<?php
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
    *                                                                        *
    *   @author Prefeitura Municipal de Itajaí                               *
    *   @updated 29/03/2007                                                  *
    *   Pacote: i-PLB Software Público Livre e Brasileiro                    *
    *                                                                        *
    *   Copyright (C) 2006  PMI - Prefeitura Municipal de Itajaí             *
    *                       ctima@itajai.sc.gov.br                           *
    *                                                                        *
    *   Este  programa  é  software livre, você pode redistribuí-lo e/ou     *
    *   modificá-lo sob os termos da Licença Pública Geral GNU, conforme     *
    *   publicada pela Free  Software  Foundation,  tanto  a versão 2 da     *
    *   Licença   como  (a  seu  critério)  qualquer  versão  mais  nova.    *
    *                                                                        *
    *   Este programa  é distribuído na expectativa de ser útil, mas SEM     *
    *   QUALQUER GARANTIA. Sem mesmo a garantia implícita de COMERCIALI-     *
    *   ZAÇÃO  ou  de ADEQUAÇÃO A QUALQUER PROPÓSITO EM PARTICULAR. Con-     *
    *   sulte  a  Licença  Pública  Geral  GNU para obter mais detalhes.     *
    *                                                                        *
    *   Você  deve  ter  recebido uma cópia da Licença Pública Geral GNU     *
    *   junto  com  este  programa. Se não, escreva para a Free Software     *
    *   Foundation,  Inc.,  59  Temple  Place,  Suite  330,  Boston,  MA     *
    *   02111-1307, USA.                                                     *
    *                                                                        *
    * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
require_once ("include/clsBase.inc.php");
require_once ("include/clsListagem.inc.php");
require_once ("include/clsBanco.inc.php");
require_once( "include/public/geral.inc.php" );

class clsIndexBase extends clsBase
{
    function Formular()
    {
        $this->SetTitulo( "{$this->_instituicao} Munic&iacute;pio" );
        $this->processoAp = "755";
        $this->addEstilo('localizacaoSistema');
    }
}

class indice extends clsListagem
{
    /**
     * Referencia pega da session para o idpes do usuario atual
     *
     * @var int
     */
    var $pessoa_logada;

    /**
     * Titulo no topo da pagina
     *
     * @var int
     */
    var $__titulo;

    /**
     * Quantidade de registros a ser apresentada em cada pagina
     *
     * @var int
     */
    var $__limite;

    /**
     * Inicio dos registros a serem exibidos (limit)
     *
     * @var int
     */
    var $__offset;

    var $idmun;
    var $nome;
    var $sigla_uf;
    var $area_km2;
    var $idmreg;
    var $idasmun;
    var $cod_ibge;
    var $geom;
    var $tipo;
    var $idmun_pai;
    var $idpes_rev;
    var $idpes_cad;
    var $data_rev;
    var $data_cad;
    var $origem_gravacao;
    var $operacao;
    var $idsis_rev;
    var $idsis_cad;
    
    var $idpais;

    function Gerar()
    {
        $this->__titulo = "Munic&iacute;pio - Listagem";

        foreach( $_GET AS $var => $val ) // passa todos os valores obtidos no GET para atributos do objeto
            $this->$var = ( $val === "" ) ? null: $val;

        

        $this->addCabecalhos( array(
            "Nome",
            "Estado"
        ) );

        // Filtros de Foreign Keys
        $opcoes = array( "" => "Selecione" );
        if( class_exists( "clsPais" ) )
        {
            $objTemp = new clsPais();
            $lista = $objTemp->lista( false, false, false, false, false, "nome ASC" );
            if ( is_array( $lista ) && count( $lista ) ) 
            {
                foreach ( $lista as $registro ) 
                {
                    $opcoes["{$registro['idpais']}"] = "{$registro['nome']}";
                }
            }
        }
        else
        {
            echo "<!--\nErro\nClasse clsPais nao encontrada\n-->";
            $opcoes = array( "" => "Erro na geracao" );
        }
        $this->campoLista( "idpais", "Pais", $opcoes, $this->idpais, "", false, "", "", false, false );

        $opcoes = array( "" => "Selecione" );
        if( class_exists( "clsUf" ) )
        {
            if( $this->idpais ) 
            {
                $objTemp = new clsUf();
                $lista = $objTemp->lista( false, false, $this->idpais, false, false, "nome ASC" );
                if ( is_array( $lista ) && count( $lista ) ) 
                {
                    foreach ( $lista as $registro ) 
                    {
                        $opcoes["{$registro['sigla_uf']}"] = "{$registro['nome']}";
                    }
                }
            }
        }
        else
        {
            echo "<!--\nErro\nClasse clsUf nao encontrada\n-->";
            $opcoes = array( "" => "Erro na geracao" );
        }
        $this->campoLista( "sigla_uf", "Estado", $opcoes, $this->sigla_uf, "", false, "", "", false, false );

        // outros Filtros
        $this->campoTexto( "nome", "Nome", $this->nome, 30, 60, false );


        // Paginador
        $this->__limite = 20;
        $this->__offset = ( $_GET["pagina_{$this->nome}"] ) ? $_GET["pagina_{$this->nome}"]*$this->__limite-$this->__limite: 0;

        $obj_municipio = new clsPublicMunicipio();
        $obj_municipio->setOrderby( "nome ASC" );
        $obj_municipio->setLimite( $this->__limite, $this->__offset );

        $lista = $obj_municipio->lista(
            $this->nome,
            $this->sigla_uf
        );

        $total = $obj_municipio->_total;

        // monta a lista
        if( is_array( $lista ) && count( $lista ) )
        {
            foreach ( $lista AS $registro )
            {
                // pega detalhes de foreign_keys
                if( class_exists( "clsUf" ) )
                {
                    $obj_sigla_uf = new clsUf( $registro["sigla_uf"] );
                    $det_sigla_uf = $obj_sigla_uf->detalhe();
                    $registro["sigla_uf"] = $det_sigla_uf["nome"];
                }
                else
                {
                    $registro["sigla_uf"] = "Erro na geracao";
                    echo "<!--\nErro\nClasse nao existente: clsUf\n-->";
                }

                $this->addLinhas( array(
                    "<a href=\"public_municipio_det.php?idmun={$registro["idmun"]}\">{$registro["nome"]}</a>",
                    "<a href=\"public_municipio_det.php?idmun={$registro["idmun"]}\">{$registro["sigla_uf"]}</a>"
                ) );
            }
        }
        $this->addPaginador2( "public_municipio_lst.php", $total, $_GET, $this->nome, $this->__limite );

        $this->largura = "100%";

        $obj_permissao = new clsPermissoes();

        if($obj_permissao->permissao_cadastra(755, $this->pessoa_logada,7,null,true))
        {
            $this->acao = "go(\"public_municipio_cad.php\")";
            $this->nome_acao = "Novo";
        }

        $localizacao = new LocalizacaoSistema();
        $localizacao->entradaCaminhos( array(
             $_SERVER['SERVER_NAME']."/intranet" => "In&iacute;cio",
             "educar_enderecamento_index.php"    => "Endereçamento",
             ""                                  => "Listagem de munic&iacute;pios"
        ));
        $this->enviaLocalizacao($localizacao->montar());        
    }
}
// cria uma extensao da classe base
$pagina = new clsIndexBase();
// cria o conteudo
$miolo = new indice();
// adiciona o conteudo na clsBase
$pagina->addForm( $miolo );
// gera o html
$pagina->MakeAll();
?>
<script>

document.getElementById('idpais').onchange = function()
{
    var campoPais = document.getElementById('idpais').value;

    var campoUf= document.getElementById('sigla_uf');
    campoUf.length = 1;
    campoUf.disabled = true;
    campoUf.options[0].text = 'Carregando estado...';

    var xml_uf = new ajax( getUf );
    xml_uf.envia( "public_uf_xml.php?pais="+campoPais );
}

function getUf( xml_uf )
{
    var campoUf = document.getElementById('sigla_uf');
    var DOM_array = xml_uf.getElementsByTagName( "estado" );

    if(DOM_array.length)
    {
        campoUf.length = 1;
        campoUf.options[0].text = 'Selecione um estado';
        campoUf.disabled = false;

        for( var i = 0; i < DOM_array.length; i++ )
        {
            campoUf.options[campoUf.options.length] = new Option( DOM_array[i].firstChild.data, DOM_array[i].getAttribute("sigla_uf"),false,false);
        }
    }
    else
        campoUf.options[0].text = 'O pais não possui nenhum estado';
}

</script>
