<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class AtualizaAcentuacaoNomesDistritos extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        $sql = <<<SQL
BEGIN;

ALTER TABLE public.distrito DISABLE TRIGGER ALL;

CREATE INDEX tmp_idx_municipio_cod_ibge ON public.municipio (cod_ibge);
CREATE INDEX tmp_idx_distrito_idmun_cod_ibge ON public.distrito (idmun, cod_ibge);

ANALYZE public.municipio;
ANALYZE public.distrito;

 update public.distrito set nome = 'Valão Quente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151107' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Angaturama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154101' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santana de Cataguases' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Sinai' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200904' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200904' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Vargem Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200904' AND distrito.cod_ibge = '56';
 update public.distrito set nome = 'Joaçuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202108' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santa Luzia de Mantenópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203304' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vila Pavão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205150' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Carmelo do Rio Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200359' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ibituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200805' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ângelo Frechiani' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Graça Aranha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201506' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São Domingos do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204658' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Montanha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedro Canário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204054' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204906' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Riacho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200607' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mussurepe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301009' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Santa Maria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301009' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Tocos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301009' AND distrito.cod_ibge = '75';
 update public.distrito set nome = 'Grussaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305000' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Afonso Arinos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300951' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Inconfidência' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303708' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Sebastião do Paraíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301108' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Banquete' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Muri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303401' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Campinas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305703' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Sebastião do Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Regência' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203205' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pontões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200102' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Conceição do Castelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aracê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201902' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vila de Laranja da Terra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203163' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São João de Petrópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204609' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Calogi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205002' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Viana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Torquato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205200' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Crubixá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200300' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Todos os Santos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202405' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Duas Barras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202603' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibatiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202454' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora das Graças' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203007' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'São João do Príncipe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203007' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Itaici' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203700' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Gruta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201209' AND distrito.cod_ibge = '19';
 update public.distrito set nome = 'Castelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição do Muqui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203403' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itapecoá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202801' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Natividade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300902' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Batatal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302106' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Pinheiro de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140530' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Pedra Bonita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148756' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Filomena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158904' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vitorinos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102100' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Silvestre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cachoeira de Santa Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171303' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Caiana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Espera Feliz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinhotiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124906' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pirapanema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143906' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Vermelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143906' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Dores do Turvo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Pomba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ewbank da Câmara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraíso Garcia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159407' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vista Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115300' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Dona Eusébia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Estrela Dalva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arapuá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5008305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Andradina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boqueirão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5005004' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Aral Moreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5001243' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maracaju' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5005400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Prudêncio Thomaz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007208' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vila União' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003454' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Aripuanã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105903' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Nova Mutum' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106224' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106208' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paranatinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Indianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101803' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Assari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101704' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'São Joaquim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107958' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Jauru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Reserva do Cabaçal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107156' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Paraguai' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5100508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rolantinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316006' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Triunfo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capão da Porteira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323002' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Rancho Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304671' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Doutor Edgardo Pereira Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Luzia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313508' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Morro Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321667' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303509' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Pacheca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303509' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Passo da Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301875' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Bororé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311718' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Campo Sêco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316402' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sant''Ana do Livramento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317103' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Cerro Partido' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306908' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Quarto Distrito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314605' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Canguçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Terceiro Distrito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304507' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Cristal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306056' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pelotas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318804' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cerro Chato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307104' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cassilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Costa Rica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003256' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Córrego do Ouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3111606' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Araúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128105' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santana da Vargem' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmeiral' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108404' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sapucaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134905' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Córrego do Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pântano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ponte Segura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165578' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Rita do Sapucaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Gonçalo do Sapucaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João da Mata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baependi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carvalhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruzília' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lourenço Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3132404' AND distrito.cod_ibge = '60';
 update public.distrito set nome = 'Paraisópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Macuco de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134301' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lavras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Cruzeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144607' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santo Antônio do Porto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150307' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Prados' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Resende Costa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio das Mortes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162500' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São Sebastião da Vitória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162500' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Padre Brito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105608' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vargem do Amargoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154408' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Bonfim da Barra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105707' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guaraciaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rosário do Pontal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152105' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Raul Soares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Bartolomeu de Sem Peixe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165560' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Vermelho Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171154' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piedade do Paraopeba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109006' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Contagem' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa Santa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Justinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154606' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sabará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mestre Caetano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156700' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barretos de Alvinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102308' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Ferros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Borba Gato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125903' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Esmeraldas de Ferros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125903' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Rio Piracicaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Florália' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157203' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Ilhéus do Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161007' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Juiraçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161007' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Gonçalo do Rio Abaixo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itabirito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bandeirantes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cláudio Manuel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140001' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Furquim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140001' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Amarantina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146107' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Antônio Pereira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146107' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Congonhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buarque de Macedo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118304' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Serra do Camapuã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Queluzito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3153806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Efigênia de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nelson de Sena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162807' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Teresa do Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148608' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Córrego Dantas do Suaçuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Capitão Andrade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3112653' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sapucaia do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127305' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Derribadinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127701' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São José do Itapinoã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127701' AND distrito.cod_ibge = '42';
 update public.distrito set nome = 'Edgard Melo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133204' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barra do Ariranha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139607' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bom Jesus do Bagre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106309' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Pedra Corrida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149952' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Patrocínio de Caratinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113404' AND distrito.cod_ibge = '24';
 update public.distrito set nome = 'Córrego Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aimorés' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Penha do Capim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101102' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Ipanema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ocidente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144003' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Corguinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130309' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Piumhi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Perdigão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baiões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126109' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santo Hilário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150505' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Aguanil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3100807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz da Aparecida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143005' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Monte Santo de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aparecida do Rio Negro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1701101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipueiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1709807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1721000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tocantínia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1721109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lizarda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1712405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cana Brava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1702406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio da Conceição' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718659' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bequimão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Rico do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109056' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Raposa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109452' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rosário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vitória do Mearim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Centro do Guilherme' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103158' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bacabal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio dos Lopes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Grajaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Dutra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araioses' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mata Roma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capinzal do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102754' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Timbiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaci Paraná' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100205' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Mutum Paraná' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100205' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Ariquemes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100023' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tabajara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100130' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Ji-Paraná' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100122' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ouro Preto do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100155' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Izidolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100015' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Nova Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100098' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Alto Alegre dos Parecis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100379' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cabixi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100031' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Corumbiara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100072' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Acre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cucui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303809' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Maraã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1302801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303908' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Eirunepé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anori' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Murutinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300300' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Freguesia do Andirá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300508' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pauini' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João da Baliza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1400506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Diamantina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212106' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Carlos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abelardo Luz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Xanxerê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Doce' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lacerdópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Irani' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Castello Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poço Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itaiópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4208104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaió' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4208104' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Cruz do Timbó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213609' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itapocu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Joinville' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curitibanos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Retiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Celso Ramos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204152' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião do Arvoredo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216503' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Aurora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lontras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Getúlio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4214003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Nereu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4214102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4214607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Apiúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201257' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Benedito Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Indaial' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Balneário Camboriú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Petrolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Leoberto Leal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João Batista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catuíra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200705' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Laguna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pindotiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211702' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barracão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211702' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Ludgero' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Gabriel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218400' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Criciúma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lauro Muller' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora do Caravagio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211603' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Maracajá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Conceição' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216404' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sombrio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Guarita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217709' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Alecrim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cândido Godói' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Machado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313425' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pratos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313425' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Bom Princípio Baixo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317905' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Consolata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321808' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barra do Guarita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301859' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Braga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Candelária' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313011' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Belo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320230' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321402' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Alto Uruguai' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321477' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bom Plano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323705' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Dois Irmãos das Missões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306429' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capivara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307302' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Osvaldo Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308508' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Salete' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310504' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São Luiz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314704' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Barão de Cotegipe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capo-Erê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307005' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ipiranga do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310462' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barão Hirstch' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310900' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Mirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320602' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Coxilha Seca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321634' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Roque Gonzales' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mato Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309001' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Rincão dos Mellos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309001' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Passo do Faxinal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315958' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Cristo Rei' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317509' AND distrito.cod_ibge = '33';
 update public.distrito set nome = 'Esquina Ipiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320321' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rosário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301503' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310207' AND distrito.cod_ibge = '37';
 update public.distrito set nome = 'Rincão do Segredo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300471' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Trentin' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310850' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Novo Barreiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313490' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Engenho Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300059' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Caetano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300059' AND distrito.cod_ibge = '28';
 update public.distrito set nome = 'Campo do Meio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308854' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Passo Fundo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Recreio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316105' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Montes Carpatos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317558' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Tapejara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José dos Campos Borges' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304101' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Depósito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307500' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Ibirubá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacuizinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310876' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jóia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311155' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campinas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316436' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tabajara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316451' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Capão Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316709' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Vista Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305603' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barros Cassal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308300' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Santa Terezinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320800' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Cerro Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322152' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'General Cadorna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312757' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Araçá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Inácio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302303' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Herveiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309571' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arroio Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312153' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Emília' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322608' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Palmas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301008' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Enxovia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312377' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312377' AND distrito.cod_ibge = '38';
 update public.distrito set nome = 'Tainhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318200' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Capão da Herança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322509' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Veranópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Florida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317400' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Tupanciretã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Várzea' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313953' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Rio Pardo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311791' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Vendelino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319752' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Vista do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302253' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fazenda Souza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305108' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Monte Belo do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312385' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sepé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tupanci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319604' AND distrito.cod_ibge = '28';
 update public.distrito set nome = 'Ivorá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310751' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Restinga Seca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Recanto Maestro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318432' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Silveira Martins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320651' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sítio Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301206' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Candelária' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruzeiro do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Doutor Ricardo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306759' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Valdástico' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306809' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Imigrante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310363' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fazenda São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314159' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Relvado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315453' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Clara do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316758' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bosque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303004' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Três Vendas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303004' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Professor Souza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301306' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Aldeia Velha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305604' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Armação dos Búzios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300233' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Saquarema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jurupema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553708' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3540200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sertãozinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3551702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruz das Posses' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3551702' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cássia dos Coqueiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Suzanápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3552551' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guararapes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3518206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeiro do Vale' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3518206' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tabajara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3526506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Antônio do Aracanguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548054' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tatuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3521200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel Arcanjo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capela do Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iperó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3521002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salto de Pirapora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3545308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550605' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cocaes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3551108' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Botujuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509601' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Engenheiro Beltrão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sertãozinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107504' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Triângulo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107504' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Iretama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bentópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109203' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nossa Senhora das Graças' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Esperança do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100806' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Margarida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102802' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santanésia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304003' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Dorândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Abarracamento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304508' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sacra Família do Tinguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301801' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Avelar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303856' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Sebastião dos Ferreiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3306206' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Glicério' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3517109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arealva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3503406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Areiópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3503604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tibiriçá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3506003' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paulistânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3536570' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pradínia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538907' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guaricanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guarapuã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514106' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pindamonhangaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lavrinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3526605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jambeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3524907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3526308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaipava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303906' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São José do Vale do Rio Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305158' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itacurussá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302601' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Muriqui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302601' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Duque de Caxias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Imbariê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301702' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Manilha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301900' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'São Francisco da Praia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550704' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Miracatu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itariri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3523305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Peruíbe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3537602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aldeia de Carapicuíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510609' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pirapora do Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3539103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guarulhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3518800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pirapó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101408' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ibiporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Irerê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113700' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pirassununga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3539301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira de Emas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3539301' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Benedito das Areias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530508' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tambaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Isabel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3546801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taboão da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3552809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riacho Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548708' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bela Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Brasilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'Godoy Moreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108551' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rosário do Ivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122651' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sete Pontes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304904' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Paranapuã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Souzas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509502' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Paulínia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3536505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lindóia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3527009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Oásis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555109' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Moema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '32';
 update public.distrito set nome = 'Ipiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '34';
 update public.distrito set nome = 'Limão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Parelheiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '55';
 update public.distrito set nome = 'Tucuruvi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '82';
 update public.distrito set nome = 'Vila Jacuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '87';
 update public.distrito set nome = 'Ibaiti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109708' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Vida Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126207' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Joá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112801' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Imbaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110078' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brasitânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515509' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Macedônia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3528205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3544202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cedral' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3511300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Estrela do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ameliópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Vicente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3551009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jardim Olinda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Almeirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gurupá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Afuá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curralinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monsarás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506302' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Soure' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Murucupi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Belém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Bárbara do Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506351' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Izabel do Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Americano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ponta de Ramos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502905' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Magalhães Barata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Alegre do Maú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504406' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bragança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila do Treme' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501709' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Caripi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tauarizinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505601' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tracuateua' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1508035' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Joana Peres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Urucuriteua' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507607' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Fernandes Belo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1508308' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Brasil Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501725' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Goianésia do Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503093' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Lindoeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507300' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Palestina do Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505494' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Geraldo do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507458' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Xinguara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1508407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Oiapoque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carvão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600402' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Ananás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1701002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araguatins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1702208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Axixá do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1702901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tocantinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1721208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carmolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1703883' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bielândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1707702' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bernardo Sayão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1703206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Couto Magalhães' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1706001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Divinópolis do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1707108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mirandópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1709302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Presidente Kennedy' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa da Confusão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1711902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brejinho de Nazaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1703701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Crixás do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1706258' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Leverger' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caramujo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102504' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guiratinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5104203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraíso do Leste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107008' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ribeirãozinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107198' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itiquira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5104609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mundo Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5214051' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aragarças' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5201702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Diorama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5207105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mutunópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5214101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Iguaçu de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5214879' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Valdelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5218904' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itaguaru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5210604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra Dourada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5207600' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Aurilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5202601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nazário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5214408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonfinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5203559' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mambaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Corumbá de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5205802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bezerra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208004' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Pirenópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5217302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Boa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5222203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5216403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João da Paraúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5220058' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Inaciolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5209937' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Joviânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pontalina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5217708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel do Passa Quatro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5220264' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cumari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5206602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cavalheiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5210109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibitu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3505500' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guaíra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3517406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itirapuã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3523701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cândido Rodrigues' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibitiúva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3539509' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Taiaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeirão do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taguaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaberá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3521705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Turiba do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3521705' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tupy' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522307' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Pereiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3537503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Eliza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128104' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Alto Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128625' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Japurá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tapejara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dez de Maio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Juvinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104808' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Catanduvas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ouro Verde do Piquiri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106308' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Diamante do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107124' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vera Cruz do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128559' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Centro Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119806' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Canzianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120358' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Enéas Marques' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Concórdia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108403' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Manfrinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114351' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salgado Filho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapejara d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senhor Bom Jesus dos Gramados' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115309' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pitanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Candói' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104428' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmeirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109401' AND distrito.cod_ibge = '75';
 update public.distrito set nome = 'Laranjeiras do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Bonito do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122156' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Doutor Ulysses' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128633' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lapa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Largo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira de São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125506' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Pedra Branca do Araraquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109609' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Anchieta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jorge Lacerda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205001' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Figueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204202' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Fazenda Zandavalli' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206652' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jardinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4208955' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Vista do Pindaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102507' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Helena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curva Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109809' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Presidente Vargas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amapá do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100550' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aurizona' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Governador Nunes Freire' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104677' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maracaçumé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106326' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lago da Pedra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marajá do Sena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106359' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Inês' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vitorino Freire' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2113009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Zé Doca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2114007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amarante do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buritirana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102358' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Montes Altos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2107001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Francisco do Brejão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110856' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Nova dos Martírios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112852' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dom Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gonçalves Dias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Governador Eugênio Barros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Domingos do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Raimundo de Codó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103307' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Colinas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mirador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Roçado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108009' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Francisco do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fortaleza do Abunã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100205' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Nova Mamoré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100338' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacynópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100338' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Surpresa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100106' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Machadinho D''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100130' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Crespo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100262' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100114' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mirante da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Teixeirópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101559' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tancredópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100346' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Castanheiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ministro Andreazza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chupinguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100924' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parecis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101450' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Walter' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200393' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campinas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200385' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Xapuri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barcelos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Isabel do Rio Negro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Gabriel da Cachoeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Autazes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iranduba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301852' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Figueiredo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303536' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lago Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300680' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tapauá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1304104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cantá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1400175' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mucajaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1400308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Faro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curuá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502855' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506807' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Anajás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salvaterra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jubim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506302' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Colares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cafezal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João da Ponta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507466' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aturiaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500909' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Umarizal do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501204' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Mocajuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tailândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507953' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Piriá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1508308' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Porto Rico' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503754' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Trairão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1508050' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Uruará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1508159' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cumaru do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502764' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Maria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506161' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Casa de Tábua' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506583' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cunani' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Joaquim do Pacuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600303' AND distrito.cod_ibge = '24';
 update public.distrito set nome = 'Cachoeirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1703826' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1720200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araguaína' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1702109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmeirante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1715705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fortaleza do Tabocão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1708254' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Goianorte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1708304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Colméia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1716703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tupiratins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1721307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1707553' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gurupi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1709500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rosário Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103403' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bom Sucesso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108402' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cassununga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108105' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Crixás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5206404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Auriverde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5206404' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Uirapuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221577' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Davidópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208905' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Jussara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lua Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212956' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Colinaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5204706' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Minaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213087' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cana Brava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213087' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Luiz do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5214606' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Tereza de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5219605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapaci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5210901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Isabel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5219357' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itauçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5211404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Francisco de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5219902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Americano do Brasil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200852' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senador Canedo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5220454' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Domingos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5219803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abadiânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Posse d''Abadia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Padre Bernardo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5215603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palestina de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5215652' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Indiara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5209952' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marzagão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Quente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5218789' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Rio Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5205109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paranaiguara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5216304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Simão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5220405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alberto Moreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3505500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Morro Agudo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3531902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Orlândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3534302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Igarapava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3520103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ituverava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3524105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Porã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3537008' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rifaina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Turvínia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3506102' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Fernando Prestes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Córrego Rico' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3524303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pitangueiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3539509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piraju' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chavantes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3557204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto da Brancal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522406' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'Pedra Branca de Itararé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3523206' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Taquarivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553856' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campina do Monte Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509452' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rechan' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522307' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Cerquilho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3511508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rondon' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tereza Breda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102505' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São Clemente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123501' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Anahy' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101051' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Vista da Aparecida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103057' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaporé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109302' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Capanema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pérola d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maravilha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Siqueira Belo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102604' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Marcionópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124400' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sede Progresso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128609' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Dois Irmãos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124806' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Lourdes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124806' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Boa Ventura de São Roque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103040' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Manoel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123857' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Campina do Simão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103958' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Laranjeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117057' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio da Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117057' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Quedas do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Francisco de Sales' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105706' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ipiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jardim do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111407' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Prudentópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Patos Velhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120606' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Teixeira Soares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ramilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121257' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106803' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paula Freitas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105201' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mariental' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113205' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Borda do Campo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120804' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guaratuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Agudos do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Descanso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro Tobias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guaraciaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216255' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Padre Reus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216701' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Alto da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204202' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Marechal Bormann' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204202' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'São Bernardino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215752' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Juscelino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216909' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Serra Alta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217550' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202537' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anita Garibaldi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219705' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'Alto Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibiam' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206751' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Engenho Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204301' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Planalto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204301' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Uruguai' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213104' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Seara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Terezinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215679' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio da Anta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215679' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Itapoá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4208450' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibirama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mirador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4214003' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Passo Manso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217808' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ascurra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Penha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Belo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinheiral' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210209' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guaporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taquaras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4214300' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jaguaruna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4208807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tubarão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morro da Fumaça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacinto Machado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4208708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lajeado Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306007' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vista Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306007' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Lajeado Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321477' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Alpestre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Liberato Salzano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lajeado Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320206' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Rio Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300901' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Faxinalzinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308052' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gaurama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itatiba do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marcelino Ramos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mariano Moro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paulo Bento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314134' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vitória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309803' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Pedro do Iraxim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318606' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bossoroca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passo Burmann' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305009' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Quinze de Novembro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309001' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Rincão dos Mendes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317509' AND distrito.cod_ibge = '43';
 update public.distrito set nome = 'São Luiz Gonzaga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Inês' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318903' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Mato Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319158' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Augusto Pestana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Antônio Kerpel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305900' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mauá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310207' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Santo Augusto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chapada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305306' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Serra do Pontão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305850' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Palmeira das Missões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Evangelista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304903' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Gentil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308854' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Treze de Maio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300554' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Santa Clara do Ingaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315354' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Sede Aurora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315354' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Júlio Borges' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316451' AND distrito.cod_ibge = '21';
 update public.distrito set nome = 'Colorado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa dos Três Cantos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311270' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Floresta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320305' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Faxinal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323200' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Fontoura Xavier' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gramado São Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308300' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Despraiado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322152' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Rincão Comprido' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322152' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Arvorezinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dois Lajeados' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306452' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guabiju' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309258' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Putinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Jorge' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318440' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fazenda Fialho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319711' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'União da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322350' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passa Sete' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314068' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pitingal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314068' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Bugre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320800' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Capão do Cedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311304' AND distrito.cod_ibge = '14';
 update public.distrito set nome = 'Carmo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312377' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Saúde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312377' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Muitos Capões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312617' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morro Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312617' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Eletra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318200' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Juá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318200' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Lajeado Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318200' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Faxinal Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318622' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Várzea' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318622' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santa Tereza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317251' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Marcos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rincão do Appel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314472' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santa Maria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arroio do Sol' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Arroio Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316907' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Aroeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313953' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Albardão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315701' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Iruí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315701' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Barão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301651' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Feliz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maratá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311791' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poço das Antas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314753' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319356' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300802' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Seca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305108' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'São Valentim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316907' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Cerrito do Ouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319604' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Vila Nova do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323457' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vale Vêneto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318432' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Fazenda Vilanova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308078' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sério' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320453' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barro Vermelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303004' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Araruama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra Mansa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pontal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3540200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Simão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lageado de Araçaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3502705' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Capão Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campina de Fora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543006' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itabôa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543006' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Mairinque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3528403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mailasqui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550605' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Alto do São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122503' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Terra Boa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lupionópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mairá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113809' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barão de Lucena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116901' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ivaitinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116901' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santo Inácio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Falcão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304128' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Engenheiro Passos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304201' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Clementina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3511904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piacatu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3537701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Agudos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3500709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nogueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3504305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lençóis Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3526803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Igaraçu do Tietê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3520004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piracaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacareí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3524402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Roseira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3544301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Redenção da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3542305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Floraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Fé do Pirapó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114807' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Maringá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sebastião de Lacerda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3306206' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Japeri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302270' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Magé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santelmo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3536703' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vanglória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3536703' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Vitoriana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3507506' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Araraquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3503208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Borborema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3507407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tapinas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522703' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ribeirão Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3542909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jardim Belval' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3505708' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jardim Silveira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3505708' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Carapicuíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana de Parnaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3547304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Apucarana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jandaia do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lerroville' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113700' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Rolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Kaloré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Suruí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302502' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Águas da Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3500402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Espírito Santo do Pinhal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515186' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itobi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3523800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipeúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3521101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3503307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conchal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3512209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iracemápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3521408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Gertrudes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3546702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibitiruna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538709' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Teresinha de Piracicaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538709' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Embu das Artes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tereza Cristina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104402' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ivaiporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117271' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João do Ivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Aliança do Ivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'José Lacerda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121703' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tibagi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaiacoca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119905' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Formosa do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Doutor Oliveira Castro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108809' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carajá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112751' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mercedes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115853' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Rio Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3549805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ubarana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555356' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ariranha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3503703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ururaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3545605' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'General Salgado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3516903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Junqueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3531407' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Neves Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Queiroz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campos Novos Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibirarema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nantes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532157' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Espírito Santo do Turvo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515194' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Graciosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118402' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Comur' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119707' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Antônio do Caiuá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Douradina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107256' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Francisco Alves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108320' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Croatá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312403' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Umarituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312403' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Itapagé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canafístula' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300903' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Capitão Pedro Sampaio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302800' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'São Domingos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303006' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Taboleiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300804' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Baixio da Donana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307403' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Várzea Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2314003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canindezinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2314003' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ibicatu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2314003' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Assaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barão de Aquiraz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302701' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Salitre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311959' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caldeirão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311959' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cuité' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2505105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Damião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2505352' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pocinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Solânea' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2516003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião de Lagoa de Roça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2515104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alagoa Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2500403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alagoinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2500502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Belém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506301' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Serra da Raiz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2515609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cuiambuca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605905' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Joaquim Nabuco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pau Ferro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611507' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Benedito do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tamandaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614857' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609402' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Lourenço da Mata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Inhapi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2703304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Entremontes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2707107' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São José da Tapera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2708402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senador Rui Palmeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2708956' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Belo Monte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2700904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Igaci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2703106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chã Preta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2701902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Colônia Leopoldina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2702108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pilar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2706901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Real do Colégio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2707503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Frei Paulo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2802304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aquidabã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2800209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Malhador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2803906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Moita Bonita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2804102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ilha das Flores' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2802700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedrinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2805109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Manoel do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinhões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918407' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Sento Sé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Igarité' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902708' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Antônio Gonçalves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itiúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Prevenido' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901155' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Central' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'João Dourado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918357' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lapão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919157' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Segrêdo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930808' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Caldeirão Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacobina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaitu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917508' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Miguel Calmon' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Duas Barras do Morro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921708' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ourolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923357' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baixa Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Macajuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Angico' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920106' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Morro das Flores' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2927200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Várzea da Roça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933059' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itacava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908903' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tiquaruçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910800' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Itatim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916856' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ouriçangas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Algodões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itapicuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mangue Seco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917904' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Inhatá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901106' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Açu da Torre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921005' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Dom Macedo Costa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sapeaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taboleiro do Castro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933174' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Itaparica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mataripe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929206' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bucuituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibitiara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caraguataí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918605' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Redenção' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922854' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Itarana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Engenheiro Franca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932101' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Canabravinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923605' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mutãs' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911709' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Igaporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa Real' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918753' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riacho de Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sebastião Laranjeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mandiroba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930006' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Urandi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cordeiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guajeru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911659' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ituaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Jânio Quadros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sussuarana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931004' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Água Bela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903953' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cândido Sales' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iguaibi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913507' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bate-Pé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933307' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Iguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João da Vitória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933307' AND distrito.cod_ibge = '33';
 update public.distrito set nome = 'Gurupá Mirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925402' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ituberá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaibim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932903' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Firmino Alves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Banco Central' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913606' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ipiaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapebi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caiubi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pimenta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920908' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'Pau Brasil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Teolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Una' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Wenceslau Guimarães' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alcobaça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2900801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caravelas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ponta da Areia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906907' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guaratinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itamaraju' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2915601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Batinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916005' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jucuruçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918456' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itupeva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921104' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Argolo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cachoeira do Mato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931350' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Arinos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Unaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caatinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Canoeiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Claro de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171006' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Serra das Araras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116159' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Januária' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Várzea Bonita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135209' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Matias Cardoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140852' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana de São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161106' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'São João do Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141009' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Gorutuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Águas Vermelhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maristela de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120870' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Retiro de Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108602' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Alvação' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118809' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Francisco Sá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canabrava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126703' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Panorâmica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143302' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Condado do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Adão Colares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108503' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barrocão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127800' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Josenópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136579' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senador Mourão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121605' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Capelinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3112307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião da Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116100' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Itamarandiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3132503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Engenheiro Schnoor' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103405' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Queixada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145307' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Águas Altas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102704' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Avaí do Jacinto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134707' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Guaranilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135803' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mata Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140555' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salto da Divisa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaguaritira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139201' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Junco de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139201' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Ituiutaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103751' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mateiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119302' AND distrito.cod_ibge = '14';
 update public.distrito set nome = 'Cruzeiro da Fortaleza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Luzia dos Barros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148103' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Rio Paranaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sete Lagoas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião do Bom Sucesso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117504' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Fronteira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Florido' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3111408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Leandro Ferreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Esteios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138807' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Funilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maravilhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Rio Abaixo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Venda Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106200' AND distrito.cod_ibge = '60';
 update public.distrito set nome = 'Corinto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rita do Cedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120904' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São João do Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111052' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Hora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201770' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buriti dos Lopes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luís Correia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piracuruca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2208304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João da Fronteira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209872' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pernambuquinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caio Prado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306504' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Palmácia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gados dos Rodrigues' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310100' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Chorozinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303956' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curupira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309458' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tipi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301703' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barbalha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Triunfo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309201' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Anjinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312106' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Poço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302503' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra Redonda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2515807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caldas Brandão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guarita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506905' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Cecília' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513158' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baía da Traição' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Camurupim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509057' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barra de Camaratuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Salema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512903' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cabedelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Beneditinos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205581' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boqueirão do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201945' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buriti dos Montes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202026' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Angical do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2200608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barro Duro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Regeneração' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2208809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aquiraz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caucaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guararu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303709' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sítios Novos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303709' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Parangaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304400' AND distrito.cod_ibge = '75';
 update public.distrito set nome = 'Lages' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Tanques' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'São Bernardo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2407005' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Marcelino Vieira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2407302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Portalegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2410207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tenente Ananias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2414100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Belmonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipuera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614006' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Verdejante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2616100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pimenteiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2208106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeiro Gonçalves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2208908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Filomena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Antônio Almeida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2200806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bertolínia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Eliseu Martins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guadalupe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2204501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nazaré do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anísio de Abreu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2200707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pacatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Queimados' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305233' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Iapi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305605' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Canindezinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309300' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Betânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309300' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Santa Maria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309409' AND distrito.cod_ibge = '24';
 update public.distrito set nome = 'Boa Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313203' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Galinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2404101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Florânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2403806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tenente Laurentino Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2414159' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Fernando' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2411809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carnaúba dos Dantas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2402402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Vicente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607703' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Varzinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613909' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Iraguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615706' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Moxotó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606606' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Algodões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614105' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jutaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608750' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Orocó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dom Inocêncio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203453' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Raimundo Nonato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tamboril do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210953' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riacho Frio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2208858' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Acauã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2200053' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campinas do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sitiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301851' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Olho d''Água dos Facundos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302404' AND distrito.cod_ibge = '32';
 update public.distrito set nome = 'Piranji' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305266' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Paus Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307635' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Santa Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2411205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serrinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2413508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vera Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2414803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601607' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Petrolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catimbau' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602803' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Belo Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gonçalves Ferreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604106' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Francisco Macedo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2204154' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Queimada Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2208650' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Acaraú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Planalto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301505' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Malhada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311900' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Carrapateiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313302' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Tereza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313302' AND distrito.cod_ibge = '33';
 update public.distrito set nome = 'Baixa Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308351' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Touros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2414407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arês' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2401206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Balanços' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Monte Horebe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lajedo do Cedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604106' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Passagem do Tó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608008' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pesqueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maniçoba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613107' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lagoa de João Carlos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605806' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Maria do Cambucá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vertentes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2616209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ameixas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Martinópole' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sussuanha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305001' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Araticum' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313609' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Manhoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2314102' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Araquém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304004' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Boa Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308807' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Manoel Correia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308500' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Mulungu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310902' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mata Fresca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301109' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Viçosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304459' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Giqui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307007' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Malta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2508802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marizópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509156' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mimoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2510907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São José de Espinharas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2514404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coremas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Emas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2505907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cacimbas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503555' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Urucuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608909' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caldeirões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602100' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Caetés' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2603207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cupira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibirajuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Meruoca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Camilos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308203' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tapuio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303105' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Senador Sá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tabuleiro do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Floresta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306900' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Tomé Vieira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304277' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Ema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306009' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Crioulos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310803' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303808' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Icozinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305407' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tavares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2516607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedra Lavrada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2511103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monteiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2515500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Igarapeassu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608701' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Panelas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tejucopapo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606200' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ibiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607653' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Macaparana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Timbaúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Livramento do Tiúma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615300' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tracunhaém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Batateira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601508' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Balseiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305902' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Livramento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305902' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São José das Lontras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305902' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Buritizal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311009' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Conceição' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305209' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Lisieux' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312205' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Trapiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312205' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Sabiaguaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300754' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Itapipoca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barrento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306405' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Gualdrapas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313500' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Recreio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Trimonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3172103' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200904' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Poranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200904' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Ecoporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Muritiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202108' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Santa Luzia do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202108' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Santo Antônio do Pousalegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201001' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'São José do Sobradinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201001' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Guararema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203908' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santo Antônio do Quinze' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203908' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São Gabriel da Palha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Valério' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205176' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Jorge da Barra Seca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205176' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Boapaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201506' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Lajinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204005' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Conceição da Barra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itauninhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204906' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Irundi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202207' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Sebastião de Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301009' AND distrito.cod_ibge = '65';
 update public.distrito set nome = 'São Joaquim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301157' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carmo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo do Coelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303401' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sodrelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305901' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Povoação' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203205' AND distrito.cod_ibge = '14';
 update public.distrito set nome = 'Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203346' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Venda Nova do Imigrante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205069' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Djalma Coutinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Almeida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205002' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Vitória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeirão do Cristo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200300' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Alto Pongal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200409' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio Novo do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Café' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200201' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santa Cruz de Irupi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202652' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Itaoca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201209' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Estrela do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201407' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mimoso do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ponte de Itabapoana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203403' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Itapemirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaipava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202801' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Pirapetinga de Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300605' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Três Irmãos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300902' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Estrada Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302106' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paraíso do Tobias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303005' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Monte Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304706' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Vilanova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139409' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Padre Fialho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140902' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Araponga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraguai' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110202' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Canaã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3111705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105509' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bom Jesus do Divino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122009' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Miradouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senador Firmino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ubari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169901' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Coronel Pacheco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juiz de Fora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Engenho Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139805' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Sebastião do Barreado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157278' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santana do Deserto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaboca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santos Dumont' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piacatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138401' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tebas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138401' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Palma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caiapó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151107' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guadalupe do Alto Paraná' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5008305' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Nioaque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5005806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruzaltina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003504' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Vargas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003702' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Piraporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004502' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Sete Quedas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Terra Roxa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105150' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Nova Monte Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108956' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guarantã do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5104104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tabaporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107941' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lucas do Rio Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105259' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rita do Trivelato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107768' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sorriso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107925' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107925' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Xavantina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106257' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coutinho União' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107065' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vale dos Sonhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101803' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Tapirapuã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101704' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Indiavaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5104500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Fé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107107' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Canela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dos Boêmios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313201' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Taquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boqueirão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308805' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Jerônimo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morrinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318408' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Costa da Cadeia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322004' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mariana Pimentel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311981' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Hartz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313060' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Viamópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323002' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Balneário Pinhal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301636' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cidreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305454' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dom Pedro de Alcântara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306551' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mampituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311734' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rincão do Cristóvão Pereira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312500' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Evaristo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317608' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Butiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321352' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Capão Comprido' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321352' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Glória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321501' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Tramandaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321600' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Xangri-lá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Camaquã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Banhado do Colégio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303509' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ibicuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310603' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Plano Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322400' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Touro Passo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316402' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São Diogo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317103' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cerro do Ouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318309' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Carajá Seival' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302808' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Bárbara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302808' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São Diogo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314175' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Quinto Distrito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304507' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Morro Redondo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312450' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedro Osório' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quilombo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314407' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Triunfo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314407' AND distrito.cod_ibge = '60';
 update public.distrito set nome = 'Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318804' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Harmonia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318804' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Coxilha do Lageado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307104' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Mingote' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307104' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'São José do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coimbra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003207' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Nhecolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003207' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Aquidauana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5001102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Miranda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5005608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Camapuã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Corguinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003108' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bom Fim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio Negro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rochedo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capão Seco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007901' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bela Alvorada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006275' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pontalete' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Albertina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Laranjeiras de Caldas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110301' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Gonçalves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senador Amaral' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165578' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição do Rio Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Lourenço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3163706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Minduri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piranguçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olegário Maciel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151008' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Piedade do Rio Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dr. Sá Fortes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102902' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Senhora das Dores' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105608' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Capela Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3112208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dom Silvério' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus de Cardosos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170503' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São José do Paraopeba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109006' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Morro Vermelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110004' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Esmeraldas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parque Durval de Barros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129806' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mário Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140159' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Doutor Lund' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149309' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carvalho de Brito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ravena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156700' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ipoema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131703' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'João Monlevade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Belo Vale' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana do Paraopeba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106408' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bituri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135407' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Moeda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rita Durão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140001' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Monsenhor Isidro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Farias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128006' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Materlândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Jacuri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3163508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fernandes Tourinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baguari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127701' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Módica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pescador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sobrália' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Divino de Virgolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João do Manteninha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162575' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipatinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bugre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109253' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dom Modesto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113404' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Café-Mirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168408' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Taruaçu de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168408' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Vargem Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170578' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Rio Doce' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101102' AND distrito.cod_ibge = '33';
 update public.distrito set nome = 'Goiabeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127370' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itueta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bambuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Serrana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Belo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3111200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana do Jacaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carmópolis de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morro do Ferro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145604' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Claraval' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Delfinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itamogi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3132909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juruaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serrania' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3166907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Almas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1700400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Natividade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1714203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1715150' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paranã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1716208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mirinzal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Luís' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barro Duro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mariza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125803' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Jerônimo da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Francisco de Imbaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106001' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Gonçalo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Mateus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305109' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mesópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529658' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3549003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Estiva Gerbi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3557303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Aparecida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509502' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Pedra Bela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3536802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Socorro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3552106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ouro Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3534807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaçanã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '39';
 update public.distrito set nome = 'Jardim São Luís' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '46';
 update public.distrito set nome = 'Pedreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '58';
 update public.distrito set nome = 'Penha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '59';
 update public.distrito set nome = 'Raposo Tavares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '65';
 update public.distrito set nome = 'Sacomã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '68';
 update public.distrito set nome = 'Santa Cecília' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '69';
 update public.distrito set nome = 'Santo Amaro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '71';
 update public.distrito set nome = 'Saúde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '77';
 update public.distrito set nome = 'Amorinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109708' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lavrinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119202' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sapopema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guapirama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salto do Itararé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana do Itararé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Siqueira Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alemoa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126603' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Meridiano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Termas de Ibirá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519402' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'José Bonifácio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3525706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mirassol' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olímpia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Onda Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3534005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Duplo Céu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535002' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mariápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3528908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mourão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3528908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lagoa Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3534609' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iubatinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508900' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Emilianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515129' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Indiana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3520608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Epitácio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Floresta do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541406' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Jundiapeba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530607' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sabaúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530607' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Salesópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3545001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mirador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cintra Pimentel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117107' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ventania' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128534' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arapoti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Castro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abapã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ponta Grossa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jesuítas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112751' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maripá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115358' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pérola Independente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115358' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Zacarias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3557154' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Botelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3545605' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Macaubal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3528106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tarabai' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Herculândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Álvaro de Carvalho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dirceu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529005' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cândido Mota' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Paranapanema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510005' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Canitar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510153' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cristo Rei' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118402' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Icatu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121000' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Cruz de Monte Castelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100509' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tapira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Soledade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306306' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Conceição' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313559' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Monte Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302800' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Targinos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302800' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Itatira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morro Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306603' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Pio X' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313708' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Altaneira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dona Inês' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2505709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serraria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2515906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campina Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Laje Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604205' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cortês' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Primavera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeirão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José da Coroa Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Xexéu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2616506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canapi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2701605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mata Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2705002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maravilha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2704609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monteirópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2705408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quebrangulo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2707602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coité do Nóia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2702009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibateguara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2703007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rocha Cavalcante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2709301' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Maceió' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2704302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boca da Mata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2701001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Teotônio Vilela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2709152' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2805208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel do Aleixo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2807006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Japaratuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2803302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aracaju' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2800308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Várzeas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Coribe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Correntina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2900207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaguaçu da Bahia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2915353' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Andorinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901353' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sítio da Baraúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901353' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mirorós' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912400' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Angical' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914604' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Várzea do Cerco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922052' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Gabriel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929255' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catinga do Moura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917508' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itapeipu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917508' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Porto Feliz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924801' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Itaberaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Elísio Medrado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipecaetá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302107' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Capistrano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Triângulo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303956' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Cristais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303501' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Pindoretama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310852' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capim de Roça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310852' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Iara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302008' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Monte Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302008' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Serrota' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302008' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Caldas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301901' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Campo Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304202' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Quimami' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308401' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Pontal da Santa Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312106' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Balanças' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307205' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itabaiana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2507200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gameleira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509404' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Pedro Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501302' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Gado Bravo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506251' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pirauá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509909' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Olho D''Água do Serrão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504033' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barra do Mamanguape' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512903' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'São Miguel de Taipu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2515005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Divino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210052' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Demerval Lobão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205557' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nazária' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206720' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Castelo do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2200202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Hugo Napoleão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2204600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pratiús' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310852' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Camará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301000' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Caponga da Bernarda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301000' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Justiniano de Serpa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301000' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Patacas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301000' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Messejana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304400' AND distrito.cod_ibge = '65';
 update public.distrito set nome = 'Guaiúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304954' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Antônio Marques' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São João do Amanari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '37';
 update public.distrito set nome = 'Santo André' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310605' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Augusto Severo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2401305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto do Rodrigues' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2400703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipanguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2404705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pendências' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2409902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luís Gomes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2407005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraná' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2408607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora do Livramento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513703' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pitimbu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2511905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pau Ferro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612208' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Flores' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Prata do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2208601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tucuns' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304103' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Independência' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Oriente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Raimundo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309409' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Holanda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313203' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Antônio Martins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2400901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jardim de Piranhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2405603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruzeta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2403004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jabitacá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606903' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Luanda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613909' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Rio da Barra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614105' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Pajeú do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207355' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dom Expedito Lopes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sussuapara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210938' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Viagem' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibuaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302404' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Várzea da Ipueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302404' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Nova-Vida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305266' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Califórnia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311306' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Belém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311405' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Encantado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nenelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311405' AND distrito.cod_ibge = '32';
 update public.distrito set nome = 'Damião Carneiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311405' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Ipiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2412302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sítio Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2413706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jundiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2406155' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Paulo do Potengi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2412609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio do Fogo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2408953' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cristália' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611101' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carnaubeira da Penha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2603926' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Airi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605707' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carneiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602803' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Perpétuo Socorro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600609' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sapucarana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601904' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Floresta do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203859' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fronteiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2204303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Patos do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207777' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barroquinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302057' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bitupitá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302057' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304251' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sambaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304707' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Aiuaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cococi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Novo Assis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310308' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Barrinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311900' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'São Paulinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300309' AND distrito.cod_ibge = '31';
 update public.distrito set nome = 'Açudinho dos Costas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308500' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Taipu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2413904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parnamirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2403251' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Extremoz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2403608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canguaretama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2402204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Sucesso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2502300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Rio do Peixe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2500700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bernardino Batista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2502052' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonito de Santa Fé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2502409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Helena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608008' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Mutuca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610905' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Papagaio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610905' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São Caitano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz do Capibaribe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa da Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304236' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São Roque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304236' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Tabainha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313401' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Nova Veneza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313609' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São Vicente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308500' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Engenheiro José Lopes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itaiçaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chile' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305332' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Morada Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pombal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Areia de Baraúnas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501153' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Gertrudes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2510808' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Teresinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana de Mangueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José de Caiana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2514305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Umburetama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609709' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Salgadinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Garanhuns' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jucati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608255' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bentevi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lagoa dos Gatos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cariré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jucá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303105' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Mumbaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308005' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Poço da Onça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308377' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Mucambo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pacujá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parapuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312007' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ipu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abílio Martins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305803' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Aruaru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308708' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Peixe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311801' AND distrito.cod_ibge = '19';
 update public.distrito set nome = 'Mapuá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306900' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bastiões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306009' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Cruzeirinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305407' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Baú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305506' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Suassurana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305506' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Orós' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santarém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309508' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Desterro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2505402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Princesa Isabel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Tigre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2514107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião do Umbuzeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2515203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sucuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2515500' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Zabelê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2517407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gurjão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sairé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana de São Joaquim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613305' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tupaoca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600708' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nazaré da Mata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruanji' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615300' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carimã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601409' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Poranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Lindo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311702' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Lagoa Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300754' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Baleia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306405' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Fleicheiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313500' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Prata dos Baianos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202108' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Mantenópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Águia Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200136' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmerino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200359' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Vila Nova de Bananal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200805' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Baunilha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201506' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Novo Brasil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202256' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jacupemba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200607' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Praia Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202207' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Dores de Macabu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301009' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Quissamã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304151' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salutaris' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303708' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Euclidelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301108' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Rita da Floresta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301108' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Valão do Barro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Joatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203163' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Maria de Marechal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203346' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Palmeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202702' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Itaquari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibitiruí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200300' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Araraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200201' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Iúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Atilio Vivacqua' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José das Torres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203403' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Muqui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marataízes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203320' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Calheiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300605' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ourânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303104' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Clara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304102' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ibitiguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304706' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Marangatu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304706' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São João da Figueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123528' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Reduto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154150' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Manhuaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162559' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brás Pires' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coimbra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Bernardes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3153103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gavião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124906' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bom Jesus do Madeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125952' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Orizânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145877' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião da Vargem Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164431' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Glória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171402' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Divinésia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Silveirânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bicas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chiador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Roça Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162906' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Taruaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162906' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Aracati de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115300' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'São João da Sapucaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138005' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Velhacaria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006309' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Debrasa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002308' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Porto XV de Novembro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5001904' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Amambai' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5000609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Montese' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004502' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Alvorada do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Rica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5008404' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Lagoa Bonita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003454' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Morumbi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003751' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Naviraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5005707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Colniza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103254' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rondolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107578' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Mundo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106265' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Alvorada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103304' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Padronal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103304' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Águas Claras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105101' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São José do Rio Claro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nobres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parque Água Limpa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106240' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Santo Antônio do Rio Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106240' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Novo Eldorado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108006' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Marcelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105580' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Planalto da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106455' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Veranópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103353' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santo Antônio do Fontoura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107354' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Água Boa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5100201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araguaiana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Progresso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107958' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Capão Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5100508' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Lavouras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5100508' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Arenápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nortelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Afonso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107263' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arroio do Ouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322541' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Forqueta Baixa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322541' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Igrejinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vale do Rio Caí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313201' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Riozinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315750' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Padilha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Quitéria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318408' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Cachoeirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canoas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parque Eldorado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306767' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Esteio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Santa Rita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313375' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cristina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314050' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sapucaia do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sertão Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320552' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Águas Claras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323002' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Capão da Canoa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304630' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capivari do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304671' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morro de Dentro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312443' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Morro do Forno' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312443' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santo Antônio da Patrulha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Três Cachoeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321667' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rainha do Mar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323804' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santa Rita do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300851' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Dom Feliciano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guterrez' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301875' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Itaqui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310603' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São Carlos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316402' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Canas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316972' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Serrinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316972' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São Gabriel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Azevedo Sodré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318309' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'José Otávio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301602' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Coronel Prestes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306908' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santana da Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Será' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306056' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Passo do Mendonça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306056' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Prado Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318804' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Pedreiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301305' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Basílio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307104' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Porto Murtinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anastácio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5000708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Congonha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5001508' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Chapadão do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002951' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro de Caldas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110301' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Camanducaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Careaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Turvolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião do Rio Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Soledade de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luminosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108909' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Virgínia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Emboabas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162500' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Pedra do Sino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113206' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ibertioga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Simão Tamm' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154408' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Piscamba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135506' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Oratórios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145851' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bicuíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154002' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Antônio do Grama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro dos Ferros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Penedia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110004' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Andiroba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124104' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Igarapé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lapinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137601' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ribeirão das Neves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Joaquim de Bicas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162922' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sete Cachoeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125903' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Padre Pinto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155702' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itauninha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158003' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santana do Alfié' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161007' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Taquaraçu de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonfim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bação' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131901' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Gonçalo do Monte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131901' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Mariana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Salto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146107' AND distrito.cod_ibge = '52';
 update public.distrito set nome = 'São Caetano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120409' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Itaverava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Braúnas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cantagalo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3112059' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158201' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Divino das Laranjeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Acácio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Goiabal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127701' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Vila Nova Floresta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127701' AND distrito.cod_ibge = '55';
 update public.distrito set nome = 'São Geraldo da Piedade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Plautino Soares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167707' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tumiritinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Limeira de Mantena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139607' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Açucena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3100500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Periquito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149952' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passa Dez' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107802' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Entre Folhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123858' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Imbé de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130556' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itajutiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130903' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João do Oriente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião do Anta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164472' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Francisco do Humaitá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144003' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Barra da Figueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151909' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Bom Pastor' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154309' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Córrego Danta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114204' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Boa Vista de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145208' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Albertos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cana Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3111903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carmo da Mata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Amparo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alpinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Bartolomeu de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109501' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Cruz do Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jacuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barranco Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101607' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jaú do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1711506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Peixe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1716604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rita do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718899' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1703305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lajeado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1712009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedro Afonso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1716505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra do Ouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1703073' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapiratins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1710904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Tereza do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1719004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arraias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1702406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Combinado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1705557' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pindorama do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1717008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rosa do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José de Ribamar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2107100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Juscelino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Amaro do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110278' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Sarney' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109270' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João Batista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Vicente Ferrer' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pirapemas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Vista do Gurupi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101970' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barão de Tromaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102606' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Buriticupu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102325' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108207' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Satubinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111722' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra do Corda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Magalhães de Almeida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anapurus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Belágua' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101731' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Milagres do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106672' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Benedito do Rio Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Alegre do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100436' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aldeias Altas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bacatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102309' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Demarcação' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100205' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Nazaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100205' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Nova Califórnia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100205' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Cujubim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100940' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Colina Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101005' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Brasilândia D''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100148' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana do Guaporé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100320' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Filadélfia d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100015' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cacoal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100049' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pimenteiras do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101468' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jordão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200328' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Plácido de Castro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200385' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Epitaciolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200252' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tabatinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1304062' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tonantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1304237' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paricatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301852' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Apuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300144' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caroebe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1400233' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Óbidos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Placas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505650' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pacoval' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506005' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Monte Dourado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500503' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Veiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Miguel dos Macacos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501808' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Sebastião de Viçosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502509' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Cruz do Arari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guamá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501402' AND distrito.cod_ibge = '55';
 update public.distrito set nome = 'Caraparu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506500' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Boa Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504307' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Marapanim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Perseverança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cametá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Areião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502103' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Curuçambaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502103' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Juaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502103' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Garrafão do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503077' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mãe do Rio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504059' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itupiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vitória da Conquista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505064' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Bannach' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501253' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curionópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502772' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Domingos do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507151' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lourenço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600204' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sucuriju' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600105' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tartarugalzinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cutias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600212' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fazendinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600303' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Igarapé do Lago' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600600' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Araguanã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1702158' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arapoema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1702307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Filadélfia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1707702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Formoso do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1708205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Acorizal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5100102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cuiabá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pirizal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Cáceres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102504' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Cangas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106505' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Poxoréo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juscimeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Galiléia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107602' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Operária' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107602' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Alto Garças' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5100409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aparecida do Rio Claro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213707' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Piranhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5217203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5203575' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campinorte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5204706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Glória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5214861' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Patrício' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5220280' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ouro Verde de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5215405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rosa de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5219506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Bárbara de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5219100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Luís de Montes Belos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5220108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Goianápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Rica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208707' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santo Antônio de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5219738' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Posse' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5218300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Simolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5220686' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Fria de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200175' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mimoso de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213053' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caiapônia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5204409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Castelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5205059' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Perolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5216452' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa do Bauzinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5218805' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Santa Helena de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5219308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Acreúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200134' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Edéia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5207402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Turvelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221551' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caldas Novas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5204508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mairipotaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porteirão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5218052' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Professor Jamil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5218391' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cristianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5206305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catalão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5205109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Domiciano Ribeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5210109' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ouvidor' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5215504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itarumã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5211305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marapoama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3528858' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vale Formoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533502' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Colina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3512001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaborandi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3524204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buritizal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capivari da Mata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3524105' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Benedito da Cachoeirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3524105' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Igaçaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3537008' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Botafogo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3506102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Marcondésia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3531506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Manduri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3528601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ourinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3534708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz dos Lopes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3523206' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Angatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3502200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guareí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3518503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapetininga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Xambrê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaporema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tuneiras do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bela Vista do Piquiri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103909' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Herveira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103909' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Primavera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112959' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Paraná d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ubiratã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araruna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quatro Pontes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120853' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Helena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dois Irmãos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127700' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Luiz do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127700' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Alto Alegre do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104600' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Espigão Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104808' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Corbélia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Matelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Missal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116059' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cristo Rei' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104501' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barra Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119806' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio da Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123808' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bom Jesus do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103156' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinhalzinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107405' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Esperança do Sudoeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116950' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porangaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3540507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tiradentes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122800' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Mariópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sulina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126652' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Espigão Alto do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107546' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Clevelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Francisco Frederico Teixeira Guimarães' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117602' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Paulo Frontin' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Silvestre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104204' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Colombo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quatro Barras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Largo da Roseira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Quitandinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iporã do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207650' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202578' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Irati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207858' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tigrinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217956' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Maratá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216107' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Caçador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Petrópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209003' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Arabutã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201273' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipumirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paial' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211876' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marcílio Dias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203808' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Nova Cultura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212205' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Três Barras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cecília' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canoas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202602' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Águas Brancas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218905' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Dona Emma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pouso Redondo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aterrado Torto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213708' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Doutor Pedrinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205159' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio dos Cedros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4214706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Itaperiú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216354' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra Clara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200903' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Claraíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211504' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Lagoa da Conceição' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205407' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santo Amaro da Imperatriz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Leonardo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200705' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Aiurê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206108' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Imaruí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Orleans' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morro Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215455' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Balneário Arroio do Silva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201950' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Manchinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321808' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Doutor Maurício Cardoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306734' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Miraguaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capinzal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305801' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Pinheirinho do Vale' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314498' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Três Palmeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321857' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vicente Dutra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinhalzinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307203' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Floriano Peixoto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308250' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonfim de Ipirá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914000' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Bárbara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2927507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buracica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931400' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cansanção' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canudos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906824' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bedengó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906824' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Massacará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910701' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Coronel João Borges' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925808' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'América Dourada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901155' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sambaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bandiaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908408' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Pé de Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924058' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alagoinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2900702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Crisópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amélia Rodrigues' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itanagra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2915908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Fundo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931707' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cunhangi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917805' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Maragogipe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Onha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922201' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Amaro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Outeiro Redondo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929008' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Passagem dos Teixeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906501' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Vera Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cacha Pregos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933208' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibipitanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibipetum' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Macaúbas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Horizonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923035' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra da Estiva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cascavel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912202' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Afrânio Peixoto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mucugê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guiné' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921906' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Palmeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caeté-Açu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Inúbia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924306' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Aiquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2900603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jitaúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Inês' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2927903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ubaíra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Roque do Paraguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920601' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Malhada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canabrava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920205' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Brumado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908705' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Barra Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902906' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caatiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dário Meira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iguaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dantilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933307' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Arataca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902252' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itatingui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902252' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Canavieiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caetité' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Teixeira do Progresso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920908' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Piraúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932200' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santo Antônio de Barcelona' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906907' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Nova Lídice' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921104' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Helvécia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923001' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Caraiva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Antônio do Boqueirão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170404' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Uruana de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170479' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'João Pinheiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Olegário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3153400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santiago de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3153400' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Icaraí de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130051' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lapa do Espírito Santo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161106' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'São João das Missões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162450' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gameleiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127339' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mamonas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139250' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155603' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Capitão Enéas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3112703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ponte dos Ciganos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118809' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Japonvar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135357' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Miralta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143302' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Rosa de Lima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143302' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São João da Ponte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Simão Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162401' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Varzelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Verdelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171030' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curral de Dentro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120870' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João da Chapada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121605' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Minas Novas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coronel Murta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana do Araçuaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152170' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Araçaji de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148707' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pedra Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101706' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santo Antônio do Mucuri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139201' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Sucanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152402' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Setubinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165552' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Topázio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168606' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Bertópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Pereira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144300' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Capinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3112604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gurinhatã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Vitória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tapuirama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170206' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Lagamar dos Coqueiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119302' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Estrela do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arapuá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quintinos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bom Sucesso de Patos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148004' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pilar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148004' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Prudente de Morais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3153608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alvorada de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapanhoacanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102407' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Honorópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3111101' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Presidente Juscelino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3153202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dores do Indaiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quartel Geral' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3153707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jequitibá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passabém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Córrego do Barro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147105' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Tavares de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147105' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'São Pedro dos Crentes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111573' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riachão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caxingó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202653' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaguarão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301208' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Campo Bom' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Glorinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309050' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capão Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309050' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Novo Hamburgo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Leopoldo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passo do Sabão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323002' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Capão Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304630' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Santa Rosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304671' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Costa do Sol' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305454' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Barra do Ouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311775' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Atlântida-Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313508' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Palmares do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313656' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Estância Velha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321600' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Fernando Ferrari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321667' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Barra do Ribeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chuvisca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305447' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tapes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra do Quaraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301875' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Manoel Viana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311759' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Borja' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318101' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Uruguaiana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vertentes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322400' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Bolso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316972' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cambaizinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316972' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pampeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317103' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tiaraju' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318309' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Minuano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300034' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Piraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301602' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Dom Pedrito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lavras do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Encruzilhada do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Bárbara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306908' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Vila Freire' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305124' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Matarazzo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314209' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Z/3' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314407' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Jaguarão Chico' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307104' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Rio Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quinta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315602' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Arvore Só' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317301' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Mirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317301' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Amolar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003207' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cipolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5001102' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Piraputanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5001102' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Palmeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003488' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Alcinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5000252' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pontinha do Cocho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002605' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Coxim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Verde de Mato Grosso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Boa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007505' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Terenos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5008008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morangas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004403' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paranaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carmo da Cachoeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Thomé das Letras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Gonçalo de Botelhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108404' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santana de Caldas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110301' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Crisólia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146008' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São José do Mato Dentro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146008' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Rita de Caldas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Repouso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sertãozinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108305' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Estiva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carmo de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pouso Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aiuruoca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piranguinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coronel Xavier Chaves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacarandira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Galego' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105608' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Mantiqueira do Palmital' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105608' AND distrito.cod_ibge = '19';
 update public.distrito set nome = 'Hermilo Alves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113206' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Canjamba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154408' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Bom Retiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Sebastião do Óculo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154002' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Zito Soares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157401' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Melo Viana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124104' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mateus Leme' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa de Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149309' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Raposos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3153905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sarzedo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165537' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus do Amparo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio da Fortaleza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125903' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Conceição de Piracicaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155702' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Padre Viegas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140001' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Ouro Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Brás do Suaçuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Correntinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128006' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Euxenita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156809' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Glucínio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158201' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mãe dos Homens' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Governador Valadares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto de Santa Helena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127701' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Brejaubinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127701' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Itanhomi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Francisco do Jataí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133204' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Aramirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3100500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Hematita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103009' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Perpétuo Socorro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106309' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Naque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144359' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Luzia de Caratinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113404' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'São Cândido' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113404' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Jerusalém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130903' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'São Tomé de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130903' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Santa Rita de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159357' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Batatal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170057' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Tabaúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101102' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Resplendor' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iguatama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vargem Bonita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José dos Salgados' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Igaratinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pains' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Candeias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3112000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Macaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108008' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Piracema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olhos D''Água da Canastra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121209' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São João Batista do Glória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaranésia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Belo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alterosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Divino Espírito Santo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paiolinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151701' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guarinos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5209457' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Salvador do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1720259' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sucupira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1720853' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itacajá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1710508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1712405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Príncipe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1714203' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Guimarães' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111201' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Axixá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105104' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cajari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Igarapé do Meio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105153' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedro do Rosário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108256' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Peri Mirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cantanhede' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Miranda do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106755' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carutapera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus das Selvas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102036' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brejo de Areia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102150' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Governador Newton Bello' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104651' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pimentel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108504' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Luzia do Paruá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110039' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Davinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103752' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro da Água Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111532' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Esperantinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lago Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lago dos Rodrigues' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105948' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Formosa da Serra Negra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104099' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Filomena do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109759' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senador Alexandre Costa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111748' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110237' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buriti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coroatá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Afonso Cunha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caxias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brejo de São Félix' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2107803' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Timon' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jatobá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105450' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibipira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106706' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Extrema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100205' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Rio Preto do Candeias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100809' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Costa Marques' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100080' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cacaulândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vale do Anari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101757' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Médici' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100254' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Urupá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alvorada D''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100346' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Seringueiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Gease d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100015' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Feijó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Acrelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200013' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amaturá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300060' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anamã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300086' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amatari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301902' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itapiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1302009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Urucará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1304302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Borba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Terra Santa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507979' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mojuí dos Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504752' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Antônio Lemos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501808' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Sebastião da Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel do Pracuúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504901' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mosqueiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501402' AND distrito.cod_ibge = '65';
 update public.distrito set nome = 'Benevides' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Murajá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502905' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São João de Pirabas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507474' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tijoca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501709' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Igarapé-Açu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Timboteua' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maiauatá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503309' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jaguarari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500206' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Aveiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abel Figueiredo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500131' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ulianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1508126' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brejo Grande do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501758' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marabá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Apinagés' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507508' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Piaçacá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600600' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Natal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1702208' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itaguatins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1710706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Terezinha do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1720002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1720309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Xambioá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1722107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Miracema do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1713205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Rosalândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1715002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pugmil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718451' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jangada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5104906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coxipó da Ponte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103403' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barão de Melgaço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cáceres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vale Rico' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5104203' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Alto Coité' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107008' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São José do Planalto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106372' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São José do Povo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107297' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5220207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Calcilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208905' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Arenópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5202353' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baliza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5203104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Niquelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5214606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Geriaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221601' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Campos Belos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5204904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Forte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5220009' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barro Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5203203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Hidrolina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5209804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5201108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaraguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5211800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bacilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5207600' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Campolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5211602' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sanclerlândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5219001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nerópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5214507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Damianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5206701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olhos D''Água' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cidade Ocidental' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5205497' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Formosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juscelino Kubitschek' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208004' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ouroana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5218805' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cachoeira Dourada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5204250' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pires do Rio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5217401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Silvânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5220603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caraíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5222005' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Aurora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5214804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itajá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5210802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olaria do Angico' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5211305' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Lagoa Santa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212253' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João de Itaguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3556008' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Colômbia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3512100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Miguelópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Franca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3516200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedregulho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3537008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Agulha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515608' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Aparecida do Monte Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3531308' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Santa Ernestina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3546504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Óleo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tibiriçá do Paranapanema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538808' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Coronel Macedo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3512605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapeva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vidigal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105508' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Goioerê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arapuan' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112207' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Rei' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116802' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Campo Mourão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125753' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Sobradinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127700' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Tupãssi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127957' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Braganey' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103354' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104808' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Bela Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Marajó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116703' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Palmitópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116703' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itaipulândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110953' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Portão Ocoí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116059' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santa Terezinha de Itaipu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124053' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sagrada Família' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119806' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Sarandi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123808' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santa Lúcia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107207' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Francisco Beltrão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Verê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Pinheiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115309' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vila Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119608' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Ouro Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123857' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cantagalo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104451' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Foz do Jordão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108452' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109401' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Bom Retiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119301' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Coronel Domingos Soares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106456' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaciaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120606' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jangada do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108502' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Porto Vitória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Fluviópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125605' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Campina Grande do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piraquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo do Tenente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riqueza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215075' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Laranjal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207759' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Oldemburg' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212106' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Planalto Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213153' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Saltinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215356' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Saudades' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ouro Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211850' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Erval Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaborá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4208609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Joaçaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaperuçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111258' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipoméia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4214409' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Peritiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bela Vista do Toldo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202131' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Irineópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palma Sola' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abdon Batista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200051' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Carlo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211058' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vargem' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219150' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Izabel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216503' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'São José do Cerrito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Braço do Trombudo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202859' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4214805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guabiruba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luiz Alves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bombinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202453' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Agrolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ituporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4208500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canelinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Governador Celso Ramos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arnópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200705' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Grão Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio das Furnas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211702' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Rio Fortuna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4214904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Maina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204608' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sanga da Toca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201406' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Independência' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Valentim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310405' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Quaraim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321808' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Pitanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306734' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Horizontina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cascata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309605' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Volta Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300505' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Caiçara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinhalzinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311601' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314704' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Rodeio Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Progresso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321808' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Volta Fechada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300901' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Barra do Rio Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301925' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sete de Setembro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307203' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Souza Ramos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308904' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Cacique Doble' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bela Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Miguel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318606' AND distrito.cod_ibge = '19';
 update public.distrito set nome = 'Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305207' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Pontão Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305009' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Entre-Ijuís' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306932' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Giruá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Paulo das Tunas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309001' AND distrito.cod_ibge = '26';
 update public.distrito set nome = 'Serrinha do Rosário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315958' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Lajeado Cerne' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317509' AND distrito.cod_ibge = '41';
 update public.distrito set nome = 'União' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317509' AND distrito.cod_ibge = '60';
 update public.distrito set nome = 'São Miguel das Missões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319158' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João Batista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323754' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Baliza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308706' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Getúlio Vargas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Povoado Tozzo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310702' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jacutinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Valentim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Espigão Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301800' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Luís Rei' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303202' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Machadinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maximiliano de Almeida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paim Filho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Expedito do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317954' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brugnarotto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318606' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Campina das Missões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Linha Harmonia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309506' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Porto Xavier' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rincão Vermelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316303' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pinheiro Machado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Timbaúva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302501' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Esquina Brasil Neves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305009' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Rincão Maciel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309001' AND distrito.cod_ibge = '24';
 update public.distrito set nome = 'Pirapó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314555' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rolador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315958' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coimbra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319158' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São João das Missões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319158' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319158' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Campo Santo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305900' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Inhacorá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310413' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Bento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304705' AND distrito.cod_ibge = '33';
 update public.distrito set nome = 'Boi Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Xadrez' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305850' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São Bento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313706' AND distrito.cod_ibge = '52';
 update public.distrito set nome = 'Sagrada Família' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316428' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio dos Pinheirinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300059' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Laranjeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311809' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Muliterno' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312625' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Recreio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314100' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Sertão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300554' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Boa Vista do Cadeado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302220' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tapera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora Aparecida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322152' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Pedregal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322152' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Nova Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322350' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Vista Alegre do Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capela São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302303' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'Osvaldo Kroeff' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303608' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Lagoa Bonita do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311239' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Pardinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316808' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Saraiva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316808' AND distrito.cod_ibge = '38';
 update public.distrito set nome = 'Bela Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320263' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vera Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinhal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302402' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Roma do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313359' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedras Brancas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319000' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cacequi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Umbu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302907' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jaguari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taquarichim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311106' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Paraíso do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314027' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Princípio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302352' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capela de Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304689' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Hortêncio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318481' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Milano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307906' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Sardenha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307906' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Taboãozinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301206' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Rincão da Estrela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307815' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Novo Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307807' AND distrito.cod_ibge = '26';
 update public.distrito set nome = 'Muçum' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capané' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303004' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cerro Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305132' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Correntezas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305604' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Iguabinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300209' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'São Pedro da Aldeia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itatiaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302254' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dumont' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio da Alegria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3547908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amandaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Araçatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3502804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vicentinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548054' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Quadra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541653' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piedade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3537800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gramadão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550209' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Araçoiaba da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3502903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sorocaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3552205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lobato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fernão Dias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Uniflor' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monumento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304003' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Resende' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Claro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barão de Juparanã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3306107' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Isabel do Rio Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3306107' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Birigui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3506508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bacuriti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508801' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Maria do Gurupá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541604' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Antônio da Estiva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538907' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bocaina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3506805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aparecida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3502507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cunha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3513603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Primeiro de Maio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Floresta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Copacabana do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cascatinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303906' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pedro do Rio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303906' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Teresópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sambaetiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301900' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Potunduva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3525300' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rubião Júnior' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3507506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pardinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3536109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Esperança do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3506706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cambaratiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519600' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bela Vista São-Carlense' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548906' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Brotas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3507902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cananéia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Eldorado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barueri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3505708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aldeia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3505708' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Warta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113700' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'São Martinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122404' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Rio de Janeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304557' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tietê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aguaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3500303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Igaraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530508' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João da Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3549102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Diadema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3513801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capuava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3547809' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'São Bernardo do Campo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Retiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Campo Belo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cidade Lider' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '24';
 update public.distrito set nome = 'Ribeirão Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pau D''Alho do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101903' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Jataizinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Frei Timóteo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112702' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Maria do Rio do Peixe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cornélio Procópio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipiiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304904' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Neves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304904' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Coelho da Rocha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Dolcinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jales' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3524808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dalas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Clara d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3546108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aparecida do Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3547403' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Salete' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3547650' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Três Fronteiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mogi Guaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Bárbara d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3545803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Águas de Lindóia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3500501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arcadas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501905' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Três Pontes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501905' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mostardas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3531209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Panorama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'José Bonifácio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '47';
 update public.distrito set nome = 'Vila Maria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '89';
 update public.distrito set nome = 'Curiúva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Guay' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109708' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Japira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Quatiguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guarani d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3518008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Indiaporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3520707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mira Estrela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Marinheiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510708' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Votuporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3557105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Altair' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3500907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibirá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mangaratu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533007' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sagres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3544707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caiuá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gardênia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3542206' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Matilde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '91';
 update public.distrito set nome = 'Mogi das Cruzes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taiaçupeba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530607' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Paraíso do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121703' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Calógeras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101606' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jaguariaíva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carambeí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104659' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaragi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119905' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Planalto do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117222' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ouro Verde do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117453' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Floresta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117909' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Roberto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538105' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Rosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3545605' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Quintana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3542008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parnaso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555000' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Lupércio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3527801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Oriente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3534104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraguaçu Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedrinhas Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3537156' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tarumã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553955' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cafezal do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103479' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Rica do Ivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109906' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Maria Helena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Gonçalo do Amarante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306306' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Iratinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306306' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Retiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313807' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'São Luís do Curu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302800' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302800' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Lagoa do Mato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306603' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Quixelô' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311355' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canaúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305704' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Amaniutuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307502' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Monte Castelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302701' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Melo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2505105' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Riachão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512747' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tacima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2516409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taboleiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501500' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Pirpirituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2511806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Frexeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605202' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio Formoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dois Riachos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2702504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pão de Açúcar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2706406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olho d''Água das Flores' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2705705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maribondo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2704807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mar Vermelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2704906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Brás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2708204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José da Laje' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2708303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Atalaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2700409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tatuamunha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2707404' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Miguel dos Milagres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2708709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Feliz Deserto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2702702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Igreja Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2703205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poço Redondo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2805406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Altos Verdes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2801405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Campo do Brito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2801009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Macambira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2803708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora de Lourdes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2804706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Propriá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2805703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rosa de Lima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2806503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Desidério' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cocos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Inhaúmas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928109' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Riacho Seco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909901' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Amaniú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2900207' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Macururé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibiraba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902708' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Morpará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pindobaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Delfino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932457' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Minas do Espírito Santo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903003' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lagoa do Boi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903235' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Inácio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911303' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Itapicuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914604' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Nuguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Angical' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Largo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924801' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Quixabeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925931' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Várzea Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933158' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Luzia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919603' AND distrito.cod_ibge = '26';
 update public.distrito set nome = 'Indaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922102' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ruy Barbosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2927200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anguera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Estevão Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901700' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Retiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908903' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Bonfim da Feira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910800' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cajueiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925956' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Paraguassú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925956' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Lustosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931400' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jeremoabo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedro Alexandre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Heliópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911857' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Triunfo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923050' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição do Coité' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ichu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922730' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araças' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902054' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Entre Rios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pojuca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lamarão do Passé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929503' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Aratuípe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Geolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904852' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cachoeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Crussai' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907301' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sítio do Meio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907301' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Jacuruna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917805' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Guaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920601' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guapira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920601' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Nagé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920601' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São Felipe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus dos Pobres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929750' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Monte Gordo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905701' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Dias d''Ávila' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910057' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quijingue' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Andaraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boninal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coronel Octaviano Alves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919306' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Diógenes Sampaio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901007' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itiruçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaibó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918001' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Oriente Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918001' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Ibitiguira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924900' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pajeú do Vento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905206' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Mortugaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pindaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaquaraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904605' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Mariana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906899' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Tranqueiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917201' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Lagoa Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906709' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ibitupã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912301' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Poções' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Panelinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905602' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ouricana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906303' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Rio do Braço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913606' AND distrito.cod_ibge = '55';
 update public.distrito set nome = 'São José da Vitória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929354' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Medeiros Neto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Posto da Mata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923001' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Vale Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925303' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Serra Bonita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cabeceira Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109451' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmital de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109451' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Garapuava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170404' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pedras de Marilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170404' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Varjão de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170750' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vazante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Manga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Verde de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140852' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Mocambinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152204' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Itamarati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101003' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Vereda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933257' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Indaiabira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130655' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jequitaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa dos Patos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3111150' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luiz Pires de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118809' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Patis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147956' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Redondo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170909' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Botumirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Belo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107307' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Guinda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121605' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Lelivéldia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106507' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cachoeira do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Granjas do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116100' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Marambainha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113008' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Virgem da Lapa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Felisburgo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Giru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136009' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Santo Antônio do Jacinto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catajás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Frei Gaspar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Pretinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168606' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Águas Formosas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3100906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Florestina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103504' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cascalho Rico' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coromandel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rosa dos Dourados' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119302' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Patrocínio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carmo do Paranaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Congonhas do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Frutal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alexandrita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134400' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Conquista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa da Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amanda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105004' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Florestal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Torneiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147105' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santa Juliana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Zelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157708' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pompéu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buenópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Parnaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Benedito Leite' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Esperantina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vazantes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301208' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santa Ana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309805' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Faísca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311603' AND distrito.cod_ibge = '21';
 update public.distrito set nome = 'Barreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301950' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parajuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302206' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Paripueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302206' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Engenho Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302008' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Monte Alverne' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304202' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Corrente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307106' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Juazeiro do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Filipe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302503' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Fagundes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gurinhém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juarez Távora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2507606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapororoca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2507101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Timbó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2507309' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pitanga da Estrada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2508901' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São José dos Ramos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2514453' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sapé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2515302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacumã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504603' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Assunção do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201051' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora de Nazaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206753' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sigefredo Pacheco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210656' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arraial' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passagem Franca do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207751' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tucunduba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303709' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Eusébio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304285' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mondubim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304400' AND distrito.cod_ibge = '70';
 update public.distrito set nome = 'Núcleo Colonial Pio XII (São Gerônimo)' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304954' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Maracanaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307650' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maranguape' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amanari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Areia Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2401107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baraúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2401453' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Geraldo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2402303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Governador Dix-Sept Rosado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2404309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Açu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2400208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coronel João Pessoa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2402907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pau dos Ferros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2409407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedras de Fogo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2511202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araripina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Granito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipubi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Trindade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Elesbão Veloso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Colônia do Gurguéia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202752' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sebastião Leal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210631' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel do Fidalgo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210391' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Alegre do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmeira do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vertentes do Lagedo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Monguba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309706' AND distrito.cod_ibge = '33';
 update public.distrito set nome = 'Pavuna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309706' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Dourados' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305233' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Itaipaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309607' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Tranqueiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305605' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Ipaporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305654' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palestina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309409' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Curatis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313203' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Almino Afonso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2400604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Martins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2407401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Macau' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2407203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caiçara do Rio do Vento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2401909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana do Matos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2411403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Timbaúba dos Batistas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2414308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parelhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2408904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Solidão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quitimbu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605103' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guaribas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2204550' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Corrente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parnaguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Oeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Luis do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210375' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedras Brancas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301851' AND distrito.cod_ibge = '14';
 update public.distrito set nome = 'Olho D''Água do Bezerril' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302404' AND distrito.cod_ibge = '31';
 update public.distrito set nome = 'Várzea da Onça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311306' AND distrito.cod_ibge = '70';
 update public.distrito set nome = 'Belo Horizonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2401602' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lagoa d''Anta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2406205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riachuelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2410900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pureza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2410405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Maria da Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jatobá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608057' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Águas Belas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610806' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Venturosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2616001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cabanas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2603108' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carapotós' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604106' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caridade do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202554' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paulistana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Santa Rita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207959' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Inácio do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Nova do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2211605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Arneiroz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ebron' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300309' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Deputado Irapuan Pinheiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304269' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carnaubinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308351' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mombaça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Macaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2407104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Espírito Santo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2403509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coronel Maia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Picos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504306' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Poço de José de Moura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512077' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salobro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610905' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Jenipapo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mulungu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612406' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Bizarra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Encruzilhada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602209' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Morrinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carnaubal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Tereza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304236' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'São Benedito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Inhuçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312304' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Caruataí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313401' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Coreaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Moraújo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonfim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312700' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Assunção' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313005' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304459' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Maceió' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304459' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Baixio Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300705' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Ibicuitinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305332' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bixopá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307601' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cajazeirinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503753' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Várzea Comprida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512101' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Quixabá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2500106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Siriji' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613800' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barra do Brejo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rainha Isabel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602100' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Canhotinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2603702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ituguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600807' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barra de Guabiraba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602308' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Forquilha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304350' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Groaíras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306108' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Brotas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308377' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Baixa Fria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312007' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Flores' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305803' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Lagoa Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308708' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Uiraponga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308708' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Lagoa Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311801' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Jaguaribara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaguaribe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iracema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Assunção' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303808' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'São Miguel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303808' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Gadelha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305506' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Palmeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506707' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Maturéia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509396' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Sabugi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2514701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruzes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610202' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Goiana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Glória do Goitá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Apoti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606101' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cachoeira Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311009' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Malhada Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312205' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Canaan' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313500' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Conceição da Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154101' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Terezinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202108' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Sapucaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203353' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itaúnas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201605' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nossa Senhora de Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203056' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Fundão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João da Barra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barcelos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305000' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pipeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305000' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Anta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Boa Sorte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301108' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Desengano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203205' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Rafael' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203205' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Biriricas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201902' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Sobreiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203163' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Alto Caxixe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205069' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Alto Santa Maria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204609' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Argolas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio Calçado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Piúma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaçuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Irupi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202652' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Menino Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203700' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santo Antônio do Muqui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203403' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Jaciguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205036' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Funil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300902' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paraoquena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304706' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Manhuaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Simonésia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alegria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167608' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Airões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148301' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carangola' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José da Pedra Menina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124203' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Faria Lemos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Patrocínio do Muriaé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rosário da Limeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156452' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sobral Pinto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104601' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Geraldo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Três Ilhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106101' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Descoberto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição da Ibitipoca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138609' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Matias Barbosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pequeri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rita de Ibitipoca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ituí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162906' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Angustura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101508' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Glória de Cataguases' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115300' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Ribeiro Junqueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138401' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Raimundo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006309' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Selvíria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Casa Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006200' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Morraria do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002159' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caarapó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaum' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003702' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Juti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5005152' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipezal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5000856' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Eldorado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003751' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guariba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103254' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Fontanillas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105150' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Bandeirantes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106158' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Colorado do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106216' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Guarita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catuaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105101' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Maringá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Groslândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105259' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Primavera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107925' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Jaraguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5100201' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Toricueije' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101803' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São Jorge' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107958' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Vila Progresso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107750' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Dois Irmãos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rolante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Entrepelado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321204' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Rio da Ilha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321204' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Santa Cruz da Concórdia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321204' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santo Amaro do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308805' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Passo Raso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322004' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Salto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302584' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Chiapetta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ijuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pejuçara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinheiro Marcado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304705' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Pinhal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314456' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Sarandi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320107' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Coxilha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305975' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ernestina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307054' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora da Saúde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309902' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Ronda Alta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Gema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318051' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Alto Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300554' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Lúcia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300554' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Rincão do Tigre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302220' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Linha Ferrari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304101' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Colônia São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306106' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Volta Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307500' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Fortaleza dos Valos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308458' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passo Real' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316451' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Linha Glória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311270' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Selbach' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tio Hugo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321469' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Linha Silveira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308300' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São José do Herval' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318465' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinhal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320800' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Pinhal Queimado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301404' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ilópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Retiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303608' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibarama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309753' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Murta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314068' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Centro Linha Brasil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322608' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Palanque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322608' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Vale do Arroio Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301008' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Vila São Paulo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310439' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Boqueirão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311304' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Tupinambá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311304' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Ranchinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312377' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Santo Antonio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312377' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312377' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Santa Rita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312617' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Pinhal da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314464' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinto Bandeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314548' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itacurubi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310553' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinhal Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314472' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Saicã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pains' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316907' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Rincão del Rei' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315701' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Harmonia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309555' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro do Maratá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311791' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Montenegro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cinco da Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304804' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Santa Lúcia do Piaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305108' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Marcorama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308607' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São José de Costa Real' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308607' AND distrito.cod_ibge = '28';
 update public.distrito set nome = 'Agudo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dona Francisca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Polêsine' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318432' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Linha Ocidental' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301206' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Estrela Velha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307815' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Costão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307807' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Progresso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315156' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tabaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320859' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Travesseiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321626' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Casimiro de Abreu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cabo Frio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guariroba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553708' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jurucê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3525102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bonfim Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543402' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Rosa de Viterbo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3547601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cajuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Andradina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3502101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araçaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3502705' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guapiara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3517604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeirão Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543253' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pilar do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3537909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Feliz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3540606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sarapuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3551108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sussuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107504' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Fênix' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quinta do Sol' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Irapuan' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Quatis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304128' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedra Selada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304201' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Califórnia da Barra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300308' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Ipiabas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300308' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cunhambebe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300100' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Engenheiro Paulo de Frontin' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conrado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302908' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Barbosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3505104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buritama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cafesópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508801' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Macucos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3517000' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Promissão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guarantã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3518107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Uru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bariri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3505203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraibuna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mandaguari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Subaio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300803' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guapimirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301850' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cabuçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301900' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Macatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3528007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Manuel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Xavier' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3503208' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Matão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Motuca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532058' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Lúcia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3546900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curupá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3552700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Carlos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Eudóxia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548906' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Osasco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3534401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caieiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Califórnia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cambé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tamarana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126678' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marumbi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olinda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303203' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Niterói' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itirapina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3523602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaqueri da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3523602' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Leme' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3526704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz da Conceição' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3546207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Charqueada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3511706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio das Pedras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3544004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Lourenço da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3549953' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo André' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3547809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto de Pinheiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '02';
 update public.distrito set nome = 'Aricanduva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '04';
 update public.distrito set nome = 'Cachoeirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Campo Limpo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Casa Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '21';
 update public.distrito set nome = 'Cidade Ademar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Lidianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113429' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra Santa Salete' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Tebas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117271' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catuporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117271' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Ubaúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125001' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Luzia da Alvorada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125001' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Nova Santa Bárbara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117214' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cecília do Pavão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Pinhal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124707' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Congonhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106407' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Leópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova América da Colina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dirce Reis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3513850' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Populina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3540408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Esmeralda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3544509' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Fé do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3546603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Estrela d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barão Ataliba Nogueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522604' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Martinho Prado Júnior' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530706' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Elias Fausto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Valinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3556206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Castelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3531605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Mercedes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3547106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Inúbia Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3520806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaraguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '42';
 update public.distrito set nome = 'Jardim Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Liberdade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '49';
 update public.distrito set nome = 'Mandaqui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '51';
 update public.distrito set nome = 'Mooca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '53';
 update public.distrito set nome = 'Morumbi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '54';
 update public.distrito set nome = 'Ponte Rasa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '64';
 update public.distrito set nome = 'São Mateus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '73';
 update public.distrito set nome = 'Ribeirão do Pinhal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cambará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeirão Claro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Real' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124103' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Conselheiro Mairinck' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Euzébio de Oliveira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109708' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Lambari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126207' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Joaquim Távora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ortigueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barreiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Américo de Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cardoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Valentim Gentil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3556107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Adolfo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3500204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Onda Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533007' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Araxãs' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541208' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Presidente Venceslau' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Regente Feijó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3542404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cezar de Souza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530607' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Solemar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541000' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nordestina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100905' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paranacity' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ouro Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126306' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Marechal Cândido Rondon' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Santa Rosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117222' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catiguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3511201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533254' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmares Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Teodoro Sampaio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arco-Íris' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3503356' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tupã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Avencas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529005' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Paulópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3540002' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Lutécia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3527900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Platina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3539707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Terra Rica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Piquiri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paulistânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100707' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Carbonera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114708' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Olímpia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Camboas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310258' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Lagoinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310258' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cemoaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313559' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'General Sampaio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Antonico' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311355' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Bela Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303303' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Mel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307403' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Felizardo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305704' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Umari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Potengi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barreiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311207' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Algodão de Jandaíra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2500577' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2500908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bananeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cuitegi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2505204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catolé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504009' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'José da Costa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605905' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Igarapeba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612901' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barra do Sirinhaém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nossa Senhora da Luz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613701' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Riacho do Sertão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2704401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Canafístula' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2706307' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tanque d''Arca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2709004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana do Mundaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2708105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cajueiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2701308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Calvo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2707305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2704500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Piaçabuçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2706802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gararu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2802403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Samambaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2807402' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Capela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2801306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salgado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2806206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tomar do Geru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2807501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Formoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143153' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146750' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Horizonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104700' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itaipé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3132305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Valão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152402' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Teófilo Otoni' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carlos Chagas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nanuque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Uberlândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134004' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Limeira de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137502' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Abaeté dos Mendes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155504' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Fechados' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158508' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Brejaúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117504' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Estrela da Barra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114550' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Sebastião do Pontal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114550' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Aparecida de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127107' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Limeira do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138625' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pirajuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição das Alagoas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Inimutaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morro da Garça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Hipólito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Estrela do Indaiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124708' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Alberto Isaacson' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibitira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140506' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Serra da Saudade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3166600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fortuna de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Inhaúma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Vermelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedra Menina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156007' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Antônio do Itambé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Deputado Augusto Clementino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167103' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Três Barras da Estrada Real' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167103' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Pitangui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Jerônimo dos Poções' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3111507' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tobati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129509' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pratinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3153004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abaeté' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3100203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sucupira do Riachão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111953' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campestre do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102556' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Estreito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104057' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curupá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100501' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Feira Nova do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104073' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Domingos do Azeitão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110658' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cabeceiras do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202059' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Joca Marques' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205458' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morro do Chapéu do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206670' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ilha Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2204659' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aracoiaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapiúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pacoti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Forquilha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302206' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Pitombeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303501' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Nova Santa Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308104' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Estrela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301901' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Crato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jardimirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307106' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jamacaru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308401' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Simão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311108' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Milagres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Queimadas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mogeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aroeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mamanguape' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2508901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruz do Espírito Santo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pilar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2511509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Renascença' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2515302' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Sobrado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2515971' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cocal de Telha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202711' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa de São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205573' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Agricolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2200103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio dos Milagres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209450' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304954' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Dourado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304954' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Ladeira Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '26';
 update public.distrito set nome = 'Mossoró' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2408003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Felipe Guerra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2403707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Janduís' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2405207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2412500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alexandria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2400505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Francisco do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2411908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Viração' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605301' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Umãs' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612208' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Várzea Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2211407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Manoel Emídio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Peixe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barreiras do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brejo do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201988' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antonio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301257' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Montenebo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304103' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304103' AND distrito.cod_ibge = '37';
 update public.distrito set nome = 'Major Simplício' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309300' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Emaús' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309409' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Patu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2409308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Umarizal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2414506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedra Preta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2409605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bodó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2401651' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Currais Novos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2403103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana do Seridó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2411429' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tabira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tuparetama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Manari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609154' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira do Roberto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600203' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Lagoa Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608750' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caracol' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Júlio Borges' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205524' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sebastião Barros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210623' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rosa do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209377' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João da Varjota' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209955' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maravilha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303931' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Dom Maurício' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311306' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Passagem' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311405' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Campo Redondo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2402105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Bento do Trairí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2411700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Campestre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2412302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ielmo Marinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2404606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa de Pedras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2406304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Belém do São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buíque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Fria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601706' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Brejo da Madre de Deus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'João Costa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205359' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Francisco de Assis do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209658' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caiçara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304251' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Granja' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pessoa Anta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304707' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Monte Sion' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310308' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Riachão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310308' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311900' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Tauá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Isidoro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300309' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Aurora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304269' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Maratoã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304269' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Barra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308351' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Cangatí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308500' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Carnaúbas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308500' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Catolé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308500' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São Miguel do Gostoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2412559' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nísia Floresta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2408201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Montanhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2407708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedro Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2409803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riacho dos Cavalos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Umari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2500700' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São José de Marimbas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503308' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Engenheiro Ávidos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503704' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Joca Claudino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513653' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Uruçu-Mirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606408' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vitorino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611705' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Sanharó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tapiraim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613107' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Chéus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614501' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Taquaritinga do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tamboatá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602209' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'João Alfredo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jijoca de Jericoacoara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307254' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Betânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304236' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Repartição' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304236' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Morrinhos Novos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305001' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Tianguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pindoguaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313401' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ubajara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Padre Vieira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2314102' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Passagem da Onça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2314102' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Frecheirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alcântaras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capitão Mor' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310506' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Mineirolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Cruz do Banabuiú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310506' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Solonópole' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pasta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313005' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Jirau' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301109' AND distrito.cod_ibge = '24';
 update public.distrito set nome = 'Açude dos Pinheiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305332' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Aparecida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2500775' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2510907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cacimba de Areia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Patos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2510808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Machados' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Orobó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poço Comprido' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Iratama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606002' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lagoa do Ouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cacimbas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303105' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Salgado dos Mendes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304350' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Aiuá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308005' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tuína' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308005' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santana do Acaraú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sapó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312007' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Serrota' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312809' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jordão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312908' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'São José do Torto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312908' AND distrito.cod_ibge = '53';
 update public.distrito set nome = 'Roldão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308708' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Tomé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311504' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Canindezinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311231' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Várzea da Conceição' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303808' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Igarói' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309508' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Junco do Seridó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2507804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José da Batalha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513000' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Cubati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2505006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Camalaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2510659' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José dos Cordeiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2514800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Upatininga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600708' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Paudalho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305902' AND distrito.cod_ibge = '37';
 update public.distrito set nome = 'Otavilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310951' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Macambira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311009' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Logradouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312205' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Moitas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300754' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Alazans' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305902' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'São Domingos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160009' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Água Doce do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200169' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Agostinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200169' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Imburana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202108' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itapina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201506' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Marilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203353' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204005' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Ponto Belo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204252' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itamira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204252' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nestor Gomes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204906' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Morangaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301009' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Travessão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301009' AND distrito.cod_ibge = '80';
 update public.distrito set nome = 'Maniva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304755' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ipuca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304805' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Macabuzinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Córrego do Ouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302403' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Pião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305406' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Córrego da Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301207' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Duas Barras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303401' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Santa Maria Madalena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'João Neiva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203130' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Linhares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Afonso Cláudio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piracema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200102' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São Luiz de Miranda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203163' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Mangaraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204500' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Vinte e Cinco de Julho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204609' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santa Júlia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204955' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Carapina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205002' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Matilde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200300' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Urânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200300' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Aghá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204203' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Celina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200201' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Divino de São Lourenço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro de Rates' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santíssima Trindade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203007' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Piaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203700' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'José Carlos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200508' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cachoeiro de Itapemirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conduru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201209' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Córrego dos Monos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201209' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Vargem Grande do Soturno' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201209' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Jerônimo Monteiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Calçado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Calçado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204807' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Divino Espírito Santo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204807' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Rio Muqui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202801' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Presidente Kennedy' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora da Penha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302205' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Varre-Sai' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3306156' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Venda das Flores' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303005' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santo Antônio de Pádua' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baltazar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304706' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Campelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304706' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Caparaó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3112109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caputira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3112901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Jequitibá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3153509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Padre Júlio Maria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3153509' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São Simão do Rio Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167608' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Abreus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cajuri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ervália' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lamim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinheiros Altos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150802' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Antônio do Pirapetinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150802' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Rio Espera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barão de Monte Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro do Glória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125952' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Muriaé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Família' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143906' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vilas Boas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129004' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Rodeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto das Flores' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106101' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Penha Longa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Maripá de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paiva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piau' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Manoel do Guaiaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122900' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Água Viva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124609' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bodoquena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002159' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campestre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5000906' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Dourados' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Panambi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003702' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Rio Brilhante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Castelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003454' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Paranaíta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106299' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Canaã do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106216' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Comodoro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sapezal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107875' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cláudia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103056' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Feliz Natal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gaúcha do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103858' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luciara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Alegre do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106778' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz do Xingu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107743' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Couto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102603' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Conquista D''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103361' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araputanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101258' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Castelo D''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103957' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Ivoti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Picada Café' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314423' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316006' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Minas do Leão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312252' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parobé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314050' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Imbé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310330' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morrinhos do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312443' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tavares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321352' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Terra de Areia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321436' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323804' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Arambaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300851' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passo Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sarandi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318002' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'São Marcos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322400' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Upamaroti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317103' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Catuçaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318309' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Vacacaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318309' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Torquato Severo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306601' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Amaral Ferrador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300638' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caçapava do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passo Real de Candiota' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304358' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Pedras Altas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314175' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Candiota' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Torrinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314506' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Terceiro Distrito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314605' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Quarto Distrito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304507' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Lourenço do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boqueirão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318804' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Curral Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317301' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Taim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317301' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Pedro Gomes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Areado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007695' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Anhanduí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002704' AND distrito.cod_ibge = '60';
 update public.distrito set nome = 'Sidrolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Marilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108857' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campanha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gramínea' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102605' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Botelhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Inconfidentes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cambuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Extrema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição dos Ouros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Silvianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cambuquira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arantina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Seritinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3166402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marmelópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição da Barra de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraíso da Piedade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150307' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Arcângelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tiradentes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Elvas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168804' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Alfredo Vasconcelos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101631' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião de Campolide' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102902' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ponte do Cosme' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105608' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Barroso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carandaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ressaquinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Bárbara do Tugúrio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra Longa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Grota' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Piedade de Ponte Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ponte Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vau-Açu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152105' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santana do Tabuleiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154002' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Águas Férreas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibirité' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Azurita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140704' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio Acima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vespasiano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itabira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cônego João Pio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161007' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Terezinha de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133709' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caetano Lopes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135407' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Coco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142304' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Diogo de Vasconcelos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Leite' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146107' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Cristiano Otoni' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pereirinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121407' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Ouro Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paulistas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quilombo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156809' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São João Evangelista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Geraldo do Baguari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162807' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São José do Jacaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3166105' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Água Boa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3100609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro do Suaçuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio dos Araújos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164506' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Vítor' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127701' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Nacip Raydan' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Geraldo do Baixio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161650' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marliéria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mesquita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana do Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158953' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caratinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cordeiro de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113404' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Santo Antônio do Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130903' AND distrito.cod_ibge = '21';
 update public.distrito set nome = 'Vale Verde de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131158' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Sebastião do Batatal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170057' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Expedicionário Alício' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101102' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Imbiruçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144003' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Altolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Divinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio dos Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itaúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Neolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133501' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ibituruna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Francisco de Paula' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José da Barra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162948' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra dos Lemes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109501' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Juréia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143005' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Milagre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143203' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vilelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114402' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Carvalhópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Divisa Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Talismã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1720978' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buritirana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1721000' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Novo Acordo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1715101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1705607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João de Cortes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Apicum-Açu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100832' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102374' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Icatu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monção' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Bento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Godofredo Viana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Luzia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Governador Edison Lobão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104552' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Igarapé Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Raimundo do Doca Bezerra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111631' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Roberto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111672' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaipava do Grajaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105351' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Joselândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fortuna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Quitéria do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Soter' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111078' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buriti Cortado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paraibano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2107704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vista Alegre do Abunã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100205' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Araras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100338' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Campo Novo de Rondônia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Candeias do Jamari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Colina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100122' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Espigão D''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100098' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vilhena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bujari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200138' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capixaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200179' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila do V' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200807' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Atalaia do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fonte Boa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juruá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1302207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alvarães' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300029' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lago do Limão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301852' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Manaus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1302603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300508' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Boa Vista do Ramos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300680' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Repartimento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1302900' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Uiramutã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1400704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iracema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1400282' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itatupã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503101' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Breves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barcarena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riachão das Neves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paulo Jacinto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2706604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Açudina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Casa Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luís Viana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907202' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pau a Pique' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907202' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Baluarte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Brejo da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924405' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sobradinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930774' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Copixaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933604' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Feira da Mata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910776' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paratinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tobias Barreto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2807402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Soares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901155' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Paz de Salobro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906204' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ibitunane' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911303' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ibipeba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conquista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914604' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Jussara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mulungu do Morro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922052' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Formoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925600' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Uibaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Hidrolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932408' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Icó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921708' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Brejo Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903805' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Iaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Governador Dr. João Durval Carneiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910800' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santa Teresinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Estêvão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sergi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929305' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Serra Preta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cajuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930204' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Uauá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cícero Dantas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Soure' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olindina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928950' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Teofilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Acajutiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2900306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riacho da Guia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2900702' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Sátiro Dias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cardeal da Silva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Subaúma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910503' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Miranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cabaceiras do Paraguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904852' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Petim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907301' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Rio da Dona' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908309' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cruz das Almas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Acupe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928604' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Menino Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906501' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Passé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906501' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Jiribatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933208' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Saudável' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904506' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Caturama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907558' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa Clara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919801' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ibicoara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lençóis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cabrália' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Apuarema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901957' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918001' AND distrito.cod_ibge = '28';
 update public.distrito set nome = 'Itanagé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919504' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Caculé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacaraci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guirapá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924504' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cristalândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904605' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lagoa Preta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931806' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Planalto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cabeceira da Jiboia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933307' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Bandeira do Colônia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cairu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nilo Peçanha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Floresta Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tapirama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911501' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itagibá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2915205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2915403' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Itamari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2915700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mascote' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ubaitaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buranhém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911808' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itanhém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Viçosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Seguro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Teixeira de Freitas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931350' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonfinópolis de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Goiasminas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126208' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Canabrava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136306' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Bonito de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108255' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Retiro Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116159' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Porto Agrário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136959' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Miravânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142254' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pintópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150570' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Acari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150570' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Barreiro da Raiz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mato Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porteirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra Branca de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152204' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Fruta de Leite' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127073' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz de Salinas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157377' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribanceira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164209' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Claro dos Poções' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibiracatu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129657' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129657' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Luislândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138682' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mirabela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brejo do Mutambal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170909' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Bocaiúva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Engenheiro Navarro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Francisco Dumont' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Desembargador Otoni' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121605' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sopa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121605' AND distrito.cod_ibge = '55';
 update public.distrito set nome = 'Berilo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Penha de França' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3132503' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'José Gonçalves de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136520' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baixa Quente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141801' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Caraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lufa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ponto dos Volantes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152170' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Medina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedra Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jequitinhonha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jordânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vasques' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612208' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Iguaracy' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Francinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2204006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canavieira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202251' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pavussu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207850' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gilbués' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2204402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curral Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304103' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Lagoa das Pedras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304103' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Monsenhor Tabosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quiterianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311264' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salva Vida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2407401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Afonso Bezerra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2400307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Angicos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2400802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cerro Corá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2402709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José da Passagem' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2411403' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Caicó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2402006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapetim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pajeú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613909' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Arcoverde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Custódia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Afrânio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poção de Afrânio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600203' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Lagoa de Fora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605152' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Curimatá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aroeiras do Itaim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2200954' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Colônia do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202778' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipiranga do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2204808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209351' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Wall Ferraz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2211704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bela Vista do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201556' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rinaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301851' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jacampari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302404' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Choró' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303931' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barbada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303931' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Pedra e Cal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305266' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Juatama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311306' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Tapuiará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311306' AND distrito.cod_ibge = '65';
 update public.distrito set nome = 'Quixeramobim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Seridó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2412401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'João Câmara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2405801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parazinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2408805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Japi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2405405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ruy Barbosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2411106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra de São Bento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2413300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra Caiada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2410306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedra Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2409506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Volta do Moxotó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608057' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Horizonte Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610806' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Boas Novas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601904' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barra do Farias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602605' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Isaías Coelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2204907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacobina do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205151' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Simões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juritianha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300200' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Bela Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passagem' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Catarina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gavião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310308' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Trici' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313302' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Ipueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308351' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tibau do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2414209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2502201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riacho do Meio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608008' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Riacho Fechado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614709' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cumaru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Croatá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304236' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barreiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312304' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Jaburuna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313609' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Lambedouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2314102' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Piquet Carneiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cangati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313005' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guajiru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304459' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300705' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Piancó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2511301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pitombeira de Dentro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513604' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Paranatama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Terezinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra do Chata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lapa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304657' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Tangente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308005' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Miraíma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308377' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Várzea do Giló' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305803' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Juazeiro de Baixo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308708' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Olho-d''Água da Bica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313104' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ererê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304277' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lima Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305407' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Barreiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'José de Alencar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305506' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Riacho Vermelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305506' AND distrito.cod_ibge = '36';
 update public.distrito set nome = 'Santa Luzia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Mamede' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2514909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tenório' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2516755' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alcantil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2500536' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Joaquim do Monte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chã Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amaraji' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barreiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Varjota' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313955' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303659' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Irajá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305209' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Aracatiara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300754' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Antônio do Aventureiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Governador Lacerda de Aguiar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200169' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cachoeirinha de Itaúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200904' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Monte Senir' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200904' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Nova Venécia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baixo Guandu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Governador Lindenberg' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202256' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Sobrado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204104' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guaraná' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200607' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibitioca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301009' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Atafona' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305000' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Glicério' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302403' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Macuco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302452' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Ribeirão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300506' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Vargem Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301603' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Lumiar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303401' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Renascença' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304607' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Trajano de Moraes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibiraçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bebedouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203205' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Sooretama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205010' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mata Fria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200102' AND distrito.cod_ibge = '28';
 update public.distrito set nome = 'Serra Pelada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200102' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'São Jorge de Oliveira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201159' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Melgaço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201902' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São João de Viçosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205069' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Itaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202702' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Maria de Jetibá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204559' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Roque do Canaã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204955' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cariacica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Queimado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205002' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Ibes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205200' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jucu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205200' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Alfredo Chaves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anchieta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jabaquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200409' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Princesa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Angélica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200201' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Dores do Rio Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pequiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203007' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Coutinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201209' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Gironda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201209' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Pacotuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201209' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Monte Pio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201407' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Camará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203809' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Airituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204807' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bom Jesus do Querendo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303104' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Porciúncula' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Purilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Monte Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300902' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itaocara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Portela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302106' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Miracema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro de Alcântara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304706' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Campos dos Goytacazes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Prata de Lajinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137700' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Pedro do Avaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139409' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Martins Soares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140530' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaguaraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154150' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Belisário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143906' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itamuri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143906' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Guiricema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mercês' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tabuleiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Miragaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169901' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Aracitaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guarará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Torreões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136702' AND distrito.cod_ibge = '80';
 update public.distrito set nome = 'Olaria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rochedo de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cataguarino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115300' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Leopoldina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Aporé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006309' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Ribas do Rio Pardo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rita do Pardo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007554' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Águas de Miranda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carumbé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004502' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vista Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5005400' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Glória de Dourados' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaquiraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mundo Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5005681' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Horizonte do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006259' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água da Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101902' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Apiacás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5100805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Peixoto de Azevedo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106422' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paranorte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105101' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ipiranga do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5104526' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caravágio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107925' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Santa Helena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106190' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Carmem' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107248' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5100359' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canabrava do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102694' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serrinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5100201' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Nova Nazaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106174' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vale de São Domingos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108352' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Denise' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103452' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tangará da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107958' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lambari D''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105234' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mirassol d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105622' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lindolfo Collor' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311627' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Maria do Herval' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316956' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Três Coroas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'General Câmara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maracanã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309050' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Vila Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309050' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Poço Fundo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314050' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Túnel Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301636' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Morro dos Leffas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306551' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Simão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312500' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Osório' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catanduva Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317608' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'Miraguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317608' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Rio do Terra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321667' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sant''Auta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303509' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Francisco Borges' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301875' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Encruzilhada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311718' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Samburá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318002' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'São Francisco de Assis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'João Arregui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322400' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Caverá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316402' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ibicuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317103' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Batovi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318309' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'Palmas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301602' AND distrito.cod_ibge = '21';
 update public.distrito set nome = 'Arroio Mau' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314175' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cascata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314407' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santa Silvana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314407' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Herval' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ilha dos Marinheiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315602' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Camisão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5001102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Dois Irmãos do Buriti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003488' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juscelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Gabriel do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007695' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Indaiá do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002902' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004403' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Coqueiral' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Frei Eustáquio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Campestrinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102605' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Bento de Caldas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cervo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Congonhal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tropical Flores' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133600' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Conceição das Pedras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ferreiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162005' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caxambu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itanhandu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bocaina de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Vicente de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serranos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Consolação' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dom Viçoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itajubá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3132404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Bárbara do Sapucaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151008' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Rosário do Rio Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134301' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Nepomuceno' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeirão Vermelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dores de Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa Dourada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nazareno' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José de Pouso Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101631' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Caranaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmital dos Carvalhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3166204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jurumirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154903' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Urucânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abre Campo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3100302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aranha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109006' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Confins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117876' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136652' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Lima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alvinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bela Vista de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cubas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125903' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Rita do Rio do Peixe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125903' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Brumal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157203' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Conceição do Rio Acima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157203' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São José do Goiabal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3163409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Manso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monsenhor Horta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140001' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Engenheiro Correia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146107' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Casa Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catas Altas da Noruega' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118007' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Entre Rios de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Joselândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'José Raydan' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136553' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Maria do Suaçuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Divino do Traíra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123700' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Chonim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127701' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santo Antônio do Pontal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127701' AND distrito.cod_ibge = '37';
 update public.distrito set nome = 'São Geraldo de Tumiritinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169505' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Floresta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115706' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mendes Pimentel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coronel Fabriciano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaguaraçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Jacutinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113404' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Sapucaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113404' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Novo Horizonte de Inhapim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130903' AND distrito.cod_ibge = '19';
 update public.distrito set nome = 'Vai-Volta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168408' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mundo Novo de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101102' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Barra do Cuieté' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118403' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cuieté Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118403' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Cuparaque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120839' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Centenário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144003' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Calixto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154309' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cachoeirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119807' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Roque de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monsenhor João Alexandre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116605' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lamounier' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133501' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vila Costina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146503' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Porto dos Mendes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3111200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Goianases' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3112406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Fortaleza de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição da Aparecida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Goianésia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Goiatins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1709005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ponte Alta do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1717909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Alegre do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Valério' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1720499' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tutóia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anajatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bela Vista do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101772' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olinda Nova do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2107456' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Penalva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Viana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vargem Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Turilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112456' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Altamira do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pindaré-Mirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Carú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111029' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'João Lisboa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Lugar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102077' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lago do Junco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tuntum' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Joaquim dos Melos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Governador Archer' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brejo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chapadinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Duque Bacelar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Dimensão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100338' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Quinto BEC' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100130' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Monte Negro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Estrela de Rondônia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100254' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Governador Jorge Teixeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riozinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100049' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Flor da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100098' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Primavera de Rondônia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101476' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cerejeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100056' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Assis Brasil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200054' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caapiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300839' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Manacapuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1302504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Augusto Montenegro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1304401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barreirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião do Uatumã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303957' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boca do Acre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bujaru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Apeú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502400' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Salinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Japerica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507474' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Quatipuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506112' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Beja' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500107' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Baião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Moiraba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502103' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Oeiras do Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guajará-Miri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500206' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tomé-Açu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1508001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Esperança do Piriá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504950' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Domingos do Capim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rurópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506195' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Divinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506195' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pacajá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505486' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senador José Porfírio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacundá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paragominas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Félix do Xingu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Azul do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500347' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Clevelândia do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600501' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Macapá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Laranjal do Jari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600279' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aguiarnópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1700301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piraquê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1717206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barrolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1703107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dois Irmãos do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1707207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pequizeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1716653' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dueré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1707306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Oliveira de Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1715507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aliança do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1700350' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caraíba do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110906' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Baús' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5100102' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Nossa Senhora do Livramento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Horizonte do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102504' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Curvelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103437' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'General Carneiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Entre Rios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103601' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santa Elvira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105200' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pedra Preta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106372' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rondonópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107602' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Buriti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5100300' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Mozarlândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5214002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buenolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208905' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jacilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5211008' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cavalcante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5205307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Colinas do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5205521' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rita do Novo Destino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5219456' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Uruana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sousânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5201108' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Messianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213400' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mossâmedes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iaciara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5209903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cocalzinho de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5205513' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Planaltina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5217609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aporé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5201504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riverlândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5218805' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Jandaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5211701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buriti Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5203906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marcianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5209101' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Três Ranchos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira Alta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5204102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sales Oliveira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3544905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cristais Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3513207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José da Bela Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3549508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guariba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3518602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Engenheiro Maia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3521705' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itaoca de Cima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532827' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Salto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509452' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Conceição' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522307' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Gramadinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522307' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Serra dos Dourados' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128104' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'São Tomé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quarto Centenário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120655' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rancho Alegre D''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121356' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Vicente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101705' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Rita d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127403' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lindoeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113452' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alvorada do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108304' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Medianeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinheiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104501' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Conciolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119004' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Marmelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121406' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vista Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107405' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bom Sucesso do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103222' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Barreiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120150' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Turvo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127965' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Imbituva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Claro do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113908' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cruz Machado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Mateus do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cerro Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Açungui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122206' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Colônia Murici' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125506' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Serra Negra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109500' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Morretes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pontal do Paraná' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119954' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Colônia Padre Paulo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100301' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ouro Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206405' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Guarujá do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Flor do Sertão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205357' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Modelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Horizonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211652' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinhalzinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coronel Martins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204459' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Galvão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taquara Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203006' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Fraiburgo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Herval d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arvoredo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201653' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tamanduá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204301' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Major Vieira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Residência Fuck' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211108' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Bento do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araquari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Saí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216206' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Leão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203600' AND distrito.cod_ibge = '26';
 update public.distrito set nome = 'Santa Cruz do Pery' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204806' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Lagoa da Estiva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201000' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Urupema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218954' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Trombudo Central' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itoupava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202404' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Grande Garcia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202404' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pomerode' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Camboriú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aguti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211504' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tijipió' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sorocaba do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202305' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barra da Lagoa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205407' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Pântano do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205407' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Centro Histórico de São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216602' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Alfredo Wagner' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Armazém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Garopaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio d''Una' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207205' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207304' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ribeirão Pequeno' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209409' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ermo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205191' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morro Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211256' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Balneário Rosa do Mar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212254' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Rosa do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215653' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217709' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Morro Chato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218806' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Vila Laranjeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317905' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Três de Maio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Crissiumal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Esquina Gaúcha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306007' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307450' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ismael' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307450' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Redentora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sede Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320230' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tenente Portela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Erval Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321907' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321907' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Ametista do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300646' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Marcos Baixo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305801' AND distrito.cod_ibge = '14';
 update public.distrito set nome = 'Cristal do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306072' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nonoai' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Tiradentes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313441' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Saltinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315909' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Taquaruçu do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321329' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Trindade do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321956' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aratiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carlos Gomes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304853' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barracão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Tigre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316600' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guarani das Missões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rincão Comprido' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315107' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Dona Otília' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Catarina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316477' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Esquina Piratini' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302501' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Santa Tereza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305009' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Igrejinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315958' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Lourenço das Missões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318903' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Giruazinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320321' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Ubiretama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322343' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alegria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300455' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bozano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302584' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Condor' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Ramada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313334' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Panambi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora de Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317806' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Linha Vitória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300471' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302154' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Santo Antônio do Planalto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317756' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Comandaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317509' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Camargo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303558' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Casca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Luiz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309902' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'São Sebastião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309902' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mato Castelhano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312138' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nicolau Vergueiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312674' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Lângaro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323358' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José das Missões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318457' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alfredo Brenner' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310009' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Capão Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316451' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Itaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316709' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Lagoão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311254' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anta Gorda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Montauri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312351' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Valentim do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319711' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Silva Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320404' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Capão do Tigre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302303' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Itaimbezinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302303' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Campestre da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303673' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Paredão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316808' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Sobradinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arlindo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322608' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Estância Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322608' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Arroio do Meio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chapada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311122' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Luzia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311304' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Encruzilhada São Sebastião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312617' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Silveira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318622' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Capão do Cipó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304655' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Clara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312104' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Arroio da Laje' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305835' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Passo do Sobrado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314076' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Francesa Alta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301651' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Brochier' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302659' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santos Reis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312401' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Tupandi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322251' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302105' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Santa Flora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316907' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'São Martinho da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319125' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Block' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319604' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Coloninha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301206' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Botucaraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lajeado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marques de Souza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312054' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Roca Sales' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pontes Filho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321451' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio Dourado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301306' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Gaviões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305604' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Vicente de Paula' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300209' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nossa Senhora do Amparo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300407' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santa Rita de Cássia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300407' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Brodowski' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3507803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jardinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3525102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ilha Solteira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3520442' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rubiácea' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3544400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Apiaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3502705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeirão Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510302' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Roque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Limpo Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itupeva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3524006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jundiaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3525904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Louveira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3527306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus dos Perdões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3507100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Farol' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107553' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mamborê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ângulo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101150' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Astorga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Centenário do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105904' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Flórida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Getulândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304409' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio das Flores' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parapeúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3306107' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santópolis do Aguapeí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cabrália Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iacanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alfredo Guedes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3526803' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lucianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3527504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Reginópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3542503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Areia Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555505' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Joanópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3525508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nazaré Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Bento do Sapucaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piquete' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Barreiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3549607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porecatu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itambé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ivatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Jorge do Ivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Posse' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303906' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Vale de Bonsucesso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305802' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Japuíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300803' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibituporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302007' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mangaratiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição de Jacareí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302601' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Visconde de Itaboraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301900' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Itatinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3523503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aparecida de São Manuel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Europa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Trabiju' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554755' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Nery' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548906' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ubatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedro Barros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529906' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sete Barras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3551801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itanhaém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arujá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3503901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paiçandu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cambira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paiquerê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113700' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Arapuã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101655' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Inhomirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302502' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Mesquita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302858' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Ferreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3540705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Venda Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510807' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Paraisolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3511706' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Piracicaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barnabés' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3526209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Belém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Carrão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Consolação' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '26';
 update public.distrito set nome = 'Freguesia do Ó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '29';
 update public.distrito set nome = 'Guaianases' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '31';
 update public.distrito set nome = 'Grandes Rios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacutinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111506' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Antônio Brandão de Oliveira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112702' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Andirá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Congonhinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Canaã Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532843' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rubinéia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3544509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Eleutério' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522604' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Americana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3537107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vinhedo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3556701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dracena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Flora Rica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaim Bibi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Marsilac' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '52';
 update public.distrito set nome = 'Pari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '56';
 update public.distrito set nome = 'Rio Pequeno' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '67';
 update public.distrito set nome = 'Vila Leopoldina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '88';
 update public.distrito set nome = 'Santo Antônio da Platina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Figueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107751' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José da Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Isabel do Marinheiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3536901' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Suinana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3500907' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mirassolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Aliança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caiabu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Esperança d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508900' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rosana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3544251' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Domingos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '95';
 update public.distrito set nome = 'Biritiba-Ussu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530607' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Vicente de Carvalho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3518701' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itaúna do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marilena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sengés' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114609' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Novo Três Passos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114609' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Paulo de Faria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3536604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tanabi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tabapuã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3552601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Castilho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532868' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Luzitânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Irapuã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3521507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itajobi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3521903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bastos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3505807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amadeu Amaral' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529005' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ocauçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Frutal do Campo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510005' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Iepê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maracaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3528809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José das Laranjeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3528809' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sapezal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535507' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Fartura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paranavaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sumaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118402' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Querência do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Ivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123709' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Carlos do Ivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125902' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Altônia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Luiz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115101' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Perobal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118857' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Jorge do Patrocínio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125357' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poço Doce' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310209' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Siupé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312403' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Baixa Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Tomé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306306' AND distrito.cod_ibge = '32';
 update public.distrito set nome = 'Serrote do Meio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306306' AND distrito.cod_ibge = '34';
 update public.distrito set nome = 'Caxitoré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313757' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Itacolomy' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313807' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Santa Luzia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313807' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Porfírio Sampaio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310704' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cachoeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306603' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Canafístula' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307403' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Baixio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arrojado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307502' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mangabeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307502' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Alagoinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Brejinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301307' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Campos Sales' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quixariú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302701' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Lagoa dos Crioulos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311959' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Caririaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Sucesso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2516102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sossêgo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2516151' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cepilho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501104' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Borborema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2502706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2502151' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio dos Palmares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610004' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itapissuma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607752' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cavaleiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607901' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pariconha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2706422' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmeira dos Índios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2706307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Betânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304301' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Limoeiro de Anadia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2704203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Munguba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2708105' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sapucaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2700409' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Capela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2701704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Murici' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2705507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maragogi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2704500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anadia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2700201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coruripe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2702306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Mateus da Palestina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2802403' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Gracho Cardoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2802601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cedro de São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2801603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Japoatã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2803401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rosário do Catete' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2806107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boquim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2800670' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barreiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cristópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Descoberto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Maria da Vitória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curaçá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chorrochó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibotirama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iguira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933604' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Bom Jesus da Lapa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Favelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903904' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Barra da Parateca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907103' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Serra do Ramalho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930154' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Formoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carrapichel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930105' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Gentio do Ouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911303' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Lagoa Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912400' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Iraporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tapiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921203' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ibiaporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922102' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tapiramutá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pataíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2900405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Antônio Cardoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição da Feira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910800' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Rafael Jambeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925956' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Argoim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925956' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Teodoro Sampaio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coronel João Sá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra da Canabrava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932002' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Adustina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2900355' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gavião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911253' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riachão do Jacuípe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Valente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buril' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909604' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Canabrava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921401' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Esplanada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amado Bahia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921005' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jacu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931707' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Coqueiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920601' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caraípe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929107' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cabuçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929750' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Caboto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906501' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Madre de Deus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919926' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brotas de Macaúbas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canatiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919801' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ubiraitá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901304' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Baraúnas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929909' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Brejões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cravolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itajuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918001' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Laje' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lajedo do Tabocal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919058' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marcionílio Souza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aracatu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Condeúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coquinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901205' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Belo Campo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caetanos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905156' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quaraçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906709' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Nova Canaã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cercadinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933307' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'José Gonçalves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933307' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Veredinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933307' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Itororó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Brasilia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926657' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Galeão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905404' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Velha Boipeba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905404' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Taperoá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guerém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932903' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Maricoabo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932903' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barra do Rocha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Roque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908002' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Gandu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibirataia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Inema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913606' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Olivença' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913606' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Itajuípe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2915502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapitanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920908' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Santa Cruz da Vitória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2927804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedras de Una' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932507' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Santa Cruz Cabrália' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2927705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pic Sagarana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104502' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Dom Bosco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122470' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmeirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170404' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Brasilândia de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108552' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagamar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chapada Gaúcha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116159' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brejo do Amparo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135209' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Riacho da Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135209' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'São Joaquim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135209' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Nhandutiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139300' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Pedro das Tabocas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149150' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barreiro Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115474' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mulungu de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152204' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Tocandira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152204' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Divisa Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122355' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Montezuma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143450' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rubelita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ferreirópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157005' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Matrona' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157005' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Paredão de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109402' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Bom Jesus da Vereda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129608' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Fé de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Romão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Umbuzeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138658' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Pedro da Garça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143302' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Inhaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121605' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Contrato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3132503' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113008' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Ponto do Marambaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113008' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Novo Cruzeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dois de Abril' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146750' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Antônio Ferreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126752' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Palmeiras do Vale' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165552' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Epaminondas Otoni' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113701' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Fronteira dos Vales' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127057' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piracaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103504' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Canápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3111804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruzeiro dos Peixotos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170206' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Martinésia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170206' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Dolearina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124807' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Santa Rita da Estrela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124807' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Patos de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Major Porto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148004' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Serra do Cipó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Silva Xavier' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167202' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itacolomi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117504' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Carneirinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114550' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iturama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaxima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118205' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jubaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118205' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Monjolos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araújos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa Bonita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jaboticatubas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morro do Pilar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião do Rio Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José da Varginha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3163102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Ponte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedrinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paineiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poções de Paineiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146404' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Curvelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fortaleza dos Nogueiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Matias Olímpio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cajueiro da Praia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202083' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302107' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Redenção' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301950' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Ocara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309458' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sucatinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302206' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Cascavel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dom Quintino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304202' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ponta da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304202' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santana do Cariri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brejo Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312106' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Brejo Santo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riachão do Bacamarte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512754' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Renascer' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503209' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Coivaras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202737' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Teresina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2211001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Francisco Ayres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2204105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmeirais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tapera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301000' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Bom Príncipio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303709' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Lagoa do Juvenal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '29';
 update public.distrito set nome = 'Papara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '32';
 update public.distrito set nome = 'Upanema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2414605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Francisco Dantas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2403905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rodolfo Fernandes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2411007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alhandra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2500601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gergelim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601102' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Timorante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605301' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Serrolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607307' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ouricuri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1400050' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonfim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1400159' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juruti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Oriximiná' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alter do Chão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506807' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vilarinho do Monte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505908' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pedreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501105' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carrazedo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503101' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Curumu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501808' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cachoeira do Arari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chaves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Muaná' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sacramenta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501402' AND distrito.cod_ibge = '75';
 update public.distrito set nome = 'Benfica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501501' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Espírito Santo do Tauá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507003' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vigia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1508209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Emboraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500909' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itapixuna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500909' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Peixe-Boi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Januacoeli' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502103' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Limoeiro do Ajuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira do Piriá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501956' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Luzia do Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506559' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacareacanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503754' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Joaquim do Ituquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501204' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'União da Floresta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504455' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Tucuruí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1508100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dom Eliseu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502939' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Ladeira Vermelha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507300' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Eldorado dos Carajás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502954' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parauapebas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505536' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Velha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600501' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itaubal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600253' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carapanantuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600303' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'Porto Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600535' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anauerapucu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600600' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Angico' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1701051' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maurilândia do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1712801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sampaio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Babaçulândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1703008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pau D''Arco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1716307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Fé do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718865' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araguacema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1701903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1709302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaporã do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1711100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cristalândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1706100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Figueirópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1707652' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passagem da Conceição' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108402' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Capão Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108402' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Bezerro Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102504' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Ponte Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Batovi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108105' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Irenópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Sebastião do Rio Claro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212204' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Registro do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213707' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Alto Horizonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200555' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Trombas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221452' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipiranga de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5210158' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rialma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5218607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rianápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5218706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brazabrantes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5203609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Limpo de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5204854' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Petrolina de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5216809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amorinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Israelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5210307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Adelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200159' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Choupana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5201306' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Caldazinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5204557' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Trindade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cabeceiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5204003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campos Lindos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5206206' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lagolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5217302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Valparaíso de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221858' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chapadão do Céu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5205471' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Doverlândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5207253' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5218805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio da Barra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5219712' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campestre de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5204607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cezarina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5205455' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Panamá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5216007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vicentinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5222054' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5215801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Corumbaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5205901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipameri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5210109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipuã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3521309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aramina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3503000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pioneiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3517703' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bebedouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3506102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lusitânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3524303' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Berto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3528601' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Cruz do Rio Pardo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3546405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sarutaiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3551207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taquarituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lovat' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128104' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Campina da Lagoa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salles de Oliveira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103909' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Nova Cantu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Yolanda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128005' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Novo Sarandi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127700' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Miguel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127700' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Santa Lúcia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123824' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Tereza do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124020' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Itavó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110953' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São José do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125704' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Jacutinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108403' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Pinhal de São Bento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119251' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro do Florido' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124400' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Doutor Antônio Paranhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105409' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vitorino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio XV de Baixo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119608' AND distrito.cod_ibge = '37';
 update public.distrito set nome = 'Atalaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109401' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Passo Liso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113304' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Faxinal do Céu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119301' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mangueirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Apiaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mallet' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Cristóvão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128203' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Antônio Olinto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Adrianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bugre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bocaiúva do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Magro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104253' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fazenda Rio Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107652' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José dos Pinhais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pangaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121208' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barra Bonita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202099' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chapecó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cordilheira Alta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204350' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guatambú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206652' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Lúcia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212106' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santa Terezinha do Progresso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215687' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sul Brasil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217758' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'União do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218855' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Faxinal dos Guedes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210555' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Milani' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216107' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Xaxim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iomerê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207577' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lebon Régis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209706' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Matos Costa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Kennedy' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204301' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Itá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4208005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caraíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217501' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Canoinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Felipe Schmidt' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203808' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Iraputã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4208104' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Papanduva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Timbó Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218251' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Cristóvão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218301' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bateias de Baixo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Fragosos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203303' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guaramirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Francisco do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campos Novos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lages' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Índios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209300' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Painel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211892' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212056' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mirim Doce' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210852' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vitor Meireles' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219358' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Witmarsum' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202206' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Blumenau' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Timbó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra Velha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itajaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4208203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tijucas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira do Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205407' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Campeche' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205407' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Santo Antônio de Lisboa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205407' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'São Pedro de Alcântara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217253' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Braço do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Invernada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206108' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sangão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215455' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Veneza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Balneário Gaivota' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202073' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Meleiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Santa Catarina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216404' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cerro Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322301' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Humaitá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tronqueiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312302' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tiradentes do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321477' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Planalto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321477' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Farinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300505' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sertãozinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300505' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Constantina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra Curta Baixa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305801' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Planalto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rondinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Laranjeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323101' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sete Lagoas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310702' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Floresta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321907' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'São José do Ouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cerro Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318606' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'Tupanci do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322186' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cerro Largo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Souto Neto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314787' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Lajeado Micuim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317509' AND distrito.cod_ibge = '70';
 update public.distrito set nome = 'Campestre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319158' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vitória das Missões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323754' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Turvinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305900' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Itaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310207' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Coqueiros do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305850' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Igrejinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305850' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312955' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quebrado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313706' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Barreirinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320107' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São João Bosco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305504' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Miguel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311809' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Capela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302220' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Faxinal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302220' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Mundo Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304101' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Avelino Paranhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307500' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Não-Me-Toque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312658' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Victor Graeff' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibirapuitã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309951' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaporé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Colombo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309407' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Nova Alvorada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312757' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Protásio Alves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315172' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sampaio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312153' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Vale do Sol' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322533' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Venâncio Aires' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Colinas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305587' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Segrêdo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310439' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Capela da Luz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312377' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Fazenda Laranjeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312617' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Cazuza Ferreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Refugiado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322509' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Tupantuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317400' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Unistalda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322376' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'João Rodrigues' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315701' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Arroio Canoas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301651' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Salvador do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Linha São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316501' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Ipiguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3521150' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mendonça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Osvaldo Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3534609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pacaembu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3534906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parapuã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3536000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alfredo Marcondes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3500808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marabá Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3528700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Teçaindá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529203' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itororó do Paranapanema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3539202' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Montalvão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541406' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Espigão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3542404' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sandovalina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3545506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Anastácio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3547700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Mariana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '90';
 update public.distrito set nome = 'Vila Medeiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '92';
 update public.distrito set nome = 'Biritiba-Mirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3506607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaquaquecetuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3523107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quatinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530607' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Boa Vista Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3552502' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Palmeiras de São Paulo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3552502' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cubatão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3513504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruzeiro do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guairaçá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Barro Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128534' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Piraí do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Diamante D''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107157' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Entre Rios do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107538' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaíra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iracema do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110656' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iguiporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114609' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Margarida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114609' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Roque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114609' AND distrito.cod_ibge = '55';
 update public.distrito set nome = 'Pato Bragado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118451' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Planalto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3539608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Adélia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3545605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Severínia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3551900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João de Iracema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3549250' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poloni' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3539905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sebastianópolis do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3551306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taciba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3552908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fernão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515657' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jafa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3516705' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Marília' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Cravinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3540002' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sussuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535309' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ipaussu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3520905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Deputado José Afonso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118402' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Brasilândia do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103370' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Esperança Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107520' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Camargo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109906' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Taiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312403' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Tururu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313559' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caiçara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302800' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302800' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Caridade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Antonina do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Naraniú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2314003' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Riacho Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2314003' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Quitaiús' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307502' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Riacho Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301307' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Nova Floresta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2510105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Montadas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Areia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rua Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501906' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guarabira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sirinhaém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibiratinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614204' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Três Ladeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606804' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Camaragibe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2603454' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Recife' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cabo de Santo Agostinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Camela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607208' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ouro Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2706109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Minador do Negrão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2705309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2701506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campestre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2701357' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passo de Camaragibe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2706505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra de Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2700508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poxim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2702306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ribeirópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2806008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Malhada dos Bois' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2803807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brejo Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2800704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Siriri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2807204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itabaianinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2803005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Estância' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2802106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Indiaroba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2802809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sítio Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928901' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Missão de Aricobé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901403' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Taguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909406' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mariquita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bem-Bom' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907202' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Poço de Fora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909901' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Abóbora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918407' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Itamotinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918407' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Poços' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926004' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Minas do Mimoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930204' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Paulo Afonso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Formoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903904' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tanquinho do Poço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901353' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Carnaíba de Baixo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924603' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Senhor do Bonfim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra do Mendes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barro Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903235' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itajubaquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911303' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ibititá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iraquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Dutra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Saúde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Vista do Tupim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Volta Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931301' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santanópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Espera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Aribice' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910701' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Caimbe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910701' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Monte Santo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Queimadas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Banzaê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902658' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910750' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeira do Pombal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barrocas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903276' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Joazeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908408' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Lamarão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Retirolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa União' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2900702' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Rio Real' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2927002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jandaíra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itanhi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917904' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Bela Flor' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907509' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sítio Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907509' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Maracangalha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929503' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Maragogipinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Castro Alves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Félix' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salvador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2927408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Botuporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tanque Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931053' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catolés' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2900108' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Igatu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901304' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bastião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Marcolino Moura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926707' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Várzea do Caldas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929909' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Wagner' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amargosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaguaquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipiúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917607' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jiquiriçá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maracás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juraci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920809' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Livramento de Nossa Senhora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caldeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905206' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Maniaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905206' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Ceraíma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911709' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Morrinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911709' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Ibiassucê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iuiú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917334' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Irundiara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917409' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Licínio de Almeida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinga Fogo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923407' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Rancho das Mães' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923407' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Ibitira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926806' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tremedal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anagé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arapiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926707' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bom Jesus da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903953' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catingal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920403' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mirante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921450' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catolezinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2915809' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ribeirão do Salto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916807' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Gamboa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905404' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Piabanha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920700' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Piraí do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924678' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Almadina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2900900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mogiquiçaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903409' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ilhéus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Japu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913606' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Comandatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932507' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Vila Brasil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932507' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Itabela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914653' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibiranhém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922003' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guarda-Mor' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Veredas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136306' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Lagoa Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137536' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cônego Marinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117836' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Rei' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136959' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Capitania' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142700' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Urucuia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170529' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catuti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115474' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bem-Querer' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154507' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vargem Grande do Rio Pardo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170651' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buritizeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaicuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170800' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Coração de Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Muquém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142007' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João da Lagoa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162252' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bentópolis de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170008' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Grão Mogol' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Padre Carvalho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146255' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Extração' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121605' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Planalto de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121605' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Leme do Prado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138351' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Turmalina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Freire Cardoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Pedro do Jequitinhonha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135803' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Malacacheta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Crisólita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120151' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Santa Luzia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120151' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cachoeira Dourada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Flor de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129103' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Félix de Estrela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124807' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Iraí de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João da Serra Negra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148103' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Catiara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3166808' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Funchal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162104' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ouro Verde de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana do Riacho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Costa Sena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117504' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Dom Joaquim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José da Bela Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162104' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Engenho do Ribeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Martinho Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itambé do Mato Dentro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3132800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Gonçalo do Rio das Pedras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167103' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Ascensão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147105' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Argenita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129509' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Biquinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morada Nova de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Augusto de Lima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'J.K.' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120904' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Madeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205854' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Princípio do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201919' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parnaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Acarape' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300150' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa de São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301208' AND distrito.cod_ibge = '19';
 update public.distrito set nome = 'Itans' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306504' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barra Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311603' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Patos dos Liberatos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303956' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Sereno de Cima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309458' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Aurora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mauriti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buritizinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308104' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Bela Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304202' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Araporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312106' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Salgado de São Félix' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504033' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mataraca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bayeux' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curralinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203255' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'José de Freitas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'União' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2211100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Longá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2200301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capitão de Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jatobá do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205276' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206951' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olho D''Água do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310852' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'João de Castro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301000' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Itaitinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306256' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Jubaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Grossos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2404408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra do Mel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2413359' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itajá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2404853' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2400406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Doutor Severiano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2403202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rafael Fernandes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2410504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601102' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Serrânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601102' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Claranã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Feitoria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602001' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tabocas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605301' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mirandiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parnamirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Icaiçara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610400' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bom Nome' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613503' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Afogados da Ingazeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carnaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2603900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sítio dos Nunes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605608' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Inhuma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2204709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Alegre do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2208551' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Francisco do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alvorada do Gurguéia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2200459' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Crateús' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Oiticica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304103' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Poti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304103' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304103' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Ematuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305605' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Nova Russas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Frutuoso Gomes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2404002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'João Dias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2405900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Bento do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2411601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lajes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2406700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra Negra do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2413409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quixaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611533' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz da Baixa Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612471' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Egito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonfim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613602' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caiçarinha da Penha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613909' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Rita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613909' AND distrito.cod_ibge = '28';
 update public.distrito set nome = 'Albuquerque Né' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614105' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Petrolina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Francisco Santos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2204204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio de Lisboa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Betânia do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201739' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Domingos da Costa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302404' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibaretama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305266' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Oiticica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305266' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Riacho Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311306' AND distrito.cod_ibge = '52';
 update public.distrito set nome = 'São Bernardo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311306' AND distrito.cod_ibge = '57';
 update public.distrito set nome = 'São Tomé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2412906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Januário Cicco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2405306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2408300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Maria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2409332' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curral Queimado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611101' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Caraíbas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612604' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Urimamã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612604' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Caraibeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614808' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guanumbi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602803' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Tupanatinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alagoinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mandaçaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602605' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Capitão Gervásio Oliveira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202455' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedro Laurentino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207934' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa do Carneiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300200' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Ibuguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304707' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Parazinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304707' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Marruás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313302' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Acopiara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quincoê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300309' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Solidão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300309' AND distrito.cod_ibge = '33';
 update public.distrito set nome = 'Ceará-Mirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2402600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baía Formosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2401404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gravatá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pão de Açúcar de Poção' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Espírito Santo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613008' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Casinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604155' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pão de Açucar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615003' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itarema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306553' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mocambo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307809' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Várzea dos Espinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305001' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Martinslândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305001' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Ibicuã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310902' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Campestre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304459' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Castanhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300705' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cabrito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300705' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São José do Lagamar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307007' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513984' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aguiar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2500205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olho d''Água' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2510402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Socorro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2510402' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Vazante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2505600' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Inês' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513356' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Vicente Ferrer' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Correntes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmeirina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iatecá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Altinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Entroncamento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608701' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Boa Vista do Caxitoré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306108' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Padre Linhares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308005' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Poço Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309003' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Aprazível' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312908' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Caioca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312908' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Taperuaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312908' AND distrito.cod_ibge = '55';
 update public.distrito set nome = 'Pedras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308708' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Quixeré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonhu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311801' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João de Deus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311801' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São João do Jaguaribe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Peixe Gordo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313104' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Candeias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303808' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Pedrinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305407' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São Vicente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305407' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Guassussê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309508' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pelo Sinal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509008' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Juazeirinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2507705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Maria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2514107' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Luzia do Cariri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2515500' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pio X' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2516300' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barra de Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501575' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boqueirão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2502508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cabaceiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riacho de Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512788' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ferreiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chã de Alegria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'América' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305902' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Engenheiro João Tomé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305902' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Gázea' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305902' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Catunda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303659' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amontada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300754' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Icaraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300754' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Assunção' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306405' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santa Luzia do Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200169' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Nelita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200169' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Cotaxé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202108' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jurama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205176' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Alto Rio Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200359' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quilômetro 14 do Mutum' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200805' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Morello' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202256' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Vinhático' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203502' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cristal do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204054' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Verona' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204906' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Vila Nova de Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301009' AND distrito.cod_ibge = '85';
 update public.distrito set nome = 'Colônia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304805' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Macaé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Frade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302403' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Werneck' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303708' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Sapucaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300506' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Amparo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Triunfo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304607' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Pendanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202504' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Pontal do Ipiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203205' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Fazenda Guandu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200102' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Santa Marta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202553' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Muniz Freire' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Patrimônio do Ouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201407' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Barra do Itapemirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203320' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carabuçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300605' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Serrinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300605' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Italva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302056' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Comendador Venâncio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302205' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São José de Ubá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305133' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmeiras do Manhuaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139409' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Matipó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana do Manhuaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Missionário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102100' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cipotânea' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Firme' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senhora de Oliveira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3166006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lacerdinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113305' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Divino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus da Cachoeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143906' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Pedra Dourada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catuné' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169208' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santana do Campestre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104601' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tuiutinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129004' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Diamante de Ubá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169901' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sobragi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106101' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Sarandira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136702' AND distrito.cod_ibge = '70';
 update public.distrito set nome = 'Oliveira Fortes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carlos Alves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162906' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pregos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165602' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Além Paraíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Três Lagoas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5008305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Garcias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5008305' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Taquarussu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007976' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bela Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guia Lopes da Laguna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Antônio João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5000906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Indápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003702' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Santa Terezinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004502' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5008404' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Iguatemi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Castanheira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102850' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Filadélfia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105150' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Campo Novo do Parecis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102637' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coqueiral' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105903' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Tapurah' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Terezinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107776' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Leste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107792' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra do Garças' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cocalinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra do Bugres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Estrela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106851' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morro Gaúcho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322541' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Arroio dos Ratos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Charqueadas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305355' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vale Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322525' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Estância Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300604' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Estância Velha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Picada São Jacob' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319901' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Itapuã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323002' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Arroio do Sal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301057' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Colônia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306551' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Costão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312443' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Aguapés' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313508' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'Quintão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313656' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Torres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Três Forquilhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321832' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318614' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião do Caí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arco Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304804' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Luiza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304804' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Criúva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305108' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cotiporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305959' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fagundes Varela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307864' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Pádua' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313086' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Vicente do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Toropi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321493' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Linha Bonita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321493' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Formigueiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canhemborá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Arroio do Tigre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Linha do Rio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304200' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Itaúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307815' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Delfina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307807' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Forquetinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308433' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bela Vista do Fão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312054' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paverama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314159' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314159' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Pouso Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315131' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Xaxim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315156' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Campinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315800' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Amoras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321303' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Teutônia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321451' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra de São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio das Ostras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304524' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Praia Seca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300209' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Tamoios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300704' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Terra Roxa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luís Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3527603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeirão Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz da Estrela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3547502' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Serrana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3551504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lavínia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3526506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmitalzinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3502705' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Itaóca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522158' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapirapuã Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522653' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3542800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paruru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519709' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Alumínio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501152' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araçariguama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3502754' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bacaetava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3521002' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3523909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porteira Preta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107702' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Roncador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tupinambá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102109' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Iguaraçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Munhoz de Melo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arrozal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304003' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São José do Turvo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300308' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Mambucaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300100' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Parati Mirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303807' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Andrade Pinto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3306206' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bilac' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3506409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lourdes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3527256' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Getulina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3517000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Francisco Xavier' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3549904' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tremembé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaratinguetá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3518404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Potim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3540754' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sertanópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Belford Roxo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300456' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto das Caixas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301900' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Guia de Pacobaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302502' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Avaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3504503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cerqueira César' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3511409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bueno de Andrada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3503208' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caraguatatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ariri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Iguape' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3520301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Registro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3542602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedro de Toledo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3537206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mairiporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3528502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Terra Preta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3528502' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pitangueiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119657' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruzmaltina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106852' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Palmital' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122107' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nilópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caconde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tapiratiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Artur Nogueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3503802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tujuguaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3512209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Limeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3526902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Saltinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3545159' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Embu-Guaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ouro Fino Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Água Rasa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '01';
 update public.distrito set nome = 'Brás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cidade Dutra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Alto Porã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rancho Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião da Amoreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora da Candelária' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itambaracá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aparecida d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3502606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmeira d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Albertina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3545704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Urânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Martim Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530805' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Antônio de Posse' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Indaiatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3520509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinhalzinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Terra Nova d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3547106' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Indaiá do Aguapeí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3516002' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jaguaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '41';
 update public.distrito set nome = 'Jardim Helena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '44';
 update public.distrito set nome = 'Sapopemba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '76';
 update public.distrito set nome = 'Tremembé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '81';
 update public.distrito set nome = 'Santa Mariana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sertaneja' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alecrim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107009' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vassoural' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109708' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Lajeado Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117305' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São João das Duas Pontes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3549201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Vista dos Andradas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501202' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pontes Gestal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3540309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olho d''Água do Casado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2705804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaramataia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2703700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olivença' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2706000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olho d''Água Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2705903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Joaquim Gomes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2703809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Lino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2705606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto de Pedras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2707404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Satuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2708907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2701407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jequiá da Praia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2703759' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Penedo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2706703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto da Folha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2805604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora das Dores' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2804607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itabaiana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2802908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Simão Dias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2807105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riachão do Dantas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2805802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Telha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2807303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barracas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2801306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2806909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'General Maynard' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2802502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riachuelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2805901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Amaro das Brotas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2806602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra dos Coqueiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2800605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaporanga d''Ajuda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2803203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cariparé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926202' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Brejolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Malhada Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928406' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Wanderley' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933455' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaborandi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917359' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Alegre de Lourdes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juremal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918407' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Saldanha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924405' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Piri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930204' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Muquém de São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922250' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Filadélfia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910859' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaguarari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bananeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924603' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Igara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930105' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Antari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903003' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Canal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Recife' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Morro do Chapéu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Camirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921708' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ponto Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925253' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itatiaia do Alto Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929370' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Várzea do Poço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919603' AND distrito.cod_ibge = '21';
 update public.distrito set nome = 'Mundo Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coração de Maria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Matinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910800' AND distrito.cod_ibge = '38';
 update public.distrito set nome = 'Canché' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João da Fortaleza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907806' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Paripiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capela do Alto Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906857' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aporá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itamira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São José do Mucambo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910602' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Catu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição do Almeida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Comércio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908309' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pirajuia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917805' AND distrito.cod_ibge = '26';
 update public.distrito set nome = 'Campinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928604' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Baixa do Palmeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929602' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Saubara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929750' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Camaçari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olhos d''Água do Seco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913002' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Brejo Luiza de Brito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923035' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bom Sossego' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Abaíra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2900108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'João Correia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921906' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Rio de Contas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riachão do Utinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932804' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Novo acre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Boaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918001' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Dom Basílio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iguatemi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919504' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pilões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906600' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905156' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itajaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922706' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vitória da Conquista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933307' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Laje do Banco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Poço Central' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902401' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Camacan' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poxim do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906303' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ibirapitanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaju do Colônia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2915403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Ibiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922755' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itagimirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2915304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibirajá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916005' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Luzia da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136306' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Cruz dos Araújos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117836' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Montalvânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Isabel de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161106' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Quem-Quem' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135100' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Nova dos Poções' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135100' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Berizal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106655' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novorizonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145372' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Retiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160454' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lassance' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pirapora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fernão Dias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108602' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santana da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3112703' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Tejuco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135209' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Campo Alegre de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129657' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143302' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santo Antônio da Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162401' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Vila Sítio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127800' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'São Norberto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123809' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Conselheiro Mata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121605' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mendanha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121605' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Aricanduva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104452' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carbonita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Padre João Afonso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3132503' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Caçaratiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169703' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Araçuaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira de Pajeú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Almenara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaguarão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134707' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio do Prado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapiru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156601' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Maria do Salto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pavão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Umburaninha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106606' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Machacalis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Helena de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157658' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amanhece' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103504' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Patrimônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152808' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tupaciguara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pântano de Santa Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119302' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Brejo Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120706' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Chapada de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124807' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Serra do Salitre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3166808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monjolinho de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137502' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Matutina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chumbo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148004' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Matozinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mocambeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141108' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santana de Pirapama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição do Mato Dentro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Córregos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117504' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ouro Fino do Mato Dentro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117504' AND distrito.cod_ibge = '28';
 update public.distrito set nome = 'Miraporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170206' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Itapagipe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senhora da Glória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160603' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Valo Fundo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160603' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Luz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Moema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quartel de São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3153707' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Araçaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cordisburgo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Milho Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167103' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Onça de Pitangui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Belo Horizonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tapira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Andrequicé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169356' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Angueretá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120904' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Geraldo do Salto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125705' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Ribeirão Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110906' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tasso Fragoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Loreto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Colinas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2107258' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sambaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Raimundo das Mangabeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Batalha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brasileira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201960' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Largo do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202174' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora dos Remédios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Arraial' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209971' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Plácido Martins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301208' AND distrito.cod_ibge = '24';
 update public.distrito set nome = 'Aratuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309805' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Córrego' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301950' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Serragem' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309458' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Serra do Félix' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302206' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Santa Vitória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301703' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302008' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Umburanas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308104' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Santa Fé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304202' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Dom Leme' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312106' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Lagoa Seca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2508307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dois Riachos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513109' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Mata Virgem' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2517001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jacaraú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2507309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Tinto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Miguel Leão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Domingos Mourão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203420' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pajuçara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307650' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Manoel Guedes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '31';
 update public.distrito set nome = 'Jucurutu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2406106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Rafael' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2412807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Venha-Ver' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2414753' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Praia de Fagundes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2508604' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Zé Gomes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605301' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santa Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612455' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibitiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2603900' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lagoa do Sítio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205599' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baixa Grande do Ribeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201150' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marcos Parente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Redenção do Gurguéia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2208700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senador Carlos Jereissati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309706' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Pacajus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Irapuá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304103' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Monte Sinai' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305605' AND distrito.cod_ibge = '34';
 update public.distrito set nome = 'Três Irmãos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309409' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Algodões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311264' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311264' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Rafael Godeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2410603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barão de Serra Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2411403' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ingazeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canaã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615706' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Inajá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sertânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jurema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205532' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Lourenço do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210359' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Geminiano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2204352' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Oliveiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313203' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Massapê dos Paes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302404' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Monte Castelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303931' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Macaoca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307635' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'União' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307635' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Juá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311306' AND distrito.cod_ibge = '43';
 update public.distrito set nome = 'Lacerda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311405' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Monte das Gameleiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2407906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brejinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2401800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passa e Fica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2409100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passagem' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2409209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nazaré do Pico' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605707' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Itaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Negras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607505' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itainópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marcolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205953' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300309' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Baixio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304269' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Senador Georgino Avelino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2413201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Flor' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2415008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2508109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira dos Índios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Trapiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611705' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Gravatá do Ibiapina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615003' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vertente do Lério' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2616183' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mucambo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305001' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Viçosa do Ceará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2314102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'General Tibúrcio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2314102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Quatiguaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2314102' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Canto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304004' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Várzea da Volta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308807' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Uruoca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campánario' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313906' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Senador Pompeu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Codia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312700' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Aracati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cabreiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Icapuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305357' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibicuitaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305357' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Alto Santo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Viçosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305332' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Jaguaruana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Borges' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307007' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São José de Piranhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2514503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2514503' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vista Serrana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2505501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lastro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2508406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Bentinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513927' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Domingos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513968' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José da Lagoa Tapada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2514206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vieirópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2517209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mãe d''Água' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2508703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passagem' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2510709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Igaracy' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2502607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cardoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Montevidéo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504405' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Curral Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2505303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2507002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedra Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2511004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bengalas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610509' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Brejão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Calçado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2603306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Miracica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606002' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Igapó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608602' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palestina do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308203' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308203' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Trapiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304350' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Riachão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308377' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Aracatiaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caracará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312908' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Rafael Arruda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312908' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Patos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312908' AND distrito.cod_ibge = '47';
 update public.distrito set nome = 'Ipueiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palhano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaguaretama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pereiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Manaíra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Teixeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2516706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baraúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501534' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Palmeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2510303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Congo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coxixola' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504850' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ouro Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2510600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sumé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2516300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caturité' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504355' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610202' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Camutanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2603603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carpina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa do Carro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608453' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vitória de Santo Antão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2616407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pirituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2616407' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Matriz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305902' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Reriutaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Croata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313955' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Macaraú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312205' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Muribeca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312205' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Poço Comprido' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300754' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Bela Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306405' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Cruxati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306405' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Lagoa das Mercês' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306405' AND distrito.cod_ibge = '49';
 update public.distrito set nome = 'Córrego Fundo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313500' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Alto Mutum Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200805' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itabaiana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203601' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200607' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santo Eduardo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301009' AND distrito.cod_ibge = '55';
 update public.distrito set nome = 'Barra Seca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304755' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Fidélis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cambiasca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304805' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carapebus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300936' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302403' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Areal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300225' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraíba do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bemposta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3306008' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cordeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conselheiro Paulino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303401' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Riograndina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303401' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Dona Mariana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305703' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santo Antônio do Imbé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304607' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Vila da Grama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305901' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Jorge de Tiradentes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204351' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Brejetuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201159' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rita de Brejetuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201159' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Isabel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201902' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Laranja da Terra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203163' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itarana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Teresa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Canaã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204609' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'São Jacinto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204955' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Araçatiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205101' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200201' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'São Raimundo da Pedra Menina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202009' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ibitirama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202553' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Burarama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Vicente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201209' AND distrito.cod_ibge = '36';
 update public.distrito set nome = 'São Pedro de Itabapoana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203403' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Piabanha do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202801' AND distrito.cod_ibge = '14';
 update public.distrito set nome = 'Itaperuna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Laje do Muriaé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aperibé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300159' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304706' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Betim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Douradilho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301909' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Capela Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303509' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Capela Velha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303509' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Sentinela do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320354' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pintado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310603' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Maçambará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311718' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pirajú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311759' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Beluno' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318101' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mangueiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316402' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Aceguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300034' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bagé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Joca Tavares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301602' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Capitão Noronha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306908' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Maria Santa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306908' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Pompeu Machado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306908' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Pinheiro Machado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piratini' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Segundo Distrito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304507' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Monte Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314407' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Mauá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Povo Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315602' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Taim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315602' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Atlântico' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317301' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Albuquerque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003207' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Romão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Figueirão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sonora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007935' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quebra Côco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007901' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Alto Sucuriú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006275' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Aparecida do Taboado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5001003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ilicínea' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monsenhor Paulo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Bento Abade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibitiúra de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacutinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poços de Caldas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Borda da Mata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapeva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Munhoz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pouso Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sao José do Pântano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152501' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tocos do Moji' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169059' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Toledo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109709' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Heliodora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Natércia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Águas de Contendas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117702' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itamonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pé do Morro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147600' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santana do Capivari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152600' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Andrelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cristina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Delfim Moreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ijaci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ingaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ritápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana do Garambéu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Tiago' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mercês de Água Limpa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165008' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caixa D''Água da Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168804' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Barbacena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Colônia Rodrigo Silva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105608' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Pinheiro Grosso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105608' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Ponto Chique do Martelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105608' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'São Vicente do Grama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135506' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Sem-Peixe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165560' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sericita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3166303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caeté' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dionísio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121803' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Senhora do Carmo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131703' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Era' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Maria de Itabira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaguara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3132206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Souza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rodrigo Silva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146107' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'São Sebastião do Gil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121407' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Divinolândia de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sardoá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Frei Lagonegro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126950' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coroaci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Galiléia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chonin de Baixo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127701' AND distrito.cod_ibge = '28';
 update public.distrito set nome = 'São José da Safira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3163003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mantena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Naque-Nanuque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3100500' AND distrito.cod_ibge = '28';
 update public.distrito set nome = 'São Sebastião de Braúnas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106309' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bom Jesus do Galho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tabajara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130903' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santa Maria do Baixio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162609' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Tarumirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alvarenga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Assaraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151909' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Independência' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154309' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Medeiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Barreiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pontevila' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126109' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Marilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133501' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Babilônia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Passos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro da União' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3163904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alfenas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poço Fundo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Granada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3100302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Campos Lindos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1703842' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Craolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1709005' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Novo Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1715259' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ponte Alta do Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1717800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bacuri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bacurituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101350' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cururupu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Primeira Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonfim do Arari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101004' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pinheiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Roque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108603' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itapecuru Mirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luís Domingues' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maranhãozinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106375' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa Grande do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105963' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paulo Ramos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itinga do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105427' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bernardo do Mearim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101939' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lima Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Luís Gonzaga do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arame' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100956' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sítio Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Governador Luiz Rocha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104628' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Custódio Lima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106300' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Buriti Bravo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parnarama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2107803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barão de Grajaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pastos Bons' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guajará-Mirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100106' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'São Francisco do Guaporé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101492' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Oriente Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100130' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tarilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100114' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Rondominas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100155' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Vila Bandeira Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100254' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Vale do Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alta Floresta D''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100015' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Vista do Pacarana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100098' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rolim de Moura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100288' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Horizonte do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Felipe D''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101484' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Colorado do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100064' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mâncio Lima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200336' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senador Guiomard' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200450' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila do Caquetá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200807' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Brasiléia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Envira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guajará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301654' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Badajos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ariaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301852' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Manaquiri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1302553' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Preto da Eva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303569' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itacoatiara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ariaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300508' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lábrea' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1302405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Manicoré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1302702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Luiz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1400605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Maracanã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503002' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Belterra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501451' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curuai' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506807' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Porto de Moz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Joanes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506302' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Lauro Sodré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502905' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Maracanã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Matapiquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504406' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Terra Alta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507961' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caratateua' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501709' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Mocajuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501709' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Francisco do Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abaetetuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Torres do Cupijó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502103' AND distrito.cod_ibge = '36';
 update public.distrito set nome = 'Concórdia do Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502756' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Irituia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel do Guamá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Urucuri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507607' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Brasília Legal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501006' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Novo Progresso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505031' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Castelo dos Sonhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500602' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Anapu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500859' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Belo Monte do Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505064' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Maracajá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505064' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Rondon do Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506187' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Nereu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507300' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Tucumã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1508084' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pau D''Arco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505551' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sapucaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507755' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pirativa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600600' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Mazagão Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600402' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Augustinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1702554' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buriti do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1703800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Darcinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1706506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Colinas do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1705508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Wanderlândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1722081' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brasilândia do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1703602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Santo do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1713700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraíso do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1716109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arruda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107701' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Água Fria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103007' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Coxipó do Ouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103403' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Seco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106109' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Caité' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107800' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Várzea Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Joselândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101605' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Coronel Ponce' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102678' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paredão Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103908' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Pontal do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106653' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Torixoréu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anhumas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107602' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Novo Planalto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5215256' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aruanã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5202502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Britânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5203807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juscelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212204' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Campos Verdes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5204953' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Taveira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5214606' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Carmo do Rio Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5205000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Natinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208608' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Diolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5211206' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Morro Agudo de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213855' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Joanápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5201108' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Damolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5206800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jesúpolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212055' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaupaci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capelinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5201306' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Buriti de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5203939' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rosalândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5220108' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Turvânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Goianira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guapó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5209200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Leopoldo de Bulhões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sítio d''Abadia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5220702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alexânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Córrego Rico' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5217609' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Gabriel de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5217609' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Propício' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5222302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rita do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5219407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Edealina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5207352' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itumbiara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5211503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Alvorada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5215306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Campo Alegre de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5204805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Goiandira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5220405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Brasília' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5300108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Horizonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Joaquim da Barra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3549409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Patrocínio Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3536307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaboticabal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3524303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taquaral' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553658' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3546405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sodrélia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3546405' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Águas Virtuosas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554201' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Irapé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3557204' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barão de Antonina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3505005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aracaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508009' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guarizinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522406' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Riversul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alambari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3500758' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Varginha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522307' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Maristela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3526407' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cianorte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cidade Gaúcha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jussara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Manoel do Paraná' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125555' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bela Vista do Tapiracuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126801' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Boa Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Janiópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Concórdia do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127700' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Campo Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104055' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capitão Leônidas Marques' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora da Penha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106308' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Guaraniaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iguatu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110052' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Céu Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maralúcia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115804' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Baulândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121604' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Serranópolis do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126355' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ampére' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101002' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bela Vista da Caroba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102752' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Realeza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Izabel do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anunciação' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123808' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Prata do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117255' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chopinzinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Coxilha Rica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111209' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124806' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Palmital' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Corumbataí do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106555' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marquinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115457' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117057' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Assentamento Ireno Alves dos Santos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122156' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pinho Fleck' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109658' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Fernandes Pinheiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107736' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rebouças' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bituruna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'General Carneiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Triunfo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113205' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Balsa Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Contenda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catanduvas do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pinhais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119152' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cacatu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Matinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto de Cima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116208' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Doce Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121208' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Idamar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205001' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212239' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Princesa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4214151' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Helena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215554' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Águas de Chapecó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Erê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Erechim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baía Alta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213401' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Arroio Trinta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra Fria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Macieira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210050' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vargem Bonita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219176' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Videira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lourdes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219309' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Alto Bela Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200754' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Xavantina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Preto do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210100' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Porto União' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Craveiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215679' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Massaranduba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bela Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203600' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Anita Garibaldi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bocaina do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202438' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Rufino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215059' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pericó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216503' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Maria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202206' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Balneário Piçarras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Angelina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Biguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeirão da Ilha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205407' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Palhoça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capivari de Baixo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203956' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pescaria Brava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212650' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cocal do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204251' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Içara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guatá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209607' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Treviso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218350' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Balneário Rincão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4220000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passo de Torres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212254' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Esquina Araújo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310405' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Porto Lucena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Cristo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barrinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321808' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'Paulo Lopes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Planalto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306007' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Martinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Três Passos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Valentin da Gruta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300646' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Castelinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308508' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Progresso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321857' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vista Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Áurea' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301552' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Benjamin Constant do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302055' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Erechim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307203' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Quatro Irmãos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315313' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Viadutos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibiaçá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Telha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309803' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sananduva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marmeleiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318606' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305207' AND distrito.cod_ibge = '14';
 update public.distrito set nome = 'Ivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302501' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Ângelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rincão dos Roratos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317509' AND distrito.cod_ibge = '47';
 update public.distrito set nome = 'Ressaca Buriti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317509' AND distrito.cod_ibge = '48';
 update public.distrito set nome = 'Sossego' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317509' AND distrito.cod_ibge = '55';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317707' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rincão de São Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318903' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Senador Salgado Filho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320321' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Medianeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300208' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Butiá Inferior' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319372' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Floresta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310207' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Pedro Paiva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317806' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Valério do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319737' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Almirante Tamandaré do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300471' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Vista das Missões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302154' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305306' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Tesouras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305306' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Jaboticaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310850' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lajeado do Bugre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311429' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ciríaco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruzaltinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305504' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'David Canabarro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Veado Pardo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311809' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Pontão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314779' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cecília do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316733' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317558' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Vila Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320909' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Vanini' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322558' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Maria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Formigueiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302220' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Boa Vista do Incra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302238' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campos Borges' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Volta Vitória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304101' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Fazenda Colorado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308458' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Quinze de Novembro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315354' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tunas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322152' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Bassano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Espumoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gramado Xavier' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309159' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José da Reserva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316808' AND distrito.cod_ibge = '41';
 update public.distrito set nome = 'Serrinha Velha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320263' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Mariante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322608' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Forqueta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301008' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Monte Alegre dos Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312377' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Retiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312617' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Capão Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312617' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vacaria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310439' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Três Mártires' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311205' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Ijucapirama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311106' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Boca do Monte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316907' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Costa da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312401' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Pareci Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314035' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caxias do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Oliva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305108' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Coronel Pilar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305934' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jansen' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307906' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mato Perso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308201' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Faxinal do Soturno' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taquaral' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301206' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Encantado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Estrela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Batovira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315156' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Novo Cabrais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313391' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arraial do Cabo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300258' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sampaio Correia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305505' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barrinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3505609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guatapará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3518859' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3523008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Três Alianças' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530102' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Independência' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Valparaíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3556305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cabreúva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508405' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Canguera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550605' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cafeara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Florestópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fumaça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304201' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Taboas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304508' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Paraty' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tarituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303807' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Paracambi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juritis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3517109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cafelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaimbê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3517307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3517307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jacuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3503406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Borebi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3507456' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piratininga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3539400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra Bonita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3505302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boracéia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3507308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Batatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538600' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Igaratá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3520202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José dos Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3549904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quiririm' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Arapeí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3503158' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Areias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3503505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Miraselva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Prado Ferreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120333' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Doutor Camargo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeiras de Macacu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304300' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Águas de Santa Bárbara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3500550' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arandu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3503109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paranapanema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Botucatu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3507506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conchas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3512308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibitinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Descalvado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3513702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibaté' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guarapiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3542909' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Corumbataí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3512704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paranabi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3520400' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Sebastião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Picinguaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barra do Turvo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3505401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapeúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514809' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ilha Comprida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3520426' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapevi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jandira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3525003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Francisco Morato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3516309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iguatemi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115200' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Reis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101408' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112108' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Maravilha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113700' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Manoel Ribeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302700' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Maria da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3547007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Roque da Fartura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3500402' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barrânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508702' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Divinolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3513900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Rio Pardo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3549706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião da Grama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Claro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ajapi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Águas de São Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3500600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jumirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3525854' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guamium' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538709' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Mauá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paranapiacaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3547809' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Artur Alvim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Cidade Tiradentes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Jardim Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lunardelli' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113759' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125001' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São Pedro do Ivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Uraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruzeiro do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nossa Senhora Aparecida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101101' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bandeirantes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João de Meriti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aspásia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3503950' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana da Ponte Pensa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3547205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Joaquim Egídio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509502' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cosmópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3512803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Alegre do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3531209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jamaica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514403' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tupi Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Adamantina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3500105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Irapuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3521606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaquera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '37';
 update public.distrito set nome = 'Jaguara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Parque do Carmo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '57';
 update public.distrito set nome = 'Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '70';
 update public.distrito set nome = 'São Rafael' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '75';
 update public.distrito set nome = 'Vila Andrade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '83';
 update public.distrito set nome = 'Vila Curuçá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '84';
 update public.distrito set nome = 'Jundiaí do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Brasília do Itararé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104709' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Reserva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bálsamo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3504800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Itapirema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532801' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Salmourão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3545100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anhumas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3502408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guachos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529203' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Presidente Prudente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Eneida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541406' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Brás Cubas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530607' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Poá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3539806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Inajá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Candeia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115358' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Palotina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cajobi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pindorama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Magda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3528304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Aprazível' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3531407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaiúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3531407' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nhandeara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nipoã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pompéia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3540002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vera Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3556602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Roseta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535507' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Bernardino de Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3506300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Esmeralda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Pedro do Paraná' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tamboara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mirante do Piquiri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100707' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Saltinho do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100707' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Guaiporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103479' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Silvestre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106605' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Rio Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108320' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Santa Helena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110607' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cágado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312403' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Serrote' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312403' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Joaquim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313757' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Apuiarés' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cariús' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caipu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Amaro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301604' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itaguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302701' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Miguel Xavier' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303204' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cariutaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304301' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Olivedos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2510501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araruna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Areial' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alagoa Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2500304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araçagi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2500809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Duas Estradas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2505808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Galante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504009' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Catende' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sauê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614857' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Igarassu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ponte dos Carvalhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602902' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nossa Senhora do Ó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607208' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São José da Figueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123528' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ponte do Silva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139409' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'Realeza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139409' AND distrito.cod_ibge = '14';
 update public.distrito set nome = 'São Sebastião do Sacramento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139409' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Manhumirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Estêvão de Araújo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103702' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paula Cândido' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piranguita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155207' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Miguel do Anta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3163805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Teixeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Triunfo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171303' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Ponte Alta de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113305' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Miraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Santa de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169208' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Ubá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Domingos da Bocaina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138609' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mar de Espanha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus do Vermelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159407' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João Nepomuceno' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Simão Pereira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cisneiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146701' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tamandaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006309' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Anaurilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5000807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova América' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002407' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bocajá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003504' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003702' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Laguna Carapã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5005251' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vicentina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5008404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coronel Sapucaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003157' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaçulândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004007' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Japorã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jateí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5005103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tacuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007950' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carlinda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102793' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Miraguaí do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108055' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nonoaí do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108055' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Itanorte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102637' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Colônia dos Mineiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103304' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Diamantino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Horizonte do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106273' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itanhangá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5104542' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Entre Rios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106240' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sinop' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Confresa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103353' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106315' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeirão Cascalheira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107180' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Espigão do Leste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107859' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'União do Leste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106257' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Itaquerê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106281' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São José dos Quatro Marcos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Visconde de Imbé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305901' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Gramado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Butiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alvorada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Eldorado do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306767' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gravataí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itacolomi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309209' AND distrito.cod_ibge = '33';
 update public.distrito set nome = 'Viamão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Magistério' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301636' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Curumim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304630' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caraá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304713' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Borussia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313508' AND distrito.cod_ibge = '28';
 update public.distrito set nome = 'Passinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313508' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Granja Getúlio Vargas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313656' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Chicolomã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317608' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Passo do Goulart' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311718' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Nhú-Porã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318002' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Colônia Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300034' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Hulha Negra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309654' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304358' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Seival' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304358' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Quinto Distrito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314605' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Cerrito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305124' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305124' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Taquaral' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318804' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Arroio Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bote' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307104' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Bojuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318507' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Corumbá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ladário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5005202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jauru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003306' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Rochedinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002704' AND distrito.cod_ibge = '80';
 update public.distrito set nome = 'Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003256' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Elói Mendes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bandeira do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Mateus de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110509' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Areias de Itapeva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133600' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Senador José Bento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cordislândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3163201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mirantão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107208' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tabuão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107505' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Liberdade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maria da Fé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itererê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3172202' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carrancas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157336' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Gonçalo do Amarante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162500' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Correia de Almeida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105608' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Senhora dos Remédios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3166204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Doce' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz do Escalvado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Roças Novas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110004' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Serra Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140704' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Benedito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157807' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Major Ezequiel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102308' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barão de Cocais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itatiaiuçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jeceaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira do Brumado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140001' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Camargos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140001' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Lavras Novas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146107' AND distrito.cod_ibge = '34';
 update public.distrito set nome = 'Miguel Burnier' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146107' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'São Bartolomeu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146107' AND distrito.cod_ibge = '55';
 update public.distrito set nome = 'Carmésia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dores de Guanhães' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guanhães' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sabinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Virginópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alpercata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campanário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição de Tronqueiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119203' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Penha do Cassiano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127701' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Guarataia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3132701' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jampruca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135076' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Virgolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Central de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itabirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3100500' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Antônio Dias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senador Melo Viana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lagoa de Pau' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135001' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Joanésia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra Grande de Mesquita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141702' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'Cachoeira do Vale' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168705' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Dom Lara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113404' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Dom Cavati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião da Barra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129301' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Inhapim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Macadame' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130903' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Santa Bárbara do Leste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157252' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição de Ipanema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bueno' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118403' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ferruginha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118403' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Mutum' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Doresópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra da Canastra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164308' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Bom Jesus de Angicos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114204' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Conceição do Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Camacho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Formiga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Perdões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passa Tempo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião da Estrela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159902' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Capitólio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3112802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaú de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133758' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arceburgo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Tomás de Aquino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Areado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carmo do Rio Claro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Douradinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139003' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Palmeirópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1715754' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte do Carmo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1713601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Real' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1716505' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Luzimangues' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718204' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santa Maria do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718881' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Sono' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718758' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Félix do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1720150' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1707009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lavandeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1712157' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taipas do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1720937' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bacabeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101251' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Humberto de Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nina Rodrigues' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2107209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cândido Mendes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Turiaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araguanã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100873' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Açailândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100055' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Imperatriz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lajeado Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105989' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedreiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pio XII' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Trizidela do Vale' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112233' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Graça Aranha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Bernardo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Peritoró' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108454' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Iorque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2107308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abunã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100205' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Príncipe da Beira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100080' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova União' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101435' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100015' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Tarauacá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Manoel Urbano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200344' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila do Incra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200807' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Içana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303809' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Benjamin Constant' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Uarini' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1304260' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cacau Pirêra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301852' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Silves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1304005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nhamundá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mocambo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303403' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Novo Aripuanã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amajari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1400027' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bagre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Portel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ananindeua' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504422' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Castanhal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Inhangapi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Praia de Marudá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504406' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Porto Salvo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1508209' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Capanema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mirasselvas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502202' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santarém Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila do Carmo do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502103' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Capitão Poço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipixuna do Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503457' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Viseu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1508308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vitória do Xingu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1508357' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taboca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507300' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Redenção' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506138' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Floresta do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503044' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Maria das Barreiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506583' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra do Navio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600055' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ferreira Gomes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600238' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Esperantina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1707405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nazaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1714302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Bento do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1720101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sítio Novo do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1720804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Olinda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1714880' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juarina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1711803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio dos Bois' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pium' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1717503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cariri do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1703867' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jarudore' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107008' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Alto Taquari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5100607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nucleo Triticola' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205555' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ponte Alta do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213351' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Cristovão do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216057' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Zortéa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219853' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jardim da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Belo do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cerro Negro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204178' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Teresinha do Salto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209300' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Otacílio Costa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211751' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Joaquim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Agronômica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'José Boiteux' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209151' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio do Campo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4214508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra da Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219358' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Brusque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ilhota' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4208302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Atalanta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chapadão do Lageado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204194' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vidal Ramos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Garcia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200903' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Boiteuxburgo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Antônio Carlos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Rio Vermelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205407' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Enseada de Brito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211900' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Águas Mornas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rancho Queimado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4214300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Imbituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207304' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Rio Pinheiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211702' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São Martinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Treze de Maio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Forquilhinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205456' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Correia Pinto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204558' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Hercílio Luz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Balneário Morro dos Conventos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201406' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Timbé do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Turvo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sete de Setembro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317202' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sírio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317905' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São José do Inhacorá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318499' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rodeio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Vista do Buricá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Progresso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302378' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Turvo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304002' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Derrubadas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306320' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Açoita Cavalo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307450' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Bela Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321907' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Estação Cocal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211207' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Arco Íris' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Coronel Finzito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307302' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307302' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Novo Xingu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313466' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314704' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Posse dos Linhares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315552' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Campinas do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Entre Rios do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306957' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Goio-Ên' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307203' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tanque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318606' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Caibaté' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Paulo das Missões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro do Butiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319372' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barrinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320206' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Colônia das Almas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305009' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Eugênio de Castro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307831' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Restinga Seca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317509' AND distrito.cod_ibge = '42';
 update public.distrito set nome = 'Santo Antônio das Missões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rincão dos Moraes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319158' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Chorão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310207' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cerro Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305157' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Teresinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313706' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Rincão Doce' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317756' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Charrua' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305371' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bela Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pulador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314100' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'São Roque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314100' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'São Domingos do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318051' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Linha Bonita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300554' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rincão dos Toledos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304101' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Varame' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304101' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Arroio Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vila Paz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321006' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Três Pinheiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308300' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Serafina Corrêa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barretos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304622' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316808' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Monte Alverne' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316808' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Canudos do Vale' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304614' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capitão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304697' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa Vermelha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campinas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311304' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'São Francisco de Paula' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rincão dos Kroeff' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318200' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'São Gonçalo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318622' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Flores' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311130' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santiago' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ernesto Alves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317400' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Monte Castelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313953' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Passo do Adão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315701' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Macega' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311791' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Fortaleza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312401' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Vendinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312401' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Campestre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316501' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Bento Gonçalves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Cristina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305108' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Garibaldi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guassupi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319406' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tamanduá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312054' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Taquari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinheiral' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303955' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Viradouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3556800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rita do Passa Quatro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3547502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz da Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3546256' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaraçaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3517802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pereira Barreto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3537404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Major Prado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548054' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jatobá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501103' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Torre de Pedra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554656' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Fim do Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Votorantim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3557006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Várzea Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3556503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ivailândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107504' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Bela Vista do Ivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107702' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Águas de Jurema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110805' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Içara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guaraci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaguapitã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Fé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alvorada do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeirão de São Joaquim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304128' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Barra do Piraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conservatória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3306107' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pentagna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3306107' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Governador Portela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Brejo Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3507753' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coroados' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3512506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gabriel Monteiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3516507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luiziânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3527702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Penápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3537305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Turiúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaiçara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3517208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3527108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itatiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3523404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tuiuti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554953' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vargem' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3556354' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campos do Jordão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monteiro Lobato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3531704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Pinhal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caçapava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Silvestre de Jacareí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3524402' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3546009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Eugênio de Melo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3549904' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Taubaté' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bananal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3504909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Silveiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3552007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bairro Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ourizona' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Petrópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaju' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3525300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3521804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lobo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3523503' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pirambóia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3502309' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Gavião Peixoto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3516853' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Lourenço do Turvo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Sebastião da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3507902' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ilhabela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3520400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pariquera-Açu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3536208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ana Dias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3523305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Correia de Freitas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101408' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101408' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Marilândia do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Itacolomi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117297' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sabáudia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Borrazópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ariranha do Ivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101853' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campestrinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3513900' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cotia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3513009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caucaia do Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3513009' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vargem Grande Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3556453' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jardim Santa Luzia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543303' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Rio Grande da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3544103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Butantã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Cambuci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '14';
 update public.distrito set nome = 'Ermelino Matarazzo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '28';
 update public.distrito set nome = 'Santa Bárbara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111506' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Manoel Ribas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monjolo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304904' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Campinas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaguariúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3524709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Mor' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3531803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra Negra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3551603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Junqueirópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3526001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Atlântida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3516002' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jardim Ângela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '43';
 update public.distrito set nome = 'Pinheiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '62';
 update public.distrito set nome = 'São Lucas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '72';
 update public.distrito set nome = 'São Miguel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '74';
 update public.distrito set nome = 'Triolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121901' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barra do Jacaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaboti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Turmalina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fátima Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guapiaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3517505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaraci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3517901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Palestina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pracinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3540853' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Euclides da Cunha Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515350' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mirante do Paranapanema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Costa Machado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530201' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pirapozinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3539202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Bernardes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campinal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541307' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Agissê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3542206' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Margarida Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515707' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Antônio Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515707' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nossa Senhora do Remédio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3545001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Praia Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Maria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100608' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Amaporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipanema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115002' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paranapoema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caetano Mendes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127502' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Papagaios Novos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117701' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Piriquitos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119905' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Novo Horizonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114609' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Jurupeba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535002' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Talhado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3549805' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Embaúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514957' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Floreal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monções' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3531001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Engenheiro Balduíno' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3531407' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Expedito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Planalto do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554300' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Universo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555000' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Alvinlândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Garça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3516705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Terezinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3527801' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Lácio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529005' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Rosália' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529005' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Assis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3504008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Borá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3507209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmital' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Rico' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Brasílio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121000' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Isabel do Ivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Caiuá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Adhemar de Barros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127304' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pérola' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paracuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aguaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306306' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Uruburetama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Soares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300903' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pentecoste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tejuçuoca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313351' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302800' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'Ipueiras dos Gomes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302800' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Bartolomeu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303303' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jucás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tarrafas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313252' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iborepi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307502' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Pajeú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301307' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Aratama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301604' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Carmelópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302701' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Farias Brito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nazaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512002' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Soledade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2516102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Matinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509339' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caiçara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Escada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'José Mariano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611804' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ilha de Itamaracá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Distrito Industrial' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600054' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jaboatão dos Guararapes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaboatão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607901' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santo Agostinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602902' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Piranhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2707107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Limoeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2706406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santana do Ipanema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2708006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacaré dos Homens' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2703403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Major Isidoro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2704401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Craíbas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2702355' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Feira Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2702603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa da Canoa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2704104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taquarana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2709103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jundiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2703908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Matriz de Camaragibe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2705101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Japaratinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2703601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra de São Miguel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2700607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paripueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2706448' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Luzia do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2707909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Alegre de Sergipe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2804201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora da Glória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2804508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Areia Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2800506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Domingos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2806800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amparo de São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2800100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana do São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2806404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2801306' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Laranjeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2803609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maruim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2804003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cristinápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2801702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cotegipe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mansidão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920452' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928208' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Félix do Coribe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929057' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra Dourada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juazeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Remanso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ramalho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910776' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Águas do Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923704' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tijuaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930105' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Lagoa Funda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903235' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Gameleira do Assuruá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Canudos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922052' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Gameleira do Jacaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929255' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Taquarandi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921401' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Dias Coelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921708' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Piritiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Jacuípe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929370' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'João Amaro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tapiraípe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2927200' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Feira de Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaguara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910800' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Bento Simões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914505' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Afligidos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Brígida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2927606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sítio do Quinto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930766' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908408' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Aroeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908408' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santaluz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pereira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928000' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Aramari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abadia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917904' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Sebastião do Passé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Belém da Cachoeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904902' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santiago do Iguape' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904902' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itaporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922300' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Nazaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Varzedo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933174' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caroba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906501' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Boquira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Oliveira dos Brejinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Triunfo do Sincora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902807' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itaeté' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2915007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Seabra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iramaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itagi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2915106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918803' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Miguel das Matas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Érico Cardoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2900504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paramirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Candiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tauape' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Parateca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920205' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Matina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921054' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Botuquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926400' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caraíbas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906899' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maetinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919959' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Malhada de Pedras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piripá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tanhaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Doce' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912301' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Manoel Vitorino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pradoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933307' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Encruzilhada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itambé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2915809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Colônia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2915809' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio do Meio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917102' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Macarani' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maiquinique' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Potiraguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Camamu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barcelos do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905800' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibiaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Presidente Tancredo Neves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925758' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932903' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Belmonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boca do Córrego' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903409' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Buerarema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coaraci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910909' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibicaraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aritaguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913606' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Coutos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913606' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Pimenteira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913606' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Itabuna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taboquinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914901' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Luzia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928059' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Faisqueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Serra Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932705' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2900801' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Juerana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mucuri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Trancoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925303' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Tapuia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905800' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Pedro do Passa Três' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109303' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ruralminas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170404' AND distrito.cod_ibge = '19';
 update public.distrito set nome = 'Paracatu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ponte Firme' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3153400' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Vila Bom Jesus de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116159' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São Sebastião dos Poções' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142700' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Travessão de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161106' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Jacu das Piranhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127339' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Rio Pardo de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salinas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibiaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Várzea da Palma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aristides Batista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118809' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'São Joaquim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118809' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Aparecida do Mundo Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143302' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Vila Nova de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143302' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Couto de Magalhães de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senador Modestino Gonçalves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tocoiós de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126505' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Posses' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138351' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Padre Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tuparecê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jacinto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catuji' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115458' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ladainha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Quente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3100906' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Bom Jesus da Vitória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157658' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Perdilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159803' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Olhos-d''Água' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145455' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Silvano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148103' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Gotardo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guarda dos Ferreiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162104' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pequi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Comendador Gomes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Rio Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127008' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Francisco de Sales' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Delta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121258' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Uberaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Japaraíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Martins Guimarães' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137205' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pedro Lessa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3167103' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Veríssimo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Perdizes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curimataí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Beltrão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119104' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Tomás Gonzaga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120904' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Felixlândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sucupira do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carolina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Balsas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cocal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaramiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mulungu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Antônio Diogo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311603' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Timbaúba dos Marinheiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303956' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Caponga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303501' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jacarecoara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303501' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ingazeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301703' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Palestina do Cariri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308104' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Arajara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301901' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Rosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304202' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Marrocos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307304' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Olinda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300101' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Penaforte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Massaranduba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pontina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506806' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Pedro Régis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512721' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pau D''Arco do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207793' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juazeiro do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205516' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Milton Brandão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206357' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoinha do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205540' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Gonçalo do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jurema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303709' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Caiçara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5207535' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208905' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Uvá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208905' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Amaralina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200829' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campinaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5204656' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Estrela do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5207501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Formoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tupiraçaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5214606' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Terezinha de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5219704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Paraíso de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Jorge' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200605' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Vila Borba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5205521' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São João d''Aliança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5220009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Teresina de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221080' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaraíta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5209291' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Castrinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5218607' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rubiataba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5218904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Luíz do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5220157' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Goialândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5201108' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Inhumas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5210000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Veneza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5215009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Córrego do Ouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5205703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fazenda Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5207600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iporá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5210208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Brasil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5215207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abadia de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200050' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Brasília' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5201405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Aragoiânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5201801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Hidrolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5209705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buritinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5203962' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208004' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jataí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5211909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Montividiu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213756' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palminópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5215900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Limpa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aloândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morrinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Orizona' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5215306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anhanguera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5201207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gouvelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5209150' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sales' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3544806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Urupês' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3556008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Restinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3542701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3531308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pirangi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3539004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salto Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3545407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Clarínia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3546405' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ribeirão Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554201' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bom Sucesso de Itararé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3507159' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Areia Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522406' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Itararé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3523206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boituva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3507001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fazenda Velha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3511607' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Umuarama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Indianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Altamira do Paraná' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100459' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juranda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112959' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Geremia Lunardelli' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116802' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Terra Roxa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Toledo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127700' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Cafelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103453' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Diamante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104808' AND distrito.cod_ibge = '55';
 update public.distrito set nome = 'Borman' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109302' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Aurora do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125704' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Salvador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101002' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Roque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121406' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'União do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123808' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Flor da Serra do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107850' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Secção Jacaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108403' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Marmeleiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sede Nova Sant''Ana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125209' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Presidente Kennedy' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128609' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Coronel Vivida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pato Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Saudade do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126272' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Laranjal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113254' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123857' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Goioxim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108650' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Inácio Martins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinhalzinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119301' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Campo do Bugre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122156' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Virmond' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128658' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Honório Serpa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109658' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guamirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110706' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Dorizon' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Domingos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128203' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guajuvira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101804' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Três Córregos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104204' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Rio Branco do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marcelino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125506' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cachoeira de Cima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101200' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Rio Negro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4208401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Entre Rios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109401' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Mariflor' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216701' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caibi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gôio-En' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204202' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Coronel Freitas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iraceminha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207759' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maravilha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Lourenço do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Frederico Wastner' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216909' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lajeado Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209458' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passos Maia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212270' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Domingos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Herciliópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200408' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Catanduvas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Lúcia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211801' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Salto Veloso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217907' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Campo da Água Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203808' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Mafra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Negrinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Balneário Barra do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202057' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pirabeiraba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Brunópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202875' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dal''Pai' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203600' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ibicuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203600' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Marombas Bossardi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204806' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Canoão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913101' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cisterna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930808' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Capim Grosso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906873' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Junco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917508' AND distrito.cod_ibge = '26';
 update public.distrito set nome = 'Tamboril' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921708' AND distrito.cod_ibge = '24';
 update public.distrito set nome = 'Ibiquera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Conceição do Jacuípe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Malhador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914000' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Pintadas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924652' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Candeal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mata da Aliança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901106' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Muritiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abrantes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905701' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mar Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933208' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Mocambo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913002' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Jequié' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Planaltino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio do Pires' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paiol' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917409' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pitarana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142700' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Barrinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139250' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Riacho dos Machados' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vargem Grande do Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108602' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Juramento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olímpio Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162401' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Vale das Cancelas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127800' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São Gonçalo do Rio Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mendonça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171071' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Novilhona' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145307' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Água Branca de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117009' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Joaíma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fidelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Poté' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Centralina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salitre de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148103' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paraopeba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campina Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3111101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poncianos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cachoeira da Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra Azul de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3166501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campos Altos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3111507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Buriti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125705' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Porto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2208502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caraúbas do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202539' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baturité' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Colina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309805' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lagoa do Barro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301950' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Novo Horizonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309458' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Missão Velha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abaiara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rosário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ingá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Feira Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513109' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Marcação' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509057' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tauapiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613909' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Ibimirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Henrique Dias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614105' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Coronel José Dias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202851' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Avelino Lopes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Belém do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201572' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boqueirão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302404' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Cacimba Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307635' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tangará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2414001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Terra Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curral Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Serra do Vento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601706' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Paes Landim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira de Fora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301505' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Marrecas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313302' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Viana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2502409' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503308' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jundiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608008' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Pinhões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611705' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612505' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Toritama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Almofala' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306553' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Antônio da Pindoba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ubaúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304004' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Catolé da Pista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310902' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Santa Tereza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301109' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Uiraúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2516904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipueiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2510907' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'São José do Bonfim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2514602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Olinda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2510204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Conselho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Camocim de São Félix' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2603504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308203' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Irauçuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312809' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304277' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Morro do Coco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301009' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Jamapará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305406' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Soledade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305703' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São Francisco Xavier do Guandu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200102' AND distrito.cod_ibge = '37';
 update public.distrito set nome = 'Santa Leopoldina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Velha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sagrada Família' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200300' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Rive' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200201' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Alto Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203700' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Limoeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201407' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'São José de Fruteiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205036' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Retiro do Muriaé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302205' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Jaguarembé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302106' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Alto Caparaó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102050' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Mantimento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3163607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Viçosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Viletes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122009' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Guarani' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bias Fortes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rosário de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136702' AND distrito.cod_ibge = '60';
 update public.distrito set nome = 'Santa Rita de Jacutinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itamarati de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3132602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pirapetinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Picadinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003702' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Ponta Porã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juruena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105176' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ouro Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106216' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Terezinha do Rio Ferro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106240' AND distrito.cod_ibge = '26';
 update public.distrito set nome = 'Vera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo São Joaquim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106281' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Figueirópolis D''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cristinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107750' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pinhal Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313201' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Inocência' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Varginha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Espírito Santo do Dourado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lambari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pintos Negreiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139904' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Luminárias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Costas da Mantiqueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105608' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Vermelho Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154002' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Antônio dos Santos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110004' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lagoinha de Fora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137601' AND distrito.cod_ibge = '14';
 update public.distrito set nome = 'Fidalgo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149309' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São José da Lapa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162955' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Bárbara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Crucilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lobo Leite' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118007' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sapucaia de Guanhães' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128006' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Engenheiro Caldas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião do Barroso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135076' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mathias Lobato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cava Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140308' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pingo-d''Água' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150539' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ubaporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170057' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Penha do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118403' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Roseiral' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144003' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Sebastião do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Oliveira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cássia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pratápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guardinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164704' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guaipava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Aurora do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1702703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morro de São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718907' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barreirinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Telêmaco Borba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caratuva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101606' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Socavão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104907' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Porto Mendes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114609' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Uchoa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catanduva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3511102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Miraluz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532504' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Varpa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555000' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Oscar Bressane' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3534500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Florínia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3516101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Planaltina do Paraná' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ivaté' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111555' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraipaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310258' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Matias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310704' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Campos Belos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303006' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Calabaça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2314003' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João do Cariri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2514008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa de Dentro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2508208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sertãozinho de Baixo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609204' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cocaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611903' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Fernando de Noronha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605459' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palestina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2706208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Belém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2700805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2708808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coqueiro Seco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2702207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Feira Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2802205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Neópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2804409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carmópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2801504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jupaguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Junco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918407' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Xique-Xique' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Laje dos Negros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906006' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Queimada Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918506' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Souto Soares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lajedo Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911907' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Humildes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910800' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cavunge' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913804' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cupissura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503001' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barra de São Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Landri Sales' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309300' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Carvalho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313203' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Firmamento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2406700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Acari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2400109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riacho do Meio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613602' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Dirceu Arcoverde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203354' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caldeirão Grande do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202091' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caiçarinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303931' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cipó dos Anjos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311306' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Manituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311405' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Barcelona' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2401503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Trairi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2414001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Monte Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2407807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rajada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611101' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Floresta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Grotão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2616001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Curral Novo do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203271' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Simplício Mendes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guriú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302602' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Uruquê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311405' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Barra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300408' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Saboeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Trussu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300309' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'São Gonçalo do Amarante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2412005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Natal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2408102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Brejo do Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2514651' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carrapateira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cimbres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610905' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Bento do Una' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Feira Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibiapina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paracuá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313906' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Córrego dos Fernandes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301109' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Mirambé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303709' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Fortaleza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304954' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'Itacima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304954' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Penedo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '33';
 update public.distrito set nome = 'Sapupara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Caraúbas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2402303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Messias Targino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2407609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2408706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Triunfo Potiguar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2414456' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Major Sales' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2407252' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riacho de Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2410801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Major Felipe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2406007' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pilões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2410009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riacho da Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2410702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Severiano Melo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2413607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taboleiro Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2413805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mata de São Braz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2414100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Rita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caaporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nascente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601102' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bodocó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caririmirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Veneza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610400' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Conceição das Crioulas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612208' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Serrita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ori' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614006' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Brejinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Calumbi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2603405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605608' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Irajaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606903' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barra D''Alcântara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201176' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Oriente do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Félix do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Valença do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2211308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Uruçuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2211209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Flores do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Floriano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Grande do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Currais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203230' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Luz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canto do Buriti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aningas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305233' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Pascoal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309607' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Assis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304103' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Realejo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304103' AND distrito.cod_ibge = '33';
 update public.distrito set nome = 'Lucrécia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2406908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serrinha dos Pintos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2413557' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fernando Pedroza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2403756' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jardim de Angicos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2405504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Teresa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2411403' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Vicente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2413003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Triunfo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Caetano do Navio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601805' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Maravilha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605103' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caatinga Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605152' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Várzea Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2211357' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cajazeiras do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202075' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paquetá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207553' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tanque do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210979' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alegrete do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2200277' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Alegre do Fidalgo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202117' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Banabuiú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301851' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Águas Belas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302404' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Guia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302404' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Rita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303931' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Custódio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311306' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Bento Fernandes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2401602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poço Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2410108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coronel Ezequiel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2402808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senador Elói de Souza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2413102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Várzea' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2414704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capoeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2603801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Grande do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202133' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaicós' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Padre Marcos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aranaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Araras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302057' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Miranda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310308' AND distrito.cod_ibge = '14';
 update public.distrito set nome = 'Felipe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311900' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Barra Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Inhamuns' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313302' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Monte grave' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308351' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cipó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308500' AND distrito.cod_ibge = '26';
 update public.distrito set nome = 'Belém do Brejo do Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2502003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catolé do Rocha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poço Dantas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512036' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mimoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610905' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tacaimbó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poço Fundo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612505' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vista Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304236' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Alto Lindo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305308' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Pedra Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José de Solonópole' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313005' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Fortim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304459' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Fé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300705' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Saquinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307007' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Condado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itajubatiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504207' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santana dos Garrotes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibiara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506608' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lagoa de São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602100' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Olho d''Água de Dentro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2603702' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606002' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jurema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra do Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600302' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Laje de São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605004' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Massapê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mutambeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312007' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ingazeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305803' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Recanto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305803' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Lagoinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311504' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Feiticeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306900' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Potiretama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311231' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagedo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303808' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Iguatu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Picuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2511400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Seridó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2515401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Assunção' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501351' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taperoá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2516508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra de São Miguel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caraúbas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504074' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo André' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513851' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Lázaro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610202' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Barra do Riachão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Aliança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Condado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ponta de Pedras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itambé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607653' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaquitinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa de Itaenga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Murupé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2616308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Dois Leões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611309' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nossa Senhora do Carmo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611309' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Belém de Maria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305902' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Pires Ferreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310951' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amanaiara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311702' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Video' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303659' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Hidrolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipu Mazagão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306405' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Deserto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306405' AND distrito.cod_ibge = '47';
 update public.distrito set nome = 'Mundaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vargem Alta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205036' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cambuci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luisburgo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138674' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Margarida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Melo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3155207' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Antônio Prado de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Queirozes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124906' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Francisco do Glória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Celeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161502' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160702' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Laranjal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora de Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003702' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Angélica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5000856' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Brasilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campinápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Olímpia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106232' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sonho Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105622' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Presidente Lucena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315149' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sapiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morro Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311775' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tapera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321352' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bandeirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303509' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Tapuraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310603' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Barragem do Itú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311759' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Forninho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302808' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Arroio do Padre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301073' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Hidráulica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304663' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rincão da Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314407' AND distrito.cod_ibge = '42';
 update public.distrito set nome = 'Santa Vitória do Palmar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guapé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Três Pontas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ouro Fino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Desterro de Entre Rios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição da Brejaúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127503' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Brejo de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3158201' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Frei Inocêncio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Frei Serafim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3132701' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Belém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144672' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião do Baixio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149952' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Iapu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conselheiro Pena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taparuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168051' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cláudio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapecerica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capetinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3112406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Resende' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Silvanópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1720655' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1711951' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taguatinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1720903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paço do Lumiar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2107506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2101004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cidelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103257' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fernando Falcão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2104081' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Doce do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100154' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Codó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Matões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Carlos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100205' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Santa Cruz da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100114' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Novo Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100098' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Marco Rondon' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100189' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cruzeiro do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Felipe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303809' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Carauari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Beruri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300631' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maués' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1302900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Mauá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315057' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tucunduva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Esperança do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307450' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Braço Forte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321402' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Padre Gonzales' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321907' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Erval Seco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pio X' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300901' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Erval Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coronel Teixeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João da Urtiga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318424' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Figueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314555' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Capela São Paulo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318903' AND distrito.cod_ibge = '14';
 update public.distrito set nome = 'Coronel Bicaco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carazinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Leonel Rocha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316428' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Caseiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304952' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sagrisa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314779' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Terezinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317558' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Campina Redonda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307500' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santo Antônio do Bom Retiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310009' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Salto do Jacuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316451' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José da Glória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323200' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Soledade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapuca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300703' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pulador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322350' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Capão Bonito do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304622' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312153' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Coqueiro Baixo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305835' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Ituim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312617' AND distrito.cod_ibge = '55';
 update public.distrito set nome = 'Antônio Prado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Izidro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311106' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Alto Feliz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300570' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Faria Lemos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302105' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Flores da Cunha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lídice' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304409' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Angra dos Reis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vassouras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3306206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guapiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3527108' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Avaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3504305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Corredeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ubirajara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bragança Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3507605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinheiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3526605' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Bilac' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107801' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bazílio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304300' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Seropédica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305554' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itambi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301900' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cambaquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3520400' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Oliveira Barros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529906' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Vila Dirce' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510609' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Água Boa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117503' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103701' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Maricá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mococa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capivari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cipó-Guaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515103' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Anhanguera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '03';
 update public.distrito set nome = 'Grajaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Abatiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rita d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3547403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Veneza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3552403' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Iguatemi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '33';
 update public.distrito set nome = 'Lapa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '48';
 update public.distrito set nome = 'Pirituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '63';
 update public.distrito set nome = 'Cachoeira do Espírito Santo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121802' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carlópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fernandópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ouroeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3534757' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3524501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Prudente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '93';
 update public.distrito set nome = 'Maristela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100608' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Dom Aquino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bandeirantes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5214838' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lucilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213707' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Roma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5214903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taquaral de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Avelinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5202809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alvorada do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Gama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5215231' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmeiras de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5215702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Goiatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5209101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piracanjuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5217104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5222005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barretos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3505500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3517703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Azul Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3531506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taiúva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Timburi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Campina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532827' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Roberto Silveira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128104' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São Lourenço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105508' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ourilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102505' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sede Alvorada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104808' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Ibema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109757' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Planalto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacutinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123808' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Pio X' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108403' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Vista Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ouro Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124806' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Guairacá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109401' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Pinhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaraúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127007' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Luiz do Purunã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102307' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Antonina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bandeirante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202081' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Formosa do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205431' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Paulo de Olivença' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Urucurituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1304401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1400100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rorainópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1400472' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santarém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ponta de Pedras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bengui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501402' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Marudá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Primavera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro de Viseu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504604' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pinhel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501006' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Medicilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504455' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piçarra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505635' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Calçoene' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mazagão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmeiras do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1713809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caseara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1703909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marianópolis do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1712504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sandolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718840' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bauxi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107701' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Poconé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5100300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Faina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5207535' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapirapuã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5211008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Montes Claros de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Montividiu do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213772' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pau Terra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221601' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Itaguari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5210562' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piloândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5210307' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Flores de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5207907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luziânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mineiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cromínia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5206503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Urutaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quirinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5218508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caitá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125605' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Porto Amazonas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alexandra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Dionísio Cerqueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mondaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cunhataí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204756' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel da Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217154' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Diadema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219705' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Treze Tílias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piratuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Moema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4208104' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Corupá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guarani' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203600' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Taió' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cedro Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4214706' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio Antinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ingleses do Rio Vermelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205407' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santa Rosa de Lima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Siderópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedro Gárcia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302600' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315404' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Gramado dos Loureiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309126' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruzaltense' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306130' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Toldo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308904' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Pinhalzinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311908' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Severiano de Almeida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mato Queimado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312179' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Buriti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317509' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rincão dos Meotti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317509' AND distrito.cod_ibge = '46';
 update public.distrito set nome = 'Santo Isidro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319208' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Barreiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310207' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Barra Funda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301958' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Rica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305306' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Sarandi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cerro Claro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319406' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Palma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Constantino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315156' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Ferreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303004' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Rialto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300407' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Altinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Apiaí-Mirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510203' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Rio Turvo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553500' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Figueira do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107504' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Itaguajé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mandaguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Castelo Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Volta Redonda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3306305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sabino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3544608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Duartina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morungaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lorena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3527207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Natividade da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Luiz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114807' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itaguaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pederneiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3536703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iaras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519253' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pratânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541059' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dobrada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catuçaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jordanésia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509205' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Floriano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mauá da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115754' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora da Aparecida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122404' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lagoa Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510807' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vargem Grande do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3556404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cordeirópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3512407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mombuca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rafard' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3542107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeirão Pires' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Branco do Ivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122172' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pilõezinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2511707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaqueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607950' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aripibu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611804' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Curado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607901' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Olinda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipojuca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carneiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2701803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Batalha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2700706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arapiraca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2700300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Luís do Quitunde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2708501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2801405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cumbe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2801900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagarto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2803500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Cristóvão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2806701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Massaroca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918407' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Américo Alves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930204' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Gameleira da Lapa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930758' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Várzea Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924603' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Raimundo Martins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312205' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Marinheiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306405' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'São José de Mantenópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203304' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Fartura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204708' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Colatina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aracruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Timbuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202207' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Comendador Levy Gasparian' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300951' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monnerat' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301603' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Farias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203205' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Itaimbé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202702' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Goiabeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205309' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Miguel do Caparaó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202306' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Dona América' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203403' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Prosperidade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205036' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Raposo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302205' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Laranjais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302106' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Durandé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123528' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lajinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amparo do Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedra do Anta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dores da Vitória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142205' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vieiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piraúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chácara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mantiqueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160702' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Sereno' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115300' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Providência' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138401' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bataguassu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5001904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Formosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003702' AND distrito.cod_ibge = '48';
 update public.distrito set nome = 'Cabeceira do Apa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006606' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Amandina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Juína' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105150' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alta Floresta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5100250' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Noroagro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103304' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Porto dos Gaúchos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Candiota' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304358' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passo das Pedras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304663' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cerrito Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314407' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santa Izabel do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301305' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Taunay' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5001102' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São José do Sucuriú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004403' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ipuiúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jesuânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jardim de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itumirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Desterro do Melo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pouso Alegre da Mata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135506' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'São Sebastião do Soberbo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Parque Industrial' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118601' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Boa Vista da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136652' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cocais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105400' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barra Feliz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157203' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vargem Linda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161007' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Santo Antônio da Vargem Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108107' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Passagem de Mariana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140001' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Santana dos Montes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Peçanha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Central de Santa Helena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122108' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Marilac' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3140100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição das Laranjeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161650' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santo Antônio de Nova Belém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144672' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Quartel do Sacramento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107802' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ipaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131158' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quatituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134103' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pocrane' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Alegre de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154309' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Arcos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel do Guaporé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100320' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rolim de Moura do Guaporé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100015' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Santa Rosa do Purus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200435' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Içá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itamarati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301951' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pacaraima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1400456' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alenquer' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arumanduba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500503' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Melgaço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Oriente de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145356' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mucuri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168606' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Umburatiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipiaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abadia dos Dourados' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3100104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Romaria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa Formosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abaeté dos Venâncios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162104' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Tabuleiro do Mato Dentro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117504' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Fátima do Pontal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114550' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Capim Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3112505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carioca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147105' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cedro do Abaeté' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luzilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedra Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301208' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Bandeirantes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5001508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraíso das Águas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006275' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo do Meio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3111309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caldas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião dos Robertos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134905' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159209' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Monte Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3110509' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Olímpio Noronha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passa-Vinte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Madre de Deus de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião dos Torres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105608' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Acaiaca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3100401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brumadinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedro Leopoldo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Luzia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catas Altas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115359' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Acuruí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131901' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Rita de Ouro Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146107' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Palmeira de Resplendor' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3100609' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Senhora da Penha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125804' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itambacuri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3132701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Félix de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161056' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Belo Oriente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Timóteo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus do Rio Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130903' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'São Vicente do Rio Doce' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168408' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São José do Itueto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carmo do Cajuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Córrego Fundo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119955' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Sucesso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibiraci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3129707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cabo Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Riachuelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100254' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Terra Boa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100346' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Rodrigues Alves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200427' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Japurá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1302108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Careiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Massauari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300680' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Floriano Peixoto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300706' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Prainha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Francisco da Jararaca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504901' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Raimundo de Borralhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507003' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Augusto Corrêa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Timboteua' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505007' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Moju' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Repartimento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505064' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Raimundo do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501758' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cachaço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600055' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carrasco Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1703891' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aragominas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1701309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chapada de Areia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1704600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aldeia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5100102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Engenho Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107800' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Campo Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102678' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tesouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro da Cipa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Matrinchã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212956' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jardim de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5203401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Alegre de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ceres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5205406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Interlândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5201108' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ivolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5211602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Goiânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Divinópolis de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cristalina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5206206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Portelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5218102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gonçalves Júnior' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110706' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'União da Vitória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araucária' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Borda do Campo de São Sebastião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125506' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Machado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212908' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Quilombo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4214201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipuaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207684' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibicaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Helena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209003' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santo Antonio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204301' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Paula Pereira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203808' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Campo Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capão Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203253' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Teresinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218905' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Salete' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio das Antas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4214409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Imbuia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4207403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Trento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Bonifácio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brusque do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211702' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São Bento Baixo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211603' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Colônia Medeiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pranchada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306734' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Porto Soberbo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321477' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Vista Gaúcha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307302' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Rio dos Índios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315552' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Três Barras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300901' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Centenário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305116' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ponte Preta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314787' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jardim Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318606' AND distrito.cod_ibge = '14';
 update public.distrito set nome = 'Esquina Bom Sucesso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305009' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Cândido Freire' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Colônia Municipal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317509' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Nicolau' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo de Sobradinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314068' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sinimbu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320677' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coxilha Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322509' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Espinilho Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322202' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Dilermando de Aguiar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306379' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bexiga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315701' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Portão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tuiutí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302105' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Loreto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319802' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Luiz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307815' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Westfalia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323770' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Silva Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iguaba Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301876' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cravinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3513108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mirandópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bento de Abreu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3506201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra do Chapéu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3505351' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3545209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Atalaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Inês' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Real' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304110' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passa Três' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304409' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Abraão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Júlio Mesquita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3525805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Alves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruzeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3513405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibiaci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120507' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Miguel do Cambuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114807' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Campos Elyseos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301702' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bofete' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3506904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Américo Brasiliense' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Vermelha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548906' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cajati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509254' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mongaguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3531100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sarandi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126256' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Altamira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107603' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Granada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coronel Goulart' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501301' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ferraz de Vasconcelos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guarujá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3518701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto do Amparo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127502' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Reianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Encantado d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102000' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Monte Verde Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509304' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Auriflama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3504206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gália' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3516606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruzália' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3513306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quatá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jangada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103479' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nilza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110607' AND distrito.cod_ibge = '14';
 update public.distrito set nome = 'Pecém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312403' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Pedro do Gavião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313559' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Caxitoré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313351' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bandeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306603' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Pedro do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307403' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Feitosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cacimba de Dentro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pilões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2511608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gameleira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Moreno' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poço das Trincheiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2707206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caldeirões de Cima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2706307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'União dos Palmares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2709301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Junqueiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2704005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa Funda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2802403' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pedra Mole' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2805000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmares' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2805802' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Miranda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2801306' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São José do Rio Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926202' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barro Vermelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909901' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Piçarrão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930204' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Rodelas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2927101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ouricuri do Ouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Contendas do Sincorá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Florestal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918001' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Tartaruga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Itaípe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924900' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Espraiado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923407' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ubiraçaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904605' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Barra do Choça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itarantim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itamotinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908002' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Colônia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932507' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Taquarinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922003' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104502' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Natalândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144375' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Gonçalo do Abaeté' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Machado Mineiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101003' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Ninheira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144656' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brasília de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João da Vereda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143302' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Itacambira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3132008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Kubitschek' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3153301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rita do Araçuaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116100' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Itaobim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3133303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Estrela de Jordânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136504' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pedro Versiani' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168606' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Chaveslândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159803' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jardinésia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152808' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Douradoquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3123502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Cruzeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117504' AND distrito.cod_ibge = '32';
 update public.distrito set nome = 'Planura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3151602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baldim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Almeida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134608' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barreiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106200' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Exu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Moreilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel da Baixa Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210383' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cristino Castro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Gonçalo do Gurguéia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209757' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Horizonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305233' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jandrangoeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305605' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Sacramento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305654' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Viçosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2414902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olho-d''Água do Borges' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2408409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Sabugi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2412104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bernardo Vieira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613909' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Arizona' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600203' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cristalândia do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alagoinha do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2200251' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cajazeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307635' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2401701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maxaranguape' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2407500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itacuruba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro do Cordeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610806' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caruaru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2604106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa do Barro do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205565' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vera Mendes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2211506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amarelas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302602' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Oiticica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310308' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Milhã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308351' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gameleira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2413904' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Brejo do Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2502805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Bento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poção' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Surubim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Umari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602209' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Sítio Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308906' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Betânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305308' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Arapá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mucurici' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra Seca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203056' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Francisco de Itabapoana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304755' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição de Macabu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Quartel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203205' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Paraju' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201902' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Garrafão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204559' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guarapari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anutiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200201' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Tiago' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202306' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Bonsucesso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200508' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Rosal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300605' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Professor Sperber' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Alto Rio Doce' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alvorada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Fervedouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125952' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Astolfo Dutra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Goianá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127388' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José dos Lopes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138609' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Conceição do Formoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160702' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cataguases' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3115300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapiruçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146701' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ilha Comprida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5008305' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5005004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fátima do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Deodápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003454' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cotriguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103379' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Colíder' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marechal Rondon' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102637' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Piratininga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106240' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Canarana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Lacerda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106182' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Petrópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fazenda Fialho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321204' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Cerro do Roque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302709' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Porto Batista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322004' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Nova Esperança do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313037' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Linha Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311643' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carlos Barbosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Farroupilha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316907' AND distrito.cod_ibge = '38';
 update public.distrito set nome = 'Vila Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313102' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Progresso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301206' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Campo Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315156' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vespasiano Correa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322855' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Floriano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300407' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pradópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3540903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra Azul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3551405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bandeirantes D''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3552304' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibiúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tapiraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Atibaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3504107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luiziana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113734' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Zélia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102109' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São João Marcos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304409' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Vargem Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300308' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Mendes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Braúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3507704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Simões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508801' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bauru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3506003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pirajuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parque Meia Lua' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3524402' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Marialva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaboraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anhembi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3502309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova América' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522703' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rincão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dourado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Franco da Rocha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3516408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaravera' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio Bom' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Torrinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Judas Tadeu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124301' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Conselheiro Zacarias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124103' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Pinhalão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tomazina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedranópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3536901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parisi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3536257' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ingás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533007' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Martinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rancharia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3542206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bertioga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3506359' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Londrina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Uvaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119905' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Engenheiro Schmidt' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3549805' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ida Iolanda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532603' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Iacri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Echaporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Alexandria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510005' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Mônica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123956' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Herculândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111555' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310258' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pitombeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306306' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Sebastião de Abreu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310704' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Sebastião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303303' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Lavras da Mangabeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Domingos do Cariri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513943' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Muquém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501104' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Sertãozinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2515930' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quipapá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jardim Jordão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607901' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Cacimbinhas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2701209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pindoba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2707008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Flexeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2702801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marechal Deodoro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2704708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poço Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2805505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pirambu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2805307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Luzia do Itanhy' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2806305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piripiri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2208403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jenipapeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301208' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Beberibe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cuncas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302008' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Miguel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308104' AND distrito.cod_ibge = '29';
 update public.distrito set nome = 'Baixio das Palmeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304202' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Carnaúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307205' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Campo Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506905' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Natuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juripiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2507903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riachão do Poço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512762' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monsenhor Gil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedro II' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2207900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catuana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303709' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itapebussu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Apodi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2401008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Condeixa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Outeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501402' AND distrito.cod_ibge = '67';
 update public.distrito set nome = 'Santo Antônio do Tauá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carapajó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502103' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Igarapé-Miri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1503309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caju' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507607' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Breu Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501782' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ourilândia do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505437' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506583' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Amapá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedra Branca do Amapari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600154' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luzinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1712454' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bandeirantes do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1703057' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio da Casca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103007' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Porto Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108402' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Primavera do Leste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107040' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Catanduva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107297' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Canadá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ponte Alta do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213707' AND distrito.cod_ibge = '26';
 update public.distrito set nome = 'Nova América' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5214705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5201603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anicuns' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5201306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barbosa Ferraz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José das Palmeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125456' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cascavel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Aurora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taquaritinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Valério' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119806' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Dois Vizinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Renascença' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Jorge d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio do Tigre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123857' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Covó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bateias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mandirituba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ararapira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São José do Cedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Iratim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102901' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cambuinzal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219507' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Irakitan' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217907' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Lindóia do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209854' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinheiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203808' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Jaraguá do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4208906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Urubici' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Laurentino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Botuverá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Navegantes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Major Gercino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213609' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Gravatal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedras Grandes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sapiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210803' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cinquentenário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322301' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sítio Gabriel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Seberi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Erebango' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306973' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibicuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeirão do Largo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926657' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aurelino Leal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2902401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Japomirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2915205' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ubatã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itabatã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922003' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Prado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cercado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170479' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Brás de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137106' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Levinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135209' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Itamirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Porteirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145059' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caçarema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3112703' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lontra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138658' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Roberto de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162252' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São João do Pacuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162658' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Datas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Angelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102852' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Glaucilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127354' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ataléia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'França' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924801' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Água Fria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2900405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Oleiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901700' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Ipirá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Gonçalo dos Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tucano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Antas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serrinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Inhambupe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palame' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910602' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jacuípe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929503' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Muniz Ferreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Candeias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Simões Filho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipuçaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923209' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Itachama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901007' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Itaquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Engenheiro Pontes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918803' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Timóteo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919504' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Rio do Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Geraldo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118809' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Ponto Chique' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152131' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Veredinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171071' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rubim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Concórdia do Mucuri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3137007' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Araguari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3103504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Alegre de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guimarânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rosa da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canastrão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168903' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'União de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170438' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Joaquim Felício' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caetanópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Doutor Campolina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135704' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itaipu de Araxá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104007' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sacramento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Silva Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152006' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Joaquim Pires' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cocal dos Alves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202729' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guassi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311603' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Itapeim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302206' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caponguinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310852' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Padre Cícero' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307304' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Inhumas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312106' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Cuité de Mamanguape' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2505238' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amarante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2200509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jardim do Mulato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205250' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Antônio Bezerra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304400' AND distrito.cod_ibge = '60';
 update public.distrito set nome = 'Tibau' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2411056' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2404903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lucena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2508604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jardim do Araripe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601102' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Tupanaci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Araguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1702000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chapada dos Guimarães' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araguainha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaciara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5104807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Lourenço de Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105200' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Mara Rosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aparecida de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5210901' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Uruceres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221700' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Heitoraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5209606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5204201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aparecida de Goiânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5201405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Águas Lindas de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5200258' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Descoberto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5219753' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maurilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serranópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5220504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Varjão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gameleira de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5208152' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Davinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5206909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nuporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeirão Corrente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Batista Botelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533809' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Buri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3508009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Laras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3526407' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Marabá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127908' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Rio Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112959' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bourbonia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102505' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Rio do Salto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104808' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Foz do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barracão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salto do Lontra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iolópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125209' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barra Bonita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119608' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bananas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117057' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Coronel Firmino Martins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105706' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Gaspar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Florianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ratones' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205407' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Anitápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Azambuja' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212403' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Araranguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Praia Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307450' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Sítio Cassemiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315404' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Vista Gaúcha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipuaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303400' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Frederico Westphalen' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Saltinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310702' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Três Arroios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321634' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Souza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318606' AND distrito.cod_ibge = '32';
 update public.distrito set nome = 'Atafona' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317509' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Rincão dos Pintos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318903' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Ajuricaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317806' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Rio Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305850' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Pedro das Missões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319364' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sede Independência' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314100' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Ponte Queimada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302220' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Rincão do Ivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316451' AND distrito.cod_ibge = '24';
 update public.distrito set nome = 'André da Rocha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300661' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309407' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Xarqueada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315206' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Segredo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320263' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boqueirão do Leão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302451' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Clemente Argolo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311304' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Estrela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322509' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Quevedos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315321' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310538' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Francesa Baixa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301651' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Cruzeiro do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mundaú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313807' AND distrito.cod_ibge = '11';
 update public.distrito set nome = 'Salitre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302800' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Poço Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307403' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Ipaumirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Miragem' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303204' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Remígio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mulungu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araçoiaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601052' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abreu e Lima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600054' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juçaral' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602902' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Delmiro Gouveia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2702405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2709400' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Efigênia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2701704' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Canindé de São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2801207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Muribeca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2804300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora do Socorro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2804805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luís Eduardo Magalhães' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919553' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tabocas do Brejo Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sobrado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907202' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Carnaíba do Sertão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918407' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Glória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quixaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921609' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pilar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917706' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Belo Campo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901155' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Canarana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Feira Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913101' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Itapura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921203' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mairi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedrão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Euclides da Cunha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nordestina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922656' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cipó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição de Campinas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923803' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Salgadália' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908408' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Igrapiúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913457' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Valença' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Algodão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912905' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jussari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918555' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Uruçuca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Formoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olhos d''Água do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136306' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Pandeiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135209' AND distrito.cod_ibge = '33';
 update public.distrito set nome = 'Morro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161106' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Janaúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra de Alegria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130655' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Angicos de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108602' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ermidinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cristália' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Terra Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107307' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Francisco Badaró' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra do Salinas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119500' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Crispim Jacques' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168606' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Serra dos Aimorés' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3166709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Indianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Carmelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pindaíbas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148004' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Papagaios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senhora do Socorro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117504' AND distrito.cod_ibge = '36';
 update public.distrito set nome = 'Rodeador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3142502' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Vicente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105004' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pará de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Desemboque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3156908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Três Marias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169356' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Franco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Murici dos Portelas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206696' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Milton Belo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301208' AND distrito.cod_ibge = '21';
 update public.distrito set nome = 'Campestre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303956' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Granjeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brejinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302008' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'São Félix' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308104' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Espacinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309300' AND distrito.cod_ibge = '19';
 update public.distrito set nome = 'Rosário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2405900' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ipueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2404804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Equador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2403400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Terezinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Logradouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613909' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Lagoas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605152' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Picos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2208007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Julião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poço da Pedra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302404' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Quixadá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lajes Pintadas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2406809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa Salgada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2406601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2411502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riacho Pequeno' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601607' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Poço do Boi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610806' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Xucuru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601706' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Massapê do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206050' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Camocim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311405' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Barra do Ingá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300309' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Velame' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304269' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Cajazeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Couro d''Antas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611705' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Frei Miguelinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Carvoeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306553' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guaraciaba do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Prefeita Suely Pinheiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313005' AND distrito.cod_ibge = '32';
 update public.distrito set nome = 'Batoque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300705' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Triunfo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2516805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catingueira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Ventura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2502102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Limoeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lajedo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Agrestina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto do Mangue' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2410256' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'José da Penha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2406007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Filomena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612554' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aroazes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2200905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jerumenha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2205300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bonfim do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201929' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibiapaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304103' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barreiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308609' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Açudinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313203' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Guamaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2404507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2406502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra Talhada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2613909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Betânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Orebe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605152' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Braz do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209559' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bocaina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2201804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monsenhor Hipólito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jandaíra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2405108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa de Velhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2406403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aroeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304004' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Gonçalo do Umari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308500' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Tróia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310506' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Barreira dos Vianas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301109' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Canindezinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305332' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sousa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2516201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2515708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chã do Rocha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609709' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jupi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arariús' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303105' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Missi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306108' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ipaguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308005' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'João Cordeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312007' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sobral' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Água' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308708' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Russas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311801' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Icó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Imaculada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Várzea' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2517100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pindurão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2503902' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Macujê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600708' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pombos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Izidro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310951' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Garças' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300754' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Arapari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306405' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Volta Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3172103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaperuna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200904' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Moacir Ávidos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202256' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pinheiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaguaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203056' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Amaro de Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301009' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Cajueiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305000' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Nossa Senhora da Aparecida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305406' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Nova Friburgo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Doutor Loréti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304607' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio Bananal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204351' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Luís de Boa Sorte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200102' AND distrito.cod_ibge = '39';
 update public.distrito set nome = 'Lima Duarte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedro Teixeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senador Cortes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brasilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cristalina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002407' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itaporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004007' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Terra Nova do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108055' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Mato Grosso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106240' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Bom Jesus do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101852' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Xingu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107354' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pontes e Lacerda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106752' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto Esperidião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106828' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barão do Triunfo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301750' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arroio dos Mengues' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306551' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Butiatuva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313656' AND distrito.cod_ibge = '16';
 update public.distrito set nome = 'Sanga Funda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321436' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Cerro Grande do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305173' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rosário do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Suspiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318309' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ibaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311502' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bom Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302808' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cerro do Baú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314175' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Segundo Distrito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314605' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Capão do Leão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304663' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305439' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Estreito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318507' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Campo Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baús' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003256' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Andradas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campestre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3111002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bueno Brandão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedralva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passa Quatro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brazópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Revés do Belém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107802' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santa Efigênia de Caratinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113404' AND distrito.cod_ibge = '26';
 update public.distrito set nome = 'Alto do Capim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Rita do Itueto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Antunes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3130200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pedra do Indaiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus da Penha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guaxupé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião do Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Machado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Centenário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1704105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alcântara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serrano do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111789' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paulino Neves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108058' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Estandarte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102606' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tufilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112274' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Olho d''Água das Cunhãs' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2107407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jenipapo dos Vieiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105476' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Urbano Santos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2112605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa do Mato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105922' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Calama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100205' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Buritis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100452' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapuã do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Camargo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100254' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Marechal Thaumaturgo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200351' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Novo Airão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipixuna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Careiro da Várzea' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301159' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Balbina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303536' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Osório da Fonseca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1302900' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caracaraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1400209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Areias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504505' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Icoaraci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501402' AND distrito.cod_ibge = '60';
 update public.distrito set nome = 'Jaguaripe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Madeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2906501' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Francisco do Conde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipupiara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jussiape' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Corta Mão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901007' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Milagres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guanambi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmas de Monte Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caldeirão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905156' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Inhobim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2933307' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Maraú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Camurugi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931202' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Castelo Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913606' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Bandeira do Almada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2915502' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Eunápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910727' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lajedão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arraial D''Ajuda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925303' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Buritis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Galena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3153400' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itacarambi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3132107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedras de Maria da Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149150' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Espinosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pai Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146552' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serranópolis de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3166956' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira do Manteiga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109402' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vista Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Judas Tadeu de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3138682' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santa Cruz de Botumirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108503' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guaraciama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128253' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gouveia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jenipapo de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135456' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeirão da Folha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141801' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São João do Vacaria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3171600' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Divisópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122454' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2412708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2610806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bezerros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2603108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeira do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2208874' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chaval' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Adrianópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304707' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Felícia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300309' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Jericó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2507408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jataúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra do Sotero' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304236' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ventura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300507' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Joaquim do Salgado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312700' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Limoeiro do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio das Queimadas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608404' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Antônio dos Fernandes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308203' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bonfim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312908' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Flores' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311801' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306009' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Barro Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305506' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Salgadinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2513000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Frei Martinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2506202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa do Souza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2608701' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Água Preta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Donato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310951' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Betânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nascente' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300754' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Barra de São Francisco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Águas Claras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200136' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pancas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Braço do Rio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201605' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Serrinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301009' AND distrito.cod_ibge = '70';
 update public.distrito set nome = 'Cantagalo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fazenda do Campo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301603' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Sossego' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304607' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Belmiro Braga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3106101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Saudade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139805' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Dores do Paraibuna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160702' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Alto Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006309' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Bálsamo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Culturama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003801' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Porto Vilma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003454' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ivinhema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paranhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006358' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Matupá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campos de Júlio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5102686' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5104559' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'União do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Rica' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Bela da Santíssima Trindade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lucialva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105002' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Salto do Céu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107750' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pega Fogo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321204' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Araricá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300877' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ipiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309209' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Espigão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323002' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Maquiné' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311775' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bacupari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313656' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pinheirinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317608' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Alegrete' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Quaraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Toroquá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318101' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Espinilho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317103' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Rio Negro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300034' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Cerro do Martins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302808' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Faxinal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318804' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Porto Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003207' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Taquari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003306' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jaraguari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5004908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmital do Cervo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113909' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Três Corações' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Taquaral de Guanhães' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128006' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santa Cruz de Galiléia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127305' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'São José do Divino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3163300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Felicina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3100500' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santo Antônio do Manhuaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113404' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Piedade de Caratinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150158' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião da Vala' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101102' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Aldeia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120839' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Alto Pião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3159506' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Tapiraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio do Monte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cristais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3120201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Petúnia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3145109' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Porto Nacional' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Recursolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Central do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103125' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Matinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmeirândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2107605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Centro Novo do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103174' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Olinda do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2107357' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribamar Fiquene' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109551' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poção de Pedras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2108900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José dos Basílios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111250' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Coelho Neto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100338' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Nova Londrina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100122' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Theobroma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1101609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Luzia D''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100296' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tefé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1304203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Olinda do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Parintins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1303403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Humaitá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porangatu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5218003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cibele' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5211206' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Uruíta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caturaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5205208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Terezópolis de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221197' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aparecida do Rio Doce' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5201454' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5203500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5219209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5204300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jeriquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3525409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro do Turvo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Retiro da Esperança' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3502200' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Cesário Lange' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3511607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Moreira Sales' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piquirivaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104303' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Três Barras do Paraná' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127858' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dom Armando' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4116059' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Luiz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104501' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Boa Esperança do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103024' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinhalzinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122156' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Irati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110706' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vera Guarani' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118709' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Areia Branca dos Assis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114302' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Marcos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125506' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Paranaguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Belmonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4202156' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tunápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4218756' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Itaberaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211454' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santiago do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215695' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Calmon' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203154' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Estrela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4201273' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Linha das Palmeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219606' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vila de Volta Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215000' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Espinilho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203600' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Linha Porto Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309506' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Sete de Setembro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320578' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dezesseis de Novembro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306353' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Oito de Agosto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320321' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Espírito Santo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300455' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Coronel Barros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305871' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rincão dos Paivas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317806' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Santa Rosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313706' AND distrito.cod_ibge = '42';
 update public.distrito set nome = 'Água Santa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300059' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibiraiaras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marau' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Engenheiro Luiz Englert' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320503' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Saldanha Marinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316436' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Pedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321006' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Itapuca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310579' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Bárbara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319711' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Casa Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302303' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Esmeralda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Martinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316808' AND distrito.cod_ibge = '42';
 update public.distrito set nome = 'Deodoro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322608' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Bom Retiro do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Judas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312377' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Bela Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322509' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Passo do Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316907' AND distrito.cod_ibge = '33';
 update public.distrito set nome = 'Passo da Areia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315701' AND distrito.cod_ibge = '24';
 update public.distrito set nome = 'Linha Comprida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316501' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Santo Antônio de Castro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304804' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Xiniquá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319406' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Cavajuretã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319802' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pinheiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304200' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Nova Bréscia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cordilheira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303004' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Morro Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300209' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Xerém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301702' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Juquiratiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3512308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tabatinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3552700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maresias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550704' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Rita do Ribeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529906' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Polvilho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509205' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Arapongas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Sucesso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4103206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Aleixo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302502' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Santa Cruz das Palmeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3546306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tupi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538709' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Cangaiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Cursino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Três Bicos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104402' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Assaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4101903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Terra Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124707' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vitória Brasil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3556958' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Hortolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519071' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amparo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaciporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514403' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itaim Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '36';
 update public.distrito set nome = 'Socorro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '79';
 update public.distrito set nome = 'Santa Amélia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monjolinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117305' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bady Bassitt' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3504602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Orindiúva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3534203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piquerobi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lajeado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '96';
 update public.distrito set nome = 'Suzano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3552502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Loanda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Assis Chateaubriand' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Camilo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117909' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ibiporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3553401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Guzolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3518909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'União Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3555703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juliânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519006' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Estrela de Alagoas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2702553' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Traipu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2709202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Viçosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2709400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacuípe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2703502' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Rio Largo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2707701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel dos Campos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2708600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itabi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2803104' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pacatuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2804904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Umbaúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2807600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aroeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2920452' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Peixe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905909' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pilão Arcado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Vista do Lagamar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2913200' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Carinhanha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2907103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sítio do Mato' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930758' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cafarnaum' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Iguitu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912400' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itamaracá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304905' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Carqueijo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309003' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Porto Velho do Cunha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301207' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Ipituna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305307' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Acioli' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203130' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Apiacá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus do Itabapoana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boaventura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302205' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Dom Corrêa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3139409' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Ribeirão de São Domingos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157906' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Padre Felisberto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102506' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Silveira Carvalho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105509' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Eugenópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3124906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tombos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3169208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guidoval' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3128808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Visconde do Rio Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3172004' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Bárbara do Monte Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3157278' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Argirita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Água Clara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5000203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Batayporã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caracol' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5002803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Douradina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003504' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sanga Puitã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5006606' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Brasnorte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5101902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nona Agrovila' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5108055' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Nova Ubiratã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106240' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Félix do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107859' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aguapeí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5105507' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Glória D''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5103957' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morro Reuter' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312476' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boca da Picada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308805' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Barro Vermelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309209' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Passo da Areia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4323002' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Itati' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310652' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Frei Sebastião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313656' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Tramandaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marilu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110805' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Colorado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Boa Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120408' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Manuel Duarte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304508' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Paty do Alferes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3303856' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lauro Penteado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3511904' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jarinu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3525201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509957' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Luís do Paraitinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pachecos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301900' AND distrito.cod_ibge = '19';
 update public.distrito set nome = 'Mineiros do Tietê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Braço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514809' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Juquiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3526100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cajamar' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Londrina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113700' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Faxinal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Inoã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302700' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Casa Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3510807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Assistência' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543907' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Artemis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538709' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Juquitiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3526209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barra Funda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Cândido de Abreu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila Nova de Florença' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124707' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Tanguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305752' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pontalinda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3540259' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Moji Mirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Holambra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519055' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Guataporanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lucélia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3527405' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Perus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '61';
 update public.distrito set nome = 'Vila Formosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '85';
 update public.distrito set nome = 'Jacarezinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Wenceslau Braz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4128500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Álvares Florence' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Simonsen' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3557105' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Lajedinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Poço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2901700' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Irará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caldeirão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932002' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ribeira do Amparo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Quitéria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mosquito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300754' AND distrito.cod_ibge = '28';
 update public.distrito set nome = 'Calugi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306405' AND distrito.cod_ibge = '36';
 update public.distrito set nome = 'Trairi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Geraldo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203304' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Mateus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cardoso Moreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3301157' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pureza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304805' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Cachoeiros de Macaé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302403' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Três Rios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3306008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sumidouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Doutor Elias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305901' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibicaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3200102' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Domingos Martins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3201902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marechal Floriano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203346' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Caldeirão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3204609' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Iconha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mundo Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3202009' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vieira Machado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3203700' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Alto Castelinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3205036' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itajara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302205' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cruzeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300902' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Chalé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião da Bela Vista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3164407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinheirinhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147600' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Dias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108909' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Wenceslau Braz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3172202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nazaré de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144607' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São João del Rei' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Antônio Carlos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Faria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105608' AND distrito.cod_ibge = '14';
 update public.distrito set nome = 'Jequeri' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135506' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Vicente da Estrela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154002' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Vera Cruz de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3149309' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Nova União' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136603' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Domingos do Prata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Glaura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146107' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Coluna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senhora do Porto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3166105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Sebastião do Bugre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119203' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Boa União de Itabirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131802' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barra Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3131307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Domingos das Dores' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3160959' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição do Capim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101102' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nicolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154309' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'São Gonçalo do Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161809' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pimenta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Muzambinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3144102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114402' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Taquaruçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1721000' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mateiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1712702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cangas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cedral' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103109' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição do Lago-Açu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103554' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Matões do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2106631' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Alegre do Pindaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100477' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guajará-Açu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501907' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São Roberto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504307' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Almoço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501709' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santa Maria do Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1506609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Acará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aurora do Pará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500958' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José do Gurupi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1508308' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Altamira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1500602' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Ipixuna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504976' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus do Tocantins' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501576' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canaã dos Carajás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502152' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ilha de Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600600' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vitória do Jari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Praia Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718303' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Abreulândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1700251' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tupirama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1721257' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marzagão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107701' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ribeirão dos Cocais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106109' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Varginha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107800' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Fazenda de Cima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5106505' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Alcantilado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5104203' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Celma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5104807' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Araguapaz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5202155' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jeroaquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5207535' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Fé de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5219258' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Uruaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5221601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapuranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5211206' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pilar de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5216908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itaberaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5210406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Moiporá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5213400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Firminópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5207808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bela Vista de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5203302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guarani de Goiás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5209408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jardim Ingá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5212501' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Santo Antônio do Sudoeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Maria do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4123857' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guarani' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117057' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Linha Rosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4122156' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Guamiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4108957' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106803' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Lajeado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125605' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ferraria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104204' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Canela' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121604' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guaraqueçaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piên' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4119103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tijucas do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127601' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Romelândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4215208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Águas Frias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4200556' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jupiá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209177' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vargeão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Luzerna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210035' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tangará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Anta Gorda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219309' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Concórdia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Castelo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4211108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Garuva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205803' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ponte Alta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Roque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216909' AND distrito.cod_ibge = '29';
 update public.distrito set nome = 'Dalbérgia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4206900' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Rio Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4208500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Canasvieiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205407' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Barreiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4216602' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vargem do Cedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217105' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barro Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4209607' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Urussanga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4219002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira de Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213807' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Porto Vera Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315073' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tuparendi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Daltro Filho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4321402' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Cruz Alta' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Bárbara do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316709' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paraí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4314001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mato Leitão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312153' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tamanduá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320263' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Nossa Senhora de Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311304' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Várzea dos Antunes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312617' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'São João dos Mellos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311205' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Linha Pinheiro Machado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302659' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Vale dos Vinhedos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302105' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Lageado Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305959' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jazidas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4319604' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Linha Brasil' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304200' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Glória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307807' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Pantano Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313953' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Antônio Rocha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3300407' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Batatais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3505906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Murutinga do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Martinho d''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501103' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Peabiru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bela Vista do Paraíso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Agulhas Negras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304201' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Valença' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3306107' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Miguel Pereira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3302908' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa América' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3517000' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Domélia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3500709' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Balbinos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3504701' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pongaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3540101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dois Córregos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Moreira César' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3538006' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Queluz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campos de Cunha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3513603' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vale do Paquequer' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305802' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guaianás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3536703' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barão de Geraldo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3509502' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sumaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3552403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paulicéia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3536406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Flórida Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3516002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jabaquara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '38';
 update public.distrito set nome = 'Perdizes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '60';
 update public.distrito set nome = 'Tatuapé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '80';
 update public.distrito set nome = 'Vila Guilherme' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '86';
 update public.distrito set nome = 'Natingui' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117305' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Ruilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530300' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Álvares Machado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3501301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cuiabá Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3530201' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila Sônia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '94';
 update public.distrito set nome = 'Cidade Kemel' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3539806' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bragantina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102000' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Potirendaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3540804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Prudêncio e Moraes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3516903' AND distrito.cod_ibge = '13';
 update public.distrito set nome = 'Barra Dourada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532504' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Padre Nóbrega' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3529005' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Conceição de Monte Alegre' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3535507' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Porto São Carlos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4124608' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Jardim Paredão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100509' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cafeeiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106605' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Icaraíma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109906' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mariluz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115101' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Umirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313757' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canindé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Araripe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Romão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2300606' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Barra de Santa Rosa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501609' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Casserengue' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504157' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mata Limpa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2501104' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Logradouro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2508554' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Maraial' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2609204' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Cruz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606804' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Água Branca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2700102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Serra Nova Dourada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107883' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Querência' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107065' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canto Krewer' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322541' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Gramal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318408' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Bom Retiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306767' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Morungava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4309209' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Arroio Teixeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304630' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Mostardas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Casa Velha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313656' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Garruchos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308656' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Margarida do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316972' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaguarão Grande' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304358' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Pavão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304663' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cordeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306056' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Turuçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322327' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaguarão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paiaguás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5003207' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Ponte Vermelha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5007695' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Campos Gerais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3111606' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Sião' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sapucaí-Mirim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3165404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162005' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Alagoa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3101300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Franceses' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3114808' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Costas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3147303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itutinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3134509' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curral Novo de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102902' AND distrito.cod_ibge = '06';
 update public.distrito set nome = 'Rio Casca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154903' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Conceição de Itaguá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109006' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Fonseca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3102308' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Baixa Verde' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121803' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Piedade dos Gerais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3150406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cachoeira do Campo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3146107' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Conselheiro Lafaiete' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3118304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gonzaga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127503' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cartucho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1709005' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Chapada da Natividade' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1705102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cajapió' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2102408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porto das Gabarras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2100709' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Junco do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2105658' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Médici' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2109239' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Senador La Rocque' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111763' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Mateus do Maranhão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Codozinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2103307' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Passagem Franca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2107902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100114' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pimenta Bueno' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1100189' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sena Madureira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1200500' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jutaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1302306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Codajás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1301308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cametá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300508' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Canutama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1300904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Normandia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1400407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Piriá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502806' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Entroncamento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1501402' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Curuçá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502905' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Caetano de Odivelas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tauari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1502202' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Cairari' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1504703' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ourém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1505403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alvorada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1508159' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João do Araguaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1507508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pracuúba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600550' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bailique' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1600303' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Riachinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1718550' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Muricilândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1713957' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Miranorte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1713304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alvorada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '1700707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mimoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5107800' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Nova Crixás' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '5214838' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Engenho Velho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4306924' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fortaleza' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307302' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'Palmitinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4313805' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Dourado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4300901' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Jaguaretê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307005' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Estação' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4307559' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Salvador das Missões' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316477' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catuípe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4305009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passo do Quaresma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4315958' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Afonso Rodrigues' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318903' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Santo Antônio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310207' AND distrito.cod_ibge = '40';
 update public.distrito set nome = 'Atiaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4320107' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Alto da União' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4310207' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Santo Antônio do Palma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4317558' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cadeado' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4302220' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São José do Centro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312658' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Mormaço' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312427' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cambará do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4303608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vale do Sampaio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322608' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Jaquirana' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311122' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Passo do Carro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312377' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São José dos Ausentes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4318622' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Júlio de Castilhos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4311205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palma' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4316907' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'General Neto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4301651' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Pesqueiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4312401' AND distrito.cod_ibge = '27';
 update public.distrito set nome = 'Vale Real' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4322541' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Otávio Rocha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4308201' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Vila União' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4304200' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Bacaxá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3305505' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vista Alegre do Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3556909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Castilho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3511003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sud Mennucci' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3552304' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Avanhandava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3504404' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Roque Novo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3506904' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Analândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3502002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacupiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3524600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jardim Presidente Dutra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3518800' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Amoreira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4114906' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'São Luiz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4113700' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Queimados' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3304144' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Engenheiro Coelho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3515152' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itapecerica da Serra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Caetano do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3548807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capão Redondo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '19';
 update public.distrito set nome = 'São Joaquim do Pontal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4111001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cardeal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Nova Odessa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533403' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João do Pau d''Alho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3549300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'República' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '66';
 update public.distrito set nome = 'Sé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3550308' AND distrito.cod_ibge = '78';
 update public.distrito set nome = 'Paranagi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4126405' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Sapé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127809' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cosmorama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3512902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Icém' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ribeiro dos Santos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3533908' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'João Ramalho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3525607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Narandiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3532207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Pátria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3541208' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ribeirão dos Índios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3543238' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guararema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3518305' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Alto Paraná' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100608' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Diamante do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4107108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Eduardo Xavier da Silva' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4112009' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Alto Santa Fé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117222' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Elisiário' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3514924' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gastão Vidigal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3516804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Cardoso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3521903' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Anápolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3519204' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Paramoti' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Girau do Ponciano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2702900' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Branquinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2701100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Messias' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2705200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José da Mata' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2504009' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Roteiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2707800' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora Aparecida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2804458' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Canhoba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2801108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Divina Pastora' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2802007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Arauá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2800407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Formosa do Rio Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911105' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rita de Cássia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Patamuté' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2909901' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Buritirama' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904753' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juacema' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917706' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Umburanas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932457' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Irecê' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914604' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mirangaba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ventura' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921708' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Serrolândia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2930600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Cruzeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910305' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Maria Quitéria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910800' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Tanquinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Biritinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903607' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barreiros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926301' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'São Domingos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928950' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mata de São João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2921005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Camassandi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2917805' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Salinas da Margarida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2927309' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lauro de Freitas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2919207' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caraibuna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2908804' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Piatã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2924306' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Irajuba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lafaiete Coutinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baixinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932101' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Ibiajara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2926905' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Luizlândia do Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136306' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Olhos d''Água do Bom Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117836' AND distrito.cod_ibge = '25';
 update public.distrito set nome = 'Retiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3161106' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Paciência' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152204' AND distrito.cod_ibge = '14';
 update public.distrito set nome = 'Taiobeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3168002' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Vila de Fátima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3108602' AND distrito.cod_ibge = '45';
 update public.distrito set nome = 'Nova Minda' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135357' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Ubaí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3170008' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Chapada do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3116100' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruzinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141801' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Bandeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3105202' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibatuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2910503' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Terra Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2931707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Governador Mangabeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santo Antônio de Jesus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2928703' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Monte Recôncavo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2929206' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Remédios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2923035' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Bonito' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2904050' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Utinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2932804' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Baixão' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2918001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Mutuípe' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2922409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brejinho das Ametistas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2905206' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Lucaia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925006' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Itapetinga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2916401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barro Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2903300' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gongogi' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2911501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itacaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2914901' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ibirapuã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2912806' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cumuruxatiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2925501' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Juvenília' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3136959' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jaíba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3135050' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tanque de Porteirinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3152204' AND distrito.cod_ibge = '23';
 update public.distrito set nome = 'Sambaíba de Minas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3109402' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Riachinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3154457' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Catuni' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126703' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Montes Claros' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143302' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa da Pedra' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3162658' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Diamantina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3121605' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Felício dos Santos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3125408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa Grande de Minas Novas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3141801' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Comercinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Miguel Alves' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206209' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ideal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301208' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Pai João' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301406' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Arisco dos Marianos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309458' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Quincuncá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304301' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Coité' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308104' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Missão Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308401' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Puxinanã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2512408' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curral de Cima' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2505279' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'João Pessoa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2507507' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jacaúna' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301000' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Carnaubais' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2402501' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Encanto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2403301' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagoa do Barro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601102' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Salgueiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Cruz dos Milagres' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209153' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Umarizeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307700' AND distrito.cod_ibge = '42';
 update public.distrito set nome = 'Ararendá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301257' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nossa Senhora do Livramento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308609' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Tamboril' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ouro Branco' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2408508' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Rita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2615904' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Dormentes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2605152' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Morro Cabeça no Tempo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2206654' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Sucesso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2313203' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Madalena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307635' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Daniel de Queiróz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311306' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Jaçanã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2405009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Córrego de São Mateus' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2405306' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Tacaratu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2614808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Domingos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602605' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Parambu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Goianinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2404200' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Brejo dos Santos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2502904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mandacaru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2606408' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Bahia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312007' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Jaibaras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312908' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Patriarca' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312908' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'São José' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310001' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Juru' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2508000' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São José de Princesa' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2514552' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Amparo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2500734' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Livramento' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2508505' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Marinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2502508' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Buenos Aires' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caricé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2607653' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Vicência' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2616308' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santa Terezinha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2600401' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Franciscópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3126752' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Presidente Pena' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3113701' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Grupiara' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3127909' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Santana de Patos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3148004' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Santo Antônio do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3117504' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Água Comprida' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3100708' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Bom Despacho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3107406' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Gororós' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3122603' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Araxá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3104007' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Frei Orlando' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3143500' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Contria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3119104' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São João dos Patos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2111102' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Félix de Balsas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2110807' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmatória' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306504' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Cedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303956' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Guanacés' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303501' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Anauá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2308104' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Belmonte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304202' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Jardim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Porteiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311108' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Juá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2310605' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Umbuzeiro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2517001' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Altos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2200400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Campo Maior' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202208' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São Miguel do Tapuio' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210409' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tejupá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3554201' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tomé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3521705' AND distrito.cod_ibge = '08';
 update public.distrito set nome = 'Morro do Alto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3522307' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Laranjal Paulista' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '3526407' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Aparecida D''Oeste' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127908' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Pocinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4102505' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Vila Ipiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127700' AND distrito.cod_ibge = '33';
 update public.distrito set nome = 'São Salvador' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4104808' AND distrito.cod_ibge = '50';
 update public.distrito set nome = 'Agro Cafeeira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115606' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Pranchita' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4120358' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cruzeiro do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106571' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Lagos do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4125209' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'São Luiz' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4105409' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'São Roque do Chopim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4118501' AND distrito.cod_ibge = '30';
 update public.distrito set nome = 'Mato Rico' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4115739' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Guarapuava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4109401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Reserva do Iguaçu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4121752' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Padre Ponciano' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4117602' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Itapará' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4110706' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Almirante Tamandaré' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4100400' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Curitiba' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4106902' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Tunas do Paraná' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4127882' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Itajubá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204905' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Grápia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212239' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Caxambu do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204103' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cunha Porã' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4204707' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palmitos' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4212106' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Entre Rios' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205175' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Ponte Serrada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213401' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Capinzal' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203907' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pinheiro Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4213005' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Nova Teutônia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217501' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'Bela Vista do Sul' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4210100' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Schroeder' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4217402' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Encruzilhada' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4203600' AND distrito.cod_ibge = '17';
 update public.distrito set nome = 'Frei Rogério' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '4205555' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Caiçara do Norte' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2401859' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pedro Avelino' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2409704' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Jardim do Seridó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2405702' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Cabrobó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2603009' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Fartura do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2203750' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'São João da Canabrava' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2209856' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Pio IX' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2208205' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Laranjeiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2301851' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Ipiranga' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2302404' AND distrito.cod_ibge = '22';
 update public.distrito set nome = 'São João dos Queirozes' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311306' AND distrito.cod_ibge = '59';
 update public.distrito set nome = 'Serra da Tapuia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2413706' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Fazenda Nova' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2602605' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Conceição do Canindé' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2202802' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Socorro do Piauí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2210904' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Timonha' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304707' AND distrito.cod_ibge = '35';
 update public.distrito set nome = 'Flamengo' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311900' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Betânia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304269' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'São José de Mipibu' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2412203' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Mato Grosso' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2509370' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Riacho das Almas' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2611705' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Panacuí' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307809' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Juá dos Vieiras' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2314102' AND distrito.cod_ibge = '12';
 update public.distrito set nome = 'Manibú' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2305357' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Santa Luzia' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2307007' AND distrito.cod_ibge = '18';
 update public.distrito set nome = 'Nazarezinho' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2510006' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Diamante' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2505600' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Angelim' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2601003' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Paquevira' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2603702' AND distrito.cod_ibge = '15';
 update public.distrito set nome = 'Saloá' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2612307' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Graça' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2304657' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Barro Preto' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2312007' AND distrito.cod_ibge = '09';
 update public.distrito set nome = 'Agua Fria' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2311504' AND distrito.cod_ibge = '07';
 update public.distrito set nome = 'Aquinópolis' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2306900' AND distrito.cod_ibge = '10';
 update public.distrito set nome = 'Cedro' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2303808' AND distrito.cod_ibge = '05';
 update public.distrito set nome = 'Palestina' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2309508' AND distrito.cod_ibge = '20';
 update public.distrito set nome = 'São Vicente do Seridó' FROM public.municipio WHERE municipio.idmun = distrito.idmun AND municipio.cod_ibge = '2515401' AND distrito.cod_ibge = '10';

DROP INDEX public.tmp_idx_municipio_cod_ibge;
DROP INDEX public.tmp_idx_distrito_idmun_cod_ibge;

ALTER TABLE public.distrito ENABLE TRIGGER ALL;

COMMIT;
SQL;
        DB::unprepared($sql);
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        //
    }
}
