--
-- PostgreSQL database dump
--

-- Dumped from database version 9.5.14
-- Dumped by pg_dump version 9.5.14

-- Started on 2018-11-19 15:03:12 -02

SET statement_timeout = 0;
SET lock_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET client_min_messages = warning;
SET row_security = off;

--
-- TOC entry 10 (class 2615 OID 9442752)
-- Name: acesso; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA acesso;


--
-- TOC entry 11 (class 2615 OID 9442753)
-- Name: alimentos; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA alimentos;


--
-- TOC entry 12 (class 2615 OID 9442754)
-- Name: cadastro; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA cadastro;


--
-- TOC entry 13 (class 2615 OID 9442755)
-- Name: consistenciacao; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA consistenciacao;


--
-- TOC entry 14 (class 2615 OID 9442756)
-- Name: conv_functions; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA conv_functions;


--
-- TOC entry 15 (class 2615 OID 9442757)
-- Name: historico; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA historico;


--
-- TOC entry 24 (class 2615 OID 9442758)
-- Name: modules; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA modules;


--
-- TOC entry 16 (class 2615 OID 9442759)
-- Name: pmiacoes; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA pmiacoes;


--
-- TOC entry 17 (class 2615 OID 9442760)
-- Name: pmicontrolesis; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA pmicontrolesis;


--
-- TOC entry 18 (class 2615 OID 9442761)
-- Name: pmidrh; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA pmidrh;


--
-- TOC entry 19 (class 2615 OID 9442762)
-- Name: pmieducar; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA pmieducar;


--
-- TOC entry 20 (class 2615 OID 9442763)
-- Name: pmiotopic; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA pmiotopic;


--
-- TOC entry 21 (class 2615 OID 9442764)
-- Name: portal; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA portal;


--
-- TOC entry 26 (class 2615 OID 9468958)
-- Name: relatorio; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA relatorio;


--
-- TOC entry 22 (class 2615 OID 9442765)
-- Name: serieciasc; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA serieciasc;


--
-- TOC entry 23 (class 2615 OID 9442766)
-- Name: urbano; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA urbano;


--
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner:
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner:
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


--
-- Name: pg_stat_statements; Type: EXTENSION; Schema: -; Owner:
--

CREATE EXTENSION IF NOT EXISTS pg_stat_statements WITH SCHEMA public;


--
-- Name: EXTENSION pg_stat_statements; Type: COMMENT; Schema: -; Owner:
--

COMMENT ON EXTENSION pg_stat_statements IS 'track execution statistics of all SQL statements executed';


--
-- Name: unaccent; Type: EXTENSION; Schema: -; Owner:
--

CREATE EXTENSION IF NOT EXISTS unaccent WITH SCHEMA public;


--
-- Name: EXTENSION unaccent; Type: COMMENT; Schema: -; Owner:
--

COMMENT ON EXTENSION unaccent IS 'text search dictionary that removes accents';


--
-- TOC entry 1398 (class 1247 OID 9442783)
-- Name: typ_idlog; Type: TYPE; Schema: public; Owner: -
--

CREATE TYPE public.typ_idlog AS (
	idlog integer
);


--
-- TOC entry 1401 (class 1247 OID 9442786)
-- Name: typ_idpes; Type: TYPE; Schema: public; Owner: -
--

CREATE TYPE public.typ_idpes AS (
	idpes integer
);


--
-- TOC entry 873 (class 1255 OID 9442787)
-- Name: fcn_calcular_qtde_cardapio(character varying, integer, integer, numeric); Type: FUNCTION; Schema: alimentos; Owner: -
--

CREATE FUNCTION alimentos.fcn_calcular_qtde_cardapio(character varying, integer, integer, numeric) RETURNS character varying
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_cli ALIAS for $1;
  v_id_car ALIAS for $2;
  v_id_pro ALIAS for $3;
  v_qtde_per_capita ALIAS for $4;
  reg_unidade RECORD;
  v_inscritos char(1);
  v_correcao numeric:=0;
  v_coccao numeric:=0;
  v_qtde numeric:= 0;
  v_qtde_retorno varchar(20);
BEGIN
  SELECT INTO v_inscritos inscritos
  FROM alimentos.cliente
  WHERE alimentos.cliente.idcli = v_id_cli;
  SELECT INTO v_correcao,v_coccao fator_correcao,fator_coccao
  FROM alimentos.produto
  WHERE alimentos.produto.idpro = v_id_pro;
  FOR reg_unidade IN SELECT unf.num_inscritos as insc, unf.num_matriculados as matr
        FROM alimentos.cardapio_faixa_unidade car,
                     alimentos.unidade_faixa_etaria unf
        WHERE car.idfeu = unf.idfeu
        AND   car.idcar = v_id_car LOOP
    IF v_inscritos = 'S' THEN
      v_qtde := v_qtde + (v_qtde_per_capita * reg_unidade.insc * v_correcao * v_coccao);
    ELSE
      v_qtde := v_qtde + (v_qtde_per_capita * reg_unidade.matr * v_correcao * v_coccao);
    END IF;
  END LOOP;

  v_qtde_retorno := trim(to_char(v_qtde, '9999999999.99'));
  RETURN v_qtde_retorno;
END;$_$;


--
-- TOC entry 874 (class 1255 OID 9442788)
-- Name: fcn_calcular_qtde_percapita(character varying, integer, integer, integer, integer); Type: FUNCTION; Schema: alimentos; Owner: -
--

CREATE FUNCTION alimentos.fcn_calcular_qtde_percapita(character varying, integer, integer, integer, integer) RETURNS numeric
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_cli ALIAS for $1;
  v_id_uni ALIAS for $2;
  v_id_pro ALIAS for $3;
  v_data_inicial ALIAS for $4;
  v_data_final ALIAS for $5;
  v_sql_qtde_produto text;
  v_reg_qtde_produto RECORD;
  v_qtde_produto_periodo numeric;
  v_existe_unidade integer;
BEGIN
  v_sql_qtde_produto := 'SELECT car.dt_cardapio
    ,cap.quantidade as qtde
    ,car.idcar as idcar
  FROM alimentos.cardapio car
      ,alimentos.cardapio_produto cap
  WHERE car.idcar = cap.idcar
  AND cap.idpro = ' || v_id_pro || '
  AND car.finalizado = ''S''
  AND car.idcli = ''' ||  v_id_cli || '''
  AND TO_NUMBER(TO_CHAR(car.dt_cardapio,''YYYYMMDD''),''99999999'') BETWEEN ' || v_data_inicial || ' AND  ' || v_data_final;
  v_qtde_produto_periodo := 0;
  v_existe_unidade := 0;
  FOR v_reg_qtde_produto IN EXECUTE v_sql_qtde_produto LOOP
    --
    -- Verifica se o cardápio atende a unidade em questão
    --
    SELECT INTO v_existe_unidade distinct uni.iduni
    FROM alimentos.cardapio car
      ,alimentos.cardapio_faixa_unidade caf
      ,alimentos.unidade_atendida uni
      ,alimentos.unidade_faixa_etaria ufa
    WHERE car.idcar = caf.idcar
    AND caf.idfeu = ufa.idfeu
    AND ufa.iduni = uni.iduni
    AND uni.iduni = v_id_uni
    AND car.idcar = v_reg_qtde_produto.idcar;
    IF v_existe_unidade > 0 THEN
      v_qtde_produto_periodo := v_qtde_produto_periodo  + v_reg_qtde_produto.qtde;
    END IF;
  END LOOP;
  RETURN v_qtde_produto_periodo;
END;$_$;


--
-- TOC entry 876 (class 1255 OID 9442789)
-- Name: fcn_calcular_qtde_unidade(character varying, integer, integer, numeric, integer, integer); Type: FUNCTION; Schema: alimentos; Owner: -
--

CREATE FUNCTION alimentos.fcn_calcular_qtde_unidade(character varying, integer, integer, numeric, integer, integer) RETURNS numeric
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_cli ALIAS for $1;
  v_id_uni ALIAS for $2;
  v_id_pro ALIAS for $3;
  v_qtde_per_capita ALIAS for $4;
  v_data_inicial ALIAS for $5;
  v_data_final ALIAS for $6;
  v_reg_faixa RECORD;
  v_inscritos char(1);
  v_correcao numeric:=0;
  v_coccao numeric:=0;
  v_qtde numeric:= 0;
  v_peso numeric:=0;
  v_qtde_produto_periodo numeric:=0;
  v_num_inscritos integer;
  v_num_matriculados integer;
BEGIN
  SELECT INTO v_inscritos inscritos
  FROM alimentos.cliente
  WHERE alimentos.cliente.idcli = v_id_cli;
  SELECT INTO v_correcao,v_coccao,v_peso pro.fator_correcao, pro.fator_coccao, unp.peso
  FROM alimentos.produto pro, alimentos.unidade_produto unp
  WHERE   pro.idunp = unp.idunp
  AND unp.idcli = v_id_cli
  AND     pro.idpro = v_id_pro;
  --
  -- Obtém inscritos e matriculados para a unidade
  --
  v_num_inscritos:=0;
  v_num_matriculados:=0;
  FOR v_reg_faixa IN SELECT distinct ufa.idfae as idfae
      ,ufa.num_inscritos as num_inscritos
      ,ufa.num_matriculados as num_matriculados
    FROM  alimentos.cardapio car
      ,alimentos.cardapio_faixa_unidade caf
      ,alimentos.unidade_atendida uni
      ,alimentos.unidade_faixa_etaria ufa
    WHERE car.idcar = caf.idcar
    AND   caf.idfeu = ufa.idfeu
    AND ufa.iduni = uni.iduni
    AND     uni.iduni = v_id_uni
    AND     car.finalizado = 'S'
    AND car.idcli = v_id_cli
    AND TO_NUMBER(TO_CHAR(car.dt_cardapio,'YYYYMMDD'),'99999999') BETWEEN v_data_inicial AND v_data_final LOOP
    v_num_inscritos:=v_num_inscritos + v_reg_faixa.num_inscritos;
    v_num_matriculados:=v_num_matriculados + v_reg_faixa.num_matriculados;
  END LOOP;
  --
  -- Calcula a qtde percapita necessária do produto para o período
  --
  select INTO v_qtde_produto_periodo
  alimentos.fcn_calcular_qtde_percapita (v_id_cli,v_id_uni,v_id_pro,v_data_inicial,v_data_final);
  IF v_inscritos = 'S' THEN
    v_qtde := v_qtde_produto_periodo * v_num_inscritos * v_correcao * v_coccao;
  ELSE
    v_qtde := v_qtde_produto_periodo * v_num_matriculados * v_correcao * v_coccao;
  END IF;
  RETURN round(v_qtde/v_peso);
END;$_$;


--
-- TOC entry 877 (class 1255 OID 9442790)
-- Name: fcn_gerar_guia_remessa(text, text, integer, integer, character varying, character varying, character varying, integer); Type: FUNCTION; Schema: alimentos; Owner: -
--

CREATE FUNCTION alimentos.fcn_gerar_guia_remessa(text, text, integer, integer, character varying, character varying, character varying, integer) RETURNS text
    LANGUAGE plpgsql
    AS $_$DECLARE
   -- Parâmetro recebidos
   v_array_fornecedor ALIAS for $1;
   v_array_unidade ALIAS for $2;
   v_data_inicial ALIAS for $3;
   v_data_final ALIAS for $4;
   v_classe ALIAS for $5;
   v_id_cliente ALIAS for $6;
   v_login ALIAS for $7;
   v_id_log ALIAS for $8;
   v_sql_unidade text;
   v_reg_unidade RECORD;
   v_reg_faixa RECORD;
   v_sql_produto text;
   v_reg_produto RECORD;
   v_sql_fornecedor text;
   v_reg_fornecedor RECORD;
   v_num_inscritos integer;
   v_num_matriculados integer;
   v_inscritos char(1);
   v_qtde_necessaria numeric;         -- quantidade total necessaria para o produto
   v_qtde_necessaria_saldo numeric;   -- saldo do produto a fornecer
   v_qtde_nec_saldo_ant numeric;      -- saldo anterior do produto
   v_qtde_guia_produto numeric;       -- qtde do produto com guia de remessa gerada
   v_qtde_disponivel numeric;         -- qtde total disponível no(s) fornecedor(res)
   v_qtde_total_contrato numeric;     -- qtde total contratada com o fornecedor
   v_percentual_forn numeric;         -- percentual que pode ser fornecido pelo forn
   -- quantidade fornecida para o produto pelo fornecedor na guia
   v_qtde_forn numeric;
   v_qtde_guia integer:=0;
   v_qtde_produto_periodo numeric:=0; -- qtde de produto necessária para o período
              --(somatória da qtde percapita da receita)

   v_id_guia integer:=0;
   v_id_guia_produto integer:=0;
   v_sequencial integer:=0;         -- sequencial da guia de remessa gerada
   v_num_inscr_matr integer:=0;
   v_num_refeicao integer:=0;
   v_dt_cardapio_ini_x date;
   v_dt_cardapio_ini_y integer:=0;
   v_dt_cardapio_ini date;
   v_dt_cardapio_fim date;
   v_classe_aux VARCHAR(2);
   v_peso numeric;
   v_existe_forn integer:=0;
   v_existe_produto integer:=0;
   v_existe_estoque integer:=0;
   --v_id_log integer:=0;

BEGIN
   --
   -- Converte data numérica invertida para o formato DD/MM/YYYY
   --
   v_dt_cardapio_ini := TO_DATE(substr(TRIM(TO_CHAR(v_data_inicial,'99999999')),7,2)|| '/' || substr(TRIM(TO_CHAR(v_data_inicial,'99999999')),5,2)|| '/' || substr(TRIM(TO_CHAR(v_data_inicial,'99999999')),1,4),'DD/MM/YYYY');
   v_dt_cardapio_ini_x := v_dt_cardapio_ini;
   v_dt_cardapio_fim := TO_DATE(substr(TRIM(TO_CHAR(v_data_final,'99999999')),7,2)|| '/' || substr(TRIM(TO_CHAR(v_data_final,'99999999')),5,2)|| '/' || substr(TRIM(TO_CHAR(v_data_final,'99999999')),1,4),'DD/MM/YYYY');
   --
   -- INSERE LOG
   --
   --v_id_log:=nextval('alimentos.log_guia_remessa_idlogguia_seq'::text);
   INSERT INTO alimentos.log_guia_remessa
    (idlogguia
    ,login
    ,idcli
    ,dt_inicial
    ,dt_final
    ,unidade
    ,fornecedor
    ,classe
    ,dt_geracao
    ,mensagem)
  VALUES
    (v_id_log
    ,v_login
    ,v_id_cliente
    ,v_dt_cardapio_ini
    ,v_dt_cardapio_fim
    ,v_array_unidade
    ,v_array_fornecedor
    ,v_classe
    ,CURRENT_TIMESTAMP
    ,'*** INÍCIO ***');
   --
   -- Obtém indicação de inscritos ou matriculados para o cliente
   --
   SELECT INTO v_inscritos inscritos
   FROM alimentos.cliente
   WHERE alimentos.cliente.idcli = v_id_cliente;
   RAISE NOTICE 'Inscritos(%)',v_inscritos;
   --
   -- GRAVA LOG
   --
   UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n Inscritos: ' || v_inscritos WHERE idlogguia = v_id_log;
   --
   -- Obtém o número de tipos de refeições que serão atendidas
   -- (total café da manhã, total almoço, etc)
   --
   SELECT INTO v_num_refeicao COUNT(distinct idtre)
   FROM alimentos.cardapio car
   WHERE car.idcli = v_id_cliente
   AND car.finalizado = 'S'
   AND TO_NUMBER(TO_CHAR(car.dt_cardapio,'YYYYMMDD'),'99999999') BETWEEN v_data_inicial AND v_data_final;
   WHILE v_dt_cardapio_ini_x <= v_dt_cardapio_fim LOOP

      RAISE NOTICE '---------------->>1º Loop Data(%)',v_dt_cardapio_ini_x;

      --
      -- GRAVA LOG
      --
      UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      ----- 1º Loop Data ' || TO_CHAR(v_dt_cardapio_ini_x,'DD/MM/YYYY') || ' -----' WHERE idlogguia = v_id_log;
      --
      -- Prepara SELECT para obter as unidades que atendem aos filtros informados
      --
      v_sql_unidade := 'SELECT distinct uni.iduni as iduni
      ,TRIM(uni.nome) as nome
      FROM alimentos.cardapio car
       ,alimentos.cardapio_faixa_unidade caf
       ,alimentos.unidade_atendida uni
       ,alimentos.unidade_faixa_etaria ufa
      WHERE car.idcar = caf.idcar
      AND caf.idfeu = ufa.idfeu
      AND ufa.iduni = uni.iduni';

      IF v_array_unidade <> '0' THEN
         v_sql_unidade := v_sql_unidade || ' AND uni.iduni IN (' || v_array_unidade || ')';
      END IF;

      v_sql_unidade := v_sql_unidade || ' AND car.finalizado = ''S''
      AND car.idcli = ''' || v_id_cliente || '''
      AND car.dt_cardapio = ''' || v_dt_cardapio_ini_x || '''';

      --
      -- Executa SELECT para obter as unidades
      --
      FOR v_reg_unidade IN EXECUTE v_sql_unidade LOOP

         RAISE NOTICE '                                          ';
         RAISE NOTICE '2º Loop Unidade(%)',v_reg_unidade.nome;

         --
         -- GRAVA LOG
         --
         UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      ----- 2º Loop Unidade ' || TRIM(TO_CHAR(v_reg_unidade.iduni, '9999999999')) || '-' || v_reg_unidade.nome || ' -----' WHERE idlogguia = v_id_log;
         v_num_inscritos:=0;
   v_num_matriculados:=0;

         --
         -- Obtém inscritos e matriculados para a unidade
         --

         FOR v_reg_faixa IN SELECT distinct ufa.idfae as idfae
                   ,ufa.num_inscritos as num_inscritos
             ,ufa.num_matriculados as num_matriculados
      FROM alimentos.cardapio car
    ,alimentos.cardapio_faixa_unidade caf
    ,alimentos.unidade_atendida uni
    ,alimentos.unidade_faixa_etaria ufa
      WHERE car.idcar = caf.idcar
      AND caf.idfeu = ufa.idfeu
      AND ufa.iduni = uni.iduni
      AND uni.iduni = v_reg_unidade.iduni
      AND car.finalizado = 'S'
      AND car.idcli = v_id_cliente
      AND car.dt_cardapio = v_dt_cardapio_ini_x LOOP

            v_num_inscritos:=v_num_inscritos + v_reg_faixa.num_inscritos;
      v_num_matriculados:=v_num_matriculados + v_reg_faixa.num_matriculados;

   END LOOP;
   RAISE NOTICE 'Inscritos(%)',v_num_inscritos;
   RAISE NOTICE 'Matriculados(%)',v_num_matriculados;

         --
         -- GRAVA LOG
         --
         UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      Nº Inscritos: ' || TRIM(TO_CHAR(v_num_inscritos, '9999999999')) WHERE idlogguia = v_id_log;
   UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      Nº Matriculados: ' || TRIM(TO_CHAR(v_num_matriculados, '9999999999')) WHERE idlogguia = v_id_log;
   --
   -- Prepara SELECT para carregar produtos existentes no cardápio
   --
         v_sql_produto := 'SELECT distinct cap.idpro as idpro
        ,cap.quantidade as qtde
        ,pro.fator_correcao as fator_correcao
        ,pro.fator_coccao as fator_coccao
        ,TRIM(pro.nome_compra) as nome_compra
        ,unp.peso as peso
      FROM  alimentos.cardapio car
        ,alimentos.cardapio_produto cap
        ,alimentos.produto pro
        ,alimentos.unidade_produto unp
        ,alimentos.cardapio_faixa_unidade caf
        ,alimentos.unidade_atendida uni
        ,alimentos.unidade_faixa_etaria ufa
      WHERE car.idcar = cap.idcar
      AND cap.idpro = pro.idpro
      AND     pro.idunp = unp.idunp
      AND     unp.idcli = ''' || v_id_cliente || '''
      AND car.idcar = caf.idcar
      AND   caf.idfeu = ufa.idfeu
      AND ufa.iduni = uni.iduni';
   IF v_classe is not null THEN
      v_sql_produto := v_sql_produto || ' AND pro.classe = ''' || v_classe || '''';
         END IF;

         --
   -- Seleciona somente os produtos do cardápio que o fornecedor
         -- pode fornecedor
   --
         IF v_array_fornecedor <> '0' THEN
      v_sql_produto := v_sql_produto || ' AND pro.idpro IN (
         SELECT cop.idpro
            FROM alimentos.contrato con
          ,alimentos.contrato_produto cop
                  WHERE cop.idcon = con.idcon
                AND con.cancelado = ''N''
                AND con.finalizado = ''S''
                AND con.ultimo_contrato = ''S''
                AND con.idfor IN (' || v_array_fornecedor || ')
                  AND cop.qtde_remessa < cop.qtde_contratada
                  AND cop.idpro = pro.idpro)';
         END IF;

         v_sql_produto := v_sql_produto || '
      AND uni.iduni = ' || v_reg_unidade.iduni || '
            AND car.finalizado = ''S''
            AND car.idcli = ''' || v_id_cliente || '''
            AND car.dt_cardapio = ''' || v_dt_cardapio_ini_x || '''
            ORDER BY TRIM(pro.nome_compra)';

         --
         -- Obtém os produtos do cardápio utilizados pela unidade
         --

         FOR v_reg_produto IN EXECUTE v_sql_produto LOOP

            RAISE NOTICE '                                          ';
            RAISE NOTICE '3º Loop Produto(%)',v_reg_produto.nome_compra;

            --
            -- GRAVA LOG
            --
            UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n      3º Loop Produto ' || TRIM(TO_CHAR(v_reg_produto.idpro, '9999999999')) || '-' || v_reg_produto.nome_compra WHERE idlogguia = v_id_log;

            v_existe_produto := v_existe_produto + 1;

            --
            -- Calcula a qtde percapita necessária do produto para o período
            --

            v_dt_cardapio_ini_y := TO_NUMBER(TO_CHAR(v_dt_cardapio_ini_x, 'YYYYMMDD'),'99999999');

            select INTO v_qtde_produto_periodo alimentos.fcn_calcular_qtde_percapita (v_id_cliente, v_reg_unidade.iduni, v_reg_produto.idpro, v_dt_cardapio_ini_y, v_dt_cardapio_ini_y);

            --
            --
            -- Calcula a qtde necessária para o produto e para a unidade considerando
            -- os inscritos/matriculados
            --
            if v_inscritos = 'S' THEN
               v_qtde_necessaria := v_qtde_produto_periodo * v_num_inscritos * v_reg_produto.fator_correcao * v_reg_produto.fator_coccao;
            ELSE
               v_qtde_necessaria := v_qtde_produto_periodo * v_num_matriculados * v_reg_produto.fator_correcao * v_reg_produto.fator_coccao;
            END IF;

            --
            -- Divide qtde total em gramas pelo peso da unidade do produto
            --
            v_qtde_necessaria := ROUND(v_qtde_necessaria / v_reg_produto.peso);

            --
            -- Obtém qtde do produto já gerado em outras guias
            --
            v_qtde_guia_produto := 0;

            SELECT INTO v_qtde_guia_produto COALESCE(SUM(qtde),0)
               FROM alimentos.guia_produto_diario
               WHERE idpro = v_reg_produto.idpro
               AND iduni = v_reg_unidade.iduni
               AND dt_guia = v_dt_cardapio_ini_x;

            v_qtde_necessaria_saldo:=v_qtde_necessaria - v_qtde_guia_produto;


            --
            -- GRAVA LOG
            --
            UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      Qtde per capita: ' || TRIM(TO_CHAR(v_qtde_produto_periodo, '9999999999.99')) WHERE idlogguia = v_id_log;

            UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      Fator correção: ' || TRIM(TO_CHAR(v_reg_produto.fator_correcao, '9999999999.99')) WHERE idlogguia = v_id_log;

            UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      Fator cocção: ' || TRIM(TO_CHAR(v_reg_produto.fator_coccao, '9999999999.99')) WHERE idlogguia = v_id_log;

            UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      Peso: ' || TRIM(TO_CHAR(v_reg_produto.peso, '9999999999.99')) WHERE idlogguia = v_id_log;
            UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      Qtde necessária: ' || TRIM(TO_CHAR(v_qtde_necessaria, '9999999999.99')) WHERE idlogguia = v_id_log;

            RAISE NOTICE 'Qtde per capita(%)',v_qtde_produto_periodo;
            RAISE NOTICE 'Fator correção(%)',v_reg_produto.fator_correcao;
            RAISE NOTICE 'Fator cocção(%)',v_reg_produto.fator_coccao;
            RAISE NOTICE 'Peso(%)',v_reg_produto.peso;
            RAISE NOTICE 'Qtde Necessária(%)',v_qtde_necessaria;

            --
            -- Obtém qtde do produto em contrato, incluindo
            -- todos os fornecedores autorizados a fornecer para a unidade
            -- e que tenham produtos a fornecer (qtde remessa < qtde contrato)
            -- ou qtde remessa = qtde_contrato (estoque zerado) e contrato vigente porque
            -- possuem outros produtos a fornecer
            --
            v_sql_fornecedor := 'SELECT con.idfor as idfor
               ,COALESCE(SUM(cop.qtde_contratada-cop.qtde_remessa),0) as qtde
               ,SUM(cop.qtde_contratada) as qtde_contratada
               FROM alimentos.contrato con
                   ,alimentos.contrato_produto cop
               WHERE con.idcon = cop.idcon
         AND con.cancelado = ''N''
         AND con.finalizado = ''S''
         AND con.ultimo_contrato = ''S''
         AND con.idfor IN (SELECT idfor
                  FROM alimentos.fornecedor_unidade_atendida
                  WHERE iduni = ' || v_reg_unidade.iduni || ')
               AND (cop.qtde_remessa < cop.qtde_contratada
               OR  (cop.qtde_remessa  = cop.qtde_contratada
               AND (SELECT COALESCE(SUM(cop2.qtde_contratada-cop2.qtde_remessa),0)
                       FROM alimentos.contrato_produto cop2
                       WHERE cop2.idcon = con.idcon
                       AND cop2.idpro <> ' ||  v_reg_produto.idpro || ' ) > 0 ))
               AND cop.idpro = ' || v_reg_produto.idpro || '
               GROUP BY con.idfor ';

            v_qtde_total_contrato := 0;
            v_existe_forn := 0;

            FOR v_reg_fornecedor IN EXECUTE v_sql_fornecedor LOOP
               v_existe_forn := 1;
               v_qtde_total_contrato:= v_qtde_total_contrato + v_reg_fornecedor.qtde_contratada;
            END LOOP;

            RAISE NOTICE 'Qtde total contrato(%)',v_qtde_total_contrato;

            --
            -- GRAVA LOG
            --
            UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      Qtde total contrato: ' || TRIM(TO_CHAR(v_qtde_total_contrato, '9999999999.99')) WHERE idlogguia = v_id_log;

            --
            -- Testa se fornecedor tem contrato e autorização para fornecer para a
            -- unidade
            --
            IF v_existe_forn = 0 THEN

               --
               -- GRAVA LOG
               --
               UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      *** existe forn: N ***' WHERE idlogguia = v_id_log;

               RETURN '-1 Produto: ' || v_reg_produto.nome_compra || ' não tem contrato ou o fornecedor contratado não está autorizado a fornecer para a unidade ' || v_reg_unidade.nome || '.';

            END IF;

            --
            -- Qtde necessária deve ser > 0
            --
            IF v_qtde_necessaria > 0 THEN

               --
               -- Calcula a quantidade a ser fornecida por cada fornecedor
               --

               -- PREPARA SELECT
               v_sql_fornecedor := 'SELECT con.idcon as idcon
                  ,con.idfor as idfor
                  ,TRIM(con.codigo) as codigo
                  ,cop.qtde_contratada as qtde_contratada
                  ,cop.qtde_remessa as qtde_remessa
                  ,cop.idcop as idcop
                  ,TRIM(forn.nome_fantasia) as nome
                  FROM  alimentos.contrato con
                       ,alimentos.contrato_produto cop
                       ,alimentos.fornecedor forn
                  WHERE con.idcon = cop.idcon
                  AND con.idfor = forn.idfor
                  AND     con.cancelado = ''N''
                  AND     con.finalizado = ''S''
                  AND con.ultimo_contrato = ''S''';

               IF v_array_fornecedor <> '0' THEN
                  v_sql_fornecedor := v_sql_fornecedor || ' AND con.idfor IN (' || v_array_fornecedor || ')';
               END IF;

               v_sql_fornecedor := v_sql_fornecedor || ' AND con.idfor IN
                  (SELECT idfor
                      FROM alimentos.fornecedor_unidade_atendida
                      WHERE iduni = ' || v_reg_unidade.iduni || ')
                      AND cop.qtde_remessa < cop.qtde_contratada
                      AND cop.idpro = ' || v_reg_produto.idpro;

               v_qtde_disponivel := 0;
               v_existe_estoque := 0;

               -- EXECUTA SELECT PREPARADO
               FOR v_reg_fornecedor IN EXECUTE v_sql_fornecedor LOOP

                  RAISE NOTICE '                                          ';
                  RAISE NOTICE '4º Loop Fornecedor(%)',v_reg_fornecedor.nome;

                  --
                  -- GRAVA LOG
                  --
                  UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n           4º Loop Fornecedor ' || TRIM(TO_CHAR(v_reg_fornecedor.idfor, '9999999999')) || '-' || v_reg_fornecedor.nome || ' Contrato: ' || v_reg_fornecedor.codigo  WHERE idlogguia = v_id_log;

                  v_existe_estoque := 1;

                  v_qtde_disponivel:=COALESCE(v_reg_fornecedor.qtde_contratada- v_reg_fornecedor.qtde_remessa,0);

                  v_percentual_forn:=(v_reg_fornecedor.qtde_contratada * 100) / v_qtde_total_contrato;

                  v_qtde_forn:=ROUND((v_qtde_necessaria * v_percentual_forn) / 100 );

                  --
                  -- Verifica quantidade de saldo a ser fornecida é < 0
                  -- Deve ser verificado por questões de arredondamento,
                  -- evitando enviar uma qtde maior que a necessária

                  v_qtde_nec_saldo_ant := v_qtde_necessaria_saldo;
                  v_qtde_necessaria_saldo:=v_qtde_necessaria_saldo - v_qtde_forn;

                  RAISE NOTICE 'Qtde disponível(%)',v_qtde_disponivel;
                  RAISE NOTICE 'Percentual(%)',v_percentual_forn;
                  RAISE NOTICE 'Qtde a fornecer(%)',v_qtde_forn;

                  --
                  -- GRAVA LOG
                  --
                  UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || '  \n           Qtde disponível: ' || TRIM(TO_CHAR(v_qtde_disponivel, '9999999999.99')) WHERE idlogguia = v_id_log;

                  UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || '  \n           Percentual: ' || TRIM(TO_CHAR(v_percentual_forn, '9999999999.9999999999')) WHERE idlogguia = v_id_log;

                  UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || '  \n           Qtde a fornecer: ' || TRIM(TO_CHAR(v_qtde_forn, '9999999999')) WHERE idlogguia = v_id_log;

                  IF v_qtde_necessaria_saldo < 0 THEN

                     v_qtde_forn := v_qtde_nec_saldo_ant;
                     RAISE NOTICE 'Qtde a fornecer ajustada(%)',v_qtde_forn;

                     --
                     -- GRAVA LOG
                     --
                     UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || '  \n           Qtde a fornecer ajustada: ' || TRIM(TO_CHAR(v_qtde_forn, '9999999999')) WHERE idlogguia = v_id_log;

                  END IF;

                  --
                  -- Qtde a ser fornecida do produto deve ser maior que zero
                  -- Qtde disponível > qtde a ser fornecida

                  IF v_qtde_forn > 0 AND v_qtde_disponivel >= v_qtde_forn THEN

                     --
                     -- Grava a Guia de Remessa para a Unidade, Forn, Produto
                     -- e Contrato
                     --
                     v_id_guia:=0;
                     -- Verifica se existe guia gravada
                     SELECT INTO v_id_guia gui.idgui
                        FROM alimentos.guia_remessa gui
                        WHERE gui.iduni = v_reg_unidade.iduni
                        AND gui.idfor = v_reg_fornecedor.idfor
                        AND gui.idcon = v_reg_fornecedor.idcon
                        AND gui.classe_produto = COALESCE (v_classe, gui.classe_produto)
                        AND gui.situacao = 'E'
                        AND gui.dt_cardapio_inicial  = v_dt_cardapio_ini
                        AND gui.dt_cardapio_final = v_dt_cardapio_fim FOR UPDATE;

                     IF v_id_guia IS NULL THEN

                        -- Obtém ID próxima guia
                        v_id_guia := nextval( 'alimentos.guia_remessa_idgui_seq'::text);

                        IF v_inscritos = 'S' THEN
                           v_num_inscr_matr := v_num_inscritos;
                        ELSE
                           v_num_inscr_matr := v_num_matriculados;
                        END IF;

                        v_classe_aux := v_classe;
                        IF v_classe IS NULL THEN
                           v_classe_aux := 'PN';
                        END IF;

                        -- Obtém o próximo sequencial anual para guia
                        SELECT INTO v_sequencial
                           COALESCE(MAX(sequencial),0) + 1
                           FROM alimentos.guia_remessa gui
                           WHERE gui.ano = TO_NUMBER(TO_CHAR(CURRENT_TIMESTAMP, 'YYYY'),'9999')
                           AND gui.idcli = v_id_cliente;

                        --
                        -- GRAVA LOG
                        --
                        UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n           ID Nova guia: ' || TRIM(TO_CHAR(v_id_guia, '9999999999')) || ' Sequencial: ' || TRIM(TO_CHAR(v_sequencial, '9999999999')) WHERE idlogguia = v_id_log;

                        INSERT INTO alimentos.guia_remessa
         (idgui
                           ,idcon
                           ,login_emissao
                           ,idfor
                           ,iduni
                           ,idcli
                           ,dt_emissao
                           ,ano
                           ,sequencial
                           ,dt_cardapio_inicial
                           ,dt_cardapio_final
                           ,num_inscr_matr
                           ,num_refeicao
                           ,situacao
                           ,classe_produto)
                           VALUES (v_id_guia
                           ,v_reg_fornecedor.idcon
                           ,v_login
                           ,v_reg_fornecedor.idfor
                           ,v_reg_unidade.iduni
                           ,v_id_cliente
                           ,CURRENT_TIMESTAMP
                           ,TO_NUMBER(TO_CHAR(CURRENT_TIMESTAMP,'YYYY'),'9999')
                           ,v_sequencial
                           ,v_dt_cardapio_ini
                           ,v_dt_cardapio_fim
                           ,v_num_inscr_matr
                           ,v_num_refeicao
                           ,'E'
                           ,v_classe_aux);

                        v_qtde_guia := v_qtde_guia + 1;

                     END IF;

                     v_id_guia_produto:=0;
                     -- Verifica se produto já existe na guia
                     SELECT INTO v_id_guia_produto gup.idgup
                        FROM alimentos.guia_remessa_produto gup
                            ,alimentos.guia_remessa gui
                        WHERE gui.idgui = gup.idgui
                        AND gup.idpro = v_reg_produto.idpro
                        AND TRIM(gui.login_emissao) = TRIM(v_login)
                        AND gui.idgui = v_id_guia FOR UPDATE;

                     v_peso := v_reg_produto.peso;

                     IF v_peso = 0 THEN
                        v_peso := 1;
                     END IF;

                     IF v_id_guia_produto IS NULL THEN

                        --
                        -- GRAVA LOG
                        --
                        UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n           *** Novo produto na guia ***   ID Guia:  ' || TRIM(TO_CHAR(v_id_guia, '9999999999')) || ' *** ' WHERE idlogguia = v_id_log;

                        -- Insere novo produto na guia
                        INSERT INTO alimentos.guia_remessa_produto (
                            idgui
                           ,idpro
                           ,qtde_per_capita
                           ,qtde_guia
                           ,peso
                           ,qtde_recebida
                           ,peso_total)
                           VALUES(v_id_guia
                           ,v_reg_produto.idpro
                           ,v_reg_produto.qtde
                           ,v_qtde_forn
                           ,v_peso
                           ,0
                           ,ROUND((v_qtde_forn*v_peso),3));

                     ELSE

                        --
                        -- GRAVA LOG
                        --
                        UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n           Update ID guia_produto: ' || TRIM(TO_CHAR(v_id_guia_produto, '9999999999')) || '   ID Guia: ' || TRIM(TO_CHAR(v_id_guia, '9999999999')) WHERE idlogguia = v_id_log;

                        UPDATE alimentos.guia_remessa_produto
                           SET qtde_guia = (qtde_guia + v_qtde_forn)
                           ,peso_total = ROUND(((qtde_guia + v_qtde_forn)*v_peso),3)
                           WHERE idgup = v_id_guia_produto;

                     END IF;

                     --
                     -- Grava guia_produto_diario.
                     -- Armazena a qtde a ser fornecida do produto em uma data
                     -- e unidade, ou seja, diariamente.
                     --
                     INSERT INTO alimentos.guia_produto_diario
                        (idgui
                        ,idpro
                        ,iduni
                        ,dt_guia
                        ,qtde)
                        VALUES
                        (v_id_guia
                        ,v_reg_produto.idpro
                        ,v_reg_unidade.iduni
                        ,v_dt_cardapio_ini_x
                        ,v_qtde_forn);

                     --
                     -- Diminui estoque do produto
                     --
                     UPDATE alimentos.produto
                        SET qtde_estoque = ROUND((qtde_estoque - v_qtde_forn),2)
                        WHERE idpro = v_reg_produto.idpro;

                     --
                     -- Aumenta quantidade de remessa emitida para o contrato
                     --
                     UPDATE alimentos.contrato_produto
                        SET qtde_remessa = ROUND((qtde_remessa + v_qtde_forn),2)
                        WHERE idcop = v_reg_fornecedor.idcop;

                  ELSE

                     IF v_qtde_disponivel < v_qtde_forn THEN

                        --
                        -- GRAVA LOG
                        --
                        UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n           *** Estoque insuficiente ***' WHERE idlogguia = v_id_log;

                        RETURN '-1 Fornecedor: ' ||  v_reg_fornecedor.nome || ' está com estoque insuficiente para o produto: ' || v_reg_produto.nome_compra || '.';

                     END IF;

                  END IF;

               END LOOP;

               --
               -- Identifica que existe contrato com fornecedor, porém
               -- contrato está com estoque zerado.
               IF v_existe_estoque = 0 THEN

                  --
                  -- GRAVA LOG
                  --
                  UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n      *** Estoque zerado ***' WHERE idlogguia = v_id_log;

                  RETURN '-1 Produto: ' ||  v_reg_produto.nome_compra || ' está com estoque zerado.';

               END IF;

            END IF;

         END LOOP;

      END LOOP;

      v_dt_cardapio_ini_x := v_dt_cardapio_ini_x + interval '1 day';

   END LOOP;

   IF v_existe_produto = 0 AND v_array_fornecedor <> '0' THEN

      --
      -- GRAVA LOG
      --
      UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n     *** Fornecedor não possui produtos para fornecer no período. ***' WHERE idlogguia = v_id_log;

      RETURN '-1 Fornecedor não possui produtos para fornecer no período. Verifique os contratos elaborados com o fornecedor.';

   ELSIF v_qtde_guia > 0 THEN

      --
      -- GRAVA LOG
      --
      UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n *** GUIAS GERADAS: ' ||  TRIM(TO_CHAR(v_qtde_guia, '9999999999')) || ' ***' WHERE idlogguia = v_id_log;

      RETURN 'Foram geradas ' || REPLACE(TRIM(TO_CHAR(v_qtde_guia,'9,999,999,999')),',','.') || ' guias de remessas.';

   ELSE

      --
      -- GRAVA LOG
      --
      UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n     *** Não existem dados para gerar guias de acordo com os filtros informados. ***' WHERE idlogguia = v_id_log;

      RETURN 'Não existem dados para gerar guias de acordo com os filtros informados.';

   END IF;

END;$_$;


--
-- TOC entry 878 (class 1255 OID 9442793)
-- Name: fcn_aft_documento(); Type: FUNCTION; Schema: cadastro; Owner: -
--

CREATE FUNCTION cadastro.fcn_aft_documento() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
                DECLARE
                  v_idpes   numeric;
                  BEGIN
                    v_idpes := NEW.idpes;
                    EXECUTE E'DELETE FROM cadastro.documento WHERE ( (rg = \'0\' OR rg IS NULL) AND (idorg_exp_rg IS NULL) AND data_exp_rg IS NULL AND (sigla_uf_exp_rg IS NULL OR length(trim(sigla_uf_exp_rg))=0) AND (tipo_cert_civil = 0 OR tipo_cert_civil IS NULL) AND (num_termo = 0 OR num_termo IS NULL) AND (num_livro = \'0\' OR num_livro IS NULL) AND (num_livro = \'0\' OR num_livro IS NULL) AND (num_folha = 0 OR num_folha IS NULL) AND data_emissao_cert_civil IS NULL AND (sigla_uf_cert_civil IS NULL OR length(trim(sigla_uf_cert_civil))=0) AND (sigla_uf_cart_trabalho IS NULL OR length(trim(sigla_uf_cart_trabalho))=0) AND (cartorio_cert_civil IS NULL OR length(trim(cartorio_cert_civil))=0) AND (num_cart_trabalho = 0 OR num_cart_trabalho IS NULL) AND (serie_cart_trabalho = 0 OR serie_cart_trabalho IS NULL) AND data_emissao_cart_trabalho IS NULL AND (num_tit_eleitor = 0 OR num_tit_eleitor IS NULL) AND (zona_tit_eleitor = 0 OR zona_tit_eleitor IS NULL) AND (secao_tit_eleitor = 0 OR secao_tit_eleitor IS NULL) ) AND idpes='||quote_literal(v_idpes)||' AND certidao_nascimento is null';
                  RETURN NEW;
                END; $$;


--
-- TOC entry 879 (class 1255 OID 9442794)
-- Name: fcn_aft_documento_provisorio(); Type: FUNCTION; Schema: cadastro; Owner: -
--

CREATE FUNCTION cadastro.fcn_aft_documento_provisorio() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  DECLARE
    v_idpes       numeric;
    v_rg        text;
    v_uf_expedicao      text;
    v_verificacao_provisorio  numeric;

    v_comando     text;
    v_registro      record;

    BEGIN
      v_idpes     := NEW.idpes;
      v_rg      := COALESCE(NEW.rg, '-1');
      v_uf_expedicao    := TRIM(COALESCE(NEW.sigla_uf_exp_rg, ''));

      v_verificacao_provisorio:= 0;

      -- verificar se a situação do cadastro da pessoa é provisório
      FOR v_registro IN SELECT situacao FROM cadastro.pessoa WHERE idpes=v_idpes LOOP
        IF v_registro.situacao = 'P' THEN
          v_verificacao_provisorio := 1;
        END IF;
      END LOOP;

      -- Verificação para atualizar ou não a situação do cadastro da pessoa para Ativo
      IF LENGTH(v_uf_expedicao) > 0 AND v_rg != '' AND v_rg != '-1' AND v_verificacao_provisorio = 1 THEN
        EXECUTE 'UPDATE cadastro.pessoa SET situacao='||quote_literal('A')||'WHERE idpes='||quote_literal(v_idpes)||';';
      END IF;
    RETURN NEW;
  END; $$;


--
-- TOC entry 881 (class 1255 OID 9442795)
-- Name: fcn_aft_fisica(); Type: FUNCTION; Schema: cadastro; Owner: -
--

CREATE FUNCTION cadastro.fcn_aft_fisica() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes       numeric;
  v_idpes_mae     numeric;
  v_idpes_pai     numeric;
  v_idpes_responsavel   numeric;
  v_idpes_conjuge     numeric;

  v_nome_mae      text;
  v_nome_pai      text;
  v_nome_responsavel    text;
  v_nome_conjuge      text;

  v_verificacao_mae   numeric;
  v_verificacao_pai   numeric;
  v_verificacao_conjuge   numeric;
  v_verificacao_responsavel numeric;

  v_num_aviso_mae     numeric;
  v_num_aviso_pai     numeric;
  v_num_aviso_conjuge   numeric;
  v_num_aviso_responsavel   numeric;

  v_existe_aviso_mae    numeric;
  v_existe_aviso_pai    numeric;
  v_existe_aviso_conjuge    numeric;
  v_existe_aviso_responsavel  numeric;

  v_comando     text;
  v_registro      record;

  BEGIN
    v_idpes     := NEW.idpes;
    v_idpes_mae   := NEW.idpes_mae;
    v_idpes_pai   := NEW.idpes_pai;
    v_idpes_responsavel := NEW.idpes_responsavel;
    v_idpes_conjuge   := NEW.idpes_con;
    v_nome_mae    := TRIM(NEW.nome_mae);
    v_nome_pai    := TRIM(NEW.nome_pai);
    v_nome_responsavel  := TRIM(NEW.nome_responsavel);
    v_nome_conjuge    := TRIM(NEW.nome_conjuge);

    v_num_aviso_mae   := 1;
    v_num_aviso_pai   := 2;
    v_num_aviso_conjuge := 3;
    v_num_aviso_responsavel := 4;

    v_verificacao_mae   := 0;
    v_verificacao_pai   := 0;
    v_verificacao_conjuge   := 0;
    v_verificacao_responsavel := 0;

    v_existe_aviso_mae    := 0;
    v_existe_aviso_pai    := 0;
    v_existe_aviso_conjuge    := 0;
    v_existe_aviso_responsavel  := 0;

    -- obter os avisos já existentes para a pessoa
    FOR v_registro IN SELECT aviso FROM cadastro.aviso_nome WHERE idpes=v_idpes LOOP
      IF v_registro.aviso = 1 THEN
        v_existe_aviso_mae := 1;
      ELSIF v_registro.aviso = 2 THEN
        v_existe_aviso_pai := 1;
      ELSIF v_registro.aviso = 3 THEN
        v_existe_aviso_conjuge := 1;
      ELSIF v_registro.aviso = 4 THEN
        v_existe_aviso_responsavel := 1;
      END IF;
    END LOOP;

    -- MAE
    IF v_idpes_mae > 0 AND v_idpes_mae IS NOT NULL AND LENGTH(v_nome_mae) > 0 AND v_nome_mae IS NOT NULL THEN
      FOR v_registro IN SELECT * from public.fcn_compara_nome_pessoa_fonetica(v_nome_mae, v_idpes_mae) LOOP
        v_verificacao_mae := v_registro.fcn_compara_nome_pessoa_fonetica;
      END LOOP;
    ELSE
      v_verificacao_mae := 1;
    END IF;

    -- PAI
    IF v_idpes_pai > 0 AND v_idpes_pai IS NOT NULL AND LENGTH(v_nome_pai) > 0 AND v_nome_pai IS NOT NULL THEN
      FOR v_registro IN SELECT * from public.fcn_compara_nome_pessoa_fonetica(v_nome_pai, v_idpes_pai) LOOP
        v_verificacao_pai := v_registro.fcn_compara_nome_pessoa_fonetica;
      END LOOP;
    ELSE
      v_verificacao_pai := 1;
    END IF;

    -- CONJUGE
    IF v_idpes_conjuge > 0 AND v_idpes_conjuge IS NOT NULL AND LENGTH(v_nome_conjuge) > 0 AND v_nome_conjuge IS NOT NULL THEN
      FOR v_registro IN SELECT * from public.fcn_compara_nome_pessoa_fonetica(v_nome_conjuge, v_idpes_conjuge) LOOP
        v_verificacao_conjuge := v_registro.fcn_compara_nome_pessoa_fonetica;
      END LOOP;
    ELSE
      v_verificacao_conjuge := 1;
    END IF;

    -- RESPONSAVEL
    IF v_idpes_responsavel > 0 AND v_idpes_responsavel IS NOT NULL AND LENGTH(v_nome_responsavel) > 0 AND v_nome_responsavel IS NOT NULL THEN
      FOR v_registro IN SELECT * from public.fcn_compara_nome_pessoa_fonetica(v_nome_responsavel, v_idpes_responsavel) LOOP
        v_verificacao_responsavel := v_registro.fcn_compara_nome_pessoa_fonetica;
      END LOOP;
    ELSE
      v_verificacao_responsavel := 1;
    END IF;
    -- Inserir ou Deletar aviso da MAE
    IF v_verificacao_mae = 0 AND v_existe_aviso_mae = 0 THEN
      EXECUTE 'INSERT INTO cadastro.aviso_nome (idpes, aviso) VALUES ('||quote_literal(v_idpes)||','||v_num_aviso_mae||');';
    ELSIF v_verificacao_mae = 1 AND v_existe_aviso_mae = 1 THEN
      EXECUTE 'DELETE FROM cadastro.aviso_nome WHERE idpes='||quote_literal(v_idpes)||' AND aviso='||v_num_aviso_mae||';';
    END IF;

    -- Inserir ou Deletar aviso do PAI
    IF v_verificacao_pai = 0 AND v_existe_aviso_pai = 0 THEN
      EXECUTE 'INSERT INTO cadastro.aviso_nome (idpes, aviso) VALUES ('||quote_literal(v_idpes)||','||v_num_aviso_pai||');';
    ELSIF v_verificacao_pai = 1 AND v_existe_aviso_pai = 1 THEN
      EXECUTE 'DELETE FROM cadastro.aviso_nome WHERE idpes='||quote_literal(v_idpes)||' AND aviso='||v_num_aviso_pai||';';
    END IF;

    -- Inserir ou Deletar aviso do CONJUGE
    IF v_verificacao_conjuge = 0 AND v_existe_aviso_conjuge = 0 THEN
      EXECUTE 'INSERT INTO cadastro.aviso_nome (idpes, aviso) VALUES ('||quote_literal(v_idpes)||','||v_num_aviso_conjuge||');';
    ELSIF v_verificacao_conjuge = 1 AND v_existe_aviso_conjuge = 1 THEN
      EXECUTE 'DELETE FROM cadastro.aviso_nome WHERE idpes='||quote_literal(v_idpes)||' AND aviso='||v_num_aviso_conjuge||';';
    END IF;

    -- Inserir ou Deletar aviso do RESPONSAVEL
    IF v_verificacao_responsavel = 0 AND v_existe_aviso_responsavel = 0 THEN
      EXECUTE 'INSERT INTO cadastro.aviso_nome (idpes, aviso) VALUES ('||quote_literal(v_idpes)||','||v_num_aviso_responsavel||');';
    ELSIF v_verificacao_responsavel = 1 AND v_existe_aviso_responsavel = 1 THEN
      EXECUTE 'DELETE FROM cadastro.aviso_nome WHERE idpes='||quote_literal(v_idpes)||' AND aviso='||v_num_aviso_responsavel||';';
    END IF;
  RETURN NEW;
END; $$;


--
-- TOC entry 882 (class 1255 OID 9442796)
-- Name: fcn_aft_fisica_cpf_provisorio(); Type: FUNCTION; Schema: cadastro; Owner: -
--

CREATE FUNCTION cadastro.fcn_aft_fisica_cpf_provisorio() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes       numeric;
  v_cpf       numeric;
  v_verificacao_provisorio  numeric;

  v_comando     text;
  v_registro      record;

  BEGIN
    v_idpes     := NEW.idpes;
    v_cpf     := COALESCE(NEW.cpf, -1);

    v_verificacao_provisorio:= 0;

    -- verificar se a situação do cadastro da pessoa é provisório
    FOR v_registro IN SELECT situacao FROM cadastro.pessoa WHERE idpes=v_idpes LOOP
      IF v_registro.situacao = 'P' THEN
        v_verificacao_provisorio := 1;
      END IF;
    END LOOP;

    -- Verificação para atualizar ou não a situação do cadastro da pessoa para Ativo
    IF v_cpf > 0 AND v_verificacao_provisorio = 1 THEN
      EXECUTE 'UPDATE cadastro.pessoa SET situacao='||quote_literal('A')||'WHERE idpes='||quote_literal(v_idpes)||';';
    END IF;
  RETURN NEW;
END; $$;


--
-- TOC entry 883 (class 1255 OID 9442797)
-- Name: fcn_aft_fisica_provisorio(); Type: FUNCTION; Schema: cadastro; Owner: -
--

CREATE FUNCTION cadastro.fcn_aft_fisica_provisorio() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes       numeric;
  v_idpes_mae     numeric;
  v_nome_mae      text;
  v_data_nascimento   text;
  v_verificacao_provisorio  numeric;

  v_comando     text;
  v_registro      record;

  BEGIN
    v_idpes     := NEW.idpes;
    v_idpes_mae   := COALESCE(NEW.idpes_mae, -1);
    v_nome_mae    := TRIM(COALESCE(NEW.nome_mae, ''));
    v_data_nascimento := COALESCE(TO_CHAR(NEW.data_nasc, 'DD/MM/YYYY'), '');

    v_verificacao_provisorio:= 0;

    -- verificar se a situação do cadastro da pessoa é provisório
    FOR v_registro IN SELECT situacao FROM cadastro.pessoa WHERE idpes=v_idpes LOOP
      IF v_registro.situacao = 'P' THEN
        v_verificacao_provisorio := 1;
      END IF;
    END LOOP;

    -- Verificação para atualizar ou não a situação do cadastro da pessoa para Ativo
    IF v_data_nascimento <> '' AND (LENGTH(v_nome_mae) > 0 OR v_idpes_mae > 0) AND v_verificacao_provisorio = 1 THEN
      EXECUTE 'UPDATE cadastro.pessoa SET situacao='||quote_literal('A')||'WHERE idpes='||quote_literal(v_idpes)||';';
    END IF;
  RETURN NEW;
END; $$;


--
-- TOC entry 884 (class 1255 OID 9442798)
-- Name: fcn_aft_ins_endereco_externo(); Type: FUNCTION; Schema: cadastro; Owner: -
--

CREATE FUNCTION cadastro.fcn_aft_ins_endereco_externo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes   numeric;
  v_tipo_endereco text;
  BEGIN
    v_idpes   := NEW.idpes;
    v_tipo_endereco := NEW.tipo;
    EXECUTE 'DELETE FROM cadastro.endereco_pessoa WHERE idpes='||quote_literal(v_idpes)||' AND tipo='||v_tipo_endereco||';';
  RETURN NEW;
END; $$;


--
-- TOC entry 875 (class 1255 OID 9442799)
-- Name: fcn_aft_ins_endereco_pessoa(); Type: FUNCTION; Schema: cadastro; Owner: -
--

CREATE FUNCTION cadastro.fcn_aft_ins_endereco_pessoa() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes   numeric;
  v_tipo_endereco text;
  BEGIN
    v_idpes   := NEW.idpes;
    v_tipo_endereco := NEW.tipo;
    EXECUTE 'DELETE FROM cadastro.endereco_externo WHERE idpes='||quote_literal(v_idpes)||' AND tipo='||v_tipo_endereco||';';
  RETURN NEW;
END; $$;


--
-- TOC entry 880 (class 1255 OID 9442800)
-- Name: fcn_delete_temp_cadastro_unificacao_cmf(integer); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_delete_temp_cadastro_unificacao_cmf(integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parametro recebidos
  v_idpes ALIAS for $1;
BEGIN
  -- Deleta dados da tabela temp_cadastro_unificacao_cmf
  DELETE FROM consistenciacao.temp_cadastro_unificacao_cmf WHERE idpes = v_idpes;
  RETURN 0;
END;$_$;


--
-- TOC entry 852 (class 1255 OID 9442801)
-- Name: fcn_delete_temp_cadastro_unificacao_siam(integer); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_delete_temp_cadastro_unificacao_siam(integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parametro recebidos
  v_idpes ALIAS for $1;
BEGIN
  -- Deleta dados da tabela temp_cadastro_unificacao_siam
  DELETE FROM consistenciacao.temp_cadastro_unificacao_siam WHERE idpes = v_idpes;
  RETURN 0;
END;$_$;


--
-- TOC entry 853 (class 1255 OID 9442802)
-- Name: fcn_documento_historico_campo(); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_documento_historico_campo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
                        DECLARE
                          v_idpes         numeric;

                          v_data_expedicao_rg_nova    date;
                          v_data_expedicao_rg_antiga    date;
                          v_data_emissao_cert_civil_nova    date;
                          v_data_emissao_cert_civil_antiga  date;
                          v_data_emissao_cart_trabalho_nova date;
                          v_data_emissao_cart_trabalho_antiga date;
                          v_orgao_expedicao_rg_novo   numeric;
                          v_orgao_expedicao_rg_antigo   numeric;
                          v_numero_rg_novo      text;
                          v_numero_rg_antigo      text;
                          v_numero_titulo_eleitor_novo    numeric;
                          v_numero_titulo_eleitor_antigo    numeric;
                          v_numero_zona_titulo_novo   numeric;
                          v_numero_zona_titulo_antigo   numeric;
                          v_numero_secao_titulo_novo    numeric;
                          v_numero_secao_titulo_antigo    numeric;
                          v_numero_cart_trabalho_novo   numeric;
                          v_numero_cart_trabalho_antigo   numeric;
                          v_numero_serie_cart_trabalho_novo numeric;
                          v_numero_serie_cart_trabalho_antigo numeric;
                          v_tipo_certidao_civil_novo    numeric;
                          v_tipo_certidao_civil_antigo    numeric;
                          v_numero_termo_certidao_civil_novo  numeric;
                          v_numero_termo_certidao_civil_antigo  numeric;
                          v_numero_livro_certidao_civil_novo  varchar;
                          v_numero_livro_certidao_civil_antigo  varchar;
                          v_numero_folha_certidao_civil_novo  numeric;
                          v_numero_folha_certidao_civil_antigo  numeric;
                          v_cartorio_certidao_civil_novo    text;
                          v_cartorio_certidao_civil_antigo  text;
                          v_uf_expedicao_rg_novo      text;
                          v_uf_expedicao_rg_antigo    text;
                          v_uf_emissao_certidao_civil_novo  text;
                          v_uf_emissao_certidao_civil_antigo  text;
                          v_uf_emissao_carteira_trabalho_novo text;
                          v_uf_emissao_carteira_trabalho_antigo text;

                          v_comando     text;
                          v_origem_gravacao   text;

                          v_credibilidade_maxima    numeric;
                          v_credibilidade_alta    numeric;
                          v_sem_credibilidade   numeric;

                          v_nova_credibilidade    numeric;

                          v_registro      record;
                          v_aux_data_nova     text;
                          v_aux_data_antiga   text;

                          -- ID dos campos
                          v_idcam_numero_rg     numeric;
                          v_idcam_orgao_expedidor_rg    numeric;
                          v_idcam_data_expedicao_rg   numeric;
                          v_idcam_uf_expedicao_rg     numeric;
                          v_idcam_tipo_certidao_civil   numeric;
                          v_idcam_numero_termo_certidao_civil numeric;
                          v_idcam_numero_livro_certidao_civil numeric;
                          v_idcam_numero_folha_certidao_civil numeric;
                          v_idcam_data_emissao_certidao_civil numeric;
                          v_idcam_cartorio_certidao_civil        numeric;
                          v_idcam_uf_emissao_certidao_civil numeric;
                          v_idcam_numero_carteira_trabalho  numeric;
                          v_idcam_numero_serie_carteira_trabalho  numeric;
                          v_idcam_data_emissao_carteira_trabalho  numeric;
                          v_idcam_uf_emissao_carteira_trabalho  numeric;
                          v_idcam_numero_titulo_eleitor   numeric;
                          v_idcam_numero_zona_titulo_eleitor  numeric;
                          v_idcam_numero_secao_titulo_eleitor numeric;

                          /*
                          consistenciacao.historico_campo.credibilidade: 1 = Maxima, 2 = Alta, 3 = Media, 4 = Baixa, 5 = Sem credibilidade
                          cadastro.pessoa.origem_gravacao: M = Migracao, U = Usuario, C = Rotina de confrontacao, O = Oscar
                          */
                          BEGIN
                            v_idpes         := NEW.idpes;

                            v_data_expedicao_rg_nova    := NEW.data_exp_rg;
                            v_data_emissao_cert_civil_nova    := NEW.data_emissao_cert_civil;
                            v_data_emissao_cart_trabalho_nova := NEW.data_emissao_cart_trabalho;
                            v_orgao_expedicao_rg_novo   := NEW.idorg_exp_rg;
                            v_numero_rg_novo      := NEW.rg;
                            v_numero_titulo_eleitor_novo    := NEW.num_tit_eleitor;
                            v_numero_zona_titulo_novo   := NEW.zona_tit_eleitor;
                            v_numero_secao_titulo_novo    := NEW.secao_tit_eleitor;
                            v_numero_cart_trabalho_novo   := NEW.num_cart_trabalho;
                            v_numero_serie_cart_trabalho_novo := NEW.serie_cart_trabalho;
                            v_tipo_certidao_civil_novo    := NEW.tipo_cert_civil;
                            v_numero_termo_certidao_civil_novo  := NEW.num_termo;
                            v_numero_livro_certidao_civil_novo  := NEW.num_livro;
                            v_numero_folha_certidao_civil_novo  := NEW.num_folha;
                            v_cartorio_certidao_civil_novo    := NEW.cartorio_cert_civil;
                            v_uf_expedicao_rg_novo      := NEW.sigla_uf_exp_rg;
                            v_uf_emissao_certidao_civil_novo  := NEW.sigla_uf_cert_civil;
                            v_uf_emissao_carteira_trabalho_novo := NEW.sigla_uf_cart_trabalho;

                            IF TG_OP <> 'UPDATE' THEN
                              v_data_expedicao_rg_antiga    := NULL;
                              v_data_emissao_cert_civil_antiga  := NULL;
                              v_data_emissao_cart_trabalho_antiga := NULL;
                              v_orgao_expedicao_rg_antigo   := 0;
                              v_numero_rg_antigo      := '';
                              v_numero_titulo_eleitor_antigo    := 0;
                              v_numero_zona_titulo_antigo   := 0;
                              v_numero_secao_titulo_antigo    := 0;
                              v_numero_cart_trabalho_antigo   := 0;
                              v_numero_serie_cart_trabalho_antigo := 0;
                              v_tipo_certidao_civil_antigo    := 0;
                              v_numero_termo_certidao_civil_antigo  := 0;
                              v_numero_livro_certidao_civil_antigo  := '';
                              v_numero_folha_certidao_civil_antigo  := 0;
                              v_cartorio_certidao_civil_antigo  := '';
                              v_uf_expedicao_rg_antigo    := '';
                              v_uf_emissao_certidao_civil_antigo  := '';
                              v_uf_emissao_carteira_trabalho_antigo := '';
                            ELSE
                              v_data_expedicao_rg_antiga    := OLD.data_exp_rg;
                              v_data_emissao_cert_civil_antiga  := OLD.data_emissao_cert_civil;
                              v_data_emissao_cart_trabalho_antiga := OLD.data_emissao_cart_trabalho;
                              v_orgao_expedicao_rg_antigo   := COALESCE(OLD.idorg_exp_rg, 0);
                              v_numero_rg_antigo      := COALESCE(OLD.rg, '');
                              v_numero_titulo_eleitor_antigo    := COALESCE(OLD.num_tit_eleitor, 0);
                              v_numero_zona_titulo_antigo   := COALESCE(OLD.zona_tit_eleitor, 0);
                              v_numero_secao_titulo_antigo    := COALESCE(OLD.secao_tit_eleitor, 0);
                              v_numero_cart_trabalho_antigo   := COALESCE(OLD.num_cart_trabalho, 0);
                              v_numero_serie_cart_trabalho_antigo := COALESCE(OLD.serie_cart_trabalho, 0);
                              v_tipo_certidao_civil_antigo    := COALESCE(OLD.tipo_cert_civil, 0);
                              v_numero_termo_certidao_civil_antigo  := COALESCE(OLD.num_termo, 0);
                              v_numero_livro_certidao_civil_antigo  := OLD.num_livro;
                              v_numero_folha_certidao_civil_antigo  := COALESCE(OLD.num_folha, 0);
                              v_cartorio_certidao_civil_antigo  := COALESCE(OLD.cartorio_cert_civil, '');
                              v_uf_expedicao_rg_antigo    := COALESCE(OLD.sigla_uf_exp_rg, '');
                              v_uf_emissao_certidao_civil_antigo  := COALESCE(OLD.sigla_uf_cert_civil, '');
                              v_uf_emissao_carteira_trabalho_antigo := COALESCE(OLD.sigla_uf_cart_trabalho, '');
                            END IF;

                            v_idcam_numero_rg     := 6;
                            v_idcam_orgao_expedidor_rg    := 7;
                            v_idcam_data_expedicao_rg   := 8;
                            v_idcam_uf_expedicao_rg     := 9;
                            v_idcam_tipo_certidao_civil   := 10;
                            v_idcam_numero_termo_certidao_civil := 11;
                            v_idcam_numero_livro_certidao_civil := 12;
                            v_idcam_numero_folha_certidao_civil := 13;
                            v_idcam_data_emissao_certidao_civil := 14;
                            v_idcam_cartorio_certidao_civil   := 15;
                            v_idcam_uf_emissao_certidao_civil := 16;
                            v_idcam_numero_carteira_trabalho  := 17;
                            v_idcam_numero_serie_carteira_trabalho  := 18;
                            v_idcam_data_emissao_carteira_trabalho  := 19;
                            v_idcam_uf_emissao_carteira_trabalho  := 20;
                            v_idcam_numero_titulo_eleitor   := 21;
                            v_idcam_numero_zona_titulo_eleitor  := 22;
                            v_idcam_numero_secao_titulo_eleitor := 23;

                            v_nova_credibilidade := 0;
                            v_credibilidade_maxima := 1;
                            v_credibilidade_alta := 2;
                            v_sem_credibilidade := 5;
                            v_comando := 'SELECT origem_gravacao FROM cadastro.pessoa WHERE idpes='||quote_literal(v_idpes)||';';

                            FOR v_registro IN EXECUTE v_comando LOOP
                              v_origem_gravacao := v_registro.origem_gravacao;
                            END LOOP;

                            IF v_origem_gravacao = 'U' OR v_origem_gravacao = 'O' THEN -- os dados foram editados pelo usuario ou pelo usuario do Oscar
                              v_nova_credibilidade := v_credibilidade_maxima;
                            ELSIF v_origem_gravacao = 'M' THEN -- os dados foram originados por migracao
                              v_nova_credibilidade := v_credibilidade_alta;
                            END IF;

                            IF v_nova_credibilidade > 0 THEN

                              -- DATA DE EXPEDICAO DO RG
                              v_aux_data_nova := COALESCE(TO_CHAR (v_data_expedicao_rg_nova, 'DD/MM/YYYY'), '');
                              v_aux_data_antiga := COALESCE(TO_CHAR (v_data_expedicao_rg_antiga, 'DD/MM/YYYY'), '');

                              IF v_aux_data_nova <> v_aux_data_antiga THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_expedicao_rg||','||v_nova_credibilidade||');';
                              END IF;

                              -- DATA DE EMISSAO CERTIDAO CIVIL
                              v_aux_data_nova := COALESCE(TO_CHAR (v_data_emissao_cert_civil_nova, 'DD/MM/YYYY'), '');
                              v_aux_data_antiga := COALESCE(TO_CHAR (v_data_emissao_cert_civil_antiga, 'DD/MM/YYYY'), '');

                              IF v_aux_data_nova <> v_aux_data_antiga THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_emissao_certidao_civil||','||v_nova_credibilidade||');';
                              END IF;

                              -- DATA DE EMISSAO CARTEIRA DE TRABALHO
                              v_aux_data_nova := COALESCE(TO_CHAR (v_data_emissao_cart_trabalho_nova, 'DD/MM/YYYY'), '');
                              v_aux_data_antiga := COALESCE(TO_CHAR (v_data_emissao_cart_trabalho_antiga, 'DD/MM/YYYY'), '');

                              IF v_aux_data_nova <> v_aux_data_antiga THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_emissao_carteira_trabalho||','||v_nova_credibilidade||');';
                              END IF;

                              -- ORGAO EXPEDIDOR DO RG
                              IF v_orgao_expedicao_rg_novo <> v_orgao_expedicao_rg_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_orgao_expedidor_rg||','||v_nova_credibilidade||');';
                              END IF;

                              -- RG
                              IF v_numero_rg_novo <> v_numero_rg_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_rg||','||v_nova_credibilidade||');';
                              END IF;

                              -- TITULO ELEITOR
                              IF v_numero_titulo_eleitor_novo <> v_numero_titulo_eleitor_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_titulo_eleitor||','||v_nova_credibilidade||');';
                              END IF;

                              -- ZONA TITULO ELEITOR
                              IF v_numero_zona_titulo_novo <> v_numero_zona_titulo_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_zona_titulo_eleitor||','||v_nova_credibilidade||');';
                              END IF;

                              -- SECAO TITULO ELEITOR
                              IF v_numero_secao_titulo_novo <> v_numero_secao_titulo_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_secao_titulo_eleitor||','||v_nova_credibilidade||');';
                              END IF;

                              -- CARTEIRA DE TRABALHO
                              IF v_numero_cart_trabalho_novo <> v_numero_cart_trabalho_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_carteira_trabalho||','||v_nova_credibilidade||');';
                              END IF;

                              -- SERIE CARTEIRA DE TRABALHO
                              IF v_numero_serie_cart_trabalho_novo <> v_numero_serie_cart_trabalho_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_serie_carteira_trabalho||','||v_nova_credibilidade||');';
                              END IF;

                              -- TIPO CERTIDAO CIVIL
                              IF v_tipo_certidao_civil_novo <> v_tipo_certidao_civil_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_tipo_certidao_civil||','||v_nova_credibilidade||');';
                              END IF;

                              -- NUMERO TERMO CERTIDAO CIVIL
                              IF v_numero_termo_certidao_civil_novo <> v_numero_termo_certidao_civil_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_termo_certidao_civil||','||v_nova_credibilidade||');';
                              END IF;

                              -- NUMERO LIVRO CERTIDAO CIVIL
                              IF v_numero_livro_certidao_civil_novo <> v_numero_livro_certidao_civil_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_livro_certidao_civil||','||v_nova_credibilidade||');';
                              END IF;

                              -- NUMERO FOLHA CERTIDAO CIVIL
                              IF v_numero_folha_certidao_civil_novo <> v_numero_folha_certidao_civil_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_folha_certidao_civil||','||v_nova_credibilidade||');';
                              END IF;

                              -- CARTORIO CERTIDAO CIVIL
                              IF v_cartorio_certidao_civil_novo <> v_cartorio_certidao_civil_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cartorio_certidao_civil||','||v_nova_credibilidade||');';
                              END IF;

                              -- UF EXPEDICAO RG
                              IF v_uf_expedicao_rg_novo <> v_uf_expedicao_rg_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_uf_expedicao_rg||','||v_nova_credibilidade||');';
                              END IF;

                              -- UF EMISSAO CERTIDAO CIVIL
                              IF v_uf_emissao_certidao_civil_novo <> v_uf_emissao_certidao_civil_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_uf_emissao_certidao_civil||','||v_nova_credibilidade||');';
                              END IF;

                              -- UF EMISSAO CARTEIRA DE TRABALHO
                              IF v_uf_emissao_carteira_trabalho_novo <> v_uf_emissao_carteira_trabalho_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_uf_emissao_carteira_trabalho||','||v_nova_credibilidade||');';
                              END IF;

                            END IF;
                            -- Verificar os campos Vazios ou Nulos
                            -- DATA DE EXPEDICAO DO RG
                            IF TRIM(v_data_expedicao_rg_nova::varchar)='' OR v_data_expedicao_rg_nova IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_expedicao_rg||','||v_sem_credibilidade||');';
                            END IF;
                            -- DATA DE EMISSAO CERTIDAO CIVIL
                            IF TRIM(v_data_emissao_cert_civil_nova::varchar)='' OR v_data_emissao_cert_civil_nova IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_emissao_certidao_civil||','||v_sem_credibilidade||');';
                            END IF;
                            -- DATA DE EMISSAO CARTEIRA DE TRABALHO
                            IF TRIM(v_data_emissao_cart_trabalho_nova::varchar)='' OR v_data_emissao_cart_trabalho_nova IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_emissao_carteira_trabalho||','||v_sem_credibilidade||');';
                            END IF;
                            -- ORGAO EXPEDIDOR DO RG
                            IF v_orgao_expedicao_rg_novo <= 0 OR v_orgao_expedicao_rg_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_orgao_expedidor_rg||','||v_sem_credibilidade||');';
                            END IF;
                            -- RG
                            IF v_numero_rg_novo = '' OR v_numero_rg_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_rg||','||v_sem_credibilidade||');';
                            END IF;
                            -- TITULO ELEITOR
                            IF v_numero_titulo_eleitor_novo <= 0 OR v_numero_titulo_eleitor_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_titulo_eleitor||','||v_sem_credibilidade||');';
                            END IF;
                            -- ZONA TITULO ELEITOR
                            IF v_numero_zona_titulo_novo <= 0 OR v_numero_zona_titulo_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_zona_titulo_eleitor||','||v_sem_credibilidade||');';
                            END IF;
                            -- SECAO TITULO ELEITOR
                            IF v_numero_secao_titulo_novo <= 0 OR v_numero_secao_titulo_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_secao_titulo_eleitor||','||v_sem_credibilidade||');';
                            END IF;
                            -- CARTEIRA DE TRABALHO
                            IF v_numero_cart_trabalho_novo <= 0 OR v_numero_cart_trabalho_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_carteira_trabalho||','||v_sem_credibilidade||');';
                            END IF;
                            -- SERIE CARTEIRA DE TRABALHO
                            IF v_numero_serie_cart_trabalho_novo <= 0 OR v_numero_serie_cart_trabalho_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_serie_carteira_trabalho||','||v_sem_credibilidade||');';
                            END IF;
                            -- TIPO CERTIDAO CIVIL
                            IF v_tipo_certidao_civil_novo <= 0 OR v_tipo_certidao_civil_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_tipo_certidao_civil||','||v_sem_credibilidade||');';
                            END IF;
                            -- NUMERO TERMO CERTIDAO CIVIL
                            IF v_numero_termo_certidao_civil_novo <= 0 OR v_numero_termo_certidao_civil_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_termo_certidao_civil||','||v_sem_credibilidade||');';
                            END IF;
                            -- NUMERO LIVRO CERTIDAO CIVIL
                            IF v_numero_livro_certidao_civil_novo = '' OR v_numero_livro_certidao_civil_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_livro_certidao_civil||','||v_sem_credibilidade||');';
                            END IF;
                            -- NUMERO FOLHA CERTIDAO CIVIL
                            IF v_numero_folha_certidao_civil_novo <= 0 OR v_numero_folha_certidao_civil_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_folha_certidao_civil||','||v_sem_credibilidade||');';
                            END IF;
                            -- CARTORIO CERTIDAO CIVIL
                            IF TRIM(v_cartorio_certidao_civil_novo)='' OR v_cartorio_certidao_civil_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cartorio_certidao_civil||','||v_sem_credibilidade||');';
                            END IF;
                            -- UF EXPEDICAO RG
                            IF TRIM(v_uf_expedicao_rg_novo)='' OR v_uf_expedicao_rg_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_uf_expedicao_rg||','||v_sem_credibilidade||');';
                            END IF;
                            -- UF EMISSAO CERTIDAO CIVIL
                            IF TRIM(v_uf_emissao_certidao_civil_novo)='' OR v_uf_emissao_certidao_civil_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_uf_emissao_certidao_civil||','||v_sem_credibilidade||');';
                            END IF;
                            -- UF EMISSAO CARTEIRA DE TRABALHO
                            IF TRIM(v_uf_emissao_carteira_trabalho_novo)='' OR v_uf_emissao_carteira_trabalho_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_uf_emissao_carteira_trabalho||','||v_sem_credibilidade||');';
                            END IF;

                          RETURN NEW;
                        END;$$;


--
-- TOC entry 872 (class 1255 OID 9442805)
-- Name: fcn_endereco_externo_historico_campo(); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_endereco_externo_historico_campo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes       numeric;

  v_sigla_uf_antiga   text;
  v_sigla_uf_nova     text;
  v_id_tipo_logradouro_antigo text;
  v_id_tipo_logradouro_novo text;
  v_logradouro_antigo   text;
  v_logradouro_novo   text;
  v_numero_antigo     numeric;
  v_numero_novo     numeric;
  v_letra_antiga      text;
  v_letra_nova      text;
  v_complemento_antigo    text;
  v_complemento_novo    text;
  v_bairro_antigo     text;
  v_bairro_novo     text;
  v_cep_antigo      numeric;
  v_cep_novo      numeric;
  v_cidade_antiga     text;
  v_cidade_nova     text;

  v_tipo_endereco     numeric;

  v_comando     text;
  v_origem_gravacao   text;

  v_credibilidade_maxima    numeric;
  v_credibilidade_alta    numeric;
  v_sem_credibilidade   numeric;

  v_nova_credibilidade    numeric;

  v_registro      record;

  -- ID dos campos
  v_idcam_sigla_uf_correspondencia    numeric;
  v_idcam_id_tipo_logradouro_correspondencia  numeric;
  v_idcam_logradouro_correspondencia    numeric;
  v_idcam_numero_correspondencia      numeric;
  v_idcam_letra_correspondencia     numeric;
  v_idcam_complemento_correspondencia   numeric;
  v_idcam_bairro_correspondencia      numeric;
  v_idcam_cep_correspondencia     numeric;
  v_idcam_cidade_correspondencia      numeric;

  v_idcam_sigla_uf_residencial      numeric;
  v_idcam_id_tipo_logradouro_residencial    numeric;
  v_idcam_logradouro_residencial      numeric;
  v_idcam_numero_residencial      numeric;
  v_idcam_letra_residencial     numeric;
  v_idcam_complemento_residencial     numeric;
  v_idcam_bairro_residencial      numeric;
  v_idcam_cep_residencial       numeric;
  v_idcam_cidade_residencial      numeric;

  v_idcam_sigla_uf_comercial      numeric;
  v_idcam_id_tipo_logradouro_comercial    numeric;
  v_idcam_logradouro_comercial      numeric;
  v_idcam_numero_comercial      numeric;
  v_idcam_letra_comercial       numeric;
  v_idcam_complemento_comercial     numeric;
  v_idcam_bairro_comercial      numeric;
  v_idcam_cep_comercial       numeric;
  v_idcam_cidade_comercial      numeric;

  v_idcam_sigla_uf    numeric;
  v_idcam_id_tipo_logradouro  numeric;
  v_idcam_logradouro    numeric;
  v_idcam_numero      numeric;
  v_idcam_letra     numeric;
  v_idcam_complemento   numeric;
  v_idcam_bairro      numeric;
  v_idcam_cep     numeric;
  v_idcam_cidade      numeric;

  /*
  consistenciacao.historico_campo.credibilidade: 1 = Máxima, 2 = Alta, 3 = Média, 4 = Baixa, 5 = Sem credibilidade
  cadastro.pessoa.origem_gravacao: M = Migração, U = Usuário, C = Rotina de confrontação, O = Oscar
  */
  BEGIN
    v_idpes       := NEW.idpes;
    v_tipo_endereco     := NEW.tipo;

    v_sigla_uf_nova     := NEW.sigla_uf;
    v_id_tipo_logradouro_novo := NEW.idtlog;
    v_logradouro_novo   := NEW.logradouro;
    v_numero_novo     := NEW.numero;
    v_letra_nova      := NEW.letra;
    v_complemento_novo    := NEW.complemento;
    v_bairro_novo     := NEW.bairro;
    v_cep_novo      := NEW.cep;
    v_cidade_nova     := NEW.cidade;

    IF TG_OP <> 'UPDATE' THEN
      v_sigla_uf_antiga   := '';
      v_id_tipo_logradouro_antigo := '';
      v_logradouro_antigo   := '';
      v_numero_antigo     := 0;
      v_letra_antiga      := '';
      v_complemento_antigo    := '';
      v_bairro_antigo     := '';
      v_cep_antigo      := 0;
      v_cidade_antiga     := '';
    ELSE
      v_sigla_uf_antiga   := COALESCE(OLD.sigla_uf, '');
      v_id_tipo_logradouro_antigo := COALESCE(OLD.idtlog, '');
      v_logradouro_antigo   := COALESCE(OLD.logradouro, '');
      v_numero_antigo     := COALESCE(OLD.numero, 0);
      v_letra_antiga      := COALESCE(OLD.letra, '');
      v_complemento_antigo    := COALESCE(OLD.complemento, '');
      v_bairro_antigo     := COALESCE(OLD.bairro, '');
      v_cep_antigo      := COALESCE(OLD.cep, 0);
      v_cidade_antiga     := COALESCE(OLD.cidade, '');
    END IF;

    v_idcam_sigla_uf_correspondencia    := 55;
    v_idcam_id_tipo_logradouro_correspondencia  := 48;
    v_idcam_logradouro_correspondencia    := 47;
    v_idcam_numero_correspondencia      := 49;
    v_idcam_letra_correspondencia     := 50;
    v_idcam_complemento_correspondencia   := 51;
    v_idcam_bairro_correspondencia      := 52;
    v_idcam_cep_correspondencia     := 53;
    v_idcam_cidade_correspondencia      := 54;
    v_idcam_sigla_uf_residencial      := 64;
    v_idcam_id_tipo_logradouro_residencial    := 57;
    v_idcam_logradouro_residencial      := 56;
    v_idcam_numero_residencial      := 58;
    v_idcam_letra_residencial     := 59;
    v_idcam_complemento_residencial     := 60;
    v_idcam_bairro_residencial      := 61;
    v_idcam_cep_residencial       := 62;
    v_idcam_cidade_residencial      := 63;
    v_idcam_sigla_uf_comercial      := 73;
    v_idcam_id_tipo_logradouro_comercial    := 66;
    v_idcam_logradouro_comercial      := 65;
    v_idcam_numero_comercial      := 67;
    v_idcam_letra_comercial       := 68;
    v_idcam_complemento_comercial     := 69;
    v_idcam_bairro_comercial      := 70;
    v_idcam_cep_comercial       := 71;
    v_idcam_cidade_comercial      := 72;

    v_nova_credibilidade := 0;
    v_credibilidade_maxima := 1;
    v_credibilidade_alta := 2;
    v_sem_credibilidade := 5;
    v_comando := 'SELECT origem_gravacao FROM cadastro.pessoa WHERE idpes='||quote_literal(v_idpes)||';';

    FOR v_registro IN EXECUTE v_comando LOOP
      v_origem_gravacao := v_registro.origem_gravacao;
    END LOOP;

    IF v_origem_gravacao = 'U' OR v_origem_gravacao = 'O' THEN -- os dados foram editados pelo usuário ou usuário do Oscar
      v_nova_credibilidade := v_credibilidade_maxima;
    ELSIF v_origem_gravacao = 'M' THEN -- os dados foram originados por migração
      v_nova_credibilidade := v_credibilidade_alta;
    END IF;

    IF v_tipo_endereco = 1 THEN
      v_idcam_sigla_uf    := v_idcam_sigla_uf_correspondencia;
      v_idcam_id_tipo_logradouro  := v_idcam_id_tipo_logradouro_correspondencia;
      v_idcam_logradouro    := v_idcam_logradouro_correspondencia;
      v_idcam_numero      := v_idcam_numero_correspondencia;
      v_idcam_letra     := v_idcam_letra_correspondencia;
      v_idcam_complemento   := v_idcam_complemento_correspondencia;
      v_idcam_bairro      := v_idcam_bairro_correspondencia;
      v_idcam_cep     := v_idcam_cep_correspondencia;
      v_idcam_cidade      := v_idcam_cidade_correspondencia;
    ELSIF v_tipo_endereco = 2 THEN
      v_idcam_sigla_uf    := v_idcam_sigla_uf_residencial;
      v_idcam_id_tipo_logradouro  := v_idcam_id_tipo_logradouro_residencial;
      v_idcam_logradouro    := v_idcam_logradouro_residencial;
      v_idcam_numero      := v_idcam_numero_residencial;
      v_idcam_letra     := v_idcam_letra_residencial;
      v_idcam_complemento   := v_idcam_complemento_residencial;
      v_idcam_bairro      := v_idcam_bairro_residencial;
      v_idcam_cep     := v_idcam_cep_residencial;
      v_idcam_cidade      := v_idcam_cidade_residencial;
    ELSIF v_tipo_endereco = 3 THEN
      v_idcam_sigla_uf    := v_idcam_sigla_uf_comercial;
      v_idcam_id_tipo_logradouro  := v_idcam_id_tipo_logradouro_comercial;
      v_idcam_logradouro    := v_idcam_logradouro_comercial;
      v_idcam_numero      := v_idcam_numero_comercial;
      v_idcam_letra     := v_idcam_letra_comercial;
      v_idcam_complemento   := v_idcam_complemento_comercial;
      v_idcam_bairro      := v_idcam_bairro_comercial;
      v_idcam_cep     := v_idcam_cep_comercial;
      v_idcam_cidade      := v_idcam_cidade_comercial;
    END IF;

    IF v_nova_credibilidade > 0 THEN
      -- UF
      IF v_sigla_uf_nova <> v_sigla_uf_antiga THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_sigla_uf||','||v_nova_credibilidade||');';
      END IF;

      -- ID TIPO LOGRADOURO
      IF v_id_tipo_logradouro_novo <> v_id_tipo_logradouro_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_id_tipo_logradouro||','||v_nova_credibilidade||');';
      END IF;

      -- LOGRADOURO
      IF v_logradouro_novo <> v_logradouro_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_logradouro||','||v_nova_credibilidade||');';
      END IF;

      -- NUMERO
      IF v_numero_novo <> v_numero_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero||','||v_nova_credibilidade||');';
      END IF;

      -- LETRA
      IF v_letra_nova <> v_letra_antiga THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_letra||','||v_nova_credibilidade||');';
      END IF;

      -- COMPLEMENTO
      IF v_complemento_novo <> v_complemento_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_complemento||','||v_nova_credibilidade||');';
      END IF;

      -- BAIRRO
      IF v_bairro_novo <> v_bairro_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_bairro||','||v_nova_credibilidade||');';
      END IF;

      -- CEP
      IF v_cep_novo <> v_cep_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cep||','||v_nova_credibilidade||');';
      END IF;

      -- CIDADE
      IF v_cidade_nova <> v_cidade_antiga THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cidade||','||v_nova_credibilidade||');';
      END IF;

    END IF;

    -- Verificar os campos Vazios ou Nulos

    -- UF
    IF TRIM(v_sigla_uf_nova)='' OR v_sigla_uf_nova IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_sigla_uf||','||v_sem_credibilidade||');';
    END IF;

    -- ID TIPO LOGRADOURO
    IF TRIM(v_id_tipo_logradouro_novo)='' OR v_id_tipo_logradouro_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_id_tipo_logradouro||','||v_sem_credibilidade||');';
    END IF;

    -- LOGRADOURO
    IF TRIM(v_logradouro_novo)='' OR v_logradouro_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_logradouro||','||v_sem_credibilidade||');';
    END IF;
    -- NUMERO
    IF v_numero_novo <= 0 OR v_numero_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero||','||v_sem_credibilidade||');';
    END IF;

    -- LETRA
    IF TRIM(v_letra_nova)='' OR v_letra_nova IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_letra||','||v_sem_credibilidade||');';
    END IF;

    -- COMPLEMENTO
    IF TRIM(v_complemento_novo)='' OR v_complemento_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_complemento||','||v_sem_credibilidade||');';
    END IF;

    -- BAIRRO
    IF TRIM(v_bairro_novo)='' OR v_bairro_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_bairro||','||v_sem_credibilidade||');';
    END IF;
    -- CEP
    IF v_cep_novo <= 0 OR v_cep_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cep||','||v_sem_credibilidade||');';
    END IF;

    -- CIDADE
    IF TRIM(v_cidade_nova)='' OR v_cidade_nova IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cidade||','||v_sem_credibilidade||');';
    END IF;

  RETURN NEW;
END; $$;


--
-- TOC entry 885 (class 1255 OID 9442808)
-- Name: fcn_endereco_pessoa_historico_campo(); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_endereco_pessoa_historico_campo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes       numeric;
  v_cep_antigo      numeric;
  v_cep_novo      numeric;
  v_id_logradouro_antigo    numeric;
  v_id_logradouro_novo    numeric;
  v_id_bairro_antigo    numeric;
  v_id_bairro_novo    numeric;
  v_numero_antigo     numeric;
  v_numero_novo     numeric;
  v_letra_antiga      text;
  v_letra_nova      text;
  v_complemento_antigo    text;
  v_complemento_novo    text;
  v_tipo_endereco     numeric;
  v_comando     text;
  v_origem_gravacao   text;
  v_credibilidade_maxima    numeric;
  v_credibilidade_alta    numeric;
  v_sem_credibilidade   numeric;
  v_nova_credibilidade    numeric;

  v_registro      record;

  -- ID dos campos
  v_idcam_cep_correspondencia     numeric;
  v_idcam_id_logradouro_correspondencia   numeric;
  v_idcam_id_bairro_correspondencia   numeric;
  v_idcam_numero_correspondencia      numeric;
  v_idcam_letra_correspondencia     numeric;
  v_idcam_complemento_correspondencia   numeric;

  v_idcam_cep_residencial       numeric;
  v_idcam_id_logradouro_residencial   numeric;
  v_idcam_id_bairro_residencial     numeric;
  v_idcam_numero_residencial      numeric;
  v_idcam_letra_residencial     numeric;
  v_idcam_complemento_residencial     numeric;

  v_idcam_cep_comercial       numeric;
  v_idcam_id_logradouro_comercial     numeric;
  v_idcam_id_bairro_comercial     numeric;
  v_idcam_numero_comercial      numeric;
  v_idcam_letra_comercial       numeric;
  v_idcam_complemento_comercial     numeric;

  v_idcam_cep     numeric;
  v_idcam_id_logradouro   numeric;
  v_idcam_id_bairro   numeric;
  v_idcam_numero      numeric;
  v_idcam_letra     numeric;
  v_idcam_complemento   numeric;

  /*
  consistenciacao.historico_campo.credibilidade: 1 = Máxima, 2 = Alta, 3 = Média, 4 = Baixa, 5 = Sem credibilidade
  cadastro.pessoa.origem_gravacao: M = Migração, U = Usuário, C = Rotina de confrontação, O = Oscar
  */
  BEGIN
    v_idpes       := NEW.idpes;
    v_tipo_endereco     := NEW.tipo;

    v_cep_novo      := NEW.cep;
    v_id_logradouro_novo    := NEW.idlog;
    v_id_bairro_novo    := NEW.idbai;
    v_numero_novo     := NEW.numero;
    v_letra_nova      := NEW.letra;
    v_complemento_novo    := NEW.complemento;

    IF TG_OP <> 'UPDATE' THEN
      v_cep_antigo    := 0;
      v_id_logradouro_antigo  := 0;
      v_id_bairro_antigo  := 0;
      v_numero_antigo   := 0;
      v_letra_antiga    := '';
      v_complemento_antigo  := '';
    ELSE
      v_cep_antigo    := COALESCE(OLD.cep, 0);
      v_id_logradouro_antigo  := COALESCE(OLD.idlog, 0);
      v_id_bairro_antigo  := COALESCE(OLD.idbai, 0);
      v_numero_antigo   := COALESCE(OLD.numero, 0);
      v_letra_antiga    := COALESCE(OLD.letra, '');
      v_complemento_antigo  := COALESCE(OLD.complemento, '');
    END IF;

    v_idcam_cep_correspondencia     := 53;
    v_idcam_id_logradouro_correspondencia   := 47;
    v_idcam_id_bairro_correspondencia   := 52;
    v_idcam_numero_correspondencia      := 49;
    v_idcam_letra_correspondencia     := 50;
    v_idcam_complemento_correspondencia   := 51;
    v_idcam_cep_residencial       := 62;
    v_idcam_id_logradouro_residencial   := 56;
    v_idcam_id_bairro_residencial     := 61;
    v_idcam_numero_residencial      := 58;
    v_idcam_letra_residencial     := 59;
    v_idcam_complemento_residencial     := 60;
    v_idcam_cep_comercial       := 71;
    v_idcam_id_logradouro_comercial     := 65;
    v_idcam_id_bairro_comercial     := 70;
    v_idcam_numero_comercial      := 67;
    v_idcam_letra_comercial       := 68;
    v_idcam_complemento_comercial     := 69;

    v_nova_credibilidade := 0;
    v_credibilidade_maxima := 1;
    v_credibilidade_alta := 2;
    v_sem_credibilidade := 5;
    v_comando := 'SELECT origem_gravacao FROM cadastro.pessoa WHERE idpes='||quote_literal(v_idpes)||';';

    FOR v_registro IN EXECUTE v_comando LOOP
      v_origem_gravacao := v_registro.origem_gravacao;
    END LOOP;
    IF v_origem_gravacao = 'U' OR v_origem_gravacao = 'O' THEN -- os dados foram editados pelo usuário ou pelo usuário do Oscar
      v_nova_credibilidade := v_credibilidade_maxima;
    ELSIF v_origem_gravacao = 'M' THEN -- os dados foram originados por migração
      v_nova_credibilidade := v_credibilidade_alta;
    END IF;
    IF v_tipo_endereco = 1 THEN
      v_idcam_cep     := v_idcam_cep_correspondencia;
      v_idcam_id_logradouro   := v_idcam_id_logradouro_correspondencia;
      v_idcam_id_bairro   := v_idcam_id_bairro_correspondencia;
      v_idcam_numero      := v_idcam_numero_correspondencia;
      v_idcam_letra     := v_idcam_letra_correspondencia;
      v_idcam_complemento   := v_idcam_complemento_correspondencia;
    ELSIF v_tipo_endereco = 2 THEN
      v_idcam_cep     := v_idcam_cep_residencial;
      v_idcam_id_logradouro   := v_idcam_id_logradouro_residencial;
      v_idcam_id_bairro   := v_idcam_id_bairro_residencial;
      v_idcam_numero      := v_idcam_numero_residencial;
      v_idcam_letra     := v_idcam_letra_residencial;
      v_idcam_complemento   := v_idcam_complemento_residencial;
    ELSIF v_tipo_endereco = 3 THEN
      v_idcam_cep     := v_idcam_cep_comercial;
      v_idcam_id_logradouro   := v_idcam_id_logradouro_comercial;
      v_idcam_id_bairro   := v_idcam_id_bairro_comercial;
      v_idcam_numero      := v_idcam_numero_comercial;
      v_idcam_letra     := v_idcam_letra_comercial;
      v_idcam_complemento   := v_idcam_complemento_comercial;
    END IF;
    IF v_nova_credibilidade > 0 THEN
      -- CEP
      IF v_cep_novo <> v_cep_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cep||','||v_nova_credibilidade||');';
      END IF;
      -- ID LOGRADOURO
      IF v_id_logradouro_novo <> v_id_logradouro_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_id_logradouro||','||v_nova_credibilidade||');';
      END IF;
      -- BAIRRO
      IF v_id_bairro_novo <> v_id_bairro_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_id_bairro||','||v_nova_credibilidade||');';
      END IF;

      -- NUMERO
      IF v_numero_novo <> v_numero_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero||','||v_nova_credibilidade||');';
      END IF;

      -- LETRA
      IF v_letra_nova <> v_letra_antiga THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_letra||','||v_nova_credibilidade||');';
      END IF;

      -- COMPLEMENTO
      IF v_complemento_novo <> v_complemento_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_complemento||','||v_nova_credibilidade||');';
      END IF;
    END IF;

    -- Verificar os campos Vazios ou Nulos

    -- CEP
    IF v_cep_novo <= 0 OR v_cep_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cep||','||v_sem_credibilidade||');';
    END IF;

    -- ID LOGRADOURO
    IF v_id_logradouro_novo <= 0 OR v_id_logradouro_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_id_logradouro||','||v_sem_credibilidade||');';
    END IF;

    -- BAIRRO
    IF v_id_bairro_novo <= 0 OR v_id_bairro_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_id_bairro||','||v_sem_credibilidade||');';
    END IF;

    -- NUMERO
    IF v_numero_novo <= 0 OR v_numero_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero||','||v_sem_credibilidade||');';
    END IF;

    -- LETRA
    IF TRIM(v_letra_nova)='' OR v_letra_nova IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_letra||','||v_sem_credibilidade||');';
    END IF;

    -- COMPLEMENTO
    IF TRIM(v_complemento_novo)='' OR v_complemento_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_complemento||','||v_sem_credibilidade||');';
    END IF;
  RETURN NEW;
END; $$;


--
-- TOC entry 886 (class 1255 OID 9442809)
-- Name: fcn_fisica_historico_campo(); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_fisica_historico_campo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
                      DECLARE
                        v_idpes       numeric;
                        v_data_nasc_nova    date;
                        v_data_nasc_antiga    date;
                        v_sexo_novo     text;
                        v_sexo_antigo     text;
                        v_nome_mae_novo     text;
                        v_nome_mae_antigo   text;
                        v_nome_pai_novo     text;
                        v_nome_pai_antigo   text;
                        v_nome_conjuge_novo   text;
                        v_nome_conjuge_antigo   text;
                        v_nome_responsavel_novo   text;
                        v_nome_responsavel_antigo text;
                        v_nome_ultima_empresa_novo  text;
                        v_nome_ultima_empresa_antigo  text;
                        v_id_ocupacao_novo    numeric;
                        v_id_ocupacao_antigo    numeric;
                        v_id_escolaridade_novo    numeric;
                        v_id_escolaridade_antigo  numeric;
                        v_id_estado_civil_novo    numeric;
                        v_id_estado_civil_antigo  numeric;
                        v_id_pais_origem_novo   numeric;
                        v_id_pais_origem_antigo   numeric;
                        v_data_chegada_brasil_nova  date;
                        v_data_chegada_brasil_antiga  date;
                        v_data_obito_nova   date;
                        v_data_obito_antiga   date;
                        v_data_uniao_nova   date;
                        v_data_uniao_antiga   date;

                        v_comando     text;
                        v_origem_gravacao   text;

                        v_credibilidade_maxima    numeric;
                        v_credibilidade_alta    numeric;
                        v_sem_credibilidade   numeric;

                        v_nova_credibilidade    numeric;

                        v_registro      record;
                        v_aux_data_nova     text;
                        v_aux_data_antiga   text;

                        -- ID dos campos
                        v_idcam_data_nasc   numeric;
                        v_idcam_sexo      numeric;
                        v_idcam_nome_mae    numeric;
                        v_idcam_nome_pai    numeric;
                        v_idcam_nome_conjuge    numeric;
                        v_idcam_nome_responsavel  numeric;
                        v_idcam_nome_ultima_empresa numeric;
                        v_idcam_ocupacao    numeric;
                        v_idcam_escolaridade    numeric;
                        v_idcam_estado_civil    numeric;
                        v_idcam_pais_origem   numeric;
                        v_idcam_data_chegada_brasil numeric;
                        v_idcam_data_obito    numeric;
                        v_idcam_data_uniao    numeric;

                        /*
                        consistenciacao.historico_campo.credibilidade: 1 = Máxima, 2 = Alta, 3 = Média, 4 = Baixa, 5 = Sem credibilidade
                        cadastro.pessoa.origem_gravacao: M = Migração, U = Usuário, C = Rotina de confrontação, O = Oscar
                        */
                        BEGIN
                          v_idpes       := NEW.idpes;
                          v_data_nasc_nova    := NEW.data_nasc;
                          v_sexo_novo     := NEW.sexo;
                          v_nome_mae_novo     := NEW.nome_mae;
                          v_nome_pai_novo     := NEW.nome_pai;
                          v_nome_conjuge_novo   := NEW.nome_conjuge;
                          v_nome_responsavel_novo   := NEW.nome_responsavel;
                          v_nome_ultima_empresa_novo  := NEW.ultima_empresa;
                          v_id_ocupacao_novo    := NEW.idocup;
                          v_id_escolaridade_novo    := NEW.idesco;
                          v_id_estado_civil_novo    := NEW.ideciv;
                          v_id_pais_origem_novo   := NEW.idpais_estrangeiro;
                          v_data_chegada_brasil_nova  := NEW.data_chegada_brasil;
                          v_data_obito_nova   := NEW.data_obito;
                          v_data_uniao_nova   := NEW.data_uniao;

                          IF TG_OP <> 'UPDATE' THEN
                            v_data_nasc_antiga    := NULL;
                            v_sexo_antigo     := '';
                            v_nome_mae_antigo   := '';
                            v_nome_pai_antigo   := '';
                            v_nome_conjuge_antigo   := '';
                            v_nome_responsavel_antigo := '';
                            v_nome_ultima_empresa_antigo  := '';
                            v_id_ocupacao_antigo    := 0;
                            v_id_escolaridade_antigo  := 0;
                            v_id_estado_civil_antigo  := 0;
                            v_id_pais_origem_antigo   := 0;
                            v_data_chegada_brasil_antiga  := NULL;
                            v_data_obito_antiga   := NULL;
                            v_data_uniao_antiga   := NULL;
                          ELSE
                            v_data_nasc_antiga    := OLD.data_nasc;
                            v_sexo_antigo     := COALESCE(OLD.sexo, '');
                            v_nome_mae_antigo   := COALESCE(OLD.nome_mae, '');
                            v_nome_pai_antigo   := COALESCE(OLD.nome_pai, '');
                            v_nome_conjuge_antigo   := COALESCE(OLD.nome_conjuge, '');
                            v_nome_responsavel_antigo := COALESCE(OLD.nome_responsavel, '');
                            v_nome_ultima_empresa_antigo  := COALESCE(OLD.ultima_empresa, '');
                            v_id_ocupacao_antigo    := COALESCE(OLD.idocup, 0);
                            v_id_escolaridade_antigo  := COALESCE(OLD.idesco, 0);
                            v_id_estado_civil_antigo  := COALESCE(OLD.ideciv, 0);
                            v_id_pais_origem_antigo   := COALESCE(OLD.idpais_estrangeiro, 0);
                            v_data_chegada_brasil_antiga  := OLD.data_chegada_brasil;
                            v_data_obito_antiga   := OLD.data_obito;
                            v_data_uniao_antiga   := OLD.data_uniao;
                          END IF;

                          v_idcam_data_nasc   := 5;
                          v_idcam_sexo      := 26;
                          v_idcam_nome_mae    := 27;
                          v_idcam_nome_pai    := 28;
                          v_idcam_nome_conjuge    := 29;
                          v_idcam_nome_responsavel  := 30;
                          v_idcam_nome_ultima_empresa := 31;
                          v_idcam_ocupacao    := 32;
                          v_idcam_escolaridade    := 33;
                          v_idcam_estado_civil    := 34;
                          v_idcam_pais_origem   := 35;
                          v_idcam_data_chegada_brasil := 36;
                          v_idcam_data_obito    := 37;
                          v_idcam_data_uniao    := 38;

                          v_nova_credibilidade := 0;
                          v_credibilidade_maxima := 1;
                          v_credibilidade_alta := 2;
                          v_sem_credibilidade := 5;
                          v_comando := 'SELECT origem_gravacao FROM cadastro.pessoa WHERE idpes='||quote_literal(v_idpes)||';';

                          FOR v_registro IN EXECUTE v_comando LOOP
                            v_origem_gravacao := v_registro.origem_gravacao;
                          END LOOP;

                          IF v_origem_gravacao = 'U' OR v_origem_gravacao = 'O' THEN -- os dados foram editados pelo usuário ou pelo usuário do Oscar
                            v_nova_credibilidade := v_credibilidade_maxima;
                          ELSIF v_origem_gravacao = 'M' THEN -- os dados foram originados por migração
                            v_nova_credibilidade := v_credibilidade_alta;
                          END IF;

                          IF v_nova_credibilidade > 0 THEN

                            -- DATA DE NASCIMENTO
                            v_aux_data_nova := COALESCE(TO_CHAR (v_data_nasc_nova, 'DD/MM/YYYY'), '');
                            v_aux_data_antiga := COALESCE(TO_CHAR (v_data_nasc_antiga, 'DD/MM/YYYY'), '');

                            IF v_aux_data_nova <> v_aux_data_antiga THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_nasc||','||v_nova_credibilidade||');';
                            END IF;

                            -- DATA DE UNIÃO
                            v_aux_data_nova := COALESCE(TO_CHAR (v_data_uniao_nova, 'DD/MM/YYYY'), '');
                            v_aux_data_antiga := COALESCE(TO_CHAR (v_data_uniao_antiga, 'DD/MM/YYYY'), '');

                            IF v_aux_data_nova <> v_aux_data_antiga THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_uniao||','||v_nova_credibilidade||');';
                            END IF;

                            -- DATA DE ÓBITO
                            v_aux_data_nova := COALESCE(TO_CHAR (v_data_obito_nova, 'DD/MM/YYYY'), '');
                            v_aux_data_antiga := COALESCE(TO_CHAR (v_data_obito_antiga, 'DD/MM/YYYY'), '');

                            IF v_aux_data_nova <> v_aux_data_antiga THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_obito||','||v_nova_credibilidade||');';
                            END IF;

                            -- DATA DE CHEGADA AO BRASIL
                            v_aux_data_nova := COALESCE(TO_CHAR (v_data_chegada_brasil_nova, 'DD/MM/YYYY'), '');
                            v_aux_data_antiga := COALESCE(TO_CHAR (v_data_chegada_brasil_antiga, 'DD/MM/YYYY'), '');

                            IF v_aux_data_nova <> v_aux_data_antiga THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_chegada_brasil||','||v_nova_credibilidade||');';
                            END IF;

                            -- NOME DA MÃE
                            IF v_nome_mae_novo <> v_nome_mae_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_mae||','||v_nova_credibilidade||');';
                            END IF;

                            -- NOME DO PAI
                            IF v_nome_pai_novo <> v_nome_pai_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_pai||','||v_nova_credibilidade||');';
                            END IF;

                            -- NOME DO CONJUGE
                            IF v_nome_conjuge_novo <> v_nome_conjuge_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_conjuge||','||v_nova_credibilidade||');';
                            END IF;

                            -- NOME DO RESPONSAVEL
                            IF v_nome_responsavel_novo <> v_nome_responsavel_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_responsavel||','||v_nova_credibilidade||');';
                            END IF;

                            -- NOME ÚLTIMA EMPRESA
                            IF v_nome_ultima_empresa_novo <> v_nome_ultima_empresa_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_ultima_empresa||','||v_nova_credibilidade||');';
                            END IF;

                            -- SEXO
                            IF v_sexo_novo <> v_sexo_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_sexo||','||v_nova_credibilidade||');';
                            END IF;

                            -- ID OCUPAÇÃO PROFISSIONAL
                            IF v_id_ocupacao_novo <> v_id_ocupacao_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_ocupacao||','||v_nova_credibilidade||');';
                            END IF;

                            -- ID ESCOLARIDADE
                            IF v_id_escolaridade_novo <> v_id_escolaridade_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_escolaridade||','||v_nova_credibilidade||');';
                            END IF;

                            -- ID ESTADO CIVIL
                            IF v_id_estado_civil_novo <> v_id_estado_civil_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_estado_civil||','||v_nova_credibilidade||');';
                            END IF;

                            -- ID PAIS ORIGEM
                            IF v_id_pais_origem_novo <> v_id_pais_origem_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_pais_origem||','||v_nova_credibilidade||');';
                            END IF;

                          END IF;

                          -- Verificar os campos Vazios ou Nulos
                          -- DATA DE NASCIMENTO
                          IF TRIM(v_data_nasc_nova::varchar)='' OR v_data_nasc_nova IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_nasc||','||v_sem_credibilidade||');';
                          END IF;
                          -- DATA DE UNIÃO
                          IF TRIM(v_data_uniao_nova::varchar)='' OR v_data_uniao_nova IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_uniao||','||v_sem_credibilidade||');';
                          END IF;
                          -- DATA DE ÓBITO
                          IF TRIM(v_data_obito_nova::varchar)='' OR v_data_obito_nova IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_obito||','||v_sem_credibilidade||');';
                          END IF;
                          -- DATA DE CHEGADA AO BRASIL
                          IF TRIM(v_data_chegada_brasil_nova::varchar)='' OR v_data_chegada_brasil_nova IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_chegada_brasil||','||v_sem_credibilidade||');';
                          END IF;
                          -- NOME DA MÃE
                          IF TRIM(v_nome_mae_novo)='' OR v_nome_mae_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_mae||','||v_sem_credibilidade||');';
                          END IF;
                          -- NOME DO PAI
                          IF TRIM(v_nome_pai_novo)='' OR v_nome_pai_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_pai||','||v_sem_credibilidade||');';
                          END IF;
                          -- NOME DO CONJUGE
                          IF TRIM(v_nome_conjuge_novo)='' OR v_nome_conjuge_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_conjuge||','||v_sem_credibilidade||');';
                          END IF;
                          -- NOME DO RESPONSAVEL
                          IF TRIM(v_nome_responsavel_novo)='' OR v_nome_responsavel_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_responsavel||','||v_sem_credibilidade||');';
                          END IF;
                          -- NOME ÚLTIMA EMPRESA
                          IF TRIM(v_nome_ultima_empresa_novo)='' OR v_nome_ultima_empresa_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_ultima_empresa||','||v_sem_credibilidade||');';
                          END IF;
                          -- SEXO
                          IF TRIM(v_sexo_novo)='' OR v_sexo_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_sexo||','||v_sem_credibilidade||');';
                          END IF;
                          -- ID OCUPAÇÃO PROFISSIONAL
                          IF v_id_ocupacao_novo <= 0 OR v_id_ocupacao_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_ocupacao||','||v_sem_credibilidade||');';
                          END IF;
                          -- ID ESCOLARIDADE
                          IF v_id_escolaridade_novo <= 0 OR v_id_escolaridade_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_escolaridade||','||v_sem_credibilidade||');';
                          END IF;
                          -- ID ESTADO CIVIL
                          IF v_id_estado_civil_novo <= 0 OR v_id_estado_civil_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_estado_civil||','||v_sem_credibilidade||');';
                          END IF;
                          -- ID PAIS ORIGEM
                          IF v_id_pais_origem_novo <= 0 OR v_id_pais_origem_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_pais_origem||','||v_sem_credibilidade||');';
                          END IF;
                        RETURN NEW;
                      END; $$;


--
-- TOC entry 887 (class 1255 OID 9442812)
-- Name: fcn_fone_historico_campo(); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_fone_historico_campo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes       numeric;

  v_ddd_antigo      numeric;
  v_ddd_novo      numeric;
  v_fone_antigo     numeric;
  v_fone_novo     numeric;
  v_tipo_fone     numeric;

  v_comando     text;
  v_origem_gravacao   text;

  v_credibilidade_maxima    numeric;
  v_credibilidade_alta    numeric;
  v_sem_credibilidade   numeric;

  v_nova_credibilidade    numeric;

  v_registro      record;

  -- ID dos campos
  v_idcam_ddd_fone_residencial  numeric;
  v_idcam_fone_residencial  numeric;
  v_idcam_ddd_fone_comercial  numeric;
  v_idcam_fone_comercial    numeric;
  v_idcam_ddd_fone_celular  numeric;
  v_idcam_fone_celular    numeric;
  v_idcam_ddd_fax     numeric;
  v_idcam_fax     numeric;

  v_idcam_ddd     numeric;
  v_idcam_fone      numeric;

  /*
  consistenciacao.historico_campo.credibilidade: 1 = Máxima, 2 = Alta, 3 = Média, 4 = Baixa, 5 = Sem credibilidade
  cadastro.pessoa.origem_gravacao: M = Migração, U = Usuário, C = Rotina de confrontação, O = Oscar
  */
  BEGIN
    v_idpes   := NEW.idpes;
    v_tipo_fone := NEW.tipo;
    v_ddd_novo  := NEW.ddd;
    v_fone_novo := NEW.fone;

    IF TG_OP <> 'UPDATE' THEN
      v_ddd_antigo  := 0;
      v_fone_antigo := 0;
    ELSE
      v_ddd_antigo  := COALESCE(OLD.ddd, 0);
      v_fone_antigo := COALESCE(OLD.fone, 0);
    END IF;

    v_idcam_ddd_fone_residencial  := 39;
    v_idcam_fone_residencial  := 40;
    v_idcam_ddd_fone_comercial  := 41;
    v_idcam_fone_comercial    := 42;
    v_idcam_ddd_fone_celular  := 43;
    v_idcam_fone_celular    := 44;
    v_idcam_ddd_fax     := 45;
    v_idcam_fax     := 46;

    v_nova_credibilidade := 0;
    v_credibilidade_maxima := 1;
    v_credibilidade_alta := 2;
    v_sem_credibilidade := 5;
    v_comando := 'SELECT origem_gravacao FROM cadastro.pessoa WHERE idpes='||quote_literal(v_idpes)||';';

    FOR v_registro IN EXECUTE v_comando LOOP
      v_origem_gravacao := v_registro.origem_gravacao;
    END LOOP;

    IF v_origem_gravacao = 'U' OR v_origem_gravacao = 'O' THEN -- os dados foram editados pelo usuário ou usuário do Oscar
      v_nova_credibilidade := v_credibilidade_maxima;
    ELSIF v_origem_gravacao = 'M' THEN -- os dados foram originados por migração
      v_nova_credibilidade := v_credibilidade_alta;
    END IF;

    IF v_tipo_fone = 1 THEN
      v_idcam_ddd := v_idcam_ddd_fone_residencial;
      v_idcam_fone := v_idcam_fone_residencial;
    ELSIF v_tipo_fone = 2 THEN
      v_idcam_ddd := v_idcam_ddd_fone_comercial;
      v_idcam_fone := v_idcam_fone_comercial;
    ELSIF v_tipo_fone = 3 THEN
      v_idcam_ddd := v_idcam_ddd_fone_celular;
      v_idcam_fone := v_idcam_fone_celular;
    ELSIF v_tipo_fone = 4 THEN
      v_idcam_ddd := v_idcam_ddd_fax;
      v_idcam_fone := v_idcam_fax;
    END IF;

    IF v_nova_credibilidade > 0 THEN
      IF v_ddd_novo <> v_ddd_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_ddd||','||v_nova_credibilidade||');';
      END IF;

      IF v_fone_novo <> v_fone_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_fone||','||v_nova_credibilidade||');';
      END IF;
    END IF;

    -- Verificar os campos Vazios ou Nulos
    IF v_ddd_novo <= 0 OR v_ddd_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_ddd||','||v_sem_credibilidade||');';
    END IF;
    IF v_fone_novo <= 0 OR v_fone_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_fone||','||v_sem_credibilidade||');';
    END IF;

  RETURN NEW;
END; $$;


--
-- TOC entry 889 (class 1255 OID 9442813)
-- Name: fcn_gravar_historico_campo(numeric, numeric, numeric); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_gravar_historico_campo(numeric, numeric, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  v_idpes ALIAS for $1;
  v_idcam ALIAS for $2;
  v_credibilidade ALIAS for $3;

  v_comando   text;
  v_existe_historico  numeric;
  v_registro    record;

  BEGIN
    -- verificar se já existe histórico para o campo
    v_comando := 'SELECT idcam FROM consistenciacao.historico_campo WHERE idpes='||quote_literal(v_idpes)||' AND idcam='||quote_literal(v_idcam)||';';
    FOR v_registro IN EXECUTE v_comando LOOP
      v_existe_historico := v_registro.idcam;
    END LOOP;
    IF v_existe_historico > 0 THEN
      EXECUTE 'UPDATE consistenciacao.historico_campo SET credibilidade='||v_credibilidade||', data_hora=CURRENT_TIMESTAMP WHERE idpes='||quote_literal(v_idpes)||' AND idcam='||quote_literal(v_idcam)||';';
    ELSE
      EXECUTE 'INSERT INTO consistenciacao.historico_campo(idpes, idcam, credibilidade, data_hora) VALUES ('||quote_literal(v_idpes)||','|| quote_literal(v_idcam)||', '||quote_literal(v_credibilidade)||', CURRENT_TIMESTAMP);';
    END IF;
  RETURN 1;
END; $_$;


--
-- TOC entry 890 (class 1255 OID 9442814)
-- Name: fcn_juridica_historico_campo(); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_juridica_historico_campo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes       numeric;
  v_cnpj_novo     numeric;
  v_cnpj_antigo     numeric;
  v_fantasia_novo     text;
  v_fantasia_antigo   text;
  v_inscricao_estadual_novo numeric;
  v_inscricao_estadual_antigo numeric;

  v_comando     text;
  v_origem_gravacao   text;

  v_credibilidade_maxima    numeric;
  v_credibilidade_alta    numeric;
  v_sem_credibilidade   numeric;

  v_nova_credibilidade    numeric;

  v_registro      record;

  -- ID dos campos
  v_idcam_cnpj      numeric;
  v_idcam_fantasia    numeric;
  v_idcam_inscricao_estadual  numeric;

  /*
  consistenciacao.historico_campo.credibilidade: 1 = Máxima, 2 = Alta, 3 = Média, 4 = Baixa, 5 = Sem credibilidade
  cadastro.pessoa.origem_gravacao: M = Migração, U = Usuário, C = Rotina de confrontação, O = Oscar
  */
  BEGIN
    v_idpes       := NEW.idpes;
    v_cnpj_novo     := NEW.cnpj;
    v_fantasia_novo     := NEW.fantasia;
    v_inscricao_estadual_novo := NEW.insc_estadual;

    IF TG_OP <> 'UPDATE' THEN
      v_cnpj_antigo     := 0;
      v_fantasia_antigo   := '';
      v_inscricao_estadual_antigo := 0;
    ELSE
      v_cnpj_antigo     := COALESCE(OLD.cnpj, 0);
      v_fantasia_antigo   := COALESCE(OLD.fantasia, '');
      v_inscricao_estadual_antigo := COALESCE(OLD.insc_estadual, 0);
    END IF;

    v_idcam_cnpj      := 1;
    v_idcam_fantasia    := 24;
    v_idcam_inscricao_estadual  := 25;

    v_nova_credibilidade := 0;
    v_credibilidade_maxima := 1;
    v_credibilidade_alta := 2;
    v_sem_credibilidade := 5;
    v_comando := 'SELECT origem_gravacao FROM cadastro.pessoa WHERE idpes='||quote_literal(v_idpes)||';';

    FOR v_registro IN EXECUTE v_comando LOOP
      v_origem_gravacao := v_registro.origem_gravacao;
    END LOOP;

    IF v_origem_gravacao = 'U' OR v_origem_gravacao = 'O' THEN -- os dados foram editados pelo usuário ou pelo usuário do Oscar
      v_nova_credibilidade := v_credibilidade_maxima;
    ELSIF v_origem_gravacao = 'M' THEN -- os dados foram originados por migração
      v_nova_credibilidade := v_credibilidade_alta;
    END IF;

    IF v_nova_credibilidade > 0 THEN

      -- CNPJ
      IF v_cnpj_novo <> v_cnpj_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cnpj||','||v_nova_credibilidade||');';
      END IF;

      -- NOME FANTASIA
      IF v_fantasia_novo <> v_fantasia_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_fantasia||','||v_nova_credibilidade||');';
      END IF;

      -- INSCRIÇÃO ESTADUAL
      IF v_inscricao_estadual_novo <> v_inscricao_estadual_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_inscricao_estadual||','||v_nova_credibilidade||');';
      END IF;
    END IF;

    -- Verificar os campos Vazios ou Nulos
    -- CNPJ
    IF v_cnpj_novo <= 0 OR v_cnpj_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cnpj||','||v_sem_credibilidade||');';
    END IF;
    -- NOME FANTASIA
    IF TRIM(v_fantasia_novo)='' OR v_fantasia_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_fantasia||','||v_sem_credibilidade||');';
    END IF;

    -- INSCRIÇÃO ESTADUAL
    IF v_inscricao_estadual_novo <= 0 OR v_inscricao_estadual_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_inscricao_estadual||','||v_sem_credibilidade||');';
    END IF;
  RETURN NEW;
END; $$;


--
-- TOC entry 891 (class 1255 OID 9442815)
-- Name: fcn_pessoa_historico_campo(); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_pessoa_historico_campo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes       numeric;
  v_nome_novo     text;
  v_nome_antigo     text;
  v_email_novo      text;
  v_email_antigo      text;
  v_url_novo      text;
  v_url_antigo      text;

  v_comando     text;
  v_origem_gravacao   text;

  v_credibilidade_maxima    numeric;
  v_credibilidade_alta    numeric;
  v_sem_credibilidade   numeric;

  v_nova_credibilidade    numeric;

  v_registro      record;

  -- ID dos campos
  v_idcam_nome      numeric;
  v_idcam_email     numeric;
  v_idcam_url     numeric;

  /*
  consistenciacao.historico_campo.credibilidade: 1 = Máxima, 2 = Alta, 3 = Média, 4 = Baixa, 5 = Sem credibilidade
  cadastro.pessoa.origem_gravacao: M = Migração, U = Usuário, C = Rotina de confrontação, O = Oscar
  */
  BEGIN
    v_idpes   := NEW.idpes;
    v_nome_novo := NEW.nome;
    v_email_novo  := NEW.email;
    v_url_novo  := NEW.url;

    IF TG_OP <> 'UPDATE' THEN
      v_nome_antigo := '';
      v_email_antigo  := '';
      v_url_antigo  := '';
    ELSE
      v_nome_antigo := COALESCE(OLD.nome, '');
      v_email_antigo  := COALESCE(OLD.email, '');
      v_url_antigo  := COALESCE(OLD.url, '');
    END IF;

    v_idcam_nome  := 2;
    v_idcam_email := 3;
    v_idcam_url := 4;

    v_nova_credibilidade := 0;
    v_credibilidade_maxima := 1;
    v_credibilidade_alta := 2;
    v_sem_credibilidade := 5;
    v_comando := 'SELECT origem_gravacao FROM cadastro.pessoa WHERE idpes='||quote_literal(v_idpes)||';';

    FOR v_registro IN EXECUTE v_comando LOOP
      v_origem_gravacao := v_registro.origem_gravacao;
    END LOOP;

    IF v_origem_gravacao = 'U' OR v_origem_gravacao = 'O' THEN -- os dados foram editados pelo usuário ou pelo usuário do Oscar
      v_nova_credibilidade := v_credibilidade_maxima;
    ELSIF v_origem_gravacao = 'M' THEN -- os dados foram originados por migração
      v_nova_credibilidade := v_credibilidade_alta;
    END IF;

    IF v_nova_credibilidade > 0 THEN

      -- NOME
      IF v_nome_novo <> v_nome_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome||','||v_nova_credibilidade||');';
      END IF;

      -- E-MAIL
      IF v_email_novo <> v_email_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_email||','||v_nova_credibilidade||');';
      END IF;

      -- URL
      IF v_url_novo <> v_url_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_url||','||v_nova_credibilidade||');';
      END IF;
    END IF;

    -- Verificar os campos Vazios ou Nulos
    -- NOME
    IF TRIM(v_nome_novo)='' OR v_nome_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome||','||v_sem_credibilidade||');';
    END IF;
    -- E-MAIL
    IF TRIM(v_email_novo)='' OR v_email_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_email||','||v_sem_credibilidade||');';
    END IF;
    -- URL
    IF TRIM(v_url_novo)='' OR v_url_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_url||','||v_sem_credibilidade||');';
    END IF;
  RETURN NEW;
END; $$;


--
-- TOC entry 892 (class 1255 OID 9442816)
-- Name: fcn_unifica_cadastro(numeric, numeric); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_unifica_cadastro(numeric, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parametro recebidos
  v_idpesVelho     ALIAS for $1;
  v_idpesNovo      ALIAS for $2;
  v_cpfAux           NUMERIC;
  v_cpfIdpesNovo     NUMERIC;
  v_reg          record;
  v_regAux         record;
BEGIN
  --Unificando registros das tabelas do cadastros de pessoas--
  SET search_path = cadastro, pg_catalog;
  --FONE_PESSOA--
  FOR v_reg IN SELECT *
       FROM fone_pessoa
       WHERE
       idpes = v_idpesVelho AND
       tipo NOT IN (SELECT tipo FROM fone_pessoa WHERE idpes = v_idpesNovo) LOOP
    INSERT INTO fone_pessoa (idpes, tipo, ddd, fone) VALUES (v_idpesNovo,v_reg.tipo, v_reg.ddd, v_reg.fone);
  END LOOP;
  --Atualizando os telefones do idpeNovo que tenham o DDD e o FONE igual a zero--
  FOR v_reg IN SELECT * FROM fone_pessoa WHERE idpes = v_idpesNovo AND ddd = 0 AND fone = 0 LOOP
    DELETE FROM fone_pessoa WHERE idpes = v_reg.idpes AND tipo = v_reg.tipo;
    FOR v_regAux IN SELECT * FROM fone_pessoa WHERE idpes = v_idpesVelho AND tipo = v_reg.tipo LOOP
      INSERT INTO fone_pessoa(idpes,tipo,ddd,fone) VALUES (v_reg.idpes,v_regAux.tipo,v_regAux.ddd,v_regAux.fone);
    END LOOP;
  END LOOP;
  DELETE FROM fone_pessoa WHERE idpes = v_idpesVelho;
  --JURIDICA--
  DELETE FROM juridica WHERE idpes = v_idpesVelho;
  --HISTORICO_CARTAO--
  UPDATE historico_cartao SET idpes_cidadao = v_idpesNovo WHERE idpes_cidadao = v_idpesVelho;
  --ENDERECO_PESSOA--
  FOR v_reg IN SELECT *
         FROM endereco_pessoa
         WHERE
         idpes = v_idpesVelho AND
         tipo NOT IN (SELECT tipo FROM endereco_pessoa WHERE idpes = v_idpesNovo) LOOP
    INSERT INTO endereco_pessoa (idpes, tipo, cep, idlog, idbai, numero, letra, complemento, reside_desde)
    VALUES (v_idpesNovo,v_reg.tipo, v_reg.cep, v_reg.idlog, v_reg.idbai, v_reg.numero, v_reg.letra, v_reg.complemento, v_reg.reside_desde);
  END LOOP;
  DELETE FROM endereco_pessoa WHERE idpes = v_idpesVelho;
  --ENDERECO_EXTERNO--
  FOR v_reg IN SELECT *
     FROM endereco_externo
     WHERE
     idpes = v_idpesVelho AND
     tipo NOT IN (SELECT tipo FROM endereco_externo WHERE idpes = v_idpesNovo) LOOP
    INSERT INTO endereco_externo (idpes, tipo, idtlog, logradouro, numero, letra, complemento, bairro, cep, cidade, sigla_uf,reside_desde)
    VALUES (v_idpesNovo, v_reg.tipo, v_reg.idtlog, v_reg.logradouro, v_reg.numero, v_reg.letra, v_reg.complemento, v_reg.bairro, v_reg.cep, v_reg.cidade, v_reg.sigla_uf,v_reg.reside_desde);
  END LOOP;
  DELETE FROM endereco_externo WHERE idpes = v_idpesVelho;
  --FISICA_CPF--
  --Obtendo enventual CPF da pessoa antiga para ser inserido na pessoa nova--
  FOR v_reg IN SELECT cpf FROM fisica_cpf WHERE idpes = v_idpesVelho AND idpes <> v_idpesNovo LOOP
    v_cpfAux := v_reg.cpf;
  END LOOP;
  DELETE FROM fisica_cpf WHERE idpes = v_idpesVelho;
  IF v_cpfAux IS NOT NULL THEN
    FOR v_reg IN SELECT cpf FROM fisica_cpf WHERE idpes = v_idpesNovo LOOP
      v_cpfIdpesNovo := v_reg.cpf;
    END LOOP;
    --Verificando se o idpess já possuí um CPF--
    IF v_cpfIdpesNovo IS NULL THEN
      INSERT INTO fisica_cpf (idpes, cpf) VALUES (v_idpesNovo,v_cpfAux);
    END IF;
  END IF;
  --FUNCIONARIO--
  UPDATE funcionario SET idpes = v_idpesNovo WHERE idpes = v_idpesVelho;
  --DOCUMENTO--
  DELETE FROM documento WHERE idpes = v_idpesVelho;
  --FISICA--
  DELETE FROM fisica WHERE idpes = v_idpesVelho;
  --PESSOA--
  DELETE FROM pessoa WHERE idpes = v_idpesVelho;
  RETURN 0;
END;$_$;


--
-- TOC entry 893 (class 1255 OID 9442817)
-- Name: fcn_unifica_cmf(numeric, numeric); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_unifica_cmf(numeric, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parametro recebidos
  v_idpesVelho ALIAS for $1;
  v_idpesNovo ALIAS for $2;

BEGIN
  --Unificando registros do SECM (Sistema de Emissao de Certidoes Municipais)--
  EXECUTE 'SELECT consistenciacao.fcn_unifica_secm('||v_idpesVelho||','||v_idpesNovo||');';
  --Unificando as tabelas do sistema de SGDO (Sistema de Gestao de Despesas Orcamentarias)--
  EXECUTE 'SELECT consistenciacao.fcn_unifica_sgdo('||v_idpesVelho||','||v_idpesNovo||');';
  --Unificando as tabelas do sistema de SGP (Sistema de Gerenciamento de Protocolo)--
  EXECUTE 'SELECT consistenciacao.fcn_unifica_sgp('||v_idpesVelho||','||v_idpesNovo||');';
  --Unificando as tabelas do sistema de SGPA (Sistema de Gestao da Praca de Atendimento)--
  EXECUTE 'SELECT consistenciacao.fcn_unifica_sgpa('||v_idpesVelho||','||v_idpesNovo||');';
  --Unificando as tabelas do sistema de SGSP (Sistema de Gerenciamento de Servicos consistenciacaoos)--
  EXECUTE 'SELECT consistenciacao.fcn_unifica_sgsp('||v_idpesVelho||','||v_idpesNovo||');';
      --Unificando registros das tabelas do SCD (Sistema de Consintenciacao de Dados)--
   EXECUTE 'SELECT consistenciacao.fcn_unifica_scd('||v_idpesVelho||','||v_idpesNovo||');';
  --Unificando registros das tabelas do SCA (Controle de acesso)--
  EXECUTE 'SELECT consistenciacao.fcn_unifica_sca('||v_idpesVelho||','||v_idpesNovo||');';
  --Unificando registros das tabelas de cadastro--
   EXECUTE 'SELECT consistenciacao.fcn_unifica_cadastro('||v_idpesVelho||','||v_idpesNovo||');';
  RETURN 0;
END;$_$;


--
-- TOC entry 888 (class 1255 OID 9442818)
-- Name: fcn_unifica_sca(numeric, numeric); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_unifica_sca(numeric, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  --Parametro recebidos--
  v_idpesVelho ALIAS for $1;
  v_idpesNovo  ALIAS for $2;
  v_loginAux   varchar;
  v_reg      record;
BEGIN
  --Unificando registros das tabelas do SCA (Sistema de Controle de Acesso)--
  SET search_path = acesso, pg_catalog;
  --PESSOA_INSTITUICAO--
  --Inserindo as instituicoes do idvelho para o id novo--
  FOR v_reg IN SELECT *
               FROM pessoa_instituicao
               WHERE
         idpes = v_idpesVelho AND
         idins NOT IN
        (SELECT idins FROM
         pessoa_instituicao
         WHERE idpes = v_idpesNovo) LOOP
    INSERT INTO pessoa_instituicao (idpes,idins) VALUES (v_idpesNovo, v_reg.idins);
  END LOOP;
  --Apagando os registro do id velho--
  EXECUTE 'DELETE FROM pessoa_instituicao WHERE idpes = '||v_idpesVelho||';';
  --LOG_ACESSO--
  EXECUTE 'UPDATE log_acesso SET idpes ='||v_idpesNovo||' WHERE idpes = '||v_idpesVelho||';';
  --USUARIO_GRUPO--
  --Obtendo o login do novo idpes para ser usado na unificacao da tabela usuario_grupo--
  FOR v_reg IN SELECT login FROM usuario WHERE idpes = v_idpesNovo LOOP
    v_loginAux := v_reg.login;
  END LOOP;
  --Inserindo os grupos do idpes velho para o idpes novo--
  FOR v_reg IN SELECT *
         FROM usuario_grupo
         WHERE
         login IN (SELECT login FROM usuario WHERE idpes = v_idpesVelho) AND
         idgrp NOT IN (SELECT idgrp
                       FROM usuario_grupo
           WHERE
           login = v_loginAux) LOOP
    INSERT INTO usuario_grupo (idgrp,login) VALUES (v_reg.idgrp, v_loginAux);
  END LOOP;
  --Deletando os registros do idpes velho--
  EXECUTE 'DELETE FROM usuario_grupo
            WHERE login IN
         (SELECT login FROM usuario WHERE idpes ='|| v_idpesVelho ||');';
  --LOG_ERRO--
  EXECUTE 'UPDATE log_erro SET idpes = '||v_idpesNovo||' WHERE idpes = '||v_idpesVelho||';';

  --USUARIO--
  EXECUTE 'DELETE FROM usuario WHERE idpes ='|| v_idpesVelho||';';
  RETURN 0;
END;$_$;


--
-- TOC entry 894 (class 1255 OID 9442819)
-- Name: fcn_unifica_scd(numeric, numeric); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_unifica_scd(numeric, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parametro recebidos
  v_idpesVelho ALIAS for $1;
  v_idpesNovo  ALIAS for $2;
BEGIN
  --Unificando registros das tabelas do SCD (Sistema de Consintenciacao de Dados)--
  SET search_path = consistenciacao, pg_catalog;
  --INCOERENCIA--
  UPDATE incoerencia_pessoa_possivel SET idpes =  v_idpesNovo WHERE idpes = v_idpesVelho;
  --CONFRONTACAO--
  UPDATE confrontacao SET idpes =  v_idpesNovo WHERE idpes = v_idpesVelho;
  RETURN 0;
END;$_$;


--
-- TOC entry 895 (class 1255 OID 9442820)
-- Name: fcn_unifica_sgp(numeric, numeric); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_unifica_sgp(numeric, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parametro recebidos
  v_idpesVelho ALIAS for $1;
  v_idpesNovo ALIAS for $2;
BEGIN
  --Unificando as tabelas do sistema de SGP (Sistema de Gerenciamento de Protocolo)--
  SET search_path = protocolo, pg_catalog;
  --ATIVIDADE--
  UPDATE atividade SET idpes_ini = v_idpesNovo WHERE idpes_ini = v_idpesVelho;
  UPDATE atividade SET idpes_fim = v_idpesNovo WHERE idpes_fim = v_idpesVelho;
  --LOG_FUNC_PROCESSO--
  UPDATE log_func_processo SET idpes = v_idpesNovo WHERE idpes = v_idpesVelho;
  --PROCESSO--
  UPDATE processo SET idpesreq = v_idpesNovo WHERE idpesreq = v_idpesVelho;
  UPDATE processo SET idpesfav = v_idpesNovo WHERE idpesfav = v_idpesVelho;
  --TEMP_ATIVIDADE--
  UPDATE temp_atividade SET idpes = v_idpesNovo WHERE idpes = v_idpesVelho;
  RETURN 0;
END;$_$;


--
-- TOC entry 896 (class 1255 OID 9442821)
-- Name: fcn_unifica_sgpa(numeric, numeric); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_unifica_sgpa(numeric, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parametro recebidos
  v_idpesVelho  ALIAS for $1;
  v_idpesNovo   ALIAS for $2;
  v_reg       record;
  v_idAtnVelho  numeric;
  v_idAtnNovo numeric;
BEGIN
  --Unificando as tabelas do sistema de SGPA (Sistema de getao da Praca de Atendimento)--
  SET search_path = praca, pg_catalog;
  --Obtendo o id do atendente velho para poder fazer UPDATE nas tabelas para o id do atendeentente novo--
  FOR v_reg IN SELECT idatn FROM atendente WHERE idpes = v_idpesVelho LOOP
    v_idAtnVelho := v_reg.idatn;
  END LOOP;
  FOR v_reg IN SELECT idatn FROM atendente WHERE idpes = v_idpesNovo LOOP
    v_idAtnNovo := v_reg.idatn;
  END LOOP;
  --ATENDIMENTO--
  UPDATE atendimento SET idpes = v_idpesNovo WHERE idpes = v_idpesVelho;
  UPDATE atendimento SET idatn = v_idAtnNovo WHERE idatn = v_idAtnVelho;
  --TURNO_ATENDENTE--
  FOR v_reg IN SELECT * FROM turno_atendente
         WHERE
         idatn = v_idAtnVelho AND
         idtur NOT IN (SELECT idtur FROM turno_atendente WHERE idatn = v_idAtnNovo) LOOP
    INSERT INTO turno_atendente (idmes,idins,idatn,idtur) VALUES (v_reg.idmes, v_reg.idins, v_idAtnNovo,v_reg.idtur);
  END LOOP;
  DELETE FROM turno_atendente WHERE idatn = v_idAtnVelho;
  --AUSENCIA--
  UPDATE ausencia SET idatn = v_idAtnNovo WHERE idatn = v_idAtnVelho;
  --SITUCAO_ATENDENTE--
  UPDATE situacao_atendente SET idatn = v_idAtnNovo WHERE idatn = v_idAtnVelho;
  --PRODUTIVIDADE--
  UPDATE produtividade SET idatn = v_idAtnNovo WHERE idatn = v_idAtnVelho;
  --ATENDENTE--
  DELETE FROM atendente WHERE idpes = v_idpesVelho;
  RETURN 0;
END;$_$;


--
-- TOC entry 898 (class 1255 OID 9442822)
-- Name: fcn_unifica_sgsp(numeric, numeric); Type: FUNCTION; Schema: consistenciacao; Owner: -
--

CREATE FUNCTION consistenciacao.fcn_unifica_sgsp(numeric, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parametro recebidos
  v_idpesVelho ALIAS for $1;
  v_idpesNovo  ALIAS for $2;
  v_reg      record;
BEGIN
  --Unificando registros das tabelas do SGSP (Sistema de Gererenciamento de Serviços Públicos)--
  SET search_path = servicos, pg_catalog;
  --FUNCIONARIO_AUTORIZADO--
  FOR v_reg IN SELECT *
         FROM funcionario_autorizado
         WHERE
         idpes = v_idpesVelho AND
         idpes <> v_idpesNovo LOOP
    INSERT INTO funcionario_autorizado (idpes, idins) VALUES (v_idpesNovo, v_reg.idins);
  END LOOP;
  --SOLICITACAO_SERVICO--
  UPDATE solicitacao_servico SET idpes_atendente = v_idpesNovo WHERE idpes_atendente = v_idpesVelho;
  UPDATE solicitacao_servico SET idpes_planejamento = v_idpesNovo WHERE idpes_planejamento = v_idpesVelho;
  --SOLICITANTE--
  UPDATE solicitante SET idpes = v_idpesNovo WHERE idpes = v_idpesVelho;
  --ORDEM_SERVICO--
  UPDATE ordem_servico SET idpes = v_idpesNovo WHERE idpes = v_idpesVelho;
  --APROVACAO--
  UPDATE aprovacao SET idpes_resposta = v_idpesNovo WHERE idpes_resposta = v_idpesVelho;
  --AUTORIZACAO_DIARIA--
  UPDATE autorizacao_diaria SET idpes_usuario = v_idpesNovo WHERE idpes_usuario = v_idpesVelho;
  UPDATE autorizacao_diaria SET idpes_autorizacao = v_idpesNovo WHERE idpes_autorizacao = v_idpesVelho;
  --FUNCIONARIO_AUTORIZADO--
  DELETE FROM funcionario_autorizado WHERE idpes = v_idpesVelho;
  RETURN 0;
END;$_$;


--
-- TOC entry 899 (class 1255 OID 9442823)
-- Name: pr_normaliza_enderecos(); Type: FUNCTION; Schema: conv_functions; Owner: -
--

CREATE FUNCTION conv_functions.pr_normaliza_enderecos() RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
cur 	record;
i_counter integer;
i_idmun integer;
i_iddis integer;
i_idbai integer;
i_idlog integer;

BEGIN

i_counter := 0;

for cur in SELECT
      ee.idpes,
      ee.idtlog,
      ee.logradouro,
      ee.numero,
      ee.letra,
      ee.complemento,
      ee.bairro,
      ee.cep,
      ee.bloco,
      ee.andar,
      ee.cidade,
      ee.zona_localizacao,
      upper(ee.sigla_uf) as sigla_uf

    FROM cadastro.pessoa p
    LEFT JOIN cadastro.endereco_pessoa ep
      ON ep.idpes = p.idpes
    LEFT JOIN cadastro.endereco_externo ee
      ON ee.idpes = p.idpes
    WHERE ep.idpes is null
    and ee.idpes is not null loop

  i_counter := i_counter + 1;

  i_idmun := 0;
  i_iddis := 0;
  i_idbai := 0;
  i_idlog := 0;

  raise notice 'counter: %', i_counter;

  SELECT COALESCE((select m.idmun
            from public.municipio m
            WHERE unaccent(nome) ilike unaccent(cur.cidade)
            AND sigla_uf = cur.sigla_uf
            LIMIT 1),0) INTO i_idmun;

  If i_idmun = 0 then
    INSERT INTO public.municipio (nome, sigla_uf, tipo, idpes_cad, data_cad, origem_gravacao, operacao, idsis_cad)
      VALUES (cur.cidade, cur.sigla_uf, 'M', 1, NOW(), 'M', 'I', 9) RETURNING idmun INTO i_idmun ;
  End if;

  SELECT COALESCE((SELECT b.idbai
              FROM public.bairro b
              WHERE trim(unaccent(nome)) ilike trim(unaccent(cur.bairro))
              AND b.idmun = i_idmun
              LIMIT 1),0) INTO i_idbai;

  If i_idbai = 0 then
    SELECT COALESCE((SELECT d.iddis
                  FROM public.distrito d
                  WHERE d.idmun = i_idmun
                  LIMIT 1),0) INTO i_iddis;


    If i_iddis = 0 then
      INSERT INTO public.distrito (idmun, nome, origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad)
        VALUES (i_idmun, cur.cidade, 'M', 1, now(), 'I', 1) returning iddis INTO i_iddis;
    End if;

    INSERT INTO public.bairro (idmun, iddis, nome, origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad, zona_localizacao)
      VALUES (i_idmun, i_iddis, cur.bairro, 'M', 1, NOW(), 'I', 1, cur.zona_localizacao) RETURNING idbai INTO i_idbai;
  End if;

  SELECT COALESCE((SELECT idlog
    FROM public.logradouro
    WHERE idmun = i_idmun
    AND trim(unaccent(nome)) ILIKE trim(unaccent(cur.logradouro))
    LIMIT 1
    ),0) INTO i_idlog;

  If i_idlog = 0 THEN
    INSERT INTO public.logradouro (idtlog, nome, idmun, ident_oficial, origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad)
    VALUES (cur.idtlog, cur.logradouro, i_idmun, 'S', 'M', 1, NOW(), 'I', 1) RETURNING idlog INTO i_idlog;

  End if;

  If NOT EXISTS (SELECT 1
              FROM urbano.cep_logradouro
              WHERE cep = cur.cep
              AND idlog = i_idlog) THEN
    INSERT INTO urbano.cep_logradouro (cep, idlog, origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad)
      VALUES (cur.cep, i_idlog, 'M', 1, NOW(), 'I', 1);
  END if;

  If NOT EXISTS (SELECT 1
              FROM urbano.cep_logradouro_bairro
              WHERE cep = cur.cep
              AND idlog = i_idlog
              AND idbai = i_idbai
              ) THEN
    INSERT INTO urbano.cep_logradouro_bairro (cep, idlog, idbai, origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad)
      VALUES (cur.cep, i_idlog, i_idbai, 'M', 1, NOW(), 'I', 1);
  END if;

  INSERT INTO cadastro.endereco_pessoa (idpes, tipo, cep, idlog, numero, letra, complemento, idbai, bloco, andar,  origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad)
    VALUES (cur.idpes, 1, cur.cep, i_idlog, cur.numero, cur.letra, cur.complemento, i_idbai, cur.bloco, cur.andar, 'M', 1, NOW(), 'I', 1);

end loop;

end;
$$;


--
-- TOC entry 900 (class 1255 OID 9442824)
-- Name: fcn_delete_grava_historico_bairro(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_delete_grava_historico_bairro() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idbai    numeric;
   v_idmun    numeric;
   v_nome   varchar;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
BEGIN
   v_idbai    := OLD.idbai;
   v_idmun    := OLD.idmun;
   v_nome   := OLD.nome;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA BAIRRO
      INSERT INTO historico.bairro
      (idbai, idmun, nome, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idbai, v_idmun, v_nome, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


--
-- TOC entry 901 (class 1255 OID 9442825)
-- Name: fcn_delete_grava_historico_cep_logradouro(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_delete_grava_historico_cep_logradouro() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_cep    numeric;
   v_idlog    numeric;
   v_nroini   numeric;
   v_nrofin   numeric;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
BEGIN
   v_cep    := OLD.cep;
   v_idlog    := OLD.idlog;
   v_nroini   := OLD.nroini;
   v_nrofin   := OLD.nrofin;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA CEP_LOGRADOURO
      INSERT INTO historico.cep_logradouro
      (cep, idlog, nroini, nrofin, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_cep, v_idlog, v_nroini, v_nrofin, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


--
-- TOC entry 902 (class 1255 OID 9442826)
-- Name: fcn_delete_grava_historico_cep_logradouro_bairro(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_delete_grava_historico_cep_logradouro_bairro() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idbai    numeric;
   v_idlog    numeric;
   v_cep    numeric;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
   v_operacao   char(1);
BEGIN
   v_idbai    := OLD.idbai;
   v_idlog    := OLD.idlog;
   v_cep    := OLD.cep;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA CEP_LOGRADOURO_BAIRRO
      INSERT INTO historico.cep_logradouro_bairro
      (idbai, idlog, cep, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idbai, v_idlog, v_cep, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


--
-- TOC entry 903 (class 1255 OID 9442827)
-- Name: fcn_delete_grava_historico_documento(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_delete_grava_historico_documento() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes    numeric;
   v_sigla_uf_exp_rg  char(2);
   v_rg     numeric;
   v_data_exp_rg  date;
   v_tipo_cert_civil  numeric;
   v_num_termo    numeric;
   v_num_livro    varchar;
   v_num_folha    numeric;
   v_data_emissao_cert_civil  date;
   v_sigla_uf_cert_civil  char(2);
   v_sigla_uf_cart_trabalho char(2);
   v_cartorio_cert_civil  varchar;
   v_num_cart_trabalho    numeric;
   v_serie_cart_trabalho  numeric;
   v_data_emissao_cart_trabalho date;
   v_num_tit_eleitor  numeric;
   v_zona_tit_eleitor numeric;
   v_secao_tit_eleitor  numeric;
   v_idorg_exp_rg   numeric;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
BEGIN
   v_idpes      := OLD.idpes;
   v_sigla_uf_exp_rg    := OLD.sigla_uf_exp_rg;
   v_rg       := OLD.rg;
   v_data_exp_rg    := OLD.data_exp_rg;
   v_tipo_cert_civil    := OLD.tipo_cert_civil;
   v_num_termo      := OLD.num_termo;
   v_num_livro      := OLD.num_livro;
   v_num_folha      := OLD.num_folha;
   v_data_emissao_cert_civil  := OLD.data_emissao_cert_civil;
   v_sigla_uf_cert_civil  := OLD.sigla_uf_cert_civil;
   v_sigla_uf_cart_trabalho := OLD.sigla_uf_cart_trabalho;
   v_cartorio_cert_civil  := OLD.cartorio_cert_civil;
   v_num_cart_trabalho    := OLD.num_cart_trabalho;
   v_serie_cart_trabalho  := OLD.serie_cart_trabalho;
   v_data_emissao_cart_trabalho := OLD.data_emissao_cart_trabalho;
   v_num_tit_eleitor    := OLD.num_tit_eleitor;
   v_zona_tit_eleitor   := OLD.zona_tit_eleitor;
   v_secao_tit_eleitor    := OLD.secao_tit_eleitor;
   v_idorg_exp_rg   := OLD.idorg_exp_rg;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA DOCUMENTO
      INSERT INTO historico.documento
      (idpes, sigla_uf_exp_rg, rg, data_exp_rg, tipo_cert_civil, num_termo, num_livro, num_folha, data_emissao_cert_civil, sigla_uf_cert_civil, sigla_uf_cart_trabalho, cartorio_cert_civil, num_cart_trabalho, serie_cart_trabalho, data_emissao_cart_trabalho, num_tit_eleitor, zona_tit_eleitor, secao_tit_eleitor, idorg_exp_rg, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_sigla_uf_exp_rg, v_rg, v_data_exp_rg, v_tipo_cert_civil, v_num_termo, v_num_livro, v_num_folha, v_data_emissao_cert_civil, v_sigla_uf_cert_civil, v_sigla_uf_cart_trabalho, v_cartorio_cert_civil, v_num_cart_trabalho, v_serie_cart_trabalho, v_data_emissao_cart_trabalho, v_num_tit_eleitor, v_zona_tit_eleitor, v_secao_tit_eleitor, v_idorg_exp_rg, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


--
-- TOC entry 905 (class 1255 OID 9442828)
-- Name: fcn_delete_grava_historico_endereco_externo(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_delete_grava_historico_endereco_externo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes    numeric;
   v_tipo   numeric;
   v_sigla_uf   char(2);
   v_idtlog   varchar;
   v_logradouro   varchar;
   v_numero   numeric;
   v_letra    char(1);
   v_complemento  varchar;
   v_bairro   varchar;
   v_cep    numeric;
   v_cidade   varchar;
   v_reside_desde date;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
BEGIN
   v_idpes      := OLD.idpes;
   v_tipo     := OLD.tipo;
   v_sigla_uf     := OLD.sigla_uf;
   v_idtlog     := OLD.idtlog;
   v_logradouro     := OLD.logradouro;
   v_numero     := OLD.numero;
   v_letra      := OLD.letra;
   v_complemento    := OLD.complemento;
   v_bairro     := OLD.bairro;
   v_cep      := OLD.cep;
   v_cidade     := OLD.cidade;
   v_reside_desde   := OLD.reside_desde;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA ENDERECO_EXTERNO
      INSERT INTO historico.endereco_externo
      (idpes, tipo, sigla_uf, idtlog, logradouro, numero, letra, complemento, bairro, cep, cidade, reside_desde, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_tipo, v_sigla_uf, v_idtlog, v_logradouro, v_numero, v_letra, v_complemento, v_bairro, v_cep, v_cidade, v_reside_desde, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


--
-- TOC entry 906 (class 1255 OID 9442829)
-- Name: fcn_delete_grava_historico_endereco_pessoa(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_delete_grava_historico_endereco_pessoa() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes    numeric;
   v_tipo   numeric;
   v_cep    numeric;
   v_idlog    numeric;
   v_idbai    numeric;
   v_numero   numeric;
   v_letra    char(1);
   v_complemento  varchar;
   v_reside_desde date;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
BEGIN
   v_idpes    := OLD.idpes;
   v_tipo   := OLD.tipo;
   v_cep    := OLD.cep;
   v_idlog    := OLD.idlog;
   v_idbai    := OLD.idbai;
   v_numero   := OLD.numero;
   v_letra    := OLD.letra;
   v_complemento  := OLD.complemento;
   v_reside_desde := OLD.reside_desde;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA ENDERECO_PESSOA
      INSERT INTO historico.endereco_pessoa
      (idpes, tipo, cep, idlog, idbai, numero, letra, complemento, reside_desde, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_tipo, v_cep, v_idlog, v_idbai, v_numero, v_letra, v_complemento, v_reside_desde, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


--
-- TOC entry 907 (class 1255 OID 9442830)
-- Name: fcn_delete_grava_historico_fisica(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_delete_grava_historico_fisica() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes      numeric;
   v_data_nasc      date;
   v_sexo     char(1);
   v_idpes_mae      numeric;
   v_idpes_pai      numeric;
   v_idpes_responsavel    numeric;
   v_idesco     numeric;
   v_ideciv     numeric;
   v_idpes_con      numeric;
   v_data_uniao     date;
   v_data_obito     date;
   v_nacionalidade    numeric;
   v_idpais_estrangeiro   numeric;
   v_data_chegada_brasil  date;
   v_idmun_nascimento   numeric;
   v_ultima_empresa   varchar;
   v_idocup     numeric;
   v_nome_mae     varchar;
   v_nome_pai     varchar;
   v_nome_conjuge   varchar;
   v_nome_responsavel   varchar;
   v_justificativa_provisorio varchar;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
BEGIN
   v_idpes      := OLD.idpes;
   v_data_nasc      := OLD.data_nasc;
   v_sexo     := OLD.sexo;
   v_idpes_mae      := OLD.idpes_mae;
   v_idpes_pai      := OLD.idpes_pai;
   v_idpes_responsavel    := OLD.idpes_responsavel;
   v_idesco     := OLD.idesco;
   v_ideciv     := OLD.ideciv;
   v_idpes_con      := OLD.idpes_con;
   v_data_uniao     := OLD.data_uniao;
   v_data_obito     := OLD.data_obito;
   v_nacionalidade    := OLD.nacionalidade;
   v_idpais_estrangeiro   := OLD.idpais_estrangeiro;
   v_data_chegada_brasil  := OLD.data_chegada_brasil;
   v_idmun_nascimento   := OLD.idmun_nascimento;
   v_ultima_empresa   := OLD.ultima_empresa;
   v_idocup     := OLD.idocup;
   v_nome_mae     := OLD.nome_mae;
   v_nome_pai     := OLD.nome_pai;
   v_nome_conjuge   := OLD.nome_conjuge;
   v_nome_responsavel   := OLD.nome_responsavel;
   v_justificativa_provisorio := OLD.justificativa_provisorio;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA FISICA
      INSERT INTO historico.fisica
      (idpes, data_nasc, sexo, idpes_mae, idpes_pai, idpes_responsavel, idesco, ideciv, idpes_con, data_uniao, data_obito, nacionalidade, idpais_estrangeiro, data_chegada_brasil, idmun_nascimento, ultima_empresa, idocup, nome_mae, nome_pai, nome_conjuge, nome_responsavel, justificativa_provisorio, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_data_nasc, v_sexo, v_idpes_mae, v_idpes_pai, v_idpes_responsavel, v_idesco, v_ideciv, v_idpes_con, v_data_uniao, v_data_obito, v_nacionalidade, v_idpais_estrangeiro, v_data_chegada_brasil, v_idmun_nascimento, v_ultima_empresa, v_idocup, v_nome_mae, v_nome_pai, v_nome_conjuge, v_nome_responsavel, v_justificativa_provisorio, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


--
-- TOC entry 908 (class 1255 OID 9442831)
-- Name: fcn_delete_grava_historico_fisica_cpf(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_delete_grava_historico_fisica_cpf() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes      numeric;
   v_cpf      numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
BEGIN
   v_idpes      := OLD.idpes;
   v_cpf      := OLD.cpf;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA FISICA_CPF
      INSERT INTO historico.fisica_cpf
      (idpes, cpf, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_cpf, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


--
-- TOC entry 909 (class 1255 OID 9442832)
-- Name: fcn_delete_grava_historico_fone_pessoa(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_delete_grava_historico_fone_pessoa() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes      numeric;
   v_tipo     numeric;
   v_ddd      numeric;
   v_fone     numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
BEGIN
   v_idpes      := OLD.idpes;
   v_tipo     := OLD.tipo;
   v_ddd      := OLD.ddd;
   v_fone     := OLD.fone;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA FONE_PESSOA
      INSERT INTO historico.fone_pessoa
      (idpes, tipo, ddd, fone, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_tipo, v_ddd, v_fone, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


--
-- TOC entry 910 (class 1255 OID 9442833)
-- Name: fcn_delete_grava_historico_funcionario(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_delete_grava_historico_funcionario() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_matricula      numeric;
   v_idins      numeric;
   v_idset      numeric;
   v_idpes      numeric;
   v_situacao     char(1);
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
BEGIN
   v_matricula      := OLD.matricula;
   v_idins      := OLD.idins;
   v_idset      := OLD.idset;
   v_idpes      := OLD.idpes;
   v_situacao     := OLD.situacao;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA FUNCIONARIO
      INSERT INTO historico.funcionario
      (matricula, idins, idset, idpes, situacao, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_matricula, v_idins, v_idset, v_idpes, v_situacao, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


--
-- TOC entry 911 (class 1255 OID 9442834)
-- Name: fcn_delete_grava_historico_juridica(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_delete_grava_historico_juridica() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes      numeric;
   v_cnpj     numeric;
   v_fantasia     varchar;
   v_insc_estadual    numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
BEGIN
   v_idpes      := OLD.idpes;
   v_cnpj     := OLD.cnpj;
   v_fantasia     := OLD.fantasia;
   v_insc_estadual    := OLD.insc_estadual;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA JURIDICA
      INSERT INTO historico.juridica
      (idpes, cnpj, fantasia, insc_estadual, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_cnpj, v_fantasia, v_insc_estadual, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


--
-- TOC entry 912 (class 1255 OID 9442835)
-- Name: fcn_delete_grava_historico_logradouro(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_delete_grava_historico_logradouro() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idlog      numeric;
   v_idtlog     varchar;
   v_nome     varchar;
   v_idmun      numeric;
   v_ident_oficial    char(1);
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
BEGIN
   v_idlog      := OLD.idlog;
   v_idtlog     := OLD.idtlog;
   v_nome     := OLD.nome;
   v_idmun      := OLD.idmun;
   v_ident_oficial    := OLD.ident_oficial;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA LOGRADOURO
      INSERT INTO historico.logradouro
      (idlog, idtlog, nome, idmun, ident_oficial, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idlog, v_idtlog, v_nome, v_idmun, v_ident_oficial, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


--
-- TOC entry 913 (class 1255 OID 9442836)
-- Name: fcn_delete_grava_historico_municipio(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_delete_grava_historico_municipio() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idmun      numeric;
   v_sigla_uf     char(2);
   v_nome     varchar;
   v_area_km2     numeric;
   v_idmreg     numeric;
   v_idasmun      numeric;
   v_cod_ibge     numeric;
   v_geom     TEXT;
   v_tipo     char(1);
   v_idmun_pai      numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
BEGIN
   v_idmun      := OLD.idmun;
   v_sigla_uf     := OLD.sigla_uf;
   v_nome     := OLD.nome;
   v_area_km2     := OLD.area_km2;
   v_idmreg     := OLD.idmreg;
   v_idasmun      := OLD.idasmun;
   v_cod_ibge     := OLD.cod_ibge;
   v_geom     := OLD.geom;
   v_tipo     := OLD.tipo;
   v_idmun_pai      := OLD.idmun_pai;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA MUNICIPIO
      INSERT INTO historico.municipio
      (idmun, sigla_uf, nome, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idmun, v_sigla_uf, v_nome, v_area_km2, v_idmreg, v_idasmun, v_cod_ibge, v_geom, v_tipo, v_idmun_pai, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


--
-- TOC entry 914 (class 1255 OID 9442837)
-- Name: fcn_delete_grava_historico_pessoa(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_delete_grava_historico_pessoa() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes    numeric;
   v_nome   TEXT;
   v_idpes_cad    numeric;
   v_data_cad   timestamp;
   v_url    TEXT;
   v_tipo   char;
   v_idpes_rev    numeric;
   v_data_rev   timestamp;
   v_email    TEXT;
   v_situacao   char;
   v_origem_gravacao  char;
   v_idsis_rev    numeric;
   v_idsis_cad    numeric;
BEGIN
   v_idpes    := OLD.idpes;
   v_nome   := OLD.nome;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_url    := OLD.url;
   v_tipo   := OLD.tipo;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_email    := OLD.email;
   v_situacao   := OLD.situacao;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idsis_cad    := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA PESSOA
      INSERT INTO historico.pessoa
      (idpes, nome, idpes_cad, data_cad, url, tipo, idpes_rev, data_rev, email, situacao, origem_gravacao, idsis_rev, idsis_cad, operacao) VALUES
      (v_idpes, v_nome, v_idpes_cad, v_data_cad, v_url, v_tipo, v_idpes_rev, v_data_rev, v_email, v_situacao, v_origem_gravacao, v_idsis_rev, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


--
-- TOC entry 915 (class 1255 OID 9442838)
-- Name: fcn_delete_grava_historico_socio(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_delete_grava_historico_socio() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes_juridica   numeric;
   v_idpes_fisica   numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
BEGIN
   v_idpes_juridica   := OLD.idpes_juridica;
   v_idpes_fisica   := OLD.idpes_fisica;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA SOCIO
      INSERT INTO historico.socio
      (idpes_juridica, idpes_fisica, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes_juridica, v_idpes_fisica, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


--
-- TOC entry 916 (class 1255 OID 9442839)
-- Name: fcn_grava_historico_bairro(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_grava_historico_bairro() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idbai    numeric;
   v_idmun    numeric;
   v_nome   varchar;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
   v_operacao   char(1);
BEGIN
   v_idbai    := OLD.idbai;
   v_idmun    := OLD.idmun;
   v_nome   := OLD.nome;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;
   v_operacao   := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA BAIRRO
      INSERT INTO historico.bairro
      (idbai, idmun, nome, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idbai, v_idmun, v_nome, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


--
-- TOC entry 917 (class 1255 OID 9442840)
-- Name: fcn_grava_historico_cep_logradouro(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_grava_historico_cep_logradouro() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_cep    numeric;
   v_idlog    numeric;
   v_nroini   numeric;
   v_nrofin   numeric;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
   v_operacao   char(1);
BEGIN
   v_cep    := OLD.cep;
   v_idlog    := OLD.idlog;
   v_nroini   := OLD.nroini;
   v_nrofin   := OLD.nrofin;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;
   v_operacao   := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA CEP_LOGRADOURO
      INSERT INTO historico.cep_logradouro
      (cep, idlog, nroini, nrofin, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_cep, v_idlog, v_nroini, v_nrofin, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


--
-- TOC entry 918 (class 1255 OID 9442841)
-- Name: fcn_grava_historico_cep_logradouro_bairro(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_grava_historico_cep_logradouro_bairro() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idbai    numeric;
   v_idlog    numeric;
   v_cep    numeric;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
   v_operacao   char(1);
BEGIN
   v_idbai    := OLD.idbai;
   v_idlog    := OLD.idlog;
   v_cep    := OLD.cep;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;
   v_operacao   := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA CEP_LOGRADOURO_BAIRRO
      INSERT INTO historico.cep_logradouro_bairro
      (idbai, idlog, cep, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idbai, v_idlog, v_cep, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


--
-- TOC entry 919 (class 1255 OID 9442842)
-- Name: fcn_grava_historico_documento(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_grava_historico_documento() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes    numeric;
   v_sigla_uf_exp_rg  char(2);
   v_rg     text;
   v_data_exp_rg  date;
   v_tipo_cert_civil  numeric;
   v_num_termo    numeric;
   v_num_livro    varchar;
   v_num_folha    numeric;
   v_data_emissao_cert_civil  date;
   v_sigla_uf_cert_civil  char(2);
   v_sigla_uf_cart_trabalho char(2);
   v_cartorio_cert_civil  varchar;
   v_num_cart_trabalho    numeric;
   v_serie_cart_trabalho  numeric;
   v_data_emissao_cart_trabalho date;
   v_num_tit_eleitor  numeric;
   v_zona_tit_eleitor numeric;
   v_secao_tit_eleitor  numeric;
   v_idorg_exp_rg   numeric;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
   v_operacao   char(1);
BEGIN
   v_idpes      := OLD.idpes;
   v_sigla_uf_exp_rg    := OLD.sigla_uf_exp_rg;
   v_rg       := OLD.rg;
   v_data_exp_rg    := OLD.data_exp_rg;
   v_tipo_cert_civil    := OLD.tipo_cert_civil;
   v_num_termo      := OLD.num_termo;
   v_num_livro      := OLD.num_livro;
   v_num_folha      := OLD.num_folha;
   v_data_emissao_cert_civil  := OLD.data_emissao_cert_civil;
   v_sigla_uf_cert_civil  := OLD.sigla_uf_cert_civil;
   v_sigla_uf_cart_trabalho := OLD.sigla_uf_cart_trabalho;
   v_cartorio_cert_civil  := OLD.cartorio_cert_civil;
   v_num_cart_trabalho    := OLD.num_cart_trabalho;
   v_serie_cart_trabalho  := OLD.serie_cart_trabalho;
   v_data_emissao_cart_trabalho := OLD.data_emissao_cart_trabalho;
   v_num_tit_eleitor    := OLD.num_tit_eleitor;
   v_zona_tit_eleitor   := OLD.zona_tit_eleitor;
   v_secao_tit_eleitor    := OLD.secao_tit_eleitor;
   v_idorg_exp_rg   := OLD.idorg_exp_rg;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA DOCUMENTO
      INSERT INTO historico.documento
      (idpes, sigla_uf_exp_rg, rg, data_exp_rg, tipo_cert_civil, num_termo, num_livro, num_folha, data_emissao_cert_civil, sigla_uf_cert_civil, sigla_uf_cart_trabalho, cartorio_cert_civil, num_cart_trabalho, serie_cart_trabalho, data_emissao_cart_trabalho, num_tit_eleitor, zona_tit_eleitor, secao_tit_eleitor, idorg_exp_rg, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_sigla_uf_exp_rg, v_rg, v_data_exp_rg, v_tipo_cert_civil, v_num_termo, v_num_livro, v_num_folha, v_data_emissao_cert_civil, v_sigla_uf_cert_civil, v_sigla_uf_cart_trabalho, v_cartorio_cert_civil, v_num_cart_trabalho, v_serie_cart_trabalho, v_data_emissao_cart_trabalho, v_num_tit_eleitor, v_zona_tit_eleitor, v_secao_tit_eleitor, v_idorg_exp_rg, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


--
-- TOC entry 920 (class 1255 OID 9442843)
-- Name: fcn_grava_historico_endereco_externo(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_grava_historico_endereco_externo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes    numeric;
   v_tipo   numeric;
   v_sigla_uf   char(2);
   v_idtlog   varchar;
   v_logradouro   varchar;
   v_numero   numeric;
   v_letra    char(1);
   v_complemento  varchar;
   v_bairro   varchar;
   v_cep    numeric;
   v_cidade   varchar;
   v_reside_desde date;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
   v_operacao   char(1);
BEGIN
   v_idpes    := OLD.idpes;
   v_tipo   := OLD.tipo;
   v_sigla_uf   := OLD.sigla_uf;
   v_idtlog   := OLD.idtlog;
   v_logradouro   := OLD.logradouro;
   v_numero   := OLD.numero;
   v_letra    := OLD.letra;
   v_complemento  := OLD.complemento;
   v_bairro   := OLD.bairro;
   v_cep    := OLD.cep;
   v_cidade   := OLD.cidade;
   v_reside_desde := OLD.reside_desde;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;
   v_operacao   := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA ENDERECO_EXTERNO
      INSERT INTO historico.endereco_externo
      (idpes, tipo, sigla_uf, idtlog, logradouro, numero, letra, complemento, bairro, cep, cidade, reside_desde, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_tipo, v_sigla_uf, v_idtlog, v_logradouro, v_numero, v_letra, v_complemento, v_bairro, v_cep, v_cidade, v_reside_desde, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


--
-- TOC entry 922 (class 1255 OID 9442844)
-- Name: fcn_grava_historico_endereco_pessoa(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_grava_historico_endereco_pessoa() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes    numeric;
   v_tipo   numeric;
   v_cep    numeric;
   v_idlog    numeric;
   v_idbai    numeric;
   v_numero   numeric;
   v_letra    char(1);
   v_complemento  varchar;
   v_reside_desde date;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
   v_operacao   char(1);
BEGIN
   v_idpes    := OLD.idpes;
   v_tipo   := OLD.tipo;
   v_cep    := OLD.cep;
   v_idlog    := OLD.idlog;
   v_idbai    := OLD.idbai;
   v_numero   := OLD.numero;
   v_letra    := OLD.letra;
   v_complemento  := OLD.complemento;
   v_reside_desde := OLD.reside_desde;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;
   v_operacao   := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA ENDERECO_PESSOA
      INSERT INTO historico.endereco_pessoa
      (idpes, tipo, cep, idlog, idbai, numero, letra, complemento, reside_desde, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_tipo, v_cep, v_idlog, v_idbai, v_numero, v_letra, v_complemento, v_reside_desde, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


--
-- TOC entry 923 (class 1255 OID 9442845)
-- Name: fcn_grava_historico_fisica(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_grava_historico_fisica() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes      numeric;
   v_data_nasc      date;
   v_sexo     char(1);
   v_idpes_mae      numeric;
   v_idpes_pai      numeric;
   v_idpes_responsavel    numeric;
   v_idesco     numeric;
   v_ideciv     numeric;
   v_idpes_con      numeric;
   v_data_uniao     date;
   v_data_obito     date;
   v_nacionalidade    numeric;
   v_idpais_estrangeiro   numeric;
   v_data_chegada_brasil  date;
   v_idmun_nascimento   numeric;
   v_ultima_empresa   varchar;
   v_idocup     numeric;
   v_nome_mae     varchar;
   v_nome_pai     varchar;
   v_nome_conjuge   varchar;
   v_nome_responsavel   varchar;
   v_justificativa_provisorio varchar;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
   v_operacao     char(1);
BEGIN
   v_idpes      := OLD.idpes;
   v_data_nasc      := OLD.data_nasc;
   v_sexo     := OLD.sexo;
   v_idpes_mae      := OLD.idpes_mae;
   v_idpes_pai      := OLD.idpes_pai;
   v_idpes_responsavel    := OLD.idpes_responsavel;
   v_idesco     := OLD.idesco;
   v_ideciv     := OLD.ideciv;
   v_idpes_con      := OLD.idpes_con;
   v_data_uniao     := OLD.data_uniao;
   v_data_obito     := OLD.data_obito;
   v_nacionalidade    := OLD.nacionalidade;
   v_idpais_estrangeiro   := OLD.idpais_estrangeiro;
   v_data_chegada_brasil  := OLD.data_chegada_brasil;
   v_idmun_nascimento   := OLD.idmun_nascimento;
   v_ultima_empresa   := OLD.ultima_empresa;
   v_idocup     := OLD.idocup;
   v_nome_mae     := OLD.nome_mae;
   v_nome_pai     := OLD.nome_pai;
   v_nome_conjuge   := OLD.nome_conjuge;
   v_nome_responsavel   := OLD.nome_responsavel;
   v_justificativa_provisorio := OLD.justificativa_provisorio;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA FISICA
      INSERT INTO historico.fisica
      (idpes, data_nasc, sexo, idpes_mae, idpes_pai, idpes_responsavel, idesco, ideciv, idpes_con, data_uniao, data_obito, nacionalidade, idpais_estrangeiro, data_chegada_brasil, idmun_nascimento, ultima_empresa, idocup, nome_mae, nome_pai, nome_conjuge, nome_responsavel, justificativa_provisorio, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_data_nasc, v_sexo, v_idpes_mae, v_idpes_pai, v_idpes_responsavel, v_idesco, v_ideciv, v_idpes_con, v_data_uniao, v_data_obito, v_nacionalidade, v_idpais_estrangeiro, v_data_chegada_brasil, v_idmun_nascimento, v_ultima_empresa, v_idocup, v_nome_mae, v_nome_pai, v_nome_conjuge, v_nome_responsavel, v_justificativa_provisorio, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


--
-- TOC entry 925 (class 1255 OID 9442846)
-- Name: fcn_grava_historico_fisica_cpf(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_grava_historico_fisica_cpf() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes      numeric;
   v_cpf      numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
   v_operacao     char(1);
BEGIN
   v_idpes      := OLD.idpes;
   v_cpf      := OLD.cpf;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA FISICA_CPF
      INSERT INTO historico.fisica_cpf
      (idpes, cpf, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_cpf, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


--
-- TOC entry 926 (class 1255 OID 9442847)
-- Name: fcn_grava_historico_fone_pessoa(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_grava_historico_fone_pessoa() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes      numeric;
   v_tipo     numeric;
   v_ddd      numeric;
   v_fone     numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
   v_operacao     char(1);
BEGIN
   v_idpes      := OLD.idpes;
   v_tipo     := OLD.tipo;
   v_ddd      := OLD.ddd;
   v_fone     := OLD.fone;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA FONE_PESSOA
      INSERT INTO historico.fone_pessoa
      (idpes, tipo, ddd, fone, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_tipo, v_ddd, v_fone, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


--
-- TOC entry 927 (class 1255 OID 9442848)
-- Name: fcn_grava_historico_funcionario(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_grava_historico_funcionario() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_matricula      numeric;
   v_idins      numeric;
   v_idset      numeric;
   v_idpes      numeric;
   v_situacao     char(1);
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
   v_operacao     char(1);
BEGIN
   v_matricula      := OLD.matricula;
   v_idins      := OLD.idins;
   v_idset      := OLD.idset;
   v_idpes      := OLD.idpes;
   v_situacao     := OLD.situacao;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA FUNCIONARIO
      INSERT INTO historico.funcionario
      (matricula, idins, idset, idpes, situacao, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_matricula, v_idins, v_idset, v_idpes, v_situacao, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


--
-- TOC entry 929 (class 1255 OID 9442849)
-- Name: fcn_grava_historico_juridica(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_grava_historico_juridica() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes      numeric;
   v_cnpj     numeric;
   v_fantasia     varchar;
   v_insc_estadual    numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
   v_operacao     char(1);
BEGIN
   v_idpes      := OLD.idpes;
   v_cnpj     := OLD.cnpj;
   v_fantasia     := OLD.fantasia;
   v_insc_estadual    := OLD.insc_estadual;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA JURIDICA
      INSERT INTO historico.juridica
      (idpes, cnpj, fantasia, insc_estadual, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_cnpj, v_fantasia, v_insc_estadual, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


--
-- TOC entry 930 (class 1255 OID 9442850)
-- Name: fcn_grava_historico_logradouro(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_grava_historico_logradouro() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idlog      numeric;
   v_idtlog     varchar;
   v_nome     varchar;
   v_idmun      numeric;
   v_ident_oficial    char(1);
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
   v_operacao     char(1);
BEGIN
   v_idlog      := OLD.idlog;
   v_idtlog     := OLD.idtlog;
   v_nome     := OLD.nome;
   v_idmun      := OLD.idmun;
   v_ident_oficial    := OLD.ident_oficial;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA LOGRADOURO
      INSERT INTO historico.logradouro
      (idlog, idtlog, nome, idmun, ident_oficial, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idlog, v_idtlog, v_nome, v_idmun, v_ident_oficial, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


--
-- TOC entry 931 (class 1255 OID 9442851)
-- Name: fcn_grava_historico_municipio(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_grava_historico_municipio() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idmun      numeric;
   v_sigla_uf     char(2);
   v_nome     varchar;
   v_area_km2     numeric;
   v_idmreg     numeric;
   v_idasmun      numeric;
   v_cod_ibge     numeric;
   v_geom     TEXT;
   v_tipo     char(1);
   v_idmun_pai      numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
   v_operacao     char(1);
BEGIN
   v_idmun      := OLD.idmun;
   v_sigla_uf     := OLD.sigla_uf;
   v_nome     := OLD.nome;
   v_area_km2     := OLD.area_km2;
   v_idmreg     := OLD.idmreg;
   v_idasmun      := OLD.idasmun;
   v_cod_ibge     := OLD.cod_ibge;
   v_geom     := OLD.geom;
   v_tipo     := OLD.tipo;
   v_idmun_pai      := OLD.idmun_pai;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA MUNICIPIO
      INSERT INTO historico.municipio
      (idmun, sigla_uf, nome, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idmun, v_sigla_uf, v_nome, v_area_km2, v_idmreg, v_idasmun, v_cod_ibge, v_geom, v_tipo, v_idmun_pai, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


--
-- TOC entry 932 (class 1255 OID 9442852)
-- Name: fcn_grava_historico_pessoa(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_grava_historico_pessoa() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes    numeric;
   v_nome   TEXT;
   v_idpes_cad    numeric;
   v_data_cad   timestamp;
   v_url    TEXT;
   v_tipo   char;
   v_idpes_rev    numeric;
   v_data_rev   timestamp;
   v_email    TEXT;
   v_situacao   char;
   v_origem_gravacao  char;
   v_idsis_rev    numeric;
   v_idsis_cad    numeric;
   v_operacao   char(1);
BEGIN
   v_idpes    := OLD.idpes;
   v_nome   := OLD.nome;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_url    := OLD.url;
   v_tipo   := OLD.tipo;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_email    := OLD.email;
   v_situacao   := OLD.situacao;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idsis_cad    := OLD.idsis_cad;
   v_operacao   := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA PESSOA
      INSERT INTO historico.pessoa
      (idpes, nome, idpes_cad, data_cad, url, tipo, idpes_rev, data_rev, email, situacao, origem_gravacao, idsis_rev, idsis_cad, operacao) VALUES
      (v_idpes, v_nome, v_idpes_cad, v_data_cad, v_url, v_tipo, v_idpes_rev, v_data_rev, v_email, v_situacao, v_origem_gravacao, v_idsis_rev, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


--
-- TOC entry 933 (class 1255 OID 9442853)
-- Name: fcn_grava_historico_socio(); Type: FUNCTION; Schema: historico; Owner: -
--

CREATE FUNCTION historico.fcn_grava_historico_socio() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes_juridica   numeric;
   v_idpes_fisica   numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
   v_operacao     char(1);
BEGIN
   v_idpes_juridica   := OLD.idpes_juridica;
   v_idpes_fisica   := OLD.idpes_fisica;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA SOCIO
      INSERT INTO historico.socio
      (idpes_juridica, idpes_fisica, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes_juridica, v_idpes_fisica, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


--
-- TOC entry 1032 (class 1255 OID 9474660)
-- Name: audita_falta_componente_curricular(); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.audita_falta_componente_curricular() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
    BEGIN
        IF (TG_OP = 'DELETE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 3, 'TRIGGER_FALTA_COMPONENTE_CURRICULAR', TO_JSON(OLD.*),NULL,NOW(),OLD.id ,nextval('auditoria_geral_id_seq'),current_query());
            RETURN OLD;
        END IF;    
        IF (TG_OP = 'UPDATE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 2, 'TRIGGER_FALTA_COMPONENTE_CURRICULAR', TO_JSON(OLD.*),TO_JSON(NEW.*),NOW(),NEW.id,nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;    
        IF (TG_OP = 'INSERT') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 1, 'TRIGGER_FALTA_COMPONENTE_CURRICULAR', NULL,TO_JSON(NEW.*),NOW(),NEW.id,nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;
        RETURN NULL;
    END;
$$;


--
-- TOC entry 1037 (class 1255 OID 9474658)
-- Name: audita_falta_geral(); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.audita_falta_geral() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
    BEGIN
        IF (TG_OP = 'DELETE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 3, 'TRIGGER_FALTA_GERAL', TO_JSON(OLD.*),NULL,NOW(),OLD.id, nextval('auditoria_geral_id_seq'),current_query());
            RETURN OLD;
        END IF;
        IF (TG_OP = 'UPDATE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 2, 'TRIGGER_FALTA_GERAL', TO_JSON(OLD.*),TO_JSON(NEW.*),NOW(),NEW.id,nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;
        IF (TG_OP = 'INSERT') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 1, 'TRIGGER_FALTA_GERAL', NULL,TO_JSON(NEW.*),NOW(),NEW.id,nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;
        RETURN NULL;
    END;
$$;


--
-- TOC entry 1035 (class 1255 OID 9474666)
-- Name: audita_media_geral(); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.audita_media_geral() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
    BEGIN
        IF (TG_OP = 'DELETE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 3, 'TRIGGER_MEDIA_GERAL', TO_JSON(OLD.*),NULL,NOW(),json_build_object('nota_aluno_id',OLD.nota_aluno_id,'etapa',OLD.etapa),nextval('auditoria_geral_id_seq'),current_query());
            RETURN OLD;
        END IF;    
        IF (TG_OP = 'UPDATE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 2, 'TRIGGER_MEDIA_GERAL', TO_JSON(OLD.*),TO_JSON(NEW.*),NOW(),json_build_object('nota_aluno_id',NEW.nota_aluno_id,'etapa',NEW.etapa),nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;    
        IF (TG_OP = 'INSERT') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 1, 'TRIGGER_MEDIA_GERAL', NULL,TO_JSON(NEW.*),NOW(),json_build_object('nota_aluno_id',NEW.nota_aluno_id,'etapa',NEW.etapa),nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;
        RETURN NULL;
    END;
$$;


--
-- TOC entry 1027 (class 1255 OID 9474650)
-- Name: audita_nota_componente_curricular(); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.audita_nota_componente_curricular() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
    BEGIN
        IF (TG_OP = 'DELETE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 3, 'TRIGGER_NOTA_COMPONENTE_CURRICULAR', TO_JSON(OLD.*),NULL,NOW(),OLD.id ,nextval('auditoria_geral_id_seq'),current_query());
            RETURN OLD;
        END IF;
        IF (TG_OP = 'UPDATE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 2, 'TRIGGER_NOTA_COMPONENTE_CURRICULAR', TO_JSON(OLD.*),TO_JSON(NEW.*),NOW(),NEW.id,nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;    
        IF (TG_OP = 'INSERT') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 1, 'TRIGGER_NOTA_COMPONENTE_CURRICULAR', NULL,TO_JSON(NEW.*),NOW(),NEW.id,nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;
        RETURN NULL;
    END;
$$;


--
-- TOC entry 1028 (class 1255 OID 9474652)
-- Name: audita_nota_componente_curricular_media(); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.audita_nota_componente_curricular_media() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
    BEGIN
        IF (TG_OP = 'DELETE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 3, 'TRIGGER_NOTA_COMPONENTE_CURRICULAR_MEDIA', TO_JSON(OLD.*),NULL,NOW(),json_build_object('nota_aluno_id', OLD.nota_aluno_id, 'componente_curricular_id',OLD.componente_curricular_id, 'etapa',OLD.etapa),nextval('auditoria_geral_id_seq'),current_query());
            RETURN OLD;
        END IF;    
        IF (TG_OP = 'UPDATE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 2, 'TRIGGER_NOTA_COMPONENTE_CURRICULAR_MEDIA', TO_JSON(OLD.*),TO_JSON(NEW.*),NOW(),json_build_object('nota_aluno_id', NEW.nota_aluno_id, 'componente_curricular_id',OLD.componente_curricular_id, 'etapa',OLD.etapa),nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;    
        IF (TG_OP = 'INSERT') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 1, 'TRIGGER_NOTA_COMPONENTE_CURRICULAR_MEDIA', NULL,TO_JSON(NEW.*),NOW(),json_build_object('nota_aluno_id', NEW.nota_aluno_id, 'componente_curricular_id',NEW.componente_curricular_id, 'etapa',NEW.etapa),nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;
        RETURN NULL;
    END;
$$;


--
-- TOC entry 1026 (class 1255 OID 9474648)
-- Name: audita_nota_exame(); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.audita_nota_exame() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
    BEGIN
        IF (TG_OP = 'DELETE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 3, 'TRIGGER_NOTA_EXAME', TO_JSON(OLD.*),NULL,NOW(),json_build_object('ref_cod_matricula', OLD.ref_cod_matricula, 'ref_cod_componente_curricular',OLD.ref_cod_componente_curricular) ,nextval('auditoria_geral_id_seq'),current_query());
            RETURN OLD;
        END IF;
        IF (TG_OP = 'UPDATE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 2, 'TRIGGER_NOTA_EXAME', TO_JSON(OLD.*),TO_JSON(NEW.*),NOW(),json_build_object('ref_cod_matricula', NEW.ref_cod_matricula, 'ref_cod_componente_curricular',NEW.ref_cod_componente_curricular) ,nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;    
        IF (TG_OP = 'INSERT') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 1, 'TRIGGER_NOTA_EXAME', NULL,TO_JSON(NEW.*),NOW(),json_build_object('ref_cod_matricula', NEW.ref_cod_matricula, 'ref_cod_componente_curricular',NEW.ref_cod_componente_curricular),nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;
        RETURN NULL;
    END;
$$;


--
-- TOC entry 1025 (class 1255 OID 9474646)
-- Name: audita_nota_geral(); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.audita_nota_geral() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
    BEGIN
        IF (TG_OP = 'DELETE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 3, 'TRIGGER_NOTA_GERAL', TO_JSON(OLD.*),NULL,NOW(),OLD.id,nextval('auditoria_geral_id_seq'),current_query());
            RETURN OLD;
        END IF;    
        IF (TG_OP = 'UPDATE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 2, 'TRIGGER_NOTA_GERAL', TO_JSON(OLD.*),TO_JSON(NEW.*),NOW(),NEW.id,nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;    
        IF (TG_OP = 'INSERT') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 1, 'TRIGGER_NOTA_GERAL', NULL,TO_JSON(NEW.*),NOW(),NEW.id,nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;
        RETURN NULL;
    END;
$$;


--
-- TOC entry 1030 (class 1255 OID 9474656)
-- Name: audita_parecer_componente_curricular(); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.audita_parecer_componente_curricular() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
    BEGIN
        IF (TG_OP = 'DELETE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 3, 'TRIGGER_PARECER_COMPONENTE_CURRICULAR', TO_JSON(OLD.*),NULL,NOW(),OLD.id,nextval('auditoria_geral_id_seq'),current_query());
            RETURN OLD;
        END IF;    
        IF (TG_OP = 'UPDATE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 2, 'TRIGGER_PARECER_COMPONENTE_CURRICULAR', TO_JSON(OLD.*),TO_JSON(NEW.*),NOW(),NEW.id,nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;    
        IF (TG_OP = 'INSERT') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 1, 'TRIGGER_PARECER_COMPONENTE_CURRICULAR', NULL,TO_JSON(NEW.*),NOW(),NEW.id,nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;
        RETURN NULL;
    END;
$$;


--
-- TOC entry 1029 (class 1255 OID 9474654)
-- Name: audita_parecer_geral(); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.audita_parecer_geral() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
    BEGIN
        IF (TG_OP = 'DELETE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 3, 'TRIGGER_PARECER_GERAL', TO_JSON(OLD.*),NULL,NOW(),OLD.id,nextval('auditoria_geral_id_seq'),current_query());
            RETURN OLD;
        END IF;    
        IF (TG_OP = 'UPDATE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 2, 'TRIGGER_PARECER_GERAL', TO_JSON(OLD.*),TO_JSON(NEW.*),NOW(),NEW.id,nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;    
        IF (TG_OP = 'INSERT') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 1, 'TRIGGER_PARECER_GERAL', NULL,TO_JSON(NEW.*),NOW(),NEW.id,nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;
        RETURN NULL;
    END;
$$;


--
-- TOC entry 934 (class 1255 OID 9442854)
-- Name: copia_notas_transf(integer, integer); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.copia_notas_transf(old_matricula_id integer, new_matricula_id integer) RETURNS character varying
    LANGUAGE plpgsql
    AS $$
              DECLARE
              cur_comp RECORD;
              cur_comp_media RECORD;
              cur_geral RECORD;
              cur_geral_media RECORD;
              cur_falta_geral RECORD;
              cur_falta_comp RECORD;
              cur_parecer_geral RECORD;
              cur_parecer_comp RECORD;
              v_tipo_nota integer;
              v_tipo_parecer integer;
              v_tipo_falta integer;
              v_nota_id integer;
              v_old_nota_id integer;
              v_falta_id integer;
              v_old_falta_id integer;
              v_parecer_id integer;
              v_old_parecer_id integer;

              old_nota_aluno_id integer;
              new_nota_aluno_id integer;
              old_ano_matricula integer;
              new_ano_matricula integer;
              begin

              old_nota_aluno_id := (select id from modules.nota_aluno where matricula_id = old_matricula_id);
              new_nota_aluno_id := (select id from modules.nota_aluno where matricula_id = new_matricula_id);

              old_nota_aluno_id := (select (case when count(1) >= 1 then 1 else 0 end) from modules.nota_componente_curricular where nota_aluno_id = old_nota_aluno_id);
              new_nota_aluno_id := (select (case when count(1) >= 1 then 1 else 0 end) from modules.nota_componente_curricular where nota_aluno_id = new_nota_aluno_id);

              old_ano_matricula := (SELECT ano FROM pmieducar.matricula WHERE cod_matricula = old_matricula_id);
              new_ano_matricula := (SELECT ano FROM pmieducar.matricula WHERE cod_matricula = new_matricula_id);

              IF (old_nota_aluno_id = 1 and new_nota_aluno_id = 0) THEN
                /* VERIFICA SE AS MATRICULAS FAZEM PARTE DO MESMO ANO LETIVO*/
                IF (old_ano_matricula = new_ano_matricula) THEN

                  IF (
                   (  CASE WHEN (select padrao_ano_escolar from pmieducar.curso
                      where cod_curso = (select ref_cod_curso from pmieducar.matricula
                      where cod_matricula = new_matricula_id)) = 1
                     THEN  (select max(sequencial) as qtd_etapa from pmieducar.ano_letivo_modulo mod
                      inner join pmieducar.matricula mat on (mat.ref_ref_cod_escola = mod.ref_ref_cod_escola)
                                  where mat.cod_matricula = new_matricula_id)
                           ELSE (select count(ref_cod_modulo) from pmieducar.turma_modulo
                      where ref_cod_turma = (select ref_cod_turma from pmieducar.matricula_turma
                      where ref_cod_matricula = new_matricula_id))
                           END
                 ) = (CASE WHEN (select padrao_ano_escolar from pmieducar.curso
                      where cod_curso = (select ref_cod_curso from pmieducar.matricula
                      where cod_matricula = old_matricula_id)) = 1
                     THEN  (select max(sequencial) as qtd_etapa from pmieducar.ano_letivo_modulo mod
                            inner join pmieducar.matricula mat on (mat.ref_ref_cod_escola = mod.ref_ref_cod_escola)
                                  where mat.cod_matricula = old_matricula_id)
                           ELSE  (select count(ref_cod_modulo) from pmieducar.turma_modulo
                      where ref_cod_turma = (select max(ref_cod_turma) from pmieducar.matricula_turma
                      where ref_cod_matricula = old_matricula_id))
                           END
                      )
                ) THEN

                    /* VERIFICA SE UTILIZAM A MESMA REGRA DE AVALIAÇÃO*/
                    IF ((SELECT id FROM modules.regra_avaliacao rg
                        INNER JOIN pmieducar.serie s ON (rg.id = s.regra_avaliacao_id)
                        INNER JOIN pmieducar.matricula m ON (s.cod_serie = m.ref_ref_cod_serie)
                        where m.cod_matricula = old_matricula_id ) =
                          (SELECT id FROM modules.regra_avaliacao rg
                            INNER JOIN pmieducar.serie s ON (rg.id = s.regra_avaliacao_id)
                            INNER JOIN pmieducar.matricula m ON (s.cod_serie = m.ref_ref_cod_serie)
                            where m.cod_matricula = new_matricula_id ) ) THEN


                      v_tipo_nota := (SELECT tipo_nota FROM modules.regra_avaliacao rg
                                INNER JOIN pmieducar.serie s ON (rg.id = s.regra_avaliacao_id)
                                INNER JOIN pmieducar.matricula m ON (s.cod_serie = m.ref_ref_cod_serie)
                                where m.cod_matricula = old_matricula_id);

                      v_tipo_falta := (SELECT tipo_presenca FROM modules.regra_avaliacao rg
                                INNER JOIN pmieducar.serie s ON (rg.id = s.regra_avaliacao_id)
                                INNER JOIN pmieducar.matricula m ON (s.cod_serie = m.ref_ref_cod_serie)
                                where m.cod_matricula = old_matricula_id);

                      v_tipo_parecer := (SELECT parecer_descritivo FROM modules.regra_avaliacao rg
                                INNER JOIN pmieducar.serie s ON (rg.id = s.regra_avaliacao_id)
                                INNER JOIN pmieducar.matricula m ON (s.cod_serie = m.ref_ref_cod_serie)
                                where m.cod_matricula = old_matricula_id);
                      /* SE A REGRA UTILIZAR NOTA, COPIA AS NOTAS*/
                      IF (v_tipo_nota >0) THEN

                        INSERT INTO modules.nota_aluno (matricula_id) VALUES (new_matricula_id);
                        v_nota_id := (SELECT max(id) FROM modules.nota_aluno WHERE matricula_id = new_matricula_id);

                        v_old_nota_id := (SELECT max(id) FROM modules.nota_aluno WHERE matricula_id = old_matricula_id);

                        FOR cur_comp IN (SELECT * FROM modules.nota_componente_curricular where nota_aluno_id = v_old_nota_id) LOOP
                          INSERT INTO modules.nota_componente_curricular (nota_aluno_id,componente_curricular_id,nota,nota_arredondada,etapa, nota_recuperacao, nota_original, nota_recuperacao_especifica)
                          VALUES(v_nota_id,cur_comp.componente_curricular_id,cur_comp.nota,cur_comp.nota_arredondada,cur_comp.etapa,cur_comp.nota_recuperacao,cur_comp.nota_original,cur_comp.nota_recuperacao_especifica);
                        END LOOP;

                        FOR cur_comp_media IN (SELECT * FROM modules.nota_componente_curricular_media where nota_aluno_id = v_old_nota_id) LOOP
                          INSERT INTO modules.nota_componente_curricular_media (nota_aluno_id,componente_curricular_id,media,media_arredondada,etapa, situacao)
                          VALUES(v_nota_id,cur_comp_media.componente_curricular_id,cur_comp_media.media,cur_comp_media.media_arredondada,cur_comp_media.etapa, cur_comp_media.situacao);
                        END LOOP;

                        FOR cur_geral IN (SELECT * FROM modules.nota_geral where nota_aluno_id = v_old_nota_id) LOOP
                          INSERT INTO modules.nota_geral (nota_aluno_id,nota,nota_arredondada,etapa)
                          VALUES(v_nota_id,cur_geral.nota,cur_geral.nota_arredondada,cur_geral.etapa);
                        END LOOP;

                        FOR cur_geral_media IN (SELECT * FROM modules.media_geral where nota_aluno_id = v_old_nota_id) LOOP
                          INSERT INTO modules.media_geral (nota_aluno_id,media,media_arredondada,etapa)
                          VALUES(v_nota_id,cur_geral_media.media,cur_geral_media.media_arredondada,cur_geral_media.etapa);
                        END LOOP;
                      END IF;

                      IF (v_tipo_falta = 1) THEN

                          INSERT INTO modules.falta_aluno (matricula_id, tipo_falta) VALUES (new_matricula_id,1);
                          v_falta_id = (SELECT max(id) FROM modules.falta_aluno WHERE matricula_id = new_matricula_id);
                        v_old_falta_id := (SELECT max(id) FROM modules.falta_aluno WHERE matricula_id = old_matricula_id);

                        FOR cur_falta_geral IN (SELECT * FROM modules.falta_geral where falta_aluno_id = v_old_falta_id) LOOP
                          INSERT INTO modules.falta_geral (falta_aluno_id,quantidade,etapa)
                          VALUES(v_falta_id,cur_falta_geral.quantidade, cur_falta_geral.etapa);
                        END LOOP;
                      END IF;

                      IF (v_tipo_falta = 2) THEN

                        INSERT INTO modules.falta_aluno (matricula_id, tipo_falta) VALUES (new_matricula_id,2);
                        v_falta_id = (SELECT max(id) FROM modules.falta_aluno WHERE matricula_id = new_matricula_id);
                        v_old_falta_id := (SELECT max(id) FROM modules.falta_aluno WHERE matricula_id = old_matricula_id);

                        FOR cur_falta_comp IN (SELECT * FROM modules.falta_componente_curricular where falta_aluno_id = v_old_falta_id) LOOP
                          INSERT INTO modules.falta_componente_curricular (falta_aluno_id,componente_curricular_id,quantidade,etapa)
                          VALUES(v_falta_id,cur_falta_comp.componente_curricular_id,cur_falta_comp.quantidade, cur_falta_comp.etapa);
                        END LOOP;
                      END IF;

                      IF (v_tipo_parecer = 2) THEN

                        INSERT INTO modules.parecer_aluno (matricula_id, parecer_descritivo)VALUES (new_matricula_id,2);
                        v_parecer_id := (SELECT max(id) FROM modules.parecer_aluno WHERE matricula_id = new_matricula_id);
                        v_old_parecer_id := (SELECT max(id) FROM modules.parecer_aluno WHERE matricula_id = old_matricula_id);

                        FOR cur_parecer_comp IN (SELECT * FROM modules.parecer_componente_curricular where parecer_aluno_id = v_old_parecer_id) LOOP
                          INSERT INTO modules.parecer_componente_curricular (parecer_aluno_id,componente_curricular_id,parecer,etapa)
                          VALUES(v_parecer_id,cur_parecer_comp.componente_curricular_id,cur_parecer_comp.parecer, cur_parecer_comp.etapa);
                        END LOOP;
                      END IF;

                      IF (v_tipo_parecer = 3) THEN

                        INSERT INTO modules.parecer_aluno (matricula_id, parecer_descritivo)VALUES (new_matricula_id,3);
                        v_parecer_id := (SELECT max(id) FROM modules.parecer_aluno WHERE matricula_id = new_matricula_id);
                        v_old_parecer_id := (SELECT max(id) FROM modules.parecer_aluno WHERE matricula_id = old_matricula_id);

                        FOR cur_parecer_geral IN (SELECT * FROM modules.parecer_geral where parecer_aluno_id = v_old_parecer_id) LOOP
                          INSERT INTO modules.parecer_geral (parecer_aluno_id,parecer,etapa)
                          VALUES(v_parecer_id,cur_parecer_geral.parecer, cur_parecer_geral.etapa);
                        END LOOP;
                      END IF;

                      RETURN 'OK';

                    ELSE RETURN 'REGRA AVALIACAO DIFERENTE'; END IF;
                  ELSE RETURN 'ETAPA DIFERENTE'; END IF;
                ELSE RETURN 'MATRICULAS DE ANOS DIFERENTES';
                END IF;
              ELSE RETURN 'NAO EXISTE NOTAS';END IF;

              end;$$;


--
-- TOC entry 936 (class 1255 OID 9442856)
-- Name: corrige_sequencial_historico(); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.corrige_sequencial_historico() RETURNS void
    LANGUAGE plpgsql
    AS $$
  DECLARE
  cur_aluno RECORD;
  cur_hist RECORD;
  contador integer;
  begin

  ALTER TABLE pmieducar.historico_escolar DISABLE TRIGGER USER;
  ALTER TABLE pmieducar.historico_escolar DROP CONSTRAINT historico_escolar_pkey cascade;
  FOR cur_aluno IN (SELECT cod_aluno as id FROM pmieducar.aluno) LOOP
    update pmieducar.historico_escolar set sequencial = sequencial + 100 where ref_cod_aluno = cur_aluno.id;
    contador:=1;
    FOR cur_hist IN (SELECT sequencial FROM pmieducar.historico_escolar WHERE ref_cod_aluno = cur_aluno.id ORDER BY ano, nm_serie, data_cadastro) LOOP
      update pmieducar.historico_escolar set sequencial = contador where ref_cod_aluno = cur_aluno.id and sequencial = cur_hist.sequencial;
      contador:=contador+1;
    END LOOP;
  END LOOP;
  ALTER TABLE pmieducar.historico_escolar ADD CONSTRAINT historico_escolar_pkey PRIMARY KEY(ref_cod_aluno, sequencial);
  ALTER TABLE pmieducar.historico_escolar ENABLE TRIGGER USER;
  end;$$;


--
-- TOC entry 937 (class 1255 OID 9442857)
-- Name: frequencia_da_matricula(integer); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.frequencia_da_matricula(p_matricula_id integer) RETURNS double precision
    LANGUAGE plpgsql
    AS $$
                      DECLARE
                        v_regra_falta integer;
                        v_falta_aluno_id  integer;
                        v_qtd_dias_letivos_serie NUMERIC;
                        v_total_faltas integer;
                        v_qtd_horas_serie integer;
                        v_hora_falta FLOAT;
                      BEGIN
                          /*
                            regra_falta:
                            1- Global
                            2- Por componente
                          */
                          v_regra_falta:= (SELECT rg.tipo_presenca
                                             FROM modules.regra_avaliacao rg
                                            INNER JOIN pmieducar.serie s ON (rg.id = s.regra_avaliacao_id)
                                            INNER JOIN pmieducar.matricula m ON (s.cod_serie = m.ref_ref_cod_serie)
                                            WHERE m.cod_matricula = p_matricula_id);
                          v_falta_aluno_id := (SELECT id
                                                 FROM modules.falta_aluno
                                                WHERE matricula_id = p_matricula_id
                                                ORDER BY id DESC
                                                LIMIT 1 );
                          IF (v_regra_falta = 1) THEN
                                v_qtd_dias_letivos_serie := (SELECT s.dias_letivos
                                                               FROM pmieducar.serie s
                                                              INNER JOIN pmieducar.matricula m ON (m.ref_ref_cod_serie = s.cod_serie)
                                                              WHERE m.cod_matricula = p_matricula_id);
                                v_total_faltas := (SELECT SUM(quantidade)
                                                     FROM modules.falta_geral
                                                    WHERE falta_aluno_id = v_falta_aluno_id);
                                RETURN TRUNC((((v_qtd_dias_letivos_serie - v_total_faltas) * 100 ) / v_qtd_dias_letivos_serie ),2);
                          ELSE

                            v_qtd_horas_serie := ( SELECT s.carga_horaria
                                                     FROM pmieducar.serie s
                                                    INNER JOIN pmieducar.matricula m ON (m.ref_ref_cod_serie = s.cod_serie)
                                                    WHERE m.cod_matricula = p_matricula_id);

                            v_total_faltas := (SELECT SUM(quantidade)
                                                 FROM falta_componente_curricular
                                                WHERE falta_aluno_id = v_falta_aluno_id);
                            v_hora_falta := (SELECT hora_falta
                                               FROM pmieducar.curso c
                                              INNER JOIN pmieducar.matricula m ON (c.cod_curso = m.ref_cod_curso)
                                              WHERE m.cod_matricula = p_matricula_id);
                            RETURN  (100 - ((v_total_faltas * (v_hora_falta*100))/v_qtd_horas_serie));
                          END IF;
                      END;$$;


--
-- TOC entry 938 (class 1255 OID 9442858)
-- Name: frequencia_etapa_padrao_ano_escolar_um(integer, integer, integer); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.frequencia_etapa_padrao_ano_escolar_um(cod_matricula_aluno integer, cod_etapa integer, id_componente_curricular integer) RETURNS numeric
    LANGUAGE plpgsql
    AS $$
                      		DECLARE
                      			dias_letivos_escola decimal;
                      			tipo_falta_aluno integer;
                      			faltas_aluno_geral decimal;
                      			faltas_aluno_componente decimal;
                      			cod_serie_ano_escolar integer;
                      		begin
                      			cod_serie_ano_escolar := (select ref_ref_cod_serie from pmieducar.matricula where matricula.cod_matricula = cod_matricula_aluno);
                      			tipo_falta_aluno := (select tipo_falta from modules.falta_aluno where matricula_id = cod_matricula_aluno);

                      			faltas_aluno_geral := (select quantidade
                      						 from modules.falta_aluno
                      					   inner join modules.falta_geral on (falta_aluno.id = falta_geral.falta_aluno_id)
                      					        where falta_aluno.matricula_id = cod_matricula_aluno
                      						  and etapa = cod_etapa::varchar);

                      			dias_letivos_escola := (select dias_letivos
                      						  from pmieducar.matricula
                      					    inner join pmieducar.ano_letivo_modulo on (matricula.ref_ref_cod_escola = ano_letivo_modulo.ref_ref_cod_escola
                      										       and matricula.ano = ano_letivo_modulo.ref_ano)
                      						 where cod_matricula = cod_matricula_aluno
                      						   and sequencial = cod_etapa);

                      			faltas_aluno_componente := (select quantidade
                      						      from modules.falta_aluno
                      					        inner join modules.falta_componente_curricular on (falta_aluno.id = falta_componente_curricular.falta_aluno_id)
                      						     where falta_aluno.matricula_id = cod_matricula_aluno
                      						       and etapa = cod_etapa::varchar
                      						       and componente_curricular_id = id_componente_curricular);

                      			if(dias_letivos_escola is not null and dias_letivos_escola <> 0) then

                      				if(tipo_falta_aluno = 1) then
                      					return round((((dias_letivos_escola - faltas_aluno_geral) * 100) / dias_letivos_escola), 2);
                      				else
                      					return round((((dias_letivos_escola - faltas_aluno_componente) * 100) / dias_letivos_escola), 2);
                      				end if;
                      			else
                      				return null;
                      			end if;
                      		end;
                      	$$;


--
-- TOC entry 939 (class 1255 OID 9442859)
-- Name: frequencia_etapa_padrao_ano_escolar_zero(integer, integer, integer); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.frequencia_etapa_padrao_ano_escolar_zero(cod_matricula_aluno integer, cod_etapa integer, id_componente_curricular integer) RETURNS numeric
    LANGUAGE plpgsql
    AS $$
		DECLARE
			dias_letivos_turma decimal;
			tipo_falta_aluno integer;
			faltas_aluno_geral decimal;
			faltas_aluno_componente decimal;
			cod_serie_ano_escolar integer;
		begin
			cod_serie_ano_escolar := (select ref_ref_cod_serie from pmieducar.matricula where matricula.cod_matricula = cod_matricula_aluno);
			tipo_falta_aluno := (select tipo_falta from modules.falta_aluno where matricula_id = cod_matricula_aluno);

			dias_letivos_turma := (select turma_modulo.dias_letivos
						 from pmieducar.matricula
					   inner join pmieducar.matricula_turma on (matricula.cod_matricula = matricula_turma.ref_cod_matricula)
					   inner join pmieducar.turma on (matricula_turma.ref_cod_turma = turma.cod_turma)
					    left join pmieducar.turma_modulo on (turma.cod_turma = turma_modulo.ref_cod_turma)
						where matricula.cod_matricula = cod_matricula_aluno
						  and turma_modulo.sequencial = cod_etapa
						  and matricula_turma.ativo = 1);

			faltas_aluno_geral := (select quantidade
						 from modules.falta_aluno
					   inner join modules.falta_geral on (falta_aluno.id = falta_geral.falta_aluno_id)
						where falta_aluno.matricula_id = cod_matricula_aluno
						  and etapa = cod_etapa);

			faltas_aluno_componente := (select quantidade
						      from modules.falta_aluno
						inner join modules.falta_componente_curricular on (falta_aluno.id = falta_componente_curricular.falta_aluno_id)
						     where falta_aluno.matricula_id = cod_matricula_aluno
						       and etapa = cod_etapa
						       and componente_curricular_id = id_componente_curricular);

			if(dias_letivos_turma is not null and dias_letivos_turma <> 0) then

				if(tipo_falta_aluno = 1) then
					return round((((dias_letivos_turma - faltas_aluno_geral) * 100) / dias_letivos_turma), 2);
				else
					return round((((dias_letivos_turma - faltas_aluno_componente) * 100) / dias_letivos_turma), 2);
				end if;
			else
				return null;
			end if;
		end;
	$$;


--
-- TOC entry 940 (class 1255 OID 9442860)
-- Name: frequencia_matricula_por_etapa(integer, character varying); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.frequencia_matricula_por_etapa(matricula integer, etapa character varying) RETURNS numeric
    LANGUAGE plpgsql
    AS $_$
                          DECLARE
                            matricula integer;
                            etapa varchar;
                            ano_matricula integer;
                            escola_matricula integer;
                            turma integer;
                            faltas_geral_matricula decimal;
                            var_dias_letivos_turma_etapa decimal;
                            dias_letivos_escola_etapa decimal;

                            BEGIN
                              matricula := $1;
                              etapa := $2;
                              turma := (SELECT ref_cod_turma
                                          FROM pmieducar.matricula_turma
                                         WHERE ref_cod_matricula = $1
                                            AND matricula_turma.sequencial = relatorio.get_max_sequencial_matricula(ref_cod_matricula));
                              ano_matricula := (SELECT ano
                                                  FROM pmieducar.matricula
                                                 WHERE cod_matricula = $1);
                              escola_matricula := (SELECT ref_ref_cod_escola
                                                     FROM pmieducar.matricula
                                                    WHERE cod_matricula = $1);
                              faltas_geral_matricula := (SELECT sum(falta_geral.quantidade)
                                                               FROM modules.falta_geral,
                                                                    modules.falta_aluno
                                                              WHERE falta_geral.falta_aluno_id = falta_aluno.id
                                                                AND falta_aluno.matricula_id = $1
                                                                AND falta_geral.etapa = $2
                                                                AND falta_aluno.tipo_falta = 1);
                              var_dias_letivos_turma_etapa := (SELECT dias_letivos
                                                                 FROM pmieducar.turma_modulo
                                                                WHERE sequencial::varchar = $2
                                                                  AND ref_cod_turma = turma);
                              dias_letivos_escola_etapa := (SELECT dias_letivos
                                                                  FROM pmieducar.ano_letivo_modulo
                                                                 WHERE sequencial::varchar = $2
                                                                   AND ref_ano = ano_matricula
                                                                   AND ref_ref_cod_escola = escola_matricula);
                              IF (var_dias_letivos_turma_etapa IS NOT NULL AND var_dias_letivos_turma_etapa <> 0) THEN
                                RETURN ((var_dias_letivos_turma_etapa - faltas_geral_matricula) * 100) / var_dias_letivos_turma_etapa;
                              ELSE
                                IF (dias_letivos_escola_etapa IS NOT NULL AND dias_letivos_escola_etapa <> 0) THEN
                                  RETURN ((var_dias_letivos_turma_etapa - faltas_geral_matricula) * 100) / var_dias_letivos_turma_etapa;
                                END IF;
                              END IF;
                            END;
                          $_$;


--
-- TOC entry 941 (class 1255 OID 9442861)
-- Name: frequencia_por_componente(integer, integer, integer); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.frequencia_por_componente(cod_matricula_id integer, cod_disciplina_id integer, cod_turma_id integer) RETURNS character varying
    LANGUAGE plpgsql
    AS $$
            DECLARE
                                         cod_falta_aluno_id integer;
                                         v_qtd_dias_letivos_serie integer;
                                         v_total_faltas integer;
                                         qtde_carga_horaria integer;
                                         v_hora_falta float;
                                         cod_serie_id integer;
                                      BEGIN
            
                                        cod_falta_aluno_id := (SELECT id FROM modules.falta_aluno WHERE matricula_id = cod_matricula_id ORDER BY id DESC LIMIT 1);
            
                                        qtde_carga_horaria := (SELECT carga_horaria :: int
                                              FROM modules.componente_curricular_turma
                                             WHERE componente_curricular_turma.componente_curricular_id = cod_disciplina_id
                                               AND componente_curricular_turma.turma_id = cod_turma_id);
            
                                        IF (qtde_carga_horaria IS NULL) THEN
                                            cod_serie_id := (SELECT ref_ref_cod_serie FROM pmieducar.turma WHERE cod_turma = cod_turma_id);
                                            qtde_carga_horaria := (SELECT carga_horaria :: int
                                                                 FROM modules.componente_curricular_ano_escolar
                                                            WHERE componente_curricular_ano_escolar.componente_curricular_id = cod_disciplina_id
                                                              AND componente_curricular_ano_escolar.ano_escolar_id = cod_serie_id);
                                        END IF;
            
                                        v_total_faltas := (SELECT SUM(quantidade)
                                                             FROM falta_componente_curricular
                                                            WHERE falta_aluno_id = cod_falta_aluno_id
                                                              AND componente_curricular_id = cod_disciplina_id);
            
                                        v_hora_falta := (SELECT hora_falta FROM pmieducar.curso c
                                                     INNER JOIN pmieducar.matricula m ON (c.cod_curso = m.ref_cod_curso)
                                                          WHERE m.cod_matricula = cod_matricula_id);
            
                                        IF (qtde_carga_horaria = 0) THEN
                                            RETURN 0;
                                        END IF;
            
                                        RETURN  trunc((100 - ((v_total_faltas * (v_hora_falta*100))/qtde_carga_horaria))::numeric, 2);
            
                                    END;
            $$;


--
-- TOC entry 1031 (class 1255 OID 9474636)
-- Name: impede_duplicacao_falta_aluno(); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.impede_duplicacao_falta_aluno() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
                    BEGIN
                        PERFORM * FROM modules.falta_aluno
                        WHERE falta_aluno.matricula_id = NEW.matricula_id
                          AND falta_aluno.id <> NEW.id;
                        IF FOUND THEN
                            RAISE EXCEPTION 'A matrícula % já existe na tabela falta_aluno', NEW.matricula_id;
                        END IF;

                        RETURN NEW;
                    END;
                    $$;


--
-- TOC entry 1036 (class 1255 OID 9474632)
-- Name: impede_duplicacao_nota_aluno(); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.impede_duplicacao_nota_aluno() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
                    BEGIN
                        PERFORM * FROM modules.nota_aluno
                                WHERE nota_aluno.matricula_id = NEW.matricula_id
                                  AND nota_aluno.id <> NEW.id;
                        IF FOUND THEN
                            RAISE EXCEPTION 'A matrícula % já existe na tabela nota_aluno', NEW.matricula_id;
                        END IF;

                        RETURN NEW;
                    END;
                    $$;


--
-- TOC entry 1018 (class 1255 OID 9474634)
-- Name: impede_duplicacao_parecer_aluno(); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.impede_duplicacao_parecer_aluno() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
                    BEGIN
                        PERFORM * FROM modules.parecer_aluno
                                 WHERE parecer_aluno.matricula_id = NEW.matricula_id
                                   AND parecer_aluno.id <> NEW.id;
                        IF FOUND THEN
                            RAISE EXCEPTION 'A matrícula % já existe na tabela parecer_aluno', NEW.matricula_id;
                        END IF;

                        RETURN NEW;
                    END;
                $$;


--
-- TOC entry 924 (class 1255 OID 9442862)
-- Name: preve_data_emprestimo(integer, date); Type: FUNCTION; Schema: modules; Owner: -
--

CREATE FUNCTION modules.preve_data_emprestimo(biblioteca_id integer, data_prevista date) RETURNS date
    LANGUAGE plpgsql
    AS $$
  DECLARE
  begin

  IF (( select 1 from pmieducar.biblioteca_dia WHERE ref_cod_biblioteca = biblioteca_id AND dia = ((SELECT EXTRACT(DOW FROM data_prevista))+1) limit 1) IS NOT null) THEN
    IF ((SELECT 1 FROM pmieducar.biblioteca_feriados WHERE ref_cod_biblioteca = biblioteca_id and data_feriado = data_prevista) IS NULL) THEN
      RETURN data_prevista;
    ELSE
      RETURN modules.preve_data_emprestimo(biblioteca_id, data_prevista+1);
    END IF;
  ELSE
    RETURN modules.preve_data_emprestimo(biblioteca_id, data_prevista+1);
  END IF;

  end;$$;


--
-- TOC entry 1033 (class 1255 OID 9474662)
-- Name: audita_matricula(); Type: FUNCTION; Schema: pmieducar; Owner: -
--

CREATE FUNCTION pmieducar.audita_matricula() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
    BEGIN
        IF (TG_OP = 'DELETE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 3, 'TRIGGER_MATRICULA', TO_JSON(OLD.*),NULL,NOW(),OLD.cod_matricula ,nextval('auditoria_geral_id_seq'),current_query());
            RETURN OLD;
        END IF;    
        IF (TG_OP = 'UPDATE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 2, 'TRIGGER_MATRICULA', TO_JSON(OLD.*),TO_JSON(NEW.*),NOW(),NEW.cod_matricula,nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;    
        IF (TG_OP = 'INSERT') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 1, 'TRIGGER_MATRICULA', NULL,TO_JSON(NEW.*),NOW(),NEW.cod_matricula,nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;    
        END IF;
        RETURN NULL;
    END;
$$;


--
-- TOC entry 1034 (class 1255 OID 9474664)
-- Name: audita_matricula_turma(); Type: FUNCTION; Schema: pmieducar; Owner: -
--

CREATE FUNCTION pmieducar.audita_matricula_turma() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
    BEGIN
        IF (TG_OP = 'DELETE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 3, 'TRIGGER_MATRICULA_TURMA', TO_JSON(OLD.*),NULL,NOW(),json_build_object('ref_cod_matricula',OLD.ref_cod_matricula,'sequencial',OLD.sequencial),nextval('auditoria_geral_id_seq'),current_query());
            RETURN OLD;
        END IF;    
        IF (TG_OP = 'UPDATE') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 2, 'TRIGGER_MATRICULA_TURMA', TO_JSON(OLD.*),TO_JSON(NEW.*),NOW(),json_build_object('ref_cod_matricula',NEW.ref_cod_matricula,'sequencial',NEW.sequencial),nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;    
        IF (TG_OP = 'INSERT') THEN
            INSERT INTO modules.auditoria_geral VALUES(1, 1, 'TRIGGER_MATRICULA_TURMA', NULL,TO_JSON(NEW.*),NOW(),json_build_object('ref_cod_matricula',NEW.ref_cod_matricula,'sequencial',NEW.sequencial),nextval('auditoria_geral_id_seq'),current_query());
            RETURN NEW;
        END IF;
        RETURN NULL;
    END;
$$;


--
-- TOC entry 1017 (class 1255 OID 9474631)
-- Name: copiaanosletivos(smallint, integer); Type: FUNCTION; Schema: pmieducar; Owner: -
--

CREATE FUNCTION pmieducar.copiaanosletivos(ianonovo smallint, icodescola integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
            DECLARE
            iAnoAnterior smallint;
            BEGIN

            SELECT COALESCE(MAX(ano),0) INTO iAnoAnterior
            FROM pmieducar.escola_ano_letivo
            WHERE ref_cod_escola = iCodEscola
            AND ano < iAnoNovo;

            If iAnoAnterior IS NOT NULL THEN

                UPDATE pmieducar.escola_curso
                SET anos_letivos = array_append(anos_letivos, iAnoNovo)
                WHERE iAnoAnterior = ANY(anos_letivos)
                AND NOT (iAnoNovo = ANY(anos_letivos))
                AND ref_cod_escola = iCodEscola;

                UPDATE pmieducar.escola_serie
                SET anos_letivos = array_append(anos_letivos, iAnoNovo)
                WHERE iAnoAnterior = ANY(anos_letivos)
                AND NOT (iAnoNovo = ANY(anos_letivos))
                AND ref_cod_escola = iCodEscola;

                UPDATE pmieducar.escola_serie_disciplina
                SET anos_letivos = array_append(anos_letivos, iAnoNovo)
                WHERE iAnoAnterior = ANY(anos_letivos)
                AND NOT (iAnoNovo = ANY(anos_letivos))
                AND ref_ref_cod_escola = iCodEscola;

                UPDATE modules.componente_curricular_ano_escolar
                SET anos_letivos = array_append(anos_letivos, iAnoNovo)
                WHERE EXISTS(
                    SELECT 1
                    FROM pmieducar.escola_serie_disciplina
                    WHERE iAnoAnterior = ANY(anos_letivos)
                    AND ref_ref_cod_escola = iCodEscola
                    AND escola_serie_disciplina.ref_cod_disciplina = componente_curricular_ano_escolar.componente_curricular_id
                    AND escola_serie_disciplina.ref_ref_cod_serie = componente_curricular_ano_escolar.ano_escolar_id
                )
                AND NOT (iAnoNovo = ANY(anos_letivos));

                INSERT INTO modules.regra_avaliacao_serie_ano
                (serie_id, regra_avaliacao_id, regra_avaliacao_diferenciada_id, ano_letivo)
                SELECT distinct serie, rasa.regra_avaliacao_id, rasa.regra_avaliacao_diferenciada_id, iAnoNovo
                FROM (
                SELECT distinct ref_cod_serie serie
                FROM pmieducar.escola_serie
                WHERE iAnoAnterior = ANY(anos_letivos)
                AND ref_cod_escola = iCodEscola
                ) AS myqq
                JOIN modules.regra_avaliacao_serie_ano rasa
                ON rasa.serie_id = serie
                AND iAnoAnterior = rasa.ano_letivo
                AND NOT EXISTS(
                    SELECT 1
                    FROM modules.regra_avaliacao_serie_ano
                    WHERE serie_id = rasa.serie_id
                    AND ano_letivo = iAnoNovo
                );

            END IF;
            END;
            $$;


--
-- TOC entry 904 (class 1255 OID 9442863)
-- Name: fcn_aft_update(); Type: FUNCTION; Schema: pmieducar; Owner: -
--

CREATE FUNCTION pmieducar.fcn_aft_update() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  nm_tabela   varchar(255);
  alteracoes    text;
  data_cadastro   TIMESTAMP;
  v_insercao    int2;


  BEGIN
    v_insercao    := 0;
    nm_tabela   := TG_RELNAME;
    alteracoes    := NEW;
    data_cadastro   := CURRENT_TIMESTAMP;
    IF TG_OP = 'INSERT' THEN
      v_insercao := 1;
    END IF;
    insert into pmieducar.historico_educar (tabela, alteracao, data, insercao) values (nm_tabela, alteracoes, data_cadastro, v_insercao);
  RETURN NEW;
END; $$;


--
-- TOC entry 921 (class 1255 OID 9442864)
-- Name: migra_beneficios_para_tabela_aluno_aluno_beneficio(); Type: FUNCTION; Schema: pmieducar; Owner: -
--

CREATE FUNCTION pmieducar.migra_beneficios_para_tabela_aluno_aluno_beneficio() RETURNS void
    LANGUAGE plpgsql
    AS $$
  DECLARE
  cur_aluno RECORD;
  begin

  FOR cur_aluno IN (SELECT cod_aluno as id, ref_cod_aluno_beneficio as beneficio_id FROM pmieducar.aluno WHERE ref_cod_aluno_beneficio IS NOT NULL) LOOP
    INSERT INTO pmieducar.aluno_aluno_beneficio VALUES (cur_aluno.id, cur_aluno.beneficio_id);
  END LOOP;

  ALTER TABLE pmieducar.aluno DROP COLUMN ref_cod_aluno_beneficio;
  end;$$;


--
-- TOC entry 942 (class 1255 OID 9442865)
-- Name: normalizadeficienciaservidor(); Type: FUNCTION; Schema: pmieducar; Owner: -
--

CREATE FUNCTION pmieducar.normalizadeficienciaservidor() RETURNS void
    LANGUAGE plpgsql
    AS $$
  DECLARE
  cur_servidor RECORD;
  begin

    FOR cur_servidor IN (SELECT cod_servidor, ref_cod_deficiencia
                      FROM pmieducar.servidor
                      WHERE ref_cod_deficiencia is not null) LOOP


      IF ((SELECT 1 FROM cadastro.fisica_deficiencia fd WHERE fd.ref_idpes = cur_servidor.cod_servidor AND fd.ref_cod_deficiencia = cur_servidor.ref_cod_deficiencia) IS NULL ) THEN
        INSERT INTO cadastro.fisica_deficiencia VALUES (cur_servidor.cod_servidor, cur_servidor.ref_cod_deficiencia);
      END IF;

    END LOOP;

  end;$$;


--
-- TOC entry 943 (class 1255 OID 9442866)
-- Name: unifica_alunos(numeric, numeric[], integer); Type: FUNCTION; Schema: pmieducar; Owner: -
--

CREATE FUNCTION pmieducar.unifica_alunos(alunoprincipal numeric, alunos numeric[], usuario integer) RETURNS void
    LANGUAGE plpgsql
    AS $_$
        DECLARE
            alunoPrincipal ALIAS FOR $1;
            alunos ALIAS FOR $2;
            usuario ALIAS FOR $3;
        BEGIN

            UPDATE pmieducar.historico_escolar
                SET ref_cod_aluno = alunoPrincipal, sequencial = he.seq+he.max_seq
            FROM
                (
                    SELECT ref_cod_aluno AS aluno, sequencial AS seq, COALESCE((
                        SELECT max(sequencial) FROM pmieducar.historico_escolar WHERE ref_cod_aluno = alunoPrincipal
                    ),0) AS max_seq
                    FROM pmieducar.historico_escolar
                    WHERE ref_cod_aluno = ANY(alunos)
                ) AS he
              WHERE sequencial = he.seq
              AND ref_cod_aluno = he.aluno;

            UPDATE pmieducar.matricula
                SET ref_cod_aluno = alunoPrincipal
            WHERE ref_cod_aluno = ANY(alunos);

            UPDATE pmieducar.aluno
                SET ativo = 0, data_exclusao = now(), ref_usuario_exc = usuario
            WHERE cod_aluno = ANY(alunos);

        END;$_$;


--
-- TOC entry 944 (class 1255 OID 9442867)
-- Name: unifica_pessoas(numeric, numeric[], integer); Type: FUNCTION; Schema: pmieducar; Owner: -
--

CREATE FUNCTION pmieducar.unifica_pessoas(pessoaprincipal numeric, pessoas numeric[], usuario integer) RETURNS void
    LANGUAGE plpgsql
    AS $_$
        DECLARE
            pessoaPrincipal ALIAS FOR $1;
            pessoas ALIAS FOR $2;
            usuario ALIAS FOR $3;
        BEGIN

            SET session_replication_role = REPLICA;

            IF
                (SELECT COUNT(1) FROM pmieducar.aluno WHERE ref_idpes = ANY(pessoas)) > 0 AND
                (SELECT COUNT(1) FROM pmieducar.aluno WHERE ref_idpes = pessoaPrincipal) = 0
                THEN
                    UPDATE pmieducar.aluno
                        SET ref_idpes = pessoaPrincipal
                    WHERE ref_idpes = ANY(pessoas)
                    AND ref_idpes <> pessoaPrincipal
                    AND cod_aluno = (SELECT MAX(cod_aluno) FROM pmieducar.aluno WHERE ref_idpes = ANY(pessoas));

                    PERFORM pmieducar.unifica_alunos(
                        (SELECT cod_aluno FROM pmieducar.aluno WHERE ref_idpes = pessoaPrincipal),
                        (SELECT ARRAY(SELECT cod_aluno::numeric FROM pmieducar.aluno WHERE ref_idpes = ANY(pessoas))),
                        1
                    );
            ELSEIF
                (SELECT COUNT(1) FROM pmieducar.aluno WHERE ref_idpes = pessoaPrincipal) > 0 AND
                (SELECT COUNT(1) FROM pmieducar.aluno WHERE ref_idpes = ANY(pessoas)) > 0
                THEN
                    PERFORM pmieducar.unifica_alunos(
                        (SELECT cod_aluno FROM pmieducar.aluno WHERE ref_idpes = pessoaPrincipal),
                        (SELECT ARRAY(SELECT cod_aluno::numeric FROM pmieducar.aluno WHERE ref_idpes = ANY(pessoas))),
                        1
                    );
	        END IF;

	        UPDATE cadastro.fisica
                SET idpes_pai = pessoaPrincipal
            WHERE idpes_pai = ANY(pessoas);

            UPDATE cadastro.fisica
                SET idpes_mae = pessoaPrincipal
            WHERE idpes_mae = ANY(pessoas);

	        UPDATE pmieducar.servidor_alocacao
                SET ref_cod_servidor = pessoaPrincipal
            WHERE ref_cod_servidor = ANY(pessoas);

	        UPDATE pmieducar.servidor_funcao
                SET ref_cod_servidor = pessoaPrincipal
            WHERE ref_cod_servidor = ANY(pessoas);

	        IF
	            (SELECT COUNT(1) FROM pmieducar.servidor WHERE cod_servidor = ANY(pessoas)) > 0 AND
	            (SELECT COUNT(1) FROM pmieducar.servidor WHERE cod_servidor = pessoaPrincipal) = 0
	            THEN
	                INSERT INTO pmieducar.servidor SELECT
	                pessoaPrincipal as cod_servidor,
        	            ref_cod_instituicao, ref_idesco, carga_horaria,
        	            data_cadastro, data_exclusao, ativo, ref_cod_subnivel,
        	            situacao_curso_superior_1, formacao_complementacao_pedagogica_1,
        	            codigo_curso_superior_1, ano_inicio_curso_superior_1,
        	            ano_conclusao_curso_superior_1, tipo_instituicao_curso_superior_1,
        	            instituicao_curso_superior_1, situacao_curso_superior_2,
        	            formacao_complementacao_pedagogica_2, codigo_curso_superior_2,
        	            ano_inicio_curso_superior_2, ano_conclusao_curso_superior_2,
        	            tipo_instituicao_curso_superior_2, instituicao_curso_superior_2,
        	            situacao_curso_superior_3, formacao_complementacao_pedagogica_3,
        	            codigo_curso_superior_3, ano_inicio_curso_superior_3,
        	            ano_conclusao_curso_superior_3, tipo_instituicao_curso_superior_3,
        	            instituicao_curso_superior_3, pos_especializacao,
        	            pos_mestrado, pos_doutorado, pos_nenhuma,
        	            curso_creche, curso_pre_escola, curso_anos_iniciais,
        	            curso_anos_finais, curso_ensino_medio, curso_eja, curso_educacao_especial,
        	            curso_educacao_indigena, curso_educacao_campo, curso_educacao_ambiental,
        	            curso_educacao_direitos_humanos, curso_genero_diversidade_sexual,
        	            curso_direito_crianca_adolescente, curso_relacoes_etnicorraciais,
        	            curso_outros, curso_nenhum, multi_seriado
    	        FROM pmieducar.servidor
    	        WHERE cod_servidor = ANY(pessoas)
    	        ORDER BY cod_servidor ASC
                LIMIT 1;
	        END IF;

	        DELETE FROM pmieducar.servidor WHERE cod_servidor = ANY(pessoas) AND cod_servidor <> pessoaPrincipal;
            DELETE FROM cadastro.documento WHERE idpes = ANY(pessoas) AND idpes <> pessoaPrincipal;
            DELETE FROM cadastro.fisica WHERE idpes = ANY(pessoas) AND idpes <> pessoaPrincipal;
            DELETE FROM cadastro.fone_pessoa WHERE idpes = ANY(pessoas) AND idpes <> pessoaPrincipal;
            DELETE FROM cadastro.pessoa WHERE idpes = ANY(pessoas) AND idpes <> pessoaPrincipal;

            SET session_replication_role = DEFAULT;

        END;$_$;


--
-- TOC entry 945 (class 1255 OID 9442868)
-- Name: unifica_tipos_transferencia(); Type: FUNCTION; Schema: pmieducar; Owner: -
--

CREATE FUNCTION pmieducar.unifica_tipos_transferencia() RETURNS void
    LANGUAGE plpgsql
    AS $$
  DECLARE
  cur_tipo RECORD;
  v_cod_tt INTEGER;
  begin

    ALTER TABLE pmieducar.transferencia_tipo ADD COLUMN ref_cod_instituicao INTEGER;

    ALTER TABLE pmieducar.transferencia_tipo ADD CONSTRAINT transferencia_tipo_ref_cod_instituicao
    FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao (cod_instituicao) MATCH SIMPLE
    ON UPDATE RESTRICT ON DELETE RESTRICT;

    FOR cur_tipo IN (SELECT tt.cod_transferencia_tipo AS id, tt.nm_tipo, escola.ref_cod_instituicao
                      FROM pmieducar.transferencia_tipo tt
                      INNER JOIN pmieducar.escola ON (tt.ref_cod_escola = escola.cod_escola)) LOOP

      v_cod_tt := (SELECT cod_transferencia_tipo FROM transferencia_tipo WHERE to_ascii(nm_tipo) ilike to_ascii(cur_tipo.nm_tipo)
                      AND cod_transferencia_tipo <= cur_tipo.id ORDER BY cod_transferencia_tipo LIMIT 1 );

      IF (v_cod_tt = cur_tipo.id) THEN
        UPDATE pmieducar.transferencia_tipo SET ref_cod_instituicao = cur_tipo.ref_cod_instituicao WHERE cod_transferencia_tipo = cur_tipo.id;
      ELSE
        UPDATE pmieducar.transferencia_solicitacao SET ref_cod_transferencia_tipo = v_cod_tt
                                                   WHERE ref_cod_transferencia_tipo = cur_tipo.id;
        DELETE FROM pmieducar.transferencia_tipo WHERE cod_transferencia_tipo = cur_tipo.id;

      END IF;

    END LOOP;

    ALTER TABLE pmieducar.transferencia_tipo  DROP CONSTRAINT transferencia_tipo_ref_cod_escola;

    ALTER TABLE pmieducar.transferencia_tipo DROP COLUMN ref_cod_escola;

  end;$$;


--
-- TOC entry 928 (class 1255 OID 9442869)
-- Name: updated_at_matricula(); Type: FUNCTION; Schema: pmieducar; Owner: -
--

CREATE FUNCTION pmieducar.updated_at_matricula() RETURNS trigger
    LANGUAGE plpgsql
    AS $$ BEGIN NEW.updated_at = now(); RETURN NEW; END; $$;


--
-- TOC entry 935 (class 1255 OID 9442870)
-- Name: updated_at_matricula_turma(); Type: FUNCTION; Schema: pmieducar; Owner: -
--

CREATE FUNCTION pmieducar.updated_at_matricula_turma() RETURNS trigger
    LANGUAGE plpgsql
    AS $$ BEGIN NEW.updated_at = now(); RETURN NEW; END; $$;


--
-- TOC entry 897 (class 1255 OID 9442871)
-- Name: commacat_ignore_nulls(text, text); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.commacat_ignore_nulls(acc text, instr text) RETURNS text
    LANGUAGE plpgsql
    AS $$
  BEGIN
      IF acc IS NULL OR acc = '' THEN
        RETURN instr;
      ELSIF instr IS NULL OR instr = '' THEN
        RETURN acc || ' <br> ';
      ELSE
        RETURN acc || ' <br> ' || instr;
      END IF;
    END;
  $$;


--
-- TOC entry 946 (class 1255 OID 9442872)
-- Name: count_weekdays(date, date); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.count_weekdays(date, date) RETURNS integer
    LANGUAGE plpgsql STABLE
    AS $_$
     DECLARE
      start_date alias for $1;
      end_date alias for $2;
      tmp_date date;
      tmp_dow integer;
      -- double precision returned from extract
      tot_dow integer;
     BEGIN
       tmp_date := start_date;
       tot_dow := 0;
       WHILE (tmp_date <= end_date) LOOP
         select into tmp_dow  cast(extract(dow from tmp_date) as integer);
         IF ((tmp_dow >= 2) and (tmp_dow <= 6)) THEN
           tot_dow := (tot_dow + 1);
         END IF;
         select into tmp_date (tmp_date + interval '1 day ');
       END LOOP;
       return tot_dow;

     END;
  $_$;


--
-- TOC entry 947 (class 1255 OID 9442873)
-- Name: cria_distritos(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.cria_distritos() RETURNS void
    LANGUAGE plpgsql
    AS $$
  DECLARE
  cur_log RECORD;
  sequence_val INTEGER;
  begin

    FOR cur_log IN (SELECT idmun, nome, idpes_cad, data_cad, origem_gravacao, operacao, idsis_cad
                      FROM public.municipio ORDER BY idmun ASC) LOOP

      INSERT INTO public.distrito (idmun, iddis, nome, idpes_cad, data_cad, origem_gravacao, operacao, idsis_cad)
                  VALUES(cur_log.idmun, cur_log.idmun, cur_log.nome, cur_log.idpes_cad, cur_log.data_cad,
                         cur_log.origem_gravacao, cur_log.operacao, cur_log.idsis_cad);
    END LOOP;
    sequence_val := (SELECT max(iddis)+1 FROM public.distrito)::INT;
    PERFORM setval('public.seq_distrito', sequence_val);

  end;$$;


--
-- TOC entry 948 (class 1255 OID 9442874)
-- Name: data_para_extenso(date); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.data_para_extenso(data date) RETURNS character varying
    LANGUAGE plpgsql
    AS $$
DECLARE
	data_extenso varchar := '';
	mes_extenso varchar := '';
	dia integer := 0;
	mes integer := 0;
	ano integer := 0;
BEGIN

	dia := date_part('day', data)::integer;
	mes := date_part('month', data)::integer;
	ano := date_part('year', data)::integer;

	mes_extenso := case
				    when mes = 1  then 'Janeiro'
				    when mes = 2  then 'Fevereiro'
				    when mes = 3  then 'Março'
				    when mes = 4  then 'Abril'
				    when mes = 5  then 'Maio'
				    when mes = 6  then 'Junho'
				    when mes = 7  then 'Julho'
				    when mes = 8  then 'Agosto'
				    when mes = 9  then 'Setembro'
				    when mes = 10 then 'Outubro'
				    when mes = 11 then 'Novembro'
				    when mes = 12 then 'Dezembro'
				   else
				   	''
				   end;

	data_extenso := dia::varchar || ' de ' || mes_extenso || ' de ' || ano::varchar;

	return data_extenso;

END;
$$;


--
-- TOC entry 1015 (class 1255 OID 9474516)
-- Name: f_unaccent(text); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.f_unaccent(text) RETURNS text
    LANGUAGE sql IMMUTABLE
    AS $_$
            SELECT public.unaccent('public.unaccent', $1)
            $_$;


--
-- TOC entry 949 (class 1255 OID 9442875)
-- Name: fcn_aft_logradouro_fonetiza(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_aft_logradouro_fonetiza() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
   DECLARE
    v_idlog    bigint;
    v_nome_n   text;
    v_nome_v   text;
    v_fonema   text;
    v_reg_fon  record;
   BEGIN
    IF TG_OP = 'INSERT' THEN
     v_idlog  := NEW.idlog;
     v_nome_n := NEW.nome;
     FOR v_reg_fon IN SELECT DISTINCT * from public.fcn_fonetiza(v_nome_n) LOOP
      v_fonema := v_reg_fon.fcn_fonetiza;
      EXECUTE 'INSERT INTO public.logradouro_fonetico (fonema,idlog) VALUES ('||quote_literal(v_fonema)||','||quote_literal(v_idlog)||');';
     END LOOP;
    ELSIF TG_OP = 'UPDATE' THEN
     v_idlog  := NEW.idlog;
     v_nome_n := NEW.nome;
     v_nome_v := OLD.nome;
     IF v_nome_n <> v_nome_v THEN
      EXECUTE 'DELETE FROM public.logradouro_fonetico WHERE idlog = '||quote_literal(v_idlog)||';';
      FOR v_reg_fon IN SELECT DISTINCT * from public.fcn_fonetiza(v_nome_n) LOOP
       v_fonema := v_reg_fon.fcn_fonetiza;
       EXECUTE 'INSERT INTO public.logradouro_fonetico (fonema,idlog) VALUES ('||quote_literal(v_fonema)||','||quote_literal(v_idlog)||');';
      END LOOP;
     END IF;
    END IF;
    RETURN NEW;
   END;
  $$;


--
-- TOC entry 950 (class 1255 OID 9442876)
-- Name: fcn_aft_pessoa_fonetiza(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_aft_pessoa_fonetiza() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
   DECLARE
    v_idpes    bigint;
    v_nome_n   text;
    v_nome_v   text;
    v_fonema   text;
    v_reg_fon  record;
   BEGIN
    IF TG_OP = 'INSERT' THEN
     v_idpes  := NEW.idpes;
     v_nome_n := NEW.nome;
     FOR v_reg_fon IN SELECT DISTINCT * from public.fcn_fonetiza(v_nome_n) LOOP
      v_fonema := v_reg_fon.fcn_fonetiza;
      EXECUTE 'INSERT INTO cadastro.pessoa_fonetico (fonema,idpes) VALUES ('||quote_literal(v_fonema)||','||quote_literal(v_idpes)||');';
     END LOOP;
    ELSIF TG_OP = 'UPDATE' THEN
     v_idpes  := NEW.idpes;
     v_nome_n := NEW.nome;
     v_nome_v := OLD.nome;
     IF v_nome_n <> v_nome_v THEN
      EXECUTE 'DELETE FROM cadastro.pessoa_fonetico WHERE idpes = '||quote_literal(v_idpes)||';';
      FOR v_reg_fon IN SELECT DISTINCT * from public.fcn_fonetiza(v_nome_n) LOOP
       v_fonema := v_reg_fon.fcn_fonetiza;
       EXECUTE 'INSERT INTO cadastro.pessoa_fonetico (fonema,idpes) VALUES
 ('||quote_literal(v_fonema)||','||quote_literal(v_idpes)||');';
      END LOOP;
     END IF;
    END IF;
    RETURN NEW;
   END;
  $$;


--
-- TOC entry 951 (class 1255 OID 9442877)
-- Name: fcn_bef_ins_fisica(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_bef_ins_fisica() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
   DECLARE
    v_idpes    cadastro.fisica.idpes%TYPE;
    v_contador integer;
   BEGIN
    SELECT INTO v_contador count(idpes) from cadastro.juridica where idpes = NEW.idpes;
    IF v_contador = 1 THEN
     RAISE EXCEPTION 'O Identificador % já está cadastrado como Pessoa Jurídica', NEW.idpes;
    END IF;
    RETURN NEW;
   END;
  $$;


--
-- TOC entry 952 (class 1255 OID 9442878)
-- Name: fcn_bef_ins_juridica(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_bef_ins_juridica() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
   DECLARE
    v_idpes    cadastro.juridica.idpes%TYPE;
    v_contador integer;
   BEGIN
    SELECT INTO v_contador count(idpes) from cadastro.fisica where idpes = NEW.idpes;
    IF v_contador = 1 THEN
     RAISE EXCEPTION 'O Identificador % já está cadastrado como Pessoa Física', NEW.idpes;
    END IF;
    RETURN NEW;
   END;
  $$;


--
-- TOC entry 953 (class 1255 OID 9442879)
-- Name: fcn_bef_logradouro_fonetiza(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_bef_logradouro_fonetiza() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
   DECLARE
    v_idlog    bigint;
   BEGIN
    v_idlog := OLD.idlog;
    EXECUTE 'DELETE FROM public.logradouro_fonetico WHERE idlog = '||quote_literal(v_idlog)||';';
    RETURN OLD;
   END;
  $$;


--
-- TOC entry 954 (class 1255 OID 9442880)
-- Name: fcn_bef_pessoa_fonetiza(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_bef_pessoa_fonetiza() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
   DECLARE
    v_idpes    bigint;
   BEGIN
    v_idpes := OLD.idpes;
    EXECUTE 'DELETE FROM cadastro.pessoa_fonetico WHERE idpes = '||quote_literal(v_idpes)||';';
    RETURN OLD;
   END;
  $$;


--
-- TOC entry 955 (class 1255 OID 9442881)
-- Name: fcn_compara_nome_pessoa_fonetica(text, numeric); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_compara_nome_pessoa_fonetica(text, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  v_nome_parametro      ALIAS FOR $1;
  v_idpes_parametro     ALIAS FOR $2;
  v_nome_pessoa_1       text;
  v_nome_pessoa_2       text;
  v_registro        record;
  v_nome_primeiro_ultimo_pessoa_1   text;
  v_nome_primeiro_ultimo_pessoa_2   text;
  v_cont     integer;
  v_fonema   text;
  v_comando  text;

  BEGIN

  -- obter o nome da pessoa referente ao IDPES passado como parametro
  v_comando := 'SELECT nome FROM cadastro.pessoa WHERE idpes = '||quote_literal(v_idpes_parametro)||';';
  FOR v_registro IN EXECUTE v_comando LOOP
    v_nome_pessoa_1 := v_registro.nome;
  END LOOP;

  v_nome_pessoa_2 := v_nome_parametro;

  v_nome_primeiro_ultimo_pessoa_1 := '';
  v_nome_primeiro_ultimo_pessoa_2 := '';
  v_cont := 0;

  -- primeiro e último nome da pessoa com fonética
  FOR v_registro IN SELECT * FROM public.fcn_fonetiza(public.fcn_obter_primeiro_ultimo_nome(v_nome_pessoa_1)) LOOP
    v_cont := v_cont + 1;
    v_fonema := v_registro.fcn_fonetiza;

    IF v_cont > 1 THEN
      v_nome_primeiro_ultimo_pessoa_1 := v_nome_primeiro_ultimo_pessoa_1 || ' ';
    END IF;
    v_nome_primeiro_ultimo_pessoa_1 := v_nome_primeiro_ultimo_pessoa_1 || v_fonema;
  END LOOP;

  v_cont := 0;
  FOR v_registro IN SELECT * FROM public.fcn_fonetiza(public.fcn_obter_primeiro_ultimo_nome(v_nome_pessoa_2)) LOOP
    v_cont := v_cont + 1;
    v_fonema := v_registro.fcn_fonetiza;

    IF v_cont > 1 THEN
      v_nome_primeiro_ultimo_pessoa_2 := v_nome_primeiro_ultimo_pessoa_2 || ' ';
    END IF;
    v_nome_primeiro_ultimo_pessoa_2 := v_nome_primeiro_ultimo_pessoa_2 || v_fonema;
  END LOOP;

  IF v_nome_primeiro_ultimo_pessoa_1 = v_nome_primeiro_ultimo_pessoa_2 THEN
    RETURN 1;
  ELSE
    RETURN 0;
  END IF;
   END;
  $_$;


--
-- TOC entry 956 (class 1255 OID 9442882)
-- Name: fcn_cons_log_fonetica(text, bigint); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_cons_log_fonetica(text, bigint) RETURNS SETOF public.typ_idlog
    LANGUAGE plpgsql
    AS $_$
   DECLARE
    v_texto    ALIAS FOR $1;
    v_idmun    ALIAS FOR $2;
    v_fonema   text;
    v_comando  text;
    v_idlog    bigint;
    v_reg_fon  record;
    v_cont     integer;
    retorno    typ_idlog%ROWTYPE;
   BEGIN
    v_cont := 0;
    v_comando := 'select public.logradouro_fonetico.idlog from public.logradouro_fonetico, public.logradouro where (fonema = ';
    FOR v_reg_fon IN SELECT DISTINCT * FROM public.fcn_fonetiza(v_texto) LOOP v_cont := v_cont + 1;
     v_fonema := v_reg_fon.fcn_fonetiza;
     IF v_cont > 1 THEN
      v_comando := v_comando||' or fonema = ';
     END IF;
     v_comando := v_comando||quote_literal(v_fonema);
    END LOOP;
    v_comando := v_comando||') AND public.logradouro.idlog = public.logradouro_fonetico.idlog';
    v_comando := v_comando||' AND public.logradouro.idmun = '||v_idmun;
    v_comando := v_comando||' group by public.logradouro_fonetico.idlog having count(fonema) = '||quote_literal(v_cont)||';';
    FOR retorno IN EXECUTE v_comando LOOP
     RETURN NEXT retorno;
    END LOOP;
    RETURN;
   END;
  $_$;


--
-- TOC entry 957 (class 1255 OID 9442883)
-- Name: fcn_consulta_fonetica(text); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_consulta_fonetica(text) RETURNS SETOF public.typ_idpes
    LANGUAGE plpgsql
    AS $_$
   DECLARE
    v_texto    ALIAS FOR $1;
    v_fonema   text;
    v_comando  text;
    v_idpes    bigint;
    v_reg_fon  record;
    v_cont     integer;
    retorno typ_idpes%ROWTYPE;
   BEGIN
    v_cont := 0;
    v_comando := 'select idpes from cadastro.pessoa_fonetico where fonema = ';
    FOR v_reg_fon IN SELECT DISTINCT * FROM public.fcn_fonetiza(v_texto) LOOP
     v_cont := v_cont + 1;
     v_fonema := v_reg_fon.fcn_fonetiza;
     IF v_cont > 1 THEN
      v_comando := v_comando||' or fonema = ';
     END IF;
     v_comando := v_comando||quote_literal(v_fonema);
    END LOOP;
    v_comando := v_comando||' group by idpes having count(fonema) = '||quote_literal(v_cont)||';';
    FOR retorno IN EXECUTE v_comando LOOP
     RETURN NEXT retorno;
    END LOOP;
    RETURN;
   END;
  $_$;


--
-- TOC entry 958 (class 1255 OID 9442884)
-- Name: fcn_delete_endereco_externo(integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_delete_endereco_externo(integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_idpes ALIAS for $1;
  v_tipo ALIAS for $2;

BEGIN
  -- Deleta dados da tabela endereco_externo
  DELETE FROM cadastro.endereco_externo WHERE idpes = v_idpes AND tipo = v_tipo;
  RETURN 0;
END;$_$;


--
-- TOC entry 959 (class 1255 OID 9442885)
-- Name: fcn_delete_endereco_pessoa(integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_delete_endereco_pessoa(integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_idpes ALIAS for $1;
  v_tipo ALIAS for $2;

BEGIN
  -- Deleta dados da tabela endereco_pessoa
  DELETE FROM cadastro.endereco_pessoa WHERE idpes = v_idpes AND tipo = v_tipo;
  RETURN 0;
END;$_$;


--
-- TOC entry 960 (class 1255 OID 9442886)
-- Name: fcn_delete_fone_pessoa(integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_delete_fone_pessoa(integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;

BEGIN
  -- Deleta dados da tabela fone_pessoa
  DELETE FROM cadastro.fone_pessoa WHERE idpes = v_id_pes;
  RETURN 0;
END;$_$;


--
-- TOC entry 961 (class 1255 OID 9442887)
-- Name: fcn_delete_funcionario(integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_delete_funcionario(integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_matricula ALIAS for $1;
  v_id_ins ALIAS for $2;

BEGIN
  -- Deleta dados da tabela funcionário
  DELETE FROM cadastro.funcionario WHERE matricula = v_matricula AND idins = v_id_ins;
  RETURN 0;
END;$_$;


--
-- TOC entry 962 (class 1255 OID 9442888)
-- Name: fcn_dia_util(date, date); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_dia_util(date, date) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_dt_ini ALIAS for $1;
  v_dt_fim ALIAS for $2;
  v_dt_ini_x date;
  v_qtde integer;
BEGIN
  v_qtde := 0;
  v_dt_ini_x := v_dt_ini;
  WHILE v_dt_ini_x <= v_dt_fim LOOP
    IF to_char(v_dt_ini_x,'D') NOT IN ('1','7') THEN
      IF NOT EXISTS(SELECT idfer
             from servicos.feriado
             WHERE to_char(data,'DD/MM/YYYY') =
             to_char(v_dt_ini_x,'DD/MM/YYYY')) THEN
        v_qtde := v_qtde + 1;
      END IF;
    END IF;
    v_dt_ini_x := v_dt_ini_x + interval '1 day';
  END LOOP;
  RETURN v_qtde;
END;$_$;


--
-- TOC entry 963 (class 1255 OID 9442889)
-- Name: fcn_fonetiza(text); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_fonetiza(text) RETURNS SETOF text
    LANGUAGE plpgsql
    AS $_$
   DECLARE
    v_array         ALIAS FOR $1;
    orig            text := '';
    dest            text := '';
    ori             integer := 1;
    v_campo         integer;
   BEGIN
    orig := public.fcn_upper_nrm(v_array)||'  ';
    FOR ori IN 1..152 LOOP
     IF substr(orig, ori, 1) = ' ' THEN
      IF substr(orig, ori + 1, 1) = ' ' THEN
       IF dest IN ('DA','DAS','DOS','DU','DUS','DI','E','S/A','LTDA','OTIDA','S.A','DO','DE','-','AVI','I','OA','A','SA') THEN
        dest := '';
       END IF;
       IF dest <> ' ' AND
          dest <> '' THEN
        RETURN NEXT trim(dest);
        dest := '';
       END IF;
       ori := 152;
       EXIT;
      ELSE
       IF dest IN ('DA','DAS','DOS','DU','DUS','DI','E','S/A','LTDA','OTIDA','S.A','DO','DE','-','AVI','I','OA','A','SA') THEN
        dest := '';
       END IF;
       IF dest <> ' ' AND
          dest <> '' THEN
        RETURN NEXT trim(dest);
        dest := '';
       END IF;
       ori := ori + 1;
      END IF;
     ELSIF substr(orig,ori + 1,1) = '-' OR
           substr(orig,ori + 1,1) = '/' THEN
      IF substr(orig,ori,1) <> ' ' AND
         substr(orig,ori + 2,1) <> ' ' THEN
       orig = substr(orig,1,ori)||' '||substr(orig,ori + 1,42);
      END IF;
     END IF;
     -- Numero
     IF substr(orig,ori,1) >= '0' and
        substr(orig,ori,1) <= '9' THEN
      dest := dest||substr(orig,ori,1);
     -- Letra Igual
     ELSIF substr(orig,ori,1) = substr(orig,ori + 1,1) THEN
      IF length(dest) = 1 THEN
       dest := '';
      END IF;
     -- Letras A, I ou O
     ELSIF substr(orig,ori,1) = 'A' OR
           substr(orig,ori,1) = 'I' OR
           substr(orig,ori,1) = 'O' THEN
      dest := dest||substr(orig,ori,1);
     -- Letra E
     ELSIF substr(orig,ori,1) = 'E' THEN
      dest := dest||'I';
     -- Letra R
     ELSIF substr(orig,ori,1) = 'R' THEN
       dest := dest||'H';
     -- Letra S
     ELSIF substr(orig,ori,1) = 'S' THEN
      IF substr(orig,ori + 1,1) NOT IN ('A','E','I','O','U','Y') AND
         length(dest) = 0 THEN
       dest := dest||'IS';
      ELSIF substr(orig,ori + 1,1) = 'C' AND
            substr(orig,ori + 2,1) = 'H' THEN
       IF length(dest) = 1 THEN
        dest := '';
       END IF;
      ELSIF substr(orig,ori + 1,1) = 'H' THEN
       dest := dest||'KS';
       ori := ori + 1;
      ELSE
       dest := dest||substr(orig,ori,1);
      END IF;
     -- Letra N
     ELSIF substr(orig,ori,1) = 'N' THEN
      IF substr(orig,ori + 1,1) = 'H' THEN
       dest := dest||'NI';
      ELSE
       IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
        dest := dest||substr(orig,ori,1);
       ELSE
        dest := dest||'M';
       END IF;
      END IF;
     -- Letra L
     ELSIF substr(orig,ori,1) = 'L' THEN
      IF substr(orig,ori + 1,1) = 'H' THEN
       dest := dest||'LI';
      ELSIF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'O';
      END IF;
     -- Letra D
     ELSIF substr(orig,ori,1) = 'D' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'DI';
      END IF;
     -- Letra C
     ELSIF substr(orig,ori,1) = 'C' THEN
      IF substr(orig,ori + 1,1) = 'H' THEN
       IF substr(orig,ori + 2,1) IN ('A','E','I','O','U','Y') THEN
        dest := dest||'KS';
        ori := ori + 1;
       END IF;
      ELSIF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
       IF substr(orig,ori + 1,1) IN ('E','I','Y') THEN
        dest := dest||'S';
       ELSE
        dest := dest||'K';
       END IF;
      ELSE
       IF length(dest) = 1 THEN
        dest := '';
       END IF;
      END IF;
     -- Letra M
     ELSIF substr(orig,ori,1) = 'M' THEN
      IF substr(orig,ori + 1,1) = 'N' THEN
       IF length(dest) = 1 THEN
        dest := '';
       END IF;
      ELSE
       dest := dest||substr(orig,ori,1);
      END IF;
     -- Letra T
     ELSIF substr(orig,ori,1) = 'T' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'TI';
      END IF;
     -- Letra U
     ELSIF substr(orig,ori,1) = 'U' THEN
      dest := dest||'O';
     -- Letra V
     ELSIF substr(orig,ori,1) = 'V' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'VI';
      END IF;
     -- Letra G
     ELSIF substr(orig,ori,1) = 'G' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
       IF substr(orig,ori + 1,1) = 'U' AND
          substr(orig,ori + 2,1) IN ('I','E','Y') THEN
        dest := dest||'J';
        ori := ori + 1;
       ELSE
        dest := dest||'J';
       END IF;
      ELSE
       dest := dest||'JI';
      END IF;
     -- Letra B
     ELSIF substr(orig,ori,1) = 'B' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'BI';
      END IF;
     -- Letra P
     ELSIF substr(orig,ori,1) = 'P' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       IF substr(orig,ori + 1,1) = 'H' THEN
        dest := dest||'F';
       ELSE
        dest := dest||'PI';
       END IF;
      END IF;
     -- Letra Z
     ELSIF substr(orig,ori,1) = 'Z' THEN
       dest := dest||'S';
     -- Letra F
     ELSIF substr(orig,ori,1) = 'F' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'FI';
      END IF;
     -- Letra J
     ELSIF substr(orig,ori,1) = 'J' THEN
      dest := dest||'J';
     -- Letra K
     ELSIF substr(orig,ori,1) = 'K' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'KI';
      END IF;
     -- Letra Y
     ELSIF substr(orig,ori,1) = 'Y' THEN
      dest := dest||'I';
     -- Letra W
     ELSIF substr(orig,ori,1) = 'W' THEN
      IF ori = 1 THEN
       IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
        dest := dest||'V';
       ELSE
        dest := dest||'VI';
       END IF;
      ELSIF substr(orig,ori - 1,1) IN ('E','I') THEN
       IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
        dest := dest||'V';
       ELSE
        dest := dest||'O';
       END IF;
      ELSE
       dest := dest||'V';
      END IF;
     -- Letra Q
     ELSIF substr(orig,ori,1) = 'Q' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y',' ') THEN
       dest := dest||'K';
       IF substr(orig,ori + 1,1) = 'U' AND
          substr(orig,ori + 2,1) IN ('I','E','Y') THEN
        ori := ori + 1;
       END IF;
      ELSE
       dest := dest||'QI';
      END IF;
     -- Letra X
     ELSIF substr(orig,ori,1) = 'X' THEN
      dest := dest||'KS';
     END IF;
    END LOOP;
    dest := NULL;
    RETURN;
   END;
  $_$;


--
-- TOC entry 964 (class 1255 OID 9442890)
-- Name: fcn_fonetiza_logr_geral(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_fonetiza_logr_geral() RETURNS text
    LANGUAGE plpgsql
    AS $$
   DECLARE
    v_fonema   text;
    v_nomlog   text;
    v_idlog    bigint;
    v_reg_log  record;
    v_reg_fon  record;
    v_cont     integer;
   BEGIN
    FOR v_reg_log IN SELECT idlog, nome FROM public.logradouro LOOP
     v_nomlog := v_reg_log.nome;
     v_idlog  := v_reg_log.idlog;
     FOR v_reg_fon IN SELECT DISTINCT * FROM public.fcn_fonetiza(v_nomlog) LOOP
      v_fonema := v_reg_fon.fcn_fonetiza;
      EXECUTE 'INSERT INTO public.logradouro_fonetico (fonema,idlog) VALUES ('||quote_literal(v_fonema)||','||quote_literal(v_idlog)||');';
     END LOOP;
    END LOOP;
    SELECT count(idlog) INTO v_cont FROM public.logradouro_fonetico;
    v_fonema := 'Foram gravados '||to_char(v_cont,'9999999')||' registros em logradouro_fonetico';
    RETURN v_fonema;
   END;
  $$;


--
-- TOC entry 966 (class 1255 OID 9442891)
-- Name: fcn_fonetiza_palavra(text); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_fonetiza_palavra(text) RETURNS text
    LANGUAGE plpgsql
    AS $_$
DECLARE
    v_array         ALIAS FOR $1;
    orig            text := '';
    dest            text := '';
    ori             integer := 1;
    v_campo         integer;
   BEGIN
    orig := public.fcn_upper_nrm(v_array)||'  ';
    FOR ori IN 1..152 LOOP
     IF substr(orig, ori, 1) = ' ' THEN
      IF substr(orig, ori + 1, 1) = ' ' THEN
       IF dest IN ('DA','DAS','DOS','DU','DUS','DI','E','S/A','LTDA','OTIDA','S.A','DO','DE','-','AVI','I','OA','A','SA') THEN
        dest := '';
       END IF;
       IF dest <> ' ' AND
          dest <> '' THEN
        RETURN trim(dest);
        dest := '';
       END IF;
       ori := 152;
       EXIT;
      ELSE
       IF dest IN ('DA','DAS','DOS','DU','DUS','DI','E','S/A','LTDA','OTIDA','S.A','DO','DE','-','AVI','I','OA','A','SA') THEN
        dest := '';
       END IF;
       IF dest <> ' ' AND
          dest <> '' THEN
        RETURN trim(dest);
        dest := '';
       END IF;
       ori := ori + 1;
      END IF;
     ELSIF substr(orig,ori + 1,1) = '-' OR
           substr(orig,ori + 1,1) = '/' THEN
      IF substr(orig,ori,1) <> ' ' AND
         substr(orig,ori + 2,1) <> ' ' THEN
       orig = substr(orig,1,ori)||' '||substr(orig,ori + 1,42);
      END IF;
     END IF;
     -- Numero
     IF substr(orig,ori,1) >= '0' and
        substr(orig,ori,1) <= '9' THEN
      dest := dest||substr(orig,ori,1);
     -- Letra Igual
     ELSIF substr(orig,ori,1) = substr(orig,ori + 1,1) THEN
      IF length(dest) = 1 THEN
       dest := '';
      END IF;
     -- Letras A, I ou O
     ELSIF substr(orig,ori,1) = 'A' OR
           substr(orig,ori,1) = 'I' OR
           substr(orig,ori,1) = 'O' THEN
      dest := dest||substr(orig,ori,1);
     -- Letra E
     ELSIF substr(orig,ori,1) = 'E' THEN
      dest := dest||'I';
     -- Letra R
     ELSIF substr(orig,ori,1) = 'R' THEN
       dest := dest||'H';
     -- Letra S
     ELSIF substr(orig,ori,1) = 'S' THEN
      IF substr(orig,ori + 1,1) NOT IN ('A','E','I','O','U','Y') AND
         length(dest) = 0 THEN
       dest := dest||'IS';
      ELSIF substr(orig,ori + 1,1) = 'C' AND
            substr(orig,ori + 2,1) = 'H' THEN
       IF length(dest) = 1 THEN
        dest := '';
       END IF;
      ELSIF substr(orig,ori + 1,1) = 'H' THEN
       dest := dest||'KS';
       ori := ori + 1;
      ELSE
       dest := dest||substr(orig,ori,1);
      END IF;
     -- Letra N
     ELSIF substr(orig,ori,1) = 'N' THEN
      IF substr(orig,ori + 1,1) = 'H' THEN
       dest := dest||'NI';
      ELSE
       IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
        dest := dest||substr(orig,ori,1);
       ELSE
        dest := dest||'M';
       END IF;
      END IF;
     -- Letra L
     ELSIF substr(orig,ori,1) = 'L' THEN
      IF substr(orig,ori + 1,1) = 'H' THEN
       dest := dest||'LI';
      ELSIF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'O';
      END IF;
     -- Letra D
     ELSIF substr(orig,ori,1) = 'D' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'DI';
      END IF;
     -- Letra C
     ELSIF substr(orig,ori,1) = 'C' THEN
      IF substr(orig,ori + 1,1) = 'H' THEN
       IF substr(orig,ori + 2,1) IN ('A','E','I','O','U','Y') THEN
        dest := dest||'KS';
        ori := ori + 1;
       END IF;
      ELSIF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
       IF substr(orig,ori + 1,1) IN ('E','I','Y') THEN
        dest := dest||'S';
       ELSE
        dest := dest||'K';
       END IF;
      ELSE
       IF length(dest) = 1 THEN
        dest := '';
       END IF;
      END IF;
     -- Letra M
     ELSIF substr(orig,ori,1) = 'M' THEN
      IF substr(orig,ori + 1,1) = 'N' THEN
       IF length(dest) = 1 THEN
        dest := '';
       END IF;
      ELSE
       dest := dest||substr(orig,ori,1);
      END IF;
     -- Letra T
     ELSIF substr(orig,ori,1) = 'T' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'TI';
      END IF;
     -- Letra U
     ELSIF substr(orig,ori,1) = 'U' THEN
      dest := dest||'O';
     -- Letra V
     ELSIF substr(orig,ori,1) = 'V' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'VI';
      END IF;
     -- Letra G
     ELSIF substr(orig,ori,1) = 'G' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
       IF substr(orig,ori + 1,1) = 'U' AND
          substr(orig,ori + 2,1) IN ('I','E','Y') THEN
        dest := dest||'J';
        ori := ori + 1;
       ELSE
        dest := dest||'J';
       END IF;
      ELSE
       dest := dest||'JI';
      END IF;
     -- Letra B
     ELSIF substr(orig,ori,1) = 'B' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'BI';
      END IF;
     -- Letra P
     ELSIF substr(orig,ori,1) = 'P' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       IF substr(orig,ori + 1,1) = 'H' THEN
        dest := dest||'F';
       ELSE
        dest := dest||'PI';
       END IF;
      END IF;
     -- Letra Z
     ELSIF substr(orig,ori,1) = 'Z' THEN
       dest := dest||'S';
     -- Letra F
     ELSIF substr(orig,ori,1) = 'F' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'FI';
      END IF;
     -- Letra J
     ELSIF substr(orig,ori,1) = 'J' THEN
      dest := dest||'J';
     -- Letra K
     ELSIF substr(orig,ori,1) = 'K' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'KI';
      END IF;
     -- Letra Y
     ELSIF substr(orig,ori,1) = 'Y' THEN
      dest := dest||'I';
     -- Letra W
     ELSIF substr(orig,ori,1) = 'W' THEN
      IF ori = 1 THEN
       IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
        dest := dest||'V';
       ELSE
        dest := dest||'VI';
       END IF;
      ELSIF substr(orig,ori - 1,1) IN ('E','I') THEN
       IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
        dest := dest||'V';
       ELSE
        dest := dest||'O';
       END IF;
      ELSE
       dest := dest||'V';
      END IF;
     -- Letra Q
     ELSIF substr(orig,ori,1) = 'Q' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y',' ') THEN
       dest := dest||'K';
       IF substr(orig,ori + 1,1) = 'U' AND
          substr(orig,ori + 2,1) IN ('I','E','Y') THEN
        ori := ori + 1;
       END IF;
      ELSE
       dest := dest||'QI';
      END IF;
     -- Letra X
     ELSIF substr(orig,ori,1) = 'X' THEN
      dest := dest||'KS';
     END IF;
    END LOOP;
    dest := NULL;
    RETURN;
   END;
  $_$;


--
-- TOC entry 967 (class 1255 OID 9442892)
-- Name: fcn_fonetiza_pessoa_geral(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_fonetiza_pessoa_geral() RETURNS text
    LANGUAGE plpgsql
    AS $$
   DECLARE
    v_fonema   text;
    v_nome     text;
    v_idpes    bigint;
    v_reg_pes  record;
    v_reg_fon  record;
    v_cont     integer;
   BEGIN
    FOR v_reg_pes IN SELECT idpes, nome FROM cadastro.pessoa LOOP
     v_nome  := v_reg_pes.nome;
     v_idpes := v_reg_pes.idpes;
     FOR v_reg_fon IN SELECT DISTINCT * FROM public.fcn_fonetiza(v_nome) LOOP
      v_fonema := v_reg_fon.fcn_fonetiza;
      EXECUTE 'INSERT INTO cadastro.pessoa_fonetico (fonema,idpes) VALUES ('||quote_literal(v_fonema)||','||quote_literal(v_idpes)||');';
     END LOOP;
    END LOOP;
    SELECT count(idpes) INTO v_cont FROM cadastro.pessoa_fonetico;
    v_fonema := 'Foram gravados '||to_char(v_cont,'999999')||' registros em pessoa_fonetico';
    RETURN v_fonema;
   END;
  $$;


--
-- TOC entry 968 (class 1255 OID 9442893)
-- Name: fcn_fonetiza_primeiro_ultimo_nome(text); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_fonetiza_primeiro_ultimo_nome(text) RETURNS text
    LANGUAGE plpgsql
    AS $_$
DECLARE
  v_nome_parametro    ALIAS FOR $1;
  v_registro      record;
  v_nome_primeiro_ultimo_pessoa text;
  v_cont          integer;
  v_fonema        text;
  BEGIN
  v_nome_primeiro_ultimo_pessoa := '';
  v_cont := 0;
  -- primeiro e último nome da pessoa com fonética
  FOR v_registro IN SELECT * FROM public.fcn_fonetiza(public.fcn_obter_primeiro_ultimo_nome(v_nome_parametro)) LOOP
    v_cont := v_cont + 1;
    v_fonema := v_registro.fcn_fonetiza;
    IF v_cont > 1 THEN
      v_nome_primeiro_ultimo_pessoa := v_nome_primeiro_ultimo_pessoa || ' ';
    END IF;
    v_nome_primeiro_ultimo_pessoa := v_nome_primeiro_ultimo_pessoa || v_fonema;
  END LOOP;
  RETURN v_nome_primeiro_ultimo_pessoa;
   END;
  $_$;


--
-- TOC entry 969 (class 1255 OID 9442894)
-- Name: fcn_insert_documento(integer, character varying, character varying, character varying, character varying, integer, integer, integer, integer, character varying, character varying, character varying, character varying, integer, integer, character varying, character varying, integer, integer, character, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_insert_documento(integer, character varying, character varying, character varying, character varying, integer, integer, integer, integer, character varying, character varying, character varying, character varying, integer, integer, character varying, character varying, integer, integer, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_rg ALIAS for $2;
  v_orgao_exp_rg ALIAS for $3;
  v_data_exp_rg ALIAS for $4;
  v_sigla_uf_exp_rg ALIAS for $5;
      v_tipo_cert_civil ALIAS for $6;
      v_num_termo ALIAS for $7;
  v_num_livro ALIAS for $8;
  v_num_folha ALIAS for $9;
      v_data_emissao_cert_civil ALIAS for $10;
      v_sigla_uf_cert_civil ALIAS for $11;
  v_sigla_uf_cart_trabalho ALIAS for $12;
  v_cartorio_cert_civil ALIAS for $13;
  v_num_cart_trabalho ALIAS for $14;
      v_serie_cart_trabalho ALIAS for $15;
      v_data_emissao_cart_trabalho ALIAS for $16;
  v_num_tit_eleitor ALIAS for $17;
  v_zona_tit_eleitor ALIAS for $18;
  v_secao_tit_eleitor ALIAS for $19;
  v_origem_gravacao ALIAS for $20;
  v_idpes_cad ALIAS for $21;
  v_idsis_cad ALIAS for $22;

    -- Outras variáveis
      v_rg_aux varchar(10);
      v_orgao_exp_rg_aux varchar(10);
      v_sigla_uf_exp_rg_aux varchar(2);
  v_tipo_cert_civil_aux integer;
  v_num_termo_aux integer;
  v_num_livro_aux integer;
  v_num_folha_aux integer;
      v_sigla_uf_cert_civil_aux varchar(2);
  v_sigla_uf_cart_trabalho_aux varchar(2);
      v_cartorio_cert_civil_aux varchar(150);
      v_num_cart_trabalho_aux integer;
      v_serie_cart_trabalho_aux integer;
      v_num_tit_eleitor_aux varchar(13);
      v_zona_tit_eleitor_aux integer;
      v_secao_tit_eleitor_aux integer;
BEGIN
    IF v_rg = '' THEN
        v_rg_aux := NULL;
    ELSE
        v_rg_aux := v_rg;
    END IF;
    IF v_orgao_exp_rg = '' THEN
        v_orgao_exp_rg_aux := NULL;
    ELSE
        v_orgao_exp_rg_aux := v_orgao_exp_rg;
    END IF;
    IF v_sigla_uf_exp_rg = '' THEN
        v_sigla_uf_exp_rg_aux := NULL;
    ELSE
        v_sigla_uf_exp_rg_aux := v_sigla_uf_exp_rg;
    END IF;
    IF v_tipo_cert_civil = 0 THEN
        v_tipo_cert_civil_aux := NULL;
    ELSE
        v_tipo_cert_civil_aux := v_tipo_cert_civil;
    END IF;
    IF v_num_termo = 0 THEN
        v_num_termo_aux := NULL;
    ELSE
        v_num_termo_aux := v_num_termo;
    END IF;
    IF v_num_livro = 0 THEN
        v_num_livro_aux := NULL;
    ELSE
        v_num_livro_aux := v_num_livro;
    END IF;
    IF v_num_folha = 0 THEN
        v_num_folha_aux := NULL;
    ELSE
        v_num_folha_aux := v_num_folha;
    END IF;
    IF v_sigla_uf_cert_civil = '' THEN
        v_sigla_uf_cert_civil_aux := NULL;
    ELSE
        v_sigla_uf_cert_civil_aux := v_sigla_uf_cert_civil;
    END IF;
    IF v_sigla_uf_cart_trabalho = '' THEN
        v_sigla_uf_cart_trabalho_aux := NULL;
    ELSE
        v_sigla_uf_cart_trabalho_aux := v_sigla_uf_cart_trabalho;
    END IF;
    IF v_cartorio_cert_civil = '' THEN
        v_cartorio_cert_civil_aux := NULL;
    ELSE
        v_cartorio_cert_civil_aux := v_cartorio_cert_civil;
    END IF;
    IF v_num_cart_trabalho = 0 THEN
        v_num_cart_trabalho_aux := NULL;
    ELSE
        v_num_cart_trabalho_aux := v_num_cart_trabalho;
    END IF;
    IF v_serie_cart_trabalho = 0 THEN
        v_serie_cart_trabalho_aux := NULL;
    ELSE
        v_serie_cart_trabalho_aux := v_serie_cart_trabalho;
    END IF;
    IF v_num_tit_eleitor = '' THEN
        v_num_tit_eleitor_aux := NULL;
    ELSE
        v_num_tit_eleitor_aux := v_num_tit_eleitor;
    END IF;
    IF v_zona_tit_eleitor = 0 THEN
        v_zona_tit_eleitor_aux := NULL;
    ELSE
        v_zona_tit_eleitor_aux := v_zona_tit_eleitor;
    END IF;
    IF v_secao_tit_eleitor = 0 THEN
        v_secao_tit_eleitor_aux := NULL;
    ELSE
        v_secao_tit_eleitor_aux := v_secao_tit_eleitor;
    END IF;

  -- Insere dados na tabela funcionário
    INSERT INTO cadastro.documento (idpes, rg, idorg_exp_rg,
                                data_exp_rg, sigla_uf_exp_rg,
                                tipo_cert_civil, num_termo,
                                num_livro, num_folha,
                                data_emissao_cert_civil, sigla_uf_cert_civil,
                                sigla_uf_cart_trabalho, cartorio_cert_civil,
                                num_cart_trabalho, serie_cart_trabalho,
                                data_emissao_cart_trabalho, num_tit_eleitor,                                              zona_tit_eleitor, secao_tit_eleitor, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao)
    VALUES(v_id_pes, to_number(v_rg_aux,9999999999), to_number(v_orgao_exp_rg_aux,9999999999),
           to_date(v_data_exp_rg,'DD/MM/YYYY'), v_sigla_uf_exp_rg_aux,
           v_tipo_cert_civil_aux, v_num_termo_aux,
           v_num_livro_aux, v_num_folha_aux,
           to_date(v_data_emissao_cert_civil,'DD/MM/YYYY'), v_sigla_uf_cert_civil_aux,
           v_sigla_uf_cart_trabalho_aux, v_cartorio_cert_civil_aux,
           v_num_cart_trabalho_aux, v_serie_cart_trabalho_aux,
           to_date(v_data_emissao_cart_trabalho,'DD/MM/YYYY'), to_number(v_num_tit_eleitor_aux,9999999999999),
           v_zona_tit_eleitor_aux, v_secao_tit_eleitor_aux, v_origem_gravacao, v_idpes_cad, v_idsis_cad, CURRENT_TIMESTAMP, 'I');
  RETURN 0;
END;$_$;


--
-- TOC entry 970 (class 1255 OID 9442895)
-- Name: fcn_insert_endereco_externo(integer, integer, character varying, character varying, character varying, integer, character varying, character varying, character varying, integer, character varying, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_insert_endereco_externo(integer, integer, character varying, character varying, character varying, integer, character varying, character varying, character varying, integer, character varying, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_tipo ALIAS for $2;
  v_sigla_uf ALIAS for $3;
  v_idtlog ALIAS for $4;
    v_logradouro ALIAS for $5;
    v_numero ALIAS for $6;
    v_letra ALIAS for $7;
    v_complemento ALIAS for $8;
    v_bairro ALIAS for $9;
    v_cep ALIAS for $10;
    v_cidade ALIAS for $11;
    v_reside_desde ALIAS for $12;
    v_origem_gravacao ALIAS for $13;
    v_idpes_cad ALIAS for $14;
    v_idsis_cad ALIAS for $15;

BEGIN
  -- Atualiza dados na tabela endereco_externo
    INSERT INTO cadastro.endereco_externo(idpes, tipo, sigla_uf, idtlog, logradouro, numero, letra, complemento, bairro, cep, cidade, reside_desde, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao)
    VALUES (v_id_pes, v_tipo, v_sigla_uf, v_idtlog, public.fcn_upper(v_logradouro), v_numero, public.fcn_upper(v_letra), public.fcn_upper(v_complemento), public.fcn_upper(v_bairro), v_cep, public.fcn_upper(v_cidade), to_date(v_reside_desde,'DD/MM/YYYY'), v_origem_gravacao, v_idpes_cad, v_idsis_cad, CURRENT_TIMESTAMP, 'I');

  RETURN 0;
END;$_$;


--
-- TOC entry 971 (class 1255 OID 9442896)
-- Name: fcn_insert_endereco_pessoa(integer, integer, integer, integer, integer, integer, character varying, character varying, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_insert_endereco_pessoa(integer, integer, integer, integer, integer, integer, character varying, character varying, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_tipo ALIAS for $2;
  v_cep ALIAS for $3;
  v_idlog ALIAS for $4;
  v_idbai ALIAS for $5;
  v_numero ALIAS for $6;
  v_letra ALIAS for $7;
  v_complemento ALIAS for $8;
  v_reside_desde ALIAS for $9;
  v_origem_gravacao ALIAS for $10;
      v_idpes_cad ALIAS for $11;
      v_idsis_cad ALIAS for $12;
BEGIN
  -- Insere dados na tabela endereco_pessoa
    INSERT INTO cadastro.endereco_pessoa (idpes,tipo,cep,idlog,idbai,numero,letra,complemento,reside_desde, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao)
  VALUES(v_id_pes,v_tipo,v_cep,v_idlog,v_idbai,v_numero,public.fcn_upper(v_letra),public.fcn_upper(v_complemento),to_date(v_reside_desde,'DD/MM/YYYY'), v_origem_gravacao, v_idpes_cad, v_idsis_cad, CURRENT_TIMESTAMP, 'I');
  RETURN 0;
END;$_$;


--
-- TOC entry 972 (class 1255 OID 9442897)
-- Name: fcn_insert_fisica(integer, character varying, character varying, integer, integer, integer, integer, integer, integer, character varying, character varying, integer, integer, character varying, integer, character varying, integer, character varying, character varying, character varying, character varying, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_insert_fisica(integer, character varying, character varying, integer, integer, integer, integer, integer, integer, character varying, character varying, integer, integer, character varying, integer, character varying, integer, character varying, character varying, character varying, character varying, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_data_nasc ALIAS for $2;
  v_sexo ALIAS for $3;
  v_id_pes_mae ALIAS for $4;
      v_id_pes_pai ALIAS for $5;
      v_id_pes_responsavel ALIAS for $6;
  v_id_esco ALIAS for $7;
  v_id_eciv ALIAS for $8;
  v_id_pes_con ALIAS for $9;
      v_data_uniao ALIAS for $10;
      v_data_obito ALIAS for $11;
  v_nacionalidade ALIAS for $12;
  v_id_pais_estrangeiro ALIAS for $13;
  v_data_chegada ALIAS for $14;
      v_id_mun_nascimento ALIAS for $15;
      v_ultima_empresa ALIAS for $16;
  v_id_ocup ALIAS for $17;
  v_nome_mae ALIAS for $18;
  v_nome_pai ALIAS for $19;
      v_nome_conjuge ALIAS for $20;
      v_nome_responsavel ALIAS for $21;
      v_justificativa_provisorio ALIAS for $22;
  v_origem_gravacao ALIAS for $23;
      v_idpes_cad ALIAS for $24;
      v_idsis_cad ALIAS for $25;
      -- Outras variáveis
      v_id_pes_mae_aux integer;
      v_id_pes_pai_aux integer;
      v_id_pes_responsavel_aux integer;
  v_id_esco_aux integer;
  v_id_eciv_aux integer;
  v_id_pes_con_aux integer;
      v_nacionalidade_aux integer;
  v_id_pais_estrangeiro_aux integer;
      v_id_mun_nascimento_aux integer;
      v_id_ocup_aux integer;
      v_sexo_aux text;
BEGIN
    IF v_id_pes_mae = 0 THEN
        v_id_pes_mae_aux := NULL;
    ELSE
        v_id_pes_mae_aux := v_id_pes_mae;
    END IF;
    IF v_id_pes_pai = 0 THEN
        v_id_pes_pai_aux := NULL;
    ELSE
        v_id_pes_pai_aux := v_id_pes_pai;
    END IF;
    IF v_id_pes_responsavel = 0 THEN
        v_id_pes_responsavel_aux := NULL;
    ELSE
        v_id_pes_responsavel_aux := v_id_pes_responsavel;
    END IF;
    IF v_id_esco = 0 THEN
        v_id_esco_aux := NULL;
    ELSE
        v_id_esco_aux := v_id_esco;
    END IF;
    IF v_id_eciv = 0 THEN
        v_id_eciv_aux := NULL;
    ELSE
        v_id_eciv_aux := v_id_eciv;
    END IF;
    IF v_id_pes_con = 0 THEN
        v_id_pes_con_aux := NULL;
    ELSE
        v_id_pes_con_aux := v_id_pes_con;
    END IF;
    IF v_nacionalidade = 0 THEN
        v_nacionalidade_aux := NULL;
    ELSE
        v_nacionalidade_aux := v_nacionalidade;
    END IF;
    IF v_id_pais_estrangeiro = 0 THEN
        v_id_pais_estrangeiro_aux := NULL;
    ELSE
        v_id_pais_estrangeiro_aux := v_id_pais_estrangeiro;
    END IF;
    IF v_id_mun_nascimento = 0 THEN
        v_id_mun_nascimento_aux := NULL;
    ELSE
        v_id_mun_nascimento_aux := v_id_mun_nascimento;
    END IF;
    IF v_id_ocup = 0 THEN
        v_id_ocup_aux := NULL;
    ELSE
        v_id_ocup_aux := v_id_ocup;
    END IF;
    IF TRIM(v_sexo) = '' THEN
        v_sexo_aux := NULL;
    ELSE
        v_sexo_aux := public.fcn_upper(v_sexo);
    END IF;
  -- Insere dados na tabela funcionário
    INSERT INTO cadastro.fisica (idpes, data_nasc, sexo,
                                idpes_mae,idpes_pai, idpes_responsavel,
                                idesco, ideciv, idpes_con,
                                data_uniao, data_obito, nacionalidade,
                                idpais_estrangeiro, data_chegada_brasil, idmun_nascimento,
                                ultima_empresa, idocup, nome_mae,
                                nome_pai, nome_conjuge,
                                nome_responsavel, justificativa_provisorio, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao)
    VALUES(v_id_pes,to_date(v_data_nasc,'DD/MM/YYYY'),v_sexo_aux,
           v_id_pes_mae_aux, v_id_pes_pai_aux, v_id_pes_responsavel_aux,
           v_id_esco_aux, v_id_eciv_aux, v_id_pes_con_aux,
           to_date(v_data_uniao,'DD/MM/YYYY'), to_date(v_data_obito,'DD/MM/YYYY'), v_nacionalidade_aux,
           v_id_pais_estrangeiro_aux, to_date(v_data_chegada,'DD/MM/YYYY'), v_id_mun_nascimento_aux,             public.fcn_upper(v_ultima_empresa), v_id_ocup_aux, public.fcn_upper(v_nome_mae),
           public.fcn_upper(v_nome_pai), public.fcn_upper(v_nome_conjuge),
           public.fcn_upper(v_nome_responsavel), v_justificativa_provisorio, v_origem_gravacao, v_idpes_cad, v_idsis_cad, CURRENT_TIMESTAMP, 'I');

  RETURN 0;
END;$_$;


--
-- TOC entry 973 (class 1255 OID 9442898)
-- Name: fcn_insert_fisica_cpf(integer, text, character, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_insert_fisica_cpf(integer, text, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_cpf ALIAS for $2;
  v_origem_gravacao ALIAS for $3;
      v_idpes_cad ALIAS for $4;
      v_idsis_cad ALIAS for $5;
BEGIN
  INSERT INTO cadastro.fisica_cpf (idpes,cpf, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (v_id_pes,to_number(v_cpf,99999999999), v_origem_gravacao, v_idpes_cad, v_idsis_cad, CURRENT_TIMESTAMP, 'I');
  RETURN 0;
END;$_$;


--
-- TOC entry 974 (class 1255 OID 9442899)
-- Name: fcn_insert_fone_pessoa(integer, integer, integer, integer, character, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_insert_fone_pessoa(integer, integer, integer, integer, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_tipo ALIAS for $2;
  v_ddd ALIAS for $3;
  v_fone ALIAS for $4;
  v_origem_gravacao ALIAS for $5;
      v_idpes_cad ALIAS for $6;
      v_idsis_cad ALIAS for $7;
BEGIN
  -- Insere dados na tabela fone_pessoa
  INSERT INTO cadastro.fone_pessoa (idpes,tipo,ddd,fone, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao)
    VALUES (v_id_pes,v_tipo,v_ddd,v_fone, v_origem_gravacao, v_idpes_cad, v_idsis_cad, CURRENT_TIMESTAMP, 'I');
  RETURN 0;
END;$_$;


--
-- TOC entry 975 (class 1255 OID 9442900)
-- Name: fcn_insert_funcionario(integer, integer, integer, integer, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_insert_funcionario(integer, integer, integer, integer, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_matricula ALIAS for $1;
  v_id_ins ALIAS for $2;
  v_id_set ALIAS for $3;
  v_id_pes ALIAS for $4;
      v_situacao ALIAS for $5;
  v_origem_gravacao ALIAS for $6;
      v_idpes_cad ALIAS for $7;
      v_idsis_cad ALIAS for $8;
    -- Outras variáveis
    v_id_set_aux integer;
BEGIN
    IF v_id_set = 0 THEN
        v_id_set_aux := NULL;
    ELSE
        v_id_set_aux := v_id_set;
    END IF;
  -- Insere dados na tabela funcionário
    INSERT INTO cadastro.funcionario (matricula,idins,idset,idpes,situacao, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao)
    VALUES(v_matricula,v_id_ins,v_id_set_aux,v_id_pes,public.fcn_upper(v_situacao), v_origem_gravacao, v_idpes_cad, v_idsis_cad, CURRENT_TIMESTAMP, 'I');
  RETURN 0;
END;$_$;


--
-- TOC entry 976 (class 1255 OID 9442901)
-- Name: fcn_insert_juridica(integer, character varying, character varying, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_insert_juridica(integer, character varying, character varying, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_cnpj ALIAS for $2;
  v_fantasia ALIAS for $3;
  v_inscr_estadual ALIAS for $4;
  v_origem_gravacao ALIAS for $5;
      v_idpes_cad ALIAS for $6;
      v_idsis_cad ALIAS for $7;

BEGIN
  -- Insere dados na tabela juridica
    INSERT INTO cadastro.juridica (idpes,cnpj,fantasia,insc_estadual, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao)
    VALUES (v_id_pes,to_number(v_cnpj,99999999999999),public.fcn_upper(v_fantasia),to_number(v_inscr_estadual,9999999999), v_origem_gravacao, v_idpes_cad, v_idsis_cad, CURRENT_TIMESTAMP, 'I');
  RETURN 0;
END;$_$;


--
-- TOC entry 977 (class 1255 OID 9442902)
-- Name: fcn_insert_pessoa(integer, character varying, character varying, character varying, character varying, integer, character varying, character varying, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_insert_pessoa(integer, character varying, character varying, character varying, character varying, integer, character varying, character varying, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_razao_social ALIAS for $2;
  v_url ALIAS for $3;
  v_email ALIAS for $4;
  v_situacao ALIAS for $5;
  v_id_pes_logado ALIAS for $6;
  v_tipo ALIAS for $7;
  v_origem_gravacao ALIAS for $8;
      v_idpes_cad ALIAS for $9;
      v_idsis_cad ALIAS for $10;

  idpes_logado integer;
BEGIN
  idpes_logado := v_id_pes_logado;
  IF (idpes_logado <= 0) THEN
    INSERT INTO cadastro.pessoa (idpes,nome,idpes_cad,data_cad,url,tipo,email,situacao,origem_gravacao, idsis_cad, operacao) VALUES (v_id_pes,public.fcn_upper(v_razao_social),NULL,CURRENT_TIMESTAMP,v_url,v_tipo,v_email,v_situacao,v_origem_gravacao, v_idsis_cad, 'I');
  ELSE
    INSERT INTO cadastro.pessoa (idpes,nome,idpes_cad,data_cad,url,tipo,email,situacao,origem_gravacao, idsis_cad, operacao) VALUES (v_id_pes,public.fcn_upper(v_razao_social),idpes_logado,CURRENT_TIMESTAMP,v_url,v_tipo,v_email,v_situacao,v_origem_gravacao, v_idsis_cad, 'I');
  END IF;
  RETURN 0;
END;$_$;


--
-- TOC entry 978 (class 1255 OID 9442903)
-- Name: fcn_obter_primeiro_ultimo_nome(text); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_obter_primeiro_ultimo_nome(text) RETURNS text
    LANGUAGE plpgsql
    AS $_$
DECLARE
  v_nome_parametro    ALIAS FOR $1;
  v_nome        text;
  v_primeiro_nome     text;
  v_ultimo_nome     text;
  v_posicao_espaco_primeiro_nome  integer;
  v_posicao_espaco_ultimo_nome  integer;
  v_cont        integer;
  v_fonema_junior     text;
  v_fonema_sobrinho   text;
  v_fonema_sobrinha   text;
  v_fonema_filho      text;
  v_fonema_filha      text;
  v_fonema_ultimo_nome    text;
  v_reg       record;
  v_total_caracteres    integer;
  BEGIN
  v_primeiro_nome := '';
  v_ultimo_nome := '';
  v_nome := TRIM(v_nome_parametro);
  v_total_caracteres := LENGTH(v_nome);
  -- obter somente o primeiro e o último nome das pessoas
  IF v_total_caracteres > 0 THEN
    -- retirar os espaços duplicados
    WHILE POSITION('  ' IN v_nome) > 0 LOOP
      v_nome := REPLACE(UPPER(v_nome),'  ', ' ');
    END LOOP;
    -- retirar ocorrências que devem ser ignoradas no nome
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OUTROS', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OUTRAS', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OUTRO', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OUTRA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OUTRS', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OTS', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OUTA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OUT', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E SM', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E S/M', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OT', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' S/M', ''));
    v_total_caracteres := LENGTH(v_nome);
    IF v_total_caracteres = (POSITION(' OUTRO' IN v_nome) + 5) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' OUTRO', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' OUTRA' IN v_nome) + 5) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' OUTRA', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' OUTROS' IN v_nome) + 6) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' OUTROS', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' OUTRAS' IN v_nome) + 6) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' OUTRAS', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' OTS' IN v_nome) + 3) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' OTS', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' OUTA' IN v_nome) + 4) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' OUTA', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' OUT' IN v_nome) + 3) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' OUT', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' OUTRS' IN v_nome) + 5) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' OUTRS', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' SM' IN v_nome) + 2) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' SM', ''));
    END IF;
    v_nome := TRIM(v_nome);
    -- posição do espaço em branco para obter o primeiro nome
    v_posicao_espaco_primeiro_nome := POSITION(' ' IN v_nome);
    IF v_posicao_espaco_primeiro_nome > 0 THEN
      v_primeiro_nome := SUBSTR(v_nome, 1, (v_posicao_espaco_primeiro_nome - 1));
    ELSE
      v_primeiro_nome := v_nome;
    END IF;
    -- obter o último nome
    v_posicao_espaco_ultimo_nome := 0;
    IF v_posicao_espaco_primeiro_nome > 0 THEN
      v_cont := v_posicao_espaco_ultimo_nome + 1;
      -- obter posição do espaço em branco anterior ao último nome
      WHILE v_cont < LENGTH(v_nome) LOOP
        IF SUBSTR(v_nome, v_cont, 1) = ' ' THEN
          v_posicao_espaco_ultimo_nome = v_cont;
        END IF;
        v_cont := v_cont + 1;
      END LOOP;
      v_ultimo_nome := SUBSTR(v_nome, (v_posicao_espaco_ultimo_nome + 1));
      -- fonema do último nome
      FOR v_reg IN SELECT * FROM public.fcn_fonetiza(v_ultimo_nome) LOOP
        v_fonema_ultimo_nome := v_reg.fcn_fonetiza;
      END LOOP;
      -- verificar se o último nome termina com Junior, Sobrinho ou Filho e outros
      FOR v_reg IN SELECT * FROM public.fcn_fonetiza('junior') LOOP
        v_fonema_junior := v_reg.fcn_fonetiza;
      END LOOP;
      FOR v_reg IN SELECT * FROM public.fcn_fonetiza('sobrinho') LOOP
        v_fonema_sobrinho := v_reg.fcn_fonetiza;
      END LOOP;
      FOR v_reg IN SELECT * FROM public.fcn_fonetiza('filho') LOOP
        v_fonema_filho := v_reg.fcn_fonetiza;
      END LOOP;
      FOR v_reg IN SELECT * FROM public.fcn_fonetiza('filha') LOOP
        v_fonema_filha := v_reg.fcn_fonetiza;
      END LOOP;
      FOR v_reg IN SELECT * FROM public.fcn_fonetiza('sobrinha') LOOP
        v_fonema_sobrinha := v_reg.fcn_fonetiza;
      END LOOP;
      IF v_fonema_ultimo_nome = v_fonema_junior OR
                          v_fonema_ultimo_nome = v_fonema_sobrinho OR
                          v_fonema_ultimo_nome = v_fonema_filho OR
                          v_fonema_ultimo_nome = v_fonema_filha OR
                          v_fonema_ultimo_nome = v_fonema_sobrinha
                        THEN
        v_nome := TRIM(SUBSTR(v_nome, 1, (LENGTH(v_nome) - LENGTH(v_ultimo_nome) - 1)));
        v_primeiro_nome := '';
        v_ultimo_nome := '';
        -- obter novamente o primeiro nome
        v_posicao_espaco_primeiro_nome := POSITION(' ' IN v_nome);
        IF v_posicao_espaco_primeiro_nome > 0 THEN
          v_primeiro_nome := SUBSTR(v_nome, 1, (v_posicao_espaco_primeiro_nome - 1));
        END IF;

        -- obter o penultimo nome
        IF v_posicao_espaco_primeiro_nome > 0 THEN
          v_posicao_espaco_ultimo_nome := 0;
          v_cont := 1;

          -- obter posição do espaço em branco anterior ao último nome
          WHILE v_cont < LENGTH(v_nome) LOOP
          IF SUBSTR(v_nome, v_cont, 1) = ' ' THEN
            v_posicao_espaco_ultimo_nome = v_cont;
          END IF;
          v_cont := v_cont + 1;
          END LOOP;
          v_ultimo_nome := SUBSTR(v_nome, (v_posicao_espaco_ultimo_nome + 1));
        END IF;
      END IF;
    END IF;
  END IF;
  RETURN v_primeiro_nome || ' ' || v_ultimo_nome;
  END;
  $_$;


--
-- TOC entry 979 (class 1255 OID 9442904)
-- Name: fcn_obter_primeiro_ultimo_nome_juridica(text); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_obter_primeiro_ultimo_nome_juridica(text) RETURNS text
    LANGUAGE plpgsql
    AS $_$
DECLARE
  v_nome_parametro    ALIAS FOR $1;
  v_nome        text;
  v_primeiro_nome     text;
  v_ultimo_nome     text;
  v_posicao_espaco_primeiro_nome  integer;
  v_posicao_espaco_ultimo_nome  integer;
  v_cont        integer;
  v_fonema_ultimo_nome    text;
  v_reg       record;
  v_total_caracteres    integer;
  BEGIN
  v_primeiro_nome := '';
  v_ultimo_nome := '';
  v_nome := TRIM(v_nome_parametro);
  v_total_caracteres := LENGTH(v_nome);
  -- obter somente o primeiro e o ultimo nome das pessoas
  IF v_total_caracteres > 0 THEN
    -- retirar os espaços duplicados
    WHILE POSITION('  ' IN v_nome) > 0 LOOP
      v_nome := REPLACE(UPPER(v_nome),'  ', ' ');
    END LOOP;
    -- retirar ocorrências que devem ser ignoradas no nome
    v_nome := TRIM(REPLACE(UPPER(v_nome),'&', ' '));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E CIA LTDA ME', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E CIA LTDA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' LTDA E OUTRA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' CIA LTDA ME', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' CIA LTDA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' CIA. LTDA.', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' CIA.LTDA.', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' CIA.LTDA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' CIA LTDA.', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' CIA. LTDA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' SC LT', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' S/C LT', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' S/C L', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' SC L', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' S/C LTD', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' SC LTD', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E CIA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' LTDA ME', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' LTDA. ME', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' LTDA.ME', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),'LTDA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),'LTDA.', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),'S/C', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),'S/A', ''));
    v_total_caracteres := LENGTH(v_nome);
    IF v_total_caracteres = (POSITION(' LT' IN v_nome) + 2) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' LT', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' LT.' IN v_nome) + 3) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' LT.', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' LTD' IN v_nome) + 3) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' LTD', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' LTD.' IN v_nome) + 4) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' LTD.', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' ME.' IN v_nome) + 3) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' ME.', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' ME' IN v_nome) + 2) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' ME', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' -ME' IN v_nome) + 3) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' -ME', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' -ME.' IN v_nome) + 4) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' -ME.', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' SA' IN v_nome) + 2) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' SA', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' S.A.' IN v_nome) + 4) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' S.A.', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' S.A' IN v_nome) + 3) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' S.A', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' S A' IN v_nome) + 3) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' S A', ''));
    END IF;
    v_nome := TRIM(v_nome);
    -- posição do espaco em branco para obter o primeiro nome
    v_posicao_espaco_primeiro_nome := POSITION(' ' IN v_nome);
    IF v_posicao_espaco_primeiro_nome > 0 THEN
      v_primeiro_nome := SUBSTR(v_nome, 1, (v_posicao_espaco_primeiro_nome - 1));
    ELSE
      v_primeiro_nome := v_nome;
    END IF;
    -- obter o ultimo nome
    v_posicao_espaco_ultimo_nome := 0;
    IF v_posicao_espaco_primeiro_nome > 0 THEN
      v_cont := v_posicao_espaco_ultimo_nome + 1;
      -- obter posicao do espaco em branco anterior ao ultimo nome
      WHILE v_cont < LENGTH(v_nome) LOOP
        IF SUBSTR(v_nome, v_cont, 1) = ' ' THEN
          v_posicao_espaco_ultimo_nome = v_cont;
        END IF;
        v_cont := v_cont + 1;
      END LOOP;
      v_ultimo_nome := SUBSTR(v_nome, (v_posicao_espaco_ultimo_nome + 1));
    END IF;
  END IF;
  --Fonetizando o primeiro nome--
  FOR v_reg IN SELECT * FROM public.fcn_fonetiza(v_primeiro_nome) LOOP
    v_primeiro_nome := v_reg.fcn_fonetiza;
  END LOOP;
  --Fonetizando o ultimo nome nome--
  FOR v_reg IN SELECT * FROM public.fcn_fonetiza(v_ultimo_nome) LOOP
    v_ultimo_nome := v_reg.fcn_fonetiza;
  END LOOP;
  RETURN v_primeiro_nome || ' ' || v_ultimo_nome;
  END;
  $_$;


--
-- TOC entry 980 (class 1255 OID 9442905)
-- Name: fcn_update_documento(integer, character varying, character varying, character varying, character varying, integer, integer, integer, integer, character varying, character varying, character varying, character varying, integer, integer, character varying, character varying, integer, integer, character, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_update_documento(integer, character varying, character varying, character varying, character varying, integer, integer, integer, integer, character varying, character varying, character varying, character varying, integer, integer, character varying, character varying, integer, integer, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_rg ALIAS for $2;
  v_orgao_exp_rg ALIAS for $3;
  v_data_exp_rg ALIAS for $4;
  v_sigla_uf_exp_rg ALIAS for $5;
    v_tipo_cert_civil ALIAS for $6;
    v_num_termo ALIAS for $7;
  v_num_livro ALIAS for $8;
  v_num_folha ALIAS for $9;
    v_data_emissao_cert_civil ALIAS for $10;
    v_sigla_uf_cert_civil ALIAS for $11;
  v_sigla_uf_cart_trabalho ALIAS for $12;
  v_cartorio_cert_civil ALIAS for $13;
  v_num_cart_trabalho ALIAS for $14;
    v_serie_cart_trabalho ALIAS for $15;
    v_data_emissao_cart_trabalho ALIAS for $16;
  v_num_tit_eleitor ALIAS for $17;
  v_zona_tit_eleitor ALIAS for $18;
  v_secao_tit_eleitor ALIAS for $19;
  v_origem_gravacao ALIAS for $20;
  v_idpes_rev ALIAS for $21;
  v_idsis_rev ALIAS for $22;

    -- Outras variáveis
    v_rg_aux varchar(10);
    v_orgao_exp_rg_aux varchar(10);
    v_sigla_uf_exp_rg_aux varchar(2);
    v_tipo_cert_civil_aux integer;
  v_num_termo_aux integer;
  v_num_livro_aux integer;
  v_num_folha_aux integer;
    v_sigla_uf_cert_civil_aux varchar(2);
  v_sigla_uf_cart_trabalho_aux varchar(2);
    v_cartorio_cert_civil_aux varchar(150);
    v_num_cart_trabalho_aux integer;
    v_serie_cart_trabalho_aux integer;
    v_num_tit_eleitor_aux varchar(13);
    v_zona_tit_eleitor_aux integer;
    v_secao_tit_eleitor_aux integer;
BEGIN
    IF v_rg = '' THEN
        v_rg_aux := NULL;
    ELSE
        v_rg_aux := v_rg;
    END IF;
    IF v_orgao_exp_rg = '' THEN
        v_orgao_exp_rg_aux := NULL;
    ELSE
        v_orgao_exp_rg_aux := v_orgao_exp_rg;
    END IF;
    IF v_sigla_uf_exp_rg = '' THEN
        v_sigla_uf_exp_rg_aux := NULL;
    ELSE
        v_sigla_uf_exp_rg_aux := v_sigla_uf_exp_rg;
    END IF;
    IF v_tipo_cert_civil = 0 THEN
        v_tipo_cert_civil_aux := NULL;
    ELSE
        v_tipo_cert_civil_aux := v_tipo_cert_civil;
    END IF;
    IF v_num_termo = 0 THEN
        v_num_termo_aux := NULL;
    ELSE
        v_num_termo_aux := v_num_termo;
    END IF;
    IF v_num_livro = 0 THEN
        v_num_livro_aux := NULL;
    ELSE
        v_num_livro_aux := v_num_livro;
    END IF;
    IF v_num_folha = 0 THEN
        v_num_folha_aux := NULL;
    ELSE
        v_num_folha_aux := v_num_folha;
    END IF;
    IF v_sigla_uf_cert_civil = '' THEN
        v_sigla_uf_cert_civil_aux := NULL;
    ELSE
        v_sigla_uf_cert_civil_aux := v_sigla_uf_cert_civil;
    END IF;
    IF v_sigla_uf_cart_trabalho = '' THEN
        v_sigla_uf_cart_trabalho_aux := NULL;
    ELSE
        v_sigla_uf_cart_trabalho_aux := v_sigla_uf_cart_trabalho;
    END IF;
    IF v_cartorio_cert_civil = '' THEN
        v_cartorio_cert_civil_aux := NULL;
    ELSE
        v_cartorio_cert_civil_aux := v_cartorio_cert_civil;
    END IF;
    IF v_num_cart_trabalho = 0 THEN
        v_num_cart_trabalho_aux := NULL;
    ELSE
        v_num_cart_trabalho_aux := v_num_cart_trabalho;
    END IF;
    IF v_serie_cart_trabalho = 0 THEN
        v_serie_cart_trabalho_aux := NULL;
    ELSE
        v_serie_cart_trabalho_aux := v_serie_cart_trabalho;
    END IF;
    IF v_num_tit_eleitor = '' THEN
        v_num_tit_eleitor_aux := NULL;
    ELSE
        v_num_tit_eleitor_aux := v_num_tit_eleitor;
    END IF;
    IF v_zona_tit_eleitor = 0 THEN
        v_zona_tit_eleitor_aux := NULL;
    ELSE
        v_zona_tit_eleitor_aux := v_zona_tit_eleitor;
    END IF;
    IF v_secao_tit_eleitor = 0 THEN
        v_secao_tit_eleitor_aux := NULL;
    ELSE
        v_secao_tit_eleitor_aux := v_secao_tit_eleitor;
    END IF;

  -- Insere dados na tabela funcionário
    UPDATE cadastro.documento
    SET rg = to_number(v_rg_aux,9999999999),
        idorg_exp_rg = to_number(v_orgao_exp_rg_aux,9999999999),
        data_exp_rg = to_date(v_data_exp_rg,'DD/MM/YYYY'),
        sigla_uf_exp_rg = v_sigla_uf_exp_rg_aux,
        tipo_cert_civil = v_tipo_cert_civil_aux,
        num_termo = v_num_termo_aux,
        num_livro = v_num_livro_aux,
        num_folha = v_num_folha_aux,
        data_emissao_cert_civil = to_date(v_data_emissao_cert_civil,'DD/MM/YYYY'),
        sigla_uf_cert_civil = v_sigla_uf_cert_civil_aux,
        sigla_uf_cart_trabalho = v_sigla_uf_cart_trabalho_aux,
        cartorio_cert_civil = v_cartorio_cert_civil_aux,
        num_cart_trabalho = v_num_cart_trabalho_aux,
        serie_cart_trabalho = v_serie_cart_trabalho_aux,
        data_emissao_cart_trabalho = to_date(v_data_emissao_cart_trabalho,'DD/MM/YYYY'),
        num_tit_eleitor = to_number(v_num_tit_eleitor_aux,9999999999999),                                              zona_tit_eleitor = v_zona_tit_eleitor_aux,
        secao_tit_eleitor = v_secao_tit_eleitor_aux,
  origem_gravacao = v_origem_gravacao,
  idpes_rev = v_idpes_rev,
  idsis_rev = v_idsis_rev,
  data_rev = CURRENT_TIMESTAMP,
  operacao = 'A'
    WHERE idpes = v_id_pes;


  RETURN 0;
END;$_$;


--
-- TOC entry 981 (class 1255 OID 9442906)
-- Name: fcn_update_endereco_externo(integer, integer, character varying, character varying, character varying, integer, character varying, character varying, character varying, integer, character varying, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_update_endereco_externo(integer, integer, character varying, character varying, character varying, integer, character varying, character varying, character varying, integer, character varying, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_tipo ALIAS for $2;
  v_sigla_uf ALIAS for $3;
  v_idtlog ALIAS for $4;
    v_logradouro ALIAS for $5;
    v_numero ALIAS for $6;
    v_letra ALIAS for $7;
    v_complemento ALIAS for $8;
    v_bairro ALIAS for $9;
    v_cep ALIAS for $10;
    v_cidade ALIAS for $11;
    v_reside_desde ALIAS for $12;
    v_origem_gravacao ALIAS for $13;
    v_idpes_rev ALIAS for $14;
    v_idsis_rev ALIAS for $15;

BEGIN
  -- Atualiza dados na tabela endereco_externo
  UPDATE cadastro.endereco_externo
    SET sigla_uf = v_sigla_uf,
        idtlog = v_idtlog,
        logradouro = public.fcn_upper(v_logradouro),
        numero = v_numero,
        letra = public.fcn_upper(v_letra),
        complemento = public.fcn_upper(v_complemento),
        bairro = public.fcn_upper(v_bairro),
        cep = v_cep,
        cidade = public.fcn_upper(v_cidade),
        reside_desde = to_date(v_reside_desde,'DD/MM/YYYY'),
  origem_gravacao = v_origem_gravacao,
  idpes_rev = v_idpes_rev,
  idsis_rev = v_idsis_rev,
  data_rev = CURRENT_TIMESTAMP,
  operacao = 'A'
    WHERE idpes = v_id_pes
    AND tipo = v_tipo;
  RETURN 0;
END;$_$;


--
-- TOC entry 982 (class 1255 OID 9442907)
-- Name: fcn_update_endereco_pessoa(integer, integer, integer, integer, integer, integer, character varying, character varying, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_update_endereco_pessoa(integer, integer, integer, integer, integer, integer, character varying, character varying, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
    -- Parâmetro recebidos
    v_id_pes ALIAS for $1;
    v_tipo ALIAS for $2;
    v_cep ALIAS for $3;
    v_idlog ALIAS for $4;
    v_idbai ALIAS for $5;
    v_numero ALIAS for $6;
    v_letra ALIAS for $7;
    v_complemento ALIAS for $8;
    v_reside_desde ALIAS for $9;
    v_origem_gravacao ALIAS for $10;
    v_idpes_rev ALIAS for $11;
    v_idsis_rev ALIAS for $12;
    v_sql_update text;
BEGIN
    -- Atualiza dados na tabela endereco_pessoa
    UPDATE cadastro.endereco_pessoa
    SET cep = v_cep,
        idlog = v_idlog,
        idbai = v_idbai,
        numero = v_numero,
        letra = public.fcn_upper(v_letra),
        complemento = public.fcn_upper(v_complemento),
        reside_desde = to_date(v_reside_desde,'DD/MM/YYYY'),
  origem_gravacao = v_origem_gravacao,
  idpes_rev = v_idpes_rev,
  idsis_rev = v_idsis_rev,
  data_rev = CURRENT_TIMESTAMP,
  operacao = 'A'
    WHERE idpes = v_id_pes
    AND tipo = v_tipo;
    RETURN 0;
END;$_$;


--
-- TOC entry 983 (class 1255 OID 9442908)
-- Name: fcn_update_fisica(integer, character varying, character varying, integer, integer, integer, integer, integer, integer, character varying, character varying, integer, integer, character varying, integer, character varying, integer, character varying, character varying, character varying, character varying, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_update_fisica(integer, character varying, character varying, integer, integer, integer, integer, integer, integer, character varying, character varying, integer, integer, character varying, integer, character varying, integer, character varying, character varying, character varying, character varying, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_data_nasc ALIAS for $2;
  v_sexo ALIAS for $3;
  v_id_pes_mae ALIAS for $4;
      v_id_pes_pai ALIAS for $5;
      v_id_pes_responsavel ALIAS for $6;
  v_id_esco ALIAS for $7;
  v_id_eciv ALIAS for $8;
  v_id_pes_con ALIAS for $9;
      v_data_uniao ALIAS for $10;
      v_data_obito ALIAS for $11;
  v_nacionalidade ALIAS for $12;
  v_id_pais_estrangeiro ALIAS for $13;
  v_data_chegada ALIAS for $14;
      v_id_mun_nascimento ALIAS for $15;
      v_ultima_empresa ALIAS for $16;
  v_id_ocup ALIAS for $17;
  v_nome_mae ALIAS for $18;
  v_nome_pai ALIAS for $19;
      v_nome_conjuge ALIAS for $20;
      v_nome_responsavel ALIAS for $21;
      v_justificativa_provisorio ALIAS for $22;
      v_origem_gravacao ALIAS for $23;
      v_idpes_rev ALIAS for $24;
      v_idsis_rev ALIAS for $25;

      -- Outras variáveis
      v_id_pes_mae_aux integer;
      v_id_pes_pai_aux integer;
      v_id_pes_responsavel_aux integer;
  v_id_esco_aux integer;
  v_id_eciv_aux integer;
  v_id_pes_con_aux integer;
      v_nacionalidade_aux integer;
  v_id_pais_estrangeiro_aux integer;
      v_id_mun_nascimento_aux integer;
      v_id_ocup_aux integer;
  v_sexo_aux text;
BEGIN
    IF v_id_pes_mae = 0 THEN
        v_id_pes_mae_aux := NULL;
    ELSE
        v_id_pes_mae_aux := v_id_pes_mae;
    END IF;
    IF v_id_pes_pai = 0 THEN
        v_id_pes_pai_aux := NULL;
    ELSE
        v_id_pes_pai_aux := v_id_pes_pai;
    END IF;
    IF v_id_pes_responsavel = 0 THEN
        v_id_pes_responsavel_aux := NULL;
    ELSE
        v_id_pes_responsavel_aux := v_id_pes_responsavel;
    END IF;
    IF v_id_esco = 0 THEN
        v_id_esco_aux := NULL;
    ELSE
        v_id_esco_aux := v_id_esco;
    END IF;
    IF v_id_eciv = 0 THEN
        v_id_eciv_aux := NULL;
    ELSE
        v_id_eciv_aux := v_id_eciv;
    END IF;
    IF v_id_pes_con = 0 THEN
        v_id_pes_con_aux := NULL;
    ELSE
        v_id_pes_con_aux := v_id_pes_con;
    END IF;
    IF v_nacionalidade = 0 THEN
        v_nacionalidade_aux := NULL;
    ELSE
        v_nacionalidade_aux := v_nacionalidade;
    END IF;
    IF v_id_pais_estrangeiro = 0 THEN
        v_id_pais_estrangeiro_aux := NULL;
    ELSE
        v_id_pais_estrangeiro_aux := v_id_pais_estrangeiro;
    END IF;
    IF v_id_mun_nascimento = 0 THEN
        v_id_mun_nascimento_aux := NULL;
    ELSE
        v_id_mun_nascimento_aux := v_id_mun_nascimento;
    END IF;
    IF v_id_ocup = 0 THEN
        v_id_ocup_aux := NULL;
    ELSE
        v_id_ocup_aux := v_id_ocup;
    END IF;
    IF TRIM(v_sexo) = '' THEN
        v_sexo_aux := NULL;
    ELSE
        v_sexo_aux := public.fcn_upper(v_sexo);
    END IF;
  -- Insere dados na tabela funcionário
    UPDATE cadastro.fisica
    SET data_nasc = to_date(v_data_nasc,'DD/MM/YYYY'),
        sexo = v_sexo_aux,
        idpes_mae = v_id_pes_mae_aux,
        idpes_pai = v_id_pes_pai_aux,
        idpes_responsavel = v_id_pes_responsavel_aux,
        idesco = v_id_esco_aux,
        ideciv = v_id_eciv_aux,
        idpes_con = v_id_pes_con_aux,
        data_uniao = to_date(v_data_uniao,'DD/MM/YYYY'),
        data_obito = to_date(v_data_obito,'DD/MM/YYYY'),
        nacionalidade = v_nacionalidade_aux,
        idpais_estrangeiro = v_id_pais_estrangeiro_aux,
        data_chegada_brasil = to_date(v_data_chegada,'DD/MM/YYYY'),
        idmun_nascimento = v_id_mun_nascimento_aux,
        ultima_empresa = public.fcn_upper(v_ultima_empresa),
        idocup = v_id_ocup_aux,
        nome_mae = public.fcn_upper(v_nome_mae),
        nome_pai = public.fcn_upper(v_nome_pai),
        nome_conjuge = public.fcn_upper(v_nome_conjuge),
        nome_responsavel = public.fcn_upper(v_nome_responsavel),
        justificativa_provisorio = v_justificativa_provisorio,
  origem_gravacao = v_origem_gravacao,
  idpes_rev = v_idpes_rev,
  idsis_rev = v_idsis_rev,
  data_rev = CURRENT_TIMESTAMP,
  operacao = 'A'
    WHERE idpes = v_id_pes;

  RETURN 0;
END;$_$;


--
-- TOC entry 984 (class 1255 OID 9442909)
-- Name: fcn_update_fisica_cpf(integer, text, character, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_update_fisica_cpf(integer, text, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_cpf ALIAS for $2;
  v_origem_gravacao ALIAS for $3;
  v_idpes_rev ALIAS for $4;
  v_idsis_rev ALIAS for $5;

BEGIN
  -- Atualiza dados na tabela fisica_cpf
  UPDATE cadastro.fisica_cpf SET
    origem_gravacao = v_origem_gravacao,
    idpes_rev = v_idpes_rev,
    idsis_rev = v_idsis_rev,
    data_rev = CURRENT_TIMESTAMP,
    operacao = 'A',
    cpf = to_number(v_cpf,99999999999)
    WHERE cadastro.fisica_cpf.idpes = v_id_pes;
  RETURN 0;
END;$_$;


--
-- TOC entry 985 (class 1255 OID 9442910)
-- Name: fcn_update_fone_pessoa(integer, integer, integer, integer, character, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_update_fone_pessoa(integer, integer, integer, integer, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_tipo ALIAS for $2;
  v_ddd ALIAS for $3;
  v_fone ALIAS for $4;
  v_origem_gravacao ALIAS for $5;
      v_idpes_rev ALIAS for $6;
      v_idsis_rev ALIAS for $7;

BEGIN
  -- Atualiza dados na tabela fone_pessoa
  UPDATE cadastro.fone_pessoa
    SET ddd = v_ddd,
        fone = v_fone,
  origem_gravacao = v_origem_gravacao,
  idpes_rev = v_idpes_rev,
  idsis_rev = v_idsis_rev,
  data_rev = CURRENT_TIMESTAMP,
  operacao = 'A'
    WHERE idpes = v_id_pes
    AND tipo = v_tipo;
  RETURN 0;
END;$_$;


--
-- TOC entry 986 (class 1255 OID 9442911)
-- Name: fcn_update_funcionario(numeric, integer, integer, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_update_funcionario(numeric, integer, integer, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_matricula ALIAS for $1;
  v_id_ins ALIAS for $2;
  v_id_set ALIAS for $3;
  v_situacao ALIAS for $4;
      v_origem_gravacao ALIAS for $5;
      v_idpes_rev ALIAS for $6;
      v_idsis_rev ALIAS for $7;
  -- Outras variáveis
  v_id_set_aux integer;
  v_matricula_aux numeric;
  v_id_ins_aux integer;
  v_situacao_aux varchar(1);
BEGIN
  v_matricula_aux := v_matricula;
  v_id_ins_aux := v_id_ins;
  v_situacao_aux := v_situacao;
  IF v_id_set <= 0 THEN
    v_id_set_aux := NULL;
  ELSE
    v_id_set_aux := v_id_set;
  END IF;

  IF v_id_set_aux IS NULL AND v_id_set = -1 THEN
    -- Sql utilizado para ativar e desativar o registro na tabela funcionário
     UPDATE cadastro.funcionario
      SET situacao=v_situacao_aux,
      origem_gravacao = v_origem_gravacao,
      idpes_rev = v_idpes_rev,
      idsis_rev = v_idsis_rev,
      data_rev = CURRENT_DATE,
      operacao = 'A'
      WHERE
          matricula=v_matricula_aux AND
          idins=v_id_ins_aux;
  ELSE
    UPDATE cadastro.funcionario
      SET idset=v_id_set_aux,
          situacao=v_situacao_aux,
          origem_gravacao = v_origem_gravacao,
          idpes_rev = v_idpes_rev,
          idsis_rev = v_idsis_rev,
          data_rev = CURRENT_TIMESTAMP,
            operacao = 'A'
      WHERE
          matricula=v_matricula_aux AND
          idins=v_id_ins_aux;
  END IF;

  RETURN 0;
END;$_$;


--
-- TOC entry 987 (class 1255 OID 9442912)
-- Name: fcn_update_juridica(integer, character varying, character varying, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_update_juridica(integer, character varying, character varying, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_cnpj ALIAS for $2;
  v_fantasia ALIAS for $3;
  v_inscr_estadual ALIAS for $4;
      v_origem_gravacao ALIAS for $5;
      v_idpes_rev ALIAS for $6;
      v_idsis_rev ALIAS for $7;

BEGIN
  -- Atualiza dados na tabela juridica
  UPDATE cadastro.juridica
    SET cnpj = to_number(v_cnpj,99999999999999),
        fantasia = public.fcn_upper(v_fantasia),
        insc_estadual = to_number(v_inscr_estadual,9999999999),
  origem_gravacao = v_origem_gravacao,
  idpes_rev = v_idpes_rev,
  idsis_rev = v_idsis_rev,
  data_rev = CURRENT_TIMESTAMP,
  operacao = 'A'
    WHERE idpes = v_id_pes;
  RETURN 0;
END;$_$;


--
-- TOC entry 988 (class 1255 OID 9442913)
-- Name: fcn_update_pessoa(integer, text, character varying, character varying, character varying, integer, character varying, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_update_pessoa(integer, text, character varying, character varying, character varying, integer, character varying, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_razao_social ALIAS for $2;
  v_url ALIAS for $3;
  v_email ALIAS for $4;
  v_situacao ALIAS for $5;
  v_id_pes_logado ALIAS for $6;
  v_origem_gravacao ALIAS for $7;
      v_idpes_rev ALIAS for $8;
      v_idsis_rev ALIAS for $9;

  idpes_logado integer;
BEGIN
  idpes_logado := v_id_pes_logado;
  IF (idpes_logado <= 0) THEN
    -- Atualiza dados na tabela pessoa
    UPDATE cadastro.pessoa SET
        nome = public.fcn_upper(v_razao_social),
        url = v_url,
        email = v_email,
        situacao = v_situacao,
        idpes_rev = NULL,
        data_rev = CURRENT_TIMESTAMP,
              origem_gravacao = v_origem_gravacao,
        idsis_rev = v_idsis_rev,
        operacao = 'A'
        WHERE idpes = v_id_pes;
  ELSE
    -- Atualiza dados na tabela pessoa
    UPDATE cadastro.pessoa SET
        nome = public.fcn_upper(v_razao_social),
        url = v_url,
        email = v_email,
        situacao = v_situacao,
        idpes_rev = idpes_logado,
        data_rev = CURRENT_TIMESTAMP,
              origem_gravacao = v_origem_gravacao,
        idsis_rev = v_idsis_rev,
        operacao = 'A'
        WHERE idpes = v_id_pes;
    END IF;
  RETURN 0;
END;$_$;


--
-- TOC entry 989 (class 1255 OID 9442914)
-- Name: fcn_upper(text); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_upper(text) RETURNS text
    LANGUAGE plpgsql
    AS $_$
   DECLARE
    v_texto     ALIAS FOR $1;
    v_retorno   text := '';
   BEGIN
    IF v_texto IS NOT NULL THEN
     SELECT translate(upper(v_texto),'áéíóúýàèìòùãõâêîôûäëïöüç','ÁÉÍÓÚÝÀÈÌÒÙÃÕÂÊÎÔÛÄËÏÖÜÇ') INTO v_retorno;
    END IF;
    RETURN v_retorno;
   END;
  $_$;


--
-- TOC entry 965 (class 1255 OID 9442915)
-- Name: fcn_upper_nrm(text); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.fcn_upper_nrm(text) RETURNS text
    LANGUAGE plpgsql
    AS $_$
   DECLARE
    v_texto     ALIAS FOR $1;
    v_retorno   text := '';
   BEGIN
    IF v_texto IS NOT NULL THEN
     SELECT translate(upper(v_texto),'áéíóúýàèìòùãõâêîôûäëïöüÿçÁÉÍÓÚÝÀÈÌÒÙÃÕÂÊÎÔÛÄËÏÖÜÇ','AEIOUYAEIOUAOAEIOUAEIOUYCAEIOUYAEIOUAOAEIOUAEIOUC') INTO v_retorno;
    END IF;
    RETURN v_retorno;
   END;
  $_$;


--
-- TOC entry 1007 (class 1255 OID 9442916)
-- Name: formata_cpf(numeric); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.formata_cpf(cpf numeric) RETURNS character varying
    LANGUAGE plpgsql
    AS $$
DECLARE
	cpf_formatado varchar := '';
BEGIN
  cpf_formatado := (SUBSTR(TO_CHAR(cpf, '00000000000'), 1, 4) || '.' ||
		    		SUBSTR(TO_CHAR(cpf, '00000000000'), 5, 3) || '.' ||
		    		SUBSTR(TO_CHAR(cpf, '00000000000'), 8, 3) || '-' ||
		    		SUBSTR(TO_CHAR(cpf, '00000000000'), 11, 2)) ;
  RETURN cpf_formatado;
END;
$$;


--
-- TOC entry 1008 (class 1255 OID 9442917)
-- Name: isnumeric(text); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.isnumeric(text) RETURNS boolean
    LANGUAGE plpgsql IMMUTABLE
    AS $_$
  DECLARE x NUMERIC;
    BEGIN
        x = $1::NUMERIC;
        RETURN TRUE;
    EXCEPTION WHEN others THEN
        RETURN FALSE;
    END;
  $_$;


--
-- TOC entry 1009 (class 1255 OID 9442918)
-- Name: retira_data_cancel_matricula_fun(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.retira_data_cancel_matricula_fun() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  BEGIN

  UPDATE pmieducar.matricula
  SET    data_cancel = NULL
  WHERE  cod_matricula = new.cod_matricula
  AND    data_cancel IS DISTINCT FROM NULL
  AND    aprovado = 3
  AND (SELECT 1 FROM pmieducar.transferencia_solicitacao WHERE ativo = 1 AND ref_cod_matricula_saida = new.cod_matricula limit 1) is null;

  RETURN NULL;
  END
  $$;


--
-- TOC entry 1010 (class 1255 OID 9442919)
-- Name: unifica_bairro(integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.unifica_bairro(p_idbai_duplicado integer, p_idbai_principal integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
cur_cep_log_bai RECORD;
begin

FOR cur_cep_log_bai IN (SELECT * FROM urbano.cep_logradouro_bairro clb WHERE clb.idbai = p_idbai_duplicado) LOOP

IF (SELECT 1 FROM urbano.cep_logradouro_bairro clb
      WHERE clb.idlog = cur_cep_log_bai.idlog
      AND clb.cep = cur_cep_log_bai.cep
      AND clb.idbai = p_idbai_principal
      LIMIT 1) IS NULL THEN

  INSERT INTO urbano.cep_logradouro_bairro (idlog, cep, idbai, origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad)
                             VALUES (cur_cep_log_bai.idlog, cur_cep_log_bai.cep, p_idbai_principal, 'U', 1, NOW(), 'I', 9);


END IF;
END LOOP;

UPDATE cadastro.endereco_pessoa SET idbai = p_idbai_principal WHERE idbai = p_idbai_duplicado;
DELETE FROM urbano.cep_logradouro_bairro WHERE idbai = p_idbai_duplicado;
DELETE FROM public.bairro WHERE idbai = p_idbai_duplicado;

end;$$;


--
-- TOC entry 1011 (class 1255 OID 9442920)
-- Name: unifica_logradouro(integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.unifica_logradouro(p_idlog_duplicado integer, p_idlog_principal integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
cur_cep_log RECORD;
begin

FOR cur_cep_log IN (SELECT * FROM urbano.cep_logradouro_bairro clb WHERE clb.idlog = p_idlog_duplicado) LOOP

IF (SELECT 1 FROM urbano.cep_logradouro cl
      WHERE cl.idlog = p_idlog_principal
      AND cl.cep = cur_cep_log.cep
      LIMIT 1) IS NULL THEN

  INSERT INTO urbano.cep_logradouro (idlog, cep, origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad)
                             VALUES (p_idlog_principal, cur_cep_log.cep, 'U', 1, NOW(), 'I', 9);


END IF;

IF (SELECT 1 FROM urbano.cep_logradouro_bairro clb
      WHERE clb.idlog = p_idlog_principal
      AND clb.cep = cur_cep_log.cep
      AND clb.idbai = cur_cep_log.idbai
      LIMIT 1) IS NULL THEN

  INSERT INTO urbano.cep_logradouro_bairro (idlog, cep, idbai, origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad)
                             VALUES (p_idlog_principal, cur_cep_log.cep, cur_cep_log.idbai, 'U', 1, NOW(), 'I', 9);


END IF;
END LOOP;

UPDATE cadastro.endereco_pessoa SET idlog = p_idlog_principal WHERE idlog = p_idlog_duplicado;
DELETE FROM urbano.cep_logradouro_bairro WHERE idlog = p_idlog_duplicado;
DELETE FROM urbano.cep_logradouro WHERE idlog = p_idlog_duplicado;
DELETE FROM public.logradouro WHERE idlog = p_idlog_duplicado;

end;$$;


--
-- TOC entry 990 (class 1255 OID 9469009)
-- Name: update_updated_at(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.update_updated_at() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
            BEGIN
                NEW.updated_at = now();
                RETURN NEW;
            END;
            $$;


--
-- TOC entry 1019 (class 1255 OID 9442921)
-- Name: verifica_existe_matricula_posterior_mesma_turma(integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.verifica_existe_matricula_posterior_mesma_turma(cod_matricula integer, cod_turma integer) RETURNS boolean
    LANGUAGE plpgsql
    AS $$
                      DECLARE existe_matricula boolean;

                      BEGIN
                        existe_matricula := EXISTS (SELECT *
                                                      FROM pmieducar.matricula_turma mt
                                                     INNER JOIN pmieducar.matricula m ON (m.cod_matricula = mt.ref_cod_matricula)
                                                     INNER JOIN pmieducar.matricula m2 ON (m2.cod_matricula = m.cod_matricula)
                                                     INNER JOIN pmieducar.matricula_turma mt2 ON (mt2.ref_cod_matricula = m.cod_matricula
                                                                                                  AND mt2.ref_cod_turma = cod_turma)
                                                     WHERE mt.ref_cod_turma = mt2.ref_cod_turma
                                                       AND mt.ref_cod_matricula <> mt2.ref_cod_matricula
                                                       AND m.ref_cod_aluno = m2.ref_cod_aluno
                                                       AND mt.data_enturmacao > mt2.data_enturmacao
                                                       AND m.ativo = 1
                                                       AND m2.ativo = 1);

                        RETURN existe_matricula;
                      END;
                      $$;


--
-- TOC entry 1020 (class 1255 OID 9442922)
-- Name: verifica_existe_matricula_posterior_mesma_turma(integer, integer, integer); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.verifica_existe_matricula_posterior_mesma_turma(cod_matricula integer, cod_turma integer, sequencial integer) RETURNS boolean
    LANGUAGE plpgsql
    AS $$

      DECLARE existe_matricula boolean;

      BEGIN
        existe_matricula := EXISTS (SELECT *
                                      FROM pmieducar.matricula_turma mt
                                     INNER JOIN pmieducar.matricula m ON (m.cod_matricula = mt.ref_cod_matricula)
                                     INNER JOIN pmieducar.matricula m2 ON (m2.cod_matricula = cod_matricula)
                                     INNER JOIN pmieducar.matricula_turma mt2 ON (mt2.ref_cod_matricula = cod_matricula
                                                                                  AND mt2.ref_cod_turma = cod_turma
                                                                                  AND mt2.sequencial = sequencial)
                                     WHERE mt.ref_cod_turma = mt2.ref_cod_turma
                                       AND mt.ref_cod_matricula <> mt2.ref_cod_matricula
                                       AND m.ref_cod_aluno = m2.ref_cod_aluno
                                       AND mt.data_enturmacao > mt2.data_enturmacao);

        RETURN existe_matricula;
      END;

      $$;


--
-- TOC entry 1023 (class 1255 OID 9468961)
-- Name: count_weekdays(date, date); Type: FUNCTION; Schema: relatorio; Owner: -
--

CREATE FUNCTION relatorio.count_weekdays(start_date date, end_date date) RETURNS integer
    LANGUAGE plpgsql
    AS $$
                        DECLARE
                          tmp_date date;
                          tmp_dow integer;
                          -- double precision returned from extract
                          tot_dow integer;
                        BEGIN
                          tmp_date := start_date;
                          tot_dow := 0;

                          WHILE (tmp_date <= end_date) LOOP
                            SELECT INTO tmp_dow cast(extract(dow
                              FROM tmp_date) AS integer);

                            IF ((tmp_dow >= 2) AND (tmp_dow <= 6)) THEN
                              tot_dow := (tot_dow + 1);
                            END IF;

                            SELECT INTO tmp_date (tmp_date + interval '1 DAY ');

                          END LOOP;

                          RETURN tot_dow;
                        END; $$;


--
-- TOC entry 1024 (class 1255 OID 9468962)
-- Name: formata_nome(text); Type: FUNCTION; Schema: relatorio; Owner: -
--

CREATE FUNCTION relatorio.formata_nome(var text) RETURNS text
    LANGUAGE sql
    AS $_$
                        SELECT array_to_string(array_agg(nomes),' ')
                          FROM(
                               SELECT CASE WHEN lower(x.id_unico[i]) = 'de' THEN lower(x.id_unico[i])
                                           WHEN lower(x.id_unico[i]) = 'dos' THEN lower(x.id_unico[i])
                                           WHEN lower(x.id_unico[i]) = 'da' THEN lower(x.id_unico[i])
                                           WHEN lower(x.id_unico[i]) = 'e' THEN lower(x.id_unico[i])
                                           ELSE upper(substring(x.id_unico[i],1,1)) || lower(substring(x.id_unico[i],2))
                                            END AS nomes
                                 FROM(
                                      SELECT *
                                        FROM string_to_array(cast($1 AS text),' ') AS id_unico) AS x,
            generate_series(1,array_upper(string_to_array(cast($1 as text),' '),1)) AS i) AS x;
                        $_$;


--
-- TOC entry 8144 (class 0 OID 0)
-- Dependencies: 1024
-- Name: FUNCTION formata_nome(var text); Type: COMMENT; Schema: relatorio; Owner: -
--

COMMENT ON FUNCTION relatorio.formata_nome(var text) IS 'Função que formata um nome, colocando iniciais em maiúsculas e demais em minúsculas';


--
-- TOC entry 1016 (class 1255 OID 9474520)
-- Name: get_nome_escola(integer); Type: FUNCTION; Schema: relatorio; Owner: -
--

CREATE FUNCTION relatorio.get_nome_escola(integer) RETURNS character varying
    LANGUAGE sql
    AS $_$SELECT COALESCE(
               (SELECT COALESCE (fcn_upper(ps.nome),fcn_upper(juridica.fantasia))
            FROM cadastro.pessoa ps, cadastro.juridica
           WHERE escola.ref_idpes = juridica.idpes
             AND juridica.idpes = ps.idpes
             AND ps.idpes = escola.ref_idpes),
               (SELECT nm_escola
            FROM pmieducar.escola_complemento
           WHERE ref_cod_escola = escola.cod_escola))
          FROM pmieducar.escola
         WHERE escola.cod_escola = $1;$_$;


--
-- TOC entry 1021 (class 1255 OID 9468959)
-- Name: get_texto_sem_caracter_especial(character varying); Type: FUNCTION; Schema: relatorio; Owner: -
--

CREATE FUNCTION relatorio.get_texto_sem_caracter_especial(character varying) RETURNS character varying
    LANGUAGE sql
    AS $_$SELECT translate(public.fcn_upper($1),
                       'åáàãâäéèêëíìîïóòõôöúùüûçÿýñÅÁÀÃÂÄÉÈÊËÍÌÎÏÓÒÕÔÖÚÙÛÜÇÝÑ',
                       'aaaaaaeeeeiiiiooooouuuucyynAAAAAAEEEEIIIIOOOOOUUUUCYN');$_$;


--
-- TOC entry 1022 (class 1255 OID 9468960)
-- Name: get_texto_sem_espaco(character varying); Type: FUNCTION; Schema: relatorio; Owner: -
--

CREATE FUNCTION relatorio.get_texto_sem_espaco(character varying) RETURNS character varying
    LANGUAGE sql
    AS $_$
SELECT translate(public.fcn_upper(regexp_replace($1,' ','','g')), 'åáàãâäéèêëíìîïóòõôöúùüûçÿýñÅÁÀÃÂÄÉÈÊËÍÌÎÏÓÒÕÔÖÚÙÛÜÇÝÑ', 'aaaaaaeeeeiiiiooooouuuucyynAAAAAAEEEEIIIIOOOOOUUUUCYN');$_$;


--
-- TOC entry 3050 (class 1255 OID 9442923)
-- Name: textcat_all(text); Type: AGGREGATE; Schema: public; Owner: -
--

CREATE AGGREGATE public.textcat_all(text) (
    SFUNC = public.commacat_ignore_nulls,
    STYPE = text,
    INITCOND = ''
);


--
-- TOC entry 204 (class 1259 OID 9442924)
-- Name: funcao_idfunc_seq; Type: SEQUENCE; Schema: acesso; Owner: -
--

CREATE SEQUENCE acesso.funcao_idfunc_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_tablespace = '';

SET default_with_oids = true;

--
-- TOC entry 205 (class 1259 OID 9442926)
-- Name: funcao; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.funcao (
    idfunc integer DEFAULT nextval('acesso.funcao_idfunc_seq'::regclass) NOT NULL,
    idsis integer NOT NULL,
    idmen integer NOT NULL,
    nome character varying(100) NOT NULL,
    situacao character(1) NOT NULL,
    url character varying(250) NOT NULL,
    ordem numeric(2,0) NOT NULL,
    descricao character varying(250) NOT NULL,
    CONSTRAINT ck_funcao_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


--
-- TOC entry 206 (class 1259 OID 9442934)
-- Name: grupo_idgrp_seq; Type: SEQUENCE; Schema: acesso; Owner: -
--

CREATE SEQUENCE acesso.grupo_idgrp_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 207 (class 1259 OID 9442936)
-- Name: grupo; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.grupo (
    idgrp integer DEFAULT nextval('acesso.grupo_idgrp_seq'::regclass) NOT NULL,
    nome character varying(40) NOT NULL,
    situacao character(1) NOT NULL,
    descricao character varying(250),
    CONSTRAINT ck_grupo_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


--
-- TOC entry 208 (class 1259 OID 9442941)
-- Name: grupo_funcao; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.grupo_funcao (
    idmen integer NOT NULL,
    idsis integer NOT NULL,
    idgrp integer NOT NULL,
    idfunc integer NOT NULL
);


--
-- TOC entry 209 (class 1259 OID 9442944)
-- Name: grupo_menu; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.grupo_menu (
    idgrp integer NOT NULL,
    idsis integer NOT NULL,
    idmen integer NOT NULL
);


--
-- TOC entry 210 (class 1259 OID 9442947)
-- Name: grupo_operacao; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.grupo_operacao (
    idfunc integer NOT NULL,
    idgrp integer NOT NULL,
    idsis integer NOT NULL,
    idmen integer NOT NULL,
    idope integer NOT NULL
);


--
-- TOC entry 211 (class 1259 OID 9442950)
-- Name: grupo_sistema; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.grupo_sistema (
    idsis integer NOT NULL,
    idgrp integer NOT NULL
);


--
-- TOC entry 212 (class 1259 OID 9442953)
-- Name: historico_senha; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.historico_senha (
    login character varying(16) NOT NULL,
    senha character varying(60) NOT NULL,
    data_cad timestamp without time zone NOT NULL
);


--
-- TOC entry 213 (class 1259 OID 9442956)
-- Name: instituicao_idins_seq; Type: SEQUENCE; Schema: acesso; Owner: -
--

CREATE SEQUENCE acesso.instituicao_idins_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 214 (class 1259 OID 9442958)
-- Name: instituicao; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.instituicao (
    idins integer DEFAULT nextval('acesso.instituicao_idins_seq'::regclass) NOT NULL,
    nome character varying(60) NOT NULL,
    situacao character(1) NOT NULL,
    CONSTRAINT ck_instituicao_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


--
-- TOC entry 215 (class 1259 OID 9442963)
-- Name: log_acesso; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.log_acesso (
    data timestamp without time zone NOT NULL,
    idpes numeric(8,0) NOT NULL,
    idsis integer,
    idins integer,
    idcli character varying(10),
    operacao character(1) NOT NULL,
    CONSTRAINT ck_log_acesso_situacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'O'::bpchar)))
);


--
-- TOC entry 216 (class 1259 OID 9442967)
-- Name: log_erro; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.log_erro (
    data timestamp without time zone NOT NULL,
    idpes numeric(8,0),
    idsis integer,
    idmen integer,
    idfunc integer,
    idope integer,
    msg_erro text NOT NULL
);


--
-- TOC entry 217 (class 1259 OID 9442973)
-- Name: menu_idmen_seq; Type: SEQUENCE; Schema: acesso; Owner: -
--

CREATE SEQUENCE acesso.menu_idmen_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 218 (class 1259 OID 9442975)
-- Name: menu; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.menu (
    idmen integer DEFAULT nextval('acesso.menu_idmen_seq'::regclass) NOT NULL,
    idsis integer NOT NULL,
    menu_idsis integer,
    menu_idmen integer,
    nome character varying(40) NOT NULL,
    descricao character varying(250) NOT NULL,
    situacao character(1) NOT NULL,
    ordem numeric(2,0) NOT NULL,
    CONSTRAINT ck_menu_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


--
-- TOC entry 219 (class 1259 OID 9442980)
-- Name: operacao_idope_seq; Type: SEQUENCE; Schema: acesso; Owner: -
--

CREATE SEQUENCE acesso.operacao_idope_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 220 (class 1259 OID 9442982)
-- Name: operacao; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.operacao (
    idope integer DEFAULT nextval('acesso.operacao_idope_seq'::regclass) NOT NULL,
    idsis integer,
    nome character varying(40) NOT NULL,
    situacao character(1) NOT NULL,
    descricao character varying(250) NOT NULL,
    CONSTRAINT ck_operacao_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


--
-- TOC entry 221 (class 1259 OID 9442987)
-- Name: operacao_funcao; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.operacao_funcao (
    idmen integer NOT NULL,
    idsis integer NOT NULL,
    idfunc integer NOT NULL,
    idope integer NOT NULL
);


--
-- TOC entry 222 (class 1259 OID 9442990)
-- Name: pessoa_instituicao; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.pessoa_instituicao (
    idins integer NOT NULL,
    idpes numeric(8,0) NOT NULL
);


--
-- TOC entry 223 (class 1259 OID 9442993)
-- Name: sistema_idsis_seq; Type: SEQUENCE; Schema: acesso; Owner: -
--

CREATE SEQUENCE acesso.sistema_idsis_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 224 (class 1259 OID 9442995)
-- Name: sistema; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.sistema (
    idsis integer DEFAULT nextval('acesso.sistema_idsis_seq'::regclass) NOT NULL,
    nome character varying(60) NOT NULL,
    descricao character varying(100) NOT NULL,
    contexto character varying(30) NOT NULL,
    situacao character(1) NOT NULL,
    CONSTRAINT ck_sistema_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


--
-- TOC entry 225 (class 1259 OID 9443000)
-- Name: usuario; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.usuario (
    login character varying(16) NOT NULL,
    idpes numeric(8,0) NOT NULL,
    idpes_sga numeric(8,0),
    senha character varying(60) NOT NULL,
    datacad date NOT NULL,
    lastlogin timestamp without time zone NOT NULL,
    dica character varying(60),
    situacao character(1) NOT NULL,
    data_alt_senha date NOT NULL,
    exp_senha character(1),
    mudar_senha character(1),
    num_sessao_atual numeric(2,0) NOT NULL,
    prazo_exp numeric(3,0),
    estilo_menu character(1),
    CONSTRAINT ck_usuario_estilo_menu CHECK (((estilo_menu = 'C'::bpchar) OR (estilo_menu = 'D'::bpchar))),
    CONSTRAINT ck_usuario_exp_senha CHECK (((exp_senha = 'S'::bpchar) OR (exp_senha = 'N'::bpchar))),
    CONSTRAINT ck_usuario_mudar_senha CHECK (((mudar_senha = 'S'::bpchar) OR (mudar_senha = 'N'::bpchar))),
    CONSTRAINT ck_usuario_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


--
-- TOC entry 226 (class 1259 OID 9443007)
-- Name: usuario_grupo; Type: TABLE; Schema: acesso; Owner: -
--

CREATE TABLE acesso.usuario_grupo (
    idgrp integer NOT NULL,
    login character varying(16) NOT NULL
);


--
-- TOC entry 227 (class 1259 OID 9443010)
-- Name: baixa_guia_produto_idbap_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.baixa_guia_produto_idbap_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 228 (class 1259 OID 9443012)
-- Name: baixa_guia_produto; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.baixa_guia_produto (
    idbap integer DEFAULT nextval('alimentos.baixa_guia_produto_idbap_seq'::regclass) NOT NULL,
    idgup integer NOT NULL,
    idbai integer NOT NULL,
    dt_validade date,
    qtde_recebida numeric NOT NULL,
    dt_operacao date NOT NULL,
    login_baixa character varying(80) NOT NULL
);


--
-- TOC entry 229 (class 1259 OID 9443019)
-- Name: baixa_guia_remessa_idbai_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.baixa_guia_remessa_idbai_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 230 (class 1259 OID 9443021)
-- Name: baixa_guia_remessa; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.baixa_guia_remessa (
    idbai integer DEFAULT nextval('alimentos.baixa_guia_remessa_idbai_seq'::regclass) NOT NULL,
    login_baixa character varying(80) NOT NULL,
    idgui integer NOT NULL,
    dt_recebimento date NOT NULL,
    nome_recebedor character varying(40) NOT NULL,
    cargo_recebedor character varying(40) NOT NULL,
    dt_operacao date NOT NULL
);


--
-- TOC entry 231 (class 1259 OID 9443025)
-- Name: calendario_idcad_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.calendario_idcad_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 232 (class 1259 OID 9443027)
-- Name: calendario; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.calendario (
    idcad integer DEFAULT nextval('alimentos.calendario_idcad_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    ano integer NOT NULL,
    descricao character varying(40) NOT NULL
);


--
-- TOC entry 233 (class 1259 OID 9443031)
-- Name: cardapio_idcar_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.cardapio_idcar_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 234 (class 1259 OID 9443033)
-- Name: cardapio; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.cardapio (
    idcar integer DEFAULT nextval('alimentos.cardapio_idcar_seq'::regclass) NOT NULL,
    login_inclusao character varying(80) NOT NULL,
    login_alteracao character varying(80),
    idcli character varying(10) NOT NULL,
    idtre integer NOT NULL,
    dt_cardapio date NOT NULL,
    dt_inclusao timestamp without time zone NOT NULL,
    dt_ultima_alteracao timestamp without time zone,
    valor numeric NOT NULL,
    finalizado character(1) NOT NULL,
    CONSTRAINT ck_cardapio_finalizado CHECK (((finalizado = 'S'::bpchar) OR (finalizado = 'N'::bpchar)))
);


--
-- TOC entry 235 (class 1259 OID 9443041)
-- Name: cardapio_faixa_unidade; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.cardapio_faixa_unidade (
    idfeu integer NOT NULL,
    idcar integer NOT NULL
);


--
-- TOC entry 236 (class 1259 OID 9443044)
-- Name: cardapio_produto_idcpr_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.cardapio_produto_idcpr_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 237 (class 1259 OID 9443046)
-- Name: cardapio_produto; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.cardapio_produto (
    idcpr integer DEFAULT nextval('alimentos.cardapio_produto_idcpr_seq'::regclass) NOT NULL,
    idpro integer NOT NULL,
    idcar integer NOT NULL,
    quantidade numeric NOT NULL,
    valor numeric NOT NULL
);


--
-- TOC entry 238 (class 1259 OID 9443053)
-- Name: cardapio_receita; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.cardapio_receita (
    idcar integer NOT NULL,
    idrec integer NOT NULL
);


--
-- TOC entry 239 (class 1259 OID 9443056)
-- Name: cliente; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.cliente (
    idcli character varying(10) NOT NULL,
    nome character varying(40) NOT NULL,
    cnpj character varying(14) NOT NULL,
    endereco character varying(60) NOT NULL,
    bairro character varying(30) NOT NULL,
    cidade character varying(18) NOT NULL,
    cep character varying(8),
    uf character varying(2) NOT NULL,
    telefone character varying(11) NOT NULL,
    fax character varying(11),
    email character varying(40),
    prefeito character varying(40) NOT NULL,
    educacao character varying(40) NOT NULL,
    administracao character varying(40) NOT NULL,
    coordenacao character varying(40) NOT NULL,
    inscritos character(1) NOT NULL,
    idpes integer NOT NULL,
    identificacao character varying(20) NOT NULL,
    tab_produtos character(1),
    CONSTRAINT ck_tab_produtos CHECK (((tab_produtos = '1'::bpchar) OR (tab_produtos = '2'::bpchar)))
);


--
-- TOC entry 240 (class 1259 OID 9443060)
-- Name: composto_quimico_idcom_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.composto_quimico_idcom_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 241 (class 1259 OID 9443062)
-- Name: composto_quimico; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.composto_quimico (
    idcom integer DEFAULT nextval('alimentos.composto_quimico_idcom_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    idgrpq integer NOT NULL,
    descricao character varying(50) NOT NULL,
    unidade character varying(5) NOT NULL
);


--
-- TOC entry 242 (class 1259 OID 9443066)
-- Name: contrato_idcon_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.contrato_idcon_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 243 (class 1259 OID 9443068)
-- Name: contrato; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.contrato (
    idcon integer DEFAULT nextval('alimentos.contrato_idcon_seq'::regclass) NOT NULL,
    codigo character varying(20) NOT NULL,
    idcli character varying(10) NOT NULL,
    login character varying(80) NOT NULL,
    num_aditivo integer NOT NULL,
    idfor integer NOT NULL,
    dt_vigencia date NOT NULL,
    tipo character(1) NOT NULL,
    vlr_atual numeric NOT NULL,
    cancelado character(1) NOT NULL,
    dt_cancelamento timestamp without time zone,
    dt_inclusao timestamp without time zone NOT NULL,
    ultimo_contrato character(1) NOT NULL,
    vlr_original numeric NOT NULL,
    finalizado character(1) NOT NULL,
    CONSTRAINT ck_contrato_cancelado CHECK (((cancelado = 'S'::bpchar) OR (cancelado = 'N'::bpchar))),
    CONSTRAINT ck_contrato_finalizado CHECK (((finalizado = 'S'::bpchar) OR (finalizado = 'N'::bpchar))),
    CONSTRAINT ck_contrato_tipo CHECK (((tipo = 'C'::bpchar) OR (tipo = 'A'::bpchar))),
    CONSTRAINT ck_contrato_ultimo_contrato CHECK (((ultimo_contrato = 'S'::bpchar) OR (ultimo_contrato = 'N'::bpchar)))
);


--
-- TOC entry 244 (class 1259 OID 9443079)
-- Name: contrato_produto_idcop_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.contrato_produto_idcop_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 245 (class 1259 OID 9443081)
-- Name: contrato_produto; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.contrato_produto (
    idcop integer DEFAULT nextval('alimentos.contrato_produto_idcop_seq'::regclass) NOT NULL,
    idcon integer NOT NULL,
    idpro integer NOT NULL,
    qtde_contratada numeric NOT NULL,
    vlr_unitario_atual numeric NOT NULL,
    qtde_remessa numeric NOT NULL,
    qtde_recebida numeric NOT NULL,
    qtde_aditivo numeric NOT NULL,
    vlr_unitario_original numeric NOT NULL,
    operacao character(1) NOT NULL,
    ajuste numeric,
    CONSTRAINT ck_contrato_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar) OR (operacao = 'N'::bpchar)))
);


--
-- TOC entry 246 (class 1259 OID 9443089)
-- Name: evento_ideve_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.evento_ideve_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 247 (class 1259 OID 9443091)
-- Name: evento; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.evento (
    ideve integer DEFAULT nextval('alimentos.evento_ideve_seq'::regclass) NOT NULL,
    idcad integer NOT NULL,
    mes integer NOT NULL,
    dia integer NOT NULL,
    dia_util character(1) NOT NULL,
    descricao character varying(50) NOT NULL,
    CONSTRAINT ck_evento_dia_util CHECK (((dia_util = 'S'::bpchar) OR (dia_util = 'N'::bpchar)))
);


--
-- TOC entry 248 (class 1259 OID 9443096)
-- Name: faixa_composto_quimico_idfcp_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.faixa_composto_quimico_idfcp_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 249 (class 1259 OID 9443098)
-- Name: faixa_composto_quimico; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.faixa_composto_quimico (
    idfcp integer DEFAULT nextval('alimentos.faixa_composto_quimico_idfcp_seq'::regclass) NOT NULL,
    idcom integer NOT NULL,
    idfae integer NOT NULL,
    quantidade numeric NOT NULL,
    qtde_max_min character(3) NOT NULL,
    CONSTRAINT ck_qtde_max_min CHECK (((qtde_max_min = 'MAX'::bpchar) OR (qtde_max_min = 'MIN'::bpchar)))
);


--
-- TOC entry 250 (class 1259 OID 9443106)
-- Name: faixa_etaria_idfae_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.faixa_etaria_idfae_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 251 (class 1259 OID 9443108)
-- Name: faixa_etaria; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.faixa_etaria (
    idfae integer DEFAULT nextval('alimentos.faixa_etaria_idfae_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    descricao character varying(50) NOT NULL,
    vlr_base_refeicao numeric NOT NULL
);


--
-- TOC entry 252 (class 1259 OID 9443115)
-- Name: fornecedor_idfor_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.fornecedor_idfor_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 253 (class 1259 OID 9443117)
-- Name: fornecedor; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.fornecedor (
    idfor integer DEFAULT nextval('alimentos.fornecedor_idfor_seq'::regclass) NOT NULL,
    idpes integer NOT NULL,
    idcli character varying(10) NOT NULL,
    razao_social character varying(50) NOT NULL,
    nome_fantasia character varying(50) NOT NULL,
    endereco character varying(40) NOT NULL,
    complemento character varying(30),
    bairro character varying(30) NOT NULL,
    cep character varying(8),
    cidade character varying(18) NOT NULL,
    uf character varying(2) NOT NULL,
    telefone character varying(11) NOT NULL,
    fax character varying(11),
    email character varying(40),
    contato character varying(40) NOT NULL,
    cpf_cnpj character varying(14) NOT NULL,
    inscr_estadual character varying(20),
    inscr_municipal character varying(20),
    tipo character(1) NOT NULL,
    CONSTRAINT ck_fornecedor CHECK (((tipo = 'F'::bpchar) OR (tipo = 'J'::bpchar)))
);


--
-- TOC entry 254 (class 1259 OID 9443122)
-- Name: fornecedor_unidade_atendida; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.fornecedor_unidade_atendida (
    iduni integer NOT NULL,
    idfor integer NOT NULL
);


--
-- TOC entry 255 (class 1259 OID 9443125)
-- Name: grupo_quimico_idgrpq_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.grupo_quimico_idgrpq_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 256 (class 1259 OID 9443127)
-- Name: grupo_quimico; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.grupo_quimico (
    idgrpq integer DEFAULT nextval('alimentos.grupo_quimico_idgrpq_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    descricao character varying(50) NOT NULL
);


--
-- TOC entry 257 (class 1259 OID 9443131)
-- Name: guia_produto_diario_idguiaprodiario_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.guia_produto_diario_idguiaprodiario_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 258 (class 1259 OID 9443133)
-- Name: guia_produto_diario; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.guia_produto_diario (
    idguiaprodiario integer DEFAULT nextval('alimentos.guia_produto_diario_idguiaprodiario_seq'::regclass) NOT NULL,
    idgui integer NOT NULL,
    idpro integer NOT NULL,
    iduni integer NOT NULL,
    dt_guia date NOT NULL,
    qtde numeric NOT NULL
);


--
-- TOC entry 259 (class 1259 OID 9443140)
-- Name: guia_remessa_idgui_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.guia_remessa_idgui_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 260 (class 1259 OID 9443142)
-- Name: guia_remessa; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.guia_remessa (
    idgui integer DEFAULT nextval('alimentos.guia_remessa_idgui_seq'::regclass) NOT NULL,
    idcon integer NOT NULL,
    login_cancelamento character varying(80),
    login_emissao character varying(80) NOT NULL,
    idfor integer NOT NULL,
    iduni integer NOT NULL,
    idcli character varying(10) NOT NULL,
    dt_emissao timestamp without time zone NOT NULL,
    ano integer NOT NULL,
    sequencial integer NOT NULL,
    dt_cardapio_inicial date NOT NULL,
    dt_cardapio_final date NOT NULL,
    num_inscr_matr integer NOT NULL,
    num_refeicao integer NOT NULL,
    situacao character(1) NOT NULL,
    dt_cancelamento timestamp without time zone,
    justificativa_cancelamento character varying(300),
    classe_produto character varying(2) NOT NULL,
    CONSTRAINT ck_guia_remessa_classe_produto CHECK ((((classe_produto)::text = 'P'::text) OR ((classe_produto)::text = 'N'::text) OR ((classe_produto)::text = 'PN'::text))),
    CONSTRAINT ck_guia_remessa_situacao CHECK (((situacao = 'E'::bpchar) OR (situacao = 'R'::bpchar) OR (situacao = 'C'::bpchar) OR (situacao = 'P'::bpchar)))
);


--
-- TOC entry 261 (class 1259 OID 9443148)
-- Name: guia_remessa_produto_idgup_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.guia_remessa_produto_idgup_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 262 (class 1259 OID 9443150)
-- Name: guia_remessa_produto; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.guia_remessa_produto (
    idgup integer DEFAULT nextval('alimentos.guia_remessa_produto_idgup_seq'::regclass) NOT NULL,
    idgui integer NOT NULL,
    idpro integer NOT NULL,
    qtde_per_capita numeric NOT NULL,
    qtde_guia numeric NOT NULL,
    peso numeric NOT NULL,
    qtde_recebida numeric NOT NULL,
    peso_total numeric NOT NULL
);


--
-- TOC entry 263 (class 1259 OID 9443157)
-- Name: log_guia_remessa_idlogguia_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.log_guia_remessa_idlogguia_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 264 (class 1259 OID 9443159)
-- Name: log_guia_remessa; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.log_guia_remessa (
    idlogguia integer DEFAULT nextval('alimentos.log_guia_remessa_idlogguia_seq'::regclass) NOT NULL,
    login character varying(80) NOT NULL,
    idcli character varying(10) NOT NULL,
    dt_inicial date NOT NULL,
    dt_final date NOT NULL,
    unidade character varying(80) NOT NULL,
    fornecedor character varying(80) NOT NULL,
    classe character(2),
    dt_geracao timestamp without time zone NOT NULL,
    mensagem text NOT NULL
);


--
-- TOC entry 265 (class 1259 OID 9443166)
-- Name: medidas_caseiras; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.medidas_caseiras (
    idmedcas character varying(20) NOT NULL,
    idcli character varying(10) NOT NULL,
    descricao character varying(50) NOT NULL
);


--
-- TOC entry 266 (class 1259 OID 9443169)
-- Name: pessoa_idpes_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.pessoa_idpes_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 267 (class 1259 OID 9443171)
-- Name: pessoa; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.pessoa (
    idpes integer DEFAULT nextval('alimentos.pessoa_idpes_seq'::regclass) NOT NULL,
    tipo character varying(1) NOT NULL,
    CONSTRAINT ck_pessoa CHECK ((((tipo)::text = 'C'::text) OR ((tipo)::text = 'F'::text) OR ((tipo)::text = 'U'::text)))
);


--
-- TOC entry 268 (class 1259 OID 9443176)
-- Name: produto_idpro_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.produto_idpro_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 269 (class 1259 OID 9443178)
-- Name: produto; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.produto (
    idpro integer DEFAULT nextval('alimentos.produto_idpro_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    idunp character varying(20) NOT NULL,
    idfnde character varying(15) NOT NULL,
    idtip integer NOT NULL,
    descricao character varying(60) NOT NULL,
    nome_compra character varying(60) NOT NULL,
    referencia_ceasa character varying(1) NOT NULL,
    fator_coccao numeric NOT NULL,
    fator_correcao numeric NOT NULL,
    vlr_unitario numeric NOT NULL,
    penultimo_vlr_unitario numeric,
    dt_ultima_compra timestamp without time zone,
    dt_penultima_compra timestamp without time zone,
    qtde_estoque numeric NOT NULL,
    classe character varying(1) NOT NULL,
    desc_composto character varying(300),
    idfor integer,
    CONSTRAINT ck_produto_classe CHECK ((((classe)::text = 'P'::text) OR ((classe)::text = 'N'::text))),
    CONSTRAINT ck_produto_referencia_ceasa CHECK ((((referencia_ceasa)::text = '1'::text) OR ((referencia_ceasa)::text = '0'::text)))
);


--
-- TOC entry 270 (class 1259 OID 9443187)
-- Name: produto_composto_quimico_idpcq_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.produto_composto_quimico_idpcq_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 271 (class 1259 OID 9443189)
-- Name: produto_composto_quimico; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.produto_composto_quimico (
    idpcq integer DEFAULT nextval('alimentos.produto_composto_quimico_idpcq_seq'::regclass) NOT NULL,
    idpro integer NOT NULL,
    idcom integer NOT NULL,
    quantidade numeric NOT NULL
);


--
-- TOC entry 272 (class 1259 OID 9443196)
-- Name: produto_fornecedor_idprf_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.produto_fornecedor_idprf_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 273 (class 1259 OID 9443198)
-- Name: produto_fornecedor; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.produto_fornecedor (
    idprf integer DEFAULT nextval('alimentos.produto_fornecedor_idprf_seq'::regclass) NOT NULL,
    idfor integer NOT NULL,
    idpro integer NOT NULL,
    codigo_ean character varying(18) NOT NULL
);


--
-- TOC entry 274 (class 1259 OID 9443202)
-- Name: produto_medida_caseira_idpmc_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.produto_medida_caseira_idpmc_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 275 (class 1259 OID 9443204)
-- Name: produto_medida_caseira; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.produto_medida_caseira (
    idpmc integer DEFAULT nextval('alimentos.produto_medida_caseira_idpmc_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    idmedcas character varying(20) NOT NULL,
    idpro integer NOT NULL,
    peso numeric NOT NULL
);


--
-- TOC entry 276 (class 1259 OID 9443211)
-- Name: receita_idrec_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.receita_idrec_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 277 (class 1259 OID 9443213)
-- Name: receita; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.receita (
    idrec integer DEFAULT nextval('alimentos.receita_idrec_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    valor numeric NOT NULL,
    descricao character varying(60) NOT NULL,
    modo_preparo text NOT NULL,
    rendimento integer NOT NULL,
    valor_percapita numeric NOT NULL
);


--
-- TOC entry 278 (class 1259 OID 9443220)
-- Name: receita_composto_quimico_idrcq_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.receita_composto_quimico_idrcq_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 279 (class 1259 OID 9443222)
-- Name: receita_composto_quimico; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.receita_composto_quimico (
    idrcq integer DEFAULT nextval('alimentos.receita_composto_quimico_idrcq_seq'::regclass) NOT NULL,
    idcom integer NOT NULL,
    idrec integer NOT NULL,
    quantidade numeric NOT NULL
);


--
-- TOC entry 280 (class 1259 OID 9443229)
-- Name: receita_produto_idrpr_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.receita_produto_idrpr_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 281 (class 1259 OID 9443231)
-- Name: receita_produto; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.receita_produto (
    idrpr integer DEFAULT nextval('alimentos.receita_produto_idrpr_seq'::regclass) NOT NULL,
    idpro integer NOT NULL,
    idrec integer NOT NULL,
    idmedcas character varying(20),
    quantidade numeric NOT NULL,
    valor numeric NOT NULL,
    qtdemedidacaseira integer NOT NULL,
    valor_percapita numeric NOT NULL
);


--
-- TOC entry 282 (class 1259 OID 9443238)
-- Name: tipo_produto_idtip_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.tipo_produto_idtip_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 283 (class 1259 OID 9443240)
-- Name: tipo_produto; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.tipo_produto (
    idtip integer DEFAULT nextval('alimentos.tipo_produto_idtip_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    descricao character varying(50) NOT NULL
);


--
-- TOC entry 284 (class 1259 OID 9443244)
-- Name: tipo_refeicao_idtre_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.tipo_refeicao_idtre_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 285 (class 1259 OID 9443246)
-- Name: tipo_refeicao; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.tipo_refeicao (
    idtre integer DEFAULT nextval('alimentos.tipo_refeicao_idtre_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    descricao character varying(30) NOT NULL
);


--
-- TOC entry 286 (class 1259 OID 9443250)
-- Name: tipo_unidade_idtip_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.tipo_unidade_idtip_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 287 (class 1259 OID 9443252)
-- Name: tipo_unidade; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.tipo_unidade (
    idtip integer DEFAULT nextval('alimentos.tipo_unidade_idtip_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    descricao character varying(50) NOT NULL
);


--
-- TOC entry 288 (class 1259 OID 9443256)
-- Name: unidade_atendida_iduni_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.unidade_atendida_iduni_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 289 (class 1259 OID 9443258)
-- Name: unidade_atendida; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.unidade_atendida (
    iduni integer DEFAULT nextval('alimentos.unidade_atendida_iduni_seq'::regclass) NOT NULL,
    idcad integer NOT NULL,
    idtip integer NOT NULL,
    codigo character varying(10) NOT NULL,
    idcli character varying(10) NOT NULL,
    nome character varying(40) NOT NULL,
    endereco character varying(60) NOT NULL,
    complemento character varying(30),
    bairro character varying(30) NOT NULL,
    cep character varying(8),
    telefone character varying(11) NOT NULL,
    fax character varying(11),
    email character varying(40),
    idpes integer NOT NULL,
    diretor character varying(40) NOT NULL
);


--
-- TOC entry 290 (class 1259 OID 9443262)
-- Name: unidade_faixa_etaria_idfeu_seq; Type: SEQUENCE; Schema: alimentos; Owner: -
--

CREATE SEQUENCE alimentos.unidade_faixa_etaria_idfeu_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 291 (class 1259 OID 9443264)
-- Name: unidade_faixa_etaria; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.unidade_faixa_etaria (
    idfeu integer DEFAULT nextval('alimentos.unidade_faixa_etaria_idfeu_seq'::regclass) NOT NULL,
    iduni integer NOT NULL,
    idfae integer NOT NULL,
    num_inscritos integer NOT NULL,
    num_matriculados integer NOT NULL
);


--
-- TOC entry 292 (class 1259 OID 9443268)
-- Name: unidade_produto; Type: TABLE; Schema: alimentos; Owner: -
--

CREATE TABLE alimentos.unidade_produto (
    idunp character varying(20) NOT NULL,
    idcli character varying(10) NOT NULL,
    descricao character varying(50) NOT NULL,
    peso numeric NOT NULL
);


--
-- TOC entry 293 (class 1259 OID 9443274)
-- Name: aviso_nome; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.aviso_nome (
    idpes numeric(8,0) NOT NULL,
    aviso numeric(1,0) NOT NULL,
    CONSTRAINT ck_aviso_nome_aviso CHECK (((aviso >= (1)::numeric) AND (aviso <= (4)::numeric)))
);


SET default_with_oids = false;

--
-- TOC entry 846 (class 1259 OID 9474351)
-- Name: codigo_cartorio_inep; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.codigo_cartorio_inep (
    id integer NOT NULL,
    id_cartorio integer NOT NULL,
    descricao character varying,
    cod_serventia integer,
    cod_municipio integer,
    ref_sigla_uf character varying(3)
);


--
-- TOC entry 845 (class 1259 OID 9474349)
-- Name: codigo_cartorio_inep_id_seq; Type: SEQUENCE; Schema: cadastro; Owner: -
--

CREATE SEQUENCE cadastro.codigo_cartorio_inep_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8145 (class 0 OID 0)
-- Dependencies: 845
-- Name: codigo_cartorio_inep_id_seq; Type: SEQUENCE OWNED BY; Schema: cadastro; Owner: -
--

ALTER SEQUENCE cadastro.codigo_cartorio_inep_id_seq OWNED BY cadastro.codigo_cartorio_inep.id;


--
-- TOC entry 294 (class 1259 OID 9443278)
-- Name: deficiencia_cod_deficiencia_seq; Type: SEQUENCE; Schema: cadastro; Owner: -
--

CREATE SEQUENCE cadastro.deficiencia_cod_deficiencia_seq
    START WITH 15
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 295 (class 1259 OID 9443280)
-- Name: deficiencia; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.deficiencia (
    cod_deficiencia integer DEFAULT nextval('cadastro.deficiencia_cod_deficiencia_seq'::regclass) NOT NULL,
    nm_deficiencia character varying(70) NOT NULL,
    deficiencia_educacenso smallint,
    desconsidera_regra_diferenciada boolean DEFAULT false
);


--
-- TOC entry 296 (class 1259 OID 9443284)
-- Name: documento; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.documento (
    idpes numeric(8,0) NOT NULL,
    rg character varying(25),
    data_exp_rg date,
    sigla_uf_exp_rg character(2),
    tipo_cert_civil numeric(2,0),
    num_termo numeric(8,0),
    num_livro character varying(8),
    num_folha numeric(4,0),
    data_emissao_cert_civil date,
    sigla_uf_cert_civil character(2),
    cartorio_cert_civil character varying(200),
    num_cart_trabalho numeric(9,0),
    serie_cart_trabalho numeric(5,0),
    data_emissao_cart_trabalho date,
    sigla_uf_cart_trabalho character(2),
    num_tit_eleitor numeric(13,0),
    zona_tit_eleitor numeric(4,0),
    secao_tit_eleitor numeric(4,0),
    idorg_exp_rg integer,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    certidao_nascimento character varying(50),
    cartorio_cert_civil_inep integer,
    certidao_casamento character varying(50),
    passaporte character varying(20),
    comprovante_residencia character varying(255),
    declaracao_trabalho_autonomo character varying,
    CONSTRAINT ck_documento_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_documento_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_documento_tipo_cert CHECK (((tipo_cert_civil >= (91)::numeric) AND (tipo_cert_civil <= (92)::numeric)))
);


--
-- TOC entry 297 (class 1259 OID 9443293)
-- Name: endereco_externo; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.endereco_externo (
    idpes numeric(8,0) NOT NULL,
    tipo numeric(1,0) NOT NULL,
    idtlog character varying(5) NOT NULL,
    logradouro character varying(150) NOT NULL,
    numero numeric(6,0),
    letra character(1),
    complemento character varying(20),
    bairro character varying(40),
    cep numeric(8,0),
    cidade character varying(60) NOT NULL,
    sigla_uf character(2) NOT NULL,
    reside_desde date,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    bloco character varying(20),
    andar numeric(2,0),
    apartamento numeric(6,0),
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    zona_localizacao integer DEFAULT 1,
    CONSTRAINT ck_endereco_externo_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_endereco_externo_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_endereco_externo_tipo CHECK (((tipo >= (1)::numeric) AND (tipo <= (3)::numeric)))
);


--
-- TOC entry 298 (class 1259 OID 9443303)
-- Name: endereco_pessoa; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.endereco_pessoa (
    idpes numeric(8,0) NOT NULL,
    tipo numeric(1,0) NOT NULL,
    cep numeric(8,0) NOT NULL,
    idlog numeric(6,0) NOT NULL,
    numero numeric(6,0),
    letra character(1),
    complemento character varying(50),
    reside_desde date,
    idbai numeric(6,0) NOT NULL,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    bloco character varying(20),
    andar numeric(2,0),
    apartamento numeric(6,0),
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    observacoes text,
    CONSTRAINT ck_endereco_pessoa_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_endereco_pessoa_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_endereco_pessoa_tipo CHECK (((tipo >= (1)::numeric) AND (tipo <= (3)::numeric)))
);


--
-- TOC entry 299 (class 1259 OID 9443312)
-- Name: escolaridade; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.escolaridade (
    idesco numeric(2,0) NOT NULL,
    descricao character varying(60) NOT NULL,
    escolaridade smallint
);


--
-- TOC entry 300 (class 1259 OID 9443315)
-- Name: estado_civil; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.estado_civil (
    ideciv numeric(1,0) NOT NULL,
    descricao character varying(15) NOT NULL
);


--
-- TOC entry 301 (class 1259 OID 9443318)
-- Name: fisica; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.fisica (
    idpes numeric(8,0) NOT NULL,
    data_nasc date,
    sexo character(1),
    idpes_mae numeric(8,0),
    idpes_pai numeric(8,0),
    idpes_responsavel numeric(8,0),
    idesco numeric(2,0),
    ideciv numeric(1,0),
    idpes_con numeric(8,0),
    data_uniao date,
    data_obito date,
    nacionalidade numeric(1,0),
    idpais_estrangeiro numeric(3,0),
    data_chegada_brasil date,
    idmun_nascimento numeric(6,0),
    ultima_empresa character varying(150),
    idocup numeric(6,0),
    nome_mae character varying(150),
    nome_pai character varying(150),
    nome_conjuge character varying(150),
    nome_responsavel character varying(150),
    justificativa_provisorio character varying(150),
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    ref_cod_sistema integer,
    cpf numeric(11,0),
    ref_cod_religiao integer,
    nis_pis_pasep numeric(11,0),
    sus character varying(20),
    ocupacao character varying(255),
    empresa character varying(255),
    pessoa_contato character varying(255),
    renda_mensal numeric(10,2),
    data_admissao date,
    ddd_telefone_empresa numeric(3,0),
    telefone_empresa numeric(11,0),
    falecido boolean,
    ativo integer DEFAULT 1,
    ref_usuario_exc integer,
    data_exclusao timestamp without time zone,
    zona_localizacao_censo integer,
    tipo_trabalho integer,
    local_trabalho character varying,
    horario_inicial_trabalho time without time zone,
    horario_final_trabalho time without time zone,
	nome_social varchar(150) NULL,
    CONSTRAINT ck_fisica_nacionalidade CHECK (((nacionalidade >= (1)::numeric) AND (nacionalidade <= (3)::numeric))),
    CONSTRAINT ck_fisica_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_fisica_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_fisica_sexo CHECK (((sexo = 'M'::bpchar) OR (sexo = 'F'::bpchar)))
);


--
-- TOC entry 302 (class 1259 OID 9443329)
-- Name: fisica_cpf; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.fisica_cpf (
    idpes numeric(8,0) NOT NULL,
    cpf numeric(11,0) NOT NULL,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_fisica_cpf_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_fisica_cpf_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


--
-- TOC entry 303 (class 1259 OID 9443337)
-- Name: fisica_deficiencia; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.fisica_deficiencia (
    ref_idpes integer NOT NULL,
    ref_cod_deficiencia integer NOT NULL
);


--
-- TOC entry 304 (class 1259 OID 9443340)
-- Name: fisica_foto; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.fisica_foto (
    idpes integer NOT NULL,
    caminho character varying(255)
);


--
-- TOC entry 305 (class 1259 OID 9443343)
-- Name: fisica_raca; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.fisica_raca (
    ref_idpes integer NOT NULL,
    ref_cod_raca integer NOT NULL
);


--
-- TOC entry 306 (class 1259 OID 9443346)
-- Name: fisica_sangue; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.fisica_sangue (
    idpes numeric(8,0) NOT NULL,
    grupo character(2) NOT NULL,
    rh smallint NOT NULL
);


--
-- TOC entry 307 (class 1259 OID 9443349)
-- Name: fone_pessoa; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.fone_pessoa (
    idpes numeric(8,0) NOT NULL,
    tipo numeric(1,0) NOT NULL,
    ddd numeric(3,0) NOT NULL,
    fone numeric(11,0) NOT NULL,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_fone_pessoa_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_fone_pessoa_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_fone_pessoa_tipo CHECK (((tipo >= (1)::numeric) AND (tipo <= (4)::numeric)))
);


--
-- TOC entry 308 (class 1259 OID 9443358)
-- Name: funcionario; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.funcionario (
    matricula numeric(8,0) NOT NULL,
    idins integer NOT NULL,
    idset integer,
    idpes numeric(8,0) NOT NULL,
    situacao character(1) NOT NULL,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_funcionario_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_funcionario_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_funcionario_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


--
-- TOC entry 309 (class 1259 OID 9443367)
-- Name: historico_cartao; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.historico_cartao (
    idpes_cidadao numeric(8,0) NOT NULL,
    data_hora timestamp without time zone NOT NULL,
    idpes_emitiu numeric(8,0) NOT NULL,
    tipo character(1) NOT NULL,
    CONSTRAINT ck_historico_cartao_tipo CHECK (((tipo = 'P'::bpchar) OR (tipo = 'D'::bpchar)))
);


--
-- TOC entry 310 (class 1259 OID 9443371)
-- Name: juridica; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.juridica (
    idpes numeric(8,0) NOT NULL,
    cnpj numeric(14,0) NOT NULL,
    insc_estadual numeric(20,0),
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    fantasia character varying(255),
    capital_social character varying(255),
    CONSTRAINT ck_juridica_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_juridica_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


--
-- TOC entry 311 (class 1259 OID 9443379)
-- Name: ocupacao; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.ocupacao (
    idocup numeric(6,0) NOT NULL,
    descricao character varying(250) NOT NULL
);


--
-- TOC entry 312 (class 1259 OID 9443382)
-- Name: orgao_emissor_rg_idorg_rg_seq; Type: SEQUENCE; Schema: cadastro; Owner: -
--

CREATE SEQUENCE cadastro.orgao_emissor_rg_idorg_rg_seq
    START WITH 30
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 313 (class 1259 OID 9443384)
-- Name: orgao_emissor_rg; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.orgao_emissor_rg (
    idorg_rg integer DEFAULT nextval('cadastro.orgao_emissor_rg_idorg_rg_seq'::regclass) NOT NULL,
    sigla character varying(20) NOT NULL,
    descricao character varying(60) NOT NULL,
    situacao character(1) NOT NULL,
    codigo_educacenso integer,
    CONSTRAINT ck_orgao_emissor_rg_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


--
-- TOC entry 314 (class 1259 OID 9443389)
-- Name: pessoa; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.pessoa (
    idpes numeric(8,0) DEFAULT nextval(('cadastro.seq_pessoa'::text)::regclass) NOT NULL,
    nome character varying(150) NOT NULL,
    idpes_cad numeric(8,0),
    data_cad timestamp without time zone NOT NULL,
    url character varying(60),
    tipo character(1) NOT NULL,
    idpes_rev numeric(8,0),
    data_rev timestamp without time zone,
    email character varying(100),
    situacao character(1) NOT NULL,
    origem_gravacao character(1) NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_pessoa_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_pessoa_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_pessoa_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar) OR (situacao = 'P'::bpchar))),
    CONSTRAINT ck_pessoa_tipo CHECK (((tipo = 'F'::bpchar) OR (tipo = 'J'::bpchar)))
);


--
-- TOC entry 315 (class 1259 OID 9443397)
-- Name: pessoa_fonetico; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.pessoa_fonetico (
    idpes numeric(8,0) NOT NULL,
    fonema character varying(30) NOT NULL
);


--
-- TOC entry 316 (class 1259 OID 9443400)
-- Name: raca_cod_raca_seq; Type: SEQUENCE; Schema: cadastro; Owner: -
--

CREATE SEQUENCE cadastro.raca_cod_raca_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 317 (class 1259 OID 9443402)
-- Name: raca; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.raca (
    cod_raca integer DEFAULT nextval('cadastro.raca_cod_raca_seq'::regclass) NOT NULL,
    idpes_exc integer,
    idpes_cad integer NOT NULL,
    nm_raca character varying(50) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo boolean DEFAULT false,
    raca_educacenso smallint
);


--
-- TOC entry 318 (class 1259 OID 9443407)
-- Name: religiao_cod_religiao_seq; Type: SEQUENCE; Schema: cadastro; Owner: -
--

CREATE SEQUENCE cadastro.religiao_cod_religiao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = false;

--
-- TOC entry 319 (class 1259 OID 9443409)
-- Name: religiao; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.religiao (
    cod_religiao integer DEFAULT nextval('cadastro.religiao_cod_religiao_seq'::regclass) NOT NULL,
    idpes_exc integer,
    idpes_cad integer NOT NULL,
    nm_religiao character varying(50) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo boolean DEFAULT false
);


--
-- TOC entry 320 (class 1259 OID 9443414)
-- Name: seq_pessoa; Type: SEQUENCE; Schema: cadastro; Owner: -
--

CREATE SEQUENCE cadastro.seq_pessoa
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 321 (class 1259 OID 9443416)
-- Name: socio; Type: TABLE; Schema: cadastro; Owner: -
--

CREATE TABLE cadastro.socio (
    idpes_juridica numeric(8,0) NOT NULL,
    idpes_fisica numeric(8,0) NOT NULL,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_socio_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_socio_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


--
-- TOC entry 322 (class 1259 OID 9443424)
-- Name: bairro; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.bairro (
    idmun numeric(6,0) NOT NULL,
    geom character varying,
    idbai numeric(6,0) DEFAULT nextval(('public.seq_bairro'::text)::regclass) NOT NULL,
    nome character varying(80) NOT NULL,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    zona_localizacao integer DEFAULT 1,
    iddis integer NOT NULL,
    idsetorbai numeric(6,0),
    CONSTRAINT ck_bairro_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_bairro_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


--
-- TOC entry 323 (class 1259 OID 9443434)
-- Name: logradouro; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.logradouro (
    idlog numeric(6,0) DEFAULT nextval(('public.seq_logradouro'::text)::regclass) NOT NULL,
    idtlog character varying(5) NOT NULL,
    nome character varying(150) NOT NULL,
    idmun numeric(6,0) NOT NULL,
    geom character varying,
    ident_oficial character(1),
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_logradouro_ident_oficial CHECK (((ident_oficial = 'S'::bpchar) OR (ident_oficial = 'N'::bpchar))),
    CONSTRAINT ck_logradouro_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_logradouro_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


--
-- TOC entry 324 (class 1259 OID 9443444)
-- Name: municipio; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.municipio (
    idmun numeric(6,0) DEFAULT nextval(('public.seq_municipio'::text)::regclass) NOT NULL,
    nome character varying(60) NOT NULL,
    sigla_uf character varying(3) NOT NULL,
    area_km2 numeric(6,0),
    idmreg numeric(2,0),
    idasmun numeric(2,0),
    cod_ibge numeric(20,0),
    geom character varying,
    tipo character(1) NOT NULL,
    idmun_pai numeric(6,0),
    idpes_rev numeric,
    idpes_cad numeric,
    data_rev timestamp without time zone,
    data_cad timestamp without time zone NOT NULL,
    origem_gravacao character(1) NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_municipio_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_municipio_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_municipio_tipo CHECK (((tipo = 'D'::bpchar) OR (tipo = 'M'::bpchar) OR (tipo = 'P'::bpchar) OR (tipo = 'R'::bpchar)))
);


--
-- TOC entry 325 (class 1259 OID 9443454)
-- Name: v_endereco; Type: VIEW; Schema: cadastro; Owner: -
--

CREATE VIEW cadastro.v_endereco AS
 SELECT e.idpes,
    e.cep,
    e.idlog,
    e.numero,
    e.letra,
    e.complemento,
    e.idbai,
    e.bloco,
    e.andar,
    e.apartamento,
    l.nome AS logradouro,
    l.idtlog,
    b.nome AS bairro,
    m.nome AS cidade,
    m.sigla_uf,
    b.zona_localizacao
   FROM cadastro.endereco_pessoa e,
    public.logradouro l,
    public.bairro b,
    public.municipio m
  WHERE ((e.idlog = l.idlog) AND (e.idbai = b.idbai) AND (b.idmun = m.idmun) AND (e.tipo = (1)::numeric))
UNION
 SELECT e.idpes,
    e.cep,
    NULL::numeric AS idlog,
    e.numero,
    e.letra,
    e.complemento,
    NULL::numeric AS idbai,
    e.bloco,
    e.andar,
    e.apartamento,
    e.logradouro,
    e.idtlog,
    e.bairro,
    e.cidade,
    e.sigla_uf,
    e.zona_localizacao
   FROM cadastro.endereco_externo e
  WHERE (e.tipo = (1)::numeric);


--
-- TOC entry 326 (class 1259 OID 9443459)
-- Name: v_fone_pessoa; Type: VIEW; Schema: cadastro; Owner: -
--

CREATE VIEW cadastro.v_fone_pessoa AS
 SELECT DISTINCT t.idpes,
    ( SELECT t1.ddd
           FROM cadastro.fone_pessoa t1
          WHERE ((t1.tipo = (1)::numeric) AND (t.idpes = t1.idpes))) AS ddd_1,
    ( SELECT t1.fone
           FROM cadastro.fone_pessoa t1
          WHERE ((t1.tipo = (1)::numeric) AND (t.idpes = t1.idpes))) AS fone_1,
    ( SELECT t1.ddd
           FROM cadastro.fone_pessoa t1
          WHERE ((t1.tipo = (2)::numeric) AND (t.idpes = t1.idpes))) AS ddd_2,
    ( SELECT t1.fone
           FROM cadastro.fone_pessoa t1
          WHERE ((t1.tipo = (2)::numeric) AND (t.idpes = t1.idpes))) AS fone_2,
    ( SELECT t1.ddd
           FROM cadastro.fone_pessoa t1
          WHERE ((t1.tipo = (3)::numeric) AND (t.idpes = t1.idpes))) AS ddd_mov,
    ( SELECT t1.fone
           FROM cadastro.fone_pessoa t1
          WHERE ((t1.tipo = (3)::numeric) AND (t.idpes = t1.idpes))) AS fone_mov,
    ( SELECT t1.ddd
           FROM cadastro.fone_pessoa t1
          WHERE ((t1.tipo = (4)::numeric) AND (t.idpes = t1.idpes))) AS ddd_fax,
    ( SELECT t1.fone
           FROM cadastro.fone_pessoa t1
          WHERE ((t1.tipo = (4)::numeric) AND (t.idpes = t1.idpes))) AS fone_fax
   FROM cadastro.fone_pessoa t
  ORDER BY t.idpes, ( SELECT t1.ddd
           FROM cadastro.fone_pessoa t1
          WHERE ((t1.tipo = (1)::numeric) AND (t.idpes = t1.idpes))), ( SELECT t1.fone
           FROM cadastro.fone_pessoa t1
          WHERE ((t1.tipo = (1)::numeric) AND (t.idpes = t1.idpes))), ( SELECT t1.ddd
           FROM cadastro.fone_pessoa t1
          WHERE ((t1.tipo = (2)::numeric) AND (t.idpes = t1.idpes))), ( SELECT t1.fone
           FROM cadastro.fone_pessoa t1
          WHERE ((t1.tipo = (2)::numeric) AND (t.idpes = t1.idpes))), ( SELECT t1.ddd
           FROM cadastro.fone_pessoa t1
          WHERE ((t1.tipo = (3)::numeric) AND (t.idpes = t1.idpes))), ( SELECT t1.fone
           FROM cadastro.fone_pessoa t1
          WHERE ((t1.tipo = (3)::numeric) AND (t.idpes = t1.idpes))), ( SELECT t1.ddd
           FROM cadastro.fone_pessoa t1
          WHERE ((t1.tipo = (4)::numeric) AND (t.idpes = t1.idpes))), ( SELECT t1.fone
           FROM cadastro.fone_pessoa t1
          WHERE ((t1.tipo = (4)::numeric) AND (t.idpes = t1.idpes)));


--
-- TOC entry 327 (class 1259 OID 9443464)
-- Name: v_pessoa_fisica; Type: VIEW; Schema: cadastro; Owner: -
--

CREATE OR REPLACE VIEW cadastro.v_pessoa_fisica AS
SELECT
    p.idpes,
    p.nome,
    p.url,
    p.email,
    p.situacao,
    f.nome_social,
    f.data_nasc,
    f.sexo,
    f.cpf,
    f.ref_cod_sistema,
    f.idesco,
    f.ativo
FROM cadastro.pessoa p
INNER JOIN cadastro.fisica f ON TRUE
AND f.idpes = p.idpes;


--
-- TOC entry 328 (class 1259 OID 9443468)
-- Name: v_pessoa_fisica_simples; Type: VIEW; Schema: cadastro; Owner: -
--

CREATE VIEW cadastro.v_pessoa_fisica_simples AS
 SELECT p.idpes,
    ( SELECT fisica_cpf.cpf
           FROM cadastro.fisica_cpf
          WHERE (fisica_cpf.idpes = p.idpes)) AS cpf,
    f.ref_cod_sistema,
    f.idesco
   FROM cadastro.pessoa p,
    cadastro.fisica f
  WHERE (p.idpes = f.idpes);


--
-- TOC entry 329 (class 1259 OID 9443472)
-- Name: v_pessoa_fj; Type: VIEW; Schema: cadastro; Owner: -
--

CREATE VIEW cadastro.v_pessoa_fj AS
 SELECT p.idpes,
    p.nome,
    ( SELECT fisica.ref_cod_sistema
           FROM cadastro.fisica
          WHERE (fisica.idpes = p.idpes)) AS ref_cod_sistema,
    ( SELECT juridica.fantasia
           FROM cadastro.juridica
          WHERE (juridica.idpes = p.idpes)) AS fantasia,
    p.tipo,
    COALESCE(( SELECT fisica.cpf
           FROM cadastro.fisica
          WHERE (fisica.idpes = p.idpes)), ( SELECT juridica.cnpj
           FROM cadastro.juridica
          WHERE (juridica.idpes = p.idpes))) AS id_federal
   FROM cadastro.pessoa p;


--
-- TOC entry 330 (class 1259 OID 9443477)
-- Name: v_pessoa_juridica; Type: VIEW; Schema: cadastro; Owner: -
--

CREATE VIEW cadastro.v_pessoa_juridica AS
 SELECT j.idpes,
    j.fantasia,
    j.cnpj,
    j.insc_estadual,
    j.capital_social,
    ( SELECT pessoa.nome
           FROM cadastro.pessoa
          WHERE (pessoa.idpes = j.idpes)) AS nome
   FROM cadastro.juridica j;


--
-- TOC entry 331 (class 1259 OID 9443481)
-- Name: v_pessoafj_count; Type: VIEW; Schema: cadastro; Owner: -
--

CREATE VIEW cadastro.v_pessoafj_count AS
 SELECT fisica.ref_cod_sistema,
    fisica.cpf AS id_federal
   FROM cadastro.fisica
UNION ALL
 SELECT NULL::integer AS ref_cod_sistema,
    juridica.cnpj AS id_federal
   FROM cadastro.juridica;


--
-- TOC entry 332 (class 1259 OID 9443485)
-- Name: campo_consistenciacao; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.campo_consistenciacao (
    idcam numeric(3,0) NOT NULL,
    campo character varying(50) NOT NULL,
    permite_regra_cadastrada character(1) NOT NULL,
    tamanho_maximo numeric(4,0),
    CONSTRAINT ck_campo_consistenciacao_permite_regra CHECK (((permite_regra_cadastrada = 'S'::bpchar) OR (permite_regra_cadastrada = 'N'::bpchar)))
);


--
-- TOC entry 333 (class 1259 OID 9443489)
-- Name: campo_metadado_id_campo_met_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: -
--

CREATE SEQUENCE consistenciacao.campo_metadado_id_campo_met_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 334 (class 1259 OID 9443491)
-- Name: campo_metadado; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.campo_metadado (
    id_campo_met integer DEFAULT nextval('consistenciacao.campo_metadado_id_campo_met_seq'::regclass) NOT NULL,
    idmet integer NOT NULL,
    idreg integer,
    idcam numeric(3,0),
    posicao_inicial numeric(5,0),
    posicao_final numeric(5,0),
    posicao_coluna numeric(5,0),
    credibilidade numeric(1,0) NOT NULL,
    data_atualizacao character(1) NOT NULL,
    CONSTRAINT ck_cam_met_campo_cred CHECK (((credibilidade >= (2)::numeric) AND (credibilidade <= (4)::numeric))),
    CONSTRAINT ck_cam_met_data_atualizacao CHECK (((data_atualizacao = 'S'::bpchar) OR (data_atualizacao = 'N'::bpchar)))
);


--
-- TOC entry 335 (class 1259 OID 9443497)
-- Name: confrontacao_idcon_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: -
--

CREATE SEQUENCE consistenciacao.confrontacao_idcon_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 336 (class 1259 OID 9443499)
-- Name: confrontacao; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.confrontacao (
    idcon integer DEFAULT nextval('consistenciacao.confrontacao_idcon_seq'::regclass) NOT NULL,
    idins integer NOT NULL,
    idpes integer NOT NULL,
    idmet integer NOT NULL,
    arquivo_fonte_dados character varying(250) NOT NULL,
    ignorar_reg_fonte date,
    desconsiderar_reg_cred_maxima date,
    data_hora timestamp without time zone NOT NULL
);


--
-- TOC entry 337 (class 1259 OID 9443503)
-- Name: fonte_idfon_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: -
--

CREATE SEQUENCE consistenciacao.fonte_idfon_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 338 (class 1259 OID 9443505)
-- Name: fonte; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.fonte (
    idfon integer DEFAULT nextval('consistenciacao.fonte_idfon_seq'::regclass) NOT NULL,
    nome character varying(60) NOT NULL,
    situacao character(1) NOT NULL,
    CONSTRAINT ck_fonte_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


--
-- TOC entry 339 (class 1259 OID 9443510)
-- Name: historico_campo; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.historico_campo (
    idpes numeric(8,0) NOT NULL,
    idcam numeric(3,0) NOT NULL,
    credibilidade numeric(1,0) NOT NULL,
    data_hora timestamp without time zone NOT NULL,
    CONSTRAINT ck_historico_campo_cred CHECK (((credibilidade >= (1)::numeric) AND (credibilidade <= (5)::numeric)))
);


--
-- TOC entry 340 (class 1259 OID 9443514)
-- Name: incoerencia_idinc_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: -
--

CREATE SEQUENCE consistenciacao.incoerencia_idinc_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 341 (class 1259 OID 9443516)
-- Name: incoerencia; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.incoerencia (
    idinc integer DEFAULT nextval('consistenciacao.incoerencia_idinc_seq'::regclass) NOT NULL,
    idcon integer NOT NULL,
    data_gravacao date NOT NULL,
    ultima_etapa numeric(1,0) NOT NULL,
    cpf_cnpj numeric(14,0),
    nome character varying(150),
    email character varying(100),
    url character varying(60),
    data_nasc character varying(20),
    fantasia character varying(50),
    insc_estadual numeric(10,0),
    sexo character varying(10),
    nome_mae character varying(150),
    nome_pai character varying(150),
    nome_responsavel character varying(150),
    nome_conjuge character varying(150),
    ultima_empresa character varying(150),
    ocupacao character varying(250),
    escolaridade character varying(60),
    estado_civil character varying(15),
    pais_estrangeiro character varying(60),
    data_chegada_brasil character varying(20),
    data_obito character varying(20),
    data_uniao character varying(20)
);


--
-- TOC entry 342 (class 1259 OID 9443523)
-- Name: incoerencia_documento_id_inc_doc_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: -
--

CREATE SEQUENCE consistenciacao.incoerencia_documento_id_inc_doc_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 343 (class 1259 OID 9443525)
-- Name: incoerencia_documento; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.incoerencia_documento (
    id_inc_doc integer DEFAULT nextval('consistenciacao.incoerencia_documento_id_inc_doc_seq'::regclass) NOT NULL,
    idinc integer NOT NULL,
    rg numeric(10,0),
    orgao_exp_rg character varying(20),
    data_exp_rg character varying(20),
    sigla_uf_rg_exp character varying(30),
    tipo_cert_civil numeric(2,0),
    num_termo numeric(8,0),
    num_livro numeric(8,0),
    num_folha numeric(4,0),
    data_emissao_cert_civil character varying(20),
    cartorio_cert_civil character varying(150),
    sigla_uf_cert_civil character varying(30),
    num_cart_trabalho numeric(7,0),
    serie_cart_trabalho numeric(5,0),
    data_emissao_cart_trabalho character varying(20),
    sigla_uf_cart_trabalho character varying(30),
    num_tit_eleitor numeric(13,0),
    zona_tit_eleitor numeric(4,0),
    secao_tit_eleitor numeric(4,0)
);


--
-- TOC entry 344 (class 1259 OID 9443529)
-- Name: incoerencia_endereco_id_inc_end_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: -
--

CREATE SEQUENCE consistenciacao.incoerencia_endereco_id_inc_end_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 345 (class 1259 OID 9443531)
-- Name: incoerencia_endereco; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.incoerencia_endereco (
    id_inc_end integer DEFAULT nextval('consistenciacao.incoerencia_endereco_id_inc_end_seq'::regclass) NOT NULL,
    idinc integer NOT NULL,
    tipo character varying(60) NOT NULL,
    tipo_logradouro character varying(15),
    logradouro character varying(150),
    numero numeric(6,0),
    letra character(1),
    complemento character varying(20),
    bairro character varying(40),
    cep numeric(8,0),
    cidade character varying(60),
    uf character varying(30),
    CONSTRAINT ck_incoerencia_endereco_tipo CHECK ((((tipo)::text >= ((1)::numeric)::text) AND ((tipo)::text <= ((3)::numeric)::text)))
);


--
-- TOC entry 346 (class 1259 OID 9443536)
-- Name: incoerencia_fone_id_inc_fone_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: -
--

CREATE SEQUENCE consistenciacao.incoerencia_fone_id_inc_fone_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 347 (class 1259 OID 9443538)
-- Name: incoerencia_fone; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.incoerencia_fone (
    id_inc_fone integer DEFAULT nextval('consistenciacao.incoerencia_fone_id_inc_fone_seq'::regclass) NOT NULL,
    idinc integer NOT NULL,
    tipo character varying(60) NOT NULL,
    ddd numeric(3,0),
    fone numeric(8,0),
    CONSTRAINT ck_incoerencia_fone_tipo CHECK ((((tipo)::text >= ((1)::numeric)::text) AND ((tipo)::text <= ((4)::numeric)::text)))
);


--
-- TOC entry 348 (class 1259 OID 9443543)
-- Name: incoerencia_pessoa_possivel; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.incoerencia_pessoa_possivel (
    idinc integer NOT NULL,
    idpes numeric(8,0) NOT NULL
);


--
-- TOC entry 349 (class 1259 OID 9443546)
-- Name: incoerencia_tipo_incoerencia; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.incoerencia_tipo_incoerencia (
    id_tipo_inc numeric(3,0) NOT NULL,
    idinc integer NOT NULL
);


--
-- TOC entry 350 (class 1259 OID 9443549)
-- Name: metadado_idmet_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: -
--

CREATE SEQUENCE consistenciacao.metadado_idmet_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 351 (class 1259 OID 9443551)
-- Name: metadado; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.metadado (
    idmet integer DEFAULT nextval('consistenciacao.metadado_idmet_seq'::regclass) NOT NULL,
    idfon integer NOT NULL,
    nome character varying(60) NOT NULL,
    situacao character(1) NOT NULL,
    separador character(1),
    CONSTRAINT ck_metadado_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


--
-- TOC entry 352 (class 1259 OID 9443556)
-- Name: ocorrencia_regra_campo; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.ocorrencia_regra_campo (
    idreg integer NOT NULL,
    conteudo_padrao character varying(60) NOT NULL,
    ocorrencias text NOT NULL
);


--
-- TOC entry 353 (class 1259 OID 9443562)
-- Name: regra_campo_idreg_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: -
--

CREATE SEQUENCE consistenciacao.regra_campo_idreg_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 354 (class 1259 OID 9443564)
-- Name: regra_campo; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.regra_campo (
    idreg integer DEFAULT nextval('consistenciacao.regra_campo_idreg_seq'::regclass) NOT NULL,
    nome character varying(60) NOT NULL,
    tipo character(1) NOT NULL,
    CONSTRAINT ck_regra_campo_tipo CHECK (((tipo = 'S'::bpchar) OR (tipo = 'N'::bpchar)))
);


--
-- TOC entry 355 (class 1259 OID 9443569)
-- Name: temp_cadastro_unificacao_cmf; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.temp_cadastro_unificacao_cmf (
    idpes numeric(8,0) NOT NULL,
    nome character varying(150) NOT NULL,
    cpf_cnpj character varying(14),
    rg character varying(10),
    uf_rg character varying(50),
    data_nascimento character varying(10),
    logradouro character varying(150),
    cep character varying(10),
    bairro character varying(40),
    numero character varying(6),
    cidade_end character varying(60),
    uf_end character varying(2),
    complemento character varying(20),
    fone character varying(14),
    nome_mae character varying(150),
    nome_mae_idpes character varying(150),
    data_cadastro character varying(10),
    data_atualizacao character varying(10),
    situacao character varying(15),
    tipo_pess character varying(1),
    nome_fantasia character varying(50),
    inscr_estadual character varying(10)
);


--
-- TOC entry 356 (class 1259 OID 9443575)
-- Name: temp_cadastro_unificacao_siam; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.temp_cadastro_unificacao_siam (
    idpes numeric(8,0) NOT NULL,
    nome character varying(40) NOT NULL,
    cpf_cnpj character varying(14),
    rg character varying(15),
    logradouro character varying(40),
    cep character varying(10),
    bairro character varying(20),
    cidade_end character varying(20),
    uf_end character varying(2),
    fone character varying(14),
    data_cadastro character varying(10)
);


--
-- TOC entry 357 (class 1259 OID 9443578)
-- Name: tipo_incoerencia; Type: TABLE; Schema: consistenciacao; Owner: -
--

CREATE TABLE consistenciacao.tipo_incoerencia (
    id_tipo_inc numeric(3,0) NOT NULL,
    idcam numeric(3,0) NOT NULL,
    descricao character varying(250) NOT NULL
);


--
-- TOC entry 358 (class 1259 OID 9443581)
-- Name: bairro; Type: TABLE; Schema: historico; Owner: -
--

CREATE TABLE historico.bairro (
    idbai numeric(6,0) NOT NULL,
    idmun numeric(6,0) NOT NULL,
    nome character varying(80) NOT NULL,
    geom character varying,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_bairro_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_bairro_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


--
-- TOC entry 359 (class 1259 OID 9443589)
-- Name: cep_logradouro; Type: TABLE; Schema: historico; Owner: -
--

CREATE TABLE historico.cep_logradouro (
    cep numeric(8,0) NOT NULL,
    idlog numeric(6,0) NOT NULL,
    nroini numeric(6,0),
    nrofin numeric(6,0),
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_cep_logradouro_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_cep_logradouro_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


--
-- TOC entry 360 (class 1259 OID 9443597)
-- Name: cep_logradouro_bairro; Type: TABLE; Schema: historico; Owner: -
--

CREATE TABLE historico.cep_logradouro_bairro (
    idbai numeric(6,0) NOT NULL,
    idlog numeric(6,0) NOT NULL,
    cep numeric(8,0) NOT NULL,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_cep_logradouro_bairro_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_cep_logradouro_bairro_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


--
-- TOC entry 361 (class 1259 OID 9443605)
-- Name: documento; Type: TABLE; Schema: historico; Owner: -
--

CREATE TABLE historico.documento (
    idpes numeric(8,0) NOT NULL,
    rg character varying(25),
    data_exp_rg date,
    sigla_uf_exp_rg character(2),
    tipo_cert_civil numeric(2,0),
    num_termo numeric(8,0),
    num_livro character varying(8),
    num_folha numeric(4,0),
    data_emissao_cert_civil date,
    sigla_uf_cert_civil character(2),
    cartorio_cert_civil character varying(150),
    num_cart_trabalho numeric(7,0),
    serie_cart_trabalho numeric(5,0),
    data_emissao_cart_trabalho date,
    sigla_uf_cart_trabalho character(2),
    num_tit_eleitor numeric(13,0),
    zona_tit_eleitor numeric(4,0),
    secao_tit_eleitor numeric(4,0),
    idorg_exp_rg integer,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_documento_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_documento_tipo_cert CHECK (((tipo_cert_civil >= (91)::numeric) AND (tipo_cert_civil <= (92)::numeric))),
    CONSTRAINT ck_fone_pessoa_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


--
-- TOC entry 362 (class 1259 OID 9443614)
-- Name: endereco_externo; Type: TABLE; Schema: historico; Owner: -
--

CREATE TABLE historico.endereco_externo (
    idpes numeric(8,0) NOT NULL,
    tipo numeric(1,0) NOT NULL,
    idtlog character varying(5) NOT NULL,
    logradouro character varying(150) NOT NULL,
    numero numeric(6,0),
    letra character(1),
    complemento character varying(20),
    bairro character varying(40),
    cep numeric(8,0),
    cidade character varying(60) NOT NULL,
    sigla_uf character(2) NOT NULL,
    reside_desde date,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_endereco_externo_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_endereco_externo_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_endereco_externo_tipo CHECK (((tipo >= (1)::numeric) AND (tipo <= (3)::numeric)))
);


--
-- TOC entry 363 (class 1259 OID 9443623)
-- Name: endereco_pessoa; Type: TABLE; Schema: historico; Owner: -
--

CREATE TABLE historico.endereco_pessoa (
    idpes numeric(8,0) NOT NULL,
    tipo numeric(1,0) NOT NULL,
    cep numeric(8,0) NOT NULL,
    idlog numeric(6,0) NOT NULL,
    idbai numeric(6,0) NOT NULL,
    numero numeric(6,0),
    letra character(1),
    complemento character varying(50),
    reside_desde date,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_endereco_pessoa_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_endereco_pessoa_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_endereco_pessoa_tipo CHECK (((tipo >= (1)::numeric) AND (tipo <= (3)::numeric)))
);


--
-- TOC entry 364 (class 1259 OID 9443632)
-- Name: fisica; Type: TABLE; Schema: historico; Owner: -
--

CREATE TABLE historico.fisica (
    idpes numeric(8,0) NOT NULL,
    data_nasc date,
    sexo character(1),
    idpes_mae numeric(8,0),
    idpes_pai numeric(8,0),
    idpes_responsavel numeric(8,0),
    idesco numeric(2,0),
    ideciv numeric(1,0),
    idpes_con numeric(8,0),
    data_uniao date,
    data_obito date,
    nacionalidade numeric(1,0),
    idpais_estrangeiro numeric(3,0),
    data_chegada_brasil date,
    idmun_nascimento numeric(6,0),
    ultima_empresa character varying(150),
    idocup numeric(6,0),
    nome_mae character varying(150),
    nome_pai character varying(150),
    nome_conjuge character varying(150),
    nome_responsavel character varying(150),
    justificativa_provisorio character varying(150),
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_fisica_nacionalidade CHECK (((nacionalidade >= (1)::numeric) AND (nacionalidade <= (3)::numeric))),
    CONSTRAINT ck_fisica_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_fisica_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_fisica_sexo CHECK (((sexo = 'M'::bpchar) OR (sexo = 'F'::bpchar)))
);


--
-- TOC entry 365 (class 1259 OID 9443642)
-- Name: fisica_cpf; Type: TABLE; Schema: historico; Owner: -
--

CREATE TABLE historico.fisica_cpf (
    idpes numeric(8,0) NOT NULL,
    cpf numeric(11,0) NOT NULL,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_fisica_cpf_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_fone_pessoa_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar)))
);


--
-- TOC entry 366 (class 1259 OID 9443650)
-- Name: fone_pessoa; Type: TABLE; Schema: historico; Owner: -
--

CREATE TABLE historico.fone_pessoa (
    idpes numeric(8,0) NOT NULL,
    tipo numeric(1,0) NOT NULL,
    ddd numeric(3,0) NOT NULL,
    fone numeric(11,0) NOT NULL,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_fone_pessoa_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_fone_pessoa_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_fone_pessoa_tipo CHECK (((tipo >= (1)::numeric) AND (tipo <= (4)::numeric)))
);


--
-- TOC entry 367 (class 1259 OID 9443659)
-- Name: funcionario; Type: TABLE; Schema: historico; Owner: -
--

CREATE TABLE historico.funcionario (
    matricula numeric(8,0) NOT NULL,
    idins integer NOT NULL,
    idset integer,
    idpes numeric(8,0) NOT NULL,
    situacao character(1) NOT NULL,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_fone_pessoa_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_funcionario_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_funcionario_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


--
-- TOC entry 368 (class 1259 OID 9443668)
-- Name: juridica; Type: TABLE; Schema: historico; Owner: -
--

CREATE TABLE historico.juridica (
    idpes numeric(8,0) NOT NULL,
    cnpj numeric(14,0) NOT NULL,
    insc_estadual numeric(20,0),
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    fantasia character varying(255),
    CONSTRAINT ck_juridica_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_juridica_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


--
-- TOC entry 369 (class 1259 OID 9443676)
-- Name: logradouro; Type: TABLE; Schema: historico; Owner: -
--

CREATE TABLE historico.logradouro (
    idlog numeric(6,0) NOT NULL,
    idtlog character varying(5) NOT NULL,
    nome character varying(150) NOT NULL,
    idmun numeric(6,0) NOT NULL,
    geom character varying,
    ident_oficial character(1),
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_logradouro_ident_oficial CHECK (((ident_oficial = 'S'::bpchar) OR (ident_oficial = 'N'::bpchar))),
    CONSTRAINT ck_logradouro_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_logradouro_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


--
-- TOC entry 370 (class 1259 OID 9443685)
-- Name: municipio; Type: TABLE; Schema: historico; Owner: -
--

CREATE TABLE historico.municipio (
    idmun numeric(6,0) NOT NULL,
    nome character varying(60) NOT NULL,
    sigla_uf character(2) NOT NULL,
    area_km2 numeric(6,0),
    idmreg numeric(2,0),
    idasmun numeric(2,0),
    cod_ibge numeric(20,0),
    geom character varying,
    tipo character(1) NOT NULL,
    idmun_pai numeric(6,0),
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_municipio_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_municipio_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_municipio_tipo CHECK (((tipo = 'D'::bpchar) OR (tipo = 'M'::bpchar) OR (tipo = 'P'::bpchar) OR (tipo = 'R'::bpchar)))
);


--
-- TOC entry 371 (class 1259 OID 9443694)
-- Name: pessoa; Type: TABLE; Schema: historico; Owner: -
--

CREATE TABLE historico.pessoa (
    idpes numeric(8,0) NOT NULL,
    nome character varying(150) NOT NULL,
    idpes_cad numeric(8,0),
    data_cad timestamp without time zone NOT NULL,
    url character varying(60),
    tipo character(1) NOT NULL,
    idpes_rev numeric(8,0),
    data_rev timestamp without time zone,
    email character varying(100),
    situacao character(1) NOT NULL,
    origem_gravacao character(1) NOT NULL,
    idsis_rev numeric,
    idsis_cad numeric NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_pessoa_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_pessoa_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_pessoa_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar) OR (situacao = 'P'::bpchar))),
    CONSTRAINT ck_pessoa_tipo CHECK (((tipo = 'F'::bpchar) OR (tipo = 'J'::bpchar)))
);


--
-- TOC entry 372 (class 1259 OID 9443704)
-- Name: socio; Type: TABLE; Schema: historico; Owner: -
--

CREATE TABLE historico.socio (
    idpes_juridica numeric(8,0) NOT NULL,
    idpes_fisica numeric(8,0) NOT NULL,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_socio_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_socio_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


SET default_with_oids = false;

--
-- TOC entry 373 (class 1259 OID 9443712)
-- Name: area_conhecimento; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.area_conhecimento (
    id integer NOT NULL,
    instituicao_id integer NOT NULL,
    nome character varying(200) NOT NULL,
    secao character varying(50),
    ordenamento_ac integer DEFAULT 99999
);


--
-- TOC entry 374 (class 1259 OID 9443716)
-- Name: area_conhecimento_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.area_conhecimento_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8146 (class 0 OID 0)
-- Dependencies: 374
-- Name: area_conhecimento_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.area_conhecimento_id_seq OWNED BY modules.area_conhecimento.id;


--
-- TOC entry 375 (class 1259 OID 9443718)
-- Name: auditoria; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.auditoria (
    usuario character varying(300),
    operacao smallint,
    rotina character varying(300),
    valor_antigo text,
    valor_novo text,
    data_hora timestamp without time zone
);


--
-- TOC entry 376 (class 1259 OID 9443724)
-- Name: auditoria_geral; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.auditoria_geral (
    usuario_id integer,
    operacao smallint,
    rotina character varying(50),
    valor_antigo json,
    valor_novo json,
    data_hora timestamp without time zone,
    codigo character varying,
    id integer NOT NULL,
    query text
);


--
-- TOC entry 850 (class 1259 OID 9474619)
-- Name: auditoria_geral_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.auditoria_geral_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8147 (class 0 OID 0)
-- Dependencies: 850
-- Name: auditoria_geral_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.auditoria_geral_id_seq OWNED BY modules.auditoria_geral.id;


--
-- TOC entry 377 (class 1259 OID 9443730)
-- Name: calendario_turma; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.calendario_turma (
    calendario_ano_letivo_id integer NOT NULL,
    ano integer NOT NULL,
    mes integer NOT NULL,
    dia integer NOT NULL,
    turma_id integer NOT NULL
);


--
-- TOC entry 378 (class 1259 OID 9443733)
-- Name: componente_curricular; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.componente_curricular (
    id integer NOT NULL,
    instituicao_id integer NOT NULL,
    area_conhecimento_id integer NOT NULL,
    nome character varying(500) NOT NULL,
    abreviatura character varying(25) NOT NULL,
    tipo_base smallint NOT NULL,
    codigo_educacenso smallint,
    ordenamento integer DEFAULT 99999
);


--
-- TOC entry 379 (class 1259 OID 9443740)
-- Name: componente_curricular_ano_escolar; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.componente_curricular_ano_escolar (
    componente_curricular_id integer NOT NULL,
    ano_escolar_id integer NOT NULL,
    carga_horaria numeric(7,3),
    tipo_nota integer,
    anos_letivos smallint[] DEFAULT '{}'::smallint[] NOT NULL
);


--
-- TOC entry 380 (class 1259 OID 9443743)
-- Name: componente_curricular_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.componente_curricular_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8148 (class 0 OID 0)
-- Dependencies: 380
-- Name: componente_curricular_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.componente_curricular_id_seq OWNED BY modules.componente_curricular.id;


--
-- TOC entry 381 (class 1259 OID 9443745)
-- Name: componente_curricular_turma; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.componente_curricular_turma (
    componente_curricular_id integer NOT NULL,
    ano_escolar_id integer NOT NULL,
    escola_id integer NOT NULL,
    turma_id integer NOT NULL,
    carga_horaria numeric(7,3),
    docente_vinculado smallint,
    etapas_especificas smallint,
    etapas_utilizadas character varying,
    updated_at timestamp without time zone DEFAULT now() NOT NULL
);


--
-- TOC entry 844 (class 1259 OID 9469019)
-- Name: config_movimento_geral; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.config_movimento_geral (
    id integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    coluna integer NOT NULL
);


--
-- TOC entry 843 (class 1259 OID 9469017)
-- Name: config_movimento_geral_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.config_movimento_geral_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8149 (class 0 OID 0)
-- Dependencies: 843
-- Name: config_movimento_geral_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.config_movimento_geral_id_seq OWNED BY modules.config_movimento_geral.id;


--
-- TOC entry 382 (class 1259 OID 9443751)
-- Name: docente_licenciatura; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.docente_licenciatura (
    id integer NOT NULL,
    servidor_id integer NOT NULL,
    licenciatura integer NOT NULL,
    curso_id integer,
    ano_conclusao integer NOT NULL,
    ies_id integer,
    user_id integer NOT NULL,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


--
-- TOC entry 383 (class 1259 OID 9443754)
-- Name: docente_licenciatura_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.docente_licenciatura_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8150 (class 0 OID 0)
-- Dependencies: 383
-- Name: docente_licenciatura_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.docente_licenciatura_id_seq OWNED BY modules.docente_licenciatura.id;


--
-- TOC entry 384 (class 1259 OID 9443756)
-- Name: educacenso_cod_aluno; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.educacenso_cod_aluno (
    cod_aluno integer NOT NULL,
    cod_aluno_inep bigint NOT NULL,
    nome_inep character varying(255),
    fonte character varying(255),
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


--
-- TOC entry 385 (class 1259 OID 9443762)
-- Name: educacenso_cod_docente; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.educacenso_cod_docente (
    cod_servidor integer NOT NULL,
    cod_docente_inep bigint NOT NULL,
    nome_inep character varying(255),
    fonte character varying(255),
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


--
-- TOC entry 386 (class 1259 OID 9443768)
-- Name: educacenso_cod_escola; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.educacenso_cod_escola (
    cod_escola integer NOT NULL,
    cod_escola_inep bigint NOT NULL,
    nome_inep character varying(255),
    fonte character varying(255),
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


--
-- TOC entry 387 (class 1259 OID 9443774)
-- Name: educacenso_cod_turma; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.educacenso_cod_turma (
    cod_turma integer NOT NULL,
    cod_turma_inep bigint NOT NULL,
    nome_inep character varying(255),
    fonte character varying(255),
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


--
-- TOC entry 388 (class 1259 OID 9443780)
-- Name: educacenso_curso_superior; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.educacenso_curso_superior (
    id integer NOT NULL,
    curso_id character varying(100) NOT NULL,
    nome character varying(255) NOT NULL,
    classe_id integer NOT NULL,
    user_id integer NOT NULL,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone,
    grau_academico smallint
);


--
-- TOC entry 389 (class 1259 OID 9443783)
-- Name: educacenso_curso_superior_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.educacenso_curso_superior_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8151 (class 0 OID 0)
-- Dependencies: 389
-- Name: educacenso_curso_superior_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.educacenso_curso_superior_id_seq OWNED BY modules.educacenso_curso_superior.id;


--
-- TOC entry 390 (class 1259 OID 9443785)
-- Name: educacenso_ies; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.educacenso_ies (
    id integer NOT NULL,
    ies_id integer NOT NULL,
    nome character varying(255) NOT NULL,
    dependencia_administrativa_id integer NOT NULL,
    tipo_instituicao_id integer NOT NULL,
    uf character(2),
    user_id integer NOT NULL,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


--
-- TOC entry 391 (class 1259 OID 9443788)
-- Name: educacenso_ies_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.educacenso_ies_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8152 (class 0 OID 0)
-- Dependencies: 391
-- Name: educacenso_ies_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.educacenso_ies_id_seq OWNED BY modules.educacenso_ies.id;


--
-- TOC entry 847 (class 1259 OID 9474458)
-- Name: educacenso_orgao_regional; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.educacenso_orgao_regional (
    sigla_uf character varying(2) NOT NULL,
    codigo character varying(5) NOT NULL
);


--
-- TOC entry 392 (class 1259 OID 9443790)
-- Name: empresa_transporte_escolar_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.empresa_transporte_escolar_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 393 (class 1259 OID 9443792)
-- Name: empresa_transporte_escolar; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.empresa_transporte_escolar (
    cod_empresa_transporte_escolar integer DEFAULT nextval('modules.empresa_transporte_escolar_seq'::regclass) NOT NULL,
    ref_idpes integer NOT NULL,
    ref_resp_idpes integer NOT NULL,
    observacao character varying(255)
);


SET default_with_oids = false;

--
-- TOC entry 394 (class 1259 OID 9443796)
-- Name: etapas_curso_educacenso; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.etapas_curso_educacenso (
    etapa_id integer NOT NULL,
    curso_id integer NOT NULL
);


--
-- TOC entry 395 (class 1259 OID 9443799)
-- Name: etapas_educacenso; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.etapas_educacenso (
    id integer NOT NULL,
    nome character varying(255)
);


--
-- TOC entry 396 (class 1259 OID 9443802)
-- Name: falta_aluno; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.falta_aluno (
    id integer NOT NULL,
    matricula_id integer NOT NULL,
    tipo_falta smallint NOT NULL
);


--
-- TOC entry 397 (class 1259 OID 9443805)
-- Name: falta_aluno_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.falta_aluno_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8153 (class 0 OID 0)
-- Dependencies: 397
-- Name: falta_aluno_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.falta_aluno_id_seq OWNED BY modules.falta_aluno.id;


--
-- TOC entry 398 (class 1259 OID 9443807)
-- Name: falta_componente_curricular; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.falta_componente_curricular (
    id integer NOT NULL,
    falta_aluno_id integer NOT NULL,
    componente_curricular_id integer NOT NULL,
    quantidade integer DEFAULT 0,
    etapa character varying(2) NOT NULL
);


--
-- TOC entry 399 (class 1259 OID 9443811)
-- Name: falta_componente_curricular_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.falta_componente_curricular_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8154 (class 0 OID 0)
-- Dependencies: 399
-- Name: falta_componente_curricular_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.falta_componente_curricular_id_seq OWNED BY modules.falta_componente_curricular.id;


--
-- TOC entry 400 (class 1259 OID 9443813)
-- Name: falta_geral; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.falta_geral (
    id integer NOT NULL,
    falta_aluno_id integer NOT NULL,
    quantidade integer DEFAULT 0,
    etapa character varying(2) NOT NULL
);


--
-- TOC entry 401 (class 1259 OID 9443817)
-- Name: falta_geral_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.falta_geral_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8155 (class 0 OID 0)
-- Dependencies: 401
-- Name: falta_geral_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.falta_geral_id_seq OWNED BY modules.falta_geral.id;


SET default_with_oids = true;

--
-- TOC entry 402 (class 1259 OID 9443819)
-- Name: ficha_medica_aluno; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.ficha_medica_aluno (
    ref_cod_aluno integer NOT NULL,
    altura character varying(4),
    peso character varying(7),
    grupo_sanguineo character varying(2),
    fator_rh character varying(1),
    alergia_medicamento character(1),
    desc_alergia_medicamento character varying(100),
    alergia_alimento character(1),
    desc_alergia_alimento character varying(100),
    doenca_congenita character(1),
    desc_doenca_congenita character varying(100),
    fumante character(1),
    doenca_caxumba character(1),
    doenca_sarampo character(1),
    doenca_rubeola character(1),
    doenca_catapora character(1),
    doenca_escarlatina character(1),
    doenca_coqueluche character(1),
    doenca_outras character varying(100),
    epiletico character(1),
    epiletico_tratamento character(1),
    hemofilico character(1),
    hipertenso character(1),
    asmatico character(1),
    diabetico character(1),
    insulina character(1),
    tratamento_medico character(1),
    desc_tratamento_medico character varying(100),
    medicacao_especifica character(1),
    desc_medicacao_especifica character varying(100),
    acomp_medico_psicologico character(1),
    desc_acomp_medico_psicologico character varying(100),
    restricao_atividade_fisica character(1),
    desc_restricao_atividade_fisica character varying(100),
    fratura_trauma character(1),
    desc_fratura_trauma character varying(100),
    plano_saude character(1),
    desc_plano_saude character varying(50),
    hospital_clinica character varying(100),
    hospital_clinica_endereco character varying(50),
    hospital_clinica_telefone character varying(20),
    responsavel character varying(50),
    responsavel_parentesco character varying(20),
    responsavel_parentesco_telefone character varying(20),
    responsavel_parentesco_celular character varying(20),
    observacao character varying(255)
);


SET default_with_oids = false;

--
-- TOC entry 403 (class 1259 OID 9443825)
-- Name: formula_media; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.formula_media (
    id integer NOT NULL,
    instituicao_id integer NOT NULL,
    nome character varying(50) NOT NULL,
    formula_media character varying(200) NOT NULL,
    tipo_formula smallint DEFAULT 1,
    substitui_menor_nota_rc smallint DEFAULT 0 NOT NULL
);


--
-- TOC entry 404 (class 1259 OID 9443830)
-- Name: formula_media_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.formula_media_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8156 (class 0 OID 0)
-- Dependencies: 404
-- Name: formula_media_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.formula_media_id_seq OWNED BY modules.formula_media.id;


--
-- TOC entry 405 (class 1259 OID 9443832)
-- Name: itinerario_transporte_escolar_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.itinerario_transporte_escolar_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 406 (class 1259 OID 9443834)
-- Name: itinerario_transporte_escolar; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.itinerario_transporte_escolar (
    cod_itinerario_transporte_escolar integer DEFAULT nextval('modules.itinerario_transporte_escolar_seq'::regclass) NOT NULL,
    ref_cod_rota_transporte_escolar integer NOT NULL,
    seq integer NOT NULL,
    ref_cod_ponto_transporte_escolar integer NOT NULL,
    ref_cod_veiculo integer,
    hora time without time zone,
    tipo character(1) NOT NULL
);


SET default_with_oids = false;

--
-- TOC entry 407 (class 1259 OID 9443838)
-- Name: lingua_indigena_educacenso; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.lingua_indigena_educacenso (
    id integer NOT NULL,
    lingua character varying(255)
);


--
-- TOC entry 408 (class 1259 OID 9443841)
-- Name: media_geral; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.media_geral (
    nota_aluno_id integer NOT NULL,
    media numeric(8,4) DEFAULT 0,
    media_arredondada character varying(10) DEFAULT 0,
    etapa character varying(2) NOT NULL
);


SET default_with_oids = true;

--
-- TOC entry 409 (class 1259 OID 9443846)
-- Name: moradia_aluno; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.moradia_aluno (
    ref_cod_aluno integer NOT NULL,
    moradia character(1),
    material character(1) DEFAULT 'A'::bpchar,
    casa_outra character varying(20),
    moradia_situacao integer,
    quartos integer,
    sala integer,
    copa integer,
    banheiro integer,
    garagem integer,
    empregada_domestica character(1),
    automovel character(1),
    motocicleta character(1),
    computador character(1),
    geladeira character(1),
    fogao character(1),
    maquina_lavar character(1),
    microondas character(1),
    video_dvd character(1),
    televisao character(1),
    celular character(1),
    telefone character(1),
    quant_pessoas integer,
    renda double precision,
    agua_encanada character(1),
    poco character(1),
    energia character(1),
    esgoto character(1),
    fossa character(1),
    lixo character(1)
);


--
-- TOC entry 410 (class 1259 OID 9443850)
-- Name: motorista_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.motorista_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 411 (class 1259 OID 9443852)
-- Name: motorista; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.motorista (
    cod_motorista integer DEFAULT nextval('modules.motorista_seq'::regclass) NOT NULL,
    ref_idpes integer NOT NULL,
    cnh character varying(15),
    tipo_cnh character varying(2),
    dt_habilitacao date,
    vencimento_cnh date,
    ref_cod_empresa_transporte_escolar integer NOT NULL,
    observacao character varying(255)
);


SET default_with_oids = false;

--
-- TOC entry 412 (class 1259 OID 9443856)
-- Name: nota_aluno; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.nota_aluno (
    id integer NOT NULL,
    matricula_id integer NOT NULL
);


--
-- TOC entry 413 (class 1259 OID 9443859)
-- Name: nota_aluno_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.nota_aluno_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8157 (class 0 OID 0)
-- Dependencies: 413
-- Name: nota_aluno_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.nota_aluno_id_seq OWNED BY modules.nota_aluno.id;


--
-- TOC entry 414 (class 1259 OID 9443861)
-- Name: nota_componente_curricular; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.nota_componente_curricular (
    id integer NOT NULL,
    nota_aluno_id integer NOT NULL,
    componente_curricular_id integer NOT NULL,
    nota numeric(8,4) DEFAULT 0,
    nota_arredondada character varying(10) DEFAULT 0,
    etapa character varying(2) NOT NULL,
    nota_recuperacao character varying(10),
    nota_original character varying(10),
    nota_recuperacao_especifica character varying(10)
);


--
-- TOC entry 415 (class 1259 OID 9443866)
-- Name: nota_componente_curricular_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.nota_componente_curricular_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8158 (class 0 OID 0)
-- Dependencies: 415
-- Name: nota_componente_curricular_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.nota_componente_curricular_id_seq OWNED BY modules.nota_componente_curricular.id;


--
-- TOC entry 416 (class 1259 OID 9443868)
-- Name: nota_componente_curricular_media; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.nota_componente_curricular_media (
    nota_aluno_id integer NOT NULL,
    componente_curricular_id integer NOT NULL,
    media numeric(8,4) DEFAULT 0,
    media_arredondada character varying(10) DEFAULT 0,
    etapa character varying(2) NOT NULL,
    situacao integer
);


SET default_with_oids = true;

--
-- TOC entry 417 (class 1259 OID 9443873)
-- Name: nota_exame; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.nota_exame (
    ref_cod_matricula integer NOT NULL,
    ref_cod_componente_curricular integer NOT NULL,
    nota_exame numeric(6,3)
);


--
-- TOC entry 418 (class 1259 OID 9443876)
-- Name: nota_geral_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.nota_geral_id_seq
    START WITH 958638
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = false;

--
-- TOC entry 419 (class 1259 OID 9443878)
-- Name: nota_geral; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.nota_geral (
    id integer DEFAULT nextval('modules.nota_geral_id_seq'::regclass) NOT NULL,
    nota_aluno_id integer NOT NULL,
    nota numeric(8,4) DEFAULT 0,
    nota_arredondada character varying(10) DEFAULT 0,
    etapa character varying(2) NOT NULL
);


--
-- TOC entry 420 (class 1259 OID 9443884)
-- Name: parecer_aluno; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.parecer_aluno (
    id integer NOT NULL,
    matricula_id integer NOT NULL,
    parecer_descritivo smallint NOT NULL
);


--
-- TOC entry 421 (class 1259 OID 9443887)
-- Name: parecer_aluno_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.parecer_aluno_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8159 (class 0 OID 0)
-- Dependencies: 421
-- Name: parecer_aluno_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.parecer_aluno_id_seq OWNED BY modules.parecer_aluno.id;


--
-- TOC entry 422 (class 1259 OID 9443889)
-- Name: parecer_componente_curricular; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.parecer_componente_curricular (
    id integer NOT NULL,
    parecer_aluno_id integer NOT NULL,
    componente_curricular_id integer NOT NULL,
    parecer text,
    etapa character varying(2) NOT NULL
);


--
-- TOC entry 423 (class 1259 OID 9443895)
-- Name: parecer_componente_curricular_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.parecer_componente_curricular_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8160 (class 0 OID 0)
-- Dependencies: 423
-- Name: parecer_componente_curricular_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.parecer_componente_curricular_id_seq OWNED BY modules.parecer_componente_curricular.id;


--
-- TOC entry 424 (class 1259 OID 9443897)
-- Name: parecer_geral; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.parecer_geral (
    id integer NOT NULL,
    parecer_aluno_id integer NOT NULL,
    parecer text,
    etapa character varying(2) NOT NULL
);


--
-- TOC entry 425 (class 1259 OID 9443903)
-- Name: parecer_geral_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.parecer_geral_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8161 (class 0 OID 0)
-- Dependencies: 425
-- Name: parecer_geral_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.parecer_geral_id_seq OWNED BY modules.parecer_geral.id;


--
-- TOC entry 426 (class 1259 OID 9443905)
-- Name: pessoa_transporte_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.pessoa_transporte_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 427 (class 1259 OID 9443907)
-- Name: pessoa_transporte; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.pessoa_transporte (
    cod_pessoa_transporte integer DEFAULT nextval('modules.pessoa_transporte_seq'::regclass) NOT NULL,
    ref_idpes integer NOT NULL,
    ref_cod_rota_transporte_escolar integer NOT NULL,
    ref_cod_ponto_transporte_escolar integer,
    ref_idpes_destino integer,
    observacao character varying(255),
    turno character varying(255)
);


--
-- TOC entry 428 (class 1259 OID 9443914)
-- Name: ponto_transporte_escolar_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.ponto_transporte_escolar_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 429 (class 1259 OID 9443916)
-- Name: ponto_transporte_escolar; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.ponto_transporte_escolar (
    cod_ponto_transporte_escolar integer DEFAULT nextval('modules.ponto_transporte_escolar_seq'::regclass) NOT NULL,
    descricao character varying(70) NOT NULL,
    cep numeric(8,0),
    idlog numeric(6,0),
    idbai numeric(6,0),
    numero numeric(6,0),
    complemento character varying(20),
    latitude character varying(20),
    longitude character varying(20)
);


--
-- TOC entry 430 (class 1259 OID 9443920)
-- Name: professor_turma_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.professor_turma_id_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = false;

--
-- TOC entry 431 (class 1259 OID 9443922)
-- Name: professor_turma; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.professor_turma (
    id integer DEFAULT nextval('modules.professor_turma_id_seq'::regclass) NOT NULL,
    ano smallint NOT NULL,
    instituicao_id integer NOT NULL,
    turma_id integer NOT NULL,
    servidor_id integer NOT NULL,
    funcao_exercida smallint NOT NULL,
    tipo_vinculo smallint,
    permite_lancar_faltas_componente integer DEFAULT 0,
    updated_at timestamp without time zone,
    turno_id integer
);


--
-- TOC entry 432 (class 1259 OID 9443927)
-- Name: professor_turma_disciplina; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.professor_turma_disciplina (
    professor_turma_id integer NOT NULL,
    componente_curricular_id integer NOT NULL
);


--
-- TOC entry 433 (class 1259 OID 9443930)
-- Name: regra_avaliacao; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.regra_avaliacao (
    id integer NOT NULL,
    instituicao_id integer NOT NULL,
    formula_media_id integer NOT NULL,
    formula_recuperacao_id integer,
    tabela_arredondamento_id integer,
    nome character varying(50) NOT NULL,
    tipo_nota smallint NOT NULL,
    tipo_progressao smallint NOT NULL,
    media numeric(5,3) DEFAULT 0.000,
    porcentagem_presenca numeric(6,3) DEFAULT 0.000,
    parecer_descritivo smallint DEFAULT 0,
    tipo_presenca smallint NOT NULL,
    media_recuperacao numeric(5,3) DEFAULT 0.000,
    tipo_recuperacao_paralela smallint DEFAULT 0,
    media_recuperacao_paralela numeric(5,3),
    nota_maxima_geral integer DEFAULT 10 NOT NULL,
    nota_maxima_exame_final integer DEFAULT 10 NOT NULL,
    qtd_casas_decimais integer DEFAULT 2 NOT NULL,
    nota_geral_por_etapa smallint DEFAULT 0,
    qtd_disciplinas_dependencia smallint DEFAULT 0 NOT NULL,
    aprova_media_disciplina smallint DEFAULT 0,
    reprovacao_automatica smallint DEFAULT 0,
    definir_componente_etapa smallint,
    qtd_matriculas_dependencia smallint DEFAULT 0 NOT NULL,
    nota_minima_geral integer DEFAULT 0,
    tabela_arredondamento_id_conceitual integer,
    regra_diferenciada_id integer
);


--
-- TOC entry 434 (class 1259 OID 9443948)
-- Name: regra_avaliacao_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.regra_avaliacao_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8162 (class 0 OID 0)
-- Dependencies: 434
-- Name: regra_avaliacao_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.regra_avaliacao_id_seq OWNED BY modules.regra_avaliacao.id;


--
-- TOC entry 435 (class 1259 OID 9443950)
-- Name: regra_avaliacao_recuperacao_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.regra_avaliacao_recuperacao_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 436 (class 1259 OID 9443952)
-- Name: regra_avaliacao_recuperacao; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.regra_avaliacao_recuperacao (
    id integer DEFAULT nextval('modules.regra_avaliacao_recuperacao_id_seq'::regclass) NOT NULL,
    regra_avaliacao_id integer NOT NULL,
    descricao character varying(25) NOT NULL,
    etapas_recuperadas character varying(25) NOT NULL,
    substitui_menor_nota boolean,
    media numeric(8,4) NOT NULL,
    nota_maxima numeric(8,4) NOT NULL
);


--
-- TOC entry 849 (class 1259 OID 9474570)
-- Name: regra_avaliacao_serie_ano; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.regra_avaliacao_serie_ano (
    serie_id integer NOT NULL,
    regra_avaliacao_id integer NOT NULL,
    regra_avaliacao_diferenciada_id integer,
    ano_letivo smallint NOT NULL
);


--
-- TOC entry 437 (class 1259 OID 9443956)
-- Name: rota_transporte_escolar_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.rota_transporte_escolar_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 438 (class 1259 OID 9443958)
-- Name: rota_transporte_escolar; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.rota_transporte_escolar (
    cod_rota_transporte_escolar integer DEFAULT nextval('modules.rota_transporte_escolar_seq'::regclass) NOT NULL,
    ref_idpes_destino integer NOT NULL,
    descricao character varying(50) NOT NULL,
    ano integer NOT NULL,
    tipo_rota character(1) NOT NULL,
    km_pav double precision,
    km_npav double precision,
    ref_cod_empresa_transporte_escolar integer,
    tercerizado character(1) NOT NULL
);


SET default_with_oids = false;

--
-- TOC entry 439 (class 1259 OID 9443962)
-- Name: tabela_arredondamento; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.tabela_arredondamento (
    id integer NOT NULL,
    instituicao_id integer NOT NULL,
    nome character varying(50) NOT NULL,
    tipo_nota smallint DEFAULT 1 NOT NULL
);


--
-- TOC entry 440 (class 1259 OID 9443966)
-- Name: tabela_arredondamento_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.tabela_arredondamento_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8163 (class 0 OID 0)
-- Dependencies: 440
-- Name: tabela_arredondamento_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.tabela_arredondamento_id_seq OWNED BY modules.tabela_arredondamento.id;


--
-- TOC entry 441 (class 1259 OID 9443968)
-- Name: tabela_arredondamento_valor; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.tabela_arredondamento_valor (
    id integer NOT NULL,
    tabela_arredondamento_id integer NOT NULL,
    nome character varying(5) NOT NULL,
    descricao character varying(25),
    valor_minimo numeric(5,3),
    valor_maximo numeric(5,3),
    casa_decimal_exata smallint,
    acao smallint
);


--
-- TOC entry 442 (class 1259 OID 9443971)
-- Name: tabela_arredondamento_valor_id_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.tabela_arredondamento_valor_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8164 (class 0 OID 0)
-- Dependencies: 442
-- Name: tabela_arredondamento_valor_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: -
--

ALTER SEQUENCE modules.tabela_arredondamento_valor_id_seq OWNED BY modules.tabela_arredondamento_valor.id;


--
-- TOC entry 443 (class 1259 OID 9443973)
-- Name: tipo_veiculo_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.tipo_veiculo_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 444 (class 1259 OID 9443975)
-- Name: tipo_veiculo; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.tipo_veiculo (
    cod_tipo_veiculo integer DEFAULT nextval('modules.tipo_veiculo_seq'::regclass) NOT NULL,
    descricao character varying(60)
);


SET default_with_oids = false;

--
-- TOC entry 445 (class 1259 OID 9443979)
-- Name: transporte_aluno; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.transporte_aluno (
    aluno_id integer NOT NULL,
    responsavel integer NOT NULL,
    user_id integer NOT NULL,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


SET default_with_oids = true;

--
-- TOC entry 446 (class 1259 OID 9443982)
-- Name: uniforme_aluno; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.uniforme_aluno (
    ref_cod_aluno integer NOT NULL,
    recebeu_uniforme character(1),
    quantidade_camiseta integer,
    tamanho_camiseta character(2),
    quantidade_blusa_jaqueta integer,
    tamanho_blusa_jaqueta character(2),
    quantidade_bermuda integer,
    tamanho_bermuda character(2),
    quantidade_calca integer,
    tamanho_calca character(2),
    quantidade_saia integer,
    tamanho_saia character(2),
    quantidade_calcado integer,
    tamanho_calcado character(2),
    quantidade_meia integer,
    tamanho_meia character(2)
);


--
-- TOC entry 447 (class 1259 OID 9443985)
-- Name: veiculo_seq; Type: SEQUENCE; Schema: modules; Owner: -
--

CREATE SEQUENCE modules.veiculo_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 448 (class 1259 OID 9443987)
-- Name: veiculo; Type: TABLE; Schema: modules; Owner: -
--

CREATE TABLE modules.veiculo (
    cod_veiculo integer DEFAULT nextval('modules.veiculo_seq'::regclass) NOT NULL,
    descricao character varying(255) NOT NULL,
    placa character varying(10),
    renavam character varying(15) NOT NULL,
    chassi character varying(30),
    marca character varying(50),
    ano_fabricacao integer,
    ano_modelo integer,
    passageiros integer NOT NULL,
    malha character(1) NOT NULL,
    ref_cod_tipo_veiculo integer NOT NULL,
    exclusivo_transporte_escolar character(1) NOT NULL,
    adaptado_necessidades_especiais character(1) NOT NULL,
    ativo character(1),
    descricao_inativo character(155),
    ref_cod_empresa_transporte_escolar integer NOT NULL,
    ref_cod_motorista integer,
    observacao character varying(255)
);


--
-- TOC entry 449 (class 1259 OID 9443994)
-- Name: acao_governo_cod_acao_governo_seq; Type: SEQUENCE; Schema: pmiacoes; Owner: -
--

CREATE SEQUENCE pmiacoes.acao_governo_cod_acao_governo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 450 (class 1259 OID 9443996)
-- Name: acao_governo; Type: TABLE; Schema: pmiacoes; Owner: -
--

CREATE TABLE pmiacoes.acao_governo (
    cod_acao_governo integer DEFAULT nextval('pmiacoes.acao_governo_cod_acao_governo_seq'::regclass) NOT NULL,
    ref_funcionario_exc integer,
    ref_funcionario_cad integer NOT NULL,
    nm_acao character varying(255) NOT NULL,
    descricao text,
    data_inauguracao timestamp without time zone,
    valor double precision,
    destaque smallint DEFAULT (0)::smallint NOT NULL,
    status_acao smallint DEFAULT (0)::smallint NOT NULL,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    numero_acao smallint DEFAULT 0,
    categoria smallint,
    idbai bigint
);


--
-- TOC entry 451 (class 1259 OID 9444007)
-- Name: acao_governo_arquivo_cod_acao_governo_arquivo_seq; Type: SEQUENCE; Schema: pmiacoes; Owner: -
--

CREATE SEQUENCE pmiacoes.acao_governo_arquivo_cod_acao_governo_arquivo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 452 (class 1259 OID 9444009)
-- Name: acao_governo_arquivo; Type: TABLE; Schema: pmiacoes; Owner: -
--

CREATE TABLE pmiacoes.acao_governo_arquivo (
    cod_acao_governo_arquivo integer DEFAULT nextval('pmiacoes.acao_governo_arquivo_cod_acao_governo_arquivo_seq'::regclass) NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    ref_cod_acao_governo integer NOT NULL,
    nm_arquivo character varying(255) NOT NULL,
    caminho_arquivo character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL
);


--
-- TOC entry 453 (class 1259 OID 9444016)
-- Name: acao_governo_categoria; Type: TABLE; Schema: pmiacoes; Owner: -
--

CREATE TABLE pmiacoes.acao_governo_categoria (
    ref_cod_categoria integer NOT NULL,
    ref_cod_acao_governo integer NOT NULL
);


--
-- TOC entry 454 (class 1259 OID 9444019)
-- Name: acao_governo_foto_cod_acao_governo_foto_seq; Type: SEQUENCE; Schema: pmiacoes; Owner: -
--

CREATE SEQUENCE pmiacoes.acao_governo_foto_cod_acao_governo_foto_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 455 (class 1259 OID 9444021)
-- Name: acao_governo_foto; Type: TABLE; Schema: pmiacoes; Owner: -
--

CREATE TABLE pmiacoes.acao_governo_foto (
    cod_acao_governo_foto integer DEFAULT nextval('pmiacoes.acao_governo_foto_cod_acao_governo_foto_seq'::regclass) NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    ref_cod_acao_governo integer NOT NULL,
    nm_foto character varying(255) NOT NULL,
    caminho character varying(255) NOT NULL,
    data_foto timestamp without time zone,
    data_cadastro timestamp without time zone NOT NULL
);


--
-- TOC entry 456 (class 1259 OID 9444028)
-- Name: acao_governo_foto_portal; Type: TABLE; Schema: pmiacoes; Owner: -
--

CREATE TABLE pmiacoes.acao_governo_foto_portal (
    ref_cod_acao_governo integer NOT NULL,
    ref_cod_foto_portal integer NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL
);


--
-- TOC entry 457 (class 1259 OID 9444031)
-- Name: acao_governo_noticia; Type: TABLE; Schema: pmiacoes; Owner: -
--

CREATE TABLE pmiacoes.acao_governo_noticia (
    ref_cod_acao_governo integer NOT NULL,
    ref_cod_not_portal integer NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL
);


--
-- TOC entry 458 (class 1259 OID 9444034)
-- Name: acao_governo_setor; Type: TABLE; Schema: pmiacoes; Owner: -
--

CREATE TABLE pmiacoes.acao_governo_setor (
    ref_cod_acao_governo integer NOT NULL,
    ref_cod_setor integer NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL
);


--
-- TOC entry 459 (class 1259 OID 9444037)
-- Name: categoria_cod_categoria_seq; Type: SEQUENCE; Schema: pmiacoes; Owner: -
--

CREATE SEQUENCE pmiacoes.categoria_cod_categoria_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 460 (class 1259 OID 9444039)
-- Name: categoria; Type: TABLE; Schema: pmiacoes; Owner: -
--

CREATE TABLE pmiacoes.categoria (
    cod_categoria integer DEFAULT nextval('pmiacoes.categoria_cod_categoria_seq'::regclass) NOT NULL,
    ref_funcionario_exc integer,
    ref_funcionario_cad integer NOT NULL,
    nm_categoria character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 461 (class 1259 OID 9444044)
-- Name: secretaria_responsavel; Type: TABLE; Schema: pmiacoes; Owner: -
--

CREATE TABLE pmiacoes.secretaria_responsavel (
    ref_cod_setor integer NOT NULL,
    ref_cod_funcionario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL
);


--
-- TOC entry 462 (class 1259 OID 9444047)
-- Name: acontecimento_cod_acontecimento_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: -
--

CREATE SEQUENCE pmicontrolesis.acontecimento_cod_acontecimento_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 463 (class 1259 OID 9444049)
-- Name: acontecimento; Type: TABLE; Schema: pmicontrolesis; Owner: -
--

CREATE TABLE pmicontrolesis.acontecimento (
    cod_acontecimento integer DEFAULT nextval('pmicontrolesis.acontecimento_cod_acontecimento_seq'::regclass) NOT NULL,
    ref_cod_tipo_acontecimento integer NOT NULL,
    ref_cod_funcionario_cad integer NOT NULL,
    ref_cod_funcionario_exc integer,
    titulo character varying(255),
    descricao text,
    dt_inicio timestamp without time zone,
    dt_fim timestamp without time zone,
    hr_inicio time without time zone,
    hr_fim time without time zone,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint,
    local character varying,
    contato character varying,
    link character varying
);


--
-- TOC entry 464 (class 1259 OID 9444057)
-- Name: artigo_cod_artigo_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: -
--

CREATE SEQUENCE pmicontrolesis.artigo_cod_artigo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 465 (class 1259 OID 9444059)
-- Name: artigo; Type: TABLE; Schema: pmicontrolesis; Owner: -
--

CREATE TABLE pmicontrolesis.artigo (
    cod_artigo integer DEFAULT nextval('pmicontrolesis.artigo_cod_artigo_seq'::regclass) NOT NULL,
    texto text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint
);


--
-- TOC entry 466 (class 1259 OID 9444067)
-- Name: foto_evento_cod_foto_evento_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: -
--

CREATE SEQUENCE pmicontrolesis.foto_evento_cod_foto_evento_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 467 (class 1259 OID 9444069)
-- Name: foto_evento; Type: TABLE; Schema: pmicontrolesis; Owner: -
--

CREATE TABLE pmicontrolesis.foto_evento (
    cod_foto_evento integer DEFAULT nextval('pmicontrolesis.foto_evento_cod_foto_evento_seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    data_foto timestamp without time zone,
    titulo character varying(255),
    descricao text,
    caminho character varying(255),
    altura integer,
    largura integer,
    nm_credito character varying(255)
);


--
-- TOC entry 468 (class 1259 OID 9444077)
-- Name: foto_vinc_cod_foto_vinc_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: -
--

CREATE SEQUENCE pmicontrolesis.foto_vinc_cod_foto_vinc_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = false;

--
-- TOC entry 469 (class 1259 OID 9444079)
-- Name: foto_vinc; Type: TABLE; Schema: pmicontrolesis; Owner: -
--

CREATE TABLE pmicontrolesis.foto_vinc (
    cod_foto_vinc integer DEFAULT nextval('pmicontrolesis.foto_vinc_cod_foto_vinc_seq'::regclass) NOT NULL,
    ref_cod_acontecimento integer NOT NULL,
    ref_cod_foto_evento integer NOT NULL
);


--
-- TOC entry 470 (class 1259 OID 9444083)
-- Name: itinerario_cod_itinerario_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: -
--

CREATE SEQUENCE pmicontrolesis.itinerario_cod_itinerario_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 471 (class 1259 OID 9444085)
-- Name: itinerario; Type: TABLE; Schema: pmicontrolesis; Owner: -
--

CREATE TABLE pmicontrolesis.itinerario (
    cod_itinerario integer DEFAULT nextval('pmicontrolesis.itinerario_cod_itinerario_seq'::regclass) NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    ref_funcionario_exc integer,
    numero integer,
    itinerario text,
    retorno text,
    horarios text,
    descricao_horario text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    nome character varying(255) NOT NULL
);


--
-- TOC entry 472 (class 1259 OID 9444093)
-- Name: menu_cod_menu_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: -
--

CREATE SEQUENCE pmicontrolesis.menu_cod_menu_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 473 (class 1259 OID 9444095)
-- Name: menu; Type: TABLE; Schema: pmicontrolesis; Owner: -
--

CREATE TABLE pmicontrolesis.menu (
    cod_menu integer DEFAULT nextval('pmicontrolesis.menu_cod_menu_seq'::regclass) NOT NULL,
    ref_cod_menu_submenu integer,
    ref_cod_menu_pai integer,
    tt_menu character varying(255) NOT NULL,
    ord_menu integer NOT NULL,
    caminho character varying(255),
    alvo character varying(20),
    suprime_menu smallint DEFAULT 1,
    ref_cod_tutormenu integer,
    ref_cod_ico integer,
    tipo_menu integer
);


--
-- TOC entry 474 (class 1259 OID 9444103)
-- Name: menu_portal_cod_menu_portal_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: -
--

CREATE SEQUENCE pmicontrolesis.menu_portal_cod_menu_portal_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 475 (class 1259 OID 9444105)
-- Name: menu_portal; Type: TABLE; Schema: pmicontrolesis; Owner: -
--

CREATE TABLE pmicontrolesis.menu_portal (
    cod_menu_portal integer DEFAULT nextval('pmicontrolesis.menu_portal_cod_menu_portal_seq'::regclass) NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    ref_funcionario_exc integer,
    nm_menu character varying(15) DEFAULT ''::character varying NOT NULL,
    title character varying(255),
    caminho character varying(255),
    cor character varying(255),
    posicao character(1) DEFAULT 'E'::bpchar NOT NULL,
    ordem double precision DEFAULT (0)::double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    expansivel smallint
);


--
-- TOC entry 476 (class 1259 OID 9444116)
-- Name: portais_cod_portais_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: -
--

CREATE SEQUENCE pmicontrolesis.portais_cod_portais_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 477 (class 1259 OID 9444118)
-- Name: portais; Type: TABLE; Schema: pmicontrolesis; Owner: -
--

CREATE TABLE pmicontrolesis.portais (
    cod_portais integer DEFAULT nextval('pmicontrolesis.portais_cod_portais_seq'::regclass) NOT NULL,
    ref_cod_funcionario_cad integer NOT NULL,
    ref_cod_funcionario_exc integer,
    url character varying(255),
    caminho character varying(255),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint,
    title character varying(255),
    descricao text
);


--
-- TOC entry 478 (class 1259 OID 9444126)
-- Name: servicos_cod_servicos_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: -
--

CREATE SEQUENCE pmicontrolesis.servicos_cod_servicos_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 479 (class 1259 OID 9444128)
-- Name: servicos; Type: TABLE; Schema: pmicontrolesis; Owner: -
--

CREATE TABLE pmicontrolesis.servicos (
    cod_servicos integer DEFAULT nextval('pmicontrolesis.servicos_cod_servicos_seq'::regclass) NOT NULL,
    ref_cod_funcionario_cad integer NOT NULL,
    ref_cod_funcionario_exc integer,
    url character varying(255),
    caminho character varying(255),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint,
    title character varying(255),
    descricao text
);


--
-- TOC entry 480 (class 1259 OID 9444136)
-- Name: sistema_cod_sistema_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: -
--

CREATE SEQUENCE pmicontrolesis.sistema_cod_sistema_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 481 (class 1259 OID 9444138)
-- Name: sistema; Type: TABLE; Schema: pmicontrolesis; Owner: -
--

CREATE TABLE pmicontrolesis.sistema (
    cod_sistema integer DEFAULT nextval('pmicontrolesis.sistema_cod_sistema_seq'::regclass) NOT NULL,
    nm_sistema character varying(255) NOT NULL,
    ref_cod_funcionario_cad integer NOT NULL,
    ref_cod_funcionario_exc integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint
);


--
-- TOC entry 482 (class 1259 OID 9444143)
-- Name: submenu_portal_cod_submenu_portal_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: -
--

CREATE SEQUENCE pmicontrolesis.submenu_portal_cod_submenu_portal_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 483 (class 1259 OID 9444145)
-- Name: submenu_portal; Type: TABLE; Schema: pmicontrolesis; Owner: -
--

CREATE TABLE pmicontrolesis.submenu_portal (
    cod_submenu_portal integer DEFAULT nextval('pmicontrolesis.submenu_portal_cod_submenu_portal_seq'::regclass) NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    ref_funcionario_exc integer,
    ref_cod_menu_portal integer DEFAULT 0 NOT NULL,
    nm_submenu character varying(255) DEFAULT ''::character varying NOT NULL,
    arquivo character varying(255) DEFAULT ''::character varying NOT NULL,
    target character(1) DEFAULT 'S'::bpchar NOT NULL,
    title text,
    ordem double precision DEFAULT (0)::double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 484 (class 1259 OID 9444158)
-- Name: telefones_cod_telefones_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: -
--

CREATE SEQUENCE pmicontrolesis.telefones_cod_telefones_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 485 (class 1259 OID 9444160)
-- Name: telefones; Type: TABLE; Schema: pmicontrolesis; Owner: -
--

CREATE TABLE pmicontrolesis.telefones (
    cod_telefones integer DEFAULT nextval('pmicontrolesis.telefones_cod_telefones_seq'::regclass) NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    ref_funcionario_exc integer,
    nome character varying(255) NOT NULL,
    numero character varying,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 486 (class 1259 OID 9444168)
-- Name: tipo_acontecimento_cod_tipo_acontecimento_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: -
--

CREATE SEQUENCE pmicontrolesis.tipo_acontecimento_cod_tipo_acontecimento_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 487 (class 1259 OID 9444170)
-- Name: tipo_acontecimento; Type: TABLE; Schema: pmicontrolesis; Owner: -
--

CREATE TABLE pmicontrolesis.tipo_acontecimento (
    cod_tipo_acontecimento integer DEFAULT nextval('pmicontrolesis.tipo_acontecimento_cod_tipo_acontecimento_seq'::regclass) NOT NULL,
    ref_cod_funcionario_cad integer NOT NULL,
    ref_cod_funcionario_exc integer,
    nm_tipo character varying(255),
    caminho character varying(255),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint
);


--
-- TOC entry 488 (class 1259 OID 9444178)
-- Name: topo_portal_cod_topo_portal_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: -
--

CREATE SEQUENCE pmicontrolesis.topo_portal_cod_topo_portal_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 489 (class 1259 OID 9444180)
-- Name: topo_portal; Type: TABLE; Schema: pmicontrolesis; Owner: -
--

CREATE TABLE pmicontrolesis.topo_portal (
    cod_topo_portal integer DEFAULT nextval('pmicontrolesis.topo_portal_cod_topo_portal_seq'::regclass) NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    ref_funcionario_exc integer,
    ref_cod_menu_portal integer DEFAULT 0,
    caminho1 character varying(255),
    caminho2 character varying(255),
    caminho3 character varying(255),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 490 (class 1259 OID 9444189)
-- Name: tutormenu_cod_tutormenu_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: -
--

CREATE SEQUENCE pmicontrolesis.tutormenu_cod_tutormenu_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 491 (class 1259 OID 9444191)
-- Name: tutormenu; Type: TABLE; Schema: pmicontrolesis; Owner: -
--

CREATE TABLE pmicontrolesis.tutormenu (
    cod_tutormenu integer DEFAULT nextval('pmicontrolesis.tutormenu_cod_tutormenu_seq'::regclass) NOT NULL,
    nm_tutormenu character varying(200) NOT NULL
);


--
-- TOC entry 492 (class 1259 OID 9444195)
-- Name: diaria_cod_diaria_seq; Type: SEQUENCE; Schema: pmidrh; Owner: -
--

CREATE SEQUENCE pmidrh.diaria_cod_diaria_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 493 (class 1259 OID 9444197)
-- Name: diaria; Type: TABLE; Schema: pmidrh; Owner: -
--

CREATE TABLE pmidrh.diaria (
    cod_diaria integer DEFAULT nextval('pmidrh.diaria_cod_diaria_seq'::regclass) NOT NULL,
    ref_funcionario_cadastro integer NOT NULL,
    ref_cod_diaria_grupo integer NOT NULL,
    ref_funcionario integer NOT NULL,
    conta_corrente integer,
    agencia integer,
    banco integer,
    dotacao_orcamentaria character varying(50),
    objetivo text,
    data_partida timestamp without time zone,
    data_chegada timestamp without time zone,
    estadual smallint,
    destino character varying(100),
    data_pedido timestamp without time zone,
    vl100 double precision,
    vl75 double precision,
    vl50 double precision,
    vl25 double precision,
    roteiro integer,
    ativo boolean DEFAULT true,
    ref_cod_setor integer,
    num_diaria numeric(6,0)
);


--
-- TOC entry 494 (class 1259 OID 9444205)
-- Name: diaria_grupo_cod_diaria_grupo_seq; Type: SEQUENCE; Schema: pmidrh; Owner: -
--

CREATE SEQUENCE pmidrh.diaria_grupo_cod_diaria_grupo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 495 (class 1259 OID 9444207)
-- Name: diaria_grupo; Type: TABLE; Schema: pmidrh; Owner: -
--

CREATE TABLE pmidrh.diaria_grupo (
    cod_diaria_grupo integer DEFAULT nextval('pmidrh.diaria_grupo_cod_diaria_grupo_seq'::regclass) NOT NULL,
    desc_grupo character varying(255) NOT NULL
);


--
-- TOC entry 496 (class 1259 OID 9444211)
-- Name: diaria_valores_cod_diaria_valores_seq; Type: SEQUENCE; Schema: pmidrh; Owner: -
--

CREATE SEQUENCE pmidrh.diaria_valores_cod_diaria_valores_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 497 (class 1259 OID 9444213)
-- Name: diaria_valores; Type: TABLE; Schema: pmidrh; Owner: -
--

CREATE TABLE pmidrh.diaria_valores (
    cod_diaria_valores integer DEFAULT nextval('pmidrh.diaria_valores_cod_diaria_valores_seq'::regclass) NOT NULL,
    ref_funcionario_cadastro integer NOT NULL,
    ref_cod_diaria_grupo integer NOT NULL,
    estadual smallint NOT NULL,
    p100 double precision,
    p75 double precision,
    p50 double precision,
    p25 double precision,
    data_vigencia timestamp without time zone NOT NULL
);


--
-- TOC entry 498 (class 1259 OID 9444217)
-- Name: setor_cod_setor_seq; Type: SEQUENCE; Schema: pmidrh; Owner: -
--

CREATE SEQUENCE pmidrh.setor_cod_setor_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 499 (class 1259 OID 9444219)
-- Name: setor; Type: TABLE; Schema: pmidrh; Owner: -
--

CREATE TABLE pmidrh.setor (
    cod_setor integer DEFAULT nextval('pmidrh.setor_cod_setor_seq'::regclass) NOT NULL,
    ref_cod_pessoa_exc integer,
    ref_cod_pessoa_cad integer NOT NULL,
    ref_cod_setor integer,
    nm_setor character varying(255) NOT NULL,
    sgl_setor character varying(15) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    nivel smallint DEFAULT (1)::smallint NOT NULL,
    no_paco smallint DEFAULT 1,
    endereco text,
    tipo character(1),
    ref_idpes_resp integer
);


--
-- TOC entry 500 (class 1259 OID 9444229)
-- Name: abandono_tipo_cod_abandono_tipo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.abandono_tipo_cod_abandono_tipo_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = false;

--
-- TOC entry 501 (class 1259 OID 9444231)
-- Name: abandono_tipo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.abandono_tipo (
    cod_abandono_tipo integer DEFAULT nextval('pmieducar.abandono_tipo_cod_abandono_tipo_seq'::regclass) NOT NULL,
    ref_cod_instituicao integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer,
    nome character varying(255) NOT NULL,
    data_cadastro timestamp without time zone,
    data_exclusao timestamp without time zone,
    ativo integer
);


--
-- TOC entry 502 (class 1259 OID 9444235)
-- Name: acervo_cod_acervo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.acervo_cod_acervo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 503 (class 1259 OID 9444237)
-- Name: acervo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.acervo (
    cod_acervo integer DEFAULT nextval('pmieducar.acervo_cod_acervo_seq'::regclass) NOT NULL,
    ref_cod_exemplar_tipo integer NOT NULL,
    ref_cod_acervo integer,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_acervo_colecao integer,
    ref_cod_acervo_idioma integer NOT NULL,
    ref_cod_acervo_editora integer NOT NULL,
    titulo character varying(255) NOT NULL,
    sub_titulo character varying(255),
    cdu character varying(20),
    cutter character varying(20),
    volume integer,
    num_edicao integer,
    ano character varying(25),
    num_paginas integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer NOT NULL,
    isbn character varying(255),
    cdd character varying(20),
    estante character varying(20),
    dimencao character varying(255),
    material_ilustrativo character varying(255),
    dimencao_ilustrativo character varying(255),
    local character varying(255),
    ref_cod_tipo_autor integer,
    tipo_autor character varying(255)
);


--
-- TOC entry 504 (class 1259 OID 9444245)
-- Name: acervo_acervo_assunto; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.acervo_acervo_assunto (
    ref_cod_acervo integer NOT NULL,
    ref_cod_acervo_assunto integer NOT NULL
);


--
-- TOC entry 505 (class 1259 OID 9444248)
-- Name: acervo_acervo_autor; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.acervo_acervo_autor (
    ref_cod_acervo_autor integer NOT NULL,
    ref_cod_acervo integer NOT NULL,
    principal smallint DEFAULT (0)::smallint NOT NULL
);


--
-- TOC entry 506 (class 1259 OID 9444252)
-- Name: acervo_assunto_cod_acervo_assunto_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.acervo_assunto_cod_acervo_assunto_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 507 (class 1259 OID 9444254)
-- Name: acervo_assunto; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.acervo_assunto (
    cod_acervo_assunto integer DEFAULT nextval('pmieducar.acervo_assunto_cod_acervo_assunto_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_assunto character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer
);


--
-- TOC entry 508 (class 1259 OID 9444262)
-- Name: acervo_autor_cod_acervo_autor_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.acervo_autor_cod_acervo_autor_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 509 (class 1259 OID 9444264)
-- Name: acervo_autor; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.acervo_autor (
    cod_acervo_autor integer DEFAULT nextval('pmieducar.acervo_autor_cod_acervo_autor_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_autor character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer NOT NULL
);


--
-- TOC entry 510 (class 1259 OID 9444272)
-- Name: acervo_colecao_cod_acervo_colecao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.acervo_colecao_cod_acervo_colecao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 511 (class 1259 OID 9444274)
-- Name: acervo_colecao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.acervo_colecao (
    cod_acervo_colecao integer DEFAULT nextval('pmieducar.acervo_colecao_cod_acervo_colecao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_colecao character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer
);


--
-- TOC entry 512 (class 1259 OID 9444282)
-- Name: acervo_editora_cod_acervo_editora_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.acervo_editora_cod_acervo_editora_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 513 (class 1259 OID 9444284)
-- Name: acervo_editora; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.acervo_editora (
    cod_acervo_editora integer DEFAULT nextval('pmieducar.acervo_editora_cod_acervo_editora_seq'::regclass) NOT NULL,
    ref_usuario_cad integer NOT NULL,
    ref_usuario_exc integer,
    ref_idtlog character varying(20),
    ref_sigla_uf character(2),
    nm_editora character varying(255) NOT NULL,
    cep numeric(8,0),
    cidade character varying(60),
    bairro character varying(60),
    logradouro character varying(255),
    numero numeric(6,0),
    telefone integer,
    ddd_telefone numeric(3,0),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer
);


--
-- TOC entry 514 (class 1259 OID 9444292)
-- Name: acervo_idioma_cod_acervo_idioma_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.acervo_idioma_cod_acervo_idioma_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 515 (class 1259 OID 9444294)
-- Name: acervo_idioma; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.acervo_idioma (
    cod_acervo_idioma integer DEFAULT nextval('pmieducar.acervo_idioma_cod_acervo_idioma_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_idioma character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer
);


--
-- TOC entry 516 (class 1259 OID 9444299)
-- Name: aluno_cod_aluno_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.aluno_cod_aluno_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 517 (class 1259 OID 9444301)
-- Name: aluno; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.aluno (
    cod_aluno integer DEFAULT nextval('pmieducar.aluno_cod_aluno_seq'::regclass) NOT NULL,
    ref_cod_religiao integer,
    ref_usuario_exc integer,
    ref_usuario_cad integer,
    ref_idpes integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    caminho_foto character varying(255),
    analfabeto smallint DEFAULT (0)::smallint,
    nm_pai character varying(255),
    nm_mae character varying(255),
    tipo_responsavel character(1),
    aluno_estado_id character varying(25),
    justificativa_falta_documentacao smallint,
    url_laudo_medico json,
    codigo_sistema character varying(30),
    veiculo_transporte_escolar smallint,
    autorizado_um character varying(150),
    parentesco_um character varying(150),
    autorizado_dois character varying(150),
    parentesco_dois character varying(150),
    autorizado_tres character varying(150),
    parentesco_tres character varying(150),
    autorizado_quatro character varying(150),
    parentesco_quatro character varying(150),
    autorizado_cinco character varying(150),
    parentesco_cinco character varying(150),
    url_documento json,
    recebe_escolarizacao_em_outro_espaco smallint DEFAULT 3 NOT NULL,
    recursos_prova_inep integer[]
);


SET default_with_oids = false;

--
-- TOC entry 518 (class 1259 OID 9444310)
-- Name: aluno_aluno_beneficio; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.aluno_aluno_beneficio (
    aluno_id integer NOT NULL,
    aluno_beneficio_id integer NOT NULL
);


--
-- TOC entry 519 (class 1259 OID 9444313)
-- Name: aluno_beneficio_cod_aluno_beneficio_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.aluno_beneficio_cod_aluno_beneficio_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 520 (class 1259 OID 9444315)
-- Name: aluno_beneficio; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.aluno_beneficio (
    cod_aluno_beneficio integer DEFAULT nextval('pmieducar.aluno_beneficio_cod_aluno_beneficio_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_beneficio character varying(255) NOT NULL,
    desc_beneficio text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


SET default_with_oids = false;

--
-- TOC entry 521 (class 1259 OID 9444323)
-- Name: aluno_historico_altura_peso; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.aluno_historico_altura_peso (
    ref_cod_aluno integer NOT NULL,
    data_historico date NOT NULL,
    altura numeric(12,2) NOT NULL,
    peso numeric(12,2) NOT NULL
);


SET default_with_oids = true;

--
-- TOC entry 522 (class 1259 OID 9444326)
-- Name: ano_letivo_modulo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.ano_letivo_modulo (
    ref_ano integer NOT NULL,
    ref_ref_cod_escola integer NOT NULL,
    sequencial integer NOT NULL,
    ref_cod_modulo integer NOT NULL,
    data_inicio date NOT NULL,
    data_fim date NOT NULL,
    dias_letivos numeric(5,0)
);


SET default_with_oids = false;

--
-- TOC entry 523 (class 1259 OID 9444329)
-- Name: auditoria_falta_componente_dispensa; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.auditoria_falta_componente_dispensa (
    id integer NOT NULL,
    ref_cod_matricula integer NOT NULL,
    ref_cod_componente_curricular integer NOT NULL,
    quantidade integer NOT NULL,
    etapa integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL
);


--
-- TOC entry 524 (class 1259 OID 9444332)
-- Name: auditoria_falta_componente_dispensa_id_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.auditoria_falta_componente_dispensa_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8165 (class 0 OID 0)
-- Dependencies: 524
-- Name: auditoria_falta_componente_dispensa_id_seq; Type: SEQUENCE OWNED BY; Schema: pmieducar; Owner: -
--

ALTER SEQUENCE pmieducar.auditoria_falta_componente_dispensa_id_seq OWNED BY pmieducar.auditoria_falta_componente_dispensa.id;


--
-- TOC entry 525 (class 1259 OID 9444334)
-- Name: auditoria_nota_dispensa; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.auditoria_nota_dispensa (
    id integer NOT NULL,
    ref_cod_matricula integer NOT NULL,
    ref_cod_componente_curricular integer NOT NULL,
    nota numeric(8,4) NOT NULL,
    etapa integer NOT NULL,
    nota_recuperacao character varying(10),
    nota_recuperacao_especifica character varying(10),
    data_cadastro timestamp without time zone NOT NULL
);


--
-- TOC entry 526 (class 1259 OID 9444337)
-- Name: auditoria_nota_dispensa_id_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.auditoria_nota_dispensa_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8166 (class 0 OID 0)
-- Dependencies: 526
-- Name: auditoria_nota_dispensa_id_seq; Type: SEQUENCE OWNED BY; Schema: pmieducar; Owner: -
--

ALTER SEQUENCE pmieducar.auditoria_nota_dispensa_id_seq OWNED BY pmieducar.auditoria_nota_dispensa.id;


SET default_with_oids = true;

--
-- TOC entry 527 (class 1259 OID 9444339)
-- Name: avaliacao_desempenho; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.avaliacao_desempenho (
    sequencial integer NOT NULL,
    ref_cod_servidor integer NOT NULL,
    ref_ref_cod_instituicao integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    descricao text NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    titulo_avaliacao character varying(255) NOT NULL
);


SET default_with_oids = false;

--
-- TOC entry 528 (class 1259 OID 9444346)
-- Name: backup; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.backup (
    id integer NOT NULL,
    caminho character varying(255) NOT NULL,
    data_backup timestamp without time zone
);


--
-- TOC entry 529 (class 1259 OID 9444349)
-- Name: backup_id_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.backup_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8167 (class 0 OID 0)
-- Dependencies: 529
-- Name: backup_id_seq; Type: SEQUENCE OWNED BY; Schema: pmieducar; Owner: -
--

ALTER SEQUENCE pmieducar.backup_id_seq OWNED BY pmieducar.backup.id;


--
-- TOC entry 530 (class 1259 OID 9444351)
-- Name: biblioteca_cod_biblioteca_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.biblioteca_cod_biblioteca_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 531 (class 1259 OID 9444353)
-- Name: biblioteca; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.biblioteca (
    cod_biblioteca integer DEFAULT nextval('pmieducar.biblioteca_cod_biblioteca_seq'::regclass) NOT NULL,
    ref_cod_instituicao integer,
    ref_cod_escola integer,
    nm_biblioteca character varying(255) NOT NULL,
    valor_multa double precision,
    max_emprestimo integer,
    valor_maximo_multa double precision,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    requisita_senha smallint DEFAULT (0)::smallint NOT NULL,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    dias_espera numeric(2,0),
    tombo_automatico boolean DEFAULT true,
    bloqueia_emprestimo_em_atraso boolean
);


--
-- TOC entry 532 (class 1259 OID 9444360)
-- Name: biblioteca_dia; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.biblioteca_dia (
    ref_cod_biblioteca integer NOT NULL,
    dia numeric(1,0) NOT NULL
);


--
-- TOC entry 533 (class 1259 OID 9444363)
-- Name: biblioteca_feriados_cod_feriado_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.biblioteca_feriados_cod_feriado_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 534 (class 1259 OID 9444365)
-- Name: biblioteca_feriados; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.biblioteca_feriados (
    cod_feriado integer DEFAULT nextval('pmieducar.biblioteca_feriados_cod_feriado_seq'::regclass) NOT NULL,
    ref_cod_biblioteca integer NOT NULL,
    nm_feriado character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    data_feriado date NOT NULL
);


--
-- TOC entry 535 (class 1259 OID 9444373)
-- Name: biblioteca_usuario; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.biblioteca_usuario (
    ref_cod_biblioteca integer NOT NULL,
    ref_cod_usuario integer NOT NULL
);


--
-- TOC entry 536 (class 1259 OID 9444376)
-- Name: bloqueio_ano_letivo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.bloqueio_ano_letivo (
    ref_cod_instituicao integer NOT NULL,
    ref_ano integer NOT NULL,
    data_inicio date NOT NULL,
    data_fim date NOT NULL
);


--
-- TOC entry 537 (class 1259 OID 9444379)
-- Name: bloqueio_lancamento_faltas_notas_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.bloqueio_lancamento_faltas_notas_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = false;

--
-- TOC entry 538 (class 1259 OID 9444381)
-- Name: bloqueio_lancamento_faltas_notas; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.bloqueio_lancamento_faltas_notas (
    cod_bloqueio integer DEFAULT nextval('public.bloqueio_lancamento_faltas_notas_seq'::regclass) NOT NULL,
    ano integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    etapa integer NOT NULL,
    data_inicio date NOT NULL,
    data_fim date NOT NULL
);


--
-- TOC entry 539 (class 1259 OID 9444385)
-- Name: calendario_ano_letivo_cod_calendario_ano_letivo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.calendario_ano_letivo_cod_calendario_ano_letivo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 540 (class 1259 OID 9444387)
-- Name: calendario_ano_letivo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.calendario_ano_letivo (
    cod_calendario_ano_letivo integer DEFAULT nextval('pmieducar.calendario_ano_letivo_cod_calendario_ano_letivo_seq'::regclass) NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ano integer NOT NULL,
    data_cadastra timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 541 (class 1259 OID 9444392)
-- Name: calendario_anotacao_cod_calendario_anotacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.calendario_anotacao_cod_calendario_anotacao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 542 (class 1259 OID 9444394)
-- Name: calendario_anotacao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.calendario_anotacao (
    cod_calendario_anotacao integer DEFAULT nextval('pmieducar.calendario_anotacao_cod_calendario_anotacao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_anotacao character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint NOT NULL
);


--
-- TOC entry 543 (class 1259 OID 9444401)
-- Name: calendario_dia; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.calendario_dia (
    ref_cod_calendario_ano_letivo integer NOT NULL,
    mes integer NOT NULL,
    dia integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_calendario_dia_motivo integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    descricao text
);


--
-- TOC entry 544 (class 1259 OID 9444408)
-- Name: calendario_dia_anotacao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.calendario_dia_anotacao (
    ref_dia integer NOT NULL,
    ref_mes integer NOT NULL,
    ref_ref_cod_calendario_ano_letivo integer NOT NULL,
    ref_cod_calendario_anotacao integer NOT NULL
);


--
-- TOC entry 545 (class 1259 OID 9444411)
-- Name: calendario_dia_motivo_cod_calendario_dia_motivo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.calendario_dia_motivo_cod_calendario_dia_motivo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 546 (class 1259 OID 9444413)
-- Name: calendario_dia_motivo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.calendario_dia_motivo (
    cod_calendario_dia_motivo integer DEFAULT nextval('pmieducar.calendario_dia_motivo_cod_calendario_dia_motivo_seq'::regclass) NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    sigla character varying(15) NOT NULL,
    descricao text,
    tipo character(1) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    nm_motivo character varying(255) NOT NULL
);


--
-- TOC entry 547 (class 1259 OID 9444421)
-- Name: candidato_reserva_vaga_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.candidato_reserva_vaga_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = false;

--
-- TOC entry 548 (class 1259 OID 9444423)
-- Name: candidato_reserva_vaga; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.candidato_reserva_vaga (
    cod_candidato_reserva_vaga integer DEFAULT nextval('pmieducar.candidato_reserva_vaga_seq'::regclass) NOT NULL,
    ano_letivo integer NOT NULL,
    data_solicitacao date NOT NULL,
    ref_cod_aluno integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    ref_cod_turno integer,
    ref_cod_pessoa_cad integer NOT NULL,
    data_cad timestamp without time zone DEFAULT now() NOT NULL,
    data_update timestamp without time zone DEFAULT now() NOT NULL,
    ref_cod_matricula integer,
    situacao character(1),
    data_situacao date,
    motivo character varying(255),
    ref_cod_escola integer,
    quantidade_membros smallint,
    mae_fez_pre_natal boolean DEFAULT false,
    membros_trabalham smallint,
    hora_solicitacao time without time zone
);


--
-- TOC entry 549 (class 1259 OID 9444430)
-- Name: categoria_nivel_cod_categoria_nivel_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.categoria_nivel_cod_categoria_nivel_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 550 (class 1259 OID 9444432)
-- Name: categoria_nivel; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.categoria_nivel (
    cod_categoria_nivel integer DEFAULT nextval('pmieducar.categoria_nivel_cod_categoria_nivel_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_categoria_nivel character varying(100) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo boolean DEFAULT true NOT NULL
);


--
-- TOC entry 551 (class 1259 OID 9444437)
-- Name: categoria_obra; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.categoria_obra (
    id integer NOT NULL,
    descricao character varying(100) NOT NULL,
    observacoes character varying(300)
);


--
-- TOC entry 552 (class 1259 OID 9444440)
-- Name: categoria_obra_id_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.categoria_obra_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8168 (class 0 OID 0)
-- Dependencies: 552
-- Name: categoria_obra_id_seq; Type: SEQUENCE OWNED BY; Schema: pmieducar; Owner: -
--

ALTER SEQUENCE pmieducar.categoria_obra_id_seq OWNED BY pmieducar.categoria_obra.id;


--
-- TOC entry 553 (class 1259 OID 9444442)
-- Name: cliente_cod_cliente_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.cliente_cod_cliente_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 554 (class 1259 OID 9444444)
-- Name: cliente; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.cliente (
    cod_cliente integer DEFAULT nextval('pmieducar.cliente_cod_cliente_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_idpes integer NOT NULL,
    login integer,
    senha character varying(255),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    observacoes text
);


--
-- TOC entry 555 (class 1259 OID 9444452)
-- Name: cliente_suspensao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.cliente_suspensao (
    sequencial integer NOT NULL,
    ref_cod_cliente integer NOT NULL,
    ref_cod_motivo_suspensao integer NOT NULL,
    ref_usuario_libera integer,
    ref_usuario_suspende integer NOT NULL,
    dias integer NOT NULL,
    data_suspensao timestamp without time zone NOT NULL,
    data_liberacao timestamp without time zone
);


--
-- TOC entry 556 (class 1259 OID 9444455)
-- Name: cliente_tipo_cod_cliente_tipo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.cliente_tipo_cod_cliente_tipo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 557 (class 1259 OID 9444457)
-- Name: cliente_tipo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.cliente_tipo (
    cod_cliente_tipo integer DEFAULT nextval('pmieducar.cliente_tipo_cod_cliente_tipo_seq'::regclass) NOT NULL,
    ref_cod_biblioteca integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


SET default_with_oids = false;

--
-- TOC entry 558 (class 1259 OID 9444465)
-- Name: cliente_tipo_cliente; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.cliente_tipo_cliente (
    ref_cod_cliente_tipo integer NOT NULL,
    ref_cod_cliente integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ref_usuario_cad integer NOT NULL,
    ref_usuario_exc integer,
    ativo smallint DEFAULT (1)::smallint,
    ref_cod_biblioteca integer
);


SET default_with_oids = true;

--
-- TOC entry 559 (class 1259 OID 9444469)
-- Name: cliente_tipo_exemplar_tipo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.cliente_tipo_exemplar_tipo (
    ref_cod_cliente_tipo integer NOT NULL,
    ref_cod_exemplar_tipo integer NOT NULL,
    dias_emprestimo numeric(3,0)
);


--
-- TOC entry 560 (class 1259 OID 9444472)
-- Name: coffebreak_tipo_cod_coffebreak_tipo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.coffebreak_tipo_cod_coffebreak_tipo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 561 (class 1259 OID 9444474)
-- Name: coffebreak_tipo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.coffebreak_tipo (
    cod_coffebreak_tipo integer DEFAULT nextval('pmieducar.coffebreak_tipo_cod_coffebreak_tipo_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    desc_tipo text,
    custo_unitario double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


SET default_with_oids = false;

--
-- TOC entry 562 (class 1259 OID 9444482)
-- Name: configuracoes_gerais; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.configuracoes_gerais (
    ref_cod_instituicao integer NOT NULL,
    permite_relacionamento_posvendas integer DEFAULT 1 NOT NULL,
    url_novo_educacao character varying(100),
    mostrar_codigo_inep_aluno smallint DEFAULT 1,
    justificativa_falta_documentacao_obrigatorio smallint DEFAULT 1,
    tamanho_min_rede_estadual integer,
    modelo_boletim_professor integer DEFAULT 1,
    custom_labels json,
    url_cadastro_usuario character varying(255) DEFAULT NULL::character varying,
    active_on_ieducar smallint DEFAULT 1,
    ieducar_image character varying(255) DEFAULT NULL::character varying,
    ieducar_entity_name character varying(255) DEFAULT NULL::character varying,
    ieducar_login_footer text DEFAULT '<p>Portabilis Tecnologia - suporte@portabilis.com.br - <a class="   light" href="http://suporte.portabilis.com.br" target="_blank"> Obter Suporte </a></p> '::character varying,
    ieducar_external_footer text DEFAULT '<p>Conhe&ccedil;a mais sobre o i-Educar e a Portabilis, acesse nosso <a href="   http://blog.portabilis.com.br">blog</a></p> '::character varying,
    ieducar_internal_footer text DEFAULT '<p>Conhe&ccedil;a mais sobre o i-Educar e a Portabilis, <a href="   http://blog.portabilis.com.br" target="_blank">acesse nosso blog</a> &nbsp;&nbsp;&nbsp; &copy; Portabilis - Todos os direitos reservados</p>'::character varying,
    facebook_url character varying(255) DEFAULT 'https://www.facebook.com/portabilis'::character varying,
    twitter_url character varying(255) DEFAULT 'https://twitter.com/portabilis'::character varying,
    linkedin_url character varying(255) DEFAULT 'https://www.linkedin.com/company/portabilis-tecnologia'::character varying,
    ieducar_suspension_message text
);


--
-- TOC entry 8169 (class 0 OID 0)
-- Dependencies: 562
-- Name: COLUMN configuracoes_gerais.mostrar_codigo_inep_aluno; Type: COMMENT; Schema: pmieducar; Owner: -
--

COMMENT ON COLUMN pmieducar.configuracoes_gerais.mostrar_codigo_inep_aluno IS 'Mostrar código INEP do aluno nas telas de cadastro';


--
-- TOC entry 8170 (class 0 OID 0)
-- Dependencies: 562
-- Name: COLUMN configuracoes_gerais.justificativa_falta_documentacao_obrigatorio; Type: COMMENT; Schema: pmieducar; Owner: -
--

COMMENT ON COLUMN pmieducar.configuracoes_gerais.justificativa_falta_documentacao_obrigatorio IS 'Campo "Justificativa para a falta de documentação" obrigatório no cadastro de alunos';


--
-- TOC entry 8171 (class 0 OID 0)
-- Dependencies: 562
-- Name: COLUMN configuracoes_gerais.tamanho_min_rede_estadual; Type: COMMENT; Schema: pmieducar; Owner: -
--

COMMENT ON COLUMN pmieducar.configuracoes_gerais.tamanho_min_rede_estadual IS 'Tamanho mínimo do campo "Código rede estadual"';


--
-- TOC entry 8172 (class 0 OID 0)
-- Dependencies: 562
-- Name: COLUMN configuracoes_gerais.modelo_boletim_professor; Type: COMMENT; Schema: pmieducar; Owner: -
--

COMMENT ON COLUMN pmieducar.configuracoes_gerais.modelo_boletim_professor IS 'Modelo do boletim do professor. 1 - Padrão, 2 - Modelo recuperação por etapa, 3 - Modelo recuperação paralela';


--
-- TOC entry 8173 (class 0 OID 0)
-- Dependencies: 562
-- Name: COLUMN configuracoes_gerais.custom_labels; Type: COMMENT; Schema: pmieducar; Owner: -
--

COMMENT ON COLUMN pmieducar.configuracoes_gerais.custom_labels IS 'Guarda customizações em labels e textos do sistema.';


--
-- TOC entry 8174 (class 0 OID 0)
-- Dependencies: 562
-- Name: COLUMN configuracoes_gerais.url_cadastro_usuario; Type: COMMENT; Schema: pmieducar; Owner: -
--

COMMENT ON COLUMN pmieducar.configuracoes_gerais.url_cadastro_usuario IS 'URL da ferramenta externa de cadastro de usuários';


--
-- TOC entry 563 (class 1259 OID 9444486)
-- Name: curso_cod_curso_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.curso_cod_curso_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 564 (class 1259 OID 9444488)
-- Name: curso; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.curso (
    cod_curso integer DEFAULT nextval('pmieducar.curso_cod_curso_seq'::regclass) NOT NULL,
    ref_usuario_cad integer NOT NULL,
    ref_cod_tipo_regime integer,
    ref_cod_nivel_ensino integer NOT NULL,
    ref_cod_tipo_ensino integer NOT NULL,
    nm_curso character varying(255) NOT NULL,
    sgl_curso character varying(15) NOT NULL,
    qtd_etapas smallint NOT NULL,
    carga_horaria double precision NOT NULL,
    ato_poder_publico character varying(255),
    objetivo_curso text,
    publico_alvo text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_usuario_exc integer,
    ref_cod_instituicao integer NOT NULL,
    padrao_ano_escolar smallint DEFAULT (0)::smallint NOT NULL,
    hora_falta double precision DEFAULT 0.00 NOT NULL,
    multi_seriado integer,
    modalidade_curso integer
);


--
-- TOC entry 565 (class 1259 OID 9444498)
-- Name: disciplina_cod_disciplina_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.disciplina_cod_disciplina_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 566 (class 1259 OID 9444500)
-- Name: disciplina; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.disciplina (
    cod_disciplina integer DEFAULT nextval('pmieducar.disciplina_cod_disciplina_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    desc_disciplina text,
    desc_resumida text,
    abreviatura character varying(15) NOT NULL,
    carga_horaria integer NOT NULL,
    apura_falta smallint DEFAULT (0)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    nm_disciplina character varying(255) NOT NULL,
    ref_cod_curso integer
);


SET default_with_oids = false;

--
-- TOC entry 567 (class 1259 OID 9444509)
-- Name: disciplina_dependencia; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.disciplina_dependencia (
    ref_cod_matricula integer NOT NULL,
    ref_cod_disciplina integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    observacao text,
    cod_disciplina_dependencia integer NOT NULL
);


--
-- TOC entry 568 (class 1259 OID 9444515)
-- Name: disciplina_serie; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.disciplina_serie (
    ref_cod_disciplina integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 569 (class 1259 OID 9444519)
-- Name: disciplina_topico_cod_disciplina_topico_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.disciplina_topico_cod_disciplina_topico_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 570 (class 1259 OID 9444521)
-- Name: disciplina_topico; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.disciplina_topico (
    cod_disciplina_topico integer DEFAULT nextval('pmieducar.disciplina_topico_cod_disciplina_topico_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_topico character varying(255) NOT NULL,
    desc_topico text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 851 (class 1259 OID 9474677)
-- Name: dispensa_disciplina_cod_dispensa_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.dispensa_disciplina_cod_dispensa_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = false;

--
-- TOC entry 571 (class 1259 OID 9444529)
-- Name: dispensa_disciplina; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.dispensa_disciplina (
    ref_cod_matricula integer NOT NULL,
    ref_cod_disciplina integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_tipo_dispensa integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    observacao text,
    cod_dispensa integer DEFAULT nextval('pmieducar.dispensa_disciplina_cod_dispensa_seq'::regclass) NOT NULL
);


--
-- TOC entry 572 (class 1259 OID 9444536)
-- Name: dispensa_etapa; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.dispensa_etapa (
    ref_cod_dispensa integer,
    etapa integer
);


--
-- TOC entry 573 (class 1259 OID 9444539)
-- Name: distribuicao_uniforme_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.distribuicao_uniforme_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 574 (class 1259 OID 9444541)
-- Name: distribuicao_uniforme; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.distribuicao_uniforme (
    cod_distribuicao_uniforme integer DEFAULT nextval('pmieducar.distribuicao_uniforme_seq'::regclass) NOT NULL,
    ref_cod_aluno integer NOT NULL,
    ano integer NOT NULL,
    kit_completo boolean,
    agasalho_qtd smallint,
    camiseta_curta_qtd smallint,
    camiseta_longa_qtd smallint,
    meias_qtd smallint,
    bermudas_tectels_qtd smallint,
    bermudas_coton_qtd smallint,
    tenis_qtd smallint,
    data date,
    agasalho_tm character varying(20),
    camiseta_curta_tm character varying(20),
    camiseta_longa_tm character varying(20),
    meias_tm character varying(20),
    bermudas_tectels_tm character varying(20),
    bermudas_coton_tm character varying(20),
    tenis_tm character varying(20),
    ref_cod_escola integer,
    camiseta_infantil_qtd smallint,
    camiseta_infantil_tm character varying(20)
);


--
-- TOC entry 575 (class 1259 OID 9444545)
-- Name: escola_cod_escola_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.escola_cod_escola_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 576 (class 1259 OID 9444547)
-- Name: escola; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.escola (
    cod_escola integer DEFAULT nextval('pmieducar.escola_cod_escola_seq'::regclass) NOT NULL,
    ref_usuario_cad integer NOT NULL,
    ref_usuario_exc integer,
    ref_cod_instituicao integer NOT NULL,
    ref_cod_escola_rede_ensino integer NOT NULL,
    ref_idpes integer,
    sigla character varying(20) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    bloquear_lancamento_diario_anos_letivos_encerrados integer,
    situacao_funcionamento integer DEFAULT 1,
    dependencia_administrativa integer DEFAULT 3,
    regulamentacao integer DEFAULT 1,
    longitude character varying(20),
    latitude character varying(20),
    acesso integer,
    ref_idpes_gestor integer,
    cargo_gestor integer,
    local_funcionamento integer,
    condicao integer DEFAULT 1,
    codigo_inep_escola_compartilhada integer,
    decreto_criacao character varying(50),
    area_terreno_total character varying(10),
    area_construida character varying(10),
    area_disponivel character varying(10),
    num_pavimentos integer,
    tipo_piso integer,
    medidor_energia integer,
    agua_consumida integer,
    dependencia_sala_diretoria integer,
    dependencia_sala_professores integer,
    dependencia_sala_secretaria integer,
    dependencia_laboratorio_informatica integer,
    dependencia_laboratorio_ciencias integer,
    dependencia_sala_aee integer,
    dependencia_quadra_coberta integer,
    dependencia_quadra_descoberta integer,
    dependencia_cozinha integer,
    dependencia_biblioteca integer,
    dependencia_sala_leitura integer,
    dependencia_parque_infantil integer,
    dependencia_bercario integer,
    dependencia_banheiro_fora integer,
    dependencia_banheiro_dentro integer,
    dependencia_banheiro_infantil integer,
    dependencia_banheiro_deficiente integer,
    dependencia_banheiro_chuveiro integer,
    dependencia_refeitorio integer,
    dependencia_dispensa integer,
    dependencia_aumoxarifado integer,
    dependencia_auditorio integer,
    dependencia_patio_coberto integer,
    dependencia_patio_descoberto integer,
    dependencia_alojamento_aluno integer,
    dependencia_alojamento_professor integer,
    dependencia_area_verde integer,
    dependencia_lavanderia integer,
    dependencia_unidade_climatizada integer,
    dependencia_quantidade_ambiente_climatizado integer,
    dependencia_nenhuma_relacionada integer,
    dependencia_numero_salas_existente integer,
    dependencia_numero_salas_utilizadas integer,
    porte_quadra_descoberta integer,
    porte_quadra_coberta integer,
    tipo_cobertura_patio integer,
    total_funcionario integer,
    atendimento_aee integer DEFAULT 0,
    atividade_complementar integer DEFAULT 0,
    fundamental_ciclo integer,
    localizacao_diferenciada integer DEFAULT 7,
    didatico_nao_utiliza integer,
    didatico_quilombola integer,
    didatico_indigena integer,
    educacao_indigena integer,
    lingua_ministrada integer,
    espaco_brasil_aprendizado integer,
    abre_final_semana integer,
    codigo_lingua_indigena integer,
    proposta_pedagogica integer,
    televisoes smallint,
    videocassetes smallint,
    dvds smallint,
    antenas_parabolicas smallint,
    copiadoras smallint,
    retroprojetores smallint,
    impressoras smallint,
    aparelhos_de_som smallint,
    projetores_digitais smallint,
    faxs smallint,
    maquinas_fotograficas smallint,
    computadores smallint,
    computadores_administrativo smallint,
    computadores_alunos smallint,
    acesso_internet smallint,
    ato_criacao character varying(255),
    dependencia_vias_deficiente smallint,
    utiliza_regra_diferenciada boolean,
    ato_autorizativo character varying(255),
    ref_idpes_secretario_escolar integer,
    impressoras_multifuncionais smallint,
    categoria_escola_privada integer,
    conveniada_com_poder_publico integer,
    cnpj_mantenedora_principal numeric(14,0),
    mantenedora_escola_privada integer[],
    materiais_didaticos_especificos integer,
    abastecimento_agua integer[],
    abastecimento_energia integer[],
    esgoto_sanitario integer[],
    destinacao_lixo integer[],
    email_gestor character varying(255),
    zona_localizacao smallint,
    codigo_inep_escola_compartilhada2 integer,
    codigo_inep_escola_compartilhada3 integer,
    codigo_inep_escola_compartilhada4 integer,
    codigo_inep_escola_compartilhada5 integer,
    codigo_inep_escola_compartilhada6 integer
);


--
-- TOC entry 577 (class 1259 OID 9444562)
-- Name: escola_ano_letivo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.escola_ano_letivo (
    ref_cod_escola integer NOT NULL,
    ano integer NOT NULL,
    ref_usuario_cad integer NOT NULL,
    ref_usuario_exc integer,
    andamento smallint DEFAULT (0)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    turmas_por_ano smallint
);


--
-- TOC entry 578 (class 1259 OID 9444567)
-- Name: escola_complemento; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.escola_complemento (
    ref_cod_escola integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    cep numeric(8,0) NOT NULL,
    numero numeric(6,0),
    complemento character varying(50),
    email character varying(50),
    nm_escola character varying(255) NOT NULL,
    municipio character varying(60) NOT NULL,
    bairro character varying(40) NOT NULL,
    logradouro character varying(150) NOT NULL,
    ddd_telefone numeric(2,0),
    telefone numeric(11,0),
    ddd_fax numeric(2,0),
    fax numeric(11,0),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 579 (class 1259 OID 9444574)
-- Name: escola_curso; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.escola_curso (
    ref_cod_escola integer NOT NULL,
    ref_cod_curso integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    autorizacao character varying(255),
    anos_letivos smallint[] DEFAULT '{}'::smallint[] NOT NULL
);


--
-- TOC entry 580 (class 1259 OID 9444578)
-- Name: escola_localizacao_cod_escola_localizacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.escola_localizacao_cod_escola_localizacao_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 581 (class 1259 OID 9444580)
-- Name: escola_localizacao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.escola_localizacao (
    cod_escola_localizacao integer DEFAULT nextval('pmieducar.escola_localizacao_cod_escola_localizacao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_localizacao character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


--
-- TOC entry 582 (class 1259 OID 9444585)
-- Name: escola_rede_ensino_cod_escola_rede_ensino_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.escola_rede_ensino_cod_escola_rede_ensino_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 583 (class 1259 OID 9444587)
-- Name: escola_rede_ensino; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.escola_rede_ensino (
    cod_escola_rede_ensino integer DEFAULT nextval('pmieducar.escola_rede_ensino_cod_escola_rede_ensino_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_rede character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


--
-- TOC entry 584 (class 1259 OID 9444592)
-- Name: escola_serie; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.escola_serie (
    ref_cod_escola integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    hora_inicial time without time zone,
    hora_final time without time zone,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    hora_inicio_intervalo time without time zone,
    hora_fim_intervalo time without time zone,
    bloquear_enturmacao_sem_vagas integer,
    bloquear_cadastro_turma_para_serie_com_vagas integer,
    anos_letivos smallint[] DEFAULT '{}'::smallint[] NOT NULL
);


SET default_with_oids = false;

--
-- TOC entry 585 (class 1259 OID 9444596)
-- Name: escola_serie_disciplina; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.escola_serie_disciplina (
    ref_ref_cod_serie integer NOT NULL,
    ref_ref_cod_escola integer NOT NULL,
    ref_cod_disciplina integer NOT NULL,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    carga_horaria numeric(7,3),
    etapas_especificas smallint,
    etapas_utilizadas character varying,
    updated_at timestamp without time zone DEFAULT now() NOT NULL,
    anos_letivos smallint[] DEFAULT '{}'::smallint[] NOT NULL
);


--
-- TOC entry 586 (class 1259 OID 9444603)
-- Name: escola_usuario; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.escola_usuario (
    id integer NOT NULL,
    ref_cod_usuario integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    escola_atual integer
);


--
-- TOC entry 587 (class 1259 OID 9444606)
-- Name: escola_usuario_id_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.escola_usuario_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8175 (class 0 OID 0)
-- Dependencies: 587
-- Name: escola_usuario_id_seq; Type: SEQUENCE OWNED BY; Schema: pmieducar; Owner: -
--

ALTER SEQUENCE pmieducar.escola_usuario_id_seq OWNED BY pmieducar.escola_usuario.id;


--
-- TOC entry 588 (class 1259 OID 9444608)
-- Name: exemplar_cod_exemplar_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.exemplar_cod_exemplar_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 589 (class 1259 OID 9444610)
-- Name: exemplar; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.exemplar (
    cod_exemplar integer DEFAULT nextval('pmieducar.exemplar_cod_exemplar_seq'::regclass) NOT NULL,
    ref_cod_fonte integer NOT NULL,
    ref_cod_motivo_baixa integer,
    ref_cod_acervo integer NOT NULL,
    ref_cod_situacao integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    permite_emprestimo smallint DEFAULT (1)::smallint NOT NULL,
    preco double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    data_aquisicao timestamp without time zone,
    tombo integer,
    sequencial integer,
    data_baixa_exemplar date
);


--
-- TOC entry 590 (class 1259 OID 9444616)
-- Name: exemplar_emprestimo_cod_emprestimo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.exemplar_emprestimo_cod_emprestimo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 591 (class 1259 OID 9444618)
-- Name: exemplar_emprestimo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.exemplar_emprestimo (
    cod_emprestimo integer DEFAULT nextval('pmieducar.exemplar_emprestimo_cod_emprestimo_seq'::regclass) NOT NULL,
    ref_usuario_devolucao integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_cliente integer NOT NULL,
    ref_cod_exemplar integer NOT NULL,
    data_retirada timestamp without time zone NOT NULL,
    data_devolucao timestamp without time zone,
    valor_multa double precision
);


--
-- TOC entry 592 (class 1259 OID 9444622)
-- Name: exemplar_tipo_cod_exemplar_tipo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.exemplar_tipo_cod_exemplar_tipo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 593 (class 1259 OID 9444624)
-- Name: exemplar_tipo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.exemplar_tipo (
    cod_exemplar_tipo integer DEFAULT nextval('pmieducar.exemplar_tipo_cod_exemplar_tipo_seq'::regclass) NOT NULL,
    ref_cod_biblioteca integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 594 (class 1259 OID 9444632)
-- Name: falta_aluno_cod_falta_aluno_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.falta_aluno_cod_falta_aluno_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = false;

--
-- TOC entry 595 (class 1259 OID 9444634)
-- Name: falta_aluno; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.falta_aluno (
    cod_falta_aluno integer DEFAULT nextval('pmieducar.falta_aluno_cod_falta_aluno_seq'::regclass) NOT NULL,
    ref_cod_disciplina integer,
    ref_cod_escola integer,
    ref_cod_serie integer,
    ref_cod_matricula integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    faltas integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    modulo smallint NOT NULL,
    ref_cod_curso_disciplina integer
);


--
-- TOC entry 596 (class 1259 OID 9444639)
-- Name: falta_atraso_cod_falta_atraso_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.falta_atraso_cod_falta_atraso_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 597 (class 1259 OID 9444641)
-- Name: falta_atraso; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.falta_atraso (
    cod_falta_atraso integer DEFAULT nextval('pmieducar.falta_atraso_cod_falta_atraso_seq'::regclass) NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_ref_cod_instituicao integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_servidor integer NOT NULL,
    tipo smallint NOT NULL,
    data_falta_atraso timestamp without time zone NOT NULL,
    qtd_horas integer,
    qtd_min integer,
    justificada smallint DEFAULT (0)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 598 (class 1259 OID 9444647)
-- Name: falta_atraso_compensado_cod_compensado_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.falta_atraso_compensado_cod_compensado_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 599 (class 1259 OID 9444649)
-- Name: falta_atraso_compensado; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.falta_atraso_compensado (
    cod_compensado integer DEFAULT nextval('pmieducar.falta_atraso_compensado_cod_compensado_seq'::regclass) NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_ref_cod_instituicao integer NOT NULL,
    ref_cod_servidor integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    data_inicio timestamp without time zone NOT NULL,
    data_fim timestamp without time zone NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 600 (class 1259 OID 9444654)
-- Name: faltas_sequencial_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.faltas_sequencial_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = false;

--
-- TOC entry 601 (class 1259 OID 9444656)
-- Name: faltas; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.faltas (
    ref_cod_matricula integer NOT NULL,
    sequencial integer DEFAULT nextval('pmieducar.faltas_sequencial_seq'::regclass) NOT NULL,
    ref_usuario_cad integer NOT NULL,
    falta integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL
);


--
-- TOC entry 602 (class 1259 OID 9444660)
-- Name: fonte_cod_fonte_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.fonte_cod_fonte_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 603 (class 1259 OID 9444662)
-- Name: fonte; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.fonte (
    cod_fonte integer DEFAULT nextval('pmieducar.fonte_cod_fonte_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_fonte character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer
);


--
-- TOC entry 604 (class 1259 OID 9444670)
-- Name: funcao_cod_funcao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.funcao_cod_funcao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 605 (class 1259 OID 9444672)
-- Name: funcao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.funcao (
    cod_funcao integer DEFAULT nextval('pmieducar.funcao_cod_funcao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_funcao character varying(255) NOT NULL,
    abreviatura character varying(30) NOT NULL,
    professor smallint DEFAULT (0)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


--
-- TOC entry 606 (class 1259 OID 9444678)
-- Name: habilitacao_cod_habilitacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.habilitacao_cod_habilitacao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 607 (class 1259 OID 9444680)
-- Name: habilitacao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.habilitacao (
    cod_habilitacao integer DEFAULT nextval('pmieducar.habilitacao_cod_habilitacao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


--
-- TOC entry 608 (class 1259 OID 9444688)
-- Name: habilitacao_curso; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.habilitacao_curso (
    ref_cod_habilitacao integer NOT NULL,
    ref_cod_curso integer NOT NULL
);


--
-- TOC entry 609 (class 1259 OID 9444691)
-- Name: historico_disciplinas; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.historico_disciplinas (
    sequencial integer NOT NULL,
    ref_ref_cod_aluno integer NOT NULL,
    ref_sequencial integer NOT NULL,
    nm_disciplina text NOT NULL,
    nota character varying(255) NOT NULL,
    faltas integer,
    import numeric(1,0),
    ordenamento integer,
    carga_horaria_disciplina integer,
    dependencia boolean DEFAULT false
);


SET default_with_oids = false;

--
-- TOC entry 610 (class 1259 OID 9444698)
-- Name: historico_educar; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.historico_educar (
    tabela character varying(50),
    alteracao text,
    data timestamp without time zone,
    insercao smallint DEFAULT 0
);


SET default_with_oids = true;

--
-- TOC entry 611 (class 1259 OID 9444705)
-- Name: historico_escolar; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.historico_escolar (
    ref_cod_aluno integer NOT NULL,
    sequencial integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ano integer NOT NULL,
    carga_horaria double precision,
    dias_letivos integer,
    escola character varying(255) NOT NULL,
    escola_cidade character varying(255) NOT NULL,
    escola_uf character varying(3),
    observacao text,
    aprovado smallint DEFAULT (1)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    faltas_globalizadas integer,
    nm_serie character varying(255),
    origem smallint DEFAULT (1)::smallint,
    extra_curricular smallint DEFAULT (0)::smallint,
    ref_cod_matricula integer,
    ref_cod_instituicao integer,
    import numeric(1,0),
    frequencia numeric(5,2) DEFAULT 0.000,
    registro character varying(50),
    livro character varying(50),
    folha character varying(50),
    historico_grade_curso_id integer,
    nm_curso character varying(255),
    aceleracao integer,
    ref_cod_escola integer,
    dependencia boolean,
    posicao integer
);


--
-- TOC entry 612 (class 1259 OID 9444716)
-- Name: historico_grade_curso_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.historico_grade_curso_seq
    START WITH 3
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 613 (class 1259 OID 9444718)
-- Name: historico_grade_curso; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.historico_grade_curso (
    id integer DEFAULT nextval('pmieducar.historico_grade_curso_seq'::regclass) NOT NULL,
    descricao_etapa character varying(20) NOT NULL,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone,
    quantidade_etapas integer,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 614 (class 1259 OID 9444723)
-- Name: infra_comodo_funcao_cod_infra_comodo_funcao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.infra_comodo_funcao_cod_infra_comodo_funcao_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 615 (class 1259 OID 9444725)
-- Name: infra_comodo_funcao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.infra_comodo_funcao (
    cod_infra_comodo_funcao integer DEFAULT nextval('pmieducar.infra_comodo_funcao_cod_infra_comodo_funcao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_funcao character varying(255) NOT NULL,
    desc_funcao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_escola integer
);


--
-- TOC entry 616 (class 1259 OID 9444733)
-- Name: infra_predio_cod_infra_predio_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.infra_predio_cod_infra_predio_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 617 (class 1259 OID 9444735)
-- Name: infra_predio; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.infra_predio (
    cod_infra_predio integer DEFAULT nextval('pmieducar.infra_predio_cod_infra_predio_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    nm_predio character varying(255) NOT NULL,
    desc_predio text,
    endereco text NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 618 (class 1259 OID 9444743)
-- Name: infra_predio_comodo_cod_infra_predio_comodo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.infra_predio_comodo_cod_infra_predio_comodo_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 619 (class 1259 OID 9444745)
-- Name: infra_predio_comodo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.infra_predio_comodo (
    cod_infra_predio_comodo integer DEFAULT nextval('pmieducar.infra_predio_comodo_cod_infra_predio_comodo_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_infra_comodo_funcao integer NOT NULL,
    ref_cod_infra_predio integer NOT NULL,
    nm_comodo character varying(255) NOT NULL,
    desc_comodo text,
    area double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 620 (class 1259 OID 9444753)
-- Name: instituicao_cod_instituicao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.instituicao_cod_instituicao_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 621 (class 1259 OID 9444755)
-- Name: instituicao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.instituicao (
    cod_instituicao integer DEFAULT nextval('pmieducar.instituicao_cod_instituicao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_idtlog character varying(20) NOT NULL,
    ref_sigla_uf character(2) NOT NULL,
    cep numeric(8,0) NOT NULL,
    cidade character varying(60) NOT NULL,
    bairro character varying(40) NOT NULL,
    logradouro character varying(255) NOT NULL,
    numero numeric(6,0),
    complemento character varying(50),
    nm_responsavel character varying(255) NOT NULL,
    ddd_telefone numeric(2,0),
    telefone numeric(11,0),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    nm_instituicao character varying(255) NOT NULL,
    data_base_remanejamento date,
    data_base_transferencia date,
    controlar_espaco_utilizacao_aluno smallint,
    percentagem_maxima_ocupacao_salas numeric(5,2),
    quantidade_alunos_metro_quadrado integer,
    exigir_vinculo_turma_professor smallint,
    gerar_historico_transferencia boolean,
    matricula_apenas_bairro_escola boolean,
    restringir_historico_escolar boolean,
    coordenador_transporte character varying,
    restringir_multiplas_enturmacoes boolean,
    permissao_filtro_abandono_transferencia boolean,
    data_base_matricula date,
    multiplas_reserva_vaga boolean DEFAULT false NOT NULL,
    reserva_integral_somente_com_renda boolean DEFAULT false NOT NULL,
    data_expiracao_reserva_vaga date,
    data_fechamento date,
    componente_curricular_turma boolean,
    reprova_dependencia_ano_concluinte boolean,
    controlar_posicao_historicos boolean,
    data_educacenso date,
    bloqueia_matricula_serie_nao_seguinte boolean,
    permitir_carga_horaria boolean DEFAULT false,
    exigir_dados_socioeconomicos boolean DEFAULT false,
    altera_atestado_para_declaracao boolean,
    orgao_regional integer,
    obrigar_campos_censo boolean,
    obrigar_documento_pessoa boolean DEFAULT false,
    exigir_lancamentos_anteriores boolean DEFAULT false,
    exibir_apenas_professores_alocados boolean DEFAULT false
);


--
-- TOC entry 8176 (class 0 OID 0)
-- Dependencies: 621
-- Name: COLUMN instituicao.exibir_apenas_professores_alocados; Type: COMMENT; Schema: pmieducar; Owner: -
--

COMMENT ON COLUMN pmieducar.instituicao.exibir_apenas_professores_alocados IS 'Para filtros de emissão de relatórios';


--
-- TOC entry 622 (class 1259 OID 9444767)
-- Name: instituicao_documentacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.instituicao_documentacao_seq
    START WITH 2
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = false;

--
-- TOC entry 623 (class 1259 OID 9444769)
-- Name: instituicao_documentacao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.instituicao_documentacao (
    id integer DEFAULT nextval('pmieducar.instituicao_documentacao_seq'::regclass) NOT NULL,
    instituicao_id integer NOT NULL,
    titulo_documento character varying(100) NOT NULL,
    url_documento character varying(255) NOT NULL,
    ref_usuario_cad integer DEFAULT 0 NOT NULL,
    ref_cod_escola integer
);


--
-- TOC entry 624 (class 1259 OID 9444774)
-- Name: material_didatico_cod_material_didatico_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.material_didatico_cod_material_didatico_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 625 (class 1259 OID 9444776)
-- Name: material_didatico; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.material_didatico (
    cod_material_didatico integer DEFAULT nextval('pmieducar.material_didatico_cod_material_didatico_seq'::regclass) NOT NULL,
    ref_cod_instituicao integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_material_tipo integer NOT NULL,
    nm_material character varying(255) NOT NULL,
    desc_material text,
    custo_unitario double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 626 (class 1259 OID 9444784)
-- Name: material_tipo_cod_material_tipo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.material_tipo_cod_material_tipo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 627 (class 1259 OID 9444786)
-- Name: material_tipo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.material_tipo (
    cod_material_tipo integer DEFAULT nextval('pmieducar.material_tipo_cod_material_tipo_seq'::regclass) NOT NULL,
    ref_usuario_cad integer NOT NULL,
    ref_usuario_exc integer,
    nm_tipo character varying(255) NOT NULL,
    desc_tipo text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


--
-- TOC entry 628 (class 1259 OID 9444794)
-- Name: matricula_cod_matricula_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.matricula_cod_matricula_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 629 (class 1259 OID 9444796)
-- Name: matricula; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.matricula (
    cod_matricula integer DEFAULT nextval('pmieducar.matricula_cod_matricula_seq'::regclass) NOT NULL,
    ref_cod_reserva_vaga integer,
    ref_ref_cod_escola integer,
    ref_ref_cod_serie integer,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_aluno integer NOT NULL,
    aprovado smallint DEFAULT (0)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ano integer NOT NULL,
    ultima_matricula smallint DEFAULT (0)::smallint NOT NULL,
    modulo smallint DEFAULT 1 NOT NULL,
    descricao_reclassificacao text,
    formando smallint DEFAULT (0)::smallint NOT NULL,
    matricula_reclassificacao smallint DEFAULT (0)::smallint,
    ref_cod_curso integer,
    matricula_transferencia boolean DEFAULT false NOT NULL,
    semestre smallint,
    observacao character varying(300),
    data_matricula timestamp without time zone,
    data_cancel timestamp without time zone,
    ref_cod_abandono_tipo integer,
    turno_pre_matricula smallint,
    dependencia boolean DEFAULT false,
    updated_at timestamp without time zone,
    saida_escola boolean DEFAULT false,
    data_saida_escola date,
    turno_id integer
);


--
-- TOC entry 630 (class 1259 OID 9444812)
-- Name: matricula_excessao_cod_aluno_excessao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.matricula_excessao_cod_aluno_excessao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = false;

--
-- TOC entry 631 (class 1259 OID 9444814)
-- Name: matricula_excessao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.matricula_excessao (
    cod_aluno_excessao integer DEFAULT nextval('pmieducar.matricula_excessao_cod_aluno_excessao_seq'::regclass) NOT NULL,
    ref_cod_matricula integer NOT NULL,
    ref_cod_turma integer NOT NULL,
    ref_sequencial integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_cod_disciplina integer NOT NULL,
    reprovado_faltas boolean NOT NULL,
    precisa_exame boolean NOT NULL,
    permite_exame boolean
);


--
-- TOC entry 632 (class 1259 OID 9444818)
-- Name: ocorrencia_disciplinar_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.ocorrencia_disciplinar_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 633 (class 1259 OID 9444820)
-- Name: matricula_ocorrencia_disciplinar; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.matricula_ocorrencia_disciplinar (
    ref_cod_matricula integer NOT NULL,
    ref_cod_tipo_ocorrencia_disciplinar integer NOT NULL,
    sequencial integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    observacao text NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    visivel_pais integer,
    cod_ocorrencia_disciplinar integer DEFAULT nextval('pmieducar.ocorrencia_disciplinar_seq'::regclass) NOT NULL
);


--
-- TOC entry 634 (class 1259 OID 9444828)
-- Name: matricula_turma; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.matricula_turma (
    ref_cod_matricula integer NOT NULL,
    ref_cod_turma integer NOT NULL,
    sequencial integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    data_enturmacao date NOT NULL,
    sequencial_fechamento integer DEFAULT 0 NOT NULL,
    transferido boolean,
    remanejado boolean,
    reclassificado boolean,
    abandono boolean,
    updated_at timestamp without time zone,
    falecido boolean,
    etapa_educacenso smallint,
    turma_unificada smallint
);


--
-- TOC entry 635 (class 1259 OID 9444833)
-- Name: menu_tipo_usuario; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.menu_tipo_usuario (
    ref_cod_tipo_usuario integer NOT NULL,
    ref_cod_menu_submenu integer NOT NULL,
    cadastra smallint DEFAULT 0 NOT NULL,
    visualiza smallint DEFAULT 0 NOT NULL,
    exclui smallint DEFAULT 0 NOT NULL
);


--
-- TOC entry 636 (class 1259 OID 9444839)
-- Name: modulo_cod_modulo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.modulo_cod_modulo_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 637 (class 1259 OID 9444841)
-- Name: modulo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.modulo (
    cod_modulo integer DEFAULT nextval('pmieducar.modulo_cod_modulo_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    descricao text,
    num_meses numeric(2,0) DEFAULT NULL::numeric,
    num_semanas integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL,
    num_etapas numeric(2,0) DEFAULT 0 NOT NULL
);


--
-- TOC entry 638 (class 1259 OID 9444849)
-- Name: motivo_afastamento_cod_motivo_afastamento_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.motivo_afastamento_cod_motivo_afastamento_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 639 (class 1259 OID 9444851)
-- Name: motivo_afastamento; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.motivo_afastamento (
    cod_motivo_afastamento integer DEFAULT nextval('pmieducar.motivo_afastamento_cod_motivo_afastamento_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_motivo character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


--
-- TOC entry 640 (class 1259 OID 9444859)
-- Name: motivo_baixa_cod_motivo_baixa_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.motivo_baixa_cod_motivo_baixa_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 641 (class 1259 OID 9444861)
-- Name: motivo_baixa; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.motivo_baixa (
    cod_motivo_baixa integer DEFAULT nextval('pmieducar.motivo_baixa_cod_motivo_baixa_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_motivo_baixa character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer
);


--
-- TOC entry 642 (class 1259 OID 9444869)
-- Name: motivo_suspensao_cod_motivo_suspensao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.motivo_suspensao_cod_motivo_suspensao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 643 (class 1259 OID 9444871)
-- Name: motivo_suspensao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.motivo_suspensao (
    cod_motivo_suspensao integer DEFAULT nextval('pmieducar.motivo_suspensao_cod_motivo_suspensao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_motivo character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer
);


--
-- TOC entry 644 (class 1259 OID 9444879)
-- Name: nivel_cod_nivel_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.nivel_cod_nivel_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = false;

--
-- TOC entry 645 (class 1259 OID 9444881)
-- Name: nivel; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.nivel (
    cod_nivel integer DEFAULT nextval('pmieducar.nivel_cod_nivel_seq'::regclass) NOT NULL,
    ref_cod_categoria_nivel integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_nivel_anterior integer,
    nm_nivel character varying(100) NOT NULL,
    salario_base double precision,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo boolean DEFAULT true NOT NULL
);


--
-- TOC entry 646 (class 1259 OID 9444886)
-- Name: nivel_ensino_cod_nivel_ensino_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.nivel_ensino_cod_nivel_ensino_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 647 (class 1259 OID 9444888)
-- Name: nivel_ensino; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.nivel_ensino (
    cod_nivel_ensino integer DEFAULT nextval('pmieducar.nivel_ensino_cod_nivel_ensino_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_nivel character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


--
-- TOC entry 648 (class 1259 OID 9444896)
-- Name: nota_aluno_cod_nota_aluno_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.nota_aluno_cod_nota_aluno_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = false;

--
-- TOC entry 649 (class 1259 OID 9444898)
-- Name: nota_aluno; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.nota_aluno (
    cod_nota_aluno integer DEFAULT nextval('pmieducar.nota_aluno_cod_nota_aluno_seq'::regclass) NOT NULL,
    ref_cod_disciplina integer,
    ref_cod_escola integer,
    ref_cod_serie integer,
    ref_cod_matricula integer NOT NULL,
    ref_sequencial integer,
    ref_ref_cod_tipo_avaliacao integer,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    modulo smallint NOT NULL,
    ref_cod_curso_disciplina integer,
    nota double precision
);


--
-- TOC entry 650 (class 1259 OID 9444903)
-- Name: operador_cod_operador_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.operador_cod_operador_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 651 (class 1259 OID 9444905)
-- Name: operador; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.operador (
    cod_operador integer DEFAULT nextval('pmieducar.operador_cod_operador_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nome character varying(50) NOT NULL,
    valor text NOT NULL,
    fim_sentenca smallint DEFAULT (1)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 652 (class 1259 OID 9444914)
-- Name: pagamento_multa_cod_pagamento_multa_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.pagamento_multa_cod_pagamento_multa_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 653 (class 1259 OID 9444916)
-- Name: pagamento_multa; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.pagamento_multa (
    cod_pagamento_multa integer DEFAULT nextval('pmieducar.pagamento_multa_cod_pagamento_multa_seq'::regclass) NOT NULL,
    ref_usuario_cad integer NOT NULL,
    ref_cod_cliente integer NOT NULL,
    valor_pago double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    ref_cod_biblioteca integer NOT NULL
);


--
-- TOC entry 654 (class 1259 OID 9444920)
-- Name: pre_requisito_cod_pre_requisito_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.pre_requisito_cod_pre_requisito_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 655 (class 1259 OID 9444922)
-- Name: pre_requisito; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.pre_requisito (
    cod_pre_requisito integer DEFAULT nextval('pmieducar.pre_requisito_cod_pre_requisito_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    schema_ character varying(50) NOT NULL,
    tabela character varying(50) NOT NULL,
    nome character varying(50) NOT NULL,
    sql text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 656 (class 1259 OID 9444930)
-- Name: projeto_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.projeto_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 657 (class 1259 OID 9444932)
-- Name: projeto; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.projeto (
    cod_projeto integer DEFAULT nextval('pmieducar.projeto_seq'::regclass) NOT NULL,
    nome character varying(50),
    observacao character varying(255)
);


--
-- TOC entry 658 (class 1259 OID 9444936)
-- Name: projeto_aluno; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.projeto_aluno (
    ref_cod_projeto integer NOT NULL,
    ref_cod_aluno integer NOT NULL,
    data_inclusao date,
    data_desligamento date,
    turno integer
);


--
-- TOC entry 659 (class 1259 OID 9444939)
-- Name: quadro_horario_cod_quadro_horario_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.quadro_horario_cod_quadro_horario_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 660 (class 1259 OID 9444941)
-- Name: quadro_horario; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.quadro_horario (
    cod_quadro_horario integer DEFAULT nextval('pmieducar.quadro_horario_cod_quadro_horario_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_turma integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ano integer
);


SET default_with_oids = false;

--
-- TOC entry 661 (class 1259 OID 9444946)
-- Name: quadro_horario_horarios; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.quadro_horario_horarios (
    ref_cod_quadro_horario integer NOT NULL,
    sequencial integer NOT NULL,
    ref_cod_disciplina integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    ref_cod_instituicao_substituto integer,
    ref_cod_instituicao_servidor integer NOT NULL,
    ref_servidor_substituto integer,
    ref_servidor integer NOT NULL,
    dia_semana integer NOT NULL,
    hora_inicial time without time zone NOT NULL,
    hora_final time without time zone NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 662 (class 1259 OID 9444950)
-- Name: quadro_horario_horarios_aux; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.quadro_horario_horarios_aux (
    ref_cod_quadro_horario integer NOT NULL,
    sequencial integer NOT NULL,
    ref_cod_disciplina integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    ref_cod_instituicao_servidor integer NOT NULL,
    ref_servidor integer NOT NULL,
    dia_semana integer NOT NULL,
    hora_inicial time without time zone NOT NULL,
    hora_final time without time zone NOT NULL,
    identificador character varying(30),
    data_cadastro timestamp without time zone NOT NULL
);


--
-- TOC entry 663 (class 1259 OID 9444953)
-- Name: quantidade_reserva_externa; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.quantidade_reserva_externa (
    ref_cod_instituicao integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_cod_curso integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    ref_turma_turno_id integer NOT NULL,
    ano integer NOT NULL,
    qtd_alunos integer NOT NULL
);


--
-- TOC entry 664 (class 1259 OID 9444956)
-- Name: relacao_categoria_acervo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.relacao_categoria_acervo (
    ref_cod_acervo integer NOT NULL,
    categoria_id integer NOT NULL
);


--
-- TOC entry 665 (class 1259 OID 9444959)
-- Name: religiao_cod_religiao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.religiao_cod_religiao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 666 (class 1259 OID 9444961)
-- Name: religiao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.religiao (
    cod_religiao integer DEFAULT nextval('pmieducar.religiao_cod_religiao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_religiao character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 667 (class 1259 OID 9444966)
-- Name: reserva_vaga_cod_reserva_vaga_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.reserva_vaga_cod_reserva_vaga_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 668 (class 1259 OID 9444968)
-- Name: reserva_vaga; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.reserva_vaga (
    cod_reserva_vaga integer DEFAULT nextval('pmieducar.reserva_vaga_cod_reserva_vaga_seq'::regclass) NOT NULL,
    ref_ref_cod_escola integer NOT NULL,
    ref_ref_cod_serie integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_aluno integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    nm_aluno character varying(255),
    cpf_responsavel numeric(11,0)
);


--
-- TOC entry 669 (class 1259 OID 9444973)
-- Name: reservas_cod_reserva_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.reservas_cod_reserva_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 670 (class 1259 OID 9444975)
-- Name: reservas; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.reservas (
    cod_reserva integer DEFAULT nextval('pmieducar.reservas_cod_reserva_seq'::regclass) NOT NULL,
    ref_usuario_libera integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_cliente integer NOT NULL,
    data_reserva timestamp without time zone,
    data_prevista_disponivel timestamp without time zone,
    data_retirada timestamp without time zone,
    ref_cod_exemplar integer NOT NULL,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 671 (class 1259 OID 9444980)
-- Name: sequencia_serie; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.sequencia_serie (
    ref_serie_origem integer NOT NULL,
    ref_serie_destino integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 672 (class 1259 OID 9444984)
-- Name: serie_cod_serie_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.serie_cod_serie_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 673 (class 1259 OID 9444986)
-- Name: serie; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.serie (
    cod_serie integer DEFAULT nextval('pmieducar.serie_cod_serie_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_curso integer NOT NULL,
    nm_serie character varying(255) NOT NULL,
    etapa_curso integer NOT NULL,
    concluinte smallint DEFAULT (0)::smallint NOT NULL,
    carga_horaria double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    intervalo integer,
    idade_inicial numeric(3,0),
    idade_final numeric(3,0),
    regra_avaliacao_id integer,
    observacao_historico character varying(100),
    dias_letivos integer,
    regra_avaliacao_diferenciada_id integer,
    alerta_faixa_etaria boolean,
    bloquear_matricula_faixa_etaria boolean,
    idade_ideal integer,
    exigir_inep boolean
);


--
-- TOC entry 674 (class 1259 OID 9444992)
-- Name: serie_pre_requisito; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.serie_pre_requisito (
    ref_cod_pre_requisito integer NOT NULL,
    ref_cod_operador integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    valor character varying
);


SET default_with_oids = false;

--
-- TOC entry 675 (class 1259 OID 9444998)
-- Name: serie_vaga; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.serie_vaga (
    ano integer NOT NULL,
    cod_serie_vaga integer NOT NULL,
    ref_cod_instituicao integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_cod_curso integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    vagas smallint NOT NULL,
    turno smallint DEFAULT 1 NOT NULL
);


SET default_with_oids = true;

--
-- TOC entry 676 (class 1259 OID 9445002)
-- Name: servidor; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.servidor (
    cod_servidor integer NOT NULL,
    ref_cod_instituicao integer NOT NULL,
    ref_idesco numeric(2,0),
    carga_horaria double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_subnivel integer,
    situacao_curso_superior_1 smallint,
    formacao_complementacao_pedagogica_1 smallint,
    codigo_curso_superior_1 integer,
    ano_inicio_curso_superior_1 numeric(4,0),
    ano_conclusao_curso_superior_1 numeric(4,0),
    instituicao_curso_superior_1 smallint,
    situacao_curso_superior_2 smallint,
    formacao_complementacao_pedagogica_2 smallint,
    codigo_curso_superior_2 integer,
    ano_inicio_curso_superior_2 numeric(4,0),
    ano_conclusao_curso_superior_2 numeric(4,0),
    instituicao_curso_superior_2 smallint,
    situacao_curso_superior_3 smallint,
    formacao_complementacao_pedagogica_3 smallint,
    codigo_curso_superior_3 integer,
    ano_inicio_curso_superior_3 numeric(4,0),
    ano_conclusao_curso_superior_3 numeric(4,0),
    instituicao_curso_superior_3 smallint,
    multi_seriado boolean,
    pos_graduacao integer[],
    curso_formacao_continuada integer[]
);


--
-- TOC entry 677 (class 1259 OID 9445006)
-- Name: servidor_afastamento; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.servidor_afastamento (
    ref_cod_servidor integer NOT NULL,
    sequencial integer NOT NULL,
    ref_ref_cod_instituicao integer NOT NULL,
    ref_cod_motivo_afastamento integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    data_retorno timestamp without time zone,
    data_saida timestamp without time zone NOT NULL,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 678 (class 1259 OID 9445010)
-- Name: servidor_alocacao_cod_servidor_alocacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.servidor_alocacao_cod_servidor_alocacao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 679 (class 1259 OID 9445012)
-- Name: servidor_alocacao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.servidor_alocacao (
    cod_servidor_alocacao integer DEFAULT nextval('pmieducar.servidor_alocacao_cod_servidor_alocacao_seq'::regclass) NOT NULL,
    ref_ref_cod_instituicao integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_cod_servidor integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    carga_horaria interval,
    periodo smallint DEFAULT (1)::smallint,
    hora_final time without time zone,
    hora_inicial time without time zone,
    dia_semana integer,
    ref_cod_servidor_funcao integer,
    ref_cod_funcionario_vinculo integer,
    ano integer,
    data_admissao date,
    hora_atividade time without time zone,
    horas_excedentes time without time zone
);


--
-- TOC entry 680 (class 1259 OID 9445018)
-- Name: servidor_curso_cod_servidor_curso_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.servidor_curso_cod_servidor_curso_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 681 (class 1259 OID 9445020)
-- Name: servidor_curso; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.servidor_curso (
    cod_servidor_curso integer DEFAULT nextval('pmieducar.servidor_curso_cod_servidor_curso_seq'::regclass) NOT NULL,
    ref_cod_formacao integer NOT NULL,
    data_conclusao timestamp without time zone NOT NULL,
    data_registro timestamp without time zone,
    diplomas_registros text
);


SET default_with_oids = false;

--
-- TOC entry 682 (class 1259 OID 9445027)
-- Name: servidor_curso_ministra; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.servidor_curso_ministra (
    ref_cod_curso integer NOT NULL,
    ref_ref_cod_instituicao integer NOT NULL,
    ref_cod_servidor integer NOT NULL
);


--
-- TOC entry 683 (class 1259 OID 9445030)
-- Name: servidor_disciplina; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.servidor_disciplina (
    ref_cod_disciplina integer NOT NULL,
    ref_ref_cod_instituicao integer NOT NULL,
    ref_cod_servidor integer NOT NULL,
    ref_cod_curso integer NOT NULL
);


--
-- TOC entry 684 (class 1259 OID 9445033)
-- Name: servidor_formacao_cod_formacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.servidor_formacao_cod_formacao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 685 (class 1259 OID 9445035)
-- Name: servidor_formacao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.servidor_formacao (
    cod_formacao integer DEFAULT nextval('pmieducar.servidor_formacao_cod_formacao_seq'::regclass) NOT NULL,
    ref_ref_cod_instituicao integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_servidor integer NOT NULL,
    nm_formacao character varying(255) NOT NULL,
    tipo character(1) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 686 (class 1259 OID 9445043)
-- Name: servidor_funcao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.servidor_funcao_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = false;

--
-- TOC entry 687 (class 1259 OID 9445045)
-- Name: servidor_funcao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.servidor_funcao (
    ref_ref_cod_instituicao integer NOT NULL,
    ref_cod_servidor integer NOT NULL,
    ref_cod_funcao integer NOT NULL,
    matricula character varying,
    cod_servidor_funcao integer DEFAULT nextval('pmieducar.servidor_funcao_seq'::regclass) NOT NULL
);


--
-- TOC entry 688 (class 1259 OID 9445052)
-- Name: servidor_titulo_concurso_cod_servidor_titulo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.servidor_titulo_concurso_cod_servidor_titulo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 689 (class 1259 OID 9445054)
-- Name: servidor_titulo_concurso; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.servidor_titulo_concurso (
    cod_servidor_titulo integer DEFAULT nextval('pmieducar.servidor_titulo_concurso_cod_servidor_titulo_seq'::regclass) NOT NULL,
    ref_cod_formacao integer NOT NULL,
    data_vigencia_homolog timestamp without time zone NOT NULL,
    data_publicacao timestamp without time zone NOT NULL
);


--
-- TOC entry 690 (class 1259 OID 9445058)
-- Name: situacao_cod_situacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.situacao_cod_situacao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 691 (class 1259 OID 9445060)
-- Name: situacao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.situacao (
    cod_situacao integer DEFAULT nextval('pmieducar.situacao_cod_situacao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_situacao character varying(255) NOT NULL,
    permite_emprestimo smallint DEFAULT (1)::smallint NOT NULL,
    descricao text,
    situacao_padrao smallint DEFAULT (0)::smallint NOT NULL,
    situacao_emprestada smallint DEFAULT (0)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer NOT NULL
);


--
-- TOC entry 692 (class 1259 OID 9445071)
-- Name: subnivel_cod_subnivel_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.subnivel_cod_subnivel_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = false;

--
-- TOC entry 693 (class 1259 OID 9445073)
-- Name: subnivel; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.subnivel (
    cod_subnivel integer DEFAULT nextval('pmieducar.subnivel_cod_subnivel_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_subnivel_anterior integer,
    ref_cod_nivel integer NOT NULL,
    nm_subnivel character varying(100),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo boolean DEFAULT true NOT NULL,
    salario double precision NOT NULL
);


--
-- TOC entry 694 (class 1259 OID 9445078)
-- Name: tipo_autor; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.tipo_autor (
    codigo integer,
    tipo_autor character varying(255)
);


--
-- TOC entry 695 (class 1259 OID 9445081)
-- Name: tipo_avaliacao_cod_tipo_avaliacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.tipo_avaliacao_cod_tipo_avaliacao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 696 (class 1259 OID 9445083)
-- Name: tipo_avaliacao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.tipo_avaliacao (
    cod_tipo_avaliacao integer DEFAULT nextval('pmieducar.tipo_avaliacao_cod_tipo_avaliacao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    conceitual smallint DEFAULT 1,
    ref_cod_instituicao integer NOT NULL
);


--
-- TOC entry 697 (class 1259 OID 9445089)
-- Name: tipo_avaliacao_valores; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.tipo_avaliacao_valores (
    ref_cod_tipo_avaliacao integer NOT NULL,
    sequencial integer NOT NULL,
    nome character varying(255) NOT NULL,
    valor double precision NOT NULL,
    valor_min double precision NOT NULL,
    valor_max double precision NOT NULL,
    ativo boolean DEFAULT true
);


--
-- TOC entry 698 (class 1259 OID 9445093)
-- Name: tipo_dispensa_cod_tipo_dispensa_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.tipo_dispensa_cod_tipo_dispensa_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 699 (class 1259 OID 9445095)
-- Name: tipo_dispensa; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.tipo_dispensa (
    cod_tipo_dispensa integer DEFAULT nextval('pmieducar.tipo_dispensa_cod_tipo_dispensa_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


--
-- TOC entry 700 (class 1259 OID 9445103)
-- Name: tipo_ensino_cod_tipo_ensino_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.tipo_ensino_cod_tipo_ensino_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 701 (class 1259 OID 9445105)
-- Name: tipo_ensino; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.tipo_ensino (
    cod_tipo_ensino integer DEFAULT nextval('pmieducar.tipo_ensino_cod_tipo_ensino_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL,
    atividade_complementar boolean DEFAULT false
);


--
-- TOC entry 702 (class 1259 OID 9445111)
-- Name: tipo_ocorrencia_disciplinar_cod_tipo_ocorrencia_disciplinar_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.tipo_ocorrencia_disciplinar_cod_tipo_ocorrencia_disciplinar_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 703 (class 1259 OID 9445113)
-- Name: tipo_ocorrencia_disciplinar; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.tipo_ocorrencia_disciplinar (
    cod_tipo_ocorrencia_disciplinar integer DEFAULT nextval('pmieducar.tipo_ocorrencia_disciplinar_cod_tipo_ocorrencia_disciplinar_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    descricao text,
    max_ocorrencias integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


--
-- TOC entry 704 (class 1259 OID 9445121)
-- Name: tipo_regime_cod_tipo_regime_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.tipo_regime_cod_tipo_regime_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 705 (class 1259 OID 9445123)
-- Name: tipo_regime; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.tipo_regime (
    cod_tipo_regime integer DEFAULT nextval('pmieducar.tipo_regime_cod_tipo_regime_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


--
-- TOC entry 706 (class 1259 OID 9445127)
-- Name: tipo_usuario_cod_tipo_usuario_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.tipo_usuario_cod_tipo_usuario_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 707 (class 1259 OID 9445129)
-- Name: tipo_usuario; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.tipo_usuario (
    cod_tipo_usuario integer DEFAULT nextval('pmieducar.tipo_usuario_cod_tipo_usuario_seq'::regclass) NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    ref_funcionario_exc integer,
    nm_tipo character varying(255) NOT NULL,
    descricao text,
    nivel integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 708 (class 1259 OID 9445137)
-- Name: transferencia_solicitacao_cod_transferencia_solicitacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.transferencia_solicitacao_cod_transferencia_solicitacao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 709 (class 1259 OID 9445139)
-- Name: transferencia_solicitacao; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.transferencia_solicitacao (
    cod_transferencia_solicitacao integer DEFAULT nextval('pmieducar.transferencia_solicitacao_cod_transferencia_solicitacao_seq'::regclass) NOT NULL,
    ref_cod_transferencia_tipo integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_matricula_entrada integer,
    ref_cod_matricula_saida integer NOT NULL,
    observacao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    data_transferencia timestamp without time zone,
    ref_cod_escola_destino integer,
    escola_destino_externa character varying,
    estado_escola_destino_externa character varying(60),
    municipio_escola_destino_externa character varying(60)
);


--
-- TOC entry 710 (class 1259 OID 9445147)
-- Name: transferencia_tipo_cod_transferencia_tipo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.transferencia_tipo_cod_transferencia_tipo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 711 (class 1259 OID 9445149)
-- Name: transferencia_tipo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.transferencia_tipo (
    cod_transferencia_tipo integer DEFAULT nextval('pmieducar.transferencia_tipo_cod_transferencia_tipo_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    desc_tipo text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer
);


--
-- TOC entry 712 (class 1259 OID 9445157)
-- Name: turma_cod_turma_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.turma_cod_turma_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 713 (class 1259 OID 9445159)
-- Name: turma; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.turma (
    cod_turma integer DEFAULT nextval('pmieducar.turma_cod_turma_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_ref_cod_serie integer,
    ref_ref_cod_escola integer,
    ref_cod_infra_predio_comodo integer,
    nm_turma character varying(255) NOT NULL,
    sgl_turma character varying(15),
    max_aluno integer NOT NULL,
    multiseriada smallint DEFAULT (0)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_turma_tipo integer NOT NULL,
    hora_inicial time without time zone,
    hora_final time without time zone,
    hora_inicio_intervalo time without time zone,
    hora_fim_intervalo time without time zone,
    ref_cod_regente integer,
    ref_cod_instituicao_regente integer,
    ref_cod_instituicao integer,
    ref_cod_curso integer,
    ref_ref_cod_serie_mult integer,
    ref_ref_cod_escola_mult integer,
    visivel boolean,
    tipo_boletim integer,
    turma_turno_id integer,
    ano integer,
    tipo_atendimento smallint,
    turma_mais_educacao smallint,
    atividade_complementar_1 integer,
    atividade_complementar_2 integer,
    atividade_complementar_3 integer,
    atividade_complementar_4 integer,
    atividade_complementar_5 integer,
    atividade_complementar_6 integer,
    aee_braille smallint,
    aee_recurso_optico smallint,
    aee_estrategia_desenvolvimento smallint,
    aee_tecnica_mobilidade smallint,
    aee_libras smallint,
    aee_caa smallint,
    aee_curricular smallint,
    aee_soroban smallint,
    aee_informatica smallint,
    aee_lingua_escrita smallint,
    aee_autonomia smallint,
    cod_curso_profissional integer,
    etapa_educacenso smallint,
    ref_cod_disciplina_dispensada integer,
    parecer_1_etapa text,
    parecer_2_etapa text,
    parecer_3_etapa text,
    parecer_4_etapa text,
    nao_informar_educacenso smallint,
    tipo_mediacao_didatico_pedagogico integer,
    dias_semana integer[],
    atividades_complementares integer[],
    atividades_aee integer[],
    tipo_boletim_diferenciado smallint
);


--
-- TOC entry 714 (class 1259 OID 9445171)
-- Name: turma_modulo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.turma_modulo (
    ref_cod_turma integer NOT NULL,
    ref_cod_modulo integer NOT NULL,
    sequencial integer NOT NULL,
    data_inicio date NOT NULL,
    data_fim date NOT NULL,
    dias_letivos integer
);


--
-- TOC entry 715 (class 1259 OID 9445174)
-- Name: turma_tipo_cod_turma_tipo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.turma_tipo_cod_turma_tipo_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 716 (class 1259 OID 9445176)
-- Name: turma_tipo; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.turma_tipo (
    cod_turma_tipo integer DEFAULT nextval('pmieducar.turma_tipo_cod_turma_tipo_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    sgl_tipo character varying(15) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer
);


--
-- TOC entry 717 (class 1259 OID 9445181)
-- Name: turma_turno_id_seq; Type: SEQUENCE; Schema: pmieducar; Owner: -
--

CREATE SEQUENCE pmieducar.turma_turno_id_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 718 (class 1259 OID 9445183)
-- Name: turma_turno; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.turma_turno (
    id integer DEFAULT nextval('pmieducar.turma_turno_id_seq'::regclass) NOT NULL,
    nome character varying(15) NOT NULL,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 719 (class 1259 OID 9445188)
-- Name: usuario; Type: TABLE; Schema: pmieducar; Owner: -
--

CREATE TABLE pmieducar.usuario (
    cod_usuario integer NOT NULL,
    ref_cod_instituicao integer,
    ref_funcionario_cad integer NOT NULL,
    ref_funcionario_exc integer,
    ref_cod_tipo_usuario integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 720 (class 1259 OID 9445192)
-- Name: v_matricula_matricula_turma; Type: VIEW; Schema: pmieducar; Owner: -
--

CREATE VIEW pmieducar.v_matricula_matricula_turma AS
 SELECT ma.cod_matricula,
    ma.ref_ref_cod_escola AS ref_cod_escola,
    ma.ref_ref_cod_serie AS ref_cod_serie,
    ma.ref_cod_aluno,
    ma.ref_cod_curso,
    mt.ref_cod_turma,
    ma.ano,
    ma.aprovado,
    ma.ultima_matricula,
    ma.modulo,
    mt.sequencial,
    ma.ativo,
    ( SELECT count(0) AS count
           FROM pmieducar.dispensa_disciplina dd
          WHERE (dd.ref_cod_matricula = ma.cod_matricula)) AS qtd_dispensa_disciplina,
    ( SELECT COALESCE((max(n.modulo))::integer, 0) AS "coalesce"
           FROM pmieducar.nota_aluno n
          WHERE ((n.ref_cod_matricula = ma.cod_matricula) AND (n.ativo = 1))) AS maior_modulo_com_nota
   FROM pmieducar.matricula ma,
    pmieducar.matricula_turma mt
  WHERE ((mt.ref_cod_matricula = ma.cod_matricula) AND (mt.ativo = ma.ativo));


--
-- TOC entry 721 (class 1259 OID 9445197)
-- Name: funcionario_su; Type: TABLE; Schema: pmiotopic; Owner: -
--

CREATE TABLE pmiotopic.funcionario_su (
    ref_ref_cod_pessoa_fj integer NOT NULL
);


--
-- TOC entry 722 (class 1259 OID 9445200)
-- Name: grupomoderador; Type: TABLE; Schema: pmiotopic; Owner: -
--

CREATE TABLE pmiotopic.grupomoderador (
    ref_ref_cod_pessoa_fj integer NOT NULL,
    ref_cod_grupos integer NOT NULL,
    ref_pessoa_exc integer,
    ref_pessoa_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 723 (class 1259 OID 9445204)
-- Name: grupopessoa; Type: TABLE; Schema: pmiotopic; Owner: -
--

CREATE TABLE pmiotopic.grupopessoa (
    ref_idpes integer NOT NULL,
    ref_cod_grupos integer NOT NULL,
    ref_grupos_exc integer,
    ref_pessoa_exc integer,
    ref_grupos_cad integer,
    ref_pessoa_cad integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_auxiliar_cad integer,
    ref_ref_cod_atendimento_cad integer
);


--
-- TOC entry 724 (class 1259 OID 9445208)
-- Name: grupos_cod_grupos_seq; Type: SEQUENCE; Schema: pmiotopic; Owner: -
--

CREATE SEQUENCE pmiotopic.grupos_cod_grupos_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 725 (class 1259 OID 9445210)
-- Name: grupos; Type: TABLE; Schema: pmiotopic; Owner: -
--

CREATE TABLE pmiotopic.grupos (
    cod_grupos integer DEFAULT nextval('pmiotopic.grupos_cod_grupos_seq'::regclass) NOT NULL,
    ref_pessoa_exc integer,
    ref_pessoa_cad integer NOT NULL,
    nm_grupo character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    atendimento smallint DEFAULT 0 NOT NULL
);


--
-- TOC entry 726 (class 1259 OID 9445216)
-- Name: notas; Type: TABLE; Schema: pmiotopic; Owner: -
--

CREATE TABLE pmiotopic.notas (
    sequencial integer NOT NULL,
    ref_idpes integer NOT NULL,
    ref_pessoa_exc integer,
    ref_pessoa_cad integer NOT NULL,
    nota text NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 727 (class 1259 OID 9445223)
-- Name: participante; Type: TABLE; Schema: pmiotopic; Owner: -
--

CREATE TABLE pmiotopic.participante (
    sequencial integer NOT NULL,
    ref_ref_cod_grupos integer NOT NULL,
    ref_ref_idpes integer NOT NULL,
    ref_cod_reuniao integer NOT NULL,
    data_chegada timestamp without time zone NOT NULL,
    data_saida timestamp without time zone
);


--
-- TOC entry 728 (class 1259 OID 9445226)
-- Name: reuniao_cod_reuniao_seq; Type: SEQUENCE; Schema: pmiotopic; Owner: -
--

CREATE SEQUENCE pmiotopic.reuniao_cod_reuniao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 729 (class 1259 OID 9445228)
-- Name: reuniao; Type: TABLE; Schema: pmiotopic; Owner: -
--

CREATE TABLE pmiotopic.reuniao (
    cod_reuniao integer DEFAULT nextval('pmiotopic.reuniao_cod_reuniao_seq'::regclass) NOT NULL,
    ref_grupos_moderador integer NOT NULL,
    ref_moderador integer NOT NULL,
    data_inicio_marcado timestamp without time zone NOT NULL,
    data_fim_marcado timestamp without time zone NOT NULL,
    data_inicio_real timestamp without time zone,
    data_fim_real timestamp without time zone,
    descricao text NOT NULL,
    email_enviado timestamp without time zone,
    publica smallint DEFAULT 0 NOT NULL
);


--
-- TOC entry 730 (class 1259 OID 9445236)
-- Name: topico_cod_topico_seq; Type: SEQUENCE; Schema: pmiotopic; Owner: -
--

CREATE SEQUENCE pmiotopic.topico_cod_topico_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 731 (class 1259 OID 9445238)
-- Name: topico; Type: TABLE; Schema: pmiotopic; Owner: -
--

CREATE TABLE pmiotopic.topico (
    cod_topico integer DEFAULT nextval('pmiotopic.topico_cod_topico_seq'::regclass) NOT NULL,
    ref_idpes_cad integer NOT NULL,
    ref_cod_grupos_cad integer NOT NULL,
    assunto character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_idpes_exc integer,
    ref_cod_grupos_exc integer
);


--
-- TOC entry 732 (class 1259 OID 9445243)
-- Name: topicoreuniao; Type: TABLE; Schema: pmiotopic; Owner: -
--

CREATE TABLE pmiotopic.topicoreuniao (
    ref_cod_topico integer NOT NULL,
    ref_cod_reuniao integer NOT NULL,
    parecer text,
    finalizado smallint,
    data_parecer timestamp without time zone
);


--
-- TOC entry 733 (class 1259 OID 9445249)
-- Name: acesso_cod_acesso_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.acesso_cod_acesso_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 734 (class 1259 OID 9445251)
-- Name: acesso; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.acesso (
    cod_acesso integer DEFAULT nextval('portal.acesso_cod_acesso_seq'::regclass) NOT NULL,
    data_hora timestamp without time zone NOT NULL,
    ip_externo character varying(50) DEFAULT ''::character varying NOT NULL,
    ip_interno character varying(255) DEFAULT ''::character varying NOT NULL,
    cod_pessoa integer DEFAULT 0 NOT NULL,
    obs text,
    sucesso boolean DEFAULT true NOT NULL
);


--
-- TOC entry 735 (class 1259 OID 9445262)
-- Name: agenda_cod_agenda_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.agenda_cod_agenda_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 736 (class 1259 OID 9445264)
-- Name: agenda; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.agenda (
    cod_agenda integer DEFAULT nextval('portal.agenda_cod_agenda_seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_exc integer,
    ref_ref_cod_pessoa_cad integer NOT NULL,
    nm_agenda character varying NOT NULL,
    publica smallint DEFAULT 0 NOT NULL,
    envia_alerta smallint DEFAULT 0 NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    data_edicao timestamp without time zone,
    ref_ref_cod_pessoa_own integer
);


--
-- TOC entry 737 (class 1259 OID 9445273)
-- Name: agenda_compromisso; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.agenda_compromisso (
    cod_agenda_compromisso integer NOT NULL,
    versao integer NOT NULL,
    ref_cod_agenda integer NOT NULL,
    ref_ref_cod_pessoa_cad integer NOT NULL,
    ativo smallint DEFAULT 1,
    data_inicio timestamp without time zone,
    titulo character varying,
    descricao text,
    importante smallint DEFAULT 0 NOT NULL,
    publico smallint DEFAULT 0 NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_fim timestamp without time zone
);


--
-- TOC entry 738 (class 1259 OID 9445282)
-- Name: agenda_pref_cod_comp_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.agenda_pref_cod_comp_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 739 (class 1259 OID 9445284)
-- Name: agenda_pref; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.agenda_pref (
    cod_comp integer DEFAULT nextval('portal.agenda_pref_cod_comp_seq'::regclass) NOT NULL,
    data_comp date NOT NULL,
    hora_comp time without time zone NOT NULL,
    hora_f_comp time without time zone NOT NULL,
    comp_comp text NOT NULL,
    local_comp character(1) DEFAULT 'I'::bpchar NOT NULL,
    publico_comp character(1) DEFAULT 'S'::bpchar NOT NULL,
    agenda_de character(1) DEFAULT 'P'::bpchar,
    ref_cad integer,
    versao integer DEFAULT 1 NOT NULL,
    ref_auto_cod integer
);


--
-- TOC entry 740 (class 1259 OID 9445295)
-- Name: agenda_responsavel; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.agenda_responsavel (
    ref_cod_agenda integer NOT NULL,
    ref_ref_cod_pessoa_fj integer NOT NULL,
    principal smallint
);


--
-- TOC entry 741 (class 1259 OID 9445298)
-- Name: compras_editais_editais_cod_compras_editais_editais_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.compras_editais_editais_cod_compras_editais_editais_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 742 (class 1259 OID 9445300)
-- Name: compras_editais_editais; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.compras_editais_editais (
    cod_compras_editais_editais integer DEFAULT nextval('portal.compras_editais_editais_cod_compras_editais_editais_seq'::regclass) NOT NULL,
    ref_cod_compras_licitacoes integer DEFAULT 0 NOT NULL,
    versao integer DEFAULT 0 NOT NULL,
    data_hora timestamp without time zone NOT NULL,
    arquivo character varying(255) DEFAULT ''::character varying NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    motivo_alteracao text,
    visivel smallint DEFAULT 1 NOT NULL
);


--
-- TOC entry 743 (class 1259 OID 9445312)
-- Name: compras_editais_editais_empresas; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.compras_editais_editais_empresas (
    ref_cod_compras_editais_editais integer DEFAULT 0 NOT NULL,
    ref_cod_compras_editais_empresa integer DEFAULT 0 NOT NULL,
    data_hora timestamp without time zone NOT NULL
);


--
-- TOC entry 744 (class 1259 OID 9445317)
-- Name: compras_editais_empresa_cod_compras_editais_empresa_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.compras_editais_empresa_cod_compras_editais_empresa_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 745 (class 1259 OID 9445319)
-- Name: compras_editais_empresa; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.compras_editais_empresa (
    cod_compras_editais_empresa integer DEFAULT nextval('portal.compras_editais_empresa_cod_compras_editais_empresa_seq'::regclass) NOT NULL,
    cnpj character varying(20) DEFAULT ''::character varying NOT NULL,
    nm_empresa character varying(255) DEFAULT ''::character varying NOT NULL,
    email character varying(255) DEFAULT ''::character varying NOT NULL,
    data_hora timestamp without time zone NOT NULL,
    endereco text,
    ref_sigla_uf character(2),
    cidade character varying(255),
    bairro character varying(255),
    telefone bigint,
    fax bigint,
    cep bigint,
    nome_contato character varying(255),
    senha character varying(32) DEFAULT ''::character varying NOT NULL
);


--
-- TOC entry 746 (class 1259 OID 9445330)
-- Name: compras_final_pregao_cod_compras_final_pregao_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.compras_final_pregao_cod_compras_final_pregao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 747 (class 1259 OID 9445332)
-- Name: compras_final_pregao; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.compras_final_pregao (
    cod_compras_final_pregao integer DEFAULT nextval('portal.compras_final_pregao_cod_compras_final_pregao_seq'::regclass) NOT NULL,
    nm_final character varying(255) DEFAULT ''::character varying NOT NULL
);


--
-- TOC entry 748 (class 1259 OID 9445337)
-- Name: compras_funcionarios; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.compras_funcionarios (
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL
);


--
-- TOC entry 749 (class 1259 OID 9445341)
-- Name: compras_licitacoes_cod_compras_licitacoes_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.compras_licitacoes_cod_compras_licitacoes_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 750 (class 1259 OID 9445343)
-- Name: compras_licitacoes; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.compras_licitacoes (
    cod_compras_licitacoes integer DEFAULT nextval('portal.compras_licitacoes_cod_compras_licitacoes_seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    ref_cod_compras_modalidade integer DEFAULT 0 NOT NULL,
    numero character varying(30) DEFAULT ''::character varying NOT NULL,
    objeto text NOT NULL,
    data_hora timestamp without time zone NOT NULL,
    cod_licitacao_semasa integer,
    oculto boolean DEFAULT false
);


--
-- TOC entry 751 (class 1259 OID 9445354)
-- Name: compras_modalidade_cod_compras_modalidade_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.compras_modalidade_cod_compras_modalidade_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 752 (class 1259 OID 9445356)
-- Name: compras_modalidade; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.compras_modalidade (
    cod_compras_modalidade integer DEFAULT nextval('portal.compras_modalidade_cod_compras_modalidade_seq'::regclass) NOT NULL,
    nm_modalidade character varying(255) DEFAULT ''::character varying NOT NULL
);


--
-- TOC entry 753 (class 1259 OID 9445361)
-- Name: compras_pregao_execucao_cod_compras_pregao_execucao_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.compras_pregao_execucao_cod_compras_pregao_execucao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 754 (class 1259 OID 9445363)
-- Name: compras_pregao_execucao; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.compras_pregao_execucao (
    cod_compras_pregao_execucao integer DEFAULT nextval('portal.compras_pregao_execucao_cod_compras_pregao_execucao_seq'::regclass) NOT NULL,
    ref_cod_compras_licitacoes integer DEFAULT 0 NOT NULL,
    ref_pregoeiro integer DEFAULT 0 NOT NULL,
    ref_equipe1 integer DEFAULT 0 NOT NULL,
    ref_equipe2 integer DEFAULT 0 NOT NULL,
    ref_equipe3 integer DEFAULT 0 NOT NULL,
    ano_processo integer,
    mes_processo integer,
    seq_processo integer,
    seq_portaria integer,
    ano_portaria integer,
    valor_referencia double precision,
    valor_real double precision,
    ref_cod_compras_final_pregao integer
);


--
-- TOC entry 755 (class 1259 OID 9445372)
-- Name: compras_prestacao_contas_cod_compras_prestacao_contas_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.compras_prestacao_contas_cod_compras_prestacao_contas_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 756 (class 1259 OID 9445374)
-- Name: compras_prestacao_contas; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.compras_prestacao_contas (
    cod_compras_prestacao_contas integer DEFAULT nextval('portal.compras_prestacao_contas_cod_compras_prestacao_contas_seq'::regclass) NOT NULL,
    caminho character varying(255) DEFAULT ''::character varying NOT NULL,
    mes integer DEFAULT 0 NOT NULL,
    ano integer DEFAULT 0 NOT NULL
);


--
-- TOC entry 757 (class 1259 OID 9445381)
-- Name: foto_portal_cod_foto_portal_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.foto_portal_cod_foto_portal_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 758 (class 1259 OID 9445383)
-- Name: foto_portal; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.foto_portal (
    cod_foto_portal integer DEFAULT nextval('portal.foto_portal_cod_foto_portal_seq'::regclass) NOT NULL,
    ref_cod_foto_secao integer,
    ref_cod_credito integer,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    data_foto timestamp without time zone,
    titulo character varying(255),
    descricao text,
    caminho character varying(255),
    altura integer,
    largura integer,
    nm_credito character varying(255),
    bkp_ref_secao bigint
);


--
-- TOC entry 759 (class 1259 OID 9445391)
-- Name: foto_secao_cod_foto_secao_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.foto_secao_cod_foto_secao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 760 (class 1259 OID 9445393)
-- Name: foto_secao; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.foto_secao (
    cod_foto_secao integer DEFAULT nextval('portal.foto_secao_cod_foto_secao_seq'::regclass) NOT NULL,
    nm_secao character varying(255)
);


--
-- TOC entry 761 (class 1259 OID 9445397)
-- Name: funcionario; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.funcionario (
    ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    matricula character varying(12),
    senha character varying(32),
    ativo smallint,
    ref_sec integer,
    ramal character varying(10),
    sequencial character(3),
    opcao_menu text,
    ref_cod_setor integer,
    ref_cod_funcionario_vinculo integer,
    tempo_expira_senha integer,
    tempo_expira_conta integer,
    data_troca_senha date,
    data_reativa_conta date,
    ref_ref_cod_pessoa_fj integer,
    proibido integer DEFAULT 0 NOT NULL,
    ref_cod_setor_new integer,
    matricula_new bigint,
    matricula_permanente smallint DEFAULT 0,
    tipo_menu smallint DEFAULT 0 NOT NULL,
    ip_logado character varying(50),
    data_login timestamp without time zone,
    email character varying(50),
    status_token character varying(50),
    matricula_interna character varying(30),
    receber_novidades smallint,
    atualizou_cadastro smallint
);


--
-- TOC entry 762 (class 1259 OID 9445407)
-- Name: funcionario_vinculo_cod_funcionario_vinculo_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.funcionario_vinculo_cod_funcionario_vinculo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 763 (class 1259 OID 9445409)
-- Name: funcionario_vinculo; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.funcionario_vinculo (
    cod_funcionario_vinculo integer DEFAULT nextval('portal.funcionario_vinculo_cod_funcionario_vinculo_seq'::regclass) NOT NULL,
    nm_vinculo character varying(255) DEFAULT ''::character varying NOT NULL,
    abreviatura character varying(16)
);


--
-- TOC entry 764 (class 1259 OID 9445414)
-- Name: imagem_cod_imagem_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.imagem_cod_imagem_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 765 (class 1259 OID 9445416)
-- Name: imagem; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.imagem (
    cod_imagem integer DEFAULT nextval('portal.imagem_cod_imagem_seq'::regclass) NOT NULL,
    ref_cod_imagem_tipo integer NOT NULL,
    caminho character varying(255) NOT NULL,
    nm_imagem character varying(100),
    extensao character(3) NOT NULL,
    altura integer,
    largura integer,
    data_cadastro timestamp without time zone NOT NULL,
    ref_cod_pessoa_cad integer NOT NULL,
    data_exclusao timestamp without time zone,
    ref_cod_pessoa_exc integer
);


--
-- TOC entry 766 (class 1259 OID 9445420)
-- Name: imagem_tipo_cod_imagem_tipo_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.imagem_tipo_cod_imagem_tipo_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 767 (class 1259 OID 9445422)
-- Name: imagem_tipo; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.imagem_tipo (
    cod_imagem_tipo integer DEFAULT nextval('portal.imagem_tipo_cod_imagem_tipo_seq'::regclass) NOT NULL,
    nm_tipo character varying(100) NOT NULL
);


--
-- TOC entry 768 (class 1259 OID 9445426)
-- Name: intranet_segur_permissao_nega_cod_intranet_segur_permissao__seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.intranet_segur_permissao_nega_cod_intranet_segur_permissao__seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 769 (class 1259 OID 9445428)
-- Name: intranet_segur_permissao_negada; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.intranet_segur_permissao_negada (
    cod_intranet_segur_permissao_negada integer DEFAULT nextval('portal.intranet_segur_permissao_nega_cod_intranet_segur_permissao__seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_fj integer,
    ip_externo character varying(15) DEFAULT ''::character varying NOT NULL,
    ip_interno character varying(255),
    data_hora timestamp without time zone NOT NULL,
    pagina character varying(255),
    variaveis text
);


--
-- TOC entry 770 (class 1259 OID 9445436)
-- Name: jor_arquivo; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.jor_arquivo (
    ref_cod_jor_edicao integer DEFAULT 0 NOT NULL,
    jor_arquivo smallint DEFAULT (0)::smallint NOT NULL,
    jor_caminho character varying(255) DEFAULT ''::character varying NOT NULL
);


--
-- TOC entry 771 (class 1259 OID 9445442)
-- Name: jor_edicao_cod_jor_edicao_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.jor_edicao_cod_jor_edicao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 772 (class 1259 OID 9445444)
-- Name: jor_edicao; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.jor_edicao (
    cod_jor_edicao integer DEFAULT nextval('portal.jor_edicao_cod_jor_edicao_seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    jor_ano_edicao character varying(5) DEFAULT ''::character varying NOT NULL,
    jor_edicao integer DEFAULT 0 NOT NULL,
    jor_dt_inicial date NOT NULL,
    jor_dt_final date,
    jor_extra smallint DEFAULT (0)::smallint
);


--
-- TOC entry 773 (class 1259 OID 9445452)
-- Name: mailling_email_cod_mailling_email_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.mailling_email_cod_mailling_email_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 774 (class 1259 OID 9445454)
-- Name: mailling_email; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.mailling_email (
    cod_mailling_email integer DEFAULT nextval('portal.mailling_email_cod_mailling_email_seq'::regclass) NOT NULL,
    nm_pessoa character varying(255) DEFAULT ''::character varying NOT NULL,
    email character varying(255) DEFAULT ''::character varying NOT NULL
);


--
-- TOC entry 775 (class 1259 OID 9445463)
-- Name: mailling_email_conteudo_cod_mailling_email_conteudo_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.mailling_email_conteudo_cod_mailling_email_conteudo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 776 (class 1259 OID 9445465)
-- Name: mailling_email_conteudo; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.mailling_email_conteudo (
    cod_mailling_email_conteudo integer DEFAULT nextval('portal.mailling_email_conteudo_cod_mailling_email_conteudo_seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    conteudo text NOT NULL,
    nm_remetente character varying(255),
    email_remetente character varying(255),
    assunto character varying(255)
);


--
-- TOC entry 777 (class 1259 OID 9445473)
-- Name: mailling_fila_envio_cod_mailling_fila_envio_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.mailling_fila_envio_cod_mailling_fila_envio_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 778 (class 1259 OID 9445475)
-- Name: mailling_fila_envio; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.mailling_fila_envio (
    cod_mailling_fila_envio integer DEFAULT nextval('portal.mailling_fila_envio_cod_mailling_fila_envio_seq'::regclass) NOT NULL,
    ref_cod_mailling_email_conteudo integer DEFAULT 0 NOT NULL,
    ref_cod_mailling_email integer,
    ref_ref_cod_pessoa_fj integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_envio timestamp without time zone
);


--
-- TOC entry 779 (class 1259 OID 9445480)
-- Name: mailling_grupo_cod_mailling_grupo_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.mailling_grupo_cod_mailling_grupo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 780 (class 1259 OID 9445482)
-- Name: mailling_grupo; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.mailling_grupo (
    cod_mailling_grupo integer DEFAULT nextval('portal.mailling_grupo_cod_mailling_grupo_seq'::regclass) NOT NULL,
    nm_grupo character varying(255) DEFAULT ''::character varying NOT NULL
);


--
-- TOC entry 781 (class 1259 OID 9445487)
-- Name: mailling_grupo_email; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.mailling_grupo_email (
    ref_cod_mailling_email integer DEFAULT 0 NOT NULL,
    ref_cod_mailling_grupo integer DEFAULT 0 NOT NULL
);


--
-- TOC entry 782 (class 1259 OID 9445492)
-- Name: mailling_historico_cod_mailling_historico_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.mailling_historico_cod_mailling_historico_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 783 (class 1259 OID 9445494)
-- Name: mailling_historico; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.mailling_historico (
    cod_mailling_historico integer DEFAULT nextval('portal.mailling_historico_cod_mailling_historico_seq'::regclass) NOT NULL,
    ref_cod_not_portal integer DEFAULT 0 NOT NULL,
    ref_cod_mailling_grupo integer DEFAULT 0 NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    data_hora timestamp without time zone NOT NULL
);


--
-- TOC entry 784 (class 1259 OID 9445501)
-- Name: menu_funcionario; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.menu_funcionario (
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    cadastra smallint DEFAULT (0)::smallint NOT NULL,
    exclui smallint DEFAULT (0)::smallint NOT NULL,
    ref_cod_menu_submenu integer DEFAULT 0 NOT NULL
);


--
-- TOC entry 785 (class 1259 OID 9445508)
-- Name: menu_menu_cod_menu_menu_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.menu_menu_cod_menu_menu_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 786 (class 1259 OID 9445510)
-- Name: menu_menu; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.menu_menu (
    cod_menu_menu integer DEFAULT nextval('portal.menu_menu_cod_menu_menu_seq'::regclass) NOT NULL,
    nm_menu character varying(255) DEFAULT ''::character varying NOT NULL,
    title character varying(255),
    ref_cod_menu_pai integer,
    caminho character varying(255) DEFAULT '#'::character varying,
    ord_menu integer DEFAULT 9999,
    ativo boolean DEFAULT true,
    icon_class character varying(20)
);


--
-- TOC entry 787 (class 1259 OID 9445521)
-- Name: menu_submenu_cod_menu_submenu_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.menu_submenu_cod_menu_submenu_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 788 (class 1259 OID 9445523)
-- Name: menu_submenu; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.menu_submenu (
    cod_menu_submenu integer DEFAULT nextval('portal.menu_submenu_cod_menu_submenu_seq'::regclass) NOT NULL,
    ref_cod_menu_menu integer,
    cod_sistema integer,
    nm_submenu character varying(255) DEFAULT ''::character varying NOT NULL,
    arquivo character varying(255) DEFAULT ''::character varying NOT NULL,
    title text,
    nivel smallint DEFAULT (3)::smallint NOT NULL
);


--
-- TOC entry 789 (class 1259 OID 9445533)
-- Name: not_portal_cod_not_portal_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.not_portal_cod_not_portal_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 790 (class 1259 OID 9445535)
-- Name: not_portal; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.not_portal (
    cod_not_portal integer DEFAULT nextval('portal.not_portal_cod_not_portal_seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    titulo character varying(255),
    descricao text,
    data_noticia timestamp without time zone NOT NULL
);


--
-- TOC entry 791 (class 1259 OID 9445543)
-- Name: not_portal_tipo; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.not_portal_tipo (
    ref_cod_not_portal integer DEFAULT 0 NOT NULL,
    ref_cod_not_tipo integer DEFAULT 0 NOT NULL
);


--
-- TOC entry 792 (class 1259 OID 9445548)
-- Name: not_tipo_cod_not_tipo_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.not_tipo_cod_not_tipo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 793 (class 1259 OID 9445550)
-- Name: not_tipo; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.not_tipo (
    cod_not_tipo integer DEFAULT nextval('portal.not_tipo_cod_not_tipo_seq'::regclass) NOT NULL,
    nm_tipo character varying(255) DEFAULT ''::character varying NOT NULL
);


--
-- TOC entry 794 (class 1259 OID 9445555)
-- Name: not_vinc_portal; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.not_vinc_portal (
    ref_cod_not_portal integer DEFAULT 0 NOT NULL,
    vic_num integer DEFAULT 0 NOT NULL,
    tipo character(1) DEFAULT 'F'::bpchar NOT NULL,
    cod_vinc integer,
    caminho character varying(255),
    nome_arquivo character varying(255)
);


--
-- TOC entry 795 (class 1259 OID 9445564)
-- Name: notificacao_cod_notificacao_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.notificacao_cod_notificacao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 796 (class 1259 OID 9445566)
-- Name: notificacao; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.notificacao (
    cod_notificacao integer DEFAULT nextval('portal.notificacao_cod_notificacao_seq'::regclass) NOT NULL,
    ref_cod_funcionario integer NOT NULL,
    titulo character varying,
    conteudo text,
    data_hora_ativa timestamp without time zone,
    url character varying,
    visualizacoes smallint DEFAULT 0 NOT NULL
);


--
-- TOC entry 797 (class 1259 OID 9445574)
-- Name: pessoa_atividade_cod_pessoa_atividade_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.pessoa_atividade_cod_pessoa_atividade_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 798 (class 1259 OID 9445576)
-- Name: pessoa_atividade; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.pessoa_atividade (
    cod_pessoa_atividade integer DEFAULT nextval('portal.pessoa_atividade_cod_pessoa_atividade_seq'::regclass) NOT NULL,
    ref_cod_ramo_atividade integer DEFAULT 0 NOT NULL,
    nm_atividade character varying(255)
);


--
-- TOC entry 799 (class 1259 OID 9445581)
-- Name: pessoa_fj_cod_pessoa_fj_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.pessoa_fj_cod_pessoa_fj_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 800 (class 1259 OID 9445583)
-- Name: pessoa_fj; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.pessoa_fj (
    cod_pessoa_fj integer DEFAULT nextval('portal.pessoa_fj_cod_pessoa_fj_seq'::regclass) NOT NULL,
    nm_pessoa character varying(255) DEFAULT ''::character varying NOT NULL,
    id_federal character varying(30),
    endereco text,
    cep character varying(9),
    ref_bairro integer,
    ddd_telefone_1 integer,
    telefone_1 character varying(15),
    ddd_telefone_2 integer,
    telefone_2 character varying(15),
    ddd_telefone_mov integer,
    telefone_mov character varying(15),
    ddd_telefone_fax integer,
    telefone_fax character varying(15),
    email character varying(255),
    http character varying(255),
    tipo_pessoa character(1) DEFAULT 'F'::bpchar NOT NULL,
    sexo smallint,
    razao_social character varying(255),
    ins_est character varying(30),
    ins_mun character varying(30),
    rg character varying(30),
    ref_cod_pessoa_pai integer,
    ref_cod_pessoa_mae integer,
    data_nasc date,
    ref_ref_cod_pessoa_fj integer
);


--
-- TOC entry 801 (class 1259 OID 9445592)
-- Name: pessoa_fj_pessoa_atividade; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.pessoa_fj_pessoa_atividade (
    ref_cod_pessoa_atividade integer DEFAULT 0 NOT NULL,
    ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL
);


--
-- TOC entry 802 (class 1259 OID 9445597)
-- Name: pessoa_ramo_atividade_cod_ramo_atividade_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.pessoa_ramo_atividade_cod_ramo_atividade_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 803 (class 1259 OID 9445599)
-- Name: pessoa_ramo_atividade; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.pessoa_ramo_atividade (
    cod_ramo_atividade integer DEFAULT nextval('portal.pessoa_ramo_atividade_cod_ramo_atividade_seq'::regclass) NOT NULL,
    nm_ramo_atividade character varying(255)
);


--
-- TOC entry 804 (class 1259 OID 9445603)
-- Name: portal_banner_cod_portal_banner_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.portal_banner_cod_portal_banner_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 805 (class 1259 OID 9445605)
-- Name: portal_concurso_cod_portal_concurso_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.portal_concurso_cod_portal_concurso_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 806 (class 1259 OID 9445607)
-- Name: portal_concurso; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.portal_concurso (
    cod_portal_concurso integer DEFAULT nextval('portal.portal_concurso_cod_portal_concurso_seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    nm_concurso character varying(255) DEFAULT ''::character varying NOT NULL,
    descricao text,
    caminho character varying(255) DEFAULT ''::character varying NOT NULL,
    tipo_arquivo character(3) DEFAULT ''::bpchar NOT NULL,
    data_hora timestamp without time zone
);


--
-- TOC entry 807 (class 1259 OID 9445618)
-- Name: sistema_cod_sistema_seq; Type: SEQUENCE; Schema: portal; Owner: -
--

CREATE SEQUENCE portal.sistema_cod_sistema_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 808 (class 1259 OID 9445620)
-- Name: sistema; Type: TABLE; Schema: portal; Owner: -
--

CREATE TABLE portal.sistema (
    cod_sistema integer DEFAULT nextval('portal.sistema_cod_sistema_seq'::regclass) NOT NULL,
    nome character varying(255),
    versao smallint NOT NULL,
    release smallint NOT NULL,
    patch smallint NOT NULL,
    tipo character varying(255)
);


--
-- TOC entry 809 (class 1259 OID 9445627)
-- Name: v_funcionario; Type: VIEW; Schema: portal; Owner: -
--

CREATE VIEW portal.v_funcionario AS
 SELECT f.ref_cod_pessoa_fj,
    f.matricula,
    f.matricula_interna,
    f.senha,
    f.ativo,
    f.ramal,
    f.sequencial,
    f.opcao_menu,
    f.ref_cod_setor,
    f.ref_cod_funcionario_vinculo,
    f.tempo_expira_senha,
    f.tempo_expira_conta,
    f.data_troca_senha,
    f.data_reativa_conta,
    f.ref_ref_cod_pessoa_fj,
    f.proibido,
    f.ref_cod_setor_new,
    f.email,
    ( SELECT pessoa.nome
           FROM cadastro.pessoa
          WHERE (pessoa.idpes = (f.ref_cod_pessoa_fj)::numeric)) AS nome
   FROM portal.funcionario f;


--
-- TOC entry 810 (class 1259 OID 9445632)
-- Name: bairro_regiao; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.bairro_regiao (
    ref_cod_regiao integer NOT NULL,
    ref_idbai integer NOT NULL
);


SET default_with_oids = false;

--
-- TOC entry 811 (class 1259 OID 9445635)
-- Name: changelog; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.changelog (
    change_number bigint NOT NULL,
    delta_set character varying(10) NOT NULL,
    start_dt timestamp without time zone NOT NULL,
    complete_dt timestamp without time zone,
    applied_by character varying(100) NOT NULL,
    description character varying(500) NOT NULL
);


SET default_with_oids = true;

--
-- TOC entry 812 (class 1259 OID 9445641)
-- Name: distrito; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.distrito (
    idmun numeric(6,0) NOT NULL,
    geom character varying,
    iddis numeric(6,0) DEFAULT nextval(('public.seq_distrito'::text)::regclass) NOT NULL,
    nome character varying(80) NOT NULL,
    cod_ibge character varying(7),
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_distrito_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_distrito_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


--
-- TOC entry 813 (class 1259 OID 9445650)
-- Name: logradouro_fonetico; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.logradouro_fonetico (
    fonema character varying(30) NOT NULL,
    idlog numeric(8,0) NOT NULL
);


--
-- TOC entry 814 (class 1259 OID 9445653)
-- Name: pais; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.pais (
    idpais numeric(3,0) NOT NULL,
    nome character varying(60) NOT NULL,
    geom character varying,
    cod_ibge integer
);


SET default_with_oids = false;

--
-- TOC entry 815 (class 1259 OID 9445659)
-- Name: pghero_query_stats; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.pghero_query_stats (
    id integer NOT NULL,
    database text,
    "user" text,
    query text,
    query_hash bigint,
    total_time double precision,
    calls bigint,
    captured_at timestamp without time zone
);


--
-- TOC entry 816 (class 1259 OID 9445665)
-- Name: pghero_query_stats_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.pghero_query_stats_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 8177 (class 0 OID 0)
-- Dependencies: 816
-- Name: pghero_query_stats_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.pghero_query_stats_id_seq OWNED BY public.pghero_query_stats.id;


--
-- TOC entry 200 (class 1259 OID 9442746)
-- Name: phinxlog; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.phinxlog (
    version bigint NOT NULL,
    migration_name character varying(100),
    start_time timestamp without time zone,
    end_time timestamp without time zone,
    breakpoint boolean DEFAULT false NOT NULL
);


--
-- TOC entry 817 (class 1259 OID 9445667)
-- Name: portal_banner_cod_portal_banner_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.portal_banner_cod_portal_banner_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 818 (class 1259 OID 9445669)
-- Name: portal_banner; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.portal_banner (
    cod_portal_banner integer DEFAULT nextval('public.portal_banner_cod_portal_banner_seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    caminho character varying(255) DEFAULT ''::character varying NOT NULL,
    title character varying(255),
    prioridade integer DEFAULT 0 NOT NULL,
    link character varying(255) DEFAULT ''::character varying NOT NULL,
    lateral_ smallint DEFAULT (1)::smallint NOT NULL
);


--
-- TOC entry 819 (class 1259 OID 9445681)
-- Name: regiao_cod_regiao_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.regiao_cod_regiao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


SET default_with_oids = true;

--
-- TOC entry 820 (class 1259 OID 9445683)
-- Name: regiao; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.regiao (
    cod_regiao integer DEFAULT nextval('public.regiao_cod_regiao_seq'::regclass) NOT NULL,
    nm_regiao character varying(100)
);


--
-- TOC entry 821 (class 1259 OID 9445687)
-- Name: seq_bairro; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.seq_bairro
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 822 (class 1259 OID 9445689)
-- Name: seq_distrito; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.seq_distrito
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 823 (class 1259 OID 9445691)
-- Name: seq_logradouro; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.seq_logradouro
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 824 (class 1259 OID 9445693)
-- Name: seq_municipio; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.seq_municipio
    START WITH 5565
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 825 (class 1259 OID 9445695)
-- Name: seq_setor_bai; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.seq_setor_bai
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 826 (class 1259 OID 9445697)
-- Name: setor_idset_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.setor_idset_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 827 (class 1259 OID 9445699)
-- Name: setor; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.setor (
    idset integer DEFAULT nextval('public.setor_idset_seq'::regclass) NOT NULL,
    nivel numeric(1,0) NOT NULL,
    nome character varying(100) NOT NULL,
    sigla character varying(25),
    idsetsub integer,
    idsetredir integer,
    situacao character(1) NOT NULL,
    localizacao character(1) NOT NULL,
    CONSTRAINT ck_setor_localizacao CHECK (((localizacao = 'E'::bpchar) OR (localizacao = 'I'::bpchar))),
    CONSTRAINT ck_setor_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


--
-- TOC entry 828 (class 1259 OID 9445705)
-- Name: setor_bai; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.setor_bai (
    idsetorbai numeric(6,0) DEFAULT nextval(('public.seq_setor_bai'::text)::regclass) NOT NULL,
    nome character varying(80) NOT NULL
);


--
-- TOC entry 829 (class 1259 OID 9445709)
-- Name: uf; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.uf (
    sigla_uf character varying(3) NOT NULL,
    nome character varying(30) NOT NULL,
    geom character varying,
    idpais numeric(3,0),
    cod_ibge numeric(6,0)
);


--
-- TOC entry 830 (class 1259 OID 9445715)
-- Name: vila; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.vila (
    idvil numeric(4,0) NOT NULL,
    idmun numeric(6,0) NOT NULL,
    nome character varying(50) NOT NULL,
    geom character varying
);


--
-- TOC entry 848 (class 1259 OID 9474521)
-- Name: view_componente_curricular; Type: VIEW; Schema: relatorio; Owner: -
--

CREATE VIEW relatorio.view_componente_curricular AS
( SELECT escola_serie_disciplina.ref_cod_disciplina AS id,
    turma.cod_turma,
    componente_curricular.nome,
    componente_curricular.abreviatura,
    componente_curricular.ordenamento,
    componente_curricular.area_conhecimento_id,
    escola_serie_disciplina.etapas_especificas,
    escola_serie_disciplina.etapas_utilizadas,
    escola_serie_disciplina.carga_horaria
   FROM (((pmieducar.turma
     JOIN pmieducar.escola_serie_disciplina ON (((escola_serie_disciplina.ref_ref_cod_serie = turma.ref_ref_cod_serie) AND (escola_serie_disciplina.ref_ref_cod_escola = turma.ref_ref_cod_escola) AND (escola_serie_disciplina.ativo = 1) AND (turma.ano = ANY (escola_serie_disciplina.anos_letivos)))))
     JOIN modules.componente_curricular ON (((componente_curricular.id = escola_serie_disciplina.ref_cod_disciplina) AND (( SELECT count(cct.componente_curricular_id) AS count
           FROM modules.componente_curricular_turma cct
          WHERE (cct.turma_id = turma.cod_turma)) = 0))))
     JOIN modules.area_conhecimento ON ((area_conhecimento.id = componente_curricular.area_conhecimento_id)))
  ORDER BY area_conhecimento.ordenamento_ac, area_conhecimento.nome, componente_curricular.ordenamento, componente_curricular.nome)
UNION ALL
( SELECT componente_curricular_turma.componente_curricular_id AS id,
    componente_curricular_turma.turma_id AS cod_turma,
    componente_curricular.nome,
    componente_curricular.abreviatura,
    componente_curricular.ordenamento,
    componente_curricular.area_conhecimento_id,
    componente_curricular_turma.etapas_especificas,
    componente_curricular_turma.etapas_utilizadas,
    componente_curricular_turma.carga_horaria
   FROM ((modules.componente_curricular_turma
     JOIN modules.componente_curricular ON ((componente_curricular.id = componente_curricular_turma.componente_curricular_id)))
     JOIN modules.area_conhecimento ON ((area_conhecimento.id = componente_curricular.area_conhecimento_id)))
  ORDER BY area_conhecimento.ordenamento_ac, area_conhecimento.nome, componente_curricular.ordenamento, componente_curricular.nome);


SET default_with_oids = false;

--
-- TOC entry 832 (class 1259 OID 9445724)
-- Name: aluno_cod_aluno; Type: TABLE; Schema: serieciasc; Owner: -
--

CREATE TABLE serieciasc.aluno_cod_aluno (
    cod_aluno integer NOT NULL,
    cod_ciasc bigint NOT NULL,
    user_id integer,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


--
-- TOC entry 833 (class 1259 OID 9445727)
-- Name: aluno_uniforme; Type: TABLE; Schema: serieciasc; Owner: -
--

CREATE TABLE serieciasc.aluno_uniforme (
    ref_cod_aluno integer NOT NULL,
    data_recebimento timestamp without time zone NOT NULL,
    camiseta character(2),
    quantidade_camiseta integer,
    bermuda character(2),
    quantidade_bermuda integer,
    jaqueta character(2),
    quantidade_jaqueta integer,
    calca character(2),
    quantidade_calca integer,
    meia character(2),
    quantidade_meia integer,
    tenis character(2),
    quantidade_tenis integer,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


--
-- TOC entry 834 (class 1259 OID 9445730)
-- Name: escola_agua; Type: TABLE; Schema: serieciasc; Owner: -
--

CREATE TABLE serieciasc.escola_agua (
    ref_cod_escola integer NOT NULL,
    rede_publica integer DEFAULT 0,
    poco_artesiano integer DEFAULT 0,
    cisterna integer DEFAULT 0,
    fonte_rio integer DEFAULT 0,
    inexistente integer DEFAULT 0,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


--
-- TOC entry 835 (class 1259 OID 9445738)
-- Name: escola_energia; Type: TABLE; Schema: serieciasc; Owner: -
--

CREATE TABLE serieciasc.escola_energia (
    ref_cod_escola integer NOT NULL,
    rede_publica integer DEFAULT 0,
    gerador_proprio integer DEFAULT 0,
    solar integer DEFAULT 0,
    eolica integer DEFAULT 0,
    inexistente integer DEFAULT 0,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


--
-- TOC entry 836 (class 1259 OID 9445746)
-- Name: escola_lingua_indigena; Type: TABLE; Schema: serieciasc; Owner: -
--

CREATE TABLE serieciasc.escola_lingua_indigena (
    ref_cod_escola integer NOT NULL,
    educacao_indigena integer DEFAULT 0,
    lingua_indigena integer DEFAULT 0,
    lingua_portuguesa integer DEFAULT 0,
    materiais_especificos integer DEFAULT 0,
    ue_terra_indigena integer DEFAULT 0,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


--
-- TOC entry 837 (class 1259 OID 9445754)
-- Name: escola_lixo; Type: TABLE; Schema: serieciasc; Owner: -
--

CREATE TABLE serieciasc.escola_lixo (
    ref_cod_escola integer NOT NULL,
    coleta integer DEFAULT 0,
    queima integer DEFAULT 0,
    outra_area integer DEFAULT 0,
    recicla integer DEFAULT 0,
    reutiliza integer DEFAULT 0,
    enterra integer DEFAULT 0,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


--
-- TOC entry 838 (class 1259 OID 9445763)
-- Name: escola_projeto; Type: TABLE; Schema: serieciasc; Owner: -
--

CREATE TABLE serieciasc.escola_projeto (
    ref_cod_escola integer NOT NULL,
    danca integer DEFAULT 0,
    folclorico integer DEFAULT 0,
    teatral integer DEFAULT 0,
    ambiental integer DEFAULT 0,
    coral integer DEFAULT 0,
    fanfarra integer DEFAULT 0,
    artes_plasticas integer DEFAULT 0,
    integrada integer DEFAULT 0,
    ambiente_alimentacao integer DEFAULT 0,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


--
-- TOC entry 839 (class 1259 OID 9445775)
-- Name: escola_regulamentacao; Type: TABLE; Schema: serieciasc; Owner: -
--

CREATE TABLE serieciasc.escola_regulamentacao (
    ref_cod_escola integer NOT NULL,
    regulamentacao integer DEFAULT 1 NOT NULL,
    situacao integer DEFAULT 1 NOT NULL,
    data_criacao date,
    ato_criacao integer DEFAULT 0,
    numero_ato_criacao character varying(20),
    data_ato_criacao date,
    ato_paralizacao integer DEFAULT 0,
    numero_ato_paralizacao character varying(20),
    data_ato_paralizacao date,
    data_extincao date,
    ato_extincao integer DEFAULT 0,
    numero_ato_extincao character varying(20),
    data_ato_extincao date,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


--
-- TOC entry 840 (class 1259 OID 9445783)
-- Name: escola_sanitario; Type: TABLE; Schema: serieciasc; Owner: -
--

CREATE TABLE serieciasc.escola_sanitario (
    ref_cod_escola integer NOT NULL,
    rede_publica integer DEFAULT 0,
    fossa integer DEFAULT 0,
    inexistente integer DEFAULT 0,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


SET default_with_oids = true;

--
-- TOC entry 841 (class 1259 OID 9445789)
-- Name: cep_logradouro; Type: TABLE; Schema: urbano; Owner: -
--

CREATE TABLE urbano.cep_logradouro (
    cep numeric(8,0) NOT NULL,
    idlog numeric(6,0) NOT NULL,
    nroini numeric(6,0),
    nrofin numeric(6,0),
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_cep_logradouro_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_logradouro_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar)))
);


--
-- TOC entry 842 (class 1259 OID 9445797)
-- Name: cep_logradouro_bairro; Type: TABLE; Schema: urbano; Owner: -
--

CREATE TABLE urbano.cep_logradouro_bairro (
    idlog numeric(6,0) NOT NULL,
    cep numeric(8,0) NOT NULL,
    idbai numeric(6,0) NOT NULL,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_cep_logradouro_bairro_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_logradouro_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar)))
);


--
-- TOC entry 831 (class 1259 OID 9445721)
-- Name: tipo_logradouro; Type: TABLE; Schema: urbano; Owner: -
--

CREATE TABLE urbano.tipo_logradouro (
    idtlog character varying(5) NOT NULL,
    descricao character varying(40) NOT NULL
);


--
-- TOC entry 5486 (class 2604 OID 9474354)
-- Name: id; Type: DEFAULT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.codigo_cartorio_inep ALTER COLUMN id SET DEFAULT nextval('cadastro.codigo_cartorio_inep_id_seq'::regclass);


--
-- TOC entry 4928 (class 2604 OID 9445805)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.area_conhecimento ALTER COLUMN id SET DEFAULT nextval('modules.area_conhecimento_id_seq'::regclass);


--
-- TOC entry 4930 (class 2604 OID 9474621)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.auditoria_geral ALTER COLUMN id SET DEFAULT nextval('modules.auditoria_geral_id_seq'::regclass);


--
-- TOC entry 4931 (class 2604 OID 9445806)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.componente_curricular ALTER COLUMN id SET DEFAULT nextval('modules.componente_curricular_id_seq'::regclass);


--
-- TOC entry 5485 (class 2604 OID 9469022)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.config_movimento_geral ALTER COLUMN id SET DEFAULT nextval('modules.config_movimento_geral_id_seq'::regclass);


--
-- TOC entry 4935 (class 2604 OID 9445807)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.docente_licenciatura ALTER COLUMN id SET DEFAULT nextval('modules.docente_licenciatura_id_seq'::regclass);


--
-- TOC entry 4936 (class 2604 OID 9445808)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.educacenso_curso_superior ALTER COLUMN id SET DEFAULT nextval('modules.educacenso_curso_superior_id_seq'::regclass);


--
-- TOC entry 4937 (class 2604 OID 9445809)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.educacenso_ies ALTER COLUMN id SET DEFAULT nextval('modules.educacenso_ies_id_seq'::regclass);


--
-- TOC entry 4939 (class 2604 OID 9445810)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.falta_aluno ALTER COLUMN id SET DEFAULT nextval('modules.falta_aluno_id_seq'::regclass);


--
-- TOC entry 4940 (class 2604 OID 9445811)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.falta_componente_curricular ALTER COLUMN id SET DEFAULT nextval('modules.falta_componente_curricular_id_seq'::regclass);


--
-- TOC entry 4942 (class 2604 OID 9445812)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.falta_geral ALTER COLUMN id SET DEFAULT nextval('modules.falta_geral_id_seq'::regclass);


--
-- TOC entry 4944 (class 2604 OID 9445813)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.formula_media ALTER COLUMN id SET DEFAULT nextval('modules.formula_media_id_seq'::regclass);


--
-- TOC entry 4952 (class 2604 OID 9445814)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.nota_aluno ALTER COLUMN id SET DEFAULT nextval('modules.nota_aluno_id_seq'::regclass);


--
-- TOC entry 4953 (class 2604 OID 9445815)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.nota_componente_curricular ALTER COLUMN id SET DEFAULT nextval('modules.nota_componente_curricular_id_seq'::regclass);


--
-- TOC entry 4961 (class 2604 OID 9445816)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.parecer_aluno ALTER COLUMN id SET DEFAULT nextval('modules.parecer_aluno_id_seq'::regclass);


--
-- TOC entry 4962 (class 2604 OID 9445817)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.parecer_componente_curricular ALTER COLUMN id SET DEFAULT nextval('modules.parecer_componente_curricular_id_seq'::regclass);


--
-- TOC entry 4963 (class 2604 OID 9445818)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.parecer_geral ALTER COLUMN id SET DEFAULT nextval('modules.parecer_geral_id_seq'::regclass);


--
-- TOC entry 4982 (class 2604 OID 9445819)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.regra_avaliacao ALTER COLUMN id SET DEFAULT nextval('modules.regra_avaliacao_id_seq'::regclass);


--
-- TOC entry 4985 (class 2604 OID 9445820)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.tabela_arredondamento ALTER COLUMN id SET DEFAULT nextval('modules.tabela_arredondamento_id_seq'::regclass);


--
-- TOC entry 4987 (class 2604 OID 9445821)
-- Name: id; Type: DEFAULT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.tabela_arredondamento_valor ALTER COLUMN id SET DEFAULT nextval('modules.tabela_arredondamento_valor_id_seq'::regclass);


--
-- TOC entry 5064 (class 2604 OID 9445822)
-- Name: id; Type: DEFAULT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.auditoria_falta_componente_dispensa ALTER COLUMN id SET DEFAULT nextval('pmieducar.auditoria_falta_componente_dispensa_id_seq'::regclass);


--
-- TOC entry 5065 (class 2604 OID 9445823)
-- Name: id; Type: DEFAULT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.auditoria_nota_dispensa ALTER COLUMN id SET DEFAULT nextval('pmieducar.auditoria_nota_dispensa_id_seq'::regclass);


--
-- TOC entry 5067 (class 2604 OID 9445824)
-- Name: id; Type: DEFAULT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.backup ALTER COLUMN id SET DEFAULT nextval('pmieducar.backup_id_seq'::regclass);


--
-- TOC entry 5087 (class 2604 OID 9445825)
-- Name: id; Type: DEFAULT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.categoria_obra ALTER COLUMN id SET DEFAULT nextval('pmieducar.categoria_obra_id_seq'::regclass);


--
-- TOC entry 5145 (class 2604 OID 9445826)
-- Name: id; Type: DEFAULT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_usuario ALTER COLUMN id SET DEFAULT nextval('pmieducar.escola_usuario_id_seq'::regclass);


--
-- TOC entry 5431 (class 2604 OID 9445827)
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.pghero_query_stats ALTER COLUMN id SET DEFAULT nextval('public.pghero_query_stats_id_seq'::regclass);


--
-- TOC entry 7501 (class 0 OID 9442926)
-- Dependencies: 205
-- Data for Name: funcao; Type: TABLE DATA; Schema: acesso; Owner: -
--



--
-- TOC entry 8178 (class 0 OID 0)
-- Dependencies: 204
-- Name: funcao_idfunc_seq; Type: SEQUENCE SET; Schema: acesso; Owner: -
--

SELECT pg_catalog.setval('acesso.funcao_idfunc_seq', 1, false);


--
-- TOC entry 7503 (class 0 OID 9442936)
-- Dependencies: 207
-- Data for Name: grupo; Type: TABLE DATA; Schema: acesso; Owner: -
--



--
-- TOC entry 7504 (class 0 OID 9442941)
-- Dependencies: 208
-- Data for Name: grupo_funcao; Type: TABLE DATA; Schema: acesso; Owner: -
--



--
-- TOC entry 8179 (class 0 OID 0)
-- Dependencies: 206
-- Name: grupo_idgrp_seq; Type: SEQUENCE SET; Schema: acesso; Owner: -
--

SELECT pg_catalog.setval('acesso.grupo_idgrp_seq', 1, false);


--
-- TOC entry 7505 (class 0 OID 9442944)
-- Dependencies: 209
-- Data for Name: grupo_menu; Type: TABLE DATA; Schema: acesso; Owner: -
--



--
-- TOC entry 7506 (class 0 OID 9442947)
-- Dependencies: 210
-- Data for Name: grupo_operacao; Type: TABLE DATA; Schema: acesso; Owner: -
--



--
-- TOC entry 7507 (class 0 OID 9442950)
-- Dependencies: 211
-- Data for Name: grupo_sistema; Type: TABLE DATA; Schema: acesso; Owner: -
--



--
-- TOC entry 7508 (class 0 OID 9442953)
-- Dependencies: 212
-- Data for Name: historico_senha; Type: TABLE DATA; Schema: acesso; Owner: -
--



--
-- TOC entry 7510 (class 0 OID 9442958)
-- Dependencies: 214
-- Data for Name: instituicao; Type: TABLE DATA; Schema: acesso; Owner: -
--



--
-- TOC entry 8180 (class 0 OID 0)
-- Dependencies: 213
-- Name: instituicao_idins_seq; Type: SEQUENCE SET; Schema: acesso; Owner: -
--

SELECT pg_catalog.setval('acesso.instituicao_idins_seq', 1, false);


--
-- TOC entry 7511 (class 0 OID 9442963)
-- Dependencies: 215
-- Data for Name: log_acesso; Type: TABLE DATA; Schema: acesso; Owner: -
--



--
-- TOC entry 7512 (class 0 OID 9442967)
-- Dependencies: 216
-- Data for Name: log_erro; Type: TABLE DATA; Schema: acesso; Owner: -
--



--
-- TOC entry 7514 (class 0 OID 9442975)
-- Dependencies: 218
-- Data for Name: menu; Type: TABLE DATA; Schema: acesso; Owner: -
--



--
-- TOC entry 8181 (class 0 OID 0)
-- Dependencies: 217
-- Name: menu_idmen_seq; Type: SEQUENCE SET; Schema: acesso; Owner: -
--

SELECT pg_catalog.setval('acesso.menu_idmen_seq', 1, false);


--
-- TOC entry 7516 (class 0 OID 9442982)
-- Dependencies: 220
-- Data for Name: operacao; Type: TABLE DATA; Schema: acesso; Owner: -
--



--
-- TOC entry 7517 (class 0 OID 9442987)
-- Dependencies: 221
-- Data for Name: operacao_funcao; Type: TABLE DATA; Schema: acesso; Owner: -
--



--
-- TOC entry 8182 (class 0 OID 0)
-- Dependencies: 219
-- Name: operacao_idope_seq; Type: SEQUENCE SET; Schema: acesso; Owner: -
--

SELECT pg_catalog.setval('acesso.operacao_idope_seq', 1, false);


--
-- TOC entry 7518 (class 0 OID 9442990)
-- Dependencies: 222
-- Data for Name: pessoa_instituicao; Type: TABLE DATA; Schema: acesso; Owner: -
--



--
-- TOC entry 7520 (class 0 OID 9442995)
-- Dependencies: 224
-- Data for Name: sistema; Type: TABLE DATA; Schema: acesso; Owner: -
--

INSERT INTO acesso.sistema VALUES (1, 'i-Educar', 'Sistema básico', '', 'A');
INSERT INTO acesso.sistema VALUES (9, 'Código legado', 'Sistema básico', '', 'A');
INSERT INTO acesso.sistema VALUES (17, 'Código legado', 'Sistema básico', '', 'A');


--
-- TOC entry 8183 (class 0 OID 0)
-- Dependencies: 223
-- Name: sistema_idsis_seq; Type: SEQUENCE SET; Schema: acesso; Owner: -
--

SELECT pg_catalog.setval('acesso.sistema_idsis_seq', 17, true);


--
-- TOC entry 7521 (class 0 OID 9443000)
-- Dependencies: 225
-- Data for Name: usuario; Type: TABLE DATA; Schema: acesso; Owner: -
--



--
-- TOC entry 7522 (class 0 OID 9443007)
-- Dependencies: 226
-- Data for Name: usuario_grupo; Type: TABLE DATA; Schema: acesso; Owner: -
--



--
-- TOC entry 7524 (class 0 OID 9443012)
-- Dependencies: 228
-- Data for Name: baixa_guia_produto; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8184 (class 0 OID 0)
-- Dependencies: 227
-- Name: baixa_guia_produto_idbap_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.baixa_guia_produto_idbap_seq', 1, false);


--
-- TOC entry 7526 (class 0 OID 9443021)
-- Dependencies: 230
-- Data for Name: baixa_guia_remessa; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8185 (class 0 OID 0)
-- Dependencies: 229
-- Name: baixa_guia_remessa_idbai_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.baixa_guia_remessa_idbai_seq', 1, false);


--
-- TOC entry 7528 (class 0 OID 9443027)
-- Dependencies: 232
-- Data for Name: calendario; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8186 (class 0 OID 0)
-- Dependencies: 231
-- Name: calendario_idcad_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.calendario_idcad_seq', 1, false);


--
-- TOC entry 7530 (class 0 OID 9443033)
-- Dependencies: 234
-- Data for Name: cardapio; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 7531 (class 0 OID 9443041)
-- Dependencies: 235
-- Data for Name: cardapio_faixa_unidade; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8187 (class 0 OID 0)
-- Dependencies: 233
-- Name: cardapio_idcar_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.cardapio_idcar_seq', 1, false);


--
-- TOC entry 7533 (class 0 OID 9443046)
-- Dependencies: 237
-- Data for Name: cardapio_produto; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8188 (class 0 OID 0)
-- Dependencies: 236
-- Name: cardapio_produto_idcpr_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.cardapio_produto_idcpr_seq', 1, false);


--
-- TOC entry 7534 (class 0 OID 9443053)
-- Dependencies: 238
-- Data for Name: cardapio_receita; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 7535 (class 0 OID 9443056)
-- Dependencies: 239
-- Data for Name: cliente; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 7537 (class 0 OID 9443062)
-- Dependencies: 241
-- Data for Name: composto_quimico; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8189 (class 0 OID 0)
-- Dependencies: 240
-- Name: composto_quimico_idcom_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.composto_quimico_idcom_seq', 1, false);


--
-- TOC entry 7539 (class 0 OID 9443068)
-- Dependencies: 243
-- Data for Name: contrato; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8190 (class 0 OID 0)
-- Dependencies: 242
-- Name: contrato_idcon_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.contrato_idcon_seq', 1, false);


--
-- TOC entry 7541 (class 0 OID 9443081)
-- Dependencies: 245
-- Data for Name: contrato_produto; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8191 (class 0 OID 0)
-- Dependencies: 244
-- Name: contrato_produto_idcop_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.contrato_produto_idcop_seq', 1, false);


--
-- TOC entry 7543 (class 0 OID 9443091)
-- Dependencies: 247
-- Data for Name: evento; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8192 (class 0 OID 0)
-- Dependencies: 246
-- Name: evento_ideve_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.evento_ideve_seq', 1, false);


--
-- TOC entry 7545 (class 0 OID 9443098)
-- Dependencies: 249
-- Data for Name: faixa_composto_quimico; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8193 (class 0 OID 0)
-- Dependencies: 248
-- Name: faixa_composto_quimico_idfcp_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.faixa_composto_quimico_idfcp_seq', 1, false);


--
-- TOC entry 7547 (class 0 OID 9443108)
-- Dependencies: 251
-- Data for Name: faixa_etaria; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8194 (class 0 OID 0)
-- Dependencies: 250
-- Name: faixa_etaria_idfae_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.faixa_etaria_idfae_seq', 1, false);


--
-- TOC entry 7549 (class 0 OID 9443117)
-- Dependencies: 253
-- Data for Name: fornecedor; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8195 (class 0 OID 0)
-- Dependencies: 252
-- Name: fornecedor_idfor_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.fornecedor_idfor_seq', 1, false);


--
-- TOC entry 7550 (class 0 OID 9443122)
-- Dependencies: 254
-- Data for Name: fornecedor_unidade_atendida; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 7552 (class 0 OID 9443127)
-- Dependencies: 256
-- Data for Name: grupo_quimico; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8196 (class 0 OID 0)
-- Dependencies: 255
-- Name: grupo_quimico_idgrpq_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.grupo_quimico_idgrpq_seq', 1, false);


--
-- TOC entry 7554 (class 0 OID 9443133)
-- Dependencies: 258
-- Data for Name: guia_produto_diario; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8197 (class 0 OID 0)
-- Dependencies: 257
-- Name: guia_produto_diario_idguiaprodiario_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.guia_produto_diario_idguiaprodiario_seq', 1, false);


--
-- TOC entry 7556 (class 0 OID 9443142)
-- Dependencies: 260
-- Data for Name: guia_remessa; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8198 (class 0 OID 0)
-- Dependencies: 259
-- Name: guia_remessa_idgui_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.guia_remessa_idgui_seq', 1, false);


--
-- TOC entry 7558 (class 0 OID 9443150)
-- Dependencies: 262
-- Data for Name: guia_remessa_produto; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8199 (class 0 OID 0)
-- Dependencies: 261
-- Name: guia_remessa_produto_idgup_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.guia_remessa_produto_idgup_seq', 1, false);


--
-- TOC entry 7560 (class 0 OID 9443159)
-- Dependencies: 264
-- Data for Name: log_guia_remessa; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8200 (class 0 OID 0)
-- Dependencies: 263
-- Name: log_guia_remessa_idlogguia_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.log_guia_remessa_idlogguia_seq', 1, false);


--
-- TOC entry 7561 (class 0 OID 9443166)
-- Dependencies: 265
-- Data for Name: medidas_caseiras; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 7563 (class 0 OID 9443171)
-- Dependencies: 267
-- Data for Name: pessoa; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8201 (class 0 OID 0)
-- Dependencies: 266
-- Name: pessoa_idpes_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.pessoa_idpes_seq', 1, false);


--
-- TOC entry 7565 (class 0 OID 9443178)
-- Dependencies: 269
-- Data for Name: produto; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 7567 (class 0 OID 9443189)
-- Dependencies: 271
-- Data for Name: produto_composto_quimico; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8202 (class 0 OID 0)
-- Dependencies: 270
-- Name: produto_composto_quimico_idpcq_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.produto_composto_quimico_idpcq_seq', 1, false);


--
-- TOC entry 7569 (class 0 OID 9443198)
-- Dependencies: 273
-- Data for Name: produto_fornecedor; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8203 (class 0 OID 0)
-- Dependencies: 272
-- Name: produto_fornecedor_idprf_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.produto_fornecedor_idprf_seq', 1, false);


--
-- TOC entry 8204 (class 0 OID 0)
-- Dependencies: 268
-- Name: produto_idpro_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.produto_idpro_seq', 1, false);


--
-- TOC entry 7571 (class 0 OID 9443204)
-- Dependencies: 275
-- Data for Name: produto_medida_caseira; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8205 (class 0 OID 0)
-- Dependencies: 274
-- Name: produto_medida_caseira_idpmc_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.produto_medida_caseira_idpmc_seq', 1, false);


--
-- TOC entry 7573 (class 0 OID 9443213)
-- Dependencies: 277
-- Data for Name: receita; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 7575 (class 0 OID 9443222)
-- Dependencies: 279
-- Data for Name: receita_composto_quimico; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8206 (class 0 OID 0)
-- Dependencies: 278
-- Name: receita_composto_quimico_idrcq_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.receita_composto_quimico_idrcq_seq', 1, false);


--
-- TOC entry 8207 (class 0 OID 0)
-- Dependencies: 276
-- Name: receita_idrec_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.receita_idrec_seq', 1, false);


--
-- TOC entry 7577 (class 0 OID 9443231)
-- Dependencies: 281
-- Data for Name: receita_produto; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8208 (class 0 OID 0)
-- Dependencies: 280
-- Name: receita_produto_idrpr_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.receita_produto_idrpr_seq', 1, false);


--
-- TOC entry 7579 (class 0 OID 9443240)
-- Dependencies: 283
-- Data for Name: tipo_produto; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8209 (class 0 OID 0)
-- Dependencies: 282
-- Name: tipo_produto_idtip_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.tipo_produto_idtip_seq', 1, false);


--
-- TOC entry 7581 (class 0 OID 9443246)
-- Dependencies: 285
-- Data for Name: tipo_refeicao; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8210 (class 0 OID 0)
-- Dependencies: 284
-- Name: tipo_refeicao_idtre_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.tipo_refeicao_idtre_seq', 1, false);


--
-- TOC entry 7583 (class 0 OID 9443252)
-- Dependencies: 287
-- Data for Name: tipo_unidade; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8211 (class 0 OID 0)
-- Dependencies: 286
-- Name: tipo_unidade_idtip_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.tipo_unidade_idtip_seq', 1, false);


--
-- TOC entry 7585 (class 0 OID 9443258)
-- Dependencies: 289
-- Data for Name: unidade_atendida; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8212 (class 0 OID 0)
-- Dependencies: 288
-- Name: unidade_atendida_iduni_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.unidade_atendida_iduni_seq', 1, false);


--
-- TOC entry 7587 (class 0 OID 9443264)
-- Dependencies: 291
-- Data for Name: unidade_faixa_etaria; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 8213 (class 0 OID 0)
-- Dependencies: 290
-- Name: unidade_faixa_etaria_idfeu_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: -
--

SELECT pg_catalog.setval('alimentos.unidade_faixa_etaria_idfeu_seq', 1, false);


--
-- TOC entry 7588 (class 0 OID 9443268)
-- Dependencies: 292
-- Data for Name: unidade_produto; Type: TABLE DATA; Schema: alimentos; Owner: -
--



--
-- TOC entry 7589 (class 0 OID 9443274)
-- Dependencies: 293
-- Data for Name: aviso_nome; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 8133 (class 0 OID 9474351)
-- Dependencies: 846
-- Data for Name: codigo_cartorio_inep; Type: TABLE DATA; Schema: cadastro; Owner: -
--

INSERT INTO cadastro.codigo_cartorio_inep VALUES (1, 7523, 'REGISTRO DE IMOVEIS, DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS NATURAIS E CIVIL DAS PESSOAS JURIDICAS E DE INTERDICOES E TUTELAS', 27474, 5216304, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2, 9370, 'CARTORIO DE NOTAS E PROTESTOS E REGISTROS DE CONTRATOS MARITIMOS', 28704, 5216304, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3, 9371, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS E TABELIONATO 2º DE NOTAS ', 28654, 5216403, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4, 1717, 'REGISTRO CIVIL PESSOAS NATURAIS', 28209, 5216403, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5, 9372, 'CARTORIO 1º OFICIO E REG. DE IMOVEIS', 25171, 5216403, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6, 9268, 'IPAMERI CARTORIO DO PRIMEIRO OFICIO DE NOTAS REGITRO GERAL DE IMOVEIS', 27789, 5210109, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7, 1141, 'CARTORIO DE REGISTRO CIVIL E TAB DE NOTAS', 25809, 5210109, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8, 9269, 'CARTORIO DO REGISTRO DE PESSOAS JURIDICAS,TITULOS,DOCUMENTOS E PROTESTOS E TABELIAO DO 2º DE NOTAS', 27367, 5210109, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9, 1140, 'IPAMERI CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS  ', 27797, 5210109, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10, 1142, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E CIVIL DAS PESSOAS JURIDICAS E DE INTERDICAO E TUTELAS, REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS, TABELIONATO DE NOTAS E PROTESTO DE TITUL', 27052, 5210158, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11, 9270, 'REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 28381, 5210208, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12, 9271, '2º SERVICO NOTARIAL E REGISTRAL DE IPORA', 24935, 5210208, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13, 1143, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE IPORA', 25965, 5210208, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14, 1145, 'TABELIONATO DE NOTAS, DE PROTESTO DE TITULOS, TABELIONATO E OFICIALATO DE  REGISTRO DE CONTRATOS MARITIMOS, DE REGISTRO DE IMOVEIS, DE REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS, CI', 146241, 5210307, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (15, 9272, 'REGISTRO DE IMOVEIS E TAB 1 DE NOTAS', 28274, 5210406, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (16, 9273, 'CARTORIO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 25296, 5210406, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (17, 9274, 'CARTORIO REGISTRO CIVIL E PESSOAS NATURAIS E TABELIONATO DE NOTAS', 27540, 5210406, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (18, 1146, 'CARTORIO REGISTRO DE IMOVEIS, NOTAS E REGISTRO CIVIL DAS PESSOAS NATURAIS', 27599, 5210562, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (19, 9275, 'TABELIONATO DE NOTAS, PROTESTO DE TITULOS, TABELIAO E OFICIAL DE REGISTRO DE CONTRATOS MARITIMOS', 29504, 5210604, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (20, 1687, 'REGISTRO DE IMOVEIS, REGISTROS DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS, CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 28530, 5210604, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (21, 9276, 'TABELIONATAO DE NOTAS, DE PROTESTOS DE TITULOS, TABELIONATO E OFICIALATO DE REGISTRO DE CONTRATOS MARITIMOS', 146753, 5210802, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (22, 7514, 'REG DE IMOVEIS, TAB 1 DE NOTAS, OF DE REG DE CONTR MARIT, REG DE TIT E DOC E C DAS PESSOAS JURIDICAS', 27995, 5210802, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (23, 1147, 'REGISTRO CIVIL DE PES. NATURAIS E TAB. DE NOTAS', 28068, 5210901, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (24, 9277, 'CARTORIO DO 2° OFICIO DE NOTAS, TITULOS DOCUMENTOS E PROTESTOS DE ITAPACI GO.', 26880, 5210901, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (25, 9278, '1º TABELIONATO DE NOTAS E REGISTRO DE IMOVEIS', 24836, 5210901, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (26, 1148, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 27078, 5211008, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (27, 9279, 'ITAPIRAPUA CARTORIO DO SEGUNDO OFICIO E NOTAS', 27805, 5211008, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (28, 9280, 'TABELIONATO 1° DE NOTAS E REGISTRO DE IMOVEIS', 29355, 5211008, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (29, 9281, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS, TABELIONATO 2° DE NOTAS, REGISTRO DE IMOVEIS, REGISTRO CIVIL DE PESSOAS NATURAIS, INTERDICOES E TUTELAS', 28738, 5211206, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (30, 1149, 'SERVICOS DE NOTAS E OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 29108, 5211206, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (31, 1151, 'CARTORIO REGISTRO CIVIL DE PESSOAS NATURAIS E TAB DE NOTAS', 27482, 5211206, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (32, 9282, 'SERVICOS DE NOTAS, REGISTRO DE CONTRATOS MARITIMOS, PROTESTO DE TITULO', 29157, 5211206, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (33, 1152, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 129460, 5211305, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (34, 9196, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS', 26112, 5206503, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (35, 9197, 'SERVICOS DE NOTAS, DE PROTESTOS DE TITULOS E REGISTRO DE CONTRATOS MARITIMOS DE CUMARI', 29132, 5206602, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (36, 1119, 'SERVICOS DE REGISTRO DE IMOVEIS, DE REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DE CUMARI', 29280, 5206602, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (37, 9198, 'PRIMEIRO TABELIONATO DE NOTAS', 27979, 5211503, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (38, 1155, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS DA 2ª CIRCUNSCRICAO E TABELIONATO DE NOTAS', 27177, 5211503, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (39, 9199, 'CARTORIO DE REGISTRO DE IMOVEIS DA 2ª CIRCUNSCRICAO DA COMARCA DE ITUMBIARA-GO', 26047, 5211503, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (40, 9200, 'SERVICOS DE NOTAS, DE PROTESTOS DE TITULOS, TABELIONATO E DE REGISTRO DE CONTRATOS MARITIMOS', 29140, 5211602, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (41, 1156, 'SERVICO DE REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS, REGISTRO CIVIL DAS PESSOAS JURIDICAS, REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS.', 28993, 5211602, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (42, 9205, 'JATAI 2º TABELIONATO DE NOTAS ', 27862, 5211909, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (43, 9206, 'CARTORIO PRIMEIRO TABELIONATO DE NOTAS', 27433, 5211909, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (44, 9207, 'SERVICO REGISTRAL DE IMOVEIS, TITULOS E DOCUMENTOS, PESSOAS JURIDICAS E PROTESTO', 29033, 5211909, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (45, 7517, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 28043, 5211909, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (46, 1159, 'CARTORIO UNICO DE JAUPACI', 27656, 5212006, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (47, 9208, 'REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DA PESSOAS  NATURAIS E DE INTERDICOES E TUTELAS', 149054, 5212105, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (48, 9209, 'TABELIONATO DE NOTAS, PROTESTO DE TITULOS, TABELIONATO E REGISTRO DE CONTRATOS MARITIMOS', 146829, 5212105, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (49, 1689, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 25924, 5212105, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (50, 9210, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 26302, 5212204, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (51, 1160, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 25957, 5212204, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (52, 9211, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E SEGUNDO TABELIONATO DE NOTAS', 28753, 5212204, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (53, 1161, 'L. BULHOES CARTORIO SEGUNDO DE NOTAS REGISTROS DE TITULOS E DOCUMENTOS', 27888, 5212303, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (54, 9212, 'TABELIONATO DE NOTAS DE PROTESTO DE TITULOS, TABELIONATO E OFICIALATO DE REGISTRO DE CONTRATOS MARITIMOS', 26831, 5212303, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (55, 1690, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 25411, 5212501, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (56, 9213, 'REGISTRO DE IMOVEIS ', 28282, 5212501, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (57, 9214, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS E PROTESTOS', 28605, 5212501, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (58, 9215, '1º TABELIONATO DE NOTAS', 145698, 5212501, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (59, 9216, 'CARTORIO DO 2º TABELIONATO DE NOTAS', 26930, 5212501, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (60, 1162, 'CARTORIO DE REGISTRO GERAL DE IMOVEIS E ANEXOS', 26641, 5212600, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (61, 1163, 'CARTORIO DO 1º OFICIO E REGISTRO GERAL DE IMOVEIS E ANEXOS', 26823, 5212709, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (62, 9217, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS TITULOS DOCUMENTOS  TABELIONATO DE PROTESTOS DE TITULOS E DE NOTAS 2', 26518, 5212808, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (63, 1120, 'CARTORIO DE REGISTRO CIVIL - TABELIONATO DE NOTAS E ANEXOS', 25403, 5206701, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (124, 9297, 'CART.REG. IMOV. TAB. NOTAS TIT.DOC. PROT.P.JUR.', 25130, 5203401, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (64, 9218, 'TABELIONATO DE NOTAS, DE PROTESTO DE TITULOS, TABELIONATO E OFICIALATO DE REGISTRO DE CONTRATOS MARITIMOS, DE REGISTRO DE IMOVEIS, DE REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS', 154641, 5206800, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (65, 1121, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 29173, 5206800, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (66, 1310, 'CARTORIO DO REGISTRO CIVIL E PESSOAS NATURAIS DE DAVINOPOLIS GOIAS', 27235, 5206909, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (67, 9219, 'CARTORIO DE 1º OFICIO E TABELIONATO DE NOTAS', 25239, 5206909, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (68, 1311, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS DE TITULOS, CIVIL DAS PESSOAS NATURAIS, INTERDICOES, TUTELAS E TABELIONATO DE NOTAS', 26427, 5207105, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (69, 1312, 'SERVICO DE NOTAS, DE PROTESTOS DE TITULOS, DE REGISTRO DE IMOVEIS, DE REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 28894, 5208301, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (70, 1670, 'TABELIONATO DE NOTAS, DE PROTESTO DE TITULOS, OFICIALATO DE REGISTRO DE IMOVEIS, DE REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS E DE INTERDICAO E TUTELAS', 29447, 5207253, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (71, 1671, 'EDEALINA CARTORIO DE REG. DE IMOVEIS 1° OFICIO', 27714, 5207352, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (72, 1672, 'CARTORIO DE REIGSTRO DE IMOVEIS, 1º TABELIAO DE NOTAS E CIVIL', 26666, 5207402, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (73, 9220, 'REGISTRO DE PESSOAS JURIDICAS', 28597, 5207402, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (74, 1673, 'SERVICOS DE REGISTRO DE IMOVEIS, DE REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS ', 29272, 5207501, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (75, 9221, 'SERVICOS DE NOTAS  E PROTESTOS DE TITULOS E REGISTRO DE CONTRATOS MARITIMOS', 29058, 5207501, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (76, 1676, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 28183, 5207535, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (77, 1675, 'REGISTRO CIVIL DAS PESSOAS NATURAIS INTERDICAO CURATELA E TAB. DE NOTAS', 28050, 5207535, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (78, 9222, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS E TABELIONATO DE NOTAS', 26450, 5207535, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (79, 1677, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 25445, 5207600, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (80, 1679, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 28191, 5207600, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (81, 9223, 'CARTORIO DE REGISTRO DE IMOVEIS E TITULOS E DOCUMENTOS.', 26351, 5207600, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (82, 1678, 'CARTORIO REGISTRO CIVIL E TAB. NOTAS', 27557, 5207600, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (83, 9224, 'TABELIONATO DE NOTAS, PROTESTO DE TITULOS E REGISTRO DE CONTRATOS MARITIMOS.', 29488, 5207600, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (84, 9225, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS E TABELIONATO 2º DE NOTAS E ESCRIVANIA 2º DO CIVEL', 28696, 5207808, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (85, 1680, 'REGISTRO CIVEL E PESSOAS NATURAIS', 28001, 5207808, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (86, 9226, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 26245, 5207808, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (87, 1681, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 25593, 5207907, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (88, 1122, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, PROTESTOS, TITULOS, DOCUMENTOS E TABELIONATO DE NOTAS DO DISTRITO JUDICIARIO DE FLORES DE GOIAS', 26401, 5207907, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (89, 9227, 'CARTORIO DO 1º OFICIO DE NOTAS E REGISTRO DE IMOVEIS E HIPOTECAS', 26799, 5208004, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (90, 1682, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS SANTA ROSA', 25973, 5208004, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (91, 1683, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS (CARTORIO DE REGISTRO CIVIL DO DISTRITO DE SANTA ROSA)', 25510, 5208004, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (92, 9228, 'CARTORIO DO REGISTRO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTO DE TITULOS E TABELIONATO 2º DE NOTAS', 27334, 5208004, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (93, 9229, 'REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS NATURAIS INTERDICOES E TUTELAS', 28399, 5208103, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (94, 9230, 'TABELIONATO DE NOTAS, PROTESTO DE TITULOS, TABELIONATO E OFICIALATO DE CONTRATOS MARITIMOS', 145961, 5208103, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (95, 9231, 'TABELIONATO 1º DE NOTAS E REGISTRO GERAL DE IMOVEIS', 29371, 5208400, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (96, 1684, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE GOIANAPOLIS-GOIAS', 25643, 5208400, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (97, 9232, 'TABELIONATO DE NOTAS, DE PROTESTO DE TITULOS, TABELIONATO E OFICILIATO DE REGISTRO DE CONTRATOS MARITIMOS', 28688, 5208400, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (98, 9233, 'REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 145920, 5208509, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (99, 9283, 'ITARUMA CARTORIO DO 1° OFICIO, REG. GERAL DE IMOVEIS E ANEXOS', 27813, 5211305, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (100, 1153, 'REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 28514, 5211404, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (101, 9284, 'ITAUCU CART. PRIMEIRO OFICIO NOTAS E REGISTRO G. IMOVEIS', 27821, 5211404, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (102, 9285, 'TABELIONATO DE PROTESTOS, REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS.', 29538, 5211503, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (103, 7516, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS 3ª CIRCUNSCRICAO E TABELIONATO DE NOTAS', 27151, 5211503, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (104, 9286, 'ITUMBIARA CARTORIO REGISTRO DE IMOVEIS - 1ª CIRCUNSCRICAO', 27847, 5211503, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (105, 1154, 'REGISTRO CIVIL DE PESSOAS NATURAIS 1ª CIRCUNSCRICAO E TABELIONATO DE NOTAS', 28092, 5211503, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (106, 9287, 'ITUMBIARA CARTORIO DO SEGUNDO OFICIO DE NOTAS ', 27839, 5211503, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (107, 9288, 'ITUMBIARA TERCEIRO TABELIONATO DE NOTAS', 27854, 5211503, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (108, 1101, 'CARTORIO DO TABELIONATO DE NOTAS E PROTESTOS DE TITULOS, REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS.', 27391, 5201801, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (109, 1102, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 25528, 5202155, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (110, 9289, 'CARTORIO BRASILENO JOSE DA SILVA', 25213, 5202155, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (111, 9290, 'CARTORIO REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 27615, 5202353, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (112, 1103, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 27250, 5202353, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (113, 1104, 'SER.NOT.PROT.TIT.TAB.REG.CONT.IMOV.DOC.CIV.PES.JUR.NAT.TUT.', 28829, 5202502, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (114, 9291, 'TABELIONATO DE NOTAS, DE PROTESTOS DE TITULOS E REGISTRO DE CONTRATOS MARITIMOS', 29462, 5202601, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (115, 1282, 'REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS NATURAIS E INTERDICOES E TULELAS', 28522, 5202601, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (116, 1283, 'CART. REGISTRO DE IMOVEIS, PESSOA JURIDICA, TITULOS, DOCUMENTOS, PROTESTOS, TABELIONATO DE NOTAS, REGISTRO DE CONTRATOS MARITIMOS, REGISTRO CIVIL, TUTELAS INTERDICOES E ANEXOS.', 25122, 5202809, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (117, 1284, 'REGISTRO CIVIL DE PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 147173, 5203104, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (118, 9292, '1º TABELINATO  DE BALIZA E 1º OFICIO E REGISTRO DE IMOVEIS', 24794, 5203104, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (119, 9293, 'TABELIONATO DE NOTAS, PROTESTO DE TITULOS E REGISTRO DE CONTRATOS MARITIMOS', 29470, 5203203, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (120, 1285, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS', 26138, 5203203, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (121, 9294, 'CARORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO 2º DE NOTAS E ESRIVANIA 2º DO CIVEL, REGISTRO CIVIL DAS PESSOAS NATURAIS', 25098, 5203302, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (122, 9295, 'REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 28373, 5203302, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (123, 9296, 'CARTORIO REGISTRO CIVIL E NOTAS', 27524, 5203401, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (125, 9298, 'CARTORIO DE TAB.NOTAS.PROT.TIT.TAB.REG.CONTRATO MARITINOS', 26690, 5203500, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (126, 9299, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS, TABELIONATO SEGUNDO DE NOTAS E REGISTRO DE IMOVEIS E REGISTRO CIVIL DE PESSOAS NATURAIS', 28670, 5203500, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (127, 1287, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 146787, 5203559, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (128, 1615, 'CARTORIO EXTRAJUDICIAL DO SEGUNDO OFICIO', 30668, 2101400, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (129, 1286, 'CARTORIO DE NOTAS,REG. DE IMOVEIS, PESSOAS JURIDICAS,TIT. E DOC. PROT. CIVIL DAS PES. NATURAIS, INTERDICOES E TUTELAS', 25288, 5203559, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (130, 1288, 'REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTO, NOTAS E REGISTRO CIVIL DAS PESSOAS NATURAIS DE BRAZABRANTES.', 145045, 5203609, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (131, 1289, 'CARTORIO REG CIVIL E TABELIONTO DE NOTAS', 27458, 5203807, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (132, 1290, 'SERVICOS DE REGISTROS DE IMOVEIS E ANEXOS', 29314, 5203807, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (133, 9300, 'REGISTRO DE IMOVEIS, TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 28555, 5203906, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (134, 1291, 'REGISTROS DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS, CIVIL DAS PESSOAS NATURAIS, INTERDICAO E TUTELAS', 28795, 5203906, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (135, 1292, 'CARTORIO DE NOTAS, DE PROTESTO DE TITULOS, REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS E DE INTERDICAO E TUTELAS', 25262, 5203939, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (136, 1105, 'CARTORIO BURITINOPOLIS', 25221, 5203962, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (137, 9301, 'CARTORIO DO REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTO E TABELIONATO DE NOTAS', 27326, 5204003, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (138, 9302, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO 2º DE NOTAS', 26526, 5220207, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (139, 7399, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 27011, 5220264, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (140, 9303, 'CARTORIO DO REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS, TABELIONATO DE NOTAS E ANEXO REGISTRO CIVIL DE PESSOAS NATURAIS', 27318, 5220264, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (141, 9304, 'CARTORIO DE 1º OFICIO, REGISTRO DE IMOVEIS E ANEXO', 25247, 5220405, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (142, 1586, 'TABELIONATO DE NOTAS, PROTESTOS DE TITULOS E REGISTROS DE CONTRATOS MARITIMOS', 29421, 5220405, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (143, 9305, 'REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 28480, 5220454, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (144, 1588, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 27292, 5220454, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (145, 7400, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 25866, 5220504, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (146, 9306, 'PRIMEIRO SERVICO NOTARIAL, REGISTRO GERAL DE IMOVEIS, TITULOS E DOCUMENTOS, PESSOAS JURIDICAS E PROTESTOS', 27961, 5220504, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (147, 9307, 'CARTORIO DE REGISTRO DAS PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO 2O DE NOTAS', 25999, 5220603, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (148, 1589, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, REGISTRO DE CONTRATOS MARITIMOS E TABELIONATO DE NOTAS ', 25569, 5220603, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (149, 9308, 'REGISTRO DE IMOVEIS E TABELIONATO 1° DE NOTAS', 28332, 5220603, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (150, 1590, 'SERV. DE NOTAS, PROT. DE TITULOS, TABEL. E REG. DE CONTRATOS MARITIMOS, REG. DE IMOVEIS, REG. DE TITULOS E DOC., CIVIL DAS PESSOAS NATURAIS E DE INTERD. E TUTELA', 28852, 5220686, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (151, 1591, 'REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS, CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 28431, 5221007, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (152, 9309, 'SERVICOS DE NOTAS, DE PROTESTO DE TITULOS, TABELIONATO E DE REGISTRO DE CONTRATOS MARITIMOS', 29124, 5221007, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (153, 1592, 'SERV. DE NOTAS E REGISTROS PUBLICOS', 28845, 5221080, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (154, 1593, 'CARTORIO DE REG. IMOVEIS, PESSOA JURIDICA, TITULO E DOCUMENTOS, PROTESTO E TAB. DE NOTAS', 25338, 5221304, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (155, 1594, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 25437, 5221403, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (156, 9310, 'CARTORIO DE REGISTRO DE IMOVEIS E 1º TABELIONATO DE NOTTAS', 26104, 5221403, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (157, 9311, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS, 2º TABELIONATO DE NOTAS', 25577, 5221403, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (158, 9312, 'SERVICO DE NOTAS, PROT. DE TIT. DOC, TAB. DE NOTAS, REG. DE CONTRATOS MARITIMOS, REG. DE IMOVEIS, REG. DE TITULOS E DOC, REG. CIVIL DAS PESS. JUR. E CIVIL DAS PESS. NAT. E DE INTER. E TUTELA', 28928, 5221452, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (159, 9313, 'REGISTRO DE IMOVEIS DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 28258, 5221502, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (160, 9314, 'TABELIONATO DE NOTAS, DE PROTESTOS DE TITULOS E DE REGISTRO DE CONTRATO MARITIMOS', 29454, 5221502, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (161, 1595, 'CARTORIO DE REGISTRO DE IMOVEIS E OUTROS', 26161, 5221551, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (162, 9315, 'CARTORIO 1º OFICIO DE NOTAS E REGISTRO GERAL DE IMOVEIS', 25163, 5221601, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (163, 9316, 'CARTORIO DO 2º DE NOTAS, REGISTRO DE PESSOAS JURIDICAS TITULOS, DOCUMENTOS E PROTESTO', 26898, 5221601, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (164, 1596, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS', 25668, 5221601, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (165, 1597, '2.CIVEL E ANEXOS', 24877, 5221700, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (166, 7401, 'CARTORIO REG. CIV. PES. NAT. E TABELIONATO DE NOTAS', 27466, 5221700, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (167, 9317, 'CARTORIO DO 1° OFICIO DE NOTAS E DE REGISTRO DE IMOVEIS', 26757, 5221700, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (168, 9318, 'REGISTRO GERAL DE IMOVEIS E REGISTRO DE T. E DOCUMENTOS', 28787, 5221809, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (169, 9319, 'TABELIONATO DE NOTAS, REGISTRO DE T. E PROTESTOS DE T.', 29512, 5221809, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (170, 1598, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS', 26153, 5221858, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (171, 1599, 'REGISTRO DE IMOVEIS ', 28407, 5221908, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (172, 9320, 'TABELIONATO DE NOTAS,PROTESTO DE TITULOS, TABELIONATO E DE REGISTRO DE CONTRATOS MARITIMOS', 145797, 5221858, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (173, 9321, 'TABELIONATO DE NOTAS DE PROTESTO DE TITULOS, TABELIONATO E OFICIALATO DE REGISTRO DE CONTRATOS MARITIMOS', 154443, 5221908, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (174, 9322, 'VIANOPOLIS CARTORIO DO 2.º OFICIO DE NOTAS', 29579, 5222005, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (175, 1962, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 26278, 5222005, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (176, 1600, '1º SERVICO NOTARIAL E REGISTRAL', 24745, 5222054, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (177, 1601, 'CARTORIO DO 2° OFICIO EXTRAJUDICIAL', 30270, 2100055, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (178, 9323, 'CARTORIO DO 1º OFICIO EXTRAJUDICIAL', 30189, 2100055, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (179, 1602, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO', 31666, 2100105, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (180, 1603, '2° OFICIO DE ALCANTARA', 29769, 2100204, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (181, 1963, 'SERVENTIA EXTRAJUDICIAL DE ALDEIAS ALTAS-MA', 31245, 2100303, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (182, 1604, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO', 31682, 2100402, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (183, 1605, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO', 147942, 2100477, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (184, 9324, 'SERVENTIA EXTRAJUDICIAL DO 1º OFICIO', 31526, 2100501, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (185, 1606, 'CARTORIO DO 2° OFICIO', 30254, 2100501, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (186, 1607, 'SERVENTIA EXTRAJUDICIAL', 31138, 2100600, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (187, 1608, 'SERVENTIA EXTRAJUDICIAL DA COMARCA DE ANAJATUBA-MA', 30114, 2100709, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (188, 6941, 'OFICIO UNICO', 30924, 2100808, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (189, 1609, 'SERVENTIA EXTRAJUDICIAL DO 1º OFICIO', 31518, 2100907, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (190, 1610, 'CARTORIO DO 1º OFICIO EXTRAJUDICIAL', 30098, 2100956, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (191, 9325, 'SERVENTIA EXTRAJUDICIAL DO 1º OFICIO', 29611, 2101004, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (192, 1611, 'CARTORIO DO 2º OFICIO EXTRAJUDICIAL', 30353, 2101004, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (193, 1612, 'SERVENTIA EXTRAJUDICIAL UNICA', 31740, 2101103, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (194, 1614, 'CARTORIO EXTRAJUDCIAL DO 2° OFICIO DE BACABAL', 30585, 2101202, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (195, 6871, '3º OFICIO EXTRAJUDICIAL DE BACABAL', 29892, 2101202, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (196, 9326, 'CARTORIO DO 1 OFICIO EXTRAJUDICIAL', 30023, 2101202, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (197, 1613, 'CARTORIO EXTRAJUDICIAL 4º OFICIO', 30601, 2101202, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (198, 9327, 'SERVENTIA EXTRAJUDICIAL DE OFICIO UNICO ', 148692, 2101251, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (199, 1964, 'SERVENTIA EXTRAJUDICIAL DE OFICIO UNICO', 31294, 2101301, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (200, 9328, 'CARTORIO DO 1º OFICIO', 30106, 2101400, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (201, 10693, 'CARTORIO DO 1° OFICIO', 66662, 1503606, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (202, 9329, 'CARTORIO NOGUEIRA 1.º OFICIO EXTRAJUDICIAL - 009', 30676, 2101509, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (203, 1616, 'SERVENTIA EXTRAJUDICIAL DO 2º. OFICIO', 31617, 2101509, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (204, 9330, 'CARTORIO DO 1º OFICIO EXTRAJUDICIAL', 30155, 2101608, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (205, 9331, 'SERVICO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 28977, 5212808, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (206, 1164, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES E TUTELAS', 27110, 5212907, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (207, 9332, 'CART. DE NOTAS , PROT, TIT.  DOC, TAB DE NOTAS, REG,  CONT. MARITIMOS REG. IMOVEIS REG PESSOAS JURIDICAS', 25106, 5212907, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (208, 1165, 'KAISON NEVES DE FREITAS', 27870, 5213004, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (209, 9333, 'TABELIONATO DE NOTAS E PROTESTOS, OFICIO DO REGISTRO DE IMOVEIS TITULOS E DOC, E PESSOAS JURIDICAS', 29413, 5213004, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (210, 9334, 'CARTORIO DE REGISTRO DE IMOVEIS, 1° OFICIO DE  NOTAS, PESSOAS JURIDICAS TITULOS E DOCUMENTOS E PROTESTO, REGISTRO CIVIL DAS PESSOAS NATURAIS', 26369, 5213053, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (211, 1166, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 147256, 5213087, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (212, 9335, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS DOC. E PROTESTOS TABELIAO 2º DE NOTAS E ESCRIVAO DO 2º CIVEL', 26559, 5213087, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (213, 9336, 'CART. REG. IMOVEIS E TAB 1 DE NOTAS', 25114, 5213087, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (214, 9337, '1º SERVICO NOTARIAL E REGISTRO DE IMOVEIS', 24752, 5213103, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (215, 1167, 'CARTORIO DE REGISTRO CIVIL', 25387, 5213103, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (216, 9338, '2º OFICIO DE NOTAS E ANEXOS', 24893, 5213103, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (217, 9339, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS', 26237, 5213400, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (218, 1168, 'SERVICO DE NOTAS, PROT. DE TITULOS, TABEL. E REG. DE CONTRATOS MARITIMOS, REG. DE IMOVEIS, REG. TITULOS E DOC., CIVIL DAS PESS. JUR. E CIVIL, DAS PESS. NAT. E DE INTERD. E TUTELA.', 28936, 5213400, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (219, 1241, 'CARTORIO DE REGISTRO CIVIL E NOTAS DO DISTRITO DE CRISTAL DO NORTE-ES', 22178, 3204054, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (220, 1072, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 23440, 3204104, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (221, 1242, 'PINHEIRO CARTORIO DO REGISTRO CIVIL E TABELIONATO', 24224, 3204104, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (222, 9132, 'CARTORIO DO 1º OFICIO ', 22863, 3204104, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (223, 1243, 'CARTORIO REGISTRO CIVIL ALVES DO VALE', 149625, 3204203, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (224, 9133, 'CARTORIO DE TABELIONATO DA SEDE', 148866, 3204203, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (225, 9134, 'CARTORIO DO 1º OFICIO DE REGISTO GERAL DE IMOVEIS E ANEXOS ', 23085, 3204203, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (226, 6867, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE ITAMIRA-ES', 23580, 3204252, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (227, 1244, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE PONTO BELO', 23390, 3204252, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (228, 1248, 'CARTORIO DE REGISTRO CIVIL E NOTAS ', 22103, 3204302, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (229, 9135, 'CARTORIO DO 1º OFICIO REGISTRO GERAL DE IMOVEIS E ANEXOS', 23119, 3204302, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (230, 6940, 'RIO BANANAL CARTORIO DE NOTAS E REGISTRO CIVIL', 24463, 3204351, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (231, 9136, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS - DISTRITO DE SAO JORGE DE TIRADENTES', 145003, 3204351, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (232, 9137, 'CARTORIO DO 1º OFICIO', 22889, 3204351, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (233, 9138, 'REGISTRO CIVIL E TABELIONATO', 24299, 3204401, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (234, 9139, 'CARTORIO DO 1º OFICIO DE RIO NOVO DO SUL(ES) - REG. GERAL DE IMOVEIS, REG. DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS E PROTESTO DE TITULOS E LETRAS', 23093, 3204401, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (235, 1073, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE RIO NOVO DO SUL-ES', 22582, 3204401, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (236, 1074, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DA SEDE DE SANTA LEOPOLDINA', 23531, 3204500, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (237, 1250, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO - DJALMA COUTINHO', 22343, 3204500, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (238, 1249, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE VILA DE MANGARAI', 23630, 3204500, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (239, 9140, 'CARTORIO 1º OFICIO', 21634, 3204500, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (240, 9141, 'CARTORIO DO 1º OFICIO DA COMARCA DE SANTA MARIA DE JETIBA ', 22996, 3204559, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (241, 1075, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DO DISTRITO DA SEDE DE SANTA MARIA DE JETIBA', 23648, 3204559, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (242, 9142, 'CARTORIO REGISTRO CIVIL E TABELIONATO (GARRAFAO)', 23820, 3204559, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (243, 1252, 'SANTA TERESA CARTORIO DO REGISTRO CIVIL E NOTAS ', 24471, 3204609, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (244, 6868, 'REGISTRO CIVIL E TABELIONATO DE ALTO CALDEIRAO', 24380, 3204609, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (245, 1078, 'REGISTRO CIVIL E TABELIONATO DE SANTO ANTONIO DO CANAA', 24489, 3204609, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (246, 9143, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO - DISTRITO DE SAO JACINTO', 145110, 3204609, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (247, 1077, 'REGISTRO CIVIL E TABELIONATO DA SEDE NILZA REICH NUNES', 24364, 3204609, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (248, 9144, 'CARTORIO DE PROTESTO DE TITULOS E TABELIONATO', 21949, 3204609, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (249, 1251, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE ALTO SANTA MARIA', 22434, 3204609, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (250, 1076, 'REGISTRO CIVIL E TABELIONATO DE 25 DE JULHO', 24372, 3204609, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (251, 9145, 'CARTORIO DO 1º OFICIO', 22921, 3204609, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (252, 1253, 'CARTORIO DE NOTAS E REGISTRO CIVIL', 21857, 3204658, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (253, 9146, 'CARTORIO DO 1º OFICIO', 22848, 3204658, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (254, 9147, 'CARTORIO DO 2º OFICIO DE SAO GABRIEL DA PALHA.ES', 23143, 3204708, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (255, 9148, 'CARTORIO DE REGISTRO CIVIL DA SEDE', 150904, 3204708, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (256, 9149, 'CARTORIO 1º OFICIO REGISTROS E PROTESTOS', 21709, 3204708, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (257, 1254, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE VILA FARTURA', 150896, 3204708, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (258, 7594, 'CARTORIO DE TABELIONATO DA SEDE', 22418, 3204708, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (259, 9150, 'CARTORIO DE NOTAS - DISTRITO VILA FARTURA', 22087, 3204708, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (260, 1256, 'CARTORIO REGISTRO CIVIL E TABELIONATO', 23796, 3204807, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (261, 9151, '1º OFICIO (SERVICO NOTARIAL E REGISTRAL)', 21352, 3204807, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (262, 1079, 'CARTORIO DO REGISTRO CIVIL TABELIONATO DA SEDE', 23937, 3204807, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (263, 1255, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE AIRITUBA', 22426, 3204807, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (264, 9152, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO - DISTRITO DE ITAUNINHAS', 145169, 3204906, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (265, 9153, 'SAO MATEUS CARTORIO DO SEGUNDO OFICIO', 24521, 3204906, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (266, 9154, 'SAO MATEUS CARTORIO DO 3º OFICIO DE NOTAS', 24505, 3204906, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (267, 1258, 'SAO MATEUS CARTORIO DO REGISTRO CIVIL E NOTAS DO DISTRITO DE BARRA NOVA', 24513, 3204906, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (268, 9155, 'CARTORIO DE REGISTRO CIVIL  E TABELIONATO', 22004, 3204906, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (269, 1257, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DA SEDE DE SAO MATEUS-ES', 23549, 3204906, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (270, 9156, 'SAO MATEUS CARTORIO DO 1º. OFICIO', 24497, 3204906, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (271, 1082, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SANTA JULIA', 22152, 3204955, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (272, 1081, 'CARTORIO CIVIL E TABELIONATO DE SAO JACINTO', 21766, 3204955, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (273, 1259, 'SAO ROQUE DO CANAA CARTORIO DE REGISTRO CIVIL E TABELIONATO ', 24539, 3204955, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (274, 1083, 'SERRA - CARTORIO DE REGISTRO CIVIL E TABELIONATO DO DISTRITO DE CARAPINA, SERRA-ES - CARTORIO ANTONIO MARIA', 24547, 3205002, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (275, 9157, 'CARTORIO DO 1º OFICIO 2A. ZONA DA SERRA', 22954, 3205002, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (276, 9158, 'CARTORIO DO 1º OFICIO DA 1ª ZONA DA SERRA-ES', 23663, 3205002, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (277, 1261, 'SERRA CARTORIO DO REGISTRO CIVIL E TABELIONATO CORIOLANO PEREIRA PIMENTEL', 24554, 3205002, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (278, 1260, 'REGISTRO CIVIL E TABELIONATO DA SEDE - SERRA/ES', 24349, 3205002, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (279, 1262, 'CARTORIO DE NOTAS E REGISTRO CIVIL  DO DISTRITO DE CALOGI', 21865, 3205002, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (280, 1263, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE SOORETAMA ', 22632, 3205010, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (281, 6869, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DA SEDE', 22400, 3205036, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (282, 9159, 'CARTORIO 1º OFICIO PROTESTOS REGISTRO DE IMOVEIS TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 21675, 3205036, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (283, 1264, 'CARTORIO DE NOTAS E REGISTRO CIVIL DE JACIGUA', 21899, 3205036, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (284, 9160, 'TABELIONATO DE NOTAS DA SEDE DA COMARCA DE VENDA NOVA DO IMIGRANTE, ES (CARTORIO LOUREIRO)', 21907, 3205069, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (285, 9161, 'CARTORIO DO 1º OFICIO DA COMARCA DE VENDA NOVA DO IMIGRANTE', 23002, 3205069, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (286, 7420, 'CARTORIO DO REGISTRO CIVIL DA SEDE DA COMARCA DE VENDA NOVA DO IMIGRANTE/ES (CARTORIO BELING)', 152934, 3205069, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (287, 1266, 'CARTORI DE REGISTRO CIVIL E TABELIONATO DE ARACATIBA', 21568, 3205101, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (288, 1265, 'VIANA CARTORIO DE TABELIONATO E REGISTRO CIVIL', 24604, 3205101, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (289, 9162, 'CARTORIO DO 1º OFICIO DE VIANA', 23101, 3205101, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (290, 1267, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DO DISTRITO DE VILA PAVAO - COMARCA DE NOVA VENECIA', 24190, 3205150, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (291, 1269, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 22236, 3205176, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (292, 1268, 'CARTORIO JOSE DE SOUZA REGISTRO CIVIL E NOTAS', 23705, 3205176, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (293, 9163, 'VILA VELHA 2º OFICIO', 24612, 3205200, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (294, 1087, 'VILA VELHA CARTORIO REGISTRO CIVIL E TABELIONATO DE SAO TORQUATO', 24646, 3205200, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (295, 1086, 'VILA VELHA CARTORIO DE REGISTRO CIVIL E TABELIONATO DO DISTRITO DO IBES', 24638, 3205200, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (296, 9164, 'CARTORIO DO 3° OFICIO DE NOTAS - VILA VELHA/ES', 23168, 3205200, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (297, 1270, 'VILA VELHA CARTORIO DO REGISTRO CIVIL E TABELIONATO', 24620, 3205200, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (298, 1084, 'CARTORIO LEONARDO AZEVEDO', 23713, 3205200, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (299, 9165, 'REGISTRO IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO 1ª ZONA DE VILA VELHA', 24455, 3205200, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (300, 1085, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DO DISTRITO DE ARGOLAS', 22541, 3205200, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (301, 9166, 'CARTORIO CONTADOR, DISTRIBUIDOR, PARTIDOR E DEPOSITARIO PUBLICO DA COMARCA DE VILA VELHA - FORO JUDICIAL NAO OFICIALIZADO - SOB INTERVENCAO DO TJ/ES', 21774, 3205200, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (302, 9167, 'CARTORIO 1 OFICIO DE VILA VELHA 2 ZONA', 21600, 3205200, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (303, 1106, 'CARTORIO DE REGISTRO CIVIL', 25353, 5204003, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (304, 1107, 'REGISTRO DE IMOVEIS, TABELIONATO DE NOTAS E ANEXOS', 28548, 5204102, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (305, 9168, 'SERVICOS DE NOTAS, PROTESTO DE TITULOS, TABELIONADO E REGISTRO DE CONTRATOS MARITIMOS, REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS, CIVIL DAS PESSOAS NATURAIS E ', 29215, 5204201, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (306, 9169, 'REGISTRO DE IMOVEIS', 28233, 5204300, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (307, 1080, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 23374, 3204906, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (308, 1293, 'SERV. TAB. NOTAS, PROTESTOS, REG. IMOVEIS, CIVIL, TIT. DOC., PESS. JURID.,CONT. MARITIMOS', 28878, 5204250, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (309, 1294, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 28035, 5204300, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (310, 9170, 'CARTORIO DE REG. DE IMOVEIS E TAB. 1º DE NOTAS', 25320, 5204409, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (311, 1295, 'REGISTRO CIVIL E TABELIONATO 3 DE NOTAS', 28159, 5204409, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (312, 9171, '2º SERVICO REGISTRAL E NOTARIAL', 24943, 5204409, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (313, 1296, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 25825, 5204508, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (314, 9172, 'REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 28357, 5204508, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (315, 9173, 'CALDAS NOVAS CARTORIO DO SEGUNDO OFICIO NOTAS', 25072, 5204508, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (316, 1297, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES ,TUTELAS E TABELIONATO DE NOTAS ', 146746, 5204607, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (317, 1298, 'SERVICOS DE NOTAS DE PROTESTOS DE TITULOS E REGISTRO DE CONTRATOS MARITIMOS, CIVIL DAS PESSOAS JURIDICAS', 29066, 5204607, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (318, 1299, 'CARTORIO K. PAULA', 27425, 5204656, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (319, 9174, 'SERVICO DE TABELIONATO DE NOTAS, REGISTRO DE IMOVEIS, PROTESTOS E ANEXOS', 29017, 5204656, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (320, 1108, 'CARTORIO REGISTRO DE IMOVEIS, CIVIL PESSOAS NATURAIS E TABELIONATO 1° DE NOTAS (TABELIONATO MIRANDA)', 27607, 5204706, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (321, 1109, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 25767, 5204805, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (322, 9175, 'CARTORIO 1º OFICIO REGISTRO DE IMOVEIS DE ANEXOS - CARTORIO MIGUEL LUCAS', 25189, 5204805, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (323, 1300, 'TABELIONATO DE NOTAS, PROTESTO DE TITULOS, REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS, REGISTRO CIVIL DAS PESSOAS JURIDICAS E DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS E REGISTRO DE C', 29496, 5204854, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (324, 1301, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS, TABELIONATO DO 2º DE NOTAS. ECRIVANIA 2º DO CIVEL E REGISTRO DE IMOVEIS', 26591, 5204904, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (325, 9176, 'SERVICOS DE NOTAS, DE PROTESTOS DE TITULOS,TABELIONATO E REGISTRO DE CONTRATOS MARITIMOS', 26807, 5204904, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (326, 1110, 'CARTORIO DO UNICO OFICIO', 27409, 5204953, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (327, 9177, 'TABELIONATO DE NOTAS, DE PROTESTO DE TITULOS, TABELIONATO E, TABELIONATO E OFICIALATO DE REGISTRO DE CONTRATOS MARITIMOS', 145904, 5205000, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (328, 1111, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 25478, 5205000, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (329, 1302, 'CARTORIO DE REGISTRO DE IMOVEIS DE REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES, TUTELAS E PROTESTOS', 26070, 5205000, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (330, 1112, 'CASTELANDIA CARTORIO DE REGISTRO DE IMOVEIS GERAL E ANEXOS', 27680, 5205059, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (331, 1303, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 25536, 5205109, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (332, 9178, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS CIVIS E PESSOA JURIDICA,PROTESTO E SEGUNDO TABELIONATO DE NOTAS', 26625, 5205109, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (333, 1113, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 25890, 5205109, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (334, 9179, 'TABELIONATO PRIMEIRO DE NOTAS E REGISTRO DE IMOVEIS', 29553, 5205109, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (335, 1304, 'REG DE IMOVEIS, REG TITULOS E DOC,CIVIL PESSOA JURIDICA, CIVIL PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 24950, 5205307, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (336, 9180, 'TABELIONATO DE NOTAS, PROTESTOS E TITULOS E REGISTRO DE CONTRATOS MARITIMOS', 29041, 5205307, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (337, 9181, 'REGISTRO DE IMOVEIS PEDROSO', 28423, 5205406, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (338, 9182, '2º TABELIONATO DE NOTAS', 24968, 5205406, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (339, 9183, 'CARTORIO DO REGISTRO CIVIL E PESSOAS NATURAIS', 27219, 5205406, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (340, 9184, '1° TABELIONATO DE NOTAS', 24703, 5205406, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (341, 1305, 'CEZARINA CARTORIO DE REGISTRO DE IMOVEIS', 27706, 5205455, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (342, 1306, 'SERVICOS DE TABELIONATO DE NOTAS, DE PROTESTO DE TITULOS, TABELIONATO E OFICIALATO DE REGISTRO DE CONTRATOS MARITIMOS, OFICIALATO DE REGISTRO DE IMOVEIS, DE REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS', 29330, 5205471, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (343, 9185, 'REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS INT. TUT. ', 147389, 5205497, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (344, 9186, 'TABELIONATO DE NOTAS E PROTESTO, OFICIALATO DE REGISTRO DE CONTRATOS MARITIMOS', 147371, 5205497, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (345, 9187, 'TABELIONATO DE NOTAS, DE PROTESTO DE TITULOS, TABELIONATO E OFICIALATO DE CONTRATOS MARITIMOS', 150466, 5205513, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (346, 1307, 'CARTORIO DE REGISTROS DE COCALZINHO', 147397, 5205513, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (347, 1308, 'TABELIONATO DE NOTAS, DE PROTESTO DE TITULOS, OFICIALATO DE REGISTRO DE IMOVEIS, DE REGISTRO DE TITULOS E DOCUMENTOS, CIVEL DAS PESSOAS JURIDICAS E CIVEL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELA', 29439, 5205521, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (348, 7317, 'SERVICO DISTRITAL DO PORTAO', 129833, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (349, 1309, 'SERVICOS DE NOTAS, PROT. DE TITULOS, TABEL. E REG. DE CONTRATOS MARITIMOS, REG. DE IMOVEIS, REG. DE TITULOS E DOC., CIVIL DAS PESS. JUR. E CIVIL DAS PESS. NAT. E DE INTERD. E TUTELA ', 29181, 5205703, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (350, 1114, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 27045, 5205802, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (351, 9188, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 26336, 5205802, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (352, 9189, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS, TABELIONATO 2º DE NOTAS E OFICIALATO DE REGISTRO DE CONTRATOS MARITIMOS. ', 26872, 5205802, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (353, 9190, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS E TABELIONATO 2° DE NOTAS E ESCRIVANIA 2° DO CIVEL.', 28647, 5205901, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (354, 9191, 'PRIMEIRO SERVICO NOTARIAL E REGISTRO DE IMOVEIS', 27953, 5205901, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (355, 1115, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 28084, 5205901, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (356, 9192, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO (1º) DE NOTAS', 26195, 5206206, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (357, 1116, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 25627, 5206206, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (358, 9193, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTO E TABELIONATO SEGUNDO DE NOTAS', 26609, 5206206, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (359, 1117, 'REGISTRO DE IMOVEIS, REGISTRO TITULOS E DOCUMENTOS CIVIL DAS PESSOAS JURIICAS E CIVIL DAS PESSOAS NATURAIS DE INTERDICAO E TUTELA, POTESTOS E TABELIONATO', 27730, 5206305, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (360, 1118, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 27300, 5206404, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (361, 9194, 'CARTORIO DO 1° OFICIO DE NOTAS E REGISTRO DE IMOVEIS', 26765, 5206404, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (362, 9195, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS E TABELIONATO 2O DE NOTAS', 28639, 5206404, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (363, 9243, '1º TABELIONATO DE PROTESTO E REGISTRO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS DE GOIANIA', 24844, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (364, 9244, 'CARTORIO DO 3º TABELIONATO DE NOTAS', 26948, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (365, 9245, 'CARTORIO DO 6º TABELIONATO DE NOTAS', 27383, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (366, 9246, 'CARTORIO DE REGISTRO DE IMOVEIS DA 4ª CIRCUNSCRICAO', 26054, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (367, 9247, 'GOIANIA OITAVO TABELIONATO DE NOTAS', 27763, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (368, 9248, 'GOIANIA CARTORIO DO SETIMO OFICIO DE NOTAS', 27755, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (369, 9249, 'CARTORIO DE REGISTRO DE IMOVEIS DA 2ª CIRCUNSCRICAO', 26039, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (370, 9250, 'REGISTRO DE PESSOA JURIDICA, TITULO, DOCUMENTO E PROTESTO, 2ª TABELIONATO DE NOTAS E 2° CIVEL', 28589, 5208806, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (371, 9251, 'REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 28365, 5208806, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (372, 1128, 'CARTORIO DE REGISTRO CIVIL E 3º TABELIONATO DE NOTAS', 25734, 5208806, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (373, 9252, 'CARTORIO RE REGISTRO CIVIL E TABELIONATO DE NOTAS', 27441, 5208905, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (374, 9253, 'CARTORIO DE REGISTRO CIVIL', 25379, 5208905, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (375, 9254, 'TABELIONATO 1º DE NOTAS E REGISTRO GERAL DE IMOVEIS', 29389, 5208905, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (376, 9255, 'TABELIONATO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO (2º) DE NOTAS', 29546, 5208905, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (377, 1129, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE BUENOLANDIA', 25726, 5208905, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (378, 9256, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS, TABELIONATO DE NOTAS', 148924, 5208905, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (379, 1674, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 25932, 5208905, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (380, 1130, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS DE COLONIA DE UVA', 25700, 5208905, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (381, 1131, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 25858, 5209101, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (382, 9257, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO 2º DE NOTAS', 26617, 5209101, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (383, 9258, 'REGISTRO DE IMOVEIS E TABELIONATO 1° DE NOTAS', 28324, 5209101, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (384, 1132, 'SERVICOS DE NOTAS, PROTESTO DE TITULOS,REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS CIVIL DAS PESSOAS NATURAIS E INTERDICOES E TUTELAS', 29223, 5209150, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (385, 9259, '1ºTABELIONATO DE NOTAS, PROTESTOS DE TITULOS, REGISTRO DE CONTRATOS MARITIMOS', 24869, 5209200, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (386, 1133, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, REGISTRO DE IMOVEIS, TABELIONATO 2º DE NOTAS E ESCRIVANIA 2º DO CIVEL', 28779, 5209200, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (387, 9260, 'REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 28472, 5209291, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (388, 1134, 'REGISTRO CIVIL E PESSOAS NATURAIS', 28142, 5209291, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (389, 1135, 'CARTORIO DO REGISTRO CIVIL DE GUARANI DE GOIAS-GO', 27128, 5209408, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (390, 9261, 'REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 28464, 5209408, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (391, 9262, 'REGISTRO DE IMOVEIS, TIT. DOC. PROT. PES. JUR. E TABELIONATO DE NOTAS.', 28563, 5209606, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (392, 1686, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 145938, 5209705, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (393, 9263, 'REGISTRO DE IMOVEIS E TABELIONATO 1° DE NOTAS', 28308, 5209705, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (394, 9264, 'REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS ', 28498, 5209804, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (395, 1137, 'SERVICOS DE NOTAS, PROTESTOS DE TITULOS, TABELIONATO, REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS E DE INTERDICAO E TUTELA', 29249, 5209903, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (396, 1138, 'SERVICOS DE NOTAS DE PROTESTOS DE TITULOS, REGISTRO DE IMOVEIS, DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS ', 29074, 5209937, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (397, 9265, 'REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONTO DE NOTAS', 28506, 5209952, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (398, 1139, 'CARTORIO DO REGISTRO CIVIL DE INHUMAS', 27136, 5210000, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (399, 9266, 'CARTORIO DO 2º OFICIO DE NOTAS, REGISTRO DE TITULOS E DOCUMENTOS E PROTESTO', 26914, 5210000, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (400, 9267, 'TABELIONATO 1º DE NOTAS E REGISTRO GERAL DE IMOVEIS', 29397, 5210000, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (401, 9340, 'REGITRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS', 26740, 5213509, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (402, 1691, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS', 25684, 5213509, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (403, 1692, 'CARTORIO', 25148, 5213707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (404, 9341, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS E PROTESTOS E TABELIONATO DE NOTAS', 26419, 5213707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (405, 1693, 'CARTORIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, PROTESTO, NOTAS E REGISTRO CIVIL', 26484, 5213756, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (406, 9342, 'SERVICO DE NOTAS, PROT. DE TITULOS, TABEL. E REG. DE CONTRATOS MARITIMOS, REG. DE IMOVEIS, REG. DE TITULOS E DOC., CIVIL DAS PEES. JUR. E CIVIL DAS PEESS. NAT. E DE INTERD. E TUTELA', 28910, 5213772, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (407, 9343, '2º TABELIONATO DE NOTAS E ANEXOS', 24976, 5213806, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (408, 9344, 'PRIMEIRO SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS', 26187, 5213806, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (409, 1694, 'CARTORIO REGISTRO CIVIL E 3º TABELIONATO DE NOTAS', 27516, 5213806, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (410, 9345, 'REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TIITULOS E DOCUMENTOS, PROTESTOS E 1. TABELIONATO DE NOTAS', 28449, 5213855, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (411, 1695, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICAO E TUTELA, REGISTRO DE CONTRATO MARITIMO E TABELIONATO DE NOTAS', 27672, 5213855, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (412, 1696, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO 2º DE NOTAS E ESCRIVANIAS 2º DO CIVEL E REGISTRO DE PESSOAS NATURAIS, INTERDICOES E TUTELAS E CONTRATO MARITIMOS', 26534, 5213905, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (413, 9346, 'REGISTRO DE IMOVEIS, TABELIONATO 1º DE NOTAS E PROTESTOS DE TITULOS', 24695, 5213905, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (414, 1697, 'CARTORIO DE REGISTRO DE IMOVEIS DE REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS, CIVIL DA PESSOAS NATURAIS E DE INTERDICOES E TUTELA', 26088, 5214002, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (415, 9347, 'SERVICO DE NOTAS, PROTESTO DE TITULOS, TABELIONATO E DE REGISTRO DE CONTRATOS MARITIMOS.', 28944, 5214002, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (416, 1698, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 28076, 5214002, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (417, 1699, 'CARTORIO DE REGISTRO DE IMOVEIS, DE TITULOS, DOCUMENTOS E PROTESTO, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS, DE INTERDICOES E TUTELAS, DE CONTRATOS MARITIMOS E TABELIONATO DE NOTAS.', 26393, 5214051, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (418, 1700, 'SERV. DE NOTAS, PROT., TAB., REG. IMOVEIS, TIT. E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DA PES. NATURAIS E DE INTERDICAO E TUTELAS.', 28860, 5214101, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (419, 1701, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 25833, 5214408, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (420, 9348, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS, TABELIAO 2º DE NOTAS E ESCRIVAO 2º CIVEL', 28720, 5214408, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (421, 9349, '1º TABELIONATO DE NOTAS E REGISTRO DE IMOVEIS', 24828, 5214507, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (422, 9350, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS, TABELIONATO 2º, DE NOTAS E ESCRIVANIA 2º CIVEL    ', 26575, 5214507, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (423, 1702, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 25916, 5214507, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (424, 9351, 'CARTORIO REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO 2 DE NOTAS', 27649, 5214606, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (425, 9352, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 26260, 5214606, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (426, 1704, 'REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS, TABELIONATO DE NOTAS E REGISTRO CIVIL', 28456, 5214705, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (427, 1705, 'CARTORIO DE SERVICOS DE REGISTRO DE IMOVEIS, DE REG. DE TITULOS E DOCUMENTO CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS ', 26682, 5214804, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (428, 1706, 'CARTORIO REGISTRO CIVIL E TABELIONATO DE NOTAS', 27565, 5214838, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (429, 1688, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 27284, 5211701, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (430, 1707, 'CARTORIO DE TABELIONATO DE NOTAS, DE PROTESTO DE TITULOS, TABELIONATO E OFICIALATO DE CONTRATOS MARITIMOS, OFICIALATO DE REGISTRO DE IMOVEIS, DE REGISTRO  DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JU', 26716, 5214838, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (431, 1708, 'SERVICO DE NOTAS, PROTESTOS DE TITULOS, REGISTRO DE CONTRATOS MARITIMOS, REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS, INTERDICAO E T', 28951, 5214861, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (432, 9353, 'SERVICOS DE NOTAS, REGISTRO DE IMOVEIS E REGISTRO DE TITULOS E DOCUMENTOS', 29256, 5214903, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (433, 1709, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 27144, 5214903, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (434, 9354, 'NOVA VENEZA CART. Iº OF. REG.DE IMOVEIS', 27896, 5215009, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (435, 1710, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 25601, 5215009, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (436, 9355, 'CAR.REG.IMOV.PES.JUR.TIT.DOC. E TAB NOTAS', 25080, 5215207, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (437, 1711, 'CARTORIO REGISTRO CIVIL E 2° TAB. NOTAS', 27490, 5215207, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (438, 1712, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 27268, 5215256, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (439, 9356, 'CARTORIO DE REG. DE IMOV., PESS. JUR., TIT., DOC., PROT., E TABELIONATO DE NOTAS', 25312, 5215256, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (440, 9357, 'REGISTRO DE DIMOVEIS E TABELIONATO 1º DE NOTAS', 28225, 5215306, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (441, 1713, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 147769, 5215306, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (442, 9358, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTO, TABELIONATO 2º DE NOTAS E ESCRIVANIA 2º DO CIVEL', 28621, 5215306, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (443, 9359, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATOS DE NOTAS DO DISTRITO JUDICIARIO DE OURO VERDE DE GOIAS COMARCA DE ANAPOLIS ESTADO DE GOIAS.', 26443, 5215405, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (444, 1714, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E INTERDICOES E TUTELAS', 28027, 5215504, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (445, 9360, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 26435, 5215504, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (446, 9361, 'TABELIONATO DE NOTAS, DE PROTESTO DE TITULOS, TABELIONATO E OFICIALATO DE REGISTRO DE CONTRATOS MARITIMOS', 26864, 5215603, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (447, 9362, 'CARTORIO DE REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS, CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 26963, 5215603, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (448, 9363, 'TAB. DE NOTAS, PROT. DE TIT., TAB. OF. REG.CONT. MART.,  REG. IMOVEIS, REG.TIT.,DOC., CV.PES. JUR.,CV PES.NAT., INT.E TUT.', 153825, 5215652, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (449, 7521, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS ', 152819, 5215652, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (450, 1715, 'CARTORIO REGISTRO CIVIL E 3 TABELIONATO DE NOTAS ', 27508, 5215702, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (451, 9364, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 26344, 5215702, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (452, 9365, 'CARTORIO DO REGISTO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS E TABELIONATO 2º DE NOTAS', 26997, 5215702, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (453, 9366, 'CARTORIO DE REGISTRO DE IMOVEIS, DE REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDECAS E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES. ', 26385, 5215801, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (454, 7522, 'REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES E TUTELAS ', 146803, 5215801, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (455, 9367, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS, TABELIONATO DE NOTAS E REGISTRO CIVIL DAS PESSOAS NATURAIS', 26468, 5215900, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (456, 9368, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS E PROTESTO', 26633, 5216007, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (457, 1716, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 27037, 5216007, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6262, 5390, 'ESCRIVANIA DE PAZ', 105874, 4210407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (458, 9369, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 26310, 5216007, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (459, 5153, 'SERVICO NOTARIAL MELQUISEDEC', 96339, 1100122, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (460, 5925, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE JURITIS-SP', 117713, 3517109, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (461, 5927, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE PIONEIROS, DA COMARCA DE GUARA', 117531, 3517703, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (462, 5952, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE SIMOES, DA COMARCA DE CAFELANDIA', 118208, 3508801, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (463, 5164, 'REGISTRO CIVIL E TABELIONATO DE NOTAS DO DISTRITO DE CALAMA', 149146, 1100205, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (464, 5165, 'REGISTRO CIVIL E DE NOTAS DO DISTRITO DE ABUNA', 96206, 1100205, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (465, 5960, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE LAGOA BRANCA, DA COMARCA DE CASA BRANCA', 118083, 3510807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (466, 5971, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE JACIPORA, DA COMARCA DE DRACENA', 117523, 3514403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (467, 5724, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE MOURAO, DA COMARCA DE ADAMANTINA', 118117, 3528908, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (468, 5727, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE TECAINDA, DA COMARCA DE MARTINOPOLIS', 121848, 3529203, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (469, 5737, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE COSTA MACHADO, DA COMARCA DE MIRANTE DO PARANAPANEMA', 117945, 3530201, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (470, 7316, 'CARTORIO REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 82925, 4105607, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (471, 5750, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE ITAIUBA, DA COMARCA DE MONTE APRAZIVEL', 114553, 3531407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (472, 6298, 'OFICIAL DE REGISTRO CIVIL DAS PESSAS NATURAIS DO 27º SUBDISTRITO - TATUAPE', 114975, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (473, 433, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS', 11965, 2901106, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (474, 542, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE CAPIXABA', 1115, 1200179, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (475, 543, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE EPITACIOLANDIA', 836, 1200252, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (476, 546, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE MANCIO LIMA', 1040, 1200336, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (477, 550, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE SENADOR GUIOMARD', 1008, 1200450, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (478, 551, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE TARAUACA', 1016, 1200609, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (479, 552, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE XAPURI', 901, 1200708, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (480, 3983, 'MARIA LUZINETE ARAUJO PESSOA', 72314, 2515401, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (481, 4824, 'OFICIO UNICO DO DISTRITO DE SAO FRANCISCO/SE', 110924, 2806909, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (482, 4829, 'CARTORIO DO 3º OFICIO DA COMARCA DE TOBIAS BARRETO/SE', 110999, 2807402, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (483, 75, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES DE NOTAS DE TABOCAS DO BREJO VELHO', 6031, 2930907, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (484, 2702, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50955, 3165107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (485, 7177, 'OUTROS', 999999, NULL, NULL);
INSERT INTO cadastro.codigo_cartorio_inep VALUES (486, 6381, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE OASIS, DA COMARCA DE TUPI PAULISTA', 121269, 3555109, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (487, 6417, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 152611, 1716307, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (488, 6439, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 139022, 1718865, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (489, 6484, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE ALTO PORA, DA COMARCA DE PEDREGULHO', 121947, 3537008, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (490, 6529, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE ESMERALDA, DA COMARCA DE SANTA FE DO SUL', 122630, 3544509, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (491, 6541, 'SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 86181, 4104402, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (492, 6553, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DO 2º DISTRITO', 91397, 3301405, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (493, 6611, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 95877, 1100122, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (494, 6652, 'CARTORIO DE REGISTRO CIVIL DE ARARUNA-PB', 69757, 2501005, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (495, 5394, 'CARTORIO DE PAZ DE  MELEIRO', 105007, 4210803, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (496, 5605, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE NOGUEIRA', 118133, 3504305, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (497, 6204, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE DUPLO CEU, DA COMARCA DE PALESTINA', 117960, 3535002, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (498, 6115, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE GUACHOS, DA COMARCA DE MARTINOPOLIS', 117994, 3529203, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (499, 6011, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE AJAPI', 117853, 3508405, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (500, 6018, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE BACAETAVA, DA COMARCA DE BOITUVA', 121491, 3521002, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (501, 6022, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE TURIBA DO SUL, DA COMARCA DE ITAPEVA', 143149, 3521705, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (502, 6026, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE GRAMADINHO, DA COMARCA DE ITAPETININGA', 130567, 3522307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (503, 6120, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE CUIABA PAULISTA, DA COMARCA DE MIRANTE DO PARANAPANEMA', 117952, 3530201, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (504, 4460, 'SERVICO DISTRITAL MARQUES DE ABRANTES', 82487, 4127882, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (505, 5492, 'ESCRIVANIA DE PAZ DO DISTRITO DE RIO DUNA', 106732, 4207205, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (506, 6130, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE ITAQUERI DA SERRA, DA COMARCA DE RIO CLARO', 121673, 3523602, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (507, 6037, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE INGAS, DA COMARCA DE NOVA GRANADA', 114595, 3533007, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (508, 6038, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE MANGARATU, DA COMARCA DE NOVA GRANADA', 114603, 3533007, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (509, 6039, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE ONDA BRANCA, DA COMARCA DE NOVA GRANADA', 114611, 3533007, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (510, 6051, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE BATISTA BOTELHO, DA COMARCA DE PIRAJU', 124313, 3533809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (511, 6155, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE IGACABA, DA COMARCA DE PEDREGULHO', 121939, 3537008, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (512, 6158, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS (ANEXADO AO EXT317)', 114322, 3538105, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (513, 3666, 'SERVICO DISTRITAL DE SERRANOPOLIS DO IGUACU', 81539, 4126355, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (514, 4478, 'CARTORIO DO RCPN E NOTAS DO 11° DISTRITO DE CAMPOS DOS GOYTACAZES-RJ', 91173, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (515, 5344, 'CARTORIO SILVA', 105734, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (516, 5371, 'IPUMIRIM CARTORIO DE PAZ', 107326, 4207700, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (517, 5558, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE UNIAO DO OESTE', 144279, 4218855, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (518, 6164, 'CARTORIO DE NOTAS E OFICIO DO REGISTRO CIVIL', 113837, 3538709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (609, 7418, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE ITAMIRA', 148486, 3203601, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (519, 6068, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE ATLANTIDA DA COMARCA DE ADAMANTINA', 117044, 3516002, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (520, 6081, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE RIBEIRO DO VALE, DA COMARCA DE GUARARAPES', 119594, 3518206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (521, 6191, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE ASSISTENCIA, DA COMARCA DE RIO CLARO', 114579, 3543907, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (522, 3683, 'SERVICO DISTRITAL DE ALTO DO AMPARO.', 80952, 4127502, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (523, 3692, 'CARTORIO DO 2º OFICIO', 78782, 2205607, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (524, 3704, 'CARTORIO DO 2º OFICIO', 78691, 2207603, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (525, 3888, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE RIACHAO BOCANARTE', 145235, 2506806, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (526, 4699, 'CARTORIO DE RCPN DA 2ª CIRCUNSCRICAO DA CAPITAL', 89797, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (527, 5570, 'OFICIO UNICO DO DISTRITO DE AMPARO DO SAO FRANCISCO/SE', 110882, 2800100, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (528, 5652, 'SERVICO NOTARIAL E DE REGISTRO DE VACACAI DE SAO GABRIEL', 100867, 4318309, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (529, 7278, 'CARTORIO DO 2º OFICIO', 78576, 2209609, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (530, 7283, 'CARTORIO DO 2º OFICIO DO REGISTRO CIVIL', 78881, 2210904, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (531, 7284, 'CARTORIO DO 2º OFICIO', 78618, 2211209, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (532, 7287, '1º ARQUIVO PUBLICO DO ACERVO DE CASAMENTO', 148981, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (533, 7288, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 74278, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (534, 7289, 'CARTORIO DE REGISTRO CIVIL E ANEXOS', 81471, 4117107, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (535, 7290, 'CARTORIO DE AGUA BOA', 81083, 4117503, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (536, 7303, 'SERVICO NOTARIAL E REGISTRAL DE RIO BOM', 86785, 4122107, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (537, 7304, 'SERVICO REGISTRAL CIVIL E NOTARIAL', 87049, 4122404, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (538, 7307, 'SERVICO NOTARIAL E REGISTRAL OLIVEIRA', 86868, 4124004, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (539, 7312, 'CARTORIO DISTRITAL DE BORRAZOPOLIS/PR', 82149, 4103305, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (540, 7315, 'CARTORIO DE REGISTRO CIVIL E ANEXOS', 81406, 4104501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (541, 5370, 'IPIRA CARTORIO DE PAZ ', 107318, 4207601, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (542, 7318, 'CARTORIO REGISTRO CIVIL E TABELIONATO DO DISTRITO DE ALECRIM', 82891, 4107009, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (543, 7327, 'SERVICO DISTRITAL DE ITAPERUCU', 86298, 4111258, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (544, 7328, 'CARTORIO DISTRITAL DE AREIA BRANCA DOS ASSIS', 82107, 4114302, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (545, 7329, 'SERVICO DISTRITAL DE FLORIANO', 129916, 4115200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (546, 7330, 'RCPN 2º DISTRITO', 92627, 3300209, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (547, 7331, 'RCPN TERCEIRO DISTRITO SAO JOSE TURVO', 93088, 3300308, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (548, 7332, 'RCPN DO 4º DISTRITO DA COMARCA DE BOM JARDIM', 92866, 3300506, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (549, 7333, 'CARTORIO DO RCPN E NOTAS DE ROSAL-3 DISTRITO DA COMARCA DE BOM JESUS DO ITABAPOANA-RJ', 91231, 3300605, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (550, 7334, 'CARTORIO DO RCPN E TABELIONATO DE NOTAS DE CARABUCU, 4º DISTRITO DE BOM JESUS DO ITABAPOANA', 91298, 3300605, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (551, 7337, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 141143, 3157401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (552, 7338, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 148031, 3168903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (553, 7341, 'CA´TORIO DO REGISTRO CIVIL E ANEXOS', 62620, 5003702, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (554, 7342, 'DOURADINA CARTORIO DE PAZ E ANEXOS', 62653, 5004502, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (555, 7343, 'CARTORIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 62232, 5004700, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (556, 7346, 'CARTORIO MARINHO DO DISTRITO DE PARANA-MIRY', 67819, 1505106, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (557, 7352, 'CARTORIO DO 2º OFICIO', 147991, 5103205, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (558, 7354, '063743', 147900, 5103353, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (559, 7356, 'CARTORIO DE BRASILIA LEGAL - AVEIRO', 139378, 1501006, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (560, 7357, 'CARTORIO DE REGISTRO DO UNICO OFICIO DE BOM JESUS DO TOCANTINS', 66530, 1501576, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (561, 7358, 'CARTORIO DA VILA DO CARMO', 139725, 1502103, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (562, 7359, 'CARTORIO UNICO DE REGISTRO CIVIL E NOTAS', 71902, 2512101, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (563, 7360, 'CARTORIO DO REGISTRO CIVIL -5º DISTRITO', 75366, 2613909, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (564, 7361, 'CARTORIO DO 2º OFICIO', 78824, 2200301, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (565, 7362, 'CARTORIO DO TERCEIRO OFICIO', 79251, 2200400, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (566, 7363, 'CARTORIO DO REGISTRO CIVIL', 79111, 2200509, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (567, 7364, 'CARTORIO DO 2º OFICIO', 78816, 2200608, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (568, 7365, 'CARTORIO DO 2º OFICIO', 78683, 2200806, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (569, 7366, 'CARTORIO DO 2º OFICIO', 78766, 2200905, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (570, 7367, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NAURIAS - 2º OFICIO', 79137, 2201002, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (571, 7368, 'CARTORIO DO REGISTRO CIVIL E ANEXO DE NOTAS', 79152, 2201101, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (572, 7369, 'CARTORIO DO 2º OFICIO', 78642, 2201200, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (573, 7370, 'CARTORIO DO 3º OFICIO', 78964, 2201200, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (574, 7371, 'CARTORIO DO SEGUNDO OFICIO DA COMARCA DE BARRO DURO', 79228, 2201408, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (575, 7372, 'CARTORIO DO 2º OFICIO', 78741, 2201507, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (576, 7373, 'CARTORIO DO SEGUNDO OFICIO', 79210, 2201606, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (577, 7374, 'CARTORIO UNICO DO REGISTRO CIVIL', 79434, 2202208, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (578, 7375, 'NEIDIVAN AMORIM DOS SANTOS', 79541, 2202307, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (579, 7376, 'CARTORIO DO 2º OFICIO', 78568, 2202703, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (580, 7377, 'CARTORIO DO 2º OFICIO', 78626, 2202802, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (581, 7378, 'CARTORIO DO 3º OFICIO', 78949, 2202901, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (582, 7379, 'CARTORIO DO REGISTRO CIVIL', 79129, 2203008, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (583, 7380, 'CARTORIO DO 2º OFICIO', 78584, 2203206, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (584, 7381, 'CARTORIO DO 2º OFICIO', 78709, 2203602, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (585, 7383, '1º CARTORIO DO REGISTRO CIVIL', 77792, 2203909, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (586, 7384, '2º CARTORIO DO REGISTRO CIVIL', 77826, 2203909, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (587, 7385, 'CARTOTIO DO 2º OFICIO', 79509, 2204006, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (588, 7386, 'CARTORIO OFICIALIZADO DO 2º OFICIO', 79368, 2204303, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (589, 7387, 'CARTORIO DO 2º OFICIO', 78725, 2204501, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (590, 7388, 'CARTORIO DO 2 OFICIO', 78501, 2204709, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (591, 7389, 'CARTORIO DO 2º OFICIO', 78733, 2204808, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (592, 7390, 'CARTORIO UNICO DO REGISTRO GERAL', 79442, 2204907, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (593, 7391, 'CARTORIO DO 2º OFICIO REGISTRO CIVIL DE PESSOAS NATURAIS', 78915, 2205003, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (594, 7392, 'CARTORIO DO 2º OFICIO DE ITAUEIRA', 78840, 2205102, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (595, 7393, 'CARTORIO DO 2º OFICIO', 78600, 2205409, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (596, 7394, 'CARTORIO OFICIAL DO 3º OFICIO', 79343, 2205508, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (597, 7395, 'CARTORIO DO 2º OFICIO', 78774, 2205706, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (598, 7396, 'CARTORIO DO 2° OFICIO', 78543, 2205805, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (599, 7397, 'CARTORIO DO 3° OFICIO', 78923, 2205805, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (600, 7398, 'CARTORIO DO 2º OFICIO', 78675, 2206001, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (601, 7402, 'CARTORIO DE REGISTRO CIVIL E DAS PESSOAS NATURAIS', 25759, 5221809, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (602, 7403, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 27029, 5222005, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (603, 7405, 'CARTORIO DO 2º. OFICIO EXTRAJUDICIAL', 30411, 2101707, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (604, 7406, 'CARTORIO DO 2º OFICIO DE BEQUIMAO/MA', 30304, 2101905, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (605, 7408, 'SERVENTIA EXTRAJUDICIAL DO 2º OFICIO', 31609, 2102606, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (606, 7412, 'CARTORIO EXTRAJUDICIAL DO 2º OFICIO', 30635, 2108306, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (607, 7415, '2ª SERVENTIA EXTRAJUDICIAL DE SAO BERNARDO-MA', 29728, 2110609, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (608, 7416, 'SERVENTIA EXTRAJUDICIAL DO 2º OFICIO', 31567, 2111003, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (610, 7419, 'CARTORIO XAVIER NUNES', 23903, 3204203, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (611, 7421, 'CARTORIO DO 1º OFICIO DE NOTAS', 147934, 5200209, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (612, 7422, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 25452, 5200308, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (613, 7423, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICAO DE TUTELA', 28969, 5201454, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (614, 7424, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 28019, 5203302, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (615, 7425, 'CARTORIO REGISTRO CIVIL E PESSOAS NATURAIS', 27532, 5203500, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (616, 7426, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E INT. E TUT.', 153833, 5204409, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (617, 7427, 'CARTORIO DE REGISTRO CIVIL E PESSOAS NATURAIS', 25775, 5204904, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (618, 7428, '2º REGISTRO CIVIL E TABELIONATO DE NOTAS', 24927, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (619, 7429, 'CARTORIO DO REGIKSTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS', 26989, 5209804, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (620, 7430, 'SERVENTIA EXTRAJUDICIAL DE REGISTRO CIVIL DO 2º OFICIO', 31393, 2112407, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (621, 7432, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PIRACAIBA', 146191, 3103504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (622, 7435, 'CARTORIO DE REGISTRO CIVIL E NOTAS DISTRITO DE ARACATI COMARCA DE CATAGUASES', 37648, 3115300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (623, 7449, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 130773, 3144102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (624, 7453, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52662, 3124500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (625, 7456, '00070990901-60', 146795, 3134707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (626, 7463, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS DO DISTRITO DE CATURAMA', 8979, 2907558, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (627, 7464, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS', 8912, 2908804, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (628, 7466, 'LUCINEIDE SANTANA ARAUJO VILAS BOAS', 11379, 2910206, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (629, 7467, 'REGISTRO CIVIL DO DISTRITO DE ELISIO MEDRADO', 12849, 2910305, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (630, 7468, 'REGISTRO CIVIL DO DISTRITO DE MONTE CRUZEIRO', 12856, 2910305, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (631, 7476, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS C/FUNC.NOTORIAIS', 9621, 2913200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (632, 7477, 'CARTORIO DE REGISTRO CIVIL  C/ FUNCOES NOTARIAIS DO DISTRITO JUDICIARIO DE IGRAPIUNA COMARCA DE CAMAMU', 5959, 2913457, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (633, 7478, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12419, 2913804, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (634, 7480, 'CARTORIO DE REGISTRO CIVIL C/FUNCOES NOTARIAS', 5975, 2914109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (635, 14081, '3O.TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE TAUBATE/SP', 113258, 3554102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (636, 7481, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS DISTRITO SEDE DE IPUPIARA-COMARCA DE BROTAS DE MACAUBAS', 8953, 2914109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (637, 7482, 'CARTORIO DO REGISTRO CIVIL C/ FUNCOES NOTARIAIS', 8631, 2914208, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (638, 7485, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9647, 2916005, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (639, 7487, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE ITAPE', 7229, 2916203, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (640, 7488, 'ITUACU - CARTORIO DE REGISTRO CIVIL - DISTRITO DE CARAIBUNA', 143651, 2917201, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (641, 7404, 'SERVENTIA EXTRAJUDICIAL DE 2º OFICIO DE BALSAS', 150151, 2101400, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (642, 7491, 'CARTORIO DE REGISTRO CIVIL DE JANDAIRA', 6957, 2917904, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (643, 7492, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12187, 2918605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (644, 7493, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12294, 2918605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (645, 7494, 'CARTORIO DE RESGITRO CIVIL COM FUNCOES NOTARIAIS', 8268, 2933059, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (646, 7495, 'CARTORIO DO REGISTRO CIVIL C/FUNCOES NOTARIAIS', 8680, 2933158, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (647, 7496, 'REGISTRO CIVIL C/FUN NOTARIAIS', 11825, 2933174, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (648, 7497, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS', 6106, 2933406, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (649, 7498, 'CART. DE NOTAS DE REG PUBLICO - CART. LOPES ROCHA', 145821, 2300150, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (650, 7502, 'CARTORIO NERI VASCONCELOS-REGISTRO CIVIL DO DISTRITO DE UBAUNA', 406, 2304004, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (651, 7503, 'CARTORIO TELLES MASCRENHAS', 145805, 2304004, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (652, 7506, 'CARTORIO DO 1O. OFICIO-REG. CIVIL - CART. DE TRAIR', 146258, 2313500, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (653, 7510, 'CARTORIO DO 1º OFICIO REG. CIVIL', 145516, 2306306, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (654, 7511, 'CARTORIO DE REGISTRO CIVIL DE ALMOFALA', 148056, 2306553, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (655, 7515, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE ITAUCU', 25502, 5211404, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (656, 7518, 'CARTORIO DE REGISTRO CIVIL E PESSOAS NATURAIS', 25791, 5212303, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (657, 7519, 'CARTORIO DO REGISTRO CIVIL E PESSOAS NATURAIS', 27227, 5212808, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (658, 7520, 'CARTORIO DE NOTAS DO 1º OFICIO E ANEXOS', 25254, 5215652, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (659, 7524, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES, TUTELAS E TABELIONATO DE NOTAS', 27102, 5216809, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (660, 7526, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 27243, 5218508, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (661, 7527, 'CARTORIO DO REGISTRO CIVIL DE SANTA LUZIA DO NORTE', 148841, 2707909, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (662, 7528, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE FONTE BOA', 4689, 1300029, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (663, 7529, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE BERURI', 142406, 1300631, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (664, 7530, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE NHAMUNDA', 142638, 1303007, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (665, 7531, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6619, 2900108, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (666, 7535, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12500, 2901700, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (667, 7536, 'CARTORIO DE REGISTRO CIVIL CON FUNCOES NOTAREIS', 6304, 2902054, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (668, 7538, 'ALAGOINHAS/DIST.ARAMARI-REGISTRO CIVIL', 5470, 2902203, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (669, 7539, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS', 12625, 2902302, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (670, 7540, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS', 12617, 2902302, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (671, 7541, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12179, 2902500, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (672, 7543, 'TJBA', 15420, 2903003, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (673, 7544, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12310, 2903409, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (674, 7546, 'CARTORIO DE REGISTRO CIVIL 1º DISTRITO', 149765, 2700300, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (675, 7547, 'CARTORIO DO REGISTRO CIVIL', 149914, 2701357, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (676, 7548, 'CARTORIO DE REGISTRO CIVIL E NOTAS MARIA FERREIRA NETO', 148718, 2701506, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (677, 7549, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE PASSO DE CAMARAGIBE', 149799, 2706505, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (678, 7550, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS - LAFAYETE COUTINHO - BA', 6189, 2918704, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (679, 7551, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS', 8904, 2918753, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (680, 7552, 'CARTORIO DE REGISTROS PUBLICOA', 8235, 2918803, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (681, 7555, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NATARIAIS', 8748, 2920452, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (682, 7558, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS', 12039, 2922102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (683, 7559, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS - NOVA REDENCAO', 6197, 2922854, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (684, 7560, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS', 8920, 2923035, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (685, 7561, 'REMEDIOS CARTORIO DO REGISTRO CIVIL E PAZ -CM- IBITIARA BAHIA', 13466, 2923035, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (686, 7562, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 7286, 2924207, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (687, 7563, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 132092, 2924306, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (688, 7565, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 140442, 2924678, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (689, 7567, 'REG CIVIL C/FUN NOTARIAIS - SEDE', 11668, 2925956, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (690, 7568, 'REGISTRO CIVIL C/FUN NOTARIAIS - ARGOIM', 11791, 2925956, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (691, 7569, 'CARTORIO DE REGISTRO CIVIL COM FUNCAO DE NOTAS', 6015, 2926657, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (692, 7570, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS', 12609, 2927309, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (693, 7571, 'CARTORIO DO REGISTRO CIVIL C/ FUNCOES NOTARIAIS', 8623, 2927903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (694, 7572, 'IRARA/DIST SANTANOPOLIS-REG CIVIL C/FUN NOTARIAIS', 11239, 2928307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (695, 7573, 'IRARA/REGISTRO CIVIL C/ FUN NOTARIAIS', 11288, 2928307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (696, 7575, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS', 10892, 2928901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (697, 7576, 'BUERAREMA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE JOSE DA VITORIA', 143461, 2929354, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (698, 7577, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS', 6791, 2929404, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (699, 7578, 'TRIBUNAL DE JUSTICA', 15438, 2930774, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (700, 7581, 'CARTORIO DO REGISTRO CIVIL E TALIONATO', 9977, 2904803, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (701, 7582, 'CARTORIO DO REGISTRO CIVIL DE CAEM', 9829, 2905107, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (702, 7584, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS', 8755, 2905404, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (703, 7585, 'REGISTRO CIVIL PESSOAS NATURAIS E PROTESTOS', 12898, 2905909, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (704, 7586, 'CARTORIO DO REG. CIVIL E TABELIONATO', 8482, 2906204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (705, 7588, 'REGISTRO PUBLICOS II', 13425, 2906709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (706, 7589, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS', 8813, 2906899, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (707, 7590, 'REG. CIVIL C/ FUNC NOTARIAIS - PETIM', 134601, 2907301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (708, 7179, 'OFICIO UNICO DE SANTANA DO SAO FRANCISCO', 110866, 2804409, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (709, 7180, '2º OFICIO DA COMARCA DE RIACHUELO- SE', 109801, 2805901, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (710, 7279, 'CARTORIO DO 2º OFICIO', 78790, 2210607, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (711, 7280, 'CARTORIO DO 3° OFICIO OFICIALIZADO', 78931, 2210607, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (712, 7281, 'CARTORIO DO 2 OFICIO', 78519, 2210706, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (713, 7291, 'REGISTRO CIVIL DAS PESSOAS NATURAIS, REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 84699, 4117602, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (714, 7293, 'ALEXANDRA CARTORIO DISTRITAL NOTAS REGISTRO CIVIL', 80655, 4118204, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (715, 7294, 'REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS NATURAIS', 84434, 4118501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (716, 7297, 'OFICIO DE REGISTRO CIVIL E TITULOS E DOCUMENTOS', 84145, 4119509, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (717, 7298, 'PITANGUEIRAS - RLD', 140202, 4119657, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (718, 7299, 'ITAIACOCA - PGO', 130427, 4119905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (719, 7301, 'PRUDENTOPOLIS TABELIONATO DE NOTAS E REGISTRO CIVIL', 84632, 4120606, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (720, 7302, 'CARTORIO DE PAZ E ANEXOS', 81182, 4120853, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (721, 7306, 'SERVICO REGISTRAL CIVIL E NOTARIAL', 87056, 4123907, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (722, 7309, 'SERVENTIA DE JUSTICA DISTRITAL DE UBAUNA', 85647, 4125001, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (723, 9234, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS E TABELIONATO DE NOTAS 2º DE NOTAS', 28712, 5208608, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (724, 9235, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 26286, 5208608, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (725, 1123, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 25882, 5208608, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (726, 1124, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 25940, 5208608, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (727, 1127, '2º REGISTRO CIVIL E TABELIONATO DE NOTAS', 24919, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (728, 1126, '1º REGISTRO CIVIL E TABELIONATO DE NOTAS', 24729, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (729, 9236, 'CARTORIO INDIO ARTIAGA - 4º TABELIONATO DE NOTAS', 27417, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (730, 9237, '2º TABELIONATO DE PROTESTO E REGISTRO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS', 25007, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (731, 9238, 'GOIANIA SEGUNDO TABELIONATO DE NOTAS', 27771, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (732, 9239, 'REGISTRO DE IMOVEIS DA 3ª CIRCUNSCRICAO DE GOIANIA-GOIAS', 28241, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (733, 9240, 'CARTORIO DE REGISTRO DE IMOVEIS DA 1ª CIRCUNSCRICAO DE GOIANIA', 26013, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (734, 9241, '1º TABELIONATO DE NOTAS DE GOIANIA', 24810, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (735, 1125, '4º REGISTRO CIVIL E TABELIONATO DE NOTAS DA COMARCA DE GOIANIA', 25023, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (736, 9242, 'CARTORIO DO 5 OFICIO DE NOTAS', 26955, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (737, 1685, '3º REGISTRO CIVIL E TABELIONATO DE NOTAS', 28126, 5208707, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (738, 14052, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE TAMBAU', 125286, 3553302, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (739, 6412, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE TANABI', 123539, 3553401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (740, 14053, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120147, 3553401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (741, 14054, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124982, 3553401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (742, 6353, 'TAPIRAI CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXO', 126243, 3553500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (743, 6354, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE TAPIRATIBA DA COMARCA DE CACONDE', 118752, 3553609, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (744, 6355, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117259, 3553658, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (745, 14055, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA COMARCA DE TAQUARITINGA', 120055, 3553708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (746, 14056, '1º TABELIONATO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 112185, 3553708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (747, 6358, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DE TAQUARITINGA', 116418, 3553708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (748, 6357, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE JURUPEMA, DE TAQUARITINGA-SP', 119172, 3553708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (749, 14057, 'CARTORIO DE REGISTRO DE IMOVEIS', 127530, 1720101, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (750, 6446, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE SAO FELIX DO-TO-TO', 127415, 1720150, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (751, 6447, 'CARTORIO DE REGISTRO CIVIL E PESSOAS NATURAIS', 127480, 1720200, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (752, 14058, 'CARTORIO DO 1º OFICIO', 128256, 1720200, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (753, 7202, 'REG CIVIL DE PESS. NAT. E TAB. DE NOTAS DO DISTRITO DE BELA VISTA', 138784, 1720200, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (754, 6448, 'CARTORO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 128959, 1720259, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (755, 14059, 'CARTORIO REGISTRO DE IMOVEIS TITULOS E DOCUMENTOS, PESSOAS JURIDICAS, PROTESTO E TABELIONATO DE NOTAS', 128884, 1720259, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (756, 6449, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 128579, 1720309, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (757, 14060, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTO E TABELIONATO DE NOTAS', 127878, 1720309, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (758, 6450, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127316, 1720499, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (759, 14061, 'CARTORIO DE REGISTRO DE IMOVEIS, TABELIONATO 1 DE NOTAS', 127977, 1720499, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (760, 6451, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 139048, 1720655, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (761, 14062, 'CARTORIO DE REGISTRO DE IMOVEIS, REGISTRO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTO E TABELIONATO DE NOTAS', 127951, 1720655, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (762, 14063, 'CARTORIO DO 1º OFICIO E ANEXOS', 128314, 1720804, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (763, 6452, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 128991, 1720804, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (764, 14064, 'CARTORIO DE REGISTRO DE IMOVEIS, TITULOS E ANEXOS', 127993, 1720853, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (765, 6453, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 126870, 1720903, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (766, 14065, 'CARTORIO DO REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E 2º TABELIONATO DE NOTAS', 128751, 1720903, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (767, 14066, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 127738, 1720903, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (768, 6454, 'CARTORIO DE REG. DE PESSOAS NATURAIS', 126680, 1720937, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (769, 14067, 'CART. REG. IMOVEIS, PESS. JUR. TIT. DOC PROT. E TAB. NOTAS.', 126524, 1720937, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (770, 14068, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS ', 152967, 1720978, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (771, 6455, 'CARTORIO DE REGISTRO CIVIL PESSOAS NATURAIS E TABELIONATO 1º DE NOTAS', 127514, 1720978, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (772, 6456, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE TOCANTINIA', 126979, 1721109, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (773, 14069, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS VALPERINO GOMES DE OLIVEIRA', 127787, 1721109, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (774, 14070, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E 2º TABELIONATO DE NOTAS DE TOCANTINIA', 128082, 1721109, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (775, 14071, '2º SERV NOT REG PES JUR E DE TIT E DOC TAB DE PROT', 126474, 1721208, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (776, 14072, 'CARTORIO DE REGISTRO DE IMOVEIS', 127597, 1721208, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (777, 6457, 'CARTORIO DE REGISTRO CIVIL E DEPOSITARIO PUBLICO', 127472, 1721208, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (778, 14073, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS ', 154146, 1721257, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (779, 7203, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127100, 1721257, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (780, 6458, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127365, 1721307, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (781, 14074, 'CARTORIO DO REGISTRO DE IMOVEIS E ANEXOS DE TUPIRATINSN', 128686, 1721307, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (782, 14075, '2º TABELIONATO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 123794, 3553708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (783, 6356, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DO DISTRITO DE GUARIROBA - SP.', 124248, 3553708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (784, 6359, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 116350, 3553807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (785, 14076, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA COMARCA DE TAQUARITINGA', 120113, 3553807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (786, 14077, 'TABELIONATO DE NOTAS E PROT LETRAS E TITULOS', 126094, 3553807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (787, 6360, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE TAQUARIVAI', 126250, 3553856, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (788, 6361, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS ', 116996, 3553906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (789, 6362, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 118893, 3553955, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (790, 6363, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELA DA COMARCA DE TATUI', 115493, 3554003, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (791, 14078, '2° TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 112409, 3554003, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (792, 14079, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 119990, 3554003, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (793, 14080, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 111815, 3554003, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (794, 6365, 'CARTORIO DE REGISTRO CIVIL', 113860, 3554102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (795, 14082, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 111799, 3554102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (796, 14083, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA COMARCA DE TAUBATE', 120279, 3554102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (797, 6364, 'OFICIAL DE REGISTRO CIVIL DA SEDE DA COMARCA DE TAUBATE - 2º SUBDISTRITO', 121210, 3554102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (798, 6366, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE QUIRIRIM', 114207, 3554102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (799, 14084, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE TAUBATE', 112821, 3554102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (800, 6367, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 123182, 3554201, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (801, 14085, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 125716, 3554300, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (802, 6368, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 120899, 3554300, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (803, 6369, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE TERRA ROXA', 118760, 3554409, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (804, 6370, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE TIETE', 116368, 3554508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (805, 14086, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120022, 3554508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (806, 14087, 'TABELIAO DE NOTAS E DE PROTESTO', 124677, 3554508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (807, 6371, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXOS', 124214, 3554607, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (808, 6372, 'OF. REG. CIVIL PES. NAT. TAB. NOTAS', 114785, 3554656, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (809, 6373, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE TORRINHA - COMARCA DE BROTAS', 117820, 3554706, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (810, 7167, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116640, 3554755, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (811, 6374, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE TREMEMBE', 118786, 3554805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (812, 6459, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127175, 1722081, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (813, 14088, '1º DE NOTAS E REGISTRO DE IMOVEIS DE WANDERLANDIA', 126425, 1722081, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (814, 14089, 'CARTORIO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO 2º DE NOTAS', 126656, 1722081, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (815, 6460, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127274, 1722107, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (816, 14090, 'CARTORIO 2º OFICIO XAMBIOA', 128769, 1722107, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (817, 14091, 'CARTORIO DO 1º OFICIO DE NOTAS E REGISTRO DE IMOVEIS', 128272, 1722107, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (818, 14092, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE TREMEMBE', 145599, 3554805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (819, 6375, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117127, 3554904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (820, 6376, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117283, 3554953, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (821, 14093, 'TABELIAO DE NOTAS E PROTESTOS DE TUPA', 125922, 3555000, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (822, 6379, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE TUPA, SP', 121442, 3555000, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (823, 6377, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE VARPA, DA COMARCA DE TUPA', 118240, 3555000, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (824, 14094, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120048, 3555000, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (825, 6378, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE PARNASO, DA COMARCA DE TUPA', 118158, 3555000, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (826, 14095, 'CARTORIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 114421, 3555109, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (827, 14096, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125021, 3555109, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (828, 6380, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS INTERDICOES E TUTELAS', 121863, 3555109, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (829, 6382, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116673, 3555208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (830, 6749, 'OFICIAL DO REGISTRO CIVIL E TABELIAO DE NOTAS DAS PESSOAS NATURAIS DE TURMALINA- SP', 121905, 3555307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (831, 6750, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE UBARANA', 124545, 3555356, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (832, 14097, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE UBATUBA', 120675, 3555406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (833, 6751, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE UBATUBA', 126391, 3555406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (834, 14098, '1º TABELIAO DE NOTAS E DE PROTESTO  ', 111633, 3555406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (835, 6752, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE UBIRAJARA', 121830, 3555505, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (836, 6753, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116632, 3555604, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (837, 6754, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 114173, 3555703, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (838, 6755, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE URANIA', 146316, 3555802, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (839, 14099, 'TABELIAO DE NOTAS E PROTESTOS DE LETRAS E TITULOS DA COMARCA DE URANIA/SP', 119503, 3555802, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (840, 6756, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE: URU - SP', 118778, 3555901, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (841, 6757, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DE URUPES', 116434, 3556008, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (842, 14100, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA COMARCA DE URUPES-SP.', 120543, 3556008, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (843, 14101, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS.-', 125526, 3556008, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (844, 6690, 'SERVICO DE REGISTRO CIVIL E TABELIONATO', 124305, 3556107, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (845, 14102, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS ', 111823, 3556206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (846, 6758, 'REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, PESSOA JURIDICA, PESSOAS NATURAIS E INTERDICOES E TUTELAS DE VALINHOS', 123687, 3556206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (847, 14103, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 120790, 3556305, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (848, 14104, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125146, 3556305, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (849, 6759, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115089, 3556305, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (850, 6760, 'OFICIAL DO REG. CIVIL DE PESSOAS NATURAIS E TABELIAO DE NOTAS', 123380, 3556354, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (851, 14105, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120345, 3556404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (852, 14106, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124826, 3556404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (853, 6761, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICAO E TUTELAS DA SEDE DA COMARCA DE VARGEM GRANDE DO SUL, ESTADO DE SAO PAULO', 115469, 3556404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (854, 6762, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXOS DO DISTRITO E MUNICIPIO DE VARGEM GRANDE PAULISTA DA COMARCA DE COTIA', 114108, 3556453, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (855, 6763, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS E OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 111971, 3556503, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (856, 14107, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA VARZEA PAULISTA', 148452, 3556503, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (857, 6764, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS ', 116657, 3556602, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (858, 14152, 'CARTORIO DO REGISTRO DE IMOVEIS, 1º TAB. DE NOTAS E ANEXOS DE BARRA DO OURO', 138826, 1703073, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (859, 14108, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE VINHEDO', 148437, 3556701, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (860, 6765, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE VINHEDO-SP', 125294, 3556701, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (861, 7168, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE VIRADOURO - SP', 116376, 3556800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (862, 14109, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE VIRADOURO', 125484, 3556800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (863, 14110, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE VIRADOURO/SP', 119974, 3556800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (864, 6766, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117408, 3556909, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (865, 6767, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116756, 3556958, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (866, 6768, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE VOTORANTIM', 141887, 3557006, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (867, 14111, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS ', 125211, 3557006, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (868, 14112, '2º TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS DA COMARCA DE VOTUPORANGA-SP', 112946, 3557105, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (869, 14113, 'VOTUPORANGA OFICIAL DE REGISTRO DE IMOVEIS E ANEXOS', 126417, 3557105, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (870, 14114, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE VOTUPORANGA', 111963, 3557105, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (871, 6769, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE VOTUPORANGA', 121376, 3557105, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (872, 14115, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ZACARIAS DA COMARCA DE BURITAMA', 153965, 3557154, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (873, 7205, 'ABREULANDIA CARTORIO DE REGISTRO DE IMOVEIS E OUTROS', 126482, 1700251, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (874, 14116, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 139071, 1700251, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (875, 14117, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS DE AGUIARNOPOLIS-TO', 154773, 1700301, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (876, 6770, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS', 127449, 1700301, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (877, 6771, 'CARTORIO DO REGISTRO CIVIL', 128439, 1700350, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (878, 14118, 'CARTORIO ALIANCA', 129296, 1700350, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (879, 14119, 'PRIMEIRO TABELIONATO DE NOTAS E REGISTRO DE IMOVEIS', 129098, 1700400, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (880, 14120, 'SEGUNDO TABELIONATO DE NOTAS,REGISTRO PESS.JUR.TIT.DOC E PROTESTO', 129254, 1700400, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (881, 6772, 'REGISTRO CIVIL SOUZA ', 129163, 1700400, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (882, 14121, 'CARTORIO DE REG.PES.JUR.TIT.DOC.PROT.TAB.2.º NOTAS', 126698, 1700707, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (883, 14122, 'ALVORADA CARTORIO DO 1.º OFICIO NOTAS REG.IMOVEIS', 126490, 1700707, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (884, 6773, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E DEPOSITARIO PUBLICO', 127423, 1700707, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (885, 14123, 'CARTORIO REGISTRO DE IMOVEIS E TABELIONATO 1° DE NOTAS', 128868, 1701002, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (886, 6774, 'CARTORIO DE REGISTRO DE PESSOAS NATURAIS', 128132, 1701002, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (887, 14124, 'CARTORIO REGISTRO PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTSO E TABELIONATO 2º DE NOTAS', 128900, 1701002, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (888, 6775, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURIAS', 127464, 1701051, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (889, 14125, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TAB DE NOTAS', 127902, 1701051, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (890, 6776, 'CARTORIO DO REGISTRO CIVIL', 128421, 1701101, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (891, 6777, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 128561, 1701903, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (892, 14126, 'CARTORIO DE REGISTRO DE IMOVEIS TABELEIONATO DE NOTAS PESSOA JURIDICA, TITULOS E DOCUMENTOS', 128009, 1701101, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (893, 14127, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 154625, 1701309, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (894, 14128, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS', 127688, 1701309, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (895, 14129, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS JURIDICA, TITULOS, DCTOS, PROSTES E 2º TABELIONATO DE NOTAS DE ARAGUACEMA-TO', 127027, 1701903, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (896, 14130, 'CARTORIO DO REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS ', 128694, 1701903, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (897, 14131, 'ARAGUACU CARTORIO DO 2° OFICIO DE NOTAS REGISTRO DE PESOAS JURIDICAS, TITULOS E DOCUMENTOS E PROTESTOS', 126508, 1702000, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (898, 6778, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127050, 1702000, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (899, 14132, 'CARTORIO DO 1º OFICIO E REGISTRO DE IMOVEIS DE ARAGUACU-TO', 128322, 1702000, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (900, 14133, 'CARTORIO DO 2º OFICIO DE NOTAS DE ARAGUAINA', 128397, 1702109, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (901, 14134, 'TABELIONATO DE PROTESTO E REGISTRO DE PESSOAS JURIDICAS TITULOS E DOCUMENTOS', 129353, 1702109, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (902, 14135, 'CARTORIO DE REGISTRO DE IMOVEIS DE ARAGUAINA', 127621, 1702109, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (903, 14136, 'CARTORIO DO 1 OFICIO DE NOTAS DE ARAGUAINA', 128181, 1702109, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (904, 6779, 'CARTORIO DE REGISTRO CIVIL DE ARAGUAINA', 126995, 1702109, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (905, 6780, 'REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS DE ARAGUANA TOCANTINS', 129213, 1702158, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (906, 6781, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127159, 1702158, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (907, 6782, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 126805, 1702208, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (908, 14137, '1º TABELIONATO DE NOTAS E REGISTRO DE IMOVEIS', 126441, 1702208, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (909, 14138, 'CARTORIO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 126649, 1702208, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (910, 6783, 'CARTORIO DE REGISTRO DE PESSOAS NATURAIS DE NATAL', 128140, 1702208, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (911, 6784, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 128512, 1702307, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (912, 14139, 'CARTORIO DO 1° OFICIO E REGISTRO DE IMOVEIS', 128215, 1702307, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (913, 14140, 'CARTORIO DO 2° OFICIO, REGISTRO DE TITULOS E DOCUMENTOS, PROTESTOS, ETC...', 128389, 1702307, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (914, 14141, 'CARTORIO DO REGISTRO DE IMOVEIS E 1º TABELIONATO DE NOTAS', 128678, 1702406, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (915, 6785, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 129114, 1702406, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (916, 14142, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO 2º. DE NOTAS', 128058, 1702406, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (917, 14143, 'CARTORIO DO TAB,. 1º DE NOTAS E REG. DE IMOVEIS', 128777, 1702554, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (918, 14144, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS TITULOS E DOCUMENTOS', 128033, 1702554, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (919, 6786, 'CARTORIO DO REGISRO CIVIL DE PESSOAS NATURAIS', 128405, 1702554, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (920, 14145, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO 2º DE NOTAS', 128157, 1702703, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (921, 14146, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 127753, 1702703, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (922, 6787, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 126847, 1702703, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (923, 14147, 'CARTORIO DE REGISTRO DE PESSOA JURIDICA TITULOS E DOCUMENTOS 2° TABELIONATO', 128017, 1702901, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (924, 14148, 'CARTORIO IZABEL ARAUJO MENDONCA', 126581, 1702901, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (925, 6788, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 128538, 1702901, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (926, 6789, 'CARTORIO DE REGISTRO CIVIL', 126714, 1703008, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (927, 14149, 'CARTORIO BABACULANDIA', 128801, 1703008, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (928, 14150, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS DO MUNICIPIO DE BANDEIRANTES-TO', 153809, 1703057, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (929, 6790, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 128652, 1703057, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (930, 14151, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE BARRA DO OURO- TO', 154765, 1703073, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (931, 14153, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS', 127670, 1703107, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (932, 6791, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127217, 1703107, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (933, 6792, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127308, 1703206, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (934, 14154, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOA JURIDICA, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 127811, 1703206, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (935, 6793, 'CARTORIO DE REGISTRO CIVIL DE BOM JESUS DO TOCANTINS', 127001, 1703305, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (936, 14155, 'CARTORIO DE REGISTRO DE IMOVEIS, REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTO E TABELIONATO DE NOTAS', 127969, 1703305, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (937, 6794, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 128462, 1703602, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (938, 14156, 'CARTORIO DE IMOVEIS, REGISTRO DE PESSOA JURIDICA, TITULOS E DOCUMENTOS, PROTESTO, TABELIONATO DE NOTAS.', 126623, 1703602, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (939, 6795, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 126821, 1703701, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (940, 14157, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOA JURIDICA, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS DE BREJINHO DE NAZARE', 129338, 1703701, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (941, 14158, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIOANTO DE NOTAS', 127555, 1703800, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (942, 6796, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127241, 1703800, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (943, 14159, 'CARTORIO MAIOR DE OLIVEIRA JUNIOR', 128819, 1703826, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (944, 6797, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 129130, 1703826, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (945, 14160, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 127936, 1703842, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (946, 6798, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 126862, 1703842, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (947, 6799, 'CARIRI CARTORIO DISTRITAL DO REGISTRO CIVIL E TABELIONATO', 126516, 1703867, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (948, 14161, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TABELIONATO DE NOTAS, PROTESTOS E OUTROS', 127837, 1703867, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (949, 14162, 'CARTORIO DE REGISTRO DE IMOVEIS', 127605, 1703891, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (950, 6800, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS DO DISTRITO JUDICIARIO DE CARRASCO BONITO-TO', 128637, 1703891, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (951, 14163, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS   ', 127852, 1703909, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (952, 6801, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127324, 1703909, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (953, 6802, 'MARIA JOSE VANDERLEISANTA CRUZ', 129031, 1704105, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (954, 14164, 'CART. REGISTRO IMOVEL R. P. JUR. TIT. DOC. PROTESTO TABELIONATO DE NOTAS', 126532, 1704105, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (955, 14165, 'REG. IMOVEIS PESS. JUR. TIT. DOC. PROT. E TAB. DE NOTAS DE CHAPADA DE AREIA-TO', 138859, 1704600, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (956, 14166, 'CARTORIO 2 TABELIONATO DE NOTAS, PESSOAS JURIDICIAS, TITULOS, DUMCUMENTOS E PROTESTOS', 126573, 1705508, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (957, 14167, 'CARTORIO DE REGISTRO DE IMOVEIS E 1º TABELIONATO DE NOTAS', 127647, 1705508, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (958, 6803, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 129049, 1705508, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (959, 14168, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 126599, 1716703, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (960, 14169, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO 2º DE NOTAS', 128041, 1716703, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (961, 6804, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 128520, 1716703, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (962, 14170, 'COMBINADO CARTORIO DE REG DE IMOVEIS E ANEXOS', 128967, 1705557, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (963, 7169, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127209, 1705557, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (964, 6805, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE CONCEICAO DO TOCANTINS', 126904, 1705607, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (965, 14171, 'CARTORIO DO 1º OFICIO DE REGISTRO DE IMOVEIS E ANEXOS', 128306, 1705607, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (966, 6806, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127092, 1706001, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (967, 14172, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 127761, 1706001, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (968, 14173, 'CARTORIO DO 1° OFICIO E REGISTRO DE IMOVEIS', 128223, 1706100, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (969, 6807, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127118, 1706100, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (970, 6808, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DO MUNICIPIO DE CRIXAS', 127506, 1706258, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (971, 14174, 'OFICIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, TABELIONATO DE PROTESTOS E 2º SERVICO DE NOTAS', 129064, 1706100, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (972, 6809, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127290, 1706506, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (973, 14175, 'CARTORIO DE REGISTRO DE IMOVEIS, TABELIONATO DE NOTAS PESSOA JURIDICA, TITULOS E DOCUMENTOS E PROTESTO DE DARCINOPOLIS-TO', 127985, 1706506, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (974, 6810, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127183, 1707009, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (975, 14176, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCS, PROTESTO E NOTAS', 129361, 1707009, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (976, 14177, '1º TABELIONATO DE NOTAS E REGISTRO DE IMOVEIS', 126458, 1707009, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (977, 14178, 'DIVINOPOLIS CARTORIO DO 1º OFICIO, REGISTRO DE IMOVEIS, TITULOS DE NOTAS', 128983, 1707108, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (978, 6811, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127167, 1707108, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (979, 6812, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE DOIS IRMAOS DO TOCANTINS', 127373, 1707207, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (980, 14179, 'CARTORIO DO 1º OFICIO, REGISTRO DE IMOVEIS, TABELIONATO DE NOTAS  PROTESTOS TITULOS E DOCUMENTOS', 128363, 1707207, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (981, 14180, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 127944, 1707306, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (982, 7170, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 127266, 1707306, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (983, 6813, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 128975, 1707405, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (984, 14181, 'CARTORIO DO 1º E 2º OFICIOS', 128231, 1707553, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (985, 6814, 'OFICIAL DO REGISTRO CIVIL E PESSOAS NATURAIS', 129056, 1707553, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (986, 14182, 'CARTORIO REGISTRO CIVIL PESSOAS JURIDICAS TITULOS DOCUMENTOS PROTESTOS E TABELIONATO 2º DE NOTAS', 128835, 1707652, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (987, 14183, 'FIGUEIROPOLIS CARTORIO DE REGISTRO DE IMOVEIS E 1º TABELIONATO DE NOTAS', 129007, 1707652, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (988, 6815, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127142, 1707652, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (989, 14184, 'SERVICO  DE  REGISTRO DE PESSOAS  JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E  TABELIONATO 2º DE  NOTAS', 129270, 1707702, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (990, 6816, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 128454, 1707702, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (991, 14185, 'CARTORIO DE REGISTRO DE IMOVEIS E PRIMEIRO TABELIONATO DE NOTAS', 127704, 1707702, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (992, 6817, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 126888, 1708205, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (993, 7198, 'CARTORIO DO 1º OFICIO DE NOTAS E REGISTRO DE IMOVEIS', 128280, 1708205, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (994, 14186, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO 2º DE NOTAS', 128116, 1708205, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (995, 6818, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 505, 1708254, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (996, 9201, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS, TABELIONATO 2º. DE NOTAS E ESCRIVANIA 2º. DO CIVEL', 26583, 5211701, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (997, 1157, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 28167, 5211701, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (998, 9202, 'REGISTRO DE IMOVEIS E NOTAS ', 28266, 5211701, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (999, 9203, 'CARTORIO DE REGISTRO DE IMOVEIS, PROTESTOS, TITULOS E DOCUMENTOS', 26476, 5211800, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1000, 9204, 'CARTORIO DO 1.º TABELIONATO ', 28571, 5211800, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1001, 1158, 'CARTORIO DE REGISTRO CIVIL E PESSOAS NATURAIS', 25783, 5211800, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1002, 5780, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE SAO BENEDITO DA CACHOEIRINHA', 114827, 3524105, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1003, 14197, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 154435, 1709807, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1004, 6822, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127076, 1710508, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1005, 14198, 'CARTORIO DE REGISTRO DE IMOVEIS', 127589, 1710508, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1006, 14199, 'CARTORIO TABELIONATO DE NOTAS', 128934, 1710508, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1007, 6823, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127043, 1710706, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1008, 14200, 'REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 129171, 1710706, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1009, 6824, 'REGISTRO CIVIL DE PESSOAS NATURAIS DO DISTRITO DE SUMAUMA', 144733, 1710706, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1010, 14201, 'REGISTRO DE  PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO 2° DE NOTAS DE ITAGUATINS', 138776, 1710706, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1011, 6825, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 139147, 1710904, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1012, 14202, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 127928, 1710904, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1013, 6826, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 126813, 1711100, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1014, 14203, 'TABELEONATO OLIVEIRA', 129312, 1711100, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1015, 6827, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 126771, 1711506, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1016, 14204, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS DO DISTRITO E MUNICIPIO DE JAU DO TOCANTINS, COMARCA DE PEIXE, ESTADO DO TOCANTINS.', 127860, 1711506, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1017, 6828, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127332, 1711803, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1018, 14205, 'CARTORIO DO REGISTRO DE IMOVEIS,PESSOAS JURIDICAS,TITULOS ,DOCUMENTOS ,PROTESTOS E TAVBELIONATO DE NOTAS', 128744, 1711803, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1019, 14206, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS LINO DE SOUZA', 127696, 1711902, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1020, 6829, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 128496, 1711902, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1021, 6830, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 126748, 1711951, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1022, 14207, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E TABELIONATO DE NOTAS', 127886, 1711951, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1023, 6831, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE LAJEADO-TO', 126920, 1712009, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1024, 14208, 'CARTORIO DO 1º OFICIO', 128264, 1712009, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1025, 14209, 'CARTORIO DO 1º OFICIO DE REGISTRO DE IMOVEIS', 128298, 1712405, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1026, 6832, 'CARTORIO DE REGISTRO CIVIL', 126722, 1712405, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1027, 7172, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS', 127431, 1712454, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1028, 6833, 'CARTORIO DE  REGISTRO CIVIL DAS PESSOAS NATURAIS', 126607, 1712504, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1029, 14210, 'CARTORIO DE REG DE IMOVEIS PESSOAS JURIDICAS E OUTROS', 126664, 1712504, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1030, 6834, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 126755, 1712702, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1031, 14211, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS', 127662, 1712702, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1032, 6835, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 128488, 1712801, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1033, 14212, 'CARTORIO DE REGISTRO DE IMOVEIS PESSOAS JURIDICAS TITULOS E DOCUMENTOS PROTESTOS E TABELIONATO DE NOTAS', 127803, 1712801, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1034, 14213, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO 2º DE NOTAS', 128124, 1713205, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1035, 6836, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS', 129304, 1713205, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1036, 14214, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 127746, 1713205, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1037, 14215, 'CARTORIO DO 1º OFICIO E REGISTRO DE IMOVEIS DE MIRANORTE-TO', 128330, 1713304, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1038, 1961, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 25429, 5219803, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1039, 1508, '(090) 2ª SERVENTIA EXTRAJUDICIAL', 29587, 2111607, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1040, 1652, 'SERVENTIA EXTRAJUDICIAL', 150458, 2107407, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1041, 1669, 'SERVICOS DE NOTAS,DE PROTESTO DE TITULOS DE REGISTRO DE IMOVEIS,DE REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 27276, 5208301, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1042, 1703, 'CARTORIO DE REGISTRO CIVIL', 25395, 5214606, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1043, 1330, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE ACRELANDIA', 1073, 1200013, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1044, 1331, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE ASSIS BRASIL', 1024, 1200054, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1045, 1336, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE PLACIDO DE CASTRO', 1065, 1200385, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1046, 1338, '5ª SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE RIO BRANCO', 893, 1200401, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1047, 1339, '4ª SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA RIO BRANCO', 802, 1200401, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1048, 1343, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE RODRIGUES ALVES', 1099, 1200427, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1049, 7131, 'CARTORIO OLIVEIRA', 105593, 4211751, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1050, 7165, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE TERRA NOVA D'' OESTE, DA COMARCA DE PANORAMA', 114272, 3547106, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1051, 1555, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 25619, 5217401, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1052, 1575, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 25486, 5219506, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1053, 1587, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATIRAIS E TABELEONATODE NOTAS', 25585, 5220405, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1054, 949, 'EUCLIDES DA CUNHA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE QUINJINGUE', 144162, 2910701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1055, 1029, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE BURARAMA', 146498, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1056, 1136, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS E TABELIONATOS DE NOTAS E PROTESTOS', 25551, 5209705, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1057, 1144, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS', 26146, 5210307, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1058, 1150, 'REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS', 28118, 5211206, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1059, 1169, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS', 27193, 5213400, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1060, 1170, 'REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS', 146852, 5213400, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1061, 1175, 'CARTORIO DE NOTAS E REGISTRO CIVIL DO DISTRITO DE COUTINHO', 145425, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1062, 4985, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS DE GETULANDIA 5° DISTRITO DA COMARCA DE RIO CLARO RJ', 91413, 3304409, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1063, 4986, 'CARTORIO DO RCPN DE LIDICE', 91165, 3304409, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1064, 4987, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 1º DISTRITO', 93286, 3304409, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1065, 4998, '6ª CIRCUNSCRICAO DE REGISTRO CIVIL DA CAPITAL RJ', 89300, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1066, 5000, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DO 6º DISTRITO DA COMARCA DE SANTA MARIA MADALENA', 93237, 3304607, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1067, 5020, 'CRCPN1ºDISTRITO DE CANTAGALO', 91637, 3301108, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1068, 5022, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO 1º DISTRITO - SEDE', 91355, 3301306, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1069, 5856, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE SAO JOAO DO MARINHEIRO, DA COMARCA CARDOSO', 115592, 3510708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1070, 4843, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS', 119313, 3501103, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1071, 4865, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE PIRAMBOIA', 122184, 3502309, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1072, 4869, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE ARACAIBA, DA COMARCA DE APIAI', 119263, 3502705, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1073, 5761, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE GUARIZINHO, DA COMARCA DE ITAPEVA', 118000, 3522406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1074, 5779, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE CAPIVARI DA MATA', 115642, 3524105, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1075, 5784, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS  DO 2O SUBDISTRITO DA SEDE =  SERVENTIA EXTINTA', 121285, 3524303, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1076, 4897, 'RCPN DO DISTRITO UNICO DE ARRAIAL DO CABO', 92924, 3300258, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1077, 4911, 'R.C.P.N. DO 4º DISTRITO DE CANTAGALO', 92403, 3301108, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1078, 4916, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO 1º DISTRITO', 91348, 3301405, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1079, 5799, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE LARAS', 118091, 3526407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1080, 5813, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE BAIRRO ALTO, DA COMARCA DE PARAIBUNA', 114348, 3532306, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1081, 5817, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE TIBIRICA, DA COMARCA DE BAURU', 118224, 3506003, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1082, 4924, 'CRCPN E TABELIONATO DE NOTAS DO 2º DISTRITO', 144865, 3301900, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1083, 4932, 'CARTORIO DO 6 DISTRITO DE NOVA IGUACU - EXTINTO EM 01.07.2011 - LEI ESTADUAL 5893.2011 - ACERVO TRANSFERIDO AO CARTORIO DO OFICIO UNICO DE JAPERI', 90761, 3302270, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1084, 4941, 'RCPN 1° DISTRITO DE MANGARATIBA', 92486, 3302601, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1085, 4945, 'SERVICO NOTARIAL E REGISTRAL CIVIL DA PESSOAS NATURAIS DO 5O. DISTRITO DE NOVA IGUACU', 93518, 3302858, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1086, 4946, 'CARTORIO DO 2º OFICIO DE JUSTICA DE MIGUEL PEREIRA', 90530, 3302908, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1087, 4958, 'CARTORIO DE RCPN DA 4ª ZONA JUDICIARIA DE NITEROI - RJ', 89813, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1088, 5819, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 118232, 3506102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1089, 5833, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE BACURITI, DA COMARCA DE CAFELANDIA', 117879, 3508801, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1090, 5031, 'SUMIDOURO CARTORIO DO 1° OFICIO', 93633, 3305703, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1091, 5068, 'CARTORIO UNICO DE ESPIRITO SANTO-RN', 94367, 2403509, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1092, 5894, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE CAFESOPOLIS, DA COMARCA DE CAFELANDIA', 117929, 3508801, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1093, 5910, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE JAMAICA, DA COMARCA DE DRACENA', 118042, 3514403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1094, 4286, 'SERVICO DISTRITAL DE SAO JOSE', 86959, 4112108, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1095, 2341, 'REGISTRO CIVIL DAS PESSOA NATURAIS', 55640, 3149309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1096, 11682, 'TABELIONATO DE PROTESTOS DE TITULOS DE PEDRO LEOPOLDO', 60806, 3149309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1097, 11683, 'OFICIO DO REGISTRO DE IMOVEIS', 44917, 3149309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1098, 2340, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE VERA CRUZ DE MINAS', 35113, 3149309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1099, 6975, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE PEDRO TEIXEIRA', 42390, 3149408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1100, 2343, 'CARTORIO REGISTRO CIVIL TABELIONATO NOTAS', 44909, 3149507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1101, 7026, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51672, 3149606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1102, 2788, 'PERDIGAO CARTORIO DE PAZ E NOTAS', 55160, 3149705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1103, 11684, 'CARTORIO DE REGISTRO DE IMOVEIS DE PERDIZES', 39164, 3149804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1104, 11685, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE CRUZILIA/MG', 60467, 3120805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1105, 11686, '2º TABELIONATO DE NOTAS ', 153544, 3120805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1106, 1833, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 34538, 3120805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1107, 1933, 'SERVICO REGISTRAL E NOTARIAL', 51243, 3120839, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1108, 1834, 'CARTORIO DE PAZ E NOTAS', 34223, 3120839, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1109, 1835, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 43109, 3120870, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1110, 1836, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTA RITA DO CEDRO', 52100, 3120904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1111, 11687, 'CARTORIO DO 1º OFICIO DE NOTAS DE CURVELO', 40840, 3120904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1112, 11688, 'CARTORIO DE REGISTRO DE IMOVEIS DA COMARCA DE CURVELO/MG', 38976, 3120904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1113, 11689, 'OFICIO DO 3º TABELIONATO DE NOTAS', 49973, 3120904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1114, 1934, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE TOMAS GONZAGA', 46649, 3120904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1115, 11690, 'OFICIO REGISTRO TITULOS E DOCUMENTOS CIVIL DE PESSOAS JURIDICAS', 54957, 3120904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1116, 1935, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS, INTERDICOES E TUTELAS DE CURVELO-MG', 59295, 3120904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1117, 6954, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ANGUERETA', 37200, 3120904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1118, 11691, 'CARTORIO DO 2º OFICIO DE NOTAS', 41335, 3120904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1119, 11692, 'TABELIONATO DE PROTESTO DE CURVELO', 60152, 3120904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1120, 6955, 'OFICIO DO REGISTRO CIVIL E NOTAS', 51185, 3121001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1121, 1837, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL', 37754, 3121100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1122, 1838, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE BARRA', 43174, 3121100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1123, 1839, 'OFICIO DO REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS DE BABILONIA', 37804, 3121209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1124, 1840, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE DELFINOPOLIS', 58255, 3121209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1125, 1841, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 150557, 3121258, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1126, 1842, 'CARTORIO DE DESCOBERTO, MG - REGISTRO CIVIL E TABELIONATO DE NOTAS', 56762, 3121308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1127, 1844, 'CARTORIO REGISTRO CIVIL E NOTAS', 44701, 3121407, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1128, 1843, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS - PEREIRINHAS', 53371, 3121407, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1129, 6956, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS- SAO SEBASTIAO DO GIL', 53736, 3121407, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1130, 7439, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE DESTERRO DE MELO', 36327, 3121506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1131, 11693, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 44339, 3121605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1132, 1849, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE INHAI', 43323, 3121605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1133, 11694, 'OFICO DO 1º TABELIONATO DE NOTAS ', 54999, 3121605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1134, 1853, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42341, 3121605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1135, 11695, 'DIAMANTINA CARTORIO REGISTRO DE IMOVEIS', 45468, 3121605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1136, 1847, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE MENDANHA', 56267, 3121605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1137, 11696, 'DIAMANTINA 2º OFICIO DE NOTAS', 45450, 3121605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1138, 1851, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE GUINDA', 37408, 3121605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1139, 11697, 'TABELIONATO DO 2º OFICIO DE NOTAS DA COMARCA DE ITAGUARA', 61259, 3132206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1140, 11698, 'OFICIO DO REGISTRO DE IMOVEIS DE ITAGUARA', 54130, 3132206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1141, 11699, 'CARTORIO DE PROTESTO DE TITULOS', 142505, 3132206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1142, 11700, 'TABELIONATO DE PROTESTO DE TITULOS COMARCA ITAGUARA', 745, 3132206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1143, 11701, 'CARTORIO REGISTRO CIVIL P.JURIRICAS E REGISTRO DE TITULOS E DOCUMENTOS', 44867, 3132206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1144, 11702, 'CARTORIO 1º OFICIO NOTAS DE ITAGUARA', 33589, 3132206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1145, 2259, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ITAIPE', 58487, 3132305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1146, 11703, 'CARTORIO REGISTRO IMOVEIS ITAJUBA', 45088, 3132404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1147, 11704, 'CARTORIO DE REGISTRO DE TITULOS, DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 40030, 3132404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1148, 2978, 'CARTORIO DE REGISTRO CIVIL - 1º SUBDISTRITO', 35337, 3132404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1149, 11705, 'OFICIO DO 1º (PRIMEIRO) TABELIONATO DE NOTAS', 47860, 3132404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1150, 2977, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DISTRITO DE SAO JOSE DO RIO MANSO', 37929, 3132404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1151, 11706, 'ITAJUBA CARTORIO DE REGISTRO DE PROTESTO', 45708, 3132404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1152, 11707, '2º TABELIONATO DE NOTAS', 33662, 3132404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1153, 2082, 'OFICIO DO 2º REGISTRO CIVIL DAS PESSOAS NATURAIS', 42051, 3132404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1154, 11708, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54510, 3132503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1155, 2260, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PADRE JOAO AFONSO', 36830, 3132503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1156, 11709, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE ITAMARANDIBA', 48744, 3132503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1157, 2084, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PENHA DE FRANCA', 36764, 3132503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1158, 11710, 'CARTORIO DO REGISTRO DE IMOVEIS', 43398, 3132503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1159, 11711, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49825, 3132503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1160, 11712, 'CARTORIO DO 1º OFICIO DE NOTAS DA COMARCA DE ITAMARANDIBA', 40816, 3132503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1161, 2083, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CONTRATO', 37226, 3132503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1162, 2085, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 44370, 3132503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1163, 2086, 'CARTORIO DE PAZ REGISTRO CIVIL E NOTAS', 34660, 3132602, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1164, 11713, 'CARTORIO DO 2º OFICIO DE NOTAS', 41418, 3132701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1165, 2261, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56119, 3132701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1166, 11714, 'CARTORIO PRIMEIRO OFICIO DE NOTAS', 44198, 3132701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1167, 2162, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE FREI JOAQUIM', 37218, 3132701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1168, 2161, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE GUARATAIA', 56879, 3132701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1169, 11715, 'TABELIONATO DE PROTESTOS DE TITULOS DE ITAMBACURI', 35022, 3132701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1170, 11716, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 45047, 3132701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1171, 11717, 'CARTORIO DO REGISTRO DE IMOVEIS', 43497, 3132701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1172, 2163, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36731, 3132800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1173, 11718, '2º TABELIONATO DE NOTAS ', 153569, 3132909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1174, 11719, 'ITAMOGI CARTORIO DO OFICIO DE NOTAS', 45716, 3132909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1175, 11720, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 45104, 3132909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1176, 11721, '1º OFICIO DE NOTAS', 32045, 3140803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1177, 11722, 'TABELIONATO DE PROTESTOS DE TITULOS DE MATIAS BARBOSA', 60871, 3140803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1178, 11723, 'CARTORIO DO 2° OFICIO DE NOTAS', 41160, 3140803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1179, 2767, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE INTERDICOES E TUTELAS', 34702, 3140852, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1180, 2203, 'OFICIO DO REGISTRO CIVIL E TAB DE NOTAS DE PADRE FIALHO ', 55046, 3140902, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1181, 7016, 'REGISTRO CIVIL E TABELIONATO DE NOTAS DE MATIPO', 47118, 3140902, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1182, 2205, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36863, 3141009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1183, 2204, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 56531, 3141009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1184, 11724, 'SEGUNDO OFICIO DE NOTAS DE MATOZINHOS', 57984, 3141108, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1185, 11725, 'CARTORIO DE REGISTRO DE IMOVEIS', 38513, 3141108, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1186, 2207, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53082, 3141108, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1187, 2206, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35568, 3141108, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1188, 11726, 'CARTORIO DE NOTAS DO 1º 0FICIO', 34017, 3141108, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1189, 11727, 'OFICIO DO 1º TABELIONATO DE PROTESTOS DE TITULOS', 48942, 3141108, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1190, 11728, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39545, 3141108, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1191, 2208, 'MATUTINA CARTORIO DE PAZ E NOTAS', 46052, 3141207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1192, 2209, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 31823, 3141306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1193, 11729, 'MEDINA CARTORIO OFICIAL DO REGISTRO DE IMOVEIS E HIPOTECAS', 46060, 3141405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1194, 11730, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39586, 3141405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1195, 11731, 'CARTORIO DO 2º OFICIO DE NOATS', 41202, 3141405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1196, 7073, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE TUPARECE', 37861, 3141405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1197, 2210, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 36384, 3141405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1198, 11732, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48488, 3141405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1199, 11733, 'CARTORIO DO 1º OFICIO DE NOTAS', 40733, 3141405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1200, 2211, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE MENDES PIMENTEL', 37457, 3141504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1201, 2212, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50765, 3141603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1202, 11734, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48330, 3141603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1203, 11735, 'OFICIO DO REGISTRO DE IMOVEIS', 53959, 3141603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1204, 11736, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48454, 3141603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1205, 11737, '2º TABELIONATO DE NOTAS ', 153619, 3141603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1206, 11738, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 47381, 3141603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1207, 11739, 'OFICIO DO 2º TABELIONATO DE NOTAS DE MESQUITA', 49890, 3141702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1208, 2213, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35824, 3141702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1209, 11740, 'CARTORIO DO 1º OFICIO DE NOTAS DE MESQUITA', 40857, 3141702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1210, 11741, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE MESQUITA', 54551, 3141702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1211, 11742, 'OFICIO DO REGISTRO DE IMOVEIS DE MESQUITA', 57265, 3141702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1212, 11743, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS DE MESQUITA', 48835, 3141702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1213, 2890, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 38398, 3149804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1214, 11744, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 40295, 3149804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1215, 11745, '2º TABELIONATO DE NOTAS ', 153643, 3149804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1216, 11746, 'OFICIO DO 1° TABELIONATO DE PROTESTO DE TITULOS DE PERDIZES', 47829, 3149804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1217, 11747, '1º TABELIONATO DE NOTAS DE PERDIZES', 31930, 3149804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1218, 11748, 'CARTORIO 2º OFICIO DE NOTAS', 33647, 3149903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1219, 11749, 'CARTORIO 1º TABELIONATO DE NOTAS DGMCARVALHO', 33605, 3149903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1220, 11750, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 33373, 3149903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1221, 11751, 'CARTORIO REGISTRO DE IMOVEIS', 44966, 3149903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1222, 2789, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50690, 3149903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1223, 11752, 'TABELIONATO DE PROTESTO DE TITULOS', 60384, 3149903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1224, 2790, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PEDRA CORRIDA', 53611, 3149952, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1225, 2344, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PERIQUITO', 53629, 3149952, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1226, 2791, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO SEBASTIAO DO BAIXIO', 53660, 3149952, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1227, 2792, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51961, 3150000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1228, 2793, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 46425, 3150109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1229, 2345, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE PIEDADE DE CARATINGA, MG', 47076, 3150158, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1230, 11753, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 42671, 3150208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1231, 2346, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PIEDADE DO RIO GRANDE', 37689, 3150307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1232, 7027, 'CARTORIO JOSE GUIMARAES JOTA', 43976, 3150406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1233, 2794, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 46904, 3150505, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1234, 2347, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PINGO DAGUA MG', 43331, 3150539, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1235, 2348, 'PINTOPOLIS CARTORIO DE REGISTRO CIVIL E NOTAS', 55186, 3150570, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1236, 2349, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE VILA ACARI', 47043, 3150570, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1237, 2795, 'CARTORIO DE NOTAS E REGISTRO CIVIL', 34041, 3150604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1238, 2350, 'OFICIO DE REGISTRO CIVIL E TABELIONATO', 46730, 3150703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1239, 11754, 'PROTESTO DE TITULOS', 55533, 3150802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1240, 7028, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51508, 3150802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1241, 11755, 'REGISTRO DE IMOVEIS', 57083, 3150802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1242, 11756, '2º OFICIO DE NOTAS', 32508, 3150802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1243, 2796, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42127, 3150802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1244, 11757, 'CARTORIO 1º OFICIO DE NOTAS ', 33530, 3150802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1245, 11758, 'REG. DE TITULOS DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 61416, 3150802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1246, 2797, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE SANTO ANTONIO DO PIRAPETINGA', 52761, 3150802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1247, 2351, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 37812, 3150901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1248, 6976, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53017, 3151008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1249, 2798, 'CARTORIO DO RCPN E TAB. DE NOTAS DE OLEGARIO MACIEL', 43125, 3151008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1250, 11759, 'OFICIO DO 3º TABELIONATO DE NOTAS', 49940, 3121605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1251, 1845, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE SENADOR MOURAO', 43059, 3121605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1252, 1848, 'REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE EXTRACAO', 149393, 3121605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1253, 11760, 'CARTORIO DE PROTESTO DE TITULOS', 34876, 3121605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1254, 11761, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE CONSELHEIRO MATA', 35915, 3121605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1255, 1850, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PLANALTO DE MINAS', 40055, 3121605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1256, 1852, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE DESEMBARGADOR OTONI', 36509, 3121605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1257, 1846, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO JOAO DA CHAPADA', 53835, 3121605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1258, 6896, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE DIOGO DE VASCONCELOS', 34728, 3121704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1259, 1854, 'DIONISIO CARTORIO DE PAZ E NOTAS', 45476, 3121803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1260, 1855, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51763, 3121803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1261, 1856, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 38208, 3121902, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1262, 1857, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52589, 3122009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1263, 11762, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS', 57554, 3122009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1264, 11763, 'CARTORIO DO 2.° OFICIO DE NOTAS -DIVINO-', 41087, 3122009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1265, 1858, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42275, 3122009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1266, 11764, 'CARTORIO DE REGISTRO DE IMOVEIS DE DIVINO', 39081, 3122009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1267, 11765, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 47662, 3122009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1268, 11766, '1° TABELIONATO DE NOTAS', 31971, 3122009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1269, 1859, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE CENTRAL DE SANTA HELENA', 37341, 3122108, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1270, 6897, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE DIVINO DAS LARANJEIRAS', 37366, 3122108, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1271, 1860, 'CARTORIO DO REGISTRO CIVIL E NOTAS DAS PESSOAS NATURAIS', 42937, 3122207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1272, 11767, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 39818, 3122306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1273, 11768, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE DIVINOPOLIS MG', 60475, 3122306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1274, 11769, 'OFICIO REGISTRO DE IMOVEIS', 54932, 3122306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1275, 11770, 'TABELIONATO DO 1º OFICIO DE NOTAS DE DIVINOPOLIS/MG', 61135, 3122306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1276, 11771, 'TABELIONATO DO 2º OFICIO DE NOTAS', 61192, 3122306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1277, 1861, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE SANTO ANTONIO DOS CAMPOS', 36293, 3122306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1278, 11772, 'REGISTRO CIVIL DAS PESSOAS NATURIAS', 56580, 3122306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1279, 1862, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE DIVISA ALEGRE', 43000, 3122355, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1280, 1863, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE DIVISA NOVA', 51466, 3122405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1281, 1864, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE DIVISOPOLIS', 34371, 3122454, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1282, 1865, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 56408, 3122470, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1283, 1866, 'DOM CAVATI OFICIO DE REGISTRO CIVIL E NOTAS', 45492, 3122504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1284, 11773, 'OFICIO REGISTRO DE IMOVEIS', 57802, 3122603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1285, 11774, 'OFICIO 1º TABELIONATO', 46359, 3122603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1286, 11775, 'REGISTRO DE IMOVEIS ', 57117, 3132909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1287, 2262, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 44388, 3132909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1288, 11776, '1.º TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE ITAMOGI', 31955, 3132909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1289, 11777, 'OFICIO DE REGISTRO DE IMOVEIS', 47225, 3133006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1290, 11778, 'OFICIO DO 2 TABELIONATO DE NOTAS', 49130, 3133006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1291, 11779, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 54593, 3133006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1292, 11780, 'CARTORIO 1º OFICIO DE NOTAS', 61564, 3133006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1293, 11781, '1º TABELIONATO DE PROTESTO DE TITULOS', 32383, 3133006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1294, 2164, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50815, 3133006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1295, 11782, 'TABELIONATO DE PROTESTO DE TITULOS E DOCUMENTOS DA COMARCA DE ITANHANDU', 60699, 3133105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1296, 11783, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 50278, 3133105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1297, 11784, 'ITANHANDU CARTORIO DO SEGUNDO OFICIO DE NOTAS', 45732, 3133105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1298, 2263, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50591, 3133105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1299, 11785, 'ITANHANDU CARTORIO DO 1° OFICIO DE NOTAS', 45724, 3133105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1300, 11786, 'CARTORIO DE REGISTRO DE IMOVEIS DA COMARCA DE ITANHANDU', 38992, 3133105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1301, 11787, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48058, 3133204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1302, 2265, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35691, 3133204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1303, 11788, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 47464, 3133204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1304, 2264, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36855, 3133204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1305, 11789, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48728, 3133204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1306, 11790, 'REGISTRO DE IMOVEIS DE ITANHOMI-MG', 39123, 3133204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1307, 11791, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49528, 3133204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1308, 2087, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 34447, 3133204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1309, 2088, 'ITAOBIM CARTORIO DE REGISTRO CIVIL E TABELIONATO', 45740, 3133303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1310, 11792, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS JURIDICAS', 50385, 3133402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1311, 11793, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS DE ITAPAJIPE', 48637, 3133402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1312, 2089, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50427, 3133402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1313, 11794, 'REGISTRO DE IMOVEIS DA COMARCA DE ITAPAGIPE', 57224, 3133402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1314, 11795, '2º TABELIONATO DE NOTAS ', 153577, 3133402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1315, 11796, 'TABELIONATO DE NOTAS DA COMARCA DE ITAPAGIPE - TABELIONATO LIMA', 60046, 3133402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1316, 11797, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 152678, 3133402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1317, 11798, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS', 54205, 3133402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1318, 2093, 'TABELIONATO DE NOTAS E REGISTRO CIVIL DE MARILANDIA', 60053, 3133501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1319, 11799, 'CARTORIO DE REGISTRO DE IMOVEIS DA COMARCA DE ITAPECERICA ', 39008, 3133501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1320, 2092, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50773, 3133501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1321, 11800, 'OFICIO DO 3º TABELIONATO DE NOTAS', 50005, 3133501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1322, 2090, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52399, 3133501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1323, 11801, '2º TABELIONATO DE NOTAS', 32649, 3141801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1324, 7310, 'CARTORIO DISTRITAL DE CACHOEIRA DE SAO JOSE', 82156, 4125506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1325, 14042, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO 1O DE NOTAS DE SANTA TEREZA DO TOCANTINS', 127910, 1719004, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1326, 6444, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE SANTA TEREZA DO TOCANTINS', 126961, 1719004, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1327, 6445, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 127498, 1720002, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1328, 14043, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 154153, 1720002, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1329, 14044, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 128603, 1720101, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1330, 6343, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116871, 3552304, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1331, 14045, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS ', 111831, 3552403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1332, 6345, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE NOVA VENEZA, DA COMARCA DE SUMARE', 121707, 3552403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1333, 6344, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS INTERDICOES E TUTELAS DA SEDE DA COMARCA DE SUMARE', 118992, 3552403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1334, 14046, 'OFICIAL DE REGISTRO DE IMOVEIS, TIULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS E TABELIONATO DE NOTAS', 121103, 3552403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1335, 6346, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116814, 3552551, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1336, 14047, 'SEGUNDO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE SUZANO', 124016, 3552502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1337, 14048, 'PRIMEIRO TABELIAO DE NOTAS E PROTESTO DE SUZANO-SP', 122481, 3552502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1338, 6347, 'REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES, TUTELAS E AUSENCIAS', 123331, 3552502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1339, 14049, 'REGISTRO DE IMOVEIS E ANEXOS DE SUZANO', 123620, 3552502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1340, 6348, 'TABAPUA-CARTORIO DO REGISTRO CIVIL E ANEXOS', 124636, 3552601, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1341, 6349, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE TABATINGA', 118745, 3552700, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1342, 14050, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTO, CIVIL DE PESSOA JURIDICAS DE PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE TABOAO DA SERRA', 148411, 3552809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1343, 6350, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 111856, 3552809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1344, 6351, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116798, 3552908, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1345, 6352, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXO DO MUNICIPIO DE TAGUAI', 124180, 3553005, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1346, 5873, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE TAIACU-SP', 114090, 3553104, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1347, 5874, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE TAIUVA', 117812, 3553203, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1348, 6411, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE TAMBAU', 113985, 3553302, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1349, 14051, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120964, 3553302, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1350, 11458, 'SERVICO REGISTRAL DE IMOVEIS DE PARACATU-MG', 59469, 3147006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1351, 2872, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 44354, 3147006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1352, 11459, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 39974, 3147006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1353, 11460, 'CARTORIO DO 1º OFICIO DE NOTAS', 40600, 3147204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1354, 11461, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54395, 3147204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1355, 11462, 'SERVICO NOTARIAL ''SAPI'' - 2º OFICIO DE NOTAS', 49445, 3147204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1356, 1914, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE ALTO MARANHAO', 38273, 3118007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1357, 11463, '1º OFICIO DE NOTAS', 32003, 3118007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1358, 2069, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35808, 3118007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1359, 11464, 'SERVICO DE REGISTRO DE IMOVEIS', 58537, 3118007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1360, 2070, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52266, 3118106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1361, 11465, 'CARTORIO REG. DE TITULOS E DOCIMENTOS CIVIL DE PESSOAS JURIDICAS.', 44248, 3118205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1362, 11466, 'PRIMEIRO TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE CONQUISTA', 55459, 3118205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1363, 11467, '2º TABELIONATO DE NOTAS DE CONQUISTA', 32805, 3118205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1364, 2071, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56036, 3118205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1365, 11468, 'CARTORIO DO PRIMEIRO TABELIONATO DE NOTAS', 41939, 3118205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1366, 11469, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56002, 3118205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1367, 11470, 'CARTORIO DE REGISTRO DE IMOVEIS', 38570, 3118205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1368, 2072, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE GUAXIMA', 34256, 3118205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1369, 11471, 'CONSELHEIRO LAFAIETE 1º OFICIO IMOVEIS', 45393, 3118304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1370, 2073, 'SERVICO REGISTRAL DE PESSOAS NATURAIS DE CONSELHEIRO LAFAIETE', 59519, 3118304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1371, 11472, 'CARTORIO DE REGISTRO DE PROTESTO', 39263, 3118304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1372, 11473, 'SERVICO REGISTRAL DE IMOVEIS - SEGUNDO OFICIO', 59402, 3118304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1373, 11474, '1º OFICIO DE NOTAS', 32037, 3118304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1374, 11475, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS', 57570, 3118304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1375, 11476, 'OFICIO DO SEGUNDO TABELIONATO DE NOTAS', 54643, 3118304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1376, 6894, 'SERVICO REGISTRAL E TABELIONATO DE NOTAS DITRITO DE BUARQUE DE MACEDO', 59725, 3118304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1377, 11477, 'CARTORIO DO 3º OFICIO DE NOTAS MOTA DUTRA', 41681, 3118304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1378, 11478, 'CARTORIO DO PRIMEIRO OFICIO NOTAS ', 41921, 3118403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1379, 1809, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CUIETE VELHO', 44651, 3118403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1380, 11479, 'CARTORIO DO 2º OFICIO DE NOTAS ', 41251, 3118403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1381, 11480, 'PROTESTO DE TITULOS', 55509, 3118403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1382, 2075, 'SERVICO DE REGISTRO CIVIL COM ATRIBUICAO DE NOTAS DE PENHA DO NORTE', 58370, 3118403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1383, 1811, 'CARTORIO DO REGISTRO CIVIL', 42010, 3118403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1384, 1812, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE BUENO - MG', 42978, 3118403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1385, 2074, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE BARRA DO CUIETE', 38042, 3118403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1386, 11481, 'REGISTRO DE TITULOS E DOCTOS E PESSOAS JURIDICAS', 57323, 3118403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1387, 1810, 'SERVICO REGISTRAL E NOTARIAL DE FERRUGINHA-MG', 43018, 3118403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1388, 11482, 'CARTORIO DE REGISTRO DE IMOVEIS', 38737, 3118403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1389, 1813, 'CONSOLACAO CARTORIO DO REGISTRO CIVIL E TABELIONATO', 45401, 3118502, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1390, 11483, 'TABELIONATO MOTA - 1º OFICIO DE NOTAS DA COMARCA DE CONTAGEM - MG', 61309, 3118601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1391, 2154, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE GUIRICEMA', 51573, 3129004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1392, 6899, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE TUIUTINGA', 46474, 3129004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1393, 2155, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52878, 3129103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1394, 2949, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51649, 3129103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1395, 2156, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52852, 3129202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1396, 2950, 'OFICO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 54981, 3129301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1397, 2951, 'OFICIO DO REGISTRO CIVIL E NOTAS', 51144, 3129301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1398, 2328, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE PINHEIRINHOS', 46607, 3147600, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1399, 2157, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E INTERDICOES E TUTELAS COM ATRIBUICAO DE NOTAS DE IBERTIOGA - CARTORIO AUGUSTO SILVA', 33803, 3129400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1400, 11484, 'CARTORIO DO 2° OFICIO DE NOTAS ', 41129, 3129509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1401, 11485, 'IBIA CARTORIO DO REGISTRO DE IMOVEIS', 45625, 3129509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1402, 11486, 'CARTORIO DE REGISTRO DE TITULOS DOCUMENTOS E PESSOAS JURIDICAS', 39396, 3129509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1403, 11487, 'PRIMEIRO TABELIONATO DE NOTAS DA COMARCA DE IBIA', 55400, 3129509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1404, 11488, 'TABELIONATO DE PROTESTO DE TITULOS E DOCUMENTOS', 60681, 3129509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1405, 2159, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ARGENITA', 51581, 3129509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1406, 2160, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE TOBATI', 37606, 3129509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1407, 2158, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56069, 3129509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1408, 7455, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55764, 3129608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1409, 2954, 'REGISTRO CIVIL DAS PESSOAS NATURAIS INTERDICOES E TUTELAS', 56556, 3129657, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1410, 2953, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE BONANCA', 36871, 3129657, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1411, 2952, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CAMPO ALEGRE DE MINAS', 35345, 3129657, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1412, 11489, 'CARTORIO DO 1º OFICIO DE NOTAS', 40550, 3129707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1413, 11490, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48660, 3129707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1414, 11491, 'CARTORIO DE REGISTRO DE IMOVEIS', 38844, 3129707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1415, 11492, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49379, 3129707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1416, 11493, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54445, 3129707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1417, 6641, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50633, 3129707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1418, 11494, 'TABELIONATO DE PROTESTO DE TITULOS DE IBIRITE', 60566, 3129806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1419, 11495, 'OFICIO DO 2 TABELIONATO DE NOTAS', 49148, 3129806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1420, 11496, 'IBIRITE CARTORIO DO 1º OFICIO DE NOTAS', 45633, 3129806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1421, 2956, 'CARTORIO REGISTRO CIVIL E TABELIONATO DE NOTAS DE DURVAL DE BARROS', 44446, 3129806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1422, 11497, 'REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 57695, 3129806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1423, 11498, 'SERVICO DE REGISTRO DE IMOVEIS DE IBIRITE', 58636, 3129806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1424, 2955, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35717, 3129806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1425, 2957, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36632, 3129905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1426, 11499, 'OFICIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE IBITURUNA', 46623, 3130002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1427, 2958, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 55079, 3130051, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1428, 11500, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS JURIDICAS', 35451, 3138807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1429, 11501, '1° TABELIONATO DE PROTESTOS', 31989, 3138807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1430, 6969, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 42689, 3138906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1431, 11502, 'OFICIO DO SEGUNDO TABELIONATO DE NOTAS', 54635, 3139003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1432, 11503, 'OFICIO DO 1º TABELIONATO DE NOTAS', 47993, 3139003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1433, 11504, 'OFICIO DO 3º TABELIONATO DE NOTAS', 50013, 3139003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1434, 11505, 'SERVICO DE REGISTRO DE IMOVEIS DA COMARCA DE MACHADO/MG', 58578, 3139003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1435, 2177, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50542, 3139003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1436, 11506, 'CART. REG.TITULOS E DOCUMENTOS E REG. CIVIL DAS PESSOAS JURIDICAS', 33381, 3139003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1437, 2176, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE DOURADINHO', 37259, 3139003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1438, 11507, 'TABELIONATO DE PROTESTOS E TITULOS', 61002, 3139003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1439, 2178, 'CARTORIO DE REGISTRO CIVIL E ANEXOS', 36566, 3139102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1440, 2179, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50849, 3139201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1441, 11508, 'OFICIO DE REGISTRO DE IMOVEIS', 47282, 3139201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1442, 11509, 'OFICIO 1 TABELIONATO DE PROTESTOS DE TITULOS', 46334, 3139201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1443, 11510, 'CARTORIO DO PRIMEIRO OFICIO DE NOTAS ', 41798, 3139201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1444, 2181, 'OFICIO REGISTRO CIVIL E TABELIONATO DE NOTAS', 54841, 3139201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1445, 7071, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTO ANTONIO DO MUCURI', 52829, 3139201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1446, 2180, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51458, 3139201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1447, 11511, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 39925, 3139201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1448, 11512, 'CARTORIO DO 2º OFICIO DE NOTAS', 41384, 3139201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1449, 2757, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE MAMONAS-MG', 36186, 3139250, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1450, 2183, 'CARTORIO DE REGISTRO CIVIL E DE TUTELAS E INTERDICOES DA COMARCA DE MANGA', 50575, 3139300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1451, 11513, 'OFICIO DO 1° TABELIONATO DE NOTAS', 47753, 3139300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1452, 2182, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE NHANDUTIBA', 34769, 3139300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1453, 11514, 'OFICO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 55004, 3139300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1454, 11515, 'CARTORIO DO 2. OFICIO DE NOTAS', 41079, 3139300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1455, 11516, 'CARTORIO DE PROTESTO DA COMARCA DE MANGA - MG', 34827, 3139300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1456, 11517, 'OFICIO DO REGISTRO DE IMOVEIS DE MANGA', 38547, 3139300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1457, 2184, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SAO PEDRO DO AVAI', 208, 3139409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1458, 11518, 'MANHUACU-TABELIAO E ESCRIVAO DE CARTORIO DO 1° OFICIO', 45963, 3139409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1459, 2759, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS C/ ATRIBUICOES DE NOTAS DE SAO SEBASTIAO DO SACRAMENTO', 58198, 3139409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1460, 11519, 'OFICIO DO TABELIONATO DE PROTESTO DE TITULOS', 54700, 3139409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1461, 11520, 'CARTORIO DE REGISTRO GERAL DE IMOVEIS', 40063, 3139409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1462, 11521, 'OFICIO DO 2º TABELINATO DE NOTAS', 49320, 3139409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1463, 11522, 'CARTORIO DE REGISTRO DE IMOVEIS', 38695, 3147204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1464, 11523, 'OFICIO DO 1° TABELIONATO DE PROTESTOS E TITULOS', 43596, 3147204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1465, 2325, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE PARAGUACU', 50674, 3147204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1466, 11524, 'CARTORIO DO 2º TABELIONATO', 41574, 3147303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1467, 2874, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 144824, 3147303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1468, 11525, 'REGISTRO DE IMOVEIS', 57042, 3147303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1469, 11526, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 57463, 3147303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1470, 2873, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DO MUNICIPIO DE COSTAS', 42523, 3147303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1471, 11528, 'TABELIONATO DE PROTESTOS DE TITULOS DE PARAISOPOLIS', 60962, 3147303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1472, 11529, 'PARAOPEBA CARTORIO DO PRIMEIRO OFICIO DE NOTAS', 55103, 3147402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1473, 11530, 'OFICIO DO Lº TABELIONATO DE PROTESTO DE TITULOS DE PARAOPEBA', 50054, 3147402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1474, 2326, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 31864, 3147402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1475, 11531, 'PARAOPEBA/CARTORIO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 55111, 3147402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1476, 11532, 'CARTORIO DO 2º OFICIO DE NOTAS DE PARAOPEBA', 55095, 3147402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1477, 11533, 'CARTORIO OFICIALA ROGERIA CRISTINA NOGUEIRA SANTOS', 44131, 3147402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1478, 11534, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48116, 3147600, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1479, 11535, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49833, 3147600, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1480, 2875, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS LAZARO GUEDES PEREIRA', 45294, 3147600, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1481, 11536, 'CARTORIO DE TITULOS E DOCUMENTOS E DE PESSOAS JRIDICAS DA COMARCA DE PASSA QUATRO/MG', 40246, 3147600, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1482, 11537, 'TABELIONATO DE PROTESTO DE TITULOS', 60426, 3147600, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1483, 7023, 'CARTORIO MAE MARIA - OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 52613, 3147600, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1484, 11538, 'OFICIO DO REGISTRO DE IMOVEIS', 54098, 3147600, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1485, 2327, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35485, 3147709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1486, 11539, 'SERVICO REGISTRAL DE PROTESTO DE TITULOS', 59543, 3147709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1487, 11540, 'SERVICO REGISTRAL DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 59592, 3147709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1488, 11541, 'SEGUNDO OFICIO DE NOTAS DA COMARCA DE PASSA TEMPO-MG', 57968, 3147709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1489, 11542, '1º TABELIONATO DE NOTAS', 32201, 3147709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1490, 11543, 'CARTORIO DE REGISTRO DE IMOVEIS', 38810, 3147709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1491, 2876, 'PASSA VINTE CARTORIO DE REGISTRO CIVIL E ANEXOS', 55129, 3147808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1492, 2329, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIA DO MUNICIPIO DE PASSABEM', 42382, 3147501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1493, 11544, 'OFICIO DO 1º TABELIONATO DE PROTESTOS DE TITULOS', 48967, 3147907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1494, 11545, 'TITULOS E DOCUMENTOS E REGISTRO CIVIS DAS PESSOAS JURIDICAS', 61457, 3147907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1495, 11546, 'CARTORIO 2º OFICIO DE NOTAS DE PASSOS', 33696, 3147907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1496, 11547, 'TABELIONATO DE PROTESTOS DE TITULOS DE CONTAGEM', 60665, 3118601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1497, 11548, 'CARTORIO 2º OFICIO DE NOTAS DE CONTAGEM', 33688, 3118601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1498, 11549, 'REGISTRO DE IMOVEIS', 57091, 3118601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1499, 1915, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DA SEDE DA COMARCA DE CONTAGEM', 56234, 3118601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1500, 11550, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 39784, 3118601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1501, 1814, 'CONTAGEM - CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 45419, 3118601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1502, 1916, 'OFICIO DO REGISTO CIVIL E TABELIONATO DE NOTAS DE COQUEIRAL', 50310, 3118700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1503, 11551, 'CARTORIO DO 1º OFICIO DE NOTAS', 40543, 3118809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1504, 11552, 'CARTORIO DE PROTESTO', 34819, 3118809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1505, 11553, 'CARTORIO DE REGISTRO DE IMOVEIS', 38935, 3118809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1506, 1816, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PONTE DOS CIGANOS', 36665, 3118809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1507, 11554, 'CARTORIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 43612, 3118809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1508, 1917, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ALVACAO', 53173, 3118809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1509, 1815, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE LUIS PIRES DE MINAS', 36889, 3118809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1510, 1918, 'CARTORIO QUERINO NOBRE REGISTRO CIVIL DAS PESSOAS NATURAIS', 44222, 3118809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1511, 1817, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO JOAQUIM', 34132, 3118809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1512, 11555, 'CARTORIO DO 2º OFICIO DE NOTAS DE CORACAO DE JESUS MG', 41541, 3118809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1513, 11527, '1º SERVICO NOTARIAL', 32185, 3147303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1514, 1818, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 38018, 3118908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1515, 1819, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE LAGOA BONITA', 37820, 3118908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1516, 1820, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51870, 3119005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1517, 11556, 'SERVICO REGISTRAL DE IMOVEIS ', 59378, 3119104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1518, 1821, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CONTRIA', 51482, 3119104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1519, 11557, '2º TABELIONATO DE NOTAS DA COMARCA DE CORINTO-MG', 32763, 3119104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1520, 11558, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 44255, 3119104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1521, 1822, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35527, 3119104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1522, 11559, 'TABELIONATO DE PROTESTO DE TITULOS E LETRAS', 60731, 3119104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1523, 11560, 'SERVICO NOTARIAL 1º OFICIO', 58800, 3119104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1524, 1823, 'RCPN COM ATRIBUICOES DE NOTAS DE COROACI/MG', 38117, 3119203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1525, 7438, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE CONCEICAO DE TRONQUEIRAS', 149401, 3119203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1526, 1824, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO SEBASTIAO DO BUGRE', 52308, 3119203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1527, 11561, '1.º SERVICO NOTARIAL  COROMANDEL-MG', 31948, 3119302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1528, 1825, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE PANTANO DE SANTA CRUZ', 51219, 3119302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1529, 1826, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35667, 3119302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1530, 11562, 'TABELIONATO DE PROTESTOS', 60772, 3119302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1531, 1829, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 42887, 3119302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1532, 11563, 'CARTORIO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 40196, 3119302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1533, 2748, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48371, 3130101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1534, 11564, 'TABELIONATO DE PROTESTOS DE TITULOS DE IGARAPE-MG', 60954, 3130101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1535, 11565, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39560, 3130101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1536, 11566, 'CARTORIO DE REGISTRO DE IMOVEIS DE IGARAPE', 39115, 3130101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1537, 11567, '2º TABELIONATO DE NOTAS ', 153551, 3130101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1538, 2959, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 44305, 3130101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1539, 6642, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DO DISTRITO DE ANTUNES', 53702, 3130200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1540, 2960, 'CARTORIO DE PAZ E DO REGISTRO CIVIL E NOTAS', 34165, 3130200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1541, 11568, 'SERVICO DO 2º OFICIO DE NOTAS', 58685, 3130309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1542, 11569, 'SERVICO DO 1º OFICIO DE NOTAS', 58677, 3130309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1543, 2961, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50526, 3130309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1544, 11570, 'SERVICO REGISTRAL DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 59634, 3130309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1545, 11571, 'SERVICO REGISTRAL DE PROTESTO DE TITULOS', 59535, 3130309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1546, 11572, 'OFICIO DE REGISTRO DE IMOVEIS', 47217, 3130309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1547, 2962, 'OFICIO DE REGISTRO CIVIL E NOTAS', 46656, 3130408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1548, 2963, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE ILICINEA', 51417, 3130507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1549, 2964, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE IMBE DE MINAS - MINAS GERAIS', 37416, 3130556, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1550, 11573, 'OFICIO DO REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS', 52886, 3130606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1551, 2247, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE INDAIABIRA', 46318, 3130655, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1552, 2248, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE INDIANOPOLIS', 43927, 3130705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1553, 2249, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS C/ ANEXO DE NOTAS', 52811, 3130804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1554, 2251, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52241, 3130903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1555, 11574, 'REGISTRO DE IMOVEIS', 57174, 3130903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1556, 11575, 'OFICIO DO PRIMEIRO TABELIONATO DE NOTAS', 50070, 3130903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1557, 2250, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE INHAPIM', 35923, 3130903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1558, 11576, 'REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS DA COMARCA DE INHAPIM-MG', 57646, 3130903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1559, 11577, 'INHAPIM CARTORIO DO SEGUNDO OFICIO DE NOTAS ', 45641, 3130903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1560, 6900, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE ITAJUTIBA', 56374, 3130903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1561, 11578, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS E OUTROS DOCUMENTOS DE DIVIDA DA COMARCA DE INHAPIM', 48892, 3130903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1562, 2965, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE INHAUMA/MG', 53512, 3131000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1563, 2252, 'CARTORIO  DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 33423, 3131109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1564, 2966, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS ', 46581, 3131158, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1565, 11579, 'REGISTRO DE IMOVEIS', 57109, 3131208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1566, 11580, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48066, 3131208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1567, 11581, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48652, 3131208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1568, 11582, 'OFICIO DO REGISTRO DE TITULO E DOCUENTOS E CIVIL DAS PESSOAS JURIDICAS', 54163, 3131208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1569, 11583, 'CARTORIO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 40238, 3139409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1570, 2758, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42085, 3139409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1571, 11584, 'CARTORIO 2º OFICIO DE NOTAS', 33654, 3139508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1572, 11585, '3º TABELIONATO DE NOTAS DE MANHUMIRIM', 32888, 3139508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1573, 11586, 'CARTORIO TITULOS, DOCUMENTOS E PESSOAS JURIDICAS', 45278, 3139508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1574, 11587, 'TABELIONATO DE PROTESTO', 60079, 3139508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1575, 11588, 'MANHUMIRIM CARTORIO DE REGISTRO DE IMOVEIS', 45971, 3139508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1576, 11589, 'PRIMEIRA SERVENTIA NOTARIAL', 55251, 3139508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1577, 2760, 'CARTORIO REGISTRO CIVIL PESSOAS NATURAIS', 44883, 3139508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1578, 11590, 'SEGUNDO SERVICO NOTARIAL', 58024, 3139607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1579, 2186, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 45997, 3139607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1580, 11591, 'CARTORIO DE REG. TITULOS E DOC, CIVIL P. JURIDICAS', 35188, 3139607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1581, 2185, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE BARRA DO ARIRANHA', 53009, 3139607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1582, 2761, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50708, 3139607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1583, 11592, 'PRIMEIRO SERVICO NOTARIAL DE MANTENA', 55343, 3139607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1584, 11593, 'CARTORIO DE PROTESTO DE TITULOS DA COMARCA DE MANTENA', 34942, 3139607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1585, 11594, 'OFICIO DO REGISTRO DE IMOVEIS', 53884, 3139607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1586, 11595, 'CARTORIO DE REGISTRO GERAL DE IMOVEIS', 40071, 3139805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1587, 11596, 'CARTORIO DE PROTESTO DE TITULOS', 34850, 3139805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1588, 7072, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE ENGENHO NOVO', 42374, 3139805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1589, 11597, 'TABELIONATO DO 2º OFICIO DE NOTAS', 61226, 3139805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1590, 2187, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55822, 3139805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1591, 2188, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 56606, 3139805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1592, 11598, 'MAR DE ESPANHA CARTORIO PRIMEIRO OFICIO JUDICIAL E NOTAS', 46003, 3139805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1593, 11599, 'CARTORIO TITULOS E DOC E PESSOAS JURIDICAS', 45252, 3139805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1594, 2189, 'OFICIO REGISTRO CIVIL E TABELIONATO DE NOTAS', 54866, 3139706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1595, 2762, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE MARIA DA FE', 53116, 3139904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1596, 2190, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53223, 3139904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1597, 2192, 'OFICIO DO REGISTRO CIVIL E TAB.DE NOTAS', 51300, 3140001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1598, 11600, 'TABELIONATO DE PROTESTO DE TITULOS', 60228, 3140001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1599, 2764, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51896, 3140001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1600, 2763, 'OFICIO DE REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE SANTA RITA DURAO', 54916, 3140001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1601, 11601, 'SEGUNDO TABELIONATO DE NOTAS', 58073, 3140001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1602, 2193, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35857, 3140001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1603, 11602, 'CARTORIO BARBOSA - REGISTRO DE TITULOS, DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 33811, 3140001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1604, 2194, 'CARTORIO REGISTRO CIVIL E NOTAS', 44529, 3140001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1605, 11603, 'MARIANA CARTORIO DO REGISTRO DE IMOVEIS', 46029, 3140001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1606, 11604, 'CARTORIO DO 1º OFICIO DE NOTAS', 40683, 3147907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1607, 11605, 'CARTORIO DE REGISTRO DE IMOVEIS', 38620, 3147907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1608, 7024, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42242, 3147907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1609, 11606, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL DE PATIS', 37473, 3147956, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1610, 11607, 'OFICIO DO TERCEIRO TABELIONATO DE NOTAS', 54726, 3148004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1611, 2334, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SANTANA DE PATOS', 37242, 3148004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1612, 11608, 'CARTORIO REGISTRO DE PROTESTOS', 45039, 3148004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1613, 11609, 'CARTORIO DO REGISTRO DE IMOVEIS', 43448, 3148004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1614, 11610, 'OFICIO DO PRIMEIRO TABELIONATO DE NOTAS', 50088, 3148004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1615, 2333, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE MAJOR PORTO', 54791, 3148004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1616, 2332, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PINDAIBAS', 51342, 3148004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1617, 2330, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES.TUTELAS COM ATRIBUICOES NOTARIAISCOES ', 53637, 3148004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1618, 11611, 'OFICIO DO 2° TABELIONATO DE NOTAS', 49213, 3148004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1619, 2331, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE BONSUCESSO DE PATOS', 53454, 3148004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1620, 2335, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 36244, 3148004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1621, 11612, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO GONCALO DO ABAETE', 152710, 3148004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1622, 2877, 'OFICIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 54783, 3148004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1623, 11613, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE PATOS DE MINAS/MG', 39743, 3148004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1624, 11614, 'OFICIO DO 1° TABELIONATO DE NOTAS', 47712, 3148103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1625, 6974, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52969, 3148103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1626, 2878, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS', 59204, 3148103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1627, 2879, 'CARTORIO DE PAZ E NOTAS DE SAO JOAO DA SERRA NEGRA', 34405, 3148103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1628, 11615, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 57489, 3148103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1629, 11616, '2º TABELIONATO DE NOTAS', 58099, 3148103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1630, 11617, 'SERVICO DE REGISTRO DE IMOVEIS DE PATROCINIO', 58644, 3148103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1631, 11618, 'CARTORIO DE PROTESTO DE PATROCINIO', 34835, 3148103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1632, 2880, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52555, 3148202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1633, 2881, 'PAULA CANDIDO CARTORIO DE PAZ E NOTAS', 55137, 3148301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1634, 2336, 'CARTORIO DE PAZ E NOTAS DE PAULISTAS', 52324, 3148400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1635, 2337, 'CARTORIO DO REG. CIVIL E NOTAS DE PAVAO MG', 41962, 3148509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1636, 11619, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE PECANHA', 47928, 3148608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1637, 11620, 'CARTORIO DO 2º OFICIO DE NOTAS', 41400, 3148608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1638, 11621, 'SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 620, 3148608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1639, 2882, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTA TERESA DO BONITO', 36673, 3148608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1640, 11622, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48264, 3148608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1641, 11623, 'CARTORIO DE REGISTRO DE IMOVEIS', 38802, 3148608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1642, 1827, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E  DE INTERDICOES E TUTELAS COM ATRIBUICAO NOTARIAL DO MATEIRO', 36079, 3119302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1643, 1828, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ALEGRE', 52340, 3119302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1644, 11624, 'SERVICO NOTORIAL 2 OFICIO', 59089, 3119302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1645, 1919, 'CARTORIO DE REGISTRO CIVIL PAZ E NOTAS DO DISTRITO DE SANTA ROSA DOS DOURADOS/MG', 38414, 3119302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1646, 11625, 'REGISTRO DE IMOVEIS DE COROMANDEL', 57257, 3119302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1647, 1830, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 37028, 3119401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1648, 1920, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 44396, 3119401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1649, 9590, 'OFICIO DO 1º TABELIONATO DE NOTAS', 32276, 3102605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1650, 11626, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39602, 3119401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1651, 11627, 'TABELIONATO DO 2º OFICIO DE NOTAS', 61176, 3119401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1652, 11628, 'SERVICO REGISTRAL DE IMOVEIS DE CORONEL FABRICIANO', 59436, 3119401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1653, 11629, 'PRIMEIRO TABELIONATO DE NOTAS DE CORONEL FABRICIANO', 55426, 3119401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1654, 11630, '1º TABELIONATO DE PROTESTO DE TITULOS E DIVIDAS', 48876, 3119401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1655, 6895, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE FREIRE CARDOSO', 52639, 3119500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1656, 1921, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS E NOTARIAL', 56820, 3119500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1657, 1922, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE CORONEL PACHECO', 36160, 3119609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1658, 1923, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL', 34082, 3119708, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1659, 1924, 'CORREGO DANTA CARTORIO DE PAZ E NOTAS', 45427, 3119807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1660, 1831, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL', 36848, 3119906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1661, 1925, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55756, 3119955, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1662, 6952, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 37036, 3120003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1663, 1926, 'CARTORIO DE REGISTRO CIVIL E OFICIO DE NOTAS', 37671, 3120102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1664, 1927, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CRISOLITA', 53488, 3120151, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1665, 6953, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS COM ATRIBUICOES DE NOTAS ', 40139, 3120201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1666, 1928, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51631, 3120300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1667, 1929, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51730, 3120409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1668, 11631, '1º OFICIO DE NOTAS', 32078, 3120508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1669, 11632, 'CARTORIO DE REGISTRO DE IMOVEIS DE CRISTINA', 39073, 3120508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1670, 11633, 'REGISTRO DE TITULOS DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 57315, 3120508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1671, 11634, 'CARTORIO DO 2º TABELIONATO DE NOTAS', 41590, 3120508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1672, 11635, 'CARTORIO DE PROTESTO DE TITULOS', 34900, 3120508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1673, 1930, 'CARTORIO DE PAZ E REGISTRO CIVIL DE CRISTINA', 34546, 3120508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1674, 1931, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 37952, 3120607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1675, 1832, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE BREJO BONITO', 33217, 3120706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1676, 14187, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E TABELIONATO DE NOTAS', 127894, 1708254, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1677, 14188, 'CARTORIO DO 1.º OFICIO E REGISTRO DE IMOVEIS', 128207, 1708304, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1678, 6819, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 126839, 1708304, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1679, 14189, 'REGISTRO DE IMOVEIS, REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS', 129106, 1709005, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1680, 6820, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 126763, 1709005, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1681, 14190, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 127779, 1709005, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1682, 14191, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS JURIDICAS TITULOS DOCUMENTOS PROTESTOS E SEGUNDO DE NOTAS', 128546, 1709302, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1683, 7171, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS RAIMUNDA SILVA ARAUJO DE GUARAI-TO', 126912, 1709302, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1684, 14192, 'GUARAI CARTORIO DO 1º OFICIO REGISTRO DE IMOVEIS E NOTAS', 129015, 1709302, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1685, 6821, 'GURUPI CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 129023, 1709500, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1686, 14193, 'CARTORIO TABELIONATO 1º DE NOTAS', 128926, 1709500, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1687, 14194, 'TABELIONATO DE PROTESTO DE TITULOS E REGISTRO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS', 129346, 1709500, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1688, 14195, 'SERVICO DE REGISTRO DE IMOVEIS DE GURUPI - TOCANTINS', 129288, 1709500, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1689, 14196, 'CARTORIO DO TABELIONATO 2º DE NOTAS', 128785, 1709500, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1690, 2973, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 44362, 3131901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1691, 11650, 'SERVICO REGISTRAL DE TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS', 59626, 3131901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1692, 2972, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53090, 3131901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1693, 11651, 'CARTORIO DO 1° OFICIO DE NOTAS DE ITABIRITO', 40444, 3131901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1694, 11652, 'SERVICO DO SEGUNDO OFICIO NOTARIAL', 58784, 3131901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1695, 6644, 'CARTORIO REGISTRO CIVIL E NOTAS', 44404, 3131901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1696, 11653, 'OFICIO DE 1º TABELIONATO DE PROTESTO DE TITULOS', 46383, 3131901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1697, 2974, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS / NOTAS', 44412, 3131901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1698, 2975, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52795, 3132008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1699, 6645, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51557, 3132107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1700, 2976, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 36541, 3132206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1701, 2313, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE FURQUIM', 45286, 3140001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1702, 2765, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 37010, 3140001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1703, 2293, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 42739, 3140001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1704, 7445, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PADRE VIEGAS', 53793, 3140001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1705, 2191, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35766, 3140001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1706, 11654, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48132, 3140001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1707, 2195, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42234, 3140100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1708, 7015, 'MARIO CAMPOS CARTORIO REGISTRO CIVIL E TABELIONATO DE NOTAS', 46045, 3140159, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1709, 2196, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE MARIPA DE MINAS', 37275, 3140209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1710, 7446, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE MARLIERIA', 37440, 3140308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1711, 2197, 'REGISTRO CIVIL E TABELINATO DE NOTAS', 56754, 3140407, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1712, 2199, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE MARTINHO CAMPOS', 46540, 3140506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1713, 2198, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ALBERTO ISAACSON', 36756, 3140506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1714, 11655, '1º TABELIONATO DE NOTAS DE MARTINHO CAMPOS', 32334, 3140506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1715, 11656, 'OFICIO DO PRIMEIRO TABELIONATO DE PROTESTO DE TITULOS', 50153, 3140506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1716, 2766, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL', 46862, 3140506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1717, 11657, '2º TABELIONATO DE NOTAS ', 153601, 3140506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1718, 11658, 'CARTORIO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 40212, 3140506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1719, 11659, 'OFICIO DO REGISTRO DE IMOVEIS DE MARTINHO CAMPOS', 44107, 3140506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1720, 2200, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35774, 3140530, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1721, 2201, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 38133, 3140555, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1722, 6970, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 56424, 3140605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1723, 11660, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS', 54197, 3140704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1724, 11661, 'SERVICO REGISTRAL DA COMARCA DE MATEUS LEME', 59188, 3140704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1725, 11662, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 152694, 3140704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1726, 11663, 'OFICIO DO 2º. TABELIONATO DE NOTAS', 562, 3140704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1727, 11664, 'CARTORIO DE PROTESTO DE TITULOS COMARCA DE MATEUS LEME', 34926, 3140704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1728, 2296, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE MATEUS LEME', 44420, 3140704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1729, 11665, 'REGISTRO CIVIL DAS PESSOAS JURIDICAS', 55665, 3140704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1730, 11666, '1º TABELIONATO DE NOTAS', 32235, 3140704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1731, 2295, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE AZURITA', 51250, 3140704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1732, 2294, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SERRA AZUL', 44230, 3140704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1733, 2202, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE MATHIAS LOBATO/MG', 56481, 3171501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1734, 11667, 'OFICIO DE REGISTRO DE IMOVEIS', 47241, 3140803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1735, 11668, 'REGISTRO CIVIL DAS PESSOAS JURIDICAS E TITULOS E DOCUMENTOS', 55699, 3140803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1736, 6971, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50856, 3140803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1737, 7075, 'CARTORIO DE REGISTRO CIVIL', 35261, 3148608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1738, 11669, 'CARTORIO DO 2º OFICIO DE NOTAS', 41269, 3148707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1739, 2883, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DO DISTRITO DE ARACAJI DE MINAS', 36459, 3148707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1740, 11670, 'OFICIO DO REGISTRO DE IMOVEIS DA COMARCA DE PEDRA AZUL', 38786, 3148707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1741, 11671, 'CARTORIO DE REGISTRO DE PROTESTO DE TITULO E DOCUMENTOS DE DIVIDA', 39297, 3148707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1742, 2884, 'CARTORIO REGISTRO CIVIL DE PESSOAS NATURAIS DE PEDRA AZUL', 44503, 3148707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1743, 11672, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DA COMARCA DE PEDRA AZUL', 39685, 3148707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1744, 11673, 'PEDRA AZUL CARTORIO 1º OFICIO DE NOTAS', 55145, 3148707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1745, 2338, 'CARTORIO SILVA', 45203, 3148756, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1746, 2885, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52951, 3148806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1747, 2886, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51524, 3148905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1748, 7025, 'CARTORIO DE PAZ, REGISTRO CIVIL E TABELIONATO DE NOTAS', 34751, 3149002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1749, 11674, 'OFICIO DO 2º TABELIONATO DE NOTAS', 45930, 3149101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1750, 11675, 'OFICIO DO PRIMEIRO TABELIONATO DE PROTESTO', 50146, 3149101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1751, 11676, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 152322, 3149101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1752, 11677, 'OFICIO DE REGISTRO DE IMOVEIS', 47258, 3149101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1753, 2887, 'CARTORIO DE REGISTRO CIVIL E PESSOAS NATURAIS DE PEDRALVA-MG', 37697, 3149101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1754, 11678, 'CARTORIO DO 1º OFICIO E NOTAS', 40972, 3149101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1755, 2339, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 33886, 3149150, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1756, 2888, 'CARTORIO DE REGISTRO CIVIL E NOTAS SAO PEDRO DAS TABOCAS  ', 43224, 3149150, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1757, 2889, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 43182, 3149200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1758, 2787, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE DOUTOR LUND', 36608, 3149309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1759, 11679, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 60012, 3149309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1760, 2342, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 36038, 3149309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1761, 11680, 'OFICIO DO 2º TABELIONATO DE NOTAS', 60004, 3149309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1762, 11681, 'OFICIO DO 1º TABELIONATO DE NOTAS', 33480, 3149309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1763, 9564, '2º TABELIONATO DE NOTAS', 32672, 3107307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1764, 9565, 'PRIMEIRO TABELIONATO DE NOTAS', 55350, 3107307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1765, 9566, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE BOCAIUVA-MG', 60434, 3107307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1766, 6883, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 38083, 3107307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1767, 9567, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE BOCAIUVA MG', 39693, 3107307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1768, 9568, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49429, 3107406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1769, 9569, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55723, 3107406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1770, 9570, 'SERVICO NOTARIAL DO PRIMEIRO OFICIO', 59022, 3107406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1771, 9571, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS DE BOM DESPACHO', 43661, 3107406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1772, 2400, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ENGENHO DO RIBEIRO', 52779, 3107406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1773, 9572, 'OFICIO DO TABELIONATO DE PROTESTO DE TITULOS', 45567, 3107406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1774, 9573, 'SERVICO REGISTRAL DE IMOVEIS DA COMARCA DE BOM DESPACHO', 59410, 3107406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1775, 2401, 'DISTRITO TABOAO CARTORIO REG. CIVIL E ANEXOS', 45484, 3107505, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1776, 2402, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52126, 3107505, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1777, 2403, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 38000, 3107604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1778, 2404, 'OFICIO DO REGISTRO CIVIL E TABELIONATO MOTA', 53777, 3107703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1779, 2406, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PASSA-DEZ', 36392, 3107802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1780, 6884, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE QUARTEL DO SACRAMENTO', 54619, 3107802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1781, 2405, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS BOM JESUS DO GALHO', 46763, 3107802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1782, 2407, 'CARTORIO DE PAZ E TABELIONATO', 34611, 3107901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1783, 9574, 'OFICIO DO 2.º TABELIONATO DE NOTAS DE BOM SUCESSO/MG', 49163, 3108008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1784, 9575, 'CARTORIO DO PRIMEIRO TABELIONATO DE NOTAS DE BOM SUCESSO/MG', 41947, 3108008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1785, 9576, 'CARTORIO DO REGISTRO DE IMOVEIS DE BOM SUCESSO', 43505, 3108008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1786, 9577, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE BOM SUCESSO/MG', 43638, 3108008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1787, 2408, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55715, 3108008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1788, 2409, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE MACAIA', 51995, 3108008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1789, 9578, 'CARTORIO 1 OFICIO DE NOTAS  DE ALTO RIO DOCE ', 33472, 3102100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1790, 2021, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51979, 3102100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1791, 9579, '1º OFICIO DE PROTESTO DE TITULOS DE ALTO RIO DOCE', 32110, 3102100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1792, 1530, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE ABREUS', 53397, 3102100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1793, 2020, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55814, 3102100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1794, 9580, 'CARTORIO DE REGISTRO DE IMOVEIS DE ALTO RIO DOCE', 39024, 3102100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1795, 9581, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49817, 3102100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1796, 9582, 'CARTORIO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 40303, 3102100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1797, 6627, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 44081, 3102209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1798, 9583, 'CARTORIO DE REGISTRO DE IMOVEIS', 38539, 3102308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1799, 1533, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52514, 3102308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1800, 9584, '1º TABELIONATO DE NOTAS ', 41822, 3102308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1801, 1532, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE MAJOR EZEQUIEL', 51805, 3102308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1802, 9585, 'CARTORIO DE REGISTRO DE PROTESTOS DE ALVINOPOLIS - MG.', 39362, 3102308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1803, 9586, 'CARTORIO DE REGISTRO DE TITULOS, DOCUMENTOS E PESSOAS JURIDICAS', 40048, 3102308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1804, 1535, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DE ALVINOPOLIS', 35683, 3102308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1805, 9587, 'CARTORIO DO 2.º OFICIO DE NOTAS', 41095, 3102308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1806, 1534, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 52522, 3102308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1807, 6628, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ALVORADA DE MINAS', 42812, 3102407, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1808, 1536, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ITAPANHOACANGA', 52035, 3102407, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1809, 1538, 'AMPARO DO SERRA CARTORIO DE PAZ E REGISTRO CIVIL', 33019, 3102506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1810, 1537, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52498, 3102506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1811, 1539, 'SERVICO DE REGISTRO CIVIL E NOTAS DO DISTRITO DE GRAMINEA', 58479, 3102605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1812, 9588, 'OFICIO DE REGISTRO DE IMOVEIS', 47332, 3102605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1813, 9589, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49353, 3102605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1814, 13859, 'TABELIONATO DE NOTAS', 102681, 4301800, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1815, 9591, 'ANDRADAS CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 33027, 3102605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1816, 9592, 'TABELIONATO DE PROTESTO DE ANDRADAS', 60145, 3102605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1817, 6629, 'SERVENTIA REGISTRAL DAS PESSOAS NATURAIS DA COMARCA DE ANDRADAS', 91, 3102605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1818, 9593, '2º TABELIONATO DO OFICIO DE NOTAS', 45815, 3102803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1819, 9594, 'OFICIO DO REGISTRO DE IMOVEIS ', 33787, 3102803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1820, 9595, 'CARTORIO 1º OFICIO DE NOTAS', 33514, 3102803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1821, 9596, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 40006, 3102803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1822, 9597, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS E DOCUMENTOS DE DIVIDA DA COMARCA DE ANDRELANDIA ', 48884, 3102803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1823, 1540, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50906, 3102803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1824, 1453, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 36137, 3102852, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1825, 1454, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ANTONIO CARLOS', 33035, 3102902, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1826, 1455, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CAMPOLIDE', 56416, 3102902, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1827, 9598, 'OFICIO DE TITULOS E DOCUMENTOS  E CIVIL DAS PESSOAS JURIDICAS', 47571, 3103009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1828, 9599, 'OFICIO DO REGISTRO DE IMOVEIS', 54072, 3103009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1829, 1542, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE HEMATITA', 44586, 3103009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1830, 1541, 'OFICIO DE REGISTRO CIVIL E NOTAS DE ANTONIO DIAS', 42754, 3103009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1831, 1543, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 56473, 3103108, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1832, 1456, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE ARACAI', 56242, 3103207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1833, 1544, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ARACITABA', 36749, 3103306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1834, 6630, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55921, 3103405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1835, 1457, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DISTRITO DE ITIRA                                     ', 42580, 3103405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1836, 6631, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE PADRE PARAISO', 37465, 3103405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1837, 9600, 'CARTORIO DO 3° OFICIO DE NOTAS DE ARACUAI', 41640, 3103405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1838, 9601, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE ARACUAI MG ', 46391, 3103405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1839, 9602, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS', 39842, 3103405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1840, 9603, 'CARTORIO DE NOTAS DO 1º OFICIO', 34025, 3103405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1841, 9604, 'TABELIONATO DO 2º OFICIO DE NOTAS', 61200, 3103405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1842, 1458, 'CARTORIO DO REGISTRO CIVIL E NOTAS DO DISTRITO DE ENGENHEIRO SCHNOOR', 43083, 3103405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1843, 9605, 'CARTORIO DE REGISTRO DE IMOVEIS DA COMARCA DE ARACUAI', 38968, 3103405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1844, 9606, 'CARTORIO 1º OFICIO DE NOTAS', 33522, 3103504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1845, 9607, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE FLORESTINA', 152637, 3103504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1846, 9608, '2º SERVICO NOTARIAL', 32581, 3103504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1847, 1545, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE AMANHECE', 53132, 3103504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1848, 9609, 'CARTORIO DO REGISTRO DE IMOVEIS', 43406, 3103504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1849, 9610, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DA PESSOAS JURIDICAS DA COMARCA DE ARAGUARI', 57372, 3103504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1850, 9611, 'TABELIONATO DE PROTESTO DE TITULOS DE ARAGUARI', 48421, 3103504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1851, 1459, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS', 59253, 3103504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1852, 1546, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53280, 3103603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1853, 1460, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE ESTEVAO DE ARAUJO', 46888, 3103702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1854, 1547, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51847, 3103702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1855, 1893, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51797, 3103751, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1856, 1461, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE ARAPUA', 42473, 3103801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1857, 1462, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ARAUJOS', 59162, 3103900, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1858, 1548, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50872, 3104007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1859, 9612, 'ARAXA CARTORIO DE REGISTRO DE IMOVEIS', 33043, 3104007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1860, 9613, '2º TABELIONATO DE NOTAS DE ARAXA', 32789, 3104007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1861, 9614, 'CARTORIO DO 1º OFICIO DE NOTAS', 40667, 3104007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1862, 9615, 'CARTORIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 43604, 3104007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1863, 9616, 'CARTORIO DE PROTESTOS DE TITULOS E DOCUMENTOS DE ARAXA', 35089, 3104007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1864, 1549, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 42549, 3104106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1865, 1550, 'ARCOS CARTORIO DO REG.CIVIL DAS PES.NAT.', 33050, 3104205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1866, 9618, 'SERVICO REGISTRAL DE IMOVEIS', 59311, 3104205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1867, 9619, 'ARCOS CARTORIO REGISTRO DE PROTESTO', 33068, 3104205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1868, 9620, 'OFICIO DO REG. TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 50252, 3104205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1869, 9621, 'SERVICO NOTARIAL DO 2º OFICIO', 58966, 3104205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1870, 9622, 'OFICIO DO 1 TABELIONATO DE PROTESTO DE TITULOS', 47647, 3104304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1871, 1463, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50609, 3104304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1872, 9623, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49775, 3104304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1873, 9624, 'CARTORIO DE REGISTRO DE IMOVEIS', 38745, 3104304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1874, 9625, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54379, 3104304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1875, 9626, 'CARTORIO DO 1º OFICIO DE NOTAS', 40725, 3104304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1876, 6632, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE ARGIRITA', 52738, 3104403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1877, 1551, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS, INTERDICOES E TUTELAS', 37184, 3104452, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1878, 9627, '2º TABELIONATO DE NOTAS DE ARINOS', 32797, 3104502, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1879, 9628, 'CARTORIO DE REGISTRO DE IMOVEIS DE ARINOS', 39032, 3104502, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1880, 9629, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 47589, 3104502, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1881, 9630, '1º OFICIO DE NOTAS', 31997, 3104502, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1882, 9631, '1º TABELIONATO DE PROTESTOS DE ARINOS', 32417, 3104502, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1883, 1552, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35758, 3104502, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1884, 1553, 'CARTORIO DE REGISTRO CIVIL PESSOAS NATURAIS E NOTAS DE ASTOLFO DUTRA', 38448, 3104601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1885, 6633, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE SANTANA DO CAMPESTRE', 37705, 3104601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1886, 1554, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SOBRAL PINTO', 34090, 3104601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1887, 1659, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE NOVO HORIZONTE', 53744, 3104700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1888, 1658, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE FIDELANDIA', 34389, 3104700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1889, 1660, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE ATALEIA', 42945, 3104700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1890, 1464, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE AUGUSTO DE LIMA', 52720, 3104809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1891, 9632, 'TABELIONATO DE PROTESTOS DE TITULOS DE BAEPENDI', 60905, 3104908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1892, 9633, 'PRIMEIRO TABELIONATO DE NOTAS', 55384, 3104908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1893, 9634, 'BAEPENDI CARTORIO DE REGISTRO DE IMOVEIS', 33076, 3104908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1894, 9635, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49601, 3104908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1895, 9636, 'TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 61432, 3104908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1896, 1465, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35733, 3104908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1897, 1467, 'CARTORIO SAO VICENTE - OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 41970, 3105004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1898, 1466, 'CARTORIO DE REG. CIVIL PAZ E NOTAS DE VILA AMANDA', 35139, 3105004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1899, 1468, 'CARTORIO DE PAZ E NOTAS DE BALDIM', 34355, 3105004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1900, 9637, 'CARTORIO DE PROTESTO DE TITULOS', 34918, 3105103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1901, 9638, 'CARTORIO DE TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS', 40147, 3105103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1902, 1661, 'CARTORIO DE REGISTRO CIVIL DE BAMBUI-MG', 36335, 3105103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1903, 9639, 'CARTORIO DE REGISTRO DE IMOVEIS', 38927, 3105103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1904, 9640, 'CARTORIO DO 1º OFICIO DE NOTAS', 33092, 3105103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1905, 9641, 'CARTORIO DO 2º OFICIO DE NOTAS ', 41475, 3105103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1906, 1469, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE BANDEIRA', 34181, 3105202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1907, 1662, 'CARTORIO 1º OFICIO DE NOTAS E REGISTRO CIVIL', 33563, 3105301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1908, 9642, 'CARTORIO DE REGISTRO DE PROTESTOS', 39347, 3105400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1909, 9643, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE BARAO DE COCAIS', 47449, 3105400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1910, 9644, 'SERVICO DE REGISTRO DE IMOVEIS DE BARAO DE COCAIS', 58602, 3105400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1911, 9645, 'OFICIO DO 1 TABELIONATO DE NOTAS', 47605, 3105400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1912, 7433, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DO DISTRITO DE COCAIS', 51441, 3105400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1913, 9617, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48199, 3104205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1914, 9646, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49197, 3105400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1915, 1663, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE BARAO DE COCAIS', 36418, 3105400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1916, 1470, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CACHOEIRA ALEGRE', 56523, 3105509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1917, 1664, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55863, 3105509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1918, 6634, 'RCPN E TABELIONATO DE NOTAS DE BARAO DO MONTE ALTO-MG', 43257, 3105509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1919, 1667, 'OFICIO 1º REGISTRO CIVIL DAS PESSOAS NATURAIS', 46342, 3105608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1920, 9647, 'TABELIONATO DE REGISTRO DE PROTESTO DE TITULOS', 61044, 3105608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1921, 1668, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PADRE BRITO', 53603, 3105608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1922, 9648, 'CARTORIO DO PRIMEIRO OFICIO DE NOTAS', 41848, 3105608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1923, 9649, 'BARBACENA CARTORIO DO 2º OFICIO DE NOTAS', 33100, 3105608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1924, 9650, 'CARTORIO DO 3º OFICIO DE NOTAS', 41665, 3105608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1925, 9651, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39651, 3105608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1926, 1666, 'CARTORIO DE REGISTRO CIVIL E ATRIBUICAO DE NOTAS DE CORREIA DE ALMEIDA', 36590, 3105608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1927, 9652, '1º OFICIO DE REGISTRO DE IMOVEIS DE BARBACENA', 59873, 3105608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1928, 9653, '2° CARTORIO DE REGISTRO DE IMOVEIS', 32466, 3105608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1929, 1665, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SENHORA  DAS DORES', 36657, 3105608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1930, 2376, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2° SUBDISTRITO E DE INTERDICOES E TUTELAS', 36012, 3105608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1931, 6635, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE FELIPE DOS SANTOS', 53496, 3105707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1932, 2377, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 38265, 3105707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1933, 9654, 'CARTORIO POLICARPO ABREU', 55707, 3105905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1934, 9655, '2º TABELIONATO DE NOTAS ', 153486, 3105905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1935, 2378, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE BARROSO', 56259, 3105905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1936, 9656, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48397, 3105905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1937, 9657, 'TABELIONATO DE PROTESTO DE TITULOS DE BARROSO', 60541, 3105905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1938, 9658, 'CARTORIO DE REGISTRO DE IMOVEIS DE BARROSO', 57208, 3105905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1939, 2379, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 46870, 3106002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1940, 2382, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE PORTO DAS FLORES', 56499, 3106101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1941, 2381, 'CARTORIO DE SAO JOSE DAS TRES ILHAS', 43919, 3106101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1942, 2380, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52605, 3106101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1943, 9659, 'SERVICO DO 5º OFICIO DE REGISTRO DE IMOVEIS DE BELO HORIZONTE', 58693, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1944, 9660, 'BELO HORIZONTE CARTORIO DO 3º OFICIO DE NOTAS', 33126, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1945, 2384, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS INTERDICOES E TUTELAS DO DISTRITO DO BARREIRO', 42556, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1946, 9661, 'OFICIO DO REGISTRO DE DISTRIBUICAO DE PROTESTO DE TITULOS', 53843, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1947, 9662, '1º TABELIONATO DE PROTESTO DE TITULOS DE BELO HORIZONTE', 32391, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1948, 9663, '6O. OFICIO DE REGISTRO DE IMOVEIS DE BH', 32920, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1949, 9664, 'PRIMEIRO OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS DE BELO HORIZONTE', 55293, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1950, 9665, '2O OFICIO DE REGISTRO DE IMOVEIS DE BELO HORIZONTE', 32458, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1951, 9666, '3º TABELIONATO DE PROTESTO DE TITULOS DE BELO HORIZONTE', 32896, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1952, 9667, 'REGISTRO CIVIL DAS PESSOAS JURIDICAS', 55673, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1953, 1471, 'REGISTRO CIVIL DO QUARTO SUBDISTRITO', 56671, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1954, 9668, '1º OFICIO DE REGISTRO DE IMOVEIS DA COMARCA DE BELO HORIZONTE', 32128, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1955, 9669, '4º OFICIO DE NOTAS DE BELO HORIZONTE', 32912, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1956, 9670, 'CARTORIO DO 7º OFICIO DO REG. IMOVEIS', 41723, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1957, 9671, 'CARTORIO DO 10º OFICIO DE NOTAS DE BELO HORIZONTE', 40386, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1958, 9672, 'SERVICO NOTARIAL DO 8O. OFICIO DE BELO HORIZONTE', 59014, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1959, 9673, 'CARTORIO 9º OFICIO DE NOTAS DE BELO HORIZONTE', 33738, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1960, 9674, '2º TABELIONATO DE PROTESTO DE TITULOS DE BELO HORIZONTE', 32839, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1961, 9675, 'CARTORIO 2º OFICIO DE NOTAS DE BELO HORIZONTE', 33670, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1962, 2386, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE VENDA NOVA', 58412, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1963, 2383, 'SEGUNDO SUBDISTRITO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE BELO HORIZONTE - MG', 58040, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1964, 2385, 'BELO HORIZONTE CARTORIO DE PAZ E REGISTRO CIVIL 1 SUBD MG', 33118, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1965, 9676, 'CARTORIO DO QUINTO OFICIO DE NOTAS', 41954, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1966, 9677, 'CARTORIO DO 7° OFICIO DE NOTAS', 41715, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1967, 9678, 'BELO HORIZONTE CARTORIO DO 3º OFICIO DE REGISTRO DE IMOVEIS', 33134, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1968, 9679, 'OFICIO DO 4º TABELIONATO DE PROTESTOS DE BELO HORIZONTE/MG', 50021, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1969, 2425, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 58180, 3108552, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1970, 9680, 'OFICIO DO Lº TABELIONATO DE PROTESTOS DE TITULOS', 50062, 3108602, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1971, 2428, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50658, 3108602, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1972, 2427, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ANGICOS DE MINAS', 35279, 3108602, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1973, 2426, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE FERNAO DIAS', 53165, 3108602, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1974, 9681, 'CARTORIO DE REGISTRO IMOVEIS DE BRASILIA DE MINAS', 40097, 3108602, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1975, 9682, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE BRASILIA DE MINAS', 40014, 3108602, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1976, 9683, 'BRASILIA DE MINAS CARTORIO DO 1º OFICO DE NOTAS', 33209, 3108602, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1977, 9684, 'CARTORIO DO 2º OFICIO DE NOTAS DE BRASILIA DE MINAS', 41517, 3108602, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1978, 9685, 'CARTORIO 2º TABELIONATO DE NOTAS', 33712, 3108909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1979, 9686, '1º TABELIONATO DE NOTAS DE BRAZOPOLIS', 32300, 3108909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1980, 9687, 'TABELIONATO DE PROTESTO DE TITULOS', 60350, 3108909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1981, 2429, 'CARTORIO DE REGISTRO DAS PESSOAS NATURAIS', 38463, 3108909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1982, 9688, 'OFICIO DO REGISTRO DE IMOVEIS', 43430, 3108909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1983, 2431, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL', 42093, 3108909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1984, 9689, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39875, 3108909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1985, 11802, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE MINAS NOVAS', 60509, 3141801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1986, 2214, 'SERVICO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 58719, 3141801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1987, 11803, 'OFICIO DO PRIMEIRO TABELIONATO DE NOTAS DA COMARCA DE MINAS NOVAS', 47621, 3141801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1988, 11804, 'REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 57679, 3141801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1989, 11805, 'REGISTRO DE IMOVEIS', 56978, 3141801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1990, 2215, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE MINDURI', 36558, 3141900, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1991, 2768, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE MUQUEM', 52597, 3142007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1992, 6972, 'MIRABELA - CARTORIO  DO REGISTRO CIVIL E NOTAS', 46078, 3142007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1993, 11806, 'CARTORIO DE REGISTRO DE PROTESTO', 39271, 3142106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1994, 11807, 'OFICIO DO 1º TABELIONATO DE NOTAS', 149807, 3142106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1995, 11808, 'REGISTRO CIVIL DAS PESSOAS JURIDICAS E REGISTRO DE TITULOS E DOCUMENTOS', 40279, 3142106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1996, 2216, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 46508, 3142106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1997, 11809, 'CARTORIO DO 2º OFICIO DE NOTAS', 299, 3142106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1998, 11810, 'REGISTRO DE IMOVEIS', 57034, 3142106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (1999, 11811, 'OFICIO DO 1O TABELIONATO DE NOTAS', 47670, 3142205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2000, 11812, 'CARTORIO DE PROTESTOS DE TITULOS', 35055, 3142205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2001, 11813, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49494, 3142205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2002, 2218, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA COMARCA DE MIRAI-MG', 42036, 3142205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2003, 11814, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS', 39826, 3142205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2004, 2217, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52449, 3142205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2005, 11815, 'CARTORIO DO REGISTRO DE IMOVEIS', 43380, 3142205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2006, 2769, 'CARTORIO DE PAZ E REGISTRO CIVIL E NOTAS', 34579, 3142254, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2007, 2219, 'REGISTRO CIVIL E TABELIONATO DE  NOTAS DO COCO', 59287, 3142304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2008, 2220, 'SERVICO REGISTRAL DE PESSOAS NATURAIS E NOTAS', 59527, 3142304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2009, 2221, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51953, 3142403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2010, 2222, 'CARTORIO DO REGISTRO CIVIL E  TABELIONATO DE NOTAS DE MONJOLOS', 42648, 3142502, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2011, 7447, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE RODEADOR', 149385, 3142502, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2012, 7017, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE MONSENHOR PAULO', 372, 3142601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2013, 11816, 'CARTORIO DE PROTESTO E TITULOS', 34991, 3142700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2014, 11817, 'CARTORIO 1º OFICIO DE NOTAS - CARTORIO MARIAS- ', 33548, 3142700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2015, 2223, 'MONTALVANIA - CARTORIO DE NOTAS DE CAPITANIA', 46102, 3142700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2016, 11818, 'OFICIO DO 2º TABELIONATO DO NOTAS DE MONTALVANIA', 41210, 3142700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2017, 2226, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52944, 3142700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2018, 11819, 'CARTORIO DE REGISTRO DE IMOVEIS DE MONTALVANIA', 31856, 3142700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2019, 2225, 'CARTORIO DE REGISTRO CIVIL DE PITARANA', 35253, 3142700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2020, 2864, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS DE PAINS', 44438, 3146503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2021, 11444, 'OFICIO DO REGISTRO DE IMOVEIS', 53967, 3146503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2022, 2785, 'REGISTRO CIVIL PESSOAS NATURAIS E TABELIONATO', 56937, 3146602, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2023, 11445, 'OFICIO DO 1º TABELIONATO DE PROTESTOS DE TITULOS', 49015, 3146701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2024, 11446, 'OFICIO DO 2º TABELIONATO', 49338, 3146701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2025, 11447, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48173, 3146701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2026, 2867, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO', 56515, 3146701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2027, 11448, 'REGISTRO DE IMOVEIS JOSE EDUARDO ANDRADE AMARAL', 57299, 3146701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2028, 2866, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55889, 3146701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2029, 11449, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54288, 3146701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2030, 2865, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ITAPIRUCU', 43133, 3146701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2031, 2868, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PALMOPOLIS', 52142, 3146750, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2032, 7022, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE DOIS DE ABRIL', 46938, 3146750, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2033, 2869, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE PAPAGAIOS', 588, 3146909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2034, 2871, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 36228, 3147105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2035, 11450, 'REGISTRO DE IMOVEIS DA COMARCA DE PARA DE MINAS-MG', 57232, 3147105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2036, 2786, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51854, 3147105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2037, 2870, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55913, 3147105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2038, 11451, 'OFICIO DO 1º. TABELIONATO DE NOTAS', 48181, 3147105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2039, 11452, 'PARA DE MINAS CARTORIO DO 2º OFICIO DE NOTAS', 55087, 3147105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2040, 11453, 'TABELIONATO DE PROTESTOS DE TITULOS', 60889, 3147105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2041, 11454, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 33753, 3147105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2042, 11455, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48009, 3147006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2043, 11456, 'TABELIONATO DE PROTESTOS DE TITULOS', 60897, 3147006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2044, 11457, 'CARTORIO DO SEGUNDO OFICIO DE NOTAS DE PARACATU', 43828, 3147006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2045, 9379, 'CARTORIO DE REGISTRO DE PESSOA JURIDICA, TITULOS E DOCUMENTOS E PROTESTO E TABELIONATO DO 2º OFICIO DE NOTAS', 26492, 5217302, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2046, 9380, 'CARTORIO DO 1º OFICIO', 26773, 5217302, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2047, 1719, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS', 25676, 5217302, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2048, 9381, 'REGISTRO DE IMOVEIS E TABELIONATO 1.º DE NOTAS', 28290, 5217401, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2049, 9382, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO 2º DE NOTAS', 28761, 5217401, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2050, 9383, '1°SERVICO NOTARIAL E REGISTRAL', 24711, 5217609, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2051, 1556, 'REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS, CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 24984, 5217609, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2052, 1557, 'CARTORIO DO REGISTRO CIVIL DE PONTALINA', 27201, 5217708, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2053, 9384, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, T, D, PROT. E TAB 2º DE NOTAS', 26542, 5217708, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2054, 9385, 'CARTORIO DO 1º OFICIO DE NOTAS E REG. DE IMOVEIS', 26781, 5217708, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2055, 9386, '7-REGISTRO DE IMOVEIS E TABELIONATO 1º NOTAS', 25031, 5218003, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2056, 9387, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS EPROTESTOS E TABELIONATO 2° DE NOTAS', 28746, 5218003, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2057, 1558, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 28175, 5218003, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2125, 1481, 'SERVENTIA EXTRAJUDICIAL OFICIO UNICO DE GODOFREDO VIANA-MA', 31732, 2104305, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2058, 1559, 'SERVICO DE NOTAS, DE PROTESTOS DE TITULOS, TABELIONATO E REGISTRO DE CONTRATOS MARITIMOS, DE REGISTRO DE IMOVEIS, DE REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS N', 28902, 5218052, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2059, 1560, 'CARTORIO DO REG. DE PESSOAS NATURAIS, REG. DE IMOVEIS, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO', 26971, 5218102, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2060, 1561, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICOES DO TABELIONATO DE NOTAS', 25494, 5218300, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2061, 9388, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 26294, 5218300, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2062, 9389, '2.º CARTORIO DE NOTAS, PROTESTOS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 27920, 5218300, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2063, 9390, 'QUIRINOPOLIS CARTORIO DO 1 OFICIO', 27987, 5218508, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2064, 9391, 'CARTORIO DO REGISTRO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS DE TITULOS E TABELIONATO 2º DE NOTAS', 27342, 5218508, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2065, 1562, 'TABELIONATO ARTIAGA', 29405, 5218607, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2066, 9392, 'CARTORIO DO 1º OFICIO E REGISTRO DE IMOVEIS ', 26815, 5218706, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2067, 1960, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 27169, 5218706, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2068, 1563, 'RIO QUENTE CARTORIO PRIMEIRO OFICIO DE NOTAS', 28803, 5218789, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2069, 9393, '1º SERVICO NOTARIAL DE RIO VERDE', 24737, 5218805, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2070, 1565, 'CARTORIO DE REGISTRO CIVIL E ANEXOS', 25742, 5218805, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2071, 1564, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 25817, 5218805, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2072, 9394, 'RIO VERDE CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS', 26120, 5218805, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2073, 9395, 'CARTORIO DO 2º OFICIO DE NOTAS', 26906, 5218805, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2074, 9396, 'CARTORIO DO REGISTRO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO 2º DE NOTAS', 27359, 5218904, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2075, 1566, 'REGISTRO CIVIL DE PESSOAS NATURAIS DE INTERDICOES, TUTELAS E TABELIONATO DE NOTAS', 28100, 5218904, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2076, 1567, 'SERVICOS DE NOTAS, TABELIONATO, REGISTRO DE CONTRATOS MARITIMOS, REGISTRO CIVIL DE PESSOAS NATURAIS E DE INTERDICOES E TUTELAS. ', 29264, 5218904, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2077, 9397, 'REGISTRO DE IMOVEIS E TABELIONATO 1° DE NOTAS', 28340, 5218904, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2078, 9398, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1° DE NOTAS', 26229, 5219001, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2079, 1568, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICAO E TUTELA E TABELIONATOS DE NOTAS', 25544, 5219001, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2080, 9399, 'CARTORIO DE REG.PES.JUR.TIT.DOC. E PROT., TAB. 2° DE NOTAS E ESC. DO 2° CIVEL', 25346, 5219001, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2081, 1569, 'SERVICOS DE NOTAS, PROT. DE TITULOS, TABEL. E REG. DE CONTRATOS MARITIMOS, REG. DE IMOVEIS, REG. DE TITULOS E DOC., CIVIL DAS PESSO.JUR. E CIVIL DAS PESS.NAT.E DE INTERD. E TUTELA', 29207, 5219100, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2082, 9400, 'SERV.DE NOTAS,PROT.TIT.TAB.E REG.CONT.MARITIMOS', 28886, 5219209, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2083, 1570, 'SERVICO DE REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS NATURAIS E DE INTERDICOES JUDICIAIS', 28985, 5219209, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2084, 1571, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 25908, 5219258, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2085, 9401, 'CARTORIO REGISTRO DE IMOVEIS, TITULOS, DOCUMENTOS, TABELIONATO DE NOTAS E PROTESTOS', 27631, 5219258, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2086, 9402, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 26252, 5219308, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2087, 1572, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS,TABELIONATO DE NOTAS E CONTRATOS MARITMOS', 25718, 5219308, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2088, 9403, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS E TABELIONATO 2º DE NOTAS', 26567, 5219308, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2089, 1573, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 145755, 5219357, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2090, 9404, 'SERVICOS DE NOTAS E ANEXOS', 29090, 5219357, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2091, 1574, '1º SERVICO NOTARIAL REGISTRO DE IMOVEIS E ANEXOS', 24760, 5219407, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2092, 1576, '07.-', 24679, 5219605, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2093, 9405, 'CARTORIO DE NOTAS, DE PROTESTOS DE TITULOS E REGISTROS DE CONTRATOS MARITIMOS', 25270, 5219704, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2094, 1577, 'SERVICOS DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS, CIVIL DAS PESSOAS NATURAIS, DE INTERDICOES E TUTELAS ', 29306, 5219704, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2095, 1578, 'SERV DE NOTAS PROT DE TIT TAB REG DE CONT MAR REG IMOVEIS', 28837, 5219712, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2096, 9406, 'CARTORIO REGISTRO DE  IMOVEIS,TITULOS E DOCUMENTOS CIVIL DAS PESSOAS JURIDICAS', 27581, 5219753, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2097, 1579, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 25874, 5219753, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2098, 9407, 'CARTORIO DO 1ºOFICIO DE NOTAS E PROTESTO DE TITULOS E DOCUMENTOS E REGISTRO DE CONTRATOS MARITIMOS', 26856, 5219753, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2099, 9408, 'CARTORIO DE REGISTRO DE IMOVEIS DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E REGISTRO CIVIL DAS PESSOAS NATURAIS E INTERDICOES E TUTELAS', 26062, 5219803, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2100, 9409, '2º TABELIONATO DE NOTAS, PROTESTOS DE TITULOS, CONTRATOS MARITIMOS', 24992, 5219803, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2101, 1580, 'REGISTRO CIVL DE PESSOAS NATURAIS', 28217, 5219902, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2102, 9410, 'CARTORIO REGISTRO DE IMOVEIS, TAB DE NOTAS, TITULOS E DOCUMENTOS', 27623, 5219902, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2103, 1581, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 146878, 5220009, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2104, 9411, 'SERVICOS DE NOTAS, PROTESTOS DE TITULOS, TABELIONATO E REGISTROS DE CONTRATOS MARITIMOS, REGISTROS DE IMOVEIS, REGISTROS DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVEL DAS PESSOAS NATURA', 29231, 5220009, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2105, 1582, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE SAO JOAO DA PARAUNA-GO', 27060, 5220058, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2106, 9412, 'TABELIONATO 1º DE NOTAS E REGISTRO GERAL DE IMOVEIS', 29363, 5220108, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2107, 1583, 'TABELIONATO DE NOTAS, TABELIONATO E OFICIALATO DE REGISTRO DE CONTRATOS MARITIMOS, REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 25841, 5220108, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2108, 1584, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO', 25650, 5220108, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2109, 9413, 'SAO LUIZ M BELOS CARTORIO DO SEGUNDO OFICIO NOTAS', 28811, 5220108, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2110, 1585, 'EDMEA FERNANDES RODRIGUES', 27722, 5220157, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2111, 9414, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1° DE NOTAS', 26211, 5220207, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2112, 9415, 'CARTORIOREGISTRO CIVIL DAS PESSOAS NATURAIS', 27664, 5220207, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2113, 1639, 'SERVENTIA EXTRAJUDICIAL', 149773, 2103752, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2114, 1474, 'CARTORIO EXTRAJUDICIAL DO 2º OFICIO', 30643, 2103802, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2115, 9416, 'CARTORIO EXTRAJUDICIAL DO 1º OFICIO', 30627, 2103802, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2116, 1475, 'SERVENTIA EXTRA JUDICIAL  DE DUQUE BACELAR', 30775, 2103901, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2117, 9417, '1º OFICIO EXTRAJUDICIAL DE ESPERANTINOPOLIS', 31427, 2104008, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2118, 1476, '2º OFICIO EXTRAJUDICIAL DE ESPERANTINOPOLIS', 149021, 2104008, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2119, 9418, 'SERVENTIA EXTRAJUDICIAL DE 1º OFICIO', 31237, 2104057, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2120, 1477, 'CARTORIO DO 2º OFICIO EXTRAJUDICIAL ', 30338, 2104057, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2121, 7410, 'SERVENTIA EXTRAJUDICIAL', 149583, 2104073, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2122, 1478, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO DE FORMOSA DA SERRA NEGRA - MA', 148940, 2104099, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2123, 1479, 'SERVENTIA EXTRAJUDICIAL DE OFICIO UNICO', 31302, 2104107, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2124, 1480, 'OFICIO UNICO', 30874, 2104206, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2126, 1640, 'SERVENTIA EXTRAJUDICIAL DE OFICIO UNICO', 31336, 2104404, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2127, 1641, 'CARTORIO OFICIO UNICO', 30684, 2104503, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2128, 1642, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO DEGOVERNADOR EDSON LOBAO', 149062, 2104552, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2129, 1643, 'SERVENTIA EXTRAJUDICIAL', 31153, 2104602, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2130, 7411, 'SERVENTIA EXTRAJUDICIAL', 31146, 2104677, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2131, 1884, 'OFICIO UNICO', 30882, 2104701, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2132, 9419, 'SERVENTIA DO PRIMEIRO OFICIO EXTRAJUDICIAL DE GRAJAU', 30999, 2104800, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2133, 1644, 'CARTORIO EXTRAJUDICIAL - 2° OFICIO', 30593, 2104800, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2134, 9420, 'SERVENTIA EX TRAJUDICIAL', 31062, 2104909, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2135, 1965, 'OFICIO UNICO', 30890, 2105005, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2136, 1885, 'SERVENTIA EXTRAJUDICIAL', 29751, 2105104, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2137, 1645, 'SERVENTIA EXTRAJUDICIAL- CARTORIO DO OFICIO UNICO', 31070, 2105203, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2138, 9421, '6° OFICIO EXTRAJUDICIAL DE IMPERATRIZ', 30445, 2105302, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2139, 9422, '7º OFICIO EXTRAJUDICIAL DE IMPERATRIZ', 29918, 2105302, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2140, 2417, '2º OFICIO EXTRAJUDICIAL', 29827, 2105302, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2141, 9423, '4º OFICIO EXTRAJUDICIAL', 29900, 2105302, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2142, 1966, '1º OFICIO EXTRAJUDICIAL', 29652, 2105302, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2143, 9424, 'CARTORIO DO 5ºOFICIO EXTRAJUDICIAL', 30437, 2105302, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2144, 9425, 'CARTORIO DO 3º OFICIO EXTRAJUDICIAL', 30429, 2105302, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2145, 9426, 'SERVENTIA EXTRAJUDICIAL 182 - REGISTRO DE IMOVEIS', 31211, 2105401, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2146, 1482, 'SERVENTIA EXTRA JUDICIAL Nº 183, REGISTRO CIVIL, REGISTRO DE TITULOS E DOCUMENTOS, REGISTROS MARITIMOS, NOTAS- 2º OFICIO', 31088, 2105401, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2147, 9427, 'SERVENTIA DO TERCEIRO OFICIO EXTRAJUDICIAL', 30551, 2105401, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2148, 1886, 'SERVENTIA EXTRAJUDICIAL DE ITINGA DO MARANHAO', 148460, 2105427, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2149, 9428, '1º OFICIO EXTRAJUDICIAL DE JOAO LISBOA', 29694, 2105500, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2150, 1967, '2º OFICIO EXTRAJUDICIAL DE JOAO LISBOA', 29843, 2105500, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2151, 1483, 'CARTORIO DO OFICIO UNICO', 30494, 2105609, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2152, 1484, '2° OFICIO EXTRAJUDICIAL', 30833, 2105708, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2153, 9429, 'EXTRAJUDICIAL DO 1º OFICIO', 30825, 2105708, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2154, 1646, 'EXTRAJUDICIAL DO OFICIO UNICO', 30817, 2105807, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2155, 1647, 'CARTORIO DO OFICIO UNICO EXTRAJUDICIAL', 30544, 2105906, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2156, 1485, 'SERVENTIA EXTRAJUDICIAL DE LIMA CAMPOS', 31278, 2106003, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2157, 1648, 'SERVENTIA EXTRAJUDICIAL DA COMARCA DE LORETO/MA', 29710, 2106102, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2158, 1486, 'SERVENTIA EXTRAJUDICIAL OFICIO UNICO', 31724, 2106300, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2159, 1487, 'SERVENTIA EXTRAJUDICIAL ', 31120, 2106326, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2160, 9430, 'SERVENTIA EXTRAJUDICIAL', 149336, 2106375, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2161, 1968, 'SERVENTIA EXTRAJUDICIAL', 31112, 2106409, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2162, 1488, 'SERVENTIA EXTRAJUDICIAL DE OFICIO UNICO', 31310, 2106508, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2163, 1649, 'SERVENTIA EXTRAJUDICIAL DE OFICIO UNICO', 31328, 2106607, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2164, 1887, 'EXTRAJUDICIAL', 30809, 2106706, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2165, 2418, 'SERVENTIA EXTRAJUDICIAL', 30502, 2106755, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2166, 1650, 'SERVENTIA EXTRAJUDICIAL DE MIRINZAL', 31286, 2106805, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2167, 1969, 'SERVENTIA EXTRAJUDICIAL WASHINGTON JOSE CAMPOS SERRA', 31757, 2106904, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2168, 1489, 'SERVENTIA EXTRAJUDICIAL DE MONTES ALTOS - OFICIO UNICO', 29637, 2107001, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2169, 1490, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO', 31633, 2107100, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2170, 1491, 'CARTORIO DO OFICIO UNICO', 30452, 2107209, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2171, 1651, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO', 31658, 2107308, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2172, 1492, 'SERVENTIA EXTRAJUDICIAL', 31187, 2107407, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2173, 1970, 'SERVENTIA EXTRAJUDICIAL DO 2º OFICIO', 31583, 2107506, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2174, 9431, '1º OFICIO EXTRAJUDICIAL DE PACO DO LUMIAR', 31534, 2107506, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2175, 1971, 'CARTORIO OFICIO UNICO EXTRAJUDICIAL', 30692, 2107605, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2176, 9432, 'EXTRAJUDICIAL', 30783, 2107704, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2177, 1653, '2ª SERVENTIA EXTRAJUDICIAL Nº 58', 29744, 2107704, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2178, 1972, 'SERVENTIA EXTRAJUDICIAL DE PARNARAMA - CARTORIO Mª DOLORES', 31369, 2107803, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2179, 1493, 'EXTRAJUDICIAL', 30791, 2107902, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2180, 1494, 'SERVENTIA EXTRAJUDICIAL DO SEGUNDO OFICIO COMARCA DE PASTOS BONS', 31708, 2108009, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2181, 9433, 'EXTRAJUDICIARIO CARTORIO 1º OFICIO COMARCA PASTOS BONS-MA', 30858, 2108009, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2182, 1654, 'SERVENTIA EXTRAJUDICIAL', 31179, 2108108, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2183, 1495, '2º OFICIO EXTRAJUDICIAL DE PEDREIRAS', 29850, 2108207, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2184, 9434, 'CARTORIO DO 3º OFICIO EXTRAJUDICIAL', 30569, 2108207, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2185, 9435, '1º OFICIO EXTRAJUDICIAL', 29660, 2108207, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2186, 6942, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO DE PEDRO DO ROSARIO-MA', 148890, 2108256, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2187, 1655, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO', 148148, 2108306, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2188, 1656, 'SERVENTIA EXTRAJUDICIAL - OFICIO UNICO', 30759, 2108405, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2189, 9436, 'OFICIO DO 2° TABELIONATO DE NOTAS', 49247, 3101508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2190, 2012, 'OFICIO DO REGISTRO CIVIL E DE INTERDICOES E TUTELAS', 51128, 3101508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2191, 9437, 'CARTORIO DE REGISTRO DE IMOVEIS', 38778, 3101508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2192, 9438, 'CARTORIO DE REGISTRO DE PROTESTO DE TITULOS E DIVIDAS', 39305, 3101508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2193, 9439, 'CARTORIO DO PRIMEIRO OFICIO DE NOTAS DE ALEM PARAIBA - MG', 41814, 3101508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2194, 2013, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ANGUSTURA', 53405, 3101508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2195, 9440, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 43943, 3101508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2196, 9441, 'OFICIO DO REGISTRO DE IMOVEIS DE ALFENAS', 38562, 3101607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2197, 9442, 'OFICIO DO 1º. TABELIONATO DE PROTESTO DE TITULOS', 49098, 3101607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2198, 9443, 'OFICIO DO 1º TABELIONATO DO NOTAS DE ALFENAS', 40451, 3101607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2199, 9444, 'CARTORIO DO 2º OFICIO DE NOTAS DE ALFENAS MG', 41509, 3101607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2200, 2014, 'REGISTRO CIVIL E TABELIONATO DE NOTAS DE BARRANCO ALTO', 52803, 3101607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2201, 1526, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS ', 50476, 3101607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2202, 9445, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 47431, 3101607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2203, 1527, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO DE NOTAS - CARTORIO OSWALDO ANGELO FURTADO', 42358, 3101631, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2204, 9446, 'NOTAS', 46177, 3101706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2205, 1528, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PEDRA GRANDE', 31922, 3101706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2206, 9447, 'CARTORIO DE REGISTRO DE IMOVEIS DE ALMENARA', 39016, 3101706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2207, 9448, 'ALMENARA CARTORIO DE PROTESTOS', 33001, 3101706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2208, 9449, 'CARTORIO DO 2º OFICIO DE NOTAS', 41491, 3101706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2209, 9450, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 39933, 3101706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2210, 2015, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55749, 3101706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2211, 1529, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE ALPERCATA', 33746, 3101805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2212, 9451, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS', 54189, 3101904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2213, 9452, 'CARTORIO PRIMEIRO OFICIO DE NOTAS DE ALPINOPOLIS', 44206, 3101904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2214, 9453, 'OFICIO DO SEGUNDO TABELIONATO DE NOTAS', 54668, 3101904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2215, 9454, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 152520, 3101904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2216, 6879, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50864, 3101904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2217, 9455, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAAS JURIDICAS', 35428, 3101904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2218, 9456, 'TABELIONATO DE PROTESTO DE TITULOS', 60327, 3101904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2219, 9457, 'CARTORIO DE REGISTRO DE IMOVEIS', 38752, 3101904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2220, 2016, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL', 52381, 3102001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2221, 2017, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE DIVINO ESPIRITO SANTO', 36145, 3102001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2222, 2018, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE ALTO CAPARAO', 38232, 3102050, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2223, 2019, 'CARTORIO DE PAZ E REGISTRO CIVIL', 34470, 3153509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2224, 1531, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE VITORINOS', 51136, 3102100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2225, 9458, 'CARTORIO DO 1º OFICIO-EXTRAJUDICIAL', 30213, 2108504, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2226, 1973, '2º OFICIO EXTRAJUDICIAL', 29801, 2108504, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2227, 9459, '1º OFICIO', 144618, 2108603, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2228, 1657, 'SEGUNDA SERVENTIA DE NOTAS E REGISTRO CIVIL', 31021, 2108603, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2229, 1496, 'PIO XII CARTORIO DO OFICIO UNICO', 30957, 2108702, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2230, 1888, 'SERVENTIA UNICA', 31765, 2108801, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2231, 1497, 'CARTORIO RAIMUNDO LUCAS', 30700, 2108900, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2232, 9460, 'CARTORIO DO 1º OFICIO EXTRAJUDICIAL ', 29942, 2109007, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2233, 1974, 'CARTORIO 2° OFICIO EXTRAJUDICIAL', 29967, 2109007, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2234, 1889, 'SERVENTIA EXTRAJUDICIAL DO 2º OFICIO', 31575, 2109106, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2235, 9461, 'SERVENTIA EXTRAJUDICIAL DO 1º OFICIO', 31484, 2109106, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2236, 1498, 'OFICIO UNICO', 30916, 2109205, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2237, 1499, 'SERVENTIA EXTRAJUDICIAL CARTORIO DO OFICIO UNICO DE PRESIDENTE VARGAS-MA', 31229, 2109304, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2238, 1975, 'OFICIO UNICO DE PRIMEIRA CRUZ-MA', 30940, 2109403, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2239, 7413, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO', 149120, 2109452, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2240, 6874, 'CARTORIO DO 2º OFICIO DE RIACHAO SERVENTIA EXTRAJUDICIAL 070', 30312, 2109502, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2241, 1500, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO DE RIBAMAR FIQUENE', 149195, 2109551, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2242, 9462, 'CARTORIO DO 1º OFICIO EXTRAJUDICIAL', 30205, 2109601, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2243, 1501, 'SERVENTIA DO 2º OFICIO EXTRAJUDICIAL', 30379, 2109601, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2244, 1502, 'CARTORIO DO OFICIO UNICO', 30460, 2109700, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2245, 1976, 'SERVENTIA DO SEGUNDO OFICIO EXTRAJUDICIAL', 31054, 2109809, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2246, 9463, 'CARTORIO DO 1º OFICIO EXTRAJUDICIAL', 30197, 2109809, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2247, 9464, '3° OFICIO EXTRAJUDICIAL', 29876, 2109908, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2248, 9465, '1º OFICIO EXTRAJUDICAL', 30122, 2109908, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2249, 1977, 'SEGUNDO OFICIO EXTRAJUDICIAL  191', 31039, 2109908, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2250, 1978, 'CARTORIO DO 2º OFICIO SERVENTIA EXTRAJUDICIAL', 30403, 2110005, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2251, 9466, '1° OFICIO EXTRAJUDICIAL DE SANTA LUZIA', 29645, 2110005, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2252, 1979, '2.º OFICIO EXTRAJUDICIAL', 30247, 2110039, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2253, 9467, 'CARTORIO DO 1º OFICIO EXTRAJUDICIAL', 30148, 2110039, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2254, 1980, 'SERVENTIA EXTRAJUDICIAL DE SANTA QUITERIA DO MARANHAO', 31401, 2110104, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2255, 1503, 'CARTORIO DO OFICIO UNICO', 30510, 2110203, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2256, 1981, 'SERVENTIA EXTRAJUDICIAL DE SANTO ANTONIO DOS LOPES', 30866, 2110302, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2257, 1982, 'SERVENTIA EXTRAJUDICIAL DE OFICIOUNICO', 31351, 2110401, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2258, 9468, 'SERVENTIA EXTRAJUDICIAL DO 1º OFICIO', 31450, 2110500, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2259, 1983, '2º OFICIO EXTRAJUDICIAL DE SAO BENTO', 29868, 2110500, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2260, 7414, '1ª SERVERTIA EXTRAJUDICIAL DE SAO BERNARDO', 29603, 2110609, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2261, 1984, 'SERVENTIA EXTRAJUDICIAL', 30650, 2110708, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2262, 1985, 'CARTORIO DO OFICIO UNICO', 30486, 2110807, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2263, 1986, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO DE SAO FRANCISCO DO MARANHAO', 31690, 2110906, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2264, 9469, 'SERVENTIA EXTRAJUDICIAL DE SAO JOAO BATISTA-MA', 148536, 2111003, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2265, 1987, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO', 148908, 2111052, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2266, 1988, 'SERVENTIA EXTRAJUDICIAL', 31161, 2111102, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2267, 9470, 'SERVENTIA EXTRAJUDICIAL DO 1º OFICIO', 31468, 2111201, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2268, 6875, '2º OFICIO EXTRAJUDICIAL - S.J. DE RIBAMAR/MA.', 29835, 2111201, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2269, 9471, 'SAO LUIS CART DE REG DE PROT DE LETRAS E OUTROS TITULOS/CARTORIO NORIS SERRA MARANHAO', 31005, 2111300, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2270, 9472, '2° OFICIO DE NOTAS', 29777, 2111300, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2271, 9473, 'CARTORIO DA 2ª ZONA DE REGISTROS DE IMOVEIS', 29975, 2111300, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2272, 1989, 'SERVENTIA EXTRAJUDICIAL DE REGISTRO CIVIL DA 4ª ZONA', 31385, 2111300, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2273, 9474, '1ºCARTORIO DE REGISTRO DE IMOVEIS', 29702, 2111300, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2274, 1504, 'SERVENTIA EXTRAJUDICIAL DE PESSOAS NATURAIS DA 5ª ZONA', 31377, 2111300, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2275, 1991, 'CARTORIO DE REGISTRO CIVIL DA 2ª ZONA', 30007, 2111300, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2276, 1505, '1ª ZONA DE REGISTRO CIVIL DE  SAO LUIS', 31047, 2111300, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2277, 9475, 'CARTORIO DE NOTAS DO 3º OFICIO', 29983, 2111300, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2278, 1990, 'CARTORIO DE REGISTRO CIVIL DA 3ª ZONA - JOAO PAULO', 30015, 2111300, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2279, 9476, 'CANTUARIA DE AZEVEDO REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DE PESSOAS JURIDICAS', 29926, 2111300, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2280, 9477, 'SAO LUIS QUARTO CARTORIO OFICIO DE NOTAS', 31013, 2111300, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2281, 9478, 'TABELIONATO DO PRIMEIRO OFICIO DA CAPITAL', 31773, 2111300, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2282, 9479, 'CARTORIO DO 1º OFICO', 30221, 2111409, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2283, 1506, 'CARTORIO DO 2º OFICIO EXTRAJUDICIAL', 30320, 2111409, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2284, 1507, 'SERVENTIA EXTRAJUDICIAL DE SAO MATEUS DO MARANHAO', 31203, 2111508, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2285, 1992, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO DE SAO PEDRO DA AGUA BRANCA', 149229, 2111532, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2286, 1993, 'SERVENTIA EXTRAJUDICIAL DA COMARCA DE SAO RAIMUNDO DAS MANGABEIRAS', 148577, 2111607, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2287, 1994, 'SERVENTIA EXTRAJUDICIAL DO OFICIO  UNICO', 31625, 2111706, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2288, 1509, 'SERVENTIA EXTRAJUDICIAL', 149518, 2111763, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2289, 1510, 'SERVENTIA EXTRAJUDICIAL', 30478, 2111805, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2290, 1995, 'SERVENTIA EXTRAJUDICIAL DE SUCUPIRA DO NORTE', 31419, 2111904, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2291, 1996, 'CARTORIO DO OFICIO UNICO', 30528, 2112001, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2292, 1997, 'CARTORIO DO OFICIO UNICO DE TIMBIRAS - SERVENTIA EXTRAJUDICIAL ', 30536, 2112100, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2293, 9480, '3° OFICIO EXTRAJUDICIAL', 30767, 2112209, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2294, 1998, 'CARTORIO DO 2 OFICIO EXTRAJUDICIAL', 30239, 2112209, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2295, 9481, 'SERVENTIA EXTRAJUDICIAL DO PRIMEIRO OFICIO DE TIMON', 29678, 2112209, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2296, 6943, 'CARTORIO DE OFICIO UNICO DE TRIZIDELA DO VALE', 149013, 2112233, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2297, 9482, '1º OFICIO EXTRAJUDICIAL DE TUNTUM/MA', 144667, 2112308, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2298, 1999, 'CARTORIO DO 2º OFICIO ACACIA LIMA FIGUEIRA', 29934, 2112308, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2299, 2000, 'SERVENTIA EXTRAJUDICIAL DE TURIACU', 150540, 2112407, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2300, 9483, 'SERVENTIA EXTRAJUDICIAL', 149666, 2112456, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2301, 9484, '1° OFICIO DE TUTOIA', 29629, 2112506, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2302, 2001, '2ª SERVENTIA EXTRAJUDICIAL DE TUTOIA MA', 29736, 2112506, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2303, 6944, 'SERVENTIA EXTRAJUDICIAL NOTARIAL E REGISTRAL', 31716, 2112605, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2304, 1511, 'SERVENTIA EXTRA JUDICIAL DO 2° OFICIO', 30734, 2112704, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2305, 9485, 'CARTORIO DO 1º OFICIO  EXTRAJUDICIAL', 30171, 2112704, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2306, 2002, 'CARTORIO DO 2º OFICIO VIANA', 30395, 2112803, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2307, 9486, 'SERVENTIA EXTRAJUDICIAL DO 1º OFICIO', 31781, 2112803, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2308, 2003, 'CARTORIO DO 2º OFICIO EXTRAJUDICIAL ', 30346, 2112902, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2309, 9487, '1º OFICIO EXTRAJUDICIAL DE VITORIA DO MEARIM', 30130, 2112902, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2310, 9488, 'PRIMEIRO OFICIO EXTRAJUDICIAL', 30981, 2113009, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2311, 2004, '2º OFICIO EXTRAJUDICIAL', 29793, 2113009, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2312, 9489, 'CARTORIO EXTRA JUDICIAL DO 1º OFICIO', 30577, 2114007, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2313, 2005, 'SERVENTIA EXTRAJUDICIAL DO 2° OFICIO', 31542, 2114007, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2314, 2006, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ABADIA DOS DOURADOS', 38141, 3100104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2315, 9490, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 47498, 3100203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2316, 9491, 'TABELIONATO DE PROTESTOS DE TITULOS DA COMARCA DE ABAETE', 60921, 3100203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2317, 9492, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49593, 3100203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2318, 1512, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 46490, 3100203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2319, 9493, 'OFICIO DO REGISTRO DE IMOVEIS DE ABAETE', 57158, 3100203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2320, 9494, 'OFICIO DO 1° TABELIONATO DE NOTAS', 547, 3100203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2321, 9495, 'SERVENTIA DO REGISTRO DE PROTESTO DE TITULOS', 58313, 3100302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2322, 9496, 'SERVICO DO REGISTRO DE IMOVEIS ', 58768, 3100302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2323, 9497, 'SERVENTIA DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 58263, 3100302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2324, 9498, 'SERVICO NOTARIAL DO 2º OFICIO DE NOTAS', 58982, 3100302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2325, 6876, 'SERVICO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE GRANADA', 52001, 3100302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2326, 9499, 'SERVICO NOTARIAL DO 1º OFICIO DE NOTAS', 58925, 3100302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2327, 2007, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 59121, 3100302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2328, 1513, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE ACAIACA', 44677, 3100401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2329, 6877, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE FELICINA', 51607, 3100500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2330, 9500, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48033, 3100500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2331, 1515, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50492, 3100500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2332, 9501, '2º TABELIONATO DE NOTAS', 32656, 3100500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2333, 9502, 'ACUCENA CARTORIO DE REGISTRO DE IMOVEIS', 32938, 3100500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2334, 1514, 'CARTORIO VIEIRA  -  REGISTRO CIVIL E NOTAS DE NAQUE-NANUQUE', 53595, 3100500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2335, 1516, 'CARTORIO SERVICO REGISTRAL E NOTARIAL DE ARAMIRIM / MG', 53413, 3100500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2336, 1517, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE GAMA', 53504, 3100500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2337, 9503, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS E DOCUMENTOS DE DIVIDAS', 48546, 3100500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2338, 9504, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39446, 3100500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2339, 1518, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE AGUA BOA', 32953, 3100609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2340, 1519, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE AGUA COMPRIDA', 37895, 3100708, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2341, 1520, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51433, 3100807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2342, 9505, 'TABELIONATO DO 1º OFICIO DE NOTAS ', 61101, 3100906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2343, 9506, 'OFICIO DE REGISTRO DE IMOVEIS', 44024, 3100906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2344, 1521, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 59808, 3100906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2345, 9507, 'OFICIO DO 2º TABELIONATO DE NOTAS', 31815, 3100906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2346, 9508, 'TABELIONATO DE PROTESTO DE TITULOS', 60210, 3100906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2347, 9509, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 44016, 3100906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2348, 1891, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ITAMARATI', 53538, 3101003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2349, 1890, 'OFICIO DO REGISTRO DAS PESSOAS NATURAIS DE AGUAS VERMELHAS MG', 37853, 3101003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2350, 9510, '2ª TABELIA DE NOTAS DA COMARCA DE AIMORES', 49155, 3101102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2351, 6878, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE TABAUNA', 38109, 3101102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2352, 9511, 'PRIMEIRO TABELIONATO DE PROTESTOS DE AIMORES', 55475, 3101102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2353, 1892, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ALTO CAPIM', 56929, 3101102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2354, 9512, 'AIMORES CARTORIO 3º OFICIO DE NOTAS', 32979, 3101102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2355, 2009, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PENHA DO CAPIM', 32961, 3101102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2356, 9513, 'SERVICO REGISTRAL IMOBILIARIO', 59733, 3101102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2357, 2010, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS', 59220, 3101102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2358, 1522, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE EXPEDICIONARIO ALICIO', 43158, 3101102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2359, 1523, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE MUNDO NOVO DE MINAS', 42911, 3101102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2360, 9514, 'TABELIONATO DO 1º OFICIO DE NOTAS', 61085, 3101102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2361, 9515, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 39917, 3101102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2362, 1524, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO SEBASTIAO DA VALA', 32987, 3101102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2363, 2008, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CONCEICAO DO CAPIM', 32995, 3101102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2364, 9516, 'CARTORIO DO 1º OFICIO DE NOTAS DE AIURUOCA', 48405, 3101201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2365, 9517, 'SERVICO REGISTRAL DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 59642, 3101201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2366, 9518, 'SERVICO DE REGISTRO DE IMOVEIS', 58529, 3101201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2367, 1525, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE AIURUOCA', 51003, 3101201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2368, 9519, '1° TABELIONATO DE PROTESTO DA COMARCA DE AIURUOCA', 48439, 3101201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2369, 9520, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49692, 3101201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2370, 2011, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ALAGOA', 52985, 3101300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2371, 7431, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ALBERTINA', 50682, 3101409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2372, 9521, 'OFICIO DO 3° TABELIONATO DE NOTAS', 49924, 3101508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2373, 1617, 'CARTORIO DO 2º OFICIO EXTRAJUDICIAL', 30387, 2101608, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2374, 9522, 'CARTORIO DO 1.º OFICIO DE BARREIRINHAS', 30031, 2101707, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2375, 1618, 'OFICIO UNICO', 30908, 2101806, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2376, 1932, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CRUZEIRO DA FORTALEZA', 58354, 3120706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2377, 11636, '1º TABELIONATO DE NOTAS', 32250, 3120805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2378, 11637, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49759, 3131208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2379, 2967, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50435, 3131208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2380, 11638, 'IPATINGA CARTORIO DE REGISTRO DE IMOVEIS', 45666, 3131307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2381, 11639, 'TABELIONATO DE NOTAS DO SEGUNDO OFICIO DE IPATINGA', 45658, 3131307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2382, 2253, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE IPATINGA', 35931, 3131307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2383, 11640, 'IPATINGA CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 45674, 3131307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2384, 11641, 'PRIMEIRO TABELIONATO DE NOTAS DE IPATINGA MINAS GERAIS', 55434, 3131307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2385, 2968, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 46961, 3131307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2386, 11642, 'TABELIONATO DE PROTESTOS DE TITULOS E OUTROS DOCUMENTOS DE DIVIDAS DE IPATINGA / MG', 60996, 3131307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2387, 2254, 'IPIACU - CARTORIO DO REGISTRO CIVIL E NOTAS', 45682, 3131406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2388, 2255, 'REGISTRO CIVIL DE PESSOAS NATURAIS E NOTAS DE IPUIUNA MG', 56648, 3131505, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2389, 2256, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E NOTAS', 36434, 3131604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2390, 11643, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS DE ITABIRA', 48827, 3131703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2391, 11644, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS DE ITABIRA', 39453, 3131703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2392, 11645, 'TABELIONATO DO 2º OFICIO DE NOTAS', 61168, 3131703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2393, 2969, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE IPOEMA', 46714, 3131703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2394, 11646, 'CARTORIO DO 3º OFICIO DE NOTAS DE ITABIRA', 41673, 3131703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2395, 2970, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 46953, 3131703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2396, 11647, 'OFICIO DO 1º TABELIONATO DE NOTAS', 47977, 3131703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2397, 2257, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DE ITABIRA ', 35949, 3131703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2398, 6643, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52316, 3131703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2399, 11648, 'OFICIO DE REGISTRO DE IMOVEIS DE ITABIRA', 45690, 3131703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2400, 2258, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ITABIRINHA', 46979, 3131802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2401, 2971, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE BOA UNIAO DE ITABIRINHA', 51680, 3131802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2402, 11649, 'OFICIO DE REGISTRO DE IMOVEIS', 47175, 3131901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2403, 1472, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICOES NOTARIAIS DE BOM JESUS DO BAGRE', 34272, 3106309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2404, 6881, 'OFICIO DO REGISTRO CIVIL PESSOAS NATURAIS', 53801, 3106408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2405, 9541, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49841, 3106408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2406, 9542, 'CARTORIO DE REGISTRO DE IMOVEIS', 38505, 3106408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2407, 9543, 'OFICIO DO 1º TEBELIONATO DE PROTESTO DE TITULOS', 49072, 3106408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2408, 9544, 'CARTORIO DO 1º TABELIONATO DE NOTAS', 41020, 3106408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2409, 2388, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SANTANA DO PARAOPEBA', 46722, 3106408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2410, 9545, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JUIRICAS', 57398, 3106408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2411, 9546, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 42838, 3106507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2412, 2389, 'CARTORIO DE NOTAS E REGISTRO CIVIL', 34066, 3106507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2413, 2390, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 36251, 3106655, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2414, 2391, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 43950, 3106606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2415, 2392, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55731, 3106705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2416, 9547, 'SERVICO REGISTRAL IMOBILIARIO DE BETIM', 39040, 3106705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2417, 9548, 'OFICIO DO 1º TABELIONATO DE PROTESTOS DE TITULOS', 48983, 3106705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2418, 9549, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39594, 3106705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2419, 9550, '2º SERVICO NOTARIAL DE BETIM', 59, 3106705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2420, 9551, 'TABELIONATO 1º OFICIO DE NOTAS DE BETIM MG', 59998, 3106705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2421, 2393, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52084, 3106804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2422, 9552, 'CARTORIO DO PRIMEIRO OFICIO DE NOTAS ARY MAROCCO', 41905, 3106903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2423, 6882, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 31831, 3106903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2424, 9553, 'CARTORIO SEGUNDO OFICIO DE NOTAS', 45195, 3106903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2425, 9554, 'TABELIONATO DE PROTESTOS DE BICAS', 60822, 3106903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2426, 9555, 'CARTORIO REGISTROS DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 45112, 3106903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2427, 9556, 'BICAS CARTORIO DE REGISTRO DE IMOVEIS', 33159, 3106903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2428, 2394, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 44461, 3107000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2429, 9557, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48231, 3107109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2430, 9558, 'CARTORIO DE PROTESTOS ', 35014, 3107109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2431, 9559, 'SERVICO NOTARIAL DO 2º OFICIO', 58941, 3107109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2432, 9560, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39529, 3107109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2433, 9561, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE FREI EUSTAQUIO', 154294, 3107109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2434, 9562, 'CARTORIO DE REGISTRO DE IMOVEOS', 39255, 3107109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2435, 2395, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42259, 3107109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2436, 2396, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE BOCAINA DE MINAS', 53447, 3107208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2437, 2397, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE MIRANTAO', 36574, 3107208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2438, 2399, 'CARTORIO DE REGISTRO CIVIL', 35238, 3107307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2439, 9563, 'BOCAIUVA - CARTORIO DO REGISTRO DE IMOVEIS', 33167, 3107307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2440, 2398, 'BOCAIUVA CARTORIO DO REGISTRO CIVIL ', 46011, 3107307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2441, 4898, 'RCPN DO 1º DISTRITO DE BARRA DO PIRAI', 92783, 3300308, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2442, 13889, 'CARTORIO DO DISTRIBUIDOR, CONTADOR E PARTIDOR', 90878, 3300308, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2443, 13890, 'SERVICO NOTARIAL E REGISTRAL DO 3° OFICIO DE BARRA MANSA', 93575, 3300407, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2444, 13891, 'CARTORIO DISTRIBUIDOR - CONTADOR - PARTIDOR - AVALIADOR', 89862, 3300407, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2445, 13892, '4º OFICIO DE BARRA MANSA - RJ', 89193, 3300407, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2446, 4899, 'SRCPN - 1º DISTRITO', 93625, 3300407, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2447, 13893, 'SERVICO NOTARIAL E REGISTRAL DO 2º OFICIO ', 90423, 3300407, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2448, 13894, 'SERVICO NOTARIAL E REGISTRAL DO 1º OFICIO DE BARRA MANSA', 93542, 3300407, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2449, 13895, 'DISTRIBUIDOR, CONTADOR E PARTIDORDA COMARCA DE BELFORD ROXO', 91975, 3300456, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2450, 4900, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO D. UNICO DE BELFORD ROXO', 93211, 3300456, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2451, 13896, '1º OFICIO DE JUSTICA DO MUNICIPIO DE BELFORD ROXO', 88856, 3300456, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2452, 6550, '3º OFICIO DE JUSTICA DE BELFORD ROXO', 89136, 3300456, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2453, 13897, 'CARTORIO DO 2º OFICIO DE JUSTICA DE BELFORD ROXO', 90506, 3300456, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2454, 13898, 'CARTORIO DO 1O OFICIO DE JUSTICA DE BOM JARDIM', 90126, 3300506, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2455, 4473, 'RCPN DO 1º DISTRITO DA COMARCA DE BOM JARDIM', 92767, 3300506, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2456, 13899, 'CARTORIO DO DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE BOM JARDIM', 90910, 3300506, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2457, 13900, 'CARTORIO DO 2º OFICIO DE NOTAS E REGISTROS PUBLICOS', 89045, 3300506, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2458, 4474, 'CARTORIO DO 2º OFICIO DE JUSTICA', 90472, 3300605, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2459, 13901, 'DISTRIBUIDOR, CONTADOR E PARTIDOR', 91793, 3300605, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2460, 4902, '1º OFICIO DE JUSTICA DE BOM JESUS DO ITABAPOANA', 88799, 3300605, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2461, 4901, 'CARTORIO DO RCPN E TABELIONADO DE NOTAS DE PIRAPETINGA 5º DISTRITO DE BOM JESUS DO ITABAPOANA-RJ', 91272, 3300605, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2462, 13902, 'CARTORIO DO 1º OFICIO DE JUSTICA DE CABO FRIO', 90290, 3300704, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2936, 13799, 'TABELIONATO EWALD', 103853, 4301305, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2463, 13903, 'CARTORIO DISTRIBUIDOR, CONTADOR E PARTIDOR', 89912, 3300704, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2464, 4903, 'CABO FRIO CARTORIO 2º DISTRITO', 89441, 3300704, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2465, 13904, '2º SERVICO NOTARIAL E REGISTRAL DE CABO FRIO', 89060, 3300704, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2466, 4904, 'RCPN 1º DISTRITO DE CABO FRIO', 92544, 3300704, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2467, 13905, '1º OFICIO DE JUSTICA', 88732, 3300803, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2468, 13906, 'DISTRIBUIDOR CONTADOR E PARTIDOR', 91660, 3300803, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2469, 13907, 'CARTORIO DO 2º OFICIO', 90415, 3300803, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2470, 4905, 'RCPN E NOTAS DO 2º DISTRITO DE CACHOEIRAS DE MACACU', 92981, 3300803, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2471, 4475, 'RCPN DO 1º DISTRITO DE CACHOEIRAS DE MACACU', 92791, 3300803, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2472, 4476, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO 1º DISTRITO DE CAMBUCI-RJ', 91363, 3300902, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2473, 13908, 'OFICIO UNICO DO MUNICIPIO DE CAMBUCI', 154583, 3300902, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2474, 5033, 'CARTORIO RCPN 1° DISTRITO DE TERESOPOLIS/RJ', 91546, 3305802, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2475, 5032, 'SERVICO NOTARIAL E REGISTRO CIVIL DO 3º DISTRITO', 93500, 3305802, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2476, 13909, 'CARTORIO 3 OFICIO DE JUSTICA DE TERESOPOLIS', 89631, 3305802, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2477, 13910, 'CARTORIO DO 1º OFICIO DE JUSTICA DA COMARCA DE TERESOPOLIS-RJ', 90282, 3305802, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2478, 13911, 'DISTRIBUIDOR CONTADOR E PARTIDOR DE TERESOPOLIS', 91694, 3305802, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2479, 5034, 'CARTORIO DO 2º DISTRITO DE TERESOPOLIS', 90399, 3305802, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2480, 13912, '2º OFICIO DE JUSTICA DE TERESOPOLIS', 89029, 3305802, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2481, 5035, 'CARTORIO DE OFICIO UNICO', 89771, 3305901, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2482, 13913, 'DISTRIBUIDOR, CONTADOR E PARTIDOR DE TRAJANO DE MORAES', 91967, 3305901, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2483, 6577, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO 1º DISTRITO DE TRES RIOS - RJ', 91470, 3306008, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2484, 13914, 'CARTORIO DO 1º OFICIO ', 90225, 3306008, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2485, 13915, 'CARTORIO 3º OFICIO DE JUSTICA', 89664, 3306008, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2486, 5036, 'CARTORIO DO REGISTRO CIVIL', 91314, 3306107, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2487, 13916, 'CARTORIO DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE TRES RIOS - RJ', 90019, 3306008, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2488, 13917, 'TRES RIOS CARTORIO DO 2º OFICIO', 93716, 3306008, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2489, 13918, 'CARTORIO DO 3° OFICIO DE VALENCA', 90597, 3306107, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2490, 13919, 'CARTORIO DO PRIMEIRO OFICIO', 91116, 3306107, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2491, 4700, 'RCPN DO 2º DISTRITO DE VALENCA', 91330, 3306107, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2492, 13920, 'CARTORIO DO SEGUNDO OFICIO', 91496, 3306107, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2493, 13921, 'DISTRIBUIDOR, CONTADOR E PARTIDOR', 91744, 3306107, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2494, 5037, 'CARTORIO OFICIO UNICO DE VARRE-SAI/RJ', 89821, 3306156, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2495, 13922, 'CARTORIO DO 2º OFICIO DE NOTAS E RGI DE VASSOURAS-RJ', 90696, 3306206, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2496, 13923, 'DISTRIBUIDOR, CONTADOR E PARTIDOR JUDICIAL', 89433, 3306206, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2497, 5038, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 1º DISTRITO DA COMARCA DE VASSOURAS', 93187, 3306206, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2498, 13924, '1°OFICIO', 89185, 3306206, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2499, 13925, 'CARTORIO DO 2 OFICIO DE JUSTICA DE VOLTA REDONDA', 90365, 3306305, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2500, 5039, 'RCPN 2ª CIRCUNSCRICAO 1° DIST.VOLTA REDONDA', 92601, 3306305, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2501, 13926, 'CARTORIO DO DISTRIBUIDOR, CONTADOR E PARTIDOR', 90852, 3306305, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2502, 13927, 'SERVICO NOTARIAL E REGISTRAL DO 1º OFICIO DE VOLTA REDONDA', 93559, 3306305, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2503, 5040, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DA 1ª CIRCUNSCRICAO DE VOLTA REDONDA', 93120, 3306305, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2504, 5041, 'CARTORIO UNICO DE NOTAS E REGISTROS DA COMARCA DE ACAR-RN', 94441, 2400109, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2505, 5042, 'ACU CARTORIO 2 OFICIO DE NOTAS', 94003, 2400208, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2506, 13928, '3º OFICIO DE NOTAS', 93963, 2400208, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2507, 13929, '1º OFICIO SERVICOS NOTARIAL E REGISTRAL IMOBILIARIO', 93823, 2400208, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2508, 6578, 'CARTORIO UNICO EXTRAJUDICIARIO ', 94599, 2400307, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2509, 5043, 'CARTORIO UNICO DE AGUA NOVA', 94292, 2400406, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2510, 13930, 'TABELIONATO DE NOTAS E PROTESTO', 103358, 4302709, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2511, 13931, 'TABELIONATO CACAPAVA ', 102509, 4302808, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2512, 4512, 'OFICIO NOTARIAL E REGISTRAL DO 4° DISTRITO DE CACAPAVA DO SUL', 100719, 4302808, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2513, 4511, 'REGISTRO CIVIL DAS PESSOAS NATURAIS, REGISTROS ESPECIAIS E REGISTRO DE IMOVEIS', 99093, 4302808, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2514, 13932, 'TABELIONATO DE NOTAS', 102822, 4302907, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2515, 7109, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 98970, 4302907, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2516, 13933, 'REGISTRO DE IMOVEIS', 99168, 4302907, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2517, 5211, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE CACHOEIRA DO SUL', 99028, 4303004, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2518, 13934, 'PRIMEIRO TABELIONATO DE NOTAS', 98806, 4303004, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2519, 13935, 'OFICIO DE REGISTRO DE IMOVEIS', 97733, 4303004, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2520, 13936, 'OFICIO DO REGISTRO DE TITUILOS E DOCUMENTOS E PROTESTO', 98244, 4303004, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2521, 13937, '2º TABELIONATO', 96834, 4303004, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2522, 5212, 'SERVICO DE REGISTROS PUBLICOS DE CACHOEIRINHA', 100131, 4303103, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2523, 13938, 'TABELIONATO DE NOTAS', 102830, 4303103, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2524, 13939, 'TABELIONATO DE NOTAS', 102715, 4303202, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2525, 5213, 'OFICIO DE REGISTROS PUBLICOS', 97899, 4303202, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2526, 13940, 'TABELIONATO DE NOTAS DE CAIBATE', 102996, 4303301, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2527, 5214, 'SERVICO DOS REGISTROS PUBLICOS DE CAIBATE', 100339, 4303301, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2528, 4513, 'SERVICO NOTARIAL E REGISTRAL DE CAICARA - RS', 101204, 4303400, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2529, 13941, 'TABELIONATO DE NOTAS', 102897, 4303509, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2530, 13942, 'REGISTRO DE IMOVEIS', 99184, 4303509, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2531, 4514, 'REG.CIVIL DAS PESSOAS NATURAIS E JURIDICAS,TITULOS E DOC. E TAB. DE PROTESTO - EXTINTO REG. CIVIL DE ARAMBARE E BONITO. CAPELA VELHA DESATIVADA TEMPORARI E EXTINTO REG. CIVIL DE SAO BRAZ E SANTA AUTA ', 98905, 4303509, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2532, 6704, 'REGISTRO CIVIL, TABELIONATO E ESPECIAIS', 99143, 4303558, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2533, 4515, 'SERVICO NOTARIAL E DE REGISTROS DE CAMBARA DO SUL', 100933, 4303608, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2534, 4516, 'OFICIO DE REGISTROS PUBLICOS', 97907, 4303707, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2535, 13943, 'TABELIONATO DE NOTAS', 102566, 4303707, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2536, 4517, 'SERVICO DE REGISTROS PUBLICOS DE CAMPINAS DO SUL', 100149, 4303806, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2537, 13944, 'TABELIONATO DE NOTAS DE CAMPINAS DO SUL', 103002, 4303806, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2538, 13945, 'CARTORIO DE GERISTRO DE IMOVEIS E ESPECIAIS', 97154, 4303905, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2539, 6705, 'CAMPO BOM - CARTORIO DO TABELIONATO E REGISTRO CIVIL', 97105, 4303905, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2540, 13946, 'TABELIONATO DE NOTAS DE CAMPO NOVO', 102608, 4304002, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2541, 5216, 'SERVICO NOTARIAL E REGISTRAL CIVIL', 101139, 4304101, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2542, 5217, 'SERVICOS DE REGISTROS PUBLICOS', 101683, 4304200, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2543, 13947, 'TABELIONATO CANDELARIA', 102517, 4304200, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2544, 4518, 'SERVICO NOTARIAL E DE REGISTRO DE BOTUCARAI', 100628, 4304200, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2545, 5218, 'SERVICOS DE REGISTROS  PUBLICOS DE CANDIDO GODOI', 142372, 4304309, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2546, 13948, 'TABELIONATO DE NOTAS DE CANDIDO GODOI', 103010, 4304309, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2547, 6706, 'SERVICO NOTARIAL E REGISTRAL DE CANDIOTA ', 139642, 4304358, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2548, 4335, 'SERVICO DISTRITAL DE NOSSA SENHORA DAS GRACAS ', 145268, 4116406, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2937, 13800, 'TABELIONATO DADALT', 102558, 4301404, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2549, 4336, 'SERVICO DISTRITAL DE NOVA ALIANCA DO IVAI-PR. ', 129437, 4116505, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2550, 3756, 'SERVICO DISTRITAL DE NOVA AMERICA DA COLINA', 80986, 4116604, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2551, 4556, 'SERVICO DISTRITAL DE PALMITOPOLIS', 83998, 4116703, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2552, 4337, 'SERVICO DISTRITAL DE NOVA AURORA', 84301, 4116703, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2553, 4338, 'SERVICO DISTRITAL DE NOVA CANTU', 87189, 4116802, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2554, 4339, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81398, 4116901, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2555, 13949, 'TABELIONATO DE NOTAS, ACUMULANDO PRECARIAMENTE O TABELIONATO DE PROTESTO DE TITULOS', 87452, 4116901, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2556, 13950, 'SERVICO DE REGISTRO DE IMOVEIS', 84004, 4116901, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2557, 4557, 'SERVICO DISTRITAL DE NOVA ESPERANCA DO SUDOESTE', 81034, 4116950, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2558, 4558, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 87148, 4117008, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2559, 13951, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 84012, 4117008, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2560, 4340, 'SERVICO DISTRITAL DE NOVA LARANJEIRAS', 130005, 4117057, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2561, 13952, 'SERVICO DISTRITAL DE GUARANI', 86272, 4117057, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2562, 4559, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMANTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 130799, 4117107, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2563, 13953, 'SERVICO DE REGISTRO DE IMOVEIS', 85050, 4117107, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2564, 13954, 'TABELIONATO DE NOTAS ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 88187, 4117107, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2565, 4341, 'SERVICO DISTRITAL DE NOVA OLIMPIA', 84020, 4117206, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2566, 4560, 'SERVICO DISTRITAL DE NOVA PRATA DO IGUACU', 85431, 4117255, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2567, 4342, 'SERVICO DISTRITAL DE NOVA SANTA BARBARA', 81612, 4117214, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2568, 4343, 'SERVICO DISTRITAL DE NOVA SANTA ROSA', 84038, 4117222, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2569, 4344, 'SERVICO DISTRITAL DE NOVA TEBAS', 88302, 4117271, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2570, 4345, 'SERVICO DISTRITAL DE NOVO ITACOLOMI', 84046, 4117297, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2571, 4347, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS ACUMULANDO PRECARIAMENTE O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS ', 81430, 4117305, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2572, 13955, 'SERVICO DE REGISTRO DE IMOVEIS ', 81414, 4117305, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2573, 13956, 'TABELIONATO DE PROTESTO DE TITULOS', 129981, 4117305, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2574, 4346, 'SERVICO DISTRITAL DE NATINGUI', 86777, 4117305, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2575, 4348, 'SERVICO DISTRITAL DE BARREIRO', 82115, 4117305, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2576, 13957, 'SERVICO NOTARIAL DE ORTIGUEIRA', 82966, 4117305, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2577, 4349, 'SERVICO DISTRITAL DE OURIZONA', 130633, 4117404, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2578, 4350, 'SERVICO DISTRITAL DE OURO VERDE DO OESTE', 80994, 4117453, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2579, 4352, 'SERVICO DISTRITAL DE PAICANDU', 130161, 4117503, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2580, 4351, 'SERVICO DISTRITAL DE AGUA BOA', 141713, 4117503, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2581, 13958, 'SERVICO DE REGISTRO DE IMOVEIS', 85019, 4117602, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2582, 4354, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 145839, 4117602, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2583, 13959, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E 2° TAB. DE NOTAS', 128074, 1713304, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2584, 6837, 'SERVENTIAL REGISTRAL DE PESSOAS NATURAIS', 129262, 1713304, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2585, 5215, 'REGISTROS PUBLICOS', 99473, 4304002, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2586, 13960, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1° DE NOTAS', 127720, 1713601, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2587, 6838, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 128504, 1713601, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2588, 13961, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS', 154450, 1713700, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2589, 6839, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS DE MONTE SANTO', 128629, 1713700, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2590, 6841, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE CHAPADA DE NATIVIDADE, TOCANTINS', 126896, 1714203, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2591, 6840, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE NATIVIDADE - TO', 126938, 1714203, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2592, 13962, 'SERVENTIA DE REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 128249, 1714203, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2593, 13963, 'SERVENTIA DE REGISTRO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO 2º DE NOTAS', 129239, 1714203, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2594, 13964, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO DE NOTAS', 127795, 1714302, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2595, 6842, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 126797, 1714302, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2596, 6843, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 128587, 1714880, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2597, 13965, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS', 127563, 1714880, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2598, 13966, 'CARTORIO 1º OFICIO E ANEXO', 126565, 1715002, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2599, 7173, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 128595, 1715002, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2600, 6844, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE NOVO ACORDO-TO.', 127381, 1715101, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2601, 13967, 'CARTORIO DE PESSOAS JURIDICAS TITULOS, DOCUMENTOS,PROTESTOS E TABELIONATO 2º DE NOTAS DE NOVO ACORDO-TO', 126631, 1715101, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2602, 13968, 'CARTORIO DE REGISTRO DE IMOVEIS E 1º TABELIONATO DE NOTAS DE NOVO ACORDO-TO', 127654, 1715101, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2603, 6845, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127340, 1715150, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2604, 13969, 'CARTORIO DO 1º OFICIO REG. DE IMOVEIS E ANEXOS', 128348, 1715150, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2605, 6847, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 139105, 1715259, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2606, 6846, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, DOCUMENTOS, PROTESTOS, TABELIONATO DE NOTAS E CIVIL.', 127829, 1715259, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2607, 6850, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 126987, 1721000, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2608, 13970, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS E TABELIONATO DE PROTESTOS DA COMARCA DE PALMAS-TO', 127035, 1721000, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2609, 6849, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS', 127456, 1721000, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2610, 6848, 'CARTORIO DE REGISTRO CIVIL', 126706, 1721000, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2611, 13971, '1º TABELIONATO DE NOTAS', 126433, 1721000, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2612, 13972, 'CARTORIO DE REGISTRO DE IMOVEIS DA COMARCA DE PALMAS-TO', 127613, 1721000, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2613, 13973, '2. TABELIONATO DE NOTAS DE PALMAS', 126466, 1721000, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2614, 13974, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS', 154476, 1715705, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2615, 6851, 'CARTORIO DO REGISTRO CIVIL', 128413, 1715705, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2616, 6413, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 126854, 1713809, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2617, 13975, '21° TABELIAO DE NOTAS DA COMARCA DE SAO PAULO - CAPITAL', 112292, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2618, 6317, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 10º SUBDISTRITO - BELENZINHO, SAO PAULO/CAPITAL', 115139, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2619, 6282, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE ITAQUERA', 118026, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2620, 13976, '9º TABELIAO DE NOTAS DA CAPITAL', 113787, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2621, 6266, 'OFICIAL DE REGISTRO CIVIL DO 8º SUBDISTRITO SANTANA', 119149, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2622, 13977, '3º OFICIAL DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 113183, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2623, 13978, '15º. OFICIAL DE REGISTRO DE IMOVEIS DE SAO PAULO', 111252, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2624, 6267, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS 21. SUBDISTRITO -SAUDE', 115055, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2625, 6288, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 46º SUBDISTRITO DE VILA FORMOSA-CAPITAL', 115329, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2626, 6275, '38º OFICIAL DE REGISTRO CIIVL VILA MATILDE', 113233, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2627, 6694, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 25º SUBDISTRITO PARI - SP', 122739, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2628, 13979, '1º OFICIAL DE REGISTRO DE IMOVEIS DE SAO PAULO - SP', 111450, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2629, 13980, '2º TABELIAO DE NOTAS DE SAO PAULO', 112722, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2630, 6319, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA SEDE DE SAO PEDRO', 115097, 3550407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2631, 13981, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120097, 3550407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2632, 13982, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124743, 3550407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2633, 6320, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117507, 3550506, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2634, 6321, 'CARTORIO DE REGISTRO CIVIL SEDE DA COMARCA DE SAO ROQUE, SP', 114355, 3550605, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2635, 13983, '1° TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS', 111062, 3550605, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2636, 13984, '2 TABELIONATO DE NOTAS E PROTESTOS DE SAO ROQUE', 112276, 3550605, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2637, 6322, 'SAO ROQUE CARTORIO DO REGISTRO CIVIL E TABELIONATO', 123752, 3550605, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2638, 13985, 'OFICIAL DO REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E TABELIAO DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE SAO ROQUE', 122002, 3550605, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2639, 13986, 'TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS', 125583, 3550704, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2640, 6323, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS  DA SEDE DA COMARCA DE SAO SEBASTIAO', 115576, 3550704, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2641, 13987, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 119958, 3550704, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2642, 6324, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE MARESIAS, DA COMARCA DE SAO SEBASTIAO', 117101, 3550704, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2643, 6325, 'SERVICO NOTORIAL E REGISTRAL CIVIL', 124503, 3550803, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2644, 6326, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE SAO SIMAO', 116335, 3550902, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2645, 13988, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E DE PROTESTOS', 119982, 3550902, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2646, 13989, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125658, 3550902, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2647, 13990, '2 TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 112250, 3551009, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2648, 13991, '3.º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE SAO VICENTE, DO ESTADO DE SAO PAULO', 113191, 3551009, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2649, 13992, '1º TABELIONATO DE NOTAS E PROTESTO DE SAO VICENTE', 112201, 3551009, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2650, 13993, 'REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS ETABELIONATO DE NOTAS DE PALMEIRAS DO TOCANTINS', 129197, 1713809, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2651, 6414, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127191, 1715754, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2652, 13994, 'CARTORIO DE REGISTRO DE  PESSOAS  JURIDICAS  TITT.  DOC. PROTESTO  2º TABELIONATO DE  NOTAS', 127522, 1715754, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2653, 13995, 'CARTORIO REGISTRO DE IMOVEIS TABELIONATO 1º DE NOTAS', 128876, 1715754, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2654, 13996, 'CARTORIO DO 1º OFICIO, NOTAS E REGISTRO DE IMOVEIS', 128355, 1716109, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2655, 6415, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE PARAISO DO TOCANTINS', 126946, 1716109, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2656, 13997, 'SERVENTIA DE REGISTRO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO 2º DE NOTAS DE PARAISO DO TOCANTINS', 128090, 1716109, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2657, 13998, 'CARTORIO DE REGISTRODE IMOVEIS E TABELIONATO 1º DE NOTAS', 128173, 1716208, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2658, 13999, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E TABELIONATO 2º DE NOTAS', 128066, 1716208, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2659, 2430, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL', 42515, 3108909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2660, 2432, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE BRAUNAS', 43885, 3108800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2661, 2433, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PIEDADE DO PARAOPEBA', 44099, 3109006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2662, 9690, '2º OFICIO DE NOTAS DE BRUMADINHO', 32557, 3109006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2663, 9691, 'OFICIO DO REGISTRO DE IMOVEIS DA COMARCA DE BRUMADINHO', 39057, 3109006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2664, 9692, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE BRUMADINHO', 60442, 3109006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2665, 6886, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SAO JOSE DO PARAOPEBA', 37580, 3109006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2666, 9693, 'OFICIO DO 1º TABELIONATO DE NOTAS', 44065, 3109006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2667, 2435, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE ARANHA', 37309, 3109006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2668, 2434, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CONCEICAO DE ITAGUA', 43992, 3109006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2669, 2436, 'CARTORIO REGISTRO CIVIL  PESSOAS NATURAIS DE BRUMADINHO ', 44321, 3109006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2670, 9694, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE BRUMADINHO', 39701, 3109006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2671, 9695, 'PRIMEIRO SERVICO NOTARIAL', 55327, 3109105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2672, 2437, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56903, 3109105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2673, 9696, 'CARTORIO DO REGISTRO TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 43703, 3109105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2674, 9697, 'REGISTRO DE IMOVEIS', 57018, 3109105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2675, 9698, '2° SERVICO NOTARIAL - CARTORIO BRUNO', 41145, 3109105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2676, 9699, 'TABELIONATO DE PROTESTO', 60061, 3109105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2677, 9700, 'CARTORIO 1º OFICIO DE NOTAS', 33506, 3109204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2678, 2438, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52548, 3109204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2679, 9701, 'PROTESTO DE TITULOS', 55541, 3109204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2680, 9702, 'SERVICO DE REGISTRO DE IMOVEIS', 58552, 3109204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2681, 9703, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS  CIVIL DAS PESSOAS JURIDICAS', 54221, 3109204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2682, 2439, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42192, 3109204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2683, 9704, 'OFICIO DO 2O TABELIONATO DE NOTAS', 49171, 3109204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2684, 2440, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 37044, 3109253, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2685, 2442, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 58388, 3109303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2686, 9705, 'PRIMEIRO TABELIONATO DE PROTESTO DE TITULOS ', 55442, 3109303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2687, 9706, 'OFICIO DO 1º TABELIONATO DE NOTAS DE BURITIS', 40832, 3109303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2688, 2441, 'CARTORIO DE PAZ, NOTAS E DO REGISTRO CIVIL', 34710, 3109303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2689, 9707, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE BURITIS', 47514, 3109303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2690, 9708, 'OFICIO DO REGISTRO DE IMOVEIS', 53991, 3109303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2691, 9709, 'CARTORIO DO 2º OFICIO DE NOTAS DE BURITIS-MG', 58081, 3109303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2692, 2444, 'CARTORIO DE PAZ E REGISTRO CIVIL ', 34512, 3109402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2693, 2443, 'TABELIONATO DE REGISTRO CIVIL E NOTAS', 61028, 3109402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2694, 6636, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50559, 3109402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2695, 2445, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52019, 3109451, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2696, 9710, 'CARTORIO DE TITULOS E DOCUMENTOS', 40170, 3109501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2697, 9711, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48645, 3109501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2698, 9712, 'REGISTRO DE IMOVEIS', 57125, 3109501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2699, 9713, 'OFICIO DO 1º TABELIONATO DE NOTAS DE CABO VERDE', 32169, 3109501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2700, 2447, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51615, 3109501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2701, 9714, '2º SERVICO NOTARIAL', 32599, 3109501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2702, 2446, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50898, 3109501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2703, 2448, 'CACHOEIRA DA PRATA-CARTORIO DE PAZ REG CIVIL E NOTAS', 33233, 3109600, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2704, 9715, 'CARTORIO DO 2º TABELIONATO DE NOTAS', 41582, 3109709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2705, 9716, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54502, 3109709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2706, 6637, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52373, 3109709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2707, 9717, 'OFICIO DO PRIMEIRO TABELIONATO DE NOTAS', 50112, 3109709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2708, 9718, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE CACHOEIRA DE MINAS', 50179, 3109709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2709, 9719, 'CACHOEIRA DE MINAS SERVICO REGISTRAL IMOBILIARIO', 33241, 3109709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2710, 2449, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50880, 3109709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2711, 2450, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE CACHOEIRA DO PAJEU', 47134, 3102704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2712, 2451, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 42697, 3109808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2713, 2452, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 42721, 3109907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2714, 9720, 'CART.REG.TIT.DOCUMENTOS E PES.JURIDICAS', 33399, 3110004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2715, 9721, 'OFICIO DO 3º TABELIONATO DE NOTAS', 49957, 3113305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2716, 2505, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DO DISTRITO DE DOM LARA', 36202, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2717, 9722, 'TABELIONATO DE PROTESTOS DE TITULOS  E DOCUMENTOS   DE DIVIDAS       DE DIVIDAS', 60913, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2718, 2508, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SAO CANDIDO', 37663, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2719, 2509, 'CARTORIO DE SANTA LUZIA DE CARATINGA', 53041, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2720, 9723, 'TERCEIRO TABELIONATO DE NOTAS DE CARATINGA-MG', 61408, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2721, 2502, 'CARTORIO DE REGISTRO CIVIL COM ATRIBUICAO DE NOTAS DO DISTRITO DE DOM MODESTO', 37374, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2722, 2506, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE CARATINGA', 35907, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2723, 9724, 'CARTORIO DO SEGUNDO OFICIO DE NOTAS', 43810, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2724, 2501, 'CARTORIO DE REGISTRO CIVIL E NOTAS DO DISTRITO DE SAPUCAIA, MUNICIPIO DE CARATINGA', 38331, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2725, 9725, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 44149, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2726, 2503, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CORDEIRO DE MINAS', 43901, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2727, 9726, 'CARTORIO DO PRIMEIRO OFICIO DE NOTAS', 41871, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2728, 2507, 'CARTORIO DE PAZ E NOTAS DIOGO PIRES', 34421, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2729, 9727, 'CARTORIO DE REGISTRO DE IMOVEIS DE CARATINGA', 39065, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2730, 9373, 'CARTORIO DE REGISTRO DE IMOVEIS E 1° TABELIONATO DE NOTAS DA COMARCA DE PETROLINA DE GOIAS-GO', 26096, 5216809, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2731, 9374, 'TABELIONATO DE NOTAS, DE PROTESTO DE TITULOS, TABELIONATO E OFICIALATO DE REGISTRO DE CONTRATOS MARITIMOS', 145714, 5216809, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2732, 1718, 'CARTORIO DE SERVICO DE NOTAS, PROTESTO DE TITULOS, TABELIONATO E REGISTRO DE CONTRATOS MARITIMOS, DE REGISTRO DE IMOVEIS, DE REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS P', 26674, 5216908, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2733, 9375, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO 2º DE NOTAS', 28613, 5217104, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2734, 7525, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 25460, 5217104, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2735, 9376, 'CARTORIO DE RAGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 25304, 5217104, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2736, 9377, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS PESSOAS JURIDICAS, TITUTLOS, DOCUMENTOS E PROTESTOS', 27086, 5217203, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2737, 9378, 'PRIMEIRO SERVICO NOTARIAL E REGISTRAL', 27946, 5217203, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2738, 13694, '1 OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS', 88526, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2739, 13695, 'CARTORIO DO 3º OFICIO DE NOTAS DA CAPITAL', 90688, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2740, 13696, '19 SERVICO NOTARIAL', 88690, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2741, 4992, 'SERVICO NOTARIAL E REGISTRAL DA 13ª CIRCUNSCRICAO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DA CAPITAL', 93534, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2742, 13697, 'TERCEIRO OFICIO DO REGISTRO DE DISTRIBUICAO', 93708, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2743, 13698, '12º OFICIO DE NOTAS', 88591, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2744, 13699, '10º SERVICO NOTARIAL', 88559, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2745, 6571, 'RIO DE JANEIRO CART 12A CIRC REG CIVIL COMARCA CAPITAL', 93336, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2746, 13700, '11º OFICIO DO REGISTRO DE IMOVEIS', 88583, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2747, 13701, '17O.OFICIO DE NOTAS  DA COMARCA DA CAPITAL', 88674, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2748, 13702, 'TABELIONATO DO 2º OFICIO DE PROTESTO DE TITULOS DA CAPITAL-RJ', 93658, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2749, 13703, '3º OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS', 89169, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2750, 13704, 'RIO DE JANEIRO CARTORIO DO 2º OFICIO DO REGISTRO DE INTERDICOES E TUTELAS', 93369, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2751, 13705, 'TABELIONATO DO 4º OFICIO DE PROTESTO DE TITULOS', 93674, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2752, 4698, '1º RCPN DA CAPITAL - RJ', 88708, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2753, 13706, '3º OFICIO DE REGISTRO DE IMOVEIS', 89151, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2754, 4996, '11ª CIRCUNSCRICAO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO ', 88567, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2755, 13707, '5º OFICIO DO REGISTRO DE DISTRIBUICAO', 89284, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2756, 13708, 'TABELIONATO DO 3º OFICIO DE PROTESTO DE TITULOS', 93666, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2757, 4997, '7º REGISTRO CIVIL DE PESSOAS NATURAIS E NOTAS', 89342, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2758, 13709, '8º OFICIO DE NOTAS', 89391, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2759, 13710, 'RJ-CARTORIO DO 7º OFICIO DE REGISTRO DE IMOVEIS', 93385, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2760, 13711, 'SERVICO REGISTRAL 6º OFICIO DO REGISTRO DE DISTRIBUICAO', 93609, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2761, 13712, '2O OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS', 88955, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2762, 13713, '10º OFICIO DO REGISTRO DE IMOVEIS', 88542, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2763, 5004, 'RCPN 1º DISTRITO', 92502, 3304607, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2764, 5168, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DO DISTRITO DE JACI PARANA', 96198, 1100205, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2765, 13714, 'TABELIONATO FACHIN - 3º TABELIONATO DE PROTESTO DE TITULOS E DOCUMENTOS', 96495, 1100205, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2766, 5167, '3º OFICIO DE REGISTRO CIVIS DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 95703, 1100205, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2767, 13715, '4º TABELIONATO DE PROTESTO DE TITULOS', 95711, 1100205, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2768, 6613, 'CARTORIO DO 4º OFICIO DE NOTAS E REGISTRO CIVIL', 96040, 1100205, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2769, 5170, 'CARTORIO DE REGISTRO DE IMOVEIS E CIVIL DAS PESSOAS NATURAIS', 96099, 1100254, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2770, 13716, 'CARTORIO ARRUDA', 95737, 1100254, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2771, 5171, 'TABELIONATO DE REGISTRO CIVIL E NOTAS DE RIO CRESPO', 96479, 1100262, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2772, 5172, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 95851, 1100288, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2773, 5173, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 95802, 1100288, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2774, 13717, 'TABELIONATO DE PROTESTO DE TITULOS', 96438, 1100288, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2775, 13718, 'SERVICO NOTARIAL DA CIDADE E COMARCA DE ROLIM DE MOURA-RO', 96305, 1100288, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2776, 13719, 'SERVICO REGISTRAL DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 96347, 1100288, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2777, 5174, 'CARTORIO ARRUDA', 95745, 1100296, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2778, 5175, 'SERVENTIA DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 96107, 1101484, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2779, 7228, 'OFICIO DE REGISTRO CIVIL E NOTAS', 152579, 1101492, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2780, 5176, 'REGISTRO CIVIL DAS PESSOAS NATURAIS, NOTAS E ANEXOS', 96180, 1100320, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2781, 6614, 'OFICIO DE REGISTRO CIVIL E NOTAS', 130385, 1101500, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2782, 5177, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE NOTAS DO MUNICIPIO DE TEIXEIROPOLIS', 130344, 1101559, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2783, 5178, 'CARTORO DE REGISTRO CIVIL E NOTAS DE THEOBROMA RO', 96388, 1101609, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2784, 4497, 'CARTORIO DE REGISTRO CIVIL E NOTAS URUPA', 95935, 1101708, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2785, 4498, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 95927, 1101807, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2786, 13720, 'TABELIONATO DE PROTESTO DE TITULOS', 96446, 1100304, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2787, 4499, 'CARTORIO UNICO DE NOTAS E ANEXOS', 96503, 1100304, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2788, 13721, 'REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 96230, 1100304, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2789, 5179, 'CARTORIO DO 2 OFICIO - CISCUNSC JUDICIARIA DE RORAIMA', 96511, 1400100, 'RR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2790, 4500, 'TABELIONATO DEUSDETE COELHO - 1º OFICIO', 96578, 1400100, 'RR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2791, 13722, 'SERVENTIA DO REGISTRO DE IMOVEIS DA COMARCA DE BOA VISTA-RR', 96552, 1400100, 'RR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2792, 5180, 'CARTORIO OFICIO UNICO - EXTRAJUDICIAL', 96545, 1400209, 'RR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2793, 5181, 'TABELIONATO BARBOSA - OFICIO UNICO', 96560, 1400308, 'RR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2794, 5182, 'CARTORIO OFICIO UNICO', 96537, 1400472, 'RR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2795, 5183, 'CARTORIO FELIX', 96529, 1400605, 'RR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2796, 4501, 'SERVICO NOTARIAL E REGISTRAL DE ACEGUA', 101162, 4300034, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2797, 6615, 'SERVICO NOTARIAL E REGISTRAL DE AGUA SANTA', 101170, 4300059, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2798, 4502, 'SERVICO DE REGISTROS PUBLICOS', 100123, 4300109, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2799, 13723, 'SERVICO DISTRITAL DE GUARAVERA (12º TABELIONATO DE NOTAS - SUB-JUDICE ADI-3517)', 79780, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2800, 4541, '2º SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E 7º TABELIONATO DE NOTAS', 80614, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2801, 13724, '3º SERVICO DE REGISTRO DE IMOVEIS', 82941, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2802, 13725, 'SERVICO DISTRITAL DE WARTA (OBS. 8º TABELIONATO DE NOTAS - SUB-JUDICE ADI-3517)', 80630, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2803, 13726, 'SERVICO DISTRITAL DE MARAVILHA (OBS.: 9º TABELIONATO DE NOTAS - SUB-JUDICE ADI-3517)', 83964, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2804, 4297, '1º SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E 6º TABELIONATO DE NOTAS', 79889, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2805, 13727, '1.º TABELIONATO DE PROTESTO DE TITULOS', 79756, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2806, 13728, '1º SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 79830, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2807, 13729, '10º TABELIONATO DE NOTAS', 79764, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2808, 13730, '5º TABELIONATO DE NOTAS', 80564, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2809, 13731, '14º TABELIONATO DE NOTAS DE LONDRINA-PR', 82248, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2810, 13732, '2º SERVICO DE REGISTRO DE IMOVEIS', 80085, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2811, 13733, 'SERVICO DISTRITAL DE PAIQUERE (OBS: 11º TABELIONATO DE NOTAS - SUB-JUDICE ADI-3517)', 129525, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2812, 13734, '2. TABELIONATO DE PROTESTO DE TITULOS ', 80093, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2813, 13735, '4º TABELIONATO DE NOTAS', 83733, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2814, 13736, '2º TABELIONATO DE NOTAS ', 80358, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2815, 13737, '3º TABELIONATO DE NOTAS', 80499, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2816, 13738, '2º SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 83741, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2817, 13739, '4º SERVICO DE REGISTRO DE IMOVEIS', 81950, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2818, 13740, '1º TABELIONATO DE NOTAS', 83758, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2819, 13741, 'SERVICO DISTRITAL DE SAO LUIZ (OBS.: 13º. TABELIONATO DE NOTAS - SUB-JUDICE ADI-3517)', 79798, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2820, 13742, '1º SERVICO DE REGISTRO DE IMOVEIS', 83766, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2821, 13743, '3º TABELIONATO DE PROTESTO DE TITULOS', 88344, 4113700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2822, 4542, 'SERVICO DISTRITAL DE LUIZIANA', 84285, 4113734, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2823, 4543, 'SERVICO DISTRITAL DE LUNARDELLI', 83774, 4113759, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2824, 4298, 'SERVICO DISTRITAL DE LUPIONOPOLIS', 87031, 4113809, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2825, 4300, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85704, 4113908, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2826, 4544, 'CARTORIO DE REGISTRO CIVIL E NOTAS DO DISTRITO DE RIO CLARO DO SUL', 81497, 4113908, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2827, 4299, 'SERVICO DISTRITAL DE DORIZON', 86645, 4113908, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2828, 13744, 'TABELIONATO DE NOTAS, ACUMULADO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 81117, 4113908, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2829, 13745, 'SERVICO DE REGISTRO DE IMOVEIS', 81919, 4114005, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2830, 13746, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87643, 4114005, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2831, 4301, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS ACUMULANDO PRECARIAMENTO O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 83782, 4114005, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2832, 6545, 'REGISTRO DE IMOVEIS ACUMULANDO PRECARIAMENTE REGISTRO CIVIL E TITULOS E DOCUMENTOS', 661, 4114104, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2833, 13747, 'TABELIONATO DE NOTAS, ACUMULADO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87437, 4114104, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2834, 13748, '1º TABELIONATO DE NOTAS ', 79855, 4127700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2835, 13749, '1º SERVICO DE  REGISTRO DE IMOVEIS', 88401, 4127700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2836, 4533, 'SERVICO DISTRITAL DE NOVO SARANDI', 84277, 4127700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2837, 13750, 'SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 82016, 4127700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2838, 13751, '2º SERVICO DE REGISTRO DE IMOVEIS', 80226, 4127700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2839, 13752, 'TABELIONATO DE NOTAS, ACUMULANDO PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87882, 4127809, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2840, 13753, 'SERVICO DE REGISTRO DE IMOVEIS', 81828, 4127809, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2841, 4459, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E  CIVIL DAS PESSOAS JURIDICAS', 84996, 4127809, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2842, 4535, 'SERVICO NOTARIAL E REGISTRADOR BOZZA DE LIMA', 86629, 4127858, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2843, 4536, 'SERVICO DISTRITAL DE MARQUES DE ABRANTES', 87593, 4127882, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2844, 4537, 'SERVICO DISTRITAL DE TUNAS DO PARANA', 129668, 4127882, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2845, 4461, 'SERVICO DISTRITAL DE TUNEIRAS DO OESTE-PR', 130500, 4127908, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2846, 3734, 'SERVICO DISTRITAL DE MARABA ', 83824, 4127908, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2847, 4538, 'DISTRITO JUDICIARIO DE TUPASSI', 88419, 4127957, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2848, 4462, 'SERVICO DISTRITAL DE TURVO', 88427, 4127965, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2849, 4463, 'REGISTRO DE IMOVEIS ACUMULANDO PRECARIAMENTE OS REGISTRO CIVIL DAS PESSOAS NATURAIS E REGISTRO DE TILULOS E DOCUMENTOS', 85175, 4128005, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2850, 13754, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE UBIRATA', 154005, 4128005, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2851, 13755, 'TABELIONATO DE NOTAS', 130229, 4128005, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2852, 4464, 'SERVICO DISTRITAL DE YOLANDA', 88435, 4128005, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2853, 13756, 'SEGUNDO TABELIONATO DE PROTESTO DE TITULOS ', 85597, 4128104, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2854, 4880, 'SERVICO DISTRITAL DE SERRA DOS DOURADOS ', 86819, 4128104, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2855, 4879, '1º SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS ', 79947, 4128104, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2856, 4465, 'SERVICO NOTARIAL E REGISTRO CIVIL DE SANTA ELISA', 86934, 4128104, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2857, 13757, '2º TABELIONATO DE NOTAS', 88450, 4128104, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2858, 13758, '2º.SERVICO DE REGISTRO DE IMOVEIS', 80416, 4128104, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2859, 13759, '1º TABELIONATO DE NOTAS', 88443, 4128104, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2860, 13760, '1º TABELIONATO DE PROTESTO DE TITULOS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 82008, 4128104, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2861, 4466, 'SERVICO DISTRITAL DE LOVAT', 86926, 4128104, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2862, 13761, '1º SERVICO DE REGISTRO DE IMOVEIS', 88476, 4128203, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2863, 13762, 'TABELIONATO DE PROTESTO DE TITULOS', 81265, 4128203, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2864, 4881, 'SERVICO DISTRITAL DE SAO CRISTOVAO', 82412, 4128203, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2865, 13763, '3º TABELIONATO DE NOTAS ', 80424, 4128203, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2866, 4467, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS,ACUMULANDO,PRECARIAMENTE,O SERVICO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84160, 4128203, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2867, 13764, '2º TABELIONATO DE NOTAS', 88468, 4128203, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2868, 13765, '2º SERVICO DE REGISTRO DE IMOVEIS ', 88484, 4128203, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2869, 13766, 'OFICIO UNICO DO MUNICIPIO DE SANTA MARIA MADALENA', 154542, 3304607, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2870, 5003, 'CARTORIO DO 4º DISTRITO', 91462, 3304607, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2871, 5001, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 3º DISTRITO DA COMARCA DE SANTA MARIA MADALENA', 146233, 3304607, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2872, 5002, 'RCPN E NOTAS DO 2° DISTRITO - TRIUNFO', 92973, 3304607, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2873, 13767, 'CARTORIO DO DISTRIBUIDOR, CONTADOR E PARTIDOR JUDICIAL DE SANTA MARIA MADALENA', 90993, 3304607, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2874, 13768, 'CARTORIO DO 3º OFICIO DE JUSTICA', 90613, 3304706, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2875, 13769, 'CARTORIO DO 2º. OFICIO DE JUSTICA', 90589, 3304706, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2876, 5005, 'RCPN - 1º DISTRITO SANTO ANTONIO DE PADUA', 92429, 3304706, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2877, 13770, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 5º DISTRITO DA COMARCA DE SANTO ANTONIO DE PADUA', 146142, 3304706, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2878, 13771, 'CARTORIO DO 1° OFICIO DE JUSTICA DE SANTO ANTONIO DE PADUA ', 90159, 3304706, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2879, 13772, 'CARTORIO DO DISTRIBUIDOR, CONTADOR E PARTIDOR', 90886, 3304706, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2880, 13773, 'OFICIO UNICO DO MUNICIPIO DE SAO FIDELIS', 154567, 3304805, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2881, 13774, 'DISTRIBUIDOR,CONTADOR E PARTIDOR DA COMARCA DE SAO FIDELIS', 92031, 3304805, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2882, 5006, 'OFICIO DO REGISTRO CIVIL, INTERDICOES E TUTELAS E TABELIONATO DO 1º DISTRITO', 92171, 3304805, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2883, 6572, 'RCPN3º DISTRITO DE SAO FIDELIS', 93104, 3304805, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2884, 5007, 'OFICIO UNICO DE SAO FRANCISCO DE ITABAPOANA', 92254, 3304755, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2885, 13775, 'CARTORIO DISTRIBUIDOR, CONTADOR E PARTIDOR', 89946, 3304755, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2886, 6573, 'RCPN DO 1º DISTRITO', 92759, 3304904, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2887, 13776, 'CARTORIO 3O. OFICIO DE JUSTICA', 89649, 3304904, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2888, 13777, 'SAO GONCALO CARTORIO DO 2° OFICIO REGISTRO E NOTAS', 93393, 3304904, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2889, 13778, 'CARTORIO DO 5 OFICIO DE JUSTICA DA COMARCA DE SAO GONCALO', 90746, 3304904, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2890, 13779, 'CARTORIO DO 1° OFICIO DE JUSTICA DE SAO GONCALO', 90167, 3304904, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2891, 5012, 'CARTORIO RCPN E NOTAS DO SEGUNDO DISTRITO DE SAO GONCALO', 91611, 3304904, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2892, 5011, 'SAO GONCALO RCPN E NOTAS DO 5 DISTRITO', 93419, 3304904, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2893, 13780, 'CARTORIO DO 6° OFICIO DE SAO GONCALO', 90779, 3304904, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2894, 5009, 'RCPN E TABELIONATO DO 3º DISTRITO DE SAO GONCALO', 93070, 3304904, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2895, 5010, 'CARTORIO DO RCPN E NOTAS DA 2ª CIRCUNSCRICAO DO 4º DISTRITO', 91223, 3304904, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2896, 13781, 'CARTORIO DISTRIBUIDOR CONTADOR E PARTIDOR', 89888, 3304904, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2897, 13782, 'SAO GONCALO CARTORIO DO 4º OFICIO DE JUSTICA', 93401, 3304904, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2898, 5008, 'RCPN DA 1A. CIRCUNSCRICAO DO 4O. DISTRITO DE SAO GONCALO', 92726, 3304904, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2899, 6574, 'RCPN E INTERDICAOES E TUTELAS DO 1º DISTRITO DE SAO JOAO DA BARRA', 92957, 3305000, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2900, 13783, 'CARTORIO DISTRIBUIDOR, CONTADOR E PARTIDOR DE SAO JOAO DA BARRA', 90035, 3305000, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2901, 5013, 'RCPN E TABELIONATO DE NOTAS DO 5° DISTRITO', 89680, 3305000, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2902, 5014, 'RCPN DO SEXTO DISTRITO DE SAO JOAO DA BARRA ', 92940, 3305000, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2903, 13784, 'OFICIO UNICO DO MUNICIPIO DE SAO JOAO DA BARRA', 93427, 3305000, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2904, 13785, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS - AGUDO/RS', 103374, 4300109, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2905, 4503, 'SERVICO DOS REGISTROS PUBLICOS DE AJURICABA', 100297, 4300208, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2906, 13786, 'TABELIONATO DE AJURICABA', 102574, 4300208, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2907, 5184, 'SERVICO REGISTRAL DE ALECRIM', 101519, 4300307, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2908, 13787, 'TABELIONATO DE NOTAS DE ALECRIM', 102921, 4300307, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2909, 13788, 'SEGUNDO TABELIONATO BLASKESI', 99655, 4300406, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2910, 13789, 'REGISTRO DE IMOVEIS DE ALEGRETE', 99275, 4300406, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2911, 5185, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E REGISTROS ESPECIAIS', 99853, 4300406, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2912, 13790, 'PRIMEIRO TABELIONATO SOUZA', 98863, 4300406, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2913, 5186, 'CARTORIO SALOMAO 2', 97121, 4300455, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2914, 5187, 'REGISTROS PUBLICOS', 99481, 4300505, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2915, 13791, 'TABELIONATO DE NOTAS DE ALPESTRE', 102939, 4300505, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2916, 4504, 'SERVICOS NOTARIAL E DE REGISTRO CIVIL', 102327, 4300554, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2917, 13792, 'TABELIONATO DE ALVORADA', 96586, 4300604, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2918, 4505, 'ALVORADA OFICIO DOS REGISTROS PUBLICOS', 97006, 4300604, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2919, 6616, 'SERVICOS NOTARIAIS E DE REGISTROS', 101972, 4300638, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2920, 5188, 'SERVICOS NOTARIAIS E DE REGISTROS DE AMETISTA DO SUL', 102020, 4300646, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2921, 5189, 'SERVICO NOTARIAL E DE REGISTRO DE ANDRE DA ROCHA', 100578, 4300661, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2922, 5190, 'SERVICOS NOTARIAIS E REGISTRAIS DE ANTA GORDA', 102269, 4300703, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2923, 5191, 'SERVICO REGISTRAL PUBLICO', 101600, 4300802, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2924, 13793, 'TABELIONATO DE NOTAS DE ANTONIO PRADO - RS', 102947, 4300802, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2925, 13794, 'TABELIONATO DE NOTAS E PROTESTOS DE ARAMBARE/RS', 103424, 4300851, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2926, 13795, 'REGISTRO DE IMOVEIS E ESPECIAIS DE ARATIBA', 99432, 4300901, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2927, 5192, 'REGISTRO CIVIL E TABELIONATO', 99119, 4300901, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2928, 6617, 'OFICIO DOS REGISTROS PUBLICOS', 98491, 4301008, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2929, 13796, 'TABELIONATO DE NOTAS E PROTESTOS DE TITULOS', 103465, 4301008, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2930, 4506, 'SERVICO NOTARIAL E DE REGISTRO DE ARROIO DO SAL', 100586, 4301057, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2931, 5193, 'OFICIO DOS REGISTROS PUBLICOS', 98368, 4301206, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2932, 13797, 'TABELIONATO DE NOTAS DE ARROIO DO TIGRE', 102954, 4301206, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2933, 13798, 'TABELIONATO DE NOTAS DE ARROIO DOS RATOS', 102962, 4301107, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2934, 5194, 'SERVICO DOS REGISTROS PUBLICOS DE ARROIO DOS RATOS', 100305, 4301107, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2935, 4507, 'OFICIO DOS REGISTROS PUBLICOS', 98558, 4301305, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2938, 5195, 'OFICIO DOS REGISTROS PUBLICOS', 98343, 4301404, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2939, 5196, 'CARTORIO DOS REGISTROS PUBLICOS', 97386, 4301503, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2940, 13801, 'TABELIONATO DE NOTAS', 102848, 4301503, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2941, 4508, 'SERVICOS NOTARIAIS E DE REGISTROS DE AUREA', 102038, 4301552, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2942, 13802, 'TERCEIRO TABELIONATO DE NOTAS DE BAGE', 104042, 4301602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2943, 4545, 'SERVICO DISTRITAL DE PULINOPOLIS', 83394, 4114104, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2944, 13803, 'SERVICO DE REGISTRO DE IMOVEIS', 85886, 4114203, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2945, 4546, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81059, 4114203, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2946, 13804, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87874, 4114203, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2947, 4303, 'SERVICO DISTRITAL DE MANDIRITUBA', 83790, 4114302, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2948, 4302, 'SERVICO DISTRITAL DE AREIA BRANCA DOS ASSIS', 143784, 4114302, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2949, 4547, 'SERVICO DISTRITAL DE MANFRINOPOLIS', 83808, 4114351, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2950, 13805, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE,O TABELIONATO DE PROTESTO DE TITULOS', 87569, 4114401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2951, 4548, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS ACUMULANDO PRECARIAMENTE O SERVICO DE REGISTRO  DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81737, 4114401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2952, 4304, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 85860, 4114500, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2953, 13806, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE O PROTESTO DE TITULOS', 83816, 4114500, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2954, 4305, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81729, 4114609, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2955, 13807, 'SERVICO DE REGISTRO DE IMOVEIS', 85183, 4114609, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2956, 13808, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTO, O TABELIONATO DE PROTESTO DE TITULOS', 87684, 4114609, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2957, 4549, 'SERVICO DISTRITAL DE PORTO MENDES', 87197, 4114609, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2958, 3748, 'SERVICO DISTRITAL DE MARIA HELENA', 144931, 4114708, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2959, 13809, '1 TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 79723, 4114807, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2960, 13810, 'SERVICO DE REGISTRO DE IMOVEIS', 83832, 4114807, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2961, 3749, 'SERVICO DISTRITAL DE AQUIDABAN', 129619, 4114807, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2962, 4306, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E 3º TABELIONATO DE NOTAS', 80523, 4114807, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2963, 13811, '2º. TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 80408, 4114807, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2964, 13812, 'SERVICO DE REGISTRO DE IMOVEIS', 145896, 4114906, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2965, 3750, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGITRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81323, 4114906, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2966, 4550, 'SERVICO DISTRITAL DE SANTO ANTONIO DO PALMITAL ', 141705, 4114906, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2967, 13813, 'TABELIONATO DE NOTAS', 131003, 4114906, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2968, 13814, 'TABELIONATO DE PROTESTO DE TITULOS', 87494, 4114906, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2969, 4551, 'SERVICO DISTRITAL DE MARILENA', 81604, 4115002, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2970, 4307, 'SERVICO DISTRITAL DE MARILUZ', 86686, 4115101, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2971, 4552, 'SERVICO DISTRITAL DE IGUATEMI', 86280, 4115200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2972, 13815, '2º SERVICO DE REGISTRO DE IMOVEIS', 85290, 4115200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2973, 13816, '2º TABELIONATO DE NOTAS', 83840, 4115200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2974, 4308, '2º SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O 6º TABELIONATO DE NOTAS', 80275, 4115200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2975, 13817, '3º SERVICO DE REGISTRO DE IMOVEIS', 80440, 4115200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2976, 13818, '1ºTABELIONATO DE NOTAS', 80077, 4128203, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2977, 4468, 'SERVICO DISTRITAL DE UNIFLOR', 85738, 4128302, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2978, 4882, 'SERVICO DISTRITAL DE CRUZEIRO DO NORTE ', 82859, 4128401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2979, 4883, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84780, 4128401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2980, 13819, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 81091, 4128401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2981, 13820, 'SERVICO DE REGISTRO DE IMOVEIS  ', 88500, 4128401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2982, 4884, 'SERVICO DISTRITAL DE VENTANIA', 82453, 4128534, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2983, 4885, 'SERVICO DISTRITAL DE VERA CRUZ DO OESTE', 86439, 4128559, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2984, 4886, 'SERVICO DISTRITAL DE VERE', 81620, 4128609, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2985, 4888, 'SERVICO DISTRITAL DE VIRMOND', 83717, 4128658, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2986, 4889, 'SERVICO DISTRITAL DE VITORINO', 83931, 4128708, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2987, 13821, 'SERVICO DE REGISTRO DE IMOVEIS ', 86124, 4128500, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2988, 13822, 'TABELIONATO DE NOTAS, ACUMULANDO PRECARIAMENTE, O TABELIONATO DE PROTESTOS DE TITULOS', 87916, 4128500, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2989, 4469, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85001, 4128500, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2990, 13823, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS.', 87528, 4128807, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2991, 13824, 'SERVICO DE REGISTRO DE IMOVEIS', 84244, 4128807, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2992, 4890, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81356, 4128807, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2993, 13825, '1º OFICIO DE JUSTICA DE ANGRA DOS REIS', 88781, 3300100, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2994, 13826, 'CARTORIO DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE ANGRA DOS REIS', 89961, 3300100, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2995, 4470, 'RCPN 4ºDISTRITO DE ANGRA DOS REIS', 92692, 3300100, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2996, 13827, '2º OFICIO DE JUSTICA DE ANGRA DOS REIS', 88963, 3300100, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2997, 4471, 'RCPN DO 1º DISTRITO DE ANGRA DOS REIS', 92775, 3300100, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2998, 4891, 'RCPN 2º DISTRITO DE ANGRA DOS REIS', 92643, 3300100, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (2999, 4892, 'RCPN DO 5º DISTRITO DE SANTO ANTONIO DE PADUA', 92908, 3300159, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3000, 13828, 'CARTORIO DO 2º OFICIO DE ARARUAMA - RJ', 90431, 3300209, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3001, 4894, 'OFICIO DO RCPN DO 1º DISTRITO E DE INTERDICOES E TUTELAS DE ARARUAMA', 92528, 3300209, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3002, 13829, 'DISTRIBUIDOR, CONTADOR, PARTIDOR', 91983, 3300209, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3003, 4893, 'CARTORIO DE RCPN E TABELIONATO DO 3º DISTRITO DE ARARUAMA', 89847, 3300209, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3004, 13830, 'CARTORIO DO 1° OFICIO DE ARARUAMA', 90134, 3300209, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3005, 4895, 'OFICIO UNICO DO MUNICIPIO DE AREAL', 92262, 3300225, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3006, 4896, 'OFICIO UNICO DO MUNICIPIO DE ARMACAO DOS BUZIOS', 92270, 3300233, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3007, 13831, 'DISTRIBUIDOR, CONTADOR E PARTIDOR', 91900, 3300233, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3008, 4472, 'CARTORIO DO OFICIO UNICO DE ARRAIAL DO CABO', 91033, 3300258, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3009, 13832, 'DISTRIBUIDOR, CONTADOR E PARTIDOR ', 91843, 3300258, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3010, 13833, 'CARTORIO DO 1º OFICIO', 90191, 3300308, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3011, 5016, 'CARTORIO DO RCPN E NOTAS DO 3º DISTRITO DE SAO JOAO DE MERITI', 91256, 3305109, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3012, 13834, '1º OFICIO DE JUSTICA', 88724, 3305109, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3013, 5017, 'RCPN 2º DISTRITO DE SAO JOAO DE MERITI', 92668, 3305109, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3014, 5015, 'SAO JOAO DE MERITI CARTORIO DO RCPN DO 1O. DISTRITO', 93450, 3305109, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3015, 13835, 'CARTORIO 2º OFICIO DE JUSTICA DE SAO JOAO DE MERITI', 89623, 3305109, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3016, 13836, 'CARTORIO DO 5.° OFICIO DE SAO JOAO DE MERITI', 90753, 3305109, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3017, 13837, 'CARTORIO DO 3º OFICIO DE JUSTICA', 90621, 3305109, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3018, 13838, 'QUARTO OFICIO DE JUSTICA DE SAO JOAO DE MERITI', 92387, 3305109, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3019, 13839, 'CARTORIO DO DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE SAO JOAO DE MERITI', 90977, 3305109, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3020, 5018, 'OFICIO UNICO DE JUSTICA DE SAO JOSE DE UBA', 92437, 3305133, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3021, 5019, 'OFICIO UNICO DO MUNICIPIO DE SAO JOSE DO VALE DO RIO PRETO', 92304, 3305158, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3022, 13840, 'DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE SAO JOSE DO VALE DO RIO PRETO', 91934, 3305158, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3023, 13841, 'CARTORIO DO 1º OFICIO - NOTARIAL E REGISTRAL', 90233, 3305208, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3024, 13842, 'CARTORIO DO 2º OFICIO DE JUSTICA', 90464, 3305208, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3025, 5023, 'RCPN 1° DISTRITO DE SAO PEDRO DA ALDEIA', 92494, 3305208, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3026, 13843, 'DISTRIBUIDOR, CONTADOR E PARTIDOR', 91769, 3305208, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3027, 13844, 'DISTRIBUIDOR, CONTADOR E PARTIDOR', 91751, 3305307, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3028, 5024, 'CARTORIO DO OFICIO UNICO DE SAO SEBASTIAO DO ALTO/RJ', 91082, 3305307, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3029, 13845, 'OFICIO UNICO DO MUNICIPIO DE SAPUCAIA', 154575, 3305406, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3030, 13846, 'DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE SAPUCAIA', 152892, 3305406, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3031, 5025, 'RCPN E TABELIONATO DE NOTAS DO 4º DISTRITO DE SAPUCAIA - RJ', 93054, 3305406, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3032, 5026, 'CARTORIO DO RCPN 1º DISTRITO DE SAPUCAIA', 91553, 3305406, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3033, 13847, 'CARTORIO DO DISTRIBUIDOR, CONTADOR E PARTIDOR', 90902, 3305505, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3034, 6575, 'RCPN E NOTAS DO 3º DISTRITO DE SAQUAREMA', 93005, 3305505, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3035, 5028, 'RCPN 1º DISTRITO DE SAQUAREMA-RJ PRIVATIVO DE INTERDICOES E TUTELAS', 92585, 3305505, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3036, 13848, 'SAQUAREMA CARTORIO OFICIO UNICO', 93476, 3305505, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3037, 5027, 'RCPN E NOTAS DO 2º DISTRITO DE SAQUAREMA-RJ', 92999, 3305505, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3038, 13849, 'DISTRIBUIDOR-CONTADOR-PARTIDOR ', 92049, 3305554, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3039, 13850, '1º OFICIO DE JUSTICA DA COMARCA DE SEROPEDICA', 88773, 3305554, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3040, 5029, '2º OFICIO DE JUSTICA DE SEROPEDICA', 92635, 3305554, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3041, 13851, 'DISTRIBUIDOR, CONTADOR E PARTIDOR', 91777, 3305604, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3042, 5030, 'OFICIO UNICO DE SILVA JARDIM', 91488, 3305604, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3043, 13852, 'DISTRIBUIDOR, CONTADOR, PARTIDOR DA COMARCA DE SUMIDOURO - RJ', 91991, 3305703, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3044, 13853, 'OFICIO UNICO DO MUNICIPIO DE SUMIDOURO', 154534, 3305703, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3045, 6576, 'CARTORIO OFICIO UNICO DE TANGUA', 91538, 3305752, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3046, 13854, 'PRIMEIRO TABELIONATO DE NOTAS', 98814, 4301602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3047, 13855, 'SERVICO DE REGISTRO DE IMOVEIS DE BAGE', 98913, 4301602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3048, 13856, '2º TABELIONATO DE NOTAS', 96859, 4301602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3049, 6618, 'SERVICO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE BAGE', 97204, 4301602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3050, 13857, 'SERVICO NOTARIAL E REGISTRAL DE BAGE', 101089, 4301602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3051, 4509, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE BARAO', 98160, 4301651, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3052, 4709, 'SERVENTIA NOTARIAL E REGISTRAL', 99770, 4301701, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3053, 6619, 'SERVICO NOTARIAL E DE REGISTRO DE BARAO DO TRIUNFO', 100594, 4301750, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3054, 5197, 'SERVICO NOTARIAL E REGISTRAL DE BARRA DO QUARAI', 101154, 4301875, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3055, 13858, 'TABELIONATO DE NOTAS E DE PROTESTO DE TITULOS', 103291, 4301909, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3056, 5198, 'REGISTROS PUBLICOS DE BARRA DO RIBEIRO', 99499, 4301909, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3057, 5199, 'SERVICO DOS REGISTROS PUBLICOS DE BARRACAO', 100313, 4301800, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3058, 5200, 'BARROS CASSAL OFICIO DOS REGISTROS PUBLICOS', 97030, 4302006, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3059, 13860, 'SERVICO NOTARIAL GUTERRES', 101485, 4302006, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3060, 13861, 'BENTO GONCALVES CARTORIO DE REGISTRO DE IMOVEIS', 97071, 4302105, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3061, 5202, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 99838, 4302105, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3062, 13862, 'BENTO GONCALVES 2º CARTORIO DE NOTAS', 97063, 4302105, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3063, 5201, 'SERVICOS NOTARIAIS E DE REGISTRO DE FARIA LEMOS', 101816, 4302105, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3064, 13863, 'OFICIO DE REGISTROS ESPECIAIS DE BENTO GONCALVES', 97824, 4302105, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3065, 6620, 'SERVICOS NOTARIAIS/REGISTRAIS DE PINTO BANDEIRA', 102319, 4302105, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3066, 13864, 'PRIMEIRO TABELIONATO DE NOTAS', 98822, 4302105, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3067, 5203, 'CARTORIO SALOMAO', 97303, 4302204, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3068, 7407, 'CARTORIO EXTRA JUDICIAL -014', 30072, 2101905, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3069, 9523, 'CARTORIO DO 1° OFICIO - SERVENTIA EXTRAJUDICIAL N° 017', 30056, 2102002, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3070, 1619, 'CARTORIO DO 2º OFICIO', 30288, 2102002, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3071, 1620, 'CARTORIO BOM JESUS - OFICIO UNICO', 147959, 2102036, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3072, 6872, '1º OFICIO EXTRAJUDICIAL DE BREJO', 31435, 2102101, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3073, 1621, 'EXTRAJUDICIAL DO 2º OFICIO', 30841, 2102101, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3074, 1622, 'SERVENTIA EXTRAJUDICIAL DE OFICIO UNICO', 31344, 2102200, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3075, 1623, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO', 31674, 2102309, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3076, 1624, 'SERVENTIA DO OFICIO UNICO', 148130, 2102325, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3077, 1625, 'SERVENTIA EXTRAJUDICIAL', 31104, 2102408, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3078, 1626, 'OFICIO UNICO DE CAJARI', 30932, 2102507, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3079, 1627, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO', 148510, 2102556, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3080, 9524, 'SERVENTIA EXTRAJUDICIAL', 149278, 2102606, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3081, 1628, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO', 31641, 2102705, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3082, 6873, 'CARTORIO DO 2º OFICIO - SERVENTIA EXTRAJUDICIAL 116', 30296, 2102804, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3083, 9525, 'CARTORIO DO 1° OFICIO EXTRAJUDICIAL N° 115', 30080, 2102804, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3084, 1629, 'SERVENTIA EXTRAJUDICIAL DE CARUTAPERA', 31252, 2102903, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3085, 9526, 'SERVENTIA EXTRAJUDICIAL DO 2º OFICIO', 31591, 2103000, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3086, 1631, 'CARTORIO DO 4º OFICIO - SERVENTIA EXTRA-JUDICIAL', 31096, 2103000, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3087, 1630, 'SERVENTIA EXTRAJUDICIAL 3º OFICIO', 30742, 2103000, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3088, 9527, 'CARTORIO EXTRAJUDICIAL DO 1º OFICIO', 30619, 2103000, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3089, 1632, 'SERVENTIA EXTRAJUDICIAL DE CEDRAL - MA', 31260, 2103109, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3090, 7409, 'CARTORIO DE NOTAS E REGISTRO CIVIL', 29991, 2103208, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3091, 9528, 'CHAPADINHA CARTORIO 1° OFICIO', 30726, 2103208, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3092, 1633, 'SERVENTIA EXTRAJUDICIAL DO OFICIO UNICO', 148122, 2103257, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3093, 9529, 'SERVENTIA EXTRAJUDICIAL DO 1º OFICIO', 31476, 2103307, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3094, 1634, '2º  OFICIO EXTRAJUDICIAL', 29785, 2103307, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3095, 9530, '3º OFICIO EXTRAJUDICIAL', 29884, 2103307, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3096, 9531, 'PRIMEIRO CARTORIO EXTRAJUDICIAL', 30973, 2103406, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3097, 1635, 'CARTORIO DO 2° OFICIO DE COELHO NETO-MA', 30262, 2103406, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3098, 9532, 'CARTORIO DO 1° OFICIO DE COLINAS', 30064, 2103505, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3099, 1636, '2º OFICIO EXTRAJUDICIAL', 29819, 2103505, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3100, 9533, 'CARTORIO DO 1º OFICIO EXTRAJUDICIAL', 30163, 2103604, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3101, 9534, 'CARTORIO DO TERCEIRO OFICIO EXTRAJUDICIAL DA COMARCA DE COROATA/MA', 30718, 2103604, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3102, 1637, 'CARTORIO DO 2º OFICIO EXTRAJUDICIAL', 30361, 2103604, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3103, 9535, '1º OFICIO EXTRAJUDICIAL DE CURURUPU/MA.', 29686, 2103703, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3104, 1638, 'SERVENTIA EXTRAJUDICIAL DO 2º OFICIO', 31559, 2103703, 'MA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3105, 9536, '2 OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS', 32433, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3106, 6880, 'CARTORIO REGISTRO CIVIL 3ºSUBDISTRITO DE BELO HORIZONTE', 31849, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3107, 9537, 'CARTORIO DO 4º OFICIO DE REGISTRO DE IMOVEIS DE BELO HORIZONTE', 41707, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3108, 9538, 'OFICIO DO 6º TABELIONATO DE NOTAS', 50039, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3109, 9539, 'CARTORIO DO 1° OFICIO DE NOTAS DE BH', 40436, 3106200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3110, 9540, 'OFICIO DE REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE SAO SEBASTIAO DE BRAUNAS', 154484, 3106309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3111, 2387, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE PERPETUO SOCORRO', 55178, 3106309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3112, 1473, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE BELO ORIENTE', 33142, 3106309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3113, 3755, 'SERVICO DE REGISTRO DE IMOVEIS ACUMULANDO, PRECARIAMENTE O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85282, 4116208, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3114, 4334, 'SERVICO DISTRITAL DE MUNHOZ DE MELLO', 83956, 4116307, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3115, 13876, '1º TABELIONATO DE NOTAS', 83865, 4115200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3116, 13877, 'SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85316, 4115200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3117, 4309, 'SERVICO DISTRITAL DE MARIOPOLIS', 130112, 4115309, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3118, 3752, 'SERVICO DISTRITAL DE MARIPA', 86553, 4115358, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3119, 13878, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS ', 154039, 4115408, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3120, 13879, 'SERVICO DE REGISTRO DE IMOVEIS', 154021, 4115408, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3121, 4310, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 83899, 4115408, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3122, 3753, 'SERVICO DISTRITAL DE MARQUINHO', 82313, 4115457, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3123, 3754, 'SERVICO DISTRITAL DE MARUMBI', 85837, 4115507, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3124, 4554, 'SERVICOS DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 87296, 4115606, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3125, 13880, 'TABELIONATO DE PROTESTO DE TITULOS', 152918, 4115606, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3126, 13881, 'TABELIONATO DE NOTAS', 152900, 4115606, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3127, 13882, 'SERVICO DE REGISTRO DE IMOVEIS', 145409, 4115606, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3128, 13883, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 88021, 4115705, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3129, 4311, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84236, 4115705, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3130, 4312, 'SERVICO DISTRITAL DE MATO RICO', 83907, 4115739, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3131, 4313, 'SERVICO DISTRITAL DE MAUA DA SERRA', 81489, 4115754, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3132, 4314, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 83923, 4115804, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3133, 13884, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87692, 4115804, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3134, 13885, 'SERVICO DE REGISTRO DE IMOVEIS', 83915, 4115804, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3135, 4331, 'SERVICO DISTRITAL DE MERCEDES', 86322, 4115853, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3136, 6546, 'SERVICO DISTRITAL DE MIRADOR', 83949, 4115903, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3137, 4555, 'SERVICO DISTRITAL DE MIRASSELVA', 87957, 4116000, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3138, 4332, 'SERVICO DISTRITAL DE MISSAL', 86728, 4116059, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3139, 4333, 'SERVICO DISTRITAL DE MOREIRA SALES ', 85811, 4116109, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3140, 13886, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87635, 4116208, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3141, 13887, '3º OFICIO DE JUSTICA', 89128, 3300308, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3142, 13888, 'CARTORIO DO SEGUNDO OFICIO DE BARRA DO PIRAI', 91504, 3300308, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3143, 13189, 'TABELIONATO DE NOTAS SAO MARCOS', 103614, 4319000, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3144, 5658, 'CARTORIO PRATES', 97410, 4319109, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3145, 13190, 'TABELIONATO DE NOTAS DE SAO MARTINHO', 103192, 4319109, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3146, 6737, 'SERVICOS NOTARIAIS E DE REGISTRO', 101725, 4319125, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3147, 5659, 'SERVICO DE REGISTROS PUBLICOS', 100081, 4319158, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3148, 13191, 'TABELIONATO DE NOTAS E DE PROTESTOS', 103309, 4319158, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3149, 13192, 'TABELIONATO SAO NICOLAU', 103994, 4319208, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3150, 6679, 'OFICIO DOS REGISTROS PUBLICOS', 97840, 4319208, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3151, 5236, 'OFICIO DOS REGISTROS PUBLICOS', 98434, 4319307, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3152, 13193, 'TABELIONATO DE NOTAS', 102780, 4319307, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3153, 4852, 'SERVICO NOTARIAL E DE REGISTRO', 100495, 4319372, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3154, 5461, 'SAO PEDRO DO SUL - OFICIO DOS REGISTROS PUBLICOS', 99622, 4319406, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3155, 13194, 'TABELIONATO CARTORIO ARIOVALDO SCHLEMMER', 102525, 4319406, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3156, 13195, 'TABELIONATO DE SAO SEBASTIAO DO CAI', 103754, 4319505, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3157, 5237, 'REGISTROS PUBLICOS DE SAO SEBASTIAO DO CAI', 99523, 4319505, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3158, 13196, 'OFICIO DO REGISTRO DE IMOVEIS', 98186, 4319604, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3159, 6738, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 98988, 4319604, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3160, 13197, 'TABELIONATO E OFICIO DOS REGISTROS ESPECIAIS', 103804, 4319604, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3161, 13198, 'TABELIONATO DE NOTAS E PROTESTOS DE SAO VALENTIM/RS', 103457, 4319703, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3162, 5238, 'SERVICO DE REGISTROS PUBLICOS', 100115, 4319703, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3163, 13199, 'TABELIONATO POZO', 103960, 4319802, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3164, 4777, 'SERVICO REGISTRAL DE SAO VICENTE DO SUL', 101543, 4319802, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3165, 13200, 'TABELIONATO DE SAPIRANGA', 103762, 4319901, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3166, 5660, 'SERVICO REGISTRAL E NOTARIAL DE PROTESTO DE TITULOS', 101584, 4319901, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3167, 13201, 'TABELIONATO SAPUCAIA DO SUL', 104000, 4320008, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3168, 5239, 'SERVICOS DE REGISTROS PUBLICOS  DE SAPUCAIA DO SUL', 101691, 4320008, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3169, 13202, 'TABELIONATO SALVATORI', 103986, 4320107, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3170, 13203, 'REGISTRO DE IMOVEIS', 99176, 4320107, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3171, 5661, 'SERVICO DO RCPN E ESPECIAIS', 100164, 4320107, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3172, 13204, 'TABELIONATO DE NOTAS DE SEBERI', 103218, 4320206, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3173, 5240, 'OFICIO DOS REGISTROS PUBLICOS', 98285, 4320206, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3174, 6739, 'SERVICO NOTARIAL E DE REGISTRO', 100511, 4320230, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3175, 5662, 'SEGREDO OFICIO DISTRITAL', 99648, 4320263, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3176, 13205, 'SERVICO NOTARIAL DE SELBACH', 100453, 4320305, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3177, 5241, 'OFICIO DE REGISTROS PUBLICOS', 97873, 4320305, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3178, 5677, 'TABELIONATO DE NOTAS E REGISTRO CIVIL DAS PESSOAS NATURAIS', 103515, 4321600, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3179, 13206, 'OFICIO DO REGISTRO DE IMOVEIS E REGISTROS ESPECIAIS DE TRAMANDAI-RS', 98228, 4321600, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3180, 13207, 'SERVICOS NOTARIAL E REGISTRAL DE TRES ARROIOS', 102335, 4321634, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3181, 5678, 'SERVICOS NOTARIAIS E DE REGISTROS DE TRES CACHOEIRAS', 102228, 4321667, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3182, 6741, 'SERVICO DOS REGISTROS PUBLICOS DE TRES COROAS', 130781, 4321709, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3183, 13208, 'SERVICOS NOTARIAIS DE TRES COROAS', 102236, 4321709, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3184, 13209, 'SERVICOS REGISTRAIS DE TRES DE MAIO - RS', 102384, 4321808, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3185, 5679, 'TRES DE MAIO TABELIONATO', 104091, 4321808, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3186, 5680, 'SERVICO NOTARIAL E DE REGISTRO DE TRES FORQUILHAS', 100842, 4321832, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3187, 13210, 'REGISTRO DE IMOVEIS DE TRES PASSOS', 99358, 4321907, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3188, 13211, 'SERVICO NOTARIAL DE TRES PASSOS', 100461, 4321907, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3189, 5681, 'SERVICO REGISTRAL DE TRES PASSOS', 101550, 4321907, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3190, 5682, 'SERVICO NOTARIAL E REGISTRAL', 101071, 4321956, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3191, 6692, 'CARTORIO GEYER - REGISTROS PUBLICOS E TABELIONATO DE PROTESTO', 97949, 4322004, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3192, 5683, 'SERVICO NOTARIAL E DE REGISTRO DE PASSO RASO', 98012, 4322004, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3193, 5246, 'SERVICO NOTARIAL E DE REGISTRO DE COSTA DO CADEIA', 100693, 4322004, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3194, 13212, 'TABELIONATO DE NOTAS DE TRIUNFO', 103267, 4322004, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3195, 13213, 'TABELIONATO DE NOTAS DE TUCUNDUVA', 103275, 4322103, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3196, 5247, 'OFICIO DOS REGISTROS PUBLICOS', 98467, 4322103, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3197, 6683, 'SERVICO NOTARIAL E REGISTRAL', 101105, 4322152, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3198, 5248, 'OFICIO DE REGISTRO CIVIL E ESPECIAL ', 97675, 4322202, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3199, 13214, 'TABELIONATO DE NOTAS', 130682, 4322202, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3200, 13215, 'REGISTRO DE IMOVEIS', 99150, 4322202, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3201, 5249, 'SERVICO NOTARIAL E DE REGISTRO DE TUPANDI', 100859, 4322251, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3202, 5250, 'SERVICO DOS REGISTROS PUBLICOS DE TUPARENDI', 100370, 4322301, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3203, 13216, 'TABELIONATO DE NOTAS E PROTESTOS DE TUPARENDI', 102533, 4322301, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3204, 13217, 'OFICIO DE REGISTRO DE IMOVEIS', 97709, 4322400, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3205, 5684, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 97642, 4322400, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3206, 13218, '2º TABELIONATO DE NOTAS DE URUGUAIANA', 96917, 4322400, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3207, 13219, 'PRIMEIRO TABELIONATO DE NOTAS DE URUGUAIANA', 98848, 4322400, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3208, 13220, 'SERVICO DOS REGISTROS ESPECIAIS', 100255, 4322400, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3209, 6684, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE VACARIA', 97659, 4322509, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3210, 13221, 'CARTORIO D0 REGISTRO DE IMOVEIS E ESPECIAIS', 97147, 4322509, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3211, 13222, 'TABELIONATO VACARIA', 102475, 4322509, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3212, 5251, 'SERVICO NOTARIAL E REGISTRAL', 101097, 4322533, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3213, 5253, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E REGISTROS ESPECIAIS', 97212, 4322608, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3214, 13223, 'CARTORIO DE REGISTRO DE IMOVEIS', 97246, 4322608, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3215, 13224, 'TABELIONATO DE NOTAS', 102772, 4322608, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3216, 13225, '1º OFICIO DE REGISTRO DE IMOVEIS', 104224, 4201000, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3217, 13226, 'TABELIONATOS DE NOTAS E PROTESTOS DE TITULOS', 109587, 4201000, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3218, 7120, 'REGISTRO CIVIL TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 108225, 4201000, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3219, 5688, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE ANITAPOLIS', 106849, 4201109, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3220, 13227, 'ESCRIVANIA DE PAZ DE ANTONIO CARLOS', 106070, 4201208, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3221, 5689, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE APIUNA', 143131, 4201257, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3222, 5264, 'ARABUTA CARTORIO DE PAZ', 104745, 4201273, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3223, 13228, 'TABELIONATO DE NOTAS E PROTESTOS DA COMARCA DE ARAQUARI', 109355, 4201307, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3224, 5265, 'ESCRIVANIA DE PAZ DO DISTRITO DE ITAPOCU, MUNICIPIO DE ARAQUARI', 106674, 4201307, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3225, 5690, 'OFICIO DE REGISTRO DE IMOVEIS E HIPOTECAS, OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, TITULOD E DOCUMENTOS E PESSOAS JURIDICAS DA COMARCA DE ARAQUARI (SC)', 107706, 4201307, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3226, 5691, 'PRIMEIRO CARTORIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS E DE PESSOAS JURIDICAS DE ARARANGUA', 108068, 4201406, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3227, 13229, '2º TABELIONATO DE NOTAS E PROTESTO', 104547, 4201406, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3228, 13230, '1º TABELIONATO DE NOTAS, REGISTRO DE IMOVEIS E PROTESTOS EM GERAL', 104364, 4201406, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3229, 5266, 'ESCRIVANIA DE PAZ DO DISTRITO DE HERCILIO LUZ', 106641, 4201406, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3230, 5692, 'OFICIO DE REGISTRO DE IMOVEIS E HIPOTECA, OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, TITULOS E DOCUMENTOS E PESOAS JURIDICAS', 107664, 4201505, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3231, 13231, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS DE ARMAZEM-SC', 109371, 4201505, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3232, 5267, 'ESCRIVANIA DE PAZ DE ARROIO TRINTA/SC', 104992, 4201604, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3233, 7093, 'ESCRIVANIA DE PAZ  ', 105825, 4201653, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3234, 5268, 'ASCURRA OFICIO DE REGISTRO DE IMOVEIS E ANEXOS', 104752, 4201703, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3235, 13232, 'TABELIONATO DE NOTAS E PROTESTOS DE ASCURRA', 109306, 4201703, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3236, 13233, 'ESCRIVANIA DE PAZ DE ATALANTA', 106088, 4201802, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3237, 5269, 'ESCRIVANIA DE PAZ DE AURORA', 106096, 4201901, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3238, 5270, 'ESCRIVANIA DE PAZ DE BALNEARIO ARROIO DO SILVA', 106104, 4201950, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3239, 7094, 'ESCRIVANIA DE PAZ BALNEARIO BARRA DO SUL-SC', 106039, 4202057, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3240, 13234, '1º TABELIONATO DE NOTAS E PROTESTOS', 104307, 4202008, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3241, 5271, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E JURIDICAS E TITULOS E DOCUMENTOS', 108126, 4202008, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3242, 13235, '2 OFICIO DE NOTAS E PROTESTOS', 104398, 4202008, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3243, 13236, '2º OFICIO DE REGISTRO DE IMOVEIS', 104455, 4202008, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3244, 13237, '1º OFICIO DE REGISTRO DE IMOVEIS', 104232, 4202008, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3245, 5693, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE BALNEARIO GAIVOTA', 149823, 4202073, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3246, 13238, 'TABELIONATO DE NOTAS E PROTESTO', 109140, 4212809, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3247, 5421, 'REGISTRO CIVIL, TITULOS, DOCUMENTOS E PESSOAS JURIDICAS', 108407, 4212809, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3248, 13239, 'OFICIO DE REGISTRO DE IMOVEIS DE BALNEARIO PICARRAS', 107607, 4212809, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3249, 5272, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE BANDEIRANTE', 144253, 4202081, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3250, 5273, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE BARRA BONITA', 144261, 4202099, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3251, 5274, 'SERVICO REGISTRAL AGUIAR', 104778, 4202107, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3252, 5242, 'SERVICO NOTARIAL E DE REGISTROS DE SENTINELA DO SUL', 135566, 4320354, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3253, 13240, 'TABELIONATO DE SERAFINA CORREA', 103770, 4320404, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3254, 5243, 'OFICIO DOS REGISTROS PUBLICOS DE SERAFINA CORREA', 98707, 4320404, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3255, 7117, 'SERVICO NOTARIAL E REGISTRAL DE SERIO', 101378, 4320453, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3256, 5663, 'OFICIO DOS REGISTROS PUBLICOS', 98301, 4320503, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3257, 13241, 'TABELIONATO DE NOTAS DE SERTAO', 103226, 4320503, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3258, 6740, 'SERVICO NOTARIAL E DE REGISTROS', 100909, 4320552, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3259, 5664, 'SERVICOS NOTARIAL E DE REGISTRO', 101956, 4320602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3260, 5665, 'SERVICOS NOTARIAIS E DE REGISTRO DE SILVEIRA MARTINS', 101899, 4320651, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3261, 5666, 'SERVICO NOTARIAL E DE REGISTRO DE SINIMBU', 100834, 4320677, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3262, 5667, 'SERVICO DE REGISTRO DE IMOVEIS E CIVIL DAS PESSOAS NATURAIS DE SOBRADINHO', 99952, 4320701, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3263, 13242, 'CARTORIO VICENTE', 97436, 4320701, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3264, 6680, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 98079, 4320800, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3265, 13243, 'OFICIO DO REGISTRO DE IMOVEIS SOLEDADE-RS', 98236, 4320800, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3266, 13244, 'SOLEDADE TABELIONATO E REGISTROS ESPECIAIS', 102418, 4320800, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3267, 5668, 'SERVICOS NOTARIAIS E DE REGISTROS DE TABAI,RS', 102202, 4320859, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3268, 5244, 'TABELIONATO DE NOTAS E SERVICO DO RCPN', 103580, 4320909, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3269, 13245, 'SERVICO DE REGISTRO DE IMOVEIS E ESPECIAIS', 99994, 4320909, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3270, 13246, 'OFICIO DE REGISTRO DE IMOVEIS E ESPECIAIS', 97782, 4321006, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3271, 5669, 'TABELIONATO E REGISTRO CIVIL', 103812, 4321006, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3272, 13247, 'TABELIONATO DE NOTAS E PROTESTOS DE TAPES', 103234, 4321105, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3273, 5670, 'REGISTROS PUBLICOS DE TAPES', 99531, 4321105, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3274, 13248, 'TABELIONATO DE NOTAS ', 102855, 4321204, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3275, 13249, 'SERVICO REGISTRAL DE IMOVEIS DE TAQUARA', 101527, 4321204, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3276, 5671, 'OFICIO DO REGISTRO CIVIL E ESPECIAIS', 98152, 4321204, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3277, 6681, 'OFICIO DOS REGISTROS PUBLICOS ', 98541, 4321303, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3278, 13250, 'TABELIONATO DE NOTAS E PROTESTOS DE TITULOS', 103473, 4321303, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3279, 5672, 'SERVICOS NOTARIAIS E DE REGISTROS DE TAVARES', 102210, 4321352, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3280, 13251, 'SERVICO DO REG. DE IMOVEIS E ESPECIAIS', 100180, 4321402, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3281, 5673, 'TABELIONATO DE NOTAS E REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE TENENTE PORTELA', 103556, 4321402, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3282, 5674, 'SERVICO NOTARIAL E REGISTRAL DE TERRA DE AREIA', 101386, 4321436, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3283, 6682, 'TEUTONIA - OFICIO DOS REGISTROS PUBLICOS', 104083, 4321451, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3284, 13252, 'TABELIONATO DE NOTAS DE TEUTONIA', 103242, 4321451, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3285, 5245, 'CARTORIO OFICIO DE NOTAS', 97402, 4321477, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3286, 5675, 'SERVICO NOTARIAL E REGISTRAL DO TERCEIRO DISTRITO(PIRATABA)', 101436, 4321501, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3287, 13253, 'TABELIONATO DE NOTAS DE TORRES ', 103259, 4321501, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3288, 5676, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 98103, 4321501, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3289, 13254, 'REGISTRO DE IMOVEIS E ESPECIAL', 99440, 4321501, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3290, 4612, 'REGISTRO DE IMOVEIS ACUMULANDO PRECARIAMENTE REGISTRO CIVIL DAS PESSOAS NATURAIS', 85225, 4106605, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3291, 13255, '2º SERVICO DE REGISTRO DE IMOVEIS', 83154, 4106605, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3292, 13256, 'SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E O TABELIONATO DE PROTESTO DE TITULOS', 83147, 4106605, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3293, 4613, 'SERVICO DISTRITAL DE CRUZEIRO DO SUL', 87213, 4106704, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3294, 4251, 'CRUZMALTINA TABELIONATO E REGISTRO CIVIL E DEMAIS ANEXOS', 150383, 4106852, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3295, 4258, '3º SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E 15º TABELIONATO DE NOTAS', 80457, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3296, 13257, '2º SERVICO DE REGISTRO DE IMOVEIS', 83246, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3297, 3627, 'SERVICO DISTRITAL DA BARREIRINHA', 82081, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3298, 4614, 'SERVICO DISTRITAL DO BACACHERI', 83261, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3299, 13258, '6º TABELIONATO DE PROTESTO DE TITULOS DE CURITIBA ', 138941, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3300, 13259, '10O. TABELIONATO DE NOTAS', 463, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3301, 4257, 'SERVICO DISTRITAL DAS MERCES', 83162, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3302, 4252, 'SERVICO DISTRITAL DE SAO CASEMIRO TABOAO', 82404, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3303, 13260, '6º TABELIONATO DE NOTAS', 80598, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3304, 13261, '4º TABELIONATO DE PROTESTO DE TITULOS', 80556, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3305, 13262, '5º TABELIONATO DE PROTESTO DE TITULOS', 129627, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3306, 4254, 'SERVICO DISTRITAL DO CAJURU', 82461, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3307, 13263, '3º SERVICO DE REGISTRO DE IMOVEIS', 80465, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3308, 13264, '6º SERVICO DE REGISTRO DE IMOVEIS', 80606, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3309, 13265, '8º TABELIONATO DE NOTAS', 80622, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3310, 13266, '2º TABELIONATO DE PROTESTOS DE TITULOS', 80382, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3311, 6543, 'SERVICO DISTRITAL DO UMBARA', 84756, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3312, 13267, '8º SERVICO DE REGISTRO DE IMOVEIS', 83238, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3313, 3738, '2º SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E 14º TABELIONATO DE NOTAS', 130518, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3314, 13268, '1º TABELIONATO DE PROTESTO DE TITULOS', 83188, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3315, 13269, '4º SERVICO DE REGISTRO DE IMOVEIS ', 80549, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3316, 13270, '3º SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 80481, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3317, 13271, '4º TABELIONATO DE NOTAS ', 83212, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3318, 3736, 'SERVICO DISTRITAL DO UBERABA', 82446, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3319, 3739, 'SERVICO DISTRITAL DO NOVO MUNDO', 82479, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3320, 13272, '11º TABELIONATO DE NOTAS', 79772, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3321, 3626, 'SERVICO DISTRITAL DE SANTA FELICIDADE', 81075, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3322, 13273, '5º TABELIONATO DE NOTAS', 80580, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3323, 4256, 'SERVICO DISTRITAL DO PINHEIRINHO', 86447, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3324, 13274, '1º TABELIONATO DE NOTAS', 83204, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3325, 3624, 'SERVICO DISTRITAL DO TATUQUARA', 83345, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3326, 6335, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS', 119347, 3551801, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3327, 4255, '1º SERVICO DE REGISTRO CIVIL DE PESSOAS NATURAIS E 13º TABELIONATO DE NOTAS', 79939, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3328, 13275, 'TABELIONATO DE NOTAS ACUMULANDO PRECARIAMENTE O TABELIONATO DE PROTESTOS DE TITULOS', 84475, 4119509, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3329, 13276, 'TABELIONATO DE NOTAS ACUMULANDO, PRECARIAMENTE O TABELIONATO DE PROTESTOS DE TITULOS. ', 87825, 4119608, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3330, 13277, 'SERVICO DE REGISTRO DE IMOVEIS', 84483, 4119608, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3331, 4379, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 82834, 4119608, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3332, 4380, 'SERVICO DISTRITAL DE PITANGUEIRAS', 81216, 4119657, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3333, 4381, 'SERVICO DISTRITAL DE PLANALTINA DO PARANA', 141929, 4119707, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3334, 4382, 'SERVICO DISTRITAL DE PLANALTO', 84491, 4119806, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3335, 4383, 'SERVICO DISTRITAL DE CENTRO NOVO', 86223, 4119806, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3336, 13278, '2° TABELIONATO DE NOTAS', 80135, 4119905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3337, 4385, 'SERVICO DISTRITAL DE GUARAGI', 82222, 4119905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3338, 13279, '1º TABELIONATO DE PROTESTO DE TITULOS', 80044, 4119905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3339, 4388, 'SERVICO DISTRITAL DE UVAIA', 86710, 4119905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3340, 13280, '2º SERVICO DE REGISTRO DE IMOVEIS', 144675, 4119905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3341, 13281, '2º TABELIONATO DE PROTESTO DE TITULOS', 80366, 4119905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3342, 4384, 'SERVICO DISTRITAL DE PIRIQUITOS', 84517, 4119905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3343, 13282, '4º TABELIONATO DE NOTAS', 84525, 4119905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3344, 13283, '3º SERVICO DE REGISTRO DE IMOVEIS', 129429, 4119905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3345, 4386, '2º SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS ACUMULANDO PRECARIAMENTE O 2º  SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 80267, 4119905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3346, 4389, '1º SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS ACUMULANDO PRECARIAMENTE O 1º SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS  E CIVIL DAS PESSOAS JURIDICAS ', 79871, 4119905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3347, 13284, '1º SERVICO DE REGISTRO DE IMOVEIS', 84509, 4119905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3348, 4387, 'SERVICO DISTRITAL DE ITAIACOCA', 86801, 4119905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3349, 13285, '1º TABELIONATO DE NOTAS', 79988, 4119905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3350, 13286, '3º TABELIONATO DE NOTAS', 84533, 4119905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3351, 4390, 'SERVICO DISTRITAL DE PONTAL DO PARANA', 82347, 4119954, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3506, 6713, 'SERVICO DOS REGISTROS PUBLICOS DE CRISSIUMAL', 100347, 4306007, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3352, 4391, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS ', 86017, 4120002, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3353, 13287, 'SERVICO DE REGISTRO DE IMOVEIS', 81836, 4120002, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3354, 13288, 'TABELIONATO DE PROTESTO DE TITULOS', 137927, 4120002, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3355, 13289, 'TABELIONATO DE NOTAS', 88328, 4120002, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3356, 4392, 'SERVICO DISTRITAL DE PORTO AMAZONAS', 82867, 4120101, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3357, 4393, 'SERVICO DISTRITAL DE PORTO BARREIRO', 86355, 4120150, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3358, 4394, 'SERVICO DISTRITAL DE PORTO RICO', 88260, 4120200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3359, 4395, 'SERVICO DISTRITAL DE PORTO VITORIA', 86561, 4120309, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3360, 4396, 'REGISTRO CIVIL E TABELIONATO / PRADO FERREIRA ', 87346, 4120333, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3361, 13290, '2º OFICIO DE JUSTICA DE ITABORAI', 88971, 3301900, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3362, 13291, 'DISTRIBUIDOR, CONTADOR E PARTIDOR', 91835, 3301900, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3363, 6416, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127068, 1716208, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3364, 14000, 'CARTORIO DO REGISTRO DE IMOVEIS, PESSOA JURIDICA, TITULOS E DOCUMENTOS, PROTESTO E TABELIONATO DE NOTAS', 128710, 1716307, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3365, 7200, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 153304, 1716307, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3366, 6418, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 126730, 1716505, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3367, 14001, 'CARTORIO DE REG. DE IMOVEIS E 1º DE NOTAS', 126672, 1716505, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3368, 14002, 'PEDRO AFONSO CART SEGUND TIT E DOC E ANEXOS', 129072, 1716505, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3369, 6420, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS', 128645, 1716604, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3370, 6419, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 128611, 1716604, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3371, 14003, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO 2º DE NOTAS', 128108, 1716604, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3372, 14004, 'CARTORIO DE REGISTRO DE IMOVEIS E TABELIONATO 1° DE NOTAS', 127712, 1716604, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3373, 6421, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE PEQUIZEIRO ', 127399, 1716653, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3374, 14005, 'PEQUIZEIRO CARTORIO DE REGISTRO DE IMOVEIS ', 129080, 1716653, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3375, 6423, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 129155, 1717008, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3376, 6422, 'CARTORIO 1º OFICIO - REGISTRO DE IMOVEIS E NOTAS', 126557, 1717008, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3377, 7201, 'CARTORIO DE REGISTRO DE IMOVEIS, TABELIONATO DE NOTAS E ANEXOS', 127258, 1717206, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3378, 14006, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127357, 1717206, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3379, 6424, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 128470, 1717503, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3380, 14007, 'CARTORIO DO 1º TABELIONATO DE NOTAS E REGISTRO DE IMOVEIS', 128371, 1717503, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3381, 14008, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E 2º TABELIONATO DE NOTAS', 128553, 1717503, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3382, 6425, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127084, 1717800, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3383, 14009, 'CARTORIO DE REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS E TABELIONATO DE NOTAS', 127845, 1717800, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3384, 14010, 'CARTORIO DE REGISTRO DE PESSOAS JURIDICAS TITULOS DOCUMENTOS PROTESTOS E TABELIONATO 2º DE NOTAS', 128025, 1717909, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3385, 6426, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE PONTE ALTA DO TO', 127407, 1717909, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3386, 14011, 'CARTORIO DE REGISTRO DE IMOVEIS', 127571, 1717909, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3387, 14012, 'CARTORIO DO REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 128736, 1718006, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3388, 6327, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 122945, 3551009, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3389, 14013, 'REGISTRO DE IMOVEIS E ANEXOS DE SAO VICENTE', 123612, 3551009, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3390, 6328, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 122150, 3551108, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3391, 6329, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117200, 3551207, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3392, 6330, 'SERVICO DO REGISTRO CIVIL E NOTAS', 124461, 3551306, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3393, 6331, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE SERRA AZUL', 118737, 3551405, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3394, 14014, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE SERRA NEGRA', 125278, 3551603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3395, 6332, 'REGISTRO CIVIL DAS PESSOAS NATURAIS INTERDICOES E TUTELAS DA SEDE', 123265, 3551603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3396, 14015, 'REGISTRO DE IMOVEIS E ANEXOS ', 123638, 3551603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3397, 14016, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOAS JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 143792, 3551504, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3398, 6333, 'TABELIAO DE NOTAS, PROTESTO DE LETRAS E TITULOS E OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 125930, 3551504, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3399, 14017, 'SEGUNDO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 123935, 3551702, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3400, 14018, '1º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 112052, 3551702, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3401, 6334, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE SERTAOZINHO', 116343, 3551702, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3402, 14019, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120386, 3551702, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3403, 6336, 'SEVERINIA CARTORIO DE REGISTRO CIVIL E TABELIONATO', 124610, 3551900, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3404, 6337, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 121616, 3552007, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3405, 14020, 'OFICIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA COMARCA DE SOCORRO - SP', 120535, 3552106, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3406, 6338, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATUARIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE SOCORRO, ESTADO DE SAO PAULO', 114991, 3552106, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3407, 14021, 'TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS ', 125609, 3552106, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3408, 6339, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2ºSUBDISTRITO DA SEDE DA COMARCA DE SOROCABA', 115287, 3552205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3409, 6341, 'REGISTRAL NOTARIAL LUCIO LAZARO DINIZ, DO DISTRITO DE BRIGADEIRO TOBIAS DA COMARCA DE SOROCABA', 122614, 3552205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3410, 14022, '4º TABELIAO DE NOTAS', 113514, 3552205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3411, 14023, '2º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E REGISTRO CIVIL DE PESSOA JURIDICA', 112607, 3552205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3412, 14024, 'SEGUNDO TABELIAO DE NOTAS DE SOROCABA', 123919, 3552205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3413, 6340, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE EDEN', 117978, 3552205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3414, 6342, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUETELAS 1º SUBDISTRITO DA SEDE DA COMARCA  DE SOROCABA - ESTADO DE SAO PAULO', 115477, 3552205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3415, 14025, '3º TABELIAO DE NOTAS DE SOROCABA ', 113290, 3552205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3416, 14026, 'PRIMEIRO TABELIAO DE NOTAS DE SOROCABA-SP', 122374, 3552205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3417, 14027, '1º OFICIAL DE REGISTRO DE IMOVEIS E ANEXO DE SOROCABA', 111468, 3552205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3418, 14028, 'TABELIONATO DE PROTESTO DE LETRAS E TITULOS DE SOROCABA', 126219, 3552205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3419, 6427, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127126, 1718006, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3420, 14029, 'CARTORIO DE REGISTRO DE IMOVEIS DE PORTO NACIONAL', 127639, 1718204, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3421, 6428, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 129148, 1718204, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3422, 14030, 'TABELIONATO 1 DE NOTAS', 129320, 1718204, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3423, 14031, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, E TABELIONATO DE PROTESTO E 2.° DE NOTAS', 129221, 1718204, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3424, 6429, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127233, 1718303, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3425, 14032, 'CARTORIO DO REGISTRO DE IMOVEIS  PES. JURIDICAS, TIT. E DOCUMENTOS, PROTESTOS E TAB. DE NOTAS', 128660, 1718303, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3426, 6430, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 129122, 1718402, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3427, 14033, 'CARTORIO DO REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 128728, 1718402, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3428, 14034, 'REG. IMOVEIS PESS. JUR. TIT. DOC. PROT. E TAB. DE NOTAS', 138693, 1718451, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3429, 6431, 'CARTORIO DO REGISTRO CIVIL ', 128447, 1718451, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3430, 14035, 'CARTORIO DO 1 OFICIO E 2 TABELIONATO DE NOTAS', 128199, 1718501, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3431, 6432, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 126540, 1718501, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3432, 14036, 'CARTORIO RIACHINHO', 128918, 1718550, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3433, 14037, 'REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCS, PROTESTOS E NOTAS', 148023, 1718659, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3434, 6433, 'CARTORIOS GONCALVES', 128942, 1718659, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3435, 6434, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE RIO DOS BOIS', 126953, 1718709, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3436, 6435, 'CARTORIO DE REGISTRO CIVIL DE PESSOAAS NATURAIS', 127019, 1718758, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3437, 14038, 'CARTORIO RIO SONO', 128165, 1718758, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3438, 14039, 'CARTORIO DE REGISTRO DE IMOVEIS', 127548, 1718808, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3439, 6436, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127134, 1718808, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3440, 14040, 'CARTORIO REGISTRO DE IMOVEIS, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, PROTESTOS E TABELIONATO DE NOTAS', 128892, 1718840, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3441, 6437, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 126789, 1718840, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3442, 6440, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 139063, 1718865, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3443, 6438, 'CARTORIO DO REGISTRO DE IMOVEIS PESSOAS JURIDICAS TITULOS E DOCUMENTOS PROTESTOS E TABELIONATO', 128702, 1718865, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3444, 14041, 'CARTORIO DE IMOVEIS E ANEXOS', 126615, 1718881, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3445, 6441, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 127282, 1718881, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3446, 6443, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 129247, 1718907, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3447, 6442, 'REGISTRO DE IMOVEIS, SEUS ANEXOS E TABELIONATO DE NOTAS', 129205, 1718907, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3448, 6563, '14ª CIRCUNSCRICAO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO', 88625, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3449, 13693, 'SEXTO SERVICO REGISTRAL DE IMOVEIS', 93617, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3450, 4415, 'SERVICO DISTRITAL DE MARMELANDIA', 82305, 4121406, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3451, 13344, 'SERVICO DE REGISTRO DE IMOVEIS ', 86116, 4121406, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3452, 4416, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS ', 84640, 4121406, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3453, 13345, 'SERVICO DE REGISTRO DE IMOVEIS', 81802, 4121505, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3454, 4417, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULADO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS.', 82933, 4121505, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3455, 13346, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 130435, 4121505, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3456, 4418, 'SERVICO DISTRITAL DE RENASCENCA', 85621, 4121604, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3457, 13347, 'SERVICO DE REGISTRO DE IMOVEIS', 84210, 4121703, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3458, 4419, 'SERVICO DISTRITAL DE JOSE LACERDA', 86314, 4121703, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3459, 4938, 'CARTORIO DO RCPN E NOTAS DO 2º DISTRITO DE MAGE', 91249, 3302502, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3460, 12998, 'REGISTRO DE IMOVEIS E ESPECIAIS', 99424, 4310009, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3461, 4740, 'TABELIONATO E SERVICO DE RCPN DE IBIRUBA', 103846, 4310009, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3462, 4741, 'SERVICO NOTARIAL E REGISTRAL', 101063, 4310009, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3463, 12999, 'TABELIONATO SCHINDLER', 104018, 4310108, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3464, 4742, 'OFICIO DOS REGISTROS PUBLICOS DE IGREJINHA', 98673, 4310108, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3465, 13000, 'TABELIONATO MARTINS BORTOLI', 103903, 4310207, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3466, 4743, 'SERVICO DE REGISTRO CIVIL DE PESSOAS NATURAIS E REGISTROS ESPECIAIS', 99887, 4310207, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3467, 13001, 'TABELIONATO DE ILOPOLIS', 102657, 4310306, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3468, 6725, 'CARTORIO DE REGISTROS PUBLICOS DE ILOPOLIS', 97311, 4310306, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3469, 4744, 'SERVICO NOTARIAL E DE REGISTROS DE IMBE', 100974, 4310330, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3470, 4745, 'SERVICO NOTARIAL E DE REGISTRO DE IMIGRANTE', 100727, 4310363, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3471, 13002, 'INDEPENDENCIA TABELIONATO', 97535, 4310405, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3472, 4746, 'OFICIO DOS REGISTROS PUBLICOS', 98517, 4310405, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3473, 4747, 'SERVICOS NOTARIAIS E DE REGISTROS', 102004, 4310413, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3474, 7111, 'SERVICOS NOTARIAIS E REGISTROS DE IPE', 102301, 4310439, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3475, 4748, 'TABELINOATO E REGISTRO CIVIL DE IPIRANGA DO SUL', 102426, 4310462, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3476, 13003, 'TABELIONATO DE NOTAS IRAI', 103606, 4310504, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3477, 13004, 'TABELIONATO DE PROTESTO DE TITULOS, OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E OFICIO DE REGISTRO CIVIL DE PESSOAS JURIDICAS', 103705, 4305108, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3478, 13005, 'REGISTRO DE IMOVEIS DA 2ª ZONA', 99259, 4305108, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3479, 4524, 'SERVICO NOTARIAL E DE REGISTRO DE ANA RECH', 100560, 4305108, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3480, 6710, 'SERVICOS NOTARIAIS E DE REGISTROS DE SANTA LUCIA DO PIAI', 97048, 4305108, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3481, 4527, 'SERVICOS NOTARIAIS E DE REGISTROS DE CERRO BRANCO', 102053, 4305132, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3482, 4528, 'SERVICOS NOTARIAIS E DE REGISTRO DE CERRO GRANDE DO SUL', 101790, 4305173, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3483, 13006, 'OFICIO DE REGISTRO DE IMOVEIS E ESPECIAL', 97790, 4305207, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3484, 6711, 'TABELIONATO DE NOTAS E SERVICO DO RCPN', 103572, 4305207, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3485, 5227, 'SERVICO DOS REGISTROS PUBLICOS DE CHAPADA', 101576, 4305306, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3486, 13007, 'TABELIONATO DE NOTAS DE CHAPADA', 103036, 4305306, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3487, 5228, 'SERVICO NOTARIAL E DE REGISTRO DE CHARQUEADAS', 100677, 4305355, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3488, 5229, 'SERVICOS NOTARIAS E DE REGISTRO', 102343, 4305371, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3489, 13008, 'TABELIONATO DE NOTAS DE CHIAPETTA ', 103044, 4305405, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3490, 5230, 'OFICIO DOS REGISTROS PUBLICOS', 98574, 4305405, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3491, 7110, 'SERVICO NOTARIAL E REGISTRAL DO CHUI', 101410, 4305439, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3492, 13009, 'TABELIONATO DE CIDREIRA ', 102616, 4305454, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3493, 5231, 'OFICIO DE REGISTROS PUBLICOS DE CIDREIRA', 97923, 4305454, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3494, 13010, 'TABELIONATO DE NOTAS E PROTESTO', 103366, 4305504, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3495, 5232, 'OFICIO DOS REGISTROS PUBLICOS', 98533, 4305504, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3496, 5233, 'SERVICO NOTARIAL E DE REGISTRO DE COLINAS', 100685, 4305587, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3497, 13011, 'TABELIONATO', 102442, 4305603, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3498, 4675, 'OFICIO DOS REGISTROS PUBLICOS', 98459, 4305603, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3499, 6712, 'SERVENTIA DE REGISTROS PUBLICOS', 99747, 4305702, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3500, 13012, 'TABELIONATO DE NOTAS E PROTESTOS DE CONDOR', 102673, 4305702, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3501, 4676, 'OFICIO DOS REGISTROS PUBLICOS', 98426, 4305801, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3502, 13013, 'TABELIONATO DE NOTAS DE CONSTANTINA', 103051, 4305801, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3503, 13014, 'SERVICO NOTARIAL DE CORONEL BICACO', 100412, 4305900, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3504, 4677, 'SERVICO DE REGISTROS PUBLICOS DE CORONEL BICACO', 100107, 4305900, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3505, 4678, 'SERVICO NOTARIAL E REGISTRAL DE COTIPORA', 101220, 4305959, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3507, 13015, 'TABELIONATO DE NOTAS DE CRISSIUMAL ', 103069, 4306007, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3508, 4679, 'SERVICO NOTARIAL E DE REGISTRO', 100487, 4306056, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3509, 13016, 'TABELIONATO DE NOTAS DE CRUZ ALTA', 103077, 4306106, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3510, 13017, 'CARTORIO DE REGISTRO DE IMOVEIS', 97238, 4306106, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3511, 4680, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E ESPECIAIS', 98145, 4306106, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3512, 4529, 'SERVICO DOS REGISTROS PUBLICOS DE CRUZEIRO DO SUL', 130658, 4306205, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3513, 13018, 'TABELIONATO DE NOTAS E DE PROTESTOS DE CRUZEIRO DO SUL', 103325, 4306205, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3514, 4681, 'SERVICOS NOTARIAIS E DE REGISTROS DE DAVID CANABARRO RS', 102079, 4306304, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3515, 13019, 'TABELIONATO DE NOTAS E PROTESTO E OFICIO DOS REGISTROS ESPECIAIS', 103390, 4313300, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3516, 5704, 'SERVICO DE REGISTRO DE IMOVEIS E DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 99960, 4313300, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3517, 5297, 'SERVICOS NOTARIAS E DE REGISTROS DE NOVA ROMA DO SUL', 102350, 4313359, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3518, 5298, 'SERVICOS NOTARIAIS E DE REGISTRO DE NOVA SANTA RITA', 101865, 4313375, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3519, 5299, 'REGISTRO CIVIL DAS PESSOAS NATURAIS, 2ª ZONA, NOVO HAMBURGO, RS', 99085, 4313409, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3520, 5301, 'SERVICO DO REGISTRO CIVIL DAS PESSOAS NATURAIS - 1ª ZONA', 100198, 4313409, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3521, 13020, 'SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DE PESSOAS JURIDICAS - NOVO HAMBURGO', 100032, 4313409, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3522, 13021, '1º TABELIONATO DE NOTAS E PROTESTOS DE NOVO HAMBURGO', 96750, 4313409, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3523, 13022, 'OFICIO DE REGISTRO DE IMOVEIS', 97683, 4313409, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3524, 5300, 'SERVICO NOTARIAL E REGISTRO CIVIL DAS PESSOAS NATURAIS DE LOMBA GRANDE', 101469, 4313409, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3525, 13023, '2º TABELIONATO DE NOTAS DE NOVO HAMBURGO', 96875, 4313409, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3526, 5302, 'OFICIO DE REGISTRO CIVIL E ANEXOS', 97667, 4313508, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3527, 13024, 'CARTORIO DE REGISTRO DE IMOVEIS DE OSORIO', 97279, 4313508, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3528, 13025, 'SERVICO NOTARIAL DE OSORIO', 100438, 4313508, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3529, 13026, 'TABELIONATO DE NOTAS DE PAIM FILHO', 102251, 4313607, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3530, 5303, 'SERVICO DE REGISTRO DE IMOVEIS E ESPECIAIS', 99986, 4313607, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3531, 13027, 'TABELIONATO DE PALMARES DO SUL', 103671, 4313656, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3532, 6730, 'OFICIO DE REGISTROS PUBLICOS DE PALMARES DO SUL/RS', 97931, 4313656, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3533, 5304, 'TABELIONATO DE NOTAS, PROTESTOS, REGISTROS ESPECIAIS E REGISTRO CIVIL DAS PESSOAS NATURAIS', 103648, 4313706, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3534, 13028, 'OFICIO DO REGISTRO DE IMOVEIS', 98194, 4313706, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3535, 5305, 'PALMITINHO OFICIO DOS REGISTROS PUBLICOS', 98509, 4313805, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3536, 13029, 'SERVICO NOTARIAL DE PALMITINHO', 100446, 4313805, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3537, 13030, 'CARTORIO DE REGSITRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS E PESSOA JURIDICA E TABELIONATO DE PROTESTOS', 97329, 4313904, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3538, 5306, 'TABELIONATO DE NOTAS E OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 103333, 4313904, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3539, 5307, 'OFICIO DE SERVICOS REGISTRAIS E NOTARIAIS', 98004, 4313953, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3540, 5308, 'SERVICO NOTARIAL E DE REGISTROS DE PARAI', 100990, 4314001, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3541, 6731, 'SERVICO NOTARIAL E DE REGISTRO DE PARAISO DO SUL - COMARCA DE AGUDO', 100784, 4314027, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3542, 5309, 'SERVICO NOTARIAL E DE REGISTRO DE PAROBE', 100792, 4314050, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3543, 5310, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 99077, 4314068, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3544, 5634, 'SERVICOS NOTARIAIS E DE REGISTRO', 101733, 4314076, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3545, 13031, 'SEGUNDO TABELIONATO DE PASSO FUNDO-RS', 99721, 4314100, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3546, 13032, 'REGISTRO DE IMOVEIS DE PASSO FUNDO', 99309, 4314100, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3547, 5635, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 98954, 4314100, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3548, 13033, 'SERVICO DE REGISTROS ESPECIAIS DA COMARCA DE PASSO FUNDO', 100057, 4314100, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3549, 13034, '1º TABELIONATO DE NOTAS DE PASSO FUNDO', 96727, 4314100, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3550, 5636, 'SERVICOS NOTARIAIS E DE REGISTRO DE PAVERAMA', 101873, 4314159, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3551, 5311, 'OFICIO DOS REGISTROS PUBLICOS', 98483, 4314209, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3552, 4711, 'ESTEIO - TABELIONATO DE NOTAS E REGISTRO CIVIL', 97469, 4307708, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3553, 13035, 'SERVICO DE REGISTRO DE IMOVEIS', 99911, 4307807, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3554, 4712, 'SERVENTIA REGISTRAL E NOTARIAL DE ESTRELA', 99812, 4307807, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3555, 13036, 'TABELIONATO DE NOTAS DE ESTRELA', 103101, 4307807, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3556, 4713, 'SERVICOS NOTARIAIS E DE REGISTRO DE FAGUNDES VARELA', 101808, 4307864, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3557, 13037, 'TABELIONATO E OFICIO DOS REGISTROS ESPECIAIS', 103796, 4307906, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3558, 13038, 'SERVENTIA DE REGISTRO DE IMOVEIS', 99754, 4307906, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3559, 4714, 'CARTORIO HART SCHNEIDER', 97394, 4307906, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3560, 4715, 'FARROUPILHA CARTORIO DE OFICIOS E NOTAS', 97477, 4307906, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3561, 13039, 'SERVICO DE REGISTRO DE IMOVEIS E ESPECIAIS', 99978, 4308003, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3562, 4716, 'SERVICOS NOTARIAIS E DE REGISTROS DE FAXINAL DO SOTURNO', 102103, 4308003, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3563, 6719, 'OFICIO DE REGISTROS PUBLICOS', 97915, 4308102, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3564, 13040, 'TABELIONATO DE NOTAS', 102749, 4308102, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3565, 13041, 'TABELIONATO FLORES DA CUNHA', 103861, 4308201, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3566, 4717, 'SERVICO DOS REGISTROS PUBLICOS', 100289, 4308201, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3567, 4718, 'SERVICO NOTARIAL E DE REGISTROS DE FONTOURA XAVIER', 100941, 4308300, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3568, 4719, 'OFICIO DOS REGISTROS PUBLICOS', 98590, 4308409, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3569, 13042, 'TABELIONATO DE FORMIGUEIRO', 102632, 4308409, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3570, 6720, 'SERVICOS NOTARIAIS E DE REGISTROS DE FORTALEZA DOS VALOS ', 102111, 4308458, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3571, 4720, 'TABELIONATO DE NOTAS E REGISTRO CIVIL DAS PESSOAS NATURAIS', 103531, 4308508, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3572, 13043, 'REGISTRO DE IMOVEIS E ESPECIAIS', 99408, 4308508, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3573, 4721, 'SERVICOS REGISTRAIS E TABELIONATO DE PROTESTOS E CRVA DE GARIBALDI', 102392, 4308607, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3574, 13044, 'TABELIONATO DE NOTAS', 102731, 4308607, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3575, 4722, 'GAURAMA - OFICIO DOS REGISTROS PUBLICOS', 97485, 4308706, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3576, 13045, 'GAURAMA TABELIONATO', 97493, 4308706, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3577, 13046, 'TABELIONATO DE GENERAL CAMARA', 102640, 4308805, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3578, 4723, 'OFICIO DOS REGISTROS PUBLICOS DE GENERAL CAMARA', 98665, 4308805, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3579, 13047, 'TABELIONATO DE NOTAS E SERVICOS DOS REGISTROS ESPECIAIS', 103598, 4308904, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3580, 4724, 'OFICIO DE REGISTROS PUBLICOS', 97881, 4308904, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3581, 4725, 'GIRUA TABELIONATO DA SEDE', 97501, 4309001, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3582, 6721, 'OFICIO DOS REGISTROS PUBLICOS', 98392, 4309001, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3583, 4726, 'OFICIO DE SERVICOS NOTARIAIS E DE REGISTROS DE GLORINHA', 97980, 4309050, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3584, 13048, 'GRAMADO REGISTROS PUBLICOS', 97519, 4309100, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3585, 4727, 'TABELIONATO DE NOTAS E REGISTRO CIVIL DAS PESSOAS NATURAIS', 103523, 4309100, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3586, 6722, 'SERVICOS NOTARIAIS E DE REGISTRO BARNABE', 101774, 4309209, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3587, 13049, 'REGISTRO DE IMOVEIS DE GRAVATAI', 99291, 4309209, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3588, 4730, 'SERVICOS NOTARIAIS E DE REGISTROS DE MORUNGAVA', 102145, 4309209, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3589, 13050, 'SERVICO NOTARIAL RAUPP', 101493, 4309209, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3590, 4749, 'REGISTROS PUBLICOS', 97378, 4310504, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3591, 4750, 'OFICIO DE SEDE MUNICIPAL DE ITAARA', 97964, 4310538, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3592, 4751, 'SERVICO NOTARIAL E REGISTRAL DE ITACURUBI', 101287, 4310553, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3593, 13051, 'OFICIO DO REGISTRO DE IMOVEIS E ESPECIAIS ', 98210, 4310603, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3594, 6676, 'TABELIONATO DE NOTAS E RCPN', 103481, 4310603, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3595, 4752, 'SERVICO NOTARIAL E DE REGISTRO DE ITATI', 100735, 4310652, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3596, 4753, 'OFICIO DE SERVICOS NOTARIAS E REGISTROS DE ITATIBA DO SUL/RS', 97998, 4310702, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3597, 4754, 'SERVICO NOTARIAL E DE REGISTRO DE IVORA-RS', 100743, 4310751, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3598, 13052, 'TABELIONATO DE NOTAS E DE PROTESTOS DE TITULOS', 149237, 4310801, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3599, 6726, 'SERVICO DE REGISTROS PUBLICOS', 101915, 4310801, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3600, 4755, 'SERVICOS NOTARIAIS E DE REGISTRO DE JABOTICABA', 101832, 4310850, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3601, 4756, 'SERVICO NOTARIAL E REGISTRAL', 101055, 4310900, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3602, 4757, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 98095, 4311007, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3603, 13053, 'SERVICO DE REGISTRO DE IMOVEIS E ESPECIAIS', 100008, 4311007, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3604, 13054, 'TABELIONATO BRODT', 102491, 4311007, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3605, 6727, 'TABELIONATO DE NOTAS E ORCPN DE JAGUARI', 103341, 4311106, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3606, 13055, 'SERVICO NOTARIAL E REGISTRAL DE JAGUARI', 101295, 4311106, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3607, 4758, 'SERVICO NOTARIAL E DE REGISTRO DE JAQUIRANA', 100750, 4311122, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3608, 4759, 'OFICIO DE NOTAS E DE REGISTROS', 97618, 4311130, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3609, 4760, 'SERVICOS NOTARIAIS E DE REGISTROS DE JOIA-RS', 102137, 4311155, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3610, 4761, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E ESPECIAIS DE JULIO DE CASTILHOS', 99069, 4311205, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3611, 13056, 'JULIO DE CASTILHOS SERVICO DE REGISTRO DE IMOVEIS', 97550, 4311205, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3612, 13057, 'JULIO DE CASTILHOS CARTORIO DE NOTAS', 97543, 4311205, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3613, 13058, 'SERVICO DE REGISTRO DE IMOVEIS, ESPECIAIS E PROTESTO DE TITULOS', 100016, 4311304, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3614, 6691, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 97634, 4311304, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3615, 13059, 'TABELIONATO DE LAGOA VERMELHA', 102665, 4311304, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3616, 4762, 'SERVICO NOTARIAL E DE REGISTRO DE LAGOAO', 130674, 4311254, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3617, 13060, 'TABELIONATO KLEIN ', 103887, 4311403, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3618, 13061, 'CARTORIO DE REGISTRO DE IMOVEIS DE LAJEADO', 97261, 4311403, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3619, 4763, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE LAJEADO', 98129, 4311403, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3620, 4764, 'SERVICO DOS REGISTROS PUBLICOS', 130666, 4311502, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3621, 13062, 'TABELIONATO ', 102459, 4311502, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3622, 4765, 'OFICIO DE SEDE MUNICIPAL', 97956, 4311601, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3623, 13063, 'TABELIONATO DE NOTAS DE MACHADINHO', 103127, 4311700, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3624, 4766, 'REGISTROS PUBLICOS DE MACHADINHO', 99507, 4311700, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3625, 6728, 'SERVICO NOTARIAL E DE REGISTROS DE MANOEL VIANA', 97428, 4311759, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3626, 4767, 'SERVICOS NOTARIAIS E DE REGISTROS', 101923, 4311775, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3627, 4768, 'REGISTRO CIVIL E TABELIONATO DE NOTAS TRENTIN', 99127, 4311809, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3628, 13064, 'OFICIO DO REGISTRO DE IMOVEIS E ESPECIAIS', 98202, 4311809, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3629, 13065, 'TABELIONATOZANIN', 104034, 4311908, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3630, 4769, 'OFICIO DOS REGISTROS PUBLICOS - MARCELINO RAMOS-RS', 98624, 4311908, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3631, 4770, 'SERVICO NOTARIAL E DE REGISTROS', 100917, 4311981, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3632, 6729, 'SERVICOS NOTARIAL E DE REGISTRO', 103507, 4312005, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3633, 4772, 'SERVICOS NOTARIAIS E DE REGISTRO DE BELA VISTA DO FAO', 101782, 4312054, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3634, 4771, 'SERVICOS NOTARIAIS E DE REGISTRO DE MARQUES DE SOUZA', 101840, 4312054, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3635, 4773, 'SERVENTIA NOTARIAL E REGISTRAL DE MATA-RS', 99796, 4312104, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3636, 4774, 'TABELIONATO E REGISTRO CIVIL DE MATO LEITAO - RS', 103838, 4312153, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3637, 13066, 'TABELIONATO TODESCHINI', 104026, 4312203, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3638, 6677, 'OFICIO DOS REGISTROS PUBLICOS', 98277, 4312203, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3639, 4775, 'CARTORIO DO SERVICO NOTARIAL E REGISTRAL DE MINAS DO LEAO', 97568, 4312252, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3640, 4776, 'SERVICO DOS REGISTROS PUBLICOS DE MIRAGUAI', 130997, 4312302, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3641, 13067, 'TABELIONATO DE NOTAS E DE PROTESTO DE MIRAGUAI', 100768, 4312302, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3642, 5290, 'SERVICOS NOTARIAIS E REGISTRAIS DE MONTAURI', 102285, 4312351, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3643, 5291, 'BENTO GONCALVES - CARTORIO DISTRITAL', 97055, 4312385, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3644, 5626, 'CARTORIO DE REGISRO DE TITULOS E DOCUMENTOS', 97188, 4312401, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3645, 13068, 'TABELIONATO DE NOTAS', 102764, 4312401, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3646, 13069, 'SERVICO DO REGISTRO DE IMOVEIS DE MONTENEGRO', 100230, 4312401, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3647, 5627, 'SERVICO NOTARIAL E REGISTRAL', 101113, 4312427, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3648, 5628, 'SERVICO NOTARIAL E DE REGISTRO DE MORRINHOS DO SUL', 100776, 4312443, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3649, 5629, 'SERVICO NOTARIAL E REGISTRAL DE MORRO REDONDO', 101311, 4312450, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3650, 5630, 'SERVICO REGISTRAL PUBLICO DE MOSTARDAS-RS', 101618, 4312500, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3651, 13070, 'MOSTARDAS TABELIONATO', 97584, 4312500, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3652, 5701, 'SERVICOS NOTARIAIS E DE REGISTROS DE MUCUM', 100982, 4312609, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3653, 13071, 'REGISTRO DE IMOVEIS E ESPECIAIS', 99390, 4312658, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3654, 5702, 'TABELIONATO DE NOTAS E REGISTRO CIVIL DAS PESSOAS NATURAIS ', 103549, 4312658, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3655, 5292, 'TABELIONATO NONOAI', 103929, 4312708, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3656, 13072, 'NONOAI REGISTRO DE IMOVEIS', 97592, 4312708, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3657, 5293, 'SERVICOS NOTARIAIS E DE REGISTROS DE NOVA ALVORADA', 102152, 4312757, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3658, 5631, 'SERVICOS NOTARIAIS E DE REGISTRO DE NOVA ARACA', 101857, 4312807, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3659, 13073, 'TABELIONATO DE NOTAS E DE PROTESTOS DE TITULOS', 142737, 4312906, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3660, 5703, 'SERVICOS REGISTRAL DE NOVA BASSANO', 101329, 4312906, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3661, 5632, 'SERVICO NOTARIAL E DE REGISTRO DE NOVA BRESCIA', 130641, 4313003, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3662, 5294, 'SERVICO NOTARIAL E REGISTRAL DE NOVA ESPERANCA DO SUL - COMARCA DE JAGUARI', 101337, 4313037, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3663, 5295, 'SERVICO NOTARIAL E REGISTRAL DE NOVA PADUA - ', 101345, 4313086, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3664, 5296, 'SERVICOS NOTARIAIS E DE REGISTRO', 101758, 4313102, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3665, 5633, 'OFICIO DOS REGISTROS PUBLICOS', 98475, 4313201, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3666, 13074, 'TABELIONATO DE NOVA PETROPOLIS', 103663, 4313201, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3667, 13075, 'PEDRO OSORIO CARTORIO DE OFICIO DE NOTAS ', 98749, 4314209, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3668, 5705, 'SERVICOS NOTARIAIS E DE REGISTROS', 101949, 4314308, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3669, 5638, '1º ZONA DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 96792, 4314407, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3670, 13076, 'ROCHA BRITO SERVICO NOTARIAL E REGISTRAL', 99572, 4314407, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3671, 13077, 'TERCEIRO TABELIONATO DE PELOTAS', 104075, 4314407, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3672, 13078, 'SEGUNDO TABELIONATO DE NOTAS', 99689, 4314407, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3673, 5313, 'DUNAS, CARTORIO EVALDO', 97451, 4314407, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3674, 13079, 'SERVICO REGISTRAL FERNANDES MACHADO', 101592, 4314407, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3675, 13080, '4º TABELIONATO DE NOTAS DE PELOTAS', 96974, 4314407, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3676, 5312, 'SERVICO DE REGISTRO CIVIL DE NASCIMENTOS, CASAMENTOS E OBITOS DA 2ª ZONA', 99861, 4314407, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3677, 13081, 'REGISTRO DE IMOVEIS DA 1ª ZONA DE PELOTAS', 99234, 4314407, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3678, 5637, 'SERVICO NOTARIAL E DE REGISTRO CERRITO ALEGRE', 100669, 4314407, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3679, 13082, 'PRIMEIRO TABELIONATO PELOTAS', 98855, 4314407, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3680, 5314, 'SERVICO NOTARIAL E DE REGISTRO', 100479, 4314423, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3681, 7112, 'PINHAL GRANDE SERVICO NOTARIAL E DE REGISTRO', 98756, 4314472, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3682, 5315, 'SERVICOS DE REGISTROS PUBLICOS DE PINHEIRO MACHADO', 101709, 4314506, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3683, 13083, 'TABELIONATO DE PINHEIRO MACHADO', 103689, 4314506, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3684, 5316, 'TABELIONATO DE NOTAS E REGISTRO CIVIL', 103499, 4314555, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3685, 5317, 'SERVICO DE REGISTROS PUBLICOS', 100073, 4314605, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3686, 13084, 'TABELIONATO DE NOTAS E DE PROTESTOS DE PIRATINI', 103135, 4314605, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3687, 13085, 'TABELIONATO PLANALTO', 103945, 4314704, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3688, 5639, 'OFICIO DOS REGISTROS PUBLICOS', 98319, 4314704, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3689, 5318, 'SERVICO NOTARIAL E REGISTRAL DE POCO DAS ANTAS', 101352, 4314753, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3690, 13086, 'TABELIONATO DE NOTAS DE PORTAO', 103143, 4314803, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3691, 7113, 'OFICIO DOS REGISTROS PUBLICOS DE PORTAO - RS', 98681, 4314803, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3692, 5320, 'OFICIO DO REGISTRO CIVIL DA 3ª ZONA', 98038, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3693, 13087, 'DECIMO PRIMEIRO TABELIONATO PORTO ALEGRE', 97444, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3694, 5319, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DA 5ª ZONA', 99002, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3695, 13088, '12º TABELIONATO DE NOTAS DE PORTO ALEGRE', 96628, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3696, 13089, '5º TABELIONATO DE NOTAS - SERVICO NOTARIAL MANICA', 96982, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3697, 13090, '1º REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS DE PORTO ALEGRE', 96651, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3698, 13091, '10º TABELIONATO DE NOTAS DE PORTO ALEGRE - RS', 96610, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3699, 5321, 'SERVENTIA REGISTRAL DAS PESSOAS NATURAIS DA 4ª ZONA', 99804, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3700, 5323, 'SERVICO DE REGISTRO CIVIL DE PESSOAS NATURAIS - 2ª ZONA', 100024, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3701, 13092, '1º TABELIONATO DE PROTESTO DE TITULOS', 96784, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3702, 13093, 'PORTO ALEGRE OITAVO TABELIONATO', 98780, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3703, 7114, 'SERVICOS NOTARIAIS E DE REGISTRO BAIRRO BELEM NOVO, ANTIGO OFICIO DISTRITAL DE BELEM NOVO', 101766, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3704, 5322, '1. OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 96602, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3705, 5324, 'CARTORIO ALVICIO - SERVICO NOTARIAL E REGISTRAL DO BAIRRO RESTINGA', 97139, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3706, 13094, '1° TABELIONATO DE NOTAS DE PORTO ALEGRE RS', 96636, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3707, 13095, 'SEXTO TABELIONATO DE NOTAS - PORTO ALEGRE', 102400, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3708, 13096, 'REGISTRO DE IMOVEIS DA 1A ZONA DE PORTO ALEGRE', 99226, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3709, 13097, 'REGISTRO DE IMOVEIS DA 3ª ZONA DE PORTO ALEGRE', 99267, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3710, 13098, 'REGISTRO DE IMOVEIS 4 ZONA', 99218, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3711, 13099, '2º TABELIONATO DE PROTESTOS', 96933, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3712, 13100, '3º TABELIONATO DE PROTESTOS', 96966, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3713, 13101, 'PORTO ALEGRE - NONO TABELIONATO', 98764, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3714, 13102, 'SERVICO DE REGISTRO DE IMOVEIS 5ª ZONA', 99937, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3715, 5640, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DA 6ª ZONA ', 99010, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3716, 13103, '2O. TABELIONATO DE NOTAS', 96800, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3717, 13104, '2º REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 96826, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3718, 13105, 'REGISTRO DE IMOVEIS DA 2A. ZONA DE PORTO ALEGRE', 99242, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3719, 13106, '7º TABELIONATO', 96990, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3720, 13107, 'TERCEIRO TABELIONATO DE NOTAS DE PORTO ALEGRE', 104067, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3721, 13108, '3º SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS ', 138552, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3722, 13109, 'PORTO ALEGRE 4º TABELIONATO DE NOTAS DE PORTO ALEGRE', 98772, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3723, 13110, 'OFICIO DE REGISTRO DE IMOVEIS 6ª ZONA', 97741, 4314902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3724, 13111, 'TABELIONATO PORTO LUCENA', 103952, 4315008, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3725, 5706, 'SERVICOS DE REGISTROS PUBLICOS', 101659, 4315008, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3726, 13112, 'TABELIONATO DE NOTAS', 102814, 4315107, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3727, 5325, 'OFICIO DOS REGISTROS PUBLICOS', 98400, 4315107, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3728, 5707, 'SERVICOS NOTARIAIS E DE REGISTROS DE POUSO NOVO', 102160, 4315131, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3729, 5326, 'SERVICO NOTARIAL E DE REGISTROS DE PROGRESSO', 101014, 4315156, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3730, 5327, 'SERVICOS NOTARIAIS E DE REGISTROS DE PUTINGA', 102178, 4315206, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3731, 5641, 'SERVENTIA DOS REGISTROS PUBLICOS DE QUARAI', 99762, 4315305, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3732, 13113, 'TABELIONATO DE NOTAS E PROTESTOS DE QUARAI', 103432, 4315305, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3733, 5642, 'SERVICOS NOTARIAIS E DE REGISTROS', 101907, 4315354, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3734, 13114, 'TABELIONATO DE NOTAS DE REDENTORA', 103150, 4315404, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3735, 5643, 'REDENTORA OFICIO DOS REGISTROS PUBLICOS', 98889, 4315404, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3736, 5644, 'SERVICOS NOTARIAIS E DE REGISTROS DE RELVADO', 102186, 4315453, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3737, 13115, 'TABELIONATO DE NOTAS DE RESTINGA SECA, RS', 97022, 4315503, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3738, 5645, 'REGISTROS PUBLICOS DE RESTINGA SECA', 99515, 4315503, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3739, 13116, 'TABELIONATO DE PROTESTOS DE TITULOS', 96925, 4315602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3740, 5328, 'PRIMEIRO OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE RIO GRANDE - RS', 98798, 4315602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3741, 13117, '2º TABELIONATO DE NOTAS ', 153718, 4315602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3742, 13118, '3º TABELINATO DE NOTAS DO RIO GRANDE', 96941, 4315602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3743, 13119, 'REGISTRO DE IMOVEIS DO RIO GRANDE - RS', 99366, 4315602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3744, 13120, '1º TABELIONATO DE NOTAS - RIO GRANDE', 96693, 4315602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3745, 5709, 'SERVICO REGISTRAL - REGISTRO CIVIL DAS PESSOAS NATURAIS - 2ª ZONA, REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 100206, 4315602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3746, 5710, 'SERVICO NOTARIAL E DE REGISTRO DO CASSINO', 100883, 4315602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3747, 5708, 'SERVICO NOTARIAL E DE REGISTROS DE POVO NOVO', 101006, 4315602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3748, 5711, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE RIO PARDO', 99044, 4315701, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3749, 13121, 'REGISTRO DE IMOVEIS DE RIO PARDO', 99317, 4315701, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3750, 13122, 'TABELIONATO PELLEGRINI', 103937, 4315701, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3751, 6678, 'OFICIO DOS REGISTROS PUBLICOS', 98327, 4315800, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3752, 13123, 'TABELIONATO DE NOTAS E PROTESTO DE ROCA SALES ', 103440, 4315800, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3753, 5712, 'OFICIO DOS REGISTROS PUBLICOS E TABELIONATO DE PROTESTOS DE RODEIO BONITO', 98731, 4315909, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3754, 13124, 'TABELIONATO DE NOTAS DE RODEIO BONITO', 103168, 4315909, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3755, 5329, 'SERVICO NOTARIAL, REGISTRO CIVIL E ESPECIAIS DE ROLANTE/RS', 103655, 4316006, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3756, 13125, 'REGISTRO DE IMOVEIS DE ROLANTE', 99325, 4316006, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3757, 5330, 'SERVICO DE REGISTROS PUBLICOS RONDA ALTA', 100156, 4316105, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3758, 13126, 'TABELIONATO RONDA ALTA', 103978, 4316105, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3759, 5446, 'SERVICO NOTARIAL E DE REGISTRO', 100503, 4316204, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3760, 5713, 'OFICIO DE REGISTROS PUBLICOS', 97832, 4316303, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3761, 13127, 'TABELIONATO DE NOTAS', 102699, 4316303, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3762, 13128, 'REGISTRO DE IMOVEIS DE ROSARIO DO SUL', 99333, 4316402, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3763, 5714, 'CARTORIO DE REGISTRO CIVIL DE ROSARIO DO SUL', 97220, 4316402, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3764, 13129, 'TABELIONATO DE NOTAS E SERV. REG. ESPECIAIS', 103564, 4316402, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3765, 13130, 'TABELIONATO DE NOTAS E PROTESTOS', 103408, 4316451, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3766, 5646, 'SERVICO DOS REGISTROS PUBLICOS DE SALTO DO JACUI', 100362, 4316451, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3767, 6732, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 100529, 4316501, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3768, 6733, 'SANANDUVA TABELIONATO E REGISTRO CIVIL', 99580, 4316600, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3769, 13131, 'REGISTRO DE IMOVEIS E ESPECIAIS', 99374, 4316600, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3770, 13132, 'TABELIONATO COLPO', 102541, 4316709, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3771, 5447, 'OFICIO DOS REGISTROS PUBLICOS', 98608, 4316709, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3772, 5715, 'SERVICOS NOTARIAIS E DE REGISTRO', 101741, 4316758, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3773, 13133, 'SERVICO DOS REG.ESPECIAIS', 100248, 4316808, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3774, 5717, 'SERVICOS NOTARIAIS E DE REGISTROS', 101980, 4316808, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3775, 13134, '2º TABELIONATO DE NOTAS DE SANTA CRUZ DO SUL', 96883, 4316808, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3776, 13135, 'OFICIO DE REGISTRO DE IMOVEIS', 97717, 4316808, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3777, 13136, '1º TABELIONATO DE NOTAS', 96669, 4316808, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3778, 5716, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 98947, 4316808, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3779, 5648, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DA 2ª ZONA', 98996, 4316907, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3780, 5649, 'SERVICO NOTARIAL E REGISTRAL DE CAMOBI', 101212, 4316907, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3781, 13137, 'OFICIO DOS REGISTROS ESPECIAIS', 98251, 4316907, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3782, 13138, 'OFICIO DO REGISTRO DE IMOVEIS', 98178, 4316907, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3783, 13139, '1º TABELIONATO DE NOTAS DE SANTA MARIA', 96735, 4316907, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3784, 13140, '2º TABELIONATO DE NOTAS DE SANTA MARIA', 96891, 4316907, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3785, 5647, 'SERVICO NOTARIAL E DE REGISTRO DE BOCA DO MONTE', 100602, 4316907, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3786, 5448, 'CARTORIO DE SEDE MUNICIPAL', 97337, 4316956, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3787, 13141, 'OFICIO DE REGISTRO DE IMOVEIS', 97691, 4317202, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3788, 5650, 'SANTA ROSA TABELIONATO E REGISTROS ESPECIAIS', 99598, 4317202, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3789, 5449, 'SERVICOS NOTARIAIS E DE REGISTRO DE SANTA TEREZA', 101881, 4317251, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3790, 5450, 'CARTORIO DO REGISTRO CIVIL, ESPECIAIS, PROTESTOS E CRVA', 99135, 4317301, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3791, 13142, 'SANTA VITORIA DO PALMAR REGISTRO DE IMOVEIS', 99606, 4317301, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3792, 13143, 'TABELIONATO DE NOTAS', 102798, 4317301, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3793, 5451, 'SERVICO NOTARIAL E REGISTRO DE SANTANA DA BOA VISTA', 101477, 4317004, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3794, 13144, '1º TABELIONATO DE NOTAS', 96677, 4317103, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3795, 13145, 'SEGUNDO TABELIONATO DE NOTAS DE SANTANA DO LIVRAMENTO', 99705, 4317103, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3796, 6734, 'RCPN E ESPECIAIS ', 98871, 4317103, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3797, 13146, 'OFICIO DE REGISTRO DE IMOVEIS ', 97725, 4317103, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3798, 13147, '2° TABELIONATO', 96818, 4317400, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3799, 13148, '1º TABELIONATO DE NOTAS E TABELIONATO DE PROTESTO DE TITULOS DE SANTIAGO', 96776, 4317400, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3800, 5651, 'SERVICO DE REGISTRO CIVIL DE PESSOAS NATURAIS E REGISTROS ESPECIAIS', 99895, 4317400, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3801, 13149, 'REGISTRO DE IMOVEIS DE SANTIAGO', 99341, 4317400, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3802, 13150, '2º TABELIONATO DE NOTAS DE SANTO ANGELO', 96909, 4317509, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3803, 5452, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 99820, 4317509, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3804, 13151, '1 TABELIONATO E REGISTRO ESPECIAL', 96594, 4317509, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3805, 13152, 'SERVICO DE REGISTRO DE IMOVEIS', 99929, 4317509, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3806, 13153, 'CARTORIO DE REGISTRO DE IMOVEIS DE SANTO ANTONIO DA PATRULHA', 97287, 4317608, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3807, 6735, 'SERVICO NOTARIAL E REGISTRAL DE MIRAGUAIA', 101303, 4317608, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3808, 13154, 'TABELIONATO BAIERLE', 102483, 4317608, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3809, 5718, 'REGISTRO CIVIL E ESPECIAIS DE SANTO ANTONIO DA PATRULHA', 99101, 4317608, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3810, 13155, 'TABELIONATO DE NOTAS', 102723, 4317707, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3811, 5719, 'OFICIO DE REGISTROS PUBLICOS', 97865, 4317707, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3812, 13156, 'TABELIONATO DE NOTAS DE SANTO AUGUSTO', 103200, 4317806, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3813, 5453, 'SERVICO DE REGISTROS PUBLICOS DO MUNICIPIO E COMARCA DE SANTO AUGUSTO/RS', 100388, 4317806, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3814, 5720, 'SERVICO REGISTRAL DE SANTO CRISTO', 101535, 4317905, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3815, 13157, 'TABELIONATO DE SANTO CRISTO', 103713, 4317905, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3816, 5454, 'OFICIO DE REGISTROS ESPECIAIS', 97816, 4318002, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3817, 13158, 'PRIMEIRO TABELIONATO DE NOTAS DE SAO BORJA', 98830, 4318002, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3818, 13159, '2º TABELIONATO DE NOTAS - CARTORIO DORNELLES', 96867, 4318002, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3819, 13160, 'REGISTRO DE IMOVEIS', 99192, 4318002, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3820, 5455, 'SERVICOS NOTARIAIS E DE REGISTROS', 102012, 4318051, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3821, 5456, 'OFICIO DOS REGISTROS PUBLICOS', 98335, 4318101, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3822, 13161, 'TABELIONATO DE SAO FRANCISCO DE ASSIS', 103721, 4318101, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3823, 5721, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 98962, 4318200, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3824, 13865, 'BOA VISTA DO BURICA TABELIONATO', 97097, 4302204, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3825, 13866, 'SERVICOS DE REGISTRO DE IMOVEIS E ESPECIAIS', 101675, 4302303, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3826, 5204, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 98137, 4302303, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3827, 13867, 'TABELIONATO DE BOM JESUS', 102582, 4302303, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3828, 5205, 'TABELIONATO DE NOTAS, DE PROTESTOS, OFICIO DE REGISTRO CIVIL DE PESSOAS JURIDICAS, DE PESSOAS NATURAIS, OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS', 103622, 4302352, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3829, 7108, 'OFICIO DOS REGISTROS PUBLICOS DE BOM RETIRO DO SUL', 98632, 4302402, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3830, 13868, 'TABELIONATO DE NOTAS DE BOM RETIRO DO SUL', 102970, 4302402, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3831, 5206, 'SERVICOS NOTARIAIS E DE REGISTROS', 101964, 4302451, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3832, 13869, 'TABELIONATO DE BOSSOROCA', 102590, 4302501, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3833, 5207, 'OFICIO DOS REGISTROS PUBLICOS', 98418, 4302501, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3834, 5208, 'SERVICOS NOTARIAIS E DE REGISTROS DE BOZANO', 102046, 4302584, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3835, 13870, 'TABELIONATO DE NOTAS MARCHON', 102988, 4302600, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3836, 4510, 'SERVICO DOS REGISTROS PUBLICOS MARCHON', 100321, 4302600, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3837, 5209, 'SERVICO NOTARIAL E REGISTRAL DE BROCHIER', 101196, 4302659, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3838, 5210, 'OFICIO DE REGISTRO DE IMOVEIS E ANEXOS', 97774, 4302709, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3839, 13871, '3º TABELIONATO DE NOTAS', 80507, 4115200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3840, 4553, 'SERVICO DISTRITAL DE FLORIANO', 81000, 4115200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3841, 13872, '2º TABELIONATO DE PROTESTO DE TITULOS', 83857, 4115200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3842, 13873, '1º TABELIONATO DE PROTESTO DE TITULOS', 80051, 4115200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3843, 3751, '1º SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O 5º TABELIONATO DE NOTAS', 79921, 4115200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3844, 13874, '4º TABELIONATO DE NOTAS', 83873, 4115200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3845, 13875, '1º SERVICO DE REGISTRO DE IMOVEIS', 83881, 4115200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3846, 4204, 'CARTORIO DE REGISTRO CIVIL DE NAZARE DA MATA', 74518, 2609501, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3847, 6736, 'SERVICO NOTARIAL E DE REGISTRO DE CAZUZA FERREIRA', 100651, 4318200, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3848, 13162, 'REGISTRO DE IMOVEIS,TITULOS E DOCUMENTOS, REGISTRO CIVIL DAS PESSOAS JURIDICAS E PROTESTO DE TITULOS', 99457, 4318200, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3849, 13163, 'TABELIONATO DE SAO FRANCISCO DE PAULA', 103739, 4318200, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3850, 13164, 'REGISTROS ESPECIAIS DE SAO GABRIEL', 99465, 4318309, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3851, 13165, 'CARTORIO DE REGISTRO DE IMOVEIS', 97253, 4318309, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3852, 5234, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 97196, 4318309, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3853, 13166, '1º TABELIONATO DE NOTAS DE SAO GABRIEL/RS', 96743, 4318309, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3854, 13167, 'SEGUNDO TABELIONATO DE NOTAS', 99671, 4318309, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3855, 5457, 'OFICIO DOS REGISTROS PUBLICOS', 98582, 4318408, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3856, 13168, 'TABELIONATO DE NOTAS DE SAO JERONIMO', 103176, 4318408, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3857, 5653, 'SERVICO NOTARIAL E DE REGISTRO DE QUITERIA', 100800, 4318408, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3858, 7115, 'SERVICO NOTARIAL E REGISTRAL DE SAO JOAO DA URTIGA (INCL. REG. ESP.)', 100818, 4318424, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3859, 7116, 'SERVICO NOTARIAL E DE REGISTRO DE SAO JORGE', 100826, 4318440, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3860, 5331, 'SERVICO NOTARIAL E REGISTRAL DE SAO JOSE DO HERVAL', 101360, 4318465, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3861, 5458, 'SERVICOS NOTARIAIS E DE REGISTROS DE SAO JOSE DO INHACORA', 102194, 4318499, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3862, 13169, 'TABELIONATO DE NOTAS DE SAO JOSE DO NORTE', 103184, 4318507, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3863, 5459, 'OFICIO DOS REGISTROS PUBLICOS', 98566, 4318507, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3864, 5460, 'SERVICO NOTARIAL E REGISTRAL DE BOJURU', 99051, 4318507, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3865, 13170, 'TABELIONATO DE SAO JOSE DO OURO', 103747, 4318606, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3866, 5332, 'SERVICO DOS REGISTROS PUBLICOS', 100271, 4318606, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3867, 13171, '1º TABELIONATO DE NOTAS E REGISTROS ESPECIAIS', 96768, 4318705, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3868, 13172, '3º TABELIONATO DE NOTAS DE SAO LEOPOLDO', 96958, 4318705, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3869, 5654, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 98053, 4318705, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3870, 13173, 'OFICIO DE REGISTRO DE IMOVEIS DE SAO LEOPOLDO', 97766, 4318705, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3871, 13174, '2º TABELIONATO DE NOTAS DE SAO LEOPOLDO', 99713, 4318705, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3872, 5656, 'SERVICO NOTARIAL E REGISTRAL TAQUARAL/BOA VISTA  ', 101444, 4318804, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3873, 5655, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE IMOVEIS', 99846, 4318804, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3874, 13175, 'LURDES INES NARDI  - TABELIONATO DE NOTAS E SERVICO DOS REGISTROS ESPECIAIS', 97576, 4318804, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3875, 5252, 'SERVICOS NOTARIAIS E DE REGISTROS DE VILA DEODORO', 102244, 4322608, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3876, 5254, 'REGISTROS PUBLICOS DE VERA CRUZ', 99549, 4322707, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3877, 13176, 'TABELIONATO DE NOTAS E PROTESTOS', 103416, 4322707, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3878, 5255, 'SERVICO DE REGISTRO DE IMOVEIS E REGISTRO CIVIL', 100040, 4322806, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3879, 13177, 'TABELIONATO DE NOTAS', 102806, 4322806, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3880, 13178, 'REGISTRO CIVIL DAS PESSOAS JURIDICAS E TITULOS E DOCUMENTOS E TABELIONATO DE PROTESTOS', 148007, 4322806, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3881, 7091, 'SERVICO NOTARIAL E DE REGISTRO DE VIADUTOS', 100875, 4322905, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3882, 5685, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 98087, 4323002, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3883, 5256, 'SERVICOS NOTARIAS E REGISTRAIS DE AGUAS CLARAS', 102368, 4323002, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3884, 13179, 'TABELIONATO DE VIAMAO', 103788, 4323002, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3885, 13180, 'REG. DE IMOVEIS , TIT. DOC. E PROTESTOS', 98897, 4323002, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3886, 5258, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE ITAPUA', 100537, 4323002, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3887, 5257, 'SERVICOS NOTARIAS E REGISTRAIS DO PASSO DO SABAO E VIAMOPOLIS', 102376, 4323002, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3888, 13181, 'TABELIONATO DE NOTAS ', 102756, 4323101, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3889, 5462, 'OFICIO DE REGISTROS PUBLICOS', 97857, 4323101, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3890, 13182, 'TABELIONATO DE NOTAS DE VICTOR GRAEFF', 103283, 4323200, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3891, 5259, 'REGISTROS PUBLICOS E TABELIONATO DE PROTESTOS', 99564, 4323200, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3892, 7092, 'SERVICO NOTARIAL E DE REGISTROS', 100925, 4323309, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3893, 5260, 'SERVICOS NOTARIAIS E DE REGISTROS', 101931, 4323408, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3894, 5261, 'SERVICO PUBLICO DELEGADO NOTARIAIS E REGISTRAIS', 101501, 4323457, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3895, 5686, 'ESCRIVANIA DE PAZ DE ABDON BATISTA ', 105916, 4200051, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3896, 13183, 'TABELIONATO DE NOTAS E OFICIO DE PROTESTOS DE TITULOS DA COMARCA DE ABELARDO LUZ', 109124, 4200101, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3897, 5687, 'OFICIO REGISTRO CIVIL, TITULOS E DOCUMENTOS, PESSOAS JURIDICAS', 107961, 4200101, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3898, 13184, 'OFICIO DO REGISTRO DE IMOVEIS', 107870, 4200101, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3899, 5463, 'ESCRIVANIA DE PAZ DE AGROLANDIA', 106047, 4200200, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3900, 5464, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE AGRONOMICA', 106823, 4200309, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3901, 5262, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE AGUA DOCE-SC.', 106831, 4200408, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3902, 5263, 'ESCRIVANIA DE PAZ DE AGUAS DE CHAPECO', 106054, 4200507, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3903, 5465, 'ESCRIVANIA DE PAZ', 104695, 4200556, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3904, 4778, 'ESCRIVANIA DE PAZ DE AGUAS MORNAS', 105569, 4200606, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3905, 5466, 'CARTORIO REGISTRO CIVIL E TABELIONATO', 105643, 4200705, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3906, 7118, 'CARTORIO DE PAZ DE ALFREDO WAGNER', 105015, 4200705, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3907, 5467, 'ALTO BELA VISTA CARTORIO DE PAZ', 104703, 4200754, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3908, 13185, 'ANCHIETA CARTORIO DE OFICIO DE IMOVEIS', 104711, 4200804, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3909, 5468, 'ANCHIETA CARTORIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 104737, 4200804, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3910, 13186, 'ANCHIETA CARTORIO DE OFICIO DE NOTAS', 104729, 4200804, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3911, 7119, 'ESCRIVANIA DE PAZ DE BARRA CLARA', 108167, 4200903, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3912, 5469, 'ESCRIVANIA DE PAZ DE ANGELINA', 107755, 4200903, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3913, 13187, 'SAO LUIZ GONZAGA CARTORIO DE REGISTRO DE IMOVEIS', 99614, 4318903, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3914, 13188, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS DESDE DEZEMBRO/2007', 103382, 4318903, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3915, 5235, 'SERVICO DO REGISTRO CIVIL E REGISTROS ESPECIAIS DE SAO LUIZ GONZAGA - RS', 100214, 4318903, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3916, 5657, 'OFICIO DOS REGISTROS PUBLICOS DE SAO MARCOS', 98699, 4319000, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3917, 4126, 'CARTORIO REGISTRO CIVIL DO UNICO OFICIO DE PESQUEIRO', 68015, 1507904, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3918, 3421, 'CARTORIO DO 2º OFICIO DO EXTRAJUDICIAL DA COMARCA DE SOURE', 66829, 1507904, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3919, 9913, 'CARTORIO DE 1º OFICIO DE NOTAS ', 65987, 1507904, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3920, 4127, 'SERVICO NOTARIAL E REGISTRAL S. NEGRAO - UNICO OFICIO', 68510, 1507953, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3921, 4128, 'CARTORIO DE VILA DE VISTA ALEGRE', 66639, 1507961, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3922, 3422, 'CARTORIO REGISTRO DE TERRA ALTA', 68056, 1507961, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3923, 3423, 'CARTORIO DO UNICO OFICIO DE TERRA SANTA', 67439, 1507979, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3924, 3424, 'UNICO OFICIO DA COMARCA DE TOME-ACU', 68601, 1508001, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3925, 3426, 'CARTORIO UNICO OFICIO DE TRACUATEUA', 68353, 1508035, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3926, 3425, 'CARTORIODE REGISTRO CIVIL DE VILA DE FATIMA - TRACUATEUA', 66613, 1508035, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3927, 7013, 'CARTORIO DO 1º OFICIO', 66688, 1508050, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3928, 3427, 'CARTORIO DO UNICO OFICIO EXTRAJUDICIAL', 67520, 1508084, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3929, 3428, 'TABELIONATO ANTONIO OSCAR DEMETRIO', 68551, 1508100, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3930, 9914, '1º TABELIONATO DE NOTAS E REGISTRO DE IMOVEL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 65607, 1508100, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3931, 3429, 'CARTORIO EXTRAJUDICIAL DO UNICO OFICIO', 67637, 1508126, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3932, 3430, 'CARTORIO RODRIGUES DAL PONTE', 68114, 1508159, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3933, 9915, 'CARTORIO DO 2º OFICIO DO MUNICIPIO E COMARCA DE VIGIA/PA - TN, RI, RTDPJ', 66753, 1508209, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3934, 3435, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE PENHALONGA', 149153, 1508209, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3935, 3436, 'CARTORIO DE REGISTRO CIVIL DE SANTA ROSA', 66886, 1508209, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3936, 3434, 'CARTORIO VILHENA DO 1º OFICIO - VIGIA', 67983, 1508209, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3937, 3433, 'CARTORIO DO UNICO OFICIO DE PORTO SALVO', 67322, 1508209, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3938, 3437, 'OFICIO DO REGISTRO CIVIL,REGISTRO DE IMOVEIS E TABELIONATO DE NOTAS', 68429, 1508308, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3939, 3440, 'CARTORIO DO UNICO OFICIO DE SAO JOSE DO PIRIA - VISEU', 67397, 1508308, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3940, 3439, 'CARTORIO DA VILA SAO JOSE DO GURUPI - VISEU', 65953, 1508308, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3941, 3438, 'CARTORIO SANTANA', 68148, 1508308, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3942, 9916, 'CARTORIO DO REGISTRO CIVIL E PESSOAS NATURAIS', 71225, 2514008, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3943, 9917, 'CARTORIO DE DISTRIBUICAO EXTRAJUDICIAL', 69484, 2514008, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3944, 9918, 'SAO JOAO DO RIO DO PEIXE-CARTORIO DO 1º OFICIO ', 72645, 2500700, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3945, 3269, 'CARTORIO MARIA DO SOCORRO GOMES ALMEIDA ', 71647, 2500700, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3946, 9919, '2º CARTORIO DE PROTESTOS', 68791, 2500700, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3947, 3975, 'CARTORIO DO REGISTRO CIVIL', 70581, 2500700, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3948, 9920, 'CARTORIO DE DISTRIBUICAO EXTRA JUDICIAL', 69450, 2500700, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3949, 3270, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE BANDARRA', 71035, 2500700, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3950, 3976, 'CARTORIO DO REGISTRO CIVIL', 70664, 2514107, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3951, 3977, 'CARTORIO DE REGISTRO CIVIL', 69641, 2514206, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3952, 9921, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 72876, 2514305, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3953, 3978, 'CARTORIO UNICO LUCENA', 71928, 2514404, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3954, 3979, 'CARTORIO DE REGISTRO CIVIL ', 69716, 2514503, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3955, 6659, 'CARTORIO DISTRITAL DE BOM JESUS', 70235, 2514503, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3956, 9922, 'SEGUNDO SERVICO NOTARIAL E REGISTRAL', 72660, 2514503, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3957, 9923, 'SERVICO REGISTRAL DE DISTRIBUICAO EXTRA JUDICIAL ALICE', 73163, 2514503, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3958, 9924, '1º SERVICO NOTARIAL E REGISTRAL - ZUZA HOLANDA', 68726, 2514503, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3959, 9925, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 69872, 2514552, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3960, 4166, 'SERVICO REGISTRAL AFONSO MEDEIROS', 73098, 2514602, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3961, 4167, 'CARTORIO DE REGISTRO CIVIL DE SAO JOSE DO BREJO DO CRUZ', 69856, 2514651, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3962, 3980, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 70763, 2514701, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3963, 4168, 'CARTORIO DE REGISTRO DE SAO JOSE DOS CORDEIROS', 70102, 2514800, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3964, 4169, 'CARTORIO DEBORA GINDRE CAXIAS ', 70144, 2514453, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3965, 3981, 'CARTIRIO DE REGISTRO CIVIL E NOTAS DE SAO MAMEDE-PB', 69104, 2514909, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3966, 3420, 'CARTORIO ISMAR SILVA', 67769, 1507805, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3967, 9926, 'CARTORIO DE DISTRIBUICAO EXTRA JUDICIAL', 69427, 2514909, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3968, 9927, 'SERVICO NOTARIAL E REGISTRAL KILMA MORAIS', 73049, 2514909, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3969, 3982, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO FALCAO', 71241, 2515005, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3970, 4170, 'OFICIO DO REGISTRO CIVIL E NOTAS', 72439, 2515104, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3971, 4171, 'CARTORIO DO REGISTRO CIVIL DE SAO SEBASTIAO DO UMBUZEIRO', 70961, 2515203, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3972, 4172, 'SERVICO REGISTRAL ALFREDO COUTINHO', 73114, 2515302, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3973, 9928, 'CARTORIO FELICIANO DA SILVA', 71456, 2515302, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3974, 9929, 'CARTORIO DE DISTRIBUICAO EXTRA JUDICIAL', 69468, 2515302, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3975, 3985, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO MUNICIPIO DE SAO VICENTE DO SERIDO ', 145359, 2515401, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3976, 3984, 'CARTORIO JOSE MEIRA DE VASCONCELOS', 71589, 2515401, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3977, 6660, 'CARTORIO COSTA BRITO', 69328, 2515500, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3978, 9930, 'CARTORIO NOTARIAL E REGISTRAL DA COMARCA DE SERRA BRANCA/PB', 71670, 2515500, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3979, 4174, 'CARTORIO DO REGISTRO CIVIL DE SUCURU', 70995, 2515500, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3980, 3279, 'CARTORIO DE REGISTRO CIVIL, OBITO E CASAMENTO', 74724, 2610608, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3981, 9931, 'CARTORIO 2º OFICIO DE PAUDALHO', 73940, 2610608, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3982, 9932, '1º OFICIO DO REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E PESSOA JURIDICA DE PAUDALHO/PE', 73544, 2610608, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3983, 9933, 'SERVICO NOTARIAL E REGISTRAL-2 OFICIO', 77644, 2610707, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3984, 9934, 'CARTORIO DE REGISTRO CIVIL E PESSOAS NATURAIS 2º DISTRITO DE PARATIBE', 148254, 2610707, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3985, 9935, 'SERVICO NOTARIAL E REGISTRAL 1º OFICIO', 77552, 2610707, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3986, 3280, 'REGISTRO CIVIL DE PRAIA DA CONCEICAO', 77446, 2610707, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3987, 3281, 'CARTORIO DE REGISTRO CIVIL', 74104, 2610707, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3988, 6538, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 74260, 2610707, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3989, 3282, 'CARTORIO DO RGISTRO CIVIL DA VILA DE SANTO ANTONIO', 76364, 2610806, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3990, 9936, 'CARTORIO UNICO: TABELIONATO DE NOTAS E PROTESTO DE TITULOS, REGISTRO DE IMOVEIS E ANEXOS', 77040, 2610806, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3991, 3284, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75457, 2610806, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3992, 3283, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 75937, 2610806, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3993, 3287, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE CIMBRES', 76059, 2610905, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3994, 9937, 'CARTORIO 1º OFICIO', 150813, 2610905, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3995, 3286, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE MIMOSO', 75127, 2610905, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3996, 6667, 'CARTORIO DO REGISTRO CIVIL DE PAPAGAIO', 75903, 2610905, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3997, 3285, 'CARTORIO DO REGISTRO CIVIL', 75226, 2610905, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3998, 3288, 'MARIA DA CONCEICAO SILVA GALVAO', 77149, 2610905, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (3999, 9938, 'CARTORIO 2º OFICIO DE NOTAS E PROTESTO', 73924, 2610905, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4000, 3289, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS PETROLANDIA', 74351, 2611002, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4001, 9939, 'SERVICO NOTARIAL E REGISTRAL DE PETROLANDIA-PE', 77610, 2611002, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4002, 3291, 'CARTORIO REGISTRO CIVIL DE PESSOAS NATURAIS', 150755, 2611101, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4003, 3292, 'CARTORIO TAVARES', 76745, 2611101, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4004, 3290, 'CARTORIO DE REGISTRO CIVIL', 74096, 2611101, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4005, 9940, 'CARTORIO 1 OFICIO TN, RE, TITULOS E DOC.', 152348, 2611101, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4006, 3293, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 74450, 2611101, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4007, 7286, 'CARTORIO REGISTRO CIVIL DE PESSOAS NATURAIS - RAJADA', 150763, 2611101, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4008, 9941, 'CARTORIO DO 2º OFICIO DE NOTAS TITULOS E PROTESTO DA COMARCA DE PETROLINA', 74922, 2611101, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4009, 3294, 'CARTORIO REGITRO CIVIL DE POCAO', 130484, 2611200, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4010, 9942, 'CARTORIO UNICO POCAO-PE', 150805, 2611200, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4011, 3295, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE POMBOS E TABELIIONAMENTO', 74336, 2611309, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4012, 6668, 'CARTORIO DE REGISTRO CIVIL E DE TABELIONATO DE NOTAS DE PRIMAVERA', 74583, 2611408, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4013, 3296, 'CARTORIO DE REGISTRO CIVIL DA SEDE DA COMARCA DE QUIPAPA - PE', 74237, 2611507, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4014, 9943, 'CARTORIO UNICO DE QUIPAPA', 76943, 2611507, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4015, 3297, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 74633, 2611533, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4016, 9944, 'SETIMO TABELIONATO DE NOTAS DO RECIFE', 77719, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4017, 3310, 'CARTORIO DO 3º DISTRITO JUDICIARIO', 74971, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4018, 9945, '3 TABELIONATO DE NOTAS', 73692, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4019, 6669, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO 9º DISTRITO JUDICIARIO DA CAPITAL', 135434, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4020, 3306, 'OITAVO SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 77503, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4021, 9946, 'RECIFE CARTORIO DO 6º OFICIO DE NOTAS', 77248, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4022, 3305, 'CARTORIO 13º DISTRITO JUDICIARIO', 73890, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4023, 3303, 'CARTORIO DE REGISTRO CIVIL DO 15º DISTRITO DA CAPITAL/RECIFE/PE', 74617, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4024, 9947, '3º OFICIO DE REGISTRO DE IMOVEIS DA COMARCA DO RECIFE', 73700, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4025, 9948, '8º OFICIO DE NOTAS DO RECIFE', 73783, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4026, 9949, 'CARTORIO DE PROTESTO DO 1º OFICIO', 74070, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4027, 3300, 'CARTORIO DE REGISTRO CIVIL DE 12 DISTRITO JUDICIARIO DA CAPITAL', 74369, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4028, 9950, 'CARTORIO DO 2º OFICIO DE NOTAS DA CAPITAL', 74906, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4029, 3298, 'CARTORIO DE REGISTRO CIVIL DA 7ª ZONA JUDICIARIA', 74203, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4030, 3307, 'CARTORIO DO 6º DISTRITO JUDICIARIO', 74997, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4031, 3302, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 5º DISTRITO JUDICIARIO', 74344, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4032, 9951, '2º CARTORIO DE REGISTRO DE TITULOS, DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DA CAPITAL', 73635, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4033, 9952, '1º OFICIO DE NOTAS DO RECIFE', 73510, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4034, 9953, 'CARTORIO DE NOTAS DO 5º OFICIO DA CAPITAL', 74005, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4035, 9954, '4º TABELIONATO DE NOTAS DA CAPITAL', 73767, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4036, 3311, '10º DISTRITO JUDICIARIO', 73478, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4037, 9955, '4º REGISTRO DE IMOVEIS DA CAPITAL', 73742, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4038, 9956, 'SERVICO REGISTRAL DE PROTESTOS 2º OFICIO-RECIFE-PE', 77677, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4039, 3304, 'CARTORIO DO 11º DISTRITO', 74799, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4040, 3299, 'CARTORIO DO REG CIVIL DA CAPITAL 4O DIST BOA VISTA', 75101, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4041, 9957, '1° SERVICO DE REGISTRO DE IMOVEIS DO RECIFE', 73494, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4042, 3301, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO 14º DISTRITO JUDICIARIO', 76240, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4043, 9958, '1 REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DE PESSOAS JURIDICAS DA COMARCA DO RECIFE', 73460, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4044, 3308, 'CARTORIO DO REGISTRO CIVIL DE SANTO ANTONIO', 76018, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4045, 9959, '2° OFICIO DE REGISTRO DE IMOVEIS DO RECIFE', 73601, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4046, 3309, 'CARTORIO PRIMEIRO DISTRITO DA CAPITAL', 76562, 2611606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4047, 3312, 'CARTORIO DE REGISTRO CIVIL DE COURO D ANTAS TABELIONATO DISTRITAL DE NOTAS', 74443, 2611705, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4048, 9960, 'CARTORIO DO OFICIO UNICO DE RIACHO DAS ALMAS', 75069, 2611705, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4049, 9961, 'CARTORIO DE REG. CIVIL 2O DISTRITO - TRAPIA', 150078, 2611705, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4050, 3313, 'CARTORIO DO REGISTRO CIVIL DO 1º DISTRITO SEDE', 148817, 2611705, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4051, 9962, 'CARTORIO OFICIO UNICO RIBEIRAO PE', 73791, 2611804, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4052, 3314, 'CARTORIO DO REGISTRO CIVIL DE RIBEIRAO-PE', 75994, 2611804, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4053, 3315, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS CUCAU', 144816, 2611903, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4054, 6670, 'CARTORIO REGISTRO CIVIL PESSOAS NATURAIS DE RIO FORMOSO', 76711, 2611903, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4055, 9963, 'CARORIO UNICO DE NOTAS E REGISTROS', 73833, 2611903, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4056, 3316, 'SAIRE CARTORIO DO REGISTRO CIVIL E NOTAS', 77487, 2612000, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4057, 3317, 'CARTORIO UNICO DE SALGADINHO', 76950, 2612109, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4058, 9964, 'CARTORIO 1º OFICIO', 73908, 2612208, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4059, 3320, 'CARTORIO REGISTRO CIVIL DE CONCEICAO DAS CRIOULAS - 2º DISTRITO DE SALGUEIRO-PE', 76646, 2612208, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4060, 3319, 'CARTORIO REGISTRO CIVIL', 76588, 2612208, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4061, 9965, '2º TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 73668, 2612208, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4062, 3318, 'CARTORIO DE REGISTRO CIVIL DE VASQUES', 74609, 2612208, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4063, 9966, 'CARTORIO DE REGISTRO CIVIL E ANEXOS DAS PESSOAS NATURAIS DO DISTRITO DE IATECA ', 150037, 2612307, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4064, 3321, 'REGISTRO CIVIL DAS PESSOAS NATURAIS/SEDE/SALOA-PE', 77396, 2612307, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4065, 9967, 'CARTORIO DE OFICIO UNICO', 74062, 2612307, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4066, 9968, 'CARTORIO UNICO DE NOTAS DE SANHARO', 76877, 2612406, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4067, 9969, 'CARTORIO ARRUDA', 130559, 2612505, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4068, 3322, 'CARTORIO DO REGISTRO CIVIL DE SANHARO', 76000, 2612406, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4069, 3323, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 76117, 2612455, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4070, 6671, 'CARTORIO DO REGISTRO CIVIL E NOTAS SANTA CRUZ DA BAIXA VERDE', 76141, 2612471, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4071, 3325, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAS', 75788, 2612505, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4072, 3324, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 77305, 2612505, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4073, 9970, '07.578-8 ', 131201, 2612505, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4074, 3326, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75580, 2612554, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4075, 3327, 'CARTORIO MARIA DO CARMO ALVES', 76539, 2612604, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4076, 9971, 'CARTORIO DO UNICO OFICIO', 76414, 2612604, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4077, 3328, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO', 75754, 2612703, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4078, 3330, 'CARTORIO DO REGISTRO CIVIL ANEXOS DE NOTAS', 75374, 2612802, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4079, 3329, 'CARTORIO DO REGISTRO CIVIL E ANEXOS DE NOTAS', 76091, 2612802, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4080, 3331, 'CARTORIO DO REGISTRO CIVIL', 75192, 2612901, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4081, 9972, 'CARTORIO JOAO MOTA 1° OFICIO', 150631, 2613008, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4082, 9973, 'CARTORIO 2º OFICIO DE NOTAS E PROTESTOS DE SAO BENTO DO UNA-PE', 73932, 2613008, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4083, 3332, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 77313, 2613008, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4084, 3333, 'CARTORIO DO REGISTRO CIVIL', 75317, 2613107, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4085, 9974, 'CARTORIO UNICO DE SAO CAETANO', 76968, 2613107, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4086, 9975, 'CARTORIO DO UNICO OFICIO', 76430, 2613206, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4087, 6539, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE SAO JOAO -PE', 75564, 2613206, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4088, 9976, 'CARTORIO UNICO', 150953, 2613305, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4089, 3334, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75465, 2613305, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4090, 4925, 'CARTORIO DO RCPN DAS PESSOAS NATURAIS E TABELIONATO DO 3º DISTRITO DE ITABORAI', 91157, 3301900, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4091, 4927, 'CARTORIO DO 4º RCPN E TABELIONATO', 90738, 3301900, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4092, 13292, 'ITABORAI CARTORIO DO PRIMEIRO OFICIO', 92064, 3301900, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4093, 13293, 'CARTORIO DO 1º OFICIO DE JUSTICA', 90274, 3302007, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4094, 13294, 'DISTRIBUIDOR, CONTADOR E PARTIDOR DE ITAGUAI', 91942, 3302007, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4095, 13295, 'CARTORIO 2° OFICIO DE JUSTICA DE ITAGUAI', 89615, 3302007, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4096, 13296, 'TERCEIRO OFICIO DE JUSTICA', 93690, 3302007, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4097, 6555, 'RCPN 1º DISTRITO DE ITAGUAI, RJ', 92569, 3302007, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4098, 13297, 'DISTRIBUIDOR, CONTADOR E PARTIDOR ', 91736, 3302056, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4099, 4928, 'CARTORIO DO OFICIO UNICO DE ITALVA', 91058, 3302056, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4100, 13298, 'DISTRIBUIDOR, CONTADOR E PARTIDOR', 91884, 3302106, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4101, 4929, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 91405, 3302106, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4102, 13299, 'CARTORIO 1º OFICIO DE NOTAS E REGISTROS DE ITAOCARA', 89581, 3302106, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4103, 13300, 'CARTORIO DO 2° OFICIO DE ITAOCARA', 90381, 3302106, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4104, 4931, 'CARTORIO DO RCPN DO 1º DISTRITO DE ITAPERUNA', 91199, 3302205, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4105, 13301, 'CARTORIO DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE ITAPERUNA', 89979, 3302205, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4106, 4930, 'RCPN DO 4º DISTRITO DE ITAPERUNA - RJ', 92874, 3302205, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4107, 13302, 'CARTORIO DO 3º OFICIO', 90605, 3302205, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4108, 13303, 'CARTORIO DO 1º OFICIO ', 90217, 3302205, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4109, 13304, 'CARTORIO DO 2º OFICIO DE JUSTICA DE ITAPERUNA - RJ', 90514, 3302205, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4110, 13305, 'DISTRIBUIDOR, CONTADOR, PARTIDOR E PROGER', 92015, 3302254, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4111, 6556, 'OFICIO UNICO DO MUNICIPIO DE ITATIAIA', 92288, 3302254, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4112, 13306, 'DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE JAPERI', 91926, 3302270, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4113, 7218, 'OFICIO UNICO DE JAPERI', 88518, 3302270, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4114, 13307, 'CARTORIO DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE LAJE DO MURIAE/RJ', 89987, 3302304, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4115, 4933, 'CARTORIO OFICIO UNICO DE LAJE DO MURIAE', 91520, 3302304, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4116, 13308, 'CARTORIO DO SEGUNDO OFICIO DE MACAE', 91512, 3302403, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4117, 13309, 'CARTORIO DISTRIBUIDOR CONTADOR E PARTIDOR', 89896, 3302403, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4118, 13310, '3° OFICIO DE JUSTICA DE MACAE', 89094, 3302403, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4119, 13311, '1º OFICIO DE JUSTICA DE MACAE', 88815, 3302403, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4120, 4935, 'RCPN DO 1º DISTRITO DE MACAE', 92809, 3302403, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4121, 4936, 'RCPN 2° DISTRITO MACAE, RJ (CARTORIO BARRA DE MACAE)', 92619, 3302403, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4122, 4934, 'MACAE CARTORIO DE RCPN E NOTAS DO 5 DISTRITO', 92072, 3302403, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4123, 7220, 'OFICIO UNICO DE MACUCO', 148106, 3302452, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4124, 5067, 'CARTORIO UNICO DE NOTAS DO TERMO DE EQUADOR/RN', 94433, 2403400, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4125, 4701, 'CARTORIO DE REGISTRO DE PESSOAS NATURAIS E REGISTRO DE IMOVEIS', 94102, 2403608, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4126, 5069, 'CARTORIO UNICO DE FELIPE GUERRA', 94375, 2403707, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4127, 6586, 'OFICIO UNICO DE FERNANDO PEDROZA', 95034, 2403756, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4128, 13312, 'CARTORIO UNICO - TERMO DE TENENTE LAURENTINO CRUZ', 131144, 2403806, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4129, 5070, 'OFICIO UNICO DE NOTAS', 95083, 2403806, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4130, 5071, 'CARTORIO UNICO JUDICIARIO DE FRANCISCO DANTAS', 94748, 2403905, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4131, 5072, 'OFICIO UNICO DO TERMO DE FRUTUOSO GOMES', 95224, 2404002, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4132, 6587, 'SERVICO UNICO NOTARIAL E REGISTRAL', 95521, 2404101, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4133, 5073, '2º OFICIO DE NOTAS DE GOIANINHA', 93930, 2404200, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4134, 13313, 'CARTORIO DO 1º OFICIO DE NOTAS DE GOIANINHA-RN', 94151, 2404200, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4135, 5074, 'CARTORIO UNICO DE GOV. DIX-SEPT ROSADO - RN', 94383, 2404309, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4136, 5075, 'GROSSOS UNICO OFICIO DE NOTAS', 94870, 2404408, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4137, 6588, 'UNICO OFICIO DE NOTAS', 95612, 2404507, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4138, 13314, 'CARTORIO UNICO', 131177, 2404804, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4139, 5076, 'CARTORIO UNICO JUDICIARIO', 94615, 2404606, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4140, 5077, 'CARTORIO UNICO DE IPANGUACU', 94268, 2404705, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4141, 5078, 'ITAU CARTORIO UNICO ', 94888, 2404903, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4142, 6589, 'CARTORIO UNICO JUDICIARIO', 94664, 2405009, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4143, 5079, 'OFICIO UNICO DE JANDAIRA', 95042, 2405108, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4144, 5080, 'JANDUIS CARTORIO SEGUNDO DE REGISTRO CIVIL E OFICIO DE NOTAS', 94896, 2405207, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4145, 5081, 'CARTORIO UNICO JUDICIARIO DE JAPI', 94755, 2405405, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4146, 6590, 'OFICIO UNICO DE JARDIM DE ANGICOS', 95059, 2405504, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4147, 5082, 'CARTORIO DO OFICIO UNICO', 94169, 2405603, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4148, 5083, 'UNICO OFICIO DE NOTAS DA COMARCA DE JARDIM DO SERIDO/RN', 95638, 2405702, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4149, 5084, 'CARTORIO DO SEGUNDO OFICIO DE NOTAS DE JOAO CAMARA/RN', 94201, 2405801, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4150, 13315, '1º OFICIO DE NOTAS DE JOAO CAMARA', 93799, 2405801, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4151, 6591, 'CARTORIO UNICO JUDICIARIO', 94631, 2405900, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4152, 5085, 'OFICIO UNICO DE NOTAS DE JOSE DA PENHA', 95133, 2406007, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4153, 13316, 'CARTORIO DO PRIMEIRO OFICIO', 94177, 2406106, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4154, 13317, '2° TABELIONATO DE NOTAS E OFICIO DO REGISTRO CIVIL', 93856, 2406106, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4155, 5086, 'OFICIO UNICO DE LAGOA D ANTA', 95067, 2406205, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4156, 5087, 'CARTORIO UNICO JUDICIARIO DE LAGOA DE PEDRAS', 94763, 2406304, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4157, 4702, 'CARTORIO UNICO DE LAGOA DE VELHOS', 94409, 2406403, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4158, 13318, 'OFICIO UNICO LAGOA NOVA', 95257, 2406502, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4159, 4703, 'SERVICO UNICO  NOTARIAL E REGISTRAL DE LAGOA SALGADA', 95463, 2406601, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4160, 4704, 'CARTORIO UNICO DE LAJES', 94417, 2406700, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4161, 6592, 'CARTORIO UNICO JUDICIARIO', 94862, 2406809, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4162, 4705, 'OFICIO UNICO DO TERMO DE LUCRECIA', 95232, 2406908, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4163, 6593, 'SERVICO NOTARIAL E REGISTRAL DE LUIS GOMES', 703, 2407005, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4164, 3737, '4º SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E 16º TABELIONATO DE NOTAS', 129759, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4165, 3625, 'SERVICO DISTRITAL DO PORTAO', 83170, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4166, 13319, '3º TABELIONATO DE PROTESTO DE TITULOS ', 80531, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4167, 13320, '2º SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 80242, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4168, 13321, '3º TABELIONATO DE NOTAS', 80515, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4169, 13322, '9º SERVICO DE REGISTRO DE IMOVEIS ', 80648, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4170, 13323, '9º TABELIONATO DE NOTAS ', 83972, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4171, 4259, 'SERVICO DISTRITAL DO BOQUEIRAO', 85746, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4172, 13324, '2º TABELIONATO DE NOTAS ', 144527, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4173, 13325, '5º SERVICO DE REGISTRO DE IMOVEIS', 80572, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4174, 13326, '1° SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 79822, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4175, 13327, '7º SERVICO DE REGISTRO DE IMOVEIS ', 75, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4176, 3735, 'SERVICO DISTRITAL DO CAMPO COMPRIDO', 83295, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4177, 13328, '7º  TABELIONATO DE NOTAS', 83279, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4178, 4253, 'SERVICO DISTRITAL DE SANTA QUITERIA', 129742, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4179, 13329, '12º TABELIONATO DE NOTAS DE CURITIBA', 83196, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4180, 13330, '4º SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 83220, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4181, 13331, '1º SERVICO DE REGISTRO DE IMOVEIS', 83253, 4106902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4182, 13332, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 87668, 4107009, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4183, 4260, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84962, 4107009, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4184, 13333, 'SERVICO DE REGISTRO IMOVEIS', 82958, 4107009, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4185, 7319, 'SERVICO DISTRITAL DE DIAMANTE DO OESTE', 141721, 4107157, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4186, 4261, 'CARTORIO REGISTRO CIVIL E TABELIONATO DE NOTAS', 82883, 4107108, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4187, 4262, 'SERVICO DISTRITAL DE DIAMANTE DO SUL ', 82065, 4107124, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4188, 4615, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 83352, 4107207, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4189, 13334, 'SERVICO DE REGISTRO DE IMOVEIS', 83378, 4107207, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4190, 13335, 'TABELIONATO DE NOTAS ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE DOIS VIZINHOS', 83360, 4107207, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4191, 4263, 'SERVICO DISTRITAL DE DOURADINA', 82909, 4107256, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4192, 4264, 'SERVICO DISTRITAL DE DOUTOR CAMARGO', 82784, 4107306, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4193, 4616, 'SERVICO DISTRITAL DE DOUTOR ULYSSES', 86256, 4128633, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4194, 4617, 'SERVICO DISTRITAL DE ENEAS MARQUES', 83386, 4107405, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4195, 4265, 'SERVICO DISTRITAL DE IVAILANDIA ', 86520, 4107504, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4196, 13336, 'TABELIONATO DE NOTAS,ACUMULANDO,PRECARIAMENTE, TABELIONATO DE PROTESTO DE TITULOS', 87809, 4107504, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4280, 9740, 'CARTORIO PRIMEIRO OFICIO DE NOTAS CAETE', 40675, 3110004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4197, 4267, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 153325, 4107504, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4198, 4268, 'SERVICO DISTRITAL DE SERTAOZINHO', 86405, 4107504, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4199, 4397, 'SERVICO  DISTRITAL DE PRANCHITA', 88005, 4120358, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4200, 7300, 'SERVICO DISTRITAL DE PRESIDENTE CASTELO BRANCO', 81588, 4120408, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4201, 4398, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO PRECARIAMENTE O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIS  DAS PESSOAS JURIDICAS', 82636, 4120507, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4202, 13337, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 84558, 4120507, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4203, 13338, 'SERVICO DE REGISTRO DE IMOVEIS', 84541, 4120507, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4204, 4399, 'SERVICO DISTRITAL DE PATOS VELHOS', 86330, 4120606, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4205, 4400, 'SERVICO DISTRITAL DE JACIABA', 144873, 4120606, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4206, 2463, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51862, 3110400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4207, 4401, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81331, 4120606, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4208, 13339, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87585, 4120606, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4209, 13340, 'SERVICO DE REGISTRO DE IMOVEIS', 84624, 4120606, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4210, 4402, 'REGISTRO CIVIL E TABELIONATO MOLEIRO', 84897, 4120655, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4211, 4403, 'SERVICO DISTRITAL DE QUATIGUA', 85878, 4120705, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4212, 4404, 'SERVICO DISTRITAL DE BORDA DO CAMPO', 83287, 4120804, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4213, 4405, 'SERVICO DISTRITAL DE QUATRO BARRAS', 82354, 4120804, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4214, 4406, 'SERVICO DISTRITAL DE QUATRO PONTES', 129965, 4120853, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4215, 4407, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84152, 4120903, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4216, 13341, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87577, 4120903, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4217, 13342, 'SERVICO DE REGISTRO DE IMOVEIS', 81943, 4120903, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4218, 4408, 'SERVICO DISTRITAL DE QUERENCIA DO NORTE', 81448, 4121000, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4219, 4409, 'SERVICO DISTRITAL DE QUINTA DO SOL ', 130526, 4121109, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4220, 4411, 'SERVICO DISTRITAL DE QUITANDINHA', 86363, 4121208, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4221, 4410, 'SERVICO DISTRITAL DE LAGOA VERDE', 82271, 4121208, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4222, 4412, 'SERVICO DISTRITAL DE RAMILANDIA', 82362, 4121257, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4223, 4413, 'SERVICO DISTRITAL DE RANCHO ALEGRE', 86371, 4121307, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4224, 4414, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO PELOI', 81646, 4121356, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4225, 13343, 'TABELIONATO DE NOTAS, ACUMULANDO PRECARIAMENTE O  TABELIONATO DE PROTESTO DE TITULOS', 85787, 4121406, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4226, 3617, 'CARTORIO JOAO ELOI BEZERRA - 2º OFICIO', 79277, 2208205, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4227, 3618, 'CARTORIO DO 2º OFICIO DE NOTAS DE PIRACURUCA', 78865, 2208304, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4228, 10065, 'CARTORIO CARVALHO', 78048, 2208304, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4229, 10066, '1º CARTORIO DO REGISTRO DE IMOVEIS E NOTAS E ANEXO', 140814, 2208403, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4230, 4646, 'CARTORIO DO 2º OFICIO', 78758, 2208502, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4231, 3619, 'CARTORIO ZE BATISTA', 79491, 2208601, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4232, 3620, 'CARTORIO UNICO', 149617, 2208700, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4233, 4647, 'CARTORIO DO REGISTRO CIVIL', 79103, 2208809, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4234, 10067, '2º CARTORIO DE REGISTRO CIVIL', 140665, 2208908, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4235, 10068, 'CARTORIO DO 1º OFICIO', 78113, 2208908, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4236, 10069, 'CARTORIO UNICO', 140798, 2209005, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4237, 7276, '1º CARTORIO DE REGISTRO DE IMOVEIS', 140822, 2209104, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4238, 4648, 'CARTORIO UNIFO OFICIO', 79517, 2209203, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4239, 4649, 'CARTORIO UNICO DE SANTA LUZ', 79426, 2209302, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4240, 10070, 'CARTORIO UNICO', 140657, 2209401, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4241, 3707, 'CARTORIO UNICO DO REGISTRO GERAL', 79459, 2209500, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4242, 10071, 'CARTORIO UNICO DE SAO FELIX DO PIAUI', 149211, 2209609, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4243, 10072, 'CARTORIO UNICO DE PRATA DO PIAUI', 140673, 2209609, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4244, 10073, 'CARTORIO UNICO', 140541, 2209658, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4245, 4650, 'CARTORIO DE OFICIO UNICO DE NOTAS E RG DE IMOVEIS DE SAO FRANCISCO DO PIAUI', 78063, 2209708, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4246, 4651, 'CARTORIO UNICO DE SAO GONCALO', 78899, 2209807, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4247, 4652, 'CARTORIO UNICO DO TERMO JUDICIARIO DE SAO JOAO DA SERRA', 79475, 2209906, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4248, 4653, 'CARTORIO DO 2º OFICIO', 78592, 2210003, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4249, 10074, 'CARTORIO DO 1º OFICIO', 78188, 2210003, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4250, 10075, 'CARTORIO UNICO', 140616, 2210102, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4251, 4654, 'CARTORIO UNICO DE REGISTRO CIVIL E DE IMOVEIS', 448, 2210201, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4252, 3708, 'SAO JULIAO CARTORIO UNICO REGISTRO IMOVEIS', 79616, 2210300, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4253, 4655, '1º CARTORIO DE REGISTRO DE IMOVEIS', 140707, 2210409, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4254, 2510, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DO DISTRITO DE SANTA EFIGENIA', 38323, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4255, 2511, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO JOAO DO JACUTINGA', 38240, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4256, 2504, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DO DISTRITO DO SANTO ANTONIO DO MANHUACU, MUNICIPIO DE CARATINGA-MG', 38349, 3113404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4257, 2512, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CARBONITA', 42325, 3113503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4258, 1895, 'OFICIO DO REGISTRO CIVIL E NOTAS DE CAREACU', 55020, 3113602, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4259, 2513, 'TABELIONATO DE NOTAS', 60020, 3113701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4260, 9728, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54353, 3113701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4261, 2023, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 47027, 3113701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4262, 9729, '1º TABELIONATO DE NOTAS', 32219, 3113701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4263, 9730, 'CARTORIO REGISTRO DE IMOVEIS', 44982, 3113701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4264, 9731, 'TABELIONATO DO 2º OFICIO DE NOTAS', 61184, 3113701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4265, 2022, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50419, 3113701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4266, 9732, 'OFICIO DO TABELIONATO DE PROTESTO DE TITULOS', 55566, 3113701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4267, 2024, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 56952, 3113800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4268, 2025, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CARMO DA CACHOEIRA', 32847, 3113909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4269, 9733, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48025, 3114006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4270, 9734, 'OFICIO DO 1.º TABELIONATO DE PROTESTOS DE TITULOS', 47415, 3114006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4271, 9735, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49478, 3114006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4272, 9736, 'OFICIO DE REGISTRO DE IMOVEIS', 47183, 3114006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4273, 2026, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 46524, 3114006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4274, 2455, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53033, 3110004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4275, 6887, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PENEDIA', 55152, 3110004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4276, 9737, 'CARTORIO DE PROTESTO DE TIT. DE CAETE', 34843, 3110004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4277, 2454, 'REGISTRO CIVIL PESSOAS NATURAIS DE CAETE', 56911, 3110004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4278, 9738, 'CAETE CARTORIO SEGUNDO OFICIO DE NOTAS', 33258, 3110004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4279, 9739, 'SERVICO NOTARIAL DO 3º OFICIO', 58990, 3110004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4281, 2456, 'CARTORIO DO REGISTRO CIVIL E NOTAS DO  DISTRITO MORRO VERMELHO.', 43075, 3110004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4282, 9741, 'SERVICO DE REGISTRO DE IMOVEIS DE CAETE-MG', 58610, 3110004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4283, 2453, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 46847, 3110004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4284, 2457, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE CAIANA', 40154, 3110103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4285, 2459, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PARAGUAI', 34462, 3110202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4286, 2458, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36814, 3110202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4287, 9742, 'REGISTRO DE TITULOS E DOCUMENTOS DE CALDAS-MG', 57513, 3110301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4288, 6888, 'REGISTRO CIVIL DAS PESSOAS NATURASIS DE CALDAS', 56572, 3110301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4289, 9743, 'CARTORIO DO 2º TABELIONATO DE NOTAS', 41608, 3110301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4290, 9744, '1º TABELIONATO DE NOTAS ', 40899, 3110301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4291, 2462, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 47001, 3110301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4292, 9745, 'CARTORIO DE REGISTRO DE IMOVEIS ', 38885, 3110301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4293, 2461, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53231, 3110301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4294, 9746, 'CARTORIO DE PROTESTOS DE TITULOS', 35048, 3110301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4295, 2460, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE LARANJEIRAS DE CALDAS', 37796, 3110301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4296, 9747, 'SERVICO DE REGISTRO DE IMOVEIS', 58503, 3110509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4297, 9748, 'CARTORIO DE PROTESTO DE TITULOS DA COMARCA DE CAMANDUCAIA-MG', 34934, 3110509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4298, 7440, 'REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE SAO MATEUS DE MINAS', 149369, 3110509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4299, 9749, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 47472, 3110509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4300, 2465, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 38216, 3110509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4301, 9750, 'OFICIO DO 1O TABELIONATO DE NOTAS', 47688, 3110509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4302, 9751, 'OFICIO DO 2º TABELIONATO DE NOTAS DE CAMANDUCAIA', 49882, 3110509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4303, 2464, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 35493, 3110509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4304, 9752, 'CARTORIO DE PROTESTOS DE TITULOS DE CAMBUI', 35063, 3110608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4305, 9753, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS', 39222, 3110608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4306, 9754, 'OFICIO REG. TITULOS E DOCUMENTOS E CIVIL PESSOAS JURIDICAS', 54767, 3110608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4307, 7441, 'REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE PONTE SEGURA', 149377, 3110608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4308, 9755, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48280, 3110608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4309, 2466, 'OFICIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE CAMBUI - MG', 46615, 3110608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4310, 9756, 'CARTORIO DO 2° OFICIO DE NOTAS DE CAMBUI', 41178, 3110608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4311, 9757, 'CARTORIO DO 2º OFICIO DE NOTAS DE CAMBUQUIRA', 41525, 3110707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4312, 9758, 'OFICIO DO REGISTRO DE IMOVEIS DE CAMBUQUIRA', 54122, 3110707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4313, 9759, 'CARTORIIO DE REG. PESSOAS JURID. TIT. DOC.', 33407, 3110707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4314, 2467, 'REGISTRO CIVIL DE PESSOAS NATURAIS, DE INTERDICOES E TUTELAS', 56663, 3110707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4315, 9760, 'CARTORIO DE PROTESTO', 34793, 3110707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4316, 9761, 'CAROTIO DO PRIMEIRO OFICIO DE NOTAS', 33365, 3110707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4317, 2468, 'OFICIO REGISTRO CIVIL E TABELIONATO DE CAMPANARIO', 54833, 3110806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4318, 9762, 'CARTORIO DO SEGUNDO OFICIO DE NOTAS', 43737, 3110905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4319, 6889, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 44297, 3110905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4320, 9763, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 39941, 3110905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4321, 9764, 'SERVICO NOTARIAL DO 1º OFICIO', 40923, 3110905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4322, 9765, 'SERVICO REGISTRAL DE IMOVEIS', 59360, 3110905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4323, 9766, 'TABELIONATO DE PROTESTO DE TITULOS', 60202, 3110905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4324, 2469, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35535, 3111002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4325, 9767, 'OFICIO DO 1° TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE CAMPESTRE', 47803, 3111002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4326, 9768, '1º TABELIONATO DE NOTAS', 32227, 3111002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4327, 9769, 'SERVICO REGISTRAL DE TIT. DOCTOS E REG. PESSOAS JURIDICAS', 59550, 3111002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4328, 9770, 'OFICIO DO REGISTRO DE IMOVEIS', 53892, 3111002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4329, 9771, 'SERVICO NOTARIAL DO 2º OFICIO', 58958, 3111002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4330, 9772, 'SERVICO NOTARIAL DO PRIMEIRO OFICIO', 59030, 3111101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4331, 2470, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE HONOROPOLIS', 45617, 3111101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4332, 9773, 'REGISTRO DE TITULOS E DOCUMENTO E PESSOAS JURIDICAS', 57331, 3111101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4333, 9774, 'TABELIONATO DE PROTESTO DE TITULOS', 60319, 3111101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4334, 9775, 'SERVENTIA DE REGISTROS DE IMOVEIS', 58248, 3111101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4335, 9776, 'OFICIO DO 2º OFICIO DE NOTAS', 49254, 3111101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4336, 2471, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55855, 3111101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4337, 2472, 'OFICIO DE REGISTRO CIVIL E NOTAS DE CAMPO AZUL', 46680, 3111150, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4338, 6890, 'REGISTRO CIVIL PESSOAS NATURAIS', 56895, 3111200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4339, 9777, 'CARTORIO DO 1º OFICIO DE NOTAS', 40659, 3111200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4340, 9778, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DA COMARCA DE CAMPO BELO/MG', 33266, 3111200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4341, 9779, 'CAMPO BELO CARTORIO REGISTRO DE IMOVEIS- MAIA RIOS', 33282, 3111200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4342, 9780, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE CAMPO BELO', 48793, 3111200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4343, 9781, 'CAMPO BELO CARTORIO DO 2º OFICIO DE NOTAS', 33274, 3111200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4344, 2473, 'CAMPO DO MEIO CARTORIO DO REGISTRO CIVIL E TABELIONATO', 33290, 3111309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4345, 2474, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE CAMPO FLORIDO', 33308, 3111408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4346, 2475, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO JERONIMO DOS POCOES', 44685, 3111507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4347, 2476, 'CARTORIO DE REGISTRO CIVIL', 35287, 3111507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4348, 9782, 'PRIMEIRO TABELIONATO DE PROTESTO DE TITULOS E DOCUMENTOS DE CAMPOS ALTOS - MG', 55467, 3111507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4349, 9783, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE CAMPOS ALTOS/MG', 39719, 3111507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4350, 9784, 'SERVENTIA DE REGISTRO DE IMOVEIS', 58206, 3111507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4351, 9786, 'TABELIONATO DO 1º OFICIO DE NOTAS DE CAMPOS ALTOS', 59972, 3111507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4352, 9787, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 39768, 3111606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4353, 9788, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS DE CAMPOS GERAIS', 48801, 3111606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4354, 9789, 'SERVICO REGISTRAL DE IMOVEIS', 59303, 3111606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4355, 2477, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35550, 3111606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4356, 9790, 'OFICIO DO 2º TABELIONATO DE NOTAS DE CAMPOS GERAIS', 41228, 3111606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4357, 9791, 'CARTORIO DO 1º OFICIO DE NOTAS', 40642, 3111606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4358, 6945, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CORREGO DO OURO', 53470, 3111606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4359, 2478, 'CARTORIO REGISTRO CIVIL E TABELIONATO DE NOTAS', 44792, 3111903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4360, 2479, 'REGISTRO CIVIL E NOTAS', 56721, 3111705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4361, 9792, 'CARTORIO DO 1º OFICIO DE NOTAS', 40402, 3111804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4362, 9793, 'TABELIONATO DE PROTESTO DE TITULOS', 60244, 3111804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4363, 9794, 'CARTORIO DO 2º OFICIO DE NOTAS', 41343, 3111804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4364, 9795, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 39990, 3111804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4365, 9796, 'SERVICO DE REGISTRO DE IMOVEIS', 58511, 3111804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4366, 2480, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 42283, 3111804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4367, 2481, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35618, 3112000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4368, 9797, 'OFICIO DO 2º TABELIONATO DE NOTAS', 46037, 3112000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4369, 9798, 'TABELIONATO DE PROTESTOS DE CANDEIAS - MG', 35030, 3112000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4370, 9799, 'CARTORIO DE REG. TIT. DOCUMENTOS', 35170, 3112000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4371, 9800, 'OFICIO DO REGISTRO DE IMOVEIS', 44073, 3112000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4372, 9801, 'CARTORIO DO 1º OFICIO NOTAS', 40998, 3112000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4373, 2482, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CANTAGALO', 43315, 3112059, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4374, 2483, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO DE NOTAS', 52670, 3112109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4375, 2484, 'REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS', 56655, 3112208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4376, 9802, 'PRIMEIRO TABELIONATO DE NOTAS DE CAPELINHA', 55418, 3112307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4377, 9803, 'CARTORIO DO 2º OFICIO DE NOTAS', 41376, 3112307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4378, 9804, 'OFICIO DO 1° TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE CAPELINHA/MG', 47811, 3112307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4379, 2485, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DE CAPELINHA', 56028, 3112307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4380, 9805, 'CARTORIO DO REGISTRO DE IMOVEIS', 43455, 3112307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4381, 3973, 'CARTORIO UNICO DE NOTAS', 71852, 2513604, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4382, 9806, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 57422, 3112307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4383, 2486, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE GOIANAZES', 53355, 3112406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4384, 6946, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE CAPETINGA/MG', 37903, 3112406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4385, 2487, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53207, 3112505, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4386, 9807, 'CAPINOPOLIS CARTORIO DE PROTESTOS', 33316, 3112604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4387, 9808, 'CAPINOPOLIS CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS CIVIL DAS PESSOAS JURIDICAS', 33324, 3112604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4388, 9809, 'OFICIO DO REGISTRO DE IMOVEIS DA COMARCA DE CAPINOPOLIS/MG', 54114, 3112604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4389, 2488, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50641, 3112604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4390, 9810, 'OFICIO DO 1º TABELIONATO DE NOTAS', 50047, 3112604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4391, 9811, 'CAPINOPOLIS CARTORIO DO SEGUNDO TABELIONATO', 33332, 3112604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4392, 2489, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 52571, 3112653, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4393, 2491, 'REGISTRO CIVIL TABELIONATO E NOTAS', 56945, 3112703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4394, 2490, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CACAREMA', 46896, 3112703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4395, 2492, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 38067, 3112802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4396, 6947, 'REGISTRO CIVIL E TABELIONATO DE NOTAS DE CAPUTIRA ', 56887, 3112901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4397, 7444, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PONTO DO MARAMBAIA', 42879, 3113008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4398, 7443, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE MARAMBAINHA', 37655, 3113008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4399, 9785, '2º TABELIONATO DE NOTAS ', 153510, 3111507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4400, 7442, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CARAI', 53199, 3113008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4401, 2493, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE CARANAIBA - MG', 42994, 3113107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4402, 9812, 'CARANDAI CARTORIO 2º OFICIO', 33340, 3113206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4403, 2494, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55905, 3113206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4404, 9813, 'CARTORIO DO 1º OFICIO DE NOTAS', 40634, 3113206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4405, 2496, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DO DISTRITO DE HERMILO ALVES ', 52688, 3113206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4406, 9814, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48512, 3113206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4407, 2495, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DISTRITO DE PEDRA DO SINO', 42655, 3113206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4408, 9815, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIS DAS PESSOS JURIDICAS', 57588, 3113206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4409, 9816, 'REGISTRO DE IMOVEIS', 57141, 3113206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4410, 9817, 'OFICIO DO 1º REGISTRO DE IMOVEIS ', 47902, 3113305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4411, 9818, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 44214, 3113305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4412, 2500, 'OFICIO DO REGISTRO CIVIL DAS PESSONAS NATURAIS', 51110, 3113305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4413, 1894, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE LACERDINHA', 54825, 3113305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4414, 9819, 'OFICIO DO 2º REGISTRO DE IMOVEIS', 49288, 3113305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4415, 2499, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PONTE ALTA DE MINAS', 43356, 3113305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4416, 2498, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ALVORADA', 45351, 3113305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4417, 9820, '2º TABELIONATO DE NOTAS', 32680, 3113305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4418, 9821, 'CARTORIO DO 1º OFICIO DE NOTAS', 40717, 3113305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4419, 2497, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 50286, 3113305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4420, 9822, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48553, 3108008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4421, 9823, 'CARTORIO DE REGISTRO DE IMOVEIS', 38851, 3108107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4422, 9824, 'OFICIO DO TABELIONATO DE PROTESTOS', 54718, 3108107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4423, 9825, 'CARTORIO DO 1º OFICIO DE NOTAS', 40584, 3108107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4424, 9826, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54320, 3108107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4425, 2411, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE SANTO ANTONIO DE VARGEM ALEGRE', 36194, 3108107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4426, 2410, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50799, 3108107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4427, 9827, 'BONFIM CARTORIO 2º OFICIO DE NOTAS ', 33175, 3108107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4428, 2412, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35832, 3108206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4429, 9828, '2º TABELIONATO DE NOTAS ', 153502, 3108206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4430, 9829, 'OFICIO DO TABELIONATO DE PROTESTO DE TITULOS', 35006, 3108206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4431, 9830, '2º TABELIONATO DE NOTAS ', 153494, 3108206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4432, 9831, 'CARTORIO DE NOTAS', 34009, 3108206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4433, 9832, 'OFICIO DE REGISTRO DE TITULOS, DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 47555, 3108206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4434, 9833, 'SERVICO DE REGISTRO DE IMOVEIS DA COMARCA DE BONFINOPOLIS DE MINAS', 58560, 3108206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4435, 2413, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE BONITO DE MINAS', 37325, 3108255, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4436, 9834, 'TABELIONATO DE PROTESTO DE TITULOS DE BORDA DA MATA', 60343, 3108305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4437, 9835, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49676, 3108305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4438, 9836, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS', 39859, 3108305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4439, 2415, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 42788, 3108305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4440, 9837, 'CARTORIO DO 1º OFICIO DE NOTAS DE BORDA DA MATA, MINAS GERAIS', 40824, 3108305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4441, 6885, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 36178, 3108305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4442, 2414, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42184, 3108305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4443, 9838, 'CARTORIO DO REGISTRO DE IMOVEIS', 43463, 3108305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4444, 2419, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 37838, 3108404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4445, 9839, '2º TABELIONATO DE NOTAS DA COMARCA DE BOTELHOS', 32755, 3108404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4446, 2416, 'CARTORIO DE REGISTRO CIVIL', 41996, 3108404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4447, 9840, 'OFICIO DO REGISTRO DE IMOVEIS DA COMARCA DE BOTELHOS', 54106, 3108404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4448, 9841, 'CARTORIO DO REGISTRO TIT E DOC E CIVIL DE PESSOAS JURIDICAS', 43695, 3108404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4449, 2420, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL', 37788, 3108404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4450, 9842, 'CARTORIO DO 1º OFICIO DE NOTAS', 40774, 3108404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4451, 9843, 'CARTORIO DE PROTESTO', 34785, 3108404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4452, 2422, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51425, 3108503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4453, 2421, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52977, 3108503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4454, 2423, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE SANTA CRUZ', 42424, 3108503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4455, 2424, 'BRAS PIRES CARTORIO DE REGISTRO CIVIL E NOTAS', 33191, 3108701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4456, 3175, 'HUDSON OLIVEIRA RIBEIRO JUNIOR - OFICIAL', 64972, 5102793, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4457, 3176, 'TABELIONATO DE NOTAS E REGISTRO CIVIL', 65532, 5102850, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4458, 3177, 'SEGUNDO SERVICO NOTARIAL E REGISTRAL ', 65219, 5103007, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4459, 3179, 'REGISTRO CIVIL DO DISTRITO DE AGUA FRIA', 64873, 5103007, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4460, 9844, '1º TABELIONATO E REGISTRADORIA PAIXAO', 63560, 5103007, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4461, 3178, 'CGJ/MT_1 SERVICO NOTARIAL E REGISTRAL CAMPOS', 64881, 5103007, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4462, 9845, 'PRIMEIRO OFICIO EXTRAJUDICIAL', 65011, 5103056, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4463, 7048, '2° OFICIO EXTRAJUDICIAL DE CLAUDIA - MT', 64949, 5103056, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4464, 9846, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 64071, 5103106, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4465, 9847, 'PRIMEIRO SERVICO REGISTRAL DA COMARCA DE COLIDER', 65052, 5103205, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4466, 7353, 'CARTORIO DO 2º OFICIO DE COLIDER', 146910, 5103205, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4467, 9848, 'REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS DA COMARCA DE COLNIZA (1º OFICIO)', 65086, 5103254, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4468, 9849, '1º OFICIO', 132712, 5103254, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4469, 3180, 'CARTORIO 2º OFICIO DA COMARCA DE COLNIZA', 63842, 5103254, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4470, 9850, '1º SERVICO REGISTRAL DE COMODORO-MT', 63537, 5103304, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4471, 3181, 'CARTORIO DE 2º OFICIO', 63891, 5103304, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4472, 9851, 'CARTORIO DE PAZ E NOTAS DE CONFRESA ', 63743, 5103353, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4473, 9852, 'PRIMEIRO SERVICO NOTARIAL E REGISTRAL DE COTRIGUACU', 65045, 5103379, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4474, 3182, 'SEGUNDO SERVICO NOTARIAL E REGISTRAL DE COTRIGUACU', 65250, 5103379, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4475, 9853, '7º SERVICO NOTARIAL E REGISTRAL DA COMARCA DE CUIABA- MT', 63792, 5103403, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4476, 9854, '2º SERVICO NOTARIAL E REGISTRAL DA 1ª CIRCUNSCRICAO IMOBILIARIA DE CUIABA', 63677, 5103403, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4477, 9855, '5º SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS DA 2ª CIRCUNSCRICAO IMOBILIARIA DA COMARCA CUIABA', 63776, 5103403, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4478, 3184, 'CARTORIO DE PAZ E NOTAS DO COXIPO DA PONTE', 65375, 5103403, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4479, 9856, '1º SERVICO NOTARIAL E REGISTRAL SE CUIABA', 63487, 5103403, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4480, 3185, 'CARTORIO DE REGISTRO CIVIL E NOTAS DO DISTRITO DE NOSSA SENHORA DA GUIA', 64063, 5103403, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4481, 3183, '3ª SERVICO NOTARIAL E REGISTRAL DE PESSOAS NATURAIS DE CUIABA MT ', 63750, 5103403, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4482, 9857, '6º SERVICO NOTARIAL E REGISTRO DE IMOVEIS DE CUIABA-MT', 63784, 5103403, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4483, 9858, '4 SERVICO NOTARIAL DE CUIABA', 63768, 5103403, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4484, 3186, 'CGJ/MT_1 SERVICO NOTARIAL E REGISTRO CIVIL', 64907, 5103452, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4485, 3187, 'SEGUNDO SERVICO NOTARIAL E REGISTRA CAPISTRANO', 65144, 5103502, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4486, 9859, '1º SERVICO DE REGISTRO DE IMOVEIS E DE TITULOS E DOCUMENTOS', 63412, 5103502, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4487, 3188, '2º OFICIO DE DOM AQUINO', 63628, 5103601, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4488, 9860, 'CARTORIO DO 1º OFICIO DE DOM AQUINO', 63859, 5103601, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4489, 3189, 'CARTORIO DO 2º OFICIO', 64394, 5103700, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4490, 9861, 'CARTORIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS', 64105, 5103700, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4491, 3190, 'CARTORIO DE PAZ E NOTAS DE FIGUEIROPOLIS DOESTE', 65235, 5103809, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4492, 3191, 'CGJ/MT_1 CARTORIO DE PAZ E REGISTRO CIVIL DE GENERAL CARNEIRO', 64725, 5103908, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4493, 9862, 'CARTORIO DO 1 OFICIO NOTAS E IMOVEIS', 66647, 1506302, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4494, 3391, 'CARTORIO DE CONDEIXA', 66019, 1506302, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4495, 3393, 'CARTORIO DE REGISTRO CIVIL RITA ALAMAR DE MELO', 66449, 1506302, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4496, 3390, 'CARTORIO DO UNICO OFICIO DA VILA DE JOANES', 68155, 1506302, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4497, 3394, 'CARTORIO DE REGISTRO CIVIL E NOTAS DO MUNICIPIO DE SANTA BARBARA', 66415, 1506351, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4498, 3865, 'CARTORIO DO UNICO OFICIO DE SANTA CRUZ DO ARARI', 67363, 1506401, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4499, 3867, 'UNICO  OFICIO CARTORIO TEIXEIRA', 68593, 1506500, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4500, 3866, 'CARTORIA DA VILA DE AMERICANO - SANTA IZABEL DO PARA', 65664, 1506500, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4501, 3868, 'CARTORIO DO UNICO OFICIO DO DISTRITO DE CARAPARU - SANTA IZABEL DO PARA', 67462, 1506500, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4502, 3870, 'CARTORIO DE JACAREQUARA - SANTA LUZIA DO PARA', 66035, 1506559, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4503, 3869, 'CARTORIO PUBLICO DE SANTA LUZIA', 67942, 1506559, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4504, 3871, 'CARTORIO DE VILA DE TENTUGAL', 66621, 1506559, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4505, 3872, 'CARTORIO DO UNICO OFICIO DE SANTA MARIA DAS BARREIRAS', 130039, 1506583, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4506, 3873, 'CARTORIO DE PESSOA NATURAL', 66092, 1506609, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4507, 3874, 'CARTORIO DO UNICO OFICIO', 67041, 1506609, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4508, 3395, 'CARTORIO DO UNICO OFICIO DE SANTANA DO ARAGUAIA', 67371, 1506708, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4509, 3398, '3O TABELIONATO DE NOTAS E REGISTRO CIVIL DE PESSOAS NATURAIS', 65649, 1506807, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4510, 3400, 'CARTORIO PANTOJA REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 68452, 1506807, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4511, 3397, 'CARTORIO DE REGISTRO DO UNICO OFICIO DE CURUAI - SANTAREM', 66548, 1506807, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4512, 9863, 'CARTORIO NOGUEIRA SIROTHEAU - PRIMEIRO OFICIO DE NOTAS E REGISTRO DE IMOVEIS', 67843, 1506807, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4513, 3396, 'CARTORIO DO UNICO OFICIO DE BOIM - SANTAREM', 67157, 1506807, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4514, 3399, 'CARTORIO EXTRAJUDICIAL DO UNICO OFICIO ', 67645, 1506807, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4515, 9864, 'TABELIONATO BENTES VIEIRA DO 2º OFICIO', 68585, 1506807, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4516, 3401, 'CARTORIO DE REGISTRO CIVIL DO UNICO OFICIO DE SANTAREM NOVO', 66365, 1506906, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4517, 3402, 'CARTORIO PANTOJA - SANTO ANTONIO DO TAUA', 67900, 1507003, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4518, 7012, 'CARTORIO DE REGISTRO CIVIL UNICO OFICIO - CARTORIO MONTEIRO', 66498, 1507003, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4519, 3403, 'CARTORIO PARANHOS GURJAO - UNICO OFICIO DE SAO CAETANO DE ODIVELAS', 67918, 1507102, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4520, 3405, 'CARTORIO DE REGSITRO CIVIL DO POVOADO DE RIO BRANCO- DISTRITO DE PERSEVERANCA', 66589, 1507102, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4521, 3404, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO SAO JOAO DOS RAMOS', 66316, 1507102, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4522, 3406, 'CARTORIO DO UNICO OFICIO DE SAO DOMINGOS DO ARAGUAIA', 67009, 1507151, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4523, 3407, 'CARTORIO DO UNICO OFICIO ', 67066, 1507201, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4524, 3408, 'CARTORIO DO UNICO OFICIO DE SAO FELIX DO XINGU', 67389, 1507300, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4525, 3410, 'CARTORIO DO UNICO OFICIO DE JAMBU-ACU', 68288, 1507409, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4526, 3409, 'CARTORIO SOUZA ', 68247, 1507409, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4527, 3431, 'CARTORIO DO UNICO OFICIO SAO GERALDO DO ARAGUAIA', 67579, 1507458, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4528, 4156, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 1º OFICIO DA CIDADE E COMARCA DE RIO TINTO - PB.', 70623, 2512903, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4529, 3968, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 69864, 2513000, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4530, 4158, 'CARTORIOI DE REGISTRO CIVIL E SERVICOS NOTARIAL ANJOS', 72009, 2513109, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4531, 9865, 'CARTORIO DISTRITAL DE DOIS RIACHOS', 70250, 2513109, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4532, 4159, 'CARTORIO DO REGISTRO CIVIL DE SANTA CECILIA', 70946, 2513158, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4533, 4160, 'CARTORIO DISTRITAL DE SANTA CRUZ', 70367, 2513208, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4534, 4161, 'CARTORIO DE REGISTRO CIVIL TABELIONATO ', 70045, 2513307, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4535, 4162, 'CARTORIO DO REGISTRO CIVIL', 70573, 2513356, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4536, 7083, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS', 73148, 2513406, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4537, 9866, 'SERVICO NOTARIAL E REGISTRAL', 72934, 2513406, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4538, 9867, 'SERVICO DE REGISTRO DE DISTRIBUICAO EXTRA JUDICIAL DE SANTA LUZIA PB', 72892, 2513406, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4539, 9868, 'SERVICO NOTARIAL E REGISTRAL INACIO MACHADO', 73031, 2513406, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4540, 4164, 'CARTORIO DISTRITAL DO REGISTRO CIVIL DE TIBIRI II', 70417, 2513703, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4541, 9869, 'SERVICO NOTARIAL E REGISTRAL DOURADO DE AZEVEDO', 73015, 2513703, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4542, 9870, 'CARTORIO CLAUDINO GOMES', 69310, 2513703, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4543, 9871, 'ANGELA MARIA DE SOUZA - SERV. NOTARIAL E REGISTRAL', 68965, 2513703, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4544, 3969, 'SERVICO REGISTRAL E NOTARIAL DE LIVRAMENTO', 70391, 2513703, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4545, 9872, 'CARTORIO DE DISTRIBUICAO EXTRA JUDICIAL', 69435, 2513703, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4546, 4165, 'CARTORIO DISTRITAL DO REGISTRO CIVIL DE PESSOAS NATURAIS DO DISTRITO DE VARZEA NOVA', 70409, 2513703, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4547, 4163, '1º CARTORIO DE REGISTRO CIVIL DE SANTA RITA - PB', 68676, 2513703, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4548, 3970, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 71076, 2513802, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4549, 3971, 'OFICIO DE REGISTRO CIVIL E NOTAS', 72371, 2513505, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4550, 9873, 'CARTORIO DE DISTRIBUICAO EXTRAJUDICIAL DE SANTANA DOS GARROTES PB', 69542, 2513604, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4551, 3972, 'CARTORIO DO REGISTRO CIVIL', 70672, 2513604, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4552, 9874, 'SERVICO CARLOS ALENCAR', 72728, 2513604, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4553, 3974, 'CARTORIO DO REGISTRO CIVIL DE SANTAREM', 71308, 2513653, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4554, 3263, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 71084, 2513851, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4555, 3265, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 148221, 2513927, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4556, 3264, 'CARTORIO SOARES', 71803, 2513901, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4557, 9875, 'SAO BENTO CARTORIO UNICO DE REGISTRO DE IMOVEIS E NOTAS', 72611, 2513901, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4558, 9876, 'CARTORIO DE DISTRIBUICAO EXTRAJUDICIAL', 166, 2513901, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4559, 3266, 'CARTORIO ELVIDIO ALVES DA SILVA', 71423, 2513968, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4560, 3267, 'SAO DOMINGOS DO CARIRI,CART.REG.CIVIL DE NOTAS E DOCUMENTOS', 72629, 2513943, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4561, 3268, 'SAO FRANCISCO CARTORIO DISTRITAL', 72637, 2513984, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4562, 9877, 'CARTORIO ALMEIDA BARROS', 69203, 2514008, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4563, 9878, 'CARTORIO DO 2º OFICIO DE REGISTRO DE IMOVEIS E PROTESTO', 150501, 2514008, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4564, 9879, 'MORENO CARTORIO 1O OFICIO DE NOTAS E REGISTROS', 77172, 2609402, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4565, 4203, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE MORENO-PE', 76638, 2609402, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4566, 9880, 'SERVICO UNICO DE REGISTRO DE IMOVEIS E ANEXOS DO MUNICIPIO DE NAZARE DA MATA - PE', 150797, 2609501, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4567, 4456, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 82610, 4124103, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4568, 13485, 'SERVICO DE REGISTRO DE IMOVEIS', 81893, 4124103, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4569, 13486, 'TABELIONATO DE NOTAS, ACUMULANDO PRECARIAMENTE O TABELIONATO DE PROTESTO DE TITULOS ', 82685, 4124103, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4570, 4455, 'SERVICO DISTRITAL DE CONSELHEIRO ZACARIAS', 82552, 4124103, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4571, 3628, 'SERVICO DISTRITAL DE SANTO ANTONIO DO CAIUA', 86793, 4124202, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4572, 13487, 'CARTORIO DO DISTRIBUIDOR, CONTADOR E PARTIDOR', 90894, 3303500, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4573, 13488, 'CARTORIO 1º OFICIO DE JUSTICA NOVA IGUACU', 89573, 3303500, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4574, 13489, 'CARTORIO 10º OFICIO DE JUSTICA DE NOVA IGUACU', 89557, 3303500, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4575, 13490, '6 OFICIO DE JUSTICA DE NOVA IGUACU', 89292, 3303500, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4576, 4967, 'NOVA IGUACU CARTORIO DO REGISTRO CIVIL 1 CIRCUNCRICAO', 92155, 3303500, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4577, 13491, '3 SERVICO NOTARIAL E REGISTRAL DE NOVA IGUACU', 89078, 3303500, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4578, 13492, 'QUARTO OFICIO DE JUDTICA DE NOVA IGUACU', 92353, 3303500, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4579, 13493, '2º OFICIO DE JUSTICA DE NOVA IGUACU', 88989, 3303500, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4580, 13494, '8º OFICIO DE JUSTICA DE NOVA IGUACU', 89383, 3303500, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4581, 13495, '7º OFICIO DE JUSTICA DE NOVA IGUACU', 89367, 3303500, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4582, 4965, 'REGISTRO CIVIL DE PESSOAS NATURAIS DA 2ª CIRCUNCRICAO DO 1º DISTRITO DE NOVA IGUACU-RJ', 93260, 3303500, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4583, 13496, 'CARTORIO 5º OFICIO DE JUSTICA DE NOVA IGUACU', 89698, 3303500, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4584, 13497, 'DISTRIBUIDOR, CONTADOR E PARTIDOR  ', 91728, 3303609, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4585, 13498, '2º OFICIO DE JUSTICA DE PARACAMBI', 88997, 3303609, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4586, 13499, '1º OFICIO DE JUSTICA DE PARACAMBI', 88849, 3303609, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4587, 4968, 'RCPN 1ª CIRCUNSCRICAO 1º DISTRITO', 92460, 3303609, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4588, 13500, 'CARTORIO DO DISTRIBUIDOR, CONTADOR E PARTIDOR DE PARAIBA DO SUL', 90985, 3303708, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4589, 4970, 'CART DO REG CIVIL DE P NATURAIS DO 1 DISTR DE P DO SUL', 89532, 3303708, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4590, 13501, 'OFICIO UNICO DO MUNICIPIO DE PARAIBA DO SUL', 154559, 3303708, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4591, 4969, 'CARTORIO RCPN E NOTAS DE INCONFIDENCIA', 92312, 3303708, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4592, 9881, '4º SERVICO DE NOTAS, PROTESTO DE TITULOS E REGISTRO DE TITULOS E DOCUMENTOS DA COMARCA DE OLINDA', 73759, 2609600, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4593, 9882, '1º CARTORIO DE NOTAS DE OLINDA', 73502, 2609600, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4594, 9883, '5º TABELIONATO DE NOTAS DE OLINDA ', 73775, 2609600, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4595, 9884, 'CARTORIO RITA RANGEL 2 OFICIO DE NOTAS', 150672, 2609600, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4596, 9885, 'SERVICO NOTARIAL FRANCISCO GOMES', 77651, 2609600, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4597, 9886, '1 OFICIO DE NOTAS E RGI OLINDA/PE', 73452, 2609600, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4598, 4205, 'CARTORIO DE REGISTRO CIVIL DE OLINDA/PE', 74526, 2609600, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4599, 4206, 'CARTORIO DO REGISTRO CIVIL DE OROBO', 75895, 2609709, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4600, 6666, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS E TABELIONATO DE UMBURETAMA', 75432, 2609709, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4601, 9887, 'SERVICO NOTARIAL E REGISTRAL DE OROBO', 77602, 2609709, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4602, 4207, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE CHA DO ROCHA', 76257, 2609709, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4603, 3610, 'CARTORIO DE RGISTRO CIVIL DAS PESSOAS NATURAIS DE OROCO', 74773, 2609808, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4604, 3611, 'CARTORIO DO REGISTRO CIVIL DA COMARCA DE OURICURI', 75416, 2609907, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4605, 9888, 'CARTORIO DO SEGUNDO OFICIO', 76380, 2609907, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4606, 9889, 'CARTORIO DO 1º OFICIO', 74823, 2609907, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4607, 3612, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 74641, 2609907, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4608, 9890, 'PRIMEIRO OFICIO DA COMARCA DE PALMARES-PE ', 148072, 2610004, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4609, 3271, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75606, 2610004, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4610, 9891, 'SERVICO NOTARIAL E REGISTRAL 2º OFICIO', 77560, 2610004, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4611, 9892, 'CARTORIO UNICO NOTAS E REGISTRO IMOVEIS', 77016, 2610103, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4612, 3272, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 77297, 2610103, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4613, 3275, 'CARTORIO DE REGISTRO CIVIL - SEDE', 74187, 2610202, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4614, 9893, 'CARTORIO UNICO DE NOTAS E SEUS ANEXOS', 76919, 2610202, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4615, 3273, 'CARTORIO CIVIL, TABELIONATO - VILA DAS CRUZES', 150623, 2610202, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4616, 3274, 'CARTORIO DE REGISTRO CIVIL - 3.º DISTRITO - PANELAS/PE', 74179, 2610202, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4617, 3276, 'PARANATAMA CARTORIO DE OFICIO UNICO', 77206, 2610301, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4618, 9894, 'CARTORIO DE NOTAS E REGISTROS PUBLICOS', 74021, 2610400, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4619, 3277, 'CARTORIO UNICO REGISTRO CIVIL', 77032, 2610400, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4620, 3278, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE PASSIRA - PERNAMBUCO', 75721, 2610509, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4621, 9895, 'CARTORIO DO OFICIO UNICO DA COMARCA DE PASSIRA - PE', 75036, 2610509, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4622, 3192, 'CRUZEIRO D OESTE CARTORIO DE PAZ E NOTAS', 64956, 5103957, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4623, 3193, 'GUARANTA CARTORIO DE PAZ', 64964, 5104104, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4624, 9896, 'CARTORIO DO PRIMEIRO OFICIO DE GUARANTA DO NORTE/MT', 64451, 5104104, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4625, 9897, 'CARTORIO DE PAZ E NOTAS', 63941, 5104203, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4626, 3194, 'CARTORIO DE NOTAS E REGISTRO CIVIL', 63917, 5104203, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4627, 9898, '1º SERVICO REGISTRAL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS DE GUIRATINGA-MT', 63438, 5104203, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4628, 3195, 'CARTORIO DE PAZ E NOTAS', 64998, 5104526, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4629, 9899, 'SERVICO REGISTRAL E NOTARIAL DE ITANHANGA', 65441, 5104542, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4630, 3196, 'SERVICO NOTARIAL E REGISTRAL DAS PESSOAS NATURAIS', 65342, 5104559, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4631, 3197, 'CARTORIO DO 2º OFICIO', 64360, 5104609, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4632, 9900, '1º SERVICO REGISTRAL DE IMOVEIS, TITULOS E DOCUMENTOS', 63545, 5104609, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4633, 9901, 'CARTORIO DO 1º OFICIO - REGISTRO DE IMOVEIS E TITULOS E DOCUMENTOS', 135442, 5104807, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4634, 3198, 'CARTORIO DO 2º OFICIO', 64402, 5104807, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4635, 3199, 'CARTORIO DO 2º OFICIO DE PAZ E NOTAS DE JANGADA-MT', 64428, 5104906, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4636, 9902, 'CARTORIO DO 1º OFICIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS DA COMARCA DE JAURU-MT', 64261, 5105002, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4637, 7049, 'CGJ/MT_1 CARTORIO DO REGISTRO CIVIL E TABELIONATO', 64816, 5105002, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4638, 3200, '2.º OFICIO DE JAURU', 63594, 5105002, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4639, 3201, 'SEGUNDO SERVICO NOTARIAL DE JUARA ', 65128, 5105101, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4640, 9903, 'CARTORIO DE PAZ E NOTAS ', 154526, 5105101, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4641, 9904, 'CATUAI- CARTORIO DO REGISTRO CIVIL E TABELIONATO', 64550, 5105101, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4642, 9905, '1º OFICIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS DE JUARA-MT', 63354, 5105101, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4643, 3203, '2º SERVICO REGISTRAL E NOTARIAL DE JUINA', 63719, 5105150, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4644, 9906, '1° SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS.', 63289, 5105150, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4645, 3202, 'CGJ/MT_1 CARTORIO DE PAZ E NOTAS DE RONDOLANDIA', 64675, 5105150, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4646, 3204, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE JURUENA', 64048, 5105176, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4647, 7050, 'CGJ/MT_1 SALVADOR GOMES DA SILVA', 64857, 5105200, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4648, 3206, 'CARTORIO DO SEGUNDO OFICIO DE JUSCIMEIRA', 64527, 5105200, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4649, 9907, 'CARTORIO DO PRIMEIRO OFICIO DE JUSCIMEIRA', 64469, 5105200, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4650, 3205, 'CGJ/MT_1 CARTORIO DE PAZ E NOTAS DE SAO LOURENCO DE FATIMA', 64709, 5105200, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4651, 9908, 'CARTORIO DE 1º OFICIO DE REGISTRO DE IMOVEIS E TITULOS E DOCUMENTOS', 63883, 5105259, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4652, 3207, 'CARTORIO 2 OFICIO DE LUCAS DO RIO VERDE', 64535, 5105259, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4653, 3208, 'CGJ/MT_1 2º TABELIONATA E REGISTRO CIVIL DE LUCIARA', 64584, 5105309, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4654, 3209, '2 OFICIO EXTRAJUDICIAL DE MARCELANDIA-MT', 63586, 5105580, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4655, 9909, '1 OFICIO EXTRAJUDICIAL DE MARCELANDIA-MT', 63263, 5105580, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4656, 9910, 'CARTORIO DO 1º OFICIO - REGISTROS DE IMOVEIS E DE TITULOS E DOCUMENTOS DE MATUPA', 64477, 5105606, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4657, 3210, 'WILTON LEMOS MELO', 65573, 5105606, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4658, 9911, 'RCPN - CRUZEIRO DOESTE - AUGUSTO BERNARDO FILHO', 137604, 5105622, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4659, 3211, 'CARTORIO DO 2º OFICIO', 64345, 5105622, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4660, 3432, 'CARTORIO DE REGISTRO CIVIL DE VILA NOVA', 66274, 1507466, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4661, 3411, 'CARTORIO DE REGISTRO CIVIL SAO JOAO DA PONTA', 66472, 1507466, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4662, 3413, 'CARTORIO NOSSA SENHORA DO LIVRAMENTO', 67850, 1507474, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4663, 3412, 'CARTORIO SANTOS', 68189, 1507474, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4664, 3414, 'CARTORIO FRUTUOSO SILVA - SAO JOAO DO ARAGUAIA', 67702, 1507508, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4665, 9912, 'CARTORIO DE REGISTRO DE IMOVEIS - 1O OFICIO', 66522, 1507607, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4666, 3415, 'CARTORIO DE REGISTRO CIVIL DO UNICO OFICIO DO CAJU - SAO MIGUEL DO GUAMA', 66381, 1507607, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4667, 3418, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE URUCURITEUA - SAO MIGUEL DO GUAMA', 66308, 1507607, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4668, 3417, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE URUCURI - CARTORIO SILVA DE OLIVEIRA', 68239, 1507607, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4669, 3416, 'CARTORIO DO 2ª OFICIO DE REGISTRO CIVIL DE SAO MIGUEL DO GUAMA', 66761, 1507607, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4670, 3419, 'CARTORIO DO UNICO OFICIO DA COMARCA DE SAO SEBASTIAO DA BOA VISTA- J. J. TEIXEIRA', 67116, 1507706, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4671, 3631, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS ', 81364, 4124400, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4672, 13539, 'TABELIONATO DE PROTESTO DE TITULOS', 84608, 4124400, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4673, 3632, 'SERVICO DISTRITAL DE SANTO INACIO', 82396, 4124509, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4674, 3633, 'SERVICO DISTRITAL DE SAO CARLOS DO IVAI - PR', 84137, 4124608, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4675, 3634, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85977, 4124707, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4676, 13540, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTOS DE TITULOS', 87601, 4124707, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4677, 13541, 'SERVICO DE REGISTRO DE IMOVEIS', 81844, 4124707, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4678, 7308, 'SERVICO DISTRITAL DE SAO JOAO DO PINHAL', 141945, 4124707, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4679, 3635, 'TABELIONATO DE NOTAS ACUMULANDO PRECARIAMENTE TABELIONATO DE PROTESTO DE TITULOS', 144626, 4124806, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4680, 13542, 'SERVICO DE REGISTRO DE IMOVEIS DA COMARCA DE SAO JOAO', 154617, 4124806, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4681, 3636, 'SERVICO DISTRITAL DE SAO JOAO DO CAIUA', 87239, 4124905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4682, 13543, 'SERVICO DE REGISTRO DE IMOVEIS', 81935, 4125001, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4683, 3637, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81299, 4125001, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4684, 13544, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87890, 4125001, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4685, 3638, 'SERVICO DISTRITAL DE UBAUNA', 130260, 4125001, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4686, 13545, 'SERVICO DE REGISTRO DE IMOVEIS', 82677, 4125100, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4687, 13546, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 82735, 4125100, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4766, 13581, 'TABELIONATO DE PROTESTO DE TITULOS', 96404, 1100106, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4688, 3639, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO PRECARIAMENTE O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 84749, 4125100, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4689, 3641, 'SERVICO DISTRITAL DE SAO JORGE DO OESTE', 85522, 4125209, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4690, 3640, 'SERVICO DISTRITAL DOUTOR ANTONIO PARANHOS', 81547, 4125209, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4691, 3642, 'SERVICOS DISTRITAL DE SAO JORGE DO IVAI', 82743, 4125308, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4692, 3643, 'SERVICO DISTRITAL DE SAO JORGE DO PATROCINIO', 86389, 4125357, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4693, 3644, 'SERVICO DISTRITAL DE SAO JOSE DA BOA VISTA', 84814, 4125407, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4694, 3645, 'SERVICO DISTRITAL DE SAO JOSE DAS PALMEIRAS', 82040, 4125456, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4695, 13547, '2º SERVICO DE REGISTRO DE IMOVEIS', 80309, 4125506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4696, 3649, 'SERVICO DISTRITAL DE COLONIA MURICI', 84855, 4125506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4697, 13548, '2º TABELIONATO DE NOTAS', 80291, 4125506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4698, 3648, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 687, 4125506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4699, 3646, 'SERVICO DISTRITAL DE SAO MARCOS', 144774, 4125506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4700, 13549, 'CARTORIO DO 11º OFICIO DE PETROPOLIS', 90076, 3303906, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4701, 4975, 'RCPN E NOTAS DO TERCEIRO DISTRITO DE PETROPOLIS', 93039, 3303906, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4702, 4976, 'CARTORIO DO OFICIO UNICO DO MUNICIPIO DE PINHEIRAL', 91090, 3303955, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4703, 13550, 'CARTORIO DISTRIBUIDOR CONTADOR PARTIDOR', 89904, 3303955, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4704, 4977, 'REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DO 5º DISTRITO DE PIRAI - RJ', 93278, 3304003, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4705, 13551, '2º OFICIO DE JUSTICA DE PIRAI-RJ', 89011, 3304003, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4706, 13552, 'DISTRIBUIDOR, CONTADOR E PARTIDOR', 91785, 3304003, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4707, 6561, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 1° DISTRITO DE PIRAI, RJ', 93153, 3304003, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4708, 13553, 'PIRAI CARTORIO DO 1 OFICIO', 92320, 3304003, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4709, 4978, 'CARTORIO DO OFICIO UNICO', 91009, 3304102, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4710, 13554, 'DISTRIBUIDOR, CONTADOR E PARTIDOR DE PORCIUNCULA', 91959, 3304102, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4711, 4979, 'CARTORIO DO OFICIO UNICO DE PORTO REAL', 91074, 3304110, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4712, 13555, 'CARTORIO DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE PORTO REAL / QUATIS', 90001, 3304110, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4713, 4980, 'SERVICO NOTARIAL E REGISTRAL OFICIO UNICO DE QUATIS', 93583, 3304128, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4714, 13556, 'CARTORIO DO 1º OFICIO DE QUEIMADOS', 90332, 3304144, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4715, 13557, 'CARTORIO DO 2º OFICIO DE JUSTICA DA COMARCA DE QUEIMADOS', 144857, 3304144, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4716, 13558, 'CARTORIO DO DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE QUEIMADOS', 90951, 3304144, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4717, 4981, 'CARTORIO DO 3º OFICIO DE JUSTICA DE QUEIMADOS', 90662, 3304144, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4718, 4982, 'OFICIO UNICO DO MUNICIPIO DE QUISSAMA', 92296, 3304151, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4719, 13559, '3º OFICIO DE JUSTICA DE RESENDE', 89144, 3304201, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4720, 13560, 'SERVICO NOTARIAL E REGISTRAL DO 2º OFICIO DE JUSTICA DE RESENDE', 93492, 3304201, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4721, 13561, 'DISTRIBUIDOR CONTADOR E PARTIDOR', 91686, 3304201, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4722, 6562, 'RCPN/TAB.DE NOTAS DO 1º DISTRITO DE RESENDE- RJ', 93096, 3304201, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4723, 13562, '1º OFICIO DE RESENDE', 88880, 3304201, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4724, 13563, '4º OFICIO DE JUSTICA DE RESENDE', 89219, 3304201, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4725, 4983, 'RCPN DO 2º DISTRITO DE RESENDE', 92841, 3304201, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4726, 13564, 'CARTORIO DO 2º OFICIO DE JUSTICA DE RIO BONITO', 90548, 3304300, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4727, 4984, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 1° DISTRITO DE RIO BONITO', 93161, 3304300, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4728, 13565, 'CARTORIO DO DISTRIBUIDOR, CONTADOR E PARTIDOR', 90860, 3304300, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4729, 13566, 'CARTORIO DO 1º OFICIO DE JUSTICA DE RIO BONITO ', 90316, 3304300, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4730, 13567, 'CARTORIO DO DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE RIO CLARO', 90969, 3304409, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4731, 13568, 'OFICIO UNICO DE RIO CLARO', 92247, 3304409, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4732, 4988, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS DO 4° DISTRITO DA COMARCA DE RIO CLARO RJ', 91439, 3304409, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4733, 6570, 'OFICIO UNICO', 92197, 3304508, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4734, 13569, 'DISTRIBUIDOR, CONTADOR E APRTIDOR', 91710, 3304508, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4735, 13570, 'DISTRIBUIDOR CONTADOR E PARTIDOR', 91678, 3304524, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4736, 4487, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 95919, 1100379, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4737, 5141, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 95836, 1100403, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4738, 13571, 'TABELIONATO DE PROTESTOS, REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS E DE PESSOAS JURIDICAS', 96172, 1100346, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4739, 5142, 'OFICIO DE REGISTRO CIVIL E NOTAS', 130369, 1100346, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4740, 13572, 'TABELIONATO DE PROTESTOS', 96461, 1100023, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4741, 13573, 'OFICIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 96156, 1100023, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4742, 5143, 'TABELIONATO DE NOTAS E OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 96370, 1100023, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4743, 13574, 'REGISTROS DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOAS JURIDICAS E TABELIONATO DE PROTESTO DE TITULOS E DOCUMENTOS', 130377, 1100452, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4744, 4488, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 96263, 1100452, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4745, 4489, 'TABELIONATO DE NOTAS E ANEXOS DO REGISTRO CIVIL DE PESSOAS NATURAIS ', 96362, 1100031, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4746, 4490, 'CARTORIO DE NOTAS E REGISTRO CIVIL DAS PESSOAS NATURAIS', 95760, 1100601, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4747, 5144, '2º OFICIO DE REGISTRO CIVIS DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE CACOAL ', 95794, 1100049, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4748, 13575, '1º OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE CACOAL', 96313, 1100049, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4749, 13576, 'TABELIONATO DE PROTESTO DE TITULOS', 96420, 1100049, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4750, 13577, '1º OFICIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIS DAS', 96248, 1100049, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4751, 6609, 'REGISTRO CIVIL E NOTAS', 150441, 1100700, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4752, 5145, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 95869, 1100809, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4753, 5146, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 95893, 1100908, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4754, 13578, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS', 96008, 1100056, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4755, 5147, 'CARTORIO DE REGISTRO CIVIL E NOTAS CAVATTI', 95828, 1100056, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4756, 5148, 'PRIMEIRO OFICIO DE REGISTRO CIVIL E DE NOTAS', 130351, 1100924, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4757, 5149, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 96131, 1100064, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4758, 13579, 'TABELIONATO DE PROTESTO DE TITULOS, SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS', 96289, 1100064, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4759, 13580, 'CARTORIO UNICO DE NOTAS DE GUAJARA MIRIM', 96081, 1100106, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4760, 4491, 'CARTORIO DE REGISTRO CIVIL E NOTAS - TABELIONATO MANFREDO', 95752, 1100072, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4761, 4492, 'OFICIO DE REGISTRO CIVIL E ANEXOS', 96115, 1100080, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4762, 4493, 'OFICIO DE REGISTRO CIVIL E DE NOTAS', 130328, 1100940, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4763, 4494, 'CARTORIO DE NOTAS, REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, PROTESTOS DE TITULOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 95778, 1100098, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4764, 5150, 'TABELIONATO DE NOTAS E REGISTRO CIVIL DE GOVERNADOR JORGE TEIXEIRA', 130336, 1101005, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4765, 6610, 'CARTORIO DE REGISTRO CIVIL E IMOVEIS', 95844, 1100106, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4767, 13582, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 95885, 1101104, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4768, 13583, 'TABELIONATO DE PROTESTO DE TITULOS', 96453, 1100114, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4769, 5151, 'CARTORIO REGISTRO CIVIL E PESSOAS NATURAIS DE JARU/RO', 96065, 1100114, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4770, 13584, 'TABELIONATO DE PROTESTO DE TITULOS', 144717, 4110607, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4771, 4277, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO PRECARIAMENTE O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84723, 4110607, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4772, 13585, 'TABELIONATO DE NOTAS', 87742, 4110607, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4773, 3795, 'SERVICO DISTRITAL DE VILA NILZA', 83592, 4110607, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4774, 3796, 'SERVICO DISTRITAL DE IRACEMA DO OESTE', 130609, 4110656, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4775, 13586, '1° SERVICO DE REGISTRO DE IMOVEIS', 79814, 4110706, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4776, 13587, '2° TABELIONATO DE NOTAS', 80127, 4110706, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4777, 13588, '1º TABELIONATO DE NOTAS, ACUMULANDO O 2º SERVICO DE REGISTRO DE IMOVEIS E O TABELIONATO DE PROTESTO DE TITULOS', 80010, 4110706, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4778, 3797, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS ACUMULANDO, PRECARIAMENTE O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81687, 4110706, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4779, 13589, 'TABELIONATO DE NOTAS ', 88047, 4110805, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4780, 3798, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS', 81992, 4110805, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4781, 13590, 'TABELIONATO DE PROTESTO DE TITULOS', 82826, 4110805, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4782, 4278, 'SERVICO DISTRITAL DE ITAGUAJE', 83600, 4110904, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4783, 3799, 'SERVICO DISTRITAL DE ITAIPULANDIA', 86843, 4110953, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4784, 7326, 'SERVICO DISTRITAL DE ITAMBARACA ', 142067, 4111001, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4785, 4279, 'SERVICO DISTRITAL DE ITAMBE', 129767, 4111100, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4786, 4280, 'SERVICO DISTRITAL DE ITAPEJARA DO OESTE', 84764, 4111209, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4787, 4281, 'SERVICO DISTRITAL DE ITAPERUCU', 129924, 4111258, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4788, 3800, 'SERVICO DISTRITAL DE ITAUNA DO SUL', 144899, 4111308, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4789, 4282, 'SERVICO DISTRITAL DE IVAI', 84269, 4111407, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4790, 3747, 'SERVICO DISTRITAL DE BOM JARDIM DO SUL', 82792, 4111407, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4791, 3335, 'CARTORIO DO REGISTRO CIVIL', 75325, 2613404, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4792, 9977, 'CART.UNICO DE NOTAS E REGISTROS', 73858, 2613404, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4793, 9978, 'CARTORIO DO SEGUNDO OFICIO DE SAO JOSE DO BELMONTE', 76398, 2613503, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4794, 3336, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 77156, 2613503, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4795, 9979, 'CARTORIO DE NOTAS: TABELIONATO - OFICAL DO REGISTRO IMOBILIARIO - REGISTRO TITULOS E DOCUMENTOS', 74054, 2613503, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4796, 9980, 'CARTORIO REGISTRO DE IMOVEIS ', 76737, 2613602, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4797, 3337, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 74534, 2613602, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4798, 3339, 'CARTORIO DE REGISTRO CIVIL DE BONFIM', 74385, 2613602, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4799, 9981, 'CARTORIO DO 2º OFICIO DE NOTAS', 74898, 2613602, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4800, 3338, 'CARTORIO DO REGISTRO CIVIL DE RIACHO DO MEIO', 75986, 2613602, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4801, 3340, 'CARTORIO DE REGISTRO CIVIL', 74112, 2613701, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4802, 9982, 'CARTORO UNICO DE SAO LOURENCO DA MATA', 77065, 2613701, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4803, 13528, 'TABELIONATO DE NOTAS', 87395, 4109807, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4804, 3342, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS DE SIRIJI', 75978, 2613800, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4805, 9983, 'TABELIONATO, REGISTRO DE IMOVEIS E SEUS ANEXOS', 77735, 2613800, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4806, 3341, 'CARTORIO DE REGISTRO CIVIL', 74161, 2613800, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4807, 9984, 'CARTORIO DO 1º OFICIO', 74815, 2613909, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4808, 3343, 'CARTORIO DO REGISTRO CIVIL -3º DISTRITO', 75358, 2613909, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4809, 6540, 'CARTORIO DE REGISTRO CIVIL SEDE', 74716, 2613909, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4810, 4561, 'CARTORIO DO REGISTRO CIVIL - TAUAPIRANGA', 75341, 2613909, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4811, 9985, 'CARTORIO DO REGISTRO CIVIL', 75176, 2613909, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4812, 9986, 'CARTORIO DO 2º OFICIO', 74872, 2613909, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4813, 3344, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º. DISTRITO DE BERNARDO VIEIRA', 75747, 2613909, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4814, 9987, 'CARTORIO UNICO DE SERRITA', 150870, 2614006, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4815, 3760, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE SERRITA', 129445, 2614006, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4816, 9988, 'CARTORIO DO 2º OFICIO E PROTESTO DE TITULOS', 74948, 2614105, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4817, 9989, '1° OFICIO DE NOTAS E REGISTROS PUBLICOS DE SERTANIA', 73486, 2614105, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4818, 4562, 'SERTANIA CARTORIO REGISTRO CIVIL', 77495, 2614105, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4819, 4563, 'CARTORIO DE REGISTRO CIVIL DO 2° DISTRITO DE SIRINHAEM', 150003, 2614204, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4820, 3761, 'CARTORIO DO REGISTRO CIVIL DO 1º DIST. DE SIRINHEM', 75739, 2614204, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4821, 9990, 'CARTORIO OFICIO UNICO DE SIRINHAEM', 150821, 2614204, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4822, 3684, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE SOLIDAO', 77362, 2614402, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4823, 9991, 'PRIMEIRO OFICIO NOTARIAL E REGISTRAL DE SURUBIM', 77214, 2614501, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4824, 4564, 'CARTORIO REGISTRO CIVIL DE SURUBIM', 76679, 2614501, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4825, 9992, '2° TABELIONATO DE NOTAS', 73619, 2614501, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4826, 4565, 'REGISTRO CIVIL DE TABIRA -PE', 77453, 2614600, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4827, 9993, 'CARTORIO UNICO DE TABIRA', 76976, 2614600, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4828, 4566, 'TACAIMBO CARTORIO UNICO DE NOTAS', 77743, 2614709, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4829, 4567, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75515, 2614808, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4830, 9994, 'OFICIO UNICO DE TACARATU - PE', 77198, 2614808, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4831, 4568, 'CARTORIO DO REGISTRO CIVIL PESSOAS NATURAIS DE TAMANDARE', 76307, 2614857, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4832, 3685, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS - SAUE', 74286, 2614857, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4833, 4315, 'CARTORIO DO RGISTRO CIVIL', 76356, 2615003, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4834, 4569, 'CARTORIO DE REGISTRO CIVIL', 74146, 2615003, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4835, 9995, 'SERVICO NOTARIAL E REGISTRAL', 76513, 2615003, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4836, 4316, 'CARTORIO DO REGISTRO CIVIL', 75168, 2615102, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4837, 4570, 'CARTORIO DE REGISTRO CIVIL DE TERRA NOVA', 74591, 2615201, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4838, 9996, 'CARTORIO UNICO TERRA NOVA', 150888, 2615201, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4839, 4571, 'CARTORIO REGISTRO CIVIL', 76596, 2615300, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4840, 4572, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75473, 2615300, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4841, 3686, 'CARTORIO REGISTRO CIVIL ', 76612, 2615300, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4842, 9997, 'CARTORIO 2 OFICIO TABELIONATO NOTAS E PROTESTOS', 150730, 2615300, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4843, 9998, '1º SERVICO DE TABELIONATO DE NOTAS E REGISTRO DE IMOVEIS DE TIMBAUBA', 73569, 2615300, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4844, 9999, 'CARTORIO UNICO', 76752, 2615409, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4845, 4573, 'CARTORIO REGISTRO CIVIL DE TORITAMA', 76687, 2615409, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4846, 3687, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE TRACUNHAEM', 74658, 2615508, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4847, 3688, 'CARTORIO DE REGISTRO CIVIL', 74153, 2615607, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4848, 10000, 'CARTORIO UNICO', 76778, 2615607, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4849, 10001, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 131193, 2615706, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4850, 10002, 'CART.NOTAS.PROT.REGS. PUBLICOS', 73841, 2615706, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4851, 4317, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 76109, 2615805, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4852, 3762, 'CARTORIO DE REGISTRO CIVIL', 74088, 2615904, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4853, 10003, 'CARTORIO UNICO DE NOTAS E REGISTROS', 76893, 2615904, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4854, 3613, 'CARTORIO DE REGISTRO CIVIL DA PESSOAS NATURAIS', 74229, 2616001, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4855, 3763, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 76224, 2616001, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4856, 10004, 'CARTORIO DO OFICIO UNICO', 75002, 2616001, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4857, 4574, 'CARTORIO UNICO', 152421, 2616100, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4858, 3614, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 77289, 2616100, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4859, 4575, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 77347, 2616183, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4860, 10005, 'CARTORIO UNICO', 152405, 2616209, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4861, 4576, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75531, 2616209, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4862, 3764, 'CARTORIO DO REGISTRO CIVIL DE VICENCIA', 76034, 2616308, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4863, 10006, 'CARTORIO UNICO - SERVICOS NOTARIAIS E REGISTRAIS', 76786, 2616308, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4864, 10007, '1º SERVICO NORTARIAL E REGISTRAL JOSE BORBA', 73577, 2616407, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4865, 3765, 'REGISTRO CIVIL DAS PESSOA NATURAIS', 77271, 2616407, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4866, 10008, '2º TABELIONATO DE NOTAS E PRIVATIVO DE PROTESTOS', 73650, 2616407, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4867, 4577, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO', 77388, 2616407, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4868, 4578, 'CARTORIO DO REGISTRO CIVIL DO XEXEU', 76075, 2616506, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4869, 3766, 'CARTORIO UNICO DE AGRICOLANDIA', 140723, 2200103, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4870, 10009, 'CARTORIO BENEVIDES - 1º OFICIO DE NOTAS', 78022, 2200202, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4871, 4318, 'CARTORIO UNICO', 79384, 2200251, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4872, 4319, 'CARTORIO 1º OFICIO', 77958, 2200301, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4873, 10010, 'ALTOS CARTORIO 1° OFICIO DE NOTAS', 77883, 2200400, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4874, 4320, 'ALTOS CARTORIO PUBLICO DO SEGUNDO OFICIO', 77891, 2200400, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4875, 4579, 'CARTORIO DO 1º OFICIO DE REGISTRO CIVIL', 78436, 2200509, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4876, 4580, 'CARTORIO UNICO DE ANGICAL DO PIAUI', 149187, 2200608, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4877, 10011, 'CARTORIO UNICO', 140517, 2200707, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4878, 4581, 'CARTORIO UNICO DE ANTONIO ALMEIDA', 148668, 2200806, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4879, 10012, 'CARTORIO UNICO DE AROAZES', 148494, 2200905, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4880, 4582, 'CARTORIO UNICO DE ARRAIAL', 148015, 2201002, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4881, 10013, 'CARTORIO DO 1º OFICIO', 78279, 2201101, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4882, 10014, 'CARTORIO UNICO DE BARRAS', 148320, 2201200, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4883, 4583, 'CARTORIO DO PRIMEIRO OFICIO DA COMARCA DE BARRO DURO', 79053, 2201408, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4884, 3767, 'CARTORIO LUIZ CASTRO - 1º OFICIO DE NOTAS', 79301, 2201507, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4885, 4321, 'CARTORIO ANTONIO LOPES  1º OFICIO DE NOTAS', 140509, 2201606, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4886, 3768, 'CARTORIO DO 2.° OFICIO', 78535, 2201705, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4887, 10015, 'CARTORIO DO 1º OFICIO DE BERTOLINIA', 78402, 2201705, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4888, 10016, 'CARTORIO UNICO DE BOCAINA ', 148379, 2201804, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4889, 3769, 'CARTORIO ', 77925, 2201903, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4890, 10017, 'CARTORIO ', 77909, 2201903, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4891, 10018, 'CARTORIO DO 1º OFICIO', 78121, 2202000, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4892, 10019, 'CARTORIO UNICO DE CABECEIRAS DO PIAUI', 148676, 2202059, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4893, 10020, 'CARTORIO UNICO DE CAMPINAS DO PIAUI', 148932, 2202109, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4894, 10021, 'CARTORIO UNICO DE CAMPO MAIOR', 148338, 2202208, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4895, 4322, 'CARTORIO MANOEL BARBOSA E SILVA', 79319, 2202307, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4896, 10022, '2º CARTORIO DE REGISTRO CIVIL', 140533, 2202406, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4897, 10023, 'CARTORIO UNICO DE CARACOL', 149286, 2202505, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4898, 3770, '2º OFICIO DE NOTAS, REGISTRO CIVIL E PROTESTO DE TITULOS', 77859, 2202604, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4899, 10024, 'CARTORIO DO 1º OFICIO DE REGISTRO DE IMOVEIS', 78444, 2202604, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4900, 3771, 'CARTORIO DO 1º OFICIO', 78212, 2202703, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4901, 3772, 'CARTORIO 1º OFICIO', 77933, 2202802, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4902, 10025, 'CARTORIO UNICO DE CORRENTE', 148858, 2202901, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4903, 10026, 'CARTORIO UNICO DE CRISTALANDIA DO PIAUI', 149088, 2203008, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4904, 4323, 'CARTORIO DO 1º OFICIO', 78154, 2203107, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4905, 10027, 'CARTORIO DO 1º OFICIO', 78162, 2203206, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4906, 10028, 'CARTORIO UNICO DE DEMERVAL LOBAO', 149526, 2203305, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4907, 4635, 'CRISTOVAO DE SANTANA BRAGA', 79525, 2203354, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4908, 10029, 'CARTORIO UNICO DE DOM INOCENCIO', 149567, 2203453, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4909, 10030, 'CARTORIO 1º OFICIO DE NOTAS', 77966, 2203503, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4910, 4636, 'CARTORIO DO 2º OFICIO DE NOTAS', 78857, 2203503, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4911, 10031, 'CARTORIO UNICO DE ELIZEU MARTINS', 78220, 2203602, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4912, 7382, '1º CARTORIO DE REGISTRO DE IMOVEIS', 140756, 2203701, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4913, 10032, 'CARTORIO UNICO', 140566, 2203800, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4914, 10033, 'CARTORIO LEAL - 2º OFICIO DE NOTAS', 77974, 2203909, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4915, 10034, 'CARTORIO CARVALHO-3º OFICIO DE NOTAS E REGISTRO DE IMOVEIS', 78055, 2203909, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4916, 10035, 'CARTORIO ROCHA 1º OFICIO', 79376, 2203909, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4917, 10036, 'CARTORIO UNICO DE FRANCINOPOLIS', 148353, 2204006, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4918, 4637, 'CARTORIO UNICO DE FRANCISCO AIRES', 79418, 2204105, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4919, 4638, 'CARTORIO DO REGISTRO CIVIL DO 2º OFICIO', 79145, 2204204, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4920, 4639, 'CARTORIO UNICO DE FRONTEIRAS -PI, REGISTRO DE IMOVEIS CIVIL NOTAS E PROTESTOS  ', 78311, 2204303, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4921, 3689, 'CARTORIO DO 1º OFICIO DE NOTAS', 140764, 2204402, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4922, 10037, 'CARTORIO UNICO DE BARREIRAS DO PIAUI', 140574, 2204402, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4923, 10038, 'CARTORIO UNICO DE GUADALUPE', 148544, 2204501, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4924, 10039, 'CARTORIO UNICO -TJ', 79392, 2204600, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4925, 10040, 'CARTORIO DO 1º OFICIO ', 78345, 2204709, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4926, 10041, 'CARTORIO MARIA DE MOURA RUFINO', 79327, 2204808, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4927, 10042, 'CARTORIO UNICO DE ISAIAS COELHO', 149096, 2204907, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4928, 10043, 'CARTORIO UNICO DE ITAINOPOLIS', 148965, 2205003, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4929, 10044, '1º CARTORIO DE REGISTRO DE IMOVEIS', 140772, 2205102, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4930, 10045, 'CARTORIO DO 1º OFICIO E REGISTRO DE IMOVEIS JAICOS (PI)', 78477, 2205201, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4931, 4640, 'CARTORIO DO 2º OFICIO OFICIO', 78907, 2205201, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4932, 3690, 'CARTORIO UNICO', 77818, 2205300, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4933, 3691, 'CARTORIO NICOLAU DE OLIVEIRA', 77917, 2205409, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4934, 10046, 'CARTORIO 1º OFICIO', 77941, 2205508, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4935, 4641, 'CARTORIO 2º OFICIO', 77990, 2205508, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4936, 10047, 'CARTORIO UNICO DE REGISTROS, NOTAS E ANEXOS', 78360, 2205607, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4937, 3693, 'CARTORIO DO 1ª OFICIO DE LUIZ CORREIA', 78089, 2205706, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4938, 10048, 'CARTORIO JOAO MELO DE CARVALHO - 1° OFICIO', 79293, 2205805, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4939, 4642, 'CARTORIO DO SEGUNDO OFICIO E REGISTRO CIVIL', 79244, 2205904, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4940, 3694, 'CARTORIO UNICO OFICIALIZADO', 78527, 2205953, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4941, 10049, 'CARTORIO UNICO', 78253, 2206001, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4942, 3695, 'CARTORIO UNICO', 79186, 2206100, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4943, 3696, 'CARTORIO UNICO DE MIGUEL ALVES', 149435, 2206209, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4944, 10050, 'CARTORIO UNICO DE MIGUEL LEAO', 148882, 2206308, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4945, 3697, '1º CARTORIO DE REGISTRO CIVIL', 140590, 2206407, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4946, 4643, 'MONSENHOR HIPOLITO CARTORIO UNICO REGISTRO DE IMOVEIS', 79533, 2206506, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4947, 10051, 'CARTORIO UNICO DE MONTE ALEGRE DO PIAUI', 148502, 2206605, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4948, 10052, '1º CARTORIO DE REGISTRO DE IMOVEIS', 140608, 2206704, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4949, 3698, 'NONATO CHAVES', 79558, 2206803, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4950, 3699, 'CARTORIO UNICO SOCORRO SOBREIRA', 79483, 2206902, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4951, 10053, 'CARTORIO 3º OFICIO DE NOTAS BENEDITO DE DEUS BARBOSA ', 78006, 2207009, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4952, 4644, 'CARTORIO DO QUARTO OFICIO NOTAS E RG', 79095, 2207009, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4953, 10054, 'CARTORIO DO PRIMEIRO OFICIO NOTAS', 79087, 2207009, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4954, 3700, 'CARTORIO UNICO', 78873, 2207207, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4955, 3701, 'CARTORIO DO UNICO OFICIO', 78667, 2207306, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4956, 3702, 'CARTORIO UNICO ALDINA DE OLIVEIRA MOURA', 148080, 2207405, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4957, 3703, 'CARTORIO DO PRIMEIRO OFICIO', 79004, 2207504, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4958, 10055, 'CARTORIO UNICO DE NOTAS E REGISTROS PUBLICOS', 153338, 2207603, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4959, 4645, '1º CARTORIO DE REGISTRO CIVIL', 140624, 2207702, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4960, 10056, 'CARTORIO ALMENDRA - 1O OFICIO', 78014, 2207702, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4961, 10057, 'CARTORIO BEZERRA', 78030, 2207702, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4962, 10058, '3º CARTORIO DE NOTAS', 140806, 2207702, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4963, 3705, 'PAULISTANA CARTORIO DO 2º OFICIO DE NOTAS', 79574, 2207801, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4964, 10059, 'PAULISTANA CARTORIO 1ºOFICIO  REGISTRO DE IMOVEIS', 79566, 2207801, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4965, 4325, 'CARTORIO DO 2º OFICIO', 78808, 2207900, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4966, 10060, 'CARTORIO DO PRIMEIRO OFICIO', 79012, 2207900, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4967, 4324, 'CARTORIO UNICO DE DOMINGOS MOURAO', 79400, 2207900, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4968, 3615, 'PICOS CARTORIO DO REGISTRO CIVIL E 4° OFICIO DE NOTAS', 79590, 2208007, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4969, 3706, 'CARTORIO DO 3º OFICIO DE NOTAS  DE PICOS', 78972, 2208007, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4970, 10061, 'CARTORIO 2° OFICIO DE REGISTRO DE IMOVEIS ZONA NORTE', 77982, 2208007, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4971, 10062, 'PICOS CARTORIO DO 1º OFICIO REGISTRO DE IMOVEIS', 79582, 2208007, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4972, 3616, 'CARTORIO UNICO DO TERMO DE DOM EXPEDITO LOPES', 79467, 2208007, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4973, 10063, 'CARTORIO UNICO', 78386, 2208106, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4974, 10064, 'CARTORIO IZIDRO DE ALENCAR BEZERRA - 1º OFICIO', 79269, 2208205, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4975, 13676, 'TABELIONATO DE NOTAS', 129841, 4127106, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4976, 3678, 'SERVICO DISTRITAL DE MALU', 81505, 4127205, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4977, 13677, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE O TABELIONATO DE PROTESTO DE TITULOS.', 88039, 4127205, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4978, 13678, 'SERVICO DE REGISTRO DE IMOVEIS', 86157, 4127205, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4979, 3679, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81679, 4127205, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4980, 3680, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS ', 81042, 4127304, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4981, 13679, 'SERVICO DE REGISTRO DE IMOVEIS', 85027, 4127304, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4982, 13680, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE O TABELIONATO DE PROTESTO DE TITULOS ', 81232, 4127304, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4983, 13681, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 88369, 4127403, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4984, 3682, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 87007, 4127403, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4985, 3681, 'SERVICO DISTRITAL DE SANTA RITA DO OESTE', 82388, 4127403, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4986, 13682, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO PRECARIAMENTE O SERVICO DE REGISTRO CIVIL DE PESSOAS NATURAIS, SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 88351, 4127403, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4987, 4531, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 88377, 4127502, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4988, 13683, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87726, 4127502, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4989, 13684, 'SERVICOS REGISTRO DE IMOVEIS ', 82719, 4127502, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4990, 4532, 'SERVICO DISTRITAL DE TIJUCAS DO SUL', 131409, 4127601, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4991, 4534, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E 3º TABELIONATO DE NOTAS', 85894, 4127700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4992, 13685, '2° SERVENTIA NOTARIAL - TABELIONATO REIS', 80317, 4127700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4993, 4458, 'SERVICO DISTRITAL DE VILA NOVA', 88393, 4127700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4994, 13686, '2. OFICIO DO REGISTRO DE IMOVEIS', 88914, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4995, 4990, 'TERCEIRA CIRCUNSCRICAO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DA CAPITAL - RJ', 93682, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4996, 13687, 'REGISTRO CIVIL DE PESSOAS JURIDICAS', 93245, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4997, 13688, 'TABELIONATO DO 1º OFICIO DE PROTESTO DE TITULOS DO RIO DE JANEIRO', 93641, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4998, 13689, '2 OFICIO DE NOTAS DO RIO DE JANEIRO', 88906, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (4999, 13690, 'CARTORIO 9º OFICIO DO REGISTRO DE DISTRIBUICAO', 89748, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5000, 13691, '20º OFICIO DE NOTAS', 88922, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5001, 13692, '16 OFICIO DE NOTAS', 88658, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5002, 6557, 'CARTORIO DO RCPN E NOTAS DO 4º DISTRITO DE MAGE', 91264, 3302502, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5003, 13348, 'DISTRIBUIDOR, CONTADOR E PARTIDOR  ', 91850, 3302502, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5004, 13349, 'CARTORIO 3° OFICIO DE MAGE', 89656, 3302502, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5005, 4939, 'RCPN 1º DISTRITO DE MAGE', 92577, 3302502, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5006, 13350, 'CARTORIO DO 2º OFICIO DE JUSTICA DE MAGE', 90522, 3302502, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5007, 4940, 'CARTORIO DE RCPN E NOTAS DO 6º DISTRITO DE MAGE', 89839, 3302502, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5008, 13351, 'SERVICO NOTARIAL E REGISTRAL DO 1º OFICIO DE MAGE/RJ', 90183, 3302502, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5009, 4937, 'SERVICO NOTARIAL E REGISTRAL CIVIL DAS PESSOAS NATURAIS DO 5º.DISTRITO DE MAGE', 93526, 3302502, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5010, 13352, 'DISTRIBUIDOR, CONTADOR E PARTIDOR', 91868, 3302601, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5011, 13353, 'OFICIO UNICO DE MANGARATIBA', 154492, 3302601, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5012, 13354, '1º OFICIO DE MANGARATIBA', 88864, 3302601, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5013, 13355, 'SERVICO NOTARIAL E RGI DE MARICA- 2º OFICIO', 93591, 3302700, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5014, 13356, 'DISTRIBUIDOR, CONTADOR E PARTIDOR', 91801, 3302700, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5015, 6558, 'REGISTRO CIVIL DO PRIMEIRO DISTRITO DE MARICA', 93302, 3302700, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5016, 4943, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º DISTRITO DA COMARCA DE MARICA', 146035, 3302700, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5017, 13357, 'CARTORIO DO 1° OFICIO DE MARICA/RJ', 90175, 3302700, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5018, 4942, 'RCPN 3º DISTRITO', 92676, 3302700, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5019, 4944, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 1º DISTRITO DA COMARCA DE MENDES', 93179, 3302809, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5020, 13358, 'DCP', 91645, 3302809, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5021, 13359, 'CARTORIO DO OFICIO UNICO DE MENDES', 89409, 3302809, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5022, 13360, 'CARTORIO DO OFICIO UNICO DE MENDES', 91066, 3302809, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5023, 13361, '1º OFICIO DE JUSTICA DO MUNICIPIO DE MESQUITA', 153346, 3302858, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5024, 13362, '2º OFICIO PRIVATIVO DO REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 154302, 3302858, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5025, 13363, 'CARTORIO DO DISTRIBUIDOR', 90845, 3302908, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5026, 13364, 'OFICIO UNICO DE MIGUEL PEREIRA', 154518, 3302908, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5027, 13365, 'CARTORIO DO 1º OFICIO DE JUSTICA', 90258, 3303005, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5028, 13366, 'DISTRIBUIDOR, CONTADOR E PARTIDOR', 91827, 3303005, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5029, 13367, 'CARTORIO DO 2º OFICIO DE JUSTICA', 90480, 3303005, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5030, 13368, 'CARTORIO DO DISTRIBUIDOR, CONTADOR E PARTIDOR', 89920, 3303104, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5031, 6559, 'OFICIO UNICO DE NATIVIDADE', 88740, 3303104, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5116, 13407, 'SERVICO DE REGISTRO DE IMOVEIS', 85357, 4121802, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5032, 4947, 'CARTORIO DE REGISTRO CIVIL E INTERDICOES E TUTELAS DO 1O.DISTRITO DE NILOPOLIS', 89854, 3303203, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5033, 13369, 'DISTRIBUIDOR, CONTADOR, PARTIDOR, AVALIADOR E DEPOSITARIO JUDICIAL', 92023, 3303203, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5034, 13370, '2 OFICIO DE NILOPOLIS', 88898, 3303203, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5035, 13371, 'NILOPOLIS CARTORIO DO TERCEIRO OFICIO DE JUSTICA', 92080, 3303203, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5036, 13372, 'QUARTO OFICIO DE JUSTICA DE NILOPOLIS', 92361, 3303203, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5037, 4953, 'RCPN 2º DISTRITO DE NILOPOLIS', 92650, 3303203, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5038, 13373, '1° OFICIO DE NOTAS DE MACAIBA/RN', 93740, 2407104, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5039, 4706, 'SEGUNDO OFICIO DE NOTAS DE MACAIBA', 95372, 2407104, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5040, 13374, 'TERCEIRO OFICIO DE NOTAS', 95562, 2407203, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5041, 4707, '2º OFICIO DE NOTAS', 93914, 2407203, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5042, 13375, '1 OFICIO DE NOTAS', 93732, 2407203, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5043, 6594, 'OFICIO UNICO DE MAJOR SALES', 95075, 2407252, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5044, 5088, 'OFICIO UNICO DA COMARCA DE MARCELINO VIEIRA', 95018, 2407302, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5045, 13376, 'OFICIO UNICO DA COMARCA DE MARTINS', 130930, 2407401, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5046, 5089, 'CARTORIO UNICO DE MAXARANGUAPE', 94425, 2407500, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5047, 5090, 'CARTORIO UNICO JUDICIARIO', 94680, 2407609, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5048, 5091, 'CARTORIO UNICO JUDICIARIO', 94607, 2407708, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5049, 6595, 'SERVICO NOTARIAL E REGISTRAL DE MONTE ALEGRE', 95448, 2407807, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5050, 5092, 'CARTORIO UNICO DO TERMO DE MONTE DAS GAMELEIRAS', 94524, 2407906, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5051, 13377, 'MOSSORO CARTORIO TERCEIRO OFICIO DE NOTAS', 94938, 2408003, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5052, 13378, 'MOSSORO CARTORIO PRIMEIRO OFICIO DE NOTAS - CARTORIO VIEIRA', 94904, 2408003, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5053, 5093, 'CARTORIO DO QUARTO OFICIO DE NOTAS', 94193, 2408003, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5054, 13379, '5° SERVICO NOTARIAL E REGISTRAL DE MOSSORO', 95331, 2408003, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5055, 13380, 'MOSSORO CARTORIO SEXTO OFICIO DE NOTAS', 94920, 2408003, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5056, 13381, 'MOSSORO CARTORIO SETIMO OFICIO DE NOTAS', 94912, 2408003, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5057, 5094, 'MOSSORO SEGUNDO OFICIO DE NOTAS', 94946, 2408003, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5058, 5095, 'CARTORIO UNICO DE IGAPO', 94391, 2408102, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5059, 5096, 'CARTORIO UNICO DO TERMO EXTRAJUDICIARIO DA REDINHA', 94532, 2408102, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5060, 13382, 'NATAL CARTORIO 2 OFICIO DE NOTAS', 94953, 2408102, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5061, 5097, 'NATAL CARTORIO DO QUARTO OFICIO DE NOTAS', 94987, 2408102, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5062, 13383, 'PRIMEIRO OFICIO DE NOTAS', 95307, 2408102, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5063, 13384, '6º OFICIO DE NOTAS', 93989, 2408102, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5064, 6596, 'NATAL CARTORIO DO QUINTO OFICIO DE NOTAS', 94995, 2408102, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5065, 13385, 'NATAL CARTORIO 3º OFICIO', 94961, 2408102, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5066, 13386, 'NATAL CARTORIO 7º OFICIO DE NOTAS', 94979, 2408102, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5067, 5098, 'SERVICO UNICO NOTARIAL E REGISTRAL', 95489, 2408201, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5068, 13387, '1. CARTORIO DE NOTAS', 94235, 2408300, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5069, 13388, 'NOVA CRUZ CARTORIO DO TERCEIRO OFICIO DE NOTAS', 95000, 2408300, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5070, 6597, '2 OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 93831, 2408300, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5071, 5099, 'CARTORIO UNICO DE OLHO DAGUA DO BORGES', 94466, 2408409, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5072, 5100, 'CARTORIO UNICO JUDICIARIO DO TERMO DE OURO BRANCO/RN', 94805, 2408508, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5073, 5101, 'OFICIO UNICO DE PARANA', 95158, 2408607, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5074, 5102, 'PARAU CARTORIO UNICO DE NOTAS', 131128, 2408706, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5075, 13389, 'OFICIO UNICO DE PARAZINHO', 95166, 2408805, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5076, 5103, 'UNICO OFICIO DE NOTAS DA COMARCA DE PARELHAS/RN', 95646, 2408904, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5077, 4266, 'SERVICO DISTRITAL DE FENIX ', 141531, 4107504, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5078, 13390, 'SERVICO DE REGISTRO DE IMOVEIS', 85266, 4107504, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5079, 4618, 'SERVICO DISTRITAL DE  ENTRE RIOS DO OESTE', 82974, 4107538, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5080, 7321, 'SERVICO DISTRITAL DE ESPERANCA NOVA', 145474, 4107520, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5081, 4619, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 141804, 4107546, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5082, 4269, 'SERVICO DISTRITAL DE FAROL', 81018, 4107553, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5083, 4270, 'CARTORIO DE REGISTRO CIVIL ANEXOS TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 81315, 4107603, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5084, 13391, 'SERVICO DE REGISTRO DE IMOVEIS', 85084, 4107603, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5085, 13392, 'CARTORIO DE NOTAS E PROTESTOS TITULOS', 81133, 4107603, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5086, 13393, 'TABELIONATO DE NOTAS', 141556, 4107652, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5087, 4620, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE,  O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 129957, 4107652, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5088, 13394, 'TABELIONATO DE PROTESTO DE TITULOS', 84087, 4107652, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5089, 13395, 'SERVICO DE REGISTRO DE IMOVEIS', 81976, 4107652, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5090, 3740, 'SERVICO DISTRITAL DE FERNANDES PINHEIRO', 82198, 4107736, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5091, 4621, 'SERVICO DISTRITAL DE FIGUEIRA', 82578, 4107751, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5092, 4622, 'SERVICO DISTRITAL DE FLOR DA SERRA DO SUL-PR', 84830, 4107850, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5093, 4623, 'SERVICO DISTRITAL DE FLORAI', 86892, 4107801, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5094, 4624, 'SERVICO DISTRITAL DE FLORESTA', 85639, 4107900, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5095, 4625, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 82586, 4108007, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5096, 3773, 'SERVICO DISTRITAL DE FLORIDA', 86454, 4108106, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5097, 13396, 'TABELIONATO DE NOTAS E ACUMULADO PRECARIAMENTE O PROTESTO DE TITULOS', 88062, 4108205, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5098, 3741, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 83410, 4108205, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5099, 13397, '1º TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O 1º TABELIONATO DE PROTESTO DE TITULOS', 80036, 4108304, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5100, 13398, '1º SERVICO DE REGISTRO DE IMOVEIS', 84582, 4108304, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5101, 13399, '2º SERVICO DE REGISTRO DE IMOVEIS', 80259, 4108304, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5102, 3742, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE,O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS.', 79897, 4108304, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5103, 13400, '2º TABELIONATO DE NOTAS', 80341, 4108304, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5104, 3743, 'SERVICO DISTRITAL DE FOZ DO JORDAO', 83303, 4108452, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5105, 4626, 'SERVICO DISTRITAL DE FRANCISCO ALVES', 86512, 4108320, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5106, 3744, 'SERVICO DISTRITAL DE RIO BONITO', 81190, 4108320, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5107, 13401, '1º TABELIONATO DE NOTAS', 83428, 4108403, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5108, 13402, '2º SERVICO DE REGISTRO DE IMOVEIS', 80184, 4108403, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5109, 3745, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 83436, 4108403, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5110, 13403, '2º TABELIONATO DE NOTAS', 80283, 4108403, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5111, 13404, 'TABELIONATO DE PROTESTO DE TITULOS', 130245, 4108403, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5112, 4420, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO PRECARIAMENTE O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85340, 4121703, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5113, 13405, 'TABELIONATO DE NOTAS, ACUMULANDO PRECARIAMENTE O TABELIONATO DE PROTESTO DE TITULOS', 84061, 4121703, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5114, 4421, 'SERVICO DISTRITAL DE RESERVA DO IGUACU', 82024, 4121752, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5115, 13406, 'TABELIONATO DE NOTAS ACUMULANDO PRECARIAMENTE O TABELIONATO DE  PROTESTO DE TITULOS', 85365, 4121802, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5117, 4422, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85928, 4121802, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5118, 4423, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E SERVICO DE REGITRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85993, 4121901, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5119, 13408, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTOS DE TITULOS', 82701, 4121901, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5120, 13409, 'SERVICO DE REGISTRO DE IMOVEIS', 87098, 4121901, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5121, 4424, 'SERVICO DISTRITAL DE RIO AZUL', 88252, 4122008, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5122, 4425, 'SERVICO DISTRITAL DE RIO BOM', 130294, 4122107, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5123, 4426, 'SERVICO DISTRITAL DE RIO BONITO DO IGUACU', 85373, 4122156, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5124, 4427, 'SERVICO DISTRITAL DE RIO BRANCO DO IVAI', 86835, 4122172, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5125, 13410, 'SERVICO DE REGISTRO DE IMOVEIS', 85035, 4122206, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5126, 4428, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85381, 4122206, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5127, 13411, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS.    ', 84053, 4122206, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5128, 13412, 'SERVICO DE REGISTRO DE IMOVEIS', 85415, 4122305, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5129, 13413, 'TABELIONATO DE NOTAS ACUMULANDO PRECARIAMENTE O TABELIONATO DE PROTESTO DE TITULOS', 85399, 4122305, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5130, 4429, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85407, 4122305, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5131, 4430, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81794, 4122404, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5132, 4431, 'SERVICO DISTRITAL DE SAO MARTINHO ', 130872, 4122404, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5133, 13414, '2º TABELIONATO DE NOTAS', 80333, 4122404, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5134, 13415, 'TABELIONATO DE PROTESTO DE TITULOS           ', 81224, 4122404, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5135, 13416, 'SERVICO DE REGISTRO DE IMOVEIS', 87155, 4122404, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5136, 13417, '1º TABELIONATO DE NOTAS ', 79996, 4122404, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5137, 4432, 'SERVICO DISTRITAL DE RONCADOR', 85423, 4122503, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5138, 4433, 'SERVICO DISTRITAL DE RONDON', 142158, 4122602, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5139, 4434, 'SERVICO DISTRITAL DE ROSARIO DO IVAI', 86678, 4122651, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5140, 4436, 'SERVICO DISTRITAL DE SABAUDIA', 87064, 4122701, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5141, 4435, 'SERVICO DISTRITAL DE BOM PROGRESSO', 86215, 4122701, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5142, 4437, 'SERVICO DISTRITAL DE SALGADO-FILHO', 85449, 4122800, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5143, 4438, 'SERVICO DISTRITAL DE SALTO DO ITARARE', 86637, 4122909, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5144, 13418, 'TABELIONATO DE NOTAS,ACUMULANDO, PRECARIAMENTE O TABELIONATO DE PROTESTO DE TITULOS ', 130922, 4123006, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5145, 13419, 'NOTAS E REGISTRO DE IMOVEIS', 92148, 3303203, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5146, 4955, 'RCPN 2O DISTRITO-5A ZONA JUDICIARIA DE NITEROI-RJ ', 92593, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5147, 4959, 'CARTORIO DO RCPN DA 6ª ZONA JUDICIARIA - 1º DISTRITO DE NITEROI - RJ', 91140, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5148, 13420, 'CARTORIO 4º OFICIO DE JUSTICA DE NITEROI', 89672, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5149, 13421, '6º OFICIO DE JUSTICA', 89326, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5150, 13422, 'NITEROI CARTORIO DO 2º DISTRIBUIDOR ', 92114, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5151, 13423, '3º DISTRIBUIDOR DE NITEROI', 89102, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5152, 4954, 'REGISTRO CIVIL DAS PESSOAS NATURAIS 1 DISTRITO 2 ZONA JUDICIARIA DE NITEROI - RJ', 93112, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5153, 13424, 'CARTORIO 10º OFICIO DE JUSTICA DE NITEROI', 89540, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5154, 13425, '2º OFICIO DE JUSTICA DE NITEROI', 89052, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5155, 13426, 'CARTORIO DO 3º OFICIO DE NITEROI', 90670, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5156, 4956, 'NITEROI - RCPN 1ª ZONA JUDICIARIA DE NITEROI - RJ', 92098, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5157, 4957, 'CARTORIO DE RCPN DA 3ª ZONA JUDICIARIA DE NITEROI - RJ', 89805, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5158, 13427, 'CARTORIO DO 18 OFICIO DE NITEROI', 90118, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5159, 13428, 'CARTORIO 11º OFICIO DE JUSTICA', 89565, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5160, 13429, '9º OFICIO DE JUSTICA DE NITEROI', 89417, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5161, 13430, 'CARTORIO DO 14º OFICIO DE JUSTICA DA COMARCA DE NITEROI', 90100, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5162, 13431, 'CARTORIO 8O. OFICIO DE NITEROI', 89714, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5163, 13432, 'CARTORIO DO 1º OFICIO DE JUSTICA DE NITEROI', 90308, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5164, 13433, 'PRIMEIRO DISTRIBUIDOR DE NITEROI', 92338, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5165, 13434, '13º OFICIO DE JUSTICA DA COMARCA DE NITEROI', 88609, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5166, 13435, 'NITEROI CARTORIO DO 15º OFICIO', 92106, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5167, 13436, 'CARTORIO DO QUINTO OFICIO DE NITEROI', 92130, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5168, 13437, 'CARTORIO DO 12 OFICIO DE NITEROI', 90084, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5169, 13438, 'NITEROI CARTORIO DO DECIMO NONO OFICIO', 92122, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5170, 13439, '16º OFICIO DE JUSTICA DA COMARCA DE NITEROI', 88666, 3303302, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5171, 13440, '1º OFICIO DE JUSTICA DE NOVA FRIBURGO', 88831, 3303401, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5172, 4963, 'RCPN 1º DISTRITO', 92536, 3303401, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5173, 4962, 'RCPN DO 3º DISTRITO DE NOVA FRIBURGO-RJ', 92858, 3303401, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5174, 13441, '3º OFICIO DE JUSTICA', 89110, 3303401, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5175, 13442, 'QUARTO OFICIO DE JUSTICA DE NOVA FRIBURGO', 92379, 3303401, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5176, 4961, 'RCPN E NOTAS DO SEXTO DISTRITO', 93021, 3303401, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5177, 13443, 'SEGUNDO OFICIO DE JUSTICA', 93484, 3303401, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5178, 13444, 'CARTORIO DISTRIBUIDOR, CONTADOR E PARTIDOR DE NOVA FRIBURGO ', 90027, 3303401, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5179, 4960, 'RCPN DO 5º DISTRITO DE NOVA FRIBURGO ', 92890, 3303401, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5180, 4964, 'RCPN E NOTAS EXTRAJUDICIAL', 93047, 3303401, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5181, 4966, 'CARTORIO RCPN DO 3 DISTRITO DE NOVA IGUACU', 91603, 3303500, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5182, 13445, 'PRIMEIRO OFICIO DE NOTAS', 95315, 2403251, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5183, 5104, 'SEGUNDO OFICIO DE NOTAS - CARTORIO PAIVA AMARAL', 95364, 2403251, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5184, 5105, 'CARTORIO LIMA SOUZA', 94227, 2409100, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5185, 13446, 'TERMO UNICO DE PASSAGEM/RN', 95596, 2409209, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5186, 4708, 'CARTORIO ANTENOR', 94094, 2409308, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5187, 5106, '2º CARTORIO OFICIO DE NOTAS', 93880, 2409407, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5188, 13447, 'PRIMEIRO CARTORIO OFICIO DE NOTAS', 95299, 2409407, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5189, 5107, 'CARTORIO UNICO JUDICIARIO', 94623, 2409506, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5190, 13448, 'CARTORIO UNICO', 131060, 2409605, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5191, 6598, 'SERVENTIA UNICA EXTRAJUDICIAL', 95398, 2409704, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5192, 13449, 'OFICIO UNICO DE PEDRO VELHO', 95174, 2409803, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5193, 13450, '1º OFICIO', 93765, 2409902, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5194, 13451, 'CARTORIO UNICO JUDICIARIO', 94656, 2410009, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5195, 5108, 'SERVICO NOTARIAL E REGISTRAL', 95406, 2410108, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5196, 5109, 'CARTORIO UNICO', 94284, 2410207, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5197, 13452, 'CARTORIO UNICO', 131011, 2410256, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5198, 5110, 'OIFCIO UNICO DE PUREZA', 95273, 2410405, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5199, 6599, 'OFICIO UNICO DE RAFAEL FERNANDES', 95182, 2410504, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5200, 5111, 'UNICO OFICIO DE NOTAS E REGISTRO GERAIS', 95653, 2410603, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5201, 5112, 'CARTORIO UNICO JUDICIARIO', 94672, 2410702, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5202, 5113, 'CARTORIO UNICO OFICIO DE NOTAS', 94847, 2410801, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5203, 6600, 'CARTORIO UNICO EXTRAJUDICIARIO', 94565, 2410900, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5204, 13453, 'CARTORIO UNICO DE RIO DO FOGO', 131037, 2408953, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5205, 5114, 'RODOLFO FERNANDES CARTORIO UNICO', 95349, 2411007, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5206, 5115, 'CARTORIO UNICO JUDICIARIO DE RUY BARBOSA', 94771, 2411106, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5207, 5116, '2º OFICIO DE NOTAS', 93922, 2411205, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5208, 13454, 'CARTORIO DO 1º OFICIO DE NOTAS', 94144, 2411205, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5209, 13455, 'CARTORIO UNICO EXTRAJUDICIAL DE SANTA MARIA', 131110, 2409332, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5210, 5117, 'SERVICO NOTARIAL E REGISTRAL', 95430, 2411403, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5211, 6601, 'CARTORIO UNIDO DE NOTAS DO TERMO DE SANTANA DO SERIDO/RN', 94854, 2411429, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5212, 5118, '2° OFICIO DE NOTAS', 93849, 2411502, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5213, 13456, 'ACERVO DE SERRINHA', 93997, 2411502, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5214, 13457, '1º OFICIO DE NOTAS DE SANTO ANTONIO/RN', 93807, 2411502, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5215, 13458, 'CARTORIO UNICO - TERMO DE JUNDIA', 131102, 2411502, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5216, 5119, 'SERVICO UNICO NOTARIAL E REGISTRAL', 95497, 2411601, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5217, 5120, 'CARTORIO UNICO EXTRAJUDICIAL', 94573, 2411700, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5218, 13459, 'CARTORIO UNICO JUDICIARIO', 94649, 2411809, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5219, 5121, 'CARTORIO UNICO OFICIO DE NOTAS ', 94813, 2411908, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5220, 13460, '2º OFICIO DA COMARCA DE SAO GONCALO DO AMARANTE, RN', 93906, 2412005, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5221, 13461, 'SAO GONCALO DO AMARANTE/RN 1º OFICIO DE NOTAS', 95323, 2412005, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5222, 13462, '1º SERVICO DE REGISTRO DE IMOVEIS', 86983, 4108403, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5223, 3746, 'SERVICO DISTRITAL DE GENERAL CARNEIRO', 82750, 4108502, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5224, 4627, 'SERVICO DISTRITAL DE GODOY MOREIRA', 87932, 4108551, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5225, 13463, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 83451, 4108601, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5226, 3774, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 83469, 4108601, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5227, 13464, 'SERVICO DE REGISTRO DE IMOVEIS', 85142, 4108601, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5228, 3775, 'SERVICO DISTRITAL DE GOIOXIM', 82206, 4108650, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5229, 13465, 'TABELIONATO DE PROTESTO DE TITULOS', 82693, 4108700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5230, 13466, 'SERVICO DE REGISTRO DE IMOVEIS', 81927, 4108700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5231, 4628, 'SERVICO DO REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULADO PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURDICAS.', 81703, 4108700, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5232, 13467, 'SERVICO DE REGISTRO DE IMOVEIS', 86033, 4108809, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5233, 13468, 'TABELIONATO DE NOTAS, ACUMULANDO PRECARIAMENTE TABELIONATO DE PROTESTOS DE TITULOS', 83485, 4108809, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5234, 3776, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS ', 84939, 4108809, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5235, 3777, 'SERVICO DISTRITAL DE DOUTOR OLIVEIRA CASTRO', 130914, 4108809, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5236, 4629, 'SERVICO DISTRITAL DE GUAIRACA', 129999, 4108908, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5237, 4630, 'SERVICO DISTRITAL DE GUAMIRANGA', 83568, 4108957, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5238, 3778, 'SERVICO DISTRITAL DE GUAPIRAMA', 84806, 4109005, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5239, 7324, 'SERVICO DISTRITAL DE GUAPOREMA', 142141, 4109104, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5240, 4631, 'SERVICO DISTRITAL DE GUARACI - JAGUAPITA', 86660, 4109203, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5241, 6672, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO PRECARIAMENTE,O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 83501, 4109302, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5242, 3779, 'SERVICO DISTRITAL DE GUAPORE', 81158, 4109302, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5243, 13469, 'SERVICO DE REGISTRO DE IMOVEIS', 83519, 4109302, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5244, 13470, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87700, 4109302, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5245, 13471, '2º TABELIONATO DE NOTAS', 83527, 4109401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5246, 6673, 'SERVICO DISTRITAL DE ENTRE RIOS', 86264, 4109401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5247, 13472, '2º. SERVICO DE REGISTRO DE IMOVEIS', 80390, 4109401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5248, 4632, 'SERVICO DISTRITAL MORRO ALTO', 82495, 4109401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5249, 13473, 'PRIMEIRO TABELIONATO DE NOTAS', 84590, 4109401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5250, 3784, 'SERVICO DISTRITAL DE BOQUEIRAO', 82131, 4109401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5251, 13474, '3º SERVICO DE REGISTRO DE IMOVEIS', 80432, 4109401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5252, 13475, '1º TABELIONATO DE PROTESTO DE TITULOS E 1ºSERVICO  DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 80069, 4109401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5253, 13476, '2º TABELIONATO DE PROTESTO DE TITULOS', 80374, 4109401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5254, 3780, 'CARTORIO DISTRITAL DE GUAIRACA', 82214, 4109401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5255, 3782, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E 2º SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS ', 81273, 4109401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5256, 3781, 'SERVICO DISTRITAL DE PALMEIRINHA', 82321, 4109401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5257, 4439, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84327, 4123006, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5258, 13477, 'SERVICO DE REGISTRO DE IMOVEIS', 85456, 4123006, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5259, 4440, 'SERVICO DISTRITAL DE SANTA AMELIA', 86918, 4123105, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5260, 4441, 'SERVICO DISTRITAL DE SANTA CECILIA DO PAVAO ', 88229, 4123204, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5261, 4442, 'SERVICO DISTRITAL DE SANTA CRUZ DE MONTE CASTELO', 81455, 4123303, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5262, 7305, 'OF REG CIVIL TIT E DOC E PES JUR - SANTA FE', 153411, 4123402, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5263, 13478, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS E SERVICO DE REGISTRO DE IMOVEIS', 81513, 4123402, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5264, 13479, 'SERVICO DE REGISTRO DE IMOVEIS', 85464, 4123501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5265, 4443, 'SERVICO DISTRITAL DE SAO CLEMENTE', 85472, 4123501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5266, 4444, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULADO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85910, 4123501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5267, 13480, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 85480, 4123501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5268, 13481, 'TABELIONATO DE NOTAS, ACUMULANDO,  PRECARIAMENTE O TABELIONATO DE PROTESTO DE TITULOS', 87502, 4123709, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5269, 4445, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84665, 4123709, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5270, 13482, 'SERVICO DE REGISTRO DE IMOVEIS', 85167, 4123709, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5271, 4446, 'SERVICO DISTRITAL DE SANTA IZABEL DO OESTE', 85498, 4123808, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5272, 4447, 'SERVICO DISTRITAL DE SANTA LUCIA', 82727, 4123824, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5273, 4449, 'SERVICO DISTRITAL DE SAO JOSE', 144923, 4123857, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5274, 4448, 'SERVICO DISTRITAL DE SANTA MARIA DO OESTE', 141796, 4123857, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5275, 13483, 'SERVICO DE REGISTRO DE IMOVEIS', 85159, 4123907, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5276, 6569, 'SERVICO DISTRITAL DE QUINZOPOLIS', 141937, 4123907, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5277, 4450, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO PRECARIAMENTE, O REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS ', 81745, 4123907, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5278, 13484, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTOS', 86603, 4123907, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5279, 4451, 'SERVICO DISTRITAL DE SANTA MONICA', 81463, 4123956, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5280, 4452, 'SERVICO DISTRITAL DE SANTA TEREZA DO OESTE ', 129403, 4124020, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5281, 4453, 'SERVICO DISTRITAL DE SANTA TEREZINHA DE ITAIPU', 129585, 4124053, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5282, 4454, 'SERVICO DISTRITAL DE SANTANA DO ITARARE', 140210, 4124004, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5283, 4457, 'SERVICO DISTRITAL DE MONTE REAL', 85506, 4124103, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5284, 12906, 'CARTORIO DO 1º OFICIO DE CAMPOS', 90241, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5285, 12907, 'CARTORIO DO 12º OFICIO DE CAMPOS DOS GOYTACAZES', 90092, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5286, 12908, 'CAMPOS CARTORIO DO 2º OFICIO', 89474, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5287, 4479, 'RCPN DO 10º DISTRITO DE CAMPOS DOS GOYTACAZES/RJ', 92734, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5288, 7158, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE IPAUCU (EXECUTA REGISTRO CIVIL)', 114546, 3520905, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5289, 6017, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE IPERO-SP', 118521, 3521002, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5290, 5937, 'CARTORIO DO REGISTRO CIVIL E ANEXOS DE IPEUNA', 114587, 3521101, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5291, 5938, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117176, 3521150, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5292, 5939, 'SERVICO DO REGISTRO CIVIL DE PESSOAS NATURAIS E ANEXO', 124453, 3521200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5293, 12037, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE IPUA', 145664, 3521309, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5294, 5940, 'SERVICO DE REGISTRO CIVIL, NOTAS E PROTESTOS', 124347, 3521309, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5295, 5941, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE IRACEMAPOLIS - SP', 117671, 3521408, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5296, 6019, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE IRAPUA', 118539, 3521507, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5297, 6020, 'OFICIAL DO REGISTRO CIVI DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 121251, 3521606, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5298, 6021, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116863, 3521705, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5299, 5943, 'OFICIAL DE REGISTRO DE IMOVEIS TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA E ITAI', 147215, 3521804, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5300, 5942, 'TABELIONATO DE NOTAS E PROTESTO DE ITAI', 116574, 3521804, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5301, 6023, 'ITAJOBI CARTORIO DO REGISTRO CIVIL E ANEXOS', 114744, 3521903, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5302, 6024, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ITAJU', 118547, 3522000, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5303, 12038, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA COM ANEXO DE NOTAS ', 120915, 3522109, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5304, 6025, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE ITANHAEM - SP', 116087, 3522109, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5305, 12039, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 112102, 3522109, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5306, 5944, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116665, 3522158, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5307, 12040, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120741, 3522208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5308, 6097, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE ITAPECERICA DA SERRA', 122135, 3522208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5309, 12041, '1º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 112037, 3522208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5310, 12042, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA COMARCA DE ITAPETININGA/SP', 120519, 3522307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5311, 12043, 'OFICIAL DE REGISTRO DE IMOVEIS - TITULOS E DOCUMENTOS CIVIL DE PESSOA JURIDICA', 119628, 3534609, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5312, 12044, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 122465, 3534609, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5313, 6061, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE OSVALDO CRUZ', 116186, 3534609, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5314, 12045, 'SEGUNDO CARTORIO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE OURINHOS-SP', 123786, 3534708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5315, 6062, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE INTERDICOES E TUTELAS DA SEDE', 121293, 3534708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5316, 12046, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE OURINHOS', 120634, 3534708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5317, 12047, 'PRIMEIRO TABELIAO DE NOTAS E PROTESTOS DE LETRAS E TITULOS', 122499, 3534708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5318, 6063, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE OURO VERDE - SP', 117317, 3534807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5319, 6064, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 129452, 3534757, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5320, 6065, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE PACAEMBU-SP', 116194, 3534906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5321, 5828, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE BOITUVA', 146522, 3507001, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5322, 5947, 'TABELIAO DE NOTAS  E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE  BOITUVA - SP.', 122259, 3507001, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5323, 5948, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 121558, 3507100, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5324, 7186, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE BONSUCESSO DE ITARARE', 149989, 3507159, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5325, 5829, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 114363, 3507209, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5326, 5830, 'BORACEIA OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 113811, 3507308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5327, 12336, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DA COMARCA DE BORBOREMA', 144832, 3507407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5328, 5886, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE BORBOREMA', 145581, 3507407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5329, 5887, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO', 123158, 3507456, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5330, 5949, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE VITORIANA, DA COMARCA DE BOTUCATU', 118257, 3507506, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5331, 5831, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO 1º SUBDISTRITO DA SEDE DA COMARCA DE BOTUCATU', 116491, 3507506, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5332, 5888, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO SEGUNDO SUBDISTRITO DA SEDE DA COMARCA DE BOTUCATU', 115378, 3507506, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5333, 5950, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE RUBIAO JUNIOR', 118174, 3507506, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5334, 12337, 'SEGUNDO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE BOTUCATU', 123976, 3507506, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5335, 12338, 'PRIMEIRO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE BOTUCATU', 122432, 3507506, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5336, 12339, 'SEGUNDO OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS DE PESSOA JURIDICA E SEGUNDO TABELIONATO DE PROTESTOS DE LETRAS E TITULOS', 123802, 3507506, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5337, 12340, '1º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS DA COMARCA DE BOTUCATU', 111542, 3507506, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5338, 12341, '2º TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS', 112912, 3507605, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5339, 12342, '1.° TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS DE BRAGANCA PAULISTA', 111112, 3507605, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5340, 5832, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115618, 3507605, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5341, 12343, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA ', 120329, 3507605, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5342, 5889, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 114264, 3507704, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5343, 5890, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE BREJO ALEGRE ', 116913, 3507753, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5344, 12344, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDIC E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE BRODOWSKI', 145557, 3507803, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5345, 6007, 'TABELIONATO DE NOTAS E PROTESTO DE LETRAS E TITULOS ', 126144, 3507803, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5346, 5951, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 122952, 3507902, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5347, 12345, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120311, 3507902, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5348, 4283, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE  TITULOS, DOCUMENTOS E CIVIL DAS PESSOA JURIDICAS', 84657, 4111506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5349, 13591, '2º TABELIONATO DE NOTAS DE IVAIPORA-PR', 82511, 4111506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5350, 3801, 'SERVICO DISTRITAL DE LIDIANOPOLIS', 129387, 4111506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5351, 13592, '1º TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 83618, 4111506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5352, 13593, 'REGISTRO DE IMOVEIS', 85076, 4111506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5353, 3802, 'SERVICO DISTRITAL DE IVATE', 86538, 4111555, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5354, 4284, 'SERVICO DISTRITAL DE HERCULANDIA', 86884, 4111555, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5355, 3803, 'OFICIO DE NOTAS E REGISTRO CIVIL', 84079, 4111605, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5356, 3804, 'SERVICO DISTRITAL DE JABOTI', 87361, 4111704, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5357, 13594, '1º TABELIONATO DE NOTAS', 88278, 4111803, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5358, 3805, 'REGISTRO CIVIL DAS PESSOAS NATURAIS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 84947, 4111803, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5359, 13595, 'SERVICO DE REGISTRO DE IMOVEIS', 83626, 4111803, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5360, 13596, 'TABELIONATO DE PROTESTO DE TITULOS', 130195, 4111803, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5361, 13597, 'SERVICO REGISTRAL DE IMOVEIS', 87106, 4111902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5362, 13598, 'TABELIONATO DE NOTAS ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87460, 4111902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5363, 4285, 'SERVICO DE REGISTRO CIVIL DE PESSOAS NATURAIS, ACUMULADO PRECARIAMENTE COM O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 80945, 4111902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5364, 13599, '1º SERVICO DE REGISTRO DE IMOVEIS', 79970, 4125506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5365, 3647, 'SERVICO DISTRITAL DE BORDA DO CAMPO DE SAO SEBASTIAO', 82073, 4125506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5366, 3650, 'SERVICO DISTRITAL DE CAMPO LARGO DA ROSEIRA', 130286, 4125506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5367, 13600, '1º TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O 1º TABELIONATO DE PROTESTO DE TITULOS', 80028, 4125506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5368, 3651, 'SERVICO DISTRITAL DE SAO MANOEL DO PARANA', 87940, 4125555, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5369, 3653, 'SERVICO DISTRITAL DE FLUVIOPOLIS ', 82057, 4125605, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5370, 3652, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULADO PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 82818, 4125605, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5371, 13601, 'SERVICO DE REGISTRO DE IMOVEIS', 85118, 4125605, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5372, 13602, 'TABELIONATO DE NOTAS E TABELIONATO DE PROTESTO DE TITULOS', 88294, 4125605, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5373, 13603, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE O TABELIONATO DE PROTESTO DE  TITULOS', 87312, 4125704, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5374, 13604, 'SERVICO DE REGISTRO DE IMOVEIS', 86074, 4125704, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5375, 3655, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS ', 86991, 4125704, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5376, 3654, 'SERVICO DISTRITAL DE AURORA DO IGUACU', 85530, 4125704, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5377, 3656, 'SERVICO DISTRITAL DE SAO PEDRO DO IGUACU', 85555, 4125753, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5378, 3657, 'SERVICO DISTRITAL DE SAO PEDRO DO IVAI', 85829, 4125803, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5379, 3658, 'SERVICO DISTRITAL DE SAO PEDRO DO PARANA', 88245, 4125902, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5380, 3659, 'SERVICO DISTRITAL DE SAO SEBASTIAO DA AMOREIRA', 82875, 4126009, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5381, 3660, 'SERVICO DISTRITAL DE SAO TOME', 144782, 4126108, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5382, 3661, 'SERVICO DISTRITAL DE SAPOPEMA', 81521, 4126207, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5383, 3662, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 130302, 4126256, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5384, 13605, 'SERVICO DE REGISTRO DE IMOVEIS', 85563, 4126256, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5385, 13606, 'TABELIONATO DE NOTAS E 1º TABELIONATO DE PROTESTO DE TITULOS', 86579, 4126256, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5386, 3663, 'SERVICO DISTRITAL DE SAUDADE DO IGUACU', 87924, 4126272, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5387, 3664, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULADO PRECARIAMENTE COM O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85605, 4126306, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5388, 3665, 'SERVICO DISTRITAL DE REIANOPOLIS', 86397, 4126306, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5389, 13607, 'TABELIONATO DE NOTAS', 86967, 4126306, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5390, 13608, 'TABELIONATO DE PROTESTO DE TITULOS ', 154104, 4126306, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5391, 3667, 'SERVICO DISTRITAL DE SERRANOPOLIS DO IGUACU', 129940, 4126355, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5392, 3668, 'SERVICO DISTRITAL DE SERTANEJA', 84863, 4126405, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5393, 13609, 'SERVICO DE REGISTRO DE IMOVEIS', 87130, 4126504, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5394, 3669, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85902, 4126504, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5395, 13610, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 83980, 4126504, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5396, 13611, 'SERVICO DE REGISTRO DE IMOVEIS', 81901, 4126603, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5397, 4989, 'SERVICO NOTARIAL E REGISTRAL DO OFICIO UNICO DE RIO DAS OSTRAS', 89789, 3304524, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5398, 4993, '5º REGISTRO CIVIL DE PESSOAS NATURAIS DA CAPITAL DO RIO DE JANEIRO', 89250, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5399, 13612, 'CARTORIO 24º OFICIO DE NOTAS', 89607, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5400, 13613, 'PRIMEIRO SERVICO REGISTRAL DE IMOVEIS - CAPITAL - RJ.', 92346, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5401, 13614, '14º OFICIO DE NOTAS', 88633, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5402, 13615, 'CARTORIO DO 8º OFICIO DO REGISTRO DE DISTRIBUICAO DO RIO DE JANEIRO', 90811, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5403, 13616, 'RIO DE JANEIRO 7 OFICIO DE NOTAS DA CAPITAL', 93328, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5404, 13617, '11° OFICIO DE NOTAS', 88575, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5405, 13618, '4º OFICIO DE NOTAS DO RIO DE JANEIRO', 89227, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5406, 13619, 'RIO DE JANEIRO CARTORIO DO 6° OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS', 93377, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5407, 13620, 'RIO DE JANEIRO CARTORIO DO 23° OFICIO DE NOTAS', 93351, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5408, 13621, 'CARTORIO DO 1º OFICIO DE REGISTRO DE DISTRIBUICAO', 90340, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5409, 13622, '13O OFICIO DE NOTAS', 88617, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5410, 13623, 'CARTORIO 8º OFICIO DE REGISTRO DE IMOVEIS', 89722, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5411, 13624, '4 OFICIO DO REGISTRO DE DISTRIBUICAO', 89177, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5412, 13625, '1º OFICIO DE NOTAS DA CAPITAL', 88872, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5413, 13626, '9º OFICIO DE REGISTRO DE IMOVEIS', 89425, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5414, 13627, 'CARTORIO DO 2º OFICIO DE REGISTRO DE DISTRIBUICAO', 90555, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5415, 13628, '4º REGISTRO DE TITULOS E DOCUMENTOS DA COMARCA DA CAPITAL-RJ', 89235, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5494, 4294, 'SERVICO DISTRITAL DE JANDINOPOLIS', 82255, 4113403, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5416, 13629, '15° OFICIO DE NOTAS DA COMARCA DA CAPITAL DO ESTADO DO RIO DE JANEIRO', 88641, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5417, 4991, 'REGISTRO CIVIL DE PESSOAS NATURAIS - 4A CIRCUNSCRICAO DA CAPITAL DO RIO DE JANEIRO', 93252, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5418, 13630, 'CARTORIO 6º OFICIO DE NOTAS', 89706, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5419, 13631, '5º OFICIO DE REGISTRO DE IMOVEIS - RJ', 89276, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5420, 4994, 'OITAVO REGISTRO CIVIL E TABELIONATO DA COMARCA DA CAPITAL - RJ', 93146, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5421, 13632, 'RIO DE JANEIRO CARTORIO 4 OFICIO DE REGISTRO DE IMOVEIS CARTORIO JOSE ROBERTO FRANCO DA SILVEIRA', 93344, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5422, 4999, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DA 9ª CIRCUNSCRICAO DA CAPITAL - RIO DE JANEIRO - RJ', 93138, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5423, 13633, 'OFICIO DE NOTAS E REGISTRO DE CONTRATOS MARITIMOS', 92163, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5424, 13634, '22° OFICIO DE NOTAS', 88948, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5425, 4995, '10ª CIRCUNSCRICAO DO REGISTRO CIVIL E TABELIONATO', 88534, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5426, 13635, 'CARTORIO 9º OFICIO DE NOTAS', 89730, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5427, 13636, '7º OFICIO DE REGISTRO DE DISTRIBUICAO', 89375, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5428, 13637, '21º OFICIO DE NOTAS', 88930, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5429, 13638, '18º OFICIO DE NOTAS', 88682, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5430, 13639, '5O OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS DO RIO DE JANEIRO', 89243, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5431, 13640, 'CARTORIO DO QUINTO OFICIO DE NOTAS', 91124, 3304557, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5432, 13641, 'TABELIONATO DE NOTAS', 96255, 1100114, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5433, 13642, 'CARTORIO DE REGISTRO DE IMOVEIS, TITULOS  E DOCUMENTOS E PESSOA JURIDICA', 96016, 1100114, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5434, 5152, 'CARTORIO DE REGISTRO CIVIL E NOTAS DO DISTRITO DE TARILANDIA', 95901, 1100114, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5435, 13643, '1º SERVICO NOTARIAL E DE REGISTRO CIVIL CORILACO', 96297, 1100122, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5436, 13644, 'OFICIO DE REGISTRO DE IMOVEIS,TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS.', 96164, 1100122, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5437, 13645, 'TABELIONATO DE PROTESTO DE JI PARANA', 96396, 1100122, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5438, 5154, 'SEGUNDO OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE JI-PARANA-RO', 95810, 1100122, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5439, 5155, 'SERVICO NOTARIAL E DE REGISTROS', 96321, 1100130, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5440, 5156, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 95976, 1101203, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5441, 5157, 'TABELIONATO CHERQUE', 96354, 1101302, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5442, 5158, 'TABELIONATO DE NOTAS E REGISTRO CIVIL', 96222, 1101401, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5443, 5159, 'CARTORIO DE REGISTRO CIVIL E NOTAS E ANEXOS', 95950, 1100148, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5444, 5160, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE NOVA MAMORE, ESTADO DE RONDONIA', 95943, 1100338, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5445, 6612, 'SERVICO REGISTRAL CIVIL E NOTARIAL FERREIRA', 96149, 1101435, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5446, 5161, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 95984, 1100502, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5447, 13646, 'CARTORIO DE REGISTRO DE IMOVEIS', 95992, 1100155, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5448, 13647, 'TABELIONATO DE NOTAS', 96057, 1100155, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5449, 5162, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 95786, 1100155, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5450, 13648, 'TABELIONATO DE PROTESTO', 96412, 1100155, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5451, 4495, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS - BRETAS', 95968, 1101450, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5452, 13649, 'SERVICO DE REGISTRO DE IMOVEIS E ANEXOS', 96271, 1100189, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5453, 4496, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 26, 1100189, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5454, 13650, 'CARTORIO UNICO DE NOTAS', 96073, 1100189, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5455, 13651, 'ARACI MENDES DE BRITO LIMA', 96487, 1100189, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5456, 13652, '1º OFICIO DE REGISTRO DE TITULOS E DOCUMENTO E CIVIL DAS PESSOAS JURIDICAS ', 95661, 1100205, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5457, 13653, '1º TABELIONATO DE PROTESTO DE TITULOS', 95695, 1100205, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5458, 5166, 'REGISTRO CIVIL E DE NOTAS DO DISTRITO DE EXTREMA', 96214, 1100205, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5459, 13654, 'CARTORIO DO 2º OFICIO DE REGISTRO DE IMOVEIS', 96024, 1100205, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5460, 5169, 'CARTORIO 2º OFICIO DE NOTAS E REGISTRO CIVIL', 95729, 1100205, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5461, 13655, 'CARTORIO DISTRIBUIDOR DE PROTESTO DE TITULOS', 153445, 1100205, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5462, 13656, '1º OFICIO DE REGISTRO DE IMOVEIS', 95679, 1100205, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5463, 5163, '1º TABELIONATO DE NOTAS E REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DE PORTO VELHO', 95687, 1100205, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5464, 13657, 'CARTORIO DO 2º TABELIONATO DE PROTESTO DE TITULOS', 96032, 1100205, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5465, 13658, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87783, 4112009, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5466, 3806, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 83634, 4112009, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5467, 13659, '1º SERVICO DE REGISTRO DE IMOVEIS ', 130971, 4112108, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5468, 13660, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87775, 4112108, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5469, 13661, '2º SERVICO DE REGISTRO DE IMOVEIS', 83642, 4112108, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5470, 3807, 'SERVICO DE REGISTRO CIVIL TITULOS E DOCUMENTOS', 81661, 4112108, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5471, 4287, 'SERVICO DISTRITAL DE JANIOPOLIS', 83659, 4112207, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5472, 4288, 'SERVICO DISTRITAL DE JAPIRA', 86652, 4112306, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5473, 3808, 'SERVICO DISTRITAL', 82263, 4112405, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5474, 4289, 'SERVICO DISTRITAL DE JARDIM ALEGRE', 86306, 4112504, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5475, 13662, 'SERVICO DISTRITAL DE FREI TIMOTEO', 154799, 4112702, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5476, 4290, 'SERVICO DISTRITAL DE JATAIZINHO', 129411, 4112702, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5477, 4291, 'SERVICO DISTRITAL DE JESUITAS', 141564, 4112751, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5478, 3809, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS CIVIL DAS PESSOAS JURIDICAS', 81307, 4112801, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5479, 13663, 'SERVICO DO REGISTRO DE IMOVEIS', 85761, 4112801, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5480, 13664, 'TABELIONATO DE NOTAS ACUMULADO PRECARIAMENTE O TABELIONATO DE PROTESTOS DE TITULOS', 83667, 4112801, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5481, 6674, 'SERVICO DISTRITAL DE JUNDIAI DO SUL', 130476, 4112900, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5482, 4292, 'SERVICO DISTRITAL DE JURANDA', 83675, 4112959, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5483, 3810, 'SERVICO DISTRITAL DE JUSSARA', 86546, 4113007, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5484, 3811, 'SERVICO DISTRITAL DE KALORE', 85712, 4113106, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5485, 3812, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 83691, 4113205, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5486, 13665, 'SERVICO DE REGISTRO DE IMOVEIS', 83683, 4113205, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5487, 13666, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 83709, 4113205, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5488, 3813, 'SERVICO DISTRITAL DE AGUA AZUL', 82099, 4113205, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5489, 4293, 'SERVICO DISTRITAL DE LARANJAL', 144907, 4113254, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5490, 13667, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 88203, 4113304, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5491, 6544, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS,ACUMULANDO,PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84129, 4113304, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5492, 13668, 'SERVICO DE REGISTRO DE IMOVEIS', 86066, 4113304, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5493, 4295, 'SERVICO DISTRITAL DE LEOPOLIS', 82289, 4113403, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5495, 4539, 'SERVENTIA DISTRITAL DE LINDOESTE', 82297, 4113452, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5496, 4296, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 83725, 4113502, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5497, 13669, 'SERVICO REGISTRAL DE IMOVEIS', 87122, 4113502, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5498, 13670, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 88492, 4113502, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5499, 4540, 'SERVICO DISTRITAL DE LOBATO', 85845, 4113601, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5500, 13671, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87833, 4126603, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5501, 3670, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 82594, 4126603, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5502, 3671, 'SERVICO DISTRITAL DE SULINA', 83444, 4126652, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5503, 3672, 'SERVICO DISTRITAL DE TAMARANA', 82420, 4126678, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5504, 3673, 'SERVICO DISTRITAL DE TAMBOARA', 88336, 4126702, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5505, 3674, 'SERVICO DISTRITAL DE TAPEJARA ', 84798, 4126801, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5506, 3675, 'SERVICO DISTRITAL DE TAPIRA   ', 84848, 4126900, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5507, 13672, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87676, 4127007, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5508, 3676, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81653, 4127007, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5509, 13673, 'SERVICO DE REGISTRO DE IMOVEIS', 81869, 4127007, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5510, 13674, 'TABELIONATO DE PROTESTO DE TITULOS', 87320, 4127106, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5511, 13675, 'SERVICO DE REGISTRO DE IMOVEIS', 85134, 4127106, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5512, 3677, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULO E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84954, 4127106, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5513, 12653, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULO E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 119826, 3528502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5514, 12654, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE MAIRIPORA/SP', 125401, 3528502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5515, 6110, 'REGISTRO CIVIL E ANEXOS DE MANDURI', 123398, 3528601, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5516, 6111, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE MARABA PAULISTA', 118588, 3528700, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5517, 6112, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE MARACAI', 142026, 3528809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5518, 12655, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125518, 3528809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5519, 5809, 'OFICIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS DE MARAPOAMA', 114769, 3528858, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5520, 6113, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE MARIAPOLIS', 118596, 3528908, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5521, 5725, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 115535, 3529005, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5522, 12656, 'PRIMEIRO OFICIAL DE REGISTRO DE IMOVEIS E ANEXOS', 122291, 3529005, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5523, 7160, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE ROSALIA, DA COMARCA DE MARILIA', 117762, 3529005, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5524, 12657, '2° TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 112425, 3529005, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5525, 12658, 'TERCEIRO (3O.) TABELIONATO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS DA COMARCA DE MARILIA, DO ESTADO DE SAO PAULO', 126276, 3529005, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5526, 12659, 'PRIMEIRO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 122408, 3529005, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5527, 12660, 'SEGUNDO OFICIAL DE REGISTRO DE IMOVEIS,TITULOS E DOCUMENTOS CIVIL DE PESSOA JURIDICA', 123836, 3529005, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5528, 6114, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 114017, 3529005, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5529, 5726, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117143, 3529104, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5530, 12661, 'OFICIAL DE REGISTRO DE IMOVEIS E ANEXOS', 119677, 3529203, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5531, 5728, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES E TUTELAS DA SEDE', 119016, 3529203, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5532, 12662, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125138, 3529203, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5533, 12663, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE MATAO', 111930, 3529302, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5534, 5729, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 122929, 3529302, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5535, 5730, 'CARTORIO DE REGISTRO CIVIL E TABELIAO DE NOTAS DE SAO LOURENCO DO TURVO-SP', 114249, 3529302, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5536, 12664, '2.º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE MATAO-SP', 112433, 3529302, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5537, 12665, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA ', 120303, 3529302, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5538, 12666, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE MAUA', 120600, 3529401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5539, 12667, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE MAUA', 153940, 3529401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5540, 12668, '1O. TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TIULOS DA COMARCA DE MAUA-SP', 111369, 3529401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5541, 5731, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA COMARCA  DE MAUA  - SAO PAULO', 119107, 3529401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5542, 5732, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 123497, 3529500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5543, 5733, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117184, 3529609, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5544, 6116, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116806, 3529658, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5545, 12669, 'TABELIONATO DE NOTAS E PROTESTOS', 109330, 4208401, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5546, 4784, 'CARTORIO DO REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 105494, 4208401, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5547, 12670, 'CARTORIO DE REGISTRO DE IMOVEIS', 105296, 4208401, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5548, 5499, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS E REGISTRO DE IMOVEIS', 108365, 4208450, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5549, 6707, 'SERVICO DE REGISTROS PUBLICOS', 100099, 4304630, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5550, 6708, 'BETTEGA SERVICO NOTARIAL E REGISTRAL', 97089, 4304663, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5551, 4519, 'SERVICO NOTARIAL E DE REGISTRO DE CAPELA DE SANTANA-RS', 100636, 4304689, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5552, 4520, 'SERVICO NOTARIAL E DE REGISTRO DE CARAA', 100644, 4304713, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5553, 12928, 'SERVICO DE REGISTRO DE IMOVEIS', 99903, 4304705, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5554, 12929, '1º TABELIONATO DE NOTAS', 96685, 4304705, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5555, 12930, '2º TABELIONATO DE NOTAS', 97014, 4304705, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5556, 5223, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 98939, 4304705, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5557, 12931, 'TABELIONATO DE PROTESTO DE TITULOS E REGISTROS ESPECIAIS', 103697, 4304705, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5558, 5224, 'OFICIO DE REGISTROS E TABELIONATO DE PROTESTOS', 97808, 4304804, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5559, 12932, 'TABELIONATO DE NOTAS', 102905, 4304804, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5560, 5225, 'OFICIO DOS REGISTROS PUBLICOS', 98442, 4304903, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5561, 12933, 'SERVICO NOTARIAL E PROTESTOS', 101030, 4304903, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5562, 4521, 'SERVICO NOTARIAL E REGISTRAL', 101048, 4304952, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5563, 12934, 'TABELIONATO DE NOTAS DE CATUIPE', 103028, 4305009, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5564, 4522, 'OFICIO DOS REGISTROS PUBLICOS E TABELIONATO DE PROTESTOS', 98723, 4305009, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5565, 5226, 'SERVICO NOTARIAL E DE REGISTRO CIVIL GALOPOLIS', 100552, 4305108, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5566, 4525, 'SERVICO DE REGISTRO CIVIL DE PESSOAS NATURAIS - 2ª ZONA - CAXIAS DO SUL', 99879, 4305108, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5567, 6709, 'REGISTRO CIVIL DA 1ª ZONA DE CAXIAS DO SUL', 98921, 4305108, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5568, 4526, 'SERVICO NOTARIAL E REGISTRAL DE VILA SECA', 101402, 4305108, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5569, 12935, 'TERCEIRO TABELIONATO DE NOTAS DE CAXIAS DO SUL', 104059, 4305108, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5570, 4523, 'SERVICOS NOTARIAIS E DE REGISTROS DE CRIUVA', 102061, 4305108, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5571, 12936, 'REGISTRO DE IMOVEIS 1ª ZONA DE CAXIAS DO SUL', 99200, 4305108, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5572, 12937, 'SEGUNDO TABELIONATO DE NOTAS', 99697, 4305108, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5573, 12938, '1º TABELIONATO DE NOTAS - SERVICO NOTARIAL DE CAXIAS DO SUL/RS', 96701, 4305108, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5574, 4365, 'SERVICO DISTRITAL DE GRACIOSA', 144725, 4118402, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5575, 6547, 'SERVICO DISTRITAL DE PATO BRAGADO', 81638, 4118451, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5576, 12939, '2O TABELIONATO DE NOTAS', 84426, 4118501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5577, 12940, '2º SERVICO DE REGISTRO  DE IMOVEIS', 80234, 4118501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5578, 12941, '1º TABELIONATO DE NOTAS ', 79863, 4118501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5579, 12942, '1º SERVICO DE REGISTRO DE IMOVEIS', 84574, 4118501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5580, 6548, 'TABELIONATO DE PROTESTOS E SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS, ACUMULANDO PRECARIAMENTE O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 84442, 4118501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5581, 3757, 'SERVICO DISTRITAL DE PAULA FREITAS', 81166, 4118600, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5582, 3758, 'SERVICO DISTRITAL DE PAULO FRONTIN', 84459, 4118709, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5583, 4367, 'SERVICO DISTRITAL DE VERA GUARANI', 83402, 4118709, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5584, 4368, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84095, 4118808, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5585, 12943, 'SERVICO  DE REGISTRO DE IMOVEIS', 87254, 4118808, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5586, 12944, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87544, 4118808, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5587, 3759, 'SERVICO DISTRITAL DE PEROBAL', 87304, 4118857, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5588, 12945, 'SERVICO DE REGISTRO DE IMOVEIS', 84467, 4118907, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5589, 12946, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTOS DE TITULOS', 87619, 4118907, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5590, 4369, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81372, 4118907, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5591, 4371, 'SERVICO DISTRITAL DE PEROLA DO OESTE', 129478, 4119004, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5592, 4370, 'SERVICO DISTRITAL DE CONCIOLANDIA', 86744, 4119004, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5593, 4372, 'SERVENTIA DISTRITAL DE PIEN', 646, 4119103, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5594, 12947, 'TABELIONATO DE NOTAS', 87379, 4119152, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5595, 4373, 'OFICIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS DE PINHAIS', 84186, 4119152, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5596, 12948, 'TABELIONATO DE PROTESTO DE TITULOS', 88070, 4119152, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5597, 12949, 'SERVICO DE REGISTRO DE IMOVEIS', 84293, 4119152, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5598, 4374, 'SERVICO DISTRITAL DE PINHAL DE SAO BENTO', 85753, 4119251, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5599, 6501, 'OFICIAL  DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE PRESIDENTE EPITACIO-SP', 114819, 3541307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5600, 12064, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120444, 3541307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5601, 12065, 'TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS', 125591, 3541307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5602, 12066, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 111732, 3541406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5603, 6176, 'SERVICO REGISTRAL DA PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 124529, 3541406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5604, 12067, '3.º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE PRESIDENTE PRUDENTE', 113209, 3541406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5605, 6502, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE ENEIDA, DA COMARCA DE PRESIDENTE PRUDENTE', 114025, 3541406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5606, 12068, '2º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E PROTESTO DE LETRAS E TITULOS DE PRESIDENTE PRUDENTE', 112615, 3541406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5607, 12069, 'QUARTO TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 122572, 3541406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5608, 12070, '1. OFICIAL DE REGISTRO DE IMOVEIS - REGISTRO DE TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS - PROTESTO DE TITULOS ', 111088, 3541406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5609, 12071, '2º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 112995, 3541406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5610, 12072, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125104, 3541505, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5611, 12073, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 120782, 3541505, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5612, 6177, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115691, 3541505, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5613, 6179, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 122994, 3541604, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5614, 6178, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE SANTA MARIA DO GURUPA, DA COMARCA DE PROMISSAO', 116772, 3541604, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5615, 12074, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E TABELIAO DE PROTESTO', 120931, 3541604, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5616, 12075, 'TABELIONATO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE PROMISSAO', 113845, 3541604, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5617, 6383, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES, TUTELAS E TABELIAO DE NOTAS E PROTESTOS DE TITULOS E LETRAS', 123547, 3537107, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5618, 7187, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE PEDRINHAS PAULISTA, COMARCA DE MARACAI', 153726, 3537156, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5619, 6156, 'OFICIAL DE REG. CIVIL DAS P.N. E TAB. NOTAS DE PEDRO DE TOLEDO', 114850, 3537206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5620, 6384, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 122663, 3537305, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5621, 12076, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E TABELIAO DE PROTESTO E LETRAS E TITULOS DE PENAPOLIS', 121012, 3537305, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5622, 12077, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 111708, 3537305, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5623, 12078, 'SEGUNDO TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 124040, 3537305, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5624, 12079, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124784, 3537404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5625, 6385, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELA', 113944, 3537404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5626, 12080, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA COMARCA DE PEREIRA BARRETO', 120527, 3537404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5627, 6386, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE PEREIRAS', 118646, 3537503, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5628, 12081, '1º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DO MUNICIPIO E COMARCA DE PERUIBE', 112086, 3537602, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5629, 6387, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 121111, 3537602, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5630, 6388, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE PIACATU', 121954, 3537701, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5631, 12366, 'OFICIO DE REGISTRO DE IMOVEIS', 143180, 4203501, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5632, 12367, 'SERVICO NOTARIAL E PROTESTOS CAMPO ERE', 108894, 4203501, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5633, 5286, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 143198, 4203501, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5634, 5470, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS DE CAMPOS NOVOS (SC)', 108357, 4203600, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5635, 12368, '1º TABELIONATO DE NOTAS E PROTESTOS DE TITULOS', 104331, 4203600, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5636, 5287, 'ESCRIVANIA DE PAZ DO DISTRITO DE MAROMBAS', 107193, 4203600, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5637, 12369, '2° TABELIONATO DE NOTAS E 2° OFICIO DE PROTESTO DE TITULOS', 108779, 4203600, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5638, 12370, 'CARTORIO DE REGISTRO DE IMOVEIS', 105353, 4203600, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5639, 7095, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE CANELINHA', 106872, 4203709, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5640, 12371, 'CARTORIO DE REGISTRO GERAL DE IMOVEIS - COMARCA DE CANOINHAS', 108571, 4203808, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5641, 5471, 'ESCRIVANIA DE PAZ DO DISTRITO DE FELIPE SCHMIDT', 106625, 4203808, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5642, 12372, '1º TABELIONATO DE NOTAS E PROTESTOS', 104299, 4203808, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5643, 5472, 'SERVICO DE REGISTRO CIVIL PESSOAS NATURAIS, PESSOAS JURIDICAS E RTD', 108886, 4203808, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5644, 12373, '2º TABELIONATO DE NOTAS E PROTESTOS', 104588, 4203808, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5645, 5473, 'CARTORIO DE PAZ', 104984, 4203253, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5646, 12374, 'TABELIONATO DE NOTAS E PROTESTOS', 109231, 4203907, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5647, 5288, 'CARTORIO CICCONET', 104935, 4203907, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5648, 12375, 'REGISTRO DE IMOVEIS NAIR VIALI', 108548, 4203907, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5649, 12376, 'TABELIONATO DE NOTAS E PROTESTOS', 109223, 4203956, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5650, 5474, 'OFICIO DE REGISTRO CIVIL TITULOS E DOCUMENTOS E REGISTRO DE IMOVEIS', 107508, 4203956, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5651, 12377, 'TABELIONATO DE NOTAS E PROTESTOS DE TITULOS DA COMARCA DE CATANDUVAS', 109348, 4204004, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5652, 5475, 'OFICIO REGISTRO CIVIL, TIT. DOC. E REGISTRO DE IMOVEIS', 107953, 4204004, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5653, 7096, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE CAXAMBU DO SUL ', 106880, 4204103, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5654, 5476, 'ESCRIVANIA DE PAZ DE CELSO RAMOS', 106179, 4204152, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5655, 5477, 'CERRONEGRO CARTORIO DE PAZ', 105775, 4204178, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5656, 12378, 'TABELIONATO DE NOTAS E PROTESTO DE SAO JOSE', 109538, 4216602, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5657, 12379, 'REGISTRO DE IMOVEIS DE SAO JOSE', 108720, 4216602, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5658, 5529, 'REGISTRO CIVIL DAS PESSOAS NATURAIS, JURIDICAS, TITULOS E DOCUMENTOS E OUTROS PAPEIS DA COMARCA DE SAO JOSE', 108134, 4216602, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5659, 5531, 'ESCRIVANIA DE PAZ DO DISTRITO DE CAMPINAS', 106609, 4216602, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5660, 5528, 'ESCRIVANIA DE PAZ DE COLONIA SANTA TERESA', 106195, 4216602, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5661, 5530, 'ESCRIVANIA DE PAZ DO DISTRITO DE BARREIROS', 108712, 4216602, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5662, 5532, 'OFICIO DO REGISTRO CIVIL, TITULOS E DOCUMENTOS', 107813, 4216701, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5663, 12380, 'OFICIO DO REGISTRO DE IMOVEIS', 107888, 4216701, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5664, 12381, 'TABELIONATO CUNHA CESAR', 109009, 4216701, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5665, 5533, 'ESCRIVANIA DE PAZ DE SAO JOSE DO CERRITO', 106500, 4216800, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5666, 5534, 'CARTORIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOA JURIDICA', 105254, 4216909, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5667, 12382, 'TABELIONATO DE NOTAS E REGISTRO DE IMOVEIS', 109504, 4216909, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5668, 5535, 'CARTORIO DE PAZ DE SAO LUDGERO', 105049, 4217006, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5669, 5536, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE SAO MARTINHO', 107045, 4217105, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5670, 5537, 'SERVENTIA DE PAZ ', 108845, 4217154, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5671, 5538, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 108290, 4217204, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5672, 12383, 'TABELIONATO DE NOTAS E OFICIO DE PROTESTOS', 109082, 4217204, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5673, 12384, 'REGISTRO DE IMOVEIS', 108449, 4217204, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5674, 5539, 'ESCRIVANIA DE PAZ DE SAO PEDRO DE ALCANTARA', 106518, 4217253, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5675, 7139, 'SAUDADES CARTORIO CIVIL', 108738, 4217303, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5676, 5540, 'SCHROEDER TABELIONATO E REFISTRO CIVIL', 108746, 4217402, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5677, 12385, 'SEARA TABELIONATO DE NOTAS E PROTESTOS', 108761, 4217501, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5678, 5541, 'OFICIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 107839, 4217501, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5679, 12386, 'REGISTRO DE IMOVEIS', 108753, 4217501, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5680, 5542, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO  SERRA ALTA', 105171, 4217550, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5681, 7140, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE SIDEROPOLIS', 107052, 4217600, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5682, 5543, 'OFICIO DO REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 107847, 4217709, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5683, 12671, 'TABELIONATO DE NOTAS E PROTESTOS DE ITAPOA', 109397, 4208450, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5684, 5500, 'CARTORIO REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 105668, 4208500, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5685, 12672, 'TABELIONATO DE NOTAS E OFICIO DE PROTESTOS DE ITUPORANGA-SC', 109520, 4208500, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5686, 12673, 'OFICIO DE REGISTRO DE IMOVEIS E HIPOTECAS', 107698, 4208500, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5687, 7125, 'RIO BONITO ESCRIVANIA DE PAZ', 108605, 4208500, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5688, 5501, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE JABORA', 106914, 4208609, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5689, 5502, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE JACINTO MACHADO', 106922, 4208708, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5690, 5503, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECA E REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 108944, 4208807, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5691, 12674, 'TABELIONATO DE NOTAS E PROTESTOS', 109207, 4208807, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5692, 5378, 'JARAGUA DO SUL OFICIO DO REGISTRO CIVIL TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 107383, 4208906, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5693, 12675, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS DE JARAGUA DO SUL ', 108985, 4208906, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5694, 12676, 'OFICIO DE REGISTRO DE IMOVEIS ISA MARTA MOHR ZIEMANN', 107920, 4208906, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5695, 5379, 'ESCRIVANIA DE PAZ', 105163, 4208955, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5696, 12677, 'REGISTRO DE IMOVEIS 1º OFICIO-JOACABA', 108472, 4209003, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5697, 5380, 'OFICIO DO REGISTRO CIVIL, PESSOAS JURIDICAS, TITULOS E DOCUMENTOS', 107797, 4209003, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5698, 12678, '1º OFICIO DE NOTAS E PROTESTOS', 104208, 4209003, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5699, 12679, '2º TABELIONATO DE NOTAS E PROTESTOS', 104570, 4209003, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5700, 12680, 'REGISTRO DE IMOVEIS 2º OFICIO', 108480, 4209003, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5701, 5381, 'NOVA PETROPOLIS CARTORIO DE PAZ E TABELIONATO', 107482, 4209003, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5702, 12681, '3º OFICIO DE REGISTRO DE IMOVEIS DE JOINVILLE', 108498, 4209102, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5703, 12682, 'REGISTRO DE IMOVEIS E HIPOTECA DA 2A. CIRCUNSCRICAO', 108506, 4209102, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5704, 7126, 'ESCRIVANIA DE PAZ DO DISTRITO DO BOA VISTA', 106781, 4209102, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5705, 12683, '3° TABELIONATO DE NOTAS E 2° DE PROTESTO DE TITULOS ', 104646, 4209102, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5706, 12684, '1º REGISTRO DE IMOVEIS DE JOINVILLE', 107896, 4209102, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5707, 12685, '1º TABELIONATO DE NOTAS E 1º OFICIO DE PROTESTOS', 104273, 4209102, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5708, 12686, 'CARTORIO DE REGISTRO CIVIL E DE TITULOS E DOCUMENTOS', 105130, 4209102, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5709, 4853, 'ESCRIVANIA DE PAZ DO DISTRITO DE PIRABEIRABA-77062', 106708, 4209102, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5710, 12687, '2º TABELIONATO DE NOTAS E 3º OFICIO DE PROTESTOS', 104521, 4209102, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5711, 4854, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE JOSE BOITEUX', 106930, 4209151, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5712, 12688, 'ESCRIVANIA DE PAZ DO MUNCIPIO DE JUPIA-SC', 106815, 4209177, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5713, 4855, 'LACERDOPOLIS CARTORIO DE PAZ', 107417, 4209201, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5714, 12689, 'PRIMEIRO TABELIONATO DE NOTAS E PROTESTOS DA COMARCA DE LAGES(SC)', 108092, 4209300, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5715, 4811, 'OFICIO UNICO DE PIRAMBU', 110833, 2805307, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5716, 4812, 'CARTORIO DO 2º OFICIO DA COMARCA DE POCO REDONDO', 110023, 2805406, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5717, 12690, 'CARTORIO DE 1º OFICIO DA COMARCA DE POCO REDONDO', 149047, 2805406, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5718, 4813, 'CARTORIO DO 2º OFICIO - TABELIONATO DE NOTAS, REGISTRO CIVIL E REGISTRO DE TITULOS E DOCUMENTOS', 110387, 2805505, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5719, 12691, 'REGISTRO DE IMOVEIS, NOTAS, PROTESTO DE TITULOS', 110957, 2805505, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5720, 12692, 'CARTORIO DO 1º OFICIO DE NOTAS E PROTESTOS', 110262, 2805604, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5721, 7150, 'CARTORIO DO 2º OFICIO', 110338, 2805604, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5722, 4814, 'SERVICO REGISTRAL GUIMARAES SILVA', 110981, 2805703, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5723, 12693, 'CARTORIO DO 1º OFICIO DA COMARCA DE PROPRIA', 110254, 2805703, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5724, 4815, 'CARTORIO DO  OFICIO UNICO ', 110353, 2805802, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5725, 12694, 'CARTORIO DO  1º OFICIO DE RIACHUELO', 130732, 2805901, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5726, 4816, '2º OFICIO DE RIACHUELO-SE ', 109843, 2805901, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5727, 12695, 'RIBEIROPOLIS CARTORIO DO PRIMEIRO OFICIO DE NOTAS', 110965, 2806008, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5728, 4817, 'CARTORIO DO 2° OFICIO', 110320, 2806008, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5729, 4818, 'CARTORIO DO OFICIO UNICO DO DISTRITO DE ROSARIO DO CATETE (COMARCA DE CARMOPOLIS)', 110619, 2806107, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5730, 6560, 'UNICO SERVICO NOTARIAL E REGISTRAL DE PARATY - RJ PRIVATIZADO', 93724, 3303807, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5731, 13502, 'CARTORIO DISTRIBUIDOR, CONTADOR E PARTIDOR', 89953, 3303807, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5732, 4971, 'OFICIO UNICO DE PATY DO ALFERES', 92239, 3303856, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5733, 13503, 'DISTRIBUIDOR, CONTADOR E PARTIDOR', 91819, 3303856, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5734, 4973, 'CARTORIO DA 1ª ZONA JUDICIARIA DE PETROPOLIS', 89755, 3303906, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5735, 13504, 'CARTORIO DO 4º OFICIO DE JUSTICA DA COMARCA DE PETROPOLIS ', 90720, 3303906, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5736, 13505, 'CARTORIO DO DECIMO OFICIO DE PETROPOLIS', 90837, 3303906, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5737, 13506, 'CARTORIO DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE PETROPOIS', 89995, 3303906, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5738, 13507, '1º OFICIO DE JUSTICA DE PETROPOLIS', 88765, 3303906, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5739, 13508, '2º OFICIO DE JUSTICA DE PETROPOLIS', 89003, 3303906, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5740, 13509, '7 OFICIO DE JUSTICA DE PETROPOLIS', 89334, 3303906, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5741, 4972, 'CARTORIO DO RCPN. E NOTAS DO 2º DISTRITO DA COMARCA DE PETROPOLIS-RJ', 91306, 3303906, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5742, 13510, 'CARTORIO DO 6º OFICIO DE JUSTICA DE PETROPOLIS', 90787, 3303906, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5743, 13511, 'CARTORIO DO 3º OFICIO DE JUSTICA DE PETROPOLIS', 90654, 3303906, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5744, 4974, 'RCPN E NOTAS DO QUARTO DISTRITO DE PETROPOLIS', 93013, 3303906, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5745, 6602, 'OFICIO UNICO DE NOTAS', 95109, 2412104, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5746, 5122, '2º OFICIO DE NOTAS, RCPNIT E PROTESTO', 93948, 2412203, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5747, 13512, 'CARTORIO DO 1º OFICIO DE NOTAS', 94136, 2412203, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5748, 5123, 'SERVICO NOTARIAL E REGISTRAL DE SAO JOSE DO CAMPESTRE/RN', 95455, 2412302, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5749, 5124, 'CARTORIO UNICO DE NOTAS E REGISTROS', 95505, 2412401, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5750, 13513, '1º OFICIO DE NOTAS SAO MIGUEL/RN', 93815, 2412500, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5751, 5125, 'SEGUNDO OFICIO DE NOTAS', 95356, 2412500, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5752, 6603, 'CARTORIO SEGUNDO OFICIO DE NOTAS', 94243, 2412609, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5753, 13514, 'CARTORIO DO PRIMEIRO OFICIO  DE NOTAS', 94185, 2412609, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5754, 13515, 'CARTORIO UNICO EXTRA JUDICIAL', 94540, 2412708, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5755, 5126, 'TABELIONATO DE NOTAS E OFICIO DE REGISTROS PUBLICOS', 95554, 2412807, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5756, 5127, 'SEGUNDO SERVICO NOTARIAL E REGISTRAL', 95380, 2412906, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5757, 13516, 'PRIMEIRO CARTORIO DE NOTAS DE SAO TOME - CARTORIO ARAKEN', 95281, 2412906, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5758, 5128, 'OFIO UNICO DE SAO VICENTE RN', 95265, 2413003, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5759, 6604, 'CARTORIO EXTRA JUDICIARIO', 94219, 2413102, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5760, 5129, 'CARTORIO UNICO DE SENADOR GEORGINO ', 94474, 2413201, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5761, 5130, 'CARTORIO UNICO JUDICIARIO', 94714, 2410306, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5762, 5131, 'OFICIO UNICO DE SERRA DE SAO BENTO', 95208, 2413300, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5763, 5132, 'TERMO JUDICIARIO DA COMARCA DE MOSSORO', 95588, 2413359, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5764, 6605, 'SERVICO NOTARIAL E REGISTRAL', 95422, 2413409, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5765, 13517, 'CARTORIO UNICO', 131078, 2413557, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5766, 5133, 'CARTORIO UNICO JUDICIARIO DE SEVERIANO MELO', 94789, 2413607, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5767, 5134, 'CARTORIO UNICO EXTRA JUDICIARIO', 94557, 2413706, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5768, 5135, 'CARTORIO UNICO OFICIO DE NOTAS', 94839, 2413805, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5769, 6606, 'SERVICO UNICO NOTARIAL E REGISTRAL DE TAIPU', 93773, 2413904, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5770, 5136, 'CARTORIO UNICO DE TANGARA', 94482, 2414001, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5771, 5137, 'OFICIO UNICO DO TERMO DE TENENTE ANANIAS/MARCELINO VIEIRA-RN', 95240, 2414100, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5772, 13518, 'CARTORIO UNICO DE TIBAU', 94490, 2411056, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5773, 4482, 'OFICIO UNICO DE TIBAU DO SUL', 95216, 2414209, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5774, 13519, 'TIMBAUBA DOS BATISTAS CART 1 TAB ESC REG CIVIL ', 131029, 2414308, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5775, 5138, 'SERVICO NOTARIAL E REGISTRAL', 95414, 2414407, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5776, 13520, 'CARTORIO UNICO - SAO MIGUEL DE TOUROS', 131185, 2414407, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5777, 4483, 'UNICO OFICIO DE NOTAS', 95620, 2414506, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5778, 4484, 'SERVICO UNICO NOTARIAL E REGISTRAL', 95471, 2414605, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5779, 4485, 'TERMO UNICO DE VARZEA', 95604, 2414704, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5780, 6607, 'CARTORIO UNICO DE VENHA VER/RN', 94508, 2414753, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5781, 5139, 'CARTORIO UNICO JUDICIARIO DE VERA CRUZ/RN', 94797, 2414803, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5782, 6608, 'CARTORIO UNICO DE VICOSA', 94516, 2414902, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5783, 5140, 'CARTORIO UNICO', 94276, 2415008, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5784, 4486, 'UNICO SERVICO NOTARIAL E DE REGISTRO', 96123, 1100015, 'RO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5785, 13521, '1º SERVICO DE REGISTRO DE IMOVEIS  ', 87288, 4109401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5786, 3783, 'SERVICO DISTRITAL DE CARRO QUEBRADO', 82172, 4109401, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5787, 3785, 'SERVICO DISTRITAL DE GUARAQUECABA', 129486, 4109500, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5788, 13522, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87627, 4109609, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5789, 13523, 'SERVICO DE REGISTRO DE IMOVEIS', 83535, 4109609, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5790, 4633, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84178, 4109609, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5791, 4634, 'SERVICO DISTRITAL DE HONORIO SERPA', 83543, 4109658, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5792, 13524, 'TABELIONATO E REGISTRO CIVIL  DE PESSOAS NATURAIS', 85852, 4109658, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5793, 13525, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 88237, 4109708, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5794, 13526, 'SERVICO DE REGISTRO DE IMOVEIS ', 86132, 4109708, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5795, 3786, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84715, 4109708, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5796, 4271, 'TABELIONATO DE NOTAS E REGISTRO CIVIL ', 87981, 4109757, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5797, 13527, 'IBIPORA - REGISTRO DE IMOVEIS', 83550, 4109807, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5798, 3787, 'CARTORIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSSOA JURIDICA', 87270, 4109807, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5799, 13529, 'TABELIONATO DE PROTESTO DE TITULOS', 129593, 4109807, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5800, 3788, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 82545, 4109906, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5801, 3790, 'SERVICO DISTRITAL DE PORTO  CAMARGO', 84871, 4109906, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5802, 13530, 'SERVICO DE REGISTRO DE IMOVEIS', 87262, 4109906, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5803, 3789, 'SERVICO DISTRITAL DE VILA RICA DO IVAI', 86900, 4109906, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5804, 13531, 'TABELIONATO DE NOTAS E OFICIO DE PROTESTO DE TITULOS DA COM DE ICARAIMA', 87478, 4109906, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5805, 3791, 'SERVICO DISTRITAL DE IGUARACU', 144790, 4110003, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5806, 4272, 'SERVICO DISTRITAL DE IGUATU', 86876, 4110052, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5807, 4273, 'SERVICO DISTRITAL DE IMBAU', 82230, 4110078, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5808, 13532, 'SERVICO DE REGISTRO DE IMOVEIS ', 87114, 4110102, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5809, 4274, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DA PESSOAS JURIDICAS', 88385, 4110102, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5810, 4275, 'SERVICO DISTRITAL DE APIABA', 86207, 4110102, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5811, 13533, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87759, 4110102, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5812, 3792, 'SERVICO DISTRITAL DE INACIO MARTINS', 83576, 4110201, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5813, 3793, 'SERVICO DISTRITAL DE INAJA', 130047, 4110300, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5814, 4276, 'SERVICO DISTRITAL DE INDIANOPOLIS', 129908, 4110409, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5815, 13534, 'TABELIONATO DE NOTAS, ACUMULANDO PRECARIAMENTE O TABELIONATO DE PROTESTO DE TITULOS', 145334, 4110508, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5816, 3794, 'SERVICO DE REGISTRO CIVIL PES.NATURAIS, TIT DOCUMENTOS E CIVIL DE P.JURIDICAS', 83584, 4110508, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5817, 13535, 'SERVICO DE REGISTO DE IMOVEL', 87163, 4110508, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5818, 13536, 'CARTORIO DE REGISTRO DE IMOVEIS', 85613, 4110607, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5819, 3629, 'SERVICO REGISTRAL E NOTARIAL DE SANTO ANTONIO DO PARAISO', 87221, 4124301, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5820, 13537, 'TABELIONATO DE NOTAS ', 88054, 4124400, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5821, 13538, 'SERVICO DE REGISTRO DE IMOVEIS', 85191, 4124400, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5822, 3630, 'SERVICO DISTRITAL DE SAO PEDRO DO FLORIDO ', 85548, 4124400, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5823, 12310, 'TABELIONATO DE NOTAS E OFICIO DE PROTESTOS', 109116, 4202602, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5824, 12311, 'ESCRIVANIA DE PAZ E TABELIONATO DE NOTAS', 107102, 4202453, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5825, 5280, 'ESCRIVANIA DE PAZ', 108183, 4202701, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5826, 12312, 'CARTORIO DE REGISTRO DE IMOVEIS', 105288, 4202800, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5827, 5699, 'CARTORIO DE REGISTRO CIVIL, TITULOS DOCUMENTOS E PESSOAS JURIDICAS', 105239, 4202800, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5828, 12313, 'CARTORIO DE NOTAS E PROTESTOS EM GERAL', 104950, 4202800, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5829, 6686, 'BRACO DO TROMBUDO ESCRIVANIA DE PAZ', 104828, 4202859, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5830, 5700, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE BRUNOPOLIS (ANTIGA PALMARES)', 106856, 4202875, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5831, 12314, 'TABELIONATOWSOUZA', 109595, 4202909, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5832, 12315, 'BRUSQUE 1º TABELIONATO PUBLICO JUDICIAL DE NOTAS E PROTESTOS', 104836, 4202909, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5833, 12316, 'OFICIO DO REGISTRO DE IMOVEIS', 107862, 4202909, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5834, 5281, 'SERVICO REGISTRAL DE BRUSQUE - RCPN-TD-PJ', 108928, 4202909, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5835, 12317, 'CACADOR CARTORIO DE NOTAS DO 1º OFICIO', 104844, 4203006, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5836, 5445, 'REGISTROCIVIL TITULOS E DOCUMETOS E PESSOAS JURIDICAS', 108597, 4215505, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5837, 12318, 'REGISTRO DE IMOVEIS ', 108563, 4215505, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5838, 5513, 'ESCRIVANIA DE PAZ DE SANTA HELENA/SC', 106484, 4215554, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5839, 7107, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 105148, 4215604, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5840, 5514, 'CARTORIO TRAJANO', 105742, 4215653, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5841, 12319, 'TABELIONATO DE NOTAS E PROTESTO DE SANTA ROSA DO SUL-SC', 109157, 4215653, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5842, 5515, 'ESCRIVANIA DE PAZ SANTA TEREZINHA', 107151, 4215679, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5843, 5516, 'REGISTRO CIVIL, TITULOS E DOC. E PESSOAS JURIDICAS', 108241, 4215703, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5844, 12320, 'SANTO AMARO DA IMPERATRIZ - REGISTRO DE IMOVEIS', 108688, 4215703, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5845, 12321, 'TABELIONATO DE NOTAS E OFICIO DE PROTESTOS', 109074, 4215703, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5846, 5517, 'CARTORIO DO REGISTRO CIVIL E ANEXOS', 105460, 4215802, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5847, 12322, 'TABELIONATO DE NOTAS E PROTESTOS', 108696, 4215802, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5848, 12323, 'CARTORIO DE REGISTRO DE IMOVEIS', 105361, 4215802, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5849, 5518, 'SAO BONIFACIO CARTORIO DE PAZ E TABELIONATO', 108704, 4215901, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5850, 12324, 'TABELIONATO DE NOTAS E REGISTRO E PROTESTOS', 109512, 4216008, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5851, 12325, 'CARTORIO DE REGISTRO DE IMOVEIS', 105304, 4216008, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5852, 7138, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 108274, 4216008, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5853, 12326, 'ESCRIVANIA DE PAZ', 105981, 4216057, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5854, 5519, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 108308, 4216107, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5855, 12327, 'TABELIONATO DE NOTAS E PROTESTOS DE TITULOS', 109017, 4216107, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5856, 12328, 'OFICIO DE REGISTRO DE IMOVEIS DE SAO DOMINGOS', 105411, 4216107, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5857, 12329, '2º TABELIONATO DE NOTAS E PROTESTOS', 150102, 4216206, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5858, 5520, 'ESCRIVANIA DE PAZ EX DISTRITO UBATUBA', 107110, 4216206, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5859, 5521, 'ESCRIVANIA DE PAZ, REG. CIVIL, TIT. E DOCUMENTOS DA SEDE DE SAO FRCO. DO SUL', 107169, 4216206, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5860, 12330, '2º REGISTRO DE IMOVEIS', 150110, 4216206, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5861, 12331, '1º TABELIONATO DE NOTAS E PROTESTO DE TITULOS E 1º OFICIO DE REGISTRO DE IMOVEIS DA COMARCA DE SAO FRANCISCO DO SUL, SC', 104927, 4216206, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5862, 5522, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 108258, 4216305, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5863, 12332, 'CARTORIO DE REGISTRO DE IMOVEIS', 105320, 4216305, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5864, 5523, 'ESCRIVANIA DE PAZ DO DISTRITO DE TIGIPIO', 106765, 4216305, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5865, 12333, 'TABELIONATO DE NOTAS E PROTESTOS DE TITULOS', 109405, 4216305, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5866, 5524, 'ESCRIVANIA DE PAZ E REGISTRO CIVIL', 107086, 4216354, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5867, 5525, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE SAO JOAO DO OESTE', 107037, 4216255, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5868, 5526, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 105155, 4216404, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5869, 5527, 'CARTORIO DO REGISTRO CIVIL, TITULOS, DOCUMENTOS E PESSOAS JURIDICAS', 105502, 4216503, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5870, 12334, 'REGISTRO GERAL DE IMOVEIS', 108589, 4216503, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5871, 12335, 'TABELIONATO DE NOTAS E PROTESTOS', 109215, 4216503, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5872, 5826, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DO MUNICIPIO DE BOCAINA-SP', 118950, 3506805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5873, 5827, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE BOFETE/SP', 118935, 3506904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5874, 12612, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS E REGISTRO DE IMOVEIS', 150268, 4207700, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5875, 5372, 'ESCRIVANIA DE PAZ DE IRACEMINHA', 108829, 4207759, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5876, 5373, 'ESCRIVANIA DE PAZ DE IRANI', 107334, 4207809, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5877, 4782, 'CARTORIO DE PAZ E ANEXOS DE IRATI', 105056, 4207858, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5878, 5374, 'CARTORIO DE REGISTRO CIVIL E ANEXOS', 105122, 4207908, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5879, 5497, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE IRINEOPOLIS', 105478, 4207908, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5880, 12613, 'TABELIONATO DE NOTAS E PROTESTOS', 109322, 4208005, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5881, 5498, 'OFICIO DE REGISTRO DE IMOVEIS E HIPOTECAS', 107680, 4208005, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5882, 5376, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS, PESSOAS JURIDICAS', 108399, 4208104, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5883, 7124, 'ESCRIVANIA DE PAZ ITAIO - OLIZANDRO KUHL', 107136, 4208104, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5884, 12614, 'ITAIOPOLIS TABELIONATO DE NOTAS E PROTESTOS EM GERAL', 107359, 4208104, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5885, 12615, 'OFICIO DO REGISTRO DE IMOVEIS DA COMARCA DE ITAIOPOLIS-SC', 107904, 4208104, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5886, 5375, 'ESCRIVANIA DE PAZ DO DISTRITO DE IRAPUTA', 106666, 4208104, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6113, 12915, '3 OFICIO DE NOTAS', 93955, 2402006, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5887, 12616, '2º OFICIO REGISTRO DE IMOVEIS', 104497, 4208203, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5888, 4783, 'ITAJAI OFICIO DO REGISTRO CIVIL', 107375, 4208203, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5889, 12617, 'ITAJAI 3 TABELIONATO DE NOTAS', 107367, 4208203, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5890, 12618, 'SEGUNDO TABELIONATO DE NOTAS E PROTESTO DE TITULOS DA COMARCA DE ITAJAI - SC', 108787, 4208203, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5891, 12619, 'Lº OFICIO DE REGISTRO DE IMOVEIS DA COMARCA DE ITAJAI-SC', 107441, 4208203, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5892, 12620, '1º TABELIONATO DE NOTAS E PROTESTOS DE ITAJAI', 104372, 4208203, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5893, 5377, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS', 150128, 4208302, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5894, 12621, 'TABELIONATO DE NOTAS E PROTESTO', 109181, 4208302, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5895, 12622, 'REGISTRO DE IMOVEIS', 150433, 4208302, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5896, 12623, 'CARTORIO DO 1º OFICIO DE NOTAS DE ITABAIANINHA', 110239, 2803005, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5897, 5883, '2º OFICIO DE NOTAS E REGISTROS', 109835, 2803005, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5898, 5884, 'OFICIO UNICO DO DISTRITO DE ITABI', 110890, 2803104, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5899, 5885, '2º OFICIO DA COMARCA DE ITAPORANGA D´AJUDA', 109793, 2803203, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5900, 12624, 'CARTORIO DO 1º OFICIO DE ITAPORANGA', 110213, 2803203, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5901, 4791, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS, TITULOS E DOCUMENTOS E TABELIONATO', 110627, 2803302, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5902, 12625, 'CARTORIO DO 1º OFICIO', 110155, 2803302, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5903, 4792, 'CARTORIO DO OFICIO UNICO DE JAPOATA-SE', 110551, 2803401, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5904, 12626, 'CARTORIO DO 1º OFICIO REGISTRO DE IMOVEIS E NOTAS', 110296, 2803500, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5905, 4793, 'CARTORIO DO 2° OFICIO', 110312, 2803500, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5906, 4794, 'CARTORIODO 2º OFICIO DA COMARCA DE LARANJEIRAS', 110809, 2803609, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5907, 12627, 'CARTORIO DO 1º OFICIO DA COMARCA DE LARANJEIRAS', 110171, 2803609, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5908, 4795, 'CARTORIO DO OFICIO UNICO DO DISTRITO DE MACAMBIRA-SE', 110593, 2803708, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5909, 4796, 'CARTORIO OFICIO UNICO', 110502, 2803807, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5910, 4797, 'OFICIO UNICO', 110825, 2803906, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5911, 12628, 'CARTORIO DO 1º OFICIO DA COMARCA DE MARUIM', 110189, 2804003, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5912, 4798, 'CARTORIO DO 2O. OFICIO DA COMARCA DE MARUIM', 110304, 2804003, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5913, 4799, 'CARTORIO DO UNICO OFICIO DO DISTRITO DE MOITA BONITA', 110700, 2804102, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5914, 4800, 'CARTORIO OFICIO UNICO DE MONTE ALEGRE DE SERGIPE', 110783, 2804201, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5915, 4801, 'CARTORIO DO OFICIO UNICO DO DISTRITO DE MURIBECA', 110601, 2804300, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5916, 12629, 'CARTORIO DO 1º OFICIO', 110114, 2804409, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5917, 4802, 'CARTORIO 2 OFICIO ', 109967, 2804409, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5918, 4803, 'CARTORIO DE OFICIO UNICO DE NOSSA SENHORA APARECIDA', 110015, 2804458, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5919, 12630, 'CARTORIO DO 1º OFICIO DE NOTAS, PROTESTOS E REGISTRO DE IMOVEIS', 110288, 2804508, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5920, 4804, 'CARTORIO DO SEGUNDO OFICIO DE NOTAS', 110692, 2804508, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5921, 12631, '1º OFICIO DE NOTAS E PROTESTO DE TITULOS', 109769, 2804607, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5922, 7149, 'CARTORIO DO 2º OFICIO', 110379, 2804607, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5923, 4805, 'CARTORIO DO OFICIO UNICO DE NOSSA SENHORA DE LOURDES', 110569, 2804706, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5924, 12632, '2° TABELIONATO DE NOTAS DA COMARCA DE NOSSA SENHORA DO SOCORRO', 109777, 2804805, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5925, 12633, 'CARTORIO DO 1º OFICIO DE NOSSA SENHORA DO SOCORRO', 110221, 2804805, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5926, 12634, 'CARTORIO DO 1° OFICIO ', 110080, 2804904, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5927, 4361, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81711, 4118105, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5928, 12884, 'TABELIONATO DE NOTAS, ACUMULANDO PRECARIAMENTE O TABELIONATO DE PROTESTOS DE TITULOS', 84616, 4118105, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5929, 7292, 'SERVICO DISTRITAL DE JARDIM OLINDA', 145458, 4118105, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5930, 12885, 'SERVICO DE REGISTRO DE IMOVEIS', 85126, 4118105, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5931, 12886, 'SERVICO DE REGISTRO DE IMOVEIS', 84368, 4118204, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5932, 12887, '1º TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 80978, 4118204, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5933, 12888, '2º TABELIONATO DE NOTAS', 84350, 4118204, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5934, 4362, 'SERVICO DO REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E O 2O. TABELIONATO DE PROTESTO DE TITULOS', 84376, 4118204, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5935, 4363, 'SERVICO DISTRITAL DE PARANAPOEMA', 84889, 4118303, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5936, 12889, 'TABELIONATO DE PROTESTO DE TITULOS ', 84400, 4118402, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5937, 12890, '1º TABELIONATO DE NOTAS', 84384, 4118402, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5938, 4364, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE  REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 129890, 4118402, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5939, 12891, '2º SERVICO DE REGISTRO DE IMOVEIS', 80200, 4118402, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5940, 4366, 'SERVICO DISTRITAL DE SUMARE', 81208, 4118402, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5941, 12892, '3º TABELIONATO DE NOTAS', 84392, 4118402, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5942, 12893, '1º SERVICO DE REGISTRO DE IMOVEIS', 79905, 4118402, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5943, 12894, '2º TABELIONATO DE NOTAS', 84418, 4118402, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5944, 12895, 'CARTORIO DO DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE CAMBUCI/RJ', 90928, 3300902, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5945, 4906, 'CARTORIO DO RCPN 5º DISTRITO', 91132, 3300902, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5946, 6551, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º DISTRITO DE CAMBUCI', 91389, 3300902, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5947, 12896, 'CARTORIO DO 9º OFICIO', 90829, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5948, 12897, 'CAMPOS CARTORIO DO 5º OFICIO', 89490, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5949, 4907, 'RCPN DO 15º DISTRITO DE CAMPOS DOS GOYTACAZES/RJ', 92742, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5950, 4908, 'RCPN DO NONO DISTRITO DE CAMPOS DOS GOYTACAZES', 92932, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5951, 12898, 'CARTORIO DO 4º OFICIO DE JUSTICA', 90712, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5952, 4950, 'CARTORIO DO RCPN DO 2º DISTRITO DE CAMPOS - RJ', 91215, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5953, 4948, 'RCPN DO 18º DISTRITO DE CAMPOS DOS GOYTACAZES/RJ', 92452, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5954, 12899, 'CARTORIO DO 6º OFICIO DE NOTAS', 90795, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5955, 4949, 'CAMPOS CARTORIO REGISTRO CIVIL DO 1° SUDISTRITO', 89516, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5956, 4480, 'REGISTRO CIVIL PESSOAS NATURAIS DO 2º SUBDISTRITO DO 1º DISTRITO DE CAMPOS DOS GOYTACAZES-RJ', 93310, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5957, 12900, 'CAMPOS CARTORIO DO 11 OFICIO DE NOTAS E REGISTRO DE IMOVEIS', 89458, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5958, 4951, 'CARTORIO RCPN E NOTAS DO 7O DISTRITO DE CAMPOS', 92718, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5959, 12901, 'CARTORIO DO 10º OFICIO DE NOTAS DE CAMPOS', 90068, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5960, 12902, 'CARTORIO DO 7º OFICIO DE JUSTICA DE CAMPOS DOS GOYTACAZES', 90803, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5961, 12903, 'CAMPOSCARTORIO13° OFICO DE NOTAS E REGISTRO DE IMOVEIS', 89524, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5962, 4909, '3 SUBDISTRITO DO 1 DISTRITO DE CAMPOS DOS GOYTACAZES', 89086, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5963, 4477, 'CAMPOS CARTORIO DO 17 DISTRITO DE NOTAS', 89466, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5964, 12904, 'CARTORIO DO OFICIO UNICO DO REGISTRO DE DISTRIBUICAO', 91108, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5965, 4481, 'CARTORIO DO RCPN DO 20º DISTRITO DE CAMPOS DOS GOYTACAZES', 91207, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5966, 12905, 'CAMPOS CARTORIO DO 8 OFICIO DE NOTAS', 89508, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5967, 4952, 'CARTORIO RCPN E NOTAS DO 4°. DISTRITO DE CAMPOS DOS GOYTACAZES/RJ', 91579, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5968, 4910, 'CARTORIO DE RCPN E NOTAS DO 12º DISTRITO DE CAMPOS DOS GOYTACAZES/RJ', 91181, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5969, 4692, 'SERVICOS NOTARIAIS E DE REGISTRO', 101717, 4306973, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5970, 12981, '1º TABELIONATO DE NOTAS DE ERECHIM', 96719, 4307005, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5971, 12982, 'REGISTRO DE IMOVEIS DE ERECHIM', 99283, 4307005, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5972, 12983, 'SERVICO DOS REGISTROS ESPECIAIS DE ERECHIM', 100263, 4307005, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5973, 12984, '2º TABELIONATO DE NOTAS', 96842, 4307005, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5974, 6716, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 98061, 4307005, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5975, 4693, 'SERVICOS NOTARIAIS E DE REGISTROS DE ERNESTINA', 102095, 4307054, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5976, 4694, 'SERVICO NOTARIAL E REGISTRAL', 101121, 4307203, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5977, 4695, 'OFICIO DOS REGISTROS PUBLICOS DE ERVAL SECO', 98640, 4307302, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5978, 12985, 'TABELIONATO DE NOTAS DE ERVAL SECO', 103093, 4307302, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5979, 4696, 'OFICIO DOS REGISTROS PUBLICOS DE ESMERALDA', 98657, 4307401, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5980, 12986, 'TABELIONATO DE ESMERALDA', 102624, 4307401, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5981, 6717, 'SERVICO NOTARIAL E REGISTRAL DE ESPERANCA DO SUL', 101246, 4307450, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5982, 12987, 'REGISTRO DE IMOVEIS E ESPECIAIS', 99416, 4307500, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5983, 4697, 'SERVICO NOTARIAL E REGISTRAL CIVIL', 101147, 4307500, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5984, 4710, 'TABELIONATO E REGISTRO CIVIL DE ESTACAO', 103820, 4307559, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5985, 12988, 'TABELIONATO KUNZLER', 103895, 4307609, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5986, 6718, 'SERVICOS DE REGISTROS E TABELIONATO DE PROTESTOS DE TITULOS', 101642, 4307609, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5987, 12989, 'SERVICO DO REG. DE IMOVEIS E ESPECIAIS', 100172, 4307708, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5988, 4729, 'OFICIO DOS REGISTROS ESPECIAIS TABELIONATO DE PROTESTO E REGISTRO CIVIL DE GRAVATAI', 98269, 4309209, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5989, 4728, 'SERVICOS NOTARIAIS E DE REGISTRO DE IPIRANGA', 101824, 4309209, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5990, 12990, 'SERVICO DO REGISTRO DE IMOVEIS', 100222, 4309308, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5991, 12991, 'TABELIONATO DE NOTAS DE GUAIBA', 103119, 4309308, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5992, 4731, 'OFICIO DO REGISTRO CIVIL DA SPESSOAS NATURAIS E JURIDICAS, TITULOS E DOCUMENTOS E PROTESTOS CAMBIAIS', 98046, 4309308, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5993, 4732, 'SERVICOS DE REGISTROS PUBLICOS', 101667, 4309407, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5994, 12992, 'TABELIONATO DE NOTAS', 102863, 4309407, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5995, 12993, 'TABELIONATO DE NOTAS', 102871, 4309506, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5996, 6723, 'OFICIO DOS REGISTROS PUBLICOS', 98376, 4309506, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5997, 4733, 'SERVICOS NOTARIAIS E REGISTRAIS DE HARMONIA', 102277, 4309555, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5998, 12994, 'TABELIONATO DE NOTAS DA COMARCA DE HERVAL', 102913, 4307104, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (5999, 4734, 'OFICIO DOS REGISTROS PUBLICOS DE HERVAL', 98350, 4307104, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6000, 4735, 'HORIZONTINA TABELIONATO', 97527, 4309605, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6001, 12995, 'SERVICOS DE REGISTRO DE IMOVEIS E ESPECIAIS', 101634, 4309605, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6002, 4736, 'SERVICO NOTARIAL E REGISTRAL DE HULHA NEGRA', 101261, 4309654, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6003, 12996, 'TABELIONATO MENEZES', 103911, 4309704, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6004, 6675, 'OFICIO DOS REGISTROS PUBLICOS', 98616, 4309704, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6005, 4737, 'SERVICO NOTARIAL E DE REGISTROS DE IBARAMA', 100958, 4309753, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6006, 4738, 'OFICIO DOS REGISTROS PUBLICOS', 98525, 4309803, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6007, 12997, 'TABELIONATO DE NOTAS DE IBIACA', 102434, 4309803, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6008, 4739, 'SERVICOS NOTARIAIS E DE REGISTROS DE IBIRAIARAS', 102129, 4309902, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6009, 6724, 'SERVICO NOTARIAL E REGISTRAL DE IBIRAPUITA', 101279, 4309951, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6010, 6168, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE PRADINIA, DA COMARCA DE PIRAJUI', 119081, 3538907, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6011, 5871, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXO (NOTAS) DO DISTRITO E MUNICIPIO DE PIRANGI, COMARCA DE MONTE ALTO, ESTADO DE SAO PAULO', 113910, 3539004, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6012, 6393, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116624, 3539103, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6013, 6394, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE PIRAPOZINHO', 147306, 3539202, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6014, 6395, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS ', 125781, 3539202, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6015, 12100, 'OFICIAL DE REGISTRO DE IMOVEIS E ANEXOS', 119651, 3539301, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6016, 6488, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE CACHOEIRA DE EMAS', 117911, 3539301, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6017, 12101, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 111807, 3539301, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6018, 6396, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E INTERDICOES E TUTELAS DA SEDE E COMARCA DEPIRASSUNUNGA SP', 116541, 3539301, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6019, 12102, '2º CARTORIO DE NOTAS E PROTESTO DE PIRASSUNUNGA', 112441, 3539301, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6020, 12103, 'TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS', 125641, 3539400, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6021, 12104, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE PIRATININGA-SP', 120642, 3539400, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6022, 7188, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE PIRATININGA', 123711, 3539400, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6023, 6489, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE PITANGUEIRAS', 116269, 3539509, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6024, 6169, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE IBITIUVA, DA COMARCA DE PITANGUEIRAS', 116590, 3539509, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6025, 12105, 'SEBASTIAO JOSE DUARTE MOREIRA', 123760, 3539509, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6026, 12106, 'TABELIONATO DE NOTAS E PROTESTO', 126102, 3539509, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6027, 6490, 'OFICIAL DE REGISTRO DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE PLANALTO', 119602, 3539608, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6028, 6491, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 114652, 3539707, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6029, 12107, '1 TABELIAO DE NOTAS E PROTESTO DE POA', 111070, 3539806, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6030, 12108, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120428, 3539806, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6031, 6492, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE - MUNICIPIO E COMARCA DE POA-SP', 115873, 3539806, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6032, 6493, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 123471, 3539905, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6033, 12109, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE POMPEIA', 125450, 3540002, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6034, 12110, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120188, 3540002, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6035, 6397, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA', 115907, 3540002, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6036, 6398, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 121541, 3540101, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6037, 6170, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE PONTAL', 148445, 3540200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6038, 6400, 'OFICIAL DE REGISTRO CIVIL P. N. E TABELIAO DE NOTAS DO DISTRITO DE CANDIA', 123455, 3540200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6039, 6399, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS TITULOS', 125856, 3540200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6040, 6401, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116764, 3540259, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6041, 6494, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE PONTES GESTAL', 117739, 3540309, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6042, 6402, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 121582, 3540408, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6114, 5057, 'CAMPO GRANDE CARTORIO UNICO OFICIO DE NOTAS', 94060, 2401305, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6043, 12111, 'TABELIONATO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE PORTO FELIZ ', 126060, 3540606, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6044, 5838, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXO DE NOTAS DE CAJAMAR ', 115402, 3509205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6045, 5839, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117242, 3509254, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6046, 5841, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE MONTE VERDE PAULISTA, DA COMARCA DE OLIMPIA', 117226, 3509304, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6047, 5773, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIA DE NOTAS DO DISTRITO DE ANA DIAS', 121483, 3523305, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6048, 5775, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE ITATIBA', 122978, 3523404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6049, 5759, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO 1º SUBDISTRITO DA SEDE', 116475, 3522307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6050, 12346, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 112789, 3522307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6051, 5758, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º SUBDISTRITO DA SEDE DA COMARCA DE ITAPETININGA', 115220, 3522307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6052, 12347, '1º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE ITAPETININGA', 111864, 3522307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6053, 4806, 'CARTORIO DO 3º OFICIO DE N. SRA.  DO SOCORRO/SE', 110460, 2804805, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6054, 4807, 'PACATUBA CARTORIO DO 2º OFICIO', 110940, 2804904, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6055, 4808, 'CARTORIO LEA ALMEIDA', 110908, 2805000, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6056, 4809, 'OFICIO UNICO DO DISTRITO DE PEDRINHAS', 110916, 2805109, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6057, 4810, 'CARTORIO GEORGE WALLACE, OFICIO UNICO DO DISTRITO DE PINHAO/SE', 110452, 2805208, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6058, 12635, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE COSMOPOLIS', 142240, 3512803, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6059, 5897, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO  DE COSMORAMA', 118273, 3512902, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6060, 6126, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 119222, 3513009, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6061, 12636, '1° TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE COTIA-SP', 111393, 3513009, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6062, 5898, 'OFICIAL DE REGISTRO CIVIL E TABELIONATO DO DISTRITO DE CAUCAIA DO ALTO', 119560, 3513009, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6063, 12637, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DA COMARCA DE COTIA', 119917, 3513009, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6064, 12638, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124909, 3513108, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6065, 6127, 'UNIDADE DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 126409, 3513108, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6066, 12639, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120261, 3513108, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6067, 6128, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE CRISTAIS PAULISTA', 141150, 3513207, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6068, 5899, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117309, 3513306, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6069, 12640, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE CRUZEIRO', 111898, 3513405, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6070, 12641, '2º TABELIAO DE NOTAS E PROTESTOS DE LETRAS E TITULOS', 113068, 3513405, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6071, 5901, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 115550, 3513405, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6072, 12642, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E TAB ELIONATO DE PROTESTO DE TITULOS DE CRUZEIRO', 120857, 3513405, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6073, 5900, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO SEGUNDO SUBDISTRITO DA SEDE DA COMARCA DE CRUZEIRO - SP', 122812, 3513405, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6074, 12643, 'PRIMEIRO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 122390, 3513504, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6075, 12644, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE CUBATAO', 112854, 3513504, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6076, 5902, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE CUBATAO - ESTADO DE SAO PAULO', 116020, 3513504, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6077, 12645, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DA PESSOA JURIDICA DE CUBATAO', 119875, 3513504, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6078, 12646, 'TEBELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 126268, 3513603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6079, 5967, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 119578, 3513603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6080, 5903, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXO DO DISTRITO DE CAMPOS DE CUNHA', 115436, 3513603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6081, 12647, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120295, 3513603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6082, 12648, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS DA COMARCA DE DESCALVADO ', 114405, 3513702, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6083, 5904, 'OFICIAL DE REGISTRO CIVIL E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE DESCALVADO, ESTADO DE SAO PAULO', 119198, 3513702, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6084, 12649, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124990, 3513702, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6085, 12650, 'TABELIONATO DE PROTESTO DE LETRAS E TITULOS DE DIADEMA', 126193, 3513801, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6086, 12651, 'OFICIAL DE REGISTRO DE IMOVEIS, TITS E DOCS E CIVIL DE PJ DE DIADEMA', 119800, 3513801, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6087, 5905, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE DIADEMA', 116038, 3513801, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6088, 12909, 'CARTORIO DO 3º OFICIO DE JUSTICA', 90639, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6089, 7210, 'OFICIO UNICO DA COMARCA DE CANTAGALO', 90142, 3301108, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6090, 12910, 'CARTORIO DO DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE CANTAGALO - RJ', 90936, 3301108, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6091, 12911, 'DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE CARAPEBUS/QUISSAMA', 91918, 3300936, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6092, 4912, 'OFICIO UNICO DE CARAPEBUS', 92205, 3300936, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6093, 5044, 'CARTORIO UNICO OFICIO DE NOTAS', 94821, 2400505, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6094, 5045, 'ALMINO AFONSO-RN UNICO OFICIO DE NOTAS', 94011, 2400604, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6095, 6579, 'OFICIO UNICO DE NOTAS - REGISTRO E PROTESTO', 95117, 2400703, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6096, 5046, 'CARTORIO UNICO DE ANGICOS', 94300, 2400802, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6097, 5047, 'CARTORIO UNICO JUDICIARIO DE ANTONIO MARTINS ', 94722, 2400901, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6098, 5048, 'APODI CARTORIO 2º OFICIO NOTAS', 94029, 2401008, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6099, 12912, 'APODI CARTORIO PRIMEIRO OFICIO DE NOTAS', 94037, 2401008, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6100, 5049, 'OFICIO UNICO DE NOTAS E REGISTROS', 95141, 2401107, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6101, 6580, 'OFICIO UNICO DE NOTAS', 95091, 2401206, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6102, 5050, 'CARTORIO UNICO DE BAIA FORMOSA', 94318, 2401404, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6103, 5051, 'BARAUNA CARTORIO UNICO OFICIO DE NOTAS', 94045, 2401453, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6104, 5052, 'CARTORIO UNICO JUDICIARIO', 94706, 2401503, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6105, 6581, 'OFICIO UNICO DE BENTO FERNANDES', 95026, 2401602, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6106, 5053, 'CARTORIO UNICO DE BOA SAUDE', 94326, 2405306, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6107, 5054, 'CARTORIO UNICO JUDICIARIO DE BOM JESUS/RN', 94730, 2401701, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6108, 5055, 'SERVICO UNICO NOTARIAL E REGISTRAL DE BREJINHO', 95539, 2401800, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6109, 6582, 'SERVICO UNICO NOTARIAL E REGISTRAL', 95513, 2401859, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6110, 12913, 'CARTORIO UNICO', 131052, 2401909, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6111, 5056, '2º CARTORIO CAICO', 93864, 2402006, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6112, 12914, 'CARTORIO DO 1.º OFICIO DE NOTAS E SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICA DE CAICO (RN)', 94110, 2402006, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6115, 5058, 'CARTORIO UNICO EXTRAJUDICIAL DE CAMPO REDONDO', 94581, 2402105, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6116, 5059, 'OFICIO UNICO DE REGISTROS E NOTAS', 95190, 2402204, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6117, 6583, 'CARAUBAS OFICIO UNICO DE NOTAS', 94078, 2402303, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6118, 5060, 'CARTORIO UNICO DE NOTAS E REGISTROS DE CARNAUBA DOS DANTAS/RN', 94458, 2402402, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6119, 5061, 'CARNAUBAIS CARTORIO UNICO', 94086, 2402501, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6120, 5062, '2º  OFICIO DE NOTAS  DE CEARA-MIRIM', 148098, 2402600, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6121, 12916, '1º OFICIO DE NOTAS CEARA-MIRIM', 93781, 2402600, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6122, 12917, '3º OFICIO DE NOTAS', 93971, 2402600, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6123, 12918, 'CARTORIO UNICO', 131045, 2402709, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6124, 6584, 'CARTORIO UNICO JUDICIARIO', 94698, 2402808, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6125, 5063, 'CARTORIO UNICO DE CEL JOAO PESSOA', 94334, 2402907, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6126, 5064, 'SERVICO UNICO DE NOTAS E REGISTROS', 95547, 2403004, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6127, 12919, '1º CARTORIO DE NOTAS', 93757, 2403103, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6128, 12920, 'TERCEIRO OFICIO DE NOTAS', 95570, 2403103, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6129, 5065, '2º CARTORIO DE NOTAS', 93872, 2403103, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6130, 6585, 'CARTORIO UNICO DE DR. SEVERIANO', 94342, 2403202, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6131, 5066, 'CARTORIO UNICO DE ENCANTO', 94359, 2403301, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6132, 12921, 'TABELIONATO JOSE HILDOR LEAL', 103879, 4304408, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6133, 5219, 'REGISTROS PUBLICOS E TABELIONATO DE PROTESTO DE TITULOS', 99556, 4304408, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6134, 12922, 'SERVICO DE REGISTRO DE IMOVEIS DE CANGUCU', 99945, 4304507, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6135, 12923, 'TABELIONATO DE NOTAS, PROTESTOS E REGISTROS DE PESSOAS JURIDICAS E TITULOS E DOCUMENTOS', 103630, 4304507, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6136, 5220, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE CANGUCU', 99036, 4304507, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6137, 12924, 'SEGUNDO TABELIONATO DE CANOAS', 99663, 4304606, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6138, 5221, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA  1A ZONA DE CANOAS', 97626, 4304606, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6139, 12925, 'CARTORIO DO REGISTRO DE IMOVEIS DE CANOAS', 97360, 4304606, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6140, 5222, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DA 2ª ZONA', 98111, 4304606, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6141, 12926, '1° TABELIONATO DE NOTAS E SERVICOS DE REGISTROS ESPECIAIS - CANOAS', 96644, 4304606, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6142, 12927, 'CARTORIO DE NOTAS DE CAPAO DA CANOA', 97162, 4304630, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6143, 12048, 'TABELIAO DE NOTAS E PROTESTOS DE LETRAS E TITULOS DE PACAEMBU', 125906, 3534906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6144, 12049, 'OFICIAL DE REGISTSRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E TABELIAO DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE PACAEMBU', 121202, 3534906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6145, 6205, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115824, 3535002, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6146, 12050, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 120758, 3535002, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6147, 12051, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124925, 3535002, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6148, 6147, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE PALMARES PAULISTA', 114637, 3535101, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6149, 12052, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE PALMEIRA D´OESTE', 125443, 3535200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6150, 6148, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117457, 3535200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6151, 12053, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 121061, 3535200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6152, 6149, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115782, 3535200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6153, 12054, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS ', 111682, 3535309, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6154, 6150, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 121277, 3535309, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6155, 12055, 'OFICIAL DE REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 119784, 3535309, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6156, 12056, '2º TABELIAO DE NOTAS DE PROTESTOS DE LETRAS E TITULOS', 112706, 3535309, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6157, 6151, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOAS JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE PANORAMA', 145680, 3535408, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6158, 12057, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 121913, 3535408, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6159, 6474, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXOS DO DISTRITO DE SAPEZAL ', 122853, 3535507, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6160, 12058, 'REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL E PESSOAS JURIDICAS', 123588, 3535507, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6161, 6476, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 5223, 3535507, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6162, 12059, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE PARAGUACU PAULISTA', 125823, 3535507, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6163, 6475, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO, MUNICIPIO, E COMARCA DE PARAGUACU PAULISTA ', 113902, 3535507, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6164, 12060, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS ', 125195, 3540804, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6165, 6172, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO NOTAS DE PRACINHA,COMARCA DE LUCELIA,ESTADO DE SAO PAULO', 118844, 3540853, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6166, 6173, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117424, 3540903, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6167, 12061, 'OFICIAL DE REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS E CIVEL DE PESSOA JURIDICA E TABELIAO DE PROTESTO', 119768, 3541000, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6168, 6174, 'PRIMEIRO TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS E OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS INTERDICOES E TUTELAS DA SEDE', 122440, 3541000, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6169, 6497, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE SOLEMAR', 118216, 3541000, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6170, 6498, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 143073, 3541059, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6171, 6175, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE GUARICANGA, DA COMARCA DE PIRAJUI', 119446, 3541109, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6172, 6499, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE PRESIDENTE ALVES', 118679, 3541109, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6173, 12062, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124883, 3541208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6174, 12063, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA', 120873, 3541208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6175, 6500, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115741, 3541208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6176, 12348, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120006, 3522406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6177, 12349, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124032, 3522406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6178, 12350, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 112110, 3522406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6179, 5760, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115857, 3522406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6180, 12351, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE ITAPEVI', 144535, 3522505, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6181, 5762, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124727, 3522505, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6182, 12352, 'SERVICO DE REGISTRO DE IMOVEIS E ANEXOS DE ITAPIRA', 124396, 3522604, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6183, 12353, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE ITAPIRA', 112862, 3522604, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6184, 12354, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE ITAPIRA', 111872, 3522604, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6185, 5763, 'CARTORIODE REGISTRO CIVIL DAS PESSOAS NATURAIS', 114702, 3522604, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6186, 5764, 'CARTORIO DE REGISTRO CIVIL E ANEXOS', 114033, 3522653, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6187, 5765, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE NOVA AMERICA, DA COMARCA ITAPOLIS', 117168, 3522703, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6188, 5767, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE TAPINAS, DA COMARCA DE ITAPOLIS', 114967, 3522703, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6189, 12355, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124750, 3522703, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6190, 12750, 'TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS', 125625, 3500501, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6191, 5766, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE ITAPOLIS ', 116095, 3522703, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6192, 12356, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120105, 3522703, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6193, 12357, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125096, 3522802, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6194, 5768, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE ITAPORANGA ESTADO DE SAO PAULO', 124222, 3522802, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6195, 12358, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120451, 3522802, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6196, 5769, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXOS', 121343, 3522901, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6197, 5770, 'OFICIAL REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE ITAPURA/SP', 122069, 3523008, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6198, 12359, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE ITAQUAQUECETUBA', 125815, 3523107, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6199, 5771, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 120907, 3523107, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6200, 5772, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE ITARARE', 116103, 3523206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6201, 12360, 'ITARARE TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 114751, 3523206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6202, 12361, 'REGISTRO DE IMOVEIS', 123562, 3523206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6203, 5774, 'OFICIAL DE REGISTRO CIVIL E ANEXO DE NOTAS', 119164, 3523305, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6204, 6687, 'OFICIO DOS REGISTROS CIVIS DE PESSOAS NATURAIS, DE INTERDICOES E TUTELAS, DAS PESSOAS JURIDICAS E TITULOS E DOCUMENTOS', 104851, 4203006, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6205, 12362, '2º TABELIONATO DE NOTAS E PROTESTOS DE CACADOR', 104604, 4203006, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6206, 12363, 'OFICIO DE REGISTRO DE IMOVEIS', 107565, 4203006, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6207, 5282, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE CAIBI', 106864, 4203105, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6208, 5283, 'ESCRIVANIA DE PAZ DE CALMON-SC', 106146, 4203154, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6209, 12364, 'TABELIONATO DE NOTAS E PROTESTOS DE TITULOS DE CAMBORIU ', 108852, 4203204, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6210, 7246, 'REGISTRO CIVIL E REGISTRO DE IMOVEIS', 149963, 4203204, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6211, 5284, 'ESCRIVANIA DE PAZ DE CAMPO ALEGRE', 106153, 4203303, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6212, 5285, 'OFICIO DE REGISTRO DE IMOVEIS E REGISTRO CIVIL DAS PESSOAS NATURAIS, JURIDICAS, TITULOS E DOCUMENTOS DA COMARCA DE CAMPO BELO DO SUL', 107722, 4203402, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6213, 12365, 'TABELIONATO DE NOTAS E PROTESTOS DE CAMPO BELO DO SUL SC.', 109389, 4203402, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6214, 12652, '1° TABELIAO DE NOTAS DE DIADEMA', 111385, 3513801, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6215, 5547, 'ESCRIVANIA DE PAZ DE TIGRINHOS', 108811, 4217956, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6216, 12439, 'SERVICO DE REGISTRO DE IMOVEIS DA COMARCA DE TIJUCAS-SC', 107912, 4218004, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6217, 5548, 'REGISTRO CIVIL DAS PESSOAS NATURAIS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 108142, 4218004, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6218, 12440, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS DE TIJUCAS', 109637, 4218004, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6219, 7141, 'CARTORIO PESSETTI', 105627, 4218103, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6220, 5549, 'OFICIO DO REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 107821, 4218202, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6221, 12441, '2º OFICIO DO REGISTRO DE IMOVEIS', 104489, 4218202, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6222, 12442, '1.º OFICIO DE REGISTRO DE IMOVEIS DA COMARCA DE TIMBO, ESTADO DE SANTA CATARINA', 104166, 4218202, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6223, 12443, 'TABELIONATO DE NOTAS E PROTESTOS EM GERAL', 109488, 4218202, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6224, 5550, 'ESCRIVANIA DE PAZ REGISTRO CIVIL E ATOS NOTARIAIS', 108662, 4218251, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6225, 5551, 'ESCRIVANIA DE PAZ DE TRES BARRAS', 106534, 4218301, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6226, 7142, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE TREVISO', 144196, 4218350, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6227, 5743, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE JUNDIAPEBA', 121640, 3530607, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6228, 12730, '1º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS DE MOGI DAS CRUZES', 111567, 3530607, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6229, 12731, 'TERCEIRO TABELIONATO DE NOTAS E PROTESTOS', 109629, 4209300, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6230, 12732, 'CARTORIO 1º OFICIO REGISTRO DE IMOVEIS E HIPOTECAS DA COMARCA DE LAGES-SC', 104885, 4209300, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6231, 12733, '2º TABELIONATO DE NOTAS E OFICIO DE PROTESTOS', 104539, 4209300, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6232, 12734, '3 OFICIO DE REGISTRO DE IMOVEIS DA COMARCA DE LAGES', 109603, 4209300, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6233, 12735, 'CARTORIO 2º OFICIO REGISTRO DE IMOVEIS E HIPOTECAS DE LAGES-SC', 104893, 4209300, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6234, 12736, 'QUARTO OFICICIO DE REGISTROS DE IMOVEIS', 108100, 4209300, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6235, 12737, 'QUARTO TABELIONATO DE NOTAS E PROTESTOS', 108118, 4209300, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6236, 4856, 'OFICIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS', 107524, 4209300, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6237, 4858, 'ESCRIVANIA DE PAZ DO DISTRITO DE RIBEIRAO PEQUENO', 106724, 4209409, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6238, 4857, 'ESCRIVANIA DE PAZ', 105973, 4209409, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6239, 5382, 'OFICIO DEMETRIO', 107748, 4209409, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6240, 12738, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECARIO', 105429, 4209409, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6241, 12739, 'TABELIONATO DE NOTAS E PROTESTOS DE LAGUNA', 107425, 4209409, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6242, 7104, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE LAJEADO GRANDE', 106948, 4209458, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6243, 5504, 'LAURENTINO TABELIONATO DE NOTAS', 107433, 4209508, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6244, 5505, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS', 150409, 4209607, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6245, 12740, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 150391, 4209607, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6246, 12741, 'CARTORIO DE REGISTRO DE IMOVEIS DE LEBON REGIS-SC', 105403, 4209706, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6247, 5506, 'CARTORIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS', 105247, 4209706, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6248, 12742, 'TABELIONATO DE NOTAS E OFICIO DE PROTESTOS', 109066, 4209706, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6249, 5383, 'SERVICOS NOTARIAS FRANZEN', 108951, 4209805, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6250, 5384, 'ESCRIVANIA DE PAZ DE LINDOIA DO SUL', 106310, 4209854, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6251, 5385, 'SERVICO REGISTRAL E NOTARIAL DE LONTRAS', 108936, 4209904, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6252, 5386, 'ESCRIVANIA DE PAZ DE LUIZ ALVES', 106328, 4210001, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6253, 7127, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE LUZERNA-SC', 106955, 4210035, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6254, 5387, 'ESCRIVANIA DE PAZ DE MACIEIRA-SC', 106336, 4210050, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6255, 5388, 'CARTORIO DO REGISTRO CIVIL', 105452, 4210100, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6256, 12743, 'REGISTRO DE IMOVEIS - 2ª CIRCUNSCRICAO', 108464, 4210100, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6257, 12744, '1. TABELIONATO DE NOTAS E PROTESTO DE MAFRA', 104141, 4210100, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6258, 12745, '2º TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 104562, 4210100, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6259, 12746, 'MAFRA 1º OFICIO DO REGISTRO DE IMOVEIS ', 107458, 4210100, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6260, 5507, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE MAJOR GERCINO', 106963, 4210209, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6261, 5389, 'ESCRIVANIA DE PAZ DE MAJOR VIEIRA', 106344, 4210308, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6263, 5391, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 108266, 4210506, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6264, 12747, 'SERVENTIA REGISTRAL IMOBILIARIA ', 108878, 4210506, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6265, 12748, 'TABELIONATO DE NOTAS E PROTESTOS DE TITULOS', 109447, 4210506, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6266, 4832, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E INTERDICOES E TUTELAS', 121475, 3500105, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6267, 7152, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE ADOLFO', 123489, 3500204, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6268, 12749, 'TABELIONATO DE NOTAS E PROTESTO DA COMARCA DE AGUAI SP', 126110, 3500303, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6269, 4833, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE AGUAI', 146563, 3500303, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6270, 4834, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS ', 123174, 3500402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6271, 4835, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE AGUAS DE LINDOIA', 144949, 3500501, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6272, 1872, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICOES NOTARIAIS', 36087, 3123007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6273, 11853, 'CARTORIO DE REGISTRO DE IMOVEIS', 33415, 3123007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6274, 1873, 'OIFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 55038, 3123106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6275, 11854, 'TABELIONATO DE PROTESTO DE TITULOS E OUTROS DOCUMENTOS DE DIVIDA', 58834, 3123205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6276, 11855, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 152660, 3123205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6277, 11856, 'SERVICO NOTARIAL DO 1º OFICIO', 58875, 3123205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6278, 1874, 'CARTORIO DE REGISTRO CIVIL PESSOAS NATURAIS DORES DO INDAIA', 35329, 3123205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6279, 11857, 'SERVICO REGISTRAL IMOBILIARIO DE DORES DO INDAIA', 59766, 3123205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6280, 11858, 'SERVICO NOTARIAL 2º OFICIO DE DORES DO INDAIA', 58818, 3123205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6281, 6958, 'OFICIO DE REGISTRO CIVIL E NOTAS', 46664, 3123304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6282, 1875, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE DORESOPOLIS', 38406, 3123403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6283, 1876, 'OFICIO DO REGISTRO CIVIL E TABELIONATO', 51367, 3123502, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6284, 1877, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE DURANDE ', 37382, 3123528, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6285, 11859, 'CARTORIO DO PRIMEIRO OFICIO DE ELOI MENDES', 41772, 3123601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6286, 11860, '2º TABELIONATO DE NOTAS', 32664, 3123601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6287, 11861, 'OFICIO DO 1º TABELIONATO DE PROTESTOS DE ELOI MENDES - MG', 48934, 3123601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6288, 11862, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39610, 3123601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6289, 11863, 'CARTORIO DE REGISTRO DE IMOVEIS', 38653, 3123601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6290, 1878, 'ELOI MENDES CARTORIO DO REGISTRO CIVIL', 45518, 3123601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6291, 1938, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52621, 3123700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6292, 1937, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE SAO JOSE DO ACACIO', 56739, 3123700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6293, 1936, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE DIVINO DO TRAIRA', 43968, 3123700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6294, 1939, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 43141, 3123809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6295, 11864, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48322, 3133501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6296, 11865, 'OFICIO DO 1º TABELIONATO DE PROTESTOS DE TITULOS', 49023, 3133501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6297, 2094, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54387, 3133501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6298, 2091, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE LAMOUNIER', 44610, 3133501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6299, 2095, 'SERVICO DO REGISTRO CIVIL DAS PESSOAS NATRUAIS E NOTAS', 58701, 3133600, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6300, 2096, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51540, 3133709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6301, 2097, 'CARTORIO REGISTRO CIVIL E TABELIONATO', 44784, 3133758, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6302, 11866, 'SERVICO NOTARIAL DO 1º OFICIO', 58909, 3133808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6303, 11867, 'OFICIO DO REGISTRO DE IMOVEIS DE ITAUNA', 59444, 3133808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6304, 11868, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49536, 3133808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6305, 6964, 'SERVICO REGISTRAL CIVIL DAS PESSOAS NATURAIS', 59139, 3133808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6306, 11869, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE ITAUNA', 59618, 3133808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6307, 11870, 'TABELIONATO DE PROTESTO DE TITULOS', 60293, 3133808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6308, 2266, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE ITAVERAVA', 37424, 3133907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6309, 2098, 'REGISTRO CIVIL DE MONSENHOR IZIDRO', 44818, 3133907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6310, 2099, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE JACARE', 45773, 3134004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6311, 6646, 'ITINGA-CARTORIO DE NOTAS E REGISTRO CIVIL', 45765, 3134004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6312, 2100, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE QUATITUBA', 53264, 3134103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6313, 2101, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE ITUETA', 53306, 3134103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6314, 11871, 'ITUIUTABA CARTORIO DO REGISTRO DE PROTESTO', 45799, 3134202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6315, 11872, 'SEGUNDO SERVICO DE REGISTRO DE IMOVEIS DA COMARCA DE ITUIUTABA', 58016, 3134202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6316, 11873, 'TERCEIRO TABELIONATO DE NOTAS', 61390, 3134202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6317, 11874, 'PRIMEIRO TABELIONATO DE NOTAS', 55376, 3134202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6318, 2102, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE ITUIUTABA-MG', 35956, 3134202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6319, 6185, 'RIBEIRA CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXOS', 116723, 3542800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6320, 6186, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 122887, 3542909, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6321, 6511, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DO DISTRITO DE GUARAPIRANGA (COMARCA DE RIBEIRAO BONITO-SP)', 115345, 3542909, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6322, 12125, 'TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS ', 126136, 3542909, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6323, 12126, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 124354, 3542909, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6324, 6187, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS', 119321, 3543006, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6325, 6188, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE RIBEIRAO CORRENTE', 124586, 3543105, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6326, 6189, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE RIBEIRAO DO SUL', 117747, 3543204, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6327, 6512, 'REGISTRO CIVIL E TABELIONATO', 123463, 3543238, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6328, 6513, 'CARTORIO DE REGISTRO CIVIL  DAS PESSOAS NATURAIS E ANEXOS DE RIBEIRAO GRANDE', 113878, 3543253, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6329, 6515, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE RIBEIRAO PIRES-SP', 116301, 3543303, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6330, 12127, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE RIBEIRAO PIRES', 125468, 3543303, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6331, 12128, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120840, 3543303, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6332, 6514, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE OURO FINO PAULISTA', 122598, 3543303, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6333, 12129, '2O. TABELIAO DE PROTESTO DE LETRAS E TITULOS DE RIBEIRAO PRETO', 112391, 3543402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6334, 6190, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DO DISTRITO DE BONFIM PAULISTA', 114298, 3543402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6335, 12130, '1º OFICIAL DE REGISTRO DE IMOVEIS DE RIBEIRAO PRETO', 111435, 3543402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6336, 12131, 'SEGUNDO TABELIAO DE NOTAS', 123877, 3543402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6337, 12132, 'MARILIA REATO DA SILVA - TERCEIRA TABELIA DE NOTAS DE RIBEIRAO PRETO', 126300, 3543402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6338, 12133, '4º TABELIONATO DE NOTAS DE RIBEIRAO PRETO', 113563, 3543402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6339, 12134, '1º TABELIAO DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE RIBEIRAO PRETO', 112144, 3543402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6340, 6517, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERICOES E TUTELAS DO 1º SUBDISTRITO', 121467, 3543402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6341, 12135, '1ºTABELIAO DE NOTAS ', 112227, 3543402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6342, 6516, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 3º SUBDISTRITO DA SEDE', 115311, 3543402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6343, 12136, '2º OFICIAL DE REGISTRO DE IMOVEIS DE RIBEIRAO PRETO', 112490, 3543402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6344, 12137, 'OFICIAL DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE RIBEIRAO PRETO', 121129, 3543402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6345, 7162, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º SUBDISTRITO DA SEDE DA COMARCA DE RIBEIRAO PRETO-SP', 115246, 3543402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6346, 12138, '5º.TABELIAO DE NOTAS DE RIBEIRAO PRETO', 113647, 3543402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6347, 6518, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE RIFAINA', 124446, 3543600, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6348, 6519, 'REGISTRO CIVIL E ANEXOS DE NOTAS', 123406, 3543709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6349, 6520, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117416, 3543808, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6350, 6521, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 115543, 3543907, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6351, 12139, '2º TABELIONATO DE NOTAS E PROTESTOS DE LETRAS E TITULOS', 113142, 3543907, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6352, 6522, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE AJAPI, DA COMARCA DE RIO CLARO', 114801, 3543907, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6353, 12140, '1º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS DA COMARCA DE RIO CLARO (SP)', 111559, 3543907, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6354, 12141, '3º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS. ', 113357, 3543907, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6355, 6192, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116848, 3544004, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6356, 5552, 'ESCRIVANIA DE PAZ DE SAO GABRIEL', 106492, 4218400, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6357, 5553, 'ESCRIVANIA DE PAZ DE TREZE TILIAS - CARTORIO PERONDI', 106559, 4218509, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6358, 5554, 'SERVICO REGISTRAL CIVIL DAS PESSOAS NATURAIS E JURIDICAS E DE TITULOS E DOCUMENTOS', 108910, 4218608, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6359, 12444, 'TROMBUDO CENTRAL OFICIO DO REGISTRO DE IMOVEIS', 109652, 4218608, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6360, 12445, 'TROMBUDO CENTRAL TABELIONATO DE NOTAS E PROTESTOS', 109660, 4218608, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6361, 12446, '1° OFICIO DE REGISTRO DE IMOVEIS DA COMARCA DE TUBARAO', 105510, 4218707, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6362, 12447, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE TUBARAO', 150060, 4218707, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6363, 12448, 'TUBARAO CARTORIO SEGUNDO OFICIO REGISTRO DE IMOVEIS ', 109678, 4218707, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6364, 12449, '2º TABELIONATO DE NOTAS E PROTESTO DE TITULOS DA COMARCA DE TUBARAO', 108803, 4218707, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6365, 5555, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, JURIDICAS, TITULOS E DOCUMENTOS DE TUBARAO', 105650, 4218707, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6366, 12450, '1º TABELIONATO DE NOTAS E PROTESTOS', 104315, 4218707, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6367, 5556, 'ESCRIVANIA DE PAZ DE TUNAPOLIS', 106567, 4218756, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6368, 12451, 'TABELIONATO DE NOTAS E DE PROTESTOS', 109041, 4218806, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6369, 7143, 'CARTORIO DE REGISTRO CIVIL, PESSOA JURIDICA, TITULOS E DOCUMENTOS', 105221, 4218806, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6370, 12452, 'CARTORIO DE REGISTRO DE IMOVEIS', 105312, 4218806, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6371, 5557, 'ESCRIVANIA DE PAZ', 107391, 4218855, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6372, 12453, 'OFICIO DE REGISTRO DE IMOVEIS DE URUBICI - SC', 105379, 4218905, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6373, 4789, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS ', 108324, 4218905, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6374, 12454, 'TABELIONATO DE NOTAS E PROTESTOS DE TITULOS ', 109421, 4218905, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6375, 5559, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE URUPEMA', 107060, 4218954, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6376, 12455, 'REGISTRO DE IMOVEIS ', 105338, 4219002, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6377, 12456, 'SERVENTIA NOTARIAL E REGISTRAL PEREIRA', 108902, 4219002, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6378, 5560, 'CARTORIO DE REGISTRO CIVIL , TITULOS E DOCUMENTOS E PESSOA JURIDICA DAMIANI', 105106, 4219002, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6379, 5840, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117218, 3509304, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6380, 12457, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124842, 3509403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6381, 5842, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE CAJURU, SP', 113951, 3509403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6382, 12458, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA ', 120246, 3509403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6383, 5843, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE CAMPINA DO MONTE ALEGRE, DA COMARCA DE ANGATUBA', 115444, 3509452, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6384, 5846, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2 SUBDISTRITO', 115196, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6385, 12459, 'SEGUNDO TABELIAO DE NOTAS DE CAMPINAS', 123893, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6386, 12460, '3º TABELIAO DE PROTESTO DE LETRAS E TITULOS DE CAMPINAS', 113399, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6387, 12461, '5º TABELIONATO DE NOTAS DE CAMPINAS/SP', 113621, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6388, 12462, '1. TABELIAO DE NOTAS DE CAMPINAS', 111104, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6389, 12463, '6ºTABELIAO DE NOTAS', 113696, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6390, 12464, '4º TABELIAO DE NOTAS DE CAMPINAS-SP', 113522, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6391, 12465, '3º OFICIAL DE REGISTRO DE IMOVEIS DA COMARCA DE CAMPINAS', 113274, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6392, 12466, '1º OFICIAL DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 122325, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6393, 5954, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO 1º SUBDISTRITO DA SEDE', 116459, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6394, 5953, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO 3ºSUBDISTRITO DE CAMPINAS-SP', 121327, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6395, 12467, '2º TABELIAO DE PROTESTO DE LETRAS E TITULOS DE CAMPINAS', 113092, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6396, 5845, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE BARAO GERALDO', 117887, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6397, 12468, '3 TABELIAO DE NOTAS', 113167, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6398, 5844, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE SOUSAS', 117804, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6399, 4788, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE TREZE DE MAIO-SC', 109645, 4218400, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6400, 4836, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE AGUAS DE SANTA BARBARA', 118281, 3500550, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6401, 4837, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE AGUAS DE SAO PEDRO', 117556, 3500600, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6402, 12751, 'CARTORIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA, E PROTESTO DE TITULOS', 114447, 3500709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6403, 12752, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 125740, 3500709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6404, 4839, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE DOMELIA', 121665, 3500709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6405, 4838, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115915, 3500709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6406, 4840, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ALAMBARI', 118299, 3500758, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6407, 4841, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE ALFREDO MARCONDES', 117564, 3500808, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6408, 4842, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ALTAIR-SP.', 118307, 3500907, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6409, 12753, 'TABELIAO DE NOTAS E PROTESTO DE LETRA E TITULOS', 125674, 3501004, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6410, 12754, 'OFICIAL DO REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL PESSOA JURIDICA E TABELIAO DE PROTESTOS DE LETRAS E TITULOS', 122028, 3501004, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6411, 7153, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE ALTINOPOLIS', 115923, 3501004, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6412, 4844, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS', 119305, 3501103, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6413, 4845, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE ALUMINIO', 114280, 3501152, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6414, 4846, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ALVARES FLORENCE, DA COMARCA DE VOTUPORANGA', 117028, 3501202, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6415, 4847, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117325, 3501301, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6416, 4848, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE CORONEL GOULART, DA COMARCA DE PRESIDENTE PRUDENTE', 123075, 3501301, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6417, 4849, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ALVARO DE CARVALHO', 118315, 3501400, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6418, 4850, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAS E TABELIAO DE NOTAS', 119065, 3501509, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6419, 4851, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE AMERICANA, ESTADO DE SAO PAULO', 121418, 3501608, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6420, 12755, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE AMERICANA', 112839, 3501608, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6421, 12756, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DA COMARCA DE AMERICANA', 119909, 3501608, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6422, 4819, 'OFICIO UNICO DE SALGADO', 110841, 2806206, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6423, 4820, 'OFICIO UNICO DE SANTA LUZIA DO ITANHY', 110858, 2806305, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6424, 4821, 'CARTORIO DE OFICIO UNICO DO DISTRITO DE SANTA ROSA DE LIMA', 110791, 2806503, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6425, 12696, 'CARTORIO DE 1º OFICIO ', 152389, 2806701, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6426, 4377, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84111, 4119301, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6427, 12950, 'SERVICO DE REGISTRO DE IMOVEIS', 87072, 4119301, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6428, 4376, 'SERVICO DISTRITAL DE PEDRO LUSTOSA', 153312, 4119301, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6429, 12951, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS E DOCUMENTOS', 88138, 4119301, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6430, 7295, 'SERVICO DISTRITAL DE BOM RETIRO ', 141770, 4119301, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6431, 12952, 'TABELIONATO DE NOTAS DE PIRAI DO SUL', 87403, 4119400, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6432, 6549, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO CIVIL DE PESSOAS NATURAIS E SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E PROTESTO', 86173, 4119400, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6433, 4378, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 144691, 4119509, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6434, 12953, 'SERVICO DE REGISTRO DE IMOVEIS', 85274, 4119509, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6435, 5021, 'OFICIO UNICO DE CARDOSO MOREIRA', 92213, 3301157, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6436, 12954, 'CARTORIO DO OFICIO UNICO', 91017, 3301207, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6437, 12955, 'DISTRIBUIDOR, CONTADOR E PARTIDOR', 91876, 3301207, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6438, 6552, 'RCPN 1 DISTRITO DE CARMO', 92445, 3301207, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6439, 12956, 'CARTORIO DISTRIBUIDOR,CONT.E PARTIDOR', 90043, 3301306, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6440, 7213, 'OFICIO UNICO DE CASIMIRO DE ABREU', 88807, 3301306, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6441, 4913, 'RCPN DO 2º DISTRITO DE CASIMIRO DE ABREU-BARRA DE SAO JOAO', 92825, 3301306, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6442, 4915, 'OFICIO UNICO DE LEVY GASPARIAN', 148114, 3300951, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6443, 4914, 'RCPN DO 5º DISTRITO DE TRES RIOS', 92916, 3300951, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6444, 12957, 'CARTORIO DISTRIBUIDOR, CONTADOR E PARTIDOR', 89938, 3301405, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6445, 12958, 'OFICIO UNICO DE CONCEICAO DE MACABU', 92221, 3301405, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6446, 12959, 'DISTRIBUIDOR, CONTADOR E PARTIDOR', 91892, 3301504, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6447, 4917, 'CARTORIO DO OFICIO UNICO DE CORDEIRO', 91041, 3301504, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6448, 12960, 'CARTORIO DISTRIBUIDOR CONTADOR E PARTIDOR', 89870, 3301603, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6449, 12961, 'OFICIO UNICO DO MUNICIPIO DE DUAS BARRAS', 154591, 3301603, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6450, 12962, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 1º DISTRITO DA COMARCA DE DUAS BARRAS', 146217, 3301603, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6451, 12963, '6° OFICIO DE JUSTICA', 89318, 3301702, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6452, 4920, 'RCPN E TABELIONATO DO 3º DISTRITO DE DUQUE DE CAXIAS-RJ', 93062, 3301702, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6453, 4919, 'RCPN 1ª CIRCUNSCRICAO DO 1º DISTRITO DE DUQUE DE CAXIAS-RJ', 92478, 3301702, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6454, 12964, 'CARTORIO DO DISTRIBUIDOR, CONTADOR E PARTIDOR DA COMARCA DE DUQUE DE CAXIAS', 90944, 3301702, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6455, 12965, '4º OFICIO DE JUSTICA DE DUQUE DE CAXIAS - DE', 89201, 3301702, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6456, 12966, '1º OFICIO DE JUSTICA', 88716, 3301702, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6457, 12967, '7º OFICIO DE JUSTICA DE DUQUE DE CAXIAS', 89359, 3301702, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6458, 12968, 'DUQUE DE CAXIAS CARTORIO DO 2 OFICIO', 92056, 3301702, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6459, 12969, 'CARTORIO DO 3º OFICIO DE JUSTICA DE DUQUE DE CAXIAS', 90647, 3301702, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6460, 4921, 'RCPN DO 2º DISTRITO DE DUQUE DE CAXIAS RJ', 92833, 3301702, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6461, 4918, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 4º DISTRITO DE DUQUE DE CAXIAS', 93203, 3301702, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6462, 12970, '5º OFICIO DE DUQUE DE CAXIAS', 89268, 3301702, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6463, 12971, 'DISTRIBUIDOR PARTIDOR E CONTADOR', 91702, 3301801, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6464, 4922, 'OFICIO UNICO', 92189, 3301801, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6465, 12972, 'DISTRIBUIDOR, CONTADOR, PARTIDOR E AVALIADOR DE GUAPIMIRIM-RJ.', 92007, 3301850, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6466, 4923, 'CARTORIO DE GUAPIMIRIM - OFICIO UNICO', 89763, 3301850, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6467, 6554, 'CARTORIO DO OFICIO UNICO', 91025, 3301876, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6468, 4375, 'SERVICO DISTRITAL DE PINHALAO', 86496, 4119202, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6469, 12973, 'DCP DE IGUABA GRANDE', 91652, 3301876, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6470, 4926, 'REGISTRO CIVIL DO PRIMEIRO DISTRITO DE ITABORAI', 93294, 3301900, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6471, 4682, 'SERVICO NOTARIAL E REGISTRO CIVIL', 101451, 4306353, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6472, 4683, 'SERVENTIA NOTARIAL E REGISTRAL DE DILERMANDO DE AGUIAR ', 99788, 4306379, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6473, 6714, 'SERVICO DOS REGISTROS PUBLICOS DE DOIS IRMAOS', 100354, 4306403, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6474, 12974, 'SERVICO NOTARIAL COCHLAR', 100404, 4306403, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6475, 12082, 'TABELIAO DE NOTAS E DE PROTESTO DE PIEDADE', 125534, 3537800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6476, 12083, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120287, 3537800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6477, 6389, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE PIEDADE', 116210, 3537800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6478, 6390, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE PILAR DO SUL', 145631, 3537909, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6479, 6391, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE PILAR DO SUL', 121780, 3537909, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6480, 12084, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 112763, 3538006, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6481, 6485, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA  SEDE', 121384, 3538006, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6482, 12085, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 111666, 3538006, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6483, 6392, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE MOREIRA CESAR COMARCA DE PINDAMONHANGABA', 118125, 3538006, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6484, 12086, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120162, 3538006, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6485, 6157, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 114306, 3538105, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6486, 6159, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE PINHALZINHO', 121772, 3538204, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6487, 6160, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE PIQUEROBI', 118653, 3538303, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6488, 6161, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117036, 3538501, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6489, 12087, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124933, 3538600, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6490, 12088, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E REGISTRO CIVIL DE PESSOA JURIDICA', 120832, 3538600, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6491, 6162, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE PIRACAIA', 116228, 3538600, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6492, 12089, '2º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 112516, 3538709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6493, 12090, '1º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 111518, 3538709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6494, 12705, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 125708, 3514106, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6495, 6163, 'OFICIAL DO REGISTRO CIVIL DA PESSOAS NATURAIS DO 2º SUBDISTRITO DA SEDE DA COMARCA DE PIRACICABA-SP', 121301, 3538709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6496, 6166, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE PIRACICABA 1º SUBDISTRITO', 116236, 3538709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6497, 12091, '2º TABELIAO DE NOTAS DE PIRACICABA', 112698, 3538709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6498, 12092, 'TABELIAO DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE PIRACICABA', 125971, 3538709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6499, 12093, '3º TABELIAO DE NOTAS DE PIRACICABA SP', 113332, 3538709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6500, 12094, '4 TABELIAO DE NOTAS PIRACICABA', 113423, 3538709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6501, 12095, '1º TABELIAO DE NOTAS DE PIRACICABA/SP', 111617, 3538709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6502, 6165, 'OFICIAL DE REG. CIVIL 3º SUBDISTRITO', 114843, 3538709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6503, 6167, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE PIRAJU', 116244, 3538808, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6504, 12096, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS E DOCUMENTOS DE PIRAJU-SP', 126169, 3538808, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6505, 12097, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120063, 3538808, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6506, 6487, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE SANTO ANTONIO DA ESTIVA, DA COMARCA DE PIRAJUI', 118182, 3538907, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6507, 12098, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 120725, 3538907, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6508, 6486, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE PIRAJUI', 116251, 3538907, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6509, 12099, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE PIRAJUI/SP', 125831, 3538907, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6510, 12387, 'OFICIO DE REGISTRO DE IMOVEIS', 108977, 4217709, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6511, 12388, 'SOMBRIO CARTORIO DE NOTAS E PROTESTOS DE TITULOS', 108969, 4217709, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6512, 5544, 'ESCRIVANIA DE PAZ', 105999, 4217758, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6513, 12389, 'REGISTRO DE IMOVEIS', 108431, 4217808, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6514, 5545, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 108332, 4217808, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6515, 12390, '2º TABELIONATO DE NOTAS E PROTESTOS DE TITULOS', 104612, 4217808, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6516, 12391, '1 TABELIONATO NOTAS E PROTESTOS', 104125, 4217808, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6517, 12392, 'REGISTRO DE IMOVEIS', 108456, 4217907, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6518, 12393, 'TABELIONATO DE NOTAS E PROTESTOS EM GERAL', 109470, 4217907, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6519, 5546, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 108282, 4217907, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6520, 12394, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125229, 3507902, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6521, 5892, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE BURI, DA COMARCA DE ITAPEVA', 117135, 3508009, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6522, 5891, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ARACACU, DA COMARCA DE ITAPEVA', 117085, 3508009, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6523, 12395, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE BURITAMA', 125328, 3508108, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6524, 5893, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS, E DE INTERDICOES E TUTELAS DA SEDE', 119008, 3508108, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6525, 12396, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120139, 3508108, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6526, 6008, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE BURITIZAL', 118398, 3508207, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6527, 6009, 'SERVICO DE REGISTRO CIVIL E NOTAS', 124271, 3508306, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6528, 7181, '1.º TABELIONATO DE NOTAS E PROTESTO DE LETRAS E TITULOS E REGISTRO CIVIL DAS PESSOAS NATURAIS', 142877, 3508405, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6529, 6010, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE CABREUVA', 142190, 3508405, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6530, 12397, 'OFICIAL DO REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E TABELIONATO DE PROTESTO', 122010, 3508504, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6531, 6012, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 122911, 3508504, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6532, 12398, '2º TABELIONATO DE NOTAS E PROTESTOS DE CACAPAVA', 113134, 3508504, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6533, 12399, '1° CARTORIO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE CACAPAVA', 111377, 3508504, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6534, 12400, 'OFICIAL DE REGISTROS DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA E PROTESTO', 121194, 3508603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6535, 6702, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES E TUTELAS DA SEDE DA COMARCA DE CACHOEIRA PAULISTA-SP', 119032, 3508603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6536, 12401, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 111047, 3508603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6537, 12402, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA ', 123661, 3508702, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6538, 12403, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125054, 3508702, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6539, 6013, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115683, 3508702, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6540, 12404, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA, DA COMARCA DE CAFELANDIA', 119859, 3508801, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6541, 5895, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115758, 3508801, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6542, 12405, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DA COMARCA DE CAFELANDIA', 126185, 3508801, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6543, 5834, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS DO MUNICIPIO DE CAIABU - COMARCA DE REGENTE FEIJO', 119461, 3508900, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6544, 5835, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS ', 116905, 3509007, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6545, 5836, 'OFICIAL DO REG. CIVIL DAS PES NAT. E TABELIAO DE NOTAS', 121236, 3509106, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6546, 5837, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE JORDANESIA, DA COMARCA DE JUNDIAI', 118067, 3509205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6547, 7151, 'OFICIO UNICO DE SANTANA DO SAO FRANCISCO', 130880, 2806404, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6548, 4822, 'CARTORIO DE SANTO AMARO DAS BROTAS', 110031, 2806602, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6549, 12697, 'CARTORIO 3º OFICIO', 109991, 2806701, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6550, 12698, 'CARTORIO 2º OFICIO', 109983, 2806701, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6551, 4823, 'SAO DOMINGOS CARTORIO DE OFICIO UNICO', 110973, 2806800, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6552, 4825, 'CARTORIO DO UNICO OFICIO DE SAO MIGUEL DO ALEIXO', 110734, 2807006, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6553, 12699, 'CARTORIO DO 1.º OFICIO', 110049, 2807105, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6554, 4826, '2º TABELIONATO DE NOTAS E OFICIO DO REGISTRO CIVIL', 109868, 2807105, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6555, 4827, 'OFICIO UNICO DO DISTRITO DE SIRIRI', 110510, 2807204, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6556, 4828, 'OFICIO UNICO DO DISTRITO DE TELHA', 110932, 2807303, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6557, 12700, 'CARTORIO DO 2º OFICIO', 110346, 2807402, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6558, 12701, 'CARTORIO ANTONIO PRADO - 1º OFICIO', 110007, 2807402, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6559, 4830, 'CARTORIO DO OFICIO UNICO DE TOMAR DO GERU', 110577, 2807501, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6560, 4831, '2º OFICIO DA COMARCA DE UMBAUBA', 109819, 2807600, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6561, 12702, 'CARTORIO 1º OFICIO DE UMBAUBA', 109959, 2807600, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6562, 12703, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124958, 3500105, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6563, 12704, 'OFICIAL DE REGISTRO DE IMOVEIS E ANEXOS DE ADAMANTINA', 119693, 3500105, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6564, 5968, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117077, 3513850, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6565, 5906, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 114157, 3513900, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6566, 5907, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS ', 116962, 3514007, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6567, 5908, 'OFICIAL DE REGISTRO CIVIL  DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA COMARCA DE DOIS CORREGOS', 114934, 3514106, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6568, 12706, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA ', 120410, 3514106, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6569, 5969, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE DOLCINOPOLIS', 114868, 3514205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6570, 5909, 'SERVICO DE REGISTRO CIVIL E NOTAS', 124289, 3514304, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6571, 12707, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE DRACENA', 125369, 3514403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6572, 12708, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120154, 3514403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6573, 5970, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 115014, 3514403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6574, 12709, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120212, 3514502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6575, 5911, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 113886, 3514502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6576, 12710, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124941, 3514502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6577, 5912, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE DUMONT', 121632, 3514601, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6578, 5913, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 124107, 3514700, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6579, 5972, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 116384, 3514809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6580, 5914, 'REGISTRO CIVIL E NOTAS', 123422, 3514809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6581, 12711, 'SERVICO DE NOTAS E ANEXO', 124065, 3514809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6582, 5973, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXAS DE ITAPEUNA', 123414, 3514809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6583, 12712, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 123570, 3514809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6584, 5974, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS', 119354, 3514908, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6585, 5975, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117358, 3514924, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6586, 5976, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS ', 117390, 3514957, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6587, 5915, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS E REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE EMBU DAS ARTES', 111989, 3515004, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6588, 5916, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE EMBU', 147199, 3515004, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6589, 5977, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXO DE NOTAS', 115394, 3515103, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6590, 4684, 'CARTORIO DE NOTAS E REGISTROS DE DOIS LAJEADOS', 97170, 4306452, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6591, 4685, 'OFICIO DOS REGISTROS PUBLICOS', 98384, 4306502, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6592, 12975, 'TABELIONATO DE NOTAS ', 102889, 4306502, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6593, 4687, 'SERVICO NOTARIAL E REGISTRAL DO PONCHE VERDE', 101428, 4306601, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6594, 4686, 'SERVICO NOTARIAL E DE REGISTRO DE DOM PEDRITO-RS', 100701, 4306601, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6595, 12976, 'CARTORIO 1º OFICIO NOTAS DOM PEDRITO-RS', 97113, 4306601, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6596, 12977, 'CARTORIO DE REGISTRO GERAL DE IMOVEIS', 97295, 4306601, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6597, 6715, 'SERVICOS NOTARIAIS E DE REGISTROS DE DONA FRANCISCA', 102087, 4306700, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6598, 4688, 'SERVICOS NOTARIAIS E DE REGISTROS', 101998, 4306734, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6599, 4689, 'SERVICOS NOTARIAIS E REGISTRAIS', 102293, 4306767, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6600, 4530, 'OFICIO DOS REGISTROS PUBLICOS', 98293, 4306809, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6601, 12978, 'TABELIONATO DE NOTAS DE ENCANTADO', 103085, 4306809, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6602, 12979, 'TABELIONATO DE NOTAS', 102707, 4306908, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6603, 4690, 'OFICIO DOS REGISTROS PUBLICOS E TABELIONATO DE PROTESTO', 98715, 4306908, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6604, 4691, 'SERVICO DE REGISTROS PUBLICOS', 100065, 4306932, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6605, 12980, 'SERVICO NOTARIAL DE ENTRE-IJUIS', 100420, 4306932, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6606, 5742, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DO DISTRITO DE TAIACUPEBA', 123059, 3530607, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6607, 5740, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS ', 115527, 3530607, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6608, 12770, '1º TABELIONATO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 112193, 3530607, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6609, 5741, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE BRAS CUBAS', 121657, 3530607, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6610, 5744, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 124081, 3530706, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6611, 12771, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE MOGI GUACU', 120618, 3530706, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6612, 12772, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE MOGI GUACU-SP', 112896, 3530706, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6613, 12773, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE MOJI MIRIM', 111658, 3530805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6614, 12774, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120220, 3530805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6615, 5745, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE MOJI MIRIM - SP ', 116160, 3530805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6616, 12775, 'SEGUNDO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE MOGI MIRIM SP', 123992, 3530805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6617, 2892, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35501, 3151800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6618, 11912, 'POCOS DE CALDAS CARTORIO DO PRIMEIRO OFICIO DE NOTAS', 55210, 3151800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6619, 11913, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36947, 3151909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6620, 2352, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE POCRANE', 51516, 3151909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6621, 6977, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE ACARAI', 43372, 3151909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6622, 11914, 'SERVENTIA DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE POMPEU-MG', 58271, 3152006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6623, 11915, '2º TABELIONATO DE NOTAS', 32722, 3152006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6624, 2353, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SILVA CAMPOS', 31799, 3152006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6625, 2806, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E INTERDICOES E TUTELAS', 36426, 3152006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6626, 11916, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48207, 3152006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6627, 11917, 'CARTORIO DE PROTESTO DE TITULOS DA COMARCA DE POMPEU', 34959, 3152006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6628, 11918, 'SERVENTIA DE REGISTRO DE IMOVEIS DA COMARCA DE POMPEU-MG', 58222, 3152006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6629, 11919, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAL JURIDICAS', 57380, 3152105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6630, 11920, 'PONTE NOVA CARTORIO DE REGISTRO DE IMOVEIS', 55228, 3152105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6631, 7076, 'CARTORIO REGISTRO CIVIL NOTAS VAU ACU ', 44859, 3152105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6632, 11921, 'CARTORIO DO SEGUNDO OFICIO DE NOTAS', 43802, 3152105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6633, 2807, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ROSARIO DO PONTAL', 44008, 3152105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6634, 2356, 'OFICIO DO 1º REGISTRO CIVIL DAS PESSOAS NATURAIS', 47886, 3152105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6635, 2355, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO SEGUNDO SUBDISTRITO', 42432, 3152105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6636, 11922, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS DE PONTE NOVA', 48850, 3152105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6637, 11923, 'SERVICO NOTARIAL DO 1° OFICIO', 58842, 3152105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6638, 11924, 'SERVICO NOTARIAL DO 3º OFICIO DE PONTE NOVA', 59006, 3152105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6639, 2354, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PONTO CHIQUE', 36681, 3152131, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6640, 2357, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53157, 3152170, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6641, 2358, 'ITINGA CARTORIO DE PAZ NOTAS E REGISTRO CIVIL', 45757, 3152170, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6642, 11925, 'OFICIO DE REGISTRO DE IMOVEIS', 47209, 3152204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6643, 11926, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 39776, 3152204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6644, 2359, 'PORTEIRINHA CARTORIO DE PAZ E REGISTRO CIVIL', 55236, 3152204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6645, 11927, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS DE PORTEIRINHA', 48868, 3152204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6646, 11928, 'CARTORIO DO 2º OFICIO DE NOTAS', 41244, 3152204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6647, 2361, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE TOCANDIRA', 46706, 3152204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6648, 2809, 'OFICIO DO REGISTRO CIVIL E NOTAS DE MOCAMBINHO', 51268, 3152204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6649, 2808, 'SERVICO DO REGISTRO CIVIL E NOTAS DO DISTRITO DE GORUTUBA', 58743, 3152204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6650, 11929, '1º OFICIO DE NOTAS', 32052, 3152204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6651, 2360, 'CARTORIO DE PAZ REGISTRO CIVIL E NOTAS', 34652, 3152204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6652, 1940, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 37176, 3123858, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6653, 11930, 'CARTORIO 2º OFICIO DE NOTAS', 33621, 3123908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6654, 11931, 'OFICIO DO 1º TABELIAO DE PROTESTOS DE TITULOS', 47910, 3123908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6655, 11932, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DA COMARCA DE ENTRE RIOS DE MINAS', 130708, 3123908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6656, 1941, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SERRA DO CAMAPUA', 52423, 3123908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6657, 11933, '1º TABELIONATO DE NOTAS DA COMARCA DE ENTRE RIOS DE MINAS', 32284, 3123908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6658, 6959, 'CARTORIO REGISTRO CIVEL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 44289, 3123908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6659, 11934, 'ENTRE RIOS DE MINAS CARTORIO DE REGISTRO DE IMOVEIS', 45526, 3123908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6660, 11935, 'CARTORIO DE TITULOS E DOCUMENTOS E PESSOA JURIDICA', 40253, 3124005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6661, 11936, 'OFICIO DO 1º TABELIONATO DE NOTAS', 47951, 3124005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6662, 11937, 'CARTORIO DO 2º OFICIO DE NOTAS', 41293, 3124005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6663, 11938, 'OFICIO DO REGISTRO DE IMOVEIS ', 53900, 3124005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6664, 6197, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTA CRUZ DA ESPERANCA', 114082, 3546256, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6665, 6198, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 122937, 3546306, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6666, 12152, 'TABELIAO DE NOTAS E PROTESTOS DE LETRAS E TITULOS', 125880, 3546306, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6667, 12153, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DA PESSOA JURIDICA', 119867, 3546306, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6668, 12154, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 120865, 3546405, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6669, 12155, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE SANTA CRUZ DO RIO PARDO', 125260, 3546405, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6670, 6199, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 123323, 3546405, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6671, 6200, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 119545, 3546504, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6672, 6201, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115766, 3546603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6673, 12156, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 125690, 3546603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6674, 12157, 'OFICIAL DE REGISTRO DE IMOVEIS E TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS', 119719, 3546603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6675, 6202, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE SANTA GERTRUDES-SP', 117788, 3546702, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6676, 12158, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS ', 125088, 3546801, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6677, 6747, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE SANTA ISABEL', 115121, 3546801, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6678, 12159, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120196, 3546801, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6679, 6748, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DO MUNICIPIO DE SANTA LUCIA-SP', 123257, 3546900, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6680, 6203, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 114009, 3547007, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6681, 6214, 'CARTORIO DE REGISTRO CIVIL E DAS PASSOAS NATURAIS', 114116, 3547106, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6682, 6215, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE SANTA RITA DOESTE-SP.', 118729, 3547403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6683, 6216, 'OFICIAL DE REGISTRO CIVIL E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE SANTA RITA DO PASSA QUATRO', 119214, 3547502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6684, 12160, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120337, 3547502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6685, 12406, 'OFICIAL DE REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 119776, 3523404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6686, 12407, 'PRIMEIRO TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE ITATIBA', 122457, 3523404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6687, 12408, 'SEGUNDA TABELIA DE NOTAS E PROTESTO DE ITATIBA', 123778, 3523404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6688, 6129, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE LOBO, DA COMARCA DE BOTUCATU', 118109, 3523503, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6689, 5776, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE ITATINGA', 117689, 3523503, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6690, 6131, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ITIRAPINA', 121756, 3523602, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6691, 6132, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE ITIRAPUA-SP', 117697, 3523701, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6692, 6133, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE ITOBI', 117705, 3523800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6758, 11828, 'SERVICO DE REGISTRO DE IMOVEIS', 59881, 3151206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6693, 5777, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE PIRAPITINGUI DE ITU', 118794, 3523909, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6694, 12409, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE ITU', 112870, 3523909, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6695, 12410, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E TABELIAO DE PROTESTO DE LETRAS E TITULOS DE ITU-SP', 120998, 3523909, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6696, 6134, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURARAIS E DE INTERDICOES E TUTELAS DA SEDE', 119057, 3523909, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6697, 12411, '1 TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE ITU', 111054, 3523909, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6698, 6135, 'SERVICO DE REGISTRO CIVIL DAS PESSOA NATURAIS E ANEXO (NOTAS) DE ITUPEVA', 124073, 3524006, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6699, 12412, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS ', 124792, 3524105, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6700, 12413, 'OFICIAL DE REGISTRO DE IMOVEIS ,TITULOS E DOCUMENTOS,CIVIL DE PESSOA  JURIDICA E 1ºTABELIAO DE PROTESTOS E LETRAS', 119610, 3524105, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6701, 5778, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE ITUVERAVA', 115501, 3524105, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6702, 6098, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117374, 3524204, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6703, 5781, 'OFICIAL DE REGISTRO CIVIL  DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA    ', 114942, 3524303, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6704, 12414, '1º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE JABOTICABAL', 111914, 3524303, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6705, 5783, 'OFICIAL REGISTRO CIVIL E TABELIAO DE NOTAS DO DISTRITO DE LUZITANIA-SP', 122085, 3524303, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6706, 5782, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE CORREGO RICO', 117937, 3524303, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6707, 12415, '2º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS ', 112987, 3524303, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6708, 12416, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120071, 3524303, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6709, 12417, '2º CARTORIO DE NOTAS PROTESTO DE LETRAS E TITULOS', 112466, 3524402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6710, 5785, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTEDICOES E TUTELAS DA SEDE DA COMARCA DE JACAREI-SP', 115451, 3524402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6711, 12418, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS ', 111674, 3524402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6712, 12419, 'CARTORIO DO OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E PROTESTO DE TITULOS DA COMARCA DE JACAREI-SP', 114496, 3524402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6713, 5917, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DO MUNICIPIO DE EMILIANOPOLIS-SP', 118968, 3515129, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6714, 5918, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ENGENHEIRO COELHO COMARCA DE MOGI MIRIM', 118422, 3515152, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6715, 12713, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120253, 3515186, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6716, 5919, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 122655, 3515186, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6717, 12714, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125013, 3515186, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6718, 5920, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 124206, 3515194, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6719, 12715, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTO E CIVIL DAS PESSOAS JURIDICAS E ANEXO DE NOTAS', 119834, 3529708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6720, 6117, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES E TUTELAS DA SEDE DA COMARCA DE MIGUELOPOLIS-SP', 121871, 3529708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6721, 12716, 'TABELIAO DE NOTAS E ANEXOS', 124651, 3529708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6722, 6118, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE MINEIROS DO TIETE', 118604, 3529807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6723, 7193, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 118901, 3530003, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6724, 12717, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 119685, 3529906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6725, 5734, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE PEDRO BARROS, DA COMARCA DE MIRACATU', 124172, 3529906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6726, 6119, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 116152, 3529906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6727, 12718, 'TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS', 126052, 3529906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6728, 12719, 'OFICIAL DO REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 121970, 3530102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6729, 12720, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125419, 3530102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6730, 5735, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 115519, 3530102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6731, 12721, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 119883, 3530201, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6732, 5736, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115808, 3530201, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6733, 12722, 'TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS', 125575, 3530201, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6734, 12723, 'TABELIONATO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE MIRASSOL', 126151, 3530300, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6735, 12724, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 119891, 3530300, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6736, 7194, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE RUILANDIA, DA COMARCA DE MIRASSOL', 118869, 3530300, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6737, 6121, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELA DA COMARCA DE MIRASSOL', 115485, 3530300, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6738, 7195, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXOS DO TABELIONATO', 113936, 3530409, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6739, 12725, 'OFICIAL DE REGISTRO DE IMOVEIS E ANEXOS ', 119644, 3530508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6740, 5738, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE IGARAI, COMARCA DE MOCOCA, SP.', 118018, 3530508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6741, 6123, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE SAO BENEDITO DAS AREIAS', 123042, 3530508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6742, 12726, '2º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE MOCOCA', 113043, 3530508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6743, 6122, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA CMARCA DE MOCOCA', 115899, 3530508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6744, 12727, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS ', 111690, 3530508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6745, 12728, '3º TABELIONATO DE NOTAS E PROTESTO DE LETRAS E TITULOS DA COMARCA DE MOGI DAS CRUZES', 113407, 3530607, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6746, 5739, 'REGISTRO CIVIL E TABELIONATO DE NOTAS DE SABAUNA', 122606, 3530607, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6747, 12729, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 112904, 3530607, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6748, 11820, 'REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 57687, 3142700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6749, 2800, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 38174, 3151107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6750, 11821, 'OFICIO DO REGISTRO DE IMOVEIS DE PIRAPETINGA', 38950, 3151107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6751, 11822, 'CARTORIO DO 2° OFICIO DE NOTAS', 41137, 3151107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6752, 2799, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 42168, 3151107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6753, 11823, 'TABELIONATO DO 1º OFICIO DE NOTAS DE PIRAPETINGA', 61143, 3151107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6754, 11824, 'CARTORIO DE PROTESTO DE TITULOS E DOCUMENTOS DE PIRAPETINGA', 34983, 3151107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6755, 11825, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E DE PESSOAS JURIDICAS', 39867, 3151206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6756, 11826, 'PIRAPORA CARTORIO DO 2°OFICIO DE NOTAS', 55202, 3151206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6757, 11827, 'TABELIONATO DE PROTESTO DE TITULOS', 60376, 3151206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6759, 2801, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55947, 3151206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6760, 11829, 'PIRAPORA CARTORIO DO 1° OFICIO DE NOTAS', 55194, 3151206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6761, 2802, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 37093, 3151305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6762, 11830, 'CARTORIO DO 1º OFICIO DE NOTAS DE PITANGUI/MG', 40881, 3151404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6763, 2803, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35584, 3151404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6764, 11831, 'OFICIAL  DE REGISTRO DE PROTESTOS', 46292, 3151404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6765, 11832, 'OFICIO DE REGISTRO DE IMOVEIS DE PITANGUI', 47357, 3151404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6766, 11833, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49411, 3151404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6767, 11834, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39909, 3151404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6768, 11835, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48124, 3151503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6769, 11836, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49791, 3151503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6770, 11837, 'CARTORIO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 40204, 3151503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6771, 2891, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS ', 35790, 3151503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6772, 11838, 'CARTORIO ALVARENGA REGISTRO DE PROTESTOS DE PIUMHI', 33779, 3151503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6773, 11839, 'CARTORIO REGISTRO DE IMOVEIS - COMARCA PIUMHI - MG', 45005, 3151503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6774, 2804, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36921, 3151602, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6775, 11840, '2º TABELIONATO DE NOTAS DE POCO FUNDO', 41103, 3151701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6776, 11841, 'TABELIONATO DE PROTESTO DE TITULOS', 39354, 3151701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6777, 7452, 'CARTORIO DE NOTAS E REGISTRO CIVIL', 34058, 3151701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6778, 11842, 'SERVICO REGISTRAL DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 39438, 3151701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6779, 2805, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50567, 3151701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6780, 11843, 'CARTORIO DO PRIMEIRO OFICIO DE NOTAS', 41897, 3151701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6781, 11844, 'OFICIO DO REGISTRO DE IMOVEIS', 53876, 3151701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6782, 11845, 'CARTORIO DO SEGUNDO OFICIO DE NOTAS', 43729, 3151800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6783, 11846, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48579, 3151800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6784, 11847, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DA COMARCA DE POCOS DE CALDAS', 57521, 3151800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6785, 6957, 'OFICIO REGISTRO CIVIL E TABELIONATO DE NOTAS DE GOROROS', 54858, 3122603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6786, 1867, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 46466, 3122603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6787, 11848, 'OFICIO DO REGISTRO DE TITULOS E DOC DAS PESSOAS JURIDICAS', 54171, 3122702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6788, 11849, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE DOM SILVERIO', 152629, 3122702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6789, 11850, 'DOM SILVERIO CARTORIO DO 1º E 2º OFICIO E NOTAS', 45500, 3122702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6790, 11851, 'OFICIO DO 1º TABELIONATO DE PROTESTOS DE TITULOS', 48975, 3122702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6791, 11852, 'OFICIO DO REGISTRO DE IMOVEIS', 54007, 3122702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6792, 1868, 'OFICIO DO REGESTRO CIVIL DAS PESSAS NATURAIS', 50302, 3122702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6793, 1869, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE DOM VICOSO', 142299, 3122801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6794, 1870, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 37234, 3122900, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6795, 1871, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS ', 52696, 3122900, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6796, 6495, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E  DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE PORANGABA', 146902, 3540507, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6797, 6403, 'TABELIAO DE NOTAS E PROTESTO', 114793, 3540507, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6798, 5872, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE PORTO FELIZ', 116277, 3540606, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6799, 12112, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E TABELIAO DE PROTESTO', 120949, 3540606, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6800, 12113, 'TABELIAO DE NOTAS E DE PROTESTO', 124685, 3540705, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6801, 12114, 'OFICIAL DE REGISTRO DE IMOVEIS TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 119743, 3540705, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6802, 6404, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115865, 3540705, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6803, 6171, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE POTIM', 118661, 3540754, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6804, 6496, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE POTIRENDABA', 143800, 3540804, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6805, 6180, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE QUADRA', 114330, 3541653, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6806, 12115, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 125773, 3541703, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6807, 6503, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DA SEDE E DE INTERDICOES E TUTELAS', 124131, 3541703, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6808, 12116, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA COMARCA DE QUATA/SP', 124438, 3541703, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6809, 6504, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE QUEIROZ', 123117, 3541802, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6810, 12117, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 119933, 3541901, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6811, 6505, 'REGISTRO CIVIL', 122622, 3541901, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6812, 12118, 'TABELIONATO DE NOTAS', 126011, 3541901, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6813, 6405, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117515, 3542008, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6814, 6506, 'CARTORIO DO OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 114504, 3542107, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6815, 12119, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124966, 3542206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6816, 6181, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE AGISSE, COMARCA DE RANCHARIA, ESTADO DE SAO PAULO', 117846, 3542206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6817, 6182, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE GARDENIA DA COMARCA DE RANCHARIA', 123109, 3542206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6818, 6507, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE RANCHARIA, ESTADO DE SAO PAULO', 116285, 3542206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6819, 12120, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120089, 3542206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6820, 6183, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 121517, 3542305, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6821, 12121, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E TABELIAO DE PROTESTO DE LETRAS E TITULOS.', 121004, 3542404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6822, 6508, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE REGENTE FEIJO', 116293, 3542404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6823, 12122, 'TABELIAO DE NOTAS E PROTESTOS DE REGENTE FEIJO - SP', 125914, 3542404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6824, 6509, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 121608, 3542503, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6825, 6510, 'OFICIAL DE RESGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 123000, 3542602, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6826, 12123, 'TABELIONATO DE NOTAS E DE PROTESTO', 126029, 3542602, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6827, 12124, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 120956, 3542602, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6828, 6184, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE RESTINGA', 118687, 3542701, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6974, 12199, '3º TABELIAO DE NOTAS', 113308, 3548500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6829, 5786, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE JACI, DA COMARCA DE MIRASSOL', 114678, 3524501, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6830, 5478, 'ESCRIVANIA DE PAZ', 105957, 4204194, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6831, 7097, '1º OFICIO DO REGISTRO CIVIL E ANEXOS', 104257, 4204202, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6832, 12420, '1º TABELIONATO DE NOTAS E PROTESTOS DE TITULOS', 104349, 4204202, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6833, 5333, 'SEDE FIGUEIRA CARTORIO DE PAZ', 104109, 4204202, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6834, 5289, 'ESCRIVANIA DE PAZ DO DISTRITO DE MARECHAL BORMANN', 106690, 4204202, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6835, 12421, 'OFICIO DE REGISTRO DE IMOVEIS', 107599, 4204202, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6836, 12422, '2º TABELIONATO DE NOTAS E PROTESTO DE TITULOS DE CHAPECO ', 104448, 4204202, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6837, 5479, 'ESCRIVANIA DE PAZ', 105924, 4204251, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6838, 12423, '1° OFICIO DE REGISTRO DE IMOVEIS ', 104182, 4204301, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6839, 12424, 'IIº OFICIO DE REGISTRO DE IMOVEIS- Iº OFICIO DE PROTESTOS ', 107276, 4204301, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6840, 12425, '1º TABELIONATO DE NOTAS E 2º OFICIO DE PROTESTO', 105783, 4204301, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6841, 5480, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, JURIDICAS E DE TITULOS E DOCUMENTOS DE CONCORDIA', 108381, 4204301, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6842, 5481, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE CORDILHEIRA ALTA', 104919, 4204350, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6843, 5334, 'ESCRIVANIA DE PAZ DE CORONEL FREITAS', 150243, 4204400, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6844, 6693, 'CARTORIO SAO DOMINGOS', 105726, 4204459, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6845, 5482, 'CARTORIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS', 150094, 4204558, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6846, 12426, 'TABELIONATO DE NOTAS E PROTESTOS DE TITULOS', 150086, 4204558, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6847, 12427, 'REGISTRO DE IMOVEIS', 150250, 4204558, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6848, 5483, 'CORUPA-TABELIONATO DE NOTAS E REGISTRO CIVIL', 105791, 4204509, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6849, 12428, '1° OFICIO DE REGISTRO DE IMOVEIS', 104174, 4204608, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6850, 12429, '1º TABELIONATO DE NOTAS E OFICIO DE PROTESTO DE TITULOS', 104380, 4204608, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6851, 12430, '2 OFICIO DO REGISTRO DE IMOVEIS DA COMARCA DE CRICIUMA-SC', 104406, 4204608, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6852, 12431, '2º TABELIONATO DE NOTAS E PROTESTOS', 104414, 4204608, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6853, 5485, 'PRIMEIRO OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, TITULOS E DOCUMENTOS E DE PESSOAS JURIDICAS DE CRICIUMA', 108076, 4204608, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6854, 5484, 'ESCRIVANIA DE PAZ', 105866, 4204608, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6855, 12432, 'CARTORIO DO REGISTRO DE IMOVEIS', 105700, 4204707, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6856, 12433, 'TABELIONATO DE NOTAS E OFICIO DE PROTESTOS', 109108, 4204707, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6857, 7122, 'REGISTRO CIVIL TITULOS E DOCUMENTOS', 108217, 4204707, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6858, 7098, 'ESCRIVANIA DE PAZ DE CUNHATAI-SC', 106203, 4204756, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6859, 12434, 'SEGUNDO TABELIONATO DE NOTAS E PROTESTOS', 108795, 4204806, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6860, 5335, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS, JURIDICAS E TITULOS E DOCUMENTOS', 105080, 4204806, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6861, 12435, '1 TABELIONATO DE NOTAS E PROTESTO ', 104117, 4204806, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6862, 12436, 'CARTORIO REGISTRO DE IMOVEIS', 105684, 4204806, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6863, 5336, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS E REGISTRO DE IMOVEIS', 108373, 4204905, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6864, 12437, 'TABELIONATO DE NOTAS E PROTESTOS DE TITULOS', 109413, 4204905, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6865, 12438, 'TABELIONATO,REGISTRO DE IMOVEIS E PROTESTO', 109579, 4205001, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6866, 5337, 'CARTORIO OLMOS', 105601, 4205001, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6867, 5581, 'CARTORIO DO OFICIO UNICO DE AREIA BRANCA-SE', 110528, 2800506, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6868, 5849, 'OFICIAL DE REGISTRO DE IMOVEIS TITULOS E DOCUMENTOS, CIVIL DE PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 119750, 3509908, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6869, 12517, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124891, 3509908, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6870, 5956, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 118919, 3509957, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6871, 12518, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120030, 3510005, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6872, 5957, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA COMARCA DE CANDIDO MOTA', 115584, 3510005, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6873, 12519, 'TÄBELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 126342, 3510005, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6874, 5958, 'SERVICO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 124255, 3510104, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6875, 5850, 'OFICIAL DE REG. CIVIL DAS PESSOAS NATURAIS E NOTARIAL DE CANITAR- COMARCA DE CHAVANTES-SP', 114876, 3510153, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6876, 12520, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125112, 3510203, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6877, 5851, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE CAPAO BONITO', 115980, 3510203, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6878, 12521, 'OFICIAL DE REGISTRO DE IMOVEIS E ANEXOS', 119669, 3510203, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6879, 5852, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO NOTAS DE CAPELA DO ALTO', 118836, 3510302, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6880, 12522, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE CAPIVARI', 125807, 3510401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6881, 5853, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE ITERDICOES E TUTELAS DA SEDE DA COMARCA DE CAPIVARI', 123034, 3510401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6882, 12523, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120378, 3510401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6883, 7130, 'ESCRINIA DE PAZ', 105809, 4211603, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6884, 5508, 'ESCRIVANIA DE PAZ DE NOVA VENEZA', 106385, 4211603, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6885, 5509, 'ESCRIVANIA DE PAZ DE NOVO HORIZONTE', 106393, 4211652, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6886, 12790, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 109173, 4211702, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6887, 5407, 'CARTORIO MARLISE MACALOSSI BURATO', 105577, 4211702, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6888, 12791, 'CARTORIO REGISTRO DE IMOVEIS ORLEANS', 105718, 4211702, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6889, 12792, 'TABELIONATO DE NOTAS E PROTESTOS DE TITULOS', 150425, 4211751, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6890, 12793, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS', 150326, 4211751, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6891, 12794, 'REGISTRO DE IMOVEIS', 149831, 4211751, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6892, 5408, 'ESCRIVANIA DE PAZ DE OURO', 106401, 4211801, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6893, 5409, 'OURO VERDE CARTORIO DE PAZ', 107979, 4211850, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6894, 7132, 'ESCRIVANIA DE PAZ DE PAIAL', 109546, 4211876, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6895, 5410, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE PAINEL', 144212, 4211892, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6896, 5412, 'OFICIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS DA COMARCA DE PALHOCA', 107532, 4211900, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6897, 5411, 'ESCRIVANIA DE PAZ DO DISTRITO DE ENSEADA DE BRITO', 106617, 4211900, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6898, 12795, 'PRIMEIRO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE AMERICANA', 122424, 3501608, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6899, 4859, 'CARTORIO DE REGISTRO CIVIL E ANEXOS DAS PESSOAS NATURAIS DE AMERICO BRASILIENSE', 114074, 3501707, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6900, 4860, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DO MUNICIPIO DE AMERICO DE CAMPOS', 123240, 3501806, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6901, 12796, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E TABELIAO DE PROTESTO DE LETRAS E TITULOS', 120980, 3501905, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6902, 12797, '1º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE AMPARO', 112078, 3501905, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6903, 4861, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE TUTELAS E DE INTERDICOES DA SEDE DA COMARCA DE AMPARO SAO PAULO', 122200, 3501905, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6904, 12798, '2ºTABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE AMPARO - SP', 113159, 3501905, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6905, 4862, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ANALANDIA', 121723, 3502002, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6906, 4863, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE INTERDICAO E TUTELA DA COMARCA DE ANDRADINA-SP', 113894, 3502101, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6907, 12799, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS DA COMARCA DE ANDRADINA', 124420, 3502101, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6908, 12800, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 125732, 3502101, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6909, 12801, 'TABELIAO DE NOTAS E DE PROTESTO DE TITULOS E OUTROS DOCUMENTOS DE DIVIDAS', 125542, 3502200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6910, 4864, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATUARIS DA SEDE DA COMARCA DE ANGATUBA', 114983, 3502200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6911, 12802, 'OFICIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS, TABELIONATO DE PROTESTO DE TITULOS', 122226, 3502200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6912, 4866, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE ANHEMBI', 117572, 3502309, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6913, 4867, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ANHUMAS, DA COMARCA PRESIDENTE PRUDENTE', 122168, 3502408, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6914, 12803, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 124412, 3502507, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6915, 7183, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE APARECIDA-SP', 115931, 3502507, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6916, 12804, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124867, 3502507, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6917, 4868, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS', 119297, 3502606, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6918, 12805, 'TABELIAO DE NOTAS E DE PROTESTO', 124669, 3502705, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6919, 4870, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE APIAI/SP', 115949, 3502705, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6920, 7184, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE ARACAIBA', 142745, 3502705, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6921, 12806, 'REGISTRO DE IMOVEIS E ANEXOS', 123596, 3502705, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6922, 12807, '1º TABELIAO DE NOTAS E PROTESTO', 112011, 3502804, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6923, 5438, 'RIO NEGRINHO CARTORIO DE REGISTRO CIVIL E ANEXOS', 108639, 4215000, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6924, 11966, 'TABELIONATO DE NOTAS E PROTESTOS DE RIO NEGRINHO', 108654, 4215000, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6925, 5439, 'CATORIO DE REGISTRO CIVIL E TABELIONATO DO MUNICIPIO DE RIO RUFINO', 105767, 4215059, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6926, 5440, 'CARTORIO DE PAZ', 104976, 4215075, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6927, 5441, 'ESCRIVANIA DE PAZ SCOZ', 107789, 4215109, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6928, 7106, 'ESCRIVANIA DE PAZ', 105833, 4215208, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6929, 5442, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE SALETE', 107029, 4215307, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6930, 5443, 'SALTO VELOSO CARTORIO DE PAZ', 108670, 4215406, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6931, 5444, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE SANGAO-SC', 105841, 4215455, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6932, 11967, 'TABELIONATO DE NOTAS E PROTESTOS SNTA CECILIA', 109496, 4215505, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6933, 11968, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124776, 3504206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6934, 11969, 'SERVICO DE REGISTRO DE IMOVEIS E ANEXOS', 124388, 3504206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6935, 5604, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 119024, 3504206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6936, 5606, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIA DE NOTAS DO MUNICIPIO DE AVAI', 116582, 3504305, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6937, 5607, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE AVANHANDAVA/SP', 117606, 3504404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6938, 5608, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA COMARCA DE AVARE SAO PAULO', 114561, 3504503, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6939, 11970, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 111757, 3504503, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6940, 11971, '2º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DA COMARCA DE AVARE', 113001, 3504503, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6941, 11972, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE AVARE', 120568, 3504503, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6942, 7154, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117010, 3504602, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6943, 5609, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE BALBINOS', 118364, 3504701, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6944, 5610, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE BALSAMO DA COMARCA DE MIRASSOL   ', 118372, 3504800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6945, 5611, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 122895, 3504909, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6946, 11973, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120014, 3504909, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6947, 11974, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124859, 3504909, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6948, 5612, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE BARAO DE ANTONINA', 124511, 3505005, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6949, 5613, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE BARBOSA', 114181, 3505104, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6950, 11975, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125005, 3505203, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6951, 5614, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115659, 3505203, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6952, 11976, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E TABELIAO DE PROTESTOS DE LETRAS E TITULOS', 121046, 3505203, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6953, 11977, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125070, 3505302, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6954, 5615, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE BARRA BONITA, ESTADO DE SAO PAULO', 115964, 3505302, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6955, 11978, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA COMARCA DE BARRA BONITA', 120493, 3505302, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6956, 5616, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXO', 124156, 3505351, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6957, 5617, 'CRTORIO DO REGISTRO CIVIL E ANEXOS', 114710, 3505401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6958, 11979, 'REGISTRO DE IMOVEIS E ANEXOS DE BARRETOS', 123604, 3505500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6959, 11980, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 112748, 3505500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6960, 5619, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO 1 SUBDISTRITO DA SEDE DA COMARCA DE BARRETOS-SP', 116442, 3505500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6961, 11981, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 111740, 3505500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6962, 6225, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 123091, 3547908, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6963, 6226, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXO', 124149, 3548005, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6964, 6227, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE SANTO ANTONIO DO ARACANGUA, DA COMARCA DE ARACATUBA', 117119, 3548054, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6965, 6228, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXO(NOTAS)', 124198, 3548104, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6966, 6229, 'REGISTRO CIVIL DAS PESSOAS NATURAIS  E TABELIONATO DE NOTAS', 122705, 3548203, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6967, 6230, 'OFICIAL DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 119552, 3548302, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6968, 6231, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE SANTOPOLIS DO AGUAPEI, DA COMARCA DE BIRIGUI', 118877, 3548401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6969, 12194, 'SANTOS 3 CARTORIO DE REGISTRO DE IMOVEIS', 123745, 3548500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6970, 12195, '5º TABELIAO DE NOTAS DE SANTOS', 113605, 3548500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6971, 12196, '2º TABELIAO DE NOTAS DE SANTOS', 112714, 3548500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6972, 12197, 'SETIMO TABELIAO DE NOTAS DE SANTOS ', 124602, 3548500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6973, 12198, '2º CARTORIO DE REGISTRO DE IMOVEIS DE SANTOS', 112474, 3548500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6975, 12200, 'OFICIAL DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 121145, 3548500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6976, 6233, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO PRIMEIRO SUBDISTRITO DE SANTOS-SP', 123018, 3548500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6977, 12201, 'OITAVO TABELIAO DE NOTAS DE SANTOS', 122234, 3548500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6978, 12202, 'TABELIAO DE PROTESTO DE LETRAS E TITULOS DE SANTOS', 125997, 3548500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6979, 6232, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º SUBDISTRITO DA SEDE', 122671, 3548500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6980, 12203, '1º TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS ', 112003, 3548906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6981, 6243, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS', 119289, 3549003, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6982, 6244, 'REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES E TUTELAS DA SEDE', 123299, 3549102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6983, 12204, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120238, 3549102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6984, 12205, 'SEGUNDO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 123950, 3549102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6985, 12206, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE SAO JOAO DA BOA VISTA', 111955, 3549102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6986, 6245, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS DO MUNICIPIO DE SAO JOAO DAS DUAS PONTES', 119495, 3549201, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6987, 6246, 'OFICIAL DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 114918, 3549250, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6988, 6247, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 118851, 3549300, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6989, 12207, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 120709, 3549409, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6990, 6248, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 122713, 3549409, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6991, 12208, 'TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS ', 125567, 3549409, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6992, 6249, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE SAO JOSE DA BELA VISTA', 117796, 3549508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6993, 6250, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 114256, 3549607, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6994, 6251, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DE SAO JOSE DO RIO PARDO-SP.', 116400, 3549706, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6995, 12209, 'REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 123695, 3549706, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6996, 12210, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 112797, 3549706, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6997, 12211, 'PRIMEIRO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 122341, 3549706, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6998, 6254, '3º CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 113266, 3549805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (6999, 6252, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º SUBDISTRITO DA SEDE DA COMARCA DE SAO JOSE DO RIO PRETO', 115261, 3549805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7000, 12212, '2º TABELIAO DE NOTAS', 123885, 3549805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7001, 12213, '2º TABELIAO DE PROTESTO DE LETRAS E TITULOS', 113076, 3549805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7002, 12214, '1º OFICIAL DE REGISTRO DE IMOVEIS', 111427, 3549805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7003, 5854, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE COMARCA DE CARAGUATATUBA', 115881, 3510500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7004, 12524, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124800, 3510500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7005, 12525, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE CARAGUATATUBA', 120592, 3510500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7006, 11903, 'CARTORIO 1º OFICIO DE NOTAS - MARIA COZAC ROCHA', 33555, 3143104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7007, 12526, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA COMARCA DE CARAPICUIBA', 148429, 3510609, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7008, 5959, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 115568, 3510609, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7009, 12527, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE CARDOSO/SP', 125344, 3510708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7010, 12528, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA COMARCA DE CARDOSO', 121087, 3510708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7011, 5855, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115626, 3510708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7012, 5857, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE CASA BRANCA, ESTADO DE SAO PAULO', 115998, 3510807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7013, 12529, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 125765, 3510807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7014, 12530, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 120824, 3510807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7015, 5858, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 123505, 3510906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7016, 5859, 'REGISTRO CIVIL DAS PESSOAS NATURAIS, ANEXO COM TABELIONATO DE NOTAS', 123273, 3511003, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7017, 12531, '1º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 111500, 3511102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7018, 12532, '1º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 112045, 3511102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7019, 5860, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE CATANDUVA', 116004, 3511102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7020, 12533, '1º OFICIAL DO REGISTRO DE IMOVEIS E ANEXOS DE JUNDIAI - SP', 111609, 3525904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7021, 12534, 'TERCEIRO CARTORIO DE NOTAS DE JUNDIAI-SP', 126284, 3525904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7022, 12535, '4º TABELIAO DE NOTAS DE JUNDIAI ', 126227, 3525904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7023, 6140, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO 1º SUBDISTRITO DA SEDE DA COMARCA DE JUNDIAI, SP', 116509, 3525904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7024, 12536, '2 TABELIAO DE NOTAS DE JUNDIAI', 112243, 3525904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7025, 12537, '1 TABELIAO DE NOTAS DE JUNDIAI', 111021, 3525904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7026, 12538, '2º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOAS JURIDICAS', 112623, 3525904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7027, 6141, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º SUBDISTRITO DA SEDE', 124123, 3525904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7028, 12539, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120204, 3526001, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7029, 6142, 'OFICIAL DE REGISTR CIVIL DAS PESSOAS NATURAIS, DE INTERDICOES E DE TUTELAS DA SEDE DA COMARCA DE JUNQUEIROPOLIS, SP', 114892, 3526001, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7030, 12540, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124735, 3526001, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7031, 12541, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 114439, 3526100, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7032, 12542, 'TABELIAO DE NOTAS DE PROTESTOS E LETRAS E TITULOS DA CIDADE DE JUQUIA', 124644, 3526100, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7033, 5795, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE JUQUIA', 116111, 3526100, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7034, 12543, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE JUQUITIBA', 121822, 3526209, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7035, 5796, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXO', 122838, 3526308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7036, 12544, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 120691, 3526407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7037, 5797, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 116129, 3526407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7038, 12545, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125062, 3526407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7039, 4871, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ARACARIGUAMA', 118323, 3502754, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7040, 4872, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE ARACATUBA-SP', 121426, 3502804, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7041, 12808, '3º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE ARACATUBA SP', 113373, 3502804, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7042, 12809, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA COMARCA DE ARACATUBA', 120477, 3502804, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7043, 12810, '2º CARTORIO DE NOTAS E PROTESTOS ', 112458, 3502804, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7044, 4873, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ARACOIABA DA SERRA, DA COMARCA DE SOROCABA', 114165, 3502903, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7045, 5989, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE FRANCISCO MORATO (OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E INTERDICOES E TUTELAS)', 125237, 3516309, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7046, 12811, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS E FRANCO DA ROCHA', 125500, 3516408, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7047, 12812, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 121178, 3516408, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7048, 5990, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115790, 3516408, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7049, 5991, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 121806, 3516507, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7050, 12813, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DEPESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE GALIA', 150961, 3516606, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7051, 5992, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS (REGISTRO CIVIL)', 125179, 3516606, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7052, 12814, 'OFICIAL DE REGISTRO DE IMOVEIS E ANEXOS DE GARCA', 119701, 3516705, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7053, 12815, 'TABELIONATO DE NOTAS E 2.°PROTESTO DE LETRAS E TITULOS', 124818, 3516705, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7054, 5993, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE JAFA', 118034, 3516705, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7055, 5921, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ESTIVA GERBI', 119479, 3557303, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7056, 12757, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS ', 124974, 3515202, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7057, 5922, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 115006, 3515202, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7058, 12758, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 120774, 3515202, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7059, 5978, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 130179, 3515301, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7060, 5979, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE EUCLIDES DA CUNHA PAULISTA', 150052, 3515350, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7061, 5980, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 116046, 3515400, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7062, 12759, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120501, 3515400, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7063, 12760, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124917, 3515400, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7064, 5982, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 121525, 3515608, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7065, 11897, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL PESSOAS JURIDICAS', 54569, 3143005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7066, 11898, 'REGISTRO DE IMOVEIS', 57026, 3143005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7067, 2229, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE JUREIA', 53330, 3143005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7068, 11899, 'OFICIO DO 1º TABELIONATO DE PROTESTOS DE TITULOS  ', 49031, 3143005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7069, 2230, 'MONTE BELO CARTORIO DO REGISTRO CIVIL', 46110, 3143005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7070, 11900, 'MONTE CARMELO-CARTORIO DE REGISTRO DE IMOVEIS-CARTORIO ADA LUZIA RODRIGUES DE MORAES', 46128, 3143104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7071, 2231, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS', 59261, 3143104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7072, 11901, 'TABELIONATO DE PROTESTOS DE MONTE CARMELO', 60855, 3143104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7073, 11902, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49718, 3143104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7074, 11904, 'SERVICO REGISTRAL DE TITULOS DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 59568, 3143104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7075, 2297, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE MONTE FORMOSO', 31807, 3143153, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7076, 2771, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36616, 3143203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7077, 11905, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39479, 3143203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7078, 11906, 'OFICIO DO PRIMEIRO TABELIONATO DE NOTAS', 50104, 3143203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7079, 11907, 'CARTORIO DO SEGUNDO OFICIO DE NOTAS', 43786, 3143203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7080, 2770, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42150, 3143203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7081, 11908, 'OFICIO DO REGISTRO DE IMOVEIS', 54080, 3143203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7082, 11909, 'TABELIONATO DO 1º OFICIO DE PROTESTOS DE MONTE SANTO DE MINAS', 59956, 3143203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7083, 11875, 'ITUIUTABA - CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS', 45781, 3134202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7084, 11876, 'SEGUNDO TABELIONATO DE NOTAS', 58057, 3134202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7085, 11877, 'PRIMEIRO SERVICO DE REGISTRO DE IMOVEIS DA COMARCA DE ITUIUTABA', 55301, 3134202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7086, 11878, 'SERVICO REGISTRAL DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 59600, 3134301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7087, 11879, '2º TABELIONATO DE NOTAS ', 153585, 3134301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7088, 6647, 'SERVICO REGISTRAL CIVIL DAS PESSOAS NATURAIS', 59147, 3134301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7089, 11880, 'SERVICO REGISTRAL DE IMOVEIS', 59394, 3134301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7090, 11881, 'SERVICO NOTARIAL', 58792, 3134301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7091, 11882, 'TABELIONATO DE PROTESTO', 60129, 3134301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7092, 2103, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE MACUCO DE MINAS', 59154, 3134301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7093, 11883, 'TABELIONATO DE PROTESTO DE TITULOS', 60236, 3134400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7094, 2104, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52225, 3134400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7095, 11884, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49643, 3134400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7096, 2224, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 35626, 3142700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7097, 11885, 'CARTORIO 1º OFICIO DE NOTAS E SEUS ANEXOS', 33571, 3142809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7098, 11886, 'CARTORIO REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 45054, 3142809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7099, 11887, 'OFICIO DO REGISTRO DE IMOVEIS', 53918, 3142809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7100, 2227, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS', 59246, 3142809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7101, 11888, '2º TABELIONATO DE NOTAS DE MONTE ALEGRE DE MINAS', 49486, 3142809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7102, 11889, 'TABELIONATO DE PROTESTO DE TITULOS DE MONTE ALEGRE DE MINAS', 60574, 3142809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7103, 11890, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48215, 3142908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7104, 11891, 'TABELIONATO DE PROTESTO DE TITULOS', 60400, 3142908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7105, 11892, 'OFICIO DE REGISTRO DE IMOVEIS', 47266, 3142908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7106, 11893, 'TABELIONATO DE REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL PESSOAS JURIDICAS', 61069, 3142908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7107, 2228, 'CARTORIO DE REGISTRO CIVIL DE MONTE AZUL, MG', 36343, 3142908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7108, 11894, 'TABELIONATO DO 2º OFICIO DE NOTAS', 61242, 3142908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7109, 11895, '1º TABELIONATO DE NOTAS DA COMARCA DE MONTE BELO', 32292, 3143005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7110, 6973, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTA CRUZ DE APARECIDA', 44313, 3143005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7111, 11896, '2º TABELIONATO DE NOTAS DE MONTE BELO-MG', 32813, 3143005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7112, 11910, 'SEGUNDO SERVICO NOTARIAL', 58032, 3143401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7113, 11911, 'SERVICO UNICO REGISTRAL DE IMOVEIS', 59865, 3151800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7114, 12142, '2º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 112532, 3543907, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7115, 12143, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 111716, 3543907, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7116, 6523, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE RIO GRANDE DA SERRA', 117754, 3544103, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7117, 6193, 'OFICIAL DO REGISTRO CIVIL E TABELIAO DE NOTAS', 121897, 3544202, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7118, 6524, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TN', 118984, 3543501, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7119, 6525, 'TABELIAO DE NOTAS E PROTESTO', 125872, 3544251, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7120, 6526, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 147926, 3544251, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7121, 6527, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 126375, 3544301, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7122, 6528, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS             ', 118927, 3544400, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7123, 6530, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS', 119362, 3544509, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7124, 6145, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE SABINO DA COMARCA DE LINS-SP', 116889, 3544608, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7125, 6194, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE SAGRES - SP', 117770, 3544707, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7126, 6406, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXO DE NOTAS', 115386, 3544806, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7127, 6407, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116954, 3544905, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7128, 7163, 'SALESOPOLIS-CARTORIO DE REGISTRO CIVIL E TABELIONATO', 123737, 3545001, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7129, 6408, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE SALMOURAO', 118695, 3545100, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7130, 6409, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE SALTINHO', 118703, 3545159, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7131, 12144, 'SEGUNDO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 123968, 3545209, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7132, 6410, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115709, 3545209, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7133, 12145, 'REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE SALTO, SP', 123653, 3545209, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7134, 6742, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 121509, 3545308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7135, 6743, 'OF. REG. CIVIL DAS PESOAS NATURAIS E NOTARIAL DE  SALTO GRANDE- COMARCA DE OURINHOS-SP', 114777, 3545407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7136, 6744, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117150, 3545506, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7137, 12146, 'SERVICO NOTARIAL E DE PROTESTOS DE LETRAS E TITULOS', 124495, 3545605, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7138, 6745, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 121392, 3545605, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7139, 12147, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DA COMARCA DE SANTA ADELIA', 119941, 3545605, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7140, 6746, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116616, 3545704, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7141, 6146, 'REGISTRO CIVIL DAS PESSOAS NATURAIS  E DE INDERTICOES E TUTELAS', 122689, 3545803, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7142, 12148, 'CARTORIO DO 1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 114488, 3545803, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7143, 12149, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120394, 3545803, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7144, 12150, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE SANTA BRANCA - SP', 120659, 3546009, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7145, 7164, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115725, 3546009, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7146, 12151, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DA COMARCA DE SANTA BRANCA', 125799, 3546009, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7147, 6195, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 121590, 3546108, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7148, 6196, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE SANTA CRUZ DA CONCEICAO', 118711, 3546207, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7149, 12469, '7º TABELIAO DE NOTAS DE CAMPINAS', 113720, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7150, 12470, '1º OFICIAL DE REGISTRO DE IMOVEIS DA COMARCA DE CAMPINAS', 122309, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7151, 12471, '4° OFICIAL DE REGISTRO DE IMOVEIS', 113464, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7152, 12472, 'SEGUNDO SERVICO DE REGISTRO DE IMOVEIS DE CAMPINAS', 123851, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7153, 12473, '1º TABELIAO DE PROTESTO DE LETRAS E TITULOS DE CAMPINAS', 112151, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7154, 12474, '2º OFICIAL DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE CAMPINAS', 112656, 3509502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7155, 5847, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE CAMPO LIMPO PAULISTA', 118406, 3509601, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7156, 12475, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE CAMPOS DO JORDAO', 125336, 3509700, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7157, 5848, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE CAMPOS DO JORDAO - SP', 115972, 3509700, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7158, 12476, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE CAMPOS DO JORDAO', 120584, 3509700, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7159, 5955, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116939, 3509809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7160, 12477, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE JACUPIRANGA', 125393, 3524600, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7161, 6136, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 122077, 3524600, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7162, 12478, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 121079, 3524600, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7163, 6137, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE JAGUARIUNA', 146282, 3524709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7164, 12479, 'TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS', 125617, 3524709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7165, 6138, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115832, 3524808, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7166, 12480, 'SEGUNDO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 123927, 3524808, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7167, 12481, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E TABELIAO DE PROTESTO DE LETRAS E TITULOS', 120972, 3524808, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7168, 12482, 'PRIMEIRO TABELIONATO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS DE JALES/SP', 122523, 3524808, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7169, 5787, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117432, 3524907, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7170, 5788, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE JANDIRA, COMARCA DE BARUERI', 121814, 3525003, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7171, 12483, 'OFICIAL DE REGISTRO DE IMOVEIS, TITTULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS', 119818, 3525102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7172, 12484, 'TABELIAO DE NOTAS E DE PROTESTO', 124693, 3525102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7173, 5789, 'REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES E TUTELAS DA SEDE DA COMARCA DE JARDINOPOLIS', 123307, 3525102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7174, 6099, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE JURUCE', 121681, 3525102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7175, 6100, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE JARINU', 118554, 3525201, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7176, 12485, '1º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E 1º TABELIAO DE PROTESTO DE LETRAS E TITULOS', 111575, 3525300, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7372, 12231, '13º TABELIAO DE NOTAS DE SAO PAULO-SP', 111203, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7177, 6101, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DO MUNICIPIO E COMARCA DE JAU, ESTADO DE SAO PAULO', 116426, 3525300, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7178, 12486, '2º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS.', 112599, 3525300, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7179, 5790, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE POTUNDUVA', 121715, 3525300, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7180, 12487, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE JAU-SP', 111922, 3525300, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7181, 12488, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE JAU-SP', 112888, 3525300, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7182, 5791, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 114140, 3525409, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7183, 5981, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE AGULHA, DA COMARCA DE TAQUARITINGA', 119396, 3515608, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7184, 5923, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE BRASITANIA DA COMARCA DE FERNANDOPOLIS', 117903, 3515509, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7185, 12761, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 123679, 3515509, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7186, 5983, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE FERNANDOPOLIS', 116053, 3515509, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7187, 12762, '1.º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE FERNANDOPOLIS', 111120, 3515509, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7188, 12763, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 113035, 3515509, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7189, 5924, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE FERNAO', 114371, 3515657, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7190, 5984, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE FERRAZ DE VASCONCELOS - SP', 117630, 3515707, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7191, 5985, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE FLORA RICA', 117648, 3515806, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7192, 6066, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116947, 3515905, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7193, 6067, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DO INDAIA DO AGUAPEI', 117291, 3516002, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7194, 7156, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE FLORIDA PAULISTA', 117234, 3516002, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7195, 5986, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 114132, 3516101, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7196, 5987, 'REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES E TUTELAS - 1º SUBDISTRITO DA COMARCA DE FRANCA/SP', 123281, 3516200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7197, 12764, 'SEGUNDO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE FRANCA', 123984, 3516200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7198, 12765, 'SEGUNDO OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E REGISTRO CIVIL DE PESSOA JURIDICA', 123828, 3516200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7199, 12766, '1º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 111773, 3516200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7200, 5988, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º SUBDISTRITO DE FRANCA/SP', 122754, 3516200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7201, 12767, '1 OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, REGISTRO CIVIL DE PESSOAS JURIDICAS E 1 TABELIAO DE PROTESTO DE LETRAS E TITULOS DE FRANCA', 111013, 3516200, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7202, 12768, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE FRANCISCO MORATO', 147181, 3516309, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7203, 12769, '2º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 112557, 3530607, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7204, 12022, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE BATATAIS-SP', 119966, 3505906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7205, 5625, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 124099, 3505906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7206, 5818, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO 1º. SUBDISTRITO DA SEDE DA COMARCA DE BAURU ', 116517, 3506003, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7207, 12023, '2º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, E CIVIL DE PESSOAS JURIDICAS DE BAURU', 112631, 3506003, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7208, 12024, '2º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 112979, 3506003, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7209, 12025, 'PRIMEIRO TABELIONATO DE NOTAS E PROTESTO DE TITULOS E LETRAS DE BAURU-SP', 122531, 3506003, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7210, 12026, '1º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS ', 111534, 3506003, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7211, 5816, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º SUBDISTRITO DA SEDE', 119073, 3506003, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7212, 12027, 'TERCEIRO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE BAURU-SP', 126334, 3506003, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7213, 5821, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE BOTAFOGO/SP', 117895, 3506102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7214, 12028, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E TABELIAO DE PROTESTOS', 121020, 3506102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7215, 12029, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE BEBEDOURO', 125310, 3506102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7216, 5820, 'CARTORIO DE REGISTRO CIVIL E DE INTERDICOES E TUTELAS DA SEDE DE BEBEDOURO', 114124, 3506102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7217, 5945, 'OFICIAL DE REGISTRO CIVIL E TABELIONATO', 119537, 3506201, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7218, 5822, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116699, 3506300, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7219, 5823, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE BERTIOGA', 118380, 3506359, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7220, 12030, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 126045, 3506409, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7221, 6124, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 121244, 3506409, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7222, 12031, 'OFICIAL DO REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 121988, 3506409, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7223, 12032, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE BIRIGUI', 112847, 3506508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7224, 12033, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 114728, 3506508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7225, 5824, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE INTERDICOES E TUTELAS DA SEDE ', 115113, 3506508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7226, 12034, 'PRIMEIRO TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 122473, 3506508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7227, 5825, 'OFICIAL DE REGISTRO CIVIL  DAS PESSOAS NATURAIS E TABELIAO  DE NOTAS DE  BIRITIBA  MIRIM - ', 114959, 3506607, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7228, 5946, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116822, 3506706, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7229, 12035, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA    ', 120170, 3520509, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7230, 12036, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE INDAIATUBA', 111906, 3520509, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7231, 5934, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115717, 3520509, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7232, 6016, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116921, 3520608, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7233, 5935, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE INDIAPORA', 118505, 3520707, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7234, 5936, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE INUBIA PAULISTA', 118513, 3520806, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7235, 7190, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE IPAUSSU', 145607, 3520905, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7236, 12289, '8º OFICIAL DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA CAPITAL', 113753, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7237, 6284, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS DO 32O SUBDISTRITO CAPELA DO SOCORRO - SAO PAULO - CAPITAL', 119438, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7238, 6316, '28º OFICIAL REGISTRO CIVIL JARDIM PAULISTA', 112375, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7239, 6294, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 44º SUBDISTRITO-LIMAO, NESTA CAPITAL ', 122796, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7240, 6302, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE SAPOPEMBA', 115360, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7241, 12290, 'CARTORIO DO 11º TABELIAO DE NOTAS', 114454, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7242, 6310, '40º ORCPN   -   SUBDISTRITO   B R A S I L A N D I A', 113431, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7243, 12291, '16° TABELIAO DE NOTAS DE SAO PAULO', 111260, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7244, 12292, '6º TABELIAO DE PROTESTO DE LETRAS E TITULOS', 113688, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7245, 12293, '2º OFICIAL DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 112649, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7246, 6307, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 42º SUBDISTRITO DO JABAQUARA, COMARCA DA CAPITAL DO ESTADO DE SAO PAULO', 122788, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7247, 6303, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO 3º SUBDISTRITO DA CAPITAL', 114538, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7248, 12294, '16º OFICIAL DE REGISTRO DE IMOVEIS', 111278, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7249, 6291, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 13 SUBDISTRITO DO BUTANTA', 115162, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7250, 12295, '3º REGISTRO DE IMOVEIS DE SAO PAULO', 113282, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7251, 6313, 'RCPN E TAB. DE NOTAS DO DISTRITO DO JARAGUA', 122267, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7252, 12296, '5º OFICIAL DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 113589, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7253, 6315, 'REGISTRO CIVIL E NOTAS 4º SUBDISTRITO NOSSA SENHORA DO O', 123430, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7254, 12297, '10 OFICIAL DE REGISTRO DE IMOVEIS DE SAO PAULO', 111138, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7255, 6312, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS - 06º SUBDISTRITO ¿ BRAS, DA COMARCA DA CAPITAL ¿ SP', 115071, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7256, 6308, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 20º SUBDISTRITO - JARDIM AMERICA', 122721, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7257, 6309, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO SEGUNDO SUBDISTRITO - LIBERDADE', 122804, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7258, 12298, 'OFICIO DE REGISTRO DE IMOVEIS DA COMARCA DE BARRA VELHA', 104760, 4202107, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7259, 12299, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS DE BARRA VELHA/SC.', 109553, 4202107, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7260, 5275, 'CARTORIO DE PAZ DE BELA VISTA DO TOLDO', 105023, 4202131, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7261, 5276, 'ESCRIVANIA DE PAZ DE BELMONTE/SC', 106120, 4202156, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7262, 6685, 'BENEDITO NOVO ESCRIVANIA DE PAZ E TABELIONATO', 104786, 4202206, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7263, 5694, 'CARTORIO DE REGISTRO CIVIL TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 105205, 4202305, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7264, 12300, 'REGISTRO DE IMOVEIS', 108423, 4202305, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7265, 12301, 'BIGUACU CARTORIO DE TABELIONATO PUBLICO', 104794, 4202305, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7266, 5695, 'ESCRIVANIA DE PAZ DO DISTRITO DE GUAPORANGA DO MUNICIPIO DE BIGUACU', 106633, 4202305, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7267, 5696, 'BLUMENAU OFICIO DO REGISTRO CIVIL', 104810, 4202404, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7268, 12302, '3º TABELIONATO DE NOTAS E PROTESTO DE TITULOS DE BLUMENAU', 109611, 4202404, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7269, 12303, '1. TABELIONATO DE NOTAS E PROTESTO DE BLUMENAU', 104133, 4202404, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7270, 5277, 'ESCRIVANIA DE PAZ DO DISTRITO DE ITOUPAVA', 106682, 4202404, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7271, 12304, '2º OFICIO DE REGISTRO DE IMOVEIS DE BLUMENAU', 104463, 4202404, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7272, 12305, '3º OFICIO DE REGISTRO DE IMOVEIS', 104653, 4202404, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7273, 12306, '1º OFICIO DE REGISTRO DE IMOVEIS', 104216, 4202404, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7274, 12307, 'BLUMENAU - 2º OFICIO DE NOTAS', 104802, 4202404, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7275, 5697, 'ESCRIVANIA DE PAZ DE BOCAINA DO SUL', 106138, 4202438, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7276, 5698, 'ESCRIVANIA DE PAZ', 105965, 4202503, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7277, 12308, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE BOM JESUS', 150375, 4202537, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7278, 7121, 'ESCRIVANIA DE PAZ ', 144220, 4202578, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7279, 12309, 'CARTORIO DE REGISTRO DE IMOVEIS', 105346, 4202602, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7280, 5279, 'REGISTRO CIVIL,TITULOS,DOCUMENTOS PESOAS JURIDICAS', 108415, 4202602, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7281, 5278, 'ESCRIVANIA DE PAZ DODISTRITO DE CANOAS', 107078, 4202602, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7282, 7159, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE LORENA - SP', 116145, 3527207, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7283, 12599, '2º TABELIAO DE NOTAS E PROTESTO DE TITULOS E DOCUMENTOS DA COMARCA DE LORENA', 113050, 3527207, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7284, 12600, 'OFICIAL DE REGISTRO DE IMOVEIS, TABELIAO DE PROTESTOS DE LETRAS E TITULOS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 119792, 3527207, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7285, 12601, '1º TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS', 111997, 3527207, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7286, 12602, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE LOURDES DA COMARCA DE BURITAMA', 153957, 3527256, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7287, 5805, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE LOUVEIRA/SP', 118570, 3527306, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7288, 12603, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 126235, 3527405, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7289, 5722, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115105, 3527405, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7290, 12604, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 119636, 3527405, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7291, 5806, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DO MUNICIPIO DE LUCIANOPOLIS', 121855, 3527504, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7292, 5723, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS DE LUIZ ANTONIO-SP.', 119420, 3527603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7293, 5807, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE LUIZIANIA', 121921, 3527702, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7294, 5808, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO', 123133, 3527801, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7295, 5994, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DAS INTERDICOES E TUTELAS DA SEDE DA COMARCA DE GARCA-SP', 122861, 3516705, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7296, 5995, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS', 119255, 3516804, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7297, 5996, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE GAVIAO PEIXOTO-SP', 118430, 3516853, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7298, 12816, 'TABELIONATO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 126128, 3516903, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7299, 12817, 'OFICIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 122218, 3516903, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7300, 5997, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 121368, 3516903, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7301, 5998, 'SERVICO REGISTRAL CIVIL E NOTARIAL', 124487, 3517000, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7302, 12818, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125757, 3517000, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7303, 7182, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115774, 3517000, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7304, 12819, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120402, 3517000, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7305, 6069, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE GLICERIO-SP.', 117655, 3517109, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7306, 6070, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 121798, 3517208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7307, 6071, 'REGISTRO CIVIL E  TABELIONATO DE NOTAS', 123372, 3517307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7308, 12820, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E DE TITULOS DE GUAIRA', 125682, 3517406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7309, 6072, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DE GUAIRA', 116392, 3517406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7310, 12821, 'CARTORIO REGISTRO DE IMOVEIS E ANEXOS DE PROTESTOS DE TITULOS, REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 114686, 3517406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7311, 5926, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE GUAPIACU, DA COMARCA DE SAO JOSE DO RIO PRETO ', 117481, 3517505, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7312, 5618, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2ºSUBDISTRITO', 122770, 3505500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7313, 7155, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE BARRINHA, DA COMARCA DE SERTAOZINHO, DO ESTADO DE SAO PAULO', 114223, 3505609, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7314, 5622, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS DO DISTRITO DE JARDIM BELVAL', 119453, 3505708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7315, 6003, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117366, 3519006, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7316, 6087, 'TABELIONATO CORREA', 126003, 3519055, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7317, 6088, 'REGISTRO CIVIL E TABELIONATO DE NOTAS DE HORTOLANDIA', 123521, 3519071, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7318, 6089, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE IACANGA', 121749, 3519105, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7319, 6090, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE IACRI', 118448, 3519204, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7320, 6091, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE IARAS', 118455, 3519253, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7321, 6004, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116731, 3519303, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7322, 6092, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE IBIRA', 118463, 3519402, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7323, 6005, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE IBIRAREMA, SP', 114199, 3519501, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7324, 11982, 'PRIMEIRO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 122416, 3519600, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7325, 5928, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE IBITINGA', 121434, 3519600, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7326, 11983, '2º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DA COMARCA DE IBITINGA', 113019, 3519600, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7327, 11984, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E PROTESTO DE LETRAS E TITULOS DE IBITINGA', 120923, 3519600, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7328, 5930, 'OFICIAL DE REGISTRO  CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE IBIUNA', 114900, 3519709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7329, 5929, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE PARURU, DA COMARCA DE IBIUNA  ', 119271, 3519709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7330, 11985, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 120733, 3519709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7331, 11986, 'TABELIAO DE NOTAS E DE PROTESTO DE IBIUNA', 124701, 3519709, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7332, 6093, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS ', 116681, 3519808, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7333, 5931, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE IEPE - SP', 118471, 3519907, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7334, 6094, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117002, 3520004, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7335, 11987, 'CARTORIO DE NOTAS E DE PROTESTO DE IGARAPAVA', 113829, 3520103, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7336, 11988, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS DE IGARAPAVA-SP', 120816, 3520103, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7337, 5932, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 116079, 3520103, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7338, 6095, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE IGARATA', 118489, 3520202, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7339, 11989, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125385, 3520301, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7340, 5933, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE IGUAPE', 114520, 3520301, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7341, 11990, 'OFICIAL DE REGISTRO DE IMOVEIS TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DA COMARCA DE IGUAPE/SP', 119735, 3520301, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7342, 6006, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ILHA COMPRIDA', 118497, 3520426, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7343, 6096, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE ILHA SOLTEIRA', 145623, 3520442, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7344, 6014, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE ILHA SOLTEIRA', 125245, 3520442, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7345, 12215, 'TERCEIRO TABELIAO DE NOTAS', 126292, 3549805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7346, 6255, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE ENGENHEIRO SCHMIDT', 122119, 3549805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7347, 6253, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES E TUTELAS DO 1º SUBSDISTRITO DE SAO JOSE DO RIO PRETO', 119040, 3549805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7348, 12216, 'PRIMEIRO TABELIAO DE NOTAS', 122333, 3549805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7349, 12217, 'PRIMEIRO TABELIAO DE PROTESTO DE LETRAS E TITULOS DE SAO JOSE DO RIO PRETO', 122515, 3549805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7350, 12218, '2º OFICIAL DE REGISTRO DE IMOVEIS DE SAO JOSE DO RIO PRETO', 112508, 3549805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7351, 12219, 'QUARTO SERVICO NOTARIAL', 122549, 3549805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7352, 12220, 'OFICIAL DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE SAO JOSE DO RIO PRETO-SP', 121137, 3549805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7353, 6258, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117051, 3549904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7354, 12221, '7º OFICIAL DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA ', 113712, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7355, 6290, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE PERUS - COMARCA DA CAPITAL - SAO PAULO', 116707, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7356, 12222, '1º OFICIAL DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS DE SAO PAULO', 111591, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7357, 12223, '12º OFICIO DE REGISTRO DE IMOVEIS', 111187, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7358, 12224, '3º TABELIAO DE PROTESTO DE LETRAS E TITULOS', 113381, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7359, 6301, '17º OFICIAL DE REGISTRO CIVIL SUBDISTRITO BELA VISTA', 111286, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7360, 6271, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 33º SUBDISTRITO ALTO DA MOOCA', 115295, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7361, 12225, '2º TABELIAO DE PROTESTO DE LETRAS E TITULOS', 113084, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7362, 6293, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS-DISTRITO DO ITAIM PAULISTA -SAO PAULO (SP)', 118810, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7363, 6300, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE PARELHEIROS', 118141, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7364, 12226, '23O TABELIAO DE NOTAS DA CAPITAL', 112318, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7365, 12227, '18º TABELIAO DE NOTAS DE SAO PAULO-SP', 111336, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7366, 6285, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 12º SUBº CAMBUCI', 115154, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7367, 6306, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 26º SUBDISTRITO VILA PRUDENTE', 122747, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7368, 6270, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 34º SUBDISTRITO CERQUEIRA CESAR', 115303, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7369, 12228, '12º TABELIAO DE NOTAS DA COMARCA DA CAPITAL', 114462, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7370, 12229, '6º REGISTRO DE TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS', 113654, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7371, 12230, '7º TABELIAO DE PROTESTO DE LETRAS E TITULOS DE SAO PAULO', 113738, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7373, 12232, '11º OFICIAL DE REGISTRO DE IMOVEIS DE SAO PAULO', 111179, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7374, 12233, '9 OFICIAL DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 113761, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7375, 12234, '2º OFICIAL DE REGISTRO DE IMOVEIS DA CAPITAL DE SAO PAULO', 112482, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7376, 7196, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 27º SUBDISTRITO DE TATUAPE', 143032, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7377, 12235, '15° TABELIAO DE NOTAS ', 111237, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7378, 6292, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE SAO MATEUS', 115352, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7379, 12236, '18º REGISTRO DE IMOVEIS', 111328, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7380, 6296, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DO JARDIM SAO LUIS, MUNICIPIO E COMARCA DE SAO PAULO - SP', 121335, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7381, 12237, '17º OFICIAL DE REGISTRO DE IMOVEIS DE SAO PAULO-SP', 111294, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7382, 6305, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS 19º SUBDISTRITO ', 115048, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7383, 12238, '4º OFICIAL DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA CAPITAL', 113480, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7384, 12239, '13º OFICIAL DE REGISTRO DE IMOVEIS DE SAO PAULO', 111195, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7385, 12161, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE SANTA RITA DO PASSA QUATRO', 125476, 3547502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7386, 6217, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115667, 3547601, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7387, 12162, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS CIVIL DE PESSOA JURIDICA', 119842, 3547601, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7388, 12163, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 112953, 3547601, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7389, 6218, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 123729, 3547650, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7390, 6219, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117440, 3547205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7391, 6220, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS SANTANA DE PARNAIBA', 118802, 3547304, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7392, 12164, '1º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 111492, 3549904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7393, 12165, '1 TABELIAO DE NOTAS DE SAO JOSE DOS CAMPOS', 111039, 3549904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7394, 6257, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º SUBDISTRITO', 115204, 3549904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7395, 12166, 'TERCEIRO TABELIAO DE NOTAS DE SAO JOSE DOS CAMPOS', 126326, 3549904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7396, 12167, '4º TABELIAO DE NOTAS', 113506, 3549904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7397, 12168, 'TABELIONATO DE PROTESTO DE LETRAS E TITULOS', 125955, 3549904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7398, 12169, '2º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE SAO JOSE DOS CAMPOS', 112581, 3549904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7399, 6703, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS-1 SUBDISTRITO DA SEDE-COMARCA DE SAO JOSE DOS CAMPOS-ESTADO DE SAO PAULO', 123026, 3549904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7400, 12170, 'SEGUNDO TABELIAO DE NOTAS', 123869, 3549904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7401, 5792, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117382, 3525508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7402, 5793, 'SERVICO DE REGISTRO CIVIL E TABELIONATO', 124297, 3525607, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7403, 5794, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS E DEMAIS ATOS DA VIDA CIVIL', 116525, 3525706, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7404, 12489, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS', 114397, 3525706, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7405, 12490, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125153, 3525706, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7406, 6102, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 123513, 3525805, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7407, 6139, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 122176, 3525854, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7408, 12491, 'TABELIAO DE PROTESTO DE LETRAS E TITULOS', 125963, 3525904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7409, 5338, 'ESCRIVANIA DE PAZ DE DONA EMMA', 106229, 4205100, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7410, 5486, 'ESCRIVANIA DE PAZ DE DOUTOR PEDRINHO', 106237, 4205159, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7411, 5339, 'REGISTRO CIVIL E TABELIONATO JEREMIAS DE ENTRE RIOS', 108209, 4205175, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7412, 7099, 'ESCRIVANIA DE PAZ DE ERMO', 106245, 4205191, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7413, 5340, 'ESCRIVANIA DE PAZ', 105940, 4205209, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7414, 5341, 'ESCRIVANIA DE PAZ DE FAXINAL DOS GUEDES', 106252, 4205308, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7415, 4779, 'SERVENTIA DE PAZ FLOR DO SERTAO', 108837, 4205357, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7416, 5348, 'ESCRIVANIA DE PAZ DE BARRA DA LAGOA', 106112, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7417, 5351, 'ESCRIVANIA DE PAZ DO DISTRITO DO RIBEIRAO DA ILHA', 106807, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7418, 12492, '2º TABELIONATO DE NOTAS E 1º DE PROTESTO DE TITULOS DA CAPITAL', 104505, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7419, 7100, 'REGISTRO CIVIL E TABELIONATO DO TERCEIRO SUBDISTRITO DOS SACO DOS LIMOES', 108159, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7420, 5343, 'ESCRIVANIA DE PAZ DO DISTRITO DE RATONES', 106716, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7421, 12493, 'ESCRIVANIA DE PAZ DO DISTRITO DE SANTO ANTONIO DE LISBOA', 143255, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7422, 5350, 'CARTORIO DE REGISTRO CIVIL TITULOS DOCUMENTOS E PESSOAS JURIDICAS', 105197, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7423, 5345, 'ESCRIVANIA DE PAZ DO DISTRITO DE INGLESES DO RIO VERMELHO', 106658, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7424, 5349, 'ESCRIVANIA DE PAZ DO 2º SUBDISTRITO DO ESTREITO', 106583, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7425, 5352, 'ESCRIVANIA DE PAZ DO 4° SUBDISTRITO DE FLORIANOPOLIS - SC', 106591, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7426, 5353, 'ESCRIVANIA DE PAZ DO DISTRITO DO CAMPECHE´FLORIANOPOLIS/SC', 106799, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7427, 5347, 'ESCRIVANIA DE PAZ DO DISTRITO DO PANTANO DO SUL', 143230, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7428, 12494, '2° OFICIO DO REGISTRO DE IMOVEIS DE FLORIANOPOLIS/SC', 104422, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7429, 12495, 'FLORIANOPOLIS CARTORIO DO REGISTRO DE IMOVEIS 1° OFICIO', 107219, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7430, 12496, '4º OFICIO DE NOTAS E 4º OFICIO DE PROTESTOS', 104687, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7431, 7249, 'CARTORIO LIDIA MAURICIA LAUREANO DA COSTA', 105544, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7432, 7101, 'REGISTRO CIVIL E TABELIONATO DE NOTAS DO DISTRITO DA LAGOA DA CONCEICAO', 108191, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7433, 5342, 'ESCRIVANIA DE PAZ DO DISTRITO DE SAO JOAO DO RIO VERMELHO', 106757, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7434, 12497, '3º TABELIONATO DE NOTAS E 2º OFICIO DE PROTESTOS', 104661, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7435, 12498, '3° OFICIO DE REGISTRO DE IMOVEIS DE FLORIANOPOLIS/SC', 104638, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7436, 5346, 'CACHOEIRA DO BOM JESUS CARTORIO REGISTRO CIVIL E TABELIONATO', 104869, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7437, 12499, '1º TABELIONATO DE NOTAS E 3º OFICIO DE PROTESTOS', 104281, 4205407, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7438, 12500, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS DE FORQUILHINHA', 109249, 4205456, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7439, 5354, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, JURIDICAS, TITULOS E DOCUMENTOS E OFICIO DO REGISTRO DE IMOVEIS DE FORQUILHINHA', 108555, 4205456, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7440, 12501, 'TABELIONATO DE NOTAS E PROTESTOS', 109199, 4205506, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7441, 12502, 'CARTORIO DE REGISTRO DE IMOVEIS FRAIBURGO', 105445, 4205506, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7442, 7592, 'OFICIO DO REGISTRO CIVIL E DAS PESSOAS NATURAIS', 107771, 4205506, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7443, 5561, 'VARGEAO TABELIONATO DE NOTAS', 109686, 4219101, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7444, 5562, 'ESCRIVANIA DE PAZ DE VARGEM', 106575, 4219150, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7445, 5563, 'ESCRIVANIA DE PAZ', 105882, 4219176, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7446, 4790, 'ESCRIVANIA DE PAZ DE VIDAL RAMOS', 108860, 4219200, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7447, 7144, 'ESCRIVANIA DE PAZ DO DISTRITO DE ANTA GORDA', 107185, 4219309, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7448, 12503, 'TABELIONATO DE NOTAS E PROTESTOS', 109272, 4219309, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7449, 7161, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE MOMBUCA', 116608, 3530904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7450, 5746, 'SERVICO DE REGISTRO CIVIL E NOTARIAL', 124263, 3531001, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7451, 5747, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOAS JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE MONGAGUA', 144006, 3531100, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7452, 12776, '1ºTABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS ( NA ATUALIDADE ACUMULA OS SERVICOS DE REGISTRO CIVIL)', 112235, 3531100, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7453, 5748, 'SERVICO REGISTRAL E NOTARIAL MONTE ALEGRE DO SUL', 124560, 3531209, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7454, 5749, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115634, 3531308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7455, 12777, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE MONTE ALTO', 111880, 3531308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7456, 12778, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE MONTE ALTO/SP', 120626, 3531308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7457, 12779, '2º TABELIAO DE NOTAS E DE PROTESTO', 112730, 3531308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7458, 12780, 'TABELIAO DE NOTAS E PROTESTOS DE LETRAS E TITULOS DE MONTE APRAZIVEL', 113852, 3531407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7459, 12781, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120121, 3531407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7460, 5751, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DAS SEDE', 113969, 3531407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7461, 12782, 'OFICIAL DO REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, PESSOA JURIDICA E PROTETO', 122036, 3531506, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7462, 5752, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115675, 3531506, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7463, 12783, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE MONTE AZUL PAULISTA-SP', 125427, 3531506, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7464, 5753, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 123083, 3531605, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7465, 5754, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS (REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS)', 125161, 3531803, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7466, 12784, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE MONTE MOR', 146290, 3531803, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7467, 7128, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE MAREMA', 106971, 4210555, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7468, 5392, 'MASSARANDUBA TABELIONATO E REGISTRO CIVIL', 107466, 4210605, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7469, 5393, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE MATOS COSTA', 106989, 4210704, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7470, 5395, 'MELEIRO CARTORIO DE PAZ DE SAPIRANGA', 107474, 4210803, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7471, 7255, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS', 150300, 4210803, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7472, 12785, 'TABELIONATO DE NOTAS E PROTESTOS DE TITULOS', 150292, 4210803, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7473, 5396, 'ESCRIVANIA DE PAZ DE MIRIM DOCE', 106369, 4210852, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7474, 12786, 'TABELIONATO DE NOTAS E PROTESTOS', 109264, 4210902, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7475, 7129, 'OFICIO DE REGISTRO DE IMOVEIS E HIPOTECAS, REGISTRO CIVIL DAS PESSOAS NATURAIS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 107714, 4210902, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7476, 12787, 'OFICIO DO REGISTRO DE IMOVEIS', 107854, 4211009, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7477, 5397, 'REGISTRO CIVIL DE MONDAI', 105551, 4211009, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7478, 12788, 'TABELIONATO DE NOTAS E OFICIO DE PROTESTOS EM GERAL', 109132, 4211009, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7479, 5398, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE MONTE CARLO', 106997, 4211058, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7480, 7256, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE MONTE CASTELO', 144238, 4211108, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7481, 5399, 'ESCRIVANIA DE PAZ DE MORRO DA FUMACA', 106377, 4211207, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7482, 5400, 'CARTORIO  DE PAZ DE MORRO GRANDE', 104877, 4211256, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7483, 5401, 'REGISTRO CIVIL DE PESSOAS NATURAIS JURIDICAS, TITULOS E DOCUMENTOS E OFICIO DE REGISTRO DE IMOVEIS DE NAVEGANTES', 108514, 4211306, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7484, 12789, 'TABELIONATO DE NOTAS E PROTESTOS', 109314, 4211306, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7485, 5402, 'TABELIONATO DE NOTAS E REGISTRO CIVIL', 105759, 4211405, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7486, 5403, 'ITABERABA CARTORIO DE PAZ', 107342, 4211454, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7487, 5406, 'ESCRIVANIA DE PAZ DO DISTRITO DE AGUTI', 144386, 4211504, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7488, 5405, 'ESCRIVANIA DE PAZ DE CLARAIBA', 106187, 4211504, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7489, 5404, 'ESCRIVANIA DE PAZ DE NOVA TRENTO REGISTRO CIVIL E NOTAS', 105585, 4211504, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7490, 1879, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50740, 3124005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7491, 11939, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48629, 3124005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7492, 11940, 'TABELIONATO DO 2º OFICIO DE NOTAS ', 61234, 3124104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7493, 1880, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56168, 3124104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7494, 11941, 'OFICIO DO REGISTRO DE IMOVEIS DE ESMERALDAS', 45534, 3124104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7495, 11942, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 57505, 3124104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7496, 11943, 'CARTORIO DO PRIMEIRO OFICIO DE NOTAS DE ESMERALDAS', 41913, 3124104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7497, 1881, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE MELO VIANA', 44164, 3124104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7498, 11944, 'TABELIONATO DE PROTESTOS DE ESMERALDAS', 60830, 3124104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7499, 6638, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ANDIROBA', 54874, 3124104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7500, 1882, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 44347, 3124203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7501, 11945, 'CARTORIO DO 2º OFICIO DE NOTAS', 41459, 3124203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7502, 11946, 'CARTORIO DO PRIMEIRO OFICIO DE NOTAS', 41830, 3124203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7503, 11947, 'CARTORIO DE REGISTRO DE IMOVEIS', 38869, 3124203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7504, 11948, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE ESPERA FELIZ', 60483, 3124203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7505, 11949, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39628, 3124203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7506, 1883, 'CARTORIO DE REGISTRO CIVIL E TABELHONATO DE SAO JOSE DA PEDRA MENINA', 37739, 3124203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7507, 11950, 'TABELIONADO DO 1º OFICIO DE NOTAS', 59964, 3124302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7508, 11951, 'CARTORIO DO REGISTRO DE IMOVEIS DE ESPINOSA', 43513, 3124302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7509, 1942, 'CARTORIO DO REGISTRO CIVIL E NOTAS - ITAMIRIM', 42929, 3124302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7510, 11952, 'TABELIONATO DO SEGUNDO OFICIO DE NOTAS DE ESPINOSA MG', 61283, 3124302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7511, 11953, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39487, 3124302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7512, 1943, 'ESPINOSA CARTORIO DE REGISTRO CIVIL, INTERDICOES E TUTELAS', 45542, 3124302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7513, 11954, 'TABELIONATO DE PROTESTOS DE TITULOS DE DIVIDAS', 60947, 3124302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7514, 11955, '2º TABELIONATO DE NOTAS E PROTESTOS  DE TITULOS E DOCUMENTOS', 104596, 4213609, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7515, 7135, 'POUSO REDONDO TABELIONATO DE NOTAS', 108035, 4213708, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7516, 5429, 'ESCRIVANIA DE PAZ', 106005, 4213807, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7517, 5430, 'PRESIDENTE CASTELLO BRANCO - CARTORIO DE PAZ', 108043, 4213906, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7518, 11956, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 150144, 4214003, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7519, 5432, 'ESCRIVANIA DE PAZ DE MIRADOR', 106351, 4214003, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7520, 5431, 'OFICIO DE REGISTRO DAS PESSOAS NATURAIS, DAS PESSOAS JURIDICAS, TITULOS E DOCUMENTOS E REGISTRO DE IMOVEIS', 107557, 4214003, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7521, 4786, 'ESCRIVANIA DE PAZ DE PRESIDENTE NEREU', 106450, 4214102, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7522, 4787, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE PRINCESA', 107011, 4214151, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7523, 11957, 'OFICIO DE REGISTRO DE IMOVEIS QUILOMBO', 107730, 4214201, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7524, 7176, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS JURIDICAS, TITULOS E DOCUMENTOS DA COMARCA DE QUILOMBO-SC', 107763, 4214201, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7525, 11958, 'TABELIONATO QUILOMBO', 109561, 4214201, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7526, 7136, 'CARTORIO DE RANCHO QUEIMADO', 105098, 4214300, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7527, 5433, 'ESCRIVANIA DE PAZ DE RIO DAS ANTAS - SC', 106468, 4214409, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7528, 11959, 'TABELIONATO DE NOTAS E PROTESTO', 109298, 4214508, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7529, 5434, 'OFICIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS E REGISTRO DE IMOVEIS', 107540, 4214508, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7530, 5435, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE RIO DO OESTE', 108613, 4214607, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7531, 11960, 'REGISTRO DE IMOVEIS E HIPOTECAS', 108522, 4214805, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7532, 11961, '2º OFICIO DO PUBLICO JUDICIAL E NOTAS', 104471, 4214805, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7533, 11962, '3º TABELIONATO DE NOTAS E PROTESTOS', 104679, 4214805, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7534, 11963, 'RIO DO SUL - 1º TABELIONATO DE NOTAS', 108621, 4214805, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7535, 5436, 'CARTORIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS, PESSOAS JURIDICAS ', 105262, 4214805, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7536, 7137, 'ESCRIVANIA DE PAZ DE RIO DOS CEDROS', 106476, 4214706, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7537, 5437, 'ESCRIVANIA DE PAZ DE CEDRO ALTO', 106161, 4214706, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7538, 11964, 'CARTORIO DE PAZ', 104968, 4214904, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7539, 11965, 'RIO NEGRINHO REGISTRO DE IMOVEIS', 108647, 4215000, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7540, 6256, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE EUGENIO DE MELO- MUNICIPIO E COMARCA DE SAO JOSE DOS CAMPOS', 123125, 3549904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7541, 6259, 'REGISTRO CIVIL DA PESSOAS NATURAIS E TABELIAO DE NOTAS DE SAO LOURENCO DA SERRA', 122648, 3549953, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7542, 12171, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 125724, 3550001, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7543, 12172, 'SERVICO DE REGISTRO DE IMOVEIS E ANEXOS', 124370, 3550001, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7544, 6260, 'OFICIAL DE REGISTROS CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE SAO LUIZ DO PARAITINGA', 121186, 3550001, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7545, 6261, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DE SAO MANUEL ', 182, 3550100, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7546, 12173, '1º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 112029, 3550100, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7547, 12174, '2º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 112961, 3550100, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7548, 12175, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 120667, 3550100, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7549, 6262, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DO DISTRITO DE APARECIDA DE SAO MANUEL DA COMARCA DE SAO MANUEL', 118943, 3550100, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7550, 6263, 'SERVICO REGISTRAL CIVIL DAS PESSOAS NATURAIS, DE INTERDICOES E TUTELAS, SERVICO NOTARIAL E DE PROTESTO DE TITULOS E DOCUMENTOS', 114694, 3550209, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7551, 12176, '28. TABELIAO DE NOTAS DA CAPITAL', 112367, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7552, 6272, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO 30º SUBDISTRITO - IBIRAPUERA', 117838, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7553, 12177, '4º REGISTRO DE IMOVEIS DE SAO PAULO', 113498, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7554, 6281, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS - 15º SUBDISTRITO - BOM RETIRO, DA COMARCA DA CAPITAL ¿ SP', 111245, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7555, 6289, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 14º SUBDISTRITO - LAPA', 115170, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7556, 6277, '41º SUBDISTRITO DE SAO PAULO - CANGAIBA', 113449, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7557, 12178, '10º OFICIAL DE REGISTRO DE TITULOS E CIVIL DAS PESSOAS JURIDICAS', 111146, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7558, 12179, '10º TABELIAO DE PROTESTO DE LETRAS E TITULOS DE SAO PAULO-SP', 111161, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7559, 12180, '1º TABELIAO DE PROTESTO DE LETRAS E TITULOS DE SAO PAULO', 112169, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7560, 12181, '7° TABELIAO DE NOTAS DA CAPITAL', 113704, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7561, 12182, '20º TABELIAO DE NOTAS DA CAPITAL', 112284, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7562, 12183, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125492, 3547700, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7563, 6221, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE SANTO ANASTACIO', 116319, 3547700, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7564, 12184, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E TABELIAO DE PROTESTOS DE LETRAS E TITULOS', 121053, 3547700, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7565, 12185, '4º TABELIAO DE NOTAS DE SANTO ANDRE', 113530, 3547809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7566, 12186, 'TABELIAO DE PROTESTO DE LETRAS E TITULOS DE SANTO ANDRE', 126201, 3547809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7567, 6222, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º SUBDISTRITO DA SEDE DA COMARCA DE SANTO ANDRE - UTINGA', 115253, 3547809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7568, 12187, '2º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE SANTO ANDRE', 112573, 3547809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7569, 12188, '1 OFICIAL DE REGISTRO DE IMOVEIS E ANEXOS DE SANTO ANDRE - SP', 111005, 3547809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7570, 6224, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO 1º SUBDISTRITO DA SEDE', 116467, 3547809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7571, 6223, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE PARANAPIACABA, DA COMARCA DE SANTO ANDRE', 122820, 3547809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7572, 12189, '6º TABELIAO DE NOTAS', 113662, 3547809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7573, 12190, '5º TABELIAO DE NOTAS DE SANTO ANDRE', 113597, 3547809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7574, 12191, 'TERCEIRO TABELIAO DE NOTAS DE SANTO ANDRE', 126318, 3547809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7575, 12192, 'PRIMEIRO TABELIAO DE NOTAS DE SANTO ANDRE', 122358, 3547809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7576, 12193, 'SEGUNDO TABELIAO DE NOTAS DE SANTO ANDRE', 123901, 3547809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7577, 5565, 'OFICIO REGISTRO CIVIL TITULOS E DOCUMENTOS E PESSOA JURIDICA DE VIDEIRA', 107946, 4219309, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7578, 5564, 'ESCRIV. DE PAZ DO DISTR. DE RIO DAS PEDRAS (ANTIGA LOURDES)', 105031, 4219309, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7579, 12504, 'VIDEIRA CARTORIO REGISTRO DE IMOVEIS', 109694, 4219309, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7580, 5566, 'VITOR MEIRELES ESCRIVAO DE PAZ', 109702, 4219358, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7581, 5567, 'WITMARSUM CARTORIO DE PAZ', 109710, 4219408, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7582, 12505, '2º TABELIONATO DE NOTAS E PROTESTOS DE TITULOS', 104620, 4219507, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7583, 12506, '1º TABELIONATO DE NOTAS E PROTESTO DE TITULOS DE XANXERE', 104356, 4219507, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7584, 5568, 'CARTORIO DO REGISTRO CIVIL TITULOS E DOCUMENTOS', 105486, 4219507, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7585, 12507, 'OFICIO DE REGISTRO DE IMOVEIS', 107581, 4219507, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7586, 7145, 'ESCRIVANIA DE PAZ DE XAVANTINA', 108175, 4219606, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7587, 12508, 'TABELIONATO DE NOTAS E PROTESTOS DE TITULOS DE XAXIM-SC', 109454, 4219705, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7588, 5569, 'XAXIM OFICIO DO REGISTRO CIVIL', 109728, 4219705, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7589, 12509, 'OFICIO DE REGISTRO DE IMOVEIS DE XAXIM-SC', 107649, 4219705, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7590, 12510, 'CARTORIO  1º OFICIO', 109918, 2800209, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7591, 5571, 'CARTORIO MOISES MACHADO (2º OFICIO)', 110767, 2800209, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7592, 5577, 'CARTORIO DO 4º OFICIO DA COMARCA DE ARACAJU', 110478, 2800308, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7593, 12511, 'ARACAJU CARTORIO DO 3º OFICIO', 109892, 2800308, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7594, 5575, 'CARTORIO LEONIA GAMA DE OLIVEIRA - 6º OFICIO DE ARACAJU/SE', 110742, 2800308, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7595, 5572, 'CARTORIO DO REGISTRO CIVIL DO 14º OFICIO', 110635, 2800308, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7596, 7146, 'CARTORIO DO 15º OFICIO', 110072, 2800308, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7597, 12512, 'CARTORIO 10º OFICIO - ARACAJU', 109934, 2800308, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7598, 5573, '13º OFICIO', 109736, 2800308, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7599, 5578, 'ARACAJU CARTORIO 2º OFICIO NOTAS', 109884, 2800308, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7600, 12513, 'CARTORIO DO 5º OFICIO DA COMARCA DE ARACAJU', 109876, 2800308, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7601, 12514, 'CARTORIO DO 1º OFICIO DE ARACAJU', 110197, 2800308, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7602, 5579, 'CARTORIO DO 12º OFICIO', 110064, 2800308, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7603, 12515, 'CARTORIO DO 11° OFICIO DA COMARCA DE ARACAJU', 110056, 2800308, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7604, 5574, 'CARTORIO DO 8º OFICIO DE NOTAS E REGISTRO CIVIL DE PESSOAS NATURAIS DA COMARCA DE ARACAJU', 110494, 2800308, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7605, 5576, 'CARTORIO DO 7º OFICIO DE NOTAS', 110486, 2800308, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7606, 12516, 'CARTORIO DO 1º OFICIO', 110148, 2800407, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7607, 5580, 'CARTORIO DO 2º OFICIO DA COMARCA DE ARAUA/SE', 109785, 2800407, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7608, 12837, 'TABELIONATO DE NOTAS', 109025, 4213203, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7609, 12838, 'OFICIO DE REGISTRO DE IMOVEIS', 107573, 4213203, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7610, 5423, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS DA COMARCA DE POMERODE', 108340, 4213203, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7611, 5512, 'ESCRIVANIA DE PAZ', 106013, 4213302, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7612, 5424, 'ESCRIVANIA DE PAZ DE PONTE ALTA DO NORTE', 107177, 4213351, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7613, 12839, 'TABELIONATO CORREIA', 108993, 4213401, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7614, 12840, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS', 105437, 4213401, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7615, 5425, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS, JURIDICAS, TITULOS E DOCUMENTOS.', 105114, 4213401, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7616, 12841, 'TABELIONATO DE NOTAS E PROTESTOS DE PORTO BELO', 109256, 4213500, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7617, 5426, 'OFICIO DE REGISTRO DE IMOVEIS E CIVIL DA COMARCA DE PORTO BELO-SC', 107656, 4213500, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7618, 5427, 'ESCRIVANIA DE PAZ DO DISTRITO DE SANTA CRUZ DO TIMBO - PORTO UNIAO/SC', 106740, 4213609, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7619, 12842, '1. º TABELIONATO DE NOTAS E PROTESTOS', 104158, 4213609, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7620, 5428, 'REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 108316, 4213609, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7621, 12843, 'REGISTRO DE IMOVEIS DA COMARCA DE PORTO UNIAO - SC', 108027, 4213609, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7622, 4874, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ARAMINA', 118331, 3503000, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7623, 4875, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ARANDU', 118349, 3503109, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7624, 4876, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE ARAPEI', 123141, 3503158, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7625, 4877, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO 1º SUBDISTRITO DA SEDE', 116483, 3503208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7626, 12844, '2º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA COMARCA DE ARARAQUARA', 112565, 3503208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7627, 12845, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 112771, 3503208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7628, 5592, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE BUENO DE ANDRADA, DA COMARCA DE ARARAQUARA', 119388, 3503208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7629, 4878, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º SUBDISTRITO DA SEDE DA COMARCA DE ARARAQUARA', 121228, 3503208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7630, 12009, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 124537, 3535606, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7631, 6478, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116970, 3535705, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7632, 6479, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE PARANAPANEMA', 124578, 3535804, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7633, 6480, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS', 119370, 3535903, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7634, 6481, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE PARAPUA', 123232, 3536000, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7635, 6482, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 123208, 3536109, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7636, 6483, 'PARIQUERA-ACU CARTORIO DE NOTAS E OFICIO DE JUSTICA', 122275, 3536208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7637, 6152, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117465, 3536257, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7638, 12010, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA ', 120436, 3536307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7639, 12011, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 125047, 3536307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7640, 6206, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTEDICOES E TUTELAS DA SEDE DA COMARCA DE PATROCINIO PAULISTA-SP', 121350, 3536307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7641, 6207, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 123166, 3536406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7642, 6208, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE PAULINIA, COMARCA DE CAMPINAS - SP', 117721, 3536505, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7643, 6209, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE PAULISTANIA', 117192, 3536570, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7644, 12012, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124768, 3536604, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7645, 12013, 'CARTORIO DE REGISTRO DE IMOVEIS COM ANEXOS DE SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E SERVICO DE REGISTRO CIVIL DE PESSOAS JURIDICAS', 114389, 3536604, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7646, 6210, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E INTERDICOES E TUTELA DA SEDE', 113993, 3536604, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7647, 12014, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 120717, 3536703, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7648, 12015, 'TABELIONATO DE NOTAS E DE PROTESTO DE PEDERNEIRAS', 126078, 3536703, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7649, 6211, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE PEDERNEIRAS-SP', 116202, 3536703, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7650, 6212, 'SERVICO REGISTRAL E NOTARIAL (ANEXO) DAS PESSOAS NATURAIS DO MUNICIPIO DE PEDRA BELA, COMARCA DE BRAGANCA PAULISTA, ESTADO DE SAO PAULO', 124552, 3536802, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7651, 2659, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTA CRUZ DO ESCALVADO', 52902, 3157401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7652, 6153, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE SANTA ISABEL DO MARINHEIRO, DA COMARCA DE FERNANDOPOLIS', 118828, 3536901, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7653, 6213, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DO MUNICIPIO DE PEDRANOPOLIS, COMARCA DE FERNANDOPOLIS, ESTADO DE SAO PAULO.', 119511, 3536901, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7654, 6154, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 121400, 3537008, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7655, 12016, 'TABELIAO DE NOTAS E DE PROTESTOS', 125559, 3537008, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7656, 12017, 'SERVICO DE REGISTRO DE IMOVEIS , TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 124362, 3537008, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7657, 12018, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 120881, 3537107, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7658, 12019, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE BARUERI', 120576, 3505708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7659, 5621, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE JARDIM SILVEIRA', 118059, 3505708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7660, 5620, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE ALDEIA, COMARCA DE BARUERI, ESTADO DE SAO PAULO', 117861, 3505708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7661, 5623, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115840, 3505708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7662, 12020, '1º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE BARUERI', 112094, 3505708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7663, 6299, 'OFICIAL DE REGISTRO CIVIL DE PESSOAS NATURAIS DO DISTRITO DE CAPAO REDONDO', 119115, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7664, 12264, '9º OFICIAL DE REGISTRO DE IMOVEIS DE SAO PAULO - SP', 113779, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7665, 12265, '9º TABELIAO DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE SAO PAULO', 113795, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7666, 12266, '5º TABELIONATO DE NOTAS DE SAO PAULO', 113639, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7667, 6287, 'REGISTRO CIVIL DO 23º SUBDISTRITO CASA VERDE', 123364, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7668, 12267, '4O TABELIONATO DE NOTAS DA CAPITAL', 113456, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7669, 12268, '8º TABELIAO DE PROTESTO DE LETRAS E TITULOS DA CAPITAL ¿ SAO PAULO', 122242, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7670, 6280, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 16º SUBDISTRITO - MOOCA DA COMARCA DA CAPITAL ', 115188, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7671, 12269, '26 TABELIONATO DE NOTAS DE SAO PAULO', 112342, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7672, 6297, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO 35 SUBDISTRITO BARRA FUNDA', 121319, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7673, 6273, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 11º SUBDISTRITO DE SANTA CECILIA', 115147, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7674, 12270, 'CARTORIO DO 1º TABELIAO DE NOTAS - SP', 114470, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7675, 7166, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 5º SUBDISTRITO SANTA EFIGENIA-SP', 115337, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7676, 12271, '10º TABELIAO DE NOTAS DA CAPITAL', 111153, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7677, 7197, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO PRIMEIRO SUBDISTRITO SE-SP', 121160, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7678, 12272, '30º TABELIAO DE NOTAS', 113217, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7679, 6311, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE SAO MIGUEL PAULISTA - SAO PAULO - SP', 118190, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7680, 12273, '14º TABELIONATO DE NOTAS', 111229, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7681, 6318, '37º REGISTRO CIVIL DAS PESSOAS NATURAIS SUBDISTRITO ACLIMACAO', 113225, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7682, 12274, '6º OFICIAL DE REGISTRO DE IMOVEIS DA CAPITAL ¿ SAO PAULO', 142935, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7683, 6278, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS - 24º SUBDISTRITO INDIANOPOLIS', 115030, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7684, 12275, '22 TABELIAO DE NOTAS DA CAPITAL', 112300, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7685, 12276, '5º TABELIAO DE PROTESTO DE LETRAS E TITULOS', 113613, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7686, 6269, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXO DE NOTAS DO 22º SUBDISTRITO - TUCURUVI, SAO PAULO - SP', 115410, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7687, 6283, 'OFICIAL REG CIV PESS NAT 9º SUBDIS VL MARIANA', 122044, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7688, 12277, 'CARTORIO DO OITAVO TABELIAO DE NOTAS DE SAO PAULO', 114512, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7689, 12278, '8º OFICIAL DE REGISTRO DE IMOVEIS', 113746, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7690, 6268, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 47º SUBDISTRTITO DA CAPITAL DE SAO PAULO VILA GUILHERME', 122127, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7691, 6264, '39º OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA CAPITAL - SUBDISTRITO DA VILA MADALENA', 113241, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7692, 12279, '29ª TABELIA DE NOTAS DE SAO PAULO', 112383, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7693, 12280, '14º OFICIAL DE REGISTRO DE IMOVEIS', 111211, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7694, 12281, '4º TABELIAO DE PROTESTO DE LETRAS E TITULOS DE SAO PAULO', 113548, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7695, 12282, 'SEXTO TABELIAO DE NOTAS DE SAO PAULO - SP', 124628, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7696, 12283, '19º TABELIONATO DE NOTAS - TABELIAO FALLEIROS', 111344, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7697, 12284, '27º TABELIONATO DE NOTAS DA CAPITAL', 112359, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7698, 6286, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS 36º SUBDISTRITO VILA MARIA', 115063, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7699, 12285, '25º TABELIAO DE NOTAS', 112334, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7700, 6279, '18º REGISTRO CIVIL IPIRANGA', 111310, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7701, 12286, '5 REGISTRO DE IMOVEIS DE SAO PAULO', 113571, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7702, 12287, 'SETIMO OFICIAL DE REGISTRO DE IMOVEIS', 124594, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7703, 6314, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXO DE TABELIONATO DE NOTAS DO DISTRITO DE ERMELINO MATARAZZO', 115428, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7704, 6304, 'OFICIAL DE REGISTRO CIVIL DAS PN -7º SUBDISTRITO', 119099, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7705, 12288, '3º TABELIAO DE NOTAS DE SAO PAULO', 113340, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7706, 12587, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS ', 124719, 3511409, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7707, 5863, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOAS JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE CERQUILHO', 143115, 3511508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7708, 12588, 'TABELIONATO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE CERQUILHO', 126037, 3511508, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7709, 5864, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE CESARIO LANGE', 118414, 3511607, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7710, 5865, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117093, 3511706, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7711, 5866, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE CHAVANTES', 142232, 3557204, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7712, 5963, 'CARTORIO DE REGISTRO CIVIL E ANEXOS', 114058, 3557204, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7713, 5962, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE CHAVANTES', 122192, 3557204, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7714, 6688, 'OFICIAL REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 122051, 3511904, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7715, 5867, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DEPESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE COLINA', 145888, 3512001, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7716, 12589, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS (REGISTRO CIVIL)', 125187, 3512001, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7717, 5964, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE COLOMBIA, COMARCA DE BARRETOS, ESTADO DE SAO PAULO', 121731, 3512100, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7718, 12590, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS ', 117267, 3512209, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7719, 5868, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE CONCHAS', 116012, 3512308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7720, 12591, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS DE CONCHAS', 120808, 3512308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7721, 5869, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE JUQUIRATIBA', 118075, 3512308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7722, 12592, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE CONCHAS', 125351, 3512308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7723, 12593, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DA COMARCA DE CORDEIROPOLIS/SP', 125948, 3512407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7724, 5870, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE CORDEIROPOLIS', 147918, 3512407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7725, 5965, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE COROADOS', 117614, 3512506, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7726, 5966, 'OFICIAL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS ', 114835, 3512605, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7727, 5896, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE CORUMBATAI', 117622, 3512704, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7728, 6125, 'TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS', 125633, 3512803, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7729, 5803, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE LIMEIRA, ESTADO DE SAO PAULO', 116137, 3526902, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7730, 12594, '1º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E 1º TABELIAO DE PROTESTO DE LETRAS E TITULOS', 111583, 3526902, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7731, 12595, '2° TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 112417, 3526902, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7732, 6144, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS ', 119248, 3527009, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7733, 5804, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE LINS', 119131, 3527108, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7734, 12596, 'SEGUNDO TABELIAO DE NOTAS E DE PROTESTO DE TITULOS DE LINS-SP', 124024, 3527108, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7735, 12597, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DA COMARCA DE LINS-SP', 119925, 3527108, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7736, 12598, 'PRIMEIRO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS ', 122382, 3527108, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7737, 12846, 'TERCEIRO TABELIAO DE NOTAS E DE PROTESTOS DE TITULOS E DOCUMENTOS DE ARARAQUARA', 114645, 3503208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7738, 12847, '1. OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIIDICA ', 111096, 3503208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7739, 12848, '1º TABELIAO DE NOTAS E DE PROTESTO', 111625, 3503208, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7740, 12849, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE ARARAS', 120550, 3503307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7741, 12850, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 111849, 3503307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7742, 5593, 'ARARAS CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXOS ', 113803, 3503307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7743, 12851, '2 TABELIAO DE NOTAS E PROTESTOS DE ARARAS', 112268, 3503307, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7744, 5594, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE ARCO IRIS', 117580, 3503356, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7745, 5596, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE JACUBA, DA COMARCA DE BAURU', 124230, 3503406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7746, 5595, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117499, 3503406, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7747, 5597, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE AREIAS', 123067, 3503505, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7748, 5598, 'OFICIAL DE REGISTRO CIVILL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 121962, 3503604, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7749, 7185, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116715, 3503703, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7750, 5599, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ARTUR NOGUEIRA-SP', 118356, 3503802, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7751, 5600, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE ARUJA', 117598, 3503901, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7752, 5601, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 121624, 3503950, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7753, 5602, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE ASSIS-SP', 115956, 3504008, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7754, 12852, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE ASSIS', 111641, 3504008, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7755, 12853, '2º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE ASSIS', 113027, 3504008, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7756, 12854, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 120766, 3504008, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7757, 12855, '1º TABELIAO DE NOTAS E PROTESTOS DE LETRAS E TITULOS', 112128, 3504107, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7758, 12856, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA COMARCA DE ATIBAIA', 120485, 3504107, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7759, 12857, '2º TABELIONATO DE NOTAS E DE PROTESTO DE ATIBAIA', 113118, 3504107, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7760, 5603, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS ', 122903, 3504107, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7761, 6077, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS DO MUNICIPIO DE GUARACI', 119487, 3517901, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7762, 6078, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 121566, 3518008, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7763, 6079, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE GUARANTA-SP', 124164, 3518107, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7764, 12858, 'TABELIAO DE NOTAS E PROTESTO DE TITULOS', 125864, 3518206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7765, 12859, 'REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 123646, 3518206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7766, 6080, 'OFICIAL DE REGISTRO DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE GUARARAPES - SP', 119586, 3518206, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7767, 5999, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117275, 3518305, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7768, 6082, 'UNIDADE DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 126367, 3518404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7769, 6000, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 1º SUBDISTRITO DA SEDE DE GUARATINGUETA-SP', 124115, 3518404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7770, 12860, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120360, 3518404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7771, 12861, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 111724, 3518404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7772, 12862, '2º TABELIAO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS', 112920, 3518404, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7773, 6083, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS', 119339, 3518503, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7774, 5624, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 121533, 3505807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7775, 12021, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125302, 3505906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7776, 2728, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DA SEDE DA COMARCA DE SANTA BARBARA', 36400, 3157203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7777, 10975, 'CARTORIO DO 1º OFICIO DE NOTAS DE SANTA BARBARA-MG', 32102, 3157203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7778, 2980, 'SERVICO REGISTRAL DE PESSOAS NATURAIS', 59493, 3157203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7779, 3089, 'SANTA BARBARA DO LESTE CARTORIO DE REGISTRO CIVIL E NOTAS ', 57844, 3157252, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7780, 3090, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE SAO SEBASTIAO DO BARREADO', 43273, 3157278, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7781, 7336, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTA BARBARA DO MONTE VERDE', 56788, 3157278, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7782, 2729, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE BOM RETIRO', 35899, 3157302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7783, 3091, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55996, 3157302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7784, 2983, 'CARTORIO SANTA CRUZ DE MINAS - REGISTRO CIVIL E TABELIONATO DE NOTAS', 53363, 3157336, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7785, 2984, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 34496, 3157377, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7786, 7032, 'CARTORIO DO REGISTRO DE NOTAS DE SAO SEBASTIAO DO SOBERBO', 43562, 3157401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7787, 12547, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124834, 3526704, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7788, 2658, 'OFICIO DOREGISTRO CIVIL E TABELIONATO DE NOTAS DE ZITO SOARES', 54734, 3157401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7789, 2660, 'CARTORIO OLIVEIRA COELHO & MORAIS', 33431, 3157500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7790, 3092, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 46565, 3157609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7791, 3093, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE SANTA HELENA DE MINAS', 54601, 3157658, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7792, 3094, 'CARTORIO DE PAZ E NOTAS DE ZELANDIA', 34413, 3157708, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7793, 2661, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 43240, 3157708, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7794, 3095, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE SANTA LUZIA - MG', 47159, 3157807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7795, 10976, 'CARTORIO PHILADELPHIA- REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 56598, 3157807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7796, 10977, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48223, 3157807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7797, 10978, 'TABELIONATO DO 2 OFICIO DE NOTAS-STA LUZIA/MG', 61150, 3157807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7798, 2662, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE SAO BENEDITO, COMARCA DE SANTA LUZIA', 56309, 3157807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7799, 10979, 'TABELIONATO DE PROTESTO DA COMARCA DE SANTA LUZIA', 60137, 3157807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7800, 10980, 'SERVICO REGISTRAL DE IMOVEIS ', 59345, 3157807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7801, 2514, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52746, 3157906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7802, 11323, 'CARTORIO DO 1º OFICIO DE NOTAS', 40493, 3116605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7803, 11324, 'CARTORIO DE REGISTRO DE IMOVEIS', 38901, 3116605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7804, 11325, 'CARTORIO DE REG. DE TITULOS E DOCUMENTOS E REG. CIVIL DAS PESSOAS JURIDICAS DA COMARCA DE CLAUDIO/MG', 35162, 3116605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7805, 11326, 'CARTORIO DO SEGUNDO OFICIO DE NOTAS', 43778, 3116605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7806, 6950, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA COMARCA DE CLAUDIO-MG', 56341, 3116605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7807, 2051, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 56440, 3116704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7808, 11327, 'OFICIO DO REGISTRO CIVIL E TABELIONATO', 51359, 3116803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7809, 11328, 'CARTORIO DE PAZ E ANEXO', 34140, 3116902, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7810, 2053, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL', 42846, 3117009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7811, 2052, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51722, 3117009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7812, 2054, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CONCEICAO DA APARECIDA', 43570, 3117108, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7813, 1912, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36699, 3115201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7814, 11329, 'CONCEICAO DAS ALAGOAS CARTORIO 1º OFICIO NOTAS', 45369, 3117306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7815, 2055, 'OFIICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 55012, 3117306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7816, 11330, 'OFICIO DE REGISTRO DE IMOVEIS', 47316, 3117306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7817, 11331, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49460, 3117306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7818, 6639, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52787, 3127602, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7819, 11332, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 39883, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7820, 11333, '2º TABELIONATO DE NOTAS DE GOVERNADOR VALADARES/MG', 58115, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7821, 2932, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE CHONIN', 37358, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7822, 11334, 'CARTORIO REGISTRO DE IMOVEIS - 1º OFICIO', 44990, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7823, 2927, 'CARTORIO DE NOTAS E REGISTRO CIVIL DE SAO JOSE DE TRONQUEIRAS', 34116, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7824, 11335, 'OFICIO DO 2º REGISTRO DE IMOVEIS DE GOVERNADOR VALADARES DA COMARCA DE GOVERNADOR VALADARES', 32631, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7825, 11336, 'TABELIONATO DE PROTESTOS DE GOVERNADOR VALADARES', 60848, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7826, 11337, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48108, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7827, 2928, 'OFICIO DO 2º REGISTRO CIVIL DAS PESSOAS NATURAIS', 41749, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7828, 2933, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO VITOR', 45161, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7829, 11338, 'CARTORIO DO 3º OFICIO DE NOTAS', 41657, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7830, 6962, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE BREJAUBINHA', 44040, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7831, 2926, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PENHA DO CASSIANO', 42143, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7832, 2931, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO 3º SUBDISTRITO', 59279, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7833, 2925, 'CARTORIO DE REGISTRO CIVIL E NOTAS ALTAIR PORTELA', 37283, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7834, 2930, 'OFICIO DO 1º REGISTRO CIVIL DAS PESSOAS NATURAIS', 47878, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7835, 2929, 'BAGUARI CARTORIO DE PAZ E NOTAS', 33084, 3127701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7836, 11339, 'OFICIO DO 1º TABELIONATO DE PROTESTOS', 48926, 3127800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7837, 11340, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL  DAS PESSOAS JURIDICAS', 54239, 3127800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7838, 11341, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48157, 3127800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7839, 11342, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49510, 3127800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7840, 11343, 'OFICIO DO REGISTRO DE IMOVEIS', 54049, 3127800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7841, 2935, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 51102, 3127800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7842, 2934, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE BARROCAO', 42952, 3127800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7843, 2936, 'CARTORIO DE PAZ E NOTAS E REGISTRO CIVIL', 34454, 3127909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7844, 11344, 'CARTORIO DO PRIMEIRO OFICIO DE NOTAS', 41889, 3128006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7845, 2937, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35675, 3128006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7846, 11345, 'CARTORIO REGISTRO DE IMOVEIS', 45575, 3128006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7847, 11346, 'CARTORIO DE PROTESTOS J. ANDRADE', 35105, 3128006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7848, 11347, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DE PESSOAS JURIDICAS', 40022, 3128006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7849, 2939, 'CARTORIO DE PAZ E NOTAS DE CORRENTINHO', 34363, 3128006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7850, 6963, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55897, 3128006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7851, 10324, 'CARTORIO REGISTRAL, NOTARIAL,TIT. E DOC. E PROTESTOS ', 71746, 2501906, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7852, 3815, 'CARTORIO DISTRITAL DE RUA NOVA', 70359, 2501906, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7853, 7067, 'CARTORIO DO REGISTRO CIVIL DE BELEM', 70805, 2501906, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7854, 3816, 'CARTORIO ANDRADE', 69211, 2502003, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7855, 3817, 'CARTORIO DE REGISTRO CIVIL', 69690, 2502052, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7856, 3818, 'CARTORIO REGISTRO CIVIL E NOTAS', 71779, 2502102, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7857, 3819, 'BOA VISTA CARTORIO DE REGISTRO CIVIL', 69013, 2502151, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7858, 3820, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 69971, 2502201, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7859, 3821, 'CARTORIO GONCALVES', 71514, 2502300, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7860, 3822, 'CARTORIO DISTRITAL DO DISTRITO DE SERRINHA', 70375, 2502300, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7861, 7014, 'CARTORIO DO REGISTRO CIVIL ', 69047, 2502409, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7862, 10325, '1º TABELIONATO E REGISTRO DE IMOVELS', 68759, 2517001, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7863, 10326, '2 CARTORIO EXTRAJUDICIAL DE NOTAS, PROTESTOS', 68767, 2517001, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7864, 4001, 'CARTORIO DO REGISTRO CIVIL DE UMBUZEIRO', 71019, 2517001, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7865, 10327, 'CARTORIO DE DISTRIBUICAO EXTRAJUDICIAL', 69500, 2517001, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7866, 6662, 'MATA VIRGEM CARTORIO DO REGISTRO CIVIL', 72322, 2517001, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7867, 4002, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 70888, 2517100, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7868, 5798, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE MARISTELA, MUNICIPIO E COMARCA DE LARANJAL PAULISTA, ESTADO DE SAO PAULO', 121699, 3526407, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7869, 6143, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE LAVINIA, DA COMARCA DE MIRANDOPOLIS', 117069, 3526506, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7870, 5800, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE LAVRINHAS', 118562, 3526605, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7871, 12546, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 120352, 3526704, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7872, 5801, 'OFICIAL DE REGISTRO CIVIL E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE LEME DO ESTADO DE SAO PAULO', 119206, 3526704, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7873, 12548, 'SERVICO DE REGISTRO DE IMOVEIS E ANEXOS DE LENCOIS PAULISTA - SP', 124404, 3526803, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7874, 12549, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 112755, 3526803, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7875, 12550, '1º TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS', 112060, 3526803, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7876, 5802, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE LENCOIS PAULISTA', 122986, 3526803, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7877, 12551, '2º REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, REG. CIVIL DE PESSOAS JURIDICAS E 2º TABELIONATO DE PROTESTO DE LETRAS E TITULOS', 112672, 3526902, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7878, 12552, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 111765, 3526902, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7879, 5355, 'ESCRIVANIA DE PAZ DE FREI ROGERIO', 106260, 4205555, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7880, 5356, 'ESCRIVANIA DE PAZ', 105908, 4205605, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7881, 12553, 'TABELIONATO DE NOTAS E PROTESTOS', 109280, 4205704, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7882, 5487, 'REGISTRO CIVIL, REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 108233, 4205704, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7883, 12554, '1° TABELIONATO DE NOTAS E PROTESTOS DE GARUVA', 104190, 4205803, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7884, 5357, 'CARTORIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS, PESSOAS JURIDICAS E REGISTRO DE IMOVEIS', 105270, 4205803, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7885, 12555, 'OFICIO DE REGISTRO DE IMOVEIS DA COMARCA DE GASPAR - SC', 104240, 4205902, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7886, 7102, 'OFICIO DO REGISTRO CIVIL, TITULOS DOCUMENTOS, PESSOAS JURIDICAS E OUTROS PAPEIS', 107805, 4205902, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7887, 12556, 'GASPAR TABELIONATO DE NOTAS', 107227, 4205902, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7888, 5358, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE GOVERNADOR CELSO RAMOS', 107094, 4206009, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7889, 5360, 'ESCRIVANIA DE PAZ DE AIURE', 106062, 4206108, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7890, 5359, 'ESCRIVANIA DE PAZ DE INVERNADA', 106294, 4206108, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7891, 5361, 'ESCRIVANIA DE PAZ ', 105932, 4206108, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7892, 5362, 'CARTORIO GRAVATAL', 106898, 4206207, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7893, 5488, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE GUABIRUBA', 143164, 4206306, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7894, 5489, 'ESCRIVANIA DE PAZ DE GUARACIABA', 107235, 4206405, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7895, 5490, 'OFICIO DE REGISTRO CIVIL DE PESSOAS NATURAIS, DE INTERDICOES E TUTELAS, DAS PESSOAS JURIDICAS, TITULOS E DOCUMENTOS, DA COMARCA DE GUARAMIRIM', 107490, 4206504, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7896, 12557, 'OFICIO DO REGISTRO DE IMOVEIS DA COMARCA DE GUARAMIRIM-SC', 107623, 4206504, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7897, 12558, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 109439, 4206504, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7898, 7103, 'ESCRIVANIA DE PAZ', 105890, 4206603, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7899, 5363, 'ESCRIVANIA DE PAZ DE GUATAMBU', 107243, 4206652, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7900, 12559, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 150417, 4206702, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7901, 6701, 'REG IMOVEIS, REGISTRO CIVIL DAS PESSOAS NATURAIS, REG TITULOS E DOCUMENTOS, REG CIVIL PESSOAS JURIDICAS', 150136, 4206702, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7902, 5364, 'ESCRIVANIA DE PAZ IBIAM', 107128, 4206751, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7903, 12560, 'ESCRIVANIA DE PAZ DE IBICARE', 106278, 4206801, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7904, 12561, '2° TABELIONATO DE NOTAS E PROTESTOS DE TITULOS DA COMARCA DE IBIRAMA/SC', 104430, 4206900, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7905, 12562, '1º TABELIONATO DE NOTAS E PROTESTOS DE IBIRAMA', 104323, 4206900, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7906, 5365, 'ESCRIVANIA DE PAZ DE DALBERGIA', 106211, 4206900, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7907, 5366, 'IBIRAMA-OFICIO DO REGISTRO CIVIL', 107268, 4206900, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7908, 12563, 'IBIRAMA OFICIO DO REGISTRO DE IMOVEIS ', 107250, 4206900, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7909, 12564, 'TABELIONATO DE NOTAS E PROTESTOS', 109033, 4207007, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7910, 6073, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS DE GUAPIARA', 119404, 3517604, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7911, 6074, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE GUARA', 143321, 3517703, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7912, 6075, 'TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS - GUARA(SP)', 125849, 3517703, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7913, 6076, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DE GUARACAI-SP', 117663, 3517802, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7914, 5755, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO E MUNICIPIO DE MONTEIRO LOBATO, COMARCA DE SAO JOSE DOS CAMPOS, ESTADO DE SAO PAULO', 118265, 3531704, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7915, 5756, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE MORRO AGUDO', 146308, 3531902, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7916, 12822, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125120, 3531902, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7917, 5757, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 118885, 3532009, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7918, 6689, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE MOTUCA', 123224, 3532058, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7919, 5810, 'REGISTRO CIVIL E TABELIONATO DE NOTAS DE MURUTINGA DO SUL, COMARCA DE ANDRADINA-SP', 114231, 3532108, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7920, 5811, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE NANTES - SP', 118612, 3532157, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7921, 5812, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE NARANDIBA', 118620, 3532207, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7922, 5814, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE NATIVIDADE DA SERRA, COMARCA DE PARAIBUNA/SP', 119123, 3532306, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7923, 5815, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE NAZARE PAULISTA', 121764, 3532405, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7924, 6027, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXOS', 122846, 3532504, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7925, 6029, 'UNIDADE DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXO DO DISTRITO DE MIRALUZ MUNICIPIO DE NEVES PAULISTA COMARCA DE MIRASSOL - SP', 126383, 3532504, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7926, 6028, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE BARRA DOURADA, DA COMARCA DE MIRASSOL', 113928, 3532504, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7927, 12823, 'OFICIAL DO REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE NHANDEARA', 121996, 3532603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7928, 6030, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 113977, 3532603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7929, 12824, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXOS DO DISTRITO DE IDA IOLANDA', 142265, 3532603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7930, 12825, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125435, 3532603, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7931, 6031, 'OFICIAL DE REGISTRO CIVIL E NOTAS DE NIPOA-SP', 119230, 3532702, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7932, 6032, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116855, 3532801, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7933, 6033, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 114066, 3532827, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7934, 6034, 'OFICIAL DE REGISTRO CIVIL E ANEXO', 119156, 3532843, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7935, 6035, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 116566, 3532868, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7936, 6036, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE NOVA EUROPA-SP', 118638, 3532900, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7937, 6040, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DE NOVA GRANADA - SP', 121459, 3533007, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7938, 12826, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125666, 3533007, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7939, 12827, 'REGISTRO DE IMOVEIS', 123554, 3533007, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7940, 6041, 'OFICIAL DO REGISTRO CIVIL E TABELIAO DE NOTAS', 121889, 3533106, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7941, 6042, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116830, 3533205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7942, 6043, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 123448, 3533304, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7943, 12828, 'REGISTRO DE IMOVEIS CARTORIO TOURINHO', 105536, 4211900, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7944, 6015, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DO MUNICIPIO DE ILHABELA', 114660, 3520400, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7945, 11991, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE NOVA ODESSA-SP', 125252, 3533403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7946, 6045, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116988, 3533254, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8012, 6240, 'OFICIAL DE REGISTRO CIVIL E DE INTERDICOES E TUTELAS 1º SUBDISTRITO SAO CARLOS -SP', 119180, 3548906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7947, 11992, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA E 1º TABELIAO DE PROTESTO DE LETRAS E TITULOS', 120683, 3533502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7948, 6046, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 126359, 3533502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7949, 6047, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117473, 3533502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7950, 11993, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 125039, 3533502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7951, 11994, 'TABELIAO DE NOTAS E PROTESTOS DE LETRAS E TITULOS DE NUPORANGA', 125898, 3533601, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7952, 6048, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE NUPORANGA/SP', 122879, 3533601, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7953, 11995, 'OFICIAL REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS CIVIL DE PESSOAS JURIDICAS E TABELIA DE PROTESTOS DE LETRA E TITULOS', 122093, 3533601, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7954, 6049, 'OFICIAL DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 121574, 3533700, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7955, 6050, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DO MUNICIPIO DE OLEO', 124339, 3533809, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7956, 11996, 'SEGUNDO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE OLIMPIA-SP.', 124008, 3533908, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7957, 6052, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E INTERDICOES E TUTELAS SEDE', 116558, 3533908, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7958, 11997, 'OFICIAL DE REGISTRO DE IMOVEIS TITULOS E DOCUMENTOS CIVIL DE PESSOA JURIDICA E TABELIAO DE PROTESTOS DE LETRAS E TITULOS ', 119727, 3533908, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7959, 6053, 'OFICIAL DE REG.CIVIL PESSOAS NAT.E TABELIAO NOTAS DISTR.DE RIB.DOS SANTOS', 114884, 3533908, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7960, 11998, '1º. TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 112219, 3533908, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7961, 6054, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE ONDA VERDE/SP', 116780, 3534005, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7962, 6055, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 117341, 3534104, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7963, 6056, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 114314, 3534203, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7964, 6057, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE ORLANDIA/SP', 116178, 3534302, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7965, 11999, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 124875, 3534302, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7966, 12000, 'OFICIAL REGISTRO IMOVEIS, TITULOS DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 122101, 3534302, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7967, 12001, '4° TABELIONATO DE NOTAS DE OSASCO', 113472, 3534401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7968, 12002, '1O. TABELIAO DE NOTAS DE OSASCO', 111351, 3534401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7969, 12003, '1º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE OSASCO', 111526, 3534401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7970, 12004, 'CARTORIO DO SEGUNDO TABELIAO DE OSASCO', 114629, 3534401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7971, 12005, 'TABELIAO DE PROTESTO DE LETRAS E TITULOS DE OSASCO', 125989, 3534401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7972, 6058, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º SUBDISTRITO DA SEDE DA COMARCA DE OSASCO', 115238, 3534401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7973, 12006, '3º TABELIAO DE NOTAS DE OSASCO', 113324, 3534401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7974, 6059, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E E INTERDICOES E TUTELAS ', 115022, 3534401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7975, 12007, 'SEGUNDO OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE OSASCO', 123810, 3534401, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7976, 6060, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE OSCAR BRESSANE', 117333, 3534500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7977, 6477, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMCARCA DE PARAIBUNA-SP', 123315, 3535606, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7978, 12008, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE PARAIBUNA', 126177, 3535606, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7979, 6276, 'SERVICO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DO DISTRITO DE GUAIANASES, COMARCA DA CAPITAL DE SAO PAULO', 124321, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7980, 6265, 'OFICIAL DE RCPN E TABELIAO DE NOTAS DO 31º SUBDISTRITO - PIRITUBA', 122580, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7981, 6274, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS 29 SUBDISTRITO - SANTO AMARO', 117549, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7982, 12240, 'QUARTO TABELIAO DE NOTAS DE SANTOS - SP', 122556, 3548500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7983, 12241, '6º TABELIAO DE NOTAS DE SANTOS', 113670, 3548500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7984, 12242, '1º CARTORIO DE NOTAS DE SANTOS', 111401, 3548500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7985, 12243, '1º OFICIAL DE REGISTRO DE IMOVEIS DE SANTOS', 111443, 3548500, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7986, 6234, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE ', 122143, 3548609, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7987, 12244, 'TABELIONATO DE NOTAS E DE PROTESTOS DE LETRAS E TITULOS ', 126086, 3548609, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7988, 12245, 'REGISTRO DE IMOVEIS,TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA', 123703, 3548609, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7989, 6235, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º SUBDISTRITO DA SEDE DE SAO BERNARDO DO CAMPO', 115279, 3548708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7990, 12246, '2.º TABELIAO DE PROTESTO DE LETRAS E TITTULOS DE SAO BERNARDO DO CAMPO', 124057, 3548708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7991, 6236, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE RIACHO GRANDE', 118166, 3548708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7992, 12247, 'PRIMEIRO TABELIAO DE NOTAS DE SAO BERNARDO DO CAMPO', 122366, 3548708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7993, 12248, '1º TABELIAO DE PROTESTO DE LETRAS E TITULOS', 112136, 3548708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7994, 12249, '2º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE SAO BERNARDO DO CAMPO', 112524, 3548708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7995, 12250, '2º TABELIAO DE NOTAS', 112680, 3548708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7996, 6237, '1º OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICÖES E TUTELAS', 111419, 3548708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7997, 12251, 'PRIMEIRO OFICIAL DE REGISTRO DE IMOVEIS TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE SAO BERNARDO DO CAMPO', 122317, 3548708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7998, 12252, 'QUARTO TABELIAO DE NOTAS DE SAO BERNARDO DO CAMPO', 122564, 3548708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (7999, 12253, '3 TABELIAO DE NOTAS DA COMARCA DE SAO BERNARDO DO CAMPO-SP', 113175, 3548708, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8000, 12254, '1º OFICIAL DE REGISTRO DE IMOVEIS E ANEXOS', 111476, 3548807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8001, 12255, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE SAO CAETANO DO SUL', 112805, 3548807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8002, 12256, '4 TABELIAO DE NOTAS E PROTESTO DE LETRAS E TITULOS DE SAO CAETANO DO SUL', 113415, 3548807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8003, 6238, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE SAO CAETANO DO SUL', 116327, 3548807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8004, 12257, '2º REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DA COMARCA DE SAO CAETANO DO SUL', 112664, 3548807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8005, 12258, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE SAO CAETANO DO SUL', 111948, 3548807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8006, 12259, '3º TABELIAO DE NOTAS E DE PROTESTO DE SAO CAETANO DO SUL', 113365, 3548807, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8007, 6242, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO DISTRITO DE SANTA EUDOXIA, DA COMARCA DE SAO CARLOS', 114926, 3548906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8008, 12260, '2º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DA COMARCA DE SAO CARLOS - SP', 112813, 3548906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8009, 2679, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 42770, 3160108, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8010, 6241, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º SUBDISTRITO DE SAO CARLOS - SP', 122762, 3548906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8011, 12261, 'CARTORIO DE REGISTRO DE IMOVEIS E ANEXOS SAO CARLOS ', 114413, 3548906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8013, 6239, 'OFICIAL DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE AGUA VERMELHA - SP', 119529, 3548906, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8014, 6295, 'REGISTRO CIVIL DE PESSOAS NATURAIS - 48º SUBDISTRITO - VILA NOVA CACHOEIRINHA', 123356, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8015, 12262, '24º TABELIAO DE NOTAS DA CAPITAL', 112326, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8016, 12263, '17º TABELIAO DE NOTAS DA CAPITAL', 111302, 3550308, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8017, 5367, 'OFICIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS', 107516, 4207007, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8018, 12565, 'OFICIO DO REGISTRO DE IMOVEIS', 108084, 4207007, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8019, 5491, 'ESCRIVANIA DE PAZ DE ILHOTA', 106286, 4207106, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8020, 12566, 'CARTORIO DE REGISTRO DE IMOVEIS DE IMARUI', 105395, 4207205, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8021, 12567, 'TABELIONATO DE NOTAS E PROTESTOS DA COMARCA DE IMARUI', 109363, 4207205, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8022, 5368, 'OFICIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 107938, 4207205, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8023, 5582, 'CARTORIO DO SEGUNDO OFICIO DE BARRA DOS COQUEIROS', 110676, 2800605, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8024, 12568, 'SERVENTIA METHAS/1º SERVENTIA DE NOTAS E PROTESTOS DA COMARCA DE BARRA DOS COQUEIROS/SE', 110759, 2800605, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8025, 7147, '2º OFICIO TABELIONATO DE NOTAS, REGISTRO CIVIL E REGISTRO DE TITULOS E DOCUMENTOS', 109850, 2800670, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8026, 12569, 'BOQUIM CARTORIO 1º OFICIO', 109900, 2800670, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8027, 5583, 'CARTORIO OFICIO UNICO DE BREJO GRANDE', 110775, 2800704, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8028, 5584, 'CARTORIO DO REGISTRO CIVIL DO 2º OFICIO', 110643, 2801009, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8029, 12570, 'CARTORIO DO 1º OFICIO DE NOTAS E PROTESTO', 110247, 2801009, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8030, 12571, 'OFICIO UNICO DISTRITO DE CANHOBA', 110874, 2801108, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8031, 5585, 'CARTORIO DO 2º OFICIO DA COMARCA DE CANINDE DE SAO FRANCISCO - ESTADO DE SERGIPE', 110395, 2801207, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8032, 12572, 'CARTORIO DO 1° OFICIO DE CANINDE DE SAO FRANCISCO', 110106, 2801207, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8033, 5586, '2º OFICIO DE CAPELA', 109827, 2801306, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8034, 12573, 'CARTORIO DO 1º OFICIO', 110130, 2801306, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8035, 5587, 'CARTORIO DO SEGUNDO OFICIO DE CARIRA - SE', 110684, 2801405, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8036, 12574, 'CARTORIO 1º OFICIO', 109942, 2801405, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8037, 12575, 'CARTORIO DO 1º OFICIO DE CARMOPOLIS/SE', 110205, 2801504, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8038, 5588, 'CARTORIO DO SEGUNDO OFICIO DA COMARCA DE CARMOPOLIS', 110668, 2801504, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8039, 5589, 'CARTORIO DO 2º OFICIO DA COMARCA DE CEDRO DE SAO JOAO/SE.', 110403, 2801603, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8040, 12576, 'CARTORIO 1 OFICIO JOSE SOARES', 109926, 2801603, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8041, 12577, 'CRISTINAPOLIS CARTORIO DO 1º OFICIO', 110817, 2801702, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8042, 5590, 'CARTORIO DO 2º OFICIO DE CRISTINAPOLIS-SE', 110429, 2801702, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8043, 5591, 'CARTORIO DO OFICIO UNICO DO DISTRITO DE CUMBE', 110585, 2801900, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8044, 5875, 'CARTORIO DO OFICIO UNICO DE DIVINA PASTORA', 110536, 2802007, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8045, 5876, 'CARTORIO DO 2º OFICIO DA COMARCA DE ESTANCIA', 110411, 2802106, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8046, 12578, 'CARTORIO DO 1º OFICIO DA COMARCA DE ESTANCIA', 110163, 2802106, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8047, 5877, 'CARTORIO DO OFICIO UNICO DO DISTRITO DE FEIRA NOVA', 130757, 2802205, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8048, 12579, '1º OFICIO DE NOTAS E PROTESTO DE TITULOS DA COMARCA DE FREI PAULO/SE', 109744, 2802304, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8049, 5878, 'CARTORIO 2º OFICIO', 109975, 2802304, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8050, 12580, 'CARTORIO DO 1º OFICIO', 110122, 2802403, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8051, 5879, 'CARTORIO DO 2º OFICIO', 110361, 2802403, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8052, 5880, 'CARTORIO DE OFICIO UNICO DE GENERAL MAYNARD  ', 110437, 2802502, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8053, 5881, 'CARTORIO DO UNICO OFICIO DE GRACCHO CARDOSO', 110726, 2802601, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8054, 7148, 'CARTORIO DO UNICO OFICIO', 110718, 2802700, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8055, 12581, 'CARTORIO DO OFICIO UNICO DO DISTRITO DE INDIAROBA', 110544, 2802809, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8056, 12582, 'CARTORIO DO 2º OFICIO DE NOTAS', 110445, 2802908, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8057, 12583, 'CARTORIO DO 1º OFICIO DE REGISTRO DE IMOVEIS', 110270, 2802908, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8058, 5882, 'CARTORIO DO REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOA JURIDICA PROTESTOS DE TITULOS', 110650, 2802908, 'SE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8059, 12584, 'SEGUNDO OFICIAL DO REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS, REGISTRO CIVIL DE PESSOAS JURIDICA E TABELIONATO DE PROTESTOS', 123844, 3511102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8060, 12585, 'SEGUNDO TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 123943, 3511102, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8061, 5861, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS', 114215, 3511201, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8062, 5961, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116897, 3511300, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8063, 12586, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS EDOCUMENTOS E CIVIL DE PESSOA JURIDICA ', 121095, 3511409, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8064, 5862, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115816, 3511409, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8065, 6044, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE NOVA ODESSA', 145862, 3533403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8066, 12829, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 109165, 4211900, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8067, 5413, 'ESCRIVANIA DE PAZ (TABELIONATO E REGISTRO CIVIL)', 106021, 4212007, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8068, 7133, 'ESCRIVANIA DE PAZ PALMEIRA', 107144, 4212056, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8069, 5414, 'CARTORIO TREBIEN', 105213, 4212106, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8070, 12830, 'TABELIONATO DE NOTAS E PROTESTOS EM GERAL', 109462, 4212106, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8071, 12831, 'CARTORIO REGISTRO DE IMOVEIS ', 105692, 4212106, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8072, 12832, 'TABELIONATO DE NOTAS E OFICIO DE PROTESTOS', 109058, 4212205, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8073, 12833, 'CARTORIO JUNG', 105528, 4212205, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8074, 12834, 'CARTORIO PRA ', 105635, 4212205, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8075, 5415, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE PARAISO', 107003, 4212239, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8076, 5416, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO LUMMERTZ', 105189, 4212254, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8077, 5417, 'PASSOS MAIA TABELIONATO DE NOTAS', 107987, 4212270, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8078, 7105, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE PAULO LOPES', 106419, 4212304, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8079, 5418, 'ESCRIVANIA DE PAZ DE PEDRAS GRANDES', 106427, 4212403, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8080, 4785, 'ESCRIVANIA DE PAZ', 105858, 4212502, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8081, 5419, 'PERITIBA CARTORIO DE PAZ', 107995, 4212601, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8082, 5420, 'ESCRIVANIA DE PAZ DE PETROLANDIA', 106435, 4212700, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8083, 5510, 'CARTORIO REGISTRO CIVIL, TITULOS, DOCUMENTOS E PESSOA JURIDICA', 105676, 4212908, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8084, 12835, 'OFICIO DE REGISTRO DE IMOVEIS DE PINHALZINHO', 107631, 4212908, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8085, 12836, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS DE PINHALZINHO/SC', 108001, 4212908, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8086, 5511, 'CARTORIO DE PAZ REGISTRO CIVIL E TABELIONATO', 105064, 4213005, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8087, 5422, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE PIRATUBA-SC', 108019, 4213104, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8088, 7134, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE PLANALTO ALEGRE/SC', 106443, 4213153, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8089, 2676, 'CARTORIO DE REGISTRO CIVIL COM ATRIBUICAO NOTARIAL', 35352, 3159100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8090, 2677, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO SEBASTIAO DA ESTRELA', 46441, 3159902, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8091, 6980, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTO ANTONIO DO AMPARO', 51565, 3159902, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8092, 3115, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTO ANTONIO DO AVENTUREIRO', 50294, 3160009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8093, 2678, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO DOMINGOS', 570, 3160009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8251, 10691, 'PAZ E NOTAS', 149849, 5100359, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8094, 2680, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52431, 3160207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8095, 2682, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53181, 3160306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8096, 2681, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTO ANTONIO DO JACINTO', 52332, 3160306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8097, 11004, 'CARTORIO DE REGISTRO DE IMOVEIS', 38679, 3160405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8098, 11005, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54262, 3160405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8099, 11006, 'CARTORIO DO 1º OFICIO DE NOTAS', 40709, 3160405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8100, 2683, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50757, 3160405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8101, 11007, 'CARTORIO DO 2º OFICIO DE NOTAS', 41442, 3160405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8102, 11008, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS.', 48900, 3160405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8103, 2684, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56101, 3160454, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8104, 2685, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 38034, 3160504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8105, 2686, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTO HIPOLITO', 59790, 3160603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8106, 7033, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SENHORA DA GLORIA', 52654, 3160603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8107, 2689, 'SERVICO REGISTRAL DE PESSOAS NATURAIS', 59485, 3160702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8108, 2987, 'CRCPN - 2O. SUBDISTRITO', 45435, 3160702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8109, 2525, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO JOAO DA SERRA', 35543, 3160702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8110, 11009, 'TABELIONATO DE PROTESTO DE TITULOS E DOCUMENTOS DE SANTOS DUMONT', 60723, 3160702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8111, 11010, 'TABELIONATO DO 1º OFICIO DE NOTAS', 61119, 3160702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8112, 11011, 'REGISTRO DE TITULOS E DOCUMENTOS E REG. CIVIL DAS PESSOAS JURIDICAS', 57653, 3160702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8113, 2687, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE DORES DO PARAIBUNA', 38455, 3160702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8114, 11012, '3O CARTORIO DE NOTAS', 32854, 3160702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8115, 11013, 'CARTORIO DO 2º OFICIO DE NOTAS', 41483, 3160702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8116, 2988, 'CARTORIO DE PAZ E REGISTRO CIVIL DO DISTRITO DE MANTIQUEIRA', 34561, 3160702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8117, 11014, 'SANTOS DUMONT CARTORIO DE REGISTRO DE IMOVEIS', 57885, 3160702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8118, 11015, 'OFICIO DO SEGUNDO TABELIONATO DE NOTAS', 54676, 3162906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8119, 2688, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CONCEICAO DO FORMOSO', 44842, 3160702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8120, 7034, 'CARTORIO DO REGISTRO CIVIL / TABELIONATO E NOTAS', 42069, 3160801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8121, 2526, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52894, 3160900, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8122, 3116, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SAO DOMINGOS DAS DORES-MG', 37523, 3160959, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8123, 2730, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTANA DO ALFIE', 34207, 3161007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8124, 11377, 'CARTORIO ESCRIVANIA E NOTAS DO FERRENTINO', 43869, 3146008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8125, 11378, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE OURO FINO', 39958, 3146008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8126, 2850, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35600, 3146008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8127, 11379, 'OURO FINO CARTORIO ESCRIVANIA E NOTAS - CARTORIO VILLAS BOAS', 55053, 3146008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8128, 11380, 'TABELIONATO DE PROTESTO DE TITULOS E DOCUMENTOS', 60673, 3146008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8129, 2859, 'CARTORIO DO 1º. OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE OURO PRETO,MG', 41046, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8130, 2853, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35782, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8131, 7450, 'OFICIO DO REGISTRO CIVIL DE ANTONIO PEREIRA - MG', 31880, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8132, 2856, 'OFICIO 2º REGISTRO CIVIL PESSOAS NATURAIS', 46367, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8133, 11381, 'REGISTRO DE IMOVEIS DE OURO PRETO/MG', 57273, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8134, 11382, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 257, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8135, 2851, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53298, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8136, 11383, 'SERVENTIA NOTARIAL 2º OFICIO OURO PRETO', 58321, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8137, 2855, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO', 34678, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8138, 2857, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE GLAURA', 37960, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8139, 11384, 'CARTORIO DO 1 OFICIO DE NOTAS DE OURO PRETO', 40378, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8140, 2854, 'CARTORIO OLIVEIRA PATROCINIO -  REGISTRO CIVIL E TABELIONATO DE NOTAS', 37515, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8141, 2784, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE AMARANTINA', 38075, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8142, 11385, 'TABELIONATO DE PROTESTO DE LETRAS E TITULOS', 60160, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8143, 7021, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CACHOEIRA DO CAMPO', 51771, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8144, 2858, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36723, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8145, 2852, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS DE SANTA RITA DE OURO PRETO', 36467, 3146107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8146, 2860, 'OURO VERDE DE MINAS CARTORIO DE REGISTRO CIVIL E NOTAS', 55061, 3146206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8147, 2861, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PADRE CARVALHO', 33894, 3146255, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8148, 7074, 'OFICIO DO REGISTRO CIVIL E NOTAS DE PAI PEDRO', 51276, 3146552, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8149, 2862, 'OFICIO  DO REGISTRO CIVIL E NOTAS', 46326, 3146404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8150, 11386, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 47704, 3117306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8151, 11387, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39511, 3117306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8152, 2056, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42309, 3117306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8153, 2057, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS, DE INTERDICOES, TUTELAS E TABELIONATO DE NOTAS', 42564, 3117207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8154, 7436, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51706, 3117405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8155, 11388, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49726, 3117504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8156, 2063, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE CORREGOS', 46839, 3117504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8157, 11389, 'TABELIONATO DE PROTESTO DE TITULOS E OUTROS DOCUMENTOS DA COMARCA DE CONCEICAO DO MATO DENTRO', 47837, 3117504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8158, 2060, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE COSTA SENA', 52233, 3117504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8159, 2061, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO SEBASTIAO DO BOM SUCESSO', 36640, 3117504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8160, 2059, 'CARTORIO REGISTRO CIVIL DE PESSOAS NATURAIS', 44495, 3117504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8161, 6951, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTO ANTONIO DO NORTE', 44552, 3117504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8162, 11390, 'OFICIO DO 1° TABELIONATO DE NOTAS', 47720, 3117504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8163, 11391, 'CONCEICAO DO MATO DENTRO CARTORIO DE REGISTRO DE IMOVEIS', 45377, 3117504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8164, 2058, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ITACOLOMI', 37937, 3117504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8165, 11392, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 46227, 3117504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8166, 11393, 'CARTORIO DE REGISTRO DE IMOVEIS', 38893, 3117702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8167, 10365, '1º SERVICO REGISTRAL DE IMOVEIS, TITULOS E DOCUMENTOS DA COMARCA DE SANTO ANTONIO DE LEVERGER-MT', 63552, 5107800, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8168, 3250, 'CARTORIO DO 2 OFICIO DE SANTO ANTONIO DE LEVERGER-MT', 64303, 5107800, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8169, 7056, 'CARTORIO DE PAZ E NOTAS DE MIMOSO', 63974, 5107800, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8170, 3252, 'CGJ/MT_1 CARTORIO DO 2º OFICIO DE REGISTRO CIVIL E TABELIONATO DA COMARCA DE SAO FELIX DO ARAGUAIA', 64782, 5107859, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8171, 10366, '1º TABELIONATO E REGISTRO DE IMOVEIS', 63578, 5107859, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8172, 3253, 'CGJ/MT_1 CARTORIO DE REGISTRO CIVIL', 64733, 5107297, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8173, 3254, 'CARTORIO DO 2º OFICIO', 64352, 5107305, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8174, 10367, '1º OFICIO DE REGISTRO DE IMOVEIS TITULOS E DOCUMENTOS', 63339, 5107305, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8175, 3255, 'CARTORIO DE 2 OFICIO DE SAO JOSE DO XINGU', 64915, 5107354, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8176, 10368, 'CARTORIO DE PRIMEIRO OFICIO - REGISTRO DE IMOVEIS TITULOS E DOCUMENTOS', 64006, 5107107, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8177, 3256, 'CARTORIO DE SEGUNDO OFICIO ', 64121, 5107107, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8178, 3257, 'SERVICO NOTARIA E REGISTRAL ', 65318, 5107404, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8179, 10369, 'CARTORIO DO 1º OFICIO', 64170, 5107875, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8180, 3258, 'CARTORIO DO 2º OFICIO', 64378, 5107875, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8181, 10370, 'SINOP CARTORIO DE REGISTRO DE IMOVEIS', 65524, 5107909, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8182, 7057, '2º OFICIO EXTRAJUDICIAL', 63651, 5107909, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8183, 10371, 'CARTORIO DO 1º OFICIO DE SORRISO - MT', 64279, 5107925, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8184, 3259, 'SEGUNDO OFICIO EXTRAJUDICIAL', 65110, 5107925, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8185, 3260, '2º. OFICIO EXTRAJUDICIAL DE TABAPORA - MT.', 65334, 5107941, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8186, 10372, 'CARTORIO DO 1º OFICIO DE TABAPORA', 64287, 5107941, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8187, 10373, 'RCPN - DISTRITO DE SAO JORGE - VANDERSON MARTINEZ DE SOUZA', 136945, 5107958, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8188, 2989, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DO DISTRITO DE PROGRESSO', 65326, 5107958, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8189, 10374, '1º SERVICO DE NOTAS E REGISTROS DE TANGARA DA SERRA MT', 63396, 5107958, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8190, 3261, 'CGJ/MT_1 2º SERVICO NOTARIAL E REGISTRO CIVIL', 64576, 5107958, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8191, 2990, 'CGJ/MT_1 CARTORIO DE REGISTRO CIVIL', 64741, 5107958, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8192, 10375, 'CARTORIO REGISTRAL E NOTARIAL DE BONITO DE SANTA FE', 109, 2502409, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8193, 10376, 'BONITO DE SANTA FE CARTORIO DE DISTRIBUICAO EXTRAJUDICIAL', 69021, 2502409, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8194, 10377, 'REGISTRO CIVIL SE PESSOAS NATURAIS DO DISTRITO DE MORORO', 145193, 2502508, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8195, 10378, 'BOQUEIRAO CARTORIO UNICO', 69039, 2502508, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8196, 3823, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS AMARO ANTONIO BARBOSA', 70904, 2502508, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8197, 10379, 'CARTORIO DE DISTRIBUICAO EXTRAJUDICIAL DE BOQUEIRAO', 154187, 2502508, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8198, 3824, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS E NOTAS ', 70912, 2502706, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8199, 10380, 'CARTORIO DO 2° TABELIONATO PUBLICO  EPROTESTO DE TITULOS E LETRAS.', 70490, 2502805, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8200, 3825, 'SERVICO REGISTRAL OLIVEIROS SOARES', 73296, 2502805, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8201, 10381, 'CARTORIO DE DISTRIBUICAO EXTRAJUDICIAL DE BREJO DO CRUZ', 154195, 2502805, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8202, 10382, 'CARTORIO RODRIGUES', 69138, 2502805, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8203, 3826, 'CARTORIO DO REGISTRO CIVIL', 70607, 2502904, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8204, 10383, 'CARTORIO EXTRAJUDICIAL DE CAAPORA', 129536, 2503001, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8205, 10384, 'SERVICO NOTARIAL E REGISTRAL 2 OFICIO DE NOTAS', 72983, 2503001, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8206, 3828, 'CARTORIO DO REGISTRO CIVIL', 70565, 2503001, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8207, 3827, 'CARTORIO DE REGISTRO CIVIL', 69674, 2503001, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8208, 10385, 'CARTORIO BEZERRA CAVALCANTI', 69252, 2503001, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8209, 10386, 'DISTRIBUICAO DA SERVENTIA EXTRAJUDICIAL', 145201, 2503100, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8210, 3829, '1º SERVICO REGISTRAL DE PESSOAS NATURAIS', 68734, 2503100, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8211, 10387, 'SERVICO NOTARIAL E REGISTRAL - CABACEIRAS-PB', 72959, 2503100, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8212, 10388, 'CARTORIO FIGUEIREDO DORNELAS', 72173, 2503209, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8213, 10389, 'SERVICO DE REG DE DIST EXTRA JUDICIAL DE CABEDELO', 72843, 2503209, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8214, 3830, 'APARECIDA DORNELAS SERVICO REGISTRAL', 68981, 2503209, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8215, 3831, 'CARTORIO DO REGISTRO CIVIL DE CACHOEIRA DOS INDIOS', 70813, 2503308, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8216, 3832, 'OFICIO DE REGISTRO CIVIL DE CACIMBA DE AREIA', 145250, 2503407, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8217, 10390, 'CARTORIO DE DISTRIBUICAO DE CACIMBA DE DENTRO', 154203, 2503506, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8218, 7068, 'SERVICO REGISTRAL E NOTARIAL GOMES DE SOUZA', 73247, 2503506, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8219, 4108, 'CARTORIO GUIOMAR DE MOURA ARRUDA', 76505, 2608107, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8220, 3140, '2º SERVICO NOTARIAL E DE REGISTRO CIVIL', 63214, 5007406, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8221, 10680, '1º SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 61689, 5007406, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8222, 3141, 'SERVICO NOTARIAL E DE REGISTROL CIVIL DE ROCHEDO', 61580, 5007505, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8223, 7005, 'SERVICO NOTARIAL E DE REGISTRO CIVL DE SANTA RITA DO PARDO', 61630, 5007554, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8224, 10681, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 63164, 5007695, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8225, 3143, 'SERVICO NOTARIAL E REGISTRO CIVIL', 63081, 5007695, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8226, 3142, 'SERVICO NOTARIAL E REGISTRO CIVIL ', 61705, 5007695, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8227, 3144, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 62943, 5007802, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8228, 10682, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 62273, 5007703, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8229, 3145, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 62182, 5007703, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8230, 10683, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL  DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 61648, 5007901, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8231, 3146, '1º OFICIO DE NOTAS E REGISTRO CIVIL DE PESSOAS NATURAIS', 61770, 5007901, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8232, 10684, 'SERVICO DE REGISTRO DE IMOVEIS, PROTESTOS DE TITULOS CAMBIAIS, REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO DAS PESSOAS JURIDICAS ', 154369, 5007935, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8233, 3147, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE SONORA ', 61606, 5007935, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8234, 7006, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE TACURU', 62190, 5007950, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8235, 3148, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE TAQUARUSSU', 62166, 5007976, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8236, 3149, 'SERVICO NOTARIAL, DE REGISTRO CIVIL DAS PESSOAS NATURAIS, DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTO E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 63024, 5008008, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8237, 10685, '3º SERVICO NOTARIAL E TABELIONATO DE PROTESTO', 61879, 5008305, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8238, 10686, '4º SERVICO NOTARIAL E REGISTRAL', 61895, 5008305, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8239, 3151, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE ARAPUA', 62067, 5008305, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8240, 3150, '2º SERVICO NOTARIAL E DE REGISTRO CIVIL', 62430, 5008305, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8241, 10687, 'SERVICO DE REGISTRO DE IMOVEIS', 62869, 5008305, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8242, 7007, 'SERVICO NOTARIAL  E DE REGISTRO CIVIL DE VICENTINA', 63040, 5008404, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8243, 3153, 'CARTORIO DE PAZ E NOTAS DE ENGENHO', 63966, 5100102, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8244, 3152, 'CARTORIO DE PAZ E NOTAS', 63933, 5100102, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8245, 3154, '2º SERVICO NOTARIAL E REGISTRAL DE AGUA BOA - MT', 63685, 5100201, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8246, 10688, '1º SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS', 63420, 5100201, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8247, 10689, 'CARTORIO DO 1º OFICIO DE ALTA FLORESTA', 63453, 5100250, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8248, 3155, 'CARTORIO DO 2º OFICIO ALTA FLORESTA', 63867, 5100250, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8249, 10690, 'CARTORIO DO 1º OFICIO', 64212, 5100300, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8250, 3156, 'CARTORIO DE TABELIONATO E REGISTRO CIVIL DAS PESSOAS NATURAIS', 64139, 5100300, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8252, 3157, 'SEGUNDO SERVICO NOTARIAL E REGISTRAL', 65185, 5100409, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8253, 10692, '1º OFICIO DE REGISTRO DE IMOVEIS E TITULOS E DOCUMENTOS ', 63321, 5100409, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8254, 3158, '2º SERVICO NOTARIAL E REGISTRAL', 63669, 5100508, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8255, 2548, 'CARTORIO BONANCA', 65839, 1503507, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8256, 2551, 'CARTORIO DO UNICO OFICIO REIS SOUZA', 67561, 1503507, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8257, 2550, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DO LIVRAMENTO DO ITABOCAL  - JUNIOR DE JESUS', 66134, 1503507, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8258, 2553, 'CARTORIO DO 2º OFICIO', 66779, 1503606, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8259, 2554, 'CARTORIO COELHO DE SOUZA', 65904, 1503705, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8260, 2555, 'CARTORIO DE REGISTRO CIVIL E NOTAS ', 66571, 1503754, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8261, 2556, 'CARTORIO DO UNICO OFICIO DE JACUNDA', 67215, 1503804, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8262, 2557, 'CARTORIO DO UNICO OFICIO H B CUNHA - COMARCA DE JURUTI', 67512, 1503903, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8263, 2558, 'CARTORIO DE REGISTRO CIVIL DE SALE - TERMO DE JURUTI', 66233, 1503903, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8264, 7065, 'CARTORIO DE REGISTRO CIVIL DO UNICO OFICIO DO RIO MARIA DOCE - LIMOEIRO DO AJURU', 66399, 1504000, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8265, 11016, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 57604, 3161007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8266, 11017, 'CARTORIO DE REGISTRO DE IMOVEIS', 38661, 3161007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8267, 11018, 'CARTORIO DO 2º OFICIO DE NOTAS', 41236, 3161007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8268, 11019, 'OFICIO DO PRIMEIRO TABELIONATO DE NOTAS', 50120, 3161007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8269, 2731, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CONEGO JOAO PIO', 34264, 3161007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8270, 3117, 'CARTORIO DE REGISTRO CIVIL  DAS PESSOAS NATURAIS', 35303, 3161007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8271, 2691, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52845, 3161007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8272, 3118, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ILHEUS DO PRATA', 34298, 3161007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8273, 11020, 'TABELIONATO DE PROTESTO DE TITULOS E DOCUMENTOS DE DIVIDA', 60640, 3161007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8274, 2690, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL DE VARGEM LINDA', 34173, 3161007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8275, 2732, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SAO FELIX DE MINAS', 37531, 3161056, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8276, 11021, 'CARTORIO DO 1º OFICIO DE NOTAS', 40477, 3161106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8277, 11022, 'TABELIONATO DE PROTESTO DE TITULOS DE SAO FRANCISCO', 60624, 3161106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8278, 2733, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE SANTA ISABEL DE MINAS ', 43034, 3161106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8279, 3472, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS INTERDICOES E TUTELAS DO DISTRITO DO MORRO', 36210, 3161106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8280, 11023, 'CARTORIO REGISTRO DE IMOVEIS DE SAO FRANCISCO', 45013, 3161106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8281, 11024, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS JURIDICAS, TITULOS E DOCUMENTOS', 35477, 3161106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8282, 3473, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DA CIDADE DE SAO FRANCISCO-MG', 42416, 3161106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8283, 11025, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49502, 3161106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8284, 3119, 'S FCO DE PAULA CART REG CIVIL NOTAS E TABELIONATO', 57810, 3161205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8285, 3474, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51490, 3161304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8286, 3120, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL', 42465, 3161403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8287, 3121, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SAO GERALDO', 37549, 3161502, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8288, 7344, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE MONTE CELESTE', 149427, 3161502, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8289, 2692, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 35980, 3161601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8290, 3475, 'SERVICO NOTARIAL E REGISTRAL', 59048, 3161650, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8291, 11026, 'CARTORIO DE REG. DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 35147, 3161700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8292, 3476, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 45245, 3161700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8293, 11027, 'CARTORIO DO 2º OFICIO DE NOTAS', 41301, 3161700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8294, 3477, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CANOEIROS', 46920, 3161700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8295, 11028, 'CARTORIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 41038, 3161700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8296, 11029, 'OFICIO DO REGISTRO DE IMOVEIS', 45237, 3161700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8297, 3478, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52274, 3161809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8298, 2693, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS ', 36020, 3161908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8299, 3479, 'CARTORIO DE PAZ E NOTAS DE SAO GONCALO DO RIO PRETO', 34397, 3125507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8300, 3480, 'SERVICO REGISTRAL PRIVATIVO CIVIL DAS PESSOAS NATURAIS', 59816, 3162005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8301, 11030, 'OFICIO DE REGISTRO DE IMOVEIS', 47233, 3162005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8302, 11031, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48082, 3162005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8303, 11032, '2º OFICIO DE NOTAS', 32490, 3162005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8304, 11033, 'REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 57612, 3162005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8305, 11034, 'TABELIONATO DE PROTESTOS DE TITULOS E DOCUMENTOS DE DIVIDA DE SAO GONCALO DO SAPUCAI-MG', 60988, 3162005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8306, 11035, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48348, 3162104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8307, 11036, 'OFICIO DO REGISTRO DE IMOVEIS DE SAO GOTARDO', 44974, 3162104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8308, 6981, 'CARTORIO REGISTRO CIVIL PESSOAS NATURAIS MUNICIPIO DE SAO GOTARDO', 44891, 3162104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8309, 2695, 'GUARDA DOS FERREIROS CARTORIO DE PAZ E NOTAS', 45591, 3162104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8310, 2062, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE BREJAUBA', 37101, 3117504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8311, 2064, 'CARTORIO DO OFICIO E NOTAS', 41756, 3117603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8312, 2065, 'OFICIO DO REG. CIVIL DAS PESSOAS NATURAIS', 50187, 3117702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8313, 11394, 'OFICIO DO 1º TABELIONATO DE NOTAS BOLIVAR TAMERIAO DE CONCEICAO DO RIO VERDE', 40626, 3117702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8314, 11395, 'CARTORIO DO 2 OFICIO DE NOTAS', 41053, 3117702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8315, 11396, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 46235, 3117702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8316, 6103, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE LUTECIA', 123216, 3527900, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8317, 6105, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE MACATUBA', 145672, 3528007, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8318, 6104, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS (REGISTRO CIVIL)', 125203, 3528007, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8319, 6106, 'SERVICO DO REGISTRO CIVIL E NOTAS', 124479, 3528106, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8320, 6107, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS DO MUNICIPIO DE MACEDONIA, COMARCA DE FERNANDOPOLIS, ESTADO DE SAO PAULO', 118976, 3528205, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8321, 6108, 'OFICIAL DE REGISTRO DIVIL DAS PESSOAS NATURAIS E ANEXO- NOTAS', 121152, 3528304, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8322, 12605, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE MAIRINQUE', 145573, 3528403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8323, 6109, 'REGISTRO CIVIL DAS PESSOAS NATURAIS, TABELIONATO DE NOTAS E PROTESTO DE TITULOS, LETRAS E DOCUMENTOS', 123349, 3528403, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8324, 7192, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 115600, 3528502, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8325, 4780, 'IMBITUBA CARTORIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS', 107284, 4207304, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8326, 5493, 'ESCRIVANIA DE PAZ DO DISTRITO DE VILA NOVA-716502', 106773, 4207304, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8327, 12606, 'TABELIONATO DE NOTAS E OFICIO DE PROTESTOS', 109090, 4207304, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8328, 12607, 'OFICIO DO REGISTRO DE IMOVEIS', 107672, 4207304, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8329, 7123, 'ESCRIVNIA DE PAZ DO DISTRITO DE MIRIM', 107201, 4207304, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8330, 5494, 'IMBUIA ESCRIVANIA DE PAZ', 107292, 4207403, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8331, 5495, 'OFICIO DE REGISTROS CIVIS DAS PESSOAS NATURAIS, E DE INTERDICOES E TUTELAS. OFICIO DE REGISTROS CIVIS DAS PESSOAS JURIDICAS E DE TITULOS E DOCUMENTOS', 107300, 4207502, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8332, 12608, '2º TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 104554, 4207502, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8333, 12609, 'CARTORIO DE REGISTRO DE IMOVEIS DA COMARCA DE INDAIAL', 105387, 4207502, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8334, 12610, '1º TABELIONATO DA COMARCA DE INDAIAL-SC', 104265, 4207502, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8335, 5369, 'ESCRIVANIA DA PAZ DE IOMERE', 105817, 4207577, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8336, 5496, 'ESCRIVANIA DE PAZ DO MUNICIPIO DE IPORA DO OESTE', 106906, 4207650, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8337, 4781, 'ESCRIVANIA DE PAZ DE IPUACU', 106302, 4207684, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8338, 12611, 'TABELIONATO DE NOTAS E PROTESTOS DE TITULOS', 150276, 4207700, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8339, 12864, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOA JURIDICA E TABELIAO DE PROTESTOS DE LETRAS E TITULOS', 121038, 3518602, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8340, 6084, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE', 122960, 3518602, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8341, 12865, '1º TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS', 111781, 3518701, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8342, 6085, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA SEDE DA COMARCA DE GUARUJA-SP', 116061, 3518701, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8343, 12866, 'OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA - TABELIONATO DE NOTAS - DE GUARUJA/SP ', 120469, 3518701, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8344, 7189, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 123190, 3518701, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8345, 12867, '1º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 111484, 3518800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8346, 12868, '1º TABELIAO DE PROTESTOS DE LETRAS E TITULOS DE GUARULHOS', 112177, 3518800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8347, 12869, '3º TABELIAO DE NOTAS DA COMARCA DE GUARULHOS - SP', 113316, 3518800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8348, 12870, '2º TABELIAO DE PROTESTO DE LETRAS E TITULOS DE GUARULHOS', 113100, 3518800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8349, 12871, 'GUARULHOS 2º CARTORIO DE NOTAS E OFICIO DE JUSTICA', 114736, 3518800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8350, 12872, 'PRIMEIRO CARTORIO DE NOTAS DE GUARULHOS', 122283, 3518800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8351, 7157, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º SUBDISTRITO DA SEDE DA COMARCA DE GUARULHOS', 115212, 3518800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8352, 12873, '2º OFICIAL DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOA JURIDICA DE GUARULHOS', 112540, 3518800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8353, 12874, '4º TABELIONATO DE NOTAS DA COMARCA DE GUARULHOS', 113555, 3518800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8354, 6086, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS  E DE INTERDICOES E TUTELAS DO 1º SUBDISTRITO DA SEDE DA COMARCA DE GUARULHOS     ', 122697, 3518800, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8355, 6001, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE NOTAS DE GUATAPARA', 119412, 3518859, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8356, 6002, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIAO DE NOTAS', 116749, 3518909, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8357, 12875, 'TABELIONATO DE NOTAS, ACUMULANDO PRECARIAMENTE O TABELIONATO DE PROTESTO DE TITULOS.', 87767, 4117602, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8358, 4353, 'SERVICO DISTRITAL PADRE PONCIANO', 130013, 4117602, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8359, 4355, 'SERVICO DISTRITAL DE FRANCISCO FREDERICO TEIXEIRA GUIMARAES', 129718, 4117602, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8360, 4356, 'SERVICO DISTRITAL DE PAPAGAIOS NOVOS', 82800, 4117701, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8361, 12876, 'SERVICO DE REGISTRO DE IMOVEIS', 85332, 4117701, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8362, 4357, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81422, 4117701, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8363, 12877, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, COM TABELIONATO DE PROTESTO DE TITULOS', 84335, 4117701, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8364, 12878, 'SERVICO DE REGISTRO DE IMOVEIS ', 82669, 4117800, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8365, 4358, 'SERVENTIA REGISTRAL DAS PESSOAS NATURAIS, REGISTRO DE TITULOS E DOCUMENTOS E DE PESSOAS JURIDICAS', 84905, 4117800, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8366, 12879, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE O TABELIONATO DE PROTESTO DE TITULOS', 88286, 4117800, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8367, 4359, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS ', 85951, 4117909, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8368, 12880, 'SERVICO DE REGISTRO DE IMOVEIS', 86041, 4117909, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8369, 12881, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 84343, 4117909, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8370, 12882, 'SERVICO DE REGISTRO DE IMOVEIS', 81984, 4118006, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8371, 12883, 'TABELIONATO DE NOTAS, ACUMULADO, PRECARIAMENTE O TABELIONATO DE PROTESTO DE TITULOS', 86470, 4118006, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8372, 4360, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 87171, 4118006, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8373, 12863, 'TABELIAO DE NOTAS E DE PROTESTO DE LETRAS E TITULOS DE GUARIBA', 125377, 3518602, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8374, 10636, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO DE TITULOS', 62026, 5005608, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8375, 10637, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 62281, 5005681, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8376, 10638, '1º SERVICO NOTARIAL E TABELIONATO DE PROTESTO', 62398, 5005707, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8377, 3128, '2º SERVICO NOTARIAL E DE REGISTRO CIVIL', 62521, 5005707, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8378, 10639, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E  CIVIL DAS PESSOAS JURIDICAS', 62240, 5005707, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8379, 3129, 'CARTORIO DE PAZ E TABELIONATO', 62083, 5005806, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8380, 10640, 'SERVICO DE REGISTROS DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS ETABELIONATO DE PROTESTO', 61663, 5005806, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8381, 7002, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 62786, 5006002, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8382, 10641, 'SERVICO DE REGISTRO DE IMOVEIS, DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO DE TITULOS', 153395, 5006002, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8383, 10642, '1º SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, PESSOAS JURIDICAS E DE PROTESTO DE TITULOS', 61671, 5006200, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8384, 3130, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE NOVA ANDRADINA- MS.', 62448, 5006200, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8385, 3131, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE NOVO HORIZONTE DO SUL', 63230, 5006259, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8386, 10643, '3º SERVICO NOTARIAL E TABELIONATO DE PROTESTO', 61846, 5006309, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8387, 3133, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE SAO JOAO DO APORE MS', 62224, 5006309, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8388, 10644, '1º SERVICO NOTARIAL E DE REGISTRO IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 62737, 5006309, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8389, 3132, '2º SERVICO NOTARIAL E DE REGISTRO CIVIL', 62158, 5006309, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8390, 7003, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE PARANHOS', 62844, 5006358, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8391, 10645, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 62976, 5006408, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8392, 3134, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 62554, 5006408, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8393, 10646, '3º SERVICO NOTARIAL E TABELIONATO DE PROTESTO', 63115, 5006606, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8394, 3136, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE SANGA PUITA', 62315, 5006606, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8395, 10647, '1º SERVICO NOTARIAL E REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 62745, 5006606, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8396, 3135, '2º SERVICO NOTARIAL E DE REGISTRO CIVIL', 61804, 5006606, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8397, 10648, '1º SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 63057, 5006903, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8398, 3137, '2º SERVICO NOTARIAL E DE REGISTRO CIVIL', 62091, 5006903, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8399, 10649, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 61622, 5007109, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8400, 7004, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 62117, 5007109, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8401, 10650, 'SERVICO DE REGISTRO DE IMOVEIS, DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS, E DE TABELIONATO DE PROTESTO', 62885, 5007208, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8402, 3138, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 62893, 5007208, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8403, 10651, 'SERVICO DE REGISTRO DE IMOVEIS, DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO DE RIO NEGRO/MS', 63131, 5007307, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8404, 3139, 'SERVICO NOTARIAL E DE REGISTRO CIVIL ', 63107, 5007307, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8405, 2630, 'CARTORIO DO UNICO OFICIO DE MOCAJATUBA ', 67710, 1502608, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8406, 2629, 'CARTORIO DO UNICO OFICIO DE COLARES', 66407, 1502608, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8407, 2631, 'SERVICO NOTARIAL E DE REGISTROS PUBLICOS DO UNICO OFICIO', 68494, 1502707, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8408, 2632, 'CARTORIO VALDETE DO CARMO', 68361, 1502756, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8409, 10652, 'CARTORIO DE CUMARU DO NORTE (SEDE)', 139766, 1502764, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8410, 2633, 'CARTORIO DO UNICO OFICIO DA COMARCA DE CURIONOPOLIS', 67082, 1502772, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8411, 2635, 'CARTORIO DE REGISTRO CIVIL DE PIRIA - CURRALINHO', 66225, 1502806, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8412, 2634, 'CARTORIO ANTONIO DANTAS', 65755, 1502806, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8413, 2637, 'CARTORIO DE REGISTRO CIVIL DE CURUA - OBIDOS', 66209, 1502855, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8414, 3087, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DE SACRAMENTO - MG', 59212, 3156908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8415, 10965, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54338, 3156908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8416, 7462, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE FERREIROPOLIS', 42333, 3157005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8417, 10966, 'CARTORIO DE REGISTRO DE IMOVEIS', 38760, 3157005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8418, 10967, 'CARTORIO DE REG. DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS.', 35154, 3157005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8419, 2657, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS, INTERDICOES E TUTELAS', 59105, 3157005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8420, 10968, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49551, 3157005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8421, 10969, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48272, 3157005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8422, 10970, 'TABELIONATO DE PROTESTO DE TITULOS E DOCUMENTOS DE DIVIDA DA COMARCA DE SALINAS', 60707, 3157005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8423, 7335, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SALTO DA DIVISA', 37168, 3157104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8424, 10971, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49437, 3157203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8425, 10972, 'SANTA BARBARA CARTORIO REGISTRO DE IMOVEIS', 57836, 3157203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8426, 3088, 'REGISTRO CIVIL DE PESSOAS NATURAIS DE BARRA FELIZ', 56622, 3157203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8427, 10973, 'TABELIONATO DE PROTESTOS DE TITULOS DA COMARCA DE SANTA BARBARA', 60939, 3157203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8428, 2982, 'SERVICO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE BRUMAL', 58438, 3157203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8429, 10974, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54478, 3157203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8430, 2981, 'SERVICO REGISTRAL DE PESSOAS NATURAIS DE CONCEICAO DO RIO ACIMA', 59501, 3157203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8431, 3941, 'CARTORIO DO REGISTRO CIVIL DE SANTA GERTRUDES', 70953, 2510808, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8432, 10699, 'CARTORIO CARLOS TRIGUEIRO', 69260, 2510808, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8433, 10700, 'PATOS CARTORIO 2º OFICIO', 72470, 2510808, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8434, 10701, 'SERVICO DE DISTRIBUICAO EXTRA JUDICIAL', 72769, 2510808, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8435, 3943, 'CEU PALMEIRA SERVICO REGISTRAL', 72041, 2510808, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8436, 3942, '2º CARTORIO REGISTO CIVIL JATOBA', 68817, 2510808, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8437, 3944, 'CARTORIO FRANCISCO MARTINS LOPES', 71498, 2510907, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8438, 10702, 'CARTORIO PE. SOLON DANTAS DE FRANCA', 71704, 2510907, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8439, 3945, 'SERVICO REGISTRAL E NOTARIAL HELENA TEOTONIO PRIMA', 73254, 2511004, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8440, 7350, 'CARTORIO DE RESGISTRO CIVIL E NOTAS DE PEDRA LAVRADA - PB INALDA CORDEIRO COSTA ', 70136, 2511103, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8441, 10703, 'CARTORIO VINAGRE DE MEDEIROS', 71969, 2511202, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8442, 3946, 'CARTORIO REGISTRO CIVIL DA COMARCA DE PEDRAS DE FOGO', 71761, 2511202, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8443, 10704, 'CARTORIO DE REGISTRO DA DISTRIBUICAO EXTRA JUDICIAL DE PEDRAS DE FOGO PB', 70060, 2511202, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8444, 3947, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 71209, 2512721, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8445, 10705, 'PIANCO CARTORIO 2º OFICIO NOTAS', 72496, 2511301, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8446, 11037, 'OFICIO DO 2º TABELIONATO DE NOTAS DE SAO GOTARDO', 49908, 3162104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8447, 3481, 'CARTORIO REGISTRO CIVIL E NOTAS', 44545, 3162104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8448, 11038, 'OF DO REG DE TITS DOCS E CIVIL DAS PESSOAS JUR', 46193, 3162104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8449, 11039, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE SAO GOTARDO', 60525, 3162104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8450, 2694, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO DE NOTAS DE FUNCHAL', 61531, 3162104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8451, 2696, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E ANEXO', 46557, 3162203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8452, 3482, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE SAO JOAO DA LAGOA/MG', 37564, 3162252, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8453, 3483, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 38059, 3162302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8454, 11040, '2º OFICIO DE NOTAS', 18, 3162401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8455, 3484, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CONDADO DO NORTE', 31906, 3162401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8456, 11041, 'OFICIO DE REGISTRO E TITULOS E DOCUMENTOS E  CIVIL DE PESSOAS JURIDICAS', 47563, 3162401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8457, 2697, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55988, 3162401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8458, 3487, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE OLIMPIO CAMPOS', 31914, 3162401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8459, 11042, 'OFICIO DO REGISTRO DE IMOVEIS DE SAO JOAO DA PONTE', 57133, 3162401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8460, 3486, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTO ANTONIO DA BOA VISTA', 34645, 3162401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8461, 11043, 'CARTORIO DE PROTESTO DE TITULOS DA COMARCA DE SAO JOAO DA PONTE', 34967, 3162401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8462, 11044, 'OFICIO DO 1º TABELIONATO DE NOTAS DE SAO JOAO DA PONTE', 33910, 3162401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8463, 3485, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SIMAO CAMPOS', 34744, 3162401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8464, 3488, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 56325, 3162450, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8465, 3492, 'REGISTRO CIVIL ', 55574, 3162500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8466, 3490, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE ARCANGELO', 190, 3162500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8467, 3489, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 46912, 3162500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8468, 3491, 'CARTORIO CIVIL E TABELIONATO DE EMBOABAS', 33878, 3162500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8469, 11045, 'CARTORIO DE REGISTRO DE PROTESTOS', 39313, 3162500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8470, 3493, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SAO GONCALO DO AMARANTE', 37556, 3162500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8471, 11046, 'CARTORIO 1º OFICIO DE NOTAS', 33498, 3162500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8472, 11047, 'SAO JOAO DEL REI CARTORIO 3º OFICIO DE NOTAS', 57893, 3162500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8473, 11048, 'CARTORIO DE TITULOS E DOCUMENTOS CIVIL DE PESSOAS JURIDICAS', 40188, 3162500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8474, 11049, 'OFICIO DE REGISTRO DE IMOVEIS', 47308, 3162500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8475, 11050, 'SAO JOAO DEL REI CARTORIO DO 2º OFICIO DE NOTAS', 57901, 3162500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8476, 7035, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 38182, 3162500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8477, 3494, 'SAO JOAO DO MANHUACU CARTORIO DE PAZ NOTAS E REGISTRO CIVIL', 57919, 3162559, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8478, 3495, 'MANTENA CARTORIO', 45989, 3162575, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8479, 3497, 'SERVICO NOTARIAL E REGISTRAL', 59055, 3162609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8480, 3496, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 51045, 3162609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8481, 3498, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO JOAO DO PACUI', 36798, 3162658, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8482, 11051, 'OFICIO DO REGISTRO DE IMOVEIS DE SAO JOAO DO PARAISO', 152777, 3162708, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8483, 11052, 'OFICIO DO TABELIONATO DE PROTESTO DE TITULOS', 152769, 3162708, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8484, 11053, '2º TABELIONATO DE NOTAS', 153403, 3162708, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8485, 11054, '1º TABELIONATO DE NOTAS DE SAO JOAO DO PARAISO', 152751, 3162708, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8486, 11055, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 152785, 3162708, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8487, 3499, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52464, 3162708, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8488, 3500, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55582, 3162807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8489, 11056, 'SERVICO NOTARIAL 1º OFICIO', 48017, 3162807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8490, 11057, 'CARTORIO DE PROTESTO DE TITULOS', 34868, 3162807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8491, 2698, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50914, 3162807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8492, 11058, 'CARTORIO  REGISTRO IMOVEIS', 33456, 3162807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8493, 11059, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49635, 3162807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8494, 11423, 'OFICIO DE REGISTRO DE IMOVEIS', 47274, 3128709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8495, 11424, 'OFICIO TABELIONATO DE PROTESTOS DE TITULOS', 54965, 3128709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8496, 2153, 'CARTORIO SEBASTIAO VIEIRA DE ANDRADE', 45179, 3128808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8497, 2947, 'OFICIODO REGISTRO CIVIL E TABELIONATO DE NOTAS', 54973, 3128907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8498, 2948, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE VILAS BOAS', 42804, 3129004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8499, 2151, 'CARTORIO SILVA RABELO-REGISTRO CIVIL E NOTAS', 45229, 3138302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8500, 6905, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52159, 3138351, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8501, 2168, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS ', 50948, 3138401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8502, 11425, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 39750, 3138401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8503, 2152, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE NOTAS DE TEBAS', 45955, 3138401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8504, 11426, 'PRIMEIRO SERVICO NOTARIAL', 55335, 3138401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8505, 2167, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PIACATUBA', 37481, 3138401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8506, 11427, 'TABELIONATO DE PROTESTOS DE TITULOS E DOCUMENTOS', 60970, 3138401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8507, 2751, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE RIBEIRO JUNQUEIRA', 43687, 3138401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8508, 2166, 'CARTORIO CIVIL PESSOAS NATURAIS INTERDICOES E TUTELA DE ABAIBA', 53389, 3138401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8509, 11428, 'CARTORIO DE REGISTRO DE IMOVEIS DE LEOPOLDINA', 39149, 3138401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8510, 2752, 'REGISTRO CIVIL E TABELIONATO DE NOTAS DE PROVIDENCIA', 37143, 3138401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8511, 11429, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49809, 3138401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8512, 6968, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE LIBERDADE', 53579, 3138500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8513, 11430, '2º TABELIONATO DE NOTAS DA COMARCA DE LIMA DUARTE', 32771, 3138609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8514, 11431, 'CARTORIO DO 1º OFICIO DE NOTAS', 40790, 3138609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8515, 2170, 'CARTORIO DO REGISTRO CIVIL DE CONCEICAO DE IBITIPOCA', 42606, 3138609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8516, 11432, 'REGISTRO DE IMOVEIS DA COMARCA DE LIMA DUARTE', 44032, 3138609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8517, 2171, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E INTERDICOES E TUTELAS DO 1º DISTRITO DE LIMA DUARTE/MG', 56366, 3138609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8518, 2169, 'CARTORIO DO REGISTRO CIVIL DE SAO JOSE DOS LOPES', 42630, 3138609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8519, 11433, 'CARTORIO DE PROTESTO', 61010, 3138609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8520, 2172, 'CARTORIO DO REGISTRO CIVIL DE SAO DOMINGOS DA BOCAINA COM ATRIBUICOES NOTARIAIS', 42622, 3138609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8521, 11434, 'REGISTRO DE TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS', 57596, 3138609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8522, 4003, 'VIEIROPOLIS CARTORIO DISTRITAL', 73411, 2517209, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8523, 4004, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 69799, 2505501, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8524, 4005, 'CARTORIO DO REGISTRO CIVIL DE ZABELE', 71027, 2517407, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8525, 10328, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS DE ABREU - CARTORIO ALFREDO MARIANO', 150607, 2600054, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8526, 10329, 'CARTORIO DO REGISTRO GERAL DE IMOVEIS, DE TITULOS, DE DOCUMENTOS E DE PESSOAS JURIDICAS', 76331, 2600054, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8527, 4006, 'CARTORIO DO REGISTRO CIVIL', 75333, 2600054, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8528, 10330, 'CARTORIO UNICO DE NOTAS E REGISTROS ', 150599, 2600104, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8529, 4007, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75572, 2600104, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8530, 4008, 'CARTORIO DO REGISTRO CIVIL CACHOEIRA DO ROBERTO', 75382, 2600203, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8531, 10331, 'CARTORIO DO REGISTRO GERAL DE IMOVEIS, NOTAS E DEMAIS ANEXOS', 76349, 2600203, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8532, 7084, 'MARIA PEREIRA RAMOS', 77164, 2600203, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8533, 10332, '2º CARTORIO DE NOTAS E PROTESTO DE TITULOS', 73627, 2600302, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8534, 4011, 'CARTORIO REGISTRO CIVIL DA PESSOAS NATURAIS 2° DISTRITO AGRESTINA', 76620, 2600302, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8535, 4010, 'CARTORIO REGISTRO CIVIL E TABELIONATO DO 3º DISTRITO AGRESTINA', 76695, 2600302, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8536, 4009, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE AGRESTINA', 74559, 2600302, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8537, 10333, '1º OFICIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E REGISTRO CIVIL DE PESSOAS JURIDICAS', 131219, 2600302, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8538, 10334, 'CARTORIO DE NOTAS E REGISTRO GERAL DE IMOVEIS - AGUA PRETA - PE', 74013, 2600401, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8539, 4012, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS ', 74294, 2600401, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8540, 4013, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 74542, 2600500, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8541, 10335, 'CARTORIO DO UNICO OFICIO', 76406, 2600500, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8542, 10336, 'CARTORIO OFICIO UNICO - ALAGOINHA', 150789, 2600609, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8543, 7085, 'CARTORIO DO REGISTRO CIVIL DE ALAGOINHA', 75804, 2600609, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8544, 4014, 'REGISTRO CIVIL ALIANCA', 77263, 2600708, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8545, 10337, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE UPATININGA - ALIANCA', 74567, 2600708, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8546, 10338, 'SERVICO NOTARIAL E REGISTRAL CARTORIO UNICO', 77578, 2600708, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8547, 10339, '1º CARTORIO DE TABELIONATO DE NOTAS, REGISTRO DE IMOVEIS E ANEXOS', 73528, 2600807, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8548, 4015, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 74252, 2600807, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8549, 10340, 'CARTORIO DO 2º OFICIO', 74880, 2600807, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8550, 4016, 'CARTORIO DO REGISTRO CIVIL E REGISTRO GERAL DE IMOVEIS', 76166, 2600906, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8551, 10341, 'CARTORIO DE REGISTRO, TITULOS E DOCUMENTOS, PROTESTOS E NOTAS', 74740, 2600906, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8552, 10342, 'TABELIONATO DE PROTESTO DE TITULOS DE VARZEA DA PALMA/MG', 60632, 3170800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8553, 10343, 'CARTORIO DO REGISTRO DE TITULOS E DOCUMENTO E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 39412, 3170800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8554, 10344, '2º TABELIONATO DE NOTAS ', 153700, 3170800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8555, 2636, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE PARANA-MIRI', 66282, 1502855, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8556, 10653, 'CARTORIO - 1º OFICIO - CURUCA', 65920, 1502905, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8557, 2640, 'CARTORIO REGISTRO DE NAZARE DO MOCAJUBA', 68031, 1502905, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8558, 2638, 'CARTORIO REGISTRO MUTUCAL', 68064, 1502905, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8559, 2639, 'CARTORIO REGISTRO CIVIL DE ARAQUAIM - CURUCA', 68007, 1502905, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8560, 2641, 'CARTORIO DA VILA MURAJA', 65946, 1502905, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8561, 2643, 'CARTORIO REGISTRO DE PONTA DE RAMOS', 68049, 1502905, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8562, 2644, 'CARTORIO DE REGISTRO CIVIL DE BOA VISTA DO IRIRITEUA', 67991, 1502905, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8563, 7063, 'CARTORIO DO 2º OFICIO - CURUCA', 66795, 1502905, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8564, 2642, 'CARTORIO REGISTRO VILA LAURO SODRE', 68072, 1502905, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8565, 2645, 'SERVICOS NOTARIAIS E DE REGISTROS PUBLICOS', 68544, 1502939, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8566, 2646, 'CARTORIO UNICO DE ELDORADO DOS CARAJAS (SEDE)', 139832, 1502954, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8567, 2647, 'CARTORIO UNICO OFICIO DE FARO', 68320, 1503002, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8568, 2648, 'SERVICO NOTARIAL PUBLICO DO UNICO OFICIO', 68528, 1503044, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8569, 2649, 'CARTORIO DO UNICO OFICIO DE GARRAFAO DO NORTE', 67181, 1503077, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8570, 2650, 'CARTORIO DO UNICO OFICIO DE GOIANESIA DO PARA', 67199, 1503093, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8571, 2651, 'CARTORIO DO UNICO OFICIO', 67017, 1503101, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8572, 2540, 'CARTORIO DO UNICO OFICIO', 66993, 1503200, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8573, 7064, 'CARTORIO DE REGISTRO CIVIL DO UNICO OFICIO DE VILA CARIPI', 66373, 1503200, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8574, 2653, 'CARTORIO DE REGISTRO CIVIL DA  VILA DE PORTO SEGURO - IGARAPE-ACU', 66183, 1503200, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8575, 2652, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 66217, 1503200, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8576, 2543, 'CARTORIO SILVA', 68213, 1503309, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8577, 2541, 'CARTORIO DO 2 OFICIO ALDA NERI', 66746, 1503309, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8578, 10654, 'CARTORIO DO 1º OFICIO SAMUEL ALMEIDA', 66738, 1503309, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8579, 2544, 'CARTORIO DA VILA MAIAUATA ', 67678, 1503309, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8580, 2542, 'CARTORIO DO UNICO OFICIO DO RIO MERUU - IGARAPE-MIRI', 67504, 1503309, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8581, 2545, 'CARTORIO UNICO OFICIO DE INHANGAPI', 68338, 1503408, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8582, 2546, 'CARTORIO DO UNICO OFICIO DE IPIXUNA DO PARA', 67207, 1503457, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8583, 2547, 'CARTORIO DE BADAJOS - IPIXUNA DO PARA', 66001, 1503457, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8584, 2549, 'CARTORIO DE REGISTRO CIVIL DE VILA CONCEICAO', 66266, 1503507, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8585, 2552, 'CARTORIO DE REGISTRO CIVIL SANTA RITA DURAO', 66456, 1503507, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8586, 10655, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO E DISTRIBUICAO DE LUCENA', 154237, 2508604, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8587, 3916, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE LUCENA', 69989, 2508604, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8588, 6654, 'MAE D AGUA CARTORIO UNICO REGISTRO CIVIL', 72280, 2508703, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8589, 3917, 'EXTRAJUDICIAL SERVICO REGISTRAL', 72140, 2508802, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8590, 10656, 'CARTORIO DE DISTRIBUICAO COMARCA DE MALTA PB', 69385, 2508802, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8591, 10657, 'CARTORIO SOUZA FERNANDES', 71811, 2508802, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8592, 10658, 'CARTORIO BUSTORFF - 2º OFICIO DE NOTAS E PROTESTO', 68783, 2508901, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8593, 3919, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 70748, 2508901, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8594, 3918, 'CARTORIO DISTRITAL DE PITANGA DA ESTRADA', 69625, 2508901, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8595, 10659, 'OFICIO DE REGISTRO DE DISTRIBUICAO', 72397, 2508901, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8596, 10660, '1º SERVICO NOTARIAL E REGISTRAL - CARTORIO SILVA RAMOS', 68718, 2508901, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8597, 3921, 'CARTORIO RABELO', 71738, 2509008, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8598, 3920, 'CARTORIO DUARTE', 71415, 2509008, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8599, 3922, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 69906, 2509057, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8600, 10661, 'CARTORIO DISTRITAL DE CUMURUPIM', 154260, 2509057, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8601, 3923, 'SERVICO REGISTRAL E NOTARIAL FRANCA', 73239, 2509107, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8602, 10662, 'CARTORIO DE DISTRIBUICAO DE MARI', 154245, 2509107, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8603, 3924, 'CARTORIO DISTRITAL DE MARIZOPOLIS', 70276, 2509156, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8604, 3925, 'ANAMARIA DE MORAIS E SILVA', 68957, 2509206, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8605, 6655, 'CARTORIO DISTRITAL DE BARRA DO CAMARATUBA', 70227, 2509305, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8606, 3926, 'CARTORIO DO REGISTRO CIVIL', 70656, 2509305, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8607, 3927, 'CARTORIO DO REGISTRO CIVIL DE MATINHAS', 70862, 2509339, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8608, 3928, 'CARTORIO OLIVEIRA MELO', 71688, 2509370, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8609, 3929, 'SERVICO REGISTRAL E NOTARIAL', 73205, 2509396, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8610, 10663, '2° TABELINATO DE NOTAS', 68775, 2509701, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8611, 2663, 'SERVENTIA DO REGISTRO CIVIL E NOTAS', 58305, 3157906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8612, 10981, 'PROTESTO DE TITULOS', 55483, 3158003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8613, 10982, 'REGISTRO DE IMOVEIS', 57000, 3158003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8614, 2664, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO FERREIRA', 38364, 3158003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8615, 10983, 'TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 61440, 3158003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8616, 2665, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51888, 3158102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8617, 10984, 'CARTORIO DO 1º OFICIO DE NOTAS', 40568, 3158201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8618, 10985, 'OFICIO DO 1º TABELIONATO DE PROTESTOS DE TITULOS', 49007, 3158201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8619, 2515, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE POAIA', 51623, 3158201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8620, 10986, 'OFICIO DO REG. DE TITS. E DOCS. E CIVIL DAS PESSOAS JUR.', 50245, 3158201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8621, 10987, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49619, 3158201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8622, 2517, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53074, 3158201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8623, 2516, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50930, 3158201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8624, 10988, 'SANTA MARIA DO SUACUI CARTORIO REGISTRO DE IMOVEIS', 57851, 3158201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8625, 2985, 'CARTORIO DE REGISTRO CIVIL DE SANTA RITA DE CALDAS', 36483, 3159209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8626, 10989, 'OFICIO DO 2º TABELIONATO DE NOTAS', 41285, 3159209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8627, 10990, 'SANTA RITA DE CALDAS CARTORIO DE REGISTRO DE IMOVEIS', 57869, 3159209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8628, 2986, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO BENTO DE CALDAS', 38166, 3159209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8629, 10991, 'SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39552, 3159209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8630, 10992, 'PRIMEIRO CARTORIO DE NOTAS ', 55269, 3159209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8631, 10993, 'OFICIO DO TABELIONATO DE PROTESTO DE TITULOS', 152744, 3159209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8632, 2518, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE BOM JESUS DO VERMELHO', 37994, 3159407, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8633, 2668, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE PARAISO GARCIA', 46813, 3159407, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8634, 2667, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SANTA RITA DE IBITIPOCA', 37002, 3159407, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8635, 3107, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ITABOCA ', 53520, 3159308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8636, 2666, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SANTA RITA DE JACUTINGA', 37507, 3159308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8637, 6979, 'CARTORIO REGISTRAL E NOTARIAL DE SANTA RITA DE MINAS', 44271, 3159357, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8638, 2669, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 52183, 3159506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8639, 2519, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE SANTA RITA DO ITUETO', 52217, 3159506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8640, 10994, 'OFICIO DO 1º TABELIONATO DO NOTAS DE SANTA RITA DO SAPUCAI', 58826, 3159605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8641, 10995, 'CARTORIO DO 2º OFICIO DE NOTAS', 41277, 3159605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8642, 10996, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE SANTA RITA DO SAPUCAI', 39289, 3159605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8643, 10997, 'SERVICO REGISTRAL DE IMOVEIS ', 59337, 3159605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8644, 2670, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42119, 3159605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8645, 10998, 'CARTORIO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 40311, 3159605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8646, 2671, 'OFICIO DO REG. CIVIL E NOTAS', 50195, 3159704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8647, 10999, 'TABELIONATO DE PROTESTO DE TITULOS', 60269, 3159803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8648, 11000, 'SERVICO NOTARIAL DO 1º OFICIO DE NOTAS', 50583, 3159803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8649, 2520, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PERDILANDIA', 604, 3159803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8650, 11001, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49767, 3159803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8651, 11002, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 130716, 3159803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8652, 2672, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CHAVESLANDIA', 51664, 3159803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8653, 2521, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE SANTA VITORIA', 50468, 3159803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8654, 11003, 'SERVICO REGISTRAL IMOBILIARIO DE SANTA VITORIA', 59774, 3159803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8655, 2522, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51920, 3158300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8656, 3108, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTANA DE CATAGUASES', 37978, 3158409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8657, 3110, 'OFICIO DO REGISTRO CIVIL E NOTAS', 45120, 3158508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8658, 11348, 'CARTORIO DO 2º OFICIO DE NOTAS', 41467, 3128006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8659, 2938, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE FARIAS', 46672, 3128006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8660, 2941, 'CARTORIO DO REGISTRO CIVIL DASPESSOAS NATURAIS', 42598, 3128105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8661, 11349, 'TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 61424, 3137403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8662, 11350, 'OFICIO DO REGISTRO DE IMOVEIS', 53934, 3137403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8663, 2287, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 37051, 3137502, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8664, 2144, 'MONJOLINHO - CARTORIO REGISTRO CIVIL E NOTAS', 46094, 3137502, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8665, 6903, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE LIMEIRA DE MINAS', 43299, 3137502, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8666, 2288, 'CARTORIO DE REGISTRO CIVIL E NOTAS ', 36954, 3137536, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8667, 11351, 'OFICIO DO 1º TABELIONATO DE NOTAS DE LAGOA SANTA', 48413, 3137601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8668, 11352, 'OFICIO DO 1º TABELIONATO DE TITULOS', 49056, 3137601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8669, 11353, 'OF.DO REG.DE TITS E DOCS. E CIVIL DAS PESSOAS JURIDICAS', 46268, 3137601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8670, 2145, 'REG. DAS PESSOAS NATURAIS E NOTAS DISTRITO DE LAPINHA', 145219, 3137601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8671, 6904, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50443, 3137601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8672, 11354, 'OFICIO DO REGISTRO DE IMOVEIS DE LAGOA SANTA', 54148, 3137601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8673, 11355, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49874, 3137601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8674, 11356, 'TABELIONATO DE PROTESTO DE TITULOS E DOCUMENTOS', 60111, 3137700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8675, 11357, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48165, 3137700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8676, 11358, 'OFICIO DO REGISTRO DE IMOVEIS', 45609, 3137700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8677, 2146, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 58172, 3137700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8678, 2289, 'REGISTRO E TABELIONATO E NOTAS DE PALMEIRAS', 57729, 3137700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8679, 11359, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 57455, 3137700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8680, 2147, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE PRATA DE LAJINHA', 34587, 3137700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8681, 11360, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49650, 3137700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8682, 11361, 'CARTORIO DO 1º OFICIO DE NOTAS', 40576, 3137809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8683, 11362, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE LAMBARI', 47456, 3137809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8684, 11363, 'REGISTRO DE IMOVEIS', 56986, 3137809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8685, 2290, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56184, 3137809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8686, 11364, 'CARTORIO DO 2º OFICIO DE NOTAS', 41350, 3137809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8687, 11365, 'OFICIO DO 1  TABELIONATO DE PROTESTO DE TITULOS', 47597, 3137809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8688, 2148, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS ', 35725, 3137908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8689, 2150, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 42747, 3138005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8690, 2149, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SAO JOAO DA SAPUCAIA ', 37572, 3138005, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8691, 2291, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51912, 3138104, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8692, 2292, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56044, 3138203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8693, 11366, 'SERVICO REGISTRAL DE IMOVEIS', 59329, 3138203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8694, 11367, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 59675, 3138203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8695, 11368, 'SERVICO NOTARIAL DO 1º OFICIO DE NOTAS', 58917, 3138203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8696, 11369, 'CARTORIO DO 2° OFICIO DE NOTAS', 41152, 3138203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8697, 11370, 'OFICIO DO TABELIONATO DE PROTESTO DE TITULOS', 59667, 3138203, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8698, 2848, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ORATORIOS', 52753, 3145851, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8699, 2849, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36822, 3145877, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8700, 11371, 'REGISTRO DE IMOVEIS', 57059, 3145901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8701, 11372, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE OURO BRANCO', 47506, 3145901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8702, 11373, '1º OFICIO DE NOTAS ', 32011, 3145901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8703, 11374, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS DE OURO BRANCO', 47845, 3145901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8704, 11375, 'OFICIO DO 2° TABELIONATO DE NOTAS', 49221, 3145901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8705, 7020, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 46482, 3145901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8706, 11376, 'CARTORIO DE REGISTRO DE IMOVEIS ', 38943, 3146008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8707, 2324, 'OFICIO DO REGISTRO CIVIL E TABELIONATO', 51383, 3146008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8708, 3559, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CAMPO REDONDO', 31898, 3170909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8709, 3560, 'CARTORIO DE REGISRTO CIVIL TAB. DE NOTAS', 35196, 3170909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8710, 6986, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36772, 3170909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8711, 10345, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48140, 3171006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8712, 3561, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52175, 3171006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8713, 10346, 'SERVICO DE REGISTRO DE IMOVEIS', 58545, 3171006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8714, 10347, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 49049, 3171006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8715, 10348, 'CARTORIO DE REGISTRO DE TITULOS DOCUMENTOS E PESSOAS JURIDICAS', 39388, 3171006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8716, 10349, 'SEGUNDO TABELIONATO DE NOTAS DE VAZANTE ', 58123, 3171006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8717, 3562, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55848, 3171006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8718, 3563, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52993, 3171030, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8719, 2601, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE VEREDINHA', 44735, 3171071, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8720, 6987, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DO DISTRITO DE MENDONCA', 35659, 3171071, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8721, 3564, 'OFICIO DE REGISTRO CIVL E TABELIONATO DE NOTAS', 47142, 3171105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8722, 6988, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL', 51375, 3171154, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8723, 10350, 'TABELIONATO DO 1° OFICIO DE NOTAS DE VESPASIANO-MG', 61077, 3171204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8724, 10351, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE VESPASIANO', 60533, 3171204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8725, 10352, 'CARTORIO DE REGISTRO DE IMOVEIS DE VESPASIANO', 47365, 3171204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8726, 10353, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 40287, 3171204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8727, 10354, 'OFICIO DO 2º TABELIONATO DE NOTAS DA COMARCA DE VESPASIANO-MG', 49585, 3171204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8728, 2602, 'CARTORIO DE REGISTRO CILVIL DAS PESSOAS NATURAIS DE VESPASIANO', 35212, 3171204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8729, 10355, 'TABELIONATO DO 1º OFICIO DE NOTAS', 61093, 3171303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8730, 3566, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E INTERDICOES E TUTELAS', 33852, 3171303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8731, 3565, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CACHOEIRA DE SANTA CRUZ', 36129, 3171303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8732, 3568, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO JOSE DO TRIUNFO', 35402, 3171303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8733, 10356, 'VICOSA CARTORIO DE REGISTRO DE IMOVEIS ', 61523, 3171303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8734, 10357, 'TABELIONATO DO 3º OFICIO DE NOTAS', 61267, 3171303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8735, 3567, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SILVESTRE', 51821, 3171303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8736, 10358, 'TABELIONTO DE PROTESTO DE TITULOS DA COMCRACA DE VICOSA-MG', 61341, 3171303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8737, 10359, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49684, 3171303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8738, 10360, 'OFICIO DO REG. DE  TIT. E DOC. E CIVIL DAS PESSOAS JURIDICAS     ', 50211, 3171303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8739, 3569, 'CARTORIO DE REGISTRO CIVIL COM ATRIBUICOES NOTARIAIS', 35378, 3171402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8740, 3570, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTO ANTONIO DO GLORIA', 40345, 3171402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8741, 3241, 'SEGUNDO TABELIONATO DE NOTAS E REGISTRO CIVIL DAS PESSOAS NATURAIS', 65292, 5107602, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8742, 3246, 'CGJ/MT_1 CARTORIO DE PAZ E NOTAS DO DISTRITO DE ARRUDA', 64717, 5107701, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8743, 10361, 'CARTORIO DO 1.º OFICIO DE ROSARIO OESTE', 64147, 5107701, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8744, 7055, 'CGJ/MT_1 CARTORIO DE PAZ E NOTAS DE BAUXI', 64626, 5107701, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8745, 3245, 'CGJ/MT_1 OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 64840, 5107701, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8746, 3244, 'CARTORIO DO 2º OFICIO DE REGISTRO CIVIS, PESSOA JURIDICA, PROTESTO E TABELIONATO', 64436, 5107701, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8747, 10362, 'CARTORIO DE PAZ E NOTAS - CRISTINOPOLIS - JOSE ANTONIO DA SILVA', 136929, 5107750, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8748, 10363, 'CARTORIO DE PAZ E NOTAS - JOSE ANTONIO DA SILVA', 136937, 5107750, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8749, 10364, 'RCPN - COMARCA SINOP', 132738, 5107248, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8750, 3247, 'SERVICO NOTARIAL E REGISTRO CIVIL', 65391, 5107768, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8751, 3248, 'CGJ/MT_1 SERVICO NOTARIAL E REGISTRAL', 64865, 5107776, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8752, 3249, 'CARTORIO DE NOTAS E REGISTRO CIVIL', 63909, 5107263, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8753, 3251, 'CARTORIO DE PAZ E NOTAS DISTRITO DE ENGENHO VELHO', 63982, 5107800, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8754, 3931, 'CARTORIO MARIA DO CARMO MARTINS SILVA', 71639, 2509404, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8755, 3930, 'CARTORIO DO RESGITRO CIVIL DO DISTRITO DE GAMELEIRA', 71332, 2509404, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8756, 3932, 'MONTADAS CARTORIO DO REGISTRO CIVIL', 72330, 2509503, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8757, 3933, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 70722, 2509602, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8758, 3934, 'CARTORIO DE REGISTRO DE PESSOAS NATURAIS DE MONTEIRO-PB', 70094, 2509701, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8759, 10664, 'CARTORIO JAYME BEZERRA DE MENEZES - SERVICO NOTARIAL E REGISTRAL - 1º OFICIO', 71563, 2509701, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8760, 10665, 'CARTORIO DO REGISTRO DE DISTRIBUICAO EXTRAJUDICIAL', 71282, 2509701, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8761, 3262, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 72447, 2509800, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8762, 7349, 'CARTORIO DO REGISTRO CIVIL ETABELIONATO', 71258, 2509909, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8763, 3935, 'NAZAREZINHO CARTORIO DISTRITAL', 72355, 2510006, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8764, 3936, 'CARTORIO UNICO DE NOVA FLORESTA/PB', 71886, 2510105, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8765, 6656, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 70771, 2510204, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8766, 3937, 'CARTORIO DISTRITAL FRANCINALDO BORGES DOS SANTOS', 70433, 2510303, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8767, 10666, 'CARTORIO UNICO DE INAJA', 76828, 2607000, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8768, 4090, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 76836, 2607109, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8769, 6535, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE IPOJUCA (1º DISTRITO-SEDE) DO ESTADO DE PERNAMBUCO', 75697, 2607208, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8770, 4091, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE CAMELA (2º DISTRITO) ', 75663, 2607208, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8771, 10667, 'CARTORIO DE IPOJUCA OFICIO UNICO', 150680, 2607208, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8772, 4092, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DO 3º DISTRITO DE NOSSA SENHORA, IPOJUCA - PE', 76281, 2607208, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8773, 10668, 'SERVICO DO OFICIO UNICO -TABELIONATO DE NOTAS, REGISTROS PUBLICOS E PROTESTO', 77537, 2607307, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8774, 4093, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75523, 2607307, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8775, 4199, 'REGISTRO CIVIL E TABELIONATO DE SERROLANDIA', 77461, 2607307, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8776, 4094, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 76844, 2607406, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8777, 10669, 'CARTORIO UNICO DE OFICIO DE ITAIBA', 150854, 2607505, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8778, 4095, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE ITAIBA - PE', 75648, 2607505, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8779, 4097, 'CARTORIO DO REGISTRO CIVIL', 75309, 2607653, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8780, 10670, '2.º CARTORIO DE NOTAS E DE PROTESTOS', 73593, 2607653, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8781, 10671, 'CARTORIO DO 1° OFICIO - CLAUDIO NUNES RIBEIRO', 150771, 2607653, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8782, 4098, 'CARTORIO DO REGISTRO CIVIL', 75218, 2607653, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8783, 10672, 'CARTORIO UNICO DE NOTAS, REGISTRO PUBLICO E DO PROTESTOS DA COMATCA DE ITAPETIM', 76935, 2607703, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8784, 4100, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE ITAPETIM', 75705, 2607703, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8785, 4099, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE SAO VICENTE', 76067, 2607703, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8786, 4101, 'CARTORIO DE REGISTRO CIVIL DE ITAPISSUMA - PE', 74484, 2607752, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8787, 10673, 'CARTORIO UNICO WANDA LADYCLAIRE', 150862, 2607752, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8788, 4102, 'CARTORIO UNICO DE ITAQUITINGA - PERNAMBUCO.', 76869, 2607802, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8789, 6536, 'CARTORIO DO REGISTRO CIVIL DE JABOATAO CENTRO', 75861, 2607901, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8790, 4104, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DO 2º DISTRITO', 77180, 2607901, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8791, 10674, 'CARTORIO DO 2º OFICIO DE NOTAS E PROTESTOS DO JABOATAO DOS GUARARAPES', 74914, 2607901, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8792, 10675, 'CARTORIO DO 1º OFICIO JABOATAO DOS GUARARARAPES/REGISTRO DE IMOVEIS/NOTAS/PROTESTOS/TITULOS E DOCUMENTOS', 74849, 2607901, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8793, 4103, 'CARTORIO DE REGISTRO CIVIL DE CAVALEIRO - 3º DISTRITO DO JABOATAO DOS GUARARAPES/PE', 74435, 2607901, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8794, 10676, 'CARTORIO 3 OFICIO DE NOTAS ', 150698, 2607901, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8795, 4105, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 76232, 2607950, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8796, 10677, 'CARTORIO UNICO JATAUBA', 150706, 2608008, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8797, 10678, 'CARTORIO TN RI TP RTDC ', 130401, 2608008, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8798, 4107, 'CARTORIO REGISTRO CIVIL DE JATAUBA', 76661, 2608008, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8799, 4106, 'CARTORIO REGISTRO CIVIL PASSAGEM DO TO', 76703, 2608008, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8800, 10679, 'SERVICO NOTARIAL E REGISTRAL', 77545, 2608107, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8801, 3109, 'CARTORIO REGISTRO CIVIL E NOTAS', 44594, 3158508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8802, 3111, 'CARTORIO DO REGISTRO CIVIL E DE NOTAS', 42663, 3158607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8803, 2523, 'CARTORIO FERREIRA', 52118, 3158706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8804, 2524, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52506, 3158805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8805, 3112, 'SANTANA DO MANHUACU CARTORIO DE PAZ E NOTAS E DE REGISTRO CIVIL', 57877, 3158904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8806, 3113, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE SANTA FILOMENA', 56283, 3158904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8807, 3114, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52258, 3158953, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8808, 2674, 'REGISTRO CIVIL E NOTAS', 56689, 3159001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8809, 2673, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE CARDEAL MOTA', 47084, 3159001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8810, 2675, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL - JOSELANDIA', 45948, 3159100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8811, 3363, 'CARTORIO FERREIRA 2º OFICIO - OBIDOS', 67660, 1505106, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8812, 3506, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO JOSE DA BARRA', 43349, 3162948, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8813, 3507, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURIAIS DO MUNICIPIO DE SAO JOSE DA LAPA', 51094, 3162955, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8814, 3508, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E INTERDICOES E TUTELAS E TABELIONATO DE NOTAS', 34595, 3163003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8815, 7037, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 42853, 3163102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8816, 2699, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 43117, 3163201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8817, 2700, 'CARTORIO NORANEI MACHADO REGISTRO CIVIL E TABELIONATO DE NOTAS', 44115, 3163300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8818, 2701, 'SAO JOSE DO GOIABAL CARTORIO DE PAZ', 57927, 3163409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8819, 2569, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO JOSE DO JACURI', 33761, 3163508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8820, 2570, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 43307, 3163607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8821, 11083, 'REGISTRO TITULOS E DOCUMENTOS/REGISTRO CIVIL DAS PESSOAS JURIDICAS', 57737, 3163706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8822, 11084, 'SERVICO REGISTRAL PRIVATIVO DE IMOVEIS DA COMARCA DE SAO LOURENCO', 59824, 3163706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8823, 2571, 'SERVICO DE REGISTRO CIVIL E NOTAS', 58461, 3163706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8824, 11085, '2º OFICIO DE NOTAS', 32516, 3163706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8825, 11086, 'TABELIONATO DE REGISTRO DE PROTESTO DE SAO LOURENCO', 61036, 3163706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8826, 11087, 'SERVICO NOTARIAL PRIVATIVO DO 1º OFICIO', 59071, 3163706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8827, 2572, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36913, 3163805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8828, 11088, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55939, 3163904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8829, 2573, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE SAO PEDRO DO SUACUI', 35998, 3164100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8830, 3509, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 46854, 3164001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8831, 2574, 'CARTORIO DE PAZ E NOTAS ', 34215, 3164001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8832, 11089, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE SAO ROMAO-MG', 47530, 3164209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8833, 11090, 'PRIMEIRO TABELIONATO DE NOTAS DA COMARCA DE SAO ROMAO', 60038, 3164209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8834, 2527, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 54627, 3164209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8835, 11091, '1º TABELIONATO DE PROTESTO ', 32367, 3164209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8836, 11092, '2º TABELIONATO DE NOTAS ', 153676, 3164209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8837, 11093, 'OFICIO DE REGISTRO DE IMOVEIS ', 47191, 3164209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8838, 3511, 'CARTORIO DE REGISTRO CIVIL, PAZ E NOTAS', 36319, 3164308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8839, 2590, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DO DISTRITO DE CANASTRAO', 53710, 3168903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8840, 3510, 'CARTORIO DE REGISTRO CIVIL PESSOAS NAT. E TABELIONATO DE NOTAS', 38430, 3164308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8841, 11094, 'SAO ROQUE DE MINAS ', 153684, 3164308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8842, 11095, 'CARTORIO DE REGISTRO DE IMOVEIS', 38646, 3164308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8843, 11096, 'CARTORIO DO 1º OFICIO DE NOTAS', 40618, 3164308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8844, 11097, 'CARTORIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 43620, 3164308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8845, 3512, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42200, 3164308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8846, 11098, 'TABELIONATO DE PROTESTO DE TITULOS', 39339, 3164308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8847, 2575, 'CARTORIO REGISTRO CIVIL E NOTAS', 44537, 3164407, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8848, 11099, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 37846, 3164431, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8849, 2576, 'OFICIO DO REGISTRO CIVIL E NOTAS DE SAO SEBASTIAO DO ANTA', 57943, 3164472, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8850, 3513, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 37150, 3164506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8851, 11100, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51474, 3164506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8852, 2577, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS ', 38158, 3164506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8853, 3514, 'CARTORIO CUNHA (REG.CIVIL E NOTAS)', 33902, 3164605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8854, 11101, '3º CARTORIO DE NOTAS', 32870, 3164704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8855, 11102, 'OFICIO DO 2º TABELIONATO DE NOTAS DE SAO SEBASTIAO DO PARAISO', 49916, 3164704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8856, 11103, 'TABELINATO DE PROTESTO S.SEBASTIAO PARAISO', 59949, 3164704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8857, 3515, 'CARTORIO DE PAZ E NOTAS', 34231, 3164704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8858, 11104, 'CARTORIO DE REGISTRO DE IMOVEIS', 38638, 3164704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8859, 11105, 'REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 57661, 3164704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8860, 7038, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35592, 3164704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8861, 10097, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 85654, 4101101, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8862, 3623, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 82537, 4101101, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8863, 4666, 'SERVICO DISTRITAL DE ANGULO', 86199, 4101150, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8864, 4667, 'SERVICO DO REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE O SERVICO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 82628, 4101200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8865, 10098, 'TABELIONATO DE NOTAS, ACUMULANDO PRECARIAMENTE O TABELIONATO DE PROTESTOS DE TITULOS', 88310, 4101200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8866, 10099, 'SERVICO DE REGISTRO DE IMOVEIS', 79715, 4101200, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8867, 4668, 'SERVICO DISTRITAL DE ANTONIO OLINTO', 88179, 4101309, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8868, 4669, 'SERVICO DISTRITAL DE PIRAPO', 88161, 4101408, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8869, 10100, '2º TABELIONATO DE NOTAS', 141341, 4101408, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8870, 3714, '1º SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 85233, 4101408, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8871, 10101, 'TABELIONATO DE PROTESTO DE TITULOS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 130591, 4101408, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8872, 10102, '2º SERVICO DE REGISTRO DE IMOVEIS', 85209, 4101408, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8873, 10103, '1º TABELIONATO DE NOTAS', 86504, 4101408, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8874, 10104, '2º  SERVICO  DE REGISTRO DE IMOVEIS', 80192, 4101507, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8875, 10105, '2º TABELIONATO DE NOTAS', 80143, 4101507, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8876, 10106, '1º. SERVICO DE REGISTRO DE IMOVEIS', 145912, 4101507, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8877, 3715, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81695, 4101507, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8878, 10107, '1º. TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS ', 80747, 4101507, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8879, 10108, 'SERVICO DE REGISTRO DE IMOVEIS', 85779, 4101606, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8880, 4670, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 85985, 4101606, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8881, 10109, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 79749, 4101606, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8882, 4671, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 129551, 4101655, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8883, 3716, 'SERVICO DISTRITAL DE ARARUNA', 86694, 4101705, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8884, 10110, '1º SERVICO DE REGISTRO DE IMOVEIS', 80754, 4101804, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8885, 10111, '2º TABELIONATO DE NOTAS DO FORO REGIONAL DE ARAUCARIA', 154047, 4101804, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8886, 10112, '1º TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O 1º TABELIONATO DE PROTESTO DE TITULOS', 80762, 4101804, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8887, 10113, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS ', 84681, 4101804, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8888, 4672, 'SERVICO DISTRITAL DE ARIRANHA DO IVAI', 88146, 4101853, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8889, 10114, 'TABELIONATO DE PROTESTO DE TITULOS DE ASSAI', 153981, 4101903, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8890, 4673, 'SERVICO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 82776, 4101903, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8891, 10115, '2º SERVICO DE REGISTRO DE IMOVEIS', 80796, 4101903, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8892, 10116, 'TABELIONATO DE NOTAS DE ASSAI', 80770, 4101903, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8893, 10117, '1º SERVICO DE REGISTRO DE IMOVEIS ', 80788, 4101903, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8894, 10118, '1º SERVICO DE REGISTRO DE IMOVEIS', 79962, 4102000, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8895, 10119, '2º SERVICO DE REGISTRO DE IMOVEIS ', 80804, 4102000, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8896, 10120, '2º TABELIONATO DE NOTAS', 80812, 4102000, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8897, 10121, '1º TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87338, 4102000, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8898, 3717, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOE E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81281, 4102000, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8899, 3718, '1º SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO PRECARIAMENTE, O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS ', 79806, 4102109, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8900, 3719, 'SERVICO DISTRITAL DE TUPINAMBA', 88013, 4102109, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8901, 4130, 'CARTORIO REGISTRO CIVIL', 71753, 2504306, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8902, 10451, 'DISTRIBUICAO EXTRAJUDICIAL', 72090, 2504306, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8903, 3853, 'CARTORIODISTRITAL DE CORONEL MAIA', 71993, 2504306, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8904, 10452, 'CARTORIO DO 2º OFICIO', 70524, 2504306, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8905, 4131, 'CARTORIO DISTRITAL DE PICO', 70318, 2504306, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8906, 4132, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 69898, 2504355, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8907, 10453, 'CARTORIO DE DISTRIBUICAO DE CONCEICAO', 69393, 2504405, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8908, 3854, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE CARDOSO', 71043, 2504405, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8909, 10454, 'CARTORIO UNICO', 71837, 2504405, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8910, 4033, 'CARTORIO DE RESGISTRO CIVIL DE RAINHA IZABEL', 74765, 2602100, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8911, 10455, 'CARTORIO DO 2O. OFICIO', 74864, 2602100, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8912, 10456, 'CARTORIO AMARAL', 73965, 2602100, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8913, 4035, 'CARTORIO DE REGISTRO CIVIL DE BOM JARDIM', 77222, 2602209, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8914, 4036, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE BIZARRA', 74666, 2602209, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8915, 10457, 'SERVICO NOTARIAL E REGISTRAL DE BOM JARDIM', 77586, 2602209, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8916, 10458, 'CARTORIO DO OFICIO UNICO DO BONITO', 75077, 2602308, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8917, 4037, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 77339, 2602308, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8918, 4038, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 77354, 2602308, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8919, 10459, 'CARTORIO DE TABELIONATO E DE REGISTRO', 152546, 2602407, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8920, 4177, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 144766, 2602407, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8921, 4039, 'CARTORIO DO REGISTRO CIVIL E ANEXO DE NOTAS DE BREJINHO', 76083, 2602506, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8922, 10460, 'CARTORIO UNICO (TABELIONATO, REGISTRO DE IMOVEIS, PROTESTOS E TITULOS)', 73437, 2602605, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8923, 4040, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE FAZENDA NOVA', 74682, 2602605, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8924, 4178, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE SAO DOMINGOS', 76026, 2602605, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8925, 7088, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 75911, 2602605, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8926, 4041, 'CARTORIO DE REGISTRO CIVIL E DE NOTAS DE BUENOS AIRES-PE', 76794, 2602704, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8927, 4045, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE VILA CARNEIRO', 76133, 2602803, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8928, 10461, 'CARTORIO UNICO DE BUIQUE', 150656, 2602803, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8929, 4044, 'CARTORIO DO REG. CIVIL E NOTAS DE VILA GUANUMBY', 75119, 2602803, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8930, 10462, 'CARTORIO UNICO DE BUIQUE', 150649, 2602803, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8931, 4043, 'CARTORIO DO REGISTRO CIVIL', 75291, 2602803, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8932, 4042, 'CARTORIO DO REGISTRO CIVIL E NOTAS DA VILA DO CATIMBAU 4º DISTRITO DE BUIQUE-PE', 76125, 2602803, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8933, 4047, 'REGISTRO CIVIL PONTE DOS CARVALHOS', 77479, 2602902, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8934, 10463, 'CARTORIO DO 3.º OFICIO DE NOTAS DO CABO-PE', 74963, 2602902, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8935, 10464, 'CARTORIO DO 1° OFICIO: TABEBIONATO, REGISTRO DE IMOVEIS, TITULOS E DOC. E PESSOA JURIDICA', 150615, 2602902, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8936, 4046, 'CARTORIO DO REGISTRO CIVIL', 75275, 2602902, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8937, 7089, 'CARTORIO DE REGISTRO CIVIL DO JUSSARAL - II DISTRITO DO MUNICIPIO DO CABO DE SANTO AGOSTINHO', 130575, 2602902, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8938, 10465, 'CARTORIO DO 2º OFICIO DO CABO', 74930, 2602902, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8939, 4179, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 75929, 2603009, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8940, 10466, 'CARTORIO DO OFICIO UNICO', 75010, 2603009, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8941, 10467, 'CARTORIO DO UNICO OFICIO DE CACHOEIRINHA', 76455, 2603108, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8942, 4049, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, DE NOTAS E DE TITULOS E DOCUMENTOS - DISTRITO DE CABANAS', 133975, 2603108, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8943, 4048, 'CARTORIO DO REGISTRO CIVIL', 75242, 2603108, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8944, 4050, 'CARTORIO DE REGISTRO CIVIL DE CAETES', 74393, 2603207, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8945, 10468, '4º SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 63180, 5001102, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8946, 3584, 'CARTORIO DISTRITAL DE PIRAPUTANGA', 62331, 5001102, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8947, 3582, '2° SERVICO NOTARIAL E DE REGISTRO CIVIL ', 61721, 5001102, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8948, 6990, 'REGISTRO CIVIL TAUNAY', 62851, 5001102, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8949, 10469, '3º SERVICO NOTARIAL E TABELIONATO DE PROTESTO', 61861, 5001102, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8950, 3583, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE CAMISAO', 62802, 5001102, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8951, 10470, '1° SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS', 61713, 5001102, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8952, 3365, 'CARTORIO FRANCISCO CERDEIRA - OEIRAS DO PARA', 67686, 1505205, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8953, 3367, 'CARTORIO DE PORTO TROMBETAS', 66100, 1505304, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8954, 3366, 'CARTORIO PEDRO MARTINS UNICO OFICIO', 67926, 1505304, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8955, 3369, 'CARTORIO DE REGISTRO CIVIL DE TUPINAMBA - OUREM', 66258, 1505403, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8956, 3368, 'CARTORIO DO UNICO OFICIO DE OUREM- CARTORIO CORREA MATOS', 67280, 1505403, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8957, 3370, 'SERVICO DE NOTAS E DE REGISTROS PUBLICOS DE OURILANDIA DO NORTE - PA', 67736, 1505437, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8958, 3371, 'CARTORIO DO UNICO OFICIO DA COMARCA DE PACAJA', 67058, 1505486, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8959, 3372, 'CARTORIO DE REG. CIVIL E TAB. DE NOTAS DO UNICO OFICIO', 66126, 1505494, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8960, 3373, 'CARTORIO DO UNICO OFICIO DE PARAGOMINAS', 67298, 1505502, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8961, 3374, 'CARTORIO DO 1º OFICIO DE PARAUAPEBAS', 67306, 1505536, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8962, 3375, 'SERVENTIA DO OFICIO UNICO DE TABELIONATO DE NOTAS E REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO BAIRRO DA PAZ', 68486, 1505536, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8963, 10751, 'CARTORIO DO 2º OFICIO DE REGISTRO DE IMOVEIS DE PARAUAPEBAS', 66811, 1505536, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8964, 3376, 'CARTORIO DO UNICO OFICIO DE PAU D ARCO - REDENCAO', 67314, 1505551, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8965, 3377, 'CARTORIO ROLIM DO UNICO OFICIO DA COMARCA DE PEIXE BOI', 68122, 1505601, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8966, 3378, 'ROSANGELA MALATO FREITAS', 68460, 1505700, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8967, 3379, 'CARTORIO DO UNICO OFICIO DA COMARCA DE PORTEL', 67108, 1505809, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8968, 3380, 'CARTORIO DO REGISTRO CIVIL E NOTAS - UNICO OFICIO', 66944, 1505908, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8969, 3381, 'CARTORIO DO UNICO OFICIO', 67033, 1506005, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8970, 3383, 'CARTORIO UNICO OFICIO DE JABAROCA -PRIMAVERA', 68346, 1506104, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8971, 3382, 'CARTORIO UNICO OFICIO DA COMARCA DE PRIMAVERA', 68296, 1506104, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8972, 3384, 'CARTORIO DE REGISTRO DO UNICO OFICIO DE QUATIPURU - PRIMAVERA', 66555, 1506112, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8973, 3385, 'CARTORIO DO 1º OFICIO DE REDENCAO', 67330, 1506138, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8974, 10752, '2O. OFICIO DE TABELIONATO DE PROTESTO DE TITULOS', 143305, 1506138, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8975, 3386, 'CARTORIO DO UNICO OFICIO DE RIO MARIA', 67348, 1506161, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8976, 3387, 'CARTORIO DO UNICO OFICIO DE RONDON DO PARA', 67355, 1506187, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8977, 3388, 'CARTORIO DO UNICO OFICIO', 67025, 1506195, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8978, 3389, 'CARTORIO DO UNICO OFICIO DE SALINOPOLIS', 67421, 1506203, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8979, 3392, 'CARTORIO BARBOSA - SALVATERRA', 65805, 1506302, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8980, 7351, 'CARTORIO DO REGISTRO CIVIL - SERVICO REGISTRAL ESTELA PAIVA ', 73080, 2511806, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8981, 3952, 'PITIMBU 1 OFICIO DE NOTAS', 72512, 2511905, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8982, 3953, 'CARTORIO DO REGSITRO CIVIL E NOTAS', 71324, 2512002, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8983, 10753, 'CARTORIO DO UNICO OFICIO', 71365, 2512002, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8984, 10754, 'CARTORIO DE DISTRIBUICAO', 69344, 2512002, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8985, 3954, '1° CARTORIO DO REGSITRO CIVIL', 68643, 2512002, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8986, 3955, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE SAO JOAO BOSCO ', 140871, 2512036, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8987, 3956, 'CARTORIO DO REGISTRO CIVIL DE POCO DANTAS', 70920, 2512036, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8988, 3957, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 71233, 2512077, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8989, 10755, 'AVELINO DE ASSIS QUEIROGA', 69005, 2512101, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8990, 10756, 'EXTRA JUDICIAL DE POMBAL-PB', 72132, 2512101, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8991, 3959, 'CARTORIO DO REGISTRO CIVIL', 70680, 2512101, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8992, 3958, 'SERVICO REGISTRAL GUIOMAR TAVARES FORMIGA', 73262, 2512101, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8993, 10757, 'CARTORIO CEL. JOAO QUEIROGA', 69286, 2512101, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8994, 10758, 'EXTRA JUDICIAL', 72124, 2512200, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8995, 10759, 'CARTORIO NOTARIAL E REGISTRAL DA COMARCA DE PRATA-PB', 71662, 2512200, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8996, 3960, 'CARTORIO DO REGISTRO CIVIL E DAS PESSOAS NATURAIS ', 71068, 2512200, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8997, 10760, 'CARTOTIO DO RESGISTRO DE DISTRIBUICAO EXTRSA JUDICIAL DA COMARCA DE PRINCESA ISABEL - PB', 72025, 2512309, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8998, 10761, '1º OFICIO DE REGISTRO DE IMOVEIS E TABELIONATO', 68692, 2512309, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (8999, 3961, 'CARTORIO DE REGISTRO CIVIL E PESSOAS NATURAIS DE PRINCESA ISABEL', 69963, 2512309, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9000, 10762, 'PRINCESA ISABEL - CARTORIO DE NOTAS E REGISTROS', 72520, 2512309, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9001, 3962, 'PUXINANA CARTORIO DO REGISTRO CIVILE NOTAS', 72538, 2512408, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9002, 11106, 'CARTORIO DO 1º OFICIO DE NOTAS DE SAO SEBASTIAO DO PARAISO', 40907, 3164704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9003, 3516, 'CARTORIO REGISTRO CIVIL E NOTAS, INTERDICAO E TUTELA', 44768, 3164803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9004, 3517, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36939, 3164902, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9005, 2703, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 46805, 3165206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9006, 3519, 'CARTORIO DE PAZ E NOTAS', 34330, 3165008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9007, 3518, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E INTERDICOES E TUTELAS', 51029, 3165008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9008, 11107, 'SERVICO DE REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE SAO TOMAS DE AQUINO', 153460, 3165107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9009, 11108, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54460, 3165107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9010, 11109, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48520, 3165107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9011, 11110, 'OFICIO DO REGISTRO DE IMOVEIS ', 53868, 3165107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9012, 7039, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53314, 3165305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9013, 2704, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE SAPUCAI-MIRIM', 36525, 3165404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9014, 2578, 'SERVICO REGISTRAL E NOTARIAL DE SARDOA', 59717, 3165503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9015, 2705, 'CARTORIO REGISTRO CIVIL E TABELIONATO DE SARZEDO', 44826, 3165537, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9016, 11111, 'OFICIO DO 1ºTABELIONATO DE PROTESTO DE TITULOS', 49106, 3168408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9017, 11112, 'CARTORIO REGISTRO DE IMOVEIS', 44925, 3168408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9018, 11113, 'TABELIONATO DO 2º OFICIO DE NOTAS DA COMARCA DE TARUMIRIM MG', 45146, 3168408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9019, 11114, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54585, 3168408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9020, 11115, '2º TABELIONATO DE NOTAS', 32706, 3168507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9021, 11116, 'CARTORIO REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 45070, 3168507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9022, 11117, 'CARTORIO DE REGISTRO DE IMOVEIS DE TEIXEIRAS-MG', 39206, 3168507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9023, 11118, 'PRIMEIRO TABELIONATO DE NOTAS', 41855, 3168507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9024, 2716, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50344, 3168507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9025, 11119, '1º TABELIONATO DE PROTESTO', 32359, 3168507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9026, 11120, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48710, 3168606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9027, 11121, 'TABELIONATO DO 3º OFICIO DE NOTAS', 61275, 3168606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9028, 11122, 'TEOFILO OTONI CARTORIO 1º OFICIO', 61374, 3168606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9029, 6983, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53348, 3168606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9030, 11123, '´TEOFILO OTONI 2º OFICICO REGISTRO DE IMOVEIS', 61572, 3168606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9031, 7041, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE CRISPIM JAQUES', 34314, 3168606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9032, 11124, 'CARTORIO DO 2º OFICIO DE NOTAS DA COMARCA DE TEOFILO OTONI', 49361, 3168606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9033, 2717, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE MUCURI', 33449, 3168606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9034, 11125, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE PEDRO VERSIANI', 56358, 3168606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9035, 11126, 'CARTORIO DE REGISTRO TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 40105, 3168606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9036, 11127, 'TEOFILO OTONI CARTORIO DO 1 OFICIO DE IMOVEIS', 61382, 3168606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9037, 7042, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 46516, 3168606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9038, 3536, 'REGISTRO CIVIL DA PESSOAS NATURAIS DE TOPAZIO', 55624, 3168606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9039, 2718, 'CARTORIO REGISTRO CIVIL E TABELIONATO DE NOTAS', 44800, 3168705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9040, 11128, 'CARTORIO DE REGISTRO DE IMOVEIS DE TIMOTEO', 39214, 3168705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9041, 11129, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39644, 3168705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9042, 2066, 'CARTORIO DE PAZ E NOTAS DO DISTRITO DE AGUAS DE CONTENDAS', 34439, 3117702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9043, 11397, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48686, 3117702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9044, 1913, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52472, 3117801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9045, 2067, 'CARTORIO REGISTRO CIVIL E NOTAS DE CONEGO MARINHO', 44719, 3117836, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9046, 7437, 'REGISTRO CIVIL DAS PESSOAS NATURAIS ', 55830, 3117876, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9047, 2068, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52530, 3117900, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9048, 6893, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 37119, 3118007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9049, 11398, 'OFICIO DO 1º TEBELIONATO DE PROTESTO DE TITULOS', 49064, 3118007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9050, 11399, 'CARTORIO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 40337, 3118007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9051, 11400, 'CONGONHAS CARTORIO SEGUNDO OFICIO DE NOTAS ', 45385, 3118007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9052, 11401, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48462, 3128105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9053, 2940, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52480, 3128105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9054, 11402, 'GUAPE REGISTRO DE IMOVEIS', 45583, 3128105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9055, 11403, 'CARTORIO DE NOTA 1º OFICIO', 33951, 3128105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9056, 11404, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49387, 3128105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9057, 11405, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54254, 3128105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9058, 2942, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52043, 3128204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9059, 6640, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO E NOTAS', 38356, 3128253, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9060, 11406, '1º TABELIONATO DE NOTAS DE GUARANESIA-MG', 32318, 3128303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9061, 11407, 'TABELIONATO DE PROTESTO DE TITULOS', 60285, 3128303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9062, 11408, 'CARTORIO DE REGISTRO DE IMOVEIS DA COMARCA DE GUARANESIA', 38984, 3128303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9063, 11409, '2º TABELIONATO DE NOTAS', 32615, 3128303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9064, 2943, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42101, 3128303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9065, 11410, 'SERVICO REGISTRAL DE TITULOS E DOCUMENTOS E SERVICO REGISTRAL CIVIL DAS PESSOAS JURIDICAS', 59659, 3128303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9066, 2944, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS ETABELIONATO DE NOTAS', 37721, 3128303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9067, 11411, 'CARTORIO DE PROTESTOS DE TITULOS DE GUARANI/MG', 47654, 3128402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9068, 11412, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 47423, 3128402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9069, 11413, 'CARTORIO DE REGISTRO DE IMOVEIS', 38729, 3128402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9070, 11414, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49312, 3128402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9071, 11415, 'OFICIO DO 1 TABELIONATO DE NOTAS', 47613, 3128402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9072, 2945, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES E TUTELAS ', 42366, 3128402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9073, 11416, 'CARTORIO DE REGISTRO DE IMOVEIS', 38836, 3128501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9074, 11417, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39636, 3128501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9075, 2946, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35709, 3128501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9076, 7454, 'OFICIO DO REGISTRO CIVIL DE GUARARA COM ATRIBUICAO DE NOTAS', 152645, 3128501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9077, 11418, 'CARTORIO DO PRIMEIRO OFICIO DE NOTAS', 41863, 3128501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9078, 11419, 'CARTORIO DE PROTESTO DE TITULOS', 34884, 3128501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9079, 2746, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52365, 3128600, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9080, 11420, '2º SERVICO NOTARIAL DE GUAXUPE', 32623, 3128709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9081, 11421, '1º TABELIONATO DE NOTAS DE GUAXUPE', 32326, 3128709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9082, 11422, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 47522, 3128709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9083, 2747, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS', 59238, 3128709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9084, 7347, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 71191, 2503555, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9085, 3833, 'CARTORIO DE REGISTRO CIVIL ISMAEL DA COSTA, COMARCA DE CAICARA PB', 70011, 2503605, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9086, 10391, 'CARTORIO EXTRAJUDICIAL DO 1º OFICIO', 71449, 2503605, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9087, 10392, 'CARTORIO EXTRAJUDICIAL DE DISTRIBUICAO', 71431, 2503605, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9088, 10393, '2º OFICIO DE NOTAS DE CAICARA-PB', 71597, 2503605, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9089, 10394, 'SERVICO NOTARIAL E REGISTRAL DE CAJAZEIRAS - CARTORIO ANTONIO HOLANDA', 69229, 2503704, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9090, 10395, 'CARTORIO DE NOTAS DE CAJAZEIRAS', 154211, 2503704, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9091, 3834, '1º CARTORIO DE REGISTRO CIVIL DE CAJAZEIRAS', 68650, 2503704, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9092, 7348, 'CARTORIO DO 1º OFICIO DE CAJAZEIRAS-', 70177, 2503704, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9093, 3835, 'CARTORIO DISTRITAL DE ENGENHEIRO AVIDOS', 70268, 2503704, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9094, 10396, 'REGISTRO DE DISTRIBUICAO EXTRA JUDICIAL', 72587, 2503704, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9095, 3836, 'CARTORIO DE REGISTRO CIVIL OBITOS E NOTAS ', 70037, 2503753, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9096, 10397, 'CARTORIO PAIVA RANGEL', 71696, 2503803, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9097, 10398, 'CARTORIO UNICO LEONIE LOBO', 77008, 2601003, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9098, 4017, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS LEONIE LOBO', 74575, 2601003, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9099, 4018, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 77768, 2601052, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9100, 4020, 'REGISTRO CIVIL DE MORAES', 77420, 2601102, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9101, 4019, 'CARTORIO JOAO GOMES DE ANDRADE ', 74245, 2601102, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9102, 10399, 'CARTORIO DE NOTAS E PROTESTO DE TITULOS', 73999, 2601102, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9103, 7086, 'CARTORIO DE REGISTRO CIVIL DE NASCENTE', 74500, 2601102, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9104, 10400, 'CARTORIO DO 1.º OFICIO', 74781, 2601102, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9105, 4021, 'CARTORIO DO REFGISTRO CIVIL ', 75093, 2601201, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9106, 10401, 'ARCOVERDE CARTORIO 1º OFICIO DE NOTAS ', 73809, 2601201, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9107, 10402, '2º TABELIONATO DE NOTAS E PROTESTOS', 73676, 2601201, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9108, 10403, 'CARTORIO DO OFICIO UNICO DE IMOVEIS, TITULOS E DOCUMENTOS', 73445, 2601300, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9109, 4022, 'CARTORIO DO REGISTRO CIVIL', 75267, 2601300, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9110, 10404, 'CARTORIO DO SEGUNDO OFICIO', 76372, 2601409, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9111, 10405, 'CARTORIO DO PRIMEIRO OFICIO', 75085, 2601409, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9112, 4023, 'CARTORIO DO REGISTRO CIVIL', 75150, 2601409, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9113, 10406, 'CARTORIO DO OFICIO UNICO DE BELEM DE MARIA-PE', 75044, 2601508, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9114, 4024, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75556, 2601508, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9115, 4025, 'CARTORIO DO REGISTRO CIVIL', 75200, 2601607, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9116, 10407, 'BELEM DE SAO FRANCISCO CARTORIO DE OFICIO UNICO', 73817, 2601607, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9117, 7087, 'CARTORIO DO REGISTRO CIVIL', 75184, 2601706, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9118, 10408, 'CARTORIOTABELIONATO, REGISTRO GERAL DE IMOVEIS, TITULO E DOCUMENTOS E PESSOAS JURIDICAS', 77057, 2601706, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9119, 10409, '2º OFICIO DA COMARCA DE BELO JARDIM', 131425, 2601706, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9120, 4026, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 77321, 2601706, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9121, 4027, 'CARTORIO AMADO AGRA DE ARAUJO', 73957, 2601706, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9122, 4028, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 75812, 2601805, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9123, 10410, 'CARTORIO DE TABELIONATO E DE REGISTRO', 75820, 2601805, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9124, 10411, 'CARTORIO DO 1 OFICIO DA COMARCA DE BEZERROS', 74856, 2601904, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9125, 4030, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 74690, 2601904, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9126, 10412, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 77727, 2601904, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9127, 4029, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE BEZERROS', 75655, 2601904, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9128, 10413, 'SERVICO UNICO DE IMOVEIS, NOTAS E ANEXOS', 77701, 2602001, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9129, 4031, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 2º DISTRITO DE CLARANA COMARCA DE BODOCO/PERNAMBUCO', 77370, 2602001, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9130, 6663, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE FEITORIA', 75671, 2602001, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9131, 4032, 'SERVICO DO REGISTRO CIVIL DE BODOCO', 77511, 2602001, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9132, 4034, 'CARTORIO REGISTRO CIVIL PESSOAS NATURAIS - BOM CONSELHO - PE', 76729, 2602100, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9133, 7045, 'CARTORIO REGISTRO CIVIL E NOTAS', 44578, 3171600, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9134, 3571, 'VIRGINIA CARTORIO DO REGISTRO CIVIL E NOTAS', 61556, 3171709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9135, 10414, 'CARTORIO DO SEGUNDO OFICIO DE NOTAS', 43752, 3171808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9136, 2559, 'CARTORIO DO UNICO OFICIO DE LIMOEIRO DO AJURU', 67223, 1504000, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9137, 2560, 'CARTORIO VIVI CORDEIRO', 68379, 1504059, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9138, 2561, 'CARTORIO BOTELHO - REGISTRO CIVIL DO UNICO OFICIO DA VILA DE CAFEZAL - MAGALHAES BARATA', 65847, 1504109, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9139, 2562, 'CARTORIO COSTA BORGES - REGISTRO CIVIL DO TERMO DE MAGALHAES BARATA', 65912, 1504109, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9140, 2563, 'CARTORIO DO OFICIO UNICO DO DISTRITO DE MORADA NOVA - MARABA', 129650, 1504208, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9141, 10694, 'CARTORIO DO 1º OFICIO - MARABA', 129635, 1504208, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9142, 2564, 'CARTORIO 2 OFICIO DE MARABA', 65680, 1504208, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9143, 2565, 'CARTORIO DE REGISTRO CIVIL SAO BENEDITO', 66464, 1504307, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9144, 2567, 'CARTORIO DO UNICO OFICIO OACIR FERREIRA', 67546, 1504307, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9145, 2566, 'CARTORIO DE REGISTRO CIVIL SAO SEBASTIAO', 66480, 1504307, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9146, 2568, 'CARTORIO DO UNICO OFICIO DA COMARCA DE MARAPANIM', 67090, 1504406, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9147, 3345, '1O. OFICIO DE TABELIONATO DE NOTAS, TABELIONATO DE PROTESTO DE TITULOS E REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO MUNICIPIO DE MARITUBA', 140178, 1504422, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9148, 10695, '2º OFICIO - CARTORIO FELIPETTO MALTA', 65615, 1504422, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9149, 3346, 'CARTORIO DO UNICO OFICIO DE MEDICILANDIA', 67249, 1504455, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9150, 3347, 'CARTORIO DO UNICO OFICIO DE MELGACO', 67256, 1504505, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9151, 3349, 'CARTORIO DO UNICO OFICIO DE SAO PEDRO DO VIZEU - VILA VIZANIA 0 MOCAJUBA', 67413, 1504604, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9152, 3348, 'CARTORIO GONCALVES - MOCAJUBA', 67728, 1504604, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9153, 3351, 'CARTORIO CAIRARI - COMARCA DE MOJU', 65862, 1504703, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9154, 3350, 'CARTORIO SANTOS', 68171, 1504703, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9155, 10696, 'CARTORIO DO 1º OFICIO DE TABELIONATO DE NOTAS E REGISTRO DE IMOVEIS DO MUNICIPIO DE MONTE ALEGRE', 67835, 1504802, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9156, 3352, 'CARTORIO DO 2. OFICIO DE TAB PROT, REG TIT DOC E CIV P JURID, E REG CIV P NATURAIS E INTERD TUTELAS DO MUNICIPIO DE MONTE ALEGRE', 65797, 1504802, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9157, 3353, 'CARTORIO DO 3ºSUBDISRITO DO RIO ATUA', 66878, 1504901, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9158, 3356, 'CARTORIO DO UNICO OFICIO DO RIO ANAJAS', 67488, 1504901, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9159, 10697, 'CARTORIO DO 1OFICIO DA COMARCA DE MUANA', 66654, 1504901, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9160, 3355, 'CARTORIO DA 2A. ZONA DE SAO MIGUEL DO PRACUUBA ', 65938, 1504901, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9161, 3357, 'CARTORIO DO 2º OFICIO DA COMARCA DE MUANA ', 66803, 1504901, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9162, 4150, 'CARTORIO DO REGISTRO CIVIL DE SOCORRO', 70979, 2510402, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9163, 3938, 'CARTORIO DO REGISTRO CIVIL DE OLHO D`AGUA', 70870, 2510402, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9164, 4151, 'OLIVEDOS CARTORIO DO REGISTRO CIVIL', 72462, 2510501, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9165, 6657, 'CARTTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 72033, 2510600, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9166, 3939, 'CARTORIO AIRES CALUETE', 69195, 2510659, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9167, 3940, 'CARTORIO UNICO DE PASSAGEM', 71894, 2510709, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9168, 10698, 'PATOS CARTORIO 3º OFICIO', 72488, 2510808, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9169, 3026, '2º OFICIO DE NOTAS E REGISTROS BEZERRA FALCAO', 65623, 1500800, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9170, 10763, 'CARTORIO DO UNICO OFICIO DA COMARCA DE QUEIMADAS - PARAIBA', 71373, 2512507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9171, 10764, 'OFICIO DE REGISTRO E DISTRIBUICAO DA SERVENTIA EXTRAJUDICIAL', 145284, 2512507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9172, 3963, 'CARTORIO DO REGISTRO CIVIL DA PESSOAS NATURAIS', 71316, 2512507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9173, 3964, 'CARTORIO CIVIL DE QUIXABA', 69294, 2512606, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9174, 10765, 'CARTORIO DE DIST.EXTRAJUDICIAL REMIGIO', 69336, 2512705, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9175, 10766, 'REMIGIO CARTORIO DE TITULOS E DOCUMENTOS', 72595, 2512705, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9176, 3965, 'CARTORIO DE REGISTRO CIVIL DE REMIGIO', 69831, 2512705, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9177, 3966, 'CARTORIO DO REGISTRO CIVIL DE RIACHAO', 70938, 2512747, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9178, 4152, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 71118, 2512747, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9179, 4153, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE RIACHAO DO POCO', 69997, 2512762, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9180, 4154, 'CARTORIO DE REGISTRO CIVIL DE RIACHO DE SANTO ANTONIO-PB', 69849, 2512788, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9181, 4155, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 71092, 2512804, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9182, 10767, 'CARTORIO PIMENTL - SERVICO NOTARIAL E REGISTRAL - OFICIO UNICO', 71720, 2512903, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9183, 10768, 'OFICIO DO REGISTRO DE DISTRIBUICAO EXTRA JUDICIAL', 72454, 2512903, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9184, 4157, 'CARTORIO DISTRITAL DO REGISTRO CIVIL', 70383, 2512903, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9185, 3967, 'CARTORIO DISTRITAL DE BARRA DE MAMANGUAPE', 70219, 2512903, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9186, 10769, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42267, 3124401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9187, 1945, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS - DISTRITO DE PANTANO DOS ROSAS', 140905, 3124500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9188, 1944, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE ESTIVA', 52027, 3124500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9189, 1947, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE AGUA VIVA', 43711, 3124609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9190, 1946, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE ESTRELA DALVA', 46748, 3124609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9191, 1949, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS ', 51755, 3124708, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9192, 1948, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE BAU', 51714, 3124708, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9193, 1950, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE ESTRELA DO SUL', 55962, 3124807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9194, 10770, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48736, 3124807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9195, 6960, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTA RITA DA ESTRELA', 34199, 3124807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9196, 10771, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 38471, 3124807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9197, 1951, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CHAPADA DE MINAS', 34249, 3124807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9198, 10772, 'CARTORIO DE REGISTRO DE IMOVEIS', 38489, 3124807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9199, 10773, 'CARTORIO DO 2º OFICIO DE NOTAS', 41392, 3124807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9200, 10774, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48389, 3124807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9201, 10775, 'CARTORIO DE REGISTRO DE IMOVEIS DE EUGENOPOLIS', 44958, 3124906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9202, 1955, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 45187, 3124906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9203, 10776, 'CARTORIO REGISTRO DE PROTESTOS', 45021, 3124906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9204, 1952, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE GAVIAO', 51904, 3124906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9205, 1954, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE PINHOTIBA', 43026, 3124906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9206, 10777, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 57638, 3124906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9207, 1953, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36624, 3124906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9208, 10778, 'CARTORIO DO PRIMEIRO OFICIO', 41764, 3124906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9209, 10779, 'CARTORIO DO 2 OFICO', 41061, 3124906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9210, 1956, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE EWBANK DA CAMARA', 43265, 3125002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9211, 10780, 'OFICIO DO 2° TABELIONATO DE NOTAS', 49205, 3125101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9212, 10781, 'SERVICO REGISTRAL IMOBILIARIO DA COMARCA DE EXTREMA', 59758, 3125101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9213, 10782, 'SERVICO DE PROTESTO', 58362, 3125101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9214, 10783, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48314, 3125101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9215, 1957, 'SERVICO DE REISTRO CIVIL DAS PESSOAS NATURAIS', 58669, 3125101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9216, 10784, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 57414, 3125101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9217, 10785, 'ITURAMA CARTORIO DE REGISTROS DE TITULOS E DOCUMENTOS', 45807, 3134400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9218, 2530, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE TIROS', 35295, 3168903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9219, 11136, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS', 57539, 3168903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9220, 11137, 'SEGUNDO TABELIONATO DE NOTAS', 58065, 3168903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9221, 3539, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 37762, 3169000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9222, 3540, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 51078, 3169059, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9223, 2719, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 61465, 3169109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9224, 11138, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 40329, 3169208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9225, 11139, 'CARTORIO DE REGISTRO DE IMOVEIS', 38604, 3169208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9226, 11140, 'CARTORIO DO TABELIONATO DO 2° OFICIO DE NOTAS', 43851, 3169208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9227, 11141, 'CARTORIO DO 1° OFICIO DE NOTAS', 40410, 3169208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9228, 11142, 'CARTORIO DO TABELIONATO DE PROTESTOS E TITULOS', 43844, 3169208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9229, 2720, 'CRTORIO REGISTRO CIVIL E NOTAS', 45443, 3169208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9230, 2591, 'CARTORIO DE REGISTRO CIVIL, INTERDICOES E TUTELAS', 34520, 3169208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9231, 11143, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48090, 3169307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9232, 11144, 'OFICIO DE REGISTRO DE IMOVEIS', 47324, 3169307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9233, 11145, 'TABELIONATO DE PROTESTOS', 60780, 3169307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9234, 11146, 'SERVICO REGISTRAL DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 59584, 3169307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9235, 2592, 'SERVICO DE REGISTRO CIVIL DE TRES CORACOES', 58446, 3169307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9236, 11147, 'TABELIONATO DO 2º OFICIO DE NOTAS', 61218, 3169307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9237, 11148, 'OFICIO DO 2º TABELIONATO DO NOTAS DE TRES MARIAS', 49544, 3169356, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9238, 11149, 'CARTORIO DE PROTESTO DE TITULOS DA COMARCA DE TRES MARIAS/MG', 34975, 3169356, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9239, 2593, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 46532, 3169356, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9240, 11150, 'CARTORIO DO 1º OFICIO DE NOTAS', 40535, 3169356, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9241, 11151, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 152793, 3169356, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9242, 11152, 'SERVICO DE REGISTRO DE IMOVEIS DA COMARCA DE TRES MARIAS', 58594, 3169356, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9243, 2531, 'CARTORIO DO REGISTRO CIVIL', 42028, 3169356, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9244, 3541, 'SOTER EUGENIO RABELLO', 59923, 3169406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9245, 11153, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49858, 3169406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9246, 11154, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48538, 3169406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9247, 11155, 'TRES PONTAS CARTORIO DE REGISTRO DE IMOVEIS', 61473, 3169406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9248, 11156, 'OFICIO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54940, 3169406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9249, 11157, 'SERVICO NOTARIAL DO 1º OFICIO', 58883, 3169406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9250, 3542, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PONTALETE', 44669, 3169406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9251, 3543, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE TUMIRITINGA', 43067, 3169505, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9252, 10712, 'SERVICO DE DISTRIBUICAO EXTRAJUDICIAL DE PILAR', 72827, 2511509, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9253, 2721, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO GERALDO DE TUMIRITINGA', 45153, 3169505, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9254, 11158, 'PRIMEIRO TABELIONATO DE NOTAS', 55368, 3169604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9255, 11159, 'OFICIO DO REGISTRO DE IMOVEIS', 53850, 3169604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9256, 11160, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49577, 3169604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9257, 11161, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 152801, 3169604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9258, 3520, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 138594, 3165560, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9259, 2706, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 37747, 3165578, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9260, 2707, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 43281, 3165602, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9261, 11162, 'CARTORIO DO 2.º OFICO DE NOTAS', 41111, 3165701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9262, 11163, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54247, 3165701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9263, 2753, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS MAGALHAES SOUSA', 56549, 3138625, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9264, 2173, 'CARTORIO DE REGISTROS CIVIL E NOTAS', 40113, 3138658, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9265, 2754, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE UMBUZEIRO', 34694, 3138658, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9266, 2755, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS LUISBURGO', 44479, 3138674, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9267, 2312, 'CARTORIO REGISTRO CIVIL E NOTAS DE LUISLANDIA', 44727, 3138682, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9268, 2174, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 46987, 3138708, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9269, 2175, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 36095, 3138807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9270, 11435, '2° TABELIONATO DE NOTAS', 32474, 3138807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9271, 11436, 'OFICIO DO REGISTRO DE IMOVEIS', 54064, 3138807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9272, 11437, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 152686, 3138807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9273, 2756, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ESTEIOS', 36285, 3138807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9274, 11438, '1º TABELIONATO DE NOTAS', 33845, 3138807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9275, 11439, 'REGISTRO DE TITULOS E DOCUMENTOS', 57349, 3138807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9276, 7451, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE NOTAS DE POCOES DE PAINEIRAS', 146175, 3146404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9277, 11440, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48504, 3146503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9278, 2863, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE VILA COSTINA', 37630, 3146503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9279, 11441, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49783, 3146503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9280, 11442, 'REGISTRO DE TITULOS E DOCUMENTOS  E CIVIL DAS PESSOAS JURIDICAS', 57356, 3146503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9281, 11443, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48074, 3146503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9282, 10415, 'CARTORIO DE PROTESTO', 34777, 3171808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9283, 10416, 'CARTORIO DO 1º OFICIO DE NOTAS DE VIRGINOPOLIS', 40915, 3171808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9284, 10417, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVISDAS PESSOAS JURIDICAS', 39834, 3171808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9285, 10418, 'CARTORIO DE REGISTRO DE IMOVEIS', 38497, 3171808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9286, 3572, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35840, 3171808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9287, 10419, 'CARTORIO REGISTRO CIVIL E NOTAS', 44644, 3171907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9288, 3573, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52860, 3171907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9289, 10420, 'OFICIO DO REGISTRO DE IMOVEIS', 53983, 3172004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9290, 10421, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54494, 3172004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9291, 3574, 'OFICIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE VISCONDE DO RIO BRANCO', 46631, 3172004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9292, 10422, 'OFICIO DO 1° TABELIONATO DE NOTAS', 47738, 3172004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9293, 10423, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49452, 3172004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9294, 10424, 'TABELIONATO DE PROTESTO DE TITULOS', 60277, 3172004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9295, 3575, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE VOLTA GRANDE', 52910, 3172103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9296, 2534, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 43166, 3172202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9297, 7046, 'CARTORIO DO 2º OFICIO SERVICO NOTARIAL E DE REGISTRO CIVIL', 62505, 5000203, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9298, 10425, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 62877, 5000203, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9299, 3576, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE ALCINOPOLIS', 62216, 5000252, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9300, 2603, '2.º SERVICO NOTARIAL E DE REGISTRO CIVIL', 61937, 5000609, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9301, 10426, '1° SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 61945, 5000609, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9302, 10427, 'SERVICO DE REGISTRO DE IMOVEIS , TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 149328, 5000708, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9303, 3577, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 62828, 5000708, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9304, 7340, 'SERVICO NOTARIAL E REGISTRO CIVIL DAS PESSOAS NATURAIS DE VILA QUEBRACHO', 144683, 5000807, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9305, 3578, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 62711, 5000807, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9306, 10428, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 62752, 5000807, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9307, 3579, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 63099, 5000856, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9308, 6989, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE IPEZAL', 62125, 5000856, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9309, 10429, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICA E TABELIONATO DE PROTESTO ', 62257, 5000856, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9310, 3580, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE ANTONIO JOAO MS', 62133, 5000906, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9311, 3581, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 63248, 5001003, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9312, 10430, 'SERVICO DE REGISTROS DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTOS', 62729, 5001003, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9313, 2991, 'CARTORIO 2º OFICIO DE TAPURAH', 63958, 5108006, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9314, 10431, '1º OFICIO DE REGISTRO DE IMOVEIS E RTD DA COMARCA DE TAPURAH-MT', 136952, 5108006, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9315, 10432, 'REGISTRO DE IMOVEIS E TITULOS E DOCUMENTOS DE TERRA NOVA DO NORTE', 65078, 5108055, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9316, 7058, 'SEGUNDO SERVICO NOTARIAL E REGISTRAL', 65565, 5108055, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9317, 2992, 'CGJ/MT_1 DILENE PEREIRA AYRES', 64832, 5108105, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9318, 2993, 'SERVICO NOTARIAL E REGISTRO CIVIL', 65383, 5108204, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9319, 2994, 'CGJ/MT_1SERVICO NOTARIAL E REGISTRAL UNIAO DO SUL', 64931, 5108303, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9320, 2997, 'CGJ/MT_1 SERVICO NOTARIAL E REGISTRAL DISTRITO DE BOM SUCESSO', 64899, 5108402, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9321, 2996, 'SERVICO REGISTRAL E NOTARIAL DO DISTRITO DO CRISTO REI', 65458, 5108402, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9322, 2995, 'SEGUNDO SERVICO NOTARIAL E DE REGISTRO', 65136, 5108402, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9323, 2998, 'SERVICO NOTARIAL E REGISTRAL DO DISTRITO DE CAPAO GRANDE', 65367, 5108402, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9324, 10433, '1º SERVICO NOTARIAL E DE REGISTROS DE VARZEA GRANDE-MT', 63446, 5108402, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9325, 7010, '2º OFICIO EXTRAJUDICIAL', 65508, 5108501, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9326, 3948, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 70730, 2511301, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9327, 10706, 'CARTORIO DE REGISTRO DE DISTRIBUICAO ', 70078, 2511301, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9328, 10707, 'CARTORIO DO 1º OFICIO DE NOTAS, REGISTROS DE IMOVEIS E HIPOTECAS', 70474, 2511301, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9329, 10708, 'REGISTRO CIVIL DO DISTRITO DE ITAJUBATIBA', 145326, 2511301, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9330, 10709, 'PICUI CARTORIO 1º OFICIO', 72504, 2511400, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9331, 6658, 'CARTORIO DO REGISTRO CIVIL ', 70706, 2511400, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9332, 10710, 'CARTORIO DE DISTRIBUICAO EXTRAJUDICIAL', 69476, 2511400, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9333, 10711, 'CARTORIO DO 2º OFICIO', 70508, 2511400, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9334, 3949, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS', 69815, 2511509, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9335, 10713, 'SERVICO NOTARIAL E REGISTRAL DE IMOVEIS E SEUS ANEXOS DA COMARCA DE PILAR-PB', 71407, 2511509, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9336, 3950, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 69732, 2511608, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9337, 10714, 'CARTORIO SALES DA SILVA', 71787, 2511608, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9338, 10715, 'SERVICO DE DISTRIBUICAO COMARCA DE PILOES - PB', 72744, 2511608, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9339, 3951, 'CARTORIO DISTRITAL DE NOTAS', 70292, 2511707, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9340, 10716, 'CARTORIO DO UNICO OFICIO DE NOTAS E REGISTRO DE IMOVEIS', 71381, 2511806, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9341, 10717, 'CARTORIO DE DISTRIBUICAO EXTRAJUDICIAL', 158, 2511806, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9342, 10718, 'CARTORIO UNICO OFICIO REGISTRO DE IMOVEIS', 77024, 2608206, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9343, 4109, 'CARTORIO DO REGISTRO CIVIL', 75283, 2608206, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9344, 4110, 'CARTORIO DO REGISTRO CIVIL TABELIONATO E NOTAS', 76315, 2608255, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9345, 4111, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75481, 2608305, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9346, 10719, 'CARTORIO DO UNICO OFICIO DE NOTAS E REGISTROS PUBLICOS DE JUPI - PE', 76471, 2608305, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9347, 4112, 'CARTORIO DO REGISTRO CIVIL', 75234, 2608404, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9348, 10720, 'CARTORIO UNICO', 152439, 2608404, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9349, 10721, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE SANTO ANTONIO DAS QUEIMADAS', 148239, 2608404, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9350, 4113, 'CARTORIO DE REGISTRO CIVIL DE LAGOA DO CARRO', 74492, 2608453, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9351, 6664, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 76208, 2608503, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9352, 4114, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE LAGOA DO OURO', 75713, 2608602, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9353, 4115, 'CARTORIO DO REGISTRO CIL E TABELIONATO DE IGAPO', 75135, 2608602, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9354, 10722, 'CARTORIO DE OFICIO UNICO ', 152413, 2608602, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9355, 10723, 'CARTORIO DO UNICO OFICIO', 76422, 2608701, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9356, 4117, 'CARTORIO  DE REGISTRO CIVIL E PESSOAS NATURAIS', 73874, 2608701, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9357, 4116, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 76216, 2608701, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9358, 10724, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 76190, 2608701, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9359, 4119, 'CARTORIO REGISTRO CIVIL DE JUTAI', 129775, 2608750, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9360, 4118, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATOS DE NOTAS DE LAGOA GRANDE', 75762, 2608750, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9361, 4120, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75440, 2608800, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9362, 10725, 'CARTORIO FERNANDES BARROS - UNICO OFICIO', 76497, 2608800, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9363, 10726, 'CARTORIO DE LIMOEIRO - PE - 2º OFICIO', 73981, 2608909, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9364, 10727, 'CARTORIO 1.º OFICIO', 73882, 2608909, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9365, 4121, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE URUCUBA', 74708, 2608909, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9366, 10728, '3º TABELIONATO DE NOTAS DE LIMOEIRO-PE', 73726, 2608909, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9367, 6665, 'CARTORIO DE REGISTRO CIVIL', 74138, 2608909, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9368, 10729, 'CARTORIO DO UNICO OFICIO', 76448, 2609006, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9369, 4122, 'CARTORIO DO REGISTRO CIVIL DE MACAPARANA', 75879, 2609006, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9370, 4123, 'CARTORIO UNICO', 76760, 2609105, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9371, 4124, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE MANARI', 76265, 2609154, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9372, 4200, 'CARTORIO DO REGISTRO CILVIL DE PESSOAS NATURAIS', 75143, 2609204, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9373, 10730, 'MARAIAL CARTORIO DO UNICO OFICIO DE NOTAS-TITULOS E DOCUMENTOS-PROTESTOS E REGISTRO DE IMOVEIS', 77131, 2609204, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9374, 4125, 'RCPN E TABELIONATO DE NOTAS DE SERTAOZINHO DE BAIXO', 77230, 2609204, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9375, 4201, 'CARTORIO DO REGISTRO CIVIL DE MIRANDIBA/PE', 75887, 2609303, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9376, 7036, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO DE NOTAS', 56226, 3162807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9377, 11060, 'CARTORIO TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 45260, 3162807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9378, 3502, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE TARUACU', 56770, 3162906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9379, 11061, 'OFICIO DO REGISTRO DE IMOVEIS DE SAO JOAO NEPOMUCENO', 43984, 3162906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9380, 3504, 'REGISTRO CIVIL DE PESSOAS NATURAIS DE ITUI', 56630, 3162906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9381, 11062, 'OFICIO DO 3º TABELIONATO DE NOTAS', 49965, 3167202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9382, 2587, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50716, 3167202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9383, 11063, 'CARTORIO 1º OFICIO REGISTRO DE IMOVEIS', 33597, 3167202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9384, 11064, 'TABELIONATO DE PROTESTO', 60095, 3167202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9385, 2586, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 34603, 3167202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9386, 11065, 'SERVICO NOTARIAL DO 2° OFICIO', 58933, 3167202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9387, 11066, 'CARTORIO FINCH', 43893, 3167202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9388, 11067, 'CARTORIO DO 1º OFICIO DE NOTAS', 40741, 3167202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9389, 2588, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS ', 52456, 3165552, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9390, 2589, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52076, 3167301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9391, 2528, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55806, 3167400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9392, 11068, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS DE SILVIANOPOLIS', 40964, 3167400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9393, 11069, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39503, 3167400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9394, 11070, 'CARTORIO DO 2º TABELIONATO DE NOTAS', 41616, 3167400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9395, 11071, 'SILVIANOPOLIS CARTORIO PRIMEIRO', 59907, 3167400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9396, 11072, 'CARTORIO DO REGISTO DE IMOVEIS', 41988, 3167400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9397, 3527, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51839, 3167509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9398, 6568, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE ALEGRIA, MUNICIPIO DE SIMONESIA-MG', 37291, 3167608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9399, 3528, 'SIMONESIA CARTORIO DE PAZ E NOTAS E DO REGISTRO CIVIL', 59915, 3167608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9400, 3529, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 51037, 3167707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9401, 3530, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE PLAUTINO SOARES', 59709, 3167707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9402, 3531, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE SOLEDADE DE MINAS', 42408, 3167806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9403, 3532, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35576, 3167905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9404, 3533, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 36046, 3168002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9405, 11073, 'CARTORIO DO 1º TABELIONATO DE NOTAS', 41004, 3168002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9406, 11074, 'CARTORIO DE TABELIONATO DE PROTESTO', 40162, 3168002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9407, 11075, 'CARTORIO 2º TABELIONATO DE NOTAS', 33704, 3168002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9408, 11076, 'OFICIO DE REGISTRO DE IMOVEIS DE TAIOBEIRAS', 44933, 3168002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9409, 11077, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS JURIDICAS E TITULOS E DOCUMENTOS', 35469, 3168002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9410, 3534, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE TAPARUBA', 596, 3168051, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9411, 3535, 'CARTORIO CIVIL E NOTAS', 33860, 3168101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9412, 11078, 'CARTORIO DE PAZ E NOTAS', 34322, 3168200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9413, 2713, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE TAQUARACU DE MINAS', 37598, 3168309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9414, 2529, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36707, 3168408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9415, 2715, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE VAI VOLTA', 38257, 3168408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9416, 2714, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50807, 3168408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9417, 11079, 'TABELIONATO DO 1°OFICIO DE NOTAS DE TARUMIRIM  ', 33464, 3168408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9418, 11080, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48561, 3162906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9419, 3503, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CARLOS ALVES', 53462, 3162906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9420, 11081, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 57448, 3162906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9421, 7345, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ROCA GRANDE', 43364, 3162906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9422, 11082, '1º TABELIONATO DE NOTAS', 32243, 3162906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9423, 3501, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56127, 3162906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9424, 3505, 'OFICIO DO REGISTRO CIVIL E TAB. DE NOTAS', 51284, 3162922, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9425, 4656, 'CARTORIO DO 1º OFICIO DE REGISTRO DE IMOVEIS E REGISTRO CIVIL DE SAO PEDRO', 78451, 2210508, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9426, 10076, 'CARTORIO DO 1º OFICIO E NOTAS', 78469, 2210607, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9427, 4326, 'CARTORIO DO 1º OFICIO', 78147, 2210706, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9428, 7282, 'CARTORIO DE REGISTRO CIVIL DE SIMPLICIO MENDES', 148684, 2210805, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9429, 10077, '1º CARTORIO DE REGISTRO DE IMOVEIS', 140731, 2210805, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9430, 10078, '1º CARTORIO DE REGISTRO DE IMOVEIS', 140749, 2210904, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9431, 4657, 'TERESINA 2º CARTORIO DO REGISTRO CIVIL', 79640, 2211001, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9432, 10079, 'TERESINA CARTORIO 1O OFICIO NOTAS E REGISTRO', 79657, 2211001, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9433, 10080, 'TERESINA CARTORIO 6 OFICIO DE NOTAS', 79681, 2211001, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9434, 10081, 'TERESINA CARTORIO DO 5 OFICIO DE NOTAS', 79699, 2211001, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9435, 4328, 'CARTORIO DO 1º OFICIO DO REGISTRO CIVIL DE PESSOAS NATURAIS - RCPN DA 1ª CIRCUNSCRICAO', 148064, 2211001, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9436, 10082, '2º OFICIO DE NOTAS E REGISTROS', 77842, 2211001, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9437, 10083, 'TERESINA CARTORIO 3º OFICIO DE NOTAS ', 79665, 2211001, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9438, 4327, 'CARTORIO DO 3º OFICIO DO REGISTRO CIVIL DE PESSOAS NATURAIS ', 78980, 2211001, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9439, 10084, 'TERESINA CARTORIO 4º OFICIO DE NOTAS E REGISTRO DE IMOVEIS', 79673, 2211001, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9440, 3709, 'CARTORIO MATHIAS QUARESMA', 79335, 2211100, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9441, 4658, 'CARTORIO JOAO ESTEVAM JUNIOR', 79285, 2211209, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9442, 4329, 'CARTORIO DO SEGUNDO OFICIO', 79202, 2211308, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9443, 3710, 'CARTORIO UNICO DE VARZEA GRANDE', 148833, 2211407, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9444, 4330, 'SERVICO DISTRITAL DE ABATIA', 129577, 4100103, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9445, 3711, 'SERVICO DISTRITAL DE ADRIANOPOLIS', 87510, 4100202, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9446, 4659, 'SERVICO DISTRITAL DE AGUDOS DO SUL', 88153, 4100301, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9447, 4660, 'SERVICO DISTRITAL DE TRANQUEIRA', 80663, 4100400, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9448, 10085, 'TABELIONATO DE PROTESTO DE TITULOS', 88104, 4100400, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9449, 10086, 'SERVICO DE REGISTRO DE IMOVEIS ', 85258, 4100400, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9450, 4661, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81786, 4100400, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9451, 10087, 'TABELIONATO DE NOTAS', 129973, 4100400, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9452, 3712, 'SERVICO DISTRITAL DE ALTAMIRA DO PARANA', 87205, 4100459, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9453, 4887, 'SERVICO DISTRITAL DE ALTO PARAISO', 86611, 4128625, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9454, 4662, 'SERVICO DE  REGISTRO CIVIL DAS PESSOAS NATURAIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84970, 4100608, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9455, 10088, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TEBELIONATO DE PROTESTO DE TITULOS', 87536, 4100608, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9456, 10089, 'SERVICO DE REGISTRO DE IMOVEIS', 85696, 4100608, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9457, 4663, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO PRECARIAMENTE O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O SERVICO DE REGISTRO DE TITULOS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84228, 4100707, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9458, 10090, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTOS DE TITULOS', 81125, 4100707, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9459, 10091, 'SERVICO DISTRITAL DE PAULISTANIA', 141333, 4100707, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9460, 10092, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 80697, 4100509, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9461, 4664, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO PRECARIAMENTE O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84921, 4100509, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9462, 10093, 'SERVICO DE REGISTRO DE IMOVEIS', 80689, 4100509, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9463, 3713, 'SERVICO DISTRITAL DE ALVORADA DO SUL', 80705, 4100806, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9464, 3621, 'SERVICO DISTRITAL DE AMAPORA', 87247, 4100905, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9465, 10094, 'SERVICO DE REGISTRO DE IMOVEIS', 154724, 4101002, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9466, 10095, 'SERVICO DE REGISTRO DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS ', 154708, 4101002, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9467, 3622, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS ', 84822, 4101002, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9468, 4665, 'SERVICO DISTRITAL DE ANAHY', 80713, 4101051, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9469, 10096, 'SERVICO DE REGISTRO DE IMOVEIS', 80721, 4101101, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9470, 10434, 'CARTORIO DO 1º OFICIO DA COMARCA DE VERA', 64238, 5108501, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9471, 2999, 'SEGUNDO SERVICO NOTARIAL E REGISTRAL', 65151, 5105507, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9472, 10435, 'CARTORIO DO 1º OFICIO', 64188, 5105507, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9473, 3001, 'RCPN - DISTRITO DE SANTA CRUZ DO XINGU - MAYSA NERY DE FIGUEIREDO', 136986, 5108600, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9474, 10436, '1º OFICIO REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS', 63362, 5108600, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9475, 3000, '2° TABELIONATO DE NOTAS E REGISTRO CIVIL', 63610, 5108600, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9476, 10437, 'CARTORIO PAZ E NOTAS DE SANTA CRUZ XINGU ', 147041, 5108600, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9477, 3006, 'CARTORIO DO 3º OFICIO J. FERREIRA - ABAETETUBA', 66860, 1500107, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9478, 7059, 'CARTORIO EXTRAJUDICIAL DE ZONA MAUBA', 67611, 1500107, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9479, 10438, 'CARTORIO A. MIRANDA - 1º OFICIO DE ABAETETUBA', 65722, 1500107, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9480, 3005, 'CARTORIO TEOBALDO MARTINS PIMENTEL', 68262, 1500107, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9481, 10439, 'CARTORIO O. COUTINHO', 67876, 1500107, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9482, 3002, 'CARTORIO DO 1º DISTRITO DE URUBUEUA', 66670, 1500107, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9483, 3003, 'CARTORIO RODRIGUES', 68106, 1500107, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9484, 3007, 'CARTORIO DO 5º SUBDISTRITO DO RIO TUCUMANDUBA', 66894, 1500107, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9485, 3008, 'CARTORIO EXTRAJUDICIAL DE RIO ARAPAPU', 67603, 1500107, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9486, 3004, 'CARTORIO DO UNICO OFICIO COLONIA DR. JOAO MIRANDA - ABAETETUBA', 67074, 1500107, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9487, 3009, 'CARTORIO DO UNICO OFICIO DE ABEL FIGUEIREDO', 67140, 1500131, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9488, 3013, 'CARTORIO DO UNICO OFICIO DO RIO ARAXITEUA - ACARA', 67496, 1500206, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9489, 3012, 'CARTORIO DE REGISTRO CIVIL DE GUAJARA-MIRI - ACARA', 66332, 1500206, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9490, 3011, 'CARTORIO LOBATO', 67801, 1500206, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9491, 3010, 'CARTORIO DO UNICO OFICIO DO DISTRITO DO RIO JARUPARITEUA - ACARA', 67470, 1500206, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9492, 3014, 'CARTORIO SANTA JULIA DO JURUPARY', 68130, 1500305, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9493, 3017, 'CARTORIO EXTRAJUDICIAL DO UNICO OFICIO DO DISTRITO DE BATURITE - AFUA', 66506, 1500305, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9494, 3018, 'CARTORIO DO UNICO OFICIO DE RIO BAIANO-AFUA', 68395, 1500305, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9495, 3016, 'CARTORIO DO BAIXO CHARAPUCU', 66910, 1500305, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9496, 3838, 'CARTORIO DISTRITAL DE PINDURAO', 70326, 2503902, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9497, 3837, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE CAMALAU', 69922, 2503902, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9498, 3841, 'CAMPINA GRANDE CARTORIO UNICO DE SAO JOSE DA MATA', 69088, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9499, 10440, 'CARTORIO IVANDRO CUNHA LIMA', 71548, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9500, 10441, '8º CARTORIO', 68908, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9501, 3843, 'CARTORIO DO REGISTRO CIVIL', 70557, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9502, 3840, 'CAMPINA GRANDE 2º CARTORIO DE REGISTRO CIVIL', 69054, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9503, 3839, 'GALANTE CARTORIO DE NOTAS E DOCUMENTOS', 72181, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9504, 10442, '9º OFICIO DE NOTAS DE CAMPINA GRANDE', 68924, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9505, 10443, 'FECHINE SERVICO NOTARIAL - 4º OFICIO', 72165, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9506, 10444, '7 CARTORIO DE OFICIO E NOTAS', 68874, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9507, 3845, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS - BODOCONGO', 72421, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9508, 3844, 'OFICIO DE REGISTRO E NOTAS', 72405, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9509, 10445, 'CAMPINA GRANDE CARTORIO DO 6º OFICIO', 69070, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9510, 7069, 'CARTORIO DE REGISTRO CIVIL DE JOSE PINHEIRO', 69773, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9511, 10446, 'CARTORIO DO 3.ºOFICIO DE NOTAS', 70540, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9512, 10447, 'REGINA FRANCA ISIDRO SERVICO NOTARIAL E REGISTRAL', 72546, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9513, 10448, 'CARTORIO DE REGISTRO E DISTRIBUICAO EXTRA JUDICIAL ', 70110, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9514, 10449, 'CAMPINA GRANDE CARTORIO DO 2.º OFICIO DE NOTAS', 69062, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9515, 3842, '1º CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 68668, 2504009, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9516, 3994, 'SERVICO REGISTRAL E NOTARIAL DE TACIMA', 73213, 2516409, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9517, 3846, 'CARTORIO DISTRITAL', 70201, 2504033, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9518, 3847, 'CARTORIO DE OFICIO E NOTAS', 69617, 2504033, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9519, 3848, 'CARTORIO CARMO SOUSA', 69278, 2504074, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9520, 3849, 'CARTORIO UNICO DE CARRAPATEIRA', 71845, 2504108, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9521, 3850, 'CARTORIO DE REGISTRO CIVIL', 69658, 2504157, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9522, 3852, 'CARTORIO DE REGISTRO CIVIL DE CATINGUEIRA', 711, 2504207, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9523, 3851, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE ITAJUBATIBA-CATINGUEIRA', 71050, 2504207, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9524, 10450, 'CARTORIO DO 1º OFICIO', 70458, 2504306, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9525, 10731, 'CARTORIO DE REGISTRO DE IMOVEIS', 74732, 2609303, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9526, 4202, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75507, 2614303, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9527, 6537, 'REGISTRO CIVIL DE CARIRIMIRIM', 77404, 2614303, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9528, 10732, 'CARTORIO 2O OFICIO DE NOTAS E REGISTROS ', 148247, 2609402, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9529, 7008, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 64519, 5100607, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9530, 10733, 'SERVICO REGISTRAL IMOBILIARIO E TIT E DOC DE ALTO TAQUARI MT', 65474, 5100607, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9531, 10734, 'CARTORIO DO 1º OFICIO', 65516, 5100805, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9532, 10735, '1º OFICIO - RI RTD', 134320, 5100805, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9533, 3159, '2º OFICIO DE REGISTRO CIVIL  DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DO MUNICIPIO DE APIACAS', 63636, 5100805, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9534, 3160, 'CGJ/MT_1 CARTORIO DE REGISTRO CIVIL', 64758, 5101001, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9535, 3161, 'CGJ/MT_1 CARTORIO REGISTRO CIVIL E TABELIONATO', 64824, 5101209, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9536, 3162, 'SEGUNDO SERVICO NOTARIAL E REGISTRAL', 65169, 5101258, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9537, 10736, '1º SERVICO REGISTRAL DA COMARCA DE ARAPUTANGA', 63503, 5101258, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9538, 3163, 'SEGUNDO SERVICO NOTARIAL E REGISTRAL', 65201, 5101308, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9539, 10737, 'CARTORIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS - 1º OFICIO', 63495, 5101308, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9540, 10738, 'CARTORIO DO 1º OFICIO DE ARIPUANA-MT - REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS', 64246, 5101407, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9541, 3164, '2° SERVICO NOTARIAL, REGISTRO CIVIL DAS PESSOAS NATURAIS E JURIDICAS E PROTESTO', 64097, 5101407, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9542, 10739, 'CARTORIO DE PAZ E NOTAS DE JOSELANDIA', 146951, 5101605, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9543, 3165, 'CGJ/MT_1 CARTORIO DE PAZ E NOTAS DE JOSELANDIA', 64659, 5101605, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9544, 7009, 'CGJ/MT_1 CARTORIO DE PAZ E NOTAS DE BARAO DE MELGACO', 64618, 5101605, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9545, 3167, 'CGJ/MT_1 CARTORIO DE PAZ DE LAVOURAS', 64592, 5101704, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9546, 3166, 'SEGUNDO SERVICO NOTARIAL E REGISTRAL', 65177, 5101704, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9547, 10740, '1º SERVICO NOTARIAL E REGISTRAL', 63461, 5101704, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9548, 3168, 'BARRA DO GARCAS CARTORIO 2° OFICIO', 63800, 5101803, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9549, 10741, 'CARTORIO DO 1º OFICIO DE BARRA DO GARCAS', 64253, 5101803, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9550, 3169, 'CARTORIO 2º OFICIO', 63826, 5101902, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9551, 10742, 'CARTORIO DO 1º OFICIO REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS', 64220, 5101902, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9552, 10743, 'CARTORIO DO 3º OFICIO DE CACERES/MT', 64444, 5102504, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9553, 10744, '1º OFICIO SERVICOS NOTARIAIS E REGISTRAIS', 63370, 5102504, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9554, 3170, 'CARTORIO DO 2º OFICIO (SEGUNDO SERVICO NOTARIAL E REGISTRAL DE CACERES-MT)', 65243, 5102504, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9555, 3171, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 64030, 5102603, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9556, 10745, 'SERVICO DE REGISTRO DE IMOVEIS E DE TITULOS E DOCUMETOS (1º OFICIO) DE CAMPINAPOLIS MT', 65300, 5102603, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9557, 3172, 'CAMPO NOVO DO PARECIS CARTORIO DO REGISTRO CIVIL E ANEXOS', 63818, 5102637, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9558, 10746, 'REG. IMOVEIS TIT. E DOC DA COMARCA DE CAMPO NOVO DO PARECIS', 65060, 5102637, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9559, 10747, '1º REGISTRO GERAL DE IMOVEIS TITULOS E DOCUMENTOS', 63388, 5102678, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9560, 7047, 'SEGUNDO SERVICO NOTARIAL E REGISTRAL NESKEN', 65268, 5102678, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9561, 10748, 'TABELIONATO DE NOTAS, REGISTRO CIVIL E ESCRIVANIA DE PAZ', 65540, 5102686, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9562, 3173, 'CARTORIO DO 2. OFICIO DE CANABRAVA DO NORTE', 64311, 5102694, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9563, 3174, '2º OFICIO NOTARIAL E REGISTRAL DE CANARANA', 63602, 5102702, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9564, 10749, 'SERVICO REGISTRAL IMOBILIARIO DE CANARANA (CARTORIO DO 1º OFICIO)  ', 65466, 5102702, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9565, 3354, 'CARTORIO DO 2º SUBDISTRITO DO RIO ATATA', 66837, 1504901, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9566, 3358, 'CARTORIO DO UNICO OFICIO DE NOVA IPIXUNA - ITUPIRANGA', 67272, 1504976, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9567, 3359, 'CARTORIO ABRAAO DO UNICO OFICIO', 65730, 1505007, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9568, 3360, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE VILA TIMBOTEUA', 66191, 1505007, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9569, 3361, 'CARTORIO DO UNICO OFICIO DE NOTAS E REGISTROS', 68619, 1505031, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9570, 3362, 'CARTORIO DO UNICO OFICIO REGISTRAL E NOTARIAL', 67553, 1505064, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9571, 10750, 'CARTORIO SANTA MARIA - 1º OFICIO', 65813, 1505106, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9572, 3364, 'CARTORIO ALMEIDA - UNICO OFICIO DE FLEXAL - 0BIDOS', 65748, 1505106, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9573, 10830, 'OFICIO DO 3º TABELIONATO DE NOTAS', 49999, 3152501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9574, 2363, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52712, 3152501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9575, 10831, 'CARTORIO DO 2º TABELIONATO DE NOTAS', 32714, 3152501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9576, 2365, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52407, 3152600, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9577, 6978, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 51086, 3152600, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9578, 10832, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 54577, 3152709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9579, 10833, 'SEGUNDO OFICIO DE NOTAS', 57950, 3152709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9580, 10834, 'OFICIO DO REGISTRO DE IMOVEIS', 54015, 3152709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9581, 10835, 'PRIMEIRO OFICIO DE NOTAS', 55285, 3152709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9582, 10836, '1º TABELIONATO DE PROTESTO DE TITULOS', 32375, 3152709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9583, 2366, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56077, 3152709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9584, 10837, 'TABELIONATO DE PROTESTO DE TITULOS', 60251, 3152808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9585, 10838, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 39891, 3152808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9586, 7460, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS ', 42614, 3152808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9587, 10839, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49668, 3152808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9588, 11191, 'CARTORIO 2º OFICIO DE NOTAS', 33613, 3114402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9589, 1901, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42176, 3114402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9590, 11192, 'CARTORIO DO 1º OFICIO NOTAS', 40980, 3114402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9591, 11193, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48694, 3114402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9592, 11194, 'CARTORIO DO REGISTRO DE IMOVEIS', 43489, 3114402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9593, 11195, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54437, 3114402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9594, 1902, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DO ITACI', 53728, 3114402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9595, 10198, '2º SERVICO DE REGISTRO DE IMOVEIS', 86140, 4106407, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9596, 11196, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 152512, 3114501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9597, 1903, 'OFICIO DO REGISTRO CIVIL E TABEIONATO DE NOTAS', 51318, 3114501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9598, 11197, 'OFICIO DO REGISTRO DE IMOVEIS', 152496, 3114501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9599, 11198, 'OFICIO DO TABELIONATO DE PROTESTO DE TITULOS', 152488, 3114501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9600, 11199, '2º TABELIONATO DE NOTAS DA COMARCA DE CARMOPOLIS DE MINAS', 153452, 3114501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9601, 11200, 'OFICIO DO 1º TABELIONATO DE NOTAS', 152470, 3114501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9602, 2901, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE FELIXLANDIA', 52167, 3125705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9603, 2234, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 51052, 3125804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9604, 2902, 'CARTORIO DE REGISTRO E NOTAS DE SENHORA DA PENHA', 422, 3125804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9605, 11201, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39537, 3125903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9606, 2236, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE FERROS', 56176, 3125903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9607, 2237, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE ESMERALDAS DE FERROS', 55590, 3125903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9608, 11202, '1º TABELIONATO DE PROTESTOS DE TITULOS', 32425, 3125903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9609, 2241, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE SANTA RITA DO RIO DE PEIXE', 37192, 3125903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9610, 11203, 'CARTORIO DO 2º OFICIO DE NOTAS', 41319, 3125903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9611, 2235, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE CUBAS', 38125, 3125903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9612, 2239, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SETE CACHOEIRAS', 56093, 3125903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9613, 11204, 'CARTORIO DO 1º OFICIO DE NOTAS', 40592, 3125903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9614, 11205, 'OFICIO DO REGISTRO DE IMOVEIS DE FERROS', 57216, 3125903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9615, 2240, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE BORBA GATO', 33183, 3125903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9616, 2238, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTO ANTONIO DA FORTALEZA', 55632, 3125903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9617, 2243, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE BOM JESUS DO MADEIRA', 51151, 3125952, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9618, 2242, 'OFICIO REGISTRO CIVIL E NOTAS DE FERVEDOURO', 54817, 3125952, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9619, 2244, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO PEDRO DO GLORIA', 37127, 3125952, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9620, 2903, 'FLORESTAL CARTORIO DE PAZ E DO REGISTRO CIVIL', 45559, 3126000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9621, 2245, 'CARTORIO DO REGISTRO CIVIL ', 42002, 3126109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9622, 11206, 'TABELIONATO PORTELA - 2º OFICIO DE NOTAS', 61333, 3126109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9623, 11207, 'CARTORIO DO PRIMEIRO OFICIO DE NOTAS', 41780, 3126109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9624, 11208, 'CARTORIO DE REGISTRO DE IMOVEIS DE FORMIGA/MG', 39099, 3126109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9625, 2246, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PONTEVILA', 56614, 3126109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9626, 11209, 'TABELIONATO DE REGISTRO DE PROTESTO DE TITULOS DA COMARCA DE FORMIGA/MG', 33944, 3126109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9627, 11210, 'REGISTRO CIVIL DAS PESSOAS NATURAIS ', 55954, 3126109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9628, 11211, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39578, 3126109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9629, 11212, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE BAIOES ', 53421, 3126109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9630, 2904, 'OFICIO DE REGISTRO CIVIL E NOTAS', 51235, 3126208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9631, 2905, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 37879, 3126307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9632, 2906, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE FORTUNA DE MINAS', 44180, 3126406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9633, 2907, 'CARTORIO DE REGISTRO CIVIL', 33993, 3126505, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9634, 11213, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54411, 3135803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9635, 3731, 'SERVICO  DISTRITAL   DE SAO LOURENCO', 85720, 4105508, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9636, 10178, '1º SERVICO DE REGISTRO DE IMOVEIS', 79913, 4105508, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9637, 10179, '1º TABELIONATO DE NOTAS - CLARICE HISSAKO MORI', 80002, 4105508, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9638, 10180, '2º SERVICO DE REGISTRO DE IMOVEIS', 85241, 4105508, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9639, 10181, 'CIANORTE - TABELIAO FLAVIO VIEIRA 2º OFICIO', 83063, 4105508, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9640, 4238, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E 3° TABELIONATO DE NOTAS', 87015, 4105508, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9641, 10182, 'SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 85324, 4105508, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9642, 4239, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 144741, 4105607, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9643, 10183, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87486, 4105607, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9644, 10184, 'SERVICO DE REGISTRO DE IMOVEIS', 81810, 4105607, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9645, 4240, 'SERVICO DISTRITAL DE SAO FRANCISCO DE SALLES', 130138, 4105706, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9646, 10185, 'TABELIONATO DE NOTAS', 87858, 4105706, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9647, 10186, 'TABELIONATO DE PROTESTO DE TITULOS', 130187, 4105706, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9648, 3732, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85969, 4105706, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9649, 10187, 'SERVICO DE REGISTRO DE IMOVEIS ', 81968, 4105805, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9650, 10188, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, AO 1º TABELIONATO DE PROTESTO DE TITULOS', 87734, 4105805, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9651, 3733, 'SERVICO DISTRITAL DE GUARAITUBA', 86769, 4105805, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9652, 4242, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 142166, 4105805, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9653, 4241, 'SERVICO DISTRITAL DE ROCA GRANDE', 82370, 4105805, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9654, 4243, 'ALTO ALEGRE, CARTORIO REGISTRO CIVIL E TABELIONATO DE NOTAS', 80671, 4105904, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9655, 10189, 'SERVICO DE REGISTRO DE IMOVEIS', 86025, 4105904, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9656, 10190, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS ', 83071, 4105904, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9657, 4244, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81778, 4105904, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9658, 10191, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 83089, 4106001, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9659, 4607, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO PRECARIAMENTE, O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 86165, 4106001, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9660, 4245, 'SERVICO DISTRITAL DE CONSELHEIRO MAIRINCK', 83097, 4106100, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9661, 4247, 'SERVICO DISTRITAL DE CATANDUVAS DO SUL ', 81554, 4106209, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9662, 4246, 'SERVICO DISTRITAL DE CONTENDA - PR', 86249, 4106209, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9663, 10192, 'CARTORIO DE REGISTRO DE IMOVEIS', 81877, 4106308, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9664, 4608, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85944, 4106308, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9665, 10193, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 83105, 4106308, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9666, 10194, 'TABELIONATO DE PROTESTOS, REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DE PESSOAS JURIDICAS', 88112, 4106407, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9667, 10195, '2º TABELIONATO DE NOTAS', 85589, 4106407, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9668, 10196, '1º TABELIONATO DE NOTAS', 84566, 4106407, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9669, 4248, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E 3º TABELIONATO DE NOTAS', 84772, 4106407, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9670, 10197, '1º SERVICO DE REGISTRO DE IMOVEIS', 86082, 4106407, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9671, 4609, 'SERVICO DISTRITAL DE CORONEL DOMINGOS SOARES', 137380, 4106456, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9672, 10199, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTOS DE TITULOS', 83121, 4106506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9673, 3595, '2º SERVICO NOTARIAL E DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 61812, 5002902, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9674, 10526, '1º SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 61614, 5002902, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9675, 3596, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 63016, 5002951, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9676, 10527, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 63123, 5002951, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9677, 3597, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE CORGUINHO', 63222, 5003108, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9678, 3598, 'SERVICO NOTARIAL E DE REGISTROCIVIL DE CORONEL SAPUCAIA-MS', 62984, 5003157, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9679, 10528, '4º SERVICO NOTARIAL E DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 61887, 5003207, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9680, 6995, '2º SERVICO NOTARIAL E DE REGISTRO CIVIL', 62042, 5003207, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9681, 10529, 'SERVICO DE REGISTRAL DE IMOBILIARIO DA 1ª CIRCUNSCRICAO', 62414, 5003207, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9682, 10530, '3 SERVICO NOTARIAL E TABELIONATO DE PROTESTO', 62455, 5003207, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9683, 10531, '5º SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS DA 2ª CIRCUNSCRICAO', 62471, 5003207, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9684, 10532, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 62265, 5003256, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9685, 3600, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE FIGUEIRAO', 62836, 5003256, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9686, 3599, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DAS PESSOAS NATURAIS ', 62562, 5003256, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9687, 10533, '1 SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS,E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATOS DE PROTESTOS', 62638, 5003306, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9688, 3601, '2º. SERVICO NOTARIAL E DE REGISTRO CIVIL', 62919, 5003306, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9689, 3602, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 62547, 5003454, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9690, 6996, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 61788, 5003454, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9691, 10534, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 62372, 5003454, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9692, 3603, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 62208, 5003488, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9693, 10535, 'SERVICO DE REGISTRO DE IMOVEIS, PROTESTO DE TITULOS CAMBIAIS, REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO DAS PESSOAS JURIDICAS ', 154351, 5003488, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9694, 3604, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE DOURADINA ', 62646, 5003504, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9695, 3606, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE VILA SAO PEDRO', 63206, 5003702, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9696, 10536, '4º SERVICO NOTARIAL E DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 62794, 5003702, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9697, 6997, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE PANAMBI', 63032, 5003702, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9698, 3605, 'SEGUNDO SERVICO NOTARIAL E DE REGISTRO CIVIL', 61796, 5003702, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9699, 10537, '1º SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS', 62661, 5003702, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9700, 10538, 'CARTORIO RIBAMAR SANTOS- 5º OFICIO DE NOTAS', 68098, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9701, 10539, 'QUARTO OFICIO DE NOTAS CARTORIO CONDURU', 68437, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9702, 10540, '2º OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS - CARTORIO VALLE CHERMONT', 65631, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9703, 10541, 'CARTORIO CHERMONT 1O. OFICIO DE NOTAS', 65870, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9704, 3049, 'CARTORIO GIVALDO ARAUJO', 66050, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9705, 10542, 'CARTORIO QUEIROZ SANTOS - 3º OFICIO DE NOTAS', 67967, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9706, 10543, 'CARTORIO DE REGISTRO DE IMOVEIS 1º OFICIO', 65888, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9707, 10544, 'CARTORIO DE PROTESTO VALE VEIGA 1º OFICIO', 66118, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9708, 10545, 'TABELIONATO DE PROTESTO II OF.MOURA PALHA', 68577, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9709, 6994, 'SERVENTIA NOTARIAL E DE REGISTRO CIVIL', 62141, 5002803, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9710, 10546, 'CARTORIO KOS MIRANDA 6º OFICIO DE NOTAS DE BELEM-PA', 67777, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9711, 10547, 'OFICIO DE NOTAS E REGISTRO DE CONTRATOS MARITIMOS - CARTORIO MARITIMO - TABELIAO MORAES', 68411, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9712, 3045, 'CARTORIO DO 3º OFICIO DE REGISTRO CIVIL', 66852, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9713, 3044, 'CART REG CIVIL NASC E OBITOS SEGUNDO OFICIO BELEM', 65656, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9714, 3043, 'CARTORIO PRIVATIVO DE CASAMENTOS 1 DISTRITO', 67934, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9715, 10840, '1º SERVICO NOTARIAL DE PRATA - MG', 32193, 3152808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9716, 2367, 'JARDINESIA CARTORIO REGISTRO CIVIL E NOTAS', 45831, 3152808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9717, 10841, 'SERVENTIA DE REGISTRO DE IMOVEIS DE PRATA', 58230, 3152808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9718, 7461, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL DE PATRIMONIO', 34348, 3152808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9719, 2368, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50781, 3152907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9720, 10842, 'REGISTRO DE IMOVEIS DA COMARCA DE PRATAPOLIS - MG', 57240, 3152907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9721, 10843, 'PRATAPOLIS CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 55244, 3152907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9722, 10844, '2º TABELIONATO DE NOTAS ', 153650, 3152907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9723, 10845, 'TABELIONATO DE PROTESTOS DE PRATAPOLIS', 60863, 3152907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9724, 10846, 'CARTORIO DE NOTAS', 33977, 3152907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9725, 2811, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PRATINHA', 52050, 3153004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9726, 7077, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE PRESIDENTE BERNARDES', 42440, 3153103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9727, 2812, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE PRESIDENTE JUSCELINO', 38091, 3153202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9728, 2813, 'OFICIO DO REGISTRO CIVIL E NOTAS', 34504, 3153301, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9729, 10847, 'CARTORIO DO 1 OFICIO - NOTAS', 40352, 3154309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9730, 10848, '1º OFICIO TABELIONATO DE PROTESTOS', 60798, 3154309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9731, 7030, 'SERVICO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS ', 58776, 3154309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9732, 10849, 'CARTORIO DE REGISTRO DE IMOVEIS DA COMARCA DE RESPLENDOR', 40089, 3154309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9733, 2895, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53249, 3154309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9734, 2896, 'SERVICO DO REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES E AUSENCIAS E ANEXOS', 58735, 3154309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9735, 2823, 'SERVICO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DE INDEPENDENCIA', 58727, 3154309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9736, 2894, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53256, 3154309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9737, 7031, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO', 42507, 3154309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9738, 10850, '2º TABELIONATO DE NOTAS E PROTESTO', 32748, 3154309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9739, 2897, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 56465, 3154408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9740, 2898, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 47068, 3154457, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9741, 2899, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE RIACHO DOS MACHADOS', 46433, 3154507, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9742, 10851, '1º OFICIO DE NOTAS DE RIBEIRAO DAS NEVES', 32094, 3154606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9743, 2900, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE JUSTINOPOLIS MG', 37432, 3154606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9744, 10852, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 43935, 3154606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9745, 2736, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35519, 3154606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9746, 10853, 'REGISTRO DE IMOVEIS DE RIBEIRAO DAS NEVES', 57281, 3154606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9747, 10854, 'CARTORIO DO 2º OFICIO DE NOTAS DE RIBEIRAO DAS NEVES', 41558, 3154606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9748, 10855, 'TABELIONATO DE PROTESTOS DA COMARCA DE RIBEIRAO DAS NEVES', 60814, 3154606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9749, 2737, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52647, 3154705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9750, 2738, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52415, 3154804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9751, 10856, 'SERVENTIA RIBEIRO - TABELIONATO DE NOTAS 2º OFICIO', 58347, 3154903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9752, 10857, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48595, 3154903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9753, 10858, 'OFICIO DO 1º TABELIONATO DE NOTAS', 46409, 3154903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9754, 10859, 'RIO CASCA CARTORIO DO REGISTRO DE IMOVEIS', 57760, 3154903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9755, 10860, 'CARTORIO DE REG TIT DOC PESSOAS JURID', 35121, 3154903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9756, 10861, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DO DISTRITO DE JURUMIRIM', 56382, 3154903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9757, 2739, 'SERVENTIA DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO MUNICIPIO DE RIO CASCA ', 58297, 3154903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9758, 2740, 'RIO DO PRADO CARTORIO DE PAZ E NOTAS', 57778, 3155108, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9759, 2741, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E NOTAS DE RIO DOCE', 36442, 3155009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9760, 10862, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 57406, 3155207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9761, 2908, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DO MUNICIPIO DE FRANCISCO DUMONT', 36301, 3126604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9762, 2909, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 36152, 3126703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9763, 2911, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 56317, 3126703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9764, 11214, 'OFICIO REGISTRO DE IMOVEIS', 54924, 3135803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9765, 2122, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50625, 3135803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9766, 11215, 'CARTORIO DO 1° OFICIO DE NOTAS', 40394, 3135803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9767, 11216, 'JEQUITINHONHA CARTORIO 2º OFICIO DE NOTAS', 45906, 3135803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9768, 11217, 'OFICIO DO 1° TABELIONATO DE PROTESTO DE TITULOS', 47795, 3135803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9769, 2280, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 43208, 3135803, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9770, 2123, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE JESUANIA', 46771, 3135902, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9771, 2125, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE JOAIMA', 43216, 3136009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9772, 2124, 'OFICIO DO REG. CIVIL E TABEL. DE NOTAS', 50203, 3136009, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9773, 6965, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE JOANESIA', 33225, 3136108, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9774, 11218, '1º OFICIO DE NOTAS', 32029, 3136207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9775, 11219, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE JOAO MONLEVADE-MG', 45096, 3136207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9776, 11220, 'REGISTRO DE IMOVEIS', 56994, 3136207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9777, 11221, 'SEGUNDO OFICIO DE NOTAS DE JOAO MONLEVADE', 57976, 3136207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9778, 2126, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 36053, 3136207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9779, 11222, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE JOAO MONLEVADE', 39727, 3136207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9780, 2128, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE LUISLANDIA DO OESTE', 44628, 3136306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9781, 2130, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE OLHOS-D AGUA DO OESTE', 47035, 3136306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9782, 11223, 'JOAO PINHEIRO CARTORIO DE REGISTRO DE IMOVEIS', 45914, 3136306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9783, 2131, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DE JOAO PINHEIRO-MG', 36061, 3136306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9784, 11224, 'TABELIONATO DE PROTESTO DE TITULOS', 60418, 3136306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9785, 11130, 'TABELIONATO DE PROTESTO DE TITULOS E DE DOCUMENTOS DE DIVIDA', 60657, 3168705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9786, 3537, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE TIMOTEO-MG', 56291, 3168705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9787, 11131, 'PRIMEIRO TABELIONATO DE NOTAS DE TIMOTEO', 32060, 3168705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9788, 11132, 'CARTORIO DO SEGUNDO OFICIO DE NOTAS', 43760, 3168705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9789, 3538, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL', 50377, 3168804, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9790, 11133, 'CARTORIO DO REGISTRO DE IMOVEIS', 43471, 3168903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9791, 11134, 'PRIMEIRO OFICIO DE NOTAS DE TIROS ', 323, 3168903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9792, 11135, 'TABELIONATO DE PROTESTO', 60087, 3168903, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9793, 4216, 'SERVICO DISTRITAL ', 129882, 4103305, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9794, 4592, 'SERVICO DISTRITAL DE BRAGANEY -', 85803, 4103354, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9795, 4593, 'SERVICO DISTRITAL DE BRASILANDIA', 80846, 4103370, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9796, 4594, 'SERVICO DISTRITAL DE CAFEARA', 87023, 4103404, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9797, 4217, 'SERVICO DISTRITAL DE CAFELANDIA', 86736, 4103453, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9798, 4595, 'SERVICO DISTRITAL DE  CAFEZAL DO SUL', 82529, 4103479, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9799, 4218, 'SERVICO DISTRITAL DE CALIFORNIA', 81349, 4103503, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9800, 10122, 'SERVICO DE REGISTRO DE IMOVEIS', 85670, 4103602, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9801, 10123, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 86942, 4103602, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9802, 4219, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 86009, 4103602, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9803, 10124, 'SERVICO DE REGISTRO DE IMOVEIS', 81851, 4103701, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9804, 10125, 'TABELIONATO DE NOTAS E 1º TABELIONATO DE PROTESTO DE TITULOS', 87429, 4103701, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9805, 4596, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO PRECARIAMENTE O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS E 2º TABELIONATO DE PROTESTO DE TITULOS', 84319, 4103701, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9806, 4220, 'SERVICO DISTRITAL DE CAMBIRA', 130625, 4103800, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9807, 10126, 'SERVICO DE REGISTRO DE IMOVEIS', 86058, 4103909, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9808, 4221, 'SERVICO DISTRITAL DE SALLES DE OLIVEIRA ', 142091, 4103909, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9809, 10127, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE O TABELIONATO DE PROTESTO DE TITULOS', 86488, 4103909, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9810, 4222, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84988, 4103909, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9811, 3722, 'SERVICO DISTRITAL DE BELA VISTA DO PIQUIRI', 86702, 4103909, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9812, 3723, 'SERVICO DISTRITAL DE CAMPINA DO SIMAO', 81067, 4103958, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9813, 4224, 'SERVICO DE REGISTRO DAS PESSOAS NATURAIS ACUMULANDO PRECARIAMENTE O SERVICO DE REGISTRO DE TITULOS E DOCUMENTO CIVIL DAS PESSOAS JURIDICAS ', 81760, 4104006, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9814, 10128, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 88120, 4104006, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9815, 10129, 'SERVICO DE REGISTRO DE IMOVEIS', 84251, 4104006, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9816, 4597, 'SERVICO DISTRITAL DE PAIOL DE BAIXO', 83311, 4104006, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9817, 4223, 'SERVICO DISTRITAL DE JARDIM PAULISTA', 80853, 4104006, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9818, 4598, 'SERVICO DISTRITAL DE CAMPO BONITO', 87973, 4104055, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9819, 4225, 'SERVICO DISTRITAL DE CAMPO DO TENENTE', 82164, 4104105, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9820, 4226, 'SERVICO DISTRITAL DE TRES CORREGOS', 86421, 4104204, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9821, 4228, 'SERVICO DISTRITAL DE FERRARIA', 129932, 4104204, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9822, 4599, 'SERVICO DISTRITAL DE BATEIAS', 80861, 4104204, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9823, 4227, 'SERVICO DISTRITAL SAO LUIZ DO PURUNA', 82503, 4104204, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9824, 10130, '1º TABELIONATO DE NOTAS, ACUMULANDO PRECARIAMENTE  O  1º TABELIONATO DE PROTESTO DE TITULOS', 80887, 4104204, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9825, 4600, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84103, 4104204, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9826, 10131, '1º SERVICO DE REGISTRO DE IMOVEIS', 80879, 4104204, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9827, 7313, 'SERVICO DISTRITAL DE CAMPO MAGRO', 87353, 4104253, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9828, 10132, '2º SERVICO DE REGISTRO DE IMOVEIS', 80218, 4104303, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9829, 10133, '1º TABELIONATO DE NOTAS', 80911, 4104303, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9830, 3724, 'SERVICO DISTRITAL DE PIQUIRIVAI', 82339, 4104303, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9831, 10134, 'REGISTRO DE IMOVEIS 1 OFICIO DE CAMPO MOURAP PR', 85217, 4104303, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9832, 10135, '2º TABELIONATO DE NOTAS', 80903, 4104303, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9833, 10136, 'SEGUNDO TABELIONATO DE TITULO ', 80929, 4104303, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9834, 10137, '1ºTABELIONATO DE PROTESTO DE TITULOS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 80895, 4104303, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9835, 4229, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E 3º TABELIONATO DE NOTAS', 81026, 4104303, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9836, 10138, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, TABELIONATO DE PROTESTOS DE TITULOS', 87841, 4104402, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9837, 2604, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE ARAL MOREIRA', 62810, 5001243, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9838, 2605, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 61952, 5001508, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9839, 10471, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTOS', 62588, 5001508, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9840, 6991, 'SERVICO NOTARIAL E DE REGISTRO CIVIL ', 62935, 5001904, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9841, 10472, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTOS', 62497, 5001904, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9842, 3585, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 62992, 5002001, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9843, 10473, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTOS', 62968, 5002001, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9844, 3586, '2º SERVICO NOTARIAL E DE REGISTRO CIVIL ', 62422, 5002100, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9845, 10474, '1º SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E TABELIONATO DE PROTESTO', 63065, 5002100, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9846, 6992, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE BODOQUENA', 62075, 5002159, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9847, 3587, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 62059, 5002209, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9848, 10475, 'SERVICO DE REGISTRO DE IMOVEIS. TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTOS', 62380, 5002209, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9849, 10476, '1º SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 62299, 5002308, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9850, 3588, '1º SERVICO NOTARIAL E DE REGISTRO CIVIL', 62356, 5002308, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9851, 3590, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE CRISTALINA', 61960, 5002407, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9852, 3589, '1º SERVICO NOTARIAL E DE REGISTRO CIVIL', 62406, 5002407, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9853, 10477, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTOS', 62307, 5002407, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9854, 6993, '2.º SERVICO NOTARIAL E DE REGISTRO CIVIL', 61978, 5002605, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9855, 10478, '1º SERVICO NOTARIAL, REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS E PROTESTO DE TITULOS ', 62018, 5002605, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9856, 3591, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE ANHANDUI', 62513, 5002704, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9857, 10479, '5º SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS DA 3ª CIRCUNSCRICAO ', 61903, 5002704, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9858, 10480, '4º SERVICO NOTARIAL E DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 62463, 5002704, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9859, 10481, '3º TABELIONATO DE PROTESTO DE TITULOS ', 154328, 5002704, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9860, 10482, '2º TABELIONATO DE PROTESTO', 61747, 5002704, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9861, 10483, '8º SERVICO NOTARIAL', 61929, 5002704, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9862, 3592, '2º SERVICO NOTARIAL E DE REGISTRO CIVIL DA 1ª CIRCUNSCRICAO                   ', 62901, 5002704, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9863, 10484, '3º SERVICO NOTARIAL', 154310, 5002704, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9864, 3594, '3º SERVICO DE REGISTRO CIVIL DA 3ª CIRCUNSCRICAO', 61838, 5002704, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9865, 3015, 'CARTORIO COELHO', 65896, 1500305, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9866, 3019, 'CARTORIO REGISTRO CIVIL UNICO OFICIO DE CAMBURAO', 68023, 1500404, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9867, 3021, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE CUIPEUA - ALENQUER', 68080, 1500404, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9868, 10485, 'CARTORIO DO 1º OFICIO DA COMARCA DE ALENQUER', 66696, 1500404, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9869, 3020, 'CARTORIO BENTES 2º OFICIO', 65821, 1500404, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9870, 3022, 'CARTORIO DO UNICO OFICIO DE ALMEIRM - RAIMUNDO MARALDO DA COSTA', 68445, 1500503, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9871, 10486, 'CARTORIO 2° OFICIO', 65698, 1500602, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9872, 7011, 'UNICO OFICIO DE NOTAS E REGISTROS DE CASTELO DE SONHOS', 129676, 1500602, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9873, 10487, 'CARTORIO DE REGISTRO DE IMOVEIS DO 1º OFICIO DE ALTAMIRA', 66514, 1500602, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9874, 7175, 'TABELIONATO DE NOTAS E REGISTRO CIVIL-3º OFICIO', 68569, 1500602, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9875, 3023, 'CARTORIO NUNES - DISTRITO DO FURO DE BREU', 67868, 1500701, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9876, 3025, 'CARTORIO GUIMARAES - UNICO OFICIO DE ANAJAS', 67744, 1500701, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9877, 3024, 'CARTORIO DO UNICO OFICIO DO DISTRITO DE CURURU', 67652, 1500701, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9878, 10488, '1º OFICIO DE ANANINDEUA - CARTORIO FARIA NETO', 65599, 1500800, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9879, 2819, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE SANTANA DO TABULEIRO', 43042, 3154002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9880, 2374, 'REGISTRO CIVIL E TABELIONATO DE NOTAS DE RECREIO', 364, 3154101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9881, 2375, 'CARTORIO REGISTRO CIVIL E TABELIONATO DISTRITO DE CONCEICAO DA BOA VISTA', 44834, 3154101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9882, 2820, 'CARTORIO REGIONAL CIVIL DE PESSOAS NATURAIS E DE NOTAS', 44263, 3154101, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9883, 2821, 'OFICIO DO REGISTRO CIVIL E TAB. DE NOTAS', 51292, 3154150, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9884, 10908, 'REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS ', 32946, 3154200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9885, 10909, 'OFICIO DE IMOVEIS', 46417, 3154200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9886, 10910, 'TABELIONATO DE PROTESTO DE TITULOS ', 55517, 3154200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9887, 10911, 'OFICIO DO SEGUNDO TABELIONATO DE NOTAS DE RESENDE COSTA', 57752, 3154200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9888, 2734, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 42457, 3154200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9889, 2822, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS ', 56390, 3154200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9890, 10912, 'CARTORIO DO 1º OFICIO DE NOTAS', 40485, 3154200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9891, 2735, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE VILA CAMPO ALEGRE DE MINAS', 42499, 3154309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9892, 10913, 'REGISTRO DE PROTESTO DE TITULOS', 57307, 3155207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9893, 10914, 'REGISTRO DE IMOVEIS', 57190, 3155207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9894, 2744, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE RIO MANSO', 46821, 3155306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9895, 2745, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SOUSA', 36236, 3155306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9896, 10915, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 47548, 3155405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9897, 3104, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50484, 3155405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9898, 10916, 'OFICIO DO PRIMEIRO TABELIONATO DE NOTAS ', 50138, 3155405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9899, 10917, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49569, 3155405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9900, 10918, 'CARTORIO DE REGISTRO DE IMOVEIS DE RIO NOVO', 39172, 3155405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9901, 10919, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 39370, 3155405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9902, 10920, '2 TABELIONATO DE NOTAS', 32441, 3155504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9903, 10921, 'REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 57703, 3155504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9904, 10922, 'TABELIONATO DE PROTESTO DE TITULOS DE RIO PARANAIBA', 60608, 3155504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9905, 10923, 'REGISTRO DE IMOVEIS', 56960, 3155504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9906, 3069, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42218, 3155504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9907, 10924, 'CARTORIO DO 1º OFICIO DE NOTAS', 40469, 3155504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9908, 3070, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ABAETE DOS MENDES', 42135, 3155504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9909, 10925, 'CARTORIO DO 2° TABELIONATO DE NOTAS', 41186, 3155603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9910, 10926, 'CARTORIO DO REGISTRO DE IMOVEIS DE RIO PARDO DE MINAS', 43521, 3155603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9911, 3071, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42226, 3155603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9912, 10927, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54312, 3155603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9913, 2654, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SERRA NOVA', 52191, 3155603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9914, 10928, 'OFICIO DO 1º TABELIONATO DE NOTAS', 50096, 3155603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9915, 10929, 'REGISTRO DE PROTESTOS DE RIO PARDO DE MINAS', 60186, 3155603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9916, 10930, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48678, 3155702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9917, 3073, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE PADRE PINTO', 56796, 3155702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9918, 10931, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 46276, 3155702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9919, 10932, 'OFICIO DO 2º TABELIONATO DE NOTAS', 57794, 3155702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9920, 10933, 'RIO PIRACICABA CARTORIO DO 1º OFICIO', 57786, 3155702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9921, 3072, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50534, 3155702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9922, 2921, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE GOIABEIRA', 51201, 3127370, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9923, 2922, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE GOIANA', 47100, 3127388, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9924, 11284, 'OFICIO DO REGISTRO CIVIL E TABELIONATO', 51391, 3127404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9925, 2923, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36897, 3127503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9926, 2924, 'CARTORIO DE REGISTRO CIVIL E NOTAS DA SEDE', 37390, 3127503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9927, 11285, '4° OFICIO DE NOTAS', 32904, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9928, 11286, 'OFICIO DO 2º REGISTRO DE IMOVEIS', 49296, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9929, 11287, 'OFICIO DO 2 TABELIONATO DE NOTAS', 49122, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9930, 2137, 'REGISTRO CIVIL DAS PESSOAS NATURAIS - 1º. SUBDISTRITO', 56218, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9931, 2165, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE SARANDIRA', 56507, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9932, 2750, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE TORREOES', 37614, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9933, 11288, 'CARTORIO DO 3º OFICIO DE REGISTRO DE IMOVEIS - CARTORIO OLAVO COSTA', 41699, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9934, 11289, 'TABELIONATO DO 1º OFICIO DE NOTAS DA COMARCA DE JUIZ DE FORA - MG MANINHO FARIA', 61127, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9935, 2136, 'OFICIO DO 2º REGISTRO CIVIL DAS PESSOAS NATURAIS', 49270, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9936, 6967, 'REGISTRO CIVIL - 4º SUBDISTRITO - JUIZ DE FORA/MG', 55608, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9937, 2139, 'CARTORIO DO DISTRITO DE ROSARIO/MG', 41731, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9938, 11290, '2º TABELIONATO DE PROTESTO DE TITULOS', 32821, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9939, 11291, 'OFICIO DO 3º TABELIONATO DE NOTAS', 61325, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9940, 11292, 'REGISTRO DE TITULOS, DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 57711, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9941, 11293, '1º TABELIONATO DE PROTESTOS DA COMARCA DE JUIZ DE FORA MG', 32409, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9942, 2138, 'OFICIO DO 3º REGISTRO CIVIL DAS PESSOAS NATURAIS', 44057, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9943, 11294, 'CARTORIO DO 1º OFICIO DE REGISTRO DE IMOVEIS DE JUIZ DE FORA', 40949, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9944, 11295, 'OFICIO DE REGISTRO DE DISTRIBUICAO DE JUIZ DE FORA', 47167, 3136702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9945, 2824, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE JURAMENTO - MG', 53025, 3136801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9946, 2283, 'CARTORIO DE REGISTRO  CIVIL E NOTAS DE PORTO AGRARIO', 35204, 3136959, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9947, 2282, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 56432, 3136959, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9948, 2140, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 56457, 3136959, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9949, 2142, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CONCORDIA DO MUCURI', 36905, 3137007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9950, 2141, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53322, 3137007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9951, 7459, 'REGISTRO CIVIL E NOTAS SERVENTIA DE LAGAMAR', 56747, 3137106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9952, 2143, 'SERVICO REG CIVIL PESSOAS NATURAIS E NOTAS DIST SAO BRAS DE MINAS', 59097, 3137106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9953, 11296, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54304, 3137205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9954, 11297, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE LAGOA DA PRATA', 60491, 3137205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9955, 11298, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49346, 3137205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9956, 2284, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35634, 3137205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9957, 11299, 'OFICIO DO 1º TABELIONATO DE NOTAS', 47985, 3137205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9958, 11300, 'CARTORIO DE REGISTRO DE IMOVEIS', 38703, 3137205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9959, 2285, 'OFICIO DO REGISTRO CIVIL E NOTAS', 51227, 3137304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9960, 2286, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 57745, 3137403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9961, 11301, 'PROTESTO DE TITULOS', 55491, 3137403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9962, 11302, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48298, 3145109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9963, 2842, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PETUNIA', 46185, 3145109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9964, 11303, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48702, 3145109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9965, 2841, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42291, 3145109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9966, 11304, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 47480, 3145109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9967, 11305, 'SERVENTIA DE REGISTRO DE IMOVEIS', 58214, 3145109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9968, 11306, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49734, 3145109, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9969, 11307, 'SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVEIS DAS PESSOAS JURIDICAS', 58651, 3145208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9970, 4000, 'SERVICO REGISTRAL DE PESSOAS NATURAIS ', 73171, 2516904, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9971, 3546, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS', 59196, 3170206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9972, 3548, 'CARTORIO DE REGISTRO DAS PESSOAS NATURAIS  E REGISTO DE NOTAS', 34280, 3170206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9973, 10281, '2º REGISTRO DE IMOVEIS DE UBERLANDIA', 32573, 3170206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9974, 2533, 'TABELIONATO DE NOTAS E REGISTRO CIVIL DE MIRAPORANGA-UBERLANDIA-MG', 146050, 3170206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9975, 10282, 'PROTESTO DE TITULOS', 55525, 3170206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9976, 3547, 'TAPUIRAMA CARTORIO DE PAZ E NOTAS', 61358, 3170206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9977, 10283, '1º OFICIO DE REGISTRO DE IMOVEIS DE UBERLANDIA', 32136, 3170206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9978, 10284, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 39966, 3170206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9979, 3549, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 42861, 3170305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9980, 3551, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 36962, 3170404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9981, 10285, 'TABELIONATO DE PROTESTO DE TITULOS', 60194, 3170404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9982, 10286, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESOAS JURIDICAS DE UNAI-MG', 39461, 3170404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9983, 10287, 'UNAI CARTORIO DO PRIMEIRO OFICIO DE NOTAS', 61507, 3170404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9984, 10288, 'UNAI REGISTRO DE IMOVEIS', 61515, 3170404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9985, 3550, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE UNAI', 36004, 3170404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9986, 3552, 'OFICIO REGISTRO CIVIL E TABELIONATO DE NOTAS DO BOQUEIRAO', 54890, 3170404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9987, 10289, '2º OFICIO DE NOTAS DE UNAI-MG', 32565, 3170404, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9988, 3553, 'CARTORIO DE REGISTRO CIVIL E ANEXOS DE UNIAO DE MINAS', 36582, 3170438, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9989, 3554, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 37085, 3170479, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9990, 6985, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 42895, 3170503, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9991, 2726, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SANTA CRUZ', 150045, 3170529, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9992, 3555, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE URUCUIA', 53215, 3170529, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9993, 2598, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 38190, 3170578, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9994, 2727, 'CARTORIO NOTAS REG. CIVIL DAS P. NATURAIS', 44123, 3170602, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9995, 3556, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 42705, 3170651, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9996, 10290, 'OFICIO DO 1 TABELIONATO DE PROTESTO DE TITULOS', 47639, 3170701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9997, 10291, 'SERVICO NOTARIAL PRIVATIVO ', 59063, 3170701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9998, 10292, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS', 57562, 3170701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (9999, 10293, 'SERVICO REGISTRAL IMOBILIARIO DE VARGINHA', 59782, 3170701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10000, 10294, 'OFICIO DO 2 TABELIONATO DE NOTAS', 49114, 3170701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10001, 3557, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55970, 3170701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10002, 2599, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE VARJAO DE MINAS', 53694, 3170750, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10003, 10295, 'TABELIONATO 1º OFICIO DE NOTAS', 59980, 3170800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10004, 2600, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE GUAICUI', 36780, 3170800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10005, 10296, 'SERVICO DE REGISTRO DE IMOVEIS DE VARZEA DA PALMA', 38588, 3170800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10006, 3558, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50500, 3170800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10007, 3229, 'SEGUNDO SERVICO NOTARIAL E REGISTRAL ', 65284, 5106422, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10008, 2536, 'CARTORIO DO 2° OFICIO', 64329, 5106505, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10009, 10297, 'CARTORIO DO 1° OFICIO', 64154, 5106505, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10010, 7355, 'SERVICO NOTARIAL E REGISTRO CIVIL', 132720, 5106653, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10011, 3230, 'PONTE BRANCA CARTORIO DE TABELIONATO E REGISTRO CIVIL', 64600, 5106703, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10012, 10298, 'PRIMEIRO SERVICO NOTARIAL E REGISTRAL', 65037, 5106752, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10013, 2537, 'SEGUNDO SERVICO NOTARIAL E REGISTRAL', 65227, 5106752, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10014, 10299, 'SERVICO REGISTRAL E IMOBILIARIO DE PORTO ALEGRE DO NORTE - MT', 65425, 5106778, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10015, 7053, '2º SERVICO NOTARIAL E REGISTRAL DE PORTO ALEGRE DO NORTE', 63701, 5106778, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10016, 2538, 'CARTORIO DO 2º OFICIO', 64337, 5106802, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10017, 10300, 'CARTORIO DO 1º OFICIO', 64162, 5106802, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10018, 10301, 'PRIMEIRO OFICIO DE REGISTRO DE IMOVEIS TITULOS E DOCUMENTOS DE PORTO ESPERIDIAO MT', 65003, 5106828, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10019, 3231, 'CARTORIO DO REGISTRO CIVIL DE PORTO ESPERIDIAO', 64493, 5106828, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10020, 2610, 'CARTORIO DO UNICO OFICIO DA VILA DE CURUCAMBABA', 67124, 1502103, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10021, 2611, 'CARTORIO DO DISTRITO JUDICIARIO DE JANUA-COELI', 66928, 1502103, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10022, 10606, 'CARTORIO DO 1º OFICIO EXTRAJUDICIAL', 66720, 1502103, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10023, 2615, 'CARTORIO DO TERCEIRO OFICIO ', 66977, 1502103, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10024, 2609, 'CARTORIO DE REGISTRO CIVIL DA VILA DE JUABA', 66175, 1502103, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10025, 2613, 'CARTORIO DE SAO RAIMUNDO DOS FURTADOS', 66597, 1502103, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10026, 2614, 'CARTORIO DA VILA DO CARMO', 66969, 1502103, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10027, 2616, '1º OFICIO DE NOTAS, PROTESTOS E REGISTRO CIVIL DAS PESSOAS NATURAIS', 130443, 1502152, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10028, 10607, 'CARTORIO MENDES SOARES-2O OFICIO DA COMARCA DE CANAA DOS CARAJAS', 67827, 1502152, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10029, 10608, 'CARTORIO BUARQUE - CAPANEMA', 65854, 1502202, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10030, 10609, 'CARTORIO DO 1º OFICIO DA COMARCA DE CAPANEMA', 66704, 1502202, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10031, 2617, 'CARTORIO DO UNICO OFICIO DE MIRASSELVAS - CAPANEMA', 67264, 1502202, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10032, 2619, 'CARTORIO 3º OFICIO -  REGISTRO CIVIL DE PESSOAS NATURAIS E DE INTERDICOES E TUTELAS E 3º OFICIO DE TABELIONATO DE NOTAS ', 65979, 1502202, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10033, 2618, 'CARTORIO DE REGISTRO CIVIL DO UNICO OFICIO DA VILA TAUARI - CAPANEMA', 66340, 1502202, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10034, 2620, 'CARTORIO DO UNICO OFICIO DE CAPITAO-POCO', 67173, 1502301, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10035, 2622, 'CARTORIO FREIRE DA SILVA - CASTANHAL', 67694, 1502400, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10036, 2621, 'CARTORIO SOUZA - APEU/CASTANHAL', 68254, 1502400, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10037, 10610, 'CARTORIO ARAUJO', 65789, 1502400, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10038, 2626, 'CARTORIO DE REGISTRO CIVIL DO RIO CURURU - CHAVES', 66324, 1502509, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10039, 2624, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE PRACATUBA', 66290, 1502509, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10040, 2625, 'CARTORIO DE REGISTRO CIVIL DO UNICO OFICIO DE RIO GANHOAO', 66357, 1502509, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10041, 2623, 'CARTORIO DE REGISTRO CIVIL DE SAO SEBASTIAO DO ARAPIXI - CHAVES', 66241, 1502509, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10042, 7062, 'SERVICO NOTARIAL E REGISTRAL CONCEICAO', 68502, 1502509, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10043, 2627, 'CARTORIO DE RIO ARROZAL - CHAVES', 68270, 1502509, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10044, 2628, 'SAO SEBASTIAO DE VICOSA', 68478, 1502509, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10045, 3903, '12° CARTORIO DE REGISTRO CIVIL DISTRITAL DE MANGABEIA - JOAO PESSOA/PB', 68635, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10046, 10611, 'TOSCANO DE BRITO SERVICO NOTARIAL E REGISTRAL', 73379, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10047, 3897, '1º REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE JOAO PESSOA', 68700, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10048, 4145, 'TERCEIRO CARTORIO DE REGISTRO CIVIL', 73361, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10049, 10612, 'CARTORIO 3° OFICIO DE NOTAS PESSOA MILANEZ', 69179, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10050, 3901, '7º CARTORIO REGISTRO CIVIL (SERVICO REGISTRAL GOMES DE SOUZA ) ', 68882, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10051, 3898, 'JOAO PESSOA 10 CARTORIO DO REGISTRO CIVIL', 72256, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10052, 10613, 'CARTORIO TRAVASSOS- 4º OFICIO DE NOTAS', 71829, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10053, 4147, '2º SERVICO REGISTRAL DAS PESSOAS NATURAIS DA COMARCA DE JOAO PESSOA-PB', 68833, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10054, 7082, 'JOAO PESSOA - CARTORIO DE REGISTRO CIVIL - 11º OFICIO - ', 72249, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10055, 3904, '5º CARTORIO DE REGISTRO CIVIL DA CAPITAL', 68858, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10056, 10614, 'CARTORIO 1º OFICIO DISTRITAL DO GEISEL', 69153, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10057, 10615, 'CARTORIO 1º TABELIONATO DE NOTAS E REGISTRO IMOBILIARIO DA ZONA SUL DE JOAO PESSOA', 69161, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10058, 10616, '7º OFICIO DE NOTAS DE JOAO PESSOA-PB', 68890, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10059, 4148, '6 REGISTRO CIVIL DE JOAO PESSOA', 68866, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10060, 10617, 'SOUTO - SERVICO NOTARIAL E REGISTRAL', 73346, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10061, 10618, 'JOAO PESSOA 2º OFICIO CIVEL E CRIMINAL', 72264, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10062, 3902, '8º SERVICO REGISTRAL FAUSTO DE OLIVEIRA', 68916, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10063, 10619, 'CARTORIO GARIBALDI 9º OFICIO DE NOTAS ', 71506, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10064, 4146, 'SERVICO  REGISTRAL LIMA GOMES', 72710, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10065, 10620, 'EUNAPIO TORRES SERVICO NOTARIAL E REGISTRAL', 72116, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10066, 10621, 'MONTEIRO DA FRANCA - SERVICO NOTARIAL', 72348, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10067, 3905, 'CARTORIO DE OFICIO DE NOTAS E REGISTRO CIVIL', 69609, 2507606, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10068, 3906, 'CARTORIO DO REGISTRO CIVIL', 70599, 2507705, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10069, 10934, 'OFICIO DO REGISTRO DE IMOVEIS', 54056, 3155702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10070, 3105, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CONCEICAO DE PIRACICABA', 56085, 3155702, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10071, 10935, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54296, 3155801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10072, 3074, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 56333, 3155801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10073, 10936, 'CARTORIO DE REGISTRO DE IMOVEIS', 38596, 3155801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10074, 10937, 'TABELIONATO DE PROTESTOS DE TITULOS DE RIO POMBA', 35071, 3155801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10075, 10938, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48249, 3155801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10076, 10939, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49627, 3155801, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10077, 10940, 'PRIMEIRO OFICIO DE NOTAS', 48355, 3155900, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10078, 10941, 'CARTORIO DE REGISTRO DE IMOVEIS', 38521, 3155900, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10079, 3106, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 42317, 3155900, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10080, 10942, 'CARTORIO DE PROTESTO DE TITULOS', 34892, 3155900, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10081, 10943, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS                                                        ', 54486, 3155900, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10082, 2281, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE VEREDAS', 53751, 3136306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10083, 11225, 'OFICIO DO 2º TABELIONATO DE NOTAS', 33795, 3136306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10084, 2129, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELA E NOTAS', 44776, 3136306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10085, 11226, 'CARTORIO DO 1º OFICIO DE NOTAS', 40766, 3136306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10086, 2127, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CANABRAVA', 36103, 3136306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10087, 11227, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39495, 3136306, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10088, 6966, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE JOAQUIM FELICIO', 52704, 3136405, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10089, 2133, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE JORDANIA', 35394, 3136504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10090, 2132, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ESTRELA DE JORDANIA', 45922, 3136504, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10091, 7458, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51656, 3136520, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10092, 2134, 'REGISTRO CIVIL E NOTAS', 56705, 3136553, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10093, 2135, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE JOSENOPOLIS', 53553, 3136579, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10094, 2749, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51987, 3136652, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10095, 2833, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50963, 3144409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10096, 11228, 'CARTORIO DO 1º OFICIO DE NOTAS', 40501, 3144409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10097, 11229, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48611, 3144409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10098, 11230, '2º CARTORIO DE NOTAS', 32482, 3144409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10099, 11231, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54403, 3144409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10100, 11232, 'CARTORIO DO REGISTRO DE IMOVEIS', 43422, 3144409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10101, 2834, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52209, 3144508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10102, 11233, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48447, 3144607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10103, 10200, 'SERVICO DE REGISTRO DE IMOVEIS', 83113, 4106506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10104, 4249, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS.', 84707, 4106506, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10105, 4610, 'SERVICO DISTRITAL DE CORUMBATAI DO SUL', 83139, 4106555, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10106, 4611, 'SERVICO DISTRITAL DE CRUZ MACHADO', 82180, 4106803, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10107, 11164, 'SENADOR FIRMINO CARTORIO DO PRIMEIRO OFICIO DE NOTAS', 58131, 3165701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10108, 11165, 'OFICIO DO 1º TABELIONATO DE PROTESTOS DE TITULOS', 48959, 3165701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10109, 2708, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DA COMARCA DE SENADOR FIRMINO', 50724, 3165701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10110, 11166, 'OFICIO DO REGISTRO DE IMOVEIS', 54031, 3165701, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10111, 2709, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 42903, 3165800, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10112, 11167, 'CARTORIO DE REGISTRO CIVIL', 35220, 3166204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10113, 7314, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85068, 4104402, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10114, 4601, 'SERVICO DISTRITAL DE TEREZA CRISTINA', 82438, 4104402, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10115, 4230, 'SERVICO DISTRITAL DE TRES BICOS', 86413, 4104402, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10116, 4231, 'SERVICO DISTRITAL DE PAZ', 83329, 4104428, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10117, 10139, 'TABELIONATO DE NOTAS ', 129502, 4104451, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10118, 4602, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO PRECARIAMENTE O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85308, 4104451, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10119, 10140, 'TABELIONATO DE PROTESTO DE TITULOS', 87387, 4104451, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10120, 3725, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 82842, 4104501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10121, 10141, 'TABELIONATO DE NOTAS', 129643, 4104501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10122, 10142, 'TABELIONATO DE PROTESTO DE TITULOS', 88088, 4104501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10123, 4232, 'REGISTRO CIVIL E TABELIONATO ALTO FARADAY', 129494, 4104501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10124, 10143, 'SERVICO DE REGISTRO DE IMOVEIS', 84202, 4104501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10125, 3726, 'SERVICO DISTRITAL DE CRISTO REI', 81174, 4104501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10126, 4603, 'SERVICO DISTRITAL DE SAO LUIZ', 141457, 4104501, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10127, 10144, 'SERVICO DE REGISTRO DE IMOVEIS', 85100, 4104600, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10128, 10145, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTETO DE TITULOS', 87791, 4104600, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10129, 4233, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85936, 4104600, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10130, 4234, 'SERVICO DISTRITAL DE CARAMBEI', 79954, 4104659, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10131, 10146, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS.', 80937, 4104709, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10132, 4235, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO PRECARIAMENTE O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O SERVICO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 85662, 4104709, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10133, 10147, 'SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 83030, 4104808, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10134, 10148, '1º TABELIONATO DE NOTAS', 83006, 4104808, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10135, 10149, '2º TABELIONATO DE PROTESTOS DE TITULOS          ', 83048, 4104808, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10136, 10150, '2º SERVICO DE REGISTRO DE IMOVEIS', 85571, 4104808, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10137, 10151, 'SERVICO DE REGISTRO DE IMOVEIS ', 85092, 4105706, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10138, 10152, 'TABELIONATO DE NOTAS, ACUMULADO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 86587, 4102109, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10139, 10153, '2° SERVICO DE REGISTRO DE IMOVEIS', 80101, 4102109, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10140, 4584, 'SERVICO DISTRITAL DE ICARA', 144808, 4102109, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10141, 4585, 'SERVICO DISTRITAL DE ATALAIA', 81570, 4102208, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10142, 4674, 'SERVICO DISTRITAL DE BALSA NOVA', 129817, 4102307, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10143, 10154, 'REGISTRO DE IMOVEIS', 85688, 4102406, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10144, 4586, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 82644, 4102406, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10145, 10155, 'TABELIONATO DE NOTAS', 130062, 4102406, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10146, 10156, 'TABELIONATO DE PROTESTO DE TITULOS', 130054, 4102406, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10147, 4208, 'SERVICO DE REGISTRO DAS PESSOAS NATURAIS, ACUMULADO, PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 80820, 4102505, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10148, 10157, 'TABELIONATO DE PROTESTOS DE TITULOS', 81240, 4102505, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10149, 10158, 'TABELIONATO DE NOTAS ', 130807, 4102505, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10150, 10159, 'SERVICO DE REGISTRO DE IMOVEIS', 84194, 4102505, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10151, 4587, 'SERVICO DISTRITAL DE OURILANDIA', 129874, 4102505, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10152, 4209, 'SERVICO DISTRITAL DE BARRA DO JACARE ', 148049, 4102703, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10153, 10160, 'TABELIONATO DE NOTAS ACUMULANDO PRECARIAMENTE O PROTESTO DE TITULOS GNOATTO', 87445, 4102604, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10154, 10161, 'SERVICO DO REGISTRO DE IMOVEIS', 86462, 4102604, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10155, 3029, 'CARTORIO SILVA - UNICO OFICIO DE NOVA OLINDA - AUGUSTO CORREA', 68221, 1500909, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10156, 3028, 'CARTORIO RABELO OFICIO UNICO', 67975, 1500909, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10157, 3027, 'CARTORIO DE REGISTRO CIVIL DE ATURIAI - CARTORIO SAO MIGUEL', 68197, 1500909, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10158, 3030, 'CARTORIO DO UNICO OFICIO DA VILA ITAPIXUNA - AUGUSTO CORREA', 67132, 1500909, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10159, 3031, 'CARTORIO ANTONIO MAGALHAES - SANTANA DO CAPIM', 65763, 1500958, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10160, 3033, 'CARTORIO UNICO OFICIO DE AVEIRO', 68304, 1501006, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10161, 3032, 'CARTORIO SARMENTO - BRASILIA LEGAL', 68205, 1501006, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10162, 3034, 'CARTORIO OFICIO UNICO DE BAGRE', 67884, 1501105, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10163, 3037, 'CARTORIO DO UNICO OFICIO DE MATACURA - BAIAO', 67231, 1501204, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10164, 3036, 'CARTORIO DOUGLAS BRASIL - BAIAO', 67587, 1501204, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10165, 3035, 'CARTORIO DO UNICO OFICIO DA VILA UMARIZAL', 65672, 1501204, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10166, 3041, 'CARTORIO DO DISTRITO DE MURUCUPI - VILA DO CONDE ', 67959, 1501303, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10167, 3038, 'SERVENTIA EXTRAJUDICAL DA VILA DOS CABANOS - OFICIO UNICO', 129379, 1501303, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10168, 3039, 'CARTORIO UNICO OFICIO DE BARCARENA', 68312, 1501303, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10169, 7060, 'CARTORIO DE ITUPANEMA - BARCARENA', 66027, 1501303, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10170, 3042, 'CARTORIO DE REGISTRO CIVIL AICARAU', 66142, 1501303, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10171, 3040, 'CARTORIO DE REGISTRO CIVIL DO UNICO OFICIO DA ILHA DAS ONCAS (FURO GRANDE)', 139451, 1501303, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10172, 3047, 'CARTORIO DO REGISTRO CIVIL E DE NOTAS DO UNICO OFICIO (MOSQUEIRO)', 66951, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10173, 3046, 'CARTORIO ELEONOR MENDES CARVALHO DO 4º CARTORIO', 67595, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10174, 10489, 'CARTORIO 2º OFICIO DE NOTAS', 65714, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10175, 3050, 'SERVICO REGISTRAL E NOTARIAL VAL DE CAES', 68536, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10176, 10490, 'CARTORIO DE REGISTRO ESPECIAL DE TITULOS, DOCUMENTOS E OUTROS PAPEIS - 1º OFICIO ', 66563, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10177, 4133, 'CARTORIO DO REGISTRO CIVIL', 70615, 2504405, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10178, 6653, 'CARTORIO REGISTRO CIVIL DO DISTRITO DE MONTEVIDEU', 69302, 2504405, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10179, 4134, 'UNICO CARTORIO DE REGISTRO CIVIL, OBITOS E NOTAS', 73395, 2504504, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10180, 4135, 'CARTORIO DE REGISTRO CIVIL E NOTAS DO CONDE - PEDRO ALVES', 71712, 2504603, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10181, 4136, 'CARTORIO LOPES CARNEIRO', 68627, 2504603, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10182, 3855, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO CONGO - PB', 69914, 2504702, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10183, 10491, 'CARTORIO DE DISTRIBUICAO EXTRAJUDICIAL DE COREMAS', 154229, 2504801, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10184, 10492, 'CARTORIO DO UNICO OFICIO', 71357, 2504801, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10185, 4137, 'CARTORIO FRANCISCA GARRIDO DE SOUZA', 71472, 2504801, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10186, 4138, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 69781, 2504850, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10187, 4139, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE CRUZ DO ESPIRITO SANTO', 69807, 2504900, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10188, 10493, 'CARTORIO DO UNICO OFICIO E NOTAS', 71399, 2504900, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10189, 10494, 'CARTORIO DE DISTRIBUICAO EXTRA JUDICIAL', 69443, 2504900, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10190, 4140, 'CARTORIO DO REGISTRO CIVIL DAS PESOAS NATURAIS E NOTAS DE CUBATI', 70714, 2505006, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10191, 10495, 'CARTORIO DO REGISTRO DE DISTRIBUICAO DE CUITE-PB', 71274, 2505105, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10192, 10496, 'CUITE CARTORIO 1 OFICIO', 72058, 2505105, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10193, 3856, 'CARTORIO DO REGISTRO CIVIL DE CUITE', 70821, 2505105, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10194, 10497, 'CUITE CARTORIO DO SEGUNDO OFICIO', 72066, 2505105, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10195, 3857, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 71134, 2505238, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10196, 4141, 'CARTORIO DO REGISTRO CIVIL DE CUITEGI', 70839, 2505204, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10197, 3858, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 69096, 2505279, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10198, 3859, 'SERVICO DO REGISTRO CIVIL DAS PESSOAS   E NOTARIAS UNICO DE CURRAL VELHO PB', 72918, 2505303, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10199, 3860, 'SERVICO REGISTRAL JOAO ANDRE DOS SANTOS', 73288, 2505352, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10200, 3861, 'DESTERRO CARTORIO CIVIL E NOTAS', 72082, 2505402, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10201, 3862, 'CARTORIO DISTRITAL DE VAZANTE', 70425, 2505600, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10202, 10498, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE DIAMANTE', 72884, 2505600, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10203, 3863, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 71175, 2505709, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10204, 3864, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 71100, 2505808, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10205, 1958, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 42531, 3125200, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10206, 6961, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53058, 3125309, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10207, 1959, 'CATORIO DE PAZ E NOTAS DE FELICIO DOS SANTOS', 45336, 3125408, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10208, 2232, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE FELISBURGO', 43190, 3125606, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10209, 2233, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO JOSE DO BURITI', 52357, 3125705, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10210, 2267, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES E TUTELAS-SEDE', 50989, 3134400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10211, 10786, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48041, 3134400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10212, 10787, 'SERVICO REGISTRAL DE IMOVEIS', 59352, 3134400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10213, 2268, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52092, 3134509, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10214, 10788, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 39800, 3134608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10215, 2269, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO JOSE DO ALMEIDA', 53652, 3134608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10216, 10789, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49403, 3134608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10217, 10790, 'CARTORIO DE REGISTRO DE IMOVEIS', 240, 3134608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10218, 2105, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56051, 3134608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10219, 10791, 'CARTORIO DO 1º OFICIO DE NOTAS E REGISTRO DE IMOVEIS', 40527, 3134608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10220, 10792, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48751, 3134608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10221, 10793, 'TABELIONATO DO 2º OFICIO DE NOTAS', 41434, 3134707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10222, 10794, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 43539, 3134707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10223, 2107, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE JAGUARAO', 55871, 3134707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10224, 10795, 'SERVICO REGISTRAL DE IMOVEIS', 43547, 3134707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10225, 2106, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55780, 3134707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10226, 2108, 'CARTORIO DE REGISTRO CIVIL COM ATRIBUICOES DE NOTAS', 35386, 3134707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10227, 10796, '1º TABELIONATO DE NOTAS DA COMARCA DE JACINTO ', 32144, 3134707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10228, 10797, 'TABELIONATO DE PROTESTO DE TITULOS', 43554, 3134707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10229, 10798, 'OFICIO DO 2º TABELIONATO DE NOTAS DE JACUI', 49239, 3134806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10230, 2109, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 38372, 3134806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10231, 10799, 'OFICIO DO 1º TABELIONATO DE NOTAS DE JACUI', 47779, 3134806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10232, 10800, 'TABELIONATO DE PROTESTOS DE TITULOS DE JACUI', 47787, 3134806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10233, 10801, 'OFICIO DO REGISTRO DE IMOVEIS DE JACUI', 45823, 3134806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10234, 10802, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 46201, 3134806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10235, 2110, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 57497, 3134905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10236, 10803, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49700, 3134905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10237, 6648, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56192, 3134905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10238, 10804, 'OFICIO DO 1° TABELIONATO DE NOTAS', 47761, 3134905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10239, 10805, 'TABELIONATO DE PROTESTO DE TITULOS', 60392, 3134905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10240, 10806, 'OFICIO DE REGISTRO DE IMOVEIS', 47290, 3134905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10241, 7457, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 42796, 3135001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10242, 2111, 'CARTORIO DE NOTAS E REGISTRO CIVIL', 34074, 3135050, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10243, 2112, 'CARTORIO REGISTRO CIVIL PESSOAS NATURAIS', 44875, 3135050, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10244, 2113, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE JAMPRUCA', 45138, 3135076, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10245, 2114, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 42481, 3135076, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10246, 10807, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE MONTE SIAO', 39735, 3143401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10247, 2314, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE MONTE SIAO - MG', 59113, 3143401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10248, 10808, 'CARTORIO DE REGISTRO DE IMOVEIS', 38828, 3143401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10249, 10809, '1º SERVICO NOTARIAL ', 32177, 3143401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10250, 10810, 'TABELIONATO DE PROTESTO DE MONTE SIAO', 60178, 3143401, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10251, 10811, 'CARTORIO DO SEGUNDO OFICIO DE NOTAS', 43794, 3143302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10252, 10812, '1º PRIMEIRO REGISTRO DE IMOVEIS DE MONTES CLAROS, MG', 32151, 3143302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10253, 2299, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS ', 58396, 3143302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10254, 2710, 'CARTORIO DE NOTAS E REGISTRO CIVIL DAS PESSOAS NATURAIS', 34108, 3165909, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10255, 7040, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 38026, 3166006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10256, 3521, 'CARTORIO BICALHO', 33829, 3166105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10257, 2579, 'OFICIO DO REGISTRO CIVIL ', 50351, 3166204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10258, 2580, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 42713, 3166303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10259, 2581, 'CARTORIO DE PAZ E TABELIONATO DE SERITINGA', 34629, 3166402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10260, 6982, 'CARTORIO DO REGISTRO CIVIL', 42044, 3166501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10261, 2711, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51813, 3166600, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10262, 3522, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CATIARA', 44487, 3166808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10263, 2712, 'CARTORIO DE REGISTRO CIVIL DE SERRA DO SALITRE', 36491, 3166808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10264, 3523, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52563, 3166709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10265, 2582, 'SERRANIA CARTORIO DO REGISTRO CIVIL', 58149, 3166907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10266, 3524, 'SERVICO DE REGISTRO CIVIL DE NOTAS DE SERRANOPOLIS DE MINAS', 58420, 3166956, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10267, 3525, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 58750, 3167004, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10268, 2585, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE MILHO VERDE', 58156, 3167103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10269, 6567, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO GONCALO DO RIO DAS PEDRAS', 58164, 3167103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10270, 11168, 'OFICIO DO SEGUNDO TABELIONATO DE NOTAS', 54650, 3167103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10271, 2583, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PEDRO LESSA', 51177, 3167103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10272, 11169, 'CARTORIO REGISTRO DE IMOVEIS', 44941, 3167103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10273, 11170, 'TABELIONATO DE PROTESTO DE TITULOS DE CREDITO E OUTROS DCS. DE DIVIDA', 60558, 3167103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10274, 11171, 'CARTORIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIS E PESSOAS JURIDICAS', 43646, 3167103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10275, 11172, 'CATORIO DO 1º OFICIO DE NOTAS', 45344, 3167103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10276, 2584, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE DEPUTADO AUGUSTO CLEMENTINO', 51193, 3167103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10277, 3526, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50369, 3167103, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10278, 11173, 'SETE LAGOAS - CARTORIO DE REGISTRO DE IMOVEIS 2 OFICIO', 59899, 3167202, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10279, 11174, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 47936, 3114006, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10280, 11175, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 152538, 3114105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10281, 1896, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35642, 3114105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10282, 11176, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS', 152462, 3114105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10283, 11177, 'CARTORIO DE REGISTRO DE IMOVEIS', 38711, 3114105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10284, 11178, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 150912, 3114105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10285, 11179, 'OFICIO DO 1º TABELIONATO DE NOTAS', 58867, 3114105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10286, 11180, '2º TABELIONATO DE NOTAS ', 153528, 3114105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10287, 11181, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS JURIDICAS', 35444, 3114105, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10288, 11182, 'CARTORIO DO 1º OFICIO DE TABELIONATO DE NOTAS DE CARMO DO CAJURU', 40956, 3114204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10289, 1898, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS DE CARMO DO CAJURU', 54544, 3114204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10290, 11183, 'CARTORIO DE REGISTRO DE IMOVEIS', 38612, 3114204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10291, 7434, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE CARMO DO CAJURU', 51011, 3114204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10292, 1897, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51946, 3114204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10293, 11184, 'OFICIO DO 1O TABELIONATO DE PROTESTO DE CARMO DO CAJURU', 47696, 3114204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10294, 11185, '2º TABELIONATO DE NOTAS ', 153536, 3114204, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10295, 11186, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 57471, 3114303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10296, 1899, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 44453, 3114303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10297, 11187, 'TABELIONATO DE PROTESTO DE TITULOS', 46243, 3114303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10298, 11188, 'REGISTRO DE IMOVEIS', 57075, 3114303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10299, 11189, 'OFICIO DO 1° TABELIONATO DE NOTAS ', 47746, 3114303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10300, 11190, 'CARTORIO DO 2º OFICIO DE NOTAS DE CARMO DO PARANAIBA/MG', 41533, 3114303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10301, 1900, 'OF REGISTRO CIVIL E TABELIONATO DE NOTAS', 46219, 3114303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10302, 3720, 'SERVICOS DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO PRECARIAMENTE O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS ', 80838, 4102604, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10303, 7285, 'REGISTRO CIVIL E TABELIONATO BELA VISTA DA CAROBA', 142117, 4102752, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10304, 10162, 'TABELIONATO DE NOTAS ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 81109, 4102802, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10305, 4210, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 82917, 4102802, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10306, 10163, 'SERVICO DE REGISTRO DE IMOVEIS', 81885, 4102802, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10307, 4588, 'SERVICO DISTRITAL DE SANTA MARGARIDA', 82982, 4102802, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10308, 4211, 'SERVICO DISTRITAL DE BITURUNA', 81596, 4102901, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10309, 3721, 'SERVICO DISTRITAL DE BOA ESPERANCA', 86827, 4103008, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10310, 4589, 'SERVICO DISTRITAL DE BOA ESPERANCA DO IGUACU', 81141, 4103024, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10311, 4212, 'SERVICO DISTRITAL DE BOA VENTURA DE SAO ROQUE', 84731, 4103040, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10312, 4213, 'SERVICO DISTRITAL DE BOA VISTA DA APARECIDA', 87965, 4103057, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10313, 10164, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 142083, 4103107, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10314, 4590, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO, PRECARIAMENTE,  O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 81752, 4103107, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10315, 10165, 'SERVICO DE REGISTRO DE IMOVEIS', 85043, 4103107, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10316, 4214, 'SERVICO DISTRITAL DE BOM JESUS DO SUL ', 82123, 4103156, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10317, 4215, 'SERVICO DISTRITAL DE BOM SUCESSO', 87999, 4103206, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10318, 4591, 'SERVICO DISTRITAL DE BOM SUCESSO DO SUL', 85795, 4103222, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10319, 3727, '1º SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O 4º TABELIONATO DE NOTAS', 79848, 4104808, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10320, 10166, '3º SERVICO DE REGISTRO DE IMOVEIS', 80473, 4104808, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10321, 10167, '1º SERVICO DE REGISTRO DE IMOVEIS', 83022, 4104808, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10322, 4604, '2º SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O 5º TABELIONATO DE NOTAS ', 80176, 4104808, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10323, 10168, '3º TABELIONATO DE NOTAS', 82990, 4104808, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10324, 10169, '2º TABELIONATO DE NOTAS', 80325, 4104808, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10325, 10170, '1º TABELIONATO DE PROTESTO DE TITULOS', 83014, 4104808, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10326, 4236, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS, ACUMULANDO PRECARIAMENTE, O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOA JURIDICAS ', 84913, 4104907, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10327, 3728, 'SERVICO DISTRITAL DE SOCAVAO', 83337, 4104907, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10328, 10171, 'SERVICO DE REGISTRO DE IMOVEIA', 86975, 4104907, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10329, 4605, 'SERVICO DISTRITAL DE ABAPAN', 82560, 4104907, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10330, 10172, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, TABELIONATO DE PROTESTO DE TITULOS', 88211, 4104907, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10331, 6542, 'SERVICO DE REGISTRO DE IMOVEIS ACUMULADO PRECARIAMENTO COM SERVICO DE REGISTRO CIVIL E TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 86090, 4105003, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10332, 10173, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTOS DE TITULOS', 87551, 4105003, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10333, 10174, 'SERVICO DE REGISTRO DE IMOVEIS', 87080, 4105102, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10334, 10175, 'TABELIONATO DE NOTAS E PROTESTOS', 87866, 4105102, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10335, 3729, 'CARTORIO DO REGISTRO CIVIL E TITULOS E DOCUMENTOS', 82602, 4105102, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10336, 4237, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 84673, 4105201, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10337, 10176, 'TABELIONATO DE NOTAS, ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 87650, 4105201, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10338, 3730, 'SERVICO DISTRITAL DE CEU AZUL', 86231, 4105300, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10339, 10177, 'TABELIONATO DE NOTAS,ACUMULANDO, PRECARIAMENTE, O TABELIONATO DE PROTESTO DE TITULOS', 88195, 4105409, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10340, 4606, 'SERVICO DE REGISTRO DE IMOVEIS, ACUMULANDO, PRECARIAMENTE, O SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E O SERVICO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 83055, 4105409, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10341, 10499, 'CARTORIO 1º OFICIO - SERVICO NOTARIAL E REGISTRAL', 69146, 2506004, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10342, 10500, 'SERVICO DE REGISTRO DE DISTRIBUICAO EXTRAJUDICIAL', 72900, 2506004, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10343, 10501, 'SERVICO NOTARIAL MARTINS', 145227, 2506004, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10344, 3876, 'SERVICO REGISTRAL LYRA', 72868, 2506004, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10345, 3877, 'CARTORIO DO REGISTRO CIVIL DE FAGUNDES', 70847, 2506103, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10346, 3878, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 70896, 2506202, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10347, 3879, 'CARTORIO DE REGISTRO CIVIL LUCENA DE MORAIS', 70029, 2506251, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10348, 10502, 'GUARABIRA CARTORIO 2º OFICIO', 72207, 2506301, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10349, 10503, 'SERVICO NOTARIAL E REGISTRAL EPAMINONDAS', 73023, 2506301, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10350, 10504, 'CAETES - CARTORIO DO UNICO OFICIO ', 73825, 2603207, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10351, 10505, 'CARTORIO UNICO DE NOTAS E REGISTOS PUBLICOS', 76885, 2603306, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10352, 4180, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS DE CALCADO PE', 75960, 2603306, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10353, 4051, 'CARTORIO DO REGISTRO CIVIL E TABELIAO DA CIDADE DE CALUMBI-PE', 75838, 2603405, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10354, 10506, 'CARTORIO EVA TENORIO DE BRITO', 76489, 2603454, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10355, 10507, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS E DE TITULOS E DOCUMENTOS PARTICULARES DE PESSOAS JURIDICAS DA COMARCA DE CAMARAGIBE', 76323, 2603454, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10356, 4181, 'CARTORIO DE REGISTRO CIVIL DA COMARCA DE CAMARAGIBE ', 74211, 2603454, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10357, 4052, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS - CAMOCIM DE SAO FELIX', 75622, 2603504, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10358, 10508, 'CARTORIO DO OFICIO UNICO', 75028, 2603504, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10359, 4053, 'CARTORIO DO REGISTRO CIVIL DE CAMUTANGA', 75846, 2603603, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10360, 10509, '1º OFICIO', 73536, 2603702, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10361, 10510, 'CARTORIO DO 2 OFICIO', 150847, 2603702, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10362, 4054, 'CARTORIO DE REGISTRO CIVIL DO MUNICIPIO E COMARCA DE CANHOTINHO/PE', 74625, 2603702, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10363, 4055, 'CARTORIO DE REGISTRO CIVIL DE CAPOEIRAS', 74401, 2603801, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10364, 10511, 'CARTORIO DO UNICO OFICIO DE CAPOEIRAS-PE', 76463, 2603801, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10365, 4057, 'CARTORIO MASCENA VERAS - REGISTRO CIVIL DAS PESSOAS NATURAIS', 149971, 2603900, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10366, 10512, 'CARTORIO UNICO DE NOTAS E REGISTROS PUBLICOS', 76901, 2603900, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10367, 4056, 'TB MEDEIROS- SERVICO REGISTRAL DE PESSOAS NATURAIS', 77750, 2603900, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10368, 10513, 'CARTORIO DE REGISTRO CIVIL DE CARNAUBEIRA DA PENHA-PE', 74419, 2603926, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10369, 4058, 'CARTORIO DO REGISTRO CIVIL DE CARPINA', 75853, 2604007, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10370, 10514, 'CARTORIO DO 1º OFICIO', 74807, 2604007, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10371, 10515, 'CARTORIO DO 2º OFICIO NOTAS E PROTESTOS', 74955, 2604007, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10372, 10516, '1º R.G.I E TABELIONATO', 73551, 2604106, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10373, 3875, 'CARTORIO DE REGISTRO CIVIL DE EMAS', 69765, 2505907, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10374, 4061, 'CARTORIO DO REGISTRO CIVIL DO 2º DISTRITO DE CARUARU - PE', 76042, 2604106, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10375, 10517, 'CARUARU - CARTORIO DO 2º OFICIO DE NOTAS', 77073, 2604106, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10376, 4060, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DA 2ª ZONA JUDICIARIA', 75630, 2604106, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10377, 4059, 'CARTORIO DE REGISTRO CIVIL DA 1ª ZONA JUDICIARIA', 74195, 2604106, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10378, 10518, '3º SERVICO NOTARIAL E DE PROTESTO', 73718, 2604106, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10379, 10519, '4CARTORIO E TABELIONATO', 73734, 2604106, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10380, 4062, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 73866, 2604155, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10381, 4063, 'CARTORIO UNICO', 130450, 2604205, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10382, 4182, 'CARTORIO UNICO DO REGISTRO CIVIL DE CEDRO', 76984, 2604304, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10383, 4064, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE CHA DE ALEGRIA', 74674, 2604403, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10384, 4065, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS COMARCA DE CHA GRANDE PE', 74302, 2604502, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10385, 10520, 'CARTORIO REGISTRO CIVIL', 76604, 2604601, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10386, 10521, '1º SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS DA 1ª CIRCUNSCRICAO', 61994, 5002704, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10387, 10522, 'SERVICO DE REGISTRO DE IMOVEIS DA 2ª CIRCUNSCRICAO ', 154344, 5002704, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10388, 10523, '6º SERVICO NOTARIAL', 61911, 5002704, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10389, 10524, '1º TABELIONATO DE PROTESTO', 62364, 5002704, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10390, 3593, '9º SERVICO NOTARIAL E DE REGISTRO CIVIL - 2ª CIRCUNSCRICAO', 62000, 5002704, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10391, 10525, '7º SERVICO NOTARIAL', 154336, 5002704, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10392, 2772, 'MIRALTA CARTORIO DE PAZ REGISTRO CIVIL E NOTAS', 46086, 3143302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10393, 2298, 'CARTORIO DE PAZ REGISTRO CIVIL E NOTAS DE SAO JOAO DA VEREDA', 34686, 3143302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10394, 10813, '1º OFICIO DE NOTAS DE MONTES CLAROS', 32086, 3143302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10395, 10814, 'CARTORIO DO 3O. OFICIO DE NOTAS', 41624, 3143302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10396, 2301, 'VILA NOVA DE MINAS CARTORIO DE PAZ E NOTAS', 61549, 3143302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10397, 6565, 'OFICIO DO REGISTRO CIVIL E NOTAS DE SANTA ROSA DE LIMA', 34553, 3143302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10398, 10815, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48603, 3143302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10399, 2773, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS DO DISTRITO DE NOVA ESPERANCA/MG', 54908, 3143302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10400, 2300, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE SAO PEDRO DA GARCA', 57935, 3143302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10401, 10816, 'CARTORIO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 40220, 3143302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10402, 10817, 'OFICIO DO 2º REGISTRO DE IMOVEIS DE MONTES CLAROS', 49304, 3143302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10403, 6564, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ERMIDINHA', 37887, 3143302, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10404, 2302, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 46755, 3143450, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10405, 2304, 'OFICIO DO REGISTRO CIVIL/FREI ORLANDO', 53819, 3143500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10406, 10818, 'TABELIONATO DE PROTESTO DE TITULOS POLCARO GARCIA', 60756, 3143500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10407, 2303, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50831, 3143500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10408, 10819, '2º TABELIONATO DE NOTAS ', 153627, 3143500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10409, 10820, 'OFICIO DO REGISTRO DE IMOVEIS', 53975, 3143500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10410, 10821, '1º TABELIONATO DE NOTAS DE MORADA NOVA', 32342, 3143500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10411, 10822, 'OF.DO REG. TITS. E DOCS. E CIVIL DAS PESSOAS JURIDICAS', 46250, 3143500, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10412, 2774, 'CARTORIO REGISTRO CIVIL E NOTAS', 44560, 3143609, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10413, 2305, 'CARTORIO REGISTRO CIVIL E NOTAS', 44636, 3143708, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10414, 2775, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE MUNHOZ', 37911, 3143807, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10415, 7018, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE BELISARIO', 44172, 3143906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10416, 10823, 'OFICIO DO 2º TABELIONATO DO NOTAS DE MURIAE', 32540, 3143906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10417, 10824, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 60582, 3143906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10418, 10825, 'OFICIO DO 1º TABELIONATO DO NOTAS DE MURIAE', 61317, 3143906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10419, 2810, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52068, 3152303, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10420, 2362, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52936, 3152402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10421, 7029, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 37986, 3152402, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10422, 10826, 'TABELIONATO DE REGISTRO DE PROTESTO DE TITULOS E DIVIDAS ', 61051, 3152501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10423, 10827, 'CARTORIO DO 1º TABELIONATO DE NOTAS', 41012, 3152501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10424, 2364, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 55772, 3152501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10425, 10828, 'OFICIO DO REGISTRO DE IMOVEIS', 54023, 3152501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10426, 10829, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54452, 3152501, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10427, 2910, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 36111, 3126703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10428, 11271, 'CARTORIO DO 2º OFICIO DE NOTAS', 41368, 3126703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10429, 11272, 'SERVICO DE REGISTRO DE IMOVEIS DE FRANCISCO SA-MG', 58628, 3126703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10430, 11273, 'TABELIONATO DE PROTESTO DE TITULOS', 60335, 3126703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10431, 2913, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE FRANCISCOPOLIS', 53785, 3126752, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10432, 2912, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ANTONIO FERREIRA', 52837, 3126752, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10433, 2076, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE FREI GASPAR', 51409, 3126802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10434, 2077, 'CARTORIO BRASILEIRO', 33837, 3126901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10435, 2914, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53108, 3126950, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10436, 2915, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 37135, 3127008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10437, 2916, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 42820, 3127008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10438, 2078, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 46573, 3127057, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10439, 2079, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL', 145318, 3127073, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10440, 11274, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 47399, 3127107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10441, 2917, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53140, 3127107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10442, 11275, 'CARTORIO DE REGISTRO DE IMOVEIS DE FRUTAL', 39107, 3127107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10443, 2080, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 55798, 3127107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10444, 11276, '1º TABELIONATO DE PROTESTOS DE TITULOS DA COMARCA DE FRUTAL', 35097, 3127107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10445, 11277, 'CARTORIO DO 2º OFICIO DE NOTAS', 41327, 3127107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10446, 11278, 'PRIMEIRO TABELIONATO DE NOTAS', 55392, 3127107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10447, 2918, 'SERVICO REGISTRO CIVIL NOTAS FUNILANDIA-MG', 59840, 3127206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10448, 11279, 'SEGUNDO TABELIONATO DE NOTAS DE GALILEIA', 58107, 3127305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10449, 6898, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50617, 3127305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10450, 2081, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SAPUCAIA DO NORTE', 36715, 3127305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10451, 11280, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48587, 3127305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10452, 11281, 'CARTORIO DO PRIMEIRO OFICIO DE NOTAS', 41806, 3127305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10453, 11282, 'OFICIO DE REG. DE TIT. E DOC. E CIVIL DAS PESSOAS JURIDICAS', 50229, 3127305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10454, 11283, 'CARTORIO DE REGISTRO DE IMOVEIS LOPES', 39230, 3127305, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10455, 2919, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 46797, 3127339, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10456, 2920, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36970, 3127354, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10457, 10249, 'SERVICO DE DISTRIBUICAO EXTRAJUDICIAL', 72785, 2500601, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10458, 10250, 'VELTON BRAGA SERVICO NOTARIAL E REGISTRAL', 73403, 2500601, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10459, 3451, 'CARTORIO DE REGISTRO CIVIL DE AMPARO', 69740, 2500734, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10460, 10251, 'CARTORIO DE DISTRUBUICAO DE ARACAGI', 154179, 2500809, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10461, 3453, 'ARACAGI CARTORIO DISTRITAL NOTAS', 68999, 2500809, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10462, 3454, 'CARTORIO DO REGISTRO CIVIL', 70649, 2500908, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10463, 10252, 'SERVICO DE DISTRIBUICAO EXTRAJUDICIAL', 72801, 2500908, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10464, 10253, 'SERVICO NOTARIAL E REGISTRAL', 72942, 2500908, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10465, 10254, 'REGISTRO CIVIL DA COMARCA DE ARARUNA', 154674, 2501005, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10466, 10255, 'SERVENTIA EXTRA-JUDICIAL', 72694, 2501005, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10467, 10256, 'CARTORIO MARTINS DE SOUSA', 71654, 2501005, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10468, 3458, 'CARTORIO DO REGISTRO CIVIL DE AREIA', 70797, 2501104, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10469, 3456, 'CARTORIO DISTRITAL DE MATA LIMPA', 70284, 2501104, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10470, 10257, 'CARTORIO MAIA DE ALBUQUERQUE', 71605, 2501104, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10471, 3455, 'CARTORIO DISTRITAL DE MUQUEM', 70342, 2501104, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10472, 3457, 'MARGUILEIDE ROQUE CANANEA', 72298, 2501104, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10473, 10258, '2º SERVICO NOTARIAL ', 68825, 2501104, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10474, 10259, 'SERVICO DE DISTRIBUICAO EXTRAJUDICIAL', 72793, 2515500, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10475, 4173, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS DE SERRA BRANCA', 71266, 2515500, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10476, 4175, 'CARTORIO DISTRITAL DE NOTAS', 70300, 2515609, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10477, 4176, 'CARTORIO MARIA AGLAIVA RAMALHO', 71621, 2515708, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10478, 3986, 'SERRA REDONDA CARTORIO DO REGISTRO CIVIL', 72678, 2515807, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10479, 10260, 'CARTORIO J PEREIRA', 71555, 2515906, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10480, 10261, 'CARTORIO DE DISTRIBUICAO', 69377, 2515906, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10481, 3987, 'CARTORIO UNICO DE REGISTRO CIVIL DE PESSOAS  NATURAIS ', 71910, 2515906, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10482, 3988, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 71142, 2515930, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10483, 3989, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SOBRADO', 69930, 2515971, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10484, 10262, 'CARTORIO ', 69120, 2516003, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10485, 10263, 'SERVICO DE DISTRIBUICAO EXTRAJUDICIAL DE SOLANEA', 72835, 2516003, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10486, 6661, 'CARTORIO DE REGISTRO CIVILI DAS PESSOAS NATURAIS', 70052, 2516003, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10487, 10264, 'CARTORIO DO REGISTRO DE IMOVEIS', 71290, 2516102, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10488, 3990, 'CARTORIO ISBELO GUEDES', 71530, 2516102, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10489, 10265, 'SEGUNDO CARTORIO NOTARIAL E REGISTRAL', 72652, 2516102, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10490, 10266, 'CARTORIO DISTRIBUIDOR EXTRAJUDICIAL', 70193, 2516102, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10491, 3991, 'CARTORIO DO REGISTRO CIVIL DE SOSSEGO', 70987, 2516151, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10492, 10267, 'CARTORIO DO 2 OFICIO ANTONIO GONCALVES', 70482, 2516201, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10493, 10268, 'SOUSA CARTORIO 3º OFICIO-NOTARIAL E REGISTRAL', 73338, 2516201, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10494, 10269, 'SOUSA CARTORIO 1º OFICIO DE NOTAS ', 73320, 2516201, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10495, 10270, 'CARTORIO DE DITRIBICAO EXTRAJUDICIAL', 69583, 2516201, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10496, 3992, 'SERVICO REGISTRAL MARIA ALICE MORAIS LANGBEHN', 70789, 2516201, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10497, 10271, 'SERVICO NOTARIAL E REGISTRAL VITON', 73072, 2516300, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10498, 10272, 'EZELDJARA SIMONE ESTEVAM DA SILVA', 72157, 2516300, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10499, 10273, 'CARTORIO DISTRITAL DE PIO X', 154278, 2516300, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10500, 3993, 'SERVICO DE REGISTRO CIVIL', 72850, 2516300, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10501, 10274, 'SERVICO NOTARIAL E REGISTRAL', 72926, 2516508, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10502, 10275, 'CARTORIO DE DISTRIBUICAO EXTRAJUDICIAL DE TAPEROA-PB', 69559, 2516508, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10503, 3995, 'CARTORIO DO REGISTRO CIVIL ', 70698, 2516508, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10504, 3996, 'TAVARES CARTORIO UNICO DE NOTAS E REGISTRO CIVIL', 73353, 2516607, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10505, 10276, 'SERVICO DE DISTRIBUICAO EXTRAJUDICIAL', 72777, 2516706, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10506, 10277, 'SERVICO NOTARIAL E REGISTRAL - OFICIO UNICO', 72975, 2516706, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10507, 3997, 'CARTORIO DO REGISTRO CIVIL DE TEIXEIRA PARAIBA', 71001, 2516706, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10508, 3998, 'CARTORIO DE REGISTRO CIVIL E NOTAS JOAQUIM TORQUATO ALVES', 69955, 2516755, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10509, 3999, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE TRIUNFO', 73387, 2516805, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10510, 10278, 'SERVENTIA DE DISTRIBUICAO EXTRAJUDICIAL', 72686, 2516904, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10511, 10279, 'SERVICO NOTARIAL E REGISTRAL MOUSINHO NONATO - UNICO OFICIO', 73056, 2516904, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10512, 10280, 'REGISTRO CIVIL DE PESSOAS NATURAIS DO DISTRITO DE JOAO BOSCO DA COMARCA DE UIRAUNA', 145300, 2516904, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10513, 10590, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 61754, 5003751, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10514, 10591, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 62778, 5003801, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10515, 10592, 'SERVICO NOTARIAL E TABELIOINATO DE PROTESTO ', 62539, 5003801, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10516, 6998, '2º SERVICO NOTARIAL E DE REGISTRO CIVIL', 61739, 5003801, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10517, 10593, '1º SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS, TILULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO ', 62489, 5004007, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10518, 3096, '2º SERVICO NOTARIAL E DE REGISTRO CIVIL', 62034, 5004007, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10519, 3097, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE GUIA LOPES DA LAGUNA', 63073, 5004106, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10520, 3098, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 62174, 5004304, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10521, 10594, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS, E TABELIONATO DE PROTESTO', 61762, 5004304, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10522, 3099, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 62950, 5004403, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10523, 10595, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 63156, 5004403, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10524, 6999, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 62703, 5004502, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10525, 10596, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS, CIVIL DE PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 148825, 5004502, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10526, 10597, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTOS.', 63149, 5004601, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10527, 3100, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 61697, 5004601, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10528, 3101, 'SERVICO NOTARIAL E DE REGISTRO CIVIL ', 62349, 5004700, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10529, 10598, 'SERVICO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 63172, 5004700, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10530, 3102, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE JAPORA', 62596, 5004809, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10531, 3103, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE JARAGUARI', 63198, 5004908, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10532, 10599, '1° SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO ', 61598, 5005004, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10533, 7000, '2º SERVICO NOTARIAL E DE REGISTRO CIVIL ', 61820, 5005004, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10534, 3122, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE JATEI', 62604, 5005103, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10535, 3123, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE JUTI', 62687, 5005152, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10536, 3124, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE LADARIO', 63008, 5005202, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10537, 3125, 'SERVICO NOTARIAL  E DE REGISTRO CIVIL DE LAGUNA CARAPA', 62570, 5005251, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10538, 7001, '2º SERVICO NOTARIAL E DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 62612, 5005400, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10539, 10600, '1° SERVICO NOTARIAL E DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS E TABELIONATO DE PROTESTO', 62760, 5005400, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10540, 2535, 'TABELIONATO VISTA ALEGRE NOTAS E REGISTRO CIVIL', 62323, 5005400, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10541, 10601, 'CARTORIO DO DISTRITO DE ANTONIO LEMOS', 149468, 1501808, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10542, 3066, 'CARTORIO DO UNICO OFICIO DE SAO MIGUEL DOS MACACOS', 67405, 1501808, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10543, 10602, 'CARTORIO DO DISTRITO DE ARAMA', 149492, 1501808, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10544, 10603, 'CARTORIO DO DISTRITO DE MUTUTI', 149450, 1501808, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10545, 2539, 'CARTORIO SANTANA DE BUJARU', 68163, 1501907, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10546, 3068, 'CARTORIO DE NOTAS E REGISTRO CIVIL DE BUJARU', 66043, 1501907, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10547, 2608, 'CARTORIO LAURO CARMEZIN DA VILA CARACARA DO ARARI - CACHOEIRA DO ARARI', 67785, 1502004, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10548, 2607, 'CARTORIO LEAO JUNIOR 2º OFICIO - CACHOEIRA DO ARARI', 67793, 1502004, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10549, 10604, 'CARTORIO HUGO PEPES DE LEAO - CACHOEIRA DO ARAI', 67751, 1502004, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10550, 2606, 'CARTORIO DE REGISTRO CIVIL DA SEGUNDA CIRCUNSCRICAO DA COMARCA DE CACHOEIRA DO ARARI', 66159, 1502004, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10551, 2612, 'CARTORIO DE REGISTRO CIVIL DA VILA DE CARAPAJO', 66167, 1502103, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10552, 10605, 'CARTORIO EXTRAJUDICIAL DO 2º OFICIO DE CAMETA', 67629, 1502103, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10553, 10906, 'OFICIO DO 2º TABELIONATO DE NOTAS DE RAUL SOARES', 554, 3154002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10554, 10907, 'CARTORIO DO 1º OFICIO DE NOTAS', 40691, 3154002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10555, 2373, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO SEBASTIAO DO OCULO', 53678, 3154002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10556, 2372, 'SERVICO REGISTRAL E NOTARIAL DE SAO VICENTE DA ESTRELA', 59683, 3154002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10557, 2893, 'SERVICO REGISTRAL E NOTARIAL DE VERMELHO VELHO', 59691, 3154002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10558, 6566, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS ', 38224, 3145455, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10559, 2323, 'OFICIO DO REGISTRO CIVIL E TABELIONATO NOTAS', 53769, 3145505, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10560, 2846, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54536, 3145604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10561, 11317, 'REGISTRO DE IMOVEIS', 57166, 3145604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10562, 2781, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 56804, 3145604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10563, 11318, 'TABELIONATO DE PROTESTOS DE TITULOS DA COMARCA DE OLIVEIRA', 59931, 3145604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10564, 2847, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE OLIVEIRA', 56275, 3145604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10565, 11319, 'OFICIO DO SEGUNDO TABELIONATO DE NOTAS', 54692, 3145604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10566, 11320, 'CARTORIO DO 1º OFICIO DE NOTAS DE OLIVEIRA', 40873, 3145604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10567, 2782, 'CARTORIO DE REGISTRO CIVIL P. NATURAIS E TABELIONATO DE NOTAS', 38380, 3145703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10568, 2783, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 38299, 3145802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10569, 2036, 'CARTORIO REGISTRO CIVIL E NOTAS', 33357, 3115607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10570, 2037, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 38281, 3115706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10571, 6892, 'CARTORIO DE PAZ E NOTAS', 34306, 3115706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10572, 2038, 'CARTORIO DE PAZ NOTAS DE CENTRALINA', 34637, 3115805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10573, 2039, 'CARTORIO DE CHACARA ', 33928, 3115904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10574, 2040, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 46789, 3116001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10575, 2042, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PROFESSOR SPERBER', 36806, 3116001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10576, 2041, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 47019, 3116001, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10577, 6949, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51748, 3116100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10578, 2044, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE SERRA DAS ARARAS', 44750, 3116159, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10579, 2043, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CHAPADA GAUCHA', 36277, 3116159, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10580, 11321, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL', 53066, 3116209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10581, 2045, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 37069, 3116209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10582, 2046, 'CARTORIO DE REGISTRO CIVIL E ANEXO DE NOTAS', 36533, 3116308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10583, 2047, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52928, 3116407, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10584, 2049, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE VISTA ALEGRE', 53272, 3116506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10585, 2048, 'SERVICO REGISTRAL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS DE CLARO DOS POCOES', 54742, 3116506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10586, 2050, 'REGISTRO CIVIL DAS PESSOAS NATURAIS  E TABELIONATO DE NOTAS', 56200, 3116605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10587, 11322, 'TABELIONATO DE PROTESTO DE TITULOS E OUTROS DOCUMENTOS DE DIVIDA', 60749, 3116605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10588, 3232, 'SERVICO REGISTRAL E NOTARIAL', 65433, 5106851, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10589, 3233, 'CGJ/MT_1 CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRO DE JARUDORE/MT ', 64790, 5107008, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10590, 10302, 'SERVICO NOTARIAL E REGISTRAL DE ALTO COITE', 135467, 5107008, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10591, 10303, 'REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS DA COMARCA DE POXOREO', 65094, 5107008, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10592, 3235, 'SERVICO NOTARIAL REGISTRAL DAS PESSOAS NATURAIS', 65409, 5107008, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10593, 3234, '2º TABELIONATO DE NOTAS E PROTESTOS', 63735, 5107008, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10594, 10304, 'SERVICO REGISTRAL DE IMOVEIS E TIT. DOCUMENTOS DE PVA DO LESTE-MT', 65417, 5107040, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10595, 7593, 'CARTORIO DO REGISTRO CIVIL DE PRIMAVERA DE LESTE', 64501, 5107040, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10596, 3236, 'CARTORIO DO 2º OFICIO DA COMARCA DE QUERENCIA', 64410, 5107065, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10597, 10305, 'CARTORIO DO 1º OFICIO DE QUERENCIA/MT', 64204, 5107065, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10598, 7054, 'CGJ/MT_1 CARTORIO DE PAZ E NOTAS DE RESERVA DO CABACAL/MT', 64667, 5107156, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10599, 10306, '1º OFICIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS DA COMARCA DE RIBEIRAO CASCALHEIRA-MT', 63347, 5107180, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10600, 3237, 'SEGUNDO OFICIO DE NOTAS, PROTESTOS, REGISTRO CIVIL DE PESSOAS JURIDICAS E DE PESSOAS NATURAIS', 65102, 5107180, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10601, 10307, 'CARTORIO DE PAZ E REGISRO CIVIL E TABELIONATO', 63990, 5107198, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10602, 3238, 'CGJ/MT_1 CARTORIO DE PAZ E NOTAS DE SALTO DO CEU', 64683, 5107206, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10603, 10308, 'CGJ/MT CARTORIO DO 1º OFICIO', 64923, 5107206, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10604, 3239, 'CGJ/MT_1 2° OFICIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 64568, 5107206, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10605, 3243, 'CGJ/MT_ CARTORIO DE REGISTRO CIVIL DE NOVA GALILEIA', 64766, 5107602, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10606, 10309, 'CARTORIO DO QUARTO OFICIO', 64485, 5107602, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10607, 3242, 'CGJ/MT_1 CARTORIO DE PAZ E NOTAS DE BOA VISTA/MT', 64634, 5107602, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10608, 10310, '1° TABELIONATO E REGISTRO DE IMOVEIS', 63297, 5107602, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10609, 10311, 'TERCEIRO TABELIONATO DE NOTAS REGISTRO DE TITULOS E DOCMUENTOS PESSOA JURIDICA', 65557, 5107602, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10610, 3240, 'CARTORIO DE PAZ DE VILA OPERARIA', 63925, 5107602, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10611, 10312, 'CARTORIO DISTRIBUIDOR EXTRA JUDICIAL DA COMARCA DE AREIA', 70185, 2501104, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10612, 3459, 'GILVANEIDE GOMES DE FREITAS', 72199, 2501153, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10613, 3460, 'SERVICO NOTARIAL E REGISTRAL DE AREIAL', 73007, 2501203, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10614, 3461, 'CARTORIO DO REGISTRO CIVIL', 331, 2501302, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10615, 10313, 'SERVENTIA EXTRAJUDICIAL - DISTRIBUICAO -', 72702, 2501302, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10616, 10314, 'CARTORIO SANTOS', 71795, 2501302, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10617, 3462, 'MARIA DA SALETE BATISTA', 72306, 2501351, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10618, 3463, 'CARTORIO FERNANDES NETO', 71464, 2501401, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10619, 3465, 'CARTORIO DISTRITAL DO TABOLEIRO', 73197, 2501500, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10620, 7066, 'CARTORIO DE REGISTRO CIVIL', 69666, 2501500, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10621, 10315, 'SERVICO DE DISTRIBUICAO EXTRAJUDICIAL DE BANANEIRAS/PB', 72819, 2501500, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10622, 3464, 'SERVICOS NOTARIAL E REGISTRAL', 73312, 2501500, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10623, 10316, 'CARTORO JUDICIARIO 1 OFICIO ', 72017, 2501500, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10624, 10317, 'CARTORIO', 71985, 2501500, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10625, 3466, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 69880, 2501534, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10626, 10318, 'CARTORIO DE DISTRIBUICAO-EXTRA JUDICIAL DA COMARCA DE BARRA DE SANTA ROSA ', 69575, 2501609, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10627, 10319, 'SERVICO NOTARIAL E REGISTRAL PAULINO DA LUZ', 73064, 2501609, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10628, 3467, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 71167, 2501609, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10629, 3469, 'CARTORIO DEMOSTENES BELO BARBOSA', 70151, 2501575, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10630, 3468, 'SERVICOS NOTARIAIS E DE REGISTRO - SERVENTIA ELIAS FARIAS', 73304, 2501575, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10631, 3470, 'SERVICO NOTARIAL E REGISTRAL CIVIL DE BARRA DE SAO MIGUEL', 72991, 2501708, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10632, 10320, 'SANTIAGO PEREIRA - SERVICO NOTARIAL E REGISTRAL', 72603, 2501807, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10633, 10321, '2ºOFICIO DE NOTAS CARTORIO ANGELA CAETANO', 68841, 2501807, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10634, 10322, 'CARTORIO DE DISTRIBUICAO EXTRAJUDICIAL MACAU RIBEIRO', 69567, 2501807, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10635, 3814, '1º SERVICO REGISTRAL GLORIA DE ARAUJO SILVA', 68742, 2501807, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10636, 3471, '2º. SERVICO REGISTRAL DAS PESSOAS NATURAIS MARINALVA LIMA', 68809, 2501807, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10637, 10323, 'CARTORIO DE DISTRIBUICAO EXTRAJUDICIAL DE BELEM - PARAIBA', 69526, 2501906, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10638, 10622, 'CARTORIO DE DISTRIBUICAO EXTRAJUDICIAL DE JUAZEIRINHO - PB', 69534, 2507705, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10639, 10623, 'CARTORIO UNICO DE NOTAS/JUAZEIRINHO', 71878, 2507705, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10640, 3907, 'CARTORIO JOSE DA CUNHA', 71571, 2507804, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10641, 3908, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 71159, 2507903, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10642, 3909, 'CARTORIO UNICO DE NOTAS E DO REGISTRO CIVIL', 71860, 2508000, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10643, 3910, 'CARTORIO FRANCISCO JOSE DE SOUSA', 71480, 2508109, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10644, 3911, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 71183, 2508208, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10645, 3912, 'SERVICO CIVIL DAS PESSOAS NATURAIS E NOTAS DE LAGOA SECA/PB', 72736, 2508307, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10646, 3913, 'CARTORIO DE REGISTRO CIVIL E NOTAS DO LASTRO', 69948, 2508406, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10647, 3914, 'CARTORIO DE REGISTRO CIVIL', 69682, 2508505, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10648, 3915, 'LOGRADOURO CARTORIO DO REGISTRO CIVIL E NOTAS', 72272, 2508554, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10649, 4149, 'CARTORIO DE REGISTRO CIVIL CUNHA DOS SANTOS', 69724, 2508604, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10650, 4079, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS ', 76273, 2605806, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10651, 4080, 'CARTORIO DE REGISTROS PUBLICOS, TABELIONATO DE NOTAS E PROTESTOS DE TITULOS', 74757, 2605905, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10652, 4250, 'CARTORIO  DISTRITAL DE CRUZEIRO DO IGUACU-PR', 80960, 4106571, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10653, 10201, 'TABELIONATO DE NOTAS DA COMARCA DE CRUZEIRO DO OESTE', 80150, 4106605, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10654, 10202, 'TABELIONATO DE PROTESTO DE TUPACIGUARA', 60764, 3169604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10655, 2722, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56010, 3169604, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10656, 2723, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 35816, 3169703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10657, 10203, 'CARTORIO DO 1º OFICIO DE NOTAS', 33985, 3169703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10658, 10204, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39677, 3169703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10659, 10205, 'CARTORIO DE REGISTRO DE IMOVEIS ', 38794, 3169703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10660, 2594, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE CACARATIBA', 42986, 3169703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10661, 10206, '2º TABELIONATO DE NOTAS ', 153692, 3169703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10662, 10207, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48470, 3169703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10663, 7043, 'SERVICO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 58495, 3169802, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10664, 10208, 'TABELIONATO DE PROTESTO DA COMARCA DE UBA-MG', 48918, 3169901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10665, 2595, 'REGISTRO CIVIL E NOTAS', 56713, 3169901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10666, 2724, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51938, 3169901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10667, 2532, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50922, 3169901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10668, 7044, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 56861, 3169901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10669, 10209, 'OFICIO DO 3º TABELIONATO DE NOTAS', 49981, 3169901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10670, 10210, 'OFICIO DO SEGUNDO TABELIONATO DE NOTAS', 54684, 3169901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10671, 10211, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTO E CIVIL DAS PESSOAS JURIDICAS', 39404, 3169901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10672, 10212, 'UBA CARTORIO DO 1º OFICIO DE NOTAS', 61481, 3169901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10673, 10213, 'CARTORIO DE REGISTRO DE IMOVEIS', 38919, 3169901, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10674, 2596, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE BENTOPOLIS DE MINAS', 42960, 3170008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10675, 3544, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE UBAI', 37622, 3170008, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10676, 6984, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 46995, 3170057, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10677, 10214, 'CARTORIO DO 3° OFICIO DE NOTAS', 41632, 3170107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10678, 10215, 'SEGUNDO OFICIO DE REGISTRO DE IMOVEIS', 58008, 3170107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10679, 10216, 'TABELIONATO DE PROTESTO DE TITULOS', 60368, 3170107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10680, 10217, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 57430, 3170107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10681, 2725, '1º REGISTRO CIVIL DAS PESSOAS NATURAIS DE UBERABA', 35741, 3170107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10682, 2597, 'OFICIO DO 3º REGISTRO CIVIL DAS PESSOAS NATURAIS', 49932, 3170107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10683, 3545, 'OFICIO DO 2ª REGISTRO CIVIL DAS PESSOAS NATURAIS DE UBERABA', 49189, 3170107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10684, 10218, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48256, 3170107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10685, 10219, '1° OFICIO DE REGISTRO DE IMOVEIS DE UBERABA-MG', 31963, 3170107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10686, 10220, 'CARTORIO DO SEGUNDO OFICIO DE NOTAS DE UBERABA', 43836, 3170107, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10687, 10221, 'UBERLANDIA CARTORIO PRIMEIRO OFICIO DE NOTAS', 61499, 3170206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10688, 10222, 'CARTORIO 3º OFICIO DE NOTAS', 33720, 3170206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10689, 7339, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS - MARTINESIA', 50997, 3170206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10690, 10223, '2º TABELIONATO DE NOTAS DE UBERLANDIA/MG', 57992, 3170206, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10691, 10224, '1º OFICIO DE MIRASSOL D´OESTE', 63313, 5105622, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10692, 7081, 'CARTORIO DO 2º OFICIO ', 64386, 5105903, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10693, 3212, 'CGJ/MT_1 CARTORIO DE PAZ E NOTAS DE COQUEIRAL', 64642, 5105903, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10694, 10225, 'CARTORIO DE 1º OFICIO DE NOBRES', 63875, 5105903, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10695, 3213, '2º SERVICO NOTARIAL E REGISTRAL DE NORTELANDIA', 63693, 5106000, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10696, 10226, '1º SERVICO NOTARIAL E REGISTRAL DE NORTELANDIA', 63479, 5106000, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10697, 3214, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE NOSSA SENHORA DO LIVRAMENTO', 64055, 5106109, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10698, 3051, 'CARTORIO DO REGISTRO CIVIL', 66936, 1501451, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10699, 3048, 'CARTORIO DE REGISTRO CIVIL NASCIMENTO E OBITOS 1º OFICIO', 66431, 1501501, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10700, 3053, 'CARTORIO DO UNICO OFICIO DE BENEVIDES', 67892, 1501501, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10701, 3052, 'CARTORIO DE NOTAS TRAVASSOS', 66068, 1501501, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10702, 3054, 'CARTORIO XAVIER ', 68387, 1501576, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10703, 3055, 'CARTORIO DE REGISTRO CIVIL E TABELINATO DE NOTAS', 66423, 1501600, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10704, 3057, 'CARTORIO DA VILA TIJOCA', 65961, 1501709, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10705, 7061, 'CARTORIO DE REGISTRO CIVIL DA VILA DO TREME', 66985, 1501709, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10706, 10549, 'CARTORIO DO 2º OFICIO', 130542, 1501709, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10707, 3062, 'CARTORIO DE VILA DE CARATATEUA', 66605, 1501709, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10708, 3056, 'CARTORIO DE BACURITEUA', 65995, 1501709, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10709, 3058, 'CARTORIO DE REGISTRO CIVIL DE NOVA MOCAJUBA', 66084, 1501709, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10710, 3060, 'CARTORIO DO ALMOCO', 66902, 1501709, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10711, 3061, 'CARTORIO DE NOVA CANINDE - BRAGANCA', 66076, 1501709, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10712, 10550, 'CARTORIO ANTONIO PEREIRA', 65771, 1501709, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10713, 3059, 'CARTORIO DO 3º OFICIO -  CARTORIO MARTINS', 66845, 1501709, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10714, 3063, 'CARTORIO DO UNICO OFICIO DE BRASIL NOVO', 67165, 1501725, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10715, 3064, 'CARTORIO DO UNICO OFICIO FONSECA COSTA', 67538, 1501758, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10716, 3065, 'CARTORIO OFICIO UNICO DE BREU BRANCO ', 65581, 1501782, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10717, 10551, 'CARTORIO DO 1º OFICIO - REGISTRO DE IMOVEIS E TABELIONATO DE NOTAS', 66712, 1501808, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10718, 10552, 'CARTORIO DO DISTRITO DE MAPUA', 149484, 1501808, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10719, 10553, 'CARTORIO DO DISTRITO DE JACARE', 149443, 1501808, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10720, 10554, 'CARTORIO DO DISTRITO DE CURUMU', 149476, 1501808, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10721, 3067, 'CARTORIO DO 2º OFICIO - CARTORIO MATOS - BREVES', 66787, 1501808, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10722, 3880, 'CARTORIO DISTRITAL DE CACHOEIRA DOS GUEDES', 70243, 2506301, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10723, 10555, 'CARTORIO 3º OFICIO', 69187, 2506301, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10724, 10556, 'CARTORIO DE DISTRIBUICAO EXTRA JUDICIAL', 69419, 2506301, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10725, 4142, 'REGISTRO CIVIL DAS PESSOAS NATURAIS ', 72561, 2506301, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10726, 3881, 'CARTORIO DO REGISTRO CIVIL', 70631, 2506400, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10727, 10557, 'CARTORIA DE DITRIBUICAO', 69112, 2506400, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10728, 10558, 'CARTORIO DE NOTAS DO REGISTRO DE IMOVEIS', 69591, 2506400, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10729, 10548, 'CGJPA / CARTORIO DE RESGISTRO DE IMOVEIS - 2º OFICIO', 68403, 1501402, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10730, 10559, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE SANTO ANDRE ', 144972, 2506509, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10731, 10560, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE SANTO ANDRE ', 144964, 2506509, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10732, 4143, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 71126, 2506509, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10733, 3883, 'SERVICO DE REGISTRO CIVIL E NOTAS', 72389, 2506608, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10734, 3882, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 72553, 2506608, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10735, 3884, 'CARTORIO DE REGITRO CIVIL DE PESSOAS NATURAIS E NOTAS', 70128, 2502607, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10736, 3885, 'IMACULDA CARTORIO UNICO DE REGISTRO CIVIL', 72215, 2506707, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10737, 3886, 'SERVICO REGISTRAL CEU', 73122, 2506707, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10738, 4144, 'CARTORIO DE REGISTRO CIVIL', 69708, 2506806, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10739, 3887, 'CARTORIO DE REGISTRO CIVIL', 69633, 2506806, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10740, 10561, 'CARTORIO DO 1º OFICIO', 70441, 2506806, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10741, 10562, 'CARTORIO DE DISTRIBUICAO', 69369, 2506806, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10742, 10563, 'CARTORIO DO 2º OFICIO', 70516, 2506806, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10743, 10564, 'CARTORIO DO 2º OFICIO', 70532, 2506905, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10744, 10565, 'CARTORIO DO 1º OFICIO', 70466, 2506905, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10745, 3889, 'SERVICO REGISTRAL DE PESSOAS NATURAIS', 73189, 2506905, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10746, 3891, 'CARTORIO DO REGISTRO CIVIL DE GUARITA', 70854, 2506905, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10747, 3890, 'CARTORIO DISTRITAL DE REGISTRO CIVIL', 70334, 2506905, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10748, 10566, 'CARTORIO DE DISTRIBUICAO EXTRAJUDICIAL', 69492, 2506905, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10749, 10567, 'CARTORIO DO OFICIO NOTARIAL E REGISTRAL', 71522, 2507002, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10750, 10568, 'CARTORIO DE DISTRIBUICAO EXTRA JUD JOSE CLEUDO LOPES DA SILVA', 69401, 2507002, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10751, 3892, 'SERVICO REGISTRAL IRINEU RODRIGUES', 73270, 2507002, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10752, 10569, '1º OFICIO DE NOTAS SERVICO NOTARIAL E REGISTRAL JOSE BARROS SOBRINHO', 68684, 2507002, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10753, 3893, 'ITAPOROROCA CARTORIO DE REGISTRO E NOTAS', 72223, 2507101, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10754, 2743, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL', 35873, 3155207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10755, 2742, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL', 35865, 3155207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10756, 7079, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE RIO ESPERA', 56812, 3155207, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10757, 10863, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 57364, 3135100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10758, 10864, 'PROTESTO DE TITULOS', 55558, 3135100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10759, 10865, 'SERVICO NOTARIAL DO 2º OFICIO', 32730, 3135100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10760, 10866, 'OFICIO DO 1º TABELIONATO DO NOTAS DE JANAUBA', 40808, 3135100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10761, 2271, 'OFICIO REG CIVIL TABELIONATO DE NOTAS DE BARREIRO DA RAIZ', 54759, 3135100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10762, 6649, 'CARTORIO DE PAZ, REGISTRO CIVIL E NOTAS DO DISTRITO DE VILA NOVA DOS POCOES', 34736, 3135100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10763, 2270, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE QUEM-QUEM', 53645, 3135100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10764, 10867, 'REGISTRO DE IMOVEIS', 57182, 3135100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10765, 2272, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56150, 3135100, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10766, 2275, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50732, 3135209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10767, 10868, 'OFICIO DO 1º TABELIONATO DE NOTAS', 47944, 3135209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10768, 2273, 'TEJUCO CARTORIO REGISTRO CIVIL E NOTAS', 61366, 3135209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10769, 10869, 'SERVICO REGISTRAL DE IMOVEIS JANUARIA', 59477, 3135209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10770, 10870, 'OFICIO DO 1º TABELIONATO DE PROTESTOS DE TITULOS', 48991, 3135209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10771, 2276, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO JOAQUIM - JANUARIA', 37945, 3135209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10772, 10871, 'SERVENTIA REG.TITS. E DOCUMENTOS E REG.PESSOAS JURIDICAS', 58339, 3135209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10773, 2115, 'CARTORIO REGISTRO CIVIL E NOTAS', 44693, 3135209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10774, 6650, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51326, 3135209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10775, 10872, 'SERVENTIA DO 2.º TABELIONATO DE NOTAS', 58289, 3135209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10776, 2274, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52134, 3135209, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10777, 10873, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 56838, 3135308, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10778, 2277, 'OFICIO DE REGISTRO CIVIL E NOTAS DE JAPONVAR', 46698, 3135357, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10779, 2116, 'OFICIO REGISTRO CIVIL E TABELIONATO DE NOTAS DE NOVA MINDA', 54882, 3135357, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10780, 2278, 'JECEABA CARTORIO DE REGISTRO CIVIL E NOTAS', 45849, 3135407, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10781, 2279, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE BITURI', 44602, 3135407, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10782, 2117, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 52282, 3135456, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10783, 10874, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54528, 3135506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10784, 2120, 'JEQUERI CARTORIO DO REGISTRO CIVIL E NOTAS DE PISCAMBA', 45880, 3135506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10785, 10875, 'OFICIO DO TABELIONATO DE PROTESTO DE TITULOS', 50161, 3135506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10786, 2119, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SAO SEBASTIAO DO GROTA', 45856, 3135506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10787, 10876, '2º TABELIONATO DE NOTAS ', 153593, 3135506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10788, 2118, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50450, 3135506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10789, 10877, 'SERVENTIA DO PRIMEIRO OFICIO DE NOTAS', 45864, 3135506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10790, 10878, 'CARTORIO DE REGISTRO DE IMOVEIS DE JEQUERI-MG', 39131, 3135506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10791, 6901, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SAO VICENTE DO GRAMA', 45872, 3135506, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10792, 2121, 'OFICIO DO REGISTRO CIVIL E TABELIOANTO DE NOTAS ', 51334, 3135605, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10793, 6902, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE JEQUITIBA', 45898, 3135704, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10794, 2307, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE PIRAPANEMA', 46284, 3143906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10795, 2310, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE MURIAE - MG', 35964, 3143906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10796, 2309, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE VERMELHO', 37267, 3143906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10797, 10879, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54270, 3143906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10798, 2306, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE BOM JESUS DA CACHOEIRA', 37317, 3143906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10799, 2776, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE ITAMURI', 53546, 3143906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10800, 11234, 'CARTORIO DO REGISTRO DE TITULOS E DOCUMENTOS/CIVIL DAS PESSOAS JURIDICAS', 43679, 3144607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10801, 2835, 'CARTORIO DE REGISTRO CIVIL DE NEPOMUCENO', 36350, 3144607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10802, 11235, 'CARTORIO DO SEGUNDO OFICIO DE NOTAS', 43745, 3144607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10803, 11236, 'NEPOMUCENO CARTORIO REGISTRO DE IMOVEIS', 46169, 3144607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10804, 11237, 'PRIMEIRO TABELIONATO DE NOTAS', 49080, 3144607, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10805, 2317, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE NINHEIRA', 35972, 3144656, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10806, 2836, 'REGISTRO CIVIL E NOTAS', 47050, 3144672, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10807, 11238, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48496, 3144706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10808, 2837, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50518, 3144706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10809, 11239, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54346, 3144706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10810, 11240, 'CARTORIO DO 1 OFICIO DE NOTAS', 40360, 3144706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10811, 11241, 'OFICIO DE REGISTRO DE IMOVEIS DE NOVA ERA-MG', 47340, 3144706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10812, 11242, 'CARTORIO DO 2º OFICIO', 41194, 3144706, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10813, 11243, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS JURIDICAS E TITULOS E DOCUMENTOS', 36368, 3144805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10814, 11244, 'CARTORIO DE REGISTRO DE PROTESTOS', 39321, 3144805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10815, 11245, 'SERVICO NOTARIAL DO 2º OFICIO', 58974, 3144805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10816, 11246, 'CARTORIO DO 1º OFICIO DE NOTAS DE NOVA LIMA', 40865, 3144805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10817, 11247, 'SERVICO REGISTRAL DE IMOVEIS DE NOVA LIMA', 59451, 3144805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10818, 2318, 'CARTORIO DE REGISTRO CIVIL DAS PESOAS NATURAIS DE NOVA LIMA', 35410, 3144805, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10819, 2319, 'CARTORIO DE REGISTRO CIVIL COM ATRIBUICAO NOTARIAL', 52290, 3144904, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10820, 11248, 'OFICIO DO 1° TABELIONATO DE PROTESTOS DE TITULOS DA COMARCA DE NOVA PONTE', 47852, 3145000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10821, 2839, 'OFICIO DO 2º REGISTRO CIVIL DAS PESSOAS NATURAIS', 49262, 3145000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10822, 11249, '2º TABELIONATO DE NOTAS ', 153635, 3145000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10823, 11250, 'SERVICO DE REGISTRO DE IMOVEIS DA COMARCA DE NOVA PONTE', 58586, 3145000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10824, 11251, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 39669, 3145000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10825, 2838, 'OFICIO DO 1º REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 47894, 3145000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10826, 11252, 'CARTORIO DO 1º OFICIO DE NOTAS ', 40782, 3145000, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10827, 2840, 'OFICIO DAS PESSOAS NATURAIS E TABELIONATO ', 46375, 3145059, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10828, 11253, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 46599, 3114550, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10829, 2027, 'S.S. DO PONTAL CARTORIO REGISTRO CIVIL PESSOAS NATURAIS', 57828, 3114550, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10830, 1904, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 51599, 3114550, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10831, 2028, 'CARTORIO DE REGISTRO CIVIL  E NOTAS DE CARRANCAS/MG ', 35311, 3114600, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10832, 2029, 'OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 37770, 3114709, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10833, 2030, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS COM ATRIBUICOES NOTARIAIS', 36517, 3114808, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10834, 2031, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE CASA GRANDE', 38307, 3114907, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10835, 6948, 'OFICIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 54775, 3115003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10836, 11254, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54361, 3115102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10837, 11255, 'CASSIA CARTORIO DO 2º OFICIO DE NOTAS', 45310, 3115102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10838, 11256, 'OFICIO DO REGISTRO DE IMOVEIS', 53942, 3115102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10839, 2032, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50666, 3115102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10840, 11257, 'CASSIA CARTORIO DO 1º OFICIO DE NOTAS', 45302, 3115102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10841, 11258, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE CASSIA/MG', 60459, 3115102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10842, 11259, 'CARTORIO REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 45062, 3115300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10843, 1908, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE SERENO', 53686, 3115300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10844, 11260, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49395, 3115300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10845, 1906, 'CARTORIO DE REGISTRO CIVIL E NOTAS DO DISTRITO DE ARACATI COMARCA DE CATAGUASES,MG', 145367, 3115300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10846, 11261, 'TABELIONATO DE PROTESTO', 60103, 3115300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10847, 3215, 'CARTORIO DE REGISTRO CIVIL PESSOAS NATURAIS', 64089, 5106158, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10848, 10227, 'CARTORIO DE PAZ E NOTAS DE NOVA BRASILANDIA', 154716, 5106208, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10849, 3216, 'SERVICOS NOTARIAIS E REGISTRAIS MONTEIRO', 65490, 5106216, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10850, 10228, '1º SERVICO REGISTRAL DA COMARCA DE NOVA CANAA DO NORTE', 63511, 5106216, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10851, 7051, 'CARTORIO DE REGISTRO CIVIL', 64022, 5108808, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10852, 3217, 'CARTORIO DE PAZ E NOTAS DE NOVA MARILANDIA', 64774, 5108857, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10853, 3218, 'SEGUNDO SERVICO NOTARIAL E REGISTRO CIVIL NOVA MARINGA', 65276, 5108907, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10854, 3219, 'CARTORIO DE REGISTROS CIVIS, PESSOA JURIDICA, PROTESTO E TABELIONATO', 64113, 5108956, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10855, 10229, '1º SERVICO REGISTRAL DA COMARCA DE NOVA MONTE VERDE', 63529, 5108956, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10856, 3220, 'CARTORIO DO 2° OFICIO DE NOVA MUTUM', 64980, 5106224, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10857, 10230, '1º SERVICO DE REGISTRO DE IMOVEIS E DE TITULOS E DOCUMENTOS', 63404, 5106224, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10858, 3221, 'SERVICOS DE REGISTRO CIVIL E NOTARIAL', 65482, 5106232, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10859, 10231, 'CARTORIO DO 1º OFICIO', 154500, 5106240, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10860, 6651, 'SERVICO NOTARIAL E REGISTRAL DE NOVA UBIRATA', 65359, 5106240, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10861, 10232, 'PRIMEIRO SERVICO DE REGISTRO DE IMOVEIS', 65029, 5106257, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10862, 3222, '2º OFICIO EXTRAJUDICAL DE NOVA XAVANTINA', 63644, 5106257, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10863, 3223, 'CGJ/MT_1 CARTORIO DO REGISTRO CIVIL E TABELIONATO', 64808, 5106273, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10864, 10233, 'REGISTRO CIVIL E TABELIONATO DE NOTAS DE NOVO MUNDO - MT', 145854, 5106265, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10865, 3224, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO MUNICIPIO DE NOVO MUNDO MT', 134338, 5106265, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10866, 3225, 'CARTORIO PAZ E NOTAS', 63834, 5106281, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10867, 10234, '1º OFICIO - REGISTRO DE IMOVEIS E TITULOS E DOCUMENTOS', 63305, 5106281, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10868, 3226, 'CARTORIO DO 2º OFICIO PARANAITA', 64543, 5106299, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10869, 10235, 'CARTORIO DO 1º OFICIO PARANAITA', 64014, 5106299, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10870, 3227, 'SEGUNDO SERVICO NOTARIAL E REGISTRAL', 65193, 5106307, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10871, 10236, '1 SERVICO DE REGISTRO DE IMOVEIS E TITULOS E DOCUMENTOS DE PARANATINGA', 63271, 5106307, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10872, 10237, 'CARTORIO DO 1º OFICIO E ANEXO', 64295, 5106372, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10873, 7052, 'CGJ/MT_1 CARTORIO DE PAZ E NOTAS DE SAO JOSE DO PLANALTO', 64691, 5106372, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10874, 3228, '2º TABELIONATO DE NOTAS E PROTESTOS', 63727, 5106372, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10875, 10238, 'CARTORIO DO 1º OFICIO', 64196, 5106422, 'MT');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10876, 3441, 'CARTORIO DO UNICO OFICIO DE VITORIA DO XINGU - ALTAMIRA', 67447, 1508357, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10877, 3442, 'CARTORIO DO UNICO OFICIO DE XINGUARA', 67454, 1508407, 'PA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10878, 3443, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 69237, 2500106, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10879, 10239, 'CARTORIO DE DISTRIBUICIDENTIFICACAO UNICA: 06.951-8AO EXTRAJUDICIAL', 69518, 2500106, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10880, 10240, 'CARTORIO MARCAL LEITE', 71613, 2500106, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10881, 3444, 'CARTORIO DO REGISTRO CIVIL DE AGUIAR', 150565, 2500205, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10882, 10241, 'SERVICO NOTARIAL E REGISTRAL - IEDA CARNEIRO - 1º OFICIO', 72967, 2500304, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10883, 3445, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 70755, 2500304, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10884, 10242, 'CARTORIO DO SEGUNDO OFICIO DE NOTAS, REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E PROTESTO.', 71340, 2500304, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10885, 10243, 'REGISTRO DE DISTRIBUICAO', 72579, 2500304, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10886, 3452, 'CARTORIO DO REGISTRO CIVIL', 68973, 2500304, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10887, 10244, 'CARTORIO DE DISTRIBUICAO DE ALAGOA NOVA PB', 69351, 2500403, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10888, 10245, 'CARTORIO UNIO TABELIONATO ALIPIO BEZERRA', 71944, 2500403, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10889, 3446, 'ALAGOA NOVA CARTORIO DO REGISTRO CIVIL', 68932, 2500403, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10890, 3447, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 72413, 2500502, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10891, 10246, 'CARTORIO UNICO OFICIO', 71936, 2500502, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10892, 10247, 'DISTRIBUICAO EXTRAJUDICIAL', 72108, 2500502, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10893, 3448, 'CARTORIO DE REGISTRO CIVIL E TABELIONTATO', 70003, 2500536, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10894, 3449, 'ALGODAO DE JANDAIRA CARTORIO DO REGISTRO CIVIL', 68940, 2500577, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10895, 3450, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS YASMIM RODRIGUES BEZERRA', 69823, 2500601, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10896, 4129, 'CARTORIO VIANA TEIXEIRA', 71951, 2500601, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10897, 10248, 'TABELIONATO DO CARTORIO DE REGISTRO DAS PESSOAS NATURAIS DE MATA REDONDA', 145177, 2500601, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10898, 7070, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE ITATUBA ', 71217, 2507200, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10899, 3895, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS DE JACARAU  ', 73155, 2507309, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10900, 3894, 'OFICIALA DO REGISTRO CIVIL E NOTAS', 72363, 2507309, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10901, 10570, 'CARTORIO DE REGISTRO DE DISTRIBUICAO EXTRA JUDICIAL', 70086, 2507309, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10902, 10571, 'CARTORIO DIAS DA CRUZ - SERVICO REGISTRAL E NOTARIAL ', 70169, 2507309, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10903, 3896, 'JERICO CARTORIO DO REGISTRO CIVIL', 72231, 2507408, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10904, 3899, 'CARTORIO BESSA VELOSO', 69245, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10905, 10572, 'SERVICO DE DISTRIBUICAO DE TITULOS DE JOAO PESSOA', 72751, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10906, 10573, 'DECARLINTO - SERVICO NOTARIAL 10. OFICIO DE NOTAS', 72074, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10907, 3900, 'SERVICO REGISTRAL ALCANTARA BRITO', 73106, 2507507, 'PB');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10908, 10574, 'SERVICO NOTARIAL E REGISTRAL UNICO', 77636, 2604601, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10909, 10575, 'CARTORIO DO 1º OFICIO DIMAS PEDROSA', 74831, 2604700, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10910, 10576, 'CARTORIO 2 OFICIO', 150938, 2604700, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10911, 4066, 'CARTORIO DO REGISTRO CIVIL DA COMARCA DAS CORRENTES', 75408, 2604700, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10912, 10577, 'CARTORIO DO UNICO OFICIO', 129791, 2604809, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10913, 4183, 'CARTORIO DO REGISTRO CIVIL', 129809, 2604809, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10914, 10578, 'CARTORIO DO OFICIO UNICO DE CUMARU', 75051, 2604908, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10915, 4184, 'CARTORIO DE REGISTRO CIVIL DE AMEIXAS ', 74377, 2604908, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10916, 4185, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 77438, 2604908, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10917, 10579, 'CARTORIO AMARO ARRUDA 1º OFICIO DE CUPIRA', 73973, 2605004, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10918, 4067, 'CARTORIO REGISTRO CIVIL DE PESSOAS NATURAIS', 76521, 2605004, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10919, 7090, 'CARTORIO MURILO MOURA CORDEIRO', 76547, 2605004, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10920, 10580, 'CARTORIO 2º OFICIO (ANTIGO UNICO OFICIO)', 73916, 2605004, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10921, 10581, 'CARTORIO DE NOTAS,REGISTRO DE IMOVEIS,HIPOTECAS,TITULOS E DOCUMENTOS E PROTESTOS', 74047, 2605103, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10922, 4186, 'CARTORIO DO REGISTRO CIVIL CUSTODIA-PE', 75390, 2605103, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10923, 4068, 'CUSTODIA CARTORIO DE REGISTRO CIVIL E NOTAS', 77081, 2605103, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10924, 4069, 'CARTORIO REGISTRO CIVIL DE DORMENTES', 130492, 2605152, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10925, 4187, 'CARTORIO REGISTRO CIVIL', 76570, 2605202, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10926, 10582, 'SERVICO NOTARIAL E REGISTRAL DE ESCADA', 77594, 2605202, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10927, 10583, 'EXU CARTORIO DO 1º OFICIO DE NOTAS E REGISTRO', 77099, 2605301, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10928, 6531, 'CARTORIO DO REGISTRO CIVIL', 75259, 2605301, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10929, 10584, 'EXU CARTORIO DO 2º OFICIO DE NOTAS', 77107, 2605301, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10930, 4189, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75598, 2605301, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10931, 4188, 'CARTORIO DO REGISTRO CIVIL E PESSOAS NATURAIS DO 3º DISTRITO DE TIMORANTE MUNICIPIO DE EXU ESTADO DE PERNAMBUCO', 76158, 2605301, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10932, 4071, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75549, 2605301, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10933, 10585, 'CARTORIO DO REGISTRO CIVIL - VIRACAO', 148296, 2605301, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10934, 4070, 'CARTORIO DO REGISTRO CIVIL DA SEDE DE EXU-PE', 75424, 2605301, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10935, 4072, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 76174, 2605400, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10936, 10586, 'CARTORIO DE TABELIONATO E DE REGISTRO', 152447, 2605400, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10937, 4073, 'CARTORIO UNICO DE FERNANDO DE NORONHA', 76802, 2605459, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10938, 4074, 'CARTORIO REGISTRO CIVIL DE FERREIROS-PE', 76653, 2605509, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10939, 4075, 'CARTORIO DE REGISTRO CIVIL', 74120, 2605608, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10940, 4076, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 75945, 2605608, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10941, 10587, 'CARTORIO UNICO DE NOTAS PRIVATIVO DO REGISTRO GERAL DE IMOVEIS E ANEXOS', 76927, 2605608, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10942, 6532, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS ', 73429, 2605707, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10943, 4078, 'CARTORIO DE REGISTRO CIVIL DE CARQUEIJA', 74427, 2605707, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10944, 10588, 'CARTORIO UNICO DE FLORESTA', 76810, 2605707, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10945, 4077, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS DE AIRI', 75952, 2605707, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10946, 3607, 'ITAHUM - CARTORIO DE REGISTRO CIVIL E ANEXOS', 62679, 5003702, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10947, 10589, '3º SERVICO NOTARIAL E TABELIONATO DE PROTESTOS', 63255, 5003702, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10948, 3608, 'SERVICO NOTARIAL E DE REGISTRO CIVIL ', 61655, 5003751, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10949, 3609, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE CULTURAMA', 62109, 5003801, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10950, 2308, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE BOA FAMILIA', 43877, 3143906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10951, 10880, 'OFICIO DO 3º TABELIONATO DO NOTAS DE MURIAE', 46136, 3143906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10952, 10881, 'OFICIO DO REGISTRO DE IMOVEIS DE MURIAE', 57067, 3143906, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10953, 10882, 'CARTORIO DO 2º OFICIO DE NOTAS ', 41426, 3144003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10954, 7448, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ROSEIRAL', 42572, 3144003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10955, 2826, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE CENTENARIO', 42077, 3144003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10956, 10883, 'REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 57620, 3144003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10957, 2777, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DO DISTRITO DE SAO FRANCISCO DE HUMAITA', 55616, 3144003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10958, 2825, 'REGISTRO CIVIL E NOTAS EM OCIDENTE', 56697, 3144003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10959, 2315, 'SERVICO DE REGISTRO CIVIL DE PESSOAS NATURAIS, INTERDICOES E TUTELAS DE MUTUM ', 36475, 3144003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10960, 10884, 'SERVICO REGISTRAL DE IMOVEIS', 59386, 3144003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10961, 10885, 'CARTORIO DO REGISTRO DE PROTESTO', 43588, 3144003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10962, 10886, '1º OFICIO DE NOTAS DE MUTUM-MG', 44156, 3144003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10963, 2311, 'CARTORIO DE REGISTRO CIVIL COM ATRIBUICOES EM NOTAS DE IMBIRUCU', 35360, 3144003, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10964, 10887, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54429, 3144102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10965, 2316, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56135, 3144102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10966, 10888, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS - MUZAMBINHO-MG', 48785, 3144102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10967, 10889, 'OFICIO DO REGISTRO DE IMOVEIS', 59741, 3144102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10968, 2827, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE JURUAIA', 53561, 3144102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10969, 10890, 'PRIMEIRO SERVICO NOTARIAL', 55319, 3144102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10970, 10891, '2º SERVICO NOTARIAL', 32607, 3144102, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10971, 2828, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 42762, 3144201, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10972, 10892, 'NANUQUE CARTORIO DO PRIMEIRO OFICIO', 46151, 3144300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10973, 10893, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS DE NANUQUE-MG', 48843, 3144300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10974, 10894, 'OFICIO DO REGISTRO DE TITTULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 54155, 3144300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10975, 2830, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50823, 3144300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10976, 10895, 'CARTORIO DO 2º OFICIO DE NOTAS DA COMARCA DE NANUQUE', 46144, 3144300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10977, 2829, 'OFICIL DO REGISTRO CIVIL E TABELIONATO', 46300, 3144300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10978, 10896, 'CARTORIO DE REGISTRO DE IMOVEIS DE NANUQUE', 39156, 3144300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10979, 2831, 'SERVICOS REGISTRAIS E NOTARIAIS DE NAQUE', 53587, 3144359, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10980, 2832, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 37077, 3144375, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10981, 2814, 'OFICIO DO REGISTRO CIVIL COM ATRIBUICAO NOTARIAL DE GALENA', 51169, 3153400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10982, 10897, 'TABELIONATO DE PROTESTO DE TITULOS ', 60301, 3153400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10983, 2815, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE PONTE FIRME', 44511, 3153400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10984, 10898, '2º TABELIONATO DE NOTAS', 32698, 3153400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10985, 10899, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 50237, 3153400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10986, 10900, 'CARTORIO DE REGISTRO DE IMOVEIS', 38687, 3153400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10987, 10901, 'CARTORIO DO 1º OFICIO DE NOTAS', 40519, 3153400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10988, 10902, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50971, 3153400, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10989, 2816, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE PRUDENTE DE MORAIS', 47126, 3153608, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10990, 2817, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE QUARTEL SAO JOAO', 37499, 3153707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10991, 2369, 'SERVICO REGISTRAL CIVIL E PN E NOTARIAL', 59170, 3153707, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10992, 2818, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE QUELUZITO', 38315, 3153806, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10993, 7078, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51789, 3153905, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10994, 10903, 'CARTORIO DO REGISTRO DE IMOVEIS ', 43414, 3154002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10995, 2371, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE BICUIBA', 53439, 3154002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10996, 10904, 'TABELIONATO DE PROTESTO DE RAUL SOARES', 60715, 3154002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10997, 10905, 'CARTORIO DO REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 43653, 3154002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10998, 2370, 'CARTORIO DE REGISTRO CIVIL', 35246, 3154002, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (10999, 1907, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE GLORIA DE CATAGUASES', 47092, 3115300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11000, 2034, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE VISTA ALEGRE', 34157, 3115300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11001, 1905, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA CIDADE DE CATAGUASES MG', 35881, 3115300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11002, 11262, 'CARTORIO DO 1° OFICIO DE NOTAS ', 40428, 3115300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11003, 2033, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE CATAGUARINO', 45328, 3115300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11004, 11263, 'CARTORIO DE REGISTRO DE IMOVEIS', 38877, 3115300, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11005, 1909, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 56846, 3115359, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11006, 2035, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM ATRIBUICAO NOTARIAL', 37333, 3115409, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11007, 1910, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE CATUJI', 356, 3115458, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11008, 1911, 'OFICIO REGISTRO CIVIL E NOTAS ', 54809, 3115474, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11009, 11264, '2º OFICIO DE NOTAS', 32524, 3115508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11010, 11265, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS', 39792, 3115508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11011, 6891, 'REGISTRO CIVIL DAS PESSOAS NATURAIS, INTERDICOES E TUTELAS DA COMARCA DE CAXAMBU/MG', 56564, 3115508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11012, 11266, 'SERVICO REGISTRAL DE IMOVEIS DA COMARCA DE CAXAMBU', 59428, 3115508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11013, 11267, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS DE CAXAMBU', 48819, 3115508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11014, 11268, 'CARTORIO DO 1º OFICIO DE NOTAS', 40758, 3115508, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11015, 11269, 'CARTORIO DE REGISTROS DE TITULOS E DOCUMENTOS E REGISTROS DAS PESSOAS JURIDICAS', 40121, 3126703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11016, 11270, 'PRIMEIRO CARTORIO DE NOTAS DA COMARCA DE FRANCISCO SA', 55277, 3126703, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11017, 1389, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6353, 2906709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11018, 7834, 'REGISTROS PUBLICOS DE IMOVEIS E HIPOTECAS', 13441, 2906808, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11019, 586, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9571, 2906808, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11020, 7835, 'TABELIONATO DE NOTAS', 13896, 2906808, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11021, 588, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS', 9696, 2906824, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11022, 587, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS', 9688, 2906824, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11023, 7836, 'TABELIONATO C/ FUNC DE PROTESTO', 134536, 2906824, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11024, 7837, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 134528, 2906824, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11025, 7838, 'REGISTRO DE IMOVEIS E HIPOTECAS TITULOS E DOCUMENTOS', 13128, 2906857, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11026, 6473, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9167, 2906857, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11027, 7839, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14449, 2906857, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11028, 940, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6486, 2906873, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11029, 7840, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECA TITULOS E DOCUMENTOS', 7518, 2906873, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11030, 7841, 'CARTORIO DE TABELIONATO E PROTESTOS DE TITULOS', 8300, 2906873, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11031, 7, 'ANAGE - CARTORIO DE REGISTRO CIVIL - DISTRITO DE CARAIBAS', 143404, 2906899, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11032, 589, 'REG. CIVIL C/ FUNC. NOTARIAIS - JUREMA', 138347, 2906907, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11033, 7842, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 7831, 2906907, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11034, 7843, 'REG. CIVIL C/ FUNC NOTARIAIS - SANTO ANTONIO DE BARCELONA', 134551, 2906907, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11035, 7844, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 15107, 2906907, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11036, 7845, 'REG. CIVIL C/ FUNC NOTARIAIS - PONTA DE AREIA', 134544, 2906907, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11037, 1390, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6692, 2906907, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11038, 592, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS DE RAMALHO-BAHIA', 6213, 2907103, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11039, 7846, 'TABELIONATO COM FUNCAO DE PROTESTO', 138453, 2907103, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11040, 591, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTAARIAIS DE FEIRA DA MATA-BAHIA', 6049, 2907103, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11041, 6906, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 6965, 2907103, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11042, 590, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS DE BARRA DO PARATECA-CARINHANHA-BAHIA', 8946, 2907103, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11043, 7847, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 7898, 2907103, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11044, 593, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12542, 2907202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11045, 594, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCAO NOTARIAL', 12583, 2907202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11046, 7848, 'CASA NOVA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE BEM BOM', 144139, 2907202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11047, 941, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCAO NOTARIAL', 12591, 2907202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11048, 7849, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14290, 2907202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11049, 7850, 'REGISTRO DE IMOVEIS HIPOTECAS TITULOS E ANEXOS', 13227, 2907202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11050, 595, 'CARTORIO DO REGISTRO CIVIL C/ FUNCOES NOTARIAIS', 8649, 2907202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11051, 1392, 'REGISTRO CIVIL C/ FUNC. NOTARIAIS DO DISTRITO DE PETIM', 11817, 2907301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11052, 7851, 'OFICIO DO REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS', 13110, 2907301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11053, 596, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 8334, 2907301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11054, 7852, 'REG. CIVIL C/ FUNC NOTARIAIS - TABOLEIRO CASTRO', 134635, 2907301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11055, 1394, 'REGISTRO CIVIL C/ FUNC. NOTARIAIS DO DISTRITO DE CRUSSAI', 11783, 2907301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11056, 7853, 'TAB DE NOTAS C/FUN DE PROTESTO', 13557, 2907301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11057, 7854, 'REG. CIVIL C/ FUNC NOTARIAIS - PARAGUACU', 134593, 2907301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11058, 1393, 'REGISTRO CIVIL C/ FUNC. NOTARIAIS DO DISTRITO DE  SITIO DO MEIO', 11809, 2907301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11059, 201, 'CARTORIO REGISTRO CIVIL C/ FUNCOES NOTARIAIS', 10959, 2917805, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11060, 204, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO 1º OFICIO SEDE', 9761, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11061, 8287, 'TABELIONATO DE NOTAS 1º OFICIO', 137976, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11062, 8288, 'CARTORIO DE IMOVEIS DO 1º OFICIO', 5645, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11063, 280, 'CARTORIO DE RESGISTRO CIVIL COM FUNCOES NOTARIAIS', 8243, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11064, 8289, 'CARTORIO DE PROTESTOS DE TITULOS', 5835, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11065, 8290, 'REG. CIVIL C/ FUNCOES NOTARIAIS - MONTE BRANCO', 133652, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11066, 8291, 'TABELIONATO DE NOTAS DO 2º OFICIO', 14928, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11067, 278, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DO DISTRITO DE ITAJURU COM FUNCOES NOTARIAIS', 7146, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11068, 8292, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ CATINGAL', 140475, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11069, 8293, 'REGISTRO DE TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS', 13383, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11070, 8294, 'REG. CIVIL C/ FUNCOES NOTARIAIS - FLORESTAL', 133645, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11071, 206, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS - 2º OFICIO', 6734, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11072, 205, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS COM FUNCOES NOTARIAIS DE MANOEL VITORINO', 7088, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11073, 8295, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ ITAIBO', 139956, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11074, 8296, 'CARTORIO DO REGISTRO DE IMOVEIS DO 2° OFICIO', 10090, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11075, 207, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS - DISTRITO DE BAIXAO', 9704, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11076, 279, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DO DISTRITO DE ORIENTE NOVO COMARCA DE JEQUIE-BA', 7153, 2918001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11077, 8297, 'REGISTRO DE IMOVEIS E HIPOTECAS', 13029, 2918100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11078, 8298, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ SITIO DO QUINTO', 140095, 2918100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11079, 8299, 'TABELIONATO DE NOTAS', 13854, 2918100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11080, 8300, 'REG. CIVIL C/ FUNCOES NOTARIAIS - CANCHE', 133660, 2918100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11081, 208, 'CARTORIO DO REGISTRO CIVIL DA PESSOAS NATURAIS ', 9068, 2918100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11082, 8301, 'PROTESTO DE TITULOS DO DISTRITO-SEDE DA COMARCA DE JEREMOABO', 154054, 2918100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11083, 209, 'CARTORIO DE REGISTRO CIVIL COM FUNCAO NOTARIAL', 6023, 2918100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11084, 8302, 'JEREMOABO - CARTORIO DE REGISTRO CIVIL - DISTRITO DE PEDRO ALEXANDRE', 144394, 2918100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11085, 8303, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 10264, 2918209, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11086, 8304, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTOS', 14787, 2918209, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11087, 210, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12534, 2918209, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11088, 8305, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14464, 2918308, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11089, 211, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6403, 2918308, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11090, 8306, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS', 7575, 2918308, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11091, 8307, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS TITULOS E DOCUMENTOS E DE PESSOAS JURIDICAS', 7799, 2918357, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11092, 212, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9357, 2918357, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11093, 8308, 'CARTORIO DO TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO DE TITULOS', 10553, 2918357, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11094, 214, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE ABOBORA', 9928, 2918407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11095, 8309, 'REG. CIVIL C/ FUNC. NOTARIAIS - PINHOES', 135731, 2918407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11096, 8310, 'REG. CIVIL. C/ FUNC. NOTARIAIS - CARNAIBA SERTAO', 137554, 2918407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11097, 213, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS', 11973, 2918407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11098, 8311, 'REG. CIVIL C/ FUNCAO NOTARIAIS - JUREMAL', 136739, 2918407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11099, 8312, 'REGISTRO DE IMOVEIS 1º OFICIO', 135673, 2918407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11100, 8313, 'CARTORIO REGISTRAL PUBLICO ¿ TITULOS, DOCUMENTOS E CIVIL DE PESSOAS JURIDICAS - (FANTASIA - CARTORIO PETRONIO ARAUJO)', 137398, 2918407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11101, 8314, 'TABELIONATO DE PROTESTO DE TITULOS', 15198, 2918407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11102, 8315, 'TABELIONATO 2º OFICIO DE NOTAS', 136382, 2918407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11103, 8316, 'REG. CIVIL C/ FUNCOES NOTARIAIS - MASSAROCA', 133686, 2918407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11104, 8317, 'REGISTRO CIVIL DAS PESSOAS NATURAIS 1º OFICIO', 137133, 2918407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11105, 215, 'CARTORIO DO REGISTRO CIVILDO DISTRITO DO JUNCO', 10017, 2918407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11106, 6928, 'CARTORIO CIVIL DAS PESSOAS NATURAIS DE IRATINGA - CARTORIO ANTONIO CUSTODIO DE MESQUITA', 16428, 2306306, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11107, 8744, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE PITOMBEIRA', 145565, 2306306, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11108, 898, 'CARTORIO ZELIA MOTA - 1º OFICIO DE ITAPAJE', 20248, 2306306, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11109, 8745, 'CERTORIO TERCEIRO OFICIO DA SEDE DA COMARCA DE ITAPIPOCA', 20321, 2306405, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11110, 804, 'CARTORIO OLIVEIRA', 19802, 2303204, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11111, 8746, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE MIGUEL XAVIER', 137182, 2303204, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11112, 807, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO SAO SEBASTIAO', 19158, 2303303, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11113, 806, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE CAIPU', 18853, 2303303, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11114, 8747, 'CARTORIO DE 1º E 2º OFICIO', 16469, 2303303, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11115, 808, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO SAO BARTOLOMEU', 19141, 2303303, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11116, 809, 'OFICIO DE NOTAS E REGISTROS DE CARNAUBAL', 19364, 2303402, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11117, 6924, 'CARTORIO DO REGISTRO CIVIL DE JACARECOARA', 18473, 2303501, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11118, 8748, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE GUANACES', 135624, 2303501, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11119, 810, 'CARTORIO DE 1º OFICIO JARBAS ARAUJO (CARTORIO JARBAS ARAUJO)', 16493, 2303501, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11120, 8749, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE CAPONGA', 137745, 2303501, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11121, 8750, 'CARTORIO MOURA FACUNDO', 19687, 2303501, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11122, 8751, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE PITOMBEIRAS', 137190, 2303501, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11123, 8752, 'CARTORIO DO 1º OFICIO E REGISTRO CIVIL', 17541, 2303600, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11124, 8753, 'CARTORIO DO 2º OFICIO DE CATARINA', 19448, 2303600, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11125, 7501, 'CART.LOURENCO OFICIO NOTAS E REGISTROS', 15875, 2303659, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11126, 8754, 'CART REG CIVIL DO DIST JUDICIARIO DE GUARARU', 147017, 2303709, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11127, 8755, 'OFICIO PRIVATIVO DE REGISTRO DE IMOVEIS', 20651, 2303709, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11128, 8756, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE CATAUANA', 137869, 2303709, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11129, 8757, '3º TABELIONATO DE NOTAS E PROTESTOS DE TITULOS, OFICIOS DE REGISTROS DE TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS E TABELIONATO E OFICIO DE REGISTRO DE CONTRATOS MARITIMOS', 15727, 2303709, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11130, 8758, 'CART. REG. CIVIL DO DIST. JUDICIARIO DE JUREMA', 147264, 2303709, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11131, 813, '1º OFICIO DE NOTAS, PROTESTOS  E REGISTROS', 15578, 2303709, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11132, 811, 'NATURAL', 20537, 2303709, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11133, 8759, 'CART REG CIVIL DO DIST JUDICIARIO DE TUCUNDUBA', 147025, 2303709, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11134, 812, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE SITIOS NOVOS', 17152, 2303709, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11206, 602, 'CARTORIO REGISTRO CIVIL COM FUNCOES NOTORIAIS', 10793, 2907806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11135, 8760, '2° TABELIONATO E OFICIO DE REGISTRO DE DISTRIBUICAO', 15628, 2303709, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11136, 814, 'CARTORIO DO 1º OFICIO', 17327, 2303808, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11137, 8761, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE VARZEA DA CONCEICAO', 137877, 2303808, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11138, 8762, 'CARTORIO 2º. OFICIO DE CEDRO-CEARA', 16113, 2303808, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11139, 8763, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE PASSAGEM', 147116, 2303907, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11140, 815, '128002', 15529, 2303907, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11141, 8764, 'CARTORIO VERAS 2º OFICIO', 20230, 2303907, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11142, 8765, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE CAICARINHA', 136861, 2303931, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11143, 816, 'CARTORIO DOS ANJOS', 19273, 2303931, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11144, 8766, 'CARTORIO TRIANGULO ', 154138, 2303956, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11145, 818, 'CARTTORIO PAULO WILTON MIRANDA BENICIO', 20263, 2303956, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11146, 817, 'CARTORIO PEREIRA OFICIO NOTAS E REGISTROS', 19893, 2303956, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11147, 8767, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE AROEIRAS', 137885, 2304004, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11148, 8768, 'CARTORIO DO 2º OFICIO SABINO CRISTINO', 17806, 2304004, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11149, 821, 'CARTORIO NERI VASCONCELOS-REGISTRO CIVIL DO DISTRITO DE UBAUNA', 136895, 2304004, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11150, 820, 'CARTORIO UBIRAJARA ANGELIM 1° OFICIO REGISTRO CIVIL', 20214, 2304004, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11151, 819, 'CARTORIO TELLES MASCARENHAS', 20206, 2304004, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11152, 823, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE SANTO ANTONIO', 19042, 2304103, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11153, 8769, 'CARTORIO CAVALCANTE 3° OFICIO', 16410, 2304103, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11154, 8770, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE TUCUNS', 135665, 2304103, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11155, 822, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE POTY, COMARCA DE CRATEUS-CEARA', 18317, 2304103, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11156, 1092, 'CARTORIO DO 2º OFICIO DE NOTAS, PROTESTO, REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E REGISTRO CIVIL', 25064, 5200308, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11157, 1093, 'CARTORIO REGISTRO CIVIL E TABELIONATO DE NOTAS', 27573, 5200506, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11158, 9077, 'ALOANDIA CARTORIO DO 1º OFICIO DE NOTAS', 25049, 5200506, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11159, 1274, 'SERVICOS DE REGISTRO DE IMOVEIS, TIT E DOC, DAS P. JUR., CIVIL DAS P. NATURAIS E DE INTERD E TUT.', 29298, 5200605, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11160, 9078, 'CARTORIO DO SERVICOS DE NOTAS, PROTESTO DE TITULOS E REGISTRO DE CONTRATOS MARITIMOS', 27375, 5200605, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11161, 9079, 'REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS, CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 146886, 5200803, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11162, 9080, 'CARTORIO DO 1º. OFICIO DE NOTAS E REGISTRO GERAL DE IMOVEIS', 26849, 5200803, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11163, 1094, 'PRIMEIRO OFICIO DE NOTAS E ANEXOS', 27938, 5200852, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11164, 9081, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 154781, 5200902, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11165, 1095, 'TABELIONATO DE NOTAS, DE PROTESTO DE TITULOS, TABELIONATO E OFICIALATO DE REGISTRO DE CONTRATOS MARITIMOS, DE REGISTRO DE IMOVEIS, DE REGISTRO DE TITULOS E DOCUMENTOS', 24786, 5200902, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11166, 9082, '1º TABELIONATO DE NOTAS DE ANAPOLIS', 24802, 5201108, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11167, 9083, 'CARTORIO DE REGISTRO DE IMOVEIS 1 ZONA', 26005, 5201108, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11168, 9084, '2° TABELIONATO DE PROTESTO DE TITULOS, REGISTRO DE TITULOS, DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 24885, 5201108, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11169, 1096, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DA 1 CIRCUNSCRICAO', 25635, 5201108, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11170, 1097, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS DO DISTRITO JUDICIARIO DE INTERLANDIA', 27185, 5201108, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11171, 9085, 'CARTORIO DO SEGUNDO TABELIONATO DE NOTAS DE ANAPOLIS', 25056, 5201108, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11172, 9086, '3º TABELIONATO DE NOTAS DE ANAPOLIS', 25015, 5201108, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11173, 9087, 'CARTORIO DE REGISTRO DE IMOVEIS DA 2ª CIRCUNSCRICAO', 26021, 5201108, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11174, 1275, '2º REGISTRO CIVIL E TABELIONATO DE NOTAS', 24901, 5201108, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11175, 9088, '1º TABELIONATO DE PROTESTOS E REGISTROS DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS DE ANAPOLIS', 24851, 5201108, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11176, 1276, 'SERVICOS DE NOTAS, DE PROTESTOS DE TITULOS, TABELIONATO E REGISTRO DE CONTRATOS MARITIMOS, DE REGISTRO DE IMOVEIS, DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS E D', 29165, 5201207, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11177, 1277, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 27003, 5201306, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11178, 9089, 'SERVICOS DE REGISTROS: DE IMOVEIS, CIVIL DAS PESSOAS JURIDICAS, TITULOS E DOCUMENTOS', 29322, 5201306, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11179, 9090, 'SERVICOS DE NOTAS DE PROTESTOS DE TITULOS, TABELIONATOS E REGISTROS DE CONTRATOS MARITIMOS', 29082, 5201306, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11180, 1278, 'REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATOS DE NOTAS', 28134, 5201405, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11181, 9091, 'REGISTRO DE IMOVEIS E TABELIONATO 1º DE NOTAS', 154757, 5201405, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11182, 1279, 'CARTORIO DE REG. CIVIL DAS PNTN. DE VILA BRASILIA', 26732, 5201405, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11183, 9092, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS E TABELIONATO 2º DE NOTAS', 28662, 5201405, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11184, 1098, 'SERVICO REGISTRAL DE IMOVEIS, PESSOAS JURIDICAS, TITULOS, DOCUMENTOS, PROTESTOS E SERVICOS NOTARIAS  ', 29025, 5201454, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11185, 1280, 'SERVICOS DE NOTAS PROT. DE TITULOS, TABEL. E REG. DE CONTRATOS MARITIMOS, REG. DE IMOVEIS, REG. DE TITULOS E DOC. CIVIL DAS PESS. JUR E CIVIL DAS PESS. NAT. E DE INTERD. E TUTELAS', 29116, 5201504, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11186, 9093, 'TABELIONATO DE NOTAS,PROTESTOS DE TITULOS, TABELIAO E OFICIAL DE REGISTRO DE CONTRATOS MARITIMOS DA COMARCA DE ARACU-GO', 29520, 5201603, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11187, 1099, 'OFICIAL DE REGISTRO DE IMOVEIS, DE REGISTRO DE TITULOS E DOCUMENTOS, CIVIL DAS PESSOAS JURIDICAS E CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 27904, 5201603, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11188, 1281, 'CATURAI CARTORIO 1° OFICIO NOTAS E REGISTRO DE IMOVEIS E ANEXOS', 27698, 5201603, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11189, 598, 'REG. CIVIL C/ FUNC NOTARIAIS - SITIO NOVO', 134643, 2907509, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11190, 597, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ BELA FLOR', 138636, 2907509, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11191, 7856, 'TABELIONATO DE NOTAS', 13706, 2907509, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11192, 599, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 138511, 2907509, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11193, 7857, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS.', 138008, 2907509, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11194, 7858, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTOS', 14761, 2907608, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11195, 7859, 'DIOGENES PEREIRA DE SOUZA', 11148, 2907608, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11196, 600, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9464, 2907608, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11197, 7860, 'CARTORIO DE REGISTRO DE IMOVEIS, HIP. E TIT E DOCUMENTOS', 131433, 2907608, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11198, 7861, 'CARTORIO DO REGISTRO DE IMOVEIS E TITULOS E DOCUMENTOS', 10314, 2907707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11199, 7862, 'TABELIONATO DE NOTAS C/FUNCAO DE PROTESTO DE TITULOS', 14167, 2907707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11200, 601, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS ', 9266, 2907707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11201, 1313, 'CARTORIO DE REGISTRO CIVIL C/ FUNCOES NOTARIAIS', 5967, 2907806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11202, 1314, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTORIAIS', 9043, 2907806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11203, 603, 'REGISTRO CIVIL E PESSOAS NATURAIS', 12872, 2907806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11204, 7863, 'CARTORIO DE REGISTRO DE IMOVEIS, HIPOTECAS, TITULOS E REGISTROS DE DOCUMENTOS', 8052, 2907806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11205, 7864, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14316, 2907806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11207, 7865, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 138107, 2907905, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11208, 7866, 'REG. CIVIL C/ FUNC NOTARIAIS - RIBEIRA DO AMPARO', 134650, 2907905, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11209, 7867, 'TABELIONATO COM FUNCAO DE PROTESTO', 131441, 2907905, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11210, 7868, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS', 138321, 2907905, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11211, 7869, 'REG. CIVIL C/ FUNC NOTARIAIS - ALMADINA', 138974, 2908002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11212, 1315, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE COARACI-BA', 6817, 2908002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11213, 7870, 'REG. CIVIL C/ FUNC NOTARIAIS - SAO ROQUE', 134684, 2908002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11214, 6907, 'TABELIONATO DE NOTAS C/FUNCAO DE PROTESTO DE TITULOS  DE COARACI', 14175, 2908002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11215, 7871, 'REG. CIVIL C/ FUNC NOTARIAIS - ITAMOTINGA', 134676, 2908002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11216, 7872, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 134148, 2901155, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11217, 7873, 'REG. CIVIL C/ FUNCOES NOTARIAIS - BELO CAMPO', 134171, 2901155, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11218, 7874, 'TABELIONATO C/ FUNC DE PROTESTO', 134163, 2901155, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11219, 434, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ SOARES', 139014, 2901155, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11220, 7875, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS', 134155, 2901155, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11221, 515, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS ', 6627, 2901205, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11222, 516, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS', 8771, 2901205, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11223, 7876, 'TABELIONATO DE NOTAS E PROTESTO', 14985, 2901205, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11224, 7877, 'CARTORIO DE REGISTRO DE IMOVEIS E TITULOS E DOCUMENTOS', 7930, 2901205, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11225, 7878, 'REGISTRO DE IMOVEIS E HIPOTECAS COM TITULOS E DOCUMENTOS', 13060, 2901304, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11226, 6470, 'ANDARAI - CARTORIO DE REGISTRO CIVIL - DISTRITO DE NOVA REDENCAO', 143420, 2901304, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11227, 435, 'CARTORIO DO TABELIONATO DE NOTAS', 10504, 2901304, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11228, 7879, 'ANDARAI - CARTORIO DE REGISTRO CIVIL - DISTRITO DE IGATU', 143412, 2901304, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11229, 517, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6288, 2901304, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11230, 7880, 'REGISTRO CIVIL COM FUNCOES NOTORIAIS - UBIRAITA', 138982, 2901304, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11231, 70, 'CARTORIO DE REGISTRO CIVIL C/F NOTARIAS DO DISTRITO DE ANDORINHA - COMARCA DE SENHOR DO BONFIM - BAHIA', 144477, 2901353, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11232, 7881, 'REG. CIVIL C/ FUNCOES NOTARIAIS - MISSAO DE ARICOBE', 134197, 2901403, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11233, 518, 'REGISTRO CIVIL DAS PESSAOS NATURAIS', 12146, 2901403, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11234, 7855, 'REG. CIVIL C/ FUNC NOTARIAIS - CAJUEIRO', 134577, 2907301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11235, 7882, 'TABELIONATO DE NOTAS COM FUNCOES PROTESTOS DE TITULOS', 14829, 2901403, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11236, 7883, 'CARTORIO REG. DE IMOV. HIP. TIT.E  DOCUMENTOS E REG DE PESSOAS JURIDICAS', 10710, 2901403, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11237, 436, 'ANTAS - CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 5496, 2901601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11238, 7884, 'REG. CIVIL C/ FUNCOES NOTARIAIS - NOVO TRIUNFO', 134205, 2901601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11239, 8318, '1º CARTORIO DE NOTAS DE JUAZEIRO', 135756, 2918407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11240, 8319, 'REGISTRO CIVIL C/ FUNC. NOTARIAIS - ITAMOTINGA', 137653, 2918407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11241, 10944, 'CARTORIO 2º OFICIO DE NOTAS', 33639, 3155900, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11242, 10945, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS ', 48777, 3156007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11243, 10946, 'OFICIO DO REGISTRO  DE TITULOS E DOCUMENTOS  E CIVIL DAS PESSOAS JURIDICAS', 50336, 3156007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11244, 2656, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE PEDRA MENINA', 46458, 3156007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11245, 10947, 'CARTORIO DE NOTAS DO 2.º OFICIO DE RIO VERMELHO/MG', 34033, 3156007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11246, 2655, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS ', 50401, 3156007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11247, 10948, '1º TABELIONATO DE NOTAS ', 153668, 3156007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11248, 10949, 'OFICIO DO REGISTRO DE IMOVEIS ', 53926, 3156007, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11249, 3075, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36988, 3156106, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11250, 2979, 'CARTORIO DE PAZ DE ROCHEDO DE MINAS', 34124, 3156205, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11251, 3076, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 51698, 3156304, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11252, 3077, '1º SERVICO NOTARIAL E REGISTRAL CIVIL DAS PESSOAS NATURAIS', 37713, 3156403, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11253, 3078, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 53124, 3156452, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11254, 3079, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 56853, 3156502, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11255, 3081, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 36269, 3156601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11256, 3080, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 46946, 3156601, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11257, 3082, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 36996, 3156700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11258, 10950, 'OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 47407, 3156700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11259, 10951, '3° TABELIONATO DE NOTAS ', 32862, 3156700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11260, 3083, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 36376, 3156700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11261, 10952, 'TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE SABARA', 60517, 3156700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11262, 3084, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO', 51060, 3156700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11263, 10953, 'OFICIO DO 1º TABELIONATO DE NOTAS', 47969, 3156700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11264, 10954, 'CARTORIO DE REGISTRO DE IMOVEIS DE SABARA', 39180, 3156700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11265, 10955, 'TABELIONATO DO SEGUNDO OFICIO DE NOTAS DE SABARA ', 61291, 3156700, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11266, 10956, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS', 57547, 3156809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11267, 10957, 'CARTORIO DE REGISTRO DE IMOVEIS', 38554, 3156809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11268, 10958, 'CARTORIO DE PROTESTO', 34801, 3156809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11269, 10959, 'PRIMEIRO TABELIONATO DE SABINOPOLIS', 31872, 3156809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11270, 3085, 'SERVICO REGISTRO CIVIL E NOTAS', 59832, 3156809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11271, 10960, '2º OFICIO DE NOTAS', 32532, 3156809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11272, 3086, 'SERVICO REGISTRO CIVIL PESSOAS NATURAIS', 59857, 3156809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11273, 7080, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 51532, 3156809, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11274, 10961, '1º TABELIONATO DE NOTAS', 32268, 3156908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11275, 10962, 'OFICIO DO 2º TABELIONATO DE NOTAS', 49742, 3156908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11276, 10963, 'CARTORIO DE REGISTRO DE IMOVEIS DE SACRAMENTO', 39198, 3156908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11277, 10964, 'TABELIONATO DE PROTESTO DE TITULOS DE SACRAMENTO', 60616, 3156908, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11278, 11308, 'CARTORIO DE REGISTRO DE IMOVEIS NOVA SERRANA', 39248, 3145208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11279, 2843, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE BOA VISTA DE MINAS', 58404, 3145208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11280, 11309, 'CARTORIO DO 1º OFICIO DE NOVA SERRANA', 40931, 3145208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11281, 11310, '2º TABELIONATO DE NOTAS DE NOVA SERRANA', 49866, 3145208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11282, 11311, 'TABELIONATO DE PROTESTO DE TITULOS DE NOVA SERRANA', 60590, 3145208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11283, 7019, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 50393, 3145208, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11284, 2320, 'SERVICO DE REGISTRO CIVIL E NOTAS', 58453, 3136603, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11285, 11312, 'OFICIO DO 1º TABELIONATO DE NOTAS', 48363, 3145307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11286, 2844, 'CARTORIO DO REGISTRO CIVIL E NOTAS DO LUFA', 43091, 3145307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11287, 2778, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 56143, 3145307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11288, 2780, 'CARTORIO REGISTRO CIVIL E NOTAS QUEIXADA', 44743, 3145307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11289, 11313, 'CARTORIO DO 2º OFICIO DO JUDICIAL E NOTAS', 41566, 3145307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11290, 11314, 'OFICIO DO REG.DE TIT. E DOC.CIVIL DAS P.JURIDICAS', 50260, 3145307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11291, 11315, 'OFICIO DO REGISTRO  DE IMOVEIS', 50328, 3145307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11292, 11316, 'OFICIO DO 1º TABELIONATO DE PROTESTO DE TITULOS', 48769, 3145307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11293, 2779, 'CARTORIO DE PAZ E REGISTRO CIVIL', 34488, 3145307, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11294, 2845, 'CARTORIO SILVA MEDEIROS', 45211, 3145356, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11295, 2321, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE INTERDICOES E TUTELAS', 33936, 3145372, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11296, 2322, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS', 43232, 3145406, 'MG');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11297, 235, 'MUNDO NOVO - CARTORIO DE REGISTRO CIVIL', 143842, 2922102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11298, 289, 'REGISTRO CIVIL DAS PESSOAS NATURAIS C FUNCOES NOTARIAIS', 12575, 2922102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11299, 8338, 'REG. CIVIL C/ FUNCAO NOTARIAIS -  ALTO BONITO', 136564, 2922102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11300, 8339, 'REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS', 13359, 2922102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11301, 36, 'REG. CIVIL C/ FUNCAO NOTARIAIS - ONHA', 136838, 2922201, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11302, 236, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS', 12633, 2922201, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11303, 290, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS C/FUN.NOTARIAIS', 6742, 2922250, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11304, 8340, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 137521, 2922300, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11305, 291, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9555, 2922300, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11306, 237, 'REG. CIVIL C/ FUNC. NOTARIAIS - ITAPORA', 137430, 2922300, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11307, 6696, 'REG. CIVIL C/ FUNCAO NOTARIAIS - GEOLANDIA', 136853, 2922300, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11308, 8341, 'REG CIVIL C/ FUNC NOTARIAIS - BABACEIRAS DO PARAGUACU', 138057, 2922300, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11309, 8342, 'TABELIONATO COM FUNCAO DE PROTESTO', 135525, 2922300, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11310, 8343, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E REG. CIVIL DAS PESSOAS JURIDICAS', 10298, 2922409, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11311, 238, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 9886, 2922409, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11312, 8344, 'CARTORIO DO TABELIONATO DE NOTAS C/ FUNCAO DE PROTESTO', 10538, 2922409, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11313, 239, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9340, 2922508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11314, 8345, 'TABELIONATO DE NOTAS C/FUNCOES DE PROTESTO', 14191, 2922508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11315, 37, 'NILO PECANHA - TABELIONATO DE NOTAS', 11452, 2922607, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11316, 8771, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE IBIAPABA', 135657, 2304103, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11317, 8772, 'CRATEUS CARTORIO SEGUNDO OFICIO-CARTORIO MARTINS', 20339, 2304103, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11318, 8773, 'CART REG CIVIL DO DIST JUDICIARIO DE OITICICA', 147132, 2304103, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11319, 824, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE MONTE NEBO-CRATEUS-CEARA', 18309, 2304103, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11320, 84, 'CARTORIO BEZERRA - PRIMEIRO OFICIO DE CRATEUS', 20255, 2304103, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11321, 8774, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE IRAPUA', 137703, 2304103, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11322, 825, 'CARTORIO DO 4º OFICIO', 17939, 2304202, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11323, 8775, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE SANTA FE', 135699, 2304202, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11324, 8776, 'CARTORIO 1º OFICIO', 15958, 2304202, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11325, 8777, 'CARTORIO DO 5º OFICIO - REGISTRO DE IMOVEIS', 17954, 2304202, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11326, 828, 'CARTORIO DO REGISTRO CIVIL DE MURITI', 18531, 2304202, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11327, 827, 'CARTORIO DE REGISTRO CIVIL FARIAS CUNHA', 17194, 2304202, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11328, 8778, 'CARTORIO DO 3º OFICIO', 17830, 2304202, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11329, 826, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE PONTA DA SERRA', 19018, 2304202, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11330, 8779, 'CARTORIO DE REGISTRO CIVIL - DISTRITO  DE DOM QUINTINO', 135707, 2304202, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11331, 8780, 'CARTORIO 2º OFICIO', 16048, 2304202, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11332, 830, 'CARTORIO DO REGISTRO CIVIL DE BARRA DO SOTERO', 18358, 2304236, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11333, 829, 'CARTORIO DE CROATA - UNICO OFICIO', 19836, 2304236, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11334, 831, 'CARTORIO MOZART SALES', 19711, 2304251, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11335, 832, 'CARTORIO DE OFICIO NOTAS E REGISTRO', 16675, 2304269, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11336, 833, 'CARTORIO DO REGISTRO CIVIL DE ERERE', 18390, 2304277, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11337, 8781, 'CARTORIO DO OFICIO DE NOTAS E REGISTROS DA COMARCA VINCULADA DE ERERE', 18044, 2304277, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11338, 8782, 'CARTORIO FACUNDO DO 2O. OFICIO', 19307, 2304285, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11339, 834, 'CARTORIO SAMPAIO DE 1º OFICIO', 20107, 2304285, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11340, 836, 'CARTORIO DO REGISTRO CIVIL -  DISTRITO DE NOVA BETANIA', 18267, 2304301, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11341, 835, 'CARTORIO 1º OFICIO', 15933, 2304301, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11342, 8783, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE QUINCUNCA', 137661, 2304301, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11343, 8784, 'CARTORIO DO 2º OFICIO', 17624, 2304301, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11344, 837, 'CARTORIO DO REGISTRO CIVIL DE CARIUTABA', 18366, 2304301, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11345, 838, 'CARTORIO DO 1º OFICIO DE REGISTRO CIVIL AMELIA GUIMARAESDE CARVALHO', 17483, 2304350, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11346, 8785, 'FORTALEZA CARTORIO DO 1° OFICIO DE NOTAS E PROTESTO', 20388, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11347, 847, 'CARTORIO DO REGISTRO CIVIL DE MONDUBIM', 18515, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11348, 848, 'REGISTRO CIVIL DA 2ª ZONA DE FORTALEZA', 20750, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11349, 8786, 'FORTALEZA 4º OFICIO DE NOTAS', 20362, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11350, 8787, '9º OFICIO DE NOTAS', 15776, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11351, 8788, '6º OFICIO DE REGISTRO DE IMOVEIS', 15750, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11352, 8789, '1º OFICIO DE REGISTRO DE DISTRIBUICAO DE PROTESTOS', 15586, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11353, 8790, 'PRIMEIRO OFICIO DE REGISTRO DE IMOVEIS DA COMARCA DE FORTALEZA', 20719, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11354, 849, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE PARANGABA-CEARA', 20370, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11355, 845, '10 TABELIONATO DE NOTAS', 15511, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11356, 8791, 'OITAVO TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 20677, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11357, 842, 'FORTALEZA PRIMEIRO OFICIO DE REGISTRO CIVIL', 20420, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11358, 841, 'CARTORIO DO REGISTRO CIVIL DA 3ª ZONA', 20396, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11359, 8792, 'FORTALEZA CARTORIO DO SEGUNDO OFICIO DE NOTAS E PROTESOS DE TITULOS', 20404, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11360, 8793, '2º OFICIO DE DISTRIBUICAO DE PROTESTOS DE TITULOS DA COMARCA DE FORTALEZA', 15651, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11361, 840, 'REGISTRO CIVIL DISTRITO MUCURIPE', 20818, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11362, 846, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS  - 5º OFICIO', 18275, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11363, 843, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE ANTONIO BEZERRA', 18762, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11364, 8794, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE URUQUE', 136119, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11365, 8795, 'CARTORIO DO 5º OFICIO DE NOTAS E PROTESTO DE TITULOS DE FORTALEZA', 17962, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11366, 8796, 'FORTALEZA CARTORIO DO TERCEIRO OFICIO DE NOTAS', 20412, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11367, 1100, '1° REGISTRO CIVIL E TABELIONATO DE NOTAS', 24687, 5201702, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11368, 9094, 'REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS, TABELIONATO 2º DE NOTAS E ESCRIVANIA DO 2º CIVEL', 145094, 5201702, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11369, 9095, 'CARTORIO DO 1º OFICIO DE ITAPEMIRIM/ES - REGISTRO DE IMOVEIS, PROTESTO DE TITULOS E REGISTRO DE TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDIASOAS JURIDICAS', 21378, 3202801, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11370, 1205, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE RIO MQUI', 22574, 3202801, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11371, 1062, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 22293, 3202801, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11372, 1204, 'CARTORIO BARRETO SOARES', 21741, 3202801, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11373, 9096, 'ITAPEMIRIM CARTORIO DE NOTAS E ESCRIVANIA 3º OFICIO', 24091, 3202801, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11374, 9097, 'CARTORIO DO PRIMEIRO OFICIO', 23275, 3202900, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11375, 1207, 'OFICIAL DE REGISTRO CIVIL E TABELIAO DE ITARANA', 22780, 3202900, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11376, 1209, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 22509, 3203007, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11377, 1208, 'CARTORIO DO REGISTRO CIVIL E NOTAS DO DISTRITO DE PEQUIA', 23358, 3203007, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11378, 9098, 'CARTORIO DE REG. DE TITULOS E DOC E REG. CIVIL DAS PESSOAS JURIDICAS', 153379, 3203007, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11379, 9099, 'CARTORIO DE REGISTRO GERAL DE IMOVEIS DA COMARCA DE IUNAES 1º OFICIO', 22756, 3203007, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11380, 9100, 'CARTORIO DE PROTESTOS DA COMARCA DE IUNA', 153353, 3203007, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11381, 9101, 'IUNA CARTORIO DE NOTAS E ORFANOLOGICO 3º OFICIO CARTORIO PAULO EXPEDICTO AMARAL', 24109, 3203007, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11382, 6862, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 22285, 3203007, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11383, 1211, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DO DISTRITO DE BARRA SECA', 22657, 3203056, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11384, 9102, 'CARTORIO DO 1º OFICIO DE JAGUARE', 23051, 3203056, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11385, 1210, 'CARTORIO DE REGISTRO CIVIL DA SEDE', 22384, 3203056, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11386, 9103, 'CARTORIO DE NOTAS DE JAGUARE', 150839, 3203056, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11387, 1212, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 23481, 3203106, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11388, 9104, 'SERVICO REGISTRAL DO PRIMEIRO OFICIO DE JERONIMO MONTEIRO/ES', 24596, 3203106, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11389, 9105, 'CARTORIO DO 1.º OFICIO DE JOAO NEIVA', 22814, 3203130, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11390, 6533, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO E NOTAS DE IRATAMA', 76299, 2606002, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11391, 4190, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DO DISTRITO DE MIRACICA', 130617, 2606002, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11392, 4192, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURIAS - 2ª ZONA', 75796, 2606002, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11393, 4081, 'CARTORIO REGISTRO CIVIL SAO PEDRO', 129684, 2606002, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11394, 4191, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE 1 ZONA JUDICIARIA DE GARANHUNS', 74328, 2606002, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11395, 10624, 'CARTORIO DO 3º OFICIO DE NOTAS', 74989, 2606002, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11396, 10625, 'GARANHUNS CARTORIO DO 2º OFICIO', 77115, 2606002, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11397, 10626, 'CARTORIO 1 OFICIO REGISTRO DE IMOVEIS, TITULOS E DOC, PESSOA JURIDICA.', 150664, 2606002, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11398, 4193, 'CARTORIO DE REGISTRO CIVIL DE GLORIA DO GOITA - PE', 74468, 2606101, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11399, 10627, 'CARTORIO UNICO DA COMARCA DE GLORIA DO GOITA ', 76554, 2606101, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11400, 4194, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DO DISTRITO DE APOTI', 130021, 2606101, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11401, 10628, '1º SERVICO NOTARIAL E REGISTRAL (CARTORIO 1º OFICIO)', 73585, 2606200, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11402, 4083, 'REGISTRO CIVIL DE TEJUCUPPO', 130468, 2606200, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11403, 10629, 'SERVICO NOTARIAL E REGISTRAL DO 2º OFICIO.', 77628, 2606200, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11404, 4082, 'REGISTRO CIVIL DE GOIANA', 77412, 2606200, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11405, 4195, 'SERVICO REGISTRAL DO 3º DISTRITO DE PONTA DE PEDRAS-GOIANA-PE.', 77693, 2606200, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11406, 4196, 'SERVICO DO REGISTRO CIVIL E TABELIONATO', 77529, 2606309, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11407, 10630, '2º SERVICO DE NOTAS E PROTESTO DE TITULOS DA COMARCA DE GRAVATA/PE', 73643, 2606408, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11408, 6534, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75499, 2606408, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11409, 4084, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 75614, 2606408, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11410, 10631, 'GRAVATA CARTORIO 1 OFICIO', 77123, 2606408, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11411, 4085, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 76182, 2606507, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11412, 10632, 'CARTORIO UNICO IBIMIRIM', 76992, 2606606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11413, 4086, 'REGISTRO  CIVIL DAS PESSOAS NATURAIS', 77255, 2606606, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11414, 4197, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE IBIRAJUBA', 74310, 2606705, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11415, 10633, 'CARTORIO DE NOTAS E REGISTROS PUBLICOS EM GERAL - TABELIONATO MAGALHAES', 74039, 2606705, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11416, 10634, 'CARTORIO DE IGARASSU/PE - OFICIO UNICO', 130583, 2606804, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11417, 4087, 'SERVICO REGISTRAL DE TRES LADEIRAS', 77685, 2606804, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11418, 4198, 'SERVICO REGISTRAL DE IGARASSU', 77669, 2606804, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11419, 4088, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE IGUARACI-PE', 75689, 2606903, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11420, 4096, 'CARTORIO DE REGISTRO CIVIL DE ITAMARACA', 74476, 2607604, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11421, 10635, 'CARTORIO UNICO DE ITAMARACA', 76851, 2607604, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11422, 4089, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS- INAJA- PE', 75770, 2607000, 'PE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11423, 3126, 'SERVICO NOTARIAL E DE REGISTRO CIVIL ', 62927, 5005608, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11424, 3127, 'SERVICO NOTARIAL E DE REGISTRO CIVIL', 62695, 5005681, 'MS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11425, 377, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ IBIRAJA', 140285, 2916005, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11426, 381, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ CACHA PREGO', 140137, 2916104, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11427, 8232, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 133553, 2916104, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11428, 8233, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ VERA CRUZ', 139915, 2916104, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11429, 382, 'ITAPARICA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE BARRA DO GIL', 144329, 2916104, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11430, 380, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ JIRIBATUBA', 139907, 2916104, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11431, 8234, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 140343, 2916104, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11432, 8235, 'REG. CIVIL  PESSOAS NATURAIS', 133561, 2916104, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11433, 7486, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS DO DISTRITO JUDICIARIO DE ITAPE', 144303, 2916203, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11434, 8236, 'TABELIONATO DE NOTAS E PROTESTO', 15024, 2916302, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11435, 1, 'CARTORIO DO REGSITRO CIVIL DAS PESSOAS NATURAIS', 10454, 2916302, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11436, 2, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9522, 2916302, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11437, 8237, 'CARTORIO DE REGISTRO DE IMOVEIS', 7435, 2916302, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11438, 3, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS DE BANDEIRA DO COLONIA', 8938, 2916401, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11439, 8238, 'REGISTRO DO 1 OF DE IMOVEIS E HIPOTECA', 13409, 2916401, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11440, 8239, 'CARTORIO DE PROTESTO DE TITULOS', 5785, 2916401, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11441, 8240, 'REGISTRO DE IMOVEIS DO 2º OFICIO', 12989, 2916401, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11442, 8241, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS', 8185, 2916401, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11443, 8242, 'TABELIONATO DO PRIMEIRO OFICIO DE NOTAS', 15354, 2916401, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11444, 8243, 'TABELIONATO DO 2º OFICIO DE NOTAS', 15305, 2916401, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11445, 6909, 'REGISTRO CIVIL DE PESOAS NATURAIS E DE INTERDICOES E TUTELAS', 12781, 2916401, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11446, 8244, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ SAMBAIBA', 139899, 2916500, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11447, 8245, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 136309, 2916500, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11448, 8246, 'TABELIONATO COM FUNCAO DE PROTESTO', 140400, 2916500, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11449, 8247, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS. ', 140038, 2916500, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11450, 8248, 'ITAPITANGA - TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 11312, 2916609, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11451, 4, 'ITAPITANGA - REGISTRO CIVIL DAS PESSOAS NATURAIS', 11304, 2916609, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11452, 8249, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS.', 140301, 2916609, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11453, 5, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12559, 2916708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11454, 8250, 'TABELIONATO DE NOTAS E PROTESTOS', 15131, 2916708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11455, 8251, 'CARTORIO DE REGISTRO DE IMOVEIS E TITULOS E DOCUMENTOS', 7922, 2916708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11456, 9, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ RIBEIRAO DO SALTO', 140061, 2916807, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11457, 8252, 'CARTORIO DE REGISTRO DE IMOVEIS TIT. DOCUMENTOS E PESSOAS JURIDICAS', 7997, 2916807, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11458, 8, 'CARTORIO DO REGISTRO CIVIL', 8532, 2916807, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11459, 8253, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 15081, 2916807, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11460, 643, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS', 9639, 2916856, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11461, 184, 'REGISTRO CIVIL C/ FUNCOES NOTORIAS', 11775, 2916906, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11462, 10, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE ITIRUCU BAHI', 6833, 2916906, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11463, 271, 'ITIRUCU - CARTORIO DE REGISTRO CIVIL - DISTRITO DE LAFAIETE COUTINHO', 143628, 2916906, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11464, 8254, 'TABELIONATO DE NOTAS E PROTESTO', 15016, 2916906, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11465, 8255, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 135152, 2916906, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11466, 8256, 'ITIUBA CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 11320, 2917003, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11467, 8257, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTOS DE TITULOS', 14795, 2917003, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11468, 272, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS - SEDE', 9605, 2917003, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11469, 8258, 'REG. CIVIL C/ FUNC NOTARIAIS - ITAIA', 135160, 2917102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11470, 8259, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS. ', 140293, 2917102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11471, 8260, 'TABELIONATO  COM FUNC. DE PROTESTO', 138032, 2917102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11472, 185, 'REGISTRO CIVIL COM FUNCOES NOTARIAS - ITATI', 140194, 2917102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11473, 273, 'REG. CIVIL C/ FUNC NOTARIAIS - RIO DO MEIO', 135186, 2917102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11474, 8261, 'REGISTRO CIVIL COM FUNCOES NOTARIAS - FIRMINO ALVES ', 140186, 2917102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11475, 8262, 'REG. CIVIL C/ FUNC NOTARIAIS - PALMIRA', 135178, 2917102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11476, 8696, 'CARTORIO 2º OFICIO / RODRIGUES PAIVA', 16089, 2301604, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11477, 8697, 'CARTORIO REG. CIVIL DISTRITO DE ARATAMA', 147009, 2301604, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11478, 767, 'CARTORIO QUEZADO - 1º OFICIO  ', 17434, 2301703, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11479, 766, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DO TIPI', 19117, 2301703, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11480, 765, 'CARTORIO GONCALVES REGISTRO CIVIL', 19406, 2301703, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11481, 8698, 'CARTORIO LEITE - 2º OFICIO', 19513, 2301703, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11482, 8699, 'CARTORIO DE NOTAS E REGISTROS PUBLICOS', 16592, 2301802, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11483, 768, 'CARTORIO DO 1º OFICIO DE REGISTRO CIVIL ADELIA FARIAS', 17475, 2301802, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11484, 8700, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE SITIA', 146928, 2301851, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11485, 8701, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE RINARE', 137836, 2301851, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11486, 8702, '1° OFICIO DE REGISTRO CIVIL', 136671, 2301851, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11487, 8703, 'CARTORIO DO 2º OFICIO', 17657, 2301851, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11488, 8704, 'CARTORIO OLIVEIRA & OLIVEIRA - 2° OFICIO DA COMARCA DE BARBALHA-CEARA', 19810, 2301901, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11489, 770, 'PRIMEIRO CARTORIO DE BARBALHA', 20701, 2301901, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11490, 769, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO ARAJARA', 18747, 2301901, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11491, 8705, '2º OFICIO DE REGISTRO DE IMOVEIS ', 137695, 2301950, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11492, 771, 'CARTORIO OFICIAL DO REGISTRO DE BARREIRA', 17301, 2301950, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11493, 774, 'CARTORIO ALMEIDA TAVARES', 16170, 2302008, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11494, 8706, 'CARTORIO DO 2º OFICIO', 17640, 2302008, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11495, 773, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE CUNCAS', 17038, 2302008, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11496, 6921, 'CARTORIO-REGISTRO CIVIL', 19299, 2302008, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11497, 772, 'CARTORIO DO 1º OFICIO DO REG. CIVIL', 17525, 2302008, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11498, 776, 'SERVICO NOTARIAAL E REGISTRAL DE BARROQUINHA', 20891, 2302057, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11499, 775, 'CARTORIO DO REGISTRO CIVIL DE ARARAS', 18333, 2302057, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11500, 8707, '2° OFICIO DE REGISTRO DE IMOVEIS', 137844, 2302057, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11501, 8708, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE BITUPITA', 136713, 2302057, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11502, 8709, 'SEGUNDO SERVICO PUBLICO DELEGADO NOTARIAL E DE REGISTROS - CARTORIO BATURITE', 20875, 2302107, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11503, 777, 'CARTORIO CASTRO E SILVA 1º. OFICIO', 16386, 2302107, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11504, 7500, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE SERRA DO FELIX', 153791, 2302206, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11505, 780, 'CARTORIO DO 1° OFICIO DE BEBERIBE', 19414, 2302206, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11506, 7499, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE PARIPUEIRA', 135483, 2302206, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11507, 8710, 'CARTORIO GERARDO FACUNDO', 19398, 2302206, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11508, 778, 'CARTORIO ARAUJO - REGISTRO CIVIL DE SUCATINGA', 18200, 2302206, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11509, 779, 'CARTORIO DO REGISTRO CIVIL DE ITAPEIM', 18457, 2302206, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11510, 6922, 'CARTORIO REGISTRO CIVIL DISTRITO DE PARAJURU', 20016, 2302206, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11511, 8711, 'CARTORIO 2º OFICIO - CARTORIO GLORIA ', 16063, 2302305, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11512, 782, 'CARTORIO DO RESGISTRO CIVIL DO DISTRITO DE PRATA', 19208, 2302305, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11513, 781, 'CARTORIO BELA CRUZ', 20180, 2302305, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11514, 786, 'CARTORIO DR ALVARES FERNANDES', 19281, 2302404, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11515, 787, 'CARTORIO GERALDINA 1º OFICIO', 19380, 2302404, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11516, 785, 'CARTORIO CONCEICAO GOMES', 16436, 2302404, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11517, 8712, '2º OFICIO NOTARIAL E DE REGISTROS PUBLICOS', 15685, 2302404, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11518, 784, 'CARTORIO BEZERRA VIEIRA', 16311, 2302404, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11519, 783, 'CARTORIO DO REGISTRO CIVIL DE JACAMPARI', 18465, 2302404, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11520, 789, 'CARTORIO DO 1º OFICIO DE BREJO SANTO', 17442, 2302503, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11521, 788, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE SAO FELIPE', 19059, 2302503, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11522, 8713, 'CARTORIO MATIAS - 2º OFICIO', 19653, 2302503, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11523, 8714, 'CARTORIO DO 3º OFICIO', 17848, 2302503, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11524, 8715, 'CARTORIO MOREIRA DE CASTRO', 19679, 2302602, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11525, 791, 'CAMOCIM CARTORIO 1º OFICIO', 15826, 2302602, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11526, 790, 'REGIJSTRO CIVIL DIST. GURIU', 20727, 2302602, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11527, 8716, 'SEGUNDO OFICIO DE CAMOCIM - MESTRE MANOEL VALENTE FIGUEIREDO NETO', 16212, 2302602, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11528, 796, 'CARTORIO DE REGISTRO CIVIL DE ITAGUA', 16923, 2302701, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11529, 795, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE QUIXARIU', 136796, 2302701, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11530, 6923, 'CARTORIO DO 1º OFICIO DE CAMPOS SALES', 265, 2302701, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11531, 1044, 'CARTORIO DE REGISTRO CIVIL E NOTAS DO DISTRITO DE ITAUNAS', 22194, 3201605, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11532, 1047, 'CARTORIO DE NOTAS E REGISTRO CIVIL DE CONCEICAO DO CASTELO, ES', 21881, 3201704, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11533, 9036, 'CONCEICAO DE CASTELO CARTORIO DE PRIMEIRO OFICIO', 23994, 3201704, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11534, 1049, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO - DIVINO SAO LOURENCO', 145037, 3201803, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11535, 1048, 'CARTORIO DO REGISTRI CIVIL E TABELIONATO DE DIVINO DE SAO LOURENCO-ES.', 23309, 3201803, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11536, 1050, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO, DISTRITO DE MELGACO, MUNICIPIO E COMARCA DE DOMINGOS MARTINS', 23671, 3201902, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11537, 9037, 'CARTORIO 1º OFICIO DOMINGOS MARTINS', 21659, 3201902, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11538, 1189, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DA SEDE, MUNICIPIO E COMARCA DE DOMINGOS MARTINS-ES', 23556, 3201902, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11539, 1188, 'REGISTRO CIVIL E TABELIONATO DE PARAJU', 24018, 3201902, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11540, 1052, 'SERVICO DE NOTAS E REGISTRO CIVIL DE ARACE', 24562, 3201902, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11541, 1051, 'CARTORIO DE SANTA IZABEL', 22764, 3201902, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11542, 1190, 'CARTORIO DE REGISTRO CIVIL', 23242, 3202009, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11543, 9038, 'CARTORIO DO PRIMEIRO OFICIO', 23259, 3202009, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11544, 9039, 'CARTORIO DO TERCEIRO OFICIO DE ECOPORANGA', 23697, 3202108, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11545, 9040, 'ECOPORANGA CARTORIO DO 1º OFICIO', 24026, 3202108, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11546, 1193, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 23366, 3202108, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11547, 1054, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 22046, 3202108, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11548, 1192, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DO DISTRITO DE SANTA LUZIA DO NORTE, ECOPORANGA-ES', 22699, 3202108, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11549, 6861, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DO DISTRITO DE JOASSUBA', 22673, 3202108, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11550, 1194, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE COTAXE', 22459, 3202108, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11551, 1191, 'CATORIO MODESTO', 23952, 3202108, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11552, 1053, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DA SEDE', 23523, 3202108, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11553, 1196, 'FUNDAO CARTORIO DE NOTAS E REGISTRO CIVIL', 24034, 3202207, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11554, 9041, 'CARTORIO DO REG. CIVIL DO DISTRITO DE PATRIARCA', 146589, 2312908, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11555, 1770, 'CARTORIO DE REGISTRO CIVIL DE ARACATIACU', 16865, 2312908, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11556, 9042, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE RAFAEL ARRUDA', 136242, 2312908, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11557, 1771, 'SOBRAL CARTORIO DO 2 OFICIO', 20909, 2312908, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11558, 9043, '1° OFICIO DE REGISTRO DE IMOVEIS', 137596, 2312908, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11559, 1769, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS DO DISTRITO DE TAPERUABA', 18614, 2312908, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11560, 9044, 'SOBRAL CARTORIO DO 6º OFICIO', 20917, 2312908, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11561, 9045, 'CARTORIO  DE REGISTRO CIVIL - DISTRITO DE JORDAO', 136267, 2312908, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11562, 9046, 'SOLONOPOLE SEGUNDO CARTORIO', 20925, 2313005, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11563, 7504, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE SAO JOSE', 136333, 2313005, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11564, 9047, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE CANGATI', 136325, 2313005, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11565, 1773, '1.ª OFICIO  DO REGISTRO CIVIL E TABELIONATO DE PROTESTO E REGISTROS', 15503, 2313005, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11566, 9048, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE PASTA', 136358, 2313005, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11567, 1774, 'CARTORIO DO PRIMEIRO OFICIO', 18093, 2313104, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11568, 9049, 'CARTORIO DO 2º OFICIO', 17616, 2313104, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11569, 1775, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 16816, 2313104, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11570, 1777, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE SUCESSO', 19083, 2313203, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11571, 1778, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE CURATIS', 17046, 2313203, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11572, 1776, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE HOLANDA', 18895, 2313203, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11573, 6931, 'CARTORIO DO PRIMEIRO OFICIO', 18119, 2313203, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11574, 1779, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE OLIVEIRAS', 18986, 2313203, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11575, 9050, 'CARTORIO DO 2º OFICIO - REGISTRO DE IMOVEIS', 17699, 2313203, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11576, 1780, 'CARTORIO DO OFICIO DE NOTAS E REGISTROS', 18036, 2313252, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11577, 1782, 'TAUA CARTORIO DO 1º OFICIO NOTAS', 20941, 2313302, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11578, 9051, 'CARTORIO DO REG. CIVIL DO DISTRITO DE CAICARA', 146597, 2313302, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11579, 1781, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE BARRA NOVA', 16840, 2313302, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11580, 9052, 'TAUA - CARTORIO DO 2º OFICIO ', 20933, 2313302, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11581, 7798, 'REG. CIVIL C/ FUNC NOTARIAIS - SAO JOAO DA PANELINHA', 133108, 2905602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11582, 7799, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 138065, 2905602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11583, 7800, 'REG. CIVIL C/ FUNC NOTARIAIS - PIMENTA', 133090, 2905602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11584, 7801, 'CAMACAN - CARTORIO DE REGISTRO CIVIL - DISTRITO DE MASCOTE', 144113, 2905602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11585, 7802, 'REG. CIVIL C/ FUNC NOTARIAIS - TEIXEIRA DO PROGRESSO', 133124, 2905602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11586, 7803, 'REG. CIVIL C/ FUNC NOTARIAIS - ARATACA', 133082, 2905602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11587, 7804, 'CAMACAN - CARTORIO DE REGISTRO CIVIL - DISTRITO DE ITATINGUI', 144105, 2905602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11588, 7805, 'REG. CIVIL C/ FUNC NOTARIAIS - SAO JOAO DO PARAISO', 133116, 2905602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11589, 7806, 'CARTORIO DE PROTESTO DE TITULOS DE CAMACARI', 5801, 2905701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11590, 7807, '2º OFICIO DE NOTAS', 5397, 2905701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11591, 7808, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 8151, 2905701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11592, 579, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12443, 2905701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11593, 7809, 'CARTORIO DE REGISTRO DE IMOVEIS DO 1º OFICIO', 7484, 2905701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11594, 578, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTORIAIS DE MONTE GORDO', 6296, 2905701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11595, 7810, 'CARTORIO DE IMOVEIS 2º 0FICIO', 5637, 2905701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11596, 7811, '1º DE NOTAS DE CAMACARI BAHIA', 5322, 2905701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11597, 580, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS DO DISTRITO DE ABRANTES CAMACARI-BAHIA', 6221, 2905701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11598, 1381, 'CARTORIO DO REGISTRO CIVIL C/ FUNCOES NOTARIAIS DO DISTRITO DE TAPUIA COMARCA DE CAMAMU-BAHIA', 8664, 2905800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11599, 582, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS  DISTRITO JUDICIARIO DE IGRAPIUNA - COMARCA DE CAMAMU - BAHIA', 143495, 2905800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11600, 7812, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 15057, 2905800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11601, 8720, 'CARTORIO DO 2º OFICIO DE CANINDE', 17228, 2302800, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11602, 581, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS DO DISTRITO JUDICIARIO DE BARCELOS DO SUL COMARCA DE CAMAMU DO ESTADO DA BAHIA', 9019, 2905800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11603, 7813, 'OFICIO DO REGISTRO DE IMOVEIS TITULOS E DOCUMENTOS PESSOAS JURIDICAS', 11528, 2905800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11604, 1382, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 11502, 2905800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11605, 7814, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14258, 2906006, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11606, 7815, 'REG. CIVIL C/ FUNC NOTARIAIS - LAJE DOS NEGROS', 133140, 2906006, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11607, 7816, 'CARTORIO DO REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS', 10413, 2906006, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11608, 7817, 'REG. CIVIL C/ FUNC NOTARIAIS - DELFINO', 133132, 2906006, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11609, 1383, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6676, 2906006, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11610, 7818, 'REG. CIVIL C/ FUNC NOTARIAIS - POCOS', 133157, 2906006, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11611, 1385, 'CARTORIO DO REGISTRO CIVIL', 8607, 2906204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11612, 7819, 'TABELIONATO C/ FUNCAO DE PROTESTO', 134445, 2906204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11613, 7820, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 134437, 2906204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11614, 1384, 'REG. CIVIL C/ FUNC NOTARIAIS - PAZ DE SALOBRO', 134486, 2906204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11615, 7821, 'CARTORIO DE TITULOS E PROTESTOS E TABELIONATO', 8326, 2906204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11616, 7822, 'REG. CIVIL C/ FUNC NOTARIAIS - LAGOA FUNDA', 134478, 2906204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11617, 7823, 'REGISTRO DE IMOVEIS, HIP. E DOCS', 133165, 2906303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11618, 583, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 139279, 2906303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11619, 7824, 'REG. CIVIL C/ FUNC NOTARIAIS - JACARANDA', 133181, 2906303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11620, 7587, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ PUXIM', 139816, 2906303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11621, 7825, 'TABELIONATO COM FUNCAO DE PROTESTOS', 133173, 2906303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11622, 584, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ OURICANA', 139691, 2906303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11623, 1386, 'REG. CIVIL C/ FUNC NOTARIAIS - CANDEAL', 135038, 2906402, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11624, 7826, 'TABELIONATO DE NOTAS C/FUNCAO DE PROTESTO', 14142, 2906501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11625, 7827, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 139469, 2906501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11626, 7828, 'REG. CIVIL C/ FUNC NOTARIAIS - PASSAGEM DO TEIXEIRAS', 133199, 2906501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11627, 7797, 'TABELIONATO COM FUNCAO DE PROTESTO', 138099, 2905602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11628, 585, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE PASSE', 9795, 2906501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11629, 7829, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS.', 139600, 2906501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11630, 1387, 'GUANAMBI - CARTORIO DE REGISTRO CIVIL - DISTRITO DE CANDIBA', 143909, 2906600, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11631, 274, 'REGISTRO CIVIL DAS PESSOAS NATURAIS ', 139980, 2917102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11632, 275, 'CARTORIO DO REGISTRO CIVI DAS PESSOAS NATURAIS', 8516, 2917201, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11633, 276, 'ITUACU - CARTORIO DE REGISTRO CIVIL - DISTRITO DE CONTENDAS DO SINCORA', 143669, 2917201, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11634, 8263, 'TABELIONATO DE NOTAS - PROTESTO DE TITULOS', 14001, 2917201, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11635, 8264, 'REG. CIVIL C/ FUNC NOTARIAIS - TRANQUEIRAS', 135194, 2917201, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11636, 8265, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS', 10025, 2917201, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11637, 186, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE ITUBERA - BAHIA', 9720, 2917300, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11638, 8266, 'REGISTRO DE IMOVEIS DA COMARCA DE ITUBERA BAHIA', 12963, 2917300, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11639, 8267, 'CARTORIO DO TABELIONATO DE NOTAS DA COMARCA DE ITUBERA - BAHIA', 10603, 2917300, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11640, 7489, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAS', 9035, 2917359, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11641, 8268, 'CARTORIO DO TABELIONATO DE NOTAS E PROTESTOS', 10629, 2917409, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11642, 8269, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS. ', 140582, 2917409, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11643, 189, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 12484, 2917409, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11644, 188, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS VILA DO PAIOL', 12062, 2917409, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11645, 187, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS', 11940, 2917409, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11646, 191, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO REGISTRO CIVIL DO 1º OFICIO', 9969, 2917508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11647, 195, 'TABELIONATO DE NOTAS DO Lº OFICIO', 14951, 2917508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11648, 7490, 'JACOBINA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE ITAITU', 144345, 2917508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11649, 8270, 'JACOBINA - 2º TABELIONATO DE NOTAS', 11338, 2917508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11650, 8271, 'REG. CIVIL C/ FUNCOES NOTARIAIS - OUROLANDIA', 133611, 2917508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11651, 8272, 'CARTORIO REGISTRO DE IMOVEIS E HIPOTECAS DO 2º OFICIO', 11007, 2917508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11652, 8273, '1º OFICIO DO REGISTRO DE IMOVEIS', 5348, 2917508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11653, 192, 'JACOBINA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE CAATINGA DO MOURA', 144337, 2917508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11654, 193, 'JACOBINA/DISTRITO DE MIRANGABA - REGISTRO CIVIL COM FUNCOES NOTARIAIS', 11346, 2917508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11655, 8274, 'REG. CIVIL C/ FUNCOES NOTARIAIS - JUNCO', 133595, 2917508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11656, 194, 'CARTORIO REGISTRO CIVIL E DAS PESSOAS NATURAIS DO 2 OFICIO', 10942, 2917508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11657, 8275, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ CAEM', 140368, 2917508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11658, 8276, 'CARTORIO DE PROTESTOS DE TITULOS E DOCUMENTOS', 5843, 2917508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11659, 8277, 'REG. CIVIL C/ FUNCOES NOTARIAIS - ITAPEIPU', 133579, 2917508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11660, 8278, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS', 8177, 2917508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11661, 190, 'REG. CIVIL C/ FUNCOES NOTARIAIS - VARZEA NOVA', 133637, 2917508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11662, 8279, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTOS', 14548, 2917607, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11663, 196, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9142, 2917607, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11664, 198, 'REG. CIVIL C/ FUNC NOTARIAIS - STELA DUBOIS', 135210, 2917607, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11665, 8280, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS TITULOS E DOCUMENTOS', 10199, 2917607, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11666, 197, 'CARTORIO DO REGISTRO CIVIL- DISTRITO DE IPIUNA', 10009, 2917607, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11667, 199, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 12369, 2917706, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11668, 200, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS ', 11882, 2917706, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11669, 8281, 'TABELIONATO DE NOTAS C/CPROTESTO DE TITULOS', 14092, 2917706, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11670, 8282, 'REGISTRO DE IMOVEIS E HIPOTECAS E TITULOS E DOCUMENTOS', 13094, 2917706, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11671, 8283, 'REG. CIVIL C/ FUNC NOTARIAIS - PILAR', 135228, 2917706, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11672, 8284, 'REGISTRO DE IMOVEIS TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 13235, 2917805, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11673, 8285, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 137505, 2917805, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11674, 8286, 'TABELIONATO DE NOTAS DA COMARCA DE JAGUARIPE BAHIA', 14860, 2917805, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11675, 277, 'REGISTRO CIVIL C/ FUNC NOTARIAIS DE CUNHANGI', 10967, 2917805, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11676, 202, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS DO DISTRITO DE PIRAJUIA DA COMARCA DE JAGUARIPE - BAHIA', 12054, 2917805, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11677, 203, 'REGISTRO CIVIL COM FUNCOES NOTARIASI - DISTRITO DE BARREIRAS DE JACURUNA', 12096, 2917805, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11678, 793, 'CARTORIO REGISTRO CIVIL - DISTRITO DE BARAO DE AQUIRAZ', 135541, 2302701, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11679, 794, 'CARTORIO DO 2º OFICIO', 17632, 2302701, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11680, 792, 'CARTORIO DE REGISTRO CIVIL DE CARMELOPOLIS', 16899, 2302701, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11681, 798, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 20776, 2302800, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11682, 799, 'CARTORIO SAO FRANCISCO', 19596, 2302800, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11683, 797, 'CARTORIO REGISTRO CIVI DE UBIRASSU', 19984, 2302800, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11684, 8717, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE BONITO', 135558, 2302800, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11685, 8718, 'CARTORIO DE TARGINOS', 17269, 2302800, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11686, 8719, 'CARTORIO ALMEIDA', 16154, 2302800, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11687, 8721, 'CARTORIO DO REGISTRO DE IMOVEIS DE CAPISTRANO', 19182, 2302909, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11688, 800, 'CARTORIO DO 1º OFICIO HERBSTER LUCAS', 17558, 2302909, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11689, 8722, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE INHUPORANGA', 136820, 2303006, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11690, 8723, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE SAO DOMINGOS', 135582, 2303006, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11691, 801, 'DE NOTAS E REGISTROS', 20347, 2303006, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11692, 803, 'CARTORIO RIBAMAR (1º OFICIO)', 20040, 2303105, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11693, 802, 'CARTORIO  DO REGISTROCIVIL DE ARARIUS', 15891, 2303105, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11694, 8724, 'CARIRE-CARTORIO DO 2º OFICIO', 15834, 2303105, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11695, 8725, 'CARTORIO 2O OFICIO - REGISTRO DE IMOVEIS', 15982, 2303204, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11696, 8726, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE VILA FEITOSA', 135616, 2303204, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11697, 805, 'CARTORIO SAO PEDRO', 20149, 2303204, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11698, 8727, 'IGUATU CARTORIO DO 2º OFICIO', 20446, 2305506, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11699, 7509, 'CARTORIO DE PRIMEIRO OFICIO -ALVES DA SILVA', 18077, 2305506, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11700, 8728, 'CARTORIO DO 3º OFICIO DE NOTAS E REGISTROS PUBLICOS DE IGUATU', 17871, 2305506, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11701, 8729, 'CARTORIO DO DISTRITO DE BAU', 149260, 2305506, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11702, 884, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE EMATUBA', 18291, 2305605, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11703, 885, 'CARTORIO JOAQUIM AUGUSTO - 1º OFICIO', 19471, 2305605, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11704, 883, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 20768, 2305605, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11705, 8730, 'CARTORIO GILVAN PACIFICO', 17814, 2305605, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11706, 8731, '2º OFICIO DE REGISTRO DE IMOVEIS', 135764, 2305605, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11707, 8732, 'CARTORIO DO 3º OFICIO O SENHOR E NOSSA JUSTICA', 17913, 2305605, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11708, 8733, 'CARTORIO GETULIO DORNELLES', 19661, 2305654, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11709, 886, 'CARTORIO DO 1º OFICIO - SOUZA MARTINS', 17368, 2305704, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11710, 8734, 'CARTORIO CASTELAR -2º. OFICIO', 16378, 2305704, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11711, 887, 'CARTORIO DO REGISTRO CIVIL', 18234, 2305704, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11712, 8735, 'CARTORIO ARAGAO - 2 OFICIO', 16238, 2305803, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11713, 888, 'IPU - CARTORIO 1º OFICIO - CARTORIO TAVARES', 20453, 2305803, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11714, 8736, 'CARTORIO DE REGISTRO CIVIL - ENG° JOAO TOME', 136903, 2305902, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11715, 891, 'CARTORIO REGISTRO CIVIL GAZEA', 20024, 2305902, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11716, 8737, 'CARTORIO DO REGISTRO CIVIL DISTRITO S. JOSE DE LONTRAS', 146993, 2305902, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11717, 890, 'CARTORIO DE REGISTRO CIVIL - DISTRITO  DE LIVRAMENTO', 135780, 2305902, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11718, 6927, 'CARTORIO BENTO FILHO', 16261, 2305902, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11719, 8738, 'CARTORIO DO REGISTRO CIVIL DIST. MATRIZ SAO GONCALO', 146985, 2305902, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11720, 889, 'OFICIO DO REGISTRO CIVIL DO DISTRITO DE NOVA FATIMA', 20644, 2305902, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11721, 8739, 'CARTORIO CATUNDA SOBRINHO - 2 OFICIO DE NOTAS E REGISTRO DE IMOVEIS', 16394, 2305902, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11722, 8740, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE AMERICA', 136911, 2305902, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11723, 892, 'CARTORIO PONTE', 19935, 2305902, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11724, 8741, 'CARTORIO DO 2º OFICIO DA COMARCA DE IRACEMA - CE', 17715, 2306009, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11725, 893, 'CARTORIO GUERRA 1º OFICIO', 19422, 2306009, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11726, 85, 'CARTORIO MAGALHAES BRAGA', 19612, 2306108, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11727, 894, 'OFICIO DE NOTAS E DE REGISTROS PUBLICOS', 20586, 2306108, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11728, 8742, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE MISSI', 135806, 2306108, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11729, 895, 'CARTORIO DE OFICIOS, NOTAS E REGISTROS DA COMARCA VINCULADA DE ITAICABA/CE', 16733, 2306207, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11730, 896, 'OFICIO DE NOTAS E REGISTROS', 136978, 2306256, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11731, 86, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE CRUZ', 137901, 2306306, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11732, 897, 'CARTORIO DO REGISTRO CIVIL DE BAIXA GRANDE', 18341, 2306306, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11733, 8743, 'CARTORIO BRITO FIRMEZA - 2º OFICIO - REGISTRO DE IMOVEIS', 16352, 2306306, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11734, 9053, 'SERVENTIA CARTORIO DE REGISTRO CIVIL - DISTRITO DE TRICI', 136440, 2313302, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11735, 1784, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE INHAMUNS', 16857, 2313302, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11736, 9054, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE MARROAS', 136432, 2313302, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11737, 1783, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO SANTA TEREZA', 19133, 2313302, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11738, 7505, 'CARTORIO DO REG. CIVIL DO DISTRITO DE MARRECAS', 146605, 2313302, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11739, 9055, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE CARRAPATEIRAS', 136416, 2313302, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11740, 1785, 'CARTORIO AMANDO FERREIRA DA SILVA - DISTRITO DE CAXITORE - COM. TEJUCUOCA-CE', 16196, 2313351, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11741, 1786, 'CARTORIO DE OFICIO, NOTAS E REGISTRO DE TEJUCUOCA', 16683, 2313351, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11742, 9056, 'SERVENTIA CARTORIO DE REGISTRO CIVIL - DISTRITO DE PINDOGUABA', 136457, 2313401, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11743, 9057, 'CARTORIO DO 2 OFICIO', 20057, 2313401, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11744, 6932, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE ARAPA', 18788, 2313401, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11745, 9058, 'CARTORIO NEVES - 3º OFICIO', 19745, 2313401, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11746, 1788, 'CARTORIO DO REGISTRO CIVIL DE CARUATAI', 18374, 2313401, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11747, 9059, 'SERVENTIA SERVENTIA CARTORIO DE REGISTRO CIVIL - DISTRITO DE TABAINHA', 136465, 2313401, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11748, 1787, 'CARTORIO NOGUEIRA LIMA - 1º OFICIO', 19778, 2313401, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11749, 9060, 'CARTORIO PRIVATIVO DE PROTESO DE TITULOS E LETRAS', 23747, 3205309, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11750, 6870, 'CARTORIO AMORIM - VITORIA CARTORIO DE TABELIONATO E REGISTRO CIVIL DO DISTRITO DE GOIABEIRAS', 21733, 3205309, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11751, 9061, '1º OFICIO (TABELIONATO)', 21360, 3205309, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11752, 9062, 'CARTORIO DO 3º OFICIO DE NOTAS DE VITORIA/ES', 23200, 3205309, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11753, 9063, 'REGISTRO GERAL DE IMOVEIS (2ª ZONA DE VITORIA)', 24448, 3205309, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11754, 9064, 'VITORIA CARTORIO DE REGISTRO DE IMOVEIS 1ª ZONA', 24653, 3205309, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11755, 1088, 'CARTORIO DE REG. CIVIL  TABELIONATO DA 2ª ZONA JUD. DE VITORIA', 21956, 3205309, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11756, 1089, 'VITORIA CARTORIO DO REGISTRO CIVIL DAS PESSOAS FISICAS, JURIDICAS E TABELIONATO DE NOTAS', 24661, 3205309, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11757, 9065, 'CARTORIO DA 3ª ZONA DO REGISTRO GERAL IMOVEIS E REGSITRO TORRENS DA COMARCA DE  VITORIA ', 21782, 3205309, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11758, 9066, 'CARTORIO DO 2º OFICIO DE NOTAS DA COMARCA DE VITORIA/ES - CARTORIO BRANDAO', 23135, 3205309, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11759, 9067, 'CARTORIO DE TABELIONATO DE NOTAS DE GOIABEIRAS', 153387, 3205309, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11760, 9068, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS', 22749, 3205309, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11761, 9069, 'CARTORIO DO 4º OFICIO DE NOTAS', 23218, 3205309, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11762, 1090, 'SERVICOS DE NOTAS, PROT. DE TITULOS, TABEL. E REG. DE CONTRATOS MARITIMOS, REG. DE IMOVEIS, REG. DE TITULOS E DOC., CIVIL DAS PESS. JUR. E CIVIL DAS PESS. NAT. E DE INTERD. E TUTELA DE ABADIA DE GOIAS', 29199, 5200050, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11763, 9070, 'SERVICO DE REGISTRO DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E PROTESTOS, TABELIONATO 2º DE NOTAS E ESCRIVANIA 2ª CIVEL DE ABADIANIA, ESTADO DE GOIAS', 29009, 5200100, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11764, 1271, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS DA COMARCA DE ABADIANIA - GO', 25692, 5200100, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11765, 9071, 'CARTORIO 1º OFICIO DE NOTAS E REGISTRO DE IMOVEIS', 25155, 5200100, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11766, 1272, 'CARTORIO DE REG. DE PESSOAS JURIDICAS, TITULOS, DOCUMENTOS E REGISTRO DE PESSOA NATURAIS', 26922, 5200134, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11767, 9072, 'CARTORIO DE REGISTRO DE IMOVEIS, PROTESTO DE TITULOS E TABELIONATO DE NOTAS', 26328, 5200134, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11768, 9073, 'UNICO OFICIO', 29561, 5200159, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11769, 1091, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOVES E ANEXOS', 27912, 5200175, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11770, 9074, 'CARTORIO DE TABELIONATO DE NOTAS, PROTESTO DE TITULOS, REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS, CIVEL DAS PESSOAS JURIDICAS, CIVEL DAS PESSOAS NATURAIS E INTERDICOES E TUTELAS E REGISTRO', 26724, 5200209, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11771, 1273, 'CARTORIO DE REGISTRO DE IMOVEIS, CIVIL E ANEXOS', 26377, 5200258, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11772, 9075, 'TABELIONATO DE NOTAS, PROTESTO DE TITULOS, TABELIONATO E OFICIALATO DE REGISTRO DE CONTRATOS MARITIMOS', 146837, 5200258, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11773, 9076, 'CARTORIO DE REGISTRO GERAL DE IMOVEIS E TABELIONATO 1º DE NOTAS', 26658, 5200308, 'GO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11774, 7830, 'CANDIDO SALES - CARTORIO DE REGISTRO CIVIL - DISTRITO DE LAGOA GRANDE', 143503, 2906709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11775, 7831, 'CANDIDO SALES - REGISTRO DE IMOVEIS', 5561, 2906709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11776, 1388, 'REG. CIVIL C/ FUNC NOTARIAIS - QUARACU', 134502, 2906709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11777, 7832, 'TABELIONATO DE NOTAS COM FUNCOES NOTARIAIS', 14811, 2906709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11778, 7833, 'TABELIONATO C/ FUNCAO DE PROTESTO', 134494, 2906709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11779, 1351, 'REGISTRO CIVIL DE PESSOAS NATURAIS E NOTAS DE BOCA DA MATA', 3582, 2701001, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11780, 1352, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE BRANQUINHA', 2998, 2701100, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11781, 7622, 'CARTORIO DO UNICO OFICIO DE BRANQUINHA', 3202, 2701100, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11782, 7623, 'CARTORIO LUIZ SOUTO NETO', 3285, 2701209, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11783, 1353, 'CARTORIO DE REGISTRO CIVIL ', 2139, 2701209, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11784, 7624, 'CARTORIO DO UNICO OFICIO', 3145, 2701308, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11785, 451, 'CARTORIO DP REG CIVIL DAS PESSOAS NATURAIS', 10652, 2904209, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11786, 7945, 'REGISTRO DE IMOVEIS E DOCUMENTOS E PESSOAS JURIDICAS', 13003, 2904308, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11787, 7946, 'TABELIONATO DE NOTAS C/ FUNCAO DE PROTESTO', 14035, 2904308, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11788, 6472, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6478, 2904308, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11789, 933, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS DE BREJOLANDIA - BA', 10900, 2904407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11790, 453, 'REGISTRO CIVIL COM FUNCOES', 11874, 2904506, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11791, 935, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9415, 2904506, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11792, 934, 'CART.REGISTRO CIVIL COM FUNCOES NOTARIAS', 5595, 2904506, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11793, 455, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ IBIPETUM', 138909, 2904506, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11794, 7947, 'CARTORIO DE REGISTRO DE IMOVEIS', 7377, 2904506, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11795, 454, 'REGISTRO CIVIL C/ FUNC NOTARIAIS - IPUPIARA', 138255, 2904506, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11796, 7948, 'CART.TAB.DE NOTAS COM FUNCAO DE PROTESTO', 5603, 2904506, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11797, 7949, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ UBIRICABA', 140954, 2904605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11798, 7950, 'CARTORIO DE NOTAS COM FUNCOES DE PROTESTOS', 5736, 2904605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11799, 7951, 'REG. CIVIL C/ FUNC NOTARIAIS - ARACATU', 133058, 2904605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11800, 7952, 'CARTORIO DO REGISTRO DE IMOVEIS E TITULOS E DOCUMENTOS', 10322, 2904605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11801, 533, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS DO DISTRITO DE ITAQUARAI, COM. DE BRUMADO - BA', 8995, 2904605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11802, 7580, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ CRISTOLANDIA', 140988, 2904605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11803, 456, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9282, 2904605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11804, 534, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9126, 2904704, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11805, 7953, 'BUERAREMA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE JUSSARI', 143479, 2904704, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11806, 7954, 'CARTORIO DE REGISTROS DE IMOVEIS TITULOS E DOCUMENTOS-PESSOA JURIDICA', 8219, 2904704, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11807, 7955, 'BUERAREMA CARTORIO DE NOTAS', 5553, 2904704, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11808, 535, 'REG. CIVIL C/ FUNC NOTARIAIS - SANTIAGO DO IGUAPE', 134395, 2904902, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11809, 575, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ BELEM', 140004, 2904902, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11810, 7956, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 134387, 2904902, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11811, 7957, 'TABELIONATO COM FUNCAO DE PROTESTO', 138990, 2904902, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11812, 7958, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS.', 138461, 2904902, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11813, 7959, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS.', 134429, 2905008, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11814, 937, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS', 134411, 2905008, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11815, 1378, 'REG. CIVIL C/ FUNCOES NOTARIAIS -DISTRITO DE IBIASSUCE', 134403, 2905008, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11816, 536, 'REGISTRO CIVIL C/ FUNCOES NOTARIAS - DISTRITO DE GUAREJU', 143487, 2905008, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11817, 7960, 'TABELIONATO DE NOTAS / CARTORIO DE PROTESTOS', 14019, 2905008, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11818, 7583, 'REGISTRO CIVIL COM FUNCOES NOTARIAS - CAETANOS', 138438, 2905156, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11819, 538, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS', 9662, 2905206, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11820, 1379, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE CAETITE SEDE', 6809, 2905206, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11821, 938, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS - LAGOA REAL', 140863, 2905206, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11822, 537, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS C.F NOTARIAIS DE PAJEU DO VENTO', 14944, 2905206, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11823, 7961, 'TABELIONATO C/ FUNCAO DE PROTESTO', 133066, 2905206, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11824, 939, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS', 8896, 2905206, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11825, 539, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS- BREJINHO DAS AMETISTAS', 9027, 2905206, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11826, 7962, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS TITULOS E DOCUMENTOS', 10207, 2905206, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11827, 540, 'REG. CIVIL C/ FUNC. NOTARIAIS - VELHA BOIPEBA', 137356, 2905404, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11828, 1380, 'CARTORIO DO REGISTRO CIVIL DE CAIRU', 9837, 2905404, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11829, 7963, 'TABELIONATO COM FUNCAO DE PROTESTO', 138131, 2905503, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11830, 7964, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 7864, 2908002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11831, 7965, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 134668, 2908101, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11832, 1317, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTOS', 14779, 2908200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11833, 8404, 'REG. CIVIL C/ FUNCOES NOTARIAIS - MIRANDELA', 133827, 2926608, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11834, 8405, 'CARTORIO DE REGISTRO DE IMOVEIS', 7443, 2926608, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11835, 258, 'RIBEIRA DO POMBAL - CARTORIO DE REGISTRO CIVIL - DISTRITO DE BANZAE', 144444, 2926608, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11836, 8406, 'TABELIONATO DE NOTAS', 13813, 2926608, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11837, 8407, 'REG. CIVIL C/ FUNC. NOTARIAIS - ARAPIRANGA', 138362, 2926707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11838, 8408, 'TABELIONATO DE NOTAS', 13789, 2926707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11839, 8409, 'REG. CIVIL C/ FUNC NOTARIAIS - MARCOLINO MOURA', 132431, 2926707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11840, 63, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9472, 2926707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11841, 607, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 5298, 2926707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11842, 8410, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS', 10132, 2926707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11843, 259, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12203, 2926707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11844, 608, 'CARTORIO DE REGISTRO CIVIL', 5892, 2926806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11845, 64, 'CARTORIO DO REGISTRO CIVIL COM F NOTARIAIS', 8706, 2926806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11846, 8411, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS ', 7872, 2926806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11847, 8412, 'TABELIONATO DE NOTAS', 13904, 2926806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11848, 8413, 'TABELIONATO DE NOTAS E PROTESTO', 15008, 2927002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11849, 65, 'REG. CIVIL C/ FUNC NOTARIAIS - JANDAIRA', 132472, 2927002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11850, 260, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS ', 6700, 2927002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11851, 8414, 'REG. CIVIL C/ FUNC NOTARIAIS - ITANHI', 132464, 2927002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11852, 8415, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS TITULOS DOCUMENTOS E PESOAS JURIDICAS', 7773, 2927002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11853, 8416, 'REG. CIVIL C/ FUNC NOTARIAIS - ABADIA', 132456, 2927002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11854, 8417, 'REG. CIVIL C/ FUNC NOTARIAIS - MANGUE SECO', 132480, 2927002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11855, 8418, 'CARTORIO DO TABELIONATO DE NOTAS', 10512, 2927101, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11856, 8419, 'REGISTRO DE IMOVEIS HIP. E TIT. E DOCS', 132498, 2927101, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11857, 66, 'CARTORIO DE REGISTRO CIVIL', 5934, 2927101, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11858, 8420, 'REGISTRO DE IMOVEIS E HIPOTECAS, TITILOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 13136, 2927200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11859, 67, 'REG. CIVIL C/ FUNC. NOTARIAIS - MORRO DAS FLORES', 137307, 2927200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11860, 609, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS', 11999, 2927200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11861, 8421, 'REG. CIVIL C/ FUNCOES NOTARIAIS - LAJEDINHO', 133835, 2927200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11945, 1357, 'SERVICO REGISTRAL E NOTARIAL DE CHA PRETA/AL', 3970, 2701902, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11862, 8422, 'TABELIONATO DE NOTAS C/FUNCAO DE PROTESTO DA COMARCA DE RUY BARBOSA/BAHIA', 14159, 2927200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11863, 8423, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS', 12005, 2927200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11864, 68, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 12799, 2927200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11865, 610, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS - DISTRITO DE SALINAS DA MARGARIDA', 144428, 2927309, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11866, 627, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE ILHA DE MARE', 12195, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11867, 8424, '13º TABELIONATO DE NOTAS', 5314, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11868, 8425, 'CARTORIO DE REGISTRO CIVIL DO SUBDISTRITO DE BOM JESUS', 131417, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11869, 293, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS ', 9183, 2922730, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11870, 241, 'REG. CIVIL C/ FUNC NOTARIAIS - NOVA IBIA', 133280, 2922755, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11871, 452, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM FINS NOTARIAIS', 12278, 2922805, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11872, 8426, 'TABELIONATO C/ FUNCAO DE PROTESTO', 131946, 2922904, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11873, 8427, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 135590, 2922904, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11874, 8428, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS E TITULOS E DOCUMENTOS AZEREDO MARILY', 7690, 2923001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11875, 8429, 'REG. CIVIL C/ FUNC. NOTARIAIS - ARGOLO', 131961, 2923001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11876, 8430, 'CARTORIO DE NOTAS E PROTESTO DE TITULOS AZEVEDO', 5769, 2923001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11877, 8431, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 131953, 2923001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11878, 242, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS', 6056, 2923001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11879, 243, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS - DISTRITO DE HELVECIA', 6239, 2923001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11880, 295, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ BREJO LUIZA DE BRITO', 139493, 2923035, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11881, 294, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS DO DISTRITO DE REMEDIOS, MUNICIPIO DE NOVO HORIZONTE DA COMARCA DE IBITIARA, BAHIA.', 139485, 2923035, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11882, 8432, 'OLINDINA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE CRISOPOLIS', 143859, 2923100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11883, 1420, 'CARTORIO DE REGISTRO CIVIL', 16782, 2311306, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11884, 1728, 'OFICIO DE NOTAS E REGISTROS DE QUIXELO', 137786, 2311355, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11885, 1730, 'CARTORIO DO REGISTRO CIVIL DE ENCANTADO ', 18382, 2311405, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11886, 8836, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE PIRABIBU', 136127, 2311405, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11887, 1729, 'CARTORIO DO REGISTRO CIVIL DE SAO MIGUEL', 17251, 2311405, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11888, 8837, 'CARTORIO QUEIROZ ROCHA - 2º OFICIO', 19968, 2311405, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11889, 1733, 'CARTORIO DE REGISTRO CIVIL DISTRITO DE PASSAGEM', 17004, 2311405, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11890, 1731, 'CARTORIO REGISTRRO CIVIL LACERDA', 20032, 2311405, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11891, 1732, 'CARTORIO DE REGISTRO CIVIL DISTRITO DE MANITUBA', 16998, 2311405, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11892, 8838, '1º OFICIO DE REGISTRO CIVIL', 137075, 2311405, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11893, 8839, 'CARTORIO DE REGISTRO DE IMOVEIS', 137083, 2311504, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11894, 1734, 'CARTORIO DE OFICIO DE NOTAS E DE REGISTRO', 16634, 2311504, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11895, 1735, 'CARTORIO OFICIAL DO REGISTRO CIVIL DO DISTRITO DE GUASSI, REDENCAO , CEARA.', 19794, 2311603, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11896, 8840, '2º OFICIO DE NOTAS E REGISTRO PUPLICOS', 15677, 2311603, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11897, 8841, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE ANTONIO DIOGO', 136135, 2311603, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11898, 1736, 'CARTORIO DO 1º OFICIO DE NOTAS', 17459, 2311603, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11899, 8842, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE AMANAIARA', 136143, 2311702, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11900, 1737, 'CARTORIO DO 1° OFICIO DO REGISTRO CIVIL DE RERIUTABA - CARTORIO RAFAELA REINALDO', 20735, 2311702, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11901, 8843, 'CARTORIO BRASILEIRO PONTES', 16337, 2311702, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11902, 1742, 'CARTORIO RANTZAU - 1º OFICIO', 19976, 2311801, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11903, 8844, 'CARTORIO DO 2º OFICIO DE RUSSAS', 20834, 2311801, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11904, 8845, 'CARTORIO DO REGISTRO CIVIL DE FLORES', 18416, 2311801, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11905, 1740, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE SAO JOAO DE DEUS - CARTORIO ESTACIO', 19067, 2311801, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11906, 1739, 'CARTORIO DE REGISTRO CIVIL  - DISTRITO DE BONHU - CARTORIO BRAGA', 137109, 2311801, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11907, 8846, 'CARTORIO DO 3º OFICIO DA COMARCA DE RUSSAS', 17863, 2311801, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11908, 1738, 'CARTORIO MACIEL - REGISTRO CIVIL DE PESSOAS NATURAIS DO DISTRITO LAGOA GRANDE - RUSSAS - CE', 19588, 2311801, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11909, 1741, 'REGISTRO CIVIL DISTRITO JUDICIARIO DE PEIXE', 20800, 2311801, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11910, 1743, 'CARTORIO DO PRIMEIRO OFICIO', 18085, 2311900, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11911, 8847, 'CARTORIO NOCRATO', 19760, 2311900, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11912, 1745, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE FLAMENGO', 18879, 2311900, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11913, 1744, 'CARTORIO DO PRIMEIRO OFICIO', 18101, 2311900, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11914, 1746, 'CARTORIO DE NOTAS E REGISTROS PUBLICOS DE SALITRE-CE', 16618, 2311959, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11915, 1750, 'CARTORIO PAULA LOBO', 19877, 2312205, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11916, 1748, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE MACARAU', 18937, 2312205, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11917, 8848, 'CARTORIO FERNANDES - 2º OFICIO', 19315, 2312205, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11918, 1747, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE TRAPIA', 19091, 2312205, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11919, 1751, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE RAIMUNDO MARTINS', 17129, 2312205, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11920, 1749, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS DO DISTRITO DE MALHADA GRANDE', 18598, 2312205, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11921, 1752, 'CARTORIO CAVALCANTE - 1º OFICIO', 16402, 2312007, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11922, 1754, 'CARTORIO ARAUJO - DISTRITO DE SAPO', 137125, 2312007, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11923, 1755, 'CARTORIO PINTO', 19919, 2312007, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11924, 1753, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE MUTAMBEIRAS', 18960, 2312007, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11925, 8849, 'CARTORIO RIOS - 2º OFICIO', 20073, 2312007, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11926, 8850, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE BREJO GRANDE', 136176, 2312106, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11927, 1756, 'CARTORIO DE REGISTRO CIVIL DE ARAPORANGA', 16881, 2312106, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11928, 8851, '1º OFICIO DE REGISTRO CIVIL', 137687, 2312106, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11929, 8852, 'SANTANA DO CARIRI CARTORIO DO SEGUNDO OFICIO', 20842, 2312106, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11930, 8853, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE ANJINHOS', 136184, 2312106, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11931, 1758, 'CARTORIO DO REGISTRO CIVIL DE INHUCU', 18440, 2312304, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11932, 1757, 'CARTORIO 2º OFICIO  DO REGISTRO CIVL', 16055, 2312304, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11933, 8854, 'CARTORIO DO 1º OFICIO DA COMARCA DE SAO BENEDITO (CARTORIO JOAO BEZERRA DE MENEZES)', 17418, 2312304, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11934, 1760, 'SAO GONCALO DO AMARANTE CARTORIO DO 1° OFICIO', 20859, 2312403, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11935, 559, 'SERVICO REGISTRAL CIVIL E NOTAS DE CAJUEIRO', 3939, 2701308, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11936, 560, 'CARTORIO DO REGISTRO CIVIL DE CAMPESTRE', 2741, 2701357, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11937, 561, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 2899, 2701407, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11938, 7625, 'UNICO OFICIO NOTARIAL E REGISTRAL', 4093, 2701407, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11939, 1354, 'CARTORIO DE REGISTRO CIVIL E NOTAS MARIA FERREIRA NETO', 2402, 2701506, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11940, 1355, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 2345, 2701605, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11941, 7626, '2º SERVICO NOTARIAL E PROTESTO DE LETRAS E TITULOS', 1859, 2701704, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11942, 562, 'SERVICO REGISTRAL DAS PESSOAS NATURAIS', 3947, 2701704, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11943, 7627, 'ALAGOAS CARTORIO 1º OFICIO REG. DE IMOV. TITULOS ', 1958, 2701704, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11944, 1356, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 2725, 2701803, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11946, 563, 'SERVICO NOTARIAL E REGISTRAL', 3814, 2702009, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11947, 7628, 'UNICO OFICIO DE COITE DO NOIA', 4069, 2702009, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11948, 93, 'CARTORIO DE REGISTRO CIVIL DE COLONIA LEOPOLDINA', 2253, 2702108, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11949, 7629, 'SERVICO NOTARIAL E REGISTRAL DE COLONIA LEOPOLDINA', 3863, 2702108, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11950, 1358, 'CARTORIO DE REGISTRO CIVIL DE COLONIA LEOPOLDINA', 152397, 2702108, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11951, 564, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 2204, 2702207, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11952, 7630, 'TABELIONATO DO UNICO OFICIO', 4044, 2702207, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11953, 7631, 'CARTORIO 2 OFICIO DE NOTAS - CORURIPE', 2055, 2702306, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11954, 566, 'CARTORIO DO REGISTRO CIVIL', 2600, 2702306, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11955, 7632, '1º SERVICO NOTARIAL E REGISTRAL DE CORURIPE', 1768, 2702306, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11956, 565, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS DE COLONIA PINDORAMA', 3046, 2702306, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11957, 997, 'REGISTRO CIVIL DE PESSOAS NATURAIS E NOTAS DE CORURIPE', 3590, 2702306, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11958, 998, 'CARTORIO DO SERVICO REGISTRAL E NOTARIAL DO 1 DISTRITO', 3053, 2702355, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11959, 7633, 'CARTORIO DO UNICO OFICIO DE CRAIBAS', 3210, 2702355, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11960, 999, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 2881, 2702355, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11961, 569, 'CARTORIO DE REG.CIVIL DE PESSOAS NATURAIS DE DELMIRO GOUVEIA-POVOADO LAGOINHA', 2121, 2702405, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11962, 568, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 3491, 2702405, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11963, 567, 'CARTORIO DO REGISTRO CIVIL - OFICIALIZADO', 2667, 2702405, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11964, 7634, 'SERVICO NOTARIAL E REGISTRAL DO 1º OFICIO DA COMARCA DE DELMIRO GOUVEIA - AL', 3905, 2702405, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11965, 7635, 'CARTORIO DO UNICO OFICIO', 3152, 2702504, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11966, 1000, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 3483, 2702504, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11967, 1359, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 3509, 2702553, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11968, 7636, 'SERVICO NOTARIAL E REGISTRAL DO UNICO OFICIO', 3913, 2702603, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11969, 1001, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 2378, 2702603, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11970, 1360, 'SERVICO DE REGISTRO CIVIL E NOTAS DO 1º DISTRITO DE FEIRA GRANDE/AL', 2923, 2702603, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11971, 1002, 'REGISTRO CIVIL DE PESSOAS NATURAIS E NOTAS DE FELIZ DESERTO', 3608, 2702702, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11972, 7637, 'SERVICO NOTARIAL E REGISTRAL', 3822, 2702801, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11973, 94, 'CARTORIO DO REGISTRO CIVIL', 2626, 2702801, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11974, 7638, 'SERVICO NOTARIAL E REGISTRAL', 3772, 2702900, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11975, 96, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE CANAFISTULA DO CIPRIANO', 2865, 2702900, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11976, 95, 'CARTORIO DO REGISTRO CIVIL DE GIRAU DO PONCIANO', 2758, 2702900, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11977, 7639, 'CARTORIO DO UNICO OFICIO', 3103, 2703007, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11978, 1361, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE IBATEGUARA ', 3012, 2703007, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11979, 7640, 'TABELIONATO E REGISTRAL', 4051, 2703106, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11980, 1362, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 3517, 2703106, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11981, 1364, 'CARTORIO DO REGISTRO CIVIL DE INHAPI', 2774, 2703205, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11982, 1363, 'CARTORIO DO REGISTRO CIVIL DE IGREJA NOVA', 2766, 2703205, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11983, 7641, 'IGREJA NOVA CARTORIO UNICO OFICIO', 3350, 2703205, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11984, 1365, 'SERVENTIA UNICA DE JACARE DOS HOMENS', 3699, 2703403, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11985, 7642, 'CARTORIO DO UNICO OFICIO', 3087, 2703403, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11986, 1366, 'CARTORIO REGISTRO CIVIL JACUIPE', 3327, 2703502, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11987, 7966, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS E TITULOS E DOCUMENTOS E REGISTROS CIVIL DAS PESSOAS JURIDICAS', 7724, 2908101, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11988, 7967, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTOS E CONTRATOS MARITIMOS', 14803, 2908101, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11989, 1316, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9423, 2908200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11990, 7968, 'CONCEICAO DA FEIRA - CARTORIO REGISTRO IMOVEIS HIP.TIT.DOCUMENTOS', 11072, 2908200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11991, 7969, 'CARTORIO DE REGISTRO DE IMOVEIS, HIP. E TIT E DOCS', 131458, 2908309, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11992, 1396, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9431, 2908309, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11993, 7970, 'CONCEICAO DO ALMEIDA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE RIO DA DONA', 143529, 2908309, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11994, 1395, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9514, 2908309, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11995, 7971, 'TABELIONATO C/ FUNCAO DE PROTESTO', 138917, 2908309, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11996, 7972, 'CARTORIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 8102, 2908408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11997, 1397, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 133231, 2908408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11998, 1398, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS DO DISTRITO DE SALGADALIA', 9001, 2908408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (11999, 7973, 'TABELIONATO DE NOTAS C/FUNCOES DE PROTESTOS DE TITULOS', 14233, 2908408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12000, 1399, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 138164, 2908507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12001, 7974, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14308, 2908507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12002, 7975, 'CARTORIO DE REGISTRO DE IMOVEIS, HIPOTECA, TITULOS E DOCUMENTOS', 8003, 2908507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12003, 7976, 'TABELIONATO COM FUNCAO DE PROTESTO', 138222, 2908606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12004, 7977, 'CARTORIO DE REGISTRO DE IMOVEIS, HIP E TIT E DOCS.', 131474, 2908606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12005, 7978, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 131466, 2908606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12006, 7979, '1º. TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 5371, 2908705, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12007, 1318, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 9878, 2908705, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12008, 7980, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS.', 138891, 2908705, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12009, 7981, 'REG. CIVIL C/ FUNC NOTARIAIS - ALEGRE', 134700, 2908705, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12010, 1319, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS', 8854, 2908804, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12011, 1321, 'CORACAO DE MARIA - REGISTRO CIVIL', 11080, 2908903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12012, 1320, 'CORACAO DE MARIA/DISTRITO ITACAVA - REGISTRO CIVIL', 11098, 2908903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12013, 7982, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO DE TITULOS', 14498, 2908903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12014, 7983, 'REG. CIVIL C/ FUNC NOTARIAIS - RETIRO', 134734, 2908903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12015, 7984, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS', 10140, 2908903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12016, 1322, 'REG. CIVIL C/ FUNC NOTARIAIS - CORDEIROS', 134718, 2909000, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12017, 7985, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS', 7567, 2909109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12018, 7986, 'REG. CIVIL C/ FUNC. NOTARIAIS - JABORANDI', 138115, 2909109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12019, 1323, 'MARIA DO SOCORRO ARAUJO DE OLIVEIRA', 11445, 2909109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12020, 7987, 'REG. CIVIL C/ FUNC NOTARIAIS - RANCHINHO', 134742, 2909109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12021, 7988, 'TABELIONATO DE NOTAS', 13755, 2909109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12022, 1324, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS DO DISTRITO DE DESCOBERTO', 12666, 2909109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12023, 1400, 'CARTORIO REGISTRO CIVIL C/ FUNCOES ', 10751, 2909307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12024, 7989, 'TAB NOTAS C/ FUNC PROTESTO', 13565, 2909307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12025, 7990, 'CARTORIO DE REGISTRO GERAL DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO PESSOA JURIDICAS', 8201, 2909307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12026, 1401, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12492, 2909307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12027, 8320, 'REGISTRO DE IMOVEIS 2º OFICIO', 133678, 2918407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12028, 8321, 'REGISTRO CIVIL DAS PESSOAS NATURAIS 2º OFICIO', 137117, 2918407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12029, 8322, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 135269, 2918506, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12030, 8323, 'TABELIONATO COM FUNCAO DE PROTESTO', 141119, 2918506, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12031, 281, 'JUSSARA - REGISTRO CIVIL', 11361, 2918506, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12032, 8324, 'REG. CIVIL C/ FUNC NOTARIAIS - RECIFE', 135285, 2918506, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12033, 8325, 'REG. CIVIL C/ FUNC NOTARIAIS - QUEIMADA NOVA', 135277, 2918506, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12034, 8326, 'REGISTRO CIVIL C/ FUNC NOTARIAIS - ARAGUATAI', 138230, 2918605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12035, 8327, 'REG. CIVIL C/ FUNC NOTARIAIS - JUSSIAPE', 132423, 2918605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12036, 283, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS.', 6924, 2918803, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12037, 8328, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS TITULO E DOCUMENTOS E DAS PESSOAS JURIDICAS', 7765, 2918803, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12038, 8329, 'REG. CIVIL C/ FUNC. NOTARIAIS - SAO MIGUEL DAS MATAS', 137539, 2918803, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12039, 282, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DO CAPAO', 9944, 2918803, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12040, 8330, 'REG. CIVIL C/ FUNC. NOTARIAIS - ENGENHEIRO PONTES', 137208, 2918803, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12041, 8331, 'TABELIONATO COM FUNCOES DE PROTESTO DE LAJE', 13656, 2918803, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12042, 216, 'REGISTRO CIVIL COM FUNCOES NOTARIAS', 11353, 2918902, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12043, 7553, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12351, 2919108, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12044, 217, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 12815, 2919157, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12045, 8332, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTOS', 14530, 2919157, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12046, 34, 'REGISTRO CIVIL DAS PESSOAS NATURAIS ', 131896, 2922003, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12047, 288, 'MUCURI - CARTORIO DE REGISTRO CIVIL - DISTRITO DE IBIRANHEM', 143818, 2922003, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12048, 8333, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS.', 137992, 2922003, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12049, 7557, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS', 8862, 2922052, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12050, 8334, 'REG. CIVIL C/ FUNC NOTARIAIS - VARZEA DO CERCO', 131839, 2922052, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12051, 8335, 'REG. CIVIL C/ FUNC NOTARIAIS - CANUDOS', 131813, 2922052, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12052, 8336, 'REG CIVIL C/ FUNC NOTARIAIS - INDAI', 135533, 2922102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12053, 35, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS', 12013, 2922102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12054, 234, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS', 6775, 2922102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12055, 8337, 'TABELIONATO COM FUNCOES DE PROTESTO', 13649, 2922102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12056, 1402, 'COTEGIPE /DISTRITO DE TAGUA - REGISTRO CIVIL C/ FUNC.NOTARIAIS', 11122, 2909406, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12057, 7991, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 134767, 2909406, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12058, 7992, 'COTEGIPE - TABELIONATO NOTAS C/FUNCAO PROTESTO', 11114, 2909406, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12059, 1403, 'COTEGIPE - CARTORIO REGISTRO CIVIL', 11106, 2909406, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12060, 7993, 'REG. CIVIL C/ FUNC NOTARIAIS - JUPAGUA', 134775, 2909406, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12061, 1404, 'REG. CIVIL C/ FUNC NOTARIAIS - CRAVOLANDIA', 132506, 2909505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12062, 7994, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 134791, 2909703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12063, 7995, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 134783, 2909703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12064, 7996, 'TABELIONATO DE NOTAS', 13771, 2909703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12065, 7997, 'REGISTRO DE IMOVEIS,TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS', 13334, 2909802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12066, 38, 'CARTORIO DO REGISTRO CIVIL C/FUN. NOTARIAIS DO DISTRITO SEDE DO MUNICIPIO DE NOVO HORIZONTE DA COMARCA DE IBITIARA, BAHIA', 135020, 2923035, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12067, 296, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6510, 2923100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12068, 8433, 'REGISTRO CIVIL C/ FUNC NOTARIAIS - BURIL', 131979, 2923100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12069, 8434, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO', 14647, 2923100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12070, 8435, 'CARTORIO DO REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS', 10397, 2923100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12071, 244, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCAO NOTARIAIS', 10884, 2923209, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12072, 8436, 'REGISTRO IMOVEL E HIPOTECA', 13417, 2923209, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12073, 297, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCAO NOTARIAIS', 6759, 2923209, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12074, 8437, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14365, 2923209, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12075, 245, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO SEDE', 12724, 2923209, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12076, 8438, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 137547, 2923407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12077, 246, 'REG. CIVIL C/ FUNC. NOTARIAIS - SEBASTIAO LARANJEIRA ', 137224, 2923407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12078, 8439, 'REGISTRO DE IMOVEIS E HIPOTECAS E TITULOS E DOCUMENTOS DO DISTRITO-SEDE DA COMARCA DE PALMAS DE MONTE ALTO', 154062, 2923407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12079, 8440, 'TABELIONATO C/ FUNCAO DE PROTESTO', 135798, 2923407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12080, 6911, 'PALMAS DE MONTE ALTO - CARTORIO DE REGISTRO CIVIL - DISTRITO DE MANDIROBA', 143867, 2923407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12081, 8441, 'REGISTRO CIVIL C/ FUNC NOTARIAIS - ESPRAIADO', 131987, 2923407, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12082, 247, 'PALMEIRAS/DISTRITO CAETE-ACU - REGISTRO CIVIL C/ FUNCOES NOTARIAIS', 11569, 2923506, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12083, 8442, 'PALMEIRAS - TABELIONATO DE NOTAS C/ FUNCOES DE PROTESTO', 11551, 2923506, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12084, 248, 'PALMEIRAS - REGISTRO CIVIL', 11536, 2923506, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12085, 8443, 'PALMEIRAS - REGISTRO DE IMOVEIS E HIPOTECAS', 11544, 2923506, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12086, 8444, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14324, 2923605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12087, 8445, 'CARTORIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS', 8086, 2923605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12088, 8446, 'PARAMIRIM - CARTORIO DE REGISTRO CIVIL - DISTRITO DE RIO DO PIRES', 143883, 2923605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12089, 8447, 'REGISTRO CIVIL C/ FUNC. NOTARIAIS - IBIAJARA', 131995, 2923605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12090, 249, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS  NATURAIS DO DISTRITO SEDE - PARAMIRIM', 9084, 2923605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12091, 8448, 'PARAMIRIM - CARTORIO DE REGISTRO CIVIL - DISTRITO DE CATURAMA', 143875, 2923605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12092, 39, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS DO DISTRITO DE CANABRAVINHA', 12658, 2923605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12093, 8449, 'REG. CIVIL C/ FUNC. NOTARIAIS - ERICO CARDOSO', 137299, 2923605, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12094, 8450, 'REG. CIVIL C/ FUNC NOTARIAIS - AGUA DO PAULISTA', 132027, 2923704, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12095, 8451, 'TABELIONATO C/ FUNC DE PROTESTO', 132019, 2923704, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12096, 250, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6460, 2923704, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12097, 8452, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 135681, 2923704, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12098, 8453, 'PARIPIRANGA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE ADUSTINA', 144576, 2923803, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12099, 298, 'CARTORIO DO REGISTRO CIVIL', 8581, 2923803, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12100, 8454, 'REGISTRO DE IMOVEIS, HIP E TIT. E DOCS', 137471, 2923803, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12101, 8455, 'REG. CIVIL C/ FUNC. NOTARIAIS - CONCEICAO DE CAMPINAS', 132035, 2923803, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12102, 8456, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTOS', 14563, 2923803, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12103, 40, 'CARTORIO REGISTRO CIVIL DE PAU BRASIL - BA', 10926, 2923902, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12104, 8457, 'REG. IMOVEIS, HIP. E TIT. E DOCS', 132050, 2923902, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12105, 8458, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO DE PAU BRASIL', 14654, 2923902, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12106, 8459, 'REG. CIVIL C/ FUNCOES NOTARIAIS - MALHADA GRANDE', 133736, 2924009, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12107, 299, 'PAULO AFONSO - CARTORIO DE REGISTRO CIVIL - DISTRITO DE SANTA BRIGIDA', 144436, 2924009, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12108, 8460, 'PAULO AFONSO CARTORIO DE IMOVEIS', 11577, 2924009, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12109, 41, 'PAULO AFONSO CARTORIO DO REGISTRO CIVIL', 138016, 2924009, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12110, 8461, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 135475, 2924009, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12111, 8462, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS.', 138412, 2924058, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12112, 8463, 'TABELIONATO DE NOTAS C/FUNCAO DE PROTESTO', 14134, 2924058, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12113, 1761, 'CARTORIO DO REGISTRO CIVIL DE SERROTE ', 18648, 2312403, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12114, 1759, 'CARTORIO DO REGISTRO CIVIL DE PECEM', 18572, 2312403, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12115, 8855, 'CARTORIO DO 3º OFICIO DE SGA-CE', 17905, 2312403, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12116, 6623, 'CARTORIO DO REGISTRO CIVIL DE TAIBA', 18663, 2312403, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12117, 8856, 'CARTORIO DO REG. CIVIL DO DISTRITO DE CROATA', 146555, 2312403, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12118, 8857, 'CARTORIO DO SEGUNDO OFICIO', 19240, 2312403, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12119, 1762, 'CARTORIO DO REGISTRO CIVIL DE SIUPE', 18655, 2312403, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12120, 8858, 'CARTORIO DE REGITRO CIVIL - DISTRITO DE UMARITUBA', 137141, 2312403, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12121, 1763, 'CARTORIO OFICIO DE NOTAS E REGISTROS', 16642, 2312502, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12122, 8859, '1° OFICIO DE REGISTRO CIVIL', 137737, 2312601, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12123, 1764, 'CARTORIO DE REGISTRO CIVIL', 16774, 2312601, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12124, 8860, 'CARTORIO DO 2º OFICIO DE SAOI LUYIS DO CURU', 17772, 2312601, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12125, 8861, 'SEGUNDO OFICIO - REGISTRO DE IMOVEIS DE SENADOR POMPEU-CE', 19257, 2312700, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12126, 1766, 'CARTORIO DO DISTRITO JUDICIARIO DO BONFIM', 18010, 2312700, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12127, 1765, 'CARTORIO JACOB', 19455, 2312700, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12128, 1767, 'CARTORIO DO 1º OFICIO', 19950, 2312700, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12129, 8862, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE ENGº JOSE LOPES', 136234, 2312700, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12130, 1768, 'CARTORIO DE OFICIOS DE NOTAS DE REGISTRO DE SENADOR SA', 16709, 2312809, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12131, 1772, 'CARTORIO DO 4º OFICIO DE SOBRAL', 17947, 2312908, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12132, 8863, 'CARTORIO ARRUDA- 3º OFICIO SOBRAL-CE', 16246, 2312908, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12133, 8864, 'CARTORIO EDITE GUIMARAES', 136259, 2312908, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12134, 8865, '5º OFICIO REGISTRO DE IMOVEIS', 15743, 2312908, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12135, 899, 'CARTORIO 1O. OFICIO', 15917, 2306405, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12136, 8866, 'CART REG CIVIL DO DIST JUDICIARIO DE ASSUNCAO', 147058, 2306405, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12137, 6854, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE BARRENTO ', 18820, 2306405, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12138, 8867, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE CRUXATI', 137760, 2306405, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12139, 900, 'CARTORIO DO DISTRITO DE MARINHEIROS ', 18002, 2306405, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12140, 8868, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE ARAPARI', 135822, 2306405, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12141, 8869, 'ITAPIPOCA CARTORIO DO SEGUNDO OFICIO', 20461, 2306405, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12142, 87, 'CARTORIO OFICIAL DO REGISTRO CIVIL DE PALMATORIA', 19786, 2306504, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12143, 901, 'CARTORIO DO 1º OFICIO E REGISTRO CIVIL', 17533, 2306504, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12144, 8870, 'CARTORIO DE RESISTRO DE IMOVEIS DE ITAPIUNA', 17244, 2306504, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12145, 89, 'CARTORIO OLIVEIRA REGISTRO CIVIL ', 19828, 2306504, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12146, 88, 'CARTORIO DE REGISTRO CIVIL DE ITANS', 16931, 2306504, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12147, 902, 'CATORIO DE OFICIO DE NOTAS E REGISTROS ', 20305, 2306553, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12148, 903, 'CARTORIO DE REGISTRO CIVIL DE ALMOFALA', 135830, 2306553, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12149, 90, 'REGISTRO CIVIL DO DISTRITO DE LAGOA DO MATO, ITATIRA-CE', 20826, 2306603, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12150, 91, '1º OFICIO DE REGISTRO CIVIL ', 136994, 2306603, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12151, 8871, 'CARTORIO PAIVA ARAUJO - 2O. OFICIO', 19851, 2306603, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12152, 8872, 'CARTORIO 2º OFICIO JAGUARETAMA', 16097, 2306702, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12153, 904, 'CARTORIO DO 1º OFICIO JAGUARETAMA (CARTORIO FERNANDES)', 17566, 2306702, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12154, 6863, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE ACIOLI', 23564, 3203130, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12155, 1213, 'IBIRACU CARTORIO DE NOTAS E REGISTRO CIVIL', 24067, 3203130, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12156, 1215, 'REGISTRO CIVIL E TABELIONATO', 24323, 3203163, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12157, 1214, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DO DISTRITO DE JOATUBA DA COMARCA DE LARANJA DA TERRA ES', 22327, 3203163, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12158, 9106, 'LARANJA DA TERRA CARTORIO REG. GERAL IMOVEIS, DOCUMENTOS, PESSOAS JURIDICAS E PROTESTO 1º OFICIO', 24117, 3203163, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12159, 1216, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE SOBREIRO', 23614, 3203163, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12160, 6864, 'CARTORIO DE BEBEDOURO, MUNICIPIO E COMARCA DE LINHARES-ES', 21808, 3203205, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12161, 9107, 'CARTORIO DO 2º OFICIO - TABELIONATO DA SEDE', 24125, 3203205, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12162, 9108, '1º TABELIONATO DE PROTESTO. OFICIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 21394, 3203205, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12163, 1219, 'SERVICO DISTRITAL DE REGENCIA', 24422, 3203205, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12164, 1217, 'LINHARES CARTORIO DO REG CIVIL E TABELIONATO DE NOTAS', 24133, 3203205, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12165, 9109, 'CARTORIO DO 3º OFICIO', 23184, 3203205, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12166, 1063, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DA SEDE', 23788, 3203205, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12167, 1218, 'REGISTRO CIVIL E TABELIONATO DESENGANO', 24406, 3203205, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12168, 1221, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DA SEDE DE MANTENOPOLIS', 22517, 3203304, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12169, 1220, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE SAO GERALDO', 22608, 3203304, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12170, 9110, 'CARTORIO DO 1° OFICIO DE MANTENOPOLIS-ES', 22830, 3203304, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12171, 1222, 'CARTORIO TONINI', 23895, 3203304, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12172, 1223, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO SAO JOSE', 24331, 3203304, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12173, 1224, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 22053, 3203320, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12174, 9111, '1º SERVICO REGISTRAL DE IMOVEIS E ANEXOS DE MARATAIZES - ES', 21386, 3203320, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12175, 6625, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO - CARTORIO GAMA', 22335, 3203346, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12176, 7885, 'CARTORIO DO TABELIONATO DE NOTAS COM FUNCAO DE PROTESTOS', 10579, 2901601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12177, 7886, 'ANTAS - RESGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS DAS PESSOAS JURIDICAS', 5504, 2901601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12178, 929, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS ', 6205, 2901809, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12179, 438, 'REGISTRO CIVIL COM FUNCOES NOTORIAIS DO DISTRITO DE ITAMIRA,COMARCA DE APORA', 12120, 2901908, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12180, 437, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE APORA BA', 12674, 2901908, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12181, 7887, 'CARTORIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS', 8094, 2901908, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12182, 7888, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO', 14621, 2901908, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12183, 7889, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS', 6064, 2901957, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12184, 519, 'ALAGOINHAS - CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS - DISTRITO DE ARACAS', 144071, 2902054, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12185, 7537, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS DO DISTRITO DE ARACATU - BA', 8961, 2902005, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12186, 7890, 'TABELIONATO DE NOTAS', 13722, 2902104, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12187, 520, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE ARACI-BA', 12682, 2902104, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12188, 7891, 'CARTORIO DE REGISTRO DE IMOVEIS, HIPOTECAS E TITULOS E DOCUMENTOS', 8037, 2902104, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12189, 521, 'REG. CIVIL C/ FUNC. NOTARIAIS - MAROGOGIPINHO', 135517, 2902302, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12190, 439, 'REG. CIVIL. C/ FUNC. NOTARIAIS - ARATUIPE', 137562, 2902302, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12191, 440, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS - LAGE DO BANCO', 6155, 2902401, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12192, 7892, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ POCO CENTRAL', 139006, 2902401, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12273, 8801, '5º OFICIO DE REGISTRO DE IMOVEIS', 15735, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12193, 7893, 'REGISTRO DE IMOVEIS, HIPOTECAS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 13276, 2902401, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12194, 441, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6437, 2902401, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12195, 7894, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO', 13821, 2902401, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12196, 522, 'BAIANOPOLIS - REGISTRO CIVIL', 5520, 2902500, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12197, 442, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS DO DISTRITO DE VARZEAS', 6247, 2902500, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12198, 7895, 'CARTORIO 1º OFICIO DE NOTAS E PROTESTO', 5611, 2902500, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12199, 7896, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 138248, 2902500, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12200, 7897, 'TABELIONATO DE NOTAS', 13698, 2902609, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12201, 930, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 10991, 2902609, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12202, 7898, 'CARTORIO DO REGISTRO DE IMOVEIS', 10033, 2902609, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12203, 523, 'REGISTRO CIVIL C/FUNC NOTARIAIS', 11833, 2902708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12204, 443, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6650, 2902708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12205, 7899, 'REGISTRO CIVIL COM FUNCOES NOTARIAS - IGARITE', 139592, 2902708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12206, 7542, 'REGISTRO CIVIL C/FUNCOES NOTARIAIS', 11841, 2902708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12207, 7900, 'REGISTRO CIVIL COM FUNCOES NOTARIAS - BURITAMA', 139584, 2902708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12208, 444, 'REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS DE IBIRABA-BARRA/BA', 12641, 2902708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12209, 7901, 'TAB.NOTASC/FUNC.PROTESTO', 13599, 2902708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12210, 7902, 'CARTORIO REG IMOV E HIP TIT E DOC', 10694, 2902708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12211, 524, 'BARRA DA ESTIVA - CARTORIO DE REGISTRO CIVIL', 5538, 2902807, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12212, 7903, 'CARTORIO DO TABELIONTO DE NOTAS', 10645, 2902807, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12213, 7904, 'BARRA DA ESTIVA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE CASCAVEL', 143438, 2902807, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12214, 7905, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS', 10181, 2902807, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12215, 7906, 'REG. CIVIL C/ FUNCOES NOTARIAIS - IBICOARA', 134239, 2902807, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12216, 445, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS', 8821, 2902807, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12217, 7907, 'CARTORIO DE NOTAS E PROTESTO DE TITULOS DE BARRA DO CHOCA-BAHIA', 5777, 2902906, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12218, 7908, 'CARTORIO DE REGISTRO DE IMOVEIS, HIPOTECAS  E TITULOS E DOCUMENTOS', 7963, 2902906, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12219, 6471, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE BARRA DO CHOCA', 9746, 2902906, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12220, 7909, 'REG. CIVIL C/ FUNCOES NOTARIAIS - CAATIBA', 134247, 2902906, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12221, 7910, 'BARRA DO MENDES - CARTORIO DE REGISTRO CIVIL - SEDE', 143446, 2903003, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12222, 8346, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E REGISTRO DE PESSOAS JURIDICAS', 10306, 2922508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12223, 8347, 'REGISTRO DE IMOVEIS E HIPOTECAS COM FUNCAO DE TITULOS E DOCUMENTOS', 13052, 2922607, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12224, 240, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12427, 2922607, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12225, 8348, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 131912, 2922656, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12226, 292, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6502, 2922656, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12227, 8349, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14415, 2922656, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12228, 8350, 'CARTORIO DE REGISTRO DE IMOVEIS', 7369, 2922706, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12229, 8351, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 137984, 2922706, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12230, 8352, 'REG. CIVIL C/ FUNCAO NOTARIAIS - ITAJAI', 131938, 2922706, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12231, 8353, 'TABELIONATO C/ FUNCAO DE PROTESTO', 131920, 2922706, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12232, 8354, 'NOVA FATIMA - REGISTRO DE IMOVEIS', 11486, 2922730, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12233, 8355, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14340, 2922730, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12234, 8356, 'TABELIONATO DE PROTESTO DE TITULOS E DOCUMENTOS DE DIVIDA 2º OFICIO', 15230, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12235, 8357, 'QUINTO OFICIO DE REGISTRO DE IMOVEIS E HIPOTECAS DE SALVADOR', 11627, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12236, 261, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE MADRE DE DEUS', 9753, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12237, 8358, 'TABELIONATO DO 5º OFICIO DE NOTAS', 15339, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12238, 8359, 'CARTORIO DO 2º OFICIO DE REGISTRO DE IMOVEIS DA COMARCA DO SALVADOR-BA', 8391, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12239, 613, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DO SUBDISTRITO DE SANTANA', 7179, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12240, 8360, 'CARTORIO DO 2º OFICIO DE NOTAS', 8383, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12241, 8361, 'CARTORIO DO 12º OFICIO DE NOTAS', 8359, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12242, 623, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO SUBDISTRITO DE SAO CRISTOVAO', 12732, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12243, 8362, 'CARTORIO DO 6 OFICIO DE NOTAS', 8425, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12244, 8363, 'TABELIONATO DO 1º OFICIO DE NOTAS', 15271, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12245, 8364, 'TABELIONATO DO 14º OFICIO DE NOTAS', 15255, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12246, 612, 'CARTORIO DO REGISTRO CIVIL PESSOAS NATURAIS DO SUBDISTRITO DE PLATAFORMA', 9993, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12247, 619, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS- SUBDISTRITO DA VITORIA', 7195, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12248, 8365, 'TABELIONATO DE PROTESTO DE TITULOS E DOCUMENTOS DE DIVIDAS 3º OFICIO', 15248, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12249, 8366, 'CARTORIO DO 1º OFICIO DE REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 8375, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12250, 8367, 'TABELIONATO DE NOTAS - 9º OFICIO', 13995, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12251, 615, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS SUBDISTRITO DA PENHA', 6916, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12252, 626, 'CARTORIO DE REGISTRO CIVIL DO SUBD. VALERIA', 7245, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12253, 8368, 'CARTORIO DE NOTAS DO 10º OFICIO DA CAPITAL', 5744, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12254, 8369, 'TERCEIRO OFICIO DE REGISTRO DE IMOVEIS', 15404, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12255, 624, 'SALVADOR - CARTORIO DE REGISTRO CIVIL - SUBDISTRITO DE BROTAS', 143362, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12256, 8370, 'PRIMEIRO OFICIO DE REGISTRO DE IMOVEIS E HIPOTECAS DE SALVADOR', 11601, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12257, 6914, 'CARTORIO REGISTRO CIVIL DE ITAPUA', 10660, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12258, 620, 'CARTORIO DE REGISTRO CIVIL DO SUBDISTRITO DA CONCEICAO DA PRAIA', 7252, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12259, 622, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DO SUBDISTRITO DOS MARES', 7187, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12260, 8371, 'CARTORIO DO 2º OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS', 8417, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12261, 8372, 'TABELIONATO DO 4º OFICIO DE NOTAS', 15321, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12262, 8373, '6º OFICIO DE REGISTRO DE IMOVEIS E HIPOTECAS DE SALVADOR', 5454, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12263, 8374, 'QUARTO OFICIO DE REGISTRO DE IMOVEIS E HIPOTECAS DE SALVADOR', 11619, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12264, 614, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO SUBDISTRITO DE SANTO ANTONIO', 6908, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12265, 611, 'CARTORIO DO RCPN DO SUBDISTRITO DO PILAR', 8441, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12266, 621, 'REGISTRO CIVIL SUBDISTRITO DE PERIPERI', 12906, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12267, 8375, '11º OFICIO DE NOTAS', 5306, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12268, 8797, '2º OFICIO DE REGISTRO DE IMOVEIS DE FORTALEZA', 15669, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12269, 8798, 'CARTORIO JOAO MACHADO', 19463, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12270, 8799, '6º TABELIONATO DE NOTAS E 3º REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DE PESSOAS JURIDICAS DE FORTALEZA', 15768, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12271, 8800, 'CARTORIO DO REGISTRO DE IMOVEIS DA 4A ZONA', 19174, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12272, 844, 'CARTORIO DO REGISTRO CIVIL DE MESSEJANA', 18507, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12274, 839, 'CARTORIO REGISTRO CIVIL DA 4ª ZONA', 19992, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12275, 8802, 'CAT DO 3º OF DE DIST DE ESC PUB E DE PROT DE TIT JUD DA COMARCA FORTALEZA', 20289, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12276, 8803, '3º OFICIO DE REGISTRO DE IMOVEIS DE FORTALEZA', 15719, 2304400, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12277, 850, 'CARTORIO MACIEL', 19570, 2304459, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12278, 8804, 'CARTORIO DO 2º OFICIO FORTIM CE', 17780, 2304459, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12279, 851, 'OFICIO DE NOTAS E DE REGISTROS', 20560, 2304509, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12280, 852, 'CARTORIO DO 1º OFICIO DE REGISTRO CIVIL DA CORMARCA VINCULADA EM GENERAL SAMPAIO', 17491, 2304608, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12281, 853, 'CARTORIO RIBEIRO DE NOTAS E REGISTROS E DE PUBLICOS', 20065, 2304657, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12282, 856, 'CARTORIO DO REGISTRO CIVIL DE TIMONHA GRANJA-CE', 18689, 2304707, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12283, 859, 'CARTORIO DO REGISTRO CIVIL DE SAMBAIBA', 18622, 2304707, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12284, 6925, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE PESSOA ANTA DA COMARCA DE GRANJA/CE', 17111, 2304707, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12285, 857, 'CARTORIO DO REGISTRO CIVIL DE ADRIANOPOLIS', 18325, 2304707, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12286, 854, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE PARAZINHO', 17095, 2304707, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12287, 8805, 'CARTORIO 2° OFICIO- REGISTRO DE IMOVEIS', 16014, 2304707, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12288, 858, 'CARTORIO LEDA ANGELIM 1/ OFICIO-REGISTRO CIVIL', 19505, 2304707, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12289, 855, 'CARTORIO DO REGISTRO CIVIL DE IBUGUACU', 18424, 2304707, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12290, 860, 'CARTORIO DE NOTAS E REGISTROS', 16550, 2304806, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12291, 861, 'CARTORIO DE OFICIO DE NOTAS E DE REGISTROS - CONR', 16667, 2304905, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12292, 862, 'CARTORIO DE 1º OFICIO DE NOTAS E REGISTROS PUBLICOS CARLOS PEREIRA', 16477, 2304954, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12293, 8806, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE ITACIMA', 137893, 2304954, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12294, 8807, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE AGUA VERDE', 137711, 2304954, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12295, 864, 'CARTORIO DO REGISTRO CIVIL DISTRITO SUSSUANHA', 18739, 2305001, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12296, 863, 'CARTORIO FERNANDES 1º OFICIO', 19323, 2305001, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12297, 8808, 'CARTORIO DO REGISTRO CIVIL DISTRITO MORRINHOS NOVO', 147140, 2305001, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12298, 8809, 'GUARACIABA DO NORTE CARTORIO 2º OFICIO', 20438, 2305001, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12299, 865, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE ESPINHOS', 17079, 2305001, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12300, 8810, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE PERNAMBUQUINHO', 137216, 2305100, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12301, 866, 'CARTORIO DE NOTAS E REGISTROS DE GUARAMIRANGA', 16576, 2305100, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12302, 869, 'CARTORIO ROSA MAGALHAES', 20081, 2305209, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12303, 868, 'CARTORIO BEZERRA', 16279, 2305209, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12304, 867, 'CARTORIO MOURAO ROCHA', 19703, 2305209, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12305, 8811, '2° OFICIO DE REGISTRO DE IMOVEIS ', 15610, 2305233, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12306, 8812, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE QUEIMADAS', 137729, 2305233, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12307, 870, 'CARTORIO MAIA', 19620, 2305233, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12308, 871, 'CARTORIO BRASILINO - 1º OFICIO', 16345, 2305266, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12309, 872, 'CARTORIO DO REGISTRO CIVIL DISTRITO DE PIRANJI ', 18713, 2305266, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12310, 8813, 'CARTORIO DE REGISTRO DE IMOVEIS 2º OFICIO DE IBARETAMA', 17236, 2305266, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12311, 8814, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE SANTO ANTONIO DA PINDOBA', 137679, 2305308, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12312, 873, 'CARTORIO DO PRIMEIRO OFICIO', 18127, 2305308, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12313, 8815, 'CARTORIO DO SEGUNDO OFICIO', 19224, 2305308, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12314, 874, 'CARTORIO DIAS RABELO', 17285, 2305332, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12315, 875, '1 OFICIO DE NOTAS, REGISTROS DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS NATURAIS ', 15495, 2305357, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12316, 8816, 'CARTORIO DO 2º OFICIO REGISTRO DE IMOVEIS', 17798, 2305357, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12317, 876, 'CAERTORIO DE REGISTRO CIVIL DO DISTRITO DE IBICUITABA', 15818, 2305357, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12318, 8817, 'CARTORIO DO REGISTRO CIVIL DISTRITO ICOZINHO', 147223, 2305407, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12319, 9112, 'CARTORIO DE PROTESTO DE TITULOS E DOCUMENTOS', 152355, 3203346, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12320, 1225, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO ARAGUAIA - CARTORIO GALVEAS', 22376, 3203346, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12321, 9113, 'CARTORIO DO 1° OFICIO DE MARECHAL FLORIANO- ES', 21790, 3203346, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12322, 9114, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 152363, 3203346, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12323, 9115, 'MARILANDIA CARTORIO DO 1° OFICIO', 24141, 3203353, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12324, 1227, 'MARILANDIA CARTORIO DO REGISTRO CIVIL E NOTAS', 24158, 3203353, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12325, 1226, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE SAPUCAIA', 22624, 3203353, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12326, 6866, 'CARTORIO DO REGISTRO CIVIL E NOTAS DO DISTRITO DE SAO PEDRO DO ITABAPOANA', 23408, 3203403, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12327, 1230, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE DONA AMERICA', 22467, 3203403, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12328, 1231, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE SAO JOSE DAS TORRES', 22616, 3203403, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12329, 1229, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DO DISTRITO DE CONCEICAO DO MUQUI ', 22558, 3203403, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12330, 1064, 'REGISTRO CIVIL E TABELIONATO DA SEDE DE MIMOSO DO SUL', 24356, 3203403, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12331, 1228, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE SANTO ANTONIO DO MUQUI ', 22590, 3203403, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12332, 9116, 'CARTORIO REGISTRO IMOVEIS, TABELIONATO, TITULOS E DOCUMENTOS, PESSOAS JURIDICAS E PROTESTOS - 1º OFICIO', 23853, 3203403, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12333, 6865, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE PONTE DO ITABAPOANA', 22566, 3203403, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12334, 9117, 'CARTORIO DO 1º OFICIO', 22913, 3203502, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12335, 1232, 'REGISTRO CIVIL E TABELIONATO', 24273, 3203502, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12336, 1065, 'REGISTRO CIVIL E TABELIONATO DE NOTAS', 23606, 3203502, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12337, 1233, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE ITABAIANA-ES', 23572, 3203601, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12338, 9118, 'CARTORIO DO 1° OFICIO', 22822, 3203601, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12339, 1066, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE MUCURICI ES', 23382, 3203601, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12340, 9119, 'CARTORIO DO 1º OFICIO', 22855, 3203700, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12341, 1067, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS DE ITAICI', 23598, 3203700, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12342, 1234, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 24232, 3203700, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12343, 1069, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO ', 23416, 3203700, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12344, 1235, 'REGISTRO CIVIL E TABELIONATO DE PIACU', 24398, 3203700, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12345, 1068, 'REGISTRO CIVIL E TABELIONATO', 24281, 3203700, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12346, 9120, 'MUQUI CARTORIO REG. GERAL IMOV. TIT. DOC. E PROT. LET. 1º OFICIO', 24166, 3203809, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12347, 1237, 'CARTORIO DE REGISTRO CIVIL DA SEDE', 149252, 3203809, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12348, 9121, 'TABELIONATO DA SEDE DA COMARCA DE MUQUI', 22269, 3203809, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12349, 1236, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE CAMARA', 22442, 3203809, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12350, 9122, 'CARTORIO DE PROTESTO DE TITULOS E DOCUMENTOS DE DIVIDA DE NOVA VENECIA', 152959, 3203908, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12351, 6626, 'REGISTRO CIVIL E TABELIONATO DE NOTAS - GUARAREMA', 24315, 3203908, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12352, 9123, 'CARTORIO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS ', 150177, 3203908, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12353, 9124, 'NOVA VENECIA CARTORIO DO TERCEIRO OFICIO', 24182, 3203908, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12354, 9125, 'CARTORIO ANTUNES DO 1º OFICIO', 24174, 3203908, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12355, 1238, 'REGISTRO CIVIL E TABELIONATO DE NOTAS DA SEDE DE NOVA VENECIA ', 23861, 3203908, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12356, 9126, 'CARTORIO DO REGISTRO CIVIL DE SANTO ANTONIO DO QUINZE', 23333, 3203908, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12357, 1070, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DA SEDE', 23457, 3204005, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12358, 9127, 'CARTORIO DO 1º OFICIO DE PANCAS', 23077, 3204005, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12359, 1240, 'PANCAS CARTORIO DO REGISTRO CIVIL E TABELIONATO DO DISTRITO DE VILA VERDE - PANCAS - ES', 24216, 3204005, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12360, 1239, 'PANCAS CARTORIO DO REGISTRO CIVIL E TABELIONATO', 24208, 3204005, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12361, 9128, 'CARTORIO DE PROTESTO DE TITULOS E DOCUMENTOS', 153429, 3204054, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12362, 9129, 'CARTORIO DO 1º OFICIO', 22897, 3204054, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12363, 1071, 'CARTORIO ', 21584, 3204054, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12364, 9130, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS DA COMARCA DE PEDRO CANARIO', 152942, 3204054, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12365, 9131, 'CARTORIO DO 2° OFICIO DE NOTAS', 23127, 3204104, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12366, 7911, 'OFICIAL DE CARTORIO DE REGISTROS DE IMOVEIS E HIPOTECAS', 11494, 2903003, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12367, 1036, 'CARTORIO ANGELO MUNIZ', 20297, 2310605, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12368, 7912, 'REG. CIVIL C/ FUNCOES NOTARIAIS - MIRORO', 134296, 2903003, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12369, 525, 'BARRA DO MENDES/DISTRITO DE MINAS DO ESPIRITO SANTO - REGISTRO CIVIL C/ FUNC.NOTARIAIS', 5546, 2903003, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12370, 7913, 'BARRA DO MENDES - CARTORIO DE REGISTRO CIVIL - DISTRITO DE ANTARI', 143453, 2903003, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12371, 7914, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14852, 2903003, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12372, 6699, 'REG. CIVIL C/ FUNC NOTARIAIS - BARRA DO ROCHA', 133413, 2903102, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12373, 7915, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS DO 2 OFICIO DA COMARCA DE BARREIRAS - BA ', 7658, 2903201, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12374, 446, 'REGISTRO CIVIL', 11734, 2903201, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12375, 7916, 'TABELIONATO COM FUNCAO DE PROTESTO', 139394, 2903201, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12376, 7917, '´CARTORIO DO REGISTROCIVIL DO 1.º OFICIO  DE BARREIRAS-BAHIA', 15479, 2903201, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12377, 7918, 'CARTORIO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 8318, 2903201, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12378, 7919, 'CARTORIO DO 1.º OFICIO DE NOTAS DE BARREIRAS-BAHIA', 8342, 2903201, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12379, 7920, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS DO 1 OFICIO DA COMARDA DE BARREIRAS - BA', 7625, 2903201, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12380, 7921, 'CARTORIO 2° OFICIO DE NOTAS', 5629, 2903201, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12381, 527, 'REG. CIVIL C/ FUNC NOTARIAIS - LAGO DO BOI', 134460, 2903235, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12382, 526, 'REG. CIVIL C/ FUNC NOTARIAIS - BARRO ALTO', 134452, 2903235, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12383, 931, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS ', 9274, 2903300, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12384, 7922, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14456, 2903300, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12385, 7923, 'CARTORIO DE REGISTRO DE IMOVEIS / TITULOS E DOCUMENTOS', 7468, 2903300, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12386, 529, 'TABELIONATO DE NOTAS', 13912, 2903409, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12387, 7924, 'REGISTRO DE IMOVEIS ', 12930, 2903409, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12388, 7925, 'REG. CIVIL C/ FUNC. NOTARIAIS - MAGIQUICABA', 138149, 2903409, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12389, 528, 'CARTORIO DE REGISTRO CIVIL DAS PESSAOS NATURAIS', 6312, 2903409, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12390, 7926, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS', 11916, 2903409, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12391, 7927, 'TABELIONATO DE NOTAS', 13730, 2903508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12392, 530, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9134, 2903508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12393, 7928, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS', 7583, 2903508, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12394, 531, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6551, 2903706, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12395, 7929, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 15073, 2903706, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12396, 7930, 'REG. CIVIL C/ FUNCOES NOTARIAIS - MIRANTE', 134312, 2903706, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12397, 7931, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 7807, 2903706, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12398, 7545, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 138123, 2903805, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12399, 7932, 'REG. CIVIL C/ FUNC NOTARIAIS - BREJO NOVO', 134353, 2903805, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12400, 7933, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 134346, 2903805, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12401, 7934, 'TABELIONATO COM FUNCAO DE PROTESTO', 138370, 2903805, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12402, 7935, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 132993, 2903904, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12403, 7936, 'REG. CIVIL C/ FUNC NOTARIAIS - GAMELEIRA DA LAPA', 133025, 2903904, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12404, 7937, 'TABELIONATO DE NOTAS', 13714, 2903904, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12405, 7938, 'REG. CIVIL C/ FUNC NOTARIAIS - FORMOSO', 133017, 2903904, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12406, 532, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE BOM JESUS DA LAPA', 12690, 2903904, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12407, 932, 'REG. CIVIL C/ FUNC NOTARIAIS - SITIO DO MATO', 133041, 2903904, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12408, 7939, 'REG. CIVIL C/ FUNC NOTARIAIS - FAVELANCIA', 133009, 2903904, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12409, 7940, 'REG. CIVIL C/ FUNC NOTARIAIS - SERRA DO RAMALHO', 133033, 2903904, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12410, 447, 'REG. CIVIL C/ FUNC NOTARIAIS - NOVA COLINA', 132076, 2904001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12411, 448, 'REG. CIVIL C/ FUNCAO NOTARIAIS - BONINAL', 132084, 2904001, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12412, 7941, 'REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS', 13144, 2904100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12413, 450, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAS', 6270, 2904100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12414, 449, 'REGISTRO CIVIL  DE PESSOAS NATURAIS DE BOQUIRA', 11742, 2904100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12415, 7942, 'CARTORIO DO TABELI0NATO DE NOTAS COM FUNCAO DE PROTESTO', 10462, 2904100, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12416, 7943, 'CARTORIO DO REG DE IMOVEIS E HIPOTECAS DE TITULOS E DOCUMENTOS DAS PESSOAS NATURAIS', 8474, 2904209, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12417, 7944, 'CARTORIO DO TABELIONATO DE NOTAS', 10470, 2904209, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12418, 8377, 'SALVADOR - CARTORIO DE REGISTRO CIVIL - SUBDISTRITO DE AMARALINA', 143347, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12419, 8378, 'SETIMO OFICIO DE REGISTRO DE IMOVEIS E HIPOTECAS DE SALVADOR', 13540, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12420, 616, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO SUBDISTRITO DE SAO PEDRO', 9811, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12421, 8379, '4º TABELIONATO DE PROTESTO DE TITULOS E DOCUMENTOS ', 5447, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12422, 618, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DO SUBDISTRITO DE PARIPE-SALVADOR/BA', 7161, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12423, 8380, '8º OFICIO DE NOTAS', 5462, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12424, 617, 'REGISTRO CIVIL DAS PESSOAS NATURAIS/PIRAJA', 12757, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12425, 8381, 'TABELIONATO DE PROTESTO DE TITULOS 1º OFICIO', 15222, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12426, 8382, 'TABELIONATO DO 7º OFICIO DE NOTAS', 15347, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12427, 628, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE SALVADOR-BA- DST- SE', 9738, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12428, 625, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DE NAZARE', 5694, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12429, 262, 'CARTORIO DO REGISTRO CIVIL DO PACO', 9951, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12430, 629, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 12831, 2927507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12431, 8383, 'TABELIONATO DE NOTAS C/ FUN. DE PROTESTO', 14027, 2927507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12432, 8384, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS CUMULADO COM FUNCOES DE TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS', 7617, 2927507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12433, 8385, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 15065, 2927705, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12434, 8386, 'CARTORIO DE REGISTRO DE IMOVEIS, REGISTRO DE TITULOS E DOCUMENTOS DAS PESSOAS JURIDICAS', 8060, 2927705, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12435, 630, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6536, 2927705, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12436, 8387, 'CARTORIO TABELIONATO DE NOTAS C/ FUNCAO DE PROTESTO', 11049, 2927903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12437, 8388, 'CARTORIO DO REGISTRO DE IMOVEIS HIPOTECAS E DE TITULOS E DOCUMENTOS', 10330, 2927903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12438, 6915, 'CARTORIO DO REGISTRO CIVI DAS PESSOAS NATURAIS', 8524, 2927903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12439, 8389, 'SANTA LUZIA - CARTORIO REGISTRO DE IMOVEIS E HIPOTECAS TITULOS E DOCUMENTOS', 13490, 2928059, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12440, 8390, 'CARTORIO TABELIONATO DE NOTAS C/ FUNCOES DE PROTESTO DE TITULOS E DOCUMENTOS', 11056, 2928059, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12441, 631, 'REGISTRO CIVIL DAS  PESSOAS NATURAIS ', 12393, 2928059, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12442, 8391, 'REG. CIVIL C/ FUNCOES NOTARIAIS - SAO FELIX DO CORIBE', 133876, 2928109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12443, 8392, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS E TITULOS E DOUCMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS DA COMARCA DE SANTA MARIA DA VITORIA-BAHIA', 7732, 2928109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12444, 632, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS COM FUNCOES NOTARIAIS DE ACUDINA', 7070, 2928109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12445, 8393, 'CARTORIO DE TABELIONTO DE NOTAS E PROTESTO', 8284, 2928109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12446, 634, 'ANTONIO ROBERTO ABREU DE MATOS', 5512, 2928109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12447, 633, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9449, 2928109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12448, 8394, 'CARTORIO DO REGISTRO DE TITULOS E DOCUMENTOS', 10447, 2928406, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12449, 636, 'SANTA RITA DE CASSIA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE MANSIDAO', 143925, 2928406, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12450, 8395, 'CARTORIO DO REGISTRO DE IMOVEIS', 7385, 2928406, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12451, 635, 'CARTORIO DO REG CIVIL COM FUNCOES NOTORIAIS', 8466, 2928406, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12452, 8396, 'CARTORIO DO REGISTRO CIVIL', 8573, 2928406, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12453, 8397, 'TABELIONATO DE NOTAS COM FUNC~ES DE PROTESTO', 14845, 2928406, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12454, 8398, 'SANTA TERESINHA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE MONTE CRUZEIRO', 143941, 2928505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12455, 8399, 'REGISTRO DE TITULOS E DOCUMENTOS', 133793, 2926301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12456, 8400, 'TABELIONATO COM FUNCAO DE PROTESTO', 138297, 2926400, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12457, 8401, 'CARTORIO DO REGISTRO DE IMOVEIS, HIPOTECAS, TITULOS, DOCUMENTOS E PESSOAS JURIDICAS', 10389, 2926400, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12458, 8402, 'REG. CIVIL C/ FUNC NOTARIAIS - BOTUQUARA', 132407, 2926400, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12459, 8403, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 132399, 2926400, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12460, 61, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS ', 8847, 2926400, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12461, 62, 'REG. CIVIL DAS PESSOAS NATURAIS', 136531, 2926608, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12462, 8376, '3º OFICIO DE NOTAS', 5439, 2927408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12463, 879, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE PEDRINHAS', 19000, 2305407, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12464, 878, 'CARTORIO DE REG. CIVIL DO DISTRITO DE CRUZEIRINHO', 16766, 2305407, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12465, 8818, 'CARTORIO DO 2º OFICIO - ICO/CE', 17673, 2305407, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12466, 877, '1A SERVENTIA DE NOTAS E REGISTROS', 18226, 2305407, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12467, 6926, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO LIMA CAMPOS ', 17186, 2305407, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12468, 881, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE SUASSURANA', 19075, 2305506, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12469, 880, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE BARREIRA', 18812, 2305506, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12470, 7508, 'CARTORIO BEZERRA', 16287, 2305506, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12471, 882, 'CART DO REG CIVIL DISTRITO QUIXOA', 15859, 2305506, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12472, 721, 'CARTORIO MANOL JOSE DO 2º OFICIO', 19638, 2300309, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12473, 8819, 'CARTORIO DO 3º OFICIO PEREIRA CABRAL COMARCA DE ACOPIARA', 17921, 2300309, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12474, 8820, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE SANTA FELICIA', 136606, 2300309, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12475, 720, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE SANTO ANTONIO', 17145, 2300309, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12476, 743, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE EBRON', 17061, 2300309, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12477, 744, 'CARTORIO DE REGISTRO CIVIL DO QUINCOE', 17202, 2300309, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12478, 718, 'CARTORIO DO 1º OFICIO DE ACOPIARA', 17376, 2300309, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12479, 719, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE TRUSSU', 17160, 2300309, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12480, 8821, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE ISIDORO', 137802, 2300309, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12481, 8822, 'CARTORIO DO 2º OFICIO DE AIUABA', 17731, 2300408, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12482, 745, 'CARTORIO DO 1º OFICIO', 17343, 2300408, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12483, 722, 'CARTORIO DE OFICIO, NOTAS E REGISTROS', 16691, 2300507, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12484, 8823, 'CARTORIO OFICIO  DE NOTAS E REGISTROS', 135459, 2300606, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12485, 6698, 'CARTORIO DO REG. CIVIL DAS PESSOAS NATURAIS', 18168, 2300705, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12486, 746, 'CARTORIO DO REG. CIVIL DAS PESSOAS NATURAIS DO DIST. CASTANHAO', 18176, 2300705, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12487, 8824, 'CARTORIO 2º OFICIO - REG. IMOVEIS', 16071, 2300705, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12488, 747, 'CARTORIO DO DISTRITO DE ICARAI ', 17996, 2300754, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12489, 749, 'OFICIO DE NOTAS E REGISTROS DE AMONTADA', 15925, 2300754, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12490, 748, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE ARACATIARA', 18770, 2300754, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12491, 8825, 'CARTORIO DO SEGUNDO OFICIO', 19216, 2300804, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12492, 6920, 'CARTORIO DO 1º OFICIO', 17335, 2300804, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12493, 750, 'CARTORIO DO OFICIO DE NOTAS E REGISTRO DE APUIARES', 18028, 2300903, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12494, 751, 'CARTORIO DE REGISTRO CIVIL DE JUSTINIANO DE SERPA', 16956, 2301000, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12495, 8826, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE PATACAS', 154161, 2301000, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12496, 8827, 'CARTORIO DO 3º OFICIO DE REGISTRO DE IMOVEIS DE AQUIRAZ - CEARA ', 17889, 2301000, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12497, 8828, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE TAPERA ', 154120, 2301000, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12498, 753, 'AQUIRAZ / CARTORIO DO 1º OFICIO', 15784, 2301000, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12499, 752, 'CARTORIO LOURENCO', 19554, 2301000, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12500, 8829, 'CARTORIO FLORENCIO 2º OFICIO', 19356, 2301000, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12501, 755, 'ARACATI CARTORIO DO REGISTRO CIVIL 1º OFICIO', 15792, 2301109, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12502, 754, '002016', 15487, 2301109, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12503, 8830, 'CARTORIO ALEXANDRE GONDIM (2º OFICIO)', 16147, 2301109, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12504, 8831, 'CARTORIO DO 3º OFICIO DE REGISTRO IMOBILIARIO DE ARACATI', 17897, 2301109, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12505, 756, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE MATA FRESCA', 17087, 2301109, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12506, 8832, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE SERRAGEM', 137828, 2301208, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12507, 757, 'CARTORIO DO REGISTRO CIVIL DE IDEAL', 18432, 2301208, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12508, 8833, 'CARTORIO DE OFICO DE NOTAS E DE REGISTROS', 16741, 2301208, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12509, 759, 'CARTORIO DE REGISTRO CIVIL 1º OFICIO', 16808, 2301208, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12510, 758, 'CARTORIO DO REGISTRO CIVIL DE VAZANTES', 18705, 2301208, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12511, 8834, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE SANTO ANTONIO', 136648, 2301257, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12512, 83, 'CARTORIO DO OFICIO UNICO', 18051, 2301257, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12513, 1727, 'CARTORIO DO REGISTRO CIVIL DE TAPUIARA', 18671, 2311306, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12514, 8835, '3O. OFICIO DE QUIXADA', 15701, 2311306, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12515, 1725, 'CARTORIO DE REGISTRO CIVIL DE DANIEL DE QUEIROZ', 16915, 2311306, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12516, 548, '3º TABELIONATO DE NOTAS E 3º OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE RIO BRANCO', 794, 1200401, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12517, 7597, '1º OFICIO DO REGISTRO DE IMOVEIS DA COMARCA DE RIO BRANCO', 851, 1200401, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12518, 1341, '2º TABELIONATO DE NOTAS E 2º OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE RIO BRANCO ', 943, 1200401, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12519, 7598, '2º TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE RIO BRANCO', 154427, 1200401, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12520, 7599, 'OFICIO DO REGISTRO DE TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS DA COMARCA DE RIO BRANCO', 1313, 1200401, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12521, 7600, 'SERVENTIA EXTRAJUDICIAL DA COMARCA DE RODRIGUES ALVES', 153866, 1200427, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12522, 1344, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE SANTA ROSA', 984, 1200435, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12523, 7601, 'SERVENTIA EXTRAJUDICIAL DA COMARCA DE SENA MADUREIRA', 153874, 1200500, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12524, 7602, 'SERVENTIA DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS DE SENA MADUREIRA', 1412, 1200500, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12525, 7603, 'SERVENTIA DE REGISTRO DE PROTESTO DE TITULOS CAMBIAIS DE SENA MADUREIRA', 1271, 1200500, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12526, 7604, 'SERVENTIA EXTRAJUDICIAL DA COMARCA DE SENA MADUREIRA', 1131, 1200500, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12527, 549, 'SERVENTIA EXTRAJUDICIAL DA COMARCA DE SENA MADUREIRA', 1107, 1200500, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12528, 7605, 'TABELIONATO DE NOTAS DA COMARCA DE SENA MADUREIRA', 1586, 1200500, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12529, 7606, 'SERVENTIA EXTRAJUDICIAL DA COMARCA DE SENADOR GUIOMARD', 153882, 1200450, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12530, 7607, 'SERVENTIA EXTRAJUDICIAL DA COMARCA DE TARAUACA', 153890, 1200609, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12531, 7608, 'SERVENTIAS EXTRAJUDICIAL DA COMARCA DE XAPURI', 153916, 1200708, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12532, 1345, '2º TABELIONATO DE NOTAS E REGISTRO CIVIL', 1883, 2700102, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12533, 7609, 'CARTORIO NOTARIAL E REGISTRAL DO 1º OFICIO', 3293, 2700102, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12534, 7610, 'CARTORIO DO 2º OFICIO DE ANADIA', 2527, 2700201, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12535, 1346, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE ANADIA ', 2972, 2700201, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12536, 7611, 'CARTORIO DO 1º OFICIO', 2477, 2700201, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12537, 555, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO  DE VILA SAO JOSE', 2857, 2700300, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12538, 553, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 2352, 2700300, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12539, 7612, 'ALAGOAS SERVICOS DO 1º OFICIO REGISTRO DE IMOVEIS', 2014, 2700300, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12540, 7613, 'CARTORIO DO 3º OFICIO', 2535, 2700300, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12541, 557, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 2360, 2700300, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12542, 7614, 'ALAGOAS CART. 2º OF. DE NOTAS', 1933, 2700300, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12543, 556, 'CARTORIO DO REGISTRO CIVIL DE ARAPIRACA - 1º DISTRITO', 2733, 2700300, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12544, 554, 'CARTORIO DO 2º DISTRITO DO REGISTRO CIVIL', 2519, 2700300, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12545, 7615, 'OFICIO DE NOTAS, PROTESTO TITULOS E DOCUMENTOS DE ATALAIA', 3418, 2700409, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12546, 7616, 'CARTORIO DO 1º OFICIO DE REGISTRO GERAL DE IMOVEIS E NOTAS', 2493, 2700409, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12547, 1347, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS, NASCIMENTO, CASAMENTO E OBITO', 2303, 2700409, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12548, 92, 'REGISTRO CIVIL E NOTAS DE BARRA DE SANTO ANTONIO', 3533, 2700508, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12549, 1348, 'CARTORIO DO UNICO OFICIO DE BARRA DE SAO MIGUEL', 3681, 2700607, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12550, 558, 'CARTORIO REGISTRO CIVIL', 3335, 2700706, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12551, 7617, 'SERVICO NOTARIAL E REGISTRAL', 150532, 2700706, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12552, 7618, 'SERVICO NOTARIAL E REGISTRAL', 150524, 2700706, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12553, 7619, 'SERVICO NOTARIAL E REGISTRAL', 3780, 2700706, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12554, 1349, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE BELEM', 2980, 2700805, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12555, 7620, 'CARTORIO DE NOTAS E DO REGISTRO GERAL DE IMOVEIS', 2097, 2700805, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12556, 1350, 'CARTORIO DO REGISTRO CIVIL', 2659, 2700904, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12557, 7621, 'UNICO OFICIO NOTARIAL E REGISTRAL', 4101, 2701001, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12558, 7711, 'CARTORIO DE IMOVEIS HIPOTECA TIT. DOC. E NOTAS', 2071, 2706505, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12559, 125, 'SERVICO DO REGISTRO CIVIL E NOTAS DE PASSO DE CAMARAGIBE', 3756, 2706505, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12560, 126, 'SERVICO DO REGISTRO CIVIL E NOTAS DE PAULO JACINTO/AL', 3764, 2706604, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12561, 7712, 'UNICO OFICIO DE NOTAS - REGISTRO GERAL DE IMOVEIS E HIPOTECA, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS - PROTESTO DE TITULOS DE PAULO JACINTO', 4077, 2706604, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12562, 127, 'CARTORIO DE REGISTRO CIVIL DA COMARCA DE PENEDO', 2188, 2706703, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12563, 7713, 'CARTORIO DO 1º OFICIO', 2485, 2706703, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12564, 7714, 'CARTORIO DO 2 OFICIO DE NOTAS E REGISTRO DE TITULOS E DOCUMENTOS ENOY MAGALHAES BITTENCOURT', 3301, 2706703, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12565, 7715, 'CARTORIO DO 3º TABELIONATO DE NOTAS DE PENEDO', 2543, 2706703, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12566, 128, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE PIACABUCU', 2022, 2706802, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12567, 7716, 'CARTORIO DO UNICO OFICIO', 3160, 2706802, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12568, 1003, 'CARTORIO DO REGISTRO CIVIL', 2618, 2706901, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12569, 7717, 'CARTORIO DO UNICO OFICIO DA COMARCA DE PILAR', 3194, 2706901, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12570, 461, 'REGISTRO CIVIL DE PINDOBA', 3624, 2707008, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12571, 7718, 'CARTORIO DO UNICO OFICIO', 3137, 2707008, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12572, 462, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 2212, 2707107, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12573, 464, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 3707, 2707107, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12574, 8062, 'REGISTRO CIVIL DAS PESSOAS NATURAIS ', 140269, 2915601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12575, 8063, 'REGISTRO DE IMOVEIS, HIPOTECAS E TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS DA COMARCA DE ITAMARAJU', 140160, 2915601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12576, 7483, 'REGISTRO CIVIL C/ FUNCOES NOTARIAIS', 133546, 2915601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12577, 8064, 'REGISTRO DE IMOVEIS, HIP E TIT E DOCS', 131599, 2915700, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12578, 7484, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 131581, 2915700, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12579, 376, 'CARTORIO REGISTRO CIVIL', 10744, 2915809, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12580, 374, 'CARTORIO REGISTRO CIVIL', 10736, 2915809, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12581, 8065, 'CARTORIO DE NOTAS C/C PROTESTO', 5710, 2915809, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12582, 375, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9258, 2915809, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12583, 8066, 'CARTORIO RE REGISTRO DE IMOVEIS', 10678, 2915809, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12584, 379, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS ¿ BATINGA', 140111, 2916005, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12585, 378, 'CARTORIO CIVIL DAS PESSOAS NATURAIS', 148528, 2916005, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12586, 8067, 'REG. CIVIL C/ FUNC NOTARIAIS - PALAME', 134841, 2910602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12587, 950, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 10801, 2910701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12588, 8068, 'EUCLIDES DA CUNHA - CARTORIO DE REGISTRO CIVIL - SEDE', 144147, 2910701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12589, 8069, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS  ', 10280, 2910701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12590, 8070, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ CAIMBE', 140087, 2910701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12591, 8071, '1º OFICIO DE NOTAS COM FUNCAO DEPROTESTOS', 5330, 2910701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12592, 8072, 'CARTORIO DO REGISTRO DE IMOVEIS DA COMARCA DE CANUDOS', 10082, 2910701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12593, 946, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12476, 2910701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12594, 948, 'EUCLIDES DA CUNHA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE ALGODOES', 144154, 2910701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12595, 947, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 10843, 2910701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12596, 309, 'REGISTRO CIVIL C FUNCOES NOTARIAIS', 11759, 2910727, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12597, 8073, 'TABELIONATO DE NOTAS E PROTESTO', 14993, 2910727, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12598, 1328, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 10827, 2910727, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12599, 8074, 'CARTORIO DE REGISTRO DE IMOVEIS', 7427, 2910727, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12600, 310, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS 1º OFICIO', 9613, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12601, 8075, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ HUMILDES', 140244, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12602, 8076, 'CARTORIO DO 2º OFICIO DE REGISTRO DE IMOVEIS E HIPOTECAS', 8409, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12603, 8077, 'REG. CIVIL C/ FUNC NOTARIAIS - BONFIM FEIRA', 133264, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12604, 7471, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ TANQUINHO', 140491, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12605, 8078, 'TABELIONATO DO 1º OFICIO DE NOTAS', 15263, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12606, 8079, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ GOV. JOAO D. CARNEIRO', 140152, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12607, 8080, 'TABELIONATO DO 3º OFICIO DE NOTAS', 153049, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12608, 8081, 'CARTORIO DE PROTESTO DE TITULOS E DOCUMENTOS DE FEIRA DE SANTANA-BAHIA', 5827, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12609, 8082, 'REGISTRO DE TITULOS E DOCUMENTOS', 133249, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12610, 8083, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ JAGUARA', 140327, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12611, 8084, 'TABELIONATO DO (3º) TERCEIRO OFICIO DE NOTAS', 11155, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12612, 7472, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ TIQUARUCU', 140129, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12613, 8085, '1º REGISTRO DE IMOVEIS E HIPOTECAS', 5355, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12614, 7470, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ MARIA QUITERIA', 140251, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12615, 8086, 'TABELIONATO DO 2º OFICIO DE NOTAS', 15313, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12616, 7469, 'REG. CIVIL C/ FUNC NOTARIAIS - JAIBA', 133272, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12617, 311, 'FEIRA DE SANTANA - CARTORIO DE REGISTRO CIVIL - 2º OFICIO', 144170, 2910800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12618, 312, 'REGISTRO CIVIL COM FUNCOES NOTARIAS - FILADEFIA', 138420, 2910859, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12619, 1329, 'REGISTRO CIVIL DAS PESSOAS NATURIAS DE FLORESTA AZUL BAHIA', 12765, 2911006, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12620, 8087, 'CARTORIO DO REG. IMOV. HIP. TIT. E DOCUMENTOS', 8490, 2911105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12621, 313, 'REGISTRO CIVIL DAS PESSOAS NATURIS', 12773, 2911105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12622, 8088, 'TABELIONATO DE NOTAS C/ FUNCOES DE PROTESTO', 14043, 2911105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12623, 314, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS  ', 9407, 2911204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12624, 1037, 'DISTRITO DE MATIAS', 20354, 2310704, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12625, 315, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS ', 8839, 2911253, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12626, 8520, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO', 14589, 2926301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12627, 8521, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS TITULOS E DOCUMENTOS', 10223, 2932200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12628, 8522, 'REGISTRO DE IMOVEIS E HIPOTECAS', 13037, 2932309, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12629, 8523, 'TABELIONATO DE NOTAS', 13946, 2932309, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12630, 8524, 'CARTORIO DO TABELIONATO DE NOTAS', 10488, 2932408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12631, 703, 'CARTORIO REG. CIVIL C/ FUNCOES NOTARIAIS', 10702, 2932408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12632, 702, 'REGISTRO CIVIL COM FUNCOES NOTORIAIS', 12112, 2932408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12633, 8525, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 132845, 2932408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12634, 77, 'JACOBINA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE UMBURANAS', 144352, 2932457, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12635, 78, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS DO DISTRITO DE DELFINO', 8987, 2932457, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12636, 8526, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 132860, 2932507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12637, 8527, 'REG. CIVIL C/ FUNCOES NOTARIAIS - COMANDATUBA', 132894, 2932507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12638, 8528, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS.', 139527, 2932507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12639, 8529, 'REG. CIVIL C/ FUNCOES NOTARIAIS - COLONIA', 132886, 2932507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12640, 8530, 'REG. CIVIL C/ FUNCOES NOTARIAIS - VILA BRASIL', 132910, 2932507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12641, 8531, 'TABELIONATO C/ FUNCAO DE PROTESTO', 132878, 2932507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12642, 8532, 'REG. CIVIL C/ FUNCOES NOTARIAIS - PEDRAS DE UNA', 132902, 2932507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12643, 8533, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS', 10173, 2932606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12644, 79, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9092, 2932606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12645, 8534, 'CARTORIO DO TABELIONATO DE NOTAS', 10520, 2932606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12646, 8535, 'CARTORIO DE REGISTRO DE IMOVEIS E TITULOS E DOCUMENTOS', 7948, 2932705, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12647, 704, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 15446, 2932705, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12648, 8536, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTOS', 14720, 2932705, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12649, 8537, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO DE TITULOS', 14472, 2932804, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12650, 707, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE UTINGA', 6841, 2932804, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12651, 706, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS DO SUBDISTRITO DE RIACHAO DE UTINGA', 6262, 2932804, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12652, 705, 'UTINGA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE WAGNER', 144055, 2932804, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12653, 8538, 'CARTORIO DE REGISTRO DE IMOVEIS HIPOTECAS TITULOS E DOCUMENTOS', 7971, 2932804, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12654, 8539, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS E PESSOAS JURIDICAS', 134023, 2932903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12655, 8540, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14266, 2932903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12656, 8541, 'REG. CIVIL C/ FUNC. NOTARIAIS - GAMBOA DO MORRO', 136390, 2932903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12657, 708, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 10876, 2932903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12658, 732, 'REG. CIVIL C/ FUNCOES NOTARIAIS - MARICOABO', 5686, 2932903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12659, 731, 'REG. CIVIL C/ FUNC NOTARIAIS - GALEAO', 135608, 2932903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12660, 710, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS - SERRA GRANDE', 9498, 2932903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12661, 8542, 'REG. CIVIL C/ FUNCOES NOTARIAIS - GUAIBIM', 134031, 2932903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12662, 709, 'REGISTRO CIVIL E NOTAS', 12864, 2932903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12663, 80, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 6973, 2933000, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12664, 8543, 'CARTORIO DE REGISTRO DE IMOVEIS E TITULOS E DOCUMENTOS', 7955, 2933000, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12665, 8544, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO DE TITULOS ', 14522, 2933000, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12666, 8545, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 132951, 2933109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12667, 8546, 'TABELIONATO DE NOTAS', 13979, 2933109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12668, 711, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12344, 2933109, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12669, 8547, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS DAS PESSOAS JURIDICAS', 8169, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12670, 8548, 'REG. CIVIL C/ FUNCOES NOTARIAIS - DANTILANDIA', 134072, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12671, 8549, 'CARTORIO DO 1º OFICIO DE REGISTRO DE IMOVEIS', 8367, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12672, 735, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS', 8870, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12673, 8550, 'REG. CIVIL C/ FUNCOES NOTARIAIS - SAO SEBASTIAO', 134106, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12674, 8551, 'PRIMEIRO TABELIONATO DE NOTAS PAES', 5363, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12675, 712, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS - 1º OFICIO', 6726, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12676, 8919, 'CARTORIO DO REG. CIVIL DO DISTRITO DE GUASSUSSE', 146548, 2309508, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12677, 995, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS - DISTRITO DE IGAROI - COMARCA DE OROS/CE', 18580, 2309508, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12678, 8920, 'CARTORIO SANTANA 2º OFICIO', 20123, 2309508, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12679, 8921, 'CARTORIO DO 3º OFICIO DA COMARCA DE PACAJUS', 17855, 2309607, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12680, 173, 'CARTORIO DO REGISTRO CIVIL', 18242, 2309607, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12681, 172, 'CARTORIO DE 1º OFICIO DE PACAJUS/CE', 16485, 2309607, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12682, 8922, 'CARTORIO MACIEL- 2º OFICIO', 19604, 2309607, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12683, 174, 'CARTORIO ALENCAR FURTADO', 16139, 2309706, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12684, 6856, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE MONGUBA', 137059, 2309706, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12685, 8923, '2º OFICIO DA COMARCA DE PACATUBA - CEARA', 15644, 2309706, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12686, 8924, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE SENADOR CARLOS JEREISSATI', 137034, 2309706, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12687, 996, 'CARTORIO ALMEIDA FIGUEIREDO', 16162, 2309706, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12688, 175, 'CARTORIO DE PAVUNA', 16758, 2309706, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12689, 176, 'CARTORIO DE NOTAS E DE REGISTROS DA COMARCA DE PACOTI', 16527, 2309805, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12690, 177, 'OFICIO DE NOTAS E DE REGISTROS PUBLICOS', 20594, 2309904, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12691, 178, 'CARTORIO DE 1º  OFICIO FOI  ANEXADO AO CARTORIO DE OFICIO DE NOTAS  E REGISTROS (13.706-7)EM 1997,LEI  12776', 16451, 2310001, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12692, 8925, 'CARTORIO DE OFICIO DE NOTAS E REGISTROS OBS. EM 1997     ATRAVES DE  LEI FOI ANEXADO A  ESTE CARTORIO  A SERVENTIA DE C ODIGO 01.645-1', 137067, 2310001, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12693, 8926, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE GADO DO FERRO', 136010, 2310100, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12694, 179, 'CARTORIO DO REG. CIVIL DO 1° OFICIO', 18184, 2310100, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12695, 8927, 'CARTORIO ANDRADE - 2º OFICIO', 16204, 2310100, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12696, 8928, 'PARACURU-CARTORIO DE NOTAS E REGISTROS PUBLICOS', 20685, 2310209, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12697, 1720, 'CARTORIO DO REGISTRO CIVIL DO PRIMEIRO OFICIO', 19166, 2310209, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12698, 1033, 'CARTORIO 1 OFICIO DE NOTAS E REGISTROS PUBLICOS DE PARAIPABA/CE', 19844, 2310258, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12699, 8929, 'CARTORIO DO 2º OFICIO DE PARAIPABA', 17756, 2310258, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12700, 8930, 'CARTORIO DO 2° OFICIO DO REGISTRO DE IMOVEIS', 17608, 2310308, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12701, 1722, 'CARTORIO DE MONTE SION', 16519, 2310308, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12702, 1721, 'CARTORIO DO REGISTRO CIVIL', 18218, 2310308, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12703, 1723, 'CARTORIO SAO FRANCISCO - 1º OFICIO', 20131, 2310308, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12704, 8931, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE COCOCI', 136028, 2310308, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12705, 1724, 'REGISTRO CIVIL CARTORIO DE PARAMOTI', 20743, 2310407, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12706, 8932, 'CARTORIO DE 2º OFICIO SAMUEL BOYADJIAN', 16501, 2310407, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12707, 1410, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE RIACHAO DO BANABUIU PEDRA BRANCA CE', 19034, 2310506, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12708, 8933, 'CARTORIO 2º OFICIO DE REGISTRO DE IMOVEIS DE PEDRA BRANCA', 19539, 2310506, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12709, 8934, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE TROIA', 136051, 2310506, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12710, 1034, 'CARTORIO PESSOA', 19901, 2310506, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12711, 1035, 'CARTORIO MINEIRO', 16832, 2310506, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12712, 1411, 'PENTECOSTE CARTORIO REGISTRO CIVIL PRIMEIRO OFICIO', 20693, 2310704, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12713, 8935, 'CARTORIO SOARES GONDIM - 2º OFICIO', 20172, 2310704, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12714, 8936, 'CARTORIO 2º OFICIO', 16022, 2310803, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12715, 7513, 'CARTORIO 1º OFICIO', 15941, 2310803, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12716, 8937, 'CARTORIO DE OFICIOS NTOAS E REGISTRO', 16725, 2310852, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12717, 1412, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE IBICUA', 137778, 2310902, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12718, 1038, 'CARTORIO NASCIMENTO - NOTAS E REGISTROS PUBLICOS', 19737, 2310902, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12719, 1039, 'CARTORIO VALLE DE NOTAS E REGISTROS', 20222, 2310951, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12720, 1413, 'CARTORIO SAMPAIO', 20099, 2310951, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12721, 1415, 'CARTORIO MARINHO', 19646, 2311009, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12722, 1414, 'CARTORIO DE REGISTRO CIVIL DE MACAMBIRA', 16964, 2311009, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12723, 1040, 'CARTORIO SANTANA - OFICIO UNICO ', 20115, 2311108, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12724, 8938, 'CARTORIO DE NOTAS E REGISTROS PUBLICOS 2.º OFICIO', 16600, 2311207, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12725, 1041, 'CARTORIO DO PRIMEIRO OFICIO DE REGISTRO CIVIL', 18135, 2311207, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12726, 1416, 'OFICIOS DE NOTAS.RTEG.PROTESTOS E REG.CIVIL', 20669, 2311231, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12727, 7719, 'CARTORIO DO UNICO OFICIO DE PIRANHAS', 3251, 2707107, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12728, 463, 'REGISTRO CIVIL DE PESSOAS NATURAIS DE ENTREMONTES', 3541, 2707107, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12729, 129, 'CARTORIO DO REGISTRO CIVIL', 2576, 2707206, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12730, 7720, 'UNICO SERVICO NOTARIAL E REGISTRAL', 4119, 2707206, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12731, 130, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 2220, 2707206, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12732, 7721, 'CARTORIO DO 1 OFICIO', 2469, 2707305, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12733, 7722, 'CARTORIO DO 2° OFICIO TABELIONATO DE NOTAS E PROTESTOS.', 2501, 2707305, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12734, 1004, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE PORTO CALVO', 2592, 2707305, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12735, 384, 'SERVICO NOTARIAL E REGISTRAL DAS PESSOAS NATURAIS DO 1º DISTRITO DE PORTO DE PEDRAS', 3855, 2707404, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12736, 7723, 'CARTORIO DO UNICO OFICIO DE PORTO DE PEDRAS', 3269, 2707404, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12737, 383, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE TATUAMUNHA', 2337, 2707404, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12738, 638, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 2931, 2707503, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12739, 7724, 'CARTORIO DO UNICO OFICIO', 3079, 2707503, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12740, 7725, 'SERVICO NOTARIAL E REGISTRAL - UNICO OFICIO', 3830, 2707602, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12741, 639, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE QUEBRANGULO-ALAGOAS', 2410, 2707602, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12742, 385, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS DE UTINGA', 2832, 2707701, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12743, 7726, 'ALAGOAS CARTORIO DE IMOVEIS HIPOTECA E NOTAS', 1982, 2707701, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12744, 7727, '2º TABELIONATO DE NOTAS E PROTESTOS', 1875, 2707701, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12745, 919, 'CARTORIO DO JUDICIAL E ANEXOS DO 2º OFICIO DA COMARCA DE PARINTINS - AMAZONAS', 4861, 1303403, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12746, 501, 'CARTORIO DO JUDICIAL E ANEXOS DA 3ª VARA DE PARINTINS', 4598, 1303403, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12747, 502, 'DESDOR JOAO MEIRELES', 5025, 1303502, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12748, 503, 'CARTORIO DO JUDICIAL E ANEXOS', 4556, 1303536, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12749, 6, 'CARTORIO DO JUDICIAL E ANEXOS COMARCA DE RIO PRETO DA EVA', 4580, 1303569, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12750, 6468, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE SANTA ISABEL DO RIO NEGRO', 142687, 1303601, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12751, 6469, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE SANTO ANTONIO DO ICA ', 4788, 1303700, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12752, 920, 'CARTORIO DA COMARCA DE SAO GABRIEL DA CACHOEIRA', 4283, 1303809, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12753, 416, 'FORUM JUDICIAL DA COMARCA DE SAO PAULO DE OLIVENCA', 5033, 1303908, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12754, 417, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE SAO SEBASTIAO DO UATUMA', 4796, 1303957, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12755, 418, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE SILVES ', 4804, 1304005, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12756, 921, 'CARTORIO DA 1ª VARA DA COMARCA DE TABATINGA', 4242, 1304062, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12757, 419, 'CARTORIO DA 2° OFICIO DA COMARCA DE TABATINGA', 4267, 1304062, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12758, 420, 'CARTORIO DE TAPAUA', 4325, 1304104, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12759, 421, '1º CARTORIO DE NOTAS E ANEXOS DA COMARCA DE TEFE/AM', 4606, 1304203, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12760, 504, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DA 2ªVARA DE TEFE', 142653, 1304203, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12761, 571, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE URUCARA ', 4812, 1304302, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12762, 422, 'CARTORIO DO JUDICIAL E ANEXOS DE URUCURITUBA', 4846, 1304401, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12763, 423, 'CARTORIO NASCIMENTO - OFICIO DE REGISTROS PUBLICOS E TABELIONATO COMARCA DE AMAPA', 5181, 1600105, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12764, 424, 'CARTORIO DE REGISTROS PUBLICOS E TABELIONATO DA COMARCA DE CALCOENE', 5132, 1600204, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12765, 505, 'CARTORIO DE REGISTRO CIVIL EXTRAJUDICIAL ', 5082, 1600212, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12766, 922, 'CARTORIO DE REGISTRO PUBLICOS E TABELIONATO ', 5108, 1600238, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12767, 425, 'CARTORIO DE REGISTROS PUBLICOS E TABELIONATO DE ITAUBAL', 5140, 1600253, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12768, 426, 'VALDAIR ELEMAR CAMARGO', 5256, 1600279, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12769, 506, '2º OFICIO DE NOTAS E ANEXOS', 5074, 1600303, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12770, 7728, 'REGISTRO DE IMOVEIS ''ELOY NUNES''', 5231, 1600303, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12771, 427, 'SUCURSAL DO CARTORIO DO BAILIQUE', 5249, 1600303, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12772, 428, 'CARTORIO DE REGISTROS PUBLICOS E MAIS CARGOS ANEXOS', 5116, 1600303, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12773, 507, 'KATIA DE SOUZA RODRIGUES', 5207, 1600402, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12774, 429, 'CARTORIO ISMAEL DE OLIVEIRA SERVICO NOTARIAL E REGISTRAL DE OIAPOQUE', 5157, 1600501, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12775, 8089, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS, REGISTRO DE TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS.', 7815, 2911204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12776, 8090, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO', 14639, 2911204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12777, 8091, 'REGISTRO DE IMOVEIS E HIPOTECAS, PESSOAS JURIDICAS E TITULOS E DOCUMENTOS', 13193, 2911253, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12778, 8092, 'TABELIONATO C/ FUNCAO DE PROTESTO', 134866, 2911253, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12779, 318, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO DISTRITO DE IAJUBAQUARA ', 11684, 2911303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12780, 316, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO DISTRITO DE SANTO INACIO', 11510, 2911303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12781, 317, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO DISTRITO DE IBITUNANE', 9779, 2911303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12782, 321, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO DISTRITO DE GAMELEIRA DO ASSURUA', 12716, 2911303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12783, 8093, 'REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 10157, 2911303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12784, 319, 'REGISTRO CIVIL DAS PESSOAS NATURAIS INTERDICOES E TUTELAS', 12161, 2911303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12785, 320, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO DISTRITO DE PITUBA', 9803, 2911303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12786, 8094, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 15040, 2911303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12787, 8095, 'TABELIONATO DE NOTAS', 13920, 2911402, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12788, 8096, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS', 134916, 2911402, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12789, 322, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6379, 2911402, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12790, 8097, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO', 14613, 2911600, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12791, 323, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9217, 2911600, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12792, 8098, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS', 10124, 2911600, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12793, 8099, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS DA COMARCA DE GUANAMBI/BA', 154633, 2911709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12794, 8100, 'REG. CIVIL C/ FUNC NOTARIAIS - PILOES', 133306, 2911709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12795, 8101, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 139089, 2911709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12796, 8102, 'REG. CIVIL C/ FUNC NOTARIAIS - MORRINHOS', 133298, 2911709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12797, 7473, 'REG. CIVIL C/ FUNCAO NOTARIAIS - CERAIMA', 136580, 2911709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12798, 8103, 'TABELIONATO DE NOTAS E DE PROTESTO DE GUANAMBI', 14894, 2911709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12799, 8104, 'REG. CIVIL C/ FUNC. NOTARIAIS - MUTAS', 136341, 2911709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12800, 8105, 'REG. CIVIL C/ FUNC NOTARIAIS - BUARANHEM', 134932, 2911808, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12801, 8106, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS.', 139634, 2911808, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12802, 8107, 'TABELIONATO COM FUNCAO DE PROTESTO', 139477, 2911808, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12803, 8614, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14431, 2929370, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12804, 8615, 'REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS', 13318, 2929370, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12805, 8616, 'SAO JOSE DP JACUIPE - CARTORIO DE REGISTRO CIVIL - DISTRITO DE ITATIAIA DO ALTO BONITO', 143966, 2929370, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12806, 667, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6395, 2929503, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12807, 668, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12328, 2929503, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12808, 666, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS/FUNCOES NOTARIAIS - DISTRITO DE CINCO RIOS', 6932, 2929503, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12809, 8617, 'REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS', 13292, 2929503, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12810, 8618, 'REG. CIVIL C/ FUNC NOTARIAIS - RURAL DO PASSE', 132571, 2929503, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12811, 8619, 'TABELIONATO DE NOTAS/PROTESTO DE TITULOS', 15180, 2929503, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12812, 8620, 'REG. CIVIL C/ FUNC NOTARIAIS -  MARANCANGALHA', 132563, 2929503, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12813, 671, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS', 6148, 2929602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12814, 670, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6338, 2929602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12815, 8621, 'TABALIONATO DE NOTAS COM FUNCAO DE PROTESTO', 13607, 2929602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12816, 8622, 'REG. CIVIL C/ FUNC NOTARIAIS - BAIXA DO PALMEIRA', 132589, 2929602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12817, 8623, 'SAPEACU - CARTORIO DE REGISTRO DE IMOVEIS, TIT., DOC. E PESSOAS JURIDICAS', 13524, 2929602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12818, 8624, 'REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS', 13177, 2929701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12819, 672, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12229, 2929701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12820, 8625, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO DE TITULOS', 14696, 2929701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12821, 669, 'TABELIONATO DE NOTAS C/FUNCOES DE PROTESTO DE TITULOS ', 6494, 2929701, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12822, 674, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS', 6171, 2929800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12823, 8626, 'TABELIONATO DO 1º OFICIO DE NOTAS DA COMARCA DE SAUDE - BAHIA', 15289, 2929800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12824, 673, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9563, 2929800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12825, 8627, 'CARTORIO REGISTRO DE IMOVEIS HIPOTECAS TITULOS E DOCUMENTOS', 11023, 2929800, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12826, 675, 'CARTORIO DE REGISTRO CIVIL DISTRITO VARZEA DO CALDAS', 7203, 2929909, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12827, 8628, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 133959, 2929909, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12828, 676, 'CARTORIO REGISTRO CIVIL DE BARAUNAS', 10918, 2929909, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12829, 8629, 'SEABRA CARTORIO DO REG DE IMOV E HIP E TIT DE DOCTOS', 13532, 2929909, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12830, 8630, 'TABELIONATO DE NOTAS C/ FUNCOES DE PROTESTO', 14068, 2929909, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12831, 6916, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9399, 2930105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12832, 677, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE TIJUACU', 9936, 2930105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12833, 8631, 'REG. CIVIL C/ FUNCOES NOTARIAIS - TANQUINHO DO POCO', 134007, 2930105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12834, 8632, 'TABELIAO DE NOTAS DO Lº OFICIO DE SR DO BONFIM', 13623, 2930105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12835, 8633, 'TABELIONATO DO SEGUNDO OFICIO DE NOTAS', 15362, 2930105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12836, 8634, 'REG. CIVIL C/ FUNCOES NOTARIAIS - SITIO DA BARAUNA', 133991, 2930105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12837, 8635, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS DO 1. OFICIO', 7633, 2930105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12838, 8636, 'REGISTRO DE TITULOS E DOCUMENTOS', 137414, 2930105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12839, 8637, 'CARTORIO DO REGISRO DE IMOVEIS DO 2. OFICIO', 8508, 2930105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12840, 8638, 'REG. CIVIL C/ FUNCOES NOTARIAIS - IGARA', 133983, 2930105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12841, 8639, 'TABELIONATO DE PROTESTO DE TITULOS', 8433, 2930105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12842, 69, 'REG. CIVIL C/ FUNCAO NOTARIAIS - CARRAPICHEL', 136549, 2930105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12843, 71, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE MINAS DE MIMOSO', 9787, 2930204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12844, 8640, 'REG. CIVIL C/ FUNC NOTARIAIS - CAJUI', 132605, 2930204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12845, 8641, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTOS', 14555, 2930204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12846, 72, 'REGISTRO CIVIL', 11700, 2930204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12847, 6917, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9480, 2930204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12848, 1198, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DA SEDE - GUARAPARI/ES', 22723, 3202405, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12849, 1058, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO - ASTORI', 23515, 3202405, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12850, 8986, 'CARTORIO 3° OFICIO DE GUARAPARI', 21725, 3202405, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12851, 8987, '2º OFICIO DE REGISTRO GERAL DE IMOVEIS DE GUARAPARI', 21402, 3202405, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12852, 7417, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE IBATIBA', 22475, 3202454, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12853, 8988, 'CARTORIO 1º OFICIO REG. IMOVEIS, PROTESTOS, TIT. E DOC. E P.J.', 21683, 3202454, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12854, 1200, 'CARTORIO DE REGISTRO CIVIL E NOTAS DO DISTRITO DE PENDANGA', 23754, 3202504, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12855, 1199, 'CARTORIO REGISTRO CIVIL E TABELIONATO', 23812, 3202504, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12856, 8989, 'CARTORIO 1º OFICIO IBIRACU-ES', 21667, 3202504, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12857, 6939, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DA SEDE DO MUNICIPIO DE IBITIRAMA-ES', 22525, 3202553, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12858, 8990, 'CARTORIO DO 1º OFICIO DE IBITIRAMA-ES', 23044, 3202553, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12859, 1201, 'CARTORIO DE REGISTRO CIVIL E NOTAS DO DISTRITO DE SANTA MARTA, MUNICIPIO DE IBITIRAMA/ES', 22186, 3202553, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12860, 1060, 'CARTORIO DE REGISTRO CIVIL - DUAS BARRAS - ICONHA - ES', 22350, 3202603, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12861, 8991, 'ICONHA CARTORIO DE SEGUNDO OFICIO TABELIONATO', 24075, 3202603, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12862, 1059, 'CARTORIO REGISTRO CIVIL E TABELIONATO', 23804, 3202603, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12863, 8992, 'CARTORIO DE TABELIONATO DE NOTAS DUAS BARRAS', 152330, 3202603, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12864, 8993, 'ICONHA CARTORIO DO PRIMEIRO OFICIO', 24083, 3202603, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12865, 1202, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 22061, 3202652, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12866, 8994, 'REGISTRO GERALDE IMOVEIES, REGISTRO DE TITULOS E DOCUMENTOS E PROTESTO DE TITULOS E DOCUMENTOS', 24414, 3202702, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12867, 1061, 'CARTORIO REGISTRO CIVIL E  TABELIONATO DE ITAIMBE ', 23762, 3202702, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12868, 1203, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE ITACU', 22483, 3202702, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12869, 8995, 'CARTORIO DO PRIMEIRO OFICIO', 23283, 3202702, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12870, 1206, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE ITAPECOA', 22491, 3202801, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12871, 6933, 'AFONSO CLAUDIO CARTORIO DE REGISTRO CIVIL E TABELIONATO', 21444, 3200102, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12872, 1436, 'OFICIO DO REGISTRO CIVIL E TABELIONATO DE NOTAS ', 21329, 3200102, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12873, 8996, 'AFONSO CLAUDIO CARTORIO DE NOTAS CIVEL E COMERCIAL 2º OFICIO', 21428, 3200102, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12874, 8997, 'AFONSO CLAUDIO CART. REG. GERAL IMOV. TIT. DOC. E PROT. 1º OFICIO', 21410, 3200102, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12875, 1438, 'AFONSO CLAUDIO CARTORIO DE R. CIVIL E TABELIONATO DE SERRA PELADA', 21436, 3200102, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12876, 1434, 'CARTORO DE NOTAS E REGISTRO CIVIL DE PIRACEMA', 23929, 3200102, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12877, 1435, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 23499, 3200102, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12878, 123, 'REGISTRO CIVIL', 3467, 2706422, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12879, 8998, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE VILA NELITA', 144956, 3200169, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12880, 1441, 'AGUA DOCE DO NORTE CARTORIO DO REGISTRO CIVIL E NOTAS', 21451, 3200169, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12881, 1440, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E TABELIONATO DE NOTAS', 23465, 3200169, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12882, 8999, 'CARTORIO DO 1º OFICIO DA COMARCA DE AGUA DOCE DO NORTE', 22988, 3200169, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12883, 1439, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 22244, 3200169, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12884, 9000, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS - DISTRITO DE SANTO AGOSTINHO', 145102, 3200169, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12885, 6934, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 22319, 3200169, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12886, 1442, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 23424, 3200136, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12887, 9001, 'CARTORIO DO 1º OFICIO', 22905, 3200136, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12888, 1445, 'CARTORIO DE REGISTRO CIVIL E NOTAS ALEGRE, ES', 22111, 3200201, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12889, 1443, 'CARTORIO DE REGISTRO CIVEL E TABELIONATO DO DISTRITO DO CAFE', 21980, 3200201, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12890, 9002, 'ALEGRE CARTORIO REG GERAL IMOVEIS TITULOS E DOCUMENTOS 1º OFICIO', 21469, 3200201, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12891, 1447, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE RIVE', 22137, 3200201, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12892, 1448, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE ARARAI', 22129, 3200201, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12893, 1446, 'CARTORIO DE REGISTRO CIVIL E NOTAS E ANUTIBA ', 22202, 3200201, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12894, 6935, 'REGISTRO CIVIL E NOTAS DE CELINA', 24265, 3200201, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12895, 1444, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE SANTA ANGELICA', 22145, 3200201, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12896, 134, 'CARTORIO DISTRITAL DE PARACUUBA', 148916, 1300300, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12897, 135, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE AUTAZES', 4648, 1300300, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12898, 477, 'CARTORIO DO 1º OFICIO DA COMARCA DE BARCELOS/AM ', 4374, 1300409, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12899, 478, 'CARTORIO DE JUDICIAL E ANEXOS DE BARREIRINHA', 4317, 1300508, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12900, 479, 'CARTORIO DA COMARCA DE BENJAMIN CONSTANT', 4275, 1300607, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12901, 480, 'CARTORIO DO JUDICIAL E ANEXOS 1ª VARA BERURI', 4564, 1300631, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12902, 136, 'CARTORIO EXTRAJUDICIAL DE BOA VISTA DOS RAMOS', 130856, 1300680, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12903, 137, 'CARTORIO JUDICIAL E ANEXOS', 4960, 1300706, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12904, 139, 'CARTORIO DISTRITAL DO REGISTRO CIVIL DE AXINI', 149179, 1300805, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12905, 138, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE BORBA', 4655, 1300805, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12906, 481, 'CARTORIO JUDICIAL E ANEXOS DA COMARCA DE CAAPIRANGA', 4978, 1300839, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12907, 915, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE CANUTAMA', 4663, 1300904, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12908, 140, 'CARTORIO EXTRAJUDICIAL DA COMARCA DE CARAUARI/AM', 4671, 1301001, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12909, 482, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DO CAREIRO ', 4820, 1301100, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12910, 394, 'CARTORIO DISTRITAL DO REGISTRO CIVIL DE AUTAZ MIRIM', 149500, 1301159, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12911, 395, 'CARTORIO DISTRITAL DO 20º REGISTRO CIVIL DE TERRA NOVA', 148361, 1301159, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12912, 142, 'CARTORIO DISTRITAL DE REGISTRO CIVIL DE MURUMURUTUBA', 148809, 1301159, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12913, 483, 'CARTORIO DA COMARCA DO CAREIRO DA VARZEA', 4291, 1301159, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12914, 141, 'CARTORIO DISTRITAL DO REGISTRO CIVIL DE PARANA DO CAMBIXE', 148403, 1301159, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12915, 396, 'CARTORIO DISTRITAL DO REGISTRO CIVIL DO PARANA DO CAREIRO DA VARZEA', 148395, 1301159, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12916, 143, 'CARTORIO 1º OFICIO', 4234, 1301209, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12917, 6464, 'CARTORIO DO 2º OFICIO JUDICIAL E ANEXO DE COARI', 4424, 1301209, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12918, 397, 'COMARCA DO JUDICIAL E ANEXOS DE CODAJAS', 5017, 1301308, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12919, 144, 'CARTORIO FERNANDES', 4952, 1301407, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12920, 145, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE ENVIRA', 142414, 1301506, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12921, 146, 'CARTORIO DO JUDICIAL E ANEXO DE FONTE BOA', 130849, 1301605, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12922, 6465, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE GUAJARA', 4697, 1301654, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12923, 147, 'CARTORIO DO PRIMEIRO OFICIO DO JUDICIAL E ANEXOS', 4895, 1301704, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12924, 484, 'CARTORIO DO 2º OFICIO DA COMARCA DE HUMAITA', 4408, 1301704, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12925, 148, 'CARTORIO DO JUDICIAL E ANEXOS COMARCA DE IPIXUNA', 4572, 1301803, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12926, 485, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE IRANDUBA', 4705, 1301852, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12927, 486, 'CARTORIO DA 2ª VARA JUDICIAL E ANEXOS DA COMARCA DE ITACOATIARA', 4416, 1301902, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12928, 149, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DA 3ª VARA DE ITACOATIRA', 142422, 1301902, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12929, 487, 'CARTORIO 1º VARA JUDICIAL E ANEXO DA COMARCA DE ITACOATIARA', 4226, 1301902, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12930, 398, 'COMARCA DO JUDICIAL E ANEXOS DA COMARCA DE ITAMARATI ', 5009, 1301951, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12931, 150, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE ITAPIRANGA ', 4713, 1302009, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12932, 488, 'CARTORIO DO JUDICIAL E ANEXOS DE JAPURA', 4838, 1302108, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12933, 489, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE JURUA', 142430, 1302207, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12934, 490, 'CARTORIO DO JUDICIAL E EXTRAJUDICIAL DE JUTAI', 4549, 1302306, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12935, 399, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE LABREA ', 4721, 1302405, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12936, 492, 'CARTORIO DISTRITAL DO REGSITRO CIVIL DE CONCEICAO', 149294, 1302504, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12937, 401, 'CARTORIO DO JUDICIAL E ANEXOS DO SEGUNDO OFICIO DA COMARCA DE MANACAPURU-AM', 4879, 1302504, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12938, 400, 'CARTORIO DISTRITAL DO REGISTRO CIVIL RIO MANACAPURU', 149039, 1302504, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12939, 6466, 'CARTORIO DISTRITAL DO REGISTRO CIVIL DA VILA DE CAMPINAS DO NORTE NO PARANA DO ANAMA', 150581, 1302504, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12940, 491, 'CARTORIO DISTRITAL DO REGISTRO CIVIL DE PARATARI', 148973, 1302504, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12941, 493, 'CARTORIO DISTRITAL DO REGISTRO CIVIL DE CAMPINAS RIO PURUS', 149344, 1302504, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12942, 151, 'CARTORIO DA 1ª VARA DE MANACAPURU-AM', 4259, 1302504, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12943, 12, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9159, 2919702, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12944, 8172, 'TABELIONATO DE NOTAS/PROTESTO DE TITULOS E DOCUMENTOS', 13672, 2919702, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12945, 8173, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS', 136556, 2919702, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12946, 8174, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ LAGOA CLARA', 140855, 2919801, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12947, 8175, 'MACAUBAS - TABELIONATO DE NOTAS', 11411, 2919801, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12948, 223, 'MACAUBAS - CART. REG. CIVIL', 11395, 2919801, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12949, 13, 'MACAUBAS - CARTORIO DE REGISTRO CIVIL - DISTRITO DE CANATIBA', 144402, 2919801, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12950, 8176, 'MACAUBAS - CART. REG. IMOVEIS', 11403, 2919801, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12951, 224, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6346, 2919900, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12952, 8177, 'TABELIOANTO DE NOTAS C/ FUNCOES PROTESTO DE TITULOS', 13631, 2919900, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12953, 8178, 'REGISTRO DE IMOVEIS E HIP. TIT. E DOCUMENTOS', 13011, 2919900, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12954, 8179, 'REG. CIVIL C/ FUNC NOTARIAIS - MAIQUINIQUE', 135319, 2920007, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12955, 15, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6361, 2920106, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12956, 8180, 'REG CIVIL C/ FUNC DE PROTESTO - DISTR. ANGICO', 131664, 2920106, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12957, 8181, 'TABELIONATO DE NOTAS', 13870, 2920106, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12958, 8182, 'CARTORIO DE REGISTRO DE IMOVEIS', 7401, 2920106, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12959, 14, 'REG. CIVIL C/ FUNC NOTARIAIS - VARZEA DA ROCA', 135327, 2920106, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12960, 8183, 'TABELIONATO DE NOTAS', 13888, 2920205, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12961, 8184, 'MALHADA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE IUIU', 143701, 2920205, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12962, 284, 'CARTORIO DE REGISTRO DAS PESSOAS NATURAIS DE MALHADA-BAHIA', 7344, 2920205, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12963, 8185, 'REG. CIVIL C/ FUNC NOTARIAIS - CANABRAVA', 135335, 2920205, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12964, 16, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS DO DISTRITO JUDICIARIO DE PARATECA', 6254, 2920205, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12965, 8186, 'MALHADAS - REGISTRO DE IMOVEI, HIP. TIT, DOCUMENTOS E P. JURIDICAS', 11429, 2920205, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12966, 936, 'CARTORIO REGISTRO CIVIL COM FUNCOES NOTARIAIS DE MALHADA DE PEDRAS', 10769, 2920304, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12967, 17, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DO DISTRITO DE CATINGAL', 7138, 2920403, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12968, 226, 'MARACAS - CARTORIO DE REGISTRO CIVIL - DISTRITO DE IBITIQUIRA', 143719, 2920502, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12969, 225, 'REGISTRO CIVIL C/ FUNCOES NOTORIAIS', 11767, 2920502, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12970, 8187, 'REGISTRO DE IMOVEIS HIP. E TIT. E DOCS', 131698, 2920502, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12971, 227, 'REGISTRO CIVIL C/~FUNCOES NOTORIAIS', 11858, 2920502, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12972, 8188, 'TABELIONATO COM FUNCOES DE PROTESTO', 131680, 2920502, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12973, 18, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 131672, 2920502, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12974, 21, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS - NAGE', 12047, 2920601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12975, 228, 'REGISTRO CIVIL C/FUNCOES NOTARIAIS - SAO ROQUE DO PARAGUACU', 135350, 2920601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12976, 20, 'CART.DO REG. CIVIL DAS P.NATURAIS C/FUNCOES NOTARIAIS', 5587, 2920601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12977, 22, 'REGISTRO CIVIL C/FUNCOES NOTARIAIS - GUAPIRA', 11387, 2920601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12978, 8189, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO', 14670, 2920601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12979, 8190, 'CARTORIO DO REGISTRO DE IMOVEIS, HIPOTECAS TITULOS E DOCUMENTOS', 10371, 2920601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12980, 19, 'REGISTRO CIVIL DAS PESSOAS NATURAIS MARAGOGIPE', 12740, 2920601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12981, 8191, 'MARAGOGIPE - CARTORIO DE REGISTRO CIVIL - DISTRITO DE COQUEIROS', 143727, 2920601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12982, 8192, 'REG. CIVIL C/ FUNC NOTARIAIS - PIABANHA', 135376, 2920700, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12983, 8193, 'CARTORIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 8128, 2920700, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12984, 8194, 'REG. CIVIL C/ FUNC NOTARIAIS - IBIACU', 135368, 2920700, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12985, 8195, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 131706, 2920700, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12986, 8196, 'TABELIONATO DE NOTAS C/FUNCOES DE PROTESTO', 14209, 2920700, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12987, 229, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS', 6783, 2920809, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12988, 23, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS ', 9175, 2920809, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12989, 8197, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO DE TITULOS', 14712, 2920809, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12990, 8198, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 7823, 2920809, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12991, 8642, 'SENTO SE - CARTORIO DE REGISTRO CIVIL - DISTRITO DE AMERICO ALVES', 143982, 2930204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12992, 678, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NTURAIS DO DISTRITO DE BOSSOROCA SENTO-SE BAHIA', 9894, 2930204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12993, 8643, 'CARTORIO DO REGISTRO DE IMOVEIS, HIPOTECAS E ANEXOS', 10363, 2930204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12994, 8644, 'REGISTRO CIVIL COM FUNCOES NOTARIAS - AMANIU', 138404, 2930204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12995, 8645, 'CARTORIO DO TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO DE TITULOS DE SERRA DOURADA - BA', 10561, 2930303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12996, 8646, 'REG. CIVIL C/ FUNC NOTARIAIS - TRAIRAS', 132662, 2930303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12997, 679, 'CARTORIO DE REGISTRO CIVIL PESSOAS NATURAIS', 7302, 2930303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12998, 8647, 'REG. CIVIL C/ FUNC NOTARIAIS - TABOCAS DO BREJO VELHO', 132654, 2930303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (12999, 8648, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 7880, 2930303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13000, 8649, 'REG. CIVIL C/ FUNC NOTARIAIS - MOMBACA', 132647, 2930303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13001, 73, 'CARTORIO DO REGISTRO CIVIL  DAS PESSOAS NATURAIS DE SERRA PRETA', 9902, 2930402, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13002, 8650, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS TITULAS E DOCUMENTOS', 7757, 2930402, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13003, 8651, 'TABELIONATO DE NOTAS DE SERRA PRETA', 14902, 2930402, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13004, 680, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS DE ANGUERA', 11908, 2930402, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13005, 683, 'REG. CIVIL C/ FUNC. NOTARIAIS - BIRITINGA', 137513, 2930501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13006, 8652, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS E TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS DA COMARCA DE SERRINHA-BAHIA', 7708, 2930501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13007, 682, 'REG. CIVIL C/ FUNCAO NOTARIAIS - BARROCAS', 136424, 2930501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13008, 681, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 7039, 2930501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13009, 8653, 'TABELIONATO DE NOTAS C/FUNCOES PROTESTO', 14241, 2930501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13010, 74, 'REGISTRO CIVIL DA PESSOAS NATURAIS', 12138, 2930600, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13011, 8654, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 132688, 2930600, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13012, 8655, 'TABELIONATO DE NOTAS', 13953, 2930600, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13013, 8656, 'TABELIONATO DE NOTAS CUMULADO COM PROTESTO DE TITULOS', 136044, 2930709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13014, 8657, 'REG. CIVIL C/ FUNCOES NOTARIAIS - ARATU', 134015, 2930709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13015, 8658, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 7856, 2930709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13016, 8659, 'SIMOES FILHO - CARTORIO DE REGISTRO CIVIL - DISTRITO DE AGUA COMPRIDA', 144485, 2930709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13017, 7591, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9365, 2930709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13018, 8660, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 139030, 2930774, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13019, 8661, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS TITULOS E DOCUMENTOS', 7781, 2930774, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13020, 8662, 'TABELIONATO DE NOTAS C/ FUNCOES DE PROTESTO', 14050, 2930774, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13021, 684, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS ', 9373, 2930808, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13022, 8663, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS DA COMARCA DE SOUTO SOARES BAHIA', 15115, 2930808, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13023, 8664, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS', 10256, 2930808, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13024, 685, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS', 11957, 2930907, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13025, 686, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9191, 2931004, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13026, 8665, 'CARTORIO DE REGISTRO DE IMOEIS E HIPOTECAS E TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS', 7351, 2931004, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13027, 687, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS', 9670, 2931004, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13028, 8666, 'CARTORIO DO TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO', 10595, 2931004, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13029, 906, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE POCO COMPRIDO- CARTORIO COSTA MACHADO', 137000, 2306801, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13030, 905, 'OFICIO DE NOTAS E REGISTROS DE JAGUARIBARA - CARTORIO PAULA CLOTILDE', 20628, 2306801, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13031, 8873, 'CARTORIO DO 2.º OFICIO', 17590, 2306900, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13032, 910, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE FEITICEIRO', 130534, 2306900, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13033, 907, 'CARTORIO DO 1.º OFICIO', 17293, 2306900, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13034, 909, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE NOVA FLORESTA', 18978, 2306900, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13035, 908, 'CARTORIO DE REGISTRO CIVIL DE MAPUA', 16972, 2306900, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13036, 8874, 'CARTORIO DO 2º OFICIO DE REGISTRO DE IMOVEIS', 17764, 2307007, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13037, 911, 'CARTORIO DE REGISTRO CIVIL DISTRITO GIQUI ', 17012, 2307007, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13038, 952, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE BORGES', 18838, 2307007, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13039, 951, 'CARTORIO DO 1º OFICIO', 17350, 2307007, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13040, 953, 'CARTORIO DO 1º OFICIO REGISTRO CIVIL', 17582, 2307106, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13041, 954, 'CARTORIO DO REGIDTRO CIVIL', 18192, 2307106, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13042, 8875, 'CARTORIO JULIO LOSSIO - 2º OFICIO', 19489, 2307106, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13043, 7643, 'CARTORIO DE OFICIO DE NOTAS DE JACUIPE-AL', 2451, 2703502, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13044, 97, 'CARTORIO DO UNICO OFICIO DE JAPARATINGA', 3228, 2703601, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13045, 1367, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE JARAMATAIA', 2782, 2703700, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13046, 98, 'REGISTRO CIVIL E NOTAS', 144550, 2703759, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13047, 1368, 'CARTORIO DE REGISTRO DE CIVIL DE JOAQUIM GOMES', 2428, 2703809, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13048, 7644, 'HERBER REGO LOUREIRO', 3343, 2703809, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13049, 7645, 'CARTORIO DO REGISTRO CIVIL', 149880, 2703908, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13050, 7646, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 149872, 2703908, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13051, 7647, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 149864, 2703908, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13052, 99, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE JUNDIA', 2642, 2703908, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13053, 7648, 'JUNQUEIRO CARTORIO DO UNICO OFICIO', 3368, 2704005, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13054, 100, 'REGISTRO CIVIL DE PESSOAS NATURAIS DE JUNQUEIRO', 3558, 2704005, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13055, 457, 'REGISTRO CIVIL DE PESSOAS NATURAIS E NOTAS DE LAGOA DA CANOA', 3616, 2704104, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13056, 7649, 'CARTORIO DO UNICO OFICIO DE LAGOA DA CANOA', 3236, 2704104, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13057, 1369, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 2394, 2704203, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13058, 7650, 'CARTORIO DO UNICO OFICIO', 3178, 2704203, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13059, 7651, 'ALAGOAS CARTORIO DO 2º OFICIO DE NOTAS', 1990, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13060, 7652, 'ALAGOAS CARTORIO 6º OFICIO', 1966, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13061, 7653, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DO DISTRITO DE BENEDITO BENTES', 149550, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13062, 7654, 'ALAGOAS CARTORIO 1 OFICIO DE PROTESTOS E NOTAS', 1941, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13063, 7655, 'ALAGOAS 2º CARTORIO DO REGISTRO GERAL DE IMOVEIS E HIPOTECAS', 1925, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13064, 458, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DO 3 DISTRITO', 2279, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13065, 7656, '2º CARTORIO DE PROTESTOS BEL CARLOS GONZAGA BREDA', 1826, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13066, 7657, '1º CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS DE MACEIO', 1735, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13067, 1373, '5º SERVICO REGISTRAL E NOTARIAL DE MACEIO', 2840, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13068, 7658, 'QUINTO SERVICO DE NOTAS', 3434, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13069, 1372, 'CARTORIO DO REGISTRO CIVIL DE NASCIMENTO E OBITOS DO 1 DISTRO DE MACEIO', 2816, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13070, 7659, 'ALAGOAS CARTORIO DO 3º OFICIO DE NOTAS', 2006, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13071, 7660, '3 REGISTRO DE IMOVEIS E HIPOTECAS DE MACEIO E OFICIO DE DISTRIBUICAO DE PROTESTOS DE TITULOS DE CREDITO', 1891, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13072, 1371, 'CARTORIO DO 4º DISTRITO DE FLORIANO PEIXOTO', 2550, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13073, 7661, '4º OFICIO DE NOTAS E REGISTRO DE  TITULOS E DOCUMENTOS E DE PESSOAS JURIDICAS DE MACEIO - AL', 1917, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13074, 102, 'SEXTO OFICIO DE REGISTRO CIVIL E NOTAS DE MACEIO - AL ', 4028, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13075, 101, 'CARTORIO DO REGISTRO CIVIL E NOTAS 2º DISTRITO', 2949, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13076, 7662, '2 CARTORIO DE TITULOS E DOCUMENTOS', 1792, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13077, 1370, 'CARTORIO DO REGISTRO CIVIL DOS CASAMENTOS E DAS CAUSAS MATRIMONIAIS', 2873, 2704302, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13078, 104, 'CARTORIO DE REGSITRO CIVIL', 2444, 2704401, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13079, 7663, 'CARTORIO DO REG. CIVIL E NOTAS', 149740, 2704401, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13080, 103, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 2907, 2704401, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13081, 7664, 'RIVALDO MENEZES DOS ANJOS', 149732, 2704401, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13082, 7665, 'SERVICO NOTARIAL E REGISTRAL ', 3798, 2704401, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13083, 105, 'CARTORIO DE REGISTRO CIVIL', 2154, 2704401, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13084, 7666, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 149898, 2704401, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13329, 371, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 10835, 2915304, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13085, 106, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS DE MAR VERMELHO', 2824, 2704906, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13086, 107, 'REGISTRO CIVIL DA COMARCA DE MARAGOGI', 3475, 2704500, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13087, 1374, 'REGISTRO CIVIL DE PESSOAS NATURAIS E NOTAS DE BARRA GRANDE', 3574, 2704500, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13088, 7667, 'UNICO OFICIO DE NOTAS E REGISTRO DE IMOVEIS', 1743, 2704500, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13089, 7668, 'SERVICO NOTARIAL E REGISTRAL', 3806, 2704609, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13090, 7669, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS - DISTRITO DE VARZEAS DE DONA JOANA', 144592, 2704609, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13091, 108, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 2691, 2704609, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13092, 1375, 'CARTORIO DE REGISTRO CIVIL DE MARECHAL DEODORO', 2261, 2704708, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13093, 7670, 'SERVICO NOTARIAL E REGISTRAL DE MARECHAL DEODORO - AL', 3871, 2704708, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13094, 7998, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO', 14605, 2909802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13095, 1405, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9332, 2909802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13096, 7999, 'TABELIONATO DE NOTAS C/FUNC. DE PROTESTO', 14126, 2909901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13097, 1407, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS', 6163, 2909901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13098, 1406, 'CURACA/DISTRITO DE POCO DE FORA - REGISTRO CIVIL C/ FUNC.NOTARIAIS', 11130, 2909901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13099, 8000, 'CARTORIO DE REGISTRO DE IMOVEIS, HIPOTECAS E ANEXO', 8011, 2909901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13100, 7174, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS C/FUNCOES NOTARIAIS DISTRITO DE BARRO VERMELHO', 7062, 2909901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13101, 6908, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 7005, 2909901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13102, 8001, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS', 11981, 2909901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13103, 1408, 'REG. CIVIL C/ FUNC NOTARIAIS - DISTRITO DARIO MEIRA', 131573, 2910008, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13104, 8002, 'TABELIONATO COM PROTESTO ', 13664, 2910057, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13105, 942, 'CARTORIO DE REGISTRO CIVIL', 5942, 2910057, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13106, 1409, 'CARTORIO REG. IMOVEIS HIP. TIT. DOCUMENTOS', 10728, 2910057, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13107, 7465, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS', 6080, 2910107, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13108, 8003, 'ENCRUZILHADA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE RIBEIRAO DO LAGO', 143537, 2910404, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13109, 8004, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14423, 2910404, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13110, 8005, 'REG. CIVIL C/ FUNC NOTARIAIS - NOVA BRASILIA', 134825, 2910404, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13111, 8006, 'REGISTRO DE IMOVEIS  HIPOTECAS TITULOS E DOCUMENTOS', 12955, 2910404, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13112, 8007, 'REG. CIVIL C/ FUNC NOTARIAIS - CAPINARANA', 134817, 2910404, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13113, 1325, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6528, 2910404, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13114, 1326, 'CARTORIO DO REGISTRO CIVIL DISTRITO DE SUBAUMA', 9910, 2910503, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13115, 1327, 'CARTORIO DO REGISTRO CIVIL COM F/NOTARIAIS DISTRITO DE CARDEAL DA SILVA-BA', 143545, 2910503, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13116, 943, 'CARTORIO DE REGISTRO CIVIL PESSOAS NATURAIS DISTRITO DE IBATUI', 7310, 2910503, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13117, 8008, 'TABELIONATO C/ FUNC DE PROTESTO', 134833, 2910503, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13118, 6621, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9506, 2910503, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13119, 8009, 'CARTORIO REGISTRO DE IMOVIS E HIP. TIT E DOCUMENTOS', 11031, 2910503, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13120, 945, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9233, 2910602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13121, 8010, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 15099, 2910602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13122, 944, 'REG. CIVIL C/ FUNC NOTARIAIS - SAO JOSE DO MUCAMBO', 134858, 2910602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13123, 8011, 'CARTORIO DE REGISTRO DE IMOVEIS HIPOTECAS TITULOS E DOCUMENTOS PESSOAS JURIDICAS DA COMARCA DE ESPLANADA -BA', 7989, 2910602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13124, 8012, 'TABELIONATO DE NOTAS', 13987, 2914000, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13125, 8013, 'REG. CIVIL C/ FUNC NOTARIAIS - IRAJUBA', 132514, 2914208, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13126, 8014, 'REGISTRO DE IMOVEIS, HIP, E TIT E DOCS', 131508, 2914307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13127, 8015, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 131490, 2914307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13128, 8016, 'REG. CIVIL C/ FUNC NOTARIAIS - DISTRITO DE NOVO ACRE', 131532, 2914307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13129, 8017, 'TABELIONATO COM FUNC DE PROTESTO', 131524, 2914307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13130, 8018, 'CARTORIO DO REGISTRO DE IMOVEIS E ANEXOS', 10108, 2914406, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13131, 358, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO IRAPORANGA', 12302, 2914406, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13132, 8019, 'TABELIONATO DE NOTAS', 13763, 2914406, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13133, 359, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12401, 2914406, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13134, 183, 'IRARA/DIST.OURICANGAS-REG CIVIL C/FUN NOTARIAIS', 11254, 2914505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13135, 269, 'IRARA/DIST.BENTO SIMOES-REG CIVIL C/ FUN NOTARIAIS', 11247, 2914505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13136, 266, 'IRARA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE PEDRAO', 143602, 2914505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13137, 8020, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS/TIT.DOC E PESSOAS JURID.', 7914, 2914505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13138, 361, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ AGUA FRIA', 140939, 2914505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13139, 8021, 'IRARA/TABELIONATO DE NOTAS C/FUNC.DE PROTESTO', 11296, 2914505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13140, 267, 'REG. CIVIL C/ FUNC NOTARIAIS - PATAIBA', 135095, 2914505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13141, 360, 'IRARA - REGISTRO CIVIL', 11213, 2914505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13142, 8022, 'TABELIONATO 2º OFICIO DE NOTAS', 133462, 2914604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13143, 300, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6577, 2924058, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13144, 42, 'IRARA/DISTRITO DE PEDRAO - REGISTRO CIVIL C/FUN NOTARIAS', 11270, 2924108, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13145, 43, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 138263, 2924306, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13146, 8464, 'TABELIONATO DE NOTAS C/ FUNCOES DE PROTESTO DA COMARCA DE PIATA', 153478, 2924306, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13147, 301, 'REG. CIVIL C/ FUNC NOTARIAIS - INUBIA', 132118, 2924306, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13148, 8465, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS.', 138479, 2924306, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13149, 8466, 'REG. CIVIL C/ FUNC NOTARIAIS - IMBUIA', 132100, 2924306, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13150, 44, 'REG. CIVIL C/ FUNC NOTARIAIS - CABRALIA', 138354, 2924306, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13151, 47, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE VILA BALUARTE', 6882, 2924405, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13152, 8467, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS ', 7526, 2924405, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13153, 46, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE VILA BREJO DA SERRA', 6890, 2924405, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13154, 8468, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTOS', 14753, 2924405, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13155, 45, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 10868, 2924405, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13156, 302, 'REGISTRO CIVIL DAS PESSOAS NATURAIS - DISTRITO VILA SALDANHA', 12567, 2924405, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13157, 50, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO', 14662, 2924504, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13158, 49, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 7047, 2924504, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13159, 8469, 'REG. CIVIL C/ FUNC PROTESTO - BONITO', 132159, 2924504, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13160, 48, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS', 7534, 2924504, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13161, 6912, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES DE PROTESTOS', 6767, 2924504, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13162, 51, 'CARTORIO DE REGISTRO CIVIL E NOTAS DO DISTRIITO DE BANANEIRAS', 7260, 2924603, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13163, 251, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6684, 2924603, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13164, 8470, 'REG. CIVIL C/ FUNC NOTARIAIS - VARZEA GRANDE', 132167, 2924603, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13165, 8471, 'REGISTRO DE IMOVEIS DE PINDOBACU', 12971, 2924603, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13166, 303, 'CARTORIO DE REGISTRO CIVIL E NOTAS DO DISTRITO DE CARNAIBA', 7278, 2924603, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13167, 8472, 'TABELIONATO DE NOTAS C/FUNCOES DE PROTESTO', 14217, 2924603, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13168, 7564, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS', 8805, 2924652, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13169, 723, 'ITUBERA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE PIRAI DO NORTE', 143677, 2924678, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13170, 52, 'REG. CIVIL C/ FUNC NOTARIAIS - PIRIPA', 134726, 2924702, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13171, 8473, 'REG. CIVIL C/ FUNC NOTARIAIS - PORTO FELIZ', 132191, 2924801, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13172, 8474, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS TITULOS E DOCUMENTOS', 10215, 2924801, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13173, 304, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS', 12104, 2924801, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13174, 305, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12435, 2924801, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13175, 306, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS', 6122, 2924801, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13176, 8475, 'TABELIONATO DE NOTAS E PROTESTOS', 15149, 2924801, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13177, 8476, 'CARTORIO DE REGISTRO DE IMOVEIS', 7450, 2925006, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13178, 252, 'REG. CIVIL C/ FUNC NOTARIAIS - LUCAIA', 132217, 2925006, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13179, 8477, 'TABELIONATO C FUNC PROTESTO', 132209, 2925006, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13180, 307, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12070, 2925006, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13181, 308, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 138313, 2925105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13182, 8478, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS.', 139212, 2925105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13183, 8479, 'REG. CIVIL C/ FUNC NOTARIAIS - CALDEIRAO', 132241, 2925105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13184, 8480, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ BOM JESUS DA SERRA', 139139, 2925105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13185, 8481, 'REG. CIVIL C/ FUNC NOTARIAIS - ALEGRE', 132233, 2925105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13186, 8482, 'TABELIONATO DE NOTAS CUMULADO COM PROTESTO DA COMARCA DE POCOES-BA', 138495, 2925105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13187, 8483, 'REG. CIVIL C/ FUNC NOTARIAIS - AGUA BELA', 132225, 2925105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13188, 8484, 'POCOES - CARTORIO DE REGISTRO CIVIL - DISTRITO DE VISTA NOVA', 143917, 2925105, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13189, 53, 'REGISTROS CIVIL E PESSOAS NATURAIS', 13433, 2925204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13190, 8485, 'CARTORIO DE REGISTROS DE IMOVEIS, TITULOS E DOCUMENTOS', 8227, 2925204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13191, 8486, 'REG. CIVIL C/ FUNC NOTARIAIS - MIRANGA', 132258, 2925204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13192, 8487, 'CARTORIO TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 11064, 2925204, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13193, 8876, 'CARTORIO SILVA BRITO - 2º OFICIO', 20164, 2307205, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13194, 955, 'CARTORIO SILVA - 1º OFICIO', 20156, 2307205, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13195, 8877, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE JERICOACOARA', 137919, 2307254, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13196, 956, 'CE181004', 20313, 2307254, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13197, 8878, 'CARTORIO DO 3º OFICIO', 17822, 2307304, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13198, 6929, 'CARTORIO PARIZ', 19885, 2307304, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13199, 959, 'CARTORIO DE REGISTRO CIVIL E PESSOAS NATURAIS (CARTORIO PADRE CICERO)', 17210, 2307304, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13200, 8879, 'CARTORIO MACHADO 2º OFICIO', 19562, 2307304, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13201, 958, 'SERVENTIA LUIZ MACHADO', 20883, 2307304, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13202, 957, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS DO DISTRITO DE MARROCOS', 18606, 2307304, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13203, 8880, 'CARTORIO 5º OFICIO DE JUAZEIRO DO NORTE', 16121, 2307304, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13204, 961, 'CARTORIO DO DISTRITO DE CANAFISTULA', 17988, 2307403, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13205, 960, 'CARTORIO DO 1º OFICIO', 17319, 2307403, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13206, 962, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE MEL', 135855, 2307403, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13207, 8881, 'CARTORIO FERNANDES DO 2º OFICIO', 19331, 2307403, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13208, 966, 'CARTORIO DE REGISTRO CIVIL - DISTRITO QUITAIUS', 135871, 2307502, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13209, 968, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE MANGABEIRA', 18945, 2307502, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13210, 964, 'CARTORIO AMANCIO', 16188, 2307502, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13211, 967, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE IBOREPI', 18911, 2307502, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13212, 8882, 'CARTORIO FERRER 2º OFICIO', 19349, 2307502, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13213, 965, 'CARTORIO MACEDO - 1º OFICIO', 19729, 2307502, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13214, 963, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE ARROJADO', 18804, 2307502, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13215, 8883, 'LIMOEIRO DO NORTE CARTORIO DO 2º OFICIO', 20479, 2307601, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13216, 6930, 'CARTORIO DO 1º OFICIO DE NOTAS E DE REGISTRO', 17467, 2307601, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13217, 8884, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE MACAOCA', 137018, 2307635, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13218, 969, 'CARTORIO ASSIS BEZERRA', 16253, 2307635, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13219, 971, 'OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 20636, 2307650, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13220, 8885, '2 OFICIO DE REGISTRO DE IMOVEIS 2 ZONA DA COMARCA DE MARACANAU CEARA', 15594, 2307650, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13221, 8886, 'MARACANAU 2 CARTORIO DE NOTAS E REGISTROS PUBLICOS', 20487, 2307650, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13222, 8887, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE PAJUCARA ', 154112, 2307650, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13223, 970, '1º NOTARIADO E 1º OFICIO DE REGISTRO DA COMARCA DE MARACANAU-CE', 15537, 2307650, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13224, 8888, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE LAGES', 135889, 2307700, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13225, 972, 'CARTORIO DE REGISTRO CIVIL DE ITAPEBUSSU', 16949, 2307700, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13226, 8889, 'MARANGUAPE CARTORIO 2º OFICIO DE NOTAS', 20495, 2307700, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13227, 976, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE SAPUPARA', 18283, 2307700, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13228, 974, 'CARTORIO DO 1º OFICIO DA COMARCA DE MARANGUAPE', 17392, 2307700, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13229, 975, 'CARTORIO DO REGISTRO CIVIL - DISTRITO DE AMANARI. NOME FANTASIA: (CARTORIO FRANCISCO SILVA)', 19372, 2307700, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13230, 7512, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE TANQUES', 146423, 2307700, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13231, 973, 'CARTORIO DO REGISTRO CIVIL DE JUBAIA', 18481, 2307700, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13232, 8890, 'CARTORIO DO 2º OFICIO - REGISTRO DE IMOVEIS', 17681, 2307809, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13233, 978, 'CARTORIO DO REGISTRO CIVIL DE PANACUI', 18556, 2307809, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13234, 977, 'MARCO CARTORIO DO PRIMEIRO OFICIO', 20503, 2307809, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13235, 8891, 'CARTORIO 2° OFICIO - REGISTRO DE IMOVEIS', 16006, 2307908, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13236, 979, 'CARTORIO DE 1° OFICIO PEREIRA', 16444, 2307908, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13237, 8892, 'CARTORIO DE 2° OFICIO DE REGISTRO DE IMOVEIS', 135897, 2308005, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13238, 982, 'CARTORIO DO 1º OFICIO REG CIVIL', 17574, 2308005, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13239, 8893, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE AIUA', 135913, 2308005, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13240, 981, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE PADRE LINHARES', 18994, 2308005, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13241, 8894, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE TUINA', 135905, 2308005, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13242, 980, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE MUMBABA', 16824, 2308005, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13243, 8895, 'CARTORIO DO 2º OFICIO CHAGAS SAMPAIO', 17707, 2308104, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13244, 6855, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE UMBURANAS', 17178, 2308104, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13245, 152, 'CARTORIO DO REGISTRO DO DISTRITO DE COITE', 19190, 2308104, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13246, 7671, 'SERVENTIA EXTRAJUDICIAL DA COMARCA DE ACRELANDIA', 153841, 1200013, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13247, 7672, 'SERVICO EXTRAJUDICIAL DE ASSIS BRASIL', 153999, 1200054, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13248, 7673, 'SERVENTIA DE REGISTRO DE IMOVEIS DA COMARCA DE BRASILEIA-AC', 1164, 1200104, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13249, 7674, 'SERVICO NOTARIAL E REGISTRAL DA COMARCA DE BRASILEIA', 153817, 1200104, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13250, 7675, 'TABELIONATO DE NOTAS DA COMARCA DE BRASILEIA-AC', 1545, 1200104, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13251, 7676, 'SERVENTIA DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS DE BRASILEIA-AC', 1362, 1200104, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13252, 1332, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE BRASILEIA-AC', 1081, 1200104, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13253, 7677, 'TABELIONATO DE PROTESTO DE TITULOS DE BRASILEIA-AC', 1651, 1200104, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13254, 541, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE BUJARI', 1032, 1200138, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13255, 7678, 'CARTORIO BANDEIRA: SERVENTIAS EXTRAJUDICIAIS DA COMARCA DE BUJARI', 154377, 1200138, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13256, 7679, 'SERVICOS EXTRAJUDICIAIS DE CAPIXABA', 154393, 1200179, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13257, 1333, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE CRUZEIRO DO SUL', 828, 1200203, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13258, 7680, 'TABELIONATO DE PROTESTO DE TITULOS DE CRUZEIRO DO SUL', 1669, 1200203, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13259, 7681, 'SERVENTIA DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS DE CRUZEIRO DO SUL', 1370, 1200203, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13260, 7682, 'SERVENTIA DE REGISTRO DE IMOVEIS DE CRUZEIRO DO SUL', 1222, 1200203, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13261, 7683, 'TABELIONATO DE NOTAS DA COMARCA DE CRUZEIRO DO SUL', 1552, 1200203, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13262, 7684, 'SERVENTIA EXTRAJUDICIAL DA COMARCA DE EPITACIOLANDIA', 153908, 1200252, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13263, 544, 'SERVENTIAS EXTRAJUDICIAIS DA COMARCA DE FEIJO', 1446, 1200302, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13264, 545, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE JORDAO', 992, 1200328, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13265, 7685, 'SERVENTIA EXTRAJUDICIAL DA COMARCA DE MANCIO LIMA', 153924, 1200336, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13266, 7686, 'SERVENTIA DE REGISTRO DE TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS DA COMARCA DE MANUEL URBANO', 1339, 1200344, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13267, 7687, 'TABELIONATO DE NOTAS DA COMARCA DE MANUEL  URBANO', 1560, 1200344, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13268, 7688, 'SERVENTIA DE REGISTRO DE IMOVEIS DA COMARCA DE MANUEL URBANO', 1206, 1200344, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13269, 1334, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE MANUEL URBANO', 1057, 1200344, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13270, 7689, 'CARTORIO REGISTRO DE PROTESTTO DE TITULOS CAMBIAIS DA COMARCA DE MANOEL URBANO ', 810, 1200344, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13271, 1335, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE MARECHAL THAUMATURGO', 844, 1200351, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13272, 7690, 'SERVENTIA EXTRAJUDICIAL DA COMARCA DE PLACIDO DE CASTRO', 153858, 1200385, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13273, 547, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE PORTO ACRE', 1453, 1200807, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13274, 7691, 'SERVENTIA EXTRAJUDICIAL DA COMARCA DE PORTO ACRE', 153932, 1200807, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13275, 1337, 'SERVENTIA DE REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE PORTO WALTER', 919, 1200393, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13276, 7692, '1º TABELIONATO DE PROTESTO DE TITULOS DA COMARCA DE RIO BRANCO ', 154419, 1200401, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13277, 1340, '1º TABELIONATO DE NOTAS E 1º OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E POSTOS AVANCADOS DA COMARCA DE RIO BRANCO', 760, 1200401, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13278, 1342, '2º TABELIONATO DE NOTAS E 2º OFICIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE RIO BRANCO', 152843, 1200401, 'AC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13279, 109, 'CARTORIO DO REGISTRO CIVIL DE MARIBONDO', 2790, 2704807, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13280, 7693, 'NOTAS E REGISTROS DO UNICO OFICIO', 3400, 2704807, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13281, 7694, 'NOTAS E REGISTRO DO UNICO OFICIO', 3384, 2705002, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13282, 110, 'REGISTRO CIVIL E NOTAS DA COMARCA DE MATA GRANDE', 3186, 2705002, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13283, 111, 'CARTORIO DO REGISTRO CIVIL E NOTAS DAS PESSOAS NATURAIS ', 2956, 2705101, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13284, 7695, 'ALAGOAS CARTORIO DE IMOV HIP TIT E NOTAS', 1974, 2705101, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13285, 112, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 2162, 2705200, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13286, 362, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 136697, 2914604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13287, 8023, 'REG. CIVIL C/ FUNC NOTARIAIS - ITAPICURU', 133496, 2914604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13288, 8024, 'TABELIONATO 1º OFICIO DE NOTAS', 133454, 2914604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13289, 8025, 'REGISTRO DE IMOVEIS - 2º OFICIO', 136689, 2914604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13290, 8026, 'REG. CIVIL C/ FUNC NOTARIAIS - CONQUISTA', 133488, 2914604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13291, 8027, 'REGISTRO DE TITULOS E DOCUMENTOS', 133447, 2914604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13292, 8028, 'TABELIONATO DE PROTESTO DE TITULOS', 136218, 2914604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13293, 8029, 'REG. CIVIL C/ FUNC NOTARIAIS - ANGICAL', 133470, 2914604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13294, 8030, 'REGISTRO DE IMOVEIS E HIPOTECAS DO 1º OFICIO', 136200, 2914604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13295, 7595, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DE ITABELA - BAHIA', 6825, 2914653, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13296, 8031, 'CARTORIO DE REGISTRO DE IMOVEIS, HIPOTECAS E TITULOS E DOCUMENTOS', 8029, 2914653, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13297, 8032, 'CARTORIO DE TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 8292, 2914653, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13298, 8033, 'TABELIONATO DO 1º OFICIO DE NOTAS', 140079, 2914703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13299, 8034, 'REGISTRO DE TITULOS E DOCUMENTOS', 133504, 2914703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13300, 8035, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS. ', 140046, 2914703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13301, 8036, 'REGISTRO DE IMOVEIS DO 2º OFICIO DO DISTRITO-SEDE DA COMARCA DE ITABERABA', 154070, 2914703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13302, 363, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 140020, 2914703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13303, 8037, 'TABELIONATO DO 2º OFICIO DE NOTAS ', 140434, 2914703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13304, 8038, 'PROTESTO DE TITULOS', 136721, 2914703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13305, 365, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 1º OFICIO DA COMARCA DE ITABUBA-BA', 6874, 2914802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13306, 8039, 'TABELIONATO DE PROTESTO DE TITULOS', 15206, 2914802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13307, 366, 'CARTORIO DE REGISTRO CIVIL-2.OFICIO', 7328, 2914802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13308, 364, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE FERRADAS', 5983, 2914802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13309, 8040, 'TABELIONATO DE NOTAS - 2º OFICIO', 14977, 2914802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13310, 8041, 'CARTORIO DE REGISTRO DE IMOVEIS DO 1º OFICIO', 7476, 2914802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13311, 8042, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E REG. CIVIL DAS PESSOAS JURIDICAS (TJBA)', 8193, 2914802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13312, 8043, 'TABELIONATO DO 1º OFICIO DE NOTAS DE ITABUNA-BAHIA', 14969, 2914802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13313, 8044, '3º OFICIO DE NOTAS', 5421, 2914802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13314, 8045, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS -2º OFICIO', 7609, 2914802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13315, 8046, 'TABELIONATO COM FUNCAO DE PROTESTO', 131540, 2914901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13316, 8047, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 137372, 2914901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13317, 8048, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS', 135723, 2914901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13318, 8049, 'REG. CIVIL C/ FUNC NOTARIAIS - TABOQUINHAS', 135574, 2914901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13319, 8050, 'CARTORIO DE REGISTRO DE IMOVEIS', 7393, 2915007, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13320, 367, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 9860, 2915007, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13321, 8051, 'TABELIONATO DE NOTAS', 13862, 2915007, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13322, 8052, 'TABELIONATO DE NOTAS', 13805, 2915106, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13323, 368, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS', 9852, 2915106, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13324, 8053, 'CARTORIO DO REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E CIVIL DAS PESSOAS JURIDICAS', 10405, 2915106, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13325, 8054, 'TABELIONATO COM FUNCAO DE PROTESTO', 131557, 2915205, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13326, 370, 'ITAGIBA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE JAPOMIRIM', 143610, 2915205, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13327, 8055, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 137265, 2915205, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13328, 369, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 137174, 2915205, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13330, 8056, 'REGISTRO DE IMOVEIS E ANEXOS', 12997, 2915304, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13331, 8057, 'TABELIONATO DE NOTAS C/F DE PROTESTO', 14100, 2915304, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13332, 6622, 'REGISTRO CIVIL C/FUNC. NOTARIAIS', 143644, 2915403, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13333, 8058, 'CARTORIO DE REGISTRO DE IMOVEIS, TITULOS, HIPOTECAS E DOCUMENTOS', 8136, 2915502, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13334, 372, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS', 6007, 2915502, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13335, 8059, 'TABELIONATO COM FUNCAO DE PROTESTO', 140319, 2915502, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13336, 373, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 135111, 2915502, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13337, 8060, 'ITAMARAJU - CARTORIO DE REGISTRO CIVIL - DISTRITO DE JUCURUCU', 144311, 2915601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13338, 8061, 'TABELIONATO C/ FUNCAO DE PROTESTO', 133538, 2915601, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13339, 8488, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS E PESSOAS JURIDICAS', 138073, 2925303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13340, 54, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 136804, 2925303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13341, 8489, 'TABELIONATO C/ FUNC. DE PROTESTO', 137612, 2925303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13342, 8490, 'REG. CIVIL C/ FUNCOES NOTARIAIS - TRANCOSO', 133751, 2925303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13343, 6913, 'REG. CIVIL C/ FUNCAO NOTARIAIS - VALE VERDE', 136887, 2925303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13344, 8491, 'REG. CIVIL C/ FUNCOES NOTARIAIS - ARRAIAL DAJUDA', 133744, 2925303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13345, 724, 'REG. CIVIL C/ FUNCOES NOTARIAIS - CARAIVA', 136846, 2925303, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13346, 55, 'REG. CIVIL C/ FUNC NOTARIAIS - GURUPA-MIRIM', 132282, 2925402, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13347, 8492, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS', 132274, 2925402, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13348, 604, 'REG CIVIL DAS PESSOAS NATURAIS', 132266, 2925402, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13349, 8493, 'TABELIONATO COM FUNCAO DE PROTESTO', 138172, 2925402, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13350, 8494, 'REG. CIVIL C/ FUNC NOTARIAIS - SAO JOSE DO PRADO', 132308, 2925501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13351, 253, 'REGISTRO CIVIL DAS PESSOA NATURAIS', 12153, 2925501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13352, 8495, 'REG. CIVIL C/ FUNC NOTARIAIS - CACHOEIRA DO MATO', 132290, 2925501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13353, 8496, 'TABELIONATO DE NOTAS E PROTESTOS - 1º OFICIO', 15156, 2925501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13354, 605, 'REGISTRO CIVIL DE PESSOAS NATURAIS', 12807, 2925501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13355, 8497, 'REG. CIVIL C/ FUNC. NOTARIAIS - CUMURUXATIBA', 138289, 2925501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13356, 8498, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS', 7559, 2925501, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13357, 8499, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS', 132316, 2925600, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13358, 56, 'PRESIDENTE DUTRA - REGISTRO CIVIL', 11593, 2925600, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13359, 8500, 'CARTORIO DE TAB. DE NOTAS C/ FUNCAO DE PROTESTO', 8276, 2925600, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13360, 8501, 'REG. CIVIL C/ FUNC NOTARIAIS - CAMPO FORMOSO', 132332, 2925600, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13361, 8502, 'REGISTRO DE IMOVEIS TIT DOC E DAS PES JURIDICAS', 11676, 2925709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13362, 8503, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 141085, 2925709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13363, 8504, 'REG. CIVIL C/ FUNC NOTARIAIS - MAETINGA', 132365, 2925709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13364, 8505, 'TABELIONATO COM FUNCAO DE PROTESTO', 132357, 2925709, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13365, 254, 'REG. CIVIL C/ FUNC. NOTARIAIS - TANCREDO NEVES', 137497, 2925758, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13366, 255, 'CARTORIO REG CIVIL DAS PESSOAS NATURAIS E REG DE INTERDICOES E TUTELAS', 10686, 2925808, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13367, 8506, 'TABELIONATO DE NOTAS C/ FUNCOES DE TABELIAO DE PROTESTO DE TITULOS E DE OF. DE REG. CENT. MARITIMAS', 14076, 2925808, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13368, 8507, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 7849, 2925808, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13369, 7566, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAS COM  FUNCOES NOTARIAIS', 6940, 2925907, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13370, 8508, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS.', 132373, 2925931, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13371, 57, 'RCNP', 11635, 2925931, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13372, 8509, 'TABELIONATO DE NOTAS COM PROTESTO', 149609, 2925931, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13373, 1391, 'REGISTRO CIVIL C/ FUNC NOTARIAIS - RAFAEL JAMBEIRO', 134619, 2925956, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13374, 6700, 'REGISTRO CIVIL C/ FUNC NOTARIAIS - ARGOIM', 134569, 2925956, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13375, 8510, 'REMANSO- TABELIONATO DE NOTAS', 13458, 2926004, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13376, 8511, 'REG. CIVIL C/ FUNCOES NOTARIAIS - PEIXE', 133777, 2926004, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13377, 8512, 'REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS', 13300, 2926004, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13378, 58, 'CARTORIO REGISTRO CIVIL DE PESSOAS NATURAIS', 10934, 2926004, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13379, 8513, 'REG. CIVIL C/ FUNCOES NOTARIAIS - CAMPO ALEGRE LOURDES', 133769, 2926004, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13380, 8514, 'REGISTRO DE IMOVEIS', 12914, 2926103, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13381, 256, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6569, 2926103, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13382, 8515, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO DE TITULOS', 14514, 2926103, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13383, 59, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12245, 2926202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13384, 8516, 'REG. CIVIL C/ FUNC NOTARIAIS - CARIPARE', 132381, 2926202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13385, 8517, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO DE TITULOS', 14704, 2926202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13386, 60, 'CARTORIO REGISTRO CIVIL COM FUNCOES NOTARIAIS', 10785, 2926202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13387, 257, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS', 8797, 2926202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13388, 8518, 'REGISTRO DE IMOVEIS, HIPOTECAS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 13268, 2926202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13389, 606, 'CARTORIO REGISTRO CIVIL PESSOAS NATURAIS', 10983, 2926301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13390, 8519, 'CARTORIO DE REGISTRO DE IMOVEIS E  HIPOTECAS', 7500, 2926301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13391, 701, 'REGISTRO CIVIL', 11718, 2932309, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13392, 8896, 'CARTORIO DO REG. CIVIL DO DISTRITO DE MARAGUA', 146530, 2308104, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13393, 984, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE ANAUA', 18754, 2308104, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13394, 985, 'CARTORIO DO 1º OFICIO', 17384, 2308104, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13395, 8897, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE COITE', 135939, 2308104, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13396, 983, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE MARARUPA', 18952, 2308104, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13397, 8898, 'CARTORIO LEITE SAMPAIO- 3º OFICIO', 19521, 2308104, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13398, 986, 'CARTORIO DO REGISTRO CIVIL DE PALESTINA', 18549, 2308104, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13399, 8899, 'CARTORIO DE OFICIOS E NOTAS DE MERUOCA', 16717, 2308203, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13400, 153, 'CARTORIO DO REGISTRO CIVIL', 18259, 2308302, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13401, 8900, 'CARTORIO BRAGA CASTRO - 2° SERVICO NOTARIAL E REGISTRAL DE MILAGRES - CE', 16329, 2308302, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13402, 987, '1º OFICIO', 15545, 2308302, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13403, 988, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DIST. DE CARNAUBINHA MILHA CEARA', 16980, 2308351, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13404, 8901, 'CARTORIO DE OFICIO DE NOTAS E DE REGISTROS', 16659, 2308351, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13405, 154, 'OFICIO DE NOTAS E DE REGISTROS', 20552, 2308377, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13406, 8902, 'CARTORIO DE REGISTRO CIVIL  DE MISSAO NOVA', 16790, 2308401, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13407, 155, 'CART0RIO DO REGISTRO CIVIL DO DISTRITO DE JAMACARU ', 15883, 2308401, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13408, 8903, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE  QUIMAMI', 135947, 2308401, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13409, 8904, 'SEGUNDO CARTORIO DE REGISTRO DE IMOVEIS DE MISSAO VELHA CE', 20867, 2308401, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13410, 156, 'CARTORIO DO PRIMEIRO  OFICIO DE MISSAO VELHA', 18069, 2308401, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13411, 8905, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE BOA VISTA', 135962, 2308500, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13412, 8906, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE CATOLE', 135954, 2308500, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13413, 989, 'MOMBACA CARTORIO DO PRIMEIRO OFICIO', 20529, 2308500, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13414, 8907, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE CARNAUBA', 135970, 2308500, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13415, 8908, 'MOMBACA 2º  CARTORIO - 2º OFICIO', 20511, 2308500, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13416, 8909, 'CARTORIO TEIXEIRA 2º OFICIO', 20198, 2308609, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13417, 157, 'CARTORIO DO 1º OFICIO DA COMARCA DE MONSENHOR TABOSA CEARA (CARTORIO LEITAO)', 17400, 2308609, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13418, 163, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE BOA AGUA', 17020, 2308708, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13419, 159, 'CARTORIO MOURA SILVA', 19695, 2308708, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13420, 162, 'CARTORIO REGISTRO CIVIL DE JUAZEIRO', 20008, 2308708, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13421, 164, 'CARTORIO HONORATO 1º OFICIO', 19430, 2308708, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13422, 160, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE UIRAPONGA', 19109, 2308708, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13423, 8910, '2º OFICIO- COMARCA DE MORADA NOVA- CE', 15693, 2308708, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13424, 158, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE PEDRAS', 17103, 2308708, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13425, 161, 'CARTORIO DO DISTRITO DE ARUARU', 17970, 2308708, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13426, 165, 'CARTORIO NEVES MARANGUAPE', 19752, 2308807, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13427, 8911, 'CARTORIO DO 2º OFICIO ', 17665, 2308807, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13428, 166, 'OFICIO DE NOTAS E REGISTROS', 20602, 2308906, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13429, 167, '1º OFICIO CARTORIO MAGALHAES', 15560, 2309003, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13430, 8912, 'CARTORIO 2º OFICIO ', 16030, 2309003, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13431, 8913, 'CARTORIO 2ª OFICIO REG. IMOVEIS', 15990, 2309102, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13432, 168, 'CARTORIO 1º OFICIO REG. CIVIL', 15974, 2309102, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13433, 8914, '2º CARTORIO DE NOTAS, PROTESTOS E REG. IMOVEIS ', 15636, 2309201, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13434, 8915, 'CARTORIO 1° OFICIO REGISTRO CIVIL', 135988, 2309201, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13435, 170, 'REGISTRO CIVIL DE MAJOR SIMPLICIO', 20784, 2309300, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13436, 8916, 'CARTORIO DE REGISTRO CIVIL - DISTRITO CANINDEZINHO', 136002, 2309300, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13437, 169, 'CAROTORIO DE REGISTRO CIVIL DE NOVA BETANIA', 20271, 2309300, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13438, 8917, 'CARTORIO CARVALHO SANTANA 2º OFICIO REGISTRO DE IMOVEIS', 16105, 2309300, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13439, 991, 'CARTORIO NOVA RUSSAS - 1º OFICIO DE RCPN E TABELIONATO DE NOTAS', 16295, 2309300, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13440, 990, 'CARTORIO DO REGISTRO CIVIL DE LAGOA DE SAO PEDRO', 18499, 2309300, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13441, 8918, '2° OFICIO - CARTORIO PINHO', 15602, 2309409, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13442, 992, 'CARTORIO DO 1º OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 17509, 2309409, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13443, 993, 'CARTORIO LIMA SILVA', 19547, 2309458, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13444, 994, 'CARTORIO DE REGISTRO CIVIL DE CURUPIRA', 16907, 2309458, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13445, 171, '1º OFICIO CARTORIO DE NOTAS', 15552, 2309508, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13446, 7696, 'CARTORIO DO UNICO OFICIO DE MESSIAS', 3244, 2705200, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13447, 113, 'CARTORIO DO REGISTRO CIVIL DE MINADOR DO NEGRAO', 2808, 2705309, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13448, 114, 'CARTORIO DO REGISTRO CIVIL', 2568, 2705408, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13449, 7697, 'CARTORIO DO REGISTRO DE IMOVEIS', 3038, 2705408, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13450, 7698, '2 OFICIO DE NOTAS E PROTESTOS DE MURICI-ALAGOAS', 1800, 2705507, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13451, 7699, 'CARTORIO 1 OFICIO DE NOTAS E REGISTRO IMOVEIS', 2030, 2705507, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13452, 6461, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 2683, 2705507, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13453, 115, 'CARTORIO DO REGISTRO CIVL E NOTAS', 3020, 2705606, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13454, 7700, 'CARTORIO DO UNICO OFICIO', 3111, 2705606, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13455, 459, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 2386, 2705705, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13456, 7701, 'CARTORIO DE NOTAS E ANEXOS JOSE DORIA DE SOUZA', 2089, 2705705, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13457, 116, 'SERVICOS DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 3988, 2705804, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13458, 117, 'REGISTRO CIVIL DE PESSOAS NATURAIS DE OLHO DAGUA GRANDE', 3566, 2705903, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13459, 118, 'CARTORIO DE REGISTRO CIVIL', 2147, 2706000, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13460, 7702, 'CARTORIO DE NOTAS E REGISTROS GERAIS', 2113, 2706000, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13461, 7703, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DO MUNICIPIO DE OURO BRANCO', 149930, 2706109, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13462, 119, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DO MUNICIPIO DE OURO BRANCO', 3715, 2706109, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13463, 7704, 'SERVICO NOTARIAL E REGISTRAL DE OURO BRANCO-AL', 3921, 2706109, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13464, 7705, 'SERVICO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DO MUNICIPIO DE OURO BRANCO', 149948, 2706109, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13465, 120, 'SERVICO DE REGISTRO CIVIL E NOTAS DE PALESTINA', 3749, 2706208, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13466, 1376, 'CARTORIO DO REGISTRO CIVIL E NOTAS DE CANAFISTULA', 3004, 2706307, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13467, 7706, '1º TABELIONATO DE NOTAS', 1776, 2706307, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13468, 7707, '3º SERVICO NOTARIAL', 1909, 2706307, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13469, 121, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE CALDEIROES DE CIMA', 2246, 2706307, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13470, 1377, 'SERVICO REGISTRAL DE PESSOAS NATURAIS', 3954, 2706307, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13471, 7708, '2º SERVICO NOTARIAL E REGISTRAL', 1867, 2706307, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13472, 460, 'CARTORIO DE REGISTRO CIVIL DA VILA ILHA DO FERRO', 2196, 2706406, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13473, 7709, '1ª SERVENTIA NOTARIAL E REGISTRAL DE PAO DE ACUCAR', 1727, 2706406, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13474, 122, 'CARTORIO REGISTRO CIVIL', 3319, 2706406, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13475, 7710, '2ª SERVICO NOTARIAL E REGISTRAL DO MUNICIPIO E COMARCA DE PAO DE ACUCAR ', 1818, 2706406, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13476, 6462, 'REGISTRO DE PESSOAS NATURAIS DA VILA LIMOEIRO', 3665, 2706406, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13477, 124, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E NOTAS', 2287, 2706448, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13478, 182, 'CARTORIO DE REGISTRO DAS PESSOAS NATURAIS DE IPIRA', 7336, 2914000, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13479, 8155, 'REGISTRO DE IMOVEIS,TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 13342, 2914000, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13480, 8156, 'CARTORIO DE IMOVEIS E HIPOTECAS', 5660, 2919157, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13481, 218, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6601, 2919207, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13482, 8157, 'REGISTRO DE IMOVEIS E TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 13201, 2919207, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13483, 8158, 'TAB NOTAS C/ FUNC. PROTESTOS', 13573, 2919207, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13484, 8159, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9324, 2919306, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13485, 8160, 'REG. CIVIL C/ FUNC NOTARIAIS - CEL OCTAVIANO ALVES', 135293, 2919306, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13486, 8161, 'CARTORIO DE REGISTRO DE TIT. E DOC. E PESSOAS JURIDICAS', 8144, 2919306, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13487, 8162, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTOS', 14738, 2919306, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13488, 8163, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS', 7591, 2919306, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13489, 8164, 'CARTORIO DO REGISTRO CIVIL COM FUN COES NOTARIAIS DO DISTRITO DE AFRANIO PEIXOTO - COMARCA DE LENCOIS-BAHIA', 8714, 2919306, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13490, 219, 'REGISTRO CIVIL COM FUNCAO NOTARIAL - DISTRITO DE TAUAPE', 11866, 2919405, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13491, 220, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12336, 2919405, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13492, 8165, 'REGISTRO DE IMOVEIS, HIPOTECAS, TITULOS E DOCUMENTOS', 13250, 2919405, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13493, 8166, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14332, 2919405, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13494, 11, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6585, 2919504, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13495, 8167, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14274, 2919504, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13496, 8168, 'REGISTRO DE IMOVEIS HIP TIT E DOC', 13219, 2919504, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13497, 222, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ ITANAGE', 140962, 2919504, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13498, 221, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9308, 2919504, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13499, 7554, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS', 6072, 2919504, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13500, 8169, 'TABELIONATO COM FUNCAO DE PROTESTO', 131623, 2919553, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13501, 8170, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS', 131615, 2919553, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13502, 8171, 'REGISTRO CIVIL COM FUNC NOTARIAIS', 131607, 2919553, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13503, 663, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 7021, 2929305, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13504, 8613, 'NOTAS', 11460, 2929305, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13505, 664, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9316, 2929354, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13506, 665, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6452, 2929370, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13507, 7221, 'RCPN DO 1º DISTRITO DA COMARCA DE MENDES', 145417, 3302809, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13508, 7222, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS DO 1ºDISTRITO DE MIGUEL PEREIRA - RJ', 91421, 3302908, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13509, 7223, 'RCPN E NOTAS', 92965, 3302908, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13510, 7224, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO 1º DISTRITO DO MUNICIPIO DE MIRACEMA', 91371, 3303005, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13511, 7225, 'RCPN DO 1º DISTRITO DE NATIVIDADE/RJ', 92817, 3303104, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13512, 7226, '2º OFICIO', 93898, 2409902, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13513, 7227, 'CARTORIO UNICO', 94250, 2415008, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13514, 7229, 'CARTORIO DISTRITAL DE JOSE OTAVIO', 97352, 4301602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13515, 7230, 'CARTORIO DISTRITAL DE ITAIMBEZINHO', 97345, 4302303, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13516, 7231, 'SERVICO REGISTRO CIVIL E TABELIONATO DE NOTAS DISTRITAL CAPELA VELHA', 101626, 4303509, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13517, 7232, 'SERVICO NOTARIAL E DE REGISTROS DE IGUATEMI', 100966, 4304507, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13518, 7233, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO 3º. DISTRITO DE PIRAI', 93195, 3304003, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13519, 7234, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 91322, 3304102, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13520, 7235, 'RCPN 6 DISTRITO-RESENDE', 92700, 3304201, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13521, 7236, 'RCPN 1º DISTRITO', 92510, 3304508, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13522, 7237, 'REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 93229, 3304607, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13523, 7238, 'RCPN 4º DISTRITO DE SAO FIDELIS', 92684, 3304805, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13524, 7239, 'CARTORIO RCPN 2º DISTRITO SAO SEBASTIAO DO ALTO', 91561, 3305307, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13525, 7240, 'CARTORIO DO RCPN E TABELIONATO DE BEMPOSTA, 3º DISTRITO', 91280, 3306008, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13526, 7241, 'OFICIO UNICO DE NOTAS - REGISTRO E PROTESTO DE TITULOS', 95125, 2400703, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13527, 7242, 'CAMPO GRANDE CARTORIO UNICO DE NOTAS', 94052, 2401305, 'RN');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13528, 7243, 'SERVICO NOATRIAL E DE REGISTRO DE VILA DEODORO', 100396, 4322608, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13529, 7244, 'SERVICO NOTARIAL E DE REGISTRO DE VILA MARIANTE', 130690, 4322608, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13530, 7245, 'SERVICO NOTARIAL E DE REGISTRO CIVIL DE PASSO D AREIA', 100545, 4323002, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13531, 7247, 'CARTORIO ANTONIO BERNARDI', 104901, 4204558, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13532, 7248, 'ESCRIVANIA DE PAZ DE TREVISO', 106542, 4204608, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13533, 7250, 'CARTORIO DE PAZ TABELIONATO E REGISTRO CIVIL', 105072, 4206702, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13534, 7251, 'JARDINOPOLIS - ESCRIVANIA DE PAZ', 107409, 4208955, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13535, 7252, 'CARTORIO PAZ PAINEL', 105619, 4209300, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13536, 7253, 'CARTORIO DE LAURO MULLER', 104943, 4209607, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13537, 7254, 'ESCRIVANIA DE PAZ DE SAO SEBASTIAO DO SUL', 106526, 4209706, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13538, 7257, 'SERVICO REGISTRAL DO VACAIQUA', 101568, 4306601, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13539, 7258, 'SERVICO NOTARIAL E REGISTRAL DE HULHA NEGRA', 101253, 4309654, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13540, 7259, 'OFICIO DE SERVICOS NOTARIAIS E DE REGISTRO DE ITAPUCA', 97972, 4310579, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13541, 7260, 'OFICIO DE NOTAS E DE REGISTRO', 97600, 4311130, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13542, 7261, 'TABELIONATO', 102467, 4311502, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13543, 7262, 'SERVICO NOTARIAL E REGISTRAL DE DUNAS', 101238, 4314407, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13544, 7263, 'SERVICO NOTARIAL E DE REGISTROS DE TORRINHAS', 101022, 4314506, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13545, 7264, 'SERIVCOS NOTARIAIS E DE REGISTROS DE RELVADO', 99739, 4315453, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13546, 7265, 'SERVICO NOTARIAL E DE REGISTROS', 100891, 4315602, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13547, 7266, 'OFICIO DISTRITAL DO CATI/ESPINILHO 7º DISTRITO DO MUNICIPIO RS', 98020, 4317103, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13548, 7267, 'SERVICO NOTARIAL E REGISTRAL DE ARROIO DO SO', 101188, 4316907, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13549, 7268, 'SERVICO NOTARIAL E DE REGISTRO DE BOQUEIRAO', 100610, 4318804, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13550, 7269, 'SERVICO NOTARIAL E REGISTRAL DE UNIAO', 101394, 4318804, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13551, 7270, 'SEGREDO OFICIO DISTRITAL', 99630, 4320263, 'RS');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13552, 7271, 'CARTORIO DO 2º OFICIO', 78659, 2206407, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13553, 7273, 'CARTORIO DO SEGUNDO OFICIO', 79194, 2207504, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13554, 7274, '2º CARTORIO DO REGISTRO CIVIL', 77834, 2207702, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13555, 7275, 'CARTORIO DO 2º OFICIO', 78832, 2208106, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13556, 7277, 'CARTORIO DO 2°. OFICIO', 78550, 2209104, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13557, 7272, 'CARTORIO DO 2º OFICIO', 78717, 2207009, 'PI');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13558, 8667, 'REGISTRO DE IMOVEIS,TITULOS E DOCUMENTOS', 13326, 2931053, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13559, 76, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12211, 2931053, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13560, 8668, 'CARTORIO DO REGISTRO DE IMOVEIS E DOCUMENTOS', 10116, 2931202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13561, 688, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 10819, 2931202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13562, 8669, 'REG. CIVIL C/ FUNCOES NOTARIAIS - AMURUGI', 132746, 2931202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13563, 8670, 'TAPEROA - TABELIONATO DE NOTAS', 15388, 2931202, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13564, 8671, 'REG. CIVIL C/ FUNC. NOTARIAIS - TAPIRAMUTA', 137364, 2931301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13565, 8672, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 136085, 2931350, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13566, 1449, 'CARTORIO DE REG. CIVIL E TAB. DE CRUBIXA', 21964, 3200300, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13567, 6936, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DO DISTRITO DE IBITIRUI', 22665, 3200300, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13568, 1452, 'CARTORIO DE REGISTRO CIVIL CIVIL E TABELIONATO DO DISTRITO DE RIBEIRAO DO CRISTO', 22012, 3200300, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13569, 1005, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 22251, 3200300, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13570, 9003, '1° OFICIO DE REGISTRO DE IMOVEIS, PROTESTO DE TITULOS, TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 21337, 3200300, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13571, 1245, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DO DISTRITO DE MATILDE', 22681, 3200300, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13572, 1451, 'REGISTRO CIVIL E TABELIONATO SAGRADA FAMILIA', 24430, 3200300, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13573, 1450, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE URANIA', 22640, 3200300, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13574, 9004, 'CARTORIO DE NOTAS AVILA', 21816, 3200300, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13575, 9005, 'CARTORIO 1º OFICIO REGISTRO GERAL DE IMOVEIS E ANEXOS', 21691, 3200359, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13576, 1008, 'CARTORIO REGISTRO CIVIL E TABELIONATO DE MONTE CARMELO DO RIO NOVO', 23846, 3200359, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13577, 1007, 'CARTORIO REGISTRO CIVIL E TAB. DO DIST. DE VI. PALMERINO', 23770, 3200359, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13578, 1006, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 22228, 3200359, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13579, 9006, 'CARTORIO DO 1 OFICIO DE ANCHIETA-ES', 22798, 3200409, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13580, 9007, 'TABELIONATO DE PROTESTO DE TITULOS', 150029, 3200409, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13581, 1010, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO GONCALVES', 22715, 3200409, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13582, 6937, 'CARTORIO DO REGISTRO CIVIL DE VILA DE ALTO PONGAL', 23341, 3200409, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13583, 1009, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 22277, 3200409, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13584, 9008, 'CARTORIO DE REG. DE TITULOS E DOC E REG. CIVIL DAS PESSOAS JURIDICAS', 153437, 3200409, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13585, 1247, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DO DISTRITO DE BONSUCESSO', 23655, 3200508, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13586, 1246, 'CARTORIO REGISTRO CIVIL E TABELIONATO DA SEDE', 23838, 3200508, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13587, 1011, 'CARTORIO DE NOTAS E REGISTRO CIVIL DO DISTRITO DE JOSE CARLOS', 21931, 3200508, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13588, 9009, 'CARTORIO DO PRIMEIRO OFICIO', 23267, 3200508, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13589, 9010, 'CARTORIO DO 1º OFICIO DE ARACRUZ', 23010, 3200607, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13590, 9011, 'ARACRUZ CARTORIO DE PROTESTO DE TITULOS E DOCUMENTOS', 21485, 3200607, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13591, 6858, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO NATALIA DEVENS', 22731, 3200607, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13592, 1013, 'CARTORIO ALZENIRA BITTI', 21576, 3200607, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13593, 1015, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DO DISTRITO DE RIACHO - CARTORIO BEIRIZ', 24257, 3200607, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13594, 9012, 'CARTORIO TERCEIRO OFICIO DE ARACRUZ', 23879, 3200607, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13595, 1014, 'ARACRUZ CARTORIO REGISTRO CIVIL E TABELIONATO DE NOTAS', 21493, 3200607, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13596, 1012, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DO DISTRITO DE GUARANA - CARTORIO MILSON PAULIN', 21477, 3200607, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13597, 1016, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 22095, 3200706, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13598, 9013, 'CARTORIO 1º OFICIO DE REGISTRO GERAL DE IMOVEIS DE ATILIO VIVACQUA', 21642, 3200706, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13599, 1017, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS, JURIDICAS E NOTAS', 23317, 3200805, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13600, 1020, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS DE IBITUBA', 22020, 3200805, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13601, 9014, 'CARTORIO 1º OFICIO', 21618, 3200805, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13602, 1019, 'CART. DE REGISTRO CIVIL E NOTAS DE VILA KM 14', 21550, 3200805, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13603, 1018, 'CARTORIO DE NOTAS E REGISTRO CIVIL DE VILA NOVA DO BANANAL', 21915, 3200805, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13604, 9015, 'CARTORIO DO REGISTRO CIVIL E NOTAS - RAQUEL LETICIA SILVA COMPER', 23911, 3200805, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13605, 7507, 'CARTORIO DE REGISTRO CIVIL E NOTAS VILA SANTO ANTONIO', 22210, 3200904, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13606, 9016, 'CARTORIO DO 3º OFICIO ', 23176, 3200904, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13607, 1025, 'CARTORIO DE REGISTRO CIVIL DE VILA PORANGA', 22038, 3200904, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13608, 6859, 'CARTORIO DE REGISTRO CIVIL E NOTAS DE VILA ITAPERUNA', 22160, 3200904, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13609, 9017, 'CARTORIO DO 1º OFICIO DE BARRA DE SAO FRANCISCO-ES, REG. GERAL DE IMOVEIS E ANEXOS ', 23028, 3200904, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13610, 1024, 'CARTORIO NIVERCINO LOURENCO DA SILVA', 23739, 3200904, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13611, 1021, 'CARTORIO MATTOS REGISTRO CIVIL E NOTAS CACHOEIRINHA DO ITAUNAS', 23721, 3200904, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13612, 6467, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE MANAQUIRI', 4739, 1302553, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13613, 7777, '4O. TABELIAO DE NOTAS  DA CAPITAL', 130815, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13614, 407, '10º OFICIO DE REGISTRO CIVIL DE PESSOAS NATURAIS  ', 4341, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13615, 7778, '7º TABELIONATO DE NOTAS', 4515, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13616, 7779, 'CARTORIO DO 5° OFICIO DE REGISTRO DE IMOVEIS DA COMARCA DA CAPITAL', 4465, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13617, 7780, 'CARTORIO DO 6º TABELIONATO DE NOTAS DA COMARCA DE MANAUS', 4507, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13618, 7781, 'CARTORIO DO TERCEIRO OFICIO DE NOTAS', 4937, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13619, 495, '7º REGISTRO CIVIL DE PESSOAS NATURAIS', 4192, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13620, 7782, 'CARTORIO DO SEXTO OFICIO DE REGISTRO DE IMOVEIS DE MANAUS', 4929, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13621, 402, 'CARTORIO DO 5º OFICIO DE REGISTRO CIVIL DE PESSOAS NATURAIS.', 4481, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13622, 7783, 'CARTORIO DO REGISTRO ESPECIAL DE TITULOS E DOCUMENTOS', 4903, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13623, 496, '9º REGISTRO CIVIL DE PESSOAS NATURAIS DE MANAUS', 4218, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13624, 7784, '2º OFICIO DE REGISTRO DE IMOVEIS E PROTESTO DE LETRAS', 4150, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13625, 497, 'CARTRIO DO 1º OFICIO DE REGISTRO CIVIL', 4994, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13626, 405, 'CARTORIO DO 4º OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 4457, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13627, 498, 'CARTORIO DISTRITAL DO 8º REGISTRO CIVIL DE TABOCAL ', 148346, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13628, 494, '2º CARTORIO DE REGISTRO CIVIL E PESSOAS NATURAIS', 4143, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13629, 7785, '2º. TABELIONATO DE NOTAS ', 4440, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13630, 7596, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 139345, 2911808, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13631, 325, 'IACU/DISTRITO DE LAGEDO ALTO - REGISTRO CIVIL', 11171, 2911907, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13632, 8108, 'REG. DE IMOV. E HIP TIT E DOCS E DAS PESSOAS JURIDICAS', 11692, 2911907, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13633, 326, 'IACU/DISTRITO JOAO AMARO - REGISTRO CIVIL COM FUNCOES NOTARIAIS', 11189, 2911907, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13634, 324, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12260, 2911907, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13635, 8109, 'IACU - TABELIONATO DE NOTAS C/ FUNCOES PROTESTO', 11163, 2911907, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13636, 327, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 6981, 2912103, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13637, 8110, 'CARTORIO DO REGISTRO DE IMOVEIS HIPOTECAS TITULOS E DOCUMENTOS', 10348, 2912103, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13638, 7474, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ SANTA CRUZ DA VITORIA', 140103, 2912103, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13639, 8111, 'TABELIONATO COM FUNCAO DE PROTESTO', 139287, 2912103, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13640, 8112, 'TABELIONATO DE NOTAS C/ PROTESTO DE TITULOS', 14084, 2912301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13641, 329, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS', 6114, 2912301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13642, 328, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6445, 2912301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13643, 8113, 'CARTORIO DE REG DE IMOVEIS E HIPOTECAS TITULOS E DOCUMENTOS E PESSOAS NATURAIS', 5850, 2912301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13644, 330, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6429, 2912301, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13645, 7475, 'REG. CIVIL C/ FUNCOES NOTARIAIS - IBIPEBA/BA', 134270, 2912400, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13646, 332, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS - DISTRITO DE IGUITU', 7054, 2912400, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13647, 8552, 'REG. CIVIL C/ FUNCOES NOTARIAIS - CERCADINHO', 134064, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13648, 8553, 'TABELIONATO DE PROTESTO DE TITULOS', 15214, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13649, 734, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE INHOBIM', 7211, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13650, 8554, 'REG. CIVIL C/ FUNCOES NOTARIAIS - SAO JOAO DA VITORIA', 134098, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13651, 8555, '2º TABELIONATO DE NOTAS', 5413, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13652, 8556, 'REG. CIVIL C/ FUNCOES NOTARIAIS - CABECEIRA DO JIBOIA', 134056, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13653, 8557, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS SEGUNDO OFICIO', 7740, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13654, 733, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE JOSE GONCALVES', 7237, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13655, 8558, 'REG. CIVIL C/ FUNCOES NOTARIAIS - PRADOSO', 134080, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13656, 736, 'REGISTRO  CIVIL 2º OFICIO', 5280, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13657, 8559, 'REG. CIVIL C/ FUNCOES NOTARIAIS - ABATE PE', 134049, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13658, 8560, 'REG. CIVIL C/ FUNCOES NOTARIAIS - VEREDINHA', 134114, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13659, 8561, 'TABELIONATO DE NOTAS DE 3º OFICIO', 14886, 2933307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13660, 8562, 'REGISTRO DE IMOVEIS, HIPOTECAS E TITULOS E DOCUMENTOS DO DISTRITO-SEDE DA COMARCA DE WANDERLEY', 154088, 2933455, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13661, 713, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS', 7294, 2933455, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13662, 8563, 'TABELIONATO COM FUNCAO DE PROTESTO DO DISTRITO-SEDE DA COMARCA DE WANDERLEY', 154096, 2933455, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13663, 8564, 'CARTORIO DO TABELIONATO DE NOTASC/FUNCOES DE PROTESTOS DE TITULOS', 10637, 2933505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13664, 8565, 'CARTORIO DE RESGISTRO DE IMOVEIS E HIPOTECAS/TITULOS E DOCUMENTOS', 8250, 2933505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13665, 738, 'TEOLANDIA - CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS', 144063, 2933505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13666, 737, 'CARTORIO DE REGISTRO CIVIL', 5918, 2933505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13667, 739, 'CARTORIO DE REGISTRO CIVIL', 5876, 2933604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13668, 740, 'XIQUE-XQUE - REGISTRO CIVIL', 15461, 2933604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13669, 8566, 'TABELIONATO DE NOTAS', 13839, 2933604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13670, 8567, 'CARTORIO DO REGISTRO DE IMOVEIS', 10066, 2933604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13671, 6919, 'CARTORIO DE REGISTRO CIVIL', 5884, 2933604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13672, 714, 'CART. DO REG. CIVIL C/FUNC. NOTARIAIS DE IGUIRA', 5579, 2933604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13673, 715, 'CARTORIO DE NOTAS E REGISTRO CIVIL DE ABAIARA', 16543, 2300101, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13674, 81, 'CARTORIO CALIXTO 1° OFICIO', 16360, 2300101, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13675, 742, 'REGISTRO CIVIL DISTRITO DE CRUZ', 20792, 2300101, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13676, 741, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE SANTA FELICIA', 17137, 2300101, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13677, 82, 'CARTORIO DE NOTAS E REG PUBLICOS DE ACARAPE', 16535, 2300150, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13678, 8568, 'CARTORIO DO SEGUNDO OFICIO', 19232, 2300200, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13679, 716, 'CARTORIO 1º OFICIO DE NOTAS E REGISTROS', 15966, 2300200, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13680, 717, 'CARTORIO DE REGISTRO CIVIL DE ARANAU', 16873, 2300200, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13681, 637, 'CARTORIO DO REGISTRO CIVIL COMARCA DE SANTA TEREZINHA BAHIA', 9050, 2928505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13682, 8569, 'SANTA TERESINHA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE ELISIO MEDRADO', 143933, 2928505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13683, 8570, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO DE TITULOS', 14506, 2928505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13684, 8571, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS E TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 7716, 2928505, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13685, 8572, 'REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E CIVIS DAS PESSOAS JURIDICAS', 13151, 2928000, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13686, 8573, 'TABELIONATO DE NOTAS', 13961, 2928000, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13687, 8574, 'REG. CIVIL C/ FUNC NOTARIAIS - PEREIRA', 132522, 2928000, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13688, 644, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6544, 2928000, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13689, 8575, 'TABELIONATO DE NOTAS C/FUNCOES DE PROTESTO', 14183, 2928208, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13690, 646, 'REGISTRO CIVIL COM FUNCAO NOTARIAIS - PORTO NOVO', 138339, 2928208, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13691, 645, 'CARTORIO DO REGISTRO CIVIL', 8565, 2928208, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13692, 8576, 'REG. CIVIL C/ FUNC NOTARIAIS - CANAPOLIS', 132530, 2928208, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13693, 8577, 'CARTORIO DE IMOVEIS E HIP. TIT. DOC. P. JURIDICA', 5652, 2928208, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13694, 270, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ SANTANAPOLIS', 140897, 2928307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13695, 268, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ BOA ESPERA', 140889, 2928307, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13696, 648, 'SANTO AMARO - CARTORIO DE REGISTRO CIVIL - SEDE', 144451, 2928604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13697, 8578, 'CARTORIO DE REG. IMOVEIS, TIT DOCUMENTOS E REG. CIVIL DAS PESSOAS JURIDICAS', 5868, 2928604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13698, 8939, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE ALGODOES', 136077, 2311264, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13699, 1417, 'CARTORIO DO REGISTRO CIVIL DISTRITO SAO FRANCISCO', 18721, 2311264, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13700, 1042, 'CARTORIO DE NOTAS E REGISTROS ', 16568, 2311264, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13701, 8940, 'CARTORIO DO 2º OFICIO DA COMARCA DE QUIXADA', 17723, 2311306, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13702, 1726, 'CARTORIO DE REGISTRO CIVIL DO DISTRITO DE DOM MAURICIO', 17053, 2311306, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13703, 1418, 'CARTORIO ANTONIA MARIA BARBOSA', 16220, 2311306, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13704, 1419, 'CARTORIO BEZERRA - 1º. OFICIO', 16303, 2311306, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13705, 8941, 'CARTORIO DE REGISTRO CIVIL - DISTRITO JUATAMA', 136101, 2311306, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13706, 8942, 'CARTORIO JUSTA 2° OFICIO', 19497, 2313500, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13707, 1790, 'CARTORIO DO 1º OFICIO DE TRAIRI', 17517, 2313500, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13708, 8943, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE CANAA', 136473, 2313500, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13709, 1789, 'CARTORIO CASTELLO BRANCO', 18523, 2313500, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13710, 8944, 'CARTORIO DO REG. CIVIL DO DISTRITO DE CEMOABA', 146613, 2313559, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13711, 1791, 'OFICIO DE NOTAS E REGISTROS', 20610, 2313559, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13712, 1794, 'CARTORIO PARENTE', 19869, 2313609, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13713, 1793, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE ARATICUM', 18796, 2313609, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13714, 1792, 'CARTORIO DESEMBARGADOR MANUEL DE SALES ANDRADE', 17277, 2313609, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13715, 8945, 'CARTORIO  UBAJARA SEGUNDO OFICIO', 15909, 2313609, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13716, 1795, 'CARORIO DO 1º OFICIO - REGISTRO CIVIL', 15842, 2313708, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13717, 8946, '2° OFICIO DE REGISTRO DE IMOVEIS', 137935, 2313708, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13718, 1797, 'CARTORIO DO REGISTRO CIVIL DE UMIRIM', 18697, 2313757, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13719, 8947, 'CARTORIO DO 2º OFICIO DE NOTAS E REGISTROS ', 17749, 2313757, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13720, 1796, 'CARTORIO DO REGISTRO CIVIL DE SAO JOAQUIM', 18630, 2313757, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13721, 8948, 'CARTORIO ARAUJO MATHIAS', 19943, 2313807, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13722, 1799, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE SANTA LUZI', 136481, 2313807, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13723, 1798, 'CARTORIO DO PRIMEIRO OFICIO DE URUBURETAMA', 18143, 2313807, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13724, 1801, 'CARTORIO DE NOTAS E REGISTROS PUBLICOS', 16584, 2313906, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13725, 1800, 'CARTORIO DO REGISTRO CIVIL DE PARACUA', 18564, 2313906, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13726, 1802, 'OFICIO DE NOTAS E DE REGISTROS DE VARJOTA, COMARCA VINCULADA DE RERIUTABA', 20578, 2313955, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13727, 1803, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE IBICATU- VARZEA ALEGRE-CE', 18903, 2314003, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13728, 8949, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE NARANIU', 136507, 2314003, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13729, 1804, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE CALABACA - VARZEA ALEGRE-CE', 18861, 2314003, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13730, 8950, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE CANINDEZINHO', 136499, 2314003, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13731, 6857, 'OFICIO DE NOTAS E DE REGISTRO DA SEDE DA COMARCA DE VARZEA ALEGRE-CEARA', 20545, 2314003, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13732, 8951, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE RIACHO VERDE', 136515, 2314003, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13733, 1808, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE QUATIGUABA', 19026, 2314102, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13734, 1805, 'CARTORIO DO 1º OFICIO DA COMARCA DE VICOSA DO CEARA', 17426, 2314102, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13735, 1807, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO PADRE VIEIRA', 19125, 2314102, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13736, 8963, '6º OFICIO DE REGISTRO DE IMOVEIS DO DISTRITO FEDERAL', 21139, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13737, 1806, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE GENERAL TIBURCIO', 18887, 2314102, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13738, 1421, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE LAMBEDOURO', 18929, 2314102, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13739, 8952, 'VICOSA DO CEARA CARTORIO DO 2° OFICIO', 20958, 2314102, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13740, 8953, '4º OFICIO DE NOTAS DO DISTRITO FEDERAL', 21071, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13741, 1425, 'CARTORIO DO 1O. OFICIO DE NOTAS, REGISTRO CIVIL, PROTESTO DE TITULOS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS DO DF', 21220, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13742, 8954, 'CARTORIO DE REGISTRO DE DISTRIBUICAO', 21196, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13743, 8955, '1º OFICIO DE NOTAS E PROTESTO DE BRASILA', 20974, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13744, 8956, '1º OFICIO DE REGISTRO DE IMOVEIS DO DISTRITO FEDERAL', 20990, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13745, 8957, 'CARTORIO DO 8º OFICIO DE NOTAS E PROTESTO DE TITULOS DO GAMA - DF', 21295, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13746, 8958, '1º OFICIO DE PROTESTO DE TITULOS DE BRASILIA', 20982, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13747, 8959, 'CARTORIO DO 3º OFICIO DE NOTAS E PROTESTO DE TITULOS DE BRASILIA-DF', 21261, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13748, 1423, 'CARTORIO DO 2º OFICIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS DE BRASILIA/DF', 21253, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13749, 430, 'CARTORIO DE REGISTROS PUBLICOS E NOTAS DE PEDRA BRANCA DO AMAPARI', 5124, 1600154, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13750, 431, 'CARTORIO MURICI TEIXEIRA', 5173, 1600535, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13751, 923, 'POSTO AVANCADO DO JUIZO DE AMAPA NO MUNICIPIO DE PRACUUBA', 5215, 1600550, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13752, 508, 'CARTORIO OLIVEIRA', 5199, 1600600, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13753, 509, 'CARTORIO DE REGISTRO PUBLICO E TABELIONATO', 5090, 1600055, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13754, 924, 'CARTORIO MACIEL', 5165, 1600709, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13755, 510, 'CARTORIO MIRANDA', 5264, 1600808, 'AP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13756, 925, 'REG. CIVIL C/ FUNC NOTARIAIS - ABAIRA', 132068, 2900108, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13757, 7729, 'RESGISTRO DE IMOVEIS IPOTECA COM TITULOS DE DOCUMENTOS', 13474, 2900108, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13758, 511, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE CATOLES', 143891, 2900108, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13759, 926, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9548, 2900207, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13760, 512, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS', 8763, 2900207, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13761, 7730, 'CARTORIO DO REGISTRO DE IMOVEIS', 10074, 2900207, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13762, 7731, 'CARTORIO DO TABELIONATO DE NOTAS E PROTESTO DE TITULOS', 10611, 2900207, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13763, 7732, 'CARTORIO DE NOTAS COM FUNCAO DE PROTESTO', 5728, 2900306, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13764, 513, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12286, 2900306, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13765, 7733, 'REGISTRO DE IMOVEIS, HIPOTECA TITULOS E DOCUMENTOS ', 13243, 2900306, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13766, 927, 'CARTORIO DO REGISTRO CIVIL C/ FUNCOES NOTARIAIS', 8656, 2900355, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13767, 7532, 'IRARA-DIST.AGUA FRIA.SUB DIST.PATAIBA - REG. CIVIL C/ FUN.NOTARIAS', 11221, 2900405, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13768, 7533, 'IRARA/DISTRITO DE AGUA FRIA - REGISTRO CIVIL C/FUN NOTARIAIS', 11262, 2900405, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13769, 928, 'REG. CIVIL C/ FUNC NOTARIAIS - DISTRITO DE AIQUARA', 131565, 2900603, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13770, 514, '2º OFICIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 5405, 2900702, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13771, 574, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS ', 11890, 2900702, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13772, 7734, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS DO 2º OFICIO DA COMARCA DE ALAGOINHAS', 7666, 2900702, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13773, 7735, 'ALAGOINHAS - CARTORIO DE REGISTRO CIVIL - DISTRITO DE ARAMARI', 144089, 2900702, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13774, 7736, 'TABELIAO DE NOTAS DO 1º OFICIO', 13615, 2900702, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13775, 7737, 'REGISTRO DE TITULOS E DOCUMENTOS', 13367, 2900702, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13776, 7738, 'MANUELA MUTTI CARVALHO ALMEIDA DE SANTANA', 11437, 2900702, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13777, 7739, 'CARTORIO DE PROTESTO DE TITULOS E DOCUMENTOS DE ALAGOINHAS', 5819, 2900702, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13778, 572, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS', 6098, 2900702, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13779, 7740, 'TABELIONATO DE NOTAS DO 2º OFICIO', 14936, 2900702, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13780, 573, 'CARTORIO DO REGISTRO CIVIL DE PESSOA NATURAIS DO 1º OFICIO', 9845, 2900702, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13781, 7741, 'ALCOBACA - REGISTRO DE IMOVEIS', 5488, 2900801, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13782, 7742, 'TABELIONATO DO 1º OFICIO DE NOTAS E PROTESTO', 15297, 2900801, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13783, 7743, 'REG. CIVIL C/ FUNCOES NOTARIAIS - SAO JOSE', 134130, 2900801, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13784, 432, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6411, 2900801, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13785, 7534, 'RCPN/FUNC C/FUNC. NOTARIAIS', 11650, 2900900, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13786, 7744, 'AMARGOSA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE ITACHAMA', 144097, 2901007, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13787, 7745, 'RCPN ', 11643, 2901007, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13788, 7746, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ DIOGENES SAMPAIO', 139881, 2901007, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13789, 7747, 'TABELIONATO DE NOTAS C/FUNC DE PROTESTO', 14118, 2901007, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13790, 7748, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS.', 139857, 2901007, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13791, 7749, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ ITACHAMA', 139675, 2901007, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13792, 7750, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS.', 138610, 2901106, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13793, 7751, 'AMELIA RODRIGUES - CARTORIO DE REGISTRO CIVIL - DISTRITO DE MATA DA ALIANCA', 143396, 2901106, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13794, 7752, 'TABELIONATO COM FUNCAO DE PROTESTO', 138396, 2901106, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13795, 7753, 'AMELIA RODRIGUES - CARTORIO DE REGISTRO CIVIL - DISTRITO DE INHATA', 143388, 2901106, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13796, 7754, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 139220, 2901106, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13797, 7755, 'REG. CIVIL C/ FUNCOES NOTARIAIS - PREVENIDO', 134189, 2901155, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13798, 131, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DE RIO LARGO', 3525, 2707701, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13799, 640, 'SERVENTIA DO REGISTRO CIVIL DE ROTEIRO', 3673, 2707800, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13800, 331, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS DA VILA DE LAGOA GRANDE', 8789, 2912400, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13801, 8114, 'MACAUBAS - CARTORIO DE REGISTRO CIVIL - DISTRITO DE IBIPITANGA', 144410, 2912509, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13802, 8115, 'TABELIONATO DE NOTAS', 13847, 2912608, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13803, 333, 'CARTORIO REGISTRO CIVIL PESSOAS NATURAIS', 10975, 2912608, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13804, 8116, 'REGISTRO DE IMOVEIS, HIP. E TIT. E DOCS', 134957, 2912608, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13805, 335, 'CARTORIO DO REGISTRO CIVIL', 8615, 2912707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13806, 334, 'CARTORIO DE REGISTRO CIVIL', 5900, 2912707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13807, 8117, 'CARTORIO DE REGISTRO DE IMOVEIS', 5272, 2912707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13808, 8118, 'REG. CIVIL C/ FUNC NOTARIAIS - NOVO HORIZONTE', 134999, 2912707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13809, 8119, 'TAB.NOTAS/COM FUNCAO DE PROTESTO', 13581, 2912707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13810, 8120, 'REG. CIVIL C/ FUNC NOTARIAIS - CAMAMUZINHO', 134973, 2912707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13811, 8121, 'CARTORIO DO TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO', 10587, 2912806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13812, 336, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9225, 2912806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13813, 8122, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS', 135004, 2912806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13814, 337, 'IBIRATAIA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE ALGODAO', 143578, 2912905, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13815, 8123, 'TABELIONATO DE NOTAS', 139501, 2912905, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13816, 338, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 139311, 2912905, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13817, 8124, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS', 131482, 2912905, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13818, 339, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO SEDE DO MUNICIPIO E COMARCA DE IBITIARA BAHIA', 13482, 2913002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13819, 8125, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14282, 2913002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13820, 8126, 'CARTORIO REGISTRO DE IMOVEIS E HIPOTECAS TITULOS E DOCUMENTOS', 11015, 2913002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13821, 340, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAS DO DISTRITO DE MOCAMBO, MUNICIPIO E COMARCA DE IBITIARA, BAHIA.', 11197, 2913002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13822, 341, 'IBITIARA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE OLHOS DAGUA DO SECO', 143586, 2913002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13823, 8127, 'TABELIONATO DE NOTAS', 13680, 2913101, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13824, 343, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9209, 2913101, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13825, 342, 'CARTORIO DO REGISTRO CIVIL COM FUNCAO NOTARIAL', 8730, 2913101, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13826, 8128, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS E TITULOS E DOCUMENTOS', 7682, 2913101, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13827, 344, 'CARTORIO DE REGISTRO CIVIL COM FUNCOES NOTARIAIS', 6130, 2913101, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13828, 8129, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS E ANEXOS', 7674, 2913200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13829, 8130, 'TABELIONATO DE NOTAS COM FUNCOESNOTARIAIS', 14837, 2913200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13830, 346, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DA COMARCA DE IBOTIRAMA BAHIA', 9712, 2913200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13831, 345, 'REG. CIVIL C/ FUNC NOTARIAIS - BOA VISTA DO LAGAMAR', 133322, 2913200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13832, 347, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 6999, 2913309, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13833, 8131, 'TABELIONATO DE NOTAS', 13748, 2913309, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13834, 8132, 'REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS', 13284, 2913309, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13835, 8133, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO DE TITULOS', 14480, 2913408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13836, 8134, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6593, 2913408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13837, 8135, 'REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS DOCUMENTOS E PESSOAS JURIDICAS', 13045, 2913408, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13838, 8136, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14357, 2913507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13839, 8137, 'IGUAI - CARTORIO DE REGISTRO CIVIL - SEDE', 143594, 2913507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13840, 8138, 'REG. CIVIL C/ FUNC NOTARIAIS - IBIPORAMA', 135053, 2913507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13841, 8139, 'REG. CIVIL C/ FUNC NOTARIAIS - PONTO XIQUE', 135087, 2913507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13842, 8140, 'REG. CIVIL C/ FUNC NOTARIAIS - ALTAMIRA', 135046, 2913507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13843, 8141, 'REG. CIVIL C/ FUNC NOTARIAIS - PALMEIRINHA', 135079, 2913507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13844, 8142, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 7542, 2913507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13845, 8143, 'REG. CIVIL C/ FUNC NOTARIAIS - IGUAIBI', 135061, 2913507, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13846, 354, 'CARTORIO DE REGISTRO CIVIL  SEDE  2º OFICIO', 144188, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13847, 265, 'ILHEUS/REGISTRO CIVIL-DISTRITO DE SAMBAITUBA', 11205, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13848, 8144, 'TABELIONATO 3º OFICIO DE NOTAS', 133389, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13849, 8579, 'REG. CIVIL C/ FUNC. NOTARIAIS - SAUBARA', 137406, 2928604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13850, 8580, 'CARTORIO DE NOTAS', 5702, 2928604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13851, 7574, 'REG. CIVIL C/ FUNCOES NOTARIAIS - CAMPINHOS', 133892, 2928604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13852, 8581, 'SANTO AMARO - CARTORIO DE REGISTRO CIVIL - DISTRITO DE BOM JESUS DOS POBRES', 144469, 2928604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13853, 647, 'REGISTRO CIVIL DE PESSOAS NATURAIS C/NOTORIAIS', 12823, 2928604, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13854, 8582, 'CARTORIO DE REGISTRO DE IMOVEIS DO 2º OFICIO', 7492, 2928703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13855, 8583, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS DO 1º OFICIO', 7641, 2928703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13856, 8584, 'TABELIONATO 2º OFICIO DE NOTAS ', 5389, 2928703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13857, 8585, 'REG. CIVIL C/ FUNC. NOTARIAIS - VARZEDO', 137166, 2928703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13858, 8586, 'TABELIONATO DE NOTAS DO 1º OFICIO', 14910, 2928703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13859, 8587, 'CARTORIO DE PROTESTO DE TITULOS', 5793, 2928703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13860, 650, 'REG. CIVIL C/ FUNCAO NOTARIAIS - DOM MACEDO COSTA', 136770, 2928703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13861, 649, 'CARTORIO REGISTRO CIVIL DAS PESSOAS NATURAIS', 10850, 2928703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13862, 8588, 'REGISTRO DE TITULOS E DOCUMENTOS E CIVIL DAAS PESSOAS JURIDICAS', 13375, 2928703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13863, 8589, 'REG. CIVIL C/ FUNCOES NOTARIAIS - TABOLEIRO DO CASTRO', 133900, 2928703, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13864, 651, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 6718, 2928802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13865, 8590, 'REG. CIVIL C/ FUNCOES NOTARIAIS - CAVANGE', 133926, 2928802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13866, 8591, 'CARTORIO DE REGISTRO DE IMOVEIS, TITULOS E DOCUMENTOS E REGISTRO CIVIL DAS PESSOAS JURIDICAS', 8110, 2928802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13867, 8592, 'REG. CIVIL C/ FUNC. NOTARIAIS - IPECAETA', 135491, 2928802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13868, 8593, 'REG. CIVIL C/ FUNCOES NOTARIAIS - ANTONIO CARDOSO', 133918, 2928802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13869, 8594, 'REG. CIVIL C/ FUNCOES NOTARIAIS - SANTO ESTEVAO VELHO', 133942, 2928802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13870, 8595, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO', 14597, 2928802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13871, 8596, 'REG. CIVIL C/ FUNCOES NOTARIAIS - POCO', 133934, 2928802, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13872, 8597, 'CARTORIO DO REGISTRO CIVIL C/FUNCOES NOTARIAIS', 8672, 2928901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13873, 8598, 'CARTORIO DE NOTAS E PROTESTO', 5751, 2928901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13874, 8599, 'REG. CIVIL C/ FUNC NOTARIAIS - VELHA DE CIMA', 132555, 2928901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13875, 8600, 'CARTORIO DE REGISTRO DE IMOVEIS E HIPOTECAS/TICULOS E DOCUMENTOS', 7906, 2928901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13876, 652, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6387, 2928901, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13877, 8601, 'CARTORIO DO TABELIONATO DE NOTAS', 10496, 2928950, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13878, 8602, 'CARTORIO DO REGISTRO DE IMOVEIS', 10041, 2928950, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13879, 653, 'CARTORIO DO REGISTRO CIVIL', 8599, 2928950, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13880, 8603, 'TABELONATO DE NOTAS C/ FUNCOES DE PROTESTO', 15370, 2929107, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13881, 8604, 'REG. CIVIL C/ FUNC. NOTARIAIS - CARAIPE', 138156, 2929107, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13882, 8605, 'SAO FELIPE - REGISTRO DE IMOVEIS, TITULOS DOCUMENTOS E PESSOAS JURIDICAS', 13508, 2929107, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13883, 6697, 'CARTORIO DO REG CIV DA COMARCA DE SAO FELIPE', 8458, 2929107, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13884, 8606, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS.', 138388, 2929008, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13885, 654, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 138271, 2929008, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13886, 8607, 'TABELIONATO COM FUNCAO DE PROTESTO', 138214, 2929008, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13887, 655, 'SAO FELIX - CARTORIO DE REGISTRO CIVIL - DISTRITO DE OUTEIRO REDONDO', 143958, 2929008, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13888, 658, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS COM FUNCOES NOTORIAIS', 7096, 2929206, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13889, 8608, 'CARTORIO DE REGISTRO DE IMOVEIS, HIPOTECAS, TIT. E DOC. E PESSOAS JURIDICAS', 8045, 2929206, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13890, 8609, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14407, 2929206, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13891, 657, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS COM FUNCOES NOTORIAIS', 7104, 2929206, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13892, 656, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS', 7013, 2929206, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13893, 8610, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 10272, 2929255, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13894, 660, 'CARTORIO DE REGISTRO CIVIL', 5926, 2929255, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13895, 8611, 'TABELIONATO DE NOTAS', 13797, 2929255, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13896, 659, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS', 11932, 2929255, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13897, 662, 'CARTORIO REGISTRO CIVIL C/FUNC. NOTARIAIS-SERGI', 13516, 2929305, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13898, 661, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9456, 2929305, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13899, 8612, 'REGISTRO DE IMOVEIS', 12922, 2929305, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13900, 8960, 'CARTORIO DO 2º OFICIO DE NOTAS E PROTESTO', 21246, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13901, 8961, '2º OFICIO DE REGISTRO DE IMOVEIS DO DF', 21022, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13902, 1424, 'CARTORIO DO 1º OFICIO DE REG. CIVIL, CASAMENTOS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 21238, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13903, 1422, '6º OFICIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS DE SAMAMBAIA - DF', 21121, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13904, 8962, 'CARTORIO DO 9.º OFICIO DE REGISTRO DE IMOVEIS DO DISTRITO FEDERAL', 21311, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13905, 1426, '4.º OFICIO DE NOTAS, PROTESTO DE TITULOS, REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS DO DISTRITO FEDERAL - BRAZLANDIA', 21063, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13906, 8964, 'CARTORIO DO 10º OFICIO DE CEILANDIA', 21204, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13907, 1427, '7 OFICIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS DO DF', 21154, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13908, 8965, '9° OFICIO DE NOTAS E PROTESTO DE TITULOS DO GAMA', 21188, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13909, 8966, '5º OFICIO DE REGISTRO DE IMOVEIS DO DISTRITO FEDERAL', 21105, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13910, 1428, '4º OFICIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS DO DISTRITO FEDERAL', 21089, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13911, 8967, '2º OFICIO DE PROTESTO DE TITULOS DO GUARA', 21014, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13912, 8968, 'CARTORIO DO 4º OFICIO DE REGISTRO DE IMOVEIS DO DISTRITO FEDERAL', 21279, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13913, 8969, '5º OFICIO DE NOTAS, REGISTRO CIVIL, TITULOS E DOCUMENTOS, PROTESTO DE TITULOS E PESSOAS JURIDICAS DO GUARA-DF ', 154609, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13914, 1429, '3º OFICIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS DO PARANOA', 21055, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13915, 8970, '8º OFICIO DE REGISTRO DE IMOVEIS DO DF', 21170, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13916, 8971, 'CARTORIO DO 12º OFICIO DE NOTAS E PROTESTO DE TITULOS DO DISTRITO FEDERAL', 21212, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13917, 1430, 'CARTORIO DO 9 OFICIO REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS DO DF', 21303, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13918, 8972, '7 OFICIO DE NOTAS DE SAMAMBAIA/DF', 21147, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13919, 1431, '2° OFICIO DE NOTAS, PROTESTO, REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS DO DF', 21006, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13920, 8973, '7º OFICIO DE REGISTRO DE IMOVEIS DO DISTRITO FEDERAL', 21162, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13921, 8974, '11 OFICIO DE NOTAS E PROTESTO DE TITULOS DO DF', 20966, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13922, 8975, '3º OFICIAL DO REGISTRO DE IMOVEIS DO DISTRITO FEDERAL', 21030, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13923, 8976, 'CARTORIO DO 5º OFICIO DE NOTAS DO DISTRITO FEDERAL', 21287, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13924, 1432, '3º OFICIO DE NOTAS, REGISTRO CIVIL E PROTESTO DE TITULOS', 21048, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13925, 8977, '6º OFICIO DE NOTAS DO DISTRITO FEDERAL', 21113, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13926, 1433, '5. OFICIO DE REGISTRO CIVIL, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS DO DISTRITO FEDERAL', 21097, 5300108, 'DF');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13927, 1437, 'CARTORIO DE TABELIONATO E REGISTRO CIVIL', 22772, 3200102, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13928, 8978, 'CARTORIO DO 1º OFICIO COMARCA DE FUNDAO', 22962, 3202207, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13929, 8979, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO - DISTRITO DE IRUNDI', 144980, 3202207, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13930, 1195, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DE TIMBUI', 23622, 3202207, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13931, 8980, 'CARTORIO DE NOTAS E REGISTRO CIVIL DA COMARCA DE FUNDAO DISTRITO DE PRAIA GRANDE', 21758, 3202207, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13932, 8981, 'GUACUI CARTORIO DE NOTAS DO SEGUNDO OFICIO', 24042, 3202306, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13933, 1197, 'CRCPN DA COMARCA DA SEDE E TABELIONATO DE NOTAS DA COMARCA DE GUACUI,ES   ', 24000, 3202306, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13934, 8982, '2º OFICIO - TABELIONATO', 145029, 3202306, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13935, 1055, 'CARTORIO DE REGISTRO CIVIL E NOTAS DISTRITO DE SAO TIAGO ( CARTORIO SOUZA )', 24570, 3202306, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13936, 1056, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO', 21998, 3202306, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13937, 8983, 'CARTORIO DO 1º OFICIO DE GUACUI-ES', 23036, 3202306, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13938, 8984, 'CARTORIO DO 1º OFICIO DE NOTAS DE GUARAPARI/ES', 23069, 3202405, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13939, 1057, 'GUARAPARI CARTORIO DE NOTAS E REGISTRO CIVIL', 24059, 3202405, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13940, 8985, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE TODOS OS SANTOS', 145060, 3202405, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13941, 7756, 'TABELIONATO DO UNICO OFICIO', 4036, 2707909, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13942, 641, 'CARTORIO DO REGISTRO CIVIL', 2634, 2707909, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13943, 386, 'SERVICOS DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 3996, 2708006, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13944, 7757, '2º OFICIO DE NOTAS E PROTESTO', 1842, 2708006, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13945, 7758, 'CARTORIO 1º OFICIO', 2048, 2708006, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13946, 387, 'CARTORIO DE REGISTRO DE PESSOAS NATURAIS E NOTAS DE SANTANA DO MUNDAU', 2436, 2708105, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13947, 7759, 'SERVICO NOTARIAL E REGISTRAL DE SAO BRAS', 3889, 2708204, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13948, 388, 'REGISTRADOR CIVIL E NOTARIO  - GE055', 3459, 2708204, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13949, 465, 'CARTORIO DO SERVICO REGISTRAL E NOTARIAL DO 2º DISTRITO DE SERRA GRANDE', 3061, 2708303, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13950, 7760, 'SERVICO NOTARIAL E REGISTRAL CARTORIO DO UNICO OFICIO', 3848, 2708303, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13951, 642, 'CARTORIO DE REGISTRO CIVIL DO 1 DISTRITO DE SAO JOSE DA LAJE-AL', 2329, 2708303, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13952, 7761, 'CARTORIO DO UNICO OFICIO - JOSE EUNE DOS SANTOS', 3442, 2708402, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13953, 466, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 2717, 2708402, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13954, 7762, 'CARTORIO DE NOTAS E PROTESTOS', 2105, 2708501, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13955, 467, 'CARTORIO DO REGISTRO CIVIL E NOTAS DAS PESSOAS NATURAIS DE SAO LUIZ DO QUITUNDE', 2964, 2708501, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13956, 7763, 'PRIMEIRO OFICIO DE NOTAS E REGISTROS DE IMOVEIS E TITULOS E DOCUMENTOS', 3426, 2708501, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13957, 468, 'MOACIR CAVALCANTI', 3376, 2708600, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13958, 7764, 'CARTORIO 2º OFICIO DE NOT. REG. TIT. E DOCUMENTOS', 2063, 2708600, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13959, 7765, '1º SERVICO NOTARIAL E REGISTRAL ', 1750, 2708600, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13960, 7766, '1º SERVICO NOTARIAL E REGISTRAL   ', 149815, 2708600, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13961, 389, 'SERVICO DE REGISTRO CIVIL E NOTAS', 3723, 2708709, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13962, 912, 'CARTORIO DO REGISTRO CIVIL E NOTAS', 2915, 2708709, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13963, 570, 'SERVICO DE REGISTRO CIVIL E NOTAS', 3731, 2708808, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13964, 7767, 'CARTORIO DO UNICO OFICIO', 3129, 2708808, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13965, 469, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DE SATUBA', 2709, 2708907, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13966, 7768, 'CARTORIO DO UNICO OFICIO DE SATUBA', 3277, 2708907, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13967, 913, 'SERVICO DE REGISTRO CIVIL E NOTAS DAS PESSOAS NATURAIS', 2675, 2708956, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13968, 7769, 'UNICO OFICIO DE REGISTRO DE IMOVEIS E NOTAS DE SENADOR RUI PALMEIRA', 4085, 2708956, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13969, 390, 'CARTORIO DE REGISTRO CIVIL', 2170, 2709004, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13970, 7770, 'CARTORIO DO UNICO OFICIO', 3095, 2709004, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13971, 470, 'CARTORIO DE REGISTRO CIVIL DE TAQUARANA', 2311, 2709103, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13972, 7771, 'NOTAS E REGISTRO DO UNICO OFICIO DE TAQUARANA', 3392, 2709103, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13973, 391, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS E NOTAS', 2238, 2709152, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13974, 914, 'SERVICO REGISTRAL E NOTARIAL DAS PESSOAS NATURAIS', 3962, 2709152, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13975, 471, 'CARTORIO DO REGISTRO CIVIL', 2584, 2709202, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13976, 7772, 'SERVICO NOTARIAL E REGISTRAL DE TRAIPU/AL', 3897, 2709202, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13977, 7773, '2º OF. REG. NOTAS E TITULOS E DOCUMENTOS', 1834, 2709301, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13978, 474, 'REGISTRO CIVIL DE UNIAO DOS PALMARES', 3640, 2709301, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13979, 7774, '1º TABELIONATO DE NOTAS REGISTRO DE IMOVEIS E PROTESTO DE TITULOS', 1784, 2709301, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13980, 473, 'REGISTRO CIVIL DE ROCHA CAVALCANTE', 3632, 2709301, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13981, 472, 'REGISTRO CIVIL DO DISTRITO DE MUNGUBA DA COMARCA DE UNIAO DOS PALMARES', 3657, 2709301, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13982, 132, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E NOTAS DE VICOSA', 2295, 2709400, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13983, 7775, 'SERVICOS NOTARIAIS DO 1° OFICIO', 4002, 2709400, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13984, 7776, 'SERVICOS NOTARIAIS E REGISTRAIS DE VICOSA-AL', 4010, 2709400, 'AL');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13985, 6463, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE ALVARAES', 4614, 1300029, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13986, 475, 'CARTORIO DISTRITAL DO REGISTRO CIVIL DE AMATURA', 148163, 1300060, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13987, 392, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE ANAMA', 4622, 1300086, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13988, 133, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE ANORI', 4630, 1300102, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13989, 393, 'CARTORIO DO JUDICIAL E DEMAIS ANEXOS DA COMARCA DE APUI', 4887, 1300144, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13990, 476, 'CARTORIO DE ATALAIA DO NORTE E ANEXO', 4309, 1300201, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13991, 348, 'REG. CIVIL C/ FUNCAO NOTARIAIS - BANCO CENTRAL', 136812, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13992, 355, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS  5º DISTRITO BANCO DA VITORIA', 6858, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13993, 350, 'REG. CIVIL C/ FUNC. NOTARIAIS - INEMA', 135772, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13994, 351, 'REG. CIVIL C/ FUNC. NOTARIAIS - PIMENTEIRA', 137455, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13995, 8145, 'TABELIONATO 2º OFICIO DE NOTAS', 133371, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13996, 264, 'REG. CIVIL C/ FUNCAO NOTARIAIS - PONTAL', 136747, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13997, 8146, 'TABELIONATO DO 1º OFICIO DE NOTAS', 154468, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13998, 352, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO 4º DISTRITO DE JAPU', 6866, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (13999, 6852, 'REG. CIVIL C/ FUNC NOTARIAIS - RIO DO BRACO', 133405, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14000, 8147, 'PROTESTO DE TITULOS', 137323, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14001, 8148, 'REGISTRO DE IMOVEIS - 2º OFICIO', 133363, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14002, 263, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE COUTOS', 136705, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14003, 356, 'REGISTRO DE IMOVEIS - 2º OFICIO', 144287, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14004, 349, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS DO DISTRITO DE ARITAGUA - ILHEUS- BAHIA', 7120, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14005, 357, 'REG. CIVIL C/ FUNC NOTARIAIS - CASTELO NOVO', 133397, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14006, 8149, 'REGISTRO DE TITULOS E DOCUMENTOS', 137257, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14007, 8150, 'REGISTRO DE IMOVEIS - 1º OFICIO', 133355, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14008, 353, 'REGISTRO CIVIL DAS PESSOAS NATURAIS 1º OFICIO', 136069, 2913606, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14009, 180, 'CARTORIO DO REGISTRO CIVIL', 8557, 2913705, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14010, 8151, 'CARTORIO DO REGISTRO DE IMOVEIS', 10058, 2913705, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14011, 8152, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14399, 2913705, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14012, 7479, 'REGISTRO CIVIL DAS PESSOAS NATURAIS ', 12450, 2913804, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14013, 181, 'IPIAU - CARTORIO DE REGISTRO CIVIL - SEDE', 144295, 2913903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14014, 8153, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS', 137091, 2913903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14015, 8154, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTOS', 136572, 2913903, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14016, 7786, 'CARTORIO DO 8º TABELIONATO DE NOTAS DA COMARCA DE MANAUS/AM', 4523, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14017, 917, 'CARTORIO DO 6º OFICIO DO REGSITRO CIVIL DAS PESSOAS NATURAIS', 4499, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14018, 406, 'CARTORIO DO 3° OFICIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 4168, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14019, 7787, 'CARTORIO DO TERCEIRO OFICIO DE REGISTRO DE IMOVEIS E PROTESTO DE LETRAS', 4945, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14020, 7788, 'CARTORIO DO 9 TABELIONATO DE NOTAS', 4531, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14021, 7789, 'CARTORIO DO 5º OFICIO DE NOTAS ', 4473, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14022, 7790, 'TABELIONATO DE NOTAS E REGISTRO DE CONTRATOS MARITIMOS', 144840, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14023, 7791, '4º OFICIO DO REGISTRO DE IMOVEIS E PROTESTO DE TITULOS', 4176, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14024, 7792, 'SEXTO OFICIO DE PROTESTO DE LETRAS DA COMARCA DE MANAUS', 5041, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14025, 7793, '5º OFICIO DE PROTESTO DE LETRAS DA COMARCA DA CAPITAL', 4184, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14026, 7794, '1º OFICIO DE NOTAS', 4135, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14027, 404, '8º REGISTRO CIVIL DE PESSOAS NATURAIS DE MANAUS', 4200, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14028, 916, '12º REGISTRO CIVIL DE PESSOAS NATURAIS', 4127, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14029, 7795, '1 OFICIO DE REGISTRO DE IMOVEIS E PROTESTOS DE LETRAS', 4333, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14030, 403, 'CARTORIO DO 11º OFICIO DO REGISTRO CIVIL DE PESSOA NATURAIS.', 4358, 1302603, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14031, 408, 'CARTORIO DO 2° OFICIO DA COMARCA DE MANICORE', 4390, 1302702, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14032, 918, 'CARTORIO DO 1° OFICIO DA COMARCA DE MANICORE', 4366, 1302702, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14033, 499, 'CARTORIO JUDICIAL E ANEXOS DA COMARCA DE MARAA', 4986, 1302801, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14034, 409, 'CARTORIO DO 1º OFICIO DE MAUES ', 4382, 1302900, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14035, 410, 'CARTORIO DO 2º OFICIO JUDICIAL E ANEXOS DE MAUES.', 4432, 1302900, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14036, 411, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE NHAMUNDA', 4747, 1303007, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14037, 412, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE NOVA OLINDA DO NORTE ', 4754, 1303106, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14038, 413, 'CARTORIO DISTRITAL DO REGSITRO CIVIL DO 2º DISTRITO DE RIO CURUPIRA', 149161, 1303106, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14039, 414, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE NOVO AIRAO', 4762, 1303205, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14040, 500, 'CARTORIO DO JUDICIAL E ANEXOS DA COMARCA DE NOVO ARIPUANA', 4770, 1303304, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14041, 415, 'CARTORIO DO JUDICIAL E ANEXOS DO 1º OFICIO DA COMARCA DE PARINTINS', 4853, 1303403, 'AM');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14042, 576, 'REGISTRO CIVIL DAS PESSOAS NATURAIS ', 12468, 2905503, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14043, 7796, 'REGISTRO DE TITULOS, DOCUMENTOS E DAS PESSOAS JURIDICAS', 13391, 2905503, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14044, 577, 'REGISTRO CIVIL PESSOAS NATURAIS', 12880, 2905602, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14045, 8199, 'REGISTRO CIVIL COM FUNCOES NOTARIAS ¿ ACU DA TORRE', 140913, 2921005, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14046, 6910, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS', 6635, 2921005, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14047, 8200, 'REG. CIVIL C/ FUNCAO NOTARIAIS - ITANAGRA', 136408, 2921005, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14048, 230, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS', 12021, 2921005, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14049, 8201, 'TABELIONATO C/ FUNCAO DE PROTESTO', 133710, 2921005, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14050, 8202, 'CARTORIO DE REGISTRO DE IMOVEIS ', 7419, 2921005, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14051, 8203, 'TABELIONATO COM FUNCAO DE PROTESTO', 131730, 2921104, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14052, 8204, 'REGISTRO DE IMOVEIS HIP E TIT. E DOCS', 131722, 2921104, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14053, 8205, 'REG. CIVIL C/ FUNC NOTARIAIS - NOVA LIDICE', 131755, 2921104, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14054, 285, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 131714, 2921104, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14055, 8206, 'REGISTRO CIVIL C/ FUNC NOTARIAIS - ITUPEVA', 131748, 2921104, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14056, 8207, 'TEBALIONATO DE NOTAS COM FUNCOES DE PROTESTO', 15396, 2921203, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14057, 8208, 'CARTORIO DO REGISTRO DE IMOVEIS TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 10355, 2921203, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14058, 6695, 'REG. CIVIL C/ FUNC NOTARIAIS - TAPIRANGA', 131771, 2921203, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14059, 231, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9118, 2921203, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14060, 232, 'REGISTRO CIVIL - ITAPURA', 131763, 2921203, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14061, 24, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12237, 2921302, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14062, 8209, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14373, 2921302, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14063, 8210, 'CARTORIO DE REGISTRO DE IMOVEIS, TIT E HIPOTECAS', 8078, 2921302, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14064, 25, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS', 11924, 2921302, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14065, 286, 'REG. CIVIL C/ FUNCOES NOTARIAIS - TAQUARENDI', 133629, 2921401, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14066, 26, 'REG. CIVIL C/ FUNCOES NOTARIAIS - NUGUACU', 133603, 2921401, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14067, 8211, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS', 136622, 2921500, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14068, 8212, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 136614, 2921500, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14069, 8213, 'TABELIONATO C/ FUNC DE PROTESTO', 136630, 2921500, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14070, 8214, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 15164, 2921609, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14071, 8215, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS', 10439, 2921609, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14072, 287, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9597, 2921609, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14073, 8216, 'REGISTRO CIVIL COM FUNCOES NOTARIAIS - QUIXABA', 131797, 2921609, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14074, 8217, 'REG. CIVIL C/ FUNC NOTARIAIS - DIAS COELHO', 131821, 2921708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14075, 8218, 'CARTORIO DO TABELIONATO DE NOTAS C/FUNCAO DE PROTESTO', 10546, 2921708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14076, 8219, 'REG. CIVIL C/ FUNC. NOTARIAIS - ICO', 135749, 2921708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14077, 27, 'REGISTRO CIVIL C/ FUNC. NOTARIAIS - CAMIRIM', 12377, 2921708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14078, 29, 'CARTORIO DO REGISTRO CIVIL COM FUNCOES NOTARIAIS', 8888, 2921708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14079, 8220, 'REG. CIVIL C/ FUNC NOTARIAIS - CAFARNAUM', 135384, 2921708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14080, 31, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12518, 2921708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14081, 28, 'CARTORIO DO REGISTRO CIVIL C/FUNCOES NOTARIAIS', 8698, 2921708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14082, 8221, 'REG. CIVIL C/ FUNC NOTARIAIS - VENTURA', 131862, 2921708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14083, 30, 'CARTORIO REGISTRO CIVIL C/FUNCOES NOTARIAS', 10777, 2921708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14084, 8222, 'REG. CIVIL C/ FUNCAO NOTARIAIS - DUAS BARRAS', 136598, 2921708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14085, 8223, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS', 10231, 2921708, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14086, 7556, 'CARTORIO MARIA DOLORES', 143685, 2921807, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14087, 8224, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTO', 14688, 2921906, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14088, 8225, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS', 10165, 2921906, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14089, 33, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE GUINE', 9530, 2921906, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14090, 32, 'CARTORIO DE REGISTRO CIVIL DAS PESSOAS NATURAIS SEDE', 6320, 2921906, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14091, 8226, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9589, 2921906, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14092, 233, 'MUCURI - CARTORIO DE REGISTRO CIVIL - DISTRITO DE TAQUARINHA', 143834, 2922003, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14093, 8227, 'TABELIONATO C/ FUNCAO DE PROTESTO', 136663, 2922003, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14094, 8228, 'MUCURI - CARTORIO DE REGISTRO CIVIL - DISTRITO DE ITABATA', 143826, 2922003, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14095, 8229, 'REGISTRO DE IMOVEIS, HIP. E TIT E DOCS. ', 139998, 2916005, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14096, 8230, 'TABELIONATO COM FUNCAO DE PROTESTO', 140335, 2916005, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14097, 8231, 'REG. CIVIL C/ FUNC NOTARIAIS - VEREDA', 135137, 2916005, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14098, 8673, 'REGISTRO DE IMOVEIS E HIPOTECAS TIT E DOCUMENTOS', 13102, 2931350, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14099, 8674, 'TABELIONATO DE NOTAS E PROTESTO DO UNICO OFICIO ', 15123, 2931350, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14100, 7579, 'TEIXEIRA DE FREITAS - CARTORIO DE REGISTRO CIVIL - DISTRITO DE CACHOEIRA DO MATO', 144493, 2931350, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14101, 691, 'REGISTRO CIVIL COM FUNCOES NOTARIAS', 12088, 2931400, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14102, 689, 'TABELIONATO DE NOTAS COM FUNCAO DE PROTESTO', 14381, 2931400, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14103, 690, 'CARTORIO DO REGISTRO CIVIL', 8540, 2931400, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14104, 692, 'CARTORIO DE REGISTRO CIVIL COM FFUNCOES NOTARIAIS DO DISTRITO DE LUSTOSA', 5991, 2931400, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14105, 8675, 'REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E PESSOAS JURIDICAS', 13185, 2931400, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14106, 693, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9290, 2931509, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14107, 8676, 'PODER JUDICIARIO DO ESTADO DA BAHIA', 11585, 2931509, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14108, 8677, 'TABELIONATO DE NOTAS C/FUNCOES DE PROTESTOS', 14225, 2931509, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14109, 694, 'REGISTRO CIVIL', 11726, 2931608, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14110, 6918, 'CARTORIO DO REGISTRO CIVIL DAS PESOAS NATUIRAIS COM FUNCOES NOTARIAIS DO DISTRITO DE JACU - COMARCA DE TERRA NOVA - BAHIA', 9076, 2931707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14111, 696, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS COM FUNCOES NOTARIAIS', 9654, 2931707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14112, 8678, 'TABELIONATO DE NOTAS COM FUNCOES DE PROTESTOS', 14746, 2931707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14113, 695, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 15453, 2931707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14114, 8679, 'CARTORIO DO REGISTRO DE IMOVEIS/HIPOTECAS/TITULOS E DOCUMENTOS E REGISTRO CIVIL DE PESSOAS JURIDICAS', 10421, 2931707, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14115, 8680, 'TABELIONATO DE NOTAS', 13938, 2931806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14116, 698, 'REG. CIVIL C/ FUNCOES NOTARIAIS - LAGOA PRETA', 132761, 2931806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14117, 697, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 132753, 2931806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14118, 8681, 'REGISTRO DE IMOVEIS', 12948, 2931806, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14119, 8682, 'CARTORIO DE IMOVEIS, HIPOTECAS, TITULOS E DOCUMENTOS', 5678, 2931905, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14120, 8683, 'REG. CIVIL C/ FUNCOES NOTARIAIS - CALDAS DO JORRO', 132779, 2931905, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14121, 725, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12526, 2931905, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14122, 8684, 'NOTAS', 11478, 2931905, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14123, 8685, 'CARTORIO DO REGISTRO DE IMOVEIS E HIPOTECAS, TITULOS E DOCUMENTOS E DAS PESSOAS JURIDICAS', 10249, 2932002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14124, 728, 'CARTORIO DO REGISTRO CIVIL P NATURAIS', 9985, 2932002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14125, 727, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9100, 2932002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14126, 726, 'CARTORIO DO REGISTRO CIVIL DAS PESSOAS NATURAIS', 9241, 2932002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14127, 8686, 'TABELIONATO COM FUNCAO DE PROTESTO', 139626, 2932002, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14128, 8687, 'REGISTRO CIVIL DAS PESSOAS NATURAIS DO DISTRITO DE BAIXINHA, DA COMARCA DE UBAIRA (BA)', 12708, 2932101, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14129, 699, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12385, 2932101, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14130, 8688, 'TABELIONATO DE NOTAS DA COMARCA DE UBAIRA (BA)', 14878, 2932101, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14131, 729, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 12252, 2932101, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14132, 8689, 'REGISTRO DE IMOVEIS E HIPOTECAS DA COMARCA DE UBAIRA (BA)', 13078, 2932101, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14133, 8690, 'REG. CIVIL C/ FUNCOES NOTARIAIS - PIRAUNA', 132829, 2932200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14134, 8691, 'UBAITABA - CARTORIO DE REGISTRO CIVIL - DISTRITO DE TAPIRAMA', 144048, 2932200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14135, 8692, 'REG. CIVIL C/ FUNCOES NOTARIAIS - FAISQUEIRA', 132811, 2932200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14136, 730, 'REGISTRO CIVIL DAS PESSOAS NATURAIS', 139683, 2932200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14137, 8693, 'TABELIONATO DE NOTAS E PROTESTO DE TITULOIS', 15032, 2932200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14138, 700, 'REG. CIVIL C/ FUNC. NOTARIAIS - GONGOGI', 138180, 2932200, 'BA');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14139, 761, 'CARTORIO DO REGISTRO CIVIL DO DISTRITO DE BREJINHO', 18846, 2301307, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14140, 8694, 'CARTORIO DO SEGUNDO OFICIO DE ARARIPE', 19265, 2301307, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14141, 760, 'CARTORIO DO PRIMEIRO OFICIO E REGISTRO CIVIL', 18150, 2301307, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14142, 6853, 'CARTORIO DE OFICIO 1 E 2', 16626, 2301406, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14143, 763, 'CARTORIO DO 1. OFICIO ARNEIROZ-CE', 15867, 2301505, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14144, 762, 'CARTORIO PINTO FEITOSA', 19927, 2301505, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14145, 8695, 'CARTORIO DE REGISTRO CIVIL - DISTRITO DE AMARO', 136655, 2301604, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14146, 764, '1º SERVICO DE NOTAS E REGISTROS DE ASSARE ', 15800, 2301604, 'CE');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14147, 1023, 'CARTORIO DE REGISTRI CIVIL DA SEDE DA COMARCA DE BARRA DE SAO FRANCISCO, ESTADO DO ESPIRITO SANTO', 21972, 3200904, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14148, 1022, 'CARTORIO DE REGISTRO CIVIL E NOTAS', 22079, 3200904, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14149, 9018, 'CARTORIO DO PRIMEIRO OFICIO DE BOA ESPERANCA - ES', 22939, 3201001, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14150, 1026, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 23473, 3201001, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14151, 9019, 'CARTORIO DO 1º OFICIO', 22871, 3201100, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14152, 1027, 'CARTORIO DO RCPN E TABELIONATO DE BOM JESUS DO NORTE', 23291, 3201100, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14153, 6624, 'CARTORIO DE NOTAS E REGISTRO CIVIL', 21832, 3201159, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14154, 1032, 'CARTORIO DE NOTAS E REG. CIVIL SAO VICENTE', 21824, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14155, 6938, 'CARORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE GIRONDA', 21543, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14156, 1171, '1º CARTORIO REGISTRO CIVIL SEDE - CART.FERNANDO VIEIRA', 21345, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14157, 1043, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DO DITRITO DA GRUTA', 22707, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14158, 9020, 'CARTORIO DE REGISTRO DE TITULOS E DOCUMENTOS E PESSOAS JURIDICAS 1º OFICIO 2ª ZONA', 150516, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14159, 9021, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO CORREGO DOS MONOS', 22392, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14160, 1030, 'CARTORIO ITAOCA NOTAS E REGISTRO CIVIL ', 21592, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14161, 1031, 'CACHOEIRO DE ITAPEMIRIM CARTORIO DE NOTAS E REGISTRO CIVIL', 21519, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14162, 9022, 'CARTORIO DO 5º OFICIO DE NOTAS DE CACHOEIRO DE ITAPEMIRIM', 23234, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14163, 9023, 'CARTORIO DO 3° OFICIO - CARTORIO BRAGA', 23150, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14164, 9024, 'CARTORIO DE PROTESTO DE TITULOS E DOCUMENTOS - 2ª ZONA', 142604, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14165, 1176, 'CACHOEIRO DE ITAPEMIRIM CARTORIO DE REGISTRO CIVIL SEGUNDA ZONA', 21527, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14166, 1028, 'CARTORIO DE NOTAS E REGISTRO CIVIL DO DISTRITO DE COUTINHO', 21923, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14167, 9025, '1º OFICIO - CARTORIO DE REGISTRO DE IMOVEIS DA 2ª ZONA ', 22970, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14168, 9026, 'CARTORIO DO 4º OFICIO DE NOTAS', 23226, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14169, 1172, 'CARTORIO TIMOTHEO BARROS DO REGO - REG. CIVIL E TABELIONATO', 23887, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14170, 1173, 'REGISTRO CIVIL DE PACOTUBA MUNICIPIO DE CACHOEIRO DE ITAPEMIRIM/ES', 24240, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14171, 1174, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS DE BURARAMA', 22533, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14172, 9027, 'CARTORIO DO 1° OFICIO DE NOTAS', 150573, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14173, 9028, 'SERVICO NOTARIAL E REGISTRAL SERVENTIA EXTRAJUDICIAL 1º OFICIO - 1ª ZONA', 24588, 3201209, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14174, 1178, 'CARIACICA CARTORIO DE REGISTRO CIVIL E NOTAS', 21535, 3201308, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14175, 9029, 'CARTORIO DO TERCEIRO OFICIO DE CARIACICA', 23689, 3201308, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14176, 1177, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTAS DO DISTRITO DA SEDE DE CARIACICA-ES - 1º DISTRITO', 21873, 3201308, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14177, 9030, 'CARTORIO DO 1 OFICIO DE CARIACICA', 22806, 3201308, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14178, 1180, 'REGISTRO CIVIL E TABELIONATO', 24307, 3201407, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14179, 9031, 'CARTORIO DO 1º OFICIO', 22947, 3201407, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14180, 9032, 'CARTORIO DO 2º OFICIO DE CASTELO', 21717, 3201407, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14181, 1179, 'CASTELO CARTORIO DE NOTAS E REGISTRO CIVIL', 23945, 3201407, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14182, 1183, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO', 23507, 3201506, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14183, 9033, 'COLATINA CARTORIO 1° OFICIO ', 23960, 3201506, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14184, 1181, 'COLATINA CARTORIO REGISTRO CIVIL DE PESSOAS NATURAIS', 23986, 3201506, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14185, 1184, 'OFICIO DE REGISTRO CIVIL E TABELIONATO DE NOTAS - DISTRITO DE GRACA ARANHA', 145052, 3201506, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14186, 1186, 'CARTORIO VON SCHILGEN', 22301, 3201506, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14187, 9034, 'CARTORIO DO 3º OFICIO DE NOTAS', 23192, 3201506, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14188, 1182, 'CARTORIO DE NOTAS E REGISTRO CIVIL', 21840, 3201506, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14189, 1185, 'COLATINA CARTORIO DO REGISTRO CIVIL E NOTAS', 23978, 3201506, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14190, 6860, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DO DISTRITO DE ANGELO FRECHIANI', 23325, 3201506, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14191, 1187, 'BOAPABA CARTORIO DE REGISTRO CIVIL E NOTAS', 21501, 3201506, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14192, 1046, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO DO DISTRITO DE BRACO DO RIO', 23432, 3201605, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14193, 1045, 'CARTORIO DE REGISTRO CIVIL E TABELIONATO - SEDE', 22368, 3201605, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14194, 9035, 'CARTORIO 1º OFICIO ', 21626, 3201605, 'ES');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14195, 7311, 'CARTORIO DE REGISTRO CIVIL DE PESSOAS NATURAIS, JURIDICAS E DE TITULOS E DOCUMENTOS DE SARANDI', 81380, 4126256, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14196, 7322, 'CARTORIO MEYER', 82768, 4107652, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14197, 7323, 'FLORAI - TABELIONATO', 130765, 4107801, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14198, 7325, 'SERVICO NOTARIAL E REGISTRAL MARTINI.', 86850, 4110409, 'PR');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14199, 7178, 'ESCRIVANIA DE PAZ DO DISTRITO DE BARREIROS', 149922, 4216602, 'SC');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14200, 7191, 'OFICIAL DE REGISTRO CIVIL DAS PESSOAS NATURAIS E DE INTERDICOES E TUTELAS DO 1º SUBDISTRITO DA SEDE DA COMARCA DE LINS', 116533, 3527108, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14201, 7204, 'CARTORIO DE REGISTRO CIVIL E ANEXOS', 114041, 3552007, 'SP');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14202, 7206, 'CARTORIO REGISTRO CIVIL DE RIACHINHO', 128827, 1701002, 'TO');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14203, 7207, 'CARTORIO DO REGISTRO CIVIL E TABELIONATO DO 1º DISTRITO', 91454, 3300605, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14204, 7208, 'CARTORIO DO REGISTRO CIVIL DE PESSOAS NATURAIS E TABELIONATO DE NOTA DO 3º DISTRITO DA COMARCA DE CAMBUCI-RJ', 91447, 3300902, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14205, 7209, 'CAMPOS CARTORIO DO 3º DISTRITO DE NOTAS', 89482, 3301009, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14206, 7211, 'R.C.P.N. DO 3º DISTRITO DA COMARCA DE CANTAGALO', 92395, 3301108, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14207, 7212, 'R.C.P.N. DO 5º DISTRITO DE CANTAGALO', 92411, 3301108, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14208, 7214, 'CARTORIO REGISTRO CIVIL DASPESSOAS NATURAIS 2º DISTRITO - AFONSO ARINOS', 91629, 3300951, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14209, 7215, 'CARTORIO RCPN DE CORDEIRO/RJ', 91587, 3301504, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14210, 7216, 'RCPN 1º DISTRITO DE ENGENHEIRO PAULO DE FRONTIN', 92551, 3301801, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14211, 7217, 'RCPN DO 5º DISTRITO DE ITAPERUNA - RJ', 92882, 3302205, 'RJ');
INSERT INTO cadastro.codigo_cartorio_inep VALUES (14212, 7219, 'CARTORIO RCPN DE MACUCO', 91595, 3302452, 'RJ');


--
-- TOC entry 8214 (class 0 OID 0)
-- Dependencies: 845
-- Name: codigo_cartorio_inep_id_seq; Type: SEQUENCE SET; Schema: cadastro; Owner: -
--

SELECT pg_catalog.setval('cadastro.codigo_cartorio_inep_id_seq', 14212, true);


--
-- TOC entry 7591 (class 0 OID 9443280)
-- Dependencies: 295
-- Data for Name: deficiencia; Type: TABLE DATA; Schema: cadastro; Owner: -
--

INSERT INTO cadastro.deficiencia VALUES (8, 'Deficiência Mental', NULL, false);
INSERT INTO cadastro.deficiencia VALUES (10, 'Autismo Clássico', NULL, false);
INSERT INTO cadastro.deficiencia VALUES (11, 'Síndrome de Asperger', NULL, false);
INSERT INTO cadastro.deficiencia VALUES (12, 'Síndrome de Rett', NULL, false);
INSERT INTO cadastro.deficiencia VALUES (13, 'Transtorno desintegrativo da infância (psicose infantil)', NULL, false);
INSERT INTO cadastro.deficiencia VALUES (14, 'Altas Habilidades/Superdotação', NULL, false);
INSERT INTO cadastro.deficiencia VALUES (2, 'Cegueira', 1, false);
INSERT INTO cadastro.deficiencia VALUES (3, 'Baixa Visão', 2, false);
INSERT INTO cadastro.deficiencia VALUES (4, 'Surdez', 3, false);
INSERT INTO cadastro.deficiencia VALUES (5, 'Deficiência Auditiva', 4, false);
INSERT INTO cadastro.deficiencia VALUES (6, 'Surdocegueira', 5, false);
INSERT INTO cadastro.deficiencia VALUES (7, 'Deficiência Física', 6, false);
INSERT INTO cadastro.deficiencia VALUES (9, 'Deficiência Múltipla', 8, false);


--
-- TOC entry 8215 (class 0 OID 0)
-- Dependencies: 294
-- Name: deficiencia_cod_deficiencia_seq; Type: SEQUENCE SET; Schema: cadastro; Owner: -
--

SELECT pg_catalog.setval('cadastro.deficiencia_cod_deficiencia_seq', 15, false);


--
-- TOC entry 7592 (class 0 OID 9443284)
-- Dependencies: 296
-- Data for Name: documento; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 7593 (class 0 OID 9443293)
-- Dependencies: 297
-- Data for Name: endereco_externo; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 7594 (class 0 OID 9443303)
-- Dependencies: 298
-- Data for Name: endereco_pessoa; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 7595 (class 0 OID 9443312)
-- Dependencies: 299
-- Data for Name: escolaridade; Type: TABLE DATA; Schema: cadastro; Owner: -
--

INSERT INTO cadastro.escolaridade VALUES (1, 'Fundamental Incompleto', 1);
INSERT INTO cadastro.escolaridade VALUES (2, 'Fundamental Completo', 2);
INSERT INTO cadastro.escolaridade VALUES (3, 'Ensino Médio (Normal/Magistério)', 3);
INSERT INTO cadastro.escolaridade VALUES (4, 'Ensino Médio (Normal/Magistério Indígena)', 4);
INSERT INTO cadastro.escolaridade VALUES (5, 'Ensino Médio', 5);
INSERT INTO cadastro.escolaridade VALUES (6, 'Superior Completo', 6);


--
-- TOC entry 7596 (class 0 OID 9443315)
-- Dependencies: 300
-- Data for Name: estado_civil; Type: TABLE DATA; Schema: cadastro; Owner: -
--

INSERT INTO cadastro.estado_civil VALUES (1, 'Solteiro(a)');
INSERT INTO cadastro.estado_civil VALUES (2, 'Casado(a)');
INSERT INTO cadastro.estado_civil VALUES (3, 'Divorciado(a)');
INSERT INTO cadastro.estado_civil VALUES (4, 'Separado(a)');
INSERT INTO cadastro.estado_civil VALUES (5, 'Viúvo(a)');
INSERT INTO cadastro.estado_civil VALUES (6, 'Companheiro(a)');


--
-- TOC entry 7597 (class 0 OID 9443318)
-- Dependencies: 301
-- Data for Name: fisica; Type: TABLE DATA; Schema: cadastro; Owner: -
--

INSERT INTO cadastro.fisica VALUES (1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'M', NULL, '2010-01-06 18:30:32.475015', 'I', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL);


--
-- TOC entry 7598 (class 0 OID 9443329)
-- Dependencies: 302
-- Data for Name: fisica_cpf; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 7599 (class 0 OID 9443337)
-- Dependencies: 303
-- Data for Name: fisica_deficiencia; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 7600 (class 0 OID 9443340)
-- Dependencies: 304
-- Data for Name: fisica_foto; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 7601 (class 0 OID 9443343)
-- Dependencies: 305
-- Data for Name: fisica_raca; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 7602 (class 0 OID 9443346)
-- Dependencies: 306
-- Data for Name: fisica_sangue; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 7603 (class 0 OID 9443349)
-- Dependencies: 307
-- Data for Name: fone_pessoa; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 7604 (class 0 OID 9443358)
-- Dependencies: 308
-- Data for Name: funcionario; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 7605 (class 0 OID 9443367)
-- Dependencies: 309
-- Data for Name: historico_cartao; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 7606 (class 0 OID 9443371)
-- Dependencies: 310
-- Data for Name: juridica; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 7607 (class 0 OID 9443379)
-- Dependencies: 311
-- Data for Name: ocupacao; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 7609 (class 0 OID 9443384)
-- Dependencies: 313
-- Data for Name: orgao_emissor_rg; Type: TABLE DATA; Schema: cadastro; Owner: -
--

INSERT INTO cadastro.orgao_emissor_rg VALUES (8, 'CRA', 'Conselho Regional de Administração', 'I', 61);
INSERT INTO cadastro.orgao_emissor_rg VALUES (10, 'CRB', 'Conselho Regional de Biblioteconomia', 'I', 63);
INSERT INTO cadastro.orgao_emissor_rg VALUES (11, 'CRC', 'Conselho Regional de Contabilidade', 'I', 64);
INSERT INTO cadastro.orgao_emissor_rg VALUES (12, 'CRECI', 'Conselho Regional de Corretores Imóveis', 'I', 65);
INSERT INTO cadastro.orgao_emissor_rg VALUES (14, 'CREA', 'Conselho Regional de Engenharia, Arquitetura e Agronomia', 'I', 67);
INSERT INTO cadastro.orgao_emissor_rg VALUES (18, 'CRM', 'Conselho Regional de Medicina', 'I', 71);
INSERT INTO cadastro.orgao_emissor_rg VALUES (20, 'OMB', 'Ordem dos Músicos do Brasil', 'I', 73);
INSERT INTO cadastro.orgao_emissor_rg VALUES (22, 'CRO', 'Conselho Regional de Odontologia', 'I', 75);
INSERT INTO cadastro.orgao_emissor_rg VALUES (24, 'CRP', 'Conselho Regional de Psicologia', 'I', 77);
INSERT INTO cadastro.orgao_emissor_rg VALUES (25, 'CRQ', 'Conselho Regional de Química', 'I', 78);
INSERT INTO cadastro.orgao_emissor_rg VALUES (27, 'OAB', 'Ordem dos Advogados do Brasil', 'I', 80);
INSERT INTO cadastro.orgao_emissor_rg VALUES (13, 'COREN', 'Conselho Regional de Enfermagem', 'I', 66);
INSERT INTO cadastro.orgao_emissor_rg VALUES (16, 'CRF', 'Conselho Regional de Farmácia', 'I', 69);
INSERT INTO cadastro.orgao_emissor_rg VALUES (21, 'CRN', 'Conselho Regional de Nutrição', 'I', 74);
INSERT INTO cadastro.orgao_emissor_rg VALUES (2, 'M MILITAR', 'Ministérios Militares', 'I', 40);
INSERT INTO cadastro.orgao_emissor_rg VALUES (3, 'MAE', 'Ministério da Aeronáutica', 'I', 41);
INSERT INTO cadastro.orgao_emissor_rg VALUES (4, 'MEX', 'Ministério do Exército', 'I', 42);
INSERT INTO cadastro.orgao_emissor_rg VALUES (5, 'MMA', 'Ministério da Marinha', 'I', 43);
INSERT INTO cadastro.orgao_emissor_rg VALUES (6, 'DPF', 'Polícia Federal', 'I', 44);
INSERT INTO cadastro.orgao_emissor_rg VALUES (7, 'I CLA', 'Carteira de Identidade Classista', 'I', 60);
INSERT INTO cadastro.orgao_emissor_rg VALUES (9, 'CRAS', 'Conselho Regional de Assist. Social', 'I', 62);
INSERT INTO cadastro.orgao_emissor_rg VALUES (15, 'CRE', 'Conselho Regional de Estatística', 'I', 68);
INSERT INTO cadastro.orgao_emissor_rg VALUES (17, 'CREFIT', 'Conselho Regional de Fisioterapia e Terapia Ocupacional', 'I', 70);
INSERT INTO cadastro.orgao_emissor_rg VALUES (19, 'CRV', 'Conselho Regional de Medicina Veterinária', 'I', 72);
INSERT INTO cadastro.orgao_emissor_rg VALUES (23, 'CRPRE', 'Conselho Regional de Profissionais de Relações Públicas', 'I', 76);
INSERT INTO cadastro.orgao_emissor_rg VALUES (26, 'CRRC', 'Conselho Regional de Representantes Comerciais', 'I', 79);
INSERT INTO cadastro.orgao_emissor_rg VALUES (28, 'OUTRO', 'Outros Emissores', 'I', 81);
INSERT INTO cadastro.orgao_emissor_rg VALUES (29, 'EST', 'Documento Estrangeiro', 'I', 82);
INSERT INTO cadastro.orgao_emissor_rg VALUES (31, 'DETRAN', 'Departamento Estadual de Trânsito', 'I', 83);
INSERT INTO cadastro.orgao_emissor_rg VALUES (1, 'SSP', 'Secretaria de Segurança Pública', 'I', 10);


--
-- TOC entry 8216 (class 0 OID 0)
-- Dependencies: 312
-- Name: orgao_emissor_rg_idorg_rg_seq; Type: SEQUENCE SET; Schema: cadastro; Owner: -
--

SELECT pg_catalog.setval('cadastro.orgao_emissor_rg_idorg_rg_seq', 31, true);


--
-- TOC entry 7610 (class 0 OID 9443389)
-- Dependencies: 314
-- Data for Name: pessoa; Type: TABLE DATA; Schema: cadastro; Owner: -
--

INSERT INTO cadastro.pessoa VALUES (1, 'Administrador', NULL, '2010-01-06 18:30:32.510871', NULL, 'F', NULL, NULL, '', 'A', 'M', 'I', NULL, 1);


--
-- TOC entry 7611 (class 0 OID 9443397)
-- Dependencies: 315
-- Data for Name: pessoa_fonetico; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 7613 (class 0 OID 9443402)
-- Dependencies: 317
-- Data for Name: raca; Type: TABLE DATA; Schema: cadastro; Owner: -
--

INSERT INTO cadastro.raca VALUES (1, NULL, 1, 'Branca', '2010-12-22 17:09:31.64', NULL, true, 1);
INSERT INTO cadastro.raca VALUES (2, NULL, 1, 'Preta', '2010-12-22 17:09:31.64', NULL, true, 2);
INSERT INTO cadastro.raca VALUES (3, NULL, 1, 'Parda', '2010-12-22 17:09:31.64', NULL, true, 3);
INSERT INTO cadastro.raca VALUES (4, NULL, 1, 'Amarela', '2010-12-22 17:09:31.64', NULL, true, 4);
INSERT INTO cadastro.raca VALUES (5, NULL, 1, 'Indígena', '2010-12-22 17:09:31.64', NULL, true, 5);
INSERT INTO cadastro.raca VALUES (6, NULL, 1, 'Não Declarada', '2010-12-22 17:09:31.64', NULL, true, 0);


--
-- TOC entry 8217 (class 0 OID 0)
-- Dependencies: 316
-- Name: raca_cod_raca_seq; Type: SEQUENCE SET; Schema: cadastro; Owner: -
--

SELECT pg_catalog.setval('cadastro.raca_cod_raca_seq', 1, false);


--
-- TOC entry 7615 (class 0 OID 9443409)
-- Dependencies: 319
-- Data for Name: religiao; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 8218 (class 0 OID 0)
-- Dependencies: 318
-- Name: religiao_cod_religiao_seq; Type: SEQUENCE SET; Schema: cadastro; Owner: -
--

SELECT pg_catalog.setval('cadastro.religiao_cod_religiao_seq', 1, false);


--
-- TOC entry 8219 (class 0 OID 0)
-- Dependencies: 320
-- Name: seq_pessoa; Type: SEQUENCE SET; Schema: cadastro; Owner: -
--

SELECT pg_catalog.setval('cadastro.seq_pessoa', 3, true);


--
-- TOC entry 7617 (class 0 OID 9443416)
-- Dependencies: 321
-- Data for Name: socio; Type: TABLE DATA; Schema: cadastro; Owner: -
--



--
-- TOC entry 7621 (class 0 OID 9443485)
-- Dependencies: 332
-- Data for Name: campo_consistenciacao; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--

INSERT INTO consistenciacao.campo_consistenciacao VALUES (1, 'CPF ou CNPJ', 'N', 14);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (2, 'Nome pessoa física ou jurídica', 'N', 150);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (3, 'E-mail', 'N', 50);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (4, 'URL', 'N', 60);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (5, 'Data nascimento', 'N', 20);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (6, 'Número RG', 'N', 10);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (7, 'Órgão expedidor RG', 'S', 20);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (8, 'Data expedição RG', 'N', 20);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (9, 'UF expedição RG', 'S', 30);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (10, 'Tipo certidão civil', 'S', 2);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (11, 'Número termo certidão civil', 'N', 8);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (12, 'Número livro certidão civil', 'N', 8);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (13, 'Número folha certidão civil', 'N', 4);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (14, 'Data emissão certidão civil', 'N', 20);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (15, 'Cartório emissor certidão civil', 'N', 150);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (16, 'UF emissão certidão civil', 'S', 30);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (17, 'Número carteira trabalho', 'N', 7);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (18, 'Número série carteira trabalho', 'N', 5);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (19, 'Data emissão carteira trabalho', 'N', 20);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (20, 'UF emissão carteira trabalho', 'S', 30);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (21, 'Número título de eleitor', 'N', 13);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (22, 'Número zona título eleitor', 'N', 4);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (23, 'Número seção título eleitor', 'N', 4);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (24, 'Nome fantasia pessoa jurídica', 'N', 50);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (25, 'Número inscrição estadual', 'N', 10);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (26, 'Sexo pessoa física', 'S', 10);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (27, 'Nome mãe', 'N', 150);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (28, 'Nome pai', 'N', 150);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (29, 'Nome cônjuge', 'N', 150);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (30, 'Nome responsável', 'N', 150);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (31, 'Nome última empresa', 'N', 150);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (32, 'Ocupação profissional', 'S', 250);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (33, 'Escolaridade', 'S', 60);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (34, 'Estado civil', 'S', 15);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (35, 'País de origem(se estrangeiro)', 'S', 60);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (36, 'Data chegada ao Brasil', 'N', 20);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (37, 'Data óbito', 'N', 20);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (38, 'Data união com cônjuge', 'N', 20);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (39, 'DDD telefone residencial', 'N', 3);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (40, 'Telefone residencial', 'N', 8);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (41, 'DDD telefone comercial', 'N', 3);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (42, 'Telefone comercial', 'N', 8);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (43, 'DDD telefone celular', 'N', 3);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (44, 'Telefone celular', 'N', 8);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (45, 'DDD fax', 'N', 3);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (46, 'Fax', 'N', 8);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (47, 'Logradouro (end. correspondência)', 'N', 150);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (48, 'Tipo logradouro (end. correspondência)', 'S', 15);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (49, 'Número (end. correspondência)', 'N', 6);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (50, 'Letra (end. correspondência)', 'N', 1);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (51, 'Complemento (end. correspondência)', 'N', 20);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (52, 'Bairro (end. correspondência)', 'N', 40);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (53, 'CEP (end. correspondência)', 'N', 8);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (54, 'Cidade (end. correspondência)', 'N', 60);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (55, 'UF (end. correspondência)', 'S', 30);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (56, 'Logradouro (end. residencial)', 'N', 150);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (57, 'Tipo logradouro (end. residencial)', 'S', 15);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (58, 'Número (end. residencial)', 'N', 6);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (59, 'Letra (end. residencial)', 'N', 1);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (60, 'Complemento (end. residencial)', 'N', 20);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (61, 'Bairro (end. residencial)', 'N', 40);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (62, 'CEP (end. residencial)', 'N', 8);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (63, 'Cidade (end. residencial)', 'N', 60);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (64, 'UF (end. residencial)', 'S', 30);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (65, 'Logradouro (end. comercial)', 'N', 150);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (66, 'Tipo logradouro (end. comercial)', 'S', 15);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (67, 'Número (end. comercial)', 'N', 6);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (68, 'Letra (end. comercial)', 'N', 1);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (69, 'Complemento (end. comercial)', 'N', 20);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (70, 'Bairro (end. comercial)', 'N', 40);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (71, 'CEP (end. comercial)', 'N', 8);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (72, 'Cidade (end. comercial)', 'N', 60);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (73, 'UF (end. comercial)', 'S', 30);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (74, 'Logradouro (correspondência ou residencial)', 'N', 150);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (75, 'Tipo logradouro (correspondência ou residencial)', 'S', 15);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (76, 'Número (correspondência ou residencial)', 'N', 6);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (77, 'Letra (correspondência ou residencial)', 'N', 1);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (78, 'Complemento (correspondência ou residencial)', 'N', 20);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (79, 'Bairro (correspondência ou residencial)', 'N', 40);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (80, 'CEP (correspondência ou residencial)', 'N', 8);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (81, 'Cidade (correspondência ou residencial)', 'N', 60);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (82, 'UF (correspondência ou residencial)', 'S', 30);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (83, 'Logradouro (correspondência ou comercial)', 'N', 150);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (84, 'Tipo logradouro (correspondência ou comercial)', 'S', 15);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (85, 'Número (correspondência ou comercial)', 'N', 6);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (86, 'Letra (correspondência ou comercial)', 'N', 1);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (87, 'Complemento (correspondência ou comercial)', 'N', 20);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (88, 'Bairro (correspondência ou comercial)', 'N', 40);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (89, 'CEP (correspondência ou comercial)', 'N', 8);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (90, 'Cidade (correspondência ou comercial)', 'N', 60);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (91, 'UF (correspondência ou comercial)', 'S', 30);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (92, 'DDD telefone comercial ou residencial', 'N', 3);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (93, 'Telefone comercial ou residencial', 'N', 8);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (94, 'CPF', 'N', 14);
INSERT INTO consistenciacao.campo_consistenciacao VALUES (95, 'CNPJ', 'N', 14);


--
-- TOC entry 7623 (class 0 OID 9443491)
-- Dependencies: 334
-- Data for Name: campo_metadado; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--



--
-- TOC entry 8220 (class 0 OID 0)
-- Dependencies: 333
-- Name: campo_metadado_id_campo_met_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: -
--

SELECT pg_catalog.setval('consistenciacao.campo_metadado_id_campo_met_seq', 1, false);


--
-- TOC entry 7625 (class 0 OID 9443499)
-- Dependencies: 336
-- Data for Name: confrontacao; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--



--
-- TOC entry 8221 (class 0 OID 0)
-- Dependencies: 335
-- Name: confrontacao_idcon_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: -
--

SELECT pg_catalog.setval('consistenciacao.confrontacao_idcon_seq', 1, false);


--
-- TOC entry 7627 (class 0 OID 9443505)
-- Dependencies: 338
-- Data for Name: fonte; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--



--
-- TOC entry 8222 (class 0 OID 0)
-- Dependencies: 337
-- Name: fonte_idfon_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: -
--

SELECT pg_catalog.setval('consistenciacao.fonte_idfon_seq', 1, false);


--
-- TOC entry 7628 (class 0 OID 9443510)
-- Dependencies: 339
-- Data for Name: historico_campo; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--



--
-- TOC entry 7630 (class 0 OID 9443516)
-- Dependencies: 341
-- Data for Name: incoerencia; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--



--
-- TOC entry 7632 (class 0 OID 9443525)
-- Dependencies: 343
-- Data for Name: incoerencia_documento; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--



--
-- TOC entry 8223 (class 0 OID 0)
-- Dependencies: 342
-- Name: incoerencia_documento_id_inc_doc_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: -
--

SELECT pg_catalog.setval('consistenciacao.incoerencia_documento_id_inc_doc_seq', 1, false);


--
-- TOC entry 7634 (class 0 OID 9443531)
-- Dependencies: 345
-- Data for Name: incoerencia_endereco; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--



--
-- TOC entry 8224 (class 0 OID 0)
-- Dependencies: 344
-- Name: incoerencia_endereco_id_inc_end_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: -
--

SELECT pg_catalog.setval('consistenciacao.incoerencia_endereco_id_inc_end_seq', 1, false);


--
-- TOC entry 7636 (class 0 OID 9443538)
-- Dependencies: 347
-- Data for Name: incoerencia_fone; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--



--
-- TOC entry 8225 (class 0 OID 0)
-- Dependencies: 346
-- Name: incoerencia_fone_id_inc_fone_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: -
--

SELECT pg_catalog.setval('consistenciacao.incoerencia_fone_id_inc_fone_seq', 1, false);


--
-- TOC entry 8226 (class 0 OID 0)
-- Dependencies: 340
-- Name: incoerencia_idinc_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: -
--

SELECT pg_catalog.setval('consistenciacao.incoerencia_idinc_seq', 1, false);


--
-- TOC entry 7637 (class 0 OID 9443543)
-- Dependencies: 348
-- Data for Name: incoerencia_pessoa_possivel; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--



--
-- TOC entry 7638 (class 0 OID 9443546)
-- Dependencies: 349
-- Data for Name: incoerencia_tipo_incoerencia; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--



--
-- TOC entry 7640 (class 0 OID 9443551)
-- Dependencies: 351
-- Data for Name: metadado; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--



--
-- TOC entry 8227 (class 0 OID 0)
-- Dependencies: 350
-- Name: metadado_idmet_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: -
--

SELECT pg_catalog.setval('consistenciacao.metadado_idmet_seq', 1, false);


--
-- TOC entry 7641 (class 0 OID 9443556)
-- Dependencies: 352
-- Data for Name: ocorrencia_regra_campo; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--



--
-- TOC entry 7643 (class 0 OID 9443564)
-- Dependencies: 354
-- Data for Name: regra_campo; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--



--
-- TOC entry 8228 (class 0 OID 0)
-- Dependencies: 353
-- Name: regra_campo_idreg_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: -
--

SELECT pg_catalog.setval('consistenciacao.regra_campo_idreg_seq', 1, false);


--
-- TOC entry 7644 (class 0 OID 9443569)
-- Dependencies: 355
-- Data for Name: temp_cadastro_unificacao_cmf; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--



--
-- TOC entry 7645 (class 0 OID 9443575)
-- Dependencies: 356
-- Data for Name: temp_cadastro_unificacao_siam; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--



--
-- TOC entry 7646 (class 0 OID 9443578)
-- Dependencies: 357
-- Data for Name: tipo_incoerencia; Type: TABLE DATA; Schema: consistenciacao; Owner: -
--



--
-- TOC entry 7647 (class 0 OID 9443581)
-- Dependencies: 358
-- Data for Name: bairro; Type: TABLE DATA; Schema: historico; Owner: -
--



--
-- TOC entry 7648 (class 0 OID 9443589)
-- Dependencies: 359
-- Data for Name: cep_logradouro; Type: TABLE DATA; Schema: historico; Owner: -
--



--
-- TOC entry 7649 (class 0 OID 9443597)
-- Dependencies: 360
-- Data for Name: cep_logradouro_bairro; Type: TABLE DATA; Schema: historico; Owner: -
--



--
-- TOC entry 7650 (class 0 OID 9443605)
-- Dependencies: 361
-- Data for Name: documento; Type: TABLE DATA; Schema: historico; Owner: -
--



--
-- TOC entry 7651 (class 0 OID 9443614)
-- Dependencies: 362
-- Data for Name: endereco_externo; Type: TABLE DATA; Schema: historico; Owner: -
--



--
-- TOC entry 7652 (class 0 OID 9443623)
-- Dependencies: 363
-- Data for Name: endereco_pessoa; Type: TABLE DATA; Schema: historico; Owner: -
--



--
-- TOC entry 7653 (class 0 OID 9443632)
-- Dependencies: 364
-- Data for Name: fisica; Type: TABLE DATA; Schema: historico; Owner: -
--



--
-- TOC entry 7654 (class 0 OID 9443642)
-- Dependencies: 365
-- Data for Name: fisica_cpf; Type: TABLE DATA; Schema: historico; Owner: -
--



--
-- TOC entry 7655 (class 0 OID 9443650)
-- Dependencies: 366
-- Data for Name: fone_pessoa; Type: TABLE DATA; Schema: historico; Owner: -
--



--
-- TOC entry 7656 (class 0 OID 9443659)
-- Dependencies: 367
-- Data for Name: funcionario; Type: TABLE DATA; Schema: historico; Owner: -
--



--
-- TOC entry 7657 (class 0 OID 9443668)
-- Dependencies: 368
-- Data for Name: juridica; Type: TABLE DATA; Schema: historico; Owner: -
--



--
-- TOC entry 7658 (class 0 OID 9443676)
-- Dependencies: 369
-- Data for Name: logradouro; Type: TABLE DATA; Schema: historico; Owner: -
--



--
-- TOC entry 7659 (class 0 OID 9443685)
-- Dependencies: 370
-- Data for Name: municipio; Type: TABLE DATA; Schema: historico; Owner: -
--

INSERT INTO historico.municipio VALUES (43, 'Sao Felipe D Oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.747041', 'I');
INSERT INTO historico.municipio VALUES (197, 'Eldorado dos Carajas', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.917067', 'I');
INSERT INTO historico.municipio VALUES (258, 'Santa Isabel do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.990198', 'I');
INSERT INTO historico.municipio VALUES (684, 'Barra D Alcantara', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.457797', 'I');
INSERT INTO historico.municipio VALUES (809, 'Olho D Agua do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.590304', 'I');
INSERT INTO historico.municipio VALUES (976, 'Itapage', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.777235', 'I');
INSERT INTO historico.municipio VALUES (1184, 'Presidente Juscelino', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.010971', 'I');
INSERT INTO historico.municipio VALUES (1539, 'Iguaraci', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.397826', 'I');
INSERT INTO historico.municipio VALUES (2773, 'Olhos-d Agua', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.728505', 'I');
INSERT INTO historico.municipio VALUES (5278, 'Poxoreo', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.486341', 'I');
INSERT INTO historico.municipio VALUES (1, 'Alta Floresta D''oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.699228', 'I');
INSERT INTO historico.municipio VALUES (5, 'Ariquemes', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.703562', 'I');
INSERT INTO historico.municipio VALUES (7, 'Cabixi', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.7053', 'I');
INSERT INTO historico.municipio VALUES (9, 'Cacoal', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.707047', 'I');
INSERT INTO historico.municipio VALUES (13, 'Cerejeiras', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.711055', 'I');
INSERT INTO historico.municipio VALUES (15, 'Colorado do Oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.712932', 'I');
INSERT INTO historico.municipio VALUES (16, 'Corumbiara', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.713842', 'I');
INSERT INTO historico.municipio VALUES (17, 'Costa Marques', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.714738', 'I');
INSERT INTO historico.municipio VALUES (19, 'Espigao D''oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.716704', 'I');
INSERT INTO historico.municipio VALUES (21, 'Guajara-mirim', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.718803', 'I');
INSERT INTO historico.municipio VALUES (23, 'Jaru', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.720746', 'I');
INSERT INTO historico.municipio VALUES (24, 'Ji-parana', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.721775', 'I');
INSERT INTO historico.municipio VALUES (25, 'Machadinho D''oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.722776', 'I');
INSERT INTO historico.municipio VALUES (29, 'Nova Brasilandia D''oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.73323', 'I');
INSERT INTO historico.municipio VALUES (33, 'Ouro Preto do Oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.737108', 'I');
INSERT INTO historico.municipio VALUES (35, 'Pimenta Bueno', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.73925', 'I');
INSERT INTO historico.municipio VALUES (37, 'Porto Velho', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.741221', 'I');
INSERT INTO historico.municipio VALUES (38, 'Presidente Medici', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.742117', 'I');
INSERT INTO historico.municipio VALUES (40, 'Rio Crespo', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.744066', 'I');
INSERT INTO historico.municipio VALUES (41, 'Rolim de Moura', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.745017', 'I');
INSERT INTO historico.municipio VALUES (42, 'Santa Luzia D''oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.745909', 'I');
INSERT INTO historico.municipio VALUES (52, 'Vilhena', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.754961', 'I');
INSERT INTO historico.municipio VALUES (45, 'Sao Miguel do Guapore', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.748533', 'I');
INSERT INTO historico.municipio VALUES (30, 'Nova Mamore', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.734184', 'I');
INSERT INTO historico.municipio VALUES (4, 'Alvorada D''oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.70262', 'I');
INSERT INTO historico.municipio VALUES (2, 'Alto Alegre dos Parecis', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.700901', 'I');
INSERT INTO historico.municipio VALUES (3, 'Alto Paraiso', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.701715', 'I');
INSERT INTO historico.municipio VALUES (6, 'Buritis', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.704461', 'I');
INSERT INTO historico.municipio VALUES (32, 'Novo Horizonte do Oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.73613', 'I');
INSERT INTO historico.municipio VALUES (8, 'Cacaulandia', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.706175', 'I');
INSERT INTO historico.municipio VALUES (10, 'Campo Novo de Rondonia', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.70796', 'I');
INSERT INTO historico.municipio VALUES (11, 'Candeias do Jamari', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.708884', 'I');
INSERT INTO historico.municipio VALUES (12, 'Castanheiras', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.709859', 'I');
INSERT INTO historico.municipio VALUES (14, 'Chupinguaia', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.711993', 'I');
INSERT INTO historico.municipio VALUES (18, 'Cujubim', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.715723', 'I');
INSERT INTO historico.municipio VALUES (20, 'Governador Jorge Teixeira', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.717717', 'I');
INSERT INTO historico.municipio VALUES (22, 'Itapua do Oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.719743', 'I');
INSERT INTO historico.municipio VALUES (26, 'Ministro Andreazza', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.723813', 'I');
INSERT INTO historico.municipio VALUES (27, 'Mirante da Serra', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.725075', 'I');
INSERT INTO historico.municipio VALUES (28, 'Monte Negro', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.731957', 'I');
INSERT INTO historico.municipio VALUES (31, 'Nova Uniao', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.735123', 'I');
INSERT INTO historico.municipio VALUES (34, 'Parecis', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.738213', 'I');
INSERT INTO historico.municipio VALUES (36, 'Pimenteiras do Oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.740233', 'I');
INSERT INTO historico.municipio VALUES (39, 'Primavera de Rondonia', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.743068', 'I');
INSERT INTO historico.municipio VALUES (44, 'Sao Francisco do Guapore', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.747752', 'I');
INSERT INTO historico.municipio VALUES (46, 'Seringueiras', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.749422', 'I');
INSERT INTO historico.municipio VALUES (47, 'Teixeiropolis', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.750356', 'I');
INSERT INTO historico.municipio VALUES (48, 'Theobroma', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.751289', 'I');
INSERT INTO historico.municipio VALUES (49, 'Urupa', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.752266', 'I');
INSERT INTO historico.municipio VALUES (50, 'Vale do Anari', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.753153', 'I');
INSERT INTO historico.municipio VALUES (51, 'Vale do Paraiso', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.754014', 'I');
INSERT INTO historico.municipio VALUES (53, 'Acrelandia', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.756206', 'I');
INSERT INTO historico.municipio VALUES (54, 'Assis Brasil', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.757065', 'I');
INSERT INTO historico.municipio VALUES (55, 'Brasileia', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.757891', 'I');
INSERT INTO historico.municipio VALUES (56, 'Bujari', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.758909', 'I');
INSERT INTO historico.municipio VALUES (57, 'Capixaba', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.759844', 'I');
INSERT INTO historico.municipio VALUES (58, 'Cruzeiro do Sul', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.760768', 'I');
INSERT INTO historico.municipio VALUES (59, 'Epitaciolandia', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.761618', 'I');
INSERT INTO historico.municipio VALUES (60, 'Feijo', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.762592', 'I');
INSERT INTO historico.municipio VALUES (61, 'Jordao', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.763501', 'I');
INSERT INTO historico.municipio VALUES (62, 'Mancio Lima', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.764379', 'I');
INSERT INTO historico.municipio VALUES (63, 'Manoel Urbano', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.765356', 'I');
INSERT INTO historico.municipio VALUES (64, 'Marechal Thaumaturgo', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.772448', 'I');
INSERT INTO historico.municipio VALUES (65, 'Placido de Castro', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.77356', 'I');
INSERT INTO historico.municipio VALUES (67, 'Porto Walter', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.775372', 'I');
INSERT INTO historico.municipio VALUES (68, 'Rio Branco', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.776144', 'I');
INSERT INTO historico.municipio VALUES (69, 'Rodrigues Alves', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.777086', 'I');
INSERT INTO historico.municipio VALUES (70, 'Santa Rosa do Purus', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.778157', 'I');
INSERT INTO historico.municipio VALUES (72, 'Senador Guiomard', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.780338', 'I');
INSERT INTO historico.municipio VALUES (71, 'Sena Madureira', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.779501', 'I');
INSERT INTO historico.municipio VALUES (73, 'Tarauaca', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.781279', 'I');
INSERT INTO historico.municipio VALUES (74, 'Xapuri', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.782326', 'I');
INSERT INTO historico.municipio VALUES (66, 'Porto Acre', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.774455', 'I');
INSERT INTO historico.municipio VALUES (75, 'Alvaraes', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.783307', 'I');
INSERT INTO historico.municipio VALUES (76, 'Amatura', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.78444', 'I');
INSERT INTO historico.municipio VALUES (77, 'Anama', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.785298', 'I');
INSERT INTO historico.municipio VALUES (78, 'Anori', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.7862', 'I');
INSERT INTO historico.municipio VALUES (79, 'Apui', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.787062', 'I');
INSERT INTO historico.municipio VALUES (80, 'Atalaia do Norte', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.787924', 'I');
INSERT INTO historico.municipio VALUES (81, 'Autazes', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.788882', 'I');
INSERT INTO historico.municipio VALUES (82, 'Barcelos', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.789694', 'I');
INSERT INTO historico.municipio VALUES (83, 'Barreirinha', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.790558', 'I');
INSERT INTO historico.municipio VALUES (84, 'Benjamin Constant', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.791396', 'I');
INSERT INTO historico.municipio VALUES (85, 'Beruri', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.792246', 'I');
INSERT INTO historico.municipio VALUES (86, 'Boa Vista do Ramos', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.793161', 'I');
INSERT INTO historico.municipio VALUES (87, 'Boca do Acre', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.794181', 'I');
INSERT INTO historico.municipio VALUES (88, 'Borba', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.795002', 'I');
INSERT INTO historico.municipio VALUES (89, 'Caapiranga', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.795793', 'I');
INSERT INTO historico.municipio VALUES (90, 'Canutama', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.796734', 'I');
INSERT INTO historico.municipio VALUES (91, 'Carauari', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.797699', 'I');
INSERT INTO historico.municipio VALUES (92, 'Careiro', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.798687', 'I');
INSERT INTO historico.municipio VALUES (93, 'Careiro da Varzea', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.799621', 'I');
INSERT INTO historico.municipio VALUES (94, 'Coari', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.800826', 'I');
INSERT INTO historico.municipio VALUES (95, 'Codajas', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.801802', 'I');
INSERT INTO historico.municipio VALUES (96, 'Eirunepe', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.802748', 'I');
INSERT INTO historico.municipio VALUES (97, 'Envira', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.803632', 'I');
INSERT INTO historico.municipio VALUES (98, 'Fonte Boa', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.804528', 'I');
INSERT INTO historico.municipio VALUES (99, 'Guajara', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.805459', 'I');
INSERT INTO historico.municipio VALUES (100, 'Humaita', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.806293', 'I');
INSERT INTO historico.municipio VALUES (101, 'Ipixuna', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.813076', 'I');
INSERT INTO historico.municipio VALUES (102, 'Iranduba', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.814239', 'I');
INSERT INTO historico.municipio VALUES (103, 'Itamarati', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.815178', 'I');
INSERT INTO historico.municipio VALUES (104, 'Itapiranga', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.816065', 'I');
INSERT INTO historico.municipio VALUES (105, 'Japura', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.81715', 'I');
INSERT INTO historico.municipio VALUES (106, 'Jurua', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.818091', 'I');
INSERT INTO historico.municipio VALUES (107, 'Jutai', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.819038', 'I');
INSERT INTO historico.municipio VALUES (108, 'Labrea', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.820032', 'I');
INSERT INTO historico.municipio VALUES (109, 'Manacapuru', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.820907', 'I');
INSERT INTO historico.municipio VALUES (110, 'Manaquiri', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.821753', 'I');
INSERT INTO historico.municipio VALUES (111, 'Manaus', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.822972', 'I');
INSERT INTO historico.municipio VALUES (112, 'Manicore', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.823952', 'I');
INSERT INTO historico.municipio VALUES (113, 'Maraa', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.824889', 'I');
INSERT INTO historico.municipio VALUES (114, 'Maues', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.825835', 'I');
INSERT INTO historico.municipio VALUES (115, 'Nhamunda', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.826766', 'I');
INSERT INTO historico.municipio VALUES (116, 'Nova Olinda do Norte', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.827685', 'I');
INSERT INTO historico.municipio VALUES (117, 'Novo Airao', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.828719', 'I');
INSERT INTO historico.municipio VALUES (118, 'Novo Aripuana', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.829683', 'I');
INSERT INTO historico.municipio VALUES (119, 'Parintins', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.830562', 'I');
INSERT INTO historico.municipio VALUES (120, 'Pauini', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.83138', 'I');
INSERT INTO historico.municipio VALUES (121, 'Presidente Figueiredo', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.832207', 'I');
INSERT INTO historico.municipio VALUES (122, 'Rio Preto da Eva', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.833161', 'I');
INSERT INTO historico.municipio VALUES (123, 'Santa Isabel do Rio Negro', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.834228', 'I');
INSERT INTO historico.municipio VALUES (124, 'Santo Antonio do Ica', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.835121', 'I');
INSERT INTO historico.municipio VALUES (125, 'Sao Gabriel da Cachoeira', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.836046', 'I');
INSERT INTO historico.municipio VALUES (126, 'Sao Paulo de Olivenca', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.836988', 'I');
INSERT INTO historico.municipio VALUES (127, 'Sao Sebastiao do Uatuma', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.837813', 'I');
INSERT INTO historico.municipio VALUES (128, 'Silves', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.838766', 'I');
INSERT INTO historico.municipio VALUES (129, 'Tabatinga', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.839732', 'I');
INSERT INTO historico.municipio VALUES (130, 'Tapaua', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.840639', 'I');
INSERT INTO historico.municipio VALUES (131, 'Tefe', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.841614', 'I');
INSERT INTO historico.municipio VALUES (132, 'Tonantins', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.842553', 'I');
INSERT INTO historico.municipio VALUES (133, 'Uarini', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.843379', 'I');
INSERT INTO historico.municipio VALUES (134, 'Urucara', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.844178', 'I');
INSERT INTO historico.municipio VALUES (135, 'Urucurituba', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.845408', 'I');
INSERT INTO historico.municipio VALUES (137, 'Amajari', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.853924', 'I');
INSERT INTO historico.municipio VALUES (136, 'Alto Alegre', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.846512', 'I');
INSERT INTO historico.municipio VALUES (138, 'Boa Vista', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.855192', 'I');
INSERT INTO historico.municipio VALUES (139, 'Bonfim', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.856157', 'I');
INSERT INTO historico.municipio VALUES (140, 'Canta', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.856972', 'I');
INSERT INTO historico.municipio VALUES (141, 'Caracarai', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.857888', 'I');
INSERT INTO historico.municipio VALUES (142, 'Caroebe', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.858888', 'I');
INSERT INTO historico.municipio VALUES (143, 'Iracema', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.859891', 'I');
INSERT INTO historico.municipio VALUES (144, 'Mucajai', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.860859', 'I');
INSERT INTO historico.municipio VALUES (145, 'Normandia', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.861807', 'I');
INSERT INTO historico.municipio VALUES (146, 'Pacaraima', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.862761', 'I');
INSERT INTO historico.municipio VALUES (147, 'Rorainopolis', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.86373', 'I');
INSERT INTO historico.municipio VALUES (148, 'Sao Joao da Baliza', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.864648', 'I');
INSERT INTO historico.municipio VALUES (149, 'Sao Luiz', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.865518', 'I');
INSERT INTO historico.municipio VALUES (150, 'Uiramuta', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.866386', 'I');
INSERT INTO historico.municipio VALUES (151, 'Abaetetuba', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.867591', 'I');
INSERT INTO historico.municipio VALUES (152, 'Abel Figueiredo', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.868448', 'I');
INSERT INTO historico.municipio VALUES (153, 'Acara', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.869342', 'I');
INSERT INTO historico.municipio VALUES (154, 'Afua', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.87027', 'I');
INSERT INTO historico.municipio VALUES (155, 'Agua Azul do Norte', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.871096', 'I');
INSERT INTO historico.municipio VALUES (156, 'Alenquer', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.872038', 'I');
INSERT INTO historico.municipio VALUES (157, 'Almeirim', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.872959', 'I');
INSERT INTO historico.municipio VALUES (158, 'Altamira', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.873993', 'I');
INSERT INTO historico.municipio VALUES (159, 'Anajas', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.874868', 'I');
INSERT INTO historico.municipio VALUES (160, 'Ananindeua', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.875805', 'I');
INSERT INTO historico.municipio VALUES (161, 'Anapu', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.87672', 'I');
INSERT INTO historico.municipio VALUES (162, 'Augusto Correa', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.877656', 'I');
INSERT INTO historico.municipio VALUES (163, 'Aurora do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.878762', 'I');
INSERT INTO historico.municipio VALUES (164, 'Aveiro', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.879577', 'I');
INSERT INTO historico.municipio VALUES (165, 'Bagre', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.88047', 'I');
INSERT INTO historico.municipio VALUES (166, 'Baiao', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.881428', 'I');
INSERT INTO historico.municipio VALUES (167, 'Bannach', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.882419', 'I');
INSERT INTO historico.municipio VALUES (168, 'Barcarena', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.883321', 'I');
INSERT INTO historico.municipio VALUES (169, 'Belem', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.884275', 'I');
INSERT INTO historico.municipio VALUES (170, 'Belterra', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.885225', 'I');
INSERT INTO historico.municipio VALUES (171, 'Benevides', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.886172', 'I');
INSERT INTO historico.municipio VALUES (172, 'Bom Jesus do Tocantins', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.887134', 'I');
INSERT INTO historico.municipio VALUES (173, 'Bonito', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.894617', 'I');
INSERT INTO historico.municipio VALUES (174, 'Braganca', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.895728', 'I');
INSERT INTO historico.municipio VALUES (175, 'Brasil Novo', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.896566', 'I');
INSERT INTO historico.municipio VALUES (176, 'Brejo Grande do Araguaia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.897635', 'I');
INSERT INTO historico.municipio VALUES (177, 'Breu Branco', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.898564', 'I');
INSERT INTO historico.municipio VALUES (178, 'Breves', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.899242', 'I');
INSERT INTO historico.municipio VALUES (179, 'Bujaru', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.900159', 'I');
INSERT INTO historico.municipio VALUES (181, 'Cachoeira do Piria', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.902107', 'I');
INSERT INTO historico.municipio VALUES (180, 'Cachoeira do Arari', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.901094', 'I');
INSERT INTO historico.municipio VALUES (182, 'Cameta', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.903016', 'I');
INSERT INTO historico.municipio VALUES (183, 'Canaa dos Carajas', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.903963', 'I');
INSERT INTO historico.municipio VALUES (184, 'Capanema', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.904782', 'I');
INSERT INTO historico.municipio VALUES (185, 'Capitao Poco', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.905681', 'I');
INSERT INTO historico.municipio VALUES (186, 'Castanhal', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.906554', 'I');
INSERT INTO historico.municipio VALUES (187, 'Chaves', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.907603', 'I');
INSERT INTO historico.municipio VALUES (188, 'Colares', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.908482', 'I');
INSERT INTO historico.municipio VALUES (189, 'Conceicao do Araguaia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.909368', 'I');
INSERT INTO historico.municipio VALUES (190, 'Concordia do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.910192', 'I');
INSERT INTO historico.municipio VALUES (191, 'Cumaru do Norte', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.911121', 'I');
INSERT INTO historico.municipio VALUES (192, 'Curionopolis', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.912262', 'I');
INSERT INTO historico.municipio VALUES (193, 'Curralinho', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.913215', 'I');
INSERT INTO historico.municipio VALUES (194, 'Curua', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.914119', 'I');
INSERT INTO historico.municipio VALUES (195, 'Curuca', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.915017', 'I');
INSERT INTO historico.municipio VALUES (196, 'Dom Eliseu', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.91602', 'I');
INSERT INTO historico.municipio VALUES (198, 'Faro', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.91806', 'I');
INSERT INTO historico.municipio VALUES (199, 'Floresta do Araguaia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.918982', 'I');
INSERT INTO historico.municipio VALUES (200, 'Garrafao do Norte', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.919913', 'I');
INSERT INTO historico.municipio VALUES (201, 'Goianesia do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.92081', 'I');
INSERT INTO historico.municipio VALUES (202, 'Gurupa', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.921711', 'I');
INSERT INTO historico.municipio VALUES (203, 'Igarape-acu', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.922705', 'I');
INSERT INTO historico.municipio VALUES (204, 'Igarape-miri', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.92357', 'I');
INSERT INTO historico.municipio VALUES (205, 'Inhangapi', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.924586', 'I');
INSERT INTO historico.municipio VALUES (206, 'Ipixuna do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.9256', 'I');
INSERT INTO historico.municipio VALUES (207, 'Irituia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.926608', 'I');
INSERT INTO historico.municipio VALUES (208, 'Itaituba', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.92776', 'I');
INSERT INTO historico.municipio VALUES (209, 'Itupiranga', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.928737', 'I');
INSERT INTO historico.municipio VALUES (210, 'Jacareacanga', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.936088', 'I');
INSERT INTO historico.municipio VALUES (211, 'Jacunda', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.937324', 'I');
INSERT INTO historico.municipio VALUES (212, 'Juruti', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.938243', 'I');
INSERT INTO historico.municipio VALUES (213, 'Limoeiro do Ajuru', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.939321', 'I');
INSERT INTO historico.municipio VALUES (214, 'Mae do Rio', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.940188', 'I');
INSERT INTO historico.municipio VALUES (215, 'Magalhaes Barata', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.941158', 'I');
INSERT INTO historico.municipio VALUES (216, 'Maraba', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.942124', 'I');
INSERT INTO historico.municipio VALUES (217, 'Maracana', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.943021', 'I');
INSERT INTO historico.municipio VALUES (218, 'Marapanim', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.943981', 'I');
INSERT INTO historico.municipio VALUES (219, 'Marituba', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.944811', 'I');
INSERT INTO historico.municipio VALUES (220, 'Medicilandia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.945759', 'I');
INSERT INTO historico.municipio VALUES (221, 'Melgaco', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.946559', 'I');
INSERT INTO historico.municipio VALUES (222, 'Mocajuba', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.947482', 'I');
INSERT INTO historico.municipio VALUES (223, 'Moju', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.948244', 'I');
INSERT INTO historico.municipio VALUES (224, 'Monte Alegre', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.949614', 'I');
INSERT INTO historico.municipio VALUES (225, 'Muana', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.950555', 'I');
INSERT INTO historico.municipio VALUES (226, 'Nova Esperanca do Piria', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.9514', 'I');
INSERT INTO historico.municipio VALUES (227, 'Nova Ipixuna', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.952304', 'I');
INSERT INTO historico.municipio VALUES (228, 'Nova Timboteua', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.953216', 'I');
INSERT INTO historico.municipio VALUES (229, 'Novo Progresso', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.954085', 'I');
INSERT INTO historico.municipio VALUES (230, 'Novo Repartimento', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.955006', 'I');
INSERT INTO historico.municipio VALUES (231, 'Obidos', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.95593', 'I');
INSERT INTO historico.municipio VALUES (232, 'Oeiras do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.956865', 'I');
INSERT INTO historico.municipio VALUES (233, 'Oriximina', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.957786', 'I');
INSERT INTO historico.municipio VALUES (234, 'Ourem', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.958709', 'I');
INSERT INTO historico.municipio VALUES (235, 'Ourilandia do Norte', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.959504', 'I');
INSERT INTO historico.municipio VALUES (236, 'Pacaja', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.960374', 'I');
INSERT INTO historico.municipio VALUES (237, 'Palestina do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.96127', 'I');
INSERT INTO historico.municipio VALUES (238, 'Paragominas', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.962164', 'I');
INSERT INTO historico.municipio VALUES (239, 'Parauapebas', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.963118', 'I');
INSERT INTO historico.municipio VALUES (240, 'Pau D''arco', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.963912', 'I');
INSERT INTO historico.municipio VALUES (241, 'Peixe-boi', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.964888', 'I');
INSERT INTO historico.municipio VALUES (242, 'Picarra', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.965834', 'I');
INSERT INTO historico.municipio VALUES (243, 'Placas', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.966852', 'I');
INSERT INTO historico.municipio VALUES (244, 'Ponta de Pedras', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.968025', 'I');
INSERT INTO historico.municipio VALUES (245, 'Portel', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.969061', 'I');
INSERT INTO historico.municipio VALUES (246, 'Porto de Moz', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.970034', 'I');
INSERT INTO historico.municipio VALUES (247, 'Prainha', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.978985', 'I');
INSERT INTO historico.municipio VALUES (248, 'Primavera', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.980101', 'I');
INSERT INTO historico.municipio VALUES (249, 'Quatipuru', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.981208', 'I');
INSERT INTO historico.municipio VALUES (250, 'Redencao', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.982118', 'I');
INSERT INTO historico.municipio VALUES (251, 'Rio Maria', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.983216', 'I');
INSERT INTO historico.municipio VALUES (252, 'Rondon do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.984434', 'I');
INSERT INTO historico.municipio VALUES (253, 'Ruropolis', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.985502', 'I');
INSERT INTO historico.municipio VALUES (254, 'Salinopolis', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.986493', 'I');
INSERT INTO historico.municipio VALUES (255, 'Salvaterra', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.987353', 'I');
INSERT INTO historico.municipio VALUES (256, 'Santa Barbara do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.988251', 'I');
INSERT INTO historico.municipio VALUES (257, 'Santa Cruz do Arari', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.989048', 'I');
INSERT INTO historico.municipio VALUES (259, 'Santa Luzia do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.991128', 'I');
INSERT INTO historico.municipio VALUES (260, 'Santa Maria das Barreiras', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.991911', 'I');
INSERT INTO historico.municipio VALUES (261, 'Santa Maria do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.992886', 'I');
INSERT INTO historico.municipio VALUES (262, 'Santana do Araguaia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.993845', 'I');
INSERT INTO historico.municipio VALUES (263, 'Santarem', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.994763', 'I');
INSERT INTO historico.municipio VALUES (264, 'Santarem Novo', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.995664', 'I');
INSERT INTO historico.municipio VALUES (265, 'Santo Antonio do Taua', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.996463', 'I');
INSERT INTO historico.municipio VALUES (266, 'Sao Caetano de Odivelas', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.997262', 'I');
INSERT INTO historico.municipio VALUES (267, 'Sao Domingos do Araguaia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.998092', 'I');
INSERT INTO historico.municipio VALUES (268, 'Sao Domingos do Capim', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.999037', 'I');
INSERT INTO historico.municipio VALUES (269, 'Sao Felix do Xingu', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.999952', 'I');
INSERT INTO historico.municipio VALUES (270, 'Sao Francisco do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.001019', 'I');
INSERT INTO historico.municipio VALUES (271, 'Sao Geraldo do Araguaia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.001861', 'I');
INSERT INTO historico.municipio VALUES (272, 'Sao Joao da Ponta', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.002762', 'I');
INSERT INTO historico.municipio VALUES (273, 'Sao Joao de Pirabas', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.003681', 'I');
INSERT INTO historico.municipio VALUES (274, 'Sao Joao do Araguaia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.004606', 'I');
INSERT INTO historico.municipio VALUES (275, 'Sao Miguel do Guama', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.005566', 'I');
INSERT INTO historico.municipio VALUES (276, 'Sao Sebastiao da Boa Vista', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.006395', 'I');
INSERT INTO historico.municipio VALUES (277, 'Sapucaia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.007271', 'I');
INSERT INTO historico.municipio VALUES (278, 'Senador Jose Porfirio', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.008163', 'I');
INSERT INTO historico.municipio VALUES (279, 'Soure', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.009091', 'I');
INSERT INTO historico.municipio VALUES (280, 'Tailandia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.010067', 'I');
INSERT INTO historico.municipio VALUES (281, 'Terra Alta', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.01103', 'I');
INSERT INTO historico.municipio VALUES (282, 'Terra Santa', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.012083', 'I');
INSERT INTO historico.municipio VALUES (283, 'Tome-acu', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.012862', 'I');
INSERT INTO historico.municipio VALUES (284, 'Tracuateua', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.020208', 'I');
INSERT INTO historico.municipio VALUES (285, 'Trairao', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.021367', 'I');
INSERT INTO historico.municipio VALUES (286, 'Tucuma', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.022234', 'I');
INSERT INTO historico.municipio VALUES (287, 'Tucurui', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.023243', 'I');
INSERT INTO historico.municipio VALUES (288, 'Ulianopolis', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.024129', 'I');
INSERT INTO historico.municipio VALUES (289, 'Uruara', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.024966', 'I');
INSERT INTO historico.municipio VALUES (290, 'Vigia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.025883', 'I');
INSERT INTO historico.municipio VALUES (291, 'Viseu', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.026802', 'I');
INSERT INTO historico.municipio VALUES (292, 'Vitoria do Xingu', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.027745', 'I');
INSERT INTO historico.municipio VALUES (293, 'Xinguara', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.028653', 'I');
INSERT INTO historico.municipio VALUES (307, 'Serra do Navio', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.041419', 'I');
INSERT INTO historico.municipio VALUES (294, 'Amapa', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.029605', 'I');
INSERT INTO historico.municipio VALUES (303, 'Pedra Branca do Amapari', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.037751', 'I');
INSERT INTO historico.municipio VALUES (295, 'Calcoene', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.030519', 'I');
INSERT INTO historico.municipio VALUES (296, 'Cutias', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.031457', 'I');
INSERT INTO historico.municipio VALUES (297, 'Ferreira Gomes', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.032313', 'I');
INSERT INTO historico.municipio VALUES (298, 'Itaubal', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.033162', 'I');
INSERT INTO historico.municipio VALUES (299, 'Laranjal do Jari', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.034147', 'I');
INSERT INTO historico.municipio VALUES (300, 'Macapa', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.035017', 'I');
INSERT INTO historico.municipio VALUES (301, 'Mazagao', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.036028', 'I');
INSERT INTO historico.municipio VALUES (302, 'Oiapoque', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.036905', 'I');
INSERT INTO historico.municipio VALUES (304, 'Porto Grande', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.038704', 'I');
INSERT INTO historico.municipio VALUES (305, 'Pracuuba', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.039594', 'I');
INSERT INTO historico.municipio VALUES (306, 'Santana', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.040511', 'I');
INSERT INTO historico.municipio VALUES (308, 'Tartarugalzinho', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.042303', 'I');
INSERT INTO historico.municipio VALUES (309, 'Vitoria do Jari', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.043135', 'I');
INSERT INTO historico.municipio VALUES (310, 'Abreulandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.044063', 'I');
INSERT INTO historico.municipio VALUES (311, 'Aguiarnopolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.045079', 'I');
INSERT INTO historico.municipio VALUES (312, 'Alianca do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.04621', 'I');
INSERT INTO historico.municipio VALUES (313, 'Almas', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.047192', 'I');
INSERT INTO historico.municipio VALUES (314, 'Alvorada', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.048146', 'I');
INSERT INTO historico.municipio VALUES (315, 'Ananas', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.049117', 'I');
INSERT INTO historico.municipio VALUES (316, 'Angico', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.050076', 'I');
INSERT INTO historico.municipio VALUES (317, 'Aparecida do Rio Negro', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.050987', 'I');
INSERT INTO historico.municipio VALUES (318, 'Aragominas', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.051903', 'I');
INSERT INTO historico.municipio VALUES (319, 'Araguacema', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.052846', 'I');
INSERT INTO historico.municipio VALUES (320, 'Araguacu', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.053962', 'I');
INSERT INTO historico.municipio VALUES (321, 'Araguaina', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.061617', 'I');
INSERT INTO historico.municipio VALUES (322, 'Araguana', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.062755', 'I');
INSERT INTO historico.municipio VALUES (323, 'Araguatins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.063685', 'I');
INSERT INTO historico.municipio VALUES (324, 'Arapoema', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.064569', 'I');
INSERT INTO historico.municipio VALUES (325, 'Arraias', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.06559', 'I');
INSERT INTO historico.municipio VALUES (326, 'Augustinopolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.066518', 'I');
INSERT INTO historico.municipio VALUES (327, 'Aurora do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.067488', 'I');
INSERT INTO historico.municipio VALUES (328, 'Axixa do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.06855', 'I');
INSERT INTO historico.municipio VALUES (329, 'Babaculandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.069459', 'I');
INSERT INTO historico.municipio VALUES (330, 'Bandeirantes do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.070302', 'I');
INSERT INTO historico.municipio VALUES (331, 'Barra do Ouro', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.071172', 'I');
INSERT INTO historico.municipio VALUES (332, 'Barrolandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.072056', 'I');
INSERT INTO historico.municipio VALUES (333, 'Bernardo Sayao', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.072885', 'I');
INSERT INTO historico.municipio VALUES (334, 'Bom Jesus do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.073818', 'I');
INSERT INTO historico.municipio VALUES (335, 'Brasilandia do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.074694', 'I');
INSERT INTO historico.municipio VALUES (336, 'Brejinho de Nazare', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.075521', 'I');
INSERT INTO historico.municipio VALUES (337, 'Buriti do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.076484', 'I');
INSERT INTO historico.municipio VALUES (338, 'Cachoeirinha', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.077361', 'I');
INSERT INTO historico.municipio VALUES (339, 'Campos Lindos', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.078201', 'I');
INSERT INTO historico.municipio VALUES (340, 'Cariri do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.079159', 'I');
INSERT INTO historico.municipio VALUES (341, 'Carmolandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.079958', 'I');
INSERT INTO historico.municipio VALUES (342, 'Carrasco Bonito', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.081026', 'I');
INSERT INTO historico.municipio VALUES (343, 'Caseara', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.082012', 'I');
INSERT INTO historico.municipio VALUES (344, 'Centenario', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.082934', 'I');
INSERT INTO historico.municipio VALUES (346, 'Chapada de Areia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.084657', 'I');
INSERT INTO historico.municipio VALUES (345, 'Chapada da Natividade', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.083733', 'I');
INSERT INTO historico.municipio VALUES (347, 'Colinas do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.085702', 'I');
INSERT INTO historico.municipio VALUES (349, 'Combinado', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.087767', 'I');
INSERT INTO historico.municipio VALUES (350, 'Conceicao do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.088722', 'I');
INSERT INTO historico.municipio VALUES (352, 'Cristalandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.090779', 'I');
INSERT INTO historico.municipio VALUES (353, 'Crixas do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.091635', 'I');
INSERT INTO historico.municipio VALUES (354, 'Darcinopolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.092435', 'I');
INSERT INTO historico.municipio VALUES (355, 'Dianopolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.093325', 'I');
INSERT INTO historico.municipio VALUES (356, 'Divinopolis do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.094239', 'I');
INSERT INTO historico.municipio VALUES (357, 'Dois Irmaos do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.09535', 'I');
INSERT INTO historico.municipio VALUES (358, 'Duere', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.102276', 'I');
INSERT INTO historico.municipio VALUES (359, 'Esperantina', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.103367', 'I');
INSERT INTO historico.municipio VALUES (360, 'Fatima', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.104253', 'I');
INSERT INTO historico.municipio VALUES (361, 'Figueiropolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.105111', 'I');
INSERT INTO historico.municipio VALUES (362, 'Filadelfia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.106031', 'I');
INSERT INTO historico.municipio VALUES (363, 'Formoso do Araguaia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.106844', 'I');
INSERT INTO historico.municipio VALUES (364, 'Fortaleza do Tabocao', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.107791', 'I');
INSERT INTO historico.municipio VALUES (365, 'Goianorte', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.108687', 'I');
INSERT INTO historico.municipio VALUES (366, 'Goiatins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.10958', 'I');
INSERT INTO historico.municipio VALUES (367, 'Guarai', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.110381', 'I');
INSERT INTO historico.municipio VALUES (368, 'Gurupi', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.111293', 'I');
INSERT INTO historico.municipio VALUES (369, 'Ipueiras', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.112298', 'I');
INSERT INTO historico.municipio VALUES (370, 'Itacaja', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.113135', 'I');
INSERT INTO historico.municipio VALUES (371, 'Itaguatins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.113912', 'I');
INSERT INTO historico.municipio VALUES (372, 'Itapiratins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.1149', 'I');
INSERT INTO historico.municipio VALUES (373, 'Itapora do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.11572', 'I');
INSERT INTO historico.municipio VALUES (374, 'Jau do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.116488', 'I');
INSERT INTO historico.municipio VALUES (375, 'Juarina', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.117396', 'I');
INSERT INTO historico.municipio VALUES (376, 'Lagoa da Confusao', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.11813', 'I');
INSERT INTO historico.municipio VALUES (377, 'Lagoa do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.118825', 'I');
INSERT INTO historico.municipio VALUES (378, 'Lajeado', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.119873', 'I');
INSERT INTO historico.municipio VALUES (379, 'Lavandeira', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.120739', 'I');
INSERT INTO historico.municipio VALUES (380, 'Lizarda', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.121597', 'I');
INSERT INTO historico.municipio VALUES (381, 'Luzinopolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.122538', 'I');
INSERT INTO historico.municipio VALUES (382, 'Marianopolis do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.123445', 'I');
INSERT INTO historico.municipio VALUES (383, 'Mateiros', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.124297', 'I');
INSERT INTO historico.municipio VALUES (384, 'Maurilandia do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.125143', 'I');
INSERT INTO historico.municipio VALUES (385, 'Miracema do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.125927', 'I');
INSERT INTO historico.municipio VALUES (386, 'Miranorte', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.126827', 'I');
INSERT INTO historico.municipio VALUES (387, 'Monte do Carmo', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.127756', 'I');
INSERT INTO historico.municipio VALUES (388, 'Monte Santo do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.128688', 'I');
INSERT INTO historico.municipio VALUES (400, 'Palmeiras do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.146676', 'I');
INSERT INTO historico.municipio VALUES (389, 'Muricilandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.129605', 'I');
INSERT INTO historico.municipio VALUES (390, 'Natividade', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.13038', 'I');
INSERT INTO historico.municipio VALUES (391, 'Nazare', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.131401', 'I');
INSERT INTO historico.municipio VALUES (392, 'Nova Olinda', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.132322', 'I');
INSERT INTO historico.municipio VALUES (393, 'Nova Rosalandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.133154', 'I');
INSERT INTO historico.municipio VALUES (394, 'Novo Acordo', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.134133', 'I');
INSERT INTO historico.municipio VALUES (395, 'Novo Alegre', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.135242', 'I');
INSERT INTO historico.municipio VALUES (396, 'Novo Jardim', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.13607', 'I');
INSERT INTO historico.municipio VALUES (397, 'Oliveira de Fatima', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.143376', 'I');
INSERT INTO historico.municipio VALUES (399, 'Palmeirante', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.145386', 'I');
INSERT INTO historico.municipio VALUES (401, 'Palmeiropolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.14756', 'I');
INSERT INTO historico.municipio VALUES (402, 'Paraiso do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.148448', 'I');
INSERT INTO historico.municipio VALUES (403, 'Parana', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.149167', 'I');
INSERT INTO historico.municipio VALUES (404, 'Pau D''arco', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.150069', 'I');
INSERT INTO historico.municipio VALUES (405, 'Pedro Afonso', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.151063', 'I');
INSERT INTO historico.municipio VALUES (406, 'Peixe', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.151996', 'I');
INSERT INTO historico.municipio VALUES (407, 'Pequizeiro', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.152856', 'I');
INSERT INTO historico.municipio VALUES (348, 'Colmeia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.086822', 'I');
INSERT INTO historico.municipio VALUES (408, 'Pindorama do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.153748', 'I');
INSERT INTO historico.municipio VALUES (409, 'Piraque', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.154606', 'I');
INSERT INTO historico.municipio VALUES (410, 'Pium', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.155474', 'I');
INSERT INTO historico.municipio VALUES (411, 'Ponte Alta do Bom Jesus', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.156408', 'I');
INSERT INTO historico.municipio VALUES (412, 'Ponte Alta do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.157673', 'I');
INSERT INTO historico.municipio VALUES (413, 'Porto Alegre do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.158647', 'I');
INSERT INTO historico.municipio VALUES (414, 'Porto Nacional', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.159639', 'I');
INSERT INTO historico.municipio VALUES (415, 'Praia Norte', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.160437', 'I');
INSERT INTO historico.municipio VALUES (416, 'Presidente Kennedy', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.16134', 'I');
INSERT INTO historico.municipio VALUES (417, 'Pugmil', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.16224', 'I');
INSERT INTO historico.municipio VALUES (418, 'Recursolandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.163175', 'I');
INSERT INTO historico.municipio VALUES (419, 'Riachinho', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.164096', 'I');
INSERT INTO historico.municipio VALUES (420, 'Rio da Conceicao', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.164921', 'I');
INSERT INTO historico.municipio VALUES (421, 'Rio dos Bois', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.165967', 'I');
INSERT INTO historico.municipio VALUES (422, 'Rio Sono', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.166949', 'I');
INSERT INTO historico.municipio VALUES (423, 'Sampaio', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.167811', 'I');
INSERT INTO historico.municipio VALUES (424, 'Sandolandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.168809', 'I');
INSERT INTO historico.municipio VALUES (425, 'Santa Fe do Araguaia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.169817', 'I');
INSERT INTO historico.municipio VALUES (426, 'Santa Maria do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.170766', 'I');
INSERT INTO historico.municipio VALUES (427, 'Santa Rita do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.171677', 'I');
INSERT INTO historico.municipio VALUES (428, 'Santa Rosa do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.172572', 'I');
INSERT INTO historico.municipio VALUES (429, 'Santa Tereza do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.173518', 'I');
INSERT INTO historico.municipio VALUES (430, 'Santa Terezinha do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.174352', 'I');
INSERT INTO historico.municipio VALUES (431, 'Sao Bento do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.17523', 'I');
INSERT INTO historico.municipio VALUES (432, 'Sao Felix do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.176102', 'I');
INSERT INTO historico.municipio VALUES (433, 'Sao Miguel do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.177106', 'I');
INSERT INTO historico.municipio VALUES (434, 'Sao Salvador do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.18496', 'I');
INSERT INTO historico.municipio VALUES (435, 'Sao Sebastiao do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.186102', 'I');
INSERT INTO historico.municipio VALUES (437, 'Silvanopolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.187777', 'I');
INSERT INTO historico.municipio VALUES (438, 'Sitio Novo do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.188758', 'I');
INSERT INTO historico.municipio VALUES (439, 'Sucupira', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.189661', 'I');
INSERT INTO historico.municipio VALUES (440, 'Taguatinga', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.190463', 'I');
INSERT INTO historico.municipio VALUES (441, 'Taipas do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.191273', 'I');
INSERT INTO historico.municipio VALUES (442, 'Talisma', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.192128', 'I');
INSERT INTO historico.municipio VALUES (398, 'Palmas', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.144446', 'I');
INSERT INTO historico.municipio VALUES (443, 'Tocantinia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.193041', 'I');
INSERT INTO historico.municipio VALUES (444, 'Tocantinopolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.19396', 'I');
INSERT INTO historico.municipio VALUES (445, 'Tupirama', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.194937', 'I');
INSERT INTO historico.municipio VALUES (446, 'Tupiratins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.195867', 'I');
INSERT INTO historico.municipio VALUES (447, 'Wanderlandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.196689', 'I');
INSERT INTO historico.municipio VALUES (448, 'Xambioa', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.197644', 'I');
INSERT INTO historico.municipio VALUES (449, 'Acailandia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.198538', 'I');
INSERT INTO historico.municipio VALUES (450, 'Afonso Cunha', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.199462', 'I');
INSERT INTO historico.municipio VALUES (451, 'Agua Doce do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.200279', 'I');
INSERT INTO historico.municipio VALUES (452, 'Alcantara', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.201164', 'I');
INSERT INTO historico.municipio VALUES (453, 'Aldeias Altas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.202176', 'I');
INSERT INTO historico.municipio VALUES (454, 'Altamira do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.203261', 'I');
INSERT INTO historico.municipio VALUES (455, 'Alto Alegre do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.204215', 'I');
INSERT INTO historico.municipio VALUES (456, 'Alto Alegre do Pindare', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.205089', 'I');
INSERT INTO historico.municipio VALUES (457, 'Alto Parnaiba', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.206158', 'I');
INSERT INTO historico.municipio VALUES (458, 'Amapa do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.20716', 'I');
INSERT INTO historico.municipio VALUES (459, 'Amarante do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.208081', 'I');
INSERT INTO historico.municipio VALUES (460, 'Anajatuba', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.208976', 'I');
INSERT INTO historico.municipio VALUES (461, 'Anapurus', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.209855', 'I');
INSERT INTO historico.municipio VALUES (462, 'Apicum-acu', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.210782', 'I');
INSERT INTO historico.municipio VALUES (463, 'Araguana', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.211696', 'I');
INSERT INTO historico.municipio VALUES (464, 'Araioses', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.212717', 'I');
INSERT INTO historico.municipio VALUES (465, 'Arame', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.21353', 'I');
INSERT INTO historico.municipio VALUES (466, 'Arari', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.214388', 'I');
INSERT INTO historico.municipio VALUES (467, 'Axixa', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.215297', 'I');
INSERT INTO historico.municipio VALUES (468, 'Bacabal', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.21624', 'I');
INSERT INTO historico.municipio VALUES (469, 'Bacabeira', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.217163', 'I');
INSERT INTO historico.municipio VALUES (470, 'Bacuri', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.218068', 'I');
INSERT INTO historico.municipio VALUES (471, 'Bacurituba', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.218906', 'I');
INSERT INTO historico.municipio VALUES (472, 'Balsas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.226511', 'I');
INSERT INTO historico.municipio VALUES (473, 'Barao de Grajau', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.227641', 'I');
INSERT INTO historico.municipio VALUES (474, 'Barra do Corda', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.228529', 'I');
INSERT INTO historico.municipio VALUES (475, 'Barreirinhas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.22946', 'I');
INSERT INTO historico.municipio VALUES (477, 'Belagua', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.231267', 'I');
INSERT INTO historico.municipio VALUES (476, 'Bela Vista do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.230349', 'I');
INSERT INTO historico.municipio VALUES (478, 'Benedito Leite', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.232219', 'I');
INSERT INTO historico.municipio VALUES (479, 'Bequimao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.233065', 'I');
INSERT INTO historico.municipio VALUES (480, 'Bernardo do Mearim', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.23398', 'I');
INSERT INTO historico.municipio VALUES (481, 'Boa Vista do Gurupi', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.234892', 'I');
INSERT INTO historico.municipio VALUES (482, 'Bom Jardim', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.235799', 'I');
INSERT INTO historico.municipio VALUES (483, 'Bom Jesus das Selvas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.236707', 'I');
INSERT INTO historico.municipio VALUES (484, 'Bom Lugar', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.237544', 'I');
INSERT INTO historico.municipio VALUES (485, 'Brejo', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.238393', 'I');
INSERT INTO historico.municipio VALUES (486, 'Brejo de Areia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.23924', 'I');
INSERT INTO historico.municipio VALUES (487, 'Buriti', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.240212', 'I');
INSERT INTO historico.municipio VALUES (488, 'Buriti Bravo', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.24103', 'I');
INSERT INTO historico.municipio VALUES (489, 'Buriticupu', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.241945', 'I');
INSERT INTO historico.municipio VALUES (490, 'Buritirana', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.242839', 'I');
INSERT INTO historico.municipio VALUES (491, 'Cachoeira Grande', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.243731', 'I');
INSERT INTO historico.municipio VALUES (492, 'Cajapio', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.244628', 'I');
INSERT INTO historico.municipio VALUES (493, 'Cajari', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.245516', 'I');
INSERT INTO historico.municipio VALUES (494, 'Campestre do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.246481', 'I');
INSERT INTO historico.municipio VALUES (495, 'Candido Mendes', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.247331', 'I');
INSERT INTO historico.municipio VALUES (496, 'Cantanhede', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.248243', 'I');
INSERT INTO historico.municipio VALUES (497, 'Capinzal do Norte', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.249166', 'I');
INSERT INTO historico.municipio VALUES (498, 'Carolina', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.250112', 'I');
INSERT INTO historico.municipio VALUES (499, 'Carutapera', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.251005', 'I');
INSERT INTO historico.municipio VALUES (500, 'Caxias', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.251858', 'I');
INSERT INTO historico.municipio VALUES (501, 'Cedral', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.252814', 'I');
INSERT INTO historico.municipio VALUES (502, 'Central do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.253724', 'I');
INSERT INTO historico.municipio VALUES (503, 'Centro do Guilherme', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.254702', 'I');
INSERT INTO historico.municipio VALUES (504, 'Centro Novo do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.255559', 'I');
INSERT INTO historico.municipio VALUES (505, 'Chapadinha', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.256472', 'I');
INSERT INTO historico.municipio VALUES (506, 'Cidelandia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.257495', 'I');
INSERT INTO historico.municipio VALUES (507, 'Codo', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.258325', 'I');
INSERT INTO historico.municipio VALUES (508, 'Coelho Neto', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.259107', 'I');
INSERT INTO historico.municipio VALUES (509, 'Colinas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.259977', 'I');
INSERT INTO historico.municipio VALUES (510, 'Conceicao do Lago-acu', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.267016', 'I');
INSERT INTO historico.municipio VALUES (511, 'Coroata', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.268195', 'I');
INSERT INTO historico.municipio VALUES (512, 'Cururupu', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.269164', 'I');
INSERT INTO historico.municipio VALUES (513, 'Davinopolis', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.270095', 'I');
INSERT INTO historico.municipio VALUES (514, 'Dom Pedro', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.271002', 'I');
INSERT INTO historico.municipio VALUES (515, 'Duque Bacelar', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.271929', 'I');
INSERT INTO historico.municipio VALUES (516, 'Esperantinopolis', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.27286', 'I');
INSERT INTO historico.municipio VALUES (517, 'Estreito', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.273795', 'I');
INSERT INTO historico.municipio VALUES (518, 'Feira Nova do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.274839', 'I');
INSERT INTO historico.municipio VALUES (519, 'Fernando Falcao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.275832', 'I');
INSERT INTO historico.municipio VALUES (520, 'Formosa da Serra Negra', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.276788', 'I');
INSERT INTO historico.municipio VALUES (521, 'Fortaleza dos Nogueiras', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.27762', 'I');
INSERT INTO historico.municipio VALUES (522, 'Fortuna', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.278459', 'I');
INSERT INTO historico.municipio VALUES (523, 'Godofredo Viana', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.279542', 'I');
INSERT INTO historico.municipio VALUES (524, 'Goncalves Dias', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.280371', 'I');
INSERT INTO historico.municipio VALUES (525, 'Governador Archer', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.281277', 'I');
INSERT INTO historico.municipio VALUES (526, 'Governador Edison Lobao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.282223', 'I');
INSERT INTO historico.municipio VALUES (527, 'Governador Eugenio Barros', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.283125', 'I');
INSERT INTO historico.municipio VALUES (528, 'Governador Luiz Rocha', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.283974', 'I');
INSERT INTO historico.municipio VALUES (529, 'Governador Newton Bello', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.284782', 'I');
INSERT INTO historico.municipio VALUES (530, 'Governador Nunes Freire', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.285675', 'I');
INSERT INTO historico.municipio VALUES (531, 'Graca Aranha', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.286846', 'I');
INSERT INTO historico.municipio VALUES (532, 'Grajau', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.287677', 'I');
INSERT INTO historico.municipio VALUES (533, 'Guimaraes', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.288667', 'I');
INSERT INTO historico.municipio VALUES (534, 'Humberto de Campos', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.289578', 'I');
INSERT INTO historico.municipio VALUES (535, 'Icatu', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.290557', 'I');
INSERT INTO historico.municipio VALUES (536, 'Igarape do Meio', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.291496', 'I');
INSERT INTO historico.municipio VALUES (537, 'Igarape Grande', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.2924', 'I');
INSERT INTO historico.municipio VALUES (538, 'Imperatriz', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.293262', 'I');
INSERT INTO historico.municipio VALUES (539, 'Itaipava do Grajau', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.294094', 'I');
INSERT INTO historico.municipio VALUES (540, 'Itapecuru Mirim', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.295124', 'I');
INSERT INTO historico.municipio VALUES (541, 'Itinga do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.296028', 'I');
INSERT INTO historico.municipio VALUES (542, 'Jatoba', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.296978', 'I');
INSERT INTO historico.municipio VALUES (543, 'Jenipapo dos Vieiras', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.29789', 'I');
INSERT INTO historico.municipio VALUES (544, 'Joao Lisboa', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.298837', 'I');
INSERT INTO historico.municipio VALUES (545, 'Joselandia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.299813', 'I');
INSERT INTO historico.municipio VALUES (546, 'Junco do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.300907', 'I');
INSERT INTO historico.municipio VALUES (547, 'Lago da Pedra', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.302071', 'I');
INSERT INTO historico.municipio VALUES (548, 'Lago do Junco', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.307903', 'I');
INSERT INTO historico.municipio VALUES (550, 'Lago Verde', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.310138', 'I');
INSERT INTO historico.municipio VALUES (551, 'Lagoa do Mato', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.311156', 'I');
INSERT INTO historico.municipio VALUES (549, 'Lago dos Rodrigues', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.309158', 'I');
INSERT INTO historico.municipio VALUES (552, 'Lagoa Grande do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.312133', 'I');
INSERT INTO historico.municipio VALUES (553, 'Lajeado Novo', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.313052', 'I');
INSERT INTO historico.municipio VALUES (554, 'Lima Campos', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.313916', 'I');
INSERT INTO historico.municipio VALUES (555, 'Loreto', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.31479', 'I');
INSERT INTO historico.municipio VALUES (556, 'Luis Domingues', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.315685', 'I');
INSERT INTO historico.municipio VALUES (557, 'Magalhaes de Almeida', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.316626', 'I');
INSERT INTO historico.municipio VALUES (558, 'Maracacume', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.317519', 'I');
INSERT INTO historico.municipio VALUES (559, 'Maraja do Sena', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.318381', 'I');
INSERT INTO historico.municipio VALUES (560, 'Maranhaozinho', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.319219', 'I');
INSERT INTO historico.municipio VALUES (561, 'Mata Roma', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.320109', 'I');
INSERT INTO historico.municipio VALUES (562, 'Matinha', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.320966', 'I');
INSERT INTO historico.municipio VALUES (563, 'Matoes', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.321907', 'I');
INSERT INTO historico.municipio VALUES (564, 'Matoes do Norte', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.32282', 'I');
INSERT INTO historico.municipio VALUES (565, 'Milagres do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.32375', 'I');
INSERT INTO historico.municipio VALUES (566, 'Mirador', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.324883', 'I');
INSERT INTO historico.municipio VALUES (567, 'Miranda do Norte', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.325801', 'I');
INSERT INTO historico.municipio VALUES (568, 'Mirinzal', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.326849', 'I');
INSERT INTO historico.municipio VALUES (569, 'Moncao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.327637', 'I');
INSERT INTO historico.municipio VALUES (570, 'Montes Altos', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.328569', 'I');
INSERT INTO historico.municipio VALUES (571, 'Morros', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.329367', 'I');
INSERT INTO historico.municipio VALUES (572, 'Nina Rodrigues', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.330692', 'I');
INSERT INTO historico.municipio VALUES (573, 'Nova Colinas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.332095', 'I');
INSERT INTO historico.municipio VALUES (574, 'Nova Iorque', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.333022', 'I');
INSERT INTO historico.municipio VALUES (575, 'Nova Olinda do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.333932', 'I');
INSERT INTO historico.municipio VALUES (576, 'Olho D''agua das Cunhas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.334867', 'I');
INSERT INTO historico.municipio VALUES (577, 'Olinda Nova do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.335779', 'I');
INSERT INTO historico.municipio VALUES (578, 'Paco do Lumiar', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.33655', 'I');
INSERT INTO historico.municipio VALUES (579, 'Palmeirandia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.337518', 'I');
INSERT INTO historico.municipio VALUES (580, 'Paraibano', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.338445', 'I');
INSERT INTO historico.municipio VALUES (581, 'Parnarama', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.340223', 'I');
INSERT INTO historico.municipio VALUES (582, 'Passagem Franca', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.341359', 'I');
INSERT INTO historico.municipio VALUES (583, 'Pastos Bons', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.342182', 'I');
INSERT INTO historico.municipio VALUES (584, 'Paulino Neves', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.352812', 'I');
INSERT INTO historico.municipio VALUES (585, 'Paulo Ramos', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.353828', 'I');
INSERT INTO historico.municipio VALUES (586, 'Pedreiras', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.354689', 'I');
INSERT INTO historico.municipio VALUES (587, 'Pedro do Rosario', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.355564', 'I');
INSERT INTO historico.municipio VALUES (588, 'Penalva', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.356425', 'I');
INSERT INTO historico.municipio VALUES (589, 'Peri Mirim', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.357303', 'I');
INSERT INTO historico.municipio VALUES (590, 'Peritoro', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.358268', 'I');
INSERT INTO historico.municipio VALUES (592, 'Pinheiro', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.360105', 'I');
INSERT INTO historico.municipio VALUES (593, 'Pio Xii', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.361003', 'I');
INSERT INTO historico.municipio VALUES (594, 'Pirapemas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.361829', 'I');
INSERT INTO historico.municipio VALUES (595, 'Pocao de Pedras', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.362741', 'I');
INSERT INTO historico.municipio VALUES (596, 'Porto Franco', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.363626', 'I');
INSERT INTO historico.municipio VALUES (597, 'Porto Rico do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.364534', 'I');
INSERT INTO historico.municipio VALUES (598, 'Presidente Dutra', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.365368', 'I');
INSERT INTO historico.municipio VALUES (599, 'Presidente Juscelino', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.366202', 'I');
INSERT INTO historico.municipio VALUES (600, 'Presidente Medici', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.367133', 'I');
INSERT INTO historico.municipio VALUES (601, 'Presidente Sarney', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.368047', 'I');
INSERT INTO historico.municipio VALUES (602, 'Presidente Vargas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.368937', 'I');
INSERT INTO historico.municipio VALUES (603, 'Primeira Cruz', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.369823', 'I');
INSERT INTO historico.municipio VALUES (604, 'Raposa', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.370771', 'I');
INSERT INTO historico.municipio VALUES (605, 'Riachao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.371655', 'I');
INSERT INTO historico.municipio VALUES (606, 'Ribamar Fiquene', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.372579', 'I');
INSERT INTO historico.municipio VALUES (607, 'Rosario', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.373524', 'I');
INSERT INTO historico.municipio VALUES (608, 'Sambaiba', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.374298', 'I');
INSERT INTO historico.municipio VALUES (609, 'Santa Filomena do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.375097', 'I');
INSERT INTO historico.municipio VALUES (610, 'Santa Helena', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.376', 'I');
INSERT INTO historico.municipio VALUES (611, 'Santa Ines', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.376926', 'I');
INSERT INTO historico.municipio VALUES (612, 'Santa Luzia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.37791', 'I');
INSERT INTO historico.municipio VALUES (613, 'Santa Luzia do Parua', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.378894', 'I');
INSERT INTO historico.municipio VALUES (614, 'Santa Quiteria do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.379769', 'I');
INSERT INTO historico.municipio VALUES (615, 'Santa Rita', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.380996', 'I');
INSERT INTO historico.municipio VALUES (616, 'Santana do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.381789', 'I');
INSERT INTO historico.municipio VALUES (617, 'Santo Amaro do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.382757', 'I');
INSERT INTO historico.municipio VALUES (618, 'Santo Antonio dos Lopes', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.38365', 'I');
INSERT INTO historico.municipio VALUES (619, 'Sao Benedito do Rio Preto', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.384567', 'I');
INSERT INTO historico.municipio VALUES (620, 'Sao Bento', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.385444', 'I');
INSERT INTO historico.municipio VALUES (621, 'Sao Bernardo', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.386272', 'I');
INSERT INTO historico.municipio VALUES (622, 'Sao Domingos do Azeitao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.388381', 'I');
INSERT INTO historico.municipio VALUES (623, 'Sao Domingos do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.395118', 'I');
INSERT INTO historico.municipio VALUES (624, 'Sao Felix de Balsas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.39616', 'I');
INSERT INTO historico.municipio VALUES (625, 'Sao Francisco do Brejao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.397025', 'I');
INSERT INTO historico.municipio VALUES (626, 'Sao Francisco do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.398044', 'I');
INSERT INTO historico.municipio VALUES (627, 'Sao Joao Batista', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.39892', 'I');
INSERT INTO historico.municipio VALUES (628, 'Sao Joao do Caru', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.399745', 'I');
INSERT INTO historico.municipio VALUES (629, 'Sao Joao do Paraiso', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.400816', 'I');
INSERT INTO historico.municipio VALUES (630, 'Sao Joao do Soter', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.401759', 'I');
INSERT INTO historico.municipio VALUES (631, 'Sao Joao dos Patos', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.402956', 'I');
INSERT INTO historico.municipio VALUES (632, 'Sao Jose de Ribamar', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.403809', 'I');
INSERT INTO historico.municipio VALUES (633, 'Sao Jose dos Basilios', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.404643', 'I');
INSERT INTO historico.municipio VALUES (634, 'Sao Luis', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.405647', 'I');
INSERT INTO historico.municipio VALUES (635, 'Sao Luis Gonzaga do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.40646', 'I');
INSERT INTO historico.municipio VALUES (636, 'Sao Mateus do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.407324', 'I');
INSERT INTO historico.municipio VALUES (637, 'Sao Pedro da Agua Branca', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.408245', 'I');
INSERT INTO historico.municipio VALUES (638, 'Sao Pedro dos Crentes', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.409364', 'I');
INSERT INTO historico.municipio VALUES (639, 'Sao Raimundo das Mangabeiras', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.410289', 'I');
INSERT INTO historico.municipio VALUES (640, 'Sao Raimundo do Doca Bezerra', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.411219', 'I');
INSERT INTO historico.municipio VALUES (641, 'Sao Roberto', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.412187', 'I');
INSERT INTO historico.municipio VALUES (642, 'Sao Vicente Ferrer', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.413132', 'I');
INSERT INTO historico.municipio VALUES (643, 'Satubinha', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.414213', 'I');
INSERT INTO historico.municipio VALUES (644, 'Senador Alexandre Costa', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.41502', 'I');
INSERT INTO historico.municipio VALUES (645, 'Senador La Rocque', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.416003', 'I');
INSERT INTO historico.municipio VALUES (646, 'Serrano do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.416907', 'I');
INSERT INTO historico.municipio VALUES (647, 'Sitio Novo', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.417788', 'I');
INSERT INTO historico.municipio VALUES (648, 'Sucupira do Norte', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.418657', 'I');
INSERT INTO historico.municipio VALUES (649, 'Sucupira do Riachao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.419524', 'I');
INSERT INTO historico.municipio VALUES (650, 'Tasso Fragoso', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.420459', 'I');
INSERT INTO historico.municipio VALUES (651, 'Timbiras', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.421346', 'I');
INSERT INTO historico.municipio VALUES (652, 'Timon', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.422227', 'I');
INSERT INTO historico.municipio VALUES (653, 'Trizidela do Vale', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.4231', 'I');
INSERT INTO historico.municipio VALUES (654, 'Tufilandia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.424033', 'I');
INSERT INTO historico.municipio VALUES (655, 'Tuntum', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.425218', 'I');
INSERT INTO historico.municipio VALUES (656, 'Turiacu', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.426154', 'I');
INSERT INTO historico.municipio VALUES (657, 'Turilandia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.426947', 'I');
INSERT INTO historico.municipio VALUES (658, 'Tutoia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.427726', 'I');
INSERT INTO historico.municipio VALUES (659, 'Urbano Santos', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.428556', 'I');
INSERT INTO historico.municipio VALUES (660, 'Vargem Grande', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.435067', 'I');
INSERT INTO historico.municipio VALUES (661, 'Viana', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.436627', 'I');
INSERT INTO historico.municipio VALUES (662, 'Vila Nova dos Martirios', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.43748', 'I');
INSERT INTO historico.municipio VALUES (663, 'Vitoria do Mearim', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.438392', 'I');
INSERT INTO historico.municipio VALUES (664, 'Vitorino Freire', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.439218', 'I');
INSERT INTO historico.municipio VALUES (665, 'Ze Doca', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.440175', 'I');
INSERT INTO historico.municipio VALUES (666, 'Acaua', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.441086', 'I');
INSERT INTO historico.municipio VALUES (667, 'Agricolandia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.44202', 'I');
INSERT INTO historico.municipio VALUES (668, 'Agua Branca', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.443259', 'I');
INSERT INTO historico.municipio VALUES (669, 'Alagoinha do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.444215', 'I');
INSERT INTO historico.municipio VALUES (670, 'Alegrete do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.445155', 'I');
INSERT INTO historico.municipio VALUES (671, 'Alto Longa', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.446035', 'I');
INSERT INTO historico.municipio VALUES (672, 'Altos', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.446996', 'I');
INSERT INTO historico.municipio VALUES (673, 'Alvorada do Gurgueia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.447826', 'I');
INSERT INTO historico.municipio VALUES (674, 'Amarante', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.448565', 'I');
INSERT INTO historico.municipio VALUES (675, 'Angical do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.449534', 'I');
INSERT INTO historico.municipio VALUES (676, 'Anisio de Abreu', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.450473', 'I');
INSERT INTO historico.municipio VALUES (677, 'Antonio Almeida', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.451325', 'I');
INSERT INTO historico.municipio VALUES (678, 'Aroazes', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.452206', 'I');
INSERT INTO historico.municipio VALUES (680, 'Arraial', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.453937', 'I');
INSERT INTO historico.municipio VALUES (681, 'Assuncao do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.454994', 'I');
INSERT INTO historico.municipio VALUES (682, 'Avelino Lopes', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.455933', 'I');
INSERT INTO historico.municipio VALUES (683, 'Baixa Grande do Ribeiro', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.456842', 'I');
INSERT INTO historico.municipio VALUES (685, 'Barras', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.458843', 'I');
INSERT INTO historico.municipio VALUES (686, 'Barreiras do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.460085', 'I');
INSERT INTO historico.municipio VALUES (687, 'Barro Duro', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.461037', 'I');
INSERT INTO historico.municipio VALUES (688, 'Batalha', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.461931', 'I');
INSERT INTO historico.municipio VALUES (689, 'Bela Vista do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.462988', 'I');
INSERT INTO historico.municipio VALUES (690, 'Belem do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.463815', 'I');
INSERT INTO historico.municipio VALUES (691, 'Beneditinos', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.464727', 'I');
INSERT INTO historico.municipio VALUES (692, 'Bertolinia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.465651', 'I');
INSERT INTO historico.municipio VALUES (693, 'Betania do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.466532', 'I');
INSERT INTO historico.municipio VALUES (694, 'Boa Hora', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.467333', 'I');
INSERT INTO historico.municipio VALUES (695, 'Bocaina', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.468202', 'I');
INSERT INTO historico.municipio VALUES (696, 'Bom Jesus', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.469091', 'I');
INSERT INTO historico.municipio VALUES (697, 'Bom Principio do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.476209', 'I');
INSERT INTO historico.municipio VALUES (698, 'Bonfim do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.477453', 'I');
INSERT INTO historico.municipio VALUES (699, 'Boqueirao do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.478284', 'I');
INSERT INTO historico.municipio VALUES (700, 'Brasileira', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.479141', 'I');
INSERT INTO historico.municipio VALUES (701, 'Brejo do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.479943', 'I');
INSERT INTO historico.municipio VALUES (702, 'Buriti dos Lopes', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.481156', 'I');
INSERT INTO historico.municipio VALUES (703, 'Buriti dos Montes', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.481975', 'I');
INSERT INTO historico.municipio VALUES (704, 'Cabeceiras do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.482873', 'I');
INSERT INTO historico.municipio VALUES (705, 'Cajazeiras do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.483761', 'I');
INSERT INTO historico.municipio VALUES (706, 'Cajueiro da Praia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.484708', 'I');
INSERT INTO historico.municipio VALUES (707, 'Caldeirao Grande do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.485653', 'I');
INSERT INTO historico.municipio VALUES (708, 'Campinas do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.4866', 'I');
INSERT INTO historico.municipio VALUES (709, 'Campo Alegre do Fidalgo', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.487558', 'I');
INSERT INTO historico.municipio VALUES (710, 'Campo Grande do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.488623', 'I');
INSERT INTO historico.municipio VALUES (711, 'Campo Largo do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.489554', 'I');
INSERT INTO historico.municipio VALUES (712, 'Campo Maior', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.490426', 'I');
INSERT INTO historico.municipio VALUES (713, 'Canavieira', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.491345', 'I');
INSERT INTO historico.municipio VALUES (714, 'Canto do Buriti', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.492473', 'I');
INSERT INTO historico.municipio VALUES (715, 'Capitao de Campos', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.493449', 'I');
INSERT INTO historico.municipio VALUES (716, 'Capitao Gervasio Oliveira', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.49426', 'I');
INSERT INTO historico.municipio VALUES (717, 'Caracol', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.495011', 'I');
INSERT INTO historico.municipio VALUES (718, 'Caraubas do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.495894', 'I');
INSERT INTO historico.municipio VALUES (719, 'Caridade do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.496798', 'I');
INSERT INTO historico.municipio VALUES (720, 'Castelo do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.49769', 'I');
INSERT INTO historico.municipio VALUES (721, 'Caxingo', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.498551', 'I');
INSERT INTO historico.municipio VALUES (722, 'Cocal', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.49945', 'I');
INSERT INTO historico.municipio VALUES (723, 'Cocal de Telha', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.500365', 'I');
INSERT INTO historico.municipio VALUES (724, 'Cocal dos Alves', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.501178', 'I');
INSERT INTO historico.municipio VALUES (725, 'Coivaras', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.50203', 'I');
INSERT INTO historico.municipio VALUES (726, 'Colonia do Gurgueia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.502948', 'I');
INSERT INTO historico.municipio VALUES (727, 'Colonia do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.503724', 'I');
INSERT INTO historico.municipio VALUES (728, 'Conceicao do Caninde', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.504605', 'I');
INSERT INTO historico.municipio VALUES (729, 'Coronel Jose Dias', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.50551', 'I');
INSERT INTO historico.municipio VALUES (730, 'Corrente', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.506368', 'I');
INSERT INTO historico.municipio VALUES (731, 'Cristalandia do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.507245', 'I');
INSERT INTO historico.municipio VALUES (732, 'Cristino Castro', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.508161', 'I');
INSERT INTO historico.municipio VALUES (733, 'Curimata', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.509093', 'I');
INSERT INTO historico.municipio VALUES (734, 'Currais', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.509915', 'I');
INSERT INTO historico.municipio VALUES (736, 'Curralinhos', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.517649', 'I');
INSERT INTO historico.municipio VALUES (735, 'Curral Novo do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.516478', 'I');
INSERT INTO historico.municipio VALUES (737, 'Demerval Lobao', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.518747', 'I');
INSERT INTO historico.municipio VALUES (738, 'Dirceu Arcoverde', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.519566', 'I');
INSERT INTO historico.municipio VALUES (739, 'Dom Expedito Lopes', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.520463', 'I');
INSERT INTO historico.municipio VALUES (741, 'Domingos Mourao', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.522', 'I');
INSERT INTO historico.municipio VALUES (740, 'Dom Inocencio', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.521277', 'I');
INSERT INTO historico.municipio VALUES (742, 'Elesbao Veloso', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.522894', 'I');
INSERT INTO historico.municipio VALUES (743, 'Eliseu Martins', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.52379', 'I');
INSERT INTO historico.municipio VALUES (744, 'Esperantina', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.524652', 'I');
INSERT INTO historico.municipio VALUES (745, 'Fartura do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.526063', 'I');
INSERT INTO historico.municipio VALUES (746, 'Flores do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.527005', 'I');
INSERT INTO historico.municipio VALUES (747, 'Floresta do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.527865', 'I');
INSERT INTO historico.municipio VALUES (748, 'Floriano', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.528733', 'I');
INSERT INTO historico.municipio VALUES (749, 'Francinopolis', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.529749', 'I');
INSERT INTO historico.municipio VALUES (750, 'Francisco Ayres', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.530678', 'I');
INSERT INTO historico.municipio VALUES (751, 'Francisco Macedo', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.531546', 'I');
INSERT INTO historico.municipio VALUES (752, 'Francisco Santos', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.532468', 'I');
INSERT INTO historico.municipio VALUES (753, 'Fronteiras', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.533279', 'I');
INSERT INTO historico.municipio VALUES (754, 'Geminiano', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.534092', 'I');
INSERT INTO historico.municipio VALUES (755, 'Gilbues', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.535027', 'I');
INSERT INTO historico.municipio VALUES (756, 'Guadalupe', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.535945', 'I');
INSERT INTO historico.municipio VALUES (757, 'Guaribas', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.536987', 'I');
INSERT INTO historico.municipio VALUES (758, 'Hugo Napoleao', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.53787', 'I');
INSERT INTO historico.municipio VALUES (759, 'Ilha Grande', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.538744', 'I');
INSERT INTO historico.municipio VALUES (760, 'Inhuma', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.539664', 'I');
INSERT INTO historico.municipio VALUES (761, 'Ipiranga do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.540631', 'I');
INSERT INTO historico.municipio VALUES (762, 'Isaias Coelho', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.541589', 'I');
INSERT INTO historico.municipio VALUES (763, 'Itainopolis', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.54226', 'I');
INSERT INTO historico.municipio VALUES (764, 'Itaueira', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.543208', 'I');
INSERT INTO historico.municipio VALUES (765, 'Jacobina do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.544013', 'I');
INSERT INTO historico.municipio VALUES (766, 'Jaicos', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.544932', 'I');
INSERT INTO historico.municipio VALUES (767, 'Jardim do Mulato', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.545843', 'I');
INSERT INTO historico.municipio VALUES (768, 'Jatoba do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.546727', 'I');
INSERT INTO historico.municipio VALUES (769, 'Jerumenha', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.547582', 'I');
INSERT INTO historico.municipio VALUES (770, 'Joao Costa', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.548411', 'I');
INSERT INTO historico.municipio VALUES (771, 'Joaquim Pires', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.549224', 'I');
INSERT INTO historico.municipio VALUES (772, 'Joca Marques', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.550172', 'I');
INSERT INTO historico.municipio VALUES (773, 'Jose de Freitas', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.557', 'I');
INSERT INTO historico.municipio VALUES (774, 'Juazeiro do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.558345', 'I');
INSERT INTO historico.municipio VALUES (775, 'Julio Borges', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.559238', 'I');
INSERT INTO historico.municipio VALUES (776, 'Jurema', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.560161', 'I');
INSERT INTO historico.municipio VALUES (782, 'Lagoinha do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.565646', 'I');
INSERT INTO historico.municipio VALUES (777, 'Lagoa Alegre', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.561061', 'I');
INSERT INTO historico.municipio VALUES (779, 'Lagoa do Barro do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.56292', 'I');
INSERT INTO historico.municipio VALUES (778, 'Lagoa de Sao Francisco', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.562032', 'I');
INSERT INTO historico.municipio VALUES (780, 'Lagoa do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.56385', 'I');
INSERT INTO historico.municipio VALUES (781, 'Lagoa do Sitio', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.56476', 'I');
INSERT INTO historico.municipio VALUES (783, 'Landri Sales', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.566526', 'I');
INSERT INTO historico.municipio VALUES (784, 'Luis Correia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.567389', 'I');
INSERT INTO historico.municipio VALUES (785, 'Luzilandia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.568333', 'I');
INSERT INTO historico.municipio VALUES (786, 'Madeiro', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.569282', 'I');
INSERT INTO historico.municipio VALUES (787, 'Manoel Emidio', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.57028', 'I');
INSERT INTO historico.municipio VALUES (788, 'Marcolandia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.571109', 'I');
INSERT INTO historico.municipio VALUES (789, 'Marcos Parente', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.571924', 'I');
INSERT INTO historico.municipio VALUES (790, 'Massape do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.572792', 'I');
INSERT INTO historico.municipio VALUES (791, 'Matias Olimpio', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.573727', 'I');
INSERT INTO historico.municipio VALUES (792, 'Miguel Alves', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.574699', 'I');
INSERT INTO historico.municipio VALUES (793, 'Miguel Leao', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.575592', 'I');
INSERT INTO historico.municipio VALUES (794, 'Milton Brandao', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.576731', 'I');
INSERT INTO historico.municipio VALUES (795, 'Monsenhor Gil', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.577659', 'I');
INSERT INTO historico.municipio VALUES (796, 'Monsenhor Hipolito', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.578489', 'I');
INSERT INTO historico.municipio VALUES (797, 'Monte Alegre do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.579329', 'I');
INSERT INTO historico.municipio VALUES (798, 'Morro Cabeca No Tempo', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.580308', 'I');
INSERT INTO historico.municipio VALUES (799, 'Morro do Chapeu do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.581572', 'I');
INSERT INTO historico.municipio VALUES (800, 'Murici dos Portelas', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.582369', 'I');
INSERT INTO historico.municipio VALUES (801, 'Nazare do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.583261', 'I');
INSERT INTO historico.municipio VALUES (803, 'Nossa Senhora de Nazare', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.585035', 'I');
INSERT INTO historico.municipio VALUES (804, 'Nossa Senhora dos Remedios', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.585913', 'I');
INSERT INTO historico.municipio VALUES (806, 'Novo Oriente do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.587703', 'I');
INSERT INTO historico.municipio VALUES (807, 'Novo Santo Antonio', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.588561', 'I');
INSERT INTO historico.municipio VALUES (808, 'Oeiras', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.58949', 'I');
INSERT INTO historico.municipio VALUES (810, 'Padre Marcos', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.591217', 'I');
INSERT INTO historico.municipio VALUES (811, 'Paes Landim', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.592557', 'I');
INSERT INTO historico.municipio VALUES (812, 'Pajeu do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.598809', 'I');
INSERT INTO historico.municipio VALUES (813, 'Palmeira do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.599731', 'I');
INSERT INTO historico.municipio VALUES (814, 'Palmeirais', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.600651', 'I');
INSERT INTO historico.municipio VALUES (815, 'Paqueta', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.601586', 'I');
INSERT INTO historico.municipio VALUES (816, 'Parnagua', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.603105', 'I');
INSERT INTO historico.municipio VALUES (817, 'Parnaiba', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.603974', 'I');
INSERT INTO historico.municipio VALUES (818, 'Passagem Franca do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.604851', 'I');
INSERT INTO historico.municipio VALUES (819, 'Patos do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.605756', 'I');
INSERT INTO historico.municipio VALUES (820, 'Pau D''arco do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.606727', 'I');
INSERT INTO historico.municipio VALUES (821, 'Paulistana', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.607612', 'I');
INSERT INTO historico.municipio VALUES (822, 'Pavussu', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.608647', 'I');
INSERT INTO historico.municipio VALUES (823, 'Pedro Ii', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.609674', 'I');
INSERT INTO historico.municipio VALUES (824, 'Pedro Laurentino', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.610587', 'I');
INSERT INTO historico.municipio VALUES (805, 'Nova Santa Rita', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.58681', 'I');
INSERT INTO historico.municipio VALUES (825, 'Picos', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.611502', 'I');
INSERT INTO historico.municipio VALUES (826, 'Pimenteiras', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.61237', 'I');
INSERT INTO historico.municipio VALUES (827, 'Pio Ix', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.61325', 'I');
INSERT INTO historico.municipio VALUES (828, 'Piracuruca', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.6142', 'I');
INSERT INTO historico.municipio VALUES (829, 'Piripiri', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.615071', 'I');
INSERT INTO historico.municipio VALUES (830, 'Porto', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.616029', 'I');
INSERT INTO historico.municipio VALUES (831, 'Porto Alegre do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.617018', 'I');
INSERT INTO historico.municipio VALUES (832, 'Prata do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.617877', 'I');
INSERT INTO historico.municipio VALUES (833, 'Queimada Nova', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.618689', 'I');
INSERT INTO historico.municipio VALUES (834, 'Redencao do Gurgueia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.619662', 'I');
INSERT INTO historico.municipio VALUES (835, 'Regeneracao', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.620619', 'I');
INSERT INTO historico.municipio VALUES (836, 'Riacho Frio', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.621548', 'I');
INSERT INTO historico.municipio VALUES (837, 'Ribeira do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.62253', 'I');
INSERT INTO historico.municipio VALUES (838, 'Ribeiro Goncalves', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.623518', 'I');
INSERT INTO historico.municipio VALUES (839, 'Rio Grande do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.624477', 'I');
INSERT INTO historico.municipio VALUES (840, 'Santa Cruz do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.625541', 'I');
INSERT INTO historico.municipio VALUES (841, 'Santa Cruz dos Milagres', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.626406', 'I');
INSERT INTO historico.municipio VALUES (842, 'Santa Filomena', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.627271', 'I');
INSERT INTO historico.municipio VALUES (843, 'Santa Luz', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.628246', 'I');
INSERT INTO historico.municipio VALUES (845, 'Santana do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.630097', 'I');
INSERT INTO historico.municipio VALUES (844, 'Santa Rosa do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.629172', 'I');
INSERT INTO historico.municipio VALUES (846, 'Santo Antonio de Lisboa', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.630983', 'I');
INSERT INTO historico.municipio VALUES (847, 'Santo Antonio dos Milagres', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.631953', 'I');
INSERT INTO historico.municipio VALUES (848, 'Santo Inacio do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.638737', 'I');
INSERT INTO historico.municipio VALUES (849, 'Sao Braz do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.640018', 'I');
INSERT INTO historico.municipio VALUES (850, 'Sao Felix do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.641003', 'I');
INSERT INTO historico.municipio VALUES (851, 'Sao Francisco de Assis do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.641974', 'I');
INSERT INTO historico.municipio VALUES (852, 'Sao Francisco do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.642905', 'I');
INSERT INTO historico.municipio VALUES (853, 'Sao Goncalo do Gurgueia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.643859', 'I');
INSERT INTO historico.municipio VALUES (854, 'Sao Goncalo do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.644778', 'I');
INSERT INTO historico.municipio VALUES (855, 'Sao Joao da Canabrava', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.645729', 'I');
INSERT INTO historico.municipio VALUES (856, 'Sao Joao da Fronteira', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.646746', 'I');
INSERT INTO historico.municipio VALUES (857, 'Sao Joao da Serra', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.64776', 'I');
INSERT INTO historico.municipio VALUES (858, 'Sao Joao da Varjota', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.648584', 'I');
INSERT INTO historico.municipio VALUES (859, 'Sao Joao do Arraial', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.649445', 'I');
INSERT INTO historico.municipio VALUES (860, 'Sao Joao do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.65029', 'I');
INSERT INTO historico.municipio VALUES (861, 'Sao Jose do Divino', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.65123', 'I');
INSERT INTO historico.municipio VALUES (862, 'Sao Jose do Peixe', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.652159', 'I');
INSERT INTO historico.municipio VALUES (863, 'Sao Jose do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.653052', 'I');
INSERT INTO historico.municipio VALUES (864, 'Sao Juliao', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.654041', 'I');
INSERT INTO historico.municipio VALUES (865, 'Sao Lourenco do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.654978', 'I');
INSERT INTO historico.municipio VALUES (866, 'Sao Luis do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.655997', 'I');
INSERT INTO historico.municipio VALUES (867, 'Sao Miguel da Baixa Grande', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.656848', 'I');
INSERT INTO historico.municipio VALUES (868, 'Sao Miguel do Fidalgo', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.657708', 'I');
INSERT INTO historico.municipio VALUES (869, 'Sao Miguel do Tapuio', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.658591', 'I');
INSERT INTO historico.municipio VALUES (870, 'Sao Pedro do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.659708', 'I');
INSERT INTO historico.municipio VALUES (871, 'Sao Raimundo Nonato', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.660725', 'I');
INSERT INTO historico.municipio VALUES (872, 'Sebastiao Barros', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.661633', 'I');
INSERT INTO historico.municipio VALUES (873, 'Sebastiao Leal', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.662743', 'I');
INSERT INTO historico.municipio VALUES (874, 'Sigefredo Pacheco', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.663614', 'I');
INSERT INTO historico.municipio VALUES (875, 'Simoes', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.664475', 'I');
INSERT INTO historico.municipio VALUES (876, 'Simplicio Mendes', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.665361', 'I');
INSERT INTO historico.municipio VALUES (877, 'Socorro do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.666288', 'I');
INSERT INTO historico.municipio VALUES (878, 'Sussuapara', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.667165', 'I');
INSERT INTO historico.municipio VALUES (879, 'Tamboril do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.668103', 'I');
INSERT INTO historico.municipio VALUES (880, 'Tanque do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.669016', 'I');
INSERT INTO historico.municipio VALUES (881, 'Teresina', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.670074', 'I');
INSERT INTO historico.municipio VALUES (882, 'Uniao', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.670865', 'I');
INSERT INTO historico.municipio VALUES (883, 'Urucui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.671796', 'I');
INSERT INTO historico.municipio VALUES (884, 'Valenca do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.67261', 'I');
INSERT INTO historico.municipio VALUES (885, 'Varzea Branca', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.679609', 'I');
INSERT INTO historico.municipio VALUES (886, 'Varzea Grande', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.680844', 'I');
INSERT INTO historico.municipio VALUES (887, 'Vera Mendes', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.681873', 'I');
INSERT INTO historico.municipio VALUES (888, 'Vila Nova do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.68279', 'I');
INSERT INTO historico.municipio VALUES (889, 'Wall Ferraz', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.683613', 'I');
INSERT INTO historico.municipio VALUES (890, 'Abaiara', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.684498', 'I');
INSERT INTO historico.municipio VALUES (891, 'Acarape', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.685459', 'I');
INSERT INTO historico.municipio VALUES (892, 'Acarau', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.686316', 'I');
INSERT INTO historico.municipio VALUES (893, 'Acopiara', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.687319', 'I');
INSERT INTO historico.municipio VALUES (894, 'Aiuaba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.688458', 'I');
INSERT INTO historico.municipio VALUES (895, 'Alcantaras', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.68946', 'I');
INSERT INTO historico.municipio VALUES (896, 'Altaneira', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.690345', 'I');
INSERT INTO historico.municipio VALUES (897, 'Alto Santo', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.691214', 'I');
INSERT INTO historico.municipio VALUES (898, 'Amontada', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.692091', 'I');
INSERT INTO historico.municipio VALUES (899, 'Antonina do Norte', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.693258', 'I');
INSERT INTO historico.municipio VALUES (900, 'Apuiares', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.69425', 'I');
INSERT INTO historico.municipio VALUES (901, 'Aquiraz', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.695167', 'I');
INSERT INTO historico.municipio VALUES (902, 'Aracati', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.69614', 'I');
INSERT INTO historico.municipio VALUES (903, 'Aracoiaba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.69696', 'I');
INSERT INTO historico.municipio VALUES (904, 'Ararenda', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.697861', 'I');
INSERT INTO historico.municipio VALUES (905, 'Araripe', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.698832', 'I');
INSERT INTO historico.municipio VALUES (906, 'Aratuba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.69974', 'I');
INSERT INTO historico.municipio VALUES (907, 'Arneiroz', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.700663', 'I');
INSERT INTO historico.municipio VALUES (908, 'Assare', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.701591', 'I');
INSERT INTO historico.municipio VALUES (909, 'Aurora', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.702351', 'I');
INSERT INTO historico.municipio VALUES (910, 'Baixio', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.703411', 'I');
INSERT INTO historico.municipio VALUES (911, 'Banabuiu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.704293', 'I');
INSERT INTO historico.municipio VALUES (912, 'Barbalha', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.705191', 'I');
INSERT INTO historico.municipio VALUES (913, 'Barreira', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.706139', 'I');
INSERT INTO historico.municipio VALUES (914, 'Barro', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.707138', 'I');
INSERT INTO historico.municipio VALUES (915, 'Barroquinha', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.708104', 'I');
INSERT INTO historico.municipio VALUES (916, 'Baturite', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.70905', 'I');
INSERT INTO historico.municipio VALUES (917, 'Beberibe', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.71002', 'I');
INSERT INTO historico.municipio VALUES (918, 'Bela Cruz', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.710898', 'I');
INSERT INTO historico.municipio VALUES (919, 'Boa Viagem', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.711755', 'I');
INSERT INTO historico.municipio VALUES (920, 'Brejo Santo', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.712556', 'I');
INSERT INTO historico.municipio VALUES (921, 'Camocim', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.713478', 'I');
INSERT INTO historico.municipio VALUES (922, 'Campos Sales', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.720078', 'I');
INSERT INTO historico.municipio VALUES (923, 'Caninde', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.721176', 'I');
INSERT INTO historico.municipio VALUES (924, 'Capistrano', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.722137', 'I');
INSERT INTO historico.municipio VALUES (925, 'Caridade', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.723051', 'I');
INSERT INTO historico.municipio VALUES (926, 'Carire', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.724031', 'I');
INSERT INTO historico.municipio VALUES (927, 'Caririacu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.725002', 'I');
INSERT INTO historico.municipio VALUES (928, 'Carius', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.72603', 'I');
INSERT INTO historico.municipio VALUES (929, 'Carnaubal', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.726882', 'I');
INSERT INTO historico.municipio VALUES (930, 'Cascavel', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.72791', 'I');
INSERT INTO historico.municipio VALUES (931, 'Catarina', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.728846', 'I');
INSERT INTO historico.municipio VALUES (932, 'Catunda', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.72975', 'I');
INSERT INTO historico.municipio VALUES (933, 'Caucaia', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.73058', 'I');
INSERT INTO historico.municipio VALUES (934, 'Cedro', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.731508', 'I');
INSERT INTO historico.municipio VALUES (935, 'Chaval', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.732465', 'I');
INSERT INTO historico.municipio VALUES (936, 'Choro', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.733347', 'I');
INSERT INTO historico.municipio VALUES (937, 'Chorozinho', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.734151', 'I');
INSERT INTO historico.municipio VALUES (938, 'Coreau', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.735038', 'I');
INSERT INTO historico.municipio VALUES (939, 'Crateus', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.735982', 'I');
INSERT INTO historico.municipio VALUES (940, 'Crato', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.736982', 'I');
INSERT INTO historico.municipio VALUES (941, 'Croata', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.73788', 'I');
INSERT INTO historico.municipio VALUES (942, 'Cruz', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.738764', 'I');
INSERT INTO historico.municipio VALUES (943, 'Deputado Irapuan Pinheiro', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.739701', 'I');
INSERT INTO historico.municipio VALUES (944, 'Erere', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.740766', 'I');
INSERT INTO historico.municipio VALUES (945, 'Eusebio', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.741714', 'I');
INSERT INTO historico.municipio VALUES (946, 'Farias Brito', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.742725', 'I');
INSERT INTO historico.municipio VALUES (947, 'Forquilha', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.743617', 'I');
INSERT INTO historico.municipio VALUES (948, 'Fortaleza', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.744504', 'I');
INSERT INTO historico.municipio VALUES (949, 'Fortim', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.74536', 'I');
INSERT INTO historico.municipio VALUES (950, 'Frecheirinha', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.7463', 'I');
INSERT INTO historico.municipio VALUES (951, 'General Sampaio', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.747206', 'I');
INSERT INTO historico.municipio VALUES (952, 'Graca', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.748217', 'I');
INSERT INTO historico.municipio VALUES (953, 'Granja', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.74904', 'I');
INSERT INTO historico.municipio VALUES (954, 'Granjeiro', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.749942', 'I');
INSERT INTO historico.municipio VALUES (955, 'Groairas', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.750947', 'I');
INSERT INTO historico.municipio VALUES (956, 'Guaiuba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.751904', 'I');
INSERT INTO historico.municipio VALUES (957, 'Guaraciaba do Norte', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.752745', 'I');
INSERT INTO historico.municipio VALUES (958, 'Guaramiranga', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.753708', 'I');
INSERT INTO historico.municipio VALUES (959, 'Hidrolandia', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.760735', 'I');
INSERT INTO historico.municipio VALUES (960, 'Horizonte', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.761924', 'I');
INSERT INTO historico.municipio VALUES (961, 'Ibaretama', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.762867', 'I');
INSERT INTO historico.municipio VALUES (962, 'Ibiapina', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.763788', 'I');
INSERT INTO historico.municipio VALUES (963, 'Ibicuitinga', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.764672', 'I');
INSERT INTO historico.municipio VALUES (964, 'Icapui', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.765576', 'I');
INSERT INTO historico.municipio VALUES (965, 'Ico', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.76682', 'I');
INSERT INTO historico.municipio VALUES (966, 'Iguatu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.767721', 'I');
INSERT INTO historico.municipio VALUES (967, 'Independencia', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.768666', 'I');
INSERT INTO historico.municipio VALUES (968, 'Ipaporanga', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.769582', 'I');
INSERT INTO historico.municipio VALUES (969, 'Ipaumirim', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.770486', 'I');
INSERT INTO historico.municipio VALUES (970, 'Ipu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.771489', 'I');
INSERT INTO historico.municipio VALUES (971, 'Ipueiras', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.772507', 'I');
INSERT INTO historico.municipio VALUES (972, 'Iracema', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.773512', 'I');
INSERT INTO historico.municipio VALUES (973, 'Iraucuba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.774468', 'I');
INSERT INTO historico.municipio VALUES (974, 'Itaicaba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.77543', 'I');
INSERT INTO historico.municipio VALUES (975, 'Itaitinga', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.77631', 'I');
INSERT INTO historico.municipio VALUES (977, 'Itapipoca', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.778328', 'I');
INSERT INTO historico.municipio VALUES (978, 'Itapiuna', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.779217', 'I');
INSERT INTO historico.municipio VALUES (979, 'Itarema', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.780134', 'I');
INSERT INTO historico.municipio VALUES (980, 'Itatira', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.781004', 'I');
INSERT INTO historico.municipio VALUES (981, 'Jaguaretama', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.781931', 'I');
INSERT INTO historico.municipio VALUES (982, 'Jaguaribara', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.782755', 'I');
INSERT INTO historico.municipio VALUES (983, 'Jaguaribe', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.783553', 'I');
INSERT INTO historico.municipio VALUES (984, 'Jaguaruana', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.784418', 'I');
INSERT INTO historico.municipio VALUES (985, 'Jardim', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.785258', 'I');
INSERT INTO historico.municipio VALUES (986, 'Jati', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.786168', 'I');
INSERT INTO historico.municipio VALUES (987, 'Jijoca de Jericoacoara', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.787039', 'I');
INSERT INTO historico.municipio VALUES (988, 'Juazeiro do Norte', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.787963', 'I');
INSERT INTO historico.municipio VALUES (989, 'Jucas', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.788883', 'I');
INSERT INTO historico.municipio VALUES (990, 'Lavras da Mangabeira', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.789684', 'I');
INSERT INTO historico.municipio VALUES (991, 'Limoeiro do Norte', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.790614', 'I');
INSERT INTO historico.municipio VALUES (992, 'Madalena', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.791485', 'I');
INSERT INTO historico.municipio VALUES (993, 'Maracanau', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.79239', 'I');
INSERT INTO historico.municipio VALUES (994, 'Maranguape', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.793456', 'I');
INSERT INTO historico.municipio VALUES (995, 'Marco', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.794381', 'I');
INSERT INTO historico.municipio VALUES (996, 'Martinopole', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.801277', 'I');
INSERT INTO historico.municipio VALUES (997, 'Massape', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.802543', 'I');
INSERT INTO historico.municipio VALUES (998, 'Mauriti', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.805558', 'I');
INSERT INTO historico.municipio VALUES (999, 'Meruoca', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.806559', 'I');
INSERT INTO historico.municipio VALUES (1000, 'Milagres', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.80731', 'I');
INSERT INTO historico.municipio VALUES (1001, 'Milha', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.808353', 'I');
INSERT INTO historico.municipio VALUES (1002, 'Miraima', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.809236', 'I');
INSERT INTO historico.municipio VALUES (1003, 'Missao Velha', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.810299', 'I');
INSERT INTO historico.municipio VALUES (1004, 'Mombaca', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.811154', 'I');
INSERT INTO historico.municipio VALUES (1005, 'Monsenhor Tabosa', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.81203', 'I');
INSERT INTO historico.municipio VALUES (1006, 'Morada Nova', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.812903', 'I');
INSERT INTO historico.municipio VALUES (1007, 'Moraujo', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.81377', 'I');
INSERT INTO historico.municipio VALUES (1008, 'Morrinhos', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.814722', 'I');
INSERT INTO historico.municipio VALUES (1009, 'Mucambo', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.815781', 'I');
INSERT INTO historico.municipio VALUES (1010, 'Mulungu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.816724', 'I');
INSERT INTO historico.municipio VALUES (1011, 'Nova Olinda', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.817636', 'I');
INSERT INTO historico.municipio VALUES (1012, 'Nova Russas', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.81856', 'I');
INSERT INTO historico.municipio VALUES (1013, 'Novo Oriente', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.819509', 'I');
INSERT INTO historico.municipio VALUES (1014, 'Ocara', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.820449', 'I');
INSERT INTO historico.municipio VALUES (1015, 'Oros', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.821307', 'I');
INSERT INTO historico.municipio VALUES (1016, 'Pacajus', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.822177', 'I');
INSERT INTO historico.municipio VALUES (1017, 'Pacatuba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.823119', 'I');
INSERT INTO historico.municipio VALUES (1018, 'Pacoti', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.823944', 'I');
INSERT INTO historico.municipio VALUES (1019, 'Pacuja', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.824879', 'I');
INSERT INTO historico.municipio VALUES (1020, 'Palhano', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.825848', 'I');
INSERT INTO historico.municipio VALUES (1021, 'Palmacia', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.826961', 'I');
INSERT INTO historico.municipio VALUES (1022, 'Paracuru', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.827911', 'I');
INSERT INTO historico.municipio VALUES (1023, 'Paraipaba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.828797', 'I');
INSERT INTO historico.municipio VALUES (1024, 'Parambu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.829733', 'I');
INSERT INTO historico.municipio VALUES (1025, 'Paramoti', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.830639', 'I');
INSERT INTO historico.municipio VALUES (1026, 'Pedra Branca', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.831545', 'I');
INSERT INTO historico.municipio VALUES (1027, 'Penaforte', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.832489', 'I');
INSERT INTO historico.municipio VALUES (1028, 'Pentecoste', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.83333', 'I');
INSERT INTO historico.municipio VALUES (1029, 'Pereiro', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.834139', 'I');
INSERT INTO historico.municipio VALUES (1030, 'Pindoretama', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.835062', 'I');
INSERT INTO historico.municipio VALUES (1031, 'Piquet Carneiro', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.842709', 'I');
INSERT INTO historico.municipio VALUES (1032, 'Pires Ferreira', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.843807', 'I');
INSERT INTO historico.municipio VALUES (1033, 'Poranga', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.844903', 'I');
INSERT INTO historico.municipio VALUES (1034, 'Porteiras', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.846084', 'I');
INSERT INTO historico.municipio VALUES (1035, 'Potengi', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.847051', 'I');
INSERT INTO historico.municipio VALUES (1036, 'Potiretama', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.848016', 'I');
INSERT INTO historico.municipio VALUES (1037, 'Quiterianopolis', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.849214', 'I');
INSERT INTO historico.municipio VALUES (1038, 'Quixada', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.850112', 'I');
INSERT INTO historico.municipio VALUES (1039, 'Quixelo', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.851035', 'I');
INSERT INTO historico.municipio VALUES (1040, 'Quixeramobim', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.851966', 'I');
INSERT INTO historico.municipio VALUES (1041, 'Quixere', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.852901', 'I');
INSERT INTO historico.municipio VALUES (1042, 'Redencao', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.853907', 'I');
INSERT INTO historico.municipio VALUES (1043, 'Reriutaba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.855028', 'I');
INSERT INTO historico.municipio VALUES (1044, 'Russas', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.85597', 'I');
INSERT INTO historico.municipio VALUES (1045, 'Saboeiro', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.856853', 'I');
INSERT INTO historico.municipio VALUES (1046, 'Salitre', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.857981', 'I');
INSERT INTO historico.municipio VALUES (1048, 'Santana do Acarau', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.85981', 'I');
INSERT INTO historico.municipio VALUES (1049, 'Santana do Cariri', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.860708', 'I');
INSERT INTO historico.municipio VALUES (1047, 'Santa Quiteria', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.858908', 'I');
INSERT INTO historico.municipio VALUES (1050, 'Sao Benedito', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.861601', 'I');
INSERT INTO historico.municipio VALUES (1051, 'Sao Goncalo do Amarante', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.862529', 'I');
INSERT INTO historico.municipio VALUES (1052, 'Sao Joao do Jaguaribe', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.863447', 'I');
INSERT INTO historico.municipio VALUES (1053, 'Sao Luis do Curu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.864358', 'I');
INSERT INTO historico.municipio VALUES (1054, 'Senador Pompeu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.865343', 'I');
INSERT INTO historico.municipio VALUES (1055, 'Senador Sa', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.866271', 'I');
INSERT INTO historico.municipio VALUES (1056, 'Sobral', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.86725', 'I');
INSERT INTO historico.municipio VALUES (1057, 'Solonopole', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.868244', 'I');
INSERT INTO historico.municipio VALUES (1058, 'Tabuleiro do Norte', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.869195', 'I');
INSERT INTO historico.municipio VALUES (1059, 'Tamboril', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.87011', 'I');
INSERT INTO historico.municipio VALUES (1060, 'Tarrafas', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.871112', 'I');
INSERT INTO historico.municipio VALUES (1061, 'Taua', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.872086', 'I');
INSERT INTO historico.municipio VALUES (1062, 'Tejucuoca', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.873195', 'I');
INSERT INTO historico.municipio VALUES (1063, 'Tiangua', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.874116', 'I');
INSERT INTO historico.municipio VALUES (1064, 'Trairi', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.875052', 'I');
INSERT INTO historico.municipio VALUES (1065, 'Tururu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.875935', 'I');
INSERT INTO historico.municipio VALUES (1066, 'Ubajara', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.883523', 'I');
INSERT INTO historico.municipio VALUES (1067, 'Umari', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.884695', 'I');
INSERT INTO historico.municipio VALUES (1068, 'Umirim', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.885677', 'I');
INSERT INTO historico.municipio VALUES (1069, 'Uruburetama', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.886516', 'I');
INSERT INTO historico.municipio VALUES (1070, 'Uruoca', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.887569', 'I');
INSERT INTO historico.municipio VALUES (1071, 'Varjota', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.88856', 'I');
INSERT INTO historico.municipio VALUES (1072, 'Varzea Alegre', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.889456', 'I');
INSERT INTO historico.municipio VALUES (1073, 'Vicosa do Ceara', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.890355', 'I');
INSERT INTO historico.municipio VALUES (1074, 'Acari', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.891402', 'I');
INSERT INTO historico.municipio VALUES (1075, 'Acu', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.892249', 'I');
INSERT INTO historico.municipio VALUES (1076, 'Afonso Bezerra', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.893143', 'I');
INSERT INTO historico.municipio VALUES (1077, 'Agua Nova', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.894078', 'I');
INSERT INTO historico.municipio VALUES (1078, 'Alexandria', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.895039', 'I');
INSERT INTO historico.municipio VALUES (1079, 'Almino Afonso', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.895926', 'I');
INSERT INTO historico.municipio VALUES (1080, 'Alto do Rodrigues', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.896798', 'I');
INSERT INTO historico.municipio VALUES (1081, 'Angicos', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.897649', 'I');
INSERT INTO historico.municipio VALUES (1082, 'Antonio Martins', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.898468', 'I');
INSERT INTO historico.municipio VALUES (1083, 'Apodi', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.899511', 'I');
INSERT INTO historico.municipio VALUES (1084, 'Areia Branca', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.900457', 'I');
INSERT INTO historico.municipio VALUES (1085, 'Ares', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.901317', 'I');
INSERT INTO historico.municipio VALUES (1086, 'Augusto Severo', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.902303', 'I');
INSERT INTO historico.municipio VALUES (1087, 'Baia Formosa', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.903218', 'I');
INSERT INTO historico.municipio VALUES (1088, 'Barauna', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.904292', 'I');
INSERT INTO historico.municipio VALUES (1089, 'Barcelona', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.905211', 'I');
INSERT INTO historico.municipio VALUES (1090, 'Bento Fernandes', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.906199', 'I');
INSERT INTO historico.municipio VALUES (1091, 'Bodo', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.907136', 'I');
INSERT INTO historico.municipio VALUES (1092, 'Bom Jesus', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.908193', 'I');
INSERT INTO historico.municipio VALUES (1093, 'Brejinho', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.909163', 'I');
INSERT INTO historico.municipio VALUES (1094, 'Caicara do Norte', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.910096', 'I');
INSERT INTO historico.municipio VALUES (1095, 'Caicara do Rio do Vento', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.911027', 'I');
INSERT INTO historico.municipio VALUES (1096, 'Caico', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.911823', 'I');
INSERT INTO historico.municipio VALUES (1097, 'Campo Redondo', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.912823', 'I');
INSERT INTO historico.municipio VALUES (1098, 'Canguaretama', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.913613', 'I');
INSERT INTO historico.municipio VALUES (1099, 'Caraubas', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.914478', 'I');
INSERT INTO historico.municipio VALUES (1100, 'Carnauba dos Dantas', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.915516', 'I');
INSERT INTO historico.municipio VALUES (1101, 'Carnaubais', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.916333', 'I');
INSERT INTO historico.municipio VALUES (1102, 'Ceara-mirim', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.917214', 'I');
INSERT INTO historico.municipio VALUES (1103, 'Cerro Cora', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.924082', 'I');
INSERT INTO historico.municipio VALUES (1104, 'Coronel Ezequiel', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.925293', 'I');
INSERT INTO historico.municipio VALUES (1105, 'Coronel Joao Pessoa', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.926424', 'I');
INSERT INTO historico.municipio VALUES (1106, 'Cruzeta', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.927437', 'I');
INSERT INTO historico.municipio VALUES (1107, 'Currais Novos', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.928357', 'I');
INSERT INTO historico.municipio VALUES (1108, 'Doutor Severiano', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.92922', 'I');
INSERT INTO historico.municipio VALUES (1170, 'Parnamirim', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.992169', 'I');
INSERT INTO historico.municipio VALUES (1109, 'Encanto', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.930124', 'I');
INSERT INTO historico.municipio VALUES (1110, 'Equador', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.930949', 'I');
INSERT INTO historico.municipio VALUES (1111, 'Espirito Santo', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.93187', 'I');
INSERT INTO historico.municipio VALUES (1112, 'Extremoz', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.93282', 'I');
INSERT INTO historico.municipio VALUES (1113, 'Felipe Guerra', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.933753', 'I');
INSERT INTO historico.municipio VALUES (1114, 'Fernando Pedroza', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.934712', 'I');
INSERT INTO historico.municipio VALUES (1115, 'Florania', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.935678', 'I');
INSERT INTO historico.municipio VALUES (1116, 'Francisco Dantas', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.936647', 'I');
INSERT INTO historico.municipio VALUES (1117, 'Frutuoso Gomes', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.93762', 'I');
INSERT INTO historico.municipio VALUES (1118, 'Galinhos', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.938502', 'I');
INSERT INTO historico.municipio VALUES (1119, 'Goianinha', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.939453', 'I');
INSERT INTO historico.municipio VALUES (1120, 'Governador Dix-sept Rosado', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.940328', 'I');
INSERT INTO historico.municipio VALUES (1121, 'Grossos', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.941151', 'I');
INSERT INTO historico.municipio VALUES (1122, 'Guamare', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.942246', 'I');
INSERT INTO historico.municipio VALUES (1123, 'Ielmo Marinho', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.943257', 'I');
INSERT INTO historico.municipio VALUES (1124, 'Ipanguacu', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.944128', 'I');
INSERT INTO historico.municipio VALUES (1125, 'Ipueira', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.945019', 'I');
INSERT INTO historico.municipio VALUES (1126, 'Itaja', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.946076', 'I');
INSERT INTO historico.municipio VALUES (1127, 'Itau', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.946989', 'I');
INSERT INTO historico.municipio VALUES (1128, 'Jacana', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.947875', 'I');
INSERT INTO historico.municipio VALUES (1129, 'Jandaira', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.948829', 'I');
INSERT INTO historico.municipio VALUES (1130, 'Janduis', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.949781', 'I');
INSERT INTO historico.municipio VALUES (1131, 'Januario Cicco', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.950601', 'I');
INSERT INTO historico.municipio VALUES (1132, 'Japi', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.951564', 'I');
INSERT INTO historico.municipio VALUES (1133, 'Jardim de Angicos', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.952483', 'I');
INSERT INTO historico.municipio VALUES (1134, 'Jardim de Piranhas', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.953409', 'I');
INSERT INTO historico.municipio VALUES (1135, 'Jardim do Serido', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.954238', 'I');
INSERT INTO historico.municipio VALUES (1136, 'Joao Camara', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.955149', 'I');
INSERT INTO historico.municipio VALUES (1137, 'Joao Dias', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.956075', 'I');
INSERT INTO historico.municipio VALUES (1138, 'Jose da Penha', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.957006', 'I');
INSERT INTO historico.municipio VALUES (1139, 'Jucurutu', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.957905', 'I');
INSERT INTO historico.municipio VALUES (1140, 'Jundia', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.958828', 'I');
INSERT INTO historico.municipio VALUES (1141, 'Lagoa D''anta', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.965134', 'I');
INSERT INTO historico.municipio VALUES (1142, 'Lagoa de Pedras', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.966233', 'I');
INSERT INTO historico.municipio VALUES (1143, 'Lagoa de Velhos', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.967108', 'I');
INSERT INTO historico.municipio VALUES (1144, 'Lagoa Nova', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.96806', 'I');
INSERT INTO historico.municipio VALUES (1145, 'Lagoa Salgada', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.968966', 'I');
INSERT INTO historico.municipio VALUES (1146, 'Lajes', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.96988', 'I');
INSERT INTO historico.municipio VALUES (1147, 'Lajes Pintadas', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.970916', 'I');
INSERT INTO historico.municipio VALUES (1148, 'Lucrecia', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.971944', 'I');
INSERT INTO historico.municipio VALUES (1149, 'Luis Gomes', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.973018', 'I');
INSERT INTO historico.municipio VALUES (1150, 'Macaiba', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.973955', 'I');
INSERT INTO historico.municipio VALUES (1151, 'Macau', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.974833', 'I');
INSERT INTO historico.municipio VALUES (1152, 'Major Sales', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.975688', 'I');
INSERT INTO historico.municipio VALUES (1153, 'Marcelino Vieira', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.976567', 'I');
INSERT INTO historico.municipio VALUES (1154, 'Martins', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.977442', 'I');
INSERT INTO historico.municipio VALUES (1155, 'Maxaranguape', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.978517', 'I');
INSERT INTO historico.municipio VALUES (1156, 'Messias Targino', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.979498', 'I');
INSERT INTO historico.municipio VALUES (1157, 'Montanhas', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.980416', 'I');
INSERT INTO historico.municipio VALUES (1158, 'Monte Alegre', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.981295', 'I');
INSERT INTO historico.municipio VALUES (1159, 'Monte das Gameleiras', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.982178', 'I');
INSERT INTO historico.municipio VALUES (1160, 'Mossoro', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.983168', 'I');
INSERT INTO historico.municipio VALUES (1161, 'Natal', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.98404', 'I');
INSERT INTO historico.municipio VALUES (1162, 'Nisia Floresta', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.984957', 'I');
INSERT INTO historico.municipio VALUES (1163, 'Nova Cruz', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.98583', 'I');
INSERT INTO historico.municipio VALUES (1164, 'Olho-d''agua do Borges', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.986796', 'I');
INSERT INTO historico.municipio VALUES (1165, 'Ouro Branco', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.987717', 'I');
INSERT INTO historico.municipio VALUES (1166, 'Parana', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.988598', 'I');
INSERT INTO historico.municipio VALUES (1167, 'Parau', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.989498', 'I');
INSERT INTO historico.municipio VALUES (1168, 'Parazinho', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.990437', 'I');
INSERT INTO historico.municipio VALUES (1169, 'Parelhas', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.99129', 'I');
INSERT INTO historico.municipio VALUES (1191, 'Rio do Fogo', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.017658', 'I');
INSERT INTO historico.municipio VALUES (1171, 'Passa e Fica', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.99297', 'I');
INSERT INTO historico.municipio VALUES (1172, 'Passagem', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.994099', 'I');
INSERT INTO historico.municipio VALUES (1173, 'Patu', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.994899', 'I');
INSERT INTO historico.municipio VALUES (1195, 'Santa Maria', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.021445', 'I');
INSERT INTO historico.municipio VALUES (1174, 'Pau dos Ferros', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.995778', 'I');
INSERT INTO historico.municipio VALUES (1175, 'Pedra Grande', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.996685', 'I');
INSERT INTO historico.municipio VALUES (1176, 'Pedra Preta', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.997564', 'I');
INSERT INTO historico.municipio VALUES (1177, 'Pedro Avelino', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.998571', 'I');
INSERT INTO historico.municipio VALUES (1178, 'Pedro Velho', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.005427', 'I');
INSERT INTO historico.municipio VALUES (1179, 'Pendencias', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.00655', 'I');
INSERT INTO historico.municipio VALUES (1180, 'Piloes', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.007471', 'I');
INSERT INTO historico.municipio VALUES (1181, 'Poco Branco', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.00834', 'I');
INSERT INTO historico.municipio VALUES (1182, 'Portalegre', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.009265', 'I');
INSERT INTO historico.municipio VALUES (1183, 'Porto do Mangue', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.010181', 'I');
INSERT INTO historico.municipio VALUES (1185, 'Pureza', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.012', 'I');
INSERT INTO historico.municipio VALUES (1186, 'Rafael Fernandes', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.012814', 'I');
INSERT INTO historico.municipio VALUES (1187, 'Rafael Godeiro', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.013633', 'I');
INSERT INTO historico.municipio VALUES (1188, 'Riacho da Cruz', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.014532', 'I');
INSERT INTO historico.municipio VALUES (1189, 'Riacho de Santana', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.015533', 'I');
INSERT INTO historico.municipio VALUES (1190, 'Riachuelo', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.016688', 'I');
INSERT INTO historico.municipio VALUES (1192, 'Rodolfo Fernandes', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.018555', 'I');
INSERT INTO historico.municipio VALUES (1229, 'Tibau', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.059823', 'I');
INSERT INTO historico.municipio VALUES (1193, 'Ruy Barbosa', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.019556', 'I');
INSERT INTO historico.municipio VALUES (1194, 'Santa Cruz', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.020402', 'I');
INSERT INTO historico.municipio VALUES (1196, 'Santana do Matos', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.022177', 'I');
INSERT INTO historico.municipio VALUES (1197, 'Santana do Serido', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.023022', 'I');
INSERT INTO historico.municipio VALUES (1198, 'Santo Antonio', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.023864', 'I');
INSERT INTO historico.municipio VALUES (1199, 'Sao Bento do Norte', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.024666', 'I');
INSERT INTO historico.municipio VALUES (1200, 'Sao Bento do Trairi', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.025598', 'I');
INSERT INTO historico.municipio VALUES (1201, 'Sao Fernando', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.026479', 'I');
INSERT INTO historico.municipio VALUES (1202, 'Sao Francisco do Oeste', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.027777', 'I');
INSERT INTO historico.municipio VALUES (1203, 'Sao Goncalo do Amarante', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.028644', 'I');
INSERT INTO historico.municipio VALUES (1204, 'Sao Joao do Sabugi', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.029513', 'I');
INSERT INTO historico.municipio VALUES (1205, 'Sao Jose de Mipibu', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.03041', 'I');
INSERT INTO historico.municipio VALUES (1206, 'Sao Jose do Campestre', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.031271', 'I');
INSERT INTO historico.municipio VALUES (1207, 'Sao Jose do Serido', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.032197', 'I');
INSERT INTO historico.municipio VALUES (1208, 'Sao Miguel', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.03317', 'I');
INSERT INTO historico.municipio VALUES (1209, 'Sao Miguel do Gostoso', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.034112', 'I');
INSERT INTO historico.municipio VALUES (1210, 'Sao Paulo do Potengi', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.035023', 'I');
INSERT INTO historico.municipio VALUES (1211, 'Sao Pedro', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.035951', 'I');
INSERT INTO historico.municipio VALUES (1212, 'Sao Rafael', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.03703', 'I');
INSERT INTO historico.municipio VALUES (1213, 'Sao Tome', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.037977', 'I');
INSERT INTO historico.municipio VALUES (1214, 'Sao Vicente', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.039135', 'I');
INSERT INTO historico.municipio VALUES (1215, 'Senador Eloi de Souza', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.045963', 'I');
INSERT INTO historico.municipio VALUES (1216, 'Senador Georgino Avelino', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.047205', 'I');
INSERT INTO historico.municipio VALUES (1217, 'Serra de Sao Bento', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.048251', 'I');
INSERT INTO historico.municipio VALUES (1218, 'Serra do Mel', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.049257', 'I');
INSERT INTO historico.municipio VALUES (1219, 'Serra Negra do Norte', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.050121', 'I');
INSERT INTO historico.municipio VALUES (1220, 'Serrinha', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.051006', 'I');
INSERT INTO historico.municipio VALUES (1221, 'Serrinha dos Pintos', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.052384', 'I');
INSERT INTO historico.municipio VALUES (1222, 'Severiano Melo', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.053323', 'I');
INSERT INTO historico.municipio VALUES (1223, 'Sitio Novo', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.05422', 'I');
INSERT INTO historico.municipio VALUES (1224, 'Taboleiro Grande', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.055116', 'I');
INSERT INTO historico.municipio VALUES (1225, 'Taipu', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.055992', 'I');
INSERT INTO historico.municipio VALUES (1226, 'Tangara', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.056821', 'I');
INSERT INTO historico.municipio VALUES (1227, 'Tenente Ananias', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.057772', 'I');
INSERT INTO historico.municipio VALUES (1228, 'Tenente Laurentino Cruz', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.058756', 'I');
INSERT INTO historico.municipio VALUES (1230, 'Tibau do Sul', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.061144', 'I');
INSERT INTO historico.municipio VALUES (1231, 'Timbauba dos Batistas', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.062201', 'I');
INSERT INTO historico.municipio VALUES (1232, 'Touros', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.063184', 'I');
INSERT INTO historico.municipio VALUES (1233, 'Triunfo Potiguar', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.064106', 'I');
INSERT INTO historico.municipio VALUES (1234, 'Umarizal', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.065006', 'I');
INSERT INTO historico.municipio VALUES (1235, 'Upanema', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.065955', 'I');
INSERT INTO historico.municipio VALUES (1236, 'Varzea', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.066769', 'I');
INSERT INTO historico.municipio VALUES (1237, 'Venha-ver', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.067688', 'I');
INSERT INTO historico.municipio VALUES (1238, 'Vera Cruz', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.068614', 'I');
INSERT INTO historico.municipio VALUES (1239, 'Vicosa', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.069524', 'I');
INSERT INTO historico.municipio VALUES (1240, 'Vila Flor', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.070393', 'I');
INSERT INTO historico.municipio VALUES (1241, 'Agua Branca', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.071439', 'I');
INSERT INTO historico.municipio VALUES (1242, 'Aguiar', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.072434', 'I');
INSERT INTO historico.municipio VALUES (1243, 'Alagoa Grande', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.073282', 'I');
INSERT INTO historico.municipio VALUES (1244, 'Alagoa Nova', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.074227', 'I');
INSERT INTO historico.municipio VALUES (1245, 'Alagoinha', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.075158', 'I');
INSERT INTO historico.municipio VALUES (1246, 'Alcantil', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.076009', 'I');
INSERT INTO historico.municipio VALUES (1247, 'Algodao de Jandaira', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.076841', 'I');
INSERT INTO historico.municipio VALUES (1248, 'Alhandra', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.07777', 'I');
INSERT INTO historico.municipio VALUES (1423, 'Sao Joao do Rio do Peixe', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.271743', 'I');
INSERT INTO historico.municipio VALUES (1249, 'Amparo', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.078587', 'I');
INSERT INTO historico.municipio VALUES (1250, 'Aparecida', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.079657', 'I');
INSERT INTO historico.municipio VALUES (1251, 'Aracagi', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.086461', 'I');
INSERT INTO historico.municipio VALUES (1252, 'Arara', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.087625', 'I');
INSERT INTO historico.municipio VALUES (1253, 'Araruna', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.088977', 'I');
INSERT INTO historico.municipio VALUES (1254, 'Areia', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.089891', 'I');
INSERT INTO historico.municipio VALUES (1255, 'Areia de Baraunas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.090763', 'I');
INSERT INTO historico.municipio VALUES (1256, 'Areial', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.09166', 'I');
INSERT INTO historico.municipio VALUES (1257, 'Aroeiras', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.092651', 'I');
INSERT INTO historico.municipio VALUES (1258, 'Assuncao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.093528', 'I');
INSERT INTO historico.municipio VALUES (1259, 'Baia da Traicao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.094762', 'I');
INSERT INTO historico.municipio VALUES (1260, 'Bananeiras', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.0956', 'I');
INSERT INTO historico.municipio VALUES (1261, 'Barauna', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.096454', 'I');
INSERT INTO historico.municipio VALUES (1263, 'Barra de Santana', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.098328', 'I');
INSERT INTO historico.municipio VALUES (1262, 'Barra de Santa Rosa', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.097433', 'I');
INSERT INTO historico.municipio VALUES (1264, 'Barra de Sao Miguel', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.099207', 'I');
INSERT INTO historico.municipio VALUES (1265, 'Bayeux', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.100233', 'I');
INSERT INTO historico.municipio VALUES (1266, 'Belem', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.101175', 'I');
INSERT INTO historico.municipio VALUES (1267, 'Belem do Brejo do Cruz', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.102014', 'I');
INSERT INTO historico.municipio VALUES (1268, 'Bernardino Batista', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.102935', 'I');
INSERT INTO historico.municipio VALUES (1269, 'Boa Ventura', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.10377', 'I');
INSERT INTO historico.municipio VALUES (1270, 'Boa Vista', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.104778', 'I');
INSERT INTO historico.municipio VALUES (1271, 'Bom Jesus', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.105776', 'I');
INSERT INTO historico.municipio VALUES (1272, 'Bom Sucesso', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.106763', 'I');
INSERT INTO historico.municipio VALUES (1273, 'Bonito de Santa Fe', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.107652', 'I');
INSERT INTO historico.municipio VALUES (1274, 'Boqueirao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.108561', 'I');
INSERT INTO historico.municipio VALUES (1326, 'Igaracy', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.169184', 'I');
INSERT INTO historico.municipio VALUES (1275, 'Borborema', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.109233', 'I');
INSERT INTO historico.municipio VALUES (1276, 'Brejo do Cruz', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.110176', 'I');
INSERT INTO historico.municipio VALUES (1277, 'Brejo dos Santos', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.111091', 'I');
INSERT INTO historico.municipio VALUES (1278, 'Caapora', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.112052', 'I');
INSERT INTO historico.municipio VALUES (1279, 'Cabaceiras', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.112919', 'I');
INSERT INTO historico.municipio VALUES (1280, 'Cabedelo', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.113819', 'I');
INSERT INTO historico.municipio VALUES (1281, 'Cachoeira dos Indios', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.114792', 'I');
INSERT INTO historico.municipio VALUES (1282, 'Cacimba de Areia', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.115622', 'I');
INSERT INTO historico.municipio VALUES (1283, 'Cacimba de Dentro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.116562', 'I');
INSERT INTO historico.municipio VALUES (1284, 'Cacimbas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.117359', 'I');
INSERT INTO historico.municipio VALUES (1285, 'Caicara', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.118234', 'I');
INSERT INTO historico.municipio VALUES (1286, 'Cajazeiras', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.119142', 'I');
INSERT INTO historico.municipio VALUES (1287, 'Cajazeirinhas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.120118', 'I');
INSERT INTO historico.municipio VALUES (1288, 'Caldas Brandao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.126902', 'I');
INSERT INTO historico.municipio VALUES (1289, 'Camalau', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.128216', 'I');
INSERT INTO historico.municipio VALUES (1290, 'Campina Grande', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.129109', 'I');
INSERT INTO historico.municipio VALUES (1292, 'Capim', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.130913', 'I');
INSERT INTO historico.municipio VALUES (1293, 'Caraubas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.131989', 'I');
INSERT INTO historico.municipio VALUES (1294, 'Carrapateira', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.132966', 'I');
INSERT INTO historico.municipio VALUES (1295, 'Casserengue', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.133895', 'I');
INSERT INTO historico.municipio VALUES (1296, 'Catingueira', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.134819', 'I');
INSERT INTO historico.municipio VALUES (1297, 'Catole do Rocha', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.135839', 'I');
INSERT INTO historico.municipio VALUES (1298, 'Caturite', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.136857', 'I');
INSERT INTO historico.municipio VALUES (1299, 'Conceicao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.137768', 'I');
INSERT INTO historico.municipio VALUES (1300, 'Condado', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.138687', 'I');
INSERT INTO historico.municipio VALUES (1301, 'Conde', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.139541', 'I');
INSERT INTO historico.municipio VALUES (1302, 'Congo', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.140593', 'I');
INSERT INTO historico.municipio VALUES (1303, 'Coremas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.141567', 'I');
INSERT INTO historico.municipio VALUES (1304, 'Coxixola', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.142408', 'I');
INSERT INTO historico.municipio VALUES (1305, 'Cruz do Espirito Santo', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.143316', 'I');
INSERT INTO historico.municipio VALUES (1306, 'Cubati', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.144275', 'I');
INSERT INTO historico.municipio VALUES (1307, 'Cuite', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.145159', 'I');
INSERT INTO historico.municipio VALUES (1309, 'Cuitegi', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.146933', 'I');
INSERT INTO historico.municipio VALUES (1308, 'Cuite de Mamanguape', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.146038', 'I');
INSERT INTO historico.municipio VALUES (1310, 'Curral de Cima', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.147807', 'I');
INSERT INTO historico.municipio VALUES (1311, 'Curral Velho', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.14869', 'I');
INSERT INTO historico.municipio VALUES (1312, 'Damiao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.149547', 'I');
INSERT INTO historico.municipio VALUES (1313, 'Desterro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.150441', 'I');
INSERT INTO historico.municipio VALUES (1462, 'Vista Serrana', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.312486', 'I');
INSERT INTO historico.municipio VALUES (1314, 'Diamante', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.151433', 'I');
INSERT INTO historico.municipio VALUES (1315, 'Dona Ines', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.152276', 'I');
INSERT INTO historico.municipio VALUES (1316, 'Duas Estradas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.153226', 'I');
INSERT INTO historico.municipio VALUES (1317, 'Emas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.154106', 'I');
INSERT INTO historico.municipio VALUES (1318, 'Esperanca', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.154937', 'I');
INSERT INTO historico.municipio VALUES (1319, 'Fagundes', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.15573', 'I');
INSERT INTO historico.municipio VALUES (1320, 'Frei Martinho', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.156702', 'I');
INSERT INTO historico.municipio VALUES (1321, 'Gado Bravo', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.157619', 'I');
INSERT INTO historico.municipio VALUES (1322, 'Guarabira', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.158561', 'I');
INSERT INTO historico.municipio VALUES (1323, 'Gurinhem', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.159521', 'I');
INSERT INTO historico.municipio VALUES (1324, 'Gurjao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.160604', 'I');
INSERT INTO historico.municipio VALUES (1325, 'Ibiara', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.168082', 'I');
INSERT INTO historico.municipio VALUES (1327, 'Imaculada', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.170197', 'I');
INSERT INTO historico.municipio VALUES (1328, 'Inga', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.171029', 'I');
INSERT INTO historico.municipio VALUES (1329, 'Itabaiana', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.172174', 'I');
INSERT INTO historico.municipio VALUES (1330, 'Itaporanga', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.173123', 'I');
INSERT INTO historico.municipio VALUES (1331, 'Itapororoca', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.174094', 'I');
INSERT INTO historico.municipio VALUES (1332, 'Itatuba', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.174905', 'I');
INSERT INTO historico.municipio VALUES (1333, 'Jacarau', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.175971', 'I');
INSERT INTO historico.municipio VALUES (1334, 'Jerico', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.176834', 'I');
INSERT INTO historico.municipio VALUES (1335, 'Joao Pessoa', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.177745', 'I');
INSERT INTO historico.municipio VALUES (1336, 'Juarez Tavora', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.178614', 'I');
INSERT INTO historico.municipio VALUES (1337, 'Juazeirinho', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.179447', 'I');
INSERT INTO historico.municipio VALUES (1338, 'Junco do Serido', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.180365', 'I');
INSERT INTO historico.municipio VALUES (1339, 'Juripiranga', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.181348', 'I');
INSERT INTO historico.municipio VALUES (1340, 'Juru', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.182217', 'I');
INSERT INTO historico.municipio VALUES (1341, 'Lagoa', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.183149', 'I');
INSERT INTO historico.municipio VALUES (1342, 'Lagoa de Dentro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.184115', 'I');
INSERT INTO historico.municipio VALUES (1343, 'Lagoa Seca', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.185256', 'I');
INSERT INTO historico.municipio VALUES (1344, 'Lastro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.186203', 'I');
INSERT INTO historico.municipio VALUES (1345, 'Livramento', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.187139', 'I');
INSERT INTO historico.municipio VALUES (1346, 'Logradouro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.18807', 'I');
INSERT INTO historico.municipio VALUES (1347, 'Lucena', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.188966', 'I');
INSERT INTO historico.municipio VALUES (1348, 'Mae D''agua', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.189872', 'I');
INSERT INTO historico.municipio VALUES (1349, 'Malta', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.190783', 'I');
INSERT INTO historico.municipio VALUES (1350, 'Mamanguape', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.191714', 'I');
INSERT INTO historico.municipio VALUES (1351, 'Manaira', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.192634', 'I');
INSERT INTO historico.municipio VALUES (1352, 'Marcacao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.193573', 'I');
INSERT INTO historico.municipio VALUES (1353, 'Mari', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.194537', 'I');
INSERT INTO historico.municipio VALUES (1354, 'Marizopolis', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.195373', 'I');
INSERT INTO historico.municipio VALUES (1355, 'Massaranduba', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.196294', 'I');
INSERT INTO historico.municipio VALUES (1356, 'Mataraca', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.197125', 'I');
INSERT INTO historico.municipio VALUES (1357, 'Matinhas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.198047', 'I');
INSERT INTO historico.municipio VALUES (1358, 'Mato Grosso', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.198975', 'I');
INSERT INTO historico.municipio VALUES (1359, 'Matureia', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.199965', 'I');
INSERT INTO historico.municipio VALUES (1360, 'Mogeiro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.200795', 'I');
INSERT INTO historico.municipio VALUES (1361, 'Montadas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.201784', 'I');
INSERT INTO historico.municipio VALUES (1362, 'Monte Horebe', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.209441', 'I');
INSERT INTO historico.municipio VALUES (1363, 'Monteiro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.210611', 'I');
INSERT INTO historico.municipio VALUES (1364, 'Mulungu', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.21166', 'I');
INSERT INTO historico.municipio VALUES (1365, 'Natuba', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.212408', 'I');
INSERT INTO historico.municipio VALUES (1366, 'Nazarezinho', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.213326', 'I');
INSERT INTO historico.municipio VALUES (1367, 'Nova Floresta', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.214238', 'I');
INSERT INTO historico.municipio VALUES (1368, 'Nova Olinda', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.215124', 'I');
INSERT INTO historico.municipio VALUES (1369, 'Nova Palmeira', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.215985', 'I');
INSERT INTO historico.municipio VALUES (1370, 'Olho D''agua', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.216966', 'I');
INSERT INTO historico.municipio VALUES (1371, 'Olivedos', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.217879', 'I');
INSERT INTO historico.municipio VALUES (1372, 'Ouro Velho', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.218822', 'I');
INSERT INTO historico.municipio VALUES (1373, 'Parari', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.219627', 'I');
INSERT INTO historico.municipio VALUES (1374, 'Passagem', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.220662', 'I');
INSERT INTO historico.municipio VALUES (1375, 'Patos', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.22147', 'I');
INSERT INTO historico.municipio VALUES (1376, 'Paulista', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.222548', 'I');
INSERT INTO historico.municipio VALUES (1377, 'Pedra Branca', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.223486', 'I');
INSERT INTO historico.municipio VALUES (1378, 'Pedra Lavrada', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.224321', 'I');
INSERT INTO historico.municipio VALUES (1379, 'Pedras de Fogo', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.225261', 'I');
INSERT INTO historico.municipio VALUES (1381, 'Pianco', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.22712', 'I');
INSERT INTO historico.municipio VALUES (1382, 'Picui', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.228008', 'I');
INSERT INTO historico.municipio VALUES (1383, 'Pilar', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.228887', 'I');
INSERT INTO historico.municipio VALUES (1384, 'Piloes', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.230081', 'I');
INSERT INTO historico.municipio VALUES (1385, 'Piloezinhos', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.230945', 'I');
INSERT INTO historico.municipio VALUES (1386, 'Pirpirituba', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.231857', 'I');
INSERT INTO historico.municipio VALUES (1387, 'Pitimbu', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.232742', 'I');
INSERT INTO historico.municipio VALUES (1388, 'Pocinhos', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.233566', 'I');
INSERT INTO historico.municipio VALUES (1389, 'Poco Dantas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.234628', 'I');
INSERT INTO historico.municipio VALUES (1390, 'Poco de Jose de Moura', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.235532', 'I');
INSERT INTO historico.municipio VALUES (1391, 'Pombal', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.236417', 'I');
INSERT INTO historico.municipio VALUES (1392, 'Prata', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.23723', 'I');
INSERT INTO historico.municipio VALUES (1393, 'Princesa Isabel', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.238127', 'I');
INSERT INTO historico.municipio VALUES (1394, 'Puxinana', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.238929', 'I');
INSERT INTO historico.municipio VALUES (1395, 'Queimadas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.239764', 'I');
INSERT INTO historico.municipio VALUES (1396, 'Quixaba', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.240693', 'I');
INSERT INTO historico.municipio VALUES (1397, 'Remigio', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.241454', 'I');
INSERT INTO historico.municipio VALUES (1380, 'Pedro Regis', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.226144', 'I');
INSERT INTO historico.municipio VALUES (1398, 'Riachao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.242406', 'I');
INSERT INTO historico.municipio VALUES (1399, 'Riachao do Bacamarte', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.243145', 'I');
INSERT INTO historico.municipio VALUES (1400, 'Riachao do Poco', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.249788', 'I');
INSERT INTO historico.municipio VALUES (1401, 'Riacho de Santo Antonio', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.250952', 'I');
INSERT INTO historico.municipio VALUES (1402, 'Riacho dos Cavalos', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.252411', 'I');
INSERT INTO historico.municipio VALUES (1403, 'Rio Tinto', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.253304', 'I');
INSERT INTO historico.municipio VALUES (1404, 'Salgadinho', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.25416', 'I');
INSERT INTO historico.municipio VALUES (1405, 'Salgado de Sao Felix', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.255117', 'I');
INSERT INTO historico.municipio VALUES (1406, 'Santa Cecilia', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.256209', 'I');
INSERT INTO historico.municipio VALUES (1407, 'Santa Cruz', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.25718', 'I');
INSERT INTO historico.municipio VALUES (1408, 'Santa Helena', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.258032', 'I');
INSERT INTO historico.municipio VALUES (1409, 'Santa Ines', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.258871', 'I');
INSERT INTO historico.municipio VALUES (1410, 'Santa Luzia', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.25973', 'I');
INSERT INTO historico.municipio VALUES (1413, 'Santana de Mangueira', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.262825', 'I');
INSERT INTO historico.municipio VALUES (1414, 'Santana dos Garrotes', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.263649', 'I');
INSERT INTO historico.municipio VALUES (1411, 'Santa Rita', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.260598', 'I');
INSERT INTO historico.municipio VALUES (1412, 'Santa Teresinha', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.261849', 'I');
INSERT INTO historico.municipio VALUES (1416, 'Santo Andre', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.265495', 'I');
INSERT INTO historico.municipio VALUES (1418, 'Sao Bento', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.26724', 'I');
INSERT INTO historico.municipio VALUES (1417, 'Sao Bentinho', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.266426', 'I');
INSERT INTO historico.municipio VALUES (1420, 'Sao Domingos do Cariri', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.269057', 'I');
INSERT INTO historico.municipio VALUES (1421, 'Sao Francisco', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.269946', 'I');
INSERT INTO historico.municipio VALUES (1422, 'Sao Joao do Cariri', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.270871', 'I');
INSERT INTO historico.municipio VALUES (1424, 'Sao Joao do Tigre', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.272737', 'I');
INSERT INTO historico.municipio VALUES (1425, 'Sao Jose da Lagoa Tapada', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.273614', 'I');
INSERT INTO historico.municipio VALUES (1426, 'Sao Jose de Caiana', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.274688', 'I');
INSERT INTO historico.municipio VALUES (1427, 'Sao Jose de Espinharas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.27563', 'I');
INSERT INTO historico.municipio VALUES (1434, 'Sao Jose dos Ramos', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.281823', 'I');
INSERT INTO historico.municipio VALUES (1428, 'Sao Jose de Piranhas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.276506', 'I');
INSERT INTO historico.municipio VALUES (1429, 'Sao Jose de Princesa', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.277443', 'I');
INSERT INTO historico.municipio VALUES (1430, 'Sao Jose do Bonfim', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.278377', 'I');
INSERT INTO historico.municipio VALUES (1431, 'Sao Jose do Brejo do Cruz', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.279212', 'I');
INSERT INTO historico.municipio VALUES (1432, 'Sao Jose do Sabugi', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.280095', 'I');
INSERT INTO historico.municipio VALUES (1433, 'Sao Jose dos Cordeiros', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.280958', 'I');
INSERT INTO historico.municipio VALUES (1435, 'Sao Mamede', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.282705', 'I');
INSERT INTO historico.municipio VALUES (1436, 'Sao Miguel de Taipu', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.283547', 'I');
INSERT INTO historico.municipio VALUES (1437, 'Sao Sebastiao de Lagoa de Roca', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.290398', 'I');
INSERT INTO historico.municipio VALUES (1438, 'Sao Sebastiao do Umbuzeiro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.291562', 'I');
INSERT INTO historico.municipio VALUES (1440, 'Sape', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.293434', 'I');
INSERT INTO historico.municipio VALUES (1439, 'Sao Vicente do Serido', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.292442', 'I');
INSERT INTO historico.municipio VALUES (1441, 'Serra Branca', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.294291', 'I');
INSERT INTO historico.municipio VALUES (1442, 'Serra da Raiz', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.295204', 'I');
INSERT INTO historico.municipio VALUES (1443, 'Serra Grande', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.29615', 'I');
INSERT INTO historico.municipio VALUES (1444, 'Serra Redonda', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.296925', 'I');
INSERT INTO historico.municipio VALUES (1445, 'Serraria', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.297727', 'I');
INSERT INTO historico.municipio VALUES (1446, 'Sertaozinho', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.298636', 'I');
INSERT INTO historico.municipio VALUES (1447, 'Sobrado', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.299495', 'I');
INSERT INTO historico.municipio VALUES (1448, 'Solanea', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.300403', 'I');
INSERT INTO historico.municipio VALUES (1449, 'Soledade', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.301233', 'I');
INSERT INTO historico.municipio VALUES (1450, 'Sossego', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.302085', 'I');
INSERT INTO historico.municipio VALUES (1451, 'Sousa', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.302975', 'I');
INSERT INTO historico.municipio VALUES (1452, 'Sume', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.303766', 'I');
INSERT INTO historico.municipio VALUES (1453, 'Taperoa', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.304635', 'I');
INSERT INTO historico.municipio VALUES (1454, 'Tavares', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.305527', 'I');
INSERT INTO historico.municipio VALUES (1455, 'Teixeira', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.306383', 'I');
INSERT INTO historico.municipio VALUES (1456, 'Tenorio', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.3074', 'I');
INSERT INTO historico.municipio VALUES (1457, 'Triunfo', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.308232', 'I');
INSERT INTO historico.municipio VALUES (1458, 'Uirauna', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.309099', 'I');
INSERT INTO historico.municipio VALUES (1459, 'Umbuzeiro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.309848', 'I');
INSERT INTO historico.municipio VALUES (1460, 'Varzea', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.310707', 'I');
INSERT INTO historico.municipio VALUES (1461, 'Vieiropolis', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.311518', 'I');
INSERT INTO historico.municipio VALUES (1463, 'Zabele', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.31346', 'I');
INSERT INTO historico.municipio VALUES (1464, 'Abreu e Lima', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.314455', 'I');
INSERT INTO historico.municipio VALUES (1465, 'Afogados da Ingazeira', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.315369', 'I');
INSERT INTO historico.municipio VALUES (1466, 'Afranio', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.316283', 'I');
INSERT INTO historico.municipio VALUES (1467, 'Agrestina', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.317184', 'I');
INSERT INTO historico.municipio VALUES (1468, 'Agua Preta', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.318148', 'I');
INSERT INTO historico.municipio VALUES (1469, 'Aguas Belas', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.319228', 'I');
INSERT INTO historico.municipio VALUES (1470, 'Alagoinha', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.320145', 'I');
INSERT INTO historico.municipio VALUES (1471, 'Alianca', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.32101', 'I');
INSERT INTO historico.municipio VALUES (1472, 'Altinho', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.321895', 'I');
INSERT INTO historico.municipio VALUES (1473, 'Amaraji', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.322767', 'I');
INSERT INTO historico.municipio VALUES (1474, 'Angelim', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.32367', 'I');
INSERT INTO historico.municipio VALUES (1475, 'Aracoiaba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.324482', 'I');
INSERT INTO historico.municipio VALUES (1476, 'Araripina', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.330102', 'I');
INSERT INTO historico.municipio VALUES (1477, 'Arcoverde', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.331269', 'I');
INSERT INTO historico.municipio VALUES (1478, 'Barra de Guabiraba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.332372', 'I');
INSERT INTO historico.municipio VALUES (1479, 'Barreiros', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.333472', 'I');
INSERT INTO historico.municipio VALUES (1480, 'Belem de Maria', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.334393', 'I');
INSERT INTO historico.municipio VALUES (1482, 'Belo Jardim', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.336241', 'I');
INSERT INTO historico.municipio VALUES (1483, 'Betania', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.337129', 'I');
INSERT INTO historico.municipio VALUES (1484, 'Bezerros', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.338076', 'I');
INSERT INTO historico.municipio VALUES (1485, 'Bodoco', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.338907', 'I');
INSERT INTO historico.municipio VALUES (1486, 'Bom Conselho', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.339929', 'I');
INSERT INTO historico.municipio VALUES (1487, 'Bom Jardim', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.340936', 'I');
INSERT INTO historico.municipio VALUES (1488, 'Bonito', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.34216', 'I');
INSERT INTO historico.municipio VALUES (1489, 'Brejao', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.343086', 'I');
INSERT INTO historico.municipio VALUES (1490, 'Brejinho', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.344037', 'I');
INSERT INTO historico.municipio VALUES (1491, 'Brejo da Madre de Deus', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.344934', 'I');
INSERT INTO historico.municipio VALUES (1492, 'Buenos Aires', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.345842', 'I');
INSERT INTO historico.municipio VALUES (1493, 'Buique', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.346767', 'I');
INSERT INTO historico.municipio VALUES (1494, 'Cabo de Santo Agostinho', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.347774', 'I');
INSERT INTO historico.municipio VALUES (1495, 'Cabrobo', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.348738', 'I');
INSERT INTO historico.municipio VALUES (1496, 'Cachoeirinha', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.349556', 'I');
INSERT INTO historico.municipio VALUES (1497, 'Caetes', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.350314', 'I');
INSERT INTO historico.municipio VALUES (1498, 'Calcado', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.351203', 'I');
INSERT INTO historico.municipio VALUES (1499, 'Calumbi', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.35222', 'I');
INSERT INTO historico.municipio VALUES (1500, 'Camaragibe', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.352986', 'I');
INSERT INTO historico.municipio VALUES (1501, 'Camocim de Sao Felix', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.35396', 'I');
INSERT INTO historico.municipio VALUES (1502, 'Camutanga', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.35491', 'I');
INSERT INTO historico.municipio VALUES (1503, 'Canhotinho', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.355843', 'I');
INSERT INTO historico.municipio VALUES (1504, 'Capoeiras', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.356719', 'I');
INSERT INTO historico.municipio VALUES (1505, 'Carnaiba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.357596', 'I');
INSERT INTO historico.municipio VALUES (1506, 'Carnaubeira da Penha', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.358502', 'I');
INSERT INTO historico.municipio VALUES (1507, 'Carpina', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.359433', 'I');
INSERT INTO historico.municipio VALUES (1508, 'Caruaru', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.360254', 'I');
INSERT INTO historico.municipio VALUES (1509, 'Casinhas', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.361206', 'I');
INSERT INTO historico.municipio VALUES (1510, 'Catende', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.362152', 'I');
INSERT INTO historico.municipio VALUES (1511, 'Cedro', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.363201', 'I');
INSERT INTO historico.municipio VALUES (1512, 'Cha de Alegria', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.364172', 'I');
INSERT INTO historico.municipio VALUES (1513, 'Cha Grande', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.364895', 'I');
INSERT INTO historico.municipio VALUES (1514, 'Condado', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.365661', 'I');
INSERT INTO historico.municipio VALUES (1515, 'Correntes', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.366715', 'I');
INSERT INTO historico.municipio VALUES (1516, 'Cortes', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.376836', 'I');
INSERT INTO historico.municipio VALUES (1517, 'Cumaru', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.377881', 'I');
INSERT INTO historico.municipio VALUES (1518, 'Cupira', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.378741', 'I');
INSERT INTO historico.municipio VALUES (1519, 'Custodia', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.379657', 'I');
INSERT INTO historico.municipio VALUES (1520, 'Dormentes', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.380527', 'I');
INSERT INTO historico.municipio VALUES (1521, 'Escada', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.381407', 'I');
INSERT INTO historico.municipio VALUES (1522, 'Exu', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.382617', 'I');
INSERT INTO historico.municipio VALUES (1523, 'Feira Nova', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.383472', 'I');
INSERT INTO historico.municipio VALUES (1524, 'Fernando de Noronha', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.384317', 'I');
INSERT INTO historico.municipio VALUES (1525, 'Ferreiros', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.3852', 'I');
INSERT INTO historico.municipio VALUES (1526, 'Flores', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.386058', 'I');
INSERT INTO historico.municipio VALUES (1527, 'Floresta', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.386923', 'I');
INSERT INTO historico.municipio VALUES (1528, 'Frei Miguelinho', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.387844', 'I');
INSERT INTO historico.municipio VALUES (1529, 'Gameleira', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.388718', 'I');
INSERT INTO historico.municipio VALUES (1530, 'Garanhuns', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.389733', 'I');
INSERT INTO historico.municipio VALUES (1531, 'Gloria do Goita', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.390524', 'I');
INSERT INTO historico.municipio VALUES (1532, 'Goiana', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.391405', 'I');
INSERT INTO historico.municipio VALUES (1533, 'Granito', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.392255', 'I');
INSERT INTO historico.municipio VALUES (1534, 'Gravata', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.393148', 'I');
INSERT INTO historico.municipio VALUES (1535, 'Iati', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.394064', 'I');
INSERT INTO historico.municipio VALUES (1536, 'Ibimirim', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.394992', 'I');
INSERT INTO historico.municipio VALUES (1537, 'Ibirajuba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.395927', 'I');
INSERT INTO historico.municipio VALUES (1538, 'Igarassu', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.396835', 'I');
INSERT INTO historico.municipio VALUES (1540, 'Inaja', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.398738', 'I');
INSERT INTO historico.municipio VALUES (1541, 'Ingazeira', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.399746', 'I');
INSERT INTO historico.municipio VALUES (1542, 'Ipojuca', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.400727', 'I');
INSERT INTO historico.municipio VALUES (1543, 'Ipubi', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.401708', 'I');
INSERT INTO historico.municipio VALUES (1544, 'Itacuruba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.402642', 'I');
INSERT INTO historico.municipio VALUES (1545, 'Itaiba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.403569', 'I');
INSERT INTO historico.municipio VALUES (1547, 'Itambe', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.405413', 'I');
INSERT INTO historico.municipio VALUES (1548, 'Itapetim', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.40621', 'I');
INSERT INTO historico.municipio VALUES (1549, 'Itapissuma', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.407134', 'I');
INSERT INTO historico.municipio VALUES (1550, 'Itaquitinga', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.408047', 'I');
INSERT INTO historico.municipio VALUES (1551, 'Jaboatao dos Guararapes', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.408818', 'I');
INSERT INTO historico.municipio VALUES (1552, 'Jaqueira', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.409756', 'I');
INSERT INTO historico.municipio VALUES (1553, 'Jatauba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.410498', 'I');
INSERT INTO historico.municipio VALUES (1554, 'Jatoba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.411876', 'I');
INSERT INTO historico.municipio VALUES (1555, 'Joao Alfredo', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.417932', 'I');
INSERT INTO historico.municipio VALUES (1556, 'Joaquim Nabuco', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.419099', 'I');
INSERT INTO historico.municipio VALUES (1557, 'Jucati', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.420118', 'I');
INSERT INTO historico.municipio VALUES (1558, 'Jupi', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.421181', 'I');
INSERT INTO historico.municipio VALUES (1559, 'Jurema', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.422125', 'I');
INSERT INTO historico.municipio VALUES (1560, 'Lagoa do Carro', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.423115', 'I');
INSERT INTO historico.municipio VALUES (1562, 'Lagoa do Ouro', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.424996', 'I');
INSERT INTO historico.municipio VALUES (1563, 'Lagoa dos Gatos', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.425859', 'I');
INSERT INTO historico.municipio VALUES (1564, 'Lagoa Grande', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.42668', 'I');
INSERT INTO historico.municipio VALUES (1565, 'Lajedo', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.427665', 'I');
INSERT INTO historico.municipio VALUES (1566, 'Limoeiro', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.428572', 'I');
INSERT INTO historico.municipio VALUES (1567, 'Macaparana', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.429473', 'I');
INSERT INTO historico.municipio VALUES (1568, 'Machados', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.430395', 'I');
INSERT INTO historico.municipio VALUES (1569, 'Manari', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.431315', 'I');
INSERT INTO historico.municipio VALUES (1570, 'Maraial', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.432227', 'I');
INSERT INTO historico.municipio VALUES (1571, 'Mirandiba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.433144', 'I');
INSERT INTO historico.municipio VALUES (1573, 'Moreno', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.434923', 'I');
INSERT INTO historico.municipio VALUES (1574, 'Nazare da Mata', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.435804', 'I');
INSERT INTO historico.municipio VALUES (1575, 'Olinda', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.436674', 'I');
INSERT INTO historico.municipio VALUES (1576, 'Orobo', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.437566', 'I');
INSERT INTO historico.municipio VALUES (1577, 'Oroco', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.438497', 'I');
INSERT INTO historico.municipio VALUES (1578, 'Ouricuri', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.439384', 'I');
INSERT INTO historico.municipio VALUES (1579, 'Palmares', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.44018', 'I');
INSERT INTO historico.municipio VALUES (1580, 'Palmeirina', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.441107', 'I');
INSERT INTO historico.municipio VALUES (1581, 'Panelas', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.442238', 'I');
INSERT INTO historico.municipio VALUES (1582, 'Paranatama', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.443039', 'I');
INSERT INTO historico.municipio VALUES (1583, 'Parnamirim', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.44394', 'I');
INSERT INTO historico.municipio VALUES (1584, 'Passira', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.444874', 'I');
INSERT INTO historico.municipio VALUES (1585, 'Paudalho', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.445746', 'I');
INSERT INTO historico.municipio VALUES (1586, 'Paulista', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.446509', 'I');
INSERT INTO historico.municipio VALUES (1587, 'Pedra', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.447374', 'I');
INSERT INTO historico.municipio VALUES (1588, 'Pesqueira', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.448217', 'I');
INSERT INTO historico.municipio VALUES (1589, 'Petrolandia', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.449198', 'I');
INSERT INTO historico.municipio VALUES (1590, 'Petrolina', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.450099', 'I');
INSERT INTO historico.municipio VALUES (1591, 'Pocao', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.451059', 'I');
INSERT INTO historico.municipio VALUES (1592, 'Pombos', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.458158', 'I');
INSERT INTO historico.municipio VALUES (1593, 'Primavera', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.459513', 'I');
INSERT INTO historico.municipio VALUES (1594, 'Quipapa', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.460461', 'I');
INSERT INTO historico.municipio VALUES (1595, 'Quixaba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.461303', 'I');
INSERT INTO historico.municipio VALUES (1596, 'Recife', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.462202', 'I');
INSERT INTO historico.municipio VALUES (1597, 'Riacho das Almas', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.463132', 'I');
INSERT INTO historico.municipio VALUES (1598, 'Ribeirao', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.464166', 'I');
INSERT INTO historico.municipio VALUES (1599, 'Rio Formoso', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.46508', 'I');
INSERT INTO historico.municipio VALUES (1600, 'Saire', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.466141', 'I');
INSERT INTO historico.municipio VALUES (1601, 'Salgadinho', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.467057', 'I');
INSERT INTO historico.municipio VALUES (1602, 'Salgueiro', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.467963', 'I');
INSERT INTO historico.municipio VALUES (1603, 'Saloa', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.468887', 'I');
INSERT INTO historico.municipio VALUES (1604, 'Sanharo', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.469786', 'I');
INSERT INTO historico.municipio VALUES (1605, 'Santa Cruz', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.470673', 'I');
INSERT INTO historico.municipio VALUES (1606, 'Santa Cruz da Baixa Verde', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.471456', 'I');
INSERT INTO historico.municipio VALUES (1607, 'Santa Cruz do Capibaribe', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.47243', 'I');
INSERT INTO historico.municipio VALUES (1608, 'Santa Filomena', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.473203', 'I');
INSERT INTO historico.municipio VALUES (1609, 'Santa Maria da Boa Vista', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.474049', 'I');
INSERT INTO historico.municipio VALUES (1610, 'Santa Maria do Cambuca', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.474981', 'I');
INSERT INTO historico.municipio VALUES (1611, 'Santa Terezinha', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.475798', 'I');
INSERT INTO historico.municipio VALUES (1612, 'Sao Benedito do Sul', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.47664', 'I');
INSERT INTO historico.municipio VALUES (1613, 'Sao Bento do Una', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.477417', 'I');
INSERT INTO historico.municipio VALUES (1614, 'Sao Caitano', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.478275', 'I');
INSERT INTO historico.municipio VALUES (1615, 'Sao Joao', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.479132', 'I');
INSERT INTO historico.municipio VALUES (1616, 'Sao Joaquim do Monte', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.479973', 'I');
INSERT INTO historico.municipio VALUES (1617, 'Sao Jose da Coroa Grande', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.48086', 'I');
INSERT INTO historico.municipio VALUES (1618, 'Sao Jose do Belmonte', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.481801', 'I');
INSERT INTO historico.municipio VALUES (1619, 'Sao Jose do Egito', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.482835', 'I');
INSERT INTO historico.municipio VALUES (1620, 'Sao Lourenco da Mata', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.48371', 'I');
INSERT INTO historico.municipio VALUES (1621, 'Sao Vicente Ferrer', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.484603', 'I');
INSERT INTO historico.municipio VALUES (1622, 'Serra Talhada', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.485455', 'I');
INSERT INTO historico.municipio VALUES (1623, 'Serrita', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.486433', 'I');
INSERT INTO historico.municipio VALUES (1624, 'Sertania', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.487232', 'I');
INSERT INTO historico.municipio VALUES (1625, 'Sirinhaem', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.48815', 'I');
INSERT INTO historico.municipio VALUES (1572, 'Moreilandia', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.434075', 'I');
INSERT INTO historico.municipio VALUES (1626, 'Solidao', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.489012', 'I');
INSERT INTO historico.municipio VALUES (1627, 'Surubim', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.489863', 'I');
INSERT INTO historico.municipio VALUES (1628, 'Tabira', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.490792', 'I');
INSERT INTO historico.municipio VALUES (1629, 'Tacaimbo', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.491684', 'I');
INSERT INTO historico.municipio VALUES (1630, 'Tacaratu', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.492321', 'I');
INSERT INTO historico.municipio VALUES (1631, 'Tamandare', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.49933', 'I');
INSERT INTO historico.municipio VALUES (1632, 'Taquaritinga do Norte', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.500598', 'I');
INSERT INTO historico.municipio VALUES (1633, 'Terezinha', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.501611', 'I');
INSERT INTO historico.municipio VALUES (1634, 'Terra Nova', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.502516', 'I');
INSERT INTO historico.municipio VALUES (1635, 'Timbauba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.503375', 'I');
INSERT INTO historico.municipio VALUES (1636, 'Toritama', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.504224', 'I');
INSERT INTO historico.municipio VALUES (1637, 'Tracunhaem', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.505121', 'I');
INSERT INTO historico.municipio VALUES (1638, 'Trindade', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.505974', 'I');
INSERT INTO historico.municipio VALUES (1639, 'Triunfo', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.506916', 'I');
INSERT INTO historico.municipio VALUES (1640, 'Tupanatinga', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.507922', 'I');
INSERT INTO historico.municipio VALUES (1641, 'Tuparetama', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.508899', 'I');
INSERT INTO historico.municipio VALUES (1642, 'Venturosa', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.509757', 'I');
INSERT INTO historico.municipio VALUES (1643, 'Verdejante', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.510673', 'I');
INSERT INTO historico.municipio VALUES (1644, 'Vertente do Lerio', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.511529', 'I');
INSERT INTO historico.municipio VALUES (1645, 'Vertentes', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.512415', 'I');
INSERT INTO historico.municipio VALUES (1646, 'Vicencia', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.513303', 'I');
INSERT INTO historico.municipio VALUES (1647, 'Vitoria de Santo Antao', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.51418', 'I');
INSERT INTO historico.municipio VALUES (1648, 'Xexeu', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.515121', 'I');
INSERT INTO historico.municipio VALUES (1649, 'Agua Branca', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.515958', 'I');
INSERT INTO historico.municipio VALUES (1650, 'Anadia', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.516876', 'I');
INSERT INTO historico.municipio VALUES (1651, 'Arapiraca', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.517813', 'I');
INSERT INTO historico.municipio VALUES (1652, 'Atalaia', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.518801', 'I');
INSERT INTO historico.municipio VALUES (1653, 'Barra de Santo Antonio', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.519858', 'I');
INSERT INTO historico.municipio VALUES (1654, 'Barra de Sao Miguel', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.520772', 'I');
INSERT INTO historico.municipio VALUES (1655, 'Batalha', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.521655', 'I');
INSERT INTO historico.municipio VALUES (1656, 'Belem', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.522539', 'I');
INSERT INTO historico.municipio VALUES (1657, 'Belo Monte', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.523412', 'I');
INSERT INTO historico.municipio VALUES (1658, 'Boca da Mata', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.524257', 'I');
INSERT INTO historico.municipio VALUES (1659, 'Branquinha', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.525049', 'I');
INSERT INTO historico.municipio VALUES (1660, 'Cacimbinhas', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.525871', 'I');
INSERT INTO historico.municipio VALUES (1661, 'Cajueiro', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.526778', 'I');
INSERT INTO historico.municipio VALUES (1662, 'Campestre', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.527574', 'I');
INSERT INTO historico.municipio VALUES (1663, 'Campo Alegre', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.528462', 'I');
INSERT INTO historico.municipio VALUES (1664, 'Campo Grande', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.529366', 'I');
INSERT INTO historico.municipio VALUES (1665, 'Canapi', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.5303', 'I');
INSERT INTO historico.municipio VALUES (1666, 'Capela', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.531062', 'I');
INSERT INTO historico.municipio VALUES (1667, 'Carneiros', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.531967', 'I');
INSERT INTO historico.municipio VALUES (1668, 'Cha Preta', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.532762', 'I');
INSERT INTO historico.municipio VALUES (1669, 'Coite do Noia', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.53981', 'I');
INSERT INTO historico.municipio VALUES (1670, 'Colonia Leopoldina', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.540909', 'I');
INSERT INTO historico.municipio VALUES (1671, 'Coqueiro Seco', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.541931', 'I');
INSERT INTO historico.municipio VALUES (1672, 'Coruripe', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.542806', 'I');
INSERT INTO historico.municipio VALUES (1673, 'Craibas', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.543615', 'I');
INSERT INTO historico.municipio VALUES (1674, 'Delmiro Gouveia', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.544416', 'I');
INSERT INTO historico.municipio VALUES (1675, 'Dois Riachos', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.545079', 'I');
INSERT INTO historico.municipio VALUES (1676, 'Estrela de Alagoas', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.545943', 'I');
INSERT INTO historico.municipio VALUES (1677, 'Feira Grande', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.546837', 'I');
INSERT INTO historico.municipio VALUES (1678, 'Feliz Deserto', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.547708', 'I');
INSERT INTO historico.municipio VALUES (1679, 'Flexeiras', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.54858', 'I');
INSERT INTO historico.municipio VALUES (1680, 'Girau do Ponciano', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.549416', 'I');
INSERT INTO historico.municipio VALUES (1681, 'Ibateguara', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.550297', 'I');
INSERT INTO historico.municipio VALUES (1682, 'Igaci', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.551161', 'I');
INSERT INTO historico.municipio VALUES (1683, 'Igreja Nova', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.552215', 'I');
INSERT INTO historico.municipio VALUES (1684, 'Inhapi', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.553518', 'I');
INSERT INTO historico.municipio VALUES (1685, 'Jacare dos Homens', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.554435', 'I');
INSERT INTO historico.municipio VALUES (1686, 'Jacuipe', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.555236', 'I');
INSERT INTO historico.municipio VALUES (1687, 'Japaratinga', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.556108', 'I');
INSERT INTO historico.municipio VALUES (1688, 'Jaramataia', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.556965', 'I');
INSERT INTO historico.municipio VALUES (1689, 'Jequia da Praia', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.557886', 'I');
INSERT INTO historico.municipio VALUES (1690, 'Joaquim Gomes', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.558773', 'I');
INSERT INTO historico.municipio VALUES (1691, 'Jundia', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.55955', 'I');
INSERT INTO historico.municipio VALUES (1692, 'Junqueiro', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.560447', 'I');
INSERT INTO historico.municipio VALUES (1693, 'Lagoa da Canoa', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.561361', 'I');
INSERT INTO historico.municipio VALUES (1694, 'Limoeiro de Anadia', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.562239', 'I');
INSERT INTO historico.municipio VALUES (1695, 'Maceio', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.563152', 'I');
INSERT INTO historico.municipio VALUES (1696, 'Major Isidoro', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.564162', 'I');
INSERT INTO historico.municipio VALUES (1698, 'Maragogi', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.566063', 'I');
INSERT INTO historico.municipio VALUES (1699, 'Maravilha', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.566937', 'I');
INSERT INTO historico.municipio VALUES (1700, 'Marechal Deodoro', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.56783', 'I');
INSERT INTO historico.municipio VALUES (1701, 'Maribondo', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.568607', 'I');
INSERT INTO historico.municipio VALUES (1697, 'Mar Vermelho', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.56511', 'I');
INSERT INTO historico.municipio VALUES (1702, 'Mata Grande', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.569485', 'I');
INSERT INTO historico.municipio VALUES (1703, 'Matriz de Camaragibe', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.570409', 'I');
INSERT INTO historico.municipio VALUES (1704, 'Messias', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.57126', 'I');
INSERT INTO historico.municipio VALUES (1705, 'Minador do Negrao', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.572177', 'I');
INSERT INTO historico.municipio VALUES (1706, 'Monteiropolis', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.573135', 'I');
INSERT INTO historico.municipio VALUES (1707, 'Murici', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.579953', 'I');
INSERT INTO historico.municipio VALUES (1708, 'Novo Lino', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.58127', 'I');
INSERT INTO historico.municipio VALUES (1709, 'Olho D''agua das Flores', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.582212', 'I');
INSERT INTO historico.municipio VALUES (1710, 'Olho D''agua do Casado', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.583111', 'I');
INSERT INTO historico.municipio VALUES (1711, 'Olho D''agua Grande', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.583997', 'I');
INSERT INTO historico.municipio VALUES (1712, 'Olivenca', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.584857', 'I');
INSERT INTO historico.municipio VALUES (1713, 'Ouro Branco', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.585722', 'I');
INSERT INTO historico.municipio VALUES (1714, 'Palestina', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.58684', 'I');
INSERT INTO historico.municipio VALUES (1715, 'Palmeira dos Indios', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.587745', 'I');
INSERT INTO historico.municipio VALUES (1716, 'Pao de Acucar', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.58866', 'I');
INSERT INTO historico.municipio VALUES (1717, 'Pariconha', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.589445', 'I');
INSERT INTO historico.municipio VALUES (1718, 'Paripueira', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.590225', 'I');
INSERT INTO historico.municipio VALUES (1719, 'Passo de Camaragibe', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.59101', 'I');
INSERT INTO historico.municipio VALUES (1720, 'Paulo Jacinto', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.591854', 'I');
INSERT INTO historico.municipio VALUES (1721, 'Penedo', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.592907', 'I');
INSERT INTO historico.municipio VALUES (1722, 'Piacabucu', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.593907', 'I');
INSERT INTO historico.municipio VALUES (1723, 'Pilar', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.594781', 'I');
INSERT INTO historico.municipio VALUES (1724, 'Pindoba', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.595808', 'I');
INSERT INTO historico.municipio VALUES (1725, 'Piranhas', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.596659', 'I');
INSERT INTO historico.municipio VALUES (1726, 'Poco das Trincheiras', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.597518', 'I');
INSERT INTO historico.municipio VALUES (1727, 'Porto Calvo', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.598531', 'I');
INSERT INTO historico.municipio VALUES (1728, 'Porto de Pedras', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.599515', 'I');
INSERT INTO historico.municipio VALUES (1729, 'Porto Real do Colegio', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.600386', 'I');
INSERT INTO historico.municipio VALUES (1730, 'Quebrangulo', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.601248', 'I');
INSERT INTO historico.municipio VALUES (1731, 'Rio Largo', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.602118', 'I');
INSERT INTO historico.municipio VALUES (1732, 'Roteiro', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.602974', 'I');
INSERT INTO historico.municipio VALUES (1733, 'Santa Luzia do Norte', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.60384', 'I');
INSERT INTO historico.municipio VALUES (1734, 'Santana do Ipanema', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.604666', 'I');
INSERT INTO historico.municipio VALUES (1735, 'Santana do Mundau', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.605464', 'I');
INSERT INTO historico.municipio VALUES (1736, 'Sao Bras', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.60638', 'I');
INSERT INTO historico.municipio VALUES (1737, 'Sao Jose da Laje', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.607218', 'I');
INSERT INTO historico.municipio VALUES (1738, 'Sao Jose da Tapera', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.608123', 'I');
INSERT INTO historico.municipio VALUES (1739, 'Sao Luis do Quitunde', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.609231', 'I');
INSERT INTO historico.municipio VALUES (1740, 'Sao Miguel dos Campos', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.610109', 'I');
INSERT INTO historico.municipio VALUES (1741, 'Sao Miguel dos Milagres', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.610971', 'I');
INSERT INTO historico.municipio VALUES (1742, 'Sao Sebastiao', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.611868', 'I');
INSERT INTO historico.municipio VALUES (1743, 'Satuba', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.612769', 'I');
INSERT INTO historico.municipio VALUES (1744, 'Senador Rui Palmeira', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.61364', 'I');
INSERT INTO historico.municipio VALUES (1745, 'Tanque D''arca', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.621045', 'I');
INSERT INTO historico.municipio VALUES (1746, 'Taquarana', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.622171', 'I');
INSERT INTO historico.municipio VALUES (1747, 'Teotonio Vilela', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.623156', 'I');
INSERT INTO historico.municipio VALUES (1748, 'Traipu', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.624182', 'I');
INSERT INTO historico.municipio VALUES (1749, 'Uniao dos Palmares', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.625153', 'I');
INSERT INTO historico.municipio VALUES (1750, 'Vicosa', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.626119', 'I');
INSERT INTO historico.municipio VALUES (1751, 'Amparo de Sao Francisco', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.626967', 'I');
INSERT INTO historico.municipio VALUES (1752, 'Aquidaba', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.627865', 'I');
INSERT INTO historico.municipio VALUES (1753, 'Aracaju', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.628811', 'I');
INSERT INTO historico.municipio VALUES (1754, 'Araua', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.629694', 'I');
INSERT INTO historico.municipio VALUES (1755, 'Areia Branca', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.630578', 'I');
INSERT INTO historico.municipio VALUES (1756, 'Barra dos Coqueiros', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.631545', 'I');
INSERT INTO historico.municipio VALUES (1757, 'Boquim', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.632563', 'I');
INSERT INTO historico.municipio VALUES (1758, 'Brejo Grande', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.633428', 'I');
INSERT INTO historico.municipio VALUES (1759, 'Campo do Brito', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.63429', 'I');
INSERT INTO historico.municipio VALUES (1760, 'Canhoba', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.635169', 'I');
INSERT INTO historico.municipio VALUES (1761, 'Caninde de Sao Francisco', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.636006', 'I');
INSERT INTO historico.municipio VALUES (1762, 'Capela', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.636835', 'I');
INSERT INTO historico.municipio VALUES (1763, 'Carira', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.637698', 'I');
INSERT INTO historico.municipio VALUES (1764, 'Carmopolis', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.638589', 'I');
INSERT INTO historico.municipio VALUES (1765, 'Cedro de Sao Joao', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.639453', 'I');
INSERT INTO historico.municipio VALUES (1766, 'Cristinapolis', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.640358', 'I');
INSERT INTO historico.municipio VALUES (1767, 'Cumbe', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.641238', 'I');
INSERT INTO historico.municipio VALUES (1768, 'Divina Pastora', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.642203', 'I');
INSERT INTO historico.municipio VALUES (1769, 'Estancia', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.642975', 'I');
INSERT INTO historico.municipio VALUES (1770, 'Feira Nova', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.643769', 'I');
INSERT INTO historico.municipio VALUES (1771, 'Frei Paulo', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.64469', 'I');
INSERT INTO historico.municipio VALUES (1772, 'Gararu', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.645572', 'I');
INSERT INTO historico.municipio VALUES (1773, 'General Maynard', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.646491', 'I');
INSERT INTO historico.municipio VALUES (1774, 'Gracho Cardoso', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.64737', 'I');
INSERT INTO historico.municipio VALUES (1775, 'Ilha das Flores', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.648183', 'I');
INSERT INTO historico.municipio VALUES (1776, 'Indiaroba', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.649012', 'I');
INSERT INTO historico.municipio VALUES (1777, 'Itabaiana', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.649896', 'I');
INSERT INTO historico.municipio VALUES (1778, 'Itabaianinha', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.650772', 'I');
INSERT INTO historico.municipio VALUES (1779, 'Itabi', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.651642', 'I');
INSERT INTO historico.municipio VALUES (1780, 'Itaporanga D''ajuda', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.652555', 'I');
INSERT INTO historico.municipio VALUES (1781, 'Japaratuba', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.653348', 'I');
INSERT INTO historico.municipio VALUES (1782, 'Japoata', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.654107', 'I');
INSERT INTO historico.municipio VALUES (1783, 'Lagarto', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.654821', 'I');
INSERT INTO historico.municipio VALUES (1784, 'Laranjeiras', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.655682', 'I');
INSERT INTO historico.municipio VALUES (1785, 'Macambira', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.661933', 'I');
INSERT INTO historico.municipio VALUES (1786, 'Malhada dos Bois', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.663166', 'I');
INSERT INTO historico.municipio VALUES (1787, 'Malhador', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.664217', 'I');
INSERT INTO historico.municipio VALUES (1788, 'Maruim', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.665029', 'I');
INSERT INTO historico.municipio VALUES (1789, 'Moita Bonita', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.665899', 'I');
INSERT INTO historico.municipio VALUES (1790, 'Monte Alegre de Sergipe', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.666702', 'I');
INSERT INTO historico.municipio VALUES (1791, 'Muribeca', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.667607', 'I');
INSERT INTO historico.municipio VALUES (1792, 'Neopolis', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.668505', 'I');
INSERT INTO historico.municipio VALUES (1793, 'Nossa Senhora Aparecida', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.66942', 'I');
INSERT INTO historico.municipio VALUES (1794, 'Nossa Senhora da Gloria', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.670251', 'I');
INSERT INTO historico.municipio VALUES (1795, 'Nossa Senhora das Dores', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.671045', 'I');
INSERT INTO historico.municipio VALUES (1796, 'Nossa Senhora de Lourdes', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.671969', 'I');
INSERT INTO historico.municipio VALUES (1797, 'Nossa Senhora do Socorro', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.672835', 'I');
INSERT INTO historico.municipio VALUES (1798, 'Pacatuba', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.673744', 'I');
INSERT INTO historico.municipio VALUES (1799, 'Pedra Mole', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.674638', 'I');
INSERT INTO historico.municipio VALUES (1800, 'Pedrinhas', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.675565', 'I');
INSERT INTO historico.municipio VALUES (1801, 'Pinhao', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.676278', 'I');
INSERT INTO historico.municipio VALUES (1802, 'Pirambu', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.677143', 'I');
INSERT INTO historico.municipio VALUES (1803, 'Poco Redondo', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.67807', 'I');
INSERT INTO historico.municipio VALUES (1804, 'Poco Verde', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.678996', 'I');
INSERT INTO historico.municipio VALUES (1805, 'Porto da Folha', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.679867', 'I');
INSERT INTO historico.municipio VALUES (1806, 'Propria', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.680723', 'I');
INSERT INTO historico.municipio VALUES (1807, 'Riachao do Dantas', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.68163', 'I');
INSERT INTO historico.municipio VALUES (1808, 'Riachuelo', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.68251', 'I');
INSERT INTO historico.municipio VALUES (1809, 'Ribeiropolis', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.683399', 'I');
INSERT INTO historico.municipio VALUES (1810, 'Rosario do Catete', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.684327', 'I');
INSERT INTO historico.municipio VALUES (1811, 'Salgado', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.685208', 'I');
INSERT INTO historico.municipio VALUES (1812, 'Santa Luzia do Itanhy', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.686053', 'I');
INSERT INTO historico.municipio VALUES (1814, 'Santana do Sao Francisco', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.688243', 'I');
INSERT INTO historico.municipio VALUES (1813, 'Santa Rosa de Lima', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.687431', 'I');
INSERT INTO historico.municipio VALUES (1815, 'Santo Amaro das Brotas', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.689158', 'I');
INSERT INTO historico.municipio VALUES (1816, 'Sao Cristovao', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.690023', 'I');
INSERT INTO historico.municipio VALUES (1817, 'Sao Domingos', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.690888', 'I');
INSERT INTO historico.municipio VALUES (1818, 'Sao Francisco', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.691767', 'I');
INSERT INTO historico.municipio VALUES (1819, 'Sao Miguel do Aleixo', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.692583', 'I');
INSERT INTO historico.municipio VALUES (1820, 'Simao Dias', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.693538', 'I');
INSERT INTO historico.municipio VALUES (1821, 'Siriri', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.694316', 'I');
INSERT INTO historico.municipio VALUES (1822, 'Telha', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.695302', 'I');
INSERT INTO historico.municipio VALUES (1823, 'Tobias Barreto', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.696176', 'I');
INSERT INTO historico.municipio VALUES (1824, 'Tomar do Geru', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.703912', 'I');
INSERT INTO historico.municipio VALUES (1825, 'Umbauba', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.704998', 'I');
INSERT INTO historico.municipio VALUES (1826, 'Abaira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.705862', 'I');
INSERT INTO historico.municipio VALUES (1827, 'Abare', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.706776', 'I');
INSERT INTO historico.municipio VALUES (1828, 'Acajutiba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.707772', 'I');
INSERT INTO historico.municipio VALUES (1829, 'Adustina', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.708678', 'I');
INSERT INTO historico.municipio VALUES (1830, 'Agua Fria', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.709564', 'I');
INSERT INTO historico.municipio VALUES (1949, 'Erico Cardoso', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.835874', 'I');
INSERT INTO historico.municipio VALUES (1831, 'Aiquara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.710453', 'I');
INSERT INTO historico.municipio VALUES (1832, 'Alagoinhas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.711342', 'I');
INSERT INTO historico.municipio VALUES (1833, 'Alcobaca', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.712309', 'I');
INSERT INTO historico.municipio VALUES (1834, 'Almadina', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.713183', 'I');
INSERT INTO historico.municipio VALUES (1835, 'Amargosa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.714102', 'I');
INSERT INTO historico.municipio VALUES (1836, 'Amelia Rodrigues', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.714937', 'I');
INSERT INTO historico.municipio VALUES (1837, 'America Dourada', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.715822', 'I');
INSERT INTO historico.municipio VALUES (1838, 'Anage', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.716687', 'I');
INSERT INTO historico.municipio VALUES (1839, 'Andarai', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.717527', 'I');
INSERT INTO historico.municipio VALUES (1840, 'Andorinha', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.718396', 'I');
INSERT INTO historico.municipio VALUES (1841, 'Angical', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.719204', 'I');
INSERT INTO historico.municipio VALUES (1842, 'Anguera', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.720208', 'I');
INSERT INTO historico.municipio VALUES (1843, 'Antas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.720988', 'I');
INSERT INTO historico.municipio VALUES (1844, 'Antonio Cardoso', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.721872', 'I');
INSERT INTO historico.municipio VALUES (1845, 'Antonio Goncalves', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.72283', 'I');
INSERT INTO historico.municipio VALUES (1846, 'Apora', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.723737', 'I');
INSERT INTO historico.municipio VALUES (1847, 'Apuarema', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.72468', 'I');
INSERT INTO historico.municipio VALUES (1849, 'Aracatu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.72638', 'I');
INSERT INTO historico.municipio VALUES (1848, 'Aracas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.725609', 'I');
INSERT INTO historico.municipio VALUES (1850, 'Araci', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.727157', 'I');
INSERT INTO historico.municipio VALUES (1851, 'Aramari', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.727919', 'I');
INSERT INTO historico.municipio VALUES (1852, 'Arataca', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.728798', 'I');
INSERT INTO historico.municipio VALUES (1853, 'Aratuipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.729676', 'I');
INSERT INTO historico.municipio VALUES (1854, 'Aurelino Leal', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.730623', 'I');
INSERT INTO historico.municipio VALUES (1855, 'Baianopolis', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.731629', 'I');
INSERT INTO historico.municipio VALUES (1856, 'Baixa Grande', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.732415', 'I');
INSERT INTO historico.municipio VALUES (1857, 'Banzae', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.733268', 'I');
INSERT INTO historico.municipio VALUES (1858, 'Barra', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.734163', 'I');
INSERT INTO historico.municipio VALUES (1859, 'Barra da Estiva', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.735027', 'I');
INSERT INTO historico.municipio VALUES (1860, 'Barra do Choca', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.735986', 'I');
INSERT INTO historico.municipio VALUES (1861, 'Barra do Mendes', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.736784', 'I');
INSERT INTO historico.municipio VALUES (1862, 'Barra do Rocha', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.737614', 'I');
INSERT INTO historico.municipio VALUES (1863, 'Barreiras', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.743632', 'I');
INSERT INTO historico.municipio VALUES (1864, 'Barro Alto', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.745185', 'I');
INSERT INTO historico.municipio VALUES (1865, 'Barrocas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.746183', 'I');
INSERT INTO historico.municipio VALUES (1866, 'Belmonte', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.747082', 'I');
INSERT INTO historico.municipio VALUES (1867, 'Belo Campo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.747989', 'I');
INSERT INTO historico.municipio VALUES (1868, 'Biritinga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.748862', 'I');
INSERT INTO historico.municipio VALUES (1869, 'Boa Nova', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.749789', 'I');
INSERT INTO historico.municipio VALUES (1870, 'Boa Vista do Tupim', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.750607', 'I');
INSERT INTO historico.municipio VALUES (1871, 'Bom Jesus da Lapa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.7516', 'I');
INSERT INTO historico.municipio VALUES (1872, 'Bom Jesus da Serra', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.752527', 'I');
INSERT INTO historico.municipio VALUES (1873, 'Boninal', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.753467', 'I');
INSERT INTO historico.municipio VALUES (1874, 'Bonito', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.754333', 'I');
INSERT INTO historico.municipio VALUES (1875, 'Boquira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.755177', 'I');
INSERT INTO historico.municipio VALUES (1876, 'Botupora', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.756099', 'I');
INSERT INTO historico.municipio VALUES (1877, 'Brejoes', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.756961', 'I');
INSERT INTO historico.municipio VALUES (1878, 'Brejolandia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.757913', 'I');
INSERT INTO historico.municipio VALUES (1879, 'Brotas de Macaubas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.758779', 'I');
INSERT INTO historico.municipio VALUES (1880, 'Brumado', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.759633', 'I');
INSERT INTO historico.municipio VALUES (1881, 'Buerarema', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.760497', 'I');
INSERT INTO historico.municipio VALUES (1882, 'Buritirama', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.761353', 'I');
INSERT INTO historico.municipio VALUES (1883, 'Caatiba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.762303', 'I');
INSERT INTO historico.municipio VALUES (1884, 'Cabaceiras do Paraguacu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.763755', 'I');
INSERT INTO historico.municipio VALUES (1885, 'Cachoeira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.764694', 'I');
INSERT INTO historico.municipio VALUES (1886, 'Cacule', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.765572', 'I');
INSERT INTO historico.municipio VALUES (1887, 'Caem', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.766486', 'I');
INSERT INTO historico.municipio VALUES (1888, 'Caetanos', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.767347', 'I');
INSERT INTO historico.municipio VALUES (1889, 'Caetite', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.768201', 'I');
INSERT INTO historico.municipio VALUES (1890, 'Cafarnaum', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.769048', 'I');
INSERT INTO historico.municipio VALUES (1891, 'Cairu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.769993', 'I');
INSERT INTO historico.municipio VALUES (1892, 'Caldeirao Grande', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.770885', 'I');
INSERT INTO historico.municipio VALUES (1893, 'Camacan', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.771855', 'I');
INSERT INTO historico.municipio VALUES (1894, 'Camacari', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.772719', 'I');
INSERT INTO historico.municipio VALUES (1895, 'Camamu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.773477', 'I');
INSERT INTO historico.municipio VALUES (1896, 'Campo Alegre de Lourdes', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.774295', 'I');
INSERT INTO historico.municipio VALUES (1897, 'Campo Formoso', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.775204', 'I');
INSERT INTO historico.municipio VALUES (1898, 'Canapolis', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.776195', 'I');
INSERT INTO historico.municipio VALUES (1899, 'Canarana', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.776955', 'I');
INSERT INTO historico.municipio VALUES (1900, 'Canavieiras', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.777826', 'I');
INSERT INTO historico.municipio VALUES (1901, 'Candeal', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.778621', 'I');
INSERT INTO historico.municipio VALUES (1902, 'Candeias', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.785654', 'I');
INSERT INTO historico.municipio VALUES (1903, 'Candiba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.786875', 'I');
INSERT INTO historico.municipio VALUES (1904, 'Candido Sales', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.787762', 'I');
INSERT INTO historico.municipio VALUES (1905, 'Cansancao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.788735', 'I');
INSERT INTO historico.municipio VALUES (1906, 'Canudos', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.789648', 'I');
INSERT INTO historico.municipio VALUES (1907, 'Capela do Alto Alegre', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.790552', 'I');
INSERT INTO historico.municipio VALUES (1908, 'Capim Grosso', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.791373', 'I');
INSERT INTO historico.municipio VALUES (1909, 'Caraibas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.792368', 'I');
INSERT INTO historico.municipio VALUES (1910, 'Caravelas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.793239', 'I');
INSERT INTO historico.municipio VALUES (1911, 'Cardeal da Silva', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.794153', 'I');
INSERT INTO historico.municipio VALUES (1912, 'Carinhanha', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.795076', 'I');
INSERT INTO historico.municipio VALUES (1913, 'Casa Nova', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.796126', 'I');
INSERT INTO historico.municipio VALUES (1914, 'Castro Alves', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.797062', 'I');
INSERT INTO historico.municipio VALUES (1915, 'Catolandia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.797944', 'I');
INSERT INTO historico.municipio VALUES (1916, 'Catu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.798905', 'I');
INSERT INTO historico.municipio VALUES (1917, 'Caturama', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.799835', 'I');
INSERT INTO historico.municipio VALUES (1918, 'Central', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.800762', 'I');
INSERT INTO historico.municipio VALUES (1919, 'Chorrocho', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.801673', 'I');
INSERT INTO historico.municipio VALUES (1920, 'Cicero Dantas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.80256', 'I');
INSERT INTO historico.municipio VALUES (1921, 'Cipo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.803435', 'I');
INSERT INTO historico.municipio VALUES (1922, 'Coaraci', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.804362', 'I');
INSERT INTO historico.municipio VALUES (1923, 'Cocos', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.805142', 'I');
INSERT INTO historico.municipio VALUES (1924, 'Conceicao da Feira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.806049', 'I');
INSERT INTO historico.municipio VALUES (1925, 'Conceicao do Almeida', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.80693', 'I');
INSERT INTO historico.municipio VALUES (1926, 'Conceicao do Coite', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.807792', 'I');
INSERT INTO historico.municipio VALUES (1927, 'Conceicao do Jacuipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.808715', 'I');
INSERT INTO historico.municipio VALUES (1928, 'Conde', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.809636', 'I');
INSERT INTO historico.municipio VALUES (1929, 'Condeuba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.810398', 'I');
INSERT INTO historico.municipio VALUES (1930, 'Contendas do Sincora', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.811224', 'I');
INSERT INTO historico.municipio VALUES (1931, 'Coracao de Maria', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.812079', 'I');
INSERT INTO historico.municipio VALUES (1932, 'Cordeiros', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.812982', 'I');
INSERT INTO historico.municipio VALUES (1933, 'Coribe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.81392', 'I');
INSERT INTO historico.municipio VALUES (1934, 'Coronel Joao Sa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.814844', 'I');
INSERT INTO historico.municipio VALUES (1935, 'Correntina', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.815785', 'I');
INSERT INTO historico.municipio VALUES (1936, 'Cotegipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.816686', 'I');
INSERT INTO historico.municipio VALUES (1937, 'Cravolandia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.817527', 'I');
INSERT INTO historico.municipio VALUES (1938, 'Crisopolis', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.818343', 'I');
INSERT INTO historico.municipio VALUES (1939, 'Cristopolis', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.819171', 'I');
INSERT INTO historico.municipio VALUES (1940, 'Cruz das Almas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.826554', 'I');
INSERT INTO historico.municipio VALUES (1941, 'Curaca', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.827636', 'I');
INSERT INTO historico.municipio VALUES (1942, 'Dario Meira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.829405', 'I');
INSERT INTO historico.municipio VALUES (1943, 'Dias D''avila', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.830489', 'I');
INSERT INTO historico.municipio VALUES (1944, 'Dom Basilio', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.831352', 'I');
INSERT INTO historico.municipio VALUES (1945, 'Dom Macedo Costa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.83241', 'I');
INSERT INTO historico.municipio VALUES (1946, 'Elisio Medrado', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.833251', 'I');
INSERT INTO historico.municipio VALUES (1947, 'Encruzilhada', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.83412', 'I');
INSERT INTO historico.municipio VALUES (1948, 'Entre Rios', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.835064', 'I');
INSERT INTO historico.municipio VALUES (1950, 'Esplanada', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.836741', 'I');
INSERT INTO historico.municipio VALUES (1951, 'Euclides da Cunha', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.837646', 'I');
INSERT INTO historico.municipio VALUES (1952, 'Eunapolis', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.838519', 'I');
INSERT INTO historico.municipio VALUES (1953, 'Fatima', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.839335', 'I');
INSERT INTO historico.municipio VALUES (1954, 'Feira da Mata', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.840193', 'I');
INSERT INTO historico.municipio VALUES (1955, 'Feira de Santana', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.841117', 'I');
INSERT INTO historico.municipio VALUES (1956, 'Filadelfia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.842011', 'I');
INSERT INTO historico.municipio VALUES (1957, 'Firmino Alves', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.842944', 'I');
INSERT INTO historico.municipio VALUES (1958, 'Floresta Azul', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.843755', 'I');
INSERT INTO historico.municipio VALUES (1959, 'Formosa do Rio Preto', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.844635', 'I');
INSERT INTO historico.municipio VALUES (1960, 'Gandu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.845544', 'I');
INSERT INTO historico.municipio VALUES (1961, 'Gaviao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.846441', 'I');
INSERT INTO historico.municipio VALUES (1962, 'Gentio do Ouro', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.847284', 'I');
INSERT INTO historico.municipio VALUES (1963, 'Gloria', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.84819', 'I');
INSERT INTO historico.municipio VALUES (1964, 'Gongogi', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.84909', 'I');
INSERT INTO historico.municipio VALUES (1966, 'Governador Mangabeira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.850857', 'I');
INSERT INTO historico.municipio VALUES (1967, 'Guajeru', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.85184', 'I');
INSERT INTO historico.municipio VALUES (1968, 'Guanambi', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.852748', 'I');
INSERT INTO historico.municipio VALUES (1969, 'Guaratinga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.853646', 'I');
INSERT INTO historico.municipio VALUES (1970, 'Heliopolis', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.854517', 'I');
INSERT INTO historico.municipio VALUES (1971, 'Iacu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.855462', 'I');
INSERT INTO historico.municipio VALUES (1972, 'Ibiassuce', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.856356', 'I');
INSERT INTO historico.municipio VALUES (1973, 'Ibicarai', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.857175', 'I');
INSERT INTO historico.municipio VALUES (1974, 'Ibicoara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.858076', 'I');
INSERT INTO historico.municipio VALUES (1975, 'Ibicui', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.858999', 'I');
INSERT INTO historico.municipio VALUES (1976, 'Ibipeba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.859993', 'I');
INSERT INTO historico.municipio VALUES (1977, 'Ibipitanga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.867007', 'I');
INSERT INTO historico.municipio VALUES (1978, 'Ibiquera', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.868154', 'I');
INSERT INTO historico.municipio VALUES (1979, 'Ibirapitanga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.869284', 'I');
INSERT INTO historico.municipio VALUES (1980, 'Ibirapua', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.870219', 'I');
INSERT INTO historico.municipio VALUES (1981, 'Ibirataia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.871155', 'I');
INSERT INTO historico.municipio VALUES (1982, 'Ibitiara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.872193', 'I');
INSERT INTO historico.municipio VALUES (1983, 'Ibitita', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.873038', 'I');
INSERT INTO historico.municipio VALUES (1984, 'Ibotirama', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.873833', 'I');
INSERT INTO historico.municipio VALUES (1985, 'Ichu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.874719', 'I');
INSERT INTO historico.municipio VALUES (1986, 'Igapora', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.875578', 'I');
INSERT INTO historico.municipio VALUES (1987, 'Igrapiuna', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.876442', 'I');
INSERT INTO historico.municipio VALUES (1988, 'Iguai', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.877337', 'I');
INSERT INTO historico.municipio VALUES (1989, 'Ilheus', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.878226', 'I');
INSERT INTO historico.municipio VALUES (1990, 'Inhambupe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.87915', 'I');
INSERT INTO historico.municipio VALUES (1991, 'Ipecaeta', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.880071', 'I');
INSERT INTO historico.municipio VALUES (1992, 'Ipiau', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.880952', 'I');
INSERT INTO historico.municipio VALUES (1993, 'Ipira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.881831', 'I');
INSERT INTO historico.municipio VALUES (1994, 'Ipupiara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.882705', 'I');
INSERT INTO historico.municipio VALUES (1995, 'Irajuba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.883566', 'I');
INSERT INTO historico.municipio VALUES (1996, 'Iramaia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.88439', 'I');
INSERT INTO historico.municipio VALUES (1997, 'Iraquara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.885298', 'I');
INSERT INTO historico.municipio VALUES (1998, 'Irara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.886211', 'I');
INSERT INTO historico.municipio VALUES (1999, 'Irece', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.887131', 'I');
INSERT INTO historico.municipio VALUES (2000, 'Itabela', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.88815', 'I');
INSERT INTO historico.municipio VALUES (2001, 'Itaberaba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.888959', 'I');
INSERT INTO historico.municipio VALUES (2002, 'Itabuna', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.889845', 'I');
INSERT INTO historico.municipio VALUES (2003, 'Itacare', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.890749', 'I');
INSERT INTO historico.municipio VALUES (2004, 'Itaete', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.891611', 'I');
INSERT INTO historico.municipio VALUES (2005, 'Itagi', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.892478', 'I');
INSERT INTO historico.municipio VALUES (2006, 'Itagiba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.893317', 'I');
INSERT INTO historico.municipio VALUES (2007, 'Itagimirim', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.894412', 'I');
INSERT INTO historico.municipio VALUES (2008, 'Itaguacu da Bahia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.895374', 'I');
INSERT INTO historico.municipio VALUES (2009, 'Itaju do Colonia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.896523', 'I');
INSERT INTO historico.municipio VALUES (2010, 'Itajuipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.897461', 'I');
INSERT INTO historico.municipio VALUES (2011, 'Itamaraju', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.898265', 'I');
INSERT INTO historico.municipio VALUES (2012, 'Itamari', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.89943', 'I');
INSERT INTO historico.municipio VALUES (2013, 'Itambe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.900314', 'I');
INSERT INTO historico.municipio VALUES (2014, 'Itanagra', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.901209', 'I');
INSERT INTO historico.municipio VALUES (2015, 'Itanhem', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.902022', 'I');
INSERT INTO historico.municipio VALUES (2016, 'Itaparica', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.906287', 'I');
INSERT INTO historico.municipio VALUES (2017, 'Itape', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.909995', 'I');
INSERT INTO historico.municipio VALUES (2018, 'Itapebi', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.911146', 'I');
INSERT INTO historico.municipio VALUES (2019, 'Itapetinga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.911973', 'I');
INSERT INTO historico.municipio VALUES (2020, 'Itapicuru', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.913016', 'I');
INSERT INTO historico.municipio VALUES (2021, 'Itapitanga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.913895', 'I');
INSERT INTO historico.municipio VALUES (2022, 'Itaquara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.914769', 'I');
INSERT INTO historico.municipio VALUES (2023, 'Itarantim', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.915654', 'I');
INSERT INTO historico.municipio VALUES (2024, 'Itatim', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.916552', 'I');
INSERT INTO historico.municipio VALUES (2025, 'Itirucu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.917472', 'I');
INSERT INTO historico.municipio VALUES (2026, 'Itiuba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.918303', 'I');
INSERT INTO historico.municipio VALUES (2027, 'Itororo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.919192', 'I');
INSERT INTO historico.municipio VALUES (2028, 'Ituacu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.920019', 'I');
INSERT INTO historico.municipio VALUES (2029, 'Itubera', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.920842', 'I');
INSERT INTO historico.municipio VALUES (2030, 'Iuiu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.921738', 'I');
INSERT INTO historico.municipio VALUES (2031, 'Jaborandi', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.922718', 'I');
INSERT INTO historico.municipio VALUES (2032, 'Jacaraci', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.923539', 'I');
INSERT INTO historico.municipio VALUES (2033, 'Jacobina', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.92442', 'I');
INSERT INTO historico.municipio VALUES (2034, 'Jaguaquara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.925284', 'I');
INSERT INTO historico.municipio VALUES (2035, 'Jaguarari', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.926186', 'I');
INSERT INTO historico.municipio VALUES (2036, 'Jaguaripe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.927091', 'I');
INSERT INTO historico.municipio VALUES (2037, 'Jandaira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.928038', 'I');
INSERT INTO historico.municipio VALUES (2038, 'Jequie', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.928884', 'I');
INSERT INTO historico.municipio VALUES (2039, 'Jeremoabo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.929851', 'I');
INSERT INTO historico.municipio VALUES (2040, 'Jiquirica', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.930853', 'I');
INSERT INTO historico.municipio VALUES (2041, 'Jitauna', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.93178', 'I');
INSERT INTO historico.municipio VALUES (2042, 'Joao Dourado', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.932709', 'I');
INSERT INTO historico.municipio VALUES (2043, 'Juazeiro', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.933661', 'I');
INSERT INTO historico.municipio VALUES (2044, 'Jucurucu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.934595', 'I');
INSERT INTO historico.municipio VALUES (2045, 'Jussara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.935594', 'I');
INSERT INTO historico.municipio VALUES (2046, 'Jussari', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.93641', 'I');
INSERT INTO historico.municipio VALUES (2047, 'Jussiape', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.937255', 'I');
INSERT INTO historico.municipio VALUES (2048, 'Lafaiete Coutinho', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.938148', 'I');
INSERT INTO historico.municipio VALUES (2049, 'Lagoa Real', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.938963', 'I');
INSERT INTO historico.municipio VALUES (2050, 'Laje', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.939756', 'I');
INSERT INTO historico.municipio VALUES (2051, 'Lajedao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.940684', 'I');
INSERT INTO historico.municipio VALUES (2052, 'Lajedinho', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.941599', 'I');
INSERT INTO historico.municipio VALUES (2053, 'Lajedo do Tabocal', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.942474', 'I');
INSERT INTO historico.municipio VALUES (2054, 'Lamarao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.943451', 'I');
INSERT INTO historico.municipio VALUES (2055, 'Lapao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.947684', 'I');
INSERT INTO historico.municipio VALUES (2056, 'Lauro de Freitas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.951579', 'I');
INSERT INTO historico.municipio VALUES (2057, 'Lencois', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.952621', 'I');
INSERT INTO historico.municipio VALUES (2058, 'Licinio de Almeida', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.953576', 'I');
INSERT INTO historico.municipio VALUES (2059, 'Livramento de Nossa Senhora', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.954557', 'I');
INSERT INTO historico.municipio VALUES (2060, 'Luis Eduardo Magalhaes', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.955329', 'I');
INSERT INTO historico.municipio VALUES (2061, 'Macajuba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.956202', 'I');
INSERT INTO historico.municipio VALUES (2062, 'Macarani', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.957096', 'I');
INSERT INTO historico.municipio VALUES (2063, 'Macaubas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.957889', 'I');
INSERT INTO historico.municipio VALUES (2064, 'Macurure', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.958774', 'I');
INSERT INTO historico.municipio VALUES (2065, 'Madre de Deus', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.959587', 'I');
INSERT INTO historico.municipio VALUES (2066, 'Maetinga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.960638', 'I');
INSERT INTO historico.municipio VALUES (2067, 'Maiquinique', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.962121', 'I');
INSERT INTO historico.municipio VALUES (2068, 'Mairi', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.963012', 'I');
INSERT INTO historico.municipio VALUES (2069, 'Malhada', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.963901', 'I');
INSERT INTO historico.municipio VALUES (2070, 'Malhada de Pedras', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.964883', 'I');
INSERT INTO historico.municipio VALUES (2071, 'Manoel Vitorino', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.966277', 'I');
INSERT INTO historico.municipio VALUES (2072, 'Mansidao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.967204', 'I');
INSERT INTO historico.municipio VALUES (2073, 'Maracas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.968095', 'I');
INSERT INTO historico.municipio VALUES (2074, 'Maragogipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.968973', 'I');
INSERT INTO historico.municipio VALUES (2075, 'Marau', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.969912', 'I');
INSERT INTO historico.municipio VALUES (2076, 'Marcionilio Souza', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.970761', 'I');
INSERT INTO historico.municipio VALUES (2077, 'Mascote', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.971642', 'I');
INSERT INTO historico.municipio VALUES (2078, 'Mata de Sao Joao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.972526', 'I');
INSERT INTO historico.municipio VALUES (2079, 'Matina', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.973388', 'I');
INSERT INTO historico.municipio VALUES (2080, 'Medeiros Neto', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.974232', 'I');
INSERT INTO historico.municipio VALUES (2081, 'Miguel Calmon', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.975182', 'I');
INSERT INTO historico.municipio VALUES (2082, 'Milagres', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.976164', 'I');
INSERT INTO historico.municipio VALUES (2083, 'Mirangaba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.977016', 'I');
INSERT INTO historico.municipio VALUES (2084, 'Mirante', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.977772', 'I');
INSERT INTO historico.municipio VALUES (2085, 'Monte Santo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.978653', 'I');
INSERT INTO historico.municipio VALUES (2086, 'Morpara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.979569', 'I');
INSERT INTO historico.municipio VALUES (2087, 'Morro do Chapeu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.980474', 'I');
INSERT INTO historico.municipio VALUES (2088, 'Mortugaba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.981328', 'I');
INSERT INTO historico.municipio VALUES (2089, 'Mucuge', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.982184', 'I');
INSERT INTO historico.municipio VALUES (2090, 'Mucuri', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.982993', 'I');
INSERT INTO historico.municipio VALUES (2091, 'Mulungu do Morro', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.983851', 'I');
INSERT INTO historico.municipio VALUES (2092, 'Mundo Novo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.984848', 'I');
INSERT INTO historico.municipio VALUES (2093, 'Muniz Ferreira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.996997', 'I');
INSERT INTO historico.municipio VALUES (2094, 'Muquem de Sao Francisco', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.998112', 'I');
INSERT INTO historico.municipio VALUES (2095, 'Muritiba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.999036', 'I');
INSERT INTO historico.municipio VALUES (2096, 'Mutuipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.999876', 'I');
INSERT INTO historico.municipio VALUES (2097, 'Nazare', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.000716', 'I');
INSERT INTO historico.municipio VALUES (2098, 'Nilo Pecanha', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.001605', 'I');
INSERT INTO historico.municipio VALUES (2099, 'Nordestina', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.002445', 'I');
INSERT INTO historico.municipio VALUES (2100, 'Nova Canaa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.003325', 'I');
INSERT INTO historico.municipio VALUES (2101, 'Nova Fatima', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.004235', 'I');
INSERT INTO historico.municipio VALUES (2102, 'Nova Ibia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.005107', 'I');
INSERT INTO historico.municipio VALUES (2103, 'Nova Itarana', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.006013', 'I');
INSERT INTO historico.municipio VALUES (2104, 'Nova Redencao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.006882', 'I');
INSERT INTO historico.municipio VALUES (2105, 'Nova Soure', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.007768', 'I');
INSERT INTO historico.municipio VALUES (2106, 'Nova Vicosa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.008715', 'I');
INSERT INTO historico.municipio VALUES (2107, 'Novo Horizonte', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.009609', 'I');
INSERT INTO historico.municipio VALUES (2108, 'Novo Triunfo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.01077', 'I');
INSERT INTO historico.municipio VALUES (2109, 'Olindina', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.011563', 'I');
INSERT INTO historico.municipio VALUES (2110, 'Oliveira dos Brejinhos', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.012481', 'I');
INSERT INTO historico.municipio VALUES (2111, 'Ouricangas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.013345', 'I');
INSERT INTO historico.municipio VALUES (2112, 'Ourolandia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.014162', 'I');
INSERT INTO historico.municipio VALUES (2113, 'Palmas de Monte Alto', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.015029', 'I');
INSERT INTO historico.municipio VALUES (2114, 'Palmeiras', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.015951', 'I');
INSERT INTO historico.municipio VALUES (2115, 'Paramirim', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.016875', 'I');
INSERT INTO historico.municipio VALUES (2116, 'Paratinga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.017719', 'I');
INSERT INTO historico.municipio VALUES (2117, 'Paripiranga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.018511', 'I');
INSERT INTO historico.municipio VALUES (2118, 'Pau Brasil', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.019288', 'I');
INSERT INTO historico.municipio VALUES (2119, 'Paulo Afonso', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.020202', 'I');
INSERT INTO historico.municipio VALUES (2120, 'Pe de Serra', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.021133', 'I');
INSERT INTO historico.municipio VALUES (2121, 'Pedrao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.022051', 'I');
INSERT INTO historico.municipio VALUES (2122, 'Pedro Alexandre', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.022977', 'I');
INSERT INTO historico.municipio VALUES (2123, 'Piata', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.023897', 'I');
INSERT INTO historico.municipio VALUES (2124, 'Pilao Arcado', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.024776', 'I');
INSERT INTO historico.municipio VALUES (2125, 'Pindai', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.025676', 'I');
INSERT INTO historico.municipio VALUES (2126, 'Pindobacu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.026444', 'I');
INSERT INTO historico.municipio VALUES (2127, 'Pintadas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.027298', 'I');
INSERT INTO historico.municipio VALUES (2128, 'Pirai do Norte', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.028163', 'I');
INSERT INTO historico.municipio VALUES (2129, 'Piripa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.028991', 'I');
INSERT INTO historico.municipio VALUES (2130, 'Piritiba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.02981', 'I');
INSERT INTO historico.municipio VALUES (2131, 'Planaltino', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.030618', 'I');
INSERT INTO historico.municipio VALUES (2132, 'Planalto', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.037238', 'I');
INSERT INTO historico.municipio VALUES (2133, 'Pocoes', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.038394', 'I');
INSERT INTO historico.municipio VALUES (2134, 'Pojuca', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.039305', 'I');
INSERT INTO historico.municipio VALUES (2135, 'Ponto Novo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.040288', 'I');
INSERT INTO historico.municipio VALUES (2136, 'Porto Seguro', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.041156', 'I');
INSERT INTO historico.municipio VALUES (2137, 'Potiragua', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.042018', 'I');
INSERT INTO historico.municipio VALUES (2138, 'Prado', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.042931', 'I');
INSERT INTO historico.municipio VALUES (2139, 'Presidente Dutra', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.04386', 'I');
INSERT INTO historico.municipio VALUES (2140, 'Presidente Janio Quadros', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.044678', 'I');
INSERT INTO historico.municipio VALUES (2141, 'Presidente Tancredo Neves', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.045568', 'I');
INSERT INTO historico.municipio VALUES (2142, 'Queimadas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.046592', 'I');
INSERT INTO historico.municipio VALUES (2143, 'Quijingue', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.047491', 'I');
INSERT INTO historico.municipio VALUES (2144, 'Quixabeira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.04839', 'I');
INSERT INTO historico.municipio VALUES (2145, 'Rafael Jambeiro', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.049242', 'I');
INSERT INTO historico.municipio VALUES (2146, 'Remanso', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.050108', 'I');
INSERT INTO historico.municipio VALUES (2147, 'Retirolandia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.051116', 'I');
INSERT INTO historico.municipio VALUES (2148, 'Riachao das Neves', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.051964', 'I');
INSERT INTO historico.municipio VALUES (2149, 'Riachao do Jacuipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.052816', 'I');
INSERT INTO historico.municipio VALUES (2150, 'Riacho de Santana', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.053696', 'I');
INSERT INTO historico.municipio VALUES (2151, 'Ribeira do Amparo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.054615', 'I');
INSERT INTO historico.municipio VALUES (2152, 'Ribeira do Pombal', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.055463', 'I');
INSERT INTO historico.municipio VALUES (2153, 'Ribeirao do Largo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.05629', 'I');
INSERT INTO historico.municipio VALUES (2154, 'Rio de Contas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.057205', 'I');
INSERT INTO historico.municipio VALUES (2155, 'Rio do Antonio', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.058091', 'I');
INSERT INTO historico.municipio VALUES (2156, 'Rio do Pires', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.059061', 'I');
INSERT INTO historico.municipio VALUES (2157, 'Rio Real', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.0599', 'I');
INSERT INTO historico.municipio VALUES (2158, 'Rodelas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.060828', 'I');
INSERT INTO historico.municipio VALUES (2159, 'Ruy Barbosa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.061686', 'I');
INSERT INTO historico.municipio VALUES (2160, 'Salinas da Margarida', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.062613', 'I');
INSERT INTO historico.municipio VALUES (2161, 'Salvador', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.063432', 'I');
INSERT INTO historico.municipio VALUES (2162, 'Santa Barbara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.064199', 'I');
INSERT INTO historico.municipio VALUES (2163, 'Santa Brigida', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.065113', 'I');
INSERT INTO historico.municipio VALUES (2164, 'Santa Cruz Cabralia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.066096', 'I');
INSERT INTO historico.municipio VALUES (2165, 'Santa Cruz da Vitoria', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.066868', 'I');
INSERT INTO historico.municipio VALUES (2166, 'Santa Ines', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.067781', 'I');
INSERT INTO historico.municipio VALUES (2171, 'Santaluz', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.081182', 'I');
INSERT INTO historico.municipio VALUES (2167, 'Santa Luzia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.068555', 'I');
INSERT INTO historico.municipio VALUES (2168, 'Santa Maria da Vitoria', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.069542', 'I');
INSERT INTO historico.municipio VALUES (2172, 'Santana', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.082258', 'I');
INSERT INTO historico.municipio VALUES (2173, 'Santanopolis', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.083118', 'I');
INSERT INTO historico.municipio VALUES (2169, 'Santa Rita de Cassia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.070478', 'I');
INSERT INTO historico.municipio VALUES (2170, 'Santa Teresinha', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.071319', 'I');
INSERT INTO historico.municipio VALUES (2174, 'Santo Amaro', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.083992', 'I');
INSERT INTO historico.municipio VALUES (2175, 'Santo Antonio de Jesus', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.084795', 'I');
INSERT INTO historico.municipio VALUES (2176, 'Santo Estevao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.085639', 'I');
INSERT INTO historico.municipio VALUES (2177, 'Sao Desiderio', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.086513', 'I');
INSERT INTO historico.municipio VALUES (2178, 'Sao Domingos', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.087428', 'I');
INSERT INTO historico.municipio VALUES (2180, 'Sao Felix', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.089086', 'I');
INSERT INTO historico.municipio VALUES (2181, 'Sao Felix do Coribe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.089995', 'I');
INSERT INTO historico.municipio VALUES (2179, 'Sao Felipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.088306', 'I');
INSERT INTO historico.municipio VALUES (2182, 'Sao Francisco do Conde', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.09092', 'I');
INSERT INTO historico.municipio VALUES (2183, 'Sao Gabriel', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.091797', 'I');
INSERT INTO historico.municipio VALUES (2184, 'Sao Goncalo dos Campos', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.092756', 'I');
INSERT INTO historico.municipio VALUES (2185, 'Sao Jose da Vitoria', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.093833', 'I');
INSERT INTO historico.municipio VALUES (2186, 'Sao Jose do Jacuipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.094768', 'I');
INSERT INTO historico.municipio VALUES (2187, 'Sao Miguel das Matas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.095662', 'I');
INSERT INTO historico.municipio VALUES (2188, 'Sao Sebastiao do Passe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.096542', 'I');
INSERT INTO historico.municipio VALUES (2189, 'Sapeacu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.09736', 'I');
INSERT INTO historico.municipio VALUES (2190, 'Satiro Dias', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.09819', 'I');
INSERT INTO historico.municipio VALUES (2191, 'Saubara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.099108', 'I');
INSERT INTO historico.municipio VALUES (2192, 'Saude', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.100012', 'I');
INSERT INTO historico.municipio VALUES (2193, 'Seabra', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.100826', 'I');
INSERT INTO historico.municipio VALUES (2194, 'Sebastiao Laranjeiras', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.101718', 'I');
INSERT INTO historico.municipio VALUES (2195, 'Senhor do Bonfim', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.102614', 'I');
INSERT INTO historico.municipio VALUES (2197, 'Serra do Ramalho', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.10448', 'I');
INSERT INTO historico.municipio VALUES (2196, 'Sento Se', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.103547', 'I');
INSERT INTO historico.municipio VALUES (2198, 'Serra Dourada', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.105375', 'I');
INSERT INTO historico.municipio VALUES (2199, 'Serra Preta', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.106273', 'I');
INSERT INTO historico.municipio VALUES (2200, 'Serrinha', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.107175', 'I');
INSERT INTO historico.municipio VALUES (2201, 'Serrolandia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.108078', 'I');
INSERT INTO historico.municipio VALUES (2202, 'Simoes Filho', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.108929', 'I');
INSERT INTO historico.municipio VALUES (2203, 'Sitio do Mato', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.109993', 'I');
INSERT INTO historico.municipio VALUES (2204, 'Sitio do Quinto', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.11146', 'I');
INSERT INTO historico.municipio VALUES (2205, 'Sobradinho', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.112381', 'I');
INSERT INTO historico.municipio VALUES (2206, 'Souto Soares', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.113153', 'I');
INSERT INTO historico.municipio VALUES (2207, 'Tabocas do Brejo Velho', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.113976', 'I');
INSERT INTO historico.municipio VALUES (2208, 'Tanhacu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.114785', 'I');
INSERT INTO historico.municipio VALUES (2209, 'Tanque Novo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.121459', 'I');
INSERT INTO historico.municipio VALUES (2210, 'Tanquinho', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.122594', 'I');
INSERT INTO historico.municipio VALUES (2211, 'Taperoa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.123519', 'I');
INSERT INTO historico.municipio VALUES (2212, 'Tapiramuta', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.124406', 'I');
INSERT INTO historico.municipio VALUES (2213, 'Teixeira de Freitas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.125229', 'I');
INSERT INTO historico.municipio VALUES (2214, 'Teodoro Sampaio', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.126164', 'I');
INSERT INTO historico.municipio VALUES (2215, 'Teofilandia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.127128', 'I');
INSERT INTO historico.municipio VALUES (2216, 'Teolandia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.128089', 'I');
INSERT INTO historico.municipio VALUES (2217, 'Terra Nova', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.129228', 'I');
INSERT INTO historico.municipio VALUES (2218, 'Tremedal', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.130582', 'I');
INSERT INTO historico.municipio VALUES (2219, 'Tucano', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.132366', 'I');
INSERT INTO historico.municipio VALUES (2220, 'Uaua', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.133639', 'I');
INSERT INTO historico.municipio VALUES (2221, 'Ubaira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.134487', 'I');
INSERT INTO historico.municipio VALUES (2222, 'Ubaitaba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.135357', 'I');
INSERT INTO historico.municipio VALUES (2223, 'Ubata', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.136179', 'I');
INSERT INTO historico.municipio VALUES (2224, 'Uibai', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.136978', 'I');
INSERT INTO historico.municipio VALUES (2225, 'Umburanas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.137875', 'I');
INSERT INTO historico.municipio VALUES (2226, 'Una', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.138736', 'I');
INSERT INTO historico.municipio VALUES (2227, 'Urandi', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.139603', 'I');
INSERT INTO historico.municipio VALUES (2228, 'Urucuca', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.14047', 'I');
INSERT INTO historico.municipio VALUES (2229, 'Utinga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.14136', 'I');
INSERT INTO historico.municipio VALUES (2230, 'Valenca', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.142211', 'I');
INSERT INTO historico.municipio VALUES (2231, 'Valente', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.143101', 'I');
INSERT INTO historico.municipio VALUES (2232, 'Varzea da Roca', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.144044', 'I');
INSERT INTO historico.municipio VALUES (2233, 'Varzea do Poco', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.145026', 'I');
INSERT INTO historico.municipio VALUES (2234, 'Varzea Nova', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.145932', 'I');
INSERT INTO historico.municipio VALUES (2235, 'Varzedo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.146908', 'I');
INSERT INTO historico.municipio VALUES (2236, 'Vera Cruz', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.147866', 'I');
INSERT INTO historico.municipio VALUES (2237, 'Vereda', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.148738', 'I');
INSERT INTO historico.municipio VALUES (2238, 'Vitoria da Conquista', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.149664', 'I');
INSERT INTO historico.municipio VALUES (2239, 'Wagner', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.150535', 'I');
INSERT INTO historico.municipio VALUES (2240, 'Wanderley', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.151529', 'I');
INSERT INTO historico.municipio VALUES (2241, 'Wenceslau Guimaraes', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.152442', 'I');
INSERT INTO historico.municipio VALUES (2242, 'Xique-xique', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.153258', 'I');
INSERT INTO historico.municipio VALUES (2243, 'Abadia dos Dourados', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.154189', 'I');
INSERT INTO historico.municipio VALUES (2244, 'Abaete', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.155248', 'I');
INSERT INTO historico.municipio VALUES (2245, 'Abre Campo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.158797', 'I');
INSERT INTO historico.municipio VALUES (2246, 'Acaiaca', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.164872', 'I');
INSERT INTO historico.municipio VALUES (2247, 'Acucena', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.166041', 'I');
INSERT INTO historico.municipio VALUES (2248, 'Agua Boa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.166914', 'I');
INSERT INTO historico.municipio VALUES (2249, 'Agua Comprida', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.167694', 'I');
INSERT INTO historico.municipio VALUES (2250, 'Aguanil', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.168652', 'I');
INSERT INTO historico.municipio VALUES (2251, 'Aguas Formosas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.169451', 'I');
INSERT INTO historico.municipio VALUES (2252, 'Aguas Vermelhas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.170365', 'I');
INSERT INTO historico.municipio VALUES (2253, 'Aimores', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.171249', 'I');
INSERT INTO historico.municipio VALUES (2254, 'Aiuruoca', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.172198', 'I');
INSERT INTO historico.municipio VALUES (2255, 'Alagoa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.17309', 'I');
INSERT INTO historico.municipio VALUES (2256, 'Albertina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.174065', 'I');
INSERT INTO historico.municipio VALUES (2257, 'Alem Paraiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.175052', 'I');
INSERT INTO historico.municipio VALUES (2258, 'Alfenas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.176142', 'I');
INSERT INTO historico.municipio VALUES (2259, 'Alfredo Vasconcelos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.177086', 'I');
INSERT INTO historico.municipio VALUES (2260, 'Almenara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.17799', 'I');
INSERT INTO historico.municipio VALUES (2261, 'Alpercata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.178942', 'I');
INSERT INTO historico.municipio VALUES (2262, 'Alpinopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.179848', 'I');
INSERT INTO historico.municipio VALUES (2263, 'Alterosa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.180759', 'I');
INSERT INTO historico.municipio VALUES (2264, 'Alto Caparao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.181657', 'I');
INSERT INTO historico.municipio VALUES (2266, 'Alto Rio Doce', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.183515', 'I');
INSERT INTO historico.municipio VALUES (2267, 'Alvarenga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.184402', 'I');
INSERT INTO historico.municipio VALUES (2268, 'Alvinopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.185229', 'I');
INSERT INTO historico.municipio VALUES (2269, 'Alvorada de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.186152', 'I');
INSERT INTO historico.municipio VALUES (2270, 'Amparo do Serra', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.187321', 'I');
INSERT INTO historico.municipio VALUES (2271, 'Andradas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.188228', 'I');
INSERT INTO historico.municipio VALUES (2349, 'Cachoeira de Pajeu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.269483', 'I');
INSERT INTO historico.municipio VALUES (2272, 'Andrelandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.189253', 'I');
INSERT INTO historico.municipio VALUES (2273, 'Angelandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.190148', 'I');
INSERT INTO historico.municipio VALUES (2274, 'Antonio Carlos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.19103', 'I');
INSERT INTO historico.municipio VALUES (2275, 'Antonio Dias', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.191859', 'I');
INSERT INTO historico.municipio VALUES (2276, 'Antonio Prado de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.192799', 'I');
INSERT INTO historico.municipio VALUES (2277, 'Aracai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.193762', 'I');
INSERT INTO historico.municipio VALUES (2278, 'Aracitaba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.194635', 'I');
INSERT INTO historico.municipio VALUES (2279, 'Aracuai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.195558', 'I');
INSERT INTO historico.municipio VALUES (2280, 'Araguari', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.196367', 'I');
INSERT INTO historico.municipio VALUES (2281, 'Arantina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.197243', 'I');
INSERT INTO historico.municipio VALUES (2282, 'Araponga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.198178', 'I');
INSERT INTO historico.municipio VALUES (2283, 'Arapora', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.203217', 'I');
INSERT INTO historico.municipio VALUES (2284, 'Arapua', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.205244', 'I');
INSERT INTO historico.municipio VALUES (2285, 'Araujos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.206219', 'I');
INSERT INTO historico.municipio VALUES (2286, 'Araxa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.207117', 'I');
INSERT INTO historico.municipio VALUES (2287, 'Arceburgo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.207902', 'I');
INSERT INTO historico.municipio VALUES (2288, 'Arcos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.208814', 'I');
INSERT INTO historico.municipio VALUES (2289, 'Areado', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.209723', 'I');
INSERT INTO historico.municipio VALUES (2290, 'Argirita', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.210605', 'I');
INSERT INTO historico.municipio VALUES (2291, 'Aricanduva', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.211483', 'I');
INSERT INTO historico.municipio VALUES (2292, 'Arinos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.212377', 'I');
INSERT INTO historico.municipio VALUES (2293, 'Astolfo Dutra', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.213327', 'I');
INSERT INTO historico.municipio VALUES (2294, 'Ataleia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.214154', 'I');
INSERT INTO historico.municipio VALUES (2295, 'Augusto de Lima', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.21493', 'I');
INSERT INTO historico.municipio VALUES (2296, 'Baependi', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.215936', 'I');
INSERT INTO historico.municipio VALUES (2297, 'Baldim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.216871', 'I');
INSERT INTO historico.municipio VALUES (2298, 'Bambui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.217768', 'I');
INSERT INTO historico.municipio VALUES (2299, 'Bandeira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.218649', 'I');
INSERT INTO historico.municipio VALUES (2300, 'Bandeira do Sul', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.219508', 'I');
INSERT INTO historico.municipio VALUES (2301, 'Barao de Cocais', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.220377', 'I');
INSERT INTO historico.municipio VALUES (2302, 'Barao de Monte Alto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.221268', 'I');
INSERT INTO historico.municipio VALUES (2303, 'Barbacena', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.222198', 'I');
INSERT INTO historico.municipio VALUES (2304, 'Barra Longa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.223036', 'I');
INSERT INTO historico.municipio VALUES (2305, 'Barroso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.22391', 'I');
INSERT INTO historico.municipio VALUES (2306, 'Bela Vista de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.224974', 'I');
INSERT INTO historico.municipio VALUES (2307, 'Belmiro Braga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.225963', 'I');
INSERT INTO historico.municipio VALUES (2308, 'Belo Horizonte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.227024', 'I');
INSERT INTO historico.municipio VALUES (2309, 'Belo Oriente', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.227973', 'I');
INSERT INTO historico.municipio VALUES (2310, 'Belo Vale', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.228893', 'I');
INSERT INTO historico.municipio VALUES (2311, 'Berilo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.229677', 'I');
INSERT INTO historico.municipio VALUES (2313, 'Bertopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.23149', 'I');
INSERT INTO historico.municipio VALUES (2312, 'Berizal', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.230571', 'I');
INSERT INTO historico.municipio VALUES (2314, 'Betim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.232321', 'I');
INSERT INTO historico.municipio VALUES (2315, 'Bias Fortes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.233321', 'I');
INSERT INTO historico.municipio VALUES (2316, 'Bicas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.23414', 'I');
INSERT INTO historico.municipio VALUES (2317, 'Biquinhas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.234928', 'I');
INSERT INTO historico.municipio VALUES (2318, 'Boa Esperanca', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.235855', 'I');
INSERT INTO historico.municipio VALUES (2319, 'Bocaina de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.236779', 'I');
INSERT INTO historico.municipio VALUES (2320, 'Bocaiuva', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.23773', 'I');
INSERT INTO historico.municipio VALUES (2321, 'Bom Despacho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.23865', 'I');
INSERT INTO historico.municipio VALUES (2322, 'Bom Jardim de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.239378', 'I');
INSERT INTO historico.municipio VALUES (2323, 'Bom Jesus da Penha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.245946', 'I');
INSERT INTO historico.municipio VALUES (2324, 'Bom Jesus do Amparo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.246959', 'I');
INSERT INTO historico.municipio VALUES (2325, 'Bom Jesus do Galho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.247908', 'I');
INSERT INTO historico.municipio VALUES (2326, 'Bom Repouso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.248786', 'I');
INSERT INTO historico.municipio VALUES (2327, 'Bom Sucesso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.249675', 'I');
INSERT INTO historico.municipio VALUES (2328, 'Bonfim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.250542', 'I');
INSERT INTO historico.municipio VALUES (2329, 'Bonfinopolis de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.251343', 'I');
INSERT INTO historico.municipio VALUES (2330, 'Bonito de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.252162', 'I');
INSERT INTO historico.municipio VALUES (2331, 'Borda da Mata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.253039', 'I');
INSERT INTO historico.municipio VALUES (2332, 'Botelhos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.253931', 'I');
INSERT INTO historico.municipio VALUES (2333, 'Botumirim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.254856', 'I');
INSERT INTO historico.municipio VALUES (2335, 'Brasilandia de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.256563', 'I');
INSERT INTO historico.municipio VALUES (2336, 'Brasilia de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.257427', 'I');
INSERT INTO historico.municipio VALUES (2334, 'Bras Pires', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.255745', 'I');
INSERT INTO historico.municipio VALUES (2338, 'Braunas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.259273', 'I');
INSERT INTO historico.municipio VALUES (2339, 'Brumadinho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.260042', 'I');
INSERT INTO historico.municipio VALUES (2340, 'Bueno Brandao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.260966', 'I');
INSERT INTO historico.municipio VALUES (2341, 'Buenopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.261895', 'I');
INSERT INTO historico.municipio VALUES (2342, 'Bugre', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.262933', 'I');
INSERT INTO historico.municipio VALUES (2343, 'Buritis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.263793', 'I');
INSERT INTO historico.municipio VALUES (2344, 'Buritizeiro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.264812', 'I');
INSERT INTO historico.municipio VALUES (2345, 'Cabeceira Grande', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.265722', 'I');
INSERT INTO historico.municipio VALUES (2346, 'Cabo Verde', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.266748', 'I');
INSERT INTO historico.municipio VALUES (2347, 'Cachoeira da Prata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.267638', 'I');
INSERT INTO historico.municipio VALUES (2348, 'Cachoeira de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.268607', 'I');
INSERT INTO historico.municipio VALUES (2350, 'Cachoeira Dourada', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.270382', 'I');
INSERT INTO historico.municipio VALUES (2351, 'Caetanopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.271481', 'I');
INSERT INTO historico.municipio VALUES (2352, 'Caete', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.272398', 'I');
INSERT INTO historico.municipio VALUES (2353, 'Caiana', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.273259', 'I');
INSERT INTO historico.municipio VALUES (2354, 'Cajuri', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.274121', 'I');
INSERT INTO historico.municipio VALUES (2355, 'Caldas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.275028', 'I');
INSERT INTO historico.municipio VALUES (2356, 'Camacho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.275929', 'I');
INSERT INTO historico.municipio VALUES (2357, 'Camanducaia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.27681', 'I');
INSERT INTO historico.municipio VALUES (2358, 'Cambui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.277738', 'I');
INSERT INTO historico.municipio VALUES (2359, 'Cambuquira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.278606', 'I');
INSERT INTO historico.municipio VALUES (2360, 'Campanario', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.279653', 'I');
INSERT INTO historico.municipio VALUES (2361, 'Campanha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.28044', 'I');
INSERT INTO historico.municipio VALUES (2362, 'Campestre', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.286607', 'I');
INSERT INTO historico.municipio VALUES (2363, 'Campina Verde', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.287827', 'I');
INSERT INTO historico.municipio VALUES (2364, 'Campo Azul', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.288775', 'I');
INSERT INTO historico.municipio VALUES (2365, 'Campo Belo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.289665', 'I');
INSERT INTO historico.municipio VALUES (2366, 'Campo do Meio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.290592', 'I');
INSERT INTO historico.municipio VALUES (2367, 'Campo Florido', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.291403', 'I');
INSERT INTO historico.municipio VALUES (2368, 'Campos Altos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.292443', 'I');
INSERT INTO historico.municipio VALUES (2369, 'Campos Gerais', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.293274', 'I');
INSERT INTO historico.municipio VALUES (2371, 'Canaa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.295135', 'I');
INSERT INTO historico.municipio VALUES (2372, 'Canapolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.296192', 'I');
INSERT INTO historico.municipio VALUES (2370, 'Cana Verde', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.294208', 'I');
INSERT INTO historico.municipio VALUES (2373, 'Candeias', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.297115', 'I');
INSERT INTO historico.municipio VALUES (2374, 'Cantagalo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.297958', 'I');
INSERT INTO historico.municipio VALUES (2375, 'Caparao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.298869', 'I');
INSERT INTO historico.municipio VALUES (2376, 'Capela Nova', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.299725', 'I');
INSERT INTO historico.municipio VALUES (2377, 'Capelinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.300742', 'I');
INSERT INTO historico.municipio VALUES (2378, 'Capetinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.301628', 'I');
INSERT INTO historico.municipio VALUES (2379, 'Capim Branco', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.302484', 'I');
INSERT INTO historico.municipio VALUES (2380, 'Capinopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.303332', 'I');
INSERT INTO historico.municipio VALUES (2381, 'Capitao Andrade', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.304204', 'I');
INSERT INTO historico.municipio VALUES (2382, 'Capitao Eneas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.304996', 'I');
INSERT INTO historico.municipio VALUES (2383, 'Capitolio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.305772', 'I');
INSERT INTO historico.municipio VALUES (2384, 'Caputira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.306769', 'I');
INSERT INTO historico.municipio VALUES (2385, 'Carai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.307704', 'I');
INSERT INTO historico.municipio VALUES (2386, 'Caranaiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.308589', 'I');
INSERT INTO historico.municipio VALUES (2387, 'Carandai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.309503', 'I');
INSERT INTO historico.municipio VALUES (2388, 'Carangola', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.310414', 'I');
INSERT INTO historico.municipio VALUES (2389, 'Caratinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.311411', 'I');
INSERT INTO historico.municipio VALUES (2390, 'Carbonita', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.312275', 'I');
INSERT INTO historico.municipio VALUES (2391, 'Careacu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.313165', 'I');
INSERT INTO historico.municipio VALUES (2392, 'Carlos Chagas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.313963', 'I');
INSERT INTO historico.municipio VALUES (2393, 'Carmesia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.31478', 'I');
INSERT INTO historico.municipio VALUES (2394, 'Carmo da Cachoeira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.31565', 'I');
INSERT INTO historico.municipio VALUES (2395, 'Carmo da Mata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.316547', 'I');
INSERT INTO historico.municipio VALUES (2396, 'Carmo de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.317444', 'I');
INSERT INTO historico.municipio VALUES (2397, 'Carmo do Cajuru', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.318302', 'I');
INSERT INTO historico.municipio VALUES (2398, 'Carmo do Paranaiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.319164', 'I');
INSERT INTO historico.municipio VALUES (2399, 'Carmo do Rio Claro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.320006', 'I');
INSERT INTO historico.municipio VALUES (2400, 'Carmopolis de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.326946', 'I');
INSERT INTO historico.municipio VALUES (2401, 'Carneirinho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.328069', 'I');
INSERT INTO historico.municipio VALUES (2402, 'Carrancas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.328901', 'I');
INSERT INTO historico.municipio VALUES (2403, 'Carvalhopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.329932', 'I');
INSERT INTO historico.municipio VALUES (2404, 'Carvalhos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.33101', 'I');
INSERT INTO historico.municipio VALUES (2405, 'Casa Grande', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.331982', 'I');
INSERT INTO historico.municipio VALUES (2406, 'Cascalho Rico', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.333627', 'I');
INSERT INTO historico.municipio VALUES (2407, 'Cassia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.334661', 'I');
INSERT INTO historico.municipio VALUES (2431, 'Conceicao da Barra de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.356084', 'I');
INSERT INTO historico.municipio VALUES (2408, 'Cataguases', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.335576', 'I');
INSERT INTO historico.municipio VALUES (2409, 'Catas Altas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.336441', 'I');
INSERT INTO historico.municipio VALUES (2410, 'Catas Altas da Noruega', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.337408', 'I');
INSERT INTO historico.municipio VALUES (2411, 'Catuji', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.338303', 'I');
INSERT INTO historico.municipio VALUES (2412, 'Catuti', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.339177', 'I');
INSERT INTO historico.municipio VALUES (2413, 'Caxambu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.340022', 'I');
INSERT INTO historico.municipio VALUES (2414, 'Cedro do Abaete', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.3409', 'I');
INSERT INTO historico.municipio VALUES (2415, 'Central de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.341802', 'I');
INSERT INTO historico.municipio VALUES (2416, 'Centralina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.342707', 'I');
INSERT INTO historico.municipio VALUES (2417, 'Chacara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.343615', 'I');
INSERT INTO historico.municipio VALUES (2418, 'Chale', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.344519', 'I');
INSERT INTO historico.municipio VALUES (2419, 'Chapada do Norte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.345402', 'I');
INSERT INTO historico.municipio VALUES (2420, 'Chapada Gaucha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.346221', 'I');
INSERT INTO historico.municipio VALUES (2421, 'Chiador', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.347172', 'I');
INSERT INTO historico.municipio VALUES (2422, 'Cipotanea', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.348109', 'I');
INSERT INTO historico.municipio VALUES (2423, 'Claraval', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.349067', 'I');
INSERT INTO historico.municipio VALUES (2424, 'Claro dos Pocoes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.349954', 'I');
INSERT INTO historico.municipio VALUES (2425, 'Claudio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.350815', 'I');
INSERT INTO historico.municipio VALUES (2426, 'Coimbra', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.351681', 'I');
INSERT INTO historico.municipio VALUES (2427, 'Coluna', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.352366', 'I');
INSERT INTO historico.municipio VALUES (2428, 'Comendador Gomes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.353256', 'I');
INSERT INTO historico.municipio VALUES (2429, 'Comercinho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.354197', 'I');
INSERT INTO historico.municipio VALUES (2430, 'Conceicao da Aparecida', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.355049', 'I');
INSERT INTO historico.municipio VALUES (2433, 'Conceicao das Pedras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.357787', 'I');
INSERT INTO historico.municipio VALUES (2432, 'Conceicao das Alagoas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.356889', 'I');
INSERT INTO historico.municipio VALUES (2434, 'Conceicao de Ipanema', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.358793', 'I');
INSERT INTO historico.municipio VALUES (2435, 'Conceicao do Mato Dentro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.35965', 'I');
INSERT INTO historico.municipio VALUES (2436, 'Conceicao do Para', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.360602', 'I');
INSERT INTO historico.municipio VALUES (2437, 'Conceicao do Rio Verde', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.367362', 'I');
INSERT INTO historico.municipio VALUES (2438, 'Conceicao dos Ouros', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.368535', 'I');
INSERT INTO historico.municipio VALUES (2439, 'Conego Marinho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.369512', 'I');
INSERT INTO historico.municipio VALUES (2440, 'Confins', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.370463', 'I');
INSERT INTO historico.municipio VALUES (2441, 'Congonhal', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.371375', 'I');
INSERT INTO historico.municipio VALUES (2442, 'Congonhas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.372194', 'I');
INSERT INTO historico.municipio VALUES (2443, 'Congonhas do Norte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.37302', 'I');
INSERT INTO historico.municipio VALUES (2444, 'Conquista', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.373929', 'I');
INSERT INTO historico.municipio VALUES (2445, 'Conselheiro Lafaiete', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.374849', 'I');
INSERT INTO historico.municipio VALUES (2446, 'Conselheiro Pena', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.375761', 'I');
INSERT INTO historico.municipio VALUES (2447, 'Consolacao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.376643', 'I');
INSERT INTO historico.municipio VALUES (2448, 'Contagem', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.377562', 'I');
INSERT INTO historico.municipio VALUES (2449, 'Coqueiral', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.37849', 'I');
INSERT INTO historico.municipio VALUES (2450, 'Coracao de Jesus', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.379263', 'I');
INSERT INTO historico.municipio VALUES (2451, 'Cordisburgo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.380177', 'I');
INSERT INTO historico.municipio VALUES (2452, 'Cordislandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.381011', 'I');
INSERT INTO historico.municipio VALUES (2453, 'Corinto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.381868', 'I');
INSERT INTO historico.municipio VALUES (2454, 'Coroaci', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.38272', 'I');
INSERT INTO historico.municipio VALUES (2455, 'Coromandel', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.38355', 'I');
INSERT INTO historico.municipio VALUES (2456, 'Coronel Fabriciano', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.384524', 'I');
INSERT INTO historico.municipio VALUES (2457, 'Coronel Murta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.385391', 'I');
INSERT INTO historico.municipio VALUES (2458, 'Coronel Pacheco', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.386312', 'I');
INSERT INTO historico.municipio VALUES (2459, 'Coronel Xavier Chaves', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.387358', 'I');
INSERT INTO historico.municipio VALUES (2460, 'Corrego Danta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.388301', 'I');
INSERT INTO historico.municipio VALUES (2461, 'Corrego do Bom Jesus', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.389213', 'I');
INSERT INTO historico.municipio VALUES (2462, 'Corrego Fundo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.390263', 'I');
INSERT INTO historico.municipio VALUES (2463, 'Corrego Novo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.391202', 'I');
INSERT INTO historico.municipio VALUES (2464, 'Couto de Magalhaes de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.392311', 'I');
INSERT INTO historico.municipio VALUES (2465, 'Crisolita', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.393212', 'I');
INSERT INTO historico.municipio VALUES (2466, 'Cristais', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.394167', 'I');
INSERT INTO historico.municipio VALUES (2467, 'Cristalia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.394971', 'I');
INSERT INTO historico.municipio VALUES (2468, 'Cristiano Otoni', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.395888', 'I');
INSERT INTO historico.municipio VALUES (2469, 'Cristina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.396852', 'I');
INSERT INTO historico.municipio VALUES (2470, 'Crucilandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.397656', 'I');
INSERT INTO historico.municipio VALUES (2471, 'Cruzeiro da Fortaleza', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.398422', 'I');
INSERT INTO historico.municipio VALUES (2472, 'Cruzilia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.399226', 'I');
INSERT INTO historico.municipio VALUES (2473, 'Cuparaque', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.400152', 'I');
INSERT INTO historico.municipio VALUES (2474, 'Curral de Dentro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.401352', 'I');
INSERT INTO historico.municipio VALUES (2475, 'Curvelo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.41163', 'I');
INSERT INTO historico.municipio VALUES (2476, 'Datas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.412738', 'I');
INSERT INTO historico.municipio VALUES (2477, 'Delfim Moreira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.413631', 'I');
INSERT INTO historico.municipio VALUES (2478, 'Delfinopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.414454', 'I');
INSERT INTO historico.municipio VALUES (2479, 'Delta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.415301', 'I');
INSERT INTO historico.municipio VALUES (2480, 'Descoberto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.416181', 'I');
INSERT INTO historico.municipio VALUES (2481, 'Desterro de Entre Rios', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.417061', 'I');
INSERT INTO historico.municipio VALUES (2482, 'Desterro do Melo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.417919', 'I');
INSERT INTO historico.municipio VALUES (2483, 'Diamantina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.418797', 'I');
INSERT INTO historico.municipio VALUES (2484, 'Diogo de Vasconcelos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.41969', 'I');
INSERT INTO historico.municipio VALUES (2485, 'Dionisio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.420606', 'I');
INSERT INTO historico.municipio VALUES (2486, 'Divinesia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.421506', 'I');
INSERT INTO historico.municipio VALUES (2487, 'Divino', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.422311', 'I');
INSERT INTO historico.municipio VALUES (2488, 'Divino das Laranjeiras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.423584', 'I');
INSERT INTO historico.municipio VALUES (2489, 'Divinolandia de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.424526', 'I');
INSERT INTO historico.municipio VALUES (2490, 'Divinopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.425468', 'I');
INSERT INTO historico.municipio VALUES (2491, 'Divisa Alegre', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.426294', 'I');
INSERT INTO historico.municipio VALUES (2492, 'Divisa Nova', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.427201', 'I');
INSERT INTO historico.municipio VALUES (2493, 'Divisopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.428217', 'I');
INSERT INTO historico.municipio VALUES (2494, 'Dom Bosco', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.429142', 'I');
INSERT INTO historico.municipio VALUES (2495, 'Dom Cavati', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.430042', 'I');
INSERT INTO historico.municipio VALUES (2496, 'Dom Joaquim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.430968', 'I');
INSERT INTO historico.municipio VALUES (2497, 'Dom Silverio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.43188', 'I');
INSERT INTO historico.municipio VALUES (2498, 'Dom Vicoso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.432759', 'I');
INSERT INTO historico.municipio VALUES (2499, 'Dona Eusebia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.433829', 'I');
INSERT INTO historico.municipio VALUES (2500, 'Dores de Campos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.434737', 'I');
INSERT INTO historico.municipio VALUES (2501, 'Dores de Guanhaes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.435545', 'I');
INSERT INTO historico.municipio VALUES (2502, 'Dores do Indaia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.436568', 'I');
INSERT INTO historico.municipio VALUES (2503, 'Dores do Turvo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.437482', 'I');
INSERT INTO historico.municipio VALUES (2504, 'Doresopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.438283', 'I');
INSERT INTO historico.municipio VALUES (2505, 'Douradoquara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.439165', 'I');
INSERT INTO historico.municipio VALUES (2506, 'Durande', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.439988', 'I');
INSERT INTO historico.municipio VALUES (2507, 'Eloi Mendes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.440884', 'I');
INSERT INTO historico.municipio VALUES (2508, 'Engenheiro Caldas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.441795', 'I');
INSERT INTO historico.municipio VALUES (2509, 'Engenheiro Navarro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.442634', 'I');
INSERT INTO historico.municipio VALUES (2510, 'Entre Folhas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.44354', 'I');
INSERT INTO historico.municipio VALUES (2511, 'Entre Rios de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.444453', 'I');
INSERT INTO historico.municipio VALUES (2512, 'Ervalia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.445278', 'I');
INSERT INTO historico.municipio VALUES (2513, 'Esmeraldas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.451797', 'I');
INSERT INTO historico.municipio VALUES (2514, 'Espera Feliz', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.452981', 'I');
INSERT INTO historico.municipio VALUES (2515, 'Espinosa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.453778', 'I');
INSERT INTO historico.municipio VALUES (2516, 'Espirito Santo do Dourado', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.454654', 'I');
INSERT INTO historico.municipio VALUES (2517, 'Estiva', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.4555', 'I');
INSERT INTO historico.municipio VALUES (2518, 'Estrela Dalva', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.456458', 'I');
INSERT INTO historico.municipio VALUES (2519, 'Estrela do Indaia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.457559', 'I');
INSERT INTO historico.municipio VALUES (2520, 'Estrela do Sul', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.458485', 'I');
INSERT INTO historico.municipio VALUES (2521, 'Eugenopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.459407', 'I');
INSERT INTO historico.municipio VALUES (2522, 'Ewbank da Camara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.460227', 'I');
INSERT INTO historico.municipio VALUES (2523, 'Extrema', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.461085', 'I');
INSERT INTO historico.municipio VALUES (2524, 'Fama', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.461955', 'I');
INSERT INTO historico.municipio VALUES (2525, 'Faria Lemos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.462875', 'I');
INSERT INTO historico.municipio VALUES (2526, 'Felicio dos Santos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.463927', 'I');
INSERT INTO historico.municipio VALUES (2965, 'Sao Goncalo do Rio Preto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.947525', 'I');
INSERT INTO historico.municipio VALUES (2527, 'Felisburgo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.464686', 'I');
INSERT INTO historico.municipio VALUES (2528, 'Felixlandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.465613', 'I');
INSERT INTO historico.municipio VALUES (2529, 'Fernandes Tourinho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.46651', 'I');
INSERT INTO historico.municipio VALUES (2530, 'Ferros', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.467262', 'I');
INSERT INTO historico.municipio VALUES (2531, 'Fervedouro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.468075', 'I');
INSERT INTO historico.municipio VALUES (2532, 'Florestal', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.469065', 'I');
INSERT INTO historico.municipio VALUES (2533, 'Formiga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.469915', 'I');
INSERT INTO historico.municipio VALUES (2534, 'Formoso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.470866', 'I');
INSERT INTO historico.municipio VALUES (2535, 'Fortaleza de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.4718', 'I');
INSERT INTO historico.municipio VALUES (2536, 'Fortuna de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.472649', 'I');
INSERT INTO historico.municipio VALUES (2537, 'Francisco Badaro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.47366', 'I');
INSERT INTO historico.municipio VALUES (2538, 'Francisco Dumont', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.474555', 'I');
INSERT INTO historico.municipio VALUES (2539, 'Francisco Sa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.47544', 'I');
INSERT INTO historico.municipio VALUES (2540, 'Franciscopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.476315', 'I');
INSERT INTO historico.municipio VALUES (2541, 'Frei Gaspar', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.477184', 'I');
INSERT INTO historico.municipio VALUES (2542, 'Frei Inocencio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.478085', 'I');
INSERT INTO historico.municipio VALUES (2543, 'Frei Lagonegro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.478996', 'I');
INSERT INTO historico.municipio VALUES (2544, 'Fronteira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.479756', 'I');
INSERT INTO historico.municipio VALUES (2545, 'Fronteira dos Vales', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.480618', 'I');
INSERT INTO historico.municipio VALUES (2546, 'Fruta de Leite', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.481494', 'I');
INSERT INTO historico.municipio VALUES (2547, 'Frutal', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.482274', 'I');
INSERT INTO historico.municipio VALUES (2548, 'Funilandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.483177', 'I');
INSERT INTO historico.municipio VALUES (2549, 'Galileia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.484093', 'I');
INSERT INTO historico.municipio VALUES (2550, 'Gameleiras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.484955', 'I');
INSERT INTO historico.municipio VALUES (2551, 'Glaucilandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.485777', 'I');
INSERT INTO historico.municipio VALUES (2552, 'Goiabeira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.493322', 'I');
INSERT INTO historico.municipio VALUES (2553, 'Goiana', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.494496', 'I');
INSERT INTO historico.municipio VALUES (2554, 'Goncalves', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.49536', 'I');
INSERT INTO historico.municipio VALUES (2555, 'Gonzaga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.496231', 'I');
INSERT INTO historico.municipio VALUES (2556, 'Gouveia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.497133', 'I');
INSERT INTO historico.municipio VALUES (2557, 'Governador Valadares', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.498098', 'I');
INSERT INTO historico.municipio VALUES (2558, 'Grao Mogol', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.498957', 'I');
INSERT INTO historico.municipio VALUES (2559, 'Grupiara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.499849', 'I');
INSERT INTO historico.municipio VALUES (2560, 'Guanhaes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.500653', 'I');
INSERT INTO historico.municipio VALUES (2561, 'Guape', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.501713', 'I');
INSERT INTO historico.municipio VALUES (2562, 'Guaraciaba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.502633', 'I');
INSERT INTO historico.municipio VALUES (2563, 'Guaraciama', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.503502', 'I');
INSERT INTO historico.municipio VALUES (2564, 'Guaranesia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.504369', 'I');
INSERT INTO historico.municipio VALUES (2565, 'Guarani', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.505195', 'I');
INSERT INTO historico.municipio VALUES (2566, 'Guarara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.506059', 'I');
INSERT INTO historico.municipio VALUES (2567, 'Guarda-mor', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.506895', 'I');
INSERT INTO historico.municipio VALUES (2568, 'Guaxupe', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.507726', 'I');
INSERT INTO historico.municipio VALUES (2569, 'Guidoval', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.508808', 'I');
INSERT INTO historico.municipio VALUES (2570, 'Guimarania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.509736', 'I');
INSERT INTO historico.municipio VALUES (2571, 'Guiricema', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.510664', 'I');
INSERT INTO historico.municipio VALUES (2572, 'Gurinhata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.51156', 'I');
INSERT INTO historico.municipio VALUES (2573, 'Heliodora', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.512439', 'I');
INSERT INTO historico.municipio VALUES (2574, 'Iapu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.513288', 'I');
INSERT INTO historico.municipio VALUES (2575, 'Ibertioga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.514211', 'I');
INSERT INTO historico.municipio VALUES (2576, 'Ibia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.515149', 'I');
INSERT INTO historico.municipio VALUES (2577, 'Ibiai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.515973', 'I');
INSERT INTO historico.municipio VALUES (2578, 'Ibiracatu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.516767', 'I');
INSERT INTO historico.municipio VALUES (2579, 'Ibiraci', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.51756', 'I');
INSERT INTO historico.municipio VALUES (2580, 'Ibirite', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.518486', 'I');
INSERT INTO historico.municipio VALUES (2581, 'Ibitiura de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.519415', 'I');
INSERT INTO historico.municipio VALUES (2582, 'Ibituruna', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.520237', 'I');
INSERT INTO historico.municipio VALUES (2583, 'Icarai de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.521141', 'I');
INSERT INTO historico.municipio VALUES (2584, 'Igarape', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.522171', 'I');
INSERT INTO historico.municipio VALUES (2585, 'Igaratinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.523975', 'I');
INSERT INTO historico.municipio VALUES (2586, 'Iguatama', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.524916', 'I');
INSERT INTO historico.municipio VALUES (2587, 'Ijaci', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.525818', 'I');
INSERT INTO historico.municipio VALUES (2588, 'Ilicinea', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.526807', 'I');
INSERT INTO historico.municipio VALUES (2589, 'Imbe de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.527566', 'I');
INSERT INTO historico.municipio VALUES (2590, 'Inconfidentes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.534284', 'I');
INSERT INTO historico.municipio VALUES (2591, 'Indaiabira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.535355', 'I');
INSERT INTO historico.municipio VALUES (2592, 'Indianopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.536141', 'I');
INSERT INTO historico.municipio VALUES (2593, 'Ingai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.53695', 'I');
INSERT INTO historico.municipio VALUES (2594, 'Inhapim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.537926', 'I');
INSERT INTO historico.municipio VALUES (2595, 'Inhauma', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.538866', 'I');
INSERT INTO historico.municipio VALUES (2596, 'Inimutaba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.539693', 'I');
INSERT INTO historico.municipio VALUES (2597, 'Ipaba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.540615', 'I');
INSERT INTO historico.municipio VALUES (2598, 'Ipanema', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.541477', 'I');
INSERT INTO historico.municipio VALUES (2599, 'Ipatinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.542301', 'I');
INSERT INTO historico.municipio VALUES (2600, 'Ipiacu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.543088', 'I');
INSERT INTO historico.municipio VALUES (2601, 'Ipuiuna', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.544006', 'I');
INSERT INTO historico.municipio VALUES (2602, 'Irai de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.544877', 'I');
INSERT INTO historico.municipio VALUES (2603, 'Itabira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.545641', 'I');
INSERT INTO historico.municipio VALUES (2604, 'Itabirinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.546423', 'I');
INSERT INTO historico.municipio VALUES (2605, 'Itabirito', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.547264', 'I');
INSERT INTO historico.municipio VALUES (2606, 'Itacambira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.54826', 'I');
INSERT INTO historico.municipio VALUES (2607, 'Itacarambi', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.549333', 'I');
INSERT INTO historico.municipio VALUES (2608, 'Itaguara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.550259', 'I');
INSERT INTO historico.municipio VALUES (2609, 'Itaipe', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.551156', 'I');
INSERT INTO historico.municipio VALUES (2610, 'Itajuba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.552041', 'I');
INSERT INTO historico.municipio VALUES (2611, 'Itamarandiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.55291', 'I');
INSERT INTO historico.municipio VALUES (2612, 'Itamarati de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.553968', 'I');
INSERT INTO historico.municipio VALUES (2613, 'Itambacuri', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.554843', 'I');
INSERT INTO historico.municipio VALUES (2614, 'Itambe do Mato Dentro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.555903', 'I');
INSERT INTO historico.municipio VALUES (2615, 'Itamogi', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.556785', 'I');
INSERT INTO historico.municipio VALUES (2616, 'Itamonte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.557679', 'I');
INSERT INTO historico.municipio VALUES (2617, 'Itanhandu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.558486', 'I');
INSERT INTO historico.municipio VALUES (2618, 'Itanhomi', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.559343', 'I');
INSERT INTO historico.municipio VALUES (2619, 'Itaobim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.560182', 'I');
INSERT INTO historico.municipio VALUES (2620, 'Itapagipe', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.561129', 'I');
INSERT INTO historico.municipio VALUES (2621, 'Itapecerica', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.562045', 'I');
INSERT INTO historico.municipio VALUES (2622, 'Itapeva', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.562886', 'I');
INSERT INTO historico.municipio VALUES (2623, 'Itatiaiucu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.56382', 'I');
INSERT INTO historico.municipio VALUES (2624, 'Itau de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.564738', 'I');
INSERT INTO historico.municipio VALUES (2625, 'Itauna', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.565631', 'I');
INSERT INTO historico.municipio VALUES (2626, 'Itaverava', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.566539', 'I');
INSERT INTO historico.municipio VALUES (2627, 'Itinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.567443', 'I');
INSERT INTO historico.municipio VALUES (2628, 'Itueta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.574206', 'I');
INSERT INTO historico.municipio VALUES (2629, 'Ituiutaba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.575462', 'I');
INSERT INTO historico.municipio VALUES (2630, 'Itumirim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.576278', 'I');
INSERT INTO historico.municipio VALUES (2631, 'Iturama', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.577299', 'I');
INSERT INTO historico.municipio VALUES (2632, 'Itutinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.578215', 'I');
INSERT INTO historico.municipio VALUES (2633, 'Jaboticatubas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.579155', 'I');
INSERT INTO historico.municipio VALUES (2634, 'Jacinto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.579934', 'I');
INSERT INTO historico.municipio VALUES (2635, 'Jacui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.580977', 'I');
INSERT INTO historico.municipio VALUES (2636, 'Jacutinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.581851', 'I');
INSERT INTO historico.municipio VALUES (2637, 'Jaguaracu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.582674', 'I');
INSERT INTO historico.municipio VALUES (2638, 'Jaiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.583605', 'I');
INSERT INTO historico.municipio VALUES (2639, 'Jampruca', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.584486', 'I');
INSERT INTO historico.municipio VALUES (2640, 'Janauba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.585356', 'I');
INSERT INTO historico.municipio VALUES (2641, 'Januaria', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.586257', 'I');
INSERT INTO historico.municipio VALUES (2642, 'Japaraiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.587138', 'I');
INSERT INTO historico.municipio VALUES (2643, 'Japonvar', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.58822', 'I');
INSERT INTO historico.municipio VALUES (2644, 'Jeceaba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.589312', 'I');
INSERT INTO historico.municipio VALUES (2645, 'Jenipapo de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.590255', 'I');
INSERT INTO historico.municipio VALUES (2646, 'Jequeri', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.591033', 'I');
INSERT INTO historico.municipio VALUES (2647, 'Jequitai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.592039', 'I');
INSERT INTO historico.municipio VALUES (2648, 'Jequitiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.592846', 'I');
INSERT INTO historico.municipio VALUES (2649, 'Jequitinhonha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.593621', 'I');
INSERT INTO historico.municipio VALUES (2650, 'Jesuania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.594594', 'I');
INSERT INTO historico.municipio VALUES (2651, 'Joaima', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.595575', 'I');
INSERT INTO historico.municipio VALUES (2652, 'Joanesia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.596474', 'I');
INSERT INTO historico.municipio VALUES (2653, 'Joao Monlevade', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.597362', 'I');
INSERT INTO historico.municipio VALUES (2654, 'Joao Pinheiro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.59822', 'I');
INSERT INTO historico.municipio VALUES (2655, 'Joaquim Felicio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.599054', 'I');
INSERT INTO historico.municipio VALUES (2656, 'Jordania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.600016', 'I');
INSERT INTO historico.municipio VALUES (2657, 'Jose Goncalves de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.600945', 'I');
INSERT INTO historico.municipio VALUES (2658, 'Jose Raydan', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.602108', 'I');
INSERT INTO historico.municipio VALUES (2659, 'Josenopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.603016', 'I');
INSERT INTO historico.municipio VALUES (2768, 'Nova Uniao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.723765', 'I');
INSERT INTO historico.municipio VALUES (2660, 'Juatuba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.604047', 'I');
INSERT INTO historico.municipio VALUES (2661, 'Juiz de Fora', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.604952', 'I');
INSERT INTO historico.municipio VALUES (2662, 'Juramento', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.605847', 'I');
INSERT INTO historico.municipio VALUES (2663, 'Juruaia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.606705', 'I');
INSERT INTO historico.municipio VALUES (2664, 'Juvenilia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.607706', 'I');
INSERT INTO historico.municipio VALUES (2665, 'Ladainha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.614724', 'I');
INSERT INTO historico.municipio VALUES (2666, 'Lagamar', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.615844', 'I');
INSERT INTO historico.municipio VALUES (2667, 'Lagoa da Prata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.616813', 'I');
INSERT INTO historico.municipio VALUES (2668, 'Lagoa dos Patos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.617738', 'I');
INSERT INTO historico.municipio VALUES (2669, 'Lagoa Dourada', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.618698', 'I');
INSERT INTO historico.municipio VALUES (2670, 'Lagoa Formosa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.619622', 'I');
INSERT INTO historico.municipio VALUES (2671, 'Lagoa Grande', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.620559', 'I');
INSERT INTO historico.municipio VALUES (2672, 'Lagoa Santa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.621608', 'I');
INSERT INTO historico.municipio VALUES (2673, 'Lajinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.622616', 'I');
INSERT INTO historico.municipio VALUES (2674, 'Lambari', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.623675', 'I');
INSERT INTO historico.municipio VALUES (2675, 'Lamim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.624505', 'I');
INSERT INTO historico.municipio VALUES (2676, 'Laranjal', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.625461', 'I');
INSERT INTO historico.municipio VALUES (2677, 'Lassance', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.626399', 'I');
INSERT INTO historico.municipio VALUES (2678, 'Lavras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.62728', 'I');
INSERT INTO historico.municipio VALUES (2679, 'Leandro Ferreira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.6282', 'I');
INSERT INTO historico.municipio VALUES (2680, 'Leme do Prado', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.629003', 'I');
INSERT INTO historico.municipio VALUES (2681, 'Leopoldina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.629801', 'I');
INSERT INTO historico.municipio VALUES (2682, 'Liberdade', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.630694', 'I');
INSERT INTO historico.municipio VALUES (2683, 'Lima Duarte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.631701', 'I');
INSERT INTO historico.municipio VALUES (2684, 'Limeira do Oeste', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.632595', 'I');
INSERT INTO historico.municipio VALUES (2685, 'Lontra', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.633499', 'I');
INSERT INTO historico.municipio VALUES (2686, 'Luisburgo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.634802', 'I');
INSERT INTO historico.municipio VALUES (2687, 'Luislandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.635773', 'I');
INSERT INTO historico.municipio VALUES (2688, 'Luminarias', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.636597', 'I');
INSERT INTO historico.municipio VALUES (2689, 'Luz', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.637763', 'I');
INSERT INTO historico.municipio VALUES (2690, 'Machacalis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.638736', 'I');
INSERT INTO historico.municipio VALUES (2691, 'Machado', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.639667', 'I');
INSERT INTO historico.municipio VALUES (2692, 'Madre de Deus de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.640612', 'I');
INSERT INTO historico.municipio VALUES (2693, 'Malacacheta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.641441', 'I');
INSERT INTO historico.municipio VALUES (2694, 'Mamonas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.642344', 'I');
INSERT INTO historico.municipio VALUES (2695, 'Manga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.643242', 'I');
INSERT INTO historico.municipio VALUES (2696, 'Manhuacu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.644213', 'I');
INSERT INTO historico.municipio VALUES (2697, 'Manhumirim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.64516', 'I');
INSERT INTO historico.municipio VALUES (2698, 'Mantena', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.646202', 'I');
INSERT INTO historico.municipio VALUES (2700, 'Maravilhas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.647968', 'I');
INSERT INTO historico.municipio VALUES (2699, 'Mar de Espanha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.647012', 'I');
INSERT INTO historico.municipio VALUES (2701, 'Maria da Fe', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.655614', 'I');
INSERT INTO historico.municipio VALUES (2702, 'Mariana', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.656908', 'I');
INSERT INTO historico.municipio VALUES (2703, 'Marilac', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.65784', 'I');
INSERT INTO historico.municipio VALUES (2704, 'Mario Campos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.658689', 'I');
INSERT INTO historico.municipio VALUES (2705, 'Maripa de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.65953', 'I');
INSERT INTO historico.municipio VALUES (2706, 'Marlieria', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.66046', 'I');
INSERT INTO historico.municipio VALUES (2707, 'Marmelopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.661483', 'I');
INSERT INTO historico.municipio VALUES (2708, 'Martinho Campos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.662437', 'I');
INSERT INTO historico.municipio VALUES (2709, 'Martins Soares', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.663486', 'I');
INSERT INTO historico.municipio VALUES (2710, 'Mata Verde', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.664361', 'I');
INSERT INTO historico.municipio VALUES (2711, 'Materlandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.665305', 'I');
INSERT INTO historico.municipio VALUES (2712, 'Mateus Leme', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.666284', 'I');
INSERT INTO historico.municipio VALUES (2714, 'Matias Barbosa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.668037', 'I');
INSERT INTO historico.municipio VALUES (2715, 'Matias Cardoso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.668913', 'I');
INSERT INTO historico.municipio VALUES (2716, 'Matipo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.669963', 'I');
INSERT INTO historico.municipio VALUES (2717, 'Mato Verde', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.670864', 'I');
INSERT INTO historico.municipio VALUES (2718, 'Matozinhos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.671823', 'I');
INSERT INTO historico.municipio VALUES (2719, 'Matutina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.672635', 'I');
INSERT INTO historico.municipio VALUES (2720, 'Medeiros', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.673506', 'I');
INSERT INTO historico.municipio VALUES (2721, 'Medina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.674315', 'I');
INSERT INTO historico.municipio VALUES (2722, 'Mendes Pimentel', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.675195', 'I');
INSERT INTO historico.municipio VALUES (2723, 'Merces', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.676123', 'I');
INSERT INTO historico.municipio VALUES (2724, 'Mesquita', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.677029', 'I');
INSERT INTO historico.municipio VALUES (2725, 'Minas Novas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.677866', 'I');
INSERT INTO historico.municipio VALUES (2726, 'Minduri', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.67889', 'I');
INSERT INTO historico.municipio VALUES (2727, 'Mirabela', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.680059', 'I');
INSERT INTO historico.municipio VALUES (2728, 'Miradouro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.681017', 'I');
INSERT INTO historico.municipio VALUES (2729, 'Mirai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.681974', 'I');
INSERT INTO historico.municipio VALUES (2730, 'Miravania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.682921', 'I');
INSERT INTO historico.municipio VALUES (2731, 'Moeda', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.683889', 'I');
INSERT INTO historico.municipio VALUES (2732, 'Moema', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.684839', 'I');
INSERT INTO historico.municipio VALUES (2733, 'Monjolos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.685732', 'I');
INSERT INTO historico.municipio VALUES (2734, 'Monsenhor Paulo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.686645', 'I');
INSERT INTO historico.municipio VALUES (2735, 'Montalvania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.687406', 'I');
INSERT INTO historico.municipio VALUES (2736, 'Monte Alegre de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.688289', 'I');
INSERT INTO historico.municipio VALUES (2737, 'Monte Azul', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.689257', 'I');
INSERT INTO historico.municipio VALUES (2738, 'Monte Belo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.696044', 'I');
INSERT INTO historico.municipio VALUES (2739, 'Monte Carmelo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.697125', 'I');
INSERT INTO historico.municipio VALUES (2740, 'Monte Formoso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.698007', 'I');
INSERT INTO historico.municipio VALUES (2741, 'Monte Santo de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.699102', 'I');
INSERT INTO historico.municipio VALUES (2743, 'Montes Claros', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.700683', 'I');
INSERT INTO historico.municipio VALUES (2742, 'Monte Siao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.699867', 'I');
INSERT INTO historico.municipio VALUES (2744, 'Montezuma', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.701663', 'I');
INSERT INTO historico.municipio VALUES (2745, 'Morada Nova de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.702366', 'I');
INSERT INTO historico.municipio VALUES (2746, 'Morro da Garca', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.703301', 'I');
INSERT INTO historico.municipio VALUES (2747, 'Morro do Pilar', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.70427', 'I');
INSERT INTO historico.municipio VALUES (2748, 'Munhoz', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.705223', 'I');
INSERT INTO historico.municipio VALUES (2749, 'Muriae', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.706065', 'I');
INSERT INTO historico.municipio VALUES (2750, 'Mutum', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.706975', 'I');
INSERT INTO historico.municipio VALUES (2751, 'Muzambinho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.707858', 'I');
INSERT INTO historico.municipio VALUES (2752, 'Nacip Raydan', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.70873', 'I');
INSERT INTO historico.municipio VALUES (2753, 'Nanuque', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.709584', 'I');
INSERT INTO historico.municipio VALUES (2754, 'Naque', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.710678', 'I');
INSERT INTO historico.municipio VALUES (2755, 'Natalandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.711561', 'I');
INSERT INTO historico.municipio VALUES (2756, 'Natercia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.712473', 'I');
INSERT INTO historico.municipio VALUES (2757, 'Nazareno', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.71354', 'I');
INSERT INTO historico.municipio VALUES (2758, 'Nepomuceno', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.714525', 'I');
INSERT INTO historico.municipio VALUES (2759, 'Ninheira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.715406', 'I');
INSERT INTO historico.municipio VALUES (2760, 'Nova Belem', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.716339', 'I');
INSERT INTO historico.municipio VALUES (2761, 'Nova Era', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.71725', 'I');
INSERT INTO historico.municipio VALUES (2762, 'Nova Lima', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.718111', 'I');
INSERT INTO historico.municipio VALUES (2763, 'Nova Modica', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.719056', 'I');
INSERT INTO historico.municipio VALUES (2764, 'Nova Ponte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.720149', 'I');
INSERT INTO historico.municipio VALUES (2765, 'Nova Porteirinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.721149', 'I');
INSERT INTO historico.municipio VALUES (2766, 'Nova Resende', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.722075', 'I');
INSERT INTO historico.municipio VALUES (2767, 'Nova Serrana', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.7229', 'I');
INSERT INTO historico.municipio VALUES (2769, 'Novo Cruzeiro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.724744', 'I');
INSERT INTO historico.municipio VALUES (2770, 'Novo Oriente de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.725723', 'I');
INSERT INTO historico.municipio VALUES (2771, 'Novorizonte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.726657', 'I');
INSERT INTO historico.municipio VALUES (2772, 'Olaria', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.727589', 'I');
INSERT INTO historico.municipio VALUES (2774, 'Olimpio Noronha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.729493', 'I');
INSERT INTO historico.municipio VALUES (2775, 'Oliveira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.740384', 'I');
INSERT INTO historico.municipio VALUES (2776, 'Oliveira Fortes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.74145', 'I');
INSERT INTO historico.municipio VALUES (2777, 'Onca de Pitangui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.742313', 'I');
INSERT INTO historico.municipio VALUES (2778, 'Oratorios', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.7431', 'I');
INSERT INTO historico.municipio VALUES (2779, 'Orizania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.743935', 'I');
INSERT INTO historico.municipio VALUES (2780, 'Ouro Branco', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.744933', 'I');
INSERT INTO historico.municipio VALUES (2781, 'Ouro Fino', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.745729', 'I');
INSERT INTO historico.municipio VALUES (2782, 'Ouro Preto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.746597', 'I');
INSERT INTO historico.municipio VALUES (2783, 'Ouro Verde de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.747426', 'I');
INSERT INTO historico.municipio VALUES (2784, 'Padre Carvalho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.748246', 'I');
INSERT INTO historico.municipio VALUES (2785, 'Padre Paraiso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.749321', 'I');
INSERT INTO historico.municipio VALUES (2787, 'Paineiras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.75118', 'I');
INSERT INTO historico.municipio VALUES (2788, 'Pains', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.752016', 'I');
INSERT INTO historico.municipio VALUES (2786, 'Pai Pedro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.750259', 'I');
INSERT INTO historico.municipio VALUES (2789, 'Paiva', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.753119', 'I');
INSERT INTO historico.municipio VALUES (2790, 'Palma', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.754061', 'I');
INSERT INTO historico.municipio VALUES (2791, 'Palmopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.755117', 'I');
INSERT INTO historico.municipio VALUES (2792, 'Papagaios', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.75607', 'I');
INSERT INTO historico.municipio VALUES (2794, 'Paracatu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.757955', 'I');
INSERT INTO historico.municipio VALUES (2793, 'Para de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.756968', 'I');
INSERT INTO historico.municipio VALUES (2795, 'Paraguacu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.758826', 'I');
INSERT INTO historico.municipio VALUES (2796, 'Paraisopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.759698', 'I');
INSERT INTO historico.municipio VALUES (2797, 'Paraopeba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.76053', 'I');
INSERT INTO historico.municipio VALUES (2801, 'Passabem', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.764189', 'I');
INSERT INTO historico.municipio VALUES (2798, 'Passa Quatro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.761404', 'I');
INSERT INTO historico.municipio VALUES (2799, 'Passa Tempo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.762299', 'I');
INSERT INTO historico.municipio VALUES (2802, 'Passos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.765124', 'I');
INSERT INTO historico.municipio VALUES (2803, 'Patis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.766075', 'I');
INSERT INTO historico.municipio VALUES (2804, 'Patos de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.766987', 'I');
INSERT INTO historico.municipio VALUES (2805, 'Patrocinio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.767808', 'I');
INSERT INTO historico.municipio VALUES (2806, 'Patrocinio do Muriae', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.768792', 'I');
INSERT INTO historico.municipio VALUES (2807, 'Paula Candido', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.769602', 'I');
INSERT INTO historico.municipio VALUES (2808, 'Paulistas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.770548', 'I');
INSERT INTO historico.municipio VALUES (2809, 'Pavao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.771502', 'I');
INSERT INTO historico.municipio VALUES (2810, 'Pecanha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.772442', 'I');
INSERT INTO historico.municipio VALUES (2811, 'Pedra Azul', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.773367', 'I');
INSERT INTO historico.municipio VALUES (2812, 'Pedra Bonita', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.774198', 'I');
INSERT INTO historico.municipio VALUES (2813, 'Pedra do Anta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.781051', 'I');
INSERT INTO historico.municipio VALUES (2814, 'Pedra do Indaia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.782165', 'I');
INSERT INTO historico.municipio VALUES (2815, 'Pedra Dourada', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.783151', 'I');
INSERT INTO historico.municipio VALUES (2816, 'Pedralva', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.784071', 'I');
INSERT INTO historico.municipio VALUES (2817, 'Pedras de Maria da Cruz', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.784969', 'I');
INSERT INTO historico.municipio VALUES (2818, 'Pedrinopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.785949', 'I');
INSERT INTO historico.municipio VALUES (2819, 'Pedro Leopoldo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.786904', 'I');
INSERT INTO historico.municipio VALUES (2820, 'Pedro Teixeira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.787893', 'I');
INSERT INTO historico.municipio VALUES (2821, 'Pequeri', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.788918', 'I');
INSERT INTO historico.municipio VALUES (2822, 'Pequi', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.789785', 'I');
INSERT INTO historico.municipio VALUES (2823, 'Perdigao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.790748', 'I');
INSERT INTO historico.municipio VALUES (2824, 'Perdizes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.791688', 'I');
INSERT INTO historico.municipio VALUES (2825, 'Perdoes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.792564', 'I');
INSERT INTO historico.municipio VALUES (2826, 'Periquito', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.793428', 'I');
INSERT INTO historico.municipio VALUES (2827, 'Pescador', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.79428', 'I');
INSERT INTO historico.municipio VALUES (2828, 'Piau', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.795255', 'I');
INSERT INTO historico.municipio VALUES (2829, 'Piedade de Caratinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.796196', 'I');
INSERT INTO historico.municipio VALUES (2830, 'Piedade de Ponte Nova', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.797037', 'I');
INSERT INTO historico.municipio VALUES (2831, 'Piedade do Rio Grande', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.797938', 'I');
INSERT INTO historico.municipio VALUES (2832, 'Piedade dos Gerais', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.798806', 'I');
INSERT INTO historico.municipio VALUES (2833, 'Pimenta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.799797', 'I');
INSERT INTO historico.municipio VALUES (2835, 'Pintopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.801687', 'I');
INSERT INTO historico.municipio VALUES (2836, 'Piracema', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.802868', 'I');
INSERT INTO historico.municipio VALUES (2837, 'Pirajuba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.803785', 'I');
INSERT INTO historico.municipio VALUES (2838, 'Piranga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.804725', 'I');
INSERT INTO historico.municipio VALUES (2839, 'Pirangucu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.805698', 'I');
INSERT INTO historico.municipio VALUES (2840, 'Piranguinho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.806615', 'I');
INSERT INTO historico.municipio VALUES (2841, 'Pirapetinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.807535', 'I');
INSERT INTO historico.municipio VALUES (2842, 'Pirapora', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.80837', 'I');
INSERT INTO historico.municipio VALUES (2843, 'Pirauba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.809281', 'I');
INSERT INTO historico.municipio VALUES (2844, 'Pitangui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.810255', 'I');
INSERT INTO historico.municipio VALUES (2845, 'Piumhi', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.811233', 'I');
INSERT INTO historico.municipio VALUES (2846, 'Planura', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.812132', 'I');
INSERT INTO historico.municipio VALUES (2847, 'Poco Fundo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.813128', 'I');
INSERT INTO historico.municipio VALUES (2848, 'Pocos de Caldas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.814049', 'I');
INSERT INTO historico.municipio VALUES (2849, 'Pocrane', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.814882', 'I');
INSERT INTO historico.municipio VALUES (2850, 'Pompeu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.822131', 'I');
INSERT INTO historico.municipio VALUES (2851, 'Ponte Nova', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.823253', 'I');
INSERT INTO historico.municipio VALUES (2852, 'Ponto Chique', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.824088', 'I');
INSERT INTO historico.municipio VALUES (2853, 'Ponto dos Volantes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.825103', 'I');
INSERT INTO historico.municipio VALUES (2854, 'Porteirinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.82606', 'I');
INSERT INTO historico.municipio VALUES (2855, 'Porto Firme', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.827004', 'I');
INSERT INTO historico.municipio VALUES (2856, 'Pote', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.828002', 'I');
INSERT INTO historico.municipio VALUES (2857, 'Pouso Alegre', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.828959', 'I');
INSERT INTO historico.municipio VALUES (2858, 'Pouso Alto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.830054', 'I');
INSERT INTO historico.municipio VALUES (2859, 'Prados', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.830956', 'I');
INSERT INTO historico.municipio VALUES (2860, 'Prata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.831842', 'I');
INSERT INTO historico.municipio VALUES (2861, 'Pratapolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.832742', 'I');
INSERT INTO historico.municipio VALUES (2862, 'Pratinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.833628', 'I');
INSERT INTO historico.municipio VALUES (2863, 'Presidente Bernardes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.834501', 'I');
INSERT INTO historico.municipio VALUES (2864, 'Presidente Juscelino', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.836256', 'I');
INSERT INTO historico.municipio VALUES (2865, 'Presidente Kubitschek', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.837166', 'I');
INSERT INTO historico.municipio VALUES (2866, 'Presidente Olegario', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.838125', 'I');
INSERT INTO historico.municipio VALUES (2265, 'Alto Jequitiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.182618', 'I');
INSERT INTO historico.municipio VALUES (2867, 'Prudente de Morais', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.839006', 'I');
INSERT INTO historico.municipio VALUES (2868, 'Quartel Geral', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.839868', 'I');
INSERT INTO historico.municipio VALUES (2869, 'Queluzito', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.840797', 'I');
INSERT INTO historico.municipio VALUES (2870, 'Raposos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.84164', 'I');
INSERT INTO historico.municipio VALUES (2871, 'Raul Soares', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.842576', 'I');
INSERT INTO historico.municipio VALUES (2872, 'Recreio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.843754', 'I');
INSERT INTO historico.municipio VALUES (2873, 'Reduto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.844654', 'I');
INSERT INTO historico.municipio VALUES (2874, 'Resende Costa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.845628', 'I');
INSERT INTO historico.municipio VALUES (2875, 'Resplendor', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.846633', 'I');
INSERT INTO historico.municipio VALUES (2876, 'Ressaquinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.847458', 'I');
INSERT INTO historico.municipio VALUES (2877, 'Riachinho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.848378', 'I');
INSERT INTO historico.municipio VALUES (2878, 'Riacho dos Machados', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.849254', 'I');
INSERT INTO historico.municipio VALUES (2879, 'Ribeirao das Neves', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.850149', 'I');
INSERT INTO historico.municipio VALUES (2880, 'Ribeirao Vermelho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.851048', 'I');
INSERT INTO historico.municipio VALUES (2881, 'Rio Acima', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.852061', 'I');
INSERT INTO historico.municipio VALUES (2882, 'Rio Casca', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.852976', 'I');
INSERT INTO historico.municipio VALUES (2884, 'Rio Doce', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.854683', 'I');
INSERT INTO historico.municipio VALUES (2883, 'Rio do Prado', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.853875', 'I');
INSERT INTO historico.municipio VALUES (2885, 'Rio Espera', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.855684', 'I');
INSERT INTO historico.municipio VALUES (2886, 'Rio Manso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.856476', 'I');
INSERT INTO historico.municipio VALUES (2887, 'Rio Novo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.863208', 'I');
INSERT INTO historico.municipio VALUES (2888, 'Rio Paranaiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.86423', 'I');
INSERT INTO historico.municipio VALUES (2889, 'Rio Pardo de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.865113', 'I');
INSERT INTO historico.municipio VALUES (2890, 'Rio Piracicaba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.866003', 'I');
INSERT INTO historico.municipio VALUES (2891, 'Rio Pomba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.866718', 'I');
INSERT INTO historico.municipio VALUES (2892, 'Rio Preto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.86757', 'I');
INSERT INTO historico.municipio VALUES (2893, 'Rio Vermelho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.868466', 'I');
INSERT INTO historico.municipio VALUES (2894, 'Ritapolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.86965', 'I');
INSERT INTO historico.municipio VALUES (2895, 'Rochedo de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.870574', 'I');
INSERT INTO historico.municipio VALUES (2896, 'Rodeiro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.87147', 'I');
INSERT INTO historico.municipio VALUES (2897, 'Romaria', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.872334', 'I');
INSERT INTO historico.municipio VALUES (2898, 'Rosario da Limeira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.873188', 'I');
INSERT INTO historico.municipio VALUES (2899, 'Rubelita', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.873986', 'I');
INSERT INTO historico.municipio VALUES (2900, 'Rubim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.874865', 'I');
INSERT INTO historico.municipio VALUES (2901, 'Sabara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.875998', 'I');
INSERT INTO historico.municipio VALUES (2902, 'Sabinopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.876908', 'I');
INSERT INTO historico.municipio VALUES (2903, 'Sacramento', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.877892', 'I');
INSERT INTO historico.municipio VALUES (2904, 'Salinas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.878715', 'I');
INSERT INTO historico.municipio VALUES (2905, 'Salto da Divisa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.87963', 'I');
INSERT INTO historico.municipio VALUES (2906, 'Santa Barbara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.880788', 'I');
INSERT INTO historico.municipio VALUES (2907, 'Santa Barbara do Leste', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.881713', 'I');
INSERT INTO historico.municipio VALUES (2908, 'Santa Barbara do Monte Verde', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.882576', 'I');
INSERT INTO historico.municipio VALUES (2909, 'Santa Barbara do Tugurio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.883499', 'I');
INSERT INTO historico.municipio VALUES (2910, 'Santa Cruz de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.884331', 'I');
INSERT INTO historico.municipio VALUES (2911, 'Santa Cruz de Salinas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.885373', 'I');
INSERT INTO historico.municipio VALUES (2912, 'Santa Cruz do Escalvado', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.886231', 'I');
INSERT INTO historico.municipio VALUES (2913, 'Santa Efigenia de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.887023', 'I');
INSERT INTO historico.municipio VALUES (2914, 'Santa Fe de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.887823', 'I');
INSERT INTO historico.municipio VALUES (2915, 'Santa Helena de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.888613', 'I');
INSERT INTO historico.municipio VALUES (2916, 'Santa Juliana', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.889436', 'I');
INSERT INTO historico.municipio VALUES (2917, 'Santa Luzia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.890286', 'I');
INSERT INTO historico.municipio VALUES (2918, 'Santa Margarida', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.891179', 'I');
INSERT INTO historico.municipio VALUES (2919, 'Santa Maria de Itabira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.892071', 'I');
INSERT INTO historico.municipio VALUES (2920, 'Santa Maria do Salto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.893033', 'I');
INSERT INTO historico.municipio VALUES (2921, 'Santa Maria do Suacui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.893934', 'I');
INSERT INTO historico.municipio VALUES (2930, 'Santana da Vargem', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.90782', 'I');
INSERT INTO historico.municipio VALUES (2931, 'Santana de Cataguases', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.908562', 'I');
INSERT INTO historico.municipio VALUES (2932, 'Santana de Pirapama', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.909396', 'I');
INSERT INTO historico.municipio VALUES (2933, 'Santana do Deserto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.91025', 'I');
INSERT INTO historico.municipio VALUES (2934, 'Santana do Garambeu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.911172', 'I');
INSERT INTO historico.municipio VALUES (2935, 'Santana do Jacare', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.912087', 'I');
INSERT INTO historico.municipio VALUES (2936, 'Santana do Manhuacu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.912919', 'I');
INSERT INTO historico.municipio VALUES (2937, 'Santana do Paraiso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.913893', 'I');
INSERT INTO historico.municipio VALUES (2938, 'Santana do Riacho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.914701', 'I');
INSERT INTO historico.municipio VALUES (2939, 'Santana dos Montes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.915635', 'I');
INSERT INTO historico.municipio VALUES (2922, 'Santa Rita de Caldas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.894802', 'I');
INSERT INTO historico.municipio VALUES (2924, 'Santa Rita de Jacutinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.896554', 'I');
INSERT INTO historico.municipio VALUES (2925, 'Santa Rita de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.90317', 'I');
INSERT INTO historico.municipio VALUES (2923, 'Santa Rita de Ibitipoca', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.895661', 'I');
INSERT INTO historico.municipio VALUES (2926, 'Santa Rita do Itueto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.904334', 'I');
INSERT INTO historico.municipio VALUES (2927, 'Santa Rita do Sapucai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.905188', 'I');
INSERT INTO historico.municipio VALUES (2928, 'Santa Rosa da Serra', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.906002', 'I');
INSERT INTO historico.municipio VALUES (2929, 'Santa Vitoria', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.906897', 'I');
INSERT INTO historico.municipio VALUES (2940, 'Santo Antonio do Amparo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.916561', 'I');
INSERT INTO historico.municipio VALUES (2941, 'Santo Antonio do Aventureiro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.917522', 'I');
INSERT INTO historico.municipio VALUES (2942, 'Santo Antonio do Grama', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.918259', 'I');
INSERT INTO historico.municipio VALUES (2943, 'Santo Antonio do Itambe', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.919652', 'I');
INSERT INTO historico.municipio VALUES (2944, 'Santo Antonio do Jacinto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.920493', 'I');
INSERT INTO historico.municipio VALUES (2945, 'Santo Antonio do Monte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.921488', 'I');
INSERT INTO historico.municipio VALUES (2946, 'Santo Antonio do Retiro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.922448', 'I');
INSERT INTO historico.municipio VALUES (2947, 'Santo Antonio do Rio Abaixo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.923338', 'I');
INSERT INTO historico.municipio VALUES (2948, 'Santo Hipolito', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.924169', 'I');
INSERT INTO historico.municipio VALUES (2949, 'Santos Dumont', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.925463', 'I');
INSERT INTO historico.municipio VALUES (2950, 'Sao Bento Abade', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.926405', 'I');
INSERT INTO historico.municipio VALUES (2951, 'Sao Bras do Suacui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.927261', 'I');
INSERT INTO historico.municipio VALUES (2952, 'Sao Domingos das Dores', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.928137', 'I');
INSERT INTO historico.municipio VALUES (2953, 'Sao Domingos do Prata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.928974', 'I');
INSERT INTO historico.municipio VALUES (2954, 'Sao Felix de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.929859', 'I');
INSERT INTO historico.municipio VALUES (2955, 'Sao Francisco', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.930685', 'I');
INSERT INTO historico.municipio VALUES (2956, 'Sao Francisco de Paula', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.931488', 'I');
INSERT INTO historico.municipio VALUES (2957, 'Sao Francisco de Sales', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.932267', 'I');
INSERT INTO historico.municipio VALUES (2958, 'Sao Francisco do Gloria', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.933213', 'I');
INSERT INTO historico.municipio VALUES (2959, 'Sao Geraldo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.934103', 'I');
INSERT INTO historico.municipio VALUES (2960, 'Sao Geraldo da Piedade', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.935011', 'I');
INSERT INTO historico.municipio VALUES (2961, 'Sao Geraldo do Baixio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.935934', 'I');
INSERT INTO historico.municipio VALUES (2962, 'Sao Goncalo do Abaete', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.936778', 'I');
INSERT INTO historico.municipio VALUES (2963, 'Sao Goncalo do Para', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.944008', 'I');
INSERT INTO historico.municipio VALUES (2964, 'Sao Goncalo do Rio Abaixo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.945446', 'I');
INSERT INTO historico.municipio VALUES (2966, 'Sao Goncalo do Sapucai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.948415', 'I');
INSERT INTO historico.municipio VALUES (2967, 'Sao Gotardo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.949358', 'I');
INSERT INTO historico.municipio VALUES (2968, 'Sao Joao Batista do Gloria', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.950284', 'I');
INSERT INTO historico.municipio VALUES (2969, 'Sao Joao da Lagoa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.951373', 'I');
INSERT INTO historico.municipio VALUES (2970, 'Sao Joao da Mata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.952414', 'I');
INSERT INTO historico.municipio VALUES (2971, 'Sao Joao da Ponte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.95334', 'I');
INSERT INTO historico.municipio VALUES (2972, 'Sao Joao das Missoes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.954242', 'I');
INSERT INTO historico.municipio VALUES (2973, 'Sao Joao Del Rei', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.955094', 'I');
INSERT INTO historico.municipio VALUES (2974, 'Sao Joao do Manhuacu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.955927', 'I');
INSERT INTO historico.municipio VALUES (2975, 'Sao Joao do Manteninha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.956767', 'I');
INSERT INTO historico.municipio VALUES (2976, 'Sao Joao do Oriente', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.957553', 'I');
INSERT INTO historico.municipio VALUES (2977, 'Sao Joao do Pacui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.958462', 'I');
INSERT INTO historico.municipio VALUES (2978, 'Sao Joao do Paraiso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.959259', 'I');
INSERT INTO historico.municipio VALUES (2979, 'Sao Joao Evangelista', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.960178', 'I');
INSERT INTO historico.municipio VALUES (2980, 'Sao Joao Nepomuceno', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.961059', 'I');
INSERT INTO historico.municipio VALUES (2981, 'Sao Joaquim de Bicas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.962029', 'I');
INSERT INTO historico.municipio VALUES (2982, 'Sao Jose da Barra', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.962922', 'I');
INSERT INTO historico.municipio VALUES (2983, 'Sao Jose da Lapa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.963826', 'I');
INSERT INTO historico.municipio VALUES (2984, 'Sao Jose da Safira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.964717', 'I');
INSERT INTO historico.municipio VALUES (2985, 'Sao Jose da Varginha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.965573', 'I');
INSERT INTO historico.municipio VALUES (2986, 'Sao Jose do Alegre', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.966464', 'I');
INSERT INTO historico.municipio VALUES (2987, 'Sao Jose do Divino', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.967302', 'I');
INSERT INTO historico.municipio VALUES (2988, 'Sao Jose do Goiabal', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.968161', 'I');
INSERT INTO historico.municipio VALUES (2989, 'Sao Jose do Jacuri', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.969054', 'I');
INSERT INTO historico.municipio VALUES (2990, 'Sao Jose do Mantimento', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.970124', 'I');
INSERT INTO historico.municipio VALUES (2991, 'Sao Lourenco', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.97104', 'I');
INSERT INTO historico.municipio VALUES (2992, 'Sao Miguel do Anta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.971941', 'I');
INSERT INTO historico.municipio VALUES (2993, 'Sao Pedro da Uniao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.972841', 'I');
INSERT INTO historico.municipio VALUES (2995, 'Sao Pedro dos Ferros', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.974488', 'I');
INSERT INTO historico.municipio VALUES (2994, 'Sao Pedro do Suacui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.973711', 'I');
INSERT INTO historico.municipio VALUES (2996, 'Sao Romao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.975409', 'I');
INSERT INTO historico.municipio VALUES (2997, 'Sao Roque de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.976377', 'I');
INSERT INTO historico.municipio VALUES (2998, 'Sao Sebastiao da Bela Vista', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.977178', 'I');
INSERT INTO historico.municipio VALUES (2999, 'Sao Sebastiao da Vargem Alegre', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.97811', 'I');
INSERT INTO historico.municipio VALUES (3000, 'Sao Sebastiao do Anta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.984627', 'I');
INSERT INTO historico.municipio VALUES (3001, 'Sao Sebastiao do Maranhao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.985785', 'I');
INSERT INTO historico.municipio VALUES (3002, 'Sao Sebastiao do Oeste', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.986709', 'I');
INSERT INTO historico.municipio VALUES (3003, 'Sao Sebastiao do Paraiso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.987623', 'I');
INSERT INTO historico.municipio VALUES (3004, 'Sao Sebastiao do Rio Preto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.988553', 'I');
INSERT INTO historico.municipio VALUES (3005, 'Sao Sebastiao do Rio Verde', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.989525', 'I');
INSERT INTO historico.municipio VALUES (3007, 'Sao Tiago', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.991371', 'I');
INSERT INTO historico.municipio VALUES (3008, 'Sao Tomas de Aquino', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.992485', 'I');
INSERT INTO historico.municipio VALUES (3006, 'Sao Thome das Letras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.990503', 'I');
INSERT INTO historico.municipio VALUES (3009, 'Sao Vicente de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.993316', 'I');
INSERT INTO historico.municipio VALUES (3010, 'Sapucai-mirim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.994126', 'I');
INSERT INTO historico.municipio VALUES (3011, 'Sardoa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.995033', 'I');
INSERT INTO historico.municipio VALUES (3012, 'Sarzedo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.995979', 'I');
INSERT INTO historico.municipio VALUES (3033, 'Setubinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.014708', 'I');
INSERT INTO historico.municipio VALUES (3014, 'Senador Amaral', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.997785', 'I');
INSERT INTO historico.municipio VALUES (3015, 'Senador Cortes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.998572', 'I');
INSERT INTO historico.municipio VALUES (3016, 'Senador Firmino', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.999432', 'I');
INSERT INTO historico.municipio VALUES (3017, 'Senador Jose Bento', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.000242', 'I');
INSERT INTO historico.municipio VALUES (3018, 'Senador Modestino Goncalves', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.001181', 'I');
INSERT INTO historico.municipio VALUES (3019, 'Senhora de Oliveira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.002238', 'I');
INSERT INTO historico.municipio VALUES (3020, 'Senhora do Porto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.003123', 'I');
INSERT INTO historico.municipio VALUES (3021, 'Senhora dos Remedios', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.003942', 'I');
INSERT INTO historico.municipio VALUES (3022, 'Sericita', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.004806', 'I');
INSERT INTO historico.municipio VALUES (3023, 'Seritinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.00583', 'I');
INSERT INTO historico.municipio VALUES (3024, 'Serra Azul de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.006724', 'I');
INSERT INTO historico.municipio VALUES (3025, 'Serra da Saudade', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.007597', 'I');
INSERT INTO historico.municipio VALUES (3027, 'Serra dos Aimores', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.00936', 'I');
INSERT INTO historico.municipio VALUES (3026, 'Serra do Salitre', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.008494', 'I');
INSERT INTO historico.municipio VALUES (3028, 'Serrania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.010257', 'I');
INSERT INTO historico.municipio VALUES (3029, 'Serranopolis de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.011126', 'I');
INSERT INTO historico.municipio VALUES (3030, 'Serranos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.011947', 'I');
INSERT INTO historico.municipio VALUES (3031, 'Serro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.012745', 'I');
INSERT INTO historico.municipio VALUES (3032, 'Sete Lagoas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.013654', 'I');
INSERT INTO historico.municipio VALUES (3034, 'Silveirania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.015627', 'I');
INSERT INTO historico.municipio VALUES (3035, 'Silvianopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.016489', 'I');
INSERT INTO historico.municipio VALUES (3036, 'Simao Pereira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.017459', 'I');
INSERT INTO historico.municipio VALUES (3037, 'Simonesia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.018331', 'I');
INSERT INTO historico.municipio VALUES (3038, 'Sobralia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.024929', 'I');
INSERT INTO historico.municipio VALUES (3039, 'Soledade de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.026211', 'I');
INSERT INTO historico.municipio VALUES (3040, 'Tabuleiro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.027116', 'I');
INSERT INTO historico.municipio VALUES (3041, 'Taiobeiras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.027909', 'I');
INSERT INTO historico.municipio VALUES (3042, 'Taparuba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.028691', 'I');
INSERT INTO historico.municipio VALUES (3043, 'Tapira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.029455', 'I');
INSERT INTO historico.municipio VALUES (3044, 'Tapirai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.030502', 'I');
INSERT INTO historico.municipio VALUES (3045, 'Taquaracu de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.031405', 'I');
INSERT INTO historico.municipio VALUES (3046, 'Tarumirim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.032341', 'I');
INSERT INTO historico.municipio VALUES (3047, 'Teixeiras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.033084', 'I');
INSERT INTO historico.municipio VALUES (3048, 'Teofilo Otoni', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.034005', 'I');
INSERT INTO historico.municipio VALUES (3049, 'Timoteo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.034877', 'I');
INSERT INTO historico.municipio VALUES (3050, 'Tiradentes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.035717', 'I');
INSERT INTO historico.municipio VALUES (3051, 'Tiros', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.036438', 'I');
INSERT INTO historico.municipio VALUES (3052, 'Tocantins', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.037378', 'I');
INSERT INTO historico.municipio VALUES (3054, 'Toledo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.039162', 'I');
INSERT INTO historico.municipio VALUES (3055, 'Tombos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.040058', 'I');
INSERT INTO historico.municipio VALUES (3056, 'Tres Coracoes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.040906', 'I');
INSERT INTO historico.municipio VALUES (3057, 'Tres Marias', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.0418', 'I');
INSERT INTO historico.municipio VALUES (3058, 'Tres Pontas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.042593', 'I');
INSERT INTO historico.municipio VALUES (3059, 'Tumiritinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.043498', 'I');
INSERT INTO historico.municipio VALUES (3060, 'Tupaciguara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.044437', 'I');
INSERT INTO historico.municipio VALUES (3061, 'Turmalina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.045367', 'I');
INSERT INTO historico.municipio VALUES (3062, 'Turvolandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.04633', 'I');
INSERT INTO historico.municipio VALUES (3063, 'Uba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.047362', 'I');
INSERT INTO historico.municipio VALUES (3064, 'Ubai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.048359', 'I');
INSERT INTO historico.municipio VALUES (3065, 'Ubaporanga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.049243', 'I');
INSERT INTO historico.municipio VALUES (3066, 'Uberaba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.050224', 'I');
INSERT INTO historico.municipio VALUES (3067, 'Uberlandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.051156', 'I');
INSERT INTO historico.municipio VALUES (3068, 'Umburatiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.052078', 'I');
INSERT INTO historico.municipio VALUES (3069, 'Unai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.052956', 'I');
INSERT INTO historico.municipio VALUES (3070, 'Uniao de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.05387', 'I');
INSERT INTO historico.municipio VALUES (3071, 'Uruana de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.054766', 'I');
INSERT INTO historico.municipio VALUES (3072, 'Urucania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.055651', 'I');
INSERT INTO historico.municipio VALUES (3073, 'Urucuia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.056552', 'I');
INSERT INTO historico.municipio VALUES (3074, 'Vargem Alegre', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.057453', 'I');
INSERT INTO historico.municipio VALUES (3075, 'Vargem Bonita', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.058481', 'I');
INSERT INTO historico.municipio VALUES (3076, 'Vargem Grande do Rio Pardo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.05921', 'I');
INSERT INTO historico.municipio VALUES (3077, 'Varginha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.065668', 'I');
INSERT INTO historico.municipio VALUES (3078, 'Varjao de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.066741', 'I');
INSERT INTO historico.municipio VALUES (3079, 'Varzea da Palma', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.067629', 'I');
INSERT INTO historico.municipio VALUES (3080, 'Varzelandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.068499', 'I');
INSERT INTO historico.municipio VALUES (3081, 'Vazante', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.069738', 'I');
INSERT INTO historico.municipio VALUES (3082, 'Verdelandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.070607', 'I');
INSERT INTO historico.municipio VALUES (3083, 'Veredinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.071486', 'I');
INSERT INTO historico.municipio VALUES (3084, 'Verissimo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.072355', 'I');
INSERT INTO historico.municipio VALUES (3085, 'Vermelho Novo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.073251', 'I');
INSERT INTO historico.municipio VALUES (3086, 'Vespasiano', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.074104', 'I');
INSERT INTO historico.municipio VALUES (3087, 'Vicosa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.074933', 'I');
INSERT INTO historico.municipio VALUES (3088, 'Vieiras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.075846', 'I');
INSERT INTO historico.municipio VALUES (2713, 'Mathias Lobato', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.667155', 'I');
INSERT INTO historico.municipio VALUES (3089, 'Virgem da Lapa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.076853', 'I');
INSERT INTO historico.municipio VALUES (3090, 'Virginia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.077734', 'I');
INSERT INTO historico.municipio VALUES (3091, 'Virginopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.078589', 'I');
INSERT INTO historico.municipio VALUES (3092, 'Virgolandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.079515', 'I');
INSERT INTO historico.municipio VALUES (3093, 'Visconde do Rio Branco', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.080291', 'I');
INSERT INTO historico.municipio VALUES (3094, 'Volta Grande', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.081204', 'I');
INSERT INTO historico.municipio VALUES (3095, 'Wenceslau Braz', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.081973', 'I');
INSERT INTO historico.municipio VALUES (3096, 'Afonso Claudio', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.082886', 'I');
INSERT INTO historico.municipio VALUES (3098, 'Aguia Branca', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.084678', 'I');
INSERT INTO historico.municipio VALUES (3097, 'Agua Doce do Norte', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.08375', 'I');
INSERT INTO historico.municipio VALUES (3099, 'Alegre', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.085605', 'I');
INSERT INTO historico.municipio VALUES (3100, 'Alfredo Chaves', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.086469', 'I');
INSERT INTO historico.municipio VALUES (3101, 'Alto Rio Novo', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.087312', 'I');
INSERT INTO historico.municipio VALUES (3102, 'Anchieta', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.088204', 'I');
INSERT INTO historico.municipio VALUES (3103, 'Apiaca', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.089062', 'I');
INSERT INTO historico.municipio VALUES (3104, 'Aracruz', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.089943', 'I');
INSERT INTO historico.municipio VALUES (3105, 'Atilio Vivacqua', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.09086', 'I');
INSERT INTO historico.municipio VALUES (3106, 'Baixo Guandu', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.091737', 'I');
INSERT INTO historico.municipio VALUES (3107, 'Barra de Sao Francisco', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.092835', 'I');
INSERT INTO historico.municipio VALUES (3108, 'Boa Esperanca', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.093704', 'I');
INSERT INTO historico.municipio VALUES (3109, 'Bom Jesus do Norte', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.094622', 'I');
INSERT INTO historico.municipio VALUES (3110, 'Brejetuba', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.095495', 'I');
INSERT INTO historico.municipio VALUES (3111, 'Cachoeiro de Itapemirim', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.096312', 'I');
INSERT INTO historico.municipio VALUES (3112, 'Cariacica', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.097169', 'I');
INSERT INTO historico.municipio VALUES (3113, 'Castelo', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.09809', 'I');
INSERT INTO historico.municipio VALUES (3114, 'Colatina', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.099011', 'I');
INSERT INTO historico.municipio VALUES (3115, 'Conceicao da Barra', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.105545', 'I');
INSERT INTO historico.municipio VALUES (3116, 'Conceicao do Castelo', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.106749', 'I');
INSERT INTO historico.municipio VALUES (3117, 'Divino de Sao Lourenco', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.107684', 'I');
INSERT INTO historico.municipio VALUES (3118, 'Domingos Martins', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.108581', 'I');
INSERT INTO historico.municipio VALUES (3119, 'Dores do Rio Preto', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.109452', 'I');
INSERT INTO historico.municipio VALUES (3120, 'Ecoporanga', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.110394', 'I');
INSERT INTO historico.municipio VALUES (3121, 'Fundao', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.111308', 'I');
INSERT INTO historico.municipio VALUES (3122, 'Governador Lindenberg', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.112208', 'I');
INSERT INTO historico.municipio VALUES (3123, 'Guacui', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.113153', 'I');
INSERT INTO historico.municipio VALUES (3124, 'Guarapari', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.11402', 'I');
INSERT INTO historico.municipio VALUES (3125, 'Ibatiba', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.11507', 'I');
INSERT INTO historico.municipio VALUES (3126, 'Ibiracu', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.115945', 'I');
INSERT INTO historico.municipio VALUES (3127, 'Ibitirama', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.116851', 'I');
INSERT INTO historico.municipio VALUES (3128, 'Iconha', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.117854', 'I');
INSERT INTO historico.municipio VALUES (3129, 'Irupi', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.118674', 'I');
INSERT INTO historico.municipio VALUES (3130, 'Itaguacu', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.119498', 'I');
INSERT INTO historico.municipio VALUES (3131, 'Itapemirim', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.120273', 'I');
INSERT INTO historico.municipio VALUES (3132, 'Itarana', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.12108', 'I');
INSERT INTO historico.municipio VALUES (3133, 'Iuna', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.122057', 'I');
INSERT INTO historico.municipio VALUES (3134, 'Jaguare', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.122973', 'I');
INSERT INTO historico.municipio VALUES (3135, 'Jeronimo Monteiro', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.123854', 'I');
INSERT INTO historico.municipio VALUES (3136, 'Joao Neiva', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.124735', 'I');
INSERT INTO historico.municipio VALUES (3137, 'Laranja da Terra', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.125741', 'I');
INSERT INTO historico.municipio VALUES (3138, 'Linhares', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.126641', 'I');
INSERT INTO historico.municipio VALUES (3139, 'Mantenopolis', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.127556', 'I');
INSERT INTO historico.municipio VALUES (3140, 'Marataizes', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.128435', 'I');
INSERT INTO historico.municipio VALUES (3141, 'Marechal Floriano', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.129304', 'I');
INSERT INTO historico.municipio VALUES (3142, 'Marilandia', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.130149', 'I');
INSERT INTO historico.municipio VALUES (3143, 'Mimoso do Sul', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.131032', 'I');
INSERT INTO historico.municipio VALUES (3144, 'Montanha', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.131767', 'I');
INSERT INTO historico.municipio VALUES (3145, 'Mucurici', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.132669', 'I');
INSERT INTO historico.municipio VALUES (3146, 'Muniz Freire', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.133579', 'I');
INSERT INTO historico.municipio VALUES (3147, 'Muqui', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.13436', 'I');
INSERT INTO historico.municipio VALUES (3148, 'Nova Venecia', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.135185', 'I');
INSERT INTO historico.municipio VALUES (3149, 'Pancas', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.136062', 'I');
INSERT INTO historico.municipio VALUES (3150, 'Pedro Canario', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.137029', 'I');
INSERT INTO historico.municipio VALUES (3151, 'Pinheiros', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.13779', 'I');
INSERT INTO historico.municipio VALUES (3152, 'Piuma', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.138726', 'I');
INSERT INTO historico.municipio VALUES (3153, 'Ponto Belo', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.139504', 'I');
INSERT INTO historico.municipio VALUES (3154, 'Presidente Kennedy', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.146339', 'I');
INSERT INTO historico.municipio VALUES (3155, 'Rio Bananal', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.150463', 'I');
INSERT INTO historico.municipio VALUES (3156, 'Rio Novo do Sul', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.151418', 'I');
INSERT INTO historico.municipio VALUES (3157, 'Santa Leopoldina', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.152323', 'I');
INSERT INTO historico.municipio VALUES (3158, 'Santa Maria de Jetiba', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.153183', 'I');
INSERT INTO historico.municipio VALUES (3159, 'Santa Teresa', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.154075', 'I');
INSERT INTO historico.municipio VALUES (3160, 'Sao Domingos do Norte', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.154905', 'I');
INSERT INTO historico.municipio VALUES (3161, 'Sao Gabriel da Palha', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.15581', 'I');
INSERT INTO historico.municipio VALUES (3162, 'Sao Jose do Calcado', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.156713', 'I');
INSERT INTO historico.municipio VALUES (3163, 'Sao Mateus', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.157706', 'I');
INSERT INTO historico.municipio VALUES (3164, 'Sao Roque do Canaa', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.158648', 'I');
INSERT INTO historico.municipio VALUES (3165, 'Serra', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.159594', 'I');
INSERT INTO historico.municipio VALUES (3166, 'Sooretama', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.160485', 'I');
INSERT INTO historico.municipio VALUES (3167, 'Vargem Alta', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.161405', 'I');
INSERT INTO historico.municipio VALUES (3168, 'Venda Nova do Imigrante', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.162222', 'I');
INSERT INTO historico.municipio VALUES (3169, 'Viana', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.163119', 'I');
INSERT INTO historico.municipio VALUES (3170, 'Vila Pavao', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.164134', 'I');
INSERT INTO historico.municipio VALUES (3171, 'Vila Valerio', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.165005', 'I');
INSERT INTO historico.municipio VALUES (3172, 'Vila Velha', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.165861', 'I');
INSERT INTO historico.municipio VALUES (3173, 'Vitoria', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.166749', 'I');
INSERT INTO historico.municipio VALUES (3174, 'Angra dos Reis', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.16759', 'I');
INSERT INTO historico.municipio VALUES (3175, 'Aperibe', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.168353', 'I');
INSERT INTO historico.municipio VALUES (3176, 'Araruama', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.169167', 'I');
INSERT INTO historico.municipio VALUES (3177, 'Areal', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.170131', 'I');
INSERT INTO historico.municipio VALUES (3178, 'Armacao dos Buzios', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.171024', 'I');
INSERT INTO historico.municipio VALUES (3179, 'Arraial do Cabo', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.171933', 'I');
INSERT INTO historico.municipio VALUES (3180, 'Barra do Pirai', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.172817', 'I');
INSERT INTO historico.municipio VALUES (3181, 'Barra Mansa', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.173722', 'I');
INSERT INTO historico.municipio VALUES (3182, 'Belford Roxo', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.174593', 'I');
INSERT INTO historico.municipio VALUES (3183, 'Bom Jardim', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.175369', 'I');
INSERT INTO historico.municipio VALUES (3184, 'Bom Jesus do Itabapoana', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.17623', 'I');
INSERT INTO historico.municipio VALUES (3185, 'Cabo Frio', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.177146', 'I');
INSERT INTO historico.municipio VALUES (3186, 'Cachoeiras de Macacu', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.178064', 'I');
INSERT INTO historico.municipio VALUES (3187, 'Cambuci', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.178988', 'I');
INSERT INTO historico.municipio VALUES (3190, 'Carapebus', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.188539', 'I');
INSERT INTO historico.municipio VALUES (3194, 'Comendador Levy Gasparian', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.192154', 'I');
INSERT INTO historico.municipio VALUES (3188, 'Campos dos Goytacazes', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.17996', 'I');
INSERT INTO historico.municipio VALUES (3189, 'Cantagalo', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.187376', 'I');
INSERT INTO historico.municipio VALUES (3191, 'Cardoso Moreira', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.189489', 'I');
INSERT INTO historico.municipio VALUES (3192, 'Carmo', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.190376', 'I');
INSERT INTO historico.municipio VALUES (3193, 'Casimiro de Abreu', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.191224', 'I');
INSERT INTO historico.municipio VALUES (3195, 'Conceicao de Macabu', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.193182', 'I');
INSERT INTO historico.municipio VALUES (3196, 'Cordeiro', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.194114', 'I');
INSERT INTO historico.municipio VALUES (3197, 'Duas Barras', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.195152', 'I');
INSERT INTO historico.municipio VALUES (3198, 'Duque de Caxias', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.195978', 'I');
INSERT INTO historico.municipio VALUES (3199, 'Engenheiro Paulo de Frontin', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.197016', 'I');
INSERT INTO historico.municipio VALUES (3200, 'Guapimirim', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.197975', 'I');
INSERT INTO historico.municipio VALUES (3201, 'Iguaba Grande', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.198896', 'I');
INSERT INTO historico.municipio VALUES (3202, 'Itaborai', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.199823', 'I');
INSERT INTO historico.municipio VALUES (3203, 'Itaguai', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.200615', 'I');
INSERT INTO historico.municipio VALUES (3204, 'Italva', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.201573', 'I');
INSERT INTO historico.municipio VALUES (3205, 'Itaocara', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.202472', 'I');
INSERT INTO historico.municipio VALUES (3206, 'Itaperuna', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.203303', 'I');
INSERT INTO historico.municipio VALUES (3207, 'Itatiaia', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.204383', 'I');
INSERT INTO historico.municipio VALUES (3208, 'Japeri', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.20529', 'I');
INSERT INTO historico.municipio VALUES (3209, 'Laje do Muriae', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.206148', 'I');
INSERT INTO historico.municipio VALUES (3210, 'Macae', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.207034', 'I');
INSERT INTO historico.municipio VALUES (3211, 'Macuco', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.207887', 'I');
INSERT INTO historico.municipio VALUES (3212, 'Mage', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.208742', 'I');
INSERT INTO historico.municipio VALUES (3213, 'Mangaratiba', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.209642', 'I');
INSERT INTO historico.municipio VALUES (3214, 'Marica', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.210561', 'I');
INSERT INTO historico.municipio VALUES (3215, 'Mendes', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.211426', 'I');
INSERT INTO historico.municipio VALUES (3216, 'Mesquita', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.212248', 'I');
INSERT INTO historico.municipio VALUES (3217, 'Miguel Pereira', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.21322', 'I');
INSERT INTO historico.municipio VALUES (3218, 'Miracema', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.214025', 'I');
INSERT INTO historico.municipio VALUES (3219, 'Natividade', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.214987', 'I');
INSERT INTO historico.municipio VALUES (3220, 'Nilopolis', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.215631', 'I');
INSERT INTO historico.municipio VALUES (3221, 'Niteroi', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.216575', 'I');
INSERT INTO historico.municipio VALUES (3222, 'Nova Friburgo', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.217505', 'I');
INSERT INTO historico.municipio VALUES (3223, 'Nova Iguacu', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.218374', 'I');
INSERT INTO historico.municipio VALUES (3224, 'Paracambi', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.219241', 'I');
INSERT INTO historico.municipio VALUES (3225, 'Paraiba do Sul', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.22011', 'I');
INSERT INTO historico.municipio VALUES (3227, 'Paty do Alferes', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.227898', 'I');
INSERT INTO historico.municipio VALUES (3228, 'Petropolis', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.22905', 'I');
INSERT INTO historico.municipio VALUES (3229, 'Pinheiral', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.229964', 'I');
INSERT INTO historico.municipio VALUES (3230, 'Pirai', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.230972', 'I');
INSERT INTO historico.municipio VALUES (3231, 'Porciuncula', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.231958', 'I');
INSERT INTO historico.municipio VALUES (3232, 'Porto Real', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.232847', 'I');
INSERT INTO historico.municipio VALUES (3233, 'Quatis', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.233751', 'I');
INSERT INTO historico.municipio VALUES (3234, 'Queimados', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.234722', 'I');
INSERT INTO historico.municipio VALUES (3235, 'Quissama', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.235676', 'I');
INSERT INTO historico.municipio VALUES (3236, 'Resende', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.236633', 'I');
INSERT INTO historico.municipio VALUES (3237, 'Rio Bonito', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.238008', 'I');
INSERT INTO historico.municipio VALUES (3238, 'Rio Claro', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.238923', 'I');
INSERT INTO historico.municipio VALUES (3239, 'Rio das Flores', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.239799', 'I');
INSERT INTO historico.municipio VALUES (3240, 'Rio das Ostras', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.24067', 'I');
INSERT INTO historico.municipio VALUES (3241, 'Rio de Janeiro', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.241514', 'I');
INSERT INTO historico.municipio VALUES (3242, 'Santa Maria Madalena', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.242392', 'I');
INSERT INTO historico.municipio VALUES (3243, 'Santo Antonio de Padua', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.24326', 'I');
INSERT INTO historico.municipio VALUES (3245, 'Sao Francisco de Itabapoana', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.244999', 'I');
INSERT INTO historico.municipio VALUES (3244, 'Sao Fidelis', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.244209', 'I');
INSERT INTO historico.municipio VALUES (3246, 'Sao Goncalo', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.245904', 'I');
INSERT INTO historico.municipio VALUES (3247, 'Sao Joao da Barra', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.24683', 'I');
INSERT INTO historico.municipio VALUES (3248, 'Sao Joao de Meriti', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.24777', 'I');
INSERT INTO historico.municipio VALUES (3249, 'Sao Jose de Uba', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.248945', 'I');
INSERT INTO historico.municipio VALUES (3250, 'Sao Jose do Vale do Rio Preto', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.249825', 'I');
INSERT INTO historico.municipio VALUES (3251, 'Sao Pedro da Aldeia', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.250587', 'I');
INSERT INTO historico.municipio VALUES (3252, 'Sao Sebastiao do Alto', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.251419', 'I');
INSERT INTO historico.municipio VALUES (3253, 'Sapucaia', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.252236', 'I');
INSERT INTO historico.municipio VALUES (3254, 'Saquarema', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.253149', 'I');
INSERT INTO historico.municipio VALUES (3255, 'Seropedica', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.254076', 'I');
INSERT INTO historico.municipio VALUES (3256, 'Silva Jardim', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.254876', 'I');
INSERT INTO historico.municipio VALUES (3257, 'Sumidouro', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.255796', 'I');
INSERT INTO historico.municipio VALUES (3258, 'Tangua', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.256693', 'I');
INSERT INTO historico.municipio VALUES (3259, 'Teresopolis', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.257579', 'I');
INSERT INTO historico.municipio VALUES (3261, 'Tres Rios', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.259558', 'I');
INSERT INTO historico.municipio VALUES (3262, 'Valenca', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.260357', 'I');
INSERT INTO historico.municipio VALUES (3263, 'Varre-sai', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.261201', 'I');
INSERT INTO historico.municipio VALUES (3264, 'Vassouras', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.262061', 'I');
INSERT INTO historico.municipio VALUES (3265, 'Volta Redonda', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.268581', 'I');
INSERT INTO historico.municipio VALUES (3266, 'Adamantina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.269835', 'I');
INSERT INTO historico.municipio VALUES (3267, 'Adolfo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.27087', 'I');
INSERT INTO historico.municipio VALUES (3268, 'Aguai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.27173', 'I');
INSERT INTO historico.municipio VALUES (3269, 'Aguas da Prata', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.272445', 'I');
INSERT INTO historico.municipio VALUES (3270, 'Aguas de Lindoia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.273402', 'I');
INSERT INTO historico.municipio VALUES (3271, 'Aguas de Santa Barbara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.274253', 'I');
INSERT INTO historico.municipio VALUES (3272, 'Aguas de Sao Pedro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.275125', 'I');
INSERT INTO historico.municipio VALUES (3273, 'Agudos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.276017', 'I');
INSERT INTO historico.municipio VALUES (3274, 'Alambari', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.276922', 'I');
INSERT INTO historico.municipio VALUES (3275, 'Alfredo Marcondes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.277864', 'I');
INSERT INTO historico.municipio VALUES (3276, 'Altair', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.278774', 'I');
INSERT INTO historico.municipio VALUES (3277, 'Altinopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.279605', 'I');
INSERT INTO historico.municipio VALUES (3278, 'Alto Alegre', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.280491', 'I');
INSERT INTO historico.municipio VALUES (3279, 'Aluminio', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.281409', 'I');
INSERT INTO historico.municipio VALUES (3280, 'Alvares Florence', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.282369', 'I');
INSERT INTO historico.municipio VALUES (3281, 'Alvares Machado', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.283238', 'I');
INSERT INTO historico.municipio VALUES (3282, 'Alvaro de Carvalho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.284169', 'I');
INSERT INTO historico.municipio VALUES (3283, 'Alvinlandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.285077', 'I');
INSERT INTO historico.municipio VALUES (3284, 'Americana', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.286013', 'I');
INSERT INTO historico.municipio VALUES (3285, 'Americo Brasiliense', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.286803', 'I');
INSERT INTO historico.municipio VALUES (3286, 'Americo de Campos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.287738', 'I');
INSERT INTO historico.municipio VALUES (3287, 'Amparo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.288607', 'I');
INSERT INTO historico.municipio VALUES (3288, 'Analandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.2895', 'I');
INSERT INTO historico.municipio VALUES (3289, 'Andradina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.290456', 'I');
INSERT INTO historico.municipio VALUES (3290, 'Angatuba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.291244', 'I');
INSERT INTO historico.municipio VALUES (3291, 'Anhembi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.29216', 'I');
INSERT INTO historico.municipio VALUES (3292, 'Anhumas', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.293119', 'I');
INSERT INTO historico.municipio VALUES (3293, 'Aparecida', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.293914', 'I');
INSERT INTO historico.municipio VALUES (3294, 'Aparecida D''oeste', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.294812', 'I');
INSERT INTO historico.municipio VALUES (3295, 'Apiai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.295701', 'I');
INSERT INTO historico.municipio VALUES (3296, 'Aracariguama', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.29661', 'I');
INSERT INTO historico.municipio VALUES (3297, 'Aracatuba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.297483', 'I');
INSERT INTO historico.municipio VALUES (3298, 'Aracoiaba da Serra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.298305', 'I');
INSERT INTO historico.municipio VALUES (3299, 'Aramina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.299187', 'I');
INSERT INTO historico.municipio VALUES (3300, 'Arandu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.299986', 'I');
INSERT INTO historico.municipio VALUES (3301, 'Arapei', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.300898', 'I');
INSERT INTO historico.municipio VALUES (3302, 'Araraquara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.301802', 'I');
INSERT INTO historico.municipio VALUES (3303, 'Araras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.308817', 'I');
INSERT INTO historico.municipio VALUES (3304, 'Arco-iris', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.31001', 'I');
INSERT INTO historico.municipio VALUES (3305, 'Arealva', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.311055', 'I');
INSERT INTO historico.municipio VALUES (3306, 'Areias', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.31192', 'I');
INSERT INTO historico.municipio VALUES (3307, 'Areiopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.312751', 'I');
INSERT INTO historico.municipio VALUES (3308, 'Ariranha', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.313577', 'I');
INSERT INTO historico.municipio VALUES (3309, 'Artur Nogueira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.314489', 'I');
INSERT INTO historico.municipio VALUES (3310, 'Aruja', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.315495', 'I');
INSERT INTO historico.municipio VALUES (3311, 'Aspasia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.316308', 'I');
INSERT INTO historico.municipio VALUES (3312, 'Assis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.317358', 'I');
INSERT INTO historico.municipio VALUES (3313, 'Atibaia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.318277', 'I');
INSERT INTO historico.municipio VALUES (3314, 'Auriflama', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.319244', 'I');
INSERT INTO historico.municipio VALUES (3315, 'Avai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.320115', 'I');
INSERT INTO historico.municipio VALUES (3316, 'Avanhandava', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.320988', 'I');
INSERT INTO historico.municipio VALUES (3317, 'Avare', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.321877', 'I');
INSERT INTO historico.municipio VALUES (3318, 'Bady Bassitt', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.322788', 'I');
INSERT INTO historico.municipio VALUES (3319, 'Balbinos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.32373', 'I');
INSERT INTO historico.municipio VALUES (3320, 'Balsamo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.324586', 'I');
INSERT INTO historico.municipio VALUES (3321, 'Bananal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.325482', 'I');
INSERT INTO historico.municipio VALUES (3322, 'Barao de Antonina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.326512', 'I');
INSERT INTO historico.municipio VALUES (3323, 'Barbosa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.327365', 'I');
INSERT INTO historico.municipio VALUES (3324, 'Bariri', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.328252', 'I');
INSERT INTO historico.municipio VALUES (3325, 'Barra Bonita', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.329113', 'I');
INSERT INTO historico.municipio VALUES (3326, 'Barra do Chapeu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.329955', 'I');
INSERT INTO historico.municipio VALUES (3327, 'Barra do Turvo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.330965', 'I');
INSERT INTO historico.municipio VALUES (3328, 'Barretos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.331935', 'I');
INSERT INTO historico.municipio VALUES (3329, 'Barrinha', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.332765', 'I');
INSERT INTO historico.municipio VALUES (3330, 'Barueri', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.333592', 'I');
INSERT INTO historico.municipio VALUES (3331, 'Bastos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.334547', 'I');
INSERT INTO historico.municipio VALUES (3332, 'Batatais', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.33538', 'I');
INSERT INTO historico.municipio VALUES (3333, 'Bauru', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.336251', 'I');
INSERT INTO historico.municipio VALUES (3334, 'Bebedouro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.337171', 'I');
INSERT INTO historico.municipio VALUES (3335, 'Bento de Abreu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.338264', 'I');
INSERT INTO historico.municipio VALUES (3336, 'Bernardino de Campos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.339179', 'I');
INSERT INTO historico.municipio VALUES (3337, 'Bertioga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.340015', 'I');
INSERT INTO historico.municipio VALUES (3338, 'Bilac', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.340826', 'I');
INSERT INTO historico.municipio VALUES (3339, 'Birigui', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.341697', 'I');
INSERT INTO historico.municipio VALUES (3340, 'Biritiba-mirim', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.342549', 'I');
INSERT INTO historico.municipio VALUES (3341, 'Boa Esperanca do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.350287', 'I');
INSERT INTO historico.municipio VALUES (3342, 'Bocaina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.351429', 'I');
INSERT INTO historico.municipio VALUES (3343, 'Bofete', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.352408', 'I');
INSERT INTO historico.municipio VALUES (3344, 'Boituva', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.353564', 'I');
INSERT INTO historico.municipio VALUES (3345, 'Bom Jesus dos Perdoes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.354421', 'I');
INSERT INTO historico.municipio VALUES (3346, 'Bom Sucesso de Itarare', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.355449', 'I');
INSERT INTO historico.municipio VALUES (3347, 'Bora', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.356379', 'I');
INSERT INTO historico.municipio VALUES (3348, 'Boraceia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.357481', 'I');
INSERT INTO historico.municipio VALUES (3349, 'Borborema', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.358426', 'I');
INSERT INTO historico.municipio VALUES (3350, 'Borebi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.359296', 'I');
INSERT INTO historico.municipio VALUES (3351, 'Botucatu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.360376', 'I');
INSERT INTO historico.municipio VALUES (3352, 'Braganca Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.361423', 'I');
INSERT INTO historico.municipio VALUES (3353, 'Brauna', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.362273', 'I');
INSERT INTO historico.municipio VALUES (3354, 'Brejo Alegre', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.363155', 'I');
INSERT INTO historico.municipio VALUES (3355, 'Brodowski', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.364124', 'I');
INSERT INTO historico.municipio VALUES (3356, 'Brotas', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.365052', 'I');
INSERT INTO historico.municipio VALUES (3357, 'Buri', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.366004', 'I');
INSERT INTO historico.municipio VALUES (3358, 'Buritama', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.366945', 'I');
INSERT INTO historico.municipio VALUES (3359, 'Buritizal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.367895', 'I');
INSERT INTO historico.municipio VALUES (3360, 'Cabralia Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.368816', 'I');
INSERT INTO historico.municipio VALUES (3361, 'Cabreuva', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.369719', 'I');
INSERT INTO historico.municipio VALUES (3362, 'Cacapava', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.370627', 'I');
INSERT INTO historico.municipio VALUES (3363, 'Cachoeira Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.371763', 'I');
INSERT INTO historico.municipio VALUES (3364, 'Caconde', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.372711', 'I');
INSERT INTO historico.municipio VALUES (3365, 'Cafelandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.373562', 'I');
INSERT INTO historico.municipio VALUES (3366, 'Caiabu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.374476', 'I');
INSERT INTO historico.municipio VALUES (3367, 'Caieiras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.375453', 'I');
INSERT INTO historico.municipio VALUES (3368, 'Caiua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.37635', 'I');
INSERT INTO historico.municipio VALUES (3369, 'Cajamar', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.377277', 'I');
INSERT INTO historico.municipio VALUES (3370, 'Cajati', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.378209', 'I');
INSERT INTO historico.municipio VALUES (3371, 'Cajobi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.379165', 'I');
INSERT INTO historico.municipio VALUES (3372, 'Cajuru', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.380188', 'I');
INSERT INTO historico.municipio VALUES (3373, 'Campina do Monte Alegre', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.381138', 'I');
INSERT INTO historico.municipio VALUES (3374, 'Campinas', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.381967', 'I');
INSERT INTO historico.municipio VALUES (3375, 'Campo Limpo Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.382892', 'I');
INSERT INTO historico.municipio VALUES (3376, 'Campos do Jordao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.384015', 'I');
INSERT INTO historico.municipio VALUES (3377, 'Campos Novos Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.390894', 'I');
INSERT INTO historico.municipio VALUES (3378, 'Cananeia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.392104', 'I');
INSERT INTO historico.municipio VALUES (3379, 'Canas', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.393199', 'I');
INSERT INTO historico.municipio VALUES (3380, 'Candido Mota', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.394055', 'I');
INSERT INTO historico.municipio VALUES (3381, 'Candido Rodrigues', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.39493', 'I');
INSERT INTO historico.municipio VALUES (3382, 'Canitar', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.395858', 'I');
INSERT INTO historico.municipio VALUES (3383, 'Capao Bonito', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.39675', 'I');
INSERT INTO historico.municipio VALUES (3384, 'Capela do Alto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.397713', 'I');
INSERT INTO historico.municipio VALUES (3385, 'Capivari', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.398691', 'I');
INSERT INTO historico.municipio VALUES (3386, 'Caraguatatuba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.399692', 'I');
INSERT INTO historico.municipio VALUES (3387, 'Carapicuiba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.400634', 'I');
INSERT INTO historico.municipio VALUES (3388, 'Cardoso', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.401562', 'I');
INSERT INTO historico.municipio VALUES (3389, 'Casa Branca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.40251', 'I');
INSERT INTO historico.municipio VALUES (3390, 'Cassia dos Coqueiros', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.403415', 'I');
INSERT INTO historico.municipio VALUES (3391, 'Castilho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.4044', 'I');
INSERT INTO historico.municipio VALUES (3392, 'Catanduva', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.405192', 'I');
INSERT INTO historico.municipio VALUES (3393, 'Catigua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.406069', 'I');
INSERT INTO historico.municipio VALUES (3394, 'Cedral', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.407007', 'I');
INSERT INTO historico.municipio VALUES (3395, 'Cerqueira Cesar', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.407879', 'I');
INSERT INTO historico.municipio VALUES (3396, 'Cerquilho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.408712', 'I');
INSERT INTO historico.municipio VALUES (3397, 'Cesario Lange', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.409578', 'I');
INSERT INTO historico.municipio VALUES (3398, 'Charqueada', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.410493', 'I');
INSERT INTO historico.municipio VALUES (3400, 'Clementina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.412407', 'I');
INSERT INTO historico.municipio VALUES (3401, 'Colina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.413332', 'I');
INSERT INTO historico.municipio VALUES (3402, 'Colombia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.41435', 'I');
INSERT INTO historico.municipio VALUES (3403, 'Conchal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.415259', 'I');
INSERT INTO historico.municipio VALUES (3404, 'Conchas', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.416408', 'I');
INSERT INTO historico.municipio VALUES (3405, 'Cordeiropolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.417364', 'I');
INSERT INTO historico.municipio VALUES (3406, 'Coroados', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.418209', 'I');
INSERT INTO historico.municipio VALUES (3407, 'Coronel Macedo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.41912', 'I');
INSERT INTO historico.municipio VALUES (3408, 'Corumbatai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.420001', 'I');
INSERT INTO historico.municipio VALUES (3409, 'Cosmopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.420964', 'I');
INSERT INTO historico.municipio VALUES (3410, 'Cosmorama', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.421879', 'I');
INSERT INTO historico.municipio VALUES (3411, 'Cotia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.422822', 'I');
INSERT INTO historico.municipio VALUES (3412, 'Cravinhos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.423659', 'I');
INSERT INTO historico.municipio VALUES (3413, 'Cristais Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.424565', 'I');
INSERT INTO historico.municipio VALUES (3414, 'Cruzalia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.433202', 'I');
INSERT INTO historico.municipio VALUES (3415, 'Cruzeiro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.43419', 'I');
INSERT INTO historico.municipio VALUES (3416, 'Cubatao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.435124', 'I');
INSERT INTO historico.municipio VALUES (3417, 'Cunha', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.436005', 'I');
INSERT INTO historico.municipio VALUES (3418, 'Descalvado', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.436909', 'I');
INSERT INTO historico.municipio VALUES (3419, 'Diadema', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.43802', 'I');
INSERT INTO historico.municipio VALUES (3420, 'Dirce Reis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.438961', 'I');
INSERT INTO historico.municipio VALUES (3421, 'Divinolandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.439881', 'I');
INSERT INTO historico.municipio VALUES (3422, 'Dobrada', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.44092', 'I');
INSERT INTO historico.municipio VALUES (3423, 'Dois Corregos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.441834', 'I');
INSERT INTO historico.municipio VALUES (3424, 'Dolcinopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.442609', 'I');
INSERT INTO historico.municipio VALUES (3425, 'Dourado', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.443543', 'I');
INSERT INTO historico.municipio VALUES (3426, 'Dracena', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.444476', 'I');
INSERT INTO historico.municipio VALUES (3427, 'Duartina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.445394', 'I');
INSERT INTO historico.municipio VALUES (3428, 'Dumont', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.44637', 'I');
INSERT INTO historico.municipio VALUES (3429, 'Echapora', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.447249', 'I');
INSERT INTO historico.municipio VALUES (3430, 'Eldorado', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.448152', 'I');
INSERT INTO historico.municipio VALUES (3431, 'Elias Fausto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.449197', 'I');
INSERT INTO historico.municipio VALUES (3432, 'Elisiario', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.450013', 'I');
INSERT INTO historico.municipio VALUES (3433, 'Embauba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.450854', 'I');
INSERT INTO historico.municipio VALUES (3435, 'Embu-guacu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.452864', 'I');
INSERT INTO historico.municipio VALUES (3436, 'Emilianopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.453877', 'I');
INSERT INTO historico.municipio VALUES (3437, 'Engenheiro Coelho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.454824', 'I');
INSERT INTO historico.municipio VALUES (3438, 'Espirito Santo do Pinhal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.455702', 'I');
INSERT INTO historico.municipio VALUES (3439, 'Espirito Santo do Turvo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.456596', 'I');
INSERT INTO historico.municipio VALUES (3442, 'Estrela D''oeste', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.464626', 'I');
INSERT INTO historico.municipio VALUES (3441, 'Estrela do Norte', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.463187', 'I');
INSERT INTO historico.municipio VALUES (3443, 'Euclides da Cunha Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.465815', 'I');
INSERT INTO historico.municipio VALUES (3444, 'Fartura', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.467149', 'I');
INSERT INTO historico.municipio VALUES (3446, 'Fernandopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.474339', 'I');
INSERT INTO historico.municipio VALUES (3445, 'Fernando Prestes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.468296', 'I');
INSERT INTO historico.municipio VALUES (3447, 'Fernao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.475403', 'I');
INSERT INTO historico.municipio VALUES (3448, 'Ferraz de Vasconcelos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.476418', 'I');
INSERT INTO historico.municipio VALUES (3449, 'Flora Rica', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.477443', 'I');
INSERT INTO historico.municipio VALUES (3450, 'Floreal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.478415', 'I');
INSERT INTO historico.municipio VALUES (3451, 'Florida Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.479622', 'I');
INSERT INTO historico.municipio VALUES (3452, 'Florinia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.480544', 'I');
INSERT INTO historico.municipio VALUES (3453, 'Franca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.481469', 'I');
INSERT INTO historico.municipio VALUES (3454, 'Francisco Morato', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.482394', 'I');
INSERT INTO historico.municipio VALUES (3455, 'Franco da Rocha', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.483499', 'I');
INSERT INTO historico.municipio VALUES (3456, 'Gabriel Monteiro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.484411', 'I');
INSERT INTO historico.municipio VALUES (3457, 'Galia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.485277', 'I');
INSERT INTO historico.municipio VALUES (3458, 'Garca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.486137', 'I');
INSERT INTO historico.municipio VALUES (3459, 'Gastao Vidigal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.487262', 'I');
INSERT INTO historico.municipio VALUES (3460, 'Gaviao Peixoto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.488275', 'I');
INSERT INTO historico.municipio VALUES (3461, 'General Salgado', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.489182', 'I');
INSERT INTO historico.municipio VALUES (3462, 'Getulina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.490105', 'I');
INSERT INTO historico.municipio VALUES (3463, 'Glicerio', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.491081', 'I');
INSERT INTO historico.municipio VALUES (3464, 'Guaicara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.49205', 'I');
INSERT INTO historico.municipio VALUES (3465, 'Guaimbe', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.492981', 'I');
INSERT INTO historico.municipio VALUES (3466, 'Guaira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.493861', 'I');
INSERT INTO historico.municipio VALUES (3467, 'Guapiacu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.494824', 'I');
INSERT INTO historico.municipio VALUES (3468, 'Guapiara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.495711', 'I');
INSERT INTO historico.municipio VALUES (3469, 'Guara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.49662', 'I');
INSERT INTO historico.municipio VALUES (3470, 'Guaracai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.497498', 'I');
INSERT INTO historico.municipio VALUES (3471, 'Guaraci', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.498609', 'I');
INSERT INTO historico.municipio VALUES (3472, 'Guarani D''oeste', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.499582', 'I');
INSERT INTO historico.municipio VALUES (3473, 'Guaranta', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.500522', 'I');
INSERT INTO historico.municipio VALUES (3474, 'Guararapes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.501478', 'I');
INSERT INTO historico.municipio VALUES (3475, 'Guararema', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.502457', 'I');
INSERT INTO historico.municipio VALUES (3476, 'Guaratingueta', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.503375', 'I');
INSERT INTO historico.municipio VALUES (3477, 'Guarei', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.504252', 'I');
INSERT INTO historico.municipio VALUES (3478, 'Guariba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.50542', 'I');
INSERT INTO historico.municipio VALUES (3479, 'Guaruja', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.506355', 'I');
INSERT INTO historico.municipio VALUES (3480, 'Guarulhos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.50736', 'I');
INSERT INTO historico.municipio VALUES (3481, 'Guatapara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.514491', 'I');
INSERT INTO historico.municipio VALUES (3482, 'Guzolandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.51563', 'I');
INSERT INTO historico.municipio VALUES (3483, 'Herculandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.516787', 'I');
INSERT INTO historico.municipio VALUES (3484, 'Holambra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.517506', 'I');
INSERT INTO historico.municipio VALUES (3485, 'Hortolandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.518326', 'I');
INSERT INTO historico.municipio VALUES (3486, 'Iacanga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.519603', 'I');
INSERT INTO historico.municipio VALUES (3487, 'Iacri', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.520661', 'I');
INSERT INTO historico.municipio VALUES (3488, 'Iaras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.521549', 'I');
INSERT INTO historico.municipio VALUES (3489, 'Ibate', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.522424', 'I');
INSERT INTO historico.municipio VALUES (3490, 'Ibira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.52329', 'I');
INSERT INTO historico.municipio VALUES (3491, 'Ibirarema', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.524224', 'I');
INSERT INTO historico.municipio VALUES (3492, 'Ibitinga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.525141', 'I');
INSERT INTO historico.municipio VALUES (3493, 'Ibiuna', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.526048', 'I');
INSERT INTO historico.municipio VALUES (3494, 'Icem', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.526892', 'I');
INSERT INTO historico.municipio VALUES (3495, 'Iepe', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.527707', 'I');
INSERT INTO historico.municipio VALUES (3496, 'Igaracu do Tiete', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.528553', 'I');
INSERT INTO historico.municipio VALUES (3497, 'Igarapava', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.5295', 'I');
INSERT INTO historico.municipio VALUES (3498, 'Igarata', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.530465', 'I');
INSERT INTO historico.municipio VALUES (3499, 'Iguape', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.531632', 'I');
INSERT INTO historico.municipio VALUES (3502, 'Ilhabela', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.534591', 'I');
INSERT INTO historico.municipio VALUES (3500, 'Ilha Comprida', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.532647', 'I');
INSERT INTO historico.municipio VALUES (3501, 'Ilha Solteira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.533656', 'I');
INSERT INTO historico.municipio VALUES (3503, 'Indaiatuba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.53556', 'I');
INSERT INTO historico.municipio VALUES (3504, 'Indiana', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.536463', 'I');
INSERT INTO historico.municipio VALUES (3505, 'Indiapora', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.537406', 'I');
INSERT INTO historico.municipio VALUES (3506, 'Inubia Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.538346', 'I');
INSERT INTO historico.municipio VALUES (3507, 'Ipaussu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.539122', 'I');
INSERT INTO historico.municipio VALUES (3508, 'Ipero', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.540114', 'I');
INSERT INTO historico.municipio VALUES (3509, 'Ipeuna', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.54106', 'I');
INSERT INTO historico.municipio VALUES (3510, 'Ipigua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.542009', 'I');
INSERT INTO historico.municipio VALUES (3511, 'Iporanga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.542934', 'I');
INSERT INTO historico.municipio VALUES (3512, 'Ipua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.543761', 'I');
INSERT INTO historico.municipio VALUES (3513, 'Iracemapolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.544853', 'I');
INSERT INTO historico.municipio VALUES (3514, 'Irapua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.545807', 'I');
INSERT INTO historico.municipio VALUES (3515, 'Irapuru', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.546727', 'I');
INSERT INTO historico.municipio VALUES (3516, 'Itabera', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.54776', 'I');
INSERT INTO historico.municipio VALUES (3517, 'Itai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.555415', 'I');
INSERT INTO historico.municipio VALUES (3518, 'Itajobi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.556639', 'I');
INSERT INTO historico.municipio VALUES (3519, 'Itaju', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.557538', 'I');
INSERT INTO historico.municipio VALUES (3520, 'Itanhaem', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.558368', 'I');
INSERT INTO historico.municipio VALUES (3521, 'Itaoca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.559349', 'I');
INSERT INTO historico.municipio VALUES (3522, 'Itapecerica da Serra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.560304', 'I');
INSERT INTO historico.municipio VALUES (3523, 'Itapetininga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.561226', 'I');
INSERT INTO historico.municipio VALUES (3524, 'Itapeva', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.562042', 'I');
INSERT INTO historico.municipio VALUES (3525, 'Itapevi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.563', 'I');
INSERT INTO historico.municipio VALUES (3526, 'Itapira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.564035', 'I');
INSERT INTO historico.municipio VALUES (3527, 'Itapirapua Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.564976', 'I');
INSERT INTO historico.municipio VALUES (3528, 'Itapolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.565875', 'I');
INSERT INTO historico.municipio VALUES (3529, 'Itaporanga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.566665', 'I');
INSERT INTO historico.municipio VALUES (3530, 'Itapui', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.567469', 'I');
INSERT INTO historico.municipio VALUES (3531, 'Itapura', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.568248', 'I');
INSERT INTO historico.municipio VALUES (3532, 'Itaquaquecetuba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.569268', 'I');
INSERT INTO historico.municipio VALUES (3533, 'Itarare', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.570327', 'I');
INSERT INTO historico.municipio VALUES (3534, 'Itariri', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.571116', 'I');
INSERT INTO historico.municipio VALUES (3535, 'Itatiba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.572068', 'I');
INSERT INTO historico.municipio VALUES (3536, 'Itatinga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.572867', 'I');
INSERT INTO historico.municipio VALUES (3537, 'Itirapina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.57366', 'I');
INSERT INTO historico.municipio VALUES (3538, 'Itirapua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.574547', 'I');
INSERT INTO historico.municipio VALUES (3539, 'Itobi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.57546', 'I');
INSERT INTO historico.municipio VALUES (3540, 'Itu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.576321', 'I');
INSERT INTO historico.municipio VALUES (3541, 'Itupeva', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.577536', 'I');
INSERT INTO historico.municipio VALUES (3542, 'Ituverava', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.578426', 'I');
INSERT INTO historico.municipio VALUES (3543, 'Jaborandi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.579392', 'I');
INSERT INTO historico.municipio VALUES (3544, 'Jaboticabal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.58031', 'I');
INSERT INTO historico.municipio VALUES (3545, 'Jacarei', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.581242', 'I');
INSERT INTO historico.municipio VALUES (3546, 'Jaci', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.582181', 'I');
INSERT INTO historico.municipio VALUES (3547, 'Jacupiranga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.583183', 'I');
INSERT INTO historico.municipio VALUES (3548, 'Jaguariuna', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.583988', 'I');
INSERT INTO historico.municipio VALUES (3549, 'Jales', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.584901', 'I');
INSERT INTO historico.municipio VALUES (3550, 'Jambeiro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.585854', 'I');
INSERT INTO historico.municipio VALUES (3551, 'Jandira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.586757', 'I');
INSERT INTO historico.municipio VALUES (3552, 'Jardinopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.587586', 'I');
INSERT INTO historico.municipio VALUES (3553, 'Jarinu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.588515', 'I');
INSERT INTO historico.municipio VALUES (3554, 'Jau', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.589433', 'I');
INSERT INTO historico.municipio VALUES (3555, 'Jeriquara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.590483', 'I');
INSERT INTO historico.municipio VALUES (3556, 'Joanopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.596351', 'I');
INSERT INTO historico.municipio VALUES (3557, 'Joao Ramalho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.597603', 'I');
INSERT INTO historico.municipio VALUES (3558, 'Jose Bonifacio', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.59875', 'I');
INSERT INTO historico.municipio VALUES (3559, 'Julio Mesquita', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.599726', 'I');
INSERT INTO historico.municipio VALUES (3560, 'Jumirim', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.600794', 'I');
INSERT INTO historico.municipio VALUES (3561, 'Jundiai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.601706', 'I');
INSERT INTO historico.municipio VALUES (3562, 'Junqueiropolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.602591', 'I');
INSERT INTO historico.municipio VALUES (3563, 'Juquia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.603635', 'I');
INSERT INTO historico.municipio VALUES (3564, 'Juquitiba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.604582', 'I');
INSERT INTO historico.municipio VALUES (3565, 'Lagoinha', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.605474', 'I');
INSERT INTO historico.municipio VALUES (3566, 'Laranjal Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.607194', 'I');
INSERT INTO historico.municipio VALUES (3567, 'Lavinia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.608188', 'I');
INSERT INTO historico.municipio VALUES (3568, 'Lavrinhas', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.60912', 'I');
INSERT INTO historico.municipio VALUES (3569, 'Leme', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.609957', 'I');
INSERT INTO historico.municipio VALUES (3570, 'Lencois Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.611063', 'I');
INSERT INTO historico.municipio VALUES (3571, 'Limeira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.612034', 'I');
INSERT INTO historico.municipio VALUES (3572, 'Lindoia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.613045', 'I');
INSERT INTO historico.municipio VALUES (3573, 'Lins', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.613865', 'I');
INSERT INTO historico.municipio VALUES (3574, 'Lorena', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.61467', 'I');
INSERT INTO historico.municipio VALUES (3575, 'Lourdes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.615605', 'I');
INSERT INTO historico.municipio VALUES (3576, 'Louveira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.616624', 'I');
INSERT INTO historico.municipio VALUES (3577, 'Lucelia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.617438', 'I');
INSERT INTO historico.municipio VALUES (3578, 'Lucianopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.618341', 'I');
INSERT INTO historico.municipio VALUES (3579, 'Luis Antonio', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.619193', 'I');
INSERT INTO historico.municipio VALUES (3580, 'Luiziania', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.620134', 'I');
INSERT INTO historico.municipio VALUES (3581, 'Lupercio', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.621094', 'I');
INSERT INTO historico.municipio VALUES (3582, 'Lutecia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.62201', 'I');
INSERT INTO historico.municipio VALUES (3583, 'Macatuba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.622926', 'I');
INSERT INTO historico.municipio VALUES (3584, 'Macaubal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.623778', 'I');
INSERT INTO historico.municipio VALUES (3585, 'Macedonia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.624723', 'I');
INSERT INTO historico.municipio VALUES (3586, 'Magda', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.625616', 'I');
INSERT INTO historico.municipio VALUES (3587, 'Mairinque', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.62654', 'I');
INSERT INTO historico.municipio VALUES (3588, 'Mairipora', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.627638', 'I');
INSERT INTO historico.municipio VALUES (3589, 'Manduri', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.628439', 'I');
INSERT INTO historico.municipio VALUES (3590, 'Maraba Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.629383', 'I');
INSERT INTO historico.municipio VALUES (3591, 'Maracai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.636541', 'I');
INSERT INTO historico.municipio VALUES (3592, 'Marapoama', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.63785', 'I');
INSERT INTO historico.municipio VALUES (3593, 'Mariapolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.638856', 'I');
INSERT INTO historico.municipio VALUES (3594, 'Marilia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.639554', 'I');
INSERT INTO historico.municipio VALUES (3595, 'Marinopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.640522', 'I');
INSERT INTO historico.municipio VALUES (3596, 'Martinopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.641428', 'I');
INSERT INTO historico.municipio VALUES (3597, 'Matao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.642269', 'I');
INSERT INTO historico.municipio VALUES (3598, 'Maua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.643236', 'I');
INSERT INTO historico.municipio VALUES (3599, 'Mendonca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.644256', 'I');
INSERT INTO historico.municipio VALUES (3600, 'Meridiano', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.645169', 'I');
INSERT INTO historico.municipio VALUES (3601, 'Mesopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.64605', 'I');
INSERT INTO historico.municipio VALUES (3602, 'Miguelopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.646934', 'I');
INSERT INTO historico.municipio VALUES (3603, 'Mineiros do Tiete', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.647811', 'I');
INSERT INTO historico.municipio VALUES (3605, 'Miracatu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.649539', 'I');
INSERT INTO historico.municipio VALUES (3604, 'Mira Estrela', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.648659', 'I');
INSERT INTO historico.municipio VALUES (3606, 'Mirandopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.650507', 'I');
INSERT INTO historico.municipio VALUES (3607, 'Mirante do Paranapanema', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.651428', 'I');
INSERT INTO historico.municipio VALUES (3608, 'Mirassol', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.652283', 'I');
INSERT INTO historico.municipio VALUES (3609, 'Mirassolandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.653107', 'I');
INSERT INTO historico.municipio VALUES (3610, 'Mococa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.65403', 'I');
INSERT INTO historico.municipio VALUES (3611, 'Mogi das Cruzes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.654934', 'I');
INSERT INTO historico.municipio VALUES (3612, 'Mogi Guacu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.655912', 'I');
INSERT INTO historico.municipio VALUES (3614, 'Mombuca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.65768', 'I');
INSERT INTO historico.municipio VALUES (3615, 'Moncoes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.658653', 'I');
INSERT INTO historico.municipio VALUES (3616, 'Mongagua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.6595', 'I');
INSERT INTO historico.municipio VALUES (3617, 'Monte Alegre do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.66052', 'I');
INSERT INTO historico.municipio VALUES (3618, 'Monte Alto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.661636', 'I');
INSERT INTO historico.municipio VALUES (3619, 'Monte Aprazivel', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.662504', 'I');
INSERT INTO historico.municipio VALUES (3620, 'Monte Azul Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.663455', 'I');
INSERT INTO historico.municipio VALUES (3621, 'Monte Castelo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.664378', 'I');
INSERT INTO historico.municipio VALUES (3623, 'Monteiro Lobato', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.66621', 'I');
INSERT INTO historico.municipio VALUES (3622, 'Monte Mor', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.665291', 'I');
INSERT INTO historico.municipio VALUES (3624, 'Morro Agudo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.667129', 'I');
INSERT INTO historico.municipio VALUES (3625, 'Morungaba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.6681', 'I');
INSERT INTO historico.municipio VALUES (3626, 'Motuca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.669012', 'I');
INSERT INTO historico.municipio VALUES (3627, 'Murutinga do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.669991', 'I');
INSERT INTO historico.municipio VALUES (3628, 'Nantes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.677087', 'I');
INSERT INTO historico.municipio VALUES (3629, 'Narandiba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.678371', 'I');
INSERT INTO historico.municipio VALUES (3630, 'Natividade da Serra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.6794', 'I');
INSERT INTO historico.municipio VALUES (3631, 'Nazare Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.680367', 'I');
INSERT INTO historico.municipio VALUES (3632, 'Neves Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.681221', 'I');
INSERT INTO historico.municipio VALUES (3633, 'Nhandeara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.682247', 'I');
INSERT INTO historico.municipio VALUES (3634, 'Nipoa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.683209', 'I');
INSERT INTO historico.municipio VALUES (3635, 'Nova Alianca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.684071', 'I');
INSERT INTO historico.municipio VALUES (3636, 'Nova Campina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.685019', 'I');
INSERT INTO historico.municipio VALUES (3637, 'Nova Canaa Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.685923', 'I');
INSERT INTO historico.municipio VALUES (3638, 'Nova Castilho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.68688', 'I');
INSERT INTO historico.municipio VALUES (3639, 'Nova Europa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.687744', 'I');
INSERT INTO historico.municipio VALUES (3640, 'Nova Granada', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.688615', 'I');
INSERT INTO historico.municipio VALUES (3641, 'Nova Guataporanga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.689453', 'I');
INSERT INTO historico.municipio VALUES (3642, 'Nova Independencia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.69033', 'I');
INSERT INTO historico.municipio VALUES (3645, 'Novais', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.693025', 'I');
INSERT INTO historico.municipio VALUES (3643, 'Nova Luzitania', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.69125', 'I');
INSERT INTO historico.municipio VALUES (3644, 'Nova Odessa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.692148', 'I');
INSERT INTO historico.municipio VALUES (3646, 'Novo Horizonte', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.693881', 'I');
INSERT INTO historico.municipio VALUES (3647, 'Nuporanga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.694756', 'I');
INSERT INTO historico.municipio VALUES (3648, 'Ocaucu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.695695', 'I');
INSERT INTO historico.municipio VALUES (3649, 'Oleo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.696598', 'I');
INSERT INTO historico.municipio VALUES (3650, 'Olimpia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.697503', 'I');
INSERT INTO historico.municipio VALUES (3651, 'Onda Verde', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.698381', 'I');
INSERT INTO historico.municipio VALUES (3652, 'Oriente', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.699328', 'I');
INSERT INTO historico.municipio VALUES (3653, 'Orindiuva', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.700226', 'I');
INSERT INTO historico.municipio VALUES (3654, 'Orlandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.70113', 'I');
INSERT INTO historico.municipio VALUES (3655, 'Osasco', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.702113', 'I');
INSERT INTO historico.municipio VALUES (3656, 'Oscar Bressane', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.703017', 'I');
INSERT INTO historico.municipio VALUES (3657, 'Osvaldo Cruz', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.703902', 'I');
INSERT INTO historico.municipio VALUES (3658, 'Ourinhos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.704848', 'I');
INSERT INTO historico.municipio VALUES (3660, 'Ouroeste', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.706649', 'I');
INSERT INTO historico.municipio VALUES (3659, 'Ouro Verde', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.705842', 'I');
INSERT INTO historico.municipio VALUES (3661, 'Pacaembu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.707503', 'I');
INSERT INTO historico.municipio VALUES (3662, 'Palestina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.708316', 'I');
INSERT INTO historico.municipio VALUES (3663, 'Palmares Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.7091', 'I');
INSERT INTO historico.municipio VALUES (3664, 'Palmeira D''oeste', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.709909', 'I');
INSERT INTO historico.municipio VALUES (3665, 'Palmital', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.710909', 'I');
INSERT INTO historico.municipio VALUES (3666, 'Panorama', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.71165', 'I');
INSERT INTO historico.municipio VALUES (3667, 'Paraguacu Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.7191', 'I');
INSERT INTO historico.municipio VALUES (3668, 'Paraibuna', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.720228', 'I');
INSERT INTO historico.municipio VALUES (3669, 'Paraiso', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.721111', 'I');
INSERT INTO historico.municipio VALUES (3670, 'Paranapanema', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.722043', 'I');
INSERT INTO historico.municipio VALUES (3671, 'Paranapua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.72293', 'I');
INSERT INTO historico.municipio VALUES (3672, 'Parapua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.723768', 'I');
INSERT INTO historico.municipio VALUES (3673, 'Pardinho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.72461', 'I');
INSERT INTO historico.municipio VALUES (3674, 'Pariquera-acu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.725544', 'I');
INSERT INTO historico.municipio VALUES (3675, 'Parisi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.726416', 'I');
INSERT INTO historico.municipio VALUES (3676, 'Patrocinio Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.727324', 'I');
INSERT INTO historico.municipio VALUES (3677, 'Pauliceia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.728179', 'I');
INSERT INTO historico.municipio VALUES (3678, 'Paulinia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.729059', 'I');
INSERT INTO historico.municipio VALUES (3679, 'Paulistania', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.730037', 'I');
INSERT INTO historico.municipio VALUES (3680, 'Paulo de Faria', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.730894', 'I');
INSERT INTO historico.municipio VALUES (3681, 'Pederneiras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.731757', 'I');
INSERT INTO historico.municipio VALUES (3682, 'Pedra Bela', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.732587', 'I');
INSERT INTO historico.municipio VALUES (3683, 'Pedranopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.733429', 'I');
INSERT INTO historico.municipio VALUES (3684, 'Pedregulho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.73431', 'I');
INSERT INTO historico.municipio VALUES (3685, 'Pedreira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.735221', 'I');
INSERT INTO historico.municipio VALUES (3686, 'Pedrinhas Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.736151', 'I');
INSERT INTO historico.municipio VALUES (3687, 'Pedro de Toledo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.737085', 'I');
INSERT INTO historico.municipio VALUES (3688, 'Penapolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.738028', 'I');
INSERT INTO historico.municipio VALUES (3689, 'Pereira Barreto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.738983', 'I');
INSERT INTO historico.municipio VALUES (3690, 'Pereiras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.73982', 'I');
INSERT INTO historico.municipio VALUES (3691, 'Peruibe', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.740635', 'I');
INSERT INTO historico.municipio VALUES (3692, 'Piacatu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.741532', 'I');
INSERT INTO historico.municipio VALUES (3693, 'Piedade', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.742468', 'I');
INSERT INTO historico.municipio VALUES (3694, 'Pilar do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.743483', 'I');
INSERT INTO historico.municipio VALUES (3695, 'Pindamonhangaba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.744333', 'I');
INSERT INTO historico.municipio VALUES (3696, 'Pindorama', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.745185', 'I');
INSERT INTO historico.municipio VALUES (3697, 'Pinhalzinho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.746103', 'I');
INSERT INTO historico.municipio VALUES (3698, 'Piquerobi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.747239', 'I');
INSERT INTO historico.municipio VALUES (3699, 'Piquete', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.748177', 'I');
INSERT INTO historico.municipio VALUES (3700, 'Piracaia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.749108', 'I');
INSERT INTO historico.municipio VALUES (3701, 'Piracicaba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.750017', 'I');
INSERT INTO historico.municipio VALUES (3702, 'Piraju', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.751064', 'I');
INSERT INTO historico.municipio VALUES (3703, 'Pirajui', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.752015', 'I');
INSERT INTO historico.municipio VALUES (3704, 'Pirangi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.759139', 'I');
INSERT INTO historico.municipio VALUES (3705, 'Pirapora do Bom Jesus', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.760398', 'I');
INSERT INTO historico.municipio VALUES (3706, 'Pirapozinho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.761455', 'I');
INSERT INTO historico.municipio VALUES (3707, 'Pirassununga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.762332', 'I');
INSERT INTO historico.municipio VALUES (3708, 'Piratininga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.76325', 'I');
INSERT INTO historico.municipio VALUES (3709, 'Pitangueiras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.764242', 'I');
INSERT INTO historico.municipio VALUES (3710, 'Planalto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.76523', 'I');
INSERT INTO historico.municipio VALUES (3711, 'Platina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.766168', 'I');
INSERT INTO historico.municipio VALUES (3712, 'Poa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.767481', 'I');
INSERT INTO historico.municipio VALUES (3713, 'Poloni', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.768419', 'I');
INSERT INTO historico.municipio VALUES (3714, 'Pompeia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.769298', 'I');
INSERT INTO historico.municipio VALUES (3715, 'Pongai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.770243', 'I');
INSERT INTO historico.municipio VALUES (3716, 'Pontal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.771057', 'I');
INSERT INTO historico.municipio VALUES (3717, 'Pontalinda', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.772236', 'I');
INSERT INTO historico.municipio VALUES (3718, 'Pontes Gestal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.77305', 'I');
INSERT INTO historico.municipio VALUES (3719, 'Populina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.773915', 'I');
INSERT INTO historico.municipio VALUES (3720, 'Porangaba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.774851', 'I');
INSERT INTO historico.municipio VALUES (3721, 'Porto Feliz', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.77596', 'I');
INSERT INTO historico.municipio VALUES (3722, 'Porto Ferreira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.77695', 'I');
INSERT INTO historico.municipio VALUES (3723, 'Potim', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.777852', 'I');
INSERT INTO historico.municipio VALUES (3724, 'Potirendaba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.778757', 'I');
INSERT INTO historico.municipio VALUES (3725, 'Pracinha', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.779736', 'I');
INSERT INTO historico.municipio VALUES (3726, 'Pradopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.780653', 'I');
INSERT INTO historico.municipio VALUES (3727, 'Praia Grande', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.781557', 'I');
INSERT INTO historico.municipio VALUES (3728, 'Pratania', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.782464', 'I');
INSERT INTO historico.municipio VALUES (3729, 'Presidente Alves', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.783493', 'I');
INSERT INTO historico.municipio VALUES (3730, 'Presidente Bernardes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.784379', 'I');
INSERT INTO historico.municipio VALUES (3731, 'Presidente Epitacio', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.785224', 'I');
INSERT INTO historico.municipio VALUES (3732, 'Presidente Prudente', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.786107', 'I');
INSERT INTO historico.municipio VALUES (3733, 'Presidente Venceslau', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.786904', 'I');
INSERT INTO historico.municipio VALUES (3734, 'Promissao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.787815', 'I');
INSERT INTO historico.municipio VALUES (3735, 'Quadra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.788698', 'I');
INSERT INTO historico.municipio VALUES (3736, 'Quata', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.789628', 'I');
INSERT INTO historico.municipio VALUES (3737, 'Queiroz', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.790503', 'I');
INSERT INTO historico.municipio VALUES (3738, 'Queluz', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.791388', 'I');
INSERT INTO historico.municipio VALUES (3739, 'Quintana', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.792194', 'I');
INSERT INTO historico.municipio VALUES (3740, 'Rafard', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.799849', 'I');
INSERT INTO historico.municipio VALUES (3741, 'Rancharia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.801147', 'I');
INSERT INTO historico.municipio VALUES (3742, 'Redencao da Serra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.802051', 'I');
INSERT INTO historico.municipio VALUES (3743, 'Regente Feijo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.802929', 'I');
INSERT INTO historico.municipio VALUES (3744, 'Reginopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.80391', 'I');
INSERT INTO historico.municipio VALUES (3745, 'Registro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.804743', 'I');
INSERT INTO historico.municipio VALUES (3746, 'Restinga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.80577', 'I');
INSERT INTO historico.municipio VALUES (3747, 'Ribeira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.806596', 'I');
INSERT INTO historico.municipio VALUES (3748, 'Ribeirao Bonito', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.807499', 'I');
INSERT INTO historico.municipio VALUES (3749, 'Ribeirao Branco', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.808385', 'I');
INSERT INTO historico.municipio VALUES (3750, 'Ribeirao Corrente', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.809327', 'I');
INSERT INTO historico.municipio VALUES (3751, 'Ribeirao do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.810148', 'I');
INSERT INTO historico.municipio VALUES (3752, 'Ribeirao dos Indios', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.811033', 'I');
INSERT INTO historico.municipio VALUES (3753, 'Ribeirao Grande', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.811878', 'I');
INSERT INTO historico.municipio VALUES (3754, 'Ribeirao Pires', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.812751', 'I');
INSERT INTO historico.municipio VALUES (3755, 'Ribeirao Preto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.813744', 'I');
INSERT INTO historico.municipio VALUES (3763, 'Riversul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.821112', 'I');
INSERT INTO historico.municipio VALUES (3756, 'Rifaina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.814689', 'I');
INSERT INTO historico.municipio VALUES (3757, 'Rincao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.815604', 'I');
INSERT INTO historico.municipio VALUES (3758, 'Rinopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.81658', 'I');
INSERT INTO historico.municipio VALUES (3759, 'Rio Claro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.817501', 'I');
INSERT INTO historico.municipio VALUES (3760, 'Rio das Pedras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.8183', 'I');
INSERT INTO historico.municipio VALUES (3761, 'Rio Grande da Serra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.819205', 'I');
INSERT INTO historico.municipio VALUES (3762, 'Riolandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.820129', 'I');
INSERT INTO historico.municipio VALUES (3764, 'Rosana', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.822033', 'I');
INSERT INTO historico.municipio VALUES (3765, 'Roseira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.822953', 'I');
INSERT INTO historico.municipio VALUES (3766, 'Rubiacea', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.823779', 'I');
INSERT INTO historico.municipio VALUES (3767, 'Rubineia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.824722', 'I');
INSERT INTO historico.municipio VALUES (3768, 'Sabino', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.825716', 'I');
INSERT INTO historico.municipio VALUES (3769, 'Sagres', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.826657', 'I');
INSERT INTO historico.municipio VALUES (3770, 'Sales', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.827569', 'I');
INSERT INTO historico.municipio VALUES (3771, 'Sales Oliveira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.8286', 'I');
INSERT INTO historico.municipio VALUES (3772, 'Salesopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.829388', 'I');
INSERT INTO historico.municipio VALUES (3773, 'Salmourao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.830267', 'I');
INSERT INTO historico.municipio VALUES (3774, 'Saltinho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.831174', 'I');
INSERT INTO historico.municipio VALUES (3775, 'Salto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.832063', 'I');
INSERT INTO historico.municipio VALUES (3776, 'Salto de Pirapora', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.832983', 'I');
INSERT INTO historico.municipio VALUES (3777, 'Salto Grande', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.833872', 'I');
INSERT INTO historico.municipio VALUES (3778, 'Sandovalina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.841128', 'I');
INSERT INTO historico.municipio VALUES (3779, 'Santa Adelia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.842526', 'I');
INSERT INTO historico.municipio VALUES (3780, 'Santa Albertina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.843562', 'I');
INSERT INTO historico.municipio VALUES (3781, 'Santa Barbara D''oeste', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.844486', 'I');
INSERT INTO historico.municipio VALUES (3782, 'Santa Branca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.845468', 'I');
INSERT INTO historico.municipio VALUES (3783, 'Santa Clara D''oeste', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.846438', 'I');
INSERT INTO historico.municipio VALUES (3784, 'Santa Cruz da Conceicao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.847281', 'I');
INSERT INTO historico.municipio VALUES (3785, 'Santa Cruz da Esperanca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.848235', 'I');
INSERT INTO historico.municipio VALUES (3786, 'Santa Cruz das Palmeiras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.849206', 'I');
INSERT INTO historico.municipio VALUES (3787, 'Santa Cruz do Rio Pardo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.850133', 'I');
INSERT INTO historico.municipio VALUES (3788, 'Santa Ernestina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.851253', 'I');
INSERT INTO historico.municipio VALUES (3789, 'Santa Fe do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.852223', 'I');
INSERT INTO historico.municipio VALUES (3790, 'Santa Gertrudes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.853156', 'I');
INSERT INTO historico.municipio VALUES (3791, 'Santa Isabel', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.854113', 'I');
INSERT INTO historico.municipio VALUES (3792, 'Santa Lucia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.854982', 'I');
INSERT INTO historico.municipio VALUES (3793, 'Santa Maria da Serra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.85605', 'I');
INSERT INTO historico.municipio VALUES (3794, 'Santa Mercedes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.857003', 'I');
INSERT INTO historico.municipio VALUES (3799, 'Santana da Ponte Pensa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.861535', 'I');
INSERT INTO historico.municipio VALUES (3800, 'Santana de Parnaiba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.862612', 'I');
INSERT INTO historico.municipio VALUES (3796, 'Santa Rita D''oeste', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.85865', 'I');
INSERT INTO historico.municipio VALUES (3795, 'Santa Rita do Passa Quatro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.857824', 'I');
INSERT INTO historico.municipio VALUES (3797, 'Santa Rosa de Viterbo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.859396', 'I');
INSERT INTO historico.municipio VALUES (3798, 'Santa Salete', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.860312', 'I');
INSERT INTO historico.municipio VALUES (3801, 'Santo Anastacio', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.863652', 'I');
INSERT INTO historico.municipio VALUES (3802, 'Santo Andre', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.864564', 'I');
INSERT INTO historico.municipio VALUES (3803, 'Santo Antonio da Alegria', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.865523', 'I');
INSERT INTO historico.municipio VALUES (3804, 'Santo Antonio de Posse', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.866439', 'I');
INSERT INTO historico.municipio VALUES (3805, 'Santo Antonio do Aracangua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.867468', 'I');
INSERT INTO historico.municipio VALUES (3806, 'Santo Antonio do Jardim', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.868427', 'I');
INSERT INTO historico.municipio VALUES (3807, 'Santo Antonio do Pinhal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.869308', 'I');
INSERT INTO historico.municipio VALUES (3808, 'Santo Expedito', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.870137', 'I');
INSERT INTO historico.municipio VALUES (3809, 'Santopolis do Aguapei', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.871076', 'I');
INSERT INTO historico.municipio VALUES (3810, 'Santos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.872026', 'I');
INSERT INTO historico.municipio VALUES (3811, 'Sao Bento do Sapucai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.873071', 'I');
INSERT INTO historico.municipio VALUES (3812, 'Sao Bernardo do Campo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.873885', 'I');
INSERT INTO historico.municipio VALUES (3813, 'Sao Caetano do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.874902', 'I');
INSERT INTO historico.municipio VALUES (3814, 'Sao Carlos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.882174', 'I');
INSERT INTO historico.municipio VALUES (3815, 'Sao Francisco', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.883328', 'I');
INSERT INTO historico.municipio VALUES (3816, 'Sao Joao da Boa Vista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.884221', 'I');
INSERT INTO historico.municipio VALUES (3817, 'Sao Joao das Duas Pontes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.8851', 'I');
INSERT INTO historico.municipio VALUES (3818, 'Sao Joao de Iracema', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.885978', 'I');
INSERT INTO historico.municipio VALUES (3819, 'Sao Joao do Pau D''alho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.886912', 'I');
INSERT INTO historico.municipio VALUES (3820, 'Sao Joaquim da Barra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.88779', 'I');
INSERT INTO historico.municipio VALUES (3821, 'Sao Jose da Bela Vista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.888824', 'I');
INSERT INTO historico.municipio VALUES (3822, 'Sao Jose do Barreiro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.889708', 'I');
INSERT INTO historico.municipio VALUES (3823, 'Sao Jose do Rio Pardo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.890643', 'I');
INSERT INTO historico.municipio VALUES (3824, 'Sao Jose do Rio Preto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.891636', 'I');
INSERT INTO historico.municipio VALUES (3825, 'Sao Jose dos Campos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.892511', 'I');
INSERT INTO historico.municipio VALUES (3826, 'Sao Lourenco da Serra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.893511', 'I');
INSERT INTO historico.municipio VALUES (3827, 'Sao Luis do Paraitinga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.89439', 'I');
INSERT INTO historico.municipio VALUES (3828, 'Sao Manuel', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.89529', 'I');
INSERT INTO historico.municipio VALUES (3829, 'Sao Miguel Arcanjo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.89607', 'I');
INSERT INTO historico.municipio VALUES (3830, 'Sao Paulo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.897057', 'I');
INSERT INTO historico.municipio VALUES (3831, 'Sao Pedro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.898029', 'I');
INSERT INTO historico.municipio VALUES (3832, 'Sao Pedro do Turvo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.898933', 'I');
INSERT INTO historico.municipio VALUES (3833, 'Sao Roque', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.899785', 'I');
INSERT INTO historico.municipio VALUES (3834, 'Sao Sebastiao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.900715', 'I');
INSERT INTO historico.municipio VALUES (3835, 'Sao Sebastiao da Grama', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.901548', 'I');
INSERT INTO historico.municipio VALUES (3836, 'Sao Simao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.902471', 'I');
INSERT INTO historico.municipio VALUES (3837, 'Sao Vicente', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.903454', 'I');
INSERT INTO historico.municipio VALUES (3838, 'Sarapui', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.904302', 'I');
INSERT INTO historico.municipio VALUES (3839, 'Sarutaia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.905087', 'I');
INSERT INTO historico.municipio VALUES (3840, 'Sebastianopolis do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.906039', 'I');
INSERT INTO historico.municipio VALUES (3841, 'Serra Azul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.907223', 'I');
INSERT INTO historico.municipio VALUES (3843, 'Serrana', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.908962', 'I');
INSERT INTO historico.municipio VALUES (3842, 'Serra Negra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.907989', 'I');
INSERT INTO historico.municipio VALUES (3844, 'Sertaozinho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.909863', 'I');
INSERT INTO historico.municipio VALUES (3845, 'Sete Barras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.910813', 'I');
INSERT INTO historico.municipio VALUES (3846, 'Severinia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.911767', 'I');
INSERT INTO historico.municipio VALUES (3847, 'Silveiras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.912684', 'I');
INSERT INTO historico.municipio VALUES (3848, 'Socorro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.913618', 'I');
INSERT INTO historico.municipio VALUES (3849, 'Sorocaba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.914527', 'I');
INSERT INTO historico.municipio VALUES (3850, 'Sud Mennucci', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.915419', 'I');
INSERT INTO historico.municipio VALUES (3851, 'Sumare', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.923764', 'I');
INSERT INTO historico.municipio VALUES (3853, 'Suzano', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.925611', 'I');
INSERT INTO historico.municipio VALUES (3852, 'Suzanapolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.924737', 'I');
INSERT INTO historico.municipio VALUES (3854, 'Tabapua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.926641', 'I');
INSERT INTO historico.municipio VALUES (3855, 'Tabatinga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.92753', 'I');
INSERT INTO historico.municipio VALUES (3856, 'Taboao da Serra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.928379', 'I');
INSERT INTO historico.municipio VALUES (3857, 'Taciba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.929364', 'I');
INSERT INTO historico.municipio VALUES (3858, 'Taguai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.930327', 'I');
INSERT INTO historico.municipio VALUES (3859, 'Taiacu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.931198', 'I');
INSERT INTO historico.municipio VALUES (3860, 'Taiuva', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.932199', 'I');
INSERT INTO historico.municipio VALUES (3861, 'Tambau', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.933029', 'I');
INSERT INTO historico.municipio VALUES (3862, 'Tanabi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.933885', 'I');
INSERT INTO historico.municipio VALUES (3863, 'Tapirai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.934819', 'I');
INSERT INTO historico.municipio VALUES (3864, 'Tapiratiba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.935627', 'I');
INSERT INTO historico.municipio VALUES (3865, 'Taquaral', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.936569', 'I');
INSERT INTO historico.municipio VALUES (3866, 'Taquaritinga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.937462', 'I');
INSERT INTO historico.municipio VALUES (3867, 'Taquarituba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.938413', 'I');
INSERT INTO historico.municipio VALUES (3868, 'Taquarivai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.939268', 'I');
INSERT INTO historico.municipio VALUES (3869, 'Tarabai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.940097', 'I');
INSERT INTO historico.municipio VALUES (3870, 'Taruma', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.941071', 'I');
INSERT INTO historico.municipio VALUES (3871, 'Tatui', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.942017', 'I');
INSERT INTO historico.municipio VALUES (3872, 'Taubate', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.942943', 'I');
INSERT INTO historico.municipio VALUES (3873, 'Tejupa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.94383', 'I');
INSERT INTO historico.municipio VALUES (3874, 'Teodoro Sampaio', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.944695', 'I');
INSERT INTO historico.municipio VALUES (3875, 'Terra Roxa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.945558', 'I');
INSERT INTO historico.municipio VALUES (3876, 'Tiete', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.946495', 'I');
INSERT INTO historico.municipio VALUES (3877, 'Timburi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.94729', 'I');
INSERT INTO historico.municipio VALUES (3878, 'Torre de Pedra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.948168', 'I');
INSERT INTO historico.municipio VALUES (3879, 'Torrinha', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.949077', 'I');
INSERT INTO historico.municipio VALUES (3880, 'Trabiju', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.949993', 'I');
INSERT INTO historico.municipio VALUES (3881, 'Tremembe', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.950947', 'I');
INSERT INTO historico.municipio VALUES (3882, 'Tres Fronteiras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.951742', 'I');
INSERT INTO historico.municipio VALUES (3883, 'Tuiuti', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.952496', 'I');
INSERT INTO historico.municipio VALUES (3884, 'Tupa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.953395', 'I');
INSERT INTO historico.municipio VALUES (3885, 'Tupi Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.954217', 'I');
INSERT INTO historico.municipio VALUES (3886, 'Turiuba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.955145', 'I');
INSERT INTO historico.municipio VALUES (3887, 'Turmalina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.956025', 'I');
INSERT INTO historico.municipio VALUES (3888, 'Ubarana', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.957522', 'I');
INSERT INTO historico.municipio VALUES (3889, 'Ubatuba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.964282', 'I');
INSERT INTO historico.municipio VALUES (3890, 'Ubirajara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.965379', 'I');
INSERT INTO historico.municipio VALUES (3891, 'Uchoa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.966314', 'I');
INSERT INTO historico.municipio VALUES (3892, 'Uniao Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.967227', 'I');
INSERT INTO historico.municipio VALUES (3893, 'Urania', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.968222', 'I');
INSERT INTO historico.municipio VALUES (3894, 'Uru', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.969163', 'I');
INSERT INTO historico.municipio VALUES (3895, 'Urupes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.970073', 'I');
INSERT INTO historico.municipio VALUES (3896, 'Valentim Gentil', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.970972', 'I');
INSERT INTO historico.municipio VALUES (3897, 'Valinhos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.971951', 'I');
INSERT INTO historico.municipio VALUES (3898, 'Valparaiso', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.972883', 'I');
INSERT INTO historico.municipio VALUES (3899, 'Vargem', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.974064', 'I');
INSERT INTO historico.municipio VALUES (3900, 'Vargem Grande do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.974954', 'I');
INSERT INTO historico.municipio VALUES (3901, 'Vargem Grande Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.976387', 'I');
INSERT INTO historico.municipio VALUES (3902, 'Varzea Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.97738', 'I');
INSERT INTO historico.municipio VALUES (3903, 'Vera Cruz', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.97827', 'I');
INSERT INTO historico.municipio VALUES (3904, 'Vinhedo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.979112', 'I');
INSERT INTO historico.municipio VALUES (3905, 'Viradouro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.980046', 'I');
INSERT INTO historico.municipio VALUES (3906, 'Vista Alegre do Alto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.980934', 'I');
INSERT INTO historico.municipio VALUES (3907, 'Vitoria Brasil', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.981804', 'I');
INSERT INTO historico.municipio VALUES (3908, 'Votorantim', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.982726', 'I');
INSERT INTO historico.municipio VALUES (3909, 'Votuporanga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.983575', 'I');
INSERT INTO historico.municipio VALUES (3910, 'Zacarias', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.984592', 'I');
INSERT INTO historico.municipio VALUES (3399, 'Chavantes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.411516', 'I');
INSERT INTO historico.municipio VALUES (3440, 'Estiva Gerbi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.459826', 'I');
INSERT INTO historico.municipio VALUES (3911, 'Abatia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.985397', 'I');
INSERT INTO historico.municipio VALUES (3912, 'Adrianopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.986287', 'I');
INSERT INTO historico.municipio VALUES (3913, 'Agudos do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.987196', 'I');
INSERT INTO historico.municipio VALUES (3914, 'Almirante Tamandare', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.988188', 'I');
INSERT INTO historico.municipio VALUES (3915, 'Altamira do Parana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.989098', 'I');
INSERT INTO historico.municipio VALUES (3919, 'Altonia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.992748', 'I');
INSERT INTO historico.municipio VALUES (3917, 'Alto Parana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.990938', 'I');
INSERT INTO historico.municipio VALUES (3918, 'Alto Piquiri', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.991839', 'I');
INSERT INTO historico.municipio VALUES (3920, 'Alvorada do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.99372', 'I');
INSERT INTO historico.municipio VALUES (3921, 'Amapora', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.99467', 'I');
INSERT INTO historico.municipio VALUES (3922, 'Ampere', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.995648', 'I');
INSERT INTO historico.municipio VALUES (3923, 'Anahy', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.996625', 'I');
INSERT INTO historico.municipio VALUES (3924, 'Andira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.997681', 'I');
INSERT INTO historico.municipio VALUES (3925, 'Angulo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.004728', 'I');
INSERT INTO historico.municipio VALUES (3926, 'Antonina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.005854', 'I');
INSERT INTO historico.municipio VALUES (3927, 'Antonio Olinto', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.007012', 'I');
INSERT INTO historico.municipio VALUES (3928, 'Apucarana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.007903', 'I');
INSERT INTO historico.municipio VALUES (3929, 'Arapongas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.008811', 'I');
INSERT INTO historico.municipio VALUES (3930, 'Arapoti', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.009634', 'I');
INSERT INTO historico.municipio VALUES (3931, 'Arapua', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.010641', 'I');
INSERT INTO historico.municipio VALUES (3932, 'Araruna', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.011512', 'I');
INSERT INTO historico.municipio VALUES (3933, 'Araucaria', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.012356', 'I');
INSERT INTO historico.municipio VALUES (3934, 'Ariranha do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.013245', 'I');
INSERT INTO historico.municipio VALUES (3935, 'Assai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.014083', 'I');
INSERT INTO historico.municipio VALUES (3936, 'Assis Chateaubriand', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.014967', 'I');
INSERT INTO historico.municipio VALUES (3937, 'Astorga', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.015824', 'I');
INSERT INTO historico.municipio VALUES (3938, 'Atalaia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.016716', 'I');
INSERT INTO historico.municipio VALUES (3939, 'Balsa Nova', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.017615', 'I');
INSERT INTO historico.municipio VALUES (3940, 'Bandeirantes', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.018653', 'I');
INSERT INTO historico.municipio VALUES (3941, 'Barbosa Ferraz', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.019459', 'I');
INSERT INTO historico.municipio VALUES (3943, 'Barracao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.021205', 'I');
INSERT INTO historico.municipio VALUES (3942, 'Barra do Jacare', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.020318', 'I');
INSERT INTO historico.municipio VALUES (3945, 'Bela Vista do Paraiso', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.023032', 'I');
INSERT INTO historico.municipio VALUES (3946, 'Bituruna', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.023906', 'I');
INSERT INTO historico.municipio VALUES (3947, 'Boa Esperanca', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.02483', 'I');
INSERT INTO historico.municipio VALUES (3948, 'Boa Esperanca do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.025742', 'I');
INSERT INTO historico.municipio VALUES (3949, 'Boa Ventura de Sao Roque', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.026662', 'I');
INSERT INTO historico.municipio VALUES (3950, 'Boa Vista da Aparecida', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.027576', 'I');
INSERT INTO historico.municipio VALUES (3951, 'Bocaiuva do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.028487', 'I');
INSERT INTO historico.municipio VALUES (3952, 'Bom Jesus do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.02933', 'I');
INSERT INTO historico.municipio VALUES (3953, 'Bom Sucesso', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.030115', 'I');
INSERT INTO historico.municipio VALUES (3954, 'Bom Sucesso do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.031027', 'I');
INSERT INTO historico.municipio VALUES (3955, 'Borrazopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.031843', 'I');
INSERT INTO historico.municipio VALUES (3956, 'Braganey', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.032806', 'I');
INSERT INTO historico.municipio VALUES (3957, 'Brasilandia do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.033978', 'I');
INSERT INTO historico.municipio VALUES (3958, 'Cafeara', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.034819', 'I');
INSERT INTO historico.municipio VALUES (3959, 'Cafelandia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.03574', 'I');
INSERT INTO historico.municipio VALUES (3960, 'Cafezal do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.036649', 'I');
INSERT INTO historico.municipio VALUES (3961, 'California', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.037542', 'I');
INSERT INTO historico.municipio VALUES (3962, 'Cambara', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.038936', 'I');
INSERT INTO historico.municipio VALUES (3963, 'Cambe', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.045765', 'I');
INSERT INTO historico.municipio VALUES (3964, 'Cambira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.047133', 'I');
INSERT INTO historico.municipio VALUES (3965, 'Campina da Lagoa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.04815', 'I');
INSERT INTO historico.municipio VALUES (3966, 'Campina do Simao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.049097', 'I');
INSERT INTO historico.municipio VALUES (3967, 'Campina Grande do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.050115', 'I');
INSERT INTO historico.municipio VALUES (3968, 'Campo Bonito', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.051104', 'I');
INSERT INTO historico.municipio VALUES (3969, 'Campo do Tenente', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.05197', 'I');
INSERT INTO historico.municipio VALUES (3970, 'Campo Largo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.053224', 'I');
INSERT INTO historico.municipio VALUES (3971, 'Campo Magro', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.054079', 'I');
INSERT INTO historico.municipio VALUES (3972, 'Campo Mourao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.054986', 'I');
INSERT INTO historico.municipio VALUES (3973, 'Candido de Abreu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.055886', 'I');
INSERT INTO historico.municipio VALUES (3974, 'Candoi', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.056861', 'I');
INSERT INTO historico.municipio VALUES (3975, 'Cantagalo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.057749', 'I');
INSERT INTO historico.municipio VALUES (3976, 'Capanema', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.05867', 'I');
INSERT INTO historico.municipio VALUES (3977, 'Capitao Leonidas Marques', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.059635', 'I');
INSERT INTO historico.municipio VALUES (3978, 'Carambei', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.060504', 'I');
INSERT INTO historico.municipio VALUES (3979, 'Carlopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.061386', 'I');
INSERT INTO historico.municipio VALUES (3980, 'Cascavel', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.062316', 'I');
INSERT INTO historico.municipio VALUES (3981, 'Castro', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.063137', 'I');
INSERT INTO historico.municipio VALUES (3982, 'Catanduvas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.064188', 'I');
INSERT INTO historico.municipio VALUES (3983, 'Centenario do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.065187', 'I');
INSERT INTO historico.municipio VALUES (3984, 'Cerro Azul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.066246', 'I');
INSERT INTO historico.municipio VALUES (3985, 'Ceu Azul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.06723', 'I');
INSERT INTO historico.municipio VALUES (3986, 'Chopinzinho', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.068245', 'I');
INSERT INTO historico.municipio VALUES (3987, 'Cianorte', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.069317', 'I');
INSERT INTO historico.municipio VALUES (3988, 'Cidade Gaucha', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.070245', 'I');
INSERT INTO historico.municipio VALUES (3989, 'Clevelandia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.071239', 'I');
INSERT INTO historico.municipio VALUES (3990, 'Colombo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.072161', 'I');
INSERT INTO historico.municipio VALUES (3991, 'Colorado', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.073279', 'I');
INSERT INTO historico.municipio VALUES (3992, 'Congonhinhas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.074223', 'I');
INSERT INTO historico.municipio VALUES (3993, 'Conselheiro Mairinck', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.075146', 'I');
INSERT INTO historico.municipio VALUES (3994, 'Contenda', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.07629', 'I');
INSERT INTO historico.municipio VALUES (3995, 'Corbelia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.077225', 'I');
INSERT INTO historico.municipio VALUES (3996, 'Cornelio Procopio', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.078202', 'I');
INSERT INTO historico.municipio VALUES (3997, 'Coronel Domingos Soares', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.079407', 'I');
INSERT INTO historico.municipio VALUES (3998, 'Coronel Vivida', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.086559', 'I');
INSERT INTO historico.municipio VALUES (3999, 'Corumbatai do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.087675', 'I');
INSERT INTO historico.municipio VALUES (4001, 'Cruzeiro do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.089408', 'I');
INSERT INTO historico.municipio VALUES (4002, 'Cruzeiro do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.090379', 'I');
INSERT INTO historico.municipio VALUES (4003, 'Cruzeiro do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.09129', 'I');
INSERT INTO historico.municipio VALUES (4000, 'Cruz Machado', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.088592', 'I');
INSERT INTO historico.municipio VALUES (4004, 'Cruzmaltina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.092294', 'I');
INSERT INTO historico.municipio VALUES (4005, 'Curitiba', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.093188', 'I');
INSERT INTO historico.municipio VALUES (4006, 'Curiuva', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.094161', 'I');
INSERT INTO historico.municipio VALUES (4007, 'Diamante do Norte', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.095041', 'I');
INSERT INTO historico.municipio VALUES (4008, 'Diamante do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.096391', 'I');
INSERT INTO historico.municipio VALUES (4009, 'Diamante D''oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.097438', 'I');
INSERT INTO historico.municipio VALUES (4010, 'Dois Vizinhos', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.098274', 'I');
INSERT INTO historico.municipio VALUES (4011, 'Douradina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.099183', 'I');
INSERT INTO historico.municipio VALUES (4012, 'Doutor Camargo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.100098', 'I');
INSERT INTO historico.municipio VALUES (4014, 'Eneas Marques', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.10187', 'I');
INSERT INTO historico.municipio VALUES (4015, 'Engenheiro Beltrao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.102709', 'I');
INSERT INTO historico.municipio VALUES (4017, 'Esperanca Nova', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.104368', 'I');
INSERT INTO historico.municipio VALUES (4016, 'Entre Rios do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.103512', 'I');
INSERT INTO historico.municipio VALUES (4018, 'Espigao Alto do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.105422', 'I');
INSERT INTO historico.municipio VALUES (4019, 'Farol', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.106399', 'I');
INSERT INTO historico.municipio VALUES (4020, 'Faxinal', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.107374', 'I');
INSERT INTO historico.municipio VALUES (4021, 'Fazenda Rio Grande', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.108241', 'I');
INSERT INTO historico.municipio VALUES (4022, 'Fenix', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.109288', 'I');
INSERT INTO historico.municipio VALUES (4023, 'Fernandes Pinheiro', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.110161', 'I');
INSERT INTO historico.municipio VALUES (4024, 'Figueira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.111065', 'I');
INSERT INTO historico.municipio VALUES (4026, 'Florai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.112881', 'I');
INSERT INTO historico.municipio VALUES (4025, 'Flor da Serra do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.111977', 'I');
INSERT INTO historico.municipio VALUES (4027, 'Floresta', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.113867', 'I');
INSERT INTO historico.municipio VALUES (4028, 'Florestopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.114779', 'I');
INSERT INTO historico.municipio VALUES (4029, 'Florida', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.115752', 'I');
INSERT INTO historico.municipio VALUES (4030, 'Formosa do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.116721', 'I');
INSERT INTO historico.municipio VALUES (4031, 'Foz do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.117707', 'I');
INSERT INTO historico.municipio VALUES (4033, 'Francisco Alves', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.119613', 'I');
INSERT INTO historico.municipio VALUES (4034, 'Francisco Beltrao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.120558', 'I');
INSERT INTO historico.municipio VALUES (4032, 'Foz do Jordao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.118639', 'I');
INSERT INTO historico.municipio VALUES (4035, 'General Carneiro', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.127423', 'I');
INSERT INTO historico.municipio VALUES (4036, 'Godoy Moreira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.128645', 'I');
INSERT INTO historico.municipio VALUES (4038, 'Goioxim', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.13055', 'I');
INSERT INTO historico.municipio VALUES (4039, 'Grandes Rios', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.131638', 'I');
INSERT INTO historico.municipio VALUES (4040, 'Guaira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.13242', 'I');
INSERT INTO historico.municipio VALUES (4041, 'Guairaca', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.133372', 'I');
INSERT INTO historico.municipio VALUES (4042, 'Guamiranga', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.134252', 'I');
INSERT INTO historico.municipio VALUES (4043, 'Guapirama', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.135191', 'I');
INSERT INTO historico.municipio VALUES (4044, 'Guaporema', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.136151', 'I');
INSERT INTO historico.municipio VALUES (4045, 'Guaraci', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.137079', 'I');
INSERT INTO historico.municipio VALUES (4046, 'Guaraniacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.138006', 'I');
INSERT INTO historico.municipio VALUES (4047, 'Guarapuava', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.138945', 'I');
INSERT INTO historico.municipio VALUES (4048, 'Guaraquecaba', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.139847', 'I');
INSERT INTO historico.municipio VALUES (4049, 'Guaratuba', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.140817', 'I');
INSERT INTO historico.municipio VALUES (4050, 'Honorio Serpa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.141648', 'I');
INSERT INTO historico.municipio VALUES (4051, 'Ibaiti', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.142752', 'I');
INSERT INTO historico.municipio VALUES (4052, 'Ibema', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.143584', 'I');
INSERT INTO historico.municipio VALUES (4053, 'Ibipora', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.14439', 'I');
INSERT INTO historico.municipio VALUES (4054, 'Icaraima', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.145266', 'I');
INSERT INTO historico.municipio VALUES (4055, 'Iguaracu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.146086', 'I');
INSERT INTO historico.municipio VALUES (4056, 'Iguatu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.146981', 'I');
INSERT INTO historico.municipio VALUES (4057, 'Imbau', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.147856', 'I');
INSERT INTO historico.municipio VALUES (4058, 'Imbituva', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.148856', 'I');
INSERT INTO historico.municipio VALUES (4059, 'Inacio Martins', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.149748', 'I');
INSERT INTO historico.municipio VALUES (4060, 'Inaja', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.150609', 'I');
INSERT INTO historico.municipio VALUES (4061, 'Indianopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.151462', 'I');
INSERT INTO historico.municipio VALUES (4062, 'Ipiranga', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.15233', 'I');
INSERT INTO historico.municipio VALUES (4063, 'Ipora', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.153244', 'I');
INSERT INTO historico.municipio VALUES (4064, 'Iracema do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.154171', 'I');
INSERT INTO historico.municipio VALUES (4065, 'Irati', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.155067', 'I');
INSERT INTO historico.municipio VALUES (4066, 'Iretama', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.155943', 'I');
INSERT INTO historico.municipio VALUES (4067, 'Itaguaje', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.156929', 'I');
INSERT INTO historico.municipio VALUES (4068, 'Itaipulandia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.157878', 'I');
INSERT INTO historico.municipio VALUES (4069, 'Itambaraca', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.158813', 'I');
INSERT INTO historico.municipio VALUES (4070, 'Itambe', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.159654', 'I');
INSERT INTO historico.municipio VALUES (4071, 'Itapejara D''oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.160601', 'I');
INSERT INTO historico.municipio VALUES (4072, 'Itaperucu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.161482', 'I');
INSERT INTO historico.municipio VALUES (4073, 'Itauna do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.162479', 'I');
INSERT INTO historico.municipio VALUES (4074, 'Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.173191', 'I');
INSERT INTO historico.municipio VALUES (4075, 'Ivaipora', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.174405', 'I');
INSERT INTO historico.municipio VALUES (4076, 'Ivate', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.175489', 'I');
INSERT INTO historico.municipio VALUES (4077, 'Ivatuba', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.176411', 'I');
INSERT INTO historico.municipio VALUES (4078, 'Jaboti', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.177343', 'I');
INSERT INTO historico.municipio VALUES (4079, 'Jacarezinho', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.178223', 'I');
INSERT INTO historico.municipio VALUES (4080, 'Jaguapita', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.17908', 'I');
INSERT INTO historico.municipio VALUES (4081, 'Jaguariaiva', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.179969', 'I');
INSERT INTO historico.municipio VALUES (4082, 'Jandaia do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.180921', 'I');
INSERT INTO historico.municipio VALUES (4083, 'Janiopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.181768', 'I');
INSERT INTO historico.municipio VALUES (4084, 'Japira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.182695', 'I');
INSERT INTO historico.municipio VALUES (4085, 'Japura', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.183595', 'I');
INSERT INTO historico.municipio VALUES (4086, 'Jardim Alegre', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.184551', 'I');
INSERT INTO historico.municipio VALUES (4087, 'Jardim Olinda', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.185484', 'I');
INSERT INTO historico.municipio VALUES (4088, 'Jataizinho', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.186508', 'I');
INSERT INTO historico.municipio VALUES (4089, 'Jesuitas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.187505', 'I');
INSERT INTO historico.municipio VALUES (4090, 'Joaquim Tavora', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.188472', 'I');
INSERT INTO historico.municipio VALUES (4091, 'Jundiai do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.189369', 'I');
INSERT INTO historico.municipio VALUES (4092, 'Juranda', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.190237', 'I');
INSERT INTO historico.municipio VALUES (4093, 'Jussara', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.191189', 'I');
INSERT INTO historico.municipio VALUES (4094, 'Kalore', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.192042', 'I');
INSERT INTO historico.municipio VALUES (4095, 'Lapa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.192994', 'I');
INSERT INTO historico.municipio VALUES (4096, 'Laranjal', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.193967', 'I');
INSERT INTO historico.municipio VALUES (4097, 'Laranjeiras do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.194892', 'I');
INSERT INTO historico.municipio VALUES (4098, 'Leopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.195946', 'I');
INSERT INTO historico.municipio VALUES (4099, 'Lidianopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.196969', 'I');
INSERT INTO historico.municipio VALUES (4100, 'Lindoeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.197979', 'I');
INSERT INTO historico.municipio VALUES (4101, 'Loanda', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.198786', 'I');
INSERT INTO historico.municipio VALUES (4102, 'Lobato', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.199695', 'I');
INSERT INTO historico.municipio VALUES (4103, 'Londrina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.200588', 'I');
INSERT INTO historico.municipio VALUES (4104, 'Luiziana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.2014', 'I');
INSERT INTO historico.municipio VALUES (4105, 'Lunardelli', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.202191', 'I');
INSERT INTO historico.municipio VALUES (4106, 'Lupionopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.203083', 'I');
INSERT INTO historico.municipio VALUES (4107, 'Mallet', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.204071', 'I');
INSERT INTO historico.municipio VALUES (4108, 'Mambore', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.205131', 'I');
INSERT INTO historico.municipio VALUES (4109, 'Mandaguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.206396', 'I');
INSERT INTO historico.municipio VALUES (4110, 'Mandaguari', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.207255', 'I');
INSERT INTO historico.municipio VALUES (4111, 'Mandirituba', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.213506', 'I');
INSERT INTO historico.municipio VALUES (4112, 'Manfrinopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.214574', 'I');
INSERT INTO historico.municipio VALUES (4113, 'Mangueirinha', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.21538', 'I');
INSERT INTO historico.municipio VALUES (4114, 'Manoel Ribas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.216194', 'I');
INSERT INTO historico.municipio VALUES (4115, 'Marechal Candido Rondon', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.217021', 'I');
INSERT INTO historico.municipio VALUES (4116, 'Maria Helena', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.217924', 'I');
INSERT INTO historico.municipio VALUES (4117, 'Marialva', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.218808', 'I');
INSERT INTO historico.municipio VALUES (4118, 'Marilandia do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.219675', 'I');
INSERT INTO historico.municipio VALUES (4119, 'Marilena', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.221127', 'I');
INSERT INTO historico.municipio VALUES (4120, 'Mariluz', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.22202', 'I');
INSERT INTO historico.municipio VALUES (4121, 'Maringa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.222938', 'I');
INSERT INTO historico.municipio VALUES (4122, 'Mariopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.223854', 'I');
INSERT INTO historico.municipio VALUES (4123, 'Maripa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.224672', 'I');
INSERT INTO historico.municipio VALUES (4124, 'Marmeleiro', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.22564', 'I');
INSERT INTO historico.municipio VALUES (4125, 'Marquinho', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.22658', 'I');
INSERT INTO historico.municipio VALUES (4126, 'Marumbi', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.227421', 'I');
INSERT INTO historico.municipio VALUES (4127, 'Matelandia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.228228', 'I');
INSERT INTO historico.municipio VALUES (4128, 'Matinhos', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.229194', 'I');
INSERT INTO historico.municipio VALUES (4129, 'Mato Rico', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.230144', 'I');
INSERT INTO historico.municipio VALUES (4130, 'Maua da Serra', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.231029', 'I');
INSERT INTO historico.municipio VALUES (4131, 'Medianeira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.232254', 'I');
INSERT INTO historico.municipio VALUES (4132, 'Mercedes', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.233069', 'I');
INSERT INTO historico.municipio VALUES (4133, 'Mirador', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.233941', 'I');
INSERT INTO historico.municipio VALUES (4134, 'Miraselva', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.234818', 'I');
INSERT INTO historico.municipio VALUES (4135, 'Missal', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.23558', 'I');
INSERT INTO historico.municipio VALUES (4136, 'Moreira Sales', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.236433', 'I');
INSERT INTO historico.municipio VALUES (4137, 'Morretes', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.237286', 'I');
INSERT INTO historico.municipio VALUES (4138, 'Munhoz de Melo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.238297', 'I');
INSERT INTO historico.municipio VALUES (4139, 'Nossa Senhora das Gracas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.239216', 'I');
INSERT INTO historico.municipio VALUES (4140, 'Nova Alianca do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.240118', 'I');
INSERT INTO historico.municipio VALUES (4141, 'Nova America da Colina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.240981', 'I');
INSERT INTO historico.municipio VALUES (4142, 'Nova Aurora', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.24191', 'I');
INSERT INTO historico.municipio VALUES (4143, 'Nova Cantu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.242841', 'I');
INSERT INTO historico.municipio VALUES (4144, 'Nova Esperanca', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.243604', 'I');
INSERT INTO historico.municipio VALUES (4145, 'Nova Esperanca do Sudoeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.244503', 'I');
INSERT INTO historico.municipio VALUES (4146, 'Nova Fatima', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.24551', 'I');
INSERT INTO historico.municipio VALUES (4147, 'Nova Laranjeiras', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.246408', 'I');
INSERT INTO historico.municipio VALUES (4148, 'Nova Londrina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.247175', 'I');
INSERT INTO historico.municipio VALUES (4149, 'Nova Olimpia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.254111', 'I');
INSERT INTO historico.municipio VALUES (4151, 'Nova Santa Barbara', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.256208', 'I');
INSERT INTO historico.municipio VALUES (4152, 'Nova Santa Rosa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.257126', 'I');
INSERT INTO historico.municipio VALUES (4150, 'Nova Prata do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.255272', 'I');
INSERT INTO historico.municipio VALUES (4153, 'Nova Tebas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.258244', 'I');
INSERT INTO historico.municipio VALUES (4154, 'Novo Itacolomi', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.259008', 'I');
INSERT INTO historico.municipio VALUES (4155, 'Ortigueira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.259923', 'I');
INSERT INTO historico.municipio VALUES (4156, 'Ourizona', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.260801', 'I');
INSERT INTO historico.municipio VALUES (4157, 'Ouro Verde do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.261512', 'I');
INSERT INTO historico.municipio VALUES (4158, 'Paicandu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.262398', 'I');
INSERT INTO historico.municipio VALUES (4159, 'Palmas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.263241', 'I');
INSERT INTO historico.municipio VALUES (4160, 'Palmeira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.264126', 'I');
INSERT INTO historico.municipio VALUES (4161, 'Palmital', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.264963', 'I');
INSERT INTO historico.municipio VALUES (4162, 'Palotina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.265805', 'I');
INSERT INTO historico.municipio VALUES (4163, 'Paraiso do Norte', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.266633', 'I');
INSERT INTO historico.municipio VALUES (4164, 'Paranacity', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.267515', 'I');
INSERT INTO historico.municipio VALUES (4165, 'Paranagua', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.268404', 'I');
INSERT INTO historico.municipio VALUES (4166, 'Paranapoema', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.269214', 'I');
INSERT INTO historico.municipio VALUES (4167, 'Paranavai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.270026', 'I');
INSERT INTO historico.municipio VALUES (4168, 'Pato Bragado', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.27079', 'I');
INSERT INTO historico.municipio VALUES (4169, 'Pato Branco', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.271724', 'I');
INSERT INTO historico.municipio VALUES (4170, 'Paula Freitas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.272627', 'I');
INSERT INTO historico.municipio VALUES (4171, 'Paulo Frontin', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.273639', 'I');
INSERT INTO historico.municipio VALUES (4172, 'Peabiru', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.274646', 'I');
INSERT INTO historico.municipio VALUES (4173, 'Perobal', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.275641', 'I');
INSERT INTO historico.municipio VALUES (4174, 'Perola', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.276605', 'I');
INSERT INTO historico.municipio VALUES (4175, 'Perola D''oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.277426', 'I');
INSERT INTO historico.municipio VALUES (4176, 'Pien', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.278261', 'I');
INSERT INTO historico.municipio VALUES (4177, 'Pinhais', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.279077', 'I');
INSERT INTO historico.municipio VALUES (4179, 'Pinhalao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.280779', 'I');
INSERT INTO historico.municipio VALUES (4178, 'Pinhal de Sao Bento', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.279898', 'I');
INSERT INTO historico.municipio VALUES (4180, 'Pinhao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.281602', 'I');
INSERT INTO historico.municipio VALUES (4181, 'Pirai do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.282487', 'I');
INSERT INTO historico.municipio VALUES (4182, 'Piraquara', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.283295', 'I');
INSERT INTO historico.municipio VALUES (4183, 'Pitanga', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.2841', 'I');
INSERT INTO historico.municipio VALUES (4184, 'Pitangueiras', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.285074', 'I');
INSERT INTO historico.municipio VALUES (4185, 'Planaltina do Parana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.28605', 'I');
INSERT INTO historico.municipio VALUES (4186, 'Planalto', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.286973', 'I');
INSERT INTO historico.municipio VALUES (4187, 'Ponta Grossa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.287832', 'I');
INSERT INTO historico.municipio VALUES (4188, 'Pontal do Parana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.294545', 'I');
INSERT INTO historico.municipio VALUES (4189, 'Porecatu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.295833', 'I');
INSERT INTO historico.municipio VALUES (4190, 'Porto Amazonas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.296693', 'I');
INSERT INTO historico.municipio VALUES (4191, 'Porto Barreiro', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.297591', 'I');
INSERT INTO historico.municipio VALUES (4192, 'Porto Rico', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.298581', 'I');
INSERT INTO historico.municipio VALUES (4193, 'Porto Vitoria', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.299373', 'I');
INSERT INTO historico.municipio VALUES (4194, 'Prado Ferreira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.300209', 'I');
INSERT INTO historico.municipio VALUES (4195, 'Pranchita', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.301016', 'I');
INSERT INTO historico.municipio VALUES (4196, 'Presidente Castelo Branco', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.301937', 'I');
INSERT INTO historico.municipio VALUES (4197, 'Primeiro de Maio', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.30282', 'I');
INSERT INTO historico.municipio VALUES (4198, 'Prudentopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.303849', 'I');
INSERT INTO historico.municipio VALUES (4199, 'Quarto Centenario', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.304786', 'I');
INSERT INTO historico.municipio VALUES (4200, 'Quatigua', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.305711', 'I');
INSERT INTO historico.municipio VALUES (4201, 'Quatro Barras', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.306515', 'I');
INSERT INTO historico.municipio VALUES (4202, 'Quatro Pontes', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.307399', 'I');
INSERT INTO historico.municipio VALUES (4203, 'Quedas do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.308241', 'I');
INSERT INTO historico.municipio VALUES (4204, 'Querencia do Norte', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.309072', 'I');
INSERT INTO historico.municipio VALUES (4205, 'Quinta do Sol', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.31021', 'I');
INSERT INTO historico.municipio VALUES (4206, 'Quitandinha', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.311014', 'I');
INSERT INTO historico.municipio VALUES (4207, 'Ramilandia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.3117', 'I');
INSERT INTO historico.municipio VALUES (4208, 'Rancho Alegre', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.312592', 'I');
INSERT INTO historico.municipio VALUES (4209, 'Rancho Alegre D''oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.313489', 'I');
INSERT INTO historico.municipio VALUES (4210, 'Realeza', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.314376', 'I');
INSERT INTO historico.municipio VALUES (4211, 'Reboucas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.315317', 'I');
INSERT INTO historico.municipio VALUES (4212, 'Renascenca', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.316337', 'I');
INSERT INTO historico.municipio VALUES (4213, 'Reserva', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.317368', 'I');
INSERT INTO historico.municipio VALUES (4214, 'Reserva do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.318231', 'I');
INSERT INTO historico.municipio VALUES (4215, 'Ribeirao Claro', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.31911', 'I');
INSERT INTO historico.municipio VALUES (4216, 'Ribeirao do Pinhal', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.319989', 'I');
INSERT INTO historico.municipio VALUES (4217, 'Rio Azul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.320821', 'I');
INSERT INTO historico.municipio VALUES (4218, 'Rio Bom', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.32181', 'I');
INSERT INTO historico.municipio VALUES (4219, 'Rio Bonito do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.322764', 'I');
INSERT INTO historico.municipio VALUES (4220, 'Rio Branco do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.323713', 'I');
INSERT INTO historico.municipio VALUES (4221, 'Rio Branco do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.324646', 'I');
INSERT INTO historico.municipio VALUES (4222, 'Rio Negro', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.325554', 'I');
INSERT INTO historico.municipio VALUES (4223, 'Rolandia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.326432', 'I');
INSERT INTO historico.municipio VALUES (4224, 'Roncador', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.327306', 'I');
INSERT INTO historico.municipio VALUES (4225, 'Rondon', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.328245', 'I');
INSERT INTO historico.municipio VALUES (4226, 'Rosario do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.338376', 'I');
INSERT INTO historico.municipio VALUES (4227, 'Sabaudia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.339508', 'I');
INSERT INTO historico.municipio VALUES (4228, 'Salgado Filho', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.34043', 'I');
INSERT INTO historico.municipio VALUES (4229, 'Salto do Itarare', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.341281', 'I');
INSERT INTO historico.municipio VALUES (4230, 'Salto do Lontra', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.342375', 'I');
INSERT INTO historico.municipio VALUES (4231, 'Santa Amelia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.343545', 'I');
INSERT INTO historico.municipio VALUES (4232, 'Santa Cecilia do Pavao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.344438', 'I');
INSERT INTO historico.municipio VALUES (4233, 'Santa Cruz de Monte Castelo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.345319', 'I');
INSERT INTO historico.municipio VALUES (4234, 'Santa Fe', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.346188', 'I');
INSERT INTO historico.municipio VALUES (4235, 'Santa Helena', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.347091', 'I');
INSERT INTO historico.municipio VALUES (4236, 'Santa Ines', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.347973', 'I');
INSERT INTO historico.municipio VALUES (4237, 'Santa Isabel do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.348934', 'I');
INSERT INTO historico.municipio VALUES (4238, 'Santa Izabel do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.349861', 'I');
INSERT INTO historico.municipio VALUES (4239, 'Santa Lucia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.350735', 'I');
INSERT INTO historico.municipio VALUES (4240, 'Santa Maria do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.351637', 'I');
INSERT INTO historico.municipio VALUES (4241, 'Santa Mariana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.352468', 'I');
INSERT INTO historico.municipio VALUES (4242, 'Santa Monica', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.353319', 'I');
INSERT INTO historico.municipio VALUES (4245, 'Santana do Itarare', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.355964', 'I');
INSERT INTO historico.municipio VALUES (4243, 'Santa Tereza do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.35425', 'I');
INSERT INTO historico.municipio VALUES (4244, 'Santa Terezinha de Itaipu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.355024', 'I');
INSERT INTO historico.municipio VALUES (4246, 'Santo Antonio da Platina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.356885', 'I');
INSERT INTO historico.municipio VALUES (4247, 'Santo Antonio do Caiua', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.357831', 'I');
INSERT INTO historico.municipio VALUES (4248, 'Santo Antonio do Paraiso', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.358771', 'I');
INSERT INTO historico.municipio VALUES (4249, 'Santo Antonio do Sudoeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.359666', 'I');
INSERT INTO historico.municipio VALUES (4250, 'Santo Inacio', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.360623', 'I');
INSERT INTO historico.municipio VALUES (4251, 'Sao Carlos do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.361502', 'I');
INSERT INTO historico.municipio VALUES (4252, 'Sao Jeronimo da Serra', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.362324', 'I');
INSERT INTO historico.municipio VALUES (4253, 'Sao Joao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.363192', 'I');
INSERT INTO historico.municipio VALUES (4254, 'Sao Joao do Caiua', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.364281', 'I');
INSERT INTO historico.municipio VALUES (4255, 'Sao Joao do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.365215', 'I');
INSERT INTO historico.municipio VALUES (4256, 'Sao Joao do Triunfo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.366215', 'I');
INSERT INTO historico.municipio VALUES (4259, 'Sao Jorge D''oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.368953', 'I');
INSERT INTO historico.municipio VALUES (4257, 'Sao Jorge do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.367092', 'I');
INSERT INTO historico.municipio VALUES (4258, 'Sao Jorge do Patrocinio', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.368034', 'I');
INSERT INTO historico.municipio VALUES (4260, 'Sao Jose da Boa Vista', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.369834', 'I');
INSERT INTO historico.municipio VALUES (4261, 'Sao Jose das Palmeiras', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.370542', 'I');
INSERT INTO historico.municipio VALUES (4262, 'Sao Jose dos Pinhais', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.371509', 'I');
INSERT INTO historico.municipio VALUES (4263, 'Sao Manoel do Parana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.372312', 'I');
INSERT INTO historico.municipio VALUES (4264, 'Sao Mateus do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.37923', 'I');
INSERT INTO historico.municipio VALUES (4265, 'Sao Miguel do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.380624', 'I');
INSERT INTO historico.municipio VALUES (4266, 'Sao Pedro do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.381553', 'I');
INSERT INTO historico.municipio VALUES (4267, 'Sao Pedro do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.382512', 'I');
INSERT INTO historico.municipio VALUES (4268, 'Sao Pedro do Parana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.383505', 'I');
INSERT INTO historico.municipio VALUES (4269, 'Sao Sebastiao da Amoreira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.384423', 'I');
INSERT INTO historico.municipio VALUES (4270, 'Sao Tome', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.38532', 'I');
INSERT INTO historico.municipio VALUES (4271, 'Sapopema', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.386212', 'I');
INSERT INTO historico.municipio VALUES (4272, 'Sarandi', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.38714', 'I');
INSERT INTO historico.municipio VALUES (4273, 'Saudade do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.388048', 'I');
INSERT INTO historico.municipio VALUES (4274, 'Senges', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.388983', 'I');
INSERT INTO historico.municipio VALUES (4275, 'Serranopolis do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.389954', 'I');
INSERT INTO historico.municipio VALUES (4276, 'Sertaneja', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.390851', 'I');
INSERT INTO historico.municipio VALUES (4277, 'Sertanopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.391827', 'I');
INSERT INTO historico.municipio VALUES (4278, 'Siqueira Campos', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.392833', 'I');
INSERT INTO historico.municipio VALUES (4279, 'Sulina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.393627', 'I');
INSERT INTO historico.municipio VALUES (4280, 'Tamarana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.394497', 'I');
INSERT INTO historico.municipio VALUES (4281, 'Tamboara', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.395464', 'I');
INSERT INTO historico.municipio VALUES (4282, 'Tapejara', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.396622', 'I');
INSERT INTO historico.municipio VALUES (4283, 'Tapira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.397553', 'I');
INSERT INTO historico.municipio VALUES (4284, 'Teixeira Soares', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.398411', 'I');
INSERT INTO historico.municipio VALUES (4285, 'Telemaco Borba', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.399685', 'I');
INSERT INTO historico.municipio VALUES (4286, 'Terra Boa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.400592', 'I');
INSERT INTO historico.municipio VALUES (4287, 'Terra Rica', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.401465', 'I');
INSERT INTO historico.municipio VALUES (4288, 'Terra Roxa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.402543', 'I');
INSERT INTO historico.municipio VALUES (4289, 'Tibagi', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.403763', 'I');
INSERT INTO historico.municipio VALUES (4290, 'Tijucas do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.404751', 'I');
INSERT INTO historico.municipio VALUES (4291, 'Toledo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.405658', 'I');
INSERT INTO historico.municipio VALUES (4292, 'Tomazina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.406592', 'I');
INSERT INTO historico.municipio VALUES (4293, 'Tres Barras do Parana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.407465', 'I');
INSERT INTO historico.municipio VALUES (4294, 'Tunas do Parana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.408366', 'I');
INSERT INTO historico.municipio VALUES (4295, 'Tuneiras do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.409234', 'I');
INSERT INTO historico.municipio VALUES (4296, 'Tupassi', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.41021', 'I');
INSERT INTO historico.municipio VALUES (4297, 'Turvo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.410984', 'I');
INSERT INTO historico.municipio VALUES (4298, 'Ubirata', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.411853', 'I');
INSERT INTO historico.municipio VALUES (4299, 'Umuarama', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.412765', 'I');
INSERT INTO historico.municipio VALUES (4300, 'Uniao da Vitoria', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.413578', 'I');
INSERT INTO historico.municipio VALUES (4301, 'Uniflor', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.42009', 'I');
INSERT INTO historico.municipio VALUES (4302, 'Urai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.421232', 'I');
INSERT INTO historico.municipio VALUES (4308, 'Wenceslau Braz', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.426895', 'I');
INSERT INTO historico.municipio VALUES (4303, 'Ventania', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.422122', 'I');
INSERT INTO historico.municipio VALUES (4304, 'Vera Cruz do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.422901', 'I');
INSERT INTO historico.municipio VALUES (4305, 'Vere', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.423951', 'I');
INSERT INTO historico.municipio VALUES (3916, 'Alto Paraiso', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.99001', 'I');
INSERT INTO historico.municipio VALUES (4013, 'Doutor Ulysses', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.100967', 'I');
INSERT INTO historico.municipio VALUES (4306, 'Virmond', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.424896', 'I');
INSERT INTO historico.municipio VALUES (4307, 'Vitorino', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.425982', 'I');
INSERT INTO historico.municipio VALUES (4309, 'Xambre', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.427805', 'I');
INSERT INTO historico.municipio VALUES (4310, 'Abdon Batista', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.428638', 'I');
INSERT INTO historico.municipio VALUES (4311, 'Abelardo Luz', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.429547', 'I');
INSERT INTO historico.municipio VALUES (4312, 'Agrolandia', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.430478', 'I');
INSERT INTO historico.municipio VALUES (4313, 'Agronomica', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.431358', 'I');
INSERT INTO historico.municipio VALUES (4314, 'Agua Doce', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.43226', 'I');
INSERT INTO historico.municipio VALUES (4315, 'Aguas de Chapeco', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.433055', 'I');
INSERT INTO historico.municipio VALUES (4316, 'Aguas Frias', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.43394', 'I');
INSERT INTO historico.municipio VALUES (4317, 'Aguas Mornas', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.434905', 'I');
INSERT INTO historico.municipio VALUES (4318, 'Alfredo Wagner', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.435771', 'I');
INSERT INTO historico.municipio VALUES (4319, 'Alto Bela Vista', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.43669', 'I');
INSERT INTO historico.municipio VALUES (4320, 'Anchieta', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.43753', 'I');
INSERT INTO historico.municipio VALUES (4321, 'Angelina', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.43846', 'I');
INSERT INTO historico.municipio VALUES (4322, 'Anita Garibaldi', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.439314', 'I');
INSERT INTO historico.municipio VALUES (4323, 'Anitapolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.440162', 'I');
INSERT INTO historico.municipio VALUES (4324, 'Antonio Carlos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.440943', 'I');
INSERT INTO historico.municipio VALUES (4325, 'Apiuna', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.441712', 'I');
INSERT INTO historico.municipio VALUES (4326, 'Arabuta', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.442617', 'I');
INSERT INTO historico.municipio VALUES (4327, 'Araquari', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.44364', 'I');
INSERT INTO historico.municipio VALUES (4328, 'Ararangua', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.444439', 'I');
INSERT INTO historico.municipio VALUES (4329, 'Armazem', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.445254', 'I');
INSERT INTO historico.municipio VALUES (4330, 'Arroio Trinta', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.446176', 'I');
INSERT INTO historico.municipio VALUES (4331, 'Arvoredo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.447106', 'I');
INSERT INTO historico.municipio VALUES (4332, 'Ascurra', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.44797', 'I');
INSERT INTO historico.municipio VALUES (4333, 'Atalanta', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.448887', 'I');
INSERT INTO historico.municipio VALUES (4334, 'Aurora', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.449795', 'I');
INSERT INTO historico.municipio VALUES (4335, 'Balneario Arroio do Silva', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.450698', 'I');
INSERT INTO historico.municipio VALUES (4337, 'Balneario Camboriu', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.45249', 'I');
INSERT INTO historico.municipio VALUES (4336, 'Balneario Barra do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.451594', 'I');
INSERT INTO historico.municipio VALUES (4338, 'Balneario Gaivota', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.453461', 'I');
INSERT INTO historico.municipio VALUES (4339, 'Bandeirante', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.460344', 'I');
INSERT INTO historico.municipio VALUES (4340, 'Barra Bonita', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.461537', 'I');
INSERT INTO historico.municipio VALUES (4341, 'Barra Velha', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.462448', 'I');
INSERT INTO historico.municipio VALUES (4342, 'Bela Vista do Toldo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.463399', 'I');
INSERT INTO historico.municipio VALUES (4343, 'Belmonte', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.464282', 'I');
INSERT INTO historico.municipio VALUES (4344, 'Benedito Novo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.465195', 'I');
INSERT INTO historico.municipio VALUES (4345, 'Biguacu', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.466322', 'I');
INSERT INTO historico.municipio VALUES (4346, 'Blumenau', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.467185', 'I');
INSERT INTO historico.municipio VALUES (4347, 'Bocaina do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.468115', 'I');
INSERT INTO historico.municipio VALUES (4352, 'Bombinhas', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.472717', 'I');
INSERT INTO historico.municipio VALUES (4348, 'Bom Jardim da Serra', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.469091', 'I');
INSERT INTO historico.municipio VALUES (4349, 'Bom Jesus', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.469971', 'I');
INSERT INTO historico.municipio VALUES (4350, 'Bom Jesus do Oeste', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.470938', 'I');
INSERT INTO historico.municipio VALUES (4351, 'Bom Retiro', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.471851', 'I');
INSERT INTO historico.municipio VALUES (4353, 'Botuvera', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.473586', 'I');
INSERT INTO historico.municipio VALUES (4354, 'Braco do Norte', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.474511', 'I');
INSERT INTO historico.municipio VALUES (4355, 'Braco do Trombudo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.47539', 'I');
INSERT INTO historico.municipio VALUES (4356, 'Brunopolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.476535', 'I');
INSERT INTO historico.municipio VALUES (4357, 'Brusque', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.477593', 'I');
INSERT INTO historico.municipio VALUES (4358, 'Cacador', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.478494', 'I');
INSERT INTO historico.municipio VALUES (4359, 'Caibi', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.479391', 'I');
INSERT INTO historico.municipio VALUES (4360, 'Calmon', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.480305', 'I');
INSERT INTO historico.municipio VALUES (4361, 'Camboriu', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.481266', 'I');
INSERT INTO historico.municipio VALUES (4368, 'Capao Alto', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.488426', 'I');
INSERT INTO historico.municipio VALUES (4362, 'Campo Alegre', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.482024', 'I');
INSERT INTO historico.municipio VALUES (4363, 'Campo Belo do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.483299', 'I');
INSERT INTO historico.municipio VALUES (4364, 'Campo Ere', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.484528', 'I');
INSERT INTO historico.municipio VALUES (4365, 'Campos Novos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.48539', 'I');
INSERT INTO historico.municipio VALUES (4366, 'Canelinha', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.486284', 'I');
INSERT INTO historico.municipio VALUES (4367, 'Canoinhas', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.487206', 'I');
INSERT INTO historico.municipio VALUES (4369, 'Capinzal', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.489197', 'I');
INSERT INTO historico.municipio VALUES (4370, 'Capivari de Baixo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.490106', 'I');
INSERT INTO historico.municipio VALUES (4371, 'Catanduvas', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.491025', 'I');
INSERT INTO historico.municipio VALUES (4372, 'Caxambu do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.491954', 'I');
INSERT INTO historico.municipio VALUES (4373, 'Celso Ramos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.492847', 'I');
INSERT INTO historico.municipio VALUES (4374, 'Cerro Negro', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.493856', 'I');
INSERT INTO historico.municipio VALUES (4375, 'Chapadao do Lageado', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.500523', 'I');
INSERT INTO historico.municipio VALUES (4376, 'Chapeco', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.501768', 'I');
INSERT INTO historico.municipio VALUES (4377, 'Cocal do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.502784', 'I');
INSERT INTO historico.municipio VALUES (4378, 'Concordia', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.50375', 'I');
INSERT INTO historico.municipio VALUES (4379, 'Cordilheira Alta', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.504637', 'I');
INSERT INTO historico.municipio VALUES (4380, 'Coronel Freitas', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.50575', 'I');
INSERT INTO historico.municipio VALUES (4381, 'Coronel Martins', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.506666', 'I');
INSERT INTO historico.municipio VALUES (4383, 'Corupa', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.508452', 'I');
INSERT INTO historico.municipio VALUES (4382, 'Correia Pinto', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.507531', 'I');
INSERT INTO historico.municipio VALUES (4384, 'Criciuma', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.509451', 'I');
INSERT INTO historico.municipio VALUES (4385, 'Cunha Pora', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.510481', 'I');
INSERT INTO historico.municipio VALUES (4386, 'Cunhatai', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.511334', 'I');
INSERT INTO historico.municipio VALUES (4387, 'Curitibanos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.512194', 'I');
INSERT INTO historico.municipio VALUES (4388, 'Descanso', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.513047', 'I');
INSERT INTO historico.municipio VALUES (4389, 'Dionisio Cerqueira', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.513922', 'I');
INSERT INTO historico.municipio VALUES (4390, 'Dona Emma', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.514778', 'I');
INSERT INTO historico.municipio VALUES (4391, 'Doutor Pedrinho', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.515649', 'I');
INSERT INTO historico.municipio VALUES (4392, 'Entre Rios', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.516534', 'I');
INSERT INTO historico.municipio VALUES (4393, 'Ermo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.517512', 'I');
INSERT INTO historico.municipio VALUES (4394, 'Erval Velho', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.518414', 'I');
INSERT INTO historico.municipio VALUES (4395, 'Faxinal dos Guedes', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.519319', 'I');
INSERT INTO historico.municipio VALUES (4396, 'Flor do Sertao', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.520213', 'I');
INSERT INTO historico.municipio VALUES (4397, 'Florianopolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.521114', 'I');
INSERT INTO historico.municipio VALUES (4398, 'Formosa do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.522109', 'I');
INSERT INTO historico.municipio VALUES (4399, 'Forquilhinha', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.523012', 'I');
INSERT INTO historico.municipio VALUES (4400, 'Fraiburgo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.523979', 'I');
INSERT INTO historico.municipio VALUES (4401, 'Frei Rogerio', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.524846', 'I');
INSERT INTO historico.municipio VALUES (4402, 'Galvao', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.525743', 'I');
INSERT INTO historico.municipio VALUES (4403, 'Garopaba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.526646', 'I');
INSERT INTO historico.municipio VALUES (4404, 'Garuva', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.527531', 'I');
INSERT INTO historico.municipio VALUES (4405, 'Gaspar', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.528459', 'I');
INSERT INTO historico.municipio VALUES (4406, 'Governador Celso Ramos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.529386', 'I');
INSERT INTO historico.municipio VALUES (4407, 'Grao Para', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.530212', 'I');
INSERT INTO historico.municipio VALUES (4408, 'Gravatal', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.531116', 'I');
INSERT INTO historico.municipio VALUES (4409, 'Guabiruba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.53194', 'I');
INSERT INTO historico.municipio VALUES (4410, 'Guaraciaba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.532863', 'I');
INSERT INTO historico.municipio VALUES (4411, 'Guaramirim', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.533779', 'I');
INSERT INTO historico.municipio VALUES (4412, 'Guaruja do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.535074', 'I');
INSERT INTO historico.municipio VALUES (4413, 'Guatambu', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.541376', 'I');
INSERT INTO historico.municipio VALUES (4414, 'Herval D''oeste', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.542596', 'I');
INSERT INTO historico.municipio VALUES (4415, 'Ibiam', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.543705', 'I');
INSERT INTO historico.municipio VALUES (4416, 'Ibicare', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.544411', 'I');
INSERT INTO historico.municipio VALUES (4417, 'Ibirama', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.54531', 'I');
INSERT INTO historico.municipio VALUES (4418, 'Icara', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.546167', 'I');
INSERT INTO historico.municipio VALUES (4419, 'Ilhota', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.546952', 'I');
INSERT INTO historico.municipio VALUES (4420, 'Imarui', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.547891', 'I');
INSERT INTO historico.municipio VALUES (4421, 'Imbituba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.548745', 'I');
INSERT INTO historico.municipio VALUES (4422, 'Imbuia', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.549615', 'I');
INSERT INTO historico.municipio VALUES (4423, 'Indaial', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.550745', 'I');
INSERT INTO historico.municipio VALUES (4424, 'Iomere', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.551707', 'I');
INSERT INTO historico.municipio VALUES (4425, 'Ipira', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.552628', 'I');
INSERT INTO historico.municipio VALUES (4426, 'Ipora do Oeste', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.553489', 'I');
INSERT INTO historico.municipio VALUES (4427, 'Ipuacu', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.554353', 'I');
INSERT INTO historico.municipio VALUES (4428, 'Ipumirim', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.555764', 'I');
INSERT INTO historico.municipio VALUES (4429, 'Iraceminha', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.556864', 'I');
INSERT INTO historico.municipio VALUES (4430, 'Irani', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.557716', 'I');
INSERT INTO historico.municipio VALUES (4431, 'Irati', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.558657', 'I');
INSERT INTO historico.municipio VALUES (4432, 'Irineopolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.559588', 'I');
INSERT INTO historico.municipio VALUES (4433, 'Ita', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.56052', 'I');
INSERT INTO historico.municipio VALUES (4434, 'Itaiopolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.5614', 'I');
INSERT INTO historico.municipio VALUES (4435, 'Itajai', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.562258', 'I');
INSERT INTO historico.municipio VALUES (4436, 'Itapema', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.563129', 'I');
INSERT INTO historico.municipio VALUES (4437, 'Itapiranga', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.564104', 'I');
INSERT INTO historico.municipio VALUES (4438, 'Itapoa', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.565082', 'I');
INSERT INTO historico.municipio VALUES (4439, 'Ituporanga', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.566056', 'I');
INSERT INTO historico.municipio VALUES (4440, 'Jabora', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.566836', 'I');
INSERT INTO historico.municipio VALUES (4441, 'Jacinto Machado', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.567842', 'I');
INSERT INTO historico.municipio VALUES (4442, 'Jaguaruna', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.568806', 'I');
INSERT INTO historico.municipio VALUES (4443, 'Jaragua do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.569621', 'I');
INSERT INTO historico.municipio VALUES (4444, 'Jardinopolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.570517', 'I');
INSERT INTO historico.municipio VALUES (4445, 'Joacaba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.571308', 'I');
INSERT INTO historico.municipio VALUES (4446, 'Joinville', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.572209', 'I');
INSERT INTO historico.municipio VALUES (4447, 'Jose Boiteux', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.573179', 'I');
INSERT INTO historico.municipio VALUES (4448, 'Jupia', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.574057', 'I');
INSERT INTO historico.municipio VALUES (4449, 'Lacerdopolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.574936', 'I');
INSERT INTO historico.municipio VALUES (4450, 'Lages', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.581911', 'I');
INSERT INTO historico.municipio VALUES (4451, 'Laguna', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.583305', 'I');
INSERT INTO historico.municipio VALUES (4452, 'Lajeado Grande', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.584135', 'I');
INSERT INTO historico.municipio VALUES (4453, 'Laurentino', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.584973', 'I');
INSERT INTO historico.municipio VALUES (4454, 'Lauro Muller', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.585797', 'I');
INSERT INTO historico.municipio VALUES (4455, 'Lebon Regis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.586737', 'I');
INSERT INTO historico.municipio VALUES (4456, 'Leoberto Leal', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.587727', 'I');
INSERT INTO historico.municipio VALUES (4457, 'Lindoia do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.589095', 'I');
INSERT INTO historico.municipio VALUES (4458, 'Lontras', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.590019', 'I');
INSERT INTO historico.municipio VALUES (4459, 'Luiz Alves', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.590917', 'I');
INSERT INTO historico.municipio VALUES (4460, 'Luzerna', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.591816', 'I');
INSERT INTO historico.municipio VALUES (4461, 'Macieira', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.592688', 'I');
INSERT INTO historico.municipio VALUES (4462, 'Mafra', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.593594', 'I');
INSERT INTO historico.municipio VALUES (4463, 'Major Gercino', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.594511', 'I');
INSERT INTO historico.municipio VALUES (4464, 'Major Vieira', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.595378', 'I');
INSERT INTO historico.municipio VALUES (4465, 'Maracaja', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.59623', 'I');
INSERT INTO historico.municipio VALUES (4466, 'Maravilha', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.597301', 'I');
INSERT INTO historico.municipio VALUES (4467, 'Marema', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.598234', 'I');
INSERT INTO historico.municipio VALUES (4468, 'Massaranduba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.59912', 'I');
INSERT INTO historico.municipio VALUES (4469, 'Matos Costa', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.600611', 'I');
INSERT INTO historico.municipio VALUES (4470, 'Meleiro', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.601584', 'I');
INSERT INTO historico.municipio VALUES (4471, 'Mirim Doce', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.602525', 'I');
INSERT INTO historico.municipio VALUES (4472, 'Modelo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.603369', 'I');
INSERT INTO historico.municipio VALUES (4473, 'Mondai', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.604263', 'I');
INSERT INTO historico.municipio VALUES (4474, 'Monte Carlo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.605228', 'I');
INSERT INTO historico.municipio VALUES (4475, 'Monte Castelo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.606147', 'I');
INSERT INTO historico.municipio VALUES (4476, 'Morro da Fumaca', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.607036', 'I');
INSERT INTO historico.municipio VALUES (4477, 'Morro Grande', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.607994', 'I');
INSERT INTO historico.municipio VALUES (4478, 'Navegantes', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.608914', 'I');
INSERT INTO historico.municipio VALUES (4479, 'Nova Erechim', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.60984', 'I');
INSERT INTO historico.municipio VALUES (4480, 'Nova Itaberaba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.610808', 'I');
INSERT INTO historico.municipio VALUES (4481, 'Nova Trento', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.611579', 'I');
INSERT INTO historico.municipio VALUES (4482, 'Nova Veneza', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.612402', 'I');
INSERT INTO historico.municipio VALUES (4483, 'Novo Horizonte', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.61326', 'I');
INSERT INTO historico.municipio VALUES (4484, 'Orleans', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.614203', 'I');
INSERT INTO historico.municipio VALUES (4485, 'Otacilio Costa', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.615091', 'I');
INSERT INTO historico.municipio VALUES (4486, 'Ouro', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.615915', 'I');
INSERT INTO historico.municipio VALUES (4487, 'Ouro Verde', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.622292', 'I');
INSERT INTO historico.municipio VALUES (4488, 'Paial', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.624172', 'I');
INSERT INTO historico.municipio VALUES (4489, 'Painel', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.625092', 'I');
INSERT INTO historico.municipio VALUES (4490, 'Palhoca', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.625997', 'I');
INSERT INTO historico.municipio VALUES (4491, 'Palma Sola', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.626836', 'I');
INSERT INTO historico.municipio VALUES (4492, 'Palmeira', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.627753', 'I');
INSERT INTO historico.municipio VALUES (4493, 'Palmitos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.628577', 'I');
INSERT INTO historico.municipio VALUES (4494, 'Papanduva', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.629483', 'I');
INSERT INTO historico.municipio VALUES (4495, 'Paraiso', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.630489', 'I');
INSERT INTO historico.municipio VALUES (4496, 'Passo de Torres', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.631393', 'I');
INSERT INTO historico.municipio VALUES (4497, 'Passos Maia', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.632217', 'I');
INSERT INTO historico.municipio VALUES (4498, 'Paulo Lopes', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.633094', 'I');
INSERT INTO historico.municipio VALUES (4499, 'Pedras Grandes', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.634126', 'I');
INSERT INTO historico.municipio VALUES (4500, 'Penha', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.635075', 'I');
INSERT INTO historico.municipio VALUES (4501, 'Peritiba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.635905', 'I');
INSERT INTO historico.municipio VALUES (4502, 'Petrolandia', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.636576', 'I');
INSERT INTO historico.municipio VALUES (4503, 'Picarras', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.637358', 'I');
INSERT INTO historico.municipio VALUES (4504, 'Pinhalzinho', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.638178', 'I');
INSERT INTO historico.municipio VALUES (4505, 'Pinheiro Preto', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.639052', 'I');
INSERT INTO historico.municipio VALUES (4506, 'Piratuba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.640027', 'I');
INSERT INTO historico.municipio VALUES (4507, 'Planalto Alegre', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.640907', 'I');
INSERT INTO historico.municipio VALUES (4508, 'Pomerode', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.641749', 'I');
INSERT INTO historico.municipio VALUES (4509, 'Ponte Alta', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.642696', 'I');
INSERT INTO historico.municipio VALUES (4510, 'Ponte Alta do Norte', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.643679', 'I');
INSERT INTO historico.municipio VALUES (4511, 'Ponte Serrada', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.644826', 'I');
INSERT INTO historico.municipio VALUES (4512, 'Porto Belo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.645727', 'I');
INSERT INTO historico.municipio VALUES (4513, 'Porto Uniao', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.646532', 'I');
INSERT INTO historico.municipio VALUES (4514, 'Pouso Redondo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.647333', 'I');
INSERT INTO historico.municipio VALUES (4515, 'Praia Grande', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.648213', 'I');
INSERT INTO historico.municipio VALUES (4516, 'Presidente Castello Branco', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.64913', 'I');
INSERT INTO historico.municipio VALUES (4517, 'Presidente Getulio', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.650041', 'I');
INSERT INTO historico.municipio VALUES (4518, 'Presidente Nereu', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.650912', 'I');
INSERT INTO historico.municipio VALUES (4519, 'Princesa', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.651836', 'I');
INSERT INTO historico.municipio VALUES (4520, 'Quilombo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.65283', 'I');
INSERT INTO historico.municipio VALUES (4521, 'Rancho Queimado', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.65372', 'I');
INSERT INTO historico.municipio VALUES (4522, 'Rio das Antas', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.654634', 'I');
INSERT INTO historico.municipio VALUES (4523, 'Rio do Campo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.65549', 'I');
INSERT INTO historico.municipio VALUES (4524, 'Rio do Oeste', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.656406', 'I');
INSERT INTO historico.municipio VALUES (4526, 'Rio dos Cedros', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.664346', 'I');
INSERT INTO historico.municipio VALUES (4525, 'Rio do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.663037', 'I');
INSERT INTO historico.municipio VALUES (4527, 'Rio Fortuna', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.665268', 'I');
INSERT INTO historico.municipio VALUES (4528, 'Rio Negrinho', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.666145', 'I');
INSERT INTO historico.municipio VALUES (4529, 'Rio Rufino', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.667136', 'I');
INSERT INTO historico.municipio VALUES (4530, 'Riqueza', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.667883', 'I');
INSERT INTO historico.municipio VALUES (4531, 'Rodeio', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.668722', 'I');
INSERT INTO historico.municipio VALUES (4532, 'Romelandia', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.669664', 'I');
INSERT INTO historico.municipio VALUES (4533, 'Salete', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.670537', 'I');
INSERT INTO historico.municipio VALUES (4534, 'Saltinho', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.671426', 'I');
INSERT INTO historico.municipio VALUES (4535, 'Salto Veloso', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.672315', 'I');
INSERT INTO historico.municipio VALUES (4536, 'Sangao', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.67311', 'I');
INSERT INTO historico.municipio VALUES (4537, 'Santa Cecilia', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.674081', 'I');
INSERT INTO historico.municipio VALUES (4538, 'Santa Helena', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.674964', 'I');
INSERT INTO historico.municipio VALUES (4539, 'Santa Rosa de Lima', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.675907', 'I');
INSERT INTO historico.municipio VALUES (4540, 'Santa Rosa do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.676772', 'I');
INSERT INTO historico.municipio VALUES (4541, 'Santa Terezinha', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.677855', 'I');
INSERT INTO historico.municipio VALUES (4542, 'Santa Terezinha do Progresso', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.678617', 'I');
INSERT INTO historico.municipio VALUES (4543, 'Santiago do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.679531', 'I');
INSERT INTO historico.municipio VALUES (4544, 'Santo Amaro da Imperatriz', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.680401', 'I');
INSERT INTO historico.municipio VALUES (4546, 'Sao Bernardino', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.682107', 'I');
INSERT INTO historico.municipio VALUES (4545, 'Sao Bento do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.681233', 'I');
INSERT INTO historico.municipio VALUES (4547, 'Sao Bonifacio', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.683118', 'I');
INSERT INTO historico.municipio VALUES (4548, 'Sao Carlos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.683978', 'I');
INSERT INTO historico.municipio VALUES (4549, 'Sao Cristovao do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.684896', 'I');
INSERT INTO historico.municipio VALUES (4550, 'Sao Domingos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.685665', 'I');
INSERT INTO historico.municipio VALUES (4551, 'Sao Francisco do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.686536', 'I');
INSERT INTO historico.municipio VALUES (4554, 'Sao Joao do Oeste', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.689546', 'I');
INSERT INTO historico.municipio VALUES (4552, 'Sao Joao Batista', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.687673', 'I');
INSERT INTO historico.municipio VALUES (4553, 'Sao Joao do Itaperiu', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.688602', 'I');
INSERT INTO historico.municipio VALUES (4555, 'Sao Joao do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.690449', 'I');
INSERT INTO historico.municipio VALUES (4556, 'Sao Joaquim', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.691291', 'I');
INSERT INTO historico.municipio VALUES (4557, 'Sao Jose', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.692211', 'I');
INSERT INTO historico.municipio VALUES (4558, 'Sao Jose do Cedro', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.693112', 'I');
INSERT INTO historico.municipio VALUES (4559, 'Sao Jose do Cerrito', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.694047', 'I');
INSERT INTO historico.municipio VALUES (4560, 'Sao Lourenco do Oeste', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.694964', 'I');
INSERT INTO historico.municipio VALUES (4561, 'Sao Ludgero', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.695892', 'I');
INSERT INTO historico.municipio VALUES (4562, 'Sao Martinho', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.696805', 'I');
INSERT INTO historico.municipio VALUES (4563, 'Sao Miguel da Boa Vista', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.704183', 'I');
INSERT INTO historico.municipio VALUES (4564, 'Sao Miguel do Oeste', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.705337', 'I');
INSERT INTO historico.municipio VALUES (4565, 'Sao Pedro de Alcantara', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.706219', 'I');
INSERT INTO historico.municipio VALUES (4566, 'Saudades', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.707271', 'I');
INSERT INTO historico.municipio VALUES (4567, 'Schroeder', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.708028', 'I');
INSERT INTO historico.municipio VALUES (4568, 'Seara', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.70891', 'I');
INSERT INTO historico.municipio VALUES (4569, 'Serra Alta', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.709735', 'I');
INSERT INTO historico.municipio VALUES (4570, 'Sideropolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.710532', 'I');
INSERT INTO historico.municipio VALUES (4571, 'Sombrio', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.711816', 'I');
INSERT INTO historico.municipio VALUES (4572, 'Sul Brasil', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.712836', 'I');
INSERT INTO historico.municipio VALUES (4573, 'Taio', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.713717', 'I');
INSERT INTO historico.municipio VALUES (4574, 'Tangara', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.714564', 'I');
INSERT INTO historico.municipio VALUES (4575, 'Tigrinhos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.715422', 'I');
INSERT INTO historico.municipio VALUES (4576, 'Tijucas', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.716342', 'I');
INSERT INTO historico.municipio VALUES (4577, 'Timbe do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.717364', 'I');
INSERT INTO historico.municipio VALUES (4578, 'Timbo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.718247', 'I');
INSERT INTO historico.municipio VALUES (4579, 'Timbo Grande', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.719183', 'I');
INSERT INTO historico.municipio VALUES (4580, 'Tres Barras', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.720092', 'I');
INSERT INTO historico.municipio VALUES (4581, 'Treviso', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.720922', 'I');
INSERT INTO historico.municipio VALUES (4582, 'Treze de Maio', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.72182', 'I');
INSERT INTO historico.municipio VALUES (4583, 'Treze Tilias', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.723155', 'I');
INSERT INTO historico.municipio VALUES (4584, 'Trombudo Central', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.724091', 'I');
INSERT INTO historico.municipio VALUES (4585, 'Tubarao', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.725008', 'I');
INSERT INTO historico.municipio VALUES (4586, 'Tunapolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.725919', 'I');
INSERT INTO historico.municipio VALUES (4587, 'Turvo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.726812', 'I');
INSERT INTO historico.municipio VALUES (4588, 'Uniao do Oeste', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.727766', 'I');
INSERT INTO historico.municipio VALUES (4589, 'Urubici', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.728589', 'I');
INSERT INTO historico.municipio VALUES (4590, 'Urupema', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.729355', 'I');
INSERT INTO historico.municipio VALUES (4591, 'Urussanga', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.730223', 'I');
INSERT INTO historico.municipio VALUES (4592, 'Vargeao', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.731004', 'I');
INSERT INTO historico.municipio VALUES (4593, 'Vargem', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.73178', 'I');
INSERT INTO historico.municipio VALUES (4594, 'Vargem Bonita', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.732992', 'I');
INSERT INTO historico.municipio VALUES (4595, 'Vidal Ramos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.734534', 'I');
INSERT INTO historico.municipio VALUES (4596, 'Videira', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.735701', 'I');
INSERT INTO historico.municipio VALUES (4597, 'Vitor Meireles', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.736573', 'I');
INSERT INTO historico.municipio VALUES (4598, 'Witmarsum', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.73748', 'I');
INSERT INTO historico.municipio VALUES (4599, 'Xanxere', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.738315', 'I');
INSERT INTO historico.municipio VALUES (4600, 'Xavantina', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.744776', 'I');
INSERT INTO historico.municipio VALUES (4601, 'Xaxim', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.745932', 'I');
INSERT INTO historico.municipio VALUES (4602, 'Zortea', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.746831', 'I');
INSERT INTO historico.municipio VALUES (4603, 'Acegua', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.747752', 'I');
INSERT INTO historico.municipio VALUES (4604, 'Agua Santa', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.748623', 'I');
INSERT INTO historico.municipio VALUES (4605, 'Agudo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.749535', 'I');
INSERT INTO historico.municipio VALUES (4606, 'Ajuricaba', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.750335', 'I');
INSERT INTO historico.municipio VALUES (4607, 'Alecrim', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.751293', 'I');
INSERT INTO historico.municipio VALUES (4608, 'Alegrete', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.75216', 'I');
INSERT INTO historico.municipio VALUES (4609, 'Alegria', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.752979', 'I');
INSERT INTO historico.municipio VALUES (4610, 'Almirante Tamandare do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.75392', 'I');
INSERT INTO historico.municipio VALUES (4611, 'Alpestre', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.754809', 'I');
INSERT INTO historico.municipio VALUES (4612, 'Alto Alegre', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.755767', 'I');
INSERT INTO historico.municipio VALUES (4613, 'Alto Feliz', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.756681', 'I');
INSERT INTO historico.municipio VALUES (4614, 'Alvorada', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.75756', 'I');
INSERT INTO historico.municipio VALUES (4615, 'Amaral Ferrador', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.758517', 'I');
INSERT INTO historico.municipio VALUES (4616, 'Ametista do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.759328', 'I');
INSERT INTO historico.municipio VALUES (4617, 'Andre da Rocha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.760208', 'I');
INSERT INTO historico.municipio VALUES (4618, 'Anta Gorda', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.760999', 'I');
INSERT INTO historico.municipio VALUES (4619, 'Antonio Prado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.76193', 'I');
INSERT INTO historico.municipio VALUES (4620, 'Arambare', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.763109', 'I');
INSERT INTO historico.municipio VALUES (4621, 'Ararica', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.76479', 'I');
INSERT INTO historico.municipio VALUES (4622, 'Aratiba', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.765569', 'I');
INSERT INTO historico.municipio VALUES (4623, 'Arroio do Meio', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.766691', 'I');
INSERT INTO historico.municipio VALUES (4625, 'Arroio do Sal', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.768531', 'I');
INSERT INTO historico.municipio VALUES (4624, 'Arroio do Padre', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.767588', 'I');
INSERT INTO historico.municipio VALUES (4627, 'Arroio dos Ratos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.770348', 'I');
INSERT INTO historico.municipio VALUES (4626, 'Arroio do Tigre', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.769457', 'I');
INSERT INTO historico.municipio VALUES (4628, 'Arroio Grande', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.771225', 'I');
INSERT INTO historico.municipio VALUES (4629, 'Arvorezinha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.772101', 'I');
INSERT INTO historico.municipio VALUES (4630, 'Augusto Pestana', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.772977', 'I');
INSERT INTO historico.municipio VALUES (4631, 'Aurea', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.773902', 'I');
INSERT INTO historico.municipio VALUES (4632, 'Bage', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.774733', 'I');
INSERT INTO historico.municipio VALUES (4633, 'Balneario Pinhal', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.775604', 'I');
INSERT INTO historico.municipio VALUES (4634, 'Barao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.776395', 'I');
INSERT INTO historico.municipio VALUES (4635, 'Barao de Cotegipe', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.777163', 'I');
INSERT INTO historico.municipio VALUES (4636, 'Barao do Triunfo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.778243', 'I');
INSERT INTO historico.municipio VALUES (4642, 'Barracao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.789888', 'I');
INSERT INTO historico.municipio VALUES (4637, 'Barra do Guarita', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.784613', 'I');
INSERT INTO historico.municipio VALUES (4638, 'Barra do Quarai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.786135', 'I');
INSERT INTO historico.municipio VALUES (4639, 'Barra do Ribeiro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.787083', 'I');
INSERT INTO historico.municipio VALUES (4640, 'Barra do Rio Azul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.787963', 'I');
INSERT INTO historico.municipio VALUES (4641, 'Barra Funda', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.788957', 'I');
INSERT INTO historico.municipio VALUES (4643, 'Barros Cassal', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.790848', 'I');
INSERT INTO historico.municipio VALUES (4644, 'Benjamin Constant do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.791749', 'I');
INSERT INTO historico.municipio VALUES (4645, 'Bento Goncalves', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.792666', 'I');
INSERT INTO historico.municipio VALUES (4646, 'Boa Vista das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.793467', 'I');
INSERT INTO historico.municipio VALUES (4647, 'Boa Vista do Burica', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.794351', 'I');
INSERT INTO historico.municipio VALUES (4648, 'Boa Vista do Cadeado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.795209', 'I');
INSERT INTO historico.municipio VALUES (4649, 'Boa Vista do Incra', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.79609', 'I');
INSERT INTO historico.municipio VALUES (4650, 'Boa Vista do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.796974', 'I');
INSERT INTO historico.municipio VALUES (4651, 'Bom Jesus', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.797947', 'I');
INSERT INTO historico.municipio VALUES (4652, 'Bom Principio', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.799093', 'I');
INSERT INTO historico.municipio VALUES (4653, 'Bom Progresso', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.80005', 'I');
INSERT INTO historico.municipio VALUES (4654, 'Bom Retiro do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.800999', 'I');
INSERT INTO historico.municipio VALUES (4655, 'Boqueirao do Leao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.801898', 'I');
INSERT INTO historico.municipio VALUES (4656, 'Bossoroca', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.802916', 'I');
INSERT INTO historico.municipio VALUES (4657, 'Bozano', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.803916', 'I');
INSERT INTO historico.municipio VALUES (4658, 'Braga', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.804862', 'I');
INSERT INTO historico.municipio VALUES (4659, 'Brochier', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.805735', 'I');
INSERT INTO historico.municipio VALUES (4660, 'Butia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.806615', 'I');
INSERT INTO historico.municipio VALUES (4661, 'Cacapava do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.807519', 'I');
INSERT INTO historico.municipio VALUES (4662, 'Cacequi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.808337', 'I');
INSERT INTO historico.municipio VALUES (4663, 'Cachoeira do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.809202', 'I');
INSERT INTO historico.municipio VALUES (4664, 'Cachoeirinha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.810127', 'I');
INSERT INTO historico.municipio VALUES (4665, 'Cacique Doble', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.811004', 'I');
INSERT INTO historico.municipio VALUES (4666, 'Caibate', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.812204', 'I');
INSERT INTO historico.municipio VALUES (4667, 'Caicara', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.813081', 'I');
INSERT INTO historico.municipio VALUES (4668, 'Camaqua', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.813986', 'I');
INSERT INTO historico.municipio VALUES (4669, 'Camargo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.814864', 'I');
INSERT INTO historico.municipio VALUES (4670, 'Cambara do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.815791', 'I');
INSERT INTO historico.municipio VALUES (4671, 'Campestre da Serra', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.816669', 'I');
INSERT INTO historico.municipio VALUES (4672, 'Campina das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.817629', 'I');
INSERT INTO historico.municipio VALUES (4673, 'Campinas do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.818566', 'I');
INSERT INTO historico.municipio VALUES (4674, 'Campo Bom', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.819422', 'I');
INSERT INTO historico.municipio VALUES (4675, 'Campo Novo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.825975', 'I');
INSERT INTO historico.municipio VALUES (4676, 'Campos Borges', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.827145', 'I');
INSERT INTO historico.municipio VALUES (4677, 'Candelaria', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.828029', 'I');
INSERT INTO historico.municipio VALUES (4678, 'Candido Godoi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.828872', 'I');
INSERT INTO historico.municipio VALUES (4679, 'Candiota', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.829693', 'I');
INSERT INTO historico.municipio VALUES (4680, 'Canela', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.830636', 'I');
INSERT INTO historico.municipio VALUES (4681, 'Cangucu', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.831498', 'I');
INSERT INTO historico.municipio VALUES (4682, 'Canoas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.8323', 'I');
INSERT INTO historico.municipio VALUES (4683, 'Canudos do Vale', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.833266', 'I');
INSERT INTO historico.municipio VALUES (4684, 'Capao Bonito do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.834669', 'I');
INSERT INTO historico.municipio VALUES (4685, 'Capao da Canoa', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.835592', 'I');
INSERT INTO historico.municipio VALUES (4686, 'Capao do Cipo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.836576', 'I');
INSERT INTO historico.municipio VALUES (4687, 'Capao do Leao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.83748', 'I');
INSERT INTO historico.municipio VALUES (4690, 'Capivari do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.840285', 'I');
INSERT INTO historico.municipio VALUES (4688, 'Capela de Santana', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.838512', 'I');
INSERT INTO historico.municipio VALUES (4689, 'Capitao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.839442', 'I');
INSERT INTO historico.municipio VALUES (4692, 'Carazinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.842067', 'I');
INSERT INTO historico.municipio VALUES (4691, 'Caraa', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.841208', 'I');
INSERT INTO historico.municipio VALUES (4693, 'Carlos Barbosa', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.842932', 'I');
INSERT INTO historico.municipio VALUES (4694, 'Carlos Gomes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.843835', 'I');
INSERT INTO historico.municipio VALUES (4695, 'Casca', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.844744', 'I');
INSERT INTO historico.municipio VALUES (4696, 'Caseiros', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.845669', 'I');
INSERT INTO historico.municipio VALUES (4697, 'Catuipe', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.846536', 'I');
INSERT INTO historico.municipio VALUES (4698, 'Caxias do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.847409', 'I');
INSERT INTO historico.municipio VALUES (4699, 'Centenario', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.848283', 'I');
INSERT INTO historico.municipio VALUES (4700, 'Cerrito', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.849096', 'I');
INSERT INTO historico.municipio VALUES (4701, 'Cerro Branco', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.849907', 'I');
INSERT INTO historico.municipio VALUES (4702, 'Cerro Grande', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.850689', 'I');
INSERT INTO historico.municipio VALUES (4703, 'Cerro Grande do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.851567', 'I');
INSERT INTO historico.municipio VALUES (4704, 'Cerro Largo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.852471', 'I');
INSERT INTO historico.municipio VALUES (4705, 'Chapada', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.853292', 'I');
INSERT INTO historico.municipio VALUES (4706, 'Charqueadas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.854176', 'I');
INSERT INTO historico.municipio VALUES (4707, 'Charrua', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.855027', 'I');
INSERT INTO historico.municipio VALUES (4708, 'Chiapeta', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.85595', 'I');
INSERT INTO historico.municipio VALUES (4709, 'Chui', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.856725', 'I');
INSERT INTO historico.municipio VALUES (4710, 'Chuvisca', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.857603', 'I');
INSERT INTO historico.municipio VALUES (4711, 'Cidreira', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.85851', 'I');
INSERT INTO historico.municipio VALUES (4712, 'Ciriaco', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.859474', 'I');
INSERT INTO historico.municipio VALUES (4713, 'Colinas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.866184', 'I');
INSERT INTO historico.municipio VALUES (4714, 'Colorado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.86748', 'I');
INSERT INTO historico.municipio VALUES (4715, 'Condor', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.868275', 'I');
INSERT INTO historico.municipio VALUES (4716, 'Constantina', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.869145', 'I');
INSERT INTO historico.municipio VALUES (4717, 'Coqueiro Baixo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.870084', 'I');
INSERT INTO historico.municipio VALUES (4718, 'Coqueiros do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.87097', 'I');
INSERT INTO historico.municipio VALUES (4719, 'Coronel Barros', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.871889', 'I');
INSERT INTO historico.municipio VALUES (4720, 'Coronel Bicaco', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.872786', 'I');
INSERT INTO historico.municipio VALUES (4721, 'Coronel Pilar', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.873768', 'I');
INSERT INTO historico.municipio VALUES (4722, 'Cotipora', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.874553', 'I');
INSERT INTO historico.municipio VALUES (4723, 'Coxilha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.875317', 'I');
INSERT INTO historico.municipio VALUES (4724, 'Crissiumal', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.876204', 'I');
INSERT INTO historico.municipio VALUES (4725, 'Cristal', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.877062', 'I');
INSERT INTO historico.municipio VALUES (4726, 'Cristal do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.877944', 'I');
INSERT INTO historico.municipio VALUES (4727, 'Cruz Alta', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.879136', 'I');
INSERT INTO historico.municipio VALUES (4728, 'Cruzaltense', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.88005', 'I');
INSERT INTO historico.municipio VALUES (4729, 'Cruzeiro do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.880928', 'I');
INSERT INTO historico.municipio VALUES (4730, 'David Canabarro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.881777', 'I');
INSERT INTO historico.municipio VALUES (4731, 'Derrubadas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.882651', 'I');
INSERT INTO historico.municipio VALUES (4732, 'Dezesseis de Novembro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.883767', 'I');
INSERT INTO historico.municipio VALUES (4733, 'Dilermando de Aguiar', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.884831', 'I');
INSERT INTO historico.municipio VALUES (4734, 'Dois Irmaos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.885678', 'I');
INSERT INTO historico.municipio VALUES (4735, 'Dois Irmaos das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.886822', 'I');
INSERT INTO historico.municipio VALUES (4736, 'Dois Lajeados', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.887804', 'I');
INSERT INTO historico.municipio VALUES (4737, 'Dom Feliciano', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.889073', 'I');
INSERT INTO historico.municipio VALUES (4739, 'Dom Pedro de Alcantara', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.891631', 'I');
INSERT INTO historico.municipio VALUES (4738, 'Dom Pedrito', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.890589', 'I');
INSERT INTO historico.municipio VALUES (4740, 'Dona Francisca', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.892557', 'I');
INSERT INTO historico.municipio VALUES (4741, 'Doutor Mauricio Cardoso', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.893417', 'I');
INSERT INTO historico.municipio VALUES (4742, 'Doutor Ricardo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.894387', 'I');
INSERT INTO historico.municipio VALUES (4743, 'Eldorado do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.895258', 'I');
INSERT INTO historico.municipio VALUES (4744, 'Encantado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.896204', 'I');
INSERT INTO historico.municipio VALUES (4745, 'Encruzilhada do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.89707', 'I');
INSERT INTO historico.municipio VALUES (4746, 'Engenho Velho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.898021', 'I');
INSERT INTO historico.municipio VALUES (4748, 'Entre-ijuis', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.899999', 'I');
INSERT INTO historico.municipio VALUES (4747, 'Entre Rios do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.899076', 'I');
INSERT INTO historico.municipio VALUES (4749, 'Erebango', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.906919', 'I');
INSERT INTO historico.municipio VALUES (4750, 'Erechim', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.908132', 'I');
INSERT INTO historico.municipio VALUES (4751, 'Ernestina', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.909116', 'I');
INSERT INTO historico.municipio VALUES (4793, 'Herval', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.952112', 'I');
INSERT INTO historico.municipio VALUES (4752, 'Erval Grande', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.910038', 'I');
INSERT INTO historico.municipio VALUES (4753, 'Erval Seco', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.910899', 'I');
INSERT INTO historico.municipio VALUES (4754, 'Esmeralda', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.91172', 'I');
INSERT INTO historico.municipio VALUES (4755, 'Esperanca do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.912737', 'I');
INSERT INTO historico.municipio VALUES (4756, 'Espumoso', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.913602', 'I');
INSERT INTO historico.municipio VALUES (4757, 'Estacao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.914491', 'I');
INSERT INTO historico.municipio VALUES (4758, 'Estancia Velha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.915345', 'I');
INSERT INTO historico.municipio VALUES (4759, 'Esteio', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.916206', 'I');
INSERT INTO historico.municipio VALUES (4760, 'Estrela', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.917135', 'I');
INSERT INTO historico.municipio VALUES (4761, 'Estrela Velha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.918019', 'I');
INSERT INTO historico.municipio VALUES (4762, 'Eugenio de Castro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.918923', 'I');
INSERT INTO historico.municipio VALUES (4763, 'Fagundes Varela', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.919878', 'I');
INSERT INTO historico.municipio VALUES (4764, 'Farroupilha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.920693', 'I');
INSERT INTO historico.municipio VALUES (4765, 'Faxinal do Soturno', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.92163', 'I');
INSERT INTO historico.municipio VALUES (4766, 'Faxinalzinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.922524', 'I');
INSERT INTO historico.municipio VALUES (4767, 'Fazenda Vilanova', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.923302', 'I');
INSERT INTO historico.municipio VALUES (4768, 'Feliz', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.924228', 'I');
INSERT INTO historico.municipio VALUES (4769, 'Flores da Cunha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.925172', 'I');
INSERT INTO historico.municipio VALUES (4770, 'Floriano Peixoto', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.926129', 'I');
INSERT INTO historico.municipio VALUES (4771, 'Fontoura Xavier', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.927051', 'I');
INSERT INTO historico.municipio VALUES (4772, 'Formigueiro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.928008', 'I');
INSERT INTO historico.municipio VALUES (4773, 'Forquetinha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.928929', 'I');
INSERT INTO historico.municipio VALUES (4774, 'Fortaleza dos Valos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.929825', 'I');
INSERT INTO historico.municipio VALUES (4775, 'Frederico Westphalen', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.93063', 'I');
INSERT INTO historico.municipio VALUES (4776, 'Garibaldi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.931355', 'I');
INSERT INTO historico.municipio VALUES (4777, 'Garruchos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.932182', 'I');
INSERT INTO historico.municipio VALUES (4778, 'Gaurama', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.933069', 'I');
INSERT INTO historico.municipio VALUES (4779, 'General Camara', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.934026', 'I');
INSERT INTO historico.municipio VALUES (4780, 'Gentil', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.934915', 'I');
INSERT INTO historico.municipio VALUES (4781, 'Getulio Vargas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.935839', 'I');
INSERT INTO historico.municipio VALUES (4782, 'Girua', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.936719', 'I');
INSERT INTO historico.municipio VALUES (4783, 'Glorinha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.937632', 'I');
INSERT INTO historico.municipio VALUES (4784, 'Gramado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.938533', 'I');
INSERT INTO historico.municipio VALUES (4785, 'Gramado dos Loureiros', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.939344', 'I');
INSERT INTO historico.municipio VALUES (4786, 'Gramado Xavier', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.940203', 'I');
INSERT INTO historico.municipio VALUES (4787, 'Gravatai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.941029', 'I');
INSERT INTO historico.municipio VALUES (4788, 'Guabiju', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.947441', 'I');
INSERT INTO historico.municipio VALUES (4789, 'Guaiba', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.9486', 'I');
INSERT INTO historico.municipio VALUES (4790, 'Guapore', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.949507', 'I');
INSERT INTO historico.municipio VALUES (4791, 'Guarani das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.950373', 'I');
INSERT INTO historico.municipio VALUES (4792, 'Harmonia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.951225', 'I');
INSERT INTO historico.municipio VALUES (4794, 'Herveiras', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.953031', 'I');
INSERT INTO historico.municipio VALUES (4795, 'Horizontina', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.953898', 'I');
INSERT INTO historico.municipio VALUES (4796, 'Hulha Negra', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.954845', 'I');
INSERT INTO historico.municipio VALUES (4797, 'Humaita', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.955805', 'I');
INSERT INTO historico.municipio VALUES (4798, 'Ibarama', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.95672', 'I');
INSERT INTO historico.municipio VALUES (4799, 'Ibiaca', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.957546', 'I');
INSERT INTO historico.municipio VALUES (4800, 'Ibiraiaras', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.958417', 'I');
INSERT INTO historico.municipio VALUES (4801, 'Ibirapuita', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.959294', 'I');
INSERT INTO historico.municipio VALUES (4802, 'Ibiruba', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.96032', 'I');
INSERT INTO historico.municipio VALUES (4803, 'Igrejinha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.96119', 'I');
INSERT INTO historico.municipio VALUES (4804, 'Ijui', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.96206', 'I');
INSERT INTO historico.municipio VALUES (4805, 'Ilopolis', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.962987', 'I');
INSERT INTO historico.municipio VALUES (4806, 'Imbe', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.963785', 'I');
INSERT INTO historico.municipio VALUES (4807, 'Imigrante', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.965082', 'I');
INSERT INTO historico.municipio VALUES (4808, 'Independencia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.96594', 'I');
INSERT INTO historico.municipio VALUES (4809, 'Inhacora', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.966873', 'I');
INSERT INTO historico.municipio VALUES (4810, 'Ipe', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.967679', 'I');
INSERT INTO historico.municipio VALUES (4811, 'Ipiranga do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.968588', 'I');
INSERT INTO historico.municipio VALUES (4812, 'Irai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.969396', 'I');
INSERT INTO historico.municipio VALUES (4813, 'Itaara', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.970351', 'I');
INSERT INTO historico.municipio VALUES (4814, 'Itacurubi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.971294', 'I');
INSERT INTO historico.municipio VALUES (4815, 'Itapuca', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.972165', 'I');
INSERT INTO historico.municipio VALUES (4816, 'Itaqui', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.973061', 'I');
INSERT INTO historico.municipio VALUES (4817, 'Itati', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.974002', 'I');
INSERT INTO historico.municipio VALUES (4818, 'Itatiba do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.974873', 'I');
INSERT INTO historico.municipio VALUES (4819, 'Ivora', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.975784', 'I');
INSERT INTO historico.municipio VALUES (4820, 'Ivoti', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.976642', 'I');
INSERT INTO historico.municipio VALUES (4821, 'Jaboticaba', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.977503', 'I');
INSERT INTO historico.municipio VALUES (4822, 'Jacuizinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.978423', 'I');
INSERT INTO historico.municipio VALUES (4823, 'Jacutinga', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.979538', 'I');
INSERT INTO historico.municipio VALUES (4824, 'Jaguarao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.980338', 'I');
INSERT INTO historico.municipio VALUES (4825, 'Jaguari', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.981152', 'I');
INSERT INTO historico.municipio VALUES (4826, 'Jaquirana', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.987939', 'I');
INSERT INTO historico.municipio VALUES (4827, 'Jari', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.989393', 'I');
INSERT INTO historico.municipio VALUES (4828, 'Joia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.990672', 'I');
INSERT INTO historico.municipio VALUES (4829, 'Julio de Castilhos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.991636', 'I');
INSERT INTO historico.municipio VALUES (4830, 'Lagoa Bonita do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.992696', 'I');
INSERT INTO historico.municipio VALUES (4833, 'Lagoao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.995228', 'I');
INSERT INTO historico.municipio VALUES (4831, 'Lagoa dos Tres Cantos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.993546', 'I');
INSERT INTO historico.municipio VALUES (4832, 'Lagoa Vermelha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.99444', 'I');
INSERT INTO historico.municipio VALUES (4834, 'Lajeado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.996115', 'I');
INSERT INTO historico.municipio VALUES (4835, 'Lajeado do Bugre', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.996989', 'I');
INSERT INTO historico.municipio VALUES (4836, 'Lavras do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.998102', 'I');
INSERT INTO historico.municipio VALUES (4837, 'Liberato Salzano', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.999038', 'I');
INSERT INTO historico.municipio VALUES (4838, 'Lindolfo Collor', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.999932', 'I');
INSERT INTO historico.municipio VALUES (4839, 'Linha Nova', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.00075', 'I');
INSERT INTO historico.municipio VALUES (4841, 'Machadinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.002707', 'I');
INSERT INTO historico.municipio VALUES (4840, 'Macambara', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.001806', 'I');
INSERT INTO historico.municipio VALUES (4842, 'Mampituba', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.003651', 'I');
INSERT INTO historico.municipio VALUES (4843, 'Manoel Viana', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.004534', 'I');
INSERT INTO historico.municipio VALUES (4844, 'Maquine', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.005502', 'I');
INSERT INTO historico.municipio VALUES (4845, 'Marata', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.006454', 'I');
INSERT INTO historico.municipio VALUES (4846, 'Marau', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.007402', 'I');
INSERT INTO historico.municipio VALUES (4847, 'Marcelino Ramos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.008247', 'I');
INSERT INTO historico.municipio VALUES (4848, 'Mariana Pimentel', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.009044', 'I');
INSERT INTO historico.municipio VALUES (4849, 'Mariano Moro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.009911', 'I');
INSERT INTO historico.municipio VALUES (4850, 'Marques de Souza', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.010831', 'I');
INSERT INTO historico.municipio VALUES (4851, 'Mata', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.011716', 'I');
INSERT INTO historico.municipio VALUES (4852, 'Mato Castelhano', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.012915', 'I');
INSERT INTO historico.municipio VALUES (4853, 'Mato Leitao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.013882', 'I');
INSERT INTO historico.municipio VALUES (4854, 'Mato Queimado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.014734', 'I');
INSERT INTO historico.municipio VALUES (4934, 'Progresso', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.101105', 'I');
INSERT INTO historico.municipio VALUES (4855, 'Maximiliano de Almeida', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.01553', 'I');
INSERT INTO historico.municipio VALUES (4856, 'Minas do Leao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.016287', 'I');
INSERT INTO historico.municipio VALUES (4857, 'Miraguai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.017159', 'I');
INSERT INTO historico.municipio VALUES (4858, 'Montauri', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.018117', 'I');
INSERT INTO historico.municipio VALUES (4859, 'Monte Alegre dos Campos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.018991', 'I');
INSERT INTO historico.municipio VALUES (4860, 'Monte Belo do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.019902', 'I');
INSERT INTO historico.municipio VALUES (4861, 'Montenegro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.020835', 'I');
INSERT INTO historico.municipio VALUES (4862, 'Mormaco', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.02173', 'I');
INSERT INTO historico.municipio VALUES (4863, 'Morrinhos do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.028527', 'I');
INSERT INTO historico.municipio VALUES (4864, 'Morro Redondo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.02965', 'I');
INSERT INTO historico.municipio VALUES (4865, 'Morro Reuter', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.030692', 'I');
INSERT INTO historico.municipio VALUES (4866, 'Mostardas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.032073', 'I');
INSERT INTO historico.municipio VALUES (4867, 'Mucum', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.033021', 'I');
INSERT INTO historico.municipio VALUES (4868, 'Muitos Capoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.033894', 'I');
INSERT INTO historico.municipio VALUES (4869, 'Muliterno', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.03487', 'I');
INSERT INTO historico.municipio VALUES (4870, 'Nao-me-toque', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.035708', 'I');
INSERT INTO historico.municipio VALUES (4871, 'Nicolau Vergueiro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.036634', 'I');
INSERT INTO historico.municipio VALUES (4872, 'Nonoai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.037482', 'I');
INSERT INTO historico.municipio VALUES (4873, 'Nova Alvorada', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.038493', 'I');
INSERT INTO historico.municipio VALUES (4874, 'Nova Araca', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.039364', 'I');
INSERT INTO historico.municipio VALUES (4875, 'Nova Bassano', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.040191', 'I');
INSERT INTO historico.municipio VALUES (4876, 'Nova Boa Vista', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.041367', 'I');
INSERT INTO historico.municipio VALUES (4877, 'Nova Brescia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.042406', 'I');
INSERT INTO historico.municipio VALUES (4878, 'Nova Candelaria', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.043243', 'I');
INSERT INTO historico.municipio VALUES (4879, 'Nova Esperanca do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.044148', 'I');
INSERT INTO historico.municipio VALUES (4880, 'Nova Hartz', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.044942', 'I');
INSERT INTO historico.municipio VALUES (4881, 'Nova Padua', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.045858', 'I');
INSERT INTO historico.municipio VALUES (4882, 'Nova Palma', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.04664', 'I');
INSERT INTO historico.municipio VALUES (4883, 'Nova Petropolis', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.047523', 'I');
INSERT INTO historico.municipio VALUES (4884, 'Nova Prata', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.04839', 'I');
INSERT INTO historico.municipio VALUES (4885, 'Nova Ramada', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.049254', 'I');
INSERT INTO historico.municipio VALUES (4886, 'Nova Roma do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.050199', 'I');
INSERT INTO historico.municipio VALUES (4887, 'Nova Santa Rita', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.051107', 'I');
INSERT INTO historico.municipio VALUES (4889, 'Novo Cabrais', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.052834', 'I');
INSERT INTO historico.municipio VALUES (4890, 'Novo Hamburgo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.053668', 'I');
INSERT INTO historico.municipio VALUES (4891, 'Novo Machado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.054539', 'I');
INSERT INTO historico.municipio VALUES (4892, 'Novo Tiradentes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.055463', 'I');
INSERT INTO historico.municipio VALUES (4893, 'Novo Xingu', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.056358', 'I');
INSERT INTO historico.municipio VALUES (4888, 'Novo Barreiro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.052035', 'I');
INSERT INTO historico.municipio VALUES (4894, 'Osorio', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.057633', 'I');
INSERT INTO historico.municipio VALUES (4895, 'Paim Filho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.058522', 'I');
INSERT INTO historico.municipio VALUES (4896, 'Palmares do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.0594', 'I');
INSERT INTO historico.municipio VALUES (4897, 'Palmeira das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.06019', 'I');
INSERT INTO historico.municipio VALUES (4898, 'Palmitinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.061164', 'I');
INSERT INTO historico.municipio VALUES (4899, 'Panambi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.062045', 'I');
INSERT INTO historico.municipio VALUES (4900, 'Pantano Grande', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.062725', 'I');
INSERT INTO historico.municipio VALUES (4901, 'Parai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.069617', 'I');
INSERT INTO historico.municipio VALUES (4902, 'Paraiso do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.07061', 'I');
INSERT INTO historico.municipio VALUES (4903, 'Pareci Novo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.07147', 'I');
INSERT INTO historico.municipio VALUES (4904, 'Parobe', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.072404', 'I');
INSERT INTO historico.municipio VALUES (4905, 'Passa Sete', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.073291', 'I');
INSERT INTO historico.municipio VALUES (4906, 'Passo do Sobrado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.074185', 'I');
INSERT INTO historico.municipio VALUES (4907, 'Passo Fundo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.075119', 'I');
INSERT INTO historico.municipio VALUES (4908, 'Paulo Bento', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.076016', 'I');
INSERT INTO historico.municipio VALUES (4909, 'Paverama', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.076943', 'I');
INSERT INTO historico.municipio VALUES (4910, 'Pedras Altas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.077899', 'I');
INSERT INTO historico.municipio VALUES (4911, 'Pedro Osorio', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.078764', 'I');
INSERT INTO historico.municipio VALUES (4912, 'Pejucara', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.08024', 'I');
INSERT INTO historico.municipio VALUES (4913, 'Pelotas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.081029', 'I');
INSERT INTO historico.municipio VALUES (4914, 'Picada Cafe', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.082336', 'I');
INSERT INTO historico.municipio VALUES (4915, 'Pinhal', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.083171', 'I');
INSERT INTO historico.municipio VALUES (4916, 'Pinhal da Serra', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.083953', 'I');
INSERT INTO historico.municipio VALUES (4917, 'Pinhal Grande', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.084872', 'I');
INSERT INTO historico.municipio VALUES (4918, 'Pinheirinho do Vale', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.08576', 'I');
INSERT INTO historico.municipio VALUES (4919, 'Pinheiro Machado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.086681', 'I');
INSERT INTO historico.municipio VALUES (4920, 'Pirapo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.087579', 'I');
INSERT INTO historico.municipio VALUES (4921, 'Piratini', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.088495', 'I');
INSERT INTO historico.municipio VALUES (4922, 'Planalto', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.089514', 'I');
INSERT INTO historico.municipio VALUES (4923, 'Poco das Antas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.090675', 'I');
INSERT INTO historico.municipio VALUES (4924, 'Pontao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.091762', 'I');
INSERT INTO historico.municipio VALUES (4925, 'Ponte Preta', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.092594', 'I');
INSERT INTO historico.municipio VALUES (4926, 'Portao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.093566', 'I');
INSERT INTO historico.municipio VALUES (4927, 'Porto Alegre', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.094539', 'I');
INSERT INTO historico.municipio VALUES (4928, 'Porto Lucena', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.095462', 'I');
INSERT INTO historico.municipio VALUES (4929, 'Porto Maua', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.09633', 'I');
INSERT INTO historico.municipio VALUES (4930, 'Porto Vera Cruz', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.097306', 'I');
INSERT INTO historico.municipio VALUES (4931, 'Porto Xavier', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.098217', 'I');
INSERT INTO historico.municipio VALUES (4932, 'Pouso Novo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.099245', 'I');
INSERT INTO historico.municipio VALUES (4933, 'Presidente Lucena', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.10017', 'I');
INSERT INTO historico.municipio VALUES (4935, 'Protasio Alves', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.102143', 'I');
INSERT INTO historico.municipio VALUES (4936, 'Putinga', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.103128', 'I');
INSERT INTO historico.municipio VALUES (4937, 'Quarai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.10406', 'I');
INSERT INTO historico.municipio VALUES (4938, 'Quatro Irmaos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.110644', 'I');
INSERT INTO historico.municipio VALUES (4939, 'Quevedos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.111825', 'I');
INSERT INTO historico.municipio VALUES (4940, 'Quinze de Novembro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.112857', 'I');
INSERT INTO historico.municipio VALUES (4941, 'Redentora', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.113697', 'I');
INSERT INTO historico.municipio VALUES (4942, 'Relvado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.114655', 'I');
INSERT INTO historico.municipio VALUES (4943, 'Restinga Seca', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.115499', 'I');
INSERT INTO historico.municipio VALUES (4944, 'Rio dos Indios', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.116294', 'I');
INSERT INTO historico.municipio VALUES (4945, 'Rio Grande', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.117266', 'I');
INSERT INTO historico.municipio VALUES (4946, 'Rio Pardo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.118179', 'I');
INSERT INTO historico.municipio VALUES (4947, 'Riozinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.119135', 'I');
INSERT INTO historico.municipio VALUES (4948, 'Roca Sales', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.119995', 'I');
INSERT INTO historico.municipio VALUES (4949, 'Rodeio Bonito', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.120924', 'I');
INSERT INTO historico.municipio VALUES (4950, 'Rolador', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.121849', 'I');
INSERT INTO historico.municipio VALUES (4951, 'Rolante', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.122777', 'I');
INSERT INTO historico.municipio VALUES (4952, 'Ronda Alta', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.123656', 'I');
INSERT INTO historico.municipio VALUES (4953, 'Rondinha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.124514', 'I');
INSERT INTO historico.municipio VALUES (4954, 'Roque Gonzales', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.125383', 'I');
INSERT INTO historico.municipio VALUES (4955, 'Rosario do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.126163', 'I');
INSERT INTO historico.municipio VALUES (4956, 'Sagrada Familia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.127151', 'I');
INSERT INTO historico.municipio VALUES (4957, 'Saldanha Marinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.128127', 'I');
INSERT INTO historico.municipio VALUES (4958, 'Salto do Jacui', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.129107', 'I');
INSERT INTO historico.municipio VALUES (4959, 'Salvador das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.13005', 'I');
INSERT INTO historico.municipio VALUES (4960, 'Salvador do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.130968', 'I');
INSERT INTO historico.municipio VALUES (4961, 'Sananduva', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.131942', 'I');
INSERT INTO historico.municipio VALUES (4962, 'Santa Barbara do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.132733', 'I');
INSERT INTO historico.municipio VALUES (4963, 'Santa Cecilia do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.133677', 'I');
INSERT INTO historico.municipio VALUES (4964, 'Santa Clara do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.134621', 'I');
INSERT INTO historico.municipio VALUES (4965, 'Santa Cruz do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.135859', 'I');
INSERT INTO historico.municipio VALUES (4967, 'Santa Maria', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.137745', 'I');
INSERT INTO historico.municipio VALUES (4968, 'Santa Maria do Herval', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.138656', 'I');
INSERT INTO historico.municipio VALUES (4966, 'Santa Margarida do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.136798', 'I');
INSERT INTO historico.municipio VALUES (4972, 'Santana da Boa Vista', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.142334', 'I');
INSERT INTO historico.municipio VALUES (4973, 'Santana do Livramento', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.143302', 'I');
INSERT INTO historico.municipio VALUES (4969, 'Santa Rosa', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.139651', 'I');
INSERT INTO historico.municipio VALUES (4970, 'Santa Tereza', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.140575', 'I');
INSERT INTO historico.municipio VALUES (4971, 'Santa Vitoria do Palmar', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.141428', 'I');
INSERT INTO historico.municipio VALUES (4974, 'Santiago', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.144184', 'I');
INSERT INTO historico.municipio VALUES (4975, 'Santo Angelo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.150861', 'I');
INSERT INTO historico.municipio VALUES (4978, 'Santo Antonio do Palma', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.153811', 'I');
INSERT INTO historico.municipio VALUES (4976, 'Santo Antonio da Patrulha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.151967', 'I');
INSERT INTO historico.municipio VALUES (4977, 'Santo Antonio das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.152911', 'I');
INSERT INTO historico.municipio VALUES (4979, 'Santo Antonio do Planalto', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.154666', 'I');
INSERT INTO historico.municipio VALUES (4980, 'Santo Augusto', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.155574', 'I');
INSERT INTO historico.municipio VALUES (4981, 'Santo Cristo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.156456', 'I');
INSERT INTO historico.municipio VALUES (4982, 'Santo Expedito do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.157362', 'I');
INSERT INTO historico.municipio VALUES (4983, 'Sao Borja', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.158226', 'I');
INSERT INTO historico.municipio VALUES (4984, 'Sao Domingos do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.159172', 'I');
INSERT INTO historico.municipio VALUES (4985, 'Sao Francisco de Assis', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.160002', 'I');
INSERT INTO historico.municipio VALUES (4986, 'Sao Francisco de Paula', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.160916', 'I');
INSERT INTO historico.municipio VALUES (4987, 'Sao Gabriel', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.161758', 'I');
INSERT INTO historico.municipio VALUES (4988, 'Sao Jeronimo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.162555', 'I');
INSERT INTO historico.municipio VALUES (4989, 'Sao Joao da Urtiga', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.163489', 'I');
INSERT INTO historico.municipio VALUES (4990, 'Sao Joao do Polesine', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.164452', 'I');
INSERT INTO historico.municipio VALUES (4991, 'Sao Jorge', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.165471', 'I');
INSERT INTO historico.municipio VALUES (4992, 'Sao Jose das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.166514', 'I');
INSERT INTO historico.municipio VALUES (4993, 'Sao Jose do Herval', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.167402', 'I');
INSERT INTO historico.municipio VALUES (4994, 'Sao Jose do Hortencio', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.168302', 'I');
INSERT INTO historico.municipio VALUES (4995, 'Sao Jose do Inhacora', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.169448', 'I');
INSERT INTO historico.municipio VALUES (4996, 'Sao Jose do Norte', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.170483', 'I');
INSERT INTO historico.municipio VALUES (4997, 'Sao Jose do Ouro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.171355', 'I');
INSERT INTO historico.municipio VALUES (4998, 'Sao Jose do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.172279', 'I');
INSERT INTO historico.municipio VALUES (4999, 'Sao Jose dos Ausentes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.173227', 'I');
INSERT INTO historico.municipio VALUES (5000, 'Sao Leopoldo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.174112', 'I');
INSERT INTO historico.municipio VALUES (5001, 'Sao Lourenco do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.175066', 'I');
INSERT INTO historico.municipio VALUES (5002, 'Sao Luiz Gonzaga', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.176058', 'I');
INSERT INTO historico.municipio VALUES (5003, 'Sao Marcos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.176959', 'I');
INSERT INTO historico.municipio VALUES (5004, 'Sao Martinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.177897', 'I');
INSERT INTO historico.municipio VALUES (5005, 'Sao Martinho da Serra', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.178867', 'I');
INSERT INTO historico.municipio VALUES (5006, 'Sao Miguel das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.17986', 'I');
INSERT INTO historico.municipio VALUES (5007, 'Sao Nicolau', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.180803', 'I');
INSERT INTO historico.municipio VALUES (5008, 'Sao Paulo das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.181651', 'I');
INSERT INTO historico.municipio VALUES (5009, 'Sao Pedro da Serra', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.18264', 'I');
INSERT INTO historico.municipio VALUES (5010, 'Sao Pedro das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.183578', 'I');
INSERT INTO historico.municipio VALUES (5011, 'Sao Pedro do Butia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.184568', 'I');
INSERT INTO historico.municipio VALUES (5012, 'Sao Pedro do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.191638', 'I');
INSERT INTO historico.municipio VALUES (5013, 'Sao Sebastiao do Cai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.192927', 'I');
INSERT INTO historico.municipio VALUES (5014, 'Sao Sepe', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.193953', 'I');
INSERT INTO historico.municipio VALUES (5015, 'Sao Valentim', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.194793', 'I');
INSERT INTO historico.municipio VALUES (5016, 'Sao Valentim do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.195665', 'I');
INSERT INTO historico.municipio VALUES (5017, 'Sao Valerio do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.196491', 'I');
INSERT INTO historico.municipio VALUES (5018, 'Sao Vendelino', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.197532', 'I');
INSERT INTO historico.municipio VALUES (5019, 'Sao Vicente do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.198462', 'I');
INSERT INTO historico.municipio VALUES (5020, 'Sapiranga', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.199365', 'I');
INSERT INTO historico.municipio VALUES (5021, 'Sapucaia do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.200245', 'I');
INSERT INTO historico.municipio VALUES (5022, 'Sarandi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.201335', 'I');
INSERT INTO historico.municipio VALUES (5023, 'Seberi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.202194', 'I');
INSERT INTO historico.municipio VALUES (5024, 'Sede Nova', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.203247', 'I');
INSERT INTO historico.municipio VALUES (5025, 'Segredo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.204153', 'I');
INSERT INTO historico.municipio VALUES (5026, 'Selbach', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.205013', 'I');
INSERT INTO historico.municipio VALUES (5027, 'Senador Salgado Filho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.205893', 'I');
INSERT INTO historico.municipio VALUES (5028, 'Sentinela do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.206792', 'I');
INSERT INTO historico.municipio VALUES (5029, 'Serafina Correa', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.207836', 'I');
INSERT INTO historico.municipio VALUES (5030, 'Serio', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.208802', 'I');
INSERT INTO historico.municipio VALUES (5031, 'Sertao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.209619', 'I');
INSERT INTO historico.municipio VALUES (5032, 'Sertao Santana', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.210595', 'I');
INSERT INTO historico.municipio VALUES (5033, 'Sete de Setembro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.211625', 'I');
INSERT INTO historico.municipio VALUES (5034, 'Severiano de Almeida', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.21262', 'I');
INSERT INTO historico.municipio VALUES (5035, 'Silveira Martins', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.213555', 'I');
INSERT INTO historico.municipio VALUES (5036, 'Sinimbu', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.21458', 'I');
INSERT INTO historico.municipio VALUES (5037, 'Sobradinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.215477', 'I');
INSERT INTO historico.municipio VALUES (5038, 'Soledade', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.216332', 'I');
INSERT INTO historico.municipio VALUES (5039, 'Tabai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.21724', 'I');
INSERT INTO historico.municipio VALUES (5040, 'Tapejara', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.218094', 'I');
INSERT INTO historico.municipio VALUES (5041, 'Tapera', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.219034', 'I');
INSERT INTO historico.municipio VALUES (5042, 'Tapes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.219964', 'I');
INSERT INTO historico.municipio VALUES (5043, 'Taquara', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.220879', 'I');
INSERT INTO historico.municipio VALUES (5044, 'Taquari', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.221862', 'I');
INSERT INTO historico.municipio VALUES (5045, 'Taquarucu do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.222788', 'I');
INSERT INTO historico.municipio VALUES (5046, 'Tavares', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.223707', 'I');
INSERT INTO historico.municipio VALUES (5047, 'Tenente Portela', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.225347', 'I');
INSERT INTO historico.municipio VALUES (5048, 'Terra de Areia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.232849', 'I');
INSERT INTO historico.municipio VALUES (5049, 'Teutonia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.234121', 'I');
INSERT INTO historico.municipio VALUES (5050, 'Tio Hugo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.235123', 'I');
INSERT INTO historico.municipio VALUES (5051, 'Tiradentes do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.23607', 'I');
INSERT INTO historico.municipio VALUES (5052, 'Toropi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.236996', 'I');
INSERT INTO historico.municipio VALUES (5053, 'Torres', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.237913', 'I');
INSERT INTO historico.municipio VALUES (5054, 'Tramandai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.23885', 'I');
INSERT INTO historico.municipio VALUES (5055, 'Travesseiro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.239806', 'I');
INSERT INTO historico.municipio VALUES (5056, 'Tres Arroios', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.240805', 'I');
INSERT INTO historico.municipio VALUES (5057, 'Tres Cachoeiras', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.241777', 'I');
INSERT INTO historico.municipio VALUES (5058, 'Tres Coroas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.242724', 'I');
INSERT INTO historico.municipio VALUES (5059, 'Tres de Maio', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.243769', 'I');
INSERT INTO historico.municipio VALUES (5060, 'Tres Forquilhas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.244655', 'I');
INSERT INTO historico.municipio VALUES (5061, 'Tres Palmeiras', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.245532', 'I');
INSERT INTO historico.municipio VALUES (5062, 'Tres Passos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.246606', 'I');
INSERT INTO historico.municipio VALUES (5063, 'Trindade do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.247562', 'I');
INSERT INTO historico.municipio VALUES (5064, 'Triunfo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.248414', 'I');
INSERT INTO historico.municipio VALUES (5065, 'Tucunduva', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.249233', 'I');
INSERT INTO historico.municipio VALUES (5066, 'Tunas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.250107', 'I');
INSERT INTO historico.municipio VALUES (5067, 'Tupanci do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.250953', 'I');
INSERT INTO historico.municipio VALUES (5068, 'Tupancireta', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.251821', 'I');
INSERT INTO historico.municipio VALUES (5069, 'Tupandi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.252708', 'I');
INSERT INTO historico.municipio VALUES (5070, 'Tuparendi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.253578', 'I');
INSERT INTO historico.municipio VALUES (5071, 'Turucu', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.254432', 'I');
INSERT INTO historico.municipio VALUES (5072, 'Ubiretama', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.255333', 'I');
INSERT INTO historico.municipio VALUES (5073, 'Uniao da Serra', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.256245', 'I');
INSERT INTO historico.municipio VALUES (5074, 'Unistalda', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.257204', 'I');
INSERT INTO historico.municipio VALUES (5075, 'Uruguaiana', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.258629', 'I');
INSERT INTO historico.municipio VALUES (5076, 'Vacaria', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.259601', 'I');
INSERT INTO historico.municipio VALUES (5079, 'Vale Verde', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.262431', 'I');
INSERT INTO historico.municipio VALUES (5077, 'Vale do Sol', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.260531', 'I');
INSERT INTO historico.municipio VALUES (5078, 'Vale Real', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.261524', 'I');
INSERT INTO historico.municipio VALUES (5080, 'Vanini', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.263447', 'I');
INSERT INTO historico.municipio VALUES (5081, 'Venancio Aires', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.264406', 'I');
INSERT INTO historico.municipio VALUES (5082, 'Vera Cruz', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.265345', 'I');
INSERT INTO historico.municipio VALUES (5083, 'Veranopolis', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.26647', 'I');
INSERT INTO historico.municipio VALUES (5084, 'Vespasiano Correa', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.273349', 'I');
INSERT INTO historico.municipio VALUES (5085, 'Viadutos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.274527', 'I');
INSERT INTO historico.municipio VALUES (5086, 'Viamao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.275464', 'I');
INSERT INTO historico.municipio VALUES (5087, 'Vicente Dutra', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.276287', 'I');
INSERT INTO historico.municipio VALUES (5088, 'Victor Graeff', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.27728', 'I');
INSERT INTO historico.municipio VALUES (5089, 'Vila Flores', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.278305', 'I');
INSERT INTO historico.municipio VALUES (5090, 'Vila Langaro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.279156', 'I');
INSERT INTO historico.municipio VALUES (5091, 'Vila Maria', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.280109', 'I');
INSERT INTO historico.municipio VALUES (5092, 'Vila Nova do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.281043', 'I');
INSERT INTO historico.municipio VALUES (5093, 'Vista Alegre', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.281928', 'I');
INSERT INTO historico.municipio VALUES (5094, 'Vista Alegre do Prata', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.282888', 'I');
INSERT INTO historico.municipio VALUES (5095, 'Vista Gaucha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.283856', 'I');
INSERT INTO historico.municipio VALUES (5096, 'Vitoria das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.284731', 'I');
INSERT INTO historico.municipio VALUES (5097, 'Westfalia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.285646', 'I');
INSERT INTO historico.municipio VALUES (5098, 'Xangri-la', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.286521', 'I');
INSERT INTO historico.municipio VALUES (5099, 'Agua Clara', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.287518', 'I');
INSERT INTO historico.municipio VALUES (5100, 'Alcinopolis', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.288446', 'I');
INSERT INTO historico.municipio VALUES (5101, 'Amambai', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.289301', 'I');
INSERT INTO historico.municipio VALUES (5102, 'Anastacio', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.290239', 'I');
INSERT INTO historico.municipio VALUES (5103, 'Anaurilandia', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.291232', 'I');
INSERT INTO historico.municipio VALUES (5104, 'Angelica', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.292032', 'I');
INSERT INTO historico.municipio VALUES (5105, 'Antonio Joao', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.293133', 'I');
INSERT INTO historico.municipio VALUES (5106, 'Aparecida do Taboado', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.294053', 'I');
INSERT INTO historico.municipio VALUES (5107, 'Aquidauana', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.294884', 'I');
INSERT INTO historico.municipio VALUES (5108, 'Aral Moreira', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.29572', 'I');
INSERT INTO historico.municipio VALUES (5109, 'Bandeirantes', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.296713', 'I');
INSERT INTO historico.municipio VALUES (5110, 'Bataguassu', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.29763', 'I');
INSERT INTO historico.municipio VALUES (5112, 'Bela Vista', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.299542', 'I');
INSERT INTO historico.municipio VALUES (5113, 'Bodoquena', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.300463', 'I');
INSERT INTO historico.municipio VALUES (5114, 'Bonito', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.301372', 'I');
INSERT INTO historico.municipio VALUES (5115, 'Brasilandia', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.302327', 'I');
INSERT INTO historico.municipio VALUES (5116, 'Caarapo', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.303136', 'I');
INSERT INTO historico.municipio VALUES (5117, 'Camapua', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.304018', 'I');
INSERT INTO historico.municipio VALUES (5118, 'Campo Grande', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.30485', 'I');
INSERT INTO historico.municipio VALUES (5119, 'Caracol', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.305697', 'I');
INSERT INTO historico.municipio VALUES (5120, 'Cassilandia', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.306539', 'I');
INSERT INTO historico.municipio VALUES (5121, 'Chapadao do Sul', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.313766', 'I');
INSERT INTO historico.municipio VALUES (5122, 'Corguinho', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.314832', 'I');
INSERT INTO historico.municipio VALUES (5123, 'Coronel Sapucaia', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.315886', 'I');
INSERT INTO historico.municipio VALUES (5124, 'Corumba', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.316677', 'I');
INSERT INTO historico.municipio VALUES (5125, 'Costa Rica', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.317565', 'I');
INSERT INTO historico.municipio VALUES (5126, 'Coxim', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.318438', 'I');
INSERT INTO historico.municipio VALUES (5127, 'Deodapolis', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.319156', 'I');
INSERT INTO historico.municipio VALUES (5128, 'Dois Irmaos do Buriti', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.320079', 'I');
INSERT INTO historico.municipio VALUES (5129, 'Douradina', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.320958', 'I');
INSERT INTO historico.municipio VALUES (5130, 'Dourados', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.321841', 'I');
INSERT INTO historico.municipio VALUES (5131, 'Eldorado', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.322753', 'I');
INSERT INTO historico.municipio VALUES (5132, 'Fatima do Sul', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.323883', 'I');
INSERT INTO historico.municipio VALUES (5133, 'Figueirao', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.324801', 'I');
INSERT INTO historico.municipio VALUES (5134, 'Gloria de Dourados', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.325637', 'I');
INSERT INTO historico.municipio VALUES (5135, 'Guia Lopes da Laguna', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.326641', 'I');
INSERT INTO historico.municipio VALUES (5136, 'Iguatemi', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.327619', 'I');
INSERT INTO historico.municipio VALUES (5137, 'Inocencia', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.328612', 'I');
INSERT INTO historico.municipio VALUES (5138, 'Itapora', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.329508', 'I');
INSERT INTO historico.municipio VALUES (5139, 'Itaquirai', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.33029', 'I');
INSERT INTO historico.municipio VALUES (5140, 'Ivinhema', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.331111', 'I');
INSERT INTO historico.municipio VALUES (5141, 'Japora', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.332023', 'I');
INSERT INTO historico.municipio VALUES (5142, 'Jaraguari', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.332947', 'I');
INSERT INTO historico.municipio VALUES (5143, 'Jardim', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.333891', 'I');
INSERT INTO historico.municipio VALUES (5144, 'Jatei', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.334815', 'I');
INSERT INTO historico.municipio VALUES (5145, 'Juti', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.335804', 'I');
INSERT INTO historico.municipio VALUES (5146, 'Ladario', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.336612', 'I');
INSERT INTO historico.municipio VALUES (5147, 'Laguna Carapa', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.337536', 'I');
INSERT INTO historico.municipio VALUES (5148, 'Maracaju', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.338444', 'I');
INSERT INTO historico.municipio VALUES (5149, 'Miranda', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.33931', 'I');
INSERT INTO historico.municipio VALUES (5150, 'Mundo Novo', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.340178', 'I');
INSERT INTO historico.municipio VALUES (5151, 'Navirai', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.341075', 'I');
INSERT INTO historico.municipio VALUES (5152, 'Nioaque', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.341888', 'I');
INSERT INTO historico.municipio VALUES (5153, 'Nova Alvorada do Sul', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.342697', 'I');
INSERT INTO historico.municipio VALUES (5154, 'Nova Andradina', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.343615', 'I');
INSERT INTO historico.municipio VALUES (5155, 'Novo Horizonte do Sul', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.344527', 'I');
INSERT INTO historico.municipio VALUES (5156, 'Paranaiba', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.345447', 'I');
INSERT INTO historico.municipio VALUES (5157, 'Paranhos', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.346394', 'I');
INSERT INTO historico.municipio VALUES (5158, 'Pedro Gomes', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.347493', 'I');
INSERT INTO historico.municipio VALUES (5159, 'Ponta Pora', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.35418', 'I');
INSERT INTO historico.municipio VALUES (5160, 'Porto Murtinho', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.355395', 'I');
INSERT INTO historico.municipio VALUES (5161, 'Ribas do Rio Pardo', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.356263', 'I');
INSERT INTO historico.municipio VALUES (5162, 'Rio Brilhante', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.357159', 'I');
INSERT INTO historico.municipio VALUES (5163, 'Rio Negro', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.358428', 'I');
INSERT INTO historico.municipio VALUES (5164, 'Rio Verde de Mato Grosso', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.359236', 'I');
INSERT INTO historico.municipio VALUES (5165, 'Rochedo', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.360185', 'I');
INSERT INTO historico.municipio VALUES (5166, 'Santa Rita do Pardo', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.360982', 'I');
INSERT INTO historico.municipio VALUES (5167, 'Sao Gabriel do Oeste', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.362003', 'I');
INSERT INTO historico.municipio VALUES (5169, 'Sete Quedas', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.363971', 'I');
INSERT INTO historico.municipio VALUES (5168, 'Selviria', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.362991', 'I');
INSERT INTO historico.municipio VALUES (5170, 'Sidrolandia', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.364965', 'I');
INSERT INTO historico.municipio VALUES (5171, 'Sonora', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.366069', 'I');
INSERT INTO historico.municipio VALUES (5172, 'Tacuru', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.366911', 'I');
INSERT INTO historico.municipio VALUES (5173, 'Taquarussu', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.368294', 'I');
INSERT INTO historico.municipio VALUES (5174, 'Terenos', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.369444', 'I');
INSERT INTO historico.municipio VALUES (5175, 'Tres Lagoas', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.370315', 'I');
INSERT INTO historico.municipio VALUES (5176, 'Vicentina', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.371201', 'I');
INSERT INTO historico.municipio VALUES (5177, 'Acorizal', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.372079', 'I');
INSERT INTO historico.municipio VALUES (5178, 'Agua Boa', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.372947', 'I');
INSERT INTO historico.municipio VALUES (5179, 'Alta Floresta', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.373825', 'I');
INSERT INTO historico.municipio VALUES (5180, 'Alto Araguaia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.374753', 'I');
INSERT INTO historico.municipio VALUES (5181, 'Alto Boa Vista', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.375625', 'I');
INSERT INTO historico.municipio VALUES (5182, 'Alto Garcas', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.376478', 'I');
INSERT INTO historico.municipio VALUES (5183, 'Alto Paraguai', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.37727', 'I');
INSERT INTO historico.municipio VALUES (5184, 'Alto Taquari', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.378248', 'I');
INSERT INTO historico.municipio VALUES (5185, 'Apiacas', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.379176', 'I');
INSERT INTO historico.municipio VALUES (5186, 'Araguaiana', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.380109', 'I');
INSERT INTO historico.municipio VALUES (5187, 'Araguainha', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.381101', 'I');
INSERT INTO historico.municipio VALUES (5188, 'Araputanga', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.382033', 'I');
INSERT INTO historico.municipio VALUES (5189, 'Arenapolis', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.383142', 'I');
INSERT INTO historico.municipio VALUES (5190, 'Aripuana', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.383975', 'I');
INSERT INTO historico.municipio VALUES (5191, 'Barao de Melgaco', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.384902', 'I');
INSERT INTO historico.municipio VALUES (5192, 'Barra do Bugres', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.385821', 'I');
INSERT INTO historico.municipio VALUES (5193, 'Barra do Garcas', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.386784', 'I');
INSERT INTO historico.municipio VALUES (5194, 'Bom Jesus do Araguaia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.387912', 'I');
INSERT INTO historico.municipio VALUES (5195, 'Brasnorte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.395783', 'I');
INSERT INTO historico.municipio VALUES (5196, 'Caceres', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.396886', 'I');
INSERT INTO historico.municipio VALUES (5197, 'Campinapolis', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.397801', 'I');
INSERT INTO historico.municipio VALUES (5198, 'Campo Novo do Parecis', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.398624', 'I');
INSERT INTO historico.municipio VALUES (5199, 'Campo Verde', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.399594', 'I');
INSERT INTO historico.municipio VALUES (5200, 'Campos de Julio', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.400449', 'I');
INSERT INTO historico.municipio VALUES (5201, 'Canabrava do Norte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.401301', 'I');
INSERT INTO historico.municipio VALUES (5202, 'Canarana', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.402031', 'I');
INSERT INTO historico.municipio VALUES (5203, 'Carlinda', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.403458', 'I');
INSERT INTO historico.municipio VALUES (5204, 'Castanheira', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.404495', 'I');
INSERT INTO historico.municipio VALUES (5205, 'Chapada dos Guimaraes', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.405573', 'I');
INSERT INTO historico.municipio VALUES (5206, 'Claudia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.406653', 'I');
INSERT INTO historico.municipio VALUES (5207, 'Cocalinho', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.407608', 'I');
INSERT INTO historico.municipio VALUES (5208, 'Colider', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.408507', 'I');
INSERT INTO historico.municipio VALUES (5209, 'Colniza', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.409412', 'I');
INSERT INTO historico.municipio VALUES (5210, 'Comodoro', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.410397', 'I');
INSERT INTO historico.municipio VALUES (5211, 'Confresa', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.411332', 'I');
INSERT INTO historico.municipio VALUES (5212, 'Conquista D''oeste', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.412235', 'I');
INSERT INTO historico.municipio VALUES (5213, 'Cotriguacu', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.413221', 'I');
INSERT INTO historico.municipio VALUES (5214, 'Cuiaba', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.414149', 'I');
INSERT INTO historico.municipio VALUES (5216, 'Denise', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.416081', 'I');
INSERT INTO historico.municipio VALUES (5217, 'Diamantino', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.417014', 'I');
INSERT INTO historico.municipio VALUES (5218, 'Dom Aquino', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.417947', 'I');
INSERT INTO historico.municipio VALUES (5219, 'Feliz Natal', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.418926', 'I');
INSERT INTO historico.municipio VALUES (5220, 'Figueiropolis D''oeste', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.419849', 'I');
INSERT INTO historico.municipio VALUES (5221, 'Gaucha do Norte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.4207', 'I');
INSERT INTO historico.municipio VALUES (5222, 'General Carneiro', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.421639', 'I');
INSERT INTO historico.municipio VALUES (5223, 'Gloria D''oeste', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.422532', 'I');
INSERT INTO historico.municipio VALUES (5224, 'Guaranta do Norte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.423784', 'I');
INSERT INTO historico.municipio VALUES (5225, 'Guiratinga', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.424887', 'I');
INSERT INTO historico.municipio VALUES (5226, 'Indiavai', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.425733', 'I');
INSERT INTO historico.municipio VALUES (5227, 'Ipiranga do Norte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.426779', 'I');
INSERT INTO historico.municipio VALUES (5228, 'Itanhanga', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.427777', 'I');
INSERT INTO historico.municipio VALUES (5229, 'Itauba', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.42877', 'I');
INSERT INTO historico.municipio VALUES (5230, 'Itiquira', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.429726', 'I');
INSERT INTO historico.municipio VALUES (5231, 'Jaciara', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.436354', 'I');
INSERT INTO historico.municipio VALUES (5232, 'Jangada', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.437631', 'I');
INSERT INTO historico.municipio VALUES (5233, 'Jauru', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.438623', 'I');
INSERT INTO historico.municipio VALUES (5234, 'Juara', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.439558', 'I');
INSERT INTO historico.municipio VALUES (5235, 'Juina', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.440473', 'I');
INSERT INTO historico.municipio VALUES (5236, 'Juruena', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.441383', 'I');
INSERT INTO historico.municipio VALUES (5237, 'Juscimeira', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.442317', 'I');
INSERT INTO historico.municipio VALUES (5238, 'Lambari D''oeste', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.443327', 'I');
INSERT INTO historico.municipio VALUES (5239, 'Lucas do Rio Verde', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.444223', 'I');
INSERT INTO historico.municipio VALUES (5240, 'Luciara', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.445157', 'I');
INSERT INTO historico.municipio VALUES (5316, 'Vila Bela da Santissima Trindade', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.528916', 'I');
INSERT INTO historico.municipio VALUES (5241, 'Marcelandia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.446077', 'I');
INSERT INTO historico.municipio VALUES (5242, 'Matupa', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.447134', 'I');
INSERT INTO historico.municipio VALUES (5243, 'Mirassol D''oeste', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.448029', 'I');
INSERT INTO historico.municipio VALUES (5244, 'Nobres', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.448969', 'I');
INSERT INTO historico.municipio VALUES (5245, 'Nortelandia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.449889', 'I');
INSERT INTO historico.municipio VALUES (5246, 'Nossa Senhora do Livramento', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.450756', 'I');
INSERT INTO historico.municipio VALUES (5247, 'Nova Bandeirantes', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.451561', 'I');
INSERT INTO historico.municipio VALUES (5256, 'Nova Nazare', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.459757', 'I');
INSERT INTO historico.municipio VALUES (5251, 'Nova Lacerda', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.455047', 'I');
INSERT INTO historico.municipio VALUES (5258, 'Nova Santa Helena', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.461782', 'I');
INSERT INTO historico.municipio VALUES (5248, 'Nova Brasilandia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.452363', 'I');
INSERT INTO historico.municipio VALUES (5249, 'Nova Canaa do Norte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.453308', 'I');
INSERT INTO historico.municipio VALUES (5255, 'Nova Mutum', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.458788', 'I');
INSERT INTO historico.municipio VALUES (5257, 'Nova Olimpia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.460794', 'I');
INSERT INTO historico.municipio VALUES (5259, 'Nova Ubirata', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.462711', 'I');
INSERT INTO historico.municipio VALUES (5260, 'Nova Xavantina', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.463694', 'I');
INSERT INTO historico.municipio VALUES (5262, 'Novo Mundo', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.465458', 'I');
INSERT INTO historico.municipio VALUES (5261, 'Novo Horizonte do Norte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.464598', 'I');
INSERT INTO historico.municipio VALUES (5264, 'Novo Sao Joaquim', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.467249', 'I');
INSERT INTO historico.municipio VALUES (5265, 'Paranaita', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.468084', 'I');
INSERT INTO historico.municipio VALUES (5266, 'Paranatinga', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.469197', 'I');
INSERT INTO historico.municipio VALUES (5263, 'Novo Santo Antonio', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.466329', 'I');
INSERT INTO historico.municipio VALUES (5267, 'Pedra Preta', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.470265', 'I');
INSERT INTO historico.municipio VALUES (5268, 'Peixoto de Azevedo', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.471267', 'I');
INSERT INTO historico.municipio VALUES (5269, 'Planalto da Serra', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.477744', 'I');
INSERT INTO historico.municipio VALUES (5270, 'Pocone', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.478832', 'I');
INSERT INTO historico.municipio VALUES (5271, 'Pontal do Araguaia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.479747', 'I');
INSERT INTO historico.municipio VALUES (5272, 'Ponte Branca', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.480811', 'I');
INSERT INTO historico.municipio VALUES (5273, 'Pontes e Lacerda', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.481784', 'I');
INSERT INTO historico.municipio VALUES (5274, 'Porto Alegre do Norte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.482693', 'I');
INSERT INTO historico.municipio VALUES (5275, 'Porto dos Gauchos', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.483624', 'I');
INSERT INTO historico.municipio VALUES (5276, 'Porto Esperidiao', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.484579', 'I');
INSERT INTO historico.municipio VALUES (5277, 'Porto Estrela', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.485413', 'I');
INSERT INTO historico.municipio VALUES (5279, 'Primavera do Leste', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.487239', 'I');
INSERT INTO historico.municipio VALUES (5280, 'Querencia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.48811', 'I');
INSERT INTO historico.municipio VALUES (5300, 'Sao Jose dos Quatro Marcos', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.506858', 'I');
INSERT INTO historico.municipio VALUES (5281, 'Reserva do Cabacal', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.489033', 'I');
INSERT INTO historico.municipio VALUES (5282, 'Ribeirao Cascalheira', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.489983', 'I');
INSERT INTO historico.municipio VALUES (5283, 'Ribeiraozinho', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.490955', 'I');
INSERT INTO historico.municipio VALUES (5284, 'Rio Branco', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.491842', 'I');
INSERT INTO historico.municipio VALUES (5289, 'Santa Carmem', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.496894', 'I');
INSERT INTO historico.municipio VALUES (5293, 'Santo Afonso', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.50045', 'I');
INSERT INTO historico.municipio VALUES (5297, 'Sao Jose do Povo', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.504015', 'I');
INSERT INTO historico.municipio VALUES (5298, 'Sao Jose do Rio Claro', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.504954', 'I');
INSERT INTO historico.municipio VALUES (5299, 'Sao Jose do Xingu', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.505931', 'I');
INSERT INTO historico.municipio VALUES (5301, 'Sao Pedro da Cipa', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.507799', 'I');
INSERT INTO historico.municipio VALUES (5285, 'Rondolandia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.492869', 'I');
INSERT INTO historico.municipio VALUES (5286, 'Rondonopolis', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.493854', 'I');
INSERT INTO historico.municipio VALUES (5287, 'Rosario Oeste', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.494826', 'I');
INSERT INTO historico.municipio VALUES (5290, 'Santa Cruz do Xingu', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.497687', 'I');
INSERT INTO historico.municipio VALUES (5288, 'Salto do Ceu', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.495786', 'I');
INSERT INTO historico.municipio VALUES (5291, 'Santa Rita do Trivelato', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.498595', 'I');
INSERT INTO historico.municipio VALUES (5292, 'Santa Terezinha', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.499475', 'I');
INSERT INTO historico.municipio VALUES (5294, 'Santo Antonio do Leste', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.50133', 'I');
INSERT INTO historico.municipio VALUES (5295, 'Santo Antonio do Leverger', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.502127', 'I');
INSERT INTO historico.municipio VALUES (5296, 'Sao Felix do Araguaia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.503103', 'I');
INSERT INTO historico.municipio VALUES (5302, 'Sapezal', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.508718', 'I');
INSERT INTO historico.municipio VALUES (5303, 'Serra Nova Dourada', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.509707', 'I');
INSERT INTO historico.municipio VALUES (5304, 'Sinop', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.510666', 'I');
INSERT INTO historico.municipio VALUES (5305, 'Sorriso', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.51148', 'I');
INSERT INTO historico.municipio VALUES (5306, 'Tabapora', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.51804', 'I');
INSERT INTO historico.municipio VALUES (5307, 'Tangara da Serra', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.51929', 'I');
INSERT INTO historico.municipio VALUES (5308, 'Tapurah', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.520225', 'I');
INSERT INTO historico.municipio VALUES (5309, 'Terra Nova do Norte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.521047', 'I');
INSERT INTO historico.municipio VALUES (5310, 'Tesouro', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.521974', 'I');
INSERT INTO historico.municipio VALUES (5311, 'Torixoreu', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.52294', 'I');
INSERT INTO historico.municipio VALUES (5312, 'Uniao do Sul', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.523883', 'I');
INSERT INTO historico.municipio VALUES (5313, 'Vale de Sao Domingos', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.524972', 'I');
INSERT INTO historico.municipio VALUES (5314, 'Varzea Grande', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.526086', 'I');
INSERT INTO historico.municipio VALUES (5315, 'Vera', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.526999', 'I');
INSERT INTO historico.municipio VALUES (5317, 'Vila Rica', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.530101', 'I');
INSERT INTO historico.municipio VALUES (5250, 'Nova Guarita', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.45418', 'I');
INSERT INTO historico.municipio VALUES (5252, 'Nova Marilandia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.455908', 'I');
INSERT INTO historico.municipio VALUES (5253, 'Nova Maringa', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.456789', 'I');
INSERT INTO historico.municipio VALUES (5254, 'Nova Monte Verde', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.457859', 'I');
INSERT INTO historico.municipio VALUES (5318, 'Abadia de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.531009', 'I');
INSERT INTO historico.municipio VALUES (5319, 'Abadiania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.53199', 'I');
INSERT INTO historico.municipio VALUES (5320, 'Acreuna', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.532886', 'I');
INSERT INTO historico.municipio VALUES (5321, 'Adelandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.533668', 'I');
INSERT INTO historico.municipio VALUES (5322, 'Agua Fria de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.534826', 'I');
INSERT INTO historico.municipio VALUES (5323, 'Agua Limpa', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.535749', 'I');
INSERT INTO historico.municipio VALUES (5324, 'Aguas Lindas de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.53668', 'I');
INSERT INTO historico.municipio VALUES (5325, 'Alexania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.537739', 'I');
INSERT INTO historico.municipio VALUES (5326, 'Aloandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.53862', 'I');
INSERT INTO historico.municipio VALUES (5327, 'Alto Horizonte', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.539517', 'I');
INSERT INTO historico.municipio VALUES (5328, 'Alto Paraiso de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.540454', 'I');
INSERT INTO historico.municipio VALUES (5329, 'Alvorada do Norte', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.541418', 'I');
INSERT INTO historico.municipio VALUES (5330, 'Amaralina', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.542313', 'I');
INSERT INTO historico.municipio VALUES (5331, 'Americano do Brasil', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.543192', 'I');
INSERT INTO historico.municipio VALUES (5332, 'Amorinopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.544118', 'I');
INSERT INTO historico.municipio VALUES (5333, 'Anapolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.544995', 'I');
INSERT INTO historico.municipio VALUES (5334, 'Anhanguera', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.545877', 'I');
INSERT INTO historico.municipio VALUES (5335, 'Anicuns', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.54685', 'I');
INSERT INTO historico.municipio VALUES (5336, 'Aparecida de Goiania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.547789', 'I');
INSERT INTO historico.municipio VALUES (5337, 'Aparecida do Rio Doce', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.548635', 'I');
INSERT INTO historico.municipio VALUES (5338, 'Apore', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.549452', 'I');
INSERT INTO historico.municipio VALUES (5339, 'Aracu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.550511', 'I');
INSERT INTO historico.municipio VALUES (5340, 'Aragarcas', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.551456', 'I');
INSERT INTO historico.municipio VALUES (5341, 'Aragoiania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.558409', 'I');
INSERT INTO historico.municipio VALUES (5342, 'Araguapaz', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.559799', 'I');
INSERT INTO historico.municipio VALUES (5343, 'Arenopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.5608', 'I');
INSERT INTO historico.municipio VALUES (5344, 'Aruana', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.561736', 'I');
INSERT INTO historico.municipio VALUES (5345, 'Aurilandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.562641', 'I');
INSERT INTO historico.municipio VALUES (5346, 'Avelinopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.563516', 'I');
INSERT INTO historico.municipio VALUES (5347, 'Baliza', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.564819', 'I');
INSERT INTO historico.municipio VALUES (5348, 'Barro Alto', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.56604', 'I');
INSERT INTO historico.municipio VALUES (5349, 'Bela Vista de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.566961', 'I');
INSERT INTO historico.municipio VALUES (5350, 'Bom Jardim de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.567928', 'I');
INSERT INTO historico.municipio VALUES (5351, 'Bom Jesus de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.568869', 'I');
INSERT INTO historico.municipio VALUES (5352, 'Bonfinopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.569784', 'I');
INSERT INTO historico.municipio VALUES (5353, 'Bonopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.570757', 'I');
INSERT INTO historico.municipio VALUES (5354, 'Brazabrantes', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.571611', 'I');
INSERT INTO historico.municipio VALUES (5355, 'Britania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.572486', 'I');
INSERT INTO historico.municipio VALUES (5356, 'Buriti Alegre', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.57334', 'I');
INSERT INTO historico.municipio VALUES (5357, 'Buriti de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.57425', 'I');
INSERT INTO historico.municipio VALUES (5358, 'Buritinopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.575213', 'I');
INSERT INTO historico.municipio VALUES (5359, 'Cabeceiras', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.57613', 'I');
INSERT INTO historico.municipio VALUES (5360, 'Cachoeira Alta', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.577058', 'I');
INSERT INTO historico.municipio VALUES (5361, 'Cachoeira de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.577887', 'I');
INSERT INTO historico.municipio VALUES (5362, 'Cachoeira Dourada', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.578836', 'I');
INSERT INTO historico.municipio VALUES (5363, 'Cacu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.579767', 'I');
INSERT INTO historico.municipio VALUES (5364, 'Caiaponia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.580695', 'I');
INSERT INTO historico.municipio VALUES (5365, 'Caldas Novas', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.581988', 'I');
INSERT INTO historico.municipio VALUES (5366, 'Caldazinha', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.582914', 'I');
INSERT INTO historico.municipio VALUES (5367, 'Campestre de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.583775', 'I');
INSERT INTO historico.municipio VALUES (5368, 'Campinacu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.584712', 'I');
INSERT INTO historico.municipio VALUES (5369, 'Campinorte', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.585668', 'I');
INSERT INTO historico.municipio VALUES (5370, 'Campo Alegre de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.586525', 'I');
INSERT INTO historico.municipio VALUES (5371, 'Campo Limpo de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.587364', 'I');
INSERT INTO historico.municipio VALUES (5372, 'Campos Belos', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.588237', 'I');
INSERT INTO historico.municipio VALUES (5373, 'Campos Verdes', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.589202', 'I');
INSERT INTO historico.municipio VALUES (5374, 'Carmo do Rio Verde', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.590143', 'I');
INSERT INTO historico.municipio VALUES (5375, 'Castelandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.591002', 'I');
INSERT INTO historico.municipio VALUES (5376, 'Catalao', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.592188', 'I');
INSERT INTO historico.municipio VALUES (5377, 'Caturai', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.603004', 'I');
INSERT INTO historico.municipio VALUES (5378, 'Cavalcante', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.604319', 'I');
INSERT INTO historico.municipio VALUES (5379, 'Ceres', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.605372', 'I');
INSERT INTO historico.municipio VALUES (5380, 'Cezarina', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.606325', 'I');
INSERT INTO historico.municipio VALUES (5381, 'Chapadao do Ceu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.607336', 'I');
INSERT INTO historico.municipio VALUES (5382, 'Cidade Ocidental', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.608275', 'I');
INSERT INTO historico.municipio VALUES (5383, 'Cocalzinho de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.609119', 'I');
INSERT INTO historico.municipio VALUES (5384, 'Colinas do Sul', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.609959', 'I');
INSERT INTO historico.municipio VALUES (5385, 'Corrego do Ouro', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.610872', 'I');
INSERT INTO historico.municipio VALUES (5386, 'Corumba de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.611794', 'I');
INSERT INTO historico.municipio VALUES (5387, 'Corumbaiba', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.612763', 'I');
INSERT INTO historico.municipio VALUES (5388, 'Cristalina', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.613699', 'I');
INSERT INTO historico.municipio VALUES (5389, 'Cristianopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.614727', 'I');
INSERT INTO historico.municipio VALUES (5390, 'Crixas', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.615553', 'I');
INSERT INTO historico.municipio VALUES (5391, 'Crominia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.616462', 'I');
INSERT INTO historico.municipio VALUES (5392, 'Cumari', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.61735', 'I');
INSERT INTO historico.municipio VALUES (5393, 'Damianopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.618249', 'I');
INSERT INTO historico.municipio VALUES (5394, 'Damolandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.619199', 'I');
INSERT INTO historico.municipio VALUES (5395, 'Davinopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.620154', 'I');
INSERT INTO historico.municipio VALUES (5396, 'Diorama', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.621073', 'I');
INSERT INTO historico.municipio VALUES (5398, 'Doverlandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.623068', 'I');
INSERT INTO historico.municipio VALUES (5399, 'Edealina', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.623962', 'I');
INSERT INTO historico.municipio VALUES (5400, 'Edeia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.624932', 'I');
INSERT INTO historico.municipio VALUES (5401, 'Estrela do Norte', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.625947', 'I');
INSERT INTO historico.municipio VALUES (5402, 'Faina', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.626774', 'I');
INSERT INTO historico.municipio VALUES (5403, 'Fazenda Nova', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.627692', 'I');
INSERT INTO historico.municipio VALUES (5404, 'Firminopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.628612', 'I');
INSERT INTO historico.municipio VALUES (5405, 'Flores de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.629589', 'I');
INSERT INTO historico.municipio VALUES (5406, 'Formosa', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.630429', 'I');
INSERT INTO historico.municipio VALUES (5407, 'Formoso', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.631268', 'I');
INSERT INTO historico.municipio VALUES (5408, 'Gameleira de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.632204', 'I');
INSERT INTO historico.municipio VALUES (5397, 'Divinopolis de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.622032', 'I');
INSERT INTO historico.municipio VALUES (5409, 'Goianapolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.633039', 'I');
INSERT INTO historico.municipio VALUES (5410, 'Goiandira', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.633983', 'I');
INSERT INTO historico.municipio VALUES (5411, 'Goianesia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.634918', 'I');
INSERT INTO historico.municipio VALUES (5412, 'Goiania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.635858', 'I');
INSERT INTO historico.municipio VALUES (5413, 'Goianira', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.636781', 'I');
INSERT INTO historico.municipio VALUES (5414, 'Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.643396', 'I');
INSERT INTO historico.municipio VALUES (5415, 'Goiatuba', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.644646', 'I');
INSERT INTO historico.municipio VALUES (5416, 'Gouvelandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.645672', 'I');
INSERT INTO historico.municipio VALUES (5417, 'Guapo', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.646555', 'I');
INSERT INTO historico.municipio VALUES (5418, 'Guaraita', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.647553', 'I');
INSERT INTO historico.municipio VALUES (5419, 'Guarani de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.648866', 'I');
INSERT INTO historico.municipio VALUES (5420, 'Guarinos', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.649863', 'I');
INSERT INTO historico.municipio VALUES (5421, 'Heitorai', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.650692', 'I');
INSERT INTO historico.municipio VALUES (5422, 'Hidrolandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.651434', 'I');
INSERT INTO historico.municipio VALUES (5423, 'Hidrolina', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.65227', 'I');
INSERT INTO historico.municipio VALUES (5424, 'Iaciara', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.653174', 'I');
INSERT INTO historico.municipio VALUES (5425, 'Inaciolandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.654174', 'I');
INSERT INTO historico.municipio VALUES (5426, 'Indiara', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.655008', 'I');
INSERT INTO historico.municipio VALUES (5427, 'Inhumas', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.655851', 'I');
INSERT INTO historico.municipio VALUES (5428, 'Ipameri', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.656848', 'I');
INSERT INTO historico.municipio VALUES (5429, 'Ipiranga de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.657863', 'I');
INSERT INTO historico.municipio VALUES (5430, 'Ipora', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.658736', 'I');
INSERT INTO historico.municipio VALUES (5431, 'Israelandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.659837', 'I');
INSERT INTO historico.municipio VALUES (5432, 'Itaberai', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.660714', 'I');
INSERT INTO historico.municipio VALUES (5433, 'Itaguari', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.66169', 'I');
INSERT INTO historico.municipio VALUES (5434, 'Itaguaru', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.662571', 'I');
INSERT INTO historico.municipio VALUES (5435, 'Itaja', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.663372', 'I');
INSERT INTO historico.municipio VALUES (5436, 'Itapaci', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.664184', 'I');
INSERT INTO historico.municipio VALUES (5437, 'Itapirapua', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.665155', 'I');
INSERT INTO historico.municipio VALUES (5438, 'Itapuranga', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.666064', 'I');
INSERT INTO historico.municipio VALUES (5439, 'Itaruma', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.666945', 'I');
INSERT INTO historico.municipio VALUES (5440, 'Itaucu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.667766', 'I');
INSERT INTO historico.municipio VALUES (5441, 'Itumbiara', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.668731', 'I');
INSERT INTO historico.municipio VALUES (5442, 'Ivolandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.669617', 'I');
INSERT INTO historico.municipio VALUES (5443, 'Jandaia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.670602', 'I');
INSERT INTO historico.municipio VALUES (5444, 'Jaragua', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.671381', 'I');
INSERT INTO historico.municipio VALUES (5445, 'Jatai', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.672203', 'I');
INSERT INTO historico.municipio VALUES (5446, 'Jaupaci', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.673077', 'I');
INSERT INTO historico.municipio VALUES (5447, 'Jesupolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.67413', 'I');
INSERT INTO historico.municipio VALUES (5448, 'Joviania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.675038', 'I');
INSERT INTO historico.municipio VALUES (5449, 'Jussara', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.675958', 'I');
INSERT INTO historico.municipio VALUES (5450, 'Lagoa Santa', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.676927', 'I');
INSERT INTO historico.municipio VALUES (5451, 'Leopoldo de Bulhoes', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.687916', 'I');
INSERT INTO historico.municipio VALUES (5452, 'Luziania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.689054', 'I');
INSERT INTO historico.municipio VALUES (5453, 'Mairipotaba', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.689933', 'I');
INSERT INTO historico.municipio VALUES (5454, 'Mambai', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.69083', 'I');
INSERT INTO historico.municipio VALUES (5455, 'Mara Rosa', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.691716', 'I');
INSERT INTO historico.municipio VALUES (5456, 'Marzagao', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.692635', 'I');
INSERT INTO historico.municipio VALUES (5457, 'Matrincha', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.693504', 'I');
INSERT INTO historico.municipio VALUES (5458, 'Maurilandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.694336', 'I');
INSERT INTO historico.municipio VALUES (5459, 'Mimoso de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.695216', 'I');
INSERT INTO historico.municipio VALUES (5460, 'Minacu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.696172', 'I');
INSERT INTO historico.municipio VALUES (5461, 'Mineiros', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.697089', 'I');
INSERT INTO historico.municipio VALUES (5462, 'Moipora', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.698025', 'I');
INSERT INTO historico.municipio VALUES (5463, 'Monte Alegre de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.69892', 'I');
INSERT INTO historico.municipio VALUES (5464, 'Montes Claros de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.699882', 'I');
INSERT INTO historico.municipio VALUES (5465, 'Montividiu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.700799', 'I');
INSERT INTO historico.municipio VALUES (5466, 'Montividiu do Norte', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.701715', 'I');
INSERT INTO historico.municipio VALUES (5467, 'Morrinhos', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.702638', 'I');
INSERT INTO historico.municipio VALUES (5468, 'Morro Agudo de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.703663', 'I');
INSERT INTO historico.municipio VALUES (5469, 'Mossamedes', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.704418', 'I');
INSERT INTO historico.municipio VALUES (5470, 'Mozarlandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.705276', 'I');
INSERT INTO historico.municipio VALUES (5471, 'Mundo Novo', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.706025', 'I');
INSERT INTO historico.municipio VALUES (5472, 'Mutunopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.706843', 'I');
INSERT INTO historico.municipio VALUES (5473, 'Nazario', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.707701', 'I');
INSERT INTO historico.municipio VALUES (5474, 'Neropolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.708646', 'I');
INSERT INTO historico.municipio VALUES (5475, 'Niquelandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.709625', 'I');
INSERT INTO historico.municipio VALUES (5476, 'Nova America', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.710551', 'I');
INSERT INTO historico.municipio VALUES (5477, 'Nova Aurora', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.711502', 'I');
INSERT INTO historico.municipio VALUES (5478, 'Nova Crixas', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.712452', 'I');
INSERT INTO historico.municipio VALUES (5479, 'Nova Gloria', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.713407', 'I');
INSERT INTO historico.municipio VALUES (5480, 'Nova Iguacu de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.714282', 'I');
INSERT INTO historico.municipio VALUES (5481, 'Nova Roma', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.715252', 'I');
INSERT INTO historico.municipio VALUES (5482, 'Nova Veneza', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.716088', 'I');
INSERT INTO historico.municipio VALUES (5483, 'Novo Brasil', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.717048', 'I');
INSERT INTO historico.municipio VALUES (5484, 'Novo Gama', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.71804', 'I');
INSERT INTO historico.municipio VALUES (5485, 'Novo Planalto', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.718969', 'I');
INSERT INTO historico.municipio VALUES (5486, 'Orizona', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.71987', 'I');
INSERT INTO historico.municipio VALUES (5487, 'Ouro Verde de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.720782', 'I');
INSERT INTO historico.municipio VALUES (5488, 'Ouvidor', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.721647', 'I');
INSERT INTO historico.municipio VALUES (5489, 'Padre Bernardo', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.730377', 'I');
INSERT INTO historico.municipio VALUES (5490, 'Palestina de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.731494', 'I');
INSERT INTO historico.municipio VALUES (5491, 'Palmeiras de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.732416', 'I');
INSERT INTO historico.municipio VALUES (5492, 'Palmelo', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.733286', 'I');
INSERT INTO historico.municipio VALUES (5493, 'Palminopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.734292', 'I');
INSERT INTO historico.municipio VALUES (5494, 'Panama', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.735177', 'I');
INSERT INTO historico.municipio VALUES (5495, 'Paranaiguara', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.736027', 'I');
INSERT INTO historico.municipio VALUES (5496, 'Parauna', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.736912', 'I');
INSERT INTO historico.municipio VALUES (5497, 'Perolandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.738016', 'I');
INSERT INTO historico.municipio VALUES (5498, 'Petrolina de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.738872', 'I');
INSERT INTO historico.municipio VALUES (5499, 'Pilar de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.739682', 'I');
INSERT INTO historico.municipio VALUES (5500, 'Piracanjuba', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.740598', 'I');
INSERT INTO historico.municipio VALUES (5501, 'Piranhas', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.741497', 'I');
INSERT INTO historico.municipio VALUES (5502, 'Pirenopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.742364', 'I');
INSERT INTO historico.municipio VALUES (5503, 'Pires do Rio', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.743286', 'I');
INSERT INTO historico.municipio VALUES (5504, 'Planaltina', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.744194', 'I');
INSERT INTO historico.municipio VALUES (5505, 'Pontalina', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.745138', 'I');
INSERT INTO historico.municipio VALUES (5506, 'Porangatu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.746057', 'I');
INSERT INTO historico.municipio VALUES (5507, 'Porteirao', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.746977', 'I');
INSERT INTO historico.municipio VALUES (5508, 'Portelandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.747798', 'I');
INSERT INTO historico.municipio VALUES (5509, 'Posse', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.74865', 'I');
INSERT INTO historico.municipio VALUES (5510, 'Professor Jamil', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.749443', 'I');
INSERT INTO historico.municipio VALUES (5511, 'Quirinopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.606333', 'I');
INSERT INTO historico.municipio VALUES (5512, 'Rialma', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.339363', 'I');
INSERT INTO historico.municipio VALUES (5513, 'Rianapolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.527984', 'I');
INSERT INTO historico.municipio VALUES (5514, 'Rio Quente', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.750281', 'I');
INSERT INTO historico.municipio VALUES (5515, 'Rio Verde', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.75147', 'I');
INSERT INTO historico.municipio VALUES (5516, 'Rubiataba', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.752375', 'I');
INSERT INTO historico.municipio VALUES (5517, 'Sanclerlandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.75327', 'I');
INSERT INTO historico.municipio VALUES (5518, 'Santa Barbara de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.754126', 'I');
INSERT INTO historico.municipio VALUES (5519, 'Santa Cruz de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.754942', 'I');
INSERT INTO historico.municipio VALUES (5520, 'Santa Fe de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.755933', 'I');
INSERT INTO historico.municipio VALUES (5521, 'Santa Helena de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.756965', 'I');
INSERT INTO historico.municipio VALUES (5522, 'Santa Isabel', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.757965', 'I');
INSERT INTO historico.municipio VALUES (5523, 'Santa Rita do Araguaia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.758958', 'I');
INSERT INTO historico.municipio VALUES (5524, 'Santa Rita do Novo Destino', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.759916', 'I');
INSERT INTO historico.municipio VALUES (5525, 'Santa Rosa de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.760746', 'I');
INSERT INTO historico.municipio VALUES (5526, 'Santa Tereza de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.76171', 'I');
INSERT INTO historico.municipio VALUES (5527, 'Santa Terezinha de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.762654', 'I');
INSERT INTO historico.municipio VALUES (5528, 'Santo Antonio da Barra', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.763614', 'I');
INSERT INTO historico.municipio VALUES (5529, 'Santo Antonio de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.764441', 'I');
INSERT INTO historico.municipio VALUES (5530, 'Santo Antonio do Descoberto', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.771458', 'I');
INSERT INTO historico.municipio VALUES (5531, 'Sao Domingos', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.77252', 'I');
INSERT INTO historico.municipio VALUES (5532, 'Sao Francisco de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.773455', 'I');
INSERT INTO historico.municipio VALUES (5534, 'Sao Joao D''alianca', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.775239', 'I');
INSERT INTO historico.municipio VALUES (5533, 'Sao Joao da Parauna', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.774354', 'I');
INSERT INTO historico.municipio VALUES (5535, 'Sao Luis de Montes Belos', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.77614', 'I');
INSERT INTO historico.municipio VALUES (5536, 'Sao Luiz do Norte', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.776981', 'I');
INSERT INTO historico.municipio VALUES (5537, 'Sao Miguel do Araguaia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.777896', 'I');
INSERT INTO historico.municipio VALUES (5538, 'Sao Miguel do Passa Quatro', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.778808', 'I');
INSERT INTO historico.municipio VALUES (5539, 'Sao Patricio', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.779725', 'I');
INSERT INTO historico.municipio VALUES (5540, 'Sao Simao', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.780665', 'I');
INSERT INTO historico.municipio VALUES (5541, 'Senador Canedo', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.7816', 'I');
INSERT INTO historico.municipio VALUES (5542, 'Serranopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.78277', 'I');
INSERT INTO historico.municipio VALUES (5543, 'Silvania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.783748', 'I');
INSERT INTO historico.municipio VALUES (5544, 'Simolandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.784751', 'I');
INSERT INTO historico.municipio VALUES (5545, 'Sitio D''abadia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.785701', 'I');
INSERT INTO historico.municipio VALUES (5546, 'Taquaral de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.786631', 'I');
INSERT INTO historico.municipio VALUES (5547, 'Teresina de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.787611', 'I');
INSERT INTO historico.municipio VALUES (5548, 'Terezopolis de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.788494', 'I');
INSERT INTO historico.municipio VALUES (5549, 'Tres Ranchos', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.789421', 'I');
INSERT INTO historico.municipio VALUES (5550, 'Trindade', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.790358', 'I');
INSERT INTO historico.municipio VALUES (5551, 'Trombas', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.791247', 'I');
INSERT INTO historico.municipio VALUES (5552, 'Turvania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.792226', 'I');
INSERT INTO historico.municipio VALUES (5553, 'Turvelandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.793204', 'I');
INSERT INTO historico.municipio VALUES (5554, 'Uirapuru', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.794106', 'I');
INSERT INTO historico.municipio VALUES (5555, 'Uruacu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.795058', 'I');
INSERT INTO historico.municipio VALUES (5556, 'Uruana', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.796026', 'I');
INSERT INTO historico.municipio VALUES (5557, 'Urutai', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.796933', 'I');
INSERT INTO historico.municipio VALUES (5558, 'Valparaiso de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.797818', 'I');
INSERT INTO historico.municipio VALUES (5559, 'Varjao', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.798714', 'I');
INSERT INTO historico.municipio VALUES (5560, 'Vianopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.799587', 'I');
INSERT INTO historico.municipio VALUES (5561, 'Vicentinopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.800364', 'I');
INSERT INTO historico.municipio VALUES (5562, 'Vila Boa', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.801199', 'I');
INSERT INTO historico.municipio VALUES (5563, 'Vila Propicio', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.802078', 'I');
INSERT INTO historico.municipio VALUES (5564, 'Brasilia', 'DF', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.80332', 'I');


--
-- TOC entry 7660 (class 0 OID 9443694)
-- Dependencies: 371
-- Data for Name: pessoa; Type: TABLE DATA; Schema: historico; Owner: -
--



--
-- TOC entry 7661 (class 0 OID 9443704)
-- Dependencies: 372
-- Data for Name: socio; Type: TABLE DATA; Schema: historico; Owner: -
--



--
-- TOC entry 7662 (class 0 OID 9443712)
-- Dependencies: 373
-- Data for Name: area_conhecimento; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8229 (class 0 OID 0)
-- Dependencies: 374
-- Name: area_conhecimento_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.area_conhecimento_id_seq', 2, true);


--
-- TOC entry 7664 (class 0 OID 9443718)
-- Dependencies: 375
-- Data for Name: auditoria; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7665 (class 0 OID 9443724)
-- Dependencies: 376
-- Data for Name: auditoria_geral; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8230 (class 0 OID 0)
-- Dependencies: 850
-- Name: auditoria_geral_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.auditoria_geral_id_seq', 1, false);


--
-- TOC entry 7666 (class 0 OID 9443730)
-- Dependencies: 377
-- Data for Name: calendario_turma; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7667 (class 0 OID 9443733)
-- Dependencies: 378
-- Data for Name: componente_curricular; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7668 (class 0 OID 9443740)
-- Dependencies: 379
-- Data for Name: componente_curricular_ano_escolar; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8231 (class 0 OID 0)
-- Dependencies: 380
-- Name: componente_curricular_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.componente_curricular_id_seq', 2, true);


--
-- TOC entry 7670 (class 0 OID 9443745)
-- Dependencies: 381
-- Data for Name: componente_curricular_turma; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8131 (class 0 OID 9469019)
-- Dependencies: 844
-- Data for Name: config_movimento_geral; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8232 (class 0 OID 0)
-- Dependencies: 843
-- Name: config_movimento_geral_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.config_movimento_geral_id_seq', 1, false);


--
-- TOC entry 7671 (class 0 OID 9443751)
-- Dependencies: 382
-- Data for Name: docente_licenciatura; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8233 (class 0 OID 0)
-- Dependencies: 383
-- Name: docente_licenciatura_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.docente_licenciatura_id_seq', 1, false);


--
-- TOC entry 7673 (class 0 OID 9443756)
-- Dependencies: 384
-- Data for Name: educacenso_cod_aluno; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7674 (class 0 OID 9443762)
-- Dependencies: 385
-- Data for Name: educacenso_cod_docente; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7675 (class 0 OID 9443768)
-- Dependencies: 386
-- Data for Name: educacenso_cod_escola; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7676 (class 0 OID 9443774)
-- Dependencies: 387
-- Data for Name: educacenso_cod_turma; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7677 (class 0 OID 9443780)
-- Dependencies: 388
-- Data for Name: educacenso_curso_superior; Type: TABLE DATA; Schema: modules; Owner: -
--

INSERT INTO modules.educacenso_curso_superior VALUES (20, '145F09', 'Formação de professor de física', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (147, '213C07', 'Carnaval', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (96, '544M02', 'Mineração e extração', 5, 1, '2010-09-20 11:45:07.078', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (125, '142A01', 'Processos Escolares', 1, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (141, '212C02', 'Produção cênica', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (145, '213A05', 'Produção audiovisual', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (146, '213C06', 'Design gráfico', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (148, '213F01', 'Fotografia', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (149, '213P02', 'Produção multimídia', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (150, '213P03', 'Produção fonográfica', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (151, '213P05', 'Produção publicitária', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (152, '213P07', 'Produção Cultural', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (153, '214D02', 'Design de moda', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (155, '214D06', 'Design de Interiores', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (157, '214P01', 'Design de produto', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (158, '215C02', 'Conservação e restauro', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (159, '215F01', 'Fabricação de Instrumentos Musicais', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (162, '223C01', 'Comunicação assistiva', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (165, '225M02', 'Museografia', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (177, '340N02', 'Comércio exterior', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (178, '341N01', 'Negócios imobiliários', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (179, '342C01', 'Comunicação institucional', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (180, '342M02', 'Marketing', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (183, '343S01', 'Gestão de Seguros', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (186, '345A02', 'Gestão de cooperativas', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (187, '345A07', 'Gestão hospitalar', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (188, '345A10', 'Gestão pública', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (189, '345C01', 'Processos gerenciais', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (190, '345G09', 'Gestão de recursos humanos', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (191, '345G10', 'Gestão da qualidade', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (192, '345G13', 'Logística', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (193, '345G16', 'Gestão comercial', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (194, '345G17', 'Gestão financeira', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (195, '345G26', 'Gestão de segurança privada', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (196, '346S01', 'Secretariado', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (198, '421B12', 'Biotecnologia', 4, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (200, '422S01', 'Saneamento ambiental', 4, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (209, '481A01', 'Redes de computadores', 4, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (210, '481B01', 'Banco de dados', 4, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (211, '481T01', 'Gestão da tecnologia da informação', 4, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (212, '481T02', 'Jogos Digitais', 4, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (213, '482U01', 'Sistemas para internet', 4, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (214, '483S01', 'Análise e desenvolvimento de sistemas / Segurança da informação', 4, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (216, '520A01', 'Automação industrial', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (221, '520G01', 'Geoprocessamento', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (222, '520M01', 'Manutenção industrial', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (223, '520P02', 'Gestão da produção industrial', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (224, '520T01', 'Gestão de telecomunicações', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (227, '521M03', 'Mecânica de precisão', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (228, '521T02', 'Processos metalúrgicos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (229, '521T03', 'Fabricação mecânica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (230, '522D02', 'Sistemas elétricos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (232, '522E08', 'Sistemas de energia', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (233, '522R01', 'Refrigeração/Aquecimento', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (234, '522T02', 'Eletrotécnica industrial', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (240, '523M01', 'Sistemas biomédicos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (241, '523S03', 'Sistemas eletrônicos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (242, '523T01', 'Redes de telecomunicações / Sistemas de telecomunicações', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (243, '523T04', 'Mecatrônica industrial', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (244, '523T05', 'Telemática', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (245, '523T06', 'Eletrônica industrial', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (248, '524T03', 'Processos químicos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (249, '524T04', 'Biocombustíveis', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (250, '525A01', 'Mecanização Agrícola', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (251, '525C04', 'Construção naval', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (255, '525M01', 'Manutenção de aeronaves', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (256, '525S01', 'Sistemas Automotivos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (257, '540F02', 'Produção Joalheira/Design de jóias e gemas', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (258, '540F03', 'Produção Gráfica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (260, '541I02', 'Laticínios', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (261, '541P05', 'Processamento de Carnes', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (262, '541P09', 'Viticultura e Enologia', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (263, '541T01', 'Alimentos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (264, '541T02', 'Produção Sucroalcooleira', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (265, '541T03', 'Produção de Cachaça', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (266, '542B01', 'Bioenergia', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (268, '542I01', 'Produção de vestuário', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (269, '542I02', 'Produção têxtil', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (270, '543C01', 'Cerâmica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (271, '543F03', 'Produção moveleira', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (272, '543F05', 'Papel e celulose', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (273, '543P06', 'Polímeros', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (275, '544E05', 'Petróleo e gás', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (277, '544R01', 'Rochas ornamentais', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (278, '544T01', 'Tecnologia de Mineração', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (279, '582A01', 'Obras hidráulicas', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (280, '582A02', 'Agrimensura', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (281, '582C05', 'Construção de Edifícios', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (284, '582M02', 'Material de construção', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (285, '582O01', 'Controle de obras', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (286, '582T04', 'Estradas', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (287, '621A03', 'Agroindústria', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (289, '621A06', 'Agroecologia', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (291, '621M02', 'Produção Agrícola', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (292, '621T01', 'Irrigação e Drenagem', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (293, '621T03', 'Agronegócio', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (294, '621T04', 'Cafeicultura', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (295, '621T05', 'Produção de Grãos', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (297, '622H01', 'Horticultura', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (298, '623S01', 'Silvicultura', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (299, '624A01', 'Aqüicultura', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (301, '624T01', 'Produção Pesqueira', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (305, '721O02', 'Oftálmica', 7, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (307, '725T06', 'Radiologia', 7, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (308, '726O01', 'Óptica e Optometria', 7, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (312, '811G01', 'Gastronomia', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (313, '811H02', 'Hotelaria', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (314, '811H03', 'Hotelaria Hospitalar', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (315, '812E01', 'Eventos', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (316, '812P01', 'Gestão de Turismo', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (318, '813F02', 'Futebol', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (319, '813G02', 'Gestão desportiva e de lazer', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (321, '815E01', 'Estética e Cosmética', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (322, '840A01', 'Pilotagem profissional de aeronaves', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (325, '840N02', 'Sistemas de navegação fluvial', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (326, '840S01', 'Gestão portuária', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (327, '840S02', 'Transporte aéreo', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (328, '840T02', 'Transporte terrestre', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (329, '850G01', 'Processos ambientais / Gestão ambiental', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (330, '861S02', 'Segurança no trânsito / Segurança pública', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (331, '861S03', 'Serviços penais', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (332, '862S01', 'Segurança no trabalho', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (338, '999992', 'Outro curso de formação superior', 9, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO modules.educacenso_curso_superior VALUES (15, '145F01', 'Formação de professor de biologia', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (16, '145F02', 'Formação de professor de ciências', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (17, '145F05', 'Formação de professor de educação religiosa', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (19, '145F08', 'Formação de professor de filosofia', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (21, '145F10', 'Formação de professor de geografia', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (22, '145F11', 'Formação de professor de história', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (24, '145F15', 'Formação de professor de português', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (26, '145F18', 'Formação de professor de matemática', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (27, '145F21', 'Formação de professor de química', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (28, '145F24', 'Formação de professor de sociologia', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (32, '146P01', 'Formação de professor de disciplinas profissionais - CONTROLE E PROCESSOS INDUSTRIAIS', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (126, '142P01', 'Pedagogia', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (127, '144F12', 'Licenciatura Interdisciplinar em Ciências Humanas', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (128, '144F13', 'Licenciatura Intercultural Indígena', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (129, '145F14', 'Letras - Língua Estrangeira', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (130, '145F17', 'Letras - Língua Portuguesa e Estrangeira', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (131, '145F28', 'Libras', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (132, '146F02', 'Licenciatura Interdisciplinar em Artes (Educação Artística', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (133, '146F04', 'Artes Visuais', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (134, '146F05', 'Informática', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (135, '146F07', 'Dança', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (136, '146F09', 'Licenciatura Interdisciplinar em Educação no Campo', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (137, '146F15', 'Educação Física', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (138, '146F20', 'Música', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (139, '146F22', 'Teatro', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (203, '443C01', 'Ciência da Terra', 4, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (336, '999990', 'Outro curso de formação superior', 9, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO modules.educacenso_curso_superior VALUES (1, '142C01', 'Ciências da educação', 1, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (38, '210A01', 'Artes', 2, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (43, '220H01', 'Humanidades', 2, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (47, '220L03', 'Letras português e línguas estrangeiras', 2, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (49, '225A01', 'Arqueologia', 2, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (50, '225H01', 'História', 2, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (51, '225M01', 'Museologia', 2, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (54, '311P02', 'Psicologia', 3, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (56, '314E02', 'Economia', 3, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (66, '380D01', 'Direito', 3, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (70, '421B07', 'Biomedicina', 4, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (72, '441F01', 'Física', 4, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (73, '442Q01', 'Química', 4, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (76, '443M01', 'Meteorologia', 4, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (78, '461M01', 'Matemática', 4, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (79, '462E01', 'Estatística', 4, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (80, '481C01', 'Ciência da computação', 4, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (86, '523E04', 'Engenharia de computação', 5, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (87, '523E04', 'Engenharia de redes de comunicação', 5, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (90, '524E06', 'Engenharia nuclear', 5, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (97, '581A05', 'Arquitetura e urbanismo', 5, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (100, '623E01', 'Engenharia florestal - silvicultura', 6, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (103, '720S01', 'Saúde', 7, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (105, '721M01', 'Medicina', 7, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (107, '724O01', 'Odontologia', 7, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (109, '726F01', 'Fisioterapia', 7, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (110, '726F03', 'Fonoaudiologia', 7, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (111, '726N02', 'Nutrição', 7, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (112, '727F01', 'Farmácia', 7, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (140, '211A02', 'Artes Visuais', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (142, '212D01', 'Dança', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (143, '212M02', 'Música', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (144, '212T01', 'Teatro', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (154, '214D05', 'Design', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (156, '214M01', 'Moda', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (160, '221T01', 'Teologia', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (161, '222L01', 'Letras - Língua Estrangeira', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (163, '223L01', 'Letras - Língua Portuguesa', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (164, '223L02', 'Libras', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (166, '226F01', 'Filosofia', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (167, '310C02', 'Ciências Sociais', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (168, '312A01', 'Antropologia', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (169, '313C01', 'Ciência política', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (170, '313R01', 'Relações Internacionais', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (171, '321C01', 'Cinema e Audiovisual', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (172, '321C02', 'Comunicação Social (Área Geral', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (173, '321J01', 'Jornalismo', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (174, '321R01', '"Radio, TV, Internet', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (175, '322A01', 'Arquivologia', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (176, '322B01', 'Biblioteconomia', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (181, '342P02', 'Publicidade e Propaganda', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (182, '342R01', 'Relações Públicas', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (184, '344C02', 'Ciências Contábeis', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (185, '345A01', 'Administração', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (197, '346S03', 'Secretariado Executivo', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (199, '421C01', 'Ciências Biológicas', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (201, '440C01', 'Bacharelado Interdisciplinar em Ciência e Tecnologia', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (202, '441R01', 'Física Medica e Radioterapia', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (204, '443G03', 'Geofísica', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (205, '443G05', 'Geografia', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (206, '443G06', 'Geologia', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (207, '443O01', 'Oceanografia', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (208, '462C01', 'Ciências Atuariais', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (215, '483S02', 'Sistemas de Informação', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (217, '520E01', 'Engenharia', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (218, '520E04', 'Engenharia de Materiais', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (219, '520E05', 'Engenharia de Produção', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (220, '520E09', 'Engenharia Ambiental e Sanitária', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (225, '521E05', 'Engenharia Mecânica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (226, '521E06', 'Engenharia Metalúrgica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (231, '522E06', 'Engenharia Elétrica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (235, '523B01', 'Engenharia Biomédica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (236, '523E09', 'Engenharia Eletrônica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (237, '523E10', 'Engenharia mecatrônica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (238, '523E11', 'Engenharia de Controle e Automação', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (239, '523E12', 'Engenharia de Telecomunicações', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (246, '524E01', 'Engenharia de Bioprocessos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (247, '524E07', 'Engenharia Química', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (252, '525E04', 'Engenharia Aeronáutica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (253, '525E05', 'Engenharia automotiva', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (254, '525E08', 'Engenharia Naval', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (259, '541E01', 'Engenharia de Alimentos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (267, '542E03', 'Engenharia Têxtil', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (274, '544E01', 'Engenharia de Minas', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (276, '544E07', 'Engenharia de Petróleo', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (282, '582E02', 'Engenharia Cartográfica e de Agrimensura', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (283, '582E03', 'Engenharia Civil', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (288, '621A04', 'Agronomia', 6, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (290, '621E03', 'Engenharia Agrícola', 6, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (296, '621Z01', 'Zootecnia', 6, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (300, '624E01', 'Engenharia de Pesca', 6, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (302, '641M01', 'Medicina Veterinária', 6, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (303, '720E01', 'Educação Física', 7, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (304, '720N01', 'Naturologia', 7, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (306, '723E01', 'Enfermagem', 7, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (309, '726Q01', 'Quiropraxia', 7, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (310, '726T01', 'Terapia Ocupacional', 7, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (311, '762S01', 'Serviço Social', 7, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (317, '812T01', 'Turismo', 8, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (320, '814E02', 'Economia doméstica', 8, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (323, '840C04', 'Ciências Aeronáuticas', 8, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (324, '840C05', 'Ciências Navais', 8, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (333, '863C01', 'Ciências Militares', 8, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (334, '863C02', 'Ciências da Logística', 8, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (335, '863F01', 'Formação Militar', 8, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO modules.educacenso_curso_superior VALUES (337, '999991', 'Outro curso de formação superior', 9, 1, '2015-06-30 21:47:05.352523', NULL, 3);


--
-- TOC entry 8234 (class 0 OID 0)
-- Dependencies: 389
-- Name: educacenso_curso_superior_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.educacenso_curso_superior_id_seq', 338, true);


--
-- TOC entry 7679 (class 0 OID 9443785)
-- Dependencies: 390
-- Data for Name: educacenso_ies; Type: TABLE DATA; Schema: modules; Owner: -
--

INSERT INTO modules.educacenso_ies VALUES (616, 776, 'FACULDADE DE CIENCIAS CONTABEIS DE JEQUIE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (848, 1116, 'FACULDADE CAICARAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1319, 1614, 'FACULDADE ASTORGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1390, 1685, 'FACULDADE BARDDAL DE CIENCIAS CONTABEIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1484, 1779, 'FACULDADE AIEC', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1531, 1826, 'FACULDADE DE DIREITO DE LEOPOLDINA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1607, 1902, 'FACULDADE SANTO AGOSTINHO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1672, 1967, 'FACULDADE DO VALE DO ITAPECURU', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2178, 2474, 'FACULDADE MARIA MILZA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2458, 2754, 'FACULDADE SAO PAULO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2916, 3213, 'AFIMA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3299, 3600, 'FACULDADE DO LITORAL PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3508, 3810, 'NUCLEO DE CIENCIAS FIORAVANTI DI PIERO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3858, 4166, 'CENTRO DE ENSINO SUPERIOR DE UBERABA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4627, 4950, 'FACULDADE AUM', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4836, 5162, 'FACULDADE COMUNITARIA DO PLANALTO CENTRAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5683, 15833, 'FACULDADE 2001', 4, 2, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (1, 1, 'UNIVERSIDADE FEDERAL DE MATO GROSSO', 1, 1, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2, 2, 'UNIVERSIDADE DE BRASILIA', 1, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3, 3, 'UNIVERSIDADE FEDERAL DE SERGIPE', 1, 1, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4, 4, 'UNIVERSIDADE FEDERAL DO AMAZONAS', 1, 1, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5, 5, 'UNIVERSIDADE FEDERAL DO PIAUI', 1, 1, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (6, 6, 'UNIVERSIDADE FEDERAL DE OURO PRETO', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (7, 7, 'UNIVERSIDADE FEDERAL DE SAO CARLOS', 1, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (8, 8, 'UNIVERSIDADE FEDERAL DE VICOSA', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (9, 9, 'UNIVERSIDADE ESTADUAL DE LONDRINA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (10, 10, 'PONTIFICIA UNIVERSIDADE CATOLICA DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (11, 11, 'UNIVERSIDADE CATOLICA DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (12, 12, 'UNIVERSIDADE FEDERAL DO RIO GRANDE', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (13, 13, 'UNIVERSIDADE DE CAXIAS DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (14, 14, 'UNIVERSIDADE DO VALE DO RIO DOS SINOS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (15, 15, 'UNIVERSIDADE CATOLICA DE PETROPOLIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (16, 16, 'UNIVERSIDADE GAMA FILHO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (17, 17, 'UNIVERSIDADE FEDERAL DE UBERLANDIA', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (18, 18, 'UNIVERSIDADE CATOLICA DE PELOTAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (19, 19, 'PONTIFICIA UNIVERSIDADE CATOLICA DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (20, 20, 'UNIVERSIDADE DE PASSO FUNDO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (21, 21, 'PONTIFICIA UNIVERSIDADE CATOLICA DO RIO GRANDE DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (22, 22, 'UNIVERSIDADE PRESBITERIANA MACKENZIE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (23, 23, 'UNIVERSIDADE FEEVALE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (24, 24, 'UNIVERSIDADE ESTADUAL DE SANTA CRUZ', 2, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (25, 26, 'ESCOLA NACIONAL DE CIENCIAS ESTATISTICAS', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (26, 27, 'UNIVERSIDADE VALE DO RIO VERDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (27, 29, 'UNIVERSIDADE ESTADUAL DO CEARA', 2, 1, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (28, 30, 'UNIVERSIDADE JOSE DO ROSARIO VELLANO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (29, 31, 'CENTRO DE EDUCACAO TECNICA DA UTRAMIG', 2, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (30, 32, 'UNIVERSIDADE ESTADUAL DE CIENCIAS DA SAUDE DE ALAGOAS UNCISAL', 2, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (31, 33, 'FACULDADE DE TECNOLOGIA DE SOROCABA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (32, 34, 'FACULDADE DE TECNOLOGIA DE SAO PAULO', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (33, 35, 'FACULDADE DE TECNOLOGIA DE AMERICANA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (34, 36, 'FACULDADE DE TECNOLOGIA RUBENS LARA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (35, 37, 'FACULDADE DE TECNOLOGIA DE JAHU', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (36, 38, 'UNIVERSIDADE DO ESTADO DO PARA', 2, 1, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (37, 39, 'INSTITUTO DE TECNOLOGIA DA AMAZONIA', 2, 1, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (38, 40, 'UNIVERSIDADE DO ESTADO DA BAHIA', 2, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (39, 41, 'FACULDADE ESTADUAL DE EDUCACAO FISICA DE JACAREZINHO', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (40, 42, 'FACULDADE ESTADUAL DE DIREITO DO NORTE PIONEIRO', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (41, 43, 'FUNDACAO UNIVERSIDADE DO ESTADO DE SANTA CATARINA', 2, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (42, 44, 'FACULDADE DE ENGENHARIA CIVIL DE ITAJUBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (43, 45, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE ITAJUBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (44, 46, 'FACULDADE ESTADUAL DE CIENCIAS ECONOMICAS DE APUCARANA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (45, 47, 'UNIVERSIDADE ESTADUAL DE GOIAS', 2, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (46, 54, 'UNIVERSIDADE ESTADUAL DE CAMPINAS', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (47, 55, 'UNIVERSIDADE DE SAO PAULO', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (48, 56, 'UNIVERSIDADE ESTADUAL PAULISTA JULIO DE MESQUITA FILHO', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (49, 57, 'UNIVERSIDADE ESTADUAL DE MARINGA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (50, 58, 'FACULDADE DE DIREITO DE SAO BERNARDO DO CAMPO', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (51, 59, 'FACULDADE DE DIREITO DE FRANCA', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (52, 60, 'CENTRO UNIVERSITARIO DE FRANCA', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (53, 61, 'ESCOLA SUPERIOR DE EDUCACAO FISICA DE AVARE', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (54, 62, 'FACULDADE DE CIENCIAS E LETRAS DE AVARE', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (55, 63, 'FACULDADE DE CIENCIAS DE BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (56, 64, 'FACULDADE DE ENGENHARIA DE BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (57, 65, 'FACULDADE DE ODONTOLOGIA DE BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (58, 66, 'FACULDADE DE DIREITO E ADMINISTRACAO DE BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (59, 67, 'ESCOLA DE ENGENHARIA DE PIRACICABA', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (60, 68, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE PENAPOLIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (61, 71, 'UNIVERSIDADE DO ESTADO DO RIO GRANDE DO NORTE', 2, 1, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (62, 72, 'FACULDADE DE FORMACAO DE PROFESSORES DA MATA SUL', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (63, 73, 'CENTRO DE ENSINO SUPERIOR DE ARCOVERDE', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (64, 74, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE SAO JOSE DO RIO PARDO', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (65, 75, 'FACULDADE ESTADUAL DE EDUCACAO CIENCIAS E LETRAS DE PARANAVAI', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (66, 76, 'UNIVERSIDADE REGIONAL DE BLUMENAU', 3, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (67, 77, 'FACULDADE DA REGIAO DOS LAGOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (68, 78, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE ALEGRE', 3, 1, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (69, 79, 'INSTITUTO MUNICIPAL DE ENSINO SUPERIOR DE CATANDUVA', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (70, 80, 'CENTRO UNIVERSITARIO PARA O DESENVOLVIMENTO DO ALTO VALE DO ITAJAI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (71, 81, 'UNIVERSIDADE DA REGIAO DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (72, 82, 'UNIVERSIDADE DO OESTE DE SANTA CATARINA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (73, 83, 'UNIVERSIDADE DO VALE DO ITAJAI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (74, 84, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE MACAE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (75, 85, 'FACULDADE DE FILOSOFIA DE ITAPERUNA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (76, 86, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS PADRE HUMBERTO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (77, 87, 'CENTRO UNIVERSITARIO DE BRUSQUE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (78, 88, 'FACULDADE DE FORMACAO DE PROFESSORES DE PENEDO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (79, 89, 'FUNDACAO FACULDADES LUIZ MENEGHEL', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (80, 90, 'ESCOLA SUPERIOR DE EDUCACAO CIENCIAS E LETRAS DE RIO VERDE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (81, 91, 'ESCOLA SUPERIOR DE CIENCIAS AGRARIAS DE RIO VERDE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (82, 92, 'ESCOLA SUPERIOR CIENCIAS HUMANAS E EXATAS DE RIO VERDE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (83, 93, 'FACULDADE DE MEDICINA DE JUNDIAI', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (84, 94, 'ESCOLA SUPERIOR DE EDUCACAO FISICA DE JUNDIAI', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (85, 95, 'UNIVERSIDADE ESTADUAL DO VALE DO ACARAU', 2, 1, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (86, 96, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS PROFESSOR JOSE AUGUSTO VIEIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (87, 97, 'ESCOLA SUPERIOR DE AGRICULTURA E CIENCIAS DE MACHADO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (88, 98, 'FACULDADE DE ADMINISTRACAO E FINANCAS DE MACHADO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (89, 99, 'FACULDADE DE DIREITO DE CONSELHEIRO LAFAIETE', 3, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (90, 100, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE ARAXA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (91, 101, 'FACULDADE DE CIENCIAS GERENCIAIS DO ALTO PARANAIBA', 3, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (92, 102, 'FACULDADE DE DIREITO DO ALTO PARANAIBA', 3, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (93, 103, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE ARAGUARI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (94, 104, 'FACULDADE DE CIENCIAS ECONOMICAS DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (95, 105, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (96, 106, 'FACULDADE DE EDUCACAO DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (97, 107, 'UNIVERSIDADE FEDERAL DE SAO JOAO DEL REI', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (98, 108, 'ESCOLA SUPERIOR DE EDUCACAO FISICA E TECNICAS DESPORTIVAS DE ANDRADINA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (99, 109, 'FACULDADES INTEGRADAS RUI BARBOSA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (100, 110, 'FACULDADE DE DIREITO DE SETE LAGOAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (101, 111, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE SETE LAGOAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (102, 122, 'FACULDADE DE ENGENHARIA DE AGRIMENSURA DE ARARAQUARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (103, 123, 'FACULDADE DE ENGENHARIA CIVIL DE ARARAQUARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (104, 124, 'CENTRO UNIVERSITARIO DE ARARAQUARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (105, 125, 'CENTRO UNIVERSITARIO DE ARARAS  ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (106, 126, 'INSTITUTO NACIONAL DE TELECOMUNICACOES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (107, 127, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE ATIBAIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (108, 128, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (109, 129, 'FACULDADE DE DIREITO DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (110, 130, 'FACULDADE DE ADMINISTRACAO DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (111, 131, 'FACULDADE DE EDUCACAO FISICA DE BARRA BONITA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (112, 132, 'FACULDADE DE EDUCACAO ANTONIO AUGUSTO REIS NEVES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (113, 133, 'FACULDADE DE CIENCIAS CONTABEIS DE BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (114, 134, 'FACULDADE DE TECNOLOGIA E PROCESSAMENTO DE DADOS BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (115, 135, 'CENTRO UNIVERSITARIO CLARETIANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (116, 136, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE BEBEDOURO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (117, 137, 'UNIVERSIDADE DO SAGRADO CORACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (118, 138, 'CENTRO UNIVERSITARIO BARAO DE MAUA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (119, 139, 'FACULDADE DE CIENCIAS ECONOMICAS DO TRIANGULO MINEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (120, 140, 'UNIVERSIDADE SEVERINO SOMBRA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (121, 141, 'FACULDADE DE DIREITO DE VARGINHA FADIVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (122, 142, 'CENTRO UNIVERSITARIO DO TRIANGULO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (123, 143, 'UNIVERSIDADE DE UBERABA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (124, 144, 'FACULDADE DE CIENCIAS HUMANAS DE OLINDA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (125, 145, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (126, 146, 'CENTRO UNIVERSITARIO DE RIO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (127, 149, 'FACULDADE DE MEDICINA DE SAO JOSE DO RIO PRETO', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (128, 150, 'UNIVERSIDADE DE SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (129, 151, 'ESCOLA DE ADMINISTRACAO DE EMPRESAS DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (130, 152, 'FACULDADE DE CIENCIAS CONTABEIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (131, 158, 'CONSERVATORIO BRASILEIRO DE MUSICA CENTRO UNIVERSITARIO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (132, 159, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE CARUARU', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (133, 160, 'FACULDADE FRASSINETTI DO RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (134, 161, 'CENTRO UNIVERSITARIO ASSUNCAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (135, 162, 'CENTRO UNIVERSITARIO BELAS ARTES DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (136, 163, 'UNIVERSIDADE ESTACIO DE SA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (137, 165, 'UNIVERSIDADE VEIGA DE ALMEIDA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (138, 166, 'FAI CENTRO DE ENSINO SUPERIOR EM GESTAO, TECNOLOGIA E EDUCACAO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (139, 167, 'UNIVERSIDADE METODISTA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (140, 170, 'FACULDADES DA FUNDACAO DE ENSINO DE MOCOCA', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (141, 171, 'FACULDADE DE DIREITO DO SUL DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (142, 172, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS EUGENIO PACELLI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (143, 173, 'FACULDADE DE CIENCIAS MEDICAS DR JOSE ANTONIO GARCIA COUTINHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (144, 174, 'INSTITUTO SUPERIOR DE ESTUDOS SOCIAIS CLOVIS BEVILACQUA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (145, 176, 'UNIVERSIDADE CASTELO BRANCO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (146, 177, 'FACULDADE DE CIENCIAS ECONOMICAS E DE ADMINISTRACAO DE EMPRESAS DE SAO JOSE DO RIO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (147, 178, 'FACULDADE DE ENGENHARIA DE SAO JOSE DO RIO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (148, 179, 'FACULDADE DE ARQUITETURA E URBANISMO DE SAO JOSE DO RIO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (149, 180, 'FACULDADE DE DIREITO DE CARUARU', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (150, 181, 'FACULDADE DE ODONTOLOGIA DE CARUARU', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (151, 190, 'ESCOLA DE MEDICINA SOUZA MARQUES DA FUNDACAO TECNICO EDUCACIONAL SOUZA MARQUES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (152, 191, 'FACULDADE DE CIENCIAS CONTABEIS E DE ADMINISTRACAO DE EMPRESAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (153, 192, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS SOUZA MARQUES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (154, 193, 'FACULDADE DE ENGENHARIA SOUZA MARQUES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (155, 194, 'ESCOLA DE ENFERMAGEM DA FUNDACAO TECNICO EDUCACIONAL SOUZA MARQUES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (156, 195, 'FACULDADE MORAES JUNIOR MACKENZIE RIO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (157, 197, 'FACULDADE DE EDUCACAO SUPERIOR DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (158, 198, 'CENTRO UNIVERSITARIO DA CIDADE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (159, 199, 'FACULDADE SAO LUIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (160, 200, 'FACULDADE CASPER LIBERO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (161, 201, 'FACULDADE BRASILEIRA DE CIENCIAS JURIDICAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (162, 202, 'FACULDADE DE ECONOMIA E FINANCAS DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (163, 203, 'UNIVERSIDADE SAO JUDAS TADEU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (164, 206, 'CENTRO UNIVERSITARIO ITALOBRASILEIRO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (165, 207, 'CENTRO UNIVERSITARIO MOURA LACERDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (166, 208, 'UNIVERSIDADE DE RIBEIRAO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (167, 210, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE SANTO ANDRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (168, 211, 'FACULDADE DE CIENCIAS ECONOMICAS E ADMINISTRATIVAS DE SANTO ANDRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (169, 212, 'FACULDADE DE FILOSOFIA DE CAMPO GRANDE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (170, 213, 'CENTRO UNIVERSITARIO FECAP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (171, 214, 'FACULDADE DE ENGENHARIA DE MINAS GERAIS FEAMIG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (172, 215, 'UNIVERSIDADE DO GRANDE ABC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (173, 216, 'CENTRO UNIVERSITARIO METODISTA IZABELA HENDRIX', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (174, 217, 'CENTRO UNIVERSITARIO DAS FACULDADES ASSOCIADAS DE ENSINO FAE', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (175, 218, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE DUQUE DE CAXIAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (176, 219, 'FACULDADE DE EDUCACAO CIENCIAS E ARTES DOM BOSCO DE MONTE APRAZIVEL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (177, 220, 'FACULDADE SAO JUDAS TADEU', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (178, 221, 'UNIVERSIDADE CRUZEIRO DO SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (179, 222, 'CENTRO UNIVERSITARIO DE VOTUPORANGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (180, 223, 'FACULDADE DE EDUCACAO FISICA DE SANTO ANDRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (181, 224, 'FACULDADE DE MEDICINA DO ABC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (182, 225, 'INSTITUTO DE ENSINO SUPERIOR SANTO ANDRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (183, 226, 'CENTRO UNIVERSITARIO LUSIADA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (184, 227, 'UNIVERSIDADE CATOLICA DE SANTOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (185, 228, 'FACULDADE DE ENGENHARIA INDUSTRIAL DE SAO BERNARDO DO CAMPO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (186, 229, 'ESCOLA SUPERIOR DE ADMINISTRACAO DE NEGOCIOS DE SAO BERNARDO DO CAMPO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (187, 230, 'ESCOLA SUPERIOR DE ADMINISTRACAO DE NEGOCIOS DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (188, 231, 'FACULDADE DE SAO BERNARDO DO CAMPO FASB', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (189, 234, 'FACULDADES OSWALDO CRUZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (190, 236, 'FACULDADE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS DE SAO JOAO DA BOA VISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (191, 237, 'FACULDADE DE DIREITO DE SAO JOAO DA BOA VISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (192, 238, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE SAO JOAO DA BOA VISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (193, 239, 'FACULDADE DE MEDICINA VETERINARIA OCTAVIO BASTOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (194, 240, 'UNIVERSIDADE SANTA URSULA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (195, 241, 'FACULDADE DE ENGENHARIA QUIMICA DE LORENA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (196, 242, 'CENTRO UNIVERSITARIO ANHANGUERA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (197, 243, 'FACULDADE DO CLUBE NAUTICO MOGIANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (198, 244, 'CENTRO UNIVERSITARIO FIEO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (199, 245, 'FACULDADE DE ADMINISTRACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (200, 254, 'CENTRO UNIVERSITARIO CAPITAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (201, 255, 'FACULDADE DE ENGENHARIA E AGRIMENSURA DE PIRASSUNUNGA FEAP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (202, 256, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE PIRAJU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (203, 257, 'FACULDADE DE ADMINISTRACAO E CIENCIAS CONTABEIS LUZWELL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (204, 263, 'FACULDADES INTEGRADAS CAMPOS SALLES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (205, 264, 'UNIVERSIDADE SAO MARCOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (206, 265, 'FACULDADES INTEGRADAS DE OURINHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (207, 266, 'UNIVERSIDADE METODISTA DE PIRACICABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (208, 267, 'FACULDADES INTEGRADAS ESPIRITO SANTENSES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (209, 268, 'FACULDADE DE DIREITO DA ALTA PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (210, 269, 'FACULDADE FACCAT', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (211, 270, 'FACULDADES ESEFAP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (212, 271, 'UNIVERSIDADE DO OESTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (213, 273, 'ESCOLA DE ENGENHARIA INDUSTRIAL DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (214, 274, 'FACULDADE DE CIENCIAS APLICADAS DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (215, 275, 'UNIVERSIDADE DO VALE DO PARAIBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (216, 276, 'FACULDADE DE DIREITO DE SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (217, 277, 'CENTRO UNIVERSITARIO AUGUSTO MOTTA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (218, 278, 'FACULDADES INTEGRADAS SIMONSEN', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (219, 279, 'FACULDADES INTEGRADAS HELIO ALONSO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (220, 280, 'FACULDADE DE DIREITO DO OESTE DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (221, 281, 'CONSERVATORIO DRAMATICO MUSICAL SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (222, 282, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS E CONTABEIS COSTA BRAGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (223, 283, 'FACULDADE DE EDUCACAO COSTA BRAGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (224, 284, 'FACULDADE DE MEDICINA DE ITAJUBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (225, 288, 'FACULDADE DE DIREITO DO VALE DO RIO DOCE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (226, 289, 'FACULDADE DE EDUCACAO DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (227, 290, 'FACULDADE DE DIREITO DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (228, 291, 'FACULDADE DE PSICOLOGIA DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (229, 292, 'FACULDADE DE CIENCIAS DA SAUDE DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (230, 293, 'FACULDADE DE CIENCIAS E TECNOLOGIA DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (231, 294, 'FACULDADE TRES DE MAIO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (232, 295, 'UNIVERSIDADE DE SANTA CRUZ DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (233, 296, 'UNIVERSIDADE DA REGIAO DA CAMPANHA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (234, 297, 'FACULDADE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS SAO JUDAS TADEU', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (235, 298, 'UNIVERSIDADE NORTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (236, 299, 'FACULDADE DE JANDAIA DO SUL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (237, 300, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE FORMIGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (238, 301, 'ESCOLA DE BIBLIOTECONOMIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (239, 302, 'FACULDADE DE CIENCIAS ECONOMICAS, ADMINISTRATIVAS E CONTABEIS DE DIVINOPOLIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (240, 303, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE CATAGUASES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (241, 304, 'FACULDADE DE CIENCIAS CONTABEIS DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (242, 307, 'FACULDADE DE MEDICINA DE BARBACENA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (243, 308, 'UNIVERSIDADE PRESIDENTE ANTONIO CARLOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (244, 316, 'UNIVERSIDADE NOVE DE JULHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (245, 317, 'FACULDADES INTEGRADAS ALCANTARA MACHADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (246, 318, 'FACULDADE DE ARTES ALCANTARA MACHADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (247, 319, 'UNIVERSIDADE CAMILO CASTELO BRANCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (248, 320, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE TATUI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (249, 321, 'FACULDADE DE DESENHO DE TATUI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (250, 322, 'UNIVERSIDADE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (251, 328, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS VIANNA JUNIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (252, 329, 'ESCOLA SUPERIOR DE AGRONOMIA DE PARAGUACU PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (253, 330, 'UNIVERSIDADE IGUACU', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (254, 332, 'ESCOLA DE ENGENHARIA DE LINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (255, 333, 'FACULDADE DE INFORMATICA DE LINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (256, 334, 'FACULDADE DE SERVICO SOCIAL DE LINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (257, 335, 'FACULDADE DE EDUCACAO E CIENCIAS PINHEIRENSE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (258, 336, 'FACULDADE MACHADO SOBRINHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (259, 337, 'CENTRO DE ENSINO SUPERIOR DE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (260, 338, 'PONTIFICIA UNIVERSIDADE CATOLICA DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (261, 339, 'FACULDADE SANTA EMILIA DE RODAT', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (262, 343, 'CENTRO UNIVERSITARIO NEWTON PAIVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (263, 344, 'CENTRO UNIVERSITARIO UNA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (264, 345, 'ESCOLA DE ENGENHARIA KENNEDY', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (265, 346, 'INSTITUTO SUPERIOR DE CIENCIAS APLICADAS ISCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (266, 349, 'CENTRO UNIVERSITARIO DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (267, 351, 'FACULDADE DE CIENCIAS MEDICAS DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (268, 352, 'CENTRO UNIVERSITARIO DE JOAO PESSOA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (269, 353, 'FACULDADE EVANGELICA DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (270, 355, 'UNIVERSIDADE TUIUTI DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (271, 359, 'ESCOLA SUPERIOR DE EDUCACAO FISICA DE MUZAMBINHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (272, 360, 'CENTRO UNIVERSITARIO PAULISTANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (273, 361, 'FACULDADE PAULISTA DE SERVICO SOCIAL DE SAO CAETANO DO SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (274, 362, 'FACULDADE PAULISTA DE SERVICO SOCIAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (275, 363, 'FACULDADE MOZARTEUM DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (276, 364, 'FACULDADE DE CIENCIAS CONTABEIS DE PONTE NOVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (277, 367, 'UNIVERSIDADE ESTADUAL DE MONTES CLAROS', 2, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (278, 368, 'FACULDADE DE EDUCACAO FISICA DA ASSOCIACAO CRISTA DE MOCOS DE SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (279, 369, 'FACULDADE AUXILIUM DE FILOSOFIA CIENCIAS E LETRAS DE LINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (280, 370, 'FACULDADE PAULISTA DE ARTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (281, 371, 'FACULDADE DE MUSICA CARLOS GOMES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (282, 372, 'FACULDADE DE BIBLIOTECONOMIA E CIENCIA DA INFORMACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (283, 373, 'ESCOLA DE SOCIOLOGIA E POLITICA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (284, 374, 'CENTRO UNIVERSITARIO DAS FACULDADES METROPOLITANAS UNIDAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (285, 375, 'UNIVERSIDADE DE SANTO AMARO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (286, 376, 'CENTRO UNIVERSITARIO ANHANGUERA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (287, 377, 'FACULDADE DE EDUCACAO PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (288, 378, 'FACULDADE DE DIREITO PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (289, 379, 'FACULDADE DE CIENCIAS E LETRAS PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (290, 380, 'FACULDADE DE CIENCIAS ECONOMICAS, CONTABEIS E DE ADM DE EMPRESAS PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (291, 381, 'FACULDADE DE PSICOLOGIA PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (292, 382, 'FACULDADE DE TECNOLOGIA PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (293, 383, 'UNIVERSIDADE DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (294, 384, 'CENTRO UNIVERSITARIO DE ANAPOLIS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (295, 385, 'UNIVERSIDADE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (296, 386, 'CENTRO UNIVERSITARIO DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (297, 387, 'UNIVERSIDADE CATOLICA DOM BOSCO', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (298, 388, 'FACULDADE DE CIENCIAS CONTABEIS E ATUARIAIS DA ALTA NOROESTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (299, 389, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS E CONTABEIS DE LINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (300, 390, 'FACULDADE DE EDUCACAO FISICA DE LINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (301, 391, 'FACULDADE DE TECNOLOGIA DA ALTA NOROESTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (302, 395, 'FACULDADE DE CIENCIAS CONTABEIS DE LUCELIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (303, 396, 'FACULDADE RUY BARBOSA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (304, 397, 'FACULDADE RUY BARBOSA DE TECNOLOGIA EM PROCESSAMENTO DE DADOS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (305, 398, 'UNIVERSIDADE TIRADENTES', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (306, 399, 'ESCOLA DE ENGENHARIA DE AGRIMENSURA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (307, 400, 'FACULDADE DE DIREITO DE OLINDA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (308, 401, 'CENTRO DE ESTUDOS SUPERIORES BARROS MELO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (309, 402, 'CENTRO UNIVERSITARIO DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (310, 403, 'UNIVERSIDADE CATOLICA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (311, 404, 'FACULDADES INTEGRADAS DA UPIS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (312, 405, 'FOCCA FACULDADE DE OLINDA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (313, 408, 'ESCOLA SUPERIOR DE RELACOES PUBLICAS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (314, 409, 'UNIVERSIDADE DE PERNAMBUCO', 2, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (315, 410, 'FACULDADE DE CIENCIAS HUMANAS ESUDA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (316, 413, 'FACULDADE PORTOALEGRENSE DE EDUCACAO, CIENCIAS E LETRAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (317, 414, 'FACULDADE PORTOALEGRENSE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (318, 415, 'FACULDADE DE CIENCIAS MEDICAS DA SANTA CASA SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (319, 416, 'FACULDADE DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (320, 417, 'UNIVERSIDADE CIDADE DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (321, 420, 'UNIVERSIDADE DE MARILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (322, 421, 'FACULDADE ESTADUAL DE CIENCIAS E LETRAS DE CAMPO MOURAO', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (323, 423, 'UNIVERSIDADE REGIONAL INTEGRADA DO ALTO URUGUAI E DAS MISSOES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (324, 424, 'FACULDADE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS DE SANTA ROSA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (325, 425, 'FACULDADE DE EDUCACAO ARTISTICA DE SANTA ROSA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (326, 426, 'CENTRO UNIVERSITARIO FRANCISCANO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (327, 428, 'FACULDADE DE CIENCIAS CONTABEIS E DE ADMINISTRACAO DE MARILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (328, 429, 'FACULDADE DE DIREITO DE MARILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (329, 430, 'CENTRO UNIVERSITARIO FILADELFIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (330, 431, 'FACULDADE DE MEDICINA DE MARILIA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (331, 432, 'FACULDADE PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (332, 433, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE PALMAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (333, 434, 'FACULDADE SANTA MARCELINA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (334, 435, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS SANTA MARCELINA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (335, 436, 'FACULDADE DE CIENCIAS DA SAUDE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (336, 437, 'UNIVERSIDADE PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (337, 438, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE ITUVERAVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (338, 439, 'FACULDADE DOUTOR FRANCISCO MAEDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (339, 440, 'FACULDADE DE DIREITO DE ITU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (340, 441, 'UNIVERSIDADE DO CONTESTADO', 3, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (341, 442, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE ITARARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (342, 443, 'FACULDADE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS DE ITARARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (343, 446, 'UNIVERSIDADE DE CRUZ ALTA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (344, 447, 'FACULDADE CATOLICA DE CIENCIAS ECONOMICAS DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (345, 448, 'CENTRO UNIVERSITARIO RITTER DOS REIS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (346, 449, 'UNIVERSIDADE LUTERANA DO BRASIL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (347, 450, 'CENTRO UNIVERSITARIO LUTERANO DE JIPARANA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (348, 451, 'CENTRO UNIVERSITARIO LUTERANO DE SANTAREM', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (349, 452, 'CENTRO UNIVERSITARIO LUTERANO DE MANAUS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (350, 453, 'CENTRO UNIVERSITARIO LUTERANO DE PALMAS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (351, 454, 'FACULDADE CAMAQUENSE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (352, 455, 'FACULDADE DE FORMACAO DE PROFESSORES E ESPECIALISTAS DE EDUCACAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (353, 456, 'CENTRO UNIVERSITARIO SANT´ANNA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (354, 457, 'UNIVERSIDADE BANDEIRANTE ANHANGUERA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (355, 458, 'UNIVERSIDADE IBIRAPUERA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (356, 459, 'FACULDADE RENASCENCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (357, 460, 'FACULDADE DE ARTES PLASTICAS DA FUNDACAO ARMANDO ALVARES PENTEADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (358, 461, 'FACULDADE DE ADMINISTRACAO DA FUNDACAO ARMANDO ALVARES PENTEADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (359, 462, 'FACULDADE DE ENGENHARIA DA FUNDACAO ARMANDO ALVARES PENTEADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (360, 463, 'FACULDADE DE COMUNICACAO E MARKETING DA FUNDACAO ARMANDO ALVARES PENTEADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (361, 464, 'FACULDADE DE ECONOMIA DA FUNDACAO ARMANDO ALVARES PENTEADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (362, 465, 'FACULDADE DE COMPUTACAO E INFORMATICA DA FUNDACAO ARMANDO ALVARES PENTEADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (363, 466, 'UNIVERSIDADE ANHEMBI MORUMBI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (364, 467, 'FACULDADE DE CIENCIAS CONTABEIS DE ITAPETININGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (365, 468, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE ITAPETININGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (366, 469, 'ABEU FACULDADES INTEGRADAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (367, 470, 'FACULDADE DE ODONTOLOGIA DE NOVA FRIBURGO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (368, 472, 'UNIVERSIDADE DO GRANDE RIO PROFESSOR JOSE DE SOUZA HERDY', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (369, 473, 'FACULDADE DE CIENCIAS ECONOMICAS, ADMINISTRATIVAS E DA COMPUTACAO DOM BOSCO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (370, 474, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DOM BOSCO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (371, 475, 'FACULDADE DE MEDICINA DE PETROPOLIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (372, 480, 'CENTRO UNIVERSITARIO SERRA DOS ORGAOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (373, 481, 'UNIVERSIDADE GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (374, 482, 'UNIVERSIDADE DO EXTREMO SUL CATARINENSE', 3, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (375, 483, 'CENTRO UNIVERSITARIO METROPOLITANO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (376, 486, 'FACULDADE DE FORMACAO DE PROFESSORES DE ARAPIRACA', 2, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (377, 487, 'FACULDADE DE ADMINISTRACAO, CIENCIAS CONTABEIS, JURIDICAS E SOCIAIS DO ESTADO DE ALAGOAS', 2, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (378, 488, 'ESCOLA SUPERIOR DE CIENCIAS HUMANAS FISICAS E BIOLOGICAS DO SERTAO', 2, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (379, 489, 'CENTRO UNIVERSITARIO DE VOLTA REDONDA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (380, 490, 'CENTRO DE ENSINO SUPERIOR DE VALENCA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (381, 491, 'FACULDADE DE EDUCACAO CIENCIAS E LETRAS DON DOMENICO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (382, 492, 'FACULDADE DE ADMINISTRACAO CIENCIAS ECON E CONTABEIS DE GUARATINGUETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (383, 493, 'FACULDADE DE EDUCACAO DE GUARATINGUETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (384, 494, 'UNIVERSIDADE DO SUL DE SANTA CATARINA', 3, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (385, 495, 'FACULDADE DE CIENCIAS E LETRAS DE BRAGANCA PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (386, 496, 'UNIVERSIDADE DE FRANCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (387, 498, 'ESCOLA SUPERIOR DE EDUCACAO FISICA E DESPORTOS DE CATANDUVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (388, 499, 'FACULDADE DE DIREITO E ADMINISTRACAO CATANDUVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (389, 500, 'FACULDADE DE MEDICINA DE CATANDUVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (390, 501, 'ESCOLA SUPERIOR DE CIENCIAS DA SANTA CASA DE MISERICORDIA DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (391, 502, 'CENTRO UNIVERSITARIO MONTE SERRAT', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (392, 503, 'FACULDADE DE DIREITO DE CAMPOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (393, 504, 'FACULDADE DE ODONTOLOGIA DE CAMPOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (394, 505, 'FACULDADE DE FILOSOFIA DE CAMPOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (395, 506, 'FACULDADE DE MEDICINA DE CAMPOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (396, 507, 'FACULDADE TRIANGULO MINEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (397, 508, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DO SUL DE MINAS   FACESM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (398, 509, 'FACULDADES INTEGRADAS DE CRUZEIRO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (399, 510, 'ESCOLA DE ENFERMAGEM WENCESLAU BRAZ', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (400, 511, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE GUAXUPE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (401, 512, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS ECONOMICAS E CONTABEIS DE GUAXUPE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (402, 513, 'UNIVERSIDADE VALE DO RIO DOCE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (403, 514, 'CENTRO UNIVERSITARIO DE BARRA MANSA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (404, 515, 'CENTRO UNIVERSITARIO ANHANGUERA DE NITEROI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (405, 516, 'CENTRO UNIVERSITARIO MOACYR SREDER BASTOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (406, 517, 'FACULDADE DE EDUCACAO SAO LUIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (407, 518, 'CENTRO UNIVERSITARIO DO DISTRITO FEDERAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (408, 519, 'UNIVERSIDADE CATOLICA DO SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (409, 521, 'UNIVERSIDADE DE MOGI DAS CRUZES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (410, 522, 'CENTRO UNIVERSITARIO CELSO LISBOA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (411, 524, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE OURO FINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (412, 526, 'UNIVERSIDADE BRAZ CUBAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (413, 527, 'PONTIFICIA UNIVERSIDADE CATOLICA DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (414, 528, 'PONTIFICIA UNIVERSIDADE CATOLICA DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (415, 530, 'FACULDADE DE MUSICA DO ESPIRITO SANTO', 2, 1, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (416, 531, 'FACULDADE DE FORMACAO DE PROFESSORES DE VITORIA DE SANTO ANTAO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (417, 532, 'UNIVERSIDADE REGIONAL DO NOROESTE DO ESTADO DO RIO GRANDE DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (418, 533, 'FACULDADES INTEGRADAS DE ITAPETININGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (419, 534, 'ESCOLA BAHIANA DE MEDICINA E SAUDE PUBLICA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (420, 535, 'CENTRO UNIVERSITARIO DE MANDAGUARI UNIMAN', 3, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (421, 543, 'FACULDADE DE CIENCIAS DA FUNDACAO INSTITUTO TECNOLOGICO DE OSASCO', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (422, 544, 'FACULDADE DE CIENCIAS HUMANAS DE ITABIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (423, 545, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS E CONTABEIS DE ITABIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (424, 546, 'PONTIFICIA UNIVERSIDADE CATOLICA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (425, 547, 'UNIVERSIDADE DO ESTADO DO RIO DE JANEIRO', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (426, 548, 'UNIVERSIDADE FEDERAL DO MARANHAO', 1, 1, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (427, 549, 'UNIVERSIDADE FEDERAL DO ACRE', 1, 1, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (428, 550, 'UNIVERSIDADE ESTADUAL DA PARAIBA', 2, 1, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (429, 552, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (430, 553, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (431, 554, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE BOA ESPERANCA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (432, 555, 'UNIVERSIDADE DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (433, 556, 'CONSERVATORIO DE MUSICA DE NITEROI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (434, 557, 'ESCOLA DE MUSICA E BELAS ARTES DO PARANA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (435, 558, 'FACULDADE DE ARTES DO PARANA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (436, 568, 'UNIVERSIDADE ESTADUAL DO MARANHAO', 2, 1, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (437, 569, 'UNIVERSIDADE FEDERAL DO PARA', 1, 1, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (438, 570, 'UNIVERSIDADE FEDERAL DO RIO GRANDE DO NORTE', 1, 1, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (439, 571, 'UNIVERSIDADE FEDERAL DO PARANA', 1, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (440, 572, 'UNIVERSIDADE FEDERAL FLUMINENSE', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (441, 573, 'UNIVERSIDADE FEDERAL DO ESPIRITO SANTO', 1, 1, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (442, 574, 'UNIVERSIDADE FEDERAL RURAL DO RIO DE JANEIRO', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (443, 575, 'UNIVERSIDADE FEDERAL DE MINAS GERAIS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (444, 576, 'UNIVERSIDADE FEDERAL DE JUIZ DE FORA', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (445, 577, 'UNIVERSIDADE FEDERAL DE ALAGOAS', 1, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (446, 578, 'UNIVERSIDADE FEDERAL DA BAHIA', 1, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (447, 579, 'UNIVERSIDADE FEDERAL DA PARAIBA', 1, 1, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (448, 580, 'UNIVERSIDADE FEDERAL DE PERNAMBUCO', 1, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (449, 581, 'UNIVERSIDADE FEDERAL DO RIO GRANDE DO SUL', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (450, 582, 'UNIVERSIDADE FEDERAL DE SANTA MARIA', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (451, 583, 'UNIVERSIDADE FEDERAL DO CEARA', 1, 1, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (452, 584, 'UNIVERSIDADE FEDERAL DE GOIAS', 1, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (453, 585, 'UNIVERSIDADE FEDERAL DE SANTA CATARINA', 1, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (454, 586, 'UNIVERSIDADE FEDERAL DO RIO DE JANEIRO', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (455, 587, 'UNIVERSIDADE FEDERAL RURAL DE PERNAMBUCO', 1, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (456, 588, 'UNIVERSIDADE TECNOLOGICA FEDERAL DO PARANA', 1, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (457, 589, 'UNIVERSIDADE FEDERAL RURAL DO SEMIARIDO', 1, 1, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (458, 590, 'UNIVERSIDADE FEDERAL RURAL DA AMAZONIA', 1, 1, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (459, 591, 'UNIVERSIDADE FEDERAL DE SAO PAULO', 1, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (460, 592, 'UNIVERSIDADE FEDERAL DE LAVRAS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (461, 593, 'CENTRO FEDERAL DE EDUCACAO TECNOLOGICA CELSO SUCKOW DA FONSECA', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (462, 594, 'CENTRO FEDERAL DE EDUCACAO TECNOLOGICA DE MINAS GERAIS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (463, 595, 'UNIVERSIDADE FEDERAL DE ALFENAS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (464, 596, 'UNIVERSIDADE FEDERAL DOS VALES DO JEQUITINHONHA E MUCURI', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (465, 597, 'UNIVERSIDADE FEDERAL DO TRIANGULO MINEIRO', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (466, 598, 'UNIVERSIDADE FEDERAL DE ITAJUBA UNIFEI', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (467, 599, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DA BAHIA', 1, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (468, 600, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO MARANHAO', 1, 1, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (469, 601, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO RIO GRANDE DO SUL', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (470, 602, 'INSTITUTO TECNOLOGICO DE AERONAUTICA', 1, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (471, 605, 'UNIVERSIDADE MUNICIPAL DE SAO CAETANO DO SUL', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (472, 606, 'FACULDADE DE DIREITO DE CACHOEIRO DO ITAPEMIRIM', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (473, 607, 'FACULDADE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS DE CACHOEIRO DO ITAPEMIRIM', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (474, 608, 'ESCOLA SUPERIOR DE CRUZEIRO "PREFEITO HAMILTON VIEIRA MENDES"', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (475, 609, 'UNIVERSIDADE ESTADUAL DO OESTE DO PARANA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (476, 610, 'CENTRO UNIVERSITARIO METODISTA BENNETT', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (477, 614, 'FACULDADE DE FILOSOFIA SANTA DOROTEIA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (478, 615, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS PROFESSORA NAIR FORTES ABU MERHY', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (479, 616, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (480, 617, 'FACULDADE DE ENFERMAGEM E OBSTETRICIA DE GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (481, 618, 'FACULDADE DE FISIOTERAPIA DE GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (482, 621, 'CENTRO UNIVERSITARIO CESMAC', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (483, 622, 'FACULDADES INTEGRADAS SILVA E SOUZA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1070, 1360, 'FACULDADE SAO GABRIEL', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (484, 623, 'FACULDADES DE FILOSOFIA CIENCIAS E LETRAS DE SANTA CRUZ DO RIO PARDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (485, 624, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS CARLOS QUEIROZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (486, 625, 'FACULDADE CENECISTA DE CAPIVARI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (487, 626, 'FACULDADE CENECISTA DE OSORIO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (488, 627, 'FACULDADE CENECISTA DE VARGINHA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (489, 629, 'FACULDADE CENECISTA DE VITORIA FACEV', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (490, 630, 'FACULDADE CENECISTA DE CIENCIAS ADMINISTRATIVAS DE OSORIO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (491, 631, 'CENTRO DE ENSINO SUPERIOR CENECISTA DE FARROUPILHA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (492, 632, 'FACULDADE DE CIENCIAS ECONOMICAS, ADMINISTRATIVAS E CONTABEIS DE SAO SEBASTIAO DO PARAISO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (493, 633, 'INSTITUTO MILITAR DE ENGENHARIA', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (494, 634, 'UNIVERSIDADE FEDERAL DE PELOTAS', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (495, 636, 'ESCOLA SUPERIOR DE PROPAGANDA E MARKETING', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (496, 637, 'FACULDADE DE ENGENHARIA SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (497, 638, 'FACULDADE DE DIREITO MILTON CAMPOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (498, 639, 'FACULDADE DE DESENHO INDUSTRIAL DE MAUA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (499, 640, 'FACULDADES INTEGRADAS MARIA THEREZA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (500, 641, 'CENTRO UNIVERSITARIO LA SALLE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (501, 645, 'CENTRO UNIVERSITARIO DE JARAGUA DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (502, 646, 'FACULDADES ASSOCIADAS DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (503, 647, 'FACULDADE DE ENFERMAGEM LUIZA DE MARILLAC', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (504, 648, 'FACULDADES ASSOCIADAS DE UBERABA FAZU', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (505, 649, 'CENTRO UNIVERSITARIO DE UNIAO DA VITORIA', 3, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (506, 650, 'FACULDADE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS DE AVARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (507, 651, 'FACULDADE DE ADMINISTRACAO DE GOVERNADOR VALADARES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (508, 652, 'FACULDADE SANTA CECILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (509, 657, 'FACULDADE DE FORMACAO DE PROFESSORES DE SERRA TALHADA', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (510, 659, 'FACULDADE DE CIENCIAS HUMANAS DO SUL PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (511, 660, 'FACULDADE METODISTA DO SUL PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (512, 661, 'FACULDADE PIO DECIMO', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (513, 662, 'FACULDADES INTEGRADAS CORACAO DE JESUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (514, 663, 'UNIVERSIDADE SALGADO DE OLIVEIRA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (515, 664, 'UNIVERSIDADE VILA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (516, 665, 'UNIVERSIDADE DE TAUBATE', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (517, 666, 'UNIVERSIDADE ESTADUAL DE FEIRA DE SANTANA', 2, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (518, 667, 'FACULDADES INTEGRADAS DE JACAREPAGUA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (519, 668, 'CENTRO UNIVERSITARIO DE ENSINO SUPERIOR DO AMAZONAS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (520, 669, 'UNIVERSIDADE NILTON LINS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (521, 670, 'UNIVERSIDADE SAO FRANCISCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (522, 671, 'UNIVERSIDADE ANHANGUERA UNIDERP', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (523, 672, 'FACULDADE DE ENGENHARIA DE SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (524, 673, 'CENTRO UNIVERSITARIO DA GRANDE DOURADOS', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (525, 674, 'CENTRO DE ENSINO SUPERIOR DO VALE SAO FRANCISCO', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (526, 677, 'FACULDADE DE REABILITACAO DA ASCE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (527, 678, 'FACULDADE DE ODONTOLOGIA DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (528, 679, 'FACULDADE DE REABILITACAO DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (529, 680, 'FACULDADES INTEGRADAS DE PEDRO LEOPOLDO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (530, 681, 'FACULDADES INTEGRADAS ANGLOAMERICANO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (531, 682, 'FACULDADE DO NOROESTE DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (532, 683, 'FACULDADE DE CIENCIAS ECONOMICAS DE COLATINA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (533, 684, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE COLATINA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (534, 685, 'FACULDADE DE FORMACAO DE PROFESSORES DE BELO JARDIM', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (535, 686, 'FACULDADE DE CIENCIAS APLICADAS DE LIMOEIRO', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (536, 687, 'FACULDADE ESTADUAL DE FILOSOFIA CIENCIAS LETRAS UNIAO DA VITORIA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (537, 688, 'UNIVERSIDADE ESTADUAL DO SUDOESTE DA BAHIA', 2, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (538, 689, 'FACULDADE DE NUTRICAO E FONOAUDIOLOGIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (539, 690, 'FACULDADE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS DE TAQUARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (540, 691, 'FACULDADE DE EDUCACAO DE TAQUARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (541, 692, 'FACULDADE DE CIENCIAS APLICADAS E SOCIAIS DE PETROLINA', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (542, 693, 'UNIVERSIDADE FEDERAL DO ESTADO DO RIO DE JANEIRO', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (543, 694, 'UNIVERSIDADE FEDERAL DE MATO GROSSO DO SUL', 1, 1, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (544, 695, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE ITUMBIARA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (545, 696, 'FACULDADE DE CIENCIAS AGRARIAS DE ITUMBIARA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (546, 697, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS DE ITUMBIARA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (547, 699, 'FUNDACAO UNIVERSIDADE FEDERAL DE RONDONIA', 1, 1, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (548, 700, 'FACULDADE DE EDUCACAO DE ITABORAI', 3, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (549, 701, 'FACULDADE DE CIENCIAS DA ADMINISTRACAO DE GARANHUNS', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (550, 702, 'FACULDADE DE FORMACAO DE PROFESSORES DE GOIANA', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (551, 703, 'FACULDADE DE FORMACAO DE PROFESSORES DE ARARIPINA', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (552, 704, 'FACULDADE DE CIENCIAS AGRARIAS DE ARARIPINA', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (553, 705, 'FACULDADE SAO JOSE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (554, 706, 'FACULDADE DE ARTES DULCINA DE MORAES', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (555, 707, 'CENTRO UNIVERSITARIO CENTRAL PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (556, 708, 'INSTITUTO DE CIENCIAS SOCIAIS APLICADAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (557, 709, 'INSTITUTO DE CIENCIAS EXATAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (558, 710, 'FACULDADE BETHENCOURT DA SILVA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (559, 711, 'FACULDADES REUNIDAS DE ADMINISTRACAO CIENCIAS CONTABEIS E ECONOMICAS DE PALMAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (560, 712, 'CENTRO UNIVERSITARIO HERMINIO DA SILVEIRA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (561, 713, 'ESCOLA SUPERIOR DE ESTATISTICA DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (562, 714, 'FACULDADE ESTADUAL DE FILOSOFIA CIENCIAS E LETRAS DE CORNELIO PROCOPIO', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (563, 715, 'FAE CENTRO UNIVERSITARIO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (564, 716, 'FACULDADES INTEGRADAS DE BOTUCATU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (565, 717, 'FUNDACAO UNIVERSIDADE FEDERAL DE CIENCIAS DA SAUDE DE PORTO ALEGRE', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (566, 718, 'UNIVERSIDADE POTIGUAR', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (567, 719, 'UNIVERSIDADE DO ESTADO DE MATO GROSSO', 2, 1, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (568, 720, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS APLICADAS DO CABO DE SANTO AGOSTINHO', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (569, 721, 'FACULDADE DE EDUCACAO DE ASSIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (570, 722, 'ESCOLA DE EDUCACAO FISICA DE ASSIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (571, 723, 'FACULDADE DE ADMINISTRACAO DE ASSIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (572, 724, 'CENTRO UNIVERSITARIO FACEX', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (573, 725, 'FACULDADE ESTADUAL DE FILOSOFIA, CIENCIAS E LETRAS DE PARANAGUA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (574, 726, 'FACULDADE ESTADUAL DE FILOSOFIA CIENCIAS E LETRAS DE JACAREZINHO', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (575, 727, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DO ALTO SAO FRANCISCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (576, 728, 'FACULDADE DE CIENCIAS HUMANAS DE CURVELO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (577, 729, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE PRESIDENTE VENCESLAU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (578, 730, 'UNIVERSIDADE ESTADUAL DE PONTA GROSSA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (579, 734, 'FACULDADES INTEGRADAS MARIA IMACULADA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (580, 736, 'FACULDADE PITAGORAS DE LINHARES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (581, 737, 'CENTRO UNIVERSITARIO SAO CAMILO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (582, 738, 'FACULDADES INTEGRADAS TERESA D´AVILA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (583, 739, 'CENTRO UNIVERSITARIO SAO CAMILO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (584, 740, 'FACULDADE DE CIENCIAS HUMANAS DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (585, 741, 'ESCOLA SUPERIOR DE SECRETARIADO DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (586, 742, 'FACULDADE DE ARQUITETURA E URBANISMO DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (587, 743, 'ESCOLA SUPERIOR DE ENSINO HELENA ANTIPOFF', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (588, 744, 'FACULDADE DE EDUCACAO E CIENCIAS HUMANAS DE ANICUNS', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (589, 745, 'INSTITUTO MUNICIPAL DE ENSINO SUPERIOR DE SAO MANUEL', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (590, 746, 'UNIVERSIDADE REGIONAL DO CARIRI', 2, 1, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (591, 747, 'FACULDADE DE CIENCIAS HUMANAS DE IVAIPORA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (592, 749, 'CENTRO DE ENSINO SUPERIOR DO VALE DO PARNAIBA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (593, 750, 'CENTRO UNIVERSITARIO UNIRG', 3, 1, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (594, 751, 'FACULDADE DA ILHA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (595, 752, 'FACULDADE DE PARA DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (596, 753, 'FACULDADE DE CIENCIAS HUMANAS DO SERTAO CENTRAL', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (597, 754, 'CENTRO DE ENSINO SUPERIOR DE CATALAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (598, 755, 'CENTRO DE ENSINO SUPERIOR DE JATAI', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (599, 756, 'UNIVERSIDADE ESTADUAL DO PIAUI', 2, 1, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (600, 757, 'FACULDADES INTEGRADAS DO TAPAJOS', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (601, 758, 'FACULDADE BRASILEIRA DE RECURSOS HUMANOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (602, 759, 'FACULDADE DE CIENCIAS MEDICAS E PARAMEDICAS FLUMINENSE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (603, 760, 'FACULDADE DE CIENCIAS HUMANAS DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (604, 761, 'FACULDADES SPEI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (605, 762, 'FACULDADES INTEGRADAS DE FATIMA DO SUL', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (606, 763, 'INSTITUTO UNIFICADO DE ENSINO SUPERIOR OBJETIVO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (607, 764, 'FACULDADE PINHEIRO GUIMARAES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (608, 767, 'INSTITUTO SUPERIOR DE INFORMATICA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (609, 768, 'FACULDADE DE ADMINISTRACAO DE NOVA ANDRADINA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (610, 769, 'FACULDADES INTEGRADAS DE NAVIRAI', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (611, 770, 'FACULDADE DE EDUCACAO DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (612, 771, 'FACULDADE MARIA AUGUSTA RIBEIRO DAHER', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (613, 773, 'FACULDADE DE ADMINISTRACAO E CIENCIAS CONTABEIS DE LINHARES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (614, 774, 'FACULDADE ALVORADA DE INFORMATICA E PROCESSAMENTO DE DADOS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (615, 775, 'FACULDADE ALVORADA DE EDUCACAO FISICA E DESPORTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (617, 777, 'FACULDADE DE EDUCACAO THEREZA PORTO MARQUES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (618, 778, 'FACULDADE DE TECNOLOGIA DE JACAREI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (619, 779, 'FACULDADE DE PONTA PORA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (620, 780, 'UNIVERSIDADE DE CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (621, 781, 'FACULDADE ANHANGUERA DE RONDONOPOLIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (622, 782, 'FACULDADE CUIABANA DE EDUCACAO E LETRAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (623, 783, 'FACULDADE MATOGROSSENSE DE CIENCIAS CONTABEIS E ADMINISTRATIVA DE CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (624, 785, 'FACULDADE DE EDUCACAO DE TANGARA DA SERRA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (625, 788, 'FACULDADE DE RONDONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (626, 789, 'UNIVERSIDADE FEDERAL DE RORAIMA', 1, 1, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (627, 790, 'FACULDADE DE ENFERMAGEM DO HOSPITAL ISRAELITA ALBERT EINSTEIN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (628, 791, 'FACULDADE SENAC DE TURISMO E HOTELARIA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (629, 792, 'CENTRO UNIVERSITARIO DO ESTADO DO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (630, 793, 'CENTRO UNIVERSITARIO ESTACIO RADIAL DE SAO PAULO ESTACIO UNIRADIAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (631, 794, 'CENTRO UNIVERSITARIO DE VARZEA GRANDE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (632, 795, 'FACULDADES INTEGRADAS DE DIAMANTINO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (633, 796, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DO VALE DO SAO LOURENCO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (634, 797, 'FACULDADE AVEC DE VILHENA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (635, 798, 'FACULDADES INTEGRADAS DE ARACRUZ', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (636, 799, 'FACULDADE LEONARDO DA VINCI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (637, 800, 'FACULDADE DE EDUCACAO FISICA MONTENEGRO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (638, 801, 'FACULDADE MONTENEGRO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (639, 802, 'CENTRO UNIVERSITARIO CARIOCA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (640, 803, 'FACULDADE INTERACAO AMERICANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (641, 809, 'FACULDADE DE DIREITO E CIENCIAS SOCIAIS DO LESTE DE MINAS FADILESTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (642, 810, 'CENTRO TECNICO EDUCACIONAL SUPERIOR DO OESTE PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (643, 811, 'FACULDADES INTEGRADAS DE CASSILANDIA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (644, 817, 'FACULDADE BATISTA CARIOCA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (645, 818, 'FACULDADE DE ADMINISTRACAO DE MINEIROS', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (646, 819, 'FACULDADE DE AGRONOMIA DE MINEIROS', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (647, 820, 'FACULDADE DE CIENCIAS DA COMPUTACAO DE MINEIROS', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (648, 821, 'FACULDADE DE PEDAGOGIA DE MINEIROS', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (649, 822, 'ESCOLA SUPERIOR DE ESTUDOS EMPRESARIAIS E INFORMATICA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (650, 823, 'UNIVERSIDADE DO CEUMA UNICEUMA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (651, 824, 'FACULDADE DE FILOSOFIA E CIENCIAS HUMANAS DE GOIATUBA', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (652, 825, 'FACULDADE PRESBITERIANA GAMMON', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (653, 826, 'CENTRO UNIVERSITARIO DE DESENVOLVIMENTO DO CENTRO OESTE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (654, 827, 'FACULDADES UNIDAS DO VALE DO ARAGUAIA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (655, 828, 'FACULDADE DE SAO LOURENCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (656, 829, 'UNIVERSIDADE DO TOCANTINS', 2, 1, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (657, 830, 'UNIVERSIDADE FEDERAL DO AMAPA', 1, 1, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (658, 831, 'FACULDADE DE CIENCIAS HUMANAS DO VALE DO RIO GRANDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (659, 832, 'FACULDADE ARQUIDIOCESANA DE CURVELO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (660, 833, 'FACULDADES INTEGRADAS DE ARIQUEMES', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (661, 834, 'FACULDADE VARZEAGRANDENSE DE CIENCIAS HUMANAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (662, 835, 'FACULDADE VARZEAGRANDENSE DE COMUNICACAO SOCIAL', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (663, 837, 'FACULDADE DE CIENCIAS HUMANAS DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (664, 838, 'FACULDADE DE CIENCIAS TECNOLOGICAS DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (665, 839, 'FACULDADE VITORIANA DE CIENCIAS CONTABEIS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (666, 840, 'FACULDADE VITORIANA DE TECNOLOGIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (667, 841, 'FACULDADE DE TURISMO GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (668, 843, 'FACULDADE DE CIENCIAS E TECNOLOGIA DE BIRIGUI', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (669, 844, 'FACULDADE DE AGRONOMIA E ENGENHARIA FLORESTAL DE GARCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (670, 845, 'FACULDADE DA FUNDACAO EDUCACIONAL ARACATUBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (671, 846, 'FACULDADE DE ADMINISTRACAO DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (672, 847, 'FACULDADE PIAUIENSE DE PROCESSAMENTO DE DADOS', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (673, 848, 'FACULDADE PARAIBANA DE PROCESSAMENTO DE DADOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (674, 849, 'FACULDADE JESUITA DE FILOSOFIA E TEOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (675, 850, 'FACULDADE PRIMUS DE INFORMATICA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (676, 851, 'FACULDADE DE TECNOLOGIA EM PROCESSAMENTO DE DADOS DO LITORAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (677, 852, 'FACULDADE DE INFORMATICA E ADMINISTRACAO PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (678, 859, 'FACULDADE REGIONAL SANTA CRUZ DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (679, 860, 'FACULDADE DE CIENCIAS SOCIAIS DE ARAUCARIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (680, 861, 'CENTRO DE ENSINO SUPERIOR DO AMAPA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (681, 862, 'FACULDADE ESTACIO DE SA DE CAMPO GRANDE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (682, 864, 'FACULDADE DE DIREITO DE VARZEA GRANDE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (683, 866, 'FACULDADE DE INFORMATICA DE CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (684, 867, 'FACULDADE DE EDUCACAO CIENCIAS E LETRAS DE PONTA PORA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (685, 873, 'FACULDADES UNIFICADAS DE FOZ DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (686, 874, 'FACULDADE DE ESTUDOS SOCIAIS APLICADOS DE VIANA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (687, 875, 'FACULDADE DE ESTUDOS SOCIAIS DE BARRA DO GARCAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (688, 876, 'FACULDADE DE TECNOLOGIA DO VALE DO ARAGUAIA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (689, 877, 'FACULDADE DE ECONOMIA E PROCESSAMENTO DE DADOS DE FOZ DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (690, 878, 'CENTRO UNIVERSITARIO DO LESTE DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (691, 880, 'FACULDADE DE CIENCIAS E TECNOLOGIA DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (692, 881, 'INSTITUTO MUNICIPAL DE ENSINO SUPERIOR DE ASSIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (693, 882, 'INSTITUTO MUNICIPAL DE ENSINO SUPERIOR DE BEBEDOURO VICTORIO CARDASSI', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (694, 886, 'FACULDADE DE HORTOLANDIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (695, 887, 'FACULDADE CHRISTUS', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (696, 888, 'FACULDADE BANDEIRANTES DE CIENCIAS EXATAS E HUMANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (697, 890, 'ESCOLA DE GOVERNO PROFESSOR PAULO NEVES DE CARVALHO', 2, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (698, 891, 'FACULDADE ANHANGUERA DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (699, 896, 'ESCOLA SUPERIOR DE TURISMO E HOTELARIA FLORIANOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (700, 897, 'UNIAO DAS ESCOLAS SUPERIORES DO VALE DO IVAI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (701, 898, 'FACULDADE DE CIENCIAS ECONOMICAS E ADMINISTRATIVAS SANTA RITA DE CASSIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (702, 899, 'FACULDADES INTEGRADAS DE RIO VERDE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (703, 900, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS E DE TECNOLOGIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (704, 903, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (705, 904, 'FACULDADE DE PROCESSAMENTO DE DADOS DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (706, 905, 'FACULDADE ESCOLA PAULISTA DE DIREITO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (707, 906, 'FACULDADE DE EDUCACAO E CIENCIAS GERENCIAIS DE SUMARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (708, 907, 'FACULDADE DE EDUCACAO E CIENCIAS GERENCIAIS DE INDAIATUBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (709, 908, 'FACULDADE ALAGOANA DE ADMINISTRACAO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (710, 909, 'FACULDADE DE BELFORD ROXO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (711, 910, 'FACULDADE SANTA LUCIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (712, 911, 'FACULDADES UNIDAS DE ITUMBIARA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (713, 912, 'FACULDADE COMPACTO DE CIENCIAS GERENCIAIS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (714, 913, 'FACULDADES INTEGRADAS DE PARANAIBA FIPAR', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (715, 914, 'FACULDADE PARANAENSE DE ADMINISTRACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (716, 915, 'FACULDADE DE ADMINISTRACAO DE FATIMA DO SUL', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (717, 916, 'FACULDADE DE CIENCIAS, SAUDE, EXATAS E JURIDICAS DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (718, 917, 'FACULDADE DE CIENCIAS CONTABEIS DE NAVIRAI', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (719, 918, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE CASCAVEL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (720, 922, 'FACULDADE REGES DE DRACENA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (721, 923, 'FACULDADE DE ADMINISTRACAO E CIENCIAS CONTABEIS DE SAO ROQUE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (722, 924, 'FACULDADE INTERLAGOS DE EDUCACAO E CULTURA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (723, 925, 'FACULDADE DE CIENCIAS GERENCIAIS DE VILHENA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (724, 926, 'CENTRO UNIVERSITARIO ANHANGUERA DE CAMPO GRANDE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (725, 927, 'CENTRO DE ESTUDOS SUPERIORES DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (726, 929, 'INSTITUTO MANAUARA DE ENSINO SUPERIOR', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (727, 930, 'FACULDADE DE EDUCACAO DE ALTA FLORESTA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (728, 934, 'FACULDADE SAO CARLOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (729, 935, 'FACULDADE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (730, 939, 'FACULDADE CATOLICA DE ANAPOLIS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (731, 940, 'FACULDADES MAGSUL', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (732, 941, 'FACULDADE DE EDUCACAO DE PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (733, 944, 'ESCOLA SUPERIOR DE PROPAGANDA E MARKETING DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (734, 945, 'INSTITUTO DE CIENCIAS SOCIAIS E HUMANAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (735, 950, 'UNIAO DE ENSINO SUPERIOR DE NOVA MUTUM', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (736, 951, 'FACULDADES INTEGRADAS DE COXIM', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (737, 952, 'UNIVERSIDADE SANTA CECILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (738, 953, 'UNIVERSIDADE METROPOLITANA DE SANTOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (739, 954, 'FACULDADE DE CIENCIAS AGRO AMBIENTAIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (740, 955, 'FACULDADE DE FILOSOFIA NOSSA SENHORA IMACULADA CONCEICAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (741, 959, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (742, 960, 'FACULDADE DE CIENCIAS CONTABEIS DE ALTA FLORESTA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (743, 961, 'FACULDADE GARCIA SILVEIRA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (744, 966, 'FACULDADE DE TURISMO SANTOS DUMONT', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (745, 967, 'FACULDADE DE TECNOLOGIA DE TAQUARITINGA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (746, 968, 'FACULDADE DE TECNOLOGIA EM PROCESSAMENTO DE DADOS DE ANDRADINA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (747, 969, 'FACULDADE DE TURISMO FORMIGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (748, 970, 'FACULDADE DE SERVICO SOCIAL DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (749, 971, 'FACULDADE DE TECNOLOGIA E CIENCIAS DE CONSELHEIRO LAFAIETE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (750, 973, 'FACULDADE DE LUCELIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (751, 975, 'FACULDADE DE FISIOTERAPIA DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (752, 976, 'FACULDADES INTEGRADAS DE PONTA PORA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (753, 977, 'FACULDADE SAO CAMILO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (754, 980, 'FACULDADE DE ADMINISTRACAO DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (755, 983, 'FACULDADE PRUDENTE DE MORAES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (756, 984, 'FACULDADE DE EDUCACAO DE IVAIPORA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (757, 985, 'FACULDADE DE CIENCIAS E EDUCACAO DE RUBIATABA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (758, 986, 'FACULDADE DE EDUCACAO E CULTURA MONTESSORI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (759, 988, 'FACULDADE DE COMUNICACAO SOCIAL TAMOIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (760, 989, 'ESCOLA SUPERIOR EM MEIO AMBIENTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (761, 990, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE CONGONHAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (762, 991, 'FACULDADE SENAICETIQT', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (763, 994, 'FACULDADE DE DUQUE DE CAXIAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (764, 997, 'CENTRO UNIVERSITARIO DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (765, 998, 'FACULDADE DE SERVICO SOCIAL DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (766, 999, 'FACULDADE DE DIREITO DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (767, 1001, 'FACULDADE DE CIENCIAS ECONOMICAS E ADMINISTRATIVAS DE PRESIDENTE PRUDENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (768, 1002, 'FACULDADE DE DIREITO DE PRESIDENTE PRUDENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (769, 1003, 'FACULDADE DE SERVICO SOCIAL PRESIDENTE PRUDENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (770, 1012, 'FACULDADE DE FORMACAO DE PROFESSORES DE AFOGADOS DA INGAZEIRA', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (771, 1013, 'FACULDADE SUDOESTE PAULISTANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (772, 1014, 'INSTITUTO SUPERIOR E CENTRO EDUCACIONAL LUTERANO BOM JESUS IELUSC', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (773, 1015, 'FACULDADE DE CIENCIAS CONTABEIS MACHADO DE ASSIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (774, 1016, 'FACULDADE DE CIENCIAS HUMANAS DO VALE DO PIRANGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (775, 1017, 'FACULDADE STEFANINI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (776, 1019, 'FACULDADE DE CIENCIAS E TECNOLOGIA DE UNAI FACTU', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (777, 1021, 'FACULDADE DE CIENCIAS DE TIMBAUBA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (778, 1027, 'UNIVERSIDADE ESTADUAL DO NORTE FLUMINENSE DARCY RIBEIRO', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (779, 1028, 'UNIVERSIDADE ESTADUAL DE MATO GROSSO DO SUL', 2, 1, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (780, 1030, 'FACULDADE DE ECONOMIA E FINANCAS IBMEC', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (781, 1031, 'FACULDADE ANDRE DA SILVEIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (782, 1032, 'CENTRO UNIVERSITARIO SALESIANO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (783, 1034, 'UNIAO DE ESCOLAS SUPERIORES DA FUNESO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (784, 1036, 'UNIVERSIDADE DO ESTADO DE MINAS GERAIS', 2, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (785, 1038, 'FACULDADES INTEGRADAS DE TRES LAGOAS', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (786, 1040, 'FACULDADES DE VALINHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (787, 1041, 'CENTRO UNIVERSITARIO UNIVATES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (788, 1042, 'UNIVERSIDADE POSITIVO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (789, 1043, 'CENTRO UNIVERSITARIO HERMINIO OMETTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (790, 1045, 'CENTRO UNIVERSITARIO ANHANGUERA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (791, 1046, 'UNIAO DAS FACULDADES DOS GRANDES LAGOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (792, 1047, 'FACULDADE TECNOLOGICA PORTO ALEGRENSE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (793, 1048, 'FACULDADE CAMPOS ELISEOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (794, 1049, 'INSTITUTO DE ENSINO SUPERIOR FUCAPI', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (795, 1051, 'FACULDADE DE CIENCIAS CONTABEIS MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (796, 1052, 'FACULDADE ADVENTISTA DE ADMINISTRACAO DO NORDESTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (797, 1053, 'FACULDADE DE TECNOLOGIA E CIENCIAS DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (798, 1054, 'ESCOLA BAHIANA DE ADMINISTRACAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (799, 1055, 'FACULDADE MAURICIO DE NASSAU DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (800, 1058, 'CENTRO UNIVERSITARIO ESTACIO DA BAHIA ESTACIO FIB', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (801, 1059, 'FACULDADE LOURENCO FILHO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (802, 1060, 'CENTRO UNIVERSITARIO DO INSTITUTO DE EDUCACAO SUPERIOR DE BRASILIA IESB', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (803, 1061, 'FACULDADE PLANALTO DE ADMINISTRACAO E CIENCIAS ECONOMICAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (804, 1063, 'FACULDADE COMUNITARIA DE VILA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (805, 1064, 'FACULDADE COMUNITARIA DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (806, 1065, 'FACULDADE DE CIENCIAS ECONOMICAS E ADMINISTRATIVAS DE VILA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (807, 1066, 'INSTITUTO DE ENSINO E PESQUISA OBJETIVO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (808, 1067, 'FACULDADE DE JUSSARA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (809, 1068, 'FACULDADE ALDETE MARIA ALVES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (810, 1069, 'CENTRO REGIONAL DE ESTUDOS EM CIENCIAS HUMANAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (811, 1070, 'INSTITUTO DE ENSINO SUPERIOR CENECISTA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (812, 1071, 'INSTITUTO DE ENSINO SUPERIOR DA FUNLEC', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (813, 1072, 'FACULDADE AFIRMATIVO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (814, 1075, 'INSTITUTO DE EDUCACAO SUPERIOR DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (815, 1076, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE CAJAZEIRAS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (816, 1077, 'FACULDADE ESTACIO DO RECIFE ESTACIO FIR', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (817, 1078, 'FACULDADE INTEGRADO DE CAMPO MOURAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (818, 1079, 'FACULDADE MARINGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (819, 1080, 'FACULDADE ARTHUR SA EARP NETO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (820, 1081, 'FACULDADE DE ENGENHARIA DE RESENDE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (821, 1082, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO RIO GRANDE DO NORTE', 1, 1, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (822, 1084, 'FACULDADE CENECISTA DE BENTO GONCALVES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (823, 1085, 'FACULDADE METODISTA DE SANTA MARIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (824, 1086, 'FACULDADE DE EDUCACAO DE COLORADO DO OESTE', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (825, 1087, 'FACULDADES INTEGRADAS APARICIO CARVALHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (826, 1088, 'FACULDADE DE DESENHO INDUSTRIAL DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (827, 1089, 'CENTRO DE EDUCACAO SUPERIOR UNICA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (828, 1090, 'FACULDADE SAO LUIS DE FRANCA', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (829, 1091, 'FACULDADE DE PEDAGOGIA DE VARGEM GRANDE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (830, 1092, 'FACULDADES INTEGRADAS DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (831, 1093, 'FACULDADE DE CIENCIAS JURIDICAS E GERENCIAIS DE GARCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (832, 1095, 'FACULDADE DE ADMINISTRACAO E NEGOCIOS DE MONTE ALTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (833, 1096, 'FACULDADE DE PRESIDENTE EPITACIO FAPE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (834, 1097, 'FACULDADES INTEGRADAS DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (835, 1099, 'FACULDADE DE EDUCACAO E CIENCIAS GERENCIAIS DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (836, 1100, 'FACULDADE CARLOS DRUMMOND DE ANDRADE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (837, 1101, 'FACULDADE ADVENTISTA DE CIENCIAS DA SAUDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (838, 1102, 'FACULDADE DE INFORMATICA MARILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (839, 1103, 'FACULDADE DE ADMINISTRACAO SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (840, 1104, 'FACULDADE DE COMUNICACAO SOCIAL DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (841, 1107, 'CENTRO UNIVERSITARIO ESTACIO DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (842, 1108, 'FACULDADE DE CIENCIAS GERENCIAIS COTIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (843, 1111, 'FACULDADE DE TURISMO DOMUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (844, 1112, 'FACULDADE DE RELACOES INTERNACIONAIS DOMUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (845, 1113, 'CENTRO UNIVERSITARIO EURO AMERICANO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (846, 1114, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS APLICADAS RIO BRANCO FIRB', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (847, 1115, 'FACULDADE SANTA TEREZINHA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (849, 1117, 'FACULDADE SENAC DE COMUNICACAO E ARTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (850, 1118, 'UNIAO DAS ESCOLAS DO GRUPO FAIMI DE EDUCACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (851, 1119, 'FACULDADE PLANALTO DE FILOSOFIA, CIENCIAS E LETRAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (852, 1120, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA FLUMINENSE', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (853, 1122, 'FACULDADE REGES DE OSVALDO CRUZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (854, 1123, 'INSTITUTO DE EDUCACAO SUPERIOR UNYAHNA DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (855, 1124, 'INSTITUTO DE EDUCACAO SUPERIOR UNYAHNA DE BARREIRAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (856, 1125, 'FACULDADES INTEGRADAS ESPIRITA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (857, 1126, 'UNIVERSIDADE ESTADUAL DO CENTRO OESTE', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (858, 1128, 'UNIVERSIDADE DE ITAUNA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (859, 1129, 'CENTRO UNIVERSITARIO DO NORTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (860, 1130, 'FACULDADE METODISTA DE CIENCIAS HUMANAS E EXATAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (861, 1131, 'FACULDADE SANTO AGOSTINHO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (862, 1132, 'FACULDADE DE CIENCIA DA COMPUTACAO DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (863, 1134, 'FACULDADE EVANGELICA LUTERANA MARTINUS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (864, 1135, 'FACULDADE PLANALTO DE CIENCIA DA COMPUTACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (865, 1136, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS DE IGARASSU', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (866, 1137, 'CENTRO DE ENSINO SUPERIOR HEROIS DE JENIPAPO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (867, 1138, 'CENTRO DE EDUCACAO SUPERIOR DE BLUMENAU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (868, 1139, 'FACULDADE DE ESTUDOS ADMINISTRATIVOS DE MINAS GERAIS FEADMG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (869, 1140, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (870, 1141, 'FACULDADE GAMA E SOUZA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (871, 1142, 'FACULDADES INTEGRADAS DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (872, 1143, 'FACULDADE DE CIENCIAS DE TIMBAUBA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (873, 1144, 'FACULDADE DE CIENCIAS HUMANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (874, 1145, 'FACULDADE DE CIENCIAS AGRARIAS DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (875, 1147, 'FACULDADE RUY BARBOSA DE PSICOLOGIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (876, 1149, 'CENTRO UNIVERSITARIO NOSSA SENHORA DO PATROCINIO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (877, 1150, 'FACULDADE SENAI DE TECNOLOGIA GRAFICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (878, 1151, 'FACULDADE DE ADMINISTRACAO E NEGOCIOS DE SERGIPE', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (879, 1152, 'INSTITUTO SUL BRASIL DE ENSINO SUPERIOR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (880, 1153, 'UNIVERSIDADE CANDIDO MENDES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (881, 1155, 'FACULDADE SALESIANA DE SANTA TERESA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (882, 1156, 'FACULDADE CENECISTA DE ITABORAI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (883, 1157, 'ESCOLA SUPERIOR SAO FRANCISCO DE ASSIS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (884, 1158, 'FACULDADE RUY BARBOSA DE CIENCIA DA COMPUTACAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (885, 1159, 'CENTRO DE ENSINO SUPERIOR DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (886, 1160, 'FACULDADE CAMBURY', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (887, 1161, 'INSPER INSTITUTO DE ENSINO E PESQUISA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (888, 1162, 'FACULDADE DE ALTA FLORESTA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (889, 1163, 'FACULDADE DE CIENCIA DA COMPUTACAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (890, 1164, 'FACULDADE VARZEAGRANDENSE DE ADMINISTRACAO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (891, 1166, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DA PARAIBA', 1, 1, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (892, 1168, 'FACULDADE DE ANALISE DE SISTEMAS DE INFORMACAO DOMUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (893, 1169, 'FACULDADE SENAC DE MODA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (894, 1170, 'FACULDADE METROPOLITANA DE CAMACARI', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (895, 1171, 'FACULDADE DE LETRAS MARILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (896, 1172, 'FACULDADE AD 1', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (897, 1173, 'FACULDADE ANHANGUERA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (898, 1174, 'FACULDADE DE SABARA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (899, 1175, 'FACULDADES RIOGRANDENSES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (900, 1176, 'FACULDADE DE ANGRA DOS REIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (901, 1177, 'ESCOLA SUPERIOR DE CIENCIAS AGRARIAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (902, 1179, 'ESCOLA SUPERIOR DE CIENCIAS DA SAUDE DE RIO VERDE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (903, 1180, 'FACULDADE BARDDAL DE LETRAS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (904, 1181, 'FACULDADE BRASILIA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (905, 1182, 'INSTITUTO DE ENSINO SUPERIOR DE AMERICANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (906, 1183, 'INSTITUTO SAO JOSE DOS CAMPOS DE ENSINO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (907, 1184, 'CENTRO DE CIENCIAS DA SAUDE DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (908, 1185, 'CENTRO UNIVERSITARIO JORGE AMADO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (909, 1186, 'FACULDADE DE TURISMO E HOTELARIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (910, 1187, 'CENTRO UNIVERSITARIO MODULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (911, 1189, 'UNIVERSIDADE DO PLANALTO CATARINENSE', 3, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (912, 1190, 'FACULDADE INTEGRAL CANTAREIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (913, 1191, 'INSTITUTO DE ENSINO SUPERIOR DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (914, 1192, 'FACULDADE DE CIENCIAS DA SAUDE DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (915, 1194, 'FACULDADE DE TECNOLOGIA DE PONTA PORA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (916, 1195, 'FACULDADE SENAI DE TECNOLOGIA MECATRONICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (917, 1196, 'CENTRO UNIVERSITARIO DE MARINGA UNICESUMAR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (918, 1197, 'FACULDADE DE TURISMO AEMARJ', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (919, 1198, 'FACULDADE DE CIENCIAS SOCIAIS E APLICADAS DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (920, 1200, 'INSTITUTO BRASILIENSE DE TECNOLOGIA E CIENCIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (921, 1201, 'FACULDADE DE ADMINISTRACAO MILTON CAMPOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (922, 1202, 'FACULDADE SANTA RITA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (923, 1203, 'FACULDADE DE ECONOMIA DE OURO FINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (924, 1204, 'FACULDADE DE AMAMBAI', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (925, 1205, 'FACULDADE EDUCACIONAL DA LAPA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (926, 1206, 'FACULDADE ADVENTISTA DE FISIOTERAPIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (927, 1207, 'FACULDADE DE ADMINISTRACAO GERAL', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (928, 1208, 'FAL ESTACIO FACULDADE ESTACIO DE NATAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (929, 1209, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (930, 1210, 'FACULDADE DE CIENCIAS DA COMUNICACAO DE TAQUARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (931, 1211, 'INSTITUTO DE ENSINO SUPERIOR DE SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (932, 1212, 'FACULDADE DE CIENCIAS CONTABEIS DE ASSIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (933, 1213, 'FACULDADE FLEMING', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (934, 1215, 'FACULDADE ANGLOLATINO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (935, 1217, 'CENTRO DE TECNOLOGIA EM AUTOMACAO DE INFORMATICA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (936, 1219, 'INSTITUTO ITAPETININGANO DE ENSINO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (937, 1220, 'INSTITUTO MATAO DE ENSINO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (938, 1221, 'FACULDADE GAMMON', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (939, 1222, 'FACULDADE SENAC DE CIENCIAS EXATAS E TECNOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (940, 1223, 'FACULDADE RADIAL JABAQUARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (941, 1224, 'CENTRO UNIVERSITARIO DE JALES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (942, 1225, 'CENTRO UNIVERSITARIO AMPARENSE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (943, 1226, 'INSTITUTO DE ENSINO SUPERIOR DO ACRE', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (944, 1227, 'FACULDADE SAO FRANCISCO DE BARREIRAS FASB', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (945, 1228, 'FACULDADE DE TECNOLOGIA EMPRESARIAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (946, 1229, 'INSTITUTO DE ENSINO SUPERIOR DO NORDESTE', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (947, 1230, 'CENTRO REGIONAL UNIVERSITARIO DE ESPIRITO SANTO DO PINHAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (948, 1231, 'INSTITUTO CENECISTA DE ENSINO SUPERIOR DE SANTO ANGELO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (949, 1232, 'CENTRO UNIVERSITARIO CAMPOS DE ANDRADE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (950, 1233, 'CENTRO UNIVERSITARIO CANDIDO RONDON', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (951, 1234, 'FACULDADE METROPOLITANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (952, 1235, 'ESCOLA DE EDUCACAO SUPERIOR IPITANGA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (953, 1236, 'ESCOLA POLITECNICA IPITANGA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (954, 1237, 'FACULDADE NOSSA SENHORA APARECIDA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (955, 1238, 'FACULDADE DE CIENCIAS CONTABEIS DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (956, 1239, 'FACULDADE PADRAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (957, 1240, 'FACULDADE DE ESTUDOS SOCIAIS DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (958, 1241, 'FACULDADE ESPIRITO SANTENSE DE ENSINO TECNOLOGICO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (959, 1243, 'FACULDADE COMUNITARIA DE ADMINISTRACAO DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (960, 1244, 'FACULDADE BRASILEIRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (961, 1245, 'FACULDADE DE CASTELO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (962, 1246, 'FACULDADE CANDIDO MENDES DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (963, 1247, 'FACULDADE DE CIENCIAS CONTABEIS DE NOVA ANDRADINA FACINAN', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (964, 1248, 'FACULDADE DE PEDAGOGIA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (965, 1249, 'FACULDADE DE EDUCACAO DE COSTA RICA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (966, 1252, 'FACULDADE PROMOVE DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (967, 1253, 'FACULDADE METODISTA GRANBERY', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (968, 1254, 'FACULDADE DE ADMINISTRACAO DE ITABIRITO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (969, 1255, 'FACULDADE BOA VIAGEM', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (970, 1256, 'FACULDADE DOM BOSCO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (971, 1257, 'FACULDADE DE ADMINISTRACAO, CIENCIAS, EDUCACAO E LETRAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (972, 1258, 'FACULDADE DE CIENCIAS APLICADAS DE CASCAVEL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (973, 1259, 'FACULDADE NOBEL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (974, 1260, 'FACULDADE OPET', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (975, 1261, 'FACULDADE ADVENTISTA DE CIENCIAS CONTABEIS DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (976, 1262, 'FACULDADE ADVENTISTA DE EDUCACAO DO NORDESTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (977, 1263, 'FACULDADE BEZERRA DE ARAUJO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (978, 1264, 'CENTRO UNIVERSITARIO DO RIO GRANDE DO NORTE', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (979, 1265, 'FACULDADE DE PROCESSAMENTO DE DADOS DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (980, 1266, 'FACULDADES INTEGRADAS URUBUPUNGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (981, 1267, 'INSTITUTO DE ENSINO SUPERIOR DA GRANDE FLORIANOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (982, 1270, 'CENTRO UNIVERSITARIO UNISEB', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (983, 1271, 'FACULDADE DE COMUNICACAO SOCIAL DOMUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (984, 1272, 'FACULDADE SANT´ANNA DE SALTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (985, 1273, 'FACULDADE CAMPO LIMPO PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (986, 1274, 'FACULDADE DE EDUCACAO DOMUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (987, 1275, 'FACULDADE DO GUARUJA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (988, 1276, 'INSTITUTO TAUBATE DE ENSINO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (989, 1277, 'FACULDADE DE INFORMATICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (990, 1278, 'FACULDADE ADVENTISTA DE EDUCACAO E CIENCIAS HUMANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (991, 1279, 'FACULDADE DE ITAPOLIS FACITA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (992, 1280, 'FACULDADE ESTACIO COTIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (993, 1281, 'FACULDADE DE CIENCIAS SOCIAIS E AGRARIAS DE ITAPEVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (994, 1283, 'INSTITUTO MANCHESTER PAULISTA DE ENSINO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (995, 1285, 'INSTITUTO DE ENSINO SUPERIOR DE MAIRIPORA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (996, 1286, 'FACULDADE SENAI DE TECNOLOGIA AMBIENTAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (997, 1287, 'FACULDADE DE CIENCIAS GERENCIAIS DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (998, 1288, 'FACULDADE INDEPENDENTE BUTANTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (999, 1289, 'FACULDADE DE DIREITO DA FUNDACAO ARMANDO ALVARES PENTEADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1000, 1290, 'FACULDADE ALVARES DE AZEVEDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1001, 1291, 'FACULDADE DO NORTE PIONEIRO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1002, 1292, 'FACULDADES ADAMANTINENSES INTEGRADAS', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1003, 1293, 'INSTITUTO DE ENSINO SUPERIOR DO OESTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1004, 1294, 'FACULDADE DAS AMERICAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1005, 1295, 'FACULDADE MORUMBI SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1006, 1296, 'ESCOLA SUPERIOR DE MARKETING', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1007, 1297, 'FACULDADE DOURADOS', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1008, 1298, 'FACULDADE ESTACIO DE ALAGOAS ESTACIO FAL', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1009, 1299, 'FACULDADES INTEGRADAS DE FERNANDOPOLIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1010, 1300, 'INSTITUTO TAQUARITINGUENSE DE ENSINO SUPERIOR DR. ARISTIDES DE CARVALHO SCHLOBACH', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1011, 1301, 'INSTITUTO MATONENSE MUNICIPAL DE ENSINO SUPERIOR', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1012, 1302, 'FACULDADE BATISTA BRASILEIRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1013, 1303, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA GOIANO', 1, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1014, 1304, 'FACULDADES INTEGRADAS DE RIBEIRAO PIRES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1015, 1305, 'FACULDADE DE CIENCIAS JURIDICAS, GERENCIAIS E EDUCACAO DE SINOP', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1016, 1306, 'FACULDADE DE CIENCIAS CONTABEIS DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1017, 1307, 'FACULDADE DE CIENCIAS HUMANAS DE GARCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1018, 1308, 'FACULDADE NOVO MILENIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1019, 1309, 'FACULDADE JESUS MARIA JOSE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1020, 1310, 'FACULDADE DE AMERICANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1021, 1311, 'TREVISAN ESCOLA SUPERIOR DE NEGOCIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1022, 1312, 'FACULDADES INTEGRADAS DE RONDONOPOLIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1023, 1313, 'FACULDADE UNIDA DE SUZANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1024, 1314, 'INSTITUTO DE ENSINO SUPERIOR JOAO ALFREDO DE ANDRADE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1025, 1315, 'FACULDADE DE EDUCACAO DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1026, 1316, 'FACULDADE DA TERRA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1027, 1317, 'FACULDADE SUDOESTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1028, 1318, 'FACULDADE JUVENCIO TERRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1029, 1319, 'FACULDADE TECSOMA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1030, 1320, 'FACULDADE DE EDUCACAO FISICA DO LITORAL NORTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1031, 1321, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS E CONTABEIS DA ZONA NORTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1032, 1322, 'FACULDADE EDUVALE DE AVARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1033, 1323, 'FACULDADE TANCREDO NEVES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1034, 1324, 'FACULDADE DE INFORMATICA LEMOS DE CASTRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1035, 1325, 'FACULDADE DE APUCARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1036, 1326, 'FACULDADE CAPIXABA DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1037, 1327, 'ESCOLA SUPERIOR DE PROPAGANDA E MARKETING DE PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1038, 1328, 'FACULDADE DE COMUNICACAO E TURISMO DE OLINDA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1039, 1329, 'FACULDADE DE ADMINISTRACAO DE DIADEMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1040, 1330, 'FACULDADE COTEMIG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1041, 1331, 'FACULDADE HOYLER DE COMUNICACAO SOCIAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1042, 1332, 'FACULDADE DE COMUNICACAO SOCIAL DE HORTOLANDIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1043, 1333, 'FACULDADE CECAP DO LAGO NORTE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1044, 1334, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS FACISA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1045, 1335, 'INSTITUTO DE ENSINO SUPERIOR THATHI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1046, 1336, 'FACULDADE ASSIS GURGACZ', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1047, 1337, 'FACULDADE MATER DEI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1048, 1338, 'FACULDADE DE EDUCACAO DE PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1049, 1339, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS DE PARANAIBA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1050, 1340, 'FACULDADE DE CIENCIAS GERENCIAIS DE SETE LAGOAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1051, 1341, 'FACULDADE DE ARQUITETURA E URBANISMO DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1052, 1342, 'FACULDADE COMUNITARIA DE PEDAGOGIA DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1053, 1343, 'FACULDADE DE EDUCACAO DA TERRA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1054, 1344, 'FACULDADE BORGES DE MENDONCA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1055, 1345, 'FACULDADE ANHANGUERA DE OSASCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1056, 1346, 'FACULDADE BATISTA DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1057, 1347, 'FACULDADE ADVENTISTA DE ADMINISTRACAO DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1058, 1348, 'FACULDADE BATISTA DE ADMINISTRACAO E INFORMATICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1059, 1349, 'FACULDADE DE CIENCIAS ECONOMICAS DE AFONSO CLAUDIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1060, 1350, 'FACULDADE DO VALE DO JAGUARIBE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1061, 1351, 'CENTRO UNIVERSITARIO TUPY', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1062, 1352, 'FACULDADE ADVENTISTA DE EDUCACAO FISICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1063, 1353, 'INSTITUTO DE ENSINO SUPERIOR DE GARCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1064, 1354, 'FACULDADE DE CIENCIA DE ADMINISTRACAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1065, 1355, 'FACULDADES INTEGRADAS DE JAHU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1066, 1356, 'FACULDADES INTEGRADAS DE SANTA FE DO SUL', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1067, 1357, 'INSTITUTO SUPERIOR DE EDUCACAO DO RIO DE JANEIRO', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1068, 1358, 'FACULDADE DE PEDAGOGIA DE AFONSO CLAUDIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1069, 1359, 'FACULDADE CAPIXABA DE NOVA VENECIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1071, 1361, 'FACULDADE DOM ORIONE', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1072, 1362, 'FACULDADE UBAENSE OZANAM COELHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1073, 1363, 'FACULDADE VISCONDE DE CAIRU', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1074, 1364, 'FACULDADE DE TECNOLOGIA E CIENCIAS DE VITORIA DA CONQUISTA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1075, 1365, 'CENTRO UNIVERSITARIO ADVENTISTA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1076, 1366, 'FACULDADE BARDDAL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1077, 1367, 'FACULDADE DE CIENCIA DA COMPUTACAO DE FORMIGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1078, 1368, 'FACULDADE DE CIENCIAS CONTABEIS DE BOM DESPACHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1079, 1369, 'FACULDADE SENAC DE TURISMO E HOTELARIA DE AGUAS DE SAO PEDRO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1080, 1370, 'FACULDADE SENAC DE TURISMO E HOTELARIA DE CAMPOS DO JORDAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1081, 1371, 'FACULDADE DE MIRANDOPOLIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1082, 1372, 'FACULDADE SENAC DE EDUCACAO AMBIENTAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1083, 1373, 'FACULDADE CASA BRANCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1084, 1374, 'FACULDADE DE CIENCIAS SOCIAIS DE GUARANTA DO NORTE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1085, 1375, 'FACULDADE CATOLICA RAINHA DA PAZ DE ARAPUTANGA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1086, 1376, 'FACULDADE COMPACTO DE EDUCACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1087, 1377, 'FACULDADE DE CIENCIA E TECNOLOGIA DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1088, 1378, 'FACULDADE ASSEMBLEIANA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1089, 1379, 'FACULDADES INTEGRADAS SAO PEDRO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1090, 1380, 'FACULDADE DE DOMINGOS MARTINS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1091, 1381, 'FACULDADE MARTHA FALCAO', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1092, 1382, 'FACULDADES EST', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1093, 1383, 'FACULDADE JOSE LACERDA FILHO DE CIENCIAS APLICADAS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1094, 1384, 'FACULDADE SANTA HELENA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1095, 1385, 'FACULDADES INTEGRADAS IPEP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1096, 1386, 'FACULDADE ESAMC CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1097, 1387, 'FACULDADE OCTOGONO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1098, 1388, 'FACULDADE SUMARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1099, 1389, 'FACULDADE TORRICELLI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1100, 1390, 'FACULDADE ELITE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1101, 1394, 'FACULDADE CASTRO ALVES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1102, 1395, 'FACULDADE DE CALDAS NOVAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1103, 1396, 'CENTRO UNIVERSITARIO DINAMICA DAS CATARATAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1104, 1397, 'FACULDADE OESTE MINEIRA DE INFORMATICA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1105, 1398, 'FACULDADE DE DIREITO DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1106, 1399, 'FACULDADE UNISSA DE SARANDI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1107, 1400, 'FACULDADE METROPOLITANA DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1108, 1401, 'FACULDADE ADELMAR ROSADO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1109, 1402, 'INSTITUTO DE CIENCIAS SOCIAIS E HUMANAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1110, 1403, 'FACULDADE DE PIMENTA BUENO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1111, 1404, 'FACULDADE DE PIRACANJUBA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1112, 1405, 'FACULDADE DE CIENCIAS CONTABEIS DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1113, 1406, 'FACULDADE DE ENGENHARIA E TECNOLOGIA DO INSTITUTO MAIRIPORA DE ENSINO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1114, 1407, 'FACULDADE DE ECONOMIA E ADMINISTRACAO DOMUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1115, 1408, 'FACULDADE DE SANTO ANDRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1116, 1409, 'FACULDADE DO CENTRO LESTE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1117, 1410, 'AREA1   FACULDADE DE CIENCIA E TECNOLOGIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1118, 1411, 'FACULDADE DOIS DE JULHO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1119, 1412, 'FACULDADE ANHAGUERA DE JUNDIAI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1120, 1413, 'FACULDADE DE PRIMAVERA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1121, 1414, 'FACULDADE SAO LUCAS', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1122, 1415, 'FACULDADE MAGISTER', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1123, 1416, 'FACULDADE GRANDE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1124, 1417, 'FACULDADE CENECISTA DE CAMPO LARGO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1125, 1418, 'CENTRO UNIVERSITARIO TOLEDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1126, 1419, 'CENTRO UNIVERSITARIO CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1127, 1420, 'FACULDADES DE DRACENA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1128, 1422, 'CENTRO UNIVERSITARIO DO NORTE', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1129, 1423, 'FACULDADE IDEAL', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1130, 1424, 'FACULDADE PIO XII', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1131, 1425, 'FACULDADE EVOLUTIVO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1132, 1426, 'INSTITUTO LUTERANO DE ENSINO SUPERIOR DE ITUMBIARA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1133, 1427, 'FACULDADE DA SERRA GAUCHA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1134, 1428, 'INSTITUTO DE ENSINO SUPERIOR PLANALTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1135, 1429, 'FACULDADE BATISTA DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1136, 1430, 'FACULDADE INGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1137, 1431, 'FACULDADE PIRATININGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1138, 1432, 'FACULDADE BERTIOGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1139, 1433, 'FACULDADE ORIGENES LESSA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1140, 1434, 'INSTITUTO DE ENSINO SUPERIOR DE ITAPIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1141, 1435, 'FACULDADE DE VILA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1142, 1436, 'ESCOLA SUPERIOR BATISTA DO AMAZONAS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1143, 1437, 'ESCOLA SUPERIOR DE TECNOLOGIA E EDUCACAO DE RIO CLARO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1144, 1438, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1145, 1439, 'FACULDADE DE CIENCIAS ECONOMICAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1146, 1440, 'INSTITUTO APHONSIANO DE ENSINO SUPERIOR', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1147, 1441, 'FACULDADE DE TECNOLOGIA DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1148, 1442, 'FACULDADE DE DIREITO DE TANGARA DA SERRA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1149, 1443, 'FACULDADE NACIONAL', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1150, 1444, 'FACULDADES INTEGRADAS EINSTEIN DE LIMEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1151, 1445, 'CENTRO UNIVERSITARIO DO INSTITUTO MAUA DE TECNOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1152, 1446, 'CENTRO UNIVERSITARIO PLANALTO DO DISTRITO FEDERAL UNIPLAN', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1153, 1447, 'FACULDADE DE DIREITO DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1154, 1448, 'FACULDADE DO CENTRO EDUCACIONAL DE NITEROI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1155, 1449, 'FACULDADE DE EDUCACAO, ADMINISTRACAO E TECNOLOGIA DE IBAITI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1156, 1450, 'CENTRO UNIVERSITARIO DO CERRADO PATROCINIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1157, 1451, 'FACULDADES INTEGRADAS DE SAO CARLOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1158, 1452, 'FACULDADE ATENAS MARANHENSE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1159, 1453, 'FACULDADE DO NORTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1160, 1454, 'FACULDADE SALESIANA DO NORDESTE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1161, 1455, 'FACULDADE SANTISSIMO SACRAMENTO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1162, 1456, 'FACULDADE ANHANGUERA DE SERTAOZINHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1163, 1457, 'FACULDADE ESTACIO EURO PANAMERICANA DE HUMANIDADES E TECNOLOGIAS ESTACIO EUROPAN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1164, 1458, 'FACULDADE DO NORTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1165, 1459, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1166, 1460, 'FACULDADE DE CIENCIAS SOCIAIS E APLICADAS DO COMPLEXO DE ENSINO SUPERIOR DO BRASIL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1167, 1461, 'FACULDADE DE TECNOLOGIA E CIENCIAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1168, 1462, 'INSTITUTO PARAIBANO DE ENSINO RENOVADO', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1169, 1463, 'FACULDADE ALFACASTELO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1170, 1464, 'HSM ESCOLA SUPERIOR DE ADMINISTRACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1171, 1465, 'FACULDADE DE RIBEIRAO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1172, 1466, 'INSTITUTO DE ENSINO SUPERIOR DE ALPHAVILLE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1173, 1467, 'FACULDADE CENECISTA DE VILA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1174, 1468, 'FACULDADE ESAMC UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1175, 1469, 'FACULDADE DE CIENCIAS SOCIAIS DE FLORIANOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1176, 1470, 'FACULDADE CAMOES', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1177, 1471, 'INSTITUTO DE ENSINO SUPERIOR DE LINHARES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1178, 1472, 'CENTRO UNIVERSITARIO LEONARDO DA VINCI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1179, 1473, 'FACULDADE DE ADMINISTRACAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1180, 1474, 'FACULDADE DE EDUCACAO DE ATIBAIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1181, 1475, 'FACULDADE DE CIENCIAS ECONOMICAS DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1182, 1476, 'FACULDADES INTEGRADAS INTERAMERICANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1183, 1477, 'FACULDADE MICHELANGELO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1184, 1478, 'FACULDADE ANHANGUERA DE SAO BERNARDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1185, 1479, 'FACULDADES INTEGRADAS TIBIRICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1186, 1480, 'FACULDADE DE LETRAS DOMUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1187, 1481, 'FACULDADE DE ADMINISTRACAO DE FLORIANOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1188, 1482, 'FACULDADE DE CIENCIAS ECONOMICAS VIANNA JUNIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1189, 1483, 'FACULDADE DE CIENCIAS ECONOMICAS DE EUNAPOLIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1190, 1484, 'FACULDADE IBMEC', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1191, 1485, 'FACULDADE DE ENFERMAGEM DE CATANDUVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1192, 1486, 'FACULDADE ESTACIO DE SA DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1193, 1487, 'FACULDADE DOM BOSCO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1194, 1488, 'FACULDADE PARAISO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1195, 1489, 'FACULDADE DE SELVIRIA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1196, 1490, 'FACULDADE DE JAGUARIUNA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1197, 1491, 'CENTRO UNIVERSITARIO INTERNACIONAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1198, 1492, 'FACULDADE PITAGORAS DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1199, 1493, 'FACULDADE ALVES FARIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1200, 1494, 'FACULDADE CATOLICA SALESIANA DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1201, 1495, 'FACULDADE UNIAO DE QUEDAS DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1202, 1496, 'FACULDADE ESTACIO DE SA DE VILA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1203, 1497, 'FACULDADE DE ADMINISTRACAO DE SANTA CRUZ DO RIO PARDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1204, 1498, 'INSTITUTO DE ENSINO SUPERIOR E FORMACAO AVANCADA DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1205, 1499, 'FACULDADE ANHANGUERA DE TABOAO DA SERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1206, 1500, 'FACULDADE DE ENSINO SUPERIOR DE SAO MIGUEL DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1207, 1501, 'FACULDADE LATINO AMERICANA DE EDUCACAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1208, 1502, 'FACULDADE PITAGORAS DE JUNDIAI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1209, 1503, 'FACULDADE DOUTOR LEOCADIO JOSE CORREIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1210, 1504, 'FACULDADE MAURICIO DE NASSAU DE MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1211, 1505, 'FACULDADE DE MEDICINA VETERINARIA E ZOOTECNIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1212, 1506, 'INSTITUTO CENECISTA FAYAL DE ENSINO SUPERIOR', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1213, 1507, 'FACULDADE PROJECAO DE CEILANDIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1214, 1508, 'FACULDADE METROPOLITANA DE MARINGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1215, 1509, 'FACULDADE ESTACIO DE SA DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1216, 1510, 'FACULDADE ESTACIO DE SA DE SANTA CATARINA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1217, 1511, 'FACULDADE DE ENFERMAGEM DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1218, 1512, 'FACULDADE DE CIENCIA DA EDUCACAO DE LAGES', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1219, 1513, 'INSTITUTO DE CIENCIAS JURIDICAS E SOCIAIS PROFESSOR CAMILLO FILHO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1220, 1514, 'FACULDADE VALE DO CRICARE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1221, 1515, 'FACULDADE DE EDUCACAO DE PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1222, 1516, 'FACULDADE DE VINHEDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1223, 1517, 'FACULDADE NOVO ATENEU DE GUARAPUAVA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1224, 1518, 'FACULDADE SANTA TEREZINHA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1225, 1519, 'FACULDADE DE PATO BRANCO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1226, 1520, 'FACULDADE FIA DE ADMINISTRACAO E NEGOCIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1227, 1521, 'INSTITUTO DE ESTUDOS SUPERIORES DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1228, 1522, 'FACULDADE DE EDUCACAO DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1229, 1523, 'FACULDADE DE DIREITO FRANCISCO BELTRAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1230, 1524, 'FACULDADES INTEGRADAS OLGA METTIG', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1231, 1525, 'FACULDADE DE CIENCIAS CONTABEIS DE AFONSO CLAUDIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1232, 1526, 'FACULDADE DE TECNOLOGIA SENAI ANTOINE SKAF', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1233, 1527, 'FACULDADE TAMOIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1234, 1528, 'FACULDADE DE CIENCIAS HUMANAS SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1235, 1529, 'FACULDADE DE EDUCACAO FISICA DE AMERICANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1236, 1530, 'FACULDADE CENECISTA DE JOINVILLE FACE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1237, 1531, 'FACULDADE DE ENFERMAGEM DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1238, 1532, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS NOSSA SENHORA APARECIDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1239, 1533, 'FACULDADE DE COMUNICACAO SOCIAL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1240, 1534, 'FACULDADE DE CIENCIAS, LETRAS E EDUCACAO DO NOROESTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1241, 1535, 'FACULDADE SAO JUDAS TADEU DE PINHAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1242, 1536, 'FACULDADE DE TELEMACO BORBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1243, 1537, 'FACULDADE EXPONENCIAL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1244, 1538, 'FACULDADE PROJECAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1245, 1539, 'FACULDADE ITALO BRASILEIRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1246, 1540, 'INSTITUTO DE ENSINO SUPERIOR DE RONDONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1247, 1541, 'FACULDADE FLAMINGO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1248, 1542, 'CENTRO UNIVERSITARIO GERALDO DI BIASE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1249, 1543, 'FACULDADE DE DIREITO DE LINHARES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1250, 1544, 'FACULDADE DECISAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1251, 1545, 'INSTITUTO DE EDUCACAO SUPERIOR DE BOITUVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1252, 1546, 'FACULDADE DE EDUCACAO SAO FRANCISCO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1253, 1547, 'FACULDADE DE MEDICINA ESTACIO DE JUAZEIRO DO NORTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1254, 1548, 'FACULDADE DE CAMPO GRANDE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1255, 1549, 'FACULDADE PALAS ATENA DE CHOPINZINHO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1256, 1550, 'FACULDADE DE EDUCACAO FISICA DE FOZ DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1257, 1551, 'FACULDADE FRANCO BRASILEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1258, 1552, 'FACULDADE PIAUIENSE', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1259, 1553, 'FACULDADE DE ODONTOLOGIA DE SAO JOSE DO RIO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1260, 1554, 'FACULDADES INTEGRADAS DO VALE DO RIBEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1261, 1555, 'FACULDADE DE DIREITO DE GUARAPUAVA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1262, 1556, 'FACULDADE SETE DE SETEMBRO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1263, 1557, 'UNIVERSIDADE FUMEC', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1264, 1558, 'FACULDADE COMUNITARIA DE JOAO MONLEVADE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1265, 1559, 'CENTRO UNIVERSITARIO DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1266, 1561, 'FACULDADE ESAMC SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1267, 1562, 'FACULDADE DE ILHA SOLTEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1268, 1563, 'CENTRO UNIVERSITARIO DA FACULDADE DE SAUDE, CIENCIAS HUMANAS E TECNOLOGICAS DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1269, 1564, 'FACULDADE SUL FLUMINENSE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1270, 1565, 'FACULDADE UNIME DE CIENCIAS JURIDICAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1271, 1566, 'FACULDADE DE CIENCIAS GERENCIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1272, 1567, 'FACULDADE VIZINHANCA VALE DO IGUACU', 3, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1273, 1568, 'FACULDADES INTEGRADAS DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1274, 1569, 'FACULDADES INTEGRADAS DE ARARAQUARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1275, 1570, 'FACULDADE DE CIENCIAS CONTABEIS DE POMBAL', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1276, 1571, 'FACULDADE UNIME DE CIENCIAS SOCIAIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1277, 1572, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1278, 1573, 'FACULDADE ALFREDO NASSER', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1279, 1574, 'FACULDADE EDUCACIONAL DE MEDIANEIRA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1280, 1575, 'CENTRO UNIVERSITARIO DO PLANALTO DE ARAXA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1281, 1576, 'INSTITUTO DE ENSINO SUPERIOR BLAURO CARDOSO DE MATTOS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1282, 1577, 'FACULDADE INTERMUNICIPAL DO NOROESTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1283, 1578, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA SULRIOGRANDENSE', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1284, 1579, 'FACULDADE DE CIENCIAS SOCIAIS DE IBIRACU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1285, 1580, 'FACULDADE DE CIENCIAS E EDUCACAO SENA AIRES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1286, 1581, 'FACULDADE DA CIDADE DE SANTA LUZIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1287, 1582, 'FACULDADE DECISAO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1288, 1583, 'FACULDADE DE TECNOLOGIA DE INDAIATUBA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1289, 1584, 'FACULDADE DE TECNOLOGIA DE GUARATINGUETA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1290, 1585, 'FACULDADE ENERGIA DE ADMINISTRACAO E NEGOCIOS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1291, 1586, 'UNIVERSIDADE DO VALE DO SAPUCAI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1292, 1587, 'FACULDADES INTEGRADAS DE TANGARA DA SERRA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1293, 1588, 'FACULDADE PITAGORAS DE TURISMO E HOTELARIA DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1294, 1589, 'FACULDADE DE CASCAVEL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1295, 1590, 'FACULDADE ESTACIO DE SAO LUIS', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1296, 1591, 'FACULDADE SEAMA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1297, 1592, 'FACULDADE DE ODONTOLOGIA DE MANAUS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1298, 1593, 'FACULDADE DE PEDAGOGIA DE EUNAPOLIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1299, 1594, 'FACULDADE DE LETRAS DA INSTITUICAO DE ENSINO SUPERIOR DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1300, 1595, 'FACULDADE DE LETRAS UNIAO DE ENSINO SUPERIOR CERTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1301, 1596, 'FACULDADE DE CIENCIAS E EDUCACAO DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1302, 1597, 'FACULDADE SANTA FE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1303, 1598, 'FACULDADE POLITECNICA DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1304, 1599, 'INSTITUTO DE ENSINO SUPERIOR PRESIDENTE TANCREDO DE ALMEIDA NEVES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1305, 1600, 'INSTITUTO DE CIENCIAS DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1306, 1601, 'FACULDADE CIDADE DE COROMANDEL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1307, 1602, 'FACULDADE DE CIENCIAS GERENCIAIS DO OESTE DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1308, 1603, 'FACULDADE DE COMUNICACAO SOCIAL DO OESTE DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1309, 1604, 'FACULDADE MAGNUN DE EDUCACAO FISICA E ESPORTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1310, 1605, 'FACULDADE DE ADMINISTRACAO DE NOVA ANDRADINA FANOVA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1311, 1606, 'FACULDADES INTEGRADAS DE CASSILANDIA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1312, 1607, 'FACULDADE LUTERANA SAO MARCOS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1313, 1608, 'FACULDADE DE INFORMATICA DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1314, 1609, 'FACULDADE DOS CERRADOS PIAUIENSES', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1315, 1610, 'FACULDADE DAS ATIVIDADES EMPRESARIAIS DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1316, 1611, 'FACULDADE EDUCACIONAL DE ARAPOTI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1317, 1612, 'FACULDADE SUL BRASIL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1318, 1613, 'FACULDADE ADVENTISTA PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1320, 1615, 'INSTITUTO SUPERIOR DO LITORAL DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1321, 1616, 'FACULDADE ANGEL VIANNA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1322, 1617, 'FACULDADE DE CIENCIAS ECONOMICAS DA REGIAO CARBONIFERA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1323, 1618, 'INSTITUTO BLUMENAUENSE DE ENSINO SUPERIOR', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1324, 1619, 'FACULDADE ERNESTO RISCALI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1325, 1620, 'FACULDADE SANTA RITA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1326, 1621, 'FACULDADE NETWORK', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1327, 1622, 'FACULDADE DO INTERIOR PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1328, 1623, 'FACULDADE DE CIENCIAS AGRARIAS DE ANDRADINA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1329, 1624, 'FACULDADE MARECHAL RONDON', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1330, 1625, 'FACULDADE REUNIDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1331, 1626, 'CENTRO DE TECNOLOGIA E CIENCIA CETEC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1332, 1627, 'FACULDADE DE EDUCACAO DE MONTE ALTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1333, 1628, 'FACULDADE DE CIENCIAS HUMANAS DE AGUAI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1334, 1629, 'INSTITUTO DE ENSINO SUPERIOR AQUIDAUANENSE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1335, 1630, 'FACULDADE ITABIRANA DE DESENVOLVIMENTO DAS CIENCIAS E TECNOLOGIAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1336, 1631, 'FACULDADE PITAGORAS DE FISIOTERAPIA DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1337, 1632, 'FACULDADE PITAGORAS DE LONDRINA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1338, 1633, 'CENTRO FEDERAL DE EDUCACAO TECNOLOGICA DE CUIABA', 1, 1, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1339, 1634, 'FACULDADE COMUNITARIA DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1340, 1635, 'FACULDADE DE CIENCIAS DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1341, 1636, 'CASTELLI ESCOLA SUPERIOR DE HOTELARIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1342, 1637, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS DE MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1343, 1638, 'FACULDADE DO AMAZONAS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1344, 1639, 'FACULDADE HELIO ROCHA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1345, 1640, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1346, 1641, 'FACULDADE SOCIAL DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1347, 1642, 'FACULDADE DE TECNOLOGIA E CIENCIAS DE ITABUNA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1348, 1643, 'FACULDADE ANISIO TEIXEIRA DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1349, 1644, 'FACULDADE UNIME DE EDUCACAO E COMUNICACAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1350, 1645, 'FACULDADE DE TECNOLOGIA E CIENCIAS DE JEQUIE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1351, 1646, 'FACULDADE DE EDUCACAO CIENCIAS E LETRAS DE PARAISO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1352, 1647, 'FACULDADE DE ENSINO E CULTURA DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1353, 1648, 'FACULDADE COMPACTO DE COMUNICACAO SOCIAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1354, 1649, 'FACULDADE DE COMUNICACAO DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1355, 1650, 'FACULDADE J. SIMOES ENSINO SUPERIOR', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1356, 1651, 'FACULDADE DE EDUCACAO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1357, 1652, 'FACULDADE DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1358, 1653, 'FACULDADE DE CIENCIA E EDUCACAO DO CAPARAO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1359, 1654, 'INSTITUTO DE ENSINO SUPERIOR DE NOVA VENECIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1360, 1655, 'FACULDADE CENECISTA DE SETE LAGOAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1361, 1656, 'INSTITUTO DE ENSINO SUPERIOR DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1362, 1657, 'FACULDADE EDUCACIONAL DE DOIS VIZINHOS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1363, 1658, 'FACULDADE INTEGRADA DA GRANDE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1364, 1659, 'FACULDADE ESTACIO DE SA DE OURINHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1365, 1660, 'FACULDADE DE CIENCIAS SOCIAIS E TECNOLOGICAS FACITEC', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1366, 1661, 'FACULDADE PROJECAO DE SOBRADINHO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1367, 1662, 'FACULDADE COMUNITARIA DE ADMINISTRACAO E EDUCACAO DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1368, 1663, 'FACULDADE ARAGUAIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1369, 1664, 'FACULDADE DA SAUDE E ECOLOGIA HUMANA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1370, 1665, 'FACULDADE KENNEDY', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1371, 1666, 'FACULDADE NOVOS HORIZONTES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1372, 1667, 'FACULDADE INTERNACIONAL DE CIENCIAS EMPRESARIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1373, 1668, 'FACULDADE DE NEGOCIOS DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1374, 1669, 'INSTITUTO METROPOLITANO DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1375, 1670, 'FACULDADE ASA DE BRUMADINHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1376, 1671, 'FACULDADE DE ENSINO UNIFICADO DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1377, 1672, 'INSTITUTO ESPERANCA DE ENSINO SUPERIOR', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1378, 1673, 'FACULDADE DE AGRONOMIA DE POMBAL', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1379, 1674, 'INSTITUTO SALESIANO DE FILOSOFIA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1380, 1675, 'FACULDADE METROPOLITANA DA GRANDE RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1381, 1676, 'FACULDADE SAO MIGUEL', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1382, 1677, 'FACULDADE DE ENSINO SUPERIOR DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1383, 1678, 'FACULDADE DE CIENCIAS DE WENCESLAU BRAZ', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1384, 1679, 'FACULDADE DE CAMPINA GRANDE DO SUL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1385, 1680, 'FACULDADE DE CIENCIAS E TECNOLOGIA MATER CHRISTI', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1386, 1681, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS IBMEC', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1387, 1682, 'FACULDADE SALESIANA MARIA AUXILIADORA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1388, 1683, 'FACULDADE PIAUIENSE', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1389, 1684, 'FACULDADE DE RORAIMA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1391, 1686, 'FACULDADE BARDDAL DE ARTES APLICADAS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1392, 1687, 'FACULDADE IDEPE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1393, 1688, 'FACULDADE SENAC DE EDUCACAO EM SAUDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1394, 1689, 'FACULDADE SANTA IZILDINHA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1395, 1690, 'FACULDADE DE SAO VICENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1396, 1691, 'FACULDADE PRAXIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1397, 1692, 'ESCOLA SUPERIOR DE TECNOLOGIA E EDUCACAO DE PORTO FERREIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1398, 1693, 'FACULDADE ITANHAEM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1399, 1694, 'ESCOLA SUPERIOR DE CRICIUMA ESUCRI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1400, 1695, 'FACULDADE DE EDUCACAO DE BOM DESPACHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1401, 1696, 'FACULDADE CENTRAL DE CRISTALINA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1402, 1697, 'FACULDADE ESCRITOR OSMAN DA COSTA LINS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1403, 1698, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DO CESCARELI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1404, 1699, 'FACULDADE DE EDUCACAO DE JARU', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1405, 1700, 'FACULDADE PROMOVE DE SETE LAGOAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1406, 1701, 'FACULDADE MACHADO DE ASSIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1407, 1702, 'ESTACIO ATUAL FACULDADE ESTACIO DA AMAZONIA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1408, 1703, 'INSTITUTO DE ENSINO SUPERIOR DE RIO VERDE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1409, 1704, 'FACULDADE DE ADMINISTRACAO DO ALTO VALE DO RIO TUBARAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1410, 1705, 'FACULDADE DE EDUCACAO DO ALTO VALE DO RIO TUBARAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1411, 1706, 'FACULDADE DE INFORMATICA DO RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1412, 1707, 'FACULDADE DE CIENCIAS CONTABEIS DE RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1413, 1708, 'INSTITUTO PERNAMBUCANO DE ENSINO SUPERIOR', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1414, 1709, 'FACULDADE INTEGRADA DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1415, 1710, 'FACULDADE DE NEGOCIOS E TECNOLOGIAS DA INFORMACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1416, 1711, 'FACULDADE DE PRESIDENTE PRUDENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1417, 1712, 'FACULDADE DE CIENCIAS E TECNOLOGIA DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1418, 1713, 'FACULDADE DE TECNOLOGIA DE SAO VICENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1419, 1714, 'ESCOLA SUPERIOR DE GESTAO COMERCIAL E MARKETING', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1420, 1715, 'FACULDADE DO SUL DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1421, 1716, 'FACULDADE UNIAO DAS AMERICAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1422, 1717, 'FACULDADE DE IMPERATRIZ', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1423, 1718, 'FACULDADE NOBRE DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1424, 1719, 'FACULDADE DE ADMINISTRACAO DE CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1425, 1720, 'FACULDADE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1426, 1721, 'FACULDADE DE VICOSA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1427, 1722, 'FACULDADE DE PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1428, 1723, 'ESCOLA SUPERIOR DE ADMINISTRACAO E GESTAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1429, 1724, 'FACULDADE DE GUARARAPES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1430, 1725, 'FACULDADE XV DE AGOSTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1431, 1726, 'FACULDADE SANTA AMELIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1432, 1727, 'FACULDADE DE CARIACICA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1433, 1728, 'FACULDADE INTERAMERICANA DE PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1434, 1729, 'FACULDADE DE ODONTOLOGIA DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1435, 1730, 'FACULDADE NORTE CAPIXABA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1436, 1731, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1437, 1732, 'FACULDADE GENNARI E PEARTREE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1438, 1733, 'FACULDADE DE ENSINO SUPERIOR DE MARECHAL CANDIDO RONDON', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1439, 1734, 'FACULDADE INTEGRAL DIFERENCIAL', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1440, 1735, 'FACULDADE DE CIENCIAS APLICADAS DOUTOR LEAO SAMPAIO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1441, 1736, 'CENTRO UNIVERSITARIO LA SALLE DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1442, 1737, 'FACULDADE DE INFORMATICA DE TAQUARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1443, 1738, 'INSTITUTO LUTERANO DE ENSINO SUPERIOR DE PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1444, 1739, 'IMP DE ENSINO SUPERIOR IMP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1445, 1740, 'FACULDADE DE TECNOLOGIA RADIAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1446, 1741, 'FACULDADE DE TECNOLOGIA INTERAMERICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1447, 1742, 'FACULDADE DE TECNOLOGIA CARLOS DRUMMOND DE ANDRADE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1596, 1891, 'FACULDADE SARTRE COC', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1448, 1743, 'FACULDADE DE TECNOLOGIA OSWALDO CRUZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1449, 1744, 'FACULDADE DE TECNOLOGIA OPET', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1450, 1745, 'FACULDADE DE TECNOLOGIA ALVARES DE AZEVEDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1451, 1746, 'FACULDADE DE TECNOLOGIA DAS AMERICAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1452, 1747, 'FACULDADE DE TECNOLOGIA FLAMINGO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1453, 1748, 'FACULDADE DE TECNOLOGIA MARIO DE ANDRADE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1454, 1749, 'FACULDADE LUSOBRASILEIRA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1455, 1750, 'UNIDADE DE ENSINO SUPERIOR EXPOENTE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1456, 1751, 'FACULDADE DE DESIGN GRAFICO', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1457, 1752, 'FACULDADE AUTONOMA DE DIREITO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1458, 1753, 'FACULDADE DE ENFERMAGEM NOVA ESPERANCA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1459, 1754, 'INSTITUTO SUPERIOR DE EDUCACAO DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1460, 1755, 'FACULDADE EQUIPE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1461, 1756, 'FACULDADE ASSOCIADA BRASIL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1462, 1757, 'ESCOLA SUPERIOR DE ADMINISTRACAO, MARKETING E COMUNICACAO DE GOIANIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1463, 1758, 'FACULDADE INDEPENDENTE DO NORDESTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1464, 1759, 'FACULDADE PADRE JOAO BAGOZZI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1465, 1760, 'FACULDADE DE PEDAGOGIA DE VITORIA DE SANTO ANTAO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1466, 1761, 'FACULDADE BRASILEIRA DE GESTAO E NEGOCIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1467, 1762, 'FACULDADE DE TECNOLOGIA E NEGOCIOS CARLOS DRUMMOND DE ANDRADE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1468, 1763, 'FACULDADE DE TECNOLOGIA SENAI CHAPECO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1469, 1764, 'FACULDADE DE EDUCACAO REGIONAL SERRANA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1470, 1765, 'FACULDADE DE JOSE BONIFACIO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1471, 1766, 'FACULDADE ESPIRITO SANTENSE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1472, 1767, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1473, 1768, 'FACULDADE REGIONAL SERRANA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1474, 1769, 'FACULDADE DE TURISMO DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1475, 1770, 'FACULDADE DE CIENCIAS EXATAS E TECNOLOGICAS DA INSTITUICAO DE ENSINO SUPERIOR DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1476, 1771, 'FACULDADE SANTA MARIA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1477, 1772, 'FACULDADE NORDESTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1478, 1773, 'FACULDADE DE ITAPIRANGA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1479, 1774, 'FACULDADE EDUCACIONAL DE PONTA GROSSA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1480, 1775, 'FACULDADE DO VALE DO IPOJUCA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1481, 1776, 'FACULDADE DE TECNOLOGIA PROF. LUIZ ROSA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1482, 1777, 'FACULDADE METROPOLITANA DE GUARAMIRIM', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1483, 1778, 'FACULDADE DE EDUCACAO, CIENCIAS E LETRAS SAO JUDAS TADEU', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1485, 1780, 'FACULDADE HORIZONTINA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1486, 1781, 'FACULDADE INTESP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1487, 1782, 'FACULDADE DE ARTES, CIENCIAS E TECNOLOGIAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1488, 1783, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1489, 1784, 'FACULDADE ANHANGUERA DE SAO CAETANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1490, 1785, 'FACULDADE DE COLIDER', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1491, 1786, 'INSTITUTO MACHADENSE DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1492, 1787, 'INSTITUTO DE ENSINO SUPERIOR DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1493, 1788, 'FACULDADE DE ADMINISTRACAO E ARTES DE LIMEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1494, 1789, 'FACULDADE CATUAI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1495, 1790, 'INSTITUTO SUPERIOR DE EDUCACAO DO SUL DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1496, 1791, 'FACULDADE DE CIENCIAS EXATAS E TECNOLOGICAS DA UNIAO DE ENSINO SUPERIOR CERTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1497, 1792, 'FACULDADE DE EDUCACAO DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1498, 1793, 'FACULDADE DE CIENCIAS EXATAS E TECNOLOGICAS DE UNIAO DA VITORIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1499, 1794, 'FACULDADE DE CIENCIAS HUMANAS DE UNIAO DA VITORIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1500, 1795, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE UNIAO DA VITORIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1501, 1796, 'FACULDADE DE MATEMATICA DA INSTITUICAO DE ENSINO SUPERIOR DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1502, 1797, 'FACULDADE NORTE PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1503, 1798, 'FACULDADE EDUCACIONAL DE CORNELIO PROCOPIO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1504, 1799, 'FACULDADE BRASILIA DE TECNOLOGIA, CIENCIAS E EDUCACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1505, 1800, 'FACULDADE DE REALEZA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1506, 1801, 'FACULDADE DOM BOSCO DE UBIRATA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1507, 1802, 'FACULDADE DE CIENCIAS DA SAUDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1508, 1803, 'FACULDADE DE TECNOLOGIA E CIENCIAS DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1509, 1804, 'FACULDADE DE MAUA FAMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1510, 1805, 'FACULDADE DOS GUARARAPES', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1511, 1806, 'FACULDADE FERNAO DIAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1512, 1807, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO CEARA', 1, 1, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1513, 1808, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO ESPIRITO SANTO', 1, 1, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1514, 1809, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE PERNAMBUCO', 1, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1515, 1810, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE SAO PAULO', 1, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1516, 1811, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE GOIAS', 1, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1517, 1812, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO AMAZONAS', 1, 1, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1518, 1813, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO PARA', 1, 1, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1519, 1814, 'FACULDADE DE CIENCIAS SOCIAIS E APLICADAS DE DIAMANTINO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1520, 1815, 'FACULDADE DO INSTITUTO BRASIL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1521, 1816, 'INSTITUTO DE ENSINO SUPERIOR DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1522, 1817, 'FACULDADE ESTACIO DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1523, 1818, 'FACULDADE PITAGORAS DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1524, 1819, 'FACULDADE FARIAS BRITO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1525, 1820, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO PIAUI', 1, 1, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1526, 1821, 'FACULDADE LIONS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1527, 1822, 'FACULDADE SULAMERICANA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1528, 1823, 'INSTITUTO DE ENSINO SUPERIOR DO AMAPA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1529, 1824, 'FACULDADE DE CIENCIAS CONTABEIS DE ITABIRITO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1530, 1825, 'FACULDADE DE ESTUDOS SUPERIORES DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1532, 1827, 'FACULDADE LUTERANA DE TEOLOGIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1533, 1828, 'ESCOLA DA CIDADE FACULDADE DE ARQUITETURA E URBANISMO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1534, 1829, 'FACULDADE DE TECNOLOGIA UIRAPURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1535, 1830, 'FACULDADE ANHANGUERA DE PASSO FUNDO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1536, 1831, 'FACULDADE CENTRO PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1537, 1832, 'FACULDADE DE JABOTICABAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1538, 1833, 'FACULDADE DE ARUJA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1539, 1834, 'FACULDADE DE AGUDOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1540, 1835, 'FACULDADE INTEGRADA DE ENSINO SUPERIOR DE COLINAS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1541, 1836, 'CENTRO UNIVERSITARIO FUNDACAO DE ENSINO OCTAVIO BASTOS   FEOB', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1542, 1837, 'ESCOLA DE ESTUDOS SUPERIORES DE VICOSA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1543, 1838, 'FACULDADES INTEGRADAS RIO BRANCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1544, 1839, 'FACULDADES INTEGRADAS DE VARZEA GRANDE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1545, 1840, 'FACULDADE CASTELO BRANCO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1546, 1841, 'FACULDADES INTEGRADAS ANTONIO EUFRASIO DE TOLEDO DE PRESIDENTE PRUDENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1547, 1842, 'FACULDADES INTEGRADAS MACHADO DE ASSIS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1548, 1843, 'FACULDADE DE ADMINISTRACAO DE CAMPO BELO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1549, 1844, 'FACULDADES INTEGRADAS STELLA MARIS DE ANDRADINA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1550, 1845, 'FEFISA FACULDADES INTEGRADAS DE SANTO ANDRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1551, 1846, 'CENTRO UNIVERSITARIO DE LINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1552, 1847, 'FACULDADE ATENAS MARANHENSE DE IMPERATRIZ', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1553, 1848, 'FACULDADE CENECISTA DE SANTA TEREZINHA DE ITAIPU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1554, 1849, 'FACULDADE DE DIREITO DE MOGI MIRIM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1555, 1850, 'FACULDADE ALVORADA DE TECNOLOGIA E EDUCACAO DE MARINGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1556, 1851, 'ESCOLA BRASILEIRA DE ADMINISTRACAO PUBLICA E DE EMPRESAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1557, 1852, 'FACULDADE SABERES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1558, 1853, 'FACULDADE DE TECNOLOGIA IBTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1559, 1854, 'FACULDADES INTEGRADAS CLARETIANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1560, 1855, 'CENTRO UNIVERSITARIO CATOLICO DO SUDOESTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1561, 1856, 'FACULDADE DO NORTE NOVO DE APUCARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1562, 1857, 'FACULDADE DEHONIANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1563, 1858, 'FACULDADE INTEGRADA EUCLIDES FERNANDES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1564, 1859, 'INSTITUTO SUPERIOR DE EDUCACAO UIRAPURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1565, 1860, 'FACULDADE DE CIENCIAS GERENCIAIS PADRE ARNALDO JANSSEN', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1566, 1861, 'FACULDADE DE DIREITO DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1567, 1862, 'FACULDADE DA REGIAO SERRANA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1568, 1863, 'FACULDADE DE MANTENA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1569, 1864, 'FACULDADE DE ADMINISTRACAO DA ASSOCIACAO BRASILIENSE DE EDUCACAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1570, 1865, 'INSTITUTO SUPERIOR DE EDUCACAO ALVORADA PLUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1571, 1866, 'FACULDADE DE CIENCIAS EMPRESARIAIS E ESTUDOS COSTEIROS DE NATAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1572, 1867, 'FACULDADE DE CIENCIAS GERENCIAIS DE SANTOS DUMONT', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1573, 1868, 'INSTITUTO SUPERIOR DE EDUCACAO DE SANTOS DUMONT', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1574, 1869, 'CENTRO UNIVERSITARIO DE ITAJUBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1575, 1870, 'FACULDADES INTEGRADAS REGIONAIS DE AVARE', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1576, 1871, 'FACULDADE DE MEDICINA DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1577, 1872, 'FACULDADES INTEGRADAS SANTA CRUZ DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1578, 1873, 'FACULDADE MERCURIO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1579, 1874, 'FACULDADE DE TECNOLOGIA DE OURINHOS', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1580, 1875, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE IBITINGA', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1581, 1876, 'FACULDADE MUNICIPAL PROFESSOR FRANCO MONTORO DE MOGI GUACU', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1582, 1877, 'FACULDADE ATUAL', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1583, 1878, 'CENTRO UNIVERSITARIO DA FUNDACAO EDUCACIONAL INACIANA PE SABOIA DE MEDEIROS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1584, 1879, 'FACULDADE EDUCACIONAL DE ARAUCARIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1585, 1880, 'FACULDADE CASA DO ESTUDANTE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1586, 1881, 'FACULDADE DA ESCADA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1587, 1882, 'FACULDADE DE ASSUNTOS ACADEMICOS E CIENTIFICOS MONSENHOR EDISSON VIEIRA LICIO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1588, 1883, 'FACULDADE DE CIENCIAS AGRARIAS E DA SAUDE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1589, 1884, 'FACULDADE RANCHARIENSE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1590, 1885, 'UNIDADE DE ENSINO SUPERIOR DOM BOSCO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1591, 1886, 'FACULDADE DE MONTE ALTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1592, 1887, 'FACULDADE DE DIREITO DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1593, 1888, 'FACULDADE DE SAUDE TECSOMA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1594, 1889, 'FACULDADE HOYLER DE LETRAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1595, 1890, 'FACULDADE AVILA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1597, 1892, 'FACULDADE ENIAC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1598, 1893, 'FACULDADE REGIONAL DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1599, 1894, 'FACULDADE EUROPEIA DE ADMINISTRACAO E MARKETING', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1600, 1895, 'CENTRO UNIVERSITARIO CHRISTUS', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1601, 1896, 'FACULDADE DE TURISMO DE NOVA ANDRADINA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1602, 1897, 'FACULDADE DE LETRAS DE NOVA ANDRADINA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1603, 1898, 'FACULDADE DO LITORAL SUL PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1604, 1899, 'FACULDADE DO NOROESTE PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1605, 1900, 'FACULDADE ANCHIETA DE ENSINO SUPERIOR DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1606, 1901, 'FACULDADE CATOLICA DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1608, 1903, 'FACULDADE CRISTO REI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1609, 1904, 'FACULDADE SAO CAMILO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1610, 1905, 'FACULDADE SANTA ADAME', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1611, 1906, 'INSTITUTO DE ENSINO SUPERIOR MATERDEI', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1612, 1907, 'FACULDADE EDUCACIONAL DE COLOMBO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1613, 1908, 'ESCOLA DE ENSINO SUPERIOR FABRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1614, 1909, 'FACULDADE PEREIRA DE FREITAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1615, 1910, 'FACULDADE MAURICIO DE NASSAU DE LAURO FREITAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1616, 1911, 'FACULDADE CENTROOESTE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1617, 1912, 'INSTITUTO SUPERIOR DE EDUCACAO JAPI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1618, 1913, 'FACULDADE DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1619, 1914, 'FACULDADE PITAGORAS DE ENFERMAGEM DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1620, 1915, 'FACULDADE DE EDUCACAO SILVA SERPA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1621, 1916, 'INSTITUTO SUPERIOR DE EDUCACAO PITAGORAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1622, 1917, 'FACULDADE DE CIENCIAS BIOMEDICAS DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1623, 1918, 'FACULDADE CAPIVARI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1624, 1919, 'FACULDADE DE CIENCIAS EXATAS E TECNOLOGICAS SANTO AGOSTINHO FACET', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1625, 1920, 'FACULDADE DE FARMACIA DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1626, 1921, 'FACULDADE DE SAO BENTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1627, 1922, 'ESCOLA SUPERIOR DE FISIOTERAPIA ESUFI', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1628, 1923, 'FACULDADE DE DIREITO PADRE ARNALDO JANSSEN', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1629, 1924, 'FACULDADE DO NORTE PIONEIRO DE JACAREZINHO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1630, 1925, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS SANTO AGOSTINHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1631, 1926, 'FACULDADE DE ADMINISTRACAO DE CATAGUASES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1632, 1927, 'FACULDADES INTEGRADAS DO VALE DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1633, 1928, 'FACULDADE CENECISTA ILHA DO GOVERNADOR', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1634, 1929, 'FACULDADE DE CIENCIAS CONTABEIS FACICONT', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1635, 1930, 'INSTITUTO SUPERIOR DE EDUCACAO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1636, 1931, 'INSTITUTO DE ENSINO SUPERIOR FRANCISCANO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1637, 1932, 'FACULDADE PALOTINA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1638, 1933, 'FACULDADE BIRIGUI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1639, 1934, 'FACULDADE SINOP', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1640, 1935, 'FACULDADE SAO PAULO DE SANTOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1641, 1936, 'FACULDADE LA SALLE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1642, 1937, 'FACULDADE EVANGELICA DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1643, 1938, 'FACULDADE GLOBAL DE UMUARAMA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1644, 1939, 'INSTITUTO DE ENSINO SUPERIOR DE LONDRINA INESUL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1645, 1940, 'FACULDADE DE NOVA SERRANA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1646, 1941, 'FACULDADE CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1647, 1942, 'FACULDADE DE COMUNICACAO SOCIAL DE FLORIANOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1648, 1943, 'FACULDADE SERRANA DE ENSINO SUPERIOR', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1649, 1944, 'FACULDADE DE TECNOLOGIA IBRATEC', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1650, 1945, 'FACULDADE DE SORRISO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1651, 1946, 'FACULDADE LEGALE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1652, 1947, 'FACULDADE DE ENGENHARIA DE TAQUARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1653, 1948, 'FACULDADE DE ENSINO SUPERIOR DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1654, 1949, 'FACULDADE DE PAULINIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1655, 1950, 'FACULDADE DE ORLANDIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1656, 1951, 'INSTITUTO DE EDUCACAO E ENSINO SUPERIOR DE SAMAMBAIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1657, 1952, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS APLICADAS DO ARAGUAIA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1658, 1953, 'FACULDADE DE CIENCIAS BIOLOGICAS E DA SAUDE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1659, 1954, 'FACULDADE DE ECONOMIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1660, 1955, 'FACULDADE DE CIENCIAS HUMANAS DE LAGES', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1661, 1956, 'INSTITUTO BATISTA DE ENSINO SUPERIOR DE ALAGOAS', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1662, 1957, 'FACULDADE DE TECNOLOGIA SENAI JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1663, 1958, 'FACULDADE DE TECNOLOGIA SENAI BLUMENAU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1664, 1959, 'FACULDADE DE CIENCIAS JURIDICAS DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1665, 1960, 'FACULDADE DE MEDICINA DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1666, 1961, 'INSTITUTO TECNOLOGICO E DAS CIENCIAS SOCIAIS APLICADAS E DA SAUDE DO CENTRO EDUC. N. SRª AUXILIADORA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1667, 1962, 'INSTITUTO SUPERIOR DE EDUCACAO DO CENTRO EDUCACIONAL NOSSA SENHORA AUXILIADORA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1668, 1963, 'FACULDADE DE FISIOTERAPIA DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1669, 1964, 'FACULDADE DE TECNOLOGIA EM HOTELARIA, GASTRONOMIA E TURISMO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1670, 1965, 'FACULDADE DE TECNOLOGIA DE ALAGOAS', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1671, 1966, 'FACULDADE ALBERT EINSTEIN', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1673, 1968, 'FACULDADE ATLANTICO', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1674, 1969, 'FACULDADE DOS IMIGRANTES FAI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1675, 1970, 'FACULDADE DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1676, 1971, 'FACULDADE DE TECNOLOGIA MORUMBI SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1677, 1972, 'FACULDADE TIJUCUSSU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1678, 1973, 'INSTITUTO SUPERIOR DE EDUCACAO ORIGENES LESSA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1679, 1974, 'INSTITUTO SUPERIOR DE EDUCACAO DE CAXIAS', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1680, 1975, 'FACULDADE DE CIENCIAS AGRARIAS DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1681, 1976, 'INSTITUTO SUPERIOR DE EDUCACAO DE LINHARES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1682, 1977, 'CENTRO DE ESTUDOS SUPERIORES APRENDIZ', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1683, 1978, 'FACULDADE METROPOLITANA DA GRANDE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1684, 1979, 'INSTITUTO SUPERIOR DE EDUCACAO CENECISTA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1685, 1980, 'FACULDADE SINERGIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1686, 1981, 'FACULDADE MILLENNIUM', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1687, 1982, 'FACULDADE DE COMUNICACAO SOCIAL DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1688, 1983, 'FACULDADE DE CIENCIAS E DA SAUDE DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1689, 1984, 'FACULDADE DE CIENCIAS GERENCIAIS DE MANHUACU', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1690, 1985, 'FACULDADE COMUNITARIA DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1691, 1986, 'FACULDADE ESTACIO DE SA DE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1692, 1987, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DEPUTADO JOSE LAVIOLA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1693, 1988, 'FACULDADE AVANTIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1694, 1989, 'INSTITUTO SUPERIOR DE EDUCACAO AVANTIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1695, 1990, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1696, 1991, 'FACULDADE JOAO PAULO PRIMEIRO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1697, 1992, 'INSTITUTO DE ENSINO SUPERIOR DE PIEDADE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1698, 1993, 'FACULDADE DE CIENCIAS HUMANAS E DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1699, 1994, 'INSTITUTO DE ENSINO SUPERIOR DE DOURADOS', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1700, 1995, 'FACULDADE DE MEDICINA NOVA ESPERANCA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1701, 1996, 'INSTITUTO CUIABA DE ENSINO E CULTURA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1702, 1997, 'INSTITUTO DE ENSINO SUPERIOR DE ARIPUANA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1703, 1998, 'INSTITUTO SUPERIOR DE EDUCACAO ELVIRA DAYRELL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1704, 1999, 'JOHN KNOX', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1705, 2000, 'FACULDADE TATUAPE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1706, 2001, 'SEMINARIO ADVENTISTA LATINOAMERICANO DE TEOLOGIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1707, 2002, 'INSTITUTO SUPERIOR DE EDUCACAO DIVINO SALVADOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1708, 2003, 'FACULADE TEOLOGICA SINAL', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1709, 2004, 'FACULDADE DE DIREITO PRESIDENTE CASTELO BRANCO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1710, 2005, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE SINOP', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1711, 2006, 'INSTITUTO SUPERIOR DE EDUCACAO DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1712, 2007, 'FACULDADE DE CIENCIAS EXATAS E TECNOLOGICAS DO BRASIL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1713, 2008, 'INSTITUTO SUPERIOR DE EDUCACAO DE SAO GOTARDO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1714, 2009, 'FACULDADE DE TAQUARITINGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1715, 2010, 'FACULDADE ESAMC SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1716, 2011, 'INSTITUTO NACIONAL DE EDUCACAO DE PORTO SEGURO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1717, 2012, 'INSTITUTO SUPERIOR DE EDUCACAO DE PESQUEIRA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1718, 2013, 'INSTITUTO SUPERIOR DE EDUCACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1719, 2014, 'FACULDADE SETELAGOANA DE CIENCIAS GERENCIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1720, 2015, 'INSTITUTO SANTO TOMAS DE AQUINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1721, 2016, 'LOGOS FACULDADE', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1722, 2017, 'FACULDADES DE ALTA FLORESTA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1723, 2018, 'FACULDADE EVOLUCAO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1724, 2019, 'INSTITUTO SUPERIOR DE EDUCACAO DE SALGUEIRO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1725, 2020, 'INSTITUTO DE EDUCACAO SUPERIOR EUROBRAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1726, 2021, 'FACULDADE JK   UNIDADE II   GAMA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1727, 2022, 'FACULDADE DE ROLIM DE MOURA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1728, 2023, 'FACULDADE DE GUANAMBI', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1729, 2024, 'INSTITUTO SUPERIOR DE EDUCACAO DAS CLARETIANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1730, 2025, 'INSTITUTO SUPERIOR DE EDUCACAO CARLI GIOVANNI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1731, 2026, 'INSTITUTO SUPERIOR DE EDUCACAO BRASIL', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1732, 2027, 'FACULDADE DE CAMPINA GRANDE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1733, 2028, 'FALCUDADE DE CIENCIAS ECONOMICAS CONTABEIS E ADMINISTRATIVAS DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1734, 2029, 'INSTITUTO SUPERIOR DE EDUCACAO DE MARECHAL CANDIDO RONDON', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1735, 2030, 'INSTITUTO SUPERIOR DE EDUCACAO CAMPO LIMPO PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1736, 2031, 'FACULDADE DE EDUCACAO DE PRESIDENTE MEDICI', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1737, 2032, 'FACULDADE DE PEDAGOGIA E FORMACAO DE NORMALISTAS DE ARAGUAINA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1738, 2033, 'INSTITUTO SUPERIOR DE EDUCACAO DE FLORESTA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1739, 2034, 'FACULDADE DE CIENCIAS CONTABEIS DE ARAGUAINA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1740, 2035, 'UNIAO LATINOAMERICADA DE TECNOLOGIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1741, 2036, 'FACULDADE ESTACIO DO PARA ESTACIO FAP', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1742, 2037, 'FACULDADE UNIME DE CIENCIAS EXATAS E TECNOLOGICAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1743, 2038, 'INSTITUTO DE EDUCACAO SUPERIOR VALE DO MEARIM', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1744, 2039, 'FACULDADE CIDADE LUZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1745, 2040, 'FACULDADE DO FUTURO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1746, 2041, 'FACULDADE SUDAMERICA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1747, 2042, 'FACULDADE FIGUEIREDO COSTA FIC', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1748, 2043, 'FACULDADE VALE DO SALGADO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1749, 2044, 'INSTITUTO SUPERIOR DE EDUCACAO VALE DO SALGADO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1750, 2045, 'FACULDADE AMADEUS', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1751, 2046, 'INSTITUTO SUPERIOR DE EDUCACAO AMADEUS', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1752, 2047, 'FACULDADE DE PSICOLOGIA DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1753, 2048, 'FACULDADE DE CIENCIAS E TECNOLOGIA DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1754, 2049, 'INSTITUTO DE ESTUDOS SUPERIORES DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1755, 2050, 'ESCOLA SUPERIOR DE GESTAO E CIENCIAS DA SAUDE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1756, 2051, 'FACULDADE INTERFUTURA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1757, 2052, 'FACULDADE DE DIREITO DE LAGES', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1758, 2053, 'FACULDADE PARA O DESENVOLVIMENTO DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1759, 2054, 'FACULDADE DE EDUCACAO DE NOVA ANDRADINA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1760, 2055, 'FACULDADE ARAUCARIA DO SUDOESTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1761, 2056, 'FACULDADE DA ALTA PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1762, 2057, 'FACULDADE DE MOGI GUACU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1763, 2058, 'FACULDADE METROPOLITANA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1764, 2059, 'FACULDADE DE EDUCACAO E CIENCIAS DE TAGUATINGA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1765, 2060, 'FACULDADE PADRE SEVERIANO LTDA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1766, 2061, 'FACULDADE DE FORMACAO DE PROFESSORES DE ARAPIRACA', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1767, 2062, 'INSTITUTO SUPERIOR DE EDUCACAO CENECISTA DE VARGINHA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1768, 2063, 'INSTITUTO NOSSA SENHORA APARECIDA DE EDUCACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1769, 2064, 'FACULDADE METROPOLITANA DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1770, 2065, 'FACULDADE DE FILOSOFIA E TEOLOGIA DE ALAGOAS', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1771, 2066, 'FACULDADE LEONARDO DA VINCI', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1772, 2067, 'FACULDADE DE CIENCIAS EMPRESARIAIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1773, 2068, 'FACULDADE DE CASTILHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1774, 2069, 'FACULDADE DE TEOLOGIA E CIENCIAS HUMANAS', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1775, 2070, 'FACULDADE DE CIENCIAS SOCIAIS AMORIL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1776, 2071, 'FACULDADE TEOLOGICA BATISTA DO BRASIL', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1777, 2072, 'FACULDADE DE DESENVOLVIMENTO SUSTENTAVEL DE CRUZEIRO DO SUL', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1778, 2073, 'INSTITUTO SUPERIOR DE EDUCACAO PADRAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1779, 2074, 'INSTITUTO EDUCACIONAL SAO JOAO DA ESOCIA DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1780, 2075, 'INSTITUTO DE ENSINO SUPERIOR DE ALAGOAS', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1781, 2076, 'FACULDADE REGIONAL DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1782, 2077, 'FACULDADE ANGLOAMERICANO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1783, 2078, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1784, 2079, 'FACULDADE DE ITAITUBA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1785, 2080, 'FACULDADE UNIVERSICA DE FILOSOFIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1786, 2081, 'FACULDADE DE CIENCIAS GERENCIAS DE PEDREIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1787, 2082, 'FACULDADE DE CIENCIAS MEDICAS DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1788, 2083, 'FACULDADE DE IBITINGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1789, 2084, 'FACULDADE CENECISTA DE NOVA PETROPOLIS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1790, 2085, 'INSTITUTO BAIANO DE ENSINO SUPERIOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1791, 2086, 'INSTITUTO DE ENSINO SUPERIOR DE FOZ DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1792, 2087, 'FACULDADE MARECHAL RONDON', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1793, 2088, 'INSTITUTO SUPERIOR DE EDUCACAO SANTO AGOSTINHO DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1794, 2089, 'FACULDADE CENECISTA DE MOSSORO', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1795, 2090, 'FACULDADE DE TURISMO DE CONGONHAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1796, 2091, 'INSTITUTO SUPERIOR DE EDUCACAO PRO SABER', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1797, 2092, 'FACULDADE DOM PEDRO II', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1798, 2093, 'FACULDADE GREGOR MENDEL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1799, 2094, 'FACULDADE DE ENSINO A', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1800, 2095, 'INSITUTO SUPERIOR DE JACAREI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1801, 2096, 'FACULDADE COMUNITARIA DE MANHUACU', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1802, 2097, 'ESCOLA SUPERIOR DE GUARARAPES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1803, 2098, 'FACULDADE KURIOS', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1804, 2099, 'INSTITUTO DE ENSINO PESQUISA E EXTENSAO DO BRASIL OESTE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1805, 2100, 'FACULDADE DE LETRAS DO SERRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1806, 2101, 'FACULDADE ASCENSAO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1807, 2102, 'FACULDADE DE AURIFLAMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1808, 2103, 'FACULDADE E CENTRO DE ENSINO DE LONDRINA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1809, 2104, 'FACULDADE DE TEOLOGIA DE HOKEMAH', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1810, 2105, 'FACULDADE ADVENTISTA DE INFORMATICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1811, 2106, 'FACULDADE DE VICOSA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1812, 2107, 'FACULDADE IBTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1813, 2108, 'FACULDADE DE DIREITO DA SEDES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1814, 2109, 'FACULDADE JOAO PESSOA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1815, 2110, 'FACULDADE DOM CESAR', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1816, 2111, 'INSTITUTO SUPERIOR DE TEOLOGIA APLICADA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1817, 2112, 'FACULDADE METODISTA DE BIRIGUI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1818, 2113, 'FACULDADE DOM BOSCO DE PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1819, 2114, 'FACULDADE DE TEOLOGIA FILADELFIA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1820, 2115, 'FACULDADE JOAO PAULO II', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1821, 2116, 'FACULDADE IGUAPENSE SANTO AUGUSTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1822, 2117, 'FACULDADE DE CIENCIA E TECNOLOGIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1823, 2118, 'INSTITUTO DE EDUCACAO SUPERIOR GUAIANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1824, 2119, 'FACULDADE GUARARAPES', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1825, 2120, 'INSTITUTO DE FILOSOFIA E DE TEOLOGIA PAULO VI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1826, 2121, 'FACULDADE DE INFORMATICA DE PEDREIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1827, 2122, 'FACULDADE ESTACIO DE SERGIPE ESTACIO FASE', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1828, 2123, 'FACULDADE MAX PLANCK', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1829, 2124, 'FACULDADE CALAFIORI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1830, 2125, 'FACULDADE DE EDUCACAO DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1831, 2126, 'ESCOLA DE DIREITO DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1832, 2127, 'FACULDADE BATISTA DE EDUCACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1833, 2128, 'ESCOLA DE DIREITO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1834, 2129, 'ESCOLA DE ECONOMIA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1835, 2130, 'FACULDADE EVANGELICA DE TEOLOGIA DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1836, 2131, 'FACULDADE FAPAN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1837, 2132, 'FACULDADE BARAO DO RIO BRANCO', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1838, 2133, 'FACULDADE DE CIENCIAS, EDUCACAO E TEOLOGIA DO NORTE DO BRASIL', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1839, 2134, 'FACULDADE DA IGREJA MINISTERIO FAMA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1840, 2135, 'FACULDADE CATOLICA RAINHA DO SERTAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1841, 2136, 'INSTITUTO DE JUINA DE ENSINO SUPERIOR', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1842, 2137, 'FACULDADE SAO MARCOS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1843, 2138, 'INSTITUTO SUPERIOR DE EDUCACAO DIVINO SALVADOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1844, 2139, 'FACULDADE DE INFORMATICA DE PARANAIBA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1845, 2140, 'INSTITUTO SUPERIOR DE EDUCACAO NOSSA SENHORA DE LOURDES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1846, 2141, 'FACULDADE TEOLOGICA BATISTA DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1847, 2142, 'FACULDADE MULTIEDUCATIVA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1848, 2143, 'INSTITUTO SUPERIOR DE EDUCACAO DE DUQUE DE CAXIAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1849, 2144, 'FACULDADE ECOPORANGA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1850, 2145, 'FACULDADE INFORIUM DE TECNOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1851, 2146, 'FACULDADE DO ACRE', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1852, 2147, 'FACULDADE METROPOLITANA DE MANAUS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1853, 2148, 'FACULDADE DE PALMAS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1854, 2149, 'FACULDADE MATO GROSSO DO SUL', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1855, 2150, 'FACULDADE DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1856, 2151, 'INSTITUTO SUPERIOR DE EDUCACAO BERLAAR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1857, 2152, 'FACULDADE DE ADMINISTRACAO E TECNOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1858, 2153, 'FACULDADE DE DIREITO DE MACAE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1859, 2154, 'INSTITUTO SUPERIOR DE CIENCIAS HUMANAS E SOCIAIS ANISIO TEIXEIRA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1860, 2155, 'FACULDADE DE CIENCIAS SOCIAIS E DA SAUDE DE CATAGUASES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1861, 2156, 'FACULDADE SAO TOMAS DE AQUINO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1862, 2157, 'INSTITUTO SUPERIOR DE EDUCACAO SANT´ANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1863, 2158, 'FACULDADE SANTA MARIA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1864, 2160, 'FACULDADE SANTANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1865, 2161, 'FACULDADE TEOLOGICA DE VALENCA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1866, 2162, 'INSTITUTO METROPOLITANO DE ENSINO SUPERIOR DE VESPASIANO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1867, 2163, 'INSTITUTO SUPERIOR DE EDUCACAO EUGENIO GOMES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1868, 2164, 'FACULDADE PANAMERICANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1869, 2165, 'FACULDADE FOZ DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1870, 2166, 'INSTITUTO DE EDUCACAO E CULTURA INTEGRADA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1871, 2167, 'FACULDADE DE EDUCACAO E CIENCIAS GERENCIAIS DE SALTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1872, 2168, 'FACULDADE CAMPO GRANDE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1873, 2169, 'FACULDADE CENECISTA DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1874, 2170, 'FACULDADE DE MATEMATICA JESUS MARIA JOSE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1875, 2171, 'INSTITUTO BELO HORIZONTE DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1876, 2172, 'FACULDADE CENECISTA DE TRES RIOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1877, 2173, 'FACULDADE GUAIANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1878, 2174, 'FACULDADE DE SANTA CATARINA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1879, 2175, 'FACULDADE METROPOLITANA DE BLUMENAU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1880, 2176, 'FACULDADE DE CIENCIAS BIOMEDICAS DE COLATINA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1881, 2177, 'INSTITUTO PAULISTA DE ENSINO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1882, 2178, 'FACULDADE CENECISTA DE MACAE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1883, 2179, 'FACULDADE DE TURISMO DO ESTADO DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1884, 2180, 'RATIO FACULDADE TEOLOGICA E FILOSOFICA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1885, 2181, 'INSTITUTO SUPERIOR DE EDUCACAO CENECISTA DE CAPIVARI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1886, 2182, 'FACULDADE BATISTA IDA NELSON', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1887, 2183, 'CENTRO UNIVERSITARIO FUNDACAO SANTO ANDRE', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1888, 2184, 'FACULDADE CENECISTA NOSSA SENHORA DOS ANJOS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1889, 2185, 'FACULDADE DE NUTRICAO DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1890, 2186, 'FACULDADE SALESIANA DOM BOSCO', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1891, 2187, 'FACULDADE DE CIENCIAS GERENCIAIS DE VALINHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1892, 2188, 'INSTITUTO SUPERIOR DE EDUCACAO NOSSA SENHORA DE SION', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1893, 2189, 'FACULDADE DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1894, 2190, 'FACULDADE JULIO CAMPOS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1895, 2191, 'FACULDADE ANHANGUERA DE PELOTAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1896, 2192, 'INSTITUTO SUPERIOR DE EDUCACAO IVOTI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1897, 2193, 'INSTITUTO SUPERIOR DE EDUCACAO IDEAL', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1898, 2194, 'FACULDADE ANHANGUERA DO RIO GRANDE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1899, 2195, 'FACULDADE DE CIENCIAS GERENCIAIS DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1900, 2196, 'FACULDADE DE INFORMATICA E TECNOLOGIAS VARZEA GRANDENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1901, 2197, 'FACULDADE VILLAS BOAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1902, 2198, 'FACULDADE MONTEIRO LOBATO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1903, 2199, 'FACULDADE DE EDUCACAO E TEOLOGIA DO BRASIL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1904, 2200, 'FACULDADE VALE DO GORUTUBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1905, 2201, 'FACULDADE ALPHA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1906, 2202, 'INSTITUTO SUPERIOR DE EDUCACAO DE GUARATUBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1907, 2203, 'FACULDADE DE EDUCACAO ANCHIETA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1908, 2204, 'FACULDADE CATARINENSE DOM BOSCO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1909, 2205, 'FACULDADE DE TUPI PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1910, 2206, 'FACULDADE FAE SAO JOSE DOS PINHAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1911, 2207, 'FACULDADE SAO JUDAS TADEU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1912, 2208, 'FACULDADE LUIS DE CAMOES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1913, 2209, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1914, 2210, 'FACULDADE GARAVELO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1915, 2211, 'INSTITUTO SUPERIOR DE EDUCACAO CENECISTA DE FARROUPILHA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1916, 2212, 'FACULDADE UNIDADE DAS AMERICAS', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1917, 2213, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1918, 2214, 'FACULDADE DE ENGENHARIA DA TERRA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1919, 2215, 'FACULDADE DE TEOLOGIA DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1920, 2216, 'INSTITUTO SUPERIOR DE EDUCACAO DE IUNA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1921, 2217, 'FACULDADE DE CIENCIAS GERENCIAIS DE IUNA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1922, 2218, 'FACULDADE DE CIENCIAS EXATAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1923, 2219, 'FACULDADE MUNDO MODERNO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1924, 2220, 'FACULDADE COMUNITARIA DE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1925, 2221, 'FACULDADE MADEIRA MAMORE', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1926, 2222, 'FACULDADE SETE DE SETEMBRO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1927, 2223, 'FACULDADE DE CIENCIAS SOCIAIS E DA SAUDE DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1928, 2224, 'FACULDADES INTEGRADAS DE IMPERATRIZ', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1929, 2225, 'INSTITUTO SUPERIOR DE FORMACAO DE PROFESSORES', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1930, 2226, 'FACULDADE DE CIENCIAS DA SAUDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1931, 2227, 'FACULDADE DE CIENCIAS BIOLOGICAS JK', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1932, 2228, 'FACULDADE DA SAUDE HUMANA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1933, 2229, 'FACULDADE VICTOR HUGO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1934, 2230, 'FACULDADE DE ADMINISTRACAO JK', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1935, 2231, 'FACULDADE DE COMUNICACAO SOCIAL JK', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1936, 2232, 'FACULDADE DE ADMINISTRACAO E MARKETING DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1937, 2233, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1938, 2234, 'FACULDADE DE PEDAGOGIA DE BETIM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1939, 2235, 'FACULDADE TEOLOGICA DAS ASSEMBLEIAS DE DEUS EM SANTOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1940, 2236, 'ESCOLA SUPERIOR DE ADMINISTRACAO MARKETING E COMUNICACAO DE SAO BERNARDO DO CAMPO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1941, 2237, 'FACULDADE TEOLOGICA BATISTA EQUATORIAL', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1942, 2238, 'FACULDADE DE PSICOLOGIA DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1943, 2239, 'FACULDADE DE DIREITO DE VILHA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1944, 2240, 'FACULDADE DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1945, 2241, 'FACULDADE DO SUDESTE MINEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1946, 2242, 'FACULDADE DO RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1947, 2243, 'FACULDADE PARAIBANA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1948, 2244, 'FACULDADE DA CIDADE DE MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1949, 2245, 'FACULDADE DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1950, 2246, 'FACULDADE METROPOLITANA DE CIENCIAS E TECNOLOGIA', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1951, 2247, 'FACULDADE DOTTORI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1952, 2248, 'FACULDADE SERGIPANA', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1953, 2249, 'FACULDADE LOGOS EM ARACAJU', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1954, 2250, 'INSTITUTO SANTO TOMAS DE AQUINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1955, 2251, 'FACULDADE DE POMPEIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1956, 2252, 'FACULDADE DE CIENCIA DA EDUCACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1957, 2253, 'FACULDADE DE DIREITO DE PRIMAVERA DO LESTE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1958, 2254, 'FACULDADE DE CIENCIAS GERENCIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1959, 2255, 'INSTITUTO DE ENSINO SUPERIOR DO AMAZONAS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1960, 2256, 'FACULDADE OBOE II', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1961, 2257, 'FACULDADE DIADEMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1962, 2258, 'FACULDADE DE PRIMEIRO MUNDO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1963, 2259, 'INSTITUTO SUPERIOR EDUCACAO LEONARDO DA VINCI', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1964, 2260, 'FACULDADE DE TECNOLOGIA IESVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1965, 2261, 'FACULDADE DE CIENCIAS HUMANAS E DA SAUDE DE TAQUARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1966, 2262, 'INSTITUTO DE EDUCACAO NORMAL SUPERIOR DE PIMENTA BUENO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1967, 2263, 'FACULDADE SANTO ANTONIO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1968, 2264, 'FACULDADE DE COMUNICACAO PITAGORAS UNIDADE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1969, 2265, 'FACULDADE DE CIENCIAS SOCIAIS E APLICADAS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1970, 2266, 'FACULDADE CAMBURY DE FORMOSA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1971, 2267, 'FACULDADE DE SAUDE DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1972, 2268, 'FACULDADE DE TEOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1973, 2269, 'INSTITUTO SUPERIOR DE EDUCACAO LUMINI', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1974, 2270, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE EXTREMA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1975, 2271, 'FACULDADE PITAGORAS DE IPATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1976, 2272, 'FACULDADE DE PSICOLOGIA DE LAGES', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1977, 2273, 'INSTITUTO SUPERIOR DE EDUCACAO DO ALTO SAO FRANCISCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1978, 2274, 'FACULDADE CIDADANIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1979, 2275, 'FACULDADE DE DIREITO SANTO AGOSTINHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1980, 2276, 'FACULDADE DE DIREITO DE VALINHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1981, 2277, 'INSTITUTO SUPERIOR DE EDUCACAO CENECISTA DE UNAI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1982, 2278, 'FACULDADE IGARATA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1983, 2279, 'FACULDADE INTEGRADA METROPOLITANA DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1984, 2280, 'FACULDADE SUPERIOR DE RIBAS DO RIO PARDO', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1985, 2281, 'FACULDADE DE FILOSOFIA SAO BOAVENTURA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1986, 2282, 'FACULDADE DE CAFELANDIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1987, 2283, 'FACULDADE SAO JOSE DA COSTA VERDE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1988, 2284, 'FACULDADE DE FILOSOFIA CENCIAS E LETRAS DE FAXINAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1989, 2285, 'FACULDADE DE PEDAGOGIA DE DORES DO INDAIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1990, 2286, 'FACULDADE DE BOM JESUS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1991, 2287, 'ESCOLA SUPERIOR DE TEOLOGIA E ESPIRITUALIDADE FRANCISCANA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1992, 2288, 'FACULDADE ALMEIDA RODRIGUES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1993, 2289, 'FACULDADE UNIAO CULTURAL DO ESTADO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1994, 2290, 'FACULDADE DE EDUCACAO CIENCIAS E HUMANIDADES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1995, 2291, 'INSTITUTO SUPERIOR DE EDUCACAO DE BEBEDOURO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1996, 2292, 'INSTITUTO DE EDUCACAO NORMAL SUPERIOR', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1997, 2293, 'FACULDADE DE CIENCIAS HUMANAS, BIOLOGICAS E DA SAUDE', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1998, 2294, 'FACULDADE DE CIENCIAS APLICADAS DA REGIAO CENTRO SUL DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (1999, 2295, 'INSTITUTO MEDICENSE DE EDUCACAO SUPERIOR', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2000, 2296, 'FACULDADE DE LETRAS DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2001, 2297, 'FACULDADE DE DIREITO DE SANTA MARIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2002, 2298, 'ESCOLA SUPERIOR DE DIREITO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2003, 2299, 'FACULDADE ESPECIAL DE EDUCACAO E CULTURA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2004, 2300, 'INSTITUTO DE EDUCACAO SUPERIOR DE ROLIM DE MOURA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2005, 2301, 'FACULDADE FIDELIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2006, 2302, 'FACULDADE PORTO SEGURO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2007, 2303, 'FACULDADE CIMO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2008, 2304, 'INSTITUTO DE ENSINO SUPERIOR DA FUNLEC DE BONITO', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2009, 2305, 'FACULDADE DE DIREITO DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2010, 2306, 'FACULDADE RIO BRANCO DO SUL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2011, 2307, 'INSTITUTO SUPERIOR DE EDUCACAO DE ITABIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2012, 2308, 'FACULDADE GEREMARIO DANTAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2013, 2309, 'FACULDADE NOVO MILENIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2014, 2310, 'FACULDADE DA REGIAO DOS VALES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2015, 2311, 'FACULDADE DE CIENCIAS JURIDICAS PROFESSOR ALBERTO DEODATO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2016, 2312, 'FACULDADE LUTERANA RUI BARBOSA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2017, 2313, 'FACULDADE DE TEOLOGIA DE BOA VISTA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2018, 2314, 'INSTITUTO DE ENSINO SUPERIOR TECNOLOGICO DE LONDRINA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2019, 2315, 'FACULDADE CEARENSE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2020, 2316, 'INSTITUTO NACIONAL DE DESENVOLVIMENTO DO ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2021, 2317, 'FACULDADE DO DESCOBRIMENTO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2022, 2318, 'FACULDADE DOM BOSCO DE NOVA AURORA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2023, 2319, 'ESCOLA SUPERIOR DE EDUCACAO CORPORATIVA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2024, 2320, 'INSTITUTO SUPERIOR DE EDUCACAO ATENEU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2025, 2321, 'FACULDADE INESP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2026, 2322, 'FACULDADE ATENEU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2027, 2323, 'FACULDADE DA AMAZONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2028, 2324, 'FACULDADE UNIAO BANDEIRANTE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2029, 2325, 'INSTITUTO SUPERIOR DE EDUCACAO DA AMAZONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2030, 2326, 'FACULDADE NOVO MILENIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2031, 2327, 'FACULDADE SERRANA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2032, 2328, 'FACULDADE ITEANA DE BOTUCATU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2033, 2329, 'FACULDADE BATISTA DO NORDESTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2034, 2330, 'FACULDADE CANDIDO RONDON   FCR', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2035, 2331, 'ESCOLA SUPERIOR DE TEOLOGIA E FILOSOFIA DO BRASIL', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2036, 2332, 'FACULDADE CORPORATIVA CESPI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2037, 2333, 'FACULDADE DE TEOLOGIA MOKITI OKADA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2038, 2334, 'FACULDADE CENECISTA DE RIO DAS OSTRAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2039, 2335, 'FACULDADE JOAQUIM MACHADO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2040, 2336, 'FACULDADE MONTES BELOS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2041, 2337, 'INSTITUTO SUPERIOR DE EDUCACAO DE MONTES BELOS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2042, 2338, 'INSTITUTO BRASILEIRO DE ESTUDOS TRIBUTARIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2043, 2339, 'FACULDADE INTERNACIONAL DE HOTELARIA E TURISMO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2044, 2340, 'FACULDE ALPHAVILLE DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2045, 2341, 'FACULDADE DA ALDEIA DE CARAPICUIBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2046, 2342, 'INSTITUTO SUPERIOR DE EDUCACAO CERES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2047, 2343, 'FACULDADE DA AMAZONIA OCIDENTAL', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2048, 2344, 'FACULDADE ITEANA DE IBITINGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2049, 2345, 'FACULDADE SETE DE SETEMBRO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2050, 2346, 'INSTITUTO SUPERIOR DE FILOSOFIA BERTHIER', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2051, 2347, 'FACULDADE GENNARI PEARTREE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2052, 2348, 'INSTITUICAO DE ENSINO SAO FRANCISCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2053, 2349, 'DINAMICO FACULDADE DE FLORIANO LTDA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2054, 2350, 'ESCOLA SUPERIOR MADRE CELESTE', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2055, 2351, 'FACULDADE ESPIRITO SANTENSE DE CIENCIAS JURIDICAS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2056, 2352, 'INSTITUTO DE EDUCACAO SUPERIOR PIO XII', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2057, 2353, 'FACULDADE DE ADMINISTRACAO DO CENTRO EDUCACIONAL DE SANTOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2058, 2354, 'INSTITUTO SUPERIOR DE EDUCACAO DO BRASIL', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2059, 2355, 'FACULDADE ANHANGUERA DE MATAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2060, 2356, 'FACULDADE PAN AMERICANA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2061, 2357, 'FACULDADE DE CIENCIAS BIOLOGICAS E DA SAUDE DO CESCARELLI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2062, 2358, 'INSTITUTO SUPERIOR DE EDUCACAO DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2063, 2359, 'INSTITUTO SUPERIOR DE EDUCACAO NOVO MILENIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2064, 2360, 'INSTITUTO SUPERIOR DE EDUCACAO MESTRE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2065, 2361, 'FACULDADE PADRAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2066, 2362, 'FACULDADE DE CIENCIAS MEDICAS DE CAMPINA GRANDE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2067, 2363, 'FACULDADE NOVO MILENIO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2068, 2364, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS DE PARAISO DO TOCANTINS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2069, 2365, 'FACULDADE CATOLICA DO TOCANTINS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2070, 2366, 'FACULDADE DE SISTEMAS DE INFORMACAO DE PARAISO DO TOCANTINS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2071, 2367, 'INSTITUTO SUPERIOR DE EDUCACAO NOVO MILENIO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2072, 2368, 'FACULDADE DE ODONTOLOGIA SAO LEOPOLDO MANDIC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2073, 2369, 'INSTITUTO DE ENSINO SUPERIOR SANTO ANTONIO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2074, 2370, 'INSTITUTO SUPERIOR DE EDUCACAO NOVO MILENIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2075, 2371, 'INSTITUTO DE EDUCACAO SUPERIOR SAO FRANCISCO DE ASSIS DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2076, 2372, 'INSTITUTO DE CIENCIAS GERENCIAIS DE BRASILIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2077, 2373, 'FACULDADES RESENDE DE FREITAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2078, 2374, 'FACULDADES INTEGRADAS CONTEMPORANEAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2079, 2375, 'FACULDADE VIZCAYA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2080, 2376, 'INSTITUTO SUPERIOR DE EDUCACAO DE BRASILIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2081, 2377, 'INSTITUTO SUPERIOR DE EDUCACAO CENECISTA PRESIDENTE KENNEDY', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2082, 2378, 'FACULDADE DE ADMINISTRACAO DE CAMPINA VERDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2083, 2379, 'INSTITUTO SUPERIOR DE EDUCACAO DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2084, 2380, 'FACULDADE ESTACIO DO AMAPA ESTACIO FAMAP', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2085, 2381, 'INSTITUTO DE ENSINO E CULTURA DE DOURADOS', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2086, 2382, 'INSTITUTO SUPERIOR DE EDUCACAO DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2087, 2383, 'FACULDADE MERIDIONAL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2088, 2384, 'FACULDADE INTEGRADA DO BRASIL', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2089, 2385, 'INSTITUTO SUPERIOR DE EDUCACAO NOVO MILENIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2090, 2386, 'FACULDADE SUL RIOGRANDENSE', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2091, 2387, 'FACULDADES INTEGRADAS POSIVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2092, 2388, 'FACULDADE NOVO MILENIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2093, 2389, 'FACULDADE DE FILOSOFIA E TEOLOGIA PAULO VI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2094, 2390, 'INSTITUTO BRUSQUENSE DE ENSINO SUPERIOR', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2095, 2391, 'INSTITUTO SUPERIOR DE EDUCACAO NOVO MILENIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2096, 2392, 'INSTITUTO SUPERIOR DE EDUCACAO DE SAO FRANCISCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2097, 2393, 'FACULDADE MARISTA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2098, 2394, 'FACULDADE DE INFORMATICA DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2099, 2395, 'FACULDADE DE CAMPO VERDE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2100, 2396, 'INSTITUTO DE EDUCACAO SUPEIOR DO SERTAO EM PAO DE ACUCAR', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2101, 2397, 'FACULDADE FUCAPE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2102, 2398, 'FACULDADE CANDIDO RONDON DE CAMPO VERDE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2103, 2399, 'FACULDADE DE SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2104, 2400, 'FACULDADE DOM BOSCO DE MARINGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2105, 2401, 'INSTITUTO SUPERIOR DE EDUCACAO DE CAMPO BELO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2106, 2402, 'FACULDADE CIDADE DO SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2107, 2403, 'FACULDADE SALESIANA DE PINDAMONHANGABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2108, 2404, 'FACULDADES INTEGRADAS DE FILOSOFIA E CIENCIAS DO PLANALTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2109, 2405, 'INSTITUTO SUPERIOR DE EDUCACAO DE SANTA LUZIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2110, 2406, 'FACULDADE DE GESTAO E EMPREENDEDORISMO', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2111, 2407, 'FACULDADES INTEGRADAS FACVEST', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2112, 2408, 'FACULDADE ESAMC SANTOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2113, 2409, 'FACULDADE ASCES', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2114, 2410, 'FACULDADE CEARENSE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2115, 2411, 'FACULDADE DA CIDADE DO NATAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2116, 2412, 'FACULDADE ECONOROESTE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2117, 2413, 'FACULDADE DE ENSINO SUPERIOR DE FLORIANO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2118, 2414, 'INSTITUTO SUPERIOR DE EDUCACAO IESDE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2119, 2415, 'FACULDADE BOM JESUS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2120, 2416, 'INSTITUTO SUPERIOR DE EDUCACAO DE BOTUCATU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2121, 2417, 'INSTITUTO SUPERIOR DE EDUCACAO METROPOLITANO DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2122, 2418, 'FACULDADES INTEGRADAS DO RECONCAVO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2123, 2419, 'FACITALGO FACULDADE DE CIENCIAS E TECNOLOGIA DE AGUAS LINDAS DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2124, 2420, 'FACULDADE PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2125, 2421, 'INSTITUTO DE ENSINO SUPERIOR', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2126, 2422, 'FACULDADE DE FILOSOFIA LETRAS E ARTES DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2127, 2423, 'FACULDADE DE CIENCIA E TECNOLOGIA DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2128, 2424, 'FACULDADE DE SISTEMA DE INFORMACAO DE MARABA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2129, 2425, 'FACULDADE DE JIPARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2130, 2426, 'FACULDADE INTEGRADA BRASIL AMAZONIA FIBRA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2131, 2427, 'FACULDADE DE CIENCIAS GERENCIAIS DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2132, 2428, 'FACULDADE DE CIENCIAS E TECNOLOGIAS DE CAMPOS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2133, 2429, 'INSTITUTO SUPERIOR DE EDUCACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2134, 2430, 'FACULDADE CATOLICA ORTODOXA SEDES SAPIENTIAM', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2135, 2431, 'FACULDADE ESTACIO MONTESSORI DE IBIUNA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2136, 2432, 'FACULDADE ALPHAVILLE DE JUNDIAI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2137, 2433, 'INSTITUTO SUPERIOR DE EDUCACAO PORTO SEGURO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2138, 2434, 'FACULDADE AMERICA LATINA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2139, 2435, 'FACULDADE DE CIENCIAS CONTABEIS LUIZ MENDES', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2140, 2436, 'FACULDADE TAHIRIH', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2141, 2437, 'FACULDADE PITAGORAS DE TEIXEIRA DE FREITAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2142, 2438, 'INSTITUTO TEOLOGICO PASTORAL DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2143, 2439, 'FACULDADE OCIDEMNTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2144, 2440, 'FACULDADE CIDADE DE JOAO PINHEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2145, 2441, 'INSTITUTO SUPERIOR DE EDUCACAO AUXILIUM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2146, 2442, 'FACULDADE DE CIENCIAS BIOMEDICAS DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2147, 2443, 'FACULDADE PROMOVE DE JANAUBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2148, 2444, 'FACULDADE JOAO CALVINO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2149, 2445, 'FACULDADE PADRAO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2150, 2446, 'INSTITUTO SUPERIOR DE EDUCACAO PADRAO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2151, 2447, 'INSTITUTO EDUCACIONAL DE CASTRO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2152, 2448, 'INSTITUTO SUPERIOR DE EDUCACAO DE JANUARIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2153, 2449, 'INSTITUTO MATO GROSSO DE EDUCACAO E CULTURA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2154, 2450, 'FACULDADE PROMOVE DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2155, 2451, 'FACULDADES INTEGRADAS IPIRANGA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2156, 2452, 'INSTITUTO BRASILEIRO DE ENSINO SUPERIOR PROFISSIONALIZANTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2157, 2453, 'FACULDADE BRASIL CENTRAL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2158, 2454, 'FACULDADE MAFRENSE DE TURISMO E CIENCIAS HUMANAS DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2159, 2455, 'FACULDADE CASTRO ALVES', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2160, 2456, 'FACULDADE DE ADMINISTRACAO DE CHAPADAO DO SUL', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2161, 2457, 'FACULDADE ISAAC NEWTON', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2162, 2458, 'CENTRO UNIFICADO DE ENSINO SUPERIOR DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2163, 2459, 'FACULDADE DE ESTUDOS AVANCADOS DO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2164, 2460, 'FACULDADE ESTACIO DE NATAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2165, 2461, 'FACULDADE CBES', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2166, 2462, 'FACULDADE SAO LUIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2167, 2463, 'FACULDADE ALVES FARIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2168, 2464, 'INSTITUTO SUPERIOR DE EDUCACAO ATENEU', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2169, 2465, 'FACULDADE DE DIREITO PROFESSOR DAMASIO DE JESUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2170, 2466, 'FACUDADE IEDUCARE FIED', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2171, 2467, 'FACULDADE NACIONAL DO NORTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2172, 2468, 'INSTITUTO TEOLOGICO FRANCISCANO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2173, 2469, 'INSTITUTO MACAPAENSE DE ENSINO SUPERIOR', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2174, 2470, 'INSTITUTO SALVADOR DE ENSINO E CULTURA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2175, 2471, 'INTITUTO SUPERIOR DE EDUCACAO DE BLUMENAU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2176, 2472, 'FACULDADE DE EDUCACAO CIENCIA E TECNOLOGIA 2001', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2177, 2473, 'INSTITUTO BRASILEIRO DE ADMINISTRACAO BIM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2179, 2475, 'FACULDADE ARQUIDIOCESANA DE MARIANA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2180, 2476, 'FACULDADE FENIX DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2181, 2477, 'FACULDADE DE ADMINISTRACAO DE MARIANA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2182, 2478, 'FACULDADE DE INTEGRACAO DO ENSINO SUPERIOR DO CONE SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2183, 2479, 'FACULDADE LATINO AMERICANA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2184, 2480, 'INSTITUTO SUPERIOR DE EDUCACAO DE ITAPOLIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2185, 2481, 'ESCOLA BRASILEIRA DE FORMACAO EMPRESARIAL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2186, 2482, 'FACULDADE DE CIENCIAS HUMANAS E APLICADAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2187, 2483, 'INSTITUTO SUPERIOR DE EDUCACAO INTEGRAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2188, 2484, 'FACULDADE PROCESSUS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2189, 2485, 'FACULDADE CATOLICA DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2190, 2486, 'FACULDADE LEONARDO DA VINCI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2191, 2487, 'FACULDADE EXIMIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2192, 2488, 'FACULDADE ANGLICANA DE ERECHIM', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2193, 2489, 'INSTITUTO SUPERIOR DE EDUCACAOBRASIL CENTRAL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2194, 2490, 'INSTITUTO SUPERIOR DE ENSINO DO LITORAL CATARINENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2195, 2491, 'INSTITUTO SUPERIOR DE EDUCACAO DO CECAP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2196, 2492, 'INSTITUTO SUPERIOR DE EDUCACAO A DISTANCIA DE BRASILIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2197, 2493, 'INSTITUTO SUPERIOR DE EDUCACAO A DISTANCIA DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2198, 2494, 'FACULDADE DE PINDAMONHANGABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2199, 2495, 'INSTITUTO DE PESQUISA GRANDE VITORIA IPGV FACULDADE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2200, 2496, 'INSTITUTO MACHADO DE ASSIS DE EDUCACAO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2201, 2497, 'FACULDADE ATENEU', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2202, 2498, 'FACULDADE DE MULTIPLAS CIENCIAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2203, 2499, 'FACULDADE APOIO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2204, 2500, 'FACULDADE EINSTEIN', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2205, 2501, 'FACULDADE ESTACIO DE SA DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2206, 2502, 'FACULDADE ARINOS DE ADMINISTRACAO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2207, 2503, 'FACULDADE DE INTEGRACAO NACIONAL LEDA JESUINO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2208, 2504, 'FACULDADE DIVINOPOLIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2209, 2505, 'FACULDADE DE ARTE E DESIGN', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2210, 2506, 'INSTITUTO SUPERIOR DE EDUCACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2211, 2507, 'FACULDADE DE TECNOLOGIA E CIENCIAS DE SANTO ANTONIO DE JESUS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2212, 2508, 'INSTITUTO SUPERIOR DE EDUCACAO SANTO AGOSTINHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2213, 2509, 'FACULDADE DE MEDICINA TRADICIONAL DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2214, 2510, 'FACULDADES MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2215, 2511, 'FACULDADE DE DIREITO UNIDADE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2216, 2512, 'INSTITUTO SUPERIOR DE EDUCACAO CUIABANO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2217, 2513, 'FACULDADE ARTHUR THOMAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2218, 2514, 'INSTITUTO NATALENSE DE EDUCACAO SUPERIOR', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2219, 2515, 'FACULDADE ERUDITA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2220, 2516, 'INSTITUTO SUPERIOR DE EDUCACAO SANTA RITA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2221, 2517, 'FACULDADE DE ESTUDOS SOCIAIS E GESTAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2222, 2518, 'FACULDADE INTENSIVA DE PEDAGOGIA E FILOSOFIA DE ILHEUS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2223, 2519, 'FACULDADE DE INFORMATICA E TECNOLOGIA TERRANOVENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2224, 2520, 'INSTITUTO DE EDUCACAO SUPERIOR TERRANOVENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2225, 2521, 'INSTITUTO SUPERIOR DE EDUCACAO DO SUL DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2226, 2522, 'INSTITUTO MARISTA SUPERIOR DE EDUCACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2227, 2523, 'FACULDADE BONDESPACHENSE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2228, 2524, 'FACULDADE DE ENGENHARIA DA ITAJUBA TECNOPOLIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2229, 2525, 'FACULDADE PAULISTA DE CIENCIAS APLICADAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2230, 2526, 'INSTITUTO SUPERIOR DE EDUCACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2231, 2527, 'INSTITUTO SUPERIOR DE EDUCACAO DE JACAREI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2232, 2528, 'INSTITUTO SUPERIOR DE EDUCACAO MAE DE DEUS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2233, 2529, 'INSTITUTO SUPERIOR DE EDUCACAO DE IGUAPE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2234, 2530, 'FACULDADE DE CIENCIAS DE GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2235, 2531, 'INSTITUTO SUPERIOR DE EDUCACAO PROFESSORA LUCIA DANTAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2236, 2532, 'FACULDADE DO SUDESTE GOIANO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2237, 2533, 'FACULDADE REGIONAL BARUERI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2238, 2534, 'FACULDADE METROPOLITANA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2239, 2535, 'FACULDADE DOS INCONFIDENTES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2240, 2536, 'FACULDADE RORAIMENSE DE ENSINO SUPERIOR', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2241, 2537, 'FACULDADE SAO GERALDO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2242, 2538, 'FACULDADE VENDA NOVA DO IMIGRANTE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2243, 2539, 'FACULDADE EVANGELICA DO MEIO NORTE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2244, 2540, 'INSTITUTO DE ENSINO SUPERIOR DE CAMAPUA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2245, 2541, 'ESCOLA SUPERIOR DE TECNOLOGIA E EDUCACAO DE ARARAQUARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2246, 2542, 'FACULDADE CENECISTA DE QUEIMADOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2247, 2543, 'FACULDADE DA CHAPADA DOS GUIMARAES', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2248, 2544, 'INSTITUTO SUPERIOR DE EDUCACAO PROFESSORA VILMA MONTEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2249, 2545, 'FACULDADE CENECISTA DE PARACAMBI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2250, 2546, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS DE VIANNA JUNIOR DE MURIARE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2251, 2547, 'FACULDADE MAGNUM DE FORMACAO DE PROFESSORES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2252, 2548, 'FACULDADE DE TEOLOGIA, FILOSOFIA E CIENCIAS HUMANAS GAMALIEL', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2253, 2549, 'FACULDADE PAULISTA DE EDUCACAO E COMUNICACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2254, 2550, 'FACULDADE SEPAM', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2255, 2551, 'FACULDADE CENECISTA ITAGUAI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2256, 2552, 'INSTITUTO SUPERIOR DE CIENCIAS DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2257, 2553, 'INSTITUTO DE EDUCACAO SUPERIOR UNYAHNA LUIS EDUARDO MAGALHAES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2258, 2554, 'FACULDADE DE EDUCACAO SANTA TEREZINHA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2259, 2555, 'FACULDADE DE EDUCACAO DE UBERABA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2260, 2556, 'FIAMFAAM CENTRO UNIVERSITARIO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2261, 2557, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE PENEDO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2262, 2558, 'FACULDADE DE DIREITO DE VILA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2263, 2559, 'INSTITUTO SUPERIOR DE EDUCACAO DAS FACULDADES DE VALINHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2264, 2560, 'FACULDADE DE ENSINO SUPERIOR DA CIDADE DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2265, 2561, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2266, 2562, 'FACULDADE JOSE LACERDA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2267, 2563, 'INSTITUTO SUPERIOR DE EDUCACAO PADRE JOAO BAGOZZI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2268, 2564, 'UNIVERSIDADE FEDERAL DE CAMPINA GRANDE', 1, 1, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2269, 2565, 'ABEU   CENTRO UNIVERSITARIO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2270, 2566, 'INSTITUTO DE ENSINO SUPERIOR DE OLINDA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2271, 2567, 'ESCOLA SUPERIOR DE CIENCIAS HUMANAS E ECONOMICAS', 2, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2272, 2568, 'FACULDADE ZACARIAS DE GOES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2273, 2569, 'FACULDADE DE TECNOLOGIA FAESA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2274, 2570, 'FACULDADE DE CIENCIAS EDUCACIONAIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2275, 2571, 'FACULDADE REDENTOR', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2276, 2572, 'FACULDADE REGIONAL DE FILOSOFIA, CIENCIAS E LETRAS DE CANDEIAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2277, 2573, 'FACULDADE TEOLOGICA SUL AMERICANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2278, 2574, 'INSTITUTO SUPERIOR DE EDUCACAO DAS FACULDADES INTEGRADAS MODULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2279, 2575, 'FACULDADES INTEGRADAS SOARES DE OLIVEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2280, 2576, 'FACULDADES PITAGORAS UNIDADE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2281, 2577, 'INSTITUTO SUPERIOR DE MUSICA DE SAO LEOPOLDO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2282, 2578, 'FACULDADE DE TEOLOGIA CARDEAL EUGENIO SALES', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2283, 2579, 'FACULDADE ATENAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2284, 2580, 'INSTITUTO SUPERIOR DE EDUCACAO PAULO MARTINS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2285, 2581, 'FACULDADE SAO SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2286, 2582, 'FACULDADE DE ENSINO SUPERIOR DO CENTRO DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2287, 2583, 'FACULDADE RIBEIRA DO POMBAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2288, 2584, 'FACULDADE DO SUDOESTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2289, 2585, 'FACULDADE DE FISIOTERAPIA DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2290, 2586, 'INSTITUTO SUPERIOR DE EDUCACAO ITALO BRASILEIRO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2291, 2587, 'FACULDADE CANDIDO MENDES DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2292, 2588, 'FALCULDADE MERCATOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2293, 2589, 'FACULDADE DE BROTAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2294, 2590, 'FACULDADE DE CIENCIA DA COMPUTACAO E INFORMATICA SILVA SERPA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2295, 2591, 'ESCOLA BRASILEIRA DE ECONOMIA E FINANCAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2296, 2592, 'FACULDADE PRESBITERIANA 15 DE NOVEMBRO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2297, 2593, 'FACULDADE DE JUAZEIRO DO NORTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2298, 2594, 'FACULDADE TEOLOGICA BATISTA ANA WOLLERMAN', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2299, 2595, 'FACULDADES COSTA BRAGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2300, 2596, 'INSTITUTO SUPERIOR DE EDUCACAO DON DOMENICO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2301, 2597, 'FACULDADE DE CIENCIAS DA SAUDE DA VITORIA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2302, 2598, 'FACULDADE PENSAR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2303, 2599, 'FACULDADE DE EDUCACAO E CIENCIAS HUMANAS NOVA FLORIDA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2304, 2600, 'FACULDADE DE CIENCIAS DA ADMINISTRACAO DA VITORIA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2305, 2601, 'FACULDADE DE CIENCIAS FILOSOFIA E LETRAS HAKAY', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2306, 2602, 'INSTITUTO SUPERIOR DE EDUCACAO BALAO VERMELHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2307, 2603, 'FACULDADE DE ODONTOLOGIA DOS GUARARAPES', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2308, 2604, 'FACULDADE TEOLOGICA BATISTA DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2309, 2605, 'FACULDADE DE CIENCIAS ECONOMICAS DE TUBARAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2310, 2606, 'FACULDADE AFIRMATIVO DE CAMPO MOURAO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2311, 2607, 'FACULDADE PADRE ANTONIO VIEIRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2312, 2608, 'INSTITUTO SUPERIOR DE EDUCACAO DE LAVRAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2313, 2609, 'INSTITUTO SUPERIOR DE EDUCACAO DE TUPI PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2314, 2610, 'FACULDADE DE JACAREI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2315, 2611, 'FACULDADE DE ENSINO SUPERIOR DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2316, 2612, 'INSTITUTO SUPERIOR DE EDUCACAO MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2317, 2613, 'Faculdade Meta', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2318, 2614, 'FACULDADE EMMANUEL KANT', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2319, 2615, 'FACULDADE INCONFIDENCIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2320, 2616, 'FACULDADE SANTO ANTONIO DE PADUA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2321, 2617, 'FACULDADE SAO BENTO DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2322, 2618, 'FACULDADE DOMINGOS SAVIO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2323, 2619, 'FACULDADE DE DIREITO DE ITABIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2324, 2620, 'FACULDADE DE AMPERE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2325, 2621, 'INSTITUTO SUPERIOR DE EDUCACAO DOMINGOS SAVIO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2326, 2622, 'INSTITUTO SUPERIOR DE EDUCACAO DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2327, 2623, 'FACULDADE DO TAPAJOS', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2328, 2624, 'FACULDADE DO LITORAL PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2329, 2625, 'FACULDADE DE TECNOLOGIA IBTA SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2330, 2626, 'FACULDADE DE COMUNICACAO SOCIAL SANTA EFIGENIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2331, 2627, 'FACULDADE JOAO XXIII', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2332, 2628, 'INSTITUTO DE EDUCACAO SUPERIOR ACADEMUS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2333, 2629, 'FACULDADE DE CIENCIAS CONTABEIS E DE ADMINISTRACAO DO VALE DO JURUENA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2334, 2630, 'INSTITUTO SUPERIOR DE EDUCACAO DO VALE DO JURUENA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2335, 2631, 'INSTITUTO DE EDUCACAO SUPERIOR', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2336, 2632, 'FACULDADES INTEGRADAS DO EXTREMO SUL DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2337, 2633, 'INSTITUTO DE EDUCACAO E TECNOLOGIAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2338, 2634, 'INSTITUTO EDUCACIONAL DALTON CUNHA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2339, 2635, 'INSTITUTO SUPERIOR DE EDUCACAO JK', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2340, 2636, 'FACULDADE DINAMICA DO VALE DO PIRANGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2341, 2637, 'FACULDADE BOM JESUS DE SIQUEIRA CAMPOS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2342, 2638, 'INSTITUTO DE CIENCIAS E EDUCACAO DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2343, 2639, 'FACULDADE DE TECNOLOGIA SENAI CONCORDIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2344, 2640, 'FACULDADE COMUNITARIA DE SAUDE DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2345, 2641, 'FACULDADE TEOLOGICA BATISTA FLUMINENSE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2346, 2642, 'FACULDADE SAO VICENTE', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2347, 2643, 'INSTITUTO SUPERIOR DE CIENCIAS E TECNOLOGIA DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2348, 2644, 'INSTITUTO DE EDUCACAO SUPERIOR DO TAPAJOS', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2349, 2645, 'INSTITUTO DE ENSINO SUPERIOR DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2350, 2646, 'FACULDADE REGIONAL IPIRANGA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2351, 2647, 'FACULDADE INTEGRADA DE SANTA MARIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2352, 2648, 'FACULDADE SUL MINEIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2353, 2649, 'FACULDADE DE CIENCIAS JURIDICAS DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2354, 2650, 'INSTITUTO DE ENSINO SUPERIOR DE ARIQUEMES', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2355, 2651, 'FACULDADE TAMANDARE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2356, 2652, 'FACULDADE UNIDA DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2357, 2653, 'FACULDADE PIEMONTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2358, 2654, 'FACULDADE DE ENSINO TECNOLOGICO DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2359, 2655, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS SOCIAIS E DA SAUDE DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2360, 2656, 'FACULDADE SANTA CATARINA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2361, 2657, 'FACULDADE ADOLFO CAMINHA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2362, 2658, 'FACULDADE AMEC TRABUCO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2363, 2659, 'FACULDADE DO VALE DO PARNAIBA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2364, 2660, 'FACULDADE PHENIX DE CIENCIAS HUMANAS E SOCIAIS DO BRASIL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2365, 2661, 'INSTITUTO DE ENSINO SUPERIOR DE BARREIRAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2366, 2662, 'INSTITUTO SUPERIOR DE ENSINO PAULA CANDIDO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2367, 2663, 'FACULDADE DE ODONTOLOGIA ARGEMIRO FIGUEIREDO', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2368, 2664, 'INSTITUTO DE ENSINO SUPERIOR DO VALE DO PARNAIBA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2369, 2665, 'FACULDADE DE TECNOLOGIA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2370, 2666, 'FACULDADE INTEGRADA DE BRUSQUE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2371, 2667, 'INSTITUTO SUPERIOR PAULO FREIRE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2372, 2668, 'FACULDADE TEOLOGICA DO SUDOESTE GOIANO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2373, 2669, 'FACULDADE CANDIDO MENDES DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2374, 2670, 'INSTITUTO DE EDUCACAO SUPERIOR ACREANO EUCLIDES DA CUNHA', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2375, 2671, 'FACULDADE DE CIENCIAS HUMANAS E PSICOLOGICAS EUCLIDES DA CUNHA', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2376, 2672, 'FACULDADE HUGO DE SAO VITOR', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2377, 2673, 'INSTITUTO SUPERIOR DE EDUCACAO AVILA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2378, 2674, 'INSTITUTO DE ENSINO SUPERIOR UNILLUZ', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2379, 2675, 'INSTITUTO SUPERIOR DE EDUCACAO LATINO AMERICANO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2380, 2676, 'FACULDADE LA SALLE', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2381, 2677, 'INSTITUTO SUPERIOR DE EDUCACAO SAO JUDAS TADEU', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2382, 2678, 'FACULDADE DE COMPUTACAO E INFORMATICA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2383, 2679, 'FACULDADE DE CIENCIA DA COMPUTACAO DE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2384, 2680, 'FACULDADE DE COMPUTACAO DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2385, 2681, 'FACULDADE DE ENGENHARIA CIVIL DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2386, 2682, 'FACULDADE DE CIENCIAS DA SAUDE DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2387, 2683, 'FACULDADE DE CIENCIAS DA COMPUTACAO DE CATAGUASES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2388, 2684, 'FACULDADE DE CIENCIAS GERENCIAIS DE LEOPOLDINA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2389, 2685, 'FACULDADE DELTA DE ENSINO SUPERIOR', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2390, 2686, 'FACULDADE SANTA IZILDINHA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2391, 2687, 'FACULDADE DOM ALBERTO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2392, 2688, 'FACULDADE INESP INSTITUTO NACIONAL DE ENSINO E PESQUISA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2393, 2689, 'FACULDADE CARLOS LOBO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2394, 2690, 'FACULDADES INTEGRADAS LOGOS FILOGOS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2395, 2691, 'FACULDADE ASSOCIADA DA BAHIA FAB', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2396, 2692, 'FACULDADE AVILA DE CIENCIAS HUMANAS E EXATAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2397, 2693, 'FACULDADES INTEGRADAS DO TRIANGULO MINEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2398, 2694, 'FACULDADE VALE DO ARAGUAIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2399, 2695, 'FACULDADE DO CENTROOESTE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2400, 2696, 'INSUBA INSTITUTO SUPERIOR DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2401, 2697, 'INSTITUTO SUPERIOR DE EDUCACAO DE AMELIA RODRIGUES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2402, 2698, 'INSTITUTO SUPERIOR DE EDUCACAO VALE DO ARAGUAIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2403, 2699, 'INSTITUTO DE ENSINO SUPERIOR AVANT GARDE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2404, 2700, 'FACULDADE UNIPOLI', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2405, 2701, 'FACULDADE DE ORLANDIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2406, 2702, 'FACULDADE DE CIENCIAS JURIDICAS DE PARAISO DO TOCANTINS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2407, 2703, 'FACULDADE SENAC MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2408, 2704, 'INSTITUTO SUPERIOR DE EDUCACAO DO INSTITUTO METODISTA UNIAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2409, 2705, 'FACULDADE DE EDUCACAO E CIENCIAS HUMANAS NOVA FLORIDA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2410, 2706, 'FACULDADE EUROPEU', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2411, 2707, 'INSTITUTO SUPERIOR DE EDUCACAO PROFESSOR EDGARDO BEZERRA DA ROCHA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2412, 2708, 'INSTITUTO SUPERIOR DE CIENCIAS HUMANAS E FILOSOFIA LA SALLE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2413, 2709, 'INSTITUTO DE ENSINO SUPERIOR NOVO HORIZONTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2414, 2710, 'INSTITUTO SUPERIOR DE EDUCACAO RANCHARIENSE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2415, 2711, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS DE CAJAMAR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2416, 2712, 'FACULDADE DE SISTEMAS DE INFORMACAO DE CAJAMAR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2417, 2713, 'INSTITUTO NORMAL SUPERIOR DE CAJAMAR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2418, 2714, 'FACULDADE DE ENFERMAGEM E OBSTETRICIA DE CAJAMAR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2419, 2715, 'FACULDADE DE CIENCIAS HUMANAS DE PONTE NOVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2420, 2716, 'FACULDADE COTEMGE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2421, 2717, 'FACULDADE DE CIENCIAS JURIDICAS VISCONDE DE CAIRU', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2422, 2718, 'INSTITUTO SUPERIOR DE EDUCACAO DO NORTE', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2423, 2719, 'FACULDADE DE DIREITO OSWALDO CRUZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2424, 2720, 'FACULDADE AUGUSTO MAIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2425, 2721, 'FACULDADE IMPACTA DE TECNOLOGIA DA INFORMACAO FITI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2426, 2722, 'FACULDADE CATOLICA DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2427, 2723, 'FACULDADE MARISTA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2428, 2724, 'INSTITUTO DE ENSINO SUPERIOR DO SUL DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2429, 2725, 'INSTITUTO SUPERIOR DE EDUCACAO DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2430, 2726, 'ESCOLA SUPERIOR DE ADMINISTRACAO DE EMPRESAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2431, 2727, 'FACULDADE DO RIO GRANDE DO NORTE', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2432, 2728, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS MAX', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2433, 2729, 'FACULDADE DE PSICOLOGIA MAX', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2434, 2730, 'FACULDADE UNIDA DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2435, 2731, 'ESCOLA SUPERIOR DE COMPUTACAO E TECNOLOGIAS DA INFORMACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2436, 2732, 'FACULDADE UNIDAS DO ENTORNO GOIAS DF UNIENTORNO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2437, 2733, 'FACULDADE TEOLOGICA ALPHA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2438, 2734, 'FACULDADE DE CIENCIAS DA SAUDE DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2439, 2735, 'FACULDADE DE CIENCIAS DA COMPUTACAO DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2440, 2736, 'INSTITUTO TECNOLOGICO DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2441, 2737, 'FACULDADE DE CIENCIAS DA INFORMACAO DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2442, 2738, 'INSTITUTO SUPERIOR DE EDUCACAO DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2443, 2739, 'FACULDADE CASTILHENSE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2444, 2740, 'FACULDADE DO VALE DO JAGUARIBE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2445, 2741, 'FACULDADE CATOLICA DOM ORIONE', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2446, 2742, 'FACULDADE DE EDUCACAO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2447, 2743, 'FACULDADE DE CIENCIA DA COMPUTACAO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2448, 2744, 'INSTITUTO SUPERIOR DE EDUCACAO VERA CRUZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2449, 2745, 'ESCOLA SUPERIOR DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2450, 2746, 'INSTITUTO DE ENSINO SUPERIOR ETAPA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2451, 2747, 'FACULDADE EUROPEU DO CEARA FEC', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2452, 2748, 'FACULDADE LATO SENSU DO BRASIL', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2453, 2749, 'INSTITUTO DE CIENCIAS JURIDICAS PITAGORAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2454, 2750, 'FACULDADE DE TECNOLOGIA SENAI LUZERNA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2455, 2751, 'INSTITUTO SUPERIOR DE EDUCACAO DE RIBEIRA DO POMBAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2456, 2752, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS PROFESSORA VILMA MONTEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2457, 2753, 'FACULDADE DE CIENCIAS EDUCACIONAIS DE CAPIM GROSSO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2459, 2755, 'FACULDADE DO VALE DO ITAJAI MIRIM', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2460, 2756, 'FACULDADE ANHANGUERA DE VALPARAISO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2461, 2757, 'FACULDADE JK ADMINISTRACAO DE VALPARAISO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2462, 2758, 'INSTITUTO SUPERIOR DE EDUCACAO PROFESSOR PAULO ALBINO PIMENTEL', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2463, 2759, 'FACULDADE PROFESSOR PAULO ALBINO PIMENTEL', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2464, 2760, 'ESCOLA SUPERIOR DE TECNOLOGIA DA INFORMACAO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2465, 2761, 'FACULDADE DO SERTAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2466, 2762, 'INSTITUTO ISAAC NEWTON', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2467, 2763, 'FACULDADE DE CIENCIAS GERENCIAIS DE SAO GOTARDO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2468, 2764, 'INSTITUTO DE ENSINO SUPERIOR DE OURO FINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2469, 2765, 'INSTITUTO DE CIENCIAS RELIGIOSAS LUMEN CHRISTI', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2470, 2766, 'FACULDADE EMPRESARIAL DE CHAPECO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2471, 2767, 'INSTITUTO SUPERIOR DE EDUCACAO DA AIMORES M G', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2472, 2768, 'INSTITUTO SUPERIOR DE EDUCACAO FACREFI', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2473, 2769, 'FAVE FACULDADE DE ADMINISTRACAO DE VESPASIANO LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2474, 2770, 'FACULDADE UNIDA DE CAMPINAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2475, 2771, 'CENTRO DE ENSINO SUPERIOR DE ILHEUS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2476, 2772, 'INSTITUTO SUPERIOR DE EDUCACAO MANHUMIRIM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2477, 2773, 'FACULDADE DE MACAPA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2478, 2774, 'CENTRO UNIVERSITARIO UNIFAFIBE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2479, 2775, 'FACULDADES INTEGRADAS DESEMBARGADOR SAVIO BRANDAO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2480, 2776, 'FACULDADES INTEGRADAS NORTE CAPIXABA FANORTE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2481, 2777, 'INSTITUTO DE ENSINO SUPERIOR SANTA MARIA DE ASSIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2482, 2778, 'INSTITUTO SUPERIOR ESPECIAL DE EDUCACAO DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2483, 2779, 'FACULDADE DE INFORMATICA DE OURO PRETO DO OESTE', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2484, 2780, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DA ALTA NOROESTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2485, 2781, 'FACULDADE DE CIENCIAS DA SAUDE DA ALTA NOROESTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2486, 2782, 'INSTITUTO SUPERIOR DE EDUCACAO AFONSO LINARES PRADO', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2487, 2783, 'FACULDADE DE TECNOLOGIA DO NORDESTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2488, 2784, 'FACULDADE FAE BLUMENAU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2489, 2785, 'ESCOLA SUPERIOR DE EDUCACAO CONTINUADA', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2490, 2786, 'INSTITUTO DE EDUCACAO SUPERIOR E TECNOLOGICA PROF FRANBRAN', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2491, 2787, 'FACULDADES PEQUENO PRINCIPE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2492, 2788, 'FACULDADE DE CIENCIAS AMBIENTAIS DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2493, 2789, 'FACULDADE JOINVILLE DE ENSINO E CULTURA FAJEC', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2494, 2790, 'FACULDADE FRANCISCANA DE ENSINO SUPERIOR FAFRES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2495, 2791, 'FACULDADE DE CIENCIAS AGRARIAS E EXATAS DE PRIMAVERA DO LESTE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2496, 2792, 'FACULDADE DE CIENCIAS SOCIAIS E EDUCACAO FACE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2497, 2793, 'FACULDADE UNIAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2498, 2794, 'FACULDADE DE CIENCIAS SOCIAIS E HUMANAS SOBRAL PINTO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2499, 2795, 'FACULDADE SAO FRANCISCO DE ASSIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2500, 2796, 'FACULDADE DE IPORA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2501, 2797, 'FACULDADE DO LITORAL SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2502, 2798, 'FAESP FACULDADE DE ENSINO SUPERIOR DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2503, 2799, 'FANEESP FACULDADE NACIONAL DE EDUCACAO E ENSINO SUPERIOR DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2504, 2800, 'FACULDADE DE ITABUNA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2505, 2801, 'INSTITUTO GUARANTA DE EDUCACAO SUPERIOR', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2506, 2802, 'FACULDADE DE CIENCIAS AGRARIAS DE GUARANTA DO NORTE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2507, 2803, 'FACULDADE CETESI', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2508, 2804, 'FACULDADE CCAA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2509, 2805, 'FACULDADE MODELO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2510, 2806, 'FACULDADE EVANGELICA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2511, 2807, 'FACULDADE CENTRO CAPE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2512, 2808, 'FACULDADES ITECNE DE CASCAVEL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2513, 2809, 'INSTITUTO DE ENSINO SUPERIOR DE UBERLANDIA IESU', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2514, 2810, 'INSTITUTO SUPERIOR DE EDUCACAO ANISIO TEIXEIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2515, 2811, 'FACULDADE PAULUS DE TECNOLOGIA E COMUNICACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2516, 2812, 'FACULDADE DO SUDESTE BRASILEIRO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2517, 2813, 'INSTITUTO SUPERIOR DE EDUCACAO CAPIMGROSSENSE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2518, 2814, 'FACULDADE SAO SEBASTIAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2519, 2815, 'FACULDADE VALE DO RIBEIRA FVR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2520, 2816, 'FACULDADE SANTO AGOSTINHO FSA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2521, 2817, 'FACULDADE DE IUNA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2522, 2818, 'FACULDADE DE VETERINARIA DE VESPASIANO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2523, 2819, 'FACULDADE ANGELO VASCONCELOS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2524, 2820, 'FACULDADE PITAGORAS DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2525, 2821, 'FACULDADE IDC', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2526, 2822, 'FACULDADE DE ENGENHARIA FLORESTAL DE IBIRACU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2527, 2823, 'FACULDADE DE ENGENHARIA AGRICOLA DE IBIRACU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2528, 2824, 'FACULDADE DE ENGENHARIA AGRONOMICA DE IBIRACU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2529, 2825, 'FACULDADE DO SISTEMA FINDES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2530, 2826, 'FACULDADE NOSSA SENHORA DE FATIMA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2531, 2827, 'FACULDADE EVANGELICA DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2532, 2828, 'FACULDADE ITABIRANA DE SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2533, 2829, 'INSTITUTO SUPERIOR DE EDUCACAO E FILOSOFIA DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2534, 2830, 'FACULDADE ADVENTISTA DE CIENCIAS DA SAUDE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2535, 2831, 'FACULDADE DOM BOSCO DE GOIOERE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2536, 2832, 'INSTITUTO SUPERIOR DE EDUCACAO PROGRAMUS', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2537, 2833, 'FACULDADE ON LINE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2538, 2834, 'INSTITUTO SUPERIOR DE PSICOLOGIA DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2539, 2835, 'CENTRO UNIVERSITARIO MAURICIO DE NASSAU', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2540, 2836, 'FACULDADE SUL DA AMERICA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2541, 2837, 'INSTITUTO SUPERIOR DE EDUCACAO SUL DA AMERICA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2542, 2838, 'FASES FACULDADE SOTEROPOLITANA DE ENSINO SUPERIOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2543, 2839, 'INSTITUTO METODISTA SUPERIOR DE EDUCACAO DA AMAZONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2544, 2840, 'FACULDADE METODISTA DE TEOLOGIA E CIENCIAS HUMANAS DA AMAZONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2545, 2841, 'FACULDADE PARANAPANEMA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2546, 2842, 'FACULDADE DE MEDICINA MACHADO DE ASSIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2547, 2843, 'FACULDADE DE CIENCIAS MEDICAS E DA SAUDE DE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2548, 2844, 'FACULDADE SALESIANA DOM BOSCO DE PIRACICABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2549, 2845, 'FACULDADE REINALDO RAMOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2550, 2846, 'FACULDADE DE TEOLOGIA UMBANDISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2551, 2847, 'INSTITUTO SUPERIOR DE EDUCACAO DO PARANAPANEMA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2552, 2848, 'FACULDADE DE NOVO PROGRESSO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2553, 2849, 'ESCOLA SUPERIOR DOM HELDER CAMARA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2554, 2850, 'FACULDADE DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2555, 2851, 'FACULDADE SANTA PAULINA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2556, 2852, 'FACULDADE DE GESTAO E NEGOCIOS DO ALTO URUGUAI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2557, 2853, 'FACULDADE PITAGORAS DE TECNOLOGIA DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2558, 2854, 'FACULDADE CONHECER', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2559, 2855, 'FACULDADE SAO FRANCISCO DE ASSIS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2560, 2856, 'FACULDADE DE TECNOLOGIA QUASAR', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2561, 2857, 'INSTITUTO CIENTIFICO DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2562, 2858, 'INSTITUTO DE SAUDE ALEXANDER FLEMING', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2563, 2859, 'FACULDADE DE BELEM', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2564, 2860, 'FACULDADE CEAQ', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2565, 2861, 'FACULDADE DE ITAPETININGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2566, 2862, 'FACULDADE DE DIREITO PRESIDENTE TANCREDO NEVES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2567, 2863, 'FACULDADE DE ADMINISTRACAO DE PETROLINA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2568, 2864, 'FACULDADE DE DIREITO DE PETROLINA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2569, 2865, 'FACULDADE DE CIENCIAS SOCIAIS DE RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2570, 2866, 'FACULDADE DE CIENCIAS JURIDICAS DE RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2571, 2867, 'FACULDADE DE DIREITO DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2572, 2868, 'FACULDADE DE ADMINISTRACAO DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2573, 2869, 'FACULDADE DE CIENCIAS SOCIAIS ADAO DE ALMEIDA E SILVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2574, 2870, 'FACULDADE SERRA DO CARMO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2575, 2871, 'INSTITUTO SUPERIOR DE EDUCACAO SERRA DO CARMO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2576, 2872, 'FACULDADE DE CIENCIAS AGRARIAS RENATO AZEREDO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2577, 2873, 'FACULDADE DE SISTEMAS DE INFORMACAO DE SAO SEBASTIAO DO PARAISO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2578, 2874, 'FACULDADE DE DIREITO DE SAO SEBASTIAO DO PARAISO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2579, 2875, 'FACULDADE INDIGENA DA AMAZONIA', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2580, 2876, 'FACULDADE UNISSA DE SARANDI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2581, 2877, 'FACULDADE UNISSA DE EDUCACAO TECNOLOGICA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2582, 2878, 'INSTITUTO SUPERIOR DE EDUCACAO DE CAIEIRAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2583, 2879, 'FACULDADE METROPOLITANA DE CAIEIRAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2584, 2880, 'INSTITUTO SUPERIOR DE EDUCACAO DE TIJUCUSSU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2585, 2881, 'INSTITUTO SUPERIOR DE EDUCACAO DO SENAC SP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2586, 2882, 'FACULDADE SAO JOSE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2587, 2883, 'FACULDADE EDUVALE DE PARANAPANEMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2588, 2884, 'INSTITUTO SUPERIOR DE EDUCACAO BOM JESUS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2589, 2885, 'FACULDADE SAO CAMILO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2590, 2886, 'FACULDADE ZUMBI DOS PALMARES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2591, 2887, 'FACULDADE EDUVALE DE PIRAJU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2592, 2888, 'UNIVERSIDADE DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2593, 2889, 'UNIVERSIDADE PARA O DESENVOLVIMENTO DA AMAZONIA', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2594, 2890, 'UNIVERSIDADE DE INTEGRACAO BRASILEIRA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2595, 2891, 'FACULDADE BARAO DE PIRATININGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2596, 2892, 'FACULDADE DE PALMARES FAPAL', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2597, 2893, 'INSTITUTO SUPERIOR DE EDUCACAO DOS PALMARES', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2598, 2894, 'FACULDADE INTEGRAL DE SANTA HELENA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2599, 2895, 'FACULDADE DE EDUCACAO E TECNOLOGIA DA REGIAO MISSIONEIRA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2600, 2896, 'FACULDADE SATC', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2601, 2897, 'FACULDADE JK', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2602, 2899, 'FACULDADES CAICARAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2603, 2900, 'INSTITUTO TECNOLOGICO REGIONAL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2604, 2901, 'INSTITUTO SUPERIOR DE EDUCACAO DO MEDIO NORTE MATO GROSSENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2605, 2902, 'FACULDADE DO MEDIO NORTE MATO GROSSENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2606, 2903, 'FACULDADE CONCORDIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2607, 2904, 'FACULDADE JK GUARA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2608, 2905, 'FACULDADE BRASILEIRA DE PEDAGOGIA UNIBRA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2609, 2906, 'FACULDADE NACIONAL', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2610, 2907, 'FACULDADE BRASILEIRA DE NANUQUE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2611, 2908, 'FACULDADE NATALENSE DE ENSINO E CULTURA', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2612, 2909, 'FACULDADE DO ESTADO DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2613, 2910, 'FACULDADE VERDE NORTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2614, 2911, 'FACULDADE PAN AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2615, 2912, 'FACULDADE MARIA MILZA CAMPUS FACTAE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2616, 2913, 'FACULDADE DO VALE DO PARAGUACU', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2617, 2914, 'INSTITUTO ABUCHAIM', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2618, 2915, 'FACULDADE CIDADE DE PATOS DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2619, 2916, 'INSTITUTO DE EDUCACAO SUPERIOR DE SERGIPE ISES', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2620, 2917, 'FACULDADE BRASIL NORTE', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2621, 2918, 'FACULDADE DE ENSINO SUPERIOR DA AMAZONIA REUNIDA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2622, 2919, 'FACULDADE SAO JOSE DE RIBAMAR', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2623, 2920, 'INSTITUTO DE ENSINO SUPERIOR CATTA PRETA E DIAMANTINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2624, 2921, 'INSTITUTO SUPERIOR DE EDUCACAO DA AMAZONIA REUNIDA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2625, 2922, 'INSTITUTO SUPERIOR DE EDUCACAO DE BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2626, 2923, 'FACULDADE TABIRENSE DE ENFERMAGEM', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2627, 2924, 'INSTITUTO SUPERIOR DE EDUCACAO CENECISTA DE BUTIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2628, 2925, 'INSTITUTO SUPERIOR DE EDUCACAO DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2629, 2926, 'FACULDADE BRASIL CENTRAL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2630, 2927, 'FACULDADE DEL REY', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2631, 2928, 'FACULDADE HOLISTICA DE CIENCIAS HUMANAS FHCH', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2632, 2929, 'FACULDADE DE MILAGRES CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2633, 2930, 'FACULDADE DE SARANDI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2634, 2931, 'FACULDADE RIO GRANDE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2635, 2932, 'FACULDADE PELOTENSE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2636, 2933, 'FACULDADE TIMONENSE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2637, 2934, 'FACULDADE DE ADMINISTRACAO E ECONOMIA DE JOINVILLE FAEJ', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2638, 2935, 'FACULDADE DE TALENTOS HUMANOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2639, 2936, 'INSTITUTO DE EDUCACAO SUPERIOR MARISTA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2640, 2937, 'FACULDADE METROPOLITANA DO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2641, 2938, 'FACULDADE DE EDUCACAO DE BARCARENA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2642, 2939, 'INSTITUTO SUPERIOR DE EDUCACAO TORRICELLI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2643, 2940, 'FACULDADE CENECISTA DE CACHOEIRAS DE MACACU', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2644, 2941, 'INSTITUTO SUPERIOR DE TEOLOGIA E PASTORAL DE BONFIM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2645, 2942, 'INSTITUTO SUPERIOR DE EDUCACAO FRANCISCANO NOSSA SENHORA DE FATIMA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2646, 2943, 'INSTITUTO SUPERIOR DE EDUCACAO PIRAMIDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2647, 2944, 'FACULDADE DO SUL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2648, 2945, 'FACULDADE DA ASSOCIACAO BRASILIENSE DE EDUCACAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2649, 2946, 'FACULDADE DE ARQUITETURA E URBANISMO DO DISTRITO FEDERAL FAU DF', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2650, 2947, 'FACULDADE DAS AMERICAS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2651, 2948, 'REAL FACULDADE DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2652, 2949, 'FACULDADE DO BAIXO PARNAIBA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2653, 2950, 'FACULDADE DE DESENVOLVIMENTO DO RIO GRANDE DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2654, 2951, 'INSTITUTO SUPERIOR DE EDUCACAO DE MORRO AGUDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2655, 2952, 'FACULDADES DO SUL FASUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2656, 2953, 'INSTITUTO SUPERIOR DE EDUCACAO DA CIDADE DO NATAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2657, 2954, 'FACULDADE SUL CAPIXABA UNISUL', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2658, 2955, 'FACULDADE DE CIENCIAS HUMANAS BIOLOGICAS E DA SAUDE DO LESTE MATOGROSSENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2659, 2956, 'FACULDADE DE CIENCIAS JURIDICAS SOCIAIS E TECNOLOGICA FACITE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2660, 2957, 'FACULDADE DE CIENCIAS EXATAS E AGRARIAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2661, 2958, 'FACULDADE DE CIENCIAS BIOLOGICAS HUMANAS E SAUDE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2662, 2959, 'FACULDADE DE CIENCIAS AGRARIAS E EXATAS DO LESTE MATOGROSSENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2663, 2960, 'FACULDADE SANTOS DUMONT', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2664, 2961, 'FACULDADE DO PANTANAL MATOGROSSENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2665, 2962, 'FACULDADE DE CIENCIAS SOCIAIS DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2666, 2963, 'FACULDADE DE CIENCIAS SOCIAIS DE PETROLINA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2667, 2964, 'FACULDADE PROJECAO DO GUARA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2668, 2965, 'FACULDADE MOKITI OKADA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2669, 2966, 'INSTITUTO SUPERIOR DE EDUCACAO HELIO MAGDALENA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2670, 2967, 'INSTITUTO SUPERIOR DE EDUCACAO PEDRO II', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2671, 2968, 'FACULDADE NOVA ESPERANCA DE NUTRICAO', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2672, 2969, 'INSTITUTO SUPERIOR DE EDUCACAO OCIDENTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2673, 2970, 'FACULDADE INTEGRAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2674, 2971, 'FACULDADE BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2675, 2972, 'FACULDADE CHAPADINHENSE DE EDUCACAO CIENCIAS E TECNOLOGIA FACHAP', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2676, 2973, 'FACULDADE DE CIENCIAS HUMANAS E BIOLOGICAS E DA SAUDE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2677, 2974, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS APLICADAS DE PRIMAVERA DO LESTE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2678, 2975, 'FACULDADE JK GUARA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2679, 2976, 'INSTITUTO SUPERIOR DE EDUCACAO DA FATEB', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2680, 2977, 'FACULDADES INTEGRADAS DE CIENCIAS E BIOTECNOLOGIA FICEB', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2681, 2978, 'FACUDADE DE ODONTOLOGIA MARIO DE OLIVEIRA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2682, 2979, 'FACULDADE SUL ESPIRITO SANTENSE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2683, 2980, 'FACULDADE SENAC CEARA DE ADMINISTRACAO E COMERCIO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2684, 2981, 'FACULDADE SAO VICENTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2685, 2982, 'FACULDADE VICTOR HUGO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2686, 2983, 'FACULDADE SAO VICENTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2687, 2984, 'FACULDADE ABRAHAN LINCON', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2688, 2985, 'FACULDADE MERIDIONAL DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2689, 2986, 'INSTITUTO DE FILOSOFIA E CIENCIAS HUMANAS DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2690, 2987, 'FACULDADE DE ODONTOLOGIA ALFEU GOMES DE OLIVEIRA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2691, 2988, 'INSTITUTO SUPERIOR DE EDUCACAO FENIX DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2692, 2989, 'IBESS INSTITUTO BRASILEIRO DE EDUCACAO SUED E SUSEJ LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2693, 2990, 'FACULDADES DE ADMINISTRACAO DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2694, 2991, 'FACULDADE DE SAPEACU', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2695, 2992, 'FACULDADE DO SUDESTE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2696, 2993, 'FACULDADE DE CIENCIAS BIOLOGICAS E DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2697, 2994, 'INSTITUTO SUPERIOR UNIFELI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2698, 2995, 'INSTITUTO SUPERIOR DE EDUCACAO LUTERANO DE PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2699, 2996, 'FACULDADE SOTEROPOLITANA DE DIREITO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2700, 2997, 'FACULDADE DE COMUNICACAO E INFORMACAO DO CENTRO OESTE COMUNICO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2701, 2998, 'FACULDADES SESI AMAZONAS FASESI', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2702, 2999, 'INSTITUTO SUPERIOR DE EDUCACAO CENECISTA DE RONDONOPOLIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2703, 3000, 'FACULDADE CENECISTA DE SINOP', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2704, 3001, 'FACULDADE CENECISTA DE RONDONOPOLIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2705, 3002, 'FACULDADE DE CIENCIAS DA SAUDE NOSSA SENHORA DAS MERCES DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2706, 3003, 'INSTITUTO SUPERIOR DE EDUCACAO JUSCELINO KUBITSCHEK', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2707, 3004, 'INSTITUTO DE ENSINO SUPERIOR SANTA CECILIA', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2708, 3005, 'FACULDADE SEM FRONTEIRAS FASEF', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2709, 3006, 'INSTITUTO SUPERIOR DE EDUCACAO MILTON CAMPOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2710, 3007, 'FACULDADE DO INSTITUTO NACIONAL DE POSGRADUACAO DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2711, 3008, 'FACULDADE DO INSTITUTO NACIONAL DE POSGRADUACAO DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2712, 3009, 'INSTITUTO DE ENSINO SUPERIOR APIAI ISA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2713, 3010, 'FACULDADE DE CIENCIAS HUMANAS DE RONDONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2714, 3011, 'FACULDADE PROF MIGUEL ANGELO DA SILVA SANTOS', 3, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2715, 3012, 'FAJOPA FACULDADE JOAO PAULO II', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2716, 3013, 'INSTITUTO SUPERIOR DE EDUCACAO CIDADANIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2717, 3014, 'FACULDADE DE FARMACIA DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2718, 3015, 'INSTITUTO DE EDUCACAO SUPERIOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2719, 3016, 'FACULDADE DE ENFERMAGEM JOSE RODRIGUES DA SILVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2720, 3017, 'INSTITUTO SUPERIOR DE EDUCACAO UNIPLAM', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2721, 3018, 'FACULDADE METROPOLITANA DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2722, 3019, 'INSTITUTO DE EDUCACAO SUPERIOR ANAMELIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2723, 3020, 'FACULDADE SANTA RITA DE CASSIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2724, 3021, 'INSTITUTO SUPERIOR DE EDUCACAO SANTA RITA DE CASSIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2725, 3022, 'FACULDADE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2726, 3023, 'FACULDADES INTEGRADAS ATLANTICA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2727, 3024, 'FACULDADES INTEGRADAS DE ENSINO SUPERIOR DO ESTADO DO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2728, 3025, 'INSTITUTO PRESBITERIANO DE EDUCACAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2729, 3026, 'FACULDADE DO PLANALTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2730, 3027, 'FACULDADE DE CIENCIAS EDUCACIONAIS E SISTEMAS INTEGRADOS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2731, 3028, 'FACULDADE REUNIDAS DO LITORAL DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2732, 3029, 'FACULDADE DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2733, 3030, 'INSTITUTO SUPERIOR DE EDUCACAO EDUVALE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2734, 3031, 'FACULDADE ALPHA', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2735, 3032, 'FACULDADE SANTA MARIA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2736, 3033, 'FACULDADE DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2737, 3034, 'FACULDADE DELTA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2738, 3035, 'FACULDADE BARBOSA CASTILHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2739, 3036, 'LIBERTAS INSTITUTO SUPERIOR DE CIENCIAS JURIDICAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2740, 3037, 'FACULDADE DE IBIUNA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2741, 3038, 'INSTITUTO SUPERIOR DE EDUCACAO LIONS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2742, 3039, 'FACULDADE VASCONCELLOS & SOUZA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2743, 3040, 'FACULDADE VALE DO JEQUITINHONHA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2744, 3041, 'FACULDADE FILADELFIA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2745, 3042, 'CHRISTUS FACULDADE DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2746, 3043, 'ABEU FACULDADE DE SAO JOAO DE MERITI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2747, 3044, 'ABEU FACULDADE VILAR DOS TELES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2748, 3045, 'ABEU FACULDADE DE QUEIMADOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2749, 3046, 'INSTITUTO SUPERIOR DE EDUCACAO ISE', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2750, 3047, 'FACULDADE POLIVALENTE FACIP', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2751, 3048, 'INSTITUTO SUPERIOR DE EDUCACAO DO INSTITUTO PORTO ALEGRE DA IGREJA METODISTA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2752, 3049, 'INSTITUTO ODONTOLOGICO DO PARANA ODONS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2753, 3050, 'FACULDADE DE TEOLOGIA DA ASSEMBLEIA DE DEUS FATEAD', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2754, 3051, 'FACULDADE TEOLOGICA DE CIENCIAS HUMANAS E SOCIAIS LOGOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2755, 3052, 'FACULDADE EDUCARE', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2756, 3053, 'FACULDADE DE ODONTOLOGIA PRO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2757, 3054, 'FACULDADE DE CIENCIAS E TECNOLOGIA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2758, 3055, 'INSTITUTO SUPERIOR DE EDUCACAO DE RONDONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2759, 3056, 'ESCOLA SUPERIOR OSWALDO CRUZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2760, 3057, 'INSTITUTO DE ENSINO SUPERIOR SAGRADA FAMILIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2761, 3058, 'INSTITUTO SUPERIOR DE EDUCACAO SAGRADA FAMILIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2762, 3059, 'INSTITUTO DE ENSINO SUPERIOR DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2763, 3060, 'INSTITUTO DE ENSINO SUPERIOR DE ARAUCARIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2764, 3061, 'INSTITUTO SUPERIOR DE EDUCACAO DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2765, 3062, 'FACULDADE COMERCIAL DE SERRINHA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2766, 3063, 'FAECO FACULDADE EDUCACIONAL COSTA OESTE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2767, 3064, 'FACULDADE DE CIENCIAS EXATAS E AGRARIAS DE RORAIMA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2768, 3065, 'INSTITUTO SUPERIOR DE EDUCACAO DE ARAUCARIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2769, 3066, 'FACULDADE INTERAMERICANA DE BELEM', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2770, 3067, 'FACULDADE ROTHSCHILD DE EDUCACAO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2771, 3068, 'FACULDADE DE TEOLOGIA E CIENCIAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2772, 3069, 'INSTITUTO DE EDUCACAO SUPERIOR DE ALAGOAS NO LITORAL NORTE', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2773, 3070, 'FACULDADE DE BELA VISTA DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2774, 3071, 'INSTITUTO DE EDUCACAO SUPERIOR UNYAHNA DE SERRINHA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2775, 3072, 'INSTITUTO DE EDUCACAO SUPERIOR UNYAHNA DE JACOBINA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2776, 3073, 'INSTITUTO DE EDUCACAO SUPERIOR UNYAHNA DE CRUZ DAS ALMAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2777, 3074, 'FACULDADE DO EXTREMO SUL DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2778, 3075, 'INSTITUTO DE EDUCACAO SUPERIOR UNYAHNA DE ALAGOINHAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2779, 3076, 'FACULDADE DE SAUDE IPITANGA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2780, 3077, 'FACULDADE METROPOLITANA DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2781, 3078, 'INSTITUTO SUPERIOR DE EDUCACAO FRUTALENSE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2782, 3079, 'INSTITUTO DE ENSINO SUPERIOR ALTERNATIVO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2783, 3080, 'FACULDADE DE ARTE E DESIGN BERLIM BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2784, 3081, 'FACULDADE ITALIANA DE TECNOLOGIA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2785, 3082, 'FACULDADE 2 DE JULHO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2786, 3083, 'FACULDADE INTEGRADA UNIVERACRUZ DE GUANAMBI', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2787, 3084, 'FACULDADE MARQUES DE POMBAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2788, 3085, 'FACULDADE EVANGELICA LUZ E VIDA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2789, 3086, 'FACULDADE DA MODA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2790, 3087, 'CHRISTUS INSTITUTO SUPERIOR DE EDUCACAO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2791, 3088, 'FACULDADE UNIDAS SUL BAHIA FUSBA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2792, 3089, 'FACULDADE CAICARAS DE TAGUATINGA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2793, 3090, 'INSTITUTO SUPERIOR NORMAL AURELINA PALMEIRA', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2794, 3091, 'CENTRO DE ENSINO LEIDE TORRES', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2795, 3092, 'FACULDADE DE BEM ESTAR SOCIAL E SAUDE DE ITAPECERICA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2796, 3093, 'FACULDADE DE ENFERMAGEM JOAO FRANCISCO DA SILVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2797, 3094, 'FACULDADE DE DIREITO DESEMBARGADOR AFFONSO TEIXEIRA LAGES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2798, 3095, 'FACULDADE DE CIENCIAS AGRARIAS DOM ORIONE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2799, 3096, 'FACULDADE DE AGRONOMIA MANOEL ANTONIO DA SILVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2800, 3097, 'FACULDADE DE DIREITO AFONSO PENA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2801, 3098, 'INSTITUTO SUPERIOR DE EDUCACAO SAO JUDAS TADEU', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2802, 3099, 'FACULDADE INTERNACIONAL DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2803, 3100, 'FACULDADE INTEGRADA UNIVERACRUZ DE BOM JESUS DA LAPA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2804, 3101, 'FACULDADE INTEGRADA UNIVERACRUZ DE ALAGOINHAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2805, 3102, 'FACULDADE INTEGRADA UNIVERACRUZ DE CAMPO FORMOSO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2806, 3103, 'FACULDADE INTEGRADA UNIVERACRUZ DE BRUMADO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2807, 3104, 'FACULDADE INTEGRADA UNIVERACRUZ DE JEQUIE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2808, 3105, 'FACULDADE INTEGRADA UNIVERACRUZ DE JACOBINA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2809, 3106, 'FACULDADE INTEGRADA UNIVERACRUZ DE ITAMARAJU', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2810, 3107, 'FACULDADE BENEMERITA EDUCADORA UNIVERACRUZ DE PAULO AFONSO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2811, 3108, 'FACULDADE INTEGRADA UNIVERACRUZ DE ITABUNA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2812, 3109, 'FACULDADE ITEGRADA UNIVERACRUZ DE VALENCA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2813, 3110, 'FACULDADE ITEGRADA UNIVERACRUZ DE CAMACARI', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2814, 3111, 'FACULDADE INTEGRADA UNIVERACRUZ DE BARREIRAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2815, 3112, 'FACULDADE INTEGRADA UNIVERACRUZ DE RIBEIRA DO POMBAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2816, 3113, 'FACULDADE INTEGRADA UNIVERACRUZ DE PILAO ARCADO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2817, 3114, 'FACULDADE INTEGRADA UNIVERACRUZ DE VITORIA DA CONQUISTA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2818, 3115, 'INSTITUTO SUPERIOR DE EDUCACAO SANTO AGOSTINHO DE PIRAPORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2819, 3116, 'FACULDADE SANTO AGOSTINHO DE PIRAPORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2820, 3117, 'FACULDADE DE SAUDE E DESENVOLVIMENTO HUMANO SANTO AGOSTINHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2821, 3118, 'FALCUDADE INTEGRADA UNIVERACRUZ DE BARRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2822, 3119, 'FACULDADE INTEGRADA UNIVERACRUZ DE DIAS D AVILA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2823, 3120, 'FACULDADE INTEGRADA UNIVERACRUZ DE CANDEIAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2824, 3121, 'FACULDADE INTEGRADA UNIVERACRUZ DE SERRINHA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2825, 3122, 'FACULDADE INTEGRADA UNIVERACRUZ SIMOES FILHO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2826, 3123, 'FACULDADE INTEGRADA UNIVERACRUZ DE SANTA MARIA DA VITORIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2827, 3124, 'FACULDADE DO DISTRITO FEDERAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2828, 3125, 'FACULDADE INTEGRADA UNIVERACRUZ DE PORTO SEGURO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2829, 3126, 'FACULDADE INTEGRADA UNIVERACRUZ DE SENHOR DO BONFIM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2830, 3127, 'FACULDADE INTEGRADA UNIVERACRUZ DE IRECE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2831, 3128, 'FACULDADE INTEGRADA UNIVERACRUZ DE LAURO DE FREITAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2832, 3129, 'FACULDADE INTEGRADA UNIVERACRUZ DE ILHEUS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2833, 3130, 'FACULDADE INTEGRADA UNIVERACRUZ DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2834, 3131, 'FACULDADE INTEGRADA UNIVERACRUZ DE EUNAPOLIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2835, 3132, 'FACULDADE INEGRADA UNIVERACRUZ DE EUCLIDES DA CUNHA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2836, 3133, 'FACULDADE INTEGRADA UNIVERACRUZ DE JUAZEIRO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2837, 3134, 'FACULDADE INTEGRADA UNIVERACRUZ DE ITABERABA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2838, 3135, 'FACULDADE INTEGRADA UNIVERACRUZ DE TEIXEIRA DE FREITAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2839, 3136, 'FACULDADES INTEGRADA UNIVERACRUZ DE IPIRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2840, 3137, 'FACULDADE INTEGRADA UNIVERACRUZ DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2841, 3138, 'FACULDADE DINAMICA DE ITAIPULANDIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2842, 3139, 'INSTITUTO DE SUPERIOR DE EDUCACAO FRANCISCO AGUIAR', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2843, 3140, 'FACULDADE ZEUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2844, 3141, 'FACVALE FACULDADE DO VALE DO JACUIPE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2845, 3142, 'INSTITUTO SUPERIOR DE EDUCACAO EDEM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2846, 3143, 'FACULDADE DO VAREJO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2847, 3144, 'FACULDADE AGUAS LINDAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2848, 3145, 'FACULDADE DE DIREITO SAO JUDAS TADEU DE PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2849, 3146, 'FACULDADE DE ODONTOLOGIA DO RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2850, 3147, 'FACULDADE DE DIREITO DE PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2851, 3148, 'FACULDADE ANCHIETA DO RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2852, 3149, 'FACULDADE PITAGORAS DE DIVINOPOLIS FPD', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2853, 3150, 'INSTITUTO SUPERIOR DE EDUCACAO DA FACULDADE DE CIENCIAS E LETRAS DE ARARAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2854, 3151, 'UNIVERSIDADE COMUNITARIA DA REGIAO DE CHAPECO', 3, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2855, 3152, 'INSTITUTO SUPERIOR DE EDUCACAO SANTA RITA DO SAPUCAI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2856, 3153, 'INSTITUTO SUPERIOR DE EDUCACAO CANTAREIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2857, 3154, 'FACULDADE DE TECNOLOGIA SENAI RIO DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2858, 3155, 'FACULDADE DE TECNOLOGIA SENAI JARAGUA DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2859, 3156, 'FACULDADE DE TECNOLOGIA SENAI BRUSQUE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2860, 3157, 'INSTITUTO SUPERIOR DE EDUCACAO ALMEIDA RODRIGUES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2861, 3158, 'INSTITUTO SUPERIOR DE EDUCACAO ANGLOAMERICANO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2862, 3159, 'FACULDADE DE TECNOLOGIA SENAI FLORIANOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2863, 3160, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE ALAGOAS', 1, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2864, 3161, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO SERTAO PERNAMBUCANO', 1, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2865, 3162, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE SANTA CATARINA', 1, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2866, 3163, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO RIO DE JANEIRO', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2867, 3164, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE MATO GROSSO', 1, 1, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2868, 3165, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO TRIANGULO MINEIRO', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2869, 3166, 'INSTITUTO SUPERIOR DE EDUCACAO DE IBIUNA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2870, 3167, 'FACULDADE DE TECNOLOGIA ESTACIO DE SA DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2871, 3168, 'FACULDADE DE TECNOLOGIA ESTACIO DE SA DE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2872, 3169, 'FACULDADE DE TECNOLOGIA IBTA CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2873, 3170, 'FACULDADES INTEGRADAS ASSOCIACAO DE ENSINO DE SANTA CATARINA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2874, 3171, 'FACULDADE EQUIPE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2875, 3172, 'UNIVERSIDADE DO ESTADO DO AMAZONAS', 2, 1, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2876, 3173, 'FACULDADE DE TECNOLOGIA DO COMERCIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2877, 3174, 'INSTITUTO SUPERIOR DE EDUCACAO DE VINHEDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2878, 3175, 'INSTITUTO SUPERIOR DE EDUCACAO DE TAQUARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2879, 3176, 'INSTITUTO SUPERIOR DE EDUCACAO EQUIPE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2880, 3177, 'FACULDADE DE ADMINISTRACAO DA FESPSP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2881, 3178, 'INSTITUTO DE EDUCACAO SUPERIOR DE BARUERI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2882, 3179, 'FACULDADE DA CIDADE DE SAO GONCALO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2883, 3180, 'INSTITUTO SUPERIOR DE EDUCACAO UNIAO DAS AMERICAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2884, 3181, 'FACULDADE DE DIREITO DE BOA VISTA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2885, 3182, 'CENTRO DE ENSINO SUPERIOR ARCANJO MIKAEL DE ARAPIRACA', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2886, 3183, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE SERGIPE', 1, 1, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2887, 3184, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE RORAIMA', 1, 1, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2888, 3185, 'CENTRO FEDERAL DE EDUCACAO TECNOLOGICA DE SAO VICENTE DO SUL', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2889, 3186, 'FACULDADE DE SAO ROQUE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2890, 3187, 'INSTITUTO SUPERIOR DE EDUCACAO CORACAO DE JESUS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2891, 3188, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO NORTE DE MINAS GERAIS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2892, 3189, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE MINAS GERAIS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2893, 3190, 'INSTITUTO SUPERIOR DE EDUCACAO DE GARCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2894, 3191, 'INSTITUTO SUPERIOR DE EDUCACAO DE SANTA CATARINA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2895, 3192, 'INSTITUTO SUPERIOR DE EDUCACAO DE CAJAZEIRAS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2896, 3193, 'FACULDADES INTEGRADAS DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2897, 3194, 'FACULDADE DE MINAS BH', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2898, 3195, 'FACULDADE VILA RICA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2899, 3196, 'FACULDADE PONTES E LACERDA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2900, 3197, 'FACULDADES DO PARECIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2901, 3198, 'FACULDADE DE CIENCIAS HUMANAS DE IVAIPORA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2902, 3199, 'FANESF FACULDADE NACIONAL DE ENSINO SUPERIOR DA FAZENDA RIO GRANDE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2903, 3200, 'FANPINHAIS FACULDADE NACIONAL DE PINHAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2904, 3201, 'FACULDADE DE EDUCACAO E ENSINO SUPERIOR DO ABRANCHES', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2905, 3202, 'FACULDADES AUGUSTUS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2906, 3203, 'INSTITUTO SUPERIOR DE EDUCACAO ALBERT EINSTEIN', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2907, 3204, 'FACULDADE DE QUATRO MARCOS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2908, 3205, 'FACULDADE DE CIENCIAS BIOLOGICAS E DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2909, 3206, 'INSTITUTO DO SABER', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2910, 3207, 'FACULDADES DE CAFELANDIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2911, 3208, 'FACULDADE AMERICA DO SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2912, 3209, 'FACULDADE DE ARACATUBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2913, 3210, 'INSTITUTO EDUCACIONAL EVANGELICO DE ARAPONGAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2914, 3211, 'FACDIPAR FACULDADE DE DIREITO DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2915, 3212, 'INSTITUTO SUPERIOR DE FILOSOFIA BERTHIER', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2917, 3214, 'FACULDADE EUROPEU DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2918, 3215, 'FACULDADE ENTRE RIOS DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2919, 3216, 'FACULDADE DE CIENCIAS DA BAHIA FACIBA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2920, 3217, 'FACULDADE DE ENSINO SUPERIOR DO BRASIL', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2921, 3218, 'FACULDADE DE CIENCIAS DA SAUDE DE PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2922, 3219, 'FACULDADE EVANGELICA DE INDAIATUBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2923, 3220, 'INSTITUTO NACIONAL DE EDUCACAO SUPERIOR DE EDUCACAO E CULTURA INESC', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2924, 3221, 'FACULDADE DE ODONTOLOGIA DE MACAPA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2925, 3222, 'FACULDADE DE ODONTOLOGIA DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2926, 3223, 'ESCOLA SUPERIOR DE CIENCIAS DA SAUDE', 2, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2927, 3224, 'FACULDADE DE FARMACIA E BIOQUIMICA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2928, 3225, 'FACULDADE DE ENFERMAGEM', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2929, 3226, 'FACULDADE DE MEDICINA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2930, 3227, 'FACULDADE DE SISTEMA DE INFORMACAO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2931, 3228, 'FACULDADE DE ADMINISTRACAO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2932, 3229, 'FACULDADE DE TURISMO DE DUQUE DE CAXIAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2933, 3230, 'FACULDADE LUIZ EDUARDO MAGALHAES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2934, 3231, 'INSTITUTO SUPERIOR DE EDUCACAO PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2935, 3232, 'FACULDADE IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2936, 3233, 'FACULDADE AMERICA DO SUL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2937, 3234, 'URN FACULDADE DE ALAGOINHAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2938, 3235, 'INSTITUTO SUPERIOR DE EDUCACAO JOAO PAULO PRIMEIRO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2939, 3236, 'INSITUTO DE TEOLOGIA DA DIOCESE DE SANTO ANDRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2940, 3237, 'FACULDADE SENAC DE ADMINISTRACAO E NEGOCIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2941, 3238, 'FACULDADE DE ODONTOLOGIA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2942, 3239, 'INSTITUTO DE DESENVOLVIMENTO EDUCACIONAL SUL CATARINENSE S C LTDA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2943, 3240, 'INSTITUTO SUPERIOR DE EDUCACAO DE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2944, 3241, 'FACULDADE NACIONAL DE EDUCACAO E ENSINO SUPERIOR DO BRASIL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2945, 3242, 'FACULDADE DE TECNOLOGIA E GESTAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2946, 3243, 'FACULDADE NACIONAL CAMPO LARGO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2947, 3244, 'FACULDADE DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2948, 3245, 'FACULDADE DE SENADOR CANEDO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2949, 3246, 'FACULDADE DE LINHARES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2950, 3247, 'FACULDADE VITORIA DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2951, 3248, 'FACULDADE DE DOMINGOS MARTINS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2952, 3249, 'FACULDADE PADRAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2953, 3250, 'FACULDADE DE MORRINHOS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2954, 3251, 'FACULDADE DE VILA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2955, 3252, 'FACULDADE QUIRINOPOLIS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2956, 3253, 'FACULDADE COSTA ESMERALDA ITAPEMA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2957, 3254, 'FACULDADE DE EDUCACAO E TEOLOGIA VIVA FATEV', 1, 1, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2958, 3255, 'FACULDADE INPG', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2959, 3256, 'INSTITUTO SUPERIOR DE ECOLOGIA HUMANA E DESENVOLVIMENTO SUSTENTAVEL ISEDS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2960, 3257, 'FAESSF FACULDADE DE ENSINO SUPERIOR SANTA FELICIDADE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2961, 3258, 'FACULDADE DE DIREITO DE RESENDE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2962, 3259, 'FACULDADES DO ICESP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2963, 3260, 'FACULDADE PRINCESA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2964, 3261, 'FACULDADE DE EDUCACAO E ENSINO SUPERIOR INTEGRAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2965, 3262, 'FACULDADE DOM BOSCO DE GUARANIACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2966, 3263, 'FACULDADE YVERDUN BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2967, 3265, 'FACULDADE BATISTA IDA NELSON', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2968, 3266, 'UNIDADE VOCACIONAL CIDADES UVC', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2969, 3267, 'FACULDADE TADEU ARGOLO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2970, 3268, 'FACULDADE MADRE THAIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2971, 3269, 'FACULDADE DE JUAZEIRO DO NORTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2972, 3270, 'FACULDADE SAO BENTO DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2973, 3271, 'FACULDADE QUASAR', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2974, 3272, 'FACULDADE DE DIREITO DE PETROLINA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2975, 3273, 'FACULDADE DO RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2976, 3274, 'FACULDADE PSICOLOGIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2977, 3275, 'FACULDADE JURIDICA DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2978, 3276, 'FACULDADE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2979, 3277, 'FACULDADE DE TECNOLOGIA PREVE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2980, 3278, 'FACULDADE DE TECNOLOGIA MARTINUS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2981, 3279, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO SUDESTE DE MINAS GERAIS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2982, 3280, 'FACULDADE SAO JOSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2983, 3281, 'FACULDADE DO DESENVOLVIMENTO DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2984, 3282, 'FACULDADE PONTAL DO PARANAPANEMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2985, 3283, 'INSTITUTO BRASILEIRO DE ZOOTECNOLOGIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2986, 3284, 'ESCOLA SUPERIOR DE ADMINISTRACAO E NEGOCIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2987, 3285, 'FACULDADE SANTO ANTONIO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2988, 3286, 'FACULDADE DE MARABA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2989, 3287, 'FACULDADE DA ASSEDIPA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2990, 3288, 'FACULDADE GENESIS FAGEN', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2991, 3289, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS E CONTABEIS COSTA BRAGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2992, 3290, 'INSTITUTO SUPERIOR DE EDUCACAO DOS INCONFIDENTES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2993, 3291, 'FACULDADE DUARTE COELHO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2994, 3292, 'INSTITUTO SUPERIOR DE EDUCACAO DE CAETE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2995, 3293, 'FACULDADE DE TECNOLOGIA DIAMANTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2996, 3294, 'FACULDADE DE TECNOLOGIA ENIACFAPI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2997, 3295, 'FACULDADE DE TECNOLOGIA SENAC FLORIANOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2998, 3296, 'FACULDADE DE TECNOLOGIA SENAC RIO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (2999, 3297, 'CENTRO DE EDUCACAO TECNOLOGICA CHRISTUS', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3000, 3298, 'FACULDADE DE TECNOLOGIA CAMOES', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3001, 3299, 'FACULDADE DE TECNOLOGIA INFORMATICA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3002, 3300, 'FACULDADE DE TECNOLOGIA MICHEL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3003, 3301, 'FACULDADE DE TECNOLOGIA MAGISTER', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3004, 3302, 'FACULDADE DE JUNQUEIROPOLIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3005, 3303, 'FACULDADES INTEGRADAS MATOGROSSENSES DE CIENCIAS SOCIAIS E HUMANAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3006, 3304, 'FACULDADES INTEGRADAS DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3007, 3305, 'FACULDADE PITAGORAS DE PSICOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3008, 3306, 'FACULDADE DE TECNOLOGIA IPUC', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3009, 3307, 'FACULDADE INED DE RIO CLARO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3010, 3308, 'FACULDADE DE TECNOLOGIA TERMOMECANICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3011, 3309, 'FACULDADE DE TECNOLOGIA INTERNACIONAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3012, 3310, 'FACULDADE DE TECNOLOGIA DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3013, 3311, 'FACULDADE DE TECNOLOGIA SAO FRANCISCO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3014, 3312, 'CENTRO FEDERAL DE EDUCACAO TECNOLOGICA DE RIO VERDE', 1, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3015, 3313, 'CENTRO FEDERAL DE EDUCACAO TECNOLOGICA DE BAMBUI', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3016, 3314, 'FACULDADE DE CIENCIAS GERENCIAIS DA FUNCEC', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3017, 3315, 'INSTITUTO SUPERIOR DE EDUCACAO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3018, 3316, 'FACULDADE SUDOESTE PAULISTANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3019, 3317, 'FACULDADE MASTER', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3020, 3318, 'FACULDADE MASTER', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3021, 3319, 'FACULDADE DE ENSINO SUPERIOR DE CATALAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3022, 3320, 'INSTITUTO DE TELEMARKETING E SERVICO AO CLIENTE LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3023, 3321, 'FACIVALE FACULDADE INTERNACIONAL DO VALE DO IVAI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3024, 3322, 'FACULDADE POLITECNICA DE ATIBAIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3025, 3323, 'INSTITUTO DE EDUCACAO E ENSINO SUPERIOR DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3026, 3324, 'FACULDADE TALENTI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3027, 3325, 'FACULDADE COMUNITARIA DE CONTAGEM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3028, 3326, 'CENTRO SUPERIOR DE ESTUDOS JURIDICOS CARLOS DRUMMOND DE ANDRADE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3029, 3327, 'UNIPONTE FACULDADE DA MEIA PONTE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3030, 3328, 'CENTRO DE ESTUDOS SUPERIORES EM CIENCIAS DA SAUDE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3031, 3329, 'FACULDADE DE DIREITO DE PARA DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3032, 3330, 'INSTITUTO DE LINGUA PORTUGUESA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3033, 3331, 'FAMOL FACULDADE MONTEIRO LOBATO', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3034, 3332, 'FACULDADE DE TECNOLOGIA SENAC RIO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3035, 3333, 'FACULDADE DE TECNOLOGIA TECBRASIL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3036, 3334, 'FACULDADE DE TECNOLOGIA SAO GONCALO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3037, 3335, 'FACULDADE DE CIENCIAS E LETRAS DO NOROESTE DO PARANA FACIP', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3038, 3336, 'UNIVERSIDADE ESTADUAL DO RIO GRANDE DO SUL', 2, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3039, 3337, 'FACULDADE DE TECNOLOGIA DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3040, 3338, 'INSTITUTO SUPERIOR DE EDUCACAO GETULIO VARGAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3041, 3339, 'FACULDADE DE GETULIO VARGAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3042, 3340, 'FACULDADE DE PAULISTA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3043, 3341, 'FACULDADES DE ALTO ARAGUAIA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3044, 3342, 'FACULDADE EVANGELICA DE CIENCIA FILOSOFICA E TEOLOGICA DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3045, 3343, 'FACULDADES DO PARECIS FACCIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3046, 3344, 'FACULDADE REGIONAL DE IRECE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3047, 3345, 'FACULDADE YVERDON DE GOIANIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3048, 3346, 'FACULDADE YVERDON', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3049, 3347, 'FACULDADE REGIONAL DE RIBEIRA DO POMBAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3050, 3348, 'FACULDADE REGIONAL DE SERRINHA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3051, 3349, 'FACULDADE REGIONAL METROPOLITANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3052, 3350, 'FACULDADE REGIONAL DE ALAGOINHAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3053, 3351, 'INSTITUTO SUPERIOR DO NOROESTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3054, 3352, 'FACULDADE REGIONAL DE SANTO AMARO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3055, 3353, 'FACULDADE RECON BAHIA EMPRESARIAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3056, 3354, 'FACULDADE REGIONAL DE ILHEUS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3057, 3355, 'FACULDADE REGIONAL DE SAO FELIX', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3058, 3356, 'INSTITUTO TEOLOGICO DE SANTA CATARINA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3059, 3357, 'FACULDADE DO SERTAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3060, 3358, 'FACULDADE CIENTIFICA DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3061, 3359, 'FESC FACULDADE DO EXTREMO SUL CATARINENSE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3062, 3360, 'INSTITUTO DE EDUCACAO SUPERIOR PRESIDENTE KENNEDY CENTRO DE FORMACAO DE PROFISSIONAIS DE EDUCACAO', 2, 1, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3063, 3361, 'INSTITUTO SUPERIOR DE EDUCACAO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3064, 3362, 'INSTITUTO DE CIENCIAS HUMANAS E SOCIAIS APLICADAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3065, 3363, 'FACULDADE GUARAI', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3066, 3364, 'FACULDADE DE ENFERMAGEM DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3067, 3365, 'FACULDADE SAO FRANCISCO DE JUAZEIRO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3068, 3366, 'FACULDADE DE CIENCIAS GERENCIAIS DE OLIVEIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3069, 3367, 'INSTITUTO SUPERIOR DE EDUCACAO DE OLIVEIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3070, 3368, 'CENTRO UNIVERSITARIO DO SUL DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3071, 3369, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS GEREMARIO DANTAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3072, 3370, 'ESCOLA DOMINICANA DE TEOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3073, 3371, 'CENTRO UNIVERSITARIO DE PATOS DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3074, 3372, 'CENTRO UNIVERSITARIO DE LAVRAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3075, 3373, 'INSTITUTO SUPERIOR DE EDUCACAO DE FORMIGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3076, 3374, 'FACULDADE PAUL SABATIER DE EDUCACAO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3077, 3375, 'INSTITUTO DE ENSINO SUPERIOR MULTIPLO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3078, 3376, 'FACULDADE DE TEOLOGIA INTEGRADA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3079, 3377, 'FACULDADE MONTESSORIANO DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3080, 3378, 'FACULDADE CENECISTA DE RECIFE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3081, 3379, 'INSTITUTO DE EDUCACAO SUPERIOR SERRANO IESSER', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3082, 3380, 'FACULDADE MISSIONEIRA DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3083, 3381, 'UNITEC FACULDADE TECNOLOGICA E CIENTIFICA DE UNAI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3084, 3382, 'ESCOLA SUPERIOR DE ENFERMAGEM E PEDAGOGIA MARIA PASTOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3085, 3383, 'INSTITUTO SUPERIOR DE EDUCACAO SAGRA ISAGRA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3086, 3384, 'FACULDADE SAGRA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3087, 3385, 'FACULDADE DE DIREITO PROFESSOR PEDRO ALEIXO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3088, 3386, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS UNITECH', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3089, 3387, 'FACULDADE NACIONAL DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3090, 3388, 'FACULDADE PARAISO DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3091, 3389, 'FACULDADE RAIZES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3092, 3390, 'FACULDADE DE DIREITO DO ICESP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3093, 3391, 'INSTITUTO SUPERIOR DE EDUCACAO NOVA VIDA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3094, 3392, 'FACULDADE DA ACADEMIA BRASILEIRA DE EDUCACAO E CULTURA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3095, 3393, 'FACULDADE DE ENSINO SUPERIOR DOM BOSCO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3096, 3394, 'FACULDADE VALE DO IPIRANGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3097, 3395, 'FACULDADE EDUCIONAL SUL PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3098, 3396, 'FACULDADE LS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3099, 3397, 'FACULDADE BOAS NOVAS DE CIENCIAS TEOLOGICAS, SOCIAIS E BIOTECNOLOGICAS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3100, 3398, 'FACULDADE DE CIENCIAS DO ESTADO DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3101, 3399, 'FACULDADE DE TUBARAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3102, 3400, 'FACULDADE DE SAUDE DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3103, 3401, 'FACULDADE DE ITAPECERICA DA SERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3104, 3402, 'FACULDADE ANGLICANA DE NEGOCIOS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3105, 3403, 'INSTITUTO SUPERIOR DE EDUCACAO RUI BARBOSA ISURB', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3106, 3404, 'FACULDADE DE FILOSOFIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3107, 3405, 'FACULDADE RUI BARBOSA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3108, 3406, 'FACULDADE CANDIDO RONDON', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3109, 3407, 'IESEMA INSTITUTO SUPERIOR DE EDUCACAO DA MATA ALAGOANA', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3110, 3408, 'FACULDADE AMAZONIA DE RORAIMA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3111, 3409, 'FACULDADE DE CIENCIAS DA SAUDE CRISTO REI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3112, 3410, 'INSTITUTO DE EDUCACAO SUPERIOR FATEV', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3113, 3411, 'FACULDADE ECA DE QUEIROS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3114, 3412, 'FACULDADE DO INTERIOR PAULISTA DE TANABI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3115, 3413, 'ISEMP INSTITUTO SUPERIOR DE EDUCACAO DA MATA PERNAMBUCANA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3116, 3414, 'FACULDADE DO ENTORNO DE BRASILIA FAEB', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3117, 3415, 'FACULDADE DE TECNOLOGIA DE CAXIAS DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3118, 3416, 'FACULDADE JK DO GAMA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3119, 3417, 'FACULDADE DO CENTRO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3120, 3418, 'FACULDADE VALE DO CARIRI', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3121, 3419, 'FACULDADE CHROMOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3122, 3420, 'INSTITUTO SUPERIOR DE EDUCACAO DE CAMPOS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3123, 3421, 'FACULDADE DE MANDAGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3124, 3422, 'FACULDADE TEOLOGICA DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3125, 3423, 'FACULDADE DE ADMINISTRACAO DE NOVO PROGRESSO', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3126, 3424, 'FACULDADE DE LAGES', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3127, 3425, 'FACETE FACULDADE DE ARTES CIENCIAS E TECNOLOGIAS DE EUNAPOLIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3128, 3426, 'ESCOLA SUPERIOR DE CIENCIAS TRADICIONAIS E AMBIENTAIS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3129, 3427, 'FACULDADE JOSE AUGUSTO VIEIRA', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3130, 3428, 'FACULDADE ALFA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3131, 3429, 'FACULDADE RIO DAS CONTAS FAC RIO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3132, 3430, 'FACULDADE UBERLANDENSE DE NUCLEOS INTEGRADOS DE ENSINO, SERVICO SOCIAL E APRENDIZAGEM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3133, 3431, 'FACULDADE DO SERIDO', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3134, 3432, 'FACULDADES INTEGRADAS DE CIENCIAS HUMANAS, SAUDE E EDUCACAO DE GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3135, 3433, 'INSTITUTO SUPERIOR DE EDUCACAO INTERLAGOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3136, 3434, 'FACULDADE DE SAUDE IBITURUNA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3137, 3435, 'INSTITUTO SUPERIOR DE EDUCACAO NORTE MINEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3138, 3436, 'FACULDADE DE ARARAQUARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3139, 3437, 'FACULDADE DO LITORAL CATARINENSE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3140, 3438, 'FACULDADE MASTER DE PALMAS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3141, 3439, 'FACULDADE MASTER DE PARAUAPEBAS', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3142, 3440, 'FACULDADE MASTER DE SANTAREM', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3143, 3441, 'FACULDADE MASTER DE MARABA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3144, 3442, 'INSTITUTO DE ENSINO ALVARES DE AZEVEDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3145, 3443, 'FACULDADE INEDI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3146, 3444, 'FACULDADE DE CIENCIAS BIOLOGICAS E SOCIAIS APLICADAS JEFFERSON JORGE SALOMAO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3147, 3445, 'FACULDADE JOAO DO VALE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3148, 3446, 'INSTITUTO SUPERIOR DE EDUCACAO JOAO DO VALE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3149, 3447, 'FACULDADES SANTAMARIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3150, 3448, 'INSTITUTO SUPERIOR DE EDUCACAO IBITURUNA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3151, 3449, 'TRECSON FACULDADE DE CIENCIAS SOCIAIS APLICADAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3152, 3450, 'FACULDADES MASTER', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3153, 3451, 'INSTITUTO SUPERIOR DE EDUCACAO DO LITORAL CATARINENSE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3154, 3453, 'FACULDADE JUSCELINO KUBTSCHEK GUARA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3155, 3454, 'FACULDADES LEONEL AGUIAR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3156, 3455, 'FACULDADE DE EDUCACAO EXPOVEST', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3157, 3456, 'FACULDADE POLITECNICA DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3158, 3457, 'FESC FACULDADE DO EXTREMO SUL CATARINENSE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3159, 3458, 'ACADEMIA TEOLOGICA DA GRACA DE DEUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3160, 3459, 'INSTITUTO DE ENSINO SUPERIOR E PESQUISA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3161, 3460, 'INSTITUTO SUPERIOR DE ENSINO E PESQUISA DE ITUIUTABA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3162, 3461, 'FACULDADE DE FILOSOFIA DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3163, 3462, 'FACULDADE DE ENFERMAGEM DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3164, 3463, 'FACULDADE DE DIREITO DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3165, 3464, 'FACULDADE DE ENGENHARIA DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3166, 3465, 'FACULDADE DE INFORMATICA DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3167, 3466, 'FACULDADE DE SERVICO SOCIAL DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3168, 3467, 'FACULDADE DE NUTRICAO DA FUNDACAO DE ENSINO SUPERIOR DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3169, 3468, 'FACULDADE DE ENGENHARIA DO TRIANGULO MINEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3170, 3469, 'FACULDADE DE ADMINISTRACAO DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3171, 3470, 'FACULDADE EDUCACAO FISICA DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3172, 3471, 'FACULDADE DE MODA DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3173, 3472, 'INSTITUTO SUPERIOR DE EDUCACAO DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3174, 3473, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE CARANGOLA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3175, 3474, 'FACULDADE DE CIENCIAS EXATAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3176, 3475, 'INSTITUTO SUPERIOR DE EDUCACAO DE CARANGOLA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3177, 3476, 'FACULDADE DE FILOSOFIA E LETRAS DE DIAMANTINA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3178, 3477, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS NOSSA SENHORA DE SION', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3179, 3478, 'FACULDADE DE CIENCIAS EXATAS E HUMANAS DA CAMPANHA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3180, 3479, 'INSTITUTO SUPERIOR DE EDUCACAO NOSSA SENHORA DE SION', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3181, 3480, 'FACULDADE DE CIENCIAS JURIDICAS DE DIAMANTINA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3182, 3481, 'INSTITUTO SUPERIOR DE EDUCACAO DE DIAMANTINA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3183, 3482, 'INSTITUTO SUPERIOR DE EDUCACAO DE DIVINOPOLIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3184, 3483, 'INSTITUTO SUPERIOR DE EDUCACAO DE CLAUDIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3185, 3484, 'FACULDADE DE CIENCIAS GERENCIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3186, 3485, 'INSTITUTO SUPERIOR DE EDUCACAO DO ALTO SAO FRANCISCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3187, 3486, 'INSTITUTO SUPERIOR DE EDUCACAO DE ITUIUTABA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3188, 3487, 'FACULDADE SENACRS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3189, 3488, 'CENTRO DE ENSINO SUPERIOR DE CONSELHEIRO LAFAIETE', 3, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3190, 3489, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE CONSELHEIRO LAFAIETE', 3, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3191, 3490, 'FACULDADE DE ENGENHARIA ELETRICA DE CONSELHEIRO LAFAIETE', 3, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3192, 3491, 'FACULDADE EVANGELICA DO BRASIL FAEB', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3193, 3492, 'FACULDADE DE DIREITO DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3194, 3493, 'FACULDADE PROJETO DIDATICO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3195, 3494, 'FACULDADE GUAJARAENSE DE EDUCACAO E CULTURA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3196, 3495, 'FACULDADE PINHALZINHO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3197, 3496, 'INSTITUTO NACIONAL DE DESENVOLVIMENTO HUMANO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3198, 3497, 'FACULDADE BRASILIENSE DE DIREITO FADIR', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3199, 3498, 'FACULDADE DE ARTES TECNOLOGIA E NEGOCIOS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3200, 3499, 'INSTITUTO BOLSA DE VALORES', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3201, 3500, 'FACULDADE DO SERTAO BAIANO FASB', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3202, 3501, 'FACULDADE DE ADMINISTRACAO DE SANTO ANTONIO DO MONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3203, 3502, 'FACULDADE DA FRONTEIRA FAF', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3204, 3503, 'FACUDADE DA CIENCIA DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3205, 3504, 'ESCOLA DE ENSINO SUPERIOR DE BRASILANDIA DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3206, 3505, 'INSTITUTO SUPERIOR DE EDUCACAO DE JACUTINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3207, 3506, 'FACULDADE DE CIENCIAS EDUCACIONAIS DE SERGIPE', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3208, 3507, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS IBRAFEM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3209, 3508, 'FACULDADE SANTO ANTONIO DE QUEIMADAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3210, 3509, 'FACULDADE VICENTINA FAVI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3211, 3510, 'UNASP FACULDADE DO SERVIDOR PUBLICO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3212, 3511, 'FACULDADES COMUNITARIA UNIDAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3213, 3512, 'ILES INSTITUTO LOGOS DE EDUCACAO E ENSINO SUPERIOR', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3214, 3513, 'FACULDADE DE PRESIDENTE VENCESLAU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3215, 3514, 'FACULDADE DE CIENCIAS GERENCIAIS ALVES FORTES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3216, 3515, 'FACULDADES INTEGRADAS DA VITORIA DE SANTO ANTAO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3217, 3516, 'FACULDADE DE CIENCIAS DA SAUDE ARCHIMEDES THEODORO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3218, 3517, 'FACULDADE IEGS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3219, 3518, 'FACULDADE JANGADA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3220, 3519, 'FACULDADE DE CIENCAS GERENCIAIS DO ALTO PARAOPEBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3221, 3520, 'INSTITUTO DE EDUCACAO SUPERIOR SANTA MARIA IESSAM', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3222, 3521, 'FACULDADE EXPOENTE DE EDUCACAO E PESQUISA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3223, 3522, 'FACULDADE CATOLICA DE POUSO ALEGRE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3224, 3523, 'FACULDADE DE DIREITO DA FUNDACAO ESCOLA SUPERIOR DO MINISTERIO PUBLICO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3225, 3524, 'UNIBUSINESS FACULDADE INTERNACIONAL DE EDUCACAO E GERENCIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3226, 3525, 'FACULDADE EVANGELICA DE TECNOLOGIA, CIENCIAS E BIOTECNOLOGIA DA CGADB', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3227, 3526, 'INSTITUTO DE ENSINO SUPERIOR MIGUEL DE CERVANTES', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3228, 3527, 'FACULDADE CATOLICA DOM AQUINO DE CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3229, 3528, 'FACULDADES CATOLICAS DE FRANCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3230, 3529, 'CENTRO UNIVERSITARIO EURIPEDES DE MARILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3231, 3530, 'FACULDADE DE NANUQUE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3232, 3531, 'FACULDADE CACHOEIRO DE ITAPEMIRIM', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3233, 3532, 'FACULDADE DO OESTE CATARINENSE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3234, 3533, 'FACULDADE CERES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3235, 3534, 'FACULDADE BRASILEIRA DE ENSINO SUPERIOR E TECNOLOGIA FABEST', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3236, 3535, 'FACULDADE PAULISTA DE CIENCIAS FARMACEUTICAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3237, 3536, 'FACULDADE DE TEOLOGIA EVANGELICA EM CURITIBA FATEV', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3238, 3537, 'INSTITUTO BRASILEIRO DE MODA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3239, 3538, 'FACULDADES INTEGRADAS SEVIGNE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3240, 3539, 'FACULDADE SANTA LUCIA MOGI GUACU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3241, 3540, 'UNIAO DE FACULDADES DE ADMINISTRACAO PUBLICA UNIFAP', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3242, 3541, 'FACULDADE ANGLICANA DE TAPEJARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3243, 3542, 'INSTITUTO DE ENSINO SUPERIOR DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3244, 3543, 'FACULDADE NOVO HAMBURGO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3245, 3544, 'FACULDADE DE FISIOTERAPIA MACHADO DE ASSIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3246, 3546, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE BARRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3247, 3547, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE ITABUNA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3248, 3548, 'FACULDADE SUICA DE HOTELARIA DE JOINVILLE S A', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3249, 3549, 'FACULDADE NACIONAL SENIOR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3250, 3550, 'FACULDADE SAO FRANCISCO DE CAJAZEIRAS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3251, 3551, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE BARREIRAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3252, 3552, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE TEIXEIRA DE FREITAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3253, 3553, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE VALENCA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3254, 3554, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE JACOBINA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3255, 3555, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE ALAGOINHAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3256, 3556, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3257, 3557, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE IRECE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3258, 3558, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE IPIRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3259, 3559, 'FACULDADE DE PORANGATU', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3260, 3560, 'FACULDADE DE CIENCIAS DA SAUDE DE CAMPINA GRANDE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3261, 3561, 'FACULDADE SANTA RITA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3262, 3562, 'FACULDADE DE ODONTOLOGIA RORAIMA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3263, 3563, 'FACULDADE DE ODONTOLOGIA RIO BRANCO', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3264, 3564, 'FACULDADE MORENENSE DE EDUCACAO FAM', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3265, 3565, 'FACULDADE MORENENSE DE EDUCACAO FAM', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3266, 3566, 'FACULDADE PAULO FREIRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3267, 3567, 'FMV FACULDADE METROPOLITANA DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3268, 3568, 'FACULDADE DE DESENVOLVIMENTO E INTEGRACAO REGIONAL', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3269, 3569, 'INSTITUTO SUPERIOR DE EDUCACAO DE MANHUACU', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3270, 3570, 'FACULDADE DE CIENCIAS E EDUCACAO DE SAO SIMAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3271, 3571, 'FACULDADE DOS INCONFIDENTES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3272, 3572, 'FACULDADE DE DIREITO DA ACADEMIA BRASILEIRA DE CIENCIAS JURIDICAS E SOCIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3273, 3573, 'FACULDADE TEOLOGICA BATISTA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3274, 3574, 'UNIAO DE FACULDADES DE PARAISO UNIFAP', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3275, 3575, 'FACULDADE ATIVA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3276, 3576, 'FACULDADE DE ENSINO SUPERIOR DO LITORAL SUL FASUL', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3277, 3577, 'FACULDADE DE ALTOS ESTUDOS DA BAHIA FAE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3278, 3578, 'FACULDADE DE CIENCIAS FARMACEUTICAS DO PANTANAL', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3279, 3579, 'INSTITUTO LUTERANO DE EDUCACAO SUPERIOR DO PARECIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3280, 3580, 'FACULDADE DE EDUCACAO CIENCIAS SOCIAIS E DA SAUDE SESI TO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3281, 3581, 'FACULDADE DE ENSINO TECNOLOGICO FILADELFIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3282, 3582, 'FACULDADE PORTO CALVO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3283, 3583, 'ESCOLAS SUPERIORES DE ADMINISTRACAO GEOGRAFIA E CURSO NORMAL SUPERIOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3284, 3584, 'INSTITUTO SUPERIOR DE EDUCACAO SANTA CRUZ', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3285, 3585, 'FACULDADE SANTA CRUZ', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3286, 3586, 'FACULDADE OXFORD DO BRASIL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3287, 3587, 'FACULDADE DIOCESANA SAO JOSE', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3288, 3588, 'FACULDADE DOM PEDRO II', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3289, 3589, 'FACULDADE TEOREMA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3290, 3590, 'FACULDADE DE ENFERMAGEM SAO VICENTE DE PAULA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3291, 3591, 'INSTITUTO SUPERIOR DE EDUCACAO DE MACAPARANA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3292, 3593, 'FACULDADE DE CHAPECO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3293, 3594, 'FACULDADE DE CIENCIA, TECNOLOGIA E EDUCACAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3294, 3595, 'INSTITUTO SUPERIOR DE EDUCACAO DE SANTA MARIA DA VITORIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3295, 3596, 'FACULDADE AMERICA LATINA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3296, 3597, 'FACULDADE DE ENSINO SUPERIOR DE SANTA CRUZ DO CAPIBARIBE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3297, 3598, 'FACULDADE DE IRATI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3298, 3599, 'FACULDADE DE ITAPEMA FAI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3300, 3601, 'FACULDADE DE TAPEJARA FATAP', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3301, 3602, 'FACULDADES INTEGRADAS DO BRASIL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3302, 3603, 'FACULDADE ANHANGUERA DE GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3303, 3604, 'INSTITUTO SUPERIOR DE EDUCACAO DE CARIACICA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3304, 3605, 'FACULDADE DE CIENCIAS COMUNICACOES E TECNOLOGIAS DE PESQUEIRA FACCIP', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3305, 3606, 'INSTITUTO SUPERIOR DE EDUCACAO PRESBITERIANO VALE DO TOCANTINS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3306, 3607, 'ESCOLA SUPERIOR ASSOCIADA DE GOIANIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3307, 3608, 'INSTITUTO SUPERIOR DE EDUCACAO DE LONDRINA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3308, 3609, 'FACULDADES INTEGRADAS IPITANGA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3309, 3610, 'FACULDADES INTEGRADAS PROMOVE DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3310, 3611, 'FACULDADES INTEGRADAS DA UNIAO DE ENSINO SUPERIOR CERTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3311, 3612, 'FACULDADE ANHANGUERA DE VALINHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3312, 3613, 'FACULDADES INTEGRADAS IESGO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3313, 3614, 'ESCOLA SUPERIOR DE CIENCIAS SOCIAIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3314, 3615, 'FACULDADE PERNAMBUCANA DE SAUDE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3315, 3616, 'FACULDADES PHD', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3316, 3617, 'FACULDADE DE CIENCIAS HUMANAS E EXATAS DO SERTAO DO SAO FRANCISCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3317, 3618, 'FACULDADE MARIO SCHENBERG', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3318, 3619, 'UNESC UNIAO DAS ESCOLAS SUPERIORES DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3319, 3620, 'ESCOLA INTERNACIONAL DE ADMINISTRACAO E NEGOCIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3320, 3621, 'INSTITUTO DE ENSINO SUPERIOR DE GARCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3321, 3622, 'INSTITUTO DE ENSINO SUPERIOR DE GARCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3322, 3623, 'FACULDADE DE CIENCIAS DA BAHIA FACIBA NOME ALTERADO POR SOLICITACAO DO MEC', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3323, 3624, 'PUC MINAS ARCOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3324, 3625, 'FACULDADE CATOLICA NOSSA SENHORA DAS VITORIAS', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3325, 3626, 'FACULDADE BRASILEIRA DE EDUCACAO E NEGOCIOS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3326, 3627, 'FACULDADE DE TECNOLOGIA BARAO DO RIO BRANCO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3327, 3628, 'FACULDADADE TEOLOGICA REFORMADA FTR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3328, 3629, 'FACULDADADE TEOLOGICA REFORMADA FTR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3329, 3630, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE PAULO AFONSO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3330, 3631, 'FACULDADE DAMAS DA INSTRUCAO CRISTA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3331, 3632, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE ITABERABA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3332, 3633, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE CAMPO FORMOSO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3333, 3634, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE BOM JESUS DA LAPA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3334, 3635, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE SANTA MARIA DA VITORIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3335, 3636, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE SENHOR DO BONFIM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3336, 3637, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE RIBEIRA DO POMBAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3337, 3638, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE ILHEUS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3338, 3639, 'FACULDADE DE DIREITO DO INSTITUTO DE ENSINO SUPERIOR DO CIRCUITO DO OURO FDINESO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3339, 3640, 'FACULDADE DE CIENCIAS ECONOMICAS DE JEQUIE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3340, 3641, 'CENTRO UNIVERSITARIO DA FUNDACAO EDUCACIONAL DE BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3341, 3642, 'FACULDADE INTEGRADA DE PERNAMBUCO SURUBIM FACIPE SURUBIM', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3342, 3643, 'FACULDADE CATOLICA NOSSA SENHORA DAS NEVES', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3343, 3644, 'FACULDADE CATOLICA SANTA TERESINHA', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3344, 3645, 'FACULDADE CATOLICA SANTA TERESINHA CADASTRADA INDEVIDAMENTE', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3345, 3646, 'FACULDADE DE TECNOLOGIA DE OURO FINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3346, 3647, 'FACULDADE DE TECNOLOGIA MARISTA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3347, 3648, 'FACULDADE ANHANGUERA DE CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3348, 3649, 'FACULDADE CIDADE VERDE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3349, 3650, 'INSTITUTO SUPERIOR DE EDUCACAO GREGORIANO ISEG', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3350, 3651, 'FACULDADE DAS AGUAS QUENTES FAQ', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3351, 3652, 'FACULDADE PRESBITERIANA SAMUEL GRAHAM', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3352, 3653, 'FACULDADE PRESBITERIANA SAMUEL GRAHAM', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3353, 3654, 'FACULDADE DE CIENCIAS COMUNICACOES E TECNOLOGIAS DE FLORESTA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3354, 3655, 'FACULDADE DE JANAUBA FAJAN', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3355, 3656, 'FACULDADE NOVA TRINDADE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3356, 3657, 'FACULDADE DE COMPUTACAO DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3357, 3658, 'FACULDADE UIRAPURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3358, 3659, 'FACULDADE DE CIENCIAS COMUNICACAO E TECNOLOGIA DE SALGUEIRO FACTS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3359, 3660, 'INSTITUTO SUPERIOR DE EDUCACAO DE SALGUEIRO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3360, 3662, 'FACULDADE EVANGELICA LOGOS', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3361, 3663, 'FACULDADE EVANGELICA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3362, 3664, 'INSTITUTO SUPERIOR DE EDUCACAO DE VARGEM GRANDE DO SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3363, 3665, 'FACULDADE DE JOACABA FJ', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3364, 3666, 'FACULDADE DE ADMINISTRACAO DA AERONAUTCA', 1, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3365, 3667, 'FACULDADE FILADELFIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3366, 3668, 'FACULDADE DE ENFERMAGEM E ADMINISTRACAO DE JATAI FEAJ', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3367, 3669, 'FACULDADE DOM LUIS DE ORLEANS E BRAGANCA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3368, 3670, 'FACULDADE DE CRICIUMA FACRI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3369, 3671, 'FACULDADE INTERDISCIPLINAR DE BLUMENAU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3370, 3672, 'FACULDADE DE CAMPOS NOVOS FACAN', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3371, 3673, 'FACULDADE PREMIER', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3372, 3674, 'INSTITUTO NORMAL SUPERIOR FBV', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3373, 3675, 'SINAL FACULDADE DE TEOLOGIA E FILOSOFIA', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3374, 3676, 'FACULDADE DE TECNOLOGIA DO VALE DO RIBEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3375, 3677, 'FACULDADE DE TECNOLOGIA DE ALTA PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3376, 3678, 'FACULDADE DE TECNOLOGIA DO VALE DO ITAJAI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3377, 3679, 'INSTITUTO DE ENSINO SUPERIOR DE GARCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3378, 3680, 'FACULDADE DE TECNOLOGIA DARCY RIBEIRO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3379, 3681, 'FACULDADES DE GARANHUNS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3380, 3682, 'INSTITUTO SUPERIOR DE EDUCACAO DO MUNICIPIO DE ITAPERUNA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3381, 3683, 'FACULDADE UNILAGOS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3382, 3684, 'FUNDACAO DE ENSINO SUPERIOR DE CLEVELANDIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3383, 3685, 'FACULDADE DA POLI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3384, 3686, 'FADITU FACULDADE DE DIREITO DE ITU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3385, 3687, 'FACULDADES INTEGRADAS DE JACAREI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3386, 3688, 'FACULDADES INTEGRADAS DO VALE DO IVAI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3387, 3689, 'FACULDADE PEDRO JULIAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3388, 3690, 'FACULDADE PEDRO II', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3389, 3691, 'FACULDADE DE TECNOLOGIA TUPY DE SAO BENTO DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3390, 3692, 'FACULDADE DE TECNOLOGIA IPEP DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3391, 3693, 'FACULDADE DE TECNOLOGIA IPEP DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3392, 3694, 'FACULDADE DE TECNOLOGIA ESTACIO DE SA DE SANTA CATARINA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3393, 3695, 'FACULDADE DE TECNOLOGIA ESTACIO DE SA DE OURINHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3394, 3696, 'FACULDADE DE TECNOLOGIA DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3395, 3697, 'FACULDADE DE TECNOLOGIA SAINT PASTOUS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3396, 3698, 'PORTAL FACULDADES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3397, 3699, 'FACULDADE ECOAR', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3398, 3700, 'FACULDADE DE CIENCIAS JURIDICAS DE PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3399, 3701, 'FACULDADE DE CIENCIAS GERENCIAIS DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3400, 3702, 'FACULDADES ELO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3401, 3703, 'INSTITUTO SUPERIOR DE ADMINISTRACAO E NEGOCIOS DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3402, 3704, 'FACULDADE DO ALTO PARNAIBA FAP', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3403, 3705, 'FACULDADE KHALIL LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3404, 3706, 'FACULDADE REGIONAL DE POJUCA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3405, 3707, 'FACULDADE INTEGRADAS DO MORENO FIAM', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3406, 3708, 'FACULDADE INTEGRAL DO RIO GRANDE DO NORTE', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3407, 3709, 'INSTUTO DE ENSINO SUPERIOR SAO LUCAS', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3408, 3710, 'ESCOLA SUPERIOR NACIONAL DE SEGUROS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3409, 3711, 'FACULDADE CENTRAL DE CRISTALINA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3410, 3712, 'FACULDADE VITORIA', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3411, 3713, 'INSTITUTO DE TEOLOGIA E PASTORAL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3412, 3714, 'INSTITUTO TATUIANO DE ENSINO SUPERIOR ITES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3413, 3715, 'FACULDADE METROPOLITANA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3414, 3716, 'FACULDADE CIENCIAS DA VIDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3415, 3717, 'FACULDADE CULTURAL ANJAGUNA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3416, 3718, 'FACULDADE DE CIENCIAS HUMANAS JULIO GOMES', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3417, 3719, 'FACULDADE DE CORACAO DE JESUS FADECOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3418, 3720, 'FACULDADE PORTO REAL', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3419, 3721, 'FACULDADE OLIVEIRA TELLES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3420, 3722, 'FACULDADE DE CIENCIAS MEDICAS INTEGRADAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3421, 3723, 'FACULDADE NACIONAL POLICURSOS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3422, 3724, 'FACULDADE MARANHENSE SAO JOSE DOS COCAIS', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3423, 3725, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE ITAMARAJU', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3424, 3726, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE JEQUIE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3425, 3727, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE EUCLIDES DA CUNHA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3426, 3728, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3427, 3729, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE GUANAMBI', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3428, 3730, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE CAMACARI', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3429, 3731, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE BRUMADO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3430, 3732, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE VITORIA DA CONQUISTA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3431, 3733, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE JUAZEIRO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3432, 3734, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE SERRINHA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3433, 3735, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE EUNAPOLIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3434, 3736, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE PILAO ARCADO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3435, 3737, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE PORTO SEGURO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3436, 3738, 'FACULDADE DE EDUCACAO CIENCIAS E LETRAS DO NOROESTE DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3437, 3739, 'FACULDADE ASSOCIACAO HOSPITALAR DE ILHA SOLTEIRA FACISA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3438, 3740, 'FACULDADE DE MEDICINA DE BOTUCATU', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3439, 3741, 'FACULDADE DE EDUCACAO DE BACABAL FEBAC', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3440, 3742, 'FACULDADES DE CIENCIAS E TECNOLOGIA DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3441, 3743, 'FACULDADE DE TECNOLOGIA SAO FRANCISCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3442, 3744, 'FACULDADE CETEP', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3443, 3745, 'INSTITUTO SUPERIOR SEJA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3444, 3746, 'FACULDADE PAULISTA DE PESQUISA E ENSINO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3445, 3747, 'FACULDADE METROPOLITANA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3446, 3748, 'FACULDADE DE TECNOLOGIA THEREZA PORTO MARQUES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3447, 3749, 'FACULDADE DE TECNOLOGIA BRASILIA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3448, 3750, 'FACULDADE DE TECNOLOGIA DO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3449, 3751, 'FACULDADE DE TECNOLOGIA DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3450, 3752, 'FACULDADE DE TECNOLOGIA CONTEC', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3451, 3753, 'FACULDADES INTEGRADAS DOM PEDRO II', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3452, 3754, 'FACULDADES INTEGRADAS ADVENTISTAS DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3453, 3755, 'FACULDADE EM AUTOCONHECIMENTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3454, 3756, 'FACULDADE DE ALMENARA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3455, 3757, 'FACULDADE SERRA DA MESA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3456, 3758, 'FACULDADE SOCIESC', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3457, 3759, 'INSTITUTO SUPERIOR TUPY DE SAO BENTO DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3458, 3760, 'FACULDADE ITABORAI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3459, 3761, 'FACULDADE MONSENHOR JOSE SINFRONIO', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3460, 3762, 'FACULDADE DE TECNOLOGIA MILENIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3461, 3763, 'FACULDADE DO INTERIOR PAULISTA DE TANABI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3462, 3764, 'CENTRO DE EDUCACAO SUPERIOR DE POUSO ALEGRE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3463, 3765, 'FACULDADE SANTO AGOSTINHO DE SANTA VITORIA FASAV', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3464, 3766, 'INSTITUTO SUPERIOR DE EDUCACAO SANTO AGOSTINHO DE SANTA VITORIA ISAV', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3465, 3767, 'FACULDADE DE EDUCACAO CIENCIAS E TECNOLOGIA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3466, 3768, 'FACULDADE IBGEN INSTITUTO BRASILEIRO DE GESTAO DE NEGOCIOS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3467, 3769, 'FACULDADE MADRE TEREZA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3468, 3770, 'FACULDADE TEOLOGICA BATISTA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3469, 3771, 'FACULDADE DE TURISMO E ADMINISTRACAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3470, 3772, 'FACULDADE DE TECNOLOGIA PASTOR DOHMS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3471, 3773, 'FACULDADE PAULIPOLITANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3472, 3774, 'FACULDADE SAO TOMAZ DE AQUINO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3473, 3775, 'INSTITUTO UVB.BR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3474, 3776, 'INSTITUTO DE ENSINO SUPERIOR DE MATO GROSSO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3475, 3777, 'FACULDADE CURITIBANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3476, 3778, 'FACULDADE DE ARACAJU', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3477, 3779, 'FACULDADE ESTACIO DE SANTO ANDRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3478, 3780, 'FACULDADE DE TECNOLOGIA IMPACTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3479, 3781, 'FACULDADE DE TECNOLOGIA DE JARAGUA DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3480, 3782, 'FACULDADE DE TECNOLOGIA CACHOEIRO DE ITAPEMIRIM', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3481, 3783, 'FACULDADE PARAENSE DE ENSINO', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3482, 3784, 'INSTITUTO DE ENSINO SUPERIOR DO RIO GRANDE DO NORTE', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3483, 3785, 'INSTITUTO MARANHENSE DE ENSINO E CULTURA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3484, 3786, 'FACULDADE DE ENSINO DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3485, 3787, 'FACULDADE DE ENSINO SUPERIOR DA AMAZONIA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3486, 3788, 'FACULDADE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3487, 3789, 'FACULDADE EVANGELICA DE GOIANESIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3488, 3790, 'FACULDADE DE TECNOLOGIA ENSITEC', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3489, 3791, 'FACULDADE DE MEDICINA DO VALE DO ACO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3490, 3792, 'FACULDADE DE TECNOLOGIA DO ITAJAIMIRIM', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3491, 3793, 'FACULDADE FRUTAL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3492, 3794, 'FACULDADE DE TECNOLOGIA DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3493, 3795, 'CENTRO DE EDUCACAO SUPERIOR TECNOLOGICA DA TERRA PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3494, 3796, 'CENTRO DE ENSINO SUPERIOR DO ESTADO DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3495, 3797, 'FACULDADE GUAIRACA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3496, 3798, 'FACULDADE DE TEOLOGIA DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3497, 3799, 'INSTITUTO SUPERIOR DE EDUCACAO E CIENCIAS DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3498, 3800, 'INSTITUTO DE EDUCACAO E CULTURA VALE DO IPANEMA', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3499, 3801, 'CENTRO UNIVERSIT[ARIO ZEN', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3500, 3802, 'CENTRO DE EDUCACAO TECNOLOGICA DO INTERIOR PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3501, 3803, 'FACULDADE JAUENSE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3502, 3804, 'FACULDADE SENAC PORTO ALEGRE FSPOA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3503, 3805, 'FACULDADE DE TECNOLOGIA DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3504, 3806, 'FACULDADE DE TECNOLOGIA DE RORAIMA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3505, 3807, 'FACULDADE DE TECNOLOGIA IAPEC', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3506, 3808, 'FACULDADE DE ENSINO FACTUAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3507, 3809, 'INSTITUTO SUPERIOR DE EDUCACAO TEOLOGICA DO AMAZONAS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3509, 3811, 'CENTRO DE ESTUDOS EM NEGOCIOS INTERNACIONAIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3510, 3812, 'FACULDADES PARA O DESENVOLVIMENTO SUSTENTAVEL DO SUL DA BAHIA FADESB', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3511, 3813, 'FATECE FACULDADES DE TECNOLOGIA CIENCIAS E EDUCACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3512, 3814, 'FACULDADE PLANALTO DO BRASIL FPB', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3513, 3815, 'FACULDADE DE DIREITO DE ALTA FLORESTA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3514, 3816, 'FACULDADE SANTA MARIA GORETTI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3515, 3817, 'FACULDADE MAURICIO DE NASSAU DE JOAO PESSOA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3516, 3818, 'FACULDADES EQUIPE LTDA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3517, 3819, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS E GESTAO PUBLICA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3518, 3820, 'FACULDADE PETRONIO PORTELA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3519, 3821, 'FACULDADE SAO BOAVENTURA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3520, 3822, 'INSTITUTO DE EDUCACAO SUPERIOR DE POUSO ALEGRE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3521, 3823, 'INSTITUTO DE EDUCACAO SUPERIOR DE POUSO ALEGRE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3522, 3824, 'FACULDADE JOSE CANDIDO DE MELO CARVALHO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3523, 3825, 'FACULDADE CATOLICA RIO PRETENSE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3524, 3826, 'FACULDADE VASCO DA GAMA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3525, 3827, 'ESCOLA SUPERIOR DE CIENCIAS COMERCIAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3526, 3828, 'INSTITUTO SUPERIOR DE EDUCACAO DE TUPA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3527, 3829, 'CENTRO DE EDUCACAO SUPERIOR TECNOLOGICA DA TERRA PAULISTA CETERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3528, 3830, 'INSTITUTO CENTRO DE ENSINO TECNOLOGICO SOBRAL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3529, 3831, 'FACULDADE DE CIENCIAS CONTABEIS', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3530, 3832, 'FACULDADE DE ZOOTECNIA', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3531, 3833, 'FACULDADE DE ENGENHARIA FLORESTAL', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3532, 3834, 'FACULDADE SANTA LUCIA PIRACICABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3533, 3835, 'UNIVERSIDADE VIRTUAL DO ESTADO DO MARANHAO', 2, 1, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3534, 3836, 'UNIVERSIDADE PAULISTA UNIP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3535, 3837, 'FACULDADE DE TECNOLOGIA MODULO PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3536, 3838, 'FACULDADE DE TECNOLOGIA DO UNIUOL', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3537, 3839, 'FACULDADE DE TECNOLOGIA NOVO RUMO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3538, 3840, 'CENTRO UNIVERSITARIO FACVEST', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3539, 3841, 'FACULDADE PITAGORAS DE ADMINISTRACAO SUPERIOR DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3540, 3842, 'FACULDADE METROPOLITANA DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3541, 3843, 'FACULDADE CANDIDO MENDES DE ARARUAMA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3542, 3844, 'ESCOLA SUPERIOR DE CASTANHAL', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3543, 3845, 'FACULDADE TAQUARITUBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3544, 3846, 'FACULDADE DE CIENCIAS E CULTURA DA LIBERDADE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3545, 3847, 'FACULDADE BAIANA DE DIREITO E GESTAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3546, 3848, 'FACULDADE GABRIELA GONCALVES', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3547, 3849, 'FUNDACAO UNIVERSIDADE FEDERAL DO TOCANTINS', 1, 1, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3548, 3850, 'FACULDADE CONTEMPORANEA UNC SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3549, 3851, 'FACULDADE DO RECONCAVO UNR CRUZ DAS ALMAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3550, 3852, 'FACULDADE DO RECONCAVO UNR CONCEICAO DO ALMEIDA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3551, 3853, 'FACULDADE MAURICIO DE NASSAU DE NATAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3552, 3854, 'FACULDADE DAS AGUAS EMENDADAS FAE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3553, 3855, 'FACULDADES INTERNACIONAIS SAN MARTIN DO BRASIL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3554, 3856, 'FACULDADE DE SANTO ANASTACIO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3555, 3857, 'FACULDADE GAUDIUM', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3556, 3858, 'FACULDADE TOBIAS BARRETO DE MENEZES FATOB', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3557, 3859, 'INSTITUTO SUPERIOR DE EDUCACAO TECNOLOGICA DO NORTE FLUMINENSE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3558, 3860, 'FACULDADE TRIUNFO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3559, 3861, 'FACULDADE DE TECNOLOGIA E NEGOCIOS CONTEMPORANEO FATEC', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3560, 3862, 'FACULDADE LUCIANO FEIJAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3561, 3863, 'FACULDADE COOPERATIVA DE GOIANIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3562, 3864, 'FACULDADE REGIONAL DE ALAGOINHAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3563, 3865, 'FACULDADES INTEGRADAS PADRE HUMBERTO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3564, 3866, 'FACULDADE BRASILEIRA DE EDUCACAO E CULTURA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3565, 3867, 'FACULDADE MAUA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3566, 3868, 'INSTITUTO DE EDUCACAO SUPERIOR DO ALTO PARANAIBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3567, 3869, 'INSTITUTO FLORENCE DE ENSINO SUPERIOR', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3568, 3870, 'INSTITUTO DE ESTUDOS DE NEGOCIOS INTERNACIONAIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3569, 3871, 'ESCOLA DE ADMINISTRACAO FAZENDARIA', 1, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3570, 3872, 'FACULDADE DE TECNOLOGIA SAO CARLOS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3571, 3873, 'FACULDADE DE TECNOLOGIA DE BRUMADO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3572, 3874, 'FACULDADE PROJECAO DE PLANALTINA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3573, 3875, 'CENTRO UNIVERSITARIO DA FUNDACAO EDUCACIONAL GUAXUPE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3574, 3876, 'AVM   FACULDADE INTEGRADA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3575, 3877, 'FACULDADE BRASIL CENTRAL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3576, 3878, 'FACULDADE DECISION DE NEGOCIOS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3577, 3879, 'FACULDADE MAURICIO DE NASSAU DE CAMPINA GRANDE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3578, 3880, 'INSTITUTO SOCIAL DE EDUCACAO', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3579, 3881, 'FACULDADE DE INTEGRACAO DO SERTAO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3580, 3882, 'INSTITUTO DE ENSINO SUPERIOR DE FORMACAO PROFISSIONAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3581, 3883, 'FACULDADE EVANGELICA LOGOS FAEL', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3582, 3884, 'CESB CENTRO DE EDUCACAO SUPERIOR DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3583, 3885, 'FACULDADES INTEGRADAS DA TERRA PAULISTA FATERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3584, 3886, 'FACULDADE AGUA BOA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3585, 3887, 'FACULDADE DE CIENCIAS JURIDICAS E GERENCIAIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3586, 3888, 'ESCOLA SUPERIOR DE ADMINISTRACAO E NEGOCIOS DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3587, 3889, 'FACULDADE DE IGARAPAVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3588, 3890, 'FACULDADE MARQUES GUIMARAES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3589, 3891, 'SOCIEDADE EDUCACIONAL ALBERTI TOLENTINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3590, 3892, 'FACULDADE DE CIENCIAS SOCIAIS J G MELO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3591, 3894, 'UNIESP UNIAO DAS INSTITUICOES EDUCACIONAIS DO ESTADO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3592, 3895, 'INSTITUTO DE EDUCACAO SUPERIOR ALBERTI TOLENTINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3593, 3896, 'FACULDADE MUNDIAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3594, 3897, 'FACULDADE BUSCA VIDA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3595, 3898, 'SLCSA FACULDADE SANTA INES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3596, 3899, 'FACULDADE DE RIBEIRAO DAS NEVES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3597, 3901, 'FACULDADES PROEDUC', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3598, 3902, 'FUNDACAO ESCOLA DO MINISTERIO PUBLICO DO ESTADO DO PARANA FEMPAR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3599, 3903, 'INFAMILIA INSTITUTO BRASILEIRO DE SAUDE DA FAMILIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3600, 3904, 'FACULDADE DE CIENCIAS GERENCIAIS DE CATAGUASES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3601, 3905, 'FACULDADE DE DIREITO DOCTUM DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3602, 3906, 'FACULDADE DE CIENCIAS AGRARIAS E DA TERRA DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3603, 3907, 'FACULDADE DE SAPIRANGA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3604, 3908, 'FACOM FACULDADE COMUNITARIA DO BRASIL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3605, 3909, 'ISTITUTO DE ENSINO SUPERIOR PARAENSE', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3606, 3910, 'INSTITUTO SUPERIOR DE EDUCACAO DE CATAGUASES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3607, 3911, 'FACULDADE DE TECNOLOGIA OXFORD DO BRASIL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3608, 3912, 'FACULDADE SUDOESTE PAULISTA BOTUCATU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3609, 3913, 'FACULDADE SUDOESTE PAULISTA TAQUARITUBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3610, 3914, 'INSTITUTO SUPERIOR DE EDUCACAO DO VALE DO CAPIBARIBE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3611, 3915, 'INSTITUTO SUPERIOR DE EDUCACAO CARLOS JOEL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3612, 3916, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3613, 3917, 'FACULDADE DE MERCADO AMPLO FAMA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3614, 3918, 'FACULDADE INTEGRADA EM CIENCIAS HUMANAS', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3615, 3919, 'FACULDADE NOSSA SENHORA DO BOM CONSELHO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3616, 3920, 'FACULDADE DE TECNOLOGIA SENAI ROBERTO MANGE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3617, 3921, 'FACULDADE ARNALDO HORACIO FERREIRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3618, 3922, 'FACULDADE ARNALDO HORACIO FERREIRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3619, 3923, 'FACULDADE SAO FRANCISCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3620, 3924, 'FACULDADE DE IBIRACU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3621, 3925, 'FACULDADE DE TEOLOGIA DO BRASIL FATEB', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3622, 3926, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DO ALTO SAO FRANCISCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3623, 3927, 'FACULDADE DE CACERES', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3624, 3928, 'FAESB FACULDADE DE ENSINO SUPERIOR DO BRASIL', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3625, 3929, 'FACULDADES UNIDAS DE SETE LAGOAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3626, 3930, 'INSTITUTO DE EDUCACAO SUPERIOR RAIMUNDO SA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3627, 3931, 'FACULDADE PRESBITERIANA ARMSTRONG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3628, 3932, 'FACULDADE DE EDUCACAO E TECNOLOGIA DE ITANHEM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3629, 3933, 'FACULDADE METODO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3630, 3934, 'FACULDADE DA SAUDE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3631, 3935, 'FACULDADE DE EDUCACAO TEOLOGICA DO DISTRITO FEDERAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3632, 3936, 'FACULDADE ANHANGUERA DE LIMEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3633, 3937, 'FACULDADE ANHANGUERA DE INDAIATUBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3634, 3938, 'FACULDADE DO NORTE DO MATO GROSSO DO SUL FANOR', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3635, 3939, 'FACULDADE ALIANCA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3636, 3940, 'FACULDADE DE ENSINO SUPERIOR SANTA BARBARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3637, 3941, 'FACULDADE COMUNITARIA DE SANTA BARBARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3638, 3942, 'FACULDADE COMUNITARIA DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3639, 3943, 'FASC TB FACULDADES ASSOCIADAS DE SC DE TUBARAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3640, 3944, 'FACULDADE DE CIENCIAS DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3641, 3945, 'INSTITUTO DE EDUCACAO EXECUTIVA CATHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3642, 3946, 'FACULDADE DE TECNOLOGIA SENAC TUBARAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3643, 3947, 'FACULDADE DE TECNOLOGIA SENAC CHAPECO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3644, 3948, 'FACULDADE DE TECNOLOGIA SENAC BLUMENAU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3645, 3949, 'CENTRO DE EDUCACAO SUPERIOR TECNOLOGICA DA TERRA PAULISTA CETERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3646, 3950, 'CENTRO DE CIENCIAS ETECNOLOGIA DETERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3647, 3951, 'FACULDADE DE TECNOLOGIA LUIZ ADELAR SCHEUER', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3648, 3952, 'FACULDADE VILAVELHENSE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3649, 3953, 'FACULDADE DE ODONTOLOGIA', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3650, 3954, 'FACULDADE DE CIENCIAS JURIDICAS E GERENCIAIS DE OLIVEIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3651, 3955, 'FACULDADES INTEGRADAS DE CATAGUASES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3652, 3956, 'ASSOCIACAO EDUCACIONAL CENTRAL DE CRISTALINA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3653, 3957, 'INSTITUTO SUPERIOR DE EDUCACAO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3654, 3958, 'FACULDADE TECNOLOGICA DE MARILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3655, 3959, 'FACULDADE TECNOLOGICA AMERICA DO SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3656, 3960, 'FACULDADE TECNOLOGICA DE BIRIGUI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3657, 3961, 'FACULDADE DE TECNOLOGIA SANTA RITA DE CASSIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3658, 3962, 'FACULDADE DE TECNOLOGIA SENAI CIMATEC', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3659, 3963, 'INSTITUTO SUPERIOR DE EDUCACAO CARLOS CHAGAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3660, 3964, 'FACULDADE DE TECNOLOGIA PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3661, 3965, 'FACULDADE DE TECNOLOGIA ENG. MARCELO SILVA GUIMARAES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3662, 3966, 'CENTRO UNIVERSITARIO DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3663, 3967, 'INSTITUTO SUPERIOR DE EDUCACAO DE RORAIMA', 2, 1, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3664, 3968, 'INSTITUTO SUPERIOR DE EDUCACAO DE RORAINOPOLIS', 2, 1, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3665, 3969, 'INSTITUTO SUPERIOR DE SEGURANCA E CIDADANIA DE RORAIMA', 2, 1, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3666, 3970, 'INSTITUTO SUPERIOR DE EDUCACAO DE PARAISOPOLIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3667, 3971, 'INSTITUTO DE ENSINO SUPERIOR DE PORTO NACIONAL', 3, 1, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3668, 3972, 'CENTRO SUPERIOR DE ENSINO E PESQUISA DE MACHADO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3669, 3973, 'FACULDADE DE TECNOLOGIA BANDEIRANTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3670, 3974, 'UNIVERSIDADE DE RIO VERDE', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3671, 3975, 'FACULDADE SAO FRANCISCO DE PIUMHI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3672, 3976, 'INSTITUTO SUPERIOR DE CIENCIAS HUMANAS E SOCIAIS APLICADAS DE ABAETE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3673, 3977, 'FACULDADE DE TECNOLOGIA DO AMAPA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3674, 3978, 'FACULDADE DE TECNOLOGIA PENTAGONO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3675, 3979, 'FACULDADE DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3676, 3980, 'FACULDADE JK BRASILIA UNIDADE PLANO PILOTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3677, 3981, 'FACULDADE DE TECNOLOGIA INTEGRAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3678, 3982, 'FACULDADE DE TECNOLOGIA FAMEG FAMETEC', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3679, 3983, 'CENTRO UNIVERSITARIO DE FORMIGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3680, 3984, 'FUNDACAO UNIVERSIDADE FEDERAL DO VALE DO SAO FRANCISCO', 1, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3681, 3985, 'CENTRO UNIVERSITARIO SENAC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3682, 3986, 'INSTITUTO SUPERIOR DE EDUCACAO DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3683, 3987, 'FACULDADE UNIAO DE GOYAZES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3684, 3988, 'FACULDADE UNIAO DE GOYAZES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3685, 3989, 'FACULDADE DE TECNOLOGIA DE JOAO PESSOA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3686, 3990, 'FACULDADE DE TECNOLOGIA ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3687, 3991, 'FACULDADE DE TECNOLOGIA SAO MATEUS', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3688, 3992, 'FACULDADE JK ASA NORTE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3689, 3993, 'FACULDADE DE TECNOLOGIA CETEP', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3690, 3994, 'FACULDADE DE TECNOLOGIA LATINO AMERICANO DE ANAPOLIS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3691, 3995, 'FACULDADE EVANGELICA CRISTO REI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3692, 3996, 'FACULDADE SENAC PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3693, 3997, 'FACULDADES DE JI PARANA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3694, 3998, 'INSTITUTO INFNET RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3695, 3999, 'CENTRO DE ENSINO SUPERIOR TECNOLOGICO DO INTERIOR PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3696, 4000, 'FACULDADE DE ENSINO SUPERIOR DO INTERIOR PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3697, 4001, 'FACULDADE DE ENSINO SUPERIOR DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3698, 4002, 'INSTITUTO DE ENSINO SUPERIOR DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3699, 4003, 'FACULDADE CENTRO OESTE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3700, 4004, 'FACULDADE CENECISTA DE ITUBERA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3701, 4005, 'FACULDADE CENECISTA DE SENHOR DO BONFIM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3702, 4006, 'FACULDADE DE TECNOLOGIA SENAC PELOTAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3703, 4007, 'FATECE FACULDADE DE TECNOLOGIA, CIENCIAS E EDUCACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3704, 4008, 'FACULDADE DE TECNOLOGIA SENAC PASSO FUNDO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3705, 4009, 'FACULDADE DE TECNOLOGIA ESTACIO DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3706, 4010, 'CENTRO UNIVERSITARIO METODISTA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3707, 4011, 'UNI DORINHA FACULDADE DE CIENCIAS E TECNOLOGIA DE DORINHA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3708, 4012, 'UNI METROPOLITANA; FACULDADES DE CIENCIAS HUMANAS E DE BIOTECNOLOGIA DA SAUDE', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3709, 4013, 'FACULDADE ANHANGUERA DE RIO CLARO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3710, 4014, 'FACULDADE ASSOCIADA PAULISTA FAP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3711, 4015, 'FACULDADE DE TECNOLOGIA IBTA RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3712, 4016, 'INSTITUTO NACIONAL DE EDUCACAO DE SURDOS', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3713, 4017, 'CENTRO UNIVERSITARIO PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3714, 4018, 'FACULDADE GAT DE GESTAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3715, 4019, 'CENTRO DE EDUCACAO TECNOLOGIA RUI BARBOSA CETERB', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3716, 4020, 'FACULDADE DE TECNOLOGIA DE BOTUCATU', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3717, 4021, 'FACULDADE DE TECNOLOGIA DE GARCA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3718, 4022, 'FACULDADE DE TECNOLOGIA DE JUNDIAI', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3719, 4023, 'FACULDADE DE TECNOLOGIA DE MAUA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3720, 4024, 'FACULDADE DE TECNOLOGIA DE MOCOCA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3721, 4025, 'FACULDADE DE TECNOLOGIA DE SAO JOSE DO RIO PRETO', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3722, 4026, 'FACULDADE DE TECNOLOGIA ZONA LESTE', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3723, 4027, 'INSTITUTO SUPERIOR DE ENSINO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3724, 4028, 'FACULDADE DE ITAPECERICA DA SERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3725, 4029, 'FACULDADE POLITEC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3726, 4030, 'CENTRO UNIVERSITARIO FLUMINENSE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3727, 4031, 'INSTITUTO DE ENSINO SUPERIOR PROFESSORA ALMEIDA CESPMA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3728, 4032, 'FACULDADE DE CIENCIAS E TECNOLOGIA DE PAULISTA FACIT', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3729, 4033, 'FACULDADE DE TECNOLOGIA FABRAI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3730, 4034, 'ASSOCIACAO EDUCACIONAL', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3731, 4035, 'FACULDADE MAUA FAMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3732, 4036, 'FACULDADE DE TECNOLOGIA DE CATALAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3733, 4037, 'FACULDADE DE TECNOLOGIA INTENSIVA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3734, 4038, 'FACULDADE DE TECNOLOGIA CONSULTIME', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3735, 4039, 'FACULDADE UNILIVRE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3736, 4040, 'ESCOLA AGROTECNICA FEDERAL DE UBERLANDIA', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3737, 4041, 'FACULDADE DE IRARA FAIR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3738, 4042, 'FACULDADE DO MEIO AMBIENTE E DE TECNOLOGIA DE NEGOCIOS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3739, 4043, 'FACULDADE TECNOLOGIA EDUVALE AVARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3740, 4044, 'FACULDADE TECNOLOGIA EXPERT', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3741, 4045, 'FACULDADE DE TECNOLOGIA TUPY CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3742, 4046, 'ESCOLA FIEMG DE LIDERES EMPRESARIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3743, 4047, 'FACULDADE TECNOLOGIA IBTA BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3744, 4048, 'FCC FACULDADE CATOLICA DO CARIRI', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3745, 4049, 'FACULDADE TEOLOGICA DA ASSEMBLEIA DE DEUS EM CURITIBA FATADC', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3746, 4050, 'FAESP FACULDADE DE ENSINO SUPERIOR E PROFISSIONALIZANTE', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3747, 4051, 'FACULDADE SILVIO ROMERO', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3748, 4052, 'INSTITUTO BONDESPACHENSE PRESIDENTE ANTONIO CARLOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3749, 4053, 'CENTRO DE EDUCACAO SUPERIOR BARNABITA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3750, 4054, 'INSTITUTO UNIFICADO DE ENSINO SUPERIOR OBJETIVO IUESO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3751, 4055, 'INSTITUTO BIBLICO DAS ASSEMBLEIAS DE DEUS DO ESTADO DO PARANA IBADEP', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3752, 4057, 'FACISA FACULDADE DE CIENCIA DA SAUDE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3753, 4058, 'FACULDADE IPE', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3754, 4059, 'FACULDADE DE CIENCIAS GERENCIAIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3755, 4060, 'CENTRO DE EDUCACAO TECNOLOGICA CENECISTA DE RIO NEGRINHO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3756, 4061, 'FACULDADE DE TECNOLOGIA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3757, 4062, 'FACULDADE ATHENIENSSE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3758, 4064, 'FACULDADE DE TECNOLOGIA FAMA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3759, 4065, 'FACULDADE DE TECNOLOGIA DO INSTITUTO BANDEIRANTE DE EDUCACAO E CULTURA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3760, 4066, 'FACULDADE BATISTA DO ESTADO DO RIO DE JANEIRO FABERJ', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3761, 4067, 'FACIT FACULDADE INDEPENDENTE DE ITAPETINGA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3762, 4068, 'FACULDADE ICESP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3763, 4069, 'FACULDADE HORIZONTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3764, 4070, 'ESCOLA AGROTECNICA FEDERAL DE SALINAS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3765, 4071, 'ESCOLA AGROTECNICA FEDERAL DE INCONFIDENTES', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3766, 4072, 'ESCOLA AGROTECNICA FEDERAL DE IGUATU', 1, 1, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3767, 4073, 'FACULDADE DE TECNOLOGIA IPIRANGA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3768, 4074, 'FACULDADE DELTA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3769, 4076, 'FACULDADE DE TECNOLOGIA PREVE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3770, 4077, 'FACULDADE DE TECNOLOGIA DE GRAVATAI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3771, 4078, 'FACULDADE METROPOLITANA DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3772, 4079, 'FACULDADE TECNOLOGICA INAP', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3773, 4080, 'FACULDADE DE PRUDENTOPOLIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3774, 4081, 'FATEG FACULDADE DE TECNOLOGIA GALVAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3775, 4082, 'IBEC INSTITUTO BRASILEIRO DE EDUCACAO SUPERIOR CONTINUADA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3776, 4083, 'MATEC CENTRO DE ENSINO TECNOLOGICO DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3777, 4084, 'INSTITUTO DE ENSINO SUPERIOR DOS MILITARES', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3778, 4085, 'FACULDADE ANCHIETA DE EDUCACAO A DISTANCIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3779, 4086, 'FACULDADE DE TECNOLOGIA JARDIM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3780, 4087, 'FACULDADE DE EDUCACAO TECNOLOGICA FET DA CDL DE SOBRAL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3781, 4088, 'FACULDADE DE TECNOLOGIA DO INSTITUTO EDUCACIONAL PROFISSIONALIZANTE DE JALES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3782, 4089, 'FACULDADE DE SIDROLANDIA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3783, 4090, 'FACULDADE DE ROSEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3784, 4091, 'FACULDADE DE TECNOLOGIA AD1', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3785, 4092, 'FACULDADE DE TECNOLOGIA PEDRO ROGERIO GARCIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3786, 4093, 'FACULDADE DE TECNOLOGIA DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3787, 4094, 'FACULDADE ESTACIO DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3788, 4095, 'FACULDADE DE TECNOLOGIA EQUIPE DARWIN', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3789, 4096, 'FACULDADE DE TECNOLOGIA TECBRASIL UNIDADE PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3790, 4097, 'FACULDADE DE TECNOLOGIA TECBRASIL UNIDADE BENTO GONCALVES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3791, 4098, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA FARROUPILHA', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3792, 4099, 'ESCOLA AGROTECNICA FEDERAL DE BARBACENA', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3793, 4100, 'FACULDADE DE TECNOLOGIA SENAI ITALO BOLOGNA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3794, 4101, 'FACULDADE DE TECNOLOGIA SENAI DE DESENVOLVIMENTO GERENCIAL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3795, 4102, 'FACULDADE DE TECNOLOGIA IBRATEC DE MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3796, 4103, 'FACULDADE METROPOLITANA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3797, 4104, 'ESCOLA SUPERIOR DE ENGENHARIA E GESTAO DE SAO PAULO ESEG', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3798, 4105, 'FACULDADES COSTA BRAGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3799, 4106, 'FAQ FACULDADE QUINZE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3800, 4107, 'FACULDADE DE TECNOLOGIA SENAI PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3801, 4108, 'INSTITUTO CATOLICO DE ESTUDOS SUPERIORES DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3802, 4109, 'FACULDADE DE SAUDE E MEDICINA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3803, 4110, 'FACULDADE DE CIENCIAS GERENCIAIS DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3804, 4111, 'ESCOLA SUPERIOR DE ADMINISTRACAO MARKETING E COMUNICACAO DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3805, 4112, 'FACULDADE TECNOLOGICA FILADELFIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3806, 4113, 'FACULDADE DE CERES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3807, 4114, 'FACULDADE TEOLOGICA CRISTA DO BRASIL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3808, 4116, 'FACULDADE MAURICIO DE NASSAU JABOATAO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3809, 4117, 'FACULDADE MAURICIO DE NASSAU MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3810, 4118, 'FACULDADE JOAQUIM NABUCO PAULISTA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3811, 4119, 'FACULDADE MAURICIO DE NASSAU GARANHUNS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3812, 4120, 'FACULDADE MAURICIO DE NASSAU CARUARU', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3813, 4121, 'FACULDADE TOBIAS BARRETO', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3814, 4122, 'CENTRO DE EDUCACAO TECNOCNOLOGICA RUI BARBOSA CETRB', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3815, 4123, 'FACULDADE JATAIENSE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3816, 4124, 'FACULDADE DOM HEITOR SALES', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3817, 4125, 'FACULDADE BATISTA IDA NELSON', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3818, 4126, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS E DE TECNOLOGIAS DE AGUA BOA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3819, 4127, 'ISEF INSTITUTO SUPERIOR DE EDUCACAO CENECISTA DE FARROUPILHA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3820, 4128, 'INSTITUTO DE EDUCACAO SUPERIOR DO PIAUI IESPI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3821, 4129, 'FACULDADE JOSE DE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3822, 4130, 'FACULDADE DE TECNOLOGIA DE CIENCIAS HOLISTICAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3823, 4131, 'FACULDADE DO DELTA DO PARNAIBA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3824, 4132, 'FACULDADE DE COLORADO FAC', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3825, 4133, 'FACULDADE DE EDUCACAO TECNOLOGICA SANTA GEMA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3826, 4134, 'INEJ INSTITUTO NACIONAL DE ESTUDOS JURIDICOS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3827, 4135, 'FACULDADE MAURICIO DE NASSAU MANAUS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3828, 4136, 'FACULDADE CANDIDO RONDON DE RONDONOPOLIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3829, 4137, 'INSTITUTO EVANGELICO SUPERIOR DE EDUCACAO CRISTO REI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3830, 4138, 'FACULDADE ANHANGUERA DE SANTA BARBARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3831, 4139, 'FACULDADE COMUNITARIA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3832, 4140, 'FACULDADE COMUNITARIA DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3833, 4141, 'FACULDADE ANHANGUERA DE TAUBATE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3834, 4142, 'FACULDADE UNIAO DE EDUCADORES E ESTUDANTES DO ENSINO SUPERIOR DE BRASILIA UNESB', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3835, 4143, 'FACULDADE EVANGELICA SHALOM', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3836, 4144, 'FACULDADE INTEGRADA GAMALIEL', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3837, 4145, 'CENTRO NACIONAL DE EDUCACAO A DISTANCIA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3838, 4146, 'FACULDADE DE CIENCIAS JURIDICAS DE ALAGOAS', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3839, 4147, 'FACULDADE TEOLOGICA DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3840, 4148, 'FACULDADE DE TECNOLOGIA SENAI SAO JOSE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3841, 4149, 'FACULDADE DE TECNOLOGIA SENAI ITAJAI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3842, 4150, 'FACULDADE DE TECNOLOGIA DE PIRACICABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3843, 4151, 'FACULDADE BOAVENTURA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3844, 4152, 'FACULDADE MAURICIO DE NASSAU JOAO PESSOA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3845, 4153, 'FACULDADE JOAQUIM NABUCO RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3846, 4154, 'FACULDADE MAURICIO DE NASSAU CAMPINA GRANDE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3847, 4155, 'FACULDADE JOAQUIM NABUCO CAMARAGIBE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3848, 4156, 'FACULDADE TECNOLOGICA DE SOORETAMA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3849, 4157, 'FACULDADE METROPOLITANA DE RIO DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3850, 4158, 'FACULDADE EVANGELICA DO MEARIM', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3851, 4159, 'FACULDADE PIRATININGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3852, 4160, 'FACULDADE DE TECNOLOGIA DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3853, 4161, 'INSTITUTO DE ENSINO SUPERIOR CAETANO VELOSO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3854, 4162, 'FACULDADE DE TECNOLOGIA SENAC GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3855, 4163, 'CENTRO UNIVERSITARIO BARRIGA VERDE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3856, 4164, 'FACULDADE EXODUS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3857, 4165, 'FACULDADE POTENCIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3859, 4167, 'INSTITUTO DE ENSINO SUPERIOR DA FUPESP', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3860, 4168, 'INSTITUTO DE ENSINO SUPERIOR DO TOCANTINS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3861, 4169, 'FACULDADE NOSSA CIDADE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3862, 4170, 'FACULDADE INTEGRADA SAO PEDRO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3863, 4171, 'ISAG INSTITUTO SUPERIOR DE ADMINISTRACAO E GESTAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3864, 4172, 'CENTRO DE ENSINO SUPERIOR DO SERVIDOR PUBLICO MARANHENSE CESPMA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3865, 4173, 'FACULDADE JK DE TECNOLOGIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3866, 4174, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS DE ENERGIA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3867, 4175, 'INSTITUTO UNIFICADO EUROPEU DO BRASIL IUNEBRASIL', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3868, 4176, 'FACULDADE DE MARILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3869, 4177, 'FACULDADE DE TECNOLOGIA DE SANTA MARIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3870, 4178, 'FACULDADE EVILASIO FORMIGA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3871, 4179, 'FACULDADE NAZARENA DO BRASIL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3872, 4180, 'FACULDADE HERRERO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3873, 4182, 'FACULDADE PRESBITERIANA SIMONTON IPES', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3874, 4183, 'FACULDADE PRESBITERIANA SIMONTON DE SAPEZAL IPES', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3875, 4184, 'INSTITUTO SUPERIOR DE EDUCACAO DE SERRANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3876, 4185, 'FACULDADE PERUIBE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3877, 4187, 'ISEFAJIPA INSTITUTO SUPERIOR DE EDUCACAO DE JI PARANA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3878, 4188, 'FACULDADE IAPEDEM ANAMACO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3879, 4189, 'INSTITUTO DE EDUCACAO SUPERIOR SAO JUDAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3880, 4190, 'UNIFOS UNIVERSO DE FORMACAO TECNICA E SUPERIOR', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3881, 4191, 'INSTITUTO SUPERIOR METROPOLITANA ISUME', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3882, 4192, 'FACULDADE METROPOLITANA DE TERESINA FAMET', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3883, 4193, 'INSTITUTO SUPERIOR DE EDUCACAO DO BRASIL ISEB', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3884, 4194, 'FACULDADE DO ALTO TIETE FAAT', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3885, 4195, 'FACULDADE PROFETA ABRAAO FAPA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3886, 4196, 'INSTITUTO BRASILEIRO ACADEMICO SOCIAL DE PESQUISAS E ENSINO IBRASPE', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3887, 4197, 'FACULDADE ALIANCA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3888, 4198, 'FACULDADE MINEIRENSE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3889, 4199, 'FACULDADE DE TECNOLOGIA ROGACIONISTA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3890, 4200, 'FACULDADE DE COMUNICACAO SOCIAL DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3891, 4201, 'FACULDADE DE ENSINO SUPERIOR DO NORDESTE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3892, 4202, 'FACULDADE ALFA FAAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3893, 4203, 'FACULDADE ABERTA DO BRASIL UNIABRA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3894, 4204, 'FACULDADE DE TECNOLOGIA INED   UNIDADE IPATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3895, 4205, 'ESCOLA SUPERIOR DO MINISTERIO PUBLICO DA UNIAO ESMPU', 1, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3896, 4206, 'INSTITUTO DE ENSINO SUPERIOR DE TAGUATINGA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3897, 4207, 'NAP ODONTO SC LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3898, 4208, 'FACULDADE DE TECNOLOGIA MONTEIRO LOBATO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3899, 4209, 'FACULDADE DE TECNOLOGIA CESAR LATTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3900, 4210, 'ESCOLA SUPERIOR DE ADMINISTRACAO, MARKETING E COMUNICACAO DO MORUMBI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3901, 4211, 'ESCOLA SUPERIOR DE ADMINISTRACAO, MARKETING E COMUNICACAO DE PERDIZES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3902, 4212, 'FACULDADE DE TECNOLOGIA DE POUSO ALEGRE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3903, 4213, 'FACULDADE DE CACAPAVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3904, 4214, 'INSTITUTO SUPERIOR PAULO FREIRE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3905, 4215, 'FACULDADE DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3906, 4216, 'INSTITUTO MOINHOS DE VENTO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3907, 4217, 'FACULDADE DE TECNOLOGIA INSTITUTO POLITECNICO DO PARANA UNIDADE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3908, 4218, 'FACULDADE PEDRO LEOPOLDO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3909, 4219, 'INSTITUTO SUPERIOR DE EDUCACAO PROFESSORA NAIR FORTES ABUMERHY', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3910, 4220, 'FACULDADE DE CIENCIAS GERENCIAIS DE BICAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3911, 4221, 'INSTITUTO SUPERIOR DE EDUCACAO DE BICAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3912, 4222, 'INSTITUTO SUPERIOR DE EDUCACAO DE MATIAS BARBOSA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3913, 4223, 'FACULDADE SANTOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3914, 4224, 'FACULDADE DE ITAPECIRICA FACITA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3915, 4225, 'FACULDADE DE TECNOLOGIA LUIZ ADELAR SCHEUER', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3916, 4227, 'FACULDADE DE TECNOLOGIA SENAC PASSO FUNDO PASSO FUNDO RS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3917, 4228, 'INSTITUTO DE EDUCACAO SUPERIOR MISSOES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3918, 4229, 'FACULDADE PARANTINGA FAP', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3919, 4230, 'FACULDADE TECNOLOGICA UNIVERSAL DE FORMACAO TECNICA E SUPERIOR', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3920, 4233, 'INSTITUTO METROPOLITANO DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3921, 4234, 'SOCIEDADE EVOLUCAO DE TECNOLOGIA E EDUCACAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3922, 4235, 'FACULDADE TRIANGULO MINEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3923, 4236, 'FACULDADES INTEGRADAS DE SERRANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3924, 4237, 'CENTRO FEDERAL DE EDUCACAO TECNOLOGICA DO AMAZONAS', 1, 1, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3925, 4239, 'FACULDADE ACAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3926, 4241, 'FACULDADE DE CIENCIAS HUMANAS SOCIAIS E TECNOLOGICAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3927, 4243, 'FACULDADE DE CIENCIAS GERENCIAIS DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3928, 4244, 'FACULDADE DE TECNOLOGIA ENSITEC', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3929, 4245, 'FACULDADE DE TECNOLOGIA DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3930, 4246, 'PROGRAMA DE POS GRADUACAO LATO SENSU DA FUNDACAO UNIMED', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3931, 4247, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS SAO PAULO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3932, 4248, 'INSTITUTO DE ENSINO PESQUISA E POS GRADUACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3933, 4249, 'FACULDADE DE CIENCIAS DE ALAGOAS FACAL', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3934, 4250, 'FACULDADE DE CIENCIAS GERENCIAIS ALVES FORTES (JUIZ DE FORA)', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3935, 4251, 'FACULDADE PITAGORAS DE TECNOLOGIA DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3936, 4252, 'FACULDADE DE TECNOLOGIA EXPOENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3937, 4253, 'ESCOLA AGROTECNICA FEDERAL DE CONCORDIA', 1, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3938, 4254, 'FACULDADES INTEGRADAS DA TERRA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3939, 4255, 'FACULDADES INTEGRADAS DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3940, 4256, 'FACULDADES INTEGRADAS PITAGORAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3941, 4257, 'INSTITUTO DE FILOSOFIA E TEOLOGIA DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3942, 4258, 'FACULDADE PURIFICACAO LTDA', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3943, 4259, 'FACULDADE DE INHUMAS FACMAIS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3944, 4260, 'FACULDADE DE TECNOLOGIA DE SAO LEOPOLDO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3945, 4261, 'FACULDADE DE TECNOLOGIA DE PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3946, 4262, 'FACULDADE DE TECNOLOGIA IDESC', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3947, 4263, 'FACULDADE ESPIRITA RAMATIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3948, 4264, 'INSTITUTO FIGUEIREDO DE EDUCACAO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3949, 4265, 'UNEPPSI UNIDADE DE ENSINO E PESQUISA EM PSICOLOGIA E PSICANALISE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3950, 4266, 'INSTITUTO GUERRA BIAGI INGB', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3951, 4267, 'INSTITUTO SUPERIOR DE EDUCACAO DA AMERICA LATINA ISAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3952, 4268, 'FACULDADE ISAG', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3953, 4269, 'SOCIEDADE BRASILEIRA DE EDUCACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3954, 4270, 'FACULDADE LIBERTAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3955, 4271, 'INSTITUTO SUPERIOR EM CIENCIAS DA HUMANIDADE', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3956, 4272, 'INSTITUTO MODAL LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3957, 4273, 'INSTITUTO SUPERIOR DE EDUCACAO SEESB', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3958, 4274, 'INSTITUTO TEOLOGICO DA ASSEMBLEIA DE DEUS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3959, 4275, 'INSTITUTO DE ENSINO E PESQUISA EM ADMINISTRACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3960, 4276, 'IETEC', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3961, 4277, 'FACULDADE LITERATUS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3962, 4278, 'FACULDADE INTEGRADA SANTA RITA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3963, 4279, 'FACULDADE DE TECNOLOGIA INSTITUTO POLITECNICO DO PARANA UNIDADE GUARAPUAVA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3964, 4280, 'FACULDADE INTEGRADA CIDADE DE PATOS DE MINAS LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3965, 4281, 'FACULDADE AMBIENTAL DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3966, 4282, 'FACULDADE PARA O DESENVOLVIMENTO DO ESTADO DE SAO PAULO FADESP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3967, 4283, 'FACULDADE IASOCIAL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3968, 4284, 'FACULDADE SAO FRANCISCO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3969, 4285, 'FUNDACAO INSTITUTO DE ADMINISTRACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3970, 4286, 'FACULDADE PRATA FAP', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3971, 4287, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS DO XINGU E AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3972, 4288, 'UNIED TECNOLOGIA EDUCACIONAL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3973, 4289, 'FACULDADE DO VALE ELVIRA DAYRELL FAVED', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3974, 4290, 'FACULDADE DE ARTES INTEGRADAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3975, 4291, 'IEMS INSTITUTO EDUCACIONAL MORADA DA SERRA DO MUNICIPIO DE CUIABA MT', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3976, 4292, 'ITECSS INSTITUTO TIRADENTES DE EDUCACAO EM CIENCIAS SOCIAIS E DA SAUDE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3977, 4293, 'FACULDADE INTEGRACAO TIETE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3978, 4294, 'FACULDADE DE TECNOLOGIA SENAC JARAGUA DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3979, 4295, 'FACULDADE DE TECNOLOGIA SENAI CETIND', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3980, 4296, 'INSTITUTO BRASILEIRO DE CIENCIAS CRIMINAIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3981, 4297, 'CENTRO DE ESTUDOS PROF JOSE BELMIRO DE CASTRO MOREIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3982, 4298, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3983, 4299, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA RS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3984, 4300, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECCAO PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3985, 4301, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL ABO DF', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3986, 4302, 'ASSOCIACAO CATARINENSE DE ODONTOLOGIA ESPECIALIZADA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3987, 4303, 'SOCIEDADE DOS CIRURGIOES DENTISTAS DE PERNAMBUCO ABO PE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3988, 4304, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL DA ABO RO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3989, 4305, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA ES RVV', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3990, 4306, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL DA ASSOCIACAO BRASILEIRA DE ODONTOLOGIA REGIONAL POUSO ALEGRE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3991, 4307, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3992, 4308, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECCAO AMAPA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3993, 4309, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO TOCANTINS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3994, 4310, 'UNIS MG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3995, 4311, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL ABO AL', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3996, 4312, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3997, 4313, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAOPAULO REGIONAL BIRIGUI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3998, 4314, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL LINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (3999, 4315, 'FACULDADE DE TEOLOGIA E CIENCIAS DA RELIGIAO', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4000, 4316, 'FACULDADE DE TECNOLOGIA SANTOS DUMONT', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4001, 4317, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4002, 4318, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4003, 4319, 'CAP ABORJ CENTRO DE APERFEICOAMENTO PROFISSIONAL DA ABO RJ', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4004, 4320, 'ESCOLA DE POS GRADUACAO ASSOCIACAO BRASILEIRA DE ODONTOLOGIA REGIONAL DE CASCAVEL PR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4005, 4321, 'IETEC INSTITUTO DE CIENCIA E TECNOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4006, 4322, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4007, 4323, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA REGIONAL CARIRI', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4008, 4324, 'FACULDADE GONZAGA DE PELOTAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4009, 4325, 'EAP ABO MURIAE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4010, 4326, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL ASSOCIACAO BRASILEIRA DE ODONTOLOGIA REGIONAL JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4011, 4327, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4012, 4328, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4013, 4329, 'FACULDADE DO CENTRO EDUCACIONAL MINEIRO FACEM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4014, 4330, 'FACULDADE DE TECNOLOGIA AMERICA DO SUL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4015, 4331, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL ARACATUBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4016, 4332, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4017, 4333, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL ARARAQUARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4018, 4334, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL SERTAOZINHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4019, 4335, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4020, 4336, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL RIBEIRAO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4021, 4337, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL PRESIDENTE PRUDENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4022, 4338, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL CATANDUVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4023, 4339, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL VALE DO PARAIBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4024, 4340, 'FACULDADE DE ENSINO SUPERIOR DE VALENCA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4025, 4341, 'ASSOCIACAO MARINGAENSE DE ODONTOLOGIA AMO ABO REGIONAL MARINGA PR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4026, 4342, 'FACULDADE STAR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4027, 4343, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL DA ABO MS', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4028, 4344, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL DA ABO PI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4029, 4345, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL DA ABO BA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4030, 4346, 'FACULDADE DE ENSINO SUPERIOR DE MIGUEL ALVES', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4031, 4347, 'FACULDADE SERRA DOS PIRINEUS DE EDUCACAO DE CIENCIAS APLICADAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4032, 4348, 'FACULDADE DE COMUNICACAO TECNOLOGIA E CIENCIA FACTEC', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4033, 4349, 'ABO REGIONAL SETE LAGOAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4034, 4350, 'E A B ASSOCIACAO BRASILEIRA DE ODOTOLOGIA RJ D DE CAXIAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4035, 4351, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4036, 4352, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA REGIONAL OSASCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4037, 4353, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL ABC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4038, 4354, 'AFISVEC', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4039, 4355, 'FACULDADE DE TECNOLOGIA DE PALMAS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4040, 4356, 'FACULDADE DE CIENCIAS SOCIAIS DOS PALMARES', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4041, 4357, 'FACULDADE DE TECNOLOGIA ALVARES DE AZEVEDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4114, 4432, 'FACULDADE GERACAO POSITIVA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4042, 4358, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO SUL DE MINAS GERAIS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4043, 4359, 'ESCOLA AGROTECNICA FEDERAL DE SATUBA', 1, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4044, 4360, 'ESCOLA AGROTECNICA FEDERAL DE MACHADO', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4045, 4361, 'FACULDADE DE CIENCIAS GERENCIAIS DE SANTA LUZIA MG FAGESA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4046, 4362, 'FACULDADE PITAGORAS DE BETIM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4047, 4363, 'INSTITUTO SANTA MONICA DE ESTUDOS E PESQUISAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4048, 4364, 'FACULDADE QUASAR', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4049, 4365, 'FABS FACULDADE DE BOM SUCESSO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4050, 4366, 'EAP ESCOLA DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4051, 4367, 'FACULDADE TERRA NORDESTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4052, 4368, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4053, 4369, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL EAP ABO RN', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4054, 4370, 'SANTA CASA DE MISERICORDIA DE PONTA GROSSA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4055, 4371, 'FACULDADE PADRE ANCHIETA DE CAJAMAR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4056, 4372, 'U E P UNIDADE DE ENSINO PROFISSIONAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4057, 4373, 'FACULDADE DE EDUCACAO CIENCIA E TECNOLOGIA DE REDENCAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4058, 4374, 'CURSO DE TEOLOGIA E PASTORAL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4059, 4375, 'UNC SALVADOR UNIDADE AVANCADA DE POS GRADUACAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4060, 4376, 'IBEG POS GRADUACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4061, 4377, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL EAP', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4062, 4378, 'NUCLEO DE ESTUDOS ORTODONTICOS MBT BRASIL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4063, 4379, 'ASSOCIACAO DE CIRURGIOES DENTISTAS DO ESTADO DE SAO PAULO', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4064, 4380, 'CENTRO DE QUALIFICACAO ODONTOLOGICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4065, 4381, 'ACADEMIA NORTE RIO GRANDENSE DE ODONTOLOGIA', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4066, 4382, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA REGIONAL PETROPOLIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4067, 4383, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECCAO DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4068, 4384, 'CESVIA FACULDADE DE VIAMAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4069, 4386, 'ESAB ESCOLA SUPERIOR ABERTA DO BRASIL', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4070, 4387, 'NETT ODONTO NUCLEO DE ESPECIALIZACAO TREINAMENTO E TRATAMENTO ODONTOLOGICO S C LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4071, 4388, 'IPEC INSTITUTO PAULISTA DE EDUCACAO CONTINUADA LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4072, 4389, 'FACULDADE INTEGRADA CARAJAS DE MARABA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4073, 4390, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL DA ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECCAO SERGIPE', 2, 1, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4074, 4391, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4075, 4392, 'FATEC DE CONTAGEM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4076, 4393, 'INSTITUTO SUPERIOR DE CIENCIAS DO COMPORTAMENTO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4077, 4394, 'FACULDADE DE EDUCACAO FISICA DE ARAGUAINA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4078, 4395, 'FACULDADE DE DIREITO DE ARAGUAINA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4079, 4396, 'FACULDADES INTEGRADAS DE MINEIROS', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4080, 4397, 'ESCOLA SUPERIOR DE ENSINO DA SEICHO NO IE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4081, 4398, 'INSTITUTO SUPERIOR DE EDUCACAO DE GOIANA', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4082, 4399, 'FACULDADE DE BALSAS', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4083, 4400, 'INSTITUTO DE ESTUDOS DA SAUDE POS GRADUACAO EM CIENCIAS DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4084, 4401, 'FACULDADE DE APIAI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4085, 4403, 'FACULDADE DA ACADEMIA MEMORIAL DE ENSINO SUPERIOR DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4086, 4404, 'INSTITUTO SEDES SAPIENTIAE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4087, 4405, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA REGIONAL DE FOZ DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4088, 4406, 'ASSOCIACAO BRAS DE ODONTO SEC DE GOIAS SUB SEC DE JATAI', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4089, 4407, 'FACULDADE DE ENSINO SUPERIOR DA TERRA PAULISTA FATERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4090, 4408, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL ABO RN REGIONAL MOSSORO', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4091, 4409, 'ASSOCIACAO INSTITUTO DE FOMENTO EDUCACIONAL FENIX', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4092, 4410, 'CRDA POS GRADUACOES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4093, 4411, 'FACULDADE PANAMERICANA DE JIPARANA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4094, 4412, 'FACULDADE VALE DO ARAGUAIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4095, 4413, 'ASSOCIACAO VITA CARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4096, 4414, 'INSTITUTO SUPERIOR DE EDUCACAO VALE DO ARAGUAIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4097, 4415, 'FSD FACULDADE SAO DOMINGOS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4098, 4416, 'FACULDADE JK   UNIDADE I   GAMA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4099, 4417, 'FACULDADE DE ENFERMAGEM DE BELO JARDIM', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4100, 4418, 'FACULDADE SAO BERNARDO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4101, 4419, 'INSTITUTO DE PESQUISA E ENSINO EM SAUDE ANIMAL IPESA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4102, 4420, 'FACULDADES INTEGRADAS BARROS MELO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4103, 4421, 'FACULDADE DE TECNOLOGIA SENAI BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4104, 4422, 'FACULDADE DE TECNOLOGIA DO ABC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4105, 4423, 'FACULDADE ADVENTISTA DE ENFERMAGEM DO NORDESTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4106, 4424, 'LIBERTAS CLINICA ESCOLA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4107, 4425, 'FACULDADE CORPO MENTE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4108, 4426, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA REGIONAL ANAPOLIS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4109, 4427, 'FACULDADE DAS CIENCIAS MULTIPLAS E DO MEIOAMBIENTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4110, 4428, 'FACULDADE PROFESSOR MIGUEL ANGELO DA SILVA SANTOS', 3, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4111, 4429, 'FACULDADE UNIGRAN CAPITAL', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4112, 4430, 'ITAL INSTITUTO DE TECNOLOGIA DE ALIMENTOS', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4113, 4431, 'FACULDADE DE ENFERMAGEM NOVA ESPERANCA DE MOSSORO FACENERN', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4115, 4433, 'FAWEST FACULDADE WESTPHALIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4116, 4434, 'INSTITUTO DE DIREITO ROMEU FELIPE BACELLAR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4117, 4435, 'FACULDADE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4118, 4436, 'FACULDADE BIG MASTER', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4119, 4437, 'CENTRO ODONTOLOGICO DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4120, 4438, 'ACADEMIA BRASILEIRA DE DIREITO CONSTITUCIONAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4121, 4439, 'COOENSINO COOPERATIVA DE ENSINO UNIVERSAL DOIS MIL', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4122, 4440, 'FACULDADE DE MEDICINA NOVA ESPERANCA DE NATAL FAMENE RN', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4123, 4441, 'SISTEMA EDUCACIONAL SUPERIOR UNIVERSITARIO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4124, 4442, 'ESCOLA SUPERIOR PAULISTA DE ADMINISTRACAO ESPA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4125, 4443, 'FACULDADE RIO CLARO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4126, 4444, 'CBPEX POS GRADUACAO', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4127, 4445, 'FACULDADE MEDIANEIRA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4128, 4446, 'FACULDADE CIDADE DE GUANHAES FACIG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4129, 4447, 'SOCIEDADE BRASILEIRA DE DIREITO PUBLICO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4130, 4448, 'SOCIEDADE BRASILEIRA DE DIREITO PUBLICO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4131, 4449, 'FACULDADE DE TECNOLOGIA DO NORTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4132, 4450, 'FACULDADE METROPOLITANA DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4133, 4451, 'FACULDADE TEOLOGICA E EDUCACIONAL AGAPE COMUNITARIA FATEAC', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4134, 4452, 'FACULDADE METROPOLITANA DE MARABA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4135, 4454, 'FACULDADE PITAGORAS DE NOVA LIMA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4136, 4455, 'GESTOS GRUPO DE ESTUDOS ORTODONTICOS E SERVICOS S C LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4137, 4456, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4138, 4457, 'INSTITUTO SUPERIOR DE EDUCACAO DE ITAPECIRICA DA SERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4139, 4458, 'INSTITUTO DE ENSINO SUPERIOR DE MACEIO IESMA', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4140, 4459, 'INEES INSTITUTO DE EDUCACAO E ESPECIALIZACAO SUPERIOR', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4141, 4460, 'FACULDADE DOM PEDRO II DE TECNOLOGIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4142, 4461, 'FACULDADE DE TECNOLOGIA SENAI CESAR RODRIGUES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4143, 4462, 'ESCOLA DE GESTAO E CONTROLE FRANCISCO JURUENA', 2, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4144, 4463, 'GRUPO DE ESTUDO ODONTOLOGICO E SERVICOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4145, 4464, 'FACULDADE LAGEANA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4146, 4465, 'CENTRO ODONTOLOGICO DE ESTUDOS E PESQUISAS COESP', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4147, 4466, 'CENTRO DE ESTUDOS PROF DIRCEU VIEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4148, 4467, 'IACE INSTITUTO AVANCADO DE CIENCIAS E EDUCACAO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4149, 4468, 'INSTITUTO APICE DE ENSINO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4150, 4469, 'FACULDADE HEXAGONO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4151, 4470, 'TVALLE ASSESSORIA E TREINAMENTO EDUCACIONAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4152, 4471, 'FACULDADE DE TECNOLOGIA POLITEC', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4153, 4472, 'CESDE BRASIL INTELIGENCIA EDUCACIONAL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4154, 4473, 'FACULDADE DE TECNOLOGIA ACCTIVA DE CIENCIA E TECNOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4155, 4474, 'ESCOLA PAULISTANA DE ODONTOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4156, 4475, 'ESCOLA CAPIXABA DE ODONTOLOGIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4157, 4476, 'ESCOLA PAULISTA DE ODONTOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4158, 4477, 'ENSINO A DISTANCIA SLMANDIC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4159, 4478, 'ESCOLA BRASILIENSE DE ODONTOLOGIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4160, 4479, 'ESCOLA CHAPECOENSE DE ODONTOLOGIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4161, 4480, 'ESCOLA CAMBORIU DE ODONTOLOGIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4162, 4481, 'ESCOLA FLUMINENSE DE ODONTOLOGIA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4163, 4482, 'ESCOLA DO NORDESTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4164, 4483, 'ESCOLA CEARENSE DE ODONTOLOGIA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4165, 4484, 'CENTRO DE PESQUISAS ODONTOLOGICAS SAO LEOPOLDO MANDIC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4166, 4485, 'ESCOLA FORENSE DE ODONTOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4167, 4486, 'ESCOLA MINEIRA DE ODONTOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4168, 4487, 'SOBRACURSOS CURSOS DE POS GRADUACAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4169, 4488, 'ESCOLA METROPOLITANA DE ODONTOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4170, 4489, 'ESCOLA SANTISTA DE ODONTOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4171, 4490, 'FACULDADE SENADOR CANEDO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4172, 4491, 'FACULDADE TECNOLOGICA ITAI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4173, 4492, 'FACULDADE PASCHOAL DANTAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4174, 4493, 'FACULDADE DE TECNOLOGIA CERTUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4175, 4494, 'COORDENADORIA DE ENSINO A DISTANCIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4176, 4495, 'FACULDADE ANHANGUERA JARAGUA DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4177, 4496, 'FACULDADE DE TECNOLOGIA DO VALE DO IVAI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4178, 4497, 'WP CENTRO DE PSICOTERAPIA COGNITIVO COMPORTAMENTAL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4179, 4498, 'CENTRO DE ENSINO TEORICO TECNICO DE TRANSITO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4180, 4499, 'CENTRO DE ENSINO TEORICO TECNICO DE TRANSITO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4181, 4500, 'FACULDADE DE TECNOLOGIA EM SAUDE DO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4182, 4501, 'FACULDADE DE TECNOLOGIA ALTO TIETE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4183, 4502, 'FACULDADES INTEGRADAS CAMPOGRANDENSES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4184, 4503, 'UNIVERSIDADE FEDERAL DO RECONCAVO DA BAHIA', 1, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4185, 4504, 'FUNDACAO UNIVERSIDADE FEDERAL DA GRANDE DOURADOS', 1, 1, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4186, 4505, 'FACULDADE FACISA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4187, 4506, 'CEFE CENTRO DE ESTUDOS DE FISIOLOGIA DO EXERCICIO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4188, 4507, 'INSTITUTO SUPERIOR XAVIER CORDEIRO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4189, 4508, 'FACULDADE DE ENSINO SUPERIOR DE FLORIANO PI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4190, 4509, 'INSTITUTO SUL BRASILEIRO DE ENSINO SUPERIOR INSBES', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4191, 4510, 'FASOMA FACULDADE SOLUCAO MARANHENSE LTDA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4192, 4511, 'IPPEO INSTITUTO PARANAENSE DE PESQUISA E ENSINO EM ODONTOLOGIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4193, 4512, 'FACULDADE AGUIAS DO DIREITO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4194, 4513, 'FATEB', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4195, 4514, 'ESCOLA SUPERIOR DA MAGISTRATURA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4196, 4515, 'ABO REGIONAL DE TAGUATINGA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4197, 4516, 'INSTITUTO CHIAVENATO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4198, 4517, 'FACULDADE DE EDUCACAO DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4199, 4518, 'FACULDADE REGIONAL PALMITOS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4200, 4519, 'OPEG FACULDADE DE TECNOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4201, 4520, 'FACULDADE CENACAP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4202, 4521, 'FACULDADE DE CIENCIAS APLICADAS DE ITAPEVA FACITA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4203, 4522, 'CENTRO UNIVERSITARIO CATOLICO SALESIANO AUXILIUM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4204, 4523, 'FACULDADE DO INSTITUTO EDUCACIONAL PROFISSIONALIZANTE DE JALES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4205, 4524, 'INSTITUTO TECNOLOGICO DE AVALIACAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4206, 4525, 'FACULDADE TECNOLOGICA DE EXCELENCIA EDUCACIONAL DO RIO GRANDE DO NORTE', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4207, 4526, 'FACULDADES INTEGRADAS LAVOISIER', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4208, 4527, 'FACULDADE DE URUACU', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4209, 4528, 'IBEXP INSTITUTO BRASILEIRO DE EXECUTIVOS PROFISSIONAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4210, 4530, 'FACULDADE INTEGRADA TIRADENTES', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4211, 4531, 'FACULDADE ADVENTISTA DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4212, 4532, 'FACULDADE DE TECNOLOGIA SENAI CAMPO GRANDE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4213, 4533, 'FACULDADE SAO FRANCISCO DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4214, 4534, 'FACULDADE HERRERO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4215, 4535, 'FACULDADE DA AMAZONIA FAMA', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4216, 4536, 'IPEO MT', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4217, 4537, 'INSTITUTO SUPERIOR DE EDUCACAO DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4218, 4538, 'FACULDADE PARQUE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4219, 4539, 'FACULDADE DE TEOLOGIA E CIENCIAS HUMANAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4220, 4540, 'FACULDADES CONE SUL', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4221, 4541, 'CENTRO BAIANO DE ESTUDOS ODONTOLOGICOS CEBEO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4222, 4542, 'INSTITUTO BIOSFERA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4223, 4543, 'FACULDADE DE EDUCACAO E ESTUDOS SUPERIORES DE AREIA FAESA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4224, 4544, 'FACULDADE LIDER', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4225, 4545, 'FACULDADE PARANATINGA FAP', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4226, 4546, 'FACULDADE METODISTA UNIAO URUGUAIANA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4227, 4547, 'CENTRO DE ESTUDOS E APERFEICOAMENTO PROFISSIONAL', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4228, 4548, 'CAP CENTRO DE APERFEICOAMENTO PROFISSIONAL', 3, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4229, 4550, 'INSTITUTO DE ENSINO PEDAGOGOS ASSOCIADOS INESPA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4230, 4551, 'FACULDADES ASSOC DE MONACO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4231, 4552, 'FACULDADE ECUMENICA LAYRA DE ALTO PARAISO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4232, 4553, 'FACULDADE MERIDIONAL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4233, 4554, 'FUNDACAO CARDIOVASCULAR SAO FRANCISCO DE ASSIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4234, 4555, 'INSTITUTO DE EDUCACAO A DISTANCIA NORTE FLUMINENSE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4235, 4556, 'FACULDADE EVOLUCAO DE CIENCIAS E TECNOLOGIA FECET', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4236, 4557, 'CLINICA INTEGRADA DE ODONTOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4237, 4558, 'FACULDADE CENECISTA DE ALTA FLORESTA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4238, 4559, 'INSTITUTO SUPERIOR LAGEANO DE EDUCACAO A DISTANCIA ISLED', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4239, 4560, 'FACULDADE DE SENHOR DO BOMFIM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4240, 4561, 'FACULDADE SANTO ANTONIO DE QUEIMADAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4241, 4562, 'FACULDADE LUZ DE GUARABIRA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4242, 4563, 'FACULDADE DE TECNOLOGIA DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4243, 4564, 'FACULDADE SANTA RITA DE CASSIA FASARC', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4244, 4565, 'INSTITUTO EDUCACIONAL SEMINARIO PAULOPOLITANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4245, 4566, 'ESTACIO FATERN FACULDADE ESTACIO DO RIO GRANDE DO NORTE', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4246, 4567, 'FACULDADE CENTRO MATOGROSSENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4247, 4568, 'FACULDADE ECA DE QUEIROZ SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4248, 4569, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL DA APCD REGIONAL TAUBATE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4249, 4570, 'FACULDADE DE TEOLOGIA DE SELVIRIA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4250, 4571, 'INSTITUTO IPESP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4251, 4572, 'FACULDADE DE TEOLOGIA E EDUCACAO DE MINAS GERAIS FATEMIG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4252, 4573, 'IBTEC INSTITUTO BRASILEIRO DE TECNOLOGIA E CIENCIAS', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4253, 4574, 'FACULDADE JACQUES COUSTEAU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4254, 4575, 'INSTITUTO DE CIENCIAS DO TRABALHO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4255, 4576, 'CENTRO DE ENSINO SUPERIOR LEOPOLDINENSE ALBERT EINSTEIN', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4256, 4577, 'ISAE FGV PARANA INSTITUTO SUPERIOR DE ADMINISTRACAO E ECONOMIA DO PARANA FUNDACAO GETULIO VARGAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4257, 4578, 'FACULDADE CARLOS CHAGAS FILHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4258, 4579, 'FACULDADE DO SUDESTE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4259, 4580, 'FACULDADE REUNIDA DE ILHA SOLTEIRA MESMO QUE 1625', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4260, 4581, 'CENTRO LUMEN DE EXTENSAO E POS GRAFUACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4261, 4582, 'FACULDADE CENTRO SUL DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4262, 4583, 'FACULDADE PITAGORAS DE ITABUNA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4263, 4584, 'FACULDADE DE TECNOLOGIA MACHADO DE ASSIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4264, 4585, 'ESCOLA SUPERIOR DA MAGISTRATURA DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4265, 4586, 'FACULDADE DO NORTE GOIANO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4266, 4587, 'FACULDADE UNIVERSAL DE FORMACAO TECNOLOGICA E SUPERIOR UNIFOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4267, 4588, 'FACULDADE APOGEU', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4268, 4589, 'FACULDADE DE DIREITO DO DISTRITO FEDERAL FDDF', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4269, 4590, 'FACULDADE DE TECNOLOGIA FATEP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4270, 4592, 'FACULDADE DE OURO PRETO DO OESTE', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4271, 4593, 'CENTRO EURO AMERICANO DE GESTAO E HOSPITALIDADE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4272, 4594, 'FACULDADE CATOLICA DE RONDONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4273, 4595, 'DEPARTAMENTO DE APERFEICOAMENTO PROFISSIONAL DAP', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4274, 4596, 'FACULDADE REGES DE RIBEIRAO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4275, 4597, 'FACULDADE DE CIENCIAS GERENCIAIS EM VOTUPORANGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4276, 4598, 'FACULDADE DE CIENCIAS GERENCIAIS BARAO DE JUNDIAI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4277, 4599, 'INSTITUTO EL SHADDAY DE TEOLOGIA E MISSOES', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4278, 4600, 'FACULDADE DE TECNOLOGIA DE MACAPA FATEMA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4279, 4601, 'FACULDADE TECNOLOGICA CRISTO REI', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4280, 4602, 'FUNDACAO ESCOLA SUPERIOR DO MPDFT', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4281, 4603, 'INSTITUTO DE TECNOLOGIA EM SAUDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4282, 4604, 'FWM FACULDADE TEOLOGICA E APOLOGETICA DR WALTER MARTIN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4283, 4605, 'FACULDADE DE ENSINO SUPERIOR KM 125', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4284, 4606, 'FACULDADE DE TECNOLOGIA CONTEC UNIDADE DE CARAPINA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4285, 4607, 'ESCOLA SUPERIOR KLYMUS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4286, 4608, 'FACULDADE 2001', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4287, 4609, 'FATESP FACULDADE TEOLOGICA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4288, 4610, 'FACULDADE DE TECNOLOGIA ASSESSORITEC', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4289, 4611, 'FACULDADE PLANALTO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4290, 4612, 'ISEBES INSTITUTO BETH SHALOM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4291, 4613, 'FACULDADE DE EDUCACAO E MEIO AMBIENTE', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4292, 4614, 'FACULDADE APROVACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4293, 4615, 'ACADEMIA DE GESTAO FISCAL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4294, 4616, 'FACULDADE ANHANGUERA DE CAXIAS DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4295, 4617, 'ATAME POS GRADUACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4296, 4618, 'E A P ESCOLA DE APERFEICOAMENTO PROFISSIONAL ABO RJ REGIONAL DUQUE DE CAXIAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4297, 4619, 'SINDICATO DOS ODONTOLOGISTAS DO ESTADO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4298, 4620, 'FACULDADE EVANGELICA CEILANDIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4299, 4621, 'FACULDADE EVANGELICA AGUAS CLARAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4300, 4622, 'FACULDADE EVANGELICA TAGUATINGA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4301, 4623, 'FACULDADE LATINO AMERICANA DE TEOLOGIA INTEGRAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4302, 4624, 'FACULDADE DE ODONTOLOGIA', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4303, 4625, 'A C CONSULTING LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4304, 4626, 'FACIDER II', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4305, 4627, 'SAO JUDAS FACULDADES INTEGRADAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4306, 4628, 'ESCOLA SUPERIOR VERBO JURIDICO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4307, 4629, 'FACULDADE DE TECNOLOGIA FUNDETEC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4308, 4630, 'FACULDADE DE TECNOLOGIA TECMED', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4309, 4631, 'FACULDADE ANGLOAMERICANO DE JOAO PESSOA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4310, 4632, 'FACULDADE ANGLOAMERICANO DE CAXIAS DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4311, 4633, 'FACULDADE ANGLOAMERICANO DE PASSO FUNDO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4312, 4634, 'ESCOLA AGROTECNICA FEDERAL DE ALEGRE', 1, 1, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4313, 4635, 'FACULDADE INTEGRADO DA COMCAM', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4314, 4636, 'FACULDADES INTEGRADAS INTERAMERICANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4315, 4637, 'FACULDADE DE RELACOES INTERNACIONAIS SERGIO VIEIRA DE MELLO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4316, 4638, 'FACULDADE TEOLOGICA BATISTA EQUATORIAL', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4317, 4639, 'FACULDADE IJUI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4318, 4640, 'ESCOLA DE TERAPIA MANUAL E POSTURAL S S LTDDA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4319, 4641, 'UNIDIDATICO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4320, 4642, 'FACULDADE UNIREAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4321, 4643, 'INSTITUTO SAO PAULO DE ESTUDOS SUPERIORES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4322, 4644, 'UNIEXODOS FACULDADE DE TECNOLOGIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4323, 4645, 'INSTITUTO BRASILEIRO DE CHI KUNG E TERAPIAS AFINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4324, 4646, 'IPG INSTITUTO DE POS GRADUACAO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4325, 4647, 'FACULDADE DE REABILITACAO DO PLANALTO CENTRAL FARPLAC', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4326, 4648, 'DEPARTAMENTO DE ENSINO E CULTURA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4327, 4649, 'JRK ESCOLA DE POS GRADUACAO EM ODONTOLOGIA LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4328, 4650, 'FACULDADE DA AMAZONIA', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4329, 4651, 'FACULDADES ANDEF', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4330, 4652, 'FACULDADE ANHANGUERA DE SAO JOSE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4331, 4653, 'FACULDADE COMUNITARIA DE GUARATINGUETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4332, 4654, 'FACULDADE COMUNITARIA DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4333, 4655, 'FACULDADE ANHANGUERA DE SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4334, 4656, 'FACULDADE ANHANGUERA DE PIRACICABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4335, 4657, 'FACULDADE DE EDUCACAO E ENSINO SUPERIOR TECNOLOGICO FAEST', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4336, 4658, '3158 INSTITUTO SUPERIOR DE EDUCACAO ANGLO AMERICANO DE FOZ DO IGUACU ISEAAFI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4337, 4659, 'FACULDADE DE TEOLOGIA EDUCACAO E CIENCIAS FATEC', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4338, 4660, 'UNIPESSOA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4339, 4661, 'FACULDADE DE AGRONEGOCIO PARAISO DO NORTE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4340, 4662, 'INSTITUTO LATINO AMERICANO DE PESQUISA E ENSINO ODONTOLOGICO ILAPEO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4341, 4663, 'NAP INSTITUTO DE ENSINO SUPERIOR LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4342, 4664, 'FAEPO NUCLEO DE POS GRADUACAO E PESQUISA EM ODONTOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4343, 4665, 'SOCIEDADE DE EDUCACAO E CULTURA CAICARAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4344, 4666, 'FACULDADE DE RONDONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4345, 4667, 'FACULDADE RIO SONO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4346, 4668, 'FACULDADE COMUNITARIA DE SUMARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4347, 4669, 'FACULDADE DELTA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4348, 4670, 'FACULDADE DE ENSINO SUPERIOR E TECNOLOGIA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4349, 4671, 'IOCP CEPOS CENTRO DE ESTUDOS E POS GRADUACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4350, 4672, 'FACULDADE EMPREENDEDORA AURORA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4351, 4673, 'ESCOLA SUPERIOR DE TEOLOGIA E FILOSOFIA DO BRASIL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4352, 4674, 'FACULDADE PORTO DAS AGUAS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4353, 4675, 'JUSPODIVM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4354, 4676, 'SENAI DENDEZEIROS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4355, 4677, 'UNIVERSIDADE JOSE DO ROSARIO VELLANO UNIFENAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4356, 4678, 'INSTITUTO DE DERMATOLOGIA MEDICINA E CIRURGIA ESTETICA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4357, 4679, 'FESPPAR FACULDADE EDUCACIONAL DE PINHAIS DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4358, 4680, 'FEPPAR FACULDADE EDUCACIONAL DE PIRAQUARA DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4359, 4681, 'FACULDADE CENTRO PAULISTANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4360, 4682, 'FACULDADE INTEGRADA BRASILEIRA RENASCENCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4361, 4683, 'PROJECTO CENTRO CULTURAL E DE FORMACAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4362, 4684, 'BUSINESS SCHOOL CEDEPE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4363, 4685, 'FACULDADES INTEGRADAS PLURAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4364, 4686, 'FACULDADE SAO BASILIO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4365, 4687, 'FACULDADE DE TEOLOGIA BRASILEIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4366, 4688, 'FACULDADE DE DIREITO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4367, 4689, 'INSTITUTO DE ENSINO SUPERIOR PASSIONISTA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4368, 4690, 'FACULDADE DE EDUCACAO SUPERIOR E TEOLOGICA MARANHENSE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4369, 4691, 'INSTITUTO PARANAENSE DE PESQUISA DESENVOLVIMENTO E POS GRADUACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4370, 4692, 'FACULDADE VITORIO BONACIN', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4371, 4693, 'FACULDADE DE TECNOLOGIA DE NOVA ANDRADINA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4372, 4694, 'FACULDADE DE TEOLOGIA E CIENCIAS DA EDUCACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4373, 4695, 'UB FACULDADE TECNOLOGICA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4374, 4696, 'FASE FACULDADE DE TECNOLOGIA DO AMAZONAS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4375, 4697, 'MOUSE COM CURSOS PROFISSIONALIZANTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4376, 4698, 'TECNOLOGIA RADIOLOGICA E RADIOTERAPICA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4377, 4699, 'FACULDADE NOROESTE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4378, 4700, 'FACULDADE NOVA ROMA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4379, 4701, 'FACULDADE CATOLICA DE CAMPINA GRANDE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4380, 4702, 'FACULDADE DE TECNOLOGIA GESTAO & MARKETING', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4381, 4703, 'INSTITUTO D ENSINO SUPERIOR CASTRO ALVES', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4382, 4704, 'FACULDADE PONTE SERRADA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4383, 4705, 'FACULDADE UNIECO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4384, 4706, 'FACULDADE WELLINGTON', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4385, 4707, 'NUCLEO DE EDUCACAO CONTINUADA NEC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4386, 4708, 'FACULDADE SINOPENSE DE ENSINO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4387, 4709, 'IRMANDADE DA SANTA CASA DE MISERICORDIA DE PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4388, 4710, 'INSTITUTO CABRERA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4389, 4711, 'UNIDADE DE ENSINO SUPERIOR DE APUCARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4390, 4712, 'FACULDADES CASA DO SABER', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4391, 4713, 'ASSOCIACAO DE ENSINO SUPERIOR EDUCARE EDUCARE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4392, 4714, 'FACULDADE DE ENSINO REGIONAL ALTERNATIVA', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4393, 4715, 'BRIGADA AMBIENTAL DO MUNICIPIO DE SAO PEDRO DA ALDEIA', 3, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4394, 4716, 'FACULDADE DE MEDICINA DE MARABA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4395, 4717, 'INSTITUTO SUPERIOR DE EDUCACAO SANTA MARIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4396, 4718, 'FACULDADE DE TECNOLOGIA SANTA MARIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4397, 4719, 'FACULDADE DE TECNOLOGIA IJUI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4398, 4720, 'IBREAS INSTITUTO BRASILEIRO DE ESTUDOS AVANCADOS EM SAUDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4399, 4721, 'ESCOLA DOMINICANA DE TEOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4400, 4722, 'FACULDADES INTEGRADAS VIANNA JUNIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4401, 4723, 'ACADEMIA NACIONAL DE POLICIA', 1, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4402, 4724, 'FACULDADE DE CIENCIAS HUMANAS DE CRUZEIRO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4403, 4725, 'FACULDADE DE TECNOLOGIA EGIDIO JOSE DA SILVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4404, 4726, 'FACULDADE EQUIPE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4405, 4727, 'FACULDADE DE EDUCACAO CIENCIA E TECNOLOGIA EM CAMOCIM', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4406, 4728, 'FACULDADE CENECISTA DE QUISSAMA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4407, 4729, 'FACULDADE CENECISTA DE RIO BONITO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4408, 4730, 'FACULDADE LUSIADA DE JI PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4409, 4731, 'FACULDADE MESSIANICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4410, 4732, 'FACULDADE DE TECNOLOGIA SENAC DF', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4411, 4733, 'VITA CARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4412, 4734, 'FACULDADES INTEGRADAS EDUCAR BRASIL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4413, 4735, 'FACULDADE ATENAS MARANHENSE FAMA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4414, 4736, 'MORAES BASTOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4415, 4737, 'FAMEM FACULDADE DO MEDIO MEARIM', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4416, 4738, 'INSTITUTO BIODELTA DE ENSINO E PESQUISA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4417, 4739, 'FACULDADE PRESBITERIANA AUGUSTO GALVAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4418, 4740, 'FACULDADE DE PATROCINIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4419, 4741, 'FACULDADE CENECISTA DE MARICA FACMAR', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4420, 4742, 'FACULDADE SANTA EMILIA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4421, 4743, 'FACULDADE DE EDUCACAO INTEGRADA E TECNOLOGIA FACEI', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4422, 4744, 'FACULDADE LITERATUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4423, 4745, 'FACULDADE LITORANEA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4424, 4746, 'FACULDADE CATOLICA DO CARIRI', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4425, 4747, 'FACULDADE REGIONAL DE RIACHAO DO JACUIPE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4426, 4748, 'FACULDADE DE TECNOLOGIA DE SANTA CATARINA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4427, 4749, 'FACULDADE ACCTIVA DE CIENCIA E TECNOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4428, 4750, 'FACULDADE SER', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4429, 4751, 'FACULDADE DE TECNOLOGIA E CIENCIAS DO NORTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4430, 4752, 'FACULDADE NOTARIAL E REGISTRAL DO BRASIL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4431, 4753, 'FACILETEC FACULDADES DE CIENCIAS LETRAS E DE TECNOLOGIA DE TURMALINA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4432, 4754, 'FACULDADES INTEGRADAS LUSO BRASILEIRA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4433, 4755, 'AMADO ASSOCIADOS IRH S C LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4434, 4756, 'CENTRO UNIVERSITARIO MUNICIPAL DE SAO JOSE', 3, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4435, 4757, 'MASTER FACE CLINICA ODONTOLOGICA LTDA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4436, 4758, 'FACULDADE DE BAIXO GUANDU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4437, 4759, 'FACULDADE DE ITAPEMIRIM', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4438, 4760, 'INSTITUTO DE ENSINO SUPERIOR BRASILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4439, 4761, 'CETAO CENTRO DE ESTUDOS TREINAMENTO E APERFEICOAMENTO EM ODONTOLOGIA S C LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4440, 4762, 'FACULDADE IGUACUANO LEONARDO CARIELO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4441, 4763, 'FATERJ FACULDADE TEOLOGICA EVANGELICA DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4442, 4764, 'ESCOLA DE SAUDE PUBLICA DR JORGE DAVID NASSER', 2, 1, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4443, 4765, 'FACULDADE DE TECNOLOGIA ALFA DE UMUARAMA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4444, 4766, 'FACULDADE UNA DE CONTAGEM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4445, 4767, 'FACULDADE QUALITAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4446, 4768, 'INSTITUTO DE CIENCIAS GERENCIAIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4447, 4769, 'FACULDADES EMPREZA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4448, 4770, 'J G MELO CURSOS DE ESPECIALIZACAO EDUCACIONAL', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4449, 4771, 'FACULDADE BI CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4450, 4772, 'FACULDADE BI SOCIAL QUARESMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4451, 4773, 'FACULDADE IBS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4452, 4774, 'INSTITUTO ELO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4453, 4775, 'ESCOLA DE APERFEICOAMENTO E FORMACAO PROFISSIONAL PROF PAULO SERODIO MELLO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4454, 4776, 'FACULDADE COMUNITARIA DE UBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4455, 4777, 'FACULDADE KENNEDY DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4456, 4778, 'FACULDADE CENECISTA DE TEUTONIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4457, 4779, 'INSTITUTO NACIONAL DE PESQUISAS DA AMAZONIA INPA', 1, 1, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4458, 4780, 'FACISA UNAI FACULDADE DE CIENCIAS DA SAUDE DE UNAI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4459, 4781, 'FACULDADE DE COMUNICACAO TECNOLOGIA E TURISMO DE OLINDA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4460, 4782, 'FACULDADE DE TECNOLOGIA OXFORD', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4461, 4783, 'LIBERTAS CLINICA ESCOLA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4462, 4784, 'FACULDADE CDL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4463, 4785, 'INSTITUTO FEDERAL DE EDUCACAO CIENCIA E TECNOLOGIA DE RONDONIA', 1, 1, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4464, 4786, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO TOCANTINS', 1, 1, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4465, 4787, 'ESCOLA AGROTECNICA FEDERAL DE SAO JOAO EVANGELISTA', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4466, 4788, 'INSTITUTO CENTRO DE ENSINO TECNOLOGICO CARIRI', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4467, 4789, 'INSTITUTO CENTRO DE ENSINO TECNOLOGICO LIMOEIRO DO NORTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4468, 4790, 'FACULDADE DE TECNOLOGIA CENTEC SOBRAL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4469, 4791, 'FACULDADE DE TECNOLOGIA CENTEC CARIRI', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4470, 4792, 'FACULDADE DE TECNOLOGIA CENTEC LIMOEIRO DO NORTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4471, 4793, 'FACULDADES INTEGRADAS DE ITARARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4472, 4794, 'ESCOLA SUPERIOR DE ENGENHARIA E GESTAO DE VALINHOS ESEG', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4473, 4795, 'FACREI FACULDADE CRISTO REI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4474, 4796, 'FACULDADE DE CIENCIAS APLICADAS DE CAMARAGIBE FAC', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4475, 4797, 'GOVERNADOR PAULO MALUF', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4476, 4798, 'FCS FACULDADE DE CIENCIAS DA SAUDE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4477, 4799, 'CENTRO ODONTOLOGICO PIO XII', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4478, 4800, 'FACULDADE DE TECNOLOGIA CENECISTA DE RIO NEGRINHO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4479, 4801, 'FACULDADE LITERATUS JAU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4480, 4802, 'FACULDADE LITERATUS PIRACICABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4481, 4803, 'FACULDADE SENAI DE TECNOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4482, 4804, 'SECONE SERVICOS DE CONSULTORIA EDUCACIONAL', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4483, 4805, 'FACULDADE AMBIENTALISTA COMUNITARIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4484, 4806, 'INSTITUTO DE EDUCACAO COELHONETENSE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4485, 4807, 'INSTITUTO SUPERIOR DE ODONTOLOGIA ISO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4486, 4808, 'FACULDADE ATHENEU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4487, 4809, 'INSTITUTO SUPERIOR DE EDUCACAO JK VALPARAISO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4488, 4810, 'FACULDADE ANTONIO MENEGHETTI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4489, 4811, 'FACULDADE SENAI DE TECNOLOGIA ROBERTO SIMONSEN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4490, 4812, 'FACULDADE SENAI DE TECNOLOGIA ROBERTO MANGE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4491, 4813, 'FACULDADE SENAI DE TECNOLOGIA GASPAR RICARDO JUNIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4492, 4814, 'FACULDADE DE TECNOLOGIA SENAI FELIX GUISARD', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4493, 4815, 'FACULDADE DE TECNOLOGIA SENAI NADIR DIAS DE FIGUEIREDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4494, 4816, 'FACULDADE SENAI DE TECNOLOGIA SUICO BRASILEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4495, 4817, 'FACULDADE DE TECNOLOGIA SENAI ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4496, 4818, 'FACULDADE SENAI DE TECNOLOGIA HORACIO AUGUSTO DA SILVEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4497, 4819, 'FACULDADE DE TECNOLOGIA SENAI MARIANO FERRAZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4498, 4820, 'FACULDADE DE TECNOLOGIA SENAI ANTONIO ADOLPHO LOBBE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4499, 4821, 'FACULDADE DE CIENCIAS GERENCIAIS E EMPREENDEDORISMO FACIGE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4500, 4822, 'FACULDADE DE TEOLOGIA BATISTA BETEL FTBB', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4501, 4823, 'FACULDADE DE TECNOLOGIA EVOLUCAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4502, 4824, 'INSTITUTO LABORATIVA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4503, 4825, 'FACULDADE DE CIENCIAS E TECNOLOGIA DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4504, 4826, 'FACULDADE ANHANGUERA DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4505, 4827, 'CENTRO AVANCADO DE ENSINOEDUCACAO E CULTURA CAEEC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4506, 4828, 'FACULDADE DE TECNOLOGIA CAMPIUOL', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4507, 4829, 'ESCOLA SUPERIOR DE ARTES CELIA HELENA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4508, 4830, 'SEMINARIO MAIOR IMACULADO CORACAO DE MARIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4509, 4831, 'FACULDADE DE TECNOLOGIA DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4510, 4832, 'FACULDADE POLITECNICA DE TAUBATE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4511, 4833, 'FACULDADE DE TECNOLOGIA DE VALENCA FACTIVA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4512, 4834, 'INSTITUTO DE EDUCACAO MORUMBI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4513, 4836, 'FACULDADE DE EDUCACAO ACRIANA EUCLIDES DA CUNHA', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4514, 4837, 'FACULDADE IESPLAC', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4515, 4838, 'INSTITUTO SUPERIOR DE EDUCACAO MONTEIRO LOBATO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4516, 4839, 'FACULDADE DE CIENCIAS LETRAS E ARTES LUIZA DE MARILLAC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4517, 4840, 'HD HEALTH DENTAL ENSINO ODONTOLOGICOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4518, 4841, 'FACULDADE WITTENBERG', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4519, 4842, 'INSTITUTO RACINE EDITORA INDUSTRIAL E SERVICOS LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4520, 4843, 'INSTITUTO DE TEOLOGIA PASTORAL E ENSINO SUPERIOR DA AMAZONIA ITEPES', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4521, 4844, 'FTC EAD FACULDADE DE TECNOLOGIA E CIENCIAS ENSINO A DISTANCIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4522, 4845, 'FACULDADE DA IGREJA MIISTERIO FAMA FAIFA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4523, 4846, 'FACULDADE VERTICE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4524, 4847, 'FACULDADE DIOCESANA DE MOSSORO', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4525, 4848, 'FACULDADE OBOE FACO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4526, 4849, 'FACULDADE DE CIENCIAS HUMANAS, ECONOMICAS E DA SAUDE DE ARAGUAINA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4527, 4850, 'MUSEU DE ASTRONOMIA E CIENCIAS AFINS MAST', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4528, 4851, 'FACULDADE E INSTITUTO SUPERIOR TECNOLOGICO E EDUCACIONAL FATEC PARACATU', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4529, 4852, 'FACULDADE E INSTITUTO SUPERIOR TECNOLOGICO E EDUCACIONAL FATEC PATOS DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4530, 4853, 'FACULDADE E INSTITUTO SUPERIOR TECNOLOGICO E EDUCACIONAL FATEC UBERABA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4531, 4854, 'FACULDADE RADIAL CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4532, 4855, 'FACULDADE DO CENTRO DO RIO GRANDE DO SUL FACERGS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4533, 4856, 'FACULDADE DE ADMINISTRACAO CIENCIAS HUMANAS E SOCIAIS BOM JESUS GO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4534, 4857, 'IEST INSTITUTO DE EDUCACAO SUPERIOR DE TAGUATINGA SOCIEDADE SIMPLES', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4535, 4858, 'ESCOLA SUPERIOR DE SAUDE DE ARCOVERDE', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4536, 4859, 'FACULDADE DE TECNOLOGIA FAESA UNIDADE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4537, 4860, 'CENTRO BRASILEIRO DE EXCELENCIA EM POS GRADUACAO NA SAUDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4538, 4861, 'FACULDADE PITAGORAS DE POUSO ALEGRE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4539, 4862, 'FACULDADE PITAGORAS DE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4540, 4863, 'FACULDADE PITAGORAS DE POCOS DE CALDAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4541, 4864, 'FACULDADE PITAGORAS DE GOVERNADOR VALADARES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4542, 4865, 'FACULDADE PITAGORAS DE SAO LUIZ', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4543, 4866, 'FACULDADE PITAGORAS DE CONTAGEM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4544, 4867, 'FACULDADE PITAGORAS DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4545, 4868, 'FACULDADE HSM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4546, 4869, 'FACULDADE DE TECNOLOGIA PITAGOTAS UNIDADE LONDRINA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4547, 4870, 'FACULDADE DE SOBRAL FASOL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4548, 4871, 'FACULDADE INTEGRADAS DO MEORENO EM CARUARU FIAMCA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4549, 4872, 'FACULDADE ETNIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4550, 4873, 'FACULDADE DE TECNOLOGIA DE TAUBATE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4551, 4874, 'INSTITUTO DE EDUCACAO E CULTURA DO OESTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4552, 4875, 'FACULDADES INTEGRADAS CIRCUITO DAS AGUAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4553, 4876, 'FACULDADE TECNOLOGICA GERACAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4554, 4877, 'FACULDADE MESSEJANA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4555, 4878, 'FACULDADE ANHANGUERA DE ITAPECERICA DA SERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4556, 4879, 'FUNDACAO PARA O DESENVOLVIMENTO CIENTIFICO E TECNOLOGICO DA ODONTOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4557, 4880, 'FACULDADE DE DIREITO DE GUARANTA DO NORTE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4558, 4881, 'FACULDADE VILAVELHENSE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4559, 4882, 'FACULDADE DE IBIRACU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4560, 4883, 'FACULDADE DE MEDICINA DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4561, 4884, 'FACULDADE ATENAS MARANHENSE DE IMPERATRIZ MA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4562, 4885, 'FACULDADE PORTO SEGURO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4563, 4886, 'INSTITUTO SUPERIOR DE EDUCACAO PORTO SEGURO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4564, 4887, 'FACULDADE DO CIRCUITO DAS AGUAS PAULISTA FAC AP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4565, 4888, 'CURSO NACIONAL DE ATUALIZACAO EM NUTROLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4566, 4889, 'FACULDADE DE CONCHAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4567, 4890, 'FACULDADE DO FUTURO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4568, 4891, 'FACULDADE DE TEOLOGIA INTEGRADA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4569, 4892, 'FUNDACAO DE ADMINISTRACAO E PESQUISA ECONOMICO SOCIAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4570, 4893, 'FACULDADE DE GESTAO E TECNOLOGIA ASSUMPCAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4571, 4894, 'INSTITUTO DE ENSINO E PESQUISA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4572, 4895, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL ABO REGIONAL DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4573, 4896, 'INSTITUTO FLEURY', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4574, 4897, 'PROCEAD PROMOTORA DE CURSOS LTDA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4575, 4898, 'FACULDADE DE EDUCACAO E ARTES SAO GERALDO', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4576, 4899, 'FACULDADE DE CIENCIAS MEDICAS DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4577, 4900, 'FACULDADE VALE DO OURO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4578, 4901, 'FACULDADE FASIPE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4579, 4902, 'FACULDADE BATISTA PIONEIRA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4580, 4903, 'FACULDADE MONITOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4581, 4904, 'FACULDADE SENAI DE TECNOLOGIA " EUVALDO LODI "', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4582, 4905, 'FACULDADE SENAI DE TECNOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4583, 4906, 'FACULDADE SENAI DE TECNOLOGIA MARCELINO CORRADI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4584, 4907, 'FACULDADE SENAI DE TECNOLOGIA "JOSE FAGUNDES NETTO "', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4585, 4908, 'FACULDADE SENAI DE TECNOLOGIA DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4586, 4909, 'FACULDADE SENAI DE TECNOLOGIA " FIDELIS REIS "', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4587, 4910, 'FACULDADE DO TRABALHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4588, 4911, 'CEPAEM CENTRO PARANAENSE DE ESTUDOS MEDICOS LTDA', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4589, 4912, 'FACULDADE EXPOENTE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4590, 4913, 'FACULDADE SAO VICENTE DE LAVRAS', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4591, 4914, 'SENSU CONSULTORIA ORGANIZACIONAL LTDA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4592, 4915, 'FACULDADE DE CASTANHAL', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4593, 4916, 'FACULDADE CATOLICA DO SUL DO MARANHAO CASUMA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4594, 4917, 'ESCOLA SUPERIOR DE ADMINISTRACAO, MARKETING E COMUNICACAO DE PIRACICABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4595, 4918, 'FACULDADE CENECISTA DE JARDIM DO SERIDO', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4596, 4919, 'FACULDADE UNIPROCESSUS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4597, 4920, 'FACULDADE DO ENSINO SUPERIOR DO MUNICIPIO DE LINHARES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4598, 4921, 'FACULDADE DE ALMIRANTE TAMANDARE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4599, 4922, 'FACULDADE INTEGRADA DAS CATARATAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4600, 4923, 'INSTITUTO SABER', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4601, 4924, 'CENTRO DE ESTUDOS AVANCADOS DA CONSERVACAO INTEGRADA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4602, 4925, 'FUNDACAO UNIVERSIDADE FEDERAL DO ABC', 1, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4603, 4926, 'FACULDADE DE TECNOLOGIA DE PRAIA GRANDE', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4604, 4927, 'INSTITUTO SUPERIOR DE CIENCIAS DA SAUDE VERDE NORTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4605, 4928, 'INSTITUTO SUPERIOR DE CIENCIAS SOCIAIS APLICADAS VERDE NORTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4606, 4929, 'CESUC CENTRO DE ENSINO SUPERIOR DE CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4607, 4930, 'FACULDADE DE SAUDE DE PAULISTA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4608, 4931, 'INSTITUTO SUPERIOR DE EDUCACAO CECAP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4609, 4932, 'IES CEAJUFE INSTITUICAO DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4610, 4933, 'FACULDADE POLITECNICA DE ALAGOAS', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4611, 4934, 'FACULDADE DE ENSINO SUPERIOR DE CIENCIAS HUMANAS', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4612, 4935, 'FACULDADE DO TRABALHO DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4613, 4936, 'INSTITUTO AGORA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4614, 4937, 'INSTITUTO LOGOS DE EDUCACAO SUPERIOR', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4615, 4938, 'FACULDADE CLARETIANA DE TEOLOGIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4616, 4939, 'FACULDADE 2 DE JULHO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4617, 4940, 'CENTRO DE ESTUDOS PESQUISAS E POS GRADUACAO EM ODONTOLOGIA CEPPO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4618, 4941, 'FACULDADES INTEGRADAS DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4619, 4942, 'FAEME FACULDADE EVANGELICA DO MEIO NORTE DE MARITUBA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4620, 4943, 'ESCOLA SUPERIOR DE ADMINISTRACAO E GESTAO DA BAIXADA SANTISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4621, 4944, 'DENTAL PRESS CENTRO DE PESQUISA E POS GRADUACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4622, 4945, 'FACULDADE INTERNACIONAL DO DELTA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4623, 4946, 'FACULDADE DE AGRONOMIA E EDUCACAO TECNOLOGICA DE SOORETAMA FAETES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4624, 4947, 'FACULDADE VITORIA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4625, 4948, 'FACULDADES DAS AGUAS QUENTES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4626, 4949, 'FCA FACULDADE CIRCUITO DAS AGUAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4628, 4951, 'FACULDADE ABERTA DE CIENCIAS MODERNAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4629, 4952, 'FACULDADE TEOLOGICA SULBRASILEIRA FATESUL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4630, 4953, 'CENTRO DE ESTUDOS E PESQUISAS EM ORTODONTIA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4631, 4954, 'ESCOLA DE ENSINO SUPERIOR ALTERNATIVO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4632, 4956, 'ESCOLA PAULISTA DA MAGISTRATURA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4633, 4957, 'FACULDADE BRASILEIRA DE CULTURA E EDUCACAO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4634, 4958, 'FACULDADE CORPORATIVA CESPI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4635, 4959, 'FACULDADE PITAGORAS DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4636, 4960, 'FACULDADE DE TECNOLOGIA LAGOA DA PAMPULHA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4637, 4961, 'FACULDADE INTEGRADA DE ARAGUATINS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4638, 4962, 'CENTRO UNIVERSITARIO DE SETE LAGOAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4639, 4963, 'FACULDADE PRESBITERIANA MACKENZIE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4640, 4964, 'FACULDADE DE CIENCIAS E TECNOLOGIA DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4641, 4965, 'FACULDADE VEZ DO MESTRE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4642, 4967, 'ESCOLA SUPERIOR DE DIREITO MUNICIPAL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4643, 4969, 'FACULDADE ITOP', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4644, 4970, 'FACULDADE FLORES DA CUNHA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4645, 4971, 'CENTRO DE ESTUDOS E TECNICAS ODONTOLOGICAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4646, 4972, 'FACULDADE ALFREDO NASSER DE REMANSO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4647, 4973, 'FACULDADE SENAI DE TECNOLOGIA DE POCOS DE CALDAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4648, 4974, 'INSTITUTO CATARINENSE DE ESTUDOS AVANCADOS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4649, 4975, 'FACULDADE OBOE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4650, 4976, 'INSTITUTO DE ESTUDOS SUPERIORES DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4651, 4977, 'FACULDADE DE TECNOLOGIA APOENA FTA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4652, 4978, 'ALPHA SMILE CENTRO CURSOS PESQUISAS ODON COM LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4653, 4979, 'FACULDADE DE LAVRAS DA MANGABEIRA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4654, 4980, 'CLIVO POS GRADUACAO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4655, 4981, 'FACULDADE UNICESP SAUDE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4656, 4982, 'FACULDADE METROPOLITANA DO PLANALTO NORTE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4657, 4983, 'FACULDADE DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4658, 4984, 'ASSOCIACAO DE ENSINO SUPERIOR BARAO DE JUNDIAI AESB', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4659, 4985, 'FACULDADE PARA O DESENVOLVIMENTO SUSTENTAVEL DO NORDESTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4660, 4986, 'CENTRO UNIVERSITARIO DA TERRA PAULISTA UNITERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4661, 4987, 'ESCOLA SUPERIOR DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4662, 4988, 'FACULDADE DE TECNOLOGIA INED DE IPATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4663, 4989, 'CITE CENTRO INTEGRADO DE TERAPIAS ENERGETICAS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4664, 4990, 'INSTITUTO DE DESENVOLVIMENTO TECNOLOGICO DO CENTRO OESTE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4665, 4991, 'FACULDADE DE TECNOLOGIA FAMEG FAMETEC', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4666, 4992, 'FACULDADE DE TECNOLOGIA CENTEC SERTAO CENTRAL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4667, 4993, 'FACULDADE DE TECNOLOGIA DO IBRATE FAITEC', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4668, 4994, 'FACULDADE LOURENCO FILHO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4669, 4995, 'FACULDADE CRUZ AZUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4670, 4996, 'FACULDADE TECNOLOGICA DO ESTADO DO ESPIRITO SANTO FATEES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4671, 4997, 'FACULDADE DO AGRESTE SETENTRIONAL DE PERNAMBUCO FASPE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4672, 4998, 'FACULDADE DE TECNOLOGIA INESUL DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4673, 4999, 'FACULDADE INTEGRADO DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4674, 5000, 'FACULDADE ESTACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4675, 5001, 'CENTRO UNIVERSITARIO AUTONOMO DO BRASIL UNIBRASIL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4676, 5002, 'SINDICATO DOS PROFESSORES DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4677, 5003, 'FACULDADE DE CIENCIAS MEDICAS DO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4678, 5004, 'ABO SECAO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4679, 5005, 'CEUNI COMPLEXO EDUCACIONAL UNICIDADE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4680, 5006, 'FACULDADE REDENTOR DE CAMPOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4681, 5007, 'FACULDADE ORTODOXA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4682, 5008, 'FACULDADE DO MEDIO PARNAIBA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4683, 5009, 'FACULDADE DO AMAZONAS FAMA', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4684, 5010, 'FACULDADE DENIZARD RIVAIL', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4685, 5011, 'FACULDADE BATISTA DO CARIRI', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4686, 5012, 'FACULDADE RELIGARE PIAUIENSE', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4687, 5013, 'CENTRO UNIVERSITARIO ESTADUAL DA ZONA OESTE', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4688, 5014, 'CENTRO TECNOLOGICO UNIVERSITARIO DO ESTADO DO RIO DE JANEIRO', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4689, 5015, 'INSTITUTO SUPERIOR DE TECNOLOGIA EM HORTICULTURA', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4690, 5016, 'FACULDADE DE EDUCACAO TECNOLOGICA DO ESTADO DO RIO DE JANEIRO FAETERJ', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4691, 5017, 'FACULDADE DE EDUCACAO TECNOLOGICA DO ESTADO DO RIO DE JANEIRO FAETERJ', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4692, 5018, 'INSTITUTO SUPERIOR DE EDUCACAO PROFESSOR ALDO MUYLAERT', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4693, 5019, 'INSTITUTO SUPERIOR DE EDUCACAO DA ZONA OESTE', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4694, 5020, 'FACULDADE DE EDUCACAO TECNOLOGICA DO ESTADO DO RIO DE JANEIRO FAETERJ', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4695, 5021, 'FACULDADE DE EDUCACAO TECNOLOGICA DO ESTADO DO RIO DE JANEIRO FAETERJ', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4696, 5022, 'FACULDADES INTEGRADAS PREVE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4697, 5023, 'FACULDADE SANTO AUGUSTO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4698, 5024, 'ESCOLA AGROTECNICA FEDERAL DE SERTAO', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4699, 5025, 'FACULDADE DE EDUCACAO SAO BRAZ', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4700, 5026, 'UNIRATI INSTITUICAO DE ENSINO SUPERIOR IRATI S C LTDA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4701, 5027, 'FAPETRO FACULDADE DE PETROLEO E GAS LTDA', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4702, 5028, 'IBEFIN INSTITUTO BRASILEIRO DE ESTUDOS EM FINANCAS E NEGOCIOS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4703, 5029, 'FAMA FACULDADE DE MARABA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4704, 5030, 'FACULDADE DE FILOSOFIA E CIENCIAS DO PLANALTO FAFICIP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4705, 5031, 'ESCOLA SUPERIOR NACIONAL DE SEGUROS DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4706, 5032, 'ILAPE POS GRADUACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4707, 5033, 'FACULDADE PRISMA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4708, 5034, 'EDUCC EDUCACAO PROF CAP E CONSULTORIA LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4709, 5035, 'FACULDADE DA FUNDACAO UNIVERSITARIA DE CARDIOLOGIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4710, 5036, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA CATARINENSE', 1, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4711, 5037, 'FUNDACAO DE APOIO AO INSTITUTO DE PESQUISAS TECNOLOGICAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4712, 5038, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE MARABA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4713, 5039, 'FACULDADE DE PSICOLOGIA FUNFARME', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4714, 5040, 'FACULDADE BAHIANA DE ENGENHARIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4715, 5041, 'ITEP INSTITUTO DE TECNOLOGIA ENSINO E PESQUISA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4716, 5042, 'SEMINARIO NACIONAL ITEJ', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4717, 5043, 'INSTITUTO SUPERIOR DE EDUCACAO DE CARAPICUIBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4718, 5044, 'FACULDADE DE DIREITO DE GARANHUNS', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4719, 5045, 'FACULDADE DE TECNOLOGIA PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4720, 5046, 'FACULDADE POLIS DAS ARTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4721, 5047, 'FACULDADE DO INTERIOR PAULISTA FIP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4722, 5048, 'FACULDADE DE TEOLOGIA DE SAO PAULO DA IGREJA PRESBITERIANA INDEPENDENTE DO BRASIL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4723, 5049, 'INSTITUTO DE ENSINO SUPERIOR SAO FRANCISO DE ASSIS DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4724, 5050, 'FACULDADE ARAUTOS DO EVANGELHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4725, 5051, 'FACULDADE DE EDUCACAO TECNOLOGICA DO ESTADO DO RIO DE JANEIRO FAETERJ', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4726, 5052, 'FACULDADE DE EDUCACAO TECNOLOGICA DO ESTADO DO RIO DE JANEIRO FAETERJ', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4727, 5053, 'FACULDADE DE EDUCACAO TECNOLOGICA DO ESTADO DO RIO DE JANEIRO', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4728, 5054, 'INSTITUTO SUPERIOR DE EDUCACAO DO SERTAO DO PAJEU', 2, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4729, 5055, 'INSTITUTO LOBO PARA O DESENVOLVIMENTO DA EDUCACAO DA CIENCIA E DA TECNOLOGIA NAO IES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4730, 5056, 'FACULDADE DE TECNOLOGIA UNIBRATEC MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4731, 5057, 'FACULDADE SAO VICENTE DE PAULO FASVIP', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4732, 5058, 'FACULDADE DE TECNOLOGIA PEDRO ROGERIO GARCIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4733, 5059, 'INSTITUTO DO CORACAO DO DISTRITO FEDERAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4734, 5060, 'FACULDADE DE TECNOLOGIA DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4735, 5061, 'FACULDADE NATAL FN', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4736, 5062, 'FACULDADE DE PIRACICABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4737, 5063, 'FACULDADE DE TECNOLOGIA INED UNIDADE TIMOTEO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4738, 5064, 'CENTRO DE FORMACAO TREINAMENTO E APERFEICOAMENTO', 1, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4739, 5065, 'FACULDADE CONSULTIME DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4740, 5066, 'FACULDADE PITAGORAS DE TECNOLOGIA DE CONTAGEM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4741, 5067, 'FACULDADE PITAGORAS DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4742, 5068, 'FACEAR FACULDADE EDUCACIONAL ARAUCARIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4743, 5069, 'FACULDADE PADRAO DE PORANGATU', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4744, 5070, 'FACULDADE DE MEDICINA CARLOS CHAGAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4745, 5071, 'FACULDADE NORTE CAPIXABA DE SAO MATEUS FAMAT', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4746, 5072, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4747, 5073, 'FACULDADE PITAGORAS DE DIVINOPOLIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4748, 5074, 'INSTITUTO EDUCACIONAL DE ENSINO SUPERIOR FACLESTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4749, 5075, 'ESCOLA AGROTECNICA FEDERAL DE CACERES', 1, 1, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4750, 5076, 'BRAZIL GLOBAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4751, 5077, 'UNIVERSIDADE ESTADUAL DE RORAIMA', 2, 1, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4752, 5078, 'UNIPED', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4753, 5079, 'FACULDADE EDUCACIONAL DE MATELANDIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4754, 5080, 'CETEC LAGOS CENTRO DE CAPACITACAO TECNOLOGICA DA REGIAO DOS LAGOS LTDA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4755, 5081, 'DIFERENCIAL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4756, 5082, 'FUNETEC', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4757, 5083, '1344 ESCOLA SUPERIOR DE HOTELARIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4758, 5084, 'FACIAC FACULDADE DE CIENCIAS APLICADAS DE CATANDUVAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4759, 5085, 'FACULDADE REGIONAL DE TIMBO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4760, 5086, 'ESAMC ESCOLA SUPERIOR DE ADMINISTRACAO MARKETING E COMUNICACAO DE MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4761, 5087, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO DISTRITO FEDERAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4762, 5088, 'IBRAFA CENTRO DE ESTUDOS EM SAUDE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4763, 5089, 'FACULDADE DE TECNOLOGIA APOENA FTA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4764, 5090, 'FACULDADE DO PROFESSOR', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4765, 5091, 'INSTITUTO DE ESTUDOS SUPERIORES E POS GRADUACAO IESP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4766, 5092, 'UNIVALE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4767, 5093, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECCAO DO ESTADO DO RIO GRANDE DO NORTE', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4768, 5094, 'FACULDADE EVOLUCAO ALTO OESTE POTIGUAR', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4769, 5095, 'FIESU FACULDADE INTERNACIONAL DE ENSINO SUPERIOR', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4770, 5096, 'ESCOLA AGROTECNICA FEDERAL DE ARAGUATINS', 1, 1, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4771, 5097, 'FACULDADE VALE DOS CARAJAS', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4772, 5098, 'FACULDADE CELEIRO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4773, 5099, 'FACULDADE DE TECNOLOGIA DE SAO BERNARDO DO CAMPO', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4774, 5100, 'FACULDADE MACHADINHO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4775, 5101, 'FACULDADE CENTRO OESTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4776, 5102, 'INSTITUTO NACIONAL DE ENSINO AVANCADO LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4777, 5103, 'IEP INSTITUTO DE ESTUDOS PREVIDENCIARIOS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4778, 5104, 'ESAD ESCOLA DE ADMINISTRACAO E NEGOCIOS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4779, 5105, 'FACULDADE INTERNACIONAL SIGNORELLI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4780, 5106, 'INSTITUTO DE GESTAO EDUCACIONAL SIGNORELLI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4781, 5107, 'FACULDADE SOGIPA DE EDUCACAO FISICA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4782, 5108, 'ASSOCIACAO INSTITUTO SAPIENTIAE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4783, 5109, 'ESCOLA SUPERIOR DE TERAPIA INTEGRAL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4784, 5110, 'FAINP FACULDADE DE INTEGRACAO DO NOROESTE PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4785, 5111, 'INSTITUTO DE ENSINO E PESQUISA E POS GRADUACAO EM EDUCACAO E SAUDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4786, 5112, 'FACULDADE UNIAO ARARUAMA DE ENSINO SS LTDA.', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4787, 5113, 'FACULDADE UNIMAC', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4788, 5114, 'INSTITUTO DE PESQUISAS EDUCACIONAIS PRAXIS LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4789, 5115, 'FACULDADE EXPANSAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4790, 5116, 'FACULDADE EVOLUCAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4791, 5117, 'INSTITUTO DE EDUCACAO SUPERIOR DE SAO LOURENCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4792, 5118, 'FACULDADE OMEGA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4793, 5119, 'FACULDADES MATISSE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4794, 5120, 'FACULDADE DINAMICA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4795, 5121, 'SEMINARIO BAIANO DE TEOLOGIA SEBATE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4796, 5122, 'INSTITUTO CIMAN DE EDUCACAO E ENSINO SUPERIOR', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4797, 5123, 'ESCOLA DA MAGISTRATURA DO ESTADO DO RIO DE JANEIRO', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4798, 5124, 'FACULDADE FACMIL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4799, 5125, 'INSTITUTO DE ENSINO E PESQUISA EM ODONTOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4800, 5126, 'ESCOLA BRASILEIRA DE MEDICINA CHINESA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4801, 5127, 'FACULDADE SOCIAL DE SAO PAULO FASSP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4802, 5128, 'FACULDADE SANTO ANDRE FASA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4803, 5129, 'ESCOLA AGROTECNICA FEDERAL DE CERES', 1, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4804, 5130, 'CEDEFACE CENTRO DE PESQUISA E POS GRADUACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4805, 5131, 'FACULDADE DE TECNOLOGIA SENAC CACADOR', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4806, 5132, 'FACULDADE SENAC CONCORDIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4807, 5133, 'FACULDADE DE TECNOLOGIA SENAC SAO MIGUEL DO OESTE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4808, 5134, 'FACULDADE SENAC CRICIUMA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4809, 5135, 'CENTRO UNIVERSITARIO DE RIO PRETO UNIRP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4810, 5136, 'FACULDADE SAO BOAVENTURA DE EDUCACAO CONTINUADA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4811, 5137, 'FATEC FACULDADE DE TEOLOGIA E CIENCIAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4812, 5138, 'INSTITUTO DELMIRENSE DE INSINO SUPERIOR', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4813, 5139, 'FACULDADE SANTA MARIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4814, 5140, 'IPEO MT', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4815, 5141, 'ESCOLA AGROTECNICA FEDERAL ANTONIO JOSE TEIXEIRA', 1, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4816, 5142, 'FACULDADES TECNOLOGICAS DA SERRA GAUCHA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4817, 5143, 'FACULDADE LUTERANA DE TEOLOGIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4818, 5144, 'UNIAO METROPOLITANA DE EDUCACAO E CULTURA S C LTDA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4819, 5145, 'SOCIEDADE DE ENSINO SUPERIOR CEDRO S S LTDA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4820, 5146, 'FACULDADE PETROLINA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4821, 5147, 'ACADEMIA CEARENSE DE ODONTOLOGIA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4822, 5148, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4823, 5149, 'ESCOLA SUPERIOR DE GESTAO E CIENCIAS DA SAUDE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4824, 5150, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4826, 5152, 'ESCOLA DA ADVOCACIA GERAL DA UNIAO', 1, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4827, 5153, 'CENTRO DE POS GRADUACAO ILADEM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4828, 5154, 'ASSSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO ALAGOAS', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4829, 5155, 'ABO REGIONAL UMUARAMA PR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4830, 5156, 'UNIVERSIDADE CAMILO CASTELO BRANCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4831, 5157, 'FACULDADES TECNOLOGICAS DA SERRA GAUCHA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4832, 5158, 'FACULDADE MARECHAL CANDIDO RONDON FAMAR', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4833, 5159, 'CENTRO AVANCADO DE ORTODONTIA PAULO PICANCO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4834, 5160, 'FACULDADE COMUNITARIA DE PINDAMONHANGABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4835, 5161, 'FACULDADE COMUNITARIA DE AMERICANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4837, 5163, 'FACULDADE COMUNITARIA DE RIBEIRAO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4838, 5164, 'FACULDADE COMUNITARIA DE OSASCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4839, 5165, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO RIO GRANDE DO SU8L', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4840, 5166, 'FACULDADE DE CIENCIAS DA SAUDE HIPOCRATES', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4841, 5167, 'FACULDADE DOMINGOS OLIMPIO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4842, 5168, 'ESCOLA AGROTECNICA FEDERAL DE CATU', 1, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4843, 5169, 'UNICETREX POS GRADUACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4844, 5170, 'UNIVERCAPANEMA FACULDADES DE LETRAS CIENCIAS TECNOLOGIA E DE BIOTECNOLOGIA DA SAUDE DE CAPANEMA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4845, 5171, 'GRUPO DO RIO DE JANEIRO DE ESTUDOS DE ORTODONTIA PELA TECNICA DO STRAIGHT WIRE DE ANDREWS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4846, 5172, 'FACULDADE DE TECNOLOGIA CENTEC SAO GONCALO DO AMARANTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4847, 5173, 'FACULDADE DE TECNOLOGIA DE PIRASSUNUNGA FATEPI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4848, 5174, 'BRAZILIAN BUSINESS SCHOOL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4849, 5175, 'FACULDADE IDAAM', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4850, 5176, 'FACULDADE DE DIREITO VALE DO ASSU', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4851, 5177, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO MS', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4852, 5178, 'MIRANDA E CARVALHO INSTITUTO DE PESQUISA POS GRADUACAO E SERVICOS EM ODONTOLOGIA LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4853, 5179, 'FACULDADE SAINT PAUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4854, 5180, 'FACULDADE DO POVO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4855, 5181, 'FACULDADE MOGIANA DO ESTADO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4856, 5182, 'IRMANDADE DA SANTA CASA DE MISERICORDIA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4857, 5183, 'INSTITUTO TECNOLOGICO DE ENSINO SUPERIOR BANDEIRANTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4858, 5184, 'FACULDADE DE CIENCIAS E TECNOLOGIA DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4859, 5185, 'FACULDADE DO INSTITUTO NACIONAL DE POS GRADUACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4860, 5186, 'FACULDADE DINAMICA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4861, 5187, 'FAEJA FACULDADE ALBERT EINSTEIN DE JACIARA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4862, 5188, 'EXPANSAO GESTAO EM EDUCACAO E EVENTOS', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4863, 5189, 'FACULDADE BAIANA DE DIREITO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4864, 5190, 'INSTITUTO CATUAI DE ENSINO SUPERIOR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4865, 5191, 'FAMAC FACULDADE DE MACHADINHO DO OESTE', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4866, 5192, 'CENTES CENTRO TECNOLOGICO DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4867, 5193, 'FEIT FACULDADE DE ENGENHARIA E INOVACAO TECNOLOGICA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4868, 5194, 'ESCOLA SUPERIOR DE TEOLOGIA E ESPIRITUALIDADE FRANCISCANA ESTEF', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4869, 5195, 'FACULDADE DO VALE DO PAJEU', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4870, 5196, 'INSTITUTO NOSSA SENHORA DO PILAR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4871, 5197, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECCAO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4872, 5198, 'UNIBRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4873, 5199, 'CENTRO AVANCADO DE ENSINOEDUCACAO E CULTURA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4874, 5200, 'FACULDADE DE TECNOLOGIA INED UNIDADE BETIM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4875, 5201, 'FACULDADE DE TECNOLOGIA INED UNIDADE BARREIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4876, 5202, 'FACULDADE INDEPENDENCIA FAI', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4877, 5203, 'FACULDADE MONTESSORIANO DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4878, 5204, 'INSTITUTO SUPERIOR DE EDUCACAO ANTONINO FREIRE ISEAF', 2, 1, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4879, 5205, 'INSTITUTO DE EDUCACAO SUPERIOR SUL BRASILEIRO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4880, 5206, 'IMEN INSTITUTO DE METABOLISMO E NUTRICAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4881, 5207, 'ATUALIZA POS GRADUACAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4882, 5208, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4883, 5209, 'INSTITUTO DE POS GRADUACAO DO PETROLEO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4884, 5210, 'FATESMA FACULDADE DE TECNOLOGIA SANTA MARIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4885, 5211, 'INSTITUTO SUPERIOR ISAG DE FORMACAO CONTINUADA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4886, 5212, 'COMISSAO CIENTIFICA SPP', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4887, 5213, 'INSTITUTO FISIOMAR', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4888, 5214, 'CENTRO DE ESTUDOS ODONTOLOGICOS DO IPSEMG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4889, 5215, 'FACULDADES INTEGRADAS PADRE ALBINO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4890, 5216, 'FACULDADE ANHANGUERA DE EDUCACAO, CIENCIAS E TECNOLOGIA DE SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4891, 5217, 'FACULDADES INTEGRADAS PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4892, 5218, 'FACULDADE DE TECNOLOGIA PROFESSOR WALDOMIRO MAY', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4893, 5219, 'INSTITUTO SUPERIOR DE ENSINO EM FONOAUDIOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4894, 5220, 'INSTITUTO DE POSGRADUACAO E ATUALIZACAO EM ODONTOLOGIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4895, 5221, 'FUNDACAO ANTARES DE ENSINO SUPERIOR POS GRADUACAO PESQUISA E EXTENSAO', 1, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4896, 5222, 'ESCOLA AGROTECNICA FEDERAL DE SOUSA', 1, 1, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4897, 5223, 'COORDENACAO GERAL DE EDUCACAO DA ANDIMA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4898, 5224, 'CENTRO DE POS GRADUACAO ESTUDOS PESQUISA E EXTENSAO INSPIRAR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4899, 5225, 'IMEO INSTITUTO MINEIRO DE ESTUDOS ODONTOLOGICOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4900, 5226, 'IMEO INSTITUTO MINEIRO DE ESTUDOS ODONTOLOGICOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4901, 5227, 'SEPAI SERVICO DE PSICANALISE EM ATENCAO A INFANCIA COORDENACAO DE ASSUNTOS EDUCACIONAIS CAE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4902, 5228, 'FACULDADE RAIMUNDO MARINHO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4903, 5229, 'IPDR INSTITUTO DE POS GRADUACAO DAVID ROCHA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4904, 5230, 'INSTITUTO PRISMA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4905, 5231, 'LFG ESCOLA NACIONAL DE ESPECIALIZACAO LFG ENESP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4906, 5232, 'INSTITUTO TOCANTINENSE DE EDUCACAO A DISTANCIA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4907, 5233, 'FUNDACAO DE APOIO A PESQUISA E ESTUDO NA AREA DE SAUDE FAPES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4908, 5234, 'FASS SISTEMA DE ENSINO A DISTANCIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4909, 5235, 'FACULDADE DE TECNOLOGIA IBRATEC', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4910, 5236, 'CENTRO DE ESTUDOS SUPERIORES DA FUNDACOR', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4911, 5237, 'INSTITUTO SUPERIOR DE FORMACAO CONTINUADA DOUGLAS ANDREANI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4912, 5238, 'INSTITUTO SAPIENTIA DE EDUCACAO SUPERIOR ISES', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4913, 5239, 'SBAC CENTRO DE POS GRADUACAO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4914, 5240, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECCAO DO PARANA REGIONAL DE PONTA GROSSA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4915, 5241, 'MUSEU PARAENSE EMILIO GOELDI', 1, 1, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4916, 5242, 'UNIVERSIDADE ESTADUAL DE ALAGOAS UNEAL', 2, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4917, 5243, 'FACULDADE DE CIENCIAS JURIDICAS DE SANTOS DUMONT', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4918, 5244, 'ASSOCIACAO DOS GESTORES DE CONHECIMENTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4919, 5245, 'SOCIEDADE DE HIPNOSE MEDICA DO ESTADO DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4920, 5246, 'CENTRO DE ESTUDOS AVANCADOS EM SAUDE UNIMAGEM', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4921, 5247, 'INAPOS INSTITUTO NACIONAL DE ENSINO SUPERIOR E POS GRADUACAO PADRE GERVASIO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4922, 5248, 'INAPOS INSTITUTO NACIONAL DE ENSINO SUPERIOR E POS GRADUACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4923, 5249, 'V F LIMA CURSOS AVANCADOS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4924, 5250, 'FACULDADE EVOLUTIVO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4925, 5251, 'INAPOS INSTITUTO NACIONAL DE ENSINO SUPERIOR E POS GRADUACAO PADRE GERVASIO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5000, 5326, 'CIODONTO POS GRADUACAO SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4926, 5252, 'INAPOS INSTITUTO NACIONAL DE ENSINO SUPERIOR E POS GRADUACAO PADRE GERVASIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4927, 5253, 'INAPOS INSTITUTO NACIONAL DE ENSINO SUPERIOR E POS GRADUACAO PADRE GERVASIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4928, 5254, 'INSTITUTO SUPERIOR DE ODONTOLOGIA FACIAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4929, 5255, 'FACULDADE REGIONAL DE RIBEIRA DO POMBAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4930, 5256, 'CENTRO DE ENSINO ESPECIAL SUPERIOR E PROFISSIONALIZANTE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4931, 5257, 'APROBATUM CENTRO NACIONAL DE QUALIFICACAO DE PESSOAL LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4932, 5258, 'INSTITUTO SUPERIOR ORTHODONTIC INTERNACIONAL', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4933, 5259, 'AGRICULTURA TROPICAL E SUBTROPICAL', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4934, 5260, 'FACULDADE DE CRUZEIRO DO OESTE FACO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4935, 5261, 'CENTRO DE EDUCACAO DO HEMOCENTRO DE RIBEIRAO PRETO CEDUC HRP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4936, 5262, 'INSTITUICAO DE ENSINO UNIORKA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4937, 5263, 'CEU CENTRO DE EXTENSAO UNIVERSITARIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4938, 5264, 'INSTITUTO SUPERIOR DO MINISTERIO PUBLICO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4939, 5265, 'FACULDADE METROPOLITANA SAO CARLOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4940, 5266, 'INSTITUTO DE EDUCACAO SECULO XXI LTDA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4941, 5267, 'INSTITUTO EFICAZ CURSOS PROFISSIONALIZANTES DE MARINGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4942, 5268, 'FACULDADE DE SAO JOAQUIM DA BARRA LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4943, 5269, 'FACULDADE CRISTA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4944, 5270, 'ESCOLA NACIONAL DE SAUDE PUBLICA ENSP', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4945, 5271, 'ESCOLA NACIONAL DE SAUDE PUBLICA', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4946, 5272, 'INSTITUTO DE POS GRADUACAO PIO XII', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4947, 5273, 'FACULDADE SANTA CRUZ', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4948, 5274, 'INSTITUTO SUPERIOR CULTURAL BRASILEIRO ISCB', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4949, 5275, 'FACULDADE DE CIENCIAS GERENCIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4950, 5276, 'FACULDADE COMUNITARIA DE CARANGOLA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4951, 5277, 'FACULDADE FORTIUM', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4952, 5278, 'FACULDADE ATUAL', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4953, 5279, 'CRDA POS GRADUACOES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4954, 5280, 'FACULDADE DE EDUCACAO SUPERIOR COELHONETENSE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4955, 5281, 'FACULDADE DE EDUCACAO CIENCIA E TECNOLOGIA DO VALE DO ACARAU', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4956, 5282, 'CENTRO DE ESTUDOS DE PESSOAL', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4957, 5283, 'HD ENSINOS ODONTOLOGICOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4958, 5284, 'FACULDADE PARA O ENSINO DAS CIENCIAS JURIDICAS INDEPENDENTEMENTE DE DISTANCIA FECJID', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4959, 5285, 'FACULDADES INTEGRADAS DE TAQUARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4960, 5286, 'INSTITUTO DE CIENCIAS SOCIAIS E ECONOMICAS LTDA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4961, 5287, 'NEO NUCLEO DE ESTUDOS ODONTOLOGICOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4962, 5288, 'FACULDADE ANHANGUERA DE RIBEIRAO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4963, 5289, 'FACULDADE DE DIREITO DO ESTADO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4964, 5290, 'FACULDADE DE CIENCIAS E TECNOLOGIA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4965, 5291, 'FACULDADE ARAUTOS DO EVANGELHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4966, 5292, 'FACULDADE VIPACS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4967, 5293, 'FACULDADE ANHANGUERA DE SUMARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4968, 5294, 'FACULDADE DINAMICA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4969, 5295, 'CEPEO CENTRO DE ENSINO E PESQUISA EM ODONTOLOGIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4970, 5296, 'ESCOLA DA VILA ESPECIALIZACAO PEDAGOGICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4971, 5297, 'ESCOLA NACIONAL DE ACUPUNTURA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4972, 5298, 'FACULDADE METAFISICA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4973, 5299, 'FACULDADE NOVO ATENEU DE GUARAPUAVA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4974, 5300, 'FAKCEN', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4975, 5301, 'FACULDADE RAIZES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4976, 5302, 'IDEAL POS GRADUACAO S S LTDA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4977, 5303, 'FACULDADE ANHANGUERA DE DOURADOS', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4978, 5304, 'FACULDADE DE ENFERMAGEM DE SAO SEBASTIAO DO PARAISO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4979, 5305, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS E HUMANAS DE GARANHUNS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4980, 5306, 'INSTITUTO SUPERIOR DE CIENCIAS AGRARIAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4981, 5307, 'FASES FACULDADE SHALOM DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4982, 5308, 'IM T INSTUTO MUNDO TRABALHO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4983, 5309, 'CEPRENO CENTRO DE ESTUDOS PAULISTA DE REABILITACAO NEUROCLUSAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4984, 5310, 'FACULDADE CIMAN', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4985, 5311, 'FACULDADE GABARITO', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4986, 5312, 'FACULDADES ATIBAIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4987, 5313, 'FACULDADES UNIFICADAS DE CATAGUASES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4988, 5314, 'FACULDADES UNIFICADAS DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4989, 5315, 'FACULDADES UNIFICADAS DE IUNA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4990, 5316, 'FACULDADES UNIFICADAS DE LEOPOLDINA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4991, 5317, 'FACULDADE PORTOALEGRENSE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4992, 5318, 'FACULDADE GUILHERME GUIMBALA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4993, 5319, 'INSTITUTO DE POS GRADUACAO AURELIO BUARQUE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4994, 5320, 'ESCOLA SUPERIOR DE ENSINO ANISIO TEIXEIRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4995, 5321, 'FESMIP', 2, 1, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4996, 5322, 'FUNDACAO UNIVERSIDADE FEDERAL DO PAMPA UNIPAMPA', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4997, 5323, 'INSTITUTO DE EDUCACAO SUPERIOR OLIVEIRAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4998, 5324, 'CIODONTO POS GRADUACAO SANTOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (4999, 5325, 'CIODONTO POS GRADUACAO SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5001, 5327, 'CIODONTO POS GRADUACAO SAO PAULO I', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5002, 5328, 'CIODONTO POS GRADUACAO SERTAOZINHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5003, 5329, 'CIODONTO POS GRADUACAO BELO HORIZONTE II', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5004, 5330, 'CIODONTO POS GRADUACAO ITAJAI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5005, 5331, 'CIODONTO POS GRADUACAO RIO DE JANEIRO III', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5006, 5332, 'CIODONTO POS GRADUACAO VITORIA II', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5007, 5333, 'CIODONTO POS GRADUACAO VITORIA I', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5008, 5334, 'CIODONTO POS GRADUACAO ERECHIM', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5009, 5335, 'CIODONTO POS GRADUACAO FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5010, 5336, 'CIODONTO POS GRADUACAO PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5011, 5337, 'CIODONTO POS GRADUACAO PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5012, 5338, 'CIODONTO POS GRADUACAO RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5013, 5339, 'CIODONTO POGRADUACAO CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5014, 5340, 'CIODONTO POGRADUACAO CAMPO GRANDE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5015, 5341, 'CIODONTO POS GRADUACAO MARINGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5016, 5342, 'CIODONTO POS GRADUACAO PASSO FUNDO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5017, 5343, 'CIODONTO POS GRADUACAO FLORIANOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5018, 5344, 'CIODONTO POS GRADUACAO GOIANIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5019, 5345, 'CIODONTO POS GRADUACAO GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5020, 5346, 'CIODONTO POS GRADUACAO JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5021, 5347, 'CIODONTO POS GRADUACAO MACAPA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5022, 5348, 'CIODONTO POS GRADUACAO RIO DE JANEIRO I', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5023, 5349, 'CIODONTO POS GRADUACAO BELO HORIZONTE I', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5024, 5350, 'CIODONTO POS GRADUACAO CURITIBA I', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5025, 5351, 'FACULDADE DE TECNOLOGIA INSTITUTO POLITECNICO DO PARANA UNIDADE GUARAPUAVA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5026, 5352, 'FACULDADE DE CIENCIAS E TECNOLOGIA DE NATAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5027, 5353, 'FACULDADE DE TECNOLOGIA BANDEIRANTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5028, 5354, 'FACULDADE CAL DE ARTES CENICAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5029, 5355, 'FACULDADE DE CIENCIAS E DESENVOLVIMENTO DO VALE DO CAPIBARIBE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5030, 5356, 'FACULDADE FLUMINENSE DE ENGENHARIA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5031, 5357, 'FACULDADE DE CIENCIAS APLICADAS E TECNOLOGICAS DO LITORAL SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5032, 5358, 'FACULDADE INTEGRADO DE IMPERATRIZ', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5033, 5359, 'FACULDADE PAULO SETUBAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5034, 5360, 'FACULDADE PADRE ANCHIETA DE VARZEA PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5035, 5361, 'FACULDADE PITAGORAS DE VOTORANTIM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5036, 5362, 'FACULDADE SERIGY', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5037, 5363, 'INPET INSTITUTO NACIONAL DE PESQUISAS E ESTUDOS TRIBUTARIOS S S LTDA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5038, 5364, 'FACULDADE ESPECIALIZADA NA AREA DE SAUDE DO RIO GRANDE DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5039, 5365, 'INSTITUTO TAQUARITINGUENSE DE ENSINO SUPERIOR DOUTOR ARISTIDES DE CARVALHO SCHLOBACH', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5040, 5366, 'CEOSP CENTRO DE ESTUDOS ODONTOLOGICOS SMILEPREV', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5041, 5367, 'CIODONTO POS GRADUACAO JOAO PESSOA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5042, 5368, 'CIODONTO POS GRADUACAO RIO DE JANEIRO II', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5043, 5369, 'FACULDADES INTEGRADAS ASMEC', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5044, 5370, 'FACULDADES UNIFICADAS DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5045, 5371, 'CEFAC POS GRADUACAO EM SAUDE E EDUCACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5046, 5372, 'FACULDADE DE RONDONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5047, 5373, 'INSTITUTO NACIONAL DE ENSINO SUPERIOR E POS GRADUACAO PADRE GERVASIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5048, 5374, 'FACULDADE BRASILEIRA DE ESTUDOS AVANCADOS FABEA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5049, 5375, 'ESCOLA SUPERIOR DE AVIACAO CIVIL', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5050, 5376, 'FACULDADE UNIESP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5051, 5377, 'INSTITUTO INTEGRAL DE PESQUISA E ENSINO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5052, 5378, 'INSTITUTO DE MEDICINA TROPICAL', 2, 1, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5053, 5379, 'INSTITUTO PAULISTA DE ESTUDOS SISTEMICOS IPES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5054, 5380, 'INSTITUTO DE CRIMINOLOGIA E POLITICA CRIMINAL ICPC', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5055, 5381, 'NCD NUTROCLINICA CURSOS A DISTANCIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5056, 5382, 'FACULDADE DE PINDAMONHANGABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5057, 5383, 'AFIP ASSOCIACAO FUNDO DE INCENTIVO A PSICOFARMACOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5058, 5384, 'IEN INSTITUTO SUPERIOR DE ENSINO DE NEUROPSICOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5059, 5385, 'FACULDADE DO INSTITUTO DE EDUCACAO EM NEGOCIOS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5060, 5386, 'FACULDADES IBDI CAMBORIU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5061, 5387, 'FACULDADE IMPACTA DE TECNOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5062, 5388, 'FACULDADES UNIVERSITAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5063, 5389, 'INSTITUTO HELIOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5064, 5390, 'FACULDADE METROPOLITANA SAO CARLOS BJI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5065, 5391, 'THUM INSTITUTO DE POS GRADUACAO E BIOPESQUISAS LTDA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5066, 5392, 'INSTITUTO DE PESQUISA E ENSINO ODONTOLOGICO LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5067, 5393, 'INSTITUTO SOBRAIMO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5068, 5394, 'INSTITUTO DE ENSINO SUPERIOR INTEGRADOIESI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5069, 5395, 'INSTITUTO DE ENSINO SUPERIOR MICHELANGELO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5070, 5396, 'INSTITUTO SUPERIOR DA ASSOCIACAO FLUMINENSE DE AMPARO AOS CEGOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5071, 5397, 'FACULDADE DE EDUCACAO E CULTURA DE VILHENA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5072, 5398, 'FACULDADE SUPERIOR DE ENSINO QUALIFICADO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5073, 5399, 'FACULDADE METROPOLITANA DE EDUCACAO E CULTURA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5074, 5400, 'FACULDADE FAMA DE SAO LUIS', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5075, 5401, 'INSTITUTO SUPERIOR DE ENSINO E PESQUISA SAO RAFAEL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5076, 5402, 'FUNDACAO JOAQUIM NABUCO', 1, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5077, 5403, 'FACULDADES OPET', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5078, 5404, 'INSTITUTO BRASILEIRO DE THERAPIAS E ENSINO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5079, 5405, 'ARCA INSTITUTO DE POS GRADUACAO E SERVICOS EM ODONTOLOGIA LTDA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5080, 5406, 'INSTITUTO ORAL ESTHETIC DE POS GRADUACAO E APERFEICOAMENTO EM ODONTOLOGIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5081, 5407, 'SISTEMA EDUCACIONAL CORPORATIVO', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5082, 5408, 'INSTITUTO BRASILEIRO DE POS GRADUACAO IBPG', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5083, 5409, 'ASSOCIACAO BRASILEIRA DE CIRURGIOES DENTISTAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5084, 5410, 'ASSOCIACAO BRASILEIRA DE CIRURGIOES DENTISTAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5085, 5411, 'ASSOCIACAO PAULISTA DE CIRURGIOES DENTISTAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5086, 5412, 'CENTRO DE DESENVOLVIMENTO CIENTIFICO EM SAUDE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5087, 5413, 'FACULDADE DOTTORI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5088, 5414, 'ASSOCIACAO PAULISTA DE CIRURGIOES DENTISTAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5089, 5415, 'FACULDADES UNIDAS DE PESQUISA CIENCIAS E SAUDE LTDA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5090, 5416, 'FACULDADE METROPOLITANA DE LAGES', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5091, 5417, 'FACULDADE LA SALLE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5092, 5418, 'FACULDADE IBMEC DISTRITO FEDERAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5093, 5419, 'FACULDADE EVANGELICA DE TAGUATINGA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5094, 5420, 'FACULDADE DE TECNOLOGIA IBDI BLU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5095, 5421, 'FACULDADE DE TECNOLOGIA IBDI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5096, 5422, 'FACULDADE DE TECNOLOGIA SENAI CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5097, 5423, 'GANEP GRUPO DE NUTRICAO HUMANA LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5098, 5424, 'INSTITUTO LEGISLATIVO BRASILEIRO', 1, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5099, 5425, 'FACULDADE DE TECNOLOGIA EM SAUDE CIEPH', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5100, 5426, 'IMES INSTITUTO MINEIRO DE EDUCACAO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5101, 5427, 'FCETM FACULDADE DE CIENCIAS ECONOMICAS DO TRIANGULO MINEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5102, 5428, 'FACULDADE ILAPE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5103, 5429, 'INSTITUTO SUPERIOR DE ENSINO DE ACREDITACAO E QUALIDADE EM SAUDE ISAQS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5104, 5430, 'FACULDADE DE TECNOLOGIA DE MINAS GERAIS FATEMIG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5105, 5431, 'CEOSP CENTRO DE ENSINO ODONTOLOGICO SMILE PREV LTDA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5106, 5432, 'SOCIEDADE EDUCACIONAL RIOGRANDENSE LTDA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5107, 5433, 'INSTITUTO BRASILEIRO DA FORMACAO E DO EMPREGO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5108, 5434, 'CENTRO HERMES DE EDUCACAO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5109, 5435, 'FACULDADE DE TECNOLOGIA DO TRANSPORTE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5110, 5436, 'FACULDADE DO PROFESSOR', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5111, 5437, 'FACULDADE PASSIONISTA DE EDUCACAO DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5112, 5438, 'FACULDADE DE TECNOLOGIA DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5113, 5439, 'FACULDADES INTEGRADAS DA UNIAO EDUCACIONAL DO PLANALTO CENTRAL FACIPLAC', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5114, 5440, 'FACULDADE SEAC', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5115, 5441, 'POS GRADUACAO IREI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5116, 5442, 'FACULADE DE CIENCIAS JURIDICAS DE NOVA LIMA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5117, 5443, 'FACULDADE ANDREAS PALLADIO ARTES CIENCIAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5118, 5444, 'FACULDADE DE EDUCACAO, TECNOLOGIA E ADMINISTRACAO DE CAARAPO', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5119, 5445, 'FACULDADE DE TECNOLOGIA SAINT PAUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5120, 5446, 'FACULDADE NOBREGA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5121, 5447, 'FACULDADE PARA O DESENVOLVIMENTO DO SUDESTE TOCANTINENSE', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5122, 5448, 'FACULDADE DE TECNOLOGIA FOCUS', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5123, 5449, 'FACULDADE DE TECNOLOGIA DO NORTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5124, 5450, 'FAT FUNDACAO DE APOIO A TECNOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5125, 5451, 'FACULDADE ANHANGUERA DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5126, 5452, 'EVOLUIR', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5127, 5453, 'INSTITUTO DE POS GRADUACAO EM CIENCIAS DA SAUDE IZAMAR MILIDIU DA SILVA LTDA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5128, 5454, 'FACULDADES GESTAO BRASIL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5129, 5455, 'FACULDADE PORTO ALEGRENSE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5130, 5456, 'INSTITUTO DE ENSINO SUPERIOR DA AMAZONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5131, 5457, 'INSTITUTO SUPERIOR DE EDUCACAO DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5132, 5458, 'ESCOLA DO MINISTERIO PUBLICO DE MARINGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5133, 5459, 'FACULDADE DE PEDAGOGIA DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5134, 5460, 'ESCOLA DO MINISTERIO PUBLICO DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5135, 5461, 'ESCOLA DO MINISTERIO PUBLICO DE LONDRINA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5136, 5462, 'FACULDADE DE CIENCIAS DA SAUDE DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5137, 5463, 'INSTITUTO SUPERIOR DA ASSOCIACAO FLUMINENSE DE AMPARO AOS CEGOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5138, 5464, 'ETHOSFARMA INSTITUTO DE ENSINO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5139, 5465, 'CONTEMPORANEO INSTITUTO DE PSICANALISE E TRANSDISCIPLINARIDADE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5140, 5466, 'FACULDADE DE CIENCIAS JURIDICAS DE AIMORES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5141, 5467, 'INSTITUTO BENJAMIN CONSTANT', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5142, 5468, 'ESCOLA EXISTENCIAL OTAVIO DE OLIVEIRA BRASIL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5143, 5469, 'INEPAD ESCOLA DE NEGOCIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5144, 5470, 'INSTITUTO SIGNOS DE EDUCACAO S S LTDA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5145, 5471, 'FACULDADE RIBEIRA DO POMBAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5146, 5472, 'PROCESSUS FACULDADE DE DIREITO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5147, 5473, 'FACULDADE DE CIENCIA, TECNOLOGIA E EDUCACAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5148, 5474, 'ESCOLA DE ULTRA SONOGRAFIA E RECICLAGEM MEDICA RIBEIRAO PRETO EURP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5149, 5475, 'INSTITUTO ANISIO TEIXEIRA', 2, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5150, 5476, 'EXCELLENCE BUSSINESS SCHOOL', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5151, 5477, 'COLEGIO BRASILEIRO DE CIENCIAS MEDICAS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5152, 5478, 'INSTITUTO SUPERIOR DE EDUCACAO IRENE DA CUNHA COSTA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5153, 5479, 'SOCIEDADE PAULISTA DE ORTODONTIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5154, 5480, 'SEITON CURSOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5155, 5481, 'CLINICA DE IMAGENOLOGIA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5156, 5482, 'FEMPERJ FUNDACAO ESCOLA SUPERIOR DO MINISTERIO PUBLICO DO ESTADO DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5157, 5483, 'INSTITUTO DE PESQUISAS E EXPERIMENTOS EM ODONTOLOGIA DO PIAUI LTDA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5158, 5484, 'FACULDADE DE EDUCACAO E CULTURA DE JI PARANA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5159, 5485, 'FACULDADE DE TECNOLOGIA DIAGRAMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5160, 5486, 'FACULDADE INSPIRAR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5161, 5487, 'FACULDADE DE TECNOLOGIA ALTO MEDIO SAO FRANCISCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5162, 5488, 'FACULDADE AURELIO DA ESTANCIA TURISTICA DE EMBU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5163, 5489, 'FACULDADE FAMA DE IMPERATRIZ', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5164, 5490, 'FACULDADE DE MEDICINA DR PAULO PRATA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5165, 5491, 'FACULDADE DO INSTITUTO ATLAS DE CIENCIA E TECNOLOGIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5166, 5492, 'FACULDADE DE MEDICINA E DE ENFERMAGEM NOVA ESPERANCA DE NATAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5167, 5493, 'FACULDADE DE TECNOLOGIA SENAI PAULO DE TARSO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5168, 5494, 'INSTITUTO JOSE ELIAS TAJRA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5169, 5495, 'FACULDADE MAURICIO DE NASSAU FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5170, 5496, 'FACULDADE MAURICIO DE NASSAU CABO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5171, 5497, 'FACULDADE DE TECNOLOGIA DO ISTITUTO EUROPEO DI DESIGN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5172, 5498, 'FACULDADE ORACULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5173, 5499, 'FACULDADE EDUCACIONAL DE FRANCISCO BELTRAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5174, 5500, 'FACULDADE ANGLOAMERICANO DE CHAPECO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5175, 5501, 'FACULDADES COC DE GOIANIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5176, 5502, 'FACULDADES COC DE MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5177, 5503, 'FACULDADES COC DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5178, 5504, 'FACULDADE UNIAO DE CAMPO MOURAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5179, 5505, 'INSTITUTO HAHNEMANNIANO DO BRASIL', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5181, 5507, 'CIODONTO POS GRADUACAO TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5182, 5508, 'CIODONTO POS GRADUACAO FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5183, 5509, 'CENTRO DE ENSINO REABILITACAO E TRATAMENTO ODONTOLOGICO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5184, 5510, 'FACULDADE DE TECNOLOGIA DE ALAGOAS', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5185, 5511, 'FACULDADE CAMPO REAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5186, 5512, 'INSTITUTO NACIONAL DE PESQUISAS DA AMAZONIA', 1, 1, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5187, 5513, 'CENTRO DE ESTUDOS E APERFEICOAMENTO ORTODONTICO PROFESSOR CARLOS TELLES CEAO CT', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5188, 5514, 'CIODONTO POS GRADUACAO BELEM', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5189, 5515, 'INSTITUTO SUPERIOR MENDES DE ALMEIDA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5190, 5516, 'INSTITUTO DE POS GRADUACAO MEDICA DO RIO DE JANEIRO LTDA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5191, 5517, 'INSTITUTO SOCRATES GUANAES ISG', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5192, 5518, 'FACULDADE GUARAPUAVA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5193, 5519, 'IPE POS GRADUACAO LATO SENSU', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5194, 5520, 'FACULDADE CATHEDRAL', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5195, 5521, 'FACULDADE DE CIENCIAS E TECNOLOGIA DO VALE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5196, 5522, 'FACULDADE ANHANGUERA DE PINDAMONHANGABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5197, 5523, 'FACULDADE DE TECNOLOGIA TECBRASIL UNIDADE NOVO HAMBURGO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5198, 5524, 'FACULDADE DE EDUCACAO E CULTURA DE BURITIS', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5199, 5525, 'FACULDADE DE TECNOLOGIA LOURENCO FILHO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5200, 5526, 'FACULDADE DE TECNOLOGIA E DESENVOLVIMENTO DE COMPETENCIAS', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5201, 5527, 'FACULDADE DE GOIANIA UNIDADE 1', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5202, 5528, 'FACULDADE METROPOLITANA DE ANAPOLIS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5203, 5529, 'FACULDADE SAO FRANCISCO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5204, 5530, 'ESCOLA DE DIREITO DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5205, 5531, 'FACULDADE INTERATIVA DE TECNOLOGIA E CIENCIAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5206, 5532, 'FACULDADE DE TECNOLOGIA FINACI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5207, 5533, 'FACULDADE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS DE CACHOEIRO DE ITAPEMIRIM', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5208, 5534, 'DINAMICO FACULDADE DE FLORIANO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5209, 5535, 'INSTITUTO UNIVERSAL DE MARKETING EM AGRIBUSINESS UMA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5210, 5536, 'FACULDADE DE TECNOLOGIA INED UNIDADE VENDA NOVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5211, 5537, 'FACULDADES VALE DO CARANGOLA FAVALE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5212, 5538, 'GANEP NUTRICAO HUMANA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5213, 5539, 'FACULDADE DO CENTRO DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5214, 5540, 'FACULDADE DE MUSICA SOUZA LIMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5215, 5541, 'FACULDADE DE TECNOLOGIA SENAC MINAS UNIDADE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5216, 5542, 'GANEP NUTRICAO HUMANA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5217, 5543, 'GANEP NUTRICAO HUMANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5218, 5544, 'FACULDADE PRESIDENTE ANTONIO CARLOS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5219, 5545, 'FACULDADE IPANEMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5220, 5546, 'FACULDADE PRINCESA DO OESTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5221, 5547, 'FACULDADE DE MATO GROSSO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5222, 5548, 'FACULDADE VILLA LOBOS DO CONE LESTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5223, 5549, 'IPOG INSTITUTO DE POS GRADUACAO E GRADUACAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5224, 5550, 'FACULDADE ANHANGUERA DE ANAPOLIS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5225, 5551, 'INSTITUTO MUNICIPAL DE ENSINO SUPERIOR DE ASSIS', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5226, 5552, 'FACULDADE DE TECNOLOGIA IBRATEC DE JOAO PESSOA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5227, 5553, 'UNIVERSIDADE HOLISTICA INTERNACIONAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5228, 5554, 'FUNDACAO DE APOIO CEFET RJ', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5229, 5555, 'FACULDADE ANHANGUERA DE JACAREI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5230, 5556, 'FACULDADE DO ENSINO DO ESTADO DO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5231, 5557, 'FACULDADE DE ENFERMAGEM DO HOSPITAL ISRAELITA ALBERT EINSTEIN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5232, 5558, 'INSTITUTO DE POS GRADUACAO NIVALDO NUERNBERG', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5233, 5559, 'FACULDADE DE ENGENHARIA DE MINAS GERAIS FEAMIG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5234, 5560, 'CENTRO DE APRENDIZAGEM E DESENVOLVIMENTO PROFISSIONAL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5235, 5561, 'ANGIOX', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5236, 5562, 'FUNDACAO INSTITUTO DE PESQUISAS CONTABEIS ATUARIAIS E FINANCEIRAS FIPECAFI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5237, 5563, 'SINDICATO DOS ODONTOLOGISTAS DO ESTADO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5238, 5564, 'FACULDADE DOM BOSCO DE CAPITAO LEONIDAS MARQUES', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5239, 5565, 'FACULDADE INTEGRADO DO RIO GRANDE DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5240, 5566, 'FACULDADE DE TECNOLOGIA NORTE FLUMINENSE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5241, 5567, 'INSTITUTO DE ENSINO SUPERIOR FRANCISCANO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5242, 5568, 'PRAETORIUM INSTITUTO DE ENSINO PESQUISA E ATIVIDADES DE EXTENSAO EM DIREITO LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5243, 5569, 'PRO RIM INSTITUTO DE EDUCACAO E PESQUISA EM SAUDE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5244, 5570, 'FUNDACAO GIRAMUNDO', 1, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5245, 5571, 'ADVANCE CURSOS DE POS GRADUCAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5246, 5572, 'INSTITUTO DE ENSINO PESQUISA E EXTENSAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5247, 5573, 'CENTRO DE PESQUISA E QUALIFICACAO TECNOLOGICA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5248, 5574, 'FACULDADE DE TECNOLOGIA DE IPATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5249, 5575, 'FACULDADE SAO MARCOS FASAMAR', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5250, 5576, 'FUNDACAO ESCOLA NACIONAL DE ADMINISTRACAO PUBLICA', 1, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5251, 5577, 'FACULDADE MAX PLANCK', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5252, 5578, 'ASSOCIACAO BRASILEIRA DE NUTROLOGIA ABRAN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5253, 5579, 'ESCOLA RIOPRETENSE DE ACUPUNTURA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5254, 5580, 'FACULDADE DE MEDICINA DE GARANHUNS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5255, 5581, 'CENTRO DE ESTUDOS DE CIENCIAS ODONTOLOGICAS IPIRANGA CECOI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5256, 5582, 'CURSOS SUI JURIS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5257, 5583, 'FACULDADE IGUAPENSE SANTO AUGUSTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5258, 5584, 'PANAMERICANA FACULDADE DE ARTE E DESIGN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5259, 5585, 'FACULDADE DE TECNOLOGIA SENAC MINAS UNIDADE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5260, 5586, 'FACULDADE DE TECNOLOGIA SENAC MINAS UNIDADE BARBACENA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5261, 5587, 'CENTRO DE POS GRADUACAO DA FUNDACAO ESCOLA DE ADMINISTRACAO DA UFBA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5262, 5588, 'CENTRO DE POS GRADUACAO DA FUNDACAO ESCOLA DE ADMINISTRACAO DA UFBA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5263, 5589, 'INSTITUTO CAPITAL HUMANO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5264, 5590, 'ESCOLA DE SOCIOLOGIA E POLITICA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5265, 5591, 'FACULDADES INTEGRADAS CAMOES', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5266, 5592, 'FACULDADES INTEGRADAS DO NORTE DE MINAS FUNORTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5267, 5593, 'FACULDADE ADVENTISTA DE HORTOLANDIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5268, 5594, 'FEMPTEC FUNDACAO DE EMPREENDIMENTOS PESQ E DESENV INST CIENT E TECNOL DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5269, 5595, 'FACULDADE DE FILOSOFIA DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5270, 5596, 'FACULDADE EVANGELICA DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5271, 5597, 'INSTITUTO CHIAVENATO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5272, 5598, 'INSTITUTO DENTALIS ENSINO E PESQUISA LTDA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5273, 5599, 'LIBERTAS FACULDADES INTEGRADAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5274, 5600, 'FACULDADES INTEGRADAS SAO JUDAS TADEU', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5275, 5601, 'FUNDACAO GORCEIX', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5276, 5602, 'ESCOLA SUPERIOR NEREU RAMOS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5277, 5603, 'HERNANDEZ ASSOCIADOS CONSULTORIA E TREINAMENTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5278, 5604, 'PROFIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5279, 5605, 'CENTRO DE ODONTOLOGIA E POS GRADUACAO SAO DOMINGOS LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5280, 5606, 'FACULDADE DE DIREITO DAMASIO DE JESUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5281, 5607, 'CENTRO DE ESTUDOS MONTESSORIANOS MENINO JESUS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5282, 5608, 'CEU CENTRO DE ESPECIALIZACAO UNIED', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5283, 5609, 'FUNDACAO DE ESTUDOS AGRARIOS LUIZ DE QUEIROZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5284, 5610, 'UNIVERSITAS PAULO FREIRE UNIFREIRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5285, 5611, 'UNISAOPAULO UNIVERSIDADES IN COMPANY DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5286, 5612, 'ASSOCIACAO INSTITUTO ANCHIETA DE ENSINO E PESQUISA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5287, 5613, 'ASSOCIACAO DE ENSINO DE CAMBE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5288, 5614, 'CAD CENTRO DE IDIOMAS E DESENVOLVIMENTO PROFISSIONAL LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5289, 5615, 'AFARP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5290, 5616, 'ASSOCIACAO PAULISTA CIRURGIOES DENTISTAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5291, 5617, 'GAPO GRUPO DE APOIO A PESQUISA ODONTOLOGICA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5292, 5618, 'ASSOCIACAO DE ASSISTENCIA A CRIANCA DEFICIENTE AACD', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5293, 5619, 'ASSOCIACAO ODONTOLOGICA DE RIBEIRAO PRETO AORP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5294, 5620, 'NAZARE UNIVERSIDADE DA LUZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5295, 5621, 'ACOES SOCIAIS EM SAUDE BUCAL E CIDADANIA B B INSTITUTO B B', 1, 1, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5296, 5622, 'ORDEM DOS ECONOMISTAS DO BRASIL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5297, 5623, 'ASSOCIACAO DOS CIRURGIOES DENTISTAS DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5298, 5624, 'FACULDADE PARANAPANEMA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5299, 5625, 'SOCIEDADE BRASILEIRA DE OFTALMOLOGIA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5300, 5626, 'UNIVERSA ESCOLA DE GESTAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5302, 5627, 'FACULDADE DE TECNOLOGIA DE PRESIDENTE PRUDENTE', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5303, 5633, 'FACULDADE DE TECNOLOGIA DE BRAGANCA PAULISTA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5304, 5663, 'FACULDADE DE VARGEM GRANDE PAULISTA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5305, 5664, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS DE ARARIPINA FACISA', 3, 1, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5306, 5668, 'FACULDADE ANHANGUERA DE JOINVILLE', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5307, 5669, 'FACULDADE DE TECNOLOGIA DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5308, 5670, 'FACULDADES UNIDAS DO VALE DO ARAGUAIA', 4, 2, 'MT', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5309, 5671, 'CENTRO UNIVERSITARIO SAO JOSE DE ITAPERUNA', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5310, 5701, 'UNIVERSIDADE DO ESTADO DO AMAPA', 2, 1, 'AP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5311, 5706, 'FACULDADE MUNICIPAL DE PALHOCA', 3, 1, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5312, 6490, 'FACULDADE DE TECNOLOGIA DE MAUA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5313, 10009, 'FAMAC FACULDADE DE MACHADINHO DO OESTE', 4, 2, 'RO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5314, 10016, 'FACULDADE OBOE   FACO', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5315, 10020, 'INSTITUTO LOGOS DE EDUCACAO SUPERIOR', 4, 2, 'AL', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5316, 10058, 'FACULDADE DE TECNOLOGIA DE VALENCA', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5317, 10059, 'FACULDADE DE TECNOLOGIA DE ENSINO SUPERIOR FATEC', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5318, 10071, 'FACULDADE DE TEOLOGIA E CIENCIAS HUMANAS', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5319, 10116, 'FACULDADE DE TECNOLOGIA SENAI CUIABA', 4, 2, 'MT', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5753, 10251, 'FACULDADE ORTODOXA', 4, 2, 'MT', 1, '2016-07-08 14:18:30.302088', NULL);
INSERT INTO modules.educacenso_ies VALUES (5320, 10323, 'FACULDADE DE TECNOLOGIA BANDEIRANTES', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5321, 10349, 'FACULDADE DE TECNOLOGIA IPPEO', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5322, 10385, 'INSTITUTO SAO PAULO DE ESTUDOS SUPERIORES', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5323, 10418, 'FACULDADE HSM', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5324, 10588, 'FACULDADE LIDER', 4, 2, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5325, 10613, 'FACULDADE DE SAUDE DE PAULISTA', 4, 2, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5326, 10685, 'FACULDADE NORTE CAPIXABA DE SAO MATEUS', 4, 2, 'ES', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5327, 10836, 'FACULDADE UNIAO ARARUAMA DE ENSINO S/S Ltda.', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5328, 10846, 'FACULDADE DINAMICA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5329, 10923, 'FACULDADE DE TECNOLOGIA DO TRANSPORTE', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5330, 10929, 'FACULDADE SANTO ANDRE', 4, 2, 'RO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5331, 10950, 'FACULDADE MARECHAL CANDIDO RONDON', 4, 2, 'RO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5332, 11007, 'FACULDADE CENTRO OESTE', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5333, 11289, 'ESCOLA SUPERIOR NACIONAL DE SEGUROS DE SAO PAULO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5334, 11308, 'FACULDADE ANHANGUERA DE SUMARE', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5335, 11376, 'FACULDADE VILLALOBOS DO CONELESTE PAULISTA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5336, 11428, 'FACULDADE DE TECNOLOGIA ALTO MEDIO SAO FRANCISCO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5337, 11429, 'FACULDADE ESPECIALIZADA NA AREA DE SAUDE DO RIO GRANDE DO SUL', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5338, 11544, 'FACULDADE METROPOLITANA DE ANAPOLIS', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5339, 11563, 'FACULDADE DE TECNOLOGIA DA SERRA GAUCHA CAXIAS DO SUL', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5340, 11584, 'FACULDADE CAL DE ARTES CENICAS', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5341, 11586, 'FACULDADES NETWORK   CAMPUS SUMARE', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5342, 11593, 'FACULDADE DE TECNOLOGIA DE MACAPA', 4, 2, 'AP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5343, 11604, 'FACULDADE ANGLOAMERICANO DE CHAPECO', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5344, 11645, 'FACULDADE DE EDUCACAO E CULTURA DE VILHENA', 4, 2, 'RO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5345, 11750, 'FACULDADE PITAGORAS DE VOTORANTIM SOROCABA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5346, 11751, 'FACULDADE PITAGORAS DE TECNOLOGIA DE BETIM', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5347, 11752, 'FACULDADE IDEAL PAULISTA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5348, 11807, 'FACULDADE DE TECNOLOGIA DO ISTITUTO EUROPEO DI DESIGN', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5349, 11817, 'FACULDADE DO POVO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5350, 11818, 'FACULDADE DE TECNOLOGIA INSPIRAR', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5351, 11841, 'FACULDADE EVOLUCAO ALTO OESTE POTIGUAR', 4, 2, 'RN', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5352, 11860, 'INSTITUTO NACIONAL DE ENSINO SUPERIOR E POSGRADUACAO PADRE GERVASIO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5353, 11861, 'FACULDADE DE CIENCIAS APLICADAS E TECNOLOGICAS DO LITORAL SUL', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5354, 11895, 'FACULDADE EVANGELICA DE TAGUATINGA', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5355, 11902, 'FACULDADE DE TECNOLOGIA E DESENVOLVIMENTO DE COMPETENCIAS', 4, 2, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5356, 11951, 'FACULDADE DO SERTAO BAIANO', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5357, 12005, 'FACULDADE DE TECNOLOGIA INED   UNIDADE VENDA NOVA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5358, 12052, 'FACULDADE DE TECNOLOGIA SENAI PAULO DE TARSO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5359, 12136, 'FACULDADE DE TECNOLOGIA DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5360, 12189, 'FACULDADE PRISMA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5361, 12229, 'FACULDADE DE TECNOLOGIA FAESA VILA VELHA', 4, 2, 'ES', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5362, 12247, 'ESCOLA DE DIREITO DE BRASILIA', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5363, 12249, 'FACULDADE PADRE ANCHIETA DE VARZEA PAULISTA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5364, 12268, 'FACULDADE DE TECNOLOGIA DE CRUZEIRO DO OESTE', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5365, 12338, 'FACULDADE DE TECNOLOGIA LA SALLE ESTRELA', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5366, 12346, 'FACULDADE METROPOLITANA SAO CARLOS', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5367, 12415, 'FACULDADES COC DE MACEIO', 4, 2, 'AL', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5368, 12416, 'FACULDADE BRASILIENSE DE NEGOCIOS', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5369, 12421, 'FACULDADES COC DE SAO PAULO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5370, 12430, 'FACULDADE METROPOLITANA SAO CARLOS BJI', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5371, 12522, 'FACULDADE MOGIANA DO ESTADO DE SAO PAULO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5372, 12523, 'FACULDADE DE TECNOLOGIA DA SERRA GAUCHA BENTO CONCALVES', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5373, 12547, 'FACITEN FACULDADE DE CIENCIAS E TECNOLOGIAS DE NATAL', 4, 2, 'RN', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5374, 12594, 'FACULDADE DE NEGOCIOS', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5375, 12597, 'FACULDADE PASSIONISTA DE EDUCACAO DE CURITIBA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5376, 12601, 'FACULDADE BRASILEIRA DE ESTUDOS AVANCADOS', 4, 2, 'MA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5377, 12611, 'FACULDADE DE MUSICA SOUZA LIMA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5378, 12620, 'FACULDADE DE TECNOLOGIA DE SETE LAGOAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5379, 12625, 'ESCOLA SUPERIOR DE AVIACAO CIVIL', 4, 2, 'PB', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5380, 12661, 'FACULDADE DE TECNOLOGIA SAINT PAUL', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5381, 12723, 'FACULDADE DE TECNOLOGIA FINACI', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5382, 12735, 'FACULDADE DE CIÊNCIAS HUMANAS E SOCIAIS DO XINGU E AMAZÔNIA', 4, 2, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5383, 12748, 'FACULDADE DE EDUCACAO, TECNOLOGIA E ADMINISTRACAO DE CAARAPO', 4, 2, 'MS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5384, 12749, 'FACULDADES UNIDAS DE PESQUISA, CIENCIAS E SAUDE LTDA', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5385, 12754, 'FACULDADE CRISTA DE CURITIBA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5386, 12758, 'FACULDADE DE EDUCACAO E CULTURA DE PORTO VELHO', 4, 2, 'RO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5387, 12766, 'FACULDADE UNIAO DE CAMPO MOURAO', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5388, 12772, 'FACULDADE DE TECNOLOGIA SENAC MINAS UNIDADE BELO HORIZONTE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5389, 12784, 'FACULDADE DE TECNOLOGIA TECBRASIL UNIDADE NOVO HAMBURGO', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5390, 12791, 'FACULDADE ANHANGUERA DE PINDAMONHANGABA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5391, 12803, 'FACULDADE IBMEC DISTRITO FEDERAL', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5392, 12829, 'FACULDADE EXITO', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5393, 12847, 'FACULDADE EDUCACIONAL DE FRANCISCO BELTRAO', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5394, 12848, 'FACULDADE DE TECNOLOGIA SENAC MINAS UNIDADE BARBACENA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5395, 12869, 'FACULDADES JOAO PAULO II', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5754, 12899, 'FACULDADE METROPOLITANA DO VALE DO AÇO', 4, 2, 'MG', 1, '2016-07-08 14:18:30.304431', NULL);
INSERT INTO modules.educacenso_ies VALUES (5396, 12916, 'IPOG INSTITUTO DE POSGRADUACAO & GRADUACAO', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5397, 12922, 'FACULDADE DE TECNOLOGIA E CIENCIAS DA BAHIA', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5398, 12923, 'FACULDADE DE TECNOLOGIA IPANEMA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5399, 12928, 'FACULDADE BRASIL CENTRAL', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5400, 12946, 'FACULDADE DE MATO GROSSO', 4, 2, 'MT', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5401, 13014, 'FACULDADE DE TEOLOGIA DA ARQUIDIOCESE DE BRASILIA', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5402, 13034, 'FACULDADE SHALOM DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5403, 13073, 'FACULDADE DE TECNOOLOGIA AEROTD', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5404, 13106, 'FACULDADE DE TECNOLOGIA LOURENCO FILHO', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5405, 13133, 'FACULDADE DE GOIANIA UNIDADE 1', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5406, 13238, 'INSTITUTO BRASILEIRO DE EDUCACAO SUPERIOR CONTINUADA', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5407, 13300, 'FACULDADE ADJETIVO CETEP', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5408, 13359, 'FACULDADE ANGLOAMERICANO DE BAGE', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5409, 13417, 'FACULDADE PRINCESA DO OESTE', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5410, 13452, 'FACULDADE DE TECNOLOGIA FUNDACAO UNIVERSITARIA DE CARDIOLOGIA', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5411, 13467, 'FACULDADE DE TECNOLOGIA EM SAUDE CIEPH', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5412, 13476, 'FACULDADE SAO BASILIO MAGNO', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5413, 13481, 'FACULDADES INTEGRADAS RIO BRANCO GRANJA VIANNA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5414, 13484, 'FACULDADE EUROPEIA DE VITORIA', 4, 2, 'ES', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5415, 13486, 'FACULDADE FACTUM', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5416, 13488, 'FACULDADE SEQUENCIAL', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5417, 13498, 'FACULDADE DE TECNOLOGIA DE BARRETOS', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5418, 13527, 'FACULDADE CANCAO NOVA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5419, 13538, 'FACULDADE CARAGUA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5420, 13620, 'FACULDADE ANHANGUERA DE PORTO ALEGRE', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5421, 13625, 'FACULDADE DE TECNOLOGIA NOVA PALHOCA', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5422, 13631, 'FACULDADE SAO FIDELIS', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5423, 13643, 'FACULDADES EVANGELICAS INTEGRADAS CANTARES DE SALOMAO', 4, 2, 'MT', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5424, 13648, 'FACULDADE SAO MARCOS', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5425, 13657, 'FACULDADE DE TECNOLOGIA ATENEU', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5426, 13663, 'FACULDADE ISEIB DE BETIM', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5427, 13666, 'FACULDADE DE DIREITO DE CONTAGEM', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5428, 13674, 'FACULDADE DE TECNOLOGIA SENAI TELEMACO BORBA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5429, 13677, 'FACULDADE DE TECNOLOGIA SENAI CIC', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5430, 13684, 'FACULDADE PITAGORAS DE CONTAGEM', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5431, 13695, 'ESCOLA DE MATEMATICA APLICADA', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5432, 13696, 'FACULDADE PRESIDENTE JK', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5433, 13716, 'FACULDADE DE TECNOLOGIA GAP', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5434, 13717, 'FACULDADES FUTURAO', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5435, 13724, 'PANAMERICANA FACULDADE DE ARTE E DESIGN', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5755, 13728, 'FACULDADE DOS CARAJÁS', 4, 2, 'PA', 1, '2016-07-08 14:18:30.304915', NULL);
INSERT INTO modules.educacenso_ies VALUES (5436, 13735, 'FACULDADE DE TECNOLOGIA, CAPACITACAO E GESTAO INTEGRAL', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5437, 13743, 'FACULDADE PITAGORAS DE GOVERNADOR VALADARES', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5438, 13749, 'FACULDADE EDUCACIONAL ARAUCARIA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5439, 13758, 'ESCOLA DE ADMINISTRACAO DE BRASILIA', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5756, 13764, 'FACULDADE DE TECNOLOGIA DE AMPÉRE', 4, 2, 'PR', 1, '2016-07-08 14:18:30.305397', NULL);
INSERT INTO modules.educacenso_ies VALUES (5440, 13775, 'FACULDADE DE TECNOLOGIA IBRATE', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5441, 13782, 'FACULDADE DE SANTA CRUZ DA BAHIA', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5442, 13783, 'FACULDADES UNIDAS FEIRA DE SANTANA', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5443, 13784, 'FACULDADE DO PLANALTO CENTRAL', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5444, 13792, 'INSTITUICAO DE ENSINO SUPERIOR DE CACOAL', 4, 2, 'RO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5445, 13796, 'FACULDADE DE PORTO FELIZ', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5446, 13809, 'FACULDADE SANTO AGOSTINHO DE SETE LAGOAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5447, 13811, 'TREVISAN ESCOLA SUPERIOR DE NEGOCIOS', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5448, 13812, 'ESCOLA SUPERIOR ABERTA DO BRASIL', 4, 2, 'ES', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5449, 13818, 'FACULDADE LA SALLE CAXIAS', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5450, 13828, 'FACULDADE ISEIB DE BELO HORIZONTE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5451, 13832, 'FACULDADE SAGRADA FAMILIA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5452, 13845, 'ESCOLA DIEESE DE CIENCIAS DO TRABALHO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5453, 13856, 'FACULDADE FACCENTRO', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5454, 13865, 'FACULDADE DE TECNOLOGIA ITEPA', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5455, 13873, 'FACULDADE FINOM DE PATOS DE MINAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5456, 13878, 'FATEC FACULDADE SENAI DE TECNOLOGIA', 4, 2, 'ES', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5457, 13883, 'FACULDADE MURIALDO', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5458, 13889, 'FACULDADE ITAPURANGA', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5459, 13890, 'FACULDADE DE TECNOLOGIA BSGU', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5460, 13897, 'FACULDADE LABORO', 4, 2, 'MA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5461, 13903, 'FACULDADE DE CIENCIAS GERENCIAIS DE SANTOS DUMONT', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5462, 13938, 'FACULDADE DE MARILIA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5463, 13944, 'FACULDADE DE ADMINISTRACAO E NEGOCIOS', 4, 2, 'AL', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5464, 13971, 'INSTITUTO DE ENSINO SUPERIOR INTEGRADO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5465, 13982, 'FACULDADE MAURICIO DE NASSAU DE BELEM', 4, 2, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5466, 14002, 'FACULDADE CEDEPE', 4, 2, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5467, 14005, 'INSTITUTO SUPERIOR DE CIENCIAS HUMANAS E SOCIAIS APLICADAS DE ABAETE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5468, 14027, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE MATOZINHOS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5469, 14028, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BETIM', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5470, 14029, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE AIMORES', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5471, 14032, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BELO HORIZONTE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5472, 14069, 'FACULDADE DE TECNOLOGIA PORTO SUL', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5473, 14090, 'FACULDADE BETIM', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5474, 14095, 'FACULDADE DE TECNOLOGIA FUTURO', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5475, 14097, 'FACULDADE REFIDIM', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5476, 14098, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ALMENARA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5477, 14101, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BAEPENDI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5478, 14114, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE MUTUM', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5479, 14115, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE PONTE NOVA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5480, 14117, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE PIRANGUINHO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5481, 14118, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE RAUL SOARES', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5482, 14119, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO FRANCISCO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5483, 14121, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO JOAO NEPOMUCENO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5484, 14122, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BELO ORIENTE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5485, 14123, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BOM SUCESSO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5486, 14124, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BURITIS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5487, 14125, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CAMPOS ALTOS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5488, 14126, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO LOURENCO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5489, 14127, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CAMPO BELO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5490, 14128, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE VAZANTE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5491, 14129, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CURVELO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5492, 14130, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE VARZEA DA PALMA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5493, 14131, 'Falculdade Presidente AntOnio Carlos de Divisa Alegre', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5494, 14132, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ITANHANDU', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5495, 14133, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE LAMBARI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5496, 14134, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ABRE CAMPO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5497, 14135, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO GOTARDO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5498, 14147, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BARAO DE COCAIS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5499, 14148, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE MARIANA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5500, 14149, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BOCAIUVA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5501, 14150, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE MONTES CLAROS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5502, 14151, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE NOVA LIMA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5503, 14152, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE PIUMHI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5504, 14153, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE PORTEIRINHA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5505, 14155, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SABARA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5506, 14156, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE TEOFILO OTONI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5507, 14157, 'FACULDADE DE EDUCACAO E ESTUDOS SOCIAIS DE UBERLANDIA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5757, 14158, 'FACULDADE DE TECNOLOGIA DE NOVO CABRAIS', 4, 2, 'RS', 1, '2016-07-08 14:18:30.305869', NULL);
INSERT INTO modules.educacenso_ies VALUES (5508, 14159, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CARMO DO PARANAIBA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5509, 14160, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CARMOPOLIS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5510, 14161, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CONTAGEM', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5713, 17224, 'FACULDADE CESMAC DO SERTAO', 4, 2, 'AL', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5511, 14162, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE GOVERNADOR VALADARES', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5512, 14163, 'FACULDADE DE EDUCACAO E ESTUDOS SOCIAIS DE GOVERNADOR VALADARES', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5513, 14165, 'FACULDADE TRES PONTAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5514, 14166, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ITABIRA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5515, 14169, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ITAMBACURI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5516, 14170, 'FACULADE PRESIDENTE ANTONIO CARLOS DE NEPOMUCENO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5517, 14171, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE PERDOES', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5518, 14172, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE POTE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5519, 14173, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE RIBEIRAO DAS NEVES', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5520, 14174, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO GONCALO DO RIO ABAIXO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5521, 14181, 'FACULDADE DE TECNOLOGIA DO COOPERATIVISMO', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5522, 14183, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO JOAO DEL REI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5523, 14189, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE MARIANA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5524, 14192, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE NANUQUE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5525, 14194, 'FACULDADE DE TEOLOGIA E CIÊNCIAS', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5526, 14201, 'INSTITUTO SUPERIOR DE CIENCIAS AGRARIAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5527, 14204, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ARCOS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5528, 14205, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BAMBUI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5529, 14206, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ELOI MENDES', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5530, 14207, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE JUATUBA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5531, 14208, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE LAGOA DOS PATOS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5532, 14209, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE LAGOA SANTA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5533, 14210, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE MARIA DA FE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5534, 14211, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE NAZARENO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5535, 14212, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO ROMAO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5536, 14213, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SETUBINHA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5537, 14214, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ALVARENGA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5538, 14215, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BARROSO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5539, 14216, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE DIVINO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5540, 14217, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE LADAINHA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5541, 14218, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE LUMINARIAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5542, 14219, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE LIBERDADE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5543, 14220, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE PIRAUBA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5544, 14221, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO DOMINGOS DO PRATA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5545, 14222, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SENHORA DOS REMEDIOS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5546, 14223, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CENTRAL DE MINAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5547, 14224, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CONCEICAO DAS ALAGOAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5548, 14225, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE FELIXLANDIA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5549, 14226, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE JABOTICATUBAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5550, 14227, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE RECREIO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5551, 14228, 'FACULDADE PRESIDENTE ANTONIO CARLOS RIO NOVO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5552, 14229, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO VICENTE DE MINAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5553, 14230, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE TOCANTINS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5554, 14231, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE URUANA DE MINAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5555, 14232, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE VESPASIANO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5556, 14236, 'FACULDADE DE CIENCIAS GERENCIAIS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5557, 14237, 'INSTITUTO SUPERIOR DE EDUCACAO DE CLAUDIO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5558, 14241, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ANDRE DA SILVEIRA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5559, 14242, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE TIMOTEO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5560, 14243, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ITABIRITO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5561, 14244, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE MONTE CARMELO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5562, 14245, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CAMPINA VERDE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5563, 14246, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE UBERABA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5564, 14247, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE TUPACIGUARA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5565, 14248, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE UBERLANDIA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5566, 14249, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CONGONHAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5567, 14258, 'INSTITUTO SUPERIOR DE ENSINO E PESQUISA DE CAMBUI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5568, 14261, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CONSELHEIRO PENA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5569, 14263, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ITAJUBA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5570, 14288, 'FACULDADE CATOLICA DE SANTA CATARINA', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5571, 14297, 'FACULDADE DE TECNOLOGIA INTENSIVA DE PARNAIBA', 4, 2, 'PI', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5572, 14313, 'NOVA FACULDADE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5573, 14321, 'FACULDADE MAURICIO DE NASSAU DE FORTALEZA', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5574, 14326, 'FACULDADE DE TECNOLOGIA INSAEOS', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5575, 14342, 'FACULDADE REDENTOR DE CAMPOS', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5576, 14367, 'FACULDADE EFICAZ', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5577, 14401, 'FACULDADE DE TECNOLOGIA PORTO DAS MONCOES', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5578, 14403, 'FACULDADE CESUMAR', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5579, 14408, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE BRASILIA', 1, 1, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5580, 14412, 'FACULDADE DE TECNOLOGIA SENAI PERNAMBUCO', 4, 2, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5581, 14429, 'FACULDADE PITAGORAS DE MACEIO', 4, 2, 'AL', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5582, 14509, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA BAIANO', 1, 1, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5583, 14609, 'FACULDADE DE TECNOLOGIA SENAI CONDE JOSE VICENTE DE AZEVEDO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5584, 14622, 'FACULDADES INTEGRADAS DE SERGIPE', 4, 2, 'SE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5585, 14715, 'FACULDADE PIAGET', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5586, 14717, 'FACULDADE MAURICIO DE NASSAU DE CARUARU', 4, 2, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5758, 14718, 'FACULDADE PARANÁ', 4, 2, 'PR', 1, '2016-07-08 14:18:30.306382', NULL);
INSERT INTO modules.educacenso_ies VALUES (5587, 14724, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO PARANA', 1, 1, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5588, 14727, 'FACULDADE PROGRESSO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5589, 14782, 'FACULDADE DE TECNOLOGIA SENAI CASCAVEL', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5590, 14783, 'FACULDADE DE TECNOLOGIA SENAI TOLEDO', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5591, 14784, 'FACULDADE DE TECNOLOGIA SENAI CURITIBA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5592, 14785, 'FACULDADE DE TECNOLOGIA SENAI MARINGA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5593, 14786, 'FACULDADE DE TECNOLOGIA SENAI LONDRINA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5594, 14858, 'FACULDADE DE TECNOLOGIA FRANCISCO MORATO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5595, 14860, 'FACULDADE TECNOLOGICA DENTAL CEEO', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5596, 14869, 'FACULDADE DE TECNOLOGIA DO IPE', 4, 2, 'MT', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5597, 14878, 'TREVISAN ESCOLA SUPERIOR DE NEGOCIOS', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5598, 14879, 'FACULDADE DOURADO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5599, 14882, 'FACULDADE HORIZONTE', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5600, 14890, 'FACULDADE PRAIA GRANDE', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5601, 14892, 'FACULDADE DE CIENCIAS DA SAUDE DE BARRETOS DR. PAULO PRATA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5602, 14901, 'FACULDADE INTEGRADA CARAJAS', 4, 2, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5603, 14914, 'FACULDADE TEOLOGICA EVANGELICA DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5604, 14927, 'FACULDADE SAO GABRIEL DA PALHA', 4, 2, 'ES', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5605, 14947, 'FACULDADE DE CIENCIAS DO TOCANTINS', 4, 2, 'TO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5606, 14951, 'FACULDADE DE ENGENHARIA E INOVACAO TECNICO PROFISSI', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5607, 14961, 'FACULDADE DE TECNOLOGIA EM SAUDE IAHCS', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5608, 14969, 'FACULDADE DE TECNOLOGIA EM SAÚDE', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5609, 14975, 'FACULDADE DO NORDESTE DA BAHIA', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5610, 14996, 'FACULDADE DE GESTAO E NEGOCIOS DE SALVADOR', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5611, 15001, 'UNIVERSIDADE FEDERAL DA INTEGRACAO LATINO AMERICANA', 1, 1, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5612, 15015, 'UNIVERSIDADE ESTADUAL DO NORTE DO PARANA', 2, 1, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5613, 15032, 'UNIVERSIDADE ALTO VALE DO RIO DO PEIXE', 3, 1, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5614, 15059, 'UNIVERSIDADE FEDERAL DO OESTE DO PARA', 1, 1, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5615, 15079, 'FACULDADE MASTER DE PARAUAPEBAS FAMAP', 4, 2, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5616, 15121, 'UNIVERSIDADE FEDERAL DA FRONTEIRA SUL', 1, 1, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5617, 15133, 'FACULDADE JARDINS', 4, 2, 'SE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5618, 15173, 'FACULDADE DE JARAGUA', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5619, 15236, 'FACULDADE DE TECNOLOGIA ALCIDES MAYA', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5620, 15272, 'FACULDADE DE TECNOLOGIA, EDUCACAO SUPERIOR E PROFISSIONAL', 4, 2, 'PI', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5621, 15280, 'FACULDADE BRASILEIRA DE ENSINO, PESQUISA E EXTENSAO', 4, 2, 'PB', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5622, 15351, 'FACULDADE IDEAU', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5623, 15355, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BOM DESPACHO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5624, 15357, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE UBA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5625, 15382, 'FACULDADE NOROESTE DO MATO GROSSO', 4, 2, 'MT', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5626, 15383, 'FACULDADE PARA O DESENVOLVIMENTO SUSTENTÁVEL DA AMAZÔNIA', 4, 2, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5627, 15401, 'FACULDADE FIPECAFI', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5628, 15410, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS DE SERRA TALHADA', 3, 1, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5629, 15428, 'FACULDADE DOM HEITOR SALES', 4, 2, 'RN', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5630, 15433, 'FACULDADE SEDAC', 4, 2, 'MT', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5631, 15445, 'FACULDADE METROPOLITANA DE CURITIBA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5632, 15447, 'CENTRO UNIVERSITARIO PRESIDENTE ANTONIO CARLOS DE BARBACENA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5633, 15448, 'CENTRO UNIVERSITARIO PRESIDENTE ANTONIO CARLOS JUIZ DE FORA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5634, 15449, 'CENTRO UNIVERSITARIO PRESIDENTE ANTONIO CARLOS DE ARAGUARI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5635, 15450, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE IPATINGA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5636, 15451, 'FACULDADE DE DIREITO DE IPATINGA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5637, 15452, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BOM DESPACHO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5638, 15453, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CONSELHEIRO LAFAIETE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5639, 15467, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE VISCONDE DO RIO BRANCO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5640, 15468, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE LEOPOLDINA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5641, 15497, 'UNIVERSIDADE DA INTEGRACAO INTERNACIONAL DA LUSOFONIA AFROBRASILEIRA', 1, 1, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5759, 15500, 'Faculdade Lusocapixaba', 4, 2, 'ES', 1, '2016-07-08 14:18:30.306888', NULL);
INSERT INTO modules.educacenso_ies VALUES (5642, 15501, 'FACULDADE DE TECNOLOGIA SENAI ROBERTO SIMONSEN', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5643, 15502, 'FACULDADE DE TECNOLOGIA SENAI SUICOBRASILEIRA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5644, 15504, 'FACULDADE IRECE', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5645, 15507, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO ACRE', 1, 1, 'AC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5646, 15508, 'INSTITUTO GALILEO DE ENSINO SUPERIOR', 4, 2, 'PI', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5647, 15518, 'FACUDADE DE MORRINHOS', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5648, 15520, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE MATO GROSSO DO SUL', 1, 1, 'MS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5714, 17226, 'FACULDADE CESMAC DO AGRESTE', 4, 2, 'AL', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5649, 15521, 'FACULDADE CATOLICA DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5650, 15522, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO AMAPA', 1, 1, 'AP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5651, 15526, 'FACULDADE DE GESTAO E NEGOCIOS DE FORTALEZA', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5760, 15562, 'Faculdade Batista do Cariri', 4, 2, 'CE', 1, '2016-07-08 14:18:30.307361', NULL);
INSERT INTO modules.educacenso_ies VALUES (5652, 15576, 'FACULDADE DE TECNOLOGIA DE MOGI DAS CRUZES', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5653, 15581, 'FACULDADE DE TECNOLOGIA DE SAO JOSE DOS CAMPOS JESSEN VIDAL', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5654, 15585, 'FACULDADE DE TECNOLOGIA SANTO ANDRE', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5655, 15639, 'FACULDADE DE TECNOLOGIA DE ITAQUAQUECETUBA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5656, 15669, 'FACULDADE DE CIENCIAS EXATAS DE GARANHUNS', 3, 1, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5657, 15680, 'FATEC CRUZEIRO PROF. WALDOMIRO MAY', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5658, 15682, 'FACULDADE DE TECNOLOGIA DE PIRACICABA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5659, 15687, 'FACULDADE DE TECNOLOGIA DE PINDAMONHANGABA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5660, 15688, 'FACULDADE DE TECONOLOGIA DA ZONA SUL', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5661, 15689, 'FACULDADE DE TECNOLOGIA DE BAURU', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5662, 15693, 'FACULDADE DE TECNOLOGIA DE ITAPETININGA PROF.ANTONIO BELIZANDRO BARBOSA REZENDE', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5663, 15695, 'FACULDADE DE TECNOLOGIA DOM AMAURY CASTANHO', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5664, 15696, 'FACULDADE DE TECNOLOGIA DE SERTAOZINHO', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5665, 15697, 'FACULDADE DE TECNOLOGIA DE ARACATUBA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5666, 15704, 'FACULDADE DE TECNOLOGIA DE CAPAO BONITO', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5667, 15708, 'FACULDADE DE TECNOLOGIA DR. THOMAZ NOVELINO', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5668, 15709, 'FACULDADE DE TECNOLOGIA DE OSASCO PREFEITO HIRANT SANAZAR', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5669, 15714, 'FATEC ARTHUR AZEVEDO MOGI MIRIM', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5670, 15715, 'FACULDADE DE TECNOLOGIA DE LINS', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5671, 15716, 'CENTRO EDUCACIONAL EM AERONAUTICA', 2, 1, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5672, 15745, 'FACULDADE DE TECNOLOGIA DE SAO CAETANO DO SUL', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5673, 15746, 'FACULDADE DE TECNOLOGIA DO IPIRANGA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5674, 15752, 'FACULDADE DE TECNOLOGIA DE GUARULHOS', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5675, 15753, 'FACULDADE DE TECNOLOGIA DE JABOTICABAL', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5676, 15757, 'FACULDADE DE TECNOLOGIA DE BARUERI', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5677, 15769, 'FACULDADE DE TECNOLOGIA DE JALES', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5678, 15775, 'FACULDADE DE TECNOLOGIA PROFESSOR FERNANDO AMARAL DE ALMEIDA PRADO', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5679, 15777, 'FACULDADE SUDOESTE PAULISTAITAPETININGA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5680, 15784, 'FACULDADE DE TECNOLOGIA ESTUDANTE RAFAEL ALMEIDA CAMARINHA MARILIA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5681, 15793, 'FACULDADE DE TECNOLOGIA DE SAO SEBASTIAO', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5682, 15803, 'FACULDADE DE TECNOLOGIA DE TATUI PROF. WILSON ROBERTO RIBEIRO DE CAMARGO', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5684, 15839, 'FACULDADE MOTIVA', 4, 2, 'PB', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5685, 15859, 'FACULDADE CATOLICA PAULISTA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5686, 15873, 'FACULDADE ITAQUA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5687, 15894, 'SOBRESP - FACULDADE DE CIENCIAS DA SAUDE', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5688, 15980, 'FACULDADE GAUCHA', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5689, 16037, 'INSTITUTO SUPERIOR DE CIENCIAS POLICIAIS', 2, 1, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5690, 16194, 'FACULDADE GRAN TIETE', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5691, 16395, 'FACULDADE DE TECNOLOGIA DE CARAPICUIBA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5692, 16410, 'FACULDADE DE TECNOLOGIA DE CATANDUVA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5693, 16453, 'FACULDADE DE TECNOLOGIA APOENA', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5694, 16502, 'FACULDADE PESTALOZZI DE FRANCA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5695, 16525, 'FACULDADE DUARTE COELHO', 4, 2, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5696, 16543, 'FACULDADE METROPOLITANA DO ESTADO DE SÃO PAULO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5761, 16602, 'FACULDADE DE EDUCAÇÃO ELIÂ', 4, 2, 'PA', 1, '2016-07-08 14:18:30.307841', NULL);
INSERT INTO modules.educacenso_ies VALUES (5697, 16728, 'FACULDADE DE CIENCIAS HUMANAS, ECONOMICAS E DA SAUDE', 4, 2, 'TO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5698, 16759, 'FACULDADE DO BICO DO PAPAGAIO', 4, 2, 'TO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5699, 16781, 'FACULDADE RIO SONO', 4, 2, 'TO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5762, 16782, 'Faculdade Mário Quintana', 4, 2, 'RS', 1, '2016-07-08 14:18:30.308305', NULL);
INSERT INTO modules.educacenso_ies VALUES (5763, 16849, 'Faculdade Modal', 4, 2, 'MG', 1, '2016-07-08 14:18:30.308763', NULL);
INSERT INTO modules.educacenso_ies VALUES (5700, 16864, 'FACULDADE CULTURA INGLESA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5701, 16881, 'FACULDADE PARA O DESENVOLVIMENTO DO SUDESTE TOCANTINENSE', 4, 2, 'TO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5702, 16894, 'FACULDADE DEVRY DE SÃO LUÍS', 4, 2, 'MA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5703, 16898, 'FACULDADE DE EDUCAÇÃO E TECNOLOGIA DA AMAZÔNIA', 4, 2, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5704, 16901, 'INSTITUTO EDUCATIE', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5705, 16914, 'FACULDADE LEONARDO DA VINCI SANTA CATARINA', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5764, 16918, 'FACULDADE CATÓLICA DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2016-07-08 14:18:30.309234', NULL);
INSERT INTO modules.educacenso_ies VALUES (5706, 16934, 'FACULDADE MELIES DE TECNOLOGIA ', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5707, 16943, 'FACULDADE TALLES DE MILETO', 4, 2, 'RN', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5765, 16948, 'Faculdade 28 de Agosto de Ensino e Pesquisa', 4, 2, 'SP', 1, '2016-07-08 14:18:30.309712', NULL);
INSERT INTO modules.educacenso_ies VALUES (5708, 16967, 'FACULDADE SENAI DE TECNOLOGIA', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5709, 17014, 'CENTRO SUPERIOR DE ESTUDOS JURIDICOS CARLOS DRUMMOND DE ANDRADE', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5766, 17025, 'Faculdade de Educação Superior de Paragominas', 4, 2, 'PA', 1, '2016-07-08 14:18:30.310355', NULL);
INSERT INTO modules.educacenso_ies VALUES (5767, 17091, 'Faculdade de Negócios do Recife', 4, 2, 'PE', 1, '2016-07-08 14:18:30.310892', NULL);
INSERT INTO modules.educacenso_ies VALUES (5768, 17115, 'FACULDADE DA UNIÃO DE ENSINO E PESQUISA INTEGRADA', 4, 2, 'PB', 1, '2016-07-08 14:18:30.311408', NULL);
INSERT INTO modules.educacenso_ies VALUES (5769, 17118, 'Faculdade do Norte de Mato Grosso', 4, 2, 'MT', 1, '2016-07-08 14:18:30.311934', NULL);
INSERT INTO modules.educacenso_ies VALUES (5710, 17138, 'CENTRO UNIVERSITARIO CATOLICA DE SANTA CATARINA EM JOINVILLE', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5711, 17165, 'FACULDADE UNILAGOS', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5712, 17200, 'FACULDADE BRASILEIRA DE TRIBUTAÇÃO', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5715, 17269, 'INSTITUTO SUPERIOR DE INOVAÇÃO E TECNOLOGIA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5716, 17277, 'FACULDADE DE TECNOLOGIA SENAC CRICIUMA', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5717, 17284, 'FACULDADE DE TECNOLOGIA INESUL DO MARANHAO', 4, 2, 'MA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5718, 17288, 'FACULDADE TEOLÓGICA BETÂNIA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5770, 17289, 'Faculdade de Teologia de Caratinga Uriel de Almeida Leitão', 4, 2, 'MG', 1, '2016-07-08 14:18:30.31245', NULL);
INSERT INTO modules.educacenso_ies VALUES (5719, 17291, 'FACULDADE ANTONIO PROPICIO AGUIAR FRANCO', 3, 1, 'TO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5720, 17322, 'FACULDADE INTEGRADA DE ARAGUATINS', 3, 1, 'TO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5721, 17326, 'FACULDADE GIANNA BERETTA', 4, 2, 'MA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5771, 17348, 'Faculdade de Tecnologia dos Inconfidentes', 4, 2, 'MG', 1, '2016-07-08 14:18:30.31299', NULL);
INSERT INTO modules.educacenso_ies VALUES (5772, 17355, 'Faculdade de Educação em Ciências da Saúde', 4, 2, 'SP', 1, '2016-07-08 14:18:30.313468', NULL);
INSERT INTO modules.educacenso_ies VALUES (5773, 17382, 'Faculdade Ietec', 4, 2, 'MG', 1, '2016-07-08 14:18:30.313964', NULL);
INSERT INTO modules.educacenso_ies VALUES (5774, 17394, 'Faculdade Alencarina de Sobral', 4, 2, 'CE', 1, '2016-07-08 14:18:30.314436', NULL);
INSERT INTO modules.educacenso_ies VALUES (5775, 17400, 'Faculdade Menino Deus', 4, 2, 'RS', 1, '2016-07-08 14:18:30.314901', NULL);
INSERT INTO modules.educacenso_ies VALUES (5722, 17401, 'FACULDADE DE TECNOLOGIA CNA', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5776, 17403, 'FACULDADE ARI DE SÁ', 4, 2, 'CE', 1, '2016-07-08 14:18:30.315443', NULL);
INSERT INTO modules.educacenso_ies VALUES (5777, 17420, 'FACULDADE CESUMAR DE PONTA GROSSA', 4, 2, 'PR', 1, '2016-07-08 14:18:30.315974', NULL);
INSERT INTO modules.educacenso_ies VALUES (5723, 17433, 'FACULDADE SANTO AGOSTINHO DE VITÓRIA DA CONQUISTA', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5778, 17460, 'FACULDADE Profissional', 4, 2, 'PR', 1, '2016-07-08 14:18:30.316482', NULL);
INSERT INTO modules.educacenso_ies VALUES (5724, 17498, 'FACULDADE DE SAÚDE SANTO AGOSTINHO DE VITÓRIA DA CONQUISTA', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5725, 17516, 'FACULDADE DE TECNOLOGIA DO SENAI HORACIO AUGUSTO DA SILVEIRA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5726, 17542, 'FACULDADE COMUNITARIA DE GUARAPARI', 4, 2, 'ES', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5779, 17558, 'Faculdade Santo André', 4, 2, 'RO', 1, '2016-07-08 14:18:30.31701', NULL);
INSERT INTO modules.educacenso_ies VALUES (5780, 17563, 'FACULDADE COESP', 4, 2, 'PB', 1, '2016-07-08 14:18:30.317484', NULL);
INSERT INTO modules.educacenso_ies VALUES (5781, 17565, 'FACULDADE DE CIÊNCIAS HUMANAS,EXATAS E DA SAÚDE DO PIAUÍ', 4, 2, 'PI', 1, '2016-07-08 14:18:30.317941', NULL);
INSERT INTO modules.educacenso_ies VALUES (5782, 17590, 'Faculdade ISAE BRASIL', 4, 2, 'PR', 1, '2016-07-08 14:18:30.318405', NULL);
INSERT INTO modules.educacenso_ies VALUES (5783, 17593, 'Faculdade de Botucatu', 4, 2, 'SP', 1, '2016-07-08 14:18:30.318861', NULL);
INSERT INTO modules.educacenso_ies VALUES (5784, 17598, 'FACULDADE PROF. WLADEMIR DOS SANTOS', 4, 2, 'SP', 1, '2016-07-08 14:18:30.319285', NULL);
INSERT INTO modules.educacenso_ies VALUES (5785, 17608, 'Faculdade de Educação Paulistana', 4, 2, 'SP', 1, '2016-07-08 14:18:30.319743', NULL);
INSERT INTO modules.educacenso_ies VALUES (5786, 17622, 'Faculdade Talles de Mileto - Sede Dragão do Mar', 4, 2, 'CE', 1, '2016-07-08 14:18:30.320402', NULL);
INSERT INTO modules.educacenso_ies VALUES (5787, 17628, 'Faculdade do Maciço do Baturité', 4, 2, 'CE', 1, '2016-07-08 14:18:30.321051', NULL);
INSERT INTO modules.educacenso_ies VALUES (5727, 17631, 'FACULDADE SENAI DE TECNOLOGIA DE POCOS DE CALDAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5728, 17633, 'CENTRO DE EDUCACAO SUPERIOR DA FOZ DO ITAJAI CESFI', 2, 1, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5788, 17662, 'Faculdade Galileu', 4, 2, 'SP', 1, '2016-07-08 14:18:30.321547', NULL);
INSERT INTO modules.educacenso_ies VALUES (5789, 17670, 'Faculdade de Quixeramobim', 4, 2, 'CE', 1, '2016-07-08 14:18:30.322035', NULL);
INSERT INTO modules.educacenso_ies VALUES (5790, 17672, 'INSTITUTO DE DIREITO PÚBLICO DE SÃO PAULO', 4, 2, 'SP', 1, '2016-07-08 14:18:30.322504', NULL);
INSERT INTO modules.educacenso_ies VALUES (5791, 17674, 'Faculdade de Educação de São Mateus', 4, 2, 'MA', 1, '2016-07-08 14:18:30.323067', NULL);
INSERT INTO modules.educacenso_ies VALUES (5729, 17690, 'FACULDADE DE TECNOLOGIA SENAI ROBERTO MANGE', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5730, 17691, 'FACULDADE DE TECNOLOGIA SENAI GASPAR RICARDO JUNIOR', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5792, 17701, 'FAP-FACULDADE DE PINHEIROS', 4, 2, 'ES', 1, '2016-07-08 14:18:30.323623', NULL);
INSERT INTO modules.educacenso_ies VALUES (5793, 17731, 'FACULDADE SESI-SP DE EDUCAÇÃO', 4, 2, 'SP', 1, '2016-07-08 14:18:30.324139', NULL);
INSERT INTO modules.educacenso_ies VALUES (5794, 17749, 'Faculdade América', 4, 2, 'ES', 1, '2016-07-08 14:18:30.324655', NULL);
INSERT INTO modules.educacenso_ies VALUES (5795, 17763, 'Faculdade SENAI de João Pessoa', 4, 2, 'PB', 1, '2016-07-08 14:18:30.325166', NULL);
INSERT INTO modules.educacenso_ies VALUES (5731, 17775, 'FACULDADE DE CIENCIAS DA SAUDE DE SERRA TALHADA', 3, 1, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5796, 17816, 'FACULDADE MAURÍCIO DE NASSAU DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2016-07-08 14:18:30.325665', NULL);
INSERT INTO modules.educacenso_ies VALUES (5797, 17828, 'Faculdade do Centro Leste - Cariacica', 4, 2, 'ES', 1, '2016-07-08 14:18:30.326154', NULL);
INSERT INTO modules.educacenso_ies VALUES (5798, 17831, 'Faculdade de Tecnologia e Negócios de Catalão', 4, 2, 'GO', 1, '2016-07-08 14:18:30.326683', NULL);
INSERT INTO modules.educacenso_ies VALUES (5799, 17850, 'FACULDADE TECNOLÓGICA SANTANNA', 4, 2, 'SP', 1, '2016-07-08 14:18:30.327206', NULL);
INSERT INTO modules.educacenso_ies VALUES (5800, 17854, 'FACULDADE CAPITAL FEDERAL', 4, 2, 'SP', 1, '2016-07-08 14:18:30.327744', NULL);
INSERT INTO modules.educacenso_ies VALUES (5732, 17942, 'FACULDADE DE TECNOLOGIA DO TATUAPE', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5733, 17952, 'FACULDADE DE TECNOLOGIA DE JACAREI', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5734, 17953, 'FACULDADE DE TECNOLOGIA DE POMPEIA SHUNJI NISHIMURA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5735, 17977, 'FACULDADE DE TECNOLOGIA DE ITAQUERA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5801, 18010, 'Faculdade Estácio de Cuiabá', 4, 2, 'MT', 1, '2016-07-08 14:18:30.328253', NULL);
INSERT INTO modules.educacenso_ies VALUES (5802, 18019, 'Faculdade do Educador', 4, 2, 'SP', 1, '2016-07-08 14:18:30.328747', NULL);
INSERT INTO modules.educacenso_ies VALUES (5803, 18023, 'FACULDADE MAURÍCIO DE NASSAU DE PETROLINA', 4, 2, 'PE', 1, '2016-07-08 14:18:30.329266', NULL);
INSERT INTO modules.educacenso_ies VALUES (5736, 18049, 'FACULDADE DE TECNOLOGIA DE TAUBATE', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5737, 18065, 'CISNE - FACULDADE DE QUIXADÁ', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5804, 18067, 'CISNE - Faculdade Tecnológica de Quixadá', 4, 2, 'CE', 1, '2016-07-08 14:18:30.329795', NULL);
INSERT INTO modules.educacenso_ies VALUES (5805, 18075, 'FACULDADE MAURÍCIO DE NASSAU DE JABOATÃO DOS GUARARAPES', 4, 2, 'PE', 1, '2016-07-08 14:18:30.330491', NULL);
INSERT INTO modules.educacenso_ies VALUES (5738, 18099, 'FACULDADE DE TECNOLOGIA DE DIADEMA LUIGI PAPAIZ', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5806, 18114, 'Faculdade Fasipe Mato Grosso', 4, 2, 'MT', 1, '2016-07-08 14:18:30.331224', NULL);
INSERT INTO modules.educacenso_ies VALUES (5807, 18133, 'Faculdade Unida de Campinas Goiânia - FACUNICAMPS GOIÂNIA', 4, 2, 'GO', 1, '2016-07-08 14:18:30.331864', NULL);
INSERT INTO modules.educacenso_ies VALUES (5808, 18165, 'Fundação Universidade Virtual do Estado de São Paulo', 2, 1, 'SP', 1, '2016-07-08 14:18:30.332461', NULL);
INSERT INTO modules.educacenso_ies VALUES (5809, 18257, 'FACULDADE SÄO JOSÉ', 4, 2, 'SC', 1, '2016-07-08 14:18:30.333078', NULL);
INSERT INTO modules.educacenso_ies VALUES (5810, 18288, 'Faculdade Latino-americana', 4, 2, 'SP', 1, '2016-07-08 14:18:30.333668', NULL);
INSERT INTO modules.educacenso_ies VALUES (5739, 18440, 'UNIVERSIDADE FEDERAL DO SUL E SUDESTE DO PARA', 1, 1, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5740, 18492, 'UNIVERSIDADE ESTADUAL DO PARANÁ', 2, 1, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5741, 18506, 'UNIVERSIDADE FEDERAL DO OESTE DA BAHIA', 1, 1, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5742, 18759, 'UNIVERSIDADE FEDERAL DO CARIRI', 1, 1, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5743, 18812, 'UNIVERSIDADE FEDERAL DO SUL DA BAHIA', 1, 1, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5744, 18817, 'FACULDADE DE TECNOLOGIA DE SÃO ROQUE', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5745, 18874, 'FACULDADE RAIMUNDO MARINHO DE PENEDO', 4, 2, 'AL', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5746, 19337, 'FACULDADE PARA O DESENVOLVIMENTO SUSTENTÁVEL DO NORDESTE', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5811, 19500, 'Faculdade de Tecnologia de São Carlos', 2, 1, 'SP', 1, '2016-07-08 14:18:30.334248', NULL);
INSERT INTO modules.educacenso_ies VALUES (5747, 19501, 'FACULDADE DE TECNOLOGIA SEBRAE', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5812, 19501, 'FACULDADE DE TECNOLOGIA SEBRAE', 2, 1, 'SP', 1, '2016-07-08 14:18:30.334732', NULL);
INSERT INTO modules.educacenso_ies VALUES (5748, 19512, 'INSTITUTO MASTER DE ENSINO PRESIDENTE ANTÔNIO CARLOS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5813, 19512, 'INSTITUTO MASTER DE ENSINO PRESIDENTE ANTÔNIO CARLOS', 4, 2, 'MG', 1, '2016-07-08 14:18:30.335189', NULL);
INSERT INTO modules.educacenso_ies VALUES (5814, 19578, 'Faculdade de Tecnologia de Cotia', 2, 1, 'SP', 1, '2016-07-08 14:18:30.335677', NULL);
INSERT INTO modules.educacenso_ies VALUES (5749, 19588, 'FACULDADE DE EDUCAÇÃO TECNOLÓGICA DO ESTADO DO RIO DE JANEIRO', 2, 1, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5815, 19588, 'FACULDADE DE EDUCAÇÃO TECNOLÓGICA DO ESTADO DO RIO DE JANEIRO', 2, 1, 'RJ', 1, '2016-07-08 14:18:30.336104', NULL);
INSERT INTO modules.educacenso_ies VALUES (5750, 19739, 'FACULDADE DE TECNOLOGIA DE CAMPINAS', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5816, 19739, 'FACULDADE DE TECNOLOGIA DE CAMPINAS', 2, 1, 'SP', 1, '2016-07-08 14:18:30.336569', NULL);
INSERT INTO modules.educacenso_ies VALUES (5817, 19862, 'Faculdade de Tecnologia de Bebedouro', 2, 1, 'SP', 1, '2016-07-08 14:18:30.337011', NULL);
INSERT INTO modules.educacenso_ies VALUES (5751, 19863, 'FACULDADE DE TECNOLOGIA DE ASSIS', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO modules.educacenso_ies VALUES (5818, 20478, 'Faculdade de Tecnologia de Santana de Parnaíba', 2, 1, 'SP', 1, '2016-07-08 14:18:30.33749', NULL);
INSERT INTO modules.educacenso_ies VALUES (5819, 21095, 'Academia Militar das Agulhas Negras', 3, 1, 'RJ', 1, '2016-07-08 14:18:30.337997', NULL);
INSERT INTO modules.educacenso_ies VALUES (5820, 21206, 'Escola de Educação Física do Exército', 3, 1, 'RJ', 1, '2016-07-08 14:18:30.338552', NULL);
INSERT INTO modules.educacenso_ies VALUES (5301, 9999999, 'INSTITUICAO NAO CADASTRADA', 4, 2, NULL, 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO modules.educacenso_ies VALUES (5821, 11748, 'FACULDADE DE EDUCAÇÃO E CULTURA DE JI-PARANÁ', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5822, 18062, 'FACULDADE MARECHAL RONDON', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5823, 19172, 'FACULDADES INTEGRADAS APARÍCIO CARVALHO VILHENA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5824, 15135, 'FACULDADE DE TECNOLOGIA SENAC AMAZONAS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5825, 17744, 'FACULDADE ESTÁCIO DE MANAUS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5826, 18684, 'FACULDADES SANTA TEREZA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5827, 18651, 'FACULDADE MAURÍCIO DE NASSAU DE BOA VISTA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5828, 17875, 'FACULDADE CATÓLICA DE BELÉM', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5829, 18077, 'FACULDADE COSMOPOLITA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5830, 18093, 'FACULDADE BRASIL INTELIGENTE', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5831, 18148, 'FACULDADE CONHECIMENTO & CIÊNCIA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5832, 13805, 'FACULDADE ADVENTISTA DA AMAZÔNIA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5833, 17487, 'FACULDADE METROPOLITANA DO MARAJÓ', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5834, 18516, 'FACULDADE MIRIENSE', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5835, 17666, 'FACULDADE METROPOLITANA DE PARAGOMINAS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5836, 17667, 'FACULDADE METROPOLITANA DE PARAUPEBAS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5837, 16816, 'FACULDADE DE ENSINO SUPERIOR DO  SUL DO PARÁ', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5838, 18253, 'FACULDADE VALE DO AÇO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5839, 18639, 'FACULDADE PITÁGORAS DE BACABAL', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5840, 17553, 'FACULDADE WALDIR FILHO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5841, 18497, 'FACULDADE MARANHENSE', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5842, 17352, 'FACULDADE DE EDUCAÇÃO MEMORIAL ADELAIDE FRANCO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5843, 16245, 'FACULDADE ESCOLA DE NEGÓCIOS EXCELLENCE', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5844, 18623, 'FACULDADE DE ESTUDOS SUPERIORES DO MARANHÃO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5845, 20110, 'FACULDADE DE TECNOLOGIA E ADMINISTRAÇÃO EDUFOR', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5846, 18745, 'FACULDADE DE CIÊNCIAS APLICADAS PIAUIENSE', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5847, 17405, 'FACULDADE AFONSO MAFRENSE', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5848, 18051, 'FACULDADES DE CIÊNCIAS E TECNOLOGIA DO NORDESTE LTDA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5849, 18167, 'FACULDADE CEPEP', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5850, 18478, 'FACULDADE PAULO PICANÇO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5851, 19206, 'FACULDADE DE EDUCAÇÃO E FORMAÇÃO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5852, 16559, 'FACULDADE SÃO FRANCISCO DO CEARÁ', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5853, 19173, 'FACULDADES INTEGRADAS DO CEARÁ', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5854, 17499, 'FACULDADE VIDAL DE LIMOEIRO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5855, 17688, 'FACULDADE DAS AMÉRICAS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5856, 18646, 'FACULDADE EVOLUÇÃO DO VALE DO ACARAÚ', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5857, 19597, 'FACULDADE CATÓLICA DA IBIAPABA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5858, 18978, 'FACULDADE REBOUÇAS DE CAMPINA GRANDE', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5859, 18627, 'FACULDADE PITÁGORAS DE JOÃO PESSOA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5860, 19329, 'FACULDADE JOAQUIM NABUCO DE JOÃO PESSOA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5861, 18211, 'FACULDADE MAURÍCIO DE NASSAU DO CABO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5862, 17109, 'FACULDADE ITPAC GARANHUNS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5863, 17116, 'FACULDADE DE CIÊNCIAS DE GOIANA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5864, 18209, 'FACULDADE MAURÍCIO DE NASSAU DE JABOATÃO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5865, 19607, 'FACULDADE SANTISSIMA TRINDADE', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5866, 16879, 'FACULDADE DE MEDICINA DE OLINDA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5867, 18210, 'FACULDADE MAURÍCIO DE NASSAU DE OLINDA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5868, 17715, 'FACULDADE DE EDUCAÇÃO SUPERIOR DE PERNAMBUCO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5869, 19465, 'FACULDADE METROPOLITANA DE PETROLINA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5870, 17894, 'FACULDADE NECTAR', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5871, 18267, 'FACULDADE INTEGRADA DE GESTÃO E MEIO AMBIENTE', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5872, 19327, 'FACULDADE CESAR EDUCAÇÃO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5873, 18471, 'FACULDADE DE CIÊNCIAS MÉDICAS AGGEU MAGALHÃES', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5874, 19331, 'FACULDADE JOAQUIM NABUCO DE MACEIÓ', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5875, 20494, 'FACULDADE AUTÔNOMA DO BRASIL - MACEIÓ', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5876, 19914, 'FACULDADE MASTER', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5877, 19297, 'FACULDADE PIO DECIMO DE CANINDE DO SAO FRANCISCO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5878, 18735, 'FACULDADE AGES DE LAGARTO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5879, 18636, 'FACULDADE DA REGIÃO SISALEIRA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5880, 19284, 'FACULDADE BATISTA BRASILEIRA DO RECÔNCAVO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5881, 17758, 'FACULDADE EUCLIDES DA CUNHA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5882, 17876, 'FACULDADE ESPÍRITO SANTO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5883, 17896, 'FACULDADE BRASILEIRA DE TECNOLOGIA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5884, 19408, 'FACULDADE AGES DE JACOBINA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5885, 18628, 'FACULDADE PITÁGORAS DE LUIS EDUARDO MAGALHÃES', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5886, 11862, 'FACULDADE ALFREDO NASSER DE REMANSO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5887, 21435, 'ESCOLA DE FORMAÇÃO COMPLEMENTAR DO EXÉRCITO', 3, 1, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5888, 18296, 'FACULDADE DE CIÊNCIAS HUMANAS E SOCIAIS III', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5889, 18625, 'FACULDADE PITÁGORAS DE VITÓRIA DA CONQUISTA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5890, 14199, 'INSTITUTO SUPERIOR DE EDUCAÇÃO DO ALTO SÃO FRANCISCO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5891, 18520, 'ALFA - FACULDADE DE ARAÇUAI', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5892, 18132, 'FACULDADE ESTÁCIO DE BARBACENA- ESTÁCIOBARBACENA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5893, 20053, 'FACULDADE UNIMED', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5894, 20664, 'INSTITUTO DE EDUCAÇÃO TECNOLÓGICA EIRELI', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5895, 18637, 'FACULDADE IMESMERCOSUR', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5896, 18692, 'ALFA - FACULDADE DE GUANHÃES', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5897, 18208, 'FACULDADE DOCTUM DE IPATINGA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5898, 18952, 'FACULDADE FAMART', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5899, 18956, 'FACULDADE DE CIÊNCIAS E TECNOLOGIA DE JANAÚBA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5900, 14738, 'FACULDADE FELUMA - SAÚDE, TECNOLOGIA E CIÊNCIA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5901, 18383, 'FACULDADE IPEL', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5902, 19865, 'FACULDADE UNA DE POUSO ALEGRE', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5903, 18454, 'FACULDADE UNA DE SETE LAGOAS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5904, 14191, 'FACULDADE PRESIDENTE ANTÔNIO CARLOS DE TEÓFILO OTONI', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5905, 14383, 'FACULDADE CENECISTA DE UBERABA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5906, 18036, 'PASSO 1', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5907, 18678, 'FACULDADE ESTÁCIO CACHOEIRO DE ITAPEMIRIM', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5908, 19050, 'FACULDADE INTEGRADA DE CARIACICA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5909, 19208, 'FACULDADE CAPIXABA DE CARIACICA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5910, 18490, 'INSTITUTO POLITÉCNICO DOCTUM DE GUARAPARI', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5911, 18107, 'FACULDADE ESTÁCIO DE SÃO MATEUS - ESTÁCIO SÃO MATEUS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5912, 17636, 'FACULDADE DA SERRA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5913, 19049, 'FACULDADE INTEGRADA DE VILA VELHA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5914, 17933, 'FACULDADE REDENTOR DE PARAÍBA DO SUL', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5915, 17657, 'FACULDADE PROFESSOR DALTRO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5916, 17738, 'FACULDADE CESGRANRIO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5917, 21414, 'CENTRO DE ESTUDOS DE PESSOAL E FORTE DUQUE DE CAXIAS', 3, 1, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5918, 21418, 'ESCOLA DE APERFEIÇOAMENTO DE OFICIAIS', 3, 1, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5919, 21419, 'ESCOLA DE INSTRUÇÃO ESPECIALIZADA', 3, 1, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5920, 21436, 'ESCOLA DE COMANDO E ESTADO-MAIOR DO EXÉRCITO', 3, 1, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5921, 21437, 'ESCOLA DE SAÚDE DO EXÉRCITO', 3, 1, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5922, 21439, 'ESCOLA DE ARTILHARIA DE COSTA E ANTIAÉREA', 3, 1, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5923, 21441, 'ESCOLA DE EQUITAÇÃO DO EXÉRCITO', 3, 1, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5924, 18048, 'FACULDADE VÉRTIX TRIRRIENSE', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5925, 18255, 'FACULDADE DE EDUCAÇÃO E TECNOLOGIA DE ARARAQUARA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5926, 18667, 'FACULDADE SANTO ANTONIO I', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5927, 18696, 'FACULDADE DE EDUCAÇÃO DE CAMPINAS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5928, 19586, 'FACULDADE UNITÀ', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5929, 19357, 'FACULDADE AFONSO SCHMIDT', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5930, 19358, 'FACULDADE THIAGO FERREIRA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5931, 13752, 'FACULDADE PROGRESSO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5932, 20465, 'FACULDADE DAS FLORES', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5933, 17928, 'FACULDADE ALIANÇA EDUCACIONAL DO ESTADO DE SÃO PAULO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5934, 17902, 'FACULDADE ESAMC JUNDIAÍ', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5935, 18258, 'FACULDADE RENIL DO BRASIL', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5936, 18526, 'FACULDADE CIDADE DE OSASCO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5937, 15922, 'FACULDADE BÍBLICA DAS ASSEMBLÉIAS DE DEUS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5938, 19861, 'FACULDADE DE SANTANA DE PARNAÍBA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5939, 17899, 'FACULDADE DE EDUCAÇÃO  E TECNOLOGIA DE SÃO CARLOS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5940, 17803, 'FACULDADE SEB DE NEGÓCIOS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5941, 13466, 'GRUPO DE NUTRIÇÃO HUMANA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5942, 17587, 'INSTITUTO DE FORMAÇÃO PROFISSIONAL ADMINISTRATIVA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5943, 18035, 'ESCOLA BRASILEIRA DE MEDICINA CHINESA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5944, 18072, 'FACULDADE LUSÓFONA DE SÃO PAULO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5945, 18266, 'FACULDADE SAINT GERMAIN SP', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5946, 19252, 'FACULDADE DE TECNOLOGIA ALPHA CHANNEL', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5947, 20328, 'FACULDADE DE ODONTOLOGIA DA APCD', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5948, 21509, 'INSTITUTO DE ENSINO E PESQUISA DO HOSPITAL SÍRIO-LIBANÊS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5949, 22022, 'INSTITUTO DE EDUCAÇÃO MORUMBI', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5950, 18406, 'FACULDADE CAMPOS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5951, 18407, 'FACULDADE FRONTEIRA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5952, 18408, 'FACULDADE TABOÃO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5953, 21416, 'CENTRO DE INSTRUÇÃO DE AVIAÇÃO DO EXÉRCITO', 3, 1, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5954, 17982, 'FACULDADE RHEMA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5955, 19406, 'FACULDADES INTEGRADAS CESUMAR DE ARAPONGAS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5956, 16107, 'FACULDADE PASSIONISTA DE EDUCAÇÃO DE CURITIBA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5957, 18046, 'FACULDADE ILAPEO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5958, 18064, 'CENTRO TECNOLÓGICO POSITIVO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5959, 18726, 'FACULDADE DE INOVAÇÃO TECNOLÓGICA DE CURITIBA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5960, 19196, 'FACULDADE IDD', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5961, 19251, 'FACULDADE PÓLIS CIVITAS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5962, 20330, 'FACULDADE EDUCACIONAL ARAUCÁRIA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5963, 18154, 'FACULDADE INTEGRADA DE GUARAPUAVA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5964, 19189, 'FIP - FACULDADE DE IPORÃ PARANÁ', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5965, 17632, 'FACULDADE CESUMAR DE LONDRINA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5966, 18290, 'FACULDADE INTEGRADA DE LONDRINA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5967, 18716, 'FACULDADE DE INOVAÇÃO TECNOLÓGICA DE LONDRINA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5968, 18149, 'FACULDADE CESUMAR DE MARINGÁ', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5969, 18289, 'FACULDADE INTEGRADA DE MARINGÁ', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5970, 18147, 'FACULDADE INTEGRADA DE PONTA GROSSA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5971, 18714, 'FACULDADE DE INOVAÇÃO TECNOLÓGICA DE PONTA GROSSA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5972, 17882, 'FACULDADE ESCOLA POLITÉCNICA DE INOVAÇÃO E CONHECIMENTO APLICADO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5973, 18025, 'FACULDADE DE EDUCAÇÃO SUPERIOR DE CHAPECÓ', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5974, 19551, 'CENTRO UNIVERSITÁRIO BARRIGA VERDE / UNIBAVE COCAL DO SUL', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5975, 17777, 'FACULDADE DE TECNOLOGIA SENAC CONCÓRDIA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5976, 21492, 'INSTITUTO DE PÓS-GRADUAÇÃO E ATUALIZAÇÃO EM ODONTOLOGIA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5977, 18201, 'FACULDADE DE TECNOLOGIA SENAC PALHOÇA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5978, 19587, 'FACULDADES JOÃO PAULO II - PELOTAS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5979, 15611, 'FACULDADE TECNOLÓGICA LATINO AMERICANA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5980, 18681, 'FACULDADE VERBO EDUCACIONAL', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5981, 19542, 'FACULDADES JOÃO PAULO II - CAMPUS PORTO ALEGRE', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5982, 21550, 'INSTITUTO MOINHOS DE VENTO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5983, 18034, 'CENTRO DE ENSINO SUPERIOR RIOGRANDESE', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5984, 18463, 'FACULDADE DE ADMINISTRAÇÃO, HUMANAS E EXATAS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5985, 18160, 'FACULDADES INTEGRADAS TOLEDO DE TRÊS LAGOAS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5986, 18616, 'FACULDADE ÁGORA - FAG', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5987, 18073, 'FACULDADE FASIPE CUIABÁ', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5988, 17889, 'FACULDADE IBG', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5989, 17874, 'FACULDADE DE EDUCAÇÃO SUPERIOR DE TANGARÁ DA SERRA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5990, 18450, 'FACULDADE IDEAL DE ALTO HORIZONTE', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5991, 20455, 'FACULDADE TENOLÓGICA DE ANÁPOLIS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5992, 18474, 'FACULDADE POLITÉCNICA DE GOIÁS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5993, 18115, 'FACULDADE ESTÁCIO DE GOIÂNIA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5994, 17559, 'FACULDADE LOGOS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5995, 17490, 'FACULDADE JOÃO PAULO II', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5996, 17680, 'FACULDADE EVANGÉLICA DE SENADOR CANEDO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5997, 19198, 'FACULDADE DE TECNOLOGIA E EDUCAÇÃO DE GOIÁS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5998, 16218, 'FACULDADE CLARETIANA DE BRASILIA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (5999, 16628, 'FACULDADE ANASPS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (6000, 18509, 'FACULDADE DF', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (6001, 18800, 'ESCOLA SUPERIOR DO MINISTÉRIO PÚBLICO', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (6002, 19216, 'FACULDADE METROPOLITANA RECANTO DAS EMAS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (6003, 19219, 'FACULDADE DO DISTRITO FEDERAL', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (6004, 19229, 'FACULDADE PRESBITERIANA MACKENZIE BRASILIA', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (6005, 19281, 'FACULDADE ATAME', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (6006, 21417, 'CENTRO DE INSTRUÇÃO DE GUERRA ELETRÔNICA', 3, 1, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (6007, 21420, 'ESCOLA DE INTELIGÊNCIA MILITAR DO EXÉRCITO', 3, 1, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (6008, 21440, 'ESCOLA DE COMUNICAÇÕES', 3, 1, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (6009, 21488, 'ESCOLA DE ADMINISTRAÇÃO E NEGÓCIOS', 4, 2, NULL, 1, '2018-11-19 15:00:22.964612', NULL);
INSERT INTO modules.educacenso_ies VALUES (6010, 16225, 'Faculdade Regional do Jacuípe', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6011, 16459, 'FACULDADE BRASILEIRA DE TECNOLOGIA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6012, 16691, 'Faculdade NETCOM', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6013, 16895, 'INSTITUTO POLITÉCNICO DOCTUM DE VITÓRIA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6014, 17438, 'Faculdade Católica Cavanis do Sudoeste do Pará', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6015, 17613, 'ACADEMIA NACIONAL DE POLÍCIA - ANP', 1, 1, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6016, 17704, 'Faculdade Retama', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6017, 17745, 'Faculdade de São Carlos', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6018, 17839, 'FACULDADE DE DRACENA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6019, 17886, 'Faculdade de Educação Sul do Piauí', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6020, 17887, 'Faculdade de Ciências Médicas de São José dos Campos', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6021, 17926, 'Faculdade de Ensino Superior Paschoal Dantas', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6022, 18009, 'Faculdade ICG', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6023, 18033, 'FACULDADE DE TEODORO SAMPAIO', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6024, 18038, 'Faculdade de Tecnologia IPENO', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6025, 18059, 'FACULDADE SANTO ANTONIO DE QUEIMADAS', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6026, 18145, 'Faculdade Estácio de São José do Rio Preto', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6027, 18164, 'Faculdade Estácio de Bauru', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6028, 18260, 'Faculdade Estácio de Imperatriz - ESTÁCIO IMPERATRIZ', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6029, 18276, 'FACULDADE CRIATIVO DE CIÊNCIAS APLICADAS', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6030, 18319, 'FAINIC - Faculdades Integradas NIC', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6031, 18338, 'Faculdade Gamaliel', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6032, 18370, 'FACULDADE INOVA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6033, 18372, 'FACULDADE SOLIDARIA DO OESTE PAULISTA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6034, 18626, 'Faculdade Pitágoras de Arapiraca', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6035, 18631, 'FACULDADE DO VALE DO RIO ARINOS', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6036, 18642, 'UNAMA FACULDADE DA AMAZÔNIA DE ANANINDEUA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6037, 18643, 'FACULDADE UNINASSAU MARACANAÚ', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6038, 18647, 'FACULDADE DA AMAZÔNIA DE MARABÁ', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6039, 18648, 'Faculdade Uninassau Arapiraca', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6040, 18649, 'FACULDADE MAURÍCIO DE NASSAU DE MOSSORÓ', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6041, 18650, 'UNAMA FACULDADE DA AMAZÔNIA DE RIO BRANCO', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6042, 18652, 'FACULDADE UNINASSAU JUAZEIRO DO NORTE', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6121, 20003, 'FACULDADE SERRANA DE SAÚDE', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6043, 18653, 'FACULDADE MAURÍCIO DE NASSAU DE GARANHUNS', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6044, 18659, 'Faculdade Educacional Fortaleza - EDUFOR', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6045, 18671, 'FACULDADE DA AMAZÔNIA DE PORTO VELHO', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6046, 18672, 'Unama Faculdade da Amazônia de Macapá', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6047, 18673, 'FACULDADE MAURÍCIO DE NASSAU DE GOIANIA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6048, 18675, 'Faculdade Univeritas Universus Veritas de Campo Grande', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6049, 18676, 'FACULDADE MAURÍCIO DE NASSAU DE PALMAS', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6050, 18679, 'Faculdade de Sidrolândia', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6051, 18698, 'FACULDADE DE EDUCAÇÃO DE MATÃO', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6052, 18700, 'Faculdade AGES de Jeremoabo', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6053, 18703, 'Faculdade JK Brasília Asa Sul II', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6054, 18708, 'Faculdade AGES de Senhor do Bonfim', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6055, 18711, 'Faculdade de Tecnologia e Ciências', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6056, 18719, 'FACULDADE DE EDUCAÇÃO DE SANTA CATARINA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6057, 18749, 'Faculdade de Elesbão Veloso', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6058, 18799, 'Faculdade Itataia', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6059, 18896, 'Soberana Faculdade de Saúde de Petrolina', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6060, 18958, 'FACULDADES INTEGRADAS QUALIS', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6061, 18979, 'FACULDADE CAPIXABA DE VILA VELHA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6062, 19130, 'FACULDADE SERRA GERAL', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6063, 19171, 'Faculdade de Teologia Fortaleza - FATEFOR', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6064, 19197, 'FACULDADE NIP DE CIÊNCIAS APLICADAS', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6065, 19214, 'Faculdade Norte e Nordeste do Brasil', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6066, 19255, 'Faculdade Pitágoras de Bom Jesus da Lapa', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6067, 19257, 'Faculdade Una de Divinópolis', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6068, 19260, 'Faculdade Pitágoras de Jequié', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6069, 19287, 'Faculdade do Centro Maranhense', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6070, 19298, 'Faculdade Pitagoras de Eunapolis', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6071, 19319, 'FACULDADE METROPOLITANA DE TERESINA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6072, 19320, 'Escola Nacional de Administração e Economia da Fundação Getulio Vargas', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6073, 19323, 'Faculdade Pitagoras de Maraba', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6074, 19325, 'Faculdade do Centro Oeste Paulista', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6075, 19332, 'FACULDADE JOAQUIM NABUCO DE BELÉM', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6076, 19333, 'FACULDADE UNINASSAU FORTALEZA - PARANGABA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6077, 19334, 'FACULDADE MAURÍCIO DE NASSAU DE BRASÍLIA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6078, 19335, 'FACULDADE UNIVERITAS UNIVERSUS VERITAS ANÁPOLIS', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6079, 19342, 'FACULDADE JOAQUIM NABUCO DE MANAUS', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6080, 19345, 'FACULDADE UNINABUCO NATAL', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6081, 19352, 'Faculdade Paulista de Gestão e Saúde', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6082, 19369, 'Faculdade Martinho Lutero', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6083, 19374, 'FACULDADE SANTA LUZIA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6084, 19375, 'FACULDADES INTEGRADAS CESUMAR', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6085, 19404, 'FACULDADES INTEGRADAS CESUMAR DE CURITIBA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6086, 19407, 'FACULDADES INTEGRADAS CESUMAR DE GUARAPUAVA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6087, 19476, 'EMGE - ESCOLA DE ENGENHARIA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6088, 19555, 'Favenorte de Porteirinha', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6089, 19563, 'FACULDADE DE ADMINISTRAÇÃO E CIÊNCIAS ECONÔMICAS LTDA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6090, 19565, 'Faculdade Tecnológica de Pernambuco', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6091, 19632, 'FACULDADE DAMA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6092, 19670, 'Faculdade de Ciências da Saúde Moinhos de Vento', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6093, 19674, 'Faculdade do Vale do São Francisco', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6094, 19716, 'Faculdade Integral de Jaboatão dos Guararapes', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6095, 19733, 'FACULDADE RENOVAÇÃO DE PONTA GROSSA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6096, 19735, 'FACULDADE RENOVAÇÃO DE LONDRINA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6097, 19781, 'Faculdade Pitágoras de Juiz de Fora', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6098, 19783, 'Faculdade Pitágoras de Paragominas', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6099, 19786, 'Faculdade Pitágoras da Serra', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6100, 19787, 'Faculdade Pitágoras de Tucuruí', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6101, 19793, 'FACULDADE FADAM DE MARACANAÚ', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6102, 19844, 'FACULDADE MAURÍCIO DE NASSAU DE SOBRAL', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6103, 19846, 'Faculdade Autônoma do Brasil - Cabo de Santo Agostinho', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6104, 19849, 'FACULDADE MAURÍCIO DE NASSAU DE VITÓRIA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6105, 19853, 'ATOPP BRASIL FACULDADE DE NEGÓCIOS', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6106, 19859, 'Faculdade Padre Dourado', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6107, 19860, 'FACULDADE CONCEITO EDUCACIONAL', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6108, 19864, 'Faculdade de Tecnologia de Itapira', 2, 2, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6109, 19866, 'Faculdade EduCareMT', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6110, 19883, 'Faculdade Sul Paulista de Itanhaém', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6111, 19910, 'Faculdades Planalto Central', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6112, 19943, 'Escola Superior de Gestão e Negócios de Porto Velho', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6113, 19945, 'Escola Superior de Engenharia de Porto Velho', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6114, 19951, 'FACULDADE DE GESTAO E NEGOCIOS DE MACEIO', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6115, 19952, 'FACULDADE DE GESTAO E NEGOCIOS DE CACHOEIRINHA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6116, 19956, 'FACULDADE DE GESTAO E NEGOCIOS DE JOAO PESSOA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6117, 19957, 'FACULDADE DE GESTAO E NEGOCIOS DE PARNAMIRIM', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6118, 19958, 'FACULDADE DE GESTAO E NEGOCIOS DE TERESINA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6119, 19963, 'FACULDADE DE ODONTOLOGIA DO NORTE DE MINAS', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6120, 19966, 'FACULDADE CAPITAL 1 DE ITAPECERICA DA SERRA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6122, 20052, 'Faculdade ABC de Goiânia', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6123, 20090, 'FACULDADE REDENTOR METROPOLITANA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6124, 20098, 'Faculdade Integração', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6125, 20100, 'Instituto Leya de Educação Superior', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6126, 20105, 'Faculdade de Ciências e Saúde Edufor', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6127, 20106, 'FACULDADE STBNB', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6128, 20122, 'Faculdade de Ensino Superior Multiprofissional', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6129, 20200, 'Faculdade do Cariri', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6130, 20219, 'FACULDADE TIRADENTES DE FEIRA DE SANTANA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6131, 20322, 'Escola de Ensino Superior do Agreste Paraibano', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6132, 20340, 'FACULDADE PAULISTA DE CIÊNCIAS DA SAÚDE', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6133, 20406, 'Faculdade Jaguar Indaiá', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6134, 20410, 'Faculdade de Indiara', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6135, 20476, 'Faculdade ANCLIVEPA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6136, 20499, 'Faculdade da Polícia Militar', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6137, 20530, 'Faculdade Marquês de Olinda', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6138, 20541, 'FACULDADE DO INSTITUTO SUPERIOR DE EDUCAÇÃO - ISE', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6139, 20547, 'Faculdade Novo Tempo de Itapipoca', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6140, 20561, 'União de Ensino Superior de Saúde e Tecnologia de Planaltina', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6141, 20570, 'Faculdade Alpha', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6142, 20605, 'Faculdades EMED - Escola de Ciências Médicas e da Saúde', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6143, 20606, 'Faculdade de Tecnologia e Ciências', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6144, 20607, 'Faculdade de Tecnologia e Ciências - FTC Petrolina', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6145, 20636, 'Faculdade Trilógica Keppe & Pacheco', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6146, 20643, 'FACULDADE UNIRB - TERESINA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6147, 20651, 'Faculdades IDAAM', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6148, 20667, 'UNETRI FACULDADES', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6149, 21112, 'Instituto de Gestão e Tecnologia da Informação', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6150, 21200, 'Faculdade ISMD', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6151, 21204, 'FACULDADE UNITERP', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6152, 21210, 'Faculdade Estratego', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6153, 21213, 'Faculdade FAE Araucária', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6154, 21215, 'Faculdade de Ensino de Pesquisa do Cooperativismo', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6155, 21240, 'FACULDADE UNIRB - PIAUÍ', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6156, 21262, 'FACULDADE REGIONAL JAGUARIBANA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6157, 21287, 'FACULDADE ESTÁCIO DE CASCAVEL', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6158, 21288, 'FACULDADE ESTÁCIO DE SÃO JOSÉ DOS PINHAIS', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6159, 21344, 'Faculdade Campos Giglio', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6160, 21364, 'FACULDADE MAURÍCIO DE NASSAU DE PORTO ALEGRE', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6161, 21366, 'FACULDADE MAURÍCIO DE NASSAU DE CURITIBA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6162, 21411, 'FACULDADE MAURÍCIO DE NASSAU CUIABÁ', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6163, 21415, 'FACULDADE UNA DE NOVA SERRANA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6164, 21421, 'FACULDADE JOAQUIM NABUCO SALVADOR', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6165, 21426, 'Faculdade Novoeste', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6166, 21442, 'Faculdade Mega', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6167, 21446, 'Instituto Superior da Convenção Nac. das Assembleias de Deus', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6168, 21540, 'FACULDADE FREIRE DE ENSINO', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6169, 21583, 'FACULDADE DE EDUCAÇÃO SUPERIOR DE PERNAMBUCO', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6170, 21593, 'FACULDADE PLUS DRAGÃO DO MAR', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6171, 21638, 'Faculdade do Instituto Pecege', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6172, 21643, 'Faculdade Rudolf Steiner', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6173, 21675, 'FACULDADE CIDADE DE APARECIDA DE GOIÂNIA', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6174, 21676, 'Faculdade Avantis de Itapema', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6175, 21713, 'Faculdade de Tecnologia - Fatec de Ribeirão Preto', 2, 2, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6176, 22093, 'Faculdade AGES de Medicina', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6177, 22096, 'FACULDADE SÃO LEOPOLDO MANDIC DE ARARAS', 4, 4, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6178, 22319, 'Faculdade de Tecnologia de Itatiba', 2, 2, NULL, 1, '2018-11-19 15:00:26.529759', NULL);
INSERT INTO modules.educacenso_ies VALUES (6179, 22939, 'Faculdade de Tecnologia de Araraquara', 2, 2, NULL, 1, '2018-11-19 15:00:26.529759', NULL);


--
-- TOC entry 8235 (class 0 OID 0)
-- Dependencies: 391
-- Name: educacenso_ies_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.educacenso_ies_id_seq', 6179, true);


--
-- TOC entry 8134 (class 0 OID 9474458)
-- Dependencies: 847
-- Data for Name: educacenso_orgao_regional; Type: TABLE DATA; Schema: modules; Owner: -
--

INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00015');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00016');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00017');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RO', '00018');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '0003A');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '0003B');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '0006A');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '0006B');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '0MI11');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '0MI12');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '0MI23');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '0MI24');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '0MI35');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '0MI36');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '0MI37');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '0MI38');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', '0MI39');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', 'MI310');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', 'MI411');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', 'MI412');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AM', 'MI413');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00015');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00016');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00017');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00018');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00019');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00020');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00021');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '00022');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01901');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01902');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01903');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01904');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01905');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01906');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01907');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01908');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01909');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01910');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01911');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01912');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01913');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01914');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01915');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01916');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01917');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01918');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01919');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PA', '01920');
INSERT INTO modules.educacenso_orgao_regional VALUES ('TO', '00000');
INSERT INTO modules.educacenso_orgao_regional VALUES ('TO', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('TO', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('TO', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('TO', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('TO', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('TO', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('TO', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('TO', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('TO', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('TO', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('TO', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('TO', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00015');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00016');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00017');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00018');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MA', '00019');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00015');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00016');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00017');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00018');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00019');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00020');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PI', '00021');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00015');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00016');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00017');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00018');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00019');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00020');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '00021');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '021R1');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '021R2');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '021R3');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '021R4');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '021R5');
INSERT INTO modules.educacenso_orgao_regional VALUES ('CE', '021R6');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RN', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RN', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RN', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RN', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RN', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RN', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RN', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RN', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RN', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RN', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RN', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RN', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RN', '00013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RN', '00014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RN', '00015');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RN', '00016');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PB', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PB', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PB', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PB', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PB', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PB', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PB', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PB', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PB', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PB', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PB', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PB', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PB', '00013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PB', '00014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PE', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PE', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PE', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PE', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PE', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PE', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PE', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PE', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PE', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PE', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PE', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PE', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PE', '00013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PE', '00014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PE', '00015');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PE', '00016');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AL', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AL', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AL', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AL', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AL', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AL', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AL', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AL', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AL', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AL', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AL', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AL', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AL', '00013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AL', '00014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('AL', '00015');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SE', '00000');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SE', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SE', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SE', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SE', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SE', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SE', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SE', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SE', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SE', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00015');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00016');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00017');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00018');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00019');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00020');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00021');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00022');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00023');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00024');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00025');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00026');
INSERT INTO modules.educacenso_orgao_regional VALUES ('BA', '00027');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00015');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00016');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00017');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00018');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00019');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00020');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00021');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00022');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00023');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00024');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00025');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00026');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00027');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00028');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00029');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00030');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00031');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00032');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00033');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00034');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00035');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00036');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00037');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00038');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00039');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00040');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00041');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00042');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00043');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00044');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00045');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00046');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MG', '00047');
INSERT INTO modules.educacenso_orgao_regional VALUES ('ES', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('ES', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('ES', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('ES', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('ES', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('ES', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('ES', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('ES', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('ES', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('ES', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('ES', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '00160');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '00170');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '00180');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '00190');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '00200');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '00210');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '00220');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '00230');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '00240');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '00250');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '0160P');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '0170P');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '0180P');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '0190P');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '0200P');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '0210P');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '0220P');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '0230P');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '0240P');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '0250P');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '11001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '11002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '11003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '11004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '11005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '11006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '11007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '11008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '11009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '11010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '11011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '11012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '11013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '11014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '11021');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '1115T');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '1116X');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '1117C');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '1118A');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '1120M');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '1121P');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '1122F');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RJ', '11999');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10101');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10102');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10104');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10205');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10207');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10208');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10210');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10211');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10312');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10314');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10316');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10317');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10318');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10401');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10402');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10403');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10501');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10502');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10503');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10601');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10602');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10603');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10606');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10701');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10702');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10703');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10704');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '10706');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '11000');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '15000');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '16000');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '17000');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '19902');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '19903');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '19908');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '19909');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '19910');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '19912');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '19918');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '19921');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '19923');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '19924');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '19925');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '19927');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '19928');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20102');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20103');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20202');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20204');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20205');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20206');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20207');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20208');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20301');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20302');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20303');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20304');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20305');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20306');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20307');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20308');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20310');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20311');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20313');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20401');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20403');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20404');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20407');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20408');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20409');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20410');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20411');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20413');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20415');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20417');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20419');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20501');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20502');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20504');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20506');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20507');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20509');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20510');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20511');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20512');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20601');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20602');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20604');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20701');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20702');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20703');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20704');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20710');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20711');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20801');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20802');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20803');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20804');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20901');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20904');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20908');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '20909');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '21001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '21003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '21004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '21006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '21101');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SP', '21102');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00015');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00016');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00017');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00018');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00019');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00020');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00021');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00022');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00023');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00024');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00025');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00026');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00027');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00028');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00029');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00030');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00031');
INSERT INTO modules.educacenso_orgao_regional VALUES ('PR', '00032');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00000');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00015');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00016');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00017');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00018');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00019');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00020');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00021');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00022');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00023');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00024');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00025');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00026');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00027');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00028');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00029');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00030');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00031');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00032');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00033');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00034');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '00035');
INSERT INTO modules.educacenso_orgao_regional VALUES ('SC', '10000');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00015');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00016');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00017');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00018');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00019');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00020');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00021');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00023');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00024');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00025');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00027');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00028');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00032');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00035');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00036');
INSERT INTO modules.educacenso_orgao_regional VALUES ('RS', '00039');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51015');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51016');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51017');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51018');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51019');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51020');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51021');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51022');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51023');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51024');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51025');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51026');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51027');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51028');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51029');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51030');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51031');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51032');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51033');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51034');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51035');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51036');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51037');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51038');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51039');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51040');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51041');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51042');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51043');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51044');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51045');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51046');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51047');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51048');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51049');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51050');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51051');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51052');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51053');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51054');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51055');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51056');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51057');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51058');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51059');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51060');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51061');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51062');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51063');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51064');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51065');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51066');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51067');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51068');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51069');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51070');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51071');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51072');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51073');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51074');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51075');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51076');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51077');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51078');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51079');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51080');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51081');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51082');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51083');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51084');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51085');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51086');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51087');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51088');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51089');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51090');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51091');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51092');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51093');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51094');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51095');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51096');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51097');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51098');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51099');
INSERT INTO modules.educacenso_orgao_regional VALUES ('MT', '51100');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00014');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00015');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00016');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00017');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00018');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00019');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00020');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00021');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00022');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00023');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00024');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00025');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00026');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00027');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00028');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00029');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00030');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00031');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00032');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00033');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00034');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00035');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00036');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00037');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00038');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00039');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00040');
INSERT INTO modules.educacenso_orgao_regional VALUES ('GO', '00041');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00001');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00002');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00003');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00004');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00005');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00006');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00007');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00008');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00009');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00010');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00011');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00012');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00013');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00015');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00017');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00018');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00019');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00098');
INSERT INTO modules.educacenso_orgao_regional VALUES ('DF', '00099');


--
-- TOC entry 7682 (class 0 OID 9443792)
-- Dependencies: 393
-- Data for Name: empresa_transporte_escolar; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8236 (class 0 OID 0)
-- Dependencies: 392
-- Name: empresa_transporte_escolar_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.empresa_transporte_escolar_seq', 1, false);


--
-- TOC entry 7683 (class 0 OID 9443796)
-- Dependencies: 394
-- Data for Name: etapas_curso_educacenso; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7684 (class 0 OID 9443799)
-- Dependencies: 395
-- Data for Name: etapas_educacenso; Type: TABLE DATA; Schema: modules; Owner: -
--

INSERT INTO modules.etapas_educacenso VALUES (1, 'Educação Infantil - Creche (0 a 3 anos)');
INSERT INTO modules.etapas_educacenso VALUES (2, 'Educação Infantil - Pré-escola (4 a 5 anos)');
INSERT INTO modules.etapas_educacenso VALUES (3, 'Ensino Fundamental 8 anos');
INSERT INTO modules.etapas_educacenso VALUES (4, 'Ensino Fundamental 9 anos');
INSERT INTO modules.etapas_educacenso VALUES (5, 'Ensino médio - Médio');
INSERT INTO modules.etapas_educacenso VALUES (6, 'Ensino médio - Integrado');
INSERT INTO modules.etapas_educacenso VALUES (7, 'Ensino médio - Normal/Magistério');
INSERT INTO modules.etapas_educacenso VALUES (8, 'Ensino médio - Educação profissional');
INSERT INTO modules.etapas_educacenso VALUES (9, 'EJA - Ensino fundamental');
INSERT INTO modules.etapas_educacenso VALUES (10, 'EJA - Ensino médio');
INSERT INTO modules.etapas_educacenso VALUES (11, 'EJA - Ensino fundamental - Projovem (urbano)');


--
-- TOC entry 7685 (class 0 OID 9443802)
-- Dependencies: 396
-- Data for Name: falta_aluno; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8237 (class 0 OID 0)
-- Dependencies: 397
-- Name: falta_aluno_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.falta_aluno_id_seq', 2, true);


--
-- TOC entry 7687 (class 0 OID 9443807)
-- Dependencies: 398
-- Data for Name: falta_componente_curricular; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8238 (class 0 OID 0)
-- Dependencies: 399
-- Name: falta_componente_curricular_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.falta_componente_curricular_id_seq', 1, true);


--
-- TOC entry 7689 (class 0 OID 9443813)
-- Dependencies: 400
-- Data for Name: falta_geral; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8239 (class 0 OID 0)
-- Dependencies: 401
-- Name: falta_geral_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.falta_geral_id_seq', 1, false);


--
-- TOC entry 7691 (class 0 OID 9443819)
-- Dependencies: 402
-- Data for Name: ficha_medica_aluno; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7692 (class 0 OID 9443825)
-- Dependencies: 403
-- Data for Name: formula_media; Type: TABLE DATA; Schema: modules; Owner: -
--

INSERT INTO modules.formula_media VALUES (1, 1, 'Média aritmética', 'Se / Et', 1, 0);
INSERT INTO modules.formula_media VALUES (2, 1, 'Média recuperação ponderada', '(Rc * 0.4) + (Se / Et * 0.6)', 2, 0);


--
-- TOC entry 8240 (class 0 OID 0)
-- Dependencies: 404
-- Name: formula_media_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.formula_media_id_seq', 2, true);


--
-- TOC entry 7695 (class 0 OID 9443834)
-- Dependencies: 406
-- Data for Name: itinerario_transporte_escolar; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8241 (class 0 OID 0)
-- Dependencies: 405
-- Name: itinerario_transporte_escolar_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.itinerario_transporte_escolar_seq', 1, false);


--
-- TOC entry 7696 (class 0 OID 9443838)
-- Dependencies: 407
-- Data for Name: lingua_indigena_educacenso; Type: TABLE DATA; Schema: modules; Owner: -
--

INSERT INTO modules.lingua_indigena_educacenso VALUES (30, 'Boróro');
INSERT INTO modules.lingua_indigena_educacenso VALUES (244, 'Umutína');
INSERT INTO modules.lingua_indigena_educacenso VALUES (42, 'Guató');
INSERT INTO modules.lingua_indigena_educacenso VALUES (12, 'Apinayé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (251, 'Canela');
INSERT INTO modules.lingua_indigena_educacenso VALUES (252, 'Kanéla Apaniekra/Canela Apaniekrã');
INSERT INTO modules.lingua_indigena_educacenso VALUES (205, 'Kanéla Rankocamekra/ Canela Ramkokamekrã');
INSERT INTO modules.lingua_indigena_educacenso VALUES (253, 'Gavião Krikatêjê/ Gavião Krinkatejé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (254, 'Gavião Parkatêjê/ Guató Parakatejé/ Gavião do Pará');
INSERT INTO modules.lingua_indigena_educacenso VALUES (240, 'Gavião Pukobiyé/ Gavião Pukobié');
INSERT INTO modules.lingua_indigena_educacenso VALUES (255, 'Krahô/ Crao, Kraô');
INSERT INTO modules.lingua_indigena_educacenso VALUES (256, 'Krao Kanela');
INSERT INTO modules.lingua_indigena_educacenso VALUES (223, 'Kreje/ Krenjé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (224, 'Krikatí/ Krinkatí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (257, 'Kokuiregatêjê/ Kokuiregatejje');
INSERT INTO modules.lingua_indigena_educacenso VALUES (258, 'Timbira');
INSERT INTO modules.lingua_indigena_educacenso VALUES (235, 'Kaingáng');
INSERT INTO modules.lingua_indigena_educacenso VALUES (221, 'Mebengokré (Kayapó)');
INSERT INTO modules.lingua_indigena_educacenso VALUES (86, 'Mentuktíre, Txukahamae (Kayapó)');
INSERT INTO modules.lingua_indigena_educacenso VALUES (220, 'Kayapó');
INSERT INTO modules.lingua_indigena_educacenso VALUES (81, 'Gorotire (Kayapó)');
INSERT INTO modules.lingua_indigena_educacenso VALUES (82, 'Kararaô (Kayapó)');
INSERT INTO modules.lingua_indigena_educacenso VALUES (83, 'Kokraimoro (Kayapó)');
INSERT INTO modules.lingua_indigena_educacenso VALUES (84, 'Kubenkrngkegn (Kayapó)');
INSERT INTO modules.lingua_indigena_educacenso VALUES (85, 'Menkrangnoti (Kayapó)');
INSERT INTO modules.lingua_indigena_educacenso VALUES (87, 'Xikrin (Kayapó)');
INSERT INTO modules.lingua_indigena_educacenso VALUES (132, 'Panará, Krenakarôre/ Kren-akarôre');
INSERT INTO modules.lingua_indigena_educacenso VALUES (150, 'Suyá, Kisêdjê/ Kisedjê');
INSERT INTO modules.lingua_indigena_educacenso VALUES (241, 'Tapayúna');
INSERT INTO modules.lingua_indigena_educacenso VALUES (259, 'Xacriabá/ Xakriabá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (5, 'Xavánte/ Xavante');
INSERT INTO modules.lingua_indigena_educacenso VALUES (6, 'Xerénte');
INSERT INTO modules.lingua_indigena_educacenso VALUES (188, 'Xokléng');
INSERT INTO modules.lingua_indigena_educacenso VALUES (260, 'Jê (não específico)');
INSERT INTO modules.lingua_indigena_educacenso VALUES (63, 'Karajá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (50, 'Javaé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (185, 'Xambioá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (92, 'Krenák');
INSERT INTO modules.lingua_indigena_educacenso VALUES (107, 'Maxakalí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (261, 'Pataxó');
INSERT INTO modules.lingua_indigena_educacenso VALUES (262, 'Pataxó Hã Hã Hãe/ Pataxó Há-Há-Há');
INSERT INTO modules.lingua_indigena_educacenso VALUES (129, 'Ofayé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (142, 'Canoeiros/ Rikbaktsá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (192, 'Fulni-ô/ Yathê');
INSERT INTO modules.lingua_indigena_educacenso VALUES (65, 'Karitiána');
INSERT INTO modules.lingua_indigena_educacenso VALUES (23, 'Awetí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (51, 'Jurúna/ Yudjá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (187, 'Xipáya');
INSERT INTO modules.lingua_indigena_educacenso VALUES (106, 'Mawé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (200, 'Arara do Aripuana/ Arara do Aripuanã');
INSERT INTO modules.lingua_indigena_educacenso VALUES (19, 'Aruá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (31, 'Cinta Larga/ Cinta-Larga');
INSERT INTO modules.lingua_indigena_educacenso VALUES (36, 'Gavião (Ikõro, Digüt), Gavião de Rondônia/ Ikolen');
INSERT INTO modules.lingua_indigena_educacenso VALUES (197, 'Zoró');
INSERT INTO modules.lingua_indigena_educacenso VALUES (263, 'Salamãy');
INSERT INTO modules.lingua_indigena_educacenso VALUES (236, 'Suruí de Rondônia');
INSERT INTO modules.lingua_indigena_educacenso VALUES (111, 'Mondé, Tupí-Mondé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (112, 'Mundurukú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (96, 'Kuruáya');
INSERT INTO modules.lingua_indigena_educacenso VALUES (141, 'Puruborá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (66, 'Arara de Rondônia/ Káro');
INSERT INTO modules.lingua_indigena_educacenso VALUES (264, 'Ramaráma');
INSERT INTO modules.lingua_indigena_educacenso VALUES (265, 'Urucú/ Urucu');
INSERT INTO modules.lingua_indigena_educacenso VALUES (198, 'Akuntsú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (99, 'Makuráp');
INSERT INTO modules.lingua_indigena_educacenso VALUES (110, 'Sakurabiat/ Kampé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (171, 'Tuparí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (2, 'Ajuru/ Wayoro, Ajurú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (7, 'Amanayé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (11, 'Apiaká');
INSERT INTO modules.lingua_indigena_educacenso VALUES (17, 'Araweté');
INSERT INTO modules.lingua_indigena_educacenso VALUES (20, 'Asuriní do Tocantins');
INSERT INTO modules.lingua_indigena_educacenso VALUES (237, 'Parakanã');
INSERT INTO modules.lingua_indigena_educacenso VALUES (4, 'Suruí do Pará/ Suruí do Tocantins/ Aikewara');
INSERT INTO modules.lingua_indigena_educacenso VALUES (21, 'Asuriní do Xingu');
INSERT INTO modules.lingua_indigena_educacenso VALUES (22, 'Ava-Canoeiro/ Avá-Canoeiro, Avá, Canoeiro');
INSERT INTO modules.lingua_indigena_educacenso VALUES (37, 'Guajá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (266, 'Guaraní');
INSERT INTO modules.lingua_indigena_educacenso VALUES (38, 'Guaraní Kaiowá/ Guarani Kayová');
INSERT INTO modules.lingua_indigena_educacenso VALUES (39, 'Guaraní Mbyá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (40, 'Guaraní Nhandéva');
INSERT INTO modules.lingua_indigena_educacenso VALUES (52, 'Kaapor/ Urubu, Kaapór');
INSERT INTO modules.lingua_indigena_educacenso VALUES (267, 'Lingua De Sinais Kaapor/ Língua de Sinais Urubu-Kaapór');
INSERT INTO modules.lingua_indigena_educacenso VALUES (59, 'Kamayurá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (199, 'Amondáwa');
INSERT INTO modules.lingua_indigena_educacenso VALUES (208, 'Diahói/ Diahui');
INSERT INTO modules.lingua_indigena_educacenso VALUES (215, 'Júma/ Juma');
INSERT INTO modules.lingua_indigena_educacenso VALUES (219, 'Karipúna');
INSERT INTO modules.lingua_indigena_educacenso VALUES (268, 'Kawahíb');
INSERT INTO modules.lingua_indigena_educacenso VALUES (238, 'Parintintín');
INSERT INTO modules.lingua_indigena_educacenso VALUES (243, 'Tenharím/ Tenharim');
INSERT INTO modules.lingua_indigena_educacenso VALUES (76, 'Uru-Eu-Wau-Wau/ Uruewawau');
INSERT INTO modules.lingua_indigena_educacenso VALUES (80, 'Kayabí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (90, 'Kokáma');
INSERT INTO modules.lingua_indigena_educacenso VALUES (204, 'Kambéba');
INSERT INTO modules.lingua_indigena_educacenso VALUES (126, 'Lingua Geral Amazônica, Nheengatu');
INSERT INTO modules.lingua_indigena_educacenso VALUES (151, 'Tapirapé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (211, 'Guajajára');
INSERT INTO modules.lingua_indigena_educacenso VALUES (155, 'Tembé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (269, 'Turiwára');
INSERT INTO modules.lingua_indigena_educacenso VALUES (183, 'Wayampí/ Oyampi');
INSERT INTO modules.lingua_indigena_educacenso VALUES (186, 'Xetá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (196, 'Zoé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (270, 'Tupí-Guaraní');
INSERT INTO modules.lingua_indigena_educacenso VALUES (250, 'Tupí, Tupi Antigo');
INSERT INTO modules.lingua_indigena_educacenso VALUES (13, 'Apurinã');
INSERT INTO modules.lingua_indigena_educacenso VALUES (60, 'Ashanínka/ Axanínka');
INSERT INTO modules.lingua_indigena_educacenso VALUES (26, 'Baníwa/ Tapiira Tapuya, Kawa Tapuya');
INSERT INTO modules.lingua_indigena_educacenso VALUES (226, 'Kuripáko');
INSERT INTO modules.lingua_indigena_educacenso VALUES (29, 'Baré');
INSERT INTO modules.lingua_indigena_educacenso VALUES (145, 'Enawenê-Nawê');
INSERT INTO modules.lingua_indigena_educacenso VALUES (271, 'Kaixána/ Kayuisiana');
INSERT INTO modules.lingua_indigena_educacenso VALUES (222, 'Kinikináu, Kinikinawa');
INSERT INTO modules.lingua_indigena_educacenso VALUES (272, 'Machinéri');
INSERT INTO modules.lingua_indigena_educacenso VALUES (273, 'Mawayána');
INSERT INTO modules.lingua_indigena_educacenso VALUES (109, 'Mehináku');
INSERT INTO modules.lingua_indigena_educacenso VALUES (131, 'Palikúr');
INSERT INTO modules.lingua_indigena_educacenso VALUES (133, 'Paresí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (152, 'Tariána');
INSERT INTO modules.lingua_indigena_educacenso VALUES (156, 'Teréna');
INSERT INTO modules.lingua_indigena_educacenso VALUES (179, 'Wapixána');
INSERT INTO modules.lingua_indigena_educacenso VALUES (180, 'Warekéna');
INSERT INTO modules.lingua_indigena_educacenso VALUES (182, 'Wauja/ Waurá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (193, 'Yawalapití');
INSERT INTO modules.lingua_indigena_educacenso VALUES (274, 'Aruák');
INSERT INTO modules.lingua_indigena_educacenso VALUES (10, 'Apalaí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (201, 'Arara do Pará, Arara do Xingu');
INSERT INTO modules.lingua_indigena_educacenso VALUES (24, 'Bakairí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (35, 'Galibí do Oiapoque, Galibí (Karíña)');
INSERT INTO modules.lingua_indigena_educacenso VALUES (43, 'Hixkaryána');
INSERT INTO modules.lingua_indigena_educacenso VALUES (173, 'Ikpeng/ Ikpéng');
INSERT INTO modules.lingua_indigena_educacenso VALUES (45, 'Ingarikó');
INSERT INTO modules.lingua_indigena_educacenso VALUES (58, 'Kalapálo');
INSERT INTO modules.lingua_indigena_educacenso VALUES (94, 'Kuikúro');
INSERT INTO modules.lingua_indigena_educacenso VALUES (103, 'Matipú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (116, 'Nahukwá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (275, 'Naravúte');
INSERT INTO modules.lingua_indigena_educacenso VALUES (276, 'Kaxuyána/ Kahyána, Warikyána');
INSERT INTO modules.lingua_indigena_educacenso VALUES (277, 'Xikuyána/ Sikiyána');
INSERT INTO modules.lingua_indigena_educacenso VALUES (100, 'Makuxí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (218, 'Kapon Patamóna/ Kapon Ptamóna');
INSERT INTO modules.lingua_indigena_educacenso VALUES (153, 'Taulipáng');
INSERT INTO modules.lingua_indigena_educacenso VALUES (167, 'Tiriyó/ Tarona');
INSERT INTO modules.lingua_indigena_educacenso VALUES (177, 'Wái Wái/ Waiwái');
INSERT INTO modules.lingua_indigena_educacenso VALUES (176, 'Waimirí-Atroarí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (184, 'Wayána');
INSERT INTO modules.lingua_indigena_educacenso VALUES (108, 'Yekuána, Mayongong, Makiritáre,');
INSERT INTO modules.lingua_indigena_educacenso VALUES (278, 'Karib');
INSERT INTO modules.lingua_indigena_educacenso VALUES (15, 'Arara do Acre, Shawãdawa');
INSERT INTO modules.lingua_indigena_educacenso VALUES (68, 'Katukína do Acre');
INSERT INTO modules.lingua_indigena_educacenso VALUES (77, 'Kaxararí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (78, 'Kaxinawá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (91, 'Korúbo');
INSERT INTO modules.lingua_indigena_educacenso VALUES (279, 'Kulína Páno');
INSERT INTO modules.lingua_indigena_educacenso VALUES (102, 'Marúbo');
INSERT INTO modules.lingua_indigena_educacenso VALUES (104, 'Matís');
INSERT INTO modules.lingua_indigena_educacenso VALUES (105, 'Matsés');
INSERT INTO modules.lingua_indigena_educacenso VALUES (389, 'Maya');
INSERT INTO modules.lingua_indigena_educacenso VALUES (128, 'Nukiní');
INSERT INTO modules.lingua_indigena_educacenso VALUES (140, 'Poyanáwa');
INSERT INTO modules.lingua_indigena_educacenso VALUES (246, 'Shanenáwa/ Xanenáwa, Xawanawa');
INSERT INTO modules.lingua_indigena_educacenso VALUES (49, 'Yamináwa');
INSERT INTO modules.lingua_indigena_educacenso VALUES (194, 'Yawanawá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (280, 'Pano');
INSERT INTO modules.lingua_indigena_educacenso VALUES (14, 'Arapáso');
INSERT INTO modules.lingua_indigena_educacenso VALUES (28, 'Bará');
INSERT INTO modules.lingua_indigena_educacenso VALUES (203, 'Barasána');
INSERT INTO modules.lingua_indigena_educacenso VALUES (33, 'Desána');
INSERT INTO modules.lingua_indigena_educacenso VALUES (64, 'Karapanã');
INSERT INTO modules.lingua_indigena_educacenso VALUES (178, 'Wanána/ Guanána');
INSERT INTO modules.lingua_indigena_educacenso VALUES (93, 'Kubéo, Kubewa');
INSERT INTO modules.lingua_indigena_educacenso VALUES (281, 'Makúna, Yebá-masã');
INSERT INTO modules.lingua_indigena_educacenso VALUES (282, 'Siriáno/ Suriana, Suriána');
INSERT INTO modules.lingua_indigena_educacenso VALUES (234, 'Tukáno / Miriti-Tapuia');
INSERT INTO modules.lingua_indigena_educacenso VALUES (172, 'Tuyúca / Tuyuca');
INSERT INTO modules.lingua_indigena_educacenso VALUES (216, 'Yurutí, Juriti');
INSERT INTO modules.lingua_indigena_educacenso VALUES (138, 'Piratapúya');
INSERT INTO modules.lingua_indigena_educacenso VALUES (283, 'Arawá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (25, 'Banawá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (32, 'Dení');
INSERT INTO modules.lingua_indigena_educacenso VALUES (284, 'Himarimã/ Hi-merimã, Mirimã, Himarimá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (285, 'Jamamadí-Kanamanti/ Jamamadí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (48, 'Jarawára');
INSERT INTO modules.lingua_indigena_educacenso VALUES (95, 'Kulína Madijá/ Kulina, Kulína Madihá (Madija)');
INSERT INTO modules.lingua_indigena_educacenso VALUES (136, 'Paumarí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (148, 'Zuruwahá, Suruahá (Zuruahá)');
INSERT INTO modules.lingua_indigena_educacenso VALUES (61, 'Kanamarí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (69, 'Katukína');
INSERT INTO modules.lingua_indigena_educacenso VALUES (174, 'Tsohom Djapa/ Tsohondjapá (Tsohom Djapa)');
INSERT INTO modules.lingua_indigena_educacenso VALUES (67, 'Katawixí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (34, 'Dâw');
INSERT INTO modules.lingua_indigena_educacenso VALUES (286, 'Hup, Húpda, Maku, Yuhupde, Yuhúp');
INSERT INTO modules.lingua_indigena_educacenso VALUES (115, 'Nadëb');
INSERT INTO modules.lingua_indigena_educacenso VALUES (287, 'Alaketesú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (288, 'Alantesú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (289, 'Hahaintesú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (290, 'Halotesú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (291, 'Kithaulú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (231, 'Mandúka/ Nambikwára do Campo');
INSERT INTO modules.lingua_indigena_educacenso VALUES (292, 'Sararé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (300, 'Sawentesú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (301, 'Waikisú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (302, 'Wakalitesú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (303, 'Wasusú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (228, 'Lakondê');
INSERT INTO modules.lingua_indigena_educacenso VALUES (229, 'Latundê');
INSERT INTO modules.lingua_indigena_educacenso VALUES (120, 'Negarotê/ Negarote');
INSERT INTO modules.lingua_indigena_educacenso VALUES (230, 'Mamaindê');
INSERT INTO modules.lingua_indigena_educacenso VALUES (242, 'Tawandê');
INSERT INTO modules.lingua_indigena_educacenso VALUES (143, 'Sabanê');
INSERT INTO modules.lingua_indigena_educacenso VALUES (304, 'Nambikwára');
INSERT INTO modules.lingua_indigena_educacenso VALUES (225, 'Kujubím');
INSERT INTO modules.lingua_indigena_educacenso VALUES (305, 'Miguelénho/ Migueleno, Miguelenho');
INSERT INTO modules.lingua_indigena_educacenso VALUES (130, 'Oro Win');
INSERT INTO modules.lingua_indigena_educacenso VALUES (168, 'Torá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (175, 'Urupá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (245, 'Pakaá Nóva/Migueleno, Miguelenho');
INSERT INTO modules.lingua_indigena_educacenso VALUES (306, 'Txapakúra');
INSERT INTO modules.lingua_indigena_educacenso VALUES (127, 'Ninám');
INSERT INTO modules.lingua_indigena_educacenso VALUES (146, 'Sanumá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (190, 'Yanomám/ Yanonmán');
INSERT INTO modules.lingua_indigena_educacenso VALUES (191, 'Yanomámi');
INSERT INTO modules.lingua_indigena_educacenso VALUES (307, 'Bóra');
INSERT INTO modules.lingua_indigena_educacenso VALUES (233, 'Miránha');
INSERT INTO modules.lingua_indigena_educacenso VALUES (53, 'Kadiwéu');
INSERT INTO modules.lingua_indigena_educacenso VALUES (308, 'Guaikurú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (113, 'Múra');
INSERT INTO modules.lingua_indigena_educacenso VALUES (137, 'Pirahã');
INSERT INTO modules.lingua_indigena_educacenso VALUES (206, 'Chamakóko/ Samúko, Chamacoco');
INSERT INTO modules.lingua_indigena_educacenso VALUES (207, 'Chiquitáno/ Chiquito');
INSERT INTO modules.lingua_indigena_educacenso VALUES (18, 'Arikapú/ Jabutí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (47, 'Djeoromitxí/ Jabotí/ Jabutí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (309, 'Witóto');
INSERT INTO modules.lingua_indigena_educacenso VALUES (1, 'Aikaná/ Aikanã');
INSERT INTO modules.lingua_indigena_educacenso VALUES (46, 'Irántxe');
INSERT INTO modules.lingua_indigena_educacenso VALUES (114, 'Mynky/ Mynký, Meky, Menky, Menki');
INSERT INTO modules.lingua_indigena_educacenso VALUES (227, 'Kwazá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (62, 'Kanoé/ Kanoê');
INSERT INTO modules.lingua_indigena_educacenso VALUES (157, 'Tikúna');
INSERT INTO modules.lingua_indigena_educacenso VALUES (169, 'Trumái');
INSERT INTO modules.lingua_indigena_educacenso VALUES (135, 'Galibí Marwórno/ Galibi Marworno');
INSERT INTO modules.lingua_indigena_educacenso VALUES (134, 'Karipúna do Amapá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (310, 'Acona/ Akona');
INSERT INTO modules.lingua_indigena_educacenso VALUES (311, 'Aimoré');
INSERT INTO modules.lingua_indigena_educacenso VALUES (312, 'Anacé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (313, 'Apolima - Arara');
INSERT INTO modules.lingua_indigena_educacenso VALUES (314, 'Arana');
INSERT INTO modules.lingua_indigena_educacenso VALUES (315, 'Arapiun');
INSERT INTO modules.lingua_indigena_educacenso VALUES (316, 'Arikén');
INSERT INTO modules.lingua_indigena_educacenso VALUES (317, 'Arikose');
INSERT INTO modules.lingua_indigena_educacenso VALUES (318, 'Atikum');
INSERT INTO modules.lingua_indigena_educacenso VALUES (319, 'Awi');
INSERT INTO modules.lingua_indigena_educacenso VALUES (320, 'Baenã');
INSERT INTO modules.lingua_indigena_educacenso VALUES (321, 'Borari');
INSERT INTO modules.lingua_indigena_educacenso VALUES (322, 'Botocudo');
INSERT INTO modules.lingua_indigena_educacenso VALUES (323, 'Catokin (Katukína)');
INSERT INTO modules.lingua_indigena_educacenso VALUES (324, 'Charrúa/ Charrua');
INSERT INTO modules.lingua_indigena_educacenso VALUES (325, 'Coiupanka');
INSERT INTO modules.lingua_indigena_educacenso VALUES (326, 'Guara');
INSERT INTO modules.lingua_indigena_educacenso VALUES (327, 'Guarino');
INSERT INTO modules.lingua_indigena_educacenso VALUES (328, 'Guaru');
INSERT INTO modules.lingua_indigena_educacenso VALUES (329, 'Isse');
INSERT INTO modules.lingua_indigena_educacenso VALUES (330, 'Jaricuna');
INSERT INTO modules.lingua_indigena_educacenso VALUES (331, 'Jeripancó/ Jeripankó');
INSERT INTO modules.lingua_indigena_educacenso VALUES (332, 'Kaete');
INSERT INTO modules.lingua_indigena_educacenso VALUES (333, 'Kaimbé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (334, 'Kalabassa');
INSERT INTO modules.lingua_indigena_educacenso VALUES (335, 'Kalankó');
INSERT INTO modules.lingua_indigena_educacenso VALUES (336, 'Kamba/ Kámba');
INSERT INTO modules.lingua_indigena_educacenso VALUES (337, 'Kambiwá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (338, 'Kambiwá Pipipã');
INSERT INTO modules.lingua_indigena_educacenso VALUES (339, 'Kanindé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (340, 'Kantaruré');
INSERT INTO modules.lingua_indigena_educacenso VALUES (341, 'Kapinawá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (342, 'Karapoto/ Karapotó');
INSERT INTO modules.lingua_indigena_educacenso VALUES (343, 'Karijo');
INSERT INTO modules.lingua_indigena_educacenso VALUES (344, 'Kariri/ Karirí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (345, 'Kariri - Xocó/ Karirí-Xocó');
INSERT INTO modules.lingua_indigena_educacenso VALUES (346, 'Kaxixó');
INSERT INTO modules.lingua_indigena_educacenso VALUES (347, 'Kayuisiana -(Kaixána)');
INSERT INTO modules.lingua_indigena_educacenso VALUES (348, 'Kiriri');
INSERT INTO modules.lingua_indigena_educacenso VALUES (349, 'Kueskue');
INSERT INTO modules.lingua_indigena_educacenso VALUES (350, 'Manao/ Manáo');
INSERT INTO modules.lingua_indigena_educacenso VALUES (351, 'Maragua');
INSERT INTO modules.lingua_indigena_educacenso VALUES (352, 'Maytapu');
INSERT INTO modules.lingua_indigena_educacenso VALUES (353, 'Mucurim');
INSERT INTO modules.lingua_indigena_educacenso VALUES (354, 'Nawa/ Náwa');
INSERT INTO modules.lingua_indigena_educacenso VALUES (355, 'Paiaku');
INSERT INTO modules.lingua_indigena_educacenso VALUES (356, 'Pankará');
INSERT INTO modules.lingua_indigena_educacenso VALUES (357, 'Pankararé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (358, 'Pankararú/ Pankarú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (359, 'Pankararú - Kalanko');
INSERT INTO modules.lingua_indigena_educacenso VALUES (360, 'Pankararú - Karuazu');
INSERT INTO modules.lingua_indigena_educacenso VALUES (361, 'Pankaru');
INSERT INTO modules.lingua_indigena_educacenso VALUES (362, 'Patxôhã/ Patxoha');
INSERT INTO modules.lingua_indigena_educacenso VALUES (363, 'Paumelenho');
INSERT INTO modules.lingua_indigena_educacenso VALUES (364, 'Piri-Piri/ Pirí-Pirí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (365, 'Pitaguari/ Pitaguarí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (366, 'Potiguara/ Potiguára');
INSERT INTO modules.lingua_indigena_educacenso VALUES (367, 'Puri/ Purí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (368, 'Sapará/ Sapara');
INSERT INTO modules.lingua_indigena_educacenso VALUES (369, 'Tabajara');
INSERT INTO modules.lingua_indigena_educacenso VALUES (370, 'Tapajós');
INSERT INTO modules.lingua_indigena_educacenso VALUES (371, 'Tapeba');
INSERT INTO modules.lingua_indigena_educacenso VALUES (372, 'Tapiuns/ Tapiun');
INSERT INTO modules.lingua_indigena_educacenso VALUES (373, 'Tapuía/ Tapúya');
INSERT INTO modules.lingua_indigena_educacenso VALUES (374, 'Tingui Botó/ Tinguí-Botó');
INSERT INTO modules.lingua_indigena_educacenso VALUES (375, 'Tremembé');
INSERT INTO modules.lingua_indigena_educacenso VALUES (376, 'Truká');
INSERT INTO modules.lingua_indigena_educacenso VALUES (377, 'Tumbalalá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (378, 'Tupinambá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (379, 'Tupinambaraná');
INSERT INTO modules.lingua_indigena_educacenso VALUES (380, 'Tupiniquim');
INSERT INTO modules.lingua_indigena_educacenso VALUES (381, 'Tuxá');
INSERT INTO modules.lingua_indigena_educacenso VALUES (382, 'Waira');
INSERT INTO modules.lingua_indigena_educacenso VALUES (383, 'Waiána-Apalaí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (384, 'Wajuju/ Wajujú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (385, 'Wassú (Wasusú)');
INSERT INTO modules.lingua_indigena_educacenso VALUES (386, 'Xocó');
INSERT INTO modules.lingua_indigena_educacenso VALUES (387, 'Xucuru/ Xukurú');
INSERT INTO modules.lingua_indigena_educacenso VALUES (388, 'Xucuru - Kariri/ Xukurú-Karirí');
INSERT INTO modules.lingua_indigena_educacenso VALUES (999, 'Outras Linguas Indigenas');


--
-- TOC entry 7697 (class 0 OID 9443841)
-- Dependencies: 408
-- Data for Name: media_geral; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7698 (class 0 OID 9443846)
-- Dependencies: 409
-- Data for Name: moradia_aluno; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7700 (class 0 OID 9443852)
-- Dependencies: 411
-- Data for Name: motorista; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8242 (class 0 OID 0)
-- Dependencies: 410
-- Name: motorista_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.motorista_seq', 1, false);


--
-- TOC entry 7701 (class 0 OID 9443856)
-- Dependencies: 412
-- Data for Name: nota_aluno; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8243 (class 0 OID 0)
-- Dependencies: 413
-- Name: nota_aluno_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.nota_aluno_id_seq', 2, true);


--
-- TOC entry 7703 (class 0 OID 9443861)
-- Dependencies: 414
-- Data for Name: nota_componente_curricular; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8244 (class 0 OID 0)
-- Dependencies: 415
-- Name: nota_componente_curricular_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.nota_componente_curricular_id_seq', 1, true);


--
-- TOC entry 7705 (class 0 OID 9443868)
-- Dependencies: 416
-- Data for Name: nota_componente_curricular_media; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7706 (class 0 OID 9443873)
-- Dependencies: 417
-- Data for Name: nota_exame; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7708 (class 0 OID 9443878)
-- Dependencies: 419
-- Data for Name: nota_geral; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8245 (class 0 OID 0)
-- Dependencies: 418
-- Name: nota_geral_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.nota_geral_id_seq', 958638, false);


--
-- TOC entry 7709 (class 0 OID 9443884)
-- Dependencies: 420
-- Data for Name: parecer_aluno; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8246 (class 0 OID 0)
-- Dependencies: 421
-- Name: parecer_aluno_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.parecer_aluno_id_seq', 1, false);


--
-- TOC entry 7711 (class 0 OID 9443889)
-- Dependencies: 422
-- Data for Name: parecer_componente_curricular; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8247 (class 0 OID 0)
-- Dependencies: 423
-- Name: parecer_componente_curricular_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.parecer_componente_curricular_id_seq', 1, false);


--
-- TOC entry 7713 (class 0 OID 9443897)
-- Dependencies: 424
-- Data for Name: parecer_geral; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8248 (class 0 OID 0)
-- Dependencies: 425
-- Name: parecer_geral_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.parecer_geral_id_seq', 1, false);


--
-- TOC entry 7716 (class 0 OID 9443907)
-- Dependencies: 427
-- Data for Name: pessoa_transporte; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8249 (class 0 OID 0)
-- Dependencies: 426
-- Name: pessoa_transporte_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.pessoa_transporte_seq', 1, false);


--
-- TOC entry 7718 (class 0 OID 9443916)
-- Dependencies: 429
-- Data for Name: ponto_transporte_escolar; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8250 (class 0 OID 0)
-- Dependencies: 428
-- Name: ponto_transporte_escolar_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.ponto_transporte_escolar_seq', 1, false);


--
-- TOC entry 7720 (class 0 OID 9443922)
-- Dependencies: 431
-- Data for Name: professor_turma; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7721 (class 0 OID 9443927)
-- Dependencies: 432
-- Data for Name: professor_turma_disciplina; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8251 (class 0 OID 0)
-- Dependencies: 430
-- Name: professor_turma_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.professor_turma_id_seq', 1, false);


--
-- TOC entry 7722 (class 0 OID 9443930)
-- Dependencies: 433
-- Data for Name: regra_avaliacao; Type: TABLE DATA; Schema: modules; Owner: -
--

INSERT INTO modules.regra_avaliacao VALUES (1, 1, 1, 2, 1, 'Regra de avaliação quantitativa', 1, 2, 6.000, 75.000, 0, 2, 6.000, 0, NULL, 10, 10, 2, 0, 0, 0, 0, 0, 0, 0, NULL, NULL);
INSERT INTO modules.regra_avaliacao VALUES (2, 1, 1, NULL, 2, 'Regra de avaliação qualitativa', 2, 1, 6.000, 80.000, 0, 2, 6.000, 0, NULL, 10, 10, 5, 0, 0, 0, 0, 0, 0, 0, NULL, NULL);


--
-- TOC entry 8252 (class 0 OID 0)
-- Dependencies: 434
-- Name: regra_avaliacao_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.regra_avaliacao_id_seq', 2, true);


--
-- TOC entry 7725 (class 0 OID 9443952)
-- Dependencies: 436
-- Data for Name: regra_avaliacao_recuperacao; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8253 (class 0 OID 0)
-- Dependencies: 435
-- Name: regra_avaliacao_recuperacao_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.regra_avaliacao_recuperacao_id_seq', 1, false);


--
-- TOC entry 8135 (class 0 OID 9474570)
-- Dependencies: 849
-- Data for Name: regra_avaliacao_serie_ano; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7727 (class 0 OID 9443958)
-- Dependencies: 438
-- Data for Name: rota_transporte_escolar; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8254 (class 0 OID 0)
-- Dependencies: 437
-- Name: rota_transporte_escolar_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.rota_transporte_escolar_seq', 1, false);


--
-- TOC entry 7728 (class 0 OID 9443962)
-- Dependencies: 439
-- Data for Name: tabela_arredondamento; Type: TABLE DATA; Schema: modules; Owner: -
--

INSERT INTO modules.tabela_arredondamento VALUES (1, 1, 'Tabela padrão de notas numéricas', 1);
INSERT INTO modules.tabela_arredondamento VALUES (2, 1, 'Tabela padrão de notas conceituais', 2);


--
-- TOC entry 8255 (class 0 OID 0)
-- Dependencies: 440
-- Name: tabela_arredondamento_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.tabela_arredondamento_id_seq', 2, true);


--
-- TOC entry 7730 (class 0 OID 9443968)
-- Dependencies: 441
-- Data for Name: tabela_arredondamento_valor; Type: TABLE DATA; Schema: modules; Owner: -
--

INSERT INTO modules.tabela_arredondamento_valor VALUES (22, 2, 'E', 'Insuficiente', 0.000, 1.900, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (23, 2, 'D', 'Irregular', 2.000, 4.900, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (24, 2, 'C', 'Bom', 5.000, 6.900, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (25, 2, 'B', 'Muito bom', 7.000, 8.900, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (26, 2, 'A', 'Excelente', 9.000, 10.000, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (1, 1, '0', NULL, 0.000, 0.400, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (2, 1, '0.5', NULL, 0.500, 0.900, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (3, 1, '1', NULL, 1.000, 1.400, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (4, 1, '1.5', NULL, 1.500, 1.900, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (5, 1, '2', NULL, 2.000, 2.400, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (6, 1, '2.5', NULL, 2.500, 2.900, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (7, 1, '3', NULL, 3.000, 3.400, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (8, 1, '3.5', NULL, 3.500, 3.900, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (9, 1, '4', NULL, 4.000, 4.000, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (10, 1, '4.5', NULL, 4.500, 4.900, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (11, 1, '5', NULL, 5.000, 5.400, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (12, 1, '5.5', NULL, 5.500, 5.900, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (13, 1, '6', NULL, 6.000, 6.400, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (14, 1, '6.5', NULL, 6.500, 6.900, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (15, 1, '7', NULL, 7.000, 7.400, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (16, 1, '7.5', NULL, 7.500, 7.900, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (17, 1, '8', NULL, 8.000, 8.400, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (18, 1, '8.5', NULL, 8.500, 8.900, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (19, 1, '9', NULL, 9.000, 9.400, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (20, 1, '9.5', NULL, 9.500, 9.900, NULL, NULL);
INSERT INTO modules.tabela_arredondamento_valor VALUES (21, 1, '10', NULL, 9.900, 10.000, NULL, NULL);


--
-- TOC entry 8256 (class 0 OID 0)
-- Dependencies: 442
-- Name: tabela_arredondamento_valor_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.tabela_arredondamento_valor_id_seq', 26, true);


--
-- TOC entry 7733 (class 0 OID 9443975)
-- Dependencies: 444
-- Data for Name: tipo_veiculo; Type: TABLE DATA; Schema: modules; Owner: -
--

INSERT INTO modules.tipo_veiculo VALUES (1, 'Vans/Kombis');
INSERT INTO modules.tipo_veiculo VALUES (2, 'Microônibus');
INSERT INTO modules.tipo_veiculo VALUES (3, 'Ônibus');
INSERT INTO modules.tipo_veiculo VALUES (4, 'Bicicleta');
INSERT INTO modules.tipo_veiculo VALUES (5, 'Tração Animal');
INSERT INTO modules.tipo_veiculo VALUES (6, 'Outro');
INSERT INTO modules.tipo_veiculo VALUES (7, 'Capacidade de até 5 Alunos');
INSERT INTO modules.tipo_veiculo VALUES (8, 'Capacidade entre 5 a 15 Alunos');
INSERT INTO modules.tipo_veiculo VALUES (9, 'Capacidade entre 15 a 35 Alunos');
INSERT INTO modules.tipo_veiculo VALUES (10, 'Capacidade acima de 35 Alunos');
INSERT INTO modules.tipo_veiculo VALUES (11, 'Trem/Metrô');


--
-- TOC entry 8257 (class 0 OID 0)
-- Dependencies: 443
-- Name: tipo_veiculo_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.tipo_veiculo_seq', 1, false);


--
-- TOC entry 7734 (class 0 OID 9443979)
-- Dependencies: 445
-- Data for Name: transporte_aluno; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7735 (class 0 OID 9443982)
-- Dependencies: 446
-- Data for Name: uniforme_aluno; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 7737 (class 0 OID 9443987)
-- Dependencies: 448
-- Data for Name: veiculo; Type: TABLE DATA; Schema: modules; Owner: -
--



--
-- TOC entry 8258 (class 0 OID 0)
-- Dependencies: 447
-- Name: veiculo_seq; Type: SEQUENCE SET; Schema: modules; Owner: -
--

SELECT pg_catalog.setval('modules.veiculo_seq', 1, false);


--
-- TOC entry 7739 (class 0 OID 9443996)
-- Dependencies: 450
-- Data for Name: acao_governo; Type: TABLE DATA; Schema: pmiacoes; Owner: -
--



--
-- TOC entry 7741 (class 0 OID 9444009)
-- Dependencies: 452
-- Data for Name: acao_governo_arquivo; Type: TABLE DATA; Schema: pmiacoes; Owner: -
--



--
-- TOC entry 8259 (class 0 OID 0)
-- Dependencies: 451
-- Name: acao_governo_arquivo_cod_acao_governo_arquivo_seq; Type: SEQUENCE SET; Schema: pmiacoes; Owner: -
--

SELECT pg_catalog.setval('pmiacoes.acao_governo_arquivo_cod_acao_governo_arquivo_seq', 1, false);


--
-- TOC entry 7742 (class 0 OID 9444016)
-- Dependencies: 453
-- Data for Name: acao_governo_categoria; Type: TABLE DATA; Schema: pmiacoes; Owner: -
--



--
-- TOC entry 8260 (class 0 OID 0)
-- Dependencies: 449
-- Name: acao_governo_cod_acao_governo_seq; Type: SEQUENCE SET; Schema: pmiacoes; Owner: -
--

SELECT pg_catalog.setval('pmiacoes.acao_governo_cod_acao_governo_seq', 1, false);


--
-- TOC entry 7744 (class 0 OID 9444021)
-- Dependencies: 455
-- Data for Name: acao_governo_foto; Type: TABLE DATA; Schema: pmiacoes; Owner: -
--



--
-- TOC entry 8261 (class 0 OID 0)
-- Dependencies: 454
-- Name: acao_governo_foto_cod_acao_governo_foto_seq; Type: SEQUENCE SET; Schema: pmiacoes; Owner: -
--

SELECT pg_catalog.setval('pmiacoes.acao_governo_foto_cod_acao_governo_foto_seq', 1, false);


--
-- TOC entry 7745 (class 0 OID 9444028)
-- Dependencies: 456
-- Data for Name: acao_governo_foto_portal; Type: TABLE DATA; Schema: pmiacoes; Owner: -
--



--
-- TOC entry 7746 (class 0 OID 9444031)
-- Dependencies: 457
-- Data for Name: acao_governo_noticia; Type: TABLE DATA; Schema: pmiacoes; Owner: -
--



--
-- TOC entry 7747 (class 0 OID 9444034)
-- Dependencies: 458
-- Data for Name: acao_governo_setor; Type: TABLE DATA; Schema: pmiacoes; Owner: -
--



--
-- TOC entry 7749 (class 0 OID 9444039)
-- Dependencies: 460
-- Data for Name: categoria; Type: TABLE DATA; Schema: pmiacoes; Owner: -
--



--
-- TOC entry 8262 (class 0 OID 0)
-- Dependencies: 459
-- Name: categoria_cod_categoria_seq; Type: SEQUENCE SET; Schema: pmiacoes; Owner: -
--

SELECT pg_catalog.setval('pmiacoes.categoria_cod_categoria_seq', 1, false);


--
-- TOC entry 7750 (class 0 OID 9444044)
-- Dependencies: 461
-- Data for Name: secretaria_responsavel; Type: TABLE DATA; Schema: pmiacoes; Owner: -
--



--
-- TOC entry 7752 (class 0 OID 9444049)
-- Dependencies: 463
-- Data for Name: acontecimento; Type: TABLE DATA; Schema: pmicontrolesis; Owner: -
--



--
-- TOC entry 8263 (class 0 OID 0)
-- Dependencies: 462
-- Name: acontecimento_cod_acontecimento_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: -
--

SELECT pg_catalog.setval('pmicontrolesis.acontecimento_cod_acontecimento_seq', 1, false);


--
-- TOC entry 7754 (class 0 OID 9444059)
-- Dependencies: 465
-- Data for Name: artigo; Type: TABLE DATA; Schema: pmicontrolesis; Owner: -
--



--
-- TOC entry 8264 (class 0 OID 0)
-- Dependencies: 464
-- Name: artigo_cod_artigo_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: -
--

SELECT pg_catalog.setval('pmicontrolesis.artigo_cod_artigo_seq', 1, false);


--
-- TOC entry 7756 (class 0 OID 9444069)
-- Dependencies: 467
-- Data for Name: foto_evento; Type: TABLE DATA; Schema: pmicontrolesis; Owner: -
--



--
-- TOC entry 8265 (class 0 OID 0)
-- Dependencies: 466
-- Name: foto_evento_cod_foto_evento_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: -
--

SELECT pg_catalog.setval('pmicontrolesis.foto_evento_cod_foto_evento_seq', 1, false);


--
-- TOC entry 7758 (class 0 OID 9444079)
-- Dependencies: 469
-- Data for Name: foto_vinc; Type: TABLE DATA; Schema: pmicontrolesis; Owner: -
--



--
-- TOC entry 8266 (class 0 OID 0)
-- Dependencies: 468
-- Name: foto_vinc_cod_foto_vinc_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: -
--

SELECT pg_catalog.setval('pmicontrolesis.foto_vinc_cod_foto_vinc_seq', 1, false);


--
-- TOC entry 7760 (class 0 OID 9444085)
-- Dependencies: 471
-- Data for Name: itinerario; Type: TABLE DATA; Schema: pmicontrolesis; Owner: -
--



--
-- TOC entry 8267 (class 0 OID 0)
-- Dependencies: 470
-- Name: itinerario_cod_itinerario_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: -
--

SELECT pg_catalog.setval('pmicontrolesis.itinerario_cod_itinerario_seq', 1, false);


--
-- TOC entry 7762 (class 0 OID 9444095)
-- Dependencies: 473
-- Data for Name: menu; Type: TABLE DATA; Schema: pmicontrolesis; Owner: -
--

INSERT INTO pmicontrolesis.menu VALUES (21122, NULL, NULL, 'Cadastros', 1, NULL, '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998851, 9998851, 999910, 'Auditoria geral', 0, 'educar_auditoria_geral_lst.php', '_self', 1, 18, 192, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21125, NULL, NULL, 'Administrativo', 4, NULL, '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21126, NULL, NULL, 'Relatórios', 5, NULL, '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21127, NULL, NULL, 'Documentos', 6, NULL, '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999614, NULL, NULL, 'Relatórios', 3, NULL, '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (20710, NULL, NULL, 'Cadastros', 1, NULL, '_self', 1, 17, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (20712, NULL, NULL, 'Relatórios', 3, NULL, '_self', 1, 17, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999400, NULL, 21127, 'Atestados', 0, NULL, '_self', 1, 15, 17, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999302, NULL, 21126, 'Servidores', 0, NULL, '_self', 1, 15, 37, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998858, 9998858, 999910, 'Backups', 1, 'educar_backup_lst.php', '_self', 4, 18, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998848, NULL, NULL, 'Importações', 1, NULL, '_self', 1, 22, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998849, 9998849, 9998848, 'Importação educacenso', 0, 'educar_importacao_educacenso.php', '_self', 1, 22, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998859, 9998859, 21150, 'Componentes da série', 0, 'educar_componentes_serie_lst.php', '_self', 1, 15, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998854, NULL, 999913, 'Servidores', 3, NULL, '_self', 1, 19, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21179, NULL, 21126, 'Relação de alunos annes - qtd', 0, NULL, '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21200, 567, 21162, 'Prédios', 0, 'educar_infra_predio_lst.php', '_self', 1, 15, 147, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21171, NULL, 999917, 'Alunos', 0, NULL, '_self', 1, 15, 62, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21210, 581, 21171, 'Tipos de benefício', 0, 'educar_aluno_beneficio_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21153, 634, 999912, 'Funções', 1, 'educar_funcao_lst.php', '_self', 1, 19, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21223, 678, 999934, 'Tipos de cor ou raça', 0, 'educar_raca_lst.php', '_self', 1, 20, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21174, 575, 999918, 'Tipos de transferência', 0, 'educar_transferencia_tipo_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21173, 580, 999918, 'Tipos de ocorrência disciplinar', 0, 'educar_tipo_ocorrencia_disciplinar_lst.php', '_self', 1, 15, 194, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21226, NULL, 999917, 'Regras de avaliação', 2, NULL, '_self', 1, 15, 195, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21170, 631, 999934, 'Tipos de deficiência', 0, 'educar_deficiencia_lst.php', '_self', 1, 20, 142, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21219, 579, 999934, 'Tipos de religião', 0, 'educar_religiao_lst.php', '_self', 1, 20, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21160, 845, 21124, 'Rematrícula automática', 1, 'educar_avancar_mod_cad.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21144, 659, 21124, 'Enturmações em lote', 2, 'educar_matriculas_turma_lst.php', '_self', 1, 15, 145, NULL);
INSERT INTO pmicontrolesis.menu VALUES (20711, NULL, NULL, 'Movimentações', 2, NULL, '_self', 1, 17, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21235, 21235, 20710, 'Empresas', 0, 'transporte_empresa_lst.php', '_self', 1, 17, 192, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21236, 21236, 20710, 'Motoristas', 0, 'transporte_motorista_lst.php', '_self', 1, 17, 192, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21237, 21237, 20710, 'Veículos', 0, 'transporte_veiculo_lst.php', '_self', 1, 17, 192, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21238, 21238, 20710, 'Pontos', 0, 'transporte_ponto_lst.php', '_self', 1, 17, 192, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21239, 21239, 20710, 'Rotas', 0, 'transporte_rota_lst.php', '_self', 1, 17, 192, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21240, 21240, 20711, 'Usuários de transporte', 0, 'transporte_pessoa_lst.php', '_self', 1, 17, 192, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21221, 572, 21162, 'Tipos de ambiente', 0, 'educar_infra_comodo_funcao_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21250, 21250, 21171, 'Tipos de projeto', 0, 'educar_projeto_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999800, NULL, 21127, 'Documentos CBAL', 7, NULL, '_self', 1, 15, 21, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21245, 950, 999918, 'Tipos de abandono', 0, 'educar_abandono_tipo_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999613, 999613, 999921, 'Históricos escolares', 1, 'module/HistoricoEscolar/processamento', '_self', 1, 15, 192, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21207, 574, 21122, 'Infraestrutura', 5, 'educar_infra_predio_comodo_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21152, 642, 999920, 'Faltas e notas', 0, 'module/Avaliacao/diario', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999303, NULL, 21126, 'Indicadores', 6, NULL, '_self', 1, 15, 24, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21244, NULL, 20711, 'Processos', 0, NULL, '_self', 1, 17, 192, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21246, 21246, 21244, 'C&oacute;pia de rotas', 0, 'transporte_copia_rotas.php', '_self', 1, 17, 192, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999811, NULL, 21127, 'Declarações', 0, NULL, '_self', 1, 15, 21, NULL);
INSERT INTO pmicontrolesis.menu VALUES (626, 950, NULL, 'Alterar datas de entrada/saída de matrículas', 0, '', '_self', 1, 7, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (627, 950, NULL, 'Cancelar matrícula', 0, '', '_self', 1, 7, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21145, 21145, 999920, 'Ocorrências disciplinares', 0, 'educar_matricula_ocorrencia_disciplinar_cad.php', '_self', 1, 15, 192, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999831, NULL, NULL, 'Documentos', 4, NULL, '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (630, 950, NULL, 'Alterar média final do aluno e situação (para regras de avaliação manuais)', 0, '', '_self', 1, 7, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999849, 950, NULL, 'Permitir lançamento de notas/faltas fora do período de bloqueio por etapa', 0, '', '_self', 1, 7, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999852, NULL, 21122, 'Bloqueio do ano letivo', 0, NULL, '_self', 1, 15, 19, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999850, NULL, 21127, 'Termos', 0, NULL, '_self', 1, 15, 19, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999858, NULL, 21126, 'Quantitativos', 0, NULL, '_self', 1, 15, 17, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999867, 999867, 999866, 'Categoria de obras', 0, 'educar_categoria_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21130, 635, 999911, 'Servidores', 2, 'educar_servidor_lst.php', '_self', 1, 19, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21195, 946, 21122, 'Componentes curriculares', 8, 'educar_componente_curricular_lst.php', '_self', 1, 15, 192, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999827, NULL, 21126, 'Gerenciais', 0, NULL, '_self', 1, 15, 17, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999861, NULL, 21127, 'Fichas', 8, NULL, '_self', 1, 15, 19, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999878, 950, NULL, 'Permitir editar endereço no cadastro de pessoa física', 0, '', '_self', 1, 7, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15858, NULL, NULL, 'Cadastros', 1, NULL, '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999900, 594, 15858, 'Tipos', 1, NULL, '_self', 1, 16, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999901, 594, 999900, 'Obras', 1, NULL, '_self', 1, 16, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999866, 598, 999901, 'Categorias', 0, 'educar_categoria_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15877, 592, 999901, 'Assuntos', 0, 'educar_acervo_assunto_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15881, 594, 999901, 'Autores', 0, 'educar_acervo_autor_lst.php', '_self', 1, 16, 141, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15882, 593, 999901, 'Coleções', 0, 'educar_acervo_colecao_lst.php', '_self', 1, 16, 119, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15883, 595, 999901, 'Editoras', 0, 'educar_acervo_editora_lst.php', '_self', 1, 16, 176, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15884, 590, 999901, 'Idiomas', 0, 'educar_acervo_idioma_lst.php', '_self', 1, 16, 26, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15889, 608, 999901, 'Fontes', 0, 'educar_fonte_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999903, 594, 999900, 'Exemplares', 3, NULL, '_self', 1, 16, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15885, 597, 999903, 'Tipos de exemplar', 1, 'educar_exemplar_tipo_lst.php', '_self', 1, 16, 177, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15891, 602, 999903, 'Tipos de situação de exemplar', 2, 'educar_situacao_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15887, 600, 999903, 'Motivos de baixa', 3, 'educar_motivo_baixa_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999904, 594, 999900, 'Clientes', 4, NULL, '_self', 1, 16, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15886, 596, 999904, 'Tipos de cliente', 1, 'educar_cliente_tipo_lst.php', '_self', 1, 16, 62, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15888, 607, 999904, 'Motivos de suspensão', 2, 'educar_motivo_suspensao_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15880, 591, 15858, 'Bibliotecas', 2, 'educar_biblioteca_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15890, 629, 15858, 'Configurações', 2, 'educar_biblioteca_dados_lst.php', '_self', 1, 16, 143, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15878, 598, 15858, 'Obras', 3, 'educar_acervo_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15879, 606, 15858, 'Exemplares', 4, 'educar_exemplar_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15892, 603, 15858, 'Clientes', 5, 'educar_cliente_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15869, 609, 15859, 'Reservas', 1, 'educar_reservas_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15894, 610, 15859, 'Empréstimos', 2, 'module/Biblioteca/emprestimo', '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15895, 628, 15859, 'Devoluções', 3, 'educar_exemplar_devolucao_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15893, 622, 15859, 'Dívidas', 4, 'educar_pagamento_multa_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999905, 594, 999614, 'Cadastrais', 1, NULL, '_self', 1, 16, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (15859, NULL, NULL, 'Movimentações', 2, NULL, '_self', 1, 16, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999906, 594, 999614, 'Movimentações', 2, NULL, '_self', 1, 16, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999907, 594, 999831, 'Comprovantes', 3, NULL, '_self', 1, 16, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999908, NULL, NULL, 'Permissões', 1, NULL, '_self', 1, 18, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (554, 554, 999908, 'Tipos de usuário', 3, 'educar_tipo_usuario_lst.php   ', '_self', 1, 18, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (555, 555, 999908, 'Usuários', 3, 'educar_usuario_lst.php', '_self', 1, 18, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999909, NULL, NULL, 'Configurações', 2, NULL, '_self', 1, 18, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999873, 999873, 999909, 'Configurações gerais', 3, 'educar_configuracoes_gerais.php', '_self', 1, 18, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999910, NULL, NULL, 'Ferramentas', 3, NULL, '_self', 1, 18, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999869, 999869, 999910, 'Exportação de usuários', 1, 'educar_exportacao_usuarios.php', '_self', 1, 18, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (644, 644, 999910, 'Atualização de matrículas', 2, 'module/Avaliacao/Promocao', '_self', 1, 18, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999911, NULL, NULL, 'Cadastros', 1, NULL, '_self', 1, 19, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999912, NULL, 999911, 'Tipos', 1, NULL, '_self', 1, 19, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21146, 632, 999912, 'Escolaridade', 2, 'educar_escolaridade_lst.php', '_self', 1, 19, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21156, 829, 999912, 'Categoria ou níveis', 3, 'educar_categoria_nivel_lst.php', '_self', 1, 19, 20, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21151, 633, 999912, 'Motivos de afastamento', 4, 'educar_motivo_afastamento_lst.php', '_self', 1, 19, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21137, 641, 999911, 'Quadros de horários', 3, 'educar_quadro_horario_lst.php', '_self', 1, 19, 105, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999913, NULL, NULL, 'Relatórios', 2, NULL, '_self', 1, 19, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999914, NULL, 999913, 'Cadastrais', 1, NULL, '_self', 1, 19, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999915, NULL, 999913, 'Indicadores', 2, NULL, '_self', 1, 19, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999916, NULL, NULL, 'Documentos', 3, NULL, '_self', 1, 19, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999917, NULL, 21122, 'Tipos', 1, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999918, NULL, 999917, 'Matrículas', 2, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21228, 948, 21226, 'Fórmulas de cálculo de média', 0, 'module/FormulaMedia/index', '_self', 1, 15, 198, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21229, 949, 21226, 'Tabelas de arredondamento', 0, 'module/TabelaArredondamento/index', '_self', 1, 15, 199, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999919, NULL, 999917, 'Componentes curriculares', 3, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21206, 945, 999919, 'Áreas de conhecimento', 0, 'module/AreaConhecimento/index', '_self', 1, 15, 189, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21213, 577, 999919, 'Tipos de dispensa', 0, 'educar_tipo_dispensa_lst.php', '_self', 1, 15, 193, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21140, NULL, 999917, 'Cursos', 4, NULL, '_self', 1, 15, 20, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21208, 573, 21140, 'Tipos de habilitação', 0, 'educar_habilitacao_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21220, 568, 21140, 'Tipos de regime', 0, 'educar_tipo_regime_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21222, 558, 21140, 'Tipos de ensino', 0, 'educar_tipo_ensino_lst.php', '_self', 1, 15, 124, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21224, 571, 21140, 'Tipos de nível ensino', 0, 'educar_nivel_ensino_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21161, NULL, 999917, 'Escolas', 5, NULL, '_self', 1, 15, 91, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21211, 562, 21161, 'Tipos de localização', 0, 'educar_escola_localizacao_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21218, 647, 21161, 'Tipos de rede de ensino', 0, 'educar_escola_rede_ensino_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21150, NULL, 999917, 'Séries', 6, NULL, '_self', 1, 15, 37, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21157, 587, 21150, 'Sequências de enturmação', 0, 'educar_sequencia_serie_lst.php', '_self', 1, 15, 145, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21165, NULL, 999917, 'Turmas', 7, NULL, '_self', 1, 15, 141, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21215, 570, 21165, 'Tipos de turma', 0, 'educar_turma_tipo_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21162, NULL, 999917, 'Infraestrutura', 8, NULL, '_self', 1, 15, 108, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21169, NULL, 999917, 'Calendários', 9, NULL, '_self', 1, 15, 104, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21209, 576, 21169, 'Tipos de evento do calendário', 0, 'educar_calendario_dia_motivo_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21205, 578, 21122, 'Alunos', 2, 'educar_aluno_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21198, 561, 21122, 'Escolas', 3, 'educar_escola_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21128, 559, 21122, 'Instituição', 4, 'educar_instituicao_lst.php', '_self', 1, 15, 26, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21199, 620, 21122, 'Calendários', 6, 'educar_calendario_ano_letivo_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21227, 947, 21122, 'Regras de avaliação', 7, 'module/RegraAvaliacao/index', '_self', 1, 15, 197, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21124, NULL, NULL, 'Movimentações', 2, NULL, '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999920, NULL, NULL, 'Lançamentos', 3, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999921, NULL, NULL, 'Processos', 4, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21202, 566, 21122, 'Cursos', 10, 'educar_curso_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21201, 583, 21122, 'Séries', 11, 'educar_serie_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21216, 585, 21122, 'Séries da escola', 12, 'educar_escola_serie_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21197, 586, 21122, 'Turmas', 13, 'educar_turma_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999301, NULL, 21126, 'Movimentações', 2, NULL, '_self', 1, 15, 31, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999922, NULL, 21126, 'Lançamentos', 3, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999300, NULL, 21126, 'Cadastrais', 4, NULL, '_self', 1, 15, 20, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999923, NULL, 21126, 'Matrículas', 5, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999924, NULL, 21126, 'Vagas', 7, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999450, NULL, 21127, 'Boletins', 2, NULL, '_self', 1, 15, 19, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999925, NULL, 21127, 'Resultados', 3, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999600, NULL, 21127, 'Carteiras', 4, NULL, '_self', 1, 15, 20, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999807, NULL, 21127, 'Certificados', 5, NULL, '_self', 1, 15, 25, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999865, 999861, 21127, 'Documentação padrão', 6, 'DocumentacaoPadrao.php', '_self', 1, 15, 21, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999460, NULL, 21127, 'Históricos', 9, NULL, '_self', 1, 15, 25, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999500, NULL, 21127, 'Registros', 10, NULL, '_self', 1, 15, 36, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999926, NULL, NULL, 'Ferramentas', 7, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999927, NULL, 999926, 'Unificações', 1, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999847, 999847, 999927, 'Unificação de alunos', 0, 'educar_unifica_aluno.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21253, 21253, 999928, 'Vagas por série/ano', 2, 'educar_serie_vaga_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21251, 21251, 999928, 'Bloqueio do ano letivo', 0, 'educar_bloqueio_ano_letivo_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999848, 999848, 999928, 'Bloqueio de lançamento de notas e faltas', 0, 'educar_bloqueio_lancamento_faltas_notas_lst.php', '_self', 1, 16, 192, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999929, NULL, NULL, 'Cadastros', 1, NULL, '_self', 1, 20, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (43, 43, 999929, 'Pessoas físicas', 1, 'atendidos_lst.php', '_self', 1, 20, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (41, 41, 999929, 'Pessoas jurídicas', 2, 'empresas_lst.php', '_self', 1, 20, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999930, NULL, NULL, 'Cadastros', 1, NULL, '_self', 1, 21, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (753, 753, 999930, 'Países', 1, 'public_pais_lst.php', '_self', 1, 21, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (754, 754, 999930, 'Estados', 2, 'public_uf_lst.php', '_self', 1, 21, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (755, 755, 999930, 'Municípios', 3, 'public_municipio_lst.php', '_self', 1, 21, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (759, 759, 999930, 'Distritos', 4, 'public_distrito_lst.php', '_self', 1, 21, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (760, 760, 999930, 'Setores', 5, 'public_setor_lst.php', '_self', 1, 21, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (756, 756, 999930, 'Bairros', 6, 'public_bairro_lst.php', '_self', 1, 21, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (757, 757, 999930, 'Logradouros', 7, 'public_logradouro_lst.php', '_self', 1, 21, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (758, 758, 999930, 'CEP', 8, 'urbano_cep_logradouro_lst.php', '_self', 1, 21, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999931, NULL, NULL, 'Ferramentas', 1, NULL, '_self', 1, 21, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999932, NULL, NULL, 'Exportações', 1, NULL, '_self', 1, 22, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (761, 761, 999931, 'Unificação de bairros', 1, 'educar_unifica_bairro.php', '_self', 1, 21, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (762, 762, 999931, 'Unificação de logradouros', 2, 'educar_unifica_logradouro.php', '_self', 1, 21, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (846, 846, 999932, '1ª fase - Matrícula inicial', 1, 'educar_exportacao_educacenso.php', '_self', 1, 22, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998845, 9998845, 999932, '2ª fase - Situação final', 1, 'educar_exportacao_educacenso.php?fase2=1', '_self', 1, 22, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999934, NULL, 999929, 'Tipos', 0, NULL, '_self', 1, 20, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998846, NULL, NULL, 'Documentos', 4, NULL, '_self', 1, 17, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998847, NULL, 20712, 'Cadastrais', 1, NULL, '_self', 1, 17, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (999928, NULL, 999926, 'Parâmetros', 2, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998867, 9998867, 999909, 'Configuração movimento geral', 3, 'module/Configuracao/ConfiguracaoMovimentoGeral', '_self', 1, 18, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998869, 9998869, 999909, 'Customização de labels', 4, 'educar_configuracoes_labels.php', '_self', 1, 18, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998876, NULL, NULL, 'Ferramentas', 2, NULL, '_self', 1, 20, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998877, NULL, 9998876, 'Unificações', 1, NULL, '_self', 1, 20, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998878, 9998878, 9998877, 'Unificação de pessoas', 0, 'educar_unifica_pessoa.php', '_self', 1, 20, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (21159, 584, 21161, 'Tipos de etapas', 0, 'educar_modulo_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998890, NULL, 999926, 'Consultas', 1, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998900, 9998900, 9998890, 'Consulta de movimento geral', 0, 'educar_consulta_movimento_geral.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (9998910, 9998910, 9998890, 'Consulta de movimento mensal', 0, 'educar_consulta_movimento_mensal.php', '_self', 1, 15, 1, NULL);
INSERT INTO pmicontrolesis.menu VALUES (190, 190, 999912, 'Vínculos da alocação', 5, 'funcionario_vinculo_lst.php', '_self', 1, 19, 1, NULL);


--
-- TOC entry 8268 (class 0 OID 0)
-- Dependencies: 472
-- Name: menu_cod_menu_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: -
--

SELECT pg_catalog.setval('pmicontrolesis.menu_cod_menu_seq', 20709, true);


--
-- TOC entry 7764 (class 0 OID 9444105)
-- Dependencies: 475
-- Data for Name: menu_portal; Type: TABLE DATA; Schema: pmicontrolesis; Owner: -
--



--
-- TOC entry 8269 (class 0 OID 0)
-- Dependencies: 474
-- Name: menu_portal_cod_menu_portal_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: -
--

SELECT pg_catalog.setval('pmicontrolesis.menu_portal_cod_menu_portal_seq', 1, false);


--
-- TOC entry 7766 (class 0 OID 9444118)
-- Dependencies: 477
-- Data for Name: portais; Type: TABLE DATA; Schema: pmicontrolesis; Owner: -
--



--
-- TOC entry 8270 (class 0 OID 0)
-- Dependencies: 476
-- Name: portais_cod_portais_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: -
--

SELECT pg_catalog.setval('pmicontrolesis.portais_cod_portais_seq', 1, false);


--
-- TOC entry 7768 (class 0 OID 9444128)
-- Dependencies: 479
-- Data for Name: servicos; Type: TABLE DATA; Schema: pmicontrolesis; Owner: -
--



--
-- TOC entry 8271 (class 0 OID 0)
-- Dependencies: 478
-- Name: servicos_cod_servicos_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: -
--

SELECT pg_catalog.setval('pmicontrolesis.servicos_cod_servicos_seq', 1, false);


--
-- TOC entry 7770 (class 0 OID 9444138)
-- Dependencies: 481
-- Data for Name: sistema; Type: TABLE DATA; Schema: pmicontrolesis; Owner: -
--



--
-- TOC entry 8272 (class 0 OID 0)
-- Dependencies: 480
-- Name: sistema_cod_sistema_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: -
--

SELECT pg_catalog.setval('pmicontrolesis.sistema_cod_sistema_seq', 1, false);


--
-- TOC entry 7772 (class 0 OID 9444145)
-- Dependencies: 483
-- Data for Name: submenu_portal; Type: TABLE DATA; Schema: pmicontrolesis; Owner: -
--



--
-- TOC entry 8273 (class 0 OID 0)
-- Dependencies: 482
-- Name: submenu_portal_cod_submenu_portal_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: -
--

SELECT pg_catalog.setval('pmicontrolesis.submenu_portal_cod_submenu_portal_seq', 1, false);


--
-- TOC entry 7774 (class 0 OID 9444160)
-- Dependencies: 485
-- Data for Name: telefones; Type: TABLE DATA; Schema: pmicontrolesis; Owner: -
--



--
-- TOC entry 8274 (class 0 OID 0)
-- Dependencies: 484
-- Name: telefones_cod_telefones_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: -
--

SELECT pg_catalog.setval('pmicontrolesis.telefones_cod_telefones_seq', 1, false);


--
-- TOC entry 7776 (class 0 OID 9444170)
-- Dependencies: 487
-- Data for Name: tipo_acontecimento; Type: TABLE DATA; Schema: pmicontrolesis; Owner: -
--



--
-- TOC entry 8275 (class 0 OID 0)
-- Dependencies: 486
-- Name: tipo_acontecimento_cod_tipo_acontecimento_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: -
--

SELECT pg_catalog.setval('pmicontrolesis.tipo_acontecimento_cod_tipo_acontecimento_seq', 1, false);


--
-- TOC entry 7778 (class 0 OID 9444180)
-- Dependencies: 489
-- Data for Name: topo_portal; Type: TABLE DATA; Schema: pmicontrolesis; Owner: -
--



--
-- TOC entry 8276 (class 0 OID 0)
-- Dependencies: 488
-- Name: topo_portal_cod_topo_portal_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: -
--

SELECT pg_catalog.setval('pmicontrolesis.topo_portal_cod_topo_portal_seq', 1, false);


--
-- TOC entry 7780 (class 0 OID 9444191)
-- Dependencies: 491
-- Data for Name: tutormenu; Type: TABLE DATA; Schema: pmicontrolesis; Owner: -
--

INSERT INTO pmicontrolesis.tutormenu VALUES (7, 'i-Pauta');
INSERT INTO pmicontrolesis.tutormenu VALUES (15, 'i-Educar');
INSERT INTO pmicontrolesis.tutormenu VALUES (16, 'i-Educar Biblioteca');
INSERT INTO pmicontrolesis.tutormenu VALUES (17, 'Transporte Escolar');
INSERT INTO pmicontrolesis.tutormenu VALUES (18, 'Configurações');
INSERT INTO pmicontrolesis.tutormenu VALUES (19, 'Servidores');
INSERT INTO pmicontrolesis.tutormenu VALUES (20, 'Pessoas');
INSERT INTO pmicontrolesis.tutormenu VALUES (21, 'Endereçamento');
INSERT INTO pmicontrolesis.tutormenu VALUES (22, 'Educacenso');


--
-- TOC entry 8277 (class 0 OID 0)
-- Dependencies: 490
-- Name: tutormenu_cod_tutormenu_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: -
--

SELECT pg_catalog.setval('pmicontrolesis.tutormenu_cod_tutormenu_seq', 16, true);


--
-- TOC entry 7782 (class 0 OID 9444197)
-- Dependencies: 493
-- Data for Name: diaria; Type: TABLE DATA; Schema: pmidrh; Owner: -
--



--
-- TOC entry 8278 (class 0 OID 0)
-- Dependencies: 492
-- Name: diaria_cod_diaria_seq; Type: SEQUENCE SET; Schema: pmidrh; Owner: -
--

SELECT pg_catalog.setval('pmidrh.diaria_cod_diaria_seq', 1, false);


--
-- TOC entry 7784 (class 0 OID 9444207)
-- Dependencies: 495
-- Data for Name: diaria_grupo; Type: TABLE DATA; Schema: pmidrh; Owner: -
--



--
-- TOC entry 8279 (class 0 OID 0)
-- Dependencies: 494
-- Name: diaria_grupo_cod_diaria_grupo_seq; Type: SEQUENCE SET; Schema: pmidrh; Owner: -
--

SELECT pg_catalog.setval('pmidrh.diaria_grupo_cod_diaria_grupo_seq', 1, false);


--
-- TOC entry 7786 (class 0 OID 9444213)
-- Dependencies: 497
-- Data for Name: diaria_valores; Type: TABLE DATA; Schema: pmidrh; Owner: -
--



--
-- TOC entry 8280 (class 0 OID 0)
-- Dependencies: 496
-- Name: diaria_valores_cod_diaria_valores_seq; Type: SEQUENCE SET; Schema: pmidrh; Owner: -
--

SELECT pg_catalog.setval('pmidrh.diaria_valores_cod_diaria_valores_seq', 1, false);


--
-- TOC entry 7788 (class 0 OID 9444219)
-- Dependencies: 499
-- Data for Name: setor; Type: TABLE DATA; Schema: pmidrh; Owner: -
--



--
-- TOC entry 8281 (class 0 OID 0)
-- Dependencies: 498
-- Name: setor_cod_setor_seq; Type: SEQUENCE SET; Schema: pmidrh; Owner: -
--

SELECT pg_catalog.setval('pmidrh.setor_cod_setor_seq', 1, false);


--
-- TOC entry 7790 (class 0 OID 9444231)
-- Dependencies: 501
-- Data for Name: abandono_tipo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--

INSERT INTO pmieducar.abandono_tipo VALUES (1, 1, NULL, 1, 'Desistência', '2014-07-18 10:40:06.877894', NULL, 1);
INSERT INTO pmieducar.abandono_tipo VALUES (2, 1, NULL, 1, 'Falecimento', '2014-07-18 10:40:06.877894', NULL, 1);


--
-- TOC entry 8282 (class 0 OID 0)
-- Dependencies: 500
-- Name: abandono_tipo_cod_abandono_tipo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.abandono_tipo_cod_abandono_tipo_seq', 2, true);


--
-- TOC entry 7792 (class 0 OID 9444237)
-- Dependencies: 503
-- Data for Name: acervo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7793 (class 0 OID 9444245)
-- Dependencies: 504
-- Data for Name: acervo_acervo_assunto; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7794 (class 0 OID 9444248)
-- Dependencies: 505
-- Data for Name: acervo_acervo_autor; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7796 (class 0 OID 9444254)
-- Dependencies: 507
-- Data for Name: acervo_assunto; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8283 (class 0 OID 0)
-- Dependencies: 506
-- Name: acervo_assunto_cod_acervo_assunto_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.acervo_assunto_cod_acervo_assunto_seq', 1, false);


--
-- TOC entry 7798 (class 0 OID 9444264)
-- Dependencies: 509
-- Data for Name: acervo_autor; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8284 (class 0 OID 0)
-- Dependencies: 508
-- Name: acervo_autor_cod_acervo_autor_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.acervo_autor_cod_acervo_autor_seq', 1, false);


--
-- TOC entry 8285 (class 0 OID 0)
-- Dependencies: 502
-- Name: acervo_cod_acervo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.acervo_cod_acervo_seq', 1, false);


--
-- TOC entry 7800 (class 0 OID 9444274)
-- Dependencies: 511
-- Data for Name: acervo_colecao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8286 (class 0 OID 0)
-- Dependencies: 510
-- Name: acervo_colecao_cod_acervo_colecao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.acervo_colecao_cod_acervo_colecao_seq', 1, false);


--
-- TOC entry 7802 (class 0 OID 9444284)
-- Dependencies: 513
-- Data for Name: acervo_editora; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8287 (class 0 OID 0)
-- Dependencies: 512
-- Name: acervo_editora_cod_acervo_editora_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.acervo_editora_cod_acervo_editora_seq', 1, false);


--
-- TOC entry 7804 (class 0 OID 9444294)
-- Dependencies: 515
-- Data for Name: acervo_idioma; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8288 (class 0 OID 0)
-- Dependencies: 514
-- Name: acervo_idioma_cod_acervo_idioma_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.acervo_idioma_cod_acervo_idioma_seq', 1, false);


--
-- TOC entry 7806 (class 0 OID 9444301)
-- Dependencies: 517
-- Data for Name: aluno; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7807 (class 0 OID 9444310)
-- Dependencies: 518
-- Data for Name: aluno_aluno_beneficio; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7809 (class 0 OID 9444315)
-- Dependencies: 520
-- Data for Name: aluno_beneficio; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8289 (class 0 OID 0)
-- Dependencies: 519
-- Name: aluno_beneficio_cod_aluno_beneficio_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.aluno_beneficio_cod_aluno_beneficio_seq', 1, false);


--
-- TOC entry 8290 (class 0 OID 0)
-- Dependencies: 516
-- Name: aluno_cod_aluno_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.aluno_cod_aluno_seq', 2, true);


--
-- TOC entry 7810 (class 0 OID 9444323)
-- Dependencies: 521
-- Data for Name: aluno_historico_altura_peso; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7811 (class 0 OID 9444326)
-- Dependencies: 522
-- Data for Name: ano_letivo_modulo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7812 (class 0 OID 9444329)
-- Dependencies: 523
-- Data for Name: auditoria_falta_componente_dispensa; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8291 (class 0 OID 0)
-- Dependencies: 524
-- Name: auditoria_falta_componente_dispensa_id_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.auditoria_falta_componente_dispensa_id_seq', 1, false);


--
-- TOC entry 7814 (class 0 OID 9444334)
-- Dependencies: 525
-- Data for Name: auditoria_nota_dispensa; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8292 (class 0 OID 0)
-- Dependencies: 526
-- Name: auditoria_nota_dispensa_id_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.auditoria_nota_dispensa_id_seq', 1, false);


--
-- TOC entry 7816 (class 0 OID 9444339)
-- Dependencies: 527
-- Data for Name: avaliacao_desempenho; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7817 (class 0 OID 9444346)
-- Dependencies: 528
-- Data for Name: backup; Type: TABLE DATA; Schema: pmieducar; Owner: -
--

INSERT INTO pmieducar.backup VALUES (1, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/07/ieducar_pre_populado_2017-07-28_03-01-57.backup', '2017-07-28 03:02:23.494584');
INSERT INTO pmieducar.backup VALUES (2, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/07/ieducar_pre_populado_2017-07-29_03-02-00.backup', '2017-07-29 03:02:22.737667');
INSERT INTO pmieducar.backup VALUES (3, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/07/ieducar_pre_populado_2017-07-30_03-01-59.backup', '2017-07-30 03:02:22.113648');
INSERT INTO pmieducar.backup VALUES (4, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/07/ieducar_pre_populado_2017-07-31_03-02-13.backup', '2017-07-31 03:02:46.400935');
INSERT INTO pmieducar.backup VALUES (5, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-01_03-01-54.backup', '2017-08-01 03:02:17.811867');
INSERT INTO pmieducar.backup VALUES (6, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-02_03-02-04.backup', '2017-08-02 03:02:29.798116');
INSERT INTO pmieducar.backup VALUES (7, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-03_03-01-39.backup', '2017-08-03 03:02:01.014928');
INSERT INTO pmieducar.backup VALUES (8, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-04_03-01-41.backup', '2017-08-04 03:02:07.566392');
INSERT INTO pmieducar.backup VALUES (9, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-05_03-01-40.backup', '2017-08-05 03:02:00.206656');
INSERT INTO pmieducar.backup VALUES (10, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-06_03-01-40.backup', '2017-08-06 03:02:03.311046');
INSERT INTO pmieducar.backup VALUES (11, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-07_03-01-36.backup', '2017-08-07 03:01:57.392421');
INSERT INTO pmieducar.backup VALUES (12, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-08_03-01-59.backup', '2017-08-08 03:02:23.249248');
INSERT INTO pmieducar.backup VALUES (13, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-09_03-01-49.backup', '2017-08-09 03:02:10.233715');
INSERT INTO pmieducar.backup VALUES (14, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-10_03-01-54.backup', '2017-08-10 03:02:18.152567');
INSERT INTO pmieducar.backup VALUES (15, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-11_03-01-55.backup', '2017-08-11 03:02:19.450144');
INSERT INTO pmieducar.backup VALUES (16, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-12_03-02-04.backup', '2017-08-12 03:02:25.533138');
INSERT INTO pmieducar.backup VALUES (17, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-13_03-02-02.backup', '2017-08-13 03:02:24.515186');
INSERT INTO pmieducar.backup VALUES (18, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-14_03-02-16.backup', '2017-08-14 03:02:41.231002');
INSERT INTO pmieducar.backup VALUES (19, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-15_03-02-06.backup', '2017-08-15 03:02:25.955715');
INSERT INTO pmieducar.backup VALUES (20, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-16_03-01-59.backup', '2017-08-16 03:02:25.089404');
INSERT INTO pmieducar.backup VALUES (21, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-17_03-02-06.backup', '2017-08-17 03:02:26.208922');
INSERT INTO pmieducar.backup VALUES (22, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-18_03-02-04.backup', '2017-08-18 03:02:30.936968');
INSERT INTO pmieducar.backup VALUES (23, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-19_03-02-15.backup', '2017-08-19 03:02:42.610698');
INSERT INTO pmieducar.backup VALUES (24, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-20_03-02-10.backup', '2017-08-20 03:02:36.450591');
INSERT INTO pmieducar.backup VALUES (25, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-21_03-02-15.backup', '2017-08-21 03:02:38.34101');
INSERT INTO pmieducar.backup VALUES (26, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-22_03-02-01.backup', '2017-08-22 03:02:25.083576');
INSERT INTO pmieducar.backup VALUES (27, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-23_03-02-15.backup', '2017-08-23 03:02:40.462951');
INSERT INTO pmieducar.backup VALUES (28, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-24_03-01-56.backup', '2017-08-24 03:02:20.418753');
INSERT INTO pmieducar.backup VALUES (29, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-25_03-02-02.backup', '2017-08-25 03:02:23.37275');
INSERT INTO pmieducar.backup VALUES (30, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-26_03-02-07.backup', '2017-08-26 03:02:26.273794');
INSERT INTO pmieducar.backup VALUES (31, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-27_03-02-14.backup', '2017-08-27 03:02:42.352425');
INSERT INTO pmieducar.backup VALUES (32, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-28_03-02-07.backup', '2017-08-28 03:02:30.444604');
INSERT INTO pmieducar.backup VALUES (33, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-29_03-02-07.backup', '2017-08-29 03:02:40.909664');
INSERT INTO pmieducar.backup VALUES (34, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-30_03-01-58.backup', '2017-08-30 03:02:20.217261');
INSERT INTO pmieducar.backup VALUES (35, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-31_03-02-17.backup', '2017-08-31 03:02:44.751316');
INSERT INTO pmieducar.backup VALUES (36, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-01_03-01-58.backup', '2017-09-01 03:02:19.512299');
INSERT INTO pmieducar.backup VALUES (37, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-02_03-01-58.backup', '2017-09-02 03:02:22.451082');
INSERT INTO pmieducar.backup VALUES (38, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-03_03-02-03.backup', '2017-09-03 03:02:25.604336');
INSERT INTO pmieducar.backup VALUES (39, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-04_03-02-18.backup', '2017-09-04 03:02:39.121908');
INSERT INTO pmieducar.backup VALUES (40, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-05_03-02-08.backup', '2017-09-05 03:02:30.111405');
INSERT INTO pmieducar.backup VALUES (41, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-06_03-01-50.backup', '2017-09-06 03:02:07.929335');
INSERT INTO pmieducar.backup VALUES (42, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-07_03-01-49.backup', '2017-09-07 03:02:09.785153');
INSERT INTO pmieducar.backup VALUES (43, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-08_03-02-04.backup', '2017-09-08 03:02:27.611416');
INSERT INTO pmieducar.backup VALUES (44, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-09_03-01-52.backup', '2017-09-09 03:02:12.233375');
INSERT INTO pmieducar.backup VALUES (45, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-10_03-01-51.backup', '2017-09-10 03:02:11.865372');
INSERT INTO pmieducar.backup VALUES (46, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-11_03-02-01.backup', '2017-09-11 03:02:18.306083');
INSERT INTO pmieducar.backup VALUES (47, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-12_03-02-13.backup', '2017-09-12 03:03:08.992889');
INSERT INTO pmieducar.backup VALUES (48, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-13_03-01-56.backup', '2017-09-13 03:02:18.667826');
INSERT INTO pmieducar.backup VALUES (49, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-14_03-02-10.backup', '2017-09-14 03:02:34.435978');
INSERT INTO pmieducar.backup VALUES (50, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-15_03-02-14.backup', '2017-09-15 03:02:39.700655');
INSERT INTO pmieducar.backup VALUES (51, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-16_03-02-09.backup', '2017-09-16 03:02:34.229662');
INSERT INTO pmieducar.backup VALUES (52, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-17_03-02-10.backup', '2017-09-17 03:02:35.38535');
INSERT INTO pmieducar.backup VALUES (53, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-18_03-02-02.backup', '2017-09-18 03:02:28.89003');
INSERT INTO pmieducar.backup VALUES (54, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-19_03-02-10.backup', '2017-09-19 03:02:31.849672');
INSERT INTO pmieducar.backup VALUES (55, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-20_03-01-58.backup', '2017-09-20 03:02:21.660694');
INSERT INTO pmieducar.backup VALUES (56, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-21_03-01-50.backup', '2017-09-21 03:02:15.565692');
INSERT INTO pmieducar.backup VALUES (57, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-22_03-01-59.backup', '2017-09-22 03:02:30.991737');
INSERT INTO pmieducar.backup VALUES (58, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-23_03-02-02.backup', '2017-09-23 03:02:25.126327');
INSERT INTO pmieducar.backup VALUES (59, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-24_03-01-59.backup', '2017-09-24 03:02:21.857708');
INSERT INTO pmieducar.backup VALUES (60, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-25_03-02-04.backup', '2017-09-25 03:02:27.570748');
INSERT INTO pmieducar.backup VALUES (61, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-26_03-02-00.backup', '2017-09-26 03:02:23.366468');
INSERT INTO pmieducar.backup VALUES (62, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-27_03-02-00.backup', '2017-09-27 03:02:26.635454');
INSERT INTO pmieducar.backup VALUES (63, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-28_03-01-54.backup', '2017-09-28 03:02:14.026364');
INSERT INTO pmieducar.backup VALUES (64, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-29_03-01-52.backup', '2017-09-29 03:02:19.97997');
INSERT INTO pmieducar.backup VALUES (65, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-30_03-01-57.backup', '2017-09-30 03:02:21.900492');
INSERT INTO pmieducar.backup VALUES (66, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-01_03-01-51.backup', '2017-10-01 03:02:17.665634');
INSERT INTO pmieducar.backup VALUES (67, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-02_03-02-01.backup', '2017-10-02 03:02:24.303286');
INSERT INTO pmieducar.backup VALUES (68, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-03_03-02-02.backup', '2017-10-03 03:02:27.402866');
INSERT INTO pmieducar.backup VALUES (69, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-04_03-02-13.backup', '2017-10-04 03:02:41.595197');
INSERT INTO pmieducar.backup VALUES (70, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-05_03-02-02.backup', '2017-10-05 03:02:24.172258');
INSERT INTO pmieducar.backup VALUES (71, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-06_03-02-05.backup', '2017-10-06 03:02:27.721378');
INSERT INTO pmieducar.backup VALUES (72, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-07_03-02-07.backup', '2017-10-07 03:02:33.449141');
INSERT INTO pmieducar.backup VALUES (73, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-08_03-02-11.backup', '2017-10-08 03:02:38.703066');
INSERT INTO pmieducar.backup VALUES (74, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-09_03-02-05.backup', '2017-10-09 03:02:30.46673');
INSERT INTO pmieducar.backup VALUES (75, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-10_03-02-07.backup', '2017-10-10 03:02:34.837989');
INSERT INTO pmieducar.backup VALUES (76, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-11_03-01-58.backup', '2017-10-11 03:02:23.912013');
INSERT INTO pmieducar.backup VALUES (77, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-12_03-01-57.backup', '2017-10-12 03:02:25.470964');
INSERT INTO pmieducar.backup VALUES (78, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-13_03-01-51.backup', '2017-10-13 03:02:11.61887');
INSERT INTO pmieducar.backup VALUES (79, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-14_03-01-58.backup', '2017-10-14 03:02:23.090849');
INSERT INTO pmieducar.backup VALUES (80, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-15_03-02-00.backup', '2017-10-15 03:02:22.670513');
INSERT INTO pmieducar.backup VALUES (81, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-16_03-01-56.backup', '2017-10-16 03:02:16.454784');
INSERT INTO pmieducar.backup VALUES (82, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-17_03-02-40.backup', '2017-10-17 03:03:03.445548');
INSERT INTO pmieducar.backup VALUES (83, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-18_03-01-54.backup', '2017-10-18 03:02:17.886933');
INSERT INTO pmieducar.backup VALUES (84, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-19_03-01-41.backup', '2017-10-19 03:02:02.106792');
INSERT INTO pmieducar.backup VALUES (85, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-20_03-02-17.backup', '2017-10-20 03:02:41.16369');
INSERT INTO pmieducar.backup VALUES (86, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-21_03-01-57.backup', '2017-10-21 03:02:17.79921');
INSERT INTO pmieducar.backup VALUES (87, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-22_03-01-59.backup', '2017-10-22 03:02:19.006087');
INSERT INTO pmieducar.backup VALUES (88, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-23_03-02-08.backup', '2017-10-23 03:02:28.23388');
INSERT INTO pmieducar.backup VALUES (89, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-24_03-02-00.backup', '2017-10-24 03:02:27.883077');
INSERT INTO pmieducar.backup VALUES (90, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-25_03-02-11.backup', '2017-10-25 03:02:31.777695');
INSERT INTO pmieducar.backup VALUES (91, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-26_03-02-14.backup', '2017-10-26 03:02:43.624362');
INSERT INTO pmieducar.backup VALUES (92, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-27_03-01-50.backup', '2017-10-27 03:02:19.433938');
INSERT INTO pmieducar.backup VALUES (93, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-28_03-01-57.backup', '2017-10-28 03:02:18.583897');
INSERT INTO pmieducar.backup VALUES (94, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-29_03-01-57.backup', '2017-10-29 03:02:15.546706');
INSERT INTO pmieducar.backup VALUES (95, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-30_03-01-49.backup', '2017-10-30 03:02:10.650243');
INSERT INTO pmieducar.backup VALUES (96, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-31_03-02-01.backup', '2017-10-31 03:02:30.769319');
INSERT INTO pmieducar.backup VALUES (97, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-01_03-01-57.backup', '2017-11-01 03:02:18.232342');
INSERT INTO pmieducar.backup VALUES (98, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-02_03-03-00.backup', '2017-11-02 03:03:41.399728');
INSERT INTO pmieducar.backup VALUES (99, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-03_03-02-05.backup', '2017-11-03 03:02:33.711542');
INSERT INTO pmieducar.backup VALUES (100, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-04_03-02-32.backup', '2017-11-04 03:03:05.092581');
INSERT INTO pmieducar.backup VALUES (101, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-05_03-02-25.backup', '2017-11-05 03:02:52.076044');
INSERT INTO pmieducar.backup VALUES (102, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-06_03-02-29.backup', '2017-11-06 03:02:59.016983');
INSERT INTO pmieducar.backup VALUES (103, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-07_03-02-07.backup', '2017-11-07 03:02:39.940655');
INSERT INTO pmieducar.backup VALUES (104, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-08_03-02-09.backup', '2017-11-08 03:02:42.180328');
INSERT INTO pmieducar.backup VALUES (105, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-09_03-02-03.backup', '2017-11-09 03:02:28.007138');
INSERT INTO pmieducar.backup VALUES (106, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-10_03-01-33.backup', '2017-11-10 03:01:56.542047');
INSERT INTO pmieducar.backup VALUES (107, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-11_03-01-54.backup', '2017-11-11 03:02:15.375696');
INSERT INTO pmieducar.backup VALUES (108, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-12_03-01-46.backup', '2017-11-12 03:02:17.185005');
INSERT INTO pmieducar.backup VALUES (109, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-13_03-01-44.backup', '2017-11-13 03:02:07.757993');
INSERT INTO pmieducar.backup VALUES (110, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-14_03-01-46.backup', '2017-11-14 03:02:14.074166');
INSERT INTO pmieducar.backup VALUES (111, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-15_03-01-50.backup', '2017-11-15 03:02:17.432019');
INSERT INTO pmieducar.backup VALUES (112, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-16_03-01-51.backup', '2017-11-16 03:02:16.888379');
INSERT INTO pmieducar.backup VALUES (113, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-17_03-01-56.backup', '2017-11-17 03:02:23.852404');
INSERT INTO pmieducar.backup VALUES (114, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-18_03-01-57.backup', '2017-11-18 03:02:22.853078');
INSERT INTO pmieducar.backup VALUES (115, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-19_03-01-45.backup', '2017-11-19 03:02:09.277979');
INSERT INTO pmieducar.backup VALUES (116, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-20_03-01-53.backup', '2017-11-20 03:02:18.576052');
INSERT INTO pmieducar.backup VALUES (117, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-21_03-01-55.backup', '2017-11-21 03:02:19.780649');
INSERT INTO pmieducar.backup VALUES (118, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-22_03-01-11.backup', '2017-11-22 03:01:37.863005');
INSERT INTO pmieducar.backup VALUES (119, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-23_03-03-04.backup', '2017-11-23 03:03:35.914205');
INSERT INTO pmieducar.backup VALUES (120, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-24_03-01-54.backup', '2017-11-24 03:02:23.862641');
INSERT INTO pmieducar.backup VALUES (121, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-25_03-01-51.backup', '2017-11-25 03:02:25.163622');
INSERT INTO pmieducar.backup VALUES (122, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-26_03-02-52.backup', '2017-11-26 03:03:20.314632');
INSERT INTO pmieducar.backup VALUES (123, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-27_03-01-55.backup', '2017-11-27 03:02:20.906006');
INSERT INTO pmieducar.backup VALUES (124, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-28_03-02-04.backup', '2017-11-28 03:02:25.117951');
INSERT INTO pmieducar.backup VALUES (125, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-29_03-01-39.backup', '2017-11-29 03:02:09.400795');
INSERT INTO pmieducar.backup VALUES (126, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-30_03-15-08.backup', '2017-11-30 03:16:02.262673');
INSERT INTO pmieducar.backup VALUES (127, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-01_03-01-51.backup', '2017-12-01 03:02:07.058599');
INSERT INTO pmieducar.backup VALUES (128, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-02_03-01-43.backup', '2017-12-02 03:02:02.774472');
INSERT INTO pmieducar.backup VALUES (129, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-03_03-01-50.backup', '2017-12-03 03:02:16.656903');
INSERT INTO pmieducar.backup VALUES (130, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-04_03-01-37.backup', '2017-12-04 03:02:03.916439');
INSERT INTO pmieducar.backup VALUES (131, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-05_03-01-38.backup', '2017-12-05 03:02:01.261207');
INSERT INTO pmieducar.backup VALUES (132, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-06_03-01-38.backup', '2017-12-06 03:01:59.354158');
INSERT INTO pmieducar.backup VALUES (133, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-07_03-01-32.backup', '2017-12-07 03:01:44.993236');
INSERT INTO pmieducar.backup VALUES (134, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-08_03-02-16.backup', '2017-12-08 03:02:33.350603');
INSERT INTO pmieducar.backup VALUES (135, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-09_03-01-57.backup', '2017-12-09 03:02:27.195024');
INSERT INTO pmieducar.backup VALUES (136, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-10_03-01-55.backup', '2017-12-10 03:02:15.839506');
INSERT INTO pmieducar.backup VALUES (137, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-11_03-01-50.backup', '2017-12-11 03:02:09.07906');
INSERT INTO pmieducar.backup VALUES (138, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-12_03-01-34.backup', '2017-12-12 03:01:52.506361');
INSERT INTO pmieducar.backup VALUES (139, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-13_03-01-46.backup', '2017-12-13 03:02:06.040887');
INSERT INTO pmieducar.backup VALUES (140, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-14_03-01-48.backup', '2017-12-14 03:02:07.634797');
INSERT INTO pmieducar.backup VALUES (141, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-15_03-01-54.backup', '2017-12-15 03:02:11.481136');
INSERT INTO pmieducar.backup VALUES (142, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-16_03-01-40.backup', '2017-12-16 03:02:03.777132');
INSERT INTO pmieducar.backup VALUES (143, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-17_03-01-53.backup', '2017-12-17 03:02:17.69098');
INSERT INTO pmieducar.backup VALUES (144, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-18_03-01-47.backup', '2017-12-18 03:02:13.062243');
INSERT INTO pmieducar.backup VALUES (145, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-19_03-01-55.backup', '2017-12-19 03:02:20.213328');
INSERT INTO pmieducar.backup VALUES (146, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-20_03-02-47.backup', '2017-12-20 03:03:17.802251');
INSERT INTO pmieducar.backup VALUES (147, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-21_03-01-51.backup', '2017-12-21 03:02:12.271007');
INSERT INTO pmieducar.backup VALUES (148, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-22_03-01-52.backup', '2017-12-22 03:02:14.747901');
INSERT INTO pmieducar.backup VALUES (149, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-23_03-01-53.backup', '2017-12-23 03:02:15.520008');
INSERT INTO pmieducar.backup VALUES (150, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-24_03-01-37.backup', '2017-12-24 03:02:04.98179');
INSERT INTO pmieducar.backup VALUES (151, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-25_03-01-39.backup', '2017-12-25 03:02:15.379474');
INSERT INTO pmieducar.backup VALUES (152, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-26_03-01-47.backup', '2017-12-26 03:02:13.713621');
INSERT INTO pmieducar.backup VALUES (153, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-27_03-01-39.backup', '2017-12-27 03:01:54.444998');
INSERT INTO pmieducar.backup VALUES (154, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-28_03-00-42.backup', '2017-12-28 03:01:13.093336');
INSERT INTO pmieducar.backup VALUES (155, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-29_03-01-07.backup', '2017-12-29 03:01:19.935801');
INSERT INTO pmieducar.backup VALUES (156, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-30_03-03-19.backup', '2017-12-30 03:03:47.169712');
INSERT INTO pmieducar.backup VALUES (157, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-31_03-02-10.backup', '2017-12-31 03:02:34.758227');
INSERT INTO pmieducar.backup VALUES (158, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-01_03-02-14.backup', '2018-01-01 03:02:40.812045');
INSERT INTO pmieducar.backup VALUES (159, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-02_03-02-07.backup', '2018-01-02 03:02:28.19197');
INSERT INTO pmieducar.backup VALUES (160, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-03_03-01-57.backup', '2018-01-03 03:02:13.135697');
INSERT INTO pmieducar.backup VALUES (161, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-04_03-00-45.backup', '2018-01-04 03:01:00.06465');
INSERT INTO pmieducar.backup VALUES (162, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-05_03-01-27.backup', '2018-01-05 03:01:46.738377');
INSERT INTO pmieducar.backup VALUES (163, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-06_03-00-48.backup', '2018-01-06 03:01:02.207831');
INSERT INTO pmieducar.backup VALUES (164, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-07_03-00-41.backup', '2018-01-07 03:00:52.425043');
INSERT INTO pmieducar.backup VALUES (165, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-08_03-01-25.backup', '2018-01-08 03:01:43.260496');
INSERT INTO pmieducar.backup VALUES (166, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-09_03-00-45.backup', '2018-01-09 03:01:04.002541');
INSERT INTO pmieducar.backup VALUES (167, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-10_03-00-49.backup', '2018-01-10 03:01:10.805381');
INSERT INTO pmieducar.backup VALUES (168, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-11_03-04-50.backup', '2018-01-11 03:05:42.306857');
INSERT INTO pmieducar.backup VALUES (169, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-12_03-01-57.backup', '2018-01-12 03:02:21.067395');
INSERT INTO pmieducar.backup VALUES (170, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-13_03-02-08.backup', '2018-01-13 03:02:35.124785');
INSERT INTO pmieducar.backup VALUES (171, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-14_03-02-27.backup', '2018-01-14 03:02:52.748563');
INSERT INTO pmieducar.backup VALUES (172, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-15_03-01-58.backup', '2018-01-15 03:02:24.48067');
INSERT INTO pmieducar.backup VALUES (173, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-16_03-01-46.backup', '2018-01-16 03:02:11.724163');
INSERT INTO pmieducar.backup VALUES (174, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-17_03-01-39.backup', '2018-01-17 03:01:57.651104');
INSERT INTO pmieducar.backup VALUES (175, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-18_03-01-49.backup', '2018-01-18 03:02:15.442958');
INSERT INTO pmieducar.backup VALUES (176, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-19_03-01-36.backup', '2018-01-19 03:02:04.381735');
INSERT INTO pmieducar.backup VALUES (177, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-20_03-01-40.backup', '2018-01-20 03:02:00.732719');
INSERT INTO pmieducar.backup VALUES (178, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-21_03-01-38.backup', '2018-01-21 03:02:01.731199');
INSERT INTO pmieducar.backup VALUES (179, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-22_03-01-33.backup', '2018-01-22 03:01:54.671287');
INSERT INTO pmieducar.backup VALUES (180, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-23_03-01-45.backup', '2018-01-23 03:02:02.04368');
INSERT INTO pmieducar.backup VALUES (181, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-24_03-18-37.backup', '2018-01-24 03:18:48.106534');
INSERT INTO pmieducar.backup VALUES (182, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-25_03-18-40.backup', '2018-01-25 03:18:50.740288');
INSERT INTO pmieducar.backup VALUES (183, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-26_03-18-38.backup', '2018-01-26 03:18:48.979649');
INSERT INTO pmieducar.backup VALUES (184, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-27_03-18-39.backup', '2018-01-27 03:18:48.522538');
INSERT INTO pmieducar.backup VALUES (185, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-28_03-18-36.backup', '2018-01-28 03:18:46.150181');
INSERT INTO pmieducar.backup VALUES (186, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-29_03-18-36.backup', '2018-01-29 03:18:48.960549');
INSERT INTO pmieducar.backup VALUES (187, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-30_03-18-36.backup', '2018-01-30 03:18:48.060504');
INSERT INTO pmieducar.backup VALUES (188, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-31_03-18-36.backup', '2018-01-31 03:18:47.64061');
INSERT INTO pmieducar.backup VALUES (189, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-01_03-18-37.backup', '2018-02-01 03:18:48.183625');
INSERT INTO pmieducar.backup VALUES (190, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-02_03-18-37.backup', '2018-02-02 03:18:48.658581');
INSERT INTO pmieducar.backup VALUES (191, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-03_03-18-40.backup', '2018-02-03 03:18:51.329829');
INSERT INTO pmieducar.backup VALUES (192, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-04_03-18-36.backup', '2018-02-04 03:18:47.841284');
INSERT INTO pmieducar.backup VALUES (193, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-05_03-18-39.backup', '2018-02-05 03:18:51.899691');
INSERT INTO pmieducar.backup VALUES (194, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-06_03-18-35.backup', '2018-02-06 03:18:46.103406');
INSERT INTO pmieducar.backup VALUES (195, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-07_03-18-38.backup', '2018-02-07 03:18:48.726103');
INSERT INTO pmieducar.backup VALUES (196, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-08_03-18-35.backup', '2018-02-08 03:18:46.004462');
INSERT INTO pmieducar.backup VALUES (197, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-09_03-18-35.backup', '2018-02-09 03:18:46.43811');
INSERT INTO pmieducar.backup VALUES (198, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-10_03-18-35.backup', '2018-02-10 03:18:45.692617');
INSERT INTO pmieducar.backup VALUES (199, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-11_03-18-35.backup', '2018-02-11 03:18:45.602062');
INSERT INTO pmieducar.backup VALUES (200, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-12_03-18-36.backup', '2018-02-12 03:18:46.164986');
INSERT INTO pmieducar.backup VALUES (201, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-13_03-18-34.backup', '2018-02-13 03:18:45.633627');
INSERT INTO pmieducar.backup VALUES (202, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-14_03-18-35.backup', '2018-02-14 03:18:45.790231');
INSERT INTO pmieducar.backup VALUES (203, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-15_03-18-33.backup', '2018-02-15 03:18:44.129354');
INSERT INTO pmieducar.backup VALUES (204, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-16_03-18-34.backup', '2018-02-16 03:18:45.184663');
INSERT INTO pmieducar.backup VALUES (205, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-17_03-18-38.backup', '2018-02-17 03:18:48.021263');
INSERT INTO pmieducar.backup VALUES (206, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-18_03-18-35.backup', '2018-02-18 03:18:45.656582');
INSERT INTO pmieducar.backup VALUES (207, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-19_03-18-35.backup', '2018-02-19 03:18:46.254113');
INSERT INTO pmieducar.backup VALUES (208, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-20_03-18-34.backup', '2018-02-20 03:18:44.210724');
INSERT INTO pmieducar.backup VALUES (209, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-21_03-18-35.backup', '2018-02-21 03:18:44.975107');
INSERT INTO pmieducar.backup VALUES (210, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-22_03-18-34.backup', '2018-02-22 03:18:45.235314');
INSERT INTO pmieducar.backup VALUES (211, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-23_03-18-35.backup', '2018-02-23 03:18:45.820392');
INSERT INTO pmieducar.backup VALUES (212, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-24_03-18-37.backup', '2018-02-24 03:18:47.477228');
INSERT INTO pmieducar.backup VALUES (213, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-25_03-18-36.backup', '2018-02-25 03:18:46.758077');
INSERT INTO pmieducar.backup VALUES (214, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-26_03-18-36.backup', '2018-02-26 03:18:46.333283');
INSERT INTO pmieducar.backup VALUES (215, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-27_03-18-36.backup', '2018-02-27 03:18:47.535309');
INSERT INTO pmieducar.backup VALUES (216, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-28_03-18-35.backup', '2018-02-28 03:18:46.058214');
INSERT INTO pmieducar.backup VALUES (217, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-01_03-18-35.backup', '2018-03-01 03:18:46.617894');
INSERT INTO pmieducar.backup VALUES (218, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-02_03-18-35.backup', '2018-03-02 03:18:45.085072');
INSERT INTO pmieducar.backup VALUES (219, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-03_03-18-35.backup', '2018-03-03 03:18:45.953686');
INSERT INTO pmieducar.backup VALUES (220, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-04_03-18-37.backup', '2018-03-04 03:18:46.614478');
INSERT INTO pmieducar.backup VALUES (221, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-05_03-18-37.backup', '2018-03-05 03:18:47.749563');
INSERT INTO pmieducar.backup VALUES (222, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-06_03-18-35.backup', '2018-03-06 03:18:46.404599');
INSERT INTO pmieducar.backup VALUES (223, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-07_03-18-35.backup', '2018-03-07 03:18:46.221971');
INSERT INTO pmieducar.backup VALUES (224, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-08_03-18-35.backup', '2018-03-08 03:18:44.934023');
INSERT INTO pmieducar.backup VALUES (225, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-09_03-18-34.backup', '2018-03-09 03:18:43.991153');
INSERT INTO pmieducar.backup VALUES (226, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-10_03-18-36.backup', '2018-03-10 03:18:46.063866');
INSERT INTO pmieducar.backup VALUES (227, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-11_03-18-35.backup', '2018-03-11 03:18:45.573358');
INSERT INTO pmieducar.backup VALUES (228, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-12_03-18-35.backup', '2018-03-12 03:18:46.305183');
INSERT INTO pmieducar.backup VALUES (229, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-13_03-20-10.backup', '2018-03-13 03:20:19.01923');
INSERT INTO pmieducar.backup VALUES (230, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-14_03-18-35.backup', '2018-03-14 03:18:45.706341');
INSERT INTO pmieducar.backup VALUES (231, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-15_03-18-34.backup', '2018-03-15 03:18:45.071549');
INSERT INTO pmieducar.backup VALUES (232, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-16_03-18-34.backup', '2018-03-16 03:18:44.913407');
INSERT INTO pmieducar.backup VALUES (233, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-17_03-18-34.backup', '2018-03-17 03:18:44.471153');
INSERT INTO pmieducar.backup VALUES (234, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-18_03-18-35.backup', '2018-03-18 03:18:47.146139');
INSERT INTO pmieducar.backup VALUES (235, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-19_03-18-35.backup', '2018-03-19 03:18:45.664928');
INSERT INTO pmieducar.backup VALUES (236, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-20_03-18-35.backup', '2018-03-20 03:18:45.712465');
INSERT INTO pmieducar.backup VALUES (237, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-21_03-18-42.backup', '2018-03-21 03:18:51.542749');
INSERT INTO pmieducar.backup VALUES (238, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-22_03-18-34.backup', '2018-03-22 03:18:45.258026');
INSERT INTO pmieducar.backup VALUES (239, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-23_03-18-35.backup', '2018-03-23 03:18:45.624248');
INSERT INTO pmieducar.backup VALUES (240, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-24_03-18-35.backup', '2018-03-24 03:18:45.031888');
INSERT INTO pmieducar.backup VALUES (241, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-25_03-18-34.backup', '2018-03-25 03:18:44.495077');
INSERT INTO pmieducar.backup VALUES (242, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-26_03-18-36.backup', '2018-03-26 03:18:46.329799');
INSERT INTO pmieducar.backup VALUES (243, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-27_03-18-35.backup', '2018-03-27 03:18:45.03986');
INSERT INTO pmieducar.backup VALUES (244, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-28_03-18-35.backup', '2018-03-28 03:18:45.960443');
INSERT INTO pmieducar.backup VALUES (245, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-29_03-18-34.backup', '2018-03-29 03:18:44.956622');
INSERT INTO pmieducar.backup VALUES (246, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-30_03-18-36.backup', '2018-03-30 03:18:46.231917');
INSERT INTO pmieducar.backup VALUES (247, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-31_03-18-34.backup', '2018-03-31 03:18:45.172706');
INSERT INTO pmieducar.backup VALUES (248, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/04/ieducar_pre_populado_2018-04-01_03-18-36.backup', '2018-04-01 03:18:46.999485');
INSERT INTO pmieducar.backup VALUES (249, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/04/ieducar_pre_populado_2018-04-02_03-18-34.backup', '2018-04-02 03:18:44.717166');
INSERT INTO pmieducar.backup VALUES (250, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/04/ieducar_pre_populado_2018-04-03_03-18-35.backup', '2018-04-03 03:18:45.897407');


--
-- TOC entry 8293 (class 0 OID 0)
-- Dependencies: 529
-- Name: backup_id_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.backup_id_seq', 250, true);


--
-- TOC entry 7820 (class 0 OID 9444353)
-- Dependencies: 531
-- Data for Name: biblioteca; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8294 (class 0 OID 0)
-- Dependencies: 530
-- Name: biblioteca_cod_biblioteca_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.biblioteca_cod_biblioteca_seq', 1, false);


--
-- TOC entry 7821 (class 0 OID 9444360)
-- Dependencies: 532
-- Data for Name: biblioteca_dia; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7823 (class 0 OID 9444365)
-- Dependencies: 534
-- Data for Name: biblioteca_feriados; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8295 (class 0 OID 0)
-- Dependencies: 533
-- Name: biblioteca_feriados_cod_feriado_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.biblioteca_feriados_cod_feriado_seq', 1, false);


--
-- TOC entry 7824 (class 0 OID 9444373)
-- Dependencies: 535
-- Data for Name: biblioteca_usuario; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7825 (class 0 OID 9444376)
-- Dependencies: 536
-- Data for Name: bloqueio_ano_letivo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7827 (class 0 OID 9444381)
-- Dependencies: 538
-- Data for Name: bloqueio_lancamento_faltas_notas; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7829 (class 0 OID 9444387)
-- Dependencies: 540
-- Data for Name: calendario_ano_letivo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8296 (class 0 OID 0)
-- Dependencies: 539
-- Name: calendario_ano_letivo_cod_calendario_ano_letivo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.calendario_ano_letivo_cod_calendario_ano_letivo_seq', 1, false);


--
-- TOC entry 7831 (class 0 OID 9444394)
-- Dependencies: 542
-- Data for Name: calendario_anotacao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8297 (class 0 OID 0)
-- Dependencies: 541
-- Name: calendario_anotacao_cod_calendario_anotacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.calendario_anotacao_cod_calendario_anotacao_seq', 1, false);


--
-- TOC entry 7832 (class 0 OID 9444401)
-- Dependencies: 543
-- Data for Name: calendario_dia; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7833 (class 0 OID 9444408)
-- Dependencies: 544
-- Data for Name: calendario_dia_anotacao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7835 (class 0 OID 9444413)
-- Dependencies: 546
-- Data for Name: calendario_dia_motivo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8298 (class 0 OID 0)
-- Dependencies: 545
-- Name: calendario_dia_motivo_cod_calendario_dia_motivo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.calendario_dia_motivo_cod_calendario_dia_motivo_seq', 1, false);


--
-- TOC entry 7837 (class 0 OID 9444423)
-- Dependencies: 548
-- Data for Name: candidato_reserva_vaga; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8299 (class 0 OID 0)
-- Dependencies: 547
-- Name: candidato_reserva_vaga_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.candidato_reserva_vaga_seq', 1, false);


--
-- TOC entry 7839 (class 0 OID 9444432)
-- Dependencies: 550
-- Data for Name: categoria_nivel; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8300 (class 0 OID 0)
-- Dependencies: 549
-- Name: categoria_nivel_cod_categoria_nivel_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.categoria_nivel_cod_categoria_nivel_seq', 1, false);


--
-- TOC entry 7840 (class 0 OID 9444437)
-- Dependencies: 551
-- Data for Name: categoria_obra; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8301 (class 0 OID 0)
-- Dependencies: 552
-- Name: categoria_obra_id_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.categoria_obra_id_seq', 1, false);


--
-- TOC entry 7843 (class 0 OID 9444444)
-- Dependencies: 554
-- Data for Name: cliente; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8302 (class 0 OID 0)
-- Dependencies: 553
-- Name: cliente_cod_cliente_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.cliente_cod_cliente_seq', 1, false);


--
-- TOC entry 7844 (class 0 OID 9444452)
-- Dependencies: 555
-- Data for Name: cliente_suspensao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7846 (class 0 OID 9444457)
-- Dependencies: 557
-- Data for Name: cliente_tipo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7847 (class 0 OID 9444465)
-- Dependencies: 558
-- Data for Name: cliente_tipo_cliente; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8303 (class 0 OID 0)
-- Dependencies: 556
-- Name: cliente_tipo_cod_cliente_tipo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.cliente_tipo_cod_cliente_tipo_seq', 1, false);


--
-- TOC entry 7848 (class 0 OID 9444469)
-- Dependencies: 559
-- Data for Name: cliente_tipo_exemplar_tipo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7850 (class 0 OID 9444474)
-- Dependencies: 561
-- Data for Name: coffebreak_tipo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8304 (class 0 OID 0)
-- Dependencies: 560
-- Name: coffebreak_tipo_cod_coffebreak_tipo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.coffebreak_tipo_cod_coffebreak_tipo_seq', 1, false);


--
-- TOC entry 7851 (class 0 OID 9444482)
-- Dependencies: 562
-- Data for Name: configuracoes_gerais; Type: TABLE DATA; Schema: pmieducar; Owner: -
--

INSERT INTO pmieducar.configuracoes_gerais VALUES (1, 1, NULL, 1, 1, NULL, 1, NULL, NULL, 1, NULL, NULL, '<p>Portabilis Tecnologia - suporte@portabilis.com.br - <a class="   light" href="http://suporte.portabilis.com.br" target="_blank"> Obter Suporte </a></p> ', '<p>Conhe&ccedil;a mais sobre o i-Educar e a Portabilis, acesse nosso <a href="   http://blog.portabilis.com.br">blog</a></p> ', '<p>Conhe&ccedil;a mais sobre o i-Educar e a Portabilis, <a href="   http://blog.portabilis.com.br" target="_blank">acesse nosso blog</a> &nbsp;&nbsp;&nbsp; &copy; Portabilis - Todos os direitos reservados</p>', 'https://www.facebook.com/portabilis', 'https://twitter.com/portabilis', 'https://www.linkedin.com/company/portabilis-tecnologia', NULL);


--
-- TOC entry 7853 (class 0 OID 9444488)
-- Dependencies: 564
-- Data for Name: curso; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8305 (class 0 OID 0)
-- Dependencies: 563
-- Name: curso_cod_curso_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.curso_cod_curso_seq', 1, true);


--
-- TOC entry 7855 (class 0 OID 9444500)
-- Dependencies: 566
-- Data for Name: disciplina; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8306 (class 0 OID 0)
-- Dependencies: 565
-- Name: disciplina_cod_disciplina_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.disciplina_cod_disciplina_seq', 1, false);


--
-- TOC entry 7856 (class 0 OID 9444509)
-- Dependencies: 567
-- Data for Name: disciplina_dependencia; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7857 (class 0 OID 9444515)
-- Dependencies: 568
-- Data for Name: disciplina_serie; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7859 (class 0 OID 9444521)
-- Dependencies: 570
-- Data for Name: disciplina_topico; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8307 (class 0 OID 0)
-- Dependencies: 569
-- Name: disciplina_topico_cod_disciplina_topico_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.disciplina_topico_cod_disciplina_topico_seq', 1, false);


--
-- TOC entry 7860 (class 0 OID 9444529)
-- Dependencies: 571
-- Data for Name: dispensa_disciplina; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8308 (class 0 OID 0)
-- Dependencies: 851
-- Name: dispensa_disciplina_cod_dispensa_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.dispensa_disciplina_cod_dispensa_seq', 1, true);


--
-- TOC entry 7861 (class 0 OID 9444536)
-- Dependencies: 572
-- Data for Name: dispensa_etapa; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7863 (class 0 OID 9444541)
-- Dependencies: 574
-- Data for Name: distribuicao_uniforme; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8309 (class 0 OID 0)
-- Dependencies: 573
-- Name: distribuicao_uniforme_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.distribuicao_uniforme_seq', 1, false);


--
-- TOC entry 7865 (class 0 OID 9444547)
-- Dependencies: 576
-- Data for Name: escola; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7866 (class 0 OID 9444562)
-- Dependencies: 577
-- Data for Name: escola_ano_letivo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8310 (class 0 OID 0)
-- Dependencies: 575
-- Name: escola_cod_escola_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.escola_cod_escola_seq', 1, true);


--
-- TOC entry 7867 (class 0 OID 9444567)
-- Dependencies: 578
-- Data for Name: escola_complemento; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7868 (class 0 OID 9444574)
-- Dependencies: 579
-- Data for Name: escola_curso; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7870 (class 0 OID 9444580)
-- Dependencies: 581
-- Data for Name: escola_localizacao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--

INSERT INTO pmieducar.escola_localizacao VALUES (1, NULL, 1, 'Urbana', '2010-12-22 17:08:47.218', NULL, 1, 1);
INSERT INTO pmieducar.escola_localizacao VALUES (2, NULL, 1, 'Rural', '2010-12-22 17:08:50.812', NULL, 1, 1);


--
-- TOC entry 8311 (class 0 OID 0)
-- Dependencies: 580
-- Name: escola_localizacao_cod_escola_localizacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.escola_localizacao_cod_escola_localizacao_seq', 1, true);


--
-- TOC entry 7872 (class 0 OID 9444587)
-- Dependencies: 583
-- Data for Name: escola_rede_ensino; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8312 (class 0 OID 0)
-- Dependencies: 582
-- Name: escola_rede_ensino_cod_escola_rede_ensino_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.escola_rede_ensino_cod_escola_rede_ensino_seq', 1, true);


--
-- TOC entry 7873 (class 0 OID 9444592)
-- Dependencies: 584
-- Data for Name: escola_serie; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7874 (class 0 OID 9444596)
-- Dependencies: 585
-- Data for Name: escola_serie_disciplina; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7875 (class 0 OID 9444603)
-- Dependencies: 586
-- Data for Name: escola_usuario; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8313 (class 0 OID 0)
-- Dependencies: 587
-- Name: escola_usuario_id_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.escola_usuario_id_seq', 1, false);


--
-- TOC entry 7878 (class 0 OID 9444610)
-- Dependencies: 589
-- Data for Name: exemplar; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8314 (class 0 OID 0)
-- Dependencies: 588
-- Name: exemplar_cod_exemplar_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.exemplar_cod_exemplar_seq', 1, false);


--
-- TOC entry 7880 (class 0 OID 9444618)
-- Dependencies: 591
-- Data for Name: exemplar_emprestimo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8315 (class 0 OID 0)
-- Dependencies: 590
-- Name: exemplar_emprestimo_cod_emprestimo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.exemplar_emprestimo_cod_emprestimo_seq', 1, false);


--
-- TOC entry 7882 (class 0 OID 9444624)
-- Dependencies: 593
-- Data for Name: exemplar_tipo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8316 (class 0 OID 0)
-- Dependencies: 592
-- Name: exemplar_tipo_cod_exemplar_tipo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.exemplar_tipo_cod_exemplar_tipo_seq', 1, false);


--
-- TOC entry 7884 (class 0 OID 9444634)
-- Dependencies: 595
-- Data for Name: falta_aluno; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8317 (class 0 OID 0)
-- Dependencies: 594
-- Name: falta_aluno_cod_falta_aluno_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.falta_aluno_cod_falta_aluno_seq', 1, false);


--
-- TOC entry 7886 (class 0 OID 9444641)
-- Dependencies: 597
-- Data for Name: falta_atraso; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8318 (class 0 OID 0)
-- Dependencies: 596
-- Name: falta_atraso_cod_falta_atraso_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.falta_atraso_cod_falta_atraso_seq', 1, false);


--
-- TOC entry 7888 (class 0 OID 9444649)
-- Dependencies: 599
-- Data for Name: falta_atraso_compensado; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8319 (class 0 OID 0)
-- Dependencies: 598
-- Name: falta_atraso_compensado_cod_compensado_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.falta_atraso_compensado_cod_compensado_seq', 1, false);


--
-- TOC entry 7890 (class 0 OID 9444656)
-- Dependencies: 601
-- Data for Name: faltas; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8320 (class 0 OID 0)
-- Dependencies: 600
-- Name: faltas_sequencial_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.faltas_sequencial_seq', 1, false);


--
-- TOC entry 7892 (class 0 OID 9444662)
-- Dependencies: 603
-- Data for Name: fonte; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8321 (class 0 OID 0)
-- Dependencies: 602
-- Name: fonte_cod_fonte_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.fonte_cod_fonte_seq', 1, false);


--
-- TOC entry 7894 (class 0 OID 9444672)
-- Dependencies: 605
-- Data for Name: funcao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8322 (class 0 OID 0)
-- Dependencies: 604
-- Name: funcao_cod_funcao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.funcao_cod_funcao_seq', 1, false);


--
-- TOC entry 7896 (class 0 OID 9444680)
-- Dependencies: 607
-- Data for Name: habilitacao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8323 (class 0 OID 0)
-- Dependencies: 606
-- Name: habilitacao_cod_habilitacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.habilitacao_cod_habilitacao_seq', 1, false);


--
-- TOC entry 7897 (class 0 OID 9444688)
-- Dependencies: 608
-- Data for Name: habilitacao_curso; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7898 (class 0 OID 9444691)
-- Dependencies: 609
-- Data for Name: historico_disciplinas; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7899 (class 0 OID 9444698)
-- Dependencies: 610
-- Data for Name: historico_educar; Type: TABLE DATA; Schema: pmieducar; Owner: -
--

INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999101,1,0,1)', '2010-09-02 11:14:32.625', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999103,1,0,1)', '2010-09-02 11:14:56.531', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999104,1,0,1)', '2010-09-02 11:15:23.484', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999200,1,0,1)', '2010-09-02 11:15:45.937', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999102,1,0,1)', '2010-09-02 11:16:10.546', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999100,1,0,1)', '2010-09-02 11:16:31.671', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999201,1,0,1)', '2010-09-02 11:17:04.531', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999202,1,0,1)', '2010-09-02 11:17:24.25', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999203,1,0,1)', '2010-09-02 11:17:49.14', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999204,1,0,1)', '2010-09-02 11:18:11.921', 1);
INSERT INTO pmieducar.historico_educar VALUES ('instituicao', '(1,,1,RUA,SC,88900000,Araranguá,Centro,"Rua Dr. Virgulino de Queiróz",200,Centro,"Prefeitura Municipal de Araranguá",48,35210956,"2010-01-04 08:00:00","2010-09-02 12:52:50.312",1,"Prefeitura Municipal de Araranguá")', '2010-09-02 12:52:50.312', 0);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999105,1,0,1)', '2010-10-19 18:04:02.701', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999106,1,0,1)', '2010-12-07 08:14:17.562', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999205,1,0,1)', '2010-12-07 08:14:38.171', 1);
INSERT INTO pmieducar.historico_educar VALUES ('escola_localizacao', '(1,,1,Urbana,"2010-12-22 17:08:47.218",,1,1)', '2010-12-22 17:08:47.218', 1);
INSERT INTO pmieducar.historico_educar VALUES ('escola_localizacao', '(2,,1,Rural,"2010-12-22 17:08:50.812",,1,1)', '2010-12-22 17:08:50.812', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999501,1,0,1)', '2011-07-22 11:14:45.057', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999502,1,0,1)', '2011-07-22 11:14:45.057', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999503,1,0,1)', '2011-07-22 11:14:45.057', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999504,1,0,1)', '2011-07-22 11:14:45.057', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999505,1,0,1)', '2011-07-22 11:14:45.057', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999506,1,0,1)', '2011-07-22 11:14:45.057', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999505,1,0,1)', '2011-07-22 11:15:06.578', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999507,1,0,1)', '2011-07-22 11:15:06.578', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999506,1,0,1)', '2011-07-22 11:15:06.578', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999200,1,0,1)', '2011-07-22 11:15:06.578', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999215,1,0,1)', '2011-07-22 11:15:06.578', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999216,1,0,1)', '2011-07-22 11:15:32.193', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999107,1,0,1)', '2011-07-22 11:15:32.193', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999217,1,0,1)', '2011-07-22 11:15:32.193', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999601,1,0,1)', '2011-07-22 11:16:01.977', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999602,1,0,1)', '2011-07-22 11:16:01.977', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,643,1,0,1)', '2011-07-22 11:16:28.456', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,644,1,0,1)', '2011-07-22 11:16:28.456', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999218,1,0,1)', '2011-07-22 11:16:45.716', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999219,1,0,1)', '2011-07-22 11:17:46.858', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999108,1,0,1)', '2011-07-22 11:17:46.858', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999109,1,0,1)', '2011-07-22 11:18:26.994', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999220,1,0,1)', '2011-07-22 11:18:48.767', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999221,1,0,1)', '2011-07-22 11:19:07.215', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999224,1,0,1)', '2011-07-22 11:19:28.688', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999206,1,0,1)', '2011-07-22 11:19:45.069', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999605,1,0,1)', '2011-07-22 11:19:45.069', 1);
INSERT INTO pmieducar.historico_educar VALUES ('instituicao', '(1,,1,RUA,SC,88820000,Modelópolis,Centro,"Rua João Paulo Segundo",2011,Centro,"Secretaria de Educação e Cultura",48,99999999,"2010-01-04 08:00:00","2011-07-22 11:24:02.914",1,"Prefeitura Municipal de Modelópolis")', '2011-07-22 11:24:02.914', 0);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999606,1,0,1)', '2011-11-19 11:36:58.50777', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999607,1,0,1)', '2011-11-19 11:36:58.50777', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999610,1,0,1)', '2011-11-19 11:37:32.304272', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999611,1,0,1)', '2011-11-19 11:37:32.304272', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999608,1,0,1)', '2011-11-19 11:37:52.570095', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999609,1,0,1)', '2011-11-19 11:37:52.570095', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999612,1,0,1)', '2011-11-19 11:38:15.408076', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999613,1,0,1)', '2012-06-22 16:27:11.94276', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999615,1,0,1)', '2012-06-22 16:31:36.620354', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999616,1,0,1)', '2012-06-22 16:31:36.620354', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999617,1,0,1)', '2012-06-22 16:31:36.620354', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999618,1,0,1)', '2012-06-22 16:31:36.620354', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999619,1,0,1)', '2012-06-22 16:31:36.620354', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999620,1,0,1)', '2012-06-22 16:31:36.620354', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999621,1,0,1)', '2012-06-22 16:31:36.620354', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999622,1,0,1)', '2012-06-22 16:31:36.620354', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999612,1,0,1)', '2014-01-07 19:02:23.592375', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,950,1,1,1)', '2014-07-18 10:40:06.877894', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,554,1,1,1)', '2014-12-02 14:39:24.548014', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999814,1,1,1)', '2014-12-08 10:19:18.276064', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,644,1,1,1)', '2014-12-09 11:52:03.368718', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21247,1,0,1)', '2015-01-15 20:29:28.137685', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21246,1,0,1)', '2015-01-27 09:15:05.808245', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21248,1,1,1)', '2015-02-04 14:05:17.895103', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,626,1,1,1)', '2015-02-17 11:51:44.947342', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21249,1,0,1)', '2015-02-17 11:51:44.971294', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999815,1,1,1)', '2015-02-20 16:26:31.739166', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999816,1,1,1)', '2015-03-03 18:19:48.689871', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,627,1,1,1)', '2015-04-02 09:59:41.187518', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21252,1,1,1)', '2015-04-06 13:56:29.435332', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999819,1,0,1)', '2015-06-15 23:58:27.676051', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999820,1,0,1)', '2015-06-30 22:14:58.625444', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999821,1,1,1)', '2015-06-30 22:14:58.639629', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999822,1,1,1)', '2015-06-30 22:14:58.64117', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999823,1,0,1)', '2015-07-17 09:51:19.440927', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999824,1,1,1)', '2015-07-20 09:34:48.277355', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999825,1,0,1)', '2015-08-02 22:14:35.724936', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999826,1,0,1)', '2015-08-02 22:14:35.728868', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999829,1,0,1)', '2015-08-17 18:31:19.930622', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999828,1,0,1)', '2015-08-26 15:35:27.060486', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999830,1,0,1)', '2015-08-31 23:55:01.077127', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999832,1,0,1)', '2015-08-31 23:55:01.087613', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999233,1,1,1)', '2015-09-17 17:04:57.188296', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999833,1,1,1)', '2015-09-20 22:44:29.226121', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999834,1,0,1)', '2015-09-20 22:44:29.235057', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999509,1,1,1)', '2015-09-21 14:27:45.310515', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999612,1,1,1)', '2015-09-21 14:59:55.052653', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999840,1,1,1)', '2015-10-01 11:27:32.978085', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999841,1,1,1)', '2015-10-17 17:50:11.414165', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999842,1,1,1)', '2015-10-17 17:50:11.423287', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999843,1,0,1)', '2015-10-30 20:54:01.523043', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999844,1,1,1)', '2015-10-30 20:54:01.538511', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999845,1,1,1)', '2015-10-30 20:54:01.540008', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999846,1,1,1)', '2015-12-02 02:10:44.263456', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999847,1,1,1)', '2015-12-02 02:10:44.311096', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,630,1,1,1)', '2015-12-02 02:10:44.337394', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999848,1,1,1)', '2016-01-13 15:23:23.393198', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999849,1,1,1)', '2016-01-13 15:23:23.454429', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999851,1,1,1)', '2016-01-13 15:23:23.487376', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999853,1,1,1)', '2016-01-13 15:23:23.489167', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999854,1,1,1)', '2016-01-25 10:26:29.732882', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999855,1,1,1)', '2016-02-07 17:25:00.024842', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999856,1,1,1)', '2016-03-18 18:05:31.806589', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999857,1,1,1)', '2016-03-28 09:29:10.763154', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999859,1,0,1)', '2016-04-04 08:35:02.498838', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999860,1,0,1)', '2016-04-11 08:27:48.534095', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999862,1,1,1)', '2016-04-25 08:20:16.356346', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999863,1,1,1)', '2016-05-09 09:08:29.088534', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999861,1,1,1)', '2016-05-16 21:36:23.877159', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999864,1,1,1)', '2016-05-24 08:35:28.524312', 1);
INSERT INTO pmieducar.historico_educar VALUES ('instituicao', '(1,,1,RUA,SC,88820000,Modelópolis,Centro,"Rua João Paulo Segundo",2011,Centro,"Secretaria de Educação e Cultura",48,99999999,"2010-01-04 08:00:00","2011-07-22 11:24:02.914",1,"Prefeitura Municipal de Modelópolis",,,,,,,,,,,,,,f,f,,,t)', '2016-05-30 17:39:48.708257', 0);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999867,1,1,1)', '2016-05-30 17:39:48.784145', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999869,1,1,1)', '2016-06-28 18:52:27.037308', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,846,1,1,1)', '2016-07-06 09:20:26.571425', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999870,1,1,1)', '2016-07-26 10:37:12.045714', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999871,1,1,1)', '2016-08-08 08:52:12.013263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999872,1,1,1)', '2016-08-17 09:12:15.490281', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999873,1,1,1)', '2016-08-29 16:31:21.220176', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999874,1,1,1)', '2016-09-01 14:47:45.937241', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999876,1,1,1)', '2016-09-20 09:02:28.590762', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999876,1,1,1)', '2016-09-20 09:16:49.810644', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999877,1,1,1)', '2016-09-28 09:32:19.795068', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,0,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,43,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,41,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,155,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,157,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,475,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,753,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,754,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,945,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,755,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,756,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,757,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,758,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,335,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,829,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,568,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,569,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,561,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,570,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,558,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,562,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,571,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,563,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,566,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,567,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,576,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,573,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,575,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,577,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,578,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,579,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,559,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,580,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,581,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,583,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,631,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,585,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,586,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,587,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,620,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,624,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,584,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,632,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,759,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,633,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,634,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,635,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,946,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,641,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,647,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,659,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,678,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,845,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,592,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,594,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,603,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,590,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,591,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,593,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,595,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,596,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,597,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,606,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,600,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,602,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,598,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,607,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,608,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,609,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,622,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,625,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,628,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,629,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,947,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,948,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,949,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,341,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,343,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,345,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,610,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21234,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21235,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21236,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21237,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21238,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21239,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21240,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21241,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,642,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999801,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999802,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999803,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999804,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21242,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999219,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999220,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999221,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999222,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999223,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999810,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999812,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999225,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999226,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999227,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999508,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999229,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21243,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999231,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999110,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999232,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21250,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21251,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,572,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,574,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999228,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999234,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999235,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999236,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999651,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999652,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,760,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999237,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999654,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,555,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999603,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999238,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999806,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999239,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999808,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999809,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999805,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999224,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999813,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,761,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,762,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,639,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999218,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999817,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999818,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999244,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21253,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999230,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999878,1,1,1)', '2016-10-07 09:04:33.61113', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999879,1,1,1)', '2016-10-27 11:05:43.98123', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999881,1,1,1)', '2016-10-28 16:24:09.345619', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999882,1,1,1)', '2016-11-28 11:40:37.02263', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999883,1,1,1)', '2016-12-06 15:19:24.825213', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999884,1,1,1)', '2016-12-13 17:56:28.840356', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999887,1,1,1)', '2017-02-01 09:32:10.717784', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999886,1,1,1)', '2017-02-01 10:11:39.180167', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999889,1,1,1)', '2017-02-20 10:09:07.375952', 1);
INSERT INTO pmieducar.historico_educar VALUES ('instituicao', '(1,,1,RUA,SC,88820000,Modelópolis,Centro,"Rua João Paulo Segundo",2011,Centro,"Secretaria de Educação e Cultura",48,99999999,"2010-01-04 08:00:00","2011-07-22 11:24:02.914",1,"Prefeitura Municipal de Modelópolis",,,,,,,,,,,,,,f,f,,,t,,,,f)', '2017-03-07 17:02:47.491663', 0);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999890,1,1,1)', '2017-03-31 17:09:44.931441', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999832,1,1,1)', '2017-04-01 05:19:04.547169', 0);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999820,1,1,1)', '2017-04-01 05:19:04.670125', 0);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999860,1,1,1)', '2017-04-01 05:19:04.670125', 0);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999874,1,1,1)', '2017-04-01 05:19:04.670125', 0);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,21145,1,1,1)', '2017-04-01 05:19:04.681312', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999859,1,1,1)', '2017-04-01 05:19:04.772938', 0);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998850,1,1,1)', '2017-04-18 18:07:20.652225', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,999891,1,1,1)', '2017-05-08 12:28:43.743157', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998851,1,1,1)', '2017-05-12 14:42:44.398162', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998852,1,1,1)', '2017-06-21 17:54:01.945054', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998853,1,1,1)', '2017-06-26 15:42:20.388422', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998858,1,1,1)', '2017-07-27 09:36:50.350403', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998849,1,1,1)', '2017-08-15 09:09:43.025897', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998859,1,1,1)', '2017-09-13 15:43:50.215045', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998860,1,1,1)', '2017-11-28 07:48:08.788494', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998857,1,1,1)', '2017-12-01 15:32:09.672494', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998855,1,1,1)', '2017-12-01 15:32:09.739552', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998862,1,1,1)', '2017-12-13 09:00:26.781581', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998865,1,1,1)', '2018-03-05 11:19:39.9654', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998866,1,1,1)', '2018-03-16 09:22:27.083225', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998867,1,1,1)', '2018-11-19 15:00:22.877079', 1);
INSERT INTO pmieducar.historico_educar VALUES ('instituicao', '(1,,1,RUA,SC,88820000,Modelópolis,Centro,"Rua João Paulo Segundo",2011,Centro,"Secretaria de Educação e Cultura",48,99999999,"2010-01-04 08:00:00","2011-07-22 11:24:02.914",1,"Prefeitura Municipal de Modelópolis",,,,,,,,,,,,,,f,f,,,t,,,,f,f,f,,)', '2018-11-19 15:00:23.033704', 0);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998869,1,1,1)', '2018-11-19 15:00:25.499012', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998878,1,1,1)', '2018-11-19 15:00:26.002687', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998900,1,1,1)', '2018-11-19 15:00:27.069351', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,9998910,1,1,1)', '2018-11-19 15:00:27.069351', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,190,1,1,1)', '2018-11-19 15:00:27.192492', 1);
INSERT INTO pmieducar.historico_educar VALUES ('menu_tipo_usuario', '(1,190,1,1,1)', '2018-11-19 15:01:06.500551', 1);


--
-- TOC entry 7900 (class 0 OID 9444705)
-- Dependencies: 611
-- Data for Name: historico_escolar; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7902 (class 0 OID 9444718)
-- Dependencies: 613
-- Data for Name: historico_grade_curso; Type: TABLE DATA; Schema: pmieducar; Owner: -
--

INSERT INTO pmieducar.historico_grade_curso VALUES (1, 'Série', '1990-12-30 00:00:00', NULL, 8, 1);
INSERT INTO pmieducar.historico_grade_curso VALUES (2, 'Ano', '1990-12-30 00:00:00', NULL, 9, 1);
INSERT INTO pmieducar.historico_grade_curso VALUES (3, 'EJA', '2017-01-04 14:48:26.233581', NULL, NULL, 1);


--
-- TOC entry 8324 (class 0 OID 0)
-- Dependencies: 612
-- Name: historico_grade_curso_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.historico_grade_curso_seq', 3, false);


--
-- TOC entry 7904 (class 0 OID 9444725)
-- Dependencies: 615
-- Data for Name: infra_comodo_funcao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8325 (class 0 OID 0)
-- Dependencies: 614
-- Name: infra_comodo_funcao_cod_infra_comodo_funcao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.infra_comodo_funcao_cod_infra_comodo_funcao_seq', 1, true);


--
-- TOC entry 7906 (class 0 OID 9444735)
-- Dependencies: 617
-- Data for Name: infra_predio; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8326 (class 0 OID 0)
-- Dependencies: 616
-- Name: infra_predio_cod_infra_predio_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.infra_predio_cod_infra_predio_seq', 1, true);


--
-- TOC entry 7908 (class 0 OID 9444745)
-- Dependencies: 619
-- Data for Name: infra_predio_comodo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8327 (class 0 OID 0)
-- Dependencies: 618
-- Name: infra_predio_comodo_cod_infra_predio_comodo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.infra_predio_comodo_cod_infra_predio_comodo_seq', 1, true);


--
-- TOC entry 7910 (class 0 OID 9444755)
-- Dependencies: 621
-- Data for Name: instituicao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--

INSERT INTO pmieducar.instituicao VALUES (1, NULL, 1, 'RUA', 'SC', 88820000, 'Modelópolis', 'Centro', 'Rua João Paulo Segundo', 2011, 'Centro', 'Secretaria de Educação e Cultura', 48, 99999999, '2010-01-04 08:00:00', '2011-07-22 11:24:02.914', 1, 'Prefeitura Municipal de Modelópolis', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, false, false, NULL, NULL, true, NULL, NULL, NULL, false, false, false, NULL, NULL, NULL, false, false, false);


--
-- TOC entry 8328 (class 0 OID 0)
-- Dependencies: 620
-- Name: instituicao_cod_instituicao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.instituicao_cod_instituicao_seq', 1, true);


--
-- TOC entry 7912 (class 0 OID 9444769)
-- Dependencies: 623
-- Data for Name: instituicao_documentacao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8329 (class 0 OID 0)
-- Dependencies: 622
-- Name: instituicao_documentacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.instituicao_documentacao_seq', 2, false);


--
-- TOC entry 7914 (class 0 OID 9444776)
-- Dependencies: 625
-- Data for Name: material_didatico; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8330 (class 0 OID 0)
-- Dependencies: 624
-- Name: material_didatico_cod_material_didatico_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.material_didatico_cod_material_didatico_seq', 1, false);


--
-- TOC entry 7916 (class 0 OID 9444786)
-- Dependencies: 627
-- Data for Name: material_tipo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8331 (class 0 OID 0)
-- Dependencies: 626
-- Name: material_tipo_cod_material_tipo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.material_tipo_cod_material_tipo_seq', 1, false);


--
-- TOC entry 7918 (class 0 OID 9444796)
-- Dependencies: 629
-- Data for Name: matricula; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8332 (class 0 OID 0)
-- Dependencies: 628
-- Name: matricula_cod_matricula_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.matricula_cod_matricula_seq', 2, true);


--
-- TOC entry 7920 (class 0 OID 9444814)
-- Dependencies: 631
-- Data for Name: matricula_excessao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8333 (class 0 OID 0)
-- Dependencies: 630
-- Name: matricula_excessao_cod_aluno_excessao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.matricula_excessao_cod_aluno_excessao_seq', 1, false);


--
-- TOC entry 7922 (class 0 OID 9444820)
-- Dependencies: 633
-- Data for Name: matricula_ocorrencia_disciplinar; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7923 (class 0 OID 9444828)
-- Dependencies: 634
-- Data for Name: matricula_turma; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7924 (class 0 OID 9444833)
-- Dependencies: 635
-- Data for Name: menu_tipo_usuario; Type: TABLE DATA; Schema: pmieducar; Owner: -
--

INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 999613, 1, 0, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 950, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 554, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 644, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 21246, 1, 0, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 626, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 627, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 999848, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 999847, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 630, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 999849, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 999861, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 999867, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 999869, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 846, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 999873, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 0, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 43, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 41, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 155, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 157, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 753, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 754, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 945, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 755, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 756, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 757, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 758, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 829, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 568, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 569, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 561, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 570, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 558, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 562, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 571, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 563, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 566, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 567, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 576, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 573, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 575, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 577, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 578, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 579, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 559, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 580, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 581, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 583, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 631, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 585, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 586, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 587, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 620, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 624, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 584, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 632, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 759, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 633, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 634, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 635, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 946, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 641, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 647, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 659, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 678, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 845, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 592, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 594, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 603, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 590, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 591, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 593, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 595, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 596, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 597, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 606, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 600, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 602, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 598, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 607, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 608, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 609, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 622, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 625, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 628, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 629, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 947, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 948, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 949, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 341, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 343, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 345, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 610, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 21234, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 21235, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 21236, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 21237, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 21238, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 21239, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 21240, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 642, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 21250, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 21251, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 572, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 574, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 760, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 555, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 761, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 762, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 21253, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 999878, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 21145, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 9998851, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 9998858, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 9998849, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 9998859, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 9998867, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 9998869, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 9998878, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 9998900, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 9998910, 1, 1, 1);
INSERT INTO pmieducar.menu_tipo_usuario VALUES (1, 190, 1, 1, 1);


--
-- TOC entry 7926 (class 0 OID 9444841)
-- Dependencies: 637
-- Data for Name: modulo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8334 (class 0 OID 0)
-- Dependencies: 636
-- Name: modulo_cod_modulo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.modulo_cod_modulo_seq', 1, true);


--
-- TOC entry 7928 (class 0 OID 9444851)
-- Dependencies: 639
-- Data for Name: motivo_afastamento; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8335 (class 0 OID 0)
-- Dependencies: 638
-- Name: motivo_afastamento_cod_motivo_afastamento_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.motivo_afastamento_cod_motivo_afastamento_seq', 1, false);


--
-- TOC entry 7930 (class 0 OID 9444861)
-- Dependencies: 641
-- Data for Name: motivo_baixa; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8336 (class 0 OID 0)
-- Dependencies: 640
-- Name: motivo_baixa_cod_motivo_baixa_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.motivo_baixa_cod_motivo_baixa_seq', 1, false);


--
-- TOC entry 7932 (class 0 OID 9444871)
-- Dependencies: 643
-- Data for Name: motivo_suspensao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8337 (class 0 OID 0)
-- Dependencies: 642
-- Name: motivo_suspensao_cod_motivo_suspensao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.motivo_suspensao_cod_motivo_suspensao_seq', 1, false);


--
-- TOC entry 7934 (class 0 OID 9444881)
-- Dependencies: 645
-- Data for Name: nivel; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8338 (class 0 OID 0)
-- Dependencies: 644
-- Name: nivel_cod_nivel_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.nivel_cod_nivel_seq', 1, false);


--
-- TOC entry 7936 (class 0 OID 9444888)
-- Dependencies: 647
-- Data for Name: nivel_ensino; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8339 (class 0 OID 0)
-- Dependencies: 646
-- Name: nivel_ensino_cod_nivel_ensino_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.nivel_ensino_cod_nivel_ensino_seq', 1, true);


--
-- TOC entry 7938 (class 0 OID 9444898)
-- Dependencies: 649
-- Data for Name: nota_aluno; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8340 (class 0 OID 0)
-- Dependencies: 648
-- Name: nota_aluno_cod_nota_aluno_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.nota_aluno_cod_nota_aluno_seq', 1, false);


--
-- TOC entry 8341 (class 0 OID 0)
-- Dependencies: 632
-- Name: ocorrencia_disciplinar_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.ocorrencia_disciplinar_seq', 1, false);


--
-- TOC entry 7940 (class 0 OID 9444905)
-- Dependencies: 651
-- Data for Name: operador; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8342 (class 0 OID 0)
-- Dependencies: 650
-- Name: operador_cod_operador_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.operador_cod_operador_seq', 1, false);


--
-- TOC entry 7942 (class 0 OID 9444916)
-- Dependencies: 653
-- Data for Name: pagamento_multa; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8343 (class 0 OID 0)
-- Dependencies: 652
-- Name: pagamento_multa_cod_pagamento_multa_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.pagamento_multa_cod_pagamento_multa_seq', 1, false);


--
-- TOC entry 7944 (class 0 OID 9444922)
-- Dependencies: 655
-- Data for Name: pre_requisito; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8344 (class 0 OID 0)
-- Dependencies: 654
-- Name: pre_requisito_cod_pre_requisito_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.pre_requisito_cod_pre_requisito_seq', 1, false);


--
-- TOC entry 7946 (class 0 OID 9444932)
-- Dependencies: 657
-- Data for Name: projeto; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7947 (class 0 OID 9444936)
-- Dependencies: 658
-- Data for Name: projeto_aluno; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8345 (class 0 OID 0)
-- Dependencies: 656
-- Name: projeto_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.projeto_seq', 1, false);


--
-- TOC entry 7949 (class 0 OID 9444941)
-- Dependencies: 660
-- Data for Name: quadro_horario; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8346 (class 0 OID 0)
-- Dependencies: 659
-- Name: quadro_horario_cod_quadro_horario_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.quadro_horario_cod_quadro_horario_seq', 1, false);


--
-- TOC entry 7950 (class 0 OID 9444946)
-- Dependencies: 661
-- Data for Name: quadro_horario_horarios; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7951 (class 0 OID 9444950)
-- Dependencies: 662
-- Data for Name: quadro_horario_horarios_aux; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7952 (class 0 OID 9444953)
-- Dependencies: 663
-- Data for Name: quantidade_reserva_externa; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7953 (class 0 OID 9444956)
-- Dependencies: 664
-- Data for Name: relacao_categoria_acervo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7955 (class 0 OID 9444961)
-- Dependencies: 666
-- Data for Name: religiao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8347 (class 0 OID 0)
-- Dependencies: 665
-- Name: religiao_cod_religiao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.religiao_cod_religiao_seq', 1, false);


--
-- TOC entry 7957 (class 0 OID 9444968)
-- Dependencies: 668
-- Data for Name: reserva_vaga; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8348 (class 0 OID 0)
-- Dependencies: 667
-- Name: reserva_vaga_cod_reserva_vaga_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.reserva_vaga_cod_reserva_vaga_seq', 1, false);


--
-- TOC entry 7959 (class 0 OID 9444975)
-- Dependencies: 670
-- Data for Name: reservas; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8349 (class 0 OID 0)
-- Dependencies: 669
-- Name: reservas_cod_reserva_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.reservas_cod_reserva_seq', 1, false);


--
-- TOC entry 7960 (class 0 OID 9444980)
-- Dependencies: 671
-- Data for Name: sequencia_serie; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7962 (class 0 OID 9444986)
-- Dependencies: 673
-- Data for Name: serie; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8350 (class 0 OID 0)
-- Dependencies: 672
-- Name: serie_cod_serie_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.serie_cod_serie_seq', 2, true);


--
-- TOC entry 7963 (class 0 OID 9444992)
-- Dependencies: 674
-- Data for Name: serie_pre_requisito; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7964 (class 0 OID 9444998)
-- Dependencies: 675
-- Data for Name: serie_vaga; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7965 (class 0 OID 9445002)
-- Dependencies: 676
-- Data for Name: servidor; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7966 (class 0 OID 9445006)
-- Dependencies: 677
-- Data for Name: servidor_afastamento; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7968 (class 0 OID 9445012)
-- Dependencies: 679
-- Data for Name: servidor_alocacao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8351 (class 0 OID 0)
-- Dependencies: 678
-- Name: servidor_alocacao_cod_servidor_alocacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.servidor_alocacao_cod_servidor_alocacao_seq', 1, false);


--
-- TOC entry 7970 (class 0 OID 9445020)
-- Dependencies: 681
-- Data for Name: servidor_curso; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8352 (class 0 OID 0)
-- Dependencies: 680
-- Name: servidor_curso_cod_servidor_curso_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.servidor_curso_cod_servidor_curso_seq', 1, false);


--
-- TOC entry 7971 (class 0 OID 9445027)
-- Dependencies: 682
-- Data for Name: servidor_curso_ministra; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7972 (class 0 OID 9445030)
-- Dependencies: 683
-- Data for Name: servidor_disciplina; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7974 (class 0 OID 9445035)
-- Dependencies: 685
-- Data for Name: servidor_formacao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8353 (class 0 OID 0)
-- Dependencies: 684
-- Name: servidor_formacao_cod_formacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.servidor_formacao_cod_formacao_seq', 1, false);


--
-- TOC entry 7976 (class 0 OID 9445045)
-- Dependencies: 687
-- Data for Name: servidor_funcao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8354 (class 0 OID 0)
-- Dependencies: 686
-- Name: servidor_funcao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.servidor_funcao_seq', 1, false);


--
-- TOC entry 7978 (class 0 OID 9445054)
-- Dependencies: 689
-- Data for Name: servidor_titulo_concurso; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8355 (class 0 OID 0)
-- Dependencies: 688
-- Name: servidor_titulo_concurso_cod_servidor_titulo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.servidor_titulo_concurso_cod_servidor_titulo_seq', 1, false);


--
-- TOC entry 7980 (class 0 OID 9445060)
-- Dependencies: 691
-- Data for Name: situacao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8356 (class 0 OID 0)
-- Dependencies: 690
-- Name: situacao_cod_situacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.situacao_cod_situacao_seq', 1, false);


--
-- TOC entry 7982 (class 0 OID 9445073)
-- Dependencies: 693
-- Data for Name: subnivel; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8357 (class 0 OID 0)
-- Dependencies: 692
-- Name: subnivel_cod_subnivel_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.subnivel_cod_subnivel_seq', 1, false);


--
-- TOC entry 7983 (class 0 OID 9445078)
-- Dependencies: 694
-- Data for Name: tipo_autor; Type: TABLE DATA; Schema: pmieducar; Owner: -
--

INSERT INTO pmieducar.tipo_autor VALUES (1, 'Autor');
INSERT INTO pmieducar.tipo_autor VALUES (2, 'Evento');
INSERT INTO pmieducar.tipo_autor VALUES (3, 'Entidade coletiva');
INSERT INTO pmieducar.tipo_autor VALUES (4, 'Anônimo');


--
-- TOC entry 7985 (class 0 OID 9445083)
-- Dependencies: 696
-- Data for Name: tipo_avaliacao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8358 (class 0 OID 0)
-- Dependencies: 695
-- Name: tipo_avaliacao_cod_tipo_avaliacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.tipo_avaliacao_cod_tipo_avaliacao_seq', 1, false);


--
-- TOC entry 7986 (class 0 OID 9445089)
-- Dependencies: 697
-- Data for Name: tipo_avaliacao_valores; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 7988 (class 0 OID 9445095)
-- Dependencies: 699
-- Data for Name: tipo_dispensa; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8359 (class 0 OID 0)
-- Dependencies: 698
-- Name: tipo_dispensa_cod_tipo_dispensa_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.tipo_dispensa_cod_tipo_dispensa_seq', 1, false);


--
-- TOC entry 7990 (class 0 OID 9445105)
-- Dependencies: 701
-- Data for Name: tipo_ensino; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8360 (class 0 OID 0)
-- Dependencies: 700
-- Name: tipo_ensino_cod_tipo_ensino_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.tipo_ensino_cod_tipo_ensino_seq', 1, true);


--
-- TOC entry 7992 (class 0 OID 9445113)
-- Dependencies: 703
-- Data for Name: tipo_ocorrencia_disciplinar; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8361 (class 0 OID 0)
-- Dependencies: 702
-- Name: tipo_ocorrencia_disciplinar_cod_tipo_ocorrencia_disciplinar_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.tipo_ocorrencia_disciplinar_cod_tipo_ocorrencia_disciplinar_seq', 1, false);


--
-- TOC entry 7994 (class 0 OID 9445123)
-- Dependencies: 705
-- Data for Name: tipo_regime; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8362 (class 0 OID 0)
-- Dependencies: 704
-- Name: tipo_regime_cod_tipo_regime_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.tipo_regime_cod_tipo_regime_seq', 1, false);


--
-- TOC entry 7996 (class 0 OID 9445129)
-- Dependencies: 707
-- Data for Name: tipo_usuario; Type: TABLE DATA; Schema: pmieducar; Owner: -
--

INSERT INTO pmieducar.tipo_usuario VALUES (1, 1, NULL, 'Administrador', '', 1, '2010-01-06 18:30:33.204604', NULL, 1);


--
-- TOC entry 8363 (class 0 OID 0)
-- Dependencies: 706
-- Name: tipo_usuario_cod_tipo_usuario_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.tipo_usuario_cod_tipo_usuario_seq', 3, true);


--
-- TOC entry 7998 (class 0 OID 9445139)
-- Dependencies: 709
-- Data for Name: transferencia_solicitacao; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8364 (class 0 OID 0)
-- Dependencies: 708
-- Name: transferencia_solicitacao_cod_transferencia_solicitacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.transferencia_solicitacao_cod_transferencia_solicitacao_seq', 1, false);


--
-- TOC entry 8000 (class 0 OID 9445149)
-- Dependencies: 711
-- Data for Name: transferencia_tipo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8365 (class 0 OID 0)
-- Dependencies: 710
-- Name: transferencia_tipo_cod_transferencia_tipo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.transferencia_tipo_cod_transferencia_tipo_seq', 1, false);


--
-- TOC entry 8002 (class 0 OID 9445159)
-- Dependencies: 713
-- Data for Name: turma; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8366 (class 0 OID 0)
-- Dependencies: 712
-- Name: turma_cod_turma_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.turma_cod_turma_seq', 2, true);


--
-- TOC entry 8003 (class 0 OID 9445171)
-- Dependencies: 714
-- Data for Name: turma_modulo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8005 (class 0 OID 9445176)
-- Dependencies: 716
-- Data for Name: turma_tipo; Type: TABLE DATA; Schema: pmieducar; Owner: -
--



--
-- TOC entry 8367 (class 0 OID 0)
-- Dependencies: 715
-- Name: turma_tipo_cod_turma_tipo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.turma_tipo_cod_turma_tipo_seq', 1, true);


--
-- TOC entry 8007 (class 0 OID 9445183)
-- Dependencies: 718
-- Data for Name: turma_turno; Type: TABLE DATA; Schema: pmieducar; Owner: -
--

INSERT INTO pmieducar.turma_turno VALUES (1, 'Matutino', 1);
INSERT INTO pmieducar.turma_turno VALUES (2, 'Vespertino', 1);
INSERT INTO pmieducar.turma_turno VALUES (3, 'Noturno', 1);
INSERT INTO pmieducar.turma_turno VALUES (4, 'Integral', 1);


--
-- TOC entry 8368 (class 0 OID 0)
-- Dependencies: 717
-- Name: turma_turno_id_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: -
--

SELECT pg_catalog.setval('pmieducar.turma_turno_id_seq', 1, false);


--
-- TOC entry 8008 (class 0 OID 9445188)
-- Dependencies: 719
-- Data for Name: usuario; Type: TABLE DATA; Schema: pmieducar; Owner: -
--

INSERT INTO pmieducar.usuario VALUES (1, NULL, 1, NULL, 1, '2010-01-06 18:30:33.207458', NULL, 1);


--
-- TOC entry 8009 (class 0 OID 9445197)
-- Dependencies: 721
-- Data for Name: funcionario_su; Type: TABLE DATA; Schema: pmiotopic; Owner: -
--



--
-- TOC entry 8010 (class 0 OID 9445200)
-- Dependencies: 722
-- Data for Name: grupomoderador; Type: TABLE DATA; Schema: pmiotopic; Owner: -
--



--
-- TOC entry 8011 (class 0 OID 9445204)
-- Dependencies: 723
-- Data for Name: grupopessoa; Type: TABLE DATA; Schema: pmiotopic; Owner: -
--



--
-- TOC entry 8013 (class 0 OID 9445210)
-- Dependencies: 725
-- Data for Name: grupos; Type: TABLE DATA; Schema: pmiotopic; Owner: -
--



--
-- TOC entry 8369 (class 0 OID 0)
-- Dependencies: 724
-- Name: grupos_cod_grupos_seq; Type: SEQUENCE SET; Schema: pmiotopic; Owner: -
--

SELECT pg_catalog.setval('pmiotopic.grupos_cod_grupos_seq', 1, false);


--
-- TOC entry 8014 (class 0 OID 9445216)
-- Dependencies: 726
-- Data for Name: notas; Type: TABLE DATA; Schema: pmiotopic; Owner: -
--



--
-- TOC entry 8015 (class 0 OID 9445223)
-- Dependencies: 727
-- Data for Name: participante; Type: TABLE DATA; Schema: pmiotopic; Owner: -
--



--
-- TOC entry 8017 (class 0 OID 9445228)
-- Dependencies: 729
-- Data for Name: reuniao; Type: TABLE DATA; Schema: pmiotopic; Owner: -
--



--
-- TOC entry 8370 (class 0 OID 0)
-- Dependencies: 728
-- Name: reuniao_cod_reuniao_seq; Type: SEQUENCE SET; Schema: pmiotopic; Owner: -
--

SELECT pg_catalog.setval('pmiotopic.reuniao_cod_reuniao_seq', 1, false);


--
-- TOC entry 8019 (class 0 OID 9445238)
-- Dependencies: 731
-- Data for Name: topico; Type: TABLE DATA; Schema: pmiotopic; Owner: -
--



--
-- TOC entry 8371 (class 0 OID 0)
-- Dependencies: 730
-- Name: topico_cod_topico_seq; Type: SEQUENCE SET; Schema: pmiotopic; Owner: -
--

SELECT pg_catalog.setval('pmiotopic.topico_cod_topico_seq', 1, false);


--
-- TOC entry 8020 (class 0 OID 9445243)
-- Dependencies: 732
-- Data for Name: topicoreuniao; Type: TABLE DATA; Schema: pmiotopic; Owner: -
--



--
-- TOC entry 8022 (class 0 OID 9445251)
-- Dependencies: 734
-- Data for Name: acesso; Type: TABLE DATA; Schema: portal; Owner: -
--

INSERT INTO portal.acesso VALUES (7, '2010-09-02 11:47:17.859', '127.0.0.1', 'NULL', 1, NULL, true);
INSERT INTO portal.acesso VALUES (8, '2010-09-02 11:50:43.687', '127.0.0.1', 'NULL', 1, NULL, false);
INSERT INTO portal.acesso VALUES (9, '2010-09-02 11:50:47.609', '127.0.0.1', 'NULL', 1, NULL, true);
INSERT INTO portal.acesso VALUES (10, '2010-09-02 11:53:28.468', '127.0.0.1', 'NULL', 1, NULL, true);
INSERT INTO portal.acesso VALUES (11, '2010-09-02 12:23:18.812', '127.0.0.1', 'NULL', 1, NULL, true);
INSERT INTO portal.acesso VALUES (12, '2010-09-02 12:28:51.859', '127.0.0.1', 'NULL', 1, NULL, true);
INSERT INTO portal.acesso VALUES (13, '2010-09-02 12:49:37.968', '127.0.0.1', 'NULL', 1, NULL, true);
INSERT INTO portal.acesso VALUES (14, '2010-12-07 09:13:31.125', '127.0.0.1', 'NULL', 1, NULL, true);
INSERT INTO portal.acesso VALUES (15, '2011-07-22 11:22:25.009', '::1', 'NULL', 1, NULL, true);
INSERT INTO portal.acesso VALUES (16, '2011-07-23 09:47:39.552', '::1', 'NULL', 1, NULL, false);
INSERT INTO portal.acesso VALUES (17, '2011-07-25 09:25:36.956', '::1', 'NULL', 1, NULL, false);
INSERT INTO portal.acesso VALUES (18, '2011-07-25 09:25:43.212', '::1', 'NULL', 1, NULL, true);
INSERT INTO portal.acesso VALUES (19, '2014-01-07 19:10:31.47822', '127.0.0.1', 'NULL', 1, NULL, true);


--
-- TOC entry 8372 (class 0 OID 0)
-- Dependencies: 733
-- Name: acesso_cod_acesso_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.acesso_cod_acesso_seq', 19, true);


--
-- TOC entry 8024 (class 0 OID 9445264)
-- Dependencies: 736
-- Data for Name: agenda; Type: TABLE DATA; Schema: portal; Owner: -
--

INSERT INTO portal.agenda VALUES (1, NULL, 1, 'Administrador', 0, 0, '2010-01-06 18:33:11.021729', NULL, 1);


--
-- TOC entry 8373 (class 0 OID 0)
-- Dependencies: 735
-- Name: agenda_cod_agenda_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.agenda_cod_agenda_seq', 1, true);


--
-- TOC entry 8025 (class 0 OID 9445273)
-- Dependencies: 737
-- Data for Name: agenda_compromisso; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8027 (class 0 OID 9445284)
-- Dependencies: 739
-- Data for Name: agenda_pref; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8374 (class 0 OID 0)
-- Dependencies: 738
-- Name: agenda_pref_cod_comp_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.agenda_pref_cod_comp_seq', 1, false);


--
-- TOC entry 8028 (class 0 OID 9445295)
-- Dependencies: 740
-- Data for Name: agenda_responsavel; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8030 (class 0 OID 9445300)
-- Dependencies: 742
-- Data for Name: compras_editais_editais; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8375 (class 0 OID 0)
-- Dependencies: 741
-- Name: compras_editais_editais_cod_compras_editais_editais_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.compras_editais_editais_cod_compras_editais_editais_seq', 1, false);


--
-- TOC entry 8031 (class 0 OID 9445312)
-- Dependencies: 743
-- Data for Name: compras_editais_editais_empresas; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8033 (class 0 OID 9445319)
-- Dependencies: 745
-- Data for Name: compras_editais_empresa; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8376 (class 0 OID 0)
-- Dependencies: 744
-- Name: compras_editais_empresa_cod_compras_editais_empresa_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.compras_editais_empresa_cod_compras_editais_empresa_seq', 1, false);


--
-- TOC entry 8035 (class 0 OID 9445332)
-- Dependencies: 747
-- Data for Name: compras_final_pregao; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8377 (class 0 OID 0)
-- Dependencies: 746
-- Name: compras_final_pregao_cod_compras_final_pregao_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.compras_final_pregao_cod_compras_final_pregao_seq', 1, false);


--
-- TOC entry 8036 (class 0 OID 9445337)
-- Dependencies: 748
-- Data for Name: compras_funcionarios; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8038 (class 0 OID 9445343)
-- Dependencies: 750
-- Data for Name: compras_licitacoes; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8378 (class 0 OID 0)
-- Dependencies: 749
-- Name: compras_licitacoes_cod_compras_licitacoes_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.compras_licitacoes_cod_compras_licitacoes_seq', 1, false);


--
-- TOC entry 8040 (class 0 OID 9445356)
-- Dependencies: 752
-- Data for Name: compras_modalidade; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8379 (class 0 OID 0)
-- Dependencies: 751
-- Name: compras_modalidade_cod_compras_modalidade_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.compras_modalidade_cod_compras_modalidade_seq', 1, false);


--
-- TOC entry 8042 (class 0 OID 9445363)
-- Dependencies: 754
-- Data for Name: compras_pregao_execucao; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8380 (class 0 OID 0)
-- Dependencies: 753
-- Name: compras_pregao_execucao_cod_compras_pregao_execucao_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.compras_pregao_execucao_cod_compras_pregao_execucao_seq', 1, false);


--
-- TOC entry 8044 (class 0 OID 9445374)
-- Dependencies: 756
-- Data for Name: compras_prestacao_contas; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8381 (class 0 OID 0)
-- Dependencies: 755
-- Name: compras_prestacao_contas_cod_compras_prestacao_contas_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.compras_prestacao_contas_cod_compras_prestacao_contas_seq', 1, false);


--
-- TOC entry 8046 (class 0 OID 9445383)
-- Dependencies: 758
-- Data for Name: foto_portal; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8382 (class 0 OID 0)
-- Dependencies: 757
-- Name: foto_portal_cod_foto_portal_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.foto_portal_cod_foto_portal_seq', 1, false);


--
-- TOC entry 8048 (class 0 OID 9445393)
-- Dependencies: 760
-- Data for Name: foto_secao; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8383 (class 0 OID 0)
-- Dependencies: 759
-- Name: foto_secao_cod_foto_secao_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.foto_secao_cod_foto_secao_seq', 1, false);


--
-- TOC entry 8049 (class 0 OID 9445397)
-- Dependencies: 761
-- Data for Name: funcionario; Type: TABLE DATA; Schema: portal; Owner: -
--

INSERT INTO portal.funcionario VALUES (1, 'admin', '25f9e794323b453885f5181f1b624d0b', 1, NULL, NULL, '1  ', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, 0, 1, '172.17.0.1', '2018-04-04 14:50:46.587163', 'admin@ieducar.com.br', NULL, NULL, NULL, NULL);


--
-- TOC entry 8051 (class 0 OID 9445409)
-- Dependencies: 763
-- Data for Name: funcionario_vinculo; Type: TABLE DATA; Schema: portal; Owner: -
--

INSERT INTO portal.funcionario_vinculo VALUES (3, 'Efetivo', 'Efet');
INSERT INTO portal.funcionario_vinculo VALUES (4, 'Contratado', 'Cont');
INSERT INTO portal.funcionario_vinculo VALUES (5, 'Comissionado', 'Com');
INSERT INTO portal.funcionario_vinculo VALUES (6, 'Estagiário', 'Est');


--
-- TOC entry 8384 (class 0 OID 0)
-- Dependencies: 762
-- Name: funcionario_vinculo_cod_funcionario_vinculo_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.funcionario_vinculo_cod_funcionario_vinculo_seq', 7, true);


--
-- TOC entry 8053 (class 0 OID 9445416)
-- Dependencies: 765
-- Data for Name: imagem; Type: TABLE DATA; Schema: portal; Owner: -
--

INSERT INTO portal.imagem VALUES (168, 6, 'logo_itajai.jpg', NULL, 'jpg', NULL, NULL, '2010-01-06 18:30:33.210952', 1, '2010-01-06 18:30:33.210952', 1);
INSERT INTO portal.imagem VALUES (34, 1, 'letra_p.gif', 'letra_p', 'gif', NULL, NULL, '2010-01-06 18:30:33.212276', 1, '2010-01-06 18:30:33.212276', NULL);
INSERT INTO portal.imagem VALUES (35, 1, 'letra_q.gif', 'letra_q', 'gif', NULL, NULL, '2010-01-06 18:30:33.212947', 1, '2010-01-06 18:30:33.212947', NULL);
INSERT INTO portal.imagem VALUES (36, 1, 'letra_r.gif', 'letra_r', 'gif', NULL, NULL, '2010-01-06 18:30:33.213685', 1, '2010-01-06 18:30:33.213685', NULL);
INSERT INTO portal.imagem VALUES (37, 1, 'letra_s.gif', 'letra_s', 'gif', NULL, NULL, '2010-01-06 18:30:33.214582', 1, '2010-01-06 18:30:33.214582', NULL);
INSERT INTO portal.imagem VALUES (38, 1, 'letra_t.gif', 'letra_t', 'gif', NULL, NULL, '2010-01-06 18:30:33.215327', 1, '2010-01-06 18:30:33.215327', NULL);
INSERT INTO portal.imagem VALUES (39, 1, 'letra_v.gif', 'letra_v', 'gif', NULL, NULL, '2010-01-06 18:30:33.215968', 1, '2010-01-06 18:30:33.215968', NULL);
INSERT INTO portal.imagem VALUES (40, 1, 'letra_x.gif', 'letra_x', 'gif', NULL, NULL, '2010-01-06 18:30:33.217264', 1, '2010-01-06 18:30:33.217264', NULL);
INSERT INTO portal.imagem VALUES (41, 1, 'letra_w.gif', 'letra_w', 'gif', NULL, NULL, '2010-01-06 18:30:33.218576', 1, '2010-01-06 18:30:33.218576', NULL);
INSERT INTO portal.imagem VALUES (42, 1, 'letra_y.gif', 'letra_y', 'gif', NULL, NULL, '2010-01-06 18:30:33.219314', 1, '2010-01-06 18:30:33.219314', NULL);
INSERT INTO portal.imagem VALUES (43, 1, 'letra_z.gif', 'letra_z', 'gif', NULL, NULL, '2010-01-06 18:30:33.220045', 1, '2010-01-06 18:30:33.220045', NULL);
INSERT INTO portal.imagem VALUES (44, 1, 'letra_u.gif', 'letra_u', 'gif', NULL, NULL, '2010-01-06 18:30:33.220895', 1, '2010-01-06 18:30:33.220895', NULL);
INSERT INTO portal.imagem VALUES (88, 1, 'letra_j.gif', 'letra_j', 'gif', NULL, NULL, '2010-01-06 18:30:33.221765', 1, '2010-01-06 18:30:33.221765', NULL);
INSERT INTO portal.imagem VALUES (89, 1, 'letra_l.gif', 'letra_l', 'gif', NULL, NULL, '2010-01-06 18:30:33.222529', 1, '2010-01-06 18:30:33.222529', NULL);
INSERT INTO portal.imagem VALUES (1, 1, 'transp.gif', 'Transp', '   ', NULL, NULL, '2010-01-06 18:30:33.223478', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (48, 1, 'email.gif', 'contato', 'gif', NULL, NULL, '2010-01-06 18:30:33.224205', 1, '2010-01-06 18:30:33.224205', NULL);
INSERT INTO portal.imagem VALUES (53, 1, 'informacoes.gif', 'informacoes', 'gif', NULL, NULL, '2010-01-06 18:30:33.22499', 1, '2010-01-06 18:30:33.22499', NULL);
INSERT INTO portal.imagem VALUES (56, 1, 'visualizar.gif', 'visualizar', 'gif', NULL, NULL, '2010-01-06 18:30:33.225714', 1, '2010-01-06 18:30:33.225714', NULL);
INSERT INTO portal.imagem VALUES (57, 1, 'novo.gif', 'novo', 'gif', NULL, NULL, '2010-01-06 18:30:33.226447', 1, '2010-01-06 18:30:33.226447', NULL);
INSERT INTO portal.imagem VALUES (59, 1, 'lista.gif', 'lista', 'gif', NULL, NULL, '2010-01-06 18:30:33.227236', 1, '2010-01-06 18:30:33.227236', NULL);
INSERT INTO portal.imagem VALUES (73, 1, 'baixa.gif', 'baixaa', 'gif', NULL, NULL, '2010-01-06 18:30:33.228131', 1, '2010-01-06 18:30:33.228131', NULL);
INSERT INTO portal.imagem VALUES (75, 1, 'carrinho.gif', 'compras', 'gif', NULL, NULL, '2010-01-06 18:30:33.228917', 1, '2010-01-06 18:30:33.228917', NULL);
INSERT INTO portal.imagem VALUES (83, 1, 'retorno.gif', 'retorno', 'gif', NULL, NULL, '2010-01-06 18:30:33.229765', 1, '2010-01-06 18:30:33.229765', NULL);
INSERT INTO portal.imagem VALUES (85, 1, 'saida2.gif', 'saida', 'gif', NULL, NULL, '2010-01-06 18:30:33.230583', 1, '2010-01-06 18:30:33.230583', NULL);
INSERT INTO portal.imagem VALUES (86, 1, 'entrada2.gif', 'entrada', 'gif', NULL, NULL, '2010-01-06 18:30:33.231266', 1, '2010-01-06 18:30:33.231266', NULL);
INSERT INTO portal.imagem VALUES (87, 1, 'seta_cima.gif', 'seta up', 'gif', NULL, NULL, '2010-01-06 18:30:33.232073', 1, '2010-01-06 18:30:33.232073', NULL);
INSERT INTO portal.imagem VALUES (66, 1, 'seta_left.gif', 'seta_left', 'gif', NULL, NULL, '2010-01-06 18:30:33.233148', 1, '2010-01-06 18:30:33.233148', NULL);
INSERT INTO portal.imagem VALUES (67, 1, 'seta_right.gif', 'seta_right', 'gif', NULL, NULL, '2010-01-06 18:30:33.23387', 1, '2010-01-06 18:30:33.23387', NULL);
INSERT INTO portal.imagem VALUES (68, 1, 'seta_up.gif', 'seta_up', 'gif', NULL, NULL, '2010-01-06 18:30:33.234652', 1, '2010-01-06 18:30:33.234652', NULL);
INSERT INTO portal.imagem VALUES (78, 1, 'retorno.gif', 'devolucao', 'gif', NULL, NULL, '2010-01-06 18:30:33.235447', 1, '2010-01-06 18:30:33.235447', NULL);
INSERT INTO portal.imagem VALUES (65, 1, 'seta_down.gif', 'seta_down', 'gif', NULL, NULL, '2010-01-06 18:30:33.236358', 1, '2010-01-06 18:30:33.236358', NULL);
INSERT INTO portal.imagem VALUES (81, 1, 'excluirrr.gif', 'excluirrr', 'gif', NULL, NULL, '2010-01-06 18:30:33.243287', 1, '2010-01-06 18:30:33.243287', NULL);
INSERT INTO portal.imagem VALUES (47, 1, 'check.gif', 'check', 'gif', NULL, NULL, '2010-01-06 18:30:33.244293', 1, '2010-01-06 18:30:33.244293', NULL);
INSERT INTO portal.imagem VALUES (90, 1, 'incluir.gif', 'incluir', 'gif', NULL, NULL, '2010-01-06 18:30:33.245064', 1, '2010-01-06 18:30:33.245064', NULL);
INSERT INTO portal.imagem VALUES (92, 1, 'interrogacao.gif', 'interrogacao', 'gif', NULL, NULL, '2010-01-06 18:30:33.245821', 1, '2010-01-06 18:30:33.245821', NULL);
INSERT INTO portal.imagem VALUES (93, 1, 'exclamacao2.gif', 'exclamacao', 'gif', NULL, NULL, '2010-01-06 18:30:33.246548', 1, '2010-01-06 18:30:33.246548', NULL);
INSERT INTO portal.imagem VALUES (102, 1, 'computador.gif', 'computador', 'gif', NULL, NULL, '2010-01-06 18:30:33.247294', 1, '2010-01-06 18:30:33.247294', NULL);
INSERT INTO portal.imagem VALUES (103, 1, 'duvida.gif', 'duvida', 'gif', NULL, NULL, '2010-01-06 18:30:33.248058', 1, '2010-01-06 18:30:33.248058', NULL);
INSERT INTO portal.imagem VALUES (144, 1, 'libera.gif', 'libera', 'gif', NULL, NULL, '2010-01-06 18:30:33.24885', 1, '2010-01-06 18:30:33.24885', NULL);
INSERT INTO portal.imagem VALUES (145, 1, 'libera2.gif', 'libera', 'gif', NULL, NULL, '2010-01-06 18:30:33.249808', 1, '2010-01-06 18:30:33.249808', NULL);
INSERT INTO portal.imagem VALUES (128, 1, 'lixeira.gif', 'lixeira', 'gif', NULL, NULL, '2010-01-06 18:30:33.250597', 1, '2010-01-06 18:30:33.250597', NULL);
INSERT INTO portal.imagem VALUES (58, 1, 'opcoes.gif', 'opcoes', 'gif', NULL, NULL, '2010-01-06 18:30:33.25141', 1, '2010-01-06 18:30:33.25141', NULL);
INSERT INTO portal.imagem VALUES (141, 1, 'candidatos.gif', 'candidatos', 'gif', NULL, NULL, '2010-01-06 18:30:33.252109', 1, '2010-01-06 18:30:33.252109', NULL);
INSERT INTO portal.imagem VALUES (153, 1, 'calculadora.gif', 'calculadora', '   ', NULL, NULL, '2010-01-06 18:30:33.2529', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (154, 1, 'cifrao.gif', 'cifrao', '   ', NULL, NULL, '2010-01-06 18:30:33.25364', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (61, 1, 'pasta.gif', 'pasta', 'gif', NULL, NULL, '2010-01-06 18:30:33.254267', 1, '2010-01-06 18:30:33.254267', NULL);
INSERT INTO portal.imagem VALUES (55, 1, 'cadeado.gif', 'cadeado', 'gif', NULL, NULL, '2010-01-06 18:30:33.255231', 1, '2010-01-06 18:30:33.255231', NULL);
INSERT INTO portal.imagem VALUES (127, 1, 'vaievolta.gif', 'vaievolta', 'gif', NULL, NULL, '2010-01-06 18:30:33.255966', 1, '2010-01-06 18:30:33.255966', NULL);
INSERT INTO portal.imagem VALUES (155, 1, 'familia.gif', 'familia', '   ', NULL, NULL, '2010-01-06 18:30:33.256764', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (156, 1, 'back.png', 'back', '   ', NULL, NULL, '2010-01-06 18:30:33.257578', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (104, 1, 'adenda.gif', 'agenda', '   ', NULL, NULL, '2010-01-06 18:30:33.25846', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (105, 1, 'relogio.gif', 'relogio', '   ', NULL, NULL, '2010-01-06 18:30:33.259269', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (106, 1, 'ark.gif', 'caixa', '   ', NULL, NULL, '2010-01-06 18:30:33.260283', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (107, 1, 'download_manager.gif', 'download', '   ', NULL, NULL, '2010-01-06 18:30:33.261117', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (108, 1, 'file-manager.gif', 'arquivo', '   ', NULL, NULL, '2010-01-06 18:30:33.261834', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (109, 1, 'filetypes.gif', 'balao', '   ', NULL, NULL, '2010-01-06 18:30:33.262552', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (110, 1, 'kate.gif', 'escrito', '   ', NULL, NULL, '2010-01-06 18:30:33.263297', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (112, 1, 'kfm_home.gif', 'sainhaa', '   ', NULL, NULL, '2010-01-06 18:30:33.264072', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (113, 1, 'ktip.gif', 'computerr', '   ', NULL, NULL, '2010-01-06 18:30:33.264791', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (114, 1, 'mycomputer.gif', 'computer', '   ', NULL, NULL, '2010-01-06 18:30:33.265575', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (115, 1, 'package_application.gif', 'lista', '   ', NULL, NULL, '2010-01-06 18:30:33.266321', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (116, 1, 'package_settings.gif', 'ferramentas', '   ', NULL, NULL, '2010-01-06 18:30:33.267047', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (117, 1, 'password.gif', 'senha', '   ', NULL, NULL, '2010-01-06 18:30:33.267829', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (118, 1, 'personal.gif', 'pessoas', '   ', NULL, NULL, '2010-01-06 18:30:33.26854', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (119, 1, 'window_list.gif', 'lista', '   ', NULL, NULL, '2010-01-06 18:30:33.269227', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (120, 1, 'yast_partitioner.gif', 'grafico', '   ', NULL, NULL, '2010-01-06 18:30:33.270037', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (121, 1, 'rede.gif', 'rede', '   ', NULL, NULL, '2010-01-06 18:30:33.270759', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (122, 1, 'lista.gif', 'lista', '   ', NULL, NULL, '2010-01-06 18:30:33.271427', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (123, 1, 'baixarr.gif', 'baixar', '   ', NULL, NULL, '2010-01-06 18:30:33.272206', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (124, 1, 'escrever.gif', 'escrever', '   ', NULL, NULL, '2010-01-06 18:30:33.272964', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (125, 1, 'identify.gif', 'identidade', '   ', NULL, NULL, '2010-01-06 18:30:33.273944', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (126, 1, 'importante.gif', 'importante', '   ', NULL, NULL, '2010-01-06 18:30:33.274716', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (111, 1, 'kdmconfig.gif', 'usuarios', '   ', NULL, NULL, '2010-01-06 18:30:33.275502', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (137, 1, 'personal2.gif', 'pessoa', '   ', NULL, NULL, '2010-01-06 18:30:33.276424', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (138, 1, 'email.gif', 'email', '   ', NULL, NULL, '2010-01-06 18:30:33.277051', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (139, 1, 'email2.gif', 'email', '   ', NULL, NULL, '2010-01-06 18:30:33.27937', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (140, 1, 'email3.gif', 'email', '   ', NULL, NULL, '2010-01-06 18:30:33.285052', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (142, 1, 'deficientes.gif', 'deficientes', '   ', NULL, NULL, '2010-01-06 18:30:33.285921', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (143, 1, 'areas.gif', 'areas', '   ', NULL, NULL, '2010-01-06 18:30:33.286602', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (146, 1, 'encaminhamento.gif', 'encaminhamento', '   ', NULL, NULL, '2010-01-06 18:30:33.287388', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (147, 1, 'empresa.gif', 'empresa', '   ', NULL, NULL, '2010-01-06 18:30:33.28876', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (148, 1, 'supergrupo.gif', 'supergrupo', '   ', NULL, NULL, '2010-01-06 18:30:33.28957', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (17, 1, 'letra_a.gif', 'letra_a', 'gif', NULL, NULL, '2010-01-06 18:30:33.290308', 1, '2010-01-06 18:30:33.290308', NULL);
INSERT INTO portal.imagem VALUES (91, 1, 'endereco.gif', 'endereco', 'gif', NULL, NULL, '2010-01-06 18:30:33.290989', 1, '2010-01-06 18:30:33.290989', NULL);
INSERT INTO portal.imagem VALUES (19, 1, 'letra_b.gif', 'letra_b', 'gif', NULL, NULL, '2010-01-06 18:30:33.291675', 1, '2010-01-06 18:30:33.291675', NULL);
INSERT INTO portal.imagem VALUES (20, 1, 'letra_c.gif', 'letra_c', 'gif', NULL, NULL, '2010-01-06 18:30:33.292368', 1, '2010-01-06 18:30:33.292368', NULL);
INSERT INTO portal.imagem VALUES (21, 1, 'letra_d.gif', 'letra_d', 'gif', NULL, NULL, '2010-01-06 18:30:33.292959', 1, '2010-01-06 18:30:33.292959', NULL);
INSERT INTO portal.imagem VALUES (22, 1, 'letra_e.gif', 'letra_e', 'gif', NULL, NULL, '2010-01-06 18:30:33.293817', 1, '2010-01-06 18:30:33.293817', NULL);
INSERT INTO portal.imagem VALUES (23, 1, 'letra_f.gif', 'letra_f', 'gif', NULL, NULL, '2010-01-06 18:30:33.29459', 1, '2010-01-06 18:30:33.29459', NULL);
INSERT INTO portal.imagem VALUES (24, 1, 'letra_g.gif', 'letra_g', 'gif', NULL, NULL, '2010-01-06 18:30:33.295332', 1, '2010-01-06 18:30:33.295332', NULL);
INSERT INTO portal.imagem VALUES (25, 1, 'letra_h.gif', 'letra_h', 'gif', NULL, NULL, '2010-01-06 18:30:33.296129', 1, '2010-01-06 18:30:33.296129', NULL);
INSERT INTO portal.imagem VALUES (26, 1, 'letra_i.gif', 'letra_i', 'gif', NULL, NULL, '2010-01-06 18:30:33.296846', 1, '2010-01-06 18:30:33.296846', NULL);
INSERT INTO portal.imagem VALUES (29, 1, 'letra_k.gif', 'letra_k', 'gif', NULL, NULL, '2010-01-06 18:30:33.297747', 1, '2010-01-06 18:30:33.297747', NULL);
INSERT INTO portal.imagem VALUES (31, 1, 'letra_m.gif', 'letra_m', 'gif', NULL, NULL, '2010-01-06 18:30:33.29847', 1, '2010-01-06 18:30:33.29847', NULL);
INSERT INTO portal.imagem VALUES (32, 1, 'letra_n.gif', 'letra_n', 'gif', NULL, NULL, '2010-01-06 18:30:33.299169', 1, '2010-01-06 18:30:33.299169', NULL);
INSERT INTO portal.imagem VALUES (33, 1, 'letra_o.gif', 'letra_o', 'gif', NULL, NULL, '2010-01-06 18:30:33.300006', 1, '2010-01-06 18:30:33.300006', NULL);
INSERT INTO portal.imagem VALUES (50, 1, 'grafico.gif', 'grafico', 'gif', NULL, NULL, '2010-01-06 18:30:33.300741', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (176, 1, 'escreve.gif', 'escrever', 'gif', NULL, NULL, '2010-01-06 18:30:33.301622', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (177, 1, 'livro.gif', 'livro', 'gif', NULL, NULL, '2010-01-06 18:30:33.302345', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (178, 1, 'sineta.gif', 'sineta', 'gif', NULL, NULL, '2010-01-06 18:30:33.303075', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (179, 1, 'check2.gif', 'check2', 'gif', NULL, NULL, '2010-01-06 18:30:33.303917', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (180, 1, 'geral.gif', 'Geral', 'gif', NULL, NULL, '2010-01-06 18:30:33.304703', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (62, 1, 'pessoa.gif', 'pessoa', 'gif', NULL, NULL, '2010-01-06 18:30:33.305518', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (63, 1, 'print.gif', 'impressao', 'gif', NULL, NULL, '2010-01-06 18:30:33.306231', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (70, 1, 'seta_baixo.gif', 'seta2_down', 'gif', NULL, NULL, '2010-01-06 18:30:33.30705', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (74, 1, 'check.gif', 'check', '   ', NULL, NULL, '2010-01-06 18:30:33.307829', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (80, 1, 'entrada_rel.gif', 'entrada_rel', '   ', NULL, NULL, '2010-01-06 18:30:33.308521', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (82, 1, 'grafico2.gif', 'grafico', '   ', NULL, NULL, '2010-01-06 18:30:33.30934', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (84, 1, 'saida_rel.gif', 'saida_rel', '   ', NULL, NULL, '2010-01-06 18:30:33.310113', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (181, 1, 'carp.jpg', 'carp', 'jpg', NULL, NULL, '2010-01-06 18:30:33.310825', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (182, 1, 'money.gif', 'money', 'gif', NULL, NULL, '2010-01-06 18:30:33.311631', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (183, 1, 'reload.jpg', 'reload', 'jpg', NULL, NULL, '2010-01-06 18:30:33.31248', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (185, 1, 'porca2.jpg', 'porca2', 'jpg', NULL, NULL, '2010-01-06 18:30:33.313215', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (186, 1, 'agua.gif', 'agua', 'gif', NULL, NULL, '2010-01-06 18:30:33.314081', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (187, 1, 'book.png', 'FAMFAMFAM iconset: book.png', 'png', 16, 16, '2010-01-06 18:30:33.314939', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (188, 1, 'book_add.png', 'FAMFAMFAM iconset: book_add.png', 'png', 16, 16, '2010-01-06 18:30:33.3157', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (189, 1, 'book_go.png', 'FAMFAMFAM iconset: book_go.png', 'png', 16, 16, '2010-01-06 18:30:33.316407', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (190, 1, 'layout.png', 'FAMFAMFAM iconset: layout.png', 'png', 16, 16, '2010-01-06 18:30:33.317136', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (191, 1, 'layout_add.png', 'FAMFAMFAM iconset: layout_add.png', 'png', 16, 16, '2010-01-06 18:30:33.317976', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (192, 1, 'layout_content.png', 'FAMFAMFAM iconset: layout_content.png', 'png', 16, 16, '2010-01-06 18:30:33.31861', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (193, 1, 'book_previous.png', 'FAMFAMFAM iconset: book_previous.png', 'png', 16, 16, '2010-01-06 18:30:33.325564', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (194, 1, 'book_error.png', 'FAMFAMFAM iconset: book_error.png', 'png', 16, 16, '2010-01-06 18:30:33.326664', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (195, 1, 'cog.png', 'FAMFAMFAM iconset: cog.png', 'png', 16, 16, '2010-01-06 18:30:33.327682', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (196, 1, 'cog_add.png', 'FAMFAMFAM iconset: cog_add.png', 'png', 16, 16, '2010-01-06 18:30:33.328624', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (197, 1, 'cog_go.png', 'FAMFAMFAM iconset: cog_go.png', 'png', 16, 16, '2010-01-06 18:30:33.329282', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (198, 1, 'calculator.png', 'FAMFAMFAM iconset: calculator.png', 'png', 16, 16, '2010-01-06 18:30:33.330079', 1, NULL, NULL);
INSERT INTO portal.imagem VALUES (199, 1, 'calendar_link.png', 'FAMFAMFAM iconset: calendar_link.png', 'png', 16, 16, '2010-01-06 18:30:33.330581', 1, NULL, NULL);


--
-- TOC entry 8385 (class 0 OID 0)
-- Dependencies: 764
-- Name: imagem_cod_imagem_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.imagem_cod_imagem_seq', 186, true);


--
-- TOC entry 8055 (class 0 OID 9445422)
-- Dependencies: 767
-- Data for Name: imagem_tipo; Type: TABLE DATA; Schema: portal; Owner: -
--

INSERT INTO portal.imagem_tipo VALUES (1, 'Icone');
INSERT INTO portal.imagem_tipo VALUES (6, 'Acervo');


--
-- TOC entry 8386 (class 0 OID 0)
-- Dependencies: 766
-- Name: imagem_tipo_cod_imagem_tipo_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.imagem_tipo_cod_imagem_tipo_seq', 6, true);


--
-- TOC entry 8387 (class 0 OID 0)
-- Dependencies: 768
-- Name: intranet_segur_permissao_nega_cod_intranet_segur_permissao__seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.intranet_segur_permissao_nega_cod_intranet_segur_permissao__seq', 1, false);


--
-- TOC entry 8057 (class 0 OID 9445428)
-- Dependencies: 769
-- Data for Name: intranet_segur_permissao_negada; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8058 (class 0 OID 9445436)
-- Dependencies: 770
-- Data for Name: jor_arquivo; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8060 (class 0 OID 9445444)
-- Dependencies: 772
-- Data for Name: jor_edicao; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8388 (class 0 OID 0)
-- Dependencies: 771
-- Name: jor_edicao_cod_jor_edicao_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.jor_edicao_cod_jor_edicao_seq', 1, false);


--
-- TOC entry 8062 (class 0 OID 9445454)
-- Dependencies: 774
-- Data for Name: mailling_email; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8389 (class 0 OID 0)
-- Dependencies: 773
-- Name: mailling_email_cod_mailling_email_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.mailling_email_cod_mailling_email_seq', 1, false);


--
-- TOC entry 8064 (class 0 OID 9445465)
-- Dependencies: 776
-- Data for Name: mailling_email_conteudo; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8390 (class 0 OID 0)
-- Dependencies: 775
-- Name: mailling_email_conteudo_cod_mailling_email_conteudo_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.mailling_email_conteudo_cod_mailling_email_conteudo_seq', 1, false);


--
-- TOC entry 8066 (class 0 OID 9445475)
-- Dependencies: 778
-- Data for Name: mailling_fila_envio; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8391 (class 0 OID 0)
-- Dependencies: 777
-- Name: mailling_fila_envio_cod_mailling_fila_envio_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.mailling_fila_envio_cod_mailling_fila_envio_seq', 1, false);


--
-- TOC entry 8068 (class 0 OID 9445482)
-- Dependencies: 780
-- Data for Name: mailling_grupo; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8392 (class 0 OID 0)
-- Dependencies: 779
-- Name: mailling_grupo_cod_mailling_grupo_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.mailling_grupo_cod_mailling_grupo_seq', 1, false);


--
-- TOC entry 8069 (class 0 OID 9445487)
-- Dependencies: 781
-- Data for Name: mailling_grupo_email; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8071 (class 0 OID 9445494)
-- Dependencies: 783
-- Data for Name: mailling_historico; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8393 (class 0 OID 0)
-- Dependencies: 782
-- Name: mailling_historico_cod_mailling_historico_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.mailling_historico_cod_mailling_historico_seq', 1, false);


--
-- TOC entry 8072 (class 0 OID 9445501)
-- Dependencies: 784
-- Data for Name: menu_funcionario; Type: TABLE DATA; Schema: portal; Owner: -
--

INSERT INTO portal.menu_funcionario VALUES (1, 0, 0, 0);
INSERT INTO portal.menu_funcionario VALUES (1, 0, 0, 21246);
INSERT INTO portal.menu_funcionario VALUES (1, 0, 0, 41);
INSERT INTO portal.menu_funcionario VALUES (1, 0, 0, 43);
INSERT INTO portal.menu_funcionario VALUES (1, 0, 0, 753);
INSERT INTO portal.menu_funcionario VALUES (1, 0, 0, 754);
INSERT INTO portal.menu_funcionario VALUES (1, 0, 0, 755);
INSERT INTO portal.menu_funcionario VALUES (1, 0, 0, 756);
INSERT INTO portal.menu_funcionario VALUES (1, 0, 0, 757);
INSERT INTO portal.menu_funcionario VALUES (1, 0, 0, 758);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 554);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 555);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 578);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 624);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 581);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 620);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 576);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 829);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 946);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 566);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 574);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 631);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 659);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 561);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 562);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 585);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 632);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 642);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 572);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 634);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 948);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 573);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 559);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 569);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 633);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 584);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 571);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 567);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 641);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 678);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 647);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 947);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 579);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 845);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 587);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 635);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 583);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 949);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 577);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 558);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 563);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 580);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 568);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 575);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 586);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 570);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 945);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 625);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 592);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 594);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 591);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 603);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 593);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 629);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 628);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 622);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 595);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 610);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 606);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 608);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 590);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 600);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 607);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 598);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 609);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 602);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 596);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 597);
INSERT INTO portal.menu_funcionario VALUES (1, 0, 0, 345);
INSERT INTO portal.menu_funcionario VALUES (1, 0, 0, 343);
INSERT INTO portal.menu_funcionario VALUES (1, 0, 0, 341);
INSERT INTO portal.menu_funcionario VALUES (1, 0, 0, 999613);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 950);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 21235);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 21236);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 21237);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 21238);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 21239);
INSERT INTO portal.menu_funcionario VALUES (1, 1, 1, 21240);


--
-- TOC entry 8074 (class 0 OID 9445510)
-- Dependencies: 786
-- Data for Name: menu_menu; Type: TABLE DATA; Schema: portal; Owner: -
--

INSERT INTO portal.menu_menu VALUES (1, 'Todos', '', NULL, '#', 9999, false, NULL);
INSERT INTO portal.menu_menu VALUES (23, 'Principal', '', NULL, '#', 9999, false, NULL);
INSERT INTO portal.menu_menu VALUES (38, 'i-Pauta', '', NULL, '#', 9999, false, NULL);
INSERT INTO portal.menu_menu VALUES (56, 'i-Educar - Controle', NULL, NULL, '#', 9999, false, NULL);
INSERT INTO portal.menu_menu VALUES (5, 'Agenda', 'Agendas', NULL, '#', 9999, false, NULL);
INSERT INTO portal.menu_menu VALUES (68, 'Endereçamento', '', NULL, '/intranet/educar_enderecamento_index.php', 2, true, 'fa-map');
INSERT INTO portal.menu_menu VALUES (7, 'Pessoas', 'Pessoas Físicas e Jurídicas', NULL, '/intranet/educar_pessoas_index.php', 3, true, 'fa-user');
INSERT INTO portal.menu_menu VALUES (55, 'Escola', NULL, NULL, '/intranet/educar_index.php', 4, true, 'fa-leanpub');
INSERT INTO portal.menu_menu VALUES (69, 'Transporte escolar', NULL, NULL, '/intranet/educar_transporte_escolar_index.php', 7, true, 'fa-bus');
INSERT INTO portal.menu_menu VALUES (57, 'Biblioteca', NULL, NULL, '/intranet/educar_biblioteca_index.php', 8, true, 'fa-book');
INSERT INTO portal.menu_menu VALUES (25, 'Configurações', 'Sistemas do RH', NULL, '/intranet/educar_configuracoes_index.php', 9, true, 'fa-gear');
INSERT INTO portal.menu_menu VALUES (70, 'Educacenso', NULL, NULL, '/intranet/educar_educacenso_index.php', 6, true, 'fa-bar-chart');
INSERT INTO portal.menu_menu VALUES (71, 'Servidores', '', NULL, '/intranet/educar_servidores_index.php', 5, true, 'fa-users');


--
-- TOC entry 8394 (class 0 OID 0)
-- Dependencies: 785
-- Name: menu_menu_cod_menu_menu_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.menu_menu_cod_menu_menu_seq', 68, true);


--
-- TOC entry 8076 (class 0 OID 9445523)
-- Dependencies: 788
-- Data for Name: menu_submenu; Type: TABLE DATA; Schema: portal; Owner: -
--

INSERT INTO portal.menu_submenu VALUES (0, 1, 0, 'Super usuário', '', '', 3);
INSERT INTO portal.menu_submenu VALUES (155, 23, 2, 'Minha agenda', 'agenda.php', '', 2);
INSERT INTO portal.menu_submenu VALUES (157, 23, 2, 'Minhas conexões', 'conexoes_lst.php', 'Minhas Conexões', 2);
INSERT INTO portal.menu_submenu VALUES (569, 55, 2, 'Material didático', 'educar_material_didatico_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (21235, 69, 2, 'Empresas do transporte', 'transporte_empresa_lst.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (21236, 69, 2, 'Motoristas do transporte', 'transporte_motorista_lst.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (563, 55, 2, 'Tipo material didático', 'educar_material_tipo_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (21237, 69, 2, 'Veículos do transporte', 'transporte_veiculo_lst.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (559, 55, 2, 'Instituição', 'educar_instituicao_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (9998851, 25, 2, 'Auditoria geral', 'educar_auditoria_geral_lst.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (9998858, 25, 2, 'Backups', 'educar_backup_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (624, 55, 2, 'Apresentação', 'educar_index.php', '', 2);
INSERT INTO portal.menu_submenu VALUES (946, 55, 2, 'Componentes curriculares', 'educar_componente_curricular_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (9998849, 70, 2, 'Importação educacenso', 'educar_importacao_educacenso.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (845, 55, 2, 'Rematrícula automática', 'educar_avancar_mod_cad.php', 'Rematrícula Automática', 3);
INSERT INTO portal.menu_submenu VALUES (9998859, 55, 2, 'Componentes da série', 'educar_componentes_serie_lst.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (606, 57, 2, 'Exemplares', 'educar_exemplar_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (602, 57, 2, 'Situação', 'educar_situacao_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (598, 57, 2, 'Obras', 'educar_acervo_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (625, 57, 2, 'Apresentação', 'educar_biblioteca_index.php', '', 2);
INSERT INTO portal.menu_submenu VALUES (947, 55, 2, 'Regras de avaliação', 'module/RegraAvaliacao/index', '', 3);
INSERT INTO portal.menu_submenu VALUES (949, 55, 2, 'Tabelas de arredondamento de nota', 'module/TabelaArredondamento/index', '', 3);
INSERT INTO portal.menu_submenu VALUES (341, 5, 2, 'Agendas', 'agenda_responsavel.php', NULL, 2);
INSERT INTO portal.menu_submenu VALUES (343, 5, 2, 'Agenda admin', 'agenda_admin_lst.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (345, 5, 2, 'Agenda pessoal', 'agenda.php', 'Agenda pessoal', 2);
INSERT INTO portal.menu_submenu VALUES (21234, 69, 2, 'Apresentação', 'transporte_index.php', NULL, 2);
INSERT INTO portal.menu_submenu VALUES (634, 71, 2, 'Funções do servidor', 'educar_funcao_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (632, 71, 2, 'Escolaridade do servidor', 'educar_escolaridade_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (829, 71, 2, 'Categoria ou níveis do servidor', 'educar_categoria_nivel_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (633, 71, 2, 'Motivos de afastamento do servidor', 'educar_motivo_afastamento_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (635, 71, 2, 'Servidores', 'educar_servidor_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (641, 71, 2, 'Quadros de horários', 'educar_quadro_horario_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (948, 55, 2, 'Fórmulas de cálculo de média', 'module/FormulaMedia/index', '', 3);
INSERT INTO portal.menu_submenu VALUES (577, 55, 2, 'Tipos de dispensa da disciplina', 'educar_tipo_dispensa_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (43, 7, 2, 'Pessoas físicas', 'atendidos_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (41, 7, 2, 'Pessoas jurídicas', 'empresas_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (753, 68, 2, 'Países', 'public_pais_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (754, 68, 2, 'Estados', 'public_uf_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (755, 68, 2, 'Municípios', 'public_municipio_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (759, 68, 2, 'Distritos', 'public_distrito_lst.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (756, 68, 2, 'Bairros', 'public_bairro_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (757, 68, 2, 'Logradouros', 'public_logradouro_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (758, 68, 2, 'CEP', 'urbano_cep_logradouro_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (581, 55, 2, 'Tipos de benefício do aluno', 'educar_aluno_beneficio_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (575, 55, 2, 'Tipos de transferência da matrícula', 'educar_transferencia_tipo_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (580, 55, 2, 'Tipos de ocorrência disciplinar da matrícula', 'educar_tipo_ocorrencia_disciplinar_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (945, 55, 2, 'Áreas de conhecimento da disciplina', 'module/AreaConhecimento/index', '', 3);
INSERT INTO portal.menu_submenu VALUES (573, 55, 2, 'Tipos de habilitação do curso', 'educar_habilitacao_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (568, 55, 2, 'Tipos de regime do curso', 'educar_tipo_regime_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (558, 55, 2, 'Tipos de ensino do curso', 'educar_tipo_ensino_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (571, 55, 2, 'Tipos de nível ensino do curso', 'educar_nivel_ensino_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (562, 55, 2, 'Tipos de localização da escola', 'educar_escola_localizacao_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (659, 55, 2, 'Enturmações em lote', 'educar_matriculas_turma_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (678, 7, 2, 'Tipos de cor ou raça da pessoa', 'educar_raca_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (631, 7, 2, 'Tipos de deficiência da pessoa', 'educar_deficiencia_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (579, 7, 2, 'Tipos de religião da pessoa', 'educar_religiao_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (21240, 69, 2, 'Usuários de transporte', 'transporte_pessoa_lst.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (21238, 69, 2, 'Rotas do transporte', 'transporte_rota_lst.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (21239, 69, 2, 'Pontos do transporte', 'transporte_ponto_lst.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (21251, 55, 2, 'Bloqueio do ano letivo', 'educar_bloqueio_ano_letivo_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (642, 55, 2, 'Lançamento de faltas e notas', 'module/Avaliacao/diario', '', 3);
INSERT INTO portal.menu_submenu VALUES (21250, 55, 2, 'Tipos de projeto do aluno', 'educar_projeto_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (950, 55, 2, 'Tipos de abandono da matrícula', 'educar_abandono_tipo_lst.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (572, 55, 2, 'Tipos de ambiente da escola', 'educar_infra_comodo_funcao_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (574, 55, 2, 'Infraestrutura da escola', 'educar_infra_predio_comodo_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (21246, 69, 2, 'Cópia de rotas do transporte', 'transporte_copia_rotas.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (761, 68, 2, 'Unificação de bairros', 'educar_unifica_bairro.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (762, 68, 2, 'Unificação de logradouros', 'educar_unifica_logradouro.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (626, 55, 0, 'Alterar datas de entrada/saída de matrículas', '', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (627, 55, 0, 'Cancelar matrícula', '', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (21253, 55, 2, 'Vagas por série/ano', 'educar_serie_vaga_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (999847, 55, 2, 'Unificação de alunos', 'educar_unifica_aluno.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (630, 55, 0, 'Alterar média final do aluno e situação (para regras de avaliação manuais)', '', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (999849, 55, 0, 'Permitir lançamento de notas/faltas fora do período de bloqueio por etapa', '', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (554, 25, 2, 'Tipos de usuário', 'educar_tipo_usuario_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (555, 25, 2, 'Usuários', 'educar_usuario_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (644, 25, 2, 'Atualização de matrículas', 'module/Avaliacao/Promocao', '', 3);
INSERT INTO portal.menu_submenu VALUES (760, 68, 2, 'Setores', 'public_setor_lst.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (999873, 25, 2, 'Configurações gerais', 'educar_configuracoes_gerais.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (999878, 55, 0, 'Permitir editar endereço no cadastro de pessoa física', '', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (592, 57, 2, 'Assuntos de obras', 'educar_acervo_assunto_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (594, 57, 2, 'Autores de obras', 'educar_acervo_autor_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (593, 57, 2, 'Coleções de obras', 'educar_acervo_colecao_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (595, 57, 2, 'Editoras de obras', 'educar_acervo_editora_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (590, 57, 2, 'Idiomas de obras', 'educar_acervo_idioma_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (608, 57, 2, 'Fontes de obras', 'educar_fonte_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (597, 57, 2, 'Tipos de exemplar', 'educar_exemplar_tipo_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (15891, 57, 2, 'Tipos de situação de exemplar', 'educar_situacao_lst.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (600, 57, 2, 'Motivos de baixa do exemplar', 'educar_motivo_baixa_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (596, 57, 2, 'Tipos de cliente', 'educar_cliente_tipo_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (607, 57, 2, 'Motivos de suspensão do cliente', 'educar_motivo_suspensao_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (591, 57, 2, 'Bibliotecas', 'educar_biblioteca_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (603, 57, 2, 'Clientes', 'educar_cliente_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (629, 57, 2, 'Configurações de bibliotecas', 'educar_biblioteca_dados_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (609, 57, 2, 'Reservas de exemplares', 'educar_reservas_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (610, 57, 2, 'Empréstimos de exemplares', 'module/Biblioteca/emprestimo', '', 3);
INSERT INTO portal.menu_submenu VALUES (628, 57, 2, 'Devoluções de exemplares', 'educar_exemplar_devolucao_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (622, 57, 2, 'Dívidas de exemplares', 'educar_pagamento_multa_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (999869, 25, 2, 'Exportação de usuários', 'educar_exportacao_usuarios.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (587, 55, 2, 'Sequências de enturmação', 'educar_sequencia_serie_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (570, 55, 2, 'Tipos de turma', 'educar_turma_tipo_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (567, 55, 2, 'Prédios da escola', 'educar_infra_predio_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (576, 55, 2, 'Tipos de evento do calendário', 'educar_calendario_dia_motivo_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (561, 55, 2, 'Escolas', 'educar_escola_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (566, 55, 2, 'Cursos', 'educar_curso_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (578, 55, 2, 'Alunos', 'educar_aluno_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (647, 55, 2, 'Tipos de rede de ensino da escola', 'educar_escola_rede_ensino_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (999867, 57, 2, 'Categorias de obras', 'educar_categoria_lst.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (846, 70, 2, 'Exportação do educacenso - 1ª fase', 'educar_exportacao_educacenso.php', NULL, 2);
INSERT INTO portal.menu_submenu VALUES (9998845, 70, 2, 'Exportação do educacenso - 2ª fase', 'educar_exportacao_educacenso.php?fase2=1', NULL, 2);
INSERT INTO portal.menu_submenu VALUES (999861, 55, 2, 'Documentação padrão', 'DocumentacaoPadrao.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (583, 55, 2, 'Séries', 'educar_serie_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (586, 55, 2, 'Turmas', 'educar_turma_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (620, 55, 2, 'Calendários', 'educar_calendario_ano_letivo_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (21145, 55, 2, 'Lançamento de ocorrências disciplinares', 'educar_matricula_ocorrencia_disciplinar_cad.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (999613, 55, 2, 'Processamento de históricos escolares', 'module/HistoricoEscolar/processamento', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (999848, 55, 2, 'Bloqueio de lançamento de notas e faltas', 'educar_bloqueio_lancamento_faltas_notas_lst.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (585, 55, 2, 'Séries da escola', 'educar_escola_serie_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (9998867, 25, 2, 'Configuração movimento geral', 'module/Configuracao/ConfiguracaoMovimentoGeral', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (9998869, 25, 2, 'Customização de labels', 'educar_configuracoes_labels.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (9998878, 7, 2, 'Unificação de pessoas', 'educar_unifica_pessoa.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (584, 55, 2, 'Tipos de etapas da escola', 'educar_modulo_lst.php', '', 3);
INSERT INTO portal.menu_submenu VALUES (9998900, 55, 2, 'Consulta de movimento geral', 'educar_consulta_movimento_geral.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (9998910, 55, 2, 'Consulta de movimento mensal', 'educar_consulta_movimento_mensal.php', NULL, 3);
INSERT INTO portal.menu_submenu VALUES (190, 71, 2, 'Vínculos da alocação', 'funcionario_vinculo_lst.php', NULL, 3);


--
-- TOC entry 8395 (class 0 OID 0)
-- Dependencies: 787
-- Name: menu_submenu_cod_menu_submenu_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.menu_submenu_cod_menu_submenu_seq', 9998910, true);


--
-- TOC entry 8078 (class 0 OID 9445535)
-- Dependencies: 790
-- Data for Name: not_portal; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8396 (class 0 OID 0)
-- Dependencies: 789
-- Name: not_portal_cod_not_portal_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.not_portal_cod_not_portal_seq', 1, false);


--
-- TOC entry 8079 (class 0 OID 9445543)
-- Dependencies: 791
-- Data for Name: not_portal_tipo; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8081 (class 0 OID 9445550)
-- Dependencies: 793
-- Data for Name: not_tipo; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8397 (class 0 OID 0)
-- Dependencies: 792
-- Name: not_tipo_cod_not_tipo_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.not_tipo_cod_not_tipo_seq', 1, false);


--
-- TOC entry 8082 (class 0 OID 9445555)
-- Dependencies: 794
-- Data for Name: not_vinc_portal; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8084 (class 0 OID 9445566)
-- Dependencies: 796
-- Data for Name: notificacao; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8398 (class 0 OID 0)
-- Dependencies: 795
-- Name: notificacao_cod_notificacao_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.notificacao_cod_notificacao_seq', 1, false);


--
-- TOC entry 8086 (class 0 OID 9445576)
-- Dependencies: 798
-- Data for Name: pessoa_atividade; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8399 (class 0 OID 0)
-- Dependencies: 797
-- Name: pessoa_atividade_cod_pessoa_atividade_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.pessoa_atividade_cod_pessoa_atividade_seq', 1, false);


--
-- TOC entry 8088 (class 0 OID 9445583)
-- Dependencies: 800
-- Data for Name: pessoa_fj; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8400 (class 0 OID 0)
-- Dependencies: 799
-- Name: pessoa_fj_cod_pessoa_fj_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.pessoa_fj_cod_pessoa_fj_seq', 1, false);


--
-- TOC entry 8089 (class 0 OID 9445592)
-- Dependencies: 801
-- Data for Name: pessoa_fj_pessoa_atividade; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8091 (class 0 OID 9445599)
-- Dependencies: 803
-- Data for Name: pessoa_ramo_atividade; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8401 (class 0 OID 0)
-- Dependencies: 802
-- Name: pessoa_ramo_atividade_cod_ramo_atividade_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.pessoa_ramo_atividade_cod_ramo_atividade_seq', 1, false);


--
-- TOC entry 8402 (class 0 OID 0)
-- Dependencies: 804
-- Name: portal_banner_cod_portal_banner_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.portal_banner_cod_portal_banner_seq', 1, false);


--
-- TOC entry 8094 (class 0 OID 9445607)
-- Dependencies: 806
-- Data for Name: portal_concurso; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8403 (class 0 OID 0)
-- Dependencies: 805
-- Name: portal_concurso_cod_portal_concurso_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.portal_concurso_cod_portal_concurso_seq', 1, false);


--
-- TOC entry 8096 (class 0 OID 9445620)
-- Dependencies: 808
-- Data for Name: sistema; Type: TABLE DATA; Schema: portal; Owner: -
--



--
-- TOC entry 8404 (class 0 OID 0)
-- Dependencies: 807
-- Name: sistema_cod_sistema_seq; Type: SEQUENCE SET; Schema: portal; Owner: -
--

SELECT pg_catalog.setval('portal.sistema_cod_sistema_seq', 1, false);


--
-- TOC entry 7618 (class 0 OID 9443424)
-- Dependencies: 322
-- Data for Name: bairro; Type: TABLE DATA; Schema: public; Owner: -
--



--
-- TOC entry 8097 (class 0 OID 9445632)
-- Dependencies: 810
-- Data for Name: bairro_regiao; Type: TABLE DATA; Schema: public; Owner: -
--



--
-- TOC entry 8405 (class 0 OID 0)
-- Dependencies: 537
-- Name: bloqueio_lancamento_faltas_notas_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.bloqueio_lancamento_faltas_notas_seq', 1, false);


--
-- TOC entry 8098 (class 0 OID 9445635)
-- Dependencies: 811
-- Data for Name: changelog; Type: TABLE DATA; Schema: public; Owner: -
--

INSERT INTO public.changelog VALUES (2, 'Main', '2010-01-06 18:30:33.677103', '2010-01-06 18:30:33.677103', 'dbdeploy', '2_popula_dados_basicos.sql');
INSERT INTO public.changelog VALUES (1, 'Main', '2010-01-06 18:30:33.678547', '2010-01-06 18:30:33.678547', 'dbdeploy', '1_cria_schema_inicial.sql');
INSERT INTO public.changelog VALUES (3, 'Main', '2010-01-06 18:30:33.67913', '2010-01-06 18:30:33.67913', 'dbdeploy', '3_corrige_sequences.sql');
INSERT INTO public.changelog VALUES (4, 'Main', '2010-01-06 18:30:33.679899', '2010-01-06 18:30:33.679899', 'dbdeploy', '4_permissoes_usuario_tipo_biblioteca.sql');
INSERT INTO public.changelog VALUES (5, 'Main', '2010-01-06 18:30:33.680667', '2010-01-06 18:30:33.680667', 'dbdeploy', '5_corrige_triggers_constrainst.sql');
INSERT INTO public.changelog VALUES (6, 'Main', '2010-01-06 18:30:33.681269', '2010-01-06 18:30:33.681269', 'dbdeploy', '6_cria_schema_modules.sql');
INSERT INTO public.changelog VALUES (7, 'Main', '2010-01-06 18:30:33.682013', '2010-01-06 18:30:33.682013', 'dbdeploy', '7_cria_tabelas_modulo_regra_avaliacao.sql');
INSERT INTO public.changelog VALUES (8, 'Main', '2010-01-06 18:30:33.682883', '2010-01-06 18:30:33.682883', 'dbdeploy', '8_remove_campos_pmieducar_serie.sql');
INSERT INTO public.changelog VALUES (9, 'Main', '2010-01-06 18:30:33.68371', '2010-01-06 18:30:33.68371', 'dbdeploy', '9_atualiza_foreign_key_de_pmieducar_escola_serie_disciplina.sql');
INSERT INTO public.changelog VALUES (10, 'Main', '2010-01-06 18:30:33.693854', '2010-01-06 18:30:33.693854', 'dbdeploy', '10_remove_campos_pmieducar_curso.sql');
INSERT INTO public.changelog VALUES (11, 'Main', '2010-01-06 18:30:33.694934', '2010-01-06 18:30:33.694934', 'dbdeploy', '11_adiciona_foreign_key_entre_pmieducar_serie_e_modules_regra_avaliacao.sql');
INSERT INTO public.changelog VALUES (12, 'Main', '2010-01-06 18:30:33.695678', '2010-01-06 18:30:33.695678', 'dbdeploy', '12_cria_tabelas_modulo_avaliacao.sql');
INSERT INTO public.changelog VALUES (13, 'Main', '2010-01-06 18:30:33.696349', '2010-01-06 18:30:33.696349', 'dbdeploy', '13_adiciona_campo_carga_horaria_pmieducar_escola_serie_disciplina_modules_componente_curricular_ano_escolar');
INSERT INTO public.changelog VALUES (14, 'Main', '2010-01-06 18:30:33.697086', '2010-01-06 18:30:33.697086', 'dbdeploy', '14_adiciona_campo_etapa_modules_nota_componente_curricular_media.sql');
INSERT INTO public.changelog VALUES (15, 'Main', '2010-01-06 18:30:33.697897', '2010-01-06 18:30:33.697897', 'dbdeploy', '15_atualiza_foreign_key_modules_falta_geral.sql');
INSERT INTO public.changelog VALUES (16, 'Main', '2010-01-06 18:30:33.698535', '2010-01-06 18:30:33.698535', 'dbdeploy', '16_permissoes_para_modules_e_correcao_menus.sql');


--
-- TOC entry 8099 (class 0 OID 9445641)
-- Dependencies: 812
-- Data for Name: distrito; Type: TABLE DATA; Schema: public; Owner: -
--

INSERT INTO public.distrito VALUES (43, NULL, 43, 'Sao Felipe D Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.747041', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (258, NULL, 258, 'Santa Isabel do Para', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.990198', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (351, NULL, 351, 'Couto de Magalhaes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.089684', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (436, NULL, 436, 'Sao Valerio da Natividade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.187014', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (591, NULL, 591, 'Pindare Mirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.359225', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (679, NULL, 679, 'Aroeira do Itaim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.453076', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (684, NULL, 684, 'Barra D Alcantara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.457797', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (809, NULL, 809, 'Olho D Agua do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.590304', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1291, NULL, 1291, 'Campo de Santana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.13001', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1419, NULL, 1419, 'Sao Domingos de Pombal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.26811', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1481, NULL, 1481, 'Belem de Sao Francisco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.335218', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1539, NULL, 1539, 'Iguaraci', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.397826', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1546, NULL, 1546, 'Itamaraca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.404483', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1561, NULL, 1561, 'Lagoa do Itaenga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.424018', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1886, NULL, 1886, 'Cacule', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.765572', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1965, NULL, 1965, 'Governador Lomanto Junior', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.849918', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2050, NULL, 2050, 'Laje', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.939756', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2337, NULL, 2337, 'Brasopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.258428', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2773, NULL, 2773, 'Olhos-d Agua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.728505', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2800, NULL, 2800, 'Passa Vinte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.763219', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2834, NULL, 2834, 'Pingo D Agua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.80073', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3013, NULL, 3013, 'Sem Peixe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.996865', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3053, NULL, 3053, 'Tocos do Mogi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.038237', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3226, NULL, 3226, 'Parati', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.221078', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3260, NULL, 3260, 'Trajano de Morais', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.258533', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3434, NULL, 3434, 'Embu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.451765', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3495, NULL, 3495, 'Iepe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.527707', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3613, NULL, 3613, 'Mogi Mirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.656906', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 3830, 'Sao Paulo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.897057', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3944, NULL, 3944, 'Bela Vista do Caroba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.022147', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4037, NULL, 4037, 'Goio-ere', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.129581', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4503, NULL, 4503, 'Picarras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.637358', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4708, NULL, 4708, 'Chiapeta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.85595', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4973, NULL, 4973, 'Santana do Livramento', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.143302', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5111, NULL, 5111, 'Bataipora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.298595', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5185, NULL, 5185, 'Apiacas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.379176', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5215, NULL, 5215, 'Cuverlandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.415073', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5318, NULL, 5318, 'Abadia de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.531009', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2243, NULL, 2243, 'Abadia dos Dourados', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.154189', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5319, NULL, 5319, 'Abadiania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.53199', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2244, NULL, 2244, 'Abaete', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.155248', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (151, NULL, 151, 'Abaetetuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.867591', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (890, NULL, 890, 'Abaiara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.684498', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1826, NULL, 1826, 'Abaira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.705862', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1827, NULL, 1827, 'Abare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.706776', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3911, NULL, 3911, 'Abatia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.985397', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4310, NULL, 4310, 'Abdon Batista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.428638', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (152, NULL, 152, 'Abel Figueiredo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.868448', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4311, NULL, 4311, 'Abelardo Luz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.429547', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2245, NULL, 2245, 'Abre Campo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.158797', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1464, NULL, 1464, 'Abreu e Lima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.314455', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (310, NULL, 310, 'Abreulandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.044063', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2246, NULL, 2246, 'Acaiaca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.164872', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (449, NULL, 449, 'Acailandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.198538', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1828, NULL, 1828, 'Acajutiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.707772', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (153, NULL, 153, 'Acara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.869342', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (891, NULL, 891, 'Acarape', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.685459', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (892, NULL, 892, 'Acarau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.686316', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1074, NULL, 1074, 'Acari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.891402', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (666, NULL, 666, 'Acaua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.441086', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4603, NULL, 4603, 'Acegua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.747752', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (893, NULL, 893, 'Acopiara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.687319', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5177, NULL, 5177, 'Acorizal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.372079', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (53, NULL, 53, 'Acrelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.756206', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5320, NULL, 5320, 'Acreuna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.532886', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1075, NULL, 1075, 'Acu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.892249', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2247, NULL, 2247, 'Acucena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.166041', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3266, NULL, 3266, 'Adamantina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.269835', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5321, NULL, 5321, 'Adelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.533668', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3267, NULL, 3267, 'Adolfo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.27087', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3912, NULL, 3912, 'Adrianopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.986287', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1829, NULL, 1829, 'Adustina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.708678', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1465, NULL, 1465, 'Afogados da Ingazeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.315369', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1076, NULL, 1076, 'Afonso Bezerra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.893143', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3096, NULL, 3096, 'Afonso Claudio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.082886', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (450, NULL, 450, 'Afonso Cunha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.199462', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1466, NULL, 1466, 'Afranio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.316283', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (154, NULL, 154, 'Afua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.87027', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1467, NULL, 1467, 'Agrestina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.317184', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (667, NULL, 667, 'Agricolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.44202', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4312, NULL, 4312, 'Agrolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.430478', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4313, NULL, 4313, 'Agronomica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.431358', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (155, NULL, 155, 'Agua Azul do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.871096', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2248, NULL, 2248, 'Agua Boa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.166914', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5178, NULL, 5178, 'Agua Boa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.372947', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (668, NULL, 668, 'Agua Branca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.443259', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1241, NULL, 1241, 'Agua Branca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.071439', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1649, NULL, 1649, 'Agua Branca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.515958', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5099, NULL, 5099, 'Agua Clara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.287518', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2249, NULL, 2249, 'Agua Comprida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.167694', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4314, NULL, 4314, 'Agua Doce', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.43226', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (451, NULL, 451, 'Agua Doce do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.200279', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3097, NULL, 3097, 'Agua Doce do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.08375', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1830, NULL, 1830, 'Agua Fria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.709564', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5322, NULL, 5322, 'Agua Fria de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.534826', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5323, NULL, 5323, 'Agua Limpa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.535749', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1077, NULL, 1077, 'Agua Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.894078', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1468, NULL, 1468, 'Agua Preta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.318148', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4604, NULL, 4604, 'Agua Santa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.748623', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3268, NULL, 3268, 'Aguai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.27173', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2250, NULL, 2250, 'Aguanil', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.168652', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1469, NULL, 1469, 'Aguas Belas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.319228', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3269, NULL, 3269, 'Aguas da Prata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.272445', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4315, NULL, 4315, 'Aguas de Chapeco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.433055', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3270, NULL, 3270, 'Aguas de Lindoia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.273402', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3271, NULL, 3271, 'Aguas de Santa Barbara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.274253', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3272, NULL, 3272, 'Aguas de Sao Pedro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.275125', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2251, NULL, 2251, 'Aguas Formosas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.169451', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4316, NULL, 4316, 'Aguas Frias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.43394', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5324, NULL, 5324, 'Aguas Lindas de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.53668', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4317, NULL, 4317, 'Aguas Mornas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.434905', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2252, NULL, 2252, 'Aguas Vermelhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.170365', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4605, NULL, 4605, 'Agudo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.749535', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3273, NULL, 3273, 'Agudos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.276017', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3913, NULL, 3913, 'Agudos do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.987196', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3098, NULL, 3098, 'Aguia Branca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.084678', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1242, NULL, 1242, 'Aguiar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.072434', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (311, NULL, 311, 'Aguiarnopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.045079', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2253, NULL, 2253, 'Aimores', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.171249', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1831, NULL, 1831, 'Aiquara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.710453', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (894, NULL, 894, 'Aiuaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.688458', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2254, NULL, 2254, 'Aiuruoca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.172198', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4606, NULL, 4606, 'Ajuricaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.750335', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2255, NULL, 2255, 'Alagoa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.17309', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1243, NULL, 1243, 'Alagoa Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.073282', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1244, NULL, 1244, 'Alagoa Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.074227', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1470, NULL, 1470, 'Alagoinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.320145', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1245, NULL, 1245, 'Alagoinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.075158', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (669, NULL, 669, 'Alagoinha do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.444215', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1832, NULL, 1832, 'Alagoinhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.711342', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3274, NULL, 3274, 'Alambari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.276922', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2256, NULL, 2256, 'Albertina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.174065', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (452, NULL, 452, 'Alcantara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.201164', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (895, NULL, 895, 'Alcantaras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.68946', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1246, NULL, 1246, 'Alcantil', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.076009', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5100, NULL, 5100, 'Alcinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.288446', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1833, NULL, 1833, 'Alcobaca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.712309', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (453, NULL, 453, 'Aldeias Altas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.202176', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4607, NULL, 4607, 'Alecrim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.751293', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3099, NULL, 3099, 'Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.085605', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4608, NULL, 4608, 'Alegrete', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.75216', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (670, NULL, 670, 'Alegrete do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.445155', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4609, NULL, 4609, 'Alegria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.752979', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2257, NULL, 2257, 'Alem Paraiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.175052', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (156, NULL, 156, 'Alenquer', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.872038', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1078, NULL, 1078, 'Alexandria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.895039', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5325, NULL, 5325, 'Alexania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.537739', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2258, NULL, 2258, 'Alfenas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.176142', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3100, NULL, 3100, 'Alfredo Chaves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.086469', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3275, NULL, 3275, 'Alfredo Marcondes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.277864', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2259, NULL, 2259, 'Alfredo Vasconcelos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.177086', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4318, NULL, 4318, 'Alfredo Wagner', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.435771', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1247, NULL, 1247, 'Algodao de Jandaira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.076841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1248, NULL, 1248, 'Alhandra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.07777', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1471, NULL, 1471, 'Alianca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.32101', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (312, NULL, 312, 'Alianca do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.04621', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1834, NULL, 1834, 'Almadina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.713183', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (313, NULL, 313, 'Almas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.047192', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (157, NULL, 157, 'Almeirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.872959', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2260, NULL, 2260, 'Almenara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.17799', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1079, NULL, 1079, 'Almino Afonso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.895926', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3914, NULL, 3914, 'Almirante Tamandare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.988188', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4610, NULL, 4610, 'Almirante Tamandare do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.75392', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5326, NULL, 5326, 'Aloandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.53862', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2261, NULL, 2261, 'Alpercata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.178942', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4611, NULL, 4611, 'Alpestre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.754809', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2262, NULL, 2262, 'Alpinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.179848', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5179, NULL, 5179, 'Alta Floresta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.373825', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1, NULL, 1, 'Alta Floresta D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.699228', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3276, NULL, 3276, 'Altair', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.278774', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (158, NULL, 158, 'Altamira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.873993', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (454, NULL, 454, 'Altamira do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.203261', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3915, NULL, 3915, 'Altamira do Parana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.989098', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (896, NULL, 896, 'Altaneira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.690345', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2263, NULL, 2263, 'Alterosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.180759', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1472, NULL, 1472, 'Altinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.321895', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3277, NULL, 3277, 'Altinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.279605', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4612, NULL, 4612, 'Alto Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.755767', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3278, NULL, 3278, 'Alto Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.280491', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (136, NULL, 136, 'Alto Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.846512', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (455, NULL, 455, 'Alto Alegre do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.204215', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (456, NULL, 456, 'Alto Alegre do Pindare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.205089', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2, NULL, 2, 'Alto Alegre dos Parecis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.700901', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5180, NULL, 5180, 'Alto Araguaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.374753', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4319, NULL, 4319, 'Alto Bela Vista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.43669', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5181, NULL, 5181, 'Alto Boa Vista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.375625', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2264, NULL, 2264, 'Alto Caparao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.181657', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1080, NULL, 1080, 'Alto do Rodrigues', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.896798', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4613, NULL, 4613, 'Alto Feliz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.756681', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5182, NULL, 5182, 'Alto Garcas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.376478', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5327, NULL, 5327, 'Alto Horizonte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.539517', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2265, NULL, 2265, 'Alto Jequitiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.182618', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (671, NULL, 671, 'Alto Longa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.446035', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5183, NULL, 5183, 'Alto Paraguai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.37727', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3, NULL, 3, 'Alto Paraiso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.701715', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3916, NULL, 3916, 'Alto Paraiso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.99001', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5328, NULL, 5328, 'Alto Paraiso de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.540454', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3917, NULL, 3917, 'Alto Parana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.990938', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (457, NULL, 457, 'Alto Parnaiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.206158', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3918, NULL, 3918, 'Alto Piquiri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.991839', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2266, NULL, 2266, 'Alto Rio Doce', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.183515', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3101, NULL, 3101, 'Alto Rio Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.087312', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (897, NULL, 897, 'Alto Santo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.691214', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5184, NULL, 5184, 'Alto Taquari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.378248', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3919, NULL, 3919, 'Altonia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.992748', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (672, NULL, 672, 'Altos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.446996', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3279, NULL, 3279, 'Aluminio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.281409', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (75, NULL, 75, 'Alvaraes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.783307', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2267, NULL, 2267, 'Alvarenga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.184402', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3280, NULL, 3280, 'Alvares Florence', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.282369', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3281, NULL, 3281, 'Alvares Machado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.283238', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3282, NULL, 3282, 'Alvaro de Carvalho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.284169', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3283, NULL, 3283, 'Alvinlandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.285077', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2268, NULL, 2268, 'Alvinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.185229', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (314, NULL, 314, 'Alvorada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.048146', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4614, NULL, 4614, 'Alvorada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.75756', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4, NULL, 4, 'Alvorada D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.70262', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2269, NULL, 2269, 'Alvorada de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.186152', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (673, NULL, 673, 'Alvorada do Gurgueia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.447826', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5329, NULL, 5329, 'Alvorada do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.541418', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3920, NULL, 3920, 'Alvorada do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.99372', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (137, NULL, 137, 'Amajari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.853924', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5101, NULL, 5101, 'Amambai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.289301', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (294, NULL, 294, 'Amapa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.029605', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (458, NULL, 458, 'Amapa do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.20716', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3921, NULL, 3921, 'Amapora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.99467', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1473, NULL, 1473, 'Amaraji', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.322767', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4615, NULL, 4615, 'Amaral Ferrador', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.758517', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5330, NULL, 5330, 'Amaralina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.542313', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (674, NULL, 674, 'Amarante', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.448565', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (459, NULL, 459, 'Amarante do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.208081', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1835, NULL, 1835, 'Amargosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.714102', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (76, NULL, 76, 'Amatura', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.78444', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1836, NULL, 1836, 'Amelia Rodrigues', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.714937', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1837, NULL, 1837, 'America Dourada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.715822', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3284, NULL, 3284, 'Americana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.286013', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5331, NULL, 5331, 'Americano do Brasil', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.543192', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3285, NULL, 3285, 'Americo Brasiliense', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.286803', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3286, NULL, 3286, 'Americo de Campos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.287738', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4616, NULL, 4616, 'Ametista do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.759328', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (898, NULL, 898, 'Amontada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.692091', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5332, NULL, 5332, 'Amorinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.544118', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1249, NULL, 1249, 'Amparo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.078587', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3287, NULL, 3287, 'Amparo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.288607', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1751, NULL, 1751, 'Amparo de Sao Francisco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.626967', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2270, NULL, 2270, 'Amparo do Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.187321', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3922, NULL, 3922, 'Ampere', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.995648', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1650, NULL, 1650, 'Anadia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.516876', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1838, NULL, 1838, 'Anage', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.716687', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3923, NULL, 3923, 'Anahy', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.996625', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (159, NULL, 159, 'Anajas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.874868', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (460, NULL, 460, 'Anajatuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.208976', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3288, NULL, 3288, 'Analandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.2895', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (77, NULL, 77, 'Anama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.785298', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (315, NULL, 315, 'Ananas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.049117', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (160, NULL, 160, 'Ananindeua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.875805', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5333, NULL, 5333, 'Anapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.544995', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (161, NULL, 161, 'Anapu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.87672', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (461, NULL, 461, 'Anapurus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.209855', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5102, NULL, 5102, 'Anastacio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.290239', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5103, NULL, 5103, 'Anaurilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.291232', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4320, NULL, 4320, 'Anchieta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.43753', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3102, NULL, 3102, 'Anchieta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.088204', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1839, NULL, 1839, 'Andarai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.717527', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3924, NULL, 3924, 'Andira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.997681', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1840, NULL, 1840, 'Andorinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.718396', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2271, NULL, 2271, 'Andradas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.188228', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3289, NULL, 3289, 'Andradina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.290456', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4617, NULL, 4617, 'Andre da Rocha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.760208', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2272, NULL, 2272, 'Andrelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.189253', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3290, NULL, 3290, 'Angatuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.291244', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2273, NULL, 2273, 'Angelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.190148', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5104, NULL, 5104, 'Angelica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.292032', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1474, NULL, 1474, 'Angelim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.32367', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4321, NULL, 4321, 'Angelina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.43846', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1841, NULL, 1841, 'Angical', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.719204', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (675, NULL, 675, 'Angical do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.449534', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (316, NULL, 316, 'Angico', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.050076', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1081, NULL, 1081, 'Angicos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.897649', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3174, NULL, 3174, 'Angra dos Reis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.16759', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1842, NULL, 1842, 'Anguera', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.720208', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3925, NULL, 3925, 'Angulo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.004728', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5334, NULL, 5334, 'Anhanguera', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.545877', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3291, NULL, 3291, 'Anhembi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.29216', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3292, NULL, 3292, 'Anhumas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.293119', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5335, NULL, 5335, 'Anicuns', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.54685', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (676, NULL, 676, 'Anisio de Abreu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.450473', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4322, NULL, 4322, 'Anita Garibaldi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.439314', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4323, NULL, 4323, 'Anitapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.440162', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (78, NULL, 78, 'Anori', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.7862', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4618, NULL, 4618, 'Anta Gorda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.760999', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1843, NULL, 1843, 'Antas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.720988', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3926, NULL, 3926, 'Antonina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.005854', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (899, NULL, 899, 'Antonina do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.693258', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (677, NULL, 677, 'Antonio Almeida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.451325', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1844, NULL, 1844, 'Antonio Cardoso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.721872', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2274, NULL, 2274, 'Antonio Carlos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.19103', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4324, NULL, 4324, 'Antonio Carlos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.440943', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2275, NULL, 2275, 'Antonio Dias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.191859', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1845, NULL, 1845, 'Antonio Goncalves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.72283', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5105, NULL, 5105, 'Antonio Joao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.293133', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1082, NULL, 1082, 'Antonio Martins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.898468', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3927, NULL, 3927, 'Antonio Olinto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.007012', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4619, NULL, 4619, 'Antonio Prado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.76193', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2276, NULL, 2276, 'Antonio Prado de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.192799', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3293, NULL, 3293, 'Aparecida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.293914', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1250, NULL, 1250, 'Aparecida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.079657', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3294, NULL, 3294, 'Aparecida D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.294812', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5336, NULL, 5336, 'Aparecida de Goiania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.547789', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5337, NULL, 5337, 'Aparecida do Rio Doce', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.548635', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (317, NULL, 317, 'Aparecida do Rio Negro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.050987', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5106, NULL, 5106, 'Aparecida do Taboado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.294053', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3175, NULL, 3175, 'Aperibe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.168353', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3103, NULL, 3103, 'Apiaca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.089062', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3295, NULL, 3295, 'Apiai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.295701', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (462, NULL, 462, 'Apicum-acu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.210782', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4325, NULL, 4325, 'Apiuna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.441712', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1083, NULL, 1083, 'Apodi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.899511', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1846, NULL, 1846, 'Apora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.723737', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5338, NULL, 5338, 'Apore', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.549452', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1847, NULL, 1847, 'Apuarema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.72468', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3928, NULL, 3928, 'Apucarana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.007903', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (79, NULL, 79, 'Apui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.787062', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (900, NULL, 900, 'Apuiares', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.69425', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1752, NULL, 1752, 'Aquidaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.627865', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5107, NULL, 5107, 'Aquidauana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.294884', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (901, NULL, 901, 'Aquiraz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.695167', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4326, NULL, 4326, 'Arabuta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.442617', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1251, NULL, 1251, 'Aracagi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.086461', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2277, NULL, 2277, 'Aracai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.193762', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1753, NULL, 1753, 'Aracaju', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.628811', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3296, NULL, 3296, 'Aracariguama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.29661', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1848, NULL, 1848, 'Aracas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.725609', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (902, NULL, 902, 'Aracati', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.69614', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1849, NULL, 1849, 'Aracatu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.72638', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3297, NULL, 3297, 'Aracatuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.297483', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1850, NULL, 1850, 'Araci', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.727157', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2278, NULL, 2278, 'Aracitaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.194635', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (903, NULL, 903, 'Aracoiaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.69696', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1475, NULL, 1475, 'Aracoiaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.324482', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3298, NULL, 3298, 'Aracoiaba da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.298305', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3104, NULL, 3104, 'Aracruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.089943', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5339, NULL, 5339, 'Aracu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.550511', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2279, NULL, 2279, 'Aracuai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.195558', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5340, NULL, 5340, 'Aragarcas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.551456', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5341, NULL, 5341, 'Aragoiania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.558409', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (318, NULL, 318, 'Aragominas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.051903', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (319, NULL, 319, 'Araguacema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.052846', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (320, NULL, 320, 'Araguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.053962', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5186, NULL, 5186, 'Araguaiana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.380109', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (321, NULL, 321, 'Araguaina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.061617', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5187, NULL, 5187, 'Araguainha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.381101', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (322, NULL, 322, 'Araguana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.062755', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (463, NULL, 463, 'Araguana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.211696', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5342, NULL, 5342, 'Araguapaz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.559799', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2280, NULL, 2280, 'Araguari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.196367', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (323, NULL, 323, 'Araguatins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.063685', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (464, NULL, 464, 'Araioses', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.212717', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5108, NULL, 5108, 'Aral Moreira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.29572', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1851, NULL, 1851, 'Aramari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.727919', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4620, NULL, 4620, 'Arambare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.763109', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (465, NULL, 465, 'Arame', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.21353', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3299, NULL, 3299, 'Aramina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.299187', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3300, NULL, 3300, 'Arandu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.299986', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2281, NULL, 2281, 'Arantina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.197243', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3301, NULL, 3301, 'Arapei', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.300898', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1651, NULL, 1651, 'Arapiraca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.517813', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (324, NULL, 324, 'Arapoema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.064569', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2282, NULL, 2282, 'Araponga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.198178', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3929, NULL, 3929, 'Arapongas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.008811', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2283, NULL, 2283, 'Arapora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.203217', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3930, NULL, 3930, 'Arapoti', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.009634', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3931, NULL, 3931, 'Arapua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.010641', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2284, NULL, 2284, 'Arapua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.205244', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5188, NULL, 5188, 'Araputanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.382033', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4327, NULL, 4327, 'Araquari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.44364', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1252, NULL, 1252, 'Arara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.087625', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4328, NULL, 4328, 'Ararangua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.444439', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3302, NULL, 3302, 'Araraquara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.301802', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3303, NULL, 3303, 'Araras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.308817', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (904, NULL, 904, 'Ararenda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.697861', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (466, NULL, 466, 'Arari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.214388', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4621, NULL, 4621, 'Ararica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.76479', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (905, NULL, 905, 'Araripe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.698832', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1476, NULL, 1476, 'Araripina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.330102', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3176, NULL, 3176, 'Araruama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.169167', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1253, NULL, 1253, 'Araruna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.088977', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3932, NULL, 3932, 'Araruna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.011512', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1852, NULL, 1852, 'Arataca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.728798', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4622, NULL, 4622, 'Aratiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.765569', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (906, NULL, 906, 'Aratuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.69974', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1853, NULL, 1853, 'Aratuipe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.729676', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1754, NULL, 1754, 'Araua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.629694', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3933, NULL, 3933, 'Araucaria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.012356', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2285, NULL, 2285, 'Araujos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.206219', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2286, NULL, 2286, 'Araxa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.207117', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2287, NULL, 2287, 'Arceburgo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.207902', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3304, NULL, 3304, 'Arco-iris', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.31001', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2288, NULL, 2288, 'Arcos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.208814', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1477, NULL, 1477, 'Arcoverde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.331269', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2289, NULL, 2289, 'Areado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.209723', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3177, NULL, 3177, 'Areal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.170131', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3305, NULL, 3305, 'Arealva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.311055', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1254, NULL, 1254, 'Areia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.089891', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1755, NULL, 1755, 'Areia Branca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.630578', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1084, NULL, 1084, 'Areia Branca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.900457', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1255, NULL, 1255, 'Areia de Baraunas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.090763', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1256, NULL, 1256, 'Areial', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.09166', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3306, NULL, 3306, 'Areias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.31192', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3307, NULL, 3307, 'Areiopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.312751', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5189, NULL, 5189, 'Arenapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.383142', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5343, NULL, 5343, 'Arenopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.5608', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1085, NULL, 1085, 'Ares', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.901317', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2290, NULL, 2290, 'Argirita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.210605', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2291, NULL, 2291, 'Aricanduva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.211483', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2292, NULL, 2292, 'Arinos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.212377', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5190, NULL, 5190, 'Aripuana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.383975', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5, NULL, 5, 'Ariquemes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.703562', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3308, NULL, 3308, 'Ariranha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.313577', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3934, NULL, 3934, 'Ariranha do Ivai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.013245', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3178, NULL, 3178, 'Armacao dos Buzios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.171024', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4329, NULL, 4329, 'Armazem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.445254', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (907, NULL, 907, 'Arneiroz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.700663', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (678, NULL, 678, 'Aroazes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.452206', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1257, NULL, 1257, 'Aroeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.092651', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (680, NULL, 680, 'Arraial', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.453937', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3179, NULL, 3179, 'Arraial do Cabo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.171933', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (325, NULL, 325, 'Arraias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.06559', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4623, NULL, 4623, 'Arroio do Meio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.766691', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4624, NULL, 4624, 'Arroio do Padre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.767588', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4625, NULL, 4625, 'Arroio do Sal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.768531', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4626, NULL, 4626, 'Arroio do Tigre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.769457', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4627, NULL, 4627, 'Arroio dos Ratos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.770348', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4628, NULL, 4628, 'Arroio Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.771225', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4330, NULL, 4330, 'Arroio Trinta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.446176', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3309, NULL, 3309, 'Artur Nogueira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.314489', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5344, NULL, 5344, 'Aruana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.561736', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3310, NULL, 3310, 'Aruja', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.315495', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4331, NULL, 4331, 'Arvoredo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.447106', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4629, NULL, 4629, 'Arvorezinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.772101', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4332, NULL, 4332, 'Ascurra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.44797', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3311, NULL, 3311, 'Aspasia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.316308', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3935, NULL, 3935, 'Assai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.014083', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (908, NULL, 908, 'Assare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.701591', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3312, NULL, 3312, 'Assis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.317358', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (54, NULL, 54, 'Assis Brasil', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.757065', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3936, NULL, 3936, 'Assis Chateaubriand', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.014967', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1258, NULL, 1258, 'Assuncao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.093528', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (681, NULL, 681, 'Assuncao do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.454994', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2293, NULL, 2293, 'Astolfo Dutra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.213327', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3937, NULL, 3937, 'Astorga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.015824', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1652, NULL, 1652, 'Atalaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.518801', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3938, NULL, 3938, 'Atalaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.016716', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (80, NULL, 80, 'Atalaia do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.787924', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4333, NULL, 4333, 'Atalanta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.448887', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2294, NULL, 2294, 'Ataleia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.214154', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3313, NULL, 3313, 'Atibaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.318277', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3105, NULL, 3105, 'Atilio Vivacqua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.09086', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (326, NULL, 326, 'Augustinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.066518', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (162, NULL, 162, 'Augusto Correa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.877656', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2295, NULL, 2295, 'Augusto de Lima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.21493', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4630, NULL, 4630, 'Augusto Pestana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.772977', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1086, NULL, 1086, 'Augusto Severo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.902303', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4631, NULL, 4631, 'Aurea', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.773902', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1854, NULL, 1854, 'Aurelino Leal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.730623', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3314, NULL, 3314, 'Auriflama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.319244', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5345, NULL, 5345, 'Aurilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.562641', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (909, NULL, 909, 'Aurora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.702351', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4334, NULL, 4334, 'Aurora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.449795', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (163, NULL, 163, 'Aurora do Para', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.878762', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (327, NULL, 327, 'Aurora do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.067488', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (81, NULL, 81, 'Autazes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.788882', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3315, NULL, 3315, 'Avai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.320115', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3316, NULL, 3316, 'Avanhandava', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.320988', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3317, NULL, 3317, 'Avare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.321877', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (164, NULL, 164, 'Aveiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.879577', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (682, NULL, 682, 'Avelino Lopes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.455933', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5346, NULL, 5346, 'Avelinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.563516', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (467, NULL, 467, 'Axixa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.215297', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (328, NULL, 328, 'Axixa do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.06855', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (329, NULL, 329, 'Babaculandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.069459', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (468, NULL, 468, 'Bacabal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.21624', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (469, NULL, 469, 'Bacabeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.217163', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (470, NULL, 470, 'Bacuri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.218068', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (471, NULL, 471, 'Bacurituba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.218906', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3318, NULL, 3318, 'Bady Bassitt', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.322788', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2296, NULL, 2296, 'Baependi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.215936', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4632, NULL, 4632, 'Bage', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.774733', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (165, NULL, 165, 'Bagre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.88047', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1259, NULL, 1259, 'Baia da Traicao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.094762', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1087, NULL, 1087, 'Baia Formosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.903218', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1855, NULL, 1855, 'Baianopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.731629', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (166, NULL, 166, 'Baiao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.881428', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1856, NULL, 1856, 'Baixa Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.732415', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (683, NULL, 683, 'Baixa Grande do Ribeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.456842', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (910, NULL, 910, 'Baixio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.703411', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3106, NULL, 3106, 'Baixo Guandu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.091737', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3319, NULL, 3319, 'Balbinos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.32373', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2297, NULL, 2297, 'Baldim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.216871', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5347, NULL, 5347, 'Baliza', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.564819', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4335, NULL, 4335, 'Balneario Arroio do Silva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.450698', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4336, NULL, 4336, 'Balneario Barra do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.451594', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4337, NULL, 4337, 'Balneario Camboriu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.45249', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4338, NULL, 4338, 'Balneario Gaivota', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.453461', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4633, NULL, 4633, 'Balneario Pinhal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.775604', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3939, NULL, 3939, 'Balsa Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.017615', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3320, NULL, 3320, 'Balsamo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.324586', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (472, NULL, 472, 'Balsas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.226511', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2298, NULL, 2298, 'Bambui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.217768', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (911, NULL, 911, 'Banabuiu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.704293', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3321, NULL, 3321, 'Bananal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.325482', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1260, NULL, 1260, 'Bananeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.0956', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2299, NULL, 2299, 'Bandeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.218649', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2300, NULL, 2300, 'Bandeira do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.219508', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4339, NULL, 4339, 'Bandeirante', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.460344', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5109, NULL, 5109, 'Bandeirantes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.296713', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3940, NULL, 3940, 'Bandeirantes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.018653', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (330, NULL, 330, 'Bandeirantes do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.070302', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (167, NULL, 167, 'Bannach', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.882419', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1857, NULL, 1857, 'Banzae', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.733268', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4634, NULL, 4634, 'Barao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.776395', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3322, NULL, 3322, 'Barao de Antonina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.326512', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2301, NULL, 2301, 'Barao de Cocais', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.220377', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4635, NULL, 4635, 'Barao de Cotegipe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.777163', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (473, NULL, 473, 'Barao de Grajau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.227641', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5191, NULL, 5191, 'Barao de Melgaco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.384902', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2302, NULL, 2302, 'Barao de Monte Alto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.221268', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4636, NULL, 4636, 'Barao do Triunfo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.778243', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1261, NULL, 1261, 'Barauna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.096454', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1088, NULL, 1088, 'Barauna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.904292', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2303, NULL, 2303, 'Barbacena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.222198', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (912, NULL, 912, 'Barbalha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.705191', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3323, NULL, 3323, 'Barbosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.327365', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3941, NULL, 3941, 'Barbosa Ferraz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.019459', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (168, NULL, 168, 'Barcarena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.883321', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1089, NULL, 1089, 'Barcelona', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.905211', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (82, NULL, 82, 'Barcelos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.789694', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3324, NULL, 3324, 'Bariri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.328252', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1858, NULL, 1858, 'Barra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.734163', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4340, NULL, 4340, 'Barra Bonita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.461537', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3325, NULL, 3325, 'Barra Bonita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.329113', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1859, NULL, 1859, 'Barra da Estiva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.735027', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1478, NULL, 1478, 'Barra de Guabiraba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.332372', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1262, NULL, 1262, 'Barra de Santa Rosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.097433', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1263, NULL, 1263, 'Barra de Santana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.098328', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1653, NULL, 1653, 'Barra de Santo Antonio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.519858', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3107, NULL, 3107, 'Barra de Sao Francisco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.092835', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1264, NULL, 1264, 'Barra de Sao Miguel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.099207', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1654, NULL, 1654, 'Barra de Sao Miguel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.520772', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5192, NULL, 5192, 'Barra do Bugres', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.385821', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3326, NULL, 3326, 'Barra do Chapeu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.329955', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1860, NULL, 1860, 'Barra do Choca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.735986', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (474, NULL, 474, 'Barra do Corda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.228529', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5193, NULL, 5193, 'Barra do Garcas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.386784', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4637, NULL, 4637, 'Barra do Guarita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.784613', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3942, NULL, 3942, 'Barra do Jacare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.020318', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1861, NULL, 1861, 'Barra do Mendes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.736784', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (331, NULL, 331, 'Barra do Ouro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.071172', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3180, NULL, 3180, 'Barra do Pirai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.172817', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4638, NULL, 4638, 'Barra do Quarai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.786135', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4639, NULL, 4639, 'Barra do Ribeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.787083', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4640, NULL, 4640, 'Barra do Rio Azul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.787963', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1862, NULL, 1862, 'Barra do Rocha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.737614', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3327, NULL, 3327, 'Barra do Turvo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.330965', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1756, NULL, 1756, 'Barra dos Coqueiros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.631545', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4641, NULL, 4641, 'Barra Funda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.788957', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2304, NULL, 2304, 'Barra Longa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.223036', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3181, NULL, 3181, 'Barra Mansa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.173722', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4341, NULL, 4341, 'Barra Velha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.462448', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4642, NULL, 4642, 'Barracao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.789888', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3943, NULL, 3943, 'Barracao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.021205', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (685, NULL, 685, 'Barras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.458843', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (913, NULL, 913, 'Barreira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.706139', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1863, NULL, 1863, 'Barreiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.743632', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (686, NULL, 686, 'Barreiras do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.460085', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (83, NULL, 83, 'Barreirinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.790558', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (475, NULL, 475, 'Barreirinhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.22946', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1479, NULL, 1479, 'Barreiros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.333472', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3328, NULL, 3328, 'Barretos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.331935', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3329, NULL, 3329, 'Barrinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.332765', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (914, NULL, 914, 'Barro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.707138', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1864, NULL, 1864, 'Barro Alto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.745185', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5348, NULL, 5348, 'Barro Alto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.56604', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (687, NULL, 687, 'Barro Duro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.461037', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1865, NULL, 1865, 'Barrocas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.746183', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (332, NULL, 332, 'Barrolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.072056', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (915, NULL, 915, 'Barroquinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.708104', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4643, NULL, 4643, 'Barros Cassal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.790848', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2305, NULL, 2305, 'Barroso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.22391', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3330, NULL, 3330, 'Barueri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.333592', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3331, NULL, 3331, 'Bastos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.334547', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5110, NULL, 5110, 'Bataguassu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.29763', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1655, NULL, 1655, 'Batalha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.521655', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (688, NULL, 688, 'Batalha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.461931', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3332, NULL, 3332, 'Batatais', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.33538', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (916, NULL, 916, 'Baturite', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.70905', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3333, NULL, 3333, 'Bauru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.336251', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1265, NULL, 1265, 'Bayeux', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.100233', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3334, NULL, 3334, 'Bebedouro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.337171', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (917, NULL, 917, 'Beberibe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.71002', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (918, NULL, 918, 'Bela Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.710898', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5112, NULL, 5112, 'Bela Vista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.299542', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5349, NULL, 5349, 'Bela Vista de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.566961', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2306, NULL, 2306, 'Bela Vista de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.224974', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (476, NULL, 476, 'Bela Vista do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.230349', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3945, NULL, 3945, 'Bela Vista do Paraiso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.023032', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (689, NULL, 689, 'Bela Vista do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.462988', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4342, NULL, 4342, 'Bela Vista do Toldo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.463399', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (477, NULL, 477, 'Belagua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.231267', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1266, NULL, 1266, 'Belem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.101175', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (169, NULL, 169, 'Belem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.884275', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1656, NULL, 1656, 'Belem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.522539', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1480, NULL, 1480, 'Belem de Maria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.334393', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1267, NULL, 1267, 'Belem do Brejo do Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.102014', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5113, NULL, 5113, 'Bodoquena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.300463', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (690, NULL, 690, 'Belem do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.463815', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3182, NULL, 3182, 'Belford Roxo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.174593', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2307, NULL, 2307, 'Belmiro Braga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.225963', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1866, NULL, 1866, 'Belmonte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.747082', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4343, NULL, 4343, 'Belmonte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.464282', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1867, NULL, 1867, 'Belo Campo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.747989', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2308, NULL, 2308, 'Belo Horizonte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.227024', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1482, NULL, 1482, 'Belo Jardim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.336241', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1657, NULL, 1657, 'Belo Monte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.523412', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2309, NULL, 2309, 'Belo Oriente', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.227973', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2310, NULL, 2310, 'Belo Vale', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.228893', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (170, NULL, 170, 'Belterra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.885225', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (691, NULL, 691, 'Beneditinos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.464727', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (478, NULL, 478, 'Benedito Leite', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.232219', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4344, NULL, 4344, 'Benedito Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.465195', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (171, NULL, 171, 'Benevides', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.886172', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (84, NULL, 84, 'Benjamin Constant', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.791396', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4644, NULL, 4644, 'Benjamin Constant do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.791749', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3335, NULL, 3335, 'Bento de Abreu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.338264', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1090, NULL, 1090, 'Bento Fernandes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.906199', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4645, NULL, 4645, 'Bento Goncalves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.792666', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (479, NULL, 479, 'Bequimao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.233065', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2311, NULL, 2311, 'Berilo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.229677', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2312, NULL, 2312, 'Berizal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.230571', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1268, NULL, 1268, 'Bernardino Batista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.102935', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3336, NULL, 3336, 'Bernardino de Campos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.339179', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (480, NULL, 480, 'Bernardo do Mearim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.23398', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (333, NULL, 333, 'Bernardo Sayao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.072885', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3337, NULL, 3337, 'Bertioga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.340015', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (692, NULL, 692, 'Bertolinia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.465651', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2313, NULL, 2313, 'Bertopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.23149', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (85, NULL, 85, 'Beruri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.792246', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1483, NULL, 1483, 'Betania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.337129', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (693, NULL, 693, 'Betania do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.466532', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2314, NULL, 2314, 'Betim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.232321', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1484, NULL, 1484, 'Bezerros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.338076', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2315, NULL, 2315, 'Bias Fortes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.233321', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2316, NULL, 2316, 'Bicas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.23414', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4345, NULL, 4345, 'Biguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.466322', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3338, NULL, 3338, 'Bilac', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.340826', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2317, NULL, 2317, 'Biquinhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.234928', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3339, NULL, 3339, 'Birigui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.341697', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3340, NULL, 3340, 'Biritiba-mirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.342549', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1868, NULL, 1868, 'Biritinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.748862', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3946, NULL, 3946, 'Bituruna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.023906', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4346, NULL, 4346, 'Blumenau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.467185', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3108, NULL, 3108, 'Boa Esperanca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.093704', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3947, NULL, 3947, 'Boa Esperanca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.02483', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2318, NULL, 2318, 'Boa Esperanca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.235855', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3948, NULL, 3948, 'Boa Esperanca do Iguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.025742', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3341, NULL, 3341, 'Boa Esperanca do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.350287', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (694, NULL, 694, 'Boa Hora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.467333', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1869, NULL, 1869, 'Boa Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.749789', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1269, NULL, 1269, 'Boa Ventura', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.10377', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3949, NULL, 3949, 'Boa Ventura de Sao Roque', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.026662', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (919, NULL, 919, 'Boa Viagem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.711755', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1270, NULL, 1270, 'Boa Vista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.104778', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (138, NULL, 138, 'Boa Vista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.855192', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3950, NULL, 3950, 'Boa Vista da Aparecida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.027576', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4646, NULL, 4646, 'Boa Vista das Missoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.793467', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4647, NULL, 4647, 'Boa Vista do Burica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.794351', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4648, NULL, 4648, 'Boa Vista do Cadeado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.795209', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (481, NULL, 481, 'Boa Vista do Gurupi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.234892', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4649, NULL, 4649, 'Boa Vista do Incra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.79609', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (86, NULL, 86, 'Boa Vista do Ramos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.793161', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4650, NULL, 4650, 'Boa Vista do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.796974', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1870, NULL, 1870, 'Boa Vista do Tupim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.750607', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1658, NULL, 1658, 'Boca da Mata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.524257', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (87, NULL, 87, 'Boca do Acre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.794181', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3342, NULL, 3342, 'Bocaina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.351429', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (695, NULL, 695, 'Bocaina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.468202', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2319, NULL, 2319, 'Bocaina de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.236779', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4347, NULL, 4347, 'Bocaina do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.468115', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2320, NULL, 2320, 'Bocaiuva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.23773', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3951, NULL, 3951, 'Bocaiuva do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.028487', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1091, NULL, 1091, 'Bodo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.907136', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1485, NULL, 1485, 'Bodoco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.338907', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3343, NULL, 3343, 'Bofete', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.352408', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3344, NULL, 3344, 'Boituva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.353564', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1486, NULL, 1486, 'Bom Conselho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.339929', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2321, NULL, 2321, 'Bom Despacho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.23865', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (482, NULL, 482, 'Bom Jardim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.235799', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3183, NULL, 3183, 'Bom Jardim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.175369', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1487, NULL, 1487, 'Bom Jardim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.340936', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4348, NULL, 4348, 'Bom Jardim da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.469091', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5350, NULL, 5350, 'Bom Jardim de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.567928', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2322, NULL, 2322, 'Bom Jardim de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.239378', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4349, NULL, 4349, 'Bom Jesus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.469971', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (696, NULL, 696, 'Bom Jesus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.469091', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1271, NULL, 1271, 'Bom Jesus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.105776', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4651, NULL, 4651, 'Bom Jesus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.797947', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1092, NULL, 1092, 'Bom Jesus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.908193', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1871, NULL, 1871, 'Bom Jesus da Lapa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.7516', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2323, NULL, 2323, 'Bom Jesus da Penha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.245946', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1872, NULL, 1872, 'Bom Jesus da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.752527', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (483, NULL, 483, 'Bom Jesus das Selvas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.236707', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5351, NULL, 5351, 'Bom Jesus de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.568869', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2324, NULL, 2324, 'Bom Jesus do Amparo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.246959', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5194, NULL, 5194, 'Bom Jesus do Araguaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.387912', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2325, NULL, 2325, 'Bom Jesus do Galho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.247908', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3184, NULL, 3184, 'Bom Jesus do Itabapoana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.17623', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3109, NULL, 3109, 'Bom Jesus do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.094622', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4350, NULL, 4350, 'Bom Jesus do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.470938', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3952, NULL, 3952, 'Bom Jesus do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.02933', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (172, NULL, 172, 'Bom Jesus do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.887134', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (334, NULL, 334, 'Bom Jesus do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.073818', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3345, NULL, 3345, 'Bom Jesus dos Perdoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.354421', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (484, NULL, 484, 'Bom Lugar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.237544', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4652, NULL, 4652, 'Bom Principio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.799093', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (697, NULL, 697, 'Bom Principio do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.476209', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4653, NULL, 4653, 'Bom Progresso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.80005', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2326, NULL, 2326, 'Bom Repouso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.248786', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4351, NULL, 4351, 'Bom Retiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.471851', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4654, NULL, 4654, 'Bom Retiro do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.800999', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2327, NULL, 2327, 'Bom Sucesso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.249675', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3953, NULL, 3953, 'Bom Sucesso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.030115', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1272, NULL, 1272, 'Bom Sucesso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.106763', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3346, NULL, 3346, 'Bom Sucesso de Itarare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.355449', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3954, NULL, 3954, 'Bom Sucesso do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.031027', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4352, NULL, 4352, 'Bombinhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.472717', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (139, NULL, 139, 'Bonfim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.856157', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2328, NULL, 2328, 'Bonfim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.250542', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (698, NULL, 698, 'Bonfim do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.477453', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5352, NULL, 5352, 'Bonfinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.569784', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2329, NULL, 2329, 'Bonfinopolis de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.251343', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1873, NULL, 1873, 'Boninal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.753467', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1488, NULL, 1488, 'Bonito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.34216', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1874, NULL, 1874, 'Bonito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.754333', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5114, NULL, 5114, 'Bonito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.301372', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (173, NULL, 173, 'Bonito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.894617', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2330, NULL, 2330, 'Bonito de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.252162', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1273, NULL, 1273, 'Bonito de Santa Fe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.107652', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5353, NULL, 5353, 'Bonopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.570757', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1274, NULL, 1274, 'Boqueirao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.108561', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4655, NULL, 4655, 'Boqueirao do Leao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.801898', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (699, NULL, 699, 'Boqueirao do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.478284', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1757, NULL, 1757, 'Boquim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.632563', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1875, NULL, 1875, 'Boquira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.755177', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3347, NULL, 3347, 'Bora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.356379', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3348, NULL, 3348, 'Boraceia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.357481', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (88, NULL, 88, 'Borba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.795002', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3349, NULL, 3349, 'Borborema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.358426', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1275, NULL, 1275, 'Borborema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.109233', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2331, NULL, 2331, 'Borda da Mata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.253039', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3350, NULL, 3350, 'Borebi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.359296', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3955, NULL, 3955, 'Borrazopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.031843', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4656, NULL, 4656, 'Bossoroca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.802916', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2332, NULL, 2332, 'Botelhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.253931', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3351, NULL, 3351, 'Botucatu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.360376', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2333, NULL, 2333, 'Botumirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.254856', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1876, NULL, 1876, 'Botupora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.756099', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4353, NULL, 4353, 'Botuvera', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.473586', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4657, NULL, 4657, 'Bozano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.803916', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4354, NULL, 4354, 'Braco do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.474511', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4355, NULL, 4355, 'Braco do Trombudo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.47539', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4658, NULL, 4658, 'Braga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.804862', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (174, NULL, 174, 'Braganca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.895728', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3352, NULL, 3352, 'Braganca Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.361423', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3956, NULL, 3956, 'Braganey', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.032806', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1659, NULL, 1659, 'Branquinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.525049', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2334, NULL, 2334, 'Bras Pires', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.255745', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (175, NULL, 175, 'Brasil Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.896566', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5115, NULL, 5115, 'Brasilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.302327', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2335, NULL, 2335, 'Brasilandia de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.256563', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3957, NULL, 3957, 'Brasilandia do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.033978', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (335, NULL, 335, 'Brasilandia do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.074694', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (55, NULL, 55, 'Brasileia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.757891', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (700, NULL, 700, 'Brasileira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.479141', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5564, NULL, 5564, 'Brasilia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.80332', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2336, NULL, 2336, 'Brasilia de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.257427', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5195, NULL, 5195, 'Brasnorte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.395783', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3353, NULL, 3353, 'Brauna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.362273', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2338, NULL, 2338, 'Braunas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.259273', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5354, NULL, 5354, 'Brazabrantes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.571611', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1489, NULL, 1489, 'Brejao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.343086', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3110, NULL, 3110, 'Brejetuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.095495', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1093, NULL, 1093, 'Brejinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.909163', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1490, NULL, 1490, 'Brejinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.344037', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (336, NULL, 336, 'Brejinho de Nazare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.075521', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (485, NULL, 485, 'Brejo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.238393', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3354, NULL, 3354, 'Brejo Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.363155', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1491, NULL, 1491, 'Brejo da Madre de Deus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.344934', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (486, NULL, 486, 'Brejo de Areia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.23924', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1276, NULL, 1276, 'Brejo do Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.110176', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (701, NULL, 701, 'Brejo do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.479943', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1277, NULL, 1277, 'Brejo dos Santos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.111091', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1758, NULL, 1758, 'Brejo Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.633428', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (176, NULL, 176, 'Brejo Grande do Araguaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.897635', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (920, NULL, 920, 'Brejo Santo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.712556', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1877, NULL, 1877, 'Brejoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.756961', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1878, NULL, 1878, 'Brejolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.757913', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (177, NULL, 177, 'Breu Branco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.898564', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (178, NULL, 178, 'Breves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.899242', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5355, NULL, 5355, 'Britania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.572486', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4659, NULL, 4659, 'Brochier', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.805735', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3355, NULL, 3355, 'Brodowski', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.364124', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3356, NULL, 3356, 'Brotas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.365052', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1879, NULL, 1879, 'Brotas de Macaubas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.758779', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2339, NULL, 2339, 'Brumadinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.260042', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1880, NULL, 1880, 'Brumado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.759633', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4356, NULL, 4356, 'Brunopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.476535', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4357, NULL, 4357, 'Brusque', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.477593', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2340, NULL, 2340, 'Bueno Brandao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.260966', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2341, NULL, 2341, 'Buenopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.261895', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1492, NULL, 1492, 'Buenos Aires', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.345842', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1881, NULL, 1881, 'Buerarema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.760497', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2342, NULL, 2342, 'Bugre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.262933', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1493, NULL, 1493, 'Buique', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.346767', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (56, NULL, 56, 'Bujari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.758909', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (179, NULL, 179, 'Bujaru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.900159', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3357, NULL, 3357, 'Buri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.366004', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3358, NULL, 3358, 'Buritama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.366945', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (487, NULL, 487, 'Buriti', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.240212', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5356, NULL, 5356, 'Buriti Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.57334', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (488, NULL, 488, 'Buriti Bravo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.24103', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5357, NULL, 5357, 'Buriti de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.57425', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (337, NULL, 337, 'Buriti do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.076484', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (702, NULL, 702, 'Buriti dos Lopes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.481156', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (703, NULL, 703, 'Buriti dos Montes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.481975', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (489, NULL, 489, 'Buriticupu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.241945', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5358, NULL, 5358, 'Buritinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.575213', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1882, NULL, 1882, 'Buritirama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.761353', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (490, NULL, 490, 'Buritirana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.242839', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (6, NULL, 6, 'Buritis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.704461', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2343, NULL, 2343, 'Buritis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.263793', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3359, NULL, 3359, 'Buritizal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.367895', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2344, NULL, 2344, 'Buritizeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.264812', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4660, NULL, 4660, 'Butia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.806615', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (89, NULL, 89, 'Caapiranga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.795793', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1278, NULL, 1278, 'Caapora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.112052', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5116, NULL, 5116, 'Caarapo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.303136', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1883, NULL, 1883, 'Caatiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.762303', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1279, NULL, 1279, 'Cabaceiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.112919', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1884, NULL, 1884, 'Cabaceiras do Paraguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.763755', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2345, NULL, 2345, 'Cabeceira Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.265722', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5359, NULL, 5359, 'Cabeceiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.57613', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (704, NULL, 704, 'Cabeceiras do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.482873', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1280, NULL, 1280, 'Cabedelo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.113819', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (7, NULL, 7, 'Cabixi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.7053', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1494, NULL, 1494, 'Cabo de Santo Agostinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.347774', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3185, NULL, 3185, 'Cabo Frio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.177146', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2346, NULL, 2346, 'Cabo Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.266748', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3360, NULL, 3360, 'Cabralia Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.368816', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3361, NULL, 3361, 'Cabreuva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.369719', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1495, NULL, 1495, 'Cabrobo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.348738', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4358, NULL, 4358, 'Cacador', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.478494', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3362, NULL, 3362, 'Cacapava', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.370627', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4661, NULL, 4661, 'Cacapava do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.807519', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (8, NULL, 8, 'Cacaulandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.706175', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4662, NULL, 4662, 'Cacequi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.808337', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5196, NULL, 5196, 'Caceres', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.396886', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1885, NULL, 1885, 'Cachoeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.764694', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5360, NULL, 5360, 'Cachoeira Alta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.577058', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2347, NULL, 2347, 'Cachoeira da Prata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.267638', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5361, NULL, 5361, 'Cachoeira de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.577887', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2348, NULL, 2348, 'Cachoeira de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.268607', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2349, NULL, 2349, 'Cachoeira de Pajeu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.269483', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (180, NULL, 180, 'Cachoeira do Arari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.901094', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (181, NULL, 181, 'Cachoeira do Piria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.902107', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4663, NULL, 4663, 'Cachoeira do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.809202', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1281, NULL, 1281, 'Cachoeira dos Indios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.114792', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5362, NULL, 5362, 'Cachoeira Dourada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.578836', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2350, NULL, 2350, 'Cachoeira Dourada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.270382', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (491, NULL, 491, 'Cachoeira Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.243731', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3363, NULL, 3363, 'Cachoeira Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.371763', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3186, NULL, 3186, 'Cachoeiras de Macacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.178064', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1496, NULL, 1496, 'Cachoeirinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.349556', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4664, NULL, 4664, 'Cachoeirinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.810127', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (338, NULL, 338, 'Cachoeirinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.077361', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3111, NULL, 3111, 'Cachoeiro de Itapemirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.096312', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1282, NULL, 1282, 'Cacimba de Areia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.115622', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1283, NULL, 1283, 'Cacimba de Dentro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.116562', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1284, NULL, 1284, 'Cacimbas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.117359', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1660, NULL, 1660, 'Cacimbinhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.525871', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4665, NULL, 4665, 'Cacique Doble', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.811004', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (9, NULL, 9, 'Cacoal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.707047', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3364, NULL, 3364, 'Caconde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.372711', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5363, NULL, 5363, 'Cacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.579767', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1887, NULL, 1887, 'Caem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.766486', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2351, NULL, 2351, 'Caetanopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.271481', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1888, NULL, 1888, 'Caetanos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.767347', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2352, NULL, 2352, 'Caete', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.272398', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1497, NULL, 1497, 'Caetes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.350314', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1889, NULL, 1889, 'Caetite', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.768201', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1890, NULL, 1890, 'Cafarnaum', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.769048', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3958, NULL, 3958, 'Cafeara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.034819', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3365, NULL, 3365, 'Cafelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.373562', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3959, NULL, 3959, 'Cafelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.03574', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3960, NULL, 3960, 'Cafezal do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.036649', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3366, NULL, 3366, 'Caiabu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.374476', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2353, NULL, 2353, 'Caiana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.273259', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5364, NULL, 5364, 'Caiaponia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.580695', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4666, NULL, 4666, 'Caibate', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.812204', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4359, NULL, 4359, 'Caibi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.479391', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1285, NULL, 1285, 'Caicara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.118234', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4667, NULL, 4667, 'Caicara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.813081', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1094, NULL, 1094, 'Caicara do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.910096', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1095, NULL, 1095, 'Caicara do Rio do Vento', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.911027', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1096, NULL, 1096, 'Caico', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.911823', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3367, NULL, 3367, 'Caieiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.375453', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1891, NULL, 1891, 'Cairu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.769993', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3368, NULL, 3368, 'Caiua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.37635', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3369, NULL, 3369, 'Cajamar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.377277', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (492, NULL, 492, 'Cajapio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.244628', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (493, NULL, 493, 'Cajari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.245516', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3370, NULL, 3370, 'Cajati', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.378209', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1286, NULL, 1286, 'Cajazeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.119142', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (705, NULL, 705, 'Cajazeiras do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.483761', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1287, NULL, 1287, 'Cajazeirinhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.120118', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3371, NULL, 3371, 'Cajobi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.379165', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1661, NULL, 1661, 'Cajueiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.526778', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (706, NULL, 706, 'Cajueiro da Praia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.484708', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2354, NULL, 2354, 'Cajuri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.274121', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3372, NULL, 3372, 'Cajuru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.380188', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1498, NULL, 1498, 'Calcado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.351203', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (295, NULL, 295, 'Calcoene', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.030519', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2355, NULL, 2355, 'Caldas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.275028', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1288, NULL, 1288, 'Caldas Brandao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.126902', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5365, NULL, 5365, 'Caldas Novas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.581988', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5366, NULL, 5366, 'Caldazinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.582914', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1892, NULL, 1892, 'Caldeirao Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.770885', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (707, NULL, 707, 'Caldeirao Grande do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.485653', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3961, NULL, 3961, 'California', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.037542', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4360, NULL, 4360, 'Calmon', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.480305', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1499, NULL, 1499, 'Calumbi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.35222', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1893, NULL, 1893, 'Camacan', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.771855', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1894, NULL, 1894, 'Camacari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.772719', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2356, NULL, 2356, 'Camacho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.275929', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1289, NULL, 1289, 'Camalau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.128216', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1895, NULL, 1895, 'Camamu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.773477', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2357, NULL, 2357, 'Camanducaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.27681', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5117, NULL, 5117, 'Camapua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.304018', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4668, NULL, 4668, 'Camaqua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.813986', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1500, NULL, 1500, 'Camaragibe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.352986', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4669, NULL, 4669, 'Camargo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.814864', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3962, NULL, 3962, 'Cambara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.038936', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4670, NULL, 4670, 'Cambara do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.815791', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3963, NULL, 3963, 'Cambe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.045765', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3964, NULL, 3964, 'Cambira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.047133', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4361, NULL, 4361, 'Camboriu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.481266', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3187, NULL, 3187, 'Cambuci', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.178988', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2358, NULL, 2358, 'Cambui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.277738', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2359, NULL, 2359, 'Cambuquira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.278606', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (182, NULL, 182, 'Cameta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.903016', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (921, NULL, 921, 'Camocim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.713478', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1501, NULL, 1501, 'Camocim de Sao Felix', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.35396', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2360, NULL, 2360, 'Campanario', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.279653', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2361, NULL, 2361, 'Campanha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.28044', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1662, NULL, 1662, 'Campestre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.527574', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2362, NULL, 2362, 'Campestre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.286607', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4671, NULL, 4671, 'Campestre da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.816669', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5367, NULL, 5367, 'Campestre de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.583775', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (494, NULL, 494, 'Campestre do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.246481', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3965, NULL, 3965, 'Campina da Lagoa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.04815', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4672, NULL, 4672, 'Campina das Missoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.817629', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3373, NULL, 3373, 'Campina do Monte Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.381138', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3966, NULL, 3966, 'Campina do Simao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.049097', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1290, NULL, 1290, 'Campina Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.129109', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3967, NULL, 3967, 'Campina Grande do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.050115', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2363, NULL, 2363, 'Campina Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.287827', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5368, NULL, 5368, 'Campinacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.584712', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5197, NULL, 5197, 'Campinapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.397801', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3374, NULL, 3374, 'Campinas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.381967', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (708, NULL, 708, 'Campinas do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.4866', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4673, NULL, 4673, 'Campinas do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.818566', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5369, NULL, 5369, 'Campinorte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.585668', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1663, NULL, 1663, 'Campo Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.528462', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4362, NULL, 4362, 'Campo Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.482024', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5370, NULL, 5370, 'Campo Alegre de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.586525', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1896, NULL, 1896, 'Campo Alegre de Lourdes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.774295', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (709, NULL, 709, 'Campo Alegre do Fidalgo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.487558', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2364, NULL, 2364, 'Campo Azul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.288775', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2365, NULL, 2365, 'Campo Belo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.289665', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4363, NULL, 4363, 'Campo Belo do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.483299', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4674, NULL, 4674, 'Campo Bom', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.819422', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3968, NULL, 3968, 'Campo Bonito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.051104', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1759, NULL, 1759, 'Campo do Brito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.63429', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2366, NULL, 2366, 'Campo do Meio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.290592', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3969, NULL, 3969, 'Campo do Tenente', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.05197', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4364, NULL, 4364, 'Campo Ere', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.484528', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2367, NULL, 2367, 'Campo Florido', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.291403', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1897, NULL, 1897, 'Campo Formoso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.775204', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5118, NULL, 5118, 'Campo Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.30485', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1664, NULL, 1664, 'Campo Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.529366', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (710, NULL, 710, 'Campo Grande do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.488623', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3970, NULL, 3970, 'Campo Largo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.053224', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (711, NULL, 711, 'Campo Largo do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.489554', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5371, NULL, 5371, 'Campo Limpo de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.587364', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3375, NULL, 3375, 'Campo Limpo Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.382892', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3971, NULL, 3971, 'Campo Magro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.054079', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (712, NULL, 712, 'Campo Maior', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.490426', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3972, NULL, 3972, 'Campo Mourao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.054986', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4675, NULL, 4675, 'Campo Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.825975', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (10, NULL, 10, 'Campo Novo de Rondonia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.70796', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5198, NULL, 5198, 'Campo Novo do Parecis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.398624', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1097, NULL, 1097, 'Campo Redondo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.912823', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5199, NULL, 5199, 'Campo Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.399594', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2368, NULL, 2368, 'Campos Altos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.292443', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5372, NULL, 5372, 'Campos Belos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.588237', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4676, NULL, 4676, 'Campos Borges', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.827145', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5200, NULL, 5200, 'Campos de Julio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.400449', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3376, NULL, 3376, 'Campos do Jordao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.384015', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3188, NULL, 3188, 'Campos dos Goytacazes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.17996', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2369, NULL, 2369, 'Campos Gerais', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.293274', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (339, NULL, 339, 'Campos Lindos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.078201', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4365, NULL, 4365, 'Campos Novos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.48539', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3377, NULL, 3377, 'Campos Novos Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.390894', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (922, NULL, 922, 'Campos Sales', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.720078', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5373, NULL, 5373, 'Campos Verdes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.589202', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1502, NULL, 1502, 'Camutanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.35491', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2370, NULL, 2370, 'Cana Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.294208', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2371, NULL, 2371, 'Canaa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.295135', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (183, NULL, 183, 'Canaa dos Carajas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.903963', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5201, NULL, 5201, 'Canabrava do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.401301', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3378, NULL, 3378, 'Cananeia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.392104', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1665, NULL, 1665, 'Canapi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.5303', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1898, NULL, 1898, 'Canapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.776195', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2372, NULL, 2372, 'Canapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.296192', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1899, NULL, 1899, 'Canarana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.776955', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5202, NULL, 5202, 'Canarana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.402031', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3379, NULL, 3379, 'Canas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.393199', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (713, NULL, 713, 'Canavieira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.491345', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1900, NULL, 1900, 'Canavieiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.777826', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1901, NULL, 1901, 'Candeal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.778621', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2373, NULL, 2373, 'Candeias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.297115', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1902, NULL, 1902, 'Candeias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.785654', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (11, NULL, 11, 'Candeias do Jamari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.708884', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4677, NULL, 4677, 'Candelaria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.828029', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1903, NULL, 1903, 'Candiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.786875', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3973, NULL, 3973, 'Candido de Abreu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.055886', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4678, NULL, 4678, 'Candido Godoi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.828872', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (495, NULL, 495, 'Candido Mendes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.247331', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3380, NULL, 3380, 'Candido Mota', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.394055', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3381, NULL, 3381, 'Candido Rodrigues', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.39493', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1904, NULL, 1904, 'Candido Sales', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.787762', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4679, NULL, 4679, 'Candiota', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.829693', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3974, NULL, 3974, 'Candoi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.056861', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4680, NULL, 4680, 'Canela', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.830636', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4366, NULL, 4366, 'Canelinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.486284', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1098, NULL, 1098, 'Canguaretama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.913613', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4681, NULL, 4681, 'Cangucu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.831498', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1760, NULL, 1760, 'Canhoba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.635169', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1503, NULL, 1503, 'Canhotinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.355843', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (923, NULL, 923, 'Caninde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.721176', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1761, NULL, 1761, 'Caninde de Sao Francisco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.636006', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3382, NULL, 3382, 'Canitar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.395858', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4682, NULL, 4682, 'Canoas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.8323', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4367, NULL, 4367, 'Canoinhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.487206', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1905, NULL, 1905, 'Cansancao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.788735', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (140, NULL, 140, 'Canta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.856972', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3975, NULL, 3975, 'Cantagalo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.057749', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3189, NULL, 3189, 'Cantagalo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.187376', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2374, NULL, 2374, 'Cantagalo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.297958', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (496, NULL, 496, 'Cantanhede', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.248243', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (714, NULL, 714, 'Canto do Buriti', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.492473', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1906, NULL, 1906, 'Canudos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.789648', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4683, NULL, 4683, 'Canudos do Vale', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.833266', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (90, NULL, 90, 'Canutama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.796734', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3976, NULL, 3976, 'Capanema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.05867', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (184, NULL, 184, 'Capanema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.904782', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4368, NULL, 4368, 'Capao Alto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.488426', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3383, NULL, 3383, 'Capao Bonito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.39675', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4684, NULL, 4684, 'Capao Bonito do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.834669', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4685, NULL, 4685, 'Capao da Canoa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.835592', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4686, NULL, 4686, 'Capao do Cipo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.836576', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4687, NULL, 4687, 'Capao do Leao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.83748', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2375, NULL, 2375, 'Caparao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.298869', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1762, NULL, 1762, 'Capela', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.636835', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1666, NULL, 1666, 'Capela', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.531062', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4688, NULL, 4688, 'Capela de Santana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.838512', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3384, NULL, 3384, 'Capela do Alto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.397713', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1907, NULL, 1907, 'Capela do Alto Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.790552', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2376, NULL, 2376, 'Capela Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.299725', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2377, NULL, 2377, 'Capelinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.300742', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2378, NULL, 2378, 'Capetinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.301628', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1292, NULL, 1292, 'Capim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.130913', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2379, NULL, 2379, 'Capim Branco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.302484', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1908, NULL, 1908, 'Capim Grosso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.791373', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2380, NULL, 2380, 'Capinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.303332', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4369, NULL, 4369, 'Capinzal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.489197', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (497, NULL, 497, 'Capinzal do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.249166', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (924, NULL, 924, 'Capistrano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.722137', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4689, NULL, 4689, 'Capitao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.839442', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2381, NULL, 2381, 'Capitao Andrade', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.304204', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (715, NULL, 715, 'Capitao de Campos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.493449', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2382, NULL, 2382, 'Capitao Eneas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.304996', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (716, NULL, 716, 'Capitao Gervasio Oliveira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.49426', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3977, NULL, 3977, 'Capitao Leonidas Marques', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.059635', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (185, NULL, 185, 'Capitao Poco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.905681', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2383, NULL, 2383, 'Capitolio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.305772', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3385, NULL, 3385, 'Capivari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.398691', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4370, NULL, 4370, 'Capivari de Baixo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.490106', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4690, NULL, 4690, 'Capivari do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.840285', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (57, NULL, 57, 'Capixaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.759844', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1504, NULL, 1504, 'Capoeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.356719', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2384, NULL, 2384, 'Caputira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.306769', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4691, NULL, 4691, 'Caraa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.841208', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (141, NULL, 141, 'Caracarai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.857888', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5119, NULL, 5119, 'Caracol', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.305697', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (717, NULL, 717, 'Caracol', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.495011', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3386, NULL, 3386, 'Caraguatatuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.399692', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2385, NULL, 2385, 'Carai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.307704', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1909, NULL, 1909, 'Caraibas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.792368', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3978, NULL, 3978, 'Carambei', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.060504', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2386, NULL, 2386, 'Caranaiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.308589', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2387, NULL, 2387, 'Carandai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.309503', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2388, NULL, 2388, 'Carangola', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.310414', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3190, NULL, 3190, 'Carapebus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.188539', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3387, NULL, 3387, 'Carapicuiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.400634', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2389, NULL, 2389, 'Caratinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.311411', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (91, NULL, 91, 'Carauari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.797699', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1293, NULL, 1293, 'Caraubas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.131989', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1099, NULL, 1099, 'Caraubas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.914478', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (718, NULL, 718, 'Caraubas do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.495894', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1910, NULL, 1910, 'Caravelas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.793239', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4692, NULL, 4692, 'Carazinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.842067', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2390, NULL, 2390, 'Carbonita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.312275', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1911, NULL, 1911, 'Cardeal da Silva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.794153', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3388, NULL, 3388, 'Cardoso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.401562', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3191, NULL, 3191, 'Cardoso Moreira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.189489', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2391, NULL, 2391, 'Careacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.313165', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (92, NULL, 92, 'Careiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.798687', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (93, NULL, 93, 'Careiro da Varzea', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.799621', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3112, NULL, 3112, 'Cariacica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.097169', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (925, NULL, 925, 'Caridade', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.723051', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (719, NULL, 719, 'Caridade do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.496798', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1912, NULL, 1912, 'Carinhanha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.795076', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1763, NULL, 1763, 'Carira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.637698', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (926, NULL, 926, 'Carire', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.724031', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (340, NULL, 340, 'Cariri do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.079159', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (927, NULL, 927, 'Caririacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.725002', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (928, NULL, 928, 'Carius', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.72603', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5203, NULL, 5203, 'Carlinda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.403458', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3979, NULL, 3979, 'Carlopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.061386', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4693, NULL, 4693, 'Carlos Barbosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.842932', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2392, NULL, 2392, 'Carlos Chagas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.313963', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4694, NULL, 4694, 'Carlos Gomes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.843835', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2393, NULL, 2393, 'Carmesia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.31478', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3192, NULL, 3192, 'Carmo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.190376', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2394, NULL, 2394, 'Carmo da Cachoeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.31565', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2395, NULL, 2395, 'Carmo da Mata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.316547', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2396, NULL, 2396, 'Carmo de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.317444', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2397, NULL, 2397, 'Carmo do Cajuru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.318302', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2398, NULL, 2398, 'Carmo do Paranaiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.319164', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4373, NULL, 4373, 'Celso Ramos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.492847', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2399, NULL, 2399, 'Carmo do Rio Claro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.320006', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5374, NULL, 5374, 'Carmo do Rio Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.590143', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (341, NULL, 341, 'Carmolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.079958', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1764, NULL, 1764, 'Carmopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.638589', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2400, NULL, 2400, 'Carmopolis de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.326946', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1505, NULL, 1505, 'Carnaiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.357596', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1100, NULL, 1100, 'Carnauba dos Dantas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.915516', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1101, NULL, 1101, 'Carnaubais', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.916333', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (929, NULL, 929, 'Carnaubal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.726882', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1506, NULL, 1506, 'Carnaubeira da Penha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.358502', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2401, NULL, 2401, 'Carneirinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.328069', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1667, NULL, 1667, 'Carneiros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.531967', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (142, NULL, 142, 'Caroebe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.858888', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (498, NULL, 498, 'Carolina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.250112', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1507, NULL, 1507, 'Carpina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.359433', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2402, NULL, 2402, 'Carrancas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.328901', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1294, NULL, 1294, 'Carrapateira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.132966', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (342, NULL, 342, 'Carrasco Bonito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.081026', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1508, NULL, 1508, 'Caruaru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.360254', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (499, NULL, 499, 'Carutapera', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.251005', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2403, NULL, 2403, 'Carvalhopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.329932', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2404, NULL, 2404, 'Carvalhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.33101', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3389, NULL, 3389, 'Casa Branca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.40251', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2405, NULL, 2405, 'Casa Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.331982', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1913, NULL, 1913, 'Casa Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.796126', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4695, NULL, 4695, 'Casca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.844744', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2406, NULL, 2406, 'Cascalho Rico', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.333627', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (930, NULL, 930, 'Cascavel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.72791', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3980, NULL, 3980, 'Cascavel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.062316', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (343, NULL, 343, 'Caseara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.082012', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4696, NULL, 4696, 'Caseiros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.845669', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3193, NULL, 3193, 'Casimiro de Abreu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.191224', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1509, NULL, 1509, 'Casinhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.361206', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1295, NULL, 1295, 'Casserengue', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.133895', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2407, NULL, 2407, 'Cassia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.334661', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3390, NULL, 3390, 'Cassia dos Coqueiros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.403415', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5120, NULL, 5120, 'Cassilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.306539', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (186, NULL, 186, 'Castanhal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.906554', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5204, NULL, 5204, 'Castanheira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.404495', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (12, NULL, 12, 'Castanheiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.709859', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5375, NULL, 5375, 'Castelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.591002', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3113, NULL, 3113, 'Castelo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.09809', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (720, NULL, 720, 'Castelo do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.49769', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3391, NULL, 3391, 'Castilho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.4044', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3981, NULL, 3981, 'Castro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.063137', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1914, NULL, 1914, 'Castro Alves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.797062', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2408, NULL, 2408, 'Cataguases', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.335576', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5376, NULL, 5376, 'Catalao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.592188', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3392, NULL, 3392, 'Catanduva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.405192', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3982, NULL, 3982, 'Catanduvas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.064188', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4371, NULL, 4371, 'Catanduvas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.491025', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (931, NULL, 931, 'Catarina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.728846', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2409, NULL, 2409, 'Catas Altas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.336441', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2410, NULL, 2410, 'Catas Altas da Noruega', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.337408', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1510, NULL, 1510, 'Catende', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.362152', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3393, NULL, 3393, 'Catigua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.406069', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1296, NULL, 1296, 'Catingueira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.134819', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1915, NULL, 1915, 'Catolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.797944', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1297, NULL, 1297, 'Catole do Rocha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.135839', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1916, NULL, 1916, 'Catu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.798905', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4697, NULL, 4697, 'Catuipe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.846536', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2411, NULL, 2411, 'Catuji', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.338303', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (932, NULL, 932, 'Catunda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.72975', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5377, NULL, 5377, 'Caturai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.603004', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1917, NULL, 1917, 'Caturama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.799835', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1298, NULL, 1298, 'Caturite', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.136857', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2412, NULL, 2412, 'Catuti', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.339177', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (933, NULL, 933, 'Caucaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.73058', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5378, NULL, 5378, 'Cavalcante', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.604319', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2413, NULL, 2413, 'Caxambu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.340022', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4372, NULL, 4372, 'Caxambu do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.491954', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (500, NULL, 500, 'Caxias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.251858', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4698, NULL, 4698, 'Caxias do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.847409', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (721, NULL, 721, 'Caxingo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.498551', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1102, NULL, 1102, 'Ceara-mirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.917214', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (501, NULL, 501, 'Cedral', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.252814', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3394, NULL, 3394, 'Cedral', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.407007', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (934, NULL, 934, 'Cedro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.731508', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1511, NULL, 1511, 'Cedro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.363201', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1765, NULL, 1765, 'Cedro de Sao Joao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.639453', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2414, NULL, 2414, 'Cedro do Abaete', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.3409', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (344, NULL, 344, 'Centenario', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.082934', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4699, NULL, 4699, 'Centenario', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.848283', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3983, NULL, 3983, 'Centenario do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.065187', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1918, NULL, 1918, 'Central', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.800762', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2415, NULL, 2415, 'Central de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.341802', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (502, NULL, 502, 'Central do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.253724', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2416, NULL, 2416, 'Centralina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.342707', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (503, NULL, 503, 'Centro do Guilherme', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.254702', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (504, NULL, 504, 'Centro Novo do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.255559', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (13, NULL, 13, 'Cerejeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.711055', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5379, NULL, 5379, 'Ceres', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.605372', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3395, NULL, 3395, 'Cerqueira Cesar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.407879', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3396, NULL, 3396, 'Cerquilho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.408712', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4700, NULL, 4700, 'Cerrito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.849096', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3984, NULL, 3984, 'Cerro Azul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.066246', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4701, NULL, 4701, 'Cerro Branco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.849907', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1103, NULL, 1103, 'Cerro Cora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.924082', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4702, NULL, 4702, 'Cerro Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.850689', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4703, NULL, 4703, 'Cerro Grande do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.851567', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4704, NULL, 4704, 'Cerro Largo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.852471', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4374, NULL, 4374, 'Cerro Negro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.493856', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3397, NULL, 3397, 'Cesario Lange', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.409578', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3985, NULL, 3985, 'Ceu Azul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.06723', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5380, NULL, 5380, 'Cezarina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.606325', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1512, NULL, 1512, 'Cha de Alegria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.364172', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1513, NULL, 1513, 'Cha Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.364895', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1668, NULL, 1668, 'Cha Preta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.532762', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2417, NULL, 2417, 'Chacara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.343615', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2418, NULL, 2418, 'Chale', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.344519', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4705, NULL, 4705, 'Chapada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.853292', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (345, NULL, 345, 'Chapada da Natividade', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.083733', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (346, NULL, 346, 'Chapada de Areia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.084657', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2419, NULL, 2419, 'Chapada do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.345402', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5205, NULL, 5205, 'Chapada dos Guimaraes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.405573', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2420, NULL, 2420, 'Chapada Gaucha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.346221', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5381, NULL, 5381, 'Chapadao do Ceu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.607336', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4375, NULL, 4375, 'Chapadao do Lageado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.500523', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5121, NULL, 5121, 'Chapadao do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.313766', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (505, NULL, 505, 'Chapadinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.256472', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4376, NULL, 4376, 'Chapeco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.501768', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3398, NULL, 3398, 'Charqueada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.410493', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4706, NULL, 4706, 'Charqueadas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.854176', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4707, NULL, 4707, 'Charrua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.855027', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (935, NULL, 935, 'Chaval', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.732465', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3399, NULL, 3399, 'Chavantes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.411516', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (187, NULL, 187, 'Chaves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.907603', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2421, NULL, 2421, 'Chiador', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.347172', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3986, NULL, 3986, 'Chopinzinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.068245', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (936, NULL, 936, 'Choro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.733347', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (937, NULL, 937, 'Chorozinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.734151', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1919, NULL, 1919, 'Chorrocho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.801673', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4709, NULL, 4709, 'Chui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.856725', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (14, NULL, 14, 'Chupinguaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.711993', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4710, NULL, 4710, 'Chuvisca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.857603', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3987, NULL, 3987, 'Cianorte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.069317', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1920, NULL, 1920, 'Cicero Dantas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.80256', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3988, NULL, 3988, 'Cidade Gaucha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.070245', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5382, NULL, 5382, 'Cidade Ocidental', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.608275', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (506, NULL, 506, 'Cidelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.257495', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4711, NULL, 4711, 'Cidreira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.85851', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1921, NULL, 1921, 'Cipo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.803435', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2422, NULL, 2422, 'Cipotanea', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.348109', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4712, NULL, 4712, 'Ciriaco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.859474', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2423, NULL, 2423, 'Claraval', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.349067', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2424, NULL, 2424, 'Claro dos Pocoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.349954', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5206, NULL, 5206, 'Claudia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.406653', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2425, NULL, 2425, 'Claudio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.350815', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3400, NULL, 3400, 'Clementina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.412407', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3989, NULL, 3989, 'Clevelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.071239', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1922, NULL, 1922, 'Coaraci', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.804362', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (94, NULL, 94, 'Coari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.800826', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (722, NULL, 722, 'Cocal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.49945', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (723, NULL, 723, 'Cocal de Telha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.500365', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4377, NULL, 4377, 'Cocal do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.502784', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (724, NULL, 724, 'Cocal dos Alves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.501178', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5207, NULL, 5207, 'Cocalinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.407608', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5383, NULL, 5383, 'Cocalzinho de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.609119', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1923, NULL, 1923, 'Cocos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.805142', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (95, NULL, 95, 'Codajas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.801802', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (507, NULL, 507, 'Codo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.258325', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (508, NULL, 508, 'Coelho Neto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.259107', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2426, NULL, 2426, 'Coimbra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.351681', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1669, NULL, 1669, 'Coite do Noia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.53981', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (725, NULL, 725, 'Coivaras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.50203', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (188, NULL, 188, 'Colares', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.908482', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3114, NULL, 3114, 'Colatina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.099011', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5208, NULL, 5208, 'Colider', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.408507', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3401, NULL, 3401, 'Colina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.413332', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4713, NULL, 4713, 'Colinas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.866184', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (509, NULL, 509, 'Colinas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.259977', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5384, NULL, 5384, 'Colinas do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.609959', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (347, NULL, 347, 'Colinas do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.085702', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (348, NULL, 348, 'Colmeia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.086822', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5209, NULL, 5209, 'Colniza', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.409412', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3402, NULL, 3402, 'Colombia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.41435', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3990, NULL, 3990, 'Colombo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.072161', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (726, NULL, 726, 'Colonia do Gurgueia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.502948', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (727, NULL, 727, 'Colonia do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.503724', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1670, NULL, 1670, 'Colonia Leopoldina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.540909', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3991, NULL, 3991, 'Colorado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.073279', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4714, NULL, 4714, 'Colorado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.86748', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (15, NULL, 15, 'Colorado do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.712932', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2427, NULL, 2427, 'Coluna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.352366', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (349, NULL, 349, 'Combinado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.087767', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2428, NULL, 2428, 'Comendador Gomes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.353256', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3194, NULL, 3194, 'Comendador Levy Gasparian', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.192154', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2429, NULL, 2429, 'Comercinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.354197', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5210, NULL, 5210, 'Comodoro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.410397', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1299, NULL, 1299, 'Conceicao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.137768', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2430, NULL, 2430, 'Conceicao da Aparecida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.355049', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3115, NULL, 3115, 'Conceicao da Barra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.105545', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2431, NULL, 2431, 'Conceicao da Barra de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.356084', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1924, NULL, 1924, 'Conceicao da Feira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.806049', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2432, NULL, 2432, 'Conceicao das Alagoas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.356889', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2433, NULL, 2433, 'Conceicao das Pedras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.357787', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2434, NULL, 2434, 'Conceicao de Ipanema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.358793', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3195, NULL, 3195, 'Conceicao de Macabu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.193182', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1925, NULL, 1925, 'Conceicao do Almeida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.80693', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (189, NULL, 189, 'Conceicao do Araguaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.909368', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (728, NULL, 728, 'Conceicao do Caninde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.504605', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3116, NULL, 3116, 'Conceicao do Castelo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.106749', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1926, NULL, 1926, 'Conceicao do Coite', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.807792', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1927, NULL, 1927, 'Conceicao do Jacuipe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.808715', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (510, NULL, 510, 'Conceicao do Lago-acu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.267016', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2435, NULL, 2435, 'Conceicao do Mato Dentro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.35965', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2436, NULL, 2436, 'Conceicao do Para', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.360602', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2437, NULL, 2437, 'Conceicao do Rio Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.367362', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (350, NULL, 350, 'Conceicao do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.088722', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2438, NULL, 2438, 'Conceicao dos Ouros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.368535', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3403, NULL, 3403, 'Conchal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.415259', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3404, NULL, 3404, 'Conchas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.416408', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4378, NULL, 4378, 'Concordia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.50375', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (190, NULL, 190, 'Concordia do Para', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.910192', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1514, NULL, 1514, 'Condado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.365661', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1300, NULL, 1300, 'Condado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.138687', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1928, NULL, 1928, 'Conde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.809636', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1301, NULL, 1301, 'Conde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.139541', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1929, NULL, 1929, 'Condeuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.810398', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4715, NULL, 4715, 'Condor', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.868275', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2439, NULL, 2439, 'Conego Marinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.369512', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2440, NULL, 2440, 'Confins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.370463', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5211, NULL, 5211, 'Confresa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.411332', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1302, NULL, 1302, 'Congo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.140593', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2441, NULL, 2441, 'Congonhal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.371375', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2442, NULL, 2442, 'Congonhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.372194', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2443, NULL, 2443, 'Congonhas do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.37302', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3992, NULL, 3992, 'Congonhinhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.074223', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2444, NULL, 2444, 'Conquista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.373929', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5212, NULL, 5212, 'Conquista D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.412235', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2445, NULL, 2445, 'Conselheiro Lafaiete', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.374849', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3993, NULL, 3993, 'Conselheiro Mairinck', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.075146', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2446, NULL, 2446, 'Conselheiro Pena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.375761', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2447, NULL, 2447, 'Consolacao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.376643', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4716, NULL, 4716, 'Constantina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.869145', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2448, NULL, 2448, 'Contagem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.377562', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3994, NULL, 3994, 'Contenda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.07629', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1930, NULL, 1930, 'Contendas do Sincora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.811224', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2449, NULL, 2449, 'Coqueiral', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.37849', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4717, NULL, 4717, 'Coqueiro Baixo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.870084', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1671, NULL, 1671, 'Coqueiro Seco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.541931', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4718, NULL, 4718, 'Coqueiros do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.87097', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2450, NULL, 2450, 'Coracao de Jesus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.379263', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1931, NULL, 1931, 'Coracao de Maria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.812079', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3995, NULL, 3995, 'Corbelia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.077225', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3196, NULL, 3196, 'Cordeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.194114', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3405, NULL, 3405, 'Cordeiropolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.417364', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1932, NULL, 1932, 'Cordeiros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.812982', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4379, NULL, 4379, 'Cordilheira Alta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.504637', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2451, NULL, 2451, 'Cordisburgo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.380177', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2452, NULL, 2452, 'Cordislandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.381011', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (938, NULL, 938, 'Coreau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.735038', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1303, NULL, 1303, 'Coremas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.141567', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5122, NULL, 5122, 'Corguinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.314832', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1933, NULL, 1933, 'Coribe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.81392', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2453, NULL, 2453, 'Corinto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.381868', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3996, NULL, 3996, 'Cornelio Procopio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.078202', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2454, NULL, 2454, 'Coroaci', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.38272', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3406, NULL, 3406, 'Coroados', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.418209', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (511, NULL, 511, 'Coroata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.268195', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2455, NULL, 2455, 'Coromandel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.38355', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4719, NULL, 4719, 'Coronel Barros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.871889', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4720, NULL, 4720, 'Coronel Bicaco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.872786', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3997, NULL, 3997, 'Coronel Domingos Soares', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.079407', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1104, NULL, 1104, 'Coronel Ezequiel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.925293', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2456, NULL, 2456, 'Coronel Fabriciano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.384524', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4380, NULL, 4380, 'Coronel Freitas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.50575', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1105, NULL, 1105, 'Coronel Joao Pessoa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.926424', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1934, NULL, 1934, 'Coronel Joao Sa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.814844', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (729, NULL, 729, 'Coronel Jose Dias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.50551', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3407, NULL, 3407, 'Coronel Macedo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.41912', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4381, NULL, 4381, 'Coronel Martins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.506666', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2457, NULL, 2457, 'Coronel Murta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.385391', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2458, NULL, 2458, 'Coronel Pacheco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.386312', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4721, NULL, 4721, 'Coronel Pilar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.873768', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5123, NULL, 5123, 'Coronel Sapucaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.315886', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3998, NULL, 3998, 'Coronel Vivida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.086559', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2459, NULL, 2459, 'Coronel Xavier Chaves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.387358', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2460, NULL, 2460, 'Corrego Danta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.388301', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2461, NULL, 2461, 'Corrego do Bom Jesus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.389213', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5385, NULL, 5385, 'Corrego do Ouro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.610872', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2462, NULL, 2462, 'Corrego Fundo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.390263', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2463, NULL, 2463, 'Corrego Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.391202', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4382, NULL, 4382, 'Correia Pinto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.507531', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (730, NULL, 730, 'Corrente', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.506368', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1515, NULL, 1515, 'Correntes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.366715', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1935, NULL, 1935, 'Correntina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.815785', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1516, NULL, 1516, 'Cortes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.376836', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5124, NULL, 5124, 'Corumba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.316677', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5386, NULL, 5386, 'Corumba de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.611794', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5387, NULL, 5387, 'Corumbaiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.612763', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3408, NULL, 3408, 'Corumbatai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.420001', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3999, NULL, 3999, 'Corumbatai do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.087675', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (16, NULL, 16, 'Corumbiara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.713842', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4383, NULL, 4383, 'Corupa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.508452', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1672, NULL, 1672, 'Coruripe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.542806', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3409, NULL, 3409, 'Cosmopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.420964', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3410, NULL, 3410, 'Cosmorama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.421879', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (17, NULL, 17, 'Costa Marques', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.714738', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5125, NULL, 5125, 'Costa Rica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.317565', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1936, NULL, 1936, 'Cotegipe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.816686', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3411, NULL, 3411, 'Cotia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.422822', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4722, NULL, 4722, 'Cotipora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.874553', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5213, NULL, 5213, 'Cotriguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.413221', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2464, NULL, 2464, 'Couto de Magalhaes de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.392311', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4723, NULL, 4723, 'Coxilha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.875317', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5126, NULL, 5126, 'Coxim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.318438', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1304, NULL, 1304, 'Coxixola', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.142408', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1673, NULL, 1673, 'Craibas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.543615', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (939, NULL, 939, 'Crateus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.735982', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (940, NULL, 940, 'Crato', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.736982', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3412, NULL, 3412, 'Cravinhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.423659', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1937, NULL, 1937, 'Cravolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.817527', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4384, NULL, 4384, 'Criciuma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.509451', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2465, NULL, 2465, 'Crisolita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.393212', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1938, NULL, 1938, 'Crisopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.818343', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4724, NULL, 4724, 'Crissiumal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.876204', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2466, NULL, 2466, 'Cristais', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.394167', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3413, NULL, 3413, 'Cristais Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.424565', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4725, NULL, 4725, 'Cristal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.877062', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4726, NULL, 4726, 'Cristal do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.877944', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (352, NULL, 352, 'Cristalandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.090779', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (731, NULL, 731, 'Cristalandia do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.507245', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2467, NULL, 2467, 'Cristalia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.394971', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5388, NULL, 5388, 'Cristalina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.613699', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2468, NULL, 2468, 'Cristiano Otoni', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.395888', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5389, NULL, 5389, 'Cristianopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.614727', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2469, NULL, 2469, 'Cristina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.396852', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1766, NULL, 1766, 'Cristinapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.640358', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (732, NULL, 732, 'Cristino Castro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.508161', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1939, NULL, 1939, 'Cristopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.819171', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5390, NULL, 5390, 'Crixas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.615553', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (353, NULL, 353, 'Crixas do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.091635', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (941, NULL, 941, 'Croata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.73788', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5391, NULL, 5391, 'Crominia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.616462', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2470, NULL, 2470, 'Crucilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.397656', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (942, NULL, 942, 'Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.738764', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4727, NULL, 4727, 'Cruz Alta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.879136', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1940, NULL, 1940, 'Cruz das Almas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.826554', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1305, NULL, 1305, 'Cruz do Espirito Santo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.143316', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4000, NULL, 4000, 'Cruz Machado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.088592', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3414, NULL, 3414, 'Cruzalia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.433202', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4728, NULL, 4728, 'Cruzaltense', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.88005', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3415, NULL, 3415, 'Cruzeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.43419', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2471, NULL, 2471, 'Cruzeiro da Fortaleza', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.398422', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4001, NULL, 4001, 'Cruzeiro do Iguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.089408', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4002, NULL, 4002, 'Cruzeiro do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.090379', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4003, NULL, 4003, 'Cruzeiro do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.09129', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (58, NULL, 58, 'Cruzeiro do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.760768', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4729, NULL, 4729, 'Cruzeiro do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.880928', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1106, NULL, 1106, 'Cruzeta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.927437', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2472, NULL, 2472, 'Cruzilia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.399226', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4004, NULL, 4004, 'Cruzmaltina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.092294', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3416, NULL, 3416, 'Cubatao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.435124', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1306, NULL, 1306, 'Cubati', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.144275', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5214, NULL, 5214, 'Cuiaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.414149', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1307, NULL, 1307, 'Cuite', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.145159', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1308, NULL, 1308, 'Cuite de Mamanguape', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.146038', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1309, NULL, 1309, 'Cuitegi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.146933', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (18, NULL, 18, 'Cujubim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.715723', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5392, NULL, 5392, 'Cumari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.61735', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1517, NULL, 1517, 'Cumaru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.377881', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (191, NULL, 191, 'Cumaru do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.911121', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1767, NULL, 1767, 'Cumbe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.641238', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3417, NULL, 3417, 'Cunha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.436005', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4385, NULL, 4385, 'Cunha Pora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.510481', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4386, NULL, 4386, 'Cunhatai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.511334', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2473, NULL, 2473, 'Cuparaque', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.400152', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1518, NULL, 1518, 'Cupira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.378741', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1941, NULL, 1941, 'Curaca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.827636', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (733, NULL, 733, 'Curimata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.509093', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (192, NULL, 192, 'Curionopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.912262', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4005, NULL, 4005, 'Curitiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.093188', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4387, NULL, 4387, 'Curitibanos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.512194', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4006, NULL, 4006, 'Curiuva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.094161', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (734, NULL, 734, 'Currais', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.509915', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1107, NULL, 1107, 'Currais Novos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.928357', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1310, NULL, 1310, 'Curral de Cima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.147807', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2474, NULL, 2474, 'Curral de Dentro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.401352', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (735, NULL, 735, 'Curral Novo do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.516478', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1311, NULL, 1311, 'Curral Velho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.14869', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (193, NULL, 193, 'Curralinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.913215', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (736, NULL, 736, 'Curralinhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.517649', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (194, NULL, 194, 'Curua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.914119', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (195, NULL, 195, 'Curuca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.915017', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (512, NULL, 512, 'Cururupu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.269164', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2475, NULL, 2475, 'Curvelo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.41163', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1519, NULL, 1519, 'Custodia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.379657', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (296, NULL, 296, 'Cutias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.031457', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5393, NULL, 5393, 'Damianopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.618249', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1312, NULL, 1312, 'Damiao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.149547', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5394, NULL, 5394, 'Damolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.619199', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (354, NULL, 354, 'Darcinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.092435', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1942, NULL, 1942, 'Dario Meira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.829405', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2476, NULL, 2476, 'Datas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.412738', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4730, NULL, 4730, 'David Canabarro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.881777', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5395, NULL, 5395, 'Davinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.620154', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (513, NULL, 513, 'Davinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.270095', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2477, NULL, 2477, 'Delfim Moreira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.413631', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2478, NULL, 2478, 'Delfinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.414454', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1674, NULL, 1674, 'Delmiro Gouveia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.544416', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2479, NULL, 2479, 'Delta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.415301', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (737, NULL, 737, 'Demerval Lobao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.518747', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5216, NULL, 5216, 'Denise', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.416081', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5127, NULL, 5127, 'Deodapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.319156', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (943, NULL, 943, 'Deputado Irapuan Pinheiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.739701', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4731, NULL, 4731, 'Derrubadas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.882651', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3418, NULL, 3418, 'Descalvado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.436909', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4388, NULL, 4388, 'Descanso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.513047', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2480, NULL, 2480, 'Descoberto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.416181', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1313, NULL, 1313, 'Desterro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.150441', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2481, NULL, 2481, 'Desterro de Entre Rios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.417061', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2482, NULL, 2482, 'Desterro do Melo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.417919', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4732, NULL, 4732, 'Dezesseis de Novembro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.883767', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3419, NULL, 3419, 'Diadema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.43802', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1314, NULL, 1314, 'Diamante', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.151433', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4009, NULL, 4009, 'Diamante D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.097438', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4007, NULL, 4007, 'Diamante do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.095041', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4008, NULL, 4008, 'Diamante do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.096391', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2483, NULL, 2483, 'Diamantina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.418797', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5217, NULL, 5217, 'Diamantino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.417014', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (355, NULL, 355, 'Dianopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.093325', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1943, NULL, 1943, 'Dias D''avila', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.830489', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4733, NULL, 4733, 'Dilermando de Aguiar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.884831', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2484, NULL, 2484, 'Diogo de Vasconcelos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.41969', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2485, NULL, 2485, 'Dionisio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.420606', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4389, NULL, 4389, 'Dionisio Cerqueira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.513922', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5396, NULL, 5396, 'Diorama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.621073', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3420, NULL, 3420, 'Dirce Reis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.438961', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (738, NULL, 738, 'Dirceu Arcoverde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.519566', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1768, NULL, 1768, 'Divina Pastora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.642203', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2486, NULL, 2486, 'Divinesia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.421506', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2487, NULL, 2487, 'Divino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.422311', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2488, NULL, 2488, 'Divino das Laranjeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.423584', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3117, NULL, 3117, 'Divino de Sao Lourenco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.107684', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3421, NULL, 3421, 'Divinolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.439881', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2489, NULL, 2489, 'Divinolandia de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.424526', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2490, NULL, 2490, 'Divinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.425468', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5397, NULL, 5397, 'Divinopolis de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.622032', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (356, NULL, 356, 'Divinopolis do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.094239', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2491, NULL, 2491, 'Divisa Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.426294', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2492, NULL, 2492, 'Divisa Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.427201', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2493, NULL, 2493, 'Divisopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.428217', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3422, NULL, 3422, 'Dobrada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.44092', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3423, NULL, 3423, 'Dois Corregos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.441834', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4734, NULL, 4734, 'Dois Irmaos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.885678', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4735, NULL, 4735, 'Dois Irmaos das Missoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.886822', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5128, NULL, 5128, 'Dois Irmaos do Buriti', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.320079', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (357, NULL, 357, 'Dois Irmaos do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.09535', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4736, NULL, 4736, 'Dois Lajeados', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.887804', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1675, NULL, 1675, 'Dois Riachos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.545079', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4010, NULL, 4010, 'Dois Vizinhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.098274', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3424, NULL, 3424, 'Dolcinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.442609', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5218, NULL, 5218, 'Dom Aquino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.417947', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1944, NULL, 1944, 'Dom Basilio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.831352', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2494, NULL, 2494, 'Dom Bosco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.429142', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2495, NULL, 2495, 'Dom Cavati', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.430042', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (196, NULL, 196, 'Dom Eliseu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.91602', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (739, NULL, 739, 'Dom Expedito Lopes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.520463', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4737, NULL, 4737, 'Dom Feliciano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.889073', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (740, NULL, 740, 'Dom Inocencio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.521277', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2496, NULL, 2496, 'Dom Joaquim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.430968', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1945, NULL, 1945, 'Dom Macedo Costa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.83241', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4738, NULL, 4738, 'Dom Pedrito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.890589', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (514, NULL, 514, 'Dom Pedro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.271002', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4739, NULL, 4739, 'Dom Pedro de Alcantara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.891631', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2497, NULL, 2497, 'Dom Silverio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.43188', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2498, NULL, 2498, 'Dom Vicoso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.432759', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3118, NULL, 3118, 'Domingos Martins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.108581', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (741, NULL, 741, 'Domingos Mourao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.522', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4390, NULL, 4390, 'Dona Emma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.514778', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2499, NULL, 2499, 'Dona Eusebia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.433829', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4740, NULL, 4740, 'Dona Francisca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.892557', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1315, NULL, 1315, 'Dona Ines', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.152276', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2500, NULL, 2500, 'Dores de Campos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.434737', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2501, NULL, 2501, 'Dores de Guanhaes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.435545', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2502, NULL, 2502, 'Dores do Indaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.436568', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3119, NULL, 3119, 'Dores do Rio Preto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.109452', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2503, NULL, 2503, 'Dores do Turvo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.437482', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2504, NULL, 2504, 'Doresopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.438283', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1520, NULL, 1520, 'Dormentes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.380527', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5129, NULL, 5129, 'Douradina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.320958', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4011, NULL, 4011, 'Douradina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.099183', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3425, NULL, 3425, 'Dourado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.443543', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2505, NULL, 2505, 'Douradoquara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.439165', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5130, NULL, 5130, 'Dourados', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.321841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4012, NULL, 4012, 'Doutor Camargo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.100098', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4741, NULL, 4741, 'Doutor Mauricio Cardoso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.893417', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4391, NULL, 4391, 'Doutor Pedrinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.515649', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4742, NULL, 4742, 'Doutor Ricardo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.894387', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1108, NULL, 1108, 'Doutor Severiano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.92922', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4013, NULL, 4013, 'Doutor Ulysses', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.100967', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5398, NULL, 5398, 'Doverlandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.623068', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3426, NULL, 3426, 'Dracena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.444476', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3427, NULL, 3427, 'Duartina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.445394', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3197, NULL, 3197, 'Duas Barras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.195152', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1316, NULL, 1316, 'Duas Estradas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.153226', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (358, NULL, 358, 'Duere', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.102276', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3428, NULL, 3428, 'Dumont', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.44637', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (515, NULL, 515, 'Duque Bacelar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.271929', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3198, NULL, 3198, 'Duque de Caxias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.195978', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2506, NULL, 2506, 'Durande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.439988', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3429, NULL, 3429, 'Echapora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.447249', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3120, NULL, 3120, 'Ecoporanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.110394', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5399, NULL, 5399, 'Edealina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.623962', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5400, NULL, 5400, 'Edeia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.624932', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (96, NULL, 96, 'Eirunepe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.802748', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3430, NULL, 3430, 'Eldorado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.448152', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5131, NULL, 5131, 'Eldorado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.322753', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4743, NULL, 4743, 'Eldorado do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.895258', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (197, NULL, 197, 'Eldorado dos Carajas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.917067', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (742, NULL, 742, 'Elesbao Veloso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.522894', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3431, NULL, 3431, 'Elias Fausto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.449197', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (743, NULL, 743, 'Eliseu Martins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.52379', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3432, NULL, 3432, 'Elisiario', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.450013', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1946, NULL, 1946, 'Elisio Medrado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.833251', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2507, NULL, 2507, 'Eloi Mendes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.440884', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1317, NULL, 1317, 'Emas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.154106', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3433, NULL, 3433, 'Embauba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.450854', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3435, NULL, 3435, 'Embu-guacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.452864', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3436, NULL, 3436, 'Emilianopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.453877', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4744, NULL, 4744, 'Encantado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.896204', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1109, NULL, 1109, 'Encanto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.930124', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1947, NULL, 1947, 'Encruzilhada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.83412', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4745, NULL, 4745, 'Encruzilhada do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.89707', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4014, NULL, 4014, 'Eneas Marques', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.10187', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4015, NULL, 4015, 'Engenheiro Beltrao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.102709', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2508, NULL, 2508, 'Engenheiro Caldas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.441795', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3437, NULL, 3437, 'Engenheiro Coelho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.454824', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2509, NULL, 2509, 'Engenheiro Navarro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.442634', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3199, NULL, 3199, 'Engenheiro Paulo de Frontin', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.197016', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4746, NULL, 4746, 'Engenho Velho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.898021', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2510, NULL, 2510, 'Entre Folhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.44354', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4392, NULL, 4392, 'Entre Rios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.516534', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1948, NULL, 1948, 'Entre Rios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.835064', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2511, NULL, 2511, 'Entre Rios de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.444453', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4016, NULL, 4016, 'Entre Rios do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.103512', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4747, NULL, 4747, 'Entre Rios do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.899076', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4748, NULL, 4748, 'Entre-ijuis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.899999', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (97, NULL, 97, 'Envira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.803632', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (59, NULL, 59, 'Epitaciolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.761618', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1110, NULL, 1110, 'Equador', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.930949', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4749, NULL, 4749, 'Erebango', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.906919', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4750, NULL, 4750, 'Erechim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.908132', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (944, NULL, 944, 'Erere', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.740766', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1949, NULL, 1949, 'Erico Cardoso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.835874', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4393, NULL, 4393, 'Ermo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.517512', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4751, NULL, 4751, 'Ernestina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.909116', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4752, NULL, 4752, 'Erval Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.910038', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4753, NULL, 4753, 'Erval Seco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.910899', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4394, NULL, 4394, 'Erval Velho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.518414', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2512, NULL, 2512, 'Ervalia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.445278', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1521, NULL, 1521, 'Escada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.381407', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4754, NULL, 4754, 'Esmeralda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.91172', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2513, NULL, 2513, 'Esmeraldas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.451797', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2514, NULL, 2514, 'Espera Feliz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.452981', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1318, NULL, 1318, 'Esperanca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.154937', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4755, NULL, 4755, 'Esperanca do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.912737', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4017, NULL, 4017, 'Esperanca Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.104368', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (359, NULL, 359, 'Esperantina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.103367', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (744, NULL, 744, 'Esperantina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.524652', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (516, NULL, 516, 'Esperantinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.27286', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4018, NULL, 4018, 'Espigao Alto do Iguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.105422', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (19, NULL, 19, 'Espigao D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.716704', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2515, NULL, 2515, 'Espinosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.453778', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1111, NULL, 1111, 'Espirito Santo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.93187', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2516, NULL, 2516, 'Espirito Santo do Dourado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.454654', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3438, NULL, 3438, 'Espirito Santo do Pinhal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.455702', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3439, NULL, 3439, 'Espirito Santo do Turvo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.456596', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1950, NULL, 1950, 'Esplanada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.836741', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4756, NULL, 4756, 'Espumoso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.913602', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4757, NULL, 4757, 'Estacao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.914491', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1769, NULL, 1769, 'Estancia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.642975', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4758, NULL, 4758, 'Estancia Velha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.915345', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4759, NULL, 4759, 'Esteio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.916206', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2517, NULL, 2517, 'Estiva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.4555', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3440, NULL, 3440, 'Estiva Gerbi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.459826', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (517, NULL, 517, 'Estreito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.273795', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4760, NULL, 4760, 'Estrela', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.917135', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3442, NULL, 3442, 'Estrela D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.464626', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2518, NULL, 2518, 'Estrela Dalva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.456458', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1676, NULL, 1676, 'Estrela de Alagoas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.545943', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2519, NULL, 2519, 'Estrela do Indaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.457559', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3441, NULL, 3441, 'Estrela do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.463187', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5401, NULL, 5401, 'Estrela do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.625947', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2520, NULL, 2520, 'Estrela do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.458485', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4761, NULL, 4761, 'Estrela Velha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.918019', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1951, NULL, 1951, 'Euclides da Cunha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.837646', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3443, NULL, 3443, 'Euclides da Cunha Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.465815', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4762, NULL, 4762, 'Eugenio de Castro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.918923', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2521, NULL, 2521, 'Eugenopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.459407', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1952, NULL, 1952, 'Eunapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.838519', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (945, NULL, 945, 'Eusebio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.741714', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2522, NULL, 2522, 'Ewbank da Camara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.460227', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2523, NULL, 2523, 'Extrema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.461085', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1112, NULL, 1112, 'Extremoz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.93282', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1522, NULL, 1522, 'Exu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.382617', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1319, NULL, 1319, 'Fagundes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.15573', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4763, NULL, 4763, 'Fagundes Varela', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.919878', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5402, NULL, 5402, 'Faina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.626774', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2524, NULL, 2524, 'Fama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.461955', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2525, NULL, 2525, 'Faria Lemos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.462875', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (946, NULL, 946, 'Farias Brito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.742725', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (198, NULL, 198, 'Faro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.91806', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4019, NULL, 4019, 'Farol', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.106399', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4764, NULL, 4764, 'Farroupilha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.920693', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3444, NULL, 3444, 'Fartura', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.467149', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (745, NULL, 745, 'Fartura do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.526063', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1953, NULL, 1953, 'Fatima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.839335', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (360, NULL, 360, 'Fatima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.104253', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5132, NULL, 5132, 'Fatima do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.323883', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4020, NULL, 4020, 'Faxinal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.107374', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4765, NULL, 4765, 'Faxinal do Soturno', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.92163', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4395, NULL, 4395, 'Faxinal dos Guedes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.519319', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4766, NULL, 4766, 'Faxinalzinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.922524', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5403, NULL, 5403, 'Fazenda Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.627692', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4021, NULL, 4021, 'Fazenda Rio Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.108241', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4767, NULL, 4767, 'Fazenda Vilanova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.923302', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (60, NULL, 60, 'Feijo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.762592', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1954, NULL, 1954, 'Feira da Mata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.840193', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1955, NULL, 1955, 'Feira de Santana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.841117', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1677, NULL, 1677, 'Feira Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.546837', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1770, NULL, 1770, 'Feira Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.643769', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1523, NULL, 1523, 'Feira Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.383472', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (518, NULL, 518, 'Feira Nova do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.274839', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2526, NULL, 2526, 'Felicio dos Santos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.463927', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1113, NULL, 1113, 'Felipe Guerra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.933753', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2527, NULL, 2527, 'Felisburgo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.464686', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2528, NULL, 2528, 'Felixlandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.465613', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4768, NULL, 4768, 'Feliz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.924228', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1678, NULL, 1678, 'Feliz Deserto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.547708', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5219, NULL, 5219, 'Feliz Natal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.418926', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4022, NULL, 4022, 'Fenix', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.109288', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4023, NULL, 4023, 'Fernandes Pinheiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.110161', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2529, NULL, 2529, 'Fernandes Tourinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.46651', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1524, NULL, 1524, 'Fernando de Noronha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.384317', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (519, NULL, 519, 'Fernando Falcao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.275832', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1114, NULL, 1114, 'Fernando Pedroza', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.934712', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3445, NULL, 3445, 'Fernando Prestes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.468296', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3446, NULL, 3446, 'Fernandopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.474339', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3447, NULL, 3447, 'Fernao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.475403', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3448, NULL, 3448, 'Ferraz de Vasconcelos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.476418', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (297, NULL, 297, 'Ferreira Gomes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.032313', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1525, NULL, 1525, 'Ferreiros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.3852', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2530, NULL, 2530, 'Ferros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.467262', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2531, NULL, 2531, 'Fervedouro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.468075', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4024, NULL, 4024, 'Figueira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.111065', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5133, NULL, 5133, 'Figueirao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.324801', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (361, NULL, 361, 'Figueiropolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.105111', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5220, NULL, 5220, 'Figueiropolis D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.419849', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (362, NULL, 362, 'Filadelfia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.106031', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1956, NULL, 1956, 'Filadelfia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.842011', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1957, NULL, 1957, 'Firmino Alves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.842944', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5404, NULL, 5404, 'Firminopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.628612', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1679, NULL, 1679, 'Flexeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.54858', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4025, NULL, 4025, 'Flor da Serra do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.111977', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4396, NULL, 4396, 'Flor do Sertao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.520213', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3449, NULL, 3449, 'Flora Rica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.477443', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4026, NULL, 4026, 'Florai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.112881', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1115, NULL, 1115, 'Florania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.935678', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3450, NULL, 3450, 'Floreal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.478415', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1526, NULL, 1526, 'Flores', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.386058', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4769, NULL, 4769, 'Flores da Cunha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.925172', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5405, NULL, 5405, 'Flores de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.629589', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (746, NULL, 746, 'Flores do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.527005', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4027, NULL, 4027, 'Floresta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.113867', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1527, NULL, 1527, 'Floresta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.386923', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1958, NULL, 1958, 'Floresta Azul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.843755', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (199, NULL, 199, 'Floresta do Araguaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.918982', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (747, NULL, 747, 'Floresta do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.527865', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2532, NULL, 2532, 'Florestal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.469065', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4028, NULL, 4028, 'Florestopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.114779', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (748, NULL, 748, 'Floriano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.528733', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4770, NULL, 4770, 'Floriano Peixoto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.926129', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4397, NULL, 4397, 'Florianopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.521114', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4029, NULL, 4029, 'Florida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.115752', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3451, NULL, 3451, 'Florida Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.479622', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3452, NULL, 3452, 'Florinia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.480544', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (98, NULL, 98, 'Fonte Boa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.804528', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4771, NULL, 4771, 'Fontoura Xavier', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.927051', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2533, NULL, 2533, 'Formiga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.469915', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4772, NULL, 4772, 'Formigueiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.928008', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5406, NULL, 5406, 'Formosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.630429', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (520, NULL, 520, 'Formosa da Serra Negra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.276788', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4030, NULL, 4030, 'Formosa do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.116721', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1959, NULL, 1959, 'Formosa do Rio Preto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.844635', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4398, NULL, 4398, 'Formosa do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.522109', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5407, NULL, 5407, 'Formoso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.631268', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2534, NULL, 2534, 'Formoso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.470866', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (363, NULL, 363, 'Formoso do Araguaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.106844', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4773, NULL, 4773, 'Forquetinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.928929', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (947, NULL, 947, 'Forquilha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.743617', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4399, NULL, 4399, 'Forquilhinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.523012', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (948, NULL, 948, 'Fortaleza', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.744504', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2535, NULL, 2535, 'Fortaleza de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.4718', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (364, NULL, 364, 'Fortaleza do Tabocao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.107791', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (521, NULL, 521, 'Fortaleza dos Nogueiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.27762', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4774, NULL, 4774, 'Fortaleza dos Valos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.929825', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (949, NULL, 949, 'Fortim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.74536', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (522, NULL, 522, 'Fortuna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.278459', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5417, NULL, 5417, 'Guapo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.646555', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2536, NULL, 2536, 'Fortuna de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.472649', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4031, NULL, 4031, 'Foz do Iguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.117707', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4032, NULL, 4032, 'Foz do Jordao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.118639', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4400, NULL, 4400, 'Fraiburgo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.523979', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3453, NULL, 3453, 'Franca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.481469', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (749, NULL, 749, 'Francinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.529749', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4033, NULL, 4033, 'Francisco Alves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.119613', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (750, NULL, 750, 'Francisco Ayres', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.530678', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2537, NULL, 2537, 'Francisco Badaro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.47366', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4034, NULL, 4034, 'Francisco Beltrao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.120558', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1116, NULL, 1116, 'Francisco Dantas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.936647', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2538, NULL, 2538, 'Francisco Dumont', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.474555', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (751, NULL, 751, 'Francisco Macedo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.531546', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3454, NULL, 3454, 'Francisco Morato', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.482394', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2539, NULL, 2539, 'Francisco Sa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.47544', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (752, NULL, 752, 'Francisco Santos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.532468', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2540, NULL, 2540, 'Franciscopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.476315', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3455, NULL, 3455, 'Franco da Rocha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.483499', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (950, NULL, 950, 'Frecheirinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.7463', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4775, NULL, 4775, 'Frederico Westphalen', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.93063', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2541, NULL, 2541, 'Frei Gaspar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.477184', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2542, NULL, 2542, 'Frei Inocencio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.478085', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2543, NULL, 2543, 'Frei Lagonegro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.478996', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1320, NULL, 1320, 'Frei Martinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.156702', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1528, NULL, 1528, 'Frei Miguelinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.387844', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1771, NULL, 1771, 'Frei Paulo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.64469', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4401, NULL, 4401, 'Frei Rogerio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.524846', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2544, NULL, 2544, 'Fronteira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.479756', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2545, NULL, 2545, 'Fronteira dos Vales', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.480618', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (753, NULL, 753, 'Fronteiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.533279', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2546, NULL, 2546, 'Fruta de Leite', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.481494', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2547, NULL, 2547, 'Frutal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.482274', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1117, NULL, 1117, 'Frutuoso Gomes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.93762', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3121, NULL, 3121, 'Fundao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.111308', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2548, NULL, 2548, 'Funilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.483177', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3456, NULL, 3456, 'Gabriel Monteiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.484411', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1321, NULL, 1321, 'Gado Bravo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.157619', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3457, NULL, 3457, 'Galia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.485277', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2549, NULL, 2549, 'Galileia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.484093', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1118, NULL, 1118, 'Galinhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.938502', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4402, NULL, 4402, 'Galvao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.525743', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1529, NULL, 1529, 'Gameleira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.388718', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5408, NULL, 5408, 'Gameleira de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.632204', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2550, NULL, 2550, 'Gameleiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.484955', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1960, NULL, 1960, 'Gandu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.845544', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1530, NULL, 1530, 'Garanhuns', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.389733', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1772, NULL, 1772, 'Gararu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.645572', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3458, NULL, 3458, 'Garca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.486137', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4776, NULL, 4776, 'Garibaldi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.931355', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4403, NULL, 4403, 'Garopaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.526646', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (200, NULL, 200, 'Garrafao do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.919913', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4777, NULL, 4777, 'Garruchos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.932182', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4404, NULL, 4404, 'Garuva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.527531', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4405, NULL, 4405, 'Gaspar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.528459', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3459, NULL, 3459, 'Gastao Vidigal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.487262', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5221, NULL, 5221, 'Gaucha do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.4207', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4778, NULL, 4778, 'Gaurama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.933069', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1961, NULL, 1961, 'Gaviao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.846441', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3460, NULL, 3460, 'Gaviao Peixoto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.488275', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (754, NULL, 754, 'Geminiano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.534092', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4779, NULL, 4779, 'General Camara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.934026', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4035, NULL, 4035, 'General Carneiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.127423', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5222, NULL, 5222, 'General Carneiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.421639', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1773, NULL, 1773, 'General Maynard', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.646491', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3461, NULL, 3461, 'General Salgado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.489182', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (951, NULL, 951, 'General Sampaio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.747206', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4780, NULL, 4780, 'Gentil', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.934915', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1962, NULL, 1962, 'Gentio do Ouro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.847284', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3462, NULL, 3462, 'Getulina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.490105', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4781, NULL, 4781, 'Getulio Vargas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.935839', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (755, NULL, 755, 'Gilbues', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.535027', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1680, NULL, 1680, 'Girau do Ponciano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.549416', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4782, NULL, 4782, 'Girua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.936719', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2551, NULL, 2551, 'Glaucilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.485777', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3463, NULL, 3463, 'Glicerio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.491081', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1963, NULL, 1963, 'Gloria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.84819', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5223, NULL, 5223, 'Gloria D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.422532', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5134, NULL, 5134, 'Gloria de Dourados', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.325637', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1531, NULL, 1531, 'Gloria do Goita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.390524', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4783, NULL, 4783, 'Glorinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.937632', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (523, NULL, 523, 'Godofredo Viana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.279542', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4036, NULL, 4036, 'Godoy Moreira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.128645', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2552, NULL, 2552, 'Goiabeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.493322', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1532, NULL, 1532, 'Goiana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.391405', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2553, NULL, 2553, 'Goiana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.494496', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5409, NULL, 5409, 'Goianapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.633039', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5410, NULL, 5410, 'Goiandira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.633983', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5411, NULL, 5411, 'Goianesia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.634918', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (201, NULL, 201, 'Goianesia do Para', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.92081', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5412, NULL, 5412, 'Goiania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.635858', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1119, NULL, 1119, 'Goianinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.939453', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5413, NULL, 5413, 'Goianira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.636781', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (365, NULL, 365, 'Goianorte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.108687', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5414, NULL, 5414, 'Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.643396', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (366, NULL, 366, 'Goiatins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.10958', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5415, NULL, 5415, 'Goiatuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.644646', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4038, NULL, 4038, 'Goioxim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.13055', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2554, NULL, 2554, 'Goncalves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.49536', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (524, NULL, 524, 'Goncalves Dias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.280371', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1964, NULL, 1964, 'Gongogi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.84909', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2555, NULL, 2555, 'Gonzaga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.496231', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2556, NULL, 2556, 'Gouveia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.497133', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5416, NULL, 5416, 'Gouvelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.645672', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (525, NULL, 525, 'Governador Archer', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.281277', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4406, NULL, 4406, 'Governador Celso Ramos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.529386', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1120, NULL, 1120, 'Governador Dix-sept Rosado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.940328', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (526, NULL, 526, 'Governador Edison Lobao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.282223', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (527, NULL, 527, 'Governador Eugenio Barros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.283125', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (20, NULL, 20, 'Governador Jorge Teixeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.717717', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3122, NULL, 3122, 'Governador Lindenberg', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.112208', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (528, NULL, 528, 'Governador Luiz Rocha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.283974', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1966, NULL, 1966, 'Governador Mangabeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.850857', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (529, NULL, 529, 'Governador Newton Bello', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.284782', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (530, NULL, 530, 'Governador Nunes Freire', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.285675', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2557, NULL, 2557, 'Governador Valadares', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.498098', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (952, NULL, 952, 'Graca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.748217', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (531, NULL, 531, 'Graca Aranha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.286846', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1774, NULL, 1774, 'Gracho Cardoso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.64737', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (532, NULL, 532, 'Grajau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.287677', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4784, NULL, 4784, 'Gramado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.938533', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4785, NULL, 4785, 'Gramado dos Loureiros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.939344', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4786, NULL, 4786, 'Gramado Xavier', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.940203', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4039, NULL, 4039, 'Grandes Rios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.131638', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1533, NULL, 1533, 'Granito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.392255', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (953, NULL, 953, 'Granja', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.74904', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (954, NULL, 954, 'Granjeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.749942', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2558, NULL, 2558, 'Grao Mogol', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.498957', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4407, NULL, 4407, 'Grao Para', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.530212', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1534, NULL, 1534, 'Gravata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.393148', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4787, NULL, 4787, 'Gravatai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.941029', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4408, NULL, 4408, 'Gravatal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.531116', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (955, NULL, 955, 'Groairas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.750947', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1121, NULL, 1121, 'Grossos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.941151', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2559, NULL, 2559, 'Grupiara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.499849', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4788, NULL, 4788, 'Guabiju', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.947441', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4409, NULL, 4409, 'Guabiruba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.53194', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3123, NULL, 3123, 'Guacui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.113153', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (756, NULL, 756, 'Guadalupe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.535945', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4789, NULL, 4789, 'Guaiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.9486', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3464, NULL, 3464, 'Guaicara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.49205', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3465, NULL, 3465, 'Guaimbe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.492981', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4040, NULL, 4040, 'Guaira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.13242', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3466, NULL, 3466, 'Guaira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.493861', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4041, NULL, 4041, 'Guairaca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.133372', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (956, NULL, 956, 'Guaiuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.751904', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (99, NULL, 99, 'Guajara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.805459', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (21, NULL, 21, 'Guajara-mirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.718803', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1967, NULL, 1967, 'Guajeru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.85184', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1122, NULL, 1122, 'Guamare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.942246', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4042, NULL, 4042, 'Guamiranga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.134252', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1968, NULL, 1968, 'Guanambi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.852748', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2560, NULL, 2560, 'Guanhaes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.500653', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2561, NULL, 2561, 'Guape', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.501713', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3467, NULL, 3467, 'Guapiacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.494824', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3468, NULL, 3468, 'Guapiara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.495711', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3200, NULL, 3200, 'Guapimirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.197975', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4043, NULL, 4043, 'Guapirama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.135191', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4790, NULL, 4790, 'Guapore', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.949507', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4044, NULL, 4044, 'Guaporema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.136151', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3469, NULL, 3469, 'Guara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.49662', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1322, NULL, 1322, 'Guarabira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.158561', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3470, NULL, 3470, 'Guaracai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.497498', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3471, NULL, 3471, 'Guaraci', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.498609', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4045, NULL, 4045, 'Guaraci', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.137079', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2562, NULL, 2562, 'Guaraciaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.502633', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4410, NULL, 4410, 'Guaraciaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.532863', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (957, NULL, 957, 'Guaraciaba do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.752745', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2563, NULL, 2563, 'Guaraciama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.503502', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (367, NULL, 367, 'Guarai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.110381', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5418, NULL, 5418, 'Guaraita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.647553', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (958, NULL, 958, 'Guaramiranga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.753708', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4411, NULL, 4411, 'Guaramirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.533779', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2564, NULL, 2564, 'Guaranesia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.504369', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2565, NULL, 2565, 'Guarani', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.505195', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3472, NULL, 3472, 'Guarani D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.499582', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4791, NULL, 4791, 'Guarani das Missoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.950373', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5419, NULL, 5419, 'Guarani de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.648866', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4046, NULL, 4046, 'Guaraniacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.138006', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3473, NULL, 3473, 'Guaranta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.500522', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5224, NULL, 5224, 'Guaranta do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.423784', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3124, NULL, 3124, 'Guarapari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.11402', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4047, NULL, 4047, 'Guarapuava', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.138945', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4048, NULL, 4048, 'Guaraquecaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.139847', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2566, NULL, 2566, 'Guarara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.506059', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3474, NULL, 3474, 'Guararapes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.501478', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3475, NULL, 3475, 'Guararema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.502457', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1969, NULL, 1969, 'Guaratinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.853646', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3476, NULL, 3476, 'Guaratingueta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.503375', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4049, NULL, 4049, 'Guaratuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.140817', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2567, NULL, 2567, 'Guarda-mor', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.506895', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3477, NULL, 3477, 'Guarei', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.504252', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3478, NULL, 3478, 'Guariba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.50542', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (757, NULL, 757, 'Guaribas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.536987', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5420, NULL, 5420, 'Guarinos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.649863', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3479, NULL, 3479, 'Guaruja', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.506355', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4412, NULL, 4412, 'Guaruja do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.535074', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3480, NULL, 3480, 'Guarulhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.50736', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4413, NULL, 4413, 'Guatambu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.541376', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3481, NULL, 3481, 'Guatapara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.514491', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2568, NULL, 2568, 'Guaxupe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.507726', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5135, NULL, 5135, 'Guia Lopes da Laguna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.326641', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2569, NULL, 2569, 'Guidoval', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.508808', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (533, NULL, 533, 'Guimaraes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.288667', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2570, NULL, 2570, 'Guimarania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.509736', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5225, NULL, 5225, 'Guiratinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.424887', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2571, NULL, 2571, 'Guiricema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.510664', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2572, NULL, 2572, 'Gurinhata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.51156', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1323, NULL, 1323, 'Gurinhem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.159521', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1324, NULL, 1324, 'Gurjao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.160604', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (202, NULL, 202, 'Gurupa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.921711', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (368, NULL, 368, 'Gurupi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.111293', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3482, NULL, 3482, 'Guzolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.51563', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4792, NULL, 4792, 'Harmonia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.951225', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5421, NULL, 5421, 'Heitorai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.650692', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2573, NULL, 2573, 'Heliodora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.512439', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1970, NULL, 1970, 'Heliopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.854517', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3483, NULL, 3483, 'Herculandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.516787', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4793, NULL, 4793, 'Herval', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.952112', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4414, NULL, 4414, 'Herval D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.542596', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4794, NULL, 4794, 'Herveiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.953031', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (959, NULL, 959, 'Hidrolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.760735', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5422, NULL, 5422, 'Hidrolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.651434', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5423, NULL, 5423, 'Hidrolina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.65227', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3484, NULL, 3484, 'Holambra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.517506', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4050, NULL, 4050, 'Honorio Serpa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.141648', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (960, NULL, 960, 'Horizonte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.761924', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4795, NULL, 4795, 'Horizontina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.953898', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3485, NULL, 3485, 'Hortolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.518326', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (758, NULL, 758, 'Hugo Napoleao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.53787', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4796, NULL, 4796, 'Hulha Negra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.954845', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4797, NULL, 4797, 'Humaita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.955805', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (100, NULL, 100, 'Humaita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.806293', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (534, NULL, 534, 'Humberto de Campos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.289578', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3486, NULL, 3486, 'Iacanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.519603', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5424, NULL, 5424, 'Iaciara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.653174', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3487, NULL, 3487, 'Iacri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.520661', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1971, NULL, 1971, 'Iacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.855462', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2574, NULL, 2574, 'Iapu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.513288', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3488, NULL, 3488, 'Iaras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.521549', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1535, NULL, 1535, 'Iati', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.394064', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4051, NULL, 4051, 'Ibaiti', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.142752', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4798, NULL, 4798, 'Ibarama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.95672', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (961, NULL, 961, 'Ibaretama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.762867', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3489, NULL, 3489, 'Ibate', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.522424', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1681, NULL, 1681, 'Ibateguara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.550297', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3125, NULL, 3125, 'Ibatiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.11507', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4052, NULL, 4052, 'Ibema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.143584', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2575, NULL, 2575, 'Ibertioga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.514211', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2576, NULL, 2576, 'Ibia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.515149', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4799, NULL, 4799, 'Ibiaca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.957546', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2577, NULL, 2577, 'Ibiai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.515973', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4415, NULL, 4415, 'Ibiam', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.543705', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (962, NULL, 962, 'Ibiapina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.763788', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1325, NULL, 1325, 'Ibiara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.168082', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1972, NULL, 1972, 'Ibiassuce', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.856356', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1973, NULL, 1973, 'Ibicarai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.857175', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4416, NULL, 4416, 'Ibicare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.544411', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1974, NULL, 1974, 'Ibicoara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.858076', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1975, NULL, 1975, 'Ibicui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.858999', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (963, NULL, 963, 'Ibicuitinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.764672', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1536, NULL, 1536, 'Ibimirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.394992', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1976, NULL, 1976, 'Ibipeba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.859993', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1977, NULL, 1977, 'Ibipitanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.867007', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4053, NULL, 4053, 'Ibipora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.14439', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1978, NULL, 1978, 'Ibiquera', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.868154', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3490, NULL, 3490, 'Ibira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.52329', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2578, NULL, 2578, 'Ibiracatu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.516767', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2579, NULL, 2579, 'Ibiraci', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.51756', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3126, NULL, 3126, 'Ibiracu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.115945', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4800, NULL, 4800, 'Ibiraiaras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.958417', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1537, NULL, 1537, 'Ibirajuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.395927', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4417, NULL, 4417, 'Ibirama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.54531', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1979, NULL, 1979, 'Ibirapitanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.869284', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1980, NULL, 1980, 'Ibirapua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.870219', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4801, NULL, 4801, 'Ibirapuita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.959294', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3491, NULL, 3491, 'Ibirarema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.524224', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1981, NULL, 1981, 'Ibirataia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.871155', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2580, NULL, 2580, 'Ibirite', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.518486', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4802, NULL, 4802, 'Ibiruba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.96032', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1982, NULL, 1982, 'Ibitiara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.872193', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3492, NULL, 3492, 'Ibitinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.525141', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3127, NULL, 3127, 'Ibitirama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.116851', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1983, NULL, 1983, 'Ibitita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.873038', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2581, NULL, 2581, 'Ibitiura de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.519415', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2582, NULL, 2582, 'Ibituruna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.520237', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3493, NULL, 3493, 'Ibiuna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.526048', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1984, NULL, 1984, 'Ibotirama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.873833', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (964, NULL, 964, 'Icapui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.765576', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4418, NULL, 4418, 'Icara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.546167', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2583, NULL, 2583, 'Icarai de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.521141', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4054, NULL, 4054, 'Icaraima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.145266', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (535, NULL, 535, 'Icatu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.290557', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3494, NULL, 3494, 'Icem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.526892', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1985, NULL, 1985, 'Ichu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.874719', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (965, NULL, 965, 'Ico', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.76682', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3128, NULL, 3128, 'Iconha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.117854', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1123, NULL, 1123, 'Ielmo Marinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.943257', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1682, NULL, 1682, 'Igaci', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.551161', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1986, NULL, 1986, 'Igapora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.875578', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3496, NULL, 3496, 'Igaracu do Tiete', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.528553', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1326, NULL, 1326, 'Igaracy', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.169184', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3497, NULL, 3497, 'Igarapava', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.5295', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2584, NULL, 2584, 'Igarape', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.522171', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (536, NULL, 536, 'Igarape do Meio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.291496', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (537, NULL, 537, 'Igarape Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.2924', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (203, NULL, 203, 'Igarape-acu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.922705', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (204, NULL, 204, 'Igarape-miri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.92357', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1538, NULL, 1538, 'Igarassu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.396835', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3498, NULL, 3498, 'Igarata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.530465', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2585, NULL, 2585, 'Igaratinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.523975', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1987, NULL, 1987, 'Igrapiuna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.876442', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1683, NULL, 1683, 'Igreja Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.552215', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4803, NULL, 4803, 'Igrejinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.96119', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3201, NULL, 3201, 'Iguaba Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.198896', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1988, NULL, 1988, 'Iguai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.877337', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3499, NULL, 3499, 'Iguape', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.531632', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4055, NULL, 4055, 'Iguaracu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.146086', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2586, NULL, 2586, 'Iguatama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.524916', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5136, NULL, 5136, 'Iguatemi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.327619', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4056, NULL, 4056, 'Iguatu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.146981', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (966, NULL, 966, 'Iguatu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.767721', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2587, NULL, 2587, 'Ijaci', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.525818', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4804, NULL, 4804, 'Ijui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.96206', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3500, NULL, 3500, 'Ilha Comprida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.532647', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1775, NULL, 1775, 'Ilha das Flores', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.648183', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (759, NULL, 759, 'Ilha Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.538744', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3501, NULL, 3501, 'Ilha Solteira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.533656', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3502, NULL, 3502, 'Ilhabela', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.534591', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1989, NULL, 1989, 'Ilheus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.878226', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4419, NULL, 4419, 'Ilhota', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.546952', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2588, NULL, 2588, 'Ilicinea', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.526807', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4805, NULL, 4805, 'Ilopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.962987', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1327, NULL, 1327, 'Imaculada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.170197', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4420, NULL, 4420, 'Imarui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.547891', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4057, NULL, 4057, 'Imbau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.147856', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4806, NULL, 4806, 'Imbe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.963785', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2589, NULL, 2589, 'Imbe de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.527566', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4421, NULL, 4421, 'Imbituba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.548745', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4058, NULL, 4058, 'Imbituva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.148856', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4422, NULL, 4422, 'Imbuia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.549615', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4807, NULL, 4807, 'Imigrante', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.965082', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (538, NULL, 538, 'Imperatriz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.293262', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4059, NULL, 4059, 'Inacio Martins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.149748', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5425, NULL, 5425, 'Inaciolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.654174', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1540, NULL, 1540, 'Inaja', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.398738', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4060, NULL, 4060, 'Inaja', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.150609', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2590, NULL, 2590, 'Inconfidentes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.534284', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2591, NULL, 2591, 'Indaiabira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.535355', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4423, NULL, 4423, 'Indaial', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.550745', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3503, NULL, 3503, 'Indaiatuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.53556', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4808, NULL, 4808, 'Independencia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.96594', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (967, NULL, 967, 'Independencia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.768666', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3504, NULL, 3504, 'Indiana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.536463', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4061, NULL, 4061, 'Indianopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.151462', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2592, NULL, 2592, 'Indianopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.536141', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3505, NULL, 3505, 'Indiapora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.537406', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5426, NULL, 5426, 'Indiara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.655008', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1776, NULL, 1776, 'Indiaroba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.649012', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5226, NULL, 5226, 'Indiavai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.425733', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1328, NULL, 1328, 'Inga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.171029', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2593, NULL, 2593, 'Ingai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.53695', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1541, NULL, 1541, 'Ingazeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.399746', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4809, NULL, 4809, 'Inhacora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.966873', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1990, NULL, 1990, 'Inhambupe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.87915', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (205, NULL, 205, 'Inhangapi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.924586', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1684, NULL, 1684, 'Inhapi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.553518', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2594, NULL, 2594, 'Inhapim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.537926', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2595, NULL, 2595, 'Inhauma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.538866', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (760, NULL, 760, 'Inhuma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.539664', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5427, NULL, 5427, 'Inhumas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.655851', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2596, NULL, 2596, 'Inimutaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.539693', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5137, NULL, 5137, 'Inocencia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.328612', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3506, NULL, 3506, 'Inubia Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.538346', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4424, NULL, 4424, 'Iomere', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.551707', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2597, NULL, 2597, 'Ipaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.540615', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5428, NULL, 5428, 'Ipameri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.656848', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2598, NULL, 2598, 'Ipanema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.541477', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1124, NULL, 1124, 'Ipanguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.944128', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (968, NULL, 968, 'Ipaporanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.769582', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2599, NULL, 2599, 'Ipatinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.542301', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (969, NULL, 969, 'Ipaumirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.770486', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3507, NULL, 3507, 'Ipaussu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.539122', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4810, NULL, 4810, 'Ipe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.967679', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1991, NULL, 1991, 'Ipecaeta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.880071', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3508, NULL, 3508, 'Ipero', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.540114', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3509, NULL, 3509, 'Ipeuna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.54106', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2600, NULL, 2600, 'Ipiacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.543088', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1992, NULL, 1992, 'Ipiau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.880952', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3510, NULL, 3510, 'Ipigua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.542009', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4425, NULL, 4425, 'Ipira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.552628', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1993, NULL, 1993, 'Ipira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.881831', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4062, NULL, 4062, 'Ipiranga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.15233', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5429, NULL, 5429, 'Ipiranga de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.657863', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5227, NULL, 5227, 'Ipiranga do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.426779', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (761, NULL, 761, 'Ipiranga do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.540631', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4811, NULL, 4811, 'Ipiranga do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.968588', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (101, NULL, 101, 'Ipixuna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.813076', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (206, NULL, 206, 'Ipixuna do Para', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.9256', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1542, NULL, 1542, 'Ipojuca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.400727', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5430, NULL, 5430, 'Ipora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.658736', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4063, NULL, 4063, 'Ipora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.153244', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4426, NULL, 4426, 'Ipora do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.553489', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3511, NULL, 3511, 'Iporanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.542934', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (970, NULL, 970, 'Ipu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.771489', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3512, NULL, 3512, 'Ipua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.543761', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4427, NULL, 4427, 'Ipuacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.554353', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1543, NULL, 1543, 'Ipubi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.401708', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1125, NULL, 1125, 'Ipueira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.945019', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (971, NULL, 971, 'Ipueiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.772507', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (369, NULL, 369, 'Ipueiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.112298', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2601, NULL, 2601, 'Ipuiuna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.544006', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4428, NULL, 4428, 'Ipumirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.555764', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1994, NULL, 1994, 'Ipupiara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.882705', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (143, NULL, 143, 'Iracema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.859891', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (972, NULL, 972, 'Iracema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.773512', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4064, NULL, 4064, 'Iracema do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.154171', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3513, NULL, 3513, 'Iracemapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.544853', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4429, NULL, 4429, 'Iraceminha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.556864', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4812, NULL, 4812, 'Irai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.969396', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2602, NULL, 2602, 'Irai de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.544877', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1995, NULL, 1995, 'Irajuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.883566', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1996, NULL, 1996, 'Iramaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.88439', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (102, NULL, 102, 'Iranduba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.814239', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4430, NULL, 4430, 'Irani', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.557716', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3514, NULL, 3514, 'Irapua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.545807', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3515, NULL, 3515, 'Irapuru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.546727', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1997, NULL, 1997, 'Iraquara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.885298', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1998, NULL, 1998, 'Irara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.886211', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4065, NULL, 4065, 'Irati', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.155067', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4431, NULL, 4431, 'Irati', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.558657', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (973, NULL, 973, 'Iraucuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.774468', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1999, NULL, 1999, 'Irece', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.887131', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4066, NULL, 4066, 'Iretama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.155943', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4432, NULL, 4432, 'Irineopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.559588', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (207, NULL, 207, 'Irituia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.926608', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3129, NULL, 3129, 'Irupi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.118674', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (762, NULL, 762, 'Isaias Coelho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.541589', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5431, NULL, 5431, 'Israelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.659837', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4433, NULL, 4433, 'Ita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.56052', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4813, NULL, 4813, 'Itaara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.970351', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1777, NULL, 1777, 'Itabaiana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.649896', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1329, NULL, 1329, 'Itabaiana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.172174', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1778, NULL, 1778, 'Itabaianinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.650772', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2000, NULL, 2000, 'Itabela', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.88815', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3516, NULL, 3516, 'Itabera', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.54776', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2001, NULL, 2001, 'Itaberaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.888959', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5432, NULL, 5432, 'Itaberai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.660714', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1779, NULL, 1779, 'Itabi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.651642', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2603, NULL, 2603, 'Itabira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.545641', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2604, NULL, 2604, 'Itabirinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.546423', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2605, NULL, 2605, 'Itabirito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.547264', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3202, NULL, 3202, 'Itaborai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.199823', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2002, NULL, 2002, 'Itabuna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.889845', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (370, NULL, 370, 'Itacaja', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.113135', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2606, NULL, 2606, 'Itacambira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.54826', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2607, NULL, 2607, 'Itacarambi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.549333', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2003, NULL, 2003, 'Itacare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.890749', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1544, NULL, 1544, 'Itacuruba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.402642', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4814, NULL, 4814, 'Itacurubi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.971294', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2004, NULL, 2004, 'Itaete', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.891611', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2005, NULL, 2005, 'Itagi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.892478', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2006, NULL, 2006, 'Itagiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.893317', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2007, NULL, 2007, 'Itagimirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.894412', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3130, NULL, 3130, 'Itaguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.119498', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2008, NULL, 2008, 'Itaguacu da Bahia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.895374', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3203, NULL, 3203, 'Itaguai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.200615', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4067, NULL, 4067, 'Itaguaje', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.156929', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2608, NULL, 2608, 'Itaguara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.550259', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5433, NULL, 5433, 'Itaguari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.66169', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5434, NULL, 5434, 'Itaguaru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.662571', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (371, NULL, 371, 'Itaguatins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.113912', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3517, NULL, 3517, 'Itai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.555415', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1545, NULL, 1545, 'Itaiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.403569', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (974, NULL, 974, 'Itaicaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.77543', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (763, NULL, 763, 'Itainopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.54226', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4434, NULL, 4434, 'Itaiopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.5614', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (539, NULL, 539, 'Itaipava do Grajau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.294094', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2609, NULL, 2609, 'Itaipe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.551156', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4068, NULL, 4068, 'Itaipulandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.157878', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (975, NULL, 975, 'Itaitinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.77631', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (208, NULL, 208, 'Itaituba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.92776', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1126, NULL, 1126, 'Itaja', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.946076', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5435, NULL, 5435, 'Itaja', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.663372', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4435, NULL, 4435, 'Itajai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.562258', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3518, NULL, 3518, 'Itajobi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.556639', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3519, NULL, 3519, 'Itaju', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.557538', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2009, NULL, 2009, 'Itaju do Colonia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.896523', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2610, NULL, 2610, 'Itajuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.552041', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2010, NULL, 2010, 'Itajuipe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.897461', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3204, NULL, 3204, 'Italva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.201573', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2011, NULL, 2011, 'Itamaraju', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.898265', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2611, NULL, 2611, 'Itamarandiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.55291', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (103, NULL, 103, 'Itamarati', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.815178', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2612, NULL, 2612, 'Itamarati de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.553968', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2012, NULL, 2012, 'Itamari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.89943', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2613, NULL, 2613, 'Itambacuri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.554843', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4069, NULL, 4069, 'Itambaraca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.158813', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2013, NULL, 2013, 'Itambe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.900314', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1547, NULL, 1547, 'Itambe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.405413', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4070, NULL, 4070, 'Itambe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.159654', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2614, NULL, 2614, 'Itambe do Mato Dentro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.555903', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2615, NULL, 2615, 'Itamogi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.556785', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2616, NULL, 2616, 'Itamonte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.557679', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2014, NULL, 2014, 'Itanagra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.901209', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3520, NULL, 3520, 'Itanhaem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.558368', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2617, NULL, 2617, 'Itanhandu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.558486', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5228, NULL, 5228, 'Itanhanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.427777', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2015, NULL, 2015, 'Itanhem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.902022', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2618, NULL, 2618, 'Itanhomi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.559343', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2619, NULL, 2619, 'Itaobim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.560182', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3521, NULL, 3521, 'Itaoca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.559349', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3205, NULL, 3205, 'Itaocara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.202472', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5436, NULL, 5436, 'Itapaci', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.664184', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (976, NULL, 976, 'Itapage', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.777235', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2620, NULL, 2620, 'Itapagipe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.561129', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2016, NULL, 2016, 'Itaparica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.906287', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2017, NULL, 2017, 'Itape', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.909995', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2018, NULL, 2018, 'Itapebi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.911146', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2621, NULL, 2621, 'Itapecerica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.562045', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3522, NULL, 3522, 'Itapecerica da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.560304', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (540, NULL, 540, 'Itapecuru Mirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.295124', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4071, NULL, 4071, 'Itapejara D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.160601', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4436, NULL, 4436, 'Itapema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.563129', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3131, NULL, 3131, 'Itapemirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.120273', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4072, NULL, 4072, 'Itaperucu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.161482', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3206, NULL, 3206, 'Itaperuna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.203303', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1548, NULL, 1548, 'Itapetim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.40621', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2019, NULL, 2019, 'Itapetinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.911973', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3523, NULL, 3523, 'Itapetininga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.561226', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3524, NULL, 3524, 'Itapeva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.562042', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2622, NULL, 2622, 'Itapeva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.562886', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3525, NULL, 3525, 'Itapevi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.563', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2020, NULL, 2020, 'Itapicuru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.913016', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (977, NULL, 977, 'Itapipoca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.778328', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3526, NULL, 3526, 'Itapira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.564035', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4437, NULL, 4437, 'Itapiranga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.564104', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (104, NULL, 104, 'Itapiranga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.816065', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5437, NULL, 5437, 'Itapirapua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.665155', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3527, NULL, 3527, 'Itapirapua Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.564976', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (372, NULL, 372, 'Itapiratins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.1149', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1549, NULL, 1549, 'Itapissuma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.407134', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2021, NULL, 2021, 'Itapitanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.913895', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (978, NULL, 978, 'Itapiuna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.779217', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4438, NULL, 4438, 'Itapoa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.565082', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3528, NULL, 3528, 'Itapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.565875', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5138, NULL, 5138, 'Itapora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.329508', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (373, NULL, 373, 'Itapora do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.11572', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3529, NULL, 3529, 'Itaporanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.566665', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1330, NULL, 1330, 'Itaporanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.173123', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1780, NULL, 1780, 'Itaporanga D''ajuda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.652555', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1331, NULL, 1331, 'Itapororoca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.174094', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (22, NULL, 22, 'Itapua do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.719743', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4815, NULL, 4815, 'Itapuca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.972165', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3530, NULL, 3530, 'Itapui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.567469', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3531, NULL, 3531, 'Itapura', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.568248', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5438, NULL, 5438, 'Itapuranga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.666064', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3532, NULL, 3532, 'Itaquaquecetuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.569268', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2022, NULL, 2022, 'Itaquara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.914769', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4816, NULL, 4816, 'Itaqui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.973061', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5139, NULL, 5139, 'Itaquirai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.33029', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1550, NULL, 1550, 'Itaquitinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.408047', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3132, NULL, 3132, 'Itarana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.12108', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2023, NULL, 2023, 'Itarantim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.915654', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3533, NULL, 3533, 'Itarare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.570327', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (979, NULL, 979, 'Itarema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.780134', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3534, NULL, 3534, 'Itariri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.571116', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5439, NULL, 5439, 'Itaruma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.666945', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4817, NULL, 4817, 'Itati', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.974002', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3207, NULL, 3207, 'Itatiaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.204383', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2623, NULL, 2623, 'Itatiaiucu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.56382', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3535, NULL, 3535, 'Itatiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.572068', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4818, NULL, 4818, 'Itatiba do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.974873', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2024, NULL, 2024, 'Itatim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.916552', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3536, NULL, 3536, 'Itatinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.572867', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (980, NULL, 980, 'Itatira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.781004', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1332, NULL, 1332, 'Itatuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.174905', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1127, NULL, 1127, 'Itau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.946989', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2624, NULL, 2624, 'Itau de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.564738', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5229, NULL, 5229, 'Itauba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.42877', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (298, NULL, 298, 'Itaubal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.033162', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5440, NULL, 5440, 'Itaucu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.667766', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (764, NULL, 764, 'Itaueira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.543208', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2625, NULL, 2625, 'Itauna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.565631', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4073, NULL, 4073, 'Itauna do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.162479', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2626, NULL, 2626, 'Itaverava', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.566539', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2627, NULL, 2627, 'Itinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.567443', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (541, NULL, 541, 'Itinga do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.296028', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5230, NULL, 5230, 'Itiquira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.429726', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3537, NULL, 3537, 'Itirapina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.57366', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3538, NULL, 3538, 'Itirapua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.574547', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2025, NULL, 2025, 'Itirucu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.917472', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2026, NULL, 2026, 'Itiuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.918303', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3539, NULL, 3539, 'Itobi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.57546', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2027, NULL, 2027, 'Itororo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.919192', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3540, NULL, 3540, 'Itu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.576321', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2028, NULL, 2028, 'Ituacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.920019', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2029, NULL, 2029, 'Itubera', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.920842', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2628, NULL, 2628, 'Itueta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.574206', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2629, NULL, 2629, 'Ituiutaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.575462', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5441, NULL, 5441, 'Itumbiara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.668731', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2630, NULL, 2630, 'Itumirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.576278', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3541, NULL, 3541, 'Itupeva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.577536', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (209, NULL, 209, 'Itupiranga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.928737', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4439, NULL, 4439, 'Ituporanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.566056', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2631, NULL, 2631, 'Iturama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.577299', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2632, NULL, 2632, 'Itutinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.578215', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3542, NULL, 3542, 'Ituverava', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.578426', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2030, NULL, 2030, 'Iuiu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.921738', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3133, NULL, 3133, 'Iuna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.122057', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4074, NULL, 4074, 'Ivai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.173191', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4075, NULL, 4075, 'Ivaipora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.174405', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4076, NULL, 4076, 'Ivate', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.175489', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4077, NULL, 4077, 'Ivatuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.176411', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5140, NULL, 5140, 'Ivinhema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.331111', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5442, NULL, 5442, 'Ivolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.669617', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4819, NULL, 4819, 'Ivora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.975784', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4820, NULL, 4820, 'Ivoti', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.976642', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1551, NULL, 1551, 'Jaboatao dos Guararapes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.408818', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4440, NULL, 4440, 'Jabora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.566836', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2031, NULL, 2031, 'Jaborandi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.922718', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3543, NULL, 3543, 'Jaborandi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.579392', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4078, NULL, 4078, 'Jaboti', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.177343', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4821, NULL, 4821, 'Jaboticaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.977503', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3544, NULL, 3544, 'Jaboticabal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.58031', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2633, NULL, 2633, 'Jaboticatubas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.579155', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1128, NULL, 1128, 'Jacana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.947875', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2032, NULL, 2032, 'Jacaraci', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.923539', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1333, NULL, 1333, 'Jacarau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.175971', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1685, NULL, 1685, 'Jacare dos Homens', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.554435', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (210, NULL, 210, 'Jacareacanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.936088', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3545, NULL, 3545, 'Jacarei', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.581242', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4079, NULL, 4079, 'Jacarezinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.178223', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3546, NULL, 3546, 'Jaci', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.582181', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5231, NULL, 5231, 'Jaciara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.436354', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2634, NULL, 2634, 'Jacinto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.579934', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4441, NULL, 4441, 'Jacinto Machado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.567842', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2033, NULL, 2033, 'Jacobina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.92442', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (765, NULL, 765, 'Jacobina do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.544013', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2635, NULL, 2635, 'Jacui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.580977', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1686, NULL, 1686, 'Jacuipe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.555236', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4822, NULL, 4822, 'Jacuizinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.978423', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (211, NULL, 211, 'Jacunda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.937324', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3547, NULL, 3547, 'Jacupiranga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.583183', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4823, NULL, 4823, 'Jacutinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.979538', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2636, NULL, 2636, 'Jacutinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.581851', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4080, NULL, 4080, 'Jaguapita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.17908', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2034, NULL, 2034, 'Jaguaquara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.925284', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2637, NULL, 2637, 'Jaguaracu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.582674', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4824, NULL, 4824, 'Jaguarao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.980338', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2035, NULL, 2035, 'Jaguarari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.926186', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3134, NULL, 3134, 'Jaguare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.122973', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (981, NULL, 981, 'Jaguaretama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.781931', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4825, NULL, 4825, 'Jaguari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.981152', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4081, NULL, 4081, 'Jaguariaiva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.179969', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (982, NULL, 982, 'Jaguaribara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.782755', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (983, NULL, 983, 'Jaguaribe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.783553', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2036, NULL, 2036, 'Jaguaripe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.927091', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3548, NULL, 3548, 'Jaguariuna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.583988', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (984, NULL, 984, 'Jaguaruana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.784418', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4442, NULL, 4442, 'Jaguaruna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.568806', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2638, NULL, 2638, 'Jaiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.583605', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (766, NULL, 766, 'Jaicos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.544932', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3549, NULL, 3549, 'Jales', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.584901', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3550, NULL, 3550, 'Jambeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.585854', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2639, NULL, 2639, 'Jampruca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.584486', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2640, NULL, 2640, 'Janauba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.585356', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5443, NULL, 5443, 'Jandaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.670602', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4082, NULL, 4082, 'Jandaia do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.180921', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2037, NULL, 2037, 'Jandaira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.928038', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1129, NULL, 1129, 'Jandaira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.948829', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3551, NULL, 3551, 'Jandira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.586757', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1130, NULL, 1130, 'Janduis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.949781', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5232, NULL, 5232, 'Jangada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.437631', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4083, NULL, 4083, 'Janiopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.181768', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2641, NULL, 2641, 'Januaria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.586257', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1131, NULL, 1131, 'Januario Cicco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.950601', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2642, NULL, 2642, 'Japaraiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.587138', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1687, NULL, 1687, 'Japaratinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.556108', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1781, NULL, 1781, 'Japaratuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.653348', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3208, NULL, 3208, 'Japeri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.20529', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1132, NULL, 1132, 'Japi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.951564', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4084, NULL, 4084, 'Japira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.182695', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1782, NULL, 1782, 'Japoata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.654107', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2643, NULL, 2643, 'Japonvar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.58822', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5141, NULL, 5141, 'Japora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.332023', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4085, NULL, 4085, 'Japura', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.183595', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (105, NULL, 105, 'Japura', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.81715', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1552, NULL, 1552, 'Jaqueira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.409756', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4826, NULL, 4826, 'Jaquirana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.987939', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5444, NULL, 5444, 'Jaragua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.671381', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4443, NULL, 4443, 'Jaragua do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.569621', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5142, NULL, 5142, 'Jaraguari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.332947', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1688, NULL, 1688, 'Jaramataia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.556965', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (985, NULL, 985, 'Jardim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.785258', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5143, NULL, 5143, 'Jardim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.333891', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4086, NULL, 4086, 'Jardim Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.184551', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1133, NULL, 1133, 'Jardim de Angicos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.952483', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1134, NULL, 1134, 'Jardim de Piranhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.953409', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (767, NULL, 767, 'Jardim do Mulato', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.545843', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1135, NULL, 1135, 'Jardim do Serido', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.954238', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4087, NULL, 4087, 'Jardim Olinda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.185484', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4444, NULL, 4444, 'Jardinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.570517', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3552, NULL, 3552, 'Jardinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.587586', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4827, NULL, 4827, 'Jari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.989393', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3553, NULL, 3553, 'Jarinu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.588515', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (23, NULL, 23, 'Jaru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.720746', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5445, NULL, 5445, 'Jatai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.672203', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4088, NULL, 4088, 'Jataizinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.186508', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1553, NULL, 1553, 'Jatauba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.410498', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5144, NULL, 5144, 'Jatei', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.334815', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (986, NULL, 986, 'Jati', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.786168', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (542, NULL, 542, 'Jatoba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.296978', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1554, NULL, 1554, 'Jatoba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.411876', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (768, NULL, 768, 'Jatoba do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.546727', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3554, NULL, 3554, 'Jau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.589433', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (374, NULL, 374, 'Jau do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.116488', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5446, NULL, 5446, 'Jaupaci', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.673077', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5233, NULL, 5233, 'Jauru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.438623', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2644, NULL, 2644, 'Jeceaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.589312', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2645, NULL, 2645, 'Jenipapo de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.590255', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (543, NULL, 543, 'Jenipapo dos Vieiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.29789', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2646, NULL, 2646, 'Jequeri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.591033', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1689, NULL, 1689, 'Jequia da Praia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.557886', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2038, NULL, 2038, 'Jequie', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.928884', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2647, NULL, 2647, 'Jequitai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.592039', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2648, NULL, 2648, 'Jequitiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.592846', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2649, NULL, 2649, 'Jequitinhonha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.593621', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2039, NULL, 2039, 'Jeremoabo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.929851', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1334, NULL, 1334, 'Jerico', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.176834', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3555, NULL, 3555, 'Jeriquara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.590483', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3135, NULL, 3135, 'Jeronimo Monteiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.123854', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (769, NULL, 769, 'Jerumenha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.547582', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2650, NULL, 2650, 'Jesuania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.594594', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4089, NULL, 4089, 'Jesuitas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.187505', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5447, NULL, 5447, 'Jesupolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.67413', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (24, NULL, 24, 'Ji-parana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.721775', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (987, NULL, 987, 'Jijoca de Jericoacoara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.787039', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2040, NULL, 2040, 'Jiquirica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.930853', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2041, NULL, 2041, 'Jitauna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.93178', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4445, NULL, 4445, 'Joacaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.571308', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2651, NULL, 2651, 'Joaima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.595575', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2652, NULL, 2652, 'Joanesia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.596474', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3556, NULL, 3556, 'Joanopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.596351', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1555, NULL, 1555, 'Joao Alfredo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.417932', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1136, NULL, 1136, 'Joao Camara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.955149', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (770, NULL, 770, 'Joao Costa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.548411', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1137, NULL, 1137, 'Joao Dias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.956075', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2042, NULL, 2042, 'Joao Dourado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.932709', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (544, NULL, 544, 'Joao Lisboa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.298837', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2653, NULL, 2653, 'Joao Monlevade', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.597362', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3136, NULL, 3136, 'Joao Neiva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.124735', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1335, NULL, 1335, 'Joao Pessoa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.177745', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2654, NULL, 2654, 'Joao Pinheiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.59822', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3557, NULL, 3557, 'Joao Ramalho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.597603', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2655, NULL, 2655, 'Joaquim Felicio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.599054', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1690, NULL, 1690, 'Joaquim Gomes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.558773', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1556, NULL, 1556, 'Joaquim Nabuco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.419099', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (771, NULL, 771, 'Joaquim Pires', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.549224', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4090, NULL, 4090, 'Joaquim Tavora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.188472', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (772, NULL, 772, 'Joca Marques', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.550172', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4828, NULL, 4828, 'Joia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.990672', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4446, NULL, 4446, 'Joinville', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.572209', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2656, NULL, 2656, 'Jordania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.600016', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (61, NULL, 61, 'Jordao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.763501', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4447, NULL, 4447, 'Jose Boiteux', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.573179', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3558, NULL, 3558, 'Jose Bonifacio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.59875', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1138, NULL, 1138, 'Jose da Penha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.957006', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (773, NULL, 773, 'Jose de Freitas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.557', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2657, NULL, 2657, 'Jose Goncalves de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.600945', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2658, NULL, 2658, 'Jose Raydan', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.602108', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (545, NULL, 545, 'Joselandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.299813', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2659, NULL, 2659, 'Josenopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.603016', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5448, NULL, 5448, 'Joviania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.675038', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5234, NULL, 5234, 'Juara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.439558', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1336, NULL, 1336, 'Juarez Tavora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.178614', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (375, NULL, 375, 'Juarina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.117396', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2660, NULL, 2660, 'Juatuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.604047', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1337, NULL, 1337, 'Juazeirinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.179447', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2043, NULL, 2043, 'Juazeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.933661', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (988, NULL, 988, 'Juazeiro do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.787963', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (774, NULL, 774, 'Juazeiro do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.558345', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (989, NULL, 989, 'Jucas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.788883', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1557, NULL, 1557, 'Jucati', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.420118', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2044, NULL, 2044, 'Jucurucu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.934595', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1139, NULL, 1139, 'Jucurutu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.957905', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5235, NULL, 5235, 'Juina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.440473', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2661, NULL, 2661, 'Juiz de Fora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.604952', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (775, NULL, 775, 'Julio Borges', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.559238', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4829, NULL, 4829, 'Julio de Castilhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.991636', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3559, NULL, 3559, 'Julio Mesquita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.599726', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3560, NULL, 3560, 'Jumirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.600794', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (546, NULL, 546, 'Junco do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.300907', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1338, NULL, 1338, 'Junco do Serido', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.180365', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1691, NULL, 1691, 'Jundia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.55955', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1140, NULL, 1140, 'Jundia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.958828', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3561, NULL, 3561, 'Jundiai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.601706', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4091, NULL, 4091, 'Jundiai do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.189369', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1692, NULL, 1692, 'Junqueiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.560447', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3562, NULL, 3562, 'Junqueiropolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.602591', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1558, NULL, 1558, 'Jupi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.421181', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4448, NULL, 4448, 'Jupia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.574057', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3563, NULL, 3563, 'Juquia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.603635', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3564, NULL, 3564, 'Juquitiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.604582', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2662, NULL, 2662, 'Juramento', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.605847', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4092, NULL, 4092, 'Juranda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.190237', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (776, NULL, 776, 'Jurema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.560161', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1559, NULL, 1559, 'Jurema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.422125', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1339, NULL, 1339, 'Juripiranga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.181348', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1340, NULL, 1340, 'Juru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.182217', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (106, NULL, 106, 'Jurua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.818091', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2663, NULL, 2663, 'Juruaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.606705', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5236, NULL, 5236, 'Juruena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.441383', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (212, NULL, 212, 'Juruti', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.938243', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5237, NULL, 5237, 'Juscimeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.442317', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2045, NULL, 2045, 'Jussara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.935594', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4093, NULL, 4093, 'Jussara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.191189', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5449, NULL, 5449, 'Jussara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.675958', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2046, NULL, 2046, 'Jussari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.93641', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2047, NULL, 2047, 'Jussiape', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.937255', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (107, NULL, 107, 'Jutai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.819038', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5145, NULL, 5145, 'Juti', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.335804', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2664, NULL, 2664, 'Juvenilia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.607706', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4094, NULL, 4094, 'Kalore', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.192042', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (108, NULL, 108, 'Labrea', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.820032', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4449, NULL, 4449, 'Lacerdopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.574936', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2665, NULL, 2665, 'Ladainha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.614724', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5146, NULL, 5146, 'Ladario', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.336612', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2048, NULL, 2048, 'Lafaiete Coutinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.938148', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2666, NULL, 2666, 'Lagamar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.615844', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1783, NULL, 1783, 'Lagarto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.654821', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4450, NULL, 4450, 'Lages', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.581911', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (547, NULL, 547, 'Lago da Pedra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.302071', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (548, NULL, 548, 'Lago do Junco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.307903', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (549, NULL, 549, 'Lago dos Rodrigues', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.309158', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (550, NULL, 550, 'Lago Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.310138', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1341, NULL, 1341, 'Lagoa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.183149', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (777, NULL, 777, 'Lagoa Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.561061', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4830, NULL, 4830, 'Lagoa Bonita do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.992696', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1141, NULL, 1141, 'Lagoa D''anta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.965134', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1693, NULL, 1693, 'Lagoa da Canoa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.561361', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (376, NULL, 376, 'Lagoa da Confusao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.11813', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2667, NULL, 2667, 'Lagoa da Prata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.616813', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1342, NULL, 1342, 'Lagoa de Dentro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.184115', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1142, NULL, 1142, 'Lagoa de Pedras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.966233', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (778, NULL, 778, 'Lagoa de Sao Francisco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.562032', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1143, NULL, 1143, 'Lagoa de Velhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.967108', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (779, NULL, 779, 'Lagoa do Barro do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.56292', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1560, NULL, 1560, 'Lagoa do Carro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.423115', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (551, NULL, 551, 'Lagoa do Mato', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.311156', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1562, NULL, 1562, 'Lagoa do Ouro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.424996', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (780, NULL, 780, 'Lagoa do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.56385', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (781, NULL, 781, 'Lagoa do Sitio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.56476', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (377, NULL, 377, 'Lagoa do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.118825', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1563, NULL, 1563, 'Lagoa dos Gatos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.425859', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2668, NULL, 2668, 'Lagoa dos Patos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.617738', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4831, NULL, 4831, 'Lagoa dos Tres Cantos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.993546', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2669, NULL, 2669, 'Lagoa Dourada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.618698', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2670, NULL, 2670, 'Lagoa Formosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.619622', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2671, NULL, 2671, 'Lagoa Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.620559', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1564, NULL, 1564, 'Lagoa Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.42668', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (552, NULL, 552, 'Lagoa Grande do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.312133', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1144, NULL, 1144, 'Lagoa Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.96806', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2049, NULL, 2049, 'Lagoa Real', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.938963', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1145, NULL, 1145, 'Lagoa Salgada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.968966', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5450, NULL, 5450, 'Lagoa Santa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.676927', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2672, NULL, 2672, 'Lagoa Santa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.621608', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1343, NULL, 1343, 'Lagoa Seca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.185256', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4832, NULL, 4832, 'Lagoa Vermelha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.99444', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4833, NULL, 4833, 'Lagoao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.995228', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3565, NULL, 3565, 'Lagoinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.605474', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (782, NULL, 782, 'Lagoinha do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.565646', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4451, NULL, 4451, 'Laguna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.583305', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5147, NULL, 5147, 'Laguna Carapa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.337536', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3209, NULL, 3209, 'Laje do Muriae', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.206148', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4834, NULL, 4834, 'Lajeado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.996115', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (378, NULL, 378, 'Lajeado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.119873', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4835, NULL, 4835, 'Lajeado do Bugre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.996989', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4452, NULL, 4452, 'Lajeado Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.584135', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (553, NULL, 553, 'Lajeado Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.313052', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2051, NULL, 2051, 'Lajedao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.940684', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2052, NULL, 2052, 'Lajedinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.941599', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1565, NULL, 1565, 'Lajedo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.427665', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2053, NULL, 2053, 'Lajedo do Tabocal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.942474', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1146, NULL, 1146, 'Lajes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.96988', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1147, NULL, 1147, 'Lajes Pintadas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.970916', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2673, NULL, 2673, 'Lajinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.622616', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2054, NULL, 2054, 'Lamarao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.943451', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2674, NULL, 2674, 'Lambari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.623675', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5238, NULL, 5238, 'Lambari D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.443327', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2675, NULL, 2675, 'Lamim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.624505', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (783, NULL, 783, 'Landri Sales', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.566526', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4095, NULL, 4095, 'Lapa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.192994', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2055, NULL, 2055, 'Lapao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.947684', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3137, NULL, 3137, 'Laranja da Terra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.125741', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2676, NULL, 2676, 'Laranjal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.625461', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4096, NULL, 4096, 'Laranjal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.193967', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (299, NULL, 299, 'Laranjal do Jari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.034147', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3566, NULL, 3566, 'Laranjal Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.607194', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1784, NULL, 1784, 'Laranjeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.655682', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4097, NULL, 4097, 'Laranjeiras do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.194892', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2677, NULL, 2677, 'Lassance', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.626399', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1344, NULL, 1344, 'Lastro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.186203', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4453, NULL, 4453, 'Laurentino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.584973', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2056, NULL, 2056, 'Lauro de Freitas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.951579', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4454, NULL, 4454, 'Lauro Muller', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.585797', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (379, NULL, 379, 'Lavandeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.120739', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3567, NULL, 3567, 'Lavinia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.608188', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2678, NULL, 2678, 'Lavras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.62728', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (990, NULL, 990, 'Lavras da Mangabeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.789684', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4836, NULL, 4836, 'Lavras do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.998102', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3568, NULL, 3568, 'Lavrinhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.60912', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2679, NULL, 2679, 'Leandro Ferreira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.6282', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4455, NULL, 4455, 'Lebon Regis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.586737', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3569, NULL, 3569, 'Leme', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.609957', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2680, NULL, 2680, 'Leme do Prado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.629003', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2057, NULL, 2057, 'Lencois', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.952621', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3570, NULL, 3570, 'Lencois Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.611063', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4456, NULL, 4456, 'Leoberto Leal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.587727', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2681, NULL, 2681, 'Leopoldina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.629801', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5451, NULL, 5451, 'Leopoldo de Bulhoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.687916', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4098, NULL, 4098, 'Leopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.195946', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4837, NULL, 4837, 'Liberato Salzano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.999038', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2682, NULL, 2682, 'Liberdade', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.630694', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2058, NULL, 2058, 'Licinio de Almeida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.953576', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4099, NULL, 4099, 'Lidianopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.196969', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (554, NULL, 554, 'Lima Campos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.313916', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2683, NULL, 2683, 'Lima Duarte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.631701', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3571, NULL, 3571, 'Limeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.612034', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2684, NULL, 2684, 'Limeira do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.632595', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1566, NULL, 1566, 'Limoeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.428572', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1694, NULL, 1694, 'Limoeiro de Anadia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.562239', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (213, NULL, 213, 'Limoeiro do Ajuru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.939321', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (991, NULL, 991, 'Limoeiro do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.790614', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4100, NULL, 4100, 'Lindoeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.197979', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3572, NULL, 3572, 'Lindoia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.613045', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4457, NULL, 4457, 'Lindoia do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.589095', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4838, NULL, 4838, 'Lindolfo Collor', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.999932', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4839, NULL, 4839, 'Linha Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.00075', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3138, NULL, 3138, 'Linhares', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.126641', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3573, NULL, 3573, 'Lins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.613865', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1345, NULL, 1345, 'Livramento', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.187139', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2059, NULL, 2059, 'Livramento de Nossa Senhora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.954557', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (380, NULL, 380, 'Lizarda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.121597', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4101, NULL, 4101, 'Loanda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.198786', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4102, NULL, 4102, 'Lobato', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.199695', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1346, NULL, 1346, 'Logradouro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.18807', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4103, NULL, 4103, 'Londrina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.200588', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2685, NULL, 2685, 'Lontra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.633499', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4458, NULL, 4458, 'Lontras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.590019', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3574, NULL, 3574, 'Lorena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.61467', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (555, NULL, 555, 'Loreto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.31479', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3575, NULL, 3575, 'Lourdes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.615605', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3576, NULL, 3576, 'Louveira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.616624', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5239, NULL, 5239, 'Lucas do Rio Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.444223', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3577, NULL, 3577, 'Lucelia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.617438', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1347, NULL, 1347, 'Lucena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.188966', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3578, NULL, 3578, 'Lucianopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.618341', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5240, NULL, 5240, 'Luciara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.445157', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1148, NULL, 1148, 'Lucrecia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.971944', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3579, NULL, 3579, 'Luis Antonio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.619193', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (784, NULL, 784, 'Luis Correia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.567389', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (556, NULL, 556, 'Luis Domingues', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.315685', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2060, NULL, 2060, 'Luis Eduardo Magalhaes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.955329', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1149, NULL, 1149, 'Luis Gomes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.973018', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2686, NULL, 2686, 'Luisburgo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.634802', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2687, NULL, 2687, 'Luislandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.635773', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4459, NULL, 4459, 'Luiz Alves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.590917', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4104, NULL, 4104, 'Luiziana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.2014', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3580, NULL, 3580, 'Luiziania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.620134', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2688, NULL, 2688, 'Luminarias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.636597', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4105, NULL, 4105, 'Lunardelli', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.202191', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3581, NULL, 3581, 'Lupercio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.621094', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4106, NULL, 4106, 'Lupionopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.203083', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3582, NULL, 3582, 'Lutecia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.62201', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2689, NULL, 2689, 'Luz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.637763', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4460, NULL, 4460, 'Luzerna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.591816', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5452, NULL, 5452, 'Luziania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.689054', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (785, NULL, 785, 'Luzilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.568333', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (381, NULL, 381, 'Luzinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.122538', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3210, NULL, 3210, 'Macae', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.207034', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1150, NULL, 1150, 'Macaiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.973955', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2061, NULL, 2061, 'Macajuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.956202', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4840, NULL, 4840, 'Macambara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.001806', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1785, NULL, 1785, 'Macambira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.661933', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (300, NULL, 300, 'Macapa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.035017', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1567, NULL, 1567, 'Macaparana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.429473', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2062, NULL, 2062, 'Macarani', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.957096', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3583, NULL, 3583, 'Macatuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.622926', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1151, NULL, 1151, 'Macau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.974833', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3584, NULL, 3584, 'Macaubal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.623778', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2063, NULL, 2063, 'Macaubas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.957889', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3585, NULL, 3585, 'Macedonia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.624723', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1695, NULL, 1695, 'Maceio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.563152', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2690, NULL, 2690, 'Machacalis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.638736', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4841, NULL, 4841, 'Machadinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.002707', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (25, NULL, 25, 'Machadinho D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.722776', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2691, NULL, 2691, 'Machado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.639667', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1568, NULL, 1568, 'Machados', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.430395', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4461, NULL, 4461, 'Macieira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.592688', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3211, NULL, 3211, 'Macuco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.207887', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2064, NULL, 2064, 'Macurure', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.958774', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (992, NULL, 992, 'Madalena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.791485', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (786, NULL, 786, 'Madeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.569282', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2065, NULL, 2065, 'Madre de Deus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.959587', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2692, NULL, 2692, 'Madre de Deus de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.640612', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1348, NULL, 1348, 'Mae D''agua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.189872', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (214, NULL, 214, 'Mae do Rio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.940188', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2066, NULL, 2066, 'Maetinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.960638', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4462, NULL, 4462, 'Mafra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.593594', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (215, NULL, 215, 'Magalhaes Barata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.941158', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (557, NULL, 557, 'Magalhaes de Almeida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.316626', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3586, NULL, 3586, 'Magda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.625616', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3212, NULL, 3212, 'Mage', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.208742', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2067, NULL, 2067, 'Maiquinique', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.962121', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2068, NULL, 2068, 'Mairi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.963012', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3587, NULL, 3587, 'Mairinque', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.62654', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3588, NULL, 3588, 'Mairipora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.627638', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5453, NULL, 5453, 'Mairipotaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.689933', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4463, NULL, 4463, 'Major Gercino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.594511', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1696, NULL, 1696, 'Major Isidoro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.564162', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1152, NULL, 1152, 'Major Sales', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.975688', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4464, NULL, 4464, 'Major Vieira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.595378', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2693, NULL, 2693, 'Malacacheta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.641441', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2069, NULL, 2069, 'Malhada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.963901', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2070, NULL, 2070, 'Malhada de Pedras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.964883', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1786, NULL, 1786, 'Malhada dos Bois', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.663166', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1787, NULL, 1787, 'Malhador', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.664217', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4107, NULL, 4107, 'Mallet', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.204071', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1349, NULL, 1349, 'Malta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.190783', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1350, NULL, 1350, 'Mamanguape', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.191714', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5454, NULL, 5454, 'Mambai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.69083', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4108, NULL, 4108, 'Mambore', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.205131', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2694, NULL, 2694, 'Mamonas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.642344', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4842, NULL, 4842, 'Mampituba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.003651', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (109, NULL, 109, 'Manacapuru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.820907', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1351, NULL, 1351, 'Manaira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.192634', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (110, NULL, 110, 'Manaquiri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.821753', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1569, NULL, 1569, 'Manari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.431315', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (111, NULL, 111, 'Manaus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.822972', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (62, NULL, 62, 'Mancio Lima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.764379', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4109, NULL, 4109, 'Mandaguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.206396', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4110, NULL, 4110, 'Mandaguari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.207255', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4111, NULL, 4111, 'Mandirituba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.213506', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3589, NULL, 3589, 'Manduri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.628439', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4112, NULL, 4112, 'Manfrinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.214574', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2695, NULL, 2695, 'Manga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.643242', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3213, NULL, 3213, 'Mangaratiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.209642', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4113, NULL, 4113, 'Mangueirinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.21538', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2696, NULL, 2696, 'Manhuacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.644213', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2697, NULL, 2697, 'Manhumirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.64516', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (112, NULL, 112, 'Manicore', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.823952', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (787, NULL, 787, 'Manoel Emidio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.57028', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4114, NULL, 4114, 'Manoel Ribas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.216194', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (63, NULL, 63, 'Manoel Urbano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.765356', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4843, NULL, 4843, 'Manoel Viana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.004534', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2071, NULL, 2071, 'Manoel Vitorino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.966277', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2072, NULL, 2072, 'Mansidao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.967204', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2698, NULL, 2698, 'Mantena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.646202', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3139, NULL, 3139, 'Mantenopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.127556', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4844, NULL, 4844, 'Maquine', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.005502', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2699, NULL, 2699, 'Mar de Espanha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.647012', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1697, NULL, 1697, 'Mar Vermelho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.56511', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5455, NULL, 5455, 'Mara Rosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.691716', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (113, NULL, 113, 'Maraa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.824889', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (216, NULL, 216, 'Maraba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.942124', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3590, NULL, 3590, 'Maraba Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.629383', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (558, NULL, 558, 'Maracacume', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.317519', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3591, NULL, 3591, 'Maracai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.636541', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4465, NULL, 4465, 'Maracaja', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.59623', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5148, NULL, 5148, 'Maracaju', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.338444', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (217, NULL, 217, 'Maracana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.943021', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (993, NULL, 993, 'Maracanau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.79239', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2073, NULL, 2073, 'Maracas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.968095', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1698, NULL, 1698, 'Maragogi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.566063', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2074, NULL, 2074, 'Maragogipe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.968973', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1570, NULL, 1570, 'Maraial', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.432227', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (559, NULL, 559, 'Maraja do Sena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.318381', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 994, 'Maranguape', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.793456', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (560, NULL, 560, 'Maranhaozinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.319219', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (218, NULL, 218, 'Marapanim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.943981', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3592, NULL, 3592, 'Marapoama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.63785', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4845, NULL, 4845, 'Marata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.006454', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3140, NULL, 3140, 'Marataizes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.128435', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2075, NULL, 2075, 'Marau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.969912', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4846, NULL, 4846, 'Marau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.007402', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4466, NULL, 4466, 'Maravilha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.597301', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1699, NULL, 1699, 'Maravilha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.566937', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2700, NULL, 2700, 'Maravilhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.647968', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1352, NULL, 1352, 'Marcacao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.193573', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5241, NULL, 5241, 'Marcelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.446077', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4847, NULL, 4847, 'Marcelino Ramos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.008247', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1153, NULL, 1153, 'Marcelino Vieira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.976567', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2076, NULL, 2076, 'Marcionilio Souza', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.970761', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (995, NULL, 995, 'Marco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.794381', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (788, NULL, 788, 'Marcolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.571109', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (789, NULL, 789, 'Marcos Parente', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.571924', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4115, NULL, 4115, 'Marechal Candido Rondon', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.217021', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1700, NULL, 1700, 'Marechal Deodoro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.56783', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3141, NULL, 3141, 'Marechal Floriano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.129304', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (64, NULL, 64, 'Marechal Thaumaturgo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.772448', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4467, NULL, 4467, 'Marema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.598234', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1353, NULL, 1353, 'Mari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.194537', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2701, NULL, 2701, 'Maria da Fe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.655614', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4116, NULL, 4116, 'Maria Helena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.217924', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4117, NULL, 4117, 'Marialva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.218808', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2702, NULL, 2702, 'Mariana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.656908', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4848, NULL, 4848, 'Mariana Pimentel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.009044', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4849, NULL, 4849, 'Mariano Moro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.009911', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (382, NULL, 382, 'Marianopolis do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.123445', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3593, NULL, 3593, 'Mariapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.638856', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1701, NULL, 1701, 'Maribondo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.568607', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3214, NULL, 3214, 'Marica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.210561', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2703, NULL, 2703, 'Marilac', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.65784', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3142, NULL, 3142, 'Marilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.130149', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4118, NULL, 4118, 'Marilandia do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.219675', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4119, NULL, 4119, 'Marilena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.221127', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3594, NULL, 3594, 'Marilia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.639554', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4120, NULL, 4120, 'Mariluz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.22202', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4121, NULL, 4121, 'Maringa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.222938', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3595, NULL, 3595, 'Marinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.640522', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2704, NULL, 2704, 'Mario Campos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.658689', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4122, NULL, 4122, 'Mariopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.223854', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4123, NULL, 4123, 'Maripa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.224672', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2705, NULL, 2705, 'Maripa de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.65953', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (219, NULL, 219, 'Marituba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.944811', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1354, NULL, 1354, 'Marizopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.195373', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2706, NULL, 2706, 'Marlieria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.66046', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4124, NULL, 4124, 'Marmeleiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.22564', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2707, NULL, 2707, 'Marmelopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.661483', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4850, NULL, 4850, 'Marques de Souza', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.010831', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4125, NULL, 4125, 'Marquinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.22658', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2708, NULL, 2708, 'Martinho Campos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.662437', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (996, NULL, 996, 'Martinopole', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.801277', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3596, NULL, 3596, 'Martinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.641428', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1154, NULL, 1154, 'Martins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.977442', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2709, NULL, 2709, 'Martins Soares', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.663486', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1788, NULL, 1788, 'Maruim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.665029', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4126, NULL, 4126, 'Marumbi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.227421', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5456, NULL, 5456, 'Marzagao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.692635', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2077, NULL, 2077, 'Mascote', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.971642', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (997, NULL, 997, 'Massape', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.802543', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (790, NULL, 790, 'Massape do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.572792', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1355, NULL, 1355, 'Massaranduba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.196294', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4468, NULL, 4468, 'Massaranduba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.59912', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4851, NULL, 4851, 'Mata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.011716', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2078, NULL, 2078, 'Mata de Sao Joao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.972526', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1702, NULL, 1702, 'Mata Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.569485', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (561, NULL, 561, 'Mata Roma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.320109', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2710, NULL, 2710, 'Mata Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.664361', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3597, NULL, 3597, 'Matao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.642269', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1356, NULL, 1356, 'Mataraca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.197125', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (383, NULL, 383, 'Mateiros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.124297', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4127, NULL, 4127, 'Matelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.228228', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2711, NULL, 2711, 'Materlandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.665305', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2712, NULL, 2712, 'Mateus Leme', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.666284', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2713, NULL, 2713, 'Mathias Lobato', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.667155', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2714, NULL, 2714, 'Matias Barbosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.668037', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2715, NULL, 2715, 'Matias Cardoso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.668913', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (791, NULL, 791, 'Matias Olimpio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.573727', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2079, NULL, 2079, 'Matina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.973388', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (562, NULL, 562, 'Matinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.320966', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1357, NULL, 1357, 'Matinhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.198047', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4128, NULL, 4128, 'Matinhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.229194', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2716, NULL, 2716, 'Matipo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.669963', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4852, NULL, 4852, 'Mato Castelhano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.012915', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1358, NULL, 1358, 'Mato Grosso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.198975', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4853, NULL, 4853, 'Mato Leitao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.013882', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4854, NULL, 4854, 'Mato Queimado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.014734', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4129, NULL, 4129, 'Mato Rico', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.230144', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2717, NULL, 2717, 'Mato Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.670864', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (563, NULL, 563, 'Matoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.321907', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (564, NULL, 564, 'Matoes do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.32282', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4469, NULL, 4469, 'Matos Costa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.600611', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2718, NULL, 2718, 'Matozinhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.671823', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5457, NULL, 5457, 'Matrincha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.693504', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1703, NULL, 1703, 'Matriz de Camaragibe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.570409', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5242, NULL, 5242, 'Matupa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.447134', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1359, NULL, 1359, 'Matureia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.199965', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2719, NULL, 2719, 'Matutina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.672635', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3598, NULL, 3598, 'Maua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.643236', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4130, NULL, 4130, 'Maua da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.231029', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (114, NULL, 114, 'Maues', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.825835', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5458, NULL, 5458, 'Maurilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.694336', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (384, NULL, 384, 'Maurilandia do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.125143', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (998, NULL, 998, 'Mauriti', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.805558', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1155, NULL, 1155, 'Maxaranguape', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.978517', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4855, NULL, 4855, 'Maximiliano de Almeida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.01553', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (301, NULL, 301, 'Mazagao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.036028', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2720, NULL, 2720, 'Medeiros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.673506', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2080, NULL, 2080, 'Medeiros Neto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.974232', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4131, NULL, 4131, 'Medianeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.232254', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (220, NULL, 220, 'Medicilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.945759', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2721, NULL, 2721, 'Medina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.674315', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4470, NULL, 4470, 'Meleiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.601584', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (221, NULL, 221, 'Melgaco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.946559', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3215, NULL, 3215, 'Mendes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.211426', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2722, NULL, 2722, 'Mendes Pimentel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.675195', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3599, NULL, 3599, 'Mendonca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.644256', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4132, NULL, 4132, 'Mercedes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.233069', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2723, NULL, 2723, 'Merces', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.676123', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3600, NULL, 3600, 'Meridiano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.645169', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (999, NULL, 999, 'Meruoca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.806559', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3601, NULL, 3601, 'Mesopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.64605', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3216, NULL, 3216, 'Mesquita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.212248', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2724, NULL, 2724, 'Mesquita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.677029', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1704, NULL, 1704, 'Messias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.57126', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1156, NULL, 1156, 'Messias Targino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.979498', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (792, NULL, 792, 'Miguel Alves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.574699', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2081, NULL, 2081, 'Miguel Calmon', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.975182', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (793, NULL, 793, 'Miguel Leao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.575592', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3217, NULL, 3217, 'Miguel Pereira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.21322', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3602, NULL, 3602, 'Miguelopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.646934', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1000, NULL, 1000, 'Milagres', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.80731', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2082, NULL, 2082, 'Milagres', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.976164', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (565, NULL, 565, 'Milagres do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.32375', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1001, NULL, 1001, 'Milha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.808353', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (794, NULL, 794, 'Milton Brandao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.576731', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5459, NULL, 5459, 'Mimoso de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.695216', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3143, NULL, 3143, 'Mimoso do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.131032', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5460, NULL, 5460, 'Minacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.696172', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1705, NULL, 1705, 'Minador do Negrao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.572177', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4856, NULL, 4856, 'Minas do Leao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.016287', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2725, NULL, 2725, 'Minas Novas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.677866', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2726, NULL, 2726, 'Minduri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.67889', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5461, NULL, 5461, 'Mineiros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.697089', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3603, NULL, 3603, 'Mineiros do Tiete', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.647811', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (26, NULL, 26, 'Ministro Andreazza', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.723813', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3604, NULL, 3604, 'Mira Estrela', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.648659', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2727, NULL, 2727, 'Mirabela', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.680059', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3605, NULL, 3605, 'Miracatu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.649539', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3218, NULL, 3218, 'Miracema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.214025', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (385, NULL, 385, 'Miracema do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.125927', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4133, NULL, 4133, 'Mirador', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.233941', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (566, NULL, 566, 'Mirador', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.324883', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2728, NULL, 2728, 'Miradouro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.681017', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4857, NULL, 4857, 'Miraguai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.017159', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2729, NULL, 2729, 'Mirai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.681974', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1002, NULL, 1002, 'Miraima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.809236', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5149, NULL, 5149, 'Miranda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.33931', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (567, NULL, 567, 'Miranda do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.325801', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1571, NULL, 1571, 'Mirandiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.433144', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3606, NULL, 3606, 'Mirandopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.650507', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2083, NULL, 2083, 'Mirangaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.977016', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (386, NULL, 386, 'Miranorte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.126827', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2084, NULL, 2084, 'Mirante', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.977772', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (27, NULL, 27, 'Mirante da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.725075', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3607, NULL, 3607, 'Mirante do Paranapanema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.651428', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4134, NULL, 4134, 'Miraselva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.234818', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3608, NULL, 3608, 'Mirassol', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.652283', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5243, NULL, 5243, 'Mirassol D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.448029', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3609, NULL, 3609, 'Mirassolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.653107', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2730, NULL, 2730, 'Miravania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.682921', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4471, NULL, 4471, 'Mirim Doce', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.602525', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (568, NULL, 568, 'Mirinzal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.326849', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4135, NULL, 4135, 'Missal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.23558', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1003, NULL, 1003, 'Missao Velha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.810299', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (222, NULL, 222, 'Mocajuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.947482', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3610, NULL, 3610, 'Mococa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.65403', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4472, NULL, 4472, 'Modelo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.603369', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2731, NULL, 2731, 'Moeda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.683889', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2732, NULL, 2732, 'Moema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.684839', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1360, NULL, 1360, 'Mogeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.200795', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3611, NULL, 3611, 'Mogi das Cruzes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.654934', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3612, NULL, 3612, 'Mogi Guacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.655912', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5462, NULL, 5462, 'Moipora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.698025', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1789, NULL, 1789, 'Moita Bonita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.665899', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (223, NULL, 223, 'Moju', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.948244', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1004, NULL, 1004, 'Mombaca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.811154', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3614, NULL, 3614, 'Mombuca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.65768', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (569, NULL, 569, 'Moncao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.327637', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3615, NULL, 3615, 'Moncoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.658653', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4473, NULL, 4473, 'Mondai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.604263', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3616, NULL, 3616, 'Mongagua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.6595', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2733, NULL, 2733, 'Monjolos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.685732', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (795, NULL, 795, 'Monsenhor Gil', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.577659', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (796, NULL, 796, 'Monsenhor Hipolito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.578489', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2734, NULL, 2734, 'Monsenhor Paulo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.686645', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1005, NULL, 1005, 'Monsenhor Tabosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.81203', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1361, NULL, 1361, 'Montadas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.201784', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2735, NULL, 2735, 'Montalvania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.687406', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3144, NULL, 3144, 'Montanha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.131767', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1157, NULL, 1157, 'Montanhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.980416', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4858, NULL, 4858, 'Montauri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.018117', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (224, NULL, 224, 'Monte Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.949614', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1158, NULL, 1158, 'Monte Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.981295', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5463, NULL, 5463, 'Monte Alegre de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.69892', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2736, NULL, 2736, 'Monte Alegre de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.688289', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1790, NULL, 1790, 'Monte Alegre de Sergipe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.666702', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (797, NULL, 797, 'Monte Alegre do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.579329', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3617, NULL, 3617, 'Monte Alegre do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.66052', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4859, NULL, 4859, 'Monte Alegre dos Campos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.018991', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3618, NULL, 3618, 'Monte Alto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.661636', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3619, NULL, 3619, 'Monte Aprazivel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.662504', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2737, NULL, 2737, 'Monte Azul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.689257', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3620, NULL, 3620, 'Monte Azul Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.663455', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2738, NULL, 2738, 'Monte Belo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.696044', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4860, NULL, 4860, 'Monte Belo do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.019902', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4474, NULL, 4474, 'Monte Carlo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.605228', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2739, NULL, 2739, 'Monte Carmelo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.697125', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4475, NULL, 4475, 'Monte Castelo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.606147', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3621, NULL, 3621, 'Monte Castelo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.664378', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1159, NULL, 1159, 'Monte das Gameleiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.982178', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (387, NULL, 387, 'Monte do Carmo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.127756', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2740, NULL, 2740, 'Monte Formoso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.698007', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1362, NULL, 1362, 'Monte Horebe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.209441', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3622, NULL, 3622, 'Monte Mor', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.665291', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (28, NULL, 28, 'Monte Negro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.731957', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2085, NULL, 2085, 'Monte Santo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.978653', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2741, NULL, 2741, 'Monte Santo de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.699102', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (388, NULL, 388, 'Monte Santo do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.128688', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2742, NULL, 2742, 'Monte Siao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.699867', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1363, NULL, 1363, 'Monteiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.210611', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3623, NULL, 3623, 'Monteiro Lobato', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.66621', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1706, NULL, 1706, 'Monteiropolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.573135', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4861, NULL, 4861, 'Montenegro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.020835', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (570, NULL, 570, 'Montes Altos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.328569', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2743, NULL, 2743, 'Montes Claros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.700683', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5464, NULL, 5464, 'Montes Claros de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.699882', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2744, NULL, 2744, 'Montezuma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.701663', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5465, NULL, 5465, 'Montividiu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.700799', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5466, NULL, 5466, 'Montividiu do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.701715', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1006, NULL, 1006, 'Morada Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.812903', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2745, NULL, 2745, 'Morada Nova de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.702366', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1007, NULL, 1007, 'Moraujo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.81377', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1572, NULL, 1572, 'Moreilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.434075', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4136, NULL, 4136, 'Moreira Sales', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.236433', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1573, NULL, 1573, 'Moreno', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.434923', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4862, NULL, 4862, 'Mormaco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.02173', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2086, NULL, 2086, 'Morpara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.979569', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4137, NULL, 4137, 'Morretes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.237286', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5467, NULL, 5467, 'Morrinhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.702638', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1008, NULL, 1008, 'Morrinhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.814722', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4863, NULL, 4863, 'Morrinhos do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.028527', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3624, NULL, 3624, 'Morro Agudo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.667129', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5468, NULL, 5468, 'Morro Agudo de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.703663', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (798, NULL, 798, 'Morro Cabeca No Tempo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.580308', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4476, NULL, 4476, 'Morro da Fumaca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.607036', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2746, NULL, 2746, 'Morro da Garca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.703301', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2087, NULL, 2087, 'Morro do Chapeu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.980474', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (799, NULL, 799, 'Morro do Chapeu do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.581572', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2747, NULL, 2747, 'Morro do Pilar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.70427', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4477, NULL, 4477, 'Morro Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.607994', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4864, NULL, 4864, 'Morro Redondo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.02965', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4865, NULL, 4865, 'Morro Reuter', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.030692', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (571, NULL, 571, 'Morros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.329367', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2088, NULL, 2088, 'Mortugaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.981328', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3625, NULL, 3625, 'Morungaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.6681', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5469, NULL, 5469, 'Mossamedes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.704418', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1160, NULL, 1160, 'Mossoro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.983168', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4866, NULL, 4866, 'Mostardas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.032073', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3626, NULL, 3626, 'Motuca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.669012', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5470, NULL, 5470, 'Mozarlandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.705276', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (225, NULL, 225, 'Muana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.950555', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (144, NULL, 144, 'Mucajai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.860859', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1009, NULL, 1009, 'Mucambo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.815781', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2089, NULL, 2089, 'Mucuge', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.982184', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4867, NULL, 4867, 'Mucum', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.033021', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2090, NULL, 2090, 'Mucuri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.982993', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3145, NULL, 3145, 'Mucurici', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.132669', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4868, NULL, 4868, 'Muitos Capoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.033894', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4869, NULL, 4869, 'Muliterno', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.03487', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1364, NULL, 1364, 'Mulungu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.21166', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1010, NULL, 1010, 'Mulungu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.816724', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2091, NULL, 2091, 'Mulungu do Morro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.983851', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5471, NULL, 5471, 'Mundo Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.706025', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2092, NULL, 2092, 'Mundo Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.984848', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5150, NULL, 5150, 'Mundo Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.340178', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2748, NULL, 2748, 'Munhoz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.705223', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4138, NULL, 4138, 'Munhoz de Melo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.238297', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2093, NULL, 2093, 'Muniz Ferreira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.996997', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3146, NULL, 3146, 'Muniz Freire', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.133579', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2094, NULL, 2094, 'Muquem de Sao Francisco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.998112', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3147, NULL, 3147, 'Muqui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.13436', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2749, NULL, 2749, 'Muriae', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.706065', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1791, NULL, 1791, 'Muribeca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.667607', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1707, NULL, 1707, 'Murici', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.579953', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (800, NULL, 800, 'Murici dos Portelas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.582369', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (389, NULL, 389, 'Muricilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.129605', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2095, NULL, 2095, 'Muritiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.999036', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3627, NULL, 3627, 'Murutinga do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.669991', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2096, NULL, 2096, 'Mutuipe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.999876', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2750, NULL, 2750, 'Mutum', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.706975', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5472, NULL, 5472, 'Mutunopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.706843', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2751, NULL, 2751, 'Muzambinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.707858', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2752, NULL, 2752, 'Nacip Raydan', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.70873', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3628, NULL, 3628, 'Nantes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.677087', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2753, NULL, 2753, 'Nanuque', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.709584', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4870, NULL, 4870, 'Nao-me-toque', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.035708', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2754, NULL, 2754, 'Naque', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.710678', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3629, NULL, 3629, 'Narandiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.678371', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1161, NULL, 1161, 'Natal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.98404', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2755, NULL, 2755, 'Natalandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.711561', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2756, NULL, 2756, 'Natercia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.712473', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (390, NULL, 390, 'Natividade', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.13038', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3219, NULL, 3219, 'Natividade', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.214987', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3630, NULL, 3630, 'Natividade da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.6794', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1365, NULL, 1365, 'Natuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.212408', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4478, NULL, 4478, 'Navegantes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.608914', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5151, NULL, 5151, 'Navirai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.341075', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2097, NULL, 2097, 'Nazare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.000716', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (391, NULL, 391, 'Nazare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.131401', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1574, NULL, 1574, 'Nazare da Mata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.435804', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (801, NULL, 801, 'Nazare do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.583261', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3631, NULL, 3631, 'Nazare Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.680367', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2757, NULL, 2757, 'Nazareno', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.71354', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1366, NULL, 1366, 'Nazarezinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.213326', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (802, NULL, 802, 'Nazária', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.584181', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5473, NULL, 5473, 'Nazario', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.707701', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1792, NULL, 1792, 'Neopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.668505', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2758, NULL, 2758, 'Nepomuceno', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.714525', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5474, NULL, 5474, 'Neropolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.708646', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3632, NULL, 3632, 'Neves Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.681221', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (115, NULL, 115, 'Nhamunda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.826766', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3633, NULL, 3633, 'Nhandeara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.682247', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4871, NULL, 4871, 'Nicolau Vergueiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.036634', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2098, NULL, 2098, 'Nilo Pecanha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.001605', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3220, NULL, 3220, 'Nilopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.215631', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (572, NULL, 572, 'Nina Rodrigues', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.330692', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2759, NULL, 2759, 'Ninheira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.715406', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5152, NULL, 5152, 'Nioaque', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.341888', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3634, NULL, 3634, 'Nipoa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.683209', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5475, NULL, 5475, 'Niquelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.709625', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1162, NULL, 1162, 'Nisia Floresta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.984957', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3221, NULL, 3221, 'Niteroi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.216575', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5244, NULL, 5244, 'Nobres', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.448969', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4872, NULL, 4872, 'Nonoai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.037482', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2099, NULL, 2099, 'Nordestina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.002445', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (145, NULL, 145, 'Normandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.861807', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5245, NULL, 5245, 'Nortelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.449889', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1793, NULL, 1793, 'Nossa Senhora Aparecida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.66942', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1794, NULL, 1794, 'Nossa Senhora da Gloria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.670251', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1795, NULL, 1795, 'Nossa Senhora das Dores', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.671045', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4139, NULL, 4139, 'Nossa Senhora das Gracas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.239216', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1796, NULL, 1796, 'Nossa Senhora de Lourdes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.671969', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (803, NULL, 803, 'Nossa Senhora de Nazare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.585035', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5246, NULL, 5246, 'Nossa Senhora do Livramento', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.450756', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1797, NULL, 1797, 'Nossa Senhora do Socorro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.672835', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (804, NULL, 804, 'Nossa Senhora dos Remedios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.585913', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3635, NULL, 3635, 'Nova Alianca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.684071', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4140, NULL, 4140, 'Nova Alianca do Ivai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.240118', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4873, NULL, 4873, 'Nova Alvorada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.038493', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5153, NULL, 5153, 'Nova Alvorada do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.342697', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5476, NULL, 5476, 'Nova America', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.710551', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4141, NULL, 4141, 'Nova America da Colina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.240981', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5154, NULL, 5154, 'Nova Andradina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.343615', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4874, NULL, 4874, 'Nova Araca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.039364', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5477, NULL, 5477, 'Nova Aurora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.711502', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4142, NULL, 4142, 'Nova Aurora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.24191', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5247, NULL, 5247, 'Nova Bandeirantes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.451561', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4875, NULL, 4875, 'Nova Bassano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.040191', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2760, NULL, 2760, 'Nova Belem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.716339', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4876, NULL, 4876, 'Nova Boa Vista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.041367', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5248, NULL, 5248, 'Nova Brasilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.452363', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (29, NULL, 29, 'Nova Brasilandia D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.73323', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4877, NULL, 4877, 'Nova Brescia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.042406', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3636, NULL, 3636, 'Nova Campina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.685019', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2100, NULL, 2100, 'Nova Canaa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.003325', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5249, NULL, 5249, 'Nova Canaa do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.453308', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3637, NULL, 3637, 'Nova Canaa Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.685923', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4878, NULL, 4878, 'Nova Candelaria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.043243', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4143, NULL, 4143, 'Nova Cantu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.242841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3638, NULL, 3638, 'Nova Castilho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.68688', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (573, NULL, 573, 'Nova Colinas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.332095', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5478, NULL, 5478, 'Nova Crixas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.712452', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1163, NULL, 1163, 'Nova Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.98583', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2761, NULL, 2761, 'Nova Era', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.71725', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4479, NULL, 4479, 'Nova Erechim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.60984', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4144, NULL, 4144, 'Nova Esperanca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.243604', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (226, NULL, 226, 'Nova Esperanca do Piria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.9514', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4145, NULL, 4145, 'Nova Esperanca do Sudoeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.244503', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4879, NULL, 4879, 'Nova Esperanca do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.044148', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3639, NULL, 3639, 'Nova Europa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.687744', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2101, NULL, 2101, 'Nova Fatima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.004235', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4146, NULL, 4146, 'Nova Fatima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.24551', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1367, NULL, 1367, 'Nova Floresta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.214238', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3222, NULL, 3222, 'Nova Friburgo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.217505', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5479, NULL, 5479, 'Nova Gloria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.713407', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3640, NULL, 3640, 'Nova Granada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.688615', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5250, NULL, 5250, 'Nova Guarita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.45418', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3641, NULL, 3641, 'Nova Guataporanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.689453', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4880, NULL, 4880, 'Nova Hartz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.044942', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2102, NULL, 2102, 'Nova Ibia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.005107', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3223, NULL, 3223, 'Nova Iguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.218374', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5480, NULL, 5480, 'Nova Iguacu de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.714282', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3642, NULL, 3642, 'Nova Independencia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.69033', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (574, NULL, 574, 'Nova Iorque', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.333022', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (227, NULL, 227, 'Nova Ipixuna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.952304', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4480, NULL, 4480, 'Nova Itaberaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.610808', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2103, NULL, 2103, 'Nova Itarana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.006013', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5251, NULL, 5251, 'Nova Lacerda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.455047', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4147, NULL, 4147, 'Nova Laranjeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.246408', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2762, NULL, 2762, 'Nova Lima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.718111', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4148, NULL, 4148, 'Nova Londrina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.247175', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3643, NULL, 3643, 'Nova Luzitania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.69125', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (30, NULL, 30, 'Nova Mamore', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.734184', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5252, NULL, 5252, 'Nova Marilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.455908', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5253, NULL, 5253, 'Nova Maringa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.456789', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2763, NULL, 2763, 'Nova Modica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.719056', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5254, NULL, 5254, 'Nova Monte Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.457859', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5255, NULL, 5255, 'Nova Mutum', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.458788', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5256, NULL, 5256, 'Nova Nazare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.459757', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3644, NULL, 3644, 'Nova Odessa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.692148', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5257, NULL, 5257, 'Nova Olimpia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.460794', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4149, NULL, 4149, 'Nova Olimpia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.254111', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1368, NULL, 1368, 'Nova Olinda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.215124', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1011, NULL, 1011, 'Nova Olinda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.817636', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (392, NULL, 392, 'Nova Olinda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.132322', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (575, NULL, 575, 'Nova Olinda do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.333932', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (116, NULL, 116, 'Nova Olinda do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.827685', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4881, NULL, 4881, 'Nova Padua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.045858', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4882, NULL, 4882, 'Nova Palma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.04664', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1369, NULL, 1369, 'Nova Palmeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.215985', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4883, NULL, 4883, 'Nova Petropolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.047523', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2764, NULL, 2764, 'Nova Ponte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.720149', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2765, NULL, 2765, 'Nova Porteirinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.721149', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4884, NULL, 4884, 'Nova Prata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.04839', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4150, NULL, 4150, 'Nova Prata do Iguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.255272', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4885, NULL, 4885, 'Nova Ramada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.049254', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2104, NULL, 2104, 'Nova Redencao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.006882', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2766, NULL, 2766, 'Nova Resende', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.722075', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5481, NULL, 5481, 'Nova Roma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.715252', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4886, NULL, 4886, 'Nova Roma do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.050199', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (393, NULL, 393, 'Nova Rosalandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.133154', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1012, NULL, 1012, 'Nova Russas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.81856', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4151, NULL, 4151, 'Nova Santa Barbara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.256208', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5258, NULL, 5258, 'Nova Santa Helena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.461782', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4887, NULL, 4887, 'Nova Santa Rita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.051107', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (805, NULL, 805, 'Nova Santa Rita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.58681', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4152, NULL, 4152, 'Nova Santa Rosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.257126', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2767, NULL, 2767, 'Nova Serrana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.7229', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2105, NULL, 2105, 'Nova Soure', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.007768', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4153, NULL, 4153, 'Nova Tebas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.258244', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (228, NULL, 228, 'Nova Timboteua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.953216', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4481, NULL, 4481, 'Nova Trento', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.611579', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5259, NULL, 5259, 'Nova Ubirata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.462711', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (31, NULL, 31, 'Nova Uniao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.735123', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2768, NULL, 2768, 'Nova Uniao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.723765', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3148, NULL, 3148, 'Nova Venecia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.135185', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4482, NULL, 4482, 'Nova Veneza', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.612402', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5482, NULL, 5482, 'Nova Veneza', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.716088', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2106, NULL, 2106, 'Nova Vicosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.008715', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5260, NULL, 5260, 'Nova Xavantina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.463694', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3645, NULL, 3645, 'Novais', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.693025', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (394, NULL, 394, 'Novo Acordo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.134133', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (117, NULL, 117, 'Novo Airao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.828719', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (395, NULL, 395, 'Novo Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.135242', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (118, NULL, 118, 'Novo Aripuana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.829683', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4888, NULL, 4888, 'Novo Barreiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.052035', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5483, NULL, 5483, 'Novo Brasil', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.717048', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4889, NULL, 4889, 'Novo Cabrais', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.052834', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2769, NULL, 2769, 'Novo Cruzeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.724744', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5484, NULL, 5484, 'Novo Gama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.71804', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4890, NULL, 4890, 'Novo Hamburgo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.053668', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2107, NULL, 2107, 'Novo Horizonte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.009609', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3646, NULL, 3646, 'Novo Horizonte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.693881', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4483, NULL, 4483, 'Novo Horizonte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.61326', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5261, NULL, 5261, 'Novo Horizonte do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.464598', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (32, NULL, 32, 'Novo Horizonte do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.73613', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5155, NULL, 5155, 'Novo Horizonte do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.344527', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4154, NULL, 4154, 'Novo Itacolomi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.259008', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (396, NULL, 396, 'Novo Jardim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.13607', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1708, NULL, 1708, 'Novo Lino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.58127', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4891, NULL, 4891, 'Novo Machado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.054539', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5262, NULL, 5262, 'Novo Mundo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.465458', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1013, NULL, 1013, 'Novo Oriente', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.819509', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2770, NULL, 2770, 'Novo Oriente de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.725723', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (806, NULL, 806, 'Novo Oriente do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.587703', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5485, NULL, 5485, 'Novo Planalto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.718969', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (229, NULL, 229, 'Novo Progresso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.954085', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (230, NULL, 230, 'Novo Repartimento', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.955006', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (807, NULL, 807, 'Novo Santo Antonio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.588561', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5263, NULL, 5263, 'Novo Santo Antonio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.466329', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5264, NULL, 5264, 'Novo Sao Joaquim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.467249', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4892, NULL, 4892, 'Novo Tiradentes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.055463', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2108, NULL, 2108, 'Novo Triunfo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.01077', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4893, NULL, 4893, 'Novo Xingu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.056358', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2771, NULL, 2771, 'Novorizonte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.726657', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3647, NULL, 3647, 'Nuporanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.694756', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (231, NULL, 231, 'Obidos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.95593', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1014, NULL, 1014, 'Ocara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.820449', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3648, NULL, 3648, 'Ocaucu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.695695', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (808, NULL, 808, 'Oeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.58949', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (232, NULL, 232, 'Oeiras do Para', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.956865', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (302, NULL, 302, 'Oiapoque', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.036905', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2772, NULL, 2772, 'Olaria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.727589', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3649, NULL, 3649, 'Oleo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.696598', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1370, NULL, 1370, 'Olho D''agua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.216966', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (576, NULL, 576, 'Olho D''agua das Cunhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.334867', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1709, NULL, 1709, 'Olho D''agua das Flores', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.582212', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1710, NULL, 1710, 'Olho D''agua do Casado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.583111', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1711, NULL, 1711, 'Olho D''agua Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.583997', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1164, NULL, 1164, 'Olho-d''agua do Borges', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.986796', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3650, NULL, 3650, 'Olimpia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.697503', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2774, NULL, 2774, 'Olimpio Noronha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.729493', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1575, NULL, 1575, 'Olinda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.436674', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (577, NULL, 577, 'Olinda Nova do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.335779', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2109, NULL, 2109, 'Olindina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.011563', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1371, NULL, 1371, 'Olivedos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.217879', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2775, NULL, 2775, 'Oliveira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.740384', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (397, NULL, 397, 'Oliveira de Fatima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.143376', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2110, NULL, 2110, 'Oliveira dos Brejinhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.012481', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2776, NULL, 2776, 'Oliveira Fortes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.74145', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1712, NULL, 1712, 'Olivenca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.584857', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2777, NULL, 2777, 'Onca de Pitangui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.742313', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3651, NULL, 3651, 'Onda Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.698381', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2778, NULL, 2778, 'Oratorios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.7431', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3652, NULL, 3652, 'Oriente', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.699328', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3653, NULL, 3653, 'Orindiuva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.700226', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (233, NULL, 233, 'Oriximina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.957786', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2779, NULL, 2779, 'Orizania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.743935', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5486, NULL, 5486, 'Orizona', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.71987', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3654, NULL, 3654, 'Orlandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.70113', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4484, NULL, 4484, 'Orleans', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.614203', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1576, NULL, 1576, 'Orobo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.437566', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1577, NULL, 1577, 'Oroco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.438497', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1015, NULL, 1015, 'Oros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.821307', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4155, NULL, 4155, 'Ortigueira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.259923', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3655, NULL, 3655, 'Osasco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.702113', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3656, NULL, 3656, 'Oscar Bressane', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.703017', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4894, NULL, 4894, 'Osorio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.057633', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3657, NULL, 3657, 'Osvaldo Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.703902', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4485, NULL, 4485, 'Otacilio Costa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.615091', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (234, NULL, 234, 'Ourem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.958709', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2111, NULL, 2111, 'Ouricangas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.013345', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1578, NULL, 1578, 'Ouricuri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.439384', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (235, NULL, 235, 'Ourilandia do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.959504', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3658, NULL, 3658, 'Ourinhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.704848', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4156, NULL, 4156, 'Ourizona', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.260801', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4486, NULL, 4486, 'Ouro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.615915', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1165, NULL, 1165, 'Ouro Branco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.987717', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2780, NULL, 2780, 'Ouro Branco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.744933', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1713, NULL, 1713, 'Ouro Branco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.585722', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2781, NULL, 2781, 'Ouro Fino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.745729', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2782, NULL, 2782, 'Ouro Preto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.746597', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (33, NULL, 33, 'Ouro Preto do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.737108', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1372, NULL, 1372, 'Ouro Velho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.218822', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4487, NULL, 4487, 'Ouro Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.622292', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3659, NULL, 3659, 'Ouro Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.705842', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5487, NULL, 5487, 'Ouro Verde de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.720782', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2783, NULL, 2783, 'Ouro Verde de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.747426', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4157, NULL, 4157, 'Ouro Verde do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.261512', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3660, NULL, 3660, 'Ouroeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.706649', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2112, NULL, 2112, 'Ourolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.014162', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5488, NULL, 5488, 'Ouvidor', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.721647', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3661, NULL, 3661, 'Pacaembu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.707503', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (236, NULL, 236, 'Pacaja', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.960374', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1016, NULL, 1016, 'Pacajus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.822177', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (146, NULL, 146, 'Pacaraima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.862761', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1798, NULL, 1798, 'Pacatuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.673744', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1017, NULL, 1017, 'Pacatuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.823119', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (578, NULL, 578, 'Paco do Lumiar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.33655', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1018, NULL, 1018, 'Pacoti', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.823944', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1019, NULL, 1019, 'Pacuja', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.824879', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5489, NULL, 5489, 'Padre Bernardo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.730377', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2784, NULL, 2784, 'Padre Carvalho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.748246', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (810, NULL, 810, 'Padre Marcos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.591217', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2785, NULL, 2785, 'Padre Paraiso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.749321', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (811, NULL, 811, 'Paes Landim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.592557', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2786, NULL, 2786, 'Pai Pedro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.750259', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4488, NULL, 4488, 'Paial', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.624172', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4158, NULL, 4158, 'Paicandu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.262398', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4895, NULL, 4895, 'Paim Filho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.058522', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2787, NULL, 2787, 'Paineiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.75118', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4489, NULL, 4489, 'Painel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.625092', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2788, NULL, 2788, 'Pains', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.752016', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2789, NULL, 2789, 'Paiva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.753119', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (812, NULL, 812, 'Pajeu do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.598809', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3662, NULL, 3662, 'Palestina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.708316', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1714, NULL, 1714, 'Palestina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.58684', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5490, NULL, 5490, 'Palestina de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.731494', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (237, NULL, 237, 'Palestina do Para', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.96127', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1020, NULL, 1020, 'Palhano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.825848', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4490, NULL, 4490, 'Palhoca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.625997', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2790, NULL, 2790, 'Palma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.754061', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4491, NULL, 4491, 'Palma Sola', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.626836', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1021, NULL, 1021, 'Palmacia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.826961', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1579, NULL, 1579, 'Palmares', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.44018', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4896, NULL, 4896, 'Palmares do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.0594', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3663, NULL, 3663, 'Palmares Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.7091', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4159, NULL, 4159, 'Palmas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.263241', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (398, NULL, 398, 'Palmas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.144446', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2113, NULL, 2113, 'Palmas de Monte Alto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.015029', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4160, NULL, 4160, 'Palmeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.264126', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4492, NULL, 4492, 'Palmeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.627753', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3664, NULL, 3664, 'Palmeira D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.709909', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4897, NULL, 4897, 'Palmeira das Missoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.06019', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (813, NULL, 813, 'Palmeira do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.599731', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1715, NULL, 1715, 'Palmeira dos Indios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.587745', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (814, NULL, 814, 'Palmeirais', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.600651', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (579, NULL, 579, 'Palmeirandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.337518', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (399, NULL, 399, 'Palmeirante', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.145386', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2114, NULL, 2114, 'Palmeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.015951', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5491, NULL, 5491, 'Palmeiras de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.732416', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (400, NULL, 400, 'Palmeiras do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.146676', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1580, NULL, 1580, 'Palmeirina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.441107', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (401, NULL, 401, 'Palmeiropolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.14756', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5492, NULL, 5492, 'Palmelo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.733286', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5493, NULL, 5493, 'Palminopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.734292', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3665, NULL, 3665, 'Palmital', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.710909', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4161, NULL, 4161, 'Palmital', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.264963', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4898, NULL, 4898, 'Palmitinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.061164', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4493, NULL, 4493, 'Palmitos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.628577', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2791, NULL, 2791, 'Palmopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.755117', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4162, NULL, 4162, 'Palotina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.265805', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5494, NULL, 5494, 'Panama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.735177', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4899, NULL, 4899, 'Panambi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.062045', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3149, NULL, 3149, 'Pancas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.136062', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1581, NULL, 1581, 'Panelas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.442238', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3666, NULL, 3666, 'Panorama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.71165', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4900, NULL, 4900, 'Pantano Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.062725', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1716, NULL, 1716, 'Pao de Acucar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.58866', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2792, NULL, 2792, 'Papagaios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.75607', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4494, NULL, 4494, 'Papanduva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.629483', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (815, NULL, 815, 'Paqueta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.601586', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2793, NULL, 2793, 'Para de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.756968', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3224, NULL, 3224, 'Paracambi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.219241', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2794, NULL, 2794, 'Paracatu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.757955', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1022, NULL, 1022, 'Paracuru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.827911', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (238, NULL, 238, 'Paragominas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.962164', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2795, NULL, 2795, 'Paraguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.758826', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3667, NULL, 3667, 'Paraguacu Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.7191', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4901, NULL, 4901, 'Parai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.069617', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3225, NULL, 3225, 'Paraiba do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.22011', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (580, NULL, 580, 'Paraibano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.338445', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3668, NULL, 3668, 'Paraibuna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.720228', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1023, NULL, 1023, 'Paraipaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.828797', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4495, NULL, 4495, 'Paraiso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.630489', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3669, NULL, 3669, 'Paraiso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.721111', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4163, NULL, 4163, 'Paraiso do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.266633', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4902, NULL, 4902, 'Paraiso do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.07061', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (402, NULL, 402, 'Paraiso do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.148448', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2796, NULL, 2796, 'Paraisopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.759698', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1024, NULL, 1024, 'Parambu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.829733', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2115, NULL, 2115, 'Paramirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.016875', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1025, NULL, 1025, 'Paramoti', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.830639', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (403, NULL, 403, 'Parana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.149167', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1166, NULL, 1166, 'Parana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.988598', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4164, NULL, 4164, 'Paranacity', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.267515', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4165, NULL, 4165, 'Paranagua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.268404', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5156, NULL, 5156, 'Paranaiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.345447', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5495, NULL, 5495, 'Paranaiguara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.736027', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5265, NULL, 5265, 'Paranaita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.468084', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3670, NULL, 3670, 'Paranapanema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.722043', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4166, NULL, 4166, 'Paranapoema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.269214', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3671, NULL, 3671, 'Paranapua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.72293', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1582, NULL, 1582, 'Paranatama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.443039', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5266, NULL, 5266, 'Paranatinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.469197', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4167, NULL, 4167, 'Paranavai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.270026', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5157, NULL, 5157, 'Paranhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.346394', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2797, NULL, 2797, 'Paraopeba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.76053', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3672, NULL, 3672, 'Parapua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.723768', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1373, NULL, 1373, 'Parari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.219627', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2116, NULL, 2116, 'Paratinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.017719', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1167, NULL, 1167, 'Parau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.989498', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (239, NULL, 239, 'Parauapebas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.963118', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5496, NULL, 5496, 'Parauna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.736912', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1168, NULL, 1168, 'Parazinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.990437', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3673, NULL, 3673, 'Pardinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.72461', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4903, NULL, 4903, 'Pareci Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.07147', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (34, NULL, 34, 'Parecis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.738213', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1169, NULL, 1169, 'Parelhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.99129', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1717, NULL, 1717, 'Pariconha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.589445', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (119, NULL, 119, 'Parintins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.830562', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2117, NULL, 2117, 'Paripiranga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.018511', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1718, NULL, 1718, 'Paripueira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.590225', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3674, NULL, 3674, 'Pariquera-acu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.725544', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3675, NULL, 3675, 'Parisi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.726416', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (816, NULL, 816, 'Parnagua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.603105', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (817, NULL, 817, 'Parnaiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.603974', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1170, NULL, 1170, 'Parnamirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.992169', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1583, NULL, 1583, 'Parnamirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.44394', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (581, NULL, 581, 'Parnarama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.340223', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4904, NULL, 4904, 'Parobe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.072404', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1171, NULL, 1171, 'Passa e Fica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.99297', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2798, NULL, 2798, 'Passa Quatro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.761404', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4905, NULL, 4905, 'Passa Sete', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.073291', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2799, NULL, 2799, 'Passa Tempo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.762299', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2801, NULL, 2801, 'Passabem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.764189', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1374, NULL, 1374, 'Passagem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.220662', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1172, NULL, 1172, 'Passagem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.994099', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (582, NULL, 582, 'Passagem Franca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.341359', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (818, NULL, 818, 'Passagem Franca do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.604851', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1584, NULL, 1584, 'Passira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.444874', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1719, NULL, 1719, 'Passo de Camaragibe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.59101', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4496, NULL, 4496, 'Passo de Torres', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.631393', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4906, NULL, 4906, 'Passo do Sobrado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.074185', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4907, NULL, 4907, 'Passo Fundo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.075119', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2802, NULL, 2802, 'Passos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.765124', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4497, NULL, 4497, 'Passos Maia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.632217', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (583, NULL, 583, 'Pastos Bons', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.342182', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2803, NULL, 2803, 'Patis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.766075', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4168, NULL, 4168, 'Pato Bragado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.27079', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4169, NULL, 4169, 'Pato Branco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.271724', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1375, NULL, 1375, 'Patos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.22147', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2804, NULL, 2804, 'Patos de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.766987', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (819, NULL, 819, 'Patos do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.605756', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2805, NULL, 2805, 'Patrocinio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.767808', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2806, NULL, 2806, 'Patrocinio do Muriae', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.768792', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3676, NULL, 3676, 'Patrocinio Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.727324', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1173, NULL, 1173, 'Patu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.994899', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3227, NULL, 3227, 'Paty do Alferes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.227898', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2118, NULL, 2118, 'Pau Brasil', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.019288', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (240, NULL, 240, 'Pau D''arco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.963912', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (404, NULL, 404, 'Pau D''arco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.150069', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (820, NULL, 820, 'Pau D''arco do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.606727', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1174, NULL, 1174, 'Pau dos Ferros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.995778', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1585, NULL, 1585, 'Paudalho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.445746', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (120, NULL, 120, 'Pauini', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.83138', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2807, NULL, 2807, 'Paula Candido', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.769602', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4170, NULL, 4170, 'Paula Freitas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.272627', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3677, NULL, 3677, 'Pauliceia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.728179', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3678, NULL, 3678, 'Paulinia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.729059', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (584, NULL, 584, 'Paulino Neves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.352812', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1586, NULL, 1586, 'Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.446509', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1376, NULL, 1376, 'Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.222548', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (821, NULL, 821, 'Paulistana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.607612', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3679, NULL, 3679, 'Paulistania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.730037', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2808, NULL, 2808, 'Paulistas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.770548', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2119, NULL, 2119, 'Paulo Afonso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.020202', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4908, NULL, 4908, 'Paulo Bento', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.076016', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3680, NULL, 3680, 'Paulo de Faria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.730894', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4171, NULL, 4171, 'Paulo Frontin', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.273639', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1720, NULL, 1720, 'Paulo Jacinto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.591854', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4498, NULL, 4498, 'Paulo Lopes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.633094', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (585, NULL, 585, 'Paulo Ramos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.353828', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2809, NULL, 2809, 'Pavao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.771502', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4909, NULL, 4909, 'Paverama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.076943', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (822, NULL, 822, 'Pavussu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.608647', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2120, NULL, 2120, 'Pe de Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.021133', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4172, NULL, 4172, 'Peabiru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.274646', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2810, NULL, 2810, 'Pecanha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.772442', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3681, NULL, 3681, 'Pederneiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.731757', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1587, NULL, 1587, 'Pedra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.447374', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2811, NULL, 2811, 'Pedra Azul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.773367', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3682, NULL, 3682, 'Pedra Bela', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.732587', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2812, NULL, 2812, 'Pedra Bonita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.774198', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1026, NULL, 1026, 'Pedra Branca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.831545', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1377, NULL, 1377, 'Pedra Branca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.223486', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (303, NULL, 303, 'Pedra Branca do Amapari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.037751', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2813, NULL, 2813, 'Pedra do Anta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.781051', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2814, NULL, 2814, 'Pedra do Indaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.782165', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2815, NULL, 2815, 'Pedra Dourada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.783151', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1175, NULL, 1175, 'Pedra Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.996685', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1378, NULL, 1378, 'Pedra Lavrada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.224321', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1799, NULL, 1799, 'Pedra Mole', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.674638', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5267, NULL, 5267, 'Pedra Preta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.470265', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1176, NULL, 1176, 'Pedra Preta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.997564', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2816, NULL, 2816, 'Pedralva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.784071', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3683, NULL, 3683, 'Pedranopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.733429', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2121, NULL, 2121, 'Pedrao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.022051', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4910, NULL, 4910, 'Pedras Altas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.077899', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1379, NULL, 1379, 'Pedras de Fogo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.225261', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2817, NULL, 2817, 'Pedras de Maria da Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.784969', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4499, NULL, 4499, 'Pedras Grandes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.634126', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3684, NULL, 3684, 'Pedregulho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.73431', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3685, NULL, 3685, 'Pedreira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.735221', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (586, NULL, 586, 'Pedreiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.354689', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1800, NULL, 1800, 'Pedrinhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.675565', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3686, NULL, 3686, 'Pedrinhas Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.736151', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2818, NULL, 2818, 'Pedrinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.785949', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (405, NULL, 405, 'Pedro Afonso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.151063', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2122, NULL, 2122, 'Pedro Alexandre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.022977', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1177, NULL, 1177, 'Pedro Avelino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.998571', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3150, NULL, 3150, 'Pedro Canario', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.137029', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3687, NULL, 3687, 'Pedro de Toledo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.737085', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (587, NULL, 587, 'Pedro do Rosario', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.355564', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5158, NULL, 5158, 'Pedro Gomes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.347493', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (823, NULL, 823, 'Pedro Ii', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.609674', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (824, NULL, 824, 'Pedro Laurentino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.610587', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2819, NULL, 2819, 'Pedro Leopoldo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.786904', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4911, NULL, 4911, 'Pedro Osorio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.078764', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1380, NULL, 1380, 'Pedro Regis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.226144', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2820, NULL, 2820, 'Pedro Teixeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.787893', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1178, NULL, 1178, 'Pedro Velho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.005427', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (406, NULL, 406, 'Peixe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.151996', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (241, NULL, 241, 'Peixe-boi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.964888', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5268, NULL, 5268, 'Peixoto de Azevedo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.471267', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4912, NULL, 4912, 'Pejucara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.08024', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4913, NULL, 4913, 'Pelotas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.081029', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1027, NULL, 1027, 'Penaforte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.832489', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (588, NULL, 588, 'Penalva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.356425', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3688, NULL, 3688, 'Penapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.738028', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1179, NULL, 1179, 'Pendencias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.00655', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1721, NULL, 1721, 'Penedo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.592907', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4500, NULL, 4500, 'Penha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.635075', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1028, NULL, 1028, 'Pentecoste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.83333', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2821, NULL, 2821, 'Pequeri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.788918', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2822, NULL, 2822, 'Pequi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.789785', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (407, NULL, 407, 'Pequizeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.152856', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2823, NULL, 2823, 'Perdigao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.790748', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2824, NULL, 2824, 'Perdizes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.791688', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2825, NULL, 2825, 'Perdoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.792564', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3689, NULL, 3689, 'Pereira Barreto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.738983', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3690, NULL, 3690, 'Pereiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.73982', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1029, NULL, 1029, 'Pereiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.834139', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (589, NULL, 589, 'Peri Mirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.357303', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2826, NULL, 2826, 'Periquito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.793428', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4501, NULL, 4501, 'Peritiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.635905', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (590, NULL, 590, 'Peritoro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.358268', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4173, NULL, 4173, 'Perobal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.275641', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4174, NULL, 4174, 'Perola', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.276605', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4175, NULL, 4175, 'Perola D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.277426', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5497, NULL, 5497, 'Perolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.738016', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3691, NULL, 3691, 'Peruibe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.740635', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2827, NULL, 2827, 'Pescador', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.79428', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1588, NULL, 1588, 'Pesqueira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.448217', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4502, NULL, 4502, 'Petrolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.636576', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1589, NULL, 1589, 'Petrolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.449198', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1590, NULL, 1590, 'Petrolina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.450099', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5498, NULL, 5498, 'Petrolina de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.738872', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3228, NULL, 3228, 'Petropolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.22905', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1722, NULL, 1722, 'Piacabucu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.593907', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3692, NULL, 3692, 'Piacatu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.741532', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1381, NULL, 1381, 'Pianco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.22712', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2123, NULL, 2123, 'Piata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.023897', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2828, NULL, 2828, 'Piau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.795255', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4914, NULL, 4914, 'Picada Cafe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.082336', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (242, NULL, 242, 'Picarra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.965834', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (825, NULL, 825, 'Picos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.611502', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1382, NULL, 1382, 'Picui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.228008', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3693, NULL, 3693, 'Piedade', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.742468', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2829, NULL, 2829, 'Piedade de Caratinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.796196', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2830, NULL, 2830, 'Piedade de Ponte Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.797037', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2831, NULL, 2831, 'Piedade do Rio Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.797938', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2832, NULL, 2832, 'Piedade dos Gerais', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.798806', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4176, NULL, 4176, 'Pien', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.278261', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2124, NULL, 2124, 'Pilao Arcado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.024776', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1723, NULL, 1723, 'Pilar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.594781', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1383, NULL, 1383, 'Pilar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.228887', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5499, NULL, 5499, 'Pilar de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.739682', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3694, NULL, 3694, 'Pilar do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.743483', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1180, NULL, 1180, 'Piloes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.007471', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1384, NULL, 1384, 'Piloes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.230081', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1385, NULL, 1385, 'Piloezinhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.230945', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2833, NULL, 2833, 'Pimenta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.799797', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (35, NULL, 35, 'Pimenta Bueno', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.73925', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (826, NULL, 826, 'Pimenteiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.61237', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (36, NULL, 36, 'Pimenteiras do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.740233', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2125, NULL, 2125, 'Pindai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.025676', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3695, NULL, 3695, 'Pindamonhangaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.744333', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1724, NULL, 1724, 'Pindoba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.595808', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2126, NULL, 2126, 'Pindobacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.026444', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3696, NULL, 3696, 'Pindorama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.745185', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (408, NULL, 408, 'Pindorama do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.153748', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1030, NULL, 1030, 'Pindoretama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.835062', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4177, NULL, 4177, 'Pinhais', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.279077', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4915, NULL, 4915, 'Pinhal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.083171', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4916, NULL, 4916, 'Pinhal da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.083953', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4178, NULL, 4178, 'Pinhal de Sao Bento', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.279898', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4917, NULL, 4917, 'Pinhal Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.084872', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4179, NULL, 4179, 'Pinhalao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.280779', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3697, NULL, 3697, 'Pinhalzinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.746103', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4504, NULL, 4504, 'Pinhalzinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.638178', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4180, NULL, 4180, 'Pinhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.281602', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1801, NULL, 1801, 'Pinhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.676278', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3229, NULL, 3229, 'Pinheiral', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.229964', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4918, NULL, 4918, 'Pinheirinho do Vale', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.08576', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (592, NULL, 592, 'Pinheiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.360105', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4919, NULL, 4919, 'Pinheiro Machado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.086681', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4505, NULL, 4505, 'Pinheiro Preto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.639052', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3151, NULL, 3151, 'Pinheiros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.13779', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2127, NULL, 2127, 'Pintadas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.027298', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2835, NULL, 2835, 'Pintopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.801687', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (827, NULL, 827, 'Pio Ix', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.61325', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (593, NULL, 593, 'Pio Xii', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.361003', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3698, NULL, 3698, 'Piquerobi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.747239', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1031, NULL, 1031, 'Piquet Carneiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.842709', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3699, NULL, 3699, 'Piquete', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.748177', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3700, NULL, 3700, 'Piracaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.749108', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5500, NULL, 5500, 'Piracanjuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.740598', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2836, NULL, 2836, 'Piracema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.802868', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3701, NULL, 3701, 'Piracicaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.750017', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (828, NULL, 828, 'Piracuruca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.6142', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3230, NULL, 3230, 'Pirai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.230972', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2128, NULL, 2128, 'Pirai do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.028163', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4181, NULL, 4181, 'Pirai do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.282487', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3702, NULL, 3702, 'Piraju', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.751064', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2837, NULL, 2837, 'Pirajuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.803785', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3703, NULL, 3703, 'Pirajui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.752015', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1802, NULL, 1802, 'Pirambu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.677143', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2838, NULL, 2838, 'Piranga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.804725', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3704, NULL, 3704, 'Pirangi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.759139', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2839, NULL, 2839, 'Pirangucu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.805698', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2840, NULL, 2840, 'Piranguinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.806615', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1725, NULL, 1725, 'Piranhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.596659', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5501, NULL, 5501, 'Piranhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.741497', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (594, NULL, 594, 'Pirapemas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.361829', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2841, NULL, 2841, 'Pirapetinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.807535', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4920, NULL, 4920, 'Pirapo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.087579', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2842, NULL, 2842, 'Pirapora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.80837', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3705, NULL, 3705, 'Pirapora do Bom Jesus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.760398', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3706, NULL, 3706, 'Pirapozinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.761455', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4182, NULL, 4182, 'Piraquara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.283295', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (409, NULL, 409, 'Piraque', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.154606', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3707, NULL, 3707, 'Pirassununga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.762332', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4921, NULL, 4921, 'Piratini', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.088495', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3708, NULL, 3708, 'Piratininga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.76325', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4506, NULL, 4506, 'Piratuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.640027', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2843, NULL, 2843, 'Pirauba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.809281', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5502, NULL, 5502, 'Pirenopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.742364', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5503, NULL, 5503, 'Pires do Rio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.743286', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1032, NULL, 1032, 'Pires Ferreira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.843807', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2129, NULL, 2129, 'Piripa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.028991', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (829, NULL, 829, 'Piripiri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.615071', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2130, NULL, 2130, 'Piritiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.02981', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1386, NULL, 1386, 'Pirpirituba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.231857', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4183, NULL, 4183, 'Pitanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.2841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3709, NULL, 3709, 'Pitangueiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.764242', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4184, NULL, 4184, 'Pitangueiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.285074', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2844, NULL, 2844, 'Pitangui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.810255', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1387, NULL, 1387, 'Pitimbu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.232742', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (410, NULL, 410, 'Pium', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.155474', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3152, NULL, 3152, 'Piuma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.138726', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2845, NULL, 2845, 'Piumhi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.811233', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (243, NULL, 243, 'Placas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.966852', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (65, NULL, 65, 'Placido de Castro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.77356', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5504, NULL, 5504, 'Planaltina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.744194', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4185, NULL, 4185, 'Planaltina do Parana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.28605', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2131, NULL, 2131, 'Planaltino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.030618', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2132, NULL, 2132, 'Planalto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.037238', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4922, NULL, 4922, 'Planalto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.089514', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3710, NULL, 3710, 'Planalto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.76523', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4186, NULL, 4186, 'Planalto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.286973', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4507, NULL, 4507, 'Planalto Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.640907', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5269, NULL, 5269, 'Planalto da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.477744', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2846, NULL, 2846, 'Planura', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.812132', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3711, NULL, 3711, 'Platina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.766168', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3712, NULL, 3712, 'Poa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.767481', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1591, NULL, 1591, 'Pocao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.451059', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (595, NULL, 595, 'Pocao de Pedras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.362741', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1388, NULL, 1388, 'Pocinhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.233566', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1181, NULL, 1181, 'Poco Branco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.00834', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1389, NULL, 1389, 'Poco Dantas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.234628', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4923, NULL, 4923, 'Poco das Antas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.090675', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1726, NULL, 1726, 'Poco das Trincheiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.597518', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1390, NULL, 1390, 'Poco de Jose de Moura', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.235532', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2847, NULL, 2847, 'Poco Fundo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.813128', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1803, NULL, 1803, 'Poco Redondo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.67807', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1804, NULL, 1804, 'Poco Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.678996', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2133, NULL, 2133, 'Pocoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.038394', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5270, NULL, 5270, 'Pocone', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.478832', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2848, NULL, 2848, 'Pocos de Caldas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.814049', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2849, NULL, 2849, 'Pocrane', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.814882', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2134, NULL, 2134, 'Pojuca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.039305', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3713, NULL, 3713, 'Poloni', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.768419', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1391, NULL, 1391, 'Pombal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.236417', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1592, NULL, 1592, 'Pombos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.458158', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4508, NULL, 4508, 'Pomerode', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.641749', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3714, NULL, 3714, 'Pompeia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.769298', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2850, NULL, 2850, 'Pompeu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.822131', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3715, NULL, 3715, 'Pongai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.770243', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (244, NULL, 244, 'Ponta de Pedras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.968025', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4187, NULL, 4187, 'Ponta Grossa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.287832', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5159, NULL, 5159, 'Ponta Pora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.35418', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3716, NULL, 3716, 'Pontal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.771057', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5271, NULL, 5271, 'Pontal do Araguaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.479747', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4188, NULL, 4188, 'Pontal do Parana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.294545', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5505, NULL, 5505, 'Pontalina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.745138', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3717, NULL, 3717, 'Pontalinda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.772236', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4924, NULL, 4924, 'Pontao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.091762', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4509, NULL, 4509, 'Ponte Alta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.642696', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (411, NULL, 411, 'Ponte Alta do Bom Jesus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.156408', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4510, NULL, 4510, 'Ponte Alta do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.643679', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (412, NULL, 412, 'Ponte Alta do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.157673', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5272, NULL, 5272, 'Ponte Branca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.480811', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2851, NULL, 2851, 'Ponte Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.823253', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4925, NULL, 4925, 'Ponte Preta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.092594', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4511, NULL, 4511, 'Ponte Serrada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.644826', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5273, NULL, 5273, 'Pontes e Lacerda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.481784', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3718, NULL, 3718, 'Pontes Gestal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.77305', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3153, NULL, 3153, 'Ponto Belo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.139504', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2852, NULL, 2852, 'Ponto Chique', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.824088', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2853, NULL, 2853, 'Ponto dos Volantes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.825103', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2135, NULL, 2135, 'Ponto Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.040288', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3719, NULL, 3719, 'Populina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.773915', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1033, NULL, 1033, 'Poranga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.844903', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3720, NULL, 3720, 'Porangaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.774851', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5506, NULL, 5506, 'Porangatu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.746057', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3231, NULL, 3231, 'Porciuncula', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.231958', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4189, NULL, 4189, 'Porecatu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.295833', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1182, NULL, 1182, 'Portalegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.009265', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4926, NULL, 4926, 'Portao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.093566', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5507, NULL, 5507, 'Porteirao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.746977', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1034, NULL, 1034, 'Porteiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.846084', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2854, NULL, 2854, 'Porteirinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.82606', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (245, NULL, 245, 'Portel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.969061', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5508, NULL, 5508, 'Portelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.747798', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (830, NULL, 830, 'Porto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.616029', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (66, NULL, 66, 'Porto Acre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.774455', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4927, NULL, 4927, 'Porto Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.094539', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5274, NULL, 5274, 'Porto Alegre do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.482693', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (831, NULL, 831, 'Porto Alegre do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.617018', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (413, NULL, 413, 'Porto Alegre do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.158647', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4190, NULL, 4190, 'Porto Amazonas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.296693', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4191, NULL, 4191, 'Porto Barreiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.297591', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4512, NULL, 4512, 'Porto Belo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.645727', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1727, NULL, 1727, 'Porto Calvo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.598531', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1805, NULL, 1805, 'Porto da Folha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.679867', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (246, NULL, 246, 'Porto de Moz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.970034', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1728, NULL, 1728, 'Porto de Pedras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.599515', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1183, NULL, 1183, 'Porto do Mangue', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.010181', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5275, NULL, 5275, 'Porto dos Gauchos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.483624', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5276, NULL, 5276, 'Porto Esperidiao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.484579', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5277, NULL, 5277, 'Porto Estrela', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.485413', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3721, NULL, 3721, 'Porto Feliz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.77596', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3722, NULL, 3722, 'Porto Ferreira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.77695', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2855, NULL, 2855, 'Porto Firme', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.827004', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (596, NULL, 596, 'Porto Franco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.363626', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (304, NULL, 304, 'Porto Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.038704', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4928, NULL, 4928, 'Porto Lucena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.095462', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4929, NULL, 4929, 'Porto Maua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.09633', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5160, NULL, 5160, 'Porto Murtinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.355395', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (414, NULL, 414, 'Porto Nacional', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.159639', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3232, NULL, 3232, 'Porto Real', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.232847', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1729, NULL, 1729, 'Porto Real do Colegio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.600386', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4192, NULL, 4192, 'Porto Rico', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.298581', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (597, NULL, 597, 'Porto Rico do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.364534', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2136, NULL, 2136, 'Porto Seguro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.041156', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4513, NULL, 4513, 'Porto Uniao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.646532', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (37, NULL, 37, 'Porto Velho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.741221', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4930, NULL, 4930, 'Porto Vera Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.097306', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4193, NULL, 4193, 'Porto Vitoria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.299373', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (67, NULL, 67, 'Porto Walter', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.775372', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4931, NULL, 4931, 'Porto Xavier', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.098217', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5509, NULL, 5509, 'Posse', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.74865', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2856, NULL, 2856, 'Pote', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.828002', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1035, NULL, 1035, 'Potengi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.847051', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3723, NULL, 3723, 'Potim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.777852', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2137, NULL, 2137, 'Potiragua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.042018', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3724, NULL, 3724, 'Potirendaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.778757', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1036, NULL, 1036, 'Potiretama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.848016', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2857, NULL, 2857, 'Pouso Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.828959', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2858, NULL, 2858, 'Pouso Alto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.830054', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4932, NULL, 4932, 'Pouso Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.099245', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4514, NULL, 4514, 'Pouso Redondo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.647333', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5278, NULL, 5278, 'Poxoreo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.486341', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3725, NULL, 3725, 'Pracinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.779736', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (305, NULL, 305, 'Pracuuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.039594', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2138, NULL, 2138, 'Prado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.042931', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4194, NULL, 4194, 'Prado Ferreira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.300209', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3726, NULL, 3726, 'Pradopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.780653', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2859, NULL, 2859, 'Prados', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.830956', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3727, NULL, 3727, 'Praia Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.781557', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4515, NULL, 4515, 'Praia Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.648213', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (415, NULL, 415, 'Praia Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.160437', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (247, NULL, 247, 'Prainha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.978985', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4195, NULL, 4195, 'Pranchita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.301016', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2860, NULL, 2860, 'Prata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.831842', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1392, NULL, 1392, 'Prata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.23723', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (832, NULL, 832, 'Prata do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.617877', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3728, NULL, 3728, 'Pratania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.782464', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2861, NULL, 2861, 'Pratapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.832742', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2862, NULL, 2862, 'Pratinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.833628', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3729, NULL, 3729, 'Presidente Alves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.783493', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3730, NULL, 3730, 'Presidente Bernardes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.784379', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2863, NULL, 2863, 'Presidente Bernardes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.834501', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4516, NULL, 4516, 'Presidente Castello Branco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.64913', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4196, NULL, 4196, 'Presidente Castelo Branco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.301937', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (598, NULL, 598, 'Presidente Dutra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.365368', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2139, NULL, 2139, 'Presidente Dutra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.04386', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3731, NULL, 3731, 'Presidente Epitacio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.785224', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (121, NULL, 121, 'Presidente Figueiredo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.832207', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4517, NULL, 4517, 'Presidente Getulio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.650041', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2140, NULL, 2140, 'Presidente Janio Quadros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.044678', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1184, NULL, 1184, 'Presidente Juscelino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.010971', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2864, NULL, 2864, 'Presidente Juscelino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.836256', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (599, NULL, 599, 'Presidente Juscelino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.366202', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3154, NULL, 3154, 'Presidente Kennedy', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.146339', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (416, NULL, 416, 'Presidente Kennedy', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.16134', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2865, NULL, 2865, 'Presidente Kubitschek', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.837166', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4933, NULL, 4933, 'Presidente Lucena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.10017', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (600, NULL, 600, 'Presidente Medici', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.367133', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (38, NULL, 38, 'Presidente Medici', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.742117', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4518, NULL, 4518, 'Presidente Nereu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.650912', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2866, NULL, 2866, 'Presidente Olegario', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.838125', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3732, NULL, 3732, 'Presidente Prudente', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.786107', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (601, NULL, 601, 'Presidente Sarney', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.368047', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2141, NULL, 2141, 'Presidente Tancredo Neves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.045568', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (602, NULL, 602, 'Presidente Vargas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.368937', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3733, NULL, 3733, 'Presidente Venceslau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.786904', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (248, NULL, 248, 'Primavera', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.980101', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1593, NULL, 1593, 'Primavera', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.459513', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (39, NULL, 39, 'Primavera de Rondonia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.743068', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5279, NULL, 5279, 'Primavera do Leste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.487239', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (603, NULL, 603, 'Primeira Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.369823', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4197, NULL, 4197, 'Primeiro de Maio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.30282', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4519, NULL, 4519, 'Princesa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.651836', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1393, NULL, 1393, 'Princesa Isabel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.238127', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5510, NULL, 5510, 'Professor Jamil', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.749443', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4934, NULL, 4934, 'Progresso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.101105', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3734, NULL, 3734, 'Promissao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.787815', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1806, NULL, 1806, 'Propria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.680723', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4935, NULL, 4935, 'Protasio Alves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.102143', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2867, NULL, 2867, 'Prudente de Morais', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.839006', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4198, NULL, 4198, 'Prudentopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.303849', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (417, NULL, 417, 'Pugmil', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.16224', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1185, NULL, 1185, 'Pureza', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.012', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4936, NULL, 4936, 'Putinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.103128', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1394, NULL, 1394, 'Puxinana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.238929', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3735, NULL, 3735, 'Quadra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.788698', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4937, NULL, 4937, 'Quarai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.10406', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2868, NULL, 2868, 'Quartel Geral', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.839868', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4199, NULL, 4199, 'Quarto Centenario', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.304786', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3736, NULL, 3736, 'Quata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.789628', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4200, NULL, 4200, 'Quatigua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.305711', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (249, NULL, 249, 'Quatipuru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.981208', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3233, NULL, 3233, 'Quatis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.233751', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4201, NULL, 4201, 'Quatro Barras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.306515', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4938, NULL, 4938, 'Quatro Irmaos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.110644', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4202, NULL, 4202, 'Quatro Pontes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.307399', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1730, NULL, 1730, 'Quebrangulo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.601248', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4203, NULL, 4203, 'Quedas do Iguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.308241', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (833, NULL, 833, 'Queimada Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.618689', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2142, NULL, 2142, 'Queimadas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.046592', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1395, NULL, 1395, 'Queimadas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.239764', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3234, NULL, 3234, 'Queimados', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.234722', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3737, NULL, 3737, 'Queiroz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.790503', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3738, NULL, 3738, 'Queluz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.791388', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2869, NULL, 2869, 'Queluzito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.840797', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5280, NULL, 5280, 'Querencia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.48811', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4204, NULL, 4204, 'Querencia do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.309072', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4939, NULL, 4939, 'Quevedos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.111825', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2143, NULL, 2143, 'Quijingue', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.047491', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4520, NULL, 4520, 'Quilombo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.65283', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4205, NULL, 4205, 'Quinta do Sol', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.31021', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3739, NULL, 3739, 'Quintana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.792194', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4940, NULL, 4940, 'Quinze de Novembro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.112857', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1594, NULL, 1594, 'Quipapa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.460461', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5511, NULL, 5511, 'Quirinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.606333', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3235, NULL, 3235, 'Quissama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.235676', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4206, NULL, 4206, 'Quitandinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.311014', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1037, NULL, 1037, 'Quiterianopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.849214', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1595, NULL, 1595, 'Quixaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.461303', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1396, NULL, 1396, 'Quixaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.240693', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2144, NULL, 2144, 'Quixabeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.04839', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1038, NULL, 1038, 'Quixada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.850112', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1039, NULL, 1039, 'Quixelo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.851035', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1040, NULL, 1040, 'Quixeramobim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.851966', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1041, NULL, 1041, 'Quixere', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.852901', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1186, NULL, 1186, 'Rafael Fernandes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.012814', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1187, NULL, 1187, 'Rafael Godeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.013633', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2145, NULL, 2145, 'Rafael Jambeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.049242', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3740, NULL, 3740, 'Rafard', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.799849', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4207, NULL, 4207, 'Ramilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.3117', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3741, NULL, 3741, 'Rancharia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.801147', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4208, NULL, 4208, 'Rancho Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.312592', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4209, NULL, 4209, 'Rancho Alegre D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.313489', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4521, NULL, 4521, 'Rancho Queimado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.65372', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (604, NULL, 604, 'Raposa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.370771', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2870, NULL, 2870, 'Raposos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.84164', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2871, NULL, 2871, 'Raul Soares', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.842576', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4210, NULL, 4210, 'Realeza', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.314376', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4211, NULL, 4211, 'Reboucas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.315317', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1596, NULL, 1596, 'Recife', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.462202', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2872, NULL, 2872, 'Recreio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.843754', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (418, NULL, 418, 'Recursolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.163175', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1042, NULL, 1042, 'Redencao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.853907', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (250, NULL, 250, 'Redencao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.982118', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3742, NULL, 3742, 'Redencao da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.802051', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (834, NULL, 834, 'Redencao do Gurgueia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.619662', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4941, NULL, 4941, 'Redentora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.113697', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2873, NULL, 2873, 'Reduto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.844654', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (835, NULL, 835, 'Regeneracao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.620619', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3743, NULL, 3743, 'Regente Feijo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.802929', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3744, NULL, 3744, 'Reginopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.80391', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3745, NULL, 3745, 'Registro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.804743', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4942, NULL, 4942, 'Relvado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.114655', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2146, NULL, 2146, 'Remanso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.050108', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1397, NULL, 1397, 'Remigio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.241454', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4212, NULL, 4212, 'Renascenca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.316337', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1043, NULL, 1043, 'Reriutaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.855028', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3236, NULL, 3236, 'Resende', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.236633', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2874, NULL, 2874, 'Resende Costa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.845628', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4213, NULL, 4213, 'Reserva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.317368', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5281, NULL, 5281, 'Reserva do Cabacal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.489033', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4214, NULL, 4214, 'Reserva do Iguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.318231', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2875, NULL, 2875, 'Resplendor', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.846633', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2876, NULL, 2876, 'Ressaquinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.847458', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3746, NULL, 3746, 'Restinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.80577', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4943, NULL, 4943, 'Restinga Seca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.115499', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2147, NULL, 2147, 'Retirolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.051116', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1398, NULL, 1398, 'Riachao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.242406', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (605, NULL, 605, 'Riachao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.371655', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2148, NULL, 2148, 'Riachao das Neves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.051964', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1399, NULL, 1399, 'Riachao do Bacamarte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.243145', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1807, NULL, 1807, 'Riachao do Dantas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.68163', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2149, NULL, 2149, 'Riachao do Jacuipe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.052816', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1400, NULL, 1400, 'Riachao do Poco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.249788', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (419, NULL, 419, 'Riachinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.164096', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2877, NULL, 2877, 'Riachinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.848378', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1188, NULL, 1188, 'Riacho da Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.014532', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1597, NULL, 1597, 'Riacho das Almas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.463132', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2150, NULL, 2150, 'Riacho de Santana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.053696', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1189, NULL, 1189, 'Riacho de Santana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.015533', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1401, NULL, 1401, 'Riacho de Santo Antonio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.250952', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1402, NULL, 1402, 'Riacho dos Cavalos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.252411', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2878, NULL, 2878, 'Riacho dos Machados', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.849254', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (836, NULL, 836, 'Riacho Frio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.621548', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1190, NULL, 1190, 'Riachuelo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.016688', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1808, NULL, 1808, 'Riachuelo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.68251', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5512, NULL, 5512, 'Rialma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.339363', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5513, NULL, 5513, 'Rianapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.527984', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (606, NULL, 606, 'Ribamar Fiquene', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.372579', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5161, NULL, 5161, 'Ribas do Rio Pardo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.356263', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3747, NULL, 3747, 'Ribeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.806596', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2151, NULL, 2151, 'Ribeira do Amparo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.054615', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (837, NULL, 837, 'Ribeira do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.62253', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2152, NULL, 2152, 'Ribeira do Pombal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.055463', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1598, NULL, 1598, 'Ribeirao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.464166', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3748, NULL, 3748, 'Ribeirao Bonito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.807499', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3749, NULL, 3749, 'Ribeirao Branco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.808385', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5282, NULL, 5282, 'Ribeirao Cascalheira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.489983', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4215, NULL, 4215, 'Ribeirao Claro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.31911', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3750, NULL, 3750, 'Ribeirao Corrente', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.809327', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2879, NULL, 2879, 'Ribeirao das Neves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.850149', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2153, NULL, 2153, 'Ribeirao do Largo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.05629', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4216, NULL, 4216, 'Ribeirao do Pinhal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.319989', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3751, NULL, 3751, 'Ribeirao do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.810148', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3752, NULL, 3752, 'Ribeirao dos Indios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.811033', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3753, NULL, 3753, 'Ribeirao Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.811878', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3754, NULL, 3754, 'Ribeirao Pires', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.812751', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3755, NULL, 3755, 'Ribeirao Preto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.813744', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2880, NULL, 2880, 'Ribeirao Vermelho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.851048', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5283, NULL, 5283, 'Ribeiraozinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.490955', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (838, NULL, 838, 'Ribeiro Goncalves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.623518', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1809, NULL, 1809, 'Ribeiropolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.683399', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3756, NULL, 3756, 'Rifaina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.814689', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3757, NULL, 3757, 'Rincao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.815604', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3758, NULL, 3758, 'Rinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.81658', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2881, NULL, 2881, 'Rio Acima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.852061', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4217, NULL, 4217, 'Rio Azul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.320821', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3155, NULL, 3155, 'Rio Bananal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.150463', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4218, NULL, 4218, 'Rio Bom', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.32181', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3237, NULL, 3237, 'Rio Bonito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.238008', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4219, NULL, 4219, 'Rio Bonito do Iguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.322764', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (68, NULL, 68, 'Rio Branco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.776144', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5284, NULL, 5284, 'Rio Branco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.491842', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4220, NULL, 4220, 'Rio Branco do Ivai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.323713', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4221, NULL, 4221, 'Rio Branco do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.324646', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5162, NULL, 5162, 'Rio Brilhante', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.357159', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2882, NULL, 2882, 'Rio Casca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.852976', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3238, NULL, 3238, 'Rio Claro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.238923', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3759, NULL, 3759, 'Rio Claro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.817501', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (40, NULL, 40, 'Rio Crespo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.744066', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (420, NULL, 420, 'Rio da Conceicao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.164921', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4522, NULL, 4522, 'Rio das Antas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.654634', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3239, NULL, 3239, 'Rio das Flores', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.239799', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3240, NULL, 3240, 'Rio das Ostras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.24067', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3760, NULL, 3760, 'Rio das Pedras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.8183', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2154, NULL, 2154, 'Rio de Contas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.057205', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3241, NULL, 3241, 'Rio de Janeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.241514', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2155, NULL, 2155, 'Rio do Antonio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.058091', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4523, NULL, 4523, 'Rio do Campo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.65549', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1191, NULL, 1191, 'Rio do Fogo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.017658', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4524, NULL, 4524, 'Rio do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.656406', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2156, NULL, 2156, 'Rio do Pires', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.059061', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2883, NULL, 2883, 'Rio do Prado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.853875', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4525, NULL, 4525, 'Rio do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.663037', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2884, NULL, 2884, 'Rio Doce', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.854683', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (421, NULL, 421, 'Rio dos Bois', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.165967', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4526, NULL, 4526, 'Rio dos Cedros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.664346', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4944, NULL, 4944, 'Rio dos Indios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.116294', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2885, NULL, 2885, 'Rio Espera', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.855684', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1599, NULL, 1599, 'Rio Formoso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.46508', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4527, NULL, 4527, 'Rio Fortuna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.665268', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4945, NULL, 4945, 'Rio Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.117266', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3761, NULL, 3761, 'Rio Grande da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.819205', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (839, NULL, 839, 'Rio Grande do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.624477', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1731, NULL, 1731, 'Rio Largo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.602118', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2886, NULL, 2886, 'Rio Manso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.856476', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (251, NULL, 251, 'Rio Maria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.983216', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4528, NULL, 4528, 'Rio Negrinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.666145', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5163, NULL, 5163, 'Rio Negro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.358428', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4222, NULL, 4222, 'Rio Negro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.325554', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2887, NULL, 2887, 'Rio Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.863208', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3156, NULL, 3156, 'Rio Novo do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.151418', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2888, NULL, 2888, 'Rio Paranaiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.86423', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4946, NULL, 4946, 'Rio Pardo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.118179', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2889, NULL, 2889, 'Rio Pardo de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.865113', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2890, NULL, 2890, 'Rio Piracicaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.866003', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2891, NULL, 2891, 'Rio Pomba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.866718', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2892, NULL, 2892, 'Rio Preto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.86757', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (122, NULL, 122, 'Rio Preto da Eva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.833161', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5514, NULL, 5514, 'Rio Quente', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.750281', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2157, NULL, 2157, 'Rio Real', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.0599', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4529, NULL, 4529, 'Rio Rufino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.667136', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (422, NULL, 422, 'Rio Sono', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.166949', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1403, NULL, 1403, 'Rio Tinto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.253304', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5515, NULL, 5515, 'Rio Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.75147', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5164, NULL, 5164, 'Rio Verde de Mato Grosso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.359236', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2893, NULL, 2893, 'Rio Vermelho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.868466', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3762, NULL, 3762, 'Riolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.820129', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4947, NULL, 4947, 'Riozinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.119135', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4530, NULL, 4530, 'Riqueza', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.667883', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2894, NULL, 2894, 'Ritapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.86965', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3763, NULL, 3763, 'Riversul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.821112', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4948, NULL, 4948, 'Roca Sales', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.119995', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5165, NULL, 5165, 'Rochedo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.360185', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2895, NULL, 2895, 'Rochedo de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.870574', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4531, NULL, 4531, 'Rodeio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.668722', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4949, NULL, 4949, 'Rodeio Bonito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.120924', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2896, NULL, 2896, 'Rodeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.87147', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2158, NULL, 2158, 'Rodelas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.060828', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1192, NULL, 1192, 'Rodolfo Fernandes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.018555', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (69, NULL, 69, 'Rodrigues Alves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.777086', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4950, NULL, 4950, 'Rolador', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.121849', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4223, NULL, 4223, 'Rolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.326432', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4951, NULL, 4951, 'Rolante', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.122777', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (41, NULL, 41, 'Rolim de Moura', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.745017', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2897, NULL, 2897, 'Romaria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.872334', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4532, NULL, 4532, 'Romelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.669664', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4224, NULL, 4224, 'Roncador', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.327306', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4952, NULL, 4952, 'Ronda Alta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.123656', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4953, NULL, 4953, 'Rondinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.124514', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5285, NULL, 5285, 'Rondolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.492869', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4225, NULL, 4225, 'Rondon', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.328245', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (252, NULL, 252, 'Rondon do Para', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.984434', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5286, NULL, 5286, 'Rondonopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.493854', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4954, NULL, 4954, 'Roque Gonzales', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.125383', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (147, NULL, 147, 'Rorainopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.86373', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3764, NULL, 3764, 'Rosana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.822033', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (607, NULL, 607, 'Rosario', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.373524', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2898, NULL, 2898, 'Rosario da Limeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.873188', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1810, NULL, 1810, 'Rosario do Catete', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.684327', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4226, NULL, 4226, 'Rosario do Ivai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.338376', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4955, NULL, 4955, 'Rosario do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.126163', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5287, NULL, 5287, 'Rosario Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.494826', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3765, NULL, 3765, 'Roseira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.822953', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1732, NULL, 1732, 'Roteiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.602974', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2899, NULL, 2899, 'Rubelita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.873986', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3766, NULL, 3766, 'Rubiacea', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.823779', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5516, NULL, 5516, 'Rubiataba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.752375', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2900, NULL, 2900, 'Rubim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.874865', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3767, NULL, 3767, 'Rubineia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.824722', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (253, NULL, 253, 'Ruropolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.985502', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1044, NULL, 1044, 'Russas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.85597', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1193, NULL, 1193, 'Ruy Barbosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.019556', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2159, NULL, 2159, 'Ruy Barbosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.061686', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2901, NULL, 2901, 'Sabara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.875998', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4227, NULL, 4227, 'Sabaudia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.339508', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3768, NULL, 3768, 'Sabino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.825716', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2902, NULL, 2902, 'Sabinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.876908', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1045, NULL, 1045, 'Saboeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.856853', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2903, NULL, 2903, 'Sacramento', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.877892', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4956, NULL, 4956, 'Sagrada Familia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.127151', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3769, NULL, 3769, 'Sagres', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.826657', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1600, NULL, 1600, 'Saire', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.466141', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4957, NULL, 4957, 'Saldanha Marinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.128127', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3770, NULL, 3770, 'Sales', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.827569', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3771, NULL, 3771, 'Sales Oliveira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.8286', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3772, NULL, 3772, 'Salesopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.829388', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4533, NULL, 4533, 'Salete', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.670537', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1404, NULL, 1404, 'Salgadinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.25416', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1601, NULL, 1601, 'Salgadinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.467057', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1811, NULL, 1811, 'Salgado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.685208', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1405, NULL, 1405, 'Salgado de Sao Felix', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.255117', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4228, NULL, 4228, 'Salgado Filho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.34043', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1602, NULL, 1602, 'Salgueiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.467963', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2904, NULL, 2904, 'Salinas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.878715', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2160, NULL, 2160, 'Salinas da Margarida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.062613', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (254, NULL, 254, 'Salinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.986493', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1046, NULL, 1046, 'Salitre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.857981', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3773, NULL, 3773, 'Salmourao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.830267', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1603, NULL, 1603, 'Saloa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.468887', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3774, NULL, 3774, 'Saltinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.831174', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4534, NULL, 4534, 'Saltinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.671426', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3775, NULL, 3775, 'Salto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.832063', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2905, NULL, 2905, 'Salto da Divisa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.87963', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3776, NULL, 3776, 'Salto de Pirapora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.832983', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5288, NULL, 5288, 'Salto do Ceu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.495786', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4229, NULL, 4229, 'Salto do Itarare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.341281', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4958, NULL, 4958, 'Salto do Jacui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.129107', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4230, NULL, 4230, 'Salto do Lontra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.342375', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3777, NULL, 3777, 'Salto Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.833872', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4535, NULL, 4535, 'Salto Veloso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.672315', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2161, NULL, 2161, 'Salvador', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.063432', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4959, NULL, 4959, 'Salvador das Missoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.13005', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4960, NULL, 4960, 'Salvador do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.130968', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (255, NULL, 255, 'Salvaterra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.987353', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (608, NULL, 608, 'Sambaiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.374298', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (423, NULL, 423, 'Sampaio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.167811', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4961, NULL, 4961, 'Sananduva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.131942', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5517, NULL, 5517, 'Sanclerlandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.75327', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (424, NULL, 424, 'Sandolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.168809', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3778, NULL, 3778, 'Sandovalina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.841128', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4536, NULL, 4536, 'Sangao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.67311', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1604, NULL, 1604, 'Sanharo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.469786', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3779, NULL, 3779, 'Santa Adelia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.842526', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3780, NULL, 3780, 'Santa Albertina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.843562', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4231, NULL, 4231, 'Santa Amelia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.343545', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2906, NULL, 2906, 'Santa Barbara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.880788', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2162, NULL, 2162, 'Santa Barbara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.064199', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3781, NULL, 3781, 'Santa Barbara D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.844486', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5518, NULL, 5518, 'Santa Barbara de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.754126', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2907, NULL, 2907, 'Santa Barbara do Leste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.881713', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2908, NULL, 2908, 'Santa Barbara do Monte Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.882576', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (256, NULL, 256, 'Santa Barbara do Para', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.988251', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4962, NULL, 4962, 'Santa Barbara do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.132733', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2909, NULL, 2909, 'Santa Barbara do Tugurio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.883499', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3782, NULL, 3782, 'Santa Branca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.845468', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2163, NULL, 2163, 'Santa Brigida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.065113', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5289, NULL, 5289, 'Santa Carmem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.496894', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1406, NULL, 1406, 'Santa Cecilia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.256209', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4537, NULL, 4537, 'Santa Cecilia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.674081', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4232, NULL, 4232, 'Santa Cecilia do Pavao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.344438', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4963, NULL, 4963, 'Santa Cecilia do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.133677', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3783, NULL, 3783, 'Santa Clara D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.846438', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4964, NULL, 4964, 'Santa Clara do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.134621', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1407, NULL, 1407, 'Santa Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.25718', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1194, NULL, 1194, 'Santa Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.020402', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1605, NULL, 1605, 'Santa Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.470673', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2164, NULL, 2164, 'Santa Cruz Cabralia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.066096', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1606, NULL, 1606, 'Santa Cruz da Baixa Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.471456', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3784, NULL, 3784, 'Santa Cruz da Conceicao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.847281', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3785, NULL, 3785, 'Santa Cruz da Esperanca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.848235', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2165, NULL, 2165, 'Santa Cruz da Vitoria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.066868', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3786, NULL, 3786, 'Santa Cruz das Palmeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.849206', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5519, NULL, 5519, 'Santa Cruz de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.754942', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2910, NULL, 2910, 'Santa Cruz de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.884331', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4233, NULL, 4233, 'Santa Cruz de Monte Castelo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.345319', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2911, NULL, 2911, 'Santa Cruz de Salinas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.885373', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (257, NULL, 257, 'Santa Cruz do Arari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.989048', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1607, NULL, 1607, 'Santa Cruz do Capibaribe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.47243', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2912, NULL, 2912, 'Santa Cruz do Escalvado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.886231', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (840, NULL, 840, 'Santa Cruz do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.625541', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3787, NULL, 3787, 'Santa Cruz do Rio Pardo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.850133', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4965, NULL, 4965, 'Santa Cruz do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.135859', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5290, NULL, 5290, 'Santa Cruz do Xingu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.497687', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (841, NULL, 841, 'Santa Cruz dos Milagres', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.626406', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2913, NULL, 2913, 'Santa Efigenia de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.887023', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3788, NULL, 3788, 'Santa Ernestina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.851253', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4234, NULL, 4234, 'Santa Fe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.346188', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5520, NULL, 5520, 'Santa Fe de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.755933', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2914, NULL, 2914, 'Santa Fe de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.887823', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (425, NULL, 425, 'Santa Fe do Araguaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.169817', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3789, NULL, 3789, 'Santa Fe do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.852223', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1608, NULL, 1608, 'Santa Filomena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.473203', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (842, NULL, 842, 'Santa Filomena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.627271', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (609, NULL, 609, 'Santa Filomena do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.375097', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3790, NULL, 3790, 'Santa Gertrudes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.853156', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (610, NULL, 610, 'Santa Helena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.376', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4235, NULL, 4235, 'Santa Helena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.347091', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1408, NULL, 1408, 'Santa Helena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.258032', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4538, NULL, 4538, 'Santa Helena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.674964', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5521, NULL, 5521, 'Santa Helena de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.756965', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2915, NULL, 2915, 'Santa Helena de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.888613', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1409, NULL, 1409, 'Santa Ines', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.258871', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (611, NULL, 611, 'Santa Ines', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.376926', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4236, NULL, 4236, 'Santa Ines', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.347973', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2166, NULL, 2166, 'Santa Ines', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.067781', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5522, NULL, 5522, 'Santa Isabel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.757965', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3791, NULL, 3791, 'Santa Isabel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.854113', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4237, NULL, 4237, 'Santa Isabel do Ivai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.348934', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (123, NULL, 123, 'Santa Isabel do Rio Negro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.834228', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4238, NULL, 4238, 'Santa Izabel do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.349861', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2916, NULL, 2916, 'Santa Juliana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.889436', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3157, NULL, 3157, 'Santa Leopoldina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.152323', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4239, NULL, 4239, 'Santa Lucia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.350735', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3792, NULL, 3792, 'Santa Lucia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.854982', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (843, NULL, 843, 'Santa Luz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.628246', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2167, NULL, 2167, 'Santa Luzia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.068555', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2917, NULL, 2917, 'Santa Luzia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.890286', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (612, NULL, 612, 'Santa Luzia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.37791', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1410, NULL, 1410, 'Santa Luzia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.25973', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (42, NULL, 42, 'Santa Luzia D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.745909', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1812, NULL, 1812, 'Santa Luzia do Itanhy', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.686053', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1733, NULL, 1733, 'Santa Luzia do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.60384', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (259, NULL, 259, 'Santa Luzia do Para', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.991128', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (613, NULL, 613, 'Santa Luzia do Parua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.378894', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2918, NULL, 2918, 'Santa Margarida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.891179', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4966, NULL, 4966, 'Santa Margarida do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.136798', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4967, NULL, 4967, 'Santa Maria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.137745', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1195, NULL, 1195, 'Santa Maria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.021445', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1609, NULL, 1609, 'Santa Maria da Boa Vista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.474049', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3793, NULL, 3793, 'Santa Maria da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.85605', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2168, NULL, 2168, 'Santa Maria da Vitoria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.069542', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (260, NULL, 260, 'Santa Maria das Barreiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.991911', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2919, NULL, 2919, 'Santa Maria de Itabira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.892071', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3158, NULL, 3158, 'Santa Maria de Jetiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.153183', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1610, NULL, 1610, 'Santa Maria do Cambuca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.474981', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4968, NULL, 4968, 'Santa Maria do Herval', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.138656', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4240, NULL, 4240, 'Santa Maria do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.351637', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (261, NULL, 261, 'Santa Maria do Para', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.992886', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2920, NULL, 2920, 'Santa Maria do Salto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.893033', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2921, NULL, 2921, 'Santa Maria do Suacui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.893934', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (426, NULL, 426, 'Santa Maria do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.170766', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3242, NULL, 3242, 'Santa Maria Madalena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.242392', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4241, NULL, 4241, 'Santa Mariana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.352468', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3794, NULL, 3794, 'Santa Mercedes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.857003', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4242, NULL, 4242, 'Santa Monica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.353319', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1047, NULL, 1047, 'Santa Quiteria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.858908', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (614, NULL, 614, 'Santa Quiteria do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.379769', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (615, NULL, 615, 'Santa Rita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.380996', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1411, NULL, 1411, 'Santa Rita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.260598', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3796, NULL, 3796, 'Santa Rita D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.85865', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2922, NULL, 2922, 'Santa Rita de Caldas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.894802', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2169, NULL, 2169, 'Santa Rita de Cassia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.070478', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2923, NULL, 2923, 'Santa Rita de Ibitipoca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.895661', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2924, NULL, 2924, 'Santa Rita de Jacutinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.896554', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2925, NULL, 2925, 'Santa Rita de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.90317', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5523, NULL, 5523, 'Santa Rita do Araguaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.758958', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2926, NULL, 2926, 'Santa Rita do Itueto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.904334', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5524, NULL, 5524, 'Santa Rita do Novo Destino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.759916', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5166, NULL, 5166, 'Santa Rita do Pardo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.360982', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3795, NULL, 3795, 'Santa Rita do Passa Quatro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.857824', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2927, NULL, 2927, 'Santa Rita do Sapucai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.905188', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (427, NULL, 427, 'Santa Rita do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.171677', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5291, NULL, 5291, 'Santa Rita do Trivelato', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.498595', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4969, NULL, 4969, 'Santa Rosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.139651', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2928, NULL, 2928, 'Santa Rosa da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.906002', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5525, NULL, 5525, 'Santa Rosa de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.760746', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1813, NULL, 1813, 'Santa Rosa de Lima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.687431', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4539, NULL, 4539, 'Santa Rosa de Lima', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.675907', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3797, NULL, 3797, 'Santa Rosa de Viterbo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.859396', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (844, NULL, 844, 'Santa Rosa do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.629172', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (70, NULL, 70, 'Santa Rosa do Purus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.778157', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4540, NULL, 4540, 'Santa Rosa do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.676772', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (428, NULL, 428, 'Santa Rosa do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.172572', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3798, NULL, 3798, 'Santa Salete', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.860312', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3159, NULL, 3159, 'Santa Teresa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.154075', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2170, NULL, 2170, 'Santa Teresinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.071319', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1412, NULL, 1412, 'Santa Teresinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.261849', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4970, NULL, 4970, 'Santa Tereza', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.140575', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5526, NULL, 5526, 'Santa Tereza de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.76171', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4243, NULL, 4243, 'Santa Tereza do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.35425', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (429, NULL, 429, 'Santa Tereza do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.173518', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5292, NULL, 5292, 'Santa Terezinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.499475', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1611, NULL, 1611, 'Santa Terezinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.475798', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4541, NULL, 4541, 'Santa Terezinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.677855', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5527, NULL, 5527, 'Santa Terezinha de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.762654', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4244, NULL, 4244, 'Santa Terezinha de Itaipu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.355024', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4542, NULL, 4542, 'Santa Terezinha do Progresso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.678617', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (430, NULL, 430, 'Santa Terezinha do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.174352', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2929, NULL, 2929, 'Santa Vitoria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.906897', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4971, NULL, 4971, 'Santa Vitoria do Palmar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.141428', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2171, NULL, 2171, 'Santaluz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.081182', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (306, NULL, 306, 'Santana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.040511', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2172, NULL, 2172, 'Santana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.082258', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4972, NULL, 4972, 'Santana da Boa Vista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.142334', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3799, NULL, 3799, 'Santana da Ponte Pensa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.861535', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2930, NULL, 2930, 'Santana da Vargem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.90782', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2931, NULL, 2931, 'Santana de Cataguases', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.908562', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1413, NULL, 1413, 'Santana de Mangueira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.262825', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3800, NULL, 3800, 'Santana de Parnaiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.862612', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2932, NULL, 2932, 'Santana de Pirapama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.909396', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1048, NULL, 1048, 'Santana do Acarau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.85981', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (262, NULL, 262, 'Santana do Araguaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.993845', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1049, NULL, 1049, 'Santana do Cariri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.860708', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2933, NULL, 2933, 'Santana do Deserto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.91025', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2934, NULL, 2934, 'Santana do Garambeu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.911172', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1734, NULL, 1734, 'Santana do Ipanema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.604666', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4245, NULL, 4245, 'Santana do Itarare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.355964', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2935, NULL, 2935, 'Santana do Jacare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.912087', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2936, NULL, 2936, 'Santana do Manhuacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.912919', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (616, NULL, 616, 'Santana do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.381789', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1196, NULL, 1196, 'Santana do Matos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.022177', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1735, NULL, 1735, 'Santana do Mundau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.605464', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2937, NULL, 2937, 'Santana do Paraiso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.913893', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (845, NULL, 845, 'Santana do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.630097', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2938, NULL, 2938, 'Santana do Riacho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.914701', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1814, NULL, 1814, 'Santana do Sao Francisco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.688243', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1197, NULL, 1197, 'Santana do Serido', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.023022', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1414, NULL, 1414, 'Santana dos Garrotes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.263649', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2939, NULL, 2939, 'Santana dos Montes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.915635', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2173, NULL, 2173, 'Santanopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.083118', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1415, NULL, 1415, 'Santarem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.264592', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (263, NULL, 263, 'Santarem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.994763', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (264, NULL, 264, 'Santarem Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.995664', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4974, NULL, 4974, 'Santiago', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.144184', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4543, NULL, 4543, 'Santiago do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.679531', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5293, NULL, 5293, 'Santo Afonso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.50045', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2174, NULL, 2174, 'Santo Amaro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.083992', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4544, NULL, 4544, 'Santo Amaro da Imperatriz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.680401', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1815, NULL, 1815, 'Santo Amaro das Brotas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.689158', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (617, NULL, 617, 'Santo Amaro do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.382757', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3801, NULL, 3801, 'Santo Anastacio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.863652', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3802, NULL, 3802, 'Santo Andre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.864564', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1416, NULL, 1416, 'Santo Andre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.265495', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4975, NULL, 4975, 'Santo Angelo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.150861', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1198, NULL, 1198, 'Santo Antonio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.023864', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4548, NULL, 4548, 'Sao Carlos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.683978', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3803, NULL, 3803, 'Santo Antonio da Alegria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.865523', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5528, NULL, 5528, 'Santo Antonio da Barra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.763614', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4976, NULL, 4976, 'Santo Antonio da Patrulha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.151967', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4246, NULL, 4246, 'Santo Antonio da Platina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.356885', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4977, NULL, 4977, 'Santo Antonio das Missoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.152911', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5529, NULL, 5529, 'Santo Antonio de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.764441', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2175, NULL, 2175, 'Santo Antonio de Jesus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.084795', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (846, NULL, 846, 'Santo Antonio de Lisboa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.630983', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3243, NULL, 3243, 'Santo Antonio de Padua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.24326', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3804, NULL, 3804, 'Santo Antonio de Posse', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.866439', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2940, NULL, 2940, 'Santo Antonio do Amparo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.916561', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3805, NULL, 3805, 'Santo Antonio do Aracangua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.867468', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2941, NULL, 2941, 'Santo Antonio do Aventureiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.917522', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4247, NULL, 4247, 'Santo Antonio do Caiua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.357831', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5530, NULL, 5530, 'Santo Antonio do Descoberto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.771458', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2942, NULL, 2942, 'Santo Antonio do Grama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.918259', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (124, NULL, 124, 'Santo Antonio do Ica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.835121', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2943, NULL, 2943, 'Santo Antonio do Itambe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.919652', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2944, NULL, 2944, 'Santo Antonio do Jacinto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.920493', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3806, NULL, 3806, 'Santo Antonio do Jardim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.868427', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5294, NULL, 5294, 'Santo Antonio do Leste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.50133', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5295, NULL, 5295, 'Santo Antonio do Leverger', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.502127', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2945, NULL, 2945, 'Santo Antonio do Monte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.921488', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4978, NULL, 4978, 'Santo Antonio do Palma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.153811', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4248, NULL, 4248, 'Santo Antonio do Paraiso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.358771', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3807, NULL, 3807, 'Santo Antonio do Pinhal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.869308', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4979, NULL, 4979, 'Santo Antonio do Planalto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.154666', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2946, NULL, 2946, 'Santo Antonio do Retiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.922448', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2947, NULL, 2947, 'Santo Antonio do Rio Abaixo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.923338', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4249, NULL, 4249, 'Santo Antonio do Sudoeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.359666', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (265, NULL, 265, 'Santo Antonio do Taua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.996463', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (618, NULL, 618, 'Santo Antonio dos Lopes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.38365', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (847, NULL, 847, 'Santo Antonio dos Milagres', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.631953', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4980, NULL, 4980, 'Santo Augusto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.155574', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4981, NULL, 4981, 'Santo Cristo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.156456', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2176, NULL, 2176, 'Santo Estevao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.085639', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3808, NULL, 3808, 'Santo Expedito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.870137', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4982, NULL, 4982, 'Santo Expedito do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.157362', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2948, NULL, 2948, 'Santo Hipolito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.924169', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4250, NULL, 4250, 'Santo Inacio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.360623', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (848, NULL, 848, 'Santo Inacio do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.638737', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3809, NULL, 3809, 'Santopolis do Aguapei', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.871076', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3810, NULL, 3810, 'Santos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.872026', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2949, NULL, 2949, 'Santos Dumont', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.925463', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1050, NULL, 1050, 'Sao Benedito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.861601', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (619, NULL, 619, 'Sao Benedito do Rio Preto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.384567', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1612, NULL, 1612, 'Sao Benedito do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.47664', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1417, NULL, 1417, 'Sao Bentinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.266426', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (620, NULL, 620, 'Sao Bento', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.385444', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1418, NULL, 1418, 'Sao Bento', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.26724', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2950, NULL, 2950, 'Sao Bento Abade', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.926405', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1199, NULL, 1199, 'Sao Bento do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.024666', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3811, NULL, 3811, 'Sao Bento do Sapucai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.873071', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4545, NULL, 4545, 'Sao Bento do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.681233', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (431, NULL, 431, 'Sao Bento do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.17523', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1200, NULL, 1200, 'Sao Bento do Trairi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.025598', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1613, NULL, 1613, 'Sao Bento do Una', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.477417', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4546, NULL, 4546, 'Sao Bernardino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.682107', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (621, NULL, 621, 'Sao Bernardo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.386272', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3812, NULL, 3812, 'Sao Bernardo do Campo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.873885', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4547, NULL, 4547, 'Sao Bonifacio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.683118', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4983, NULL, 4983, 'Sao Borja', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.158226', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1736, NULL, 1736, 'Sao Bras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.60638', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2951, NULL, 2951, 'Sao Bras do Suacui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.927261', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (849, NULL, 849, 'Sao Braz do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.640018', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (266, NULL, 266, 'Sao Caetano de Odivelas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.997262', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3813, NULL, 3813, 'Sao Caetano do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.874902', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1614, NULL, 1614, 'Sao Caitano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.478275', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3814, NULL, 3814, 'Sao Carlos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.882174', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4251, NULL, 4251, 'Sao Carlos do Ivai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.361502', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1816, NULL, 1816, 'Sao Cristovao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.690023', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4549, NULL, 4549, 'Sao Cristovao do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.684896', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2177, NULL, 2177, 'Sao Desiderio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.086513', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2178, NULL, 2178, 'Sao Domingos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.087428', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5531, NULL, 5531, 'Sao Domingos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.77252', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4550, NULL, 4550, 'Sao Domingos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.685665', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1817, NULL, 1817, 'Sao Domingos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.690888', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2952, NULL, 2952, 'Sao Domingos das Dores', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.928137', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (267, NULL, 267, 'Sao Domingos do Araguaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.998092', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (622, NULL, 622, 'Sao Domingos do Azeitao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.388381', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (268, NULL, 268, 'Sao Domingos do Capim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.999037', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1420, NULL, 1420, 'Sao Domingos do Cariri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.269057', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (623, NULL, 623, 'Sao Domingos do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.395118', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3160, NULL, 3160, 'Sao Domingos do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.154905', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2953, NULL, 2953, 'Sao Domingos do Prata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.928974', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4984, NULL, 4984, 'Sao Domingos do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.159172', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2179, NULL, 2179, 'Sao Felipe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.088306', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2180, NULL, 2180, 'Sao Felix', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.089086', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (624, NULL, 624, 'Sao Felix de Balsas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.39616', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2954, NULL, 2954, 'Sao Felix de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.929859', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5296, NULL, 5296, 'Sao Felix do Araguaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.503103', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2181, NULL, 2181, 'Sao Felix do Coribe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.089995', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (850, NULL, 850, 'Sao Felix do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.641003', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (432, NULL, 432, 'Sao Felix do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.176102', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (269, NULL, 269, 'Sao Felix do Xingu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.999952', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1201, NULL, 1201, 'Sao Fernando', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.026479', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3244, NULL, 3244, 'Sao Fidelis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.244209', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3815, NULL, 3815, 'Sao Francisco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.883328', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2955, NULL, 2955, 'Sao Francisco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.930685', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1421, NULL, 1421, 'Sao Francisco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.269946', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1818, NULL, 1818, 'Sao Francisco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.691767', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4985, NULL, 4985, 'Sao Francisco de Assis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.160002', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (851, NULL, 851, 'Sao Francisco de Assis do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.641974', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5532, NULL, 5532, 'Sao Francisco de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.773455', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3245, NULL, 3245, 'Sao Francisco de Itabapoana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.244999', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2956, NULL, 2956, 'Sao Francisco de Paula', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.931488', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4986, NULL, 4986, 'Sao Francisco de Paula', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.160916', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2957, NULL, 2957, 'Sao Francisco de Sales', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.932267', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (625, NULL, 625, 'Sao Francisco do Brejao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.397025', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2182, NULL, 2182, 'Sao Francisco do Conde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.09092', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2958, NULL, 2958, 'Sao Francisco do Gloria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.933213', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (44, NULL, 44, 'Sao Francisco do Guapore', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.747752', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (626, NULL, 626, 'Sao Francisco do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.398044', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1202, NULL, 1202, 'Sao Francisco do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.027777', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (270, NULL, 270, 'Sao Francisco do Para', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.001019', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (852, NULL, 852, 'Sao Francisco do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.642905', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4551, NULL, 4551, 'Sao Francisco do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.686536', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2183, NULL, 2183, 'Sao Gabriel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.091797', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4987, NULL, 4987, 'Sao Gabriel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.161758', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (125, NULL, 125, 'Sao Gabriel da Cachoeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.836046', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3161, NULL, 3161, 'Sao Gabriel da Palha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.15581', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5167, NULL, 5167, 'Sao Gabriel do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.362003', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2959, NULL, 2959, 'Sao Geraldo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.934103', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2960, NULL, 2960, 'Sao Geraldo da Piedade', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.935011', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (271, NULL, 271, 'Sao Geraldo do Araguaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.001861', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2961, NULL, 2961, 'Sao Geraldo do Baixio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.935934', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3246, NULL, 3246, 'Sao Goncalo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.245904', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2962, NULL, 2962, 'Sao Goncalo do Abaete', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.936778', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1203, NULL, 1203, 'Sao Goncalo do Amarante', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.028644', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1051, NULL, 1051, 'Sao Goncalo do Amarante', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.862529', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (853, NULL, 853, 'Sao Goncalo do Gurgueia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.643859', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2963, NULL, 2963, 'Sao Goncalo do Para', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.944008', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (854, NULL, 854, 'Sao Goncalo do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.644778', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2964, NULL, 2964, 'Sao Goncalo do Rio Abaixo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.945446', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2965, NULL, 2965, 'Sao Goncalo do Rio Preto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.947525', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2966, NULL, 2966, 'Sao Goncalo do Sapucai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.948415', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2184, NULL, 2184, 'Sao Goncalo dos Campos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.092756', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2967, NULL, 2967, 'Sao Gotardo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.949358', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4988, NULL, 4988, 'Sao Jeronimo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.162555', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4252, NULL, 4252, 'Sao Jeronimo da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.362324', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4253, NULL, 4253, 'Sao Joao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.363192', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1615, NULL, 1615, 'Sao Joao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.479132', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4552, NULL, 4552, 'Sao Joao Batista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.687673', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (627, NULL, 627, 'Sao Joao Batista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.39892', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2968, NULL, 2968, 'Sao Joao Batista do Gloria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.950284', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5534, NULL, 5534, 'Sao Joao D''alianca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.775239', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (148, NULL, 148, 'Sao Joao da Baliza', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.864648', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3247, NULL, 3247, 'Sao Joao da Barra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.24683', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3816, NULL, 3816, 'Sao Joao da Boa Vista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.884221', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (855, NULL, 855, 'Sao Joao da Canabrava', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.645729', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (856, NULL, 856, 'Sao Joao da Fronteira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.646746', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2969, NULL, 2969, 'Sao Joao da Lagoa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.951373', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2970, NULL, 2970, 'Sao Joao da Mata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.952414', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5533, NULL, 5533, 'Sao Joao da Parauna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.774354', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (272, NULL, 272, 'Sao Joao da Ponta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.002762', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2971, NULL, 2971, 'Sao Joao da Ponte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.95334', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (857, NULL, 857, 'Sao Joao da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.64776', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4989, NULL, 4989, 'Sao Joao da Urtiga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.163489', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (858, NULL, 858, 'Sao Joao da Varjota', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.648584', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3817, NULL, 3817, 'Sao Joao das Duas Pontes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.8851', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2972, NULL, 2972, 'Sao Joao das Missoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.954242', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3818, NULL, 3818, 'Sao Joao de Iracema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.885978', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3248, NULL, 3248, 'Sao Joao de Meriti', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.24777', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (273, NULL, 273, 'Sao Joao de Pirabas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.003681', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2973, NULL, 2973, 'Sao Joao Del Rei', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.955094', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (274, NULL, 274, 'Sao Joao do Araguaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.004606', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (859, NULL, 859, 'Sao Joao do Arraial', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.649445', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4254, NULL, 4254, 'Sao Joao do Caiua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.364281', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1422, NULL, 1422, 'Sao Joao do Cariri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.270871', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (628, NULL, 628, 'Sao Joao do Caru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.399745', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4553, NULL, 4553, 'Sao Joao do Itaperiu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.688602', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4255, NULL, 4255, 'Sao Joao do Ivai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.365215', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1052, NULL, 1052, 'Sao Joao do Jaguaribe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.863447', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2974, NULL, 2974, 'Sao Joao do Manhuacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.955927', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2975, NULL, 2975, 'Sao Joao do Manteninha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.956767', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4554, NULL, 4554, 'Sao Joao do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.689546', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2976, NULL, 2976, 'Sao Joao do Oriente', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.957553', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2977, NULL, 2977, 'Sao Joao do Pacui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.958462', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (629, NULL, 629, 'Sao Joao do Paraiso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.400816', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2978, NULL, 2978, 'Sao Joao do Paraiso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.959259', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3819, NULL, 3819, 'Sao Joao do Pau D''alho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.886912', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (860, NULL, 860, 'Sao Joao do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.65029', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4990, NULL, 4990, 'Sao Joao do Polesine', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.164452', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1423, NULL, 1423, 'Sao Joao do Rio do Peixe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.271743', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1204, NULL, 1204, 'Sao Joao do Sabugi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.029513', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (630, NULL, 630, 'Sao Joao do Soter', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.401759', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4555, NULL, 4555, 'Sao Joao do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.690449', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1424, NULL, 1424, 'Sao Joao do Tigre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.272737', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4256, NULL, 4256, 'Sao Joao do Triunfo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.366215', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (631, NULL, 631, 'Sao Joao dos Patos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.402956', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2979, NULL, 2979, 'Sao Joao Evangelista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.960178', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2980, NULL, 2980, 'Sao Joao Nepomuceno', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.961059', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4556, NULL, 4556, 'Sao Joaquim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.691291', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3820, NULL, 3820, 'Sao Joaquim da Barra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.88779', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2981, NULL, 2981, 'Sao Joaquim de Bicas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.962029', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1616, NULL, 1616, 'Sao Joaquim do Monte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.479973', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4991, NULL, 4991, 'Sao Jorge', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.165471', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4259, NULL, 4259, 'Sao Jorge D''oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.368953', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4257, NULL, 4257, 'Sao Jorge do Ivai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.367092', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4258, NULL, 4258, 'Sao Jorge do Patrocinio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.368034', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4557, NULL, 4557, 'Sao Jose', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.692211', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2982, NULL, 2982, 'Sao Jose da Barra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.962922', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3821, NULL, 3821, 'Sao Jose da Bela Vista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.888824', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4260, NULL, 4260, 'Sao Jose da Boa Vista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.369834', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1617, NULL, 1617, 'Sao Jose da Coroa Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.48086', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1425, NULL, 1425, 'Sao Jose da Lagoa Tapada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.273614', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1737, NULL, 1737, 'Sao Jose da Laje', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.607218', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2983, NULL, 2983, 'Sao Jose da Lapa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.963826', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2984, NULL, 2984, 'Sao Jose da Safira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.964717', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1738, NULL, 1738, 'Sao Jose da Tapera', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.608123', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2985, NULL, 2985, 'Sao Jose da Varginha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.965573', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2185, NULL, 2185, 'Sao Jose da Vitoria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.093833', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4992, NULL, 4992, 'Sao Jose das Missoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.166514', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4261, NULL, 4261, 'Sao Jose das Palmeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.370542', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1426, NULL, 1426, 'Sao Jose de Caiana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.274688', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1427, NULL, 1427, 'Sao Jose de Espinharas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.27563', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1205, NULL, 1205, 'Sao Jose de Mipibu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.03041', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1428, NULL, 1428, 'Sao Jose de Piranhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.276506', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1429, NULL, 1429, 'Sao Jose de Princesa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.277443', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (632, NULL, 632, 'Sao Jose de Ribamar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.403809', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3249, NULL, 3249, 'Sao Jose de Uba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.248945', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2986, NULL, 2986, 'Sao Jose do Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.966464', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3822, NULL, 3822, 'Sao Jose do Barreiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.889708', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1618, NULL, 1618, 'Sao Jose do Belmonte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.481801', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1430, NULL, 1430, 'Sao Jose do Bonfim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.278377', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1431, NULL, 1431, 'Sao Jose do Brejo do Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.279212', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3162, NULL, 3162, 'Sao Jose do Calcado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.156713', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1206, NULL, 1206, 'Sao Jose do Campestre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.031271', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4558, NULL, 4558, 'Sao Jose do Cedro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.693112', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4559, NULL, 4559, 'Sao Jose do Cerrito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.694047', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2987, NULL, 2987, 'Sao Jose do Divino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.967302', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (861, NULL, 861, 'Sao Jose do Divino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.65123', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1619, NULL, 1619, 'Sao Jose do Egito', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.482835', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2988, NULL, 2988, 'Sao Jose do Goiabal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.968161', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4993, NULL, 4993, 'Sao Jose do Herval', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.167402', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4994, NULL, 4994, 'Sao Jose do Hortencio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.168302', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4995, NULL, 4995, 'Sao Jose do Inhacora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.169448', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2186, NULL, 2186, 'Sao Jose do Jacuipe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.094768', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2989, NULL, 2989, 'Sao Jose do Jacuri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.969054', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2990, NULL, 2990, 'Sao Jose do Mantimento', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.970124', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4996, NULL, 4996, 'Sao Jose do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.170483', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4997, NULL, 4997, 'Sao Jose do Ouro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.171355', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (862, NULL, 862, 'Sao Jose do Peixe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.652159', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (863, NULL, 863, 'Sao Jose do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.653052', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5297, NULL, 5297, 'Sao Jose do Povo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.504015', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5298, NULL, 5298, 'Sao Jose do Rio Claro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.504954', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3823, NULL, 3823, 'Sao Jose do Rio Pardo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.890643', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3824, NULL, 3824, 'Sao Jose do Rio Preto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.891636', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1432, NULL, 1432, 'Sao Jose do Sabugi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.280095', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1207, NULL, 1207, 'Sao Jose do Serido', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.032197', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4998, NULL, 4998, 'Sao Jose do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.172279', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3250, NULL, 3250, 'Sao Jose do Vale do Rio Preto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.249825', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5299, NULL, 5299, 'Sao Jose do Xingu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.505931', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4999, NULL, 4999, 'Sao Jose dos Ausentes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.173227', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (633, NULL, 633, 'Sao Jose dos Basilios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.404643', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3825, NULL, 3825, 'Sao Jose dos Campos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.892511', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1433, NULL, 1433, 'Sao Jose dos Cordeiros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.280958', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4262, NULL, 4262, 'Sao Jose dos Pinhais', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.371509', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5300, NULL, 5300, 'Sao Jose dos Quatro Marcos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.506858', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1434, NULL, 1434, 'Sao Jose dos Ramos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.281823', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (864, NULL, 864, 'Sao Juliao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.654041', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5000, NULL, 5000, 'Sao Leopoldo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.174112', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2991, NULL, 2991, 'Sao Lourenco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.97104', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1620, NULL, 1620, 'Sao Lourenco da Mata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.48371', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3826, NULL, 3826, 'Sao Lourenco da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.893511', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4560, NULL, 4560, 'Sao Lourenco do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.694964', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (865, NULL, 865, 'Sao Lourenco do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.654978', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5001, NULL, 5001, 'Sao Lourenco do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.175066', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4561, NULL, 4561, 'Sao Ludgero', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.695892', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (634, NULL, 634, 'Sao Luis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.405647', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5535, NULL, 5535, 'Sao Luis de Montes Belos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.77614', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1053, NULL, 1053, 'Sao Luis do Curu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.864358', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3827, NULL, 3827, 'Sao Luis do Paraitinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.89439', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (866, NULL, 866, 'Sao Luis do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.655997', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1739, NULL, 1739, 'Sao Luis do Quitunde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.609231', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (635, NULL, 635, 'Sao Luis Gonzaga do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.40646', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (149, NULL, 149, 'Sao Luiz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.865518', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5536, NULL, 5536, 'Sao Luiz do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.776981', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5002, NULL, 5002, 'Sao Luiz Gonzaga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.176058', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1435, NULL, 1435, 'Sao Mamede', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.282705', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4263, NULL, 4263, 'Sao Manoel do Parana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.372312', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3828, NULL, 3828, 'Sao Manuel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.89529', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5003, NULL, 5003, 'Sao Marcos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.176959', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5004, NULL, 5004, 'Sao Martinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.177897', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4562, NULL, 4562, 'Sao Martinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.696805', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5005, NULL, 5005, 'Sao Martinho da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.178867', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3163, NULL, 3163, 'Sao Mateus', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.157706', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (636, NULL, 636, 'Sao Mateus do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.407324', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4264, NULL, 4264, 'Sao Mateus do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.37923', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1208, NULL, 1208, 'Sao Miguel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.03317', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3829, NULL, 3829, 'Sao Miguel Arcanjo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.89607', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (867, NULL, 867, 'Sao Miguel da Baixa Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.656848', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4563, NULL, 4563, 'Sao Miguel da Boa Vista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.704183', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2187, NULL, 2187, 'Sao Miguel das Matas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.095662', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5006, NULL, 5006, 'Sao Miguel das Missoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.17986', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1436, NULL, 1436, 'Sao Miguel de Taipu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.283547', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1819, NULL, 1819, 'Sao Miguel do Aleixo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.692583', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2992, NULL, 2992, 'Sao Miguel do Anta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.971941', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5537, NULL, 5537, 'Sao Miguel do Araguaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.777896', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (868, NULL, 868, 'Sao Miguel do Fidalgo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.657708', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1209, NULL, 1209, 'Sao Miguel do Gostoso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.034112', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (275, NULL, 275, 'Sao Miguel do Guama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.005566', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (45, NULL, 45, 'Sao Miguel do Guapore', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.748533', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4265, NULL, 4265, 'Sao Miguel do Iguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.380624', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4564, NULL, 4564, 'Sao Miguel do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.705337', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5538, NULL, 5538, 'Sao Miguel do Passa Quatro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.778808', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (869, NULL, 869, 'Sao Miguel do Tapuio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.658591', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (433, NULL, 433, 'Sao Miguel do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.177106', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1740, NULL, 1740, 'Sao Miguel dos Campos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.610109', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1741, NULL, 1741, 'Sao Miguel dos Milagres', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.610971', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5007, NULL, 5007, 'Sao Nicolau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.180803', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5539, NULL, 5539, 'Sao Patricio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.779725', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5008, NULL, 5008, 'Sao Paulo das Missoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.181651', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (126, NULL, 126, 'Sao Paulo de Olivenca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.836988', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1210, NULL, 1210, 'Sao Paulo do Potengi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.035023', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1211, NULL, 1211, 'Sao Pedro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.035951', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3831, NULL, 3831, 'Sao Pedro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.898029', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (637, NULL, 637, 'Sao Pedro da Agua Branca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.408245', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3251, NULL, 3251, 'Sao Pedro da Aldeia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.250587', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5301, NULL, 5301, 'Sao Pedro da Cipa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.507799', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5009, NULL, 5009, 'Sao Pedro da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.18264', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2993, NULL, 2993, 'Sao Pedro da Uniao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.972841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5010, NULL, 5010, 'Sao Pedro das Missoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.183578', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4565, NULL, 4565, 'Sao Pedro de Alcantara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.706219', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5011, NULL, 5011, 'Sao Pedro do Butia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.184568', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4266, NULL, 4266, 'Sao Pedro do Iguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.381553', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4267, NULL, 4267, 'Sao Pedro do Ivai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.382512', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4268, NULL, 4268, 'Sao Pedro do Parana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.383505', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (870, NULL, 870, 'Sao Pedro do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.659708', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2994, NULL, 2994, 'Sao Pedro do Suacui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.973711', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5012, NULL, 5012, 'Sao Pedro do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.191638', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3832, NULL, 3832, 'Sao Pedro do Turvo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.898933', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (638, NULL, 638, 'Sao Pedro dos Crentes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.409364', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2995, NULL, 2995, 'Sao Pedro dos Ferros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.974488', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1212, NULL, 1212, 'Sao Rafael', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.03703', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (639, NULL, 639, 'Sao Raimundo das Mangabeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.410289', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (640, NULL, 640, 'Sao Raimundo do Doca Bezerra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.411219', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (871, NULL, 871, 'Sao Raimundo Nonato', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.660725', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (641, NULL, 641, 'Sao Roberto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.412187', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2996, NULL, 2996, 'Sao Romao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.975409', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3833, NULL, 3833, 'Sao Roque', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.899785', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2997, NULL, 2997, 'Sao Roque de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.976377', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3164, NULL, 3164, 'Sao Roque do Canaa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.158648', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (434, NULL, 434, 'Sao Salvador do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.18496', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1742, NULL, 1742, 'Sao Sebastiao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.611868', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3834, NULL, 3834, 'Sao Sebastiao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.900715', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4269, NULL, 4269, 'Sao Sebastiao da Amoreira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.384423', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2998, NULL, 2998, 'Sao Sebastiao da Bela Vista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.977178', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (276, NULL, 276, 'Sao Sebastiao da Boa Vista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.006395', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3835, NULL, 3835, 'Sao Sebastiao da Grama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.901548', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2999, NULL, 2999, 'Sao Sebastiao da Vargem Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.97811', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1437, NULL, 1437, 'Sao Sebastiao de Lagoa de Roca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.290398', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3252, NULL, 3252, 'Sao Sebastiao do Alto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.251419', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3000, NULL, 3000, 'Sao Sebastiao do Anta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.984627', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5013, NULL, 5013, 'Sao Sebastiao do Cai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.192927', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3001, NULL, 3001, 'Sao Sebastiao do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.985785', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3002, NULL, 3002, 'Sao Sebastiao do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.986709', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3003, NULL, 3003, 'Sao Sebastiao do Paraiso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.987623', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2188, NULL, 2188, 'Sao Sebastiao do Passe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.096542', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3004, NULL, 3004, 'Sao Sebastiao do Rio Preto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.988553', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3005, NULL, 3005, 'Sao Sebastiao do Rio Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.989525', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (435, NULL, 435, 'Sao Sebastiao do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.186102', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (127, NULL, 127, 'Sao Sebastiao do Uatuma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.837813', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1438, NULL, 1438, 'Sao Sebastiao do Umbuzeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.291562', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5014, NULL, 5014, 'Sao Sepe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.193953', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3836, NULL, 3836, 'Sao Simao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.902471', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5540, NULL, 5540, 'Sao Simao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.780665', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3006, NULL, 3006, 'Sao Thome das Letras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.990503', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3007, NULL, 3007, 'Sao Tiago', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.991371', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3008, NULL, 3008, 'Sao Tomas de Aquino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.992485', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1213, NULL, 1213, 'Sao Tome', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.037977', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4270, NULL, 4270, 'Sao Tome', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.38532', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5015, NULL, 5015, 'Sao Valentim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.194793', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5016, NULL, 5016, 'Sao Valentim do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.195665', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5017, NULL, 5017, 'Sao Valerio do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.196491', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5018, NULL, 5018, 'Sao Vendelino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.197532', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3837, NULL, 3837, 'Sao Vicente', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.903454', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1214, NULL, 1214, 'Sao Vicente', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.039135', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3009, NULL, 3009, 'Sao Vicente de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.993316', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1439, NULL, 1439, 'Sao Vicente do Serido', '10', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.292442', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5019, NULL, 5019, 'Sao Vicente do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.198462', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (642, NULL, 642, 'Sao Vicente Ferrer', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.413132', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1621, NULL, 1621, 'Sao Vicente Ferrer', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.484603', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1440, NULL, 1440, 'Sape', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.293434', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2189, NULL, 2189, 'Sapeacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.09736', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5302, NULL, 5302, 'Sapezal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.508718', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5020, NULL, 5020, 'Sapiranga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.199365', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4271, NULL, 4271, 'Sapopema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.386212', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3010, NULL, 3010, 'Sapucai-mirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.994126', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3253, NULL, 3253, 'Sapucaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.252236', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (277, NULL, 277, 'Sapucaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.007271', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5021, NULL, 5021, 'Sapucaia do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.200245', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3254, NULL, 3254, 'Saquarema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.253149', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5022, NULL, 5022, 'Sarandi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.201335', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4272, NULL, 4272, 'Sarandi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.38714', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3838, NULL, 3838, 'Sarapui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.904302', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3011, NULL, 3011, 'Sardoa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.995033', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3839, NULL, 3839, 'Sarutaia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.905087', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3012, NULL, 3012, 'Sarzedo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.995979', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2190, NULL, 2190, 'Satiro Dias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.09819', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1743, NULL, 1743, 'Satuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.612769', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (643, NULL, 643, 'Satubinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.414213', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2191, NULL, 2191, 'Saubara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.099108', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4273, NULL, 4273, 'Saudade do Iguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.388048', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4566, NULL, 4566, 'Saudades', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.707271', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2192, NULL, 2192, 'Saude', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.100012', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4567, NULL, 4567, 'Schroeder', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.708028', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2193, NULL, 2193, 'Seabra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.100826', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4568, NULL, 4568, 'Seara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.70891', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3840, NULL, 3840, 'Sebastianopolis do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.906039', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (872, NULL, 872, 'Sebastiao Barros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.661633', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2194, NULL, 2194, 'Sebastiao Laranjeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.101718', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (873, NULL, 873, 'Sebastiao Leal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.662743', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5023, NULL, 5023, 'Seberi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.202194', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5024, NULL, 5024, 'Sede Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.203247', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5025, NULL, 5025, 'Segredo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.204153', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5026, NULL, 5026, 'Selbach', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.205013', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5168, NULL, 5168, 'Selviria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.362991', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (71, NULL, 71, 'Sena Madureira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.779501', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (644, NULL, 644, 'Senador Alexandre Costa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.41502', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3014, NULL, 3014, 'Senador Amaral', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.997785', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5541, NULL, 5541, 'Senador Canedo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.7816', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3015, NULL, 3015, 'Senador Cortes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.998572', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1215, NULL, 1215, 'Senador Eloi de Souza', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.045963', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3016, NULL, 3016, 'Senador Firmino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.999432', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1216, NULL, 1216, 'Senador Georgino Avelino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.047205', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (72, NULL, 72, 'Senador Guiomard', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.780338', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3017, NULL, 3017, 'Senador Jose Bento', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.000242', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (278, NULL, 278, 'Senador Jose Porfirio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.008163', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (645, NULL, 645, 'Senador La Rocque', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.416003', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3018, NULL, 3018, 'Senador Modestino Goncalves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.001181', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1054, NULL, 1054, 'Senador Pompeu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.865343', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1744, NULL, 1744, 'Senador Rui Palmeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.61364', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1055, NULL, 1055, 'Senador Sa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.866271', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5027, NULL, 5027, 'Senador Salgado Filho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.205893', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4274, NULL, 4274, 'Senges', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.388983', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2195, NULL, 2195, 'Senhor do Bonfim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.102614', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3019, NULL, 3019, 'Senhora de Oliveira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.002238', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3020, NULL, 3020, 'Senhora do Porto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.003123', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3021, NULL, 3021, 'Senhora dos Remedios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.003942', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5028, NULL, 5028, 'Sentinela do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.206792', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2196, NULL, 2196, 'Sento Se', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.103547', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5029, NULL, 5029, 'Serafina Correa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.207836', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3022, NULL, 3022, 'Sericita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.004806', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (46, NULL, 46, 'Seringueiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.749422', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5030, NULL, 5030, 'Serio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.208802', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3023, NULL, 3023, 'Seritinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.00583', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3255, NULL, 3255, 'Seropedica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.254076', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3165, NULL, 3165, 'Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.159594', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4569, NULL, 4569, 'Serra Alta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.709735', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3841, NULL, 3841, 'Serra Azul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.907223', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3024, NULL, 3024, 'Serra Azul de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.006724', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1441, NULL, 1441, 'Serra Branca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.294291', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1442, NULL, 1442, 'Serra da Raiz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.295204', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3025, NULL, 3025, 'Serra da Saudade', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.007597', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1217, NULL, 1217, 'Serra de Sao Bento', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.048251', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1218, NULL, 1218, 'Serra do Mel', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.049257', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (307, NULL, 307, 'Serra do Navio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.041419', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2197, NULL, 2197, 'Serra do Ramalho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.10448', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3026, NULL, 3026, 'Serra do Salitre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.008494', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3027, NULL, 3027, 'Serra dos Aimores', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.00936', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2198, NULL, 2198, 'Serra Dourada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.105375', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1443, NULL, 1443, 'Serra Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.29615', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3842, NULL, 3842, 'Serra Negra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.907989', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1219, NULL, 1219, 'Serra Negra do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.050121', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5303, NULL, 5303, 'Serra Nova Dourada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.509707', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2199, NULL, 2199, 'Serra Preta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.106273', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1444, NULL, 1444, 'Serra Redonda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.296925', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1622, NULL, 1622, 'Serra Talhada', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.485455', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3843, NULL, 3843, 'Serrana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.908962', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3028, NULL, 3028, 'Serrania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.010257', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (646, NULL, 646, 'Serrano do Maranhao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.416907', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5542, NULL, 5542, 'Serranopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.78277', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3029, NULL, 3029, 'Serranopolis de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.011126', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4275, NULL, 4275, 'Serranopolis do Iguacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.389954', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3030, NULL, 3030, 'Serranos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.011947', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1445, NULL, 1445, 'Serraria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.297727', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2200, NULL, 2200, 'Serrinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.107175', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1220, NULL, 1220, 'Serrinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.051006', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1221, NULL, 1221, 'Serrinha dos Pintos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.052384', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1623, NULL, 1623, 'Serrita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.486433', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3031, NULL, 3031, 'Serro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.012745', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2201, NULL, 2201, 'Serrolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.108078', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4276, NULL, 4276, 'Sertaneja', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.390851', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1624, NULL, 1624, 'Sertania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.487232', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4277, NULL, 4277, 'Sertanopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.391827', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5031, NULL, 5031, 'Sertao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.209619', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5032, NULL, 5032, 'Sertao Santana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.210595', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1446, NULL, 1446, 'Sertaozinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.298636', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3844, NULL, 3844, 'Sertaozinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.909863', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3845, NULL, 3845, 'Sete Barras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.910813', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5033, NULL, 5033, 'Sete de Setembro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.211625', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3032, NULL, 3032, 'Sete Lagoas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.013654', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5169, NULL, 5169, 'Sete Quedas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.363971', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3033, NULL, 3033, 'Setubinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.014708', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5034, NULL, 5034, 'Severiano de Almeida', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.21262', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1222, NULL, 1222, 'Severiano Melo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.053323', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3846, NULL, 3846, 'Severinia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.911767', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4570, NULL, 4570, 'Sideropolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.710532', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5170, NULL, 5170, 'Sidrolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.364965', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (874, NULL, 874, 'Sigefredo Pacheco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.663614', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3256, NULL, 3256, 'Silva Jardim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.254876', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5543, NULL, 5543, 'Silvania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.783748', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (437, NULL, 437, 'Silvanopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.187777', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5035, NULL, 5035, 'Silveira Martins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.213555', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3034, NULL, 3034, 'Silveirania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.015627', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3847, NULL, 3847, 'Silveiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.912684', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (128, NULL, 128, 'Silves', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.838766', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3035, NULL, 3035, 'Silvianopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.016489', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1820, NULL, 1820, 'Simao Dias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.693538', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3036, NULL, 3036, 'Simao Pereira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.017459', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (875, NULL, 875, 'Simoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.664475', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2202, NULL, 2202, 'Simoes Filho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.108929', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5544, NULL, 5544, 'Simolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.784751', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3037, NULL, 3037, 'Simonesia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.018331', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (876, NULL, 876, 'Simplicio Mendes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.665361', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5036, NULL, 5036, 'Sinimbu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.21458', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5304, NULL, 5304, 'Sinop', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.510666', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4278, NULL, 4278, 'Siqueira Campos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.392833', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1625, NULL, 1625, 'Sirinhaem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.48815', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1821, NULL, 1821, 'Siriri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.694316', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5545, NULL, 5545, 'Sitio D''abadia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.785701', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2203, NULL, 2203, 'Sitio do Mato', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.109993', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2204, NULL, 2204, 'Sitio do Quinto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.11146', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (647, NULL, 647, 'Sitio Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.417788', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1223, NULL, 1223, 'Sitio Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.05422', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (438, NULL, 438, 'Sitio Novo do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.188758', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5037, NULL, 5037, 'Sobradinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.215477', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2205, NULL, 2205, 'Sobradinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.112381', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1447, NULL, 1447, 'Sobrado', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.299495', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1056, NULL, 1056, 'Sobral', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.86725', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3038, NULL, 3038, 'Sobralia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.024929', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3848, NULL, 3848, 'Socorro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.913618', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (877, NULL, 877, 'Socorro do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.666288', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1448, NULL, 1448, 'Solanea', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.300403', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1449, NULL, 1449, 'Soledade', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.301233', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5038, NULL, 5038, 'Soledade', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.216332', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3039, NULL, 3039, 'Soledade de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.026211', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1626, NULL, 1626, 'Solidao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.489012', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1057, NULL, 1057, 'Solonopole', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.868244', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4571, NULL, 4571, 'Sombrio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.711816', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5171, NULL, 5171, 'Sonora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.366069', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3166, NULL, 3166, 'Sooretama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.160485', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3849, NULL, 3849, 'Sorocaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.914527', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5305, NULL, 5305, 'Sorriso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.51148', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1450, NULL, 1450, 'Sossego', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.302085', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (279, NULL, 279, 'Soure', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.009091', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1451, NULL, 1451, 'Sousa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.302975', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2206, NULL, 2206, 'Souto Soares', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.113153', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (439, NULL, 439, 'Sucupira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.189661', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (648, NULL, 648, 'Sucupira do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.418657', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (649, NULL, 649, 'Sucupira do Riachao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.419524', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3850, NULL, 3850, 'Sud Mennucci', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.915419', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4572, NULL, 4572, 'Sul Brasil', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.712836', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4279, NULL, 4279, 'Sulina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.393627', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3851, NULL, 3851, 'Sumare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.923764', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1452, NULL, 1452, 'Sume', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.303766', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3257, NULL, 3257, 'Sumidouro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.255796', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1627, NULL, 1627, 'Surubim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.489863', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (878, NULL, 878, 'Sussuapara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.667165', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3852, NULL, 3852, 'Suzanapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.924737', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3853, NULL, 3853, 'Suzano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.925611', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5039, NULL, 5039, 'Tabai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.21724', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5306, NULL, 5306, 'Tabapora', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.51804', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3854, NULL, 3854, 'Tabapua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.926641', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3855, NULL, 3855, 'Tabatinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.92753', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (129, NULL, 129, 'Tabatinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.839732', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1628, NULL, 1628, 'Tabira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.490792', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3856, NULL, 3856, 'Taboao da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.928379', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2207, NULL, 2207, 'Tabocas do Brejo Velho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.113976', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1224, NULL, 1224, 'Taboleiro Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.055116', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3040, NULL, 3040, 'Tabuleiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.027116', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1058, NULL, 1058, 'Tabuleiro do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.869195', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1629, NULL, 1629, 'Tacaimbo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.491684', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1630, NULL, 1630, 'Tacaratu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.492321', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3857, NULL, 3857, 'Taciba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.929364', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5172, NULL, 5172, 'Tacuru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.366911', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3858, NULL, 3858, 'Taguai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.930327', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (440, NULL, 440, 'Taguatinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.190463', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3859, NULL, 3859, 'Taiacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.931198', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (280, NULL, 280, 'Tailandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.010067', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4573, NULL, 4573, 'Taio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.713717', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3041, NULL, 3041, 'Taiobeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.027909', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (441, NULL, 441, 'Taipas do Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.191273', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1225, NULL, 1225, 'Taipu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.055992', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3860, NULL, 3860, 'Taiuva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.932199', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (442, NULL, 442, 'Talisma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.192128', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1631, NULL, 1631, 'Tamandare', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.49933', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4280, NULL, 4280, 'Tamarana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.394497', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3861, NULL, 3861, 'Tambau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.933029', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4281, NULL, 4281, 'Tamboara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.395464', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1059, NULL, 1059, 'Tamboril', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.87011', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (879, NULL, 879, 'Tamboril do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.668103', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3862, NULL, 3862, 'Tanabi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.933885', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1226, NULL, 1226, 'Tangara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.056821', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4574, NULL, 4574, 'Tangara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.714564', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5307, NULL, 5307, 'Tangara da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.51929', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3258, NULL, 3258, 'Tangua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.256693', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2208, NULL, 2208, 'Tanhacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.114785', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1745, NULL, 1745, 'Tanque D''arca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.621045', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (880, NULL, 880, 'Tanque do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.669016', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2209, NULL, 2209, 'Tanque Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.121459', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2210, NULL, 2210, 'Tanquinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.122594', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3042, NULL, 3042, 'Taparuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.028691', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (130, NULL, 130, 'Tapaua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.840639', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5040, NULL, 5040, 'Tapejara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.218094', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4282, NULL, 4282, 'Tapejara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.396622', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5041, NULL, 5041, 'Tapera', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.219034', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1453, NULL, 1453, 'Taperoa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.304635', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2211, NULL, 2211, 'Taperoa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.123519', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5042, NULL, 5042, 'Tapes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.219964', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3043, NULL, 3043, 'Tapira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.029455', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4283, NULL, 4283, 'Tapira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.397553', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3863, NULL, 3863, 'Tapirai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.934819', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3044, NULL, 3044, 'Tapirai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.030502', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2212, NULL, 2212, 'Tapiramuta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.124406', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3864, NULL, 3864, 'Tapiratiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.935627', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5308, NULL, 5308, 'Tapurah', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.520225', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5043, NULL, 5043, 'Taquara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.220879', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3045, NULL, 3045, 'Taquaracu de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.031405', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3865, NULL, 3865, 'Taquaral', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.936569', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5546, NULL, 5546, 'Taquaral de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.786631', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1746, NULL, 1746, 'Taquarana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.622171', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5044, NULL, 5044, 'Taquari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.221862', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3866, NULL, 3866, 'Taquaritinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.937462', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1632, NULL, 1632, 'Taquaritinga do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.500598', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3867, NULL, 3867, 'Taquarituba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.938413', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3868, NULL, 3868, 'Taquarivai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.939268', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5045, NULL, 5045, 'Taquarucu do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.222788', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5173, NULL, 5173, 'Taquarussu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.368294', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3869, NULL, 3869, 'Tarabai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.940097', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (73, NULL, 73, 'Tarauaca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.781279', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1060, NULL, 1060, 'Tarrafas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.871112', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (308, NULL, 308, 'Tartarugalzinho', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.042303', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3870, NULL, 3870, 'Taruma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.941071', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3046, NULL, 3046, 'Tarumirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.032341', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (650, NULL, 650, 'Tasso Fragoso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.420459', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3871, NULL, 3871, 'Tatui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.942017', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1061, NULL, 1061, 'Taua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.872086', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3872, NULL, 3872, 'Taubate', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.942943', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5046, NULL, 5046, 'Tavares', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.223707', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1454, NULL, 1454, 'Tavares', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.305527', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (131, NULL, 131, 'Tefe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.841614', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1455, NULL, 1455, 'Teixeira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.306383', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2213, NULL, 2213, 'Teixeira de Freitas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.125229', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4284, NULL, 4284, 'Teixeira Soares', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.398411', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3047, NULL, 3047, 'Teixeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.033084', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (47, NULL, 47, 'Teixeiropolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.750356', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1062, NULL, 1062, 'Tejucuoca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.873195', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3873, NULL, 3873, 'Tejupa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.94383', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4285, NULL, 4285, 'Telemaco Borba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.399685', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1822, NULL, 1822, 'Telha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.695302', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1227, NULL, 1227, 'Tenente Ananias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.057772', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1228, NULL, 1228, 'Tenente Laurentino Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.058756', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5047, NULL, 5047, 'Tenente Portela', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.225347', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1456, NULL, 1456, 'Tenorio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.3074', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3874, NULL, 3874, 'Teodoro Sampaio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.944695', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2214, NULL, 2214, 'Teodoro Sampaio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.126164', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2215, NULL, 2215, 'Teofilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.127128', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3048, NULL, 3048, 'Teofilo Otoni', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.034005', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2216, NULL, 2216, 'Teolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.128089', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1747, NULL, 1747, 'Teotonio Vilela', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.623156', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5174, NULL, 5174, 'Terenos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.369444', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (881, NULL, 881, 'Teresina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.670074', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5547, NULL, 5547, 'Teresina de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.787611', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3259, NULL, 3259, 'Teresopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.257579', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1633, NULL, 1633, 'Terezinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.501611', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5548, NULL, 5548, 'Terezopolis de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.788494', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (281, NULL, 281, 'Terra Alta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.01103', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4286, NULL, 4286, 'Terra Boa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.400592', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5048, NULL, 5048, 'Terra de Areia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.232849', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2217, NULL, 2217, 'Terra Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.129228', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1634, NULL, 1634, 'Terra Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.502516', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5309, NULL, 5309, 'Terra Nova do Norte', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.521047', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4287, NULL, 4287, 'Terra Rica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.401465', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3875, NULL, 3875, 'Terra Roxa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.945558', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4288, NULL, 4288, 'Terra Roxa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.402543', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (282, NULL, 282, 'Terra Santa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.012083', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5310, NULL, 5310, 'Tesouro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.521974', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5049, NULL, 5049, 'Teutonia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.234121', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (48, NULL, 48, 'Theobroma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.751289', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1063, NULL, 1063, 'Tiangua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.874116', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4289, NULL, 4289, 'Tibagi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.403763', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1229, NULL, 1229, 'Tibau', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.059823', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1230, NULL, 1230, 'Tibau do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.061144', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3876, NULL, 3876, 'Tiete', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.946495', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4575, NULL, 4575, 'Tigrinhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.715422', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4576, NULL, 4576, 'Tijucas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.716342', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4290, NULL, 4290, 'Tijucas do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.404751', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1635, NULL, 1635, 'Timbauba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.503375', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1231, NULL, 1231, 'Timbauba dos Batistas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.062201', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4577, NULL, 4577, 'Timbe do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.717364', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (651, NULL, 651, 'Timbiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.421346', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4578, NULL, 4578, 'Timbo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.718247', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4579, NULL, 4579, 'Timbo Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.719183', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3877, NULL, 3877, 'Timburi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.94729', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (652, NULL, 652, 'Timon', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.422227', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3049, NULL, 3049, 'Timoteo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.034877', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5050, NULL, 5050, 'Tio Hugo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.235123', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3050, NULL, 3050, 'Tiradentes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.035717', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5051, NULL, 5051, 'Tiradentes do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.23607', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3051, NULL, 3051, 'Tiros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.036438', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1823, NULL, 1823, 'Tobias Barreto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.696176', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (443, NULL, 443, 'Tocantinia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.193041', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (444, NULL, 444, 'Tocantinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.19396', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3052, NULL, 3052, 'Tocantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.037378', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3054, NULL, 3054, 'Toledo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.039162', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4291, NULL, 4291, 'Toledo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.405658', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1824, NULL, 1824, 'Tomar do Geru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.703912', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4292, NULL, 4292, 'Tomazina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.406592', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3055, NULL, 3055, 'Tombos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.040058', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (283, NULL, 283, 'Tome-acu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.012862', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (132, NULL, 132, 'Tonantins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.842553', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1636, NULL, 1636, 'Toritama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.504224', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5311, NULL, 5311, 'Torixoreu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.52294', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5052, NULL, 5052, 'Toropi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.236996', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3878, NULL, 3878, 'Torre de Pedra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.948168', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5053, NULL, 5053, 'Torres', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.237913', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3879, NULL, 3879, 'Torrinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.949077', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1232, NULL, 1232, 'Touros', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.063184', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3880, NULL, 3880, 'Trabiju', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.949993', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (284, NULL, 284, 'Tracuateua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.020208', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1637, NULL, 1637, 'Tracunhaem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.505121', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1748, NULL, 1748, 'Traipu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.624182', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (285, NULL, 285, 'Trairao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.021367', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1064, NULL, 1064, 'Trairi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.875052', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5054, NULL, 5054, 'Tramandai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.23885', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5055, NULL, 5055, 'Travesseiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.239806', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2218, NULL, 2218, 'Tremedal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.130582', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3881, NULL, 3881, 'Tremembe', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.950947', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5056, NULL, 5056, 'Tres Arroios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.240805', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4580, NULL, 4580, 'Tres Barras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.720092', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4293, NULL, 4293, 'Tres Barras do Parana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.407465', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5057, NULL, 5057, 'Tres Cachoeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.241777', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3056, NULL, 3056, 'Tres Coracoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.040906', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5058, NULL, 5058, 'Tres Coroas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.242724', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5059, NULL, 5059, 'Tres de Maio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.243769', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5060, NULL, 5060, 'Tres Forquilhas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.244655', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3882, NULL, 3882, 'Tres Fronteiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.951742', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5175, NULL, 5175, 'Tres Lagoas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.370315', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3057, NULL, 3057, 'Tres Marias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.0418', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5061, NULL, 5061, 'Tres Palmeiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.245532', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5062, NULL, 5062, 'Tres Passos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.246606', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3058, NULL, 3058, 'Tres Pontas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.042593', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5549, NULL, 5549, 'Tres Ranchos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.789421', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3261, NULL, 3261, 'Tres Rios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.259558', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4581, NULL, 4581, 'Treviso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.720922', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4582, NULL, 4582, 'Treze de Maio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.72182', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4583, NULL, 4583, 'Treze Tilias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.723155', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1638, NULL, 1638, 'Trindade', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.505974', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5550, NULL, 5550, 'Trindade', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.790358', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5063, NULL, 5063, 'Trindade do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.247562', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1639, NULL, 1639, 'Triunfo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.506916', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1457, NULL, 1457, 'Triunfo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.308232', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5064, NULL, 5064, 'Triunfo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.248414', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1233, NULL, 1233, 'Triunfo Potiguar', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.064106', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (653, NULL, 653, 'Trizidela do Vale', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.4231', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5551, NULL, 5551, 'Trombas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.791247', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4584, NULL, 4584, 'Trombudo Central', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.724091', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4585, NULL, 4585, 'Tubarao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.725008', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2219, NULL, 2219, 'Tucano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.132366', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (286, NULL, 286, 'Tucuma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.022234', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5065, NULL, 5065, 'Tucunduva', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.249233', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (287, NULL, 287, 'Tucurui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.023243', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (654, NULL, 654, 'Tufilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.424033', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3883, NULL, 3883, 'Tuiuti', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.952496', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3059, NULL, 3059, 'Tumiritinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.043498', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4586, NULL, 4586, 'Tunapolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.725919', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5066, NULL, 5066, 'Tunas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.250107', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4294, NULL, 4294, 'Tunas do Parana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.408366', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4295, NULL, 4295, 'Tuneiras do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.409234', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (655, NULL, 655, 'Tuntum', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.425218', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3884, NULL, 3884, 'Tupa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.953395', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3060, NULL, 3060, 'Tupaciguara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.044437', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1640, NULL, 1640, 'Tupanatinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.507922', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5067, NULL, 5067, 'Tupanci do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.250953', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5068, NULL, 5068, 'Tupancireta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.251821', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5069, NULL, 5069, 'Tupandi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.252708', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5070, NULL, 5070, 'Tuparendi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.253578', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1641, NULL, 1641, 'Tuparetama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.508899', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4296, NULL, 4296, 'Tupassi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.41021', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3885, NULL, 3885, 'Tupi Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.954217', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (445, NULL, 445, 'Tupirama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.194937', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (446, NULL, 446, 'Tupiratins', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.195867', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (656, NULL, 656, 'Turiacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.426154', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (657, NULL, 657, 'Turilandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.426947', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3886, NULL, 3886, 'Turiuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.955145', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3887, NULL, 3887, 'Turmalina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.956025', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3061, NULL, 3061, 'Turmalina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.045367', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5071, NULL, 5071, 'Turucu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.254432', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1065, NULL, 1065, 'Tururu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.875935', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5552, NULL, 5552, 'Turvania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.792226', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5553, NULL, 5553, 'Turvelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.793204', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4587, NULL, 4587, 'Turvo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.726812', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4297, NULL, 4297, 'Turvo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.410984', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3062, NULL, 3062, 'Turvolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.04633', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (658, NULL, 658, 'Tutoia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.427726', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (133, NULL, 133, 'Uarini', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.843379', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2220, NULL, 2220, 'Uaua', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.133639', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3063, NULL, 3063, 'Uba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.047362', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3064, NULL, 3064, 'Ubai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.048359', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2221, NULL, 2221, 'Ubaira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.134487', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2222, NULL, 2222, 'Ubaitaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.135357', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1066, NULL, 1066, 'Ubajara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.883523', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3065, NULL, 3065, 'Ubaporanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.049243', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3888, NULL, 3888, 'Ubarana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.957522', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2223, NULL, 2223, 'Ubata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.136179', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3889, NULL, 3889, 'Ubatuba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.964282', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3066, NULL, 3066, 'Uberaba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.050224', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3067, NULL, 3067, 'Uberlandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.051156', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3890, NULL, 3890, 'Ubirajara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.965379', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4298, NULL, 4298, 'Ubirata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.411853', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5072, NULL, 5072, 'Ubiretama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.255333', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3891, NULL, 3891, 'Uchoa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.966314', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2224, NULL, 2224, 'Uibai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.136978', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (150, NULL, 150, 'Uiramuta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.866386', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5554, NULL, 5554, 'Uirapuru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.794106', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1458, NULL, 1458, 'Uirauna', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.309099', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (288, NULL, 288, 'Ulianopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.024129', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1067, NULL, 1067, 'Umari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.884695', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1234, NULL, 1234, 'Umarizal', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.065006', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1825, NULL, 1825, 'Umbauba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.704998', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2225, NULL, 2225, 'Umburanas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.137875', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3068, NULL, 3068, 'Umburatiba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.052078', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1459, NULL, 1459, 'Umbuzeiro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.309848', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1068, NULL, 1068, 'Umirim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.885677', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4299, NULL, 4299, 'Umuarama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.412765', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2226, NULL, 2226, 'Una', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.138736', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3069, NULL, 3069, 'Unai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.052956', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (882, NULL, 882, 'Uniao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.670865', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5073, NULL, 5073, 'Uniao da Serra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.256245', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4300, NULL, 4300, 'Uniao da Vitoria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.413578', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3070, NULL, 3070, 'Uniao de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.05387', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4588, NULL, 4588, 'Uniao do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.727766', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5312, NULL, 5312, 'Uniao do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.523883', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1749, NULL, 1749, 'Uniao dos Palmares', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.625153', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3892, NULL, 3892, 'Uniao Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.967227', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4301, NULL, 4301, 'Uniflor', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.42009', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5074, NULL, 5074, 'Unistalda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.257204', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1235, NULL, 1235, 'Upanema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.065955', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4302, NULL, 4302, 'Urai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.421232', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2227, NULL, 2227, 'Urandi', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.139603', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3893, NULL, 3893, 'Urania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.968222', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (659, NULL, 659, 'Urbano Santos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.428556', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3894, NULL, 3894, 'Uru', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.969163', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5555, NULL, 5555, 'Uruacu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.795058', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5556, NULL, 5556, 'Uruana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.796026', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3071, NULL, 3071, 'Uruana de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.054766', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (289, NULL, 289, 'Uruara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.024966', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4589, NULL, 4589, 'Urubici', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.728589', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1069, NULL, 1069, 'Uruburetama', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.886516', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3072, NULL, 3072, 'Urucania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.055651', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (134, NULL, 134, 'Urucara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.844178', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2228, NULL, 2228, 'Urucuca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.14047', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (883, NULL, 883, 'Urucui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.671796', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3073, NULL, 3073, 'Urucuia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.056552', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (135, NULL, 135, 'Urucurituba', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.845408', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5075, NULL, 5075, 'Uruguaiana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.258629', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1070, NULL, 1070, 'Uruoca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.887569', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (49, NULL, 49, 'Urupa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.752266', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4590, NULL, 4590, 'Urupema', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.729355', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3895, NULL, 3895, 'Urupes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.970073', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4591, NULL, 4591, 'Urussanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.730223', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5557, NULL, 5557, 'Urutai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.796933', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2229, NULL, 2229, 'Utinga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.14136', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5076, NULL, 5076, 'Vacaria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.259601', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5313, NULL, 5313, 'Vale de Sao Domingos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.524972', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (50, NULL, 50, 'Vale do Anari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.753153', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (51, NULL, 51, 'Vale do Paraiso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.754014', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5077, NULL, 5077, 'Vale do Sol', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.260531', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5078, NULL, 5078, 'Vale Real', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.261524', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5079, NULL, 5079, 'Vale Verde', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.262431', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3262, NULL, 3262, 'Valenca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.260357', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2230, NULL, 2230, 'Valenca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.142211', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (884, NULL, 884, 'Valenca do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.67261', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2231, NULL, 2231, 'Valente', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.143101', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3896, NULL, 3896, 'Valentim Gentil', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.970972', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3897, NULL, 3897, 'Valinhos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.971951', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3898, NULL, 3898, 'Valparaiso', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.972883', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5558, NULL, 5558, 'Valparaiso de Goias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.797818', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5080, NULL, 5080, 'Vanini', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.263447', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4592, NULL, 4592, 'Vargeao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.731004', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4593, NULL, 4593, 'Vargem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.73178', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3899, NULL, 3899, 'Vargem', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.974064', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3074, NULL, 3074, 'Vargem Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.057453', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3167, NULL, 3167, 'Vargem Alta', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.161405', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3075, NULL, 3075, 'Vargem Bonita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.058481', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4594, NULL, 4594, 'Vargem Bonita', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.732992', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (660, NULL, 660, 'Vargem Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.435067', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3076, NULL, 3076, 'Vargem Grande do Rio Pardo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.05921', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3900, NULL, 3900, 'Vargem Grande do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.974954', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3901, NULL, 3901, 'Vargem Grande Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.976387', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3077, NULL, 3077, 'Varginha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.065668', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5559, NULL, 5559, 'Varjao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.798714', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3078, NULL, 3078, 'Varjao de Minas', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.066741', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1071, NULL, 1071, 'Varjota', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.88856', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3263, NULL, 3263, 'Varre-sai', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.261201', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1460, NULL, 1460, 'Varzea', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.310707', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1236, NULL, 1236, 'Varzea', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.066769', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1072, NULL, 1072, 'Varzea Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.889456', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (885, NULL, 885, 'Varzea Branca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.679609', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3079, NULL, 3079, 'Varzea da Palma', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.067629', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2232, NULL, 2232, 'Varzea da Roca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.144044', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2233, NULL, 2233, 'Varzea do Poco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.145026', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (886, NULL, 886, 'Varzea Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.680844', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5314, NULL, 5314, 'Varzea Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.526086', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2234, NULL, 2234, 'Varzea Nova', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.145932', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3902, NULL, 3902, 'Varzea Paulista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.97738', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2235, NULL, 2235, 'Varzedo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.146908', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3080, NULL, 3080, 'Varzelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.068499', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3264, NULL, 3264, 'Vassouras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.262061', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3081, NULL, 3081, 'Vazante', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.069738', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5081, NULL, 5081, 'Venancio Aires', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.264406', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3168, NULL, 3168, 'Venda Nova do Imigrante', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.162222', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1237, NULL, 1237, 'Venha-ver', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.067688', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4303, NULL, 4303, 'Ventania', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.422122', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1642, NULL, 1642, 'Venturosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.509757', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5315, NULL, 5315, 'Vera', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.526999', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5082, NULL, 5082, 'Vera Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.265345', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3903, NULL, 3903, 'Vera Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.97827', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2236, NULL, 2236, 'Vera Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.147866', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1238, NULL, 1238, 'Vera Cruz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.068614', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4304, NULL, 4304, 'Vera Cruz do Oeste', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.422901', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (887, NULL, 887, 'Vera Mendes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.681873', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5083, NULL, 5083, 'Veranopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.26647', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1643, NULL, 1643, 'Verdejante', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.510673', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3082, NULL, 3082, 'Verdelandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.070607', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4305, NULL, 4305, 'Vere', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.423951', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2237, NULL, 2237, 'Vereda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.148738', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3083, NULL, 3083, 'Veredinha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.071486', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3084, NULL, 3084, 'Verissimo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.072355', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3085, NULL, 3085, 'Vermelho Novo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.073251', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1644, NULL, 1644, 'Vertente do Lerio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.511529', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1645, NULL, 1645, 'Vertentes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.512415', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3086, NULL, 3086, 'Vespasiano', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.074104', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5084, NULL, 5084, 'Vespasiano Correa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.273349', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5085, NULL, 5085, 'Viadutos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.274527', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5086, NULL, 5086, 'Viamao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.275464', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (661, NULL, 661, 'Viana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.436627', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3169, NULL, 3169, 'Viana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.163119', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5560, NULL, 5560, 'Vianopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.799587', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1646, NULL, 1646, 'Vicencia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.513303', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5087, NULL, 5087, 'Vicente Dutra', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.276287', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5176, NULL, 5176, 'Vicentina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.371201', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5561, NULL, 5561, 'Vicentinopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.800364', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1750, NULL, 1750, 'Vicosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.626119', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3087, NULL, 3087, 'Vicosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.074933', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1239, NULL, 1239, 'Vicosa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.069524', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1073, NULL, 1073, 'Vicosa do Ceara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.890355', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5088, NULL, 5088, 'Victor Graeff', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.27728', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4595, NULL, 4595, 'Vidal Ramos', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.734534', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4596, NULL, 4596, 'Videira', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.735701', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3088, NULL, 3088, 'Vieiras', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.075846', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1461, NULL, 1461, 'Vieiropolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.311518', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (290, NULL, 290, 'Vigia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.025883', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5316, NULL, 5316, 'Vila Bela da Santissima Trindade', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.528916', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5562, NULL, 5562, 'Vila Boa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.801199', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1240, NULL, 1240, 'Vila Flor', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.070393', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5089, NULL, 5089, 'Vila Flores', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.278305', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5090, NULL, 5090, 'Vila Langaro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.279156', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5091, NULL, 5091, 'Vila Maria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.280109', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (888, NULL, 888, 'Vila Nova do Piaui', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.68279', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5092, NULL, 5092, 'Vila Nova do Sul', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.281043', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (662, NULL, 662, 'Vila Nova dos Martirios', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.43748', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3170, NULL, 3170, 'Vila Pavao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.164134', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5563, NULL, 5563, 'Vila Propicio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.802078', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5317, NULL, 5317, 'Vila Rica', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.530101', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3171, NULL, 3171, 'Vila Valerio', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.165005', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3172, NULL, 3172, 'Vila Velha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.165861', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (52, NULL, 52, 'Vilhena', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.754961', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3904, NULL, 3904, 'Vinhedo', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.979112', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3905, NULL, 3905, 'Viradouro', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.980046', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3089, NULL, 3089, 'Virgem da Lapa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.076853', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3090, NULL, 3090, 'Virginia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.077734', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3091, NULL, 3091, 'Virginopolis', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.078589', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3092, NULL, 3092, 'Virgolandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.079515', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4306, NULL, 4306, 'Virmond', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.424896', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3093, NULL, 3093, 'Visconde do Rio Branco', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.080291', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (291, NULL, 291, 'Viseu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.026802', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5093, NULL, 5093, 'Vista Alegre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.281928', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3906, NULL, 3906, 'Vista Alegre do Alto', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.980934', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5094, NULL, 5094, 'Vista Alegre do Prata', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.282888', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5095, NULL, 5095, 'Vista Gaucha', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.283856', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1462, NULL, 1462, 'Vista Serrana', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.312486', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4597, NULL, 4597, 'Vitor Meireles', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.736573', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3173, NULL, 3173, 'Vitoria', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.166749', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3907, NULL, 3907, 'Vitoria Brasil', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.981804', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2238, NULL, 2238, 'Vitoria da Conquista', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.149664', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5096, NULL, 5096, 'Vitoria das Missoes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.284731', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1647, NULL, 1647, 'Vitoria de Santo Antao', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.51418', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (309, NULL, 309, 'Vitoria do Jari', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.043135', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (663, NULL, 663, 'Vitoria do Mearim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.438392', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (292, NULL, 292, 'Vitoria do Xingu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.027745', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4307, NULL, 4307, 'Vitorino', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.425982', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (664, NULL, 664, 'Vitorino Freire', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.439218', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3094, NULL, 3094, 'Volta Grande', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.081204', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3265, NULL, 3265, 'Volta Redonda', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.268581', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3908, NULL, 3908, 'Votorantim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.982726', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3909, NULL, 3909, 'Votuporanga', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.983575', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2239, NULL, 2239, 'Wagner', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.150535', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (889, NULL, 889, 'Wall Ferraz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.683613', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (447, NULL, 447, 'Wanderlandia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.196689', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2240, NULL, 2240, 'Wanderley', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.151529', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4308, NULL, 4308, 'Wenceslau Braz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.426895', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3095, NULL, 3095, 'Wenceslau Braz', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.081973', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2241, NULL, 2241, 'Wenceslau Guimaraes', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.152442', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5097, NULL, 5097, 'Westfalia', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.285646', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4598, NULL, 4598, 'Witmarsum', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.73748', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (448, NULL, 448, 'Xambioa', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.197644', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4309, NULL, 4309, 'Xambre', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.427805', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5098, NULL, 5098, 'Xangri-la', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:39.286521', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4599, NULL, 4599, 'Xanxere', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.738315', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (74, NULL, 74, 'Xapuri', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:33.782326', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4600, NULL, 4600, 'Xavantina', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.744776', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4601, NULL, 4601, 'Xaxim', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.745932', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1648, NULL, 1648, 'Xexeu', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.515121', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (293, NULL, 293, 'Xinguara', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.028653', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2242, NULL, 2242, 'Xique-xique', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:36.153258', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1463, NULL, 1463, 'Zabele', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:35.31346', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3910, NULL, 3910, 'Zacarias', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:37.984592', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (665, NULL, 665, 'Ze Doca', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:34.440175', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4602, NULL, 4602, 'Zortea', '05', NULL, NULL, 'M', 1, '2010-01-06 18:30:38.746831', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5319, NULL, 5565, 'Posse d''Abadia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (151, NULL, 5566, 'Beja', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (890, NULL, 5567, 'São José', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1826, NULL, 5568, 'Catolés', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1827, NULL, 5569, 'Ibó', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2245, NULL, 5570, 'Granada', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1464, NULL, 5571, 'Distrito Industrial', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (153, NULL, 5572, 'Jaguarari', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (153, NULL, 5573, 'Guajará-Miri', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (892, NULL, 5574, 'Aranaú', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (892, NULL, 5575, 'Juritianha', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (892, NULL, 5576, 'Lagoa do Carneiro', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4603, NULL, 5577, 'Colônia Nova', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4603, NULL, 5578, 'Rio Negro', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4603, NULL, 5579, 'Minuano', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (893, NULL, 5580, 'São Paulinho', '31', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (893, NULL, 5581, 'Ebron', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (893, NULL, 5582, 'Barra do Ingá', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (893, NULL, 5583, 'Santo Antônio', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (893, NULL, 5584, 'Solidão', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (893, NULL, 5585, 'Trussu', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (893, NULL, 5586, 'Santa Felícia', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (893, NULL, 5587, 'Isidoro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (893, NULL, 5588, 'Quincoê', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5177, NULL, 5589, 'Aldeia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5177, NULL, 5590, 'Baús', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2247, NULL, 5591, 'Aramirim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2247, NULL, 5592, 'Gama', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2247, NULL, 5593, 'Naque-Nanuque', '28', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2247, NULL, 5594, 'Felicina', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3096, NULL, 5595, 'Ibicaba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3096, NULL, 5596, 'São Francisco Xavier do Guandu', '37', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3096, NULL, 5597, 'Fazenda Guandu', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3096, NULL, 5598, 'Mata Fria', '28', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3096, NULL, 5599, 'Pontões', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3096, NULL, 5600, 'Serra Pelada', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3096, NULL, 5601, 'São Luís de Boa Sorte', '39', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3096, NULL, 5602, 'Piracema', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1466, NULL, 5603, 'Arizona', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1466, NULL, 5604, 'Cachoeira do Roberto', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1466, NULL, 5605, 'Poção de Afrânio', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1467, NULL, 5606, 'Barra do Jardim', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1467, NULL, 5607, 'Barra do Chata', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2248, NULL, 5608, 'Serrinha', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5178, NULL, 5609, 'Serrinha', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2248, NULL, 5610, 'Palmeira de Resplendor', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5178, NULL, 5611, 'Palmeira de Resplendor', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2248, NULL, 5612, 'Jaraguá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5178, NULL, 5613, 'Jaraguá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4314, NULL, 5614, 'Herciliópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3097, NULL, 5615, 'Santa Luzia do Azul', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3097, NULL, 5616, 'Governador Lacerda de Aguiar', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3097, NULL, 5617, 'Vila Nelita', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3097, NULL, 5618, 'Santo Agostinho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1830, NULL, 5619, 'Pataíba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1468, NULL, 5620, 'Santa Terezinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4604, NULL, 5621, 'Santo Antônio dos Pinheirinhos', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4604, NULL, 5622, 'Engenho Grande', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4604, NULL, 5623, 'São Caetano', '28', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1469, NULL, 5624, 'Curral Novo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3269, NULL, 5625, 'São Roque da Fartura', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2251, NULL, 5626, 'Água Quente', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2252, NULL, 5627, 'Machado Mineiro', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2252, NULL, 5628, 'Itamarati', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3273, NULL, 5629, 'Domélia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3913, NULL, 5630, 'Colônia Padre Paulo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3098, NULL, 5631, 'Águas Claras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2253, NULL, 5632, 'Conceição do Capim', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2253, NULL, 5633, 'São Sebastião da Vala', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2253, NULL, 5634, 'Santo Antônio do Rio Doce', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2253, NULL, 5635, 'Alto do Capim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2253, NULL, 5636, 'Tabaúna', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2253, NULL, 5637, 'Penha do Capim', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2253, NULL, 5638, 'Expedicionário Alício', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2253, NULL, 5639, 'Mundo Novo de Minas', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (894, NULL, 5640, 'Barra', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4606, NULL, 5641, 'Medianeira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1245, NULL, 5642, 'Perpétuo Socorro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1470, NULL, 5643, 'Perpétuo Socorro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1832, NULL, 5644, 'Riacho da Guia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1832, NULL, 5645, 'Boa União', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (452, NULL, 5646, 'São João de Cortes', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (895, NULL, 5647, 'Ventura', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1833, NULL, 5648, 'São José', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3099, NULL, 5649, 'Celina', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3099, NULL, 5650, 'Araraí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3099, NULL, 5651, 'Santa Angélica', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3099, NULL, 5652, 'Anutiba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3099, NULL, 5653, 'Rive', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3099, NULL, 5654, 'São João do Norte', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3099, NULL, 5655, 'Café', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4608, NULL, 5656, 'Passo Novo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4609, NULL, 5657, 'Espírito Santo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2257, NULL, 5658, 'Angustura', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5325, NULL, 5659, 'Olhos D''Água', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2258, NULL, 5660, 'Barranco Alto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3100, NULL, 5661, 'Urânia', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3100, NULL, 5662, 'Ribeirão do Cristo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3100, NULL, 5663, 'Sagrada Família', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3100, NULL, 5664, 'Matilde', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3100, NULL, 5665, 'Ibitiruí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3100, NULL, 5666, 'Crubixá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2259, NULL, 5667, 'São José de Pouso Alegre', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4318, NULL, 5668, 'Catuíra', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4318, NULL, 5669, 'Arnópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4318, NULL, 5670, 'São Leonardo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1471, NULL, 5671, 'Macujê', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1471, NULL, 5672, 'Upatininga', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1471, NULL, 5673, 'Tupaoca', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (157, NULL, 5674, 'Monte Dourado', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (157, NULL, 5675, 'Arumanduba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2260, NULL, 5676, 'Pedra Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4610, NULL, 5677, 'Rincão do Segredo', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4610, NULL, 5678, 'Linha Vitória', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4611, NULL, 5679, 'Volta Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4611, NULL, 5680, 'Farinhas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4611, NULL, 5681, 'Sertãozinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1, NULL, 5682, 'Santo Antônio d''Oeste', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1, NULL, 5683, 'Rolim de Moura do Guaporé', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1, NULL, 5684, 'Izidolândia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1, NULL, 5685, 'Filadélfia d''Oeste', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1, NULL, 5686, 'Nova Gease d''Oeste', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3276, NULL, 5687, 'Suinana', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (158, NULL, 5688, 'Castelo dos Sonhos', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (896, NULL, 5689, 'São Romão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2263, NULL, 5690, 'Divino Espírito Santo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1472, NULL, 5691, 'Ituguaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (136, NULL, 5692, 'Treze de Maio', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4612, NULL, 5693, 'Treze de Maio', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3278, NULL, 5694, 'Treze de Maio', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (136, NULL, 5695, 'Linha Bonita', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4612, NULL, 5696, 'Linha Bonita', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3278, NULL, 5697, 'Linha Bonita', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (136, NULL, 5698, 'Jatobá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4612, NULL, 5699, 'Jatobá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3278, NULL, 5700, 'Jatobá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (136, NULL, 5701, 'Santa Lúcia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4612, NULL, 5702, 'Santa Lúcia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3278, NULL, 5703, 'Santa Lúcia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (136, NULL, 5704, 'São José', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4612, NULL, 5705, 'São José', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3278, NULL, 5706, 'São José', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (136, NULL, 5707, 'São Martinho d''Oeste', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4612, NULL, 5708, 'São Martinho d''Oeste', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3278, NULL, 5709, 'São Martinho d''Oeste', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5180, NULL, 5710, 'Buriti', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2265, NULL, 5711, 'Padre Júlio Maria', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5183, NULL, 5712, 'Capão Verde', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5183, NULL, 5713, 'Lavouras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5328, NULL, 5714, 'São Jorge', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3917, NULL, 5715, 'Maristela', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3917, NULL, 5716, 'Santa Maria', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (457, NULL, 5717, 'Curupá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3918, NULL, 5718, 'Saltinho do Oeste', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3918, NULL, 5719, 'Mirante do Piquiri', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3918, NULL, 5720, 'Paulistânia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2266, NULL, 5721, 'Vitorinos', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2266, NULL, 5722, 'Abreus', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2266, NULL, 5723, 'Missionário', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3101, NULL, 5724, 'Monte Carmelo do Rio Novo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3101, NULL, 5725, 'Palmerino', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (897, NULL, 5726, 'Baixio Grande', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (897, NULL, 5727, 'Bom Jesus', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (897, NULL, 5728, 'Boa Fé', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (897, NULL, 5729, 'Castanhão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (897, NULL, 5730, 'Cabrito', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (897, NULL, 5731, 'Batoque', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3919, NULL, 5732, 'São João', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3919, NULL, 5733, 'Jardim Paredão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3280, NULL, 5734, 'Boa Vista dos Andradas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3281, NULL, 5735, 'Coronel Goulart', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2268, NULL, 5736, 'Major Ezequiel', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2268, NULL, 5737, 'Fonseca', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2268, NULL, 5738, 'Barretos de Alvinópolis', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (314, NULL, 5739, 'Estância Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4614, NULL, 5740, 'Estância Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4, NULL, 5741, 'Tancredópolis', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4, NULL, 5742, 'Terra Boa', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2269, NULL, 5743, 'Itapanhoacanga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3920, NULL, 5744, 'Esperança do Norte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (294, NULL, 5745, 'Sucuriju', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3921, NULL, 5746, 'Nordestina', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1835, NULL, 5747, 'Diógenes Sampaio', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1835, NULL, 5748, 'Itachama', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1835, NULL, 5749, 'Corta Mão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1836, NULL, 5750, 'Mata da Aliança', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1836, NULL, 5751, 'Inhatá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1837, NULL, 5752, 'Soares', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1837, NULL, 5753, 'Prevenido', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1837, NULL, 5754, 'Belo Campo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4616, NULL, 5755, 'São Valentin da Gruta', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (898, NULL, 5756, 'Mosquito', '28', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (898, NULL, 5757, 'Poço Comprido', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (898, NULL, 5758, 'Aracatiara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (898, NULL, 5759, 'Nascente', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (898, NULL, 5760, 'Lagoa Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (898, NULL, 5761, 'Garças', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (898, NULL, 5762, 'Moitas', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (898, NULL, 5763, 'Sabiaguaba', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (898, NULL, 5764, 'Icaraí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3287, NULL, 5765, 'Arcadas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1249, NULL, 5766, 'Arcadas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3287, NULL, 5767, 'Três Pontes', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1249, NULL, 5768, 'Três Pontes', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2270, NULL, 5769, 'Padre Felisberto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3922, NULL, 5770, 'São Pedro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3922, NULL, 5771, 'São Salvador', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1838, NULL, 5772, 'Coquinhos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (460, NULL, 5773, 'Porto das Gabarras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5333, NULL, 5774, 'Sousânia', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5333, NULL, 5775, 'Joanápolis', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5333, NULL, 5776, 'Interlândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5333, NULL, 5777, 'Goialândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4320, NULL, 5778, 'Alto Pongal', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3102, NULL, 5779, 'Alto Pongal', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4320, NULL, 5780, 'Jabaquara', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3102, NULL, 5781, 'Jabaquara', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1839, NULL, 5782, 'Igatu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1839, NULL, 5783, 'Ubiraitá', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3924, NULL, 5784, 'Nossa Senhora Aparecida', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1840, NULL, 5785, 'Sítio da Baraúna', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1840, NULL, 5786, 'Tanquinho do Poço', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2271, NULL, 5787, 'Gramínea', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2271, NULL, 5788, 'Campestrinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3290, NULL, 5789, 'Bom Retiro da Esperança', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5104, NULL, 5790, 'Ipezal', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4321, NULL, 5791, 'Barra Clara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4321, NULL, 5792, 'Garcia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1841, NULL, 5793, 'Missão de Aricobé', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3174, NULL, 5794, 'Cunhambebe', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3174, NULL, 5795, 'Mambucaba', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3174, NULL, 5796, 'Abraão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3291, NULL, 5797, 'Pirambóia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5335, NULL, 5798, 'Choupana', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5335, NULL, 5799, 'Capelinha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4322, NULL, 5800, 'Lagoa da Estiva', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4618, NULL, 5801, 'Itapuca', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3926, NULL, 5802, 'Cachoeira de Cima', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3926, NULL, 5803, 'Cacatu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (899, NULL, 5804, 'Taboleiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1844, NULL, 5805, 'Santo Estevão Velho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1844, NULL, 5806, 'Poço', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1844, NULL, 5807, 'Oleiro', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4324, NULL, 5808, 'Curral Novo de Minas', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2274, NULL, 5809, 'Curral Novo de Minas', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4324, NULL, 5810, 'Dr. Sá Fortes', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2274, NULL, 5811, 'Dr. Sá Fortes', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4324, NULL, 5812, 'São Sebastião de Campolide', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2274, NULL, 5813, 'São Sebastião de Campolide', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2275, NULL, 5814, 'Hematita', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5105, NULL, 5815, 'Campestre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4619, NULL, 5816, 'Santana', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5336, NULL, 5817, 'Nova Brasília', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3103, NULL, 5818, 'José Carlos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3103, NULL, 5819, 'Bonsucesso', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3295, NULL, 5820, 'Lageado de Araçaíba', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3295, NULL, 5821, 'Araçaíba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3295, NULL, 5822, 'Palmitalzinho', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1846, NULL, 5823, 'Itamira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3928, NULL, 5824, 'Pirapó', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3928, NULL, 5825, 'Vila Reis', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3928, NULL, 5826, 'Correia de Freitas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3928, NULL, 5827, 'São Pedro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (900, NULL, 5828, 'Canafístula', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (900, NULL, 5829, 'Vila Soares', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5107, NULL, 5830, 'Cipolândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5107, NULL, 5831, 'Camisão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5107, NULL, 5832, 'Piraputanga', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5107, NULL, 5833, 'Taunay', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (901, NULL, 5834, 'Camará', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (901, NULL, 5835, 'Jacaúna', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (901, NULL, 5836, 'Justiniano de Serpa', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (901, NULL, 5837, 'Patacas', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (901, NULL, 5838, 'Tapera', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (901, NULL, 5839, 'Caponga da Bernarda', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (901, NULL, 5840, 'João de Castro', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4326, NULL, 5841, 'Nova Estrela', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (902, NULL, 5842, 'Santa Tereza', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (902, NULL, 5843, 'Barreira dos Vianas', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (902, NULL, 5844, 'Córrego dos Fernandes', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (902, NULL, 5845, 'Cabreiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (902, NULL, 5846, 'Mata Fresca', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (902, NULL, 5847, 'Jirau', '24', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (903, NULL, 5848, 'Plácido Martins', '24', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1475, NULL, 5849, 'Plácido Martins', '24', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (903, NULL, 5850, 'Ideal', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1475, NULL, 5851, 'Ideal', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (903, NULL, 5852, 'Milton Belo', '21', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1475, NULL, 5853, 'Milton Belo', '21', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (903, NULL, 5854, 'Jaguarão', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1475, NULL, 5855, 'Jaguarão', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (903, NULL, 5856, 'Vazantes', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1475, NULL, 5857, 'Vazantes', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (903, NULL, 5858, 'Jenipapeiro', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1475, NULL, 5859, 'Jenipapeiro', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (903, NULL, 5860, 'Lagoa de São João', '19', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1475, NULL, 5861, 'Lagoa de São João', '19', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (903, NULL, 5862, 'Pedra Branca', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1475, NULL, 5863, 'Pedra Branca', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3104, NULL, 5864, 'Guaraná', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3104, NULL, 5865, 'Riacho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3104, NULL, 5866, 'Jacupemba', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3104, NULL, 5867, 'Santa Cruz', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2279, NULL, 5868, 'Itira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2279, NULL, 5869, 'Engenheiro Schnoor', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2280, NULL, 5870, 'Amanhece', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2280, NULL, 5871, 'Florestina', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2280, NULL, 5872, 'Piracaíba', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (323, NULL, 5873, 'Natal', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4620, NULL, 5874, 'Santa Rita do Sul', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2282, NULL, 5875, 'Estêvão de Araújo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3930, NULL, 5876, 'Caratuva', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3930, NULL, 5877, 'Calógeras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4327, NULL, 5878, 'Itapocu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4328, NULL, 5879, 'Balneário Morro dos Conventos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4328, NULL, 5880, 'Sanga da Toca', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4328, NULL, 5881, 'Hercílio Luz', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3302, NULL, 5882, 'Bueno de Andrada', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3302, NULL, 5883, 'Vila Xavier', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (904, NULL, 5884, 'Santo Antonio', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (466, NULL, 5885, 'Bonfim do Arari', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (905, NULL, 5886, 'Riacho Grande', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (905, NULL, 5887, 'Alagoinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (905, NULL, 5888, 'Brejinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (905, NULL, 5889, 'Pajeú', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1476, NULL, 5890, 'Serrânia', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1476, NULL, 5891, 'Morais', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1476, NULL, 5892, 'Lagoa do Barro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1476, NULL, 5893, 'Bom Jardim do Araripe', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1476, NULL, 5894, 'Gergelim', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1476, NULL, 5895, 'Nascente', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3176, NULL, 5896, 'Praia Seca', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3176, NULL, 5897, 'São Vicente de Paula', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3176, NULL, 5898, 'Morro Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3176, NULL, 5899, 'Iguabinha', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3932, NULL, 5900, 'São Vicente', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1253, NULL, 5901, 'São Vicente', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1852, NULL, 5902, 'Itatingui', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4622, NULL, 5903, 'Três Barras', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4622, NULL, 5904, 'Volta Fechada', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4622, NULL, 5905, 'Pio X', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4622, NULL, 5906, 'Dourado', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4622, NULL, 5907, 'Rio Azul', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (906, NULL, 5908, 'Pai João', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1853, NULL, 5909, 'Maragogipinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3933, NULL, 5910, 'Guajuvira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2286, NULL, 5911, 'Itaipu de Araxá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3305, NULL, 5912, 'Jacuba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1254, NULL, 5913, 'Cepilho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1254, NULL, 5914, 'Muquém', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1254, NULL, 5915, 'Mata Limpa', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2292, NULL, 5916, 'Pic Sagarana', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2292, NULL, 5917, 'Vila Bom Jesus', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (907, NULL, 5918, 'Planalto', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (907, NULL, 5919, 'Cachoeira de Fora', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1257, NULL, 5920, 'Pedro Velho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (325, NULL, 5921, 'Cana Brava', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4623, NULL, 5922, 'Vale do Arroio Grande', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4623, NULL, 5923, 'Palmas', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4623, NULL, 5924, 'Forqueta', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4626, NULL, 5925, 'Taboãozinho', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4626, NULL, 5926, 'Linha Ocidental', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4626, NULL, 5927, 'Vila Progresso', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4626, NULL, 5928, 'Coloninha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4626, NULL, 5929, 'Sítio Alto', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4626, NULL, 5930, 'Taquaral', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4628, NULL, 5931, 'Santa Izabel do Sul', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4628, NULL, 5932, 'Mauá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4628, NULL, 5933, 'Pedreiras', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4629, NULL, 5934, 'Pinhal Queimado', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3935, NULL, 5935, 'Pau D''Alho do Sul', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (908, NULL, 5936, 'Aratama', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (908, NULL, 5937, 'Amaro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3936, NULL, 5938, 'Bragantina', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3936, NULL, 5939, 'Encantado d''Oeste', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2293, NULL, 5940, 'Sobral Pinto', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2293, NULL, 5941, 'Santana do Campestre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3937, NULL, 5942, 'Tupinambá', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3937, NULL, 5943, 'Santa Zélia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3937, NULL, 5944, 'Içara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3938, NULL, 5945, 'Sapucaia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1652, NULL, 5946, 'Sapucaia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2294, NULL, 5947, 'Fidelândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2294, NULL, 5948, 'Novo Horizonte', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (162, NULL, 5949, 'Itapixuna', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (162, NULL, 5950, 'Aturiaí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (162, NULL, 5951, 'Emboraí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4630, NULL, 5952, 'Rosário', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1854, NULL, 5953, 'Poço Central', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1854, NULL, 5954, 'Laje do Banco', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (909, NULL, 5955, 'Tipi', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4334, NULL, 5956, 'Tipi', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (909, NULL, 5957, 'Santa Vitória', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4334, NULL, 5958, 'Santa Vitória', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (909, NULL, 5959, 'Ingazeiras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4334, NULL, 5960, 'Ingazeiras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (81, NULL, 5961, 'Murutinga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3315, NULL, 5962, 'Nogueira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (164, NULL, 5963, 'Pinhel', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (164, NULL, 5964, 'Brasília Legal', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4632, NULL, 5965, 'Piraí', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4632, NULL, 5966, 'Palmas', '21', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4632, NULL, 5967, 'Joca Tavares', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4632, NULL, 5968, 'José Otávio', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (165, NULL, 5969, 'Pedreira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1855, NULL, 5970, 'Várzeas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (166, NULL, 5971, 'Umarizal do Tocantins', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (166, NULL, 5972, 'São Joaquim do Ituquara', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (166, NULL, 5973, 'Joana Peres', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3106, NULL, 5974, 'Alto Mutum Preto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3106, NULL, 5975, 'Ibituba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3106, NULL, 5976, 'Vila Nova de Bananal', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3106, NULL, 5977, 'Quilômetro 14 do Mutum', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2297, NULL, 5978, 'Amanda', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2297, NULL, 5979, 'São Vicente', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4633, NULL, 5980, 'Túnel Verde', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4633, NULL, 5981, 'Magistério', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3939, NULL, 5982, 'São Luiz do Purunã', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3939, NULL, 5983, 'Bugre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (911, NULL, 5984, 'Rinaré', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (911, NULL, 5985, 'Laranjeiras', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (911, NULL, 5986, 'Pedras Brancas', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (911, NULL, 5987, 'Sitiá', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1260, NULL, 5988, 'Taboleiro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1260, NULL, 5989, 'Maia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5109, NULL, 5990, 'Nossa Senhora da Candelária', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3940, NULL, 5991, 'Nossa Senhora da Candelária', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5109, NULL, 5992, 'Congonha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3940, NULL, 5993, 'Congonha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4634, NULL, 5994, 'General Neto', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4634, NULL, 5995, 'Francesa Baixa', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4634, NULL, 5996, 'Arroio Canoas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4634, NULL, 5997, 'Francesa Alta', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2301, NULL, 5998, 'Cocais', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5191, NULL, 5999, 'Joselândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2302, NULL, 6000, 'Silveira Carvalho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2302, NULL, 6001, 'Cachoeira Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2303, NULL, 6002, 'Mantiqueira do Palmital', '19', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2303, NULL, 6003, 'Correia de Almeida', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2303, NULL, 6004, 'Galego', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2303, NULL, 6005, 'Costas da Mantiqueira', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2303, NULL, 6006, 'São Sebastião dos Torres', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2303, NULL, 6007, 'Padre Brito', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2303, NULL, 6008, 'Faria', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2303, NULL, 6009, 'Senhora das Dores', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2303, NULL, 6010, 'Colônia Rodrigo Silva', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2303, NULL, 6011, 'Pinheiro Grosso', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2303, NULL, 6012, 'Ponto Chique do Martelo', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2303, NULL, 6013, 'Ponte do Cosme', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (912, NULL, 6014, 'Caldas', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (912, NULL, 6015, 'Arajara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (912, NULL, 6016, 'Estrela', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3941, NULL, 6017, 'Ourilândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3941, NULL, 6018, 'Pocinho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3941, NULL, 6019, 'Tereza Breda', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3941, NULL, 6020, 'Bourbonia', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (168, NULL, 6021, 'Murucupi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1858, NULL, 6022, 'Ibiraba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1858, NULL, 6023, 'Igarité', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1859, NULL, 6024, 'Triunfo do Sincora', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3107, NULL, 6025, 'Vargem Alegre', '56', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3107, NULL, 6026, 'Santo Antônio', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3107, NULL, 6027, 'Monte Sinai', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3107, NULL, 6028, 'Monte Senir', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3107, NULL, 6029, 'Itaperuna', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3107, NULL, 6030, 'Paulista', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3107, NULL, 6031, 'Cachoeirinha de Itaúna', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3107, NULL, 6032, 'Poranga', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5192, NULL, 6033, 'Assari', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5192, NULL, 6034, 'Tapirapuã', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1860, NULL, 6035, 'Barra Nova', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5193, NULL, 6036, 'Vale dos Sonhos', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5193, NULL, 6037, 'Indianópolis', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5193, NULL, 6038, 'Toricueije', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1861, NULL, 6039, 'Antari', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1861, NULL, 6040, 'Minas do Espírito Santo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3180, NULL, 6041, 'Dorândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3180, NULL, 6042, 'São José do Turvo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3180, NULL, 6043, 'Vargem Alegre', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3180, NULL, 6044, 'Ipiabas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3180, NULL, 6045, 'Califórnia da Barra', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4638, NULL, 6046, 'Francisco Borges', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4638, NULL, 6047, 'Guterrez', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4638, NULL, 6048, 'Passo da Cruz', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4639, NULL, 6049, 'Douradilho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2304, NULL, 6050, 'Bonfim da Barra', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3181, NULL, 6051, 'Nossa Senhora do Amparo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3181, NULL, 6052, 'Antônio Rocha', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3181, NULL, 6053, 'Santa Rita de Cássia', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3181, NULL, 6054, 'Rialto', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3181, NULL, 6055, 'Floriano', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3943, NULL, 6056, 'Siqueira Belo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4642, NULL, 6057, 'Siqueira Belo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3943, NULL, 6058, 'Espigão Alto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4642, NULL, 6059, 'Espigão Alto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (913, NULL, 6060, 'Lagoa do Barro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (913, NULL, 6061, 'Córrego', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (913, NULL, 6062, 'Lagoa Grande', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (83, NULL, 6063, 'Ariaú', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (83, NULL, 6064, 'Pedras', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (83, NULL, 6065, 'Cametá', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (83, NULL, 6066, 'Freguesia do Andirá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1479, NULL, 6067, 'Carimã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3328, NULL, 6068, 'Ibitu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3328, NULL, 6069, 'Alberto Moreira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (914, NULL, 6070, 'Cuncas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (914, NULL, 6071, 'Monte Alegre', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (914, NULL, 6072, 'Engenho Velho', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (914, NULL, 6073, 'Iara', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (914, NULL, 6074, 'Brejinho', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (914, NULL, 6075, 'Serrota', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (914, NULL, 6076, 'Santo Antônio', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5348, NULL, 6077, 'Lagoa Funda', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1864, NULL, 6078, 'Lagoa Funda', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5348, NULL, 6079, 'Lagoa do Boi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1864, NULL, 6080, 'Lagoa do Boi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (915, NULL, 6081, 'Araras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (915, NULL, 6082, 'Bitupitá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3330, NULL, 6083, 'Jardim Belval', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3330, NULL, 6084, 'Jardim Silveira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3330, NULL, 6085, 'Aldeia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5110, NULL, 6086, 'Porto XV de Novembro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (916, NULL, 6087, 'Boa Vista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (916, NULL, 6088, 'São Sebastião', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3333, NULL, 6089, 'Tibiriçá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3334, NULL, 6090, 'Turvínia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3334, NULL, 6091, 'Botafogo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (917, NULL, 6092, 'Sucatinga', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (917, NULL, 6093, 'Forquilha', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (917, NULL, 6094, 'Parajuru', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (917, NULL, 6095, 'Serra do Félix', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (917, NULL, 6096, 'Paripueira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (917, NULL, 6097, 'Itapeim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (918, NULL, 6098, 'Prata', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5112, NULL, 6099, 'Nossa Senhora de Fátima', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3945, NULL, 6100, 'Santa Margarida', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1266, NULL, 6101, 'Guamá', '55', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (169, NULL, 6102, 'Guamá', '55', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1656, NULL, 6103, 'Guamá', '55', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1266, NULL, 6104, 'Rua Nova', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (169, NULL, 6105, 'Rua Nova', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1656, NULL, 6106, 'Rua Nova', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1266, NULL, 6107, 'Icoaraci', '60', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (169, NULL, 6108, 'Icoaraci', '60', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1656, NULL, 6109, 'Icoaraci', '60', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1266, NULL, 6110, 'Bengui', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (169, NULL, 6111, 'Bengui', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1656, NULL, 6112, 'Bengui', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1266, NULL, 6113, 'Sacramenta', '75', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (169, NULL, 6114, 'Sacramenta', '75', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1656, NULL, 6115, 'Sacramenta', '75', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1266, NULL, 6116, 'Mosqueiro', '65', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (169, NULL, 6117, 'Mosqueiro', '65', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1656, NULL, 6118, 'Mosqueiro', '65', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1266, NULL, 6119, 'Entroncamento', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (169, NULL, 6120, 'Entroncamento', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1656, NULL, 6121, 'Entroncamento', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1266, NULL, 6122, 'Outeiro', '67', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (169, NULL, 6123, 'Outeiro', '67', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1656, NULL, 6124, 'Outeiro', '67', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1480, NULL, 6125, 'Batateira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2307, NULL, 6126, 'Sobragi', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2307, NULL, 6127, 'Porto das Flores', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2307, NULL, 6128, 'Três Ilhas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1866, NULL, 6129, 'Boca do Córrego', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4343, NULL, 6130, 'Boca do Córrego', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1866, NULL, 6131, 'Mogiquiçaba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4343, NULL, 6132, 'Mogiquiçaba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2308, NULL, 6133, 'Venda Nova', '60', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2308, NULL, 6134, 'Barreiro', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1482, NULL, 6135, 'Xucuru', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1482, NULL, 6136, 'Água Fria', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1482, NULL, 6137, 'Serra do Vento', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2309, NULL, 6138, 'Perpétuo Socorro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2309, NULL, 6139, 'São Sebastião de Braúnas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2309, NULL, 6140, 'Bom Jesus do Bagre', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2310, NULL, 6141, 'Santana do Paraopeba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4344, NULL, 6142, 'Santa Maria', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4344, NULL, 6143, 'Barra São João', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (171, NULL, 6144, 'Benfica', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1090, NULL, 6145, 'Belo Horizonte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4645, NULL, 6146, 'Vale dos Vinhedos', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4645, NULL, 6147, 'Faria Lemos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4645, NULL, 6148, 'Tuiutí', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4645, NULL, 6149, 'São Pedro', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2311, NULL, 6150, 'Lelivéldia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2313, NULL, 6151, 'Umburaninha', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1483, NULL, 6152, 'São Caetano do Navio', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1484, NULL, 6153, 'Boas Novas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1484, NULL, 6154, 'Sapucarana', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4345, NULL, 6155, 'Guaporanga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4345, NULL, 6156, 'Sorocaba do Sul', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3946, NULL, 6157, 'Santo Antônio do Iratim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4346, NULL, 6158, 'Grande Garcia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4346, NULL, 6159, 'Itoupava', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3947, NULL, 6160, 'São José do Sobradinho', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2318, NULL, 6161, 'São José do Sobradinho', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3108, NULL, 6162, 'São José do Sobradinho', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3947, NULL, 6163, 'Santo Antônio do Pousalegre', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2318, NULL, 6164, 'Santo Antônio do Pousalegre', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3108, NULL, 6165, 'Santo Antônio do Pousalegre', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (919, NULL, 6166, 'Olho D''Água do Bezerril', '31', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (919, NULL, 6167, 'Ipiranga', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (919, NULL, 6168, 'Várzea da Ipueira', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (919, NULL, 6169, 'Águas Belas', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (919, NULL, 6170, 'Massapê dos Paes', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (919, NULL, 6171, 'Guia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (919, NULL, 6172, 'Boqueirão', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (919, NULL, 6173, 'Poço da Pedra', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (919, NULL, 6174, 'Jacampari', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (919, NULL, 6175, 'Ibuaçu', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (919, NULL, 6176, 'Olho d''Água dos Facundos', '32', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (919, NULL, 6177, 'Domingos da Costa', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4646, NULL, 6178, 'São João', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4648, NULL, 6179, 'Cadeado', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4648, NULL, 6180, 'Ponte Queimada', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4648, NULL, 6181, 'Formigueiro', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4648, NULL, 6182, 'Faxinal', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4648, NULL, 6183, 'Capela', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4648, NULL, 6184, 'Rincão do Tigre', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (86, NULL, 6185, 'Lago Preto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (86, NULL, 6186, 'Massauari', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1870, NULL, 6187, 'Brejo Novo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (87, NULL, 6188, 'Floriano Peixoto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2319, NULL, 6189, 'Mirantão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2320, NULL, 6190, 'Terra Branca', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2320, NULL, 6191, 'Alto Belo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1485, NULL, 6192, 'Claranã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1485, NULL, 6193, 'Feitoria', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5113, NULL, 6194, 'Morraria do Sul', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3343, NULL, 6195, 'São Roque Novo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1486, NULL, 6196, 'Barra do Brejo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1486, NULL, 6197, 'Caldeirões', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1486, NULL, 6198, 'Rainha Isabel', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1486, NULL, 6199, 'Lagoa de São José', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2321, NULL, 6200, 'Engenho do Ribeiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1487, NULL, 6201, 'Umari', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (482, NULL, 6202, 'Umari', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3183, NULL, 6203, 'Umari', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1487, NULL, 6204, 'Banquete', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (482, NULL, 6205, 'Banquete', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3183, NULL, 6206, 'Banquete', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1487, NULL, 6207, 'Bizarra', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (482, NULL, 6208, 'Bizarra', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3183, NULL, 6209, 'Bizarra', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1487, NULL, 6210, 'Encruzilhada', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (482, NULL, 6211, 'Encruzilhada', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3183, NULL, 6212, 'Encruzilhada', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1487, NULL, 6213, 'Tamboatá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (482, NULL, 6214, 'Tamboatá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3183, NULL, 6215, 'Tamboatá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1487, NULL, 6216, 'Barra Alegre', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (482, NULL, 6217, 'Barra Alegre', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3183, NULL, 6218, 'Barra Alegre', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1487, NULL, 6219, 'São José do Ribeirão', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (482, NULL, 6220, 'São José do Ribeirão', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3183, NULL, 6221, 'São José do Ribeirão', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2322, NULL, 6222, 'Tabuão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (696, NULL, 6223, 'Itaimbezinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1271, NULL, 6224, 'Itaimbezinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1092, NULL, 6225, 'Itaimbezinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4651, NULL, 6226, 'Itaimbezinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4349, NULL, 6227, 'Itaimbezinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (696, NULL, 6228, 'Casa Branca', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1271, NULL, 6229, 'Casa Branca', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1092, NULL, 6230, 'Casa Branca', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4651, NULL, 6231, 'Casa Branca', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4349, NULL, 6232, 'Casa Branca', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (696, NULL, 6233, 'Capela São Francisco', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1271, NULL, 6234, 'Capela São Francisco', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1092, NULL, 6235, 'Capela São Francisco', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4651, NULL, 6236, 'Capela São Francisco', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4349, NULL, 6237, 'Capela São Francisco', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (696, NULL, 6238, 'Capão do Tigre', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1271, NULL, 6239, 'Capão do Tigre', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1092, NULL, 6240, 'Capão do Tigre', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4651, NULL, 6241, 'Capão do Tigre', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4349, NULL, 6242, 'Capão do Tigre', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (696, NULL, 6243, 'Santo Inácio', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1271, NULL, 6244, 'Santo Inácio', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1092, NULL, 6245, 'Santo Inácio', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4651, NULL, 6246, 'Santo Inácio', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4349, NULL, 6247, 'Santo Inácio', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1871, NULL, 6248, 'Formoso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1871, NULL, 6249, 'Favelândia', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1872, NULL, 6250, 'Água Bela', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2325, NULL, 6251, 'Quartel do Sacramento', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2325, NULL, 6252, 'Passa Dez', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2325, NULL, 6253, 'Revés do Belém', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3184, NULL, 6254, 'Carabuçu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3184, NULL, 6255, 'Serrinha', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3184, NULL, 6256, 'Calheiros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3184, NULL, 6257, 'Rosal', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3184, NULL, 6258, 'Pirapetinga de Bom Jesus', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4351, NULL, 6259, 'Canoas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4654, NULL, 6260, 'Pinhal', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1272, NULL, 6261, 'Macaia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2327, NULL, 6262, 'Macaia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3953, NULL, 6263, 'Macaia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2328, NULL, 6264, 'Santo Antônio da Vargem Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (139, NULL, 6265, 'Santo Antônio da Vargem Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1873, NULL, 6266, 'Bastião', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1874, NULL, 6267, 'Alto Bonito', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5114, NULL, 6268, 'Alto Bonito', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1488, NULL, 6269, 'Alto Bonito', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (173, NULL, 6270, 'Alto Bonito', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1874, NULL, 6271, 'Bentevi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5114, NULL, 6272, 'Bentevi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1488, NULL, 6273, 'Bentevi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (173, NULL, 6274, 'Bentevi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1874, NULL, 6275, 'Águas de Miranda', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5114, NULL, 6276, 'Águas de Miranda', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1488, NULL, 6277, 'Águas de Miranda', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (173, NULL, 6278, 'Águas de Miranda', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1273, NULL, 6279, 'Viana', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1274, NULL, 6280, 'Marinho', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1875, NULL, 6281, 'Bucuituba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2331, NULL, 6282, 'Sertãozinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2331, NULL, 6283, 'Cervo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4656, NULL, 6284, 'Timbaúva', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4656, NULL, 6285, 'Ivaí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4656, NULL, 6286, 'Esquina Piratini', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2332, NULL, 6287, 'Palmeiral', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2332, NULL, 6288, 'São Gonçalo de Botelhos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3351, NULL, 6289, 'Vitoriana', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3351, NULL, 6290, 'Rubião Júnior', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2333, NULL, 6291, 'Adão Colares', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2333, NULL, 6292, 'Santa Cruz de Botumirim', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4657, NULL, 6293, 'Salto', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4658, NULL, 6294, 'Pedro Gárcia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (174, NULL, 6295, 'Caratateua', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (174, NULL, 6296, 'Tijoca', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (174, NULL, 6297, 'Almoço', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (174, NULL, 6298, 'Vila do Treme', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (174, NULL, 6299, 'Nova Mocajuba', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5115, NULL, 6300, 'Debrasa', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2336, NULL, 6301, 'Angicos de Minas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2336, NULL, 6302, 'Fernão Dias', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2336, NULL, 6303, 'Retiro de Santo Antônio', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2336, NULL, 6304, 'Vila de Fátima', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2336, NULL, 6305, 'Vargem Grande do Bom Jesus', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5195, NULL, 6306, 'Água da Prata', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3110, NULL, 6307, 'São Jorge de Oliveira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3110, NULL, 6308, 'Santa Rita de Brejetuba', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1491, NULL, 6309, 'Barra do Farias', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1491, NULL, 6310, 'Fazenda Nova', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1491, NULL, 6311, 'São Domingos', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1491, NULL, 6312, 'Mandaçaia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (176, NULL, 6313, 'São Raimundo do Araguaia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (920, NULL, 6314, 'São Filipe', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (920, NULL, 6315, 'Poço', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (178, NULL, 6316, 'Curumu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (178, NULL, 6317, 'Antônio Lemos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (178, NULL, 6318, 'São Miguel dos Macacos', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4659, NULL, 6319, 'Linha Pinheiro Machado', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3356, NULL, 6320, 'São Sebastião da Serra', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1879, NULL, 6321, 'Saudável', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1879, NULL, 6322, 'Ouricuri do Ouro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2339, NULL, 6323, 'São José do Paraopeba', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2339, NULL, 6324, 'Aranha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2339, NULL, 6325, 'Conceição de Itaguá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2339, NULL, 6326, 'Piedade do Paraopeba', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1880, NULL, 6327, 'Ubiraçaba', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1880, NULL, 6328, 'Cristalândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1880, NULL, 6329, 'Itaquaraí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2341, NULL, 6330, 'Curimataí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1493, NULL, 6331, 'Guanumbi', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1493, NULL, 6332, 'Carneiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1493, NULL, 6333, 'Catimbau', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (179, NULL, 6334, 'Guajará-Açu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3357, NULL, 6335, 'Aracaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (488, NULL, 6336, 'Bacatuba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2343, NULL, 6337, 'Serra Bonita', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (6, NULL, 6338, 'Serra Bonita', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2343, NULL, 6339, 'São Pedro do Passa Três', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (6, NULL, 6340, 'São Pedro do Passa Três', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2344, NULL, 6341, 'Sambaíba de Minas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2344, NULL, 6342, 'Paredão de Minas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2344, NULL, 6343, 'Cachoeira do Manteiga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4660, NULL, 6344, 'Cerro do Roque', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1278, NULL, 6345, 'Cupissura', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5116, NULL, 6346, 'Nova América', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5116, NULL, 6347, 'Cristalina', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1884, NULL, 6348, 'Geolândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2345, NULL, 6349, 'Palmital de Minas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1280, NULL, 6350, 'Renascer', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1494, NULL, 6351, 'Ponte dos Carvalhos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1494, NULL, 6352, 'Santo Agostinho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1494, NULL, 6353, 'Juçaral', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3185, NULL, 6354, 'Tamoios', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2346, NULL, 6355, 'São Bartolomeu de Minas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2346, NULL, 6356, 'Serra dos Lemes', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3361, NULL, 6357, 'Bom Fim do Bom Jesus', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3361, NULL, 6358, 'Jacaré', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4358, NULL, 6359, 'Taquara Verde', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4661, NULL, 6360, 'Bom Jardim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4661, NULL, 6361, 'Carajá Seival', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4661, NULL, 6362, 'Santa Bárbara', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4661, NULL, 6363, 'Forninho', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4661, NULL, 6364, 'Cerro do Martins', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4662, NULL, 6365, 'Saicã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4662, NULL, 6366, 'Umbu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5196, NULL, 6367, 'Bezerro Branco', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5196, NULL, 6368, 'Nova Cáceres', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5196, NULL, 6369, 'Horizonte do Oeste', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5196, NULL, 6370, 'Caramujo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1885, NULL, 6371, 'Santiago do Iguape', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1885, NULL, 6372, 'Belém da Cachoeira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2348, NULL, 6373, 'Itaim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2349, NULL, 6374, 'Águas Altas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4663, NULL, 6375, 'Ferreira', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4663, NULL, 6376, 'Três Vendas', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4663, NULL, 6377, 'Bosque', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4663, NULL, 6378, 'Barro Vermelho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4663, NULL, 6379, 'Cordilheira', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4663, NULL, 6380, 'Capané', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1281, NULL, 6381, 'São José de Marimbas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1281, NULL, 6382, 'Balanços', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1281, NULL, 6383, 'Fátima', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3186, NULL, 6384, 'Japuíba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3186, NULL, 6385, 'Subaio', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4664, NULL, 6386, 'Cabanas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (338, NULL, 6387, 'Cabanas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1496, NULL, 6388, 'Cabanas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3111, NULL, 6389, 'Gruta', '19', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3111, NULL, 6390, 'Coutinho', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3111, NULL, 6391, 'Itaoca', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3111, NULL, 6392, 'Gironda', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3111, NULL, 6393, 'Pacotuba', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3111, NULL, 6394, 'Conduru', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3111, NULL, 6395, 'Burarama', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3111, NULL, 6396, 'Vargem Grande do Soturno', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3111, NULL, 6397, 'Córrego dos Monos', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3111, NULL, 6398, 'São Vicente', '36', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4665, NULL, 6399, 'São Luís Rei', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (9, NULL, 6400, 'Riozinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3364, NULL, 6401, 'Barrânia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1888, NULL, 6402, 'Caldeirão', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1888, NULL, 6403, 'Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2352, NULL, 6404, 'Antônio dos Santos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2352, NULL, 6405, 'Penedia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2352, NULL, 6406, 'Morro Vermelho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2352, NULL, 6407, 'Roças Novas', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1889, NULL, 6408, 'Caldeiras', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1889, NULL, 6409, 'Brejinho das Ametistas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1889, NULL, 6410, 'Pajeú do Vento', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1889, NULL, 6411, 'Maniaçu', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1890, NULL, 6412, 'Canal', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3959, NULL, 6413, 'Simões', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3365, NULL, 6414, 'Simões', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3959, NULL, 6415, 'Bacuriti', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3365, NULL, 6416, 'Bacuriti', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3959, NULL, 6417, 'Cafesópolis', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3365, NULL, 6418, 'Cafesópolis', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3960, NULL, 6419, 'Guaiporã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3960, NULL, 6420, 'Jangada', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3366, NULL, 6421, 'Boa Esperança d''Oeste', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3366, NULL, 6422, 'Iubatinga', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4667, NULL, 6423, 'Ipuaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1285, NULL, 6424, 'Ipuaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1891, NULL, 6425, 'Gamboa', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1891, NULL, 6426, 'Velha Boipeba', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1891, NULL, 6427, 'Galeão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3369, NULL, 6428, 'Polvilho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3369, NULL, 6429, 'Jordanésia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (493, NULL, 6430, 'Boa Vista do Pindaré', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1286, NULL, 6431, 'Engenheiro Ávidos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3371, NULL, 6432, 'Monte Verde Paulista', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2354, NULL, 6433, 'Paraguai', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (295, NULL, 6434, 'Lourenço', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (295, NULL, 6435, 'Cunani', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2355, NULL, 6436, 'Santana de Caldas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2355, NULL, 6437, 'São Pedro de Caldas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2355, NULL, 6438, 'Laranjeiras de Caldas', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1893, NULL, 6439, 'São João do Panelinha', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1894, NULL, 6440, 'Abrantes', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1894, NULL, 6441, 'Monte Gordo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1289, NULL, 6442, 'Pindurão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1895, NULL, 6443, 'Tapuia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1895, NULL, 6444, 'Barcelos do Sul', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2357, NULL, 6445, 'Monte Verde', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2357, NULL, 6446, 'São Mateus de Minas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5117, NULL, 6447, 'Pontinha do Cocho', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4668, NULL, 6448, 'Bandeirinha', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4668, NULL, 6449, 'Bonito', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4668, NULL, 6450, 'Banhado do Colégio', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4668, NULL, 6451, 'Capela Santo Antônio', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4668, NULL, 6452, 'Capela Velha', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4668, NULL, 6453, 'Sant''Auta', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4668, NULL, 6454, 'Pacheca', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4670, NULL, 6455, 'Bom Retiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4670, NULL, 6456, 'Osvaldo Kroeff', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3963, NULL, 6457, 'Prata', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4361, NULL, 6458, 'Monte Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3187, NULL, 6459, 'Monte Verde', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3187, NULL, 6460, 'São João do Paraíso', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3187, NULL, 6461, 'Cruzeiro', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3187, NULL, 6462, 'Três Irmãos', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3187, NULL, 6463, 'Funil', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (182, NULL, 6464, 'Carapajó', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (182, NULL, 6465, 'Areião', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (182, NULL, 6466, 'Torres do Cupijó', '36', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (182, NULL, 6467, 'Januacoeli', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (182, NULL, 6468, 'Curuçambaba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (182, NULL, 6469, 'Moiraba', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (182, NULL, 6470, 'Vila do Carmo do Tocantins', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (182, NULL, 6471, 'Juaba', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (921, NULL, 6472, 'Guriú', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (921, NULL, 6473, 'Amarelas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3965, NULL, 6474, 'Herveira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3965, NULL, 6475, 'Bela Vista do Piquiri', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3965, NULL, 6476, 'Salles de Oliveira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3373, NULL, 6477, 'Salto', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1290, NULL, 6478, 'Galante', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1290, NULL, 6479, 'São José da Mata', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1290, NULL, 6480, 'Catolé', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2363, NULL, 6481, 'Honorópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5197, NULL, 6482, 'São José do Couto', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3374, NULL, 6483, 'Souzas', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3374, NULL, 6484, 'Joaquim Egídio', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3374, NULL, 6485, 'Nova Aparecida', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3374, NULL, 6486, 'Barão de Geraldo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5369, NULL, 6487, 'Colinaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4362, NULL, 6488, 'Bateias de Baixo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1663, NULL, 6489, 'Bateias de Baixo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4362, NULL, 6490, 'Fragosos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1663, NULL, 6491, 'Fragosos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1896, NULL, 6492, 'Peixe', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2365, NULL, 6493, 'Porto dos Mendes', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1897, NULL, 6494, 'Laje dos Negros', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5118, NULL, 6495, 'Anhanduí', '60', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1664, NULL, 6496, 'Anhanduí', '60', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5118, NULL, 6497, 'Rochedinho', '80', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1664, NULL, 6498, 'Rochedinho', '80', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3970, NULL, 6499, 'Três Córregos', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3970, NULL, 6500, 'Ferraria', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3970, NULL, 6501, 'São Silvestre', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3970, NULL, 6502, 'Bateias', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3375, NULL, 6503, 'Botujuru', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3972, NULL, 6504, 'Piquirivaí', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4675, NULL, 6505, 'Vila Turvo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5198, NULL, 6506, 'Itanorte', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5198, NULL, 6507, 'Marechal Rondon', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5199, NULL, 6508, 'Coronel Ponce', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2368, NULL, 6509, 'São Jerônimo dos Poções', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4676, NULL, 6510, 'Varame', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4676, NULL, 6511, 'Linha Ferrari', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4676, NULL, 6512, 'Volta Vitória', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4676, NULL, 6513, 'São José dos Campos Borges', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4676, NULL, 6514, 'Mundo Novo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4676, NULL, 6515, 'Rincão dos Toledos', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3188, NULL, 6516, 'Mussurepe', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3188, NULL, 6517, 'Dores de Macabu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3188, NULL, 6518, 'Tocos', '75', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3188, NULL, 6519, 'Santa Maria', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3188, NULL, 6520, 'São Sebastião de Campos', '65', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3188, NULL, 6521, 'Santo Eduardo', '55', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3188, NULL, 6522, 'Vila Nova de Campos', '85', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3188, NULL, 6523, 'Ibitioca', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3188, NULL, 6524, 'Morro do Coco', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3188, NULL, 6525, 'Serrinha', '70', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3188, NULL, 6526, 'Morangaba', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3188, NULL, 6527, 'Santo Amaro de Campos', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3188, NULL, 6528, 'Travessão', '80', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2369, NULL, 6529, 'Córrego do Ouro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4365, NULL, 6530, 'Guarani', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4365, NULL, 6531, 'Leão', '26', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4365, NULL, 6532, 'Dal''Pai', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4365, NULL, 6533, 'Ibicuí', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4365, NULL, 6534, 'Bela Vista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4365, NULL, 6535, 'Encruzilhada', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4365, NULL, 6536, 'Espinilho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (922, NULL, 6537, 'Itaguá', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (922, NULL, 6538, 'Carmelópolis', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (922, NULL, 6539, 'Quixariú', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (922, NULL, 6540, 'Barão de Aquiraz', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (922, NULL, 6541, 'Monte Castelo', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3378, NULL, 6542, 'Ariri', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1899, NULL, 6543, 'Paz de Salobro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5202, NULL, 6544, 'Paz de Salobro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1900, NULL, 6545, 'Poxim do Sul', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1900, NULL, 6546, 'Ouricana', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2373, NULL, 6547, 'Passé', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1902, NULL, 6548, 'Passé', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2373, NULL, 6549, 'Caroba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1902, NULL, 6550, 'Caroba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2373, NULL, 6551, 'Madeira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1902, NULL, 6552, 'Madeira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2373, NULL, 6553, 'Caboto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1902, NULL, 6554, 'Caboto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2373, NULL, 6555, 'Menino Jesus', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1902, NULL, 6556, 'Menino Jesus', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2373, NULL, 6557, 'Passagem dos Teixeiras', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1902, NULL, 6558, 'Passagem dos Teixeiras', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (11, NULL, 6559, 'Rio Preto do Candeias', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4677, NULL, 6560, 'Linha do Rio', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4677, NULL, 6561, 'Botucaraí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4677, NULL, 6562, 'Linha Brasil', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4677, NULL, 6563, 'Vila União', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4677, NULL, 6564, 'Pinheiro', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1903, NULL, 6565, 'Pilões', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3973, NULL, 6566, 'Tereza Cristina', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3973, NULL, 6567, 'Três Bicos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (495, NULL, 6568, 'Estandarte', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (495, NULL, 6569, 'Barão de Tromaí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3380, NULL, 6570, 'Frutal do Campo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3380, NULL, 6571, 'Nova Alexandria', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3380, NULL, 6572, 'Santo Antônio do Paranapanema', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1904, NULL, 6573, 'Quaraçu', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1904, NULL, 6574, 'Lagoa Grande', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4679, NULL, 6575, 'Baú', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4679, NULL, 6576, 'Seival', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4679, NULL, 6577, 'Passo Real de Candiota', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4679, NULL, 6578, 'Jaguarão Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4681, NULL, 6579, 'Quinto Distrito', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4681, NULL, 6580, 'Segundo Distrito', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4681, NULL, 6581, 'Terceiro Distrito', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4681, NULL, 6582, 'Quarto Distrito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1503, NULL, 6583, 'Olho d''Água de Dentro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1503, NULL, 6584, 'Paquevira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (923, NULL, 6585, 'Salitre', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (923, NULL, 6586, 'Ipueiras dos Gomes', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (923, NULL, 6587, 'Iguaçu', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (923, NULL, 6588, 'Caiçara', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (923, NULL, 6589, 'Capitão Pedro Sampaio', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (923, NULL, 6590, 'Esperança', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (923, NULL, 6591, 'Bonito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (923, NULL, 6592, 'Monte Alegre', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (923, NULL, 6593, 'Targinos', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (923, NULL, 6594, 'Campos', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4367, NULL, 6595, 'Marcílio Dias', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4367, NULL, 6596, 'Paula Pereira', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4367, NULL, 6597, 'Campo da Água Verde', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4367, NULL, 6598, 'Pinheiros', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4367, NULL, 6599, 'Felipe Schmidt', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3975, NULL, 6600, 'São Sebastião do Paraíba', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3189, NULL, 6601, 'São Sebastião do Paraíba', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2374, NULL, 6602, 'São Sebastião do Paraíba', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3975, NULL, 6603, 'Euclidelândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3189, NULL, 6604, 'Euclidelândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2374, NULL, 6605, 'Euclidelândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3975, NULL, 6606, 'Boa Sorte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3189, NULL, 6607, 'Boa Sorte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2374, NULL, 6608, 'Boa Sorte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3975, NULL, 6609, 'Santa Rita da Floresta', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3189, NULL, 6610, 'Santa Rita da Floresta', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2374, NULL, 6611, 'Santa Rita da Floresta', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1906, NULL, 6612, 'Bedengó', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (184, NULL, 6613, 'Mirasselvas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3976, NULL, 6614, 'Mirasselvas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (184, NULL, 6615, 'Pinheiro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3976, NULL, 6616, 'Pinheiro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (184, NULL, 6617, 'São Luiz', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3976, NULL, 6618, 'São Luiz', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (184, NULL, 6619, 'Cristo Rei', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3976, NULL, 6620, 'Cristo Rei', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (184, NULL, 6621, 'Tauari', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3976, NULL, 6622, 'Tauari', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3383, NULL, 6623, 'Apiaí-Mirim', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4684, NULL, 6624, 'Barretos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4685, NULL, 6625, 'Arroio Teixeira', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4685, NULL, 6626, 'Capão Novo', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4685, NULL, 6627, 'Curumim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4687, NULL, 6628, 'Pavão', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4687, NULL, 6629, 'Hidráulica', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4687, NULL, 6630, 'Passo das Pedras', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1666, NULL, 6631, 'Santa Efigênia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1762, NULL, 6632, 'Santa Efigênia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1666, NULL, 6633, 'Pedras', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1762, NULL, 6634, 'Pedras', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1666, NULL, 6635, 'Miranda', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1762, NULL, 6636, 'Miranda', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1666, NULL, 6637, 'Barracas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1762, NULL, 6638, 'Barracas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3384, NULL, 6639, 'Porto', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2378, NULL, 6640, 'Goianases', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1292, NULL, 6641, 'Olho D''Água do Serrão', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4369, NULL, 6642, 'Alto Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2382, NULL, 6643, 'Caçarema', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2382, NULL, 6644, 'Santana da Serra', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3977, NULL, 6645, 'Alto Alegre do Iguaçu', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4690, NULL, 6646, 'Rancho Velho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4690, NULL, 6647, 'Santa Rosa', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3386, NULL, 6648, 'Porto Novo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2385, NULL, 6649, 'Ponto do Marambaia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2385, NULL, 6650, 'Marambainha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2385, NULL, 6651, 'Maranhão', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1909, NULL, 6652, 'Vila Mariana', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2387, NULL, 6653, 'Pedra do Sino', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2387, NULL, 6654, 'Hermilo Alves', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2388, NULL, 6655, 'Ponte Alta de Minas', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2388, NULL, 6656, 'Alvorada', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2388, NULL, 6657, 'Lacerdinha', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3387, NULL, 6658, 'Vila Dirce', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3387, NULL, 6659, 'Aldeia de Carapicuíba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2389, NULL, 6660, 'Patrocínio de Caratinga', '24', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2389, NULL, 6661, 'Santa Efigênia de Caratinga', '26', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2389, NULL, 6662, 'São Cândido', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2389, NULL, 6663, 'Sapucaia', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2389, NULL, 6664, 'Santa Luzia de Caratinga', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2389, NULL, 6665, 'São João do Jacutinga', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2389, NULL, 6666, 'Dom Lara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2389, NULL, 6667, 'Santo Antônio do Manhuaçu', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2389, NULL, 6668, 'Cordeiro de Minas', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2389, NULL, 6669, 'Dom Modesto', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1099, NULL, 6670, 'São Geraldo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1293, NULL, 6671, 'São Geraldo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1910, NULL, 6672, 'Juerana', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1910, NULL, 6673, 'Ponta da Areia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1910, NULL, 6674, 'Santo Antônio de Barcelona', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4692, NULL, 6675, 'Pinheiro Marcado', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4692, NULL, 6676, 'São Bento', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3388, NULL, 6677, 'São João do Marinheiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3191, NULL, 6678, 'São Joaquim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3112, NULL, 6679, 'Itaquari', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (925, NULL, 6680, 'São Domingos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (925, NULL, 6681, 'Campos Belos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1912, NULL, 6682, 'Barra da Parateca', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1763, NULL, 6683, 'Altos Verdes', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (926, NULL, 6684, 'Tapuio', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (926, NULL, 6685, 'Jucá', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (926, NULL, 6686, 'Cacimbas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (926, NULL, 6687, 'Arariús', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (927, NULL, 6688, 'Miragem', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (927, NULL, 6689, 'Feitosa', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (927, NULL, 6690, 'Miguel Xavier', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (928, NULL, 6691, 'Bela Vista', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (928, NULL, 6692, 'Caipu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (928, NULL, 6693, 'São Bartolomeu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (928, NULL, 6694, 'São Sebastião', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3979, NULL, 6695, 'Nova Brasília do Itararé', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4693, NULL, 6696, 'Cinco da Boa Vista', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4693, NULL, 6697, 'Santo Antônio de Castro', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4693, NULL, 6698, 'Arco Verde', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4693, NULL, 6699, 'Santa Luiza', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2392, NULL, 6700, 'Presidente Pena', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2392, NULL, 6701, 'Epaminondas Otoni', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3192, NULL, 6702, 'Córrego da Prata', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3192, NULL, 6703, 'Porto Velho do Cunha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2394, NULL, 6704, 'Palmital do Cervo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2397, NULL, 6705, 'Santo Antônio da Serra', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2397, NULL, 6706, 'Bom Jesus de Angicos', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2397, NULL, 6707, 'São José dos Salgados', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2398, NULL, 6708, 'Quintinos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2399, NULL, 6709, 'Itaci', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2399, NULL, 6710, 'Vilelândia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1505, NULL, 6711, 'Ibitiranga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2401, NULL, 6712, 'Estrela da Barra', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2401, NULL, 6713, 'São Sebastião do Pontal', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2401, NULL, 6714, 'Fátima do Pontal', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1508, NULL, 6715, 'Gonçalves Ferreira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1508, NULL, 6716, 'Carapotós', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1508, NULL, 6717, 'Lajedo do Cedro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2404, NULL, 6718, 'Franceses', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3389, NULL, 6719, 'Venda Branca', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3389, NULL, 6720, 'Lagoa Branca', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1913, NULL, 6721, 'Luís Viana', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1913, NULL, 6722, 'Bem-Bom', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1913, NULL, 6723, 'Sobrado', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1913, NULL, 6724, 'Pau a Pique', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4695, NULL, 6725, 'Evangelista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (930, NULL, 6726, 'Sede Alvorada', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3980, NULL, 6727, 'Sede Alvorada', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (930, NULL, 6728, 'São Salvador', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3980, NULL, 6729, 'São Salvador', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (930, NULL, 6730, 'Rio do Salto', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3980, NULL, 6731, 'Rio do Salto', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (930, NULL, 6732, 'Cristais', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3980, NULL, 6733, 'Cristais', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (930, NULL, 6734, 'Guanacés', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3980, NULL, 6735, 'Guanacés', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (930, NULL, 6736, 'Jacarecoara', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3980, NULL, 6737, 'Jacarecoara', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (930, NULL, 6738, 'Pitombeiras', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3980, NULL, 6739, 'Pitombeiras', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (930, NULL, 6740, 'Diamante', '55', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3980, NULL, 6741, 'Diamante', '55', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (930, NULL, 6742, 'São João d''Oeste', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3980, NULL, 6743, 'São João d''Oeste', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (930, NULL, 6744, 'Caponga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3980, NULL, 6745, 'Caponga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (930, NULL, 6746, 'Juvinópolis', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3980, NULL, 6747, 'Juvinópolis', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (930, NULL, 6748, 'Espigão Azul', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3980, NULL, 6749, 'Espigão Azul', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3193, NULL, 6750, 'Barra de São João', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3193, NULL, 6751, 'Rio Dourado', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3193, NULL, 6752, 'Professor Souza', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5120, NULL, 6753, 'Indaiá do Sul', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (186, NULL, 6754, 'Apeú', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3113, NULL, 6755, 'Estrela do Norte', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3113, NULL, 6756, 'Patrimônio do Ouro', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3113, NULL, 6757, 'Limoeiro', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3113, NULL, 6758, 'Monte Pio', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3981, NULL, 6759, 'Abapã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3981, NULL, 6760, 'Socavão', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1914, NULL, 6761, 'Crussai', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1914, NULL, 6762, 'Petim', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1914, NULL, 6763, 'Sítio do Meio', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2408, NULL, 6764, 'Sereno', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2408, NULL, 6765, 'Vista Alegre', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2408, NULL, 6766, 'Cataguarino', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2408, NULL, 6767, 'Glória de Cataguases', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2408, NULL, 6768, 'Aracati de Minas', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5376, NULL, 6769, 'Santo Antônio do Rio Verde', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1510, NULL, 6770, 'Laje Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1296, NULL, 6771, 'Itajubatiba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1297, NULL, 6772, 'Coronel Maia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1297, NULL, 6773, 'Picos', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1916, NULL, 6774, 'Sítio Novo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1916, NULL, 6775, 'Bela Flor', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4697, NULL, 6776, 'Pontão Santo Antônio', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4697, NULL, 6777, 'Esquina Bom Sucesso', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4697, NULL, 6778, 'Santa Tereza', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4697, NULL, 6779, 'Colônia das Almas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4697, NULL, 6780, 'Passo Burmann', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4697, NULL, 6781, 'Esquina Brasil Neves', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (932, NULL, 6782, 'Paraíso', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (932, NULL, 6783, 'Video', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2412, NULL, 6784, 'Barreiro Branco', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (933, NULL, 6785, 'Bom Príncipio', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (933, NULL, 6786, 'Tucunduba', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (933, NULL, 6787, 'Mirambé', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (933, NULL, 6788, 'Catuana', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (933, NULL, 6789, 'Jurema', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (933, NULL, 6790, 'Sítios Novos', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (933, NULL, 6791, 'Guararu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4698, NULL, 6792, 'Vila Cristina', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4698, NULL, 6793, 'Santa Lúcia do Piaí', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4698, NULL, 6794, 'Oliva', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4698, NULL, 6795, 'Seca', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4698, NULL, 6796, 'Criúva', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4698, NULL, 6797, 'Fazenda Souza', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1511, NULL, 6798, 'Lagedo', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (934, NULL, 6799, 'Lagedo', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1511, NULL, 6800, 'São Miguel', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (934, NULL, 6801, 'São Miguel', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1511, NULL, 6802, 'Assunção', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (934, NULL, 6803, 'Assunção', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1511, NULL, 6804, 'Candeias', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (934, NULL, 6805, 'Candeias', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1511, NULL, 6806, 'Várzea da Conceição', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (934, NULL, 6807, 'Várzea da Conceição', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1511, NULL, 6808, 'Santo Antônio', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (934, NULL, 6809, 'Santo Antônio', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2415, NULL, 6810, 'Floresta', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4700, NULL, 6811, 'Alto Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4700, NULL, 6812, 'Vila Freire', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3984, NULL, 6813, 'São Sebastião', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4704, NULL, 6814, 'São Francisco', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4704, NULL, 6815, 'Santo Antônio', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3397, NULL, 6816, 'Fazenda Velha', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2418, NULL, 6817, 'Professor Sperber', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4705, NULL, 6818, 'São Miguel', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4705, NULL, 6819, 'Tesouras', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4705, NULL, 6820, 'Santana', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4705, NULL, 6821, 'Vila Rica', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4705, NULL, 6822, 'Boi Preto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2419, NULL, 6823, 'Cachoeira do Norte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2419, NULL, 6824, 'São Sebastião da Boa Vista', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2419, NULL, 6825, 'Granjas do Norte', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2419, NULL, 6826, 'Santa Rita do Araçuaí', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5205, NULL, 6827, 'Rio da Casca', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5205, NULL, 6828, 'Água Fria', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2420, NULL, 6829, 'Vila Retiro Velho', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2420, NULL, 6830, 'Vila Bom Jesus de Minas', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2420, NULL, 6831, 'Serra das Araras', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4376, NULL, 6832, 'Marechal Bormann', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4376, NULL, 6833, 'Gôio-En', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4376, NULL, 6834, 'Figueira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4376, NULL, 6835, 'Alto da Serra', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3398, NULL, 6836, 'Paraisolândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (935, NULL, 6837, 'Passagem', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3399, NULL, 6838, 'Irapé', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (187, NULL, 6839, 'São Sebastião de Viçosa', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2421, NULL, 6840, 'Penha Longa', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3986, NULL, 6841, 'São Francisco', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3986, NULL, 6842, 'São Luiz', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (936, NULL, 6843, 'Barbada', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (936, NULL, 6844, 'Caiçarinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (936, NULL, 6845, 'Monte Castelo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (936, NULL, 6846, 'Santa Rita', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (936, NULL, 6847, 'Maravilha', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (937, NULL, 6848, 'Triângulo', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (937, NULL, 6849, 'Timbaúba dos Marinheiros', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (937, NULL, 6850, 'Cedro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (937, NULL, 6851, 'Patos dos Liberatos', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (937, NULL, 6852, 'Campestre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3987, NULL, 6853, 'Vidigal', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3987, NULL, 6854, 'São Lourenço', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1920, NULL, 6855, 'São João da Fortaleza', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4711, NULL, 6856, 'Costa do Sol', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4712, NULL, 6857, 'São João Bosco', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4712, NULL, 6858, 'Cruzaltinha', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2424, NULL, 6859, 'Vista Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2425, NULL, 6860, 'Monsenhor João Alexandre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3400, NULL, 6861, 'Lauro Penteado', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3989, NULL, 6862, 'Coronel Firmino Martins', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3989, NULL, 6863, 'São Francisco de Sales', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1922, NULL, 6864, 'Itamotinga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1922, NULL, 6865, 'São Roque', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (95, NULL, 6866, 'Badajos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (507, NULL, 6867, 'São Raimundo de Codó', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (507, NULL, 6868, 'Codozinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3114, NULL, 6869, 'Ângelo Frechiani', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3114, NULL, 6870, 'Boapaba', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3114, NULL, 6871, 'Itapina', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3114, NULL, 6872, 'Baunilha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3114, NULL, 6873, 'Graça Aranha', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5384, NULL, 6874, 'Vila Borba', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5209, NULL, 6875, 'Guariba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3991, NULL, 6876, 'Vista Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4714, NULL, 6877, 'Vista Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3991, NULL, 6878, 'Alto Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4714, NULL, 6879, 'Alto Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3194, NULL, 6880, 'Afonso Arinos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2429, NULL, 6881, 'Água Branca de Minas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5210, NULL, 6882, 'Nova Alvorada', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5210, NULL, 6883, 'Padronal', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5210, NULL, 6884, 'Noroagro', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5210, NULL, 6885, 'Colônia dos Mineiros', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1299, NULL, 6886, 'Cardoso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1299, NULL, 6887, 'Montevidéo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3115, NULL, 6888, 'Itaúnas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3115, NULL, 6889, 'Braço do Rio', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2432, NULL, 6890, 'Poncianos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3195, NULL, 6891, 'Macabuzinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1925, NULL, 6892, 'Rio da Dona', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1925, NULL, 6893, 'Comércio', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1926, NULL, 6894, 'São João', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1926, NULL, 6895, 'Salgadália', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1926, NULL, 6896, 'Aroeira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1926, NULL, 6897, 'Joazeiro', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1926, NULL, 6898, 'Bandiaçu', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2435, NULL, 6899, 'Brejaúba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2435, NULL, 6900, 'Santo Antônio do Cruzeiro', '32', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2435, NULL, 6901, 'Tabuleiro do Mato Dentro', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2435, NULL, 6902, 'Santo Antônio do Norte', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2435, NULL, 6903, 'Itacolomi', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2435, NULL, 6904, 'São Sebastião do Bom Sucesso', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2435, NULL, 6905, 'Costa Sena', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2435, NULL, 6906, 'Senhora do Socorro', '36', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2435, NULL, 6907, 'Ouro Fino do Mato Dentro', '28', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2435, NULL, 6908, 'Córregos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2437, NULL, 6909, 'Águas de Contendas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3403, NULL, 6910, 'Tujuguaba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3404, NULL, 6911, 'Juquiratiba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4378, NULL, 6912, 'Presidente Kennedy', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4378, NULL, 6913, 'Tamanduá', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4378, NULL, 6914, 'Santo Antonio', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4378, NULL, 6915, 'Engenho Velho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4378, NULL, 6916, 'Planalto', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1301, NULL, 6917, 'Jacumã', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1928, NULL, 6918, 'Jacumã', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1929, NULL, 6919, 'Alegre', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2439, NULL, 6920, 'Cruz dos Araújos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2439, NULL, 6921, 'Olhos d''Água do Bom Jesus', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5211, NULL, 6922, 'Veranópolis', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2442, NULL, 6923, 'Lobo Leite', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2442, NULL, 6924, 'Alto Maranhão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3992, NULL, 6925, 'São Francisco de Imbaú', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3992, NULL, 6926, 'Santa Maria do Rio do Peixe', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2444, NULL, 6927, 'Jubaí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2444, NULL, 6928, 'Guaxima', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2445, NULL, 6929, 'Buarque de Macedo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2446, NULL, 6930, 'Barra do Cuieté', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2446, NULL, 6931, 'Bueno', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2446, NULL, 6932, 'Ferruginha', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2446, NULL, 6933, 'Penha do Norte', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2446, NULL, 6934, 'Cuieté Velho', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4716, NULL, 6935, 'Barra Curta Baixa', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4716, NULL, 6936, 'Capinzal', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4716, NULL, 6937, 'São Marcos Baixo', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2448, NULL, 6938, 'Parque Industrial', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3994, NULL, 6939, 'Catanduvas do Sul', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1930, NULL, 6940, 'Caraibuna', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2449, NULL, 6941, 'Frei Eustáquio', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4717, NULL, 6942, 'Arroio da Laje', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4718, NULL, 6943, 'Rio Bonito', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4718, NULL, 6944, 'Igrejinha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4718, NULL, 6945, 'Serra do Pontão', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4718, NULL, 6946, 'Xadrez', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2450, NULL, 6947, 'Luiz Pires de Minas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2450, NULL, 6948, 'Ponte dos Ciganos', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2450, NULL, 6949, 'Alvação', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2450, NULL, 6950, 'São Joaquim', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2450, NULL, 6951, 'São Geraldo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2450, NULL, 6952, 'Aristides Batista', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1931, NULL, 6953, 'Retiro', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1931, NULL, 6954, 'Itacava', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3995, NULL, 6955, 'Nossa Senhora da Penha', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3995, NULL, 6956, 'Ouro Verde do Piquiri', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2451, NULL, 6957, 'Lagoa Bonita', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (938, NULL, 6958, 'Ubaúna', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (938, NULL, 6959, 'Araquém', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (938, NULL, 6960, 'Canto', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (938, NULL, 6961, 'Aroeiras', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5122, NULL, 6962, 'Baianópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1933, NULL, 6963, 'Descoberto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2453, NULL, 6964, 'Beltrão', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2453, NULL, 6965, 'Contria', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3996, NULL, 6966, 'Congonhas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2454, NULL, 6967, 'Conceição de Tronqueiras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2454, NULL, 6968, 'São Sebastião do Bugre', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2455, NULL, 6969, 'Pântano de Santa Cruz', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2455, NULL, 6970, 'Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2455, NULL, 6971, 'Lagamar dos Coqueiros', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2455, NULL, 6972, 'Mateiro', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2455, NULL, 6973, 'Santa Rosa dos Dourados', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4720, NULL, 6974, 'Campo Santo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4720, NULL, 6975, 'Turvinho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4720, NULL, 6976, 'Antônio Kerpel', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2456, NULL, 6977, 'Senador Melo Viana', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2457, NULL, 6978, 'Barra do Salinas', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2457, NULL, 6979, 'Freire Cardoso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3998, NULL, 6980, 'Vista Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2460, NULL, 6981, 'Cachoeirinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1515, NULL, 6982, 'Poço Comprido', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1935, NULL, 6983, 'São Manoel do Norte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5124, NULL, 6984, 'Porto Esperança', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5124, NULL, 6985, 'Coimbra', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5124, NULL, 6986, 'Nhecolândia', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5124, NULL, 6987, 'Albuquerque', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5124, NULL, 6988, 'Paiaguás', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5124, NULL, 6989, 'Amolar', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1672, NULL, 6990, 'Poxim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (17, NULL, 6991, 'Príncipe da Beira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5125, NULL, 6992, 'Paraíso', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5125, NULL, 6993, 'Baús', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1936, NULL, 6994, 'Jupaguá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1936, NULL, 6995, 'Taguá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3411, NULL, 6996, 'Caucaia do Alto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4722, NULL, 6997, 'Lageado Bonito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5126, NULL, 6998, 'Jauru', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5126, NULL, 6999, 'Taquari', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5126, NULL, 7000, 'São Romão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (939, NULL, 7001, 'Montenebo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (939, NULL, 7002, 'Tucuns', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (939, NULL, 7003, 'Oiticica', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (939, NULL, 7004, 'Realejo', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (939, NULL, 7005, 'Irapuá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (939, NULL, 7006, 'Curral Velho', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (939, NULL, 7007, 'Santo Antônio', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (939, NULL, 7008, 'Santana', '37', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (939, NULL, 7009, 'Assis', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (939, NULL, 7010, 'Poti', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (939, NULL, 7011, 'Ibiapaba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (939, NULL, 7012, 'Lagoa das Pedras', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (940, NULL, 7013, 'Bela Vista', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (940, NULL, 7014, 'Santa Fé', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (940, NULL, 7015, 'Baixio das Palmeiras', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (940, NULL, 7016, 'Belmonte', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (940, NULL, 7017, 'Santa Rosa', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (940, NULL, 7018, 'Dom Quintino', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (940, NULL, 7019, 'Monte Alverne', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (940, NULL, 7020, 'Campo Alegre', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (940, NULL, 7021, 'Ponta da Serra', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4384, NULL, 7022, 'Rio Maina', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2465, NULL, 7023, 'Nova Santa Luzia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1938, NULL, 7024, 'Buril', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4724, NULL, 7025, 'Esquina Gaúcha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4724, NULL, 7026, 'Vista Nova', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4724, NULL, 7027, 'Lajeado Grande', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4724, NULL, 7028, 'Planalto', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4725, NULL, 7029, 'Bom Será', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4725, NULL, 7030, 'Cordeiro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4725, NULL, 7031, 'Passo do Mendonça', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5388, NULL, 7032, 'Campos Lindos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2468, NULL, 7033, 'São Caetano', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5390, NULL, 7034, 'Auriverde', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (941, NULL, 7035, 'Betânia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (941, NULL, 7036, 'Repartição', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (941, NULL, 7037, 'Vista Alegre', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (941, NULL, 7038, 'São Roque', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (941, NULL, 7039, 'Santa Tereza', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (941, NULL, 7040, 'Barra do Sotero', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (941, NULL, 7041, 'Lagoa da Cruz', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (942, NULL, 7042, 'Caiçara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4727, NULL, 7043, 'Colônia São João', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4000, NULL, 7044, 'Santana', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4000, NULL, 7045, 'Pinaré', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2471, NULL, 7046, 'Brejo Bonito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4002, NULL, 7047, 'Cafeeiros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4002, NULL, 7048, 'São Silvestre', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5214, NULL, 7049, 'Coxipó da Ponte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5214, NULL, 7050, 'Coxipó do Ouro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5214, NULL, 7051, 'Guia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1307, NULL, 7052, 'Melo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1517, NULL, 7053, 'Ameixas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3417, NULL, 7054, 'Campos de Cunha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2473, NULL, 7055, 'Aldeia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1518, NULL, 7056, 'Laje de São José', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1941, NULL, 7057, 'Riacho Seco', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1941, NULL, 7058, 'Poço de Fora', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1941, NULL, 7059, 'Barro Vermelho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1941, NULL, 7060, 'Patamuté', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4387, NULL, 7061, 'Marombas Bossardi', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4387, NULL, 7062, 'Santa Cruz do Pery', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4006, NULL, 7063, 'Alecrim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2474, NULL, 7064, 'Maristela de Minas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (193, NULL, 7065, 'Piriá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (195, NULL, 7066, 'Ponta de Ramos', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (195, NULL, 7067, 'Murajá', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (195, NULL, 7068, 'Lauro Sodré', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2475, NULL, 7069, 'J.K.', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2475, NULL, 7070, 'Tomás Gonzaga', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2475, NULL, 7071, 'Angueretá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2475, NULL, 7072, 'Santa Rita do Cedro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1519, NULL, 7073, 'Maravilha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1519, NULL, 7074, 'Quitimbu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2478, NULL, 7075, 'Babilônia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2478, NULL, 7076, 'Olhos D''Água da Canastra', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5127, NULL, 7077, 'Vila União', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5127, NULL, 7078, 'Porto Vilma', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5127, NULL, 7079, 'Presidente Castelo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5127, NULL, 7080, 'Lagoa Bonita', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (943, NULL, 7081, 'Baixio', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (943, NULL, 7082, 'Maratoã', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (943, NULL, 7083, 'Aurora', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (943, NULL, 7084, 'Velame', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (943, NULL, 7085, 'Betânia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4388, NULL, 7086, 'Itajubá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2481, NULL, 7087, 'Pereirinhas', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2481, NULL, 7088, 'São Sebastião do Gil', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1314, NULL, 7089, 'Vazante', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2483, NULL, 7090, 'Planalto de Minas', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2483, NULL, 7091, 'Senador Mourão', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2483, NULL, 7092, 'Guinda', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2483, NULL, 7093, 'Extração', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2483, NULL, 7094, 'São João da Chapada', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2483, NULL, 7095, 'Sopa', '55', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2483, NULL, 7096, 'Desembargador Otoni', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2483, NULL, 7097, 'Conselheiro Mata', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2483, NULL, 7098, 'Mendanha', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2483, NULL, 7099, 'Inhaí', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2485, NULL, 7100, 'Baixa Verde', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2485, NULL, 7101, 'Conceição de Minas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4389, NULL, 7102, 'Idamar', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4389, NULL, 7103, 'Jorge Lacerda', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4389, NULL, 7104, 'São Pedro Tobias', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2487, NULL, 7105, 'Bom Jesus do Divino', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2487, NULL, 7106, 'Viletes', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2488, NULL, 7107, 'Central de Santa Helena', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3421, NULL, 7108, 'Campestrinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2490, NULL, 7109, 'Santo Antônio dos Campos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3423, NULL, 7110, 'Guarapuã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5128, NULL, 7111, 'Palmeiras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4010, NULL, 7112, 'Santa Lúcia', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5218, NULL, 7113, 'Entre Rios', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2496, NULL, 7114, 'Gororós', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4738, NULL, 7115, 'Torquato Severo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4739, NULL, 7116, 'Arroio dos Mengues', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4739, NULL, 7117, 'Porto Colônia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4739, NULL, 7118, 'Morro dos Leffas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3118, NULL, 7119, 'Paraju', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3118, NULL, 7120, 'Melgaço', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3118, NULL, 7121, 'Biriricas', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3118, NULL, 7122, 'Aracê', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3118, NULL, 7123, 'Isabel', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2499, NULL, 7124, 'São Manoel do Guaiaçu', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3119, NULL, 7125, 'São Raimundo da Pedra Menina', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3119, NULL, 7126, 'Mundo Novo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1520, NULL, 7127, 'Lagoas', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1520, NULL, 7128, 'Caatinga Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1520, NULL, 7129, 'Lagoa de Fora', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1520, NULL, 7130, 'Monte Orebe', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4011, NULL, 7131, 'Cruzaltina', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5129, NULL, 7132, 'Cruzaltina', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4011, NULL, 7133, 'Bocajá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5129, NULL, 7134, 'Bocajá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5130, NULL, 7135, 'Picadinha', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5130, NULL, 7136, 'Vila Formosa', '48', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5130, NULL, 7137, 'Guaçu', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5130, NULL, 7138, 'São Pedro', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5130, NULL, 7139, 'Vila Vargas', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5130, NULL, 7140, 'Itaum', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5130, NULL, 7141, 'Panambi', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5130, NULL, 7142, 'Indápolis', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4741, NULL, 7143, 'Pitanga', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4741, NULL, 7144, 'Pranchada', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3426, NULL, 7145, 'Jaciporã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3426, NULL, 7146, 'Jamaica', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3197, NULL, 7147, 'Fazenda do Campo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3197, NULL, 7148, 'Monnerat', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3197, NULL, 7149, 'Vargem Grande', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3198, NULL, 7150, 'Imbariê', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3198, NULL, 7151, 'Xerém', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3198, NULL, 7152, 'Campos Elyseos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2506, NULL, 7153, 'São João da Figueira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2506, NULL, 7154, 'São José da Figueira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3120, NULL, 7155, 'Imburana', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3120, NULL, 7156, 'Prata dos Baianos', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3120, NULL, 7157, 'Santa Terezinha', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3120, NULL, 7158, 'Joaçuba', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3120, NULL, 7159, 'Muritiba', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3120, NULL, 7160, 'Cotaxé', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3120, NULL, 7161, 'Santa Luzia do Norte', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3430, NULL, 7162, 'Itapeúna', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5131, NULL, 7163, 'Itapeúna', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3430, NULL, 7164, 'Morumbi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5131, NULL, 7165, 'Morumbi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3430, NULL, 7166, 'Braço', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5131, NULL, 7167, 'Braço', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4743, NULL, 7168, 'Bom Retiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4743, NULL, 7169, 'Parque Eldorado', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3431, NULL, 7170, 'Cardeal', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1946, NULL, 7171, 'Monte Cruzeiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3435, NULL, 7172, 'Cipó-Guaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4744, NULL, 7173, 'Valdástico', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4745, NULL, 7174, 'Cerro Partido', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4745, NULL, 7175, 'Santa Bárbara', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4745, NULL, 7176, 'Coronel Prestes', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4745, NULL, 7177, 'Capitão Noronha', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4745, NULL, 7178, 'Maria Santa', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4745, NULL, 7179, 'Pompeu Machado', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4014, NULL, 7180, 'Pinhalzinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4014, NULL, 7181, 'Vista Alegre', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4015, NULL, 7182, 'Ivailândia', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4015, NULL, 7183, 'Triângulo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4015, NULL, 7184, 'Sertãozinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4015, NULL, 7185, 'Figueira do Oeste', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4015, NULL, 7186, 'Sussuí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2508, NULL, 7187, 'Divino do Traíra', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2508, NULL, 7188, 'São José do Acácio', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2509, NULL, 7189, 'São Norberto', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3199, NULL, 7190, 'Sacra Família do Tinguá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4392, NULL, 7191, 'Ibatuí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1948, NULL, 7192, 'Ibatuí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4392, NULL, 7193, 'Subaúma', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1948, NULL, 7194, 'Subaúma', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2511, NULL, 7195, 'Serra do Camapuã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4750, NULL, 7196, 'Jaguaretê', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4750, NULL, 7197, 'Capo-Erê', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (944, NULL, 7198, 'Tomé Vieira', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (944, NULL, 7199, 'São João', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4752, NULL, 7200, 'Goio-Ên', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4752, NULL, 7201, 'Sete de Setembro', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4752, NULL, 7202, 'Santana', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4752, NULL, 7203, 'Pinhalzinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4753, NULL, 7204, 'São Bom Jesus', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4753, NULL, 7205, 'Arco Íris', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4753, NULL, 7206, 'Vista Gaúcha', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4753, NULL, 7207, 'Capivara', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4753, NULL, 7208, 'Coronel Finzito', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4753, NULL, 7209, 'Fortaleza', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4394, NULL, 7210, 'Barra Fria', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1521, NULL, 7211, 'Frexeiras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4754, NULL, 7212, 'São Sebastião', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2513, NULL, 7213, 'Andiroba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2513, NULL, 7214, 'Melo Viana', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2514, NULL, 7215, 'São José da Pedra Menina', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4755, NULL, 7216, 'Bom Jardim', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4755, NULL, 7217, 'Ismael', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4755, NULL, 7218, 'Açoita Cavalo', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4755, NULL, 7219, 'Lara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (19, NULL, 7220, 'Boa Vista do Pacarana', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (19, NULL, 7221, 'Novo Paraíso', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (19, NULL, 7222, 'Nova Esperança', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (19, NULL, 7223, 'Flor da Serra', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2515, NULL, 7224, 'Itamirim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1950, NULL, 7225, 'São José do Mucambo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1950, NULL, 7226, 'Palame', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4756, NULL, 7227, 'Avelino Paranhos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4756, NULL, 7228, 'Volta Alegre', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4756, NULL, 7229, 'Depósito', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4756, NULL, 7230, 'Campina Redonda', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2517, NULL, 7231, 'Pântano', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4760, NULL, 7232, 'Glória', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4760, NULL, 7233, 'Costão', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4760, NULL, 7234, 'Novo Paraíso', '26', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4760, NULL, 7235, 'Delfina', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2518, NULL, 7236, 'Água Viva', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2519, NULL, 7237, 'Baú', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2520, NULL, 7238, 'Dolearina', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2520, NULL, 7239, 'São Félix de Estrela', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2520, NULL, 7240, 'Chapada de Minas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2520, NULL, 7241, 'Santa Rita da Estrela', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4761, NULL, 7242, 'São Luiz', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4761, NULL, 7243, 'Rincão da Estrela', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4761, NULL, 7244, 'Itaúba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1951, NULL, 7245, 'Aribice', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1951, NULL, 7246, 'Caimbe', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1951, NULL, 7247, 'Massacará', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2521, NULL, 7248, 'Queirozes', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2521, NULL, 7249, 'Gavião', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2521, NULL, 7250, 'Pinhotiba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1522, NULL, 7251, 'Viração', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1522, NULL, 7252, 'Tabocas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1522, NULL, 7253, 'Timorante', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1522, NULL, 7254, 'Zé Gomes', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5402, NULL, 7255, 'Caiçara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5402, NULL, 7256, 'Jeroaquara', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (946, NULL, 7257, 'Nova Betânia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (946, NULL, 7258, 'Quincuncá', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (946, NULL, 7259, 'Cariutaba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (198, NULL, 7260, 'Nova Maracanã', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4764, NULL, 7261, 'Nova Sardenha', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4764, NULL, 7262, 'Nova Milano', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4764, NULL, 7263, 'Jansen', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5132, NULL, 7264, 'Culturama', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4020, NULL, 7265, 'Nova Altamira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4395, NULL, 7266, 'Barra Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5403, NULL, 7267, 'Serra Dourada', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5403, NULL, 7268, 'Bacilândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1954, NULL, 7269, 'Ramalho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1955, NULL, 7270, 'Matinha', '38', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1955, NULL, 7271, 'Tiquaruçu', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1955, NULL, 7272, 'Governador Dr. João Durval Carneiro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1955, NULL, 7273, 'Jaíba', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1955, NULL, 7274, 'Bonfim da Feira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1955, NULL, 7275, 'Humildes', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1955, NULL, 7276, 'Maria Quitéria', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1955, NULL, 7277, 'Jaguara', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2528, NULL, 7278, 'São Geraldo do Salto', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2528, NULL, 7279, 'São José do Buriti', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4022, NULL, 7280, 'Bela Vista do Ivaí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4022, NULL, 7281, 'Porteira Preta', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2529, NULL, 7282, 'Senhora da Penha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3445, NULL, 7283, 'Agulha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3446, NULL, 7284, 'Brasitânia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3448, NULL, 7285, 'Santa Margarida Paulista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3448, NULL, 7286, 'Santo Antônio Paulista', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2530, NULL, 7287, 'Santo Antônio da Fortaleza', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2530, NULL, 7288, 'Borba Gato', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2530, NULL, 7289, 'Sete Cachoeiras', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2530, NULL, 7290, 'Esmeraldas de Ferros', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2530, NULL, 7291, 'Cubas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2530, NULL, 7292, 'Santa Rita do Rio do Peixe', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2531, NULL, 7293, 'São Pedro do Glória', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2531, NULL, 7294, 'Bom Jesus do Madeira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (362, NULL, 7295, 'Bielândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1956, NULL, 7296, 'Bielândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1957, NULL, 7297, 'Itaiá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4026, NULL, 7298, 'Nova Bilac', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1526, NULL, 7299, 'Fátima', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1526, NULL, 7300, 'Sítio dos Nunes', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4769, NULL, 7301, 'Mato Perso', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4769, NULL, 7302, 'Otávio Rocha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4027, NULL, 7303, 'Nazaré do Pico', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1527, NULL, 7304, 'Nazaré do Pico', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4027, NULL, 7305, 'Airi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1527, NULL, 7306, 'Airi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4397, NULL, 7307, 'São João do Rio Vermelho', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4397, NULL, 7308, 'Ratones', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4397, NULL, 7309, 'Ribeirão da Ilha', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4397, NULL, 7310, 'Canasvieiras', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4397, NULL, 7311, 'Barra da Lagoa', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4397, NULL, 7312, 'Pântano do Sul', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4397, NULL, 7313, 'Ingleses do Rio Vermelho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4397, NULL, 7314, 'Cachoeira do Bom Jesus', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4397, NULL, 7315, 'Campeche', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4397, NULL, 7316, 'Lagoa da Conceição', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4397, NULL, 7317, 'Santo Antônio de Lisboa', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3451, NULL, 7318, 'Indaiá do Aguapeí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3451, NULL, 7319, 'Atlântida', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4771, NULL, 7320, 'Três Pinheiros', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4771, NULL, 7321, 'Campo Novo', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4771, NULL, 7322, 'Gramado São Pedro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4771, NULL, 7323, 'Linha Silveira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2533, NULL, 7324, 'Baiões', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2533, NULL, 7325, 'Albertos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2533, NULL, 7326, 'Pontevila', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5406, NULL, 7327, 'Santa Rosa', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5406, NULL, 7328, 'Juscelino Kubitschek', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5406, NULL, 7329, 'Bezerra', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2534, NULL, 7330, 'Goiasminas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5407, NULL, 7331, 'Goiasminas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (947, NULL, 7332, 'Trapiá', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (947, NULL, 7333, 'Salgado dos Mendes', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (948, NULL, 7334, 'Mondubim', '70', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (948, NULL, 7335, 'Messejana', '65', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (948, NULL, 7336, 'Parangaba', '75', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (948, NULL, 7337, 'Antônio Bezerra', '60', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4774, NULL, 7338, 'Fazenda Colorado', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (949, NULL, 7339, 'Maceió', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (949, NULL, 7340, 'Viçosa', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (949, NULL, 7341, 'Barra', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (949, NULL, 7342, 'Guajiru', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (949, NULL, 7343, 'Campestre', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4031, NULL, 7344, 'Alvorada do Iguaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4033, NULL, 7345, 'Rio Bonito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2537, NULL, 7346, 'Tocoiós de Minas', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4034, NULL, 7347, 'Nova Concórdia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4034, NULL, 7348, 'São Pio X', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4034, NULL, 7349, 'Jacutinga', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4034, NULL, 7350, 'Secção Jacaré', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2539, NULL, 7351, 'Canabrava', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2539, NULL, 7352, 'Catuni', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2540, NULL, 7353, 'Antônio Ferreira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4775, NULL, 7354, 'Osvaldo Cruz', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4775, NULL, 7355, 'Castelinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1528, NULL, 7356, 'Lagoa de João Carlos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4401, NULL, 7357, 'Nucleo Triticola', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2544, NULL, 7358, 'Santo Antônio do Rio Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2547, NULL, 7359, 'Aparecida de Minas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3121, NULL, 7360, 'Timbuí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3121, NULL, 7361, 'Praia Grande', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3121, NULL, 7362, 'Irundi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2549, NULL, 7363, 'Sapucaia do Norte', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2549, NULL, 7364, 'Santa Cruz de Galiléia', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1529, NULL, 7365, 'José da Costa', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1529, NULL, 7366, 'Cuiambuca', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2550, NULL, 7367, 'Jacu das Piranhas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1530, NULL, 7368, 'Iratama', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1530, NULL, 7369, 'São Pedro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1530, NULL, 7370, 'Miracica', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1772, NULL, 7371, 'Lagoa Funda', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1772, NULL, 7372, 'São Mateus da Palestina', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3458, NULL, 7373, 'Jafa', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4776, NULL, 7374, 'São José de Costa Real', '28', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4776, NULL, 7375, 'Marcorama', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4778, NULL, 7376, 'Baliza', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4779, NULL, 7377, 'Santo Amaro do Sul', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4779, NULL, 7378, 'Boca da Picada', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4779, NULL, 7379, 'Boqueirão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4035, NULL, 7380, 'Paredão Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5222, NULL, 7381, 'Paredão Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4035, NULL, 7382, 'Jangada do Sul', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5222, NULL, 7383, 'Jangada do Sul', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3461, NULL, 7384, 'Prudêncio e Moraes', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4780, NULL, 7385, 'Campo do Meio', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1962, NULL, 7386, 'Itajubaquara', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1962, NULL, 7387, 'Pituba', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1962, NULL, 7388, 'Ibitunane', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1962, NULL, 7389, 'Santo Inácio', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1962, NULL, 7390, 'Gameleira do Assuruá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3462, NULL, 7391, 'Macucos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3462, NULL, 7392, 'Santa América', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4781, NULL, 7393, 'Rio Toldo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4781, NULL, 7394, 'Souza Ramos', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4782, NULL, 7395, 'Cândido Freire', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4782, NULL, 7396, 'Mato Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4782, NULL, 7397, 'São Paulo das Tunas', '26', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4782, NULL, 7398, 'Rincão dos Mellos', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4782, NULL, 7399, 'Quinze de Novembro', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4782, NULL, 7400, 'Rincão Maciel', '24', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3463, NULL, 7401, 'Juritis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5223, NULL, 7402, 'Monte Castelo D''Oeste', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5134, NULL, 7403, 'Nova Esperança', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5134, NULL, 7404, 'Guaçulândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1531, NULL, 7405, 'Apoti', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4783, NULL, 7406, 'Maracanã', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4783, NULL, 7407, 'Vila Nova', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4783, NULL, 7408, 'Capão Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (523, NULL, 7409, 'Aurizona', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1532, NULL, 7410, 'Tejucopapo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2553, NULL, 7411, 'Tejucopapo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1532, NULL, 7412, 'Ponta de Pedras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2553, NULL, 7413, 'Ponta de Pedras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5411, NULL, 7414, 'Natinópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5412, NULL, 7415, 'Vila Rica', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5414, NULL, 7416, 'São João', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5414, NULL, 7417, 'Calcilândia', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5414, NULL, 7418, 'Uvá', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5414, NULL, 7419, 'Buenolândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5414, NULL, 7420, 'Davidópolis', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (366, NULL, 7421, 'Craolândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (366, NULL, 7422, 'Cartucho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5415, NULL, 7423, 'Marcianópolis', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1964, NULL, 7424, 'Tapirama', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2555, NULL, 7425, 'Conceição da Brejaúba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (20, NULL, 7426, 'Colina Verde', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3122, NULL, 7427, 'Moacir Ávidos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3122, NULL, 7428, 'Novo Brasil', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3122, NULL, 7429, 'Morello', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2557, NULL, 7430, 'Chonin de Baixo', '28', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2557, NULL, 7431, 'São Vítor', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2557, NULL, 7432, 'Chonim', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2557, NULL, 7433, 'Alto de Santa Helena', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2557, NULL, 7434, 'Brejaubinha', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2557, NULL, 7435, 'Baguari', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2557, NULL, 7436, 'Santo Antônio do Pontal', '37', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2557, NULL, 7437, 'Penha do Cassiano', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2557, NULL, 7438, 'Derribadinha', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2557, NULL, 7439, 'Goiabal', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2557, NULL, 7440, 'Vila Nova Floresta', '55', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2557, NULL, 7441, 'São José do Itapinoã', '42', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (952, NULL, 7442, 'Lapa', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4039, NULL, 7443, 'Ribeirão Bonito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (953, NULL, 7444, 'Ibuguaçu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (953, NULL, 7445, 'Adrianópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (953, NULL, 7446, 'Parazinho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (953, NULL, 7447, 'Timonha', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (953, NULL, 7448, 'Sambaíba', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (953, NULL, 7449, 'Pessoa Anta', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2558, NULL, 7450, 'Barrocão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2558, NULL, 7451, 'Vale das Cancelas', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2558, NULL, 7452, 'Vila Sítio', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4407, NULL, 7453, 'Aiurê', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4407, NULL, 7454, 'Invernada', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1534, NULL, 7455, 'Mandacaru', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1534, NULL, 7456, 'Uruçu-Mirim', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4787, NULL, 7457, 'Barro Vermelho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4787, NULL, 7458, 'Morungava', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4787, NULL, 7459, 'Ipiranga', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4787, NULL, 7460, 'Itacolomi', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (955, NULL, 7461, 'Itamaracá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3123, NULL, 7462, 'São Pedro de Rates', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3123, NULL, 7463, 'São Miguel do Caparaó', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3123, NULL, 7464, 'São Tiago', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3465, NULL, 7465, 'Fátima', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3466, NULL, 7466, 'Doutor Oliveira Castro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4040, NULL, 7467, 'Doutor Oliveira Castro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (956, NULL, 7468, 'Núcleo Colonial Pio XII (São Gerônimo)', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (956, NULL, 7469, 'Água Verde', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (956, NULL, 7470, 'Dourado', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (956, NULL, 7471, 'Baú', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (956, NULL, 7472, 'Itacima', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (21, NULL, 7473, 'Surpresa', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (21, NULL, 7474, 'Iata', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1968, NULL, 7475, 'Morrinhos', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1968, NULL, 7476, 'Ceraíma', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1968, NULL, 7477, 'Mutãs', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2560, NULL, 7478, 'Correntinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2560, NULL, 7479, 'Sapucaia de Guanhães', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2560, NULL, 7480, 'Farias', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2560, NULL, 7481, 'Taquaral de Guanhães', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2561, NULL, 7482, 'Araúna', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4790, NULL, 7483, 'Colombo', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4790, NULL, 7484, 'Santo Antônio', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3469, NULL, 7485, 'Pioneiros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1322, NULL, 7486, 'Cachoeira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4045, NULL, 7487, 'Bentópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3471, NULL, 7488, 'Bentópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2562, NULL, 7489, 'Ouro Verde', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4410, NULL, 7490, 'Ouro Verde', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (957, NULL, 7491, 'Várzea dos Espinhos', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (957, NULL, 7492, 'Sussuanha', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (957, NULL, 7493, 'Morrinhos Novos', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (957, NULL, 7494, 'Mucambo', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (957, NULL, 7495, 'Martinslândia', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (367, NULL, 7496, 'Mirandópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (958, NULL, 7497, 'Pernambuquinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2564, NULL, 7498, 'Santa Cruz do Prata', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4791, NULL, 7499, 'Linha Porto Alegre', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4791, NULL, 7500, 'Linha Harmonia', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4046, NULL, 7501, 'Guaporé', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4046, NULL, 7502, 'Borman', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4046, NULL, 7503, 'Bela Vista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3124, NULL, 7504, 'Rio Calçado', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3124, NULL, 7505, 'Todos os Santos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4047, NULL, 7506, 'Guará', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4047, NULL, 7507, 'Palmeirinha', '75', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4047, NULL, 7508, 'Entre Rios', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4047, NULL, 7509, 'Atalaia', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4047, NULL, 7510, 'Guairacá', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4048, NULL, 7511, 'Serra Negra', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4048, NULL, 7512, 'Ararapira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3474, NULL, 7513, 'Ribeiro do Vale', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1969, NULL, 7514, 'Buranhém', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4049, NULL, 7515, 'Pedra Branca do Araraquara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3479, NULL, 7516, 'Vicente de Carvalho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3480, NULL, 7517, 'Jardim Presidente Dutra', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4413, NULL, 7518, 'Fazenda Zandavalli', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5225, NULL, 7519, 'Alcantilado', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5225, NULL, 7520, 'Vale Rico', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2571, NULL, 7521, 'Tuiutinga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2571, NULL, 7522, 'Vilas Boas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2572, NULL, 7523, 'Flor de Minas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (202, NULL, 7524, 'Carrazedo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (202, NULL, 7525, 'Itatupã', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3483, NULL, 7526, 'Juliânia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4793, NULL, 7527, 'Cerro Chato', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4793, NULL, 7528, 'Coxilha do Lageado', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4793, NULL, 7529, 'Mingote', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4793, NULL, 7530, 'Basílio', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4793, NULL, 7531, 'Bote', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4793, NULL, 7532, 'Jaguarão Chico', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (959, NULL, 7533, 'Irajá', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5422, NULL, 7534, 'Irajá', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (959, NULL, 7535, 'Betânia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5422, NULL, 7536, 'Betânia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (959, NULL, 7537, 'Conceição', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5422, NULL, 7538, 'Conceição', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4050, NULL, 7539, 'Pinho Fleck', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (960, NULL, 7540, 'Aningas', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (960, NULL, 7541, 'Dourados', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (960, NULL, 7542, 'Queimados', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4795, NULL, 7543, 'Cascata', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3487, NULL, 7544, 'Anápolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1971, NULL, 7545, 'João Amaro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1971, NULL, 7546, 'Lajedo Alto', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2574, NULL, 7547, 'São Sebastião da Barra', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4051, NULL, 7548, 'Amorinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4051, NULL, 7549, 'Campinho', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4051, NULL, 7550, 'Euzébio de Oliveira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4051, NULL, 7551, 'Vassoural', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4051, NULL, 7552, 'Vila Guay', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (961, NULL, 7553, 'Nova-Vida', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (961, NULL, 7554, 'Piranji', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (961, NULL, 7555, 'Oiticica', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (961, NULL, 7556, 'Pedra e Cal', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2576, NULL, 7557, 'Tobati', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2576, NULL, 7558, 'Argenita', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4799, NULL, 7559, 'Rio Telha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4799, NULL, 7560, 'Vitória', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2577, NULL, 7561, 'Bom Jesus da Vereda', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (962, NULL, 7562, 'Betânia', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (962, NULL, 7563, 'Alto Lindo', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (962, NULL, 7564, 'Santo Antônio da Pindoba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1325, NULL, 7565, 'Cachoeirinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1974, NULL, 7566, 'Cascavel', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1975, NULL, 7567, 'Ibitupã', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1975, NULL, 7568, 'Água Doce', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (963, NULL, 7569, 'Chile', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (963, NULL, 7570, 'Açude dos Pinheiros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (963, NULL, 7571, 'Canindezinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (963, NULL, 7572, 'Viçosa', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1536, NULL, 7573, 'Moxotó', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1976, NULL, 7574, 'Lagoa Grande', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1976, NULL, 7575, 'Iguitu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1976, NULL, 7576, 'Mirorós', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3490, NULL, 7577, 'Termas de Ibirá', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2578, NULL, 7578, 'Campo Alegre de Minas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2578, NULL, 7579, 'Bonança', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3126, NULL, 7580, 'Pendanga', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4800, NULL, 7581, 'São Luiz', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4800, NULL, 7582, 'São Sebastião', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4800, NULL, 7583, 'Nossa Senhora da Saúde', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4417, NULL, 7584, 'Dalbérgia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1981, NULL, 7585, 'Algodão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2580, NULL, 7586, 'Parque Durval de Barros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4802, NULL, 7587, 'Alfredo Brenner', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4802, NULL, 7588, 'Santo Antônio do Bom Retiro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1982, NULL, 7589, 'Mocambo', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1982, NULL, 7590, 'Olhos d''Água do Seco', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3492, NULL, 7591, 'Cambaratiba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3127, NULL, 7592, 'Santa Marta', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1983, NULL, 7593, 'Canoão', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1983, NULL, 7594, 'Feira Nova', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3493, NULL, 7595, 'Paruru', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1984, NULL, 7596, 'Boa Vista do Lagamar', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (964, NULL, 7597, 'Ibicuitaba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (964, NULL, 7598, 'Manibú', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4054, NULL, 7599, 'Vila Rica do Ivaí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4054, NULL, 7600, 'Porto Camargo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (535, NULL, 7601, 'Itapera', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (965, NULL, 7602, 'Cruzeirinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (965, NULL, 7603, 'Lima Campos', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (965, NULL, 7604, 'Pedrinhas', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (965, NULL, 7605, 'Icozinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (965, NULL, 7606, 'São Vicente', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3128, NULL, 7607, 'Duas Barras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (203, NULL, 7608, 'Caripi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (204, NULL, 7609, 'Maiauatá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1538, NULL, 7610, 'Nova Cruz', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1538, NULL, 7611, 'Três Ladeiras', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2585, NULL, 7612, 'Antunes', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1988, NULL, 7613, 'Iguaibi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2586, NULL, 7614, 'Corguinhos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4056, NULL, 7615, 'Gadelha', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (966, NULL, 7616, 'Gadelha', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4056, NULL, 7617, 'Barro Alto', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (966, NULL, 7618, 'Barro Alto', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4056, NULL, 7619, 'Suassurana', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (966, NULL, 7620, 'Suassurana', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4056, NULL, 7621, 'Barreiras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (966, NULL, 7622, 'Barreiras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4056, NULL, 7623, 'José de Alencar', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (966, NULL, 7624, 'José de Alencar', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4056, NULL, 7625, 'Riacho Vermelho', '36', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (966, NULL, 7626, 'Riacho Vermelho', '36', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4056, NULL, 7627, 'Baú', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (966, NULL, 7628, 'Baú', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4804, NULL, 7629, 'Mauá', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4804, NULL, 7630, 'Barreiro', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4804, NULL, 7631, 'Santana', '37', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4804, NULL, 7632, 'Chorão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4804, NULL, 7633, 'Itaí', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4804, NULL, 7634, 'Floresta', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4804, NULL, 7635, 'Alto da União', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4804, NULL, 7636, 'Santo Antônio', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3502, NULL, 7637, 'Cambaquara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3502, NULL, 7638, 'Paranabi', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1989, NULL, 7639, 'Pimenteira', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1989, NULL, 7640, 'Castelo Novo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1989, NULL, 7641, 'Rio do Braço', '55', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1989, NULL, 7642, 'Inema', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1989, NULL, 7643, 'Coutos', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1989, NULL, 7644, 'Aritaguá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1989, NULL, 7645, 'Olivença', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1989, NULL, 7646, 'Banco Central', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1989, NULL, 7647, 'Japu', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1327, NULL, 7648, 'Palmeira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4420, NULL, 7649, 'Rio d''Una', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4421, NULL, 7650, 'Vila Nova', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4421, NULL, 7651, 'Mirim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4058, NULL, 7652, 'Apiaba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2591, NULL, 7653, 'Barra de Alegria', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (967, NULL, 7654, 'São Valentim', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4808, NULL, 7655, 'São Valentim', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (967, NULL, 7656, 'Colônia Medeiros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4808, NULL, 7657, 'Colônia Medeiros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (967, NULL, 7658, 'Monte Sinai', '34', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4808, NULL, 7659, 'Monte Sinai', '34', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (967, NULL, 7660, 'Iapi', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4808, NULL, 7661, 'Iapi', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (967, NULL, 7662, 'Jandrangoeira', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4808, NULL, 7663, 'Jandrangoeira', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (967, NULL, 7664, 'Esquina Araújo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4808, NULL, 7665, 'Esquina Araújo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (967, NULL, 7666, 'Tranqueiras', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4808, NULL, 7667, 'Tranqueiras', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (967, NULL, 7668, 'Ematuba', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4808, NULL, 7669, 'Ematuba', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1328, NULL, 7670, 'Pontina', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2594, NULL, 7671, 'Novo Horizonte de Inhapim', '19', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2594, NULL, 7672, 'Santo Antônio do Alegre', '21', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2594, NULL, 7673, 'Itajutiba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2594, NULL, 7674, 'São Tomé de Minas', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2594, NULL, 7675, 'Jerusalém', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2594, NULL, 7676, 'Tabajara', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2594, NULL, 7677, 'Bom Jesus do Rio Preto', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2594, NULL, 7678, 'Macadame', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5137, NULL, 7679, 'São José do Sucuriú', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5137, NULL, 7680, 'São Pedro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5137, NULL, 7681, 'Morangas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2597, NULL, 7682, 'Vale Verde de Minas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5428, NULL, 7683, 'Domiciano Ribeiro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5428, NULL, 7684, 'Cavalheiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (968, NULL, 7685, 'Sacramento', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2599, NULL, 7686, 'Barra Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (969, NULL, 7687, 'Canaúna', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (969, NULL, 7688, 'Felizardo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4810, NULL, 7689, 'Vila Segrêdo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4810, NULL, 7690, 'Vila São Paulo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1991, NULL, 7691, 'Cavunge', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3508, NULL, 7692, 'Bacaetava', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4425, NULL, 7693, 'Malhador', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1993, NULL, 7694, 'Malhador', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4425, NULL, 7695, 'Bonfim de Ipirá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1993, NULL, 7696, 'Bonfim de Ipirá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1542, NULL, 7697, 'Camela', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1542, NULL, 7698, 'Nossa Senhora do Ó', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5430, NULL, 7699, 'Nova Santa Helena', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4063, NULL, 7700, 'Nova Santa Helena', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5430, NULL, 7701, 'Nilza', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4063, NULL, 7702, 'Nilza', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (970, NULL, 7703, 'Ingazeiras', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (970, NULL, 7704, 'Várzea do Giló', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (970, NULL, 7705, 'Recanto', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (970, NULL, 7706, 'Flores', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (970, NULL, 7707, 'Abílio Martins', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1543, NULL, 7708, 'Serrolândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1543, NULL, 7709, 'Serra Branca', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (369, NULL, 7710, 'América', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (971, NULL, 7711, 'América', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (369, NULL, 7712, 'Balseiros', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (971, NULL, 7713, 'Balseiros', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (369, NULL, 7714, 'Engenheiro João Tomé', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (971, NULL, 7715, 'Engenheiro João Tomé', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (369, NULL, 7716, 'Matriz', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (971, NULL, 7717, 'Matriz', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (369, NULL, 7718, 'Nova Fátima', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (971, NULL, 7719, 'Nova Fátima', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (369, NULL, 7720, 'Livramento', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (971, NULL, 7721, 'Livramento', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (369, NULL, 7722, 'São José', '37', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (971, NULL, 7723, 'São José', '37', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (369, NULL, 7724, 'Alazans', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (971, NULL, 7725, 'Alazans', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (369, NULL, 7726, 'São José das Lontras', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (971, NULL, 7727, 'São José das Lontras', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (369, NULL, 7728, 'Gázea', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (971, NULL, 7729, 'Gázea', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1994, NULL, 7730, 'Ibipetum', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (143, NULL, 7731, 'Bastiões', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (972, NULL, 7732, 'Bastiões', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (143, NULL, 7733, 'Ema', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (972, NULL, 7734, 'Ema', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (143, NULL, 7735, 'São José', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (972, NULL, 7736, 'São José', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4429, NULL, 7737, 'São José do Laranjal', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4812, NULL, 7738, 'Vila Salete', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1996, NULL, 7739, 'Novo acre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (102, NULL, 7740, 'Ariaú', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (102, NULL, 7741, 'Cacau Pirêra', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (102, NULL, 7742, 'Lago do Limão', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (102, NULL, 7743, 'Paricatuba', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1997, NULL, 7744, 'Iraporanga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1998, NULL, 7745, 'Bento Simões', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4431, NULL, 7746, 'Itapará', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4065, NULL, 7747, 'Itapará', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4431, NULL, 7748, 'Gonçalves Júnior', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4065, NULL, 7749, 'Gonçalves Júnior', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4431, NULL, 7750, 'Guamirim', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4065, NULL, 7751, 'Guamirim', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (973, NULL, 7752, 'Boa Vista do Caxitoré', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (973, NULL, 7753, 'Missi', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (973, NULL, 7754, 'Juá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1999, NULL, 7755, 'Itapicuru', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1999, NULL, 7756, 'Angical', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1999, NULL, 7757, 'Conquista', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4066, NULL, 7758, 'Águas de Jurema', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4066, NULL, 7759, 'Marilu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4432, NULL, 7760, 'Poço Preto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3129, NULL, 7761, 'Santa Cruz de Irupi', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5431, NULL, 7762, 'Piloândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1777, NULL, 7763, 'Guarita', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1329, NULL, 7764, 'Guarita', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1777, NULL, 7765, 'Campo Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1329, NULL, 7766, 'Campo Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3516, NULL, 7767, 'Tomé', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3516, NULL, 7768, 'Engenheiro Maia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3516, NULL, 7769, 'Turiba do Sul', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2603, NULL, 7770, 'Ipoema', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2603, NULL, 7771, 'Senhora do Carmo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2604, NULL, 7772, 'Boa União de Itabirinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2605, NULL, 7773, 'Bação', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2605, NULL, 7774, 'Acuruí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2605, NULL, 7775, 'São Gonçalo do Monte', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3202, NULL, 7776, 'Visconde de Itaboraí', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3202, NULL, 7777, 'Manilha', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3202, NULL, 7778, 'Itambi', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3202, NULL, 7779, 'Pachecos', '19', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3202, NULL, 7780, 'Porto das Caixas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3202, NULL, 7781, 'Cabuçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3202, NULL, 7782, 'Sambaetiba', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2003, NULL, 7783, 'Taboquinhas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2006, NULL, 7784, 'Japomirim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3130, NULL, 7785, 'Palmeira', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3130, NULL, 7786, 'Itaimbé', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3130, NULL, 7787, 'Itaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3203, NULL, 7788, 'Ibituporanga', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1545, NULL, 7789, 'Negras', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4434, NULL, 7790, 'Itaió', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4434, NULL, 7791, 'Iraputã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4434, NULL, 7792, 'Moema', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4068, NULL, 7793, 'São José do Itavó', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3518, NULL, 7794, 'Nova Cardoso', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2009, NULL, 7795, 'Palmira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2610, NULL, 7796, 'Lourenço Velho', '60', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2010, NULL, 7797, 'Bandeira do Almada', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2611, NULL, 7798, 'Contrato', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2611, NULL, 7799, 'Penha de França', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2611, NULL, 7800, 'Padre João Afonso', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2613, NULL, 7801, 'Frei Serafim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2613, NULL, 7802, 'Guarataia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4069, NULL, 7803, 'São Joaquim do Pontal', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4070, NULL, 7804, 'Ibiranga', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2013, NULL, 7805, 'Ibiranga', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1547, NULL, 7806, 'Ibiranga', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4070, NULL, 7807, 'São José do Colônia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2013, NULL, 7808, 'São José do Colônia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1547, NULL, 7809, 'São José do Colônia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4070, NULL, 7810, 'Caricé', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2013, NULL, 7811, 'Caricé', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1547, NULL, 7812, 'Caricé', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4070, NULL, 7813, 'Catolezinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2013, NULL, 7814, 'Catolezinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1547, NULL, 7815, 'Catolezinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2015, NULL, 7816, 'Batinga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2015, NULL, 7817, 'Ibirajá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2618, NULL, 7818, 'Edgard Melo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2618, NULL, 7819, 'São Francisco do Jataí', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3205, NULL, 7820, 'Laranjais', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3205, NULL, 7821, 'Jaguarembé', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3205, NULL, 7822, 'Estrada Nova', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3205, NULL, 7823, 'Portela', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3205, NULL, 7824, 'Batatal', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5436, NULL, 7825, 'Aparecida de Goiás', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (976, NULL, 7826, 'Baixa Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (976, NULL, 7827, 'Pitombeira', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (976, NULL, 7828, 'Iratinga', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (976, NULL, 7829, 'Cruz', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (976, NULL, 7830, 'Aguaí', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (976, NULL, 7831, 'São Tomé', '32', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (976, NULL, 7832, 'Soledade', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (976, NULL, 7833, 'Serrote do Meio', '34', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2018, NULL, 7834, 'Caiubi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2621, NULL, 7835, 'Neolândia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2621, NULL, 7836, 'Lamounier', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2621, NULL, 7837, 'Marilândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4071, NULL, 7838, 'Barra Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4071, NULL, 7839, 'Coxilha Rica', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3131, NULL, 7840, 'Rio Muqui', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3131, NULL, 7841, 'Itaipava', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3131, NULL, 7842, 'Piabanha do Norte', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3131, NULL, 7843, 'Itapecoá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3206, NULL, 7844, 'Raposo', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3206, NULL, 7845, 'Comendador Venâncio', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3206, NULL, 7846, 'Boaventura', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3206, NULL, 7847, 'Retiro do Muriaé', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3206, NULL, 7848, 'Itajara', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3206, NULL, 7849, 'Nossa Senhora da Penha', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1548, NULL, 7850, 'São Vicente', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2019, NULL, 7851, 'Bandeira do Colônia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3523, NULL, 7852, 'Morro do Alto', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3523, NULL, 7853, 'Rechan', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3523, NULL, 7854, 'Conceição', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3523, NULL, 7855, 'Tupy', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3523, NULL, 7856, 'Gramadinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3523, NULL, 7857, 'Varginha', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3524, NULL, 7858, 'Alto da Brancal', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2622, NULL, 7859, 'Alto da Brancal', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3524, NULL, 7860, 'Guarizinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2622, NULL, 7861, 'Guarizinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3524, NULL, 7862, 'Areia Branca', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2622, NULL, 7863, 'Areia Branca', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3524, NULL, 7864, 'Tropical Flores', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2622, NULL, 7865, 'Tropical Flores', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3524, NULL, 7866, 'Areias de Itapeva', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2622, NULL, 7867, 'Areias de Itapeva', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2020, NULL, 7868, 'Sambaíba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (977, NULL, 7869, 'Ipu Mazagão', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (977, NULL, 7870, 'Baleia', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (977, NULL, 7871, 'Assunção', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (977, NULL, 7872, 'Barrento', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (977, NULL, 7873, 'Deserto', '47', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (977, NULL, 7874, 'Arapari', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (977, NULL, 7875, 'Marinheiros', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (977, NULL, 7876, 'Lagoa das Mercês', '49', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (977, NULL, 7877, 'Calugi', '36', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (977, NULL, 7878, 'Cruxati', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (977, NULL, 7879, 'Bela Vista', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3526, NULL, 7880, 'Eleutério', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3526, NULL, 7881, 'Barão Ataliba Nogueira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5437, NULL, 7882, 'Jacilândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (978, NULL, 7883, 'Caio Prado', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (978, NULL, 7884, 'Palmatória', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (978, NULL, 7885, 'Itans', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3528, NULL, 7886, 'Tapinas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3528, NULL, 7887, 'Nova América', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5138, NULL, 7888, 'Montese', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5138, NULL, 7889, 'Piraporã', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5138, NULL, 7890, 'Carumbé', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5138, NULL, 7891, 'Santa Terezinha', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5438, NULL, 7892, 'Diolândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5438, NULL, 7893, 'Cibele', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4816, NULL, 7894, 'Itaó', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4816, NULL, 7895, 'Pintado', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4816, NULL, 7896, 'Ibicuí', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4816, NULL, 7897, 'Tapuraí', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2023, NULL, 7898, 'Ribeirão do Salto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3533, NULL, 7899, 'Santa Cruz dos Lopes', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3533, NULL, 7900, 'Pedra Branca de Itararé', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (979, NULL, 7901, 'Almofala', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (979, NULL, 7902, 'Carvoeiro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3534, NULL, 7903, 'Ana Dias', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5439, NULL, 7904, 'Olaria do Angico', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2623, NULL, 7905, 'Santa Terezinha de Minas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4818, NULL, 7906, 'Povoado Tozzo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4818, NULL, 7907, 'Sete Lagoas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4818, NULL, 7908, 'Saltinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3536, NULL, 7909, 'Lobo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (980, NULL, 7910, 'Cachoeira', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (980, NULL, 7911, 'Morro Branco', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (980, NULL, 7912, 'Bandeira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (980, NULL, 7913, 'Lagoa do Mato', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2626, NULL, 7914, 'Monsenhor Isidro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2627, NULL, 7915, 'Jacaré', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3537, NULL, 7916, 'Itaqueri da Serra', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2027, NULL, 7917, 'Itati', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2027, NULL, 7918, 'Rio do Meio', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2028, NULL, 7919, 'Tranqueiras', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2628, NULL, 7920, 'Quatituba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2630, NULL, 7921, 'Macuco de Minas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2630, NULL, 7922, 'Rosário do Rio Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4439, NULL, 7923, 'Rio Bonito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2631, NULL, 7924, 'Alexandrita', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3542, NULL, 7925, 'São Benedito da Cachoeirinha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3542, NULL, 7926, 'Capivari da Mata', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3133, NULL, 7927, 'Nossa Senhora das Graças', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3133, NULL, 7928, 'Santíssima Trindade', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3133, NULL, 7929, 'São João do Príncipe', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3133, NULL, 7930, 'Pequiá', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4074, NULL, 7931, 'Bom Jardim do Sul', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4075, NULL, 7932, 'Santa Bárbara', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4075, NULL, 7933, 'Jacutinga', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4075, NULL, 7934, 'Alto Porã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4076, NULL, 7935, 'Herculândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5140, NULL, 7936, 'Amandina', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5442, NULL, 7937, 'Campolândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1551, NULL, 7938, 'Jaboatão', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1551, NULL, 7939, 'Cavaleiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1551, NULL, 7940, 'Jardim Jordão', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1551, NULL, 7941, 'Curado', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4821, NULL, 7942, 'Trentin', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3544, NULL, 7943, 'Lusitânia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3544, NULL, 7944, 'Córrego Rico', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2633, NULL, 7945, 'Almeida', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2032, NULL, 7946, 'Irundiara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2032, NULL, 7947, 'Paiol', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1333, NULL, 7948, 'Timbó', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (210, NULL, 7949, 'Porto Rico', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3545, NULL, 7950, 'Parque Meia Lua', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3545, NULL, 7951, 'São Silvestre de Jacareí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5231, NULL, 7952, 'Celma', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2634, NULL, 7953, 'Avaí do Jacinto', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2634, NULL, 7954, 'Jaguarão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2033, NULL, 7955, 'Itapeipu', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2033, NULL, 7956, 'Itaitu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2033, NULL, 7957, 'Junco', '26', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2033, NULL, 7958, 'Catinga do Moura', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2636, NULL, 7959, 'Barão Hirstch', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4823, NULL, 7960, 'Barão Hirstch', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2636, NULL, 7961, 'Sapucaí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4823, NULL, 7962, 'Sapucaí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2636, NULL, 7963, 'São Sebastião dos Robertos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4823, NULL, 7964, 'São Sebastião dos Robertos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2034, NULL, 7965, 'Ipiúna', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2637, NULL, 7966, 'Lagoa de Pau', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2035, NULL, 7967, 'Juacema', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2035, NULL, 7968, 'Pilar', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3134, NULL, 7969, 'Nossa Senhora de Fátima', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3134, NULL, 7970, 'Barra Seca', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4825, NULL, 7971, 'Taquarichim', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4825, NULL, 7972, 'Ijucapirama', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4825, NULL, 7973, 'Santo Izidro', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4081, NULL, 7974, 'Eduardo Xavier da Silva', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (983, NULL, 7975, 'Feiticeiro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (983, NULL, 7976, 'Mapuá', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (983, NULL, 7977, 'Aquinópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (983, NULL, 7978, 'Nova Floresta', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2036, NULL, 7979, 'Camassandi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2036, NULL, 7980, 'Jacuruna', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2036, NULL, 7981, 'Cunhangi', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2036, NULL, 7982, 'Pirajuia', '26', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (984, NULL, 7983, 'Saquinho', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (984, NULL, 7984, 'Borges', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (984, NULL, 7985, 'São José do Lagamar', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (984, NULL, 7986, 'Santa Luzia', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (984, NULL, 7987, 'Giqui', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2639, NULL, 7988, 'São Sebastião do Barroso', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2640, NULL, 7989, 'Vila Nova dos Poções', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2640, NULL, 7990, 'Quem-Quem', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2640, NULL, 7991, 'Barreiro da Raiz', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4082, NULL, 7992, 'São José', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2037, NULL, 7993, 'Mangue Seco', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1129, NULL, 7994, 'Mangue Seco', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2037, NULL, 7995, 'Abadia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1129, NULL, 7996, 'Abadia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2037, NULL, 7997, 'Itanhi', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1129, NULL, 7998, 'Itanhi', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4083, NULL, 7999, 'Arapuan', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2641, NULL, 8000, 'Pandeiros', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2641, NULL, 8001, 'Várzea Bonita', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2641, NULL, 8002, 'Brejo do Amparo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2641, NULL, 8003, 'Levinópolis', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2641, NULL, 8004, 'Riacho da Cruz', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2641, NULL, 8005, 'São Joaquim', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2641, NULL, 8006, 'Tejuco', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1131, NULL, 8007, 'Córrego de São Mateus', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4084, NULL, 8008, 'Novo Jardim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2643, NULL, 8009, 'Nova Minda', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4826, NULL, 8010, 'Chapada', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5142, NULL, 8011, 'Bom Fim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5143, NULL, 8012, 'Corrente', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (985, NULL, 8013, 'Corrente', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5143, NULL, 8014, 'Jardimirim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (985, NULL, 8015, 'Jardimirim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5143, NULL, 8016, 'Boqueirão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (985, NULL, 8017, 'Boqueirão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3552, NULL, 8018, 'Jurucê', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4444, NULL, 8019, 'Jurucê', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (23, NULL, 8020, 'Santa Cruz da Serra', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (23, NULL, 8021, 'Bom Jesus', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (23, NULL, 8022, 'Tarilândia', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4088, NULL, 8023, 'Frei Timóteo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4088, NULL, 8024, 'Antônio Brandão de Oliveira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1553, NULL, 8025, 'Jacu', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1553, NULL, 8026, 'Passagem do Tó', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1553, NULL, 8027, 'Riacho do Meio', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1553, NULL, 8028, 'Jundiá', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (986, NULL, 8029, 'Balanças', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (986, NULL, 8030, 'Carnaúba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (542, NULL, 8031, 'Volta do Moxotó', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1554, NULL, 8032, 'Volta do Moxotó', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3554, NULL, 8033, 'Potunduva', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5233, NULL, 8034, 'Lucialva', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2644, NULL, 8035, 'Bituri', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2644, NULL, 8036, 'Caetano Lopes', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2646, NULL, 8037, 'Grota', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2646, NULL, 8038, 'Pouso Alegre da Mata', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2646, NULL, 8039, 'Piscamba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2646, NULL, 8040, 'São Vicente do Grama', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2038, NULL, 8041, 'Baixão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2038, NULL, 8042, 'Itaibó', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2038, NULL, 8043, 'Oriente Novo', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2038, NULL, 8044, 'Monte Branco', '28', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2038, NULL, 8045, 'Boaçu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2038, NULL, 8046, 'Itajuru', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2038, NULL, 8047, 'Florestal', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2648, NULL, 8048, 'Doutor Campolina', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2649, NULL, 8049, 'Guaranilândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2649, NULL, 8050, 'São Pedro do Jequitinhonha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2039, NULL, 8051, 'Canché', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4089, NULL, 8052, 'Carajá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (24, NULL, 8053, 'Nova Colina', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (24, NULL, 8054, 'Nova Londrina', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4445, NULL, 8055, 'Santa Helena', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4445, NULL, 8056, 'Nova Petrópolis', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2651, NULL, 8057, 'Giru', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1137, NULL, 8058, 'Rosário', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3136, NULL, 8059, 'Acioli', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2654, NULL, 8060, 'Veredas', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2654, NULL, 8061, 'Canabrava', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2654, NULL, 8062, 'Olhos d''Água do Oeste', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2654, NULL, 8063, 'Luizlândia do Oeste', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2654, NULL, 8064, 'Santa Luzia da Serra', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2654, NULL, 8065, 'Caatinga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4090, NULL, 8066, 'Joá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4446, NULL, 8067, 'Pirabeiraba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2656, NULL, 8068, 'Estrela de Jordânia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1138, NULL, 8069, 'Major Felipe', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5234, NULL, 8070, 'Paranorte', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5234, NULL, 8071, 'Águas Claras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5234, NULL, 8072, 'Catuaí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2660, NULL, 8073, 'Boa Vista da Serra', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2043, NULL, 8074, 'Itamotinga', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2043, NULL, 8075, 'Juremal', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2043, NULL, 8076, 'Pinhões', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2043, NULL, 8077, 'Abóbora', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2043, NULL, 8078, 'Junco', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2043, NULL, 8079, 'Carnaíba do Sertão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2043, NULL, 8080, 'Massaroca', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (988, NULL, 8081, 'Marrocos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (988, NULL, 8082, 'Padre Cícero', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (989, NULL, 8083, 'Poço Grande', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (989, NULL, 8084, 'Mel', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (989, NULL, 8085, 'Baixio da Donana', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (989, NULL, 8086, 'Canafístula', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (989, NULL, 8087, 'São Pedro do Norte', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5235, NULL, 8088, 'Fontanillas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5235, NULL, 8089, 'Terra Roxa', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5235, NULL, 8090, 'Filadélfia', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2661, NULL, 8091, 'Sarandira', '70', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2661, NULL, 8092, 'Rosário de Minas', '60', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2661, NULL, 8093, 'Torreões', '80', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4829, NULL, 8094, 'São João dos Mellos', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4829, NULL, 8095, 'Três Mártires', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3564, NULL, 8096, 'Barnabés', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4092, NULL, 8097, 'Primavera', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4092, NULL, 8098, 'Rio Verde', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1559, NULL, 8099, 'Santo Antônio das Queimadas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (776, NULL, 8100, 'Santo Antônio das Queimadas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5237, NULL, 8101, 'Irenópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5237, NULL, 8102, 'Santa Elvira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5237, NULL, 8103, 'São Lourenço de Fátima', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4093, NULL, 8104, 'Recife', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2045, NULL, 8105, 'Recife', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5449, NULL, 8106, 'Recife', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4093, NULL, 8107, 'Canadá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2045, NULL, 8108, 'Canadá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5449, NULL, 8109, 'Canadá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4093, NULL, 8110, 'Juscelândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2045, NULL, 8111, 'Juscelândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5449, NULL, 8112, 'Juscelândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4093, NULL, 8113, 'São Sebastião do Rio Claro', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2045, NULL, 8114, 'São Sebastião do Rio Claro', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5449, NULL, 8115, 'São Sebastião do Rio Claro', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4093, NULL, 8116, 'Queimada Nova', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2045, NULL, 8117, 'Queimada Nova', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5449, NULL, 8118, 'Queimada Nova', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2047, NULL, 8119, 'Caraguataí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2664, NULL, 8120, 'Monte Rei', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2664, NULL, 8121, 'Porto Agrário', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2665, NULL, 8122, 'Concórdia do Mucuri', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2666, NULL, 8123, 'São Brás de Minas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4450, NULL, 8124, 'Santa Teresinha do Salto', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4450, NULL, 8125, 'Índios', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2667, NULL, 8126, 'Martins Guimarães', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1562, NULL, 8127, 'Igapó', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1563, NULL, 8128, 'Lagoa do Souza', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1563, NULL, 8129, 'Entroncamento', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1563, NULL, 8130, 'Igarapeassu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4831, NULL, 8131, 'Linha Glória', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2670, NULL, 8132, 'Limeira de Minas', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2670, NULL, 8133, 'Monjolinho de Minas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1564, NULL, 8134, 'Jutaí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2671, NULL, 8135, 'Jutaí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5450, NULL, 8136, 'Lapinha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2672, NULL, 8137, 'Lapinha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5450, NULL, 8138, 'Lagoinha de Fora', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2672, NULL, 8139, 'Lagoinha de Fora', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4832, NULL, 8140, 'Campinas', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4832, NULL, 8141, 'Boqueirão', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4832, NULL, 8142, 'Tupinambá', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4832, NULL, 8143, 'Santa Luzia', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4832, NULL, 8144, 'Nossa Senhora de Fátima', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4832, NULL, 8145, 'Capão do Cedro', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4832, NULL, 8146, 'Clemente Argolo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4451, NULL, 8147, 'Ribeirão Pequeno', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2050, NULL, 8148, 'Capão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2050, NULL, 8149, 'Engenheiro Pontes', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1146, NULL, 8150, 'Firmamento', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2673, NULL, 8151, 'Prata de Lajinha', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4095, NULL, 8152, 'Água Azul', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4095, NULL, 8153, 'Mariental', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3137, NULL, 8154, 'Joatuba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3137, NULL, 8155, 'Sobreiro', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3137, NULL, 8156, 'São Luiz de Miranda', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3137, NULL, 8157, 'Vila de Laranja da Terra', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2676, NULL, 8158, 'São João da Sapucaia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4096, NULL, 8159, 'São João da Sapucaia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3566, NULL, 8160, 'Laras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3566, NULL, 8161, 'Maristela', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4097, NULL, 8162, 'Passo Liso', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4454, NULL, 8163, 'Guatá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4454, NULL, 8164, 'Barro Branco', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3567, NULL, 8165, 'Tabajara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (990, NULL, 8166, 'Quitaiús', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (990, NULL, 8167, 'Amaniutuba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (990, NULL, 8168, 'Arrojado', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (990, NULL, 8169, 'Iborepi', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (990, NULL, 8170, 'Mangabeira', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4836, NULL, 8171, 'Ibaré', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3568, NULL, 8172, 'Pinheiros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4455, NULL, 8173, 'São Sebastião do Sul', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2680, NULL, 8174, 'Posses', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2057, NULL, 8175, 'Afrânio Peixoto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2057, NULL, 8176, 'Coronel Octaviano Alves', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3570, NULL, 8177, 'Alfredo Guedes', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2681, NULL, 8178, 'Piacatuba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2681, NULL, 8179, 'Providência', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2681, NULL, 8180, 'Tebas', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2681, NULL, 8181, 'Abaíba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2681, NULL, 8182, 'Ribeiro Junqueira', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4837, NULL, 8183, 'Pinhalzinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2058, NULL, 8184, 'Tauape', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2683, NULL, 8185, 'São José dos Lopes', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2683, NULL, 8186, 'Conceição da Ibitipoca', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2683, NULL, 8187, 'São Domingos da Bocaina', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1566, NULL, 8188, 'Urucuba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (991, NULL, 8189, 'Bixopá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3138, NULL, 8190, 'São Rafael', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3138, NULL, 8191, 'Bebedouro', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3138, NULL, 8192, 'Rio Quartel', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3138, NULL, 8193, 'Pontal do Ipiranga', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3138, NULL, 8194, 'Regência', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3138, NULL, 8195, 'Farias', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3138, NULL, 8196, 'Desengano', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3138, NULL, 8197, 'Povoação', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3573, NULL, 8198, 'Guapiranga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2059, NULL, 8199, 'Iguatemi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2059, NULL, 8200, 'São Timóteo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2059, NULL, 8201, 'Itanagé', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (380, NULL, 8202, 'Alto Bonito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4103, NULL, 8203, 'Irerê', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4103, NULL, 8204, 'Guaravera', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4103, NULL, 8205, 'Paiquerê', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4103, NULL, 8206, 'São Luiz', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4103, NULL, 8207, 'Warta', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4103, NULL, 8208, 'Maravilha', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4103, NULL, 8209, 'Lerroville', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2685, NULL, 8210, 'Umbuzeiro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5239, NULL, 8211, 'Groslândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1347, NULL, 8212, 'Praia de Fagundes', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1149, NULL, 8213, 'São Bernardo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2687, NULL, 8214, 'São Judas Tadeu de Minas', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3581, NULL, 8215, 'Santa Terezinha', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4106, NULL, 8216, 'Mairá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2689, NULL, 8217, 'Esteios', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5452, NULL, 8218, 'Jardim Ingá', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3210, NULL, 8219, 'Frade', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3210, NULL, 8220, 'Sana', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3210, NULL, 8221, 'Córrego do Ouro', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3210, NULL, 8222, 'Glicério', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3210, NULL, 8223, 'Cachoeiros de Macaé', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2061, NULL, 8224, 'Nova Cruz', '21', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2061, NULL, 8225, 'Santa Luzia', '26', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4840, NULL, 8226, 'Bororé', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4840, NULL, 8227, 'Passo do Goulart', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4840, NULL, 8228, 'Encruzilhada', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (300, NULL, 8229, 'São Joaquim do Pacuí', '24', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (300, NULL, 8230, 'Carapanantuba', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (300, NULL, 8231, 'Bailique', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (300, NULL, 8232, 'Fazendinha', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2063, NULL, 8233, 'Lagoa Clara', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2063, NULL, 8234, 'Canatiba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4841, NULL, 8235, 'Bela Vista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (25, NULL, 8236, 'Tabajara', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (25, NULL, 8237, 'Oriente Novo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (25, NULL, 8238, 'Quinto BEC', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2691, NULL, 8239, 'Douradinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (992, NULL, 8240, 'Macaoca', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (992, NULL, 8241, 'Cacimba Nova', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (992, NULL, 8242, 'Cajazeiras', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (992, NULL, 8243, 'Paus Branco', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (992, NULL, 8244, 'União', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4462, NULL, 8245, 'Bela Vista do Sul', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4462, NULL, 8246, 'Rio Preto do Sul', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (215, NULL, 8247, 'Cafezal', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (557, NULL, 8248, 'Custódio Lima', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3212, NULL, 8249, 'Santo Aleixo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3212, NULL, 8250, 'Suruí', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3212, NULL, 8251, 'Inhomirim', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3212, NULL, 8252, 'Guia de Pacobaíba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2068, NULL, 8253, 'Angico', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3588, NULL, 8254, 'Terra Preta', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4463, NULL, 8255, 'Pinheiral', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4463, NULL, 8256, 'Boiteuxburgo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1696, NULL, 8257, 'Riacho do Sertão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2693, NULL, 8258, 'Junco de Minas', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2693, NULL, 8259, 'Santo Antônio do Mucuri', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2693, NULL, 8260, 'Jaguaritira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2069, NULL, 8261, 'Parateca', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2069, NULL, 8262, 'Canabrava', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4107, NULL, 8263, 'Rio Claro do Sul', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4107, NULL, 8264, 'Dorizon', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1350, NULL, 8265, 'Pitanga da Estrada', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2694, NULL, 8266, 'Barrinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1351, NULL, 8267, 'Pelo Sinal', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4111, NULL, 8268, 'Areia Branca dos Assis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3589, NULL, 8269, 'São Berto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2695, NULL, 8270, 'Nhandutiba', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3213, NULL, 8271, 'Vila Muriqui', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3213, NULL, 8272, 'Itacurussá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3213, NULL, 8273, 'Conceição de Jacareí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4113, NULL, 8274, 'Covó', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2696, NULL, 8275, 'Ponte do Silva', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2696, NULL, 8276, 'São Pedro do Avaí', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2696, NULL, 8277, 'Palmeiras do Manhuaçu', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2696, NULL, 8278, 'Dom Corrêa', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2696, NULL, 8279, 'Realeza', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2696, NULL, 8280, 'São Sebastião do Sacramento', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2696, NULL, 8281, 'Vilanova', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4114, NULL, 8282, 'Barra Santa Salete', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4843, NULL, 8283, 'Barragem do Itú', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4843, NULL, 8284, 'Pirajú', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2071, NULL, 8285, 'Catingal', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2072, NULL, 8286, 'Aroeiras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2698, NULL, 8287, 'Limeira de Mantena', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2698, NULL, 8288, 'Barra do Ariranha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3139, NULL, 8289, 'São José de Mantenópolis', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3139, NULL, 8290, 'Santa Luzia de Mantenópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3139, NULL, 8291, 'São Geraldo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4844, NULL, 8292, 'Barra do Ouro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4844, NULL, 8293, 'Morro Alto', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2699, NULL, 8294, 'Engenho Novo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2699, NULL, 8295, 'Saudade', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3591, NULL, 8296, 'São José das Laranjeiras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5148, NULL, 8297, 'Vista Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (217, NULL, 8298, 'Boa Esperança', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (217, NULL, 8299, 'São Roberto', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (993, NULL, 8300, 'Pajuçara', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1698, NULL, 8301, 'Barra Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2074, NULL, 8302, 'Nagé', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2074, NULL, 8303, 'Coqueiros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2074, NULL, 8304, 'São Roque do Paraguaçu', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2074, NULL, 8305, 'Guaí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2074, NULL, 8306, 'Guapira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1570, NULL, 8307, 'Sertãozinho de Baixo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 8308, 'Antônio Marques', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 8309, 'Umarizeiras', '42', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 8310, 'Cachoeira', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 8311, 'Jubaia', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 8312, 'Itapebussu', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 8313, 'Ladeira Grande', '26', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 8314, 'Amanari', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 8315, 'Vertentes do Lagedo', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 8316, 'Manoel Guedes', '31', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 8317, 'São João do Amanari', '37', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 8318, 'Papara', '32', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 8319, 'Lagoa do Juvenal', '29', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 8320, 'Lages', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 8321, 'Tanques', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 8322, 'Sapupara', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (994, NULL, 8323, 'Penedo', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (218, NULL, 8324, 'Matapiquara', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (218, NULL, 8325, 'Marudá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (218, NULL, 8326, 'Praia de Marudá', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (218, NULL, 8327, 'Monte Alegre do Maú', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4845, NULL, 8328, 'Macega', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4845, NULL, 8329, 'Esperança', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4845, NULL, 8330, 'São Pedro do Maratá', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3140, NULL, 8331, 'Barra do Itapemirim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4846, NULL, 8332, 'Ibiaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2075, NULL, 8333, 'Ibiaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4846, NULL, 8334, 'São Miguel', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2075, NULL, 8335, 'São Miguel', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4846, NULL, 8336, 'Veado Pardo', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2075, NULL, 8337, 'Veado Pardo', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4846, NULL, 8338, 'Piabanha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2075, NULL, 8339, 'Piabanha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4846, NULL, 8340, 'Laranjeira', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2075, NULL, 8341, 'Laranjeira', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1352, NULL, 8342, 'Camurupim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4847, NULL, 8343, 'Coronel Teixeira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4847, NULL, 8344, 'Pinhalzinho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2076, NULL, 8345, 'Juraci', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (995, NULL, 8346, 'Panacuí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (995, NULL, 8347, 'Mocambo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4115, NULL, 8348, 'Novo Três Passos', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4115, NULL, 8349, 'Porto Mendes', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4115, NULL, 8350, 'Bom Jardim', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4115, NULL, 8351, 'Iguiporã', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4115, NULL, 8352, 'Novo Horizonte', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4115, NULL, 8353, 'São Roque', '55', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4115, NULL, 8354, 'Margarida', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3141, NULL, 8355, 'Santa Maria de Marechal', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3141, NULL, 8356, 'Araguaia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2701, NULL, 8357, 'Pintos Negreiros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4116, NULL, 8358, 'Carbonera', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4117, NULL, 8359, 'São Miguel do Cambuí', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4117, NULL, 8360, 'Santa Fé do Pirapó', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4117, NULL, 8361, 'São Luiz', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2702, NULL, 8362, 'Furquim', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2702, NULL, 8363, 'Monsenhor Horta', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2702, NULL, 8364, 'Cachoeira do Brumado', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2702, NULL, 8365, 'Camargos', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2702, NULL, 8366, 'Passagem de Mariana', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2702, NULL, 8367, 'Padre Viegas', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2702, NULL, 8368, 'Bandeirantes', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2702, NULL, 8369, 'Cláudio Manuel', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2702, NULL, 8370, 'Santa Rita Durão', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3593, NULL, 8371, 'Mourão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3214, NULL, 8372, 'Inoã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3214, NULL, 8373, 'Manoel Ribeiro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3142, NULL, 8374, 'Sapucaia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4118, NULL, 8375, 'Nova Amoreira', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4119, NULL, 8376, 'Ipanema', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3594, NULL, 8377, 'Amadeu Amaral', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3594, NULL, 8378, 'Dirceu', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3594, NULL, 8379, 'Padre Nóbrega', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3594, NULL, 8380, 'Avencas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3594, NULL, 8381, 'Rosália', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3594, NULL, 8382, 'Lácio', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4120, NULL, 8383, 'São Luiz', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4121, NULL, 8384, 'Iguatemi', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4121, NULL, 8385, 'Floriano', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4122, NULL, 8386, 'Senhor Bom Jesus dos Gramados', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4122, NULL, 8387, 'Rio Pinheiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4123, NULL, 8388, 'Pérola Independente', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4123, NULL, 8389, 'Candeia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2706, NULL, 8390, 'Cava Grande', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4850, NULL, 8391, 'Bela Vista do Fão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4850, NULL, 8392, 'Tamanduá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2708, NULL, 8393, 'Alberto Isaacson', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2708, NULL, 8394, 'Ibitira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3596, NULL, 8395, 'Guachos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3596, NULL, 8396, 'Teçaindá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1154, NULL, 8397, 'Salva Vida', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2709, NULL, 8398, 'Pinheiro de Minas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2077, NULL, 8399, 'Pimenta', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2077, NULL, 8400, 'Teixeira do Progresso', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2077, NULL, 8401, 'São João do Paraíso', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (997, NULL, 8402, 'Aiuá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (997, NULL, 8403, 'Ipaguaçu', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (997, NULL, 8404, 'Tuína', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (997, NULL, 8405, 'Tangente', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (997, NULL, 8406, 'Padre Linhares', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (997, NULL, 8407, 'Mumbaba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4851, NULL, 8408, 'Clara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2078, NULL, 8409, 'Amado Bahia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2078, NULL, 8410, 'Açu da Torre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3597, NULL, 8411, 'São Lourenço do Turvo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1356, NULL, 8412, 'Barra de Camaratuba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4127, NULL, 8413, 'Agro Cafeeira', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2712, NULL, 8414, 'Serra Azul', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2712, NULL, 8415, 'Azurita', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2715, NULL, 8416, 'Rio Verde de Minas', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2716, NULL, 8417, 'Padre Fialho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4853, NULL, 8418, 'Santo Antônio', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4853, NULL, 8419, 'Arroio Bonito', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4853, NULL, 8420, 'Sampaio', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2717, NULL, 8421, 'São João do Bonito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2718, NULL, 8422, 'Mocambeiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5457, NULL, 8423, 'Lua Nova', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (114, NULL, 8424, 'Osório da Fonseca', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (114, NULL, 8425, 'Repartimento', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (998, NULL, 8426, 'São Félix', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (998, NULL, 8427, 'Palestina do Cariri', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (998, NULL, 8428, 'Nova Santa Cruz', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (998, NULL, 8429, 'Buritizinho', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (998, NULL, 8430, 'Umburanas', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (998, NULL, 8431, 'São Miguel', '29', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (998, NULL, 8432, 'Anauá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (998, NULL, 8433, 'Coité', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (301, NULL, 8434, 'Carvão', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (301, NULL, 8435, 'Mazagão Velho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2080, NULL, 8436, 'Itupeva', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2080, NULL, 8437, 'Nova Lídice', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4131, NULL, 8438, 'Maralúcia', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (220, NULL, 8439, 'União da Floresta', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2721, NULL, 8440, 'Tuparecê', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4470, NULL, 8441, 'Sapiranga', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (221, NULL, 8442, 'Areias', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (999, NULL, 8443, 'Santo Antônio dos Fernandes', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (999, NULL, 8444, 'Anil', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (999, NULL, 8445, 'Camilos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (999, NULL, 8446, 'Palestina do Norte', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (999, NULL, 8447, 'São Francisco', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3216, NULL, 8448, 'Barra Grande de Mesquita', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2724, NULL, 8449, 'Barra Grande de Mesquita', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2081, NULL, 8450, 'Tapiranga', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2081, NULL, 8451, 'Itapura', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3217, NULL, 8452, 'Conrado', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3217, NULL, 8453, 'Governador Portela', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2082, NULL, 8454, 'Rosário', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1000, NULL, 8455, 'Rosário', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2082, NULL, 8456, 'Tartaruga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1000, NULL, 8457, 'Tartaruga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1001, NULL, 8458, 'Carnaubinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1001, NULL, 8459, 'Baixa Verde', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1001, NULL, 8460, 'Ipueira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1001, NULL, 8461, 'Monte grave', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1001, NULL, 8462, 'Barra', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3143, NULL, 8463, 'São Pedro de Itabapoana', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3143, NULL, 8464, 'Conceição do Muqui', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3143, NULL, 8465, 'Dona América', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3143, NULL, 8466, 'Ponte de Itabapoana', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3143, NULL, 8467, 'São José das Torres', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3143, NULL, 8468, 'Santo Antônio do Muqui', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5460, NULL, 8469, 'Cana Brava', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2725, NULL, 8470, 'Cruzinha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2725, NULL, 8471, 'Ribeirão da Folha', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2725, NULL, 8472, 'Baixa Quente', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2725, NULL, 8473, 'Lagoa Grande de Minas Novas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2727, NULL, 8474, 'Muquém', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3605, NULL, 8475, 'Santa Rita do Ribeira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3605, NULL, 8476, 'Pedro Barros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3605, NULL, 8477, 'Oliveira Barros', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3218, NULL, 8478, 'Venda das Flores', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3218, NULL, 8479, 'Paraíso do Tobias', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (566, NULL, 8480, 'Ibipira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4133, NULL, 8481, 'Ibipira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4857, NULL, 8482, 'Sítio Gabriel', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4857, NULL, 8483, 'Tronqueiras', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2729, NULL, 8484, 'Dores da Vitória', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1002, NULL, 8485, 'Brotas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1002, NULL, 8486, 'Poço da Onça', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1002, NULL, 8487, 'Riachão', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1571, NULL, 8488, 'Tupanaci', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3606, NULL, 8489, 'Amandaba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3606, NULL, 8490, 'Três Alianças', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2083, NULL, 8491, 'Nuguaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2083, NULL, 8492, 'Canabrava', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2083, NULL, 8493, 'Taquarandi', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3607, NULL, 8494, 'Costa Machado', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3607, NULL, 8495, 'Cuiabá Paulista', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3608, NULL, 8496, 'Ruilândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5243, NULL, 8497, 'Sonho Azul', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4135, NULL, 8498, 'Portão Ocoí', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4135, NULL, 8499, 'Dom Armando', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1003, NULL, 8500, 'Missão Nova', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1003, NULL, 8501, 'Quimami', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1003, NULL, 8502, 'Jamacaru', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (222, NULL, 8503, 'São Pedro de Viseu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3610, NULL, 8504, 'Igaraí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3610, NULL, 8505, 'São Benedito das Areias', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2731, NULL, 8506, 'Coco', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1360, NULL, 8507, 'Gameleira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3611, NULL, 8508, 'Biritiba-Ussu', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3611, NULL, 8509, 'Quatinga', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3611, NULL, 8510, 'Taiaçupeba', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3611, NULL, 8511, 'Sabaúna', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3611, NULL, 8512, 'Brás Cubas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3611, NULL, 8513, 'Cezar de Souza', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3611, NULL, 8514, 'Jundiapeba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3612, NULL, 8515, 'Martinho Prado Júnior', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5462, NULL, 8516, 'Messianópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (223, NULL, 8517, 'Cairari', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1004, NULL, 8518, 'Cipó', '26', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1004, NULL, 8519, 'Açudinho dos Costas', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1004, NULL, 8520, 'São Vicente', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1004, NULL, 8521, 'São Gonçalo do Umari', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1004, NULL, 8522, 'Manoel Correia', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1004, NULL, 8523, 'Cangatí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1004, NULL, 8524, 'Carnaúbas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1004, NULL, 8525, 'Boa Vista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1004, NULL, 8526, 'Catolé', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2733, NULL, 8527, 'Rodeador', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1005, NULL, 8528, 'Barreiros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1005, NULL, 8529, 'Nossa Senhora do Livramento', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2735, NULL, 8530, 'São Sebastião dos Poções', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2735, NULL, 8531, 'Capitania', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2735, NULL, 8532, 'Pitarana', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3144, NULL, 8533, 'Vinhático', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3617, NULL, 8534, 'Mostardas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4859, NULL, 8535, 'Enxovia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4859, NULL, 8536, 'Capela da Luz', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4859, NULL, 8537, 'São Judas', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4859, NULL, 8538, 'São José', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4859, NULL, 8539, 'Santo Antonio', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4859, NULL, 8540, 'Ranchinho', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4859, NULL, 8541, 'São Francisco', '38', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4859, NULL, 8542, 'Carmo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4859, NULL, 8543, 'Passo do Carro', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4859, NULL, 8544, 'Saúde', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3618, NULL, 8545, 'Aparecida do Monte Alto', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3619, NULL, 8546, 'Engenheiro Balduíno', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3619, NULL, 8547, 'Itaiúba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3619, NULL, 8548, 'Junqueira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3620, NULL, 8549, 'Marcondésia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2738, NULL, 8550, 'Santa Cruz da Aparecida', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2738, NULL, 8551, 'Juréia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3621, NULL, 8552, 'Residência Fuck', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4475, NULL, 8553, 'Residência Fuck', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2741, NULL, 8554, 'Milagre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4861, NULL, 8555, 'Costa da Serra', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4861, NULL, 8556, 'Vendinha', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4861, NULL, 8557, 'Fortaleza', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4861, NULL, 8558, 'Pesqueiro', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4861, NULL, 8559, 'Santos Reis', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2743, NULL, 8560, 'Nova Esperança', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2743, NULL, 8561, 'Santa Rosa de Lima', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2743, NULL, 8562, 'Ermidinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2743, NULL, 8563, 'Miralta', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2743, NULL, 8564, 'São Pedro da Garça', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2743, NULL, 8565, 'Vila Nova de Minas', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2743, NULL, 8566, 'Panorâmica', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2743, NULL, 8567, 'Aparecida do Mundo Novo', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2743, NULL, 8568, 'São João da Vereda', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5464, NULL, 8569, 'Aparecida do Rio Claro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5464, NULL, 8570, 'Lucilândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5464, NULL, 8571, 'Ponte Alta do Araguaia', '26', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5464, NULL, 8572, 'Registro do Araguaia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1006, NULL, 8573, 'Juazeiro de Baixo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1006, NULL, 8574, 'Boa Água', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1006, NULL, 8575, 'Uiraponga', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1006, NULL, 8576, 'Aruaru', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1006, NULL, 8577, 'Pedras', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1006, NULL, 8578, 'Roldão', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1006, NULL, 8579, 'Lagoa Grande', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2745, NULL, 8580, 'Frei Orlando', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1007, NULL, 8581, 'Boa Esperança', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1007, NULL, 8582, 'Várzea da Volta', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1572, NULL, 8583, 'Caririmirim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4136, NULL, 8584, 'Paraná d''Oeste', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1573, NULL, 8585, 'Bonança', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2086, NULL, 8586, 'Quixaba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4137, NULL, 8587, 'Porto de Cima', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1008, NULL, 8588, 'Sítio Alegre', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5467, NULL, 8589, 'Sítio Alegre', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4863, NULL, 8590, 'Costão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4863, NULL, 8591, 'Morro de Dentro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4863, NULL, 8592, 'Morro do Forno', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4476, NULL, 8593, 'Estação Cocal', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2087, NULL, 8594, 'Icó', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2087, NULL, 8595, 'Dias Coelho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2087, NULL, 8596, 'Camirim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2087, NULL, 8597, 'Ventura', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2087, NULL, 8598, 'Duas Barras do Morro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2087, NULL, 8599, 'Tamboril', '24', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4866, NULL, 8600, 'São Simão', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4866, NULL, 8601, 'Doutor Edgardo Pereira Velho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4866, NULL, 8602, 'Rincão do Cristóvão Pereira', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (225, NULL, 8603, 'São Miguel do Pracuúba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (225, NULL, 8604, 'São Francisco da Jararaca', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1009, NULL, 8605, 'Carqueijo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1009, NULL, 8606, 'Poço Verde', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2089, NULL, 8607, 'Guiné', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2089, NULL, 8608, 'João Correia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2090, NULL, 8609, 'Taquarinha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2090, NULL, 8610, 'Ibiranhém', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2090, NULL, 8611, 'Itabatã', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3145, NULL, 8612, 'Itabaiana', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4868, NULL, 8613, 'Santa Rita', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4868, NULL, 8614, 'Bom Retiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4868, NULL, 8615, 'Capão Grande', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4868, NULL, 8616, 'Vila Ituim', '55', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4868, NULL, 8617, 'Morro Grande', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4868, NULL, 8618, 'Encruzilhada São Sebastião', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4868, NULL, 8619, 'Várzea dos Antunes', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4868, NULL, 8620, 'Fazenda Laranjeiras', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2091, NULL, 8621, 'Várzea do Cerco', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2091, NULL, 8622, 'Canudos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2092, NULL, 8623, 'Ibiaporã', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5471, NULL, 8624, 'Ibiaporã', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5150, NULL, 8625, 'Ibiaporã', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2092, NULL, 8626, 'Indaí', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5471, NULL, 8627, 'Indaí', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5150, NULL, 8628, 'Indaí', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2092, NULL, 8629, 'Alto Bonito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5471, NULL, 8630, 'Alto Bonito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5150, NULL, 8631, 'Alto Bonito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4138, NULL, 8632, 'Fernão Dias', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2093, NULL, 8633, 'Onha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3146, NULL, 8634, 'Alto Norte', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3146, NULL, 8635, 'Menino Jesus', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3146, NULL, 8636, 'Itaici', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3146, NULL, 8637, 'Vieira Machado', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3146, NULL, 8638, 'Piaçu', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3146, NULL, 8639, 'São Pedro', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3147, NULL, 8640, 'Camará', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2749, NULL, 8641, 'Bom Jesus da Cachoeira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2749, NULL, 8642, 'Boa Família', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2749, NULL, 8643, 'Itamuri', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2749, NULL, 8644, 'Belisário', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2749, NULL, 8645, 'Vermelho', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2749, NULL, 8646, 'Pirapanema', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2095, NULL, 8647, 'Itaporã', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2750, NULL, 8648, 'Imbiruçu', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2750, NULL, 8649, 'Ocidente', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2750, NULL, 8650, 'Centenário', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2750, NULL, 8651, 'Roseiral', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2750, NULL, 8652, 'São Francisco do Humaitá', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2753, NULL, 8653, 'Vila Pereira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4870, NULL, 8654, 'São José do Centro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (390, NULL, 8655, 'Príncipe', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3219, NULL, 8656, 'Príncipe', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (390, NULL, 8657, 'Bom Jesus do Querendo', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3219, NULL, 8658, 'Bom Jesus do Querendo', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (390, NULL, 8659, 'Ourânia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3219, NULL, 8660, 'Ourânia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3630, NULL, 8661, 'Bairro Alto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1365, NULL, 8662, 'Pirauá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2758, NULL, 8663, 'Santo Antônio do Cruzeiro', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2758, NULL, 8664, 'Nazaré de Minas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3632, NULL, 8665, 'Barra Dourada', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3632, NULL, 8666, 'Miraluz', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3633, NULL, 8667, 'Ida Iolanda', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3220, NULL, 8668, 'Olinda', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5475, NULL, 8669, 'Tupiraçaba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5475, NULL, 8670, 'São Luiz do Tocantins', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5475, NULL, 8671, 'Vila Taveira', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5244, NULL, 8672, 'Coqueiral', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5244, NULL, 8673, 'Bom Jardim', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5246, NULL, 8674, 'Seco', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5246, NULL, 8675, 'Pirizal', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5246, NULL, 8676, 'Ribeirão dos Cocais', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3635, NULL, 8677, 'Nova Itapirema', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4873, NULL, 8678, 'General Cadorna', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5154, NULL, 8679, 'Nova Casa Verde', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5477, NULL, 8680, 'Marajó', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4142, NULL, 8681, 'Marajó', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5477, NULL, 8682, 'Palmitópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4142, NULL, 8683, 'Palmitópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2760, NULL, 8684, 'Santo Antônio de Nova Belém', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5248, NULL, 8685, 'Riolândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3636, NULL, 8686, 'Itaoca de Cima', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2100, NULL, 8687, 'Itajaí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5249, NULL, 8688, 'Colorado do Norte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5249, NULL, 8689, 'Ouro Branco', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4143, NULL, 8690, 'Geremia Lunardelli', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4143, NULL, 8691, 'Santo Rei', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5478, NULL, 8692, 'Bandeirantes', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4144, NULL, 8693, 'Ivaitinga', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4144, NULL, 8694, 'Barão de Lucena', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3222, NULL, 8695, 'São Pedro da Serra', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3222, NULL, 8696, 'Lumiar', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3222, NULL, 8697, 'Riograndina', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3222, NULL, 8698, 'Campo do Coelho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3222, NULL, 8699, 'Muri', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3222, NULL, 8700, 'Conselheiro Paulino', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3222, NULL, 8701, 'Amparo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3640, NULL, 8702, 'Onda Branca', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3640, NULL, 8703, 'Mangaratu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3640, NULL, 8704, 'Ingás', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4147, NULL, 8705, 'Guarani', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4147, NULL, 8706, 'Rio da Prata', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4147, NULL, 8707, 'Bananas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4147, NULL, 8708, 'Guaraí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4148, NULL, 8709, 'Cintra Pimentel', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (30, NULL, 8710, 'Nova Dimensão', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (30, NULL, 8711, 'Palmeiras', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (30, NULL, 8712, 'Araras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (30, NULL, 8713, 'Jacynópolis', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (392, NULL, 8714, 'Triunfo', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1368, NULL, 8715, 'Triunfo', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1011, NULL, 8716, 'Triunfo', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4882, NULL, 8717, 'Vila Cruz', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4882, NULL, 8718, 'Canhemborá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4883, NULL, 8719, 'Vale do Rio Caí', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4883, NULL, 8720, 'Pinhal Alto', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4883, NULL, 8721, 'Dos Boêmios', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2766, NULL, 8722, 'Petúnia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1012, NULL, 8723, 'São Pedro', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1012, NULL, 8724, 'Major Simplício', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1012, NULL, 8725, 'Canindezinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1012, NULL, 8726, 'Espacinha', '19', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1012, NULL, 8727, 'Nova Betânia', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4152, NULL, 8728, 'Alto Santa Fé', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4152, NULL, 8729, 'Planalto do Oeste', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2767, NULL, 8730, 'Boa Vista de Minas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4153, NULL, 8731, 'Catuporanga', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4153, NULL, 8732, 'Poema', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (228, NULL, 8733, 'Timboteua', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4481, NULL, 8734, 'Aguti', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4481, NULL, 8735, 'Claraíba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5259, NULL, 8736, 'Parque Água Limpa', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5259, NULL, 8737, 'Novo Mato Grosso', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5259, NULL, 8738, 'Santo Antônio do Rio Bonito', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5259, NULL, 8739, 'Entre Rios', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5259, NULL, 8740, 'Piratininga', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5259, NULL, 8741, 'Santa Terezinha do Rio Ferro', '26', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3148, NULL, 8742, 'Santo Antônio do Quinze', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3148, NULL, 8743, 'Guararema', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5482, NULL, 8744, 'São Bento Baixo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4482, NULL, 8745, 'São Bento Baixo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5482, NULL, 8746, 'Nossa Senhora do Caravagio', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4482, NULL, 8747, 'Nossa Senhora do Caravagio', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2106, NULL, 8748, 'Helvécia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2106, NULL, 8749, 'Posto da Mata', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2106, NULL, 8750, 'Argolo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5260, NULL, 8751, 'União do Leste', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2769, NULL, 8752, 'Lufa', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2769, NULL, 8753, 'Queixada', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2769, NULL, 8754, 'Novilhona', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3646, NULL, 8755, 'Vale Formoso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4483, NULL, 8756, 'Vale Formoso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2107, NULL, 8757, 'Vale Formoso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3646, NULL, 8758, 'Brejo Luiza de Brito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4483, NULL, 8759, 'Brejo Luiza de Brito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2107, NULL, 8760, 'Brejo Luiza de Brito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3646, NULL, 8761, 'Remédios', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4483, NULL, 8762, 'Remédios', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2107, NULL, 8763, 'Remédios', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4891, NULL, 8764, 'Pratos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1013, NULL, 8765, 'Santa Maria', '24', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1013, NULL, 8766, 'São Raimundo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1013, NULL, 8767, 'Palestina', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1013, NULL, 8768, 'Emaús', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1013, NULL, 8769, 'Três Irmãos', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (230, NULL, 8770, 'Belo Monte do Pará', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (230, NULL, 8771, 'Maracajá', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (230, NULL, 8772, 'Vitória da Conquista', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5264, NULL, 8773, 'Itaquerê', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1014, NULL, 8774, 'Arisco dos Marianos', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1014, NULL, 8775, 'Serragem', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1014, NULL, 8776, 'Curupira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1014, NULL, 8777, 'Sereno de Cima', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1014, NULL, 8778, 'Novo Horizonte', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (302, NULL, 8779, 'Vila Velha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (302, NULL, 8780, 'Clevelândia do Norte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3649, NULL, 8781, 'Batista Botelho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1370, NULL, 8782, 'Socorro', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3650, NULL, 8783, 'Ribeiro dos Santos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3650, NULL, 8784, 'Baguaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2775, NULL, 8785, 'Morro do Ferro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2110, NULL, 8786, 'Ipuçaba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2110, NULL, 8787, 'Bom Sossego', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5486, NULL, 8788, 'Alto Alvorada', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4484, NULL, 8789, 'Brusque do Sul', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4484, NULL, 8790, 'Pindotiba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4484, NULL, 8791, 'Barracão', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4484, NULL, 8792, 'Rio das Furnas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4484, NULL, 8793, 'Rio Pinheiros', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1576, NULL, 8794, 'Chã do Rocha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1576, NULL, 8795, 'Umburetama', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1015, NULL, 8796, 'Palestina', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1015, NULL, 8797, 'Santarém', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1015, NULL, 8798, 'Guassussê', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1015, NULL, 8799, 'Igarói', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4155, NULL, 8800, 'Natingui', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4155, NULL, 8801, 'Monjolinho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4155, NULL, 8802, 'Lajeado Bonito', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4155, NULL, 8803, 'Barreiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4894, NULL, 8804, 'Passinhos', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4894, NULL, 8805, 'Aguapés', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4894, NULL, 8806, 'Santa Luzia', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4894, NULL, 8807, 'Borussia', '28', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4894, NULL, 8808, 'Atlântida-Sul', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3657, NULL, 8809, 'Lagoa Azul', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1578, NULL, 8810, 'Barra de São Pedro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4486, NULL, 8811, 'Santa Lúcia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2781, NULL, 8812, 'Crisólia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2781, NULL, 8813, 'São José do Mato Dentro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2782, NULL, 8814, 'São Bartolomeu', '55', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2782, NULL, 8815, 'Santa Rita de Ouro Preto', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2782, NULL, 8816, 'Glaura', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2782, NULL, 8817, 'Amarantina', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2782, NULL, 8818, 'Engenheiro Correia', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2782, NULL, 8819, 'Antônio Pereira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2782, NULL, 8820, 'Miguel Burnier', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2782, NULL, 8821, 'Cachoeira do Campo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2782, NULL, 8822, 'Santo Antônio do Salto', '52', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2782, NULL, 8823, 'Santo Antônio do Leite', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2782, NULL, 8824, 'Rodrigo Silva', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2782, NULL, 8825, 'Lavras Novas', '34', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (33, NULL, 8826, 'Rondominas', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1016, NULL, 8827, 'Pascoal', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1016, NULL, 8828, 'Itaipaba', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1017, NULL, 8829, 'Pavuna', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1798, NULL, 8830, 'Pavuna', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1017, NULL, 8831, 'Senador Carlos Jereissati', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1798, NULL, 8832, 'Senador Carlos Jereissati', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1017, NULL, 8833, 'Monguba', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1798, NULL, 8834, 'Monguba', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1018, NULL, 8835, 'Santa Ana', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1018, NULL, 8836, 'Colina', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1018, NULL, 8837, 'Fátima', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4158, NULL, 8838, 'Água Boa', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2787, NULL, 8839, 'Poções de Paineiras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2788, NULL, 8840, 'Vila Costina', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1714, NULL, 8841, 'Jurupeba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3662, NULL, 8842, 'Jurupeba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1714, NULL, 8843, 'Duplo Céu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3662, NULL, 8844, 'Duplo Céu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1020, NULL, 8845, 'São José', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4490, NULL, 8846, 'Enseada de Brito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2790, NULL, 8847, 'Itapiruçu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2790, NULL, 8848, 'Cisneiros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1021, NULL, 8849, 'Gado', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1021, NULL, 8850, 'Gados dos Rodrigues', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1579, NULL, 8851, 'Santo Antônio dos Palmares', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4896, NULL, 8852, 'Granja Getúlio Vargas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4896, NULL, 8853, 'Frei Sebastião', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4896, NULL, 8854, 'Quintão', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4896, NULL, 8855, 'Bacupari', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4896, NULL, 8856, 'Butiatuva', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4896, NULL, 8857, 'Casa Velha', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4159, NULL, 8858, 'Francisco Frederico Teixeira Guimarães', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (398, NULL, 8859, 'Francisco Frederico Teixeira Guimarães', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4159, NULL, 8860, 'Buritirana', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (398, NULL, 8861, 'Buritirana', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4159, NULL, 8862, 'Padre Ponciano', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (398, NULL, 8863, 'Padre Ponciano', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4159, NULL, 8864, 'Taquaruçu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (398, NULL, 8865, 'Taquaruçu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2113, NULL, 8866, 'Rancho das Mães', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2113, NULL, 8867, 'Espraiado', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2113, NULL, 8868, 'Pinga Fogo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4160, NULL, 8869, 'Papagaios Novos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4492, NULL, 8870, 'Papagaios Novos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3664, NULL, 8871, 'Dalas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4897, NULL, 8872, 'Quebrado', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4897, NULL, 8873, 'Santa Rosa', '42', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4897, NULL, 8874, 'Santa Teresinha', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4897, NULL, 8875, 'São Bento', '52', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1715, NULL, 8876, 'Canafístula', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1715, NULL, 8877, 'Caldeirões de Cima', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2114, NULL, 8878, 'Caeté-Açu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3665, NULL, 8879, 'Sussuí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4161, NULL, 8880, 'Sussuí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4493, NULL, 8881, 'Diamantina', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4493, NULL, 8882, 'Oldemburg', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4493, NULL, 8883, 'Santa Lúcia', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2791, NULL, 8884, 'Dois de Abril', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4162, NULL, 8885, 'São Camilo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4162, NULL, 8886, 'Vila Floresta', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3149, NULL, 8887, 'Vila Verde', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3149, NULL, 8888, 'Lajinha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1581, NULL, 8889, 'São Lázaro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1581, NULL, 8890, 'Cruzes', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1581, NULL, 8891, 'São José', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4900, NULL, 8892, 'Várzea', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4900, NULL, 8893, 'Aroeiras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4900, NULL, 8894, 'Monte Castelo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1716, NULL, 8895, 'Limoeiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4494, NULL, 8896, 'Nova Cultura', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2793, NULL, 8897, 'Carioca', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2793, NULL, 8898, 'Torneiros', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2793, NULL, 8899, 'Tavares de Minas', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2793, NULL, 8900, 'Córrego do Barro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2793, NULL, 8901, 'Ascensão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1022, NULL, 8902, 'Poço Doce', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1022, NULL, 8903, 'Jardim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2795, NULL, 8904, 'Guaipava', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3667, NULL, 8905, 'Conceição de Monte Alegre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3667, NULL, 8906, 'Roseta', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3667, NULL, 8907, 'Sapezal', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3225, NULL, 8908, 'Salutaris', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3225, NULL, 8909, 'Inconfidência', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3225, NULL, 8910, 'Werneck', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1023, NULL, 8911, 'Boa Vista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1023, NULL, 8912, 'Camboas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1023, NULL, 8913, 'Lagoinha', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4495, NULL, 8914, 'Grápia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3669, NULL, 8915, 'Grápia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2796, NULL, 8916, 'Costas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1024, NULL, 8917, 'Miranda', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1024, NULL, 8918, 'Novo Assis', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1024, NULL, 8919, 'Gavião', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1024, NULL, 8920, 'Oiticica', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1024, NULL, 8921, 'Riachão', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1024, NULL, 8922, 'Monte Sion', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1024, NULL, 8923, 'Cococi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2115, NULL, 8924, 'Canabravinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4165, NULL, 8925, 'Alexandra', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5156, NULL, 8926, 'Alto Santana', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5156, NULL, 8927, 'Velhacaria', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5156, NULL, 8928, 'São João do Aporé', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5156, NULL, 8929, 'Raimundo', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5156, NULL, 8930, 'Tamandaré', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4167, NULL, 8931, 'Cristo Rei', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4167, NULL, 8932, 'Deputado José Afonso', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4167, NULL, 8933, 'Graciosa', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4167, NULL, 8934, 'Sumaré', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2116, NULL, 8935, 'Águas do Paulista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (119, NULL, 8936, 'Mocambo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2117, NULL, 8937, 'Conceição de Campinas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1583, NULL, 8938, 'Icaiçara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1170, NULL, 8939, 'Icaiçara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1583, NULL, 8940, 'Veneza', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1170, NULL, 8941, 'Veneza', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (581, NULL, 8942, 'Brejo de São Félix', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4904, NULL, 8943, 'Santa Cristina', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4904, NULL, 8944, 'Poço Fundo', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2798, NULL, 8945, 'Pé do Morro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2798, NULL, 8946, 'Pinheirinhos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4905, NULL, 8947, 'Pitingal', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4905, NULL, 8948, 'Campo de Sobradinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4905, NULL, 8949, 'Murta', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1584, NULL, 8950, 'Bengalas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4496, NULL, 8951, 'Balneário Rosa do Mar', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4907, NULL, 8952, 'Pulador', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4907, NULL, 8953, 'Bom Recreio', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4907, NULL, 8954, 'Bela Vista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4907, NULL, 8955, 'Sede Independência', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4907, NULL, 8956, 'São Roque', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (583, NULL, 8957, 'Roçado', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4169, NULL, 8958, 'São Roque do Chopim', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1375, NULL, 8959, 'Santa Gertrudes', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2804, NULL, 8960, 'Chumbo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2804, NULL, 8961, 'Bom Sucesso de Patos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2804, NULL, 8962, 'Santana de Patos', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2804, NULL, 8963, 'Major Porto', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2804, NULL, 8964, 'Pindaíbas', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2804, NULL, 8965, 'Pilar', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2805, NULL, 8966, 'Santa Luzia dos Barros', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2805, NULL, 8967, 'Silvano', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2805, NULL, 8968, 'Salitre de Minas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2805, NULL, 8969, 'São João da Serra Negra', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3227, NULL, 8970, 'Avelar', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2807, NULL, 8971, 'Airões', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1376, NULL, 8972, 'Mimoso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1586, NULL, 8973, 'Mimoso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1376, NULL, 8974, 'Ipueiras', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1586, NULL, 8975, 'Ipueiras', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4171, NULL, 8976, 'Vera Guarani', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4909, NULL, 8977, 'Bom Jardim', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4909, NULL, 8978, 'Fazenda São José', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2810, NULL, 8979, 'Santa Teresa do Bonito', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3681, NULL, 8980, 'Vanglória', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3681, NULL, 8981, 'Guaianás', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3681, NULL, 8982, 'Santelmo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1587, NULL, 8983, 'Santo Antônio', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1587, NULL, 8984, 'São Pedro do Cordeiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1587, NULL, 8985, 'Poço do Boi', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1587, NULL, 8986, 'Horizonte Alegre', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2811, NULL, 8987, 'Araçaji de Minas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1377, NULL, 8988, 'Capitão Mor', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1026, NULL, 8989, 'Capitão Mor', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1377, NULL, 8990, 'Mineirolândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1026, NULL, 8991, 'Mineirolândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1377, NULL, 8992, 'Santa Cruz do Banabuiú', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1026, NULL, 8993, 'Santa Cruz do Banabuiú', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1377, NULL, 8994, 'Tróia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1026, NULL, 8995, 'Tróia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1176, NULL, 8996, 'São José do Planalto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5267, NULL, 8997, 'São José do Planalto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3683, NULL, 8998, 'Santa Isabel do Marinheiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4910, NULL, 8999, 'Arroio Mau', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4910, NULL, 9000, 'Cerro do Baú', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4910, NULL, 9001, 'São Diogo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2817, NULL, 9002, 'São Pedro das Tabocas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4499, NULL, 9003, 'Azambuja', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3684, NULL, 9004, 'Alto Porã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3684, NULL, 9005, 'Igaçaba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (586, NULL, 9006, 'Marianópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (405, NULL, 9007, 'Porto Real', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3150, NULL, 9008, 'Cristal do Norte', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2819, NULL, 9009, 'Fidalgo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2819, NULL, 9010, 'Vera Cruz de Minas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2819, NULL, 9011, 'Doutor Lund', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2819, NULL, 9012, 'Lagoa de Santo Antônio', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4911, NULL, 9013, 'Matarazzo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (241, NULL, 9014, 'Tauarizinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4913, NULL, 9015, 'Monte Bonito', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4913, NULL, 9016, 'Triunfo', '60', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4913, NULL, 9017, 'Quilombo', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4913, NULL, 9018, 'Cerrito Alegre', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4913, NULL, 9019, 'Rincão da Cruz', '42', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4913, NULL, 9020, 'Santa Silvana', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4913, NULL, 9021, 'Cascata', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4913, NULL, 9022, 'Z/3', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1027, NULL, 9023, 'Juá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1027, NULL, 9024, 'Santo André', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1028, NULL, 9025, 'Sebastião de Abreu', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1028, NULL, 9026, 'Matias', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1028, NULL, 9027, 'Porfírio Sampaio', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1029, NULL, 9028, 'Crioulos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2826, NULL, 9029, 'São Sebastião do Baixio', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2826, NULL, 9030, 'Pedra Corrida', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4175, NULL, 9031, 'Conciolândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1588, NULL, 9032, 'Salobro', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1588, NULL, 9033, 'Mutuca', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1588, NULL, 9034, 'Papagaio', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1588, NULL, 9035, 'Mimoso', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1588, NULL, 9036, 'Cimbres', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1589, NULL, 9037, 'Rio Antinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4502, NULL, 9038, 'Rio Antinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1590, NULL, 9039, 'Rajada', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1590, NULL, 9040, 'Curral Queimado', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1590, NULL, 9041, 'Cristália', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3228, NULL, 9042, 'Posse', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3228, NULL, 9043, 'Pedro do Rio', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3228, NULL, 9044, 'Cascatinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3228, NULL, 9045, 'Itaipava', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2123, NULL, 9046, 'Inúbia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2123, NULL, 9047, 'Cabrália', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2831, NULL, 9048, 'Paraíso da Piedade', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2831, NULL, 9049, 'Santo Antônio do Porto', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2124, NULL, 9050, 'Saldanha', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2124, NULL, 9051, 'Brejo da Serra', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2124, NULL, 9052, 'Baluarte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2833, NULL, 9053, 'Santo Hilário', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (35, NULL, 9054, 'Marco Rondon', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2125, NULL, 9055, 'Guirapá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3695, NULL, 9056, 'Moreira César', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2126, NULL, 9057, 'Bananeiras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2126, NULL, 9058, 'Várzea Grande', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2126, NULL, 9059, 'Carnaíba de Baixo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3696, NULL, 9060, 'Roberto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1030, NULL, 9061, 'Caponguinha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1030, NULL, 9062, 'Capim de Roça', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1030, NULL, 9063, 'Ema', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1030, NULL, 9064, 'Pratiús', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4917, NULL, 9065, 'Rincão do Appel', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4179, NULL, 9066, 'Lavrinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4504, NULL, 9067, 'Machado', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3697, NULL, 9068, 'Machado', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1801, NULL, 9069, 'Bom Retiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4180, NULL, 9070, 'Bom Retiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1801, NULL, 9071, 'Pinhalzinho', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4180, NULL, 9072, 'Pinhalzinho', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1801, NULL, 9073, 'Faxinal do Céu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4180, NULL, 9074, 'Faxinal do Céu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (592, NULL, 9075, 'Roque', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4919, NULL, 9076, 'Candiota', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4919, NULL, 9077, 'Torrinhas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3151, NULL, 9078, 'São João do Sobrado', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2835, NULL, 9079, 'Vila Acari', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1031, NULL, 9080, 'Mulungu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1031, NULL, 9081, 'Catolé da Pista', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1031, NULL, 9082, 'Ibicuã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3700, NULL, 9083, 'Batatuba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3701, NULL, 9084, 'Santa Teresinha de Piracicaba', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3701, NULL, 9085, 'Ibitiruna', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3701, NULL, 9086, 'Artemis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3701, NULL, 9087, 'Guamium', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3701, NULL, 9088, 'Tupi', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3230, NULL, 9089, 'Arrozal', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3230, NULL, 9090, 'Santanésia', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3230, NULL, 9091, 'Monumento', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3702, NULL, 9092, 'Tibiriçá do Paranapanema', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3703, NULL, 9093, 'Santo Antônio da Estiva', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3703, NULL, 9094, 'Corredeira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3703, NULL, 9095, 'Pradínia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2838, NULL, 9096, 'Santo Antônio do Pirapetinga', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2838, NULL, 9097, 'Pinheiros Altos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2840, NULL, 9098, 'Santa Bárbara do Sapucaí', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2840, NULL, 9099, 'Olegário Maciel', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5501, NULL, 9100, 'Entremontes', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1725, NULL, 9101, 'Entremontes', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2841, NULL, 9102, 'Valão Quente', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2841, NULL, 9103, 'Caiapó', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4920, NULL, 9104, 'Figueira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3706, NULL, 9105, 'Itororó do Paranapanema', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3707, NULL, 9106, 'Cachoeira de Emas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4921, NULL, 9107, 'Segundo Distrito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4921, NULL, 9108, 'Quarto Distrito', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4921, NULL, 9109, 'Terceiro Distrito', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4921, NULL, 9110, 'Quinto Distrito', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4506, NULL, 9111, 'Uruguai', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5502, NULL, 9112, 'Lagolândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1032, NULL, 9113, 'Donato', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1032, NULL, 9114, 'Santo Izidro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1032, NULL, 9115, 'Otavilândia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2130, NULL, 9116, 'Largo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2130, NULL, 9117, 'Porto Feliz', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2130, NULL, 9118, 'França', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4183, NULL, 9119, 'Rio XV de Baixo', '37', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4183, NULL, 9120, 'Barra Bonita', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4183, NULL, 9121, 'Vila Nova', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3709, NULL, 9122, 'Ibitiúva', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4184, NULL, 9123, 'Ibitiúva', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3152, NULL, 9124, 'Aghá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (65, NULL, 9125, 'Campinas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5504, NULL, 9126, 'São Gabriel de Goiás', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5504, NULL, 9127, 'Córrego Rico', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4185, NULL, 9128, 'Comur', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2131, NULL, 9129, 'Ibitiguira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2131, NULL, 9130, 'Nova Itaípe', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2132, NULL, 9131, 'São Luiz', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4186, NULL, 9132, 'São Luiz', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4922, NULL, 9133, 'São Luiz', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3710, NULL, 9134, 'São Luiz', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2132, NULL, 9135, 'Valério', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4186, NULL, 9136, 'Valério', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4922, NULL, 9137, 'Valério', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3710, NULL, 9138, 'Valério', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2132, NULL, 9139, 'Centro Novo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4186, NULL, 9140, 'Centro Novo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4922, NULL, 9141, 'Centro Novo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3710, NULL, 9142, 'Centro Novo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2132, NULL, 9143, 'Santa Cruz', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4186, NULL, 9144, 'Santa Cruz', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4922, NULL, 9145, 'Santa Cruz', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3710, NULL, 9146, 'Santa Cruz', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2132, NULL, 9147, 'Barra Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4186, NULL, 9148, 'Barra Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4922, NULL, 9149, 'Barra Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3710, NULL, 9150, 'Barra Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2132, NULL, 9151, 'São José', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4186, NULL, 9152, 'São José', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4922, NULL, 9153, 'São José', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3710, NULL, 9154, 'São José', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2132, NULL, 9155, 'Sagrada Família', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4186, NULL, 9156, 'Sagrada Família', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4922, NULL, 9157, 'Sagrada Família', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3710, NULL, 9158, 'Sagrada Família', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2132, NULL, 9159, 'Lucaia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4186, NULL, 9160, 'Lucaia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4922, NULL, 9161, 'Lucaia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3710, NULL, 9162, 'Lucaia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3712, NULL, 9163, 'Cidade Kemel', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1591, NULL, 9164, 'Pão de Açúcar de Poção', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1388, NULL, 9165, 'Nazaré', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2847, NULL, 9166, 'Paiolinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5270, NULL, 9167, 'Fazenda de Cima', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5270, NULL, 9168, 'Cangas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2849, NULL, 9169, 'Barra da Figueira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2849, NULL, 9170, 'Assaraí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2134, NULL, 9171, 'Miranga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1391, NULL, 9172, 'Várzea Comprida', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1592, NULL, 9173, 'Dois Leões', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1592, NULL, 9174, 'Nossa Senhora do Carmo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3714, NULL, 9175, 'Paulópolis', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3714, NULL, 9176, 'Novo Cravinhos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2850, NULL, 9177, 'Silva Campos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4187, NULL, 9178, 'Guaragi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4187, NULL, 9179, 'Itaiacoca', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4187, NULL, 9180, 'Piriquitos', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4187, NULL, 9181, 'Uvaia', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5159, NULL, 9182, 'Cabeceira do Apa', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5159, NULL, 9183, 'Sanga Puitã', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3716, NULL, 9184, 'Cândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4924, NULL, 9185, 'Sagrisa', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2851, NULL, 9186, 'Vau-Açu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2851, NULL, 9187, 'Rosário do Pontal', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4925, NULL, 9188, 'Souto Neto', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4511, NULL, 9189, 'Baía Alta', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3153, NULL, 9190, 'Itamira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2853, NULL, 9191, 'Santana do Araçuaí', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1033, NULL, 9192, 'Macambira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1033, NULL, 9193, 'Buritizal', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1033, NULL, 9194, 'Cachoeira Grande', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3231, NULL, 9195, 'Santa Clara', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3231, NULL, 9196, 'Purilândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1034, NULL, 9197, 'Simão', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2854, NULL, 9198, 'Paciência', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2854, NULL, 9199, 'Mulungu de Minas', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2854, NULL, 9200, 'Tocandira', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2854, NULL, 9201, 'Tanque de Porteirinha', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2854, NULL, 9202, 'Mocambinho', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2854, NULL, 9203, 'Serra Branca de Minas', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2854, NULL, 9204, 'Gorutuba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (66, NULL, 9205, 'Vila do V', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (66, NULL, 9206, 'Vila do Incra', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (66, NULL, 9207, 'Vila do Caquetá', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (246, NULL, 9208, 'Veiros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (246, NULL, 9209, 'Vilarinho do Monte', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1728, NULL, 9210, 'Tatuamunha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (414, NULL, 9211, 'Luzimangues', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2136, NULL, 9212, 'Caraiva', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2136, NULL, 9213, 'Trancoso', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2136, NULL, 9214, 'Arraial D''Ajuda', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2136, NULL, 9215, 'Vale Verde', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4513, NULL, 9216, 'São Miguel da Serra', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4513, NULL, 9217, 'Santa Cruz do Timbó', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (37, NULL, 9218, 'Calama', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (37, NULL, 9219, 'Extrema', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (37, NULL, 9220, 'Jaci Paraná', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (37, NULL, 9221, 'Abunã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (37, NULL, 9222, 'Nazaré', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (37, NULL, 9223, 'São Carlos', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (37, NULL, 9224, 'Demarcação', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (37, NULL, 9225, 'Vista Alegre do Abunã', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (37, NULL, 9226, 'Fortaleza do Abunã', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (37, NULL, 9227, 'Nova Califórnia', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (37, NULL, 9228, 'Mutum Paraná', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4931, NULL, 9229, 'Rincão Comprido', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2856, NULL, 9230, 'Sucanga', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2856, NULL, 9231, 'Valão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1035, NULL, 9232, 'Barreiros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2137, NULL, 9233, 'Gurupá Mirim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1036, NULL, 9234, 'Canindezinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2857, NULL, 9235, 'Sao José do Pântano', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2858, NULL, 9236, 'Santana do Capivari', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4514, NULL, 9237, 'Aterrado Torto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5278, NULL, 9238, 'Alto Coité', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5278, NULL, 9239, 'Jarudore', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5278, NULL, 9240, 'Paraíso do Leste', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2138, NULL, 9241, 'Cumuruxatiba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3727, NULL, 9242, 'Cachoeira de Fátima', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4515, NULL, 9243, 'Cachoeira de Fátima', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3727, NULL, 9244, 'Solemar', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4515, NULL, 9245, 'Solemar', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (247, NULL, 9246, 'Pacoval', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4195, NULL, 9247, 'Canzianópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1392, NULL, 9248, 'Jardinésia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2860, NULL, 9249, 'Jardinésia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1392, NULL, 9250, 'Patrimônio', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2860, NULL, 9251, 'Patrimônio', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3729, NULL, 9252, 'Guaricanga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2863, NULL, 9253, 'Nova Pátria', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3730, NULL, 9254, 'Nova Pátria', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2863, NULL, 9255, 'Araxãs', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3730, NULL, 9256, 'Araxãs', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4196, NULL, 9257, 'Boa Vista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (598, NULL, 9258, 'Campo Formoso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2139, NULL, 9259, 'Campo Formoso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3731, NULL, 9260, 'Campinal', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (121, NULL, 9261, 'Balbina', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4517, NULL, 9262, 'Mirador', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (38, NULL, 9263, 'Estrela de Rondônia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (600, NULL, 9264, 'Estrela de Rondônia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (38, NULL, 9265, 'Novo Riachuelo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (600, NULL, 9266, 'Novo Riachuelo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (38, NULL, 9267, 'Vila Bandeira Branca', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (600, NULL, 9268, 'Vila Bandeira Branca', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (38, NULL, 9269, 'Vila Camargo', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (600, NULL, 9270, 'Vila Camargo', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2866, NULL, 9271, 'Ponte Firme', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2866, NULL, 9272, 'Santiago de Minas', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2866, NULL, 9273, 'Galena', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3732, NULL, 9274, 'Montalvão', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3732, NULL, 9275, 'Eneida', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3732, NULL, 9276, 'Ameliópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3732, NULL, 9277, 'Floresta do Sul', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4197, NULL, 9278, 'Ibiaci', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4934, NULL, 9279, 'Batovira', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4934, NULL, 9280, 'Constantino', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4934, NULL, 9281, 'Xaxim', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4934, NULL, 9282, 'Campo Branco', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3734, NULL, 9283, 'Santa Maria do Gurupá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4198, NULL, 9284, 'Patos Velhos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4198, NULL, 9285, 'Jaciaba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4936, NULL, 9286, 'Xarqueada', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2868, NULL, 9287, 'Quartel de São João', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3233, NULL, 9288, 'Falcão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3233, NULL, 9289, 'Ribeirão de São Joaquim', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4201, NULL, 9290, 'Borda do Campo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1395, NULL, 9291, 'Coronel João Borges', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2142, NULL, 9292, 'Coronel João Borges', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5280, NULL, 9293, 'Coutinho União', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4204, NULL, 9294, 'Porto Brasílio', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4204, NULL, 9295, 'Icatu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2143, NULL, 9296, 'Algodões', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4205, NULL, 9297, 'Irapuan', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4940, NULL, 9298, 'Santa Clara do Ingaí', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4940, NULL, 9299, 'Sede Aurora', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1594, NULL, 9300, 'Pau Ferro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4206, NULL, 9301, 'Pangaré', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4206, NULL, 9302, 'Doce Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1037, NULL, 9303, 'São Francisco', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1037, NULL, 9304, 'Algodões', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1038, NULL, 9305, 'Custódio', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1038, NULL, 9306, 'Riacho Verde', '52', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1038, NULL, 9307, 'São Bernardo', '57', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1038, NULL, 9308, 'São João dos Queirozes', '59', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1038, NULL, 9309, 'Dom Maurício', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1038, NULL, 9310, 'Juá', '43', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1038, NULL, 9311, 'Tapuiará', '65', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1038, NULL, 9312, 'Daniel de Queiróz', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1038, NULL, 9313, 'Cipó dos Anjos', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1038, NULL, 9314, 'Várzea da Onça', '70', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1038, NULL, 9315, 'Califórnia', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1038, NULL, 9316, 'Juatama', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1039, NULL, 9317, 'Antonico', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1040, NULL, 9318, 'Lacerda', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1040, NULL, 9319, 'Manituba', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1040, NULL, 9320, 'Nenelândia', '32', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1040, NULL, 9321, 'Belém', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1040, NULL, 9322, 'Damião Carneiro', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1040, NULL, 9323, 'Uruquê', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1040, NULL, 9324, 'Passagem', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1040, NULL, 9325, 'São Miguel', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1040, NULL, 9326, 'Encantado', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1041, NULL, 9327, 'Agua Fria', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1041, NULL, 9328, 'Tomé', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1041, NULL, 9329, 'Lagoinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2145, NULL, 9330, 'Paraguassú', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2145, NULL, 9331, 'Cajueiro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2145, NULL, 9332, 'Argoim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3741, NULL, 9333, 'Agissê', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3741, NULL, 9334, 'Gardênia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4521, NULL, 9335, 'Taquaras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2871, NULL, 9336, 'São Vicente da Estrela', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2871, NULL, 9337, 'Vermelho Velho', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2871, NULL, 9338, 'Santana do Tabuleiro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2871, NULL, 9339, 'São Sebastião do Óculo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2871, NULL, 9340, 'Bicuíba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4210, NULL, 9341, 'Marmelândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4210, NULL, 9342, 'Maravilha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4210, NULL, 9343, 'São Roque', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2872, NULL, 9344, 'Conceição da Boa Vista', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2872, NULL, 9345, 'Angaturama', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1042, NULL, 9346, 'Antônio Diogo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (250, NULL, 9347, 'Antônio Diogo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1042, NULL, 9348, 'Guassi', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (250, NULL, 9349, 'Guassi', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1042, NULL, 9350, 'Faísca', '21', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (250, NULL, 9351, 'Faísca', '21', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1042, NULL, 9352, 'Barra Nova', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (250, NULL, 9353, 'Barra Nova', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4941, NULL, 9354, 'Sítio Cassemiro', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4941, NULL, 9355, 'São João', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2873, NULL, 9356, 'Jaguaraí', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3743, NULL, 9357, 'Espigão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2146, NULL, 9358, 'Poços', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4212, NULL, 9359, 'Canela', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4212, NULL, 9360, 'Baulândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1043, NULL, 9361, 'Campo Lindo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1043, NULL, 9362, 'Amanaiara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3236, NULL, 9363, 'Pedra Selada', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3236, NULL, 9364, 'Agulhas Negras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3236, NULL, 9365, 'Engenheiro Passos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3236, NULL, 9366, 'Fumaça', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2874, NULL, 9367, 'Jacarandira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4213, NULL, 9368, 'Rio Novo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4213, NULL, 9369, 'José Lacerda', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2875, NULL, 9370, 'Bom Pastor', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2875, NULL, 9371, 'Independência', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2875, NULL, 9372, 'Campo Alegre de Minas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2875, NULL, 9373, 'Nicolândia', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2875, NULL, 9374, 'Calixto', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2876, NULL, 9375, 'Canjamba', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2876, NULL, 9376, 'Vargem do Amargoso', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2876, NULL, 9377, 'Simão Tamm', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2148, NULL, 9378, 'São José do Rio Grande', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2148, NULL, 9379, 'Cariparé', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1807, NULL, 9380, 'Palmares', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2149, NULL, 9381, 'Barreiros', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1597, NULL, 9382, 'Pinhões', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1597, NULL, 9383, 'Couro d''Antas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1597, NULL, 9384, 'Trapiá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1597, NULL, 9385, 'Vitorino', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1189, NULL, 9386, 'Botuquara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2150, NULL, 9387, 'Botuquara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2878, NULL, 9388, 'Bem-Querer', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5512, NULL, 9389, 'Castrinópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5161, NULL, 9390, 'Bálsamo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1598, NULL, 9391, 'José Mariano', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1598, NULL, 9392, 'Aripibu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3748, NULL, 9393, 'Guarapiranga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3749, NULL, 9394, 'Campina de Fora', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3749, NULL, 9395, 'Itabôa', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4215, NULL, 9396, 'Cachoeira do Espírito Santo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2879, NULL, 9397, 'Justinópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2153, NULL, 9398, 'Nova Brasilia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4216, NULL, 9399, 'Triolândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3754, NULL, 9400, 'Jardim Santa Luzia', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3754, NULL, 9401, 'Ouro Fino Paulista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3755, NULL, 9402, 'Bonfim Paulista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3155, NULL, 9403, 'São Jorge de Tiradentes', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4218, NULL, 9404, 'Santo Antônio do Palmital', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3237, NULL, 9405, 'Bazílio', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3237, NULL, 9406, 'Boa Esperança', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4219, NULL, 9407, 'Campo do Bugre', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4219, NULL, 9408, 'Assentamento Ireno Alves dos Santos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4219, NULL, 9409, 'Pinhalzinho', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4219, NULL, 9410, 'Linha Rosa', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4221, NULL, 9411, 'Açungui', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5162, NULL, 9412, 'Prudêncio Thomaz', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2882, NULL, 9413, 'Jurumirim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3759, NULL, 9414, 'São João Marcos', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3238, NULL, 9415, 'São João Marcos', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3759, NULL, 9416, 'Getulândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3238, NULL, 9417, 'Getulândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3759, NULL, 9418, 'Assistência', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3238, NULL, 9419, 'Assistência', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3759, NULL, 9420, 'Lídice', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3238, NULL, 9421, 'Lídice', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3759, NULL, 9422, 'Passa Três', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3238, NULL, 9423, 'Passa Três', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3759, NULL, 9424, 'Ajapi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3238, NULL, 9425, 'Ajapi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4522, NULL, 9426, 'Ipoméia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3239, NULL, 9427, 'Taboas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3239, NULL, 9428, 'Abarracamento', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3239, NULL, 9429, 'Manuel Duarte', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2154, NULL, 9430, 'Marcolino Moura', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2154, NULL, 9431, 'Arapiranga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2155, NULL, 9432, 'Ibitira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2156, NULL, 9433, 'Ibiajara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4526, NULL, 9434, 'Cedro Alto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4944, NULL, 9435, 'Posse dos Linhares', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2885, NULL, 9436, 'Rio Melo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2885, NULL, 9437, 'Piranguita', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1599, NULL, 9438, 'Cocaú', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4945, NULL, 9439, 'Ilha dos Marinheiros', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4945, NULL, 9440, 'Quinta', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4945, NULL, 9441, 'Taim', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4945, NULL, 9442, 'Povo Novo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2886, NULL, 9443, 'Souza', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4528, NULL, 9444, 'Vila de Volta Grande', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4222, NULL, 9445, 'Nova Esperança', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5163, NULL, 9446, 'Nova Esperança', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3156, NULL, 9447, 'Princesa', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2888, NULL, 9448, 'Abaeté dos Mendes', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4946, NULL, 9449, 'João Rodrigues', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4946, NULL, 9450, 'Passo da Areia', '24', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4946, NULL, 9451, 'Rincão del Rei', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4946, NULL, 9452, 'Bexiga', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4946, NULL, 9453, 'Passo do Adão', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4946, NULL, 9454, 'Albardão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4946, NULL, 9455, 'Iruí', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2889, NULL, 9456, 'Serra Nova', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2890, NULL, 9457, 'Conceição de Piracicaba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2890, NULL, 9458, 'Padre Pinto', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1403, NULL, 9459, 'Barra do Mamanguape', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1403, NULL, 9460, 'Salema', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5515, NULL, 9461, 'Lagoa do Bauzinho', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5515, NULL, 9462, 'Riverlândia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5515, NULL, 9463, 'Ouroana', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5164, NULL, 9464, 'Juscelândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2893, NULL, 9465, 'Pedra Menina', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4948, NULL, 9466, 'Campinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5165, NULL, 9467, 'Água Boa', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4949, NULL, 9468, 'Saltinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4950, NULL, 9469, 'Passo do Quaresma', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4950, NULL, 9470, 'Igrejinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4950, NULL, 9471, 'Serrinha do Rosário', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4950, NULL, 9472, 'Passo do Faxinal', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4223, NULL, 9473, 'São Martinho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4223, NULL, 9474, 'Nossa Senhora da Aparecida', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4951, NULL, 9475, 'Boa Esperança', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4951, NULL, 9476, 'Rolantinho', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4224, NULL, 9477, 'Alto do São João', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4952, NULL, 9478, 'Alto Recreio', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5286, NULL, 9479, 'Anhumas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5286, NULL, 9480, 'Boa Vista', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5286, NULL, 9481, 'Nova Galiléia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5286, NULL, 9482, 'Vila Operária', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4954, NULL, 9483, 'Dona Otília', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4954, NULL, 9484, 'Rincão Vermelho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4955, NULL, 9485, 'Mangueiras', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4955, NULL, 9486, 'Touro Passo', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4955, NULL, 9487, 'São Carlos', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4955, NULL, 9488, 'Caverá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4955, NULL, 9489, 'Campo Sêco', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5287, NULL, 9490, 'Marzagão', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5287, NULL, 9491, 'Bauxi', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5287, NULL, 9492, 'Arruda', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5516, NULL, 9493, 'Valdelândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2900, NULL, 9494, 'Itapiru', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3767, NULL, 9495, 'Esmeralda', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (253, NULL, 9496, 'Divinópolis', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1044, NULL, 9497, 'Peixe', '19', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1044, NULL, 9498, 'São João de Deus', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1044, NULL, 9499, 'Bonhu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1044, NULL, 9500, 'Lagoa Grande', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1044, NULL, 9501, 'Flores', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1193, NULL, 9502, 'Morro das Flores', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2159, NULL, 9503, 'Morro das Flores', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1193, NULL, 9504, 'Tapiraípe', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2159, NULL, 9505, 'Tapiraípe', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2901, NULL, 9506, 'Carvalho de Brito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2901, NULL, 9507, 'Mestre Caetano', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2901, NULL, 9508, 'Ravena', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2902, NULL, 9509, 'Euxenita', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2902, NULL, 9510, 'Quilombo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1045, NULL, 9511, 'Flamengo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1045, NULL, 9512, 'Felipe', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1045, NULL, 9513, 'Barrinha', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1045, NULL, 9514, 'São José', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1045, NULL, 9515, 'Malhada', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2903, NULL, 9516, 'Desemboque', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4956, NULL, 9517, 'Leonel Rocha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4957, NULL, 9518, 'Campinas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3772, NULL, 9519, 'Nossa Senhora do Remédio', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1404, NULL, 9520, 'São José da Batalha', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1601, NULL, 9521, 'São José da Batalha', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1405, NULL, 9522, 'Dois Riachos', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1405, NULL, 9523, 'Feira Nova', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4228, NULL, 9524, 'Tiradentes', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1602, NULL, 9525, 'Pau Ferro', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1602, NULL, 9526, 'Umãs', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1602, NULL, 9527, 'Conceição das Crioulas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1602, NULL, 9528, 'Vasques', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2904, NULL, 9529, 'Nova Matrona', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2904, NULL, 9530, 'Ferreirópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1046, NULL, 9531, 'Caldeirão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1046, NULL, 9532, 'Lagoa dos Crioulos', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1603, NULL, 9533, 'Iatecá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5288, NULL, 9534, 'Vila Progresso', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5288, NULL, 9535, 'Cristinópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4958, NULL, 9536, 'Capão Bonito', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4958, NULL, 9537, 'Tabajara', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4958, NULL, 9538, 'Júlio Borges', '21', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4958, NULL, 9539, 'Rincão do Ivaí', '24', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4958, NULL, 9540, 'Passo Real', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4959, NULL, 9541, 'Santa Catarina', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4960, NULL, 9542, 'Linha São João', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4960, NULL, 9543, 'Linha Comprida', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4960, NULL, 9544, 'Campestre', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (255, NULL, 9545, 'Monsarás', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (255, NULL, 9546, 'Jubim', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (255, NULL, 9547, 'Joanes', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (255, NULL, 9548, 'Condeixa', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4961, NULL, 9549, 'Rio Tigre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4536, NULL, 9550, 'Morro Grande', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1604, NULL, 9551, 'Mulungu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1604, NULL, 9552, 'Jenipapo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3779, NULL, 9553, 'Botelho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3779, NULL, 9554, 'Santa Rosa', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3779, NULL, 9555, 'Ururaí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2162, NULL, 9556, 'Conceição do Rio Acima', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2906, NULL, 9557, 'Conceição do Rio Acima', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2162, NULL, 9558, 'Florália', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2906, NULL, 9559, 'Florália', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2162, NULL, 9560, 'Brumal', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2906, NULL, 9561, 'Brumal', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2162, NULL, 9562, 'Barra Feliz', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2906, NULL, 9563, 'Barra Feliz', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2908, NULL, 9564, 'São Sebastião do Barreado', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4962, NULL, 9565, 'Capão Alto', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4962, NULL, 9566, 'Itaíba', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2909, NULL, 9567, 'Bom Retiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4233, NULL, 9568, 'Santa Esmeralda', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1607, NULL, 9569, 'Pará', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1607, NULL, 9570, 'Poço Fundo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2912, NULL, 9571, 'São Sebastião do Soberbo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2912, NULL, 9572, 'Zito Soares', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3787, NULL, 9573, 'Caporanga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3787, NULL, 9574, 'Sodrélia', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3787, NULL, 9575, 'Clarínia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4965, NULL, 9576, 'Monte Alverne', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4965, NULL, 9577, 'Saraiva', '38', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4965, NULL, 9578, 'São José da Reserva', '41', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4965, NULL, 9579, 'Alto Paredão', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4965, NULL, 9580, 'Boa Vista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4965, NULL, 9581, 'São Martinho', '42', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4965, NULL, 9582, 'Rio Pardinho', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1408, NULL, 9583, 'Curva Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (610, NULL, 9584, 'Curva Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4538, NULL, 9585, 'Curva Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4235, NULL, 9586, 'Curva Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1408, NULL, 9587, 'São Clemente', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (610, NULL, 9588, 'São Clemente', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4538, NULL, 9589, 'São Clemente', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4235, NULL, 9590, 'São Clemente', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2915, NULL, 9591, 'Bom Jesus da Vitória', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4237, NULL, 9592, 'São José do Ivaí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4238, NULL, 9593, 'Jacutinga', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4238, NULL, 9594, 'Anunciação', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4238, NULL, 9595, 'Sarandi', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4238, NULL, 9596, 'Rio da Prata', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4238, NULL, 9597, 'União do Oeste', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2916, NULL, 9598, 'Zelândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3157, NULL, 9599, 'Djalma Coutinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3157, NULL, 9600, 'Mangaraí', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2917, NULL, 9601, 'São Benedito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2167, NULL, 9602, 'São Benedito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (612, NULL, 9603, 'São Benedito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1410, NULL, 9604, 'São Benedito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2918, NULL, 9605, 'Ribeirão de São Domingos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4966, NULL, 9606, 'Cambaizinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4966, NULL, 9607, 'Bolso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4966, NULL, 9608, 'Canas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4966, NULL, 9609, 'Serrinha', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4967, NULL, 9610, 'Santo Antão', '38', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1195, NULL, 9611, 'Santo Antão', '38', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4967, NULL, 9612, 'Arroio do Sol', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1195, NULL, 9613, 'Arroio do Sol', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4967, NULL, 9614, 'São Valentim', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1195, NULL, 9615, 'São Valentim', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4967, NULL, 9616, 'Boca do Monte', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1195, NULL, 9617, 'Boca do Monte', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4967, NULL, 9618, 'Palma', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1195, NULL, 9619, 'Palma', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4967, NULL, 9620, 'Arroio Grande', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1195, NULL, 9621, 'Arroio Grande', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4967, NULL, 9622, 'Pains', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1195, NULL, 9623, 'Pains', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4967, NULL, 9624, 'Passo do Verde', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1195, NULL, 9625, 'Passo do Verde', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4967, NULL, 9626, 'Santa Flora', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1195, NULL, 9627, 'Santa Flora', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1609, NULL, 9628, 'Caraíbas', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1609, NULL, 9629, 'Urimamã', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2168, NULL, 9630, 'Inhaúmas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2168, NULL, 9631, 'Açudina', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (260, NULL, 9632, 'Casa de Tábua', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (260, NULL, 9633, 'Nova Esperança', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2919, NULL, 9634, 'Itauninha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3158, NULL, 9635, 'Garrafão', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4240, NULL, 9636, 'Rio do Tigre', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4240, NULL, 9637, 'São José', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4240, NULL, 9638, 'São Manoel', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4240, NULL, 9639, 'Ouro Verde', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2921, NULL, 9640, 'Poaia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2921, NULL, 9641, 'Brejo de Minas', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2921, NULL, 9642, 'Glucínio', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3242, NULL, 9643, 'Santo Antônio do Imbé', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3242, NULL, 9644, 'Renascença', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3242, NULL, 9645, 'Doutor Loréti', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3242, NULL, 9646, 'Sossego', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3242, NULL, 9647, 'Triunfo', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3794, NULL, 9648, 'Terra Nova d''Oeste', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1047, NULL, 9649, 'Raimundo Martins', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1047, NULL, 9650, 'Logradouro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1047, NULL, 9651, 'Malhada Grande', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1047, NULL, 9652, 'Lisieux', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1047, NULL, 9653, 'Macaraú', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1047, NULL, 9654, 'Trapiá', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1047, NULL, 9655, 'Muribeca', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1411, NULL, 9656, 'Nossa Senhora do Livramento', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (615, NULL, 9657, 'Nossa Senhora do Livramento', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3796, NULL, 9658, 'Aparecida do Bonito', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2922, NULL, 9659, 'Pião', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2922, NULL, 9660, 'São Bento de Caldas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2169, NULL, 9661, 'Malhada Grande', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2923, NULL, 9662, 'Paraíso Garcia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2923, NULL, 9663, 'Bom Jesus do Vermelho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2924, NULL, 9664, 'Itaboca', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2926, NULL, 9665, 'São José do Itueto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2926, NULL, 9666, 'Alto Pião', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3795, NULL, 9667, 'Santa Cruz da Estrela', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4969, NULL, 9668, 'Sete de Setembro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (428, NULL, 9669, 'Morro de São João', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (428, NULL, 9670, 'Cangas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3159, NULL, 9671, 'São João de Petrópolis', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3159, NULL, 9672, 'Alto Caldeirão', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3159, NULL, 9673, 'Alto Santa Maria', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3159, NULL, 9674, 'Vinte e Cinco de Julho', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3159, NULL, 9675, 'Santo Antônio do Canaã', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4541, NULL, 9676, 'Rio da Anta', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5292, NULL, 9677, 'Rio da Anta', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1611, NULL, 9678, 'Rio da Anta', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4541, NULL, 9679, 'Craveiro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5292, NULL, 9680, 'Craveiro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1611, NULL, 9681, 'Craveiro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2929, NULL, 9682, 'Perdilândia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2929, NULL, 9683, 'Chaveslândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4971, NULL, 9684, 'Taim', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4971, NULL, 9685, 'Mirim', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4971, NULL, 9686, 'Atlântico', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4971, NULL, 9687, 'Arvore Só', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4971, NULL, 9688, 'Curral Alto', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2171, NULL, 9689, 'Pereira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2172, NULL, 9690, 'Pirativa', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (306, NULL, 9691, 'Pirativa', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2172, NULL, 9692, 'Piaçacá', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (306, NULL, 9693, 'Piaçacá', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2172, NULL, 9694, 'Ilha de Santana', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (306, NULL, 9695, 'Ilha de Santana', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2172, NULL, 9696, 'Porto Novo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (306, NULL, 9697, 'Porto Novo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2172, NULL, 9698, 'Anauerapucu', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (306, NULL, 9699, 'Anauerapucu', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2172, NULL, 9700, 'Igarapé do Lago', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (306, NULL, 9701, 'Igarapé do Lago', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2932, NULL, 9702, 'Fechados', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1048, NULL, 9703, 'Baixa Fria', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1048, NULL, 9704, 'Parapuí', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1048, NULL, 9705, 'Bahia', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1048, NULL, 9706, 'Sapó', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1048, NULL, 9707, 'Mutambeiras', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1048, NULL, 9708, 'João Cordeiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1048, NULL, 9709, 'Barro Preto', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1049, NULL, 9710, 'Inhumas', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1049, NULL, 9711, 'Brejo Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1049, NULL, 9712, 'Araporanga', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1049, NULL, 9713, 'Dom Leme', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1049, NULL, 9714, 'Anjinhos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1049, NULL, 9715, 'Pontal da Santa Cruz', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2936, NULL, 9716, 'Santa Filomena', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1196, NULL, 9717, 'Barão de Serra Branca', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1196, NULL, 9718, 'Santa Teresa', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1196, NULL, 9719, 'São José da Passagem', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1735, NULL, 9720, 'Munguba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2938, NULL, 9721, 'Serra do Cipó', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1414, NULL, 9722, 'Pitombeira de Dentro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2939, NULL, 9723, 'Joselândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2173, NULL, 9724, 'Boa Espera', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1415, NULL, 9725, 'Boim', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (263, NULL, 9726, 'Boim', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1415, NULL, 9727, 'Curuai', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (263, NULL, 9728, 'Curuai', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1415, NULL, 9729, 'Alter do Chão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (263, NULL, 9730, 'Alter do Chão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4974, NULL, 9731, 'Tupantuba', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4974, NULL, 9732, 'Florida', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4974, NULL, 9733, 'Ernesto Alves', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2174, NULL, 9734, 'Acupe', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2174, NULL, 9735, 'Campinhos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3802, NULL, 9736, 'Paranapiacaba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1416, NULL, 9737, 'Paranapiacaba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3802, NULL, 9738, 'Capuava', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1416, NULL, 9739, 'Capuava', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4975, NULL, 9740, 'União', '60', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4975, NULL, 9741, 'Lajeado Cerne', '41', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4975, NULL, 9742, 'Colônia Municipal', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4975, NULL, 9743, 'Cristo Rei', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4975, NULL, 9744, 'Restinga Seca', '42', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4975, NULL, 9745, 'Sossego', '55', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4975, NULL, 9746, 'Ressaca Buriti', '48', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4975, NULL, 9747, 'Rincão dos Roratos', '47', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4975, NULL, 9748, 'Comandaí', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4975, NULL, 9749, 'Rincão dos Meotti', '46', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4975, NULL, 9750, 'Buriti', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4975, NULL, 9751, 'Lajeado Micuim', '70', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4975, NULL, 9752, 'Atafona', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4975, NULL, 9753, 'Rincão dos Mendes', '43', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4976, NULL, 9754, 'Evaristo', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4976, NULL, 9755, 'Chicolomã', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4976, NULL, 9756, 'Miraguaia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4976, NULL, 9757, 'Catanduva Grande', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4976, NULL, 9758, 'Pinheirinhos', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4246, NULL, 9759, 'Monte Real', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4246, NULL, 9760, 'Conselheiro Zacarias', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4977, NULL, 9761, 'São José', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3243, NULL, 9762, 'Paraoquena', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3243, NULL, 9763, 'Santa Cruz', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3243, NULL, 9764, 'Ibitiguaçu', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3243, NULL, 9765, 'Campelo', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3243, NULL, 9766, 'Baltazar', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3243, NULL, 9767, 'Marangatu', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3243, NULL, 9768, 'Monte Alegre', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3243, NULL, 9769, 'São Pedro de Alcântara', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2940, NULL, 9770, 'São Sebastião da Estrela', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3805, NULL, 9771, 'Vicentinópolis', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3805, NULL, 9772, 'Major Prado', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2941, NULL, 9773, 'São Domingos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2944, NULL, 9774, 'Catajás', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5295, NULL, 9775, 'Caité', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5295, NULL, 9776, 'Mimoso', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5295, NULL, 9777, 'Varginha', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5295, NULL, 9778, 'Engenho Velho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4978, NULL, 9779, 'São José', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4978, NULL, 9780, 'Santa Terezinha', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4978, NULL, 9781, 'Montes Carpatos', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4248, NULL, 9782, 'São Judas Tadeu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4979, NULL, 9783, 'Rincão Doce', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4249, NULL, 9784, 'São Pedro do Florido', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4249, NULL, 9785, 'Marcionópolis', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (265, NULL, 9786, 'São Raimundo de Borralhos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (265, NULL, 9787, 'Espírito Santo do Tauá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4980, NULL, 9788, 'Nossa Senhora de Fátima', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4980, NULL, 9789, 'Pedro Paiva', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4980, NULL, 9790, 'Rincão dos Paivas', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4980, NULL, 9791, 'Santo Antônio', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4981, NULL, 9792, 'Sírio', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4981, NULL, 9793, 'Vila Bom Princípio Baixo', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4981, NULL, 9794, 'Vila Laranjeira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2948, NULL, 9795, 'Valo Fundo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2948, NULL, 9796, 'Senhora da Glória', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2949, NULL, 9797, 'São João da Serra', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2949, NULL, 9798, 'Dores do Paraibuna', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2949, NULL, 9799, 'Mantiqueira', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2949, NULL, 9800, 'Conceição do Formoso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1050, NULL, 9801, 'Barreiros', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1050, NULL, 9802, 'Inhuçu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1612, NULL, 9803, 'Igarapeba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1613, NULL, 9804, 'Espírito Santo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3812, NULL, 9805, 'Riacho Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4983, NULL, 9806, 'Samburá', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4983, NULL, 9807, 'Nhú-Porã', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4983, NULL, 9808, 'Sarandi', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (266, NULL, 9809, 'Perseverança', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1614, NULL, 9810, 'Tapiraim', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1614, NULL, 9811, 'Maniçoba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4548, NULL, 9812, 'Água Vermelha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3814, NULL, 9813, 'Água Vermelha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4548, NULL, 9814, 'Santa Eudóxia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3814, NULL, 9815, 'Santa Eudóxia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4548, NULL, 9816, 'Bela Vista São-Carlense', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3814, NULL, 9817, 'Bela Vista São-Carlense', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4548, NULL, 9818, 'Vila Nery', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3814, NULL, 9819, 'Vila Nery', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4251, NULL, 9820, 'Porto São Carlos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2177, NULL, 9821, 'Sítio Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5531, NULL, 9822, 'Santo Antônio', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2178, NULL, 9823, 'Santo Antônio', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1817, NULL, 9824, 'Santo Antônio', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4550, NULL, 9825, 'Santo Antônio', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5531, NULL, 9826, 'Maratá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2178, NULL, 9827, 'Maratá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1817, NULL, 9828, 'Maratá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4550, NULL, 9829, 'Maratá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5531, NULL, 9830, 'Vila Milani', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2178, NULL, 9831, 'Vila Milani', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1817, NULL, 9832, 'Vila Milani', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4550, NULL, 9833, 'Vila Milani', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2953, NULL, 9834, 'Santana do Alfié', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2953, NULL, 9835, 'Cônego João Pio', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2953, NULL, 9836, 'Vargem Linda', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2953, NULL, 9837, 'Juiraçu', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2953, NULL, 9838, 'Ilhéus do Prata', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4984, NULL, 9839, 'Santa Gema', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2179, NULL, 9840, 'Caraípe', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2180, NULL, 9841, 'Outeiro Redondo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5296, NULL, 9842, 'Espigão do Leste', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (269, NULL, 9843, 'Vila Ladeira Vermelha', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (269, NULL, 9844, 'Vila Nereu', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (269, NULL, 9845, 'Taboca', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (269, NULL, 9846, 'Vila Lindoeste', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3244, NULL, 9847, 'Cambiasca', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3244, NULL, 9848, 'Pureza', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3244, NULL, 9849, 'Colônia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3244, NULL, 9850, 'Ipuca', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1818, NULL, 9851, 'Travessão de Minas', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2955, NULL, 9852, 'Travessão de Minas', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1421, NULL, 9853, 'Travessão de Minas', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3815, NULL, 9854, 'Travessão de Minas', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1818, NULL, 9855, 'Santa Isabel de Minas', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2955, NULL, 9856, 'Santa Isabel de Minas', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1421, NULL, 9857, 'Santa Isabel de Minas', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3815, NULL, 9858, 'Santa Isabel de Minas', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1818, NULL, 9859, 'Morro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2955, NULL, 9860, 'Morro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1421, NULL, 9861, 'Morro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3815, NULL, 9862, 'Morro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1818, NULL, 9863, 'Santana de São Francisco', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2955, NULL, 9864, 'Santana de São Francisco', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1421, NULL, 9865, 'Santana de São Francisco', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3815, NULL, 9866, 'Santana de São Francisco', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1818, NULL, 9867, 'Retiro', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2955, NULL, 9868, 'Retiro', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1421, NULL, 9869, 'Retiro', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3815, NULL, 9870, 'Retiro', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1818, NULL, 9871, 'Lapa do Espírito Santo', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2955, NULL, 9872, 'Lapa do Espírito Santo', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1421, NULL, 9873, 'Lapa do Espírito Santo', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3815, NULL, 9874, 'Lapa do Espírito Santo', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4985, NULL, 9875, 'Toroquá', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4985, NULL, 9876, 'Boa Vista', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4985, NULL, 9877, 'Beluno', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3245, NULL, 9878, 'Maniva', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3245, NULL, 9879, 'Barra Seca', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2956, NULL, 9880, 'Juá', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4986, NULL, 9881, 'Juá', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2956, NULL, 9882, 'Cazuza Ferreira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4986, NULL, 9883, 'Cazuza Ferreira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2956, NULL, 9884, 'Rincão dos Kroeff', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4986, NULL, 9885, 'Rincão dos Kroeff', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2956, NULL, 9886, 'Tainhas', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4986, NULL, 9887, 'Tainhas', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2956, NULL, 9888, 'Eletra', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4986, NULL, 9889, 'Eletra', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2956, NULL, 9890, 'Lajeado Grande', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4986, NULL, 9891, 'Lajeado Grande', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2182, NULL, 9892, 'Mataripe', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2182, NULL, 9893, 'Monte Recôncavo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (626, NULL, 9894, 'Caraíba do Norte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (626, NULL, 9895, 'Ribeirão Azul', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4551, NULL, 9896, 'Saí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4987, NULL, 9897, 'Catuçaba', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2183, NULL, 9898, 'Catuçaba', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4987, NULL, 9899, 'Cerro do Ouro', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2183, NULL, 9900, 'Cerro do Ouro', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4987, NULL, 9901, 'Vacacaí', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2183, NULL, 9902, 'Vacacaí', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4987, NULL, 9903, 'Suspiro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2183, NULL, 9904, 'Suspiro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4987, NULL, 9905, 'Azevedo Sodré', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2183, NULL, 9906, 'Azevedo Sodré', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4987, NULL, 9907, 'Batovi', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2183, NULL, 9908, 'Batovi', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4987, NULL, 9909, 'Gameleira do Jacaré', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2183, NULL, 9910, 'Gameleira do Jacaré', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4987, NULL, 9911, 'Tiaraju', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2183, NULL, 9912, 'Tiaraju', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (125, NULL, 9913, 'Cucui', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (125, NULL, 9914, 'São Felipe', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (125, NULL, 9915, 'Içana', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3161, NULL, 9916, 'Fartura', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5167, NULL, 9917, 'Ponte Vermelha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5167, NULL, 9918, 'Areado', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2959, NULL, 9919, 'Monte Celeste', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2961, NULL, 9920, 'Conceição das Laranjeiras', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3246, NULL, 9921, 'Sete Pontes', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3246, NULL, 9922, 'Neves', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3246, NULL, 9923, 'Monjolo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3246, NULL, 9924, 'Ipiiba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2962, NULL, 9925, 'Canoeiros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1051, NULL, 9926, 'Pecém', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1203, NULL, 9927, 'Pecém', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1051, NULL, 9928, 'Croatá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1203, NULL, 9929, 'Croatá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1051, NULL, 9930, 'Serrote', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1203, NULL, 9931, 'Serrote', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1051, NULL, 9932, 'Cágado', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1203, NULL, 9933, 'Cágado', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1051, NULL, 9934, 'Umarituba', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1203, NULL, 9935, 'Umarituba', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1051, NULL, 9936, 'Taiba', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1203, NULL, 9937, 'Taiba', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1051, NULL, 9938, 'Siupé', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1203, NULL, 9939, 'Siupé', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2966, NULL, 9940, 'Ribeiros', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2966, NULL, 9941, 'Ferreiras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2184, NULL, 9942, 'Sergi', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2184, NULL, 9943, 'Afligidos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2967, NULL, 9944, 'Funchal', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2967, NULL, 9945, 'Abaeté dos Venâncios', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2967, NULL, 9946, 'Guarda dos Ferreiros', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2967, NULL, 9947, 'São José da Bela Vista', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4988, NULL, 9948, 'Quitéria', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4988, NULL, 9949, 'Morrinhos', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4988, NULL, 9950, 'Gramal', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4252, NULL, 9951, 'São João do Pinhal', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4252, NULL, 9952, 'Vila Nova de Florença', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4252, NULL, 9953, 'Terra Nova', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4253, NULL, 9954, 'Dois Irmãos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1615, NULL, 9955, 'Dois Irmãos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4253, NULL, 9956, 'Vila Paraíso', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1615, NULL, 9957, 'Vila Paraíso', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4253, NULL, 9958, 'Ouro Verde', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1615, NULL, 9959, 'Ouro Verde', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4253, NULL, 9960, 'Nova Lourdes', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1615, NULL, 9961, 'Nova Lourdes', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (627, NULL, 9962, 'Tijipió', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4552, NULL, 9963, 'Tijipió', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5534, NULL, 9964, 'Forte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3247, NULL, 9965, 'Pipeiras', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3247, NULL, 9966, 'Grussaí', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3247, NULL, 9967, 'Cajueiro', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3247, NULL, 9968, 'Barcelos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3247, NULL, 9969, 'Atafona', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2969, NULL, 9970, 'São Roberto de Minas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2971, NULL, 9971, 'Olímpio Campos', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2971, NULL, 9972, 'Condado do Norte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2971, NULL, 9973, 'Santo Antônio da Boa Vista', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2971, NULL, 9974, 'Simão Campos', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3248, NULL, 9975, 'Coelho da Rocha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3248, NULL, 9976, 'São Mateus', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (273, NULL, 9977, 'Japerica', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2973, NULL, 9978, 'São Gonçalo do Amarante', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2973, NULL, 9979, 'Arcângelo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2973, NULL, 9980, 'Emboabas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2973, NULL, 9981, 'São Sebastião da Vitória', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2973, NULL, 9982, 'Rio das Mortes', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (274, NULL, 9983, 'Apinagés', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4255, NULL, 9984, 'Santa Luzia da Alvorada', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4255, NULL, 9985, 'Luar', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4255, NULL, 9986, 'Ubaúna', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2976, NULL, 9987, 'Santa Maria do Baixio', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2977, NULL, 9988, 'Santa da Pedra', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4990, NULL, 9989, 'Vale Vêneto', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4990, NULL, 9990, 'Recanto Maestro', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1423, NULL, 9991, 'Umari', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4555, NULL, 9992, 'Vila Santa Catarina', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4555, NULL, 9993, 'Vila Conceição', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1424, NULL, 9994, 'Santa Maria', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4256, NULL, 9995, 'Palmira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2979, NULL, 9996, 'São Geraldo do Baguari', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2979, NULL, 9997, 'Nelson de Sena', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2980, NULL, 9998, 'Taruaçu', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2980, NULL, 9999, 'Roça Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2980, NULL, 10000, 'Ituí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2980, NULL, 10001, 'Carlos Alves', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4556, NULL, 10002, 'São Sebastião do Arvoredo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4556, NULL, 10003, 'Santa Izabel', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4556, NULL, 10004, 'Pericó', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1616, NULL, 10005, 'Barra do Riachão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1616, NULL, 10006, 'Santana de São Joaquim', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4259, NULL, 10007, 'Doutor Antônio Paranhos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4259, NULL, 10008, 'Lagos do Iguaçu', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4259, NULL, 10009, 'Iolópolis', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4259, NULL, 10010, 'Sede Nova Sant''Ana', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4257, NULL, 10011, 'Copacabana do Norte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4557, NULL, 10012, 'Barreiros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4557, NULL, 10013, 'Centro Histórico de São José', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1428, NULL, 10014, 'Bom Jesus', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (632, NULL, 10015, 'Mata', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1618, NULL, 10016, 'Bom Nome', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3162, NULL, 10017, 'Airituba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3162, NULL, 10018, 'Divino Espírito Santo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3162, NULL, 10019, 'Alto Calçado', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1206, NULL, 10020, 'Ipiranga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4558, NULL, 10021, 'Padre Reus', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4558, NULL, 10022, 'Mariflor', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1619, NULL, 10023, 'Bonfim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1619, NULL, 10024, 'Riacho do Meio', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2186, NULL, 10025, 'Itatiaia do Alto Bonito', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4996, NULL, 10026, 'Bojuru', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4996, NULL, 10027, 'Estreito', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4997, NULL, 10028, 'Vila Souza', '32', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4997, NULL, 10029, 'Brugnarotto', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4997, NULL, 10030, 'Jardim Alegre', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4997, NULL, 10031, 'São Miguel', '19', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4997, NULL, 10032, 'Cerro Azul', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4997, NULL, 10033, 'Tanque', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4997, NULL, 10034, 'São Pedro do Iraxim', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4997, NULL, 10035, 'Marmeleiro', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5297, NULL, 10036, 'Nova Catanduva', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3824, NULL, 10037, 'Talhado', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3824, NULL, 10038, 'Engenheiro Schmidt', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5299, NULL, 10039, 'Santo Antônio do Fontoura', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4999, NULL, 10040, 'São Gonçalo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4999, NULL, 10041, 'Silveira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4999, NULL, 10042, 'Faxinal Preto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4999, NULL, 10043, 'Várzea', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3825, NULL, 10044, 'São Francisco Xavier', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3825, NULL, 10045, 'Eugênio de Melo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4262, NULL, 10046, 'Campo Largo da Roseira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4262, NULL, 10047, 'Borda do Campo de São Sebastião', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4262, NULL, 10048, 'Cachoeira de São José', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4262, NULL, 10049, 'Marcelino', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4262, NULL, 10050, 'Colônia Murici', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4262, NULL, 10051, 'São Marcos', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5300, NULL, 10052, 'Santa Fé', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1620, NULL, 10053, 'Nossa Senhora da Luz', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4560, NULL, 10054, 'Frederico Wastner', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4560, NULL, 10055, 'Presidente Juscelino', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4560, NULL, 10056, 'São Roque', '29', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5001, NULL, 10057, 'Taquaral', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5001, NULL, 10058, 'Esperança', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5001, NULL, 10059, 'Faxinal', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5001, NULL, 10060, 'Harmonia', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5001, NULL, 10061, 'Boqueirão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5001, NULL, 10062, 'Prado Novo', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5001, NULL, 10063, 'Boa Vista', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5535, NULL, 10064, 'Rosalândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3827, NULL, 10065, 'Catuçaba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5002, NULL, 10066, 'Afonso Rodrigues', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5002, NULL, 10067, 'Santa Inês', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5002, NULL, 10068, 'Capela São Paulo', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5002, NULL, 10069, 'São Lourenço das Missões', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5002, NULL, 10070, 'Rincão de São Pedro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5002, NULL, 10071, 'Rincão dos Pintos', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3828, NULL, 10072, 'Aparecida de São Manuel', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5003, NULL, 10073, 'Pedras Brancas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5004, NULL, 10074, 'Vargem do Cedro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4562, NULL, 10075, 'Vargem do Cedro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3163, NULL, 10076, 'Itauninhas', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3163, NULL, 10077, 'Nova Verona', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3163, NULL, 10078, 'Barra Nova', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3163, NULL, 10079, 'Nestor Gomes', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4264, NULL, 10080, 'Caitá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4264, NULL, 10081, 'Lajeado', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4264, NULL, 10082, 'Fluviópolis', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3829, NULL, 10083, 'Gramadão', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5006, NULL, 10084, 'São José', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5006, NULL, 10085, 'Campestre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5006, NULL, 10086, 'São João das Missões', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5006, NULL, 10087, 'Mato Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5006, NULL, 10088, 'Coimbra', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5006, NULL, 10089, 'Rincão dos Moraes', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (275, NULL, 10090, 'Urucuri', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (275, NULL, 10091, 'Caju', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (275, NULL, 10092, 'Urucuriteua', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (45, NULL, 10093, 'Santana do Guaporé', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4265, NULL, 10094, 'Aurora do Iguaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4265, NULL, 10095, 'São José do Iguaçu', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5007, NULL, 10096, 'Santo Isidro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10097, 'Brasilândia', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10098, 'São Domingos', '95', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10099, 'Vila Prudente', '93', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10100, 'Vila Leopoldina', '88', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10101, 'Rio Pequeno', '67', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10102, 'Capão Redondo', '19', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10103, 'Pari', '56', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10104, 'Marsilac', '52', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10105, 'Itaim Bibi', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10106, 'República', '66', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10107, 'Sé', '78', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10108, 'Cangaiba', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10109, 'Pirituba', '63', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10110, 'Guaianases', '31', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10111, 'Freguesia do Ó', '29', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10112, 'Consolação', '26', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10113, 'Lapa', '48', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10114, 'Carrão', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10115, 'Belém', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10116, 'Vila Sônia', '94', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10117, 'Vila Guilherme', '86', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10118, 'Tatuapé', '80', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10119, 'Perdizes', '60', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10120, 'Jabaquara', '38', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10121, 'Vila Mariana', '90', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10122, 'Vila Medeiros', '92', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10123, 'Jaraguá', '42', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10124, 'Jardim Paulista', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10125, 'Iguatemi', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10126, 'Cursino', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10127, 'Vila Matilde', '91', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10128, 'Vila Maria', '89', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10129, 'José Bonifácio', '47', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10130, 'São Miguel', '74', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10131, 'São Lucas', '72', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10132, 'Pinheiros', '62', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10133, 'Jardim Ângela', '43', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10134, 'Liberdade', '49', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10135, 'Ermelino Matarazzo', '28', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10136, 'Grajaú', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10137, 'Anhanguera', '03', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10138, 'Cambuci', '14', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10139, 'Butantã', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10140, 'Água Rasa', '01', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10141, 'Cidade Lider', '24', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10142, 'Campo Belo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10143, 'Brás', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10144, 'Bom Retiro', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10145, 'Cidade Dutra', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10146, 'Mandaqui', '51', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10147, 'Saúde', '77', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10148, 'Jaguaré', '41', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10149, 'Jardim Helena', '44', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10150, 'Sapopemba', '76', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10151, 'Tremembé', '81', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10152, 'Mooca', '53', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10153, 'Cidade Ademar', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10154, 'Artur Alvim', '05', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10155, 'Campo Grande', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10156, 'Cidade Tiradentes', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10157, 'Bela Vista', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10158, 'Itaim Paulista', '36', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10159, 'Moema', '32', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10160, 'Ipiranga', '34', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10161, 'Limão', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10162, 'Parelheiros', '55', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10163, 'Tucuruvi', '82', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10164, 'Santo Amaro', '71', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10165, 'Vila Jacuí', '87', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10166, 'Vila Formosa', '85', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10167, 'Itaquera', '37', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10168, 'Jaguara', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10169, 'Parque do Carmo', '57', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10170, 'Santana', '70', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10171, 'São Rafael', '75', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10172, 'Perus', '61', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10173, 'Santa Cecília', '69', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10174, 'Vila Andrade', '83', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10175, 'Barra Funda', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10176, 'Vila Curuçá', '84', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10177, 'Sacomã', '68', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10178, 'Alto de Pinheiros', '02', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10179, 'Aricanduva', '04', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10180, 'Raposo Tavares', '65', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10181, 'Lajeado', '96', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10182, 'Cachoeirinha', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10183, 'Jaçanã', '39', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10184, 'São Mateus', '73', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10185, 'Ponte Rasa', '64', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10186, 'Jardim São Luís', '46', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10187, 'Morumbi', '54', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10188, 'Pedreira', '58', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10189, 'Campo Limpo', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10190, 'Socorro', '79', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10191, 'Casa Verde', '21', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3830, NULL, 10192, 'Penha', '59', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5008, NULL, 10193, 'Pinheiro Machado', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (126, NULL, 10194, 'Santa Rita', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5011, NULL, 10195, 'Butiá Inferior', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4267, NULL, 10196, 'Mariza', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4268, NULL, 10197, 'Porto São José', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2994, NULL, 10198, 'Córrego Dantas do Suaçuí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5012, NULL, 10199, 'Guassupi', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5012, NULL, 10200, 'Xiniquá', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5012, NULL, 10201, 'Cerro Claro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2995, NULL, 10202, 'Águas Férreas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2996, NULL, 10203, 'Ribanceira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3833, NULL, 10204, 'Canguera', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3833, NULL, 10205, 'São João Novo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3833, NULL, 10206, 'Mailasqui', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2997, NULL, 10207, 'Serra da Canastra', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2997, NULL, 10208, 'São José do Barreiro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3164, NULL, 10209, 'São Jacinto', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3164, NULL, 10210, 'Santa Júlia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1742, NULL, 10211, 'São Francisco da Praia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3834, NULL, 10212, 'São Francisco da Praia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1742, NULL, 10213, 'Maresias', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3834, NULL, 10214, 'Maresias', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3252, NULL, 10215, 'Ipituna', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3252, NULL, 10216, 'Valão do Barro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3001, NULL, 10217, 'Santo Antônio dos Araújos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3001, NULL, 10218, 'Mãe dos Homens', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3003, NULL, 10219, 'Guardinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2188, NULL, 10220, 'Lamarão do Passé', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2188, NULL, 10221, 'Jacuípe', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2188, NULL, 10222, 'Maracangalha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5014, NULL, 10223, 'Tupanci', '28', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5014, NULL, 10224, 'Vila Block', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5014, NULL, 10225, 'Cerrito do Ouro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5014, NULL, 10226, 'Jazidas', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3836, NULL, 10227, 'Itaguaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5540, NULL, 10228, 'Itaguaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3007, NULL, 10229, 'Mercês de Água Limpa', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5016, NULL, 10230, 'Fazenda Fialho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5016, NULL, 10231, 'Santa Bárbara', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1439, NULL, 10232, 'Seridó', '05', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5019, NULL, 10233, 'Cavajuretã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5019, NULL, 10234, 'Loreto', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (642, NULL, 10235, 'Siriji', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1621, NULL, 10236, 'Siriji', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1440, NULL, 10237, 'Renascença', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2189, NULL, 10238, 'Baixa do Palmeira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5020, NULL, 10239, 'Picada São Jacob', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4271, NULL, 10240, 'Vida Nova', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4271, NULL, 10241, 'Lambari', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3253, NULL, 10242, 'Nossa Senhora da Aparecida', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (277, NULL, 10243, 'Nossa Senhora da Aparecida', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3253, NULL, 10244, 'Anta', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (277, NULL, 10245, 'Anta', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3253, NULL, 10246, 'Jamapará', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (277, NULL, 10247, 'Jamapará', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3253, NULL, 10248, 'Pião', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (277, NULL, 10249, 'Pião', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3254, NULL, 10250, 'Sampaio Correia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3254, NULL, 10251, 'Bacaxá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5022, NULL, 10252, 'Barreirinho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4272, NULL, 10253, 'Barreirinho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5022, NULL, 10254, 'Novo Sarandi', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4272, NULL, 10255, 'Novo Sarandi', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5022, NULL, 10256, 'Atiaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4272, NULL, 10257, 'Atiaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3838, NULL, 10258, 'Cocaes', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2191, NULL, 10259, 'Cabuçu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2191, NULL, 10260, 'Bom Jesus dos Pobres', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2193, NULL, 10261, 'Várzea do Caldas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2193, NULL, 10262, 'Baraúnas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4568, NULL, 10263, 'Nova Teutônia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4568, NULL, 10264, 'Caraíba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2194, NULL, 10265, 'Mandiroba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5023, NULL, 10266, 'Barrinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5023, NULL, 10267, 'Lajeado Bonito', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5024, NULL, 10268, 'Monte Belo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5025, NULL, 10269, 'Tamanduá', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5025, NULL, 10270, 'Bela Vista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5025, NULL, 10271, 'Serrinha Velha', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5026, NULL, 10272, 'Arroio Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5026, NULL, 10273, 'Floresta', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3014, NULL, 10274, 'Ponte Segura', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3015, NULL, 10275, 'Pregos', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1054, NULL, 10276, 'Bonfim', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1054, NULL, 10277, 'São Joaquim do Salgado', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1054, NULL, 10278, 'Codia', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1054, NULL, 10279, 'Engenheiro José Lopes', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1055, NULL, 10280, 'Serrota', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1055, NULL, 10281, 'Salão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5027, NULL, 10282, 'Vila Oito de Agosto', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5027, NULL, 10283, 'Esquina Ipiranga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5027, NULL, 10284, 'Giruazinho', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4274, NULL, 10285, 'Reianópolis', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4274, NULL, 10286, 'Ouro Verde', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2195, NULL, 10287, 'Carrapichel', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2195, NULL, 10288, 'Igara', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2195, NULL, 10289, 'Tijuaçu', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3020, NULL, 10290, 'São José do Jacaré', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3021, NULL, 10291, 'Palmital dos Carvalhos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2196, NULL, 10292, 'Piri', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2196, NULL, 10293, 'Cajuí', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2196, NULL, 10294, 'Piçarrão', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2196, NULL, 10295, 'Minas do Mimoso', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2196, NULL, 10296, 'Américo Alves', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2196, NULL, 10297, 'Amaniú', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5029, NULL, 10298, 'Silva Jardim', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3165, NULL, 10299, 'Calogi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3165, NULL, 10300, 'Nova Almeida', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3165, NULL, 10301, 'Queimado', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3165, NULL, 10302, 'Carapina', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1441, NULL, 10303, 'Sucuru', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1441, NULL, 10304, 'Santa Luzia do Cariri', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (307, NULL, 10305, 'Cachaço', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3026, NULL, 10306, 'Catiara', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1622, NULL, 10307, 'Tauapiranga', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1622, NULL, 10308, 'Santa Rita', '28', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1622, NULL, 10309, 'Luanda', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1622, NULL, 10310, 'Bernardo Vieira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1622, NULL, 10311, 'Pajeú', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1622, NULL, 10312, 'Varzinha', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1622, NULL, 10313, 'Caiçarinha da Penha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1622, NULL, 10314, 'Logradouro', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1623, NULL, 10315, 'Ori', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1623, NULL, 10316, 'Ipuera', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3031, NULL, 10317, 'São Gonçalo do Rio das Pedras', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3031, NULL, 10318, 'Milho Verde', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3031, NULL, 10319, 'Deputado Augusto Clementino', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3031, NULL, 10320, 'Três Barras da Estrada Real', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3031, NULL, 10321, 'Pedro Lessa', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4276, NULL, 10322, 'Paranagi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1624, NULL, 10323, 'Algodões', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1624, NULL, 10324, 'Albuquerque Né', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1624, NULL, 10325, 'Rio da Barra', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1624, NULL, 10326, 'Henrique Dias', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5031, NULL, 10327, 'Engenheiro Luiz Englert', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3844, NULL, 10328, 'Cruz das Posses', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1446, NULL, 10329, 'Cruz das Posses', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3032, NULL, 10330, 'Silva Xavier', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3033, NULL, 10331, 'Palmeiras do Vale', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5034, NULL, 10332, 'Mirim', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5170, NULL, 10333, 'Capão Seco', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5170, NULL, 10334, 'Quebra Côco', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3256, NULL, 10335, 'Aldeia Velha', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3256, NULL, 10336, 'Gaviões', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3256, NULL, 10337, 'Correntezas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3037, NULL, 10338, 'São Simão do Rio Preto', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3037, NULL, 10339, 'Alegria', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4278, NULL, 10340, 'Alemoa', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1625, NULL, 10341, 'Barra do Sirinhaém', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1625, NULL, 10342, 'Ibiratinga', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2203, NULL, 10343, 'Gameleira da Lapa', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1223, NULL, 10344, 'Serra da Tapuia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (647, NULL, 10345, 'Serra da Tapuia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1056, NULL, 10346, 'São José do Torto', '53', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1056, NULL, 10347, 'Patriarca', '50', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1056, NULL, 10348, 'Bonfim', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1056, NULL, 10349, 'Patos', '47', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1056, NULL, 10350, 'Rafael Arruda', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1056, NULL, 10351, 'Caracará', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1056, NULL, 10352, 'Aracatiaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1056, NULL, 10353, 'Taperuaba', '55', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1056, NULL, 10354, 'Caioca', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1056, NULL, 10355, 'Aprazível', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1056, NULL, 10356, 'Jordão', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1056, NULL, 10357, 'Jaibaras', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3038, NULL, 10358, 'Plautino Soares', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5038, NULL, 10359, 'Bom Sucesso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1449, NULL, 10360, 'Bom Sucesso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5038, NULL, 10361, 'Pinhal', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1449, NULL, 10362, 'Pinhal', '27', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5038, NULL, 10363, 'Bugre', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1449, NULL, 10364, 'Bugre', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5038, NULL, 10365, 'Santa Terezinha', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1449, NULL, 10366, 'Santa Terezinha', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1057, NULL, 10367, 'Cangati', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1057, NULL, 10368, 'Assunção', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1057, NULL, 10369, 'Pasta', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1057, NULL, 10370, 'São José de Solonópole', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1057, NULL, 10371, 'Prefeita Suely Pinheiro', '32', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4571, NULL, 10372, 'Nova Guarita', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4571, NULL, 10373, 'Boa Esperança', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5305, NULL, 10374, 'Primavera', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5305, NULL, 10375, 'Boa Esperança', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5305, NULL, 10376, 'Caravágio', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2206, NULL, 10377, 'Segrêdo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2206, NULL, 10378, 'Cisterna', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3850, NULL, 10379, 'Bandeirantes D''Oeste', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3851, NULL, 10380, 'Nova Veneza', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1452, NULL, 10381, 'Pio X', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3257, NULL, 10382, 'Soledade', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3257, NULL, 10383, 'Dona Mariana', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3257, NULL, 10384, 'Campinas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1627, NULL, 10385, 'Chéus', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3853, NULL, 10386, 'Palmeiras de São Paulo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3853, NULL, 10387, 'Boa Vista Paulista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (129, NULL, 10388, 'Curupá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3855, NULL, 10389, 'Curupá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2207, NULL, 10390, 'Mariquita', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1058, NULL, 10391, 'Peixe Gordo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1058, NULL, 10392, 'Olho-d''Água da Bica', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1629, NULL, 10393, 'Riacho Fechado', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1630, NULL, 10394, 'Caraibeiras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4573, NULL, 10395, 'Passo Manso', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1225, NULL, 10396, 'Gameleira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1631, NULL, 10397, 'Sauê', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1059, NULL, 10398, 'Boa Esperança', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1059, NULL, 10399, 'Sucesso', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1059, NULL, 10400, 'Oliveiras', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1059, NULL, 10401, 'Açudinho', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1059, NULL, 10402, 'Carvalho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1059, NULL, 10403, 'Curatis', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1059, NULL, 10404, 'Holanda', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3862, NULL, 10405, 'Ibiporanga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1226, NULL, 10406, 'Marari', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4574, NULL, 10407, 'Marari', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1226, NULL, 10408, 'Trairi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4574, NULL, 10409, 'Trairi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1226, NULL, 10410, 'Irakitan', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4574, NULL, 10411, 'Irakitan', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5307, NULL, 10412, 'São Joaquim', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5307, NULL, 10413, 'Progresso', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5307, NULL, 10414, 'São Jorge', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2208, NULL, 10415, 'Sussuarana', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4282, NULL, 10416, 'Bela Vista do Tapiracuí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5040, NULL, 10417, 'Bela Vista do Tapiracuí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4282, NULL, 10418, 'Vila Campos', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5040, NULL, 10419, 'Vila Campos', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5041, NULL, 10420, 'São Pedro', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5041, NULL, 10421, 'Vila Paz', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2211, NULL, 10422, 'Camurugi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1453, NULL, 10423, 'Camurugi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3044, NULL, 10424, 'Rio Turvo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3863, NULL, 10425, 'Rio Turvo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3044, NULL, 10426, 'Altolândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3863, NULL, 10427, 'Altolândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2212, NULL, 10428, 'Volta Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5308, NULL, 10429, 'Novo Eldorado', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5043, NULL, 10430, 'Pega Fogo', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5043, NULL, 10431, 'Padilha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5043, NULL, 10432, 'Santa Cruz da Concórdia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5043, NULL, 10433, 'Rio da Ilha', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5043, NULL, 10434, 'Entrepelado', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5043, NULL, 10435, 'Fazenda Fialho', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5044, NULL, 10436, 'Amoras', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3866, NULL, 10437, 'Guariroba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3866, NULL, 10438, 'Jurupema', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1632, NULL, 10439, 'Gravatá do Ibiapina', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1632, NULL, 10440, 'Pão de Açucar', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3046, NULL, 10441, 'São Vicente do Rio Doce', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3046, NULL, 10442, 'Taruaçu de Minas', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3046, NULL, 10443, 'Vai-Volta', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3046, NULL, 10444, 'Café-Mirim', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1061, NULL, 10445, 'Inhamuns', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1061, NULL, 10446, 'Marruás', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1061, NULL, 10447, 'Trici', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1061, NULL, 10448, 'Carrapateiras', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1061, NULL, 10449, 'Santa Tereza', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1061, NULL, 10450, 'Marrecas', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1061, NULL, 10451, 'Barra Nova', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3872, NULL, 10452, 'Quiririm', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1454, NULL, 10453, 'Butiás', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5046, NULL, 10454, 'Butiás', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1454, NULL, 10455, 'Tapera', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5046, NULL, 10456, 'Tapera', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1454, NULL, 10457, 'Capão Comprido', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5046, NULL, 10458, 'Capão Comprido', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2213, NULL, 10459, 'Cachoeira do Mato', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4284, NULL, 10460, 'Guaraúna', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1062, NULL, 10461, 'Caxitoré', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3873, NULL, 10462, 'Águas Virtuosas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3873, NULL, 10463, 'Ribeirão Bonito', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1227, NULL, 10464, 'Mata de São Braz', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5047, NULL, 10465, 'São Pedro', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5047, NULL, 10466, 'Daltro Filho', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5047, NULL, 10467, 'Braço Forte', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3874, NULL, 10468, 'Planalto do Sul', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2214, NULL, 10469, 'Planalto do Sul', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3874, NULL, 10470, 'Lustosa', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2214, NULL, 10471, 'Lustosa', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3874, NULL, 10472, 'Buracica', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2214, NULL, 10473, 'Buracica', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3048, NULL, 10474, 'Rio Pretinho', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3048, NULL, 10475, 'Pedro Versiani', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3048, NULL, 10476, 'Mucuri', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3048, NULL, 10477, 'Crispim Jacques', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3048, NULL, 10478, 'Topázio', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3259, NULL, 10479, 'Vale de Bonsucesso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3259, NULL, 10480, 'Vale do Paquequer', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5048, NULL, 10481, 'Sanga Funda', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1634, NULL, 10482, 'Jacu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2217, NULL, 10483, 'Jacu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1634, NULL, 10484, 'Rio Fundo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2217, NULL, 10485, 'Rio Fundo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5309, NULL, 10486, 'Miraguaí do Norte', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5309, NULL, 10487, 'Nona Agrovila', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5309, NULL, 10488, 'Nonoaí do Norte', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4287, NULL, 10489, 'Adhemar de Barros', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4288, NULL, 10490, 'Santa Rita d''Oeste', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3875, NULL, 10491, 'Santa Rita d''Oeste', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5310, NULL, 10492, 'Batovi', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5310, NULL, 10493, 'Cassununga', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5049, NULL, 10494, 'Pontes Filho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1063, NULL, 10495, 'Tabainha', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1063, NULL, 10496, 'Arapá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1063, NULL, 10497, 'Pindoguaba', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1063, NULL, 10498, 'Caruataí', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4289, NULL, 10499, 'Caetano Mendes', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4289, NULL, 10500, 'Alto do Amparo', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1635, NULL, 10501, 'Livramento do Tiúma', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1635, NULL, 10502, 'Cruanji', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (652, NULL, 10503, 'Buriti Cortado', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3049, NULL, 10504, 'Cachoeira do Vale', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3050, NULL, 10505, 'Caixa D''Água da Esperança', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3050, NULL, 10506, 'Elvas', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5051, NULL, 10507, 'Alto Uruguai', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5051, NULL, 10508, 'Porto Soberbo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5051, NULL, 10509, 'Lajeado Bonito', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5051, NULL, 10510, 'Novo Planalto', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3051, NULL, 10511, 'Canastrão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1823, NULL, 10512, 'Samambaia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4291, NULL, 10513, 'Vila Ipiranga', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3054, NULL, 10514, 'Vila Ipiranga', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4291, NULL, 10515, 'Concórdia do Oeste', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3054, NULL, 10516, 'Concórdia do Oeste', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4291, NULL, 10517, 'Vila Nova', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3054, NULL, 10518, 'Vila Nova', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4291, NULL, 10519, 'Novo Sobradinho', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3054, NULL, 10520, 'Novo Sobradinho', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4291, NULL, 10521, 'Dois Irmãos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3054, NULL, 10522, 'Dois Irmãos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4291, NULL, 10523, 'Novo Sarandi', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3054, NULL, 10524, 'Novo Sarandi', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4291, NULL, 10525, 'São Luiz do Oeste', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3054, NULL, 10526, 'São Luiz do Oeste', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4291, NULL, 10527, 'São Miguel', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3054, NULL, 10528, 'São Miguel', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4291, NULL, 10529, 'Dez de Maio', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3054, NULL, 10530, 'Dez de Maio', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4292, NULL, 10531, 'Sapé', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3055, NULL, 10532, 'Água Santa de Minas', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3055, NULL, 10533, 'Catuné', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5052, NULL, 10534, 'Linha Bonita', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5053, NULL, 10535, 'Glória', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1064, NULL, 10536, 'Gualdrapas', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1064, NULL, 10537, 'Córrego Fundo', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1064, NULL, 10538, 'Mundaú', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1064, NULL, 10539, 'Canaan', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1064, NULL, 10540, 'Fleicheiras', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5054, NULL, 10541, 'Nova Tramandaí', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5054, NULL, 10542, 'Estância Velha', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2218, NULL, 10543, 'Lagoa Preta', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5056, NULL, 10544, 'Coxilha Seca', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4580, NULL, 10545, 'São Cristóvão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5057, NULL, 10546, 'Vila Fernando Ferrari', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5057, NULL, 10547, 'Morro Azul', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5057, NULL, 10548, 'Rio do Terra', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5059, NULL, 10549, 'Barrinha', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5059, NULL, 10550, 'Progresso', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5059, NULL, 10551, 'Consolata', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5059, NULL, 10552, 'Quaraim', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5059, NULL, 10553, 'Manchinha', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5175, NULL, 10554, 'Garcias', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5175, NULL, 10555, 'Arapuá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5175, NULL, 10556, 'Ilha Comprida', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5175, NULL, 10557, 'Guadalupe do Alto Paraná', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3057, NULL, 10558, 'Andrequicé', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5061, NULL, 10559, 'Progresso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5062, NULL, 10560, 'Alto Erval Novo', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5062, NULL, 10561, 'Santo Antônio', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5062, NULL, 10562, 'Floresta', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5062, NULL, 10563, 'Padre Gonzales', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5062, NULL, 10564, 'Bela Vista', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3058, NULL, 10565, 'Pontalete', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3261, NULL, 10566, 'Bemposta', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4582, NULL, 10567, 'São Gabriel', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5064, NULL, 10568, 'Canaã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1457, NULL, 10569, 'Canaã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1639, NULL, 10570, 'Canaã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5064, NULL, 10571, 'Costa da Cadeia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1457, NULL, 10572, 'Costa da Cadeia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1639, NULL, 10573, 'Costa da Cadeia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5064, NULL, 10574, 'Porto Batista', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1457, NULL, 10575, 'Porto Batista', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1639, NULL, 10576, 'Porto Batista', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5064, NULL, 10577, 'Iraguaçu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1457, NULL, 10578, 'Iraguaçu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1639, NULL, 10579, 'Iraguaçu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5064, NULL, 10580, 'Passo Raso', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1457, NULL, 10581, 'Passo Raso', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1639, NULL, 10582, 'Passo Raso', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3059, NULL, 10583, 'São Geraldo de Tumiritinga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5066, NULL, 10584, 'Cerro Preto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5066, NULL, 10585, 'Nossa Senhora Aparecida', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5066, NULL, 10586, 'Pedregal', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5066, NULL, 10587, 'Rincão Comprido', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5066, NULL, 10588, 'Despraiado', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4295, NULL, 10589, 'Marabá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4295, NULL, 10590, 'Aparecida D''Oeste', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (655, NULL, 10591, 'São Joaquim dos Melos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3884, NULL, 10592, 'Varpa', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3884, NULL, 10593, 'Universo', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3884, NULL, 10594, 'Parnaso', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5068, NULL, 10595, 'Espinilho Grande', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5070, NULL, 10596, 'Cerro Alto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5070, NULL, 10597, 'Cinquentenário', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1641, NULL, 10598, 'Santa Rita', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3885, NULL, 10599, 'Oásis', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3887, NULL, 10600, 'Fátima Paulista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3061, NULL, 10601, 'Fátima Paulista', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3887, NULL, 10602, 'Caçaratiba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3061, NULL, 10603, 'Caçaratiba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1065, NULL, 10604, 'São Pedro do Gavião', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1065, NULL, 10605, 'Cemoaba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1065, NULL, 10606, 'Conceição', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4587, NULL, 10607, 'Morro Chato', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4297, NULL, 10608, 'Morro Chato', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (658, NULL, 10609, 'Barro Duro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2220, NULL, 10610, 'Serra da Canabrava', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2220, NULL, 10611, 'Caldeirão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3063, NULL, 10612, 'Diamante de Ubá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3063, NULL, 10613, 'Miragaia', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3063, NULL, 10614, 'Ubari', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3064, NULL, 10615, 'Bentópolis de Minas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2221, NULL, 10616, 'Engenheiro Franca', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2221, NULL, 10617, 'Baixinha', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2222, NULL, 10618, 'Faisqueira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2222, NULL, 10619, 'Piraúna', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1066, NULL, 10620, 'Jaburuna', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1066, NULL, 10621, 'Nova Veneza', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1066, NULL, 10622, 'Araticum', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3065, NULL, 10623, 'São Sebastião do Batatal', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3065, NULL, 10624, 'São José do Batatal', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3889, NULL, 10625, 'Picinguaba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3067, NULL, 10626, 'Martinésia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3067, NULL, 10627, 'Miraporanga', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3067, NULL, 10628, 'Tapuirama', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3067, NULL, 10629, 'Cruzeiro dos Peixotos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3890, NULL, 10630, 'Areia Branca', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4298, NULL, 10631, 'Yolanda', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2224, NULL, 10632, 'Hidrolândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1067, NULL, 10633, 'Pio X', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2225, NULL, 10634, 'Delfino', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1459, NULL, 10635, 'Mata Virgem', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1068, NULL, 10636, 'São Joaquim', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1068, NULL, 10637, 'Caxitoré', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4299, NULL, 10638, 'Lovat', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4299, NULL, 10639, 'Santa Eliza', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4299, NULL, 10640, 'Roberto Silveira', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4299, NULL, 10641, 'Serra dos Dourados', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2226, NULL, 10642, 'Vila Brasil', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2226, NULL, 10643, 'Colônia', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2226, NULL, 10644, 'Pedras de Una', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2226, NULL, 10645, 'Comandatuba', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3069, NULL, 10646, 'Ruralminas', '19', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3069, NULL, 10647, 'Pedras de Marilândia', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3069, NULL, 10648, 'Garapuava', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3069, NULL, 10649, 'Santo Antônio do Boqueirão', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3069, NULL, 10650, 'Palmeirinha', '18', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5073, NULL, 10651, 'Oeste', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5073, NULL, 10652, 'Pulador', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4300, NULL, 10653, 'São Domingos', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4300, NULL, 10654, 'São Cristóvão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1749, NULL, 10655, 'Rocha Cavalcante', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4302, NULL, 10656, 'Cruzeiro do Norte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5555, NULL, 10657, 'Geriaçu', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5555, NULL, 10658, 'Pau Terra', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5556, NULL, 10659, 'Uruceres', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5556, NULL, 10660, 'Uruíta', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3071, NULL, 10661, 'Cercado', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (289, NULL, 10662, 'Alvorada', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4589, NULL, 10663, 'Águas Brancas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4589, NULL, 10664, 'Santa Teresinha', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1069, NULL, 10665, 'Santa Luzia', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1069, NULL, 10666, 'Itacolomy', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1069, NULL, 10667, 'Retiro', '13', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1069, NULL, 10668, 'Mundaú', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3072, NULL, 10669, 'Bom Jesus de Cardosos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2228, NULL, 10670, 'Serra Grande', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (135, NULL, 10671, 'Augusto Montenegro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5075, NULL, 10672, 'Vertentes', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5075, NULL, 10673, 'Plano Alto', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5075, NULL, 10674, 'João Arregui', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5075, NULL, 10675, 'São Marcos', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1070, NULL, 10676, 'Campánario', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1070, NULL, 10677, 'Paracuá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3895, NULL, 10678, 'São João de Itaguaçu', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2229, NULL, 10679, 'Riachão do Utinga', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5076, NULL, 10680, 'Coxilha Grande', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5076, NULL, 10681, 'Bela Vista', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5076, NULL, 10682, 'Estrela', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5076, NULL, 10683, 'Refugiado', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5076, NULL, 10684, 'Capão da Herança', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5078, NULL, 10685, 'Morro Gaúcho', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5078, NULL, 10686, 'Canto Krewer', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5078, NULL, 10687, 'Forqueta Baixa', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5078, NULL, 10688, 'Arroio do Ouro', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2230, NULL, 10689, 'Guerém', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3262, NULL, 10690, 'Guerém', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2230, NULL, 10691, 'Serra Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3262, NULL, 10692, 'Serra Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2230, NULL, 10693, 'Parapeúna', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3262, NULL, 10694, 'Parapeúna', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2230, NULL, 10695, 'Maricoabo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3262, NULL, 10696, 'Maricoabo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2230, NULL, 10697, 'Pentagna', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3262, NULL, 10698, 'Pentagna', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2230, NULL, 10699, 'Conservatória', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3262, NULL, 10700, 'Conservatória', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2230, NULL, 10701, 'Guaibim', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3262, NULL, 10702, 'Guaibim', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2230, NULL, 10703, 'Santa Isabel do Rio Preto', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3262, NULL, 10704, 'Santa Isabel do Rio Preto', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2230, NULL, 10705, 'Barão de Juparanã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3262, NULL, 10706, 'Barão de Juparanã', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3167, NULL, 10707, 'Prosperidade', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3167, NULL, 10708, 'Alto Castelinho', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3167, NULL, 10709, 'Jaciguá', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3167, NULL, 10710, 'São José de Fruteiras', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1071, NULL, 10711, 'Croata', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1072, NULL, 10712, 'Canindezinho', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1072, NULL, 10713, 'Calabaça', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1072, NULL, 10714, 'Ibicatu', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1072, NULL, 10715, 'Naraniú', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1072, NULL, 10716, 'Riacho Verde', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3079, NULL, 10717, 'Guaicuí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (886, NULL, 10718, 'Capão Grande', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5314, NULL, 10719, 'Capão Grande', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (886, NULL, 10720, 'Bom Sucesso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5314, NULL, 10721, 'Bom Sucesso', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (886, NULL, 10722, 'Porto Velho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5314, NULL, 10723, 'Porto Velho', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (886, NULL, 10724, 'Passagem da Conceição', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5314, NULL, 10725, 'Passagem da Conceição', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2235, NULL, 10726, 'Taboleiro do Castro', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3080, NULL, 10727, 'Brejo do Mutambal', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3080, NULL, 10728, 'Campo Redondo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3264, NULL, 10729, 'Sebastião de Lacerda', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3264, NULL, 10730, 'São Sebastião dos Ferreiros', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3264, NULL, 10731, 'Andrade Pinto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3081, NULL, 10732, 'Claro de Minas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5081, NULL, 10733, 'Deodoro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5081, NULL, 10734, 'Palanque', '22', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5081, NULL, 10735, 'Mariante', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5081, NULL, 10736, 'Centro Linha Brasil', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5081, NULL, 10737, 'Santa Emília', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5081, NULL, 10738, 'Vale do Sampaio', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5081, NULL, 10739, 'Estância Nova', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5081, NULL, 10740, 'Arlindo', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3168, NULL, 10741, 'Alto Caxixe', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3168, NULL, 10742, 'São João de Viçosa', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4303, NULL, 10743, 'Novo Barro Preto', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1642, NULL, 10744, 'Grotão', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2236, NULL, 10745, 'Mar Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3903, NULL, 10746, 'Mar Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5082, NULL, 10747, 'Mar Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1238, NULL, 10748, 'Mar Grande', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2236, NULL, 10749, 'Jiribatuba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3903, NULL, 10750, 'Jiribatuba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5082, NULL, 10751, 'Jiribatuba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1238, NULL, 10752, 'Jiribatuba', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2236, NULL, 10753, 'Cacha Pregos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3903, NULL, 10754, 'Cacha Pregos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5082, NULL, 10755, 'Cacha Pregos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1238, NULL, 10756, 'Cacha Pregos', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4305, NULL, 10757, 'Presidente Kennedy', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4305, NULL, 10758, 'Sede Progresso', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3083, NULL, 10759, 'Mendonça', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5086, NULL, 10760, 'Viamópolis', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5086, NULL, 10761, 'Passo do Sabão', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5086, NULL, 10762, 'Capão da Porteira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5086, NULL, 10763, 'Passo da Areia', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5086, NULL, 10764, 'Águas Claras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5086, NULL, 10765, 'Itapuã', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5086, NULL, 10766, 'Espigão', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3169, NULL, 10767, 'Araçatiba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (661, NULL, 10768, 'Araçatiba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5560, NULL, 10769, 'Caraíba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1646, NULL, 10770, 'Murupé', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5087, NULL, 10771, 'Laranjeira', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5176, NULL, 10772, 'São José', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5176, NULL, 10773, 'Vila Rica', '45', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3087, NULL, 10774, 'Silvestre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1239, NULL, 10775, 'Silvestre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1750, NULL, 10776, 'Silvestre', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3087, NULL, 10777, 'Cachoeira de Santa Cruz', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1239, NULL, 10778, 'Cachoeira de Santa Cruz', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1750, NULL, 10779, 'Cachoeira de Santa Cruz', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3087, NULL, 10780, 'Anel', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1239, NULL, 10781, 'Anel', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1750, NULL, 10782, 'Anel', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3087, NULL, 10783, 'São José do Triunfo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1239, NULL, 10784, 'São José do Triunfo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1750, NULL, 10785, 'São José do Triunfo', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1073, NULL, 10786, 'Passagem da Onça', '23', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1073, NULL, 10787, 'Quatiguaba', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1073, NULL, 10788, 'Manhoso', '17', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1073, NULL, 10789, 'General Tibúrcio', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1073, NULL, 10790, 'Lambedouro', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1073, NULL, 10791, 'Juá dos Vieiras', '12', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1073, NULL, 10792, 'Padre Vieira', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5088, NULL, 10793, 'Faxinal', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5088, NULL, 10794, 'São José da Glória', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4596, NULL, 10795, 'Anta Gorda', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4596, NULL, 10796, 'Lourdes', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3088, NULL, 10797, 'Santo Antônio do Glória', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (290, NULL, 10798, 'Porto Salvo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5316, NULL, 10799, 'Aguapeí', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3171, NULL, 10800, 'São Jorge da Barra Seca', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3171, NULL, 10801, 'Jurama', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3172, NULL, 10802, 'Ibes', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3172, NULL, 10803, 'São Torquato', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3172, NULL, 10804, 'Argolas', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3172, NULL, 10805, 'Jucu', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3089, NULL, 10806, 'São João do Vacaria', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3092, NULL, 10807, 'Divino de Virgolândia', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (291, NULL, 10808, 'São José do Piriá', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (291, NULL, 10809, 'Fernandes Belo', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (291, NULL, 10810, 'São José do Gurupi', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5095, NULL, 10811, 'Bom Plano', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4597, NULL, 10812, 'Barra da Prata', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3173, NULL, 10813, 'Goiabeiras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2238, NULL, 10814, 'São João da Vitória', '33', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2238, NULL, 10815, 'São Sebastião', '35', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2238, NULL, 10816, 'Inhobim', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2238, NULL, 10817, 'Bate-Pé', '06', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2238, NULL, 10818, 'Iguá', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2238, NULL, 10819, 'Cabeceira da Jiboia', '07', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2238, NULL, 10820, 'Veredinha', '40', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2238, NULL, 10821, 'José Gonçalves', '20', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2238, NULL, 10822, 'Cercadinho', '08', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2238, NULL, 10823, 'Dantilândia', '09', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2238, NULL, 10824, 'Pradoso', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5096, NULL, 10825, 'São João Batista', '30', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (1647, NULL, 10826, 'Pirituba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3094, NULL, 10827, 'Trimonte', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3909, NULL, 10828, 'Simonsen', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4308, NULL, 10829, 'Itererê', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (3095, NULL, 10830, 'Itererê', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5098, NULL, 10831, 'Guará', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (5098, NULL, 10832, 'Rainha do Mar', '25', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4599, NULL, 10833, 'Cambuinzal', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4600, NULL, 10834, 'Linha das Palmeiras', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4601, NULL, 10835, 'Anita Garibaldi', '11', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (4601, NULL, 10836, 'Diadema', '16', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2242, NULL, 10837, 'Copixaba', '10', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);
INSERT INTO public.distrito VALUES (2242, NULL, 10838, 'Iguira', '15', NULL, NULL, 'M', 1, '2018-11-19 15:00:23.161841', 'I', NULL, 9);


--
-- TOC entry 7619 (class 0 OID 9443434)
-- Dependencies: 323
-- Data for Name: logradouro; Type: TABLE DATA; Schema: public; Owner: -
--



--
-- TOC entry 8100 (class 0 OID 9445650)
-- Dependencies: 813
-- Data for Name: logradouro_fonetico; Type: TABLE DATA; Schema: public; Owner: -
--



--
-- TOC entry 7620 (class 0 OID 9443444)
-- Dependencies: 324
-- Data for Name: municipio; Type: TABLE DATA; Schema: public; Owner: -
--

INSERT INTO public.municipio VALUES (1514, 'Condado', 'PE', NULL, NULL, NULL, 2604601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.365661', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (351, 'Couto de Magalhaes', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.089684', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (436, 'Sao Valerio da Natividade', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.187014', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (591, 'Pindare Mirim', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.359225', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (679, 'Aroeira do Itaim', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.453076', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (802, 'Nazária', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.584181', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1291, 'Campo de Santana', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.13001', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1415, 'Santarem', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.264592', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1419, 'Sao Domingos de Pombal', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.26811', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1481, 'Belem de Sao Francisco', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.335218', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1546, 'Itamaraca', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.404483', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1561, 'Lagoa do Itaenga', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.424018', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1965, 'Governador Lomanto Junior', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.849918', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2337, 'Brasopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.258428', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2800, 'Passa Vinte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.763219', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2834, 'Pingo D Agua', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.80073', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3013, 'Sem Peixe', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.996865', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3053, 'Tocos do Mogi', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.038237', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3226, 'Parati', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.221078', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3260, 'Trajano de Morais', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.258533', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3434, 'Embu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.451765', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3613, 'Mogi Mirim', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.656906', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3944, 'Bela Vista do Caroba', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.022147', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4037, 'Goio-ere', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.129581', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5111, 'Bataipora', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.298595', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5215, 'Cuverlandia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.415073', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5278, 'Poxoreo', 'MT', NULL, NULL, NULL, 5107008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.486341', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (43, 'Sao Felipe D Oeste', 'RO', NULL, NULL, NULL, 1101484, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.747041', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (197, 'Eldorado dos Carajas', 'PA', NULL, NULL, NULL, 1502954, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.917067', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (258, 'Santa Isabel do Para', 'PA', NULL, NULL, NULL, 150650, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.990198', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (684, 'Barra D Alcantara', 'PI', NULL, NULL, NULL, 2201176, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.457797', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (809, 'Olho D Agua do Piaui', 'PI', NULL, NULL, NULL, 2207108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.590304', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (976, 'Itapage', 'CE', NULL, NULL, NULL, 230630, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.777235', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1184, 'Presidente Juscelino', 'RN', NULL, NULL, NULL, 241030, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.010971', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1539, 'Iguaraci', 'PE', NULL, NULL, NULL, 2606903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.397826', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2773, 'Olhos-d Agua', 'MG', NULL, NULL, NULL, 3145455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.728505', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1, 'Alta Floresta D''oeste', 'RO', NULL, NULL, NULL, 1100015, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.699228', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5, 'Ariquemes', 'RO', NULL, NULL, NULL, 1100023, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.703562', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (7, 'Cabixi', 'RO', NULL, NULL, NULL, 1100031, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.7053', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (9, 'Cacoal', 'RO', NULL, NULL, NULL, 1100049, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.707047', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (13, 'Cerejeiras', 'RO', NULL, NULL, NULL, 1100056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.711055', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (15, 'Colorado do Oeste', 'RO', NULL, NULL, NULL, 1100064, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.712932', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (16, 'Corumbiara', 'RO', NULL, NULL, NULL, 1100072, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.713842', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (17, 'Costa Marques', 'RO', NULL, NULL, NULL, 1100080, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.714738', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (19, 'Espigao D''oeste', 'RO', NULL, NULL, NULL, 1100098, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.716704', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (21, 'Guajara-mirim', 'RO', NULL, NULL, NULL, 1100106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.718803', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (23, 'Jaru', 'RO', NULL, NULL, NULL, 1100114, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.720746', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (24, 'Ji-parana', 'RO', NULL, NULL, NULL, 1100122, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.721775', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (25, 'Machadinho D''oeste', 'RO', NULL, NULL, NULL, 1100130, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.722776', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (29, 'Nova Brasilandia D''oeste', 'RO', NULL, NULL, NULL, 1100148, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.73323', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (33, 'Ouro Preto do Oeste', 'RO', NULL, NULL, NULL, 1100155, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.737108', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (35, 'Pimenta Bueno', 'RO', NULL, NULL, NULL, 1100189, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.73925', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (37, 'Porto Velho', 'RO', NULL, NULL, NULL, 1100205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.741221', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (38, 'Presidente Medici', 'RO', NULL, NULL, NULL, 1100254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.742117', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (40, 'Rio Crespo', 'RO', NULL, NULL, NULL, 1100262, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.744066', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (41, 'Rolim de Moura', 'RO', NULL, NULL, NULL, 1100288, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.745017', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (42, 'Santa Luzia D''oeste', 'RO', NULL, NULL, NULL, 1100296, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.745909', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (52, 'Vilhena', 'RO', NULL, NULL, NULL, 1100304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.754961', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (45, 'Sao Miguel do Guapore', 'RO', NULL, NULL, NULL, 1100320, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.748533', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (30, 'Nova Mamore', 'RO', NULL, NULL, NULL, 1100338, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.734184', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4, 'Alvorada D''oeste', 'RO', NULL, NULL, NULL, 1100346, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.70262', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2, 'Alto Alegre dos Parecis', 'RO', NULL, NULL, NULL, 1100379, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.700901', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3, 'Alto Paraiso', 'RO', NULL, NULL, NULL, 1100403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.701715', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (6, 'Buritis', 'RO', NULL, NULL, NULL, 1100452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.704461', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (32, 'Novo Horizonte do Oeste', 'RO', NULL, NULL, NULL, 1100502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.73613', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (8, 'Cacaulandia', 'RO', NULL, NULL, NULL, 1100601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.706175', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (10, 'Campo Novo de Rondonia', 'RO', NULL, NULL, NULL, 1100700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.70796', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (11, 'Candeias do Jamari', 'RO', NULL, NULL, NULL, 1100809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.708884', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (12, 'Castanheiras', 'RO', NULL, NULL, NULL, 1100908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.709859', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (14, 'Chupinguaia', 'RO', NULL, NULL, NULL, 1100924, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.711993', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (18, 'Cujubim', 'RO', NULL, NULL, NULL, 1100940, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.715723', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (20, 'Governador Jorge Teixeira', 'RO', NULL, NULL, NULL, 1101005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.717717', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (22, 'Itapua do Oeste', 'RO', NULL, NULL, NULL, 1101104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.719743', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (26, 'Ministro Andreazza', 'RO', NULL, NULL, NULL, 1101203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.723813', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (27, 'Mirante da Serra', 'RO', NULL, NULL, NULL, 1101302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.725075', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (28, 'Monte Negro', 'RO', NULL, NULL, NULL, 1101401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.731957', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (31, 'Nova Uniao', 'RO', NULL, NULL, NULL, 1101435, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.735123', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (34, 'Parecis', 'RO', NULL, NULL, NULL, 1101450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.738213', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (36, 'Pimenteiras do Oeste', 'RO', NULL, NULL, NULL, 1101468, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.740233', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (39, 'Primavera de Rondonia', 'RO', NULL, NULL, NULL, 1101476, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.743068', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (44, 'Sao Francisco do Guapore', 'RO', NULL, NULL, NULL, 1101492, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.747752', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (46, 'Seringueiras', 'RO', NULL, NULL, NULL, 1101500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.749422', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (47, 'Teixeiropolis', 'RO', NULL, NULL, NULL, 1101559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.750356', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (48, 'Theobroma', 'RO', NULL, NULL, NULL, 1101609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.751289', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (49, 'Urupa', 'RO', NULL, NULL, NULL, 1101708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.752266', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (50, 'Vale do Anari', 'RO', NULL, NULL, NULL, 1101757, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.753153', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (51, 'Vale do Paraiso', 'RO', NULL, NULL, NULL, 1101807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.754014', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (53, 'Acrelandia', 'AC', NULL, NULL, NULL, 1200013, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.756206', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (54, 'Assis Brasil', 'AC', NULL, NULL, NULL, 1200054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.757065', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (55, 'Brasileia', 'AC', NULL, NULL, NULL, 1200104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.757891', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (56, 'Bujari', 'AC', NULL, NULL, NULL, 1200138, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.758909', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (57, 'Capixaba', 'AC', NULL, NULL, NULL, 1200179, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.759844', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (58, 'Cruzeiro do Sul', 'AC', NULL, NULL, NULL, 1200203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.760768', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (59, 'Epitaciolandia', 'AC', NULL, NULL, NULL, 1200252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.761618', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (60, 'Feijo', 'AC', NULL, NULL, NULL, 1200302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.762592', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (61, 'Jordao', 'AC', NULL, NULL, NULL, 1200328, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.763501', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (62, 'Mancio Lima', 'AC', NULL, NULL, NULL, 1200336, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.764379', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (63, 'Manoel Urbano', 'AC', NULL, NULL, NULL, 1200344, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.765356', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (64, 'Marechal Thaumaturgo', 'AC', NULL, NULL, NULL, 1200351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.772448', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (65, 'Placido de Castro', 'AC', NULL, NULL, NULL, 1200385, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.77356', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (67, 'Porto Walter', 'AC', NULL, NULL, NULL, 1200393, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.775372', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (68, 'Rio Branco', 'AC', NULL, NULL, NULL, 1200401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.776144', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (69, 'Rodrigues Alves', 'AC', NULL, NULL, NULL, 1200427, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.777086', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (70, 'Santa Rosa do Purus', 'AC', NULL, NULL, NULL, 1200435, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.778157', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (72, 'Senador Guiomard', 'AC', NULL, NULL, NULL, 1200450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.780338', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (71, 'Sena Madureira', 'AC', NULL, NULL, NULL, 1200500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.779501', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (73, 'Tarauaca', 'AC', NULL, NULL, NULL, 1200609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.781279', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (74, 'Xapuri', 'AC', NULL, NULL, NULL, 1200708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.782326', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (66, 'Porto Acre', 'AC', NULL, NULL, NULL, 1200807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.774455', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (75, 'Alvaraes', 'AM', NULL, NULL, NULL, 1300029, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.783307', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (76, 'Amatura', 'AM', NULL, NULL, NULL, 1300060, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.78444', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (77, 'Anama', 'AM', NULL, NULL, NULL, 1300086, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.785298', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (78, 'Anori', 'AM', NULL, NULL, NULL, 1300102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.7862', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (79, 'Apui', 'AM', NULL, NULL, NULL, 1300144, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.787062', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (80, 'Atalaia do Norte', 'AM', NULL, NULL, NULL, 1300201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.787924', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (81, 'Autazes', 'AM', NULL, NULL, NULL, 1300300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.788882', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (82, 'Barcelos', 'AM', NULL, NULL, NULL, 1300409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.789694', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (83, 'Barreirinha', 'AM', NULL, NULL, NULL, 1300508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.790558', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (84, 'Benjamin Constant', 'AM', NULL, NULL, NULL, 1300607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.791396', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (85, 'Beruri', 'AM', NULL, NULL, NULL, 1300631, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.792246', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (86, 'Boa Vista do Ramos', 'AM', NULL, NULL, NULL, 1300680, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.793161', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (87, 'Boca do Acre', 'AM', NULL, NULL, NULL, 1300706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.794181', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (88, 'Borba', 'AM', NULL, NULL, NULL, 1300805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.795002', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (89, 'Caapiranga', 'AM', NULL, NULL, NULL, 1300839, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.795793', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (90, 'Canutama', 'AM', NULL, NULL, NULL, 1300904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.796734', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (91, 'Carauari', 'AM', NULL, NULL, NULL, 1301001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.797699', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (92, 'Careiro', 'AM', NULL, NULL, NULL, 1301100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.798687', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (93, 'Careiro da Varzea', 'AM', NULL, NULL, NULL, 1301159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.799621', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (94, 'Coari', 'AM', NULL, NULL, NULL, 1301209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.800826', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (95, 'Codajas', 'AM', NULL, NULL, NULL, 1301308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.801802', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (96, 'Eirunepe', 'AM', NULL, NULL, NULL, 1301407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.802748', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (97, 'Envira', 'AM', NULL, NULL, NULL, 1301506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.803632', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (98, 'Fonte Boa', 'AM', NULL, NULL, NULL, 1301605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.804528', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (99, 'Guajara', 'AM', NULL, NULL, NULL, 1301654, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.805459', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (100, 'Humaita', 'AM', NULL, NULL, NULL, 1301704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.806293', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (101, 'Ipixuna', 'AM', NULL, NULL, NULL, 1301803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.813076', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (102, 'Iranduba', 'AM', NULL, NULL, NULL, 1301852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.814239', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (103, 'Itamarati', 'AM', NULL, NULL, NULL, 1301951, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.815178', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (104, 'Itapiranga', 'AM', NULL, NULL, NULL, 1302009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.816065', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (105, 'Japura', 'AM', NULL, NULL, NULL, 1302108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.81715', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (106, 'Jurua', 'AM', NULL, NULL, NULL, 1302207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.818091', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (107, 'Jutai', 'AM', NULL, NULL, NULL, 1302306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.819038', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (108, 'Labrea', 'AM', NULL, NULL, NULL, 1302405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.820032', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (109, 'Manacapuru', 'AM', NULL, NULL, NULL, 1302504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.820907', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (110, 'Manaquiri', 'AM', NULL, NULL, NULL, 1302553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.821753', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (111, 'Manaus', 'AM', NULL, NULL, NULL, 1302603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.822972', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (112, 'Manicore', 'AM', NULL, NULL, NULL, 1302702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.823952', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (113, 'Maraa', 'AM', NULL, NULL, NULL, 1302801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.824889', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (114, 'Maues', 'AM', NULL, NULL, NULL, 1302900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.825835', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (115, 'Nhamunda', 'AM', NULL, NULL, NULL, 1303007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.826766', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (116, 'Nova Olinda do Norte', 'AM', NULL, NULL, NULL, 1303106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.827685', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (117, 'Novo Airao', 'AM', NULL, NULL, NULL, 1303205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.828719', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (118, 'Novo Aripuana', 'AM', NULL, NULL, NULL, 1303304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.829683', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (119, 'Parintins', 'AM', NULL, NULL, NULL, 1303403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.830562', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (120, 'Pauini', 'AM', NULL, NULL, NULL, 1303502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.83138', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (121, 'Presidente Figueiredo', 'AM', NULL, NULL, NULL, 1303536, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.832207', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (122, 'Rio Preto da Eva', 'AM', NULL, NULL, NULL, 1303569, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.833161', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (123, 'Santa Isabel do Rio Negro', 'AM', NULL, NULL, NULL, 1303601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.834228', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (124, 'Santo Antonio do Ica', 'AM', NULL, NULL, NULL, 1303700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.835121', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (125, 'Sao Gabriel da Cachoeira', 'AM', NULL, NULL, NULL, 1303809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.836046', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (126, 'Sao Paulo de Olivenca', 'AM', NULL, NULL, NULL, 1303908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.836988', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (127, 'Sao Sebastiao do Uatuma', 'AM', NULL, NULL, NULL, 1303957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.837813', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (128, 'Silves', 'AM', NULL, NULL, NULL, 1304005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.838766', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (129, 'Tabatinga', 'AM', NULL, NULL, NULL, 1304062, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.839732', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (130, 'Tapaua', 'AM', NULL, NULL, NULL, 1304104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.840639', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (131, 'Tefe', 'AM', NULL, NULL, NULL, 1304203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.841614', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (132, 'Tonantins', 'AM', NULL, NULL, NULL, 1304237, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.842553', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (133, 'Uarini', 'AM', NULL, NULL, NULL, 1304260, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.843379', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (134, 'Urucara', 'AM', NULL, NULL, NULL, 1304302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.844178', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (135, 'Urucurituba', 'AM', NULL, NULL, NULL, 1304401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.845408', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (137, 'Amajari', 'RR', NULL, NULL, NULL, 1400027, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.853924', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (136, 'Alto Alegre', 'RR', NULL, NULL, NULL, 1400050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.846512', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (138, 'Boa Vista', 'RR', NULL, NULL, NULL, 1400100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.855192', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (139, 'Bonfim', 'RR', NULL, NULL, NULL, 1400159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.856157', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (140, 'Canta', 'RR', NULL, NULL, NULL, 1400175, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.856972', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (141, 'Caracarai', 'RR', NULL, NULL, NULL, 1400209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.857888', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (142, 'Caroebe', 'RR', NULL, NULL, NULL, 1400233, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.858888', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (143, 'Iracema', 'RR', NULL, NULL, NULL, 1400282, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.859891', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (144, 'Mucajai', 'RR', NULL, NULL, NULL, 1400308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.860859', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (145, 'Normandia', 'RR', NULL, NULL, NULL, 1400407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.861807', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (146, 'Pacaraima', 'RR', NULL, NULL, NULL, 1400456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.862761', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (147, 'Rorainopolis', 'RR', NULL, NULL, NULL, 1400472, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.86373', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (148, 'Sao Joao da Baliza', 'RR', NULL, NULL, NULL, 1400506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.864648', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (149, 'Sao Luiz', 'RR', NULL, NULL, NULL, 1400605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.865518', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (150, 'Uiramuta', 'RR', NULL, NULL, NULL, 1400704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.866386', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (151, 'Abaetetuba', 'PA', NULL, NULL, NULL, 1500107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.867591', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (152, 'Abel Figueiredo', 'PA', NULL, NULL, NULL, 1500131, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.868448', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (153, 'Acara', 'PA', NULL, NULL, NULL, 1500206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.869342', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (154, 'Afua', 'PA', NULL, NULL, NULL, 1500305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.87027', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (155, 'Agua Azul do Norte', 'PA', NULL, NULL, NULL, 1500347, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.871096', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (156, 'Alenquer', 'PA', NULL, NULL, NULL, 1500404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.872038', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (157, 'Almeirim', 'PA', NULL, NULL, NULL, 1500503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.872959', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (158, 'Altamira', 'PA', NULL, NULL, NULL, 1500602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.873993', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (159, 'Anajas', 'PA', NULL, NULL, NULL, 1500701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.874868', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (160, 'Ananindeua', 'PA', NULL, NULL, NULL, 1500800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.875805', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (161, 'Anapu', 'PA', NULL, NULL, NULL, 1500859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.87672', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (162, 'Augusto Correa', 'PA', NULL, NULL, NULL, 1500909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.877656', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (163, 'Aurora do Para', 'PA', NULL, NULL, NULL, 1500958, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.878762', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (164, 'Aveiro', 'PA', NULL, NULL, NULL, 1501006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.879577', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (165, 'Bagre', 'PA', NULL, NULL, NULL, 1501105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.88047', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (166, 'Baiao', 'PA', NULL, NULL, NULL, 1501204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.881428', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (167, 'Bannach', 'PA', NULL, NULL, NULL, 1501253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.882419', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (168, 'Barcarena', 'PA', NULL, NULL, NULL, 1501303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.883321', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (169, 'Belem', 'PA', NULL, NULL, NULL, 1501402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.884275', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (170, 'Belterra', 'PA', NULL, NULL, NULL, 1501451, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.885225', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (171, 'Benevides', 'PA', NULL, NULL, NULL, 1501501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.886172', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (172, 'Bom Jesus do Tocantins', 'PA', NULL, NULL, NULL, 1501576, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.887134', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (173, 'Bonito', 'PA', NULL, NULL, NULL, 1501600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.894617', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (174, 'Braganca', 'PA', NULL, NULL, NULL, 1501709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.895728', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (175, 'Brasil Novo', 'PA', NULL, NULL, NULL, 1501725, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.896566', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (176, 'Brejo Grande do Araguaia', 'PA', NULL, NULL, NULL, 1501758, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.897635', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (177, 'Breu Branco', 'PA', NULL, NULL, NULL, 1501782, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.898564', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (178, 'Breves', 'PA', NULL, NULL, NULL, 1501808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.899242', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (179, 'Bujaru', 'PA', NULL, NULL, NULL, 1501907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.900159', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (181, 'Cachoeira do Piria', 'PA', NULL, NULL, NULL, 1501956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.902107', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (180, 'Cachoeira do Arari', 'PA', NULL, NULL, NULL, 1502004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.901094', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (182, 'Cameta', 'PA', NULL, NULL, NULL, 1502103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.903016', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (183, 'Canaa dos Carajas', 'PA', NULL, NULL, NULL, 1502152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.903963', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (184, 'Capanema', 'PA', NULL, NULL, NULL, 1502202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.904782', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (185, 'Capitao Poco', 'PA', NULL, NULL, NULL, 1502301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.905681', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (186, 'Castanhal', 'PA', NULL, NULL, NULL, 1502400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.906554', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (187, 'Chaves', 'PA', NULL, NULL, NULL, 1502509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.907603', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (188, 'Colares', 'PA', NULL, NULL, NULL, 1502608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.908482', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (189, 'Conceicao do Araguaia', 'PA', NULL, NULL, NULL, 1502707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.909368', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (190, 'Concordia do Para', 'PA', NULL, NULL, NULL, 1502756, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.910192', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (191, 'Cumaru do Norte', 'PA', NULL, NULL, NULL, 1502764, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.911121', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (192, 'Curionopolis', 'PA', NULL, NULL, NULL, 1502772, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.912262', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (193, 'Curralinho', 'PA', NULL, NULL, NULL, 1502806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.913215', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (194, 'Curua', 'PA', NULL, NULL, NULL, 1502855, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.914119', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (195, 'Curuca', 'PA', NULL, NULL, NULL, 1502905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.915017', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (196, 'Dom Eliseu', 'PA', NULL, NULL, NULL, 1502939, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.91602', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (198, 'Faro', 'PA', NULL, NULL, NULL, 1503002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.91806', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (199, 'Floresta do Araguaia', 'PA', NULL, NULL, NULL, 1503044, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.918982', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (200, 'Garrafao do Norte', 'PA', NULL, NULL, NULL, 1503077, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.919913', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (201, 'Goianesia do Para', 'PA', NULL, NULL, NULL, 1503093, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.92081', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (202, 'Gurupa', 'PA', NULL, NULL, NULL, 1503101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.921711', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (203, 'Igarape-acu', 'PA', NULL, NULL, NULL, 1503200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.922705', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (204, 'Igarape-miri', 'PA', NULL, NULL, NULL, 1503309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.92357', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (205, 'Inhangapi', 'PA', NULL, NULL, NULL, 1503408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.924586', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (206, 'Ipixuna do Para', 'PA', NULL, NULL, NULL, 1503457, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.9256', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (207, 'Irituia', 'PA', NULL, NULL, NULL, 1503507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.926608', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (208, 'Itaituba', 'PA', NULL, NULL, NULL, 1503606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.92776', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (209, 'Itupiranga', 'PA', NULL, NULL, NULL, 1503705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.928737', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (210, 'Jacareacanga', 'PA', NULL, NULL, NULL, 1503754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.936088', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (211, 'Jacunda', 'PA', NULL, NULL, NULL, 1503804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.937324', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (212, 'Juruti', 'PA', NULL, NULL, NULL, 1503903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.938243', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (213, 'Limoeiro do Ajuru', 'PA', NULL, NULL, NULL, 1504000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.939321', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (214, 'Mae do Rio', 'PA', NULL, NULL, NULL, 1504059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.940188', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (215, 'Magalhaes Barata', 'PA', NULL, NULL, NULL, 1504109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.941158', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (216, 'Maraba', 'PA', NULL, NULL, NULL, 1504208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.942124', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (217, 'Maracana', 'PA', NULL, NULL, NULL, 1504307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.943021', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (218, 'Marapanim', 'PA', NULL, NULL, NULL, 1504406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.943981', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (219, 'Marituba', 'PA', NULL, NULL, NULL, 1504422, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.944811', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (220, 'Medicilandia', 'PA', NULL, NULL, NULL, 1504455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.945759', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (221, 'Melgaco', 'PA', NULL, NULL, NULL, 1504505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.946559', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (222, 'Mocajuba', 'PA', NULL, NULL, NULL, 1504604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.947482', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (223, 'Moju', 'PA', NULL, NULL, NULL, 1504703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.948244', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (224, 'Monte Alegre', 'PA', NULL, NULL, NULL, 1504802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.949614', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (225, 'Muana', 'PA', NULL, NULL, NULL, 1504901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.950555', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (226, 'Nova Esperanca do Piria', 'PA', NULL, NULL, NULL, 1504950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.9514', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (227, 'Nova Ipixuna', 'PA', NULL, NULL, NULL, 1504976, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.952304', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (228, 'Nova Timboteua', 'PA', NULL, NULL, NULL, 1505007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.953216', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (229, 'Novo Progresso', 'PA', NULL, NULL, NULL, 1505031, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.954085', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (230, 'Novo Repartimento', 'PA', NULL, NULL, NULL, 1505064, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.955006', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (231, 'Obidos', 'PA', NULL, NULL, NULL, 1505106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.95593', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (232, 'Oeiras do Para', 'PA', NULL, NULL, NULL, 1505205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.956865', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (233, 'Oriximina', 'PA', NULL, NULL, NULL, 1505304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.957786', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (234, 'Ourem', 'PA', NULL, NULL, NULL, 1505403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.958709', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (235, 'Ourilandia do Norte', 'PA', NULL, NULL, NULL, 1505437, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.959504', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (236, 'Pacaja', 'PA', NULL, NULL, NULL, 1505486, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.960374', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (237, 'Palestina do Para', 'PA', NULL, NULL, NULL, 1505494, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.96127', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (238, 'Paragominas', 'PA', NULL, NULL, NULL, 1505502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.962164', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (239, 'Parauapebas', 'PA', NULL, NULL, NULL, 1505536, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.963118', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (240, 'Pau D''arco', 'PA', NULL, NULL, NULL, 1505551, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.963912', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (241, 'Peixe-boi', 'PA', NULL, NULL, NULL, 1505601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.964888', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (242, 'Picarra', 'PA', NULL, NULL, NULL, 1505635, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.965834', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (243, 'Placas', 'PA', NULL, NULL, NULL, 1505650, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.966852', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (244, 'Ponta de Pedras', 'PA', NULL, NULL, NULL, 1505700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.968025', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (245, 'Portel', 'PA', NULL, NULL, NULL, 1505809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.969061', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (246, 'Porto de Moz', 'PA', NULL, NULL, NULL, 1505908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.970034', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (247, 'Prainha', 'PA', NULL, NULL, NULL, 1506005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.978985', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (248, 'Primavera', 'PA', NULL, NULL, NULL, 1506104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.980101', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (249, 'Quatipuru', 'PA', NULL, NULL, NULL, 1506112, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.981208', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (250, 'Redencao', 'PA', NULL, NULL, NULL, 1506138, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.982118', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (251, 'Rio Maria', 'PA', NULL, NULL, NULL, 1506161, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.983216', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (252, 'Rondon do Para', 'PA', NULL, NULL, NULL, 1506187, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.984434', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (253, 'Ruropolis', 'PA', NULL, NULL, NULL, 1506195, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.985502', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (254, 'Salinopolis', 'PA', NULL, NULL, NULL, 1506203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.986493', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (255, 'Salvaterra', 'PA', NULL, NULL, NULL, 1506302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.987353', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (256, 'Santa Barbara do Para', 'PA', NULL, NULL, NULL, 1506351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.988251', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (257, 'Santa Cruz do Arari', 'PA', NULL, NULL, NULL, 1506401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.989048', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (259, 'Santa Luzia do Para', 'PA', NULL, NULL, NULL, 1506559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.991128', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (260, 'Santa Maria das Barreiras', 'PA', NULL, NULL, NULL, 1506583, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.991911', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (261, 'Santa Maria do Para', 'PA', NULL, NULL, NULL, 1506609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.992886', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (262, 'Santana do Araguaia', 'PA', NULL, NULL, NULL, 1506708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.993845', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (263, 'Santarem', 'PA', NULL, NULL, NULL, 1506807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.994763', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (264, 'Santarem Novo', 'PA', NULL, NULL, NULL, 1506906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.995664', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (265, 'Santo Antonio do Taua', 'PA', NULL, NULL, NULL, 1507003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.996463', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (266, 'Sao Caetano de Odivelas', 'PA', NULL, NULL, NULL, 1507102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.997262', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (267, 'Sao Domingos do Araguaia', 'PA', NULL, NULL, NULL, 1507151, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.998092', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (268, 'Sao Domingos do Capim', 'PA', NULL, NULL, NULL, 1507201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.999037', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (269, 'Sao Felix do Xingu', 'PA', NULL, NULL, NULL, 1507300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.999952', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (270, 'Sao Francisco do Para', 'PA', NULL, NULL, NULL, 1507409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.001019', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (271, 'Sao Geraldo do Araguaia', 'PA', NULL, NULL, NULL, 1507458, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.001861', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (272, 'Sao Joao da Ponta', 'PA', NULL, NULL, NULL, 1507466, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.002762', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (273, 'Sao Joao de Pirabas', 'PA', NULL, NULL, NULL, 1507474, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.003681', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (274, 'Sao Joao do Araguaia', 'PA', NULL, NULL, NULL, 1507508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.004606', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (275, 'Sao Miguel do Guama', 'PA', NULL, NULL, NULL, 1507607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.005566', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (276, 'Sao Sebastiao da Boa Vista', 'PA', NULL, NULL, NULL, 1507706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.006395', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (277, 'Sapucaia', 'PA', NULL, NULL, NULL, 1507755, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.007271', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (278, 'Senador Jose Porfirio', 'PA', NULL, NULL, NULL, 1507805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.008163', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (279, 'Soure', 'PA', NULL, NULL, NULL, 1507904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.009091', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (280, 'Tailandia', 'PA', NULL, NULL, NULL, 1507953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.010067', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (281, 'Terra Alta', 'PA', NULL, NULL, NULL, 1507961, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.01103', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (282, 'Terra Santa', 'PA', NULL, NULL, NULL, 1507979, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.012083', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (283, 'Tome-acu', 'PA', NULL, NULL, NULL, 1508001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.012862', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (284, 'Tracuateua', 'PA', NULL, NULL, NULL, 1508035, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.020208', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (285, 'Trairao', 'PA', NULL, NULL, NULL, 1508050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.021367', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (286, 'Tucuma', 'PA', NULL, NULL, NULL, 1508084, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.022234', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (287, 'Tucurui', 'PA', NULL, NULL, NULL, 1508100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.023243', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (288, 'Ulianopolis', 'PA', NULL, NULL, NULL, 1508126, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.024129', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (289, 'Uruara', 'PA', NULL, NULL, NULL, 1508159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.024966', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (290, 'Vigia', 'PA', NULL, NULL, NULL, 1508209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.025883', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (291, 'Viseu', 'PA', NULL, NULL, NULL, 1508308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.026802', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (292, 'Vitoria do Xingu', 'PA', NULL, NULL, NULL, 1508357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.027745', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (293, 'Xinguara', 'PA', NULL, NULL, NULL, 1508407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.028653', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (307, 'Serra do Navio', 'AP', NULL, NULL, NULL, 1600055, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.041419', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (294, 'Amapa', 'AP', NULL, NULL, NULL, 1600105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.029605', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (303, 'Pedra Branca do Amapari', 'AP', NULL, NULL, NULL, 1600154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.037751', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (295, 'Calcoene', 'AP', NULL, NULL, NULL, 1600204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.030519', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (296, 'Cutias', 'AP', NULL, NULL, NULL, 1600212, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.031457', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (297, 'Ferreira Gomes', 'AP', NULL, NULL, NULL, 1600238, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.032313', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (298, 'Itaubal', 'AP', NULL, NULL, NULL, 1600253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.033162', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (299, 'Laranjal do Jari', 'AP', NULL, NULL, NULL, 1600279, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.034147', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (300, 'Macapa', 'AP', NULL, NULL, NULL, 1600303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.035017', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (301, 'Mazagao', 'AP', NULL, NULL, NULL, 1600402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.036028', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (302, 'Oiapoque', 'AP', NULL, NULL, NULL, 1600501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.036905', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (304, 'Porto Grande', 'AP', NULL, NULL, NULL, 1600535, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.038704', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (305, 'Pracuuba', 'AP', NULL, NULL, NULL, 1600550, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.039594', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (306, 'Santana', 'AP', NULL, NULL, NULL, 1600600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.040511', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (308, 'Tartarugalzinho', 'AP', NULL, NULL, NULL, 1600709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.042303', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (309, 'Vitoria do Jari', 'AP', NULL, NULL, NULL, 1600808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.043135', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (310, 'Abreulandia', 'TO', NULL, NULL, NULL, 1700251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.044063', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (311, 'Aguiarnopolis', 'TO', NULL, NULL, NULL, 1700301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.045079', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (312, 'Alianca do Tocantins', 'TO', NULL, NULL, NULL, 1700350, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.04621', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (313, 'Almas', 'TO', NULL, NULL, NULL, 1700400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.047192', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (314, 'Alvorada', 'TO', NULL, NULL, NULL, 1700707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.048146', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (315, 'Ananas', 'TO', NULL, NULL, NULL, 1701002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.049117', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (316, 'Angico', 'TO', NULL, NULL, NULL, 1701051, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.050076', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (317, 'Aparecida do Rio Negro', 'TO', NULL, NULL, NULL, 1701101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.050987', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (318, 'Aragominas', 'TO', NULL, NULL, NULL, 1701309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.051903', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (319, 'Araguacema', 'TO', NULL, NULL, NULL, 1701903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.052846', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (320, 'Araguacu', 'TO', NULL, NULL, NULL, 1702000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.053962', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (321, 'Araguaina', 'TO', NULL, NULL, NULL, 1702109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.061617', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (322, 'Araguana', 'TO', NULL, NULL, NULL, 1702158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.062755', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (323, 'Araguatins', 'TO', NULL, NULL, NULL, 1702208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.063685', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (324, 'Arapoema', 'TO', NULL, NULL, NULL, 1702307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.064569', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (325, 'Arraias', 'TO', NULL, NULL, NULL, 1702406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.06559', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (326, 'Augustinopolis', 'TO', NULL, NULL, NULL, 1702554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.066518', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (327, 'Aurora do Tocantins', 'TO', NULL, NULL, NULL, 1702703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.067488', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (328, 'Axixa do Tocantins', 'TO', NULL, NULL, NULL, 1702901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.06855', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (329, 'Babaculandia', 'TO', NULL, NULL, NULL, 1703008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.069459', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (330, 'Bandeirantes do Tocantins', 'TO', NULL, NULL, NULL, 1703057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.070302', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (331, 'Barra do Ouro', 'TO', NULL, NULL, NULL, 1703073, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.071172', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (332, 'Barrolandia', 'TO', NULL, NULL, NULL, 1703107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.072056', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (333, 'Bernardo Sayao', 'TO', NULL, NULL, NULL, 1703206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.072885', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (334, 'Bom Jesus do Tocantins', 'TO', NULL, NULL, NULL, 1703305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.073818', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (335, 'Brasilandia do Tocantins', 'TO', NULL, NULL, NULL, 1703602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.074694', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (336, 'Brejinho de Nazare', 'TO', NULL, NULL, NULL, 1703701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.075521', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (337, 'Buriti do Tocantins', 'TO', NULL, NULL, NULL, 1703800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.076484', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (338, 'Cachoeirinha', 'TO', NULL, NULL, NULL, 1703826, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.077361', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (339, 'Campos Lindos', 'TO', NULL, NULL, NULL, 1703842, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.078201', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (340, 'Cariri do Tocantins', 'TO', NULL, NULL, NULL, 1703867, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.079159', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (341, 'Carmolandia', 'TO', NULL, NULL, NULL, 1703883, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.079958', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (342, 'Carrasco Bonito', 'TO', NULL, NULL, NULL, 1703891, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.081026', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (343, 'Caseara', 'TO', NULL, NULL, NULL, 1703909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.082012', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (344, 'Centenario', 'TO', NULL, NULL, NULL, 1704105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.082934', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (346, 'Chapada de Areia', 'TO', NULL, NULL, NULL, 1704600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.084657', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (345, 'Chapada da Natividade', 'TO', NULL, NULL, NULL, 1705102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.083733', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (347, 'Colinas do Tocantins', 'TO', NULL, NULL, NULL, 1705508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.085702', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (349, 'Combinado', 'TO', NULL, NULL, NULL, 1705557, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.087767', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (350, 'Conceicao do Tocantins', 'TO', NULL, NULL, NULL, 1705607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.088722', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (352, 'Cristalandia', 'TO', NULL, NULL, NULL, 1706100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.090779', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (353, 'Crixas do Tocantins', 'TO', NULL, NULL, NULL, 1706258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.091635', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (354, 'Darcinopolis', 'TO', NULL, NULL, NULL, 1706506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.092435', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (355, 'Dianopolis', 'TO', NULL, NULL, NULL, 1707009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.093325', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (356, 'Divinopolis do Tocantins', 'TO', NULL, NULL, NULL, 1707108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.094239', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (357, 'Dois Irmaos do Tocantins', 'TO', NULL, NULL, NULL, 1707207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.09535', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (358, 'Duere', 'TO', NULL, NULL, NULL, 1707306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.102276', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (359, 'Esperantina', 'TO', NULL, NULL, NULL, 1707405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.103367', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (360, 'Fatima', 'TO', NULL, NULL, NULL, 1707553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.104253', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (361, 'Figueiropolis', 'TO', NULL, NULL, NULL, 1707652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.105111', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (362, 'Filadelfia', 'TO', NULL, NULL, NULL, 1707702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.106031', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (363, 'Formoso do Araguaia', 'TO', NULL, NULL, NULL, 1708205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.106844', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (364, 'Fortaleza do Tabocao', 'TO', NULL, NULL, NULL, 1708254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.107791', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (365, 'Goianorte', 'TO', NULL, NULL, NULL, 1708304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.108687', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (366, 'Goiatins', 'TO', NULL, NULL, NULL, 1709005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.10958', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (367, 'Guarai', 'TO', NULL, NULL, NULL, 1709302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.110381', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (368, 'Gurupi', 'TO', NULL, NULL, NULL, 1709500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.111293', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (369, 'Ipueiras', 'TO', NULL, NULL, NULL, 1709807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.112298', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (370, 'Itacaja', 'TO', NULL, NULL, NULL, 1710508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.113135', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (371, 'Itaguatins', 'TO', NULL, NULL, NULL, 1710706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.113912', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (372, 'Itapiratins', 'TO', NULL, NULL, NULL, 1710904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.1149', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (373, 'Itapora do Tocantins', 'TO', NULL, NULL, NULL, 1711100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.11572', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (374, 'Jau do Tocantins', 'TO', NULL, NULL, NULL, 1711506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.116488', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (375, 'Juarina', 'TO', NULL, NULL, NULL, 1711803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.117396', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (376, 'Lagoa da Confusao', 'TO', NULL, NULL, NULL, 1711902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.11813', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (377, 'Lagoa do Tocantins', 'TO', NULL, NULL, NULL, 1711951, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.118825', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (378, 'Lajeado', 'TO', NULL, NULL, NULL, 1712009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.119873', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (379, 'Lavandeira', 'TO', NULL, NULL, NULL, 1712157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.120739', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (380, 'Lizarda', 'TO', NULL, NULL, NULL, 1712405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.121597', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (381, 'Luzinopolis', 'TO', NULL, NULL, NULL, 1712454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.122538', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (382, 'Marianopolis do Tocantins', 'TO', NULL, NULL, NULL, 1712504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.123445', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (383, 'Mateiros', 'TO', NULL, NULL, NULL, 1712702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.124297', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (384, 'Maurilandia do Tocantins', 'TO', NULL, NULL, NULL, 1712801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.125143', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (385, 'Miracema do Tocantins', 'TO', NULL, NULL, NULL, 1713205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.125927', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (386, 'Miranorte', 'TO', NULL, NULL, NULL, 1713304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.126827', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (387, 'Monte do Carmo', 'TO', NULL, NULL, NULL, 1713601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.127756', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (388, 'Monte Santo do Tocantins', 'TO', NULL, NULL, NULL, 1713700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.128688', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (400, 'Palmeiras do Tocantins', 'TO', NULL, NULL, NULL, 1713809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.146676', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (389, 'Muricilandia', 'TO', NULL, NULL, NULL, 1713957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.129605', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (390, 'Natividade', 'TO', NULL, NULL, NULL, 1714203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.13038', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (391, 'Nazare', 'TO', NULL, NULL, NULL, 1714302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.131401', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (392, 'Nova Olinda', 'TO', NULL, NULL, NULL, 1714880, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.132322', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (393, 'Nova Rosalandia', 'TO', NULL, NULL, NULL, 1715002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.133154', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (394, 'Novo Acordo', 'TO', NULL, NULL, NULL, 1715101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.134133', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (395, 'Novo Alegre', 'TO', NULL, NULL, NULL, 1715150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.135242', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (396, 'Novo Jardim', 'TO', NULL, NULL, NULL, 1715259, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.13607', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (397, 'Oliveira de Fatima', 'TO', NULL, NULL, NULL, 1715507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.143376', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (399, 'Palmeirante', 'TO', NULL, NULL, NULL, 1715705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.145386', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (401, 'Palmeiropolis', 'TO', NULL, NULL, NULL, 1715754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.14756', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (402, 'Paraiso do Tocantins', 'TO', NULL, NULL, NULL, 1716109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.148448', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (403, 'Parana', 'TO', NULL, NULL, NULL, 1716208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.149167', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (404, 'Pau D''arco', 'TO', NULL, NULL, NULL, 1716307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.150069', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (405, 'Pedro Afonso', 'TO', NULL, NULL, NULL, 1716505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.151063', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (406, 'Peixe', 'TO', NULL, NULL, NULL, 1716604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.151996', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (407, 'Pequizeiro', 'TO', NULL, NULL, NULL, 1716653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.152856', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (348, 'Colmeia', 'TO', NULL, NULL, NULL, 1716703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.086822', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (408, 'Pindorama do Tocantins', 'TO', NULL, NULL, NULL, 1717008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.153748', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (409, 'Piraque', 'TO', NULL, NULL, NULL, 1717206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.154606', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (410, 'Pium', 'TO', NULL, NULL, NULL, 1717503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.155474', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (411, 'Ponte Alta do Bom Jesus', 'TO', NULL, NULL, NULL, 1717800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.156408', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (412, 'Ponte Alta do Tocantins', 'TO', NULL, NULL, NULL, 1717909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.157673', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (413, 'Porto Alegre do Tocantins', 'TO', NULL, NULL, NULL, 1718006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.158647', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (414, 'Porto Nacional', 'TO', NULL, NULL, NULL, 1718204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.159639', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (415, 'Praia Norte', 'TO', NULL, NULL, NULL, 1718303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.160437', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (416, 'Presidente Kennedy', 'TO', NULL, NULL, NULL, 1718402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.16134', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (417, 'Pugmil', 'TO', NULL, NULL, NULL, 1718451, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.16224', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (418, 'Recursolandia', 'TO', NULL, NULL, NULL, 1718501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.163175', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (419, 'Riachinho', 'TO', NULL, NULL, NULL, 1718550, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.164096', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (420, 'Rio da Conceicao', 'TO', NULL, NULL, NULL, 1718659, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.164921', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (421, 'Rio dos Bois', 'TO', NULL, NULL, NULL, 1718709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.165967', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (422, 'Rio Sono', 'TO', NULL, NULL, NULL, 1718758, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.166949', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (423, 'Sampaio', 'TO', NULL, NULL, NULL, 1718808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.167811', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (424, 'Sandolandia', 'TO', NULL, NULL, NULL, 1718840, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.168809', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (425, 'Santa Fe do Araguaia', 'TO', NULL, NULL, NULL, 1718865, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.169817', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (426, 'Santa Maria do Tocantins', 'TO', NULL, NULL, NULL, 1718881, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.170766', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (427, 'Santa Rita do Tocantins', 'TO', NULL, NULL, NULL, 1718899, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.171677', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (428, 'Santa Rosa do Tocantins', 'TO', NULL, NULL, NULL, 1718907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.172572', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (429, 'Santa Tereza do Tocantins', 'TO', NULL, NULL, NULL, 1719004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.173518', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (430, 'Santa Terezinha do Tocantins', 'TO', NULL, NULL, NULL, 1720002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.174352', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (431, 'Sao Bento do Tocantins', 'TO', NULL, NULL, NULL, 1720101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.17523', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (432, 'Sao Felix do Tocantins', 'TO', NULL, NULL, NULL, 1720150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.176102', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (433, 'Sao Miguel do Tocantins', 'TO', NULL, NULL, NULL, 1720200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.177106', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (434, 'Sao Salvador do Tocantins', 'TO', NULL, NULL, NULL, 1720259, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.18496', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (435, 'Sao Sebastiao do Tocantins', 'TO', NULL, NULL, NULL, 1720309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.186102', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (437, 'Silvanopolis', 'TO', NULL, NULL, NULL, 1720655, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.187777', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (438, 'Sitio Novo do Tocantins', 'TO', NULL, NULL, NULL, 1720804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.188758', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (439, 'Sucupira', 'TO', NULL, NULL, NULL, 1720853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.189661', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (440, 'Taguatinga', 'TO', NULL, NULL, NULL, 1720903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.190463', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (441, 'Taipas do Tocantins', 'TO', NULL, NULL, NULL, 1720937, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.191273', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (442, 'Talisma', 'TO', NULL, NULL, NULL, 1720978, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.192128', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (398, 'Palmas', 'TO', NULL, NULL, NULL, 1721000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.144446', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (443, 'Tocantinia', 'TO', NULL, NULL, NULL, 1721109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.193041', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (444, 'Tocantinopolis', 'TO', NULL, NULL, NULL, 1721208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.19396', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (445, 'Tupirama', 'TO', NULL, NULL, NULL, 1721257, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.194937', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (446, 'Tupiratins', 'TO', NULL, NULL, NULL, 1721307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.195867', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (447, 'Wanderlandia', 'TO', NULL, NULL, NULL, 1722081, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.196689', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (448, 'Xambioa', 'TO', NULL, NULL, NULL, 1722107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.197644', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (449, 'Acailandia', 'MA', NULL, NULL, NULL, 2100055, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.198538', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (450, 'Afonso Cunha', 'MA', NULL, NULL, NULL, 2100105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.199462', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (451, 'Agua Doce do Maranhao', 'MA', NULL, NULL, NULL, 2100154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.200279', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (452, 'Alcantara', 'MA', NULL, NULL, NULL, 2100204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.201164', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (453, 'Aldeias Altas', 'MA', NULL, NULL, NULL, 2100303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.202176', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (454, 'Altamira do Maranhao', 'MA', NULL, NULL, NULL, 2100402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.203261', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (455, 'Alto Alegre do Maranhao', 'MA', NULL, NULL, NULL, 2100436, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.204215', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (456, 'Alto Alegre do Pindare', 'MA', NULL, NULL, NULL, 2100477, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.205089', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (457, 'Alto Parnaiba', 'MA', NULL, NULL, NULL, 2100501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.206158', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (458, 'Amapa do Maranhao', 'MA', NULL, NULL, NULL, 2100550, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.20716', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (459, 'Amarante do Maranhao', 'MA', NULL, NULL, NULL, 2100600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.208081', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (460, 'Anajatuba', 'MA', NULL, NULL, NULL, 2100709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.208976', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (461, 'Anapurus', 'MA', NULL, NULL, NULL, 2100808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.209855', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (462, 'Apicum-acu', 'MA', NULL, NULL, NULL, 2100832, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.210782', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (463, 'Araguana', 'MA', NULL, NULL, NULL, 2100873, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.211696', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (464, 'Araioses', 'MA', NULL, NULL, NULL, 2100907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.212717', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (465, 'Arame', 'MA', NULL, NULL, NULL, 2100956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.21353', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (466, 'Arari', 'MA', NULL, NULL, NULL, 2101004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.214388', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (467, 'Axixa', 'MA', NULL, NULL, NULL, 2101103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.215297', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (468, 'Bacabal', 'MA', NULL, NULL, NULL, 2101202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.21624', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (469, 'Bacabeira', 'MA', NULL, NULL, NULL, 2101251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.217163', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (470, 'Bacuri', 'MA', NULL, NULL, NULL, 2101301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.218068', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (471, 'Bacurituba', 'MA', NULL, NULL, NULL, 2101350, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.218906', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (472, 'Balsas', 'MA', NULL, NULL, NULL, 2101400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.226511', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (473, 'Barao de Grajau', 'MA', NULL, NULL, NULL, 2101509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.227641', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (474, 'Barra do Corda', 'MA', NULL, NULL, NULL, 2101608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.228529', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (475, 'Barreirinhas', 'MA', NULL, NULL, NULL, 2101707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.22946', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (477, 'Belagua', 'MA', NULL, NULL, NULL, 2101731, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.231267', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (476, 'Bela Vista do Maranhao', 'MA', NULL, NULL, NULL, 2101772, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.230349', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (478, 'Benedito Leite', 'MA', NULL, NULL, NULL, 2101806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.232219', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (479, 'Bequimao', 'MA', NULL, NULL, NULL, 2101905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.233065', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (480, 'Bernardo do Mearim', 'MA', NULL, NULL, NULL, 2101939, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.23398', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (481, 'Boa Vista do Gurupi', 'MA', NULL, NULL, NULL, 2101970, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.234892', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (482, 'Bom Jardim', 'MA', NULL, NULL, NULL, 2102002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.235799', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (483, 'Bom Jesus das Selvas', 'MA', NULL, NULL, NULL, 2102036, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.236707', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (484, 'Bom Lugar', 'MA', NULL, NULL, NULL, 2102077, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.237544', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (485, 'Brejo', 'MA', NULL, NULL, NULL, 2102101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.238393', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (486, 'Brejo de Areia', 'MA', NULL, NULL, NULL, 2102150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.23924', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (487, 'Buriti', 'MA', NULL, NULL, NULL, 2102200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.240212', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (488, 'Buriti Bravo', 'MA', NULL, NULL, NULL, 2102309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.24103', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (489, 'Buriticupu', 'MA', NULL, NULL, NULL, 2102325, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.241945', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (490, 'Buritirana', 'MA', NULL, NULL, NULL, 2102358, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.242839', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (491, 'Cachoeira Grande', 'MA', NULL, NULL, NULL, 2102374, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.243731', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (492, 'Cajapio', 'MA', NULL, NULL, NULL, 2102408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.244628', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (493, 'Cajari', 'MA', NULL, NULL, NULL, 2102507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.245516', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (494, 'Campestre do Maranhao', 'MA', NULL, NULL, NULL, 2102556, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.246481', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (495, 'Candido Mendes', 'MA', NULL, NULL, NULL, 2102606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.247331', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (496, 'Cantanhede', 'MA', NULL, NULL, NULL, 2102705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.248243', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (497, 'Capinzal do Norte', 'MA', NULL, NULL, NULL, 2102754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.249166', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (498, 'Carolina', 'MA', NULL, NULL, NULL, 2102804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.250112', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (499, 'Carutapera', 'MA', NULL, NULL, NULL, 2102903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.251005', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (500, 'Caxias', 'MA', NULL, NULL, NULL, 2103000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.251858', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (501, 'Cedral', 'MA', NULL, NULL, NULL, 2103109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.252814', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (502, 'Central do Maranhao', 'MA', NULL, NULL, NULL, 2103125, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.253724', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (503, 'Centro do Guilherme', 'MA', NULL, NULL, NULL, 2103158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.254702', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (504, 'Centro Novo do Maranhao', 'MA', NULL, NULL, NULL, 2103174, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.255559', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (505, 'Chapadinha', 'MA', NULL, NULL, NULL, 2103208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.256472', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (506, 'Cidelandia', 'MA', NULL, NULL, NULL, 2103257, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.257495', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (507, 'Codo', 'MA', NULL, NULL, NULL, 2103307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.258325', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (508, 'Coelho Neto', 'MA', NULL, NULL, NULL, 2103406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.259107', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (509, 'Colinas', 'MA', NULL, NULL, NULL, 2103505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.259977', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (510, 'Conceicao do Lago-acu', 'MA', NULL, NULL, NULL, 2103554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.267016', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (511, 'Coroata', 'MA', NULL, NULL, NULL, 2103604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.268195', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (512, 'Cururupu', 'MA', NULL, NULL, NULL, 2103703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.269164', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (513, 'Davinopolis', 'MA', NULL, NULL, NULL, 2103752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.270095', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (514, 'Dom Pedro', 'MA', NULL, NULL, NULL, 2103802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.271002', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (515, 'Duque Bacelar', 'MA', NULL, NULL, NULL, 2103901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.271929', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (516, 'Esperantinopolis', 'MA', NULL, NULL, NULL, 2104008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.27286', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (517, 'Estreito', 'MA', NULL, NULL, NULL, 2104057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.273795', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (518, 'Feira Nova do Maranhao', 'MA', NULL, NULL, NULL, 2104073, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.274839', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (519, 'Fernando Falcao', 'MA', NULL, NULL, NULL, 2104081, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.275832', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (520, 'Formosa da Serra Negra', 'MA', NULL, NULL, NULL, 2104099, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.276788', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (521, 'Fortaleza dos Nogueiras', 'MA', NULL, NULL, NULL, 2104107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.27762', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (522, 'Fortuna', 'MA', NULL, NULL, NULL, 2104206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.278459', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (523, 'Godofredo Viana', 'MA', NULL, NULL, NULL, 2104305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.279542', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (524, 'Goncalves Dias', 'MA', NULL, NULL, NULL, 2104404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.280371', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (525, 'Governador Archer', 'MA', NULL, NULL, NULL, 2104503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.281277', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (526, 'Governador Edison Lobao', 'MA', NULL, NULL, NULL, 2104552, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.282223', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (527, 'Governador Eugenio Barros', 'MA', NULL, NULL, NULL, 2104602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.283125', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (528, 'Governador Luiz Rocha', 'MA', NULL, NULL, NULL, 2104628, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.283974', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (529, 'Governador Newton Bello', 'MA', NULL, NULL, NULL, 2104651, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.284782', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (530, 'Governador Nunes Freire', 'MA', NULL, NULL, NULL, 2104677, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.285675', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (531, 'Graca Aranha', 'MA', NULL, NULL, NULL, 2104701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.286846', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (532, 'Grajau', 'MA', NULL, NULL, NULL, 2104800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.287677', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (533, 'Guimaraes', 'MA', NULL, NULL, NULL, 2104909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.288667', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (534, 'Humberto de Campos', 'MA', NULL, NULL, NULL, 2105005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.289578', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (535, 'Icatu', 'MA', NULL, NULL, NULL, 2105104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.290557', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (536, 'Igarape do Meio', 'MA', NULL, NULL, NULL, 2105153, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.291496', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (537, 'Igarape Grande', 'MA', NULL, NULL, NULL, 2105203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.2924', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (538, 'Imperatriz', 'MA', NULL, NULL, NULL, 2105302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.293262', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (688, 'Batalha', 'PI', NULL, NULL, NULL, 2201507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.461931', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (539, 'Itaipava do Grajau', 'MA', NULL, NULL, NULL, 2105351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.294094', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (540, 'Itapecuru Mirim', 'MA', NULL, NULL, NULL, 2105401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.295124', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (541, 'Itinga do Maranhao', 'MA', NULL, NULL, NULL, 2105427, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.296028', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (542, 'Jatoba', 'MA', NULL, NULL, NULL, 2105450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.296978', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (543, 'Jenipapo dos Vieiras', 'MA', NULL, NULL, NULL, 2105476, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.29789', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (544, 'Joao Lisboa', 'MA', NULL, NULL, NULL, 2105500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.298837', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (545, 'Joselandia', 'MA', NULL, NULL, NULL, 2105609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.299813', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (546, 'Junco do Maranhao', 'MA', NULL, NULL, NULL, 2105658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.300907', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (547, 'Lago da Pedra', 'MA', NULL, NULL, NULL, 2105708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.302071', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (548, 'Lago do Junco', 'MA', NULL, NULL, NULL, 2105807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.307903', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (550, 'Lago Verde', 'MA', NULL, NULL, NULL, 2105906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.310138', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (551, 'Lagoa do Mato', 'MA', NULL, NULL, NULL, 2105922, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.311156', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (549, 'Lago dos Rodrigues', 'MA', NULL, NULL, NULL, 2105948, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.309158', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (552, 'Lagoa Grande do Maranhao', 'MA', NULL, NULL, NULL, 2105963, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.312133', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (553, 'Lajeado Novo', 'MA', NULL, NULL, NULL, 2105989, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.313052', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (554, 'Lima Campos', 'MA', NULL, NULL, NULL, 2106003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.313916', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (555, 'Loreto', 'MA', NULL, NULL, NULL, 2106102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.31479', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (556, 'Luis Domingues', 'MA', NULL, NULL, NULL, 2106201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.315685', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (557, 'Magalhaes de Almeida', 'MA', NULL, NULL, NULL, 2106300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.316626', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (558, 'Maracacume', 'MA', NULL, NULL, NULL, 2106326, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.317519', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (559, 'Maraja do Sena', 'MA', NULL, NULL, NULL, 2106359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.318381', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (560, 'Maranhaozinho', 'MA', NULL, NULL, NULL, 2106375, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.319219', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (561, 'Mata Roma', 'MA', NULL, NULL, NULL, 2106409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.320109', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (562, 'Matinha', 'MA', NULL, NULL, NULL, 2106508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.320966', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (563, 'Matoes', 'MA', NULL, NULL, NULL, 2106607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.321907', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (564, 'Matoes do Norte', 'MA', NULL, NULL, NULL, 2106631, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.32282', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (565, 'Milagres do Maranhao', 'MA', NULL, NULL, NULL, 2106672, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.32375', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (566, 'Mirador', 'MA', NULL, NULL, NULL, 2106706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.324883', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (567, 'Miranda do Norte', 'MA', NULL, NULL, NULL, 2106755, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.325801', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (568, 'Mirinzal', 'MA', NULL, NULL, NULL, 2106805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.326849', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (569, 'Moncao', 'MA', NULL, NULL, NULL, 2106904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.327637', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (570, 'Montes Altos', 'MA', NULL, NULL, NULL, 2107001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.328569', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (571, 'Morros', 'MA', NULL, NULL, NULL, 2107100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.329367', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (572, 'Nina Rodrigues', 'MA', NULL, NULL, NULL, 2107209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.330692', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (573, 'Nova Colinas', 'MA', NULL, NULL, NULL, 2107258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.332095', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (574, 'Nova Iorque', 'MA', NULL, NULL, NULL, 2107308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.333022', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (575, 'Nova Olinda do Maranhao', 'MA', NULL, NULL, NULL, 2107357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.333932', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (576, 'Olho D''agua das Cunhas', 'MA', NULL, NULL, NULL, 2107407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.334867', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (577, 'Olinda Nova do Maranhao', 'MA', NULL, NULL, NULL, 2107456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.335779', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (578, 'Paco do Lumiar', 'MA', NULL, NULL, NULL, 2107506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.33655', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (579, 'Palmeirandia', 'MA', NULL, NULL, NULL, 2107605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.337518', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (580, 'Paraibano', 'MA', NULL, NULL, NULL, 2107704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.338445', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (581, 'Parnarama', 'MA', NULL, NULL, NULL, 2107803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.340223', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (582, 'Passagem Franca', 'MA', NULL, NULL, NULL, 2107902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.341359', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (583, 'Pastos Bons', 'MA', NULL, NULL, NULL, 2108009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.342182', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (584, 'Paulino Neves', 'MA', NULL, NULL, NULL, 2108058, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.352812', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (585, 'Paulo Ramos', 'MA', NULL, NULL, NULL, 2108108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.353828', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (586, 'Pedreiras', 'MA', NULL, NULL, NULL, 2108207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.354689', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (587, 'Pedro do Rosario', 'MA', NULL, NULL, NULL, 2108256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.355564', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (588, 'Penalva', 'MA', NULL, NULL, NULL, 2108306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.356425', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (589, 'Peri Mirim', 'MA', NULL, NULL, NULL, 2108405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.357303', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (590, 'Peritoro', 'MA', NULL, NULL, NULL, 2108454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.358268', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (592, 'Pinheiro', 'MA', NULL, NULL, NULL, 2108603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.360105', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (593, 'Pio Xii', 'MA', NULL, NULL, NULL, 2108702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.361003', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (594, 'Pirapemas', 'MA', NULL, NULL, NULL, 2108801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.361829', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (595, 'Pocao de Pedras', 'MA', NULL, NULL, NULL, 2108900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.362741', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (596, 'Porto Franco', 'MA', NULL, NULL, NULL, 2109007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.363626', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (597, 'Porto Rico do Maranhao', 'MA', NULL, NULL, NULL, 2109056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.364534', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (598, 'Presidente Dutra', 'MA', NULL, NULL, NULL, 2109106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.365368', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (599, 'Presidente Juscelino', 'MA', NULL, NULL, NULL, 2109205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.366202', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (600, 'Presidente Medici', 'MA', NULL, NULL, NULL, 2109239, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.367133', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (601, 'Presidente Sarney', 'MA', NULL, NULL, NULL, 2109270, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.368047', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (602, 'Presidente Vargas', 'MA', NULL, NULL, NULL, 2109304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.368937', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (603, 'Primeira Cruz', 'MA', NULL, NULL, NULL, 2109403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.369823', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (604, 'Raposa', 'MA', NULL, NULL, NULL, 2109452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.370771', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (605, 'Riachao', 'MA', NULL, NULL, NULL, 2109502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.371655', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (606, 'Ribamar Fiquene', 'MA', NULL, NULL, NULL, 2109551, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.372579', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (607, 'Rosario', 'MA', NULL, NULL, NULL, 2109601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.373524', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (608, 'Sambaiba', 'MA', NULL, NULL, NULL, 2109700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.374298', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (609, 'Santa Filomena do Maranhao', 'MA', NULL, NULL, NULL, 2109759, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.375097', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (610, 'Santa Helena', 'MA', NULL, NULL, NULL, 2109809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.376', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (611, 'Santa Ines', 'MA', NULL, NULL, NULL, 2109908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.376926', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (612, 'Santa Luzia', 'MA', NULL, NULL, NULL, 2110005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.37791', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (613, 'Santa Luzia do Parua', 'MA', NULL, NULL, NULL, 2110039, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.378894', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (687, 'Barro Duro', 'PI', NULL, NULL, NULL, 2201408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.461037', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (614, 'Santa Quiteria do Maranhao', 'MA', NULL, NULL, NULL, 2110104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.379769', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (615, 'Santa Rita', 'MA', NULL, NULL, NULL, 2110203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.380996', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (616, 'Santana do Maranhao', 'MA', NULL, NULL, NULL, 2110237, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.381789', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (617, 'Santo Amaro do Maranhao', 'MA', NULL, NULL, NULL, 2110278, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.382757', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (618, 'Santo Antonio dos Lopes', 'MA', NULL, NULL, NULL, 2110302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.38365', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (619, 'Sao Benedito do Rio Preto', 'MA', NULL, NULL, NULL, 2110401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.384567', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (620, 'Sao Bento', 'MA', NULL, NULL, NULL, 2110500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.385444', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (621, 'Sao Bernardo', 'MA', NULL, NULL, NULL, 2110609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.386272', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (622, 'Sao Domingos do Azeitao', 'MA', NULL, NULL, NULL, 2110658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.388381', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (623, 'Sao Domingos do Maranhao', 'MA', NULL, NULL, NULL, 2110708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.395118', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (624, 'Sao Felix de Balsas', 'MA', NULL, NULL, NULL, 2110807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.39616', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (625, 'Sao Francisco do Brejao', 'MA', NULL, NULL, NULL, 2110856, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.397025', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (626, 'Sao Francisco do Maranhao', 'MA', NULL, NULL, NULL, 2110906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.398044', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (627, 'Sao Joao Batista', 'MA', NULL, NULL, NULL, 2111003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.39892', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (628, 'Sao Joao do Caru', 'MA', NULL, NULL, NULL, 2111029, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.399745', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (629, 'Sao Joao do Paraiso', 'MA', NULL, NULL, NULL, 2111052, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.400816', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (630, 'Sao Joao do Soter', 'MA', NULL, NULL, NULL, 2111078, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.401759', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (631, 'Sao Joao dos Patos', 'MA', NULL, NULL, NULL, 2111102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.402956', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (632, 'Sao Jose de Ribamar', 'MA', NULL, NULL, NULL, 2111201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.403809', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (633, 'Sao Jose dos Basilios', 'MA', NULL, NULL, NULL, 2111250, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.404643', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (634, 'Sao Luis', 'MA', NULL, NULL, NULL, 2111300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.405647', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (635, 'Sao Luis Gonzaga do Maranhao', 'MA', NULL, NULL, NULL, 2111409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.40646', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (636, 'Sao Mateus do Maranhao', 'MA', NULL, NULL, NULL, 2111508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.407324', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (637, 'Sao Pedro da Agua Branca', 'MA', NULL, NULL, NULL, 2111532, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.408245', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (638, 'Sao Pedro dos Crentes', 'MA', NULL, NULL, NULL, 2111573, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.409364', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (639, 'Sao Raimundo das Mangabeiras', 'MA', NULL, NULL, NULL, 2111607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.410289', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (640, 'Sao Raimundo do Doca Bezerra', 'MA', NULL, NULL, NULL, 2111631, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.411219', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (641, 'Sao Roberto', 'MA', NULL, NULL, NULL, 2111672, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.412187', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (642, 'Sao Vicente Ferrer', 'MA', NULL, NULL, NULL, 2111706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.413132', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (643, 'Satubinha', 'MA', NULL, NULL, NULL, 2111722, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.414213', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (644, 'Senador Alexandre Costa', 'MA', NULL, NULL, NULL, 2111748, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.41502', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (645, 'Senador La Rocque', 'MA', NULL, NULL, NULL, 2111763, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.416003', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (646, 'Serrano do Maranhao', 'MA', NULL, NULL, NULL, 2111789, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.416907', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (647, 'Sitio Novo', 'MA', NULL, NULL, NULL, 2111805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.417788', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (648, 'Sucupira do Norte', 'MA', NULL, NULL, NULL, 2111904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.418657', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (649, 'Sucupira do Riachao', 'MA', NULL, NULL, NULL, 2111953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.419524', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (650, 'Tasso Fragoso', 'MA', NULL, NULL, NULL, 2112001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.420459', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (651, 'Timbiras', 'MA', NULL, NULL, NULL, 2112100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.421346', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (652, 'Timon', 'MA', NULL, NULL, NULL, 2112209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.422227', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (653, 'Trizidela do Vale', 'MA', NULL, NULL, NULL, 2112233, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.4231', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (654, 'Tufilandia', 'MA', NULL, NULL, NULL, 2112274, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.424033', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (655, 'Tuntum', 'MA', NULL, NULL, NULL, 2112308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.425218', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (656, 'Turiacu', 'MA', NULL, NULL, NULL, 2112407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.426154', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (657, 'Turilandia', 'MA', NULL, NULL, NULL, 2112456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.426947', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (658, 'Tutoia', 'MA', NULL, NULL, NULL, 2112506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.427726', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (659, 'Urbano Santos', 'MA', NULL, NULL, NULL, 2112605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.428556', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (660, 'Vargem Grande', 'MA', NULL, NULL, NULL, 2112704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.435067', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (661, 'Viana', 'MA', NULL, NULL, NULL, 2112803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.436627', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (662, 'Vila Nova dos Martirios', 'MA', NULL, NULL, NULL, 2112852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.43748', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (663, 'Vitoria do Mearim', 'MA', NULL, NULL, NULL, 2112902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.438392', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (664, 'Vitorino Freire', 'MA', NULL, NULL, NULL, 2113009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.439218', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (665, 'Ze Doca', 'MA', NULL, NULL, NULL, 2114007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.440175', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (666, 'Acaua', 'PI', NULL, NULL, NULL, 2200053, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.441086', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (667, 'Agricolandia', 'PI', NULL, NULL, NULL, 2200103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.44202', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (668, 'Agua Branca', 'PI', NULL, NULL, NULL, 2200202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.443259', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (669, 'Alagoinha do Piaui', 'PI', NULL, NULL, NULL, 2200251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.444215', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (670, 'Alegrete do Piaui', 'PI', NULL, NULL, NULL, 2200277, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.445155', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (671, 'Alto Longa', 'PI', NULL, NULL, NULL, 2200301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.446035', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (672, 'Altos', 'PI', NULL, NULL, NULL, 2200400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.446996', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (673, 'Alvorada do Gurgueia', 'PI', NULL, NULL, NULL, 2200459, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.447826', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (674, 'Amarante', 'PI', NULL, NULL, NULL, 2200509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.448565', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (675, 'Angical do Piaui', 'PI', NULL, NULL, NULL, 2200608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.449534', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (676, 'Anisio de Abreu', 'PI', NULL, NULL, NULL, 2200707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.450473', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (677, 'Antonio Almeida', 'PI', NULL, NULL, NULL, 2200806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.451325', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (678, 'Aroazes', 'PI', NULL, NULL, NULL, 2200905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.452206', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (680, 'Arraial', 'PI', NULL, NULL, NULL, 2201002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.453937', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (681, 'Assuncao do Piaui', 'PI', NULL, NULL, NULL, 2201051, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.454994', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (682, 'Avelino Lopes', 'PI', NULL, NULL, NULL, 2201101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.455933', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (683, 'Baixa Grande do Ribeiro', 'PI', NULL, NULL, NULL, 2201150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.456842', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (685, 'Barras', 'PI', NULL, NULL, NULL, 2201200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.458843', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (686, 'Barreiras do Piaui', 'PI', NULL, NULL, NULL, 2201309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.460085', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (689, 'Bela Vista do Piaui', 'PI', NULL, NULL, NULL, 2201556, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.462988', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (690, 'Belem do Piaui', 'PI', NULL, NULL, NULL, 2201572, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.463815', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (691, 'Beneditinos', 'PI', NULL, NULL, NULL, 2201606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.464727', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (692, 'Bertolinia', 'PI', NULL, NULL, NULL, 2201705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.465651', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (693, 'Betania do Piaui', 'PI', NULL, NULL, NULL, 2201739, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.466532', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (694, 'Boa Hora', 'PI', NULL, NULL, NULL, 2201770, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.467333', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (695, 'Bocaina', 'PI', NULL, NULL, NULL, 2201804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.468202', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (696, 'Bom Jesus', 'PI', NULL, NULL, NULL, 2201903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.469091', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (697, 'Bom Principio do Piaui', 'PI', NULL, NULL, NULL, 2201919, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.476209', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (698, 'Bonfim do Piaui', 'PI', NULL, NULL, NULL, 2201929, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.477453', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (699, 'Boqueirao do Piaui', 'PI', NULL, NULL, NULL, 2201945, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.478284', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (700, 'Brasileira', 'PI', NULL, NULL, NULL, 2201960, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.479141', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (701, 'Brejo do Piaui', 'PI', NULL, NULL, NULL, 2201988, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.479943', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (702, 'Buriti dos Lopes', 'PI', NULL, NULL, NULL, 2202000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.481156', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (703, 'Buriti dos Montes', 'PI', NULL, NULL, NULL, 2202026, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.481975', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (704, 'Cabeceiras do Piaui', 'PI', NULL, NULL, NULL, 2202059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.482873', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (705, 'Cajazeiras do Piaui', 'PI', NULL, NULL, NULL, 2202075, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.483761', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (706, 'Cajueiro da Praia', 'PI', NULL, NULL, NULL, 2202083, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.484708', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (707, 'Caldeirao Grande do Piaui', 'PI', NULL, NULL, NULL, 2202091, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.485653', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (708, 'Campinas do Piaui', 'PI', NULL, NULL, NULL, 2202109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.4866', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (709, 'Campo Alegre do Fidalgo', 'PI', NULL, NULL, NULL, 2202117, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.487558', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (710, 'Campo Grande do Piaui', 'PI', NULL, NULL, NULL, 2202133, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.488623', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (711, 'Campo Largo do Piaui', 'PI', NULL, NULL, NULL, 2202174, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.489554', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (712, 'Campo Maior', 'PI', NULL, NULL, NULL, 2202208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.490426', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (713, 'Canavieira', 'PI', NULL, NULL, NULL, 2202251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.491345', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (714, 'Canto do Buriti', 'PI', NULL, NULL, NULL, 2202307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.492473', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (715, 'Capitao de Campos', 'PI', NULL, NULL, NULL, 2202406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.493449', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (716, 'Capitao Gervasio Oliveira', 'PI', NULL, NULL, NULL, 2202455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.49426', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (717, 'Caracol', 'PI', NULL, NULL, NULL, 2202505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.495011', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (718, 'Caraubas do Piaui', 'PI', NULL, NULL, NULL, 2202539, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.495894', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (719, 'Caridade do Piaui', 'PI', NULL, NULL, NULL, 2202554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.496798', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (720, 'Castelo do Piaui', 'PI', NULL, NULL, NULL, 2202604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.49769', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (721, 'Caxingo', 'PI', NULL, NULL, NULL, 2202653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.498551', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (722, 'Cocal', 'PI', NULL, NULL, NULL, 2202703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.49945', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (723, 'Cocal de Telha', 'PI', NULL, NULL, NULL, 2202711, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.500365', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (724, 'Cocal dos Alves', 'PI', NULL, NULL, NULL, 2202729, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.501178', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (725, 'Coivaras', 'PI', NULL, NULL, NULL, 2202737, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.50203', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (726, 'Colonia do Gurgueia', 'PI', NULL, NULL, NULL, 2202752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.502948', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (727, 'Colonia do Piaui', 'PI', NULL, NULL, NULL, 2202778, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.503724', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (728, 'Conceicao do Caninde', 'PI', NULL, NULL, NULL, 2202802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.504605', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (729, 'Coronel Jose Dias', 'PI', NULL, NULL, NULL, 2202851, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.50551', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (730, 'Corrente', 'PI', NULL, NULL, NULL, 2202901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.506368', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (731, 'Cristalandia do Piaui', 'PI', NULL, NULL, NULL, 2203008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.507245', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (732, 'Cristino Castro', 'PI', NULL, NULL, NULL, 2203107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.508161', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (733, 'Curimata', 'PI', NULL, NULL, NULL, 2203206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.509093', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (734, 'Currais', 'PI', NULL, NULL, NULL, 2203230, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.509915', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (736, 'Curralinhos', 'PI', NULL, NULL, NULL, 2203255, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.517649', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (735, 'Curral Novo do Piaui', 'PI', NULL, NULL, NULL, 2203271, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.516478', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (737, 'Demerval Lobao', 'PI', NULL, NULL, NULL, 2203305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.518747', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (738, 'Dirceu Arcoverde', 'PI', NULL, NULL, NULL, 2203354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.519566', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (739, 'Dom Expedito Lopes', 'PI', NULL, NULL, NULL, 2203404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.520463', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (741, 'Domingos Mourao', 'PI', NULL, NULL, NULL, 2203420, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.522', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (740, 'Dom Inocencio', 'PI', NULL, NULL, NULL, 2203453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.521277', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (742, 'Elesbao Veloso', 'PI', NULL, NULL, NULL, 2203503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.522894', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (743, 'Eliseu Martins', 'PI', NULL, NULL, NULL, 2203602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.52379', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (744, 'Esperantina', 'PI', NULL, NULL, NULL, 2203701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.524652', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (745, 'Fartura do Piaui', 'PI', NULL, NULL, NULL, 2203750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.526063', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (746, 'Flores do Piaui', 'PI', NULL, NULL, NULL, 2203800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.527005', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (747, 'Floresta do Piaui', 'PI', NULL, NULL, NULL, 2203859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.527865', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (748, 'Floriano', 'PI', NULL, NULL, NULL, 2203909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.528733', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (749, 'Francinopolis', 'PI', NULL, NULL, NULL, 2204006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.529749', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (750, 'Francisco Ayres', 'PI', NULL, NULL, NULL, 2204105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.530678', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (751, 'Francisco Macedo', 'PI', NULL, NULL, NULL, 2204154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.531546', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (752, 'Francisco Santos', 'PI', NULL, NULL, NULL, 2204204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.532468', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (753, 'Fronteiras', 'PI', NULL, NULL, NULL, 2204303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.533279', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (754, 'Geminiano', 'PI', NULL, NULL, NULL, 2204352, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.534092', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (755, 'Gilbues', 'PI', NULL, NULL, NULL, 2204402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.535027', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (756, 'Guadalupe', 'PI', NULL, NULL, NULL, 2204501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.535945', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (757, 'Guaribas', 'PI', NULL, NULL, NULL, 2204550, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.536987', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (758, 'Hugo Napoleao', 'PI', NULL, NULL, NULL, 2204600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.53787', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (759, 'Ilha Grande', 'PI', NULL, NULL, NULL, 2204659, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.538744', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (760, 'Inhuma', 'PI', NULL, NULL, NULL, 2204709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.539664', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (761, 'Ipiranga do Piaui', 'PI', NULL, NULL, NULL, 2204808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.540631', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (762, 'Isaias Coelho', 'PI', NULL, NULL, NULL, 2204907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.541589', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (763, 'Itainopolis', 'PI', NULL, NULL, NULL, 2205003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.54226', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (764, 'Itaueira', 'PI', NULL, NULL, NULL, 2205102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.543208', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (765, 'Jacobina do Piaui', 'PI', NULL, NULL, NULL, 2205151, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.544013', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (766, 'Jaicos', 'PI', NULL, NULL, NULL, 2205201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.544932', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (767, 'Jardim do Mulato', 'PI', NULL, NULL, NULL, 2205250, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.545843', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (768, 'Jatoba do Piaui', 'PI', NULL, NULL, NULL, 2205276, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.546727', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (769, 'Jerumenha', 'PI', NULL, NULL, NULL, 2205300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.547582', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (770, 'Joao Costa', 'PI', NULL, NULL, NULL, 2205359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.548411', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (771, 'Joaquim Pires', 'PI', NULL, NULL, NULL, 2205409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.549224', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (772, 'Joca Marques', 'PI', NULL, NULL, NULL, 2205458, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.550172', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (773, 'Jose de Freitas', 'PI', NULL, NULL, NULL, 2205508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.557', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (774, 'Juazeiro do Piaui', 'PI', NULL, NULL, NULL, 2205516, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.558345', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (775, 'Julio Borges', 'PI', NULL, NULL, NULL, 2205524, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.559238', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (776, 'Jurema', 'PI', NULL, NULL, NULL, 2205532, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.560161', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (782, 'Lagoinha do Piaui', 'PI', NULL, NULL, NULL, 2205540, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.565646', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (777, 'Lagoa Alegre', 'PI', NULL, NULL, NULL, 2205557, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.561061', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (779, 'Lagoa do Barro do Piaui', 'PI', NULL, NULL, NULL, 2205565, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.56292', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (778, 'Lagoa de Sao Francisco', 'PI', NULL, NULL, NULL, 2205573, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.562032', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (780, 'Lagoa do Piaui', 'PI', NULL, NULL, NULL, 2205581, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.56385', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (781, 'Lagoa do Sitio', 'PI', NULL, NULL, NULL, 2205599, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.56476', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (783, 'Landri Sales', 'PI', NULL, NULL, NULL, 2205607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.566526', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (784, 'Luis Correia', 'PI', NULL, NULL, NULL, 2205706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.567389', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (785, 'Luzilandia', 'PI', NULL, NULL, NULL, 2205805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.568333', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (786, 'Madeiro', 'PI', NULL, NULL, NULL, 2205854, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.569282', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (787, 'Manoel Emidio', 'PI', NULL, NULL, NULL, 2205904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.57028', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (788, 'Marcolandia', 'PI', NULL, NULL, NULL, 2205953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.571109', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (789, 'Marcos Parente', 'PI', NULL, NULL, NULL, 2206001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.571924', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (790, 'Massape do Piaui', 'PI', NULL, NULL, NULL, 2206050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.572792', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (791, 'Matias Olimpio', 'PI', NULL, NULL, NULL, 2206100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.573727', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (792, 'Miguel Alves', 'PI', NULL, NULL, NULL, 2206209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.574699', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (793, 'Miguel Leao', 'PI', NULL, NULL, NULL, 2206308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.575592', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (794, 'Milton Brandao', 'PI', NULL, NULL, NULL, 2206357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.576731', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (795, 'Monsenhor Gil', 'PI', NULL, NULL, NULL, 2206407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.577659', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (796, 'Monsenhor Hipolito', 'PI', NULL, NULL, NULL, 2206506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.578489', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (797, 'Monte Alegre do Piaui', 'PI', NULL, NULL, NULL, 2206605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.579329', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (798, 'Morro Cabeca No Tempo', 'PI', NULL, NULL, NULL, 2206654, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.580308', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (799, 'Morro do Chapeu do Piaui', 'PI', NULL, NULL, NULL, 2206670, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.581572', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (800, 'Murici dos Portelas', 'PI', NULL, NULL, NULL, 2206696, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.582369', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (801, 'Nazare do Piaui', 'PI', NULL, NULL, NULL, 2206704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.583261', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (803, 'Nossa Senhora de Nazare', 'PI', NULL, NULL, NULL, 2206753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.585035', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (804, 'Nossa Senhora dos Remedios', 'PI', NULL, NULL, NULL, 2206803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.585913', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (806, 'Novo Oriente do Piaui', 'PI', NULL, NULL, NULL, 2206902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.587703', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (807, 'Novo Santo Antonio', 'PI', NULL, NULL, NULL, 2206951, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.588561', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (808, 'Oeiras', 'PI', NULL, NULL, NULL, 2207009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.58949', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (810, 'Padre Marcos', 'PI', NULL, NULL, NULL, 2207207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.591217', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (811, 'Paes Landim', 'PI', NULL, NULL, NULL, 2207306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.592557', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (812, 'Pajeu do Piaui', 'PI', NULL, NULL, NULL, 2207355, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.598809', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (813, 'Palmeira do Piaui', 'PI', NULL, NULL, NULL, 2207405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.599731', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (814, 'Palmeirais', 'PI', NULL, NULL, NULL, 2207504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.600651', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (815, 'Paqueta', 'PI', NULL, NULL, NULL, 2207553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.601586', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (816, 'Parnagua', 'PI', NULL, NULL, NULL, 2207603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.603105', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (817, 'Parnaiba', 'PI', NULL, NULL, NULL, 2207702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.603974', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (818, 'Passagem Franca do Piaui', 'PI', NULL, NULL, NULL, 2207751, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.604851', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (819, 'Patos do Piaui', 'PI', NULL, NULL, NULL, 2207777, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.605756', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (820, 'Pau D''arco do Piaui', 'PI', NULL, NULL, NULL, 2207793, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.606727', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (821, 'Paulistana', 'PI', NULL, NULL, NULL, 2207801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.607612', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (822, 'Pavussu', 'PI', NULL, NULL, NULL, 2207850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.608647', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (823, 'Pedro Ii', 'PI', NULL, NULL, NULL, 2207900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.609674', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (824, 'Pedro Laurentino', 'PI', NULL, NULL, NULL, 2207934, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.610587', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (805, 'Nova Santa Rita', 'PI', NULL, NULL, NULL, 2207959, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.58681', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (825, 'Picos', 'PI', NULL, NULL, NULL, 2208007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.611502', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (826, 'Pimenteiras', 'PI', NULL, NULL, NULL, 2208106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.61237', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (827, 'Pio Ix', 'PI', NULL, NULL, NULL, 2208205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.61325', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (828, 'Piracuruca', 'PI', NULL, NULL, NULL, 2208304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.6142', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (829, 'Piripiri', 'PI', NULL, NULL, NULL, 2208403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.615071', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (830, 'Porto', 'PI', NULL, NULL, NULL, 2208502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.616029', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (831, 'Porto Alegre do Piaui', 'PI', NULL, NULL, NULL, 2208551, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.617018', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (832, 'Prata do Piaui', 'PI', NULL, NULL, NULL, 2208601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.617877', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (833, 'Queimada Nova', 'PI', NULL, NULL, NULL, 2208650, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.618689', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (834, 'Redencao do Gurgueia', 'PI', NULL, NULL, NULL, 2208700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.619662', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (835, 'Regeneracao', 'PI', NULL, NULL, NULL, 2208809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.620619', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (836, 'Riacho Frio', 'PI', NULL, NULL, NULL, 2208858, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.621548', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (837, 'Ribeira do Piaui', 'PI', NULL, NULL, NULL, 2208874, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.62253', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (838, 'Ribeiro Goncalves', 'PI', NULL, NULL, NULL, 2208908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.623518', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (839, 'Rio Grande do Piaui', 'PI', NULL, NULL, NULL, 2209005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.624477', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (840, 'Santa Cruz do Piaui', 'PI', NULL, NULL, NULL, 2209104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.625541', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (841, 'Santa Cruz dos Milagres', 'PI', NULL, NULL, NULL, 2209153, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.626406', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (842, 'Santa Filomena', 'PI', NULL, NULL, NULL, 2209203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.627271', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (843, 'Santa Luz', 'PI', NULL, NULL, NULL, 2209302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.628246', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (845, 'Santana do Piaui', 'PI', NULL, NULL, NULL, 2209351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.630097', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (844, 'Santa Rosa do Piaui', 'PI', NULL, NULL, NULL, 2209377, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.629172', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (846, 'Santo Antonio de Lisboa', 'PI', NULL, NULL, NULL, 2209401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.630983', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (847, 'Santo Antonio dos Milagres', 'PI', NULL, NULL, NULL, 2209450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.631953', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (848, 'Santo Inacio do Piaui', 'PI', NULL, NULL, NULL, 2209500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.638737', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (849, 'Sao Braz do Piaui', 'PI', NULL, NULL, NULL, 2209559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.640018', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (850, 'Sao Felix do Piaui', 'PI', NULL, NULL, NULL, 2209609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.641003', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (851, 'Sao Francisco de Assis do Piaui', 'PI', NULL, NULL, NULL, 2209658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.641974', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (852, 'Sao Francisco do Piaui', 'PI', NULL, NULL, NULL, 2209708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.642905', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (853, 'Sao Goncalo do Gurgueia', 'PI', NULL, NULL, NULL, 2209757, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.643859', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (854, 'Sao Goncalo do Piaui', 'PI', NULL, NULL, NULL, 2209807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.644778', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (855, 'Sao Joao da Canabrava', 'PI', NULL, NULL, NULL, 2209856, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.645729', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (856, 'Sao Joao da Fronteira', 'PI', NULL, NULL, NULL, 2209872, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.646746', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (857, 'Sao Joao da Serra', 'PI', NULL, NULL, NULL, 2209906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.64776', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (858, 'Sao Joao da Varjota', 'PI', NULL, NULL, NULL, 2209955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.648584', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (859, 'Sao Joao do Arraial', 'PI', NULL, NULL, NULL, 2209971, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.649445', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (860, 'Sao Joao do Piaui', 'PI', NULL, NULL, NULL, 2210003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.65029', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (861, 'Sao Jose do Divino', 'PI', NULL, NULL, NULL, 2210052, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.65123', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (862, 'Sao Jose do Peixe', 'PI', NULL, NULL, NULL, 2210102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.652159', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (863, 'Sao Jose do Piaui', 'PI', NULL, NULL, NULL, 2210201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.653052', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (864, 'Sao Juliao', 'PI', NULL, NULL, NULL, 2210300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.654041', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (865, 'Sao Lourenco do Piaui', 'PI', NULL, NULL, NULL, 2210359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.654978', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (866, 'Sao Luis do Piaui', 'PI', NULL, NULL, NULL, 2210375, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.655997', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (867, 'Sao Miguel da Baixa Grande', 'PI', NULL, NULL, NULL, 2210383, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.656848', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (868, 'Sao Miguel do Fidalgo', 'PI', NULL, NULL, NULL, 2210391, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.657708', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (869, 'Sao Miguel do Tapuio', 'PI', NULL, NULL, NULL, 2210409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.658591', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (870, 'Sao Pedro do Piaui', 'PI', NULL, NULL, NULL, 2210508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.659708', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (871, 'Sao Raimundo Nonato', 'PI', NULL, NULL, NULL, 2210607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.660725', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (872, 'Sebastiao Barros', 'PI', NULL, NULL, NULL, 2210623, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.661633', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (873, 'Sebastiao Leal', 'PI', NULL, NULL, NULL, 2210631, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.662743', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (874, 'Sigefredo Pacheco', 'PI', NULL, NULL, NULL, 2210656, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.663614', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (875, 'Simoes', 'PI', NULL, NULL, NULL, 2210706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.664475', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (876, 'Simplicio Mendes', 'PI', NULL, NULL, NULL, 2210805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.665361', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (877, 'Socorro do Piaui', 'PI', NULL, NULL, NULL, 2210904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.666288', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (878, 'Sussuapara', 'PI', NULL, NULL, NULL, 2210938, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.667165', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (879, 'Tamboril do Piaui', 'PI', NULL, NULL, NULL, 2210953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.668103', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (880, 'Tanque do Piaui', 'PI', NULL, NULL, NULL, 2210979, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.669016', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (881, 'Teresina', 'PI', NULL, NULL, NULL, 2211001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.670074', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (882, 'Uniao', 'PI', NULL, NULL, NULL, 2211100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.670865', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (883, 'Urucui', 'PI', NULL, NULL, NULL, 2211209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.671796', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (884, 'Valenca do Piaui', 'PI', NULL, NULL, NULL, 2211308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.67261', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (885, 'Varzea Branca', 'PI', NULL, NULL, NULL, 2211357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.679609', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (886, 'Varzea Grande', 'PI', NULL, NULL, NULL, 2211407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.680844', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (887, 'Vera Mendes', 'PI', NULL, NULL, NULL, 2211506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.681873', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (888, 'Vila Nova do Piaui', 'PI', NULL, NULL, NULL, 2211605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.68279', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (889, 'Wall Ferraz', 'PI', NULL, NULL, NULL, 2211704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.683613', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (890, 'Abaiara', 'CE', NULL, NULL, NULL, 2300101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.684498', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (891, 'Acarape', 'CE', NULL, NULL, NULL, 2300150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.685459', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (892, 'Acarau', 'CE', NULL, NULL, NULL, 2300200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.686316', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (893, 'Acopiara', 'CE', NULL, NULL, NULL, 2300309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.687319', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (894, 'Aiuaba', 'CE', NULL, NULL, NULL, 2300408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.688458', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (895, 'Alcantaras', 'CE', NULL, NULL, NULL, 2300507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.68946', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (896, 'Altaneira', 'CE', NULL, NULL, NULL, 2300606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.690345', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (897, 'Alto Santo', 'CE', NULL, NULL, NULL, 2300705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.691214', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (898, 'Amontada', 'CE', NULL, NULL, NULL, 2300754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.692091', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (899, 'Antonina do Norte', 'CE', NULL, NULL, NULL, 2300804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.693258', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (900, 'Apuiares', 'CE', NULL, NULL, NULL, 2300903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.69425', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (901, 'Aquiraz', 'CE', NULL, NULL, NULL, 2301000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.695167', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (902, 'Aracati', 'CE', NULL, NULL, NULL, 2301109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.69614', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (903, 'Aracoiaba', 'CE', NULL, NULL, NULL, 2301208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.69696', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (904, 'Ararenda', 'CE', NULL, NULL, NULL, 2301257, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.697861', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (905, 'Araripe', 'CE', NULL, NULL, NULL, 2301307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.698832', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (906, 'Aratuba', 'CE', NULL, NULL, NULL, 2301406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.69974', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (907, 'Arneiroz', 'CE', NULL, NULL, NULL, 2301505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.700663', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (908, 'Assare', 'CE', NULL, NULL, NULL, 2301604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.701591', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (909, 'Aurora', 'CE', NULL, NULL, NULL, 2301703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.702351', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (910, 'Baixio', 'CE', NULL, NULL, NULL, 2301802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.703411', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (911, 'Banabuiu', 'CE', NULL, NULL, NULL, 2301851, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.704293', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (912, 'Barbalha', 'CE', NULL, NULL, NULL, 2301901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.705191', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (913, 'Barreira', 'CE', NULL, NULL, NULL, 2301950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.706139', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (914, 'Barro', 'CE', NULL, NULL, NULL, 2302008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.707138', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (915, 'Barroquinha', 'CE', NULL, NULL, NULL, 2302057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.708104', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (916, 'Baturite', 'CE', NULL, NULL, NULL, 2302107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.70905', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (917, 'Beberibe', 'CE', NULL, NULL, NULL, 2302206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.71002', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (918, 'Bela Cruz', 'CE', NULL, NULL, NULL, 2302305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.710898', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (919, 'Boa Viagem', 'CE', NULL, NULL, NULL, 2302404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.711755', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (920, 'Brejo Santo', 'CE', NULL, NULL, NULL, 2302503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.712556', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (921, 'Camocim', 'CE', NULL, NULL, NULL, 2302602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.713478', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (922, 'Campos Sales', 'CE', NULL, NULL, NULL, 2302701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.720078', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (923, 'Caninde', 'CE', NULL, NULL, NULL, 2302800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.721176', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (924, 'Capistrano', 'CE', NULL, NULL, NULL, 2302909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.722137', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (925, 'Caridade', 'CE', NULL, NULL, NULL, 2303006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.723051', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (926, 'Carire', 'CE', NULL, NULL, NULL, 2303105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.724031', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (927, 'Caririacu', 'CE', NULL, NULL, NULL, 2303204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.725002', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (928, 'Carius', 'CE', NULL, NULL, NULL, 2303303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.72603', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (929, 'Carnaubal', 'CE', NULL, NULL, NULL, 2303402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.726882', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (930, 'Cascavel', 'CE', NULL, NULL, NULL, 2303501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.72791', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (931, 'Catarina', 'CE', NULL, NULL, NULL, 2303600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.728846', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (932, 'Catunda', 'CE', NULL, NULL, NULL, 2303659, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.72975', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (933, 'Caucaia', 'CE', NULL, NULL, NULL, 2303709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.73058', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (934, 'Cedro', 'CE', NULL, NULL, NULL, 2303808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.731508', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (935, 'Chaval', 'CE', NULL, NULL, NULL, 2303907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.732465', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (936, 'Choro', 'CE', NULL, NULL, NULL, 2303931, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.733347', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (937, 'Chorozinho', 'CE', NULL, NULL, NULL, 2303956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.734151', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (938, 'Coreau', 'CE', NULL, NULL, NULL, 2304004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.735038', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (939, 'Crateus', 'CE', NULL, NULL, NULL, 2304103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.735982', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (940, 'Crato', 'CE', NULL, NULL, NULL, 2304202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.736982', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (941, 'Croata', 'CE', NULL, NULL, NULL, 2304236, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.73788', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (942, 'Cruz', 'CE', NULL, NULL, NULL, 2304251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.738764', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (943, 'Deputado Irapuan Pinheiro', 'CE', NULL, NULL, NULL, 2304269, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.739701', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (944, 'Erere', 'CE', NULL, NULL, NULL, 2304277, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.740766', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (945, 'Eusebio', 'CE', NULL, NULL, NULL, 2304285, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.741714', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (946, 'Farias Brito', 'CE', NULL, NULL, NULL, 2304301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.742725', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (947, 'Forquilha', 'CE', NULL, NULL, NULL, 2304350, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.743617', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (948, 'Fortaleza', 'CE', NULL, NULL, NULL, 2304400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.744504', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (949, 'Fortim', 'CE', NULL, NULL, NULL, 2304459, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.74536', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (950, 'Frecheirinha', 'CE', NULL, NULL, NULL, 2304509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.7463', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (951, 'General Sampaio', 'CE', NULL, NULL, NULL, 2304608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.747206', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (952, 'Graca', 'CE', NULL, NULL, NULL, 2304657, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.748217', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (953, 'Granja', 'CE', NULL, NULL, NULL, 2304707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.74904', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (954, 'Granjeiro', 'CE', NULL, NULL, NULL, 2304806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.749942', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (955, 'Groairas', 'CE', NULL, NULL, NULL, 2304905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.750947', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (956, 'Guaiuba', 'CE', NULL, NULL, NULL, 2304954, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.751904', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (957, 'Guaraciaba do Norte', 'CE', NULL, NULL, NULL, 2305001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.752745', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (958, 'Guaramiranga', 'CE', NULL, NULL, NULL, 2305100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.753708', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (959, 'Hidrolandia', 'CE', NULL, NULL, NULL, 2305209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.760735', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (960, 'Horizonte', 'CE', NULL, NULL, NULL, 2305233, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.761924', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (961, 'Ibaretama', 'CE', NULL, NULL, NULL, 2305266, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.762867', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (962, 'Ibiapina', 'CE', NULL, NULL, NULL, 2305308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.763788', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (963, 'Ibicuitinga', 'CE', NULL, NULL, NULL, 2305332, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.764672', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (964, 'Icapui', 'CE', NULL, NULL, NULL, 2305357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.765576', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (965, 'Ico', 'CE', NULL, NULL, NULL, 2305407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.76682', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (966, 'Iguatu', 'CE', NULL, NULL, NULL, 2305506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.767721', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (967, 'Independencia', 'CE', NULL, NULL, NULL, 2305605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.768666', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (968, 'Ipaporanga', 'CE', NULL, NULL, NULL, 2305654, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.769582', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (969, 'Ipaumirim', 'CE', NULL, NULL, NULL, 2305704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.770486', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (970, 'Ipu', 'CE', NULL, NULL, NULL, 2305803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.771489', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (971, 'Ipueiras', 'CE', NULL, NULL, NULL, 2305902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.772507', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (972, 'Iracema', 'CE', NULL, NULL, NULL, 2306009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.773512', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (973, 'Iraucuba', 'CE', NULL, NULL, NULL, 2306108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.774468', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (974, 'Itaicaba', 'CE', NULL, NULL, NULL, 2306207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.77543', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (975, 'Itaitinga', 'CE', NULL, NULL, NULL, 2306256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.77631', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (977, 'Itapipoca', 'CE', NULL, NULL, NULL, 2306405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.778328', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (978, 'Itapiuna', 'CE', NULL, NULL, NULL, 2306504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.779217', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (979, 'Itarema', 'CE', NULL, NULL, NULL, 2306553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.780134', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (980, 'Itatira', 'CE', NULL, NULL, NULL, 2306603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.781004', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (981, 'Jaguaretama', 'CE', NULL, NULL, NULL, 2306702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.781931', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (982, 'Jaguaribara', 'CE', NULL, NULL, NULL, 2306801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.782755', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (983, 'Jaguaribe', 'CE', NULL, NULL, NULL, 2306900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.783553', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (984, 'Jaguaruana', 'CE', NULL, NULL, NULL, 2307007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.784418', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (985, 'Jardim', 'CE', NULL, NULL, NULL, 2307106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.785258', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (986, 'Jati', 'CE', NULL, NULL, NULL, 2307205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.786168', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (987, 'Jijoca de Jericoacoara', 'CE', NULL, NULL, NULL, 2307254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.787039', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (988, 'Juazeiro do Norte', 'CE', NULL, NULL, NULL, 2307304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.787963', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (989, 'Jucas', 'CE', NULL, NULL, NULL, 2307403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.788883', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (990, 'Lavras da Mangabeira', 'CE', NULL, NULL, NULL, 2307502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.789684', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (991, 'Limoeiro do Norte', 'CE', NULL, NULL, NULL, 2307601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.790614', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (992, 'Madalena', 'CE', NULL, NULL, NULL, 2307635, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.791485', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (993, 'Maracanau', 'CE', NULL, NULL, NULL, 2307650, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.79239', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (994, 'Maranguape', 'CE', NULL, NULL, NULL, 2307700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.793456', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (995, 'Marco', 'CE', NULL, NULL, NULL, 2307809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.794381', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (996, 'Martinopole', 'CE', NULL, NULL, NULL, 2307908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.801277', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (997, 'Massape', 'CE', NULL, NULL, NULL, 2308005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.802543', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (998, 'Mauriti', 'CE', NULL, NULL, NULL, 2308104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.805558', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (999, 'Meruoca', 'CE', NULL, NULL, NULL, 2308203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.806559', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1000, 'Milagres', 'CE', NULL, NULL, NULL, 2308302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.80731', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1001, 'Milha', 'CE', NULL, NULL, NULL, 2308351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.808353', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1002, 'Miraima', 'CE', NULL, NULL, NULL, 2308377, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.809236', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1003, 'Missao Velha', 'CE', NULL, NULL, NULL, 2308401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.810299', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1004, 'Mombaca', 'CE', NULL, NULL, NULL, 2308500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.811154', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1005, 'Monsenhor Tabosa', 'CE', NULL, NULL, NULL, 2308609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.81203', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1006, 'Morada Nova', 'CE', NULL, NULL, NULL, 2308708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.812903', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1007, 'Moraujo', 'CE', NULL, NULL, NULL, 2308807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.81377', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1008, 'Morrinhos', 'CE', NULL, NULL, NULL, 2308906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.814722', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1009, 'Mucambo', 'CE', NULL, NULL, NULL, 2309003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.815781', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1010, 'Mulungu', 'CE', NULL, NULL, NULL, 2309102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.816724', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1011, 'Nova Olinda', 'CE', NULL, NULL, NULL, 2309201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.817636', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1012, 'Nova Russas', 'CE', NULL, NULL, NULL, 2309300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.81856', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1013, 'Novo Oriente', 'CE', NULL, NULL, NULL, 2309409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.819509', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1014, 'Ocara', 'CE', NULL, NULL, NULL, 2309458, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.820449', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1015, 'Oros', 'CE', NULL, NULL, NULL, 2309508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.821307', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1016, 'Pacajus', 'CE', NULL, NULL, NULL, 2309607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.822177', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1017, 'Pacatuba', 'CE', NULL, NULL, NULL, 2309706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.823119', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1018, 'Pacoti', 'CE', NULL, NULL, NULL, 2309805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.823944', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1019, 'Pacuja', 'CE', NULL, NULL, NULL, 2309904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.824879', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1020, 'Palhano', 'CE', NULL, NULL, NULL, 2310001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.825848', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1021, 'Palmacia', 'CE', NULL, NULL, NULL, 2310100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.826961', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1022, 'Paracuru', 'CE', NULL, NULL, NULL, 2310209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.827911', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1023, 'Paraipaba', 'CE', NULL, NULL, NULL, 2310258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.828797', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1024, 'Parambu', 'CE', NULL, NULL, NULL, 2310308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.829733', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1025, 'Paramoti', 'CE', NULL, NULL, NULL, 2310407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.830639', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1026, 'Pedra Branca', 'CE', NULL, NULL, NULL, 2310506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.831545', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1027, 'Penaforte', 'CE', NULL, NULL, NULL, 2310605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.832489', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1028, 'Pentecoste', 'CE', NULL, NULL, NULL, 2310704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.83333', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1029, 'Pereiro', 'CE', NULL, NULL, NULL, 2310803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.834139', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1030, 'Pindoretama', 'CE', NULL, NULL, NULL, 2310852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.835062', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1031, 'Piquet Carneiro', 'CE', NULL, NULL, NULL, 2310902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.842709', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1032, 'Pires Ferreira', 'CE', NULL, NULL, NULL, 2310951, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.843807', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1033, 'Poranga', 'CE', NULL, NULL, NULL, 2311009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.844903', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1034, 'Porteiras', 'CE', NULL, NULL, NULL, 2311108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.846084', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1035, 'Potengi', 'CE', NULL, NULL, NULL, 2311207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.847051', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1036, 'Potiretama', 'CE', NULL, NULL, NULL, 2311231, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.848016', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1037, 'Quiterianopolis', 'CE', NULL, NULL, NULL, 2311264, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.849214', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1038, 'Quixada', 'CE', NULL, NULL, NULL, 2311306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.850112', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1039, 'Quixelo', 'CE', NULL, NULL, NULL, 2311355, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.851035', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1040, 'Quixeramobim', 'CE', NULL, NULL, NULL, 2311405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.851966', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1041, 'Quixere', 'CE', NULL, NULL, NULL, 2311504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.852901', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1042, 'Redencao', 'CE', NULL, NULL, NULL, 2311603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.853907', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1043, 'Reriutaba', 'CE', NULL, NULL, NULL, 2311702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.855028', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1044, 'Russas', 'CE', NULL, NULL, NULL, 2311801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.85597', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1045, 'Saboeiro', 'CE', NULL, NULL, NULL, 2311900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.856853', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1046, 'Salitre', 'CE', NULL, NULL, NULL, 2311959, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.857981', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1048, 'Santana do Acarau', 'CE', NULL, NULL, NULL, 2312007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.85981', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1049, 'Santana do Cariri', 'CE', NULL, NULL, NULL, 2312106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.860708', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1047, 'Santa Quiteria', 'CE', NULL, NULL, NULL, 2312205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.858908', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1050, 'Sao Benedito', 'CE', NULL, NULL, NULL, 2312304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.861601', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1051, 'Sao Goncalo do Amarante', 'CE', NULL, NULL, NULL, 2312403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.862529', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1052, 'Sao Joao do Jaguaribe', 'CE', NULL, NULL, NULL, 2312502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.863447', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1053, 'Sao Luis do Curu', 'CE', NULL, NULL, NULL, 2312601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.864358', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1054, 'Senador Pompeu', 'CE', NULL, NULL, NULL, 2312700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.865343', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1055, 'Senador Sa', 'CE', NULL, NULL, NULL, 2312809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.866271', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1056, 'Sobral', 'CE', NULL, NULL, NULL, 2312908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.86725', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1057, 'Solonopole', 'CE', NULL, NULL, NULL, 2313005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.868244', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1058, 'Tabuleiro do Norte', 'CE', NULL, NULL, NULL, 2313104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.869195', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1059, 'Tamboril', 'CE', NULL, NULL, NULL, 2313203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.87011', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1060, 'Tarrafas', 'CE', NULL, NULL, NULL, 2313252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.871112', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1061, 'Taua', 'CE', NULL, NULL, NULL, 2313302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.872086', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1062, 'Tejucuoca', 'CE', NULL, NULL, NULL, 2313351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.873195', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1063, 'Tiangua', 'CE', NULL, NULL, NULL, 2313401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.874116', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1064, 'Trairi', 'CE', NULL, NULL, NULL, 2313500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.875052', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1065, 'Tururu', 'CE', NULL, NULL, NULL, 2313559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.875935', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1066, 'Ubajara', 'CE', NULL, NULL, NULL, 2313609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.883523', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1067, 'Umari', 'CE', NULL, NULL, NULL, 2313708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.884695', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1068, 'Umirim', 'CE', NULL, NULL, NULL, 2313757, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.885677', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1069, 'Uruburetama', 'CE', NULL, NULL, NULL, 2313807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.886516', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1070, 'Uruoca', 'CE', NULL, NULL, NULL, 2313906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.887569', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1071, 'Varjota', 'CE', NULL, NULL, NULL, 2313955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.88856', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1072, 'Varzea Alegre', 'CE', NULL, NULL, NULL, 2314003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.889456', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1073, 'Vicosa do Ceara', 'CE', NULL, NULL, NULL, 2314102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.890355', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1074, 'Acari', 'RN', NULL, NULL, NULL, 2400109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.891402', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1075, 'Acu', 'RN', NULL, NULL, NULL, 2400208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.892249', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1076, 'Afonso Bezerra', 'RN', NULL, NULL, NULL, 2400307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.893143', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1077, 'Agua Nova', 'RN', NULL, NULL, NULL, 2400406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.894078', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1078, 'Alexandria', 'RN', NULL, NULL, NULL, 2400505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.895039', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1079, 'Almino Afonso', 'RN', NULL, NULL, NULL, 2400604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.895926', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1080, 'Alto do Rodrigues', 'RN', NULL, NULL, NULL, 2400703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.896798', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1081, 'Angicos', 'RN', NULL, NULL, NULL, 2400802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.897649', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1082, 'Antonio Martins', 'RN', NULL, NULL, NULL, 2400901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.898468', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1083, 'Apodi', 'RN', NULL, NULL, NULL, 2401008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.899511', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1084, 'Areia Branca', 'RN', NULL, NULL, NULL, 2401107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.900457', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1085, 'Ares', 'RN', NULL, NULL, NULL, 2401206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.901317', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1086, 'Augusto Severo', 'RN', NULL, NULL, NULL, 2401305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.902303', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1087, 'Baia Formosa', 'RN', NULL, NULL, NULL, 2401404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.903218', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1088, 'Barauna', 'RN', NULL, NULL, NULL, 2401453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.904292', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1089, 'Barcelona', 'RN', NULL, NULL, NULL, 2401503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.905211', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1090, 'Bento Fernandes', 'RN', NULL, NULL, NULL, 2401602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.906199', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1091, 'Bodo', 'RN', NULL, NULL, NULL, 2401651, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.907136', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1092, 'Bom Jesus', 'RN', NULL, NULL, NULL, 2401701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.908193', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1093, 'Brejinho', 'RN', NULL, NULL, NULL, 2401800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.909163', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1094, 'Caicara do Norte', 'RN', NULL, NULL, NULL, 2401859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.910096', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1095, 'Caicara do Rio do Vento', 'RN', NULL, NULL, NULL, 2401909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.911027', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1096, 'Caico', 'RN', NULL, NULL, NULL, 2402006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.911823', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1097, 'Campo Redondo', 'RN', NULL, NULL, NULL, 2402105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.912823', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1098, 'Canguaretama', 'RN', NULL, NULL, NULL, 2402204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.913613', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1099, 'Caraubas', 'RN', NULL, NULL, NULL, 2402303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.914478', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1100, 'Carnauba dos Dantas', 'RN', NULL, NULL, NULL, 2402402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.915516', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1101, 'Carnaubais', 'RN', NULL, NULL, NULL, 2402501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.916333', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1102, 'Ceara-mirim', 'RN', NULL, NULL, NULL, 2402600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.917214', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1103, 'Cerro Cora', 'RN', NULL, NULL, NULL, 2402709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.924082', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1104, 'Coronel Ezequiel', 'RN', NULL, NULL, NULL, 2402808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.925293', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1105, 'Coronel Joao Pessoa', 'RN', NULL, NULL, NULL, 2402907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.926424', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1106, 'Cruzeta', 'RN', NULL, NULL, NULL, 2403004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.927437', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1107, 'Currais Novos', 'RN', NULL, NULL, NULL, 2403103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.928357', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1108, 'Doutor Severiano', 'RN', NULL, NULL, NULL, 2403202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.92922', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1170, 'Parnamirim', 'RN', NULL, NULL, NULL, 2403251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.992169', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1109, 'Encanto', 'RN', NULL, NULL, NULL, 2403301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.930124', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1110, 'Equador', 'RN', NULL, NULL, NULL, 2403400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.930949', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1111, 'Espirito Santo', 'RN', NULL, NULL, NULL, 2403509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.93187', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1112, 'Extremoz', 'RN', NULL, NULL, NULL, 2403608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.93282', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1113, 'Felipe Guerra', 'RN', NULL, NULL, NULL, 2403707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.933753', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1114, 'Fernando Pedroza', 'RN', NULL, NULL, NULL, 2403756, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.934712', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1115, 'Florania', 'RN', NULL, NULL, NULL, 2403806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.935678', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1116, 'Francisco Dantas', 'RN', NULL, NULL, NULL, 2403905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.936647', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1117, 'Frutuoso Gomes', 'RN', NULL, NULL, NULL, 2404002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.93762', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1118, 'Galinhos', 'RN', NULL, NULL, NULL, 2404101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.938502', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1119, 'Goianinha', 'RN', NULL, NULL, NULL, 2404200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.939453', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1120, 'Governador Dix-sept Rosado', 'RN', NULL, NULL, NULL, 2404309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.940328', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1121, 'Grossos', 'RN', NULL, NULL, NULL, 2404408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.941151', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1122, 'Guamare', 'RN', NULL, NULL, NULL, 2404507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.942246', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1123, 'Ielmo Marinho', 'RN', NULL, NULL, NULL, 2404606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.943257', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1124, 'Ipanguacu', 'RN', NULL, NULL, NULL, 2404705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.944128', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1125, 'Ipueira', 'RN', NULL, NULL, NULL, 2404804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.945019', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1126, 'Itaja', 'RN', NULL, NULL, NULL, 2404853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.946076', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1127, 'Itau', 'RN', NULL, NULL, NULL, 2404903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.946989', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1128, 'Jacana', 'RN', NULL, NULL, NULL, 2405009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.947875', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1129, 'Jandaira', 'RN', NULL, NULL, NULL, 2405108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.948829', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1130, 'Janduis', 'RN', NULL, NULL, NULL, 2405207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.949781', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1131, 'Januario Cicco', 'RN', NULL, NULL, NULL, 2405306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.950601', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1132, 'Japi', 'RN', NULL, NULL, NULL, 2405405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.951564', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1133, 'Jardim de Angicos', 'RN', NULL, NULL, NULL, 2405504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.952483', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1134, 'Jardim de Piranhas', 'RN', NULL, NULL, NULL, 2405603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.953409', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1135, 'Jardim do Serido', 'RN', NULL, NULL, NULL, 2405702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.954238', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1136, 'Joao Camara', 'RN', NULL, NULL, NULL, 2405801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.955149', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1137, 'Joao Dias', 'RN', NULL, NULL, NULL, 2405900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.956075', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1138, 'Jose da Penha', 'RN', NULL, NULL, NULL, 2406007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.957006', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1139, 'Jucurutu', 'RN', NULL, NULL, NULL, 2406106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.957905', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1140, 'Jundia', 'RN', NULL, NULL, NULL, 2406155, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.958828', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1141, 'Lagoa D''anta', 'RN', NULL, NULL, NULL, 2406205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.965134', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1142, 'Lagoa de Pedras', 'RN', NULL, NULL, NULL, 2406304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.966233', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1143, 'Lagoa de Velhos', 'RN', NULL, NULL, NULL, 2406403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.967108', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1144, 'Lagoa Nova', 'RN', NULL, NULL, NULL, 2406502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.96806', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1145, 'Lagoa Salgada', 'RN', NULL, NULL, NULL, 2406601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.968966', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1146, 'Lajes', 'RN', NULL, NULL, NULL, 2406700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.96988', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1147, 'Lajes Pintadas', 'RN', NULL, NULL, NULL, 2406809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.970916', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1148, 'Lucrecia', 'RN', NULL, NULL, NULL, 2406908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.971944', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1149, 'Luis Gomes', 'RN', NULL, NULL, NULL, 2407005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.973018', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1150, 'Macaiba', 'RN', NULL, NULL, NULL, 2407104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.973955', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1151, 'Macau', 'RN', NULL, NULL, NULL, 2407203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.974833', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1152, 'Major Sales', 'RN', NULL, NULL, NULL, 2407252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.975688', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1153, 'Marcelino Vieira', 'RN', NULL, NULL, NULL, 2407302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.976567', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1154, 'Martins', 'RN', NULL, NULL, NULL, 2407401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.977442', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1155, 'Maxaranguape', 'RN', NULL, NULL, NULL, 2407500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.978517', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1156, 'Messias Targino', 'RN', NULL, NULL, NULL, 2407609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.979498', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1157, 'Montanhas', 'RN', NULL, NULL, NULL, 2407708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.980416', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1158, 'Monte Alegre', 'RN', NULL, NULL, NULL, 2407807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.981295', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1159, 'Monte das Gameleiras', 'RN', NULL, NULL, NULL, 2407906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.982178', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1160, 'Mossoro', 'RN', NULL, NULL, NULL, 2408003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.983168', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1161, 'Natal', 'RN', NULL, NULL, NULL, 2408102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.98404', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1162, 'Nisia Floresta', 'RN', NULL, NULL, NULL, 2408201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.984957', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1163, 'Nova Cruz', 'RN', NULL, NULL, NULL, 2408300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.98583', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1164, 'Olho-d''agua do Borges', 'RN', NULL, NULL, NULL, 2408409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.986796', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1165, 'Ouro Branco', 'RN', NULL, NULL, NULL, 2408508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.987717', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1166, 'Parana', 'RN', NULL, NULL, NULL, 2408607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.988598', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1167, 'Parau', 'RN', NULL, NULL, NULL, 2408706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.989498', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1168, 'Parazinho', 'RN', NULL, NULL, NULL, 2408805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.990437', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1169, 'Parelhas', 'RN', NULL, NULL, NULL, 2408904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.99129', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1191, 'Rio do Fogo', 'RN', NULL, NULL, NULL, 2408953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.017658', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1171, 'Passa e Fica', 'RN', NULL, NULL, NULL, 2409100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.99297', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1172, 'Passagem', 'RN', NULL, NULL, NULL, 2409209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.994099', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1173, 'Patu', 'RN', NULL, NULL, NULL, 2409308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.994899', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1195, 'Santa Maria', 'RN', NULL, NULL, NULL, 2409332, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.021445', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1174, 'Pau dos Ferros', 'RN', NULL, NULL, NULL, 2409407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.995778', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1175, 'Pedra Grande', 'RN', NULL, NULL, NULL, 2409506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.996685', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1176, 'Pedra Preta', 'RN', NULL, NULL, NULL, 2409605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.997564', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1177, 'Pedro Avelino', 'RN', NULL, NULL, NULL, 2409704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.998571', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1178, 'Pedro Velho', 'RN', NULL, NULL, NULL, 2409803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.005427', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1179, 'Pendencias', 'RN', NULL, NULL, NULL, 2409902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.00655', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1180, 'Piloes', 'RN', NULL, NULL, NULL, 2410009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.007471', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1181, 'Poco Branco', 'RN', NULL, NULL, NULL, 2410108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.00834', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1182, 'Portalegre', 'RN', NULL, NULL, NULL, 2410207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.009265', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1183, 'Porto do Mangue', 'RN', NULL, NULL, NULL, 2410256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.010181', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1185, 'Pureza', 'RN', NULL, NULL, NULL, 2410405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.012', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1186, 'Rafael Fernandes', 'RN', NULL, NULL, NULL, 2410504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.012814', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1187, 'Rafael Godeiro', 'RN', NULL, NULL, NULL, 2410603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.013633', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1188, 'Riacho da Cruz', 'RN', NULL, NULL, NULL, 2410702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.014532', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1189, 'Riacho de Santana', 'RN', NULL, NULL, NULL, 2410801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.015533', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1190, 'Riachuelo', 'RN', NULL, NULL, NULL, 2410900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.016688', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1192, 'Rodolfo Fernandes', 'RN', NULL, NULL, NULL, 2411007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.018555', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1229, 'Tibau', 'RN', NULL, NULL, NULL, 2411056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.059823', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1193, 'Ruy Barbosa', 'RN', NULL, NULL, NULL, 2411106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.019556', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1194, 'Santa Cruz', 'RN', NULL, NULL, NULL, 2411205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.020402', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1196, 'Santana do Matos', 'RN', NULL, NULL, NULL, 2411403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.022177', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1197, 'Santana do Serido', 'RN', NULL, NULL, NULL, 2411429, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.023022', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1198, 'Santo Antonio', 'RN', NULL, NULL, NULL, 2411502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.023864', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1199, 'Sao Bento do Norte', 'RN', NULL, NULL, NULL, 2411601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.024666', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1200, 'Sao Bento do Trairi', 'RN', NULL, NULL, NULL, 2411700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.025598', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1201, 'Sao Fernando', 'RN', NULL, NULL, NULL, 2411809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.026479', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1202, 'Sao Francisco do Oeste', 'RN', NULL, NULL, NULL, 2411908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.027777', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1203, 'Sao Goncalo do Amarante', 'RN', NULL, NULL, NULL, 2412005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.028644', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1204, 'Sao Joao do Sabugi', 'RN', NULL, NULL, NULL, 2412104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.029513', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1205, 'Sao Jose de Mipibu', 'RN', NULL, NULL, NULL, 2412203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.03041', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1206, 'Sao Jose do Campestre', 'RN', NULL, NULL, NULL, 2412302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.031271', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1207, 'Sao Jose do Serido', 'RN', NULL, NULL, NULL, 2412401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.032197', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1208, 'Sao Miguel', 'RN', NULL, NULL, NULL, 2412500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.03317', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1209, 'Sao Miguel do Gostoso', 'RN', NULL, NULL, NULL, 2412559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.034112', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1210, 'Sao Paulo do Potengi', 'RN', NULL, NULL, NULL, 2412609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.035023', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1211, 'Sao Pedro', 'RN', NULL, NULL, NULL, 2412708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.035951', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1212, 'Sao Rafael', 'RN', NULL, NULL, NULL, 2412807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.03703', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1213, 'Sao Tome', 'RN', NULL, NULL, NULL, 2412906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.037977', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1214, 'Sao Vicente', 'RN', NULL, NULL, NULL, 2413003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.039135', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1215, 'Senador Eloi de Souza', 'RN', NULL, NULL, NULL, 2413102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.045963', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1216, 'Senador Georgino Avelino', 'RN', NULL, NULL, NULL, 2413201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.047205', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1217, 'Serra de Sao Bento', 'RN', NULL, NULL, NULL, 2413300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.048251', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1218, 'Serra do Mel', 'RN', NULL, NULL, NULL, 2413359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.049257', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1219, 'Serra Negra do Norte', 'RN', NULL, NULL, NULL, 2413409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.050121', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1220, 'Serrinha', 'RN', NULL, NULL, NULL, 2413508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.051006', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1221, 'Serrinha dos Pintos', 'RN', NULL, NULL, NULL, 2413557, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.052384', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1222, 'Severiano Melo', 'RN', NULL, NULL, NULL, 2413607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.053323', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1223, 'Sitio Novo', 'RN', NULL, NULL, NULL, 2413706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.05422', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1224, 'Taboleiro Grande', 'RN', NULL, NULL, NULL, 2413805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.055116', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1225, 'Taipu', 'RN', NULL, NULL, NULL, 2413904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.055992', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1226, 'Tangara', 'RN', NULL, NULL, NULL, 2414001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.056821', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1227, 'Tenente Ananias', 'RN', NULL, NULL, NULL, 2414100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.057772', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1228, 'Tenente Laurentino Cruz', 'RN', NULL, NULL, NULL, 2414159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.058756', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1230, 'Tibau do Sul', 'RN', NULL, NULL, NULL, 2414209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.061144', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1231, 'Timbauba dos Batistas', 'RN', NULL, NULL, NULL, 2414308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.062201', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1232, 'Touros', 'RN', NULL, NULL, NULL, 2414407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.063184', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1233, 'Triunfo Potiguar', 'RN', NULL, NULL, NULL, 2414456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.064106', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1234, 'Umarizal', 'RN', NULL, NULL, NULL, 2414506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.065006', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1235, 'Upanema', 'RN', NULL, NULL, NULL, 2414605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.065955', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1236, 'Varzea', 'RN', NULL, NULL, NULL, 2414704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.066769', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1237, 'Venha-ver', 'RN', NULL, NULL, NULL, 2414753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.067688', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1238, 'Vera Cruz', 'RN', NULL, NULL, NULL, 2414803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.068614', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1239, 'Vicosa', 'RN', NULL, NULL, NULL, 2414902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.069524', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1240, 'Vila Flor', 'RN', NULL, NULL, NULL, 2415008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.070393', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1241, 'Agua Branca', 'PB', NULL, NULL, NULL, 2500106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.071439', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1242, 'Aguiar', 'PB', NULL, NULL, NULL, 2500205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.072434', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1243, 'Alagoa Grande', 'PB', NULL, NULL, NULL, 2500304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.073282', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1244, 'Alagoa Nova', 'PB', NULL, NULL, NULL, 2500403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.074227', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1245, 'Alagoinha', 'PB', NULL, NULL, NULL, 2500502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.075158', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1246, 'Alcantil', 'PB', NULL, NULL, NULL, 2500536, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.076009', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1247, 'Algodao de Jandaira', 'PB', NULL, NULL, NULL, 2500577, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.076841', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1248, 'Alhandra', 'PB', NULL, NULL, NULL, 2500601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.07777', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1423, 'Sao Joao do Rio do Peixe', 'PB', NULL, NULL, NULL, 2500700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.271743', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1249, 'Amparo', 'PB', NULL, NULL, NULL, 2500734, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.078587', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1250, 'Aparecida', 'PB', NULL, NULL, NULL, 2500775, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.079657', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1251, 'Aracagi', 'PB', NULL, NULL, NULL, 2500809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.086461', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1252, 'Arara', 'PB', NULL, NULL, NULL, 2500908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.087625', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1253, 'Araruna', 'PB', NULL, NULL, NULL, 2501005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.088977', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1254, 'Areia', 'PB', NULL, NULL, NULL, 2501104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.089891', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1255, 'Areia de Baraunas', 'PB', NULL, NULL, NULL, 2501153, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.090763', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1256, 'Areial', 'PB', NULL, NULL, NULL, 2501203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.09166', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1257, 'Aroeiras', 'PB', NULL, NULL, NULL, 2501302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.092651', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1258, 'Assuncao', 'PB', NULL, NULL, NULL, 2501351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.093528', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1259, 'Baia da Traicao', 'PB', NULL, NULL, NULL, 2501401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.094762', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1260, 'Bananeiras', 'PB', NULL, NULL, NULL, 2501500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.0956', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1261, 'Barauna', 'PB', NULL, NULL, NULL, 2501534, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.096454', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1263, 'Barra de Santana', 'PB', NULL, NULL, NULL, 2501575, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.098328', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1262, 'Barra de Santa Rosa', 'PB', NULL, NULL, NULL, 2501609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.097433', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1264, 'Barra de Sao Miguel', 'PB', NULL, NULL, NULL, 2501708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.099207', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1265, 'Bayeux', 'PB', NULL, NULL, NULL, 2501807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.100233', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1266, 'Belem', 'PB', NULL, NULL, NULL, 2501906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.101175', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1267, 'Belem do Brejo do Cruz', 'PB', NULL, NULL, NULL, 2502003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.102014', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1268, 'Bernardino Batista', 'PB', NULL, NULL, NULL, 2502052, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.102935', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1269, 'Boa Ventura', 'PB', NULL, NULL, NULL, 2502102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.10377', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1270, 'Boa Vista', 'PB', NULL, NULL, NULL, 2502151, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.104778', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1271, 'Bom Jesus', 'PB', NULL, NULL, NULL, 2502201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.105776', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1272, 'Bom Sucesso', 'PB', NULL, NULL, NULL, 2502300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.106763', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1273, 'Bonito de Santa Fe', 'PB', NULL, NULL, NULL, 2502409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.107652', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1274, 'Boqueirao', 'PB', NULL, NULL, NULL, 2502508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.108561', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1326, 'Igaracy', 'PB', NULL, NULL, NULL, 2502607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.169184', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1275, 'Borborema', 'PB', NULL, NULL, NULL, 2502706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.109233', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1276, 'Brejo do Cruz', 'PB', NULL, NULL, NULL, 2502805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.110176', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1277, 'Brejo dos Santos', 'PB', NULL, NULL, NULL, 2502904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.111091', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1278, 'Caapora', 'PB', NULL, NULL, NULL, 2503001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.112052', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1279, 'Cabaceiras', 'PB', NULL, NULL, NULL, 2503100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.112919', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1280, 'Cabedelo', 'PB', NULL, NULL, NULL, 2503209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.113819', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1281, 'Cachoeira dos Indios', 'PB', NULL, NULL, NULL, 2503308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.114792', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1282, 'Cacimba de Areia', 'PB', NULL, NULL, NULL, 2503407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.115622', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1283, 'Cacimba de Dentro', 'PB', NULL, NULL, NULL, 2503506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.116562', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1284, 'Cacimbas', 'PB', NULL, NULL, NULL, 2503555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.117359', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1285, 'Caicara', 'PB', NULL, NULL, NULL, 2503605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.118234', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1286, 'Cajazeiras', 'PB', NULL, NULL, NULL, 2503704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.119142', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1287, 'Cajazeirinhas', 'PB', NULL, NULL, NULL, 2503753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.120118', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1288, 'Caldas Brandao', 'PB', NULL, NULL, NULL, 2503803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.126902', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1289, 'Camalau', 'PB', NULL, NULL, NULL, 2503902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.128216', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1290, 'Campina Grande', 'PB', NULL, NULL, NULL, 2504009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.129109', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1292, 'Capim', 'PB', NULL, NULL, NULL, 2504033, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.130913', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1293, 'Caraubas', 'PB', NULL, NULL, NULL, 2504074, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.131989', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1294, 'Carrapateira', 'PB', NULL, NULL, NULL, 2504108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.132966', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1295, 'Casserengue', 'PB', NULL, NULL, NULL, 2504157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.133895', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1296, 'Catingueira', 'PB', NULL, NULL, NULL, 2504207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.134819', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1297, 'Catole do Rocha', 'PB', NULL, NULL, NULL, 2504306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.135839', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1298, 'Caturite', 'PB', NULL, NULL, NULL, 2504355, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.136857', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1299, 'Conceicao', 'PB', NULL, NULL, NULL, 2504405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.137768', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1300, 'Condado', 'PB', NULL, NULL, NULL, 2504504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.138687', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1301, 'Conde', 'PB', NULL, NULL, NULL, 2504603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.139541', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1302, 'Congo', 'PB', NULL, NULL, NULL, 2504702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.140593', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1303, 'Coremas', 'PB', NULL, NULL, NULL, 2504801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.141567', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1304, 'Coxixola', 'PB', NULL, NULL, NULL, 2504850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.142408', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1305, 'Cruz do Espirito Santo', 'PB', NULL, NULL, NULL, 2504900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.143316', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1306, 'Cubati', 'PB', NULL, NULL, NULL, 2505006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.144275', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1307, 'Cuite', 'PB', NULL, NULL, NULL, 2505105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.145159', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1309, 'Cuitegi', 'PB', NULL, NULL, NULL, 2505204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.146933', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1308, 'Cuite de Mamanguape', 'PB', NULL, NULL, NULL, 2505238, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.146038', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1310, 'Curral de Cima', 'PB', NULL, NULL, NULL, 2505279, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.147807', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1311, 'Curral Velho', 'PB', NULL, NULL, NULL, 2505303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.14869', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1312, 'Damiao', 'PB', NULL, NULL, NULL, 2505352, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.149547', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1313, 'Desterro', 'PB', NULL, NULL, NULL, 2505402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.150441', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1462, 'Vista Serrana', 'PB', NULL, NULL, NULL, 2505501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.312486', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1314, 'Diamante', 'PB', NULL, NULL, NULL, 2505600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.151433', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1315, 'Dona Ines', 'PB', NULL, NULL, NULL, 2505709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.152276', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1316, 'Duas Estradas', 'PB', NULL, NULL, NULL, 2505808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.153226', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1317, 'Emas', 'PB', NULL, NULL, NULL, 2505907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.154106', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1318, 'Esperanca', 'PB', NULL, NULL, NULL, 2506004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.154937', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1319, 'Fagundes', 'PB', NULL, NULL, NULL, 2506103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.15573', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1320, 'Frei Martinho', 'PB', NULL, NULL, NULL, 2506202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.156702', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1321, 'Gado Bravo', 'PB', NULL, NULL, NULL, 2506251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.157619', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1322, 'Guarabira', 'PB', NULL, NULL, NULL, 2506301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.158561', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1323, 'Gurinhem', 'PB', NULL, NULL, NULL, 2506400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.159521', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1324, 'Gurjao', 'PB', NULL, NULL, NULL, 2506509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.160604', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1325, 'Ibiara', 'PB', NULL, NULL, NULL, 2506608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.168082', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1327, 'Imaculada', 'PB', NULL, NULL, NULL, 2506707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.170197', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1328, 'Inga', 'PB', NULL, NULL, NULL, 2506806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.171029', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1329, 'Itabaiana', 'PB', NULL, NULL, NULL, 2506905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.172174', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1330, 'Itaporanga', 'PB', NULL, NULL, NULL, 2507002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.173123', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1331, 'Itapororoca', 'PB', NULL, NULL, NULL, 2507101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.174094', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1332, 'Itatuba', 'PB', NULL, NULL, NULL, 2507200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.174905', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1333, 'Jacarau', 'PB', NULL, NULL, NULL, 2507309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.175971', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1334, 'Jerico', 'PB', NULL, NULL, NULL, 2507408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.176834', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1335, 'Joao Pessoa', 'PB', NULL, NULL, NULL, 2507507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.177745', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1336, 'Juarez Tavora', 'PB', NULL, NULL, NULL, 2507606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.178614', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1337, 'Juazeirinho', 'PB', NULL, NULL, NULL, 2507705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.179447', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1338, 'Junco do Serido', 'PB', NULL, NULL, NULL, 2507804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.180365', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1339, 'Juripiranga', 'PB', NULL, NULL, NULL, 2507903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.181348', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1340, 'Juru', 'PB', NULL, NULL, NULL, 2508000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.182217', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1341, 'Lagoa', 'PB', NULL, NULL, NULL, 2508109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.183149', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1342, 'Lagoa de Dentro', 'PB', NULL, NULL, NULL, 2508208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.184115', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1343, 'Lagoa Seca', 'PB', NULL, NULL, NULL, 2508307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.185256', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1344, 'Lastro', 'PB', NULL, NULL, NULL, 2508406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.186203', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1345, 'Livramento', 'PB', NULL, NULL, NULL, 2508505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.187139', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1346, 'Logradouro', 'PB', NULL, NULL, NULL, 2508554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.18807', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1347, 'Lucena', 'PB', NULL, NULL, NULL, 2508604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.188966', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1348, 'Mae D''agua', 'PB', NULL, NULL, NULL, 2508703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.189872', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1349, 'Malta', 'PB', NULL, NULL, NULL, 2508802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.190783', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1350, 'Mamanguape', 'PB', NULL, NULL, NULL, 2508901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.191714', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1351, 'Manaira', 'PB', NULL, NULL, NULL, 2509008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.192634', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1352, 'Marcacao', 'PB', NULL, NULL, NULL, 2509057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.193573', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1353, 'Mari', 'PB', NULL, NULL, NULL, 2509107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.194537', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1354, 'Marizopolis', 'PB', NULL, NULL, NULL, 2509156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.195373', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1355, 'Massaranduba', 'PB', NULL, NULL, NULL, 2509206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.196294', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1356, 'Mataraca', 'PB', NULL, NULL, NULL, 2509305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.197125', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1357, 'Matinhas', 'PB', NULL, NULL, NULL, 2509339, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.198047', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1358, 'Mato Grosso', 'PB', NULL, NULL, NULL, 2509370, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.198975', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1359, 'Matureia', 'PB', NULL, NULL, NULL, 2509396, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.199965', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1360, 'Mogeiro', 'PB', NULL, NULL, NULL, 2509404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.200795', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1361, 'Montadas', 'PB', NULL, NULL, NULL, 2509503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.201784', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1362, 'Monte Horebe', 'PB', NULL, NULL, NULL, 2509602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.209441', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1363, 'Monteiro', 'PB', NULL, NULL, NULL, 2509701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.210611', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1364, 'Mulungu', 'PB', NULL, NULL, NULL, 2509800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.21166', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1365, 'Natuba', 'PB', NULL, NULL, NULL, 2509909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.212408', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1366, 'Nazarezinho', 'PB', NULL, NULL, NULL, 2510006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.213326', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1367, 'Nova Floresta', 'PB', NULL, NULL, NULL, 2510105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.214238', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1368, 'Nova Olinda', 'PB', NULL, NULL, NULL, 2510204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.215124', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1369, 'Nova Palmeira', 'PB', NULL, NULL, NULL, 2510303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.215985', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1370, 'Olho D''agua', 'PB', NULL, NULL, NULL, 2510402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.216966', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1371, 'Olivedos', 'PB', NULL, NULL, NULL, 2510501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.217879', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1372, 'Ouro Velho', 'PB', NULL, NULL, NULL, 2510600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.218822', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1373, 'Parari', 'PB', NULL, NULL, NULL, 2510659, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.219627', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1374, 'Passagem', 'PB', NULL, NULL, NULL, 2510709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.220662', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1375, 'Patos', 'PB', NULL, NULL, NULL, 2510808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.22147', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1376, 'Paulista', 'PB', NULL, NULL, NULL, 2510907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.222548', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1377, 'Pedra Branca', 'PB', NULL, NULL, NULL, 2511004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.223486', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1378, 'Pedra Lavrada', 'PB', NULL, NULL, NULL, 2511103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.224321', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1379, 'Pedras de Fogo', 'PB', NULL, NULL, NULL, 2511202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.225261', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1381, 'Pianco', 'PB', NULL, NULL, NULL, 2511301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.22712', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1382, 'Picui', 'PB', NULL, NULL, NULL, 2511400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.228008', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1383, 'Pilar', 'PB', NULL, NULL, NULL, 2511509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.228887', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1384, 'Piloes', 'PB', NULL, NULL, NULL, 2511608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.230081', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1385, 'Piloezinhos', 'PB', NULL, NULL, NULL, 2511707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.230945', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1386, 'Pirpirituba', 'PB', NULL, NULL, NULL, 2511806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.231857', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1387, 'Pitimbu', 'PB', NULL, NULL, NULL, 2511905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.232742', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1388, 'Pocinhos', 'PB', NULL, NULL, NULL, 2512002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.233566', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1389, 'Poco Dantas', 'PB', NULL, NULL, NULL, 2512036, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.234628', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1390, 'Poco de Jose de Moura', 'PB', NULL, NULL, NULL, 2512077, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.235532', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1391, 'Pombal', 'PB', NULL, NULL, NULL, 2512101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.236417', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1392, 'Prata', 'PB', NULL, NULL, NULL, 2512200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.23723', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1393, 'Princesa Isabel', 'PB', NULL, NULL, NULL, 2512309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.238127', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1394, 'Puxinana', 'PB', NULL, NULL, NULL, 2512408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.238929', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1395, 'Queimadas', 'PB', NULL, NULL, NULL, 2512507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.239764', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1396, 'Quixaba', 'PB', NULL, NULL, NULL, 2512606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.240693', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1397, 'Remigio', 'PB', NULL, NULL, NULL, 2512705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.241454', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1380, 'Pedro Regis', 'PB', NULL, NULL, NULL, 2512721, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.226144', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1398, 'Riachao', 'PB', NULL, NULL, NULL, 2512747, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.242406', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1399, 'Riachao do Bacamarte', 'PB', NULL, NULL, NULL, 2512754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.243145', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1400, 'Riachao do Poco', 'PB', NULL, NULL, NULL, 2512762, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.249788', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1401, 'Riacho de Santo Antonio', 'PB', NULL, NULL, NULL, 2512788, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.250952', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1402, 'Riacho dos Cavalos', 'PB', NULL, NULL, NULL, 2512804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.252411', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1403, 'Rio Tinto', 'PB', NULL, NULL, NULL, 2512903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.253304', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1404, 'Salgadinho', 'PB', NULL, NULL, NULL, 2513000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.25416', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1405, 'Salgado de Sao Felix', 'PB', NULL, NULL, NULL, 2513109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.255117', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1406, 'Santa Cecilia', 'PB', NULL, NULL, NULL, 2513158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.256209', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1407, 'Santa Cruz', 'PB', NULL, NULL, NULL, 2513208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.25718', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1408, 'Santa Helena', 'PB', NULL, NULL, NULL, 2513307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.258032', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1409, 'Santa Ines', 'PB', NULL, NULL, NULL, 2513356, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.258871', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1410, 'Santa Luzia', 'PB', NULL, NULL, NULL, 2513406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.25973', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1413, 'Santana de Mangueira', 'PB', NULL, NULL, NULL, 2513505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.262825', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1414, 'Santana dos Garrotes', 'PB', NULL, NULL, NULL, 2513604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.263649', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1411, 'Santa Rita', 'PB', NULL, NULL, NULL, 2513703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.260598', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1412, 'Santa Teresinha', 'PB', NULL, NULL, NULL, 2513802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.261849', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1416, 'Santo Andre', 'PB', NULL, NULL, NULL, 2513851, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.265495', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1418, 'Sao Bento', 'PB', NULL, NULL, NULL, 2513901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.26724', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1417, 'Sao Bentinho', 'PB', NULL, NULL, NULL, 2513927, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.266426', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1420, 'Sao Domingos do Cariri', 'PB', NULL, NULL, NULL, 2513943, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.269057', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1421, 'Sao Francisco', 'PB', NULL, NULL, NULL, 2513984, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.269946', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1422, 'Sao Joao do Cariri', 'PB', NULL, NULL, NULL, 2514008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.270871', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1424, 'Sao Joao do Tigre', 'PB', NULL, NULL, NULL, 2514107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.272737', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1425, 'Sao Jose da Lagoa Tapada', 'PB', NULL, NULL, NULL, 2514206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.273614', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1426, 'Sao Jose de Caiana', 'PB', NULL, NULL, NULL, 2514305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.274688', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1427, 'Sao Jose de Espinharas', 'PB', NULL, NULL, NULL, 2514404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.27563', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1434, 'Sao Jose dos Ramos', 'PB', NULL, NULL, NULL, 2514453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.281823', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1428, 'Sao Jose de Piranhas', 'PB', NULL, NULL, NULL, 2514503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.276506', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1429, 'Sao Jose de Princesa', 'PB', NULL, NULL, NULL, 2514552, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.277443', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1430, 'Sao Jose do Bonfim', 'PB', NULL, NULL, NULL, 2514602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.278377', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1431, 'Sao Jose do Brejo do Cruz', 'PB', NULL, NULL, NULL, 2514651, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.279212', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1432, 'Sao Jose do Sabugi', 'PB', NULL, NULL, NULL, 2514701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.280095', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1433, 'Sao Jose dos Cordeiros', 'PB', NULL, NULL, NULL, 2514800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.280958', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1435, 'Sao Mamede', 'PB', NULL, NULL, NULL, 2514909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.282705', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1436, 'Sao Miguel de Taipu', 'PB', NULL, NULL, NULL, 2515005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.283547', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1437, 'Sao Sebastiao de Lagoa de Roca', 'PB', NULL, NULL, NULL, 2515104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.290398', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1438, 'Sao Sebastiao do Umbuzeiro', 'PB', NULL, NULL, NULL, 2515203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.291562', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1440, 'Sape', 'PB', NULL, NULL, NULL, 2515302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.293434', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1439, 'Sao Vicente do Serido', 'PB', NULL, NULL, NULL, 2515401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.292442', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1441, 'Serra Branca', 'PB', NULL, NULL, NULL, 2515500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.294291', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1442, 'Serra da Raiz', 'PB', NULL, NULL, NULL, 2515609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.295204', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1443, 'Serra Grande', 'PB', NULL, NULL, NULL, 2515708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.29615', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1444, 'Serra Redonda', 'PB', NULL, NULL, NULL, 2515807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.296925', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1445, 'Serraria', 'PB', NULL, NULL, NULL, 2515906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.297727', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1446, 'Sertaozinho', 'PB', NULL, NULL, NULL, 2515930, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.298636', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1447, 'Sobrado', 'PB', NULL, NULL, NULL, 2515971, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.299495', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1448, 'Solanea', 'PB', NULL, NULL, NULL, 2516003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.300403', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1449, 'Soledade', 'PB', NULL, NULL, NULL, 2516102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.301233', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1450, 'Sossego', 'PB', NULL, NULL, NULL, 2516151, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.302085', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1451, 'Sousa', 'PB', NULL, NULL, NULL, 2516201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.302975', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1452, 'Sume', 'PB', NULL, NULL, NULL, 2516300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.303766', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1453, 'Taperoa', 'PB', NULL, NULL, NULL, 2516508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.304635', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1454, 'Tavares', 'PB', NULL, NULL, NULL, 2516607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.305527', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1455, 'Teixeira', 'PB', NULL, NULL, NULL, 2516706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.306383', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1456, 'Tenorio', 'PB', NULL, NULL, NULL, 2516755, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.3074', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1457, 'Triunfo', 'PB', NULL, NULL, NULL, 2516805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.308232', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1458, 'Uirauna', 'PB', NULL, NULL, NULL, 2516904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.309099', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1459, 'Umbuzeiro', 'PB', NULL, NULL, NULL, 2517001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.309848', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1460, 'Varzea', 'PB', NULL, NULL, NULL, 2517100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.310707', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1461, 'Vieiropolis', 'PB', NULL, NULL, NULL, 2517209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.311518', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1463, 'Zabele', 'PB', NULL, NULL, NULL, 2517407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.31346', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1464, 'Abreu e Lima', 'PE', NULL, NULL, NULL, 2600054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.314455', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1465, 'Afogados da Ingazeira', 'PE', NULL, NULL, NULL, 2600104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.315369', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1466, 'Afranio', 'PE', NULL, NULL, NULL, 2600203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.316283', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1467, 'Agrestina', 'PE', NULL, NULL, NULL, 2600302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.317184', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1468, 'Agua Preta', 'PE', NULL, NULL, NULL, 2600401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.318148', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1469, 'Aguas Belas', 'PE', NULL, NULL, NULL, 2600500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.319228', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1470, 'Alagoinha', 'PE', NULL, NULL, NULL, 2600609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.320145', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1471, 'Alianca', 'PE', NULL, NULL, NULL, 2600708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.32101', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1472, 'Altinho', 'PE', NULL, NULL, NULL, 2600807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.321895', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1473, 'Amaraji', 'PE', NULL, NULL, NULL, 2600906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.322767', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1474, 'Angelim', 'PE', NULL, NULL, NULL, 2601003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.32367', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1475, 'Aracoiaba', 'PE', NULL, NULL, NULL, 2601052, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.324482', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1476, 'Araripina', 'PE', NULL, NULL, NULL, 2601102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.330102', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1477, 'Arcoverde', 'PE', NULL, NULL, NULL, 2601201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.331269', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1478, 'Barra de Guabiraba', 'PE', NULL, NULL, NULL, 2601300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.332372', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1479, 'Barreiros', 'PE', NULL, NULL, NULL, 2601409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.333472', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1480, 'Belem de Maria', 'PE', NULL, NULL, NULL, 2601508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.334393', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1482, 'Belo Jardim', 'PE', NULL, NULL, NULL, 2601706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.336241', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1483, 'Betania', 'PE', NULL, NULL, NULL, 2601805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.337129', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1484, 'Bezerros', 'PE', NULL, NULL, NULL, 2601904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.338076', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1485, 'Bodoco', 'PE', NULL, NULL, NULL, 2602001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.338907', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1486, 'Bom Conselho', 'PE', NULL, NULL, NULL, 2602100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.339929', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1487, 'Bom Jardim', 'PE', NULL, NULL, NULL, 2602209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.340936', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1488, 'Bonito', 'PE', NULL, NULL, NULL, 2602308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.34216', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1489, 'Brejao', 'PE', NULL, NULL, NULL, 2602407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.343086', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1490, 'Brejinho', 'PE', NULL, NULL, NULL, 2602506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.344037', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1491, 'Brejo da Madre de Deus', 'PE', NULL, NULL, NULL, 2602605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.344934', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1492, 'Buenos Aires', 'PE', NULL, NULL, NULL, 2602704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.345842', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1493, 'Buique', 'PE', NULL, NULL, NULL, 2602803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.346767', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1494, 'Cabo de Santo Agostinho', 'PE', NULL, NULL, NULL, 2602902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.347774', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1495, 'Cabrobo', 'PE', NULL, NULL, NULL, 2603009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.348738', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1496, 'Cachoeirinha', 'PE', NULL, NULL, NULL, 2603108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.349556', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1497, 'Caetes', 'PE', NULL, NULL, NULL, 2603207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.350314', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1498, 'Calcado', 'PE', NULL, NULL, NULL, 2603306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.351203', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1499, 'Calumbi', 'PE', NULL, NULL, NULL, 2603405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.35222', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1500, 'Camaragibe', 'PE', NULL, NULL, NULL, 2603454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.352986', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1501, 'Camocim de Sao Felix', 'PE', NULL, NULL, NULL, 2603504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.35396', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1502, 'Camutanga', 'PE', NULL, NULL, NULL, 2603603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.35491', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1503, 'Canhotinho', 'PE', NULL, NULL, NULL, 2603702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.355843', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1504, 'Capoeiras', 'PE', NULL, NULL, NULL, 2603801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.356719', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1505, 'Carnaiba', 'PE', NULL, NULL, NULL, 2603900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.357596', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1506, 'Carnaubeira da Penha', 'PE', NULL, NULL, NULL, 2603926, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.358502', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1507, 'Carpina', 'PE', NULL, NULL, NULL, 2604007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.359433', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1508, 'Caruaru', 'PE', NULL, NULL, NULL, 2604106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.360254', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1509, 'Casinhas', 'PE', NULL, NULL, NULL, 2604155, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.361206', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1510, 'Catende', 'PE', NULL, NULL, NULL, 2604205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.362152', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1511, 'Cedro', 'PE', NULL, NULL, NULL, 2604304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.363201', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1512, 'Cha de Alegria', 'PE', NULL, NULL, NULL, 2604403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.364172', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1513, 'Cha Grande', 'PE', NULL, NULL, NULL, 2604502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.364895', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1515, 'Correntes', 'PE', NULL, NULL, NULL, 2604700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.366715', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1516, 'Cortes', 'PE', NULL, NULL, NULL, 2604809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.376836', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1517, 'Cumaru', 'PE', NULL, NULL, NULL, 2604908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.377881', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1518, 'Cupira', 'PE', NULL, NULL, NULL, 2605004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.378741', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1519, 'Custodia', 'PE', NULL, NULL, NULL, 2605103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.379657', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1520, 'Dormentes', 'PE', NULL, NULL, NULL, 2605152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.380527', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1521, 'Escada', 'PE', NULL, NULL, NULL, 2605202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.381407', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1522, 'Exu', 'PE', NULL, NULL, NULL, 2605301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.382617', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1523, 'Feira Nova', 'PE', NULL, NULL, NULL, 2605400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.383472', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1524, 'Fernando de Noronha', 'PE', NULL, NULL, NULL, 2605459, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.384317', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1525, 'Ferreiros', 'PE', NULL, NULL, NULL, 2605509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.3852', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1526, 'Flores', 'PE', NULL, NULL, NULL, 2605608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.386058', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1527, 'Floresta', 'PE', NULL, NULL, NULL, 2605707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.386923', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1528, 'Frei Miguelinho', 'PE', NULL, NULL, NULL, 2605806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.387844', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1529, 'Gameleira', 'PE', NULL, NULL, NULL, 2605905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.388718', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1530, 'Garanhuns', 'PE', NULL, NULL, NULL, 2606002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.389733', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1531, 'Gloria do Goita', 'PE', NULL, NULL, NULL, 2606101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.390524', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1532, 'Goiana', 'PE', NULL, NULL, NULL, 2606200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.391405', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1533, 'Granito', 'PE', NULL, NULL, NULL, 2606309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.392255', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1534, 'Gravata', 'PE', NULL, NULL, NULL, 2606408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.393148', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1535, 'Iati', 'PE', NULL, NULL, NULL, 2606507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.394064', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1536, 'Ibimirim', 'PE', NULL, NULL, NULL, 2606606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.394992', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1537, 'Ibirajuba', 'PE', NULL, NULL, NULL, 2606705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.395927', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1538, 'Igarassu', 'PE', NULL, NULL, NULL, 2606804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.396835', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1540, 'Inaja', 'PE', NULL, NULL, NULL, 2607000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.398738', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1541, 'Ingazeira', 'PE', NULL, NULL, NULL, 2607109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.399746', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1542, 'Ipojuca', 'PE', NULL, NULL, NULL, 2607208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.400727', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1543, 'Ipubi', 'PE', NULL, NULL, NULL, 2607307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.401708', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1544, 'Itacuruba', 'PE', NULL, NULL, NULL, 2607406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.402642', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1545, 'Itaiba', 'PE', NULL, NULL, NULL, 2607505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.403569', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1547, 'Itambe', 'PE', NULL, NULL, NULL, 2607653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.405413', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1548, 'Itapetim', 'PE', NULL, NULL, NULL, 2607703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.40621', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1549, 'Itapissuma', 'PE', NULL, NULL, NULL, 2607752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.407134', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1550, 'Itaquitinga', 'PE', NULL, NULL, NULL, 2607802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.408047', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1551, 'Jaboatao dos Guararapes', 'PE', NULL, NULL, NULL, 2607901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.408818', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1552, 'Jaqueira', 'PE', NULL, NULL, NULL, 2607950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.409756', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1553, 'Jatauba', 'PE', NULL, NULL, NULL, 2608008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.410498', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1554, 'Jatoba', 'PE', NULL, NULL, NULL, 2608057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.411876', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1555, 'Joao Alfredo', 'PE', NULL, NULL, NULL, 2608107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.417932', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1556, 'Joaquim Nabuco', 'PE', NULL, NULL, NULL, 2608206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.419099', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1557, 'Jucati', 'PE', NULL, NULL, NULL, 2608255, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.420118', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1558, 'Jupi', 'PE', NULL, NULL, NULL, 2608305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.421181', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1559, 'Jurema', 'PE', NULL, NULL, NULL, 2608404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.422125', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1560, 'Lagoa do Carro', 'PE', NULL, NULL, NULL, 2608453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.423115', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1562, 'Lagoa do Ouro', 'PE', NULL, NULL, NULL, 2608602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.424996', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1563, 'Lagoa dos Gatos', 'PE', NULL, NULL, NULL, 2608701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.425859', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1564, 'Lagoa Grande', 'PE', NULL, NULL, NULL, 2608750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.42668', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1565, 'Lajedo', 'PE', NULL, NULL, NULL, 2608800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.427665', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1566, 'Limoeiro', 'PE', NULL, NULL, NULL, 2608909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.428572', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1567, 'Macaparana', 'PE', NULL, NULL, NULL, 2609006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.429473', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1568, 'Machados', 'PE', NULL, NULL, NULL, 2609105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.430395', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1569, 'Manari', 'PE', NULL, NULL, NULL, 2609154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.431315', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1570, 'Maraial', 'PE', NULL, NULL, NULL, 2609204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.432227', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1571, 'Mirandiba', 'PE', NULL, NULL, NULL, 2609303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.433144', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1573, 'Moreno', 'PE', NULL, NULL, NULL, 2609402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.434923', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1574, 'Nazare da Mata', 'PE', NULL, NULL, NULL, 2609501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.435804', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1575, 'Olinda', 'PE', NULL, NULL, NULL, 2609600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.436674', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1576, 'Orobo', 'PE', NULL, NULL, NULL, 2609709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.437566', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1577, 'Oroco', 'PE', NULL, NULL, NULL, 2609808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.438497', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1578, 'Ouricuri', 'PE', NULL, NULL, NULL, 2609907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.439384', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1579, 'Palmares', 'PE', NULL, NULL, NULL, 2610004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.44018', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1580, 'Palmeirina', 'PE', NULL, NULL, NULL, 2610103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.441107', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1581, 'Panelas', 'PE', NULL, NULL, NULL, 2610202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.442238', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1582, 'Paranatama', 'PE', NULL, NULL, NULL, 2610301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.443039', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1583, 'Parnamirim', 'PE', NULL, NULL, NULL, 2610400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.44394', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1584, 'Passira', 'PE', NULL, NULL, NULL, 2610509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.444874', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1585, 'Paudalho', 'PE', NULL, NULL, NULL, 2610608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.445746', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1586, 'Paulista', 'PE', NULL, NULL, NULL, 2610707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.446509', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1587, 'Pedra', 'PE', NULL, NULL, NULL, 2610806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.447374', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1588, 'Pesqueira', 'PE', NULL, NULL, NULL, 2610905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.448217', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1589, 'Petrolandia', 'PE', NULL, NULL, NULL, 2611002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.449198', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1590, 'Petrolina', 'PE', NULL, NULL, NULL, 2611101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.450099', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1591, 'Pocao', 'PE', NULL, NULL, NULL, 2611200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.451059', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1592, 'Pombos', 'PE', NULL, NULL, NULL, 2611309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.458158', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1593, 'Primavera', 'PE', NULL, NULL, NULL, 2611408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.459513', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1594, 'Quipapa', 'PE', NULL, NULL, NULL, 2611507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.460461', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1595, 'Quixaba', 'PE', NULL, NULL, NULL, 2611533, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.461303', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1596, 'Recife', 'PE', NULL, NULL, NULL, 2611606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.462202', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1597, 'Riacho das Almas', 'PE', NULL, NULL, NULL, 2611705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.463132', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1598, 'Ribeirao', 'PE', NULL, NULL, NULL, 2611804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.464166', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1599, 'Rio Formoso', 'PE', NULL, NULL, NULL, 2611903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.46508', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1600, 'Saire', 'PE', NULL, NULL, NULL, 2612000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.466141', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1601, 'Salgadinho', 'PE', NULL, NULL, NULL, 2612109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.467057', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1602, 'Salgueiro', 'PE', NULL, NULL, NULL, 2612208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.467963', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1603, 'Saloa', 'PE', NULL, NULL, NULL, 2612307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.468887', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1604, 'Sanharo', 'PE', NULL, NULL, NULL, 2612406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.469786', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1605, 'Santa Cruz', 'PE', NULL, NULL, NULL, 2612455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.470673', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1606, 'Santa Cruz da Baixa Verde', 'PE', NULL, NULL, NULL, 2612471, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.471456', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1607, 'Santa Cruz do Capibaribe', 'PE', NULL, NULL, NULL, 2612505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.47243', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1608, 'Santa Filomena', 'PE', NULL, NULL, NULL, 2612554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.473203', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1609, 'Santa Maria da Boa Vista', 'PE', NULL, NULL, NULL, 2612604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.474049', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1610, 'Santa Maria do Cambuca', 'PE', NULL, NULL, NULL, 2612703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.474981', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1611, 'Santa Terezinha', 'PE', NULL, NULL, NULL, 2612802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.475798', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1612, 'Sao Benedito do Sul', 'PE', NULL, NULL, NULL, 2612901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.47664', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1613, 'Sao Bento do Una', 'PE', NULL, NULL, NULL, 2613008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.477417', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1614, 'Sao Caitano', 'PE', NULL, NULL, NULL, 2613107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.478275', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1615, 'Sao Joao', 'PE', NULL, NULL, NULL, 2613206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.479132', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1616, 'Sao Joaquim do Monte', 'PE', NULL, NULL, NULL, 2613305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.479973', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1617, 'Sao Jose da Coroa Grande', 'PE', NULL, NULL, NULL, 2613404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.48086', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1618, 'Sao Jose do Belmonte', 'PE', NULL, NULL, NULL, 2613503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.481801', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1619, 'Sao Jose do Egito', 'PE', NULL, NULL, NULL, 2613602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.482835', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1620, 'Sao Lourenco da Mata', 'PE', NULL, NULL, NULL, 2613701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.48371', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1621, 'Sao Vicente Ferrer', 'PE', NULL, NULL, NULL, 2613800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.484603', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1622, 'Serra Talhada', 'PE', NULL, NULL, NULL, 2613909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.485455', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1623, 'Serrita', 'PE', NULL, NULL, NULL, 2614006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.486433', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1624, 'Sertania', 'PE', NULL, NULL, NULL, 2614105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.487232', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1625, 'Sirinhaem', 'PE', NULL, NULL, NULL, 2614204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.48815', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1572, 'Moreilandia', 'PE', NULL, NULL, NULL, 2614303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.434075', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1626, 'Solidao', 'PE', NULL, NULL, NULL, 2614402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.489012', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1627, 'Surubim', 'PE', NULL, NULL, NULL, 2614501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.489863', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1628, 'Tabira', 'PE', NULL, NULL, NULL, 2614600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.490792', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1629, 'Tacaimbo', 'PE', NULL, NULL, NULL, 2614709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.491684', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1630, 'Tacaratu', 'PE', NULL, NULL, NULL, 2614808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.492321', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1631, 'Tamandare', 'PE', NULL, NULL, NULL, 2614857, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.49933', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1632, 'Taquaritinga do Norte', 'PE', NULL, NULL, NULL, 2615003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.500598', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1633, 'Terezinha', 'PE', NULL, NULL, NULL, 2615102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.501611', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1634, 'Terra Nova', 'PE', NULL, NULL, NULL, 2615201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.502516', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1635, 'Timbauba', 'PE', NULL, NULL, NULL, 2615300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.503375', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1636, 'Toritama', 'PE', NULL, NULL, NULL, 2615409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.504224', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1637, 'Tracunhaem', 'PE', NULL, NULL, NULL, 2615508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.505121', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1638, 'Trindade', 'PE', NULL, NULL, NULL, 2615607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.505974', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1639, 'Triunfo', 'PE', NULL, NULL, NULL, 2615706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.506916', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1640, 'Tupanatinga', 'PE', NULL, NULL, NULL, 2615805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.507922', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1641, 'Tuparetama', 'PE', NULL, NULL, NULL, 2615904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.508899', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1642, 'Venturosa', 'PE', NULL, NULL, NULL, 2616001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.509757', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1643, 'Verdejante', 'PE', NULL, NULL, NULL, 2616100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.510673', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1644, 'Vertente do Lerio', 'PE', NULL, NULL, NULL, 2616183, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.511529', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1645, 'Vertentes', 'PE', NULL, NULL, NULL, 2616209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.512415', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1646, 'Vicencia', 'PE', NULL, NULL, NULL, 2616308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.513303', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1647, 'Vitoria de Santo Antao', 'PE', NULL, NULL, NULL, 2616407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.51418', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1648, 'Xexeu', 'PE', NULL, NULL, NULL, 2616506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.515121', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1649, 'Agua Branca', 'AL', NULL, NULL, NULL, 2700102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.515958', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1650, 'Anadia', 'AL', NULL, NULL, NULL, 2700201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.516876', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1651, 'Arapiraca', 'AL', NULL, NULL, NULL, 2700300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.517813', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1652, 'Atalaia', 'AL', NULL, NULL, NULL, 2700409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.518801', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1653, 'Barra de Santo Antonio', 'AL', NULL, NULL, NULL, 2700508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.519858', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1654, 'Barra de Sao Miguel', 'AL', NULL, NULL, NULL, 2700607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.520772', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1655, 'Batalha', 'AL', NULL, NULL, NULL, 2700706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.521655', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1656, 'Belem', 'AL', NULL, NULL, NULL, 2700805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.522539', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1657, 'Belo Monte', 'AL', NULL, NULL, NULL, 2700904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.523412', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1658, 'Boca da Mata', 'AL', NULL, NULL, NULL, 2701001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.524257', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1659, 'Branquinha', 'AL', NULL, NULL, NULL, 2701100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.525049', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1660, 'Cacimbinhas', 'AL', NULL, NULL, NULL, 2701209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.525871', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1661, 'Cajueiro', 'AL', NULL, NULL, NULL, 2701308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.526778', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1662, 'Campestre', 'AL', NULL, NULL, NULL, 2701357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.527574', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1663, 'Campo Alegre', 'AL', NULL, NULL, NULL, 2701407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.528462', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1664, 'Campo Grande', 'AL', NULL, NULL, NULL, 2701506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.529366', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1665, 'Canapi', 'AL', NULL, NULL, NULL, 2701605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.5303', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1666, 'Capela', 'AL', NULL, NULL, NULL, 2701704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.531062', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1667, 'Carneiros', 'AL', NULL, NULL, NULL, 2701803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.531967', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1668, 'Cha Preta', 'AL', NULL, NULL, NULL, 2701902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.532762', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1669, 'Coite do Noia', 'AL', NULL, NULL, NULL, 2702009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.53981', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1670, 'Colonia Leopoldina', 'AL', NULL, NULL, NULL, 2702108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.540909', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1671, 'Coqueiro Seco', 'AL', NULL, NULL, NULL, 2702207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.541931', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1672, 'Coruripe', 'AL', NULL, NULL, NULL, 2702306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.542806', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1673, 'Craibas', 'AL', NULL, NULL, NULL, 2702355, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.543615', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1674, 'Delmiro Gouveia', 'AL', NULL, NULL, NULL, 2702405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.544416', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1675, 'Dois Riachos', 'AL', NULL, NULL, NULL, 2702504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.545079', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1676, 'Estrela de Alagoas', 'AL', NULL, NULL, NULL, 2702553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.545943', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1677, 'Feira Grande', 'AL', NULL, NULL, NULL, 2702603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.546837', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1678, 'Feliz Deserto', 'AL', NULL, NULL, NULL, 2702702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.547708', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1679, 'Flexeiras', 'AL', NULL, NULL, NULL, 2702801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.54858', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1680, 'Girau do Ponciano', 'AL', NULL, NULL, NULL, 2702900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.549416', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1681, 'Ibateguara', 'AL', NULL, NULL, NULL, 2703007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.550297', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1682, 'Igaci', 'AL', NULL, NULL, NULL, 2703106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.551161', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1683, 'Igreja Nova', 'AL', NULL, NULL, NULL, 2703205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.552215', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1684, 'Inhapi', 'AL', NULL, NULL, NULL, 2703304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.553518', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1685, 'Jacare dos Homens', 'AL', NULL, NULL, NULL, 2703403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.554435', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1686, 'Jacuipe', 'AL', NULL, NULL, NULL, 2703502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.555236', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1687, 'Japaratinga', 'AL', NULL, NULL, NULL, 2703601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.556108', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1688, 'Jaramataia', 'AL', NULL, NULL, NULL, 2703700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.556965', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1689, 'Jequia da Praia', 'AL', NULL, NULL, NULL, 2703759, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.557886', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1690, 'Joaquim Gomes', 'AL', NULL, NULL, NULL, 2703809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.558773', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1691, 'Jundia', 'AL', NULL, NULL, NULL, 2703908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.55955', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1692, 'Junqueiro', 'AL', NULL, NULL, NULL, 2704005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.560447', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1693, 'Lagoa da Canoa', 'AL', NULL, NULL, NULL, 2704104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.561361', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1694, 'Limoeiro de Anadia', 'AL', NULL, NULL, NULL, 2704203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.562239', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1695, 'Maceio', 'AL', NULL, NULL, NULL, 2704302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.563152', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1696, 'Major Isidoro', 'AL', NULL, NULL, NULL, 2704401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.564162', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1698, 'Maragogi', 'AL', NULL, NULL, NULL, 2704500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.566063', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1699, 'Maravilha', 'AL', NULL, NULL, NULL, 2704609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.566937', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1700, 'Marechal Deodoro', 'AL', NULL, NULL, NULL, 2704708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.56783', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1701, 'Maribondo', 'AL', NULL, NULL, NULL, 2704807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.568607', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1697, 'Mar Vermelho', 'AL', NULL, NULL, NULL, 2704906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.56511', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1702, 'Mata Grande', 'AL', NULL, NULL, NULL, 2705002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.569485', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1703, 'Matriz de Camaragibe', 'AL', NULL, NULL, NULL, 2705101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.570409', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1704, 'Messias', 'AL', NULL, NULL, NULL, 2705200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.57126', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1705, 'Minador do Negrao', 'AL', NULL, NULL, NULL, 2705309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.572177', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1706, 'Monteiropolis', 'AL', NULL, NULL, NULL, 2705408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.573135', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1707, 'Murici', 'AL', NULL, NULL, NULL, 2705507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.579953', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1708, 'Novo Lino', 'AL', NULL, NULL, NULL, 2705606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.58127', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1709, 'Olho D''agua das Flores', 'AL', NULL, NULL, NULL, 2705705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.582212', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1710, 'Olho D''agua do Casado', 'AL', NULL, NULL, NULL, 2705804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.583111', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1711, 'Olho D''agua Grande', 'AL', NULL, NULL, NULL, 2705903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.583997', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1712, 'Olivenca', 'AL', NULL, NULL, NULL, 2706000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.584857', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1713, 'Ouro Branco', 'AL', NULL, NULL, NULL, 2706109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.585722', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1714, 'Palestina', 'AL', NULL, NULL, NULL, 2706208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.58684', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1715, 'Palmeira dos Indios', 'AL', NULL, NULL, NULL, 2706307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.587745', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1716, 'Pao de Acucar', 'AL', NULL, NULL, NULL, 2706406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.58866', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1717, 'Pariconha', 'AL', NULL, NULL, NULL, 2706422, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.589445', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1718, 'Paripueira', 'AL', NULL, NULL, NULL, 2706448, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.590225', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1719, 'Passo de Camaragibe', 'AL', NULL, NULL, NULL, 2706505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.59101', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1720, 'Paulo Jacinto', 'AL', NULL, NULL, NULL, 2706604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.591854', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1721, 'Penedo', 'AL', NULL, NULL, NULL, 2706703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.592907', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1722, 'Piacabucu', 'AL', NULL, NULL, NULL, 2706802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.593907', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1723, 'Pilar', 'AL', NULL, NULL, NULL, 2706901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.594781', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1724, 'Pindoba', 'AL', NULL, NULL, NULL, 2707008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.595808', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1725, 'Piranhas', 'AL', NULL, NULL, NULL, 2707107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.596659', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1726, 'Poco das Trincheiras', 'AL', NULL, NULL, NULL, 2707206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.597518', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1727, 'Porto Calvo', 'AL', NULL, NULL, NULL, 2707305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.598531', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1728, 'Porto de Pedras', 'AL', NULL, NULL, NULL, 2707404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.599515', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1729, 'Porto Real do Colegio', 'AL', NULL, NULL, NULL, 2707503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.600386', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1730, 'Quebrangulo', 'AL', NULL, NULL, NULL, 2707602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.601248', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1731, 'Rio Largo', 'AL', NULL, NULL, NULL, 2707701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.602118', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1732, 'Roteiro', 'AL', NULL, NULL, NULL, 2707800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.602974', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1733, 'Santa Luzia do Norte', 'AL', NULL, NULL, NULL, 2707909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.60384', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1734, 'Santana do Ipanema', 'AL', NULL, NULL, NULL, 2708006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.604666', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1735, 'Santana do Mundau', 'AL', NULL, NULL, NULL, 2708105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.605464', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1736, 'Sao Bras', 'AL', NULL, NULL, NULL, 2708204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.60638', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1737, 'Sao Jose da Laje', 'AL', NULL, NULL, NULL, 2708303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.607218', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1738, 'Sao Jose da Tapera', 'AL', NULL, NULL, NULL, 2708402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.608123', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1739, 'Sao Luis do Quitunde', 'AL', NULL, NULL, NULL, 2708501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.609231', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1740, 'Sao Miguel dos Campos', 'AL', NULL, NULL, NULL, 2708600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.610109', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1741, 'Sao Miguel dos Milagres', 'AL', NULL, NULL, NULL, 2708709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.610971', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1742, 'Sao Sebastiao', 'AL', NULL, NULL, NULL, 2708808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.611868', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1743, 'Satuba', 'AL', NULL, NULL, NULL, 2708907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.612769', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1744, 'Senador Rui Palmeira', 'AL', NULL, NULL, NULL, 2708956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.61364', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1745, 'Tanque D''arca', 'AL', NULL, NULL, NULL, 2709004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.621045', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1746, 'Taquarana', 'AL', NULL, NULL, NULL, 2709103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.622171', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1747, 'Teotonio Vilela', 'AL', NULL, NULL, NULL, 2709152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.623156', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1748, 'Traipu', 'AL', NULL, NULL, NULL, 2709202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.624182', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1749, 'Uniao dos Palmares', 'AL', NULL, NULL, NULL, 2709301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.625153', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1750, 'Vicosa', 'AL', NULL, NULL, NULL, 2709400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.626119', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1751, 'Amparo de Sao Francisco', 'SE', NULL, NULL, NULL, 2800100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.626967', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1752, 'Aquidaba', 'SE', NULL, NULL, NULL, 2800209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.627865', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1753, 'Aracaju', 'SE', NULL, NULL, NULL, 2800308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.628811', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1754, 'Araua', 'SE', NULL, NULL, NULL, 2800407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.629694', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1755, 'Areia Branca', 'SE', NULL, NULL, NULL, 2800506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.630578', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1756, 'Barra dos Coqueiros', 'SE', NULL, NULL, NULL, 2800605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.631545', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1757, 'Boquim', 'SE', NULL, NULL, NULL, 2800670, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.632563', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1758, 'Brejo Grande', 'SE', NULL, NULL, NULL, 2800704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.633428', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1759, 'Campo do Brito', 'SE', NULL, NULL, NULL, 2801009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.63429', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1760, 'Canhoba', 'SE', NULL, NULL, NULL, 2801108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.635169', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1761, 'Caninde de Sao Francisco', 'SE', NULL, NULL, NULL, 2801207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.636006', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1762, 'Capela', 'SE', NULL, NULL, NULL, 2801306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.636835', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1763, 'Carira', 'SE', NULL, NULL, NULL, 2801405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.637698', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1764, 'Carmopolis', 'SE', NULL, NULL, NULL, 2801504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.638589', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1765, 'Cedro de Sao Joao', 'SE', NULL, NULL, NULL, 2801603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.639453', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1766, 'Cristinapolis', 'SE', NULL, NULL, NULL, 2801702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.640358', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1767, 'Cumbe', 'SE', NULL, NULL, NULL, 2801900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.641238', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1768, 'Divina Pastora', 'SE', NULL, NULL, NULL, 2802007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.642203', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1769, 'Estancia', 'SE', NULL, NULL, NULL, 2802106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.642975', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1770, 'Feira Nova', 'SE', NULL, NULL, NULL, 2802205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.643769', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1771, 'Frei Paulo', 'SE', NULL, NULL, NULL, 2802304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.64469', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1772, 'Gararu', 'SE', NULL, NULL, NULL, 2802403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.645572', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1773, 'General Maynard', 'SE', NULL, NULL, NULL, 2802502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.646491', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1774, 'Gracho Cardoso', 'SE', NULL, NULL, NULL, 2802601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.64737', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1775, 'Ilha das Flores', 'SE', NULL, NULL, NULL, 2802700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.648183', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1776, 'Indiaroba', 'SE', NULL, NULL, NULL, 2802809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.649012', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1777, 'Itabaiana', 'SE', NULL, NULL, NULL, 2802908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.649896', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1778, 'Itabaianinha', 'SE', NULL, NULL, NULL, 2803005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.650772', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1779, 'Itabi', 'SE', NULL, NULL, NULL, 2803104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.651642', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1857, 'Banzae', 'BA', NULL, NULL, NULL, 2902658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.733268', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1780, 'Itaporanga D''ajuda', 'SE', NULL, NULL, NULL, 2803203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.652555', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1781, 'Japaratuba', 'SE', NULL, NULL, NULL, 2803302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.653348', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1782, 'Japoata', 'SE', NULL, NULL, NULL, 2803401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.654107', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1783, 'Lagarto', 'SE', NULL, NULL, NULL, 2803500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.654821', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1784, 'Laranjeiras', 'SE', NULL, NULL, NULL, 2803609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.655682', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1785, 'Macambira', 'SE', NULL, NULL, NULL, 2803708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.661933', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1786, 'Malhada dos Bois', 'SE', NULL, NULL, NULL, 2803807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.663166', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1787, 'Malhador', 'SE', NULL, NULL, NULL, 2803906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.664217', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1788, 'Maruim', 'SE', NULL, NULL, NULL, 2804003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.665029', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1789, 'Moita Bonita', 'SE', NULL, NULL, NULL, 2804102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.665899', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1790, 'Monte Alegre de Sergipe', 'SE', NULL, NULL, NULL, 2804201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.666702', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1791, 'Muribeca', 'SE', NULL, NULL, NULL, 2804300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.667607', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1792, 'Neopolis', 'SE', NULL, NULL, NULL, 2804409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.668505', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1793, 'Nossa Senhora Aparecida', 'SE', NULL, NULL, NULL, 2804458, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.66942', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1794, 'Nossa Senhora da Gloria', 'SE', NULL, NULL, NULL, 2804508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.670251', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1795, 'Nossa Senhora das Dores', 'SE', NULL, NULL, NULL, 2804607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.671045', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1796, 'Nossa Senhora de Lourdes', 'SE', NULL, NULL, NULL, 2804706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.671969', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1797, 'Nossa Senhora do Socorro', 'SE', NULL, NULL, NULL, 2804805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.672835', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1798, 'Pacatuba', 'SE', NULL, NULL, NULL, 2804904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.673744', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1799, 'Pedra Mole', 'SE', NULL, NULL, NULL, 2805000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.674638', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1800, 'Pedrinhas', 'SE', NULL, NULL, NULL, 2805109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.675565', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1801, 'Pinhao', 'SE', NULL, NULL, NULL, 2805208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.676278', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1802, 'Pirambu', 'SE', NULL, NULL, NULL, 2805307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.677143', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1803, 'Poco Redondo', 'SE', NULL, NULL, NULL, 2805406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.67807', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1804, 'Poco Verde', 'SE', NULL, NULL, NULL, 2805505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.678996', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1805, 'Porto da Folha', 'SE', NULL, NULL, NULL, 2805604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.679867', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1806, 'Propria', 'SE', NULL, NULL, NULL, 2805703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.680723', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1807, 'Riachao do Dantas', 'SE', NULL, NULL, NULL, 2805802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.68163', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1808, 'Riachuelo', 'SE', NULL, NULL, NULL, 2805901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.68251', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1809, 'Ribeiropolis', 'SE', NULL, NULL, NULL, 2806008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.683399', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1810, 'Rosario do Catete', 'SE', NULL, NULL, NULL, 2806107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.684327', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1811, 'Salgado', 'SE', NULL, NULL, NULL, 2806206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.685208', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1812, 'Santa Luzia do Itanhy', 'SE', NULL, NULL, NULL, 2806305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.686053', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1814, 'Santana do Sao Francisco', 'SE', NULL, NULL, NULL, 2806404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.688243', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1813, 'Santa Rosa de Lima', 'SE', NULL, NULL, NULL, 2806503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.687431', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1815, 'Santo Amaro das Brotas', 'SE', NULL, NULL, NULL, 2806602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.689158', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1816, 'Sao Cristovao', 'SE', NULL, NULL, NULL, 2806701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.690023', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1817, 'Sao Domingos', 'SE', NULL, NULL, NULL, 2806800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.690888', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1818, 'Sao Francisco', 'SE', NULL, NULL, NULL, 2806909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.691767', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1819, 'Sao Miguel do Aleixo', 'SE', NULL, NULL, NULL, 2807006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.692583', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1820, 'Simao Dias', 'SE', NULL, NULL, NULL, 2807105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.693538', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1821, 'Siriri', 'SE', NULL, NULL, NULL, 2807204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.694316', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1822, 'Telha', 'SE', NULL, NULL, NULL, 2807303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.695302', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1823, 'Tobias Barreto', 'SE', NULL, NULL, NULL, 2807402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.696176', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1824, 'Tomar do Geru', 'SE', NULL, NULL, NULL, 2807501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.703912', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1825, 'Umbauba', 'SE', NULL, NULL, NULL, 2807600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.704998', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1826, 'Abaira', 'BA', NULL, NULL, NULL, 2900108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.705862', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1827, 'Abare', 'BA', NULL, NULL, NULL, 2900207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.706776', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1828, 'Acajutiba', 'BA', NULL, NULL, NULL, 2900306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.707772', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1829, 'Adustina', 'BA', NULL, NULL, NULL, 2900355, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.708678', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1830, 'Agua Fria', 'BA', NULL, NULL, NULL, 2900405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.709564', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1949, 'Erico Cardoso', 'BA', NULL, NULL, NULL, 2900504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.835874', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1831, 'Aiquara', 'BA', NULL, NULL, NULL, 2900603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.710453', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1832, 'Alagoinhas', 'BA', NULL, NULL, NULL, 2900702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.711342', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1833, 'Alcobaca', 'BA', NULL, NULL, NULL, 2900801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.712309', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1834, 'Almadina', 'BA', NULL, NULL, NULL, 2900900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.713183', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1835, 'Amargosa', 'BA', NULL, NULL, NULL, 2901007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.714102', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1836, 'Amelia Rodrigues', 'BA', NULL, NULL, NULL, 2901106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.714937', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1837, 'America Dourada', 'BA', NULL, NULL, NULL, 2901155, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.715822', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1838, 'Anage', 'BA', NULL, NULL, NULL, 2901205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.716687', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1839, 'Andarai', 'BA', NULL, NULL, NULL, 2901304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.717527', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1840, 'Andorinha', 'BA', NULL, NULL, NULL, 2901353, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.718396', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1841, 'Angical', 'BA', NULL, NULL, NULL, 2901403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.719204', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1842, 'Anguera', 'BA', NULL, NULL, NULL, 2901502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.720208', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1843, 'Antas', 'BA', NULL, NULL, NULL, 2901601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.720988', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1844, 'Antonio Cardoso', 'BA', NULL, NULL, NULL, 2901700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.721872', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1845, 'Antonio Goncalves', 'BA', NULL, NULL, NULL, 2901809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.72283', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1846, 'Apora', 'BA', NULL, NULL, NULL, 2901908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.723737', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1847, 'Apuarema', 'BA', NULL, NULL, NULL, 2901957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.72468', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1849, 'Aracatu', 'BA', NULL, NULL, NULL, 2902005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.72638', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1848, 'Aracas', 'BA', NULL, NULL, NULL, 2902054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.725609', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1850, 'Araci', 'BA', NULL, NULL, NULL, 2902104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.727157', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1851, 'Aramari', 'BA', NULL, NULL, NULL, 2902203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.727919', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1852, 'Arataca', 'BA', NULL, NULL, NULL, 2902252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.728798', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1853, 'Aratuipe', 'BA', NULL, NULL, NULL, 2902302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.729676', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1854, 'Aurelino Leal', 'BA', NULL, NULL, NULL, 2902401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.730623', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1855, 'Baianopolis', 'BA', NULL, NULL, NULL, 2902500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.731629', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1856, 'Baixa Grande', 'BA', NULL, NULL, NULL, 2902609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.732415', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1858, 'Barra', 'BA', NULL, NULL, NULL, 2902708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.734163', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1859, 'Barra da Estiva', 'BA', NULL, NULL, NULL, 2902807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.735027', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1860, 'Barra do Choca', 'BA', NULL, NULL, NULL, 2902906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.735986', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1861, 'Barra do Mendes', 'BA', NULL, NULL, NULL, 2903003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.736784', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1862, 'Barra do Rocha', 'BA', NULL, NULL, NULL, 2903102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.737614', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1863, 'Barreiras', 'BA', NULL, NULL, NULL, 2903201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.743632', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1864, 'Barro Alto', 'BA', NULL, NULL, NULL, 2903235, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.745185', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1865, 'Barrocas', 'BA', NULL, NULL, NULL, 2903276, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.746183', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1866, 'Belmonte', 'BA', NULL, NULL, NULL, 2903409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.747082', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1867, 'Belo Campo', 'BA', NULL, NULL, NULL, 2903508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.747989', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1868, 'Biritinga', 'BA', NULL, NULL, NULL, 2903607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.748862', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1869, 'Boa Nova', 'BA', NULL, NULL, NULL, 2903706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.749789', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1870, 'Boa Vista do Tupim', 'BA', NULL, NULL, NULL, 2903805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.750607', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1871, 'Bom Jesus da Lapa', 'BA', NULL, NULL, NULL, 2903904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.7516', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1872, 'Bom Jesus da Serra', 'BA', NULL, NULL, NULL, 2903953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.752527', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1873, 'Boninal', 'BA', NULL, NULL, NULL, 2904001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.753467', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1874, 'Bonito', 'BA', NULL, NULL, NULL, 2904050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.754333', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1875, 'Boquira', 'BA', NULL, NULL, NULL, 2904100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.755177', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1876, 'Botupora', 'BA', NULL, NULL, NULL, 2904209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.756099', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1877, 'Brejoes', 'BA', NULL, NULL, NULL, 2904308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.756961', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1878, 'Brejolandia', 'BA', NULL, NULL, NULL, 2904407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.757913', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1879, 'Brotas de Macaubas', 'BA', NULL, NULL, NULL, 2904506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.758779', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1880, 'Brumado', 'BA', NULL, NULL, NULL, 2904605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.759633', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1881, 'Buerarema', 'BA', NULL, NULL, NULL, 2904704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.760497', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1882, 'Buritirama', 'BA', NULL, NULL, NULL, 2904753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.761353', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1883, 'Caatiba', 'BA', NULL, NULL, NULL, 2904803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.762303', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1884, 'Cabaceiras do Paraguacu', 'BA', NULL, NULL, NULL, 2904852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.763755', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1885, 'Cachoeira', 'BA', NULL, NULL, NULL, 2904902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.764694', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1886, 'Cacule', 'BA', NULL, NULL, NULL, 2905008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.765572', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1887, 'Caem', 'BA', NULL, NULL, NULL, 2905107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.766486', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1888, 'Caetanos', 'BA', NULL, NULL, NULL, 2905156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.767347', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1889, 'Caetite', 'BA', NULL, NULL, NULL, 2905206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.768201', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1890, 'Cafarnaum', 'BA', NULL, NULL, NULL, 2905305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.769048', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1891, 'Cairu', 'BA', NULL, NULL, NULL, 2905404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.769993', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1892, 'Caldeirao Grande', 'BA', NULL, NULL, NULL, 2905503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.770885', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1893, 'Camacan', 'BA', NULL, NULL, NULL, 2905602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.771855', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1894, 'Camacari', 'BA', NULL, NULL, NULL, 2905701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.772719', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1895, 'Camamu', 'BA', NULL, NULL, NULL, 2905800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.773477', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1896, 'Campo Alegre de Lourdes', 'BA', NULL, NULL, NULL, 2905909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.774295', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1897, 'Campo Formoso', 'BA', NULL, NULL, NULL, 2906006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.775204', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1898, 'Canapolis', 'BA', NULL, NULL, NULL, 2906105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.776195', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1899, 'Canarana', 'BA', NULL, NULL, NULL, 2906204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.776955', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1900, 'Canavieiras', 'BA', NULL, NULL, NULL, 2906303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.777826', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1901, 'Candeal', 'BA', NULL, NULL, NULL, 2906402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.778621', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1902, 'Candeias', 'BA', NULL, NULL, NULL, 2906501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.785654', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1903, 'Candiba', 'BA', NULL, NULL, NULL, 2906600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.786875', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1904, 'Candido Sales', 'BA', NULL, NULL, NULL, 2906709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.787762', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1905, 'Cansancao', 'BA', NULL, NULL, NULL, 2906808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.788735', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1906, 'Canudos', 'BA', NULL, NULL, NULL, 2906824, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.789648', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1907, 'Capela do Alto Alegre', 'BA', NULL, NULL, NULL, 2906857, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.790552', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1908, 'Capim Grosso', 'BA', NULL, NULL, NULL, 2906873, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.791373', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1909, 'Caraibas', 'BA', NULL, NULL, NULL, 2906899, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.792368', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1910, 'Caravelas', 'BA', NULL, NULL, NULL, 2906907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.793239', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1911, 'Cardeal da Silva', 'BA', NULL, NULL, NULL, 2907004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.794153', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1912, 'Carinhanha', 'BA', NULL, NULL, NULL, 2907103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.795076', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1913, 'Casa Nova', 'BA', NULL, NULL, NULL, 2907202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.796126', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1914, 'Castro Alves', 'BA', NULL, NULL, NULL, 2907301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.797062', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1915, 'Catolandia', 'BA', NULL, NULL, NULL, 2907400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.797944', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1916, 'Catu', 'BA', NULL, NULL, NULL, 2907509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.798905', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1917, 'Caturama', 'BA', NULL, NULL, NULL, 2907558, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.799835', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1918, 'Central', 'BA', NULL, NULL, NULL, 2907608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.800762', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1919, 'Chorrocho', 'BA', NULL, NULL, NULL, 2907707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.801673', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1920, 'Cicero Dantas', 'BA', NULL, NULL, NULL, 2907806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.80256', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1921, 'Cipo', 'BA', NULL, NULL, NULL, 2907905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.803435', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1922, 'Coaraci', 'BA', NULL, NULL, NULL, 2908002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.804362', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1923, 'Cocos', 'BA', NULL, NULL, NULL, 2908101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.805142', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1924, 'Conceicao da Feira', 'BA', NULL, NULL, NULL, 2908200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.806049', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1925, 'Conceicao do Almeida', 'BA', NULL, NULL, NULL, 2908309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.80693', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1926, 'Conceicao do Coite', 'BA', NULL, NULL, NULL, 2908408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.807792', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1927, 'Conceicao do Jacuipe', 'BA', NULL, NULL, NULL, 2908507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.808715', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1928, 'Conde', 'BA', NULL, NULL, NULL, 2908606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.809636', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1929, 'Condeuba', 'BA', NULL, NULL, NULL, 2908705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.810398', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1930, 'Contendas do Sincora', 'BA', NULL, NULL, NULL, 2908804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.811224', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1931, 'Coracao de Maria', 'BA', NULL, NULL, NULL, 2908903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.812079', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1932, 'Cordeiros', 'BA', NULL, NULL, NULL, 2909000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.812982', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1933, 'Coribe', 'BA', NULL, NULL, NULL, 2909109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.81392', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1934, 'Coronel Joao Sa', 'BA', NULL, NULL, NULL, 2909208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.814844', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1935, 'Correntina', 'BA', NULL, NULL, NULL, 2909307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.815785', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1936, 'Cotegipe', 'BA', NULL, NULL, NULL, 2909406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.816686', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1937, 'Cravolandia', 'BA', NULL, NULL, NULL, 2909505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.817527', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1938, 'Crisopolis', 'BA', NULL, NULL, NULL, 2909604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.818343', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1939, 'Cristopolis', 'BA', NULL, NULL, NULL, 2909703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.819171', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1940, 'Cruz das Almas', 'BA', NULL, NULL, NULL, 2909802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.826554', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1941, 'Curaca', 'BA', NULL, NULL, NULL, 2909901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.827636', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1942, 'Dario Meira', 'BA', NULL, NULL, NULL, 2910008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.829405', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1943, 'Dias D''avila', 'BA', NULL, NULL, NULL, 2910057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.830489', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1944, 'Dom Basilio', 'BA', NULL, NULL, NULL, 2910107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.831352', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1945, 'Dom Macedo Costa', 'BA', NULL, NULL, NULL, 2910206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.83241', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1946, 'Elisio Medrado', 'BA', NULL, NULL, NULL, 2910305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.833251', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1947, 'Encruzilhada', 'BA', NULL, NULL, NULL, 2910404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.83412', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1948, 'Entre Rios', 'BA', NULL, NULL, NULL, 2910503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.835064', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1950, 'Esplanada', 'BA', NULL, NULL, NULL, 2910602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.836741', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1951, 'Euclides da Cunha', 'BA', NULL, NULL, NULL, 2910701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.837646', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1952, 'Eunapolis', 'BA', NULL, NULL, NULL, 2910727, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.838519', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1953, 'Fatima', 'BA', NULL, NULL, NULL, 2910750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.839335', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1954, 'Feira da Mata', 'BA', NULL, NULL, NULL, 2910776, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.840193', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1955, 'Feira de Santana', 'BA', NULL, NULL, NULL, 2910800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.841117', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1956, 'Filadelfia', 'BA', NULL, NULL, NULL, 2910859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.842011', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1957, 'Firmino Alves', 'BA', NULL, NULL, NULL, 2910909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.842944', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1958, 'Floresta Azul', 'BA', NULL, NULL, NULL, 2911006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.843755', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1959, 'Formosa do Rio Preto', 'BA', NULL, NULL, NULL, 2911105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.844635', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1960, 'Gandu', 'BA', NULL, NULL, NULL, 2911204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.845544', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1961, 'Gaviao', 'BA', NULL, NULL, NULL, 2911253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.846441', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1962, 'Gentio do Ouro', 'BA', NULL, NULL, NULL, 2911303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.847284', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1963, 'Gloria', 'BA', NULL, NULL, NULL, 2911402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.84819', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1964, 'Gongogi', 'BA', NULL, NULL, NULL, 2911501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.84909', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1966, 'Governador Mangabeira', 'BA', NULL, NULL, NULL, 2911600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.850857', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1967, 'Guajeru', 'BA', NULL, NULL, NULL, 2911659, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.85184', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1968, 'Guanambi', 'BA', NULL, NULL, NULL, 2911709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.852748', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1969, 'Guaratinga', 'BA', NULL, NULL, NULL, 2911808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.853646', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1970, 'Heliopolis', 'BA', NULL, NULL, NULL, 2911857, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.854517', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1971, 'Iacu', 'BA', NULL, NULL, NULL, 2911907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.855462', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1972, 'Ibiassuce', 'BA', NULL, NULL, NULL, 2912004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.856356', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1973, 'Ibicarai', 'BA', NULL, NULL, NULL, 2912103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.857175', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1974, 'Ibicoara', 'BA', NULL, NULL, NULL, 2912202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.858076', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1975, 'Ibicui', 'BA', NULL, NULL, NULL, 2912301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.858999', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1976, 'Ibipeba', 'BA', NULL, NULL, NULL, 2912400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.859993', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1977, 'Ibipitanga', 'BA', NULL, NULL, NULL, 2912509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.867007', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1978, 'Ibiquera', 'BA', NULL, NULL, NULL, 2912608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.868154', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1979, 'Ibirapitanga', 'BA', NULL, NULL, NULL, 2912707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.869284', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1980, 'Ibirapua', 'BA', NULL, NULL, NULL, 2912806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.870219', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1981, 'Ibirataia', 'BA', NULL, NULL, NULL, 2912905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.871155', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1982, 'Ibitiara', 'BA', NULL, NULL, NULL, 2913002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.872193', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1983, 'Ibitita', 'BA', NULL, NULL, NULL, 2913101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.873038', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1984, 'Ibotirama', 'BA', NULL, NULL, NULL, 2913200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.873833', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1985, 'Ichu', 'BA', NULL, NULL, NULL, 2913309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.874719', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1986, 'Igapora', 'BA', NULL, NULL, NULL, 2913408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.875578', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1987, 'Igrapiuna', 'BA', NULL, NULL, NULL, 2913457, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.876442', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1988, 'Iguai', 'BA', NULL, NULL, NULL, 2913507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.877337', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1989, 'Ilheus', 'BA', NULL, NULL, NULL, 2913606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.878226', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1990, 'Inhambupe', 'BA', NULL, NULL, NULL, 2913705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.87915', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1991, 'Ipecaeta', 'BA', NULL, NULL, NULL, 2913804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.880071', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1992, 'Ipiau', 'BA', NULL, NULL, NULL, 2913903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.880952', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1993, 'Ipira', 'BA', NULL, NULL, NULL, 2914000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.881831', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1994, 'Ipupiara', 'BA', NULL, NULL, NULL, 2914109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.882705', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1995, 'Irajuba', 'BA', NULL, NULL, NULL, 2914208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.883566', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1996, 'Iramaia', 'BA', NULL, NULL, NULL, 2914307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.88439', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1997, 'Iraquara', 'BA', NULL, NULL, NULL, 2914406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.885298', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1998, 'Irara', 'BA', NULL, NULL, NULL, 2914505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.886211', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (1999, 'Irece', 'BA', NULL, NULL, NULL, 2914604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.887131', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2000, 'Itabela', 'BA', NULL, NULL, NULL, 2914653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.88815', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2001, 'Itaberaba', 'BA', NULL, NULL, NULL, 2914703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.888959', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2002, 'Itabuna', 'BA', NULL, NULL, NULL, 2914802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.889845', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2003, 'Itacare', 'BA', NULL, NULL, NULL, 2914901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.890749', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2004, 'Itaete', 'BA', NULL, NULL, NULL, 2915007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.891611', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2005, 'Itagi', 'BA', NULL, NULL, NULL, 2915106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.892478', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2006, 'Itagiba', 'BA', NULL, NULL, NULL, 2915205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.893317', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2007, 'Itagimirim', 'BA', NULL, NULL, NULL, 2915304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.894412', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2008, 'Itaguacu da Bahia', 'BA', NULL, NULL, NULL, 2915353, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.895374', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2009, 'Itaju do Colonia', 'BA', NULL, NULL, NULL, 2915403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.896523', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2010, 'Itajuipe', 'BA', NULL, NULL, NULL, 2915502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.897461', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2011, 'Itamaraju', 'BA', NULL, NULL, NULL, 2915601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.898265', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2012, 'Itamari', 'BA', NULL, NULL, NULL, 2915700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.89943', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2013, 'Itambe', 'BA', NULL, NULL, NULL, 2915809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.900314', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2014, 'Itanagra', 'BA', NULL, NULL, NULL, 2915908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.901209', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2015, 'Itanhem', 'BA', NULL, NULL, NULL, 2916005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.902022', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2016, 'Itaparica', 'BA', NULL, NULL, NULL, 2916104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.906287', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2017, 'Itape', 'BA', NULL, NULL, NULL, 2916203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.909995', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2018, 'Itapebi', 'BA', NULL, NULL, NULL, 2916302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.911146', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2019, 'Itapetinga', 'BA', NULL, NULL, NULL, 2916401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.911973', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2020, 'Itapicuru', 'BA', NULL, NULL, NULL, 2916500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.913016', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2021, 'Itapitanga', 'BA', NULL, NULL, NULL, 2916609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.913895', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2022, 'Itaquara', 'BA', NULL, NULL, NULL, 2916708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.914769', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2023, 'Itarantim', 'BA', NULL, NULL, NULL, 2916807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.915654', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2024, 'Itatim', 'BA', NULL, NULL, NULL, 2916856, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.916552', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2025, 'Itirucu', 'BA', NULL, NULL, NULL, 2916906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.917472', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2026, 'Itiuba', 'BA', NULL, NULL, NULL, 2917003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.918303', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2027, 'Itororo', 'BA', NULL, NULL, NULL, 2917102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.919192', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2028, 'Ituacu', 'BA', NULL, NULL, NULL, 2917201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.920019', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2029, 'Itubera', 'BA', NULL, NULL, NULL, 2917300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.920842', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2030, 'Iuiu', 'BA', NULL, NULL, NULL, 2917334, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.921738', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2031, 'Jaborandi', 'BA', NULL, NULL, NULL, 2917359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.922718', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2032, 'Jacaraci', 'BA', NULL, NULL, NULL, 2917409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.923539', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2033, 'Jacobina', 'BA', NULL, NULL, NULL, 2917508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.92442', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2034, 'Jaguaquara', 'BA', NULL, NULL, NULL, 2917607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.925284', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2035, 'Jaguarari', 'BA', NULL, NULL, NULL, 2917706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.926186', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2036, 'Jaguaripe', 'BA', NULL, NULL, NULL, 2917805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.927091', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2037, 'Jandaira', 'BA', NULL, NULL, NULL, 2917904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.928038', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2038, 'Jequie', 'BA', NULL, NULL, NULL, 2918001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.928884', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2039, 'Jeremoabo', 'BA', NULL, NULL, NULL, 2918100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.929851', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2040, 'Jiquirica', 'BA', NULL, NULL, NULL, 2918209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.930853', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2041, 'Jitauna', 'BA', NULL, NULL, NULL, 2918308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.93178', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2042, 'Joao Dourado', 'BA', NULL, NULL, NULL, 2918357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.932709', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2043, 'Juazeiro', 'BA', NULL, NULL, NULL, 2918407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.933661', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2044, 'Jucurucu', 'BA', NULL, NULL, NULL, 2918456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.934595', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2045, 'Jussara', 'BA', NULL, NULL, NULL, 2918506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.935594', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2046, 'Jussari', 'BA', NULL, NULL, NULL, 2918555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.93641', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2047, 'Jussiape', 'BA', NULL, NULL, NULL, 2918605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.937255', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2048, 'Lafaiete Coutinho', 'BA', NULL, NULL, NULL, 2918704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.938148', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2049, 'Lagoa Real', 'BA', NULL, NULL, NULL, 2918753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.938963', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2050, 'Laje', 'BA', NULL, NULL, NULL, 2918803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.939756', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2051, 'Lajedao', 'BA', NULL, NULL, NULL, 2918902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.940684', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2052, 'Lajedinho', 'BA', NULL, NULL, NULL, 2919009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.941599', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2053, 'Lajedo do Tabocal', 'BA', NULL, NULL, NULL, 2919058, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.942474', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2054, 'Lamarao', 'BA', NULL, NULL, NULL, 2919108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.943451', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2055, 'Lapao', 'BA', NULL, NULL, NULL, 2919157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.947684', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2056, 'Lauro de Freitas', 'BA', NULL, NULL, NULL, 2919207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.951579', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2057, 'Lencois', 'BA', NULL, NULL, NULL, 2919306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.952621', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2058, 'Licinio de Almeida', 'BA', NULL, NULL, NULL, 2919405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.953576', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2059, 'Livramento de Nossa Senhora', 'BA', NULL, NULL, NULL, 2919504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.954557', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2060, 'Luis Eduardo Magalhaes', 'BA', NULL, NULL, NULL, 2919553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.955329', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2061, 'Macajuba', 'BA', NULL, NULL, NULL, 2919603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.956202', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2062, 'Macarani', 'BA', NULL, NULL, NULL, 2919702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.957096', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2063, 'Macaubas', 'BA', NULL, NULL, NULL, 2919801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.957889', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2064, 'Macurure', 'BA', NULL, NULL, NULL, 2919900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.958774', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2065, 'Madre de Deus', 'BA', NULL, NULL, NULL, 2919926, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.959587', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2066, 'Maetinga', 'BA', NULL, NULL, NULL, 2919959, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.960638', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2067, 'Maiquinique', 'BA', NULL, NULL, NULL, 2920007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.962121', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2068, 'Mairi', 'BA', NULL, NULL, NULL, 2920106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.963012', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2069, 'Malhada', 'BA', NULL, NULL, NULL, 2920205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.963901', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2070, 'Malhada de Pedras', 'BA', NULL, NULL, NULL, 2920304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.964883', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2071, 'Manoel Vitorino', 'BA', NULL, NULL, NULL, 2920403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.966277', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2072, 'Mansidao', 'BA', NULL, NULL, NULL, 2920452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.967204', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2073, 'Maracas', 'BA', NULL, NULL, NULL, 2920502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.968095', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2074, 'Maragogipe', 'BA', NULL, NULL, NULL, 2920601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.968973', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2075, 'Marau', 'BA', NULL, NULL, NULL, 2920700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.969912', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2076, 'Marcionilio Souza', 'BA', NULL, NULL, NULL, 2920809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.970761', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2077, 'Mascote', 'BA', NULL, NULL, NULL, 2920908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.971642', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2078, 'Mata de Sao Joao', 'BA', NULL, NULL, NULL, 2921005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.972526', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2079, 'Matina', 'BA', NULL, NULL, NULL, 2921054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.973388', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2080, 'Medeiros Neto', 'BA', NULL, NULL, NULL, 2921104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.974232', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2081, 'Miguel Calmon', 'BA', NULL, NULL, NULL, 2921203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.975182', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2082, 'Milagres', 'BA', NULL, NULL, NULL, 2921302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.976164', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2083, 'Mirangaba', 'BA', NULL, NULL, NULL, 2921401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.977016', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2084, 'Mirante', 'BA', NULL, NULL, NULL, 2921450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.977772', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2085, 'Monte Santo', 'BA', NULL, NULL, NULL, 2921500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.978653', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2086, 'Morpara', 'BA', NULL, NULL, NULL, 2921609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.979569', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2087, 'Morro do Chapeu', 'BA', NULL, NULL, NULL, 2921708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.980474', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2088, 'Mortugaba', 'BA', NULL, NULL, NULL, 2921807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.981328', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2089, 'Mucuge', 'BA', NULL, NULL, NULL, 2921906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.982184', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2090, 'Mucuri', 'BA', NULL, NULL, NULL, 2922003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.982993', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2091, 'Mulungu do Morro', 'BA', NULL, NULL, NULL, 2922052, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.983851', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2092, 'Mundo Novo', 'BA', NULL, NULL, NULL, 2922102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.984848', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2093, 'Muniz Ferreira', 'BA', NULL, NULL, NULL, 2922201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.996997', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2094, 'Muquem de Sao Francisco', 'BA', NULL, NULL, NULL, 2922250, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.998112', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2095, 'Muritiba', 'BA', NULL, NULL, NULL, 2922300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.999036', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2096, 'Mutuipe', 'BA', NULL, NULL, NULL, 2922409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.999876', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2097, 'Nazare', 'BA', NULL, NULL, NULL, 2922508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.000716', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2098, 'Nilo Pecanha', 'BA', NULL, NULL, NULL, 2922607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.001605', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2099, 'Nordestina', 'BA', NULL, NULL, NULL, 2922656, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.002445', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2100, 'Nova Canaa', 'BA', NULL, NULL, NULL, 2922706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.003325', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2101, 'Nova Fatima', 'BA', NULL, NULL, NULL, 2922730, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.004235', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2102, 'Nova Ibia', 'BA', NULL, NULL, NULL, 2922755, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.005107', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2103, 'Nova Itarana', 'BA', NULL, NULL, NULL, 2922805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.006013', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2104, 'Nova Redencao', 'BA', NULL, NULL, NULL, 2922854, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.006882', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2105, 'Nova Soure', 'BA', NULL, NULL, NULL, 2922904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.007768', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2106, 'Nova Vicosa', 'BA', NULL, NULL, NULL, 2923001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.008715', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2107, 'Novo Horizonte', 'BA', NULL, NULL, NULL, 2923035, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.009609', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2108, 'Novo Triunfo', 'BA', NULL, NULL, NULL, 2923050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.01077', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2109, 'Olindina', 'BA', NULL, NULL, NULL, 2923100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.011563', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2110, 'Oliveira dos Brejinhos', 'BA', NULL, NULL, NULL, 2923209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.012481', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2111, 'Ouricangas', 'BA', NULL, NULL, NULL, 2923308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.013345', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2112, 'Ourolandia', 'BA', NULL, NULL, NULL, 2923357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.014162', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2113, 'Palmas de Monte Alto', 'BA', NULL, NULL, NULL, 2923407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.015029', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2114, 'Palmeiras', 'BA', NULL, NULL, NULL, 2923506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.015951', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2115, 'Paramirim', 'BA', NULL, NULL, NULL, 2923605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.016875', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2116, 'Paratinga', 'BA', NULL, NULL, NULL, 2923704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.017719', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2117, 'Paripiranga', 'BA', NULL, NULL, NULL, 2923803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.018511', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2118, 'Pau Brasil', 'BA', NULL, NULL, NULL, 2923902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.019288', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2119, 'Paulo Afonso', 'BA', NULL, NULL, NULL, 2924009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.020202', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2120, 'Pe de Serra', 'BA', NULL, NULL, NULL, 2924058, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.021133', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2121, 'Pedrao', 'BA', NULL, NULL, NULL, 2924108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.022051', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2122, 'Pedro Alexandre', 'BA', NULL, NULL, NULL, 2924207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.022977', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2123, 'Piata', 'BA', NULL, NULL, NULL, 2924306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.023897', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2124, 'Pilao Arcado', 'BA', NULL, NULL, NULL, 2924405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.024776', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2125, 'Pindai', 'BA', NULL, NULL, NULL, 2924504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.025676', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2126, 'Pindobacu', 'BA', NULL, NULL, NULL, 2924603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.026444', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2127, 'Pintadas', 'BA', NULL, NULL, NULL, 2924652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.027298', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2128, 'Pirai do Norte', 'BA', NULL, NULL, NULL, 2924678, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.028163', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2129, 'Piripa', 'BA', NULL, NULL, NULL, 2924702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.028991', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2130, 'Piritiba', 'BA', NULL, NULL, NULL, 2924801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.02981', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2131, 'Planaltino', 'BA', NULL, NULL, NULL, 2924900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.030618', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2132, 'Planalto', 'BA', NULL, NULL, NULL, 2925006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.037238', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2133, 'Pocoes', 'BA', NULL, NULL, NULL, 2925105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.038394', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2134, 'Pojuca', 'BA', NULL, NULL, NULL, 2925204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.039305', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2135, 'Ponto Novo', 'BA', NULL, NULL, NULL, 2925253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.040288', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2136, 'Porto Seguro', 'BA', NULL, NULL, NULL, 2925303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.041156', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2137, 'Potiragua', 'BA', NULL, NULL, NULL, 2925402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.042018', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2138, 'Prado', 'BA', NULL, NULL, NULL, 2925501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.042931', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2139, 'Presidente Dutra', 'BA', NULL, NULL, NULL, 2925600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.04386', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2140, 'Presidente Janio Quadros', 'BA', NULL, NULL, NULL, 2925709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.044678', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2141, 'Presidente Tancredo Neves', 'BA', NULL, NULL, NULL, 2925758, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.045568', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2142, 'Queimadas', 'BA', NULL, NULL, NULL, 2925808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.046592', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2143, 'Quijingue', 'BA', NULL, NULL, NULL, 2925907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.047491', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2144, 'Quixabeira', 'BA', NULL, NULL, NULL, 2925931, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.04839', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2145, 'Rafael Jambeiro', 'BA', NULL, NULL, NULL, 2925956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.049242', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2146, 'Remanso', 'BA', NULL, NULL, NULL, 2926004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.050108', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2147, 'Retirolandia', 'BA', NULL, NULL, NULL, 2926103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.051116', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2148, 'Riachao das Neves', 'BA', NULL, NULL, NULL, 2926202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.051964', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2149, 'Riachao do Jacuipe', 'BA', NULL, NULL, NULL, 2926301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.052816', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2150, 'Riacho de Santana', 'BA', NULL, NULL, NULL, 2926400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.053696', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2151, 'Ribeira do Amparo', 'BA', NULL, NULL, NULL, 2926509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.054615', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2152, 'Ribeira do Pombal', 'BA', NULL, NULL, NULL, 2926608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.055463', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2153, 'Ribeirao do Largo', 'BA', NULL, NULL, NULL, 2926657, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.05629', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2154, 'Rio de Contas', 'BA', NULL, NULL, NULL, 2926707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.057205', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2155, 'Rio do Antonio', 'BA', NULL, NULL, NULL, 2926806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.058091', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2156, 'Rio do Pires', 'BA', NULL, NULL, NULL, 2926905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.059061', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2157, 'Rio Real', 'BA', NULL, NULL, NULL, 2927002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.0599', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2158, 'Rodelas', 'BA', NULL, NULL, NULL, 2927101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.060828', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2159, 'Ruy Barbosa', 'BA', NULL, NULL, NULL, 2927200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.061686', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2160, 'Salinas da Margarida', 'BA', NULL, NULL, NULL, 2927309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.062613', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2161, 'Salvador', 'BA', NULL, NULL, NULL, 2927408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.063432', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2162, 'Santa Barbara', 'BA', NULL, NULL, NULL, 2927507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.064199', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2163, 'Santa Brigida', 'BA', NULL, NULL, NULL, 2927606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.065113', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2164, 'Santa Cruz Cabralia', 'BA', NULL, NULL, NULL, 2927705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.066096', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2165, 'Santa Cruz da Vitoria', 'BA', NULL, NULL, NULL, 2927804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.066868', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2166, 'Santa Ines', 'BA', NULL, NULL, NULL, 2927903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.067781', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2171, 'Santaluz', 'BA', NULL, NULL, NULL, 2928000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.081182', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2167, 'Santa Luzia', 'BA', NULL, NULL, NULL, 2928059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.068555', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2168, 'Santa Maria da Vitoria', 'BA', NULL, NULL, NULL, 2928109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.069542', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2172, 'Santana', 'BA', NULL, NULL, NULL, 2928208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.082258', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2173, 'Santanopolis', 'BA', NULL, NULL, NULL, 2928307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.083118', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2169, 'Santa Rita de Cassia', 'BA', NULL, NULL, NULL, 2928406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.070478', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2170, 'Santa Teresinha', 'BA', NULL, NULL, NULL, 2928505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.071319', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2174, 'Santo Amaro', 'BA', NULL, NULL, NULL, 2928604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.083992', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2175, 'Santo Antonio de Jesus', 'BA', NULL, NULL, NULL, 2928703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.084795', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2176, 'Santo Estevao', 'BA', NULL, NULL, NULL, 2928802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.085639', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2177, 'Sao Desiderio', 'BA', NULL, NULL, NULL, 2928901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.086513', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2178, 'Sao Domingos', 'BA', NULL, NULL, NULL, 2928950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.087428', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2180, 'Sao Felix', 'BA', NULL, NULL, NULL, 2929008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.089086', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2181, 'Sao Felix do Coribe', 'BA', NULL, NULL, NULL, 2929057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.089995', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2179, 'Sao Felipe', 'BA', NULL, NULL, NULL, 2929107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.088306', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2182, 'Sao Francisco do Conde', 'BA', NULL, NULL, NULL, 2929206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.09092', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2183, 'Sao Gabriel', 'BA', NULL, NULL, NULL, 2929255, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.091797', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2184, 'Sao Goncalo dos Campos', 'BA', NULL, NULL, NULL, 2929305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.092756', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2185, 'Sao Jose da Vitoria', 'BA', NULL, NULL, NULL, 2929354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.093833', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2186, 'Sao Jose do Jacuipe', 'BA', NULL, NULL, NULL, 2929370, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.094768', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2187, 'Sao Miguel das Matas', 'BA', NULL, NULL, NULL, 2929404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.095662', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2188, 'Sao Sebastiao do Passe', 'BA', NULL, NULL, NULL, 2929503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.096542', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2189, 'Sapeacu', 'BA', NULL, NULL, NULL, 2929602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.09736', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2190, 'Satiro Dias', 'BA', NULL, NULL, NULL, 2929701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.09819', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2191, 'Saubara', 'BA', NULL, NULL, NULL, 2929750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.099108', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2192, 'Saude', 'BA', NULL, NULL, NULL, 2929800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.100012', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2193, 'Seabra', 'BA', NULL, NULL, NULL, 2929909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.100826', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2194, 'Sebastiao Laranjeiras', 'BA', NULL, NULL, NULL, 2930006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.101718', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2195, 'Senhor do Bonfim', 'BA', NULL, NULL, NULL, 2930105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.102614', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2197, 'Serra do Ramalho', 'BA', NULL, NULL, NULL, 2930154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.10448', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2196, 'Sento Se', 'BA', NULL, NULL, NULL, 2930204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.103547', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2198, 'Serra Dourada', 'BA', NULL, NULL, NULL, 2930303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.105375', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2199, 'Serra Preta', 'BA', NULL, NULL, NULL, 2930402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.106273', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2200, 'Serrinha', 'BA', NULL, NULL, NULL, 2930501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.107175', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2201, 'Serrolandia', 'BA', NULL, NULL, NULL, 2930600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.108078', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2202, 'Simoes Filho', 'BA', NULL, NULL, NULL, 2930709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.108929', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2203, 'Sitio do Mato', 'BA', NULL, NULL, NULL, 2930758, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.109993', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2204, 'Sitio do Quinto', 'BA', NULL, NULL, NULL, 2930766, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.11146', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2205, 'Sobradinho', 'BA', NULL, NULL, NULL, 2930774, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.112381', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2206, 'Souto Soares', 'BA', NULL, NULL, NULL, 2930808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.113153', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2207, 'Tabocas do Brejo Velho', 'BA', NULL, NULL, NULL, 2930907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.113976', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2208, 'Tanhacu', 'BA', NULL, NULL, NULL, 2931004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.114785', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2209, 'Tanque Novo', 'BA', NULL, NULL, NULL, 2931053, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.121459', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2210, 'Tanquinho', 'BA', NULL, NULL, NULL, 2931103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.122594', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2211, 'Taperoa', 'BA', NULL, NULL, NULL, 2931202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.123519', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2212, 'Tapiramuta', 'BA', NULL, NULL, NULL, 2931301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.124406', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2213, 'Teixeira de Freitas', 'BA', NULL, NULL, NULL, 2931350, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.125229', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2214, 'Teodoro Sampaio', 'BA', NULL, NULL, NULL, 2931400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.126164', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2215, 'Teofilandia', 'BA', NULL, NULL, NULL, 2931509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.127128', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2216, 'Teolandia', 'BA', NULL, NULL, NULL, 2931608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.128089', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2217, 'Terra Nova', 'BA', NULL, NULL, NULL, 2931707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.129228', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2218, 'Tremedal', 'BA', NULL, NULL, NULL, 2931806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.130582', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2219, 'Tucano', 'BA', NULL, NULL, NULL, 2931905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.132366', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2220, 'Uaua', 'BA', NULL, NULL, NULL, 2932002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.133639', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2221, 'Ubaira', 'BA', NULL, NULL, NULL, 2932101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.134487', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2222, 'Ubaitaba', 'BA', NULL, NULL, NULL, 2932200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.135357', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2223, 'Ubata', 'BA', NULL, NULL, NULL, 2932309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.136179', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2224, 'Uibai', 'BA', NULL, NULL, NULL, 2932408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.136978', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2225, 'Umburanas', 'BA', NULL, NULL, NULL, 2932457, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.137875', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2226, 'Una', 'BA', NULL, NULL, NULL, 2932507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.138736', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2227, 'Urandi', 'BA', NULL, NULL, NULL, 2932606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.139603', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2228, 'Urucuca', 'BA', NULL, NULL, NULL, 2932705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.14047', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2229, 'Utinga', 'BA', NULL, NULL, NULL, 2932804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.14136', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2230, 'Valenca', 'BA', NULL, NULL, NULL, 2932903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.142211', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2231, 'Valente', 'BA', NULL, NULL, NULL, 2933000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.143101', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2232, 'Varzea da Roca', 'BA', NULL, NULL, NULL, 2933059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.144044', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2233, 'Varzea do Poco', 'BA', NULL, NULL, NULL, 2933109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.145026', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2234, 'Varzea Nova', 'BA', NULL, NULL, NULL, 2933158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.145932', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2235, 'Varzedo', 'BA', NULL, NULL, NULL, 2933174, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.146908', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2236, 'Vera Cruz', 'BA', NULL, NULL, NULL, 2933208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.147866', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2237, 'Vereda', 'BA', NULL, NULL, NULL, 2933257, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.148738', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2238, 'Vitoria da Conquista', 'BA', NULL, NULL, NULL, 2933307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.149664', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2239, 'Wagner', 'BA', NULL, NULL, NULL, 2933406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.150535', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2240, 'Wanderley', 'BA', NULL, NULL, NULL, 2933455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.151529', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2241, 'Wenceslau Guimaraes', 'BA', NULL, NULL, NULL, 2933505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.152442', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2242, 'Xique-xique', 'BA', NULL, NULL, NULL, 2933604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.153258', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2243, 'Abadia dos Dourados', 'MG', NULL, NULL, NULL, 3100104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.154189', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2244, 'Abaete', 'MG', NULL, NULL, NULL, 3100203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.155248', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2245, 'Abre Campo', 'MG', NULL, NULL, NULL, 3100302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.158797', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2246, 'Acaiaca', 'MG', NULL, NULL, NULL, 3100401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.164872', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2247, 'Acucena', 'MG', NULL, NULL, NULL, 3100500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.166041', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2248, 'Agua Boa', 'MG', NULL, NULL, NULL, 3100609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.166914', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2249, 'Agua Comprida', 'MG', NULL, NULL, NULL, 3100708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.167694', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2250, 'Aguanil', 'MG', NULL, NULL, NULL, 3100807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.168652', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2251, 'Aguas Formosas', 'MG', NULL, NULL, NULL, 3100906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.169451', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2252, 'Aguas Vermelhas', 'MG', NULL, NULL, NULL, 3101003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.170365', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2253, 'Aimores', 'MG', NULL, NULL, NULL, 3101102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.171249', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2254, 'Aiuruoca', 'MG', NULL, NULL, NULL, 3101201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.172198', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2255, 'Alagoa', 'MG', NULL, NULL, NULL, 3101300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.17309', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2256, 'Albertina', 'MG', NULL, NULL, NULL, 3101409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.174065', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2257, 'Alem Paraiba', 'MG', NULL, NULL, NULL, 3101508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.175052', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2258, 'Alfenas', 'MG', NULL, NULL, NULL, 3101607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.176142', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2259, 'Alfredo Vasconcelos', 'MG', NULL, NULL, NULL, 3101631, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.177086', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2260, 'Almenara', 'MG', NULL, NULL, NULL, 3101706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.17799', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2261, 'Alpercata', 'MG', NULL, NULL, NULL, 3101805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.178942', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2262, 'Alpinopolis', 'MG', NULL, NULL, NULL, 3101904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.179848', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2263, 'Alterosa', 'MG', NULL, NULL, NULL, 3102001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.180759', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2264, 'Alto Caparao', 'MG', NULL, NULL, NULL, 3102050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.181657', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2266, 'Alto Rio Doce', 'MG', NULL, NULL, NULL, 3102100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.183515', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2267, 'Alvarenga', 'MG', NULL, NULL, NULL, 3102209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.184402', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2268, 'Alvinopolis', 'MG', NULL, NULL, NULL, 3102308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.185229', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2269, 'Alvorada de Minas', 'MG', NULL, NULL, NULL, 3102407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.186152', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2270, 'Amparo do Serra', 'MG', NULL, NULL, NULL, 3102506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.187321', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2271, 'Andradas', 'MG', NULL, NULL, NULL, 3102605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.188228', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2349, 'Cachoeira de Pajeu', 'MG', NULL, NULL, NULL, 3102704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.269483', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2272, 'Andrelandia', 'MG', NULL, NULL, NULL, 3102803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.189253', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2273, 'Angelandia', 'MG', NULL, NULL, NULL, 3102852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.190148', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2274, 'Antonio Carlos', 'MG', NULL, NULL, NULL, 3102902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.19103', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2275, 'Antonio Dias', 'MG', NULL, NULL, NULL, 3103009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.191859', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2276, 'Antonio Prado de Minas', 'MG', NULL, NULL, NULL, 3103108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.192799', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2277, 'Aracai', 'MG', NULL, NULL, NULL, 3103207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.193762', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2278, 'Aracitaba', 'MG', NULL, NULL, NULL, 3103306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.194635', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2279, 'Aracuai', 'MG', NULL, NULL, NULL, 3103405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.195558', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2280, 'Araguari', 'MG', NULL, NULL, NULL, 3103504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.196367', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2281, 'Arantina', 'MG', NULL, NULL, NULL, 3103603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.197243', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2282, 'Araponga', 'MG', NULL, NULL, NULL, 3103702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.198178', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2283, 'Arapora', 'MG', NULL, NULL, NULL, 3103751, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.203217', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2284, 'Arapua', 'MG', NULL, NULL, NULL, 3103801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.205244', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2285, 'Araujos', 'MG', NULL, NULL, NULL, 3103900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.206219', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2286, 'Araxa', 'MG', NULL, NULL, NULL, 3104007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.207117', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2287, 'Arceburgo', 'MG', NULL, NULL, NULL, 3104106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.207902', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2288, 'Arcos', 'MG', NULL, NULL, NULL, 3104205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.208814', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2289, 'Areado', 'MG', NULL, NULL, NULL, 3104304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.209723', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2290, 'Argirita', 'MG', NULL, NULL, NULL, 3104403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.210605', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2291, 'Aricanduva', 'MG', NULL, NULL, NULL, 3104452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.211483', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2292, 'Arinos', 'MG', NULL, NULL, NULL, 3104502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.212377', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2293, 'Astolfo Dutra', 'MG', NULL, NULL, NULL, 3104601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.213327', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2294, 'Ataleia', 'MG', NULL, NULL, NULL, 3104700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.214154', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2295, 'Augusto de Lima', 'MG', NULL, NULL, NULL, 3104809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.21493', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2296, 'Baependi', 'MG', NULL, NULL, NULL, 3104908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.215936', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2297, 'Baldim', 'MG', NULL, NULL, NULL, 3105004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.216871', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2298, 'Bambui', 'MG', NULL, NULL, NULL, 3105103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.217768', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2299, 'Bandeira', 'MG', NULL, NULL, NULL, 3105202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.218649', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2300, 'Bandeira do Sul', 'MG', NULL, NULL, NULL, 3105301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.219508', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2301, 'Barao de Cocais', 'MG', NULL, NULL, NULL, 3105400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.220377', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2302, 'Barao de Monte Alto', 'MG', NULL, NULL, NULL, 3105509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.221268', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2303, 'Barbacena', 'MG', NULL, NULL, NULL, 3105608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.222198', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2304, 'Barra Longa', 'MG', NULL, NULL, NULL, 3105707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.223036', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2305, 'Barroso', 'MG', NULL, NULL, NULL, 3105905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.22391', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2306, 'Bela Vista de Minas', 'MG', NULL, NULL, NULL, 3106002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.224974', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2307, 'Belmiro Braga', 'MG', NULL, NULL, NULL, 3106101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.225963', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2308, 'Belo Horizonte', 'MG', NULL, NULL, NULL, 3106200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.227024', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2309, 'Belo Oriente', 'MG', NULL, NULL, NULL, 3106309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.227973', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2310, 'Belo Vale', 'MG', NULL, NULL, NULL, 3106408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.228893', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2311, 'Berilo', 'MG', NULL, NULL, NULL, 3106507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.229677', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2313, 'Bertopolis', 'MG', NULL, NULL, NULL, 3106606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.23149', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2312, 'Berizal', 'MG', NULL, NULL, NULL, 3106655, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.230571', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2314, 'Betim', 'MG', NULL, NULL, NULL, 3106705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.232321', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2315, 'Bias Fortes', 'MG', NULL, NULL, NULL, 3106804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.233321', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2316, 'Bicas', 'MG', NULL, NULL, NULL, 3106903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.23414', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2317, 'Biquinhas', 'MG', NULL, NULL, NULL, 3107000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.234928', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2318, 'Boa Esperanca', 'MG', NULL, NULL, NULL, 3107109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.235855', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2319, 'Bocaina de Minas', 'MG', NULL, NULL, NULL, 3107208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.236779', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2320, 'Bocaiuva', 'MG', NULL, NULL, NULL, 3107307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.23773', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2321, 'Bom Despacho', 'MG', NULL, NULL, NULL, 3107406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.23865', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2322, 'Bom Jardim de Minas', 'MG', NULL, NULL, NULL, 3107505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.239378', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2323, 'Bom Jesus da Penha', 'MG', NULL, NULL, NULL, 3107604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.245946', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2324, 'Bom Jesus do Amparo', 'MG', NULL, NULL, NULL, 3107703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.246959', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2325, 'Bom Jesus do Galho', 'MG', NULL, NULL, NULL, 3107802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.247908', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2326, 'Bom Repouso', 'MG', NULL, NULL, NULL, 3107901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.248786', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2327, 'Bom Sucesso', 'MG', NULL, NULL, NULL, 3108008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.249675', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2328, 'Bonfim', 'MG', NULL, NULL, NULL, 3108107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.250542', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2329, 'Bonfinopolis de Minas', 'MG', NULL, NULL, NULL, 3108206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.251343', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2330, 'Bonito de Minas', 'MG', NULL, NULL, NULL, 3108255, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.252162', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2331, 'Borda da Mata', 'MG', NULL, NULL, NULL, 3108305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.253039', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2332, 'Botelhos', 'MG', NULL, NULL, NULL, 3108404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.253931', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2333, 'Botumirim', 'MG', NULL, NULL, NULL, 3108503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.254856', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2335, 'Brasilandia de Minas', 'MG', NULL, NULL, NULL, 3108552, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.256563', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2336, 'Brasilia de Minas', 'MG', NULL, NULL, NULL, 3108602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.257427', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2334, 'Bras Pires', 'MG', NULL, NULL, NULL, 3108701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.255745', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2338, 'Braunas', 'MG', NULL, NULL, NULL, 3108800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.259273', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2339, 'Brumadinho', 'MG', NULL, NULL, NULL, 3109006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.260042', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2340, 'Bueno Brandao', 'MG', NULL, NULL, NULL, 3109105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.260966', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2341, 'Buenopolis', 'MG', NULL, NULL, NULL, 3109204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.261895', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2342, 'Bugre', 'MG', NULL, NULL, NULL, 3109253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.262933', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2343, 'Buritis', 'MG', NULL, NULL, NULL, 3109303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.263793', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2344, 'Buritizeiro', 'MG', NULL, NULL, NULL, 3109402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.264812', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2345, 'Cabeceira Grande', 'MG', NULL, NULL, NULL, 3109451, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.265722', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2346, 'Cabo Verde', 'MG', NULL, NULL, NULL, 3109501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.266748', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2347, 'Cachoeira da Prata', 'MG', NULL, NULL, NULL, 3109600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.267638', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2348, 'Cachoeira de Minas', 'MG', NULL, NULL, NULL, 3109709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.268607', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2350, 'Cachoeira Dourada', 'MG', NULL, NULL, NULL, 3109808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.270382', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2351, 'Caetanopolis', 'MG', NULL, NULL, NULL, 3109907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.271481', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2352, 'Caete', 'MG', NULL, NULL, NULL, 3110004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.272398', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2353, 'Caiana', 'MG', NULL, NULL, NULL, 3110103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.273259', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2354, 'Cajuri', 'MG', NULL, NULL, NULL, 3110202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.274121', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2355, 'Caldas', 'MG', NULL, NULL, NULL, 3110301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.275028', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2356, 'Camacho', 'MG', NULL, NULL, NULL, 3110400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.275929', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2357, 'Camanducaia', 'MG', NULL, NULL, NULL, 3110509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.27681', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2358, 'Cambui', 'MG', NULL, NULL, NULL, 3110608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.277738', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2359, 'Cambuquira', 'MG', NULL, NULL, NULL, 3110707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.278606', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2360, 'Campanario', 'MG', NULL, NULL, NULL, 3110806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.279653', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2361, 'Campanha', 'MG', NULL, NULL, NULL, 3110905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.28044', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2362, 'Campestre', 'MG', NULL, NULL, NULL, 3111002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.286607', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2363, 'Campina Verde', 'MG', NULL, NULL, NULL, 3111101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.287827', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2364, 'Campo Azul', 'MG', NULL, NULL, NULL, 3111150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.288775', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2365, 'Campo Belo', 'MG', NULL, NULL, NULL, 3111200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.289665', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2366, 'Campo do Meio', 'MG', NULL, NULL, NULL, 3111309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.290592', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2367, 'Campo Florido', 'MG', NULL, NULL, NULL, 3111408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.291403', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2368, 'Campos Altos', 'MG', NULL, NULL, NULL, 3111507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.292443', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2369, 'Campos Gerais', 'MG', NULL, NULL, NULL, 3111606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.293274', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2371, 'Canaa', 'MG', NULL, NULL, NULL, 3111705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.295135', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2372, 'Canapolis', 'MG', NULL, NULL, NULL, 3111804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.296192', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2370, 'Cana Verde', 'MG', NULL, NULL, NULL, 3111903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.294208', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2373, 'Candeias', 'MG', NULL, NULL, NULL, 3112000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.297115', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2374, 'Cantagalo', 'MG', NULL, NULL, NULL, 3112059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.297958', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2375, 'Caparao', 'MG', NULL, NULL, NULL, 3112109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.298869', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2376, 'Capela Nova', 'MG', NULL, NULL, NULL, 3112208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.299725', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2377, 'Capelinha', 'MG', NULL, NULL, NULL, 3112307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.300742', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2378, 'Capetinga', 'MG', NULL, NULL, NULL, 3112406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.301628', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2379, 'Capim Branco', 'MG', NULL, NULL, NULL, 3112505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.302484', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2380, 'Capinopolis', 'MG', NULL, NULL, NULL, 3112604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.303332', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2381, 'Capitao Andrade', 'MG', NULL, NULL, NULL, 3112653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.304204', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2382, 'Capitao Eneas', 'MG', NULL, NULL, NULL, 3112703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.304996', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2383, 'Capitolio', 'MG', NULL, NULL, NULL, 3112802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.305772', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2384, 'Caputira', 'MG', NULL, NULL, NULL, 3112901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.306769', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2385, 'Carai', 'MG', NULL, NULL, NULL, 3113008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.307704', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2386, 'Caranaiba', 'MG', NULL, NULL, NULL, 3113107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.308589', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2387, 'Carandai', 'MG', NULL, NULL, NULL, 3113206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.309503', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2388, 'Carangola', 'MG', NULL, NULL, NULL, 3113305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.310414', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2389, 'Caratinga', 'MG', NULL, NULL, NULL, 3113404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.311411', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2390, 'Carbonita', 'MG', NULL, NULL, NULL, 3113503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.312275', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2391, 'Careacu', 'MG', NULL, NULL, NULL, 3113602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.313165', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2392, 'Carlos Chagas', 'MG', NULL, NULL, NULL, 3113701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.313963', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2393, 'Carmesia', 'MG', NULL, NULL, NULL, 3113800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.31478', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2394, 'Carmo da Cachoeira', 'MG', NULL, NULL, NULL, 3113909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.31565', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2395, 'Carmo da Mata', 'MG', NULL, NULL, NULL, 3114006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.316547', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2396, 'Carmo de Minas', 'MG', NULL, NULL, NULL, 3114105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.317444', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2397, 'Carmo do Cajuru', 'MG', NULL, NULL, NULL, 3114204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.318302', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2398, 'Carmo do Paranaiba', 'MG', NULL, NULL, NULL, 3114303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.319164', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2399, 'Carmo do Rio Claro', 'MG', NULL, NULL, NULL, 3114402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.320006', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2400, 'Carmopolis de Minas', 'MG', NULL, NULL, NULL, 3114501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.326946', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2401, 'Carneirinho', 'MG', NULL, NULL, NULL, 3114550, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.328069', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2402, 'Carrancas', 'MG', NULL, NULL, NULL, 3114600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.328901', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2403, 'Carvalhopolis', 'MG', NULL, NULL, NULL, 3114709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.329932', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2404, 'Carvalhos', 'MG', NULL, NULL, NULL, 3114808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.33101', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2405, 'Casa Grande', 'MG', NULL, NULL, NULL, 3114907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.331982', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2406, 'Cascalho Rico', 'MG', NULL, NULL, NULL, 3115003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.333627', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2407, 'Cassia', 'MG', NULL, NULL, NULL, 3115102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.334661', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2431, 'Conceicao da Barra de Minas', 'MG', NULL, NULL, NULL, 3115201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.356084', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2408, 'Cataguases', 'MG', NULL, NULL, NULL, 3115300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.335576', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2409, 'Catas Altas', 'MG', NULL, NULL, NULL, 3115359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.336441', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2410, 'Catas Altas da Noruega', 'MG', NULL, NULL, NULL, 3115409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.337408', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2411, 'Catuji', 'MG', NULL, NULL, NULL, 3115458, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.338303', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2412, 'Catuti', 'MG', NULL, NULL, NULL, 3115474, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.339177', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2413, 'Caxambu', 'MG', NULL, NULL, NULL, 3115508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.340022', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2414, 'Cedro do Abaete', 'MG', NULL, NULL, NULL, 3115607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.3409', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2415, 'Central de Minas', 'MG', NULL, NULL, NULL, 3115706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.341802', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2416, 'Centralina', 'MG', NULL, NULL, NULL, 3115805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.342707', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2417, 'Chacara', 'MG', NULL, NULL, NULL, 3115904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.343615', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2418, 'Chale', 'MG', NULL, NULL, NULL, 3116001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.344519', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2419, 'Chapada do Norte', 'MG', NULL, NULL, NULL, 3116100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.345402', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2420, 'Chapada Gaucha', 'MG', NULL, NULL, NULL, 3116159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.346221', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2421, 'Chiador', 'MG', NULL, NULL, NULL, 3116209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.347172', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2422, 'Cipotanea', 'MG', NULL, NULL, NULL, 3116308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.348109', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2423, 'Claraval', 'MG', NULL, NULL, NULL, 3116407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.349067', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2424, 'Claro dos Pocoes', 'MG', NULL, NULL, NULL, 3116506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.349954', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2425, 'Claudio', 'MG', NULL, NULL, NULL, 3116605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.350815', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2426, 'Coimbra', 'MG', NULL, NULL, NULL, 3116704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.351681', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2427, 'Coluna', 'MG', NULL, NULL, NULL, 3116803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.352366', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2428, 'Comendador Gomes', 'MG', NULL, NULL, NULL, 3116902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.353256', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2429, 'Comercinho', 'MG', NULL, NULL, NULL, 3117009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.354197', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2430, 'Conceicao da Aparecida', 'MG', NULL, NULL, NULL, 3117108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.355049', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2433, 'Conceicao das Pedras', 'MG', NULL, NULL, NULL, 3117207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.357787', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2432, 'Conceicao das Alagoas', 'MG', NULL, NULL, NULL, 3117306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.356889', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2434, 'Conceicao de Ipanema', 'MG', NULL, NULL, NULL, 3117405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.358793', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2435, 'Conceicao do Mato Dentro', 'MG', NULL, NULL, NULL, 3117504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.35965', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2436, 'Conceicao do Para', 'MG', NULL, NULL, NULL, 3117603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.360602', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2437, 'Conceicao do Rio Verde', 'MG', NULL, NULL, NULL, 3117702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.367362', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2438, 'Conceicao dos Ouros', 'MG', NULL, NULL, NULL, 3117801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.368535', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2439, 'Conego Marinho', 'MG', NULL, NULL, NULL, 3117836, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.369512', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2440, 'Confins', 'MG', NULL, NULL, NULL, 3117876, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.370463', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2441, 'Congonhal', 'MG', NULL, NULL, NULL, 3117900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.371375', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2442, 'Congonhas', 'MG', NULL, NULL, NULL, 3118007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.372194', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2443, 'Congonhas do Norte', 'MG', NULL, NULL, NULL, 3118106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.37302', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2444, 'Conquista', 'MG', NULL, NULL, NULL, 3118205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.373929', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2445, 'Conselheiro Lafaiete', 'MG', NULL, NULL, NULL, 3118304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.374849', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2446, 'Conselheiro Pena', 'MG', NULL, NULL, NULL, 3118403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.375761', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2447, 'Consolacao', 'MG', NULL, NULL, NULL, 3118502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.376643', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2448, 'Contagem', 'MG', NULL, NULL, NULL, 3118601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.377562', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2449, 'Coqueiral', 'MG', NULL, NULL, NULL, 3118700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.37849', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2450, 'Coracao de Jesus', 'MG', NULL, NULL, NULL, 3118809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.379263', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2451, 'Cordisburgo', 'MG', NULL, NULL, NULL, 3118908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.380177', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2452, 'Cordislandia', 'MG', NULL, NULL, NULL, 3119005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.381011', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2453, 'Corinto', 'MG', NULL, NULL, NULL, 3119104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.381868', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2454, 'Coroaci', 'MG', NULL, NULL, NULL, 3119203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.38272', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2455, 'Coromandel', 'MG', NULL, NULL, NULL, 3119302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.38355', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2456, 'Coronel Fabriciano', 'MG', NULL, NULL, NULL, 3119401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.384524', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2457, 'Coronel Murta', 'MG', NULL, NULL, NULL, 3119500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.385391', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2458, 'Coronel Pacheco', 'MG', NULL, NULL, NULL, 3119609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.386312', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2459, 'Coronel Xavier Chaves', 'MG', NULL, NULL, NULL, 3119708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.387358', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2460, 'Corrego Danta', 'MG', NULL, NULL, NULL, 3119807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.388301', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2461, 'Corrego do Bom Jesus', 'MG', NULL, NULL, NULL, 3119906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.389213', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2462, 'Corrego Fundo', 'MG', NULL, NULL, NULL, 3119955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.390263', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2463, 'Corrego Novo', 'MG', NULL, NULL, NULL, 3120003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.391202', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2464, 'Couto de Magalhaes de Minas', 'MG', NULL, NULL, NULL, 3120102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.392311', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2465, 'Crisolita', 'MG', NULL, NULL, NULL, 3120151, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.393212', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2466, 'Cristais', 'MG', NULL, NULL, NULL, 3120201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.394167', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2467, 'Cristalia', 'MG', NULL, NULL, NULL, 3120300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.394971', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2468, 'Cristiano Otoni', 'MG', NULL, NULL, NULL, 3120409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.395888', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2469, 'Cristina', 'MG', NULL, NULL, NULL, 3120508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.396852', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2470, 'Crucilandia', 'MG', NULL, NULL, NULL, 3120607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.397656', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2471, 'Cruzeiro da Fortaleza', 'MG', NULL, NULL, NULL, 3120706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.398422', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2472, 'Cruzilia', 'MG', NULL, NULL, NULL, 3120805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.399226', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2473, 'Cuparaque', 'MG', NULL, NULL, NULL, 3120839, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.400152', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2474, 'Curral de Dentro', 'MG', NULL, NULL, NULL, 3120870, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.401352', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2475, 'Curvelo', 'MG', NULL, NULL, NULL, 3120904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.41163', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2476, 'Datas', 'MG', NULL, NULL, NULL, 3121001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.412738', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2477, 'Delfim Moreira', 'MG', NULL, NULL, NULL, 3121100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.413631', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2478, 'Delfinopolis', 'MG', NULL, NULL, NULL, 3121209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.414454', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2479, 'Delta', 'MG', NULL, NULL, NULL, 3121258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.415301', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2480, 'Descoberto', 'MG', NULL, NULL, NULL, 3121308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.416181', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2481, 'Desterro de Entre Rios', 'MG', NULL, NULL, NULL, 3121407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.417061', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2482, 'Desterro do Melo', 'MG', NULL, NULL, NULL, 3121506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.417919', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2483, 'Diamantina', 'MG', NULL, NULL, NULL, 3121605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.418797', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2484, 'Diogo de Vasconcelos', 'MG', NULL, NULL, NULL, 3121704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.41969', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2485, 'Dionisio', 'MG', NULL, NULL, NULL, 3121803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.420606', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2486, 'Divinesia', 'MG', NULL, NULL, NULL, 3121902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.421506', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2487, 'Divino', 'MG', NULL, NULL, NULL, 3122009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.422311', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2488, 'Divino das Laranjeiras', 'MG', NULL, NULL, NULL, 3122108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.423584', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2489, 'Divinolandia de Minas', 'MG', NULL, NULL, NULL, 3122207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.424526', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2490, 'Divinopolis', 'MG', NULL, NULL, NULL, 3122306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.425468', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2491, 'Divisa Alegre', 'MG', NULL, NULL, NULL, 3122355, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.426294', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2492, 'Divisa Nova', 'MG', NULL, NULL, NULL, 3122405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.427201', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2493, 'Divisopolis', 'MG', NULL, NULL, NULL, 3122454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.428217', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2494, 'Dom Bosco', 'MG', NULL, NULL, NULL, 3122470, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.429142', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2495, 'Dom Cavati', 'MG', NULL, NULL, NULL, 3122504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.430042', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2496, 'Dom Joaquim', 'MG', NULL, NULL, NULL, 3122603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.430968', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2497, 'Dom Silverio', 'MG', NULL, NULL, NULL, 3122702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.43188', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2498, 'Dom Vicoso', 'MG', NULL, NULL, NULL, 3122801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.432759', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2499, 'Dona Eusebia', 'MG', NULL, NULL, NULL, 3122900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.433829', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2500, 'Dores de Campos', 'MG', NULL, NULL, NULL, 3123007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.434737', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2501, 'Dores de Guanhaes', 'MG', NULL, NULL, NULL, 3123106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.435545', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2502, 'Dores do Indaia', 'MG', NULL, NULL, NULL, 3123205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.436568', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2503, 'Dores do Turvo', 'MG', NULL, NULL, NULL, 3123304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.437482', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2504, 'Doresopolis', 'MG', NULL, NULL, NULL, 3123403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.438283', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2505, 'Douradoquara', 'MG', NULL, NULL, NULL, 3123502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.439165', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2506, 'Durande', 'MG', NULL, NULL, NULL, 3123528, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.439988', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2507, 'Eloi Mendes', 'MG', NULL, NULL, NULL, 3123601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.440884', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2508, 'Engenheiro Caldas', 'MG', NULL, NULL, NULL, 3123700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.441795', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2509, 'Engenheiro Navarro', 'MG', NULL, NULL, NULL, 3123809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.442634', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2510, 'Entre Folhas', 'MG', NULL, NULL, NULL, 3123858, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.44354', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2511, 'Entre Rios de Minas', 'MG', NULL, NULL, NULL, 3123908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.444453', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2512, 'Ervalia', 'MG', NULL, NULL, NULL, 3124005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.445278', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2513, 'Esmeraldas', 'MG', NULL, NULL, NULL, 3124104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.451797', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2514, 'Espera Feliz', 'MG', NULL, NULL, NULL, 3124203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.452981', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2515, 'Espinosa', 'MG', NULL, NULL, NULL, 3124302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.453778', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2516, 'Espirito Santo do Dourado', 'MG', NULL, NULL, NULL, 3124401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.454654', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2517, 'Estiva', 'MG', NULL, NULL, NULL, 3124500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.4555', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2518, 'Estrela Dalva', 'MG', NULL, NULL, NULL, 3124609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.456458', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2519, 'Estrela do Indaia', 'MG', NULL, NULL, NULL, 3124708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.457559', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2520, 'Estrela do Sul', 'MG', NULL, NULL, NULL, 3124807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.458485', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2521, 'Eugenopolis', 'MG', NULL, NULL, NULL, 3124906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.459407', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2522, 'Ewbank da Camara', 'MG', NULL, NULL, NULL, 3125002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.460227', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2523, 'Extrema', 'MG', NULL, NULL, NULL, 3125101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.461085', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2524, 'Fama', 'MG', NULL, NULL, NULL, 3125200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.461955', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2525, 'Faria Lemos', 'MG', NULL, NULL, NULL, 3125309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.462875', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2526, 'Felicio dos Santos', 'MG', NULL, NULL, NULL, 3125408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.463927', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2965, 'Sao Goncalo do Rio Preto', 'MG', NULL, NULL, NULL, 3125507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.947525', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2527, 'Felisburgo', 'MG', NULL, NULL, NULL, 3125606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.464686', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2528, 'Felixlandia', 'MG', NULL, NULL, NULL, 3125705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.465613', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2529, 'Fernandes Tourinho', 'MG', NULL, NULL, NULL, 3125804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.46651', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2530, 'Ferros', 'MG', NULL, NULL, NULL, 3125903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.467262', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2531, 'Fervedouro', 'MG', NULL, NULL, NULL, 3125952, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.468075', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2532, 'Florestal', 'MG', NULL, NULL, NULL, 3126000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.469065', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2533, 'Formiga', 'MG', NULL, NULL, NULL, 3126109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.469915', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2534, 'Formoso', 'MG', NULL, NULL, NULL, 3126208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.470866', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2535, 'Fortaleza de Minas', 'MG', NULL, NULL, NULL, 3126307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.4718', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2536, 'Fortuna de Minas', 'MG', NULL, NULL, NULL, 3126406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.472649', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2537, 'Francisco Badaro', 'MG', NULL, NULL, NULL, 3126505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.47366', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2538, 'Francisco Dumont', 'MG', NULL, NULL, NULL, 3126604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.474555', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2539, 'Francisco Sa', 'MG', NULL, NULL, NULL, 3126703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.47544', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2540, 'Franciscopolis', 'MG', NULL, NULL, NULL, 3126752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.476315', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2541, 'Frei Gaspar', 'MG', NULL, NULL, NULL, 3126802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.477184', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2542, 'Frei Inocencio', 'MG', NULL, NULL, NULL, 3126901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.478085', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2543, 'Frei Lagonegro', 'MG', NULL, NULL, NULL, 3126950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.478996', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2544, 'Fronteira', 'MG', NULL, NULL, NULL, 3127008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.479756', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2545, 'Fronteira dos Vales', 'MG', NULL, NULL, NULL, 3127057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.480618', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2546, 'Fruta de Leite', 'MG', NULL, NULL, NULL, 3127073, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.481494', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2547, 'Frutal', 'MG', NULL, NULL, NULL, 3127107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.482274', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2548, 'Funilandia', 'MG', NULL, NULL, NULL, 3127206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.483177', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2549, 'Galileia', 'MG', NULL, NULL, NULL, 3127305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.484093', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2550, 'Gameleiras', 'MG', NULL, NULL, NULL, 3127339, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.484955', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2551, 'Glaucilandia', 'MG', NULL, NULL, NULL, 3127354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.485777', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2552, 'Goiabeira', 'MG', NULL, NULL, NULL, 3127370, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.493322', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2553, 'Goiana', 'MG', NULL, NULL, NULL, 3127388, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.494496', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2554, 'Goncalves', 'MG', NULL, NULL, NULL, 3127404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.49536', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2555, 'Gonzaga', 'MG', NULL, NULL, NULL, 3127503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.496231', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2556, 'Gouveia', 'MG', NULL, NULL, NULL, 3127602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.497133', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2557, 'Governador Valadares', 'MG', NULL, NULL, NULL, 3127701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.498098', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2558, 'Grao Mogol', 'MG', NULL, NULL, NULL, 3127800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.498957', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2559, 'Grupiara', 'MG', NULL, NULL, NULL, 3127909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.499849', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2560, 'Guanhaes', 'MG', NULL, NULL, NULL, 3128006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.500653', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2561, 'Guape', 'MG', NULL, NULL, NULL, 3128105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.501713', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2562, 'Guaraciaba', 'MG', NULL, NULL, NULL, 3128204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.502633', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2563, 'Guaraciama', 'MG', NULL, NULL, NULL, 3128253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.503502', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2564, 'Guaranesia', 'MG', NULL, NULL, NULL, 3128303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.504369', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2565, 'Guarani', 'MG', NULL, NULL, NULL, 3128402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.505195', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2566, 'Guarara', 'MG', NULL, NULL, NULL, 3128501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.506059', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2567, 'Guarda-mor', 'MG', NULL, NULL, NULL, 3128600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.506895', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2568, 'Guaxupe', 'MG', NULL, NULL, NULL, 3128709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.507726', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2569, 'Guidoval', 'MG', NULL, NULL, NULL, 3128808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.508808', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2570, 'Guimarania', 'MG', NULL, NULL, NULL, 3128907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.509736', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2571, 'Guiricema', 'MG', NULL, NULL, NULL, 3129004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.510664', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2572, 'Gurinhata', 'MG', NULL, NULL, NULL, 3129103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.51156', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2573, 'Heliodora', 'MG', NULL, NULL, NULL, 3129202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.512439', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2574, 'Iapu', 'MG', NULL, NULL, NULL, 3129301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.513288', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2575, 'Ibertioga', 'MG', NULL, NULL, NULL, 3129400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.514211', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2576, 'Ibia', 'MG', NULL, NULL, NULL, 3129509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.515149', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2577, 'Ibiai', 'MG', NULL, NULL, NULL, 3129608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.515973', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2578, 'Ibiracatu', 'MG', NULL, NULL, NULL, 3129657, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.516767', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2579, 'Ibiraci', 'MG', NULL, NULL, NULL, 3129707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.51756', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2580, 'Ibirite', 'MG', NULL, NULL, NULL, 3129806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.518486', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2581, 'Ibitiura de Minas', 'MG', NULL, NULL, NULL, 3129905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.519415', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2582, 'Ibituruna', 'MG', NULL, NULL, NULL, 3130002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.520237', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2583, 'Icarai de Minas', 'MG', NULL, NULL, NULL, 3130051, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.521141', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2584, 'Igarape', 'MG', NULL, NULL, NULL, 3130101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.522171', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2585, 'Igaratinga', 'MG', NULL, NULL, NULL, 3130200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.523975', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2586, 'Iguatama', 'MG', NULL, NULL, NULL, 3130309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.524916', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2587, 'Ijaci', 'MG', NULL, NULL, NULL, 3130408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.525818', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2588, 'Ilicinea', 'MG', NULL, NULL, NULL, 3130507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.526807', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2589, 'Imbe de Minas', 'MG', NULL, NULL, NULL, 3130556, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.527566', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2590, 'Inconfidentes', 'MG', NULL, NULL, NULL, 3130606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.534284', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2591, 'Indaiabira', 'MG', NULL, NULL, NULL, 3130655, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.535355', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2592, 'Indianopolis', 'MG', NULL, NULL, NULL, 3130705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.536141', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2593, 'Ingai', 'MG', NULL, NULL, NULL, 3130804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.53695', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2594, 'Inhapim', 'MG', NULL, NULL, NULL, 3130903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.537926', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2595, 'Inhauma', 'MG', NULL, NULL, NULL, 3131000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.538866', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2596, 'Inimutaba', 'MG', NULL, NULL, NULL, 3131109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.539693', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2597, 'Ipaba', 'MG', NULL, NULL, NULL, 3131158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.540615', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2598, 'Ipanema', 'MG', NULL, NULL, NULL, 3131208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.541477', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2599, 'Ipatinga', 'MG', NULL, NULL, NULL, 3131307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.542301', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2600, 'Ipiacu', 'MG', NULL, NULL, NULL, 3131406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.543088', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2601, 'Ipuiuna', 'MG', NULL, NULL, NULL, 3131505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.544006', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2602, 'Irai de Minas', 'MG', NULL, NULL, NULL, 3131604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.544877', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2603, 'Itabira', 'MG', NULL, NULL, NULL, 3131703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.545641', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2604, 'Itabirinha', 'MG', NULL, NULL, NULL, 3131802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.546423', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2605, 'Itabirito', 'MG', NULL, NULL, NULL, 3131901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.547264', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2606, 'Itacambira', 'MG', NULL, NULL, NULL, 3132008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.54826', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2607, 'Itacarambi', 'MG', NULL, NULL, NULL, 3132107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.549333', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2608, 'Itaguara', 'MG', NULL, NULL, NULL, 3132206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.550259', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2609, 'Itaipe', 'MG', NULL, NULL, NULL, 3132305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.551156', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2610, 'Itajuba', 'MG', NULL, NULL, NULL, 3132404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.552041', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2611, 'Itamarandiba', 'MG', NULL, NULL, NULL, 3132503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.55291', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2612, 'Itamarati de Minas', 'MG', NULL, NULL, NULL, 3132602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.553968', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2613, 'Itambacuri', 'MG', NULL, NULL, NULL, 3132701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.554843', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2614, 'Itambe do Mato Dentro', 'MG', NULL, NULL, NULL, 3132800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.555903', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2615, 'Itamogi', 'MG', NULL, NULL, NULL, 3132909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.556785', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2616, 'Itamonte', 'MG', NULL, NULL, NULL, 3133006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.557679', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2617, 'Itanhandu', 'MG', NULL, NULL, NULL, 3133105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.558486', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2618, 'Itanhomi', 'MG', NULL, NULL, NULL, 3133204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.559343', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2619, 'Itaobim', 'MG', NULL, NULL, NULL, 3133303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.560182', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2620, 'Itapagipe', 'MG', NULL, NULL, NULL, 3133402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.561129', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2621, 'Itapecerica', 'MG', NULL, NULL, NULL, 3133501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.562045', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2622, 'Itapeva', 'MG', NULL, NULL, NULL, 3133600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.562886', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2623, 'Itatiaiucu', 'MG', NULL, NULL, NULL, 3133709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.56382', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2624, 'Itau de Minas', 'MG', NULL, NULL, NULL, 3133758, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.564738', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2625, 'Itauna', 'MG', NULL, NULL, NULL, 3133808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.565631', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2626, 'Itaverava', 'MG', NULL, NULL, NULL, 3133907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.566539', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2627, 'Itinga', 'MG', NULL, NULL, NULL, 3134004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.567443', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2628, 'Itueta', 'MG', NULL, NULL, NULL, 3134103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.574206', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2629, 'Ituiutaba', 'MG', NULL, NULL, NULL, 3134202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.575462', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2630, 'Itumirim', 'MG', NULL, NULL, NULL, 3134301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.576278', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2631, 'Iturama', 'MG', NULL, NULL, NULL, 3134400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.577299', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2632, 'Itutinga', 'MG', NULL, NULL, NULL, 3134509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.578215', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2633, 'Jaboticatubas', 'MG', NULL, NULL, NULL, 3134608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.579155', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2634, 'Jacinto', 'MG', NULL, NULL, NULL, 3134707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.579934', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2635, 'Jacui', 'MG', NULL, NULL, NULL, 3134806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.580977', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2636, 'Jacutinga', 'MG', NULL, NULL, NULL, 3134905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.581851', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2637, 'Jaguaracu', 'MG', NULL, NULL, NULL, 3135001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.582674', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2638, 'Jaiba', 'MG', NULL, NULL, NULL, 3135050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.583605', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2639, 'Jampruca', 'MG', NULL, NULL, NULL, 3135076, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.584486', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2640, 'Janauba', 'MG', NULL, NULL, NULL, 3135100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.585356', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2641, 'Januaria', 'MG', NULL, NULL, NULL, 3135209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.586257', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2642, 'Japaraiba', 'MG', NULL, NULL, NULL, 3135308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.587138', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2643, 'Japonvar', 'MG', NULL, NULL, NULL, 3135357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.58822', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2644, 'Jeceaba', 'MG', NULL, NULL, NULL, 3135407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.589312', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2645, 'Jenipapo de Minas', 'MG', NULL, NULL, NULL, 3135456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.590255', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2646, 'Jequeri', 'MG', NULL, NULL, NULL, 3135506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.591033', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2647, 'Jequitai', 'MG', NULL, NULL, NULL, 3135605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.592039', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2648, 'Jequitiba', 'MG', NULL, NULL, NULL, 3135704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.592846', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2649, 'Jequitinhonha', 'MG', NULL, NULL, NULL, 3135803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.593621', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2650, 'Jesuania', 'MG', NULL, NULL, NULL, 3135902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.594594', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2651, 'Joaima', 'MG', NULL, NULL, NULL, 3136009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.595575', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2652, 'Joanesia', 'MG', NULL, NULL, NULL, 3136108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.596474', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2653, 'Joao Monlevade', 'MG', NULL, NULL, NULL, 3136207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.597362', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2654, 'Joao Pinheiro', 'MG', NULL, NULL, NULL, 3136306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.59822', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2655, 'Joaquim Felicio', 'MG', NULL, NULL, NULL, 3136405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.599054', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2656, 'Jordania', 'MG', NULL, NULL, NULL, 3136504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.600016', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2657, 'Jose Goncalves de Minas', 'MG', NULL, NULL, NULL, 3136520, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.600945', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2658, 'Jose Raydan', 'MG', NULL, NULL, NULL, 3136553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.602108', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2659, 'Josenopolis', 'MG', NULL, NULL, NULL, 3136579, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.603016', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2768, 'Nova Uniao', 'MG', NULL, NULL, NULL, 3136603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.723765', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2660, 'Juatuba', 'MG', NULL, NULL, NULL, 3136652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.604047', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2661, 'Juiz de Fora', 'MG', NULL, NULL, NULL, 3136702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.604952', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2662, 'Juramento', 'MG', NULL, NULL, NULL, 3136801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.605847', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2663, 'Juruaia', 'MG', NULL, NULL, NULL, 3136900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.606705', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2664, 'Juvenilia', 'MG', NULL, NULL, NULL, 3136959, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.607706', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2665, 'Ladainha', 'MG', NULL, NULL, NULL, 3137007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.614724', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2666, 'Lagamar', 'MG', NULL, NULL, NULL, 3137106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.615844', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2667, 'Lagoa da Prata', 'MG', NULL, NULL, NULL, 3137205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.616813', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2668, 'Lagoa dos Patos', 'MG', NULL, NULL, NULL, 3137304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.617738', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2669, 'Lagoa Dourada', 'MG', NULL, NULL, NULL, 3137403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.618698', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2670, 'Lagoa Formosa', 'MG', NULL, NULL, NULL, 3137502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.619622', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2671, 'Lagoa Grande', 'MG', NULL, NULL, NULL, 3137536, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.620559', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2672, 'Lagoa Santa', 'MG', NULL, NULL, NULL, 3137601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.621608', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2673, 'Lajinha', 'MG', NULL, NULL, NULL, 3137700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.622616', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2674, 'Lambari', 'MG', NULL, NULL, NULL, 3137809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.623675', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2675, 'Lamim', 'MG', NULL, NULL, NULL, 3137908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.624505', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2676, 'Laranjal', 'MG', NULL, NULL, NULL, 3138005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.625461', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2677, 'Lassance', 'MG', NULL, NULL, NULL, 3138104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.626399', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2678, 'Lavras', 'MG', NULL, NULL, NULL, 3138203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.62728', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2679, 'Leandro Ferreira', 'MG', NULL, NULL, NULL, 3138302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.6282', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2680, 'Leme do Prado', 'MG', NULL, NULL, NULL, 3138351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.629003', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2681, 'Leopoldina', 'MG', NULL, NULL, NULL, 3138401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.629801', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2682, 'Liberdade', 'MG', NULL, NULL, NULL, 3138500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.630694', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2683, 'Lima Duarte', 'MG', NULL, NULL, NULL, 3138609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.631701', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2684, 'Limeira do Oeste', 'MG', NULL, NULL, NULL, 3138625, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.632595', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2685, 'Lontra', 'MG', NULL, NULL, NULL, 3138658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.633499', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2686, 'Luisburgo', 'MG', NULL, NULL, NULL, 3138674, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.634802', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2687, 'Luislandia', 'MG', NULL, NULL, NULL, 3138682, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.635773', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2688, 'Luminarias', 'MG', NULL, NULL, NULL, 3138708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.636597', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2689, 'Luz', 'MG', NULL, NULL, NULL, 3138807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.637763', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2690, 'Machacalis', 'MG', NULL, NULL, NULL, 3138906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.638736', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2691, 'Machado', 'MG', NULL, NULL, NULL, 3139003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.639667', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2692, 'Madre de Deus de Minas', 'MG', NULL, NULL, NULL, 3139102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.640612', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2693, 'Malacacheta', 'MG', NULL, NULL, NULL, 3139201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.641441', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2694, 'Mamonas', 'MG', NULL, NULL, NULL, 3139250, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.642344', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2695, 'Manga', 'MG', NULL, NULL, NULL, 3139300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.643242', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2696, 'Manhuacu', 'MG', NULL, NULL, NULL, 3139409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.644213', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2697, 'Manhumirim', 'MG', NULL, NULL, NULL, 3139508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.64516', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2698, 'Mantena', 'MG', NULL, NULL, NULL, 3139607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.646202', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2700, 'Maravilhas', 'MG', NULL, NULL, NULL, 3139706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.647968', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2699, 'Mar de Espanha', 'MG', NULL, NULL, NULL, 3139805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.647012', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2701, 'Maria da Fe', 'MG', NULL, NULL, NULL, 3139904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.655614', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2702, 'Mariana', 'MG', NULL, NULL, NULL, 3140001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.656908', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2703, 'Marilac', 'MG', NULL, NULL, NULL, 3140100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.65784', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2704, 'Mario Campos', 'MG', NULL, NULL, NULL, 3140159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.658689', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2705, 'Maripa de Minas', 'MG', NULL, NULL, NULL, 3140209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.65953', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2706, 'Marlieria', 'MG', NULL, NULL, NULL, 3140308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.66046', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2707, 'Marmelopolis', 'MG', NULL, NULL, NULL, 3140407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.661483', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2708, 'Martinho Campos', 'MG', NULL, NULL, NULL, 3140506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.662437', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2709, 'Martins Soares', 'MG', NULL, NULL, NULL, 3140530, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.663486', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2710, 'Mata Verde', 'MG', NULL, NULL, NULL, 3140555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.664361', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2711, 'Materlandia', 'MG', NULL, NULL, NULL, 3140605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.665305', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2712, 'Mateus Leme', 'MG', NULL, NULL, NULL, 3140704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.666284', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2714, 'Matias Barbosa', 'MG', NULL, NULL, NULL, 3140803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.668037', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2715, 'Matias Cardoso', 'MG', NULL, NULL, NULL, 3140852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.668913', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2716, 'Matipo', 'MG', NULL, NULL, NULL, 3140902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.669963', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2717, 'Mato Verde', 'MG', NULL, NULL, NULL, 3141009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.670864', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2718, 'Matozinhos', 'MG', NULL, NULL, NULL, 3141108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.671823', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2719, 'Matutina', 'MG', NULL, NULL, NULL, 3141207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.672635', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2720, 'Medeiros', 'MG', NULL, NULL, NULL, 3141306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.673506', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2721, 'Medina', 'MG', NULL, NULL, NULL, 3141405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.674315', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2722, 'Mendes Pimentel', 'MG', NULL, NULL, NULL, 3141504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.675195', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2723, 'Merces', 'MG', NULL, NULL, NULL, 3141603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.676123', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2724, 'Mesquita', 'MG', NULL, NULL, NULL, 3141702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.677029', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2725, 'Minas Novas', 'MG', NULL, NULL, NULL, 3141801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.677866', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2726, 'Minduri', 'MG', NULL, NULL, NULL, 3141900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.67889', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2727, 'Mirabela', 'MG', NULL, NULL, NULL, 3142007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.680059', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2728, 'Miradouro', 'MG', NULL, NULL, NULL, 3142106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.681017', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2729, 'Mirai', 'MG', NULL, NULL, NULL, 3142205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.681974', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2730, 'Miravania', 'MG', NULL, NULL, NULL, 3142254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.682921', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2731, 'Moeda', 'MG', NULL, NULL, NULL, 3142304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.683889', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2732, 'Moema', 'MG', NULL, NULL, NULL, 3142403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.684839', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2733, 'Monjolos', 'MG', NULL, NULL, NULL, 3142502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.685732', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2734, 'Monsenhor Paulo', 'MG', NULL, NULL, NULL, 3142601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.686645', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2735, 'Montalvania', 'MG', NULL, NULL, NULL, 3142700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.687406', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2736, 'Monte Alegre de Minas', 'MG', NULL, NULL, NULL, 3142809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.688289', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2737, 'Monte Azul', 'MG', NULL, NULL, NULL, 3142908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.689257', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2738, 'Monte Belo', 'MG', NULL, NULL, NULL, 3143005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.696044', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2739, 'Monte Carmelo', 'MG', NULL, NULL, NULL, 3143104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.697125', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2740, 'Monte Formoso', 'MG', NULL, NULL, NULL, 3143153, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.698007', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2741, 'Monte Santo de Minas', 'MG', NULL, NULL, NULL, 3143203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.699102', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2743, 'Montes Claros', 'MG', NULL, NULL, NULL, 3143302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.700683', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2742, 'Monte Siao', 'MG', NULL, NULL, NULL, 3143401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.699867', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2744, 'Montezuma', 'MG', NULL, NULL, NULL, 3143450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.701663', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2745, 'Morada Nova de Minas', 'MG', NULL, NULL, NULL, 3143500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.702366', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2746, 'Morro da Garca', 'MG', NULL, NULL, NULL, 3143609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.703301', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2747, 'Morro do Pilar', 'MG', NULL, NULL, NULL, 3143708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.70427', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2748, 'Munhoz', 'MG', NULL, NULL, NULL, 3143807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.705223', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2749, 'Muriae', 'MG', NULL, NULL, NULL, 3143906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.706065', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2750, 'Mutum', 'MG', NULL, NULL, NULL, 3144003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.706975', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2751, 'Muzambinho', 'MG', NULL, NULL, NULL, 3144102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.707858', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2752, 'Nacip Raydan', 'MG', NULL, NULL, NULL, 3144201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.70873', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2753, 'Nanuque', 'MG', NULL, NULL, NULL, 3144300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.709584', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2754, 'Naque', 'MG', NULL, NULL, NULL, 3144359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.710678', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2755, 'Natalandia', 'MG', NULL, NULL, NULL, 3144375, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.711561', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2756, 'Natercia', 'MG', NULL, NULL, NULL, 3144409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.712473', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2757, 'Nazareno', 'MG', NULL, NULL, NULL, 3144508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.71354', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2758, 'Nepomuceno', 'MG', NULL, NULL, NULL, 3144607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.714525', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2759, 'Ninheira', 'MG', NULL, NULL, NULL, 3144656, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.715406', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2760, 'Nova Belem', 'MG', NULL, NULL, NULL, 3144672, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.716339', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2761, 'Nova Era', 'MG', NULL, NULL, NULL, 3144706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.71725', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2762, 'Nova Lima', 'MG', NULL, NULL, NULL, 3144805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.718111', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2763, 'Nova Modica', 'MG', NULL, NULL, NULL, 3144904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.719056', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2764, 'Nova Ponte', 'MG', NULL, NULL, NULL, 3145000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.720149', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2765, 'Nova Porteirinha', 'MG', NULL, NULL, NULL, 3145059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.721149', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2766, 'Nova Resende', 'MG', NULL, NULL, NULL, 3145109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.722075', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2767, 'Nova Serrana', 'MG', NULL, NULL, NULL, 3145208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.7229', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2769, 'Novo Cruzeiro', 'MG', NULL, NULL, NULL, 3145307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.724744', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2770, 'Novo Oriente de Minas', 'MG', NULL, NULL, NULL, 3145356, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.725723', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2771, 'Novorizonte', 'MG', NULL, NULL, NULL, 3145372, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.726657', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2772, 'Olaria', 'MG', NULL, NULL, NULL, 3145406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.727589', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2774, 'Olimpio Noronha', 'MG', NULL, NULL, NULL, 3145505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.729493', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2775, 'Oliveira', 'MG', NULL, NULL, NULL, 3145604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.740384', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2776, 'Oliveira Fortes', 'MG', NULL, NULL, NULL, 3145703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.74145', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2777, 'Onca de Pitangui', 'MG', NULL, NULL, NULL, 3145802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.742313', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2778, 'Oratorios', 'MG', NULL, NULL, NULL, 3145851, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.7431', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2779, 'Orizania', 'MG', NULL, NULL, NULL, 3145877, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.743935', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2780, 'Ouro Branco', 'MG', NULL, NULL, NULL, 3145901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.744933', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2781, 'Ouro Fino', 'MG', NULL, NULL, NULL, 3146008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.745729', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2782, 'Ouro Preto', 'MG', NULL, NULL, NULL, 3146107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.746597', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2783, 'Ouro Verde de Minas', 'MG', NULL, NULL, NULL, 3146206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.747426', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2784, 'Padre Carvalho', 'MG', NULL, NULL, NULL, 3146255, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.748246', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2785, 'Padre Paraiso', 'MG', NULL, NULL, NULL, 3146305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.749321', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2787, 'Paineiras', 'MG', NULL, NULL, NULL, 3146404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.75118', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2788, 'Pains', 'MG', NULL, NULL, NULL, 3146503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.752016', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2786, 'Pai Pedro', 'MG', NULL, NULL, NULL, 3146552, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.750259', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2789, 'Paiva', 'MG', NULL, NULL, NULL, 3146602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.753119', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2790, 'Palma', 'MG', NULL, NULL, NULL, 3146701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.754061', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2791, 'Palmopolis', 'MG', NULL, NULL, NULL, 3146750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.755117', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2792, 'Papagaios', 'MG', NULL, NULL, NULL, 3146909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.75607', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2794, 'Paracatu', 'MG', NULL, NULL, NULL, 3147006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.757955', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2793, 'Para de Minas', 'MG', NULL, NULL, NULL, 3147105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.756968', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2795, 'Paraguacu', 'MG', NULL, NULL, NULL, 3147204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.758826', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2796, 'Paraisopolis', 'MG', NULL, NULL, NULL, 3147303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.759698', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2797, 'Paraopeba', 'MG', NULL, NULL, NULL, 3147402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.76053', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2801, 'Passabem', 'MG', NULL, NULL, NULL, 3147501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.764189', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2798, 'Passa Quatro', 'MG', NULL, NULL, NULL, 3147600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.761404', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2799, 'Passa Tempo', 'MG', NULL, NULL, NULL, 3147709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.762299', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2802, 'Passos', 'MG', NULL, NULL, NULL, 3147907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.765124', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2803, 'Patis', 'MG', NULL, NULL, NULL, 3147956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.766075', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2804, 'Patos de Minas', 'MG', NULL, NULL, NULL, 3148004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.766987', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2805, 'Patrocinio', 'MG', NULL, NULL, NULL, 3148103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.767808', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2806, 'Patrocinio do Muriae', 'MG', NULL, NULL, NULL, 3148202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.768792', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2807, 'Paula Candido', 'MG', NULL, NULL, NULL, 3148301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.769602', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2808, 'Paulistas', 'MG', NULL, NULL, NULL, 3148400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.770548', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2809, 'Pavao', 'MG', NULL, NULL, NULL, 3148509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.771502', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2810, 'Pecanha', 'MG', NULL, NULL, NULL, 3148608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.772442', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2811, 'Pedra Azul', 'MG', NULL, NULL, NULL, 3148707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.773367', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2812, 'Pedra Bonita', 'MG', NULL, NULL, NULL, 3148756, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.774198', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2813, 'Pedra do Anta', 'MG', NULL, NULL, NULL, 3148806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.781051', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2814, 'Pedra do Indaia', 'MG', NULL, NULL, NULL, 3148905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.782165', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2815, 'Pedra Dourada', 'MG', NULL, NULL, NULL, 3149002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.783151', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2816, 'Pedralva', 'MG', NULL, NULL, NULL, 3149101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.784071', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2817, 'Pedras de Maria da Cruz', 'MG', NULL, NULL, NULL, 3149150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.784969', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2818, 'Pedrinopolis', 'MG', NULL, NULL, NULL, 3149200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.785949', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2819, 'Pedro Leopoldo', 'MG', NULL, NULL, NULL, 3149309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.786904', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2820, 'Pedro Teixeira', 'MG', NULL, NULL, NULL, 3149408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.787893', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2821, 'Pequeri', 'MG', NULL, NULL, NULL, 3149507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.788918', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2822, 'Pequi', 'MG', NULL, NULL, NULL, 3149606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.789785', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2823, 'Perdigao', 'MG', NULL, NULL, NULL, 3149705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.790748', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2824, 'Perdizes', 'MG', NULL, NULL, NULL, 3149804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.791688', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2825, 'Perdoes', 'MG', NULL, NULL, NULL, 3149903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.792564', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2826, 'Periquito', 'MG', NULL, NULL, NULL, 3149952, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.793428', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2827, 'Pescador', 'MG', NULL, NULL, NULL, 3150000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.79428', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2828, 'Piau', 'MG', NULL, NULL, NULL, 3150109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.795255', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2829, 'Piedade de Caratinga', 'MG', NULL, NULL, NULL, 3150158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.796196', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2830, 'Piedade de Ponte Nova', 'MG', NULL, NULL, NULL, 3150208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.797037', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2831, 'Piedade do Rio Grande', 'MG', NULL, NULL, NULL, 3150307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.797938', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2832, 'Piedade dos Gerais', 'MG', NULL, NULL, NULL, 3150406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.798806', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2833, 'Pimenta', 'MG', NULL, NULL, NULL, 3150505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.799797', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2835, 'Pintopolis', 'MG', NULL, NULL, NULL, 3150570, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.801687', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2836, 'Piracema', 'MG', NULL, NULL, NULL, 3150604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.802868', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2837, 'Pirajuba', 'MG', NULL, NULL, NULL, 3150703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.803785', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2838, 'Piranga', 'MG', NULL, NULL, NULL, 3150802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.804725', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2839, 'Pirangucu', 'MG', NULL, NULL, NULL, 3150901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.805698', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2840, 'Piranguinho', 'MG', NULL, NULL, NULL, 3151008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.806615', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2841, 'Pirapetinga', 'MG', NULL, NULL, NULL, 3151107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.807535', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2842, 'Pirapora', 'MG', NULL, NULL, NULL, 3151206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.80837', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2843, 'Pirauba', 'MG', NULL, NULL, NULL, 3151305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.809281', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2844, 'Pitangui', 'MG', NULL, NULL, NULL, 3151404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.810255', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2845, 'Piumhi', 'MG', NULL, NULL, NULL, 3151503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.811233', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2846, 'Planura', 'MG', NULL, NULL, NULL, 3151602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.812132', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2847, 'Poco Fundo', 'MG', NULL, NULL, NULL, 3151701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.813128', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2848, 'Pocos de Caldas', 'MG', NULL, NULL, NULL, 3151800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.814049', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2849, 'Pocrane', 'MG', NULL, NULL, NULL, 3151909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.814882', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2850, 'Pompeu', 'MG', NULL, NULL, NULL, 3152006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.822131', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2851, 'Ponte Nova', 'MG', NULL, NULL, NULL, 3152105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.823253', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2852, 'Ponto Chique', 'MG', NULL, NULL, NULL, 3152131, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.824088', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2853, 'Ponto dos Volantes', 'MG', NULL, NULL, NULL, 3152170, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.825103', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2854, 'Porteirinha', 'MG', NULL, NULL, NULL, 3152204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.82606', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2855, 'Porto Firme', 'MG', NULL, NULL, NULL, 3152303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.827004', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2856, 'Pote', 'MG', NULL, NULL, NULL, 3152402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.828002', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2857, 'Pouso Alegre', 'MG', NULL, NULL, NULL, 3152501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.828959', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2858, 'Pouso Alto', 'MG', NULL, NULL, NULL, 3152600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.830054', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2859, 'Prados', 'MG', NULL, NULL, NULL, 3152709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.830956', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2860, 'Prata', 'MG', NULL, NULL, NULL, 3152808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.831842', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2861, 'Pratapolis', 'MG', NULL, NULL, NULL, 3152907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.832742', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2862, 'Pratinha', 'MG', NULL, NULL, NULL, 3153004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.833628', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2863, 'Presidente Bernardes', 'MG', NULL, NULL, NULL, 3153103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.834501', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2864, 'Presidente Juscelino', 'MG', NULL, NULL, NULL, 3153202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.836256', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2865, 'Presidente Kubitschek', 'MG', NULL, NULL, NULL, 3153301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.837166', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2866, 'Presidente Olegario', 'MG', NULL, NULL, NULL, 3153400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.838125', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2265, 'Alto Jequitiba', 'MG', NULL, NULL, NULL, 3153509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.182618', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2867, 'Prudente de Morais', 'MG', NULL, NULL, NULL, 3153608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.839006', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2868, 'Quartel Geral', 'MG', NULL, NULL, NULL, 3153707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.839868', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2869, 'Queluzito', 'MG', NULL, NULL, NULL, 3153806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.840797', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2870, 'Raposos', 'MG', NULL, NULL, NULL, 3153905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.84164', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2871, 'Raul Soares', 'MG', NULL, NULL, NULL, 3154002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.842576', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2872, 'Recreio', 'MG', NULL, NULL, NULL, 3154101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.843754', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2873, 'Reduto', 'MG', NULL, NULL, NULL, 3154150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.844654', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2874, 'Resende Costa', 'MG', NULL, NULL, NULL, 3154200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.845628', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2875, 'Resplendor', 'MG', NULL, NULL, NULL, 3154309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.846633', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2876, 'Ressaquinha', 'MG', NULL, NULL, NULL, 3154408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.847458', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2877, 'Riachinho', 'MG', NULL, NULL, NULL, 3154457, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.848378', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2878, 'Riacho dos Machados', 'MG', NULL, NULL, NULL, 3154507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.849254', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2879, 'Ribeirao das Neves', 'MG', NULL, NULL, NULL, 3154606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.850149', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2880, 'Ribeirao Vermelho', 'MG', NULL, NULL, NULL, 3154705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.851048', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2881, 'Rio Acima', 'MG', NULL, NULL, NULL, 3154804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.852061', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2882, 'Rio Casca', 'MG', NULL, NULL, NULL, 3154903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.852976', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2884, 'Rio Doce', 'MG', NULL, NULL, NULL, 3155009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.854683', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2883, 'Rio do Prado', 'MG', NULL, NULL, NULL, 3155108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.853875', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2885, 'Rio Espera', 'MG', NULL, NULL, NULL, 3155207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.855684', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2886, 'Rio Manso', 'MG', NULL, NULL, NULL, 3155306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.856476', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2887, 'Rio Novo', 'MG', NULL, NULL, NULL, 3155405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.863208', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2888, 'Rio Paranaiba', 'MG', NULL, NULL, NULL, 3155504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.86423', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2889, 'Rio Pardo de Minas', 'MG', NULL, NULL, NULL, 3155603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.865113', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2890, 'Rio Piracicaba', 'MG', NULL, NULL, NULL, 3155702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.866003', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2891, 'Rio Pomba', 'MG', NULL, NULL, NULL, 3155801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.866718', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2892, 'Rio Preto', 'MG', NULL, NULL, NULL, 3155900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.86757', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2893, 'Rio Vermelho', 'MG', NULL, NULL, NULL, 3156007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.868466', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2894, 'Ritapolis', 'MG', NULL, NULL, NULL, 3156106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.86965', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2895, 'Rochedo de Minas', 'MG', NULL, NULL, NULL, 3156205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.870574', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2896, 'Rodeiro', 'MG', NULL, NULL, NULL, 3156304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.87147', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2897, 'Romaria', 'MG', NULL, NULL, NULL, 3156403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.872334', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2898, 'Rosario da Limeira', 'MG', NULL, NULL, NULL, 3156452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.873188', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2899, 'Rubelita', 'MG', NULL, NULL, NULL, 3156502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.873986', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2900, 'Rubim', 'MG', NULL, NULL, NULL, 3156601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.874865', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2901, 'Sabara', 'MG', NULL, NULL, NULL, 3156700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.875998', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2902, 'Sabinopolis', 'MG', NULL, NULL, NULL, 3156809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.876908', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2903, 'Sacramento', 'MG', NULL, NULL, NULL, 3156908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.877892', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2904, 'Salinas', 'MG', NULL, NULL, NULL, 3157005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.878715', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2905, 'Salto da Divisa', 'MG', NULL, NULL, NULL, 3157104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.87963', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2906, 'Santa Barbara', 'MG', NULL, NULL, NULL, 3157203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.880788', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2907, 'Santa Barbara do Leste', 'MG', NULL, NULL, NULL, 3157252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.881713', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2908, 'Santa Barbara do Monte Verde', 'MG', NULL, NULL, NULL, 3157278, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.882576', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2909, 'Santa Barbara do Tugurio', 'MG', NULL, NULL, NULL, 3157302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.883499', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2910, 'Santa Cruz de Minas', 'MG', NULL, NULL, NULL, 3157336, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.884331', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2911, 'Santa Cruz de Salinas', 'MG', NULL, NULL, NULL, 3157377, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.885373', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2912, 'Santa Cruz do Escalvado', 'MG', NULL, NULL, NULL, 3157401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.886231', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2913, 'Santa Efigenia de Minas', 'MG', NULL, NULL, NULL, 3157500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.887023', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2914, 'Santa Fe de Minas', 'MG', NULL, NULL, NULL, 3157609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.887823', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2915, 'Santa Helena de Minas', 'MG', NULL, NULL, NULL, 3157658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.888613', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2916, 'Santa Juliana', 'MG', NULL, NULL, NULL, 3157708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.889436', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2917, 'Santa Luzia', 'MG', NULL, NULL, NULL, 3157807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.890286', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2918, 'Santa Margarida', 'MG', NULL, NULL, NULL, 3157906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.891179', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2919, 'Santa Maria de Itabira', 'MG', NULL, NULL, NULL, 3158003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.892071', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2920, 'Santa Maria do Salto', 'MG', NULL, NULL, NULL, 3158102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.893033', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2921, 'Santa Maria do Suacui', 'MG', NULL, NULL, NULL, 3158201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.893934', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2930, 'Santana da Vargem', 'MG', NULL, NULL, NULL, 3158300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.90782', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2931, 'Santana de Cataguases', 'MG', NULL, NULL, NULL, 3158409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.908562', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2932, 'Santana de Pirapama', 'MG', NULL, NULL, NULL, 3158508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.909396', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2933, 'Santana do Deserto', 'MG', NULL, NULL, NULL, 3158607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.91025', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2934, 'Santana do Garambeu', 'MG', NULL, NULL, NULL, 3158706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.911172', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2935, 'Santana do Jacare', 'MG', NULL, NULL, NULL, 3158805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.912087', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2936, 'Santana do Manhuacu', 'MG', NULL, NULL, NULL, 3158904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.912919', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2937, 'Santana do Paraiso', 'MG', NULL, NULL, NULL, 3158953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.913893', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2938, 'Santana do Riacho', 'MG', NULL, NULL, NULL, 3159001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.914701', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2939, 'Santana dos Montes', 'MG', NULL, NULL, NULL, 3159100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.915635', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2922, 'Santa Rita de Caldas', 'MG', NULL, NULL, NULL, 3159209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.894802', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2924, 'Santa Rita de Jacutinga', 'MG', NULL, NULL, NULL, 3159308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.896554', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2925, 'Santa Rita de Minas', 'MG', NULL, NULL, NULL, 3159357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.90317', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2923, 'Santa Rita de Ibitipoca', 'MG', NULL, NULL, NULL, 3159407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.895661', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2926, 'Santa Rita do Itueto', 'MG', NULL, NULL, NULL, 3159506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.904334', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2927, 'Santa Rita do Sapucai', 'MG', NULL, NULL, NULL, 3159605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.905188', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2928, 'Santa Rosa da Serra', 'MG', NULL, NULL, NULL, 3159704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.906002', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2929, 'Santa Vitoria', 'MG', NULL, NULL, NULL, 3159803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.906897', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2940, 'Santo Antonio do Amparo', 'MG', NULL, NULL, NULL, 3159902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.916561', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2941, 'Santo Antonio do Aventureiro', 'MG', NULL, NULL, NULL, 3160009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.917522', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2942, 'Santo Antonio do Grama', 'MG', NULL, NULL, NULL, 3160108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.918259', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2943, 'Santo Antonio do Itambe', 'MG', NULL, NULL, NULL, 3160207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.919652', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2944, 'Santo Antonio do Jacinto', 'MG', NULL, NULL, NULL, 3160306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.920493', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2945, 'Santo Antonio do Monte', 'MG', NULL, NULL, NULL, 3160405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.921488', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2946, 'Santo Antonio do Retiro', 'MG', NULL, NULL, NULL, 3160454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.922448', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2947, 'Santo Antonio do Rio Abaixo', 'MG', NULL, NULL, NULL, 3160504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.923338', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2948, 'Santo Hipolito', 'MG', NULL, NULL, NULL, 3160603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.924169', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2949, 'Santos Dumont', 'MG', NULL, NULL, NULL, 3160702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.925463', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2950, 'Sao Bento Abade', 'MG', NULL, NULL, NULL, 3160801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.926405', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2951, 'Sao Bras do Suacui', 'MG', NULL, NULL, NULL, 3160900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.927261', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2952, 'Sao Domingos das Dores', 'MG', NULL, NULL, NULL, 3160959, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.928137', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2953, 'Sao Domingos do Prata', 'MG', NULL, NULL, NULL, 3161007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.928974', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2954, 'Sao Felix de Minas', 'MG', NULL, NULL, NULL, 3161056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.929859', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2955, 'Sao Francisco', 'MG', NULL, NULL, NULL, 3161106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.930685', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2956, 'Sao Francisco de Paula', 'MG', NULL, NULL, NULL, 3161205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.931488', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2957, 'Sao Francisco de Sales', 'MG', NULL, NULL, NULL, 3161304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.932267', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2958, 'Sao Francisco do Gloria', 'MG', NULL, NULL, NULL, 3161403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.933213', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2959, 'Sao Geraldo', 'MG', NULL, NULL, NULL, 3161502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.934103', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2960, 'Sao Geraldo da Piedade', 'MG', NULL, NULL, NULL, 3161601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.935011', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2961, 'Sao Geraldo do Baixio', 'MG', NULL, NULL, NULL, 3161650, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.935934', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2962, 'Sao Goncalo do Abaete', 'MG', NULL, NULL, NULL, 3161700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.936778', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2963, 'Sao Goncalo do Para', 'MG', NULL, NULL, NULL, 3161809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.944008', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2964, 'Sao Goncalo do Rio Abaixo', 'MG', NULL, NULL, NULL, 3161908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.945446', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2966, 'Sao Goncalo do Sapucai', 'MG', NULL, NULL, NULL, 3162005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.948415', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2967, 'Sao Gotardo', 'MG', NULL, NULL, NULL, 3162104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.949358', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2968, 'Sao Joao Batista do Gloria', 'MG', NULL, NULL, NULL, 3162203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.950284', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2969, 'Sao Joao da Lagoa', 'MG', NULL, NULL, NULL, 3162252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.951373', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2970, 'Sao Joao da Mata', 'MG', NULL, NULL, NULL, 3162302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.952414', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2971, 'Sao Joao da Ponte', 'MG', NULL, NULL, NULL, 3162401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.95334', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2972, 'Sao Joao das Missoes', 'MG', NULL, NULL, NULL, 3162450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.954242', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2973, 'Sao Joao Del Rei', 'MG', NULL, NULL, NULL, 3162500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.955094', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2974, 'Sao Joao do Manhuacu', 'MG', NULL, NULL, NULL, 3162559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.955927', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2975, 'Sao Joao do Manteninha', 'MG', NULL, NULL, NULL, 3162575, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.956767', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2976, 'Sao Joao do Oriente', 'MG', NULL, NULL, NULL, 3162609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.957553', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2977, 'Sao Joao do Pacui', 'MG', NULL, NULL, NULL, 3162658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.958462', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2978, 'Sao Joao do Paraiso', 'MG', NULL, NULL, NULL, 3162708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.959259', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2979, 'Sao Joao Evangelista', 'MG', NULL, NULL, NULL, 3162807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.960178', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2980, 'Sao Joao Nepomuceno', 'MG', NULL, NULL, NULL, 3162906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.961059', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2981, 'Sao Joaquim de Bicas', 'MG', NULL, NULL, NULL, 3162922, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.962029', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2982, 'Sao Jose da Barra', 'MG', NULL, NULL, NULL, 3162948, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.962922', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2983, 'Sao Jose da Lapa', 'MG', NULL, NULL, NULL, 3162955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.963826', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2984, 'Sao Jose da Safira', 'MG', NULL, NULL, NULL, 3163003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.964717', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2985, 'Sao Jose da Varginha', 'MG', NULL, NULL, NULL, 3163102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.965573', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2986, 'Sao Jose do Alegre', 'MG', NULL, NULL, NULL, 3163201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.966464', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2987, 'Sao Jose do Divino', 'MG', NULL, NULL, NULL, 3163300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.967302', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2988, 'Sao Jose do Goiabal', 'MG', NULL, NULL, NULL, 3163409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.968161', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2989, 'Sao Jose do Jacuri', 'MG', NULL, NULL, NULL, 3163508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.969054', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2990, 'Sao Jose do Mantimento', 'MG', NULL, NULL, NULL, 3163607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.970124', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2991, 'Sao Lourenco', 'MG', NULL, NULL, NULL, 3163706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.97104', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2992, 'Sao Miguel do Anta', 'MG', NULL, NULL, NULL, 3163805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.971941', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2993, 'Sao Pedro da Uniao', 'MG', NULL, NULL, NULL, 3163904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.972841', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2995, 'Sao Pedro dos Ferros', 'MG', NULL, NULL, NULL, 3164001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.974488', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2994, 'Sao Pedro do Suacui', 'MG', NULL, NULL, NULL, 3164100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.973711', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2996, 'Sao Romao', 'MG', NULL, NULL, NULL, 3164209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.975409', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2997, 'Sao Roque de Minas', 'MG', NULL, NULL, NULL, 3164308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.976377', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2998, 'Sao Sebastiao da Bela Vista', 'MG', NULL, NULL, NULL, 3164407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.977178', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2999, 'Sao Sebastiao da Vargem Alegre', 'MG', NULL, NULL, NULL, 3164431, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.97811', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3000, 'Sao Sebastiao do Anta', 'MG', NULL, NULL, NULL, 3164472, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.984627', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3001, 'Sao Sebastiao do Maranhao', 'MG', NULL, NULL, NULL, 3164506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.985785', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3002, 'Sao Sebastiao do Oeste', 'MG', NULL, NULL, NULL, 3164605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.986709', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3003, 'Sao Sebastiao do Paraiso', 'MG', NULL, NULL, NULL, 3164704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.987623', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3004, 'Sao Sebastiao do Rio Preto', 'MG', NULL, NULL, NULL, 3164803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.988553', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3005, 'Sao Sebastiao do Rio Verde', 'MG', NULL, NULL, NULL, 3164902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.989525', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3007, 'Sao Tiago', 'MG', NULL, NULL, NULL, 3165008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.991371', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3008, 'Sao Tomas de Aquino', 'MG', NULL, NULL, NULL, 3165107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.992485', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3006, 'Sao Thome das Letras', 'MG', NULL, NULL, NULL, 3165206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.990503', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3009, 'Sao Vicente de Minas', 'MG', NULL, NULL, NULL, 3165305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.993316', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3010, 'Sapucai-mirim', 'MG', NULL, NULL, NULL, 3165404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.994126', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3011, 'Sardoa', 'MG', NULL, NULL, NULL, 3165503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.995033', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3012, 'Sarzedo', 'MG', NULL, NULL, NULL, 3165537, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.995979', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3033, 'Setubinha', 'MG', NULL, NULL, NULL, 3165552, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.014708', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3014, 'Senador Amaral', 'MG', NULL, NULL, NULL, 3165578, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.997785', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3015, 'Senador Cortes', 'MG', NULL, NULL, NULL, 3165602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.998572', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3016, 'Senador Firmino', 'MG', NULL, NULL, NULL, 3165701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.999432', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3017, 'Senador Jose Bento', 'MG', NULL, NULL, NULL, 3165800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.000242', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3018, 'Senador Modestino Goncalves', 'MG', NULL, NULL, NULL, 3165909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.001181', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3019, 'Senhora de Oliveira', 'MG', NULL, NULL, NULL, 3166006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.002238', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3020, 'Senhora do Porto', 'MG', NULL, NULL, NULL, 3166105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.003123', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3021, 'Senhora dos Remedios', 'MG', NULL, NULL, NULL, 3166204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.003942', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3022, 'Sericita', 'MG', NULL, NULL, NULL, 3166303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.004806', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3023, 'Seritinga', 'MG', NULL, NULL, NULL, 3166402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.00583', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3024, 'Serra Azul de Minas', 'MG', NULL, NULL, NULL, 3166501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.006724', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3025, 'Serra da Saudade', 'MG', NULL, NULL, NULL, 3166600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.007597', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3027, 'Serra dos Aimores', 'MG', NULL, NULL, NULL, 3166709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.00936', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3026, 'Serra do Salitre', 'MG', NULL, NULL, NULL, 3166808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.008494', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3028, 'Serrania', 'MG', NULL, NULL, NULL, 3166907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.010257', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3029, 'Serranopolis de Minas', 'MG', NULL, NULL, NULL, 3166956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.011126', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3030, 'Serranos', 'MG', NULL, NULL, NULL, 3167004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.011947', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3031, 'Serro', 'MG', NULL, NULL, NULL, 3167103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.012745', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3032, 'Sete Lagoas', 'MG', NULL, NULL, NULL, 3167202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.013654', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3034, 'Silveirania', 'MG', NULL, NULL, NULL, 3167301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.015627', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3035, 'Silvianopolis', 'MG', NULL, NULL, NULL, 3167400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.016489', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3036, 'Simao Pereira', 'MG', NULL, NULL, NULL, 3167509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.017459', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3037, 'Simonesia', 'MG', NULL, NULL, NULL, 3167608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.018331', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3038, 'Sobralia', 'MG', NULL, NULL, NULL, 3167707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.024929', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3039, 'Soledade de Minas', 'MG', NULL, NULL, NULL, 3167806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.026211', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3040, 'Tabuleiro', 'MG', NULL, NULL, NULL, 3167905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.027116', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3041, 'Taiobeiras', 'MG', NULL, NULL, NULL, 3168002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.027909', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3042, 'Taparuba', 'MG', NULL, NULL, NULL, 3168051, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.028691', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3043, 'Tapira', 'MG', NULL, NULL, NULL, 3168101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.029455', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3044, 'Tapirai', 'MG', NULL, NULL, NULL, 3168200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.030502', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3045, 'Taquaracu de Minas', 'MG', NULL, NULL, NULL, 3168309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.031405', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3046, 'Tarumirim', 'MG', NULL, NULL, NULL, 3168408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.032341', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3047, 'Teixeiras', 'MG', NULL, NULL, NULL, 3168507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.033084', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3048, 'Teofilo Otoni', 'MG', NULL, NULL, NULL, 3168606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.034005', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3049, 'Timoteo', 'MG', NULL, NULL, NULL, 3168705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.034877', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3050, 'Tiradentes', 'MG', NULL, NULL, NULL, 3168804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.035717', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3051, 'Tiros', 'MG', NULL, NULL, NULL, 3168903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.036438', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3052, 'Tocantins', 'MG', NULL, NULL, NULL, 3169000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.037378', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3054, 'Toledo', 'MG', NULL, NULL, NULL, 3169109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.039162', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3055, 'Tombos', 'MG', NULL, NULL, NULL, 3169208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.040058', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3056, 'Tres Coracoes', 'MG', NULL, NULL, NULL, 3169307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.040906', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3057, 'Tres Marias', 'MG', NULL, NULL, NULL, 3169356, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.0418', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3058, 'Tres Pontas', 'MG', NULL, NULL, NULL, 3169406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.042593', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3059, 'Tumiritinga', 'MG', NULL, NULL, NULL, 3169505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.043498', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3060, 'Tupaciguara', 'MG', NULL, NULL, NULL, 3169604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.044437', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3061, 'Turmalina', 'MG', NULL, NULL, NULL, 3169703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.045367', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3062, 'Turvolandia', 'MG', NULL, NULL, NULL, 3169802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.04633', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3063, 'Uba', 'MG', NULL, NULL, NULL, 3169901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.047362', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3064, 'Ubai', 'MG', NULL, NULL, NULL, 3170008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.048359', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3065, 'Ubaporanga', 'MG', NULL, NULL, NULL, 3170057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.049243', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3066, 'Uberaba', 'MG', NULL, NULL, NULL, 3170107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.050224', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3067, 'Uberlandia', 'MG', NULL, NULL, NULL, 3170206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.051156', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3068, 'Umburatiba', 'MG', NULL, NULL, NULL, 3170305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.052078', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3069, 'Unai', 'MG', NULL, NULL, NULL, 3170404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.052956', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3070, 'Uniao de Minas', 'MG', NULL, NULL, NULL, 3170438, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.05387', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3071, 'Uruana de Minas', 'MG', NULL, NULL, NULL, 3170479, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.054766', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3072, 'Urucania', 'MG', NULL, NULL, NULL, 3170503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.055651', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3073, 'Urucuia', 'MG', NULL, NULL, NULL, 3170529, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.056552', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3074, 'Vargem Alegre', 'MG', NULL, NULL, NULL, 3170578, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.057453', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3075, 'Vargem Bonita', 'MG', NULL, NULL, NULL, 3170602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.058481', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3076, 'Vargem Grande do Rio Pardo', 'MG', NULL, NULL, NULL, 3170651, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.05921', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3077, 'Varginha', 'MG', NULL, NULL, NULL, 3170701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.065668', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3078, 'Varjao de Minas', 'MG', NULL, NULL, NULL, 3170750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.066741', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3079, 'Varzea da Palma', 'MG', NULL, NULL, NULL, 3170800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.067629', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3080, 'Varzelandia', 'MG', NULL, NULL, NULL, 3170909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.068499', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3081, 'Vazante', 'MG', NULL, NULL, NULL, 3171006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.069738', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3082, 'Verdelandia', 'MG', NULL, NULL, NULL, 3171030, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.070607', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3083, 'Veredinha', 'MG', NULL, NULL, NULL, 3171071, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.071486', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3084, 'Verissimo', 'MG', NULL, NULL, NULL, 3171105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.072355', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3085, 'Vermelho Novo', 'MG', NULL, NULL, NULL, 3171154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.073251', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3086, 'Vespasiano', 'MG', NULL, NULL, NULL, 3171204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.074104', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3087, 'Vicosa', 'MG', NULL, NULL, NULL, 3171303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.074933', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3088, 'Vieiras', 'MG', NULL, NULL, NULL, 3171402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.075846', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (2713, 'Mathias Lobato', 'MG', NULL, NULL, NULL, 3171501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.667155', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3089, 'Virgem da Lapa', 'MG', NULL, NULL, NULL, 3171600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.076853', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3090, 'Virginia', 'MG', NULL, NULL, NULL, 3171709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.077734', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3091, 'Virginopolis', 'MG', NULL, NULL, NULL, 3171808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.078589', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3092, 'Virgolandia', 'MG', NULL, NULL, NULL, 3171907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.079515', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3093, 'Visconde do Rio Branco', 'MG', NULL, NULL, NULL, 3172004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.080291', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3094, 'Volta Grande', 'MG', NULL, NULL, NULL, 3172103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.081204', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3095, 'Wenceslau Braz', 'MG', NULL, NULL, NULL, 3172202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.081973', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3096, 'Afonso Claudio', 'ES', NULL, NULL, NULL, 3200102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.082886', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3098, 'Aguia Branca', 'ES', NULL, NULL, NULL, 3200136, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.084678', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3097, 'Agua Doce do Norte', 'ES', NULL, NULL, NULL, 3200169, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.08375', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3099, 'Alegre', 'ES', NULL, NULL, NULL, 3200201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.085605', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3100, 'Alfredo Chaves', 'ES', NULL, NULL, NULL, 3200300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.086469', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3101, 'Alto Rio Novo', 'ES', NULL, NULL, NULL, 3200359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.087312', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3102, 'Anchieta', 'ES', NULL, NULL, NULL, 3200409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.088204', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3103, 'Apiaca', 'ES', NULL, NULL, NULL, 3200508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.089062', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3104, 'Aracruz', 'ES', NULL, NULL, NULL, 3200607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.089943', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3105, 'Atilio Vivacqua', 'ES', NULL, NULL, NULL, 3200706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.09086', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3106, 'Baixo Guandu', 'ES', NULL, NULL, NULL, 3200805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.091737', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3107, 'Barra de Sao Francisco', 'ES', NULL, NULL, NULL, 3200904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.092835', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3108, 'Boa Esperanca', 'ES', NULL, NULL, NULL, 3201001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.093704', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3109, 'Bom Jesus do Norte', 'ES', NULL, NULL, NULL, 3201100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.094622', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3110, 'Brejetuba', 'ES', NULL, NULL, NULL, 3201159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.095495', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3111, 'Cachoeiro de Itapemirim', 'ES', NULL, NULL, NULL, 3201209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.096312', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3112, 'Cariacica', 'ES', NULL, NULL, NULL, 3201308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.097169', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3113, 'Castelo', 'ES', NULL, NULL, NULL, 3201407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.09809', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3114, 'Colatina', 'ES', NULL, NULL, NULL, 3201506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.099011', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3115, 'Conceicao da Barra', 'ES', NULL, NULL, NULL, 3201605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.105545', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3116, 'Conceicao do Castelo', 'ES', NULL, NULL, NULL, 3201704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.106749', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3117, 'Divino de Sao Lourenco', 'ES', NULL, NULL, NULL, 3201803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.107684', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3118, 'Domingos Martins', 'ES', NULL, NULL, NULL, 3201902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.108581', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3119, 'Dores do Rio Preto', 'ES', NULL, NULL, NULL, 3202009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.109452', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3120, 'Ecoporanga', 'ES', NULL, NULL, NULL, 3202108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.110394', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3121, 'Fundao', 'ES', NULL, NULL, NULL, 3202207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.111308', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3122, 'Governador Lindenberg', 'ES', NULL, NULL, NULL, 3202256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.112208', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3123, 'Guacui', 'ES', NULL, NULL, NULL, 3202306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.113153', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3124, 'Guarapari', 'ES', NULL, NULL, NULL, 3202405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.11402', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3125, 'Ibatiba', 'ES', NULL, NULL, NULL, 3202454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.11507', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3126, 'Ibiracu', 'ES', NULL, NULL, NULL, 3202504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.115945', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3127, 'Ibitirama', 'ES', NULL, NULL, NULL, 3202553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.116851', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3128, 'Iconha', 'ES', NULL, NULL, NULL, 3202603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.117854', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3129, 'Irupi', 'ES', NULL, NULL, NULL, 3202652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.118674', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3130, 'Itaguacu', 'ES', NULL, NULL, NULL, 3202702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.119498', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3131, 'Itapemirim', 'ES', NULL, NULL, NULL, 3202801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.120273', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3132, 'Itarana', 'ES', NULL, NULL, NULL, 3202900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.12108', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3133, 'Iuna', 'ES', NULL, NULL, NULL, 3203007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.122057', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3134, 'Jaguare', 'ES', NULL, NULL, NULL, 3203056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.122973', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3135, 'Jeronimo Monteiro', 'ES', NULL, NULL, NULL, 3203106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.123854', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3136, 'Joao Neiva', 'ES', NULL, NULL, NULL, 3203130, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.124735', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3137, 'Laranja da Terra', 'ES', NULL, NULL, NULL, 3203163, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.125741', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3138, 'Linhares', 'ES', NULL, NULL, NULL, 3203205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.126641', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3139, 'Mantenopolis', 'ES', NULL, NULL, NULL, 3203304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.127556', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3140, 'Marataizes', 'ES', NULL, NULL, NULL, 3203320, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.128435', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3141, 'Marechal Floriano', 'ES', NULL, NULL, NULL, 3203346, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.129304', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3142, 'Marilandia', 'ES', NULL, NULL, NULL, 3203353, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.130149', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3143, 'Mimoso do Sul', 'ES', NULL, NULL, NULL, 3203403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.131032', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3144, 'Montanha', 'ES', NULL, NULL, NULL, 3203502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.131767', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3145, 'Mucurici', 'ES', NULL, NULL, NULL, 3203601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.132669', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3146, 'Muniz Freire', 'ES', NULL, NULL, NULL, 3203700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.133579', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3147, 'Muqui', 'ES', NULL, NULL, NULL, 3203809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.13436', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3148, 'Nova Venecia', 'ES', NULL, NULL, NULL, 3203908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.135185', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3149, 'Pancas', 'ES', NULL, NULL, NULL, 3204005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.136062', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3150, 'Pedro Canario', 'ES', NULL, NULL, NULL, 3204054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.137029', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3151, 'Pinheiros', 'ES', NULL, NULL, NULL, 3204104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.13779', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3152, 'Piuma', 'ES', NULL, NULL, NULL, 3204203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.138726', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3153, 'Ponto Belo', 'ES', NULL, NULL, NULL, 3204252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.139504', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3154, 'Presidente Kennedy', 'ES', NULL, NULL, NULL, 3204302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.146339', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3155, 'Rio Bananal', 'ES', NULL, NULL, NULL, 3204351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.150463', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3156, 'Rio Novo do Sul', 'ES', NULL, NULL, NULL, 3204401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.151418', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3157, 'Santa Leopoldina', 'ES', NULL, NULL, NULL, 3204500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.152323', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3158, 'Santa Maria de Jetiba', 'ES', NULL, NULL, NULL, 3204559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.153183', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3159, 'Santa Teresa', 'ES', NULL, NULL, NULL, 3204609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.154075', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3160, 'Sao Domingos do Norte', 'ES', NULL, NULL, NULL, 3204658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.154905', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3161, 'Sao Gabriel da Palha', 'ES', NULL, NULL, NULL, 3204708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.15581', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3162, 'Sao Jose do Calcado', 'ES', NULL, NULL, NULL, 3204807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.156713', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3163, 'Sao Mateus', 'ES', NULL, NULL, NULL, 3204906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.157706', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3164, 'Sao Roque do Canaa', 'ES', NULL, NULL, NULL, 3204955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.158648', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3165, 'Serra', 'ES', NULL, NULL, NULL, 3205002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.159594', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3166, 'Sooretama', 'ES', NULL, NULL, NULL, 3205010, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.160485', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3167, 'Vargem Alta', 'ES', NULL, NULL, NULL, 3205036, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.161405', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3168, 'Venda Nova do Imigrante', 'ES', NULL, NULL, NULL, 3205069, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.162222', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3169, 'Viana', 'ES', NULL, NULL, NULL, 3205101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.163119', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3170, 'Vila Pavao', 'ES', NULL, NULL, NULL, 3205150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.164134', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3171, 'Vila Valerio', 'ES', NULL, NULL, NULL, 3205176, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.165005', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3172, 'Vila Velha', 'ES', NULL, NULL, NULL, 3205200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.165861', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3173, 'Vitoria', 'ES', NULL, NULL, NULL, 3205309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.166749', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3174, 'Angra dos Reis', 'RJ', NULL, NULL, NULL, 3300100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.16759', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3175, 'Aperibe', 'RJ', NULL, NULL, NULL, 3300159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.168353', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3176, 'Araruama', 'RJ', NULL, NULL, NULL, 3300209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.169167', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3177, 'Areal', 'RJ', NULL, NULL, NULL, 3300225, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.170131', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3178, 'Armacao dos Buzios', 'RJ', NULL, NULL, NULL, 3300233, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.171024', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3179, 'Arraial do Cabo', 'RJ', NULL, NULL, NULL, 3300258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.171933', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3180, 'Barra do Pirai', 'RJ', NULL, NULL, NULL, 3300308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.172817', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3181, 'Barra Mansa', 'RJ', NULL, NULL, NULL, 3300407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.173722', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3182, 'Belford Roxo', 'RJ', NULL, NULL, NULL, 3300456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.174593', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3183, 'Bom Jardim', 'RJ', NULL, NULL, NULL, 3300506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.175369', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3184, 'Bom Jesus do Itabapoana', 'RJ', NULL, NULL, NULL, 3300605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.17623', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3185, 'Cabo Frio', 'RJ', NULL, NULL, NULL, 3300704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.177146', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3186, 'Cachoeiras de Macacu', 'RJ', NULL, NULL, NULL, 3300803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.178064', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3187, 'Cambuci', 'RJ', NULL, NULL, NULL, 3300902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.178988', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3190, 'Carapebus', 'RJ', NULL, NULL, NULL, 3300936, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.188539', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3194, 'Comendador Levy Gasparian', 'RJ', NULL, NULL, NULL, 3300951, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.192154', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3188, 'Campos dos Goytacazes', 'RJ', NULL, NULL, NULL, 3301009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.17996', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3189, 'Cantagalo', 'RJ', NULL, NULL, NULL, 3301108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.187376', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3191, 'Cardoso Moreira', 'RJ', NULL, NULL, NULL, 3301157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.189489', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3192, 'Carmo', 'RJ', NULL, NULL, NULL, 3301207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.190376', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3193, 'Casimiro de Abreu', 'RJ', NULL, NULL, NULL, 3301306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.191224', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3195, 'Conceicao de Macabu', 'RJ', NULL, NULL, NULL, 3301405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.193182', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3196, 'Cordeiro', 'RJ', NULL, NULL, NULL, 3301504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.194114', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3197, 'Duas Barras', 'RJ', NULL, NULL, NULL, 3301603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.195152', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3198, 'Duque de Caxias', 'RJ', NULL, NULL, NULL, 3301702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.195978', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3199, 'Engenheiro Paulo de Frontin', 'RJ', NULL, NULL, NULL, 3301801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.197016', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3200, 'Guapimirim', 'RJ', NULL, NULL, NULL, 3301850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.197975', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3201, 'Iguaba Grande', 'RJ', NULL, NULL, NULL, 3301876, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.198896', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3202, 'Itaborai', 'RJ', NULL, NULL, NULL, 3301900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.199823', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3203, 'Itaguai', 'RJ', NULL, NULL, NULL, 3302007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.200615', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3204, 'Italva', 'RJ', NULL, NULL, NULL, 3302056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.201573', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3205, 'Itaocara', 'RJ', NULL, NULL, NULL, 3302106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.202472', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3206, 'Itaperuna', 'RJ', NULL, NULL, NULL, 3302205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.203303', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3207, 'Itatiaia', 'RJ', NULL, NULL, NULL, 3302254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.204383', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3208, 'Japeri', 'RJ', NULL, NULL, NULL, 3302270, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.20529', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3209, 'Laje do Muriae', 'RJ', NULL, NULL, NULL, 3302304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.206148', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3210, 'Macae', 'RJ', NULL, NULL, NULL, 3302403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.207034', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3211, 'Macuco', 'RJ', NULL, NULL, NULL, 3302452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.207887', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3212, 'Mage', 'RJ', NULL, NULL, NULL, 3302502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.208742', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3213, 'Mangaratiba', 'RJ', NULL, NULL, NULL, 3302601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.209642', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3214, 'Marica', 'RJ', NULL, NULL, NULL, 3302700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.210561', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3215, 'Mendes', 'RJ', NULL, NULL, NULL, 3302809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.211426', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3216, 'Mesquita', 'RJ', NULL, NULL, NULL, 3302858, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.212248', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3217, 'Miguel Pereira', 'RJ', NULL, NULL, NULL, 3302908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.21322', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3218, 'Miracema', 'RJ', NULL, NULL, NULL, 3303005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.214025', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3219, 'Natividade', 'RJ', NULL, NULL, NULL, 3303104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.214987', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3220, 'Nilopolis', 'RJ', NULL, NULL, NULL, 3303203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.215631', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3221, 'Niteroi', 'RJ', NULL, NULL, NULL, 3303302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.216575', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3222, 'Nova Friburgo', 'RJ', NULL, NULL, NULL, 3303401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.217505', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3223, 'Nova Iguacu', 'RJ', NULL, NULL, NULL, 3303500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.218374', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3224, 'Paracambi', 'RJ', NULL, NULL, NULL, 3303609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.219241', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3225, 'Paraiba do Sul', 'RJ', NULL, NULL, NULL, 3303708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.22011', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3227, 'Paty do Alferes', 'RJ', NULL, NULL, NULL, 3303856, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.227898', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3228, 'Petropolis', 'RJ', NULL, NULL, NULL, 3303906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.22905', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3229, 'Pinheiral', 'RJ', NULL, NULL, NULL, 3303955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.229964', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3230, 'Pirai', 'RJ', NULL, NULL, NULL, 3304003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.230972', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3231, 'Porciuncula', 'RJ', NULL, NULL, NULL, 3304102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.231958', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3232, 'Porto Real', 'RJ', NULL, NULL, NULL, 3304110, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.232847', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3233, 'Quatis', 'RJ', NULL, NULL, NULL, 3304128, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.233751', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3234, 'Queimados', 'RJ', NULL, NULL, NULL, 3304144, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.234722', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3235, 'Quissama', 'RJ', NULL, NULL, NULL, 3304151, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.235676', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3236, 'Resende', 'RJ', NULL, NULL, NULL, 3304201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.236633', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3237, 'Rio Bonito', 'RJ', NULL, NULL, NULL, 3304300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.238008', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3238, 'Rio Claro', 'RJ', NULL, NULL, NULL, 3304409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.238923', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3239, 'Rio das Flores', 'RJ', NULL, NULL, NULL, 3304508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.239799', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3240, 'Rio das Ostras', 'RJ', NULL, NULL, NULL, 3304524, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.24067', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3241, 'Rio de Janeiro', 'RJ', NULL, NULL, NULL, 3304557, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.241514', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3242, 'Santa Maria Madalena', 'RJ', NULL, NULL, NULL, 3304607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.242392', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3243, 'Santo Antonio de Padua', 'RJ', NULL, NULL, NULL, 3304706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.24326', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3245, 'Sao Francisco de Itabapoana', 'RJ', NULL, NULL, NULL, 3304755, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.244999', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3244, 'Sao Fidelis', 'RJ', NULL, NULL, NULL, 3304805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.244209', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3246, 'Sao Goncalo', 'RJ', NULL, NULL, NULL, 3304904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.245904', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3247, 'Sao Joao da Barra', 'RJ', NULL, NULL, NULL, 3305000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.24683', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3248, 'Sao Joao de Meriti', 'RJ', NULL, NULL, NULL, 3305109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.24777', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3249, 'Sao Jose de Uba', 'RJ', NULL, NULL, NULL, 3305133, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.248945', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3250, 'Sao Jose do Vale do Rio Preto', 'RJ', NULL, NULL, NULL, 3305158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.249825', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3251, 'Sao Pedro da Aldeia', 'RJ', NULL, NULL, NULL, 3305208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.250587', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3252, 'Sao Sebastiao do Alto', 'RJ', NULL, NULL, NULL, 3305307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.251419', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3253, 'Sapucaia', 'RJ', NULL, NULL, NULL, 3305406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.252236', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3254, 'Saquarema', 'RJ', NULL, NULL, NULL, 3305505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.253149', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3255, 'Seropedica', 'RJ', NULL, NULL, NULL, 3305554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.254076', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3256, 'Silva Jardim', 'RJ', NULL, NULL, NULL, 3305604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.254876', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3257, 'Sumidouro', 'RJ', NULL, NULL, NULL, 3305703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.255796', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3258, 'Tangua', 'RJ', NULL, NULL, NULL, 3305752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.256693', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3259, 'Teresopolis', 'RJ', NULL, NULL, NULL, 3305802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.257579', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3261, 'Tres Rios', 'RJ', NULL, NULL, NULL, 3306008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.259558', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3262, 'Valenca', 'RJ', NULL, NULL, NULL, 3306107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.260357', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3263, 'Varre-sai', 'RJ', NULL, NULL, NULL, 3306156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.261201', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3264, 'Vassouras', 'RJ', NULL, NULL, NULL, 3306206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.262061', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3265, 'Volta Redonda', 'RJ', NULL, NULL, NULL, 3306305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.268581', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3266, 'Adamantina', 'SP', NULL, NULL, NULL, 3500105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.269835', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3267, 'Adolfo', 'SP', NULL, NULL, NULL, 3500204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.27087', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3268, 'Aguai', 'SP', NULL, NULL, NULL, 3500303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.27173', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3269, 'Aguas da Prata', 'SP', NULL, NULL, NULL, 3500402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.272445', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3270, 'Aguas de Lindoia', 'SP', NULL, NULL, NULL, 3500501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.273402', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3271, 'Aguas de Santa Barbara', 'SP', NULL, NULL, NULL, 3500550, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.274253', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3272, 'Aguas de Sao Pedro', 'SP', NULL, NULL, NULL, 3500600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.275125', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3273, 'Agudos', 'SP', NULL, NULL, NULL, 3500709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.276017', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3274, 'Alambari', 'SP', NULL, NULL, NULL, 3500758, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.276922', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3275, 'Alfredo Marcondes', 'SP', NULL, NULL, NULL, 3500808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.277864', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3276, 'Altair', 'SP', NULL, NULL, NULL, 3500907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.278774', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3277, 'Altinopolis', 'SP', NULL, NULL, NULL, 3501004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.279605', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3278, 'Alto Alegre', 'SP', NULL, NULL, NULL, 3501103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.280491', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3279, 'Aluminio', 'SP', NULL, NULL, NULL, 3501152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.281409', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3280, 'Alvares Florence', 'SP', NULL, NULL, NULL, 3501202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.282369', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3281, 'Alvares Machado', 'SP', NULL, NULL, NULL, 3501301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.283238', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3282, 'Alvaro de Carvalho', 'SP', NULL, NULL, NULL, 3501400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.284169', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3283, 'Alvinlandia', 'SP', NULL, NULL, NULL, 3501509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.285077', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3284, 'Americana', 'SP', NULL, NULL, NULL, 3501608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.286013', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3285, 'Americo Brasiliense', 'SP', NULL, NULL, NULL, 3501707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.286803', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3286, 'Americo de Campos', 'SP', NULL, NULL, NULL, 3501806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.287738', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3287, 'Amparo', 'SP', NULL, NULL, NULL, 3501905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.288607', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3288, 'Analandia', 'SP', NULL, NULL, NULL, 3502002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.2895', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3289, 'Andradina', 'SP', NULL, NULL, NULL, 3502101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.290456', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3290, 'Angatuba', 'SP', NULL, NULL, NULL, 3502200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.291244', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3291, 'Anhembi', 'SP', NULL, NULL, NULL, 3502309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.29216', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3292, 'Anhumas', 'SP', NULL, NULL, NULL, 3502408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.293119', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3293, 'Aparecida', 'SP', NULL, NULL, NULL, 3502507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.293914', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3294, 'Aparecida D''oeste', 'SP', NULL, NULL, NULL, 3502606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.294812', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3295, 'Apiai', 'SP', NULL, NULL, NULL, 3502705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.295701', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3296, 'Aracariguama', 'SP', NULL, NULL, NULL, 3502754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.29661', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3297, 'Aracatuba', 'SP', NULL, NULL, NULL, 3502804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.297483', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3298, 'Aracoiaba da Serra', 'SP', NULL, NULL, NULL, 3502903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.298305', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3299, 'Aramina', 'SP', NULL, NULL, NULL, 3503000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.299187', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3300, 'Arandu', 'SP', NULL, NULL, NULL, 3503109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.299986', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3301, 'Arapei', 'SP', NULL, NULL, NULL, 3503158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.300898', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3302, 'Araraquara', 'SP', NULL, NULL, NULL, 3503208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.301802', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3303, 'Araras', 'SP', NULL, NULL, NULL, 3503307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.308817', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3304, 'Arco-iris', 'SP', NULL, NULL, NULL, 3503356, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.31001', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3305, 'Arealva', 'SP', NULL, NULL, NULL, 3503406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.311055', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3306, 'Areias', 'SP', NULL, NULL, NULL, 3503505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.31192', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3307, 'Areiopolis', 'SP', NULL, NULL, NULL, 3503604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.312751', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3308, 'Ariranha', 'SP', NULL, NULL, NULL, 3503703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.313577', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3309, 'Artur Nogueira', 'SP', NULL, NULL, NULL, 3503802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.314489', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3310, 'Aruja', 'SP', NULL, NULL, NULL, 3503901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.315495', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3311, 'Aspasia', 'SP', NULL, NULL, NULL, 3503950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.316308', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3312, 'Assis', 'SP', NULL, NULL, NULL, 3504008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.317358', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3313, 'Atibaia', 'SP', NULL, NULL, NULL, 3504107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.318277', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3314, 'Auriflama', 'SP', NULL, NULL, NULL, 3504206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.319244', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3315, 'Avai', 'SP', NULL, NULL, NULL, 3504305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.320115', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3316, 'Avanhandava', 'SP', NULL, NULL, NULL, 3504404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.320988', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3317, 'Avare', 'SP', NULL, NULL, NULL, 3504503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.321877', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3318, 'Bady Bassitt', 'SP', NULL, NULL, NULL, 3504602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.322788', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3319, 'Balbinos', 'SP', NULL, NULL, NULL, 3504701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.32373', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3320, 'Balsamo', 'SP', NULL, NULL, NULL, 3504800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.324586', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3321, 'Bananal', 'SP', NULL, NULL, NULL, 3504909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.325482', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3322, 'Barao de Antonina', 'SP', NULL, NULL, NULL, 3505005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.326512', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3323, 'Barbosa', 'SP', NULL, NULL, NULL, 3505104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.327365', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3324, 'Bariri', 'SP', NULL, NULL, NULL, 3505203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.328252', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3325, 'Barra Bonita', 'SP', NULL, NULL, NULL, 3505302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.329113', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3326, 'Barra do Chapeu', 'SP', NULL, NULL, NULL, 3505351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.329955', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3327, 'Barra do Turvo', 'SP', NULL, NULL, NULL, 3505401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.330965', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3328, 'Barretos', 'SP', NULL, NULL, NULL, 3505500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.331935', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3329, 'Barrinha', 'SP', NULL, NULL, NULL, 3505609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.332765', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3330, 'Barueri', 'SP', NULL, NULL, NULL, 3505708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.333592', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3331, 'Bastos', 'SP', NULL, NULL, NULL, 3505807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.334547', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3332, 'Batatais', 'SP', NULL, NULL, NULL, 3505906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.33538', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3333, 'Bauru', 'SP', NULL, NULL, NULL, 3506003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.336251', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3334, 'Bebedouro', 'SP', NULL, NULL, NULL, 3506102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.337171', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3335, 'Bento de Abreu', 'SP', NULL, NULL, NULL, 3506201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.338264', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3336, 'Bernardino de Campos', 'SP', NULL, NULL, NULL, 3506300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.339179', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3337, 'Bertioga', 'SP', NULL, NULL, NULL, 3506359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.340015', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3338, 'Bilac', 'SP', NULL, NULL, NULL, 3506409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.340826', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3339, 'Birigui', 'SP', NULL, NULL, NULL, 3506508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.341697', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3340, 'Biritiba-mirim', 'SP', NULL, NULL, NULL, 3506607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.342549', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3341, 'Boa Esperanca do Sul', 'SP', NULL, NULL, NULL, 3506706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.350287', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3342, 'Bocaina', 'SP', NULL, NULL, NULL, 3506805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.351429', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3343, 'Bofete', 'SP', NULL, NULL, NULL, 3506904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.352408', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3344, 'Boituva', 'SP', NULL, NULL, NULL, 3507001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.353564', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3345, 'Bom Jesus dos Perdoes', 'SP', NULL, NULL, NULL, 3507100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.354421', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3346, 'Bom Sucesso de Itarare', 'SP', NULL, NULL, NULL, 3507159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.355449', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3347, 'Bora', 'SP', NULL, NULL, NULL, 3507209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.356379', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3348, 'Boraceia', 'SP', NULL, NULL, NULL, 3507308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.357481', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3349, 'Borborema', 'SP', NULL, NULL, NULL, 3507407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.358426', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3350, 'Borebi', 'SP', NULL, NULL, NULL, 3507456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.359296', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3351, 'Botucatu', 'SP', NULL, NULL, NULL, 3507506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.360376', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3352, 'Braganca Paulista', 'SP', NULL, NULL, NULL, 3507605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.361423', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3353, 'Brauna', 'SP', NULL, NULL, NULL, 3507704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.362273', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3354, 'Brejo Alegre', 'SP', NULL, NULL, NULL, 3507753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.363155', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3355, 'Brodowski', 'SP', NULL, NULL, NULL, 3507803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.364124', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3356, 'Brotas', 'SP', NULL, NULL, NULL, 3507902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.365052', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3357, 'Buri', 'SP', NULL, NULL, NULL, 3508009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.366004', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3358, 'Buritama', 'SP', NULL, NULL, NULL, 3508108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.366945', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3359, 'Buritizal', 'SP', NULL, NULL, NULL, 3508207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.367895', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3360, 'Cabralia Paulista', 'SP', NULL, NULL, NULL, 3508306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.368816', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3361, 'Cabreuva', 'SP', NULL, NULL, NULL, 3508405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.369719', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3362, 'Cacapava', 'SP', NULL, NULL, NULL, 3508504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.370627', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3363, 'Cachoeira Paulista', 'SP', NULL, NULL, NULL, 3508603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.371763', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3364, 'Caconde', 'SP', NULL, NULL, NULL, 3508702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.372711', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3365, 'Cafelandia', 'SP', NULL, NULL, NULL, 3508801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.373562', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3366, 'Caiabu', 'SP', NULL, NULL, NULL, 3508900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.374476', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3367, 'Caieiras', 'SP', NULL, NULL, NULL, 3509007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.375453', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3368, 'Caiua', 'SP', NULL, NULL, NULL, 3509106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.37635', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3369, 'Cajamar', 'SP', NULL, NULL, NULL, 3509205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.377277', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3370, 'Cajati', 'SP', NULL, NULL, NULL, 3509254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.378209', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3371, 'Cajobi', 'SP', NULL, NULL, NULL, 3509304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.379165', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3372, 'Cajuru', 'SP', NULL, NULL, NULL, 3509403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.380188', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3373, 'Campina do Monte Alegre', 'SP', NULL, NULL, NULL, 3509452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.381138', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3374, 'Campinas', 'SP', NULL, NULL, NULL, 3509502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.381967', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3375, 'Campo Limpo Paulista', 'SP', NULL, NULL, NULL, 3509601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.382892', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3376, 'Campos do Jordao', 'SP', NULL, NULL, NULL, 3509700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.384015', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3377, 'Campos Novos Paulista', 'SP', NULL, NULL, NULL, 3509809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.390894', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3378, 'Cananeia', 'SP', NULL, NULL, NULL, 3509908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.392104', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3379, 'Canas', 'SP', NULL, NULL, NULL, 3509957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.393199', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3380, 'Candido Mota', 'SP', NULL, NULL, NULL, 3510005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.394055', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3381, 'Candido Rodrigues', 'SP', NULL, NULL, NULL, 3510104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.39493', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3382, 'Canitar', 'SP', NULL, NULL, NULL, 3510153, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.395858', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3383, 'Capao Bonito', 'SP', NULL, NULL, NULL, 3510203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.39675', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3384, 'Capela do Alto', 'SP', NULL, NULL, NULL, 3510302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.397713', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3385, 'Capivari', 'SP', NULL, NULL, NULL, 3510401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.398691', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3386, 'Caraguatatuba', 'SP', NULL, NULL, NULL, 3510500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.399692', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3387, 'Carapicuiba', 'SP', NULL, NULL, NULL, 3510609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.400634', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3388, 'Cardoso', 'SP', NULL, NULL, NULL, 3510708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.401562', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3389, 'Casa Branca', 'SP', NULL, NULL, NULL, 3510807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.40251', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3390, 'Cassia dos Coqueiros', 'SP', NULL, NULL, NULL, 3510906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.403415', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3391, 'Castilho', 'SP', NULL, NULL, NULL, 3511003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.4044', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3392, 'Catanduva', 'SP', NULL, NULL, NULL, 3511102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.405192', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3393, 'Catigua', 'SP', NULL, NULL, NULL, 3511201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.406069', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3394, 'Cedral', 'SP', NULL, NULL, NULL, 3511300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.407007', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3395, 'Cerqueira Cesar', 'SP', NULL, NULL, NULL, 3511409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.407879', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3396, 'Cerquilho', 'SP', NULL, NULL, NULL, 3511508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.408712', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3397, 'Cesario Lange', 'SP', NULL, NULL, NULL, 3511607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.409578', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3398, 'Charqueada', 'SP', NULL, NULL, NULL, 3511706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.410493', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3400, 'Clementina', 'SP', NULL, NULL, NULL, 3511904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.412407', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3401, 'Colina', 'SP', NULL, NULL, NULL, 3512001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.413332', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3402, 'Colombia', 'SP', NULL, NULL, NULL, 3512100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.41435', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3403, 'Conchal', 'SP', NULL, NULL, NULL, 3512209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.415259', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3404, 'Conchas', 'SP', NULL, NULL, NULL, 3512308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.416408', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3405, 'Cordeiropolis', 'SP', NULL, NULL, NULL, 3512407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.417364', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3406, 'Coroados', 'SP', NULL, NULL, NULL, 3512506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.418209', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3407, 'Coronel Macedo', 'SP', NULL, NULL, NULL, 3512605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.41912', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3408, 'Corumbatai', 'SP', NULL, NULL, NULL, 3512704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.420001', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3409, 'Cosmopolis', 'SP', NULL, NULL, NULL, 3512803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.420964', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3410, 'Cosmorama', 'SP', NULL, NULL, NULL, 3512902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.421879', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3411, 'Cotia', 'SP', NULL, NULL, NULL, 3513009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.422822', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3412, 'Cravinhos', 'SP', NULL, NULL, NULL, 3513108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.423659', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3413, 'Cristais Paulista', 'SP', NULL, NULL, NULL, 3513207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.424565', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3414, 'Cruzalia', 'SP', NULL, NULL, NULL, 3513306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.433202', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3415, 'Cruzeiro', 'SP', NULL, NULL, NULL, 3513405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.43419', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3416, 'Cubatao', 'SP', NULL, NULL, NULL, 3513504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.435124', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3417, 'Cunha', 'SP', NULL, NULL, NULL, 3513603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.436005', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3418, 'Descalvado', 'SP', NULL, NULL, NULL, 3513702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.436909', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3419, 'Diadema', 'SP', NULL, NULL, NULL, 3513801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.43802', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3420, 'Dirce Reis', 'SP', NULL, NULL, NULL, 3513850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.438961', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3421, 'Divinolandia', 'SP', NULL, NULL, NULL, 3513900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.439881', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3422, 'Dobrada', 'SP', NULL, NULL, NULL, 3514007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.44092', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3423, 'Dois Corregos', 'SP', NULL, NULL, NULL, 3514106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.441834', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3424, 'Dolcinopolis', 'SP', NULL, NULL, NULL, 3514205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.442609', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3425, 'Dourado', 'SP', NULL, NULL, NULL, 3514304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.443543', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3426, 'Dracena', 'SP', NULL, NULL, NULL, 3514403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.444476', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3427, 'Duartina', 'SP', NULL, NULL, NULL, 3514502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.445394', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3428, 'Dumont', 'SP', NULL, NULL, NULL, 3514601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.44637', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3429, 'Echapora', 'SP', NULL, NULL, NULL, 3514700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.447249', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3430, 'Eldorado', 'SP', NULL, NULL, NULL, 3514809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.448152', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3431, 'Elias Fausto', 'SP', NULL, NULL, NULL, 3514908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.449197', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3432, 'Elisiario', 'SP', NULL, NULL, NULL, 3514924, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.450013', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3433, 'Embauba', 'SP', NULL, NULL, NULL, 3514957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.450854', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3435, 'Embu-guacu', 'SP', NULL, NULL, NULL, 3515103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.452864', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3436, 'Emilianopolis', 'SP', NULL, NULL, NULL, 3515129, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.453877', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3437, 'Engenheiro Coelho', 'SP', NULL, NULL, NULL, 3515152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.454824', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3438, 'Espirito Santo do Pinhal', 'SP', NULL, NULL, NULL, 3515186, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.455702', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3439, 'Espirito Santo do Turvo', 'SP', NULL, NULL, NULL, 3515194, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.456596', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3442, 'Estrela D''oeste', 'SP', NULL, NULL, NULL, 3515202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.464626', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3441, 'Estrela do Norte', 'SP', NULL, NULL, NULL, 3515301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.463187', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3443, 'Euclides da Cunha Paulista', 'SP', NULL, NULL, NULL, 3515350, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.465815', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3444, 'Fartura', 'SP', NULL, NULL, NULL, 3515400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.467149', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3446, 'Fernandopolis', 'SP', NULL, NULL, NULL, 3515509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.474339', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3445, 'Fernando Prestes', 'SP', NULL, NULL, NULL, 3515608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.468296', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3447, 'Fernao', 'SP', NULL, NULL, NULL, 3515657, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.475403', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3448, 'Ferraz de Vasconcelos', 'SP', NULL, NULL, NULL, 3515707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.476418', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3449, 'Flora Rica', 'SP', NULL, NULL, NULL, 3515806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.477443', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3450, 'Floreal', 'SP', NULL, NULL, NULL, 3515905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.478415', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3451, 'Florida Paulista', 'SP', NULL, NULL, NULL, 3516002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.479622', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3452, 'Florinia', 'SP', NULL, NULL, NULL, 3516101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.480544', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3453, 'Franca', 'SP', NULL, NULL, NULL, 3516200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.481469', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3454, 'Francisco Morato', 'SP', NULL, NULL, NULL, 3516309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.482394', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3455, 'Franco da Rocha', 'SP', NULL, NULL, NULL, 3516408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.483499', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3456, 'Gabriel Monteiro', 'SP', NULL, NULL, NULL, 3516507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.484411', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3457, 'Galia', 'SP', NULL, NULL, NULL, 3516606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.485277', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3458, 'Garca', 'SP', NULL, NULL, NULL, 3516705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.486137', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3459, 'Gastao Vidigal', 'SP', NULL, NULL, NULL, 3516804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.487262', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3460, 'Gaviao Peixoto', 'SP', NULL, NULL, NULL, 3516853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.488275', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3461, 'General Salgado', 'SP', NULL, NULL, NULL, 3516903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.489182', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3462, 'Getulina', 'SP', NULL, NULL, NULL, 3517000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.490105', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3463, 'Glicerio', 'SP', NULL, NULL, NULL, 3517109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.491081', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3464, 'Guaicara', 'SP', NULL, NULL, NULL, 3517208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.49205', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3465, 'Guaimbe', 'SP', NULL, NULL, NULL, 3517307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.492981', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3466, 'Guaira', 'SP', NULL, NULL, NULL, 3517406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.493861', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3467, 'Guapiacu', 'SP', NULL, NULL, NULL, 3517505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.494824', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3468, 'Guapiara', 'SP', NULL, NULL, NULL, 3517604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.495711', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3469, 'Guara', 'SP', NULL, NULL, NULL, 3517703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.49662', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3470, 'Guaracai', 'SP', NULL, NULL, NULL, 3517802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.497498', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3471, 'Guaraci', 'SP', NULL, NULL, NULL, 3517901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.498609', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3472, 'Guarani D''oeste', 'SP', NULL, NULL, NULL, 3518008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.499582', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3473, 'Guaranta', 'SP', NULL, NULL, NULL, 3518107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.500522', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3474, 'Guararapes', 'SP', NULL, NULL, NULL, 3518206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.501478', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3475, 'Guararema', 'SP', NULL, NULL, NULL, 3518305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.502457', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3476, 'Guaratingueta', 'SP', NULL, NULL, NULL, 3518404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.503375', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3477, 'Guarei', 'SP', NULL, NULL, NULL, 3518503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.504252', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3478, 'Guariba', 'SP', NULL, NULL, NULL, 3518602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.50542', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3479, 'Guaruja', 'SP', NULL, NULL, NULL, 3518701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.506355', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3480, 'Guarulhos', 'SP', NULL, NULL, NULL, 3518800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.50736', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3481, 'Guatapara', 'SP', NULL, NULL, NULL, 3518859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.514491', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3482, 'Guzolandia', 'SP', NULL, NULL, NULL, 3518909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.51563', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3483, 'Herculandia', 'SP', NULL, NULL, NULL, 3519006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.516787', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3484, 'Holambra', 'SP', NULL, NULL, NULL, 3519055, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.517506', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3485, 'Hortolandia', 'SP', NULL, NULL, NULL, 3519071, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.518326', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3486, 'Iacanga', 'SP', NULL, NULL, NULL, 3519105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.519603', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3487, 'Iacri', 'SP', NULL, NULL, NULL, 3519204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.520661', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3488, 'Iaras', 'SP', NULL, NULL, NULL, 3519253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.521549', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3489, 'Ibate', 'SP', NULL, NULL, NULL, 3519303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.522424', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3490, 'Ibira', 'SP', NULL, NULL, NULL, 3519402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.52329', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3491, 'Ibirarema', 'SP', NULL, NULL, NULL, 3519501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.524224', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3492, 'Ibitinga', 'SP', NULL, NULL, NULL, 3519600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.525141', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3493, 'Ibiuna', 'SP', NULL, NULL, NULL, 3519709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.526048', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3494, 'Icem', 'SP', NULL, NULL, NULL, 3519808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.526892', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3495, 'Iepe', 'SP', NULL, NULL, NULL, 3519907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.527707', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3496, 'Igaracu do Tiete', 'SP', NULL, NULL, NULL, 3520004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.528553', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3497, 'Igarapava', 'SP', NULL, NULL, NULL, 3520103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.5295', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3498, 'Igarata', 'SP', NULL, NULL, NULL, 3520202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.530465', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3499, 'Iguape', 'SP', NULL, NULL, NULL, 3520301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.531632', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3502, 'Ilhabela', 'SP', NULL, NULL, NULL, 3520400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.534591', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3500, 'Ilha Comprida', 'SP', NULL, NULL, NULL, 3520426, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.532647', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3501, 'Ilha Solteira', 'SP', NULL, NULL, NULL, 3520442, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.533656', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3503, 'Indaiatuba', 'SP', NULL, NULL, NULL, 3520509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.53556', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3504, 'Indiana', 'SP', NULL, NULL, NULL, 3520608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.536463', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3505, 'Indiapora', 'SP', NULL, NULL, NULL, 3520707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.537406', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3506, 'Inubia Paulista', 'SP', NULL, NULL, NULL, 3520806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.538346', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3507, 'Ipaussu', 'SP', NULL, NULL, NULL, 3520905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.539122', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3508, 'Ipero', 'SP', NULL, NULL, NULL, 3521002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.540114', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3509, 'Ipeuna', 'SP', NULL, NULL, NULL, 3521101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.54106', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3510, 'Ipigua', 'SP', NULL, NULL, NULL, 3521150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.542009', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3511, 'Iporanga', 'SP', NULL, NULL, NULL, 3521200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.542934', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3512, 'Ipua', 'SP', NULL, NULL, NULL, 3521309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.543761', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3513, 'Iracemapolis', 'SP', NULL, NULL, NULL, 3521408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.544853', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3514, 'Irapua', 'SP', NULL, NULL, NULL, 3521507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.545807', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3515, 'Irapuru', 'SP', NULL, NULL, NULL, 3521606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.546727', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3516, 'Itabera', 'SP', NULL, NULL, NULL, 3521705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.54776', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3517, 'Itai', 'SP', NULL, NULL, NULL, 3521804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.555415', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3518, 'Itajobi', 'SP', NULL, NULL, NULL, 3521903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.556639', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3519, 'Itaju', 'SP', NULL, NULL, NULL, 3522000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.557538', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3520, 'Itanhaem', 'SP', NULL, NULL, NULL, 3522109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.558368', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3521, 'Itaoca', 'SP', NULL, NULL, NULL, 3522158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.559349', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3522, 'Itapecerica da Serra', 'SP', NULL, NULL, NULL, 3522208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.560304', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3523, 'Itapetininga', 'SP', NULL, NULL, NULL, 3522307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.561226', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3524, 'Itapeva', 'SP', NULL, NULL, NULL, 3522406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.562042', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3525, 'Itapevi', 'SP', NULL, NULL, NULL, 3522505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.563', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3526, 'Itapira', 'SP', NULL, NULL, NULL, 3522604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.564035', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3527, 'Itapirapua Paulista', 'SP', NULL, NULL, NULL, 3522653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.564976', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3528, 'Itapolis', 'SP', NULL, NULL, NULL, 3522703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.565875', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3529, 'Itaporanga', 'SP', NULL, NULL, NULL, 3522802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.566665', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3530, 'Itapui', 'SP', NULL, NULL, NULL, 3522901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.567469', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3531, 'Itapura', 'SP', NULL, NULL, NULL, 3523008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.568248', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3532, 'Itaquaquecetuba', 'SP', NULL, NULL, NULL, 3523107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.569268', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3533, 'Itarare', 'SP', NULL, NULL, NULL, 3523206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.570327', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3534, 'Itariri', 'SP', NULL, NULL, NULL, 3523305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.571116', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3535, 'Itatiba', 'SP', NULL, NULL, NULL, 3523404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.572068', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3536, 'Itatinga', 'SP', NULL, NULL, NULL, 3523503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.572867', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3537, 'Itirapina', 'SP', NULL, NULL, NULL, 3523602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.57366', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3538, 'Itirapua', 'SP', NULL, NULL, NULL, 3523701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.574547', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3539, 'Itobi', 'SP', NULL, NULL, NULL, 3523800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.57546', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3540, 'Itu', 'SP', NULL, NULL, NULL, 3523909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.576321', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3541, 'Itupeva', 'SP', NULL, NULL, NULL, 3524006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.577536', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3542, 'Ituverava', 'SP', NULL, NULL, NULL, 3524105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.578426', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3543, 'Jaborandi', 'SP', NULL, NULL, NULL, 3524204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.579392', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3544, 'Jaboticabal', 'SP', NULL, NULL, NULL, 3524303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.58031', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3545, 'Jacarei', 'SP', NULL, NULL, NULL, 3524402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.581242', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3546, 'Jaci', 'SP', NULL, NULL, NULL, 3524501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.582181', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3547, 'Jacupiranga', 'SP', NULL, NULL, NULL, 3524600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.583183', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3548, 'Jaguariuna', 'SP', NULL, NULL, NULL, 3524709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.583988', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3549, 'Jales', 'SP', NULL, NULL, NULL, 3524808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.584901', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3550, 'Jambeiro', 'SP', NULL, NULL, NULL, 3524907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.585854', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3551, 'Jandira', 'SP', NULL, NULL, NULL, 3525003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.586757', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3552, 'Jardinopolis', 'SP', NULL, NULL, NULL, 3525102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.587586', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3553, 'Jarinu', 'SP', NULL, NULL, NULL, 3525201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.588515', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3554, 'Jau', 'SP', NULL, NULL, NULL, 3525300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.589433', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3555, 'Jeriquara', 'SP', NULL, NULL, NULL, 3525409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.590483', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3556, 'Joanopolis', 'SP', NULL, NULL, NULL, 3525508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.596351', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3557, 'Joao Ramalho', 'SP', NULL, NULL, NULL, 3525607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.597603', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3558, 'Jose Bonifacio', 'SP', NULL, NULL, NULL, 3525706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.59875', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3559, 'Julio Mesquita', 'SP', NULL, NULL, NULL, 3525805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.599726', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3560, 'Jumirim', 'SP', NULL, NULL, NULL, 3525854, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.600794', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3561, 'Jundiai', 'SP', NULL, NULL, NULL, 3525904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.601706', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3562, 'Junqueiropolis', 'SP', NULL, NULL, NULL, 3526001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.602591', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3563, 'Juquia', 'SP', NULL, NULL, NULL, 3526100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.603635', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3564, 'Juquitiba', 'SP', NULL, NULL, NULL, 3526209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.604582', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3565, 'Lagoinha', 'SP', NULL, NULL, NULL, 3526308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.605474', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3566, 'Laranjal Paulista', 'SP', NULL, NULL, NULL, 3526407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.607194', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3567, 'Lavinia', 'SP', NULL, NULL, NULL, 3526506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.608188', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3568, 'Lavrinhas', 'SP', NULL, NULL, NULL, 3526605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.60912', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3569, 'Leme', 'SP', NULL, NULL, NULL, 3526704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.609957', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3570, 'Lencois Paulista', 'SP', NULL, NULL, NULL, 3526803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.611063', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3571, 'Limeira', 'SP', NULL, NULL, NULL, 3526902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.612034', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3572, 'Lindoia', 'SP', NULL, NULL, NULL, 3527009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.613045', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3573, 'Lins', 'SP', NULL, NULL, NULL, 3527108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.613865', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3574, 'Lorena', 'SP', NULL, NULL, NULL, 3527207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.61467', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3575, 'Lourdes', 'SP', NULL, NULL, NULL, 3527256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.615605', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3576, 'Louveira', 'SP', NULL, NULL, NULL, 3527306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.616624', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3577, 'Lucelia', 'SP', NULL, NULL, NULL, 3527405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.617438', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3578, 'Lucianopolis', 'SP', NULL, NULL, NULL, 3527504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.618341', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3579, 'Luis Antonio', 'SP', NULL, NULL, NULL, 3527603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.619193', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3580, 'Luiziania', 'SP', NULL, NULL, NULL, 3527702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.620134', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3581, 'Lupercio', 'SP', NULL, NULL, NULL, 3527801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.621094', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3582, 'Lutecia', 'SP', NULL, NULL, NULL, 3527900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.62201', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3583, 'Macatuba', 'SP', NULL, NULL, NULL, 3528007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.622926', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3584, 'Macaubal', 'SP', NULL, NULL, NULL, 3528106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.623778', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3585, 'Macedonia', 'SP', NULL, NULL, NULL, 3528205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.624723', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3586, 'Magda', 'SP', NULL, NULL, NULL, 3528304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.625616', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3587, 'Mairinque', 'SP', NULL, NULL, NULL, 3528403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.62654', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3588, 'Mairipora', 'SP', NULL, NULL, NULL, 3528502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.627638', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3589, 'Manduri', 'SP', NULL, NULL, NULL, 3528601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.628439', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3590, 'Maraba Paulista', 'SP', NULL, NULL, NULL, 3528700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.629383', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3591, 'Maracai', 'SP', NULL, NULL, NULL, 3528809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.636541', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3592, 'Marapoama', 'SP', NULL, NULL, NULL, 3528858, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.63785', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3593, 'Mariapolis', 'SP', NULL, NULL, NULL, 3528908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.638856', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3594, 'Marilia', 'SP', NULL, NULL, NULL, 3529005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.639554', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3595, 'Marinopolis', 'SP', NULL, NULL, NULL, 3529104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.640522', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3596, 'Martinopolis', 'SP', NULL, NULL, NULL, 3529203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.641428', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3597, 'Matao', 'SP', NULL, NULL, NULL, 3529302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.642269', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3598, 'Maua', 'SP', NULL, NULL, NULL, 3529401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.643236', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3599, 'Mendonca', 'SP', NULL, NULL, NULL, 3529500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.644256', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3600, 'Meridiano', 'SP', NULL, NULL, NULL, 3529609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.645169', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3601, 'Mesopolis', 'SP', NULL, NULL, NULL, 3529658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.64605', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3602, 'Miguelopolis', 'SP', NULL, NULL, NULL, 3529708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.646934', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3603, 'Mineiros do Tiete', 'SP', NULL, NULL, NULL, 3529807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.647811', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3605, 'Miracatu', 'SP', NULL, NULL, NULL, 3529906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.649539', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3604, 'Mira Estrela', 'SP', NULL, NULL, NULL, 3530003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.648659', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3606, 'Mirandopolis', 'SP', NULL, NULL, NULL, 3530102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.650507', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3607, 'Mirante do Paranapanema', 'SP', NULL, NULL, NULL, 3530201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.651428', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3608, 'Mirassol', 'SP', NULL, NULL, NULL, 3530300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.652283', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3609, 'Mirassolandia', 'SP', NULL, NULL, NULL, 3530409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.653107', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3610, 'Mococa', 'SP', NULL, NULL, NULL, 3530508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.65403', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3611, 'Mogi das Cruzes', 'SP', NULL, NULL, NULL, 3530607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.654934', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3612, 'Mogi Guacu', 'SP', NULL, NULL, NULL, 3530706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.655912', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3614, 'Mombuca', 'SP', NULL, NULL, NULL, 3530904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.65768', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3615, 'Moncoes', 'SP', NULL, NULL, NULL, 3531001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.658653', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3616, 'Mongagua', 'SP', NULL, NULL, NULL, 3531100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.6595', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3617, 'Monte Alegre do Sul', 'SP', NULL, NULL, NULL, 3531209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.66052', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3618, 'Monte Alto', 'SP', NULL, NULL, NULL, 3531308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.661636', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3619, 'Monte Aprazivel', 'SP', NULL, NULL, NULL, 3531407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.662504', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3620, 'Monte Azul Paulista', 'SP', NULL, NULL, NULL, 3531506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.663455', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3621, 'Monte Castelo', 'SP', NULL, NULL, NULL, 3531605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.664378', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3623, 'Monteiro Lobato', 'SP', NULL, NULL, NULL, 3531704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.66621', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3622, 'Monte Mor', 'SP', NULL, NULL, NULL, 3531803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.665291', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3624, 'Morro Agudo', 'SP', NULL, NULL, NULL, 3531902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.667129', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3625, 'Morungaba', 'SP', NULL, NULL, NULL, 3532009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.6681', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3626, 'Motuca', 'SP', NULL, NULL, NULL, 3532058, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.669012', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3627, 'Murutinga do Sul', 'SP', NULL, NULL, NULL, 3532108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.669991', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3628, 'Nantes', 'SP', NULL, NULL, NULL, 3532157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.677087', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3629, 'Narandiba', 'SP', NULL, NULL, NULL, 3532207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.678371', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3630, 'Natividade da Serra', 'SP', NULL, NULL, NULL, 3532306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.6794', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3631, 'Nazare Paulista', 'SP', NULL, NULL, NULL, 3532405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.680367', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3632, 'Neves Paulista', 'SP', NULL, NULL, NULL, 3532504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.681221', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3633, 'Nhandeara', 'SP', NULL, NULL, NULL, 3532603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.682247', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3634, 'Nipoa', 'SP', NULL, NULL, NULL, 3532702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.683209', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3635, 'Nova Alianca', 'SP', NULL, NULL, NULL, 3532801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.684071', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3636, 'Nova Campina', 'SP', NULL, NULL, NULL, 3532827, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.685019', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3637, 'Nova Canaa Paulista', 'SP', NULL, NULL, NULL, 3532843, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.685923', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3638, 'Nova Castilho', 'SP', NULL, NULL, NULL, 3532868, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.68688', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3639, 'Nova Europa', 'SP', NULL, NULL, NULL, 3532900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.687744', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3640, 'Nova Granada', 'SP', NULL, NULL, NULL, 3533007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.688615', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3641, 'Nova Guataporanga', 'SP', NULL, NULL, NULL, 3533106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.689453', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3642, 'Nova Independencia', 'SP', NULL, NULL, NULL, 3533205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.69033', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3645, 'Novais', 'SP', NULL, NULL, NULL, 3533254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.693025', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3643, 'Nova Luzitania', 'SP', NULL, NULL, NULL, 3533304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.69125', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3644, 'Nova Odessa', 'SP', NULL, NULL, NULL, 3533403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.692148', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3646, 'Novo Horizonte', 'SP', NULL, NULL, NULL, 3533502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.693881', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3647, 'Nuporanga', 'SP', NULL, NULL, NULL, 3533601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.694756', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3648, 'Ocaucu', 'SP', NULL, NULL, NULL, 3533700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.695695', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3649, 'Oleo', 'SP', NULL, NULL, NULL, 3533809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.696598', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3650, 'Olimpia', 'SP', NULL, NULL, NULL, 3533908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.697503', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3651, 'Onda Verde', 'SP', NULL, NULL, NULL, 3534005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.698381', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3652, 'Oriente', 'SP', NULL, NULL, NULL, 3534104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.699328', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3653, 'Orindiuva', 'SP', NULL, NULL, NULL, 3534203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.700226', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3654, 'Orlandia', 'SP', NULL, NULL, NULL, 3534302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.70113', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3655, 'Osasco', 'SP', NULL, NULL, NULL, 3534401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.702113', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3656, 'Oscar Bressane', 'SP', NULL, NULL, NULL, 3534500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.703017', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3657, 'Osvaldo Cruz', 'SP', NULL, NULL, NULL, 3534609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.703902', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3658, 'Ourinhos', 'SP', NULL, NULL, NULL, 3534708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.704848', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3660, 'Ouroeste', 'SP', NULL, NULL, NULL, 3534757, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.706649', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3659, 'Ouro Verde', 'SP', NULL, NULL, NULL, 3534807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.705842', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3661, 'Pacaembu', 'SP', NULL, NULL, NULL, 3534906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.707503', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3662, 'Palestina', 'SP', NULL, NULL, NULL, 3535002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.708316', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3663, 'Palmares Paulista', 'SP', NULL, NULL, NULL, 3535101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.7091', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3664, 'Palmeira D''oeste', 'SP', NULL, NULL, NULL, 3535200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.709909', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3665, 'Palmital', 'SP', NULL, NULL, NULL, 3535309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.710909', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3666, 'Panorama', 'SP', NULL, NULL, NULL, 3535408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.71165', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3667, 'Paraguacu Paulista', 'SP', NULL, NULL, NULL, 3535507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.7191', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3668, 'Paraibuna', 'SP', NULL, NULL, NULL, 3535606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.720228', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3669, 'Paraiso', 'SP', NULL, NULL, NULL, 3535705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.721111', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3670, 'Paranapanema', 'SP', NULL, NULL, NULL, 3535804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.722043', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3671, 'Paranapua', 'SP', NULL, NULL, NULL, 3535903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.72293', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3672, 'Parapua', 'SP', NULL, NULL, NULL, 3536000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.723768', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3673, 'Pardinho', 'SP', NULL, NULL, NULL, 3536109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.72461', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3674, 'Pariquera-acu', 'SP', NULL, NULL, NULL, 3536208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.725544', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3675, 'Parisi', 'SP', NULL, NULL, NULL, 3536257, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.726416', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3676, 'Patrocinio Paulista', 'SP', NULL, NULL, NULL, 3536307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.727324', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3677, 'Pauliceia', 'SP', NULL, NULL, NULL, 3536406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.728179', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3678, 'Paulinia', 'SP', NULL, NULL, NULL, 3536505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.729059', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3679, 'Paulistania', 'SP', NULL, NULL, NULL, 3536570, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.730037', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3680, 'Paulo de Faria', 'SP', NULL, NULL, NULL, 3536604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.730894', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3681, 'Pederneiras', 'SP', NULL, NULL, NULL, 3536703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.731757', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3682, 'Pedra Bela', 'SP', NULL, NULL, NULL, 3536802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.732587', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3683, 'Pedranopolis', 'SP', NULL, NULL, NULL, 3536901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.733429', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3684, 'Pedregulho', 'SP', NULL, NULL, NULL, 3537008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.73431', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3685, 'Pedreira', 'SP', NULL, NULL, NULL, 3537107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.735221', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3686, 'Pedrinhas Paulista', 'SP', NULL, NULL, NULL, 3537156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.736151', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3687, 'Pedro de Toledo', 'SP', NULL, NULL, NULL, 3537206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.737085', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3688, 'Penapolis', 'SP', NULL, NULL, NULL, 3537305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.738028', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3689, 'Pereira Barreto', 'SP', NULL, NULL, NULL, 3537404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.738983', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3690, 'Pereiras', 'SP', NULL, NULL, NULL, 3537503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.73982', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3691, 'Peruibe', 'SP', NULL, NULL, NULL, 3537602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.740635', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3692, 'Piacatu', 'SP', NULL, NULL, NULL, 3537701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.741532', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3693, 'Piedade', 'SP', NULL, NULL, NULL, 3537800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.742468', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3694, 'Pilar do Sul', 'SP', NULL, NULL, NULL, 3537909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.743483', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3695, 'Pindamonhangaba', 'SP', NULL, NULL, NULL, 3538006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.744333', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3696, 'Pindorama', 'SP', NULL, NULL, NULL, 3538105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.745185', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3697, 'Pinhalzinho', 'SP', NULL, NULL, NULL, 3538204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.746103', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3698, 'Piquerobi', 'SP', NULL, NULL, NULL, 3538303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.747239', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3699, 'Piquete', 'SP', NULL, NULL, NULL, 3538501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.748177', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3700, 'Piracaia', 'SP', NULL, NULL, NULL, 3538600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.749108', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3701, 'Piracicaba', 'SP', NULL, NULL, NULL, 3538709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.750017', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3702, 'Piraju', 'SP', NULL, NULL, NULL, 3538808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.751064', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3703, 'Pirajui', 'SP', NULL, NULL, NULL, 3538907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.752015', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3704, 'Pirangi', 'SP', NULL, NULL, NULL, 3539004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.759139', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3705, 'Pirapora do Bom Jesus', 'SP', NULL, NULL, NULL, 3539103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.760398', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3706, 'Pirapozinho', 'SP', NULL, NULL, NULL, 3539202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.761455', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3707, 'Pirassununga', 'SP', NULL, NULL, NULL, 3539301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.762332', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3708, 'Piratininga', 'SP', NULL, NULL, NULL, 3539400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.76325', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3709, 'Pitangueiras', 'SP', NULL, NULL, NULL, 3539509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.764242', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3710, 'Planalto', 'SP', NULL, NULL, NULL, 3539608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.76523', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3711, 'Platina', 'SP', NULL, NULL, NULL, 3539707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.766168', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3712, 'Poa', 'SP', NULL, NULL, NULL, 3539806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.767481', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3713, 'Poloni', 'SP', NULL, NULL, NULL, 3539905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.768419', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3714, 'Pompeia', 'SP', NULL, NULL, NULL, 3540002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.769298', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3715, 'Pongai', 'SP', NULL, NULL, NULL, 3540101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.770243', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3716, 'Pontal', 'SP', NULL, NULL, NULL, 3540200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.771057', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3717, 'Pontalinda', 'SP', NULL, NULL, NULL, 3540259, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.772236', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3718, 'Pontes Gestal', 'SP', NULL, NULL, NULL, 3540309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.77305', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3719, 'Populina', 'SP', NULL, NULL, NULL, 3540408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.773915', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3720, 'Porangaba', 'SP', NULL, NULL, NULL, 3540507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.774851', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3721, 'Porto Feliz', 'SP', NULL, NULL, NULL, 3540606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.77596', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3722, 'Porto Ferreira', 'SP', NULL, NULL, NULL, 3540705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.77695', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3723, 'Potim', 'SP', NULL, NULL, NULL, 3540754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.777852', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3724, 'Potirendaba', 'SP', NULL, NULL, NULL, 3540804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.778757', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3725, 'Pracinha', 'SP', NULL, NULL, NULL, 3540853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.779736', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3726, 'Pradopolis', 'SP', NULL, NULL, NULL, 3540903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.780653', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3727, 'Praia Grande', 'SP', NULL, NULL, NULL, 3541000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.781557', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3728, 'Pratania', 'SP', NULL, NULL, NULL, 3541059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.782464', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3729, 'Presidente Alves', 'SP', NULL, NULL, NULL, 3541109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.783493', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3730, 'Presidente Bernardes', 'SP', NULL, NULL, NULL, 3541208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.784379', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3731, 'Presidente Epitacio', 'SP', NULL, NULL, NULL, 3541307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.785224', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3732, 'Presidente Prudente', 'SP', NULL, NULL, NULL, 3541406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.786107', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3733, 'Presidente Venceslau', 'SP', NULL, NULL, NULL, 3541505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.786904', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3734, 'Promissao', 'SP', NULL, NULL, NULL, 3541604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.787815', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3735, 'Quadra', 'SP', NULL, NULL, NULL, 3541653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.788698', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3736, 'Quata', 'SP', NULL, NULL, NULL, 3541703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.789628', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3737, 'Queiroz', 'SP', NULL, NULL, NULL, 3541802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.790503', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3738, 'Queluz', 'SP', NULL, NULL, NULL, 3541901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.791388', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3739, 'Quintana', 'SP', NULL, NULL, NULL, 3542008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.792194', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3740, 'Rafard', 'SP', NULL, NULL, NULL, 3542107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.799849', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3741, 'Rancharia', 'SP', NULL, NULL, NULL, 3542206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.801147', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3742, 'Redencao da Serra', 'SP', NULL, NULL, NULL, 3542305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.802051', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3743, 'Regente Feijo', 'SP', NULL, NULL, NULL, 3542404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.802929', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3744, 'Reginopolis', 'SP', NULL, NULL, NULL, 3542503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.80391', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3745, 'Registro', 'SP', NULL, NULL, NULL, 3542602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.804743', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3746, 'Restinga', 'SP', NULL, NULL, NULL, 3542701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.80577', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3747, 'Ribeira', 'SP', NULL, NULL, NULL, 3542800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.806596', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3748, 'Ribeirao Bonito', 'SP', NULL, NULL, NULL, 3542909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.807499', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3749, 'Ribeirao Branco', 'SP', NULL, NULL, NULL, 3543006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.808385', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3750, 'Ribeirao Corrente', 'SP', NULL, NULL, NULL, 3543105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.809327', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3751, 'Ribeirao do Sul', 'SP', NULL, NULL, NULL, 3543204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.810148', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3752, 'Ribeirao dos Indios', 'SP', NULL, NULL, NULL, 3543238, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.811033', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3753, 'Ribeirao Grande', 'SP', NULL, NULL, NULL, 3543253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.811878', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3754, 'Ribeirao Pires', 'SP', NULL, NULL, NULL, 3543303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.812751', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3755, 'Ribeirao Preto', 'SP', NULL, NULL, NULL, 3543402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.813744', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3763, 'Riversul', 'SP', NULL, NULL, NULL, 3543501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.821112', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3756, 'Rifaina', 'SP', NULL, NULL, NULL, 3543600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.814689', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3757, 'Rincao', 'SP', NULL, NULL, NULL, 3543709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.815604', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3758, 'Rinopolis', 'SP', NULL, NULL, NULL, 3543808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.81658', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3759, 'Rio Claro', 'SP', NULL, NULL, NULL, 3543907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.817501', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3760, 'Rio das Pedras', 'SP', NULL, NULL, NULL, 3544004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.8183', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3761, 'Rio Grande da Serra', 'SP', NULL, NULL, NULL, 3544103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.819205', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3762, 'Riolandia', 'SP', NULL, NULL, NULL, 3544202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.820129', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3764, 'Rosana', 'SP', NULL, NULL, NULL, 3544251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.822033', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3765, 'Roseira', 'SP', NULL, NULL, NULL, 3544301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.822953', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3766, 'Rubiacea', 'SP', NULL, NULL, NULL, 3544400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.823779', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3767, 'Rubineia', 'SP', NULL, NULL, NULL, 3544509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.824722', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3768, 'Sabino', 'SP', NULL, NULL, NULL, 3544608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.825716', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3769, 'Sagres', 'SP', NULL, NULL, NULL, 3544707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.826657', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3770, 'Sales', 'SP', NULL, NULL, NULL, 3544806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.827569', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3771, 'Sales Oliveira', 'SP', NULL, NULL, NULL, 3544905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.8286', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3772, 'Salesopolis', 'SP', NULL, NULL, NULL, 3545001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.829388', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3773, 'Salmourao', 'SP', NULL, NULL, NULL, 3545100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.830267', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3774, 'Saltinho', 'SP', NULL, NULL, NULL, 3545159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.831174', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3775, 'Salto', 'SP', NULL, NULL, NULL, 3545209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.832063', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3776, 'Salto de Pirapora', 'SP', NULL, NULL, NULL, 3545308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.832983', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3777, 'Salto Grande', 'SP', NULL, NULL, NULL, 3545407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.833872', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3778, 'Sandovalina', 'SP', NULL, NULL, NULL, 3545506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.841128', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3779, 'Santa Adelia', 'SP', NULL, NULL, NULL, 3545605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.842526', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3780, 'Santa Albertina', 'SP', NULL, NULL, NULL, 3545704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.843562', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3781, 'Santa Barbara D''oeste', 'SP', NULL, NULL, NULL, 3545803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.844486', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3782, 'Santa Branca', 'SP', NULL, NULL, NULL, 3546009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.845468', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3783, 'Santa Clara D''oeste', 'SP', NULL, NULL, NULL, 3546108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.846438', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3784, 'Santa Cruz da Conceicao', 'SP', NULL, NULL, NULL, 3546207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.847281', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3785, 'Santa Cruz da Esperanca', 'SP', NULL, NULL, NULL, 3546256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.848235', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3786, 'Santa Cruz das Palmeiras', 'SP', NULL, NULL, NULL, 3546306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.849206', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3787, 'Santa Cruz do Rio Pardo', 'SP', NULL, NULL, NULL, 3546405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.850133', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3788, 'Santa Ernestina', 'SP', NULL, NULL, NULL, 3546504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.851253', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3789, 'Santa Fe do Sul', 'SP', NULL, NULL, NULL, 3546603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.852223', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3790, 'Santa Gertrudes', 'SP', NULL, NULL, NULL, 3546702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.853156', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3791, 'Santa Isabel', 'SP', NULL, NULL, NULL, 3546801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.854113', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3792, 'Santa Lucia', 'SP', NULL, NULL, NULL, 3546900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.854982', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3793, 'Santa Maria da Serra', 'SP', NULL, NULL, NULL, 3547007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.85605', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3794, 'Santa Mercedes', 'SP', NULL, NULL, NULL, 3547106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.857003', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3799, 'Santana da Ponte Pensa', 'SP', NULL, NULL, NULL, 3547205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.861535', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3800, 'Santana de Parnaiba', 'SP', NULL, NULL, NULL, 3547304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.862612', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3796, 'Santa Rita D''oeste', 'SP', NULL, NULL, NULL, 3547403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.85865', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3795, 'Santa Rita do Passa Quatro', 'SP', NULL, NULL, NULL, 3547502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.857824', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3797, 'Santa Rosa de Viterbo', 'SP', NULL, NULL, NULL, 3547601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.859396', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3798, 'Santa Salete', 'SP', NULL, NULL, NULL, 3547650, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.860312', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3801, 'Santo Anastacio', 'SP', NULL, NULL, NULL, 3547700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.863652', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3802, 'Santo Andre', 'SP', NULL, NULL, NULL, 3547809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.864564', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3803, 'Santo Antonio da Alegria', 'SP', NULL, NULL, NULL, 3547908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.865523', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3804, 'Santo Antonio de Posse', 'SP', NULL, NULL, NULL, 3548005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.866439', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3805, 'Santo Antonio do Aracangua', 'SP', NULL, NULL, NULL, 3548054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.867468', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3806, 'Santo Antonio do Jardim', 'SP', NULL, NULL, NULL, 3548104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.868427', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3807, 'Santo Antonio do Pinhal', 'SP', NULL, NULL, NULL, 3548203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.869308', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3808, 'Santo Expedito', 'SP', NULL, NULL, NULL, 3548302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.870137', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3809, 'Santopolis do Aguapei', 'SP', NULL, NULL, NULL, 3548401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.871076', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3810, 'Santos', 'SP', NULL, NULL, NULL, 3548500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.872026', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3811, 'Sao Bento do Sapucai', 'SP', NULL, NULL, NULL, 3548609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.873071', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3812, 'Sao Bernardo do Campo', 'SP', NULL, NULL, NULL, 3548708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.873885', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3813, 'Sao Caetano do Sul', 'SP', NULL, NULL, NULL, 3548807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.874902', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3814, 'Sao Carlos', 'SP', NULL, NULL, NULL, 3548906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.882174', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3815, 'Sao Francisco', 'SP', NULL, NULL, NULL, 3549003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.883328', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3816, 'Sao Joao da Boa Vista', 'SP', NULL, NULL, NULL, 3549102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.884221', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3817, 'Sao Joao das Duas Pontes', 'SP', NULL, NULL, NULL, 3549201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.8851', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3818, 'Sao Joao de Iracema', 'SP', NULL, NULL, NULL, 3549250, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.885978', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3819, 'Sao Joao do Pau D''alho', 'SP', NULL, NULL, NULL, 3549300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.886912', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3820, 'Sao Joaquim da Barra', 'SP', NULL, NULL, NULL, 3549409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.88779', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3821, 'Sao Jose da Bela Vista', 'SP', NULL, NULL, NULL, 3549508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.888824', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3822, 'Sao Jose do Barreiro', 'SP', NULL, NULL, NULL, 3549607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.889708', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3823, 'Sao Jose do Rio Pardo', 'SP', NULL, NULL, NULL, 3549706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.890643', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3824, 'Sao Jose do Rio Preto', 'SP', NULL, NULL, NULL, 3549805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.891636', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3825, 'Sao Jose dos Campos', 'SP', NULL, NULL, NULL, 3549904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.892511', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3826, 'Sao Lourenco da Serra', 'SP', NULL, NULL, NULL, 3549953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.893511', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3827, 'Sao Luis do Paraitinga', 'SP', NULL, NULL, NULL, 3550001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.89439', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3828, 'Sao Manuel', 'SP', NULL, NULL, NULL, 3550100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.89529', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3829, 'Sao Miguel Arcanjo', 'SP', NULL, NULL, NULL, 3550209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.89607', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3830, 'Sao Paulo', 'SP', NULL, NULL, NULL, 3550308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.897057', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3831, 'Sao Pedro', 'SP', NULL, NULL, NULL, 3550407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.898029', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3832, 'Sao Pedro do Turvo', 'SP', NULL, NULL, NULL, 3550506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.898933', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3833, 'Sao Roque', 'SP', NULL, NULL, NULL, 3550605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.899785', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3834, 'Sao Sebastiao', 'SP', NULL, NULL, NULL, 3550704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.900715', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3835, 'Sao Sebastiao da Grama', 'SP', NULL, NULL, NULL, 3550803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.901548', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3836, 'Sao Simao', 'SP', NULL, NULL, NULL, 3550902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.902471', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3837, 'Sao Vicente', 'SP', NULL, NULL, NULL, 3551009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.903454', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3838, 'Sarapui', 'SP', NULL, NULL, NULL, 3551108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.904302', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3839, 'Sarutaia', 'SP', NULL, NULL, NULL, 3551207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.905087', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3840, 'Sebastianopolis do Sul', 'SP', NULL, NULL, NULL, 3551306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.906039', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3841, 'Serra Azul', 'SP', NULL, NULL, NULL, 3551405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.907223', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3843, 'Serrana', 'SP', NULL, NULL, NULL, 3551504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.908962', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3842, 'Serra Negra', 'SP', NULL, NULL, NULL, 3551603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.907989', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3844, 'Sertaozinho', 'SP', NULL, NULL, NULL, 3551702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.909863', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3845, 'Sete Barras', 'SP', NULL, NULL, NULL, 3551801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.910813', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3846, 'Severinia', 'SP', NULL, NULL, NULL, 3551900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.911767', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3847, 'Silveiras', 'SP', NULL, NULL, NULL, 3552007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.912684', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3848, 'Socorro', 'SP', NULL, NULL, NULL, 3552106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.913618', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3849, 'Sorocaba', 'SP', NULL, NULL, NULL, 3552205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.914527', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3850, 'Sud Mennucci', 'SP', NULL, NULL, NULL, 3552304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.915419', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3851, 'Sumare', 'SP', NULL, NULL, NULL, 3552403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.923764', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3853, 'Suzano', 'SP', NULL, NULL, NULL, 3552502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.925611', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3852, 'Suzanapolis', 'SP', NULL, NULL, NULL, 3552551, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.924737', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3854, 'Tabapua', 'SP', NULL, NULL, NULL, 3552601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.926641', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3855, 'Tabatinga', 'SP', NULL, NULL, NULL, 3552700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.92753', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3856, 'Taboao da Serra', 'SP', NULL, NULL, NULL, 3552809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.928379', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3857, 'Taciba', 'SP', NULL, NULL, NULL, 3552908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.929364', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3858, 'Taguai', 'SP', NULL, NULL, NULL, 3553005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.930327', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3859, 'Taiacu', 'SP', NULL, NULL, NULL, 3553104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.931198', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3860, 'Taiuva', 'SP', NULL, NULL, NULL, 3553203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.932199', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3861, 'Tambau', 'SP', NULL, NULL, NULL, 3553302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.933029', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3862, 'Tanabi', 'SP', NULL, NULL, NULL, 3553401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.933885', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3863, 'Tapirai', 'SP', NULL, NULL, NULL, 3553500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.934819', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3864, 'Tapiratiba', 'SP', NULL, NULL, NULL, 3553609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.935627', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3865, 'Taquaral', 'SP', NULL, NULL, NULL, 3553658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.936569', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3866, 'Taquaritinga', 'SP', NULL, NULL, NULL, 3553708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.937462', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3867, 'Taquarituba', 'SP', NULL, NULL, NULL, 3553807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.938413', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3868, 'Taquarivai', 'SP', NULL, NULL, NULL, 3553856, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.939268', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3869, 'Tarabai', 'SP', NULL, NULL, NULL, 3553906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.940097', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3870, 'Taruma', 'SP', NULL, NULL, NULL, 3553955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.941071', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3871, 'Tatui', 'SP', NULL, NULL, NULL, 3554003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.942017', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3872, 'Taubate', 'SP', NULL, NULL, NULL, 3554102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.942943', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3873, 'Tejupa', 'SP', NULL, NULL, NULL, 3554201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.94383', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3874, 'Teodoro Sampaio', 'SP', NULL, NULL, NULL, 3554300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.944695', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3875, 'Terra Roxa', 'SP', NULL, NULL, NULL, 3554409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.945558', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3876, 'Tiete', 'SP', NULL, NULL, NULL, 3554508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.946495', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3877, 'Timburi', 'SP', NULL, NULL, NULL, 3554607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.94729', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3878, 'Torre de Pedra', 'SP', NULL, NULL, NULL, 3554656, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.948168', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3879, 'Torrinha', 'SP', NULL, NULL, NULL, 3554706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.949077', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3880, 'Trabiju', 'SP', NULL, NULL, NULL, 3554755, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.949993', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3881, 'Tremembe', 'SP', NULL, NULL, NULL, 3554805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.950947', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3882, 'Tres Fronteiras', 'SP', NULL, NULL, NULL, 3554904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.951742', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3883, 'Tuiuti', 'SP', NULL, NULL, NULL, 3554953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.952496', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3884, 'Tupa', 'SP', NULL, NULL, NULL, 3555000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.953395', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3885, 'Tupi Paulista', 'SP', NULL, NULL, NULL, 3555109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.954217', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3886, 'Turiuba', 'SP', NULL, NULL, NULL, 3555208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.955145', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3887, 'Turmalina', 'SP', NULL, NULL, NULL, 3555307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.956025', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3888, 'Ubarana', 'SP', NULL, NULL, NULL, 3555356, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.957522', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3889, 'Ubatuba', 'SP', NULL, NULL, NULL, 3555406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.964282', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3890, 'Ubirajara', 'SP', NULL, NULL, NULL, 3555505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.965379', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3891, 'Uchoa', 'SP', NULL, NULL, NULL, 3555604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.966314', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3892, 'Uniao Paulista', 'SP', NULL, NULL, NULL, 3555703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.967227', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3893, 'Urania', 'SP', NULL, NULL, NULL, 3555802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.968222', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3894, 'Uru', 'SP', NULL, NULL, NULL, 3555901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.969163', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3895, 'Urupes', 'SP', NULL, NULL, NULL, 3556008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.970073', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3896, 'Valentim Gentil', 'SP', NULL, NULL, NULL, 3556107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.970972', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3897, 'Valinhos', 'SP', NULL, NULL, NULL, 3556206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.971951', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3898, 'Valparaiso', 'SP', NULL, NULL, NULL, 3556305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.972883', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3899, 'Vargem', 'SP', NULL, NULL, NULL, 3556354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.974064', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3900, 'Vargem Grande do Sul', 'SP', NULL, NULL, NULL, 3556404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.974954', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3901, 'Vargem Grande Paulista', 'SP', NULL, NULL, NULL, 3556453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.976387', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3902, 'Varzea Paulista', 'SP', NULL, NULL, NULL, 3556503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.97738', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3903, 'Vera Cruz', 'SP', NULL, NULL, NULL, 3556602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.97827', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3904, 'Vinhedo', 'SP', NULL, NULL, NULL, 3556701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.979112', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3905, 'Viradouro', 'SP', NULL, NULL, NULL, 3556800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.980046', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3906, 'Vista Alegre do Alto', 'SP', NULL, NULL, NULL, 3556909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.980934', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3907, 'Vitoria Brasil', 'SP', NULL, NULL, NULL, 3556958, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.981804', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3908, 'Votorantim', 'SP', NULL, NULL, NULL, 3557006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.982726', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3909, 'Votuporanga', 'SP', NULL, NULL, NULL, 3557105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.983575', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3910, 'Zacarias', 'SP', NULL, NULL, NULL, 3557154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.984592', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3399, 'Chavantes', 'SP', NULL, NULL, NULL, 3557204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.411516', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3440, 'Estiva Gerbi', 'SP', NULL, NULL, NULL, 3557303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.459826', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3911, 'Abatia', 'PR', NULL, NULL, NULL, 4100103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.985397', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3912, 'Adrianopolis', 'PR', NULL, NULL, NULL, 4100202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.986287', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3913, 'Agudos do Sul', 'PR', NULL, NULL, NULL, 4100301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.987196', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3914, 'Almirante Tamandare', 'PR', NULL, NULL, NULL, 4100400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.988188', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3915, 'Altamira do Parana', 'PR', NULL, NULL, NULL, 4100459, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.989098', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3919, 'Altonia', 'PR', NULL, NULL, NULL, 4100509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.992748', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3917, 'Alto Parana', 'PR', NULL, NULL, NULL, 4100608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.990938', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3918, 'Alto Piquiri', 'PR', NULL, NULL, NULL, 4100707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.991839', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3920, 'Alvorada do Sul', 'PR', NULL, NULL, NULL, 4100806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.99372', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3921, 'Amapora', 'PR', NULL, NULL, NULL, 4100905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.99467', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3922, 'Ampere', 'PR', NULL, NULL, NULL, 4101002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.995648', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3923, 'Anahy', 'PR', NULL, NULL, NULL, 4101051, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.996625', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3924, 'Andira', 'PR', NULL, NULL, NULL, 4101101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.997681', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3925, 'Angulo', 'PR', NULL, NULL, NULL, 4101150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.004728', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3926, 'Antonina', 'PR', NULL, NULL, NULL, 4101200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.005854', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3927, 'Antonio Olinto', 'PR', NULL, NULL, NULL, 4101309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.007012', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3928, 'Apucarana', 'PR', NULL, NULL, NULL, 4101408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.007903', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3929, 'Arapongas', 'PR', NULL, NULL, NULL, 4101507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.008811', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3930, 'Arapoti', 'PR', NULL, NULL, NULL, 4101606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.009634', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3931, 'Arapua', 'PR', NULL, NULL, NULL, 4101655, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.010641', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3932, 'Araruna', 'PR', NULL, NULL, NULL, 4101705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.011512', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3933, 'Araucaria', 'PR', NULL, NULL, NULL, 4101804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.012356', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3934, 'Ariranha do Ivai', 'PR', NULL, NULL, NULL, 4101853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.013245', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3935, 'Assai', 'PR', NULL, NULL, NULL, 4101903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.014083', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3936, 'Assis Chateaubriand', 'PR', NULL, NULL, NULL, 4102000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.014967', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3937, 'Astorga', 'PR', NULL, NULL, NULL, 4102109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.015824', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3938, 'Atalaia', 'PR', NULL, NULL, NULL, 4102208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.016716', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3939, 'Balsa Nova', 'PR', NULL, NULL, NULL, 4102307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.017615', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3940, 'Bandeirantes', 'PR', NULL, NULL, NULL, 4102406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.018653', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3941, 'Barbosa Ferraz', 'PR', NULL, NULL, NULL, 4102505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.019459', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3943, 'Barracao', 'PR', NULL, NULL, NULL, 4102604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.021205', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3942, 'Barra do Jacare', 'PR', NULL, NULL, NULL, 4102703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.020318', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3945, 'Bela Vista do Paraiso', 'PR', NULL, NULL, NULL, 4102802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.023032', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3946, 'Bituruna', 'PR', NULL, NULL, NULL, 4102901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.023906', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3947, 'Boa Esperanca', 'PR', NULL, NULL, NULL, 4103008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.02483', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3948, 'Boa Esperanca do Iguacu', 'PR', NULL, NULL, NULL, 4103024, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.025742', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3949, 'Boa Ventura de Sao Roque', 'PR', NULL, NULL, NULL, 4103040, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.026662', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3950, 'Boa Vista da Aparecida', 'PR', NULL, NULL, NULL, 4103057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.027576', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3951, 'Bocaiuva do Sul', 'PR', NULL, NULL, NULL, 4103107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.028487', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3952, 'Bom Jesus do Sul', 'PR', NULL, NULL, NULL, 4103156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.02933', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3953, 'Bom Sucesso', 'PR', NULL, NULL, NULL, 4103206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.030115', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3954, 'Bom Sucesso do Sul', 'PR', NULL, NULL, NULL, 4103222, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.031027', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3955, 'Borrazopolis', 'PR', NULL, NULL, NULL, 4103305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.031843', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3956, 'Braganey', 'PR', NULL, NULL, NULL, 4103354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.032806', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3957, 'Brasilandia do Sul', 'PR', NULL, NULL, NULL, 4103370, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.033978', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3958, 'Cafeara', 'PR', NULL, NULL, NULL, 4103404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.034819', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3959, 'Cafelandia', 'PR', NULL, NULL, NULL, 4103453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.03574', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3960, 'Cafezal do Sul', 'PR', NULL, NULL, NULL, 4103479, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.036649', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3961, 'California', 'PR', NULL, NULL, NULL, 4103503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.037542', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3962, 'Cambara', 'PR', NULL, NULL, NULL, 4103602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.038936', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3963, 'Cambe', 'PR', NULL, NULL, NULL, 4103701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.045765', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3964, 'Cambira', 'PR', NULL, NULL, NULL, 4103800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.047133', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3965, 'Campina da Lagoa', 'PR', NULL, NULL, NULL, 4103909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.04815', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3966, 'Campina do Simao', 'PR', NULL, NULL, NULL, 4103958, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.049097', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3967, 'Campina Grande do Sul', 'PR', NULL, NULL, NULL, 4104006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.050115', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3968, 'Campo Bonito', 'PR', NULL, NULL, NULL, 4104055, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.051104', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3969, 'Campo do Tenente', 'PR', NULL, NULL, NULL, 4104105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.05197', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3970, 'Campo Largo', 'PR', NULL, NULL, NULL, 4104204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.053224', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3971, 'Campo Magro', 'PR', NULL, NULL, NULL, 4104253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.054079', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3972, 'Campo Mourao', 'PR', NULL, NULL, NULL, 4104303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.054986', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3973, 'Candido de Abreu', 'PR', NULL, NULL, NULL, 4104402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.055886', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3974, 'Candoi', 'PR', NULL, NULL, NULL, 4104428, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.056861', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3975, 'Cantagalo', 'PR', NULL, NULL, NULL, 4104451, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.057749', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3976, 'Capanema', 'PR', NULL, NULL, NULL, 4104501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.05867', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3977, 'Capitao Leonidas Marques', 'PR', NULL, NULL, NULL, 4104600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.059635', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3978, 'Carambei', 'PR', NULL, NULL, NULL, 4104659, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.060504', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3979, 'Carlopolis', 'PR', NULL, NULL, NULL, 4104709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.061386', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3980, 'Cascavel', 'PR', NULL, NULL, NULL, 4104808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.062316', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3981, 'Castro', 'PR', NULL, NULL, NULL, 4104907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.063137', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3982, 'Catanduvas', 'PR', NULL, NULL, NULL, 4105003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.064188', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3983, 'Centenario do Sul', 'PR', NULL, NULL, NULL, 4105102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.065187', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3984, 'Cerro Azul', 'PR', NULL, NULL, NULL, 4105201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.066246', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3985, 'Ceu Azul', 'PR', NULL, NULL, NULL, 4105300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.06723', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3986, 'Chopinzinho', 'PR', NULL, NULL, NULL, 4105409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.068245', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3987, 'Cianorte', 'PR', NULL, NULL, NULL, 4105508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.069317', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3988, 'Cidade Gaucha', 'PR', NULL, NULL, NULL, 4105607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.070245', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3989, 'Clevelandia', 'PR', NULL, NULL, NULL, 4105706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.071239', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3990, 'Colombo', 'PR', NULL, NULL, NULL, 4105805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.072161', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3991, 'Colorado', 'PR', NULL, NULL, NULL, 4105904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.073279', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3992, 'Congonhinhas', 'PR', NULL, NULL, NULL, 4106001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.074223', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3993, 'Conselheiro Mairinck', 'PR', NULL, NULL, NULL, 4106100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.075146', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3994, 'Contenda', 'PR', NULL, NULL, NULL, 4106209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.07629', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3995, 'Corbelia', 'PR', NULL, NULL, NULL, 4106308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.077225', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3996, 'Cornelio Procopio', 'PR', NULL, NULL, NULL, 4106407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.078202', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3997, 'Coronel Domingos Soares', 'PR', NULL, NULL, NULL, 4106456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.079407', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3998, 'Coronel Vivida', 'PR', NULL, NULL, NULL, 4106506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.086559', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3999, 'Corumbatai do Sul', 'PR', NULL, NULL, NULL, 4106555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.087675', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4001, 'Cruzeiro do Iguacu', 'PR', NULL, NULL, NULL, 4106571, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.089408', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4002, 'Cruzeiro do Oeste', 'PR', NULL, NULL, NULL, 4106605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.090379', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4003, 'Cruzeiro do Sul', 'PR', NULL, NULL, NULL, 4106704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.09129', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4000, 'Cruz Machado', 'PR', NULL, NULL, NULL, 4106803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.088592', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4004, 'Cruzmaltina', 'PR', NULL, NULL, NULL, 4106852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.092294', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4005, 'Curitiba', 'PR', NULL, NULL, NULL, 4106902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.093188', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4006, 'Curiuva', 'PR', NULL, NULL, NULL, 4107009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.094161', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4007, 'Diamante do Norte', 'PR', NULL, NULL, NULL, 4107108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.095041', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4008, 'Diamante do Sul', 'PR', NULL, NULL, NULL, 4107124, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.096391', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4009, 'Diamante D''oeste', 'PR', NULL, NULL, NULL, 4107157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.097438', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4010, 'Dois Vizinhos', 'PR', NULL, NULL, NULL, 4107207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.098274', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4011, 'Douradina', 'PR', NULL, NULL, NULL, 4107256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.099183', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4012, 'Doutor Camargo', 'PR', NULL, NULL, NULL, 4107306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.100098', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4014, 'Eneas Marques', 'PR', NULL, NULL, NULL, 4107405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.10187', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4015, 'Engenheiro Beltrao', 'PR', NULL, NULL, NULL, 4107504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.102709', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4017, 'Esperanca Nova', 'PR', NULL, NULL, NULL, 4107520, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.104368', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4016, 'Entre Rios do Oeste', 'PR', NULL, NULL, NULL, 4107538, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.103512', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4018, 'Espigao Alto do Iguacu', 'PR', NULL, NULL, NULL, 4107546, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.105422', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4019, 'Farol', 'PR', NULL, NULL, NULL, 4107553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.106399', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4020, 'Faxinal', 'PR', NULL, NULL, NULL, 4107603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.107374', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4021, 'Fazenda Rio Grande', 'PR', NULL, NULL, NULL, 4107652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.108241', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4022, 'Fenix', 'PR', NULL, NULL, NULL, 4107702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.109288', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4023, 'Fernandes Pinheiro', 'PR', NULL, NULL, NULL, 4107736, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.110161', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4024, 'Figueira', 'PR', NULL, NULL, NULL, 4107751, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.111065', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4026, 'Florai', 'PR', NULL, NULL, NULL, 4107801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.112881', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4025, 'Flor da Serra do Sul', 'PR', NULL, NULL, NULL, 4107850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.111977', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4027, 'Floresta', 'PR', NULL, NULL, NULL, 4107900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.113867', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4028, 'Florestopolis', 'PR', NULL, NULL, NULL, 4108007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.114779', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4029, 'Florida', 'PR', NULL, NULL, NULL, 4108106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.115752', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4030, 'Formosa do Oeste', 'PR', NULL, NULL, NULL, 4108205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.116721', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4031, 'Foz do Iguacu', 'PR', NULL, NULL, NULL, 4108304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.117707', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4033, 'Francisco Alves', 'PR', NULL, NULL, NULL, 4108320, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.119613', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4034, 'Francisco Beltrao', 'PR', NULL, NULL, NULL, 4108403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.120558', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4032, 'Foz do Jordao', 'PR', NULL, NULL, NULL, 4108452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.118639', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4035, 'General Carneiro', 'PR', NULL, NULL, NULL, 4108502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.127423', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4036, 'Godoy Moreira', 'PR', NULL, NULL, NULL, 4108551, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.128645', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4038, 'Goioxim', 'PR', NULL, NULL, NULL, 4108650, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.13055', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4039, 'Grandes Rios', 'PR', NULL, NULL, NULL, 4108700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.131638', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4040, 'Guaira', 'PR', NULL, NULL, NULL, 4108809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.13242', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4041, 'Guairaca', 'PR', NULL, NULL, NULL, 4108908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.133372', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4042, 'Guamiranga', 'PR', NULL, NULL, NULL, 4108957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.134252', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4043, 'Guapirama', 'PR', NULL, NULL, NULL, 4109005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.135191', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4044, 'Guaporema', 'PR', NULL, NULL, NULL, 4109104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.136151', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4045, 'Guaraci', 'PR', NULL, NULL, NULL, 4109203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.137079', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4046, 'Guaraniacu', 'PR', NULL, NULL, NULL, 4109302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.138006', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4047, 'Guarapuava', 'PR', NULL, NULL, NULL, 4109401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.138945', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4048, 'Guaraquecaba', 'PR', NULL, NULL, NULL, 4109500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.139847', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4049, 'Guaratuba', 'PR', NULL, NULL, NULL, 4109609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.140817', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4050, 'Honorio Serpa', 'PR', NULL, NULL, NULL, 4109658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.141648', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4051, 'Ibaiti', 'PR', NULL, NULL, NULL, 4109708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.142752', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4052, 'Ibema', 'PR', NULL, NULL, NULL, 4109757, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.143584', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4053, 'Ibipora', 'PR', NULL, NULL, NULL, 4109807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.14439', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4054, 'Icaraima', 'PR', NULL, NULL, NULL, 4109906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.145266', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4055, 'Iguaracu', 'PR', NULL, NULL, NULL, 4110003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.146086', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4056, 'Iguatu', 'PR', NULL, NULL, NULL, 4110052, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.146981', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4057, 'Imbau', 'PR', NULL, NULL, NULL, 4110078, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.147856', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4058, 'Imbituva', 'PR', NULL, NULL, NULL, 4110102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.148856', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4059, 'Inacio Martins', 'PR', NULL, NULL, NULL, 4110201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.149748', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4060, 'Inaja', 'PR', NULL, NULL, NULL, 4110300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.150609', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4061, 'Indianopolis', 'PR', NULL, NULL, NULL, 4110409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.151462', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4062, 'Ipiranga', 'PR', NULL, NULL, NULL, 4110508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.15233', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4063, 'Ipora', 'PR', NULL, NULL, NULL, 4110607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.153244', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4064, 'Iracema do Oeste', 'PR', NULL, NULL, NULL, 4110656, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.154171', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4065, 'Irati', 'PR', NULL, NULL, NULL, 4110706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.155067', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4066, 'Iretama', 'PR', NULL, NULL, NULL, 4110805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.155943', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4067, 'Itaguaje', 'PR', NULL, NULL, NULL, 4110904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.156929', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4068, 'Itaipulandia', 'PR', NULL, NULL, NULL, 4110953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.157878', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4069, 'Itambaraca', 'PR', NULL, NULL, NULL, 4111001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.158813', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4070, 'Itambe', 'PR', NULL, NULL, NULL, 4111100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.159654', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4071, 'Itapejara D''oeste', 'PR', NULL, NULL, NULL, 4111209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.160601', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4072, 'Itaperucu', 'PR', NULL, NULL, NULL, 4111258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.161482', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4073, 'Itauna do Sul', 'PR', NULL, NULL, NULL, 4111308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.162479', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4074, 'Ivai', 'PR', NULL, NULL, NULL, 4111407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.173191', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4075, 'Ivaipora', 'PR', NULL, NULL, NULL, 4111506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.174405', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4076, 'Ivate', 'PR', NULL, NULL, NULL, 4111555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.175489', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4077, 'Ivatuba', 'PR', NULL, NULL, NULL, 4111605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.176411', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4078, 'Jaboti', 'PR', NULL, NULL, NULL, 4111704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.177343', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4079, 'Jacarezinho', 'PR', NULL, NULL, NULL, 4111803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.178223', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4080, 'Jaguapita', 'PR', NULL, NULL, NULL, 4111902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.17908', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4081, 'Jaguariaiva', 'PR', NULL, NULL, NULL, 4112009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.179969', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4082, 'Jandaia do Sul', 'PR', NULL, NULL, NULL, 4112108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.180921', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4083, 'Janiopolis', 'PR', NULL, NULL, NULL, 4112207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.181768', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4084, 'Japira', 'PR', NULL, NULL, NULL, 4112306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.182695', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4085, 'Japura', 'PR', NULL, NULL, NULL, 4112405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.183595', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4086, 'Jardim Alegre', 'PR', NULL, NULL, NULL, 4112504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.184551', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4087, 'Jardim Olinda', 'PR', NULL, NULL, NULL, 4112603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.185484', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4088, 'Jataizinho', 'PR', NULL, NULL, NULL, 4112702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.186508', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4089, 'Jesuitas', 'PR', NULL, NULL, NULL, 4112751, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.187505', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4090, 'Joaquim Tavora', 'PR', NULL, NULL, NULL, 4112801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.188472', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4091, 'Jundiai do Sul', 'PR', NULL, NULL, NULL, 4112900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.189369', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4092, 'Juranda', 'PR', NULL, NULL, NULL, 4112959, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.190237', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4093, 'Jussara', 'PR', NULL, NULL, NULL, 4113007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.191189', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4094, 'Kalore', 'PR', NULL, NULL, NULL, 4113106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.192042', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4095, 'Lapa', 'PR', NULL, NULL, NULL, 4113205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.192994', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4096, 'Laranjal', 'PR', NULL, NULL, NULL, 4113254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.193967', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4097, 'Laranjeiras do Sul', 'PR', NULL, NULL, NULL, 4113304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.194892', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4098, 'Leopolis', 'PR', NULL, NULL, NULL, 4113403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.195946', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4099, 'Lidianopolis', 'PR', NULL, NULL, NULL, 4113429, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.196969', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4100, 'Lindoeste', 'PR', NULL, NULL, NULL, 4113452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.197979', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4101, 'Loanda', 'PR', NULL, NULL, NULL, 4113502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.198786', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4102, 'Lobato', 'PR', NULL, NULL, NULL, 4113601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.199695', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4103, 'Londrina', 'PR', NULL, NULL, NULL, 4113700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.200588', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4104, 'Luiziana', 'PR', NULL, NULL, NULL, 4113734, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.2014', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4105, 'Lunardelli', 'PR', NULL, NULL, NULL, 4113759, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.202191', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4106, 'Lupionopolis', 'PR', NULL, NULL, NULL, 4113809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.203083', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4107, 'Mallet', 'PR', NULL, NULL, NULL, 4113908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.204071', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4108, 'Mambore', 'PR', NULL, NULL, NULL, 4114005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.205131', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4109, 'Mandaguacu', 'PR', NULL, NULL, NULL, 4114104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.206396', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4110, 'Mandaguari', 'PR', NULL, NULL, NULL, 4114203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.207255', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4111, 'Mandirituba', 'PR', NULL, NULL, NULL, 4114302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.213506', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4112, 'Manfrinopolis', 'PR', NULL, NULL, NULL, 4114351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.214574', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4113, 'Mangueirinha', 'PR', NULL, NULL, NULL, 4114401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.21538', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4114, 'Manoel Ribas', 'PR', NULL, NULL, NULL, 4114500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.216194', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4115, 'Marechal Candido Rondon', 'PR', NULL, NULL, NULL, 4114609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.217021', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4116, 'Maria Helena', 'PR', NULL, NULL, NULL, 4114708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.217924', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4117, 'Marialva', 'PR', NULL, NULL, NULL, 4114807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.218808', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4118, 'Marilandia do Sul', 'PR', NULL, NULL, NULL, 4114906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.219675', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4119, 'Marilena', 'PR', NULL, NULL, NULL, 4115002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.221127', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4120, 'Mariluz', 'PR', NULL, NULL, NULL, 4115101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.22202', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4121, 'Maringa', 'PR', NULL, NULL, NULL, 4115200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.222938', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4122, 'Mariopolis', 'PR', NULL, NULL, NULL, 4115309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.223854', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4123, 'Maripa', 'PR', NULL, NULL, NULL, 4115358, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.224672', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4124, 'Marmeleiro', 'PR', NULL, NULL, NULL, 4115408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.22564', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4125, 'Marquinho', 'PR', NULL, NULL, NULL, 4115457, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.22658', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4126, 'Marumbi', 'PR', NULL, NULL, NULL, 4115507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.227421', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4127, 'Matelandia', 'PR', NULL, NULL, NULL, 4115606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.228228', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4128, 'Matinhos', 'PR', NULL, NULL, NULL, 4115705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.229194', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4129, 'Mato Rico', 'PR', NULL, NULL, NULL, 4115739, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.230144', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4130, 'Maua da Serra', 'PR', NULL, NULL, NULL, 4115754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.231029', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4131, 'Medianeira', 'PR', NULL, NULL, NULL, 4115804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.232254', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4132, 'Mercedes', 'PR', NULL, NULL, NULL, 4115853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.233069', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4133, 'Mirador', 'PR', NULL, NULL, NULL, 4115903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.233941', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4134, 'Miraselva', 'PR', NULL, NULL, NULL, 4116000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.234818', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4135, 'Missal', 'PR', NULL, NULL, NULL, 4116059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.23558', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4136, 'Moreira Sales', 'PR', NULL, NULL, NULL, 4116109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.236433', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4137, 'Morretes', 'PR', NULL, NULL, NULL, 4116208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.237286', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4138, 'Munhoz de Melo', 'PR', NULL, NULL, NULL, 4116307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.238297', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4139, 'Nossa Senhora das Gracas', 'PR', NULL, NULL, NULL, 4116406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.239216', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4140, 'Nova Alianca do Ivai', 'PR', NULL, NULL, NULL, 4116505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.240118', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4141, 'Nova America da Colina', 'PR', NULL, NULL, NULL, 4116604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.240981', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4142, 'Nova Aurora', 'PR', NULL, NULL, NULL, 4116703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.24191', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4143, 'Nova Cantu', 'PR', NULL, NULL, NULL, 4116802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.242841', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4144, 'Nova Esperanca', 'PR', NULL, NULL, NULL, 4116901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.243604', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4145, 'Nova Esperanca do Sudoeste', 'PR', NULL, NULL, NULL, 4116950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.244503', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4146, 'Nova Fatima', 'PR', NULL, NULL, NULL, 4117008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.24551', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4147, 'Nova Laranjeiras', 'PR', NULL, NULL, NULL, 4117057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.246408', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4148, 'Nova Londrina', 'PR', NULL, NULL, NULL, 4117107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.247175', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4149, 'Nova Olimpia', 'PR', NULL, NULL, NULL, 4117206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.254111', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4151, 'Nova Santa Barbara', 'PR', NULL, NULL, NULL, 4117214, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.256208', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4152, 'Nova Santa Rosa', 'PR', NULL, NULL, NULL, 4117222, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.257126', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4150, 'Nova Prata do Iguacu', 'PR', NULL, NULL, NULL, 4117255, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.255272', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4153, 'Nova Tebas', 'PR', NULL, NULL, NULL, 4117271, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.258244', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4154, 'Novo Itacolomi', 'PR', NULL, NULL, NULL, 4117297, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.259008', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4155, 'Ortigueira', 'PR', NULL, NULL, NULL, 4117305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.259923', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4156, 'Ourizona', 'PR', NULL, NULL, NULL, 4117404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.260801', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4157, 'Ouro Verde do Oeste', 'PR', NULL, NULL, NULL, 4117453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.261512', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4158, 'Paicandu', 'PR', NULL, NULL, NULL, 4117503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.262398', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4159, 'Palmas', 'PR', NULL, NULL, NULL, 4117602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.263241', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4160, 'Palmeira', 'PR', NULL, NULL, NULL, 4117701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.264126', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4161, 'Palmital', 'PR', NULL, NULL, NULL, 4117800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.264963', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4162, 'Palotina', 'PR', NULL, NULL, NULL, 4117909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.265805', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4163, 'Paraiso do Norte', 'PR', NULL, NULL, NULL, 4118006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.266633', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4164, 'Paranacity', 'PR', NULL, NULL, NULL, 4118105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.267515', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4165, 'Paranagua', 'PR', NULL, NULL, NULL, 4118204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.268404', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4166, 'Paranapoema', 'PR', NULL, NULL, NULL, 4118303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.269214', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4167, 'Paranavai', 'PR', NULL, NULL, NULL, 4118402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.270026', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4168, 'Pato Bragado', 'PR', NULL, NULL, NULL, 4118451, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.27079', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4169, 'Pato Branco', 'PR', NULL, NULL, NULL, 4118501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.271724', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4170, 'Paula Freitas', 'PR', NULL, NULL, NULL, 4118600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.272627', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4171, 'Paulo Frontin', 'PR', NULL, NULL, NULL, 4118709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.273639', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4172, 'Peabiru', 'PR', NULL, NULL, NULL, 4118808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.274646', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4173, 'Perobal', 'PR', NULL, NULL, NULL, 4118857, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.275641', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4174, 'Perola', 'PR', NULL, NULL, NULL, 4118907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.276605', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4175, 'Perola D''oeste', 'PR', NULL, NULL, NULL, 4119004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.277426', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4176, 'Pien', 'PR', NULL, NULL, NULL, 4119103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.278261', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4177, 'Pinhais', 'PR', NULL, NULL, NULL, 4119152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.279077', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4179, 'Pinhalao', 'PR', NULL, NULL, NULL, 4119202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.280779', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4178, 'Pinhal de Sao Bento', 'PR', NULL, NULL, NULL, 4119251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.279898', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4180, 'Pinhao', 'PR', NULL, NULL, NULL, 4119301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.281602', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4181, 'Pirai do Sul', 'PR', NULL, NULL, NULL, 4119400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.282487', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4182, 'Piraquara', 'PR', NULL, NULL, NULL, 4119509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.283295', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4183, 'Pitanga', 'PR', NULL, NULL, NULL, 4119608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.2841', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4184, 'Pitangueiras', 'PR', NULL, NULL, NULL, 4119657, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.285074', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4185, 'Planaltina do Parana', 'PR', NULL, NULL, NULL, 4119707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.28605', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4186, 'Planalto', 'PR', NULL, NULL, NULL, 4119806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.286973', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4187, 'Ponta Grossa', 'PR', NULL, NULL, NULL, 4119905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.287832', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4188, 'Pontal do Parana', 'PR', NULL, NULL, NULL, 4119954, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.294545', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4189, 'Porecatu', 'PR', NULL, NULL, NULL, 4120002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.295833', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4190, 'Porto Amazonas', 'PR', NULL, NULL, NULL, 4120101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.296693', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4191, 'Porto Barreiro', 'PR', NULL, NULL, NULL, 4120150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.297591', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4192, 'Porto Rico', 'PR', NULL, NULL, NULL, 4120200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.298581', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4193, 'Porto Vitoria', 'PR', NULL, NULL, NULL, 4120309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.299373', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4194, 'Prado Ferreira', 'PR', NULL, NULL, NULL, 4120333, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.300209', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4195, 'Pranchita', 'PR', NULL, NULL, NULL, 4120358, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.301016', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4196, 'Presidente Castelo Branco', 'PR', NULL, NULL, NULL, 4120408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.301937', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4197, 'Primeiro de Maio', 'PR', NULL, NULL, NULL, 4120507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.30282', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4198, 'Prudentopolis', 'PR', NULL, NULL, NULL, 4120606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.303849', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4199, 'Quarto Centenario', 'PR', NULL, NULL, NULL, 4120655, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.304786', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4200, 'Quatigua', 'PR', NULL, NULL, NULL, 4120705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.305711', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4201, 'Quatro Barras', 'PR', NULL, NULL, NULL, 4120804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.306515', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4202, 'Quatro Pontes', 'PR', NULL, NULL, NULL, 4120853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.307399', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4203, 'Quedas do Iguacu', 'PR', NULL, NULL, NULL, 4120903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.308241', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4204, 'Querencia do Norte', 'PR', NULL, NULL, NULL, 4121000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.309072', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4205, 'Quinta do Sol', 'PR', NULL, NULL, NULL, 4121109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.31021', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4206, 'Quitandinha', 'PR', NULL, NULL, NULL, 4121208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.311014', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4207, 'Ramilandia', 'PR', NULL, NULL, NULL, 4121257, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.3117', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4208, 'Rancho Alegre', 'PR', NULL, NULL, NULL, 4121307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.312592', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4209, 'Rancho Alegre D''oeste', 'PR', NULL, NULL, NULL, 4121356, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.313489', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4210, 'Realeza', 'PR', NULL, NULL, NULL, 4121406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.314376', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4211, 'Reboucas', 'PR', NULL, NULL, NULL, 4121505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.315317', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4212, 'Renascenca', 'PR', NULL, NULL, NULL, 4121604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.316337', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4213, 'Reserva', 'PR', NULL, NULL, NULL, 4121703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.317368', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4214, 'Reserva do Iguacu', 'PR', NULL, NULL, NULL, 4121752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.318231', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4215, 'Ribeirao Claro', 'PR', NULL, NULL, NULL, 4121802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.31911', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4216, 'Ribeirao do Pinhal', 'PR', NULL, NULL, NULL, 4121901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.319989', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4217, 'Rio Azul', 'PR', NULL, NULL, NULL, 4122008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.320821', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4218, 'Rio Bom', 'PR', NULL, NULL, NULL, 4122107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.32181', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4219, 'Rio Bonito do Iguacu', 'PR', NULL, NULL, NULL, 4122156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.322764', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4220, 'Rio Branco do Ivai', 'PR', NULL, NULL, NULL, 4122172, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.323713', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4221, 'Rio Branco do Sul', 'PR', NULL, NULL, NULL, 4122206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.324646', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4222, 'Rio Negro', 'PR', NULL, NULL, NULL, 4122305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.325554', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4223, 'Rolandia', 'PR', NULL, NULL, NULL, 4122404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.326432', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4224, 'Roncador', 'PR', NULL, NULL, NULL, 4122503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.327306', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4225, 'Rondon', 'PR', NULL, NULL, NULL, 4122602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.328245', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4226, 'Rosario do Ivai', 'PR', NULL, NULL, NULL, 4122651, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.338376', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4227, 'Sabaudia', 'PR', NULL, NULL, NULL, 4122701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.339508', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4228, 'Salgado Filho', 'PR', NULL, NULL, NULL, 4122800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.34043', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4229, 'Salto do Itarare', 'PR', NULL, NULL, NULL, 4122909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.341281', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4230, 'Salto do Lontra', 'PR', NULL, NULL, NULL, 4123006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.342375', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4231, 'Santa Amelia', 'PR', NULL, NULL, NULL, 4123105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.343545', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4232, 'Santa Cecilia do Pavao', 'PR', NULL, NULL, NULL, 4123204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.344438', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4233, 'Santa Cruz de Monte Castelo', 'PR', NULL, NULL, NULL, 4123303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.345319', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4234, 'Santa Fe', 'PR', NULL, NULL, NULL, 4123402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.346188', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4235, 'Santa Helena', 'PR', NULL, NULL, NULL, 4123501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.347091', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4236, 'Santa Ines', 'PR', NULL, NULL, NULL, 4123600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.347973', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4237, 'Santa Isabel do Ivai', 'PR', NULL, NULL, NULL, 4123709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.348934', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4238, 'Santa Izabel do Oeste', 'PR', NULL, NULL, NULL, 4123808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.349861', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4239, 'Santa Lucia', 'PR', NULL, NULL, NULL, 4123824, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.350735', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4240, 'Santa Maria do Oeste', 'PR', NULL, NULL, NULL, 4123857, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.351637', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4241, 'Santa Mariana', 'PR', NULL, NULL, NULL, 4123907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.352468', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4242, 'Santa Monica', 'PR', NULL, NULL, NULL, 4123956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.353319', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4245, 'Santana do Itarare', 'PR', NULL, NULL, NULL, 4124004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.355964', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4243, 'Santa Tereza do Oeste', 'PR', NULL, NULL, NULL, 4124020, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.35425', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4244, 'Santa Terezinha de Itaipu', 'PR', NULL, NULL, NULL, 4124053, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.355024', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4246, 'Santo Antonio da Platina', 'PR', NULL, NULL, NULL, 4124103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.356885', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4247, 'Santo Antonio do Caiua', 'PR', NULL, NULL, NULL, 4124202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.357831', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4248, 'Santo Antonio do Paraiso', 'PR', NULL, NULL, NULL, 4124301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.358771', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4249, 'Santo Antonio do Sudoeste', 'PR', NULL, NULL, NULL, 4124400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.359666', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4250, 'Santo Inacio', 'PR', NULL, NULL, NULL, 4124509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.360623', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4251, 'Sao Carlos do Ivai', 'PR', NULL, NULL, NULL, 4124608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.361502', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4252, 'Sao Jeronimo da Serra', 'PR', NULL, NULL, NULL, 4124707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.362324', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4253, 'Sao Joao', 'PR', NULL, NULL, NULL, 4124806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.363192', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4254, 'Sao Joao do Caiua', 'PR', NULL, NULL, NULL, 4124905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.364281', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4255, 'Sao Joao do Ivai', 'PR', NULL, NULL, NULL, 4125001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.365215', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4256, 'Sao Joao do Triunfo', 'PR', NULL, NULL, NULL, 4125100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.366215', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4259, 'Sao Jorge D''oeste', 'PR', NULL, NULL, NULL, 4125209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.368953', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4257, 'Sao Jorge do Ivai', 'PR', NULL, NULL, NULL, 4125308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.367092', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4258, 'Sao Jorge do Patrocinio', 'PR', NULL, NULL, NULL, 4125357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.368034', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4260, 'Sao Jose da Boa Vista', 'PR', NULL, NULL, NULL, 4125407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.369834', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4261, 'Sao Jose das Palmeiras', 'PR', NULL, NULL, NULL, 4125456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.370542', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4262, 'Sao Jose dos Pinhais', 'PR', NULL, NULL, NULL, 4125506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.371509', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4263, 'Sao Manoel do Parana', 'PR', NULL, NULL, NULL, 4125555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.372312', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4264, 'Sao Mateus do Sul', 'PR', NULL, NULL, NULL, 4125605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.37923', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4265, 'Sao Miguel do Iguacu', 'PR', NULL, NULL, NULL, 4125704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.380624', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4266, 'Sao Pedro do Iguacu', 'PR', NULL, NULL, NULL, 4125753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.381553', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4267, 'Sao Pedro do Ivai', 'PR', NULL, NULL, NULL, 4125803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.382512', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4268, 'Sao Pedro do Parana', 'PR', NULL, NULL, NULL, 4125902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.383505', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4269, 'Sao Sebastiao da Amoreira', 'PR', NULL, NULL, NULL, 4126009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.384423', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4270, 'Sao Tome', 'PR', NULL, NULL, NULL, 4126108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.38532', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4271, 'Sapopema', 'PR', NULL, NULL, NULL, 4126207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.386212', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4272, 'Sarandi', 'PR', NULL, NULL, NULL, 4126256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.38714', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4273, 'Saudade do Iguacu', 'PR', NULL, NULL, NULL, 4126272, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.388048', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4274, 'Senges', 'PR', NULL, NULL, NULL, 4126306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.388983', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4275, 'Serranopolis do Iguacu', 'PR', NULL, NULL, NULL, 4126355, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.389954', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4276, 'Sertaneja', 'PR', NULL, NULL, NULL, 4126405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.390851', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4277, 'Sertanopolis', 'PR', NULL, NULL, NULL, 4126504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.391827', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4278, 'Siqueira Campos', 'PR', NULL, NULL, NULL, 4126603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.392833', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4279, 'Sulina', 'PR', NULL, NULL, NULL, 4126652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.393627', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4280, 'Tamarana', 'PR', NULL, NULL, NULL, 4126678, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.394497', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4281, 'Tamboara', 'PR', NULL, NULL, NULL, 4126702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.395464', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4282, 'Tapejara', 'PR', NULL, NULL, NULL, 4126801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.396622', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4283, 'Tapira', 'PR', NULL, NULL, NULL, 4126900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.397553', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4284, 'Teixeira Soares', 'PR', NULL, NULL, NULL, 4127007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.398411', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4285, 'Telemaco Borba', 'PR', NULL, NULL, NULL, 4127106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.399685', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4286, 'Terra Boa', 'PR', NULL, NULL, NULL, 4127205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.400592', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4287, 'Terra Rica', 'PR', NULL, NULL, NULL, 4127304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.401465', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4288, 'Terra Roxa', 'PR', NULL, NULL, NULL, 4127403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.402543', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4289, 'Tibagi', 'PR', NULL, NULL, NULL, 4127502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.403763', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4290, 'Tijucas do Sul', 'PR', NULL, NULL, NULL, 4127601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.404751', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4291, 'Toledo', 'PR', NULL, NULL, NULL, 4127700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.405658', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4292, 'Tomazina', 'PR', NULL, NULL, NULL, 4127809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.406592', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4293, 'Tres Barras do Parana', 'PR', NULL, NULL, NULL, 4127858, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.407465', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4294, 'Tunas do Parana', 'PR', NULL, NULL, NULL, 4127882, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.408366', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4295, 'Tuneiras do Oeste', 'PR', NULL, NULL, NULL, 4127908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.409234', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4296, 'Tupassi', 'PR', NULL, NULL, NULL, 4127957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.41021', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4297, 'Turvo', 'PR', NULL, NULL, NULL, 4127965, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.410984', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4298, 'Ubirata', 'PR', NULL, NULL, NULL, 4128005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.411853', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4299, 'Umuarama', 'PR', NULL, NULL, NULL, 4128104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.412765', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4300, 'Uniao da Vitoria', 'PR', NULL, NULL, NULL, 4128203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.413578', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4301, 'Uniflor', 'PR', NULL, NULL, NULL, 4128302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.42009', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4302, 'Urai', 'PR', NULL, NULL, NULL, 4128401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.421232', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4308, 'Wenceslau Braz', 'PR', NULL, NULL, NULL, 4128500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.426895', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4303, 'Ventania', 'PR', NULL, NULL, NULL, 4128534, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.422122', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4304, 'Vera Cruz do Oeste', 'PR', NULL, NULL, NULL, 4128559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.422901', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4305, 'Vere', 'PR', NULL, NULL, NULL, 4128609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.423951', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (3916, 'Alto Paraiso', 'PR', NULL, NULL, NULL, 4128625, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.99001', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4013, 'Doutor Ulysses', 'PR', NULL, NULL, NULL, 4128633, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.100967', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4306, 'Virmond', 'PR', NULL, NULL, NULL, 4128658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.424896', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4307, 'Vitorino', 'PR', NULL, NULL, NULL, 4128708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.425982', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4309, 'Xambre', 'PR', NULL, NULL, NULL, 4128807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.427805', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4310, 'Abdon Batista', 'SC', NULL, NULL, NULL, 4200051, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.428638', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4311, 'Abelardo Luz', 'SC', NULL, NULL, NULL, 4200101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.429547', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4312, 'Agrolandia', 'SC', NULL, NULL, NULL, 4200200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.430478', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4313, 'Agronomica', 'SC', NULL, NULL, NULL, 4200309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.431358', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4314, 'Agua Doce', 'SC', NULL, NULL, NULL, 4200408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.43226', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4315, 'Aguas de Chapeco', 'SC', NULL, NULL, NULL, 4200507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.433055', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4316, 'Aguas Frias', 'SC', NULL, NULL, NULL, 4200556, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.43394', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4317, 'Aguas Mornas', 'SC', NULL, NULL, NULL, 4200606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.434905', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4318, 'Alfredo Wagner', 'SC', NULL, NULL, NULL, 4200705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.435771', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4319, 'Alto Bela Vista', 'SC', NULL, NULL, NULL, 4200754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.43669', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4320, 'Anchieta', 'SC', NULL, NULL, NULL, 4200804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.43753', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4321, 'Angelina', 'SC', NULL, NULL, NULL, 4200903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.43846', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4322, 'Anita Garibaldi', 'SC', NULL, NULL, NULL, 4201000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.439314', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4323, 'Anitapolis', 'SC', NULL, NULL, NULL, 4201109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.440162', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4324, 'Antonio Carlos', 'SC', NULL, NULL, NULL, 4201208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.440943', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4325, 'Apiuna', 'SC', NULL, NULL, NULL, 4201257, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.441712', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4326, 'Arabuta', 'SC', NULL, NULL, NULL, 4201273, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.442617', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4327, 'Araquari', 'SC', NULL, NULL, NULL, 4201307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.44364', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4328, 'Ararangua', 'SC', NULL, NULL, NULL, 4201406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.444439', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4329, 'Armazem', 'SC', NULL, NULL, NULL, 4201505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.445254', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4330, 'Arroio Trinta', 'SC', NULL, NULL, NULL, 4201604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.446176', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4331, 'Arvoredo', 'SC', NULL, NULL, NULL, 4201653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.447106', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4332, 'Ascurra', 'SC', NULL, NULL, NULL, 4201703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.44797', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4333, 'Atalanta', 'SC', NULL, NULL, NULL, 4201802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.448887', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4334, 'Aurora', 'SC', NULL, NULL, NULL, 4201901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.449795', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4335, 'Balneario Arroio do Silva', 'SC', NULL, NULL, NULL, 4201950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.450698', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4337, 'Balneario Camboriu', 'SC', NULL, NULL, NULL, 4202008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.45249', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4336, 'Balneario Barra do Sul', 'SC', NULL, NULL, NULL, 4202057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.451594', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4338, 'Balneario Gaivota', 'SC', NULL, NULL, NULL, 4202073, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.453461', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4339, 'Bandeirante', 'SC', NULL, NULL, NULL, 4202081, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.460344', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4340, 'Barra Bonita', 'SC', NULL, NULL, NULL, 4202099, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.461537', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4341, 'Barra Velha', 'SC', NULL, NULL, NULL, 4202107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.462448', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4342, 'Bela Vista do Toldo', 'SC', NULL, NULL, NULL, 4202131, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.463399', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4343, 'Belmonte', 'SC', NULL, NULL, NULL, 4202156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.464282', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4344, 'Benedito Novo', 'SC', NULL, NULL, NULL, 4202206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.465195', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4345, 'Biguacu', 'SC', NULL, NULL, NULL, 4202305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.466322', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4346, 'Blumenau', 'SC', NULL, NULL, NULL, 4202404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.467185', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4347, 'Bocaina do Sul', 'SC', NULL, NULL, NULL, 4202438, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.468115', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4352, 'Bombinhas', 'SC', NULL, NULL, NULL, 4202453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.472717', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4348, 'Bom Jardim da Serra', 'SC', NULL, NULL, NULL, 4202503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.469091', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4349, 'Bom Jesus', 'SC', NULL, NULL, NULL, 4202537, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.469971', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4350, 'Bom Jesus do Oeste', 'SC', NULL, NULL, NULL, 4202578, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.470938', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4351, 'Bom Retiro', 'SC', NULL, NULL, NULL, 4202602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.471851', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4353, 'Botuvera', 'SC', NULL, NULL, NULL, 4202701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.473586', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4354, 'Braco do Norte', 'SC', NULL, NULL, NULL, 4202800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.474511', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4355, 'Braco do Trombudo', 'SC', NULL, NULL, NULL, 4202859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.47539', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4356, 'Brunopolis', 'SC', NULL, NULL, NULL, 4202875, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.476535', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4357, 'Brusque', 'SC', NULL, NULL, NULL, 4202909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.477593', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4358, 'Cacador', 'SC', NULL, NULL, NULL, 4203006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.478494', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4359, 'Caibi', 'SC', NULL, NULL, NULL, 4203105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.479391', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4360, 'Calmon', 'SC', NULL, NULL, NULL, 4203154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.480305', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4361, 'Camboriu', 'SC', NULL, NULL, NULL, 4203204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.481266', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4368, 'Capao Alto', 'SC', NULL, NULL, NULL, 4203253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.488426', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4362, 'Campo Alegre', 'SC', NULL, NULL, NULL, 4203303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.482024', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4363, 'Campo Belo do Sul', 'SC', NULL, NULL, NULL, 4203402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.483299', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4364, 'Campo Ere', 'SC', NULL, NULL, NULL, 4203501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.484528', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4365, 'Campos Novos', 'SC', NULL, NULL, NULL, 4203600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.48539', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4366, 'Canelinha', 'SC', NULL, NULL, NULL, 4203709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.486284', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4367, 'Canoinhas', 'SC', NULL, NULL, NULL, 4203808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.487206', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4369, 'Capinzal', 'SC', NULL, NULL, NULL, 4203907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.489197', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4370, 'Capivari de Baixo', 'SC', NULL, NULL, NULL, 4203956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.490106', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4371, 'Catanduvas', 'SC', NULL, NULL, NULL, 4204004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.491025', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4372, 'Caxambu do Sul', 'SC', NULL, NULL, NULL, 4204103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.491954', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4373, 'Celso Ramos', 'SC', NULL, NULL, NULL, 4204152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.492847', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4374, 'Cerro Negro', 'SC', NULL, NULL, NULL, 4204178, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.493856', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4375, 'Chapadao do Lageado', 'SC', NULL, NULL, NULL, 4204194, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.500523', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4376, 'Chapeco', 'SC', NULL, NULL, NULL, 4204202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.501768', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4377, 'Cocal do Sul', 'SC', NULL, NULL, NULL, 4204251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.502784', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4378, 'Concordia', 'SC', NULL, NULL, NULL, 4204301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.50375', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4379, 'Cordilheira Alta', 'SC', NULL, NULL, NULL, 4204350, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.504637', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4380, 'Coronel Freitas', 'SC', NULL, NULL, NULL, 4204400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.50575', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4381, 'Coronel Martins', 'SC', NULL, NULL, NULL, 4204459, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.506666', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4383, 'Corupa', 'SC', NULL, NULL, NULL, 4204509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.508452', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4382, 'Correia Pinto', 'SC', NULL, NULL, NULL, 4204558, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.507531', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4384, 'Criciuma', 'SC', NULL, NULL, NULL, 4204608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.509451', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4385, 'Cunha Pora', 'SC', NULL, NULL, NULL, 4204707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.510481', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4386, 'Cunhatai', 'SC', NULL, NULL, NULL, 4204756, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.511334', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4387, 'Curitibanos', 'SC', NULL, NULL, NULL, 4204806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.512194', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4388, 'Descanso', 'SC', NULL, NULL, NULL, 4204905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.513047', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4389, 'Dionisio Cerqueira', 'SC', NULL, NULL, NULL, 4205001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.513922', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4390, 'Dona Emma', 'SC', NULL, NULL, NULL, 4205100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.514778', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4391, 'Doutor Pedrinho', 'SC', NULL, NULL, NULL, 4205159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.515649', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4392, 'Entre Rios', 'SC', NULL, NULL, NULL, 4205175, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.516534', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4393, 'Ermo', 'SC', NULL, NULL, NULL, 4205191, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.517512', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4394, 'Erval Velho', 'SC', NULL, NULL, NULL, 4205209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.518414', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4395, 'Faxinal dos Guedes', 'SC', NULL, NULL, NULL, 4205308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.519319', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4396, 'Flor do Sertao', 'SC', NULL, NULL, NULL, 4205357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.520213', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4397, 'Florianopolis', 'SC', NULL, NULL, NULL, 4205407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.521114', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4398, 'Formosa do Sul', 'SC', NULL, NULL, NULL, 4205431, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.522109', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4399, 'Forquilhinha', 'SC', NULL, NULL, NULL, 4205456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.523012', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4400, 'Fraiburgo', 'SC', NULL, NULL, NULL, 4205506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.523979', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4401, 'Frei Rogerio', 'SC', NULL, NULL, NULL, 4205555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.524846', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4402, 'Galvao', 'SC', NULL, NULL, NULL, 4205605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.525743', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4403, 'Garopaba', 'SC', NULL, NULL, NULL, 4205707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.526646', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4404, 'Garuva', 'SC', NULL, NULL, NULL, 4205803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.527531', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4405, 'Gaspar', 'SC', NULL, NULL, NULL, 4205902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.528459', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4406, 'Governador Celso Ramos', 'SC', NULL, NULL, NULL, 4206009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.529386', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4407, 'Grao Para', 'SC', NULL, NULL, NULL, 4206108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.530212', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4408, 'Gravatal', 'SC', NULL, NULL, NULL, 4206207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.531116', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4409, 'Guabiruba', 'SC', NULL, NULL, NULL, 4206306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.53194', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4410, 'Guaraciaba', 'SC', NULL, NULL, NULL, 4206405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.532863', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4411, 'Guaramirim', 'SC', NULL, NULL, NULL, 4206504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.533779', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4412, 'Guaruja do Sul', 'SC', NULL, NULL, NULL, 4206603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.535074', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4413, 'Guatambu', 'SC', NULL, NULL, NULL, 4206652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.541376', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4414, 'Herval D''oeste', 'SC', NULL, NULL, NULL, 4206702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.542596', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4415, 'Ibiam', 'SC', NULL, NULL, NULL, 4206751, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.543705', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4416, 'Ibicare', 'SC', NULL, NULL, NULL, 4206801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.544411', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4417, 'Ibirama', 'SC', NULL, NULL, NULL, 4206900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.54531', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4418, 'Icara', 'SC', NULL, NULL, NULL, 4207007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.546167', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4419, 'Ilhota', 'SC', NULL, NULL, NULL, 4207106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.546952', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4420, 'Imarui', 'SC', NULL, NULL, NULL, 4207205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.547891', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4421, 'Imbituba', 'SC', NULL, NULL, NULL, 4207304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.548745', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4422, 'Imbuia', 'SC', NULL, NULL, NULL, 4207403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.549615', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4423, 'Indaial', 'SC', NULL, NULL, NULL, 4207502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.550745', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4424, 'Iomere', 'SC', NULL, NULL, NULL, 4207577, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.551707', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4425, 'Ipira', 'SC', NULL, NULL, NULL, 4207601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.552628', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4426, 'Ipora do Oeste', 'SC', NULL, NULL, NULL, 4207650, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.553489', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4427, 'Ipuacu', 'SC', NULL, NULL, NULL, 4207684, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.554353', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4428, 'Ipumirim', 'SC', NULL, NULL, NULL, 4207700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.555764', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4429, 'Iraceminha', 'SC', NULL, NULL, NULL, 4207759, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.556864', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4430, 'Irani', 'SC', NULL, NULL, NULL, 4207809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.557716', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4431, 'Irati', 'SC', NULL, NULL, NULL, 4207858, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.558657', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4432, 'Irineopolis', 'SC', NULL, NULL, NULL, 4207908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.559588', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4433, 'Ita', 'SC', NULL, NULL, NULL, 4208005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.56052', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4434, 'Itaiopolis', 'SC', NULL, NULL, NULL, 4208104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.5614', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4435, 'Itajai', 'SC', NULL, NULL, NULL, 4208203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.562258', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4436, 'Itapema', 'SC', NULL, NULL, NULL, 4208302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.563129', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4437, 'Itapiranga', 'SC', NULL, NULL, NULL, 4208401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.564104', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4438, 'Itapoa', 'SC', NULL, NULL, NULL, 4208450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.565082', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4439, 'Ituporanga', 'SC', NULL, NULL, NULL, 4208500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.566056', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4440, 'Jabora', 'SC', NULL, NULL, NULL, 4208609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.566836', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4441, 'Jacinto Machado', 'SC', NULL, NULL, NULL, 4208708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.567842', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4442, 'Jaguaruna', 'SC', NULL, NULL, NULL, 4208807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.568806', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4443, 'Jaragua do Sul', 'SC', NULL, NULL, NULL, 4208906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.569621', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4444, 'Jardinopolis', 'SC', NULL, NULL, NULL, 4208955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.570517', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4445, 'Joacaba', 'SC', NULL, NULL, NULL, 4209003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.571308', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4446, 'Joinville', 'SC', NULL, NULL, NULL, 4209102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.572209', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4447, 'Jose Boiteux', 'SC', NULL, NULL, NULL, 4209151, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.573179', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4448, 'Jupia', 'SC', NULL, NULL, NULL, 4209177, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.574057', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4449, 'Lacerdopolis', 'SC', NULL, NULL, NULL, 4209201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.574936', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4450, 'Lages', 'SC', NULL, NULL, NULL, 4209300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.581911', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4451, 'Laguna', 'SC', NULL, NULL, NULL, 4209409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.583305', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4452, 'Lajeado Grande', 'SC', NULL, NULL, NULL, 4209458, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.584135', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4453, 'Laurentino', 'SC', NULL, NULL, NULL, 4209508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.584973', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4454, 'Lauro Muller', 'SC', NULL, NULL, NULL, 4209607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.585797', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4455, 'Lebon Regis', 'SC', NULL, NULL, NULL, 4209706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.586737', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4456, 'Leoberto Leal', 'SC', NULL, NULL, NULL, 4209805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.587727', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4457, 'Lindoia do Sul', 'SC', NULL, NULL, NULL, 4209854, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.589095', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4458, 'Lontras', 'SC', NULL, NULL, NULL, 4209904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.590019', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4459, 'Luiz Alves', 'SC', NULL, NULL, NULL, 4210001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.590917', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4460, 'Luzerna', 'SC', NULL, NULL, NULL, 4210035, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.591816', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4461, 'Macieira', 'SC', NULL, NULL, NULL, 4210050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.592688', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4462, 'Mafra', 'SC', NULL, NULL, NULL, 4210100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.593594', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4463, 'Major Gercino', 'SC', NULL, NULL, NULL, 4210209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.594511', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4464, 'Major Vieira', 'SC', NULL, NULL, NULL, 4210308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.595378', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4465, 'Maracaja', 'SC', NULL, NULL, NULL, 4210407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.59623', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4466, 'Maravilha', 'SC', NULL, NULL, NULL, 4210506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.597301', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4467, 'Marema', 'SC', NULL, NULL, NULL, 4210555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.598234', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4468, 'Massaranduba', 'SC', NULL, NULL, NULL, 4210605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.59912', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4469, 'Matos Costa', 'SC', NULL, NULL, NULL, 4210704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.600611', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4470, 'Meleiro', 'SC', NULL, NULL, NULL, 4210803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.601584', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4471, 'Mirim Doce', 'SC', NULL, NULL, NULL, 4210852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.602525', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4472, 'Modelo', 'SC', NULL, NULL, NULL, 4210902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.603369', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4473, 'Mondai', 'SC', NULL, NULL, NULL, 4211009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.604263', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4474, 'Monte Carlo', 'SC', NULL, NULL, NULL, 4211058, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.605228', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4475, 'Monte Castelo', 'SC', NULL, NULL, NULL, 4211108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.606147', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4476, 'Morro da Fumaca', 'SC', NULL, NULL, NULL, 4211207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.607036', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4477, 'Morro Grande', 'SC', NULL, NULL, NULL, 4211256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.607994', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4478, 'Navegantes', 'SC', NULL, NULL, NULL, 4211306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.608914', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4479, 'Nova Erechim', 'SC', NULL, NULL, NULL, 4211405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.60984', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4480, 'Nova Itaberaba', 'SC', NULL, NULL, NULL, 4211454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.610808', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4481, 'Nova Trento', 'SC', NULL, NULL, NULL, 4211504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.611579', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4482, 'Nova Veneza', 'SC', NULL, NULL, NULL, 4211603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.612402', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4483, 'Novo Horizonte', 'SC', NULL, NULL, NULL, 4211652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.61326', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4484, 'Orleans', 'SC', NULL, NULL, NULL, 4211702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.614203', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4485, 'Otacilio Costa', 'SC', NULL, NULL, NULL, 4211751, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.615091', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4486, 'Ouro', 'SC', NULL, NULL, NULL, 4211801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.615915', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4487, 'Ouro Verde', 'SC', NULL, NULL, NULL, 4211850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.622292', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4488, 'Paial', 'SC', NULL, NULL, NULL, 4211876, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.624172', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4489, 'Painel', 'SC', NULL, NULL, NULL, 4211892, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.625092', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4490, 'Palhoca', 'SC', NULL, NULL, NULL, 4211900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.625997', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4491, 'Palma Sola', 'SC', NULL, NULL, NULL, 4212007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.626836', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4492, 'Palmeira', 'SC', NULL, NULL, NULL, 4212056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.627753', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4493, 'Palmitos', 'SC', NULL, NULL, NULL, 4212106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.628577', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4494, 'Papanduva', 'SC', NULL, NULL, NULL, 4212205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.629483', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4495, 'Paraiso', 'SC', NULL, NULL, NULL, 4212239, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.630489', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4496, 'Passo de Torres', 'SC', NULL, NULL, NULL, 4212254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.631393', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4497, 'Passos Maia', 'SC', NULL, NULL, NULL, 4212270, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.632217', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4498, 'Paulo Lopes', 'SC', NULL, NULL, NULL, 4212304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.633094', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4499, 'Pedras Grandes', 'SC', NULL, NULL, NULL, 4212403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.634126', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4500, 'Penha', 'SC', NULL, NULL, NULL, 4212502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.635075', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4501, 'Peritiba', 'SC', NULL, NULL, NULL, 4212601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.635905', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4502, 'Petrolandia', 'SC', NULL, NULL, NULL, 4212700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.636576', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4503, 'Picarras', 'SC', NULL, NULL, NULL, 4212809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.637358', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4504, 'Pinhalzinho', 'SC', NULL, NULL, NULL, 4212908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.638178', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4505, 'Pinheiro Preto', 'SC', NULL, NULL, NULL, 4213005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.639052', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4506, 'Piratuba', 'SC', NULL, NULL, NULL, 4213104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.640027', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4507, 'Planalto Alegre', 'SC', NULL, NULL, NULL, 4213153, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.640907', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4508, 'Pomerode', 'SC', NULL, NULL, NULL, 4213203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.641749', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4509, 'Ponte Alta', 'SC', NULL, NULL, NULL, 4213302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.642696', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4510, 'Ponte Alta do Norte', 'SC', NULL, NULL, NULL, 4213351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.643679', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4511, 'Ponte Serrada', 'SC', NULL, NULL, NULL, 4213401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.644826', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4512, 'Porto Belo', 'SC', NULL, NULL, NULL, 4213500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.645727', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4513, 'Porto Uniao', 'SC', NULL, NULL, NULL, 4213609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.646532', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4514, 'Pouso Redondo', 'SC', NULL, NULL, NULL, 4213708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.647333', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4515, 'Praia Grande', 'SC', NULL, NULL, NULL, 4213807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.648213', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4516, 'Presidente Castello Branco', 'SC', NULL, NULL, NULL, 4213906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.64913', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4517, 'Presidente Getulio', 'SC', NULL, NULL, NULL, 4214003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.650041', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4518, 'Presidente Nereu', 'SC', NULL, NULL, NULL, 4214102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.650912', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4519, 'Princesa', 'SC', NULL, NULL, NULL, 4214151, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.651836', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4520, 'Quilombo', 'SC', NULL, NULL, NULL, 4214201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.65283', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4521, 'Rancho Queimado', 'SC', NULL, NULL, NULL, 4214300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.65372', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4522, 'Rio das Antas', 'SC', NULL, NULL, NULL, 4214409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.654634', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4523, 'Rio do Campo', 'SC', NULL, NULL, NULL, 4214508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.65549', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4524, 'Rio do Oeste', 'SC', NULL, NULL, NULL, 4214607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.656406', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4526, 'Rio dos Cedros', 'SC', NULL, NULL, NULL, 4214706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.664346', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4525, 'Rio do Sul', 'SC', NULL, NULL, NULL, 4214805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.663037', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4527, 'Rio Fortuna', 'SC', NULL, NULL, NULL, 4214904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.665268', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4528, 'Rio Negrinho', 'SC', NULL, NULL, NULL, 4215000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.666145', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4529, 'Rio Rufino', 'SC', NULL, NULL, NULL, 4215059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.667136', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4530, 'Riqueza', 'SC', NULL, NULL, NULL, 4215075, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.667883', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4531, 'Rodeio', 'SC', NULL, NULL, NULL, 4215109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.668722', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4532, 'Romelandia', 'SC', NULL, NULL, NULL, 4215208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.669664', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4533, 'Salete', 'SC', NULL, NULL, NULL, 4215307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.670537', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4534, 'Saltinho', 'SC', NULL, NULL, NULL, 4215356, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.671426', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4535, 'Salto Veloso', 'SC', NULL, NULL, NULL, 4215406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.672315', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4536, 'Sangao', 'SC', NULL, NULL, NULL, 4215455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.67311', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4537, 'Santa Cecilia', 'SC', NULL, NULL, NULL, 4215505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.674081', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4538, 'Santa Helena', 'SC', NULL, NULL, NULL, 4215554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.674964', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4539, 'Santa Rosa de Lima', 'SC', NULL, NULL, NULL, 4215604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.675907', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4540, 'Santa Rosa do Sul', 'SC', NULL, NULL, NULL, 4215653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.676772', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4541, 'Santa Terezinha', 'SC', NULL, NULL, NULL, 4215679, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.677855', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4542, 'Santa Terezinha do Progresso', 'SC', NULL, NULL, NULL, 4215687, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.678617', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4543, 'Santiago do Sul', 'SC', NULL, NULL, NULL, 4215695, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.679531', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4544, 'Santo Amaro da Imperatriz', 'SC', NULL, NULL, NULL, 4215703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.680401', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4546, 'Sao Bernardino', 'SC', NULL, NULL, NULL, 4215752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.682107', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4545, 'Sao Bento do Sul', 'SC', NULL, NULL, NULL, 4215802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.681233', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4547, 'Sao Bonifacio', 'SC', NULL, NULL, NULL, 4215901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.683118', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4548, 'Sao Carlos', 'SC', NULL, NULL, NULL, 4216008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.683978', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4549, 'Sao Cristovao do Sul', 'SC', NULL, NULL, NULL, 4216057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.684896', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4550, 'Sao Domingos', 'SC', NULL, NULL, NULL, 4216107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.685665', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4551, 'Sao Francisco do Sul', 'SC', NULL, NULL, NULL, 4216206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.686536', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4554, 'Sao Joao do Oeste', 'SC', NULL, NULL, NULL, 4216255, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.689546', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4552, 'Sao Joao Batista', 'SC', NULL, NULL, NULL, 4216305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.687673', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4553, 'Sao Joao do Itaperiu', 'SC', NULL, NULL, NULL, 4216354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.688602', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4555, 'Sao Joao do Sul', 'SC', NULL, NULL, NULL, 4216404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.690449', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4556, 'Sao Joaquim', 'SC', NULL, NULL, NULL, 4216503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.691291', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4557, 'Sao Jose', 'SC', NULL, NULL, NULL, 4216602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.692211', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4558, 'Sao Jose do Cedro', 'SC', NULL, NULL, NULL, 4216701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.693112', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4559, 'Sao Jose do Cerrito', 'SC', NULL, NULL, NULL, 4216800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.694047', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4560, 'Sao Lourenco do Oeste', 'SC', NULL, NULL, NULL, 4216909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.694964', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4561, 'Sao Ludgero', 'SC', NULL, NULL, NULL, 4217006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.695892', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4562, 'Sao Martinho', 'SC', NULL, NULL, NULL, 4217105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.696805', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4563, 'Sao Miguel da Boa Vista', 'SC', NULL, NULL, NULL, 4217154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.704183', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4564, 'Sao Miguel do Oeste', 'SC', NULL, NULL, NULL, 4217204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.705337', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4565, 'Sao Pedro de Alcantara', 'SC', NULL, NULL, NULL, 4217253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.706219', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4566, 'Saudades', 'SC', NULL, NULL, NULL, 4217303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.707271', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4567, 'Schroeder', 'SC', NULL, NULL, NULL, 4217402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.708028', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4568, 'Seara', 'SC', NULL, NULL, NULL, 4217501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.70891', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4569, 'Serra Alta', 'SC', NULL, NULL, NULL, 4217550, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.709735', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4570, 'Sideropolis', 'SC', NULL, NULL, NULL, 4217600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.710532', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4571, 'Sombrio', 'SC', NULL, NULL, NULL, 4217709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.711816', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4572, 'Sul Brasil', 'SC', NULL, NULL, NULL, 4217758, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.712836', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4573, 'Taio', 'SC', NULL, NULL, NULL, 4217808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.713717', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4574, 'Tangara', 'SC', NULL, NULL, NULL, 4217907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.714564', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4575, 'Tigrinhos', 'SC', NULL, NULL, NULL, 4217956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.715422', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4576, 'Tijucas', 'SC', NULL, NULL, NULL, 4218004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.716342', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4577, 'Timbe do Sul', 'SC', NULL, NULL, NULL, 4218103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.717364', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4578, 'Timbo', 'SC', NULL, NULL, NULL, 4218202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.718247', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4579, 'Timbo Grande', 'SC', NULL, NULL, NULL, 4218251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.719183', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4580, 'Tres Barras', 'SC', NULL, NULL, NULL, 4218301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.720092', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4581, 'Treviso', 'SC', NULL, NULL, NULL, 4218350, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.720922', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4582, 'Treze de Maio', 'SC', NULL, NULL, NULL, 4218400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.72182', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4583, 'Treze Tilias', 'SC', NULL, NULL, NULL, 4218509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.723155', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4584, 'Trombudo Central', 'SC', NULL, NULL, NULL, 4218608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.724091', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4585, 'Tubarao', 'SC', NULL, NULL, NULL, 4218707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.725008', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4586, 'Tunapolis', 'SC', NULL, NULL, NULL, 4218756, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.725919', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4587, 'Turvo', 'SC', NULL, NULL, NULL, 4218806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.726812', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4588, 'Uniao do Oeste', 'SC', NULL, NULL, NULL, 4218855, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.727766', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4589, 'Urubici', 'SC', NULL, NULL, NULL, 4218905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.728589', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4590, 'Urupema', 'SC', NULL, NULL, NULL, 4218954, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.729355', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4591, 'Urussanga', 'SC', NULL, NULL, NULL, 4219002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.730223', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4592, 'Vargeao', 'SC', NULL, NULL, NULL, 4219101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.731004', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4593, 'Vargem', 'SC', NULL, NULL, NULL, 4219150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.73178', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4594, 'Vargem Bonita', 'SC', NULL, NULL, NULL, 4219176, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.732992', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4595, 'Vidal Ramos', 'SC', NULL, NULL, NULL, 4219200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.734534', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4596, 'Videira', 'SC', NULL, NULL, NULL, 4219309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.735701', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4597, 'Vitor Meireles', 'SC', NULL, NULL, NULL, 4219358, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.736573', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4598, 'Witmarsum', 'SC', NULL, NULL, NULL, 4219408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.73748', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4599, 'Xanxere', 'SC', NULL, NULL, NULL, 4219507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.738315', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4600, 'Xavantina', 'SC', NULL, NULL, NULL, 4219606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.744776', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4601, 'Xaxim', 'SC', NULL, NULL, NULL, 4219705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.745932', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4602, 'Zortea', 'SC', NULL, NULL, NULL, 4219853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.746831', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4603, 'Acegua', 'RS', NULL, NULL, NULL, 4300034, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.747752', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4604, 'Agua Santa', 'RS', NULL, NULL, NULL, 4300059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.748623', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4605, 'Agudo', 'RS', NULL, NULL, NULL, 4300109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.749535', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4606, 'Ajuricaba', 'RS', NULL, NULL, NULL, 4300208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.750335', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4607, 'Alecrim', 'RS', NULL, NULL, NULL, 4300307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.751293', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4608, 'Alegrete', 'RS', NULL, NULL, NULL, 4300406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.75216', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4609, 'Alegria', 'RS', NULL, NULL, NULL, 4300455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.752979', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4610, 'Almirante Tamandare do Sul', 'RS', NULL, NULL, NULL, 4300471, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.75392', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4611, 'Alpestre', 'RS', NULL, NULL, NULL, 4300505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.754809', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4612, 'Alto Alegre', 'RS', NULL, NULL, NULL, 4300554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.755767', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4613, 'Alto Feliz', 'RS', NULL, NULL, NULL, 4300570, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.756681', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4614, 'Alvorada', 'RS', NULL, NULL, NULL, 4300604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.75756', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4615, 'Amaral Ferrador', 'RS', NULL, NULL, NULL, 4300638, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.758517', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4616, 'Ametista do Sul', 'RS', NULL, NULL, NULL, 4300646, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.759328', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4617, 'Andre da Rocha', 'RS', NULL, NULL, NULL, 4300661, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.760208', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4618, 'Anta Gorda', 'RS', NULL, NULL, NULL, 4300703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.760999', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4619, 'Antonio Prado', 'RS', NULL, NULL, NULL, 4300802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.76193', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4620, 'Arambare', 'RS', NULL, NULL, NULL, 4300851, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.763109', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4621, 'Ararica', 'RS', NULL, NULL, NULL, 4300877, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.76479', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4622, 'Aratiba', 'RS', NULL, NULL, NULL, 4300901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.765569', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4623, 'Arroio do Meio', 'RS', NULL, NULL, NULL, 4301008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.766691', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4625, 'Arroio do Sal', 'RS', NULL, NULL, NULL, 4301057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.768531', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4624, 'Arroio do Padre', 'RS', NULL, NULL, NULL, 4301073, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.767588', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4627, 'Arroio dos Ratos', 'RS', NULL, NULL, NULL, 4301107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.770348', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4626, 'Arroio do Tigre', 'RS', NULL, NULL, NULL, 4301206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.769457', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4628, 'Arroio Grande', 'RS', NULL, NULL, NULL, 4301305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.771225', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4629, 'Arvorezinha', 'RS', NULL, NULL, NULL, 4301404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.772101', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4630, 'Augusto Pestana', 'RS', NULL, NULL, NULL, 4301503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.772977', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4631, 'Aurea', 'RS', NULL, NULL, NULL, 4301552, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.773902', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4632, 'Bage', 'RS', NULL, NULL, NULL, 4301602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.774733', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4633, 'Balneario Pinhal', 'RS', NULL, NULL, NULL, 4301636, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.775604', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4634, 'Barao', 'RS', NULL, NULL, NULL, 4301651, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.776395', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4635, 'Barao de Cotegipe', 'RS', NULL, NULL, NULL, 4301701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.777163', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4636, 'Barao do Triunfo', 'RS', NULL, NULL, NULL, 4301750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.778243', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4642, 'Barracao', 'RS', NULL, NULL, NULL, 4301800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.789888', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4637, 'Barra do Guarita', 'RS', NULL, NULL, NULL, 4301859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.784613', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4638, 'Barra do Quarai', 'RS', NULL, NULL, NULL, 4301875, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.786135', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4639, 'Barra do Ribeiro', 'RS', NULL, NULL, NULL, 4301909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.787083', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4640, 'Barra do Rio Azul', 'RS', NULL, NULL, NULL, 4301925, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.787963', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4641, 'Barra Funda', 'RS', NULL, NULL, NULL, 4301958, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.788957', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4643, 'Barros Cassal', 'RS', NULL, NULL, NULL, 4302006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.790848', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4644, 'Benjamin Constant do Sul', 'RS', NULL, NULL, NULL, 4302055, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.791749', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4645, 'Bento Goncalves', 'RS', NULL, NULL, NULL, 4302105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.792666', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4646, 'Boa Vista das Missoes', 'RS', NULL, NULL, NULL, 4302154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.793467', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4647, 'Boa Vista do Burica', 'RS', NULL, NULL, NULL, 4302204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.794351', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4648, 'Boa Vista do Cadeado', 'RS', NULL, NULL, NULL, 4302220, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.795209', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4649, 'Boa Vista do Incra', 'RS', NULL, NULL, NULL, 4302238, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.79609', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4650, 'Boa Vista do Sul', 'RS', NULL, NULL, NULL, 4302253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.796974', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4651, 'Bom Jesus', 'RS', NULL, NULL, NULL, 4302303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.797947', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4652, 'Bom Principio', 'RS', NULL, NULL, NULL, 4302352, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.799093', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4653, 'Bom Progresso', 'RS', NULL, NULL, NULL, 4302378, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.80005', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4654, 'Bom Retiro do Sul', 'RS', NULL, NULL, NULL, 4302402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.800999', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4655, 'Boqueirao do Leao', 'RS', NULL, NULL, NULL, 4302451, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.801898', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4656, 'Bossoroca', 'RS', NULL, NULL, NULL, 4302501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.802916', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4657, 'Bozano', 'RS', NULL, NULL, NULL, 4302584, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.803916', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4658, 'Braga', 'RS', NULL, NULL, NULL, 4302600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.804862', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4659, 'Brochier', 'RS', NULL, NULL, NULL, 4302659, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.805735', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4660, 'Butia', 'RS', NULL, NULL, NULL, 4302709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.806615', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4661, 'Cacapava do Sul', 'RS', NULL, NULL, NULL, 4302808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.807519', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4662, 'Cacequi', 'RS', NULL, NULL, NULL, 4302907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.808337', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4663, 'Cachoeira do Sul', 'RS', NULL, NULL, NULL, 4303004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.809202', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4664, 'Cachoeirinha', 'RS', NULL, NULL, NULL, 4303103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.810127', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4665, 'Cacique Doble', 'RS', NULL, NULL, NULL, 4303202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.811004', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4666, 'Caibate', 'RS', NULL, NULL, NULL, 4303301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.812204', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4667, 'Caicara', 'RS', NULL, NULL, NULL, 4303400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.813081', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4668, 'Camaqua', 'RS', NULL, NULL, NULL, 4303509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.813986', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4669, 'Camargo', 'RS', NULL, NULL, NULL, 4303558, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.814864', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4670, 'Cambara do Sul', 'RS', NULL, NULL, NULL, 4303608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.815791', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4671, 'Campestre da Serra', 'RS', NULL, NULL, NULL, 4303673, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.816669', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4672, 'Campina das Missoes', 'RS', NULL, NULL, NULL, 4303707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.817629', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4673, 'Campinas do Sul', 'RS', NULL, NULL, NULL, 4303806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.818566', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4674, 'Campo Bom', 'RS', NULL, NULL, NULL, 4303905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.819422', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4675, 'Campo Novo', 'RS', NULL, NULL, NULL, 4304002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.825975', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4676, 'Campos Borges', 'RS', NULL, NULL, NULL, 4304101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.827145', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4677, 'Candelaria', 'RS', NULL, NULL, NULL, 4304200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.828029', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4678, 'Candido Godoi', 'RS', NULL, NULL, NULL, 4304309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.828872', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4679, 'Candiota', 'RS', NULL, NULL, NULL, 4304358, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.829693', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4680, 'Canela', 'RS', NULL, NULL, NULL, 4304408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.830636', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4681, 'Cangucu', 'RS', NULL, NULL, NULL, 4304507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.831498', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4682, 'Canoas', 'RS', NULL, NULL, NULL, 4304606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.8323', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4683, 'Canudos do Vale', 'RS', NULL, NULL, NULL, 4304614, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.833266', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4684, 'Capao Bonito do Sul', 'RS', NULL, NULL, NULL, 4304622, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.834669', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4685, 'Capao da Canoa', 'RS', NULL, NULL, NULL, 4304630, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.835592', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4686, 'Capao do Cipo', 'RS', NULL, NULL, NULL, 4304655, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.836576', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4687, 'Capao do Leao', 'RS', NULL, NULL, NULL, 4304663, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.83748', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4690, 'Capivari do Sul', 'RS', NULL, NULL, NULL, 4304671, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.840285', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4688, 'Capela de Santana', 'RS', NULL, NULL, NULL, 4304689, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.838512', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4689, 'Capitao', 'RS', NULL, NULL, NULL, 4304697, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.839442', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4692, 'Carazinho', 'RS', NULL, NULL, NULL, 4304705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.842067', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4691, 'Caraa', 'RS', NULL, NULL, NULL, 4304713, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.841208', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4693, 'Carlos Barbosa', 'RS', NULL, NULL, NULL, 4304804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.842932', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4694, 'Carlos Gomes', 'RS', NULL, NULL, NULL, 4304853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.843835', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4695, 'Casca', 'RS', NULL, NULL, NULL, 4304903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.844744', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4696, 'Caseiros', 'RS', NULL, NULL, NULL, 4304952, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.845669', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4697, 'Catuipe', 'RS', NULL, NULL, NULL, 4305009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.846536', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4698, 'Caxias do Sul', 'RS', NULL, NULL, NULL, 4305108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.847409', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4699, 'Centenario', 'RS', NULL, NULL, NULL, 4305116, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.848283', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4700, 'Cerrito', 'RS', NULL, NULL, NULL, 4305124, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.849096', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4701, 'Cerro Branco', 'RS', NULL, NULL, NULL, 4305132, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.849907', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4702, 'Cerro Grande', 'RS', NULL, NULL, NULL, 4305157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.850689', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4703, 'Cerro Grande do Sul', 'RS', NULL, NULL, NULL, 4305173, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.851567', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4704, 'Cerro Largo', 'RS', NULL, NULL, NULL, 4305207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.852471', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4705, 'Chapada', 'RS', NULL, NULL, NULL, 4305306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.853292', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4706, 'Charqueadas', 'RS', NULL, NULL, NULL, 4305355, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.854176', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4707, 'Charrua', 'RS', NULL, NULL, NULL, 4305371, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.855027', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4708, 'Chiapeta', 'RS', NULL, NULL, NULL, 4305405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.85595', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4709, 'Chui', 'RS', NULL, NULL, NULL, 4305439, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.856725', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4710, 'Chuvisca', 'RS', NULL, NULL, NULL, 4305447, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.857603', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4711, 'Cidreira', 'RS', NULL, NULL, NULL, 4305454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.85851', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4712, 'Ciriaco', 'RS', NULL, NULL, NULL, 4305504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.859474', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4713, 'Colinas', 'RS', NULL, NULL, NULL, 4305587, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.866184', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4714, 'Colorado', 'RS', NULL, NULL, NULL, 4305603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.86748', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4715, 'Condor', 'RS', NULL, NULL, NULL, 4305702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.868275', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4716, 'Constantina', 'RS', NULL, NULL, NULL, 4305801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.869145', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4717, 'Coqueiro Baixo', 'RS', NULL, NULL, NULL, 4305835, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.870084', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4718, 'Coqueiros do Sul', 'RS', NULL, NULL, NULL, 4305850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.87097', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4719, 'Coronel Barros', 'RS', NULL, NULL, NULL, 4305871, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.871889', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4720, 'Coronel Bicaco', 'RS', NULL, NULL, NULL, 4305900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.872786', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4721, 'Coronel Pilar', 'RS', NULL, NULL, NULL, 4305934, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.873768', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4722, 'Cotipora', 'RS', NULL, NULL, NULL, 4305959, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.874553', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4723, 'Coxilha', 'RS', NULL, NULL, NULL, 4305975, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.875317', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4724, 'Crissiumal', 'RS', NULL, NULL, NULL, 4306007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.876204', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4725, 'Cristal', 'RS', NULL, NULL, NULL, 4306056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.877062', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4726, 'Cristal do Sul', 'RS', NULL, NULL, NULL, 4306072, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.877944', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4727, 'Cruz Alta', 'RS', NULL, NULL, NULL, 4306106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.879136', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4728, 'Cruzaltense', 'RS', NULL, NULL, NULL, 4306130, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.88005', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4729, 'Cruzeiro do Sul', 'RS', NULL, NULL, NULL, 4306205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.880928', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4730, 'David Canabarro', 'RS', NULL, NULL, NULL, 4306304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.881777', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4731, 'Derrubadas', 'RS', NULL, NULL, NULL, 4306320, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.882651', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4732, 'Dezesseis de Novembro', 'RS', NULL, NULL, NULL, 4306353, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.883767', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4733, 'Dilermando de Aguiar', 'RS', NULL, NULL, NULL, 4306379, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.884831', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4734, 'Dois Irmaos', 'RS', NULL, NULL, NULL, 4306403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.885678', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4735, 'Dois Irmaos das Missoes', 'RS', NULL, NULL, NULL, 4306429, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.886822', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4736, 'Dois Lajeados', 'RS', NULL, NULL, NULL, 4306452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.887804', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4737, 'Dom Feliciano', 'RS', NULL, NULL, NULL, 4306502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.889073', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4739, 'Dom Pedro de Alcantara', 'RS', NULL, NULL, NULL, 4306551, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.891631', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4738, 'Dom Pedrito', 'RS', NULL, NULL, NULL, 4306601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.890589', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4740, 'Dona Francisca', 'RS', NULL, NULL, NULL, 4306700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.892557', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4741, 'Doutor Mauricio Cardoso', 'RS', NULL, NULL, NULL, 4306734, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.893417', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4742, 'Doutor Ricardo', 'RS', NULL, NULL, NULL, 4306759, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.894387', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4743, 'Eldorado do Sul', 'RS', NULL, NULL, NULL, 4306767, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.895258', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4744, 'Encantado', 'RS', NULL, NULL, NULL, 4306809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.896204', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4745, 'Encruzilhada do Sul', 'RS', NULL, NULL, NULL, 4306908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.89707', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4746, 'Engenho Velho', 'RS', NULL, NULL, NULL, 4306924, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.898021', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4748, 'Entre-ijuis', 'RS', NULL, NULL, NULL, 4306932, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.899999', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4747, 'Entre Rios do Sul', 'RS', NULL, NULL, NULL, 4306957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.899076', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4749, 'Erebango', 'RS', NULL, NULL, NULL, 4306973, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.906919', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4750, 'Erechim', 'RS', NULL, NULL, NULL, 4307005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.908132', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4751, 'Ernestina', 'RS', NULL, NULL, NULL, 4307054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.909116', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4793, 'Herval', 'RS', NULL, NULL, NULL, 4307104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.952112', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4752, 'Erval Grande', 'RS', NULL, NULL, NULL, 4307203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.910038', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4753, 'Erval Seco', 'RS', NULL, NULL, NULL, 4307302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.910899', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4754, 'Esmeralda', 'RS', NULL, NULL, NULL, 4307401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.91172', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4755, 'Esperanca do Sul', 'RS', NULL, NULL, NULL, 4307450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.912737', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4756, 'Espumoso', 'RS', NULL, NULL, NULL, 4307500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.913602', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4757, 'Estacao', 'RS', NULL, NULL, NULL, 4307559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.914491', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4758, 'Estancia Velha', 'RS', NULL, NULL, NULL, 4307609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.915345', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4759, 'Esteio', 'RS', NULL, NULL, NULL, 4307708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.916206', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4760, 'Estrela', 'RS', NULL, NULL, NULL, 4307807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.917135', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4761, 'Estrela Velha', 'RS', NULL, NULL, NULL, 4307815, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.918019', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4762, 'Eugenio de Castro', 'RS', NULL, NULL, NULL, 4307831, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.918923', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4763, 'Fagundes Varela', 'RS', NULL, NULL, NULL, 4307864, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.919878', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4764, 'Farroupilha', 'RS', NULL, NULL, NULL, 4307906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.920693', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4765, 'Faxinal do Soturno', 'RS', NULL, NULL, NULL, 4308003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.92163', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4766, 'Faxinalzinho', 'RS', NULL, NULL, NULL, 4308052, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.922524', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4767, 'Fazenda Vilanova', 'RS', NULL, NULL, NULL, 4308078, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.923302', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4768, 'Feliz', 'RS', NULL, NULL, NULL, 4308102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.924228', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4769, 'Flores da Cunha', 'RS', NULL, NULL, NULL, 4308201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.925172', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4770, 'Floriano Peixoto', 'RS', NULL, NULL, NULL, 4308250, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.926129', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4771, 'Fontoura Xavier', 'RS', NULL, NULL, NULL, 4308300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.927051', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4772, 'Formigueiro', 'RS', NULL, NULL, NULL, 4308409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.928008', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4773, 'Forquetinha', 'RS', NULL, NULL, NULL, 4308433, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.928929', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4774, 'Fortaleza dos Valos', 'RS', NULL, NULL, NULL, 4308458, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.929825', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4775, 'Frederico Westphalen', 'RS', NULL, NULL, NULL, 4308508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.93063', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4776, 'Garibaldi', 'RS', NULL, NULL, NULL, 4308607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.931355', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4777, 'Garruchos', 'RS', NULL, NULL, NULL, 4308656, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.932182', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4778, 'Gaurama', 'RS', NULL, NULL, NULL, 4308706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.933069', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4779, 'General Camara', 'RS', NULL, NULL, NULL, 4308805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.934026', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4780, 'Gentil', 'RS', NULL, NULL, NULL, 4308854, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.934915', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4781, 'Getulio Vargas', 'RS', NULL, NULL, NULL, 4308904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.935839', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4782, 'Girua', 'RS', NULL, NULL, NULL, 4309001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.936719', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4783, 'Glorinha', 'RS', NULL, NULL, NULL, 4309050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.937632', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4784, 'Gramado', 'RS', NULL, NULL, NULL, 4309100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.938533', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4785, 'Gramado dos Loureiros', 'RS', NULL, NULL, NULL, 4309126, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.939344', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4786, 'Gramado Xavier', 'RS', NULL, NULL, NULL, 4309159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.940203', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4787, 'Gravatai', 'RS', NULL, NULL, NULL, 4309209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.941029', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4788, 'Guabiju', 'RS', NULL, NULL, NULL, 4309258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.947441', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4789, 'Guaiba', 'RS', NULL, NULL, NULL, 4309308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.9486', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4790, 'Guapore', 'RS', NULL, NULL, NULL, 4309407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.949507', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4791, 'Guarani das Missoes', 'RS', NULL, NULL, NULL, 4309506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.950373', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4792, 'Harmonia', 'RS', NULL, NULL, NULL, 4309555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.951225', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4794, 'Herveiras', 'RS', NULL, NULL, NULL, 4309571, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.953031', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4795, 'Horizontina', 'RS', NULL, NULL, NULL, 4309605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.953898', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4796, 'Hulha Negra', 'RS', NULL, NULL, NULL, 4309654, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.954845', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4797, 'Humaita', 'RS', NULL, NULL, NULL, 4309704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.955805', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4798, 'Ibarama', 'RS', NULL, NULL, NULL, 4309753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.95672', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4799, 'Ibiaca', 'RS', NULL, NULL, NULL, 4309803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.957546', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4800, 'Ibiraiaras', 'RS', NULL, NULL, NULL, 4309902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.958417', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4801, 'Ibirapuita', 'RS', NULL, NULL, NULL, 4309951, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.959294', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4802, 'Ibiruba', 'RS', NULL, NULL, NULL, 4310009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.96032', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4803, 'Igrejinha', 'RS', NULL, NULL, NULL, 4310108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.96119', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4804, 'Ijui', 'RS', NULL, NULL, NULL, 4310207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.96206', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4805, 'Ilopolis', 'RS', NULL, NULL, NULL, 4310306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.962987', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4806, 'Imbe', 'RS', NULL, NULL, NULL, 4310330, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.963785', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4807, 'Imigrante', 'RS', NULL, NULL, NULL, 4310363, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.965082', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4808, 'Independencia', 'RS', NULL, NULL, NULL, 4310405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.96594', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4809, 'Inhacora', 'RS', NULL, NULL, NULL, 4310413, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.966873', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4810, 'Ipe', 'RS', NULL, NULL, NULL, 4310439, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.967679', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4811, 'Ipiranga do Sul', 'RS', NULL, NULL, NULL, 4310462, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.968588', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4812, 'Irai', 'RS', NULL, NULL, NULL, 4310504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.969396', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4813, 'Itaara', 'RS', NULL, NULL, NULL, 4310538, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.970351', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4814, 'Itacurubi', 'RS', NULL, NULL, NULL, 4310553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.971294', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4815, 'Itapuca', 'RS', NULL, NULL, NULL, 4310579, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.972165', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4816, 'Itaqui', 'RS', NULL, NULL, NULL, 4310603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.973061', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4817, 'Itati', 'RS', NULL, NULL, NULL, 4310652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.974002', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4818, 'Itatiba do Sul', 'RS', NULL, NULL, NULL, 4310702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.974873', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4819, 'Ivora', 'RS', NULL, NULL, NULL, 4310751, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.975784', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4820, 'Ivoti', 'RS', NULL, NULL, NULL, 4310801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.976642', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4821, 'Jaboticaba', 'RS', NULL, NULL, NULL, 4310850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.977503', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4822, 'Jacuizinho', 'RS', NULL, NULL, NULL, 4310876, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.978423', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4823, 'Jacutinga', 'RS', NULL, NULL, NULL, 4310900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.979538', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4824, 'Jaguarao', 'RS', NULL, NULL, NULL, 4311007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.980338', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4825, 'Jaguari', 'RS', NULL, NULL, NULL, 4311106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.981152', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4826, 'Jaquirana', 'RS', NULL, NULL, NULL, 4311122, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.987939', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4827, 'Jari', 'RS', NULL, NULL, NULL, 4311130, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.989393', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4828, 'Joia', 'RS', NULL, NULL, NULL, 4311155, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.990672', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4829, 'Julio de Castilhos', 'RS', NULL, NULL, NULL, 4311205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.991636', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4830, 'Lagoa Bonita do Sul', 'RS', NULL, NULL, NULL, 4311239, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.992696', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4833, 'Lagoao', 'RS', NULL, NULL, NULL, 4311254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.995228', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4831, 'Lagoa dos Tres Cantos', 'RS', NULL, NULL, NULL, 4311270, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.993546', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4832, 'Lagoa Vermelha', 'RS', NULL, NULL, NULL, 4311304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.99444', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4834, 'Lajeado', 'RS', NULL, NULL, NULL, 4311403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.996115', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4835, 'Lajeado do Bugre', 'RS', NULL, NULL, NULL, 4311429, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.996989', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4836, 'Lavras do Sul', 'RS', NULL, NULL, NULL, 4311502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.998102', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4837, 'Liberato Salzano', 'RS', NULL, NULL, NULL, 4311601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.999038', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4838, 'Lindolfo Collor', 'RS', NULL, NULL, NULL, 4311627, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.999932', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4839, 'Linha Nova', 'RS', NULL, NULL, NULL, 4311643, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.00075', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4841, 'Machadinho', 'RS', NULL, NULL, NULL, 4311700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.002707', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4840, 'Macambara', 'RS', NULL, NULL, NULL, 4311718, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.001806', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4842, 'Mampituba', 'RS', NULL, NULL, NULL, 4311734, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.003651', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4843, 'Manoel Viana', 'RS', NULL, NULL, NULL, 4311759, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.004534', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4844, 'Maquine', 'RS', NULL, NULL, NULL, 4311775, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.005502', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4845, 'Marata', 'RS', NULL, NULL, NULL, 4311791, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.006454', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4846, 'Marau', 'RS', NULL, NULL, NULL, 4311809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.007402', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4847, 'Marcelino Ramos', 'RS', NULL, NULL, NULL, 4311908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.008247', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4848, 'Mariana Pimentel', 'RS', NULL, NULL, NULL, 4311981, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.009044', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4849, 'Mariano Moro', 'RS', NULL, NULL, NULL, 4312005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.009911', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4850, 'Marques de Souza', 'RS', NULL, NULL, NULL, 4312054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.010831', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4851, 'Mata', 'RS', NULL, NULL, NULL, 4312104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.011716', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4852, 'Mato Castelhano', 'RS', NULL, NULL, NULL, 4312138, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.012915', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4853, 'Mato Leitao', 'RS', NULL, NULL, NULL, 4312153, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.013882', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4854, 'Mato Queimado', 'RS', NULL, NULL, NULL, 4312179, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.014734', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4855, 'Maximiliano de Almeida', 'RS', NULL, NULL, NULL, 4312203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.01553', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4856, 'Minas do Leao', 'RS', NULL, NULL, NULL, 4312252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.016287', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4857, 'Miraguai', 'RS', NULL, NULL, NULL, 4312302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.017159', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4858, 'Montauri', 'RS', NULL, NULL, NULL, 4312351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.018117', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4859, 'Monte Alegre dos Campos', 'RS', NULL, NULL, NULL, 4312377, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.018991', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4860, 'Monte Belo do Sul', 'RS', NULL, NULL, NULL, 4312385, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.019902', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4861, 'Montenegro', 'RS', NULL, NULL, NULL, 4312401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.020835', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4862, 'Mormaco', 'RS', NULL, NULL, NULL, 4312427, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.02173', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4863, 'Morrinhos do Sul', 'RS', NULL, NULL, NULL, 4312443, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.028527', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4864, 'Morro Redondo', 'RS', NULL, NULL, NULL, 4312450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.02965', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4865, 'Morro Reuter', 'RS', NULL, NULL, NULL, 4312476, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.030692', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4866, 'Mostardas', 'RS', NULL, NULL, NULL, 4312500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.032073', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4867, 'Mucum', 'RS', NULL, NULL, NULL, 4312609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.033021', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4868, 'Muitos Capoes', 'RS', NULL, NULL, NULL, 4312617, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.033894', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4869, 'Muliterno', 'RS', NULL, NULL, NULL, 4312625, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.03487', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4870, 'Nao-me-toque', 'RS', NULL, NULL, NULL, 4312658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.035708', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4871, 'Nicolau Vergueiro', 'RS', NULL, NULL, NULL, 4312674, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.036634', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4872, 'Nonoai', 'RS', NULL, NULL, NULL, 4312708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.037482', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4873, 'Nova Alvorada', 'RS', NULL, NULL, NULL, 4312757, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.038493', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4874, 'Nova Araca', 'RS', NULL, NULL, NULL, 4312807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.039364', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4875, 'Nova Bassano', 'RS', NULL, NULL, NULL, 4312906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.040191', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4876, 'Nova Boa Vista', 'RS', NULL, NULL, NULL, 4312955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.041367', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4877, 'Nova Brescia', 'RS', NULL, NULL, NULL, 4313003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.042406', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4878, 'Nova Candelaria', 'RS', NULL, NULL, NULL, 4313011, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.043243', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4879, 'Nova Esperanca do Sul', 'RS', NULL, NULL, NULL, 4313037, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.044148', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4880, 'Nova Hartz', 'RS', NULL, NULL, NULL, 4313060, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.044942', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4881, 'Nova Padua', 'RS', NULL, NULL, NULL, 4313086, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.045858', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4882, 'Nova Palma', 'RS', NULL, NULL, NULL, 4313102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.04664', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4883, 'Nova Petropolis', 'RS', NULL, NULL, NULL, 4313201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.047523', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4884, 'Nova Prata', 'RS', NULL, NULL, NULL, 4313300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.04839', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4885, 'Nova Ramada', 'RS', NULL, NULL, NULL, 4313334, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.049254', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4886, 'Nova Roma do Sul', 'RS', NULL, NULL, NULL, 4313359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.050199', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4887, 'Nova Santa Rita', 'RS', NULL, NULL, NULL, 4313375, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.051107', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4889, 'Novo Cabrais', 'RS', NULL, NULL, NULL, 4313391, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.052834', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4890, 'Novo Hamburgo', 'RS', NULL, NULL, NULL, 4313409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.053668', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4891, 'Novo Machado', 'RS', NULL, NULL, NULL, 4313425, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.054539', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4892, 'Novo Tiradentes', 'RS', NULL, NULL, NULL, 4313441, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.055463', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4893, 'Novo Xingu', 'RS', NULL, NULL, NULL, 4313466, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.056358', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4888, 'Novo Barreiro', 'RS', NULL, NULL, NULL, 4313490, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.052035', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4894, 'Osorio', 'RS', NULL, NULL, NULL, 4313508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.057633', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4895, 'Paim Filho', 'RS', NULL, NULL, NULL, 4313607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.058522', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4896, 'Palmares do Sul', 'RS', NULL, NULL, NULL, 4313656, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.0594', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4897, 'Palmeira das Missoes', 'RS', NULL, NULL, NULL, 4313706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.06019', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4898, 'Palmitinho', 'RS', NULL, NULL, NULL, 4313805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.061164', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4899, 'Panambi', 'RS', NULL, NULL, NULL, 4313904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.062045', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4900, 'Pantano Grande', 'RS', NULL, NULL, NULL, 4313953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.062725', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4901, 'Parai', 'RS', NULL, NULL, NULL, 4314001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.069617', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4902, 'Paraiso do Sul', 'RS', NULL, NULL, NULL, 4314027, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.07061', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4903, 'Pareci Novo', 'RS', NULL, NULL, NULL, 4314035, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.07147', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4904, 'Parobe', 'RS', NULL, NULL, NULL, 4314050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.072404', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4905, 'Passa Sete', 'RS', NULL, NULL, NULL, 4314068, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.073291', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4906, 'Passo do Sobrado', 'RS', NULL, NULL, NULL, 4314076, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.074185', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4907, 'Passo Fundo', 'RS', NULL, NULL, NULL, 4314100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.075119', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4908, 'Paulo Bento', 'RS', NULL, NULL, NULL, 4314134, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.076016', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4909, 'Paverama', 'RS', NULL, NULL, NULL, 4314159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.076943', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4910, 'Pedras Altas', 'RS', NULL, NULL, NULL, 4314175, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.077899', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4911, 'Pedro Osorio', 'RS', NULL, NULL, NULL, 4314209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.078764', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4912, 'Pejucara', 'RS', NULL, NULL, NULL, 4314308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.08024', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4913, 'Pelotas', 'RS', NULL, NULL, NULL, 4314407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.081029', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4914, 'Picada Cafe', 'RS', NULL, NULL, NULL, 4314423, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.082336', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4915, 'Pinhal', 'RS', NULL, NULL, NULL, 4314456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.083171', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4916, 'Pinhal da Serra', 'RS', NULL, NULL, NULL, 4314464, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.083953', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4917, 'Pinhal Grande', 'RS', NULL, NULL, NULL, 4314472, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.084872', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4918, 'Pinheirinho do Vale', 'RS', NULL, NULL, NULL, 4314498, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.08576', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4919, 'Pinheiro Machado', 'RS', NULL, NULL, NULL, 4314506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.086681', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4920, 'Pirapo', 'RS', NULL, NULL, NULL, 4314555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.087579', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4921, 'Piratini', 'RS', NULL, NULL, NULL, 4314605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.088495', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4922, 'Planalto', 'RS', NULL, NULL, NULL, 4314704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.089514', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4923, 'Poco das Antas', 'RS', NULL, NULL, NULL, 4314753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.090675', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4924, 'Pontao', 'RS', NULL, NULL, NULL, 4314779, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.091762', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4925, 'Ponte Preta', 'RS', NULL, NULL, NULL, 4314787, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.092594', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4926, 'Portao', 'RS', NULL, NULL, NULL, 4314803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.093566', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4927, 'Porto Alegre', 'RS', NULL, NULL, NULL, 4314902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.094539', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4928, 'Porto Lucena', 'RS', NULL, NULL, NULL, 4315008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.095462', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4929, 'Porto Maua', 'RS', NULL, NULL, NULL, 4315057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.09633', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4930, 'Porto Vera Cruz', 'RS', NULL, NULL, NULL, 4315073, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.097306', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4931, 'Porto Xavier', 'RS', NULL, NULL, NULL, 4315107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.098217', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4932, 'Pouso Novo', 'RS', NULL, NULL, NULL, 4315131, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.099245', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4933, 'Presidente Lucena', 'RS', NULL, NULL, NULL, 4315149, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.10017', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4934, 'Progresso', 'RS', NULL, NULL, NULL, 4315156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.101105', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4935, 'Protasio Alves', 'RS', NULL, NULL, NULL, 4315172, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.102143', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4936, 'Putinga', 'RS', NULL, NULL, NULL, 4315206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.103128', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4937, 'Quarai', 'RS', NULL, NULL, NULL, 4315305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.10406', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4938, 'Quatro Irmaos', 'RS', NULL, NULL, NULL, 4315313, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.110644', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4939, 'Quevedos', 'RS', NULL, NULL, NULL, 4315321, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.111825', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4940, 'Quinze de Novembro', 'RS', NULL, NULL, NULL, 4315354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.112857', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4941, 'Redentora', 'RS', NULL, NULL, NULL, 4315404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.113697', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4942, 'Relvado', 'RS', NULL, NULL, NULL, 4315453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.114655', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4943, 'Restinga Seca', 'RS', NULL, NULL, NULL, 4315503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.115499', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4944, 'Rio dos Indios', 'RS', NULL, NULL, NULL, 4315552, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.116294', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4945, 'Rio Grande', 'RS', NULL, NULL, NULL, 4315602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.117266', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4946, 'Rio Pardo', 'RS', NULL, NULL, NULL, 4315701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.118179', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4947, 'Riozinho', 'RS', NULL, NULL, NULL, 4315750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.119135', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4948, 'Roca Sales', 'RS', NULL, NULL, NULL, 4315800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.119995', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4949, 'Rodeio Bonito', 'RS', NULL, NULL, NULL, 4315909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.120924', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4950, 'Rolador', 'RS', NULL, NULL, NULL, 4315958, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.121849', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4951, 'Rolante', 'RS', NULL, NULL, NULL, 4316006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.122777', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4952, 'Ronda Alta', 'RS', NULL, NULL, NULL, 4316105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.123656', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4953, 'Rondinha', 'RS', NULL, NULL, NULL, 4316204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.124514', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4954, 'Roque Gonzales', 'RS', NULL, NULL, NULL, 4316303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.125383', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4955, 'Rosario do Sul', 'RS', NULL, NULL, NULL, 4316402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.126163', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4956, 'Sagrada Familia', 'RS', NULL, NULL, NULL, 4316428, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.127151', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4957, 'Saldanha Marinho', 'RS', NULL, NULL, NULL, 4316436, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.128127', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4958, 'Salto do Jacui', 'RS', NULL, NULL, NULL, 4316451, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.129107', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4959, 'Salvador das Missoes', 'RS', NULL, NULL, NULL, 4316477, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.13005', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4960, 'Salvador do Sul', 'RS', NULL, NULL, NULL, 4316501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.130968', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4961, 'Sananduva', 'RS', NULL, NULL, NULL, 4316600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.131942', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4962, 'Santa Barbara do Sul', 'RS', NULL, NULL, NULL, 4316709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.132733', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4963, 'Santa Cecilia do Sul', 'RS', NULL, NULL, NULL, 4316733, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.133677', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4964, 'Santa Clara do Sul', 'RS', NULL, NULL, NULL, 4316758, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.134621', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4965, 'Santa Cruz do Sul', 'RS', NULL, NULL, NULL, 4316808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.135859', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4967, 'Santa Maria', 'RS', NULL, NULL, NULL, 4316907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.137745', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4968, 'Santa Maria do Herval', 'RS', NULL, NULL, NULL, 4316956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.138656', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4966, 'Santa Margarida do Sul', 'RS', NULL, NULL, NULL, 4316972, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.136798', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4972, 'Santana da Boa Vista', 'RS', NULL, NULL, NULL, 4317004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.142334', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4973, 'Santana do Livramento', 'RS', NULL, NULL, NULL, 4317103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.143302', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4969, 'Santa Rosa', 'RS', NULL, NULL, NULL, 4317202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.139651', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4970, 'Santa Tereza', 'RS', NULL, NULL, NULL, 4317251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.140575', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4971, 'Santa Vitoria do Palmar', 'RS', NULL, NULL, NULL, 4317301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.141428', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4974, 'Santiago', 'RS', NULL, NULL, NULL, 4317400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.144184', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4975, 'Santo Angelo', 'RS', NULL, NULL, NULL, 4317509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.150861', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4978, 'Santo Antonio do Palma', 'RS', NULL, NULL, NULL, 4317558, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.153811', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4976, 'Santo Antonio da Patrulha', 'RS', NULL, NULL, NULL, 4317608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.151967', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4977, 'Santo Antonio das Missoes', 'RS', NULL, NULL, NULL, 4317707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.152911', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4979, 'Santo Antonio do Planalto', 'RS', NULL, NULL, NULL, 4317756, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.154666', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4980, 'Santo Augusto', 'RS', NULL, NULL, NULL, 4317806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.155574', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4981, 'Santo Cristo', 'RS', NULL, NULL, NULL, 4317905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.156456', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4982, 'Santo Expedito do Sul', 'RS', NULL, NULL, NULL, 4317954, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.157362', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4983, 'Sao Borja', 'RS', NULL, NULL, NULL, 4318002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.158226', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4984, 'Sao Domingos do Sul', 'RS', NULL, NULL, NULL, 4318051, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.159172', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4985, 'Sao Francisco de Assis', 'RS', NULL, NULL, NULL, 4318101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.160002', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4986, 'Sao Francisco de Paula', 'RS', NULL, NULL, NULL, 4318200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.160916', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4987, 'Sao Gabriel', 'RS', NULL, NULL, NULL, 4318309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.161758', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4988, 'Sao Jeronimo', 'RS', NULL, NULL, NULL, 4318408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.162555', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4989, 'Sao Joao da Urtiga', 'RS', NULL, NULL, NULL, 4318424, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.163489', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4990, 'Sao Joao do Polesine', 'RS', NULL, NULL, NULL, 4318432, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.164452', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4991, 'Sao Jorge', 'RS', NULL, NULL, NULL, 4318440, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.165471', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4992, 'Sao Jose das Missoes', 'RS', NULL, NULL, NULL, 4318457, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.166514', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4993, 'Sao Jose do Herval', 'RS', NULL, NULL, NULL, 4318465, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.167402', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4994, 'Sao Jose do Hortencio', 'RS', NULL, NULL, NULL, 4318481, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.168302', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4995, 'Sao Jose do Inhacora', 'RS', NULL, NULL, NULL, 4318499, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.169448', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4996, 'Sao Jose do Norte', 'RS', NULL, NULL, NULL, 4318507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.170483', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4997, 'Sao Jose do Ouro', 'RS', NULL, NULL, NULL, 4318606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.171355', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4998, 'Sao Jose do Sul', 'RS', NULL, NULL, NULL, 4318614, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.172279', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (4999, 'Sao Jose dos Ausentes', 'RS', NULL, NULL, NULL, 4318622, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.173227', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5000, 'Sao Leopoldo', 'RS', NULL, NULL, NULL, 4318705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.174112', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5001, 'Sao Lourenco do Sul', 'RS', NULL, NULL, NULL, 4318804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.175066', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5002, 'Sao Luiz Gonzaga', 'RS', NULL, NULL, NULL, 4318903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.176058', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5003, 'Sao Marcos', 'RS', NULL, NULL, NULL, 4319000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.176959', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5004, 'Sao Martinho', 'RS', NULL, NULL, NULL, 4319109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.177897', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5005, 'Sao Martinho da Serra', 'RS', NULL, NULL, NULL, 4319125, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.178867', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5006, 'Sao Miguel das Missoes', 'RS', NULL, NULL, NULL, 4319158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.17986', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5007, 'Sao Nicolau', 'RS', NULL, NULL, NULL, 4319208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.180803', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5008, 'Sao Paulo das Missoes', 'RS', NULL, NULL, NULL, 4319307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.181651', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5009, 'Sao Pedro da Serra', 'RS', NULL, NULL, NULL, 4319356, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.18264', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5010, 'Sao Pedro das Missoes', 'RS', NULL, NULL, NULL, 4319364, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.183578', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5011, 'Sao Pedro do Butia', 'RS', NULL, NULL, NULL, 4319372, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.184568', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5012, 'Sao Pedro do Sul', 'RS', NULL, NULL, NULL, 4319406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.191638', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5013, 'Sao Sebastiao do Cai', 'RS', NULL, NULL, NULL, 4319505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.192927', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5014, 'Sao Sepe', 'RS', NULL, NULL, NULL, 4319604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.193953', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5015, 'Sao Valentim', 'RS', NULL, NULL, NULL, 4319703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.194793', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5016, 'Sao Valentim do Sul', 'RS', NULL, NULL, NULL, 4319711, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.195665', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5017, 'Sao Valerio do Sul', 'RS', NULL, NULL, NULL, 4319737, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.196491', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5018, 'Sao Vendelino', 'RS', NULL, NULL, NULL, 4319752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.197532', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5019, 'Sao Vicente do Sul', 'RS', NULL, NULL, NULL, 4319802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.198462', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5020, 'Sapiranga', 'RS', NULL, NULL, NULL, 4319901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.199365', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5021, 'Sapucaia do Sul', 'RS', NULL, NULL, NULL, 4320008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.200245', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5022, 'Sarandi', 'RS', NULL, NULL, NULL, 4320107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.201335', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5023, 'Seberi', 'RS', NULL, NULL, NULL, 4320206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.202194', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5024, 'Sede Nova', 'RS', NULL, NULL, NULL, 4320230, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.203247', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5025, 'Segredo', 'RS', NULL, NULL, NULL, 4320263, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.204153', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5026, 'Selbach', 'RS', NULL, NULL, NULL, 4320305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.205013', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5027, 'Senador Salgado Filho', 'RS', NULL, NULL, NULL, 4320321, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.205893', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5028, 'Sentinela do Sul', 'RS', NULL, NULL, NULL, 4320354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.206792', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5029, 'Serafina Correa', 'RS', NULL, NULL, NULL, 4320404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.207836', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5030, 'Serio', 'RS', NULL, NULL, NULL, 4320453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.208802', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5031, 'Sertao', 'RS', NULL, NULL, NULL, 4320503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.209619', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5032, 'Sertao Santana', 'RS', NULL, NULL, NULL, 4320552, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.210595', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5033, 'Sete de Setembro', 'RS', NULL, NULL, NULL, 4320578, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.211625', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5034, 'Severiano de Almeida', 'RS', NULL, NULL, NULL, 4320602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.21262', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5035, 'Silveira Martins', 'RS', NULL, NULL, NULL, 4320651, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.213555', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5036, 'Sinimbu', 'RS', NULL, NULL, NULL, 4320677, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.21458', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5037, 'Sobradinho', 'RS', NULL, NULL, NULL, 4320701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.215477', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5038, 'Soledade', 'RS', NULL, NULL, NULL, 4320800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.216332', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5039, 'Tabai', 'RS', NULL, NULL, NULL, 4320859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.21724', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5040, 'Tapejara', 'RS', NULL, NULL, NULL, 4320909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.218094', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5041, 'Tapera', 'RS', NULL, NULL, NULL, 4321006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.219034', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5042, 'Tapes', 'RS', NULL, NULL, NULL, 4321105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.219964', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5043, 'Taquara', 'RS', NULL, NULL, NULL, 4321204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.220879', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5044, 'Taquari', 'RS', NULL, NULL, NULL, 4321303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.221862', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5045, 'Taquarucu do Sul', 'RS', NULL, NULL, NULL, 4321329, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.222788', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5046, 'Tavares', 'RS', NULL, NULL, NULL, 4321352, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.223707', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5047, 'Tenente Portela', 'RS', NULL, NULL, NULL, 4321402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.225347', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5048, 'Terra de Areia', 'RS', NULL, NULL, NULL, 4321436, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.232849', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5049, 'Teutonia', 'RS', NULL, NULL, NULL, 4321451, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.234121', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5050, 'Tio Hugo', 'RS', NULL, NULL, NULL, 4321469, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.235123', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5051, 'Tiradentes do Sul', 'RS', NULL, NULL, NULL, 4321477, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.23607', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5052, 'Toropi', 'RS', NULL, NULL, NULL, 4321493, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.236996', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5053, 'Torres', 'RS', NULL, NULL, NULL, 4321501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.237913', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5054, 'Tramandai', 'RS', NULL, NULL, NULL, 4321600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.23885', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5055, 'Travesseiro', 'RS', NULL, NULL, NULL, 4321626, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.239806', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5056, 'Tres Arroios', 'RS', NULL, NULL, NULL, 4321634, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.240805', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5057, 'Tres Cachoeiras', 'RS', NULL, NULL, NULL, 4321667, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.241777', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5058, 'Tres Coroas', 'RS', NULL, NULL, NULL, 4321709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.242724', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5059, 'Tres de Maio', 'RS', NULL, NULL, NULL, 4321808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.243769', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5060, 'Tres Forquilhas', 'RS', NULL, NULL, NULL, 4321832, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.244655', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5061, 'Tres Palmeiras', 'RS', NULL, NULL, NULL, 4321857, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.245532', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5062, 'Tres Passos', 'RS', NULL, NULL, NULL, 4321907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.246606', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5063, 'Trindade do Sul', 'RS', NULL, NULL, NULL, 4321956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.247562', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5064, 'Triunfo', 'RS', NULL, NULL, NULL, 4322004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.248414', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5065, 'Tucunduva', 'RS', NULL, NULL, NULL, 4322103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.249233', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5066, 'Tunas', 'RS', NULL, NULL, NULL, 4322152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.250107', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5067, 'Tupanci do Sul', 'RS', NULL, NULL, NULL, 4322186, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.250953', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5068, 'Tupancireta', 'RS', NULL, NULL, NULL, 4322202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.251821', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5069, 'Tupandi', 'RS', NULL, NULL, NULL, 4322251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.252708', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5070, 'Tuparendi', 'RS', NULL, NULL, NULL, 4322301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.253578', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5071, 'Turucu', 'RS', NULL, NULL, NULL, 4322327, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.254432', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5072, 'Ubiretama', 'RS', NULL, NULL, NULL, 4322343, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.255333', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5073, 'Uniao da Serra', 'RS', NULL, NULL, NULL, 4322350, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.256245', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5074, 'Unistalda', 'RS', NULL, NULL, NULL, 4322376, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.257204', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5075, 'Uruguaiana', 'RS', NULL, NULL, NULL, 4322400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.258629', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5076, 'Vacaria', 'RS', NULL, NULL, NULL, 4322509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.259601', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5079, 'Vale Verde', 'RS', NULL, NULL, NULL, 4322525, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.262431', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5077, 'Vale do Sol', 'RS', NULL, NULL, NULL, 4322533, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.260531', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5078, 'Vale Real', 'RS', NULL, NULL, NULL, 4322541, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.261524', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5080, 'Vanini', 'RS', NULL, NULL, NULL, 4322558, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.263447', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5081, 'Venancio Aires', 'RS', NULL, NULL, NULL, 4322608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.264406', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5082, 'Vera Cruz', 'RS', NULL, NULL, NULL, 4322707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.265345', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5083, 'Veranopolis', 'RS', NULL, NULL, NULL, 4322806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.26647', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5084, 'Vespasiano Correa', 'RS', NULL, NULL, NULL, 4322855, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.273349', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5085, 'Viadutos', 'RS', NULL, NULL, NULL, 4322905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.274527', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5086, 'Viamao', 'RS', NULL, NULL, NULL, 4323002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.275464', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5087, 'Vicente Dutra', 'RS', NULL, NULL, NULL, 4323101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.276287', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5088, 'Victor Graeff', 'RS', NULL, NULL, NULL, 4323200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.27728', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5089, 'Vila Flores', 'RS', NULL, NULL, NULL, 4323309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.278305', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5090, 'Vila Langaro', 'RS', NULL, NULL, NULL, 4323358, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.279156', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5091, 'Vila Maria', 'RS', NULL, NULL, NULL, 4323408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.280109', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5092, 'Vila Nova do Sul', 'RS', NULL, NULL, NULL, 4323457, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.281043', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5093, 'Vista Alegre', 'RS', NULL, NULL, NULL, 4323507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.281928', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5094, 'Vista Alegre do Prata', 'RS', NULL, NULL, NULL, 4323606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.282888', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5095, 'Vista Gaucha', 'RS', NULL, NULL, NULL, 4323705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.283856', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5096, 'Vitoria das Missoes', 'RS', NULL, NULL, NULL, 4323754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.284731', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5097, 'Westfalia', 'RS', NULL, NULL, NULL, 4323770, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.285646', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5098, 'Xangri-la', 'RS', NULL, NULL, NULL, 4323804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.286521', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5099, 'Agua Clara', 'MS', NULL, NULL, NULL, 5000203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.287518', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5100, 'Alcinopolis', 'MS', NULL, NULL, NULL, 5000252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.288446', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5101, 'Amambai', 'MS', NULL, NULL, NULL, 5000609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.289301', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5102, 'Anastacio', 'MS', NULL, NULL, NULL, 5000708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.290239', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5103, 'Anaurilandia', 'MS', NULL, NULL, NULL, 5000807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.291232', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5104, 'Angelica', 'MS', NULL, NULL, NULL, 5000856, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.292032', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5105, 'Antonio Joao', 'MS', NULL, NULL, NULL, 5000906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.293133', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5106, 'Aparecida do Taboado', 'MS', NULL, NULL, NULL, 5001003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.294053', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5107, 'Aquidauana', 'MS', NULL, NULL, NULL, 5001102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.294884', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5108, 'Aral Moreira', 'MS', NULL, NULL, NULL, 5001243, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.29572', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5109, 'Bandeirantes', 'MS', NULL, NULL, NULL, 5001508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.296713', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5110, 'Bataguassu', 'MS', NULL, NULL, NULL, 5001904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.29763', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5112, 'Bela Vista', 'MS', NULL, NULL, NULL, 5002100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.299542', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5113, 'Bodoquena', 'MS', NULL, NULL, NULL, 5002159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.300463', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5114, 'Bonito', 'MS', NULL, NULL, NULL, 5002209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.301372', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5115, 'Brasilandia', 'MS', NULL, NULL, NULL, 5002308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.302327', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5116, 'Caarapo', 'MS', NULL, NULL, NULL, 5002407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.303136', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5117, 'Camapua', 'MS', NULL, NULL, NULL, 5002605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.304018', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5118, 'Campo Grande', 'MS', NULL, NULL, NULL, 5002704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.30485', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5119, 'Caracol', 'MS', NULL, NULL, NULL, 5002803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.305697', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5120, 'Cassilandia', 'MS', NULL, NULL, NULL, 5002902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.306539', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5121, 'Chapadao do Sul', 'MS', NULL, NULL, NULL, 5002951, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.313766', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5122, 'Corguinho', 'MS', NULL, NULL, NULL, 5003108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.314832', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5123, 'Coronel Sapucaia', 'MS', NULL, NULL, NULL, 5003157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.315886', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5124, 'Corumba', 'MS', NULL, NULL, NULL, 5003207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.316677', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5125, 'Costa Rica', 'MS', NULL, NULL, NULL, 5003256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.317565', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5126, 'Coxim', 'MS', NULL, NULL, NULL, 5003306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.318438', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5127, 'Deodapolis', 'MS', NULL, NULL, NULL, 5003454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.319156', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5128, 'Dois Irmaos do Buriti', 'MS', NULL, NULL, NULL, 5003488, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.320079', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5129, 'Douradina', 'MS', NULL, NULL, NULL, 5003504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.320958', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5130, 'Dourados', 'MS', NULL, NULL, NULL, 5003702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.321841', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5131, 'Eldorado', 'MS', NULL, NULL, NULL, 5003751, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.322753', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5132, 'Fatima do Sul', 'MS', NULL, NULL, NULL, 5003801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.323883', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5133, 'Figueirao', 'MS', NULL, NULL, NULL, 5003900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.324801', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5134, 'Gloria de Dourados', 'MS', NULL, NULL, NULL, 5004007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.325637', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5135, 'Guia Lopes da Laguna', 'MS', NULL, NULL, NULL, 5004106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.326641', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5136, 'Iguatemi', 'MS', NULL, NULL, NULL, 5004304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.327619', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5137, 'Inocencia', 'MS', NULL, NULL, NULL, 5004403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.328612', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5138, 'Itapora', 'MS', NULL, NULL, NULL, 5004502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.329508', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5139, 'Itaquirai', 'MS', NULL, NULL, NULL, 5004601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.33029', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5140, 'Ivinhema', 'MS', NULL, NULL, NULL, 5004700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.331111', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5141, 'Japora', 'MS', NULL, NULL, NULL, 5004809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.332023', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5142, 'Jaraguari', 'MS', NULL, NULL, NULL, 5004908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.332947', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5143, 'Jardim', 'MS', NULL, NULL, NULL, 5005004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.333891', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5144, 'Jatei', 'MS', NULL, NULL, NULL, 5005103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.334815', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5145, 'Juti', 'MS', NULL, NULL, NULL, 5005152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.335804', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5146, 'Ladario', 'MS', NULL, NULL, NULL, 5005202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.336612', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5147, 'Laguna Carapa', 'MS', NULL, NULL, NULL, 5005251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.337536', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5148, 'Maracaju', 'MS', NULL, NULL, NULL, 5005400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.338444', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5149, 'Miranda', 'MS', NULL, NULL, NULL, 5005608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.33931', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5150, 'Mundo Novo', 'MS', NULL, NULL, NULL, 5005681, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.340178', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5151, 'Navirai', 'MS', NULL, NULL, NULL, 5005707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.341075', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5152, 'Nioaque', 'MS', NULL, NULL, NULL, 5005806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.341888', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5153, 'Nova Alvorada do Sul', 'MS', NULL, NULL, NULL, 5006002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.342697', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5154, 'Nova Andradina', 'MS', NULL, NULL, NULL, 5006200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.343615', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5155, 'Novo Horizonte do Sul', 'MS', NULL, NULL, NULL, 5006259, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.344527', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5156, 'Paranaiba', 'MS', NULL, NULL, NULL, 5006309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.345447', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5157, 'Paranhos', 'MS', NULL, NULL, NULL, 5006358, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.346394', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5158, 'Pedro Gomes', 'MS', NULL, NULL, NULL, 5006408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.347493', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5159, 'Ponta Pora', 'MS', NULL, NULL, NULL, 5006606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.35418', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5160, 'Porto Murtinho', 'MS', NULL, NULL, NULL, 5006903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.355395', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5161, 'Ribas do Rio Pardo', 'MS', NULL, NULL, NULL, 5007109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.356263', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5162, 'Rio Brilhante', 'MS', NULL, NULL, NULL, 5007208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.357159', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5163, 'Rio Negro', 'MS', NULL, NULL, NULL, 5007307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.358428', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5164, 'Rio Verde de Mato Grosso', 'MS', NULL, NULL, NULL, 5007406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.359236', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5165, 'Rochedo', 'MS', NULL, NULL, NULL, 5007505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.360185', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5166, 'Santa Rita do Pardo', 'MS', NULL, NULL, NULL, 5007554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.360982', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5167, 'Sao Gabriel do Oeste', 'MS', NULL, NULL, NULL, 5007695, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.362003', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5169, 'Sete Quedas', 'MS', NULL, NULL, NULL, 5007703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.363971', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5168, 'Selviria', 'MS', NULL, NULL, NULL, 5007802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.362991', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5170, 'Sidrolandia', 'MS', NULL, NULL, NULL, 5007901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.364965', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5171, 'Sonora', 'MS', NULL, NULL, NULL, 5007935, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.366069', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5172, 'Tacuru', 'MS', NULL, NULL, NULL, 5007950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.366911', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5173, 'Taquarussu', 'MS', NULL, NULL, NULL, 5007976, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.368294', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5174, 'Terenos', 'MS', NULL, NULL, NULL, 5008008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.369444', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5175, 'Tres Lagoas', 'MS', NULL, NULL, NULL, 5008305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.370315', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5176, 'Vicentina', 'MS', NULL, NULL, NULL, 5008404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.371201', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5177, 'Acorizal', 'MT', NULL, NULL, NULL, 5100102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.372079', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5178, 'Agua Boa', 'MT', NULL, NULL, NULL, 5100201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.372947', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5179, 'Alta Floresta', 'MT', NULL, NULL, NULL, 5100250, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.373825', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5180, 'Alto Araguaia', 'MT', NULL, NULL, NULL, 5100300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.374753', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5181, 'Alto Boa Vista', 'MT', NULL, NULL, NULL, 5100359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.375625', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5182, 'Alto Garcas', 'MT', NULL, NULL, NULL, 5100409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.376478', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5183, 'Alto Paraguai', 'MT', NULL, NULL, NULL, 5100508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.37727', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5184, 'Alto Taquari', 'MT', NULL, NULL, NULL, 5100607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.378248', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5185, 'Apiacas', 'MT', NULL, NULL, NULL, 5100805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.379176', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5186, 'Araguaiana', 'MT', NULL, NULL, NULL, 5101001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.380109', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5187, 'Araguainha', 'MT', NULL, NULL, NULL, 5101209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.381101', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5188, 'Araputanga', 'MT', NULL, NULL, NULL, 5101258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.382033', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5189, 'Arenapolis', 'MT', NULL, NULL, NULL, 5101308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.383142', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5190, 'Aripuana', 'MT', NULL, NULL, NULL, 5101407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.383975', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5191, 'Barao de Melgaco', 'MT', NULL, NULL, NULL, 5101605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.384902', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5192, 'Barra do Bugres', 'MT', NULL, NULL, NULL, 5101704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.385821', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5193, 'Barra do Garcas', 'MT', NULL, NULL, NULL, 5101803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.386784', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5194, 'Bom Jesus do Araguaia', 'MT', NULL, NULL, NULL, 5101852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.387912', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5195, 'Brasnorte', 'MT', NULL, NULL, NULL, 5101902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.395783', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5196, 'Caceres', 'MT', NULL, NULL, NULL, 5102504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.396886', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5197, 'Campinapolis', 'MT', NULL, NULL, NULL, 5102603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.397801', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5198, 'Campo Novo do Parecis', 'MT', NULL, NULL, NULL, 5102637, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.398624', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5199, 'Campo Verde', 'MT', NULL, NULL, NULL, 5102678, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.399594', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5200, 'Campos de Julio', 'MT', NULL, NULL, NULL, 5102686, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.400449', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5201, 'Canabrava do Norte', 'MT', NULL, NULL, NULL, 5102694, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.401301', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5202, 'Canarana', 'MT', NULL, NULL, NULL, 5102702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.402031', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5203, 'Carlinda', 'MT', NULL, NULL, NULL, 5102793, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.403458', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5204, 'Castanheira', 'MT', NULL, NULL, NULL, 5102850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.404495', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5205, 'Chapada dos Guimaraes', 'MT', NULL, NULL, NULL, 5103007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.405573', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5206, 'Claudia', 'MT', NULL, NULL, NULL, 5103056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.406653', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5207, 'Cocalinho', 'MT', NULL, NULL, NULL, 5103106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.407608', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5208, 'Colider', 'MT', NULL, NULL, NULL, 5103205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.408507', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5209, 'Colniza', 'MT', NULL, NULL, NULL, 5103254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.409412', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5210, 'Comodoro', 'MT', NULL, NULL, NULL, 5103304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.410397', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5211, 'Confresa', 'MT', NULL, NULL, NULL, 5103353, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.411332', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5212, 'Conquista D''oeste', 'MT', NULL, NULL, NULL, 5103361, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.412235', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5213, 'Cotriguacu', 'MT', NULL, NULL, NULL, 5103379, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.413221', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5214, 'Cuiaba', 'MT', NULL, NULL, NULL, 5103403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.414149', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5216, 'Denise', 'MT', NULL, NULL, NULL, 5103452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.416081', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5217, 'Diamantino', 'MT', NULL, NULL, NULL, 5103502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.417014', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5218, 'Dom Aquino', 'MT', NULL, NULL, NULL, 5103601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.417947', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5219, 'Feliz Natal', 'MT', NULL, NULL, NULL, 5103700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.418926', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5220, 'Figueiropolis D''oeste', 'MT', NULL, NULL, NULL, 5103809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.419849', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5221, 'Gaucha do Norte', 'MT', NULL, NULL, NULL, 5103858, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.4207', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5222, 'General Carneiro', 'MT', NULL, NULL, NULL, 5103908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.421639', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5223, 'Gloria D''oeste', 'MT', NULL, NULL, NULL, 5103957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.422532', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5224, 'Guaranta do Norte', 'MT', NULL, NULL, NULL, 5104104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.423784', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5225, 'Guiratinga', 'MT', NULL, NULL, NULL, 5104203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.424887', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5226, 'Indiavai', 'MT', NULL, NULL, NULL, 5104500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.425733', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5227, 'Ipiranga do Norte', 'MT', NULL, NULL, NULL, 5104526, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.426779', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5228, 'Itanhanga', 'MT', NULL, NULL, NULL, 5104542, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.427777', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5229, 'Itauba', 'MT', NULL, NULL, NULL, 5104559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.42877', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5230, 'Itiquira', 'MT', NULL, NULL, NULL, 5104609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.429726', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5231, 'Jaciara', 'MT', NULL, NULL, NULL, 5104807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.436354', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5232, 'Jangada', 'MT', NULL, NULL, NULL, 5104906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.437631', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5233, 'Jauru', 'MT', NULL, NULL, NULL, 5105002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.438623', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5234, 'Juara', 'MT', NULL, NULL, NULL, 5105101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.439558', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5235, 'Juina', 'MT', NULL, NULL, NULL, 5105150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.440473', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5236, 'Juruena', 'MT', NULL, NULL, NULL, 5105176, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.441383', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5237, 'Juscimeira', 'MT', NULL, NULL, NULL, 5105200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.442317', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5238, 'Lambari D''oeste', 'MT', NULL, NULL, NULL, 5105234, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.443327', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5239, 'Lucas do Rio Verde', 'MT', NULL, NULL, NULL, 5105259, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.444223', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5240, 'Luciara', 'MT', NULL, NULL, NULL, 5105309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.445157', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5316, 'Vila Bela da Santissima Trindade', 'MT', NULL, NULL, NULL, 5105507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.528916', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5241, 'Marcelandia', 'MT', NULL, NULL, NULL, 5105580, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.446077', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5242, 'Matupa', 'MT', NULL, NULL, NULL, 5105606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.447134', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5243, 'Mirassol D''oeste', 'MT', NULL, NULL, NULL, 5105622, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.448029', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5244, 'Nobres', 'MT', NULL, NULL, NULL, 5105903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.448969', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5245, 'Nortelandia', 'MT', NULL, NULL, NULL, 5106000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.449889', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5246, 'Nossa Senhora do Livramento', 'MT', NULL, NULL, NULL, 5106109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.450756', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5247, 'Nova Bandeirantes', 'MT', NULL, NULL, NULL, 5106158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.451561', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5256, 'Nova Nazare', 'MT', NULL, NULL, NULL, 5106174, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.459757', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5251, 'Nova Lacerda', 'MT', NULL, NULL, NULL, 5106182, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.455047', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5258, 'Nova Santa Helena', 'MT', NULL, NULL, NULL, 5106190, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.461782', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5248, 'Nova Brasilandia', 'MT', NULL, NULL, NULL, 5106208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.452363', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5249, 'Nova Canaa do Norte', 'MT', NULL, NULL, NULL, 5106216, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.453308', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5255, 'Nova Mutum', 'MT', NULL, NULL, NULL, 5106224, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.458788', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5257, 'Nova Olimpia', 'MT', NULL, NULL, NULL, 5106232, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.460794', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5259, 'Nova Ubirata', 'MT', NULL, NULL, NULL, 5106240, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.462711', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5260, 'Nova Xavantina', 'MT', NULL, NULL, NULL, 5106257, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.463694', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5262, 'Novo Mundo', 'MT', NULL, NULL, NULL, 5106265, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.465458', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5261, 'Novo Horizonte do Norte', 'MT', NULL, NULL, NULL, 5106273, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.464598', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5264, 'Novo Sao Joaquim', 'MT', NULL, NULL, NULL, 5106281, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.467249', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5265, 'Paranaita', 'MT', NULL, NULL, NULL, 5106299, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.468084', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5266, 'Paranatinga', 'MT', NULL, NULL, NULL, 5106307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.469197', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5263, 'Novo Santo Antonio', 'MT', NULL, NULL, NULL, 5106315, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.466329', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5267, 'Pedra Preta', 'MT', NULL, NULL, NULL, 5106372, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.470265', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5268, 'Peixoto de Azevedo', 'MT', NULL, NULL, NULL, 5106422, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.471267', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5269, 'Planalto da Serra', 'MT', NULL, NULL, NULL, 5106455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.477744', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5270, 'Pocone', 'MT', NULL, NULL, NULL, 5106505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.478832', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5271, 'Pontal do Araguaia', 'MT', NULL, NULL, NULL, 5106653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.479747', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5272, 'Ponte Branca', 'MT', NULL, NULL, NULL, 5106703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.480811', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5273, 'Pontes e Lacerda', 'MT', NULL, NULL, NULL, 5106752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.481784', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5274, 'Porto Alegre do Norte', 'MT', NULL, NULL, NULL, 5106778, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.482693', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5275, 'Porto dos Gauchos', 'MT', NULL, NULL, NULL, 5106802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.483624', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5276, 'Porto Esperidiao', 'MT', NULL, NULL, NULL, 5106828, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.484579', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5277, 'Porto Estrela', 'MT', NULL, NULL, NULL, 5106851, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.485413', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5279, 'Primavera do Leste', 'MT', NULL, NULL, NULL, 5107040, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.487239', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5280, 'Querencia', 'MT', NULL, NULL, NULL, 5107065, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.48811', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5300, 'Sao Jose dos Quatro Marcos', 'MT', NULL, NULL, NULL, 5107107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.506858', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5281, 'Reserva do Cabacal', 'MT', NULL, NULL, NULL, 5107156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.489033', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5282, 'Ribeirao Cascalheira', 'MT', NULL, NULL, NULL, 5107180, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.489983', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5283, 'Ribeiraozinho', 'MT', NULL, NULL, NULL, 5107198, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.490955', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5284, 'Rio Branco', 'MT', NULL, NULL, NULL, 5107206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.491842', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5289, 'Santa Carmem', 'MT', NULL, NULL, NULL, 5107248, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.496894', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5293, 'Santo Afonso', 'MT', NULL, NULL, NULL, 5107263, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.50045', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5297, 'Sao Jose do Povo', 'MT', NULL, NULL, NULL, 5107297, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.504015', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5298, 'Sao Jose do Rio Claro', 'MT', NULL, NULL, NULL, 5107305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.504954', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5299, 'Sao Jose do Xingu', 'MT', NULL, NULL, NULL, 5107354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.505931', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5301, 'Sao Pedro da Cipa', 'MT', NULL, NULL, NULL, 5107404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.507799', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5285, 'Rondolandia', 'MT', NULL, NULL, NULL, 5107578, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.492869', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5286, 'Rondonopolis', 'MT', NULL, NULL, NULL, 5107602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.493854', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5287, 'Rosario Oeste', 'MT', NULL, NULL, NULL, 5107701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.494826', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5290, 'Santa Cruz do Xingu', 'MT', NULL, NULL, NULL, 5107743, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.497687', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5288, 'Salto do Ceu', 'MT', NULL, NULL, NULL, 5107750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.495786', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5291, 'Santa Rita do Trivelato', 'MT', NULL, NULL, NULL, 5107768, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.498595', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5292, 'Santa Terezinha', 'MT', NULL, NULL, NULL, 5107776, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.499475', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5294, 'Santo Antonio do Leste', 'MT', NULL, NULL, NULL, 5107792, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.50133', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5295, 'Santo Antonio do Leverger', 'MT', NULL, NULL, NULL, 5107800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.502127', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5296, 'Sao Felix do Araguaia', 'MT', NULL, NULL, NULL, 5107859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.503103', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5302, 'Sapezal', 'MT', NULL, NULL, NULL, 5107875, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.508718', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5303, 'Serra Nova Dourada', 'MT', NULL, NULL, NULL, 5107883, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.509707', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5304, 'Sinop', 'MT', NULL, NULL, NULL, 5107909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.510666', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5305, 'Sorriso', 'MT', NULL, NULL, NULL, 5107925, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.51148', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5306, 'Tabapora', 'MT', NULL, NULL, NULL, 5107941, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.51804', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5307, 'Tangara da Serra', 'MT', NULL, NULL, NULL, 5107958, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.51929', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5308, 'Tapurah', 'MT', NULL, NULL, NULL, 5108006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.520225', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5309, 'Terra Nova do Norte', 'MT', NULL, NULL, NULL, 5108055, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.521047', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5310, 'Tesouro', 'MT', NULL, NULL, NULL, 5108105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.521974', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5311, 'Torixoreu', 'MT', NULL, NULL, NULL, 5108204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.52294', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5312, 'Uniao do Sul', 'MT', NULL, NULL, NULL, 5108303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.523883', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5313, 'Vale de Sao Domingos', 'MT', NULL, NULL, NULL, 5108352, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.524972', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5314, 'Varzea Grande', 'MT', NULL, NULL, NULL, 5108402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.526086', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5315, 'Vera', 'MT', NULL, NULL, NULL, 5108501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.526999', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5317, 'Vila Rica', 'MT', NULL, NULL, NULL, 5108600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.530101', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5250, 'Nova Guarita', 'MT', NULL, NULL, NULL, 5108808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.45418', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5252, 'Nova Marilandia', 'MT', NULL, NULL, NULL, 5108857, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.455908', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5253, 'Nova Maringa', 'MT', NULL, NULL, NULL, 5108907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.456789', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5254, 'Nova Monte Verde', 'MT', NULL, NULL, NULL, 5108956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.457859', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5318, 'Abadia de Goias', 'GO', NULL, NULL, NULL, 5200050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.531009', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5319, 'Abadiania', 'GO', NULL, NULL, NULL, 5200100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.53199', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5320, 'Acreuna', 'GO', NULL, NULL, NULL, 5200134, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.532886', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5321, 'Adelandia', 'GO', NULL, NULL, NULL, 5200159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.533668', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5322, 'Agua Fria de Goias', 'GO', NULL, NULL, NULL, 5200175, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.534826', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5323, 'Agua Limpa', 'GO', NULL, NULL, NULL, 5200209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.535749', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5324, 'Aguas Lindas de Goias', 'GO', NULL, NULL, NULL, 5200258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.53668', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5325, 'Alexania', 'GO', NULL, NULL, NULL, 5200308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.537739', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5326, 'Aloandia', 'GO', NULL, NULL, NULL, 5200506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.53862', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5327, 'Alto Horizonte', 'GO', NULL, NULL, NULL, 5200555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.539517', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5328, 'Alto Paraiso de Goias', 'GO', NULL, NULL, NULL, 5200605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.540454', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5329, 'Alvorada do Norte', 'GO', NULL, NULL, NULL, 5200803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.541418', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5330, 'Amaralina', 'GO', NULL, NULL, NULL, 5200829, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.542313', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5331, 'Americano do Brasil', 'GO', NULL, NULL, NULL, 5200852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.543192', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5332, 'Amorinopolis', 'GO', NULL, NULL, NULL, 5200902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.544118', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5333, 'Anapolis', 'GO', NULL, NULL, NULL, 5201108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.544995', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5334, 'Anhanguera', 'GO', NULL, NULL, NULL, 5201207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.545877', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5335, 'Anicuns', 'GO', NULL, NULL, NULL, 5201306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.54685', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5336, 'Aparecida de Goiania', 'GO', NULL, NULL, NULL, 5201405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.547789', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5337, 'Aparecida do Rio Doce', 'GO', NULL, NULL, NULL, 5201454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.548635', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5338, 'Apore', 'GO', NULL, NULL, NULL, 5201504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.549452', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5339, 'Aracu', 'GO', NULL, NULL, NULL, 5201603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.550511', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5340, 'Aragarcas', 'GO', NULL, NULL, NULL, 5201702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.551456', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5341, 'Aragoiania', 'GO', NULL, NULL, NULL, 5201801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.558409', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5342, 'Araguapaz', 'GO', NULL, NULL, NULL, 5202155, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.559799', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5343, 'Arenopolis', 'GO', NULL, NULL, NULL, 5202353, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.5608', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5344, 'Aruana', 'GO', NULL, NULL, NULL, 5202502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.561736', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5345, 'Aurilandia', 'GO', NULL, NULL, NULL, 5202601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.562641', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5346, 'Avelinopolis', 'GO', NULL, NULL, NULL, 5202809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.563516', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5347, 'Baliza', 'GO', NULL, NULL, NULL, 5203104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.564819', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5348, 'Barro Alto', 'GO', NULL, NULL, NULL, 5203203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.56604', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5349, 'Bela Vista de Goias', 'GO', NULL, NULL, NULL, 5203302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.566961', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5350, 'Bom Jardim de Goias', 'GO', NULL, NULL, NULL, 5203401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.567928', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5351, 'Bom Jesus de Goias', 'GO', NULL, NULL, NULL, 5203500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.568869', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5352, 'Bonfinopolis', 'GO', NULL, NULL, NULL, 5203559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.569784', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5353, 'Bonopolis', 'GO', NULL, NULL, NULL, 5203575, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.570757', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5354, 'Brazabrantes', 'GO', NULL, NULL, NULL, 5203609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.571611', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5355, 'Britania', 'GO', NULL, NULL, NULL, 5203807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.572486', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5356, 'Buriti Alegre', 'GO', NULL, NULL, NULL, 5203906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.57334', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5357, 'Buriti de Goias', 'GO', NULL, NULL, NULL, 5203939, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.57425', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5358, 'Buritinopolis', 'GO', NULL, NULL, NULL, 5203962, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.575213', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5359, 'Cabeceiras', 'GO', NULL, NULL, NULL, 5204003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.57613', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5360, 'Cachoeira Alta', 'GO', NULL, NULL, NULL, 5204102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.577058', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5361, 'Cachoeira de Goias', 'GO', NULL, NULL, NULL, 5204201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.577887', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5362, 'Cachoeira Dourada', 'GO', NULL, NULL, NULL, 5204250, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.578836', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5363, 'Cacu', 'GO', NULL, NULL, NULL, 5204300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.579767', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5364, 'Caiaponia', 'GO', NULL, NULL, NULL, 5204409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.580695', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5365, 'Caldas Novas', 'GO', NULL, NULL, NULL, 5204508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.581988', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5366, 'Caldazinha', 'GO', NULL, NULL, NULL, 5204557, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.582914', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5367, 'Campestre de Goias', 'GO', NULL, NULL, NULL, 5204607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.583775', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5368, 'Campinacu', 'GO', NULL, NULL, NULL, 5204656, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.584712', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5369, 'Campinorte', 'GO', NULL, NULL, NULL, 5204706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.585668', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5370, 'Campo Alegre de Goias', 'GO', NULL, NULL, NULL, 5204805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.586525', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5371, 'Campo Limpo de Goias', 'GO', NULL, NULL, NULL, 5204854, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.587364', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5372, 'Campos Belos', 'GO', NULL, NULL, NULL, 5204904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.588237', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5373, 'Campos Verdes', 'GO', NULL, NULL, NULL, 5204953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.589202', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5374, 'Carmo do Rio Verde', 'GO', NULL, NULL, NULL, 5205000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.590143', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5375, 'Castelandia', 'GO', NULL, NULL, NULL, 5205059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.591002', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5376, 'Catalao', 'GO', NULL, NULL, NULL, 5205109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.592188', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5377, 'Caturai', 'GO', NULL, NULL, NULL, 5205208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.603004', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5378, 'Cavalcante', 'GO', NULL, NULL, NULL, 5205307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.604319', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5379, 'Ceres', 'GO', NULL, NULL, NULL, 5205406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.605372', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5380, 'Cezarina', 'GO', NULL, NULL, NULL, 5205455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.606325', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5381, 'Chapadao do Ceu', 'GO', NULL, NULL, NULL, 5205471, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.607336', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5382, 'Cidade Ocidental', 'GO', NULL, NULL, NULL, 5205497, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.608275', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5383, 'Cocalzinho de Goias', 'GO', NULL, NULL, NULL, 5205513, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.609119', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5384, 'Colinas do Sul', 'GO', NULL, NULL, NULL, 5205521, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.609959', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5385, 'Corrego do Ouro', 'GO', NULL, NULL, NULL, 5205703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.610872', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5386, 'Corumba de Goias', 'GO', NULL, NULL, NULL, 5205802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.611794', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5387, 'Corumbaiba', 'GO', NULL, NULL, NULL, 5205901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.612763', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5388, 'Cristalina', 'GO', NULL, NULL, NULL, 5206206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.613699', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5389, 'Cristianopolis', 'GO', NULL, NULL, NULL, 5206305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.614727', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5390, 'Crixas', 'GO', NULL, NULL, NULL, 5206404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.615553', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5391, 'Crominia', 'GO', NULL, NULL, NULL, 5206503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.616462', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5392, 'Cumari', 'GO', NULL, NULL, NULL, 5206602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.61735', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5393, 'Damianopolis', 'GO', NULL, NULL, NULL, 5206701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.618249', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5394, 'Damolandia', 'GO', NULL, NULL, NULL, 5206800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.619199', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5395, 'Davinopolis', 'GO', NULL, NULL, NULL, 5206909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.620154', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5396, 'Diorama', 'GO', NULL, NULL, NULL, 5207105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.621073', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5398, 'Doverlandia', 'GO', NULL, NULL, NULL, 5207253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.623068', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5399, 'Edealina', 'GO', NULL, NULL, NULL, 5207352, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.623962', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5400, 'Edeia', 'GO', NULL, NULL, NULL, 5207402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.624932', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5401, 'Estrela do Norte', 'GO', NULL, NULL, NULL, 5207501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.625947', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5402, 'Faina', 'GO', NULL, NULL, NULL, 5207535, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.626774', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5403, 'Fazenda Nova', 'GO', NULL, NULL, NULL, 5207600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.627692', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5404, 'Firminopolis', 'GO', NULL, NULL, NULL, 5207808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.628612', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5405, 'Flores de Goias', 'GO', NULL, NULL, NULL, 5207907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.629589', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5406, 'Formosa', 'GO', NULL, NULL, NULL, 5208004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.630429', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5407, 'Formoso', 'GO', NULL, NULL, NULL, 5208103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.631268', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5408, 'Gameleira de Goias', 'GO', NULL, NULL, NULL, 5208152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.632204', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5397, 'Divinopolis de Goias', 'GO', NULL, NULL, NULL, 5208301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.622032', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5409, 'Goianapolis', 'GO', NULL, NULL, NULL, 5208400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.633039', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5410, 'Goiandira', 'GO', NULL, NULL, NULL, 5208509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.633983', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5411, 'Goianesia', 'GO', NULL, NULL, NULL, 5208608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.634918', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5412, 'Goiania', 'GO', NULL, NULL, NULL, 5208707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.635858', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5413, 'Goianira', 'GO', NULL, NULL, NULL, 5208806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.636781', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5414, 'Goias', 'GO', NULL, NULL, NULL, 5208905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.643396', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5415, 'Goiatuba', 'GO', NULL, NULL, NULL, 5209101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.644646', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5416, 'Gouvelandia', 'GO', NULL, NULL, NULL, 5209150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.645672', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5417, 'Guapo', 'GO', NULL, NULL, NULL, 5209200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.646555', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5418, 'Guaraita', 'GO', NULL, NULL, NULL, 5209291, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.647553', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5419, 'Guarani de Goias', 'GO', NULL, NULL, NULL, 5209408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.648866', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5420, 'Guarinos', 'GO', NULL, NULL, NULL, 5209457, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.649863', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5421, 'Heitorai', 'GO', NULL, NULL, NULL, 5209606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.650692', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5422, 'Hidrolandia', 'GO', NULL, NULL, NULL, 5209705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.651434', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5423, 'Hidrolina', 'GO', NULL, NULL, NULL, 5209804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.65227', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5424, 'Iaciara', 'GO', NULL, NULL, NULL, 5209903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.653174', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5425, 'Inaciolandia', 'GO', NULL, NULL, NULL, 5209937, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.654174', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5426, 'Indiara', 'GO', NULL, NULL, NULL, 5209952, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.655008', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5427, 'Inhumas', 'GO', NULL, NULL, NULL, 5210000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.655851', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5428, 'Ipameri', 'GO', NULL, NULL, NULL, 5210109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.656848', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5429, 'Ipiranga de Goias', 'GO', NULL, NULL, NULL, 5210158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.657863', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5430, 'Ipora', 'GO', NULL, NULL, NULL, 5210208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.658736', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5431, 'Israelandia', 'GO', NULL, NULL, NULL, 5210307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.659837', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5432, 'Itaberai', 'GO', NULL, NULL, NULL, 5210406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.660714', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5433, 'Itaguari', 'GO', NULL, NULL, NULL, 5210562, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.66169', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5434, 'Itaguaru', 'GO', NULL, NULL, NULL, 5210604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.662571', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5435, 'Itaja', 'GO', NULL, NULL, NULL, 5210802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.663372', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5436, 'Itapaci', 'GO', NULL, NULL, NULL, 5210901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.664184', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5437, 'Itapirapua', 'GO', NULL, NULL, NULL, 5211008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.665155', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5438, 'Itapuranga', 'GO', NULL, NULL, NULL, 5211206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.666064', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5439, 'Itaruma', 'GO', NULL, NULL, NULL, 5211305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.666945', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5440, 'Itaucu', 'GO', NULL, NULL, NULL, 5211404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.667766', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5441, 'Itumbiara', 'GO', NULL, NULL, NULL, 5211503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.668731', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5442, 'Ivolandia', 'GO', NULL, NULL, NULL, 5211602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.669617', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5443, 'Jandaia', 'GO', NULL, NULL, NULL, 5211701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.670602', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5444, 'Jaragua', 'GO', NULL, NULL, NULL, 5211800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.671381', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5445, 'Jatai', 'GO', NULL, NULL, NULL, 5211909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.672203', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5446, 'Jaupaci', 'GO', NULL, NULL, NULL, 5212006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.673077', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5447, 'Jesupolis', 'GO', NULL, NULL, NULL, 5212055, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.67413', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5448, 'Joviania', 'GO', NULL, NULL, NULL, 5212105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.675038', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5449, 'Jussara', 'GO', NULL, NULL, NULL, 5212204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.675958', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5450, 'Lagoa Santa', 'GO', NULL, NULL, NULL, 5212253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.676927', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5451, 'Leopoldo de Bulhoes', 'GO', NULL, NULL, NULL, 5212303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.687916', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5452, 'Luziania', 'GO', NULL, NULL, NULL, 5212501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.689054', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5453, 'Mairipotaba', 'GO', NULL, NULL, NULL, 5212600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.689933', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5454, 'Mambai', 'GO', NULL, NULL, NULL, 5212709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.69083', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5455, 'Mara Rosa', 'GO', NULL, NULL, NULL, 5212808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.691716', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5456, 'Marzagao', 'GO', NULL, NULL, NULL, 5212907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.692635', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5457, 'Matrincha', 'GO', NULL, NULL, NULL, 5212956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.693504', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5458, 'Maurilandia', 'GO', NULL, NULL, NULL, 5213004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.694336', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5459, 'Mimoso de Goias', 'GO', NULL, NULL, NULL, 5213053, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.695216', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5460, 'Minacu', 'GO', NULL, NULL, NULL, 5213087, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.696172', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5461, 'Mineiros', 'GO', NULL, NULL, NULL, 5213103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.697089', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5462, 'Moipora', 'GO', NULL, NULL, NULL, 5213400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.698025', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5463, 'Monte Alegre de Goias', 'GO', NULL, NULL, NULL, 5213509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.69892', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5464, 'Montes Claros de Goias', 'GO', NULL, NULL, NULL, 5213707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.699882', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5465, 'Montividiu', 'GO', NULL, NULL, NULL, 5213756, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.700799', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5466, 'Montividiu do Norte', 'GO', NULL, NULL, NULL, 5213772, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.701715', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5467, 'Morrinhos', 'GO', NULL, NULL, NULL, 5213806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.702638', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5468, 'Morro Agudo de Goias', 'GO', NULL, NULL, NULL, 5213855, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.703663', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5469, 'Mossamedes', 'GO', NULL, NULL, NULL, 5213905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.704418', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5470, 'Mozarlandia', 'GO', NULL, NULL, NULL, 5214002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.705276', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5471, 'Mundo Novo', 'GO', NULL, NULL, NULL, 5214051, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.706025', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5472, 'Mutunopolis', 'GO', NULL, NULL, NULL, 5214101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.706843', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5473, 'Nazario', 'GO', NULL, NULL, NULL, 5214408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.707701', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5474, 'Neropolis', 'GO', NULL, NULL, NULL, 5214507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.708646', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5475, 'Niquelandia', 'GO', NULL, NULL, NULL, 5214606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.709625', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5476, 'Nova America', 'GO', NULL, NULL, NULL, 5214705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.710551', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5477, 'Nova Aurora', 'GO', NULL, NULL, NULL, 5214804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.711502', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5478, 'Nova Crixas', 'GO', NULL, NULL, NULL, 5214838, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.712452', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5479, 'Nova Gloria', 'GO', NULL, NULL, NULL, 5214861, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.713407', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5480, 'Nova Iguacu de Goias', 'GO', NULL, NULL, NULL, 5214879, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.714282', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5481, 'Nova Roma', 'GO', NULL, NULL, NULL, 5214903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.715252', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5482, 'Nova Veneza', 'GO', NULL, NULL, NULL, 5215009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.716088', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5483, 'Novo Brasil', 'GO', NULL, NULL, NULL, 5215207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.717048', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5484, 'Novo Gama', 'GO', NULL, NULL, NULL, 5215231, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.71804', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5485, 'Novo Planalto', 'GO', NULL, NULL, NULL, 5215256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.718969', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5486, 'Orizona', 'GO', NULL, NULL, NULL, 5215306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.71987', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5487, 'Ouro Verde de Goias', 'GO', NULL, NULL, NULL, 5215405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.720782', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5488, 'Ouvidor', 'GO', NULL, NULL, NULL, 5215504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.721647', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5489, 'Padre Bernardo', 'GO', NULL, NULL, NULL, 5215603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.730377', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5490, 'Palestina de Goias', 'GO', NULL, NULL, NULL, 5215652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.731494', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5491, 'Palmeiras de Goias', 'GO', NULL, NULL, NULL, 5215702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.732416', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5492, 'Palmelo', 'GO', NULL, NULL, NULL, 5215801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.733286', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5493, 'Palminopolis', 'GO', NULL, NULL, NULL, 5215900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.734292', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5494, 'Panama', 'GO', NULL, NULL, NULL, 5216007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.735177', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5495, 'Paranaiguara', 'GO', NULL, NULL, NULL, 5216304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.736027', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5496, 'Parauna', 'GO', NULL, NULL, NULL, 5216403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.736912', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5497, 'Perolandia', 'GO', NULL, NULL, NULL, 5216452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.738016', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5498, 'Petrolina de Goias', 'GO', NULL, NULL, NULL, 5216809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.738872', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5499, 'Pilar de Goias', 'GO', NULL, NULL, NULL, 5216908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.739682', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5500, 'Piracanjuba', 'GO', NULL, NULL, NULL, 5217104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.740598', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5501, 'Piranhas', 'GO', NULL, NULL, NULL, 5217203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.741497', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5502, 'Pirenopolis', 'GO', NULL, NULL, NULL, 5217302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.742364', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5503, 'Pires do Rio', 'GO', NULL, NULL, NULL, 5217401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.743286', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5504, 'Planaltina', 'GO', NULL, NULL, NULL, 5217609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.744194', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5505, 'Pontalina', 'GO', NULL, NULL, NULL, 5217708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.745138', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5506, 'Porangatu', 'GO', NULL, NULL, NULL, 5218003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.746057', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5507, 'Porteirao', 'GO', NULL, NULL, NULL, 5218052, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.746977', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5508, 'Portelandia', 'GO', NULL, NULL, NULL, 5218102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.747798', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5509, 'Posse', 'GO', NULL, NULL, NULL, 5218300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.74865', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5510, 'Professor Jamil', 'GO', NULL, NULL, NULL, 5218391, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.749443', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5511, 'Quirinopolis', 'GO', NULL, NULL, NULL, 5218508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.606333', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5512, 'Rialma', 'GO', NULL, NULL, NULL, 5218607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.339363', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5513, 'Rianapolis', 'GO', NULL, NULL, NULL, 5218706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.527984', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5514, 'Rio Quente', 'GO', NULL, NULL, NULL, 5218789, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.750281', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5515, 'Rio Verde', 'GO', NULL, NULL, NULL, 5218805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.75147', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5516, 'Rubiataba', 'GO', NULL, NULL, NULL, 5218904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.752375', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5517, 'Sanclerlandia', 'GO', NULL, NULL, NULL, 5219001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.75327', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5518, 'Santa Barbara de Goias', 'GO', NULL, NULL, NULL, 5219100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.754126', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5519, 'Santa Cruz de Goias', 'GO', NULL, NULL, NULL, 5219209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.754942', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5520, 'Santa Fe de Goias', 'GO', NULL, NULL, NULL, 5219258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.755933', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5521, 'Santa Helena de Goias', 'GO', NULL, NULL, NULL, 5219308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.756965', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5522, 'Santa Isabel', 'GO', NULL, NULL, NULL, 5219357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.757965', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5523, 'Santa Rita do Araguaia', 'GO', NULL, NULL, NULL, 5219407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.758958', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5524, 'Santa Rita do Novo Destino', 'GO', NULL, NULL, NULL, 5219456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.759916', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5525, 'Santa Rosa de Goias', 'GO', NULL, NULL, NULL, 5219506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.760746', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5526, 'Santa Tereza de Goias', 'GO', NULL, NULL, NULL, 5219605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.76171', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5527, 'Santa Terezinha de Goias', 'GO', NULL, NULL, NULL, 5219704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.762654', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5528, 'Santo Antonio da Barra', 'GO', NULL, NULL, NULL, 5219712, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.763614', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5529, 'Santo Antonio de Goias', 'GO', NULL, NULL, NULL, 5219738, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.764441', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5530, 'Santo Antonio do Descoberto', 'GO', NULL, NULL, NULL, 5219753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.771458', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5531, 'Sao Domingos', 'GO', NULL, NULL, NULL, 5219803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.77252', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5532, 'Sao Francisco de Goias', 'GO', NULL, NULL, NULL, 5219902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.773455', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5534, 'Sao Joao D''alianca', 'GO', NULL, NULL, NULL, 5220009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.775239', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5533, 'Sao Joao da Parauna', 'GO', NULL, NULL, NULL, 5220058, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.774354', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5535, 'Sao Luis de Montes Belos', 'GO', NULL, NULL, NULL, 5220108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.77614', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5536, 'Sao Luiz do Norte', 'GO', NULL, NULL, NULL, 5220157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.776981', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5537, 'Sao Miguel do Araguaia', 'GO', NULL, NULL, NULL, 5220207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.777896', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5538, 'Sao Miguel do Passa Quatro', 'GO', NULL, NULL, NULL, 5220264, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.778808', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5539, 'Sao Patricio', 'GO', NULL, NULL, NULL, 5220280, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.779725', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5540, 'Sao Simao', 'GO', NULL, NULL, NULL, 5220405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.780665', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5541, 'Senador Canedo', 'GO', NULL, NULL, NULL, 5220454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.7816', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5542, 'Serranopolis', 'GO', NULL, NULL, NULL, 5220504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.78277', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5543, 'Silvania', 'GO', NULL, NULL, NULL, 5220603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.783748', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5544, 'Simolandia', 'GO', NULL, NULL, NULL, 5220686, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.784751', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5545, 'Sitio D''abadia', 'GO', NULL, NULL, NULL, 5220702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.785701', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5546, 'Taquaral de Goias', 'GO', NULL, NULL, NULL, 5221007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.786631', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5547, 'Teresina de Goias', 'GO', NULL, NULL, NULL, 5221080, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.787611', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5548, 'Terezopolis de Goias', 'GO', NULL, NULL, NULL, 5221197, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.788494', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5549, 'Tres Ranchos', 'GO', NULL, NULL, NULL, 5221304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.789421', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5550, 'Trindade', 'GO', NULL, NULL, NULL, 5221403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.790358', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5551, 'Trombas', 'GO', NULL, NULL, NULL, 5221452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.791247', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5552, 'Turvania', 'GO', NULL, NULL, NULL, 5221502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.792226', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5553, 'Turvelandia', 'GO', NULL, NULL, NULL, 5221551, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.793204', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5554, 'Uirapuru', 'GO', NULL, NULL, NULL, 5221577, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.794106', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5555, 'Uruacu', 'GO', NULL, NULL, NULL, 5221601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.795058', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5556, 'Uruana', 'GO', NULL, NULL, NULL, 5221700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.796026', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5557, 'Urutai', 'GO', NULL, NULL, NULL, 5221809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.796933', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5558, 'Valparaiso de Goias', 'GO', NULL, NULL, NULL, 5221858, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.797818', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5559, 'Varjao', 'GO', NULL, NULL, NULL, 5221908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.798714', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5560, 'Vianopolis', 'GO', NULL, NULL, NULL, 5222005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.799587', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5561, 'Vicentinopolis', 'GO', NULL, NULL, NULL, 5222054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.800364', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5562, 'Vila Boa', 'GO', NULL, NULL, NULL, 5222203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.801199', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5563, 'Vila Propicio', 'GO', NULL, NULL, NULL, 5222302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.802078', 'M', 'I', NULL, 9);
INSERT INTO public.municipio VALUES (5564, 'Brasilia', 'DF', NULL, NULL, NULL, 5300108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.80332', 'M', 'I', NULL, 9);


--
-- TOC entry 8101 (class 0 OID 9445653)
-- Dependencies: 814
-- Data for Name: pais; Type: TABLE DATA; Schema: public; Owner: -
--

INSERT INTO public.pais VALUES (1, 'Abissínia', NULL, NULL);
INSERT INTO public.pais VALUES (2, 'Açores', NULL, NULL);
INSERT INTO public.pais VALUES (3, 'Afar Francês', NULL, NULL);
INSERT INTO public.pais VALUES (7, 'Alto Volta', NULL, NULL);
INSERT INTO public.pais VALUES (10, 'Antártica Francesa', NULL, NULL);
INSERT INTO public.pais VALUES (11, 'Antártico Argentino', NULL, NULL);
INSERT INTO public.pais VALUES (12, 'Antártico Britânico, Território', NULL, NULL);
INSERT INTO public.pais VALUES (13, 'Antártico Chileno', NULL, NULL);
INSERT INTO public.pais VALUES (14, 'Antártico Noruegues', NULL, NULL);
INSERT INTO public.pais VALUES (15, 'Antígua E. Dep. Barbuda', NULL, NULL);
INSERT INTO public.pais VALUES (22, 'Arquipélago de Bismark', NULL, NULL);
INSERT INTO public.pais VALUES (23, 'Arquipélago Manahiki', NULL, NULL);
INSERT INTO public.pais VALUES (24, 'Arquipélago Midway', NULL, NULL);
INSERT INTO public.pais VALUES (26, 'Ascensão e Tristão da Cunha,is', NULL, NULL);
INSERT INTO public.pais VALUES (27, 'Ashmore e Cartier', NULL, NULL);
INSERT INTO public.pais VALUES (34, 'Bashkista', NULL, NULL);
INSERT INTO public.pais VALUES (35, 'Bechuanalândia', NULL, NULL);
INSERT INTO public.pais VALUES (38, 'Benin', NULL, NULL);
INSERT INTO public.pais VALUES (40, 'Bhutan', NULL, NULL);
INSERT INTO public.pais VALUES (41, 'Birmânia', NULL, NULL);
INSERT INTO public.pais VALUES (43, 'Bósnia Herzegovina', NULL, NULL);
INSERT INTO public.pais VALUES (44, 'Botsuana', NULL, NULL);
INSERT INTO public.pais VALUES (48, 'Burkina Fasso', NULL, NULL);
INSERT INTO public.pais VALUES (50, 'Buryat', NULL, NULL);
INSERT INTO public.pais VALUES (54, 'Carélia', NULL, NULL);
INSERT INTO public.pais VALUES (57, 'Ceilão', NULL, NULL);
INSERT INTO public.pais VALUES (58, 'Ceuta e Melilla', NULL, NULL);
INSERT INTO public.pais VALUES (60, 'Chechen Ingusth', NULL, NULL);
INSERT INTO public.pais VALUES (63, 'China (taiwan)', NULL, NULL);
INSERT INTO public.pais VALUES (65, 'Chuvash', NULL, NULL);
INSERT INTO public.pais VALUES (68, 'Comunidade das Bahamas', NULL, NULL);
INSERT INTO public.pais VALUES (69, 'Comunidade Dominicana', NULL, NULL);
INSERT INTO public.pais VALUES (70, 'Congo', NULL, NULL);
INSERT INTO public.pais VALUES (71, 'Coréia', NULL, NULL);
INSERT INTO public.pais VALUES (74, 'Coveite', NULL, NULL);
INSERT INTO public.pais VALUES (78, 'Dagesta', NULL, NULL);
INSERT INTO public.pais VALUES (79, 'Daomé', NULL, NULL);
INSERT INTO public.pais VALUES (80, 'Dependência de Ross', NULL, NULL);
INSERT INTO public.pais VALUES (82, 'Djibuti', NULL, NULL);
INSERT INTO public.pais VALUES (83, 'Eire', NULL, NULL);
INSERT INTO public.pais VALUES (86, 'Escócia', NULL, NULL);
INSERT INTO public.pais VALUES (90, 'Estado da Cidade do Vaticano', NULL, NULL);
INSERT INTO public.pais VALUES (91, 'Estados Assoc. das Antilhas', NULL, NULL);
INSERT INTO public.pais VALUES (100, 'Gaza', NULL, NULL);
INSERT INTO public.pais VALUES (103, 'Gorno Altai', NULL, NULL);
INSERT INTO public.pais VALUES (104, 'Grã-bretanha', NULL, NULL);
INSERT INTO public.pais VALUES (110, 'Guiana Francesa', NULL, NULL);
INSERT INTO public.pais VALUES (112, 'Guiné Bissau', NULL, NULL);
INSERT INTO public.pais VALUES (116, 'Honduras Britânicas', NULL, NULL);
INSERT INTO public.pais VALUES (117, 'Hong-kong', NULL, NULL);
INSERT INTO public.pais VALUES (119, 'Iemen', NULL, NULL);
INSERT INTO public.pais VALUES (120, 'Iemen do Sul', NULL, NULL);
INSERT INTO public.pais VALUES (121, 'Ifni', NULL, NULL);
INSERT INTO public.pais VALUES (122, 'Ilha Johnston e Sand', NULL, NULL);
INSERT INTO public.pais VALUES (123, 'Ilha Milhos', NULL, NULL);
INSERT INTO public.pais VALUES (124, 'Ilhas Baker', NULL, NULL);
INSERT INTO public.pais VALUES (125, 'Ilhas Baleares', NULL, NULL);
INSERT INTO public.pais VALUES (126, 'Ilhas Canárias', NULL, NULL);
INSERT INTO public.pais VALUES (127, 'Ilhas Cantão e Enderburg', NULL, NULL);
INSERT INTO public.pais VALUES (128, 'Ilhas Carolinas', NULL, NULL);
INSERT INTO public.pais VALUES (129, 'Ilhas Christmas', NULL, NULL);
INSERT INTO public.pais VALUES (130, 'Ilhas Comores', NULL, NULL);
INSERT INTO public.pais VALUES (132, 'Ilhas Cosmoledo (lomores)', NULL, NULL);
INSERT INTO public.pais VALUES (133, 'Ilhas de Man', NULL, NULL);
INSERT INTO public.pais VALUES (135, 'Ilhas do Pacífico', NULL, NULL);
INSERT INTO public.pais VALUES (136, 'Ilhas Falklands', NULL, NULL);
INSERT INTO public.pais VALUES (137, 'Ilhas Faroes', NULL, NULL);
INSERT INTO public.pais VALUES (138, 'Ilhas Gilbert', NULL, NULL);
INSERT INTO public.pais VALUES (139, 'Ilhas Guadalupe', NULL, NULL);
INSERT INTO public.pais VALUES (140, 'Ilhas Howland e Jarvis', NULL, NULL);
INSERT INTO public.pais VALUES (141, 'Ilhas Kingman Reef', NULL, NULL);
INSERT INTO public.pais VALUES (142, 'Ilhas Linha', NULL, NULL);
INSERT INTO public.pais VALUES (143, 'Ilhas Macdonal e Heard', NULL, NULL);
INSERT INTO public.pais VALUES (144, 'Ilhas Macquaire', NULL, NULL);
INSERT INTO public.pais VALUES (146, 'Ilhas Marianas', NULL, NULL);
INSERT INTO public.pais VALUES (148, 'Ilhas Niue', NULL, NULL);
INSERT INTO public.pais VALUES (149, 'Ilhas Norfolk', NULL, NULL);
INSERT INTO public.pais VALUES (150, 'Ilhas Nova Caledônia', NULL, NULL);
INSERT INTO public.pais VALUES (151, 'Ilhas Novas Hebridas', NULL, NULL);
INSERT INTO public.pais VALUES (152, 'Ilhas Palau', NULL, NULL);
INSERT INTO public.pais VALUES (153, 'Ilhas Páscoa', NULL, NULL);
INSERT INTO public.pais VALUES (154, 'Ilhas Pitcairin', NULL, NULL);
INSERT INTO public.pais VALUES (156, 'Ilhas Santa Cruz', NULL, NULL);
INSERT INTO public.pais VALUES (157, 'Ilhas Serranas', NULL, NULL);
INSERT INTO public.pais VALUES (158, 'Ilhas Tokelau', NULL, NULL);
INSERT INTO public.pais VALUES (159, 'Ilhas Turca', NULL, NULL);
INSERT INTO public.pais VALUES (160, 'Ilhas Turks e Caicos', NULL, NULL);
INSERT INTO public.pais VALUES (163, 'Ilhas Wake', NULL, NULL);
INSERT INTO public.pais VALUES (164, 'Ilhas Wallis e Futuna', NULL, NULL);
INSERT INTO public.pais VALUES (165, 'índia', NULL, NULL);
INSERT INTO public.pais VALUES (167, 'Inglaterra', NULL, NULL);
INSERT INTO public.pais VALUES (171, 'Irlanda do Norte', NULL, NULL);
INSERT INTO public.pais VALUES (175, 'Iugoslávia', NULL, NULL);
INSERT INTO public.pais VALUES (179, 'Kabardino Balkar', NULL, NULL);
INSERT INTO public.pais VALUES (180, 'Kalimatan', NULL, NULL);
INSERT INTO public.pais VALUES (181, 'Kalmir', NULL, NULL);
INSERT INTO public.pais VALUES (182, 'Kara Kalpak', NULL, NULL);
INSERT INTO public.pais VALUES (183, 'Karachaevocherkess', NULL, NULL);
INSERT INTO public.pais VALUES (184, 'Khakass', NULL, NULL);
INSERT INTO public.pais VALUES (185, 'Kmer/camboja', NULL, NULL);
INSERT INTO public.pais VALUES (186, 'Komi', NULL, NULL);
INSERT INTO public.pais VALUES (187, 'Kuwait', NULL, NULL);
INSERT INTO public.pais VALUES (190, 'Letônia', NULL, NULL);
INSERT INTO public.pais VALUES (198, 'Madagascar', NULL, NULL);
INSERT INTO public.pais VALUES (199, 'Madeira', NULL, NULL);
INSERT INTO public.pais VALUES (202, 'Maldivas,is', NULL, NULL);
INSERT INTO public.pais VALUES (204, 'Mari', NULL, NULL);
INSERT INTO public.pais VALUES (207, 'Mascate', NULL, NULL);
INSERT INTO public.pais VALUES (208, 'Maurício', NULL, NULL);
INSERT INTO public.pais VALUES (211, 'Mianma', NULL, NULL);
INSERT INTO public.pais VALUES (216, 'Monte Serrat', NULL, NULL);
INSERT INTO public.pais VALUES (221, 'Nguane', NULL, NULL);
INSERT INTO public.pais VALUES (225, 'Nova Guiné', NULL, NULL);
INSERT INTO public.pais VALUES (227, 'Oman', NULL, NULL);
INSERT INTO public.pais VALUES (228, 'Ossetia Setentrional', NULL, NULL);
INSERT INTO public.pais VALUES (229, 'País de Gales', NULL, NULL);
INSERT INTO public.pais VALUES (230, 'Países Baixos', NULL, NULL);
INSERT INTO public.pais VALUES (233, 'Panamá - Zona do Canal', NULL, NULL);
INSERT INTO public.pais VALUES (234, 'Papua Nova Guiné', NULL, NULL);
INSERT INTO public.pais VALUES (242, 'Praças Norte Africanas', NULL, NULL);
INSERT INTO public.pais VALUES (243, 'Protetor do Sudoeste Africano', NULL, NULL);
INSERT INTO public.pais VALUES (244, 'Quênia', NULL, NULL);
INSERT INTO public.pais VALUES (245, 'Quirguistão', NULL, NULL);
INSERT INTO public.pais VALUES (246, 'Quitasueno', NULL, NULL);
INSERT INTO public.pais VALUES (247, 'República árabe do Egito', NULL, NULL);
INSERT INTO public.pais VALUES (248, 'República Centro Africana', NULL, NULL);
INSERT INTO public.pais VALUES (249, 'República da áfrica do Sul', NULL, NULL);
INSERT INTO public.pais VALUES (250, 'República da Bielorrússia', NULL, NULL);
INSERT INTO public.pais VALUES (251, 'República da Macedônia', NULL, NULL);
INSERT INTO public.pais VALUES (252, 'República de El Salvador', NULL, NULL);
INSERT INTO public.pais VALUES (253, 'República de Fiji', NULL, NULL);
INSERT INTO public.pais VALUES (254, 'República de Malta', NULL, NULL);
INSERT INTO public.pais VALUES (255, 'República do Gabão', NULL, NULL);
INSERT INTO public.pais VALUES (256, 'República do Haiti', NULL, NULL);
INSERT INTO public.pais VALUES (257, 'República do Níger', NULL, NULL);
INSERT INTO public.pais VALUES (259, 'República Guiana', NULL, NULL);
INSERT INTO public.pais VALUES (261, 'Reservado', NULL, NULL);
INSERT INTO public.pais VALUES (262, 'Reservado', NULL, NULL);
INSERT INTO public.pais VALUES (263, 'Reservado', NULL, NULL);
INSERT INTO public.pais VALUES (264, 'Reservado', NULL, NULL);
INSERT INTO public.pais VALUES (265, 'Reunião', NULL, NULL);
INSERT INTO public.pais VALUES (266, 'Rodésia (zimbábwe)', NULL, NULL);
INSERT INTO public.pais VALUES (267, 'Romênia', NULL, NULL);
INSERT INTO public.pais VALUES (268, 'Roncador', NULL, NULL);
INSERT INTO public.pais VALUES (270, 'Ruiquiu,is', NULL, NULL);
INSERT INTO public.pais VALUES (272, 'Saara Espanhol', NULL, NULL);
INSERT INTO public.pais VALUES (273, 'Sabah', NULL, NULL);
INSERT INTO public.pais VALUES (275, 'Samoa Ocidental', NULL, NULL);
INSERT INTO public.pais VALUES (279, 'São Cristóvão', NULL, NULL);
INSERT INTO public.pais VALUES (281, 'São Vicente', NULL, NULL);
INSERT INTO public.pais VALUES (282, 'Sarawak', NULL, NULL);
INSERT INTO public.pais VALUES (284, 'Sequin', NULL, NULL);
INSERT INTO public.pais VALUES (287, 'Seychelles', NULL, NULL);
INSERT INTO public.pais VALUES (289, 'Somália, República', NULL, NULL);
INSERT INTO public.pais VALUES (290, 'Sri-lanka', NULL, NULL);
INSERT INTO public.pais VALUES (291, 'St. Pierre et Miquelon', NULL, NULL);
INSERT INTO public.pais VALUES (297, 'Svalbard e Jan Mayer,is', NULL, NULL);
INSERT INTO public.pais VALUES (298, 'Tadjiquistão', NULL, NULL);
INSERT INTO public.pais VALUES (300, 'Tanganica', NULL, NULL);
INSERT INTO public.pais VALUES (302, 'Tartaria', NULL, NULL);
INSERT INTO public.pais VALUES (303, 'Tchecoslováquia', NULL, NULL);
INSERT INTO public.pais VALUES (304, 'Terr. Antártico da Austrália', NULL, NULL);
INSERT INTO public.pais VALUES (305, 'Terras Austrais', NULL, NULL);
INSERT INTO public.pais VALUES (306, 'Territ. Britânico do Oceano índico', NULL, NULL);
INSERT INTO public.pais VALUES (307, 'Território de Cocos', NULL, NULL);
INSERT INTO public.pais VALUES (308, 'Território de Papua', NULL, NULL);
INSERT INTO public.pais VALUES (309, 'Timor', NULL, NULL);
INSERT INTO public.pais VALUES (312, 'Transkei', NULL, NULL);
INSERT INTO public.pais VALUES (313, 'Trégua, Estado', NULL, NULL);
INSERT INTO public.pais VALUES (319, 'Tuvin', NULL, NULL);
INSERT INTO public.pais VALUES (321, 'Udmurt', NULL, NULL);
INSERT INTO public.pais VALUES (323, 'União Soviética', NULL, NULL);
INSERT INTO public.pais VALUES (327, 'Vietnã do Norte', NULL, NULL);
INSERT INTO public.pais VALUES (328, 'Vietnã do Sul', NULL, NULL);
INSERT INTO public.pais VALUES (329, 'Yakut', NULL, NULL);
INSERT INTO public.pais VALUES (330, 'Zaire', NULL, NULL);
INSERT INTO public.pais VALUES (332, 'Zimbábwe', NULL, NULL);
INSERT INTO public.pais VALUES (73, 'Costa Rica', NULL, 188);
INSERT INTO public.pais VALUES (76, 'Cuba', NULL, 192);
INSERT INTO public.pais VALUES (81, 'Dinamarca', NULL, 208);
INSERT INTO public.pais VALUES (258, 'República Dominicana', NULL, 214);
INSERT INTO public.pais VALUES (113, 'Guiné Equatorial', NULL, 226);
INSERT INTO public.pais VALUES (94, 'Etiópia', NULL, 231);
INSERT INTO public.pais VALUES (106, 'Grécia', NULL, 300);
INSERT INTO public.pais VALUES (118, 'Hungria', NULL, 348);
INSERT INTO public.pais VALUES (166, 'Indonésia', NULL, 360);
INSERT INTO public.pais VALUES (174, 'Itália', NULL, 380);
INSERT INTO public.pais VALUES (192, 'Libéria', NULL, 430);
INSERT INTO public.pais VALUES (195, 'Lituânia', NULL, 440);
INSERT INTO public.pais VALUES (200, 'Malásia', NULL, 458);
INSERT INTO public.pais VALUES (209, 'Mauritânia', NULL, 478);
INSERT INTO public.pais VALUES (210, 'México', NULL, 484);
INSERT INTO public.pais VALUES (214, 'Mônaco', NULL, 492);
INSERT INTO public.pais VALUES (4, 'Afeganistão', NULL, 4);
INSERT INTO public.pais VALUES (5, 'Albânia', NULL, 8);
INSERT INTO public.pais VALUES (19, 'Argélia', NULL, 12);
INSERT INTO public.pais VALUES (274, 'Samoa Americana', NULL, 16);
INSERT INTO public.pais VALUES (8, 'Andorra', NULL, 20);
INSERT INTO public.pais VALUES (9, 'Angola', NULL, 24);
INSERT INTO public.pais VALUES (20, 'Argentina', NULL, 32);
INSERT INTO public.pais VALUES (21, 'Armênia', NULL, 51);
INSERT INTO public.pais VALUES (25, 'Aruba', NULL, 533);
INSERT INTO public.pais VALUES (28, 'Austrália', NULL, 36);
INSERT INTO public.pais VALUES (29, 'áustria', NULL, 40);
INSERT INTO public.pais VALUES (30, 'Azerbaijão', NULL, 31);
INSERT INTO public.pais VALUES (31, 'Bahrein', NULL, 48);
INSERT INTO public.pais VALUES (32, 'Bangladesh', NULL, 50);
INSERT INTO public.pais VALUES (33, 'Barbados', NULL, 52);
INSERT INTO public.pais VALUES (36, 'Bélgica', NULL, 56);
INSERT INTO public.pais VALUES (37, 'Belize', NULL, 84);
INSERT INTO public.pais VALUES (39, 'Bermudas', NULL, 60);
INSERT INTO public.pais VALUES (42, 'Bolívia', NULL, 68);
INSERT INTO public.pais VALUES (45, 'Brasil', NULL, 76);
INSERT INTO public.pais VALUES (46, 'Brunei', NULL, 96);
INSERT INTO public.pais VALUES (47, 'Bulgária', NULL, 100);
INSERT INTO public.pais VALUES (49, 'Burundi', NULL, 108);
INSERT INTO public.pais VALUES (52, 'Camarões', NULL, 120);
INSERT INTO public.pais VALUES (53, 'Canadá', NULL, 124);
INSERT INTO public.pais VALUES (51, 'Cabo Verde', NULL, 132);
INSERT INTO public.pais VALUES (59, 'Chade', NULL, 148);
INSERT INTO public.pais VALUES (61, 'Chile', NULL, 152);
INSERT INTO public.pais VALUES (62, 'China', NULL, 156);
INSERT INTO public.pais VALUES (67, 'Colômbia', NULL, 170);
INSERT INTO public.pais VALUES (131, 'Ilhas Cook', NULL, 184);
INSERT INTO public.pais VALUES (72, 'Costa do Marfim', NULL, 384);
INSERT INTO public.pais VALUES (75, 'Croácia', NULL, 191);
INSERT INTO public.pais VALUES (64, 'Chipre', NULL, 196);
INSERT INTO public.pais VALUES (260, 'República Tcheca', NULL, 203);
INSERT INTO public.pais VALUES (85, 'Equador', NULL, 218);
INSERT INTO public.pais VALUES (145, 'Ilhas Malvinas', NULL, 238);
INSERT INTO public.pais VALUES (96, 'Finlândia', NULL, 246);
INSERT INTO public.pais VALUES (97, 'França', NULL, 250);
INSERT INTO public.pais VALUES (238, 'Polinésia Francesa', NULL, 258);
INSERT INTO public.pais VALUES (98, 'Gâmbia', NULL, 270);
INSERT INTO public.pais VALUES (101, 'Geórgia', NULL, 268);
INSERT INTO public.pais VALUES (99, 'Gana', NULL, 288);
INSERT INTO public.pais VALUES (107, 'Groenlândia', NULL, 304);
INSERT INTO public.pais VALUES (105, 'Granada', NULL, 308);
INSERT INTO public.pais VALUES (108, 'Guam', NULL, 316);
INSERT INTO public.pais VALUES (109, 'Guatemala', NULL, 320);
INSERT INTO public.pais VALUES (111, 'Guiné', NULL, 324);
INSERT INTO public.pais VALUES (115, 'Honduras', NULL, 340);
INSERT INTO public.pais VALUES (172, 'Islândia', NULL, 352);
INSERT INTO public.pais VALUES (168, 'Irã', NULL, 364);
INSERT INTO public.pais VALUES (169, 'Iraque', NULL, 368);
INSERT INTO public.pais VALUES (170, 'Irlanda', NULL, 372);
INSERT INTO public.pais VALUES (173, 'Israel', NULL, 376);
INSERT INTO public.pais VALUES (176, 'Jamaica', NULL, 388);
INSERT INTO public.pais VALUES (177, 'Japão', NULL, 392);
INSERT INTO public.pais VALUES (178, 'Jordânia', NULL, 400);
INSERT INTO public.pais VALUES (56, 'Cazaquistão', NULL, 398);
INSERT INTO public.pais VALUES (188, 'Laos', NULL, 418);
INSERT INTO public.pais VALUES (191, 'Líbano', NULL, 422);
INSERT INTO public.pais VALUES (189, 'Lesoto', NULL, 426);
INSERT INTO public.pais VALUES (193, 'Líbia', NULL, 434);
INSERT INTO public.pais VALUES (194, 'Liechtenstein', NULL, 438);
INSERT INTO public.pais VALUES (196, 'Luxemburgo', NULL, 442);
INSERT INTO public.pais VALUES (197, 'Macau', NULL, 446);
INSERT INTO public.pais VALUES (201, 'Malawi', NULL, 454);
INSERT INTO public.pais VALUES (203, 'Mali', NULL, 466);
INSERT INTO public.pais VALUES (147, 'Ilhas Marshall', NULL, 584);
INSERT INTO public.pais VALUES (206, 'Martinica', NULL, 474);
INSERT INTO public.pais VALUES (213, 'Moldávia', NULL, 498);
INSERT INTO public.pais VALUES (215, 'Mongólia', NULL, 496);
INSERT INTO public.pais VALUES (217, 'Montenegro', NULL, 499);
INSERT INTO public.pais VALUES (205, 'Marrocos', NULL, 504);
INSERT INTO public.pais VALUES (212, 'Moçambique', NULL, 508);
INSERT INTO public.pais VALUES (218, 'Namíbia', NULL, 516);
INSERT INTO public.pais VALUES (219, 'Nauru', NULL, 520);
INSERT INTO public.pais VALUES (220, 'Nepal', NULL, 524);
INSERT INTO public.pais VALUES (114, 'Holanda', NULL, 528);
INSERT INTO public.pais VALUES (296, 'Suriname', NULL, 740);
INSERT INTO public.pais VALUES (16, 'Antilhas Holandesas', NULL, 530);
INSERT INTO public.pais VALUES (226, 'Nova Zelândia', NULL, 554);
INSERT INTO public.pais VALUES (222, 'Nicarágua', NULL, 558);
INSERT INTO public.pais VALUES (223, 'Nigéria', NULL, 566);
INSERT INTO public.pais VALUES (224, 'Noruega', NULL, 578);
INSERT INTO public.pais VALUES (235, 'Paquistão', NULL, 586);
INSERT INTO public.pais VALUES (231, 'Palestina', NULL, 275);
INSERT INTO public.pais VALUES (232, 'Panamá', NULL, 591);
INSERT INTO public.pais VALUES (236, 'Paraguai', NULL, 600);
INSERT INTO public.pais VALUES (237, 'Peru', NULL, 604);
INSERT INTO public.pais VALUES (95, 'Filipinas', NULL, 608);
INSERT INTO public.pais VALUES (239, 'Polônia', NULL, 616);
INSERT INTO public.pais VALUES (241, 'Portugal', NULL, 620);
INSERT INTO public.pais VALUES (240, 'Porto Rico', NULL, 630);
INSERT INTO public.pais VALUES (55, 'Catar', NULL, 634);
INSERT INTO public.pais VALUES (271, 'Rússia', NULL, 643);
INSERT INTO public.pais VALUES (277, 'Santa Helena', NULL, 654);
INSERT INTO public.pais VALUES (278, 'Santa Lúcia', NULL, 662);
INSERT INTO public.pais VALUES (276, 'San Marino', NULL, 674);
INSERT INTO public.pais VALUES (18, 'Arábia Saudita', NULL, 682);
INSERT INTO public.pais VALUES (283, 'Senegal', NULL, 686);
INSERT INTO public.pais VALUES (286, 'Sérvia', NULL, 688);
INSERT INTO public.pais VALUES (285, 'Serra Leoa', NULL, 694);
INSERT INTO public.pais VALUES (66, 'Cingapura', NULL, 702);
INSERT INTO public.pais VALUES (87, 'Eslováquia', NULL, 703);
INSERT INTO public.pais VALUES (88, 'Eslovênia', NULL, 705);
INSERT INTO public.pais VALUES (155, 'Ilhas Salomão', NULL, 90);
INSERT INTO public.pais VALUES (292, 'Suazilândia', NULL, 748);
INSERT INTO public.pais VALUES (294, 'Suécia', NULL, 752);
INSERT INTO public.pais VALUES (295, 'Suíça', NULL, 756);
INSERT INTO public.pais VALUES (288, 'Síria', NULL, 760);
INSERT INTO public.pais VALUES (299, 'Tailândia', NULL, 764);
INSERT INTO public.pais VALUES (310, 'Togo', NULL, 768);
INSERT INTO public.pais VALUES (311, 'Tonga', NULL, 776);
INSERT INTO public.pais VALUES (314, 'Trinidad e Tobago', NULL, 780);
INSERT INTO public.pais VALUES (315, 'Tunísia', NULL, 788);
INSERT INTO public.pais VALUES (317, 'Turquia', NULL, 792);
INSERT INTO public.pais VALUES (318, 'Tuvalu', NULL, 798);
INSERT INTO public.pais VALUES (322, 'Uganda', NULL, 800);
INSERT INTO public.pais VALUES (320, 'Ucrânia', NULL, 804);
INSERT INTO public.pais VALUES (84, 'Emirados árabes Unidos', NULL, 784);
INSERT INTO public.pais VALUES (92, 'Estados Unidos da América (eua)', NULL, 840);
INSERT INTO public.pais VALUES (324, 'Uruguai', NULL, 858);
INSERT INTO public.pais VALUES (325, 'Uzbequistão', NULL, 860);
INSERT INTO public.pais VALUES (326, 'Venezuela', NULL, 862);
INSERT INTO public.pais VALUES (162, 'Ilhas Virgens Britânicas', NULL, 92);
INSERT INTO public.pais VALUES (161, 'Ilhas Virgens Americanas', NULL, 850);
INSERT INTO public.pais VALUES (331, 'Zâmbia', NULL, 894);
INSERT INTO public.pais VALUES (93, 'Estônia', NULL, 233);
INSERT INTO public.pais VALUES (102, 'Gibraltar', NULL, 292);
INSERT INTO public.pais VALUES (269, 'Ruanda', NULL, 646);
INSERT INTO public.pais VALUES (280, 'São Tomé e Príncipe', NULL, 678);
INSERT INTO public.pais VALUES (89, 'Espanha', NULL, 724);
INSERT INTO public.pais VALUES (301, 'Tanzânia', NULL, 834);
INSERT INTO public.pais VALUES (316, 'Turcomenistão', NULL, 795);
INSERT INTO public.pais VALUES (6, 'Alemanha', NULL, 276);
INSERT INTO public.pais VALUES (17, 'Apátrida', NULL, 339);
INSERT INTO public.pais VALUES (77, 'Curaçao', NULL, 531);
INSERT INTO public.pais VALUES (293, 'Sudão', NULL, 729);
INSERT INTO public.pais VALUES (134, 'Ilhas do Canal', NULL, 830);


--
-- TOC entry 8102 (class 0 OID 9445659)
-- Dependencies: 815
-- Data for Name: pghero_query_stats; Type: TABLE DATA; Schema: public; Owner: -
--



--
-- TOC entry 8406 (class 0 OID 0)
-- Dependencies: 816
-- Name: pghero_query_stats_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.pghero_query_stats_id_seq', 1, false);


--
-- TOC entry 7499 (class 0 OID 9442746)
-- Dependencies: 200
-- Data for Name: phinxlog; Type: TABLE DATA; Schema: public; Owner: -
--

INSERT INTO public.phinxlog VALUES (20180221190026, 'CriaCamposMateriaisDidaticosEspecificos', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180222192205, 'AdicionaCamposArrayNaEscola', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180227123727, 'AtualizaCampoAbastecimentoAgua', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180227133346, 'AtualizaCampoAbastecimentoEnergia', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180227140143, 'AtualizaCampoEsgotoSanitario', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180227145322, 'AtualizaCampoDestinacaoLixo', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180227191158, 'RemoveCamposNaoUtilizados', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180306125032, 'CriaCampoDiasSemanaNaTurma', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180306130942, 'AtualizaCampoDiasSemana', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180307131819, 'CriaCampoAtividadesComplementaresNaTurma', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180307171003, 'CriaCampoAtividadesAeeNaTurma', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180308140947, 'AdicionaCampoDeAtualizacaoDeComponentes', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180315195846, 'RemoveCampoTurmaSemProfessor', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180327171018, 'CriaColunaRegraAvaliacaoDiferenciadaEmRegraAvaliacao', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180328154035, 'CriaTabelaConfigMovimentoGeral', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180328154248, 'CriaMenuConfigMovimentoGeral', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180406171734, 'RemoveCampoTipoInstituicaoCursoSuperior', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180406175731, 'UnificaCampoPosGraduacao', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180410131010, 'UnificaCamposCursoFormacaoContinuada', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180412191509, 'CriaColunaTipoBoletimDiferenciadoNasTurmas', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180418140901, 'AtualizaIntituicoesDeEnsinoSuperiorEducacenso', '2018-11-19 17:00:22', '2018-11-19 17:00:22', false);
INSERT INTO public.phinxlog VALUES (20180419170537, 'AjustaOnDeleteConstraintCursoSuperior', '2018-11-19 17:00:23', '2018-11-19 17:00:23', false);
INSERT INTO public.phinxlog VALUES (20180419171943, 'RemoveCursosNaoExistentesNoEducacenso', '2018-11-19 17:00:23', '2018-11-19 17:00:23', false);
INSERT INTO public.phinxlog VALUES (20180502193207, 'AjustesTabelaOrgaoEmissorEducacenso', '2018-11-19 17:00:23', '2018-11-19 17:00:23', false);
INSERT INTO public.phinxlog VALUES (20180504190318, 'AlteraTamanhoCampoCartorio', '2018-11-19 17:00:23', '2018-11-19 17:00:23', false);
INSERT INTO public.phinxlog VALUES (20180507141518, 'MigraOrgaoRegionalParaInstituicao', '2018-11-19 17:00:23', '2018-11-19 17:00:23', false);
INSERT INTO public.phinxlog VALUES (20180507170132, 'PopulaCodigoInepPaises', '2018-11-19 17:00:23', '2018-11-19 17:00:23', false);
INSERT INTO public.phinxlog VALUES (20180507195508, 'CriaCamposConfiguracoesFerramentaAdm', '2018-11-19 17:00:23', '2018-11-19 17:00:23', false);
INSERT INTO public.phinxlog VALUES (20180507210857, 'PopulaCodIbgeNaUf', '2018-11-19 17:00:23', '2018-11-19 17:00:23', false);
INSERT INTO public.phinxlog VALUES (20180507212335, 'PopulaCodIbgeNoDistrito', '2018-11-19 17:00:23', '2018-11-19 17:00:25', false);
INSERT INTO public.phinxlog VALUES (20180508144301, 'CustomLabel', '2018-11-19 17:00:25', '2018-11-19 17:00:25', false);
INSERT INTO public.phinxlog VALUES (20180508181809, 'MigraEtapaTurmaEducacensoParaEnturmacao', '2018-11-19 17:00:25', '2018-11-19 17:00:25', false);
INSERT INTO public.phinxlog VALUES (20180508182610, 'UnificaCamposDeRecursosParaProvaInep', '2018-11-19 17:00:25', '2018-11-19 17:00:25', false);
INSERT INTO public.phinxlog VALUES (20180508192134, 'RemoveCamposRecursosProvaInep', '2018-11-19 17:00:25', '2018-11-19 17:00:25', false);
INSERT INTO public.phinxlog VALUES (20180508213834, 'AdicionaEmailGestorEscolarEmEscola', '2018-11-19 17:00:25', '2018-11-19 17:00:25', false);
INSERT INTO public.phinxlog VALUES (20180509172602, 'CriaTabelaCodigoCartorioInep', '2018-11-19 17:00:25', '2018-11-19 17:00:25', false);
INSERT INTO public.phinxlog VALUES (20180509172940, 'PopulaTabelaCodigoCartorioInep', '2018-11-19 17:00:25', '2018-11-19 17:00:25', false);
INSERT INTO public.phinxlog VALUES (20180509235540, 'CriaColunaCadastroUsuarioEmConfiguracoesGerais', '2018-11-19 17:00:25', '2018-11-19 17:00:25', false);
INSERT INTO public.phinxlog VALUES (20180510204632, 'CriaColunasNovasConfiguracoesFerramentaAdm', '2018-11-19 17:00:25', '2018-11-19 17:00:25', false);
INSERT INTO public.phinxlog VALUES (20180511120044, 'RemoveTabelaTurmaDiaSemana', '2018-11-19 17:00:25', '2018-11-19 17:00:25', false);
INSERT INTO public.phinxlog VALUES (20180511174737, 'CriaColunaSuspensionMessageEmConfiguracoesGerais', '2018-11-19 17:00:25', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180514184707, 'AlteraCamposTextoEmConfiguracoesGerais', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180515144434, 'TrocaCampoZonaLocalizacaoEscola', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180515202955, 'CriaMenuUnificacaoDePessoas', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180516194808, 'AdicionaCampoObrigarCamposCensoEmInstituicao', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180516225839, 'MigraIdsDoCartorioInep', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180522211536, 'RemoveDefaulValueFormulaMediaRegraAvaliacao', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180523145626, 'UpdateTurnoMatriculaUsarComponenteTurno', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180523200850, 'MigraCampoEmailGestorEscolar', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180524115928, 'CriaTabelaEducacensoOrgaoRegional', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180529142246, 'AdicionaDefaultEmCampoRecebeEscolarizacaoDosAlunos', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180529182006, 'AdicionaIndicesEducacensoIes', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180529200349, 'AdicionaNovasInstituicoesDeEnsino', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180530143408, 'AdicionaCampoDataAdmissaoServidorAlocacao', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180612183130, 'AdicionaDependenciasSchemaRelatorio', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180613194737, 'CriaCampoQueObrigaDocumentoDaPessoa', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180614130817, 'RemoveParecerDuplicadoGeralAndPorComponente', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180614132150, 'AlteraChavePrimariaParaDeixarComposta', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180615141317, 'RemoveFkDaDispensaDisciplina', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180615200842, 'AdicionaCampoNumericoDeEtapasNaTabelaModulo', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180615201121, 'AlteraNomesDoMenuModuloParaEtapa', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180622143156, 'AlteraFuncaoFrequenciaPorComponente', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180628204326, 'CriaCamposCodigoInepEscolaCompartilhada', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180629174827, 'RemoveCampoBandaLargaEscola', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180704201550, 'AdicionaCamposHoraServidorAlocacao', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180705213341, 'AjustaTipoDoCampoDisciplinaDoHistorico', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180711133054, 'AdicionaCampoAnosLetivosEmEscolaCurso', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180711142802, 'AdicionaCampoAnosLetivosEmComponenteCurricularAnoEscolar', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180711183400, 'AdicionaTabelaRegraAvaliacaoSerieAno', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180712121246, 'AdicionaAnosLetivosEmEscolaSerie', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180712171230, 'AdicionaAnosLetivosEmEscolaSerieDisciplina', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180712190821, 'MigraValoresIniciaisParaAnosLetivos', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180719120252, 'AlteraViewComponenteCurricularPreverAnosLetivos', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180719185458, 'CriaCampoParaDesconsiderarDeficienciaNaRegraDiferenciada', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180724151229, 'MigraTurmaUnificadaParaEnturmacao', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180727205418, 'AdicionaIdNaTabelaDeAuditoriaGeral', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180731201900, 'CriaFuncaoCopiaAnosLetivos', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180801183745, 'AjustaEtapasDosModulos', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180801191005, 'AjustaModulosDeAnos', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180801210413, 'AjustaModulosDeTurmas', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180817192142, 'CriaTriggerParaImpedirDuplicacaoDeNotas', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180817192154, 'CriaTriggerParaImpedirDuplicacaoDePareceres', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180817192158, 'CriaTriggerParaImpedirDuplicacaoDeFaltas', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180820134201, 'AdicionaCampoExigirLancamentosAnterioresEmInstituicao', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180822140819, 'CriaNovaColunaQueryEmAuditoriaGeral', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180822141028, 'CriaTriggerAuditaNotaGeral', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180822143918, 'CriaTriggerAuditaNotaExame', '2018-11-19 17:00:26', '2018-11-19 17:00:26', false);
INSERT INTO public.phinxlog VALUES (20180822144312, 'CriaTriggerAuditaNotaComponenteCurricular', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180822144436, 'CriaTriggerAuditaNotaComponenteCurricularMedia', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180822144605, 'CriaTriggerAuditaParecerGeral', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180822144712, 'CriaTriggerAuditaParecerComponenteCurricular', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180822144839, 'CriaTriggerAuditaFaltaGeral', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180822145032, 'CriaTriggerAuditaFaltaComponenteCurricular', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180822145147, 'CriaTriggerAuditaMatricula', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180822145248, 'CriaTriggerAuditaMatriculaTurma', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180822172257, 'CriaTriggerAuditaMediaGeral', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180823181003, 'RemoveNotNullDaColunaNunSemanasDaTabelaModulos', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180823181019, 'RemoveNotNullDaColunaNunMesesDaTabelaModulos', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180823210652, 'Consultas', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180827173740, 'AlteraColunasParaPermitirNull', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180830163429, 'AlteraTriggerImpedeDuplicacaoFaltaAluno', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180830165757, 'AlteraTriggerImpedeDuplicacaoNotaAluno', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180830170056, 'AlteraTriggerImpedeDuplicacaoParecerAluno', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180831175718, 'AtualizaSituacaoNotaComponente', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180903170004, 'CriaSequencialParaDispensa', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180905054553, 'AtualizaSubstituiMenorNota', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180905184020, 'AdicionaColunaCamisetaInfantil', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180910201540, 'AlteraTriggerAuditoriaFaltaGeral', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20180928193631, 'AdicionaColunaParaExibirProfessoresAlocados', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20181015204242, 'AdicionaColunaAbreviaturaFuncionarioVinculo', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20181015205358, 'AbreviaturasFuncionarioVinculo', '2018-11-19 17:00:27', '2018-11-19 17:00:27', false);
INSERT INTO public.phinxlog VALUES (20181018204519, 'CriaMenuFuncionarioVinculo', '2018-11-19 17:01:06', '2018-11-19 17:01:06', false);
INSERT INTO public.phinxlog VALUES (20181029192129, 'CampoObservacoesEndereco', '2018-11-19 17:02:15', '2018-11-19 17:02:15', false);
INSERT INTO public.phinxlog VALUES (20181031182118, 'AdicionaTurnoAoVinculoTurmaProfessor', '2018-11-19 17:02:15', '2018-11-19 17:02:15', false);


--
-- TOC entry 8105 (class 0 OID 9445669)
-- Dependencies: 818
-- Data for Name: portal_banner; Type: TABLE DATA; Schema: public; Owner: -
--



--
-- TOC entry 8407 (class 0 OID 0)
-- Dependencies: 817
-- Name: portal_banner_cod_portal_banner_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.portal_banner_cod_portal_banner_seq', 1, false);


--
-- TOC entry 8107 (class 0 OID 9445683)
-- Dependencies: 820
-- Data for Name: regiao; Type: TABLE DATA; Schema: public; Owner: -
--



--
-- TOC entry 8408 (class 0 OID 0)
-- Dependencies: 819
-- Name: regiao_cod_regiao_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.regiao_cod_regiao_seq', 1, false);


--
-- TOC entry 8409 (class 0 OID 0)
-- Dependencies: 821
-- Name: seq_bairro; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.seq_bairro', 1, false);


--
-- TOC entry 8410 (class 0 OID 0)
-- Dependencies: 822
-- Name: seq_distrito; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.seq_distrito', 10839, true);


--
-- TOC entry 8411 (class 0 OID 0)
-- Dependencies: 823
-- Name: seq_logradouro; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.seq_logradouro', 1, false);


--
-- TOC entry 8412 (class 0 OID 0)
-- Dependencies: 824
-- Name: seq_municipio; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.seq_municipio', 5565, false);


--
-- TOC entry 8413 (class 0 OID 0)
-- Dependencies: 825
-- Name: seq_setor_bai; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.seq_setor_bai', 1, false);


--
-- TOC entry 8114 (class 0 OID 9445699)
-- Dependencies: 827
-- Data for Name: setor; Type: TABLE DATA; Schema: public; Owner: -
--



--
-- TOC entry 8115 (class 0 OID 9445705)
-- Dependencies: 828
-- Data for Name: setor_bai; Type: TABLE DATA; Schema: public; Owner: -
--



--
-- TOC entry 8414 (class 0 OID 0)
-- Dependencies: 826
-- Name: setor_idset_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.setor_idset_seq', 1, false);


--
-- TOC entry 8116 (class 0 OID 9445709)
-- Dependencies: 829
-- Data for Name: uf; Type: TABLE DATA; Schema: public; Owner: -
--

INSERT INTO public.uf VALUES ('RO', 'Rondônia', NULL, 45, 11);
INSERT INTO public.uf VALUES ('AC', 'Acre', NULL, 45, 12);
INSERT INTO public.uf VALUES ('AM', 'Amazonas', NULL, 45, 13);
INSERT INTO public.uf VALUES ('RR', 'Roraima', NULL, 45, 14);
INSERT INTO public.uf VALUES ('PA', 'Pará', NULL, 45, 15);
INSERT INTO public.uf VALUES ('AP', 'Amapá', NULL, 45, 16);
INSERT INTO public.uf VALUES ('TO', 'Tocantins', NULL, 45, 17);
INSERT INTO public.uf VALUES ('MA', 'Maranhão', NULL, 45, 21);
INSERT INTO public.uf VALUES ('PI', 'Piauí', NULL, 45, 22);
INSERT INTO public.uf VALUES ('CE', 'Ceará', NULL, 45, 23);
INSERT INTO public.uf VALUES ('RN', 'Rio Grande do Norte', NULL, 45, 24);
INSERT INTO public.uf VALUES ('PB', 'Paraíba', NULL, 45, 25);
INSERT INTO public.uf VALUES ('PE', 'Pernambuco', NULL, 45, 26);
INSERT INTO public.uf VALUES ('AL', 'Alagoas', NULL, 45, 27);
INSERT INTO public.uf VALUES ('SE', 'Sergipe', NULL, 45, 28);
INSERT INTO public.uf VALUES ('BA', 'Bahia', NULL, 45, 29);
INSERT INTO public.uf VALUES ('MG', 'Minas Gerais', NULL, 45, 31);
INSERT INTO public.uf VALUES ('ES', 'Espírito Santo', NULL, 45, 32);
INSERT INTO public.uf VALUES ('RJ', 'Rio de Janeiro', NULL, 45, 33);
INSERT INTO public.uf VALUES ('SP', 'São Paulo', NULL, 45, 35);
INSERT INTO public.uf VALUES ('PR', 'Paraná', NULL, 45, 41);
INSERT INTO public.uf VALUES ('SC', 'Santa Catarina', NULL, 45, 42);
INSERT INTO public.uf VALUES ('RS', 'Rio Grande do Sul', NULL, 45, 43);
INSERT INTO public.uf VALUES ('MS', 'Mato Grosso do Sul', NULL, 45, 50);
INSERT INTO public.uf VALUES ('MT', 'Mato Grosso', NULL, 45, 51);
INSERT INTO public.uf VALUES ('GO', 'Goiás', NULL, 45, 52);
INSERT INTO public.uf VALUES ('DF', 'Distrito Federal', NULL, 45, 53);


--
-- TOC entry 8117 (class 0 OID 9445715)
-- Dependencies: 830
-- Data for Name: vila; Type: TABLE DATA; Schema: public; Owner: -
--



--
-- TOC entry 8119 (class 0 OID 9445724)
-- Dependencies: 832
-- Data for Name: aluno_cod_aluno; Type: TABLE DATA; Schema: serieciasc; Owner: -
--



--
-- TOC entry 8120 (class 0 OID 9445727)
-- Dependencies: 833
-- Data for Name: aluno_uniforme; Type: TABLE DATA; Schema: serieciasc; Owner: -
--



--
-- TOC entry 8121 (class 0 OID 9445730)
-- Dependencies: 834
-- Data for Name: escola_agua; Type: TABLE DATA; Schema: serieciasc; Owner: -
--



--
-- TOC entry 8122 (class 0 OID 9445738)
-- Dependencies: 835
-- Data for Name: escola_energia; Type: TABLE DATA; Schema: serieciasc; Owner: -
--



--
-- TOC entry 8123 (class 0 OID 9445746)
-- Dependencies: 836
-- Data for Name: escola_lingua_indigena; Type: TABLE DATA; Schema: serieciasc; Owner: -
--



--
-- TOC entry 8124 (class 0 OID 9445754)
-- Dependencies: 837
-- Data for Name: escola_lixo; Type: TABLE DATA; Schema: serieciasc; Owner: -
--



--
-- TOC entry 8125 (class 0 OID 9445763)
-- Dependencies: 838
-- Data for Name: escola_projeto; Type: TABLE DATA; Schema: serieciasc; Owner: -
--



--
-- TOC entry 8126 (class 0 OID 9445775)
-- Dependencies: 839
-- Data for Name: escola_regulamentacao; Type: TABLE DATA; Schema: serieciasc; Owner: -
--



--
-- TOC entry 8127 (class 0 OID 9445783)
-- Dependencies: 840
-- Data for Name: escola_sanitario; Type: TABLE DATA; Schema: serieciasc; Owner: -
--



--
-- TOC entry 8128 (class 0 OID 9445789)
-- Dependencies: 841
-- Data for Name: cep_logradouro; Type: TABLE DATA; Schema: urbano; Owner: -
--



--
-- TOC entry 8129 (class 0 OID 9445797)
-- Dependencies: 842
-- Data for Name: cep_logradouro_bairro; Type: TABLE DATA; Schema: urbano; Owner: -
--



--
-- TOC entry 8118 (class 0 OID 9445721)
-- Dependencies: 831
-- Data for Name: tipo_logradouro; Type: TABLE DATA; Schema: urbano; Owner: -
--

INSERT INTO urbano.tipo_logradouro VALUES ('CORRE', 'Corredor');
INSERT INTO urbano.tipo_logradouro VALUES ('DESCI', 'Descida');
INSERT INTO urbano.tipo_logradouro VALUES ('AEROP', 'Aeroporto');
INSERT INTO urbano.tipo_logradouro VALUES ('DESVI', 'Desvio');
INSERT INTO urbano.tipo_logradouro VALUES ('ELEVA', 'Elevada');
INSERT INTO urbano.tipo_logradouro VALUES ('ENTRP', 'Entrada Particular');
INSERT INTO urbano.tipo_logradouro VALUES ('ESCA', 'Escada');
INSERT INTO urbano.tipo_logradouro VALUES ('ESCAD', 'Escadaria');
INSERT INTO urbano.tipo_logradouro VALUES ('ESTAC', 'Estacionamento');
INSERT INTO urbano.tipo_logradouro VALUES ('ESPLA', 'Esplanada');
INSERT INTO urbano.tipo_logradouro VALUES ('GALER', 'Galeria');
INSERT INTO urbano.tipo_logradouro VALUES ('ILHA', 'Ilha');
INSERT INTO urbano.tipo_logradouro VALUES ('JDNET', 'Jardinete');
INSERT INTO urbano.tipo_logradouro VALUES ('LAGO', 'Lago');
INSERT INTO urbano.tipo_logradouro VALUES ('LAGOA', 'Lagoa');
INSERT INTO urbano.tipo_logradouro VALUES ('MONTE', 'Monte');
INSERT INTO urbano.tipo_logradouro VALUES ('MARIN', 'Marina');
INSERT INTO urbano.tipo_logradouro VALUES ('VERED', 'Vereda');
INSERT INTO urbano.tipo_logradouro VALUES ('CORRG', 'Córrego');
INSERT INTO urbano.tipo_logradouro VALUES ('PASSE', 'Passeio');
INSERT INTO urbano.tipo_logradouro VALUES ('BULEV', 'Bulevar');
INSERT INTO urbano.tipo_logradouro VALUES ('COLON', 'Colônia');
INSERT INTO urbano.tipo_logradouro VALUES ('PATIO', 'Pátio');
INSERT INTO urbano.tipo_logradouro VALUES ('TUNEL', 'Túnel');
INSERT INTO urbano.tipo_logradouro VALUES ('ROTUL', 'Rótula');
INSERT INTO urbano.tipo_logradouro VALUES ('ESTAD', 'Estádio');
INSERT INTO urbano.tipo_logradouro VALUES ('MODUL', 'Módulo');
INSERT INTO urbano.tipo_logradouro VALUES ('SERVI', 'Servidão');
INSERT INTO urbano.tipo_logradouro VALUES ('ALM', 'Alameda');
INSERT INTO urbano.tipo_logradouro VALUES ('ALTO', 'Alto');
INSERT INTO urbano.tipo_logradouro VALUES ('AV', 'Avenida');
INSERT INTO urbano.tipo_logradouro VALUES ('BEC', 'Beco');
INSERT INTO urbano.tipo_logradouro VALUES ('COND', 'Condomínio');
INSERT INTO urbano.tipo_logradouro VALUES ('CONJ', 'Conjunto');
INSERT INTO urbano.tipo_logradouro VALUES ('DIV', 'Divisa');
INSERT INTO urbano.tipo_logradouro VALUES ('EST', 'Estrada');
INSERT INTO urbano.tipo_logradouro VALUES ('FEIRA', 'Feira');
INSERT INTO urbano.tipo_logradouro VALUES ('JD', 'Jardim');
INSERT INTO urbano.tipo_logradouro VALUES ('LAD', 'Ladeira');
INSERT INTO urbano.tipo_logradouro VALUES ('LTM', 'Loteamento');
INSERT INTO urbano.tipo_logradouro VALUES ('LRG', 'Largo');
INSERT INTO urbano.tipo_logradouro VALUES ('MRG', 'Margem');
INSERT INTO urbano.tipo_logradouro VALUES ('PORTO', 'Porto');
INSERT INTO urbano.tipo_logradouro VALUES ('PQE', 'Parque');
INSERT INTO urbano.tipo_logradouro VALUES ('PRAIA', 'Praia');
INSERT INTO urbano.tipo_logradouro VALUES ('QDA', 'Quadra');
INSERT INTO urbano.tipo_logradouro VALUES ('REC', 'Recanto');
INSERT INTO urbano.tipo_logradouro VALUES ('RES', 'Residencial');
INSERT INTO urbano.tipo_logradouro VALUES ('RET', 'Retorno');
INSERT INTO urbano.tipo_logradouro VALUES ('ROD', 'Rodovia');
INSERT INTO urbano.tipo_logradouro VALUES ('ROT', 'Rotatória');
INSERT INTO urbano.tipo_logradouro VALUES ('RUA', 'Rua');
INSERT INTO urbano.tipo_logradouro VALUES ('TER', 'Terminal');
INSERT INTO urbano.tipo_logradouro VALUES ('TRV', 'Travessa');
INSERT INTO urbano.tipo_logradouro VALUES ('UND', 'Unidade');
INSERT INTO urbano.tipo_logradouro VALUES ('VIA', 'Via');
INSERT INTO urbano.tipo_logradouro VALUES ('VLA', 'Vila');
INSERT INTO urbano.tipo_logradouro VALUES ('ACAMP', 'Acampamento');
INSERT INTO urbano.tipo_logradouro VALUES ('ACESS', 'Acesso');
INSERT INTO urbano.tipo_logradouro VALUES ('VIACE', 'Via de Acesso');
INSERT INTO urbano.tipo_logradouro VALUES ('ADRO', 'Adro');
INSERT INTO urbano.tipo_logradouro VALUES ('ANTES', 'Antiga Estrada');
INSERT INTO urbano.tipo_logradouro VALUES ('AREA', 'Área');
INSERT INTO urbano.tipo_logradouro VALUES ('ARESP', 'Área Especial');
INSERT INTO urbano.tipo_logradouro VALUES ('ATALH', 'Atalho');
INSERT INTO urbano.tipo_logradouro VALUES ('AVCON', 'Avenida Contorno');
INSERT INTO urbano.tipo_logradouro VALUES ('AVMAR', 'Avenida Marginal');
INSERT INTO urbano.tipo_logradouro VALUES ('AVVEL', 'Avenida Velha');
INSERT INTO urbano.tipo_logradouro VALUES ('PARAL', 'Paralela');
INSERT INTO urbano.tipo_logradouro VALUES ('ENTRQ', 'Entre Quadra');
INSERT INTO urbano.tipo_logradouro VALUES ('PRQMU', 'Parque Municipal');
INSERT INTO urbano.tipo_logradouro VALUES ('PRQRE', 'Parque Residencial');
INSERT INTO urbano.tipo_logradouro VALUES ('BAIXA', 'Baixa');
INSERT INTO urbano.tipo_logradouro VALUES ('PASSG', 'Passagem');
INSERT INTO urbano.tipo_logradouro VALUES ('PASPE', 'Passagem de Pedestres');
INSERT INTO urbano.tipo_logradouro VALUES ('PASSB', 'Passagem Subterrânea');
INSERT INTO urbano.tipo_logradouro VALUES ('BELVE', 'Belvedere');
INSERT INTO urbano.tipo_logradouro VALUES ('PASSA', 'Passarela');
INSERT INTO urbano.tipo_logradouro VALUES ('BLOCO', 'Bloco');
INSERT INTO urbano.tipo_logradouro VALUES ('BOSQU', 'Bosque');
INSERT INTO urbano.tipo_logradouro VALUES ('PONTA', 'Ponta');
INSERT INTO urbano.tipo_logradouro VALUES ('BOULE', 'Boulevard');
INSERT INTO urbano.tipo_logradouro VALUES ('ZIGUE', 'Zigue-Zague');
INSERT INTO urbano.tipo_logradouro VALUES ('VIELA', 'Viela');
INSERT INTO urbano.tipo_logradouro VALUES ('VIDUT', 'Viaduto');
INSERT INTO urbano.tipo_logradouro VALUES ('VIALO', 'Via Local');
INSERT INTO urbano.tipo_logradouro VALUES ('VIAPE', 'Via de Pedestre');
INSERT INTO urbano.tipo_logradouro VALUES ('VIALI', 'Via Litorânea');
INSERT INTO urbano.tipo_logradouro VALUES ('VIAEL', 'Via Elevado');
INSERT INTO urbano.tipo_logradouro VALUES ('VIAEX', 'Via Expressa');
INSERT INTO urbano.tipo_logradouro VALUES ('VIACO', 'Via Coletora');
INSERT INTO urbano.tipo_logradouro VALUES ('CAMIN', 'Caminho');
INSERT INTO urbano.tipo_logradouro VALUES ('VALE', 'Vale');
INSERT INTO urbano.tipo_logradouro VALUES ('VALA', 'Vala');
INSERT INTO urbano.tipo_logradouro VALUES ('TRAVP', 'Travessa Particular');
INSERT INTO urbano.tipo_logradouro VALUES ('TRAVV', 'Travessa Velha');
INSERT INTO urbano.tipo_logradouro VALUES ('TRECH', 'Trecho');
INSERT INTO urbano.tipo_logradouro VALUES ('TREVO', 'Trevo');
INSERT INTO urbano.tipo_logradouro VALUES ('RUAPE', 'Rua de Pedestre');
INSERT INTO urbano.tipo_logradouro VALUES ('RUAPA', 'Rua Particular');
INSERT INTO urbano.tipo_logradouro VALUES ('RUAVE', 'Rua Velha');
INSERT INTO urbano.tipo_logradouro VALUES ('SUBID', 'Subida');
INSERT INTO urbano.tipo_logradouro VALUES ('PONTE', 'Ponte');
INSERT INTO urbano.tipo_logradouro VALUES ('RAMPA', 'Rampa');
INSERT INTO urbano.tipo_logradouro VALUES ('BURAC', 'Buraco');
INSERT INTO urbano.tipo_logradouro VALUES ('QUINT', 'Quinta');
INSERT INTO urbano.tipo_logradouro VALUES ('RETIR', 'Retiro');
INSERT INTO urbano.tipo_logradouro VALUES ('CAIS', 'Cais');
INSERT INTO urbano.tipo_logradouro VALUES ('FONTE', 'Fonte');
INSERT INTO urbano.tipo_logradouro VALUES ('PROLO', 'Prolongamento');
INSERT INTO urbano.tipo_logradouro VALUES ('PARAD', 'Parada');
INSERT INTO urbano.tipo_logradouro VALUES ('SETOR', 'Setor');
INSERT INTO urbano.tipo_logradouro VALUES ('RETA', 'Reta');
INSERT INTO urbano.tipo_logradouro VALUES ('MORRO', 'Morro');
INSERT INTO urbano.tipo_logradouro VALUES ('RODAN', 'Rodo Anel');
INSERT INTO urbano.tipo_logradouro VALUES ('RAMAL', 'Ramal');
INSERT INTO urbano.tipo_logradouro VALUES ('FERRO', 'Ferrovia');
INSERT INTO urbano.tipo_logradouro VALUES ('CANAL', 'Canal');
INSERT INTO urbano.tipo_logradouro VALUES ('FORT', 'Forte');
INSERT INTO urbano.tipo_logradouro VALUES ('DISTR', 'Distrito');
INSERT INTO urbano.tipo_logradouro VALUES ('ESTRE', 'Estrada Estadual');
INSERT INTO urbano.tipo_logradouro VALUES ('ESTRM', 'Estrada Municipal');
INSERT INTO urbano.tipo_logradouro VALUES ('ESTRP', 'Estrada Particular');
INSERT INTO urbano.tipo_logradouro VALUES ('ESTRV', 'Estrada Velha');
INSERT INTO urbano.tipo_logradouro VALUES ('ESTRC', 'Estrada Vicinal');
INSERT INTO urbano.tipo_logradouro VALUES ('CICLO', 'Ciclovia');
INSERT INTO urbano.tipo_logradouro VALUES ('GRANJ', 'Granja');
INSERT INTO urbano.tipo_logradouro VALUES ('FAZEN', 'Fazenda');
INSERT INTO urbano.tipo_logradouro VALUES ('CAMPO', 'Campo');
INSERT INTO urbano.tipo_logradouro VALUES ('FAVEL', 'Favela');
INSERT INTO urbano.tipo_logradouro VALUES ('CIRCU', 'Circular');
INSERT INTO urbano.tipo_logradouro VALUES ('CONTO', 'Contorno');
INSERT INTO urbano.tipo_logradouro VALUES ('RUALI', 'Rua de Ligação');
INSERT INTO urbano.tipo_logradouro VALUES ('ROTAT', 'Rotatória');
INSERT INTO urbano.tipo_logradouro VALUES ('NUCLE', 'Núcleo');
INSERT INTO urbano.tipo_logradouro VALUES ('ESTRL', 'Estrada de Ligação');
INSERT INTO urbano.tipo_logradouro VALUES ('ARTER', 'Artéria');
INSERT INTO urbano.tipo_logradouro VALUES ('COMVI', 'Complexo Viário');
INSERT INTO urbano.tipo_logradouro VALUES ('CJOMU', 'Conjunto Mutirão');
INSERT INTO urbano.tipo_logradouro VALUES ('BALAO', 'Balão');
INSERT INTO urbano.tipo_logradouro VALUES ('CALCA', 'Calçada');
INSERT INTO urbano.tipo_logradouro VALUES ('CHAC', 'Chácara');
INSERT INTO urbano.tipo_logradouro VALUES ('ESTAO', 'Estação');
INSERT INTO urbano.tipo_logradouro VALUES ('PCA', 'Praça');
INSERT INTO urbano.tipo_logradouro VALUES ('PCAES', 'Praça Esportes');
INSERT INTO urbano.tipo_logradouro VALUES ('SITIO', 'Sítio');
INSERT INTO urbano.tipo_logradouro VALUES ('ASSEN', 'Assentamento');


--
-- TOC entry 5490 (class 2606 OID 9463870)
-- Name: pk_funcao; Type: CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.funcao
    ADD CONSTRAINT pk_funcao PRIMARY KEY (idfunc, idsis, idmen);


--
-- TOC entry 5492 (class 2606 OID 9463872)
-- Name: pk_grupo; Type: CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.grupo
    ADD CONSTRAINT pk_grupo PRIMARY KEY (idgrp);


--
-- TOC entry 5494 (class 2606 OID 9463874)
-- Name: pk_grupo_funcao; Type: CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.grupo_funcao
    ADD CONSTRAINT pk_grupo_funcao PRIMARY KEY (idmen, idsis, idgrp, idfunc);


--
-- TOC entry 5496 (class 2606 OID 9463876)
-- Name: pk_grupo_menu; Type: CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.grupo_menu
    ADD CONSTRAINT pk_grupo_menu PRIMARY KEY (idgrp, idsis, idmen);


--
-- TOC entry 5498 (class 2606 OID 9463878)
-- Name: pk_grupo_operacao; Type: CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.grupo_operacao
    ADD CONSTRAINT pk_grupo_operacao PRIMARY KEY (idfunc, idgrp, idsis, idmen, idope);


--
-- TOC entry 5500 (class 2606 OID 9463880)
-- Name: pk_grupo_sistema; Type: CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.grupo_sistema
    ADD CONSTRAINT pk_grupo_sistema PRIMARY KEY (idsis, idgrp);


--
-- TOC entry 5502 (class 2606 OID 9463882)
-- Name: pk_historico_senha; Type: CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.historico_senha
    ADD CONSTRAINT pk_historico_senha PRIMARY KEY (login, senha);


--
-- TOC entry 5504 (class 2606 OID 9463884)
-- Name: pk_instituicao; Type: CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.instituicao
    ADD CONSTRAINT pk_instituicao PRIMARY KEY (idins);


--
-- TOC entry 5506 (class 2606 OID 9463886)
-- Name: pk_menu; Type: CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.menu
    ADD CONSTRAINT pk_menu PRIMARY KEY (idsis, idmen);


--
-- TOC entry 5508 (class 2606 OID 9463888)
-- Name: pk_operacao; Type: CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.operacao
    ADD CONSTRAINT pk_operacao PRIMARY KEY (idope);


--
-- TOC entry 5510 (class 2606 OID 9463890)
-- Name: pk_operacao_funcao; Type: CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.operacao_funcao
    ADD CONSTRAINT pk_operacao_funcao PRIMARY KEY (idmen, idsis, idfunc, idope);


--
-- TOC entry 5512 (class 2606 OID 9463892)
-- Name: pk_pessoa_instituicao; Type: CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.pessoa_instituicao
    ADD CONSTRAINT pk_pessoa_instituicao PRIMARY KEY (idins, idpes);


--
-- TOC entry 5514 (class 2606 OID 9463894)
-- Name: pk_sistema; Type: CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.sistema
    ADD CONSTRAINT pk_sistema PRIMARY KEY (idsis);


--
-- TOC entry 5516 (class 2606 OID 9463896)
-- Name: pk_usuario; Type: CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.usuario
    ADD CONSTRAINT pk_usuario PRIMARY KEY (login);


--
-- TOC entry 5519 (class 2606 OID 9463898)
-- Name: pk_usuario_grupo; Type: CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.usuario_grupo
    ADD CONSTRAINT pk_usuario_grupo PRIMARY KEY (idgrp, login);


--
-- TOC entry 5521 (class 2606 OID 9463900)
-- Name: pk_baixa_guia_produto; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.baixa_guia_produto
    ADD CONSTRAINT pk_baixa_guia_produto PRIMARY KEY (idbap);


--
-- TOC entry 5523 (class 2606 OID 9463902)
-- Name: pk_baixa_guia_remessa; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.baixa_guia_remessa
    ADD CONSTRAINT pk_baixa_guia_remessa PRIMARY KEY (idbai);


--
-- TOC entry 5526 (class 2606 OID 9463904)
-- Name: pk_calendario; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.calendario
    ADD CONSTRAINT pk_calendario PRIMARY KEY (idcad);


--
-- TOC entry 5528 (class 2606 OID 9463906)
-- Name: pk_cardapio; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.cardapio
    ADD CONSTRAINT pk_cardapio PRIMARY KEY (idcar);


--
-- TOC entry 5530 (class 2606 OID 9463908)
-- Name: pk_cardapio_faixa_unidade; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.cardapio_faixa_unidade
    ADD CONSTRAINT pk_cardapio_faixa_unidade PRIMARY KEY (idfeu, idcar);


--
-- TOC entry 5532 (class 2606 OID 9463910)
-- Name: pk_cardapio_produto; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.cardapio_produto
    ADD CONSTRAINT pk_cardapio_produto PRIMARY KEY (idcpr);


--
-- TOC entry 5535 (class 2606 OID 9463912)
-- Name: pk_cardapio_receita; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.cardapio_receita
    ADD CONSTRAINT pk_cardapio_receita PRIMARY KEY (idcar, idrec);


--
-- TOC entry 5537 (class 2606 OID 9463914)
-- Name: pk_cliente; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.cliente
    ADD CONSTRAINT pk_cliente PRIMARY KEY (idcli);


--
-- TOC entry 5542 (class 2606 OID 9463916)
-- Name: pk_contrato; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.contrato
    ADD CONSTRAINT pk_contrato PRIMARY KEY (idcon);


--
-- TOC entry 5545 (class 2606 OID 9463918)
-- Name: pk_contrato_produto; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.contrato_produto
    ADD CONSTRAINT pk_contrato_produto PRIMARY KEY (idcop);


--
-- TOC entry 5540 (class 2606 OID 9463920)
-- Name: pk_cp_quimico; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.composto_quimico
    ADD CONSTRAINT pk_cp_quimico PRIMARY KEY (idcom);


--
-- TOC entry 5548 (class 2606 OID 9463922)
-- Name: pk_evento; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.evento
    ADD CONSTRAINT pk_evento PRIMARY KEY (ideve);


--
-- TOC entry 5551 (class 2606 OID 9463924)
-- Name: pk_faixa_composto_quimico; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.faixa_composto_quimico
    ADD CONSTRAINT pk_faixa_composto_quimico PRIMARY KEY (idfcp);


--
-- TOC entry 5554 (class 2606 OID 9463926)
-- Name: pk_faixa_etaria; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.faixa_etaria
    ADD CONSTRAINT pk_faixa_etaria PRIMARY KEY (idfae);


--
-- TOC entry 5556 (class 2606 OID 9463928)
-- Name: pk_fornecedor; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.fornecedor
    ADD CONSTRAINT pk_fornecedor PRIMARY KEY (idfor);


--
-- TOC entry 5560 (class 2606 OID 9463930)
-- Name: pk_grp_quimico; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.grupo_quimico
    ADD CONSTRAINT pk_grp_quimico PRIMARY KEY (idgrpq);


--
-- TOC entry 5562 (class 2606 OID 9463932)
-- Name: pk_guia_produto_diario; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.guia_produto_diario
    ADD CONSTRAINT pk_guia_produto_diario PRIMARY KEY (idguiaprodiario);


--
-- TOC entry 5564 (class 2606 OID 9463934)
-- Name: pk_guia_remessa; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.guia_remessa
    ADD CONSTRAINT pk_guia_remessa PRIMARY KEY (idgui);


--
-- TOC entry 5567 (class 2606 OID 9463936)
-- Name: pk_guia_remessa_produto; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.guia_remessa_produto
    ADD CONSTRAINT pk_guia_remessa_produto PRIMARY KEY (idgup);


--
-- TOC entry 5570 (class 2606 OID 9463938)
-- Name: pk_log_guia_remessa; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.log_guia_remessa
    ADD CONSTRAINT pk_log_guia_remessa PRIMARY KEY (idlogguia);


--
-- TOC entry 5572 (class 2606 OID 9463940)
-- Name: pk_medidas_caseiras; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.medidas_caseiras
    ADD CONSTRAINT pk_medidas_caseiras PRIMARY KEY (idmedcas, idcli);


--
-- TOC entry 5574 (class 2606 OID 9463942)
-- Name: pk_pessoa; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.pessoa
    ADD CONSTRAINT pk_pessoa PRIMARY KEY (idpes);


--
-- TOC entry 5579 (class 2606 OID 9463944)
-- Name: pk_prod_cp_quimico; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.produto_composto_quimico
    ADD CONSTRAINT pk_prod_cp_quimico PRIMARY KEY (idpcq);


--
-- TOC entry 5576 (class 2606 OID 9463946)
-- Name: pk_produto; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.produto
    ADD CONSTRAINT pk_produto PRIMARY KEY (idpro);


--
-- TOC entry 5582 (class 2606 OID 9463948)
-- Name: pk_produto_fornecedor; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.produto_fornecedor
    ADD CONSTRAINT pk_produto_fornecedor PRIMARY KEY (idprf);


--
-- TOC entry 5585 (class 2606 OID 9463950)
-- Name: pk_produto_medida_caseira; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.produto_medida_caseira
    ADD CONSTRAINT pk_produto_medida_caseira PRIMARY KEY (idpmc);


--
-- TOC entry 5590 (class 2606 OID 9463952)
-- Name: pk_rec_cp_quimico; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.receita_composto_quimico
    ADD CONSTRAINT pk_rec_cp_quimico PRIMARY KEY (idrcq);


--
-- TOC entry 5593 (class 2606 OID 9463954)
-- Name: pk_rec_prod; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.receita_produto
    ADD CONSTRAINT pk_rec_prod PRIMARY KEY (idrpr);


--
-- TOC entry 5588 (class 2606 OID 9463956)
-- Name: pk_receita; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.receita
    ADD CONSTRAINT pk_receita PRIMARY KEY (idrec);


--
-- TOC entry 5600 (class 2606 OID 9463958)
-- Name: pk_tipo_unidade; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.tipo_unidade
    ADD CONSTRAINT pk_tipo_unidade PRIMARY KEY (idtip);


--
-- TOC entry 5596 (class 2606 OID 9463960)
-- Name: pk_tp_produto; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.tipo_produto
    ADD CONSTRAINT pk_tp_produto PRIMARY KEY (idtip);


--
-- TOC entry 5598 (class 2606 OID 9463962)
-- Name: pk_tp_refeicao; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.tipo_refeicao
    ADD CONSTRAINT pk_tp_refeicao PRIMARY KEY (idtre);


--
-- TOC entry 5605 (class 2606 OID 9463964)
-- Name: pk_uni_faixa_etaria; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.unidade_faixa_etaria
    ADD CONSTRAINT pk_uni_faixa_etaria PRIMARY KEY (idfeu);


--
-- TOC entry 5608 (class 2606 OID 9463966)
-- Name: pk_uni_produto; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.unidade_produto
    ADD CONSTRAINT pk_uni_produto PRIMARY KEY (idunp, idcli);


--
-- TOC entry 5602 (class 2606 OID 9463968)
-- Name: pk_unidade_atendida; Type: CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.unidade_atendida
    ADD CONSTRAINT pk_unidade_atendida PRIMARY KEY (iduni);


--
-- TOC entry 5631 (class 2606 OID 9463970)
-- Name: fisica_foto_pkey; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica_foto
    ADD CONSTRAINT fisica_foto_pkey PRIMARY KEY (idpes);


--
-- TOC entry 5635 (class 2606 OID 9463972)
-- Name: fisica_sangue_pkey; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica_sangue
    ADD CONSTRAINT fisica_sangue_pkey PRIMARY KEY (idpes);


--
-- TOC entry 5610 (class 2606 OID 9463974)
-- Name: pk_aviso_nome; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.aviso_nome
    ADD CONSTRAINT pk_aviso_nome PRIMARY KEY (idpes, aviso);


--
-- TOC entry 5612 (class 2606 OID 9463976)
-- Name: pk_cadastro_escolaridade; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.deficiencia
    ADD CONSTRAINT pk_cadastro_escolaridade PRIMARY KEY (cod_deficiencia);


--
-- TOC entry 5614 (class 2606 OID 9463978)
-- Name: pk_documento; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.documento
    ADD CONSTRAINT pk_documento PRIMARY KEY (idpes);


--
-- TOC entry 5616 (class 2606 OID 9463980)
-- Name: pk_endereco_externo; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.endereco_externo
    ADD CONSTRAINT pk_endereco_externo PRIMARY KEY (idpes, tipo);


--
-- TOC entry 5618 (class 2606 OID 9463982)
-- Name: pk_endereco_pessoa; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.endereco_pessoa
    ADD CONSTRAINT pk_endereco_pessoa PRIMARY KEY (idpes, tipo);


--
-- TOC entry 5620 (class 2606 OID 9463984)
-- Name: pk_escolaridade; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.escolaridade
    ADD CONSTRAINT pk_escolaridade PRIMARY KEY (idesco);


--
-- TOC entry 5622 (class 2606 OID 9463986)
-- Name: pk_estado_civil; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.estado_civil
    ADD CONSTRAINT pk_estado_civil PRIMARY KEY (ideciv);


--
-- TOC entry 5624 (class 2606 OID 9463988)
-- Name: pk_fisica; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica
    ADD CONSTRAINT pk_fisica PRIMARY KEY (idpes);


--
-- TOC entry 5626 (class 2606 OID 9463990)
-- Name: pk_fisica_cpf; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica_cpf
    ADD CONSTRAINT pk_fisica_cpf PRIMARY KEY (idpes);


--
-- TOC entry 5629 (class 2606 OID 9463992)
-- Name: pk_fisica_deficiencia; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica_deficiencia
    ADD CONSTRAINT pk_fisica_deficiencia PRIMARY KEY (ref_idpes, ref_cod_deficiencia);


--
-- TOC entry 5633 (class 2606 OID 9463994)
-- Name: pk_fisica_raca; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica_raca
    ADD CONSTRAINT pk_fisica_raca PRIMARY KEY (ref_idpes);


--
-- TOC entry 5637 (class 2606 OID 9463996)
-- Name: pk_fone_pessoa; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fone_pessoa
    ADD CONSTRAINT pk_fone_pessoa PRIMARY KEY (idpes, tipo);


--
-- TOC entry 5639 (class 2606 OID 9463998)
-- Name: pk_funcionario; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.funcionario
    ADD CONSTRAINT pk_funcionario PRIMARY KEY (matricula, idins);


--
-- TOC entry 6389 (class 2606 OID 9474359)
-- Name: pk_id; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.codigo_cartorio_inep
    ADD CONSTRAINT pk_id PRIMARY KEY (id);


--
-- TOC entry 5641 (class 2606 OID 9464000)
-- Name: pk_juridica; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.juridica
    ADD CONSTRAINT pk_juridica PRIMARY KEY (idpes);


--
-- TOC entry 5644 (class 2606 OID 9464002)
-- Name: pk_ocupacao; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.ocupacao
    ADD CONSTRAINT pk_ocupacao PRIMARY KEY (idocup);


--
-- TOC entry 5646 (class 2606 OID 9464004)
-- Name: pk_orgao_emissor_rg; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.orgao_emissor_rg
    ADD CONSTRAINT pk_orgao_emissor_rg PRIMARY KEY (idorg_rg);


--
-- TOC entry 5648 (class 2606 OID 9464006)
-- Name: pk_pessoa; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.pessoa
    ADD CONSTRAINT pk_pessoa PRIMARY KEY (idpes);


--
-- TOC entry 5650 (class 2606 OID 9464008)
-- Name: pk_pessoa_fonetico; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.pessoa_fonetico
    ADD CONSTRAINT pk_pessoa_fonetico PRIMARY KEY (fonema, idpes);


--
-- TOC entry 5656 (class 2606 OID 9464010)
-- Name: pk_socio; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.socio
    ADD CONSTRAINT pk_socio PRIMARY KEY (idpes_juridica, idpes_fisica);


--
-- TOC entry 5652 (class 2606 OID 9464012)
-- Name: raca_pkey; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.raca
    ADD CONSTRAINT raca_pkey PRIMARY KEY (cod_raca);


--
-- TOC entry 5654 (class 2606 OID 9464014)
-- Name: religiao_pkey; Type: CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.religiao
    ADD CONSTRAINT religiao_pkey PRIMARY KEY (cod_religiao);


--
-- TOC entry 5664 (class 2606 OID 9464016)
-- Name: pk_campo_consistenciacao; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.campo_consistenciacao
    ADD CONSTRAINT pk_campo_consistenciacao PRIMARY KEY (idcam);


--
-- TOC entry 5666 (class 2606 OID 9464018)
-- Name: pk_campo_metadado; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.campo_metadado
    ADD CONSTRAINT pk_campo_metadado PRIMARY KEY (id_campo_met);


--
-- TOC entry 5668 (class 2606 OID 9464020)
-- Name: pk_confrontacao; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.confrontacao
    ADD CONSTRAINT pk_confrontacao PRIMARY KEY (idcon);


--
-- TOC entry 5670 (class 2606 OID 9464022)
-- Name: pk_fonte; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.fonte
    ADD CONSTRAINT pk_fonte PRIMARY KEY (idfon);


--
-- TOC entry 5672 (class 2606 OID 9464024)
-- Name: pk_historico_campo; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.historico_campo
    ADD CONSTRAINT pk_historico_campo PRIMARY KEY (idpes, idcam);


--
-- TOC entry 5682 (class 2606 OID 9464026)
-- Name: pk_inc_pessoa_possivel; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.incoerencia_pessoa_possivel
    ADD CONSTRAINT pk_inc_pessoa_possivel PRIMARY KEY (idinc, idpes);


--
-- TOC entry 5674 (class 2606 OID 9464028)
-- Name: pk_incoerencia; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.incoerencia
    ADD CONSTRAINT pk_incoerencia PRIMARY KEY (idinc);


--
-- TOC entry 5676 (class 2606 OID 9464030)
-- Name: pk_incoerencia_documento; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.incoerencia_documento
    ADD CONSTRAINT pk_incoerencia_documento PRIMARY KEY (id_inc_doc);


--
-- TOC entry 5678 (class 2606 OID 9464032)
-- Name: pk_incoerencia_endereco; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.incoerencia_endereco
    ADD CONSTRAINT pk_incoerencia_endereco PRIMARY KEY (id_inc_end);


--
-- TOC entry 5680 (class 2606 OID 9464034)
-- Name: pk_incoerencia_fone; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.incoerencia_fone
    ADD CONSTRAINT pk_incoerencia_fone PRIMARY KEY (id_inc_fone);


--
-- TOC entry 5684 (class 2606 OID 9464036)
-- Name: pk_incoerencia_tipo_incoerencia; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.incoerencia_tipo_incoerencia
    ADD CONSTRAINT pk_incoerencia_tipo_incoerencia PRIMARY KEY (id_tipo_inc, idinc);


--
-- TOC entry 5686 (class 2606 OID 9464038)
-- Name: pk_metadado; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.metadado
    ADD CONSTRAINT pk_metadado PRIMARY KEY (idmet);


--
-- TOC entry 5688 (class 2606 OID 9464040)
-- Name: pk_ocorrencia_regra_campo; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.ocorrencia_regra_campo
    ADD CONSTRAINT pk_ocorrencia_regra_campo PRIMARY KEY (idreg, conteudo_padrao);


--
-- TOC entry 5690 (class 2606 OID 9464042)
-- Name: pk_regra_campo; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.regra_campo
    ADD CONSTRAINT pk_regra_campo PRIMARY KEY (idreg);


--
-- TOC entry 5692 (class 2606 OID 9464044)
-- Name: pk_temp_cadastro_unificacao_cmf; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.temp_cadastro_unificacao_cmf
    ADD CONSTRAINT pk_temp_cadastro_unificacao_cmf PRIMARY KEY (idpes);


--
-- TOC entry 5694 (class 2606 OID 9464046)
-- Name: pk_temp_cadastro_unificacao_siam; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.temp_cadastro_unificacao_siam
    ADD CONSTRAINT pk_temp_cadastro_unificacao_siam PRIMARY KEY (idpes);


--
-- TOC entry 5696 (class 2606 OID 9464048)
-- Name: pk_tipo_incoerencia; Type: CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.tipo_incoerencia
    ADD CONSTRAINT pk_tipo_incoerencia PRIMARY KEY (id_tipo_inc);


--
-- TOC entry 5699 (class 2606 OID 9464050)
-- Name: area_conhecimento_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.area_conhecimento
    ADD CONSTRAINT area_conhecimento_pkey PRIMARY KEY (id, instituicao_id);


--
-- TOC entry 5701 (class 2606 OID 9474623)
-- Name: auditoria_geral_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.auditoria_geral
    ADD CONSTRAINT auditoria_geral_pkey PRIMARY KEY (id);


--
-- TOC entry 5703 (class 2606 OID 9464052)
-- Name: calendario_turma_pk; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.calendario_turma
    ADD CONSTRAINT calendario_turma_pk PRIMARY KEY (calendario_ano_letivo_id, ano, mes, dia, turma_id);


--
-- TOC entry 6387 (class 2606 OID 9469024)
-- Name: cod_config_movimento_geral_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.config_movimento_geral
    ADD CONSTRAINT cod_config_movimento_geral_pkey PRIMARY KEY (id);


--
-- TOC entry 5709 (class 2606 OID 9464054)
-- Name: componente_curricular_ano_escolar_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.componente_curricular_ano_escolar
    ADD CONSTRAINT componente_curricular_ano_escolar_pkey PRIMARY KEY (componente_curricular_id, ano_escolar_id);


--
-- TOC entry 5707 (class 2606 OID 9464056)
-- Name: componente_curricular_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.componente_curricular
    ADD CONSTRAINT componente_curricular_pkey PRIMARY KEY (id, instituicao_id);


--
-- TOC entry 5711 (class 2606 OID 9464058)
-- Name: componente_curricular_turma_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.componente_curricular_turma
    ADD CONSTRAINT componente_curricular_turma_pkey PRIMARY KEY (componente_curricular_id, turma_id);


--
-- TOC entry 5714 (class 2606 OID 9464060)
-- Name: docente_licenciatura_curso_unique; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.docente_licenciatura
    ADD CONSTRAINT docente_licenciatura_curso_unique UNIQUE (servidor_id, curso_id, ies_id);


--
-- TOC entry 5717 (class 2606 OID 9464062)
-- Name: docente_licenciatura_pk; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.docente_licenciatura
    ADD CONSTRAINT docente_licenciatura_pk PRIMARY KEY (id);


--
-- TOC entry 5719 (class 2606 OID 9464064)
-- Name: educacenso_cod_aluno_pk; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.educacenso_cod_aluno
    ADD CONSTRAINT educacenso_cod_aluno_pk PRIMARY KEY (cod_aluno, cod_aluno_inep);


--
-- TOC entry 5721 (class 2606 OID 9464066)
-- Name: educacenso_cod_docente_pk; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.educacenso_cod_docente
    ADD CONSTRAINT educacenso_cod_docente_pk PRIMARY KEY (cod_servidor, cod_docente_inep);


--
-- TOC entry 5723 (class 2606 OID 9464068)
-- Name: educacenso_cod_escola_pk; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.educacenso_cod_escola
    ADD CONSTRAINT educacenso_cod_escola_pk PRIMARY KEY (cod_escola, cod_escola_inep);


--
-- TOC entry 5725 (class 2606 OID 9464070)
-- Name: educacenso_cod_turma_pk; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.educacenso_cod_turma
    ADD CONSTRAINT educacenso_cod_turma_pk PRIMARY KEY (cod_turma, cod_turma_inep);


--
-- TOC entry 5727 (class 2606 OID 9464072)
-- Name: educacenso_curso_superior_pk; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.educacenso_curso_superior
    ADD CONSTRAINT educacenso_curso_superior_pk PRIMARY KEY (id);


--
-- TOC entry 5729 (class 2606 OID 9464074)
-- Name: educacenso_ies_pk; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.educacenso_ies
    ADD CONSTRAINT educacenso_ies_pk PRIMARY KEY (id);


--
-- TOC entry 5733 (class 2606 OID 9464076)
-- Name: empresa_transporte_escolar_cod_empresa_transporte_escolar_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.empresa_transporte_escolar
    ADD CONSTRAINT empresa_transporte_escolar_cod_empresa_transporte_escolar_pkey PRIMARY KEY (cod_empresa_transporte_escolar);


--
-- TOC entry 5735 (class 2606 OID 9464078)
-- Name: etapas_curso_educacenso_pk; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.etapas_curso_educacenso
    ADD CONSTRAINT etapas_curso_educacenso_pk PRIMARY KEY (etapa_id, curso_id);


--
-- TOC entry 5737 (class 2606 OID 9464080)
-- Name: etapas_educacenso_pk; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.etapas_educacenso
    ADD CONSTRAINT etapas_educacenso_pk PRIMARY KEY (id);


--
-- TOC entry 5739 (class 2606 OID 9464082)
-- Name: falta_aluno_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.falta_aluno
    ADD CONSTRAINT falta_aluno_pkey PRIMARY KEY (id);


--
-- TOC entry 5743 (class 2606 OID 9464084)
-- Name: falta_componente_curricular_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.falta_componente_curricular
    ADD CONSTRAINT falta_componente_curricular_pkey PRIMARY KEY (falta_aluno_id, componente_curricular_id, etapa);


--
-- TOC entry 5746 (class 2606 OID 9464086)
-- Name: falta_geral_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.falta_geral
    ADD CONSTRAINT falta_geral_pkey PRIMARY KEY (falta_aluno_id, etapa);


--
-- TOC entry 5749 (class 2606 OID 9464088)
-- Name: ficha_medica_cod_aluno_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.ficha_medica_aluno
    ADD CONSTRAINT ficha_medica_cod_aluno_pkey PRIMARY KEY (ref_cod_aluno);


--
-- TOC entry 5751 (class 2606 OID 9464090)
-- Name: formula_media_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.formula_media
    ADD CONSTRAINT formula_media_pkey PRIMARY KEY (id, instituicao_id);


--
-- TOC entry 5753 (class 2606 OID 9464092)
-- Name: itinerario_transporte_escolar_cod_itinerario_transporte_escolar; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.itinerario_transporte_escolar
    ADD CONSTRAINT itinerario_transporte_escolar_cod_itinerario_transporte_escolar PRIMARY KEY (cod_itinerario_transporte_escolar);


--
-- TOC entry 5755 (class 2606 OID 9464094)
-- Name: lingua_indigena_educacenso_pk; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.lingua_indigena_educacenso
    ADD CONSTRAINT lingua_indigena_educacenso_pk PRIMARY KEY (id);


--
-- TOC entry 5757 (class 2606 OID 9464096)
-- Name: media_geral_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.media_geral
    ADD CONSTRAINT media_geral_pkey PRIMARY KEY (nota_aluno_id, etapa);


--
-- TOC entry 5759 (class 2606 OID 9464098)
-- Name: moradia_aluno_pkei; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.moradia_aluno
    ADD CONSTRAINT moradia_aluno_pkei PRIMARY KEY (ref_cod_aluno);


--
-- TOC entry 5761 (class 2606 OID 9464100)
-- Name: motorista_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.motorista
    ADD CONSTRAINT motorista_pkey PRIMARY KEY (cod_motorista);


--
-- TOC entry 5765 (class 2606 OID 9464102)
-- Name: nota_aluno_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.nota_aluno
    ADD CONSTRAINT nota_aluno_pkey PRIMARY KEY (id);


--
-- TOC entry 5772 (class 2606 OID 9464104)
-- Name: nota_componente_curricular_media_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.nota_componente_curricular_media
    ADD CONSTRAINT nota_componente_curricular_media_pkey PRIMARY KEY (nota_aluno_id, componente_curricular_id);


--
-- TOC entry 5770 (class 2606 OID 9464106)
-- Name: nota_componente_curricular_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.nota_componente_curricular
    ADD CONSTRAINT nota_componente_curricular_pkey PRIMARY KEY (nota_aluno_id, componente_curricular_id, etapa);


--
-- TOC entry 5774 (class 2606 OID 9464108)
-- Name: nota_geral_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.nota_geral
    ADD CONSTRAINT nota_geral_pkey PRIMARY KEY (id);


--
-- TOC entry 5777 (class 2606 OID 9464110)
-- Name: parecer_aluno_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.parecer_aluno
    ADD CONSTRAINT parecer_aluno_pkey PRIMARY KEY (id);


--
-- TOC entry 5780 (class 2606 OID 9474537)
-- Name: parecer_componente_curricular_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.parecer_componente_curricular
    ADD CONSTRAINT parecer_componente_curricular_pkey PRIMARY KEY (parecer_aluno_id, componente_curricular_id, etapa);


--
-- TOC entry 5783 (class 2606 OID 9474535)
-- Name: parecer_geral_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.parecer_geral
    ADD CONSTRAINT parecer_geral_pkey PRIMARY KEY (parecer_aluno_id, etapa);


--
-- TOC entry 5785 (class 2606 OID 9464116)
-- Name: pessoa_transporte_cod_pessoa_transporte_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.pessoa_transporte
    ADD CONSTRAINT pessoa_transporte_cod_pessoa_transporte_pkey PRIMARY KEY (cod_pessoa_transporte);


--
-- TOC entry 6391 (class 2606 OID 9474462)
-- Name: pk_educacenso_orgao_regional; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.educacenso_orgao_regional
    ADD CONSTRAINT pk_educacenso_orgao_regional PRIMARY KEY (sigla_uf, codigo);


--
-- TOC entry 5787 (class 2606 OID 9464118)
-- Name: ponto_transporte_escolar_cod_ponto_transporte_escolar_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.ponto_transporte_escolar
    ADD CONSTRAINT ponto_transporte_escolar_cod_ponto_transporte_escolar_pkey PRIMARY KEY (cod_ponto_transporte_escolar);


--
-- TOC entry 5791 (class 2606 OID 9464120)
-- Name: professor_turma_disciplina_pk; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.professor_turma_disciplina
    ADD CONSTRAINT professor_turma_disciplina_pk PRIMARY KEY (professor_turma_id, componente_curricular_id);


--
-- TOC entry 5789 (class 2606 OID 9464122)
-- Name: professor_turma_id_pk; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.professor_turma
    ADD CONSTRAINT professor_turma_id_pk PRIMARY KEY (id);


--
-- TOC entry 5794 (class 2606 OID 9464124)
-- Name: regra_avaliacao_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.regra_avaliacao
    ADD CONSTRAINT regra_avaliacao_pkey PRIMARY KEY (id, instituicao_id);


--
-- TOC entry 5796 (class 2606 OID 9464126)
-- Name: regra_avaliacao_recuperacao_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.regra_avaliacao_recuperacao
    ADD CONSTRAINT regra_avaliacao_recuperacao_pkey PRIMARY KEY (id);


--
-- TOC entry 6393 (class 2606 OID 9474574)
-- Name: regra_avaliacao_serie_ano_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.regra_avaliacao_serie_ano
    ADD CONSTRAINT regra_avaliacao_serie_ano_pkey PRIMARY KEY (serie_id, ano_letivo);


--
-- TOC entry 5798 (class 2606 OID 9464128)
-- Name: rota_transporte_escolar_cod_rota_transporte_escolar_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.rota_transporte_escolar
    ADD CONSTRAINT rota_transporte_escolar_cod_rota_transporte_escolar_pkey PRIMARY KEY (cod_rota_transporte_escolar);


--
-- TOC entry 5801 (class 2606 OID 9464130)
-- Name: tabela_arredondamento_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.tabela_arredondamento
    ADD CONSTRAINT tabela_arredondamento_pkey PRIMARY KEY (id, instituicao_id);


--
-- TOC entry 5804 (class 2606 OID 9464132)
-- Name: tabela_arredondamento_valor_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.tabela_arredondamento_valor
    ADD CONSTRAINT tabela_arredondamento_valor_pkey PRIMARY KEY (id);


--
-- TOC entry 5806 (class 2606 OID 9464134)
-- Name: tipo_veiculo_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.tipo_veiculo
    ADD CONSTRAINT tipo_veiculo_pkey PRIMARY KEY (cod_tipo_veiculo);


--
-- TOC entry 5808 (class 2606 OID 9464136)
-- Name: transporte_aluno_pk; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.transporte_aluno
    ADD CONSTRAINT transporte_aluno_pk PRIMARY KEY (aluno_id);


--
-- TOC entry 5810 (class 2606 OID 9464138)
-- Name: uniforme_aluno_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.uniforme_aluno
    ADD CONSTRAINT uniforme_aluno_pkey PRIMARY KEY (ref_cod_aluno);


--
-- TOC entry 5812 (class 2606 OID 9464140)
-- Name: veiculo_pkey; Type: CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.veiculo
    ADD CONSTRAINT veiculo_pkey PRIMARY KEY (cod_veiculo);


--
-- TOC entry 5816 (class 2606 OID 9464142)
-- Name: acao_governo_arquivo_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_arquivo
    ADD CONSTRAINT acao_governo_arquivo_pkey PRIMARY KEY (cod_acao_governo_arquivo);


--
-- TOC entry 5818 (class 2606 OID 9464144)
-- Name: acao_governo_categoria_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_categoria
    ADD CONSTRAINT acao_governo_categoria_pkey PRIMARY KEY (ref_cod_categoria, ref_cod_acao_governo);


--
-- TOC entry 5820 (class 2606 OID 9464146)
-- Name: acao_governo_foto_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_foto
    ADD CONSTRAINT acao_governo_foto_pkey PRIMARY KEY (cod_acao_governo_foto);


--
-- TOC entry 5822 (class 2606 OID 9464148)
-- Name: acao_governo_foto_portal_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_foto_portal
    ADD CONSTRAINT acao_governo_foto_portal_pkey PRIMARY KEY (ref_cod_acao_governo, ref_cod_foto_portal);


--
-- TOC entry 5824 (class 2606 OID 9464150)
-- Name: acao_governo_noticia_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_noticia
    ADD CONSTRAINT acao_governo_noticia_pkey PRIMARY KEY (ref_cod_acao_governo, ref_cod_not_portal);


--
-- TOC entry 5814 (class 2606 OID 9464152)
-- Name: acao_governo_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo
    ADD CONSTRAINT acao_governo_pkey PRIMARY KEY (cod_acao_governo);


--
-- TOC entry 5826 (class 2606 OID 9464154)
-- Name: acao_governo_setor_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_setor
    ADD CONSTRAINT acao_governo_setor_pkey PRIMARY KEY (ref_cod_acao_governo, ref_cod_setor);


--
-- TOC entry 5828 (class 2606 OID 9464156)
-- Name: categoria_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.categoria
    ADD CONSTRAINT categoria_pkey PRIMARY KEY (cod_categoria);


--
-- TOC entry 5830 (class 2606 OID 9464158)
-- Name: secretaria_responsavel_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.secretaria_responsavel
    ADD CONSTRAINT secretaria_responsavel_pkey PRIMARY KEY (ref_cod_setor);


--
-- TOC entry 5832 (class 2606 OID 9464160)
-- Name: acontecimento_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.acontecimento
    ADD CONSTRAINT acontecimento_pkey PRIMARY KEY (cod_acontecimento);


--
-- TOC entry 5834 (class 2606 OID 9464162)
-- Name: artigo_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.artigo
    ADD CONSTRAINT artigo_pkey PRIMARY KEY (cod_artigo);


--
-- TOC entry 5836 (class 2606 OID 9464164)
-- Name: foto_evento_pk; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.foto_evento
    ADD CONSTRAINT foto_evento_pk PRIMARY KEY (cod_foto_evento);


--
-- TOC entry 5838 (class 2606 OID 9464166)
-- Name: foto_vinc_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.foto_vinc
    ADD CONSTRAINT foto_vinc_pkey PRIMARY KEY (cod_foto_vinc);


--
-- TOC entry 5840 (class 2606 OID 9464168)
-- Name: itinerario_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.itinerario
    ADD CONSTRAINT itinerario_pkey PRIMARY KEY (cod_itinerario);


--
-- TOC entry 5842 (class 2606 OID 9464170)
-- Name: menu_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.menu
    ADD CONSTRAINT menu_pkey PRIMARY KEY (cod_menu);


--
-- TOC entry 5844 (class 2606 OID 9464172)
-- Name: menu_portal_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.menu_portal
    ADD CONSTRAINT menu_portal_pkey PRIMARY KEY (cod_menu_portal);


--
-- TOC entry 5846 (class 2606 OID 9464174)
-- Name: portais_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.portais
    ADD CONSTRAINT portais_pkey PRIMARY KEY (cod_portais);


--
-- TOC entry 5848 (class 2606 OID 9464176)
-- Name: servicos_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.servicos
    ADD CONSTRAINT servicos_pkey PRIMARY KEY (cod_servicos);


--
-- TOC entry 5850 (class 2606 OID 9464178)
-- Name: sistema_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.sistema
    ADD CONSTRAINT sistema_pkey PRIMARY KEY (cod_sistema);


--
-- TOC entry 5852 (class 2606 OID 9464180)
-- Name: submenu_portal_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.submenu_portal
    ADD CONSTRAINT submenu_portal_pkey PRIMARY KEY (cod_submenu_portal);


--
-- TOC entry 5854 (class 2606 OID 9464182)
-- Name: telefones_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.telefones
    ADD CONSTRAINT telefones_pkey PRIMARY KEY (cod_telefones);


--
-- TOC entry 5856 (class 2606 OID 9464184)
-- Name: tipo_acontecimento_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.tipo_acontecimento
    ADD CONSTRAINT tipo_acontecimento_pkey PRIMARY KEY (cod_tipo_acontecimento);


--
-- TOC entry 5858 (class 2606 OID 9464186)
-- Name: topo_portal_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.topo_portal
    ADD CONSTRAINT topo_portal_pkey PRIMARY KEY (cod_topo_portal);


--
-- TOC entry 5860 (class 2606 OID 9464188)
-- Name: tutormenu_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.tutormenu
    ADD CONSTRAINT tutormenu_pkey PRIMARY KEY (cod_tutormenu);


--
-- TOC entry 5864 (class 2606 OID 9464190)
-- Name: diaria_grupo_pkey; Type: CONSTRAINT; Schema: pmidrh; Owner: -
--

ALTER TABLE ONLY pmidrh.diaria_grupo
    ADD CONSTRAINT diaria_grupo_pkey PRIMARY KEY (cod_diaria_grupo);


--
-- TOC entry 5862 (class 2606 OID 9464192)
-- Name: diaria_pkey; Type: CONSTRAINT; Schema: pmidrh; Owner: -
--

ALTER TABLE ONLY pmidrh.diaria
    ADD CONSTRAINT diaria_pkey PRIMARY KEY (cod_diaria);


--
-- TOC entry 5866 (class 2606 OID 9464194)
-- Name: diaria_valores_pkey; Type: CONSTRAINT; Schema: pmidrh; Owner: -
--

ALTER TABLE ONLY pmidrh.diaria_valores
    ADD CONSTRAINT diaria_valores_pkey PRIMARY KEY (cod_diaria_valores);


--
-- TOC entry 5868 (class 2606 OID 9464196)
-- Name: setor_pkey; Type: CONSTRAINT; Schema: pmidrh; Owner: -
--

ALTER TABLE ONLY pmidrh.setor
    ADD CONSTRAINT setor_pkey PRIMARY KEY (cod_setor);


--
-- TOC entry 5874 (class 2606 OID 9464198)
-- Name: acervo_acervo_assunto_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_acervo_assunto
    ADD CONSTRAINT acervo_acervo_assunto_pkey PRIMARY KEY (ref_cod_acervo, ref_cod_acervo_assunto);


--
-- TOC entry 5876 (class 2606 OID 9464200)
-- Name: acervo_acervo_autor_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_acervo_autor
    ADD CONSTRAINT acervo_acervo_autor_pkey PRIMARY KEY (ref_cod_acervo_autor, ref_cod_acervo);


--
-- TOC entry 5878 (class 2606 OID 9464202)
-- Name: acervo_assunto_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_assunto
    ADD CONSTRAINT acervo_assunto_pkey PRIMARY KEY (cod_acervo_assunto);


--
-- TOC entry 5880 (class 2606 OID 9464204)
-- Name: acervo_autor_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_autor
    ADD CONSTRAINT acervo_autor_pkey PRIMARY KEY (cod_acervo_autor);


--
-- TOC entry 5882 (class 2606 OID 9464206)
-- Name: acervo_colecao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_colecao
    ADD CONSTRAINT acervo_colecao_pkey PRIMARY KEY (cod_acervo_colecao);


--
-- TOC entry 5884 (class 2606 OID 9464208)
-- Name: acervo_editora_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_editora
    ADD CONSTRAINT acervo_editora_pkey PRIMARY KEY (cod_acervo_editora);


--
-- TOC entry 5886 (class 2606 OID 9464210)
-- Name: acervo_idioma_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_idioma
    ADD CONSTRAINT acervo_idioma_pkey PRIMARY KEY (cod_acervo_idioma);


--
-- TOC entry 5872 (class 2606 OID 9464212)
-- Name: acervo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo
    ADD CONSTRAINT acervo_pkey PRIMARY KEY (cod_acervo);


--
-- TOC entry 5896 (class 2606 OID 9464214)
-- Name: aluno_aluno_beneficio_pk; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.aluno_aluno_beneficio
    ADD CONSTRAINT aluno_aluno_beneficio_pk PRIMARY KEY (aluno_id, aluno_beneficio_id);


--
-- TOC entry 5898 (class 2606 OID 9464216)
-- Name: aluno_beneficio_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.aluno_beneficio
    ADD CONSTRAINT aluno_beneficio_pkey PRIMARY KEY (cod_aluno_beneficio);


--
-- TOC entry 5888 (class 2606 OID 9464218)
-- Name: aluno_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.aluno
    ADD CONSTRAINT aluno_pkey PRIMARY KEY (cod_aluno);


--
-- TOC entry 5890 (class 2606 OID 9464220)
-- Name: aluno_ref_idpes_un; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.aluno
    ADD CONSTRAINT aluno_ref_idpes_un UNIQUE (ref_idpes);


--
-- TOC entry 5903 (class 2606 OID 9464222)
-- Name: ano_letivo_modulo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.ano_letivo_modulo
    ADD CONSTRAINT ano_letivo_modulo_pkey PRIMARY KEY (ref_ano, ref_ref_cod_escola, sequencial, ref_cod_modulo);


--
-- TOC entry 5905 (class 2606 OID 9464224)
-- Name: auditoria_falta_componente_dispensa_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.auditoria_falta_componente_dispensa
    ADD CONSTRAINT auditoria_falta_componente_dispensa_pkey PRIMARY KEY (id);


--
-- TOC entry 5907 (class 2606 OID 9464226)
-- Name: auditoria_nota_dispensa_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.auditoria_nota_dispensa
    ADD CONSTRAINT auditoria_nota_dispensa_pkey PRIMARY KEY (id);


--
-- TOC entry 5909 (class 2606 OID 9464228)
-- Name: avaliacao_desempenho_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.avaliacao_desempenho
    ADD CONSTRAINT avaliacao_desempenho_pkey PRIMARY KEY (sequencial, ref_cod_servidor, ref_ref_cod_instituicao);


--
-- TOC entry 5911 (class 2606 OID 9464230)
-- Name: backup_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.backup
    ADD CONSTRAINT backup_pkey PRIMARY KEY (id);


--
-- TOC entry 5915 (class 2606 OID 9464232)
-- Name: biblioteca_dia_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.biblioteca_dia
    ADD CONSTRAINT biblioteca_dia_pkey PRIMARY KEY (ref_cod_biblioteca, dia);


--
-- TOC entry 5917 (class 2606 OID 9464234)
-- Name: biblioteca_feriados_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.biblioteca_feriados
    ADD CONSTRAINT biblioteca_feriados_pkey PRIMARY KEY (cod_feriado);


--
-- TOC entry 5913 (class 2606 OID 9464236)
-- Name: biblioteca_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.biblioteca
    ADD CONSTRAINT biblioteca_pkey PRIMARY KEY (cod_biblioteca);


--
-- TOC entry 5919 (class 2606 OID 9464238)
-- Name: biblioteca_usuario_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.biblioteca_usuario
    ADD CONSTRAINT biblioteca_usuario_pkey PRIMARY KEY (ref_cod_biblioteca, ref_cod_usuario);


--
-- TOC entry 5926 (class 2606 OID 9464240)
-- Name: calendario_ano_letivo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_ano_letivo
    ADD CONSTRAINT calendario_ano_letivo_pkey PRIMARY KEY (cod_calendario_ano_letivo);


--
-- TOC entry 5932 (class 2606 OID 9464242)
-- Name: calendario_anotacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_anotacao
    ADD CONSTRAINT calendario_anotacao_pkey PRIMARY KEY (cod_calendario_anotacao);


--
-- TOC entry 5941 (class 2606 OID 9464244)
-- Name: calendario_dia_anotacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_dia_anotacao
    ADD CONSTRAINT calendario_dia_anotacao_pkey PRIMARY KEY (ref_dia, ref_mes, ref_ref_cod_calendario_ano_letivo, ref_cod_calendario_anotacao);


--
-- TOC entry 5943 (class 2606 OID 9464246)
-- Name: calendario_dia_motivo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_dia_motivo
    ADD CONSTRAINT calendario_dia_motivo_pkey PRIMARY KEY (cod_calendario_dia_motivo);


--
-- TOC entry 5934 (class 2606 OID 9464248)
-- Name: calendario_dia_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_dia
    ADD CONSTRAINT calendario_dia_pkey PRIMARY KEY (ref_cod_calendario_ano_letivo, mes, dia);


--
-- TOC entry 5952 (class 2606 OID 9464250)
-- Name: categoria_nivel_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.categoria_nivel
    ADD CONSTRAINT categoria_nivel_pkey PRIMARY KEY (cod_categoria_nivel);


--
-- TOC entry 5954 (class 2606 OID 9464252)
-- Name: categoria_obra_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.categoria_obra
    ADD CONSTRAINT categoria_obra_pkey PRIMARY KEY (id);


--
-- TOC entry 5956 (class 2606 OID 9464254)
-- Name: cliente_login_ukey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente
    ADD CONSTRAINT cliente_login_ukey UNIQUE (login);


--
-- TOC entry 5958 (class 2606 OID 9464256)
-- Name: cliente_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente
    ADD CONSTRAINT cliente_pkey PRIMARY KEY (cod_cliente);


--
-- TOC entry 5960 (class 2606 OID 9464258)
-- Name: cliente_suspensao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente_suspensao
    ADD CONSTRAINT cliente_suspensao_pkey PRIMARY KEY (sequencial, ref_cod_cliente, ref_cod_motivo_suspensao);


--
-- TOC entry 5964 (class 2606 OID 9464260)
-- Name: cliente_tipo_cliente_pk; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente_tipo_cliente
    ADD CONSTRAINT cliente_tipo_cliente_pk PRIMARY KEY (ref_cod_cliente_tipo, ref_cod_cliente);


--
-- TOC entry 5966 (class 2606 OID 9464262)
-- Name: cliente_tipo_exemplar_tipo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente_tipo_exemplar_tipo
    ADD CONSTRAINT cliente_tipo_exemplar_tipo_pkey PRIMARY KEY (ref_cod_cliente_tipo, ref_cod_exemplar_tipo);


--
-- TOC entry 5962 (class 2606 OID 9464264)
-- Name: cliente_tipo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente_tipo
    ADD CONSTRAINT cliente_tipo_pkey PRIMARY KEY (cod_cliente_tipo);


--
-- TOC entry 5950 (class 2606 OID 9464266)
-- Name: cod_candidato_reserva_vaga_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.candidato_reserva_vaga
    ADD CONSTRAINT cod_candidato_reserva_vaga_pkey PRIMARY KEY (cod_candidato_reserva_vaga);


--
-- TOC entry 5995 (class 2606 OID 9464268)
-- Name: cod_disciplina_dependencia_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.disciplina_dependencia
    ADD CONSTRAINT cod_disciplina_dependencia_pkey PRIMARY KEY (cod_disciplina_dependencia);


--
-- TOC entry 6004 (class 2606 OID 9464270)
-- Name: cod_dispensa_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.dispensa_disciplina
    ADD CONSTRAINT cod_dispensa_pkey PRIMARY KEY (cod_dispensa);


--
-- TOC entry 6177 (class 2606 OID 9464272)
-- Name: cod_serie_vaga_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.serie_vaga
    ADD CONSTRAINT cod_serie_vaga_pkey PRIMARY KEY (cod_serie_vaga);


--
-- TOC entry 6179 (class 2606 OID 9464274)
-- Name: cod_serie_vaga_unique; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.serie_vaga
    ADD CONSTRAINT cod_serie_vaga_unique UNIQUE (ano, ref_cod_instituicao, ref_cod_escola, ref_cod_curso, ref_cod_serie, turno);


--
-- TOC entry 6199 (class 2606 OID 9464276)
-- Name: cod_servidor_funcao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_funcao
    ADD CONSTRAINT cod_servidor_funcao_pkey PRIMARY KEY (cod_servidor_funcao);


--
-- TOC entry 5968 (class 2606 OID 9464278)
-- Name: coffebreak_tipo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.coffebreak_tipo
    ADD CONSTRAINT coffebreak_tipo_pkey PRIMARY KEY (cod_coffebreak_tipo);


--
-- TOC entry 5974 (class 2606 OID 9464280)
-- Name: curso_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.curso
    ADD CONSTRAINT curso_pkey PRIMARY KEY (cod_curso);


--
-- TOC entry 5987 (class 2606 OID 9464282)
-- Name: disciplina_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.disciplina
    ADD CONSTRAINT disciplina_pkey PRIMARY KEY (cod_disciplina);


--
-- TOC entry 5997 (class 2606 OID 9464284)
-- Name: disciplina_serie_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.disciplina_serie
    ADD CONSTRAINT disciplina_serie_pkey PRIMARY KEY (ref_cod_disciplina, ref_cod_serie);


--
-- TOC entry 5999 (class 2606 OID 9464286)
-- Name: disciplina_topico_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.disciplina_topico
    ADD CONSTRAINT disciplina_topico_pkey PRIMARY KEY (cod_disciplina_topico);


--
-- TOC entry 6007 (class 2606 OID 9464288)
-- Name: distribuicao_uniforme_cod_distribuicao_uniforme_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.distribuicao_uniforme
    ADD CONSTRAINT distribuicao_uniforme_cod_distribuicao_uniforme_pkey PRIMARY KEY (cod_distribuicao_uniforme);


--
-- TOC entry 6017 (class 2606 OID 9464290)
-- Name: escola_ano_letivo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_ano_letivo
    ADD CONSTRAINT escola_ano_letivo_pkey PRIMARY KEY (ref_cod_escola, ano);


--
-- TOC entry 6019 (class 2606 OID 9464292)
-- Name: escola_complemento_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_complemento
    ADD CONSTRAINT escola_complemento_pkey PRIMARY KEY (ref_cod_escola);


--
-- TOC entry 6031 (class 2606 OID 9464294)
-- Name: escola_curso_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_curso
    ADD CONSTRAINT escola_curso_pkey PRIMARY KEY (ref_cod_escola, ref_cod_curso);


--
-- TOC entry 6035 (class 2606 OID 9464296)
-- Name: escola_localizacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_localizacao
    ADD CONSTRAINT escola_localizacao_pkey PRIMARY KEY (cod_escola_localizacao);


--
-- TOC entry 6009 (class 2606 OID 9464298)
-- Name: escola_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola
    ADD CONSTRAINT escola_pkey PRIMARY KEY (cod_escola);


--
-- TOC entry 6040 (class 2606 OID 9464300)
-- Name: escola_rede_ensino_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_rede_ensino
    ADD CONSTRAINT escola_rede_ensino_pkey PRIMARY KEY (cod_escola_rede_ensino);


--
-- TOC entry 6051 (class 2606 OID 9464302)
-- Name: escola_serie_disciplina_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_serie_disciplina
    ADD CONSTRAINT escola_serie_disciplina_pkey PRIMARY KEY (ref_ref_cod_serie, ref_ref_cod_escola, ref_cod_disciplina);


--
-- TOC entry 6045 (class 2606 OID 9464304)
-- Name: escola_serie_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_serie
    ADD CONSTRAINT escola_serie_pkey PRIMARY KEY (ref_cod_escola, ref_cod_serie);


--
-- TOC entry 6053 (class 2606 OID 9464306)
-- Name: escola_usuario_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_usuario
    ADD CONSTRAINT escola_usuario_pkey PRIMARY KEY (id);


--
-- TOC entry 6058 (class 2606 OID 9464308)
-- Name: exemplar_emprestimo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.exemplar_emprestimo
    ADD CONSTRAINT exemplar_emprestimo_pkey PRIMARY KEY (cod_emprestimo);


--
-- TOC entry 6055 (class 2606 OID 9464310)
-- Name: exemplar_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.exemplar
    ADD CONSTRAINT exemplar_pkey PRIMARY KEY (cod_exemplar);


--
-- TOC entry 6060 (class 2606 OID 9464312)
-- Name: exemplar_tipo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.exemplar_tipo
    ADD CONSTRAINT exemplar_tipo_pkey PRIMARY KEY (cod_exemplar_tipo);


--
-- TOC entry 6062 (class 2606 OID 9464314)
-- Name: falta_aluno_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.falta_aluno
    ADD CONSTRAINT falta_aluno_pkey PRIMARY KEY (cod_falta_aluno);


--
-- TOC entry 6066 (class 2606 OID 9464316)
-- Name: falta_atraso_compensado_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.falta_atraso_compensado
    ADD CONSTRAINT falta_atraso_compensado_pkey PRIMARY KEY (cod_compensado);


--
-- TOC entry 6064 (class 2606 OID 9464318)
-- Name: falta_atraso_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.falta_atraso
    ADD CONSTRAINT falta_atraso_pkey PRIMARY KEY (cod_falta_atraso);


--
-- TOC entry 6068 (class 2606 OID 9464320)
-- Name: faltas_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.faltas
    ADD CONSTRAINT faltas_pkey PRIMARY KEY (ref_cod_matricula, sequencial);


--
-- TOC entry 5924 (class 2606 OID 9464322)
-- Name: fk_bloqueio_lancamento_faltas_notas; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.bloqueio_lancamento_faltas_notas
    ADD CONSTRAINT fk_bloqueio_lancamento_faltas_notas PRIMARY KEY (cod_bloqueio);


--
-- TOC entry 6070 (class 2606 OID 9464324)
-- Name: fonte_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.fonte
    ADD CONSTRAINT fonte_pkey PRIMARY KEY (cod_fonte);


--
-- TOC entry 6072 (class 2606 OID 9464326)
-- Name: funcao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.funcao
    ADD CONSTRAINT funcao_pkey PRIMARY KEY (cod_funcao);


--
-- TOC entry 6084 (class 2606 OID 9464328)
-- Name: habilitacao_curso_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.habilitacao_curso
    ADD CONSTRAINT habilitacao_curso_pkey PRIMARY KEY (ref_cod_habilitacao, ref_cod_curso);


--
-- TOC entry 6079 (class 2606 OID 9464330)
-- Name: habilitacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.habilitacao
    ADD CONSTRAINT habilitacao_pkey PRIMARY KEY (cod_habilitacao);


--
-- TOC entry 6086 (class 2606 OID 9464332)
-- Name: historico_disciplinas_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.historico_disciplinas
    ADD CONSTRAINT historico_disciplinas_pkey PRIMARY KEY (sequencial, ref_ref_cod_aluno, ref_sequencial);


--
-- TOC entry 6093 (class 2606 OID 9464334)
-- Name: historico_escolar_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.historico_escolar
    ADD CONSTRAINT historico_escolar_pkey PRIMARY KEY (ref_cod_aluno, sequencial);


--
-- TOC entry 6099 (class 2606 OID 9464336)
-- Name: historico_grade_curso_pk; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.historico_grade_curso
    ADD CONSTRAINT historico_grade_curso_pk PRIMARY KEY (id);


--
-- TOC entry 6101 (class 2606 OID 9464338)
-- Name: infra_comodo_funcao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.infra_comodo_funcao
    ADD CONSTRAINT infra_comodo_funcao_pkey PRIMARY KEY (cod_infra_comodo_funcao);


--
-- TOC entry 6105 (class 2606 OID 9464340)
-- Name: infra_predio_comodo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.infra_predio_comodo
    ADD CONSTRAINT infra_predio_comodo_pkey PRIMARY KEY (cod_infra_predio_comodo);


--
-- TOC entry 6103 (class 2606 OID 9464342)
-- Name: infra_predio_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.infra_predio
    ADD CONSTRAINT infra_predio_pkey PRIMARY KEY (cod_infra_predio);


--
-- TOC entry 6109 (class 2606 OID 9464344)
-- Name: instituicao_documentacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.instituicao_documentacao
    ADD CONSTRAINT instituicao_documentacao_pkey PRIMARY KEY (id);


--
-- TOC entry 6107 (class 2606 OID 9464346)
-- Name: instituicao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.instituicao
    ADD CONSTRAINT instituicao_pkey PRIMARY KEY (cod_instituicao);


--
-- TOC entry 6111 (class 2606 OID 9464348)
-- Name: material_didatico_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.material_didatico
    ADD CONSTRAINT material_didatico_pkey PRIMARY KEY (cod_material_didatico);


--
-- TOC entry 6113 (class 2606 OID 9464350)
-- Name: material_tipo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.material_tipo
    ADD CONSTRAINT material_tipo_pkey PRIMARY KEY (cod_material_tipo);


--
-- TOC entry 6120 (class 2606 OID 9464352)
-- Name: matricula_excessao_pk; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula_excessao
    ADD CONSTRAINT matricula_excessao_pk PRIMARY KEY (cod_aluno_excessao);


--
-- TOC entry 6122 (class 2606 OID 9464354)
-- Name: matricula_ocorrencia_disciplinar_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula_ocorrencia_disciplinar
    ADD CONSTRAINT matricula_ocorrencia_disciplinar_pkey PRIMARY KEY (ref_cod_matricula, ref_cod_tipo_ocorrencia_disciplinar, sequencial);


--
-- TOC entry 6118 (class 2606 OID 9464356)
-- Name: matricula_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula
    ADD CONSTRAINT matricula_pkey PRIMARY KEY (cod_matricula);


--
-- TOC entry 6125 (class 2606 OID 9464358)
-- Name: matricula_turma_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula_turma
    ADD CONSTRAINT matricula_turma_pkey PRIMARY KEY (ref_cod_matricula, ref_cod_turma, sequencial);


--
-- TOC entry 6127 (class 2606 OID 9464360)
-- Name: menu_tipo_usuario_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.menu_tipo_usuario
    ADD CONSTRAINT menu_tipo_usuario_pkey PRIMARY KEY (ref_cod_tipo_usuario, ref_cod_menu_submenu);


--
-- TOC entry 6129 (class 2606 OID 9464362)
-- Name: modulo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.modulo
    ADD CONSTRAINT modulo_pkey PRIMARY KEY (cod_modulo);


--
-- TOC entry 6131 (class 2606 OID 9464364)
-- Name: motivo_afastamento_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.motivo_afastamento
    ADD CONSTRAINT motivo_afastamento_pkey PRIMARY KEY (cod_motivo_afastamento);


--
-- TOC entry 6133 (class 2606 OID 9464366)
-- Name: motivo_baixa_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.motivo_baixa
    ADD CONSTRAINT motivo_baixa_pkey PRIMARY KEY (cod_motivo_baixa);


--
-- TOC entry 6135 (class 2606 OID 9464368)
-- Name: motivo_suspensao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.motivo_suspensao
    ADD CONSTRAINT motivo_suspensao_pkey PRIMARY KEY (cod_motivo_suspensao);


--
-- TOC entry 6139 (class 2606 OID 9464370)
-- Name: nivel_ensino_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.nivel_ensino
    ADD CONSTRAINT nivel_ensino_pkey PRIMARY KEY (cod_nivel_ensino);


--
-- TOC entry 6137 (class 2606 OID 9464372)
-- Name: nivel_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.nivel
    ADD CONSTRAINT nivel_pkey PRIMARY KEY (cod_nivel);


--
-- TOC entry 6142 (class 2606 OID 9464374)
-- Name: nota_aluno_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.nota_aluno
    ADD CONSTRAINT nota_aluno_pkey PRIMARY KEY (cod_nota_aluno);


--
-- TOC entry 6144 (class 2606 OID 9464376)
-- Name: operador_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.operador
    ADD CONSTRAINT operador_pkey PRIMARY KEY (cod_operador);


--
-- TOC entry 6146 (class 2606 OID 9464378)
-- Name: pagamento_multa_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.pagamento_multa
    ADD CONSTRAINT pagamento_multa_pkey PRIMARY KEY (cod_pagamento_multa);


--
-- TOC entry 5870 (class 2606 OID 9464380)
-- Name: pk_cod_abandono_tipo; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.abandono_tipo
    ADD CONSTRAINT pk_cod_abandono_tipo PRIMARY KEY (cod_abandono_tipo);


--
-- TOC entry 5922 (class 2606 OID 9464382)
-- Name: pmieducar_bloqueio_ano_letivo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.bloqueio_ano_letivo
    ADD CONSTRAINT pmieducar_bloqueio_ano_letivo_pkey PRIMARY KEY (ref_cod_instituicao, ref_ano);


--
-- TOC entry 6152 (class 2606 OID 9464384)
-- Name: pmieducar_projeto_aluno_pk; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.projeto_aluno
    ADD CONSTRAINT pmieducar_projeto_aluno_pk PRIMARY KEY (ref_cod_projeto, ref_cod_aluno);


--
-- TOC entry 6150 (class 2606 OID 9464386)
-- Name: pmieducar_projeto_cod_projeto; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.projeto
    ADD CONSTRAINT pmieducar_projeto_cod_projeto PRIMARY KEY (cod_projeto);


--
-- TOC entry 6148 (class 2606 OID 9464388)
-- Name: pre_requisito_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.pre_requisito
    ADD CONSTRAINT pre_requisito_pkey PRIMARY KEY (cod_pre_requisito);


--
-- TOC entry 6159 (class 2606 OID 9464390)
-- Name: quadro_horario_horarios_aux_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.quadro_horario_horarios_aux
    ADD CONSTRAINT quadro_horario_horarios_aux_pkey PRIMARY KEY (ref_cod_quadro_horario, sequencial);


--
-- TOC entry 6157 (class 2606 OID 9464392)
-- Name: quadro_horario_horarios_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.quadro_horario_horarios
    ADD CONSTRAINT quadro_horario_horarios_pkey PRIMARY KEY (ref_cod_quadro_horario, sequencial);


--
-- TOC entry 6154 (class 2606 OID 9464394)
-- Name: quadro_horario_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.quadro_horario
    ADD CONSTRAINT quadro_horario_pkey PRIMARY KEY (cod_quadro_horario);


--
-- TOC entry 6161 (class 2606 OID 9464396)
-- Name: quantidade_reserva_externa_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.quantidade_reserva_externa
    ADD CONSTRAINT quantidade_reserva_externa_pkey PRIMARY KEY (ref_cod_instituicao, ref_cod_escola, ref_cod_curso, ref_cod_serie, ref_turma_turno_id, ano);


--
-- TOC entry 6163 (class 2606 OID 9464398)
-- Name: religiao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.religiao
    ADD CONSTRAINT religiao_pkey PRIMARY KEY (cod_religiao);


--
-- TOC entry 6165 (class 2606 OID 9464400)
-- Name: reserva_vaga_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.reserva_vaga
    ADD CONSTRAINT reserva_vaga_pkey PRIMARY KEY (cod_reserva_vaga);


--
-- TOC entry 6167 (class 2606 OID 9464402)
-- Name: reservas_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.reservas
    ADD CONSTRAINT reservas_pkey PRIMARY KEY (cod_reserva);


--
-- TOC entry 6169 (class 2606 OID 9464404)
-- Name: sequencia_serie_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.sequencia_serie
    ADD CONSTRAINT sequencia_serie_pkey PRIMARY KEY (ref_serie_origem, ref_serie_destino);


--
-- TOC entry 6173 (class 2606 OID 9464406)
-- Name: serie_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.serie
    ADD CONSTRAINT serie_pkey PRIMARY KEY (cod_serie);


--
-- TOC entry 6175 (class 2606 OID 9464408)
-- Name: serie_pre_requisito_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.serie_pre_requisito
    ADD CONSTRAINT serie_pre_requisito_pkey PRIMARY KEY (ref_cod_pre_requisito, ref_cod_operador, ref_cod_serie);


--
-- TOC entry 6186 (class 2606 OID 9464410)
-- Name: servidor_afastamento_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_afastamento
    ADD CONSTRAINT servidor_afastamento_pkey PRIMARY KEY (ref_cod_servidor, sequencial, ref_ref_cod_instituicao);


--
-- TOC entry 6189 (class 2606 OID 9464412)
-- Name: servidor_alocacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_alocacao
    ADD CONSTRAINT servidor_alocacao_pkey PRIMARY KEY (cod_servidor_alocacao);


--
-- TOC entry 6191 (class 2606 OID 9464414)
-- Name: servidor_curso_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_curso
    ADD CONSTRAINT servidor_curso_pkey PRIMARY KEY (cod_servidor_curso);


--
-- TOC entry 6193 (class 2606 OID 9464416)
-- Name: servidor_cuso_ministra_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_curso_ministra
    ADD CONSTRAINT servidor_cuso_ministra_pkey PRIMARY KEY (ref_cod_curso, ref_ref_cod_instituicao, ref_cod_servidor);


--
-- TOC entry 6195 (class 2606 OID 9464418)
-- Name: servidor_disciplina_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_disciplina
    ADD CONSTRAINT servidor_disciplina_pkey PRIMARY KEY (ref_cod_disciplina, ref_ref_cod_instituicao, ref_cod_servidor, ref_cod_curso);


--
-- TOC entry 6197 (class 2606 OID 9464420)
-- Name: servidor_formacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_formacao
    ADD CONSTRAINT servidor_formacao_pkey PRIMARY KEY (cod_formacao);


--
-- TOC entry 6184 (class 2606 OID 9464422)
-- Name: servidor_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor
    ADD CONSTRAINT servidor_pkey PRIMARY KEY (cod_servidor, ref_cod_instituicao);


--
-- TOC entry 6201 (class 2606 OID 9464424)
-- Name: servidor_titulo_concurso_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_titulo_concurso
    ADD CONSTRAINT servidor_titulo_concurso_pkey PRIMARY KEY (cod_servidor_titulo);


--
-- TOC entry 6203 (class 2606 OID 9464426)
-- Name: situacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.situacao
    ADD CONSTRAINT situacao_pkey PRIMARY KEY (cod_situacao);


--
-- TOC entry 6205 (class 2606 OID 9464428)
-- Name: subnivel_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.subnivel
    ADD CONSTRAINT subnivel_pkey PRIMARY KEY (cod_subnivel);


--
-- TOC entry 6207 (class 2606 OID 9464430)
-- Name: tipo_avaliacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_avaliacao
    ADD CONSTRAINT tipo_avaliacao_pkey PRIMARY KEY (cod_tipo_avaliacao);


--
-- TOC entry 6209 (class 2606 OID 9464432)
-- Name: tipo_avaliacao_valores_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_avaliacao_valores
    ADD CONSTRAINT tipo_avaliacao_valores_pkey PRIMARY KEY (ref_cod_tipo_avaliacao, sequencial);


--
-- TOC entry 6211 (class 2606 OID 9464434)
-- Name: tipo_dispensa_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_dispensa
    ADD CONSTRAINT tipo_dispensa_pkey PRIMARY KEY (cod_tipo_dispensa);


--
-- TOC entry 6213 (class 2606 OID 9464436)
-- Name: tipo_ensino_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_ensino
    ADD CONSTRAINT tipo_ensino_pkey PRIMARY KEY (cod_tipo_ensino);


--
-- TOC entry 6215 (class 2606 OID 9464438)
-- Name: tipo_ocorrencia_disciplinar_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_ocorrencia_disciplinar
    ADD CONSTRAINT tipo_ocorrencia_disciplinar_pkey PRIMARY KEY (cod_tipo_ocorrencia_disciplinar);


--
-- TOC entry 6217 (class 2606 OID 9464440)
-- Name: tipo_regime_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_regime
    ADD CONSTRAINT tipo_regime_pkey PRIMARY KEY (cod_tipo_regime);


--
-- TOC entry 6219 (class 2606 OID 9464442)
-- Name: tipo_usuario_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_usuario
    ADD CONSTRAINT tipo_usuario_pkey PRIMARY KEY (cod_tipo_usuario);


--
-- TOC entry 6221 (class 2606 OID 9464444)
-- Name: transferencia_solicitacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.transferencia_solicitacao
    ADD CONSTRAINT transferencia_solicitacao_pkey PRIMARY KEY (cod_transferencia_solicitacao);


--
-- TOC entry 6223 (class 2606 OID 9464446)
-- Name: transferencia_tipo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.transferencia_tipo
    ADD CONSTRAINT transferencia_tipo_pkey PRIMARY KEY (cod_transferencia_tipo);


--
-- TOC entry 6228 (class 2606 OID 9464450)
-- Name: turma_modulo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma_modulo
    ADD CONSTRAINT turma_modulo_pkey PRIMARY KEY (ref_cod_turma, ref_cod_modulo, sequencial);


--
-- TOC entry 6226 (class 2606 OID 9464452)
-- Name: turma_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma
    ADD CONSTRAINT turma_pkey PRIMARY KEY (cod_turma);


--
-- TOC entry 6230 (class 2606 OID 9464454)
-- Name: turma_tipo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma_tipo
    ADD CONSTRAINT turma_tipo_pkey PRIMARY KEY (cod_turma_tipo);


--
-- TOC entry 6232 (class 2606 OID 9464456)
-- Name: turma_turno_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma_turno
    ADD CONSTRAINT turma_turno_pkey PRIMARY KEY (id);


--
-- TOC entry 6234 (class 2606 OID 9464458)
-- Name: usuario_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.usuario
    ADD CONSTRAINT usuario_pkey PRIMARY KEY (cod_usuario);


--
-- TOC entry 6236 (class 2606 OID 9464460)
-- Name: funcionario_su_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.funcionario_su
    ADD CONSTRAINT funcionario_su_pkey PRIMARY KEY (ref_ref_cod_pessoa_fj);


--
-- TOC entry 6238 (class 2606 OID 9464462)
-- Name: grupomoderador_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.grupomoderador
    ADD CONSTRAINT grupomoderador_pkey PRIMARY KEY (ref_ref_cod_pessoa_fj, ref_cod_grupos);


--
-- TOC entry 6240 (class 2606 OID 9464464)
-- Name: grupopessoa_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.grupopessoa
    ADD CONSTRAINT grupopessoa_pkey PRIMARY KEY (ref_idpes, ref_cod_grupos);


--
-- TOC entry 6242 (class 2606 OID 9464466)
-- Name: grupos_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.grupos
    ADD CONSTRAINT grupos_pkey PRIMARY KEY (cod_grupos);


--
-- TOC entry 6244 (class 2606 OID 9464468)
-- Name: notas_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.notas
    ADD CONSTRAINT notas_pkey PRIMARY KEY (sequencial, ref_idpes);


--
-- TOC entry 6246 (class 2606 OID 9464470)
-- Name: participante_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.participante
    ADD CONSTRAINT participante_pkey PRIMARY KEY (sequencial, ref_ref_cod_grupos, ref_ref_idpes, ref_cod_reuniao);


--
-- TOC entry 6248 (class 2606 OID 9464472)
-- Name: reuniao_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.reuniao
    ADD CONSTRAINT reuniao_pkey PRIMARY KEY (cod_reuniao);


--
-- TOC entry 6250 (class 2606 OID 9464474)
-- Name: topico_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.topico
    ADD CONSTRAINT topico_pkey PRIMARY KEY (cod_topico);


--
-- TOC entry 6252 (class 2606 OID 9464476)
-- Name: topicoreuniao_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.topicoreuniao
    ADD CONSTRAINT topicoreuniao_pkey PRIMARY KEY (ref_cod_topico, ref_cod_reuniao);


--
-- TOC entry 6254 (class 2606 OID 9464478)
-- Name: acesso_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.acesso
    ADD CONSTRAINT acesso_pk PRIMARY KEY (cod_acesso);


--
-- TOC entry 6258 (class 2606 OID 9464480)
-- Name: agenda_compromisso_pkey; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.agenda_compromisso
    ADD CONSTRAINT agenda_compromisso_pkey PRIMARY KEY (cod_agenda_compromisso, versao, ref_cod_agenda);


--
-- TOC entry 6256 (class 2606 OID 9464482)
-- Name: agenda_pkey; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.agenda
    ADD CONSTRAINT agenda_pkey PRIMARY KEY (cod_agenda);


--
-- TOC entry 6260 (class 2606 OID 9464484)
-- Name: agenda_pref_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.agenda_pref
    ADD CONSTRAINT agenda_pref_pk PRIMARY KEY (cod_comp);


--
-- TOC entry 6262 (class 2606 OID 9464486)
-- Name: agenda_responsavel_pkey; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.agenda_responsavel
    ADD CONSTRAINT agenda_responsavel_pkey PRIMARY KEY (ref_cod_agenda, ref_ref_cod_pessoa_fj);


--
-- TOC entry 6266 (class 2606 OID 9464488)
-- Name: compras_editais_editais_empresas_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_editais_editais_empresas
    ADD CONSTRAINT compras_editais_editais_empresas_pk PRIMARY KEY (ref_cod_compras_editais_editais, ref_cod_compras_editais_empresa, data_hora);


--
-- TOC entry 6264 (class 2606 OID 9464490)
-- Name: compras_editais_editais_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_editais_editais
    ADD CONSTRAINT compras_editais_editais_pk PRIMARY KEY (cod_compras_editais_editais);


--
-- TOC entry 6268 (class 2606 OID 9464492)
-- Name: compras_editais_empresa_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_editais_empresa
    ADD CONSTRAINT compras_editais_empresa_pk PRIMARY KEY (cod_compras_editais_empresa);


--
-- TOC entry 6270 (class 2606 OID 9464494)
-- Name: compras_final_pregao_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_final_pregao
    ADD CONSTRAINT compras_final_pregao_pk PRIMARY KEY (cod_compras_final_pregao);


--
-- TOC entry 6272 (class 2606 OID 9464496)
-- Name: compras_funcionarios_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_funcionarios
    ADD CONSTRAINT compras_funcionarios_pk PRIMARY KEY (ref_ref_cod_pessoa_fj);


--
-- TOC entry 6274 (class 2606 OID 9464498)
-- Name: compras_licitacoes_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_licitacoes
    ADD CONSTRAINT compras_licitacoes_pk PRIMARY KEY (cod_compras_licitacoes);


--
-- TOC entry 6276 (class 2606 OID 9464500)
-- Name: compras_modalidade_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_modalidade
    ADD CONSTRAINT compras_modalidade_pk PRIMARY KEY (cod_compras_modalidade);


--
-- TOC entry 6278 (class 2606 OID 9464502)
-- Name: compras_pregao_execucao_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_pregao_execucao
    ADD CONSTRAINT compras_pregao_execucao_pk PRIMARY KEY (cod_compras_pregao_execucao);


--
-- TOC entry 6280 (class 2606 OID 9464504)
-- Name: compras_prestacao_contas_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_prestacao_contas
    ADD CONSTRAINT compras_prestacao_contas_pk PRIMARY KEY (cod_compras_prestacao_contas);


--
-- TOC entry 6282 (class 2606 OID 9464506)
-- Name: foto_portal_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.foto_portal
    ADD CONSTRAINT foto_portal_pk PRIMARY KEY (cod_foto_portal);


--
-- TOC entry 6284 (class 2606 OID 9464508)
-- Name: foto_secao_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.foto_secao
    ADD CONSTRAINT foto_secao_pk PRIMARY KEY (cod_foto_secao);


--
-- TOC entry 6286 (class 2606 OID 9464510)
-- Name: funcionario_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.funcionario
    ADD CONSTRAINT funcionario_pk PRIMARY KEY (ref_cod_pessoa_fj);


--
-- TOC entry 6288 (class 2606 OID 9464512)
-- Name: funcionario_vinculo_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.funcionario_vinculo
    ADD CONSTRAINT funcionario_vinculo_pk PRIMARY KEY (cod_funcionario_vinculo);


--
-- TOC entry 6290 (class 2606 OID 9464514)
-- Name: imagem_pkey; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.imagem
    ADD CONSTRAINT imagem_pkey PRIMARY KEY (cod_imagem);


--
-- TOC entry 6292 (class 2606 OID 9464516)
-- Name: imagem_tipo_pkey; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.imagem_tipo
    ADD CONSTRAINT imagem_tipo_pkey PRIMARY KEY (cod_imagem_tipo);


--
-- TOC entry 6294 (class 2606 OID 9464518)
-- Name: intranet_segur_permissao_negada_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.intranet_segur_permissao_negada
    ADD CONSTRAINT intranet_segur_permissao_negada_pk PRIMARY KEY (cod_intranet_segur_permissao_negada);


--
-- TOC entry 6296 (class 2606 OID 9464520)
-- Name: jor_arquivo_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.jor_arquivo
    ADD CONSTRAINT jor_arquivo_pk PRIMARY KEY (ref_cod_jor_edicao, jor_arquivo);


--
-- TOC entry 6298 (class 2606 OID 9464522)
-- Name: jor_edicao_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.jor_edicao
    ADD CONSTRAINT jor_edicao_pk PRIMARY KEY (cod_jor_edicao);


--
-- TOC entry 6302 (class 2606 OID 9464524)
-- Name: mailling_email_conteudo_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.mailling_email_conteudo
    ADD CONSTRAINT mailling_email_conteudo_pk PRIMARY KEY (cod_mailling_email_conteudo);


--
-- TOC entry 6300 (class 2606 OID 9464526)
-- Name: mailling_email_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.mailling_email
    ADD CONSTRAINT mailling_email_pk PRIMARY KEY (cod_mailling_email);


--
-- TOC entry 6305 (class 2606 OID 9464528)
-- Name: mailling_fila_envio_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.mailling_fila_envio
    ADD CONSTRAINT mailling_fila_envio_pk PRIMARY KEY (cod_mailling_fila_envio);


--
-- TOC entry 6312 (class 2606 OID 9464530)
-- Name: mailling_grupo_email_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.mailling_grupo_email
    ADD CONSTRAINT mailling_grupo_email_pk PRIMARY KEY (ref_cod_mailling_email, ref_cod_mailling_grupo);


--
-- TOC entry 6310 (class 2606 OID 9464532)
-- Name: mailling_grupo_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.mailling_grupo
    ADD CONSTRAINT mailling_grupo_pk PRIMARY KEY (cod_mailling_grupo);


--
-- TOC entry 6314 (class 2606 OID 9464534)
-- Name: mailling_historico_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.mailling_historico
    ADD CONSTRAINT mailling_historico_pk PRIMARY KEY (cod_mailling_historico);


--
-- TOC entry 6316 (class 2606 OID 9464536)
-- Name: menu_funcionario_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.menu_funcionario
    ADD CONSTRAINT menu_funcionario_pk PRIMARY KEY (ref_ref_cod_pessoa_fj, ref_cod_menu_submenu);


--
-- TOC entry 6318 (class 2606 OID 9464538)
-- Name: menu_menu_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.menu_menu
    ADD CONSTRAINT menu_menu_pk PRIMARY KEY (cod_menu_menu);


--
-- TOC entry 6320 (class 2606 OID 9464540)
-- Name: menu_submenu_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.menu_submenu
    ADD CONSTRAINT menu_submenu_pk PRIMARY KEY (cod_menu_submenu);


--
-- TOC entry 6322 (class 2606 OID 9464542)
-- Name: not_portal_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.not_portal
    ADD CONSTRAINT not_portal_pk PRIMARY KEY (cod_not_portal);


--
-- TOC entry 6324 (class 2606 OID 9464544)
-- Name: not_portal_tipo_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.not_portal_tipo
    ADD CONSTRAINT not_portal_tipo_pk PRIMARY KEY (ref_cod_not_portal, ref_cod_not_tipo);


--
-- TOC entry 6326 (class 2606 OID 9464546)
-- Name: not_tipo_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.not_tipo
    ADD CONSTRAINT not_tipo_pk PRIMARY KEY (cod_not_tipo);


--
-- TOC entry 6328 (class 2606 OID 9464548)
-- Name: not_vinc_portal_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.not_vinc_portal
    ADD CONSTRAINT not_vinc_portal_pk PRIMARY KEY (ref_cod_not_portal, vic_num);


--
-- TOC entry 6330 (class 2606 OID 9464550)
-- Name: pessoa_atividade_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.pessoa_atividade
    ADD CONSTRAINT pessoa_atividade_pk PRIMARY KEY (cod_pessoa_atividade);


--
-- TOC entry 6334 (class 2606 OID 9464552)
-- Name: pessoa_fj_pessoa_atividade_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.pessoa_fj_pessoa_atividade
    ADD CONSTRAINT pessoa_fj_pessoa_atividade_pk PRIMARY KEY (ref_cod_pessoa_atividade, ref_cod_pessoa_fj);


--
-- TOC entry 6332 (class 2606 OID 9464554)
-- Name: pessoa_fj_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.pessoa_fj
    ADD CONSTRAINT pessoa_fj_pk PRIMARY KEY (cod_pessoa_fj);


--
-- TOC entry 6336 (class 2606 OID 9464556)
-- Name: pessoa_ramo_atividade_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.pessoa_ramo_atividade
    ADD CONSTRAINT pessoa_ramo_atividade_pk PRIMARY KEY (cod_ramo_atividade);


--
-- TOC entry 6338 (class 2606 OID 9464558)
-- Name: portal_concurso_pk; Type: CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.portal_concurso
    ADD CONSTRAINT portal_concurso_pk PRIMARY KEY (cod_portal_concurso);


--
-- TOC entry 6340 (class 2606 OID 9464560)
-- Name: bairro_regiao_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.bairro_regiao
    ADD CONSTRAINT bairro_regiao_pkey PRIMARY KEY (ref_cod_regiao, ref_idbai);


--
-- TOC entry 6351 (class 2606 OID 9464562)
-- Name: pghero_query_stats_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.pghero_query_stats
    ADD CONSTRAINT pghero_query_stats_pkey PRIMARY KEY (id);


--
-- TOC entry 5488 (class 2606 OID 9442751)
-- Name: phinxlog_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.phinxlog
    ADD CONSTRAINT phinxlog_pkey PRIMARY KEY (version);


--
-- TOC entry 5658 (class 2606 OID 9464564)
-- Name: pk_bairro; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.bairro
    ADD CONSTRAINT pk_bairro PRIMARY KEY (idbai);


--
-- TOC entry 6344 (class 2606 OID 9464566)
-- Name: pk_distrito; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.distrito
    ADD CONSTRAINT pk_distrito PRIMARY KEY (iddis);


--
-- TOC entry 5660 (class 2606 OID 9464568)
-- Name: pk_logradouro; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.logradouro
    ADD CONSTRAINT pk_logradouro PRIMARY KEY (idlog);


--
-- TOC entry 6346 (class 2606 OID 9464570)
-- Name: pk_logradouro_fonetico; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.logradouro_fonetico
    ADD CONSTRAINT pk_logradouro_fonetico PRIMARY KEY (fonema, idlog);


--
-- TOC entry 5662 (class 2606 OID 9464572)
-- Name: pk_municipio; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.municipio
    ADD CONSTRAINT pk_municipio PRIMARY KEY (idmun);


--
-- TOC entry 6348 (class 2606 OID 9464574)
-- Name: pk_pais; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.pais
    ADD CONSTRAINT pk_pais PRIMARY KEY (idpais);


--
-- TOC entry 6355 (class 2606 OID 9464576)
-- Name: pk_setor; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.setor
    ADD CONSTRAINT pk_setor PRIMARY KEY (idset);


--
-- TOC entry 6357 (class 2606 OID 9464578)
-- Name: pk_setorbai; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.setor_bai
    ADD CONSTRAINT pk_setorbai PRIMARY KEY (idsetorbai);


--
-- TOC entry 6359 (class 2606 OID 9464580)
-- Name: pk_uf; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.uf
    ADD CONSTRAINT pk_uf PRIMARY KEY (sigla_uf);


--
-- TOC entry 6361 (class 2606 OID 9464582)
-- Name: pk_vila; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.vila
    ADD CONSTRAINT pk_vila PRIMARY KEY (idvil);


--
-- TOC entry 6342 (class 2606 OID 9464584)
-- Name: pkchangelog; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.changelog
    ADD CONSTRAINT pkchangelog PRIMARY KEY (change_number, delta_set);


--
-- TOC entry 6353 (class 2606 OID 9464586)
-- Name: regiao_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.regiao
    ADD CONSTRAINT regiao_pkey PRIMARY KEY (cod_regiao);


--
-- TOC entry 6367 (class 2606 OID 9464588)
-- Name: aluno_uniforme_ref_cod_aluno_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.aluno_uniforme
    ADD CONSTRAINT aluno_uniforme_ref_cod_aluno_pk PRIMARY KEY (ref_cod_aluno, data_recebimento);


--
-- TOC entry 6365 (class 2606 OID 9464590)
-- Name: cod_aluno_serie_ref_cod_aluno_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.aluno_cod_aluno
    ADD CONSTRAINT cod_aluno_serie_ref_cod_aluno_pk PRIMARY KEY (cod_aluno, cod_ciasc);


--
-- TOC entry 6379 (class 2606 OID 9464592)
-- Name: educacenso_ref_cod_escola_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.escola_regulamentacao
    ADD CONSTRAINT educacenso_ref_cod_escola_pk PRIMARY KEY (ref_cod_escola);


--
-- TOC entry 6369 (class 2606 OID 9464594)
-- Name: escola_agua_ref_cod_escola_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.escola_agua
    ADD CONSTRAINT escola_agua_ref_cod_escola_pk PRIMARY KEY (ref_cod_escola);


--
-- TOC entry 6371 (class 2606 OID 9464596)
-- Name: escola_energia_ref_cod_escola_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.escola_energia
    ADD CONSTRAINT escola_energia_ref_cod_escola_pk PRIMARY KEY (ref_cod_escola);


--
-- TOC entry 6373 (class 2606 OID 9464598)
-- Name: escola_lingua_indigena_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.escola_lingua_indigena
    ADD CONSTRAINT escola_lingua_indigena_pk PRIMARY KEY (ref_cod_escola);


--
-- TOC entry 6375 (class 2606 OID 9464600)
-- Name: escola_lixo_ref_cod_escola_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.escola_lixo
    ADD CONSTRAINT escola_lixo_ref_cod_escola_pk PRIMARY KEY (ref_cod_escola);


--
-- TOC entry 6377 (class 2606 OID 9464602)
-- Name: escola_projeto_ref_cod_escola_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.escola_projeto
    ADD CONSTRAINT escola_projeto_ref_cod_escola_pk PRIMARY KEY (ref_cod_escola);


--
-- TOC entry 6381 (class 2606 OID 9464604)
-- Name: escola_sanitario_ref_cod_escola_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.escola_sanitario
    ADD CONSTRAINT escola_sanitario_ref_cod_escola_pk PRIMARY KEY (ref_cod_escola);


--
-- TOC entry 6383 (class 2606 OID 9464606)
-- Name: pk_cep_logradouro; Type: CONSTRAINT; Schema: urbano; Owner: -
--

ALTER TABLE ONLY urbano.cep_logradouro
    ADD CONSTRAINT pk_cep_logradouro PRIMARY KEY (cep, idlog);


--
-- TOC entry 6385 (class 2606 OID 9464608)
-- Name: pk_cep_logradouro_bairro; Type: CONSTRAINT; Schema: urbano; Owner: -
--

ALTER TABLE ONLY urbano.cep_logradouro_bairro
    ADD CONSTRAINT pk_cep_logradouro_bairro PRIMARY KEY (idbai, idlog, cep);


--
-- TOC entry 6363 (class 2606 OID 9464610)
-- Name: pk_tipo_logradouro; Type: CONSTRAINT; Schema: urbano; Owner: -
--

ALTER TABLE ONLY urbano.tipo_logradouro
    ADD CONSTRAINT pk_tipo_logradouro PRIMARY KEY (idtlog);


--
-- TOC entry 5517 (class 1259 OID 9464611)
-- Name: un_usuario_idpes; Type: INDEX; Schema: acesso; Owner: -
--

CREATE UNIQUE INDEX un_usuario_idpes ON acesso.usuario USING btree (idpes);


--
-- TOC entry 5524 (class 1259 OID 9464612)
-- Name: un_baixa_guia_remessa; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_baixa_guia_remessa ON alimentos.baixa_guia_remessa USING btree (idgui, dt_recebimento);


--
-- TOC entry 5533 (class 1259 OID 9464613)
-- Name: un_cardapio_produto; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_cardapio_produto ON alimentos.cardapio_produto USING btree (idcar, idpro);


--
-- TOC entry 5538 (class 1259 OID 9464614)
-- Name: un_cliente; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_cliente ON alimentos.cliente USING btree (idcli, identificacao);


--
-- TOC entry 5543 (class 1259 OID 9464615)
-- Name: un_contrato; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_contrato ON alimentos.contrato USING btree (idcli, codigo, num_aditivo);


--
-- TOC entry 5546 (class 1259 OID 9464616)
-- Name: un_contrato_produto; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_contrato_produto ON alimentos.contrato_produto USING btree (idcon, idpro);


--
-- TOC entry 5549 (class 1259 OID 9464617)
-- Name: un_evento; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_evento ON alimentos.evento USING btree (idcad, mes, dia);


--
-- TOC entry 5552 (class 1259 OID 9464618)
-- Name: un_faixa_cp_quimico; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_faixa_cp_quimico ON alimentos.faixa_composto_quimico USING btree (idcom, idfae);


--
-- TOC entry 5557 (class 1259 OID 9464619)
-- Name: un_fornecedor; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_fornecedor ON alimentos.fornecedor USING btree (idcli, nome_fantasia);


--
-- TOC entry 5558 (class 1259 OID 9464620)
-- Name: un_fornecedor_unidade_atend; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_fornecedor_unidade_atend ON alimentos.fornecedor_unidade_atendida USING btree (iduni, idfor);


--
-- TOC entry 5565 (class 1259 OID 9464621)
-- Name: un_guia_remessa; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_guia_remessa ON alimentos.guia_remessa USING btree (idcli, ano, sequencial);


--
-- TOC entry 5568 (class 1259 OID 9464622)
-- Name: un_guia_remessa_produto; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_guia_remessa_produto ON alimentos.guia_remessa_produto USING btree (idgui, idpro);


--
-- TOC entry 5580 (class 1259 OID 9464623)
-- Name: un_prod_cp_quimico; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_prod_cp_quimico ON alimentos.produto_composto_quimico USING btree (idpro, idcom);


--
-- TOC entry 5577 (class 1259 OID 9464624)
-- Name: un_produto; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_produto ON alimentos.produto USING btree (idcli, nome_compra);


--
-- TOC entry 5583 (class 1259 OID 9464625)
-- Name: un_produto_fornecedor; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_produto_fornecedor ON alimentos.produto_fornecedor USING btree (idfor, idpro);


--
-- TOC entry 5586 (class 1259 OID 9464626)
-- Name: un_produto_medida_caseira; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_produto_medida_caseira ON alimentos.produto_medida_caseira USING btree (idmedcas, idcli, idpro);


--
-- TOC entry 5591 (class 1259 OID 9464627)
-- Name: un_rec_cp_quimico; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_rec_cp_quimico ON alimentos.receita_composto_quimico USING btree (idcom, idrec);


--
-- TOC entry 5594 (class 1259 OID 9464628)
-- Name: un_rec_prod; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_rec_prod ON alimentos.receita_produto USING btree (idpro, idrec);


--
-- TOC entry 5606 (class 1259 OID 9464629)
-- Name: un_uni_faixa_etaria; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_uni_faixa_etaria ON alimentos.unidade_faixa_etaria USING btree (iduni, idfae);


--
-- TOC entry 5603 (class 1259 OID 9464630)
-- Name: un_unidade_atendida; Type: INDEX; Schema: alimentos; Owner: -
--

CREATE UNIQUE INDEX un_unidade_atendida ON alimentos.unidade_atendida USING btree (idcli, codigo);


--
-- TOC entry 5627 (class 1259 OID 9464631)
-- Name: un_fisica_cpf; Type: INDEX; Schema: cadastro; Owner: -
--

CREATE UNIQUE INDEX un_fisica_cpf ON cadastro.fisica_cpf USING btree (cpf);


--
-- TOC entry 5642 (class 1259 OID 9464632)
-- Name: un_juridica_cnpj; Type: INDEX; Schema: cadastro; Owner: -
--

CREATE UNIQUE INDEX un_juridica_cnpj ON cadastro.juridica USING btree (cnpj);


--
-- TOC entry 5778 (class 1259 OID 9464633)
-- Name: alunocomponenteetapa; Type: INDEX; Schema: modules; Owner: -
--

CREATE UNIQUE INDEX alunocomponenteetapa ON modules.parecer_componente_curricular USING btree (parecer_aluno_id, componente_curricular_id, etapa);


--
-- TOC entry 5697 (class 1259 OID 9464634)
-- Name: area_conhecimento_nome_key; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX area_conhecimento_nome_key ON modules.area_conhecimento USING btree (nome);


--
-- TOC entry 5704 (class 1259 OID 9464635)
-- Name: componente_curricular_area_conhecimento_key; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX componente_curricular_area_conhecimento_key ON modules.componente_curricular USING btree (area_conhecimento_id);


--
-- TOC entry 5705 (class 1259 OID 9464636)
-- Name: componente_curricular_id_key; Type: INDEX; Schema: modules; Owner: -
--

CREATE UNIQUE INDEX componente_curricular_id_key ON modules.componente_curricular USING btree (id);


--
-- TOC entry 5712 (class 1259 OID 9464637)
-- Name: componente_curricular_turma_turma_idx; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX componente_curricular_turma_turma_idx ON modules.componente_curricular_turma USING btree (turma_id);


--
-- TOC entry 5715 (class 1259 OID 9464638)
-- Name: docente_licenciatura_ies_idx; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX docente_licenciatura_ies_idx ON modules.docente_licenciatura USING btree (ies_id);


--
-- TOC entry 5730 (class 1259 OID 9474464)
-- Name: idx_educacenso_ies_ies_id; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX idx_educacenso_ies_ies_id ON modules.educacenso_ies USING btree (ies_id);


--
-- TOC entry 5740 (class 1259 OID 9464639)
-- Name: idx_falta_aluno_matricula_id; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX idx_falta_aluno_matricula_id ON modules.falta_aluno USING btree (matricula_id);


--
-- TOC entry 5741 (class 1259 OID 9464640)
-- Name: idx_falta_aluno_matricula_id_tipo; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX idx_falta_aluno_matricula_id_tipo ON modules.falta_aluno USING btree (matricula_id, tipo_falta);


--
-- TOC entry 5744 (class 1259 OID 9464641)
-- Name: idx_falta_componente_curricular_id1; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX idx_falta_componente_curricular_id1 ON modules.falta_componente_curricular USING btree (falta_aluno_id, componente_curricular_id, etapa);


--
-- TOC entry 5747 (class 1259 OID 9464642)
-- Name: idx_falta_geral_falta_aluno_id; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX idx_falta_geral_falta_aluno_id ON modules.falta_geral USING btree (falta_aluno_id);


--
-- TOC entry 5762 (class 1259 OID 9464643)
-- Name: idx_nota_aluno_matricula; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX idx_nota_aluno_matricula ON modules.nota_aluno USING btree (matricula_id);


--
-- TOC entry 5763 (class 1259 OID 9464644)
-- Name: idx_nota_aluno_matricula_id; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX idx_nota_aluno_matricula_id ON modules.nota_aluno USING btree (id, matricula_id);


--
-- TOC entry 5766 (class 1259 OID 9464645)
-- Name: idx_nota_componente_curricular_etapa; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX idx_nota_componente_curricular_etapa ON modules.nota_componente_curricular USING btree (nota_aluno_id, componente_curricular_id, etapa);


--
-- TOC entry 5767 (class 1259 OID 9464646)
-- Name: idx_nota_componente_curricular_etp; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX idx_nota_componente_curricular_etp ON modules.nota_componente_curricular USING btree (componente_curricular_id, etapa);


--
-- TOC entry 5768 (class 1259 OID 9464647)
-- Name: idx_nota_componente_curricular_id; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX idx_nota_componente_curricular_id ON modules.nota_componente_curricular USING btree (componente_curricular_id);


--
-- TOC entry 5775 (class 1259 OID 9464648)
-- Name: idx_parecer_aluno_matricula_id; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX idx_parecer_aluno_matricula_id ON modules.parecer_aluno USING btree (matricula_id);


--
-- TOC entry 5781 (class 1259 OID 9464649)
-- Name: idx_parecer_geral_parecer_aluno_etp; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX idx_parecer_geral_parecer_aluno_etp ON modules.parecer_geral USING btree (parecer_aluno_id, etapa);


--
-- TOC entry 5802 (class 1259 OID 9464650)
-- Name: idx_tabela_arredondamento_valor_tabela_id; Type: INDEX; Schema: modules; Owner: -
--

CREATE INDEX idx_tabela_arredondamento_valor_tabela_id ON modules.tabela_arredondamento_valor USING btree (tabela_arredondamento_id);


--
-- TOC entry 5792 (class 1259 OID 9464651)
-- Name: regra_avaliacao_id_key; Type: INDEX; Schema: modules; Owner: -
--

CREATE UNIQUE INDEX regra_avaliacao_id_key ON modules.regra_avaliacao USING btree (id);


--
-- TOC entry 5799 (class 1259 OID 9464652)
-- Name: tabela_arredondamento_id_key; Type: INDEX; Schema: modules; Owner: -
--

CREATE UNIQUE INDEX tabela_arredondamento_id_key ON modules.tabela_arredondamento USING btree (id);


--
-- TOC entry 6056 (class 1259 OID 9464653)
-- Name: exemplar_tombo_idx; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX exemplar_tombo_idx ON pmieducar.exemplar USING btree (tombo);


--
-- TOC entry 5920 (class 1259 OID 9464654)
-- Name: fki_biblioteca_usuario_ref_cod_biblioteca_fk; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX fki_biblioteca_usuario_ref_cod_biblioteca_fk ON pmieducar.biblioteca_usuario USING btree (ref_cod_biblioteca);


--
-- TOC entry 6180 (class 1259 OID 9464655)
-- Name: fki_servidor_ref_cod_subnivel; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX fki_servidor_ref_cod_subnivel ON pmieducar.servidor USING btree (ref_cod_subnivel);


--
-- TOC entry 6181 (class 1259 OID 9464656)
-- Name: fki_servidor_ref_cod_subnivel_; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX fki_servidor_ref_cod_subnivel_ ON pmieducar.servidor USING btree (ref_cod_subnivel);


--
-- TOC entry 6089 (class 1259 OID 9464657)
-- Name: historico_escolar_ano_idx; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX historico_escolar_ano_idx ON pmieducar.historico_escolar USING btree (ano);


--
-- TOC entry 6090 (class 1259 OID 9464658)
-- Name: historico_escolar_ativo_idx; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX historico_escolar_ativo_idx ON pmieducar.historico_escolar USING btree (ativo);


--
-- TOC entry 6091 (class 1259 OID 9464659)
-- Name: historico_escolar_nm_serie_idx; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX historico_escolar_nm_serie_idx ON pmieducar.historico_escolar USING btree (nm_serie);


--
-- TOC entry 5891 (class 1259 OID 9464660)
-- Name: i_aluno_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_aluno_ativo ON pmieducar.aluno USING btree (ativo);


--
-- TOC entry 5899 (class 1259 OID 9464661)
-- Name: i_aluno_beneficio_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_aluno_beneficio_ativo ON pmieducar.aluno_beneficio USING btree (ativo);


--
-- TOC entry 5900 (class 1259 OID 9464662)
-- Name: i_aluno_beneficio_nm_beneficio; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_aluno_beneficio_nm_beneficio ON pmieducar.aluno_beneficio USING btree (nm_beneficio);


--
-- TOC entry 5901 (class 1259 OID 9464663)
-- Name: i_aluno_beneficio_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_aluno_beneficio_ref_usuario_cad ON pmieducar.aluno_beneficio USING btree (ref_usuario_cad);


--
-- TOC entry 5892 (class 1259 OID 9464664)
-- Name: i_aluno_ref_cod_religiao; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_aluno_ref_cod_religiao ON pmieducar.aluno USING btree (ref_cod_religiao);


--
-- TOC entry 5893 (class 1259 OID 9464665)
-- Name: i_aluno_ref_idpes; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_aluno_ref_idpes ON pmieducar.aluno USING btree (ref_idpes);


--
-- TOC entry 5894 (class 1259 OID 9464666)
-- Name: i_aluno_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_aluno_ref_usuario_cad ON pmieducar.aluno USING btree (ref_usuario_cad);


--
-- TOC entry 5927 (class 1259 OID 9464667)
-- Name: i_calendario_ano_letivo_ano; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_calendario_ano_letivo_ano ON pmieducar.calendario_ano_letivo USING btree (ano);


--
-- TOC entry 5928 (class 1259 OID 9464668)
-- Name: i_calendario_ano_letivo_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_calendario_ano_letivo_ativo ON pmieducar.calendario_ano_letivo USING btree (ativo);


--
-- TOC entry 5929 (class 1259 OID 9464669)
-- Name: i_calendario_ano_letivo_ref_cod_escola; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_calendario_ano_letivo_ref_cod_escola ON pmieducar.calendario_ano_letivo USING btree (ref_cod_escola);


--
-- TOC entry 5930 (class 1259 OID 9464670)
-- Name: i_calendario_ano_letivo_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_calendario_ano_letivo_ref_usuario_cad ON pmieducar.calendario_ano_letivo USING btree (ref_usuario_cad);


--
-- TOC entry 5935 (class 1259 OID 9464671)
-- Name: i_calendario_dia_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_calendario_dia_ativo ON pmieducar.calendario_dia USING btree (ativo);


--
-- TOC entry 5936 (class 1259 OID 9464672)
-- Name: i_calendario_dia_dia; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_calendario_dia_dia ON pmieducar.calendario_dia USING btree (dia);


--
-- TOC entry 5937 (class 1259 OID 9464673)
-- Name: i_calendario_dia_mes; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_calendario_dia_mes ON pmieducar.calendario_dia USING btree (mes);


--
-- TOC entry 5944 (class 1259 OID 9464674)
-- Name: i_calendario_dia_motivo_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_calendario_dia_motivo_ativo ON pmieducar.calendario_dia_motivo USING btree (ativo);


--
-- TOC entry 5945 (class 1259 OID 9464675)
-- Name: i_calendario_dia_motivo_ref_cod_escola; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_calendario_dia_motivo_ref_cod_escola ON pmieducar.calendario_dia_motivo USING btree (ref_cod_escola);


--
-- TOC entry 5946 (class 1259 OID 9464676)
-- Name: i_calendario_dia_motivo_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_calendario_dia_motivo_ref_usuario_cad ON pmieducar.calendario_dia_motivo USING btree (ref_usuario_cad);


--
-- TOC entry 5947 (class 1259 OID 9464677)
-- Name: i_calendario_dia_motivo_sigla; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_calendario_dia_motivo_sigla ON pmieducar.calendario_dia_motivo USING btree (sigla);


--
-- TOC entry 5948 (class 1259 OID 9464678)
-- Name: i_calendario_dia_motivo_tipo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_calendario_dia_motivo_tipo ON pmieducar.calendario_dia_motivo USING btree (tipo);


--
-- TOC entry 5938 (class 1259 OID 9464679)
-- Name: i_calendario_dia_ref_cod_calendario_dia_motivo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_calendario_dia_ref_cod_calendario_dia_motivo ON pmieducar.calendario_dia USING btree (ref_cod_calendario_dia_motivo);


--
-- TOC entry 5939 (class 1259 OID 9464680)
-- Name: i_calendario_dia_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_calendario_dia_ref_usuario_cad ON pmieducar.calendario_dia USING btree (ref_usuario_cad);


--
-- TOC entry 5969 (class 1259 OID 9464681)
-- Name: i_coffebreak_tipo_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_coffebreak_tipo_ativo ON pmieducar.coffebreak_tipo USING btree (ativo);


--
-- TOC entry 5970 (class 1259 OID 9464682)
-- Name: i_coffebreak_tipo_custo_unitario; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_coffebreak_tipo_custo_unitario ON pmieducar.coffebreak_tipo USING btree (custo_unitario);


--
-- TOC entry 5971 (class 1259 OID 9464683)
-- Name: i_coffebreak_tipo_nm_tipo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_coffebreak_tipo_nm_tipo ON pmieducar.coffebreak_tipo USING btree (nm_tipo);


--
-- TOC entry 5972 (class 1259 OID 9464684)
-- Name: i_coffebreak_tipo_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_coffebreak_tipo_ref_usuario_cad ON pmieducar.coffebreak_tipo USING btree (ref_usuario_cad);


--
-- TOC entry 5975 (class 1259 OID 9464685)
-- Name: i_curso_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_curso_ativo ON pmieducar.curso USING btree (ativo);


--
-- TOC entry 5976 (class 1259 OID 9464686)
-- Name: i_curso_ato_poder_publico; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_curso_ato_poder_publico ON pmieducar.curso USING btree (ato_poder_publico);


--
-- TOC entry 5977 (class 1259 OID 9464687)
-- Name: i_curso_carga_horaria; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_curso_carga_horaria ON pmieducar.curso USING btree (carga_horaria);


--
-- TOC entry 5978 (class 1259 OID 9464688)
-- Name: i_curso_nm_curso; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_curso_nm_curso ON pmieducar.curso USING btree (nm_curso);


--
-- TOC entry 5979 (class 1259 OID 9464689)
-- Name: i_curso_objetivo_curso; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_curso_objetivo_curso ON pmieducar.curso USING btree (objetivo_curso);


--
-- TOC entry 5980 (class 1259 OID 9464690)
-- Name: i_curso_qtd_etapas; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_curso_qtd_etapas ON pmieducar.curso USING btree (qtd_etapas);


--
-- TOC entry 5981 (class 1259 OID 9464691)
-- Name: i_curso_ref_cod_nivel_ensino; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_curso_ref_cod_nivel_ensino ON pmieducar.curso USING btree (ref_cod_nivel_ensino);


--
-- TOC entry 5982 (class 1259 OID 9464692)
-- Name: i_curso_ref_cod_tipo_ensino; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_curso_ref_cod_tipo_ensino ON pmieducar.curso USING btree (ref_cod_tipo_ensino);


--
-- TOC entry 5983 (class 1259 OID 9464693)
-- Name: i_curso_ref_cod_tipo_regime; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_curso_ref_cod_tipo_regime ON pmieducar.curso USING btree (ref_cod_tipo_regime);


--
-- TOC entry 5984 (class 1259 OID 9464694)
-- Name: i_curso_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_curso_ref_usuario_cad ON pmieducar.curso USING btree (ref_usuario_cad);


--
-- TOC entry 5985 (class 1259 OID 9464695)
-- Name: i_curso_sgl_curso; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_curso_sgl_curso ON pmieducar.curso USING btree (sgl_curso);


--
-- TOC entry 5988 (class 1259 OID 9464696)
-- Name: i_disciplina_abreviatura; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_disciplina_abreviatura ON pmieducar.disciplina USING btree (abreviatura);


--
-- TOC entry 5989 (class 1259 OID 9464697)
-- Name: i_disciplina_apura_falta; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_disciplina_apura_falta ON pmieducar.disciplina USING btree (apura_falta);


--
-- TOC entry 5990 (class 1259 OID 9464698)
-- Name: i_disciplina_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_disciplina_ativo ON pmieducar.disciplina USING btree (ativo);


--
-- TOC entry 5991 (class 1259 OID 9464699)
-- Name: i_disciplina_carga_horaria; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_disciplina_carga_horaria ON pmieducar.disciplina USING btree (carga_horaria);


--
-- TOC entry 5992 (class 1259 OID 9464700)
-- Name: i_disciplina_nm_disciplina; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_disciplina_nm_disciplina ON pmieducar.disciplina USING btree (nm_disciplina);


--
-- TOC entry 5993 (class 1259 OID 9464701)
-- Name: i_disciplina_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_disciplina_ref_usuario_cad ON pmieducar.disciplina USING btree (ref_usuario_cad);


--
-- TOC entry 6000 (class 1259 OID 9464702)
-- Name: i_disciplina_topico_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_disciplina_topico_ativo ON pmieducar.disciplina_topico USING btree (ativo);


--
-- TOC entry 6001 (class 1259 OID 9464703)
-- Name: i_disciplina_topico_nm_topico; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_disciplina_topico_nm_topico ON pmieducar.disciplina_topico USING btree (nm_topico);


--
-- TOC entry 6002 (class 1259 OID 9464704)
-- Name: i_disciplina_topico_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_disciplina_topico_ref_usuario_cad ON pmieducar.disciplina_topico USING btree (ref_usuario_cad);


--
-- TOC entry 6005 (class 1259 OID 9464705)
-- Name: i_dispensa_disciplina_ref_cod_matricula; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_dispensa_disciplina_ref_cod_matricula ON pmieducar.dispensa_disciplina USING btree (ref_cod_matricula);


--
-- TOC entry 6010 (class 1259 OID 9464706)
-- Name: i_escola_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_ativo ON pmieducar.escola USING btree (ativo);


--
-- TOC entry 6020 (class 1259 OID 9464707)
-- Name: i_escola_complemento_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_complemento_ativo ON pmieducar.escola_complemento USING btree (ativo);


--
-- TOC entry 6021 (class 1259 OID 9464708)
-- Name: i_escola_complemento_bairro; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_complemento_bairro ON pmieducar.escola_complemento USING btree (bairro);


--
-- TOC entry 6022 (class 1259 OID 9464709)
-- Name: i_escola_complemento_cep; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_complemento_cep ON pmieducar.escola_complemento USING btree (cep);


--
-- TOC entry 6023 (class 1259 OID 9464710)
-- Name: i_escola_complemento_complemento; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_complemento_complemento ON pmieducar.escola_complemento USING btree (complemento);


--
-- TOC entry 6024 (class 1259 OID 9464711)
-- Name: i_escola_complemento_email; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_complemento_email ON pmieducar.escola_complemento USING btree (email);


--
-- TOC entry 6025 (class 1259 OID 9464712)
-- Name: i_escola_complemento_logradouro; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_complemento_logradouro ON pmieducar.escola_complemento USING btree (logradouro);


--
-- TOC entry 6026 (class 1259 OID 9464713)
-- Name: i_escola_complemento_municipio; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_complemento_municipio ON pmieducar.escola_complemento USING btree (municipio);


--
-- TOC entry 6027 (class 1259 OID 9464714)
-- Name: i_escola_complemento_nm_escola; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_complemento_nm_escola ON pmieducar.escola_complemento USING btree (nm_escola);


--
-- TOC entry 6028 (class 1259 OID 9464715)
-- Name: i_escola_complemento_numero; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_complemento_numero ON pmieducar.escola_complemento USING btree (numero);


--
-- TOC entry 6029 (class 1259 OID 9464716)
-- Name: i_escola_complemento_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_complemento_ref_usuario_cad ON pmieducar.escola_complemento USING btree (ref_usuario_cad);


--
-- TOC entry 6032 (class 1259 OID 9464717)
-- Name: i_escola_curso_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_curso_ativo ON pmieducar.escola_curso USING btree (ativo);


--
-- TOC entry 6033 (class 1259 OID 9464718)
-- Name: i_escola_curso_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_curso_ref_usuario_cad ON pmieducar.escola_curso USING btree (ref_usuario_cad);


--
-- TOC entry 6036 (class 1259 OID 9464719)
-- Name: i_escola_localizacao_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_localizacao_ativo ON pmieducar.escola_localizacao USING btree (ativo);


--
-- TOC entry 6037 (class 1259 OID 9464720)
-- Name: i_escola_localizacao_nm_localizacao; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_localizacao_nm_localizacao ON pmieducar.escola_localizacao USING btree (nm_localizacao);


--
-- TOC entry 6038 (class 1259 OID 9464721)
-- Name: i_escola_localizacao_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_localizacao_ref_usuario_cad ON pmieducar.escola_localizacao USING btree (ref_usuario_cad);


--
-- TOC entry 6041 (class 1259 OID 9464722)
-- Name: i_escola_rede_ensino_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_rede_ensino_ativo ON pmieducar.escola_rede_ensino USING btree (ativo);


--
-- TOC entry 6042 (class 1259 OID 9464723)
-- Name: i_escola_rede_ensino_nm_rede; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_rede_ensino_nm_rede ON pmieducar.escola_rede_ensino USING btree (nm_rede);


--
-- TOC entry 6043 (class 1259 OID 9464724)
-- Name: i_escola_rede_ensino_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_rede_ensino_ref_usuario_cad ON pmieducar.escola_rede_ensino USING btree (ref_usuario_cad);


--
-- TOC entry 6011 (class 1259 OID 9464726)
-- Name: i_escola_ref_cod_escola_rede_ensino; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_ref_cod_escola_rede_ensino ON pmieducar.escola USING btree (ref_cod_escola_rede_ensino);


--
-- TOC entry 6012 (class 1259 OID 9464727)
-- Name: i_escola_ref_cod_instituicao; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_ref_cod_instituicao ON pmieducar.escola USING btree (ref_cod_instituicao);


--
-- TOC entry 6013 (class 1259 OID 9464728)
-- Name: i_escola_ref_idpes; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_ref_idpes ON pmieducar.escola USING btree (ref_idpes);


--
-- TOC entry 6014 (class 1259 OID 9464729)
-- Name: i_escola_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_ref_usuario_cad ON pmieducar.escola USING btree (ref_usuario_cad);


--
-- TOC entry 6046 (class 1259 OID 9464730)
-- Name: i_escola_serie_ensino_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_serie_ensino_ativo ON pmieducar.escola_serie USING btree (ativo);


--
-- TOC entry 6047 (class 1259 OID 9464731)
-- Name: i_escola_serie_hora_final; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_serie_hora_final ON pmieducar.escola_serie USING btree (hora_final);


--
-- TOC entry 6048 (class 1259 OID 9464732)
-- Name: i_escola_serie_hora_inicial; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_serie_hora_inicial ON pmieducar.escola_serie USING btree (hora_inicial);


--
-- TOC entry 6049 (class 1259 OID 9464733)
-- Name: i_escola_serie_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_serie_ref_usuario_cad ON pmieducar.escola_serie USING btree (ref_usuario_cad);


--
-- TOC entry 6015 (class 1259 OID 9464734)
-- Name: i_escola_sigla; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_escola_sigla ON pmieducar.escola USING btree (sigla);


--
-- TOC entry 6073 (class 1259 OID 9464735)
-- Name: i_funcao_abreviatura; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_funcao_abreviatura ON pmieducar.funcao USING btree (abreviatura);


--
-- TOC entry 6074 (class 1259 OID 9464736)
-- Name: i_funcao_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_funcao_ativo ON pmieducar.funcao USING btree (ativo);


--
-- TOC entry 6075 (class 1259 OID 9464737)
-- Name: i_funcao_nm_funcao; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_funcao_nm_funcao ON pmieducar.funcao USING btree (nm_funcao);


--
-- TOC entry 6076 (class 1259 OID 9464738)
-- Name: i_funcao_professor; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_funcao_professor ON pmieducar.funcao USING btree (professor);


--
-- TOC entry 6077 (class 1259 OID 9464739)
-- Name: i_funcao_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_funcao_ref_usuario_cad ON pmieducar.funcao USING btree (ref_usuario_cad);


--
-- TOC entry 6080 (class 1259 OID 9464740)
-- Name: i_habilitacao_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_habilitacao_ativo ON pmieducar.habilitacao USING btree (ativo);


--
-- TOC entry 6081 (class 1259 OID 9464741)
-- Name: i_habilitacao_nm_tipo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_habilitacao_nm_tipo ON pmieducar.habilitacao USING btree (nm_tipo);


--
-- TOC entry 6082 (class 1259 OID 9464742)
-- Name: i_habilitacao_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_habilitacao_ref_usuario_cad ON pmieducar.habilitacao USING btree (ref_usuario_cad);


--
-- TOC entry 6123 (class 1259 OID 9464743)
-- Name: i_matricula_turma_ref_cod_turma; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_matricula_turma_ref_cod_turma ON pmieducar.matricula_turma USING btree (ref_cod_turma);


--
-- TOC entry 6140 (class 1259 OID 9464744)
-- Name: i_nota_aluno_ref_cod_matricula; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_nota_aluno_ref_cod_matricula ON pmieducar.nota_aluno USING btree (ref_cod_matricula);


--
-- TOC entry 6224 (class 1259 OID 9464745)
-- Name: i_turma_nm_turma; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX i_turma_nm_turma ON pmieducar.turma USING btree (nm_turma);


--
-- TOC entry 6087 (class 1259 OID 9464746)
-- Name: idx_historico_disciplinas_id; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX idx_historico_disciplinas_id ON pmieducar.historico_disciplinas USING btree (sequencial, ref_ref_cod_aluno, ref_sequencial);


--
-- TOC entry 6088 (class 1259 OID 9464747)
-- Name: idx_historico_disciplinas_id1; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX idx_historico_disciplinas_id1 ON pmieducar.historico_disciplinas USING btree (ref_ref_cod_aluno, ref_sequencial);


--
-- TOC entry 6094 (class 1259 OID 9464748)
-- Name: idx_historico_escolar_aluno_ativo; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX idx_historico_escolar_aluno_ativo ON pmieducar.historico_escolar USING btree (ref_cod_aluno, ativo);


--
-- TOC entry 6095 (class 1259 OID 9464749)
-- Name: idx_historico_escolar_id1; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX idx_historico_escolar_id1 ON pmieducar.historico_escolar USING btree (ref_cod_aluno, sequencial);


--
-- TOC entry 6096 (class 1259 OID 9464750)
-- Name: idx_historico_escolar_id2; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX idx_historico_escolar_id2 ON pmieducar.historico_escolar USING btree (ref_cod_aluno, sequencial, ano);


--
-- TOC entry 6097 (class 1259 OID 9464751)
-- Name: idx_historico_escolar_id3; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX idx_historico_escolar_id3 ON pmieducar.historico_escolar USING btree (ref_cod_aluno, ano);


--
-- TOC entry 6114 (class 1259 OID 9464752)
-- Name: idx_matricula_cod_escola_aluno; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX idx_matricula_cod_escola_aluno ON pmieducar.matricula USING btree (ref_ref_cod_escola, ref_cod_aluno);


--
-- TOC entry 6170 (class 1259 OID 9464753)
-- Name: idx_serie_cod_regra_avaliacao_id; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX idx_serie_cod_regra_avaliacao_id ON pmieducar.serie USING btree (cod_serie, regra_avaliacao_id);


--
-- TOC entry 6171 (class 1259 OID 9464754)
-- Name: idx_serie_regra_avaliacao_id; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX idx_serie_regra_avaliacao_id ON pmieducar.serie USING btree (regra_avaliacao_id);


--
-- TOC entry 6115 (class 1259 OID 9464755)
-- Name: matricula_ano_idx; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX matricula_ano_idx ON pmieducar.matricula USING btree (ano);


--
-- TOC entry 6116 (class 1259 OID 9464756)
-- Name: matricula_ativo_idx; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX matricula_ativo_idx ON pmieducar.matricula USING btree (ativo);


--
-- TOC entry 6155 (class 1259 OID 9464757)
-- Name: quadro_horario_horarios_busca_horarios_idx; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX quadro_horario_horarios_busca_horarios_idx ON pmieducar.quadro_horario_horarios USING btree (ref_servidor, ref_cod_instituicao_servidor, dia_semana, hora_inicial, hora_final, ativo);


--
-- TOC entry 8415 (class 0 OID 0)
-- Dependencies: 6155
-- Name: INDEX quadro_horario_horarios_busca_horarios_idx; Type: COMMENT; Schema: pmieducar; Owner: -
--

COMMENT ON INDEX pmieducar.quadro_horario_horarios_busca_horarios_idx IS 'Índice para otimizar a busca por professores na criação de quadro de horários.';


--
-- TOC entry 6187 (class 1259 OID 9464758)
-- Name: servidor_alocacao_busca_horarios_idx; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX servidor_alocacao_busca_horarios_idx ON pmieducar.servidor_alocacao USING btree (ref_ref_cod_instituicao, ref_cod_escola, ativo, periodo, carga_horaria);


--
-- TOC entry 6182 (class 1259 OID 9464759)
-- Name: servidor_idx; Type: INDEX; Schema: pmieducar; Owner: -
--

CREATE INDEX servidor_idx ON pmieducar.servidor USING btree (cod_servidor, ref_cod_instituicao, ativo);


--
-- TOC entry 8416 (class 0 OID 0)
-- Dependencies: 6182
-- Name: INDEX servidor_idx; Type: COMMENT; Schema: pmieducar; Owner: -
--

COMMENT ON INDEX pmieducar.servidor_idx IS 'Índice para otimização de acesso aos campos mais usados para queries na tabela.';


--
-- TOC entry 6303 (class 1259 OID 9464760)
-- Name: mailling_fila_envio_data_envio_idx; Type: INDEX; Schema: portal; Owner: -
--

CREATE INDEX mailling_fila_envio_data_envio_idx ON portal.mailling_fila_envio USING btree (data_envio);


--
-- TOC entry 6306 (class 1259 OID 9464761)
-- Name: mailling_fila_envio_ref_cod_mailling_email; Type: INDEX; Schema: portal; Owner: -
--

CREATE INDEX mailling_fila_envio_ref_cod_mailling_email ON portal.mailling_fila_envio USING btree (ref_cod_mailling_email);


--
-- TOC entry 6307 (class 1259 OID 9464762)
-- Name: mailling_fila_envio_ref_cod_mailling_email_conteudo; Type: INDEX; Schema: portal; Owner: -
--

CREATE INDEX mailling_fila_envio_ref_cod_mailling_email_conteudo ON portal.mailling_fila_envio USING btree (ref_cod_mailling_email_conteudo);


--
-- TOC entry 6308 (class 1259 OID 9464763)
-- Name: mailling_fila_envio_ref_cod_mailling_fila_envio; Type: INDEX; Schema: portal; Owner: -
--

CREATE INDEX mailling_fila_envio_ref_cod_mailling_fila_envio ON portal.mailling_fila_envio USING btree (cod_mailling_fila_envio);


--
-- TOC entry 6349 (class 1259 OID 9464764)
-- Name: pghero_query_stats_database_captured_at_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX pghero_query_stats_database_captured_at_idx ON public.pghero_query_stats USING btree (database, captured_at);


--
-- TOC entry 7211 (class 2620 OID 9464765)
-- Name: trg_aft_documento; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_documento AFTER INSERT OR UPDATE ON cadastro.documento FOR EACH ROW EXECUTE PROCEDURE cadastro.fcn_aft_documento();


--
-- TOC entry 7212 (class 2620 OID 9464766)
-- Name: trg_aft_documento_historico_campo; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_documento_historico_campo AFTER INSERT OR UPDATE ON cadastro.documento FOR EACH ROW EXECUTE PROCEDURE consistenciacao.fcn_documento_historico_campo();


--
-- TOC entry 7213 (class 2620 OID 9464767)
-- Name: trg_aft_documento_provisorio; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_documento_provisorio AFTER INSERT OR UPDATE ON cadastro.documento FOR EACH ROW EXECUTE PROCEDURE cadastro.fcn_aft_documento_provisorio();


--
-- TOC entry 7216 (class 2620 OID 9464768)
-- Name: trg_aft_endereco_externo_historico_campo; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_endereco_externo_historico_campo AFTER INSERT OR UPDATE ON cadastro.endereco_externo FOR EACH ROW EXECUTE PROCEDURE consistenciacao.fcn_endereco_externo_historico_campo();


--
-- TOC entry 7220 (class 2620 OID 9464769)
-- Name: trg_aft_endereco_pessoa_historico_campo; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_endereco_pessoa_historico_campo AFTER INSERT OR UPDATE ON cadastro.endereco_pessoa FOR EACH ROW EXECUTE PROCEDURE consistenciacao.fcn_endereco_pessoa_historico_campo();


--
-- TOC entry 7224 (class 2620 OID 9464770)
-- Name: trg_aft_fisica; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_fisica AFTER INSERT OR UPDATE ON cadastro.fisica FOR EACH ROW EXECUTE PROCEDURE cadastro.fcn_aft_fisica();


--
-- TOC entry 7230 (class 2620 OID 9464771)
-- Name: trg_aft_fisica_cpf_provisorio; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_fisica_cpf_provisorio AFTER INSERT OR UPDATE ON cadastro.fisica_cpf FOR EACH ROW EXECUTE PROCEDURE cadastro.fcn_aft_fisica_cpf_provisorio();


--
-- TOC entry 7225 (class 2620 OID 9464772)
-- Name: trg_aft_fisica_historico_campo; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_fisica_historico_campo AFTER INSERT OR UPDATE ON cadastro.fisica FOR EACH ROW EXECUTE PROCEDURE consistenciacao.fcn_fisica_historico_campo();


--
-- TOC entry 7226 (class 2620 OID 9464773)
-- Name: trg_aft_fisica_provisorio; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_fisica_provisorio AFTER INSERT OR UPDATE ON cadastro.fisica FOR EACH ROW EXECUTE PROCEDURE cadastro.fcn_aft_fisica_provisorio();


--
-- TOC entry 7233 (class 2620 OID 9464774)
-- Name: trg_aft_fone_historico_campo; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_fone_historico_campo AFTER INSERT OR UPDATE ON cadastro.fone_pessoa FOR EACH ROW EXECUTE PROCEDURE consistenciacao.fcn_fone_historico_campo();


--
-- TOC entry 7234 (class 2620 OID 9464775)
-- Name: trg_aft_fone_pessoa_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_fone_pessoa_historico AFTER DELETE ON cadastro.fone_pessoa FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_fone_pessoa();


--
-- TOC entry 7237 (class 2620 OID 9464776)
-- Name: trg_aft_funcionario_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_funcionario_historico AFTER DELETE ON cadastro.funcionario FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_funcionario();


--
-- TOC entry 7217 (class 2620 OID 9464777)
-- Name: trg_aft_ins_endereco_externo; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_ins_endereco_externo AFTER INSERT OR UPDATE ON cadastro.endereco_externo FOR EACH ROW EXECUTE PROCEDURE cadastro.fcn_aft_ins_endereco_externo();


--
-- TOC entry 7221 (class 2620 OID 9464778)
-- Name: trg_aft_ins_endereco_pessoa; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_ins_endereco_pessoa AFTER INSERT OR UPDATE ON cadastro.endereco_pessoa FOR EACH ROW EXECUTE PROCEDURE cadastro.fcn_aft_ins_endereco_pessoa();


--
-- TOC entry 7240 (class 2620 OID 9464779)
-- Name: trg_aft_juridica_historico_campo; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_juridica_historico_campo AFTER INSERT OR UPDATE ON cadastro.juridica FOR EACH ROW EXECUTE PROCEDURE consistenciacao.fcn_juridica_historico_campo();


--
-- TOC entry 7244 (class 2620 OID 9464780)
-- Name: trg_aft_pessoa_fonetiza; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_pessoa_fonetiza AFTER INSERT OR UPDATE ON cadastro.pessoa FOR EACH ROW EXECUTE PROCEDURE public.fcn_aft_pessoa_fonetiza();


--
-- TOC entry 7245 (class 2620 OID 9464781)
-- Name: trg_aft_pessoa_historico_campo; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_aft_pessoa_historico_campo AFTER INSERT OR UPDATE ON cadastro.pessoa FOR EACH ROW EXECUTE PROCEDURE consistenciacao.fcn_pessoa_historico_campo();


--
-- TOC entry 7214 (class 2620 OID 9464782)
-- Name: trg_bef_documento_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_bef_documento_historico BEFORE UPDATE ON cadastro.documento FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_documento();


--
-- TOC entry 7218 (class 2620 OID 9464783)
-- Name: trg_bef_endereco_externo_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_bef_endereco_externo_historico BEFORE UPDATE ON cadastro.endereco_externo FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_endereco_externo();


--
-- TOC entry 7222 (class 2620 OID 9464784)
-- Name: trg_bef_endereco_pessoa_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_bef_endereco_pessoa_historico BEFORE UPDATE ON cadastro.endereco_pessoa FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_endereco_pessoa();


--
-- TOC entry 7231 (class 2620 OID 9464785)
-- Name: trg_bef_fisica_cpf_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_bef_fisica_cpf_historico BEFORE UPDATE ON cadastro.fisica_cpf FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_fisica_cpf();


--
-- TOC entry 7227 (class 2620 OID 9464786)
-- Name: trg_bef_fisica_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_bef_fisica_historico BEFORE UPDATE ON cadastro.fisica FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_fisica();


--
-- TOC entry 7235 (class 2620 OID 9464787)
-- Name: trg_bef_fone_pessoa_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_bef_fone_pessoa_historico BEFORE UPDATE ON cadastro.fone_pessoa FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_fone_pessoa();


--
-- TOC entry 7238 (class 2620 OID 9464788)
-- Name: trg_bef_funcionario_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_bef_funcionario_historico BEFORE UPDATE ON cadastro.funcionario FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_funcionario();


--
-- TOC entry 7228 (class 2620 OID 9464789)
-- Name: trg_bef_ins_fisica; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_bef_ins_fisica BEFORE INSERT ON cadastro.fisica FOR EACH ROW EXECUTE PROCEDURE public.fcn_bef_ins_fisica();


--
-- TOC entry 7241 (class 2620 OID 9464790)
-- Name: trg_bef_ins_juridica; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_bef_ins_juridica BEFORE INSERT ON cadastro.juridica FOR EACH ROW EXECUTE PROCEDURE public.fcn_bef_ins_juridica();


--
-- TOC entry 7242 (class 2620 OID 9464791)
-- Name: trg_bef_juridica_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_bef_juridica_historico BEFORE UPDATE ON cadastro.juridica FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_juridica();


--
-- TOC entry 7246 (class 2620 OID 9464792)
-- Name: trg_bef_pessoa_fonetiza; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_bef_pessoa_fonetiza BEFORE DELETE ON cadastro.pessoa FOR EACH ROW EXECUTE PROCEDURE public.fcn_bef_pessoa_fonetiza();


--
-- TOC entry 7247 (class 2620 OID 9464793)
-- Name: trg_bef_pessoa_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_bef_pessoa_historico BEFORE UPDATE ON cadastro.pessoa FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_pessoa();


--
-- TOC entry 7249 (class 2620 OID 9464794)
-- Name: trg_bef_socio_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_bef_socio_historico BEFORE UPDATE ON cadastro.socio FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_socio();


--
-- TOC entry 7215 (class 2620 OID 9464795)
-- Name: trg_delete_documento_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_delete_documento_historico AFTER DELETE ON cadastro.documento FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_documento();


--
-- TOC entry 7219 (class 2620 OID 9464796)
-- Name: trg_delete_endereco_externo_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_delete_endereco_externo_historico AFTER DELETE ON cadastro.endereco_externo FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_endereco_externo();


--
-- TOC entry 7223 (class 2620 OID 9464797)
-- Name: trg_delete_endereco_pessoa_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_delete_endereco_pessoa_historico AFTER DELETE ON cadastro.endereco_pessoa FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_endereco_pessoa();


--
-- TOC entry 7232 (class 2620 OID 9464798)
-- Name: trg_delete_fisica_cpf_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_delete_fisica_cpf_historico AFTER DELETE ON cadastro.fisica_cpf FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_fisica_cpf();


--
-- TOC entry 7229 (class 2620 OID 9464799)
-- Name: trg_delete_fisica_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_delete_fisica_historico AFTER DELETE ON cadastro.fisica FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_fisica();


--
-- TOC entry 7236 (class 2620 OID 9464800)
-- Name: trg_delete_fone_pessoa_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_delete_fone_pessoa_historico AFTER DELETE ON cadastro.fone_pessoa FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_fone_pessoa();


--
-- TOC entry 7239 (class 2620 OID 9464801)
-- Name: trg_delete_funcionario_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_delete_funcionario_historico AFTER DELETE ON cadastro.funcionario FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_funcionario();


--
-- TOC entry 7243 (class 2620 OID 9464802)
-- Name: trg_delete_juridica_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_delete_juridica_historico AFTER DELETE ON cadastro.juridica FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_juridica();


--
-- TOC entry 7248 (class 2620 OID 9464803)
-- Name: trg_delete_pessoa_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_delete_pessoa_historico AFTER DELETE ON cadastro.pessoa FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_pessoa();


--
-- TOC entry 7250 (class 2620 OID 9464804)
-- Name: trg_delete_socio_historico; Type: TRIGGER; Schema: cadastro; Owner: -
--

CREATE TRIGGER trg_delete_socio_historico AFTER DELETE ON cadastro.socio FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_socio();


--
-- TOC entry 7260 (class 2620 OID 9474637)
-- Name: impede_duplicacao_falta_aluno; Type: TRIGGER; Schema: modules; Owner: -
--

CREATE TRIGGER impede_duplicacao_falta_aluno BEFORE INSERT OR UPDATE ON modules.falta_aluno FOR EACH ROW EXECUTE PROCEDURE modules.impede_duplicacao_falta_aluno();


--
-- TOC entry 7264 (class 2620 OID 9474633)
-- Name: impede_duplicacao_nota_aluno; Type: TRIGGER; Schema: modules; Owner: -
--

CREATE TRIGGER impede_duplicacao_nota_aluno BEFORE INSERT OR UPDATE ON modules.nota_aluno FOR EACH ROW EXECUTE PROCEDURE modules.impede_duplicacao_nota_aluno();


--
-- TOC entry 7269 (class 2620 OID 9474635)
-- Name: impede_duplicacao_parecer_aluno; Type: TRIGGER; Schema: modules; Owner: -
--

CREATE TRIGGER impede_duplicacao_parecer_aluno BEFORE INSERT OR UPDATE ON modules.parecer_aluno FOR EACH ROW EXECUTE PROCEDURE modules.impede_duplicacao_parecer_aluno();


--
-- TOC entry 7261 (class 2620 OID 9474661)
-- Name: trigger_audita_falta_componente_curricular; Type: TRIGGER; Schema: modules; Owner: -
--

CREATE TRIGGER trigger_audita_falta_componente_curricular AFTER INSERT OR DELETE OR UPDATE ON modules.falta_componente_curricular FOR EACH ROW EXECUTE PROCEDURE modules.audita_falta_componente_curricular();


--
-- TOC entry 7262 (class 2620 OID 9474659)
-- Name: trigger_audita_falta_geral; Type: TRIGGER; Schema: modules; Owner: -
--

CREATE TRIGGER trigger_audita_falta_geral AFTER INSERT OR DELETE OR UPDATE ON modules.falta_geral FOR EACH ROW EXECUTE PROCEDURE modules.audita_falta_geral();


--
-- TOC entry 7263 (class 2620 OID 9474667)
-- Name: trigger_audita_media_geral; Type: TRIGGER; Schema: modules; Owner: -
--

CREATE TRIGGER trigger_audita_media_geral AFTER INSERT OR DELETE OR UPDATE ON modules.media_geral FOR EACH ROW EXECUTE PROCEDURE modules.audita_media_geral();


--
-- TOC entry 7265 (class 2620 OID 9474651)
-- Name: trigger_audita_nota_componente_curricular; Type: TRIGGER; Schema: modules; Owner: -
--

CREATE TRIGGER trigger_audita_nota_componente_curricular AFTER INSERT OR DELETE OR UPDATE ON modules.nota_componente_curricular FOR EACH ROW EXECUTE PROCEDURE modules.audita_nota_componente_curricular();


--
-- TOC entry 7266 (class 2620 OID 9474653)
-- Name: trigger_audita_nota_componente_curricular_media; Type: TRIGGER; Schema: modules; Owner: -
--

CREATE TRIGGER trigger_audita_nota_componente_curricular_media AFTER INSERT OR DELETE OR UPDATE ON modules.nota_componente_curricular_media FOR EACH ROW EXECUTE PROCEDURE modules.audita_nota_componente_curricular_media();


--
-- TOC entry 7267 (class 2620 OID 9474649)
-- Name: trigger_audita_nota_exame; Type: TRIGGER; Schema: modules; Owner: -
--

CREATE TRIGGER trigger_audita_nota_exame AFTER INSERT OR DELETE OR UPDATE ON modules.nota_exame FOR EACH ROW EXECUTE PROCEDURE modules.audita_nota_exame();


--
-- TOC entry 7268 (class 2620 OID 9474647)
-- Name: trigger_audita_nota_geral; Type: TRIGGER; Schema: modules; Owner: -
--

CREATE TRIGGER trigger_audita_nota_geral AFTER INSERT OR DELETE OR UPDATE ON modules.nota_geral FOR EACH ROW EXECUTE PROCEDURE modules.audita_nota_geral();


--
-- TOC entry 7270 (class 2620 OID 9474657)
-- Name: trigger_audita_parecer_componente_curricular; Type: TRIGGER; Schema: modules; Owner: -
--

CREATE TRIGGER trigger_audita_parecer_componente_curricular AFTER INSERT OR DELETE OR UPDATE ON modules.parecer_componente_curricular FOR EACH ROW EXECUTE PROCEDURE modules.audita_parecer_componente_curricular();


--
-- TOC entry 7271 (class 2620 OID 9474655)
-- Name: trigger_audita_parecer_geral; Type: TRIGGER; Schema: modules; Owner: -
--

CREATE TRIGGER trigger_audita_parecer_geral AFTER INSERT OR DELETE OR UPDATE ON modules.parecer_geral FOR EACH ROW EXECUTE PROCEDURE modules.audita_parecer_geral();


--
-- TOC entry 7259 (class 2620 OID 9469011)
-- Name: update_componente_curricular_turma_updated_at; Type: TRIGGER; Schema: modules; Owner: -
--

CREATE TRIGGER update_componente_curricular_turma_updated_at BEFORE UPDATE ON modules.componente_curricular_turma FOR EACH ROW EXECUTE PROCEDURE public.update_updated_at();


--
-- TOC entry 7324 (class 2620 OID 9464805)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.instituicao FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7272 (class 2620 OID 9464806)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.acervo FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7273 (class 2620 OID 9464807)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.acervo_acervo_assunto FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7274 (class 2620 OID 9464808)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.acervo_acervo_autor FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7275 (class 2620 OID 9464809)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.acervo_assunto FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7276 (class 2620 OID 9464810)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.acervo_autor FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7277 (class 2620 OID 9464811)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.acervo_colecao FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7278 (class 2620 OID 9464812)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.acervo_editora FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7279 (class 2620 OID 9464813)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.acervo_idioma FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7280 (class 2620 OID 9464814)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.aluno FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7281 (class 2620 OID 9464815)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.aluno_beneficio FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7282 (class 2620 OID 9464816)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.ano_letivo_modulo FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7283 (class 2620 OID 9464817)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.avaliacao_desempenho FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7284 (class 2620 OID 9464818)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.biblioteca FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7285 (class 2620 OID 9464819)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.biblioteca_dia FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7286 (class 2620 OID 9464820)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.biblioteca_feriados FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7287 (class 2620 OID 9464821)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.biblioteca_usuario FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7288 (class 2620 OID 9464822)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.calendario_ano_letivo FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7289 (class 2620 OID 9464823)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.calendario_anotacao FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7290 (class 2620 OID 9464824)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.calendario_dia FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7291 (class 2620 OID 9464825)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.calendario_dia_anotacao FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7292 (class 2620 OID 9464826)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.calendario_dia_motivo FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7293 (class 2620 OID 9464827)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.cliente FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7294 (class 2620 OID 9464828)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.cliente_suspensao FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7295 (class 2620 OID 9464829)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.cliente_tipo FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7296 (class 2620 OID 9464830)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.cliente_tipo_cliente FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7297 (class 2620 OID 9464831)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.cliente_tipo_exemplar_tipo FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7298 (class 2620 OID 9464832)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.coffebreak_tipo FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7299 (class 2620 OID 9464833)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.curso FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7300 (class 2620 OID 9464834)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.disciplina FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7301 (class 2620 OID 9464835)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.disciplina_topico FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7302 (class 2620 OID 9464836)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.escola FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7303 (class 2620 OID 9464837)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.escola_ano_letivo FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7304 (class 2620 OID 9464838)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.escola_complemento FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7305 (class 2620 OID 9464839)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.escola_curso FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7306 (class 2620 OID 9464840)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.escola_localizacao FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7307 (class 2620 OID 9464841)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.escola_rede_ensino FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7308 (class 2620 OID 9464842)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.escola_serie FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7310 (class 2620 OID 9464843)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.exemplar FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7311 (class 2620 OID 9464844)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.exemplar_emprestimo FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7312 (class 2620 OID 9464845)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.exemplar_tipo FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7313 (class 2620 OID 9464846)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.falta_atraso FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7314 (class 2620 OID 9464847)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.falta_atraso_compensado FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7315 (class 2620 OID 9464848)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.fonte FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7316 (class 2620 OID 9464849)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.funcao FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7317 (class 2620 OID 9464850)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.habilitacao FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7318 (class 2620 OID 9464851)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.habilitacao_curso FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7319 (class 2620 OID 9464852)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.historico_disciplinas FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7320 (class 2620 OID 9464853)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.historico_escolar FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7321 (class 2620 OID 9464854)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.infra_comodo_funcao FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7322 (class 2620 OID 9464855)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.infra_predio FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7323 (class 2620 OID 9464856)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.infra_predio_comodo FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7325 (class 2620 OID 9464857)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.material_didatico FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7326 (class 2620 OID 9464858)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.material_tipo FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7327 (class 2620 OID 9464859)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.matricula FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7331 (class 2620 OID 9464860)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.matricula_ocorrencia_disciplinar FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7334 (class 2620 OID 9464861)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.menu_tipo_usuario FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7335 (class 2620 OID 9464862)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.modulo FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7336 (class 2620 OID 9464863)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.motivo_afastamento FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7337 (class 2620 OID 9464864)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.motivo_baixa FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7338 (class 2620 OID 9464865)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.motivo_suspensao FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7339 (class 2620 OID 9464866)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.nivel_ensino FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7340 (class 2620 OID 9464867)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.operador FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7341 (class 2620 OID 9464868)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.pagamento_multa FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7342 (class 2620 OID 9464869)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.pre_requisito FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7343 (class 2620 OID 9464870)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.quadro_horario FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7344 (class 2620 OID 9464871)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.religiao FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7345 (class 2620 OID 9464872)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.reserva_vaga FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7346 (class 2620 OID 9464873)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.reservas FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7347 (class 2620 OID 9464874)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.sequencia_serie FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7348 (class 2620 OID 9464875)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.serie FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7349 (class 2620 OID 9464876)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.serie_pre_requisito FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7350 (class 2620 OID 9464877)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.servidor FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7351 (class 2620 OID 9464878)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.servidor_afastamento FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7352 (class 2620 OID 9464879)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.servidor_alocacao FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7353 (class 2620 OID 9464880)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.servidor_curso FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7354 (class 2620 OID 9464881)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.servidor_formacao FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7355 (class 2620 OID 9464882)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.servidor_titulo_concurso FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7356 (class 2620 OID 9464883)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.situacao FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7357 (class 2620 OID 9464884)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.tipo_avaliacao FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7358 (class 2620 OID 9464885)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.tipo_avaliacao_valores FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7359 (class 2620 OID 9464886)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.tipo_dispensa FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7360 (class 2620 OID 9464887)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.tipo_ensino FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7361 (class 2620 OID 9464888)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.tipo_ocorrencia_disciplinar FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7362 (class 2620 OID 9464889)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.tipo_regime FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7363 (class 2620 OID 9464890)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.tipo_usuario FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7364 (class 2620 OID 9464891)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.transferencia_solicitacao FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7365 (class 2620 OID 9464892)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.transferencia_tipo FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7366 (class 2620 OID 9464893)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.turma FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7367 (class 2620 OID 9464895)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.turma_modulo FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7368 (class 2620 OID 9464896)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.turma_tipo FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7369 (class 2620 OID 9464897)
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pmieducar.usuario FOR EACH ROW EXECUTE PROCEDURE pmieducar.fcn_aft_update();


--
-- TOC entry 7328 (class 2620 OID 9464898)
-- Name: retira_data_cancel_matricula_trg; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER retira_data_cancel_matricula_trg AFTER UPDATE ON pmieducar.matricula FOR EACH ROW EXECUTE PROCEDURE public.retira_data_cancel_matricula_fun();


--
-- TOC entry 7330 (class 2620 OID 9474663)
-- Name: trigger_audita_matricula; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER trigger_audita_matricula AFTER INSERT OR DELETE OR UPDATE ON pmieducar.matricula FOR EACH ROW EXECUTE PROCEDURE pmieducar.audita_matricula();


--
-- TOC entry 7332 (class 2620 OID 9474665)
-- Name: trigger_audita_matricula_turma; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER trigger_audita_matricula_turma AFTER INSERT OR DELETE OR UPDATE ON pmieducar.matricula_turma FOR EACH ROW EXECUTE PROCEDURE pmieducar.audita_matricula_turma();


--
-- TOC entry 7329 (class 2620 OID 9464899)
-- Name: trigger_updated_at_matricula; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER trigger_updated_at_matricula BEFORE UPDATE ON pmieducar.matricula FOR EACH ROW EXECUTE PROCEDURE pmieducar.updated_at_matricula();


--
-- TOC entry 7333 (class 2620 OID 9464900)
-- Name: trigger_updated_at_matricula_turma; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER trigger_updated_at_matricula_turma BEFORE UPDATE ON pmieducar.matricula_turma FOR EACH ROW EXECUTE PROCEDURE pmieducar.updated_at_matricula_turma();


--
-- TOC entry 7309 (class 2620 OID 9469010)
-- Name: update_escola_serie_disciplina_updated_at; Type: TRIGGER; Schema: pmieducar; Owner: -
--

CREATE TRIGGER update_escola_serie_disciplina_updated_at BEFORE UPDATE ON pmieducar.escola_serie_disciplina FOR EACH ROW EXECUTE PROCEDURE public.update_updated_at();


--
-- TOC entry 7253 (class 2620 OID 9464901)
-- Name: trg_aft_logradouro_fonetiza; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER trg_aft_logradouro_fonetiza AFTER INSERT OR UPDATE ON public.logradouro FOR EACH ROW EXECUTE PROCEDURE public.fcn_aft_logradouro_fonetiza();


--
-- TOC entry 7251 (class 2620 OID 9464902)
-- Name: trg_bef_bairro_historico; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER trg_bef_bairro_historico BEFORE UPDATE ON public.bairro FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_bairro();


--
-- TOC entry 7254 (class 2620 OID 9464903)
-- Name: trg_bef_logradouro_fonetiza; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER trg_bef_logradouro_fonetiza BEFORE DELETE ON public.logradouro FOR EACH ROW EXECUTE PROCEDURE public.fcn_bef_logradouro_fonetiza();


--
-- TOC entry 7255 (class 2620 OID 9464904)
-- Name: trg_bef_logradouro_historico; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER trg_bef_logradouro_historico BEFORE UPDATE ON public.logradouro FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_logradouro();


--
-- TOC entry 7257 (class 2620 OID 9464905)
-- Name: trg_bef_municipio_historico; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER trg_bef_municipio_historico BEFORE UPDATE ON public.municipio FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_municipio();


--
-- TOC entry 7252 (class 2620 OID 9464906)
-- Name: trg_delete_bairro_historico; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER trg_delete_bairro_historico AFTER DELETE ON public.bairro FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_bairro();


--
-- TOC entry 7256 (class 2620 OID 9464907)
-- Name: trg_delete_logradouro_historico; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER trg_delete_logradouro_historico AFTER DELETE ON public.logradouro FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_logradouro();


--
-- TOC entry 7258 (class 2620 OID 9464908)
-- Name: trg_delete_municipio_historico; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER trg_delete_municipio_historico AFTER DELETE ON public.municipio FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_municipio();


--
-- TOC entry 7372 (class 2620 OID 9464909)
-- Name: trg_bef_cep_logradouro_bairro_historico; Type: TRIGGER; Schema: urbano; Owner: -
--

CREATE TRIGGER trg_bef_cep_logradouro_bairro_historico BEFORE UPDATE ON urbano.cep_logradouro_bairro FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_cep_logradouro_bairro();


--
-- TOC entry 7370 (class 2620 OID 9464910)
-- Name: trg_bef_cep_logradouro_historico; Type: TRIGGER; Schema: urbano; Owner: -
--

CREATE TRIGGER trg_bef_cep_logradouro_historico BEFORE UPDATE ON urbano.cep_logradouro FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_cep_logradouro();


--
-- TOC entry 7373 (class 2620 OID 9464911)
-- Name: trg_delete_cep_logradouro_bairro_historico; Type: TRIGGER; Schema: urbano; Owner: -
--

CREATE TRIGGER trg_delete_cep_logradouro_bairro_historico AFTER DELETE ON urbano.cep_logradouro_bairro FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_cep_logradouro_bairro();


--
-- TOC entry 7371 (class 2620 OID 9464912)
-- Name: trg_delete_cep_logradouro_historico; Type: TRIGGER; Schema: urbano; Owner: -
--

CREATE TRIGGER trg_delete_cep_logradouro_historico AFTER DELETE ON urbano.cep_logradouro FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_cep_logradouro();


--
-- TOC entry 6396 (class 2606 OID 9464913)
-- Name: fk_funcao_grp_funcao; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.grupo_funcao
    ADD CONSTRAINT fk_funcao_grp_funcao FOREIGN KEY (idfunc, idsis, idmen) REFERENCES acesso.funcao(idfunc, idsis, idmen);


--
-- TOC entry 6407 (class 2606 OID 9464918)
-- Name: fk_funcao_operacao_funcao; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.operacao_funcao
    ADD CONSTRAINT fk_funcao_operacao_funcao FOREIGN KEY (idfunc, idsis, idmen) REFERENCES acesso.funcao(idfunc, idsis, idmen);


--
-- TOC entry 6400 (class 2606 OID 9464923)
-- Name: fk_grp_fun_grp_operacao; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.grupo_operacao
    ADD CONSTRAINT fk_grp_fun_grp_operacao FOREIGN KEY (idmen, idsis, idgrp, idfunc) REFERENCES acesso.grupo_funcao(idmen, idsis, idgrp, idfunc);


--
-- TOC entry 6395 (class 2606 OID 9464928)
-- Name: fk_grp_menu_grp_funcao; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.grupo_funcao
    ADD CONSTRAINT fk_grp_menu_grp_funcao FOREIGN KEY (idgrp, idsis, idmen) REFERENCES acesso.grupo_menu(idgrp, idsis, idmen);


--
-- TOC entry 6398 (class 2606 OID 9464933)
-- Name: fk_grp_sis_grp_menu; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.grupo_menu
    ADD CONSTRAINT fk_grp_sis_grp_menu FOREIGN KEY (idsis, idgrp) REFERENCES acesso.grupo_sistema(idsis, idgrp);


--
-- TOC entry 6402 (class 2606 OID 9464938)
-- Name: fk_grupo_grupo_sistema; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.grupo_sistema
    ADD CONSTRAINT fk_grupo_grupo_sistema FOREIGN KEY (idgrp) REFERENCES acesso.grupo(idgrp);


--
-- TOC entry 6412 (class 2606 OID 9464943)
-- Name: fk_grupo_usuario_grupo; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.usuario_grupo
    ADD CONSTRAINT fk_grupo_usuario_grupo FOREIGN KEY (idgrp) REFERENCES acesso.grupo(idgrp);


--
-- TOC entry 6409 (class 2606 OID 9464948)
-- Name: fk_inst_pessoa_instituicao; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.pessoa_instituicao
    ADD CONSTRAINT fk_inst_pessoa_instituicao FOREIGN KEY (idins) REFERENCES acesso.instituicao(idins);


--
-- TOC entry 6394 (class 2606 OID 9464953)
-- Name: fk_menu_funcao; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.funcao
    ADD CONSTRAINT fk_menu_funcao FOREIGN KEY (idmen, idsis) REFERENCES acesso.menu(idmen, idsis);


--
-- TOC entry 6397 (class 2606 OID 9464958)
-- Name: fk_menu_grp_menu; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.grupo_menu
    ADD CONSTRAINT fk_menu_grp_menu FOREIGN KEY (idmen, idsis) REFERENCES acesso.menu(idmen, idsis);


--
-- TOC entry 6404 (class 2606 OID 9464963)
-- Name: fk_menu_menu; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.menu
    ADD CONSTRAINT fk_menu_menu FOREIGN KEY (menu_idsis, menu_idmen) REFERENCES acesso.menu(idsis, idmen);


--
-- TOC entry 6399 (class 2606 OID 9464968)
-- Name: fk_oper_func_grp_oper; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.grupo_operacao
    ADD CONSTRAINT fk_oper_func_grp_oper FOREIGN KEY (idmen, idsis, idfunc, idope) REFERENCES acesso.operacao_funcao(idmen, idsis, idfunc, idope);


--
-- TOC entry 6406 (class 2606 OID 9464973)
-- Name: fk_operacao_operacao_funcao; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.operacao_funcao
    ADD CONSTRAINT fk_operacao_operacao_funcao FOREIGN KEY (idope) REFERENCES acesso.operacao(idope);


--
-- TOC entry 6408 (class 2606 OID 9464978)
-- Name: fk_pes_pessoa_instituicao; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.pessoa_instituicao
    ADD CONSTRAINT fk_pes_pessoa_instituicao FOREIGN KEY (idpes) REFERENCES cadastro.pessoa(idpes);


--
-- TOC entry 6410 (class 2606 OID 9464983)
-- Name: fk_pessoa_usuario; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.usuario
    ADD CONSTRAINT fk_pessoa_usuario FOREIGN KEY (idpes) REFERENCES cadastro.pessoa(idpes);


--
-- TOC entry 6401 (class 2606 OID 9464988)
-- Name: fk_sistema_grupo_sistema; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.grupo_sistema
    ADD CONSTRAINT fk_sistema_grupo_sistema FOREIGN KEY (idsis) REFERENCES acesso.sistema(idsis);


--
-- TOC entry 6403 (class 2606 OID 9464993)
-- Name: fk_sistema_menu; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.menu
    ADD CONSTRAINT fk_sistema_menu FOREIGN KEY (idsis) REFERENCES acesso.sistema(idsis);


--
-- TOC entry 6405 (class 2606 OID 9464998)
-- Name: fk_sistema_operacao; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.operacao
    ADD CONSTRAINT fk_sistema_operacao FOREIGN KEY (idsis) REFERENCES acesso.sistema(idsis);


--
-- TOC entry 6411 (class 2606 OID 9465003)
-- Name: fk_usuario_usuario_grupo; Type: FK CONSTRAINT; Schema: acesso; Owner: -
--

ALTER TABLE ONLY acesso.usuario_grupo
    ADD CONSTRAINT fk_usuario_usuario_grupo FOREIGN KEY (login) REFERENCES acesso.usuario(login);


--
-- TOC entry 6422 (class 2606 OID 9465008)
-- Name: fk_alterar_usuario_cardapio; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.cardapio
    ADD CONSTRAINT fk_alterar_usuario_cardapio FOREIGN KEY (login_alteracao) REFERENCES acesso.usuario(login);


--
-- TOC entry 6415 (class 2606 OID 9465013)
-- Name: fk_baixa_guia_baixa_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.baixa_guia_produto
    ADD CONSTRAINT fk_baixa_guia_baixa_produto FOREIGN KEY (idbai) REFERENCES alimentos.baixa_guia_remessa(idbai);


--
-- TOC entry 6437 (class 2606 OID 9465018)
-- Name: fk_calendario_evento; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.evento
    ADD CONSTRAINT fk_calendario_evento FOREIGN KEY (idcad) REFERENCES alimentos.calendario(idcad);


--
-- TOC entry 6482 (class 2606 OID 9465023)
-- Name: fk_calendario_unidade; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.unidade_atendida
    ADD CONSTRAINT fk_calendario_unidade FOREIGN KEY (idcad) REFERENCES alimentos.calendario(idcad);


--
-- TOC entry 6454 (class 2606 OID 9465028)
-- Name: fk_cancelar_usuario_guia_remessa; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.guia_remessa
    ADD CONSTRAINT fk_cancelar_usuario_guia_remessa FOREIGN KEY (login_cancelamento) REFERENCES acesso.usuario(login);


--
-- TOC entry 6424 (class 2606 OID 9465033)
-- Name: fk_cardapio_cardapio_faixa_unidade; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.cardapio_faixa_unidade
    ADD CONSTRAINT fk_cardapio_cardapio_faixa_unidade FOREIGN KEY (idcar) REFERENCES alimentos.cardapio(idcar);


--
-- TOC entry 6426 (class 2606 OID 9465038)
-- Name: fk_cardapio_cardapio_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.cardapio_produto
    ADD CONSTRAINT fk_cardapio_cardapio_produto FOREIGN KEY (idcar) REFERENCES alimentos.cardapio(idcar);


--
-- TOC entry 6428 (class 2606 OID 9465043)
-- Name: fk_cardapio_cardapio_receita; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.cardapio_receita
    ADD CONSTRAINT fk_cardapio_cardapio_receita FOREIGN KEY (idcar) REFERENCES alimentos.cardapio(idcar);


--
-- TOC entry 6418 (class 2606 OID 9465048)
-- Name: fk_cliente_calendario; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.calendario
    ADD CONSTRAINT fk_cliente_calendario FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6421 (class 2606 OID 9465053)
-- Name: fk_cliente_cardapio; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.cardapio
    ADD CONSTRAINT fk_cliente_cardapio FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6434 (class 2606 OID 9465058)
-- Name: fk_cliente_contrato; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.contrato
    ADD CONSTRAINT fk_cliente_contrato FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6431 (class 2606 OID 9465063)
-- Name: fk_cliente_cpquimico; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.composto_quimico
    ADD CONSTRAINT fk_cliente_cpquimico FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6442 (class 2606 OID 9465068)
-- Name: fk_cliente_fornecedor; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.fornecedor
    ADD CONSTRAINT fk_cliente_fornecedor FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6440 (class 2606 OID 9465073)
-- Name: fk_cliente_grpatencao; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.faixa_etaria
    ADD CONSTRAINT fk_cliente_grpatencao FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6445 (class 2606 OID 9465078)
-- Name: fk_cliente_grpquimico; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.grupo_quimico
    ADD CONSTRAINT fk_cliente_grpquimico FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6453 (class 2606 OID 9465083)
-- Name: fk_cliente_guia_remessa; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.guia_remessa
    ADD CONSTRAINT fk_cliente_guia_remessa FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6458 (class 2606 OID 9465088)
-- Name: fk_cliente_log_guia; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.log_guia_remessa
    ADD CONSTRAINT fk_cliente_log_guia FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6471 (class 2606 OID 9465093)
-- Name: fk_cliente_receita; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.receita
    ADD CONSTRAINT fk_cliente_receita FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6476 (class 2606 OID 9465098)
-- Name: fk_cliente_tpproduto; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.tipo_produto
    ADD CONSTRAINT fk_cliente_tpproduto FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6477 (class 2606 OID 9465103)
-- Name: fk_cliente_tprefeicao; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.tipo_refeicao
    ADD CONSTRAINT fk_cliente_tprefeicao FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6478 (class 2606 OID 9465108)
-- Name: fk_cliente_tpunidade; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.tipo_unidade
    ADD CONSTRAINT fk_cliente_tpunidade FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6481 (class 2606 OID 9465113)
-- Name: fk_cliente_unidade; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.unidade_atendida
    ADD CONSTRAINT fk_cliente_unidade FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6485 (class 2606 OID 9465118)
-- Name: fk_cliente_uniproduto; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.unidade_produto
    ADD CONSTRAINT fk_cliente_uniproduto FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6436 (class 2606 OID 9465123)
-- Name: fk_contrato_contrato_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.contrato_produto
    ADD CONSTRAINT fk_contrato_contrato_produto FOREIGN KEY (idcon) REFERENCES alimentos.contrato(idcon);


--
-- TOC entry 6452 (class 2606 OID 9465128)
-- Name: fk_contrato_guia_remessa; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.guia_remessa
    ADD CONSTRAINT fk_contrato_guia_remessa FOREIGN KEY (idcon) REFERENCES alimentos.contrato(idcon);


--
-- TOC entry 6439 (class 2606 OID 9465133)
-- Name: fk_cp_quimico_faixa_cp_quimico; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.faixa_composto_quimico
    ADD CONSTRAINT fk_cp_quimico_faixa_cp_quimico FOREIGN KEY (idcom) REFERENCES alimentos.composto_quimico(idcom);


--
-- TOC entry 6451 (class 2606 OID 9465138)
-- Name: fk_emitir_usuario_guia_remessa; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.guia_remessa
    ADD CONSTRAINT fk_emitir_usuario_guia_remessa FOREIGN KEY (login_emissao) REFERENCES acesso.usuario(login);


--
-- TOC entry 6484 (class 2606 OID 9465143)
-- Name: fk_faixa_etaria_unidade_faixa; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.unidade_faixa_etaria
    ADD CONSTRAINT fk_faixa_etaria_unidade_faixa FOREIGN KEY (idfae) REFERENCES alimentos.faixa_etaria(idfae);


--
-- TOC entry 6438 (class 2606 OID 9465148)
-- Name: fk_faixa_faixa_cp_quimico; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.faixa_composto_quimico
    ADD CONSTRAINT fk_faixa_faixa_cp_quimico FOREIGN KEY (idfae) REFERENCES alimentos.faixa_etaria(idfae);


--
-- TOC entry 6423 (class 2606 OID 9465153)
-- Name: fk_faixa_uni_cardapio_faixa_unidade; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.cardapio_faixa_unidade
    ADD CONSTRAINT fk_faixa_uni_cardapio_faixa_unidade FOREIGN KEY (idfeu) REFERENCES alimentos.unidade_faixa_etaria(idfeu);


--
-- TOC entry 6433 (class 2606 OID 9465158)
-- Name: fk_fornecedor_contrato; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.contrato
    ADD CONSTRAINT fk_fornecedor_contrato FOREIGN KEY (idfor) REFERENCES alimentos.fornecedor(idfor);


--
-- TOC entry 6450 (class 2606 OID 9465163)
-- Name: fk_fornecedor_guia_remessa; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.guia_remessa
    ADD CONSTRAINT fk_fornecedor_guia_remessa FOREIGN KEY (idfor) REFERENCES alimentos.fornecedor(idfor);


--
-- TOC entry 6467 (class 2606 OID 9465168)
-- Name: fk_fornecedor_produto_fornecedor; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.produto_fornecedor
    ADD CONSTRAINT fk_fornecedor_produto_fornecedor FOREIGN KEY (idfor) REFERENCES alimentos.fornecedor(idfor);


--
-- TOC entry 6444 (class 2606 OID 9465173)
-- Name: fk_fornecedor_unidade; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.fornecedor_unidade_atendida
    ADD CONSTRAINT fk_fornecedor_unidade FOREIGN KEY (idfor) REFERENCES alimentos.fornecedor(idfor);


--
-- TOC entry 6430 (class 2606 OID 9465178)
-- Name: fk_grupo_cp_quimico_cp_quimico; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.composto_quimico
    ADD CONSTRAINT fk_grupo_cp_quimico_cp_quimico FOREIGN KEY (idgrpq) REFERENCES alimentos.grupo_quimico(idgrpq);


--
-- TOC entry 6456 (class 2606 OID 9465183)
-- Name: fk_guia_guia_remessa_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.guia_remessa_produto
    ADD CONSTRAINT fk_guia_guia_remessa_produto FOREIGN KEY (idgui) REFERENCES alimentos.guia_remessa(idgui);


--
-- TOC entry 6414 (class 2606 OID 9465188)
-- Name: fk_guia_produto_baixa_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.baixa_guia_produto
    ADD CONSTRAINT fk_guia_produto_baixa_produto FOREIGN KEY (idgup) REFERENCES alimentos.guia_remessa_produto(idgup);


--
-- TOC entry 6417 (class 2606 OID 9465193)
-- Name: fk_guia_remessa_baixa_guia; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.baixa_guia_remessa
    ADD CONSTRAINT fk_guia_remessa_baixa_guia FOREIGN KEY (idgui) REFERENCES alimentos.guia_remessa(idgui);


--
-- TOC entry 6448 (class 2606 OID 9465198)
-- Name: fk_guia_remessa_guia_pro_diario; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.guia_produto_diario
    ADD CONSTRAINT fk_guia_remessa_guia_pro_diario FOREIGN KEY (idgui) REFERENCES alimentos.guia_remessa(idgui);


--
-- TOC entry 6420 (class 2606 OID 9465203)
-- Name: fk_incluir_usuario_cardapio; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.cardapio
    ADD CONSTRAINT fk_incluir_usuario_cardapio FOREIGN KEY (login_inclusao) REFERENCES acesso.usuario(login);


--
-- TOC entry 6459 (class 2606 OID 9465208)
-- Name: fk_medidas_caseiras_cliente; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.medidas_caseiras
    ADD CONSTRAINT fk_medidas_caseiras_cliente FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6429 (class 2606 OID 9465213)
-- Name: fk_pessoa_cliente; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.cliente
    ADD CONSTRAINT fk_pessoa_cliente FOREIGN KEY (idpes) REFERENCES alimentos.pessoa(idpes);


--
-- TOC entry 6441 (class 2606 OID 9465218)
-- Name: fk_pessoa_fornecedor; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.fornecedor
    ADD CONSTRAINT fk_pessoa_fornecedor FOREIGN KEY (idpes) REFERENCES alimentos.pessoa(idpes);


--
-- TOC entry 6480 (class 2606 OID 9465223)
-- Name: fk_pessoa_unidade_atend; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.unidade_atendida
    ADD CONSTRAINT fk_pessoa_unidade_atend FOREIGN KEY (idpes) REFERENCES alimentos.pessoa(idpes);


--
-- TOC entry 6465 (class 2606 OID 9465228)
-- Name: fk_prod_cp_quimico_cp_quimico; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.produto_composto_quimico
    ADD CONSTRAINT fk_prod_cp_quimico_cp_quimico FOREIGN KEY (idcom) REFERENCES alimentos.composto_quimico(idcom);


--
-- TOC entry 6464 (class 2606 OID 9465233)
-- Name: fk_prod_cp_quimico_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.produto_composto_quimico
    ADD CONSTRAINT fk_prod_cp_quimico_produto FOREIGN KEY (idpro) REFERENCES alimentos.produto(idpro);


--
-- TOC entry 6425 (class 2606 OID 9465238)
-- Name: fk_produto_cardapio_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.cardapio_produto
    ADD CONSTRAINT fk_produto_cardapio_produto FOREIGN KEY (idpro) REFERENCES alimentos.produto(idpro);


--
-- TOC entry 6463 (class 2606 OID 9465243)
-- Name: fk_produto_cliente; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.produto
    ADD CONSTRAINT fk_produto_cliente FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6435 (class 2606 OID 9465248)
-- Name: fk_produto_contrato_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.contrato_produto
    ADD CONSTRAINT fk_produto_contrato_produto FOREIGN KEY (idpro) REFERENCES alimentos.produto(idpro);


--
-- TOC entry 6462 (class 2606 OID 9465253)
-- Name: fk_produto_fornecedor; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.produto
    ADD CONSTRAINT fk_produto_fornecedor FOREIGN KEY (idfor) REFERENCES alimentos.fornecedor(idfor);


--
-- TOC entry 6447 (class 2606 OID 9465258)
-- Name: fk_produto_guia_pro_diario; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.guia_produto_diario
    ADD CONSTRAINT fk_produto_guia_pro_diario FOREIGN KEY (idpro) REFERENCES alimentos.produto(idpro);


--
-- TOC entry 6455 (class 2606 OID 9465263)
-- Name: fk_produto_guia_remessa_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.guia_remessa_produto
    ADD CONSTRAINT fk_produto_guia_remessa_produto FOREIGN KEY (idpro) REFERENCES alimentos.produto(idpro);


--
-- TOC entry 6470 (class 2606 OID 9465268)
-- Name: fk_produto_medida_caseira_cliente; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.produto_medida_caseira
    ADD CONSTRAINT fk_produto_medida_caseira_cliente FOREIGN KEY (idcli) REFERENCES alimentos.cliente(idcli);


--
-- TOC entry 6469 (class 2606 OID 9465273)
-- Name: fk_produto_medida_caseira_medidas; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.produto_medida_caseira
    ADD CONSTRAINT fk_produto_medida_caseira_medidas FOREIGN KEY (idmedcas, idcli) REFERENCES alimentos.medidas_caseiras(idmedcas, idcli);


--
-- TOC entry 6468 (class 2606 OID 9465278)
-- Name: fk_produto_medida_caseira_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.produto_medida_caseira
    ADD CONSTRAINT fk_produto_medida_caseira_produto FOREIGN KEY (idpro) REFERENCES alimentos.produto(idpro);


--
-- TOC entry 6466 (class 2606 OID 9465283)
-- Name: fk_produto_produto_fornecedor; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.produto_fornecedor
    ADD CONSTRAINT fk_produto_produto_fornecedor FOREIGN KEY (idpro) REFERENCES alimentos.produto(idpro);


--
-- TOC entry 6461 (class 2606 OID 9465288)
-- Name: fk_produto_tipo; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.produto
    ADD CONSTRAINT fk_produto_tipo FOREIGN KEY (idtip) REFERENCES alimentos.tipo_produto(idtip);


--
-- TOC entry 6460 (class 2606 OID 9465293)
-- Name: fk_produto_unidade; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.produto
    ADD CONSTRAINT fk_produto_unidade FOREIGN KEY (idunp, idcli) REFERENCES alimentos.unidade_produto(idunp, idcli);


--
-- TOC entry 6473 (class 2606 OID 9465298)
-- Name: fk_rec_cp_quimico_cp_quimico; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.receita_composto_quimico
    ADD CONSTRAINT fk_rec_cp_quimico_cp_quimico FOREIGN KEY (idcom) REFERENCES alimentos.composto_quimico(idcom);


--
-- TOC entry 6472 (class 2606 OID 9465303)
-- Name: fk_rec_cp_quimico_receita; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.receita_composto_quimico
    ADD CONSTRAINT fk_rec_cp_quimico_receita FOREIGN KEY (idrec) REFERENCES alimentos.receita(idrec);


--
-- TOC entry 6475 (class 2606 OID 9465308)
-- Name: fk_rec_prod_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.receita_produto
    ADD CONSTRAINT fk_rec_prod_produto FOREIGN KEY (idpro) REFERENCES alimentos.produto(idpro);


--
-- TOC entry 6474 (class 2606 OID 9465313)
-- Name: fk_rec_prod_receita; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.receita_produto
    ADD CONSTRAINT fk_rec_prod_receita FOREIGN KEY (idrec) REFERENCES alimentos.receita(idrec);


--
-- TOC entry 6427 (class 2606 OID 9465318)
-- Name: fk_receita_cardapio_receita; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.cardapio_receita
    ADD CONSTRAINT fk_receita_cardapio_receita FOREIGN KEY (idrec) REFERENCES alimentos.receita(idrec);


--
-- TOC entry 6479 (class 2606 OID 9465323)
-- Name: fk_tipo_uni_uni_atendida; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.unidade_atendida
    ADD CONSTRAINT fk_tipo_uni_uni_atendida FOREIGN KEY (idtip) REFERENCES alimentos.tipo_unidade(idtip);


--
-- TOC entry 6419 (class 2606 OID 9465328)
-- Name: fk_tp_refeicao_cardapio; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.cardapio
    ADD CONSTRAINT fk_tp_refeicao_cardapio FOREIGN KEY (idtre) REFERENCES alimentos.tipo_refeicao(idtre);


--
-- TOC entry 6449 (class 2606 OID 9465333)
-- Name: fk_uni_atend_guia_remessa; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.guia_remessa
    ADD CONSTRAINT fk_uni_atend_guia_remessa FOREIGN KEY (iduni) REFERENCES alimentos.unidade_atendida(iduni);


--
-- TOC entry 6483 (class 2606 OID 9465338)
-- Name: fk_uni_atend_uni_faixa_eta; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.unidade_faixa_etaria
    ADD CONSTRAINT fk_uni_atend_uni_faixa_eta FOREIGN KEY (iduni) REFERENCES alimentos.unidade_atendida(iduni);


--
-- TOC entry 6446 (class 2606 OID 9465343)
-- Name: fk_unidade_atendida_guia_pro_diario; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.guia_produto_diario
    ADD CONSTRAINT fk_unidade_atendida_guia_pro_diario FOREIGN KEY (iduni) REFERENCES alimentos.unidade_atendida(iduni);


--
-- TOC entry 6443 (class 2606 OID 9465348)
-- Name: fk_unidade_fornecedor; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.fornecedor_unidade_atendida
    ADD CONSTRAINT fk_unidade_fornecedor FOREIGN KEY (iduni) REFERENCES alimentos.unidade_atendida(iduni);


--
-- TOC entry 6413 (class 2606 OID 9465353)
-- Name: fk_usuario_baixa_guia; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.baixa_guia_produto
    ADD CONSTRAINT fk_usuario_baixa_guia FOREIGN KEY (login_baixa) REFERENCES acesso.usuario(login);


--
-- TOC entry 6416 (class 2606 OID 9465358)
-- Name: fk_usuario_baixa_guia_remessa; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.baixa_guia_remessa
    ADD CONSTRAINT fk_usuario_baixa_guia_remessa FOREIGN KEY (login_baixa) REFERENCES acesso.usuario(login);


--
-- TOC entry 6432 (class 2606 OID 9465363)
-- Name: fk_usuario_contrato; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.contrato
    ADD CONSTRAINT fk_usuario_contrato FOREIGN KEY (login) REFERENCES acesso.usuario(login);


--
-- TOC entry 6457 (class 2606 OID 9465368)
-- Name: fk_usuario_log_guia; Type: FK CONSTRAINT; Schema: alimentos; Owner: -
--

ALTER TABLE ONLY alimentos.log_guia_remessa
    ADD CONSTRAINT fk_usuario_log_guia FOREIGN KEY (login) REFERENCES acesso.usuario(login);


--
-- TOC entry 6496 (class 2606 OID 9474453)
-- Name: cartorio_cert_civil_inep_fk; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.documento
    ADD CONSTRAINT cartorio_cert_civil_inep_fk FOREIGN KEY (cartorio_cert_civil_inep) REFERENCES cadastro.codigo_cartorio_inep(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6532 (class 2606 OID 9465373)
-- Name: fisica_foto_idpes_fkey; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica_foto
    ADD CONSTRAINT fisica_foto_idpes_fkey FOREIGN KEY (idpes) REFERENCES cadastro.pessoa(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6510 (class 2606 OID 9465378)
-- Name: fisica_ref_cod_religiao; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica
    ADD CONSTRAINT fisica_ref_cod_religiao FOREIGN KEY (ref_cod_religiao) REFERENCES pmieducar.religiao(cod_religiao);


--
-- TOC entry 6535 (class 2606 OID 9465383)
-- Name: fisica_sangue_idpes_fkey; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica_sangue
    ADD CONSTRAINT fisica_sangue_idpes_fkey FOREIGN KEY (idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6486 (class 2606 OID 9465388)
-- Name: fk_aviso_nome_fisica; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.aviso_nome
    ADD CONSTRAINT fk_aviso_nome_fisica FOREIGN KEY (idpes) REFERENCES cadastro.fisica(idpes) ON DELETE RESTRICT;


--
-- TOC entry 6487 (class 2606 OID 9465393)
-- Name: fk_documento_fisica; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.documento
    ADD CONSTRAINT fk_documento_fisica FOREIGN KEY (idpes) REFERENCES cadastro.fisica(idpes);


--
-- TOC entry 6488 (class 2606 OID 9465398)
-- Name: fk_documento_orgao_emissor_rg; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.documento
    ADD CONSTRAINT fk_documento_orgao_emissor_rg FOREIGN KEY (idorg_exp_rg) REFERENCES cadastro.orgao_emissor_rg(idorg_rg) ON DELETE RESTRICT;


--
-- TOC entry 6489 (class 2606 OID 9465403)
-- Name: fk_documento_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.documento
    ADD CONSTRAINT fk_documento_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6490 (class 2606 OID 9465408)
-- Name: fk_documento_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.documento
    ADD CONSTRAINT fk_documento_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6491 (class 2606 OID 9465413)
-- Name: fk_documento_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.documento
    ADD CONSTRAINT fk_documento_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6492 (class 2606 OID 9465418)
-- Name: fk_documento_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.documento
    ADD CONSTRAINT fk_documento_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6493 (class 2606 OID 9465423)
-- Name: fk_documento_uf_cart_trabalho; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.documento
    ADD CONSTRAINT fk_documento_uf_cart_trabalho FOREIGN KEY (sigla_uf_cart_trabalho) REFERENCES public.uf(sigla_uf);


--
-- TOC entry 6494 (class 2606 OID 9465428)
-- Name: fk_documento_uf_cert_civil; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.documento
    ADD CONSTRAINT fk_documento_uf_cert_civil FOREIGN KEY (sigla_uf_cert_civil) REFERENCES public.uf(sigla_uf);


--
-- TOC entry 6495 (class 2606 OID 9465433)
-- Name: fk_documento_uf_rg; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.documento
    ADD CONSTRAINT fk_documento_uf_rg FOREIGN KEY (sigla_uf_exp_rg) REFERENCES public.uf(sigla_uf);


--
-- TOC entry 6497 (class 2606 OID 9465438)
-- Name: fk_endereco_externo_pessoa; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.endereco_externo
    ADD CONSTRAINT fk_endereco_externo_pessoa FOREIGN KEY (idpes) REFERENCES cadastro.pessoa(idpes);


--
-- TOC entry 6498 (class 2606 OID 9465443)
-- Name: fk_endereco_externo_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.endereco_externo
    ADD CONSTRAINT fk_endereco_externo_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6499 (class 2606 OID 9465448)
-- Name: fk_endereco_externo_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.endereco_externo
    ADD CONSTRAINT fk_endereco_externo_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6500 (class 2606 OID 9465453)
-- Name: fk_endereco_externo_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.endereco_externo
    ADD CONSTRAINT fk_endereco_externo_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6501 (class 2606 OID 9465458)
-- Name: fk_endereco_externo_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.endereco_externo
    ADD CONSTRAINT fk_endereco_externo_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6502 (class 2606 OID 9465463)
-- Name: fk_endereco_externo_tipo_log; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.endereco_externo
    ADD CONSTRAINT fk_endereco_externo_tipo_log FOREIGN KEY (idtlog) REFERENCES urbano.tipo_logradouro(idtlog);


--
-- TOC entry 6503 (class 2606 OID 9465468)
-- Name: fk_endereco_externo_uf; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.endereco_externo
    ADD CONSTRAINT fk_endereco_externo_uf FOREIGN KEY (sigla_uf) REFERENCES public.uf(sigla_uf);


--
-- TOC entry 6504 (class 2606 OID 9465473)
-- Name: fk_endereco_pes_cep_log_bai; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.endereco_pessoa
    ADD CONSTRAINT fk_endereco_pes_cep_log_bai FOREIGN KEY (cep, idbai, idlog) REFERENCES urbano.cep_logradouro_bairro(cep, idbai, idlog) ON UPDATE CASCADE;


--
-- TOC entry 6505 (class 2606 OID 9465478)
-- Name: fk_endereco_pessoa_pessoa; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.endereco_pessoa
    ADD CONSTRAINT fk_endereco_pessoa_pessoa FOREIGN KEY (idpes) REFERENCES cadastro.pessoa(idpes);


--
-- TOC entry 6506 (class 2606 OID 9465483)
-- Name: fk_endereco_pessoa_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.endereco_pessoa
    ADD CONSTRAINT fk_endereco_pessoa_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6507 (class 2606 OID 9465488)
-- Name: fk_endereco_pessoa_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.endereco_pessoa
    ADD CONSTRAINT fk_endereco_pessoa_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6508 (class 2606 OID 9465493)
-- Name: fk_endereco_pessoa_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.endereco_pessoa
    ADD CONSTRAINT fk_endereco_pessoa_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6509 (class 2606 OID 9465498)
-- Name: fk_endereco_pessoa_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.endereco_pessoa
    ADD CONSTRAINT fk_endereco_pessoa_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6529 (class 2606 OID 9465503)
-- Name: fk_fisica_cpf_fisica; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica_cpf
    ADD CONSTRAINT fk_fisica_cpf_fisica FOREIGN KEY (idpes) REFERENCES cadastro.fisica(idpes) ON DELETE RESTRICT;


--
-- TOC entry 6528 (class 2606 OID 9465508)
-- Name: fk_fisica_cpf_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica_cpf
    ADD CONSTRAINT fk_fisica_cpf_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6527 (class 2606 OID 9465513)
-- Name: fk_fisica_cpf_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica_cpf
    ADD CONSTRAINT fk_fisica_cpf_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6526 (class 2606 OID 9465518)
-- Name: fk_fisica_cpf_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica_cpf
    ADD CONSTRAINT fk_fisica_cpf_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6525 (class 2606 OID 9465523)
-- Name: fk_fisica_cpf_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica_cpf
    ADD CONSTRAINT fk_fisica_cpf_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6511 (class 2606 OID 9465528)
-- Name: fk_fisica_escolaridade; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica
    ADD CONSTRAINT fk_fisica_escolaridade FOREIGN KEY (idesco) REFERENCES cadastro.escolaridade(idesco);


--
-- TOC entry 6512 (class 2606 OID 9465533)
-- Name: fk_fisica_estado_civil; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica
    ADD CONSTRAINT fk_fisica_estado_civil FOREIGN KEY (ideciv) REFERENCES cadastro.estado_civil(ideciv);


--
-- TOC entry 6513 (class 2606 OID 9465538)
-- Name: fk_fisica_municipio; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica
    ADD CONSTRAINT fk_fisica_municipio FOREIGN KEY (idmun_nascimento) REFERENCES public.municipio(idmun);


--
-- TOC entry 6514 (class 2606 OID 9465543)
-- Name: fk_fisica_ocupacao; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica
    ADD CONSTRAINT fk_fisica_ocupacao FOREIGN KEY (idocup) REFERENCES cadastro.ocupacao(idocup);


--
-- TOC entry 6515 (class 2606 OID 9465548)
-- Name: fk_fisica_pais; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica
    ADD CONSTRAINT fk_fisica_pais FOREIGN KEY (idpais_estrangeiro) REFERENCES public.pais(idpais);


--
-- TOC entry 6516 (class 2606 OID 9465553)
-- Name: fk_fisica_pessoa; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica
    ADD CONSTRAINT fk_fisica_pessoa FOREIGN KEY (idpes) REFERENCES cadastro.pessoa(idpes) ON DELETE RESTRICT;


--
-- TOC entry 6517 (class 2606 OID 9465558)
-- Name: fk_fisica_pessoa_conjuge; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica
    ADD CONSTRAINT fk_fisica_pessoa_conjuge FOREIGN KEY (idpes_con) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6518 (class 2606 OID 9465563)
-- Name: fk_fisica_pessoa_mae; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica
    ADD CONSTRAINT fk_fisica_pessoa_mae FOREIGN KEY (idpes_mae) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6519 (class 2606 OID 9465568)
-- Name: fk_fisica_pessoa_pai; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica
    ADD CONSTRAINT fk_fisica_pessoa_pai FOREIGN KEY (idpes_pai) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6520 (class 2606 OID 9465573)
-- Name: fk_fisica_pessoa_responsavel; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica
    ADD CONSTRAINT fk_fisica_pessoa_responsavel FOREIGN KEY (idpes_responsavel) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6521 (class 2606 OID 9465578)
-- Name: fk_fisica_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica
    ADD CONSTRAINT fk_fisica_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6522 (class 2606 OID 9465583)
-- Name: fk_fisica_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica
    ADD CONSTRAINT fk_fisica_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6523 (class 2606 OID 9465588)
-- Name: fk_fisica_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica
    ADD CONSTRAINT fk_fisica_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6524 (class 2606 OID 9465593)
-- Name: fk_fisica_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica
    ADD CONSTRAINT fk_fisica_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6540 (class 2606 OID 9465598)
-- Name: fk_fone_pessoa_pessoa; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fone_pessoa
    ADD CONSTRAINT fk_fone_pessoa_pessoa FOREIGN KEY (idpes) REFERENCES cadastro.pessoa(idpes);


--
-- TOC entry 6539 (class 2606 OID 9465603)
-- Name: fk_fone_pessoa_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fone_pessoa
    ADD CONSTRAINT fk_fone_pessoa_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6538 (class 2606 OID 9465608)
-- Name: fk_fone_pessoa_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fone_pessoa
    ADD CONSTRAINT fk_fone_pessoa_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6537 (class 2606 OID 9465613)
-- Name: fk_fone_pessoa_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fone_pessoa
    ADD CONSTRAINT fk_fone_pessoa_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6536 (class 2606 OID 9465618)
-- Name: fk_fone_pessoa_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fone_pessoa
    ADD CONSTRAINT fk_fone_pessoa_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6541 (class 2606 OID 9465623)
-- Name: fk_funcionario_fisica; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.funcionario
    ADD CONSTRAINT fk_funcionario_fisica FOREIGN KEY (idpes) REFERENCES cadastro.fisica(idpes);


--
-- TOC entry 6542 (class 2606 OID 9465628)
-- Name: fk_funcionario_instituicao; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.funcionario
    ADD CONSTRAINT fk_funcionario_instituicao FOREIGN KEY (idins) REFERENCES acesso.instituicao(idins);


--
-- TOC entry 6543 (class 2606 OID 9465633)
-- Name: fk_funcionario_setor; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.funcionario
    ADD CONSTRAINT fk_funcionario_setor FOREIGN KEY (idset) REFERENCES public.setor(idset);


--
-- TOC entry 6544 (class 2606 OID 9465638)
-- Name: fk_funcionario_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.funcionario
    ADD CONSTRAINT fk_funcionario_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6545 (class 2606 OID 9465643)
-- Name: fk_funcionario_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.funcionario
    ADD CONSTRAINT fk_funcionario_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6546 (class 2606 OID 9465648)
-- Name: fk_funcionario_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.funcionario
    ADD CONSTRAINT fk_funcionario_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6547 (class 2606 OID 9465653)
-- Name: fk_funcionario_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.funcionario
    ADD CONSTRAINT fk_funcionario_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6549 (class 2606 OID 9465658)
-- Name: fk_hist_cartao_pes_cidadao; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.historico_cartao
    ADD CONSTRAINT fk_hist_cartao_pes_cidadao FOREIGN KEY (idpes_cidadao) REFERENCES cadastro.pessoa(idpes);


--
-- TOC entry 6548 (class 2606 OID 9465663)
-- Name: fk_hist_cartao_pes_emitiu; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.historico_cartao
    ADD CONSTRAINT fk_hist_cartao_pes_emitiu FOREIGN KEY (idpes_emitiu) REFERENCES cadastro.pessoa(idpes);


--
-- TOC entry 6554 (class 2606 OID 9465668)
-- Name: fk_juridica_pessoa; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.juridica
    ADD CONSTRAINT fk_juridica_pessoa FOREIGN KEY (idpes) REFERENCES cadastro.pessoa(idpes);


--
-- TOC entry 6553 (class 2606 OID 9465673)
-- Name: fk_juridica_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.juridica
    ADD CONSTRAINT fk_juridica_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6552 (class 2606 OID 9465678)
-- Name: fk_juridica_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.juridica
    ADD CONSTRAINT fk_juridica_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6551 (class 2606 OID 9465683)
-- Name: fk_juridica_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.juridica
    ADD CONSTRAINT fk_juridica_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6550 (class 2606 OID 9465688)
-- Name: fk_juridica_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.juridica
    ADD CONSTRAINT fk_juridica_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6567 (class 2606 OID 9465693)
-- Name: fk_juridica_socio; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.socio
    ADD CONSTRAINT fk_juridica_socio FOREIGN KEY (idpes_juridica) REFERENCES cadastro.juridica(idpes);


--
-- TOC entry 6559 (class 2606 OID 9465698)
-- Name: fk_pessoa_fonetico_pessoa; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.pessoa_fonetico
    ADD CONSTRAINT fk_pessoa_fonetico_pessoa FOREIGN KEY (idpes) REFERENCES cadastro.pessoa(idpes);


--
-- TOC entry 6558 (class 2606 OID 9465703)
-- Name: fk_pessoa_pessoa_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.pessoa
    ADD CONSTRAINT fk_pessoa_pessoa_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6557 (class 2606 OID 9465708)
-- Name: fk_pessoa_pessoa_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.pessoa
    ADD CONSTRAINT fk_pessoa_pessoa_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6556 (class 2606 OID 9465713)
-- Name: fk_pessoa_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.pessoa
    ADD CONSTRAINT fk_pessoa_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6555 (class 2606 OID 9465718)
-- Name: fk_pessoa_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.pessoa
    ADD CONSTRAINT fk_pessoa_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6566 (class 2606 OID 9465723)
-- Name: fk_pessoa_socio; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.socio
    ADD CONSTRAINT fk_pessoa_socio FOREIGN KEY (idpes_fisica) REFERENCES cadastro.pessoa(idpes);


--
-- TOC entry 7207 (class 2606 OID 9474360)
-- Name: fk_ref_sigla_uf; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.codigo_cartorio_inep
    ADD CONSTRAINT fk_ref_sigla_uf FOREIGN KEY (ref_sigla_uf) REFERENCES public.uf(sigla_uf);


--
-- TOC entry 6565 (class 2606 OID 9465728)
-- Name: fk_socio_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.socio
    ADD CONSTRAINT fk_socio_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6564 (class 2606 OID 9465733)
-- Name: fk_socio_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.socio
    ADD CONSTRAINT fk_socio_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6563 (class 2606 OID 9465738)
-- Name: fk_socio_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.socio
    ADD CONSTRAINT fk_socio_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6562 (class 2606 OID 9465743)
-- Name: fk_socio_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.socio
    ADD CONSTRAINT fk_socio_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6531 (class 2606 OID 9465748)
-- Name: pessoa_deficiencia_ref_cod_deficiencia_fkey; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica_deficiencia
    ADD CONSTRAINT pessoa_deficiencia_ref_cod_deficiencia_fkey FOREIGN KEY (ref_cod_deficiencia) REFERENCES cadastro.deficiencia(cod_deficiencia) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6530 (class 2606 OID 9465753)
-- Name: pessoa_deficiencia_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica_deficiencia
    ADD CONSTRAINT pessoa_deficiencia_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6534 (class 2606 OID 9465758)
-- Name: pessoa_raca_ref_cod_deficiencia_fkey; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica_raca
    ADD CONSTRAINT pessoa_raca_ref_cod_deficiencia_fkey FOREIGN KEY (ref_cod_raca) REFERENCES cadastro.raca(cod_raca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6533 (class 2606 OID 9465763)
-- Name: pessoa_raca_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.fisica_raca
    ADD CONSTRAINT pessoa_raca_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6561 (class 2606 OID 9465768)
-- Name: religiao_idpes_cad_fkey; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.religiao
    ADD CONSTRAINT religiao_idpes_cad_fkey FOREIGN KEY (idpes_cad) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6560 (class 2606 OID 9465773)
-- Name: religiao_idpes_exc_fkey; Type: FK CONSTRAINT; Schema: cadastro; Owner: -
--

ALTER TABLE ONLY cadastro.religiao
    ADD CONSTRAINT religiao_idpes_exc_fkey FOREIGN KEY (idpes_exc) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6589 (class 2606 OID 9465778)
-- Name: fk_campo_metadado_campo_consis; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.campo_metadado
    ADD CONSTRAINT fk_campo_metadado_campo_consis FOREIGN KEY (idcam) REFERENCES consistenciacao.campo_consistenciacao(idcam);


--
-- TOC entry 6588 (class 2606 OID 9465783)
-- Name: fk_campo_metadado_metadado; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.campo_metadado
    ADD CONSTRAINT fk_campo_metadado_metadado FOREIGN KEY (idmet) REFERENCES consistenciacao.metadado(idmet);


--
-- TOC entry 6587 (class 2606 OID 9465788)
-- Name: fk_campo_metadado_regra_campo; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.campo_metadado
    ADD CONSTRAINT fk_campo_metadado_regra_campo FOREIGN KEY (idreg) REFERENCES consistenciacao.regra_campo(idreg);


--
-- TOC entry 6591 (class 2606 OID 9465793)
-- Name: fk_confrontacao_metadado; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.confrontacao
    ADD CONSTRAINT fk_confrontacao_metadado FOREIGN KEY (idmet) REFERENCES consistenciacao.metadado(idmet);


--
-- TOC entry 6590 (class 2606 OID 9465798)
-- Name: fk_confrontacao_pessoa_instituicao; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.confrontacao
    ADD CONSTRAINT fk_confrontacao_pessoa_instituicao FOREIGN KEY (idins, idpes) REFERENCES acesso.pessoa_instituicao(idins, idpes);


--
-- TOC entry 6593 (class 2606 OID 9465803)
-- Name: fk_hist_campo_campo_consist; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.historico_campo
    ADD CONSTRAINT fk_hist_campo_campo_consist FOREIGN KEY (idcam) REFERENCES consistenciacao.campo_consistenciacao(idcam) ON DELETE CASCADE;


--
-- TOC entry 6592 (class 2606 OID 9465808)
-- Name: fk_historico_campo_pessoa; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.historico_campo
    ADD CONSTRAINT fk_historico_campo_pessoa FOREIGN KEY (idpes) REFERENCES cadastro.pessoa(idpes) ON DELETE CASCADE;


--
-- TOC entry 6599 (class 2606 OID 9465813)
-- Name: fk_inc_pessoa_possivel_incoerencia; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.incoerencia_pessoa_possivel
    ADD CONSTRAINT fk_inc_pessoa_possivel_incoerencia FOREIGN KEY (idinc) REFERENCES consistenciacao.incoerencia(idinc) ON DELETE CASCADE;


--
-- TOC entry 6598 (class 2606 OID 9465818)
-- Name: fk_inc_pessoa_possivel_pessoa; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.incoerencia_pessoa_possivel
    ADD CONSTRAINT fk_inc_pessoa_possivel_pessoa FOREIGN KEY (idpes) REFERENCES cadastro.pessoa(idpes);


--
-- TOC entry 6601 (class 2606 OID 9465823)
-- Name: fk_inc_tipo_inc_incoerencia; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.incoerencia_tipo_incoerencia
    ADD CONSTRAINT fk_inc_tipo_inc_incoerencia FOREIGN KEY (idinc) REFERENCES consistenciacao.incoerencia(idinc) ON DELETE CASCADE;


--
-- TOC entry 6600 (class 2606 OID 9465828)
-- Name: fk_inc_tipo_inc_tipo_incoerencia; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.incoerencia_tipo_incoerencia
    ADD CONSTRAINT fk_inc_tipo_inc_tipo_incoerencia FOREIGN KEY (id_tipo_inc) REFERENCES consistenciacao.tipo_incoerencia(id_tipo_inc);


--
-- TOC entry 6594 (class 2606 OID 9465833)
-- Name: fk_incoerencia_confrontacao; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.incoerencia
    ADD CONSTRAINT fk_incoerencia_confrontacao FOREIGN KEY (idcon) REFERENCES consistenciacao.confrontacao(idcon);


--
-- TOC entry 6595 (class 2606 OID 9465838)
-- Name: fk_incoerencia_documento_incoerencia; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.incoerencia_documento
    ADD CONSTRAINT fk_incoerencia_documento_incoerencia FOREIGN KEY (idinc) REFERENCES consistenciacao.incoerencia(idinc) ON DELETE CASCADE;


--
-- TOC entry 6596 (class 2606 OID 9465843)
-- Name: fk_incoerencia_endereco_incoerencia; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.incoerencia_endereco
    ADD CONSTRAINT fk_incoerencia_endereco_incoerencia FOREIGN KEY (idinc) REFERENCES consistenciacao.incoerencia(idinc) ON DELETE CASCADE;


--
-- TOC entry 6597 (class 2606 OID 9465848)
-- Name: fk_incoerencia_fone_incoerencia; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.incoerencia_fone
    ADD CONSTRAINT fk_incoerencia_fone_incoerencia FOREIGN KEY (idinc) REFERENCES consistenciacao.incoerencia(idinc) ON DELETE CASCADE;


--
-- TOC entry 6602 (class 2606 OID 9465853)
-- Name: fk_metadado_fonte; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.metadado
    ADD CONSTRAINT fk_metadado_fonte FOREIGN KEY (idfon) REFERENCES consistenciacao.fonte(idfon);


--
-- TOC entry 6603 (class 2606 OID 9465858)
-- Name: fk_oco_reg_cam_regra_campo; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.ocorrencia_regra_campo
    ADD CONSTRAINT fk_oco_reg_cam_regra_campo FOREIGN KEY (idreg) REFERENCES consistenciacao.regra_campo(idreg);


--
-- TOC entry 6604 (class 2606 OID 9465863)
-- Name: fk_tipo_incoerencia_campo_consis; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: -
--

ALTER TABLE ONLY consistenciacao.tipo_incoerencia
    ADD CONSTRAINT fk_tipo_incoerencia_campo_consis FOREIGN KEY (idcam) REFERENCES consistenciacao.campo_consistenciacao(idcam);


--
-- TOC entry 6605 (class 2606 OID 9465868)
-- Name: calendario_turma_calendario_dia_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.calendario_turma
    ADD CONSTRAINT calendario_turma_calendario_dia_fk FOREIGN KEY (calendario_ano_letivo_id, mes, dia) REFERENCES pmieducar.calendario_dia(ref_cod_calendario_ano_letivo, mes, dia) MATCH FULL ON DELETE CASCADE;


--
-- TOC entry 6607 (class 2606 OID 9465873)
-- Name: componente_curricular_ano_escolar_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.componente_curricular_ano_escolar
    ADD CONSTRAINT componente_curricular_ano_escolar_fk FOREIGN KEY (componente_curricular_id) REFERENCES modules.componente_curricular(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6606 (class 2606 OID 9465878)
-- Name: componente_curricular_area_conhecimento_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.componente_curricular
    ADD CONSTRAINT componente_curricular_area_conhecimento_fk FOREIGN KEY (area_conhecimento_id, instituicao_id) REFERENCES modules.area_conhecimento(id, instituicao_id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6609 (class 2606 OID 9465883)
-- Name: componente_curricular_turma_componente_curricular_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.componente_curricular_turma
    ADD CONSTRAINT componente_curricular_turma_componente_curricular_fkey FOREIGN KEY (componente_curricular_id) REFERENCES modules.componente_curricular(id) ON DELETE RESTRICT;


--
-- TOC entry 6608 (class 2606 OID 9465888)
-- Name: componente_curricular_turma_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.componente_curricular_turma
    ADD CONSTRAINT componente_curricular_turma_fkey FOREIGN KEY (turma_id) REFERENCES pmieducar.turma(cod_turma) ON DELETE CASCADE;


--
-- TOC entry 6610 (class 2606 OID 9465893)
-- Name: docente_licenciatura_ies_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.docente_licenciatura
    ADD CONSTRAINT docente_licenciatura_ies_fk FOREIGN KEY (ies_id) REFERENCES modules.educacenso_ies(id) ON DELETE RESTRICT;


--
-- TOC entry 6611 (class 2606 OID 9465898)
-- Name: educacenso_cod_aluno_cod_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.educacenso_cod_aluno
    ADD CONSTRAINT educacenso_cod_aluno_cod_aluno_fk FOREIGN KEY (cod_aluno) REFERENCES pmieducar.aluno(cod_aluno) ON DELETE CASCADE;


--
-- TOC entry 6612 (class 2606 OID 9465903)
-- Name: educacenso_cod_escola_cod_escola_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.educacenso_cod_escola
    ADD CONSTRAINT educacenso_cod_escola_cod_escola_fk FOREIGN KEY (cod_escola) REFERENCES pmieducar.escola(cod_escola) ON DELETE CASCADE;


--
-- TOC entry 6613 (class 2606 OID 9465908)
-- Name: educacenso_cod_turma_cod_turma_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.educacenso_cod_turma
    ADD CONSTRAINT educacenso_cod_turma_cod_turma_fk FOREIGN KEY (cod_turma) REFERENCES pmieducar.turma(cod_turma) ON DELETE CASCADE;


--
-- TOC entry 6615 (class 2606 OID 9465913)
-- Name: empresa_transporte_escolar_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.empresa_transporte_escolar
    ADD CONSTRAINT empresa_transporte_escolar_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.juridica(idpes);


--
-- TOC entry 6614 (class 2606 OID 9465918)
-- Name: empresa_transporte_escolar_ref_resp_idpes_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.empresa_transporte_escolar
    ADD CONSTRAINT empresa_transporte_escolar_ref_resp_idpes_fkey FOREIGN KEY (ref_resp_idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6617 (class 2606 OID 9465923)
-- Name: etapas_curso_educacenso_curso_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.etapas_curso_educacenso
    ADD CONSTRAINT etapas_curso_educacenso_curso_fk FOREIGN KEY (curso_id) REFERENCES pmieducar.curso(cod_curso);


--
-- TOC entry 6616 (class 2606 OID 9465928)
-- Name: etapas_curso_educacenso_etapa_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.etapas_curso_educacenso
    ADD CONSTRAINT etapas_curso_educacenso_etapa_fk FOREIGN KEY (etapa_id) REFERENCES modules.etapas_educacenso(id);


--
-- TOC entry 6618 (class 2606 OID 9465933)
-- Name: falta_componente_curricular_falta_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.falta_componente_curricular
    ADD CONSTRAINT falta_componente_curricular_falta_aluno_fk FOREIGN KEY (falta_aluno_id) REFERENCES modules.falta_aluno(id) ON DELETE CASCADE;


--
-- TOC entry 6619 (class 2606 OID 9465938)
-- Name: falta_geral_falta_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.falta_geral
    ADD CONSTRAINT falta_geral_falta_aluno_fk FOREIGN KEY (falta_aluno_id) REFERENCES modules.falta_aluno(id) ON DELETE CASCADE;


--
-- TOC entry 6620 (class 2606 OID 9465943)
-- Name: ficha_medica_aluno_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.ficha_medica_aluno
    ADD CONSTRAINT ficha_medica_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES pmieducar.aluno(cod_aluno) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6637 (class 2606 OID 9465948)
-- Name: fk_ponto_cep_log_bai; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.ponto_transporte_escolar
    ADD CONSTRAINT fk_ponto_cep_log_bai FOREIGN KEY (idbai, idlog, cep) REFERENCES urbano.cep_logradouro_bairro(idbai, idlog, cep);


--
-- TOC entry 6622 (class 2606 OID 9465953)
-- Name: itinerario_transporte_escolar_ref_cod_rota_transporte_escolar_f; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.itinerario_transporte_escolar
    ADD CONSTRAINT itinerario_transporte_escolar_ref_cod_rota_transporte_escolar_f FOREIGN KEY (ref_cod_rota_transporte_escolar) REFERENCES modules.rota_transporte_escolar(cod_rota_transporte_escolar);


--
-- TOC entry 6623 (class 2606 OID 9465958)
-- Name: media_geral_nota_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.media_geral
    ADD CONSTRAINT media_geral_nota_aluno_fk FOREIGN KEY (nota_aluno_id) REFERENCES modules.nota_aluno(id) ON DELETE CASCADE;


--
-- TOC entry 6624 (class 2606 OID 9465963)
-- Name: moradia_aluno_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.moradia_aluno
    ADD CONSTRAINT moradia_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES pmieducar.aluno(cod_aluno) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6629 (class 2606 OID 9465968)
-- Name: moradia_aluno_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.nota_exame
    ADD CONSTRAINT moradia_aluno_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES pmieducar.matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6626 (class 2606 OID 9465973)
-- Name: motorista_ref_cod_empresa_transporte_escolar_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.motorista
    ADD CONSTRAINT motorista_ref_cod_empresa_transporte_escolar_fkey FOREIGN KEY (ref_cod_empresa_transporte_escolar) REFERENCES modules.empresa_transporte_escolar(cod_empresa_transporte_escolar) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6625 (class 2606 OID 9465978)
-- Name: motorista_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.motorista
    ADD CONSTRAINT motorista_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6628 (class 2606 OID 9465983)
-- Name: nota_componente_curricular_media_nota_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.nota_componente_curricular_media
    ADD CONSTRAINT nota_componente_curricular_media_nota_aluno_fk FOREIGN KEY (nota_aluno_id) REFERENCES modules.nota_aluno(id) ON DELETE CASCADE;


--
-- TOC entry 6627 (class 2606 OID 9465988)
-- Name: nota_componente_curricular_nota_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.nota_componente_curricular
    ADD CONSTRAINT nota_componente_curricular_nota_aluno_fk FOREIGN KEY (nota_aluno_id) REFERENCES modules.nota_aluno(id) ON DELETE CASCADE;


--
-- TOC entry 6630 (class 2606 OID 9465993)
-- Name: nota_nota_geral_nota_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.nota_geral
    ADD CONSTRAINT nota_nota_geral_nota_aluno_fk FOREIGN KEY (nota_aluno_id) REFERENCES modules.nota_aluno(id) ON DELETE CASCADE;


--
-- TOC entry 6631 (class 2606 OID 9465998)
-- Name: parecer_componente_curricular_parecer_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.parecer_componente_curricular
    ADD CONSTRAINT parecer_componente_curricular_parecer_aluno_fk FOREIGN KEY (parecer_aluno_id) REFERENCES modules.parecer_aluno(id) ON DELETE CASCADE;


--
-- TOC entry 6632 (class 2606 OID 9466003)
-- Name: parecer_geral_parecer_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.parecer_geral
    ADD CONSTRAINT parecer_geral_parecer_aluno_fk FOREIGN KEY (parecer_aluno_id) REFERENCES modules.parecer_aluno(id) ON DELETE CASCADE;


--
-- TOC entry 6636 (class 2606 OID 9466008)
-- Name: pessoa_transporte_ref_cod_ponto_transporte_escolar_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.pessoa_transporte
    ADD CONSTRAINT pessoa_transporte_ref_cod_ponto_transporte_escolar_fkey FOREIGN KEY (ref_cod_ponto_transporte_escolar) REFERENCES modules.ponto_transporte_escolar(cod_ponto_transporte_escolar);


--
-- TOC entry 6635 (class 2606 OID 9466013)
-- Name: pessoa_transporte_ref_cod_rota_transporte_escolar_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.pessoa_transporte
    ADD CONSTRAINT pessoa_transporte_ref_cod_rota_transporte_escolar_fkey FOREIGN KEY (ref_cod_rota_transporte_escolar) REFERENCES modules.rota_transporte_escolar(cod_rota_transporte_escolar);


--
-- TOC entry 6634 (class 2606 OID 9466018)
-- Name: pessoa_transporte_ref_idpes_destino_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.pessoa_transporte
    ADD CONSTRAINT pessoa_transporte_ref_idpes_destino_fkey FOREIGN KEY (ref_idpes_destino) REFERENCES cadastro.juridica(idpes);


--
-- TOC entry 6633 (class 2606 OID 9466023)
-- Name: pessoa_transporte_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.pessoa_transporte
    ADD CONSTRAINT pessoa_transporte_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6621 (class 2606 OID 9466028)
-- Name: ponto_transporte_escolar_ref_cod_veiculo_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.itinerario_transporte_escolar
    ADD CONSTRAINT ponto_transporte_escolar_ref_cod_veiculo_fkey FOREIGN KEY (ref_cod_veiculo) REFERENCES modules.veiculo(cod_veiculo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6642 (class 2606 OID 9466033)
-- Name: professor_turma_disciplina_componente_curricular_id_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.professor_turma_disciplina
    ADD CONSTRAINT professor_turma_disciplina_componente_curricular_id_fk FOREIGN KEY (componente_curricular_id) REFERENCES modules.componente_curricular(id) MATCH FULL ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6641 (class 2606 OID 9466038)
-- Name: professor_turma_disciplina_professor_turma_id_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.professor_turma_disciplina
    ADD CONSTRAINT professor_turma_disciplina_professor_turma_id_fk FOREIGN KEY (professor_turma_id) REFERENCES modules.professor_turma(id) MATCH FULL ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6640 (class 2606 OID 9466043)
-- Name: professor_turma_servidor_id_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.professor_turma
    ADD CONSTRAINT professor_turma_servidor_id_fk FOREIGN KEY (servidor_id, instituicao_id) REFERENCES pmieducar.servidor(cod_servidor, ref_cod_instituicao) MATCH FULL ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6639 (class 2606 OID 9466048)
-- Name: professor_turma_turma_id_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.professor_turma
    ADD CONSTRAINT professor_turma_turma_id_fk FOREIGN KEY (turma_id) REFERENCES pmieducar.turma(cod_turma) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6638 (class 2606 OID 9474700)
-- Name: professor_turma_turma_turno_id_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.professor_turma
    ADD CONSTRAINT professor_turma_turma_turno_id_fk FOREIGN KEY (turno_id) REFERENCES pmieducar.turma_turno(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7206 (class 2606 OID 9469025)
-- Name: ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.config_movimento_geral
    ADD CONSTRAINT ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie) REFERENCES pmieducar.serie(cod_serie);


--
-- TOC entry 6646 (class 2606 OID 9466053)
-- Name: regra_avaliacao_formula_media_formula_media_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.regra_avaliacao
    ADD CONSTRAINT regra_avaliacao_formula_media_formula_media_fk FOREIGN KEY (formula_media_id, instituicao_id) REFERENCES modules.formula_media(id, instituicao_id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6645 (class 2606 OID 9466058)
-- Name: regra_avaliacao_formula_media_formula_recuperacao_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.regra_avaliacao
    ADD CONSTRAINT regra_avaliacao_formula_media_formula_recuperacao_fk FOREIGN KEY (formula_recuperacao_id, instituicao_id) REFERENCES modules.formula_media(id, instituicao_id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6647 (class 2606 OID 9466063)
-- Name: regra_avaliacao_regra_avaliacao_recuperacao_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.regra_avaliacao_recuperacao
    ADD CONSTRAINT regra_avaliacao_regra_avaliacao_recuperacao_fk FOREIGN KEY (regra_avaliacao_id) REFERENCES modules.regra_avaliacao(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7208 (class 2606 OID 9474585)
-- Name: regra_avaliacao_serie_ano_fk_regra_avaliacao_diferenciada_id; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.regra_avaliacao_serie_ano
    ADD CONSTRAINT regra_avaliacao_serie_ano_fk_regra_avaliacao_diferenciada_id FOREIGN KEY (regra_avaliacao_diferenciada_id) REFERENCES modules.regra_avaliacao(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7209 (class 2606 OID 9474580)
-- Name: regra_avaliacao_serie_ano_fk_regra_avaliacao_id; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.regra_avaliacao_serie_ano
    ADD CONSTRAINT regra_avaliacao_serie_ano_fk_regra_avaliacao_id FOREIGN KEY (regra_avaliacao_id) REFERENCES modules.regra_avaliacao(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7210 (class 2606 OID 9474575)
-- Name: regra_avaliacao_serie_ano_fk_serie_id; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.regra_avaliacao_serie_ano
    ADD CONSTRAINT regra_avaliacao_serie_ano_fk_serie_id FOREIGN KEY (serie_id) REFERENCES pmieducar.serie(cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6644 (class 2606 OID 9466068)
-- Name: regra_avaliacao_tabela_arredondamento_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.regra_avaliacao
    ADD CONSTRAINT regra_avaliacao_tabela_arredondamento_fk FOREIGN KEY (tabela_arredondamento_id, instituicao_id) REFERENCES modules.tabela_arredondamento(id, instituicao_id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6643 (class 2606 OID 9469012)
-- Name: regra_diferenciada_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.regra_avaliacao
    ADD CONSTRAINT regra_diferenciada_fk FOREIGN KEY (regra_diferenciada_id) REFERENCES modules.regra_avaliacao(id);


--
-- TOC entry 6649 (class 2606 OID 9466073)
-- Name: rota_transporte_escolar_ref_cod_empresa_transporte_escolar_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.rota_transporte_escolar
    ADD CONSTRAINT rota_transporte_escolar_ref_cod_empresa_transporte_escolar_fkey FOREIGN KEY (ref_cod_empresa_transporte_escolar) REFERENCES modules.empresa_transporte_escolar(cod_empresa_transporte_escolar) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6648 (class 2606 OID 9466078)
-- Name: rota_transporte_escolar_ref_idpes_destino_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.rota_transporte_escolar
    ADD CONSTRAINT rota_transporte_escolar_ref_idpes_destino_fkey FOREIGN KEY (ref_idpes_destino) REFERENCES cadastro.juridica(idpes);


--
-- TOC entry 6650 (class 2606 OID 9466083)
-- Name: tabela_arredondamento_tabela_arredondamento_valor_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.tabela_arredondamento_valor
    ADD CONSTRAINT tabela_arredondamento_tabela_arredondamento_valor_fk FOREIGN KEY (tabela_arredondamento_id) REFERENCES modules.tabela_arredondamento(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6651 (class 2606 OID 9466088)
-- Name: transporte_aluno_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.transporte_aluno
    ADD CONSTRAINT transporte_aluno_aluno_fk FOREIGN KEY (aluno_id) REFERENCES pmieducar.aluno(cod_aluno) ON DELETE CASCADE;


--
-- TOC entry 6652 (class 2606 OID 9466093)
-- Name: uniforme_aluno_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.uniforme_aluno
    ADD CONSTRAINT uniforme_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES pmieducar.aluno(cod_aluno) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6654 (class 2606 OID 9466098)
-- Name: veiculo_ref_cod_empresa_transporte_escolar_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.veiculo
    ADD CONSTRAINT veiculo_ref_cod_empresa_transporte_escolar_fkey FOREIGN KEY (ref_cod_empresa_transporte_escolar) REFERENCES modules.empresa_transporte_escolar(cod_empresa_transporte_escolar);


--
-- TOC entry 6653 (class 2606 OID 9466103)
-- Name: veiculo_ref_cod_tipo_veiculo_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: -
--

ALTER TABLE ONLY modules.veiculo
    ADD CONSTRAINT veiculo_ref_cod_tipo_veiculo_fkey FOREIGN KEY (ref_cod_tipo_veiculo) REFERENCES modules.tipo_veiculo(cod_tipo_veiculo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6658 (class 2606 OID 9466108)
-- Name: acao_governo_arquivo_ref_cod_acao_governo_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_arquivo
    ADD CONSTRAINT acao_governo_arquivo_ref_cod_acao_governo_fkey FOREIGN KEY (ref_cod_acao_governo) REFERENCES pmiacoes.acao_governo(cod_acao_governo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6657 (class 2606 OID 9466113)
-- Name: acao_governo_arquivo_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_arquivo
    ADD CONSTRAINT acao_governo_arquivo_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6660 (class 2606 OID 9466118)
-- Name: acao_governo_categoria_ref_cod_acao_governo_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_categoria
    ADD CONSTRAINT acao_governo_categoria_ref_cod_acao_governo_fkey FOREIGN KEY (ref_cod_acao_governo) REFERENCES pmiacoes.acao_governo(cod_acao_governo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6659 (class 2606 OID 9466123)
-- Name: acao_governo_categoria_ref_cod_categoria_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_categoria
    ADD CONSTRAINT acao_governo_categoria_ref_cod_categoria_fkey FOREIGN KEY (ref_cod_categoria) REFERENCES pmiacoes.categoria(cod_categoria) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6665 (class 2606 OID 9466128)
-- Name: acao_governo_foto_portal_ref_cod_acao_governo_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_foto_portal
    ADD CONSTRAINT acao_governo_foto_portal_ref_cod_acao_governo_fkey FOREIGN KEY (ref_cod_acao_governo) REFERENCES pmiacoes.acao_governo(cod_acao_governo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6664 (class 2606 OID 9466133)
-- Name: acao_governo_foto_portal_ref_cod_foto_portal_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_foto_portal
    ADD CONSTRAINT acao_governo_foto_portal_ref_cod_foto_portal_fkey FOREIGN KEY (ref_cod_foto_portal) REFERENCES portal.foto_portal(cod_foto_portal) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6663 (class 2606 OID 9466138)
-- Name: acao_governo_foto_portal_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_foto_portal
    ADD CONSTRAINT acao_governo_foto_portal_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6662 (class 2606 OID 9466143)
-- Name: acao_governo_foto_ref_cod_acao_governo_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_foto
    ADD CONSTRAINT acao_governo_foto_ref_cod_acao_governo_fkey FOREIGN KEY (ref_cod_acao_governo) REFERENCES pmiacoes.acao_governo(cod_acao_governo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6661 (class 2606 OID 9466148)
-- Name: acao_governo_foto_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_foto
    ADD CONSTRAINT acao_governo_foto_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6668 (class 2606 OID 9466153)
-- Name: acao_governo_noticia_ref_cod_acao_governo_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_noticia
    ADD CONSTRAINT acao_governo_noticia_ref_cod_acao_governo_fkey FOREIGN KEY (ref_cod_acao_governo) REFERENCES pmiacoes.acao_governo(cod_acao_governo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6667 (class 2606 OID 9466158)
-- Name: acao_governo_noticia_ref_cod_not_portal_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_noticia
    ADD CONSTRAINT acao_governo_noticia_ref_cod_not_portal_fkey FOREIGN KEY (ref_cod_not_portal) REFERENCES portal.not_portal(cod_not_portal) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6666 (class 2606 OID 9466163)
-- Name: acao_governo_noticia_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_noticia
    ADD CONSTRAINT acao_governo_noticia_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6656 (class 2606 OID 9466168)
-- Name: acao_governo_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo
    ADD CONSTRAINT acao_governo_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6655 (class 2606 OID 9466173)
-- Name: acao_governo_ref_funcionario_exc_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo
    ADD CONSTRAINT acao_governo_ref_funcionario_exc_fkey FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6671 (class 2606 OID 9466178)
-- Name: acao_governo_setor_ref_cod_acao_governo_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_setor
    ADD CONSTRAINT acao_governo_setor_ref_cod_acao_governo_fkey FOREIGN KEY (ref_cod_acao_governo) REFERENCES pmiacoes.acao_governo(cod_acao_governo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6670 (class 2606 OID 9466183)
-- Name: acao_governo_setor_ref_cod_setor_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_setor
    ADD CONSTRAINT acao_governo_setor_ref_cod_setor_fkey FOREIGN KEY (ref_cod_setor) REFERENCES pmidrh.setor(cod_setor) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6669 (class 2606 OID 9466188)
-- Name: acao_governo_setor_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.acao_governo_setor
    ADD CONSTRAINT acao_governo_setor_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6673 (class 2606 OID 9466193)
-- Name: categoria_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.categoria
    ADD CONSTRAINT categoria_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6672 (class 2606 OID 9466198)
-- Name: categoria_ref_funcionario_exc_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.categoria
    ADD CONSTRAINT categoria_ref_funcionario_exc_fkey FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6675 (class 2606 OID 9466203)
-- Name: secretaria_responsavel_ref_cod_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.secretaria_responsavel
    ADD CONSTRAINT secretaria_responsavel_ref_cod_funcionario_cad_fkey FOREIGN KEY (ref_cod_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6674 (class 2606 OID 9466208)
-- Name: secretaria_responsavel_ref_cod_setor_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: -
--

ALTER TABLE ONLY pmiacoes.secretaria_responsavel
    ADD CONSTRAINT secretaria_responsavel_ref_cod_setor_fkey FOREIGN KEY (ref_cod_setor) REFERENCES pmidrh.setor(cod_setor) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6678 (class 2606 OID 9466213)
-- Name: acontecimento_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.acontecimento
    ADD CONSTRAINT acontecimento_ref_funcionario_cad_fk FOREIGN KEY (ref_cod_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6702 (class 2606 OID 9466218)
-- Name: acontecimento_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.tipo_acontecimento
    ADD CONSTRAINT acontecimento_ref_funcionario_cad_fk FOREIGN KEY (ref_cod_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6677 (class 2606 OID 9466223)
-- Name: acontecimento_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.acontecimento
    ADD CONSTRAINT acontecimento_ref_funcionario_exc_fk FOREIGN KEY (ref_cod_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6701 (class 2606 OID 9466228)
-- Name: acontecimento_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.tipo_acontecimento
    ADD CONSTRAINT acontecimento_ref_funcionario_exc_fk FOREIGN KEY (ref_cod_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6687 (class 2606 OID 9466233)
-- Name: fk_to_imagem_ico; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.menu
    ADD CONSTRAINT fk_to_imagem_ico FOREIGN KEY (ref_cod_ico) REFERENCES portal.imagem(cod_imagem) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6686 (class 2606 OID 9466238)
-- Name: fk_to_tutor; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.menu
    ADD CONSTRAINT fk_to_tutor FOREIGN KEY (ref_cod_tutormenu) REFERENCES pmicontrolesis.tutormenu(cod_tutormenu);


--
-- TOC entry 6679 (class 2606 OID 9466243)
-- Name: foto_evento_ibfk_1; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.foto_evento
    ADD CONSTRAINT foto_evento_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6681 (class 2606 OID 9466248)
-- Name: foto_vinc_ref_cod_acontecimento_fkey; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.foto_vinc
    ADD CONSTRAINT foto_vinc_ref_cod_acontecimento_fkey FOREIGN KEY (ref_cod_acontecimento) REFERENCES pmicontrolesis.acontecimento(cod_acontecimento);


--
-- TOC entry 6680 (class 2606 OID 9466253)
-- Name: foto_vinc_ref_cod_foto_evento_fkey; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.foto_vinc
    ADD CONSTRAINT foto_vinc_ref_cod_foto_evento_fkey FOREIGN KEY (ref_cod_foto_evento) REFERENCES pmicontrolesis.foto_evento(cod_foto_evento);


--
-- TOC entry 6683 (class 2606 OID 9466258)
-- Name: itinerario_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.itinerario
    ADD CONSTRAINT itinerario_ref_funcionario_cad_fk FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6682 (class 2606 OID 9466263)
-- Name: itinerario_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.itinerario
    ADD CONSTRAINT itinerario_ref_funcionario_exc_fk FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6689 (class 2606 OID 9466268)
-- Name: menu_portal_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.menu_portal
    ADD CONSTRAINT menu_portal_ref_funcionario_cad_fk FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6688 (class 2606 OID 9466273)
-- Name: menu_portal_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.menu_portal
    ADD CONSTRAINT menu_portal_ref_funcionario_exc_fk FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6685 (class 2606 OID 9466278)
-- Name: menu_ref_cod_menu_pai_fkey; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.menu
    ADD CONSTRAINT menu_ref_cod_menu_pai_fkey FOREIGN KEY (ref_cod_menu_pai) REFERENCES pmicontrolesis.menu(cod_menu) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6684 (class 2606 OID 9466283)
-- Name: menu_ref_cod_menu_submenu_fkey; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.menu
    ADD CONSTRAINT menu_ref_cod_menu_submenu_fkey FOREIGN KEY (ref_cod_menu_submenu) REFERENCES portal.menu_submenu(cod_menu_submenu) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6691 (class 2606 OID 9466288)
-- Name: portais_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.portais
    ADD CONSTRAINT portais_ref_funcionario_cad_fk FOREIGN KEY (ref_cod_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6690 (class 2606 OID 9466293)
-- Name: portais_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.portais
    ADD CONSTRAINT portais_ref_funcionario_exc_fk FOREIGN KEY (ref_cod_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6693 (class 2606 OID 9466298)
-- Name: servicos_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.servicos
    ADD CONSTRAINT servicos_ref_funcionario_cad_fk FOREIGN KEY (ref_cod_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6692 (class 2606 OID 9466303)
-- Name: servicos_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.servicos
    ADD CONSTRAINT servicos_ref_funcionario_exc_fk FOREIGN KEY (ref_cod_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6695 (class 2606 OID 9466308)
-- Name: sistema_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.sistema
    ADD CONSTRAINT sistema_ref_funcionario_cad_fk FOREIGN KEY (ref_cod_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6694 (class 2606 OID 9466313)
-- Name: sistema_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.sistema
    ADD CONSTRAINT sistema_ref_funcionario_exc_fk FOREIGN KEY (ref_cod_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6698 (class 2606 OID 9466318)
-- Name: submenu_portal_ref_cod_menu_portal_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.submenu_portal
    ADD CONSTRAINT submenu_portal_ref_cod_menu_portal_fk FOREIGN KEY (ref_cod_menu_portal) REFERENCES pmicontrolesis.menu_portal(cod_menu_portal);


--
-- TOC entry 6697 (class 2606 OID 9466323)
-- Name: submenu_portal_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.submenu_portal
    ADD CONSTRAINT submenu_portal_ref_funcionario_cad_fk FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6705 (class 2606 OID 9466328)
-- Name: submenu_portal_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.topo_portal
    ADD CONSTRAINT submenu_portal_ref_funcionario_cad_fk FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6696 (class 2606 OID 9466333)
-- Name: submenu_portal_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.submenu_portal
    ADD CONSTRAINT submenu_portal_ref_funcionario_exc_fk FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6704 (class 2606 OID 9466338)
-- Name: submenu_portal_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.topo_portal
    ADD CONSTRAINT submenu_portal_ref_funcionario_exc_fk FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6700 (class 2606 OID 9466343)
-- Name: telefones_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.telefones
    ADD CONSTRAINT telefones_ref_funcionario_cad_fk FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6699 (class 2606 OID 9466348)
-- Name: telefones_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.telefones
    ADD CONSTRAINT telefones_ref_funcionario_exc_fk FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- TOC entry 6676 (class 2606 OID 9466353)
-- Name: tipo_acontecimento_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.acontecimento
    ADD CONSTRAINT tipo_acontecimento_ref_funcionario_cad_fk FOREIGN KEY (ref_cod_tipo_acontecimento) REFERENCES pmicontrolesis.tipo_acontecimento(cod_tipo_acontecimento);


--
-- TOC entry 6703 (class 2606 OID 9466358)
-- Name: topo_portal_ref_cod_menu_portal_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: -
--

ALTER TABLE ONLY pmicontrolesis.topo_portal
    ADD CONSTRAINT topo_portal_ref_cod_menu_portal_fk FOREIGN KEY (ref_cod_menu_portal) REFERENCES pmicontrolesis.menu_portal(cod_menu_portal);


--
-- TOC entry 6709 (class 2606 OID 9466363)
-- Name: diaria_ref_cod_diaria_grupo_fkey; Type: FK CONSTRAINT; Schema: pmidrh; Owner: -
--

ALTER TABLE ONLY pmidrh.diaria
    ADD CONSTRAINT diaria_ref_cod_diaria_grupo_fkey FOREIGN KEY (ref_cod_diaria_grupo) REFERENCES pmidrh.diaria_grupo(cod_diaria_grupo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6708 (class 2606 OID 9466368)
-- Name: diaria_ref_cod_setor; Type: FK CONSTRAINT; Schema: pmidrh; Owner: -
--

ALTER TABLE ONLY pmidrh.diaria
    ADD CONSTRAINT diaria_ref_cod_setor FOREIGN KEY (ref_cod_setor) REFERENCES pmidrh.setor(cod_setor);


--
-- TOC entry 6707 (class 2606 OID 9466373)
-- Name: diaria_ref_funcionario_cadastro_fkey; Type: FK CONSTRAINT; Schema: pmidrh; Owner: -
--

ALTER TABLE ONLY pmidrh.diaria
    ADD CONSTRAINT diaria_ref_funcionario_cadastro_fkey FOREIGN KEY (ref_funcionario_cadastro) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6706 (class 2606 OID 9466378)
-- Name: diaria_ref_funcionario_fkey; Type: FK CONSTRAINT; Schema: pmidrh; Owner: -
--

ALTER TABLE ONLY pmidrh.diaria
    ADD CONSTRAINT diaria_ref_funcionario_fkey FOREIGN KEY (ref_funcionario) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6711 (class 2606 OID 9466383)
-- Name: diaria_valores_ref_cod_diaria_grupo_fkey; Type: FK CONSTRAINT; Schema: pmidrh; Owner: -
--

ALTER TABLE ONLY pmidrh.diaria_valores
    ADD CONSTRAINT diaria_valores_ref_cod_diaria_grupo_fkey FOREIGN KEY (ref_cod_diaria_grupo) REFERENCES pmidrh.diaria_grupo(cod_diaria_grupo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6710 (class 2606 OID 9466388)
-- Name: diaria_valores_ref_funcionario_cadastro_fkey; Type: FK CONSTRAINT; Schema: pmidrh; Owner: -
--

ALTER TABLE ONLY pmidrh.diaria_valores
    ADD CONSTRAINT diaria_valores_ref_funcionario_cadastro_fkey FOREIGN KEY (ref_funcionario_cadastro) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6715 (class 2606 OID 9466393)
-- Name: fk_setor_pai; Type: FK CONSTRAINT; Schema: pmidrh; Owner: -
--

ALTER TABLE ONLY pmidrh.setor
    ADD CONSTRAINT fk_setor_pai FOREIGN KEY (ref_cod_setor) REFERENCES pmidrh.setor(cod_setor) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6714 (class 2606 OID 9466398)
-- Name: fk_to_idpes_resp; Type: FK CONSTRAINT; Schema: pmidrh; Owner: -
--

ALTER TABLE ONLY pmidrh.setor
    ADD CONSTRAINT fk_to_idpes_resp FOREIGN KEY (ref_idpes_resp) REFERENCES cadastro.fisica(idpes);


--
-- TOC entry 6713 (class 2606 OID 9466403)
-- Name: setor_ref_cod_pessoa_cad_fkey; Type: FK CONSTRAINT; Schema: pmidrh; Owner: -
--

ALTER TABLE ONLY pmidrh.setor
    ADD CONSTRAINT setor_ref_cod_pessoa_cad_fkey FOREIGN KEY (ref_cod_pessoa_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6712 (class 2606 OID 9466408)
-- Name: setor_ref_cod_pessoa_exc_fkey; Type: FK CONSTRAINT; Schema: pmidrh; Owner: -
--

ALTER TABLE ONLY pmidrh.setor
    ADD CONSTRAINT setor_ref_cod_pessoa_exc_fkey FOREIGN KEY (ref_cod_pessoa_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6728 (class 2606 OID 9466413)
-- Name: acervo_acervo_assunto_ref_cod_acervo_assunto_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_acervo_assunto
    ADD CONSTRAINT acervo_acervo_assunto_ref_cod_acervo_assunto_fkey FOREIGN KEY (ref_cod_acervo_assunto) REFERENCES pmieducar.acervo_assunto(cod_acervo_assunto) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6727 (class 2606 OID 9466418)
-- Name: acervo_acervo_assunto_ref_cod_acervo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_acervo_assunto
    ADD CONSTRAINT acervo_acervo_assunto_ref_cod_acervo_fkey FOREIGN KEY (ref_cod_acervo) REFERENCES pmieducar.acervo(cod_acervo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6730 (class 2606 OID 9466423)
-- Name: acervo_acervo_autor_ref_cod_acervo_autor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_acervo_autor
    ADD CONSTRAINT acervo_acervo_autor_ref_cod_acervo_autor_fkey FOREIGN KEY (ref_cod_acervo_autor) REFERENCES pmieducar.acervo_autor(cod_acervo_autor) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6729 (class 2606 OID 9466428)
-- Name: acervo_acervo_autor_ref_cod_acervo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_acervo_autor
    ADD CONSTRAINT acervo_acervo_autor_ref_cod_acervo_fkey FOREIGN KEY (ref_cod_acervo) REFERENCES pmieducar.acervo(cod_acervo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6733 (class 2606 OID 9466433)
-- Name: acervo_assunto_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_assunto
    ADD CONSTRAINT acervo_assunto_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6732 (class 2606 OID 9466438)
-- Name: acervo_assunto_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_assunto
    ADD CONSTRAINT acervo_assunto_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6731 (class 2606 OID 9466443)
-- Name: acervo_assunto_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_assunto
    ADD CONSTRAINT acervo_assunto_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6736 (class 2606 OID 9466448)
-- Name: acervo_autor_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_autor
    ADD CONSTRAINT acervo_autor_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6735 (class 2606 OID 9466453)
-- Name: acervo_autor_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_autor
    ADD CONSTRAINT acervo_autor_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6739 (class 2606 OID 9466458)
-- Name: acervo_colecao_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_colecao
    ADD CONSTRAINT acervo_colecao_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6738 (class 2606 OID 9466463)
-- Name: acervo_colecao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_colecao
    ADD CONSTRAINT acervo_colecao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6737 (class 2606 OID 9466468)
-- Name: acervo_colecao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_colecao
    ADD CONSTRAINT acervo_colecao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6744 (class 2606 OID 9466473)
-- Name: acervo_editora_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_editora
    ADD CONSTRAINT acervo_editora_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6743 (class 2606 OID 9466478)
-- Name: acervo_editora_ref_idtlog_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_editora
    ADD CONSTRAINT acervo_editora_ref_idtlog_fkey FOREIGN KEY (ref_idtlog) REFERENCES urbano.tipo_logradouro(idtlog) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6742 (class 2606 OID 9466483)
-- Name: acervo_editora_ref_sigla_uf_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_editora
    ADD CONSTRAINT acervo_editora_ref_sigla_uf_fkey FOREIGN KEY (ref_sigla_uf) REFERENCES public.uf(sigla_uf) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6741 (class 2606 OID 9466488)
-- Name: acervo_editora_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_editora
    ADD CONSTRAINT acervo_editora_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6740 (class 2606 OID 9466493)
-- Name: acervo_editora_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_editora
    ADD CONSTRAINT acervo_editora_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6747 (class 2606 OID 9466498)
-- Name: acervo_idioma_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_idioma
    ADD CONSTRAINT acervo_idioma_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6746 (class 2606 OID 9466503)
-- Name: acervo_idioma_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_idioma
    ADD CONSTRAINT acervo_idioma_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6745 (class 2606 OID 9466508)
-- Name: acervo_idioma_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_idioma
    ADD CONSTRAINT acervo_idioma_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6726 (class 2606 OID 9466513)
-- Name: acervo_ref_cod_acervo_colecao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo
    ADD CONSTRAINT acervo_ref_cod_acervo_colecao_fkey FOREIGN KEY (ref_cod_acervo_colecao) REFERENCES pmieducar.acervo_colecao(cod_acervo_colecao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6725 (class 2606 OID 9466518)
-- Name: acervo_ref_cod_acervo_editora_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo
    ADD CONSTRAINT acervo_ref_cod_acervo_editora_fkey FOREIGN KEY (ref_cod_acervo_editora) REFERENCES pmieducar.acervo_editora(cod_acervo_editora) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6724 (class 2606 OID 9466523)
-- Name: acervo_ref_cod_acervo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo
    ADD CONSTRAINT acervo_ref_cod_acervo_fkey FOREIGN KEY (ref_cod_acervo) REFERENCES pmieducar.acervo(cod_acervo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6723 (class 2606 OID 9466528)
-- Name: acervo_ref_cod_acervo_idioma_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo
    ADD CONSTRAINT acervo_ref_cod_acervo_idioma_fkey FOREIGN KEY (ref_cod_acervo_idioma) REFERENCES pmieducar.acervo_idioma(cod_acervo_idioma) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6722 (class 2606 OID 9466533)
-- Name: acervo_ref_cod_biblioteca; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo
    ADD CONSTRAINT acervo_ref_cod_biblioteca FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6734 (class 2606 OID 9466538)
-- Name: acervo_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo_autor
    ADD CONSTRAINT acervo_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6721 (class 2606 OID 9466543)
-- Name: acervo_ref_cod_exemplar_tipo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo
    ADD CONSTRAINT acervo_ref_cod_exemplar_tipo_fkey FOREIGN KEY (ref_cod_exemplar_tipo) REFERENCES pmieducar.exemplar_tipo(cod_exemplar_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6720 (class 2606 OID 9466548)
-- Name: acervo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo
    ADD CONSTRAINT acervo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6719 (class 2606 OID 9466553)
-- Name: acervo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.acervo
    ADD CONSTRAINT acervo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6752 (class 2606 OID 9466558)
-- Name: aluno_aluno_beneficio_aluno_beneficio_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.aluno_aluno_beneficio
    ADD CONSTRAINT aluno_aluno_beneficio_aluno_beneficio_fk FOREIGN KEY (aluno_beneficio_id) REFERENCES pmieducar.aluno_beneficio(cod_aluno_beneficio);


--
-- TOC entry 6751 (class 2606 OID 9466563)
-- Name: aluno_aluno_beneficio_aluno_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.aluno_aluno_beneficio
    ADD CONSTRAINT aluno_aluno_beneficio_aluno_fk FOREIGN KEY (aluno_id) REFERENCES pmieducar.aluno(cod_aluno);


--
-- TOC entry 6754 (class 2606 OID 9466568)
-- Name: aluno_beneficio_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.aluno_beneficio
    ADD CONSTRAINT aluno_beneficio_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6753 (class 2606 OID 9466573)
-- Name: aluno_beneficio_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.aluno_beneficio
    ADD CONSTRAINT aluno_beneficio_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6755 (class 2606 OID 9466578)
-- Name: aluno_historico_altura_peso_ref_cod_aluno_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.aluno_historico_altura_peso
    ADD CONSTRAINT aluno_historico_altura_peso_ref_cod_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES pmieducar.aluno(cod_aluno);


--
-- TOC entry 6750 (class 2606 OID 9466583)
-- Name: aluno_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.aluno
    ADD CONSTRAINT aluno_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6749 (class 2606 OID 9466588)
-- Name: aluno_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.aluno
    ADD CONSTRAINT aluno_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6748 (class 2606 OID 9466593)
-- Name: aluno_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.aluno
    ADD CONSTRAINT aluno_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6757 (class 2606 OID 9466598)
-- Name: ano_letivo_modulo_ref_cod_modulo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.ano_letivo_modulo
    ADD CONSTRAINT ano_letivo_modulo_ref_cod_modulo_fkey FOREIGN KEY (ref_cod_modulo) REFERENCES pmieducar.modulo(cod_modulo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6756 (class 2606 OID 9466603)
-- Name: ano_letivo_modulo_ref_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.ano_letivo_modulo
    ADD CONSTRAINT ano_letivo_modulo_ref_ref_cod_escola_fkey FOREIGN KEY (ref_ref_cod_escola, ref_ano) REFERENCES pmieducar.escola_ano_letivo(ref_cod_escola, ano) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6759 (class 2606 OID 9466608)
-- Name: auditoria_falta_componente_di_ref_cod_componente_curricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.auditoria_falta_componente_dispensa
    ADD CONSTRAINT auditoria_falta_componente_di_ref_cod_componente_curricula_fkey FOREIGN KEY (ref_cod_componente_curricular) REFERENCES modules.componente_curricular(id);


--
-- TOC entry 6758 (class 2606 OID 9466613)
-- Name: auditoria_falta_componente_dispensa_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.auditoria_falta_componente_dispensa
    ADD CONSTRAINT auditoria_falta_componente_dispensa_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES pmieducar.matricula(cod_matricula);


--
-- TOC entry 6761 (class 2606 OID 9466618)
-- Name: auditoria_nota_dispensa_ref_cod_componente_curricular_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.auditoria_nota_dispensa
    ADD CONSTRAINT auditoria_nota_dispensa_ref_cod_componente_curricular_fkey FOREIGN KEY (ref_cod_componente_curricular) REFERENCES modules.componente_curricular(id);


--
-- TOC entry 6760 (class 2606 OID 9466623)
-- Name: auditoria_nota_dispensa_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.auditoria_nota_dispensa
    ADD CONSTRAINT auditoria_nota_dispensa_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES pmieducar.matricula(cod_matricula);


--
-- TOC entry 6764 (class 2606 OID 9466628)
-- Name: avaliacao_desempenho_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.avaliacao_desempenho
    ADD CONSTRAINT avaliacao_desempenho_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES pmieducar.servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6763 (class 2606 OID 9466633)
-- Name: avaliacao_desempenho_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.avaliacao_desempenho
    ADD CONSTRAINT avaliacao_desempenho_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6762 (class 2606 OID 9466638)
-- Name: avaliacao_desempenho_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.avaliacao_desempenho
    ADD CONSTRAINT avaliacao_desempenho_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6767 (class 2606 OID 9466643)
-- Name: biblioteca_dia_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.biblioteca_dia
    ADD CONSTRAINT biblioteca_dia_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6768 (class 2606 OID 9466648)
-- Name: biblioteca_feriados_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.biblioteca_feriados
    ADD CONSTRAINT biblioteca_feriados_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6766 (class 2606 OID 9466653)
-- Name: biblioteca_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.biblioteca
    ADD CONSTRAINT biblioteca_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6765 (class 2606 OID 9466658)
-- Name: biblioteca_ref_cod_instituicao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.biblioteca
    ADD CONSTRAINT biblioteca_ref_cod_instituicao_fkey FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6769 (class 2606 OID 9466663)
-- Name: biblioteca_usuario_ref_cod_biblioteca_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.biblioteca_usuario
    ADD CONSTRAINT biblioteca_usuario_ref_cod_biblioteca_fk FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6771 (class 2606 OID 9466668)
-- Name: bloqueio_lancamento_faltas_notas_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.bloqueio_lancamento_faltas_notas
    ADD CONSTRAINT bloqueio_lancamento_faltas_notas_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6774 (class 2606 OID 9466673)
-- Name: calendario_ano_letivo_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_ano_letivo
    ADD CONSTRAINT calendario_ano_letivo_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6773 (class 2606 OID 9466678)
-- Name: calendario_ano_letivo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_ano_letivo
    ADD CONSTRAINT calendario_ano_letivo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6772 (class 2606 OID 9466683)
-- Name: calendario_ano_letivo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_ano_letivo
    ADD CONSTRAINT calendario_ano_letivo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6776 (class 2606 OID 9466688)
-- Name: calendario_anotacao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_anotacao
    ADD CONSTRAINT calendario_anotacao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6775 (class 2606 OID 9466693)
-- Name: calendario_anotacao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_anotacao
    ADD CONSTRAINT calendario_anotacao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6782 (class 2606 OID 9466698)
-- Name: calendario_dia_anotacao_ref_cod_calendario_anotacao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_dia_anotacao
    ADD CONSTRAINT calendario_dia_anotacao_ref_cod_calendario_anotacao_fkey FOREIGN KEY (ref_cod_calendario_anotacao) REFERENCES pmieducar.calendario_anotacao(cod_calendario_anotacao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6781 (class 2606 OID 9466703)
-- Name: calendario_dia_anotacao_ref_ref_cod_calendario_ano_letivo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_dia_anotacao
    ADD CONSTRAINT calendario_dia_anotacao_ref_ref_cod_calendario_ano_letivo_fkey FOREIGN KEY (ref_ref_cod_calendario_ano_letivo, ref_mes, ref_dia) REFERENCES pmieducar.calendario_dia(ref_cod_calendario_ano_letivo, mes, dia) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6785 (class 2606 OID 9466708)
-- Name: calendario_dia_motivo_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_dia_motivo
    ADD CONSTRAINT calendario_dia_motivo_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6784 (class 2606 OID 9466713)
-- Name: calendario_dia_motivo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_dia_motivo
    ADD CONSTRAINT calendario_dia_motivo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6783 (class 2606 OID 9466718)
-- Name: calendario_dia_motivo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_dia_motivo
    ADD CONSTRAINT calendario_dia_motivo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6780 (class 2606 OID 9466723)
-- Name: calendario_dia_ref_cod_calendario_ano_letivo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_dia
    ADD CONSTRAINT calendario_dia_ref_cod_calendario_ano_letivo_fkey FOREIGN KEY (ref_cod_calendario_ano_letivo) REFERENCES pmieducar.calendario_ano_letivo(cod_calendario_ano_letivo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6779 (class 2606 OID 9466728)
-- Name: calendario_dia_ref_cod_calendario_dia_motivo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_dia
    ADD CONSTRAINT calendario_dia_ref_cod_calendario_dia_motivo_fkey FOREIGN KEY (ref_cod_calendario_dia_motivo) REFERENCES pmieducar.calendario_dia_motivo(cod_calendario_dia_motivo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6778 (class 2606 OID 9466733)
-- Name: calendario_dia_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_dia
    ADD CONSTRAINT calendario_dia_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6777 (class 2606 OID 9466738)
-- Name: calendario_dia_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.calendario_dia
    ADD CONSTRAINT calendario_dia_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6790 (class 2606 OID 9466743)
-- Name: candidato_reserva_vaga_ref_cod_escola; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.candidato_reserva_vaga
    ADD CONSTRAINT candidato_reserva_vaga_ref_cod_escola FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola);


--
-- TOC entry 6792 (class 2606 OID 9466748)
-- Name: categoria_nivel_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.categoria_nivel
    ADD CONSTRAINT categoria_nivel_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6791 (class 2606 OID 9466753)
-- Name: categoria_nivel_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.categoria_nivel
    ADD CONSTRAINT categoria_nivel_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6795 (class 2606 OID 9466758)
-- Name: cliente_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente
    ADD CONSTRAINT cliente_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6794 (class 2606 OID 9466763)
-- Name: cliente_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente
    ADD CONSTRAINT cliente_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6793 (class 2606 OID 9466768)
-- Name: cliente_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente
    ADD CONSTRAINT cliente_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6799 (class 2606 OID 9466773)
-- Name: cliente_suspensao_ref_cod_cliente_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente_suspensao
    ADD CONSTRAINT cliente_suspensao_ref_cod_cliente_fkey FOREIGN KEY (ref_cod_cliente) REFERENCES pmieducar.cliente(cod_cliente) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6798 (class 2606 OID 9466778)
-- Name: cliente_suspensao_ref_cod_motivo_suspensao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente_suspensao
    ADD CONSTRAINT cliente_suspensao_ref_cod_motivo_suspensao_fkey FOREIGN KEY (ref_cod_motivo_suspensao) REFERENCES pmieducar.motivo_suspensao(cod_motivo_suspensao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6797 (class 2606 OID 9466783)
-- Name: cliente_suspensao_ref_usuario_libera_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente_suspensao
    ADD CONSTRAINT cliente_suspensao_ref_usuario_libera_fkey FOREIGN KEY (ref_usuario_libera) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6796 (class 2606 OID 9466788)
-- Name: cliente_suspensao_ref_usuario_suspende_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente_suspensao
    ADD CONSTRAINT cliente_suspensao_ref_usuario_suspende_fkey FOREIGN KEY (ref_usuario_suspende) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6805 (class 2606 OID 9466793)
-- Name: cliente_tipo_cliente_ibfk1; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente_tipo_cliente
    ADD CONSTRAINT cliente_tipo_cliente_ibfk1 FOREIGN KEY (ref_cod_cliente) REFERENCES pmieducar.cliente(cod_cliente) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6804 (class 2606 OID 9466798)
-- Name: cliente_tipo_cliente_ibfk2; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente_tipo_cliente
    ADD CONSTRAINT cliente_tipo_cliente_ibfk2 FOREIGN KEY (ref_cod_cliente_tipo) REFERENCES pmieducar.cliente_tipo(cod_cliente_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6807 (class 2606 OID 9466803)
-- Name: cliente_tipo_exemplar_tipo_ref_cod_cliente_tipo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente_tipo_exemplar_tipo
    ADD CONSTRAINT cliente_tipo_exemplar_tipo_ref_cod_cliente_tipo_fkey FOREIGN KEY (ref_cod_cliente_tipo) REFERENCES pmieducar.cliente_tipo(cod_cliente_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6806 (class 2606 OID 9466808)
-- Name: cliente_tipo_exemplar_tipo_ref_cod_exemplar_tipo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente_tipo_exemplar_tipo
    ADD CONSTRAINT cliente_tipo_exemplar_tipo_ref_cod_exemplar_tipo_fkey FOREIGN KEY (ref_cod_exemplar_tipo) REFERENCES pmieducar.exemplar_tipo(cod_exemplar_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6802 (class 2606 OID 9466813)
-- Name: cliente_tipo_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente_tipo
    ADD CONSTRAINT cliente_tipo_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6801 (class 2606 OID 9466818)
-- Name: cliente_tipo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente_tipo
    ADD CONSTRAINT cliente_tipo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6800 (class 2606 OID 9466823)
-- Name: cliente_tipo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente_tipo
    ADD CONSTRAINT cliente_tipo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7026 (class 2606 OID 9469036)
-- Name: codigo_curso_superior_1_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor
    ADD CONSTRAINT codigo_curso_superior_1_fk FOREIGN KEY (codigo_curso_superior_1) REFERENCES modules.educacenso_curso_superior(id) ON DELETE SET NULL;


--
-- TOC entry 7027 (class 2606 OID 9469041)
-- Name: codigo_curso_superior_2_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor
    ADD CONSTRAINT codigo_curso_superior_2_fk FOREIGN KEY (codigo_curso_superior_2) REFERENCES modules.educacenso_curso_superior(id) ON DELETE SET NULL;


--
-- TOC entry 7028 (class 2606 OID 9469046)
-- Name: codigo_curso_superior_3_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor
    ADD CONSTRAINT codigo_curso_superior_3_fk FOREIGN KEY (codigo_curso_superior_3) REFERENCES modules.educacenso_curso_superior(id) ON DELETE SET NULL;


--
-- TOC entry 6809 (class 2606 OID 9466843)
-- Name: coffebreak_tipo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.coffebreak_tipo
    ADD CONSTRAINT coffebreak_tipo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6808 (class 2606 OID 9466848)
-- Name: coffebreak_tipo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.coffebreak_tipo
    ADD CONSTRAINT coffebreak_tipo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6815 (class 2606 OID 9466853)
-- Name: curso_ref_cod_instituicao_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.curso
    ADD CONSTRAINT curso_ref_cod_instituicao_fk FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6814 (class 2606 OID 9466858)
-- Name: curso_ref_cod_nivel_ensino_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.curso
    ADD CONSTRAINT curso_ref_cod_nivel_ensino_fkey FOREIGN KEY (ref_cod_nivel_ensino) REFERENCES pmieducar.nivel_ensino(cod_nivel_ensino) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6813 (class 2606 OID 9466863)
-- Name: curso_ref_cod_tipo_ensino_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.curso
    ADD CONSTRAINT curso_ref_cod_tipo_ensino_fkey FOREIGN KEY (ref_cod_tipo_ensino) REFERENCES pmieducar.tipo_ensino(cod_tipo_ensino) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6812 (class 2606 OID 9466868)
-- Name: curso_ref_cod_tipo_regime_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.curso
    ADD CONSTRAINT curso_ref_cod_tipo_regime_fkey FOREIGN KEY (ref_cod_tipo_regime) REFERENCES pmieducar.tipo_regime(cod_tipo_regime) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6811 (class 2606 OID 9466873)
-- Name: curso_ref_cod_usuario_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.curso
    ADD CONSTRAINT curso_ref_cod_usuario_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6810 (class 2606 OID 9466878)
-- Name: curso_ref_usuario_exc_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.curso
    ADD CONSTRAINT curso_ref_usuario_exc_fk FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6820 (class 2606 OID 9466883)
-- Name: disciplina_dependencia_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.disciplina_dependencia
    ADD CONSTRAINT disciplina_dependencia_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES pmieducar.matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6819 (class 2606 OID 9466888)
-- Name: disciplina_dependencia_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.disciplina_dependencia
    ADD CONSTRAINT disciplina_dependencia_ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie, ref_cod_escola, ref_cod_disciplina) REFERENCES pmieducar.escola_serie_disciplina(ref_ref_cod_serie, ref_ref_cod_escola, ref_cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6818 (class 2606 OID 9466893)
-- Name: disciplina_ref_cod_curso; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.disciplina
    ADD CONSTRAINT disciplina_ref_cod_curso FOREIGN KEY (ref_cod_curso) REFERENCES pmieducar.curso(cod_curso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6817 (class 2606 OID 9466898)
-- Name: disciplina_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.disciplina
    ADD CONSTRAINT disciplina_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6816 (class 2606 OID 9466903)
-- Name: disciplina_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.disciplina
    ADD CONSTRAINT disciplina_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6822 (class 2606 OID 9466908)
-- Name: disciplina_serie_ref_cod_disciplina_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.disciplina_serie
    ADD CONSTRAINT disciplina_serie_ref_cod_disciplina_fkey FOREIGN KEY (ref_cod_disciplina) REFERENCES pmieducar.disciplina(cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6821 (class 2606 OID 9466913)
-- Name: disciplina_serie_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.disciplina_serie
    ADD CONSTRAINT disciplina_serie_ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie) REFERENCES pmieducar.serie(cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6824 (class 2606 OID 9466918)
-- Name: disciplina_topico_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.disciplina_topico
    ADD CONSTRAINT disciplina_topico_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6823 (class 2606 OID 9466923)
-- Name: disciplina_topico_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.disciplina_topico
    ADD CONSTRAINT disciplina_topico_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6828 (class 2606 OID 9466928)
-- Name: dispensa_disciplina_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.dispensa_disciplina
    ADD CONSTRAINT dispensa_disciplina_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES pmieducar.matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6827 (class 2606 OID 9466938)
-- Name: dispensa_disciplina_ref_cod_tipo_dispensa_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.dispensa_disciplina
    ADD CONSTRAINT dispensa_disciplina_ref_cod_tipo_dispensa_fkey FOREIGN KEY (ref_cod_tipo_dispensa) REFERENCES pmieducar.tipo_dispensa(cod_tipo_dispensa) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6826 (class 2606 OID 9466943)
-- Name: dispensa_disciplina_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.dispensa_disciplina
    ADD CONSTRAINT dispensa_disciplina_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6825 (class 2606 OID 9466948)
-- Name: dispensa_disciplina_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.dispensa_disciplina
    ADD CONSTRAINT dispensa_disciplina_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6831 (class 2606 OID 9466953)
-- Name: distribuicao_uniforme_ref_cod_aluno_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.distribuicao_uniforme
    ADD CONSTRAINT distribuicao_uniforme_ref_cod_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES pmieducar.aluno(cod_aluno) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6842 (class 2606 OID 9466958)
-- Name: escola_ano_letivo_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_ano_letivo
    ADD CONSTRAINT escola_ano_letivo_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6841 (class 2606 OID 9466963)
-- Name: escola_ano_letivo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_ano_letivo
    ADD CONSTRAINT escola_ano_letivo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6840 (class 2606 OID 9466968)
-- Name: escola_ano_letivo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_ano_letivo
    ADD CONSTRAINT escola_ano_letivo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6832 (class 2606 OID 9466973)
-- Name: escola_codigo_indigena_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola
    ADD CONSTRAINT escola_codigo_indigena_fk FOREIGN KEY (codigo_lingua_indigena) REFERENCES modules.lingua_indigena_educacenso(id);


--
-- TOC entry 6844 (class 2606 OID 9466978)
-- Name: escola_complemento_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_complemento
    ADD CONSTRAINT escola_complemento_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6843 (class 2606 OID 9466983)
-- Name: escola_complemento_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_complemento
    ADD CONSTRAINT escola_complemento_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6848 (class 2606 OID 9466988)
-- Name: escola_curso_ref_cod_curso_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_curso
    ADD CONSTRAINT escola_curso_ref_cod_curso_fkey FOREIGN KEY (ref_cod_curso) REFERENCES pmieducar.curso(cod_curso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6847 (class 2606 OID 9466993)
-- Name: escola_curso_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_curso
    ADD CONSTRAINT escola_curso_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6846 (class 2606 OID 9466998)
-- Name: escola_curso_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_curso
    ADD CONSTRAINT escola_curso_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6845 (class 2606 OID 9467003)
-- Name: escola_curso_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_curso
    ADD CONSTRAINT escola_curso_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6851 (class 2606 OID 9467008)
-- Name: escola_localizacao_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_localizacao
    ADD CONSTRAINT escola_localizacao_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6850 (class 2606 OID 9467013)
-- Name: escola_localizacao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_localizacao
    ADD CONSTRAINT escola_localizacao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6849 (class 2606 OID 9467018)
-- Name: escola_localizacao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_localizacao
    ADD CONSTRAINT escola_localizacao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6853 (class 2606 OID 9467023)
-- Name: escola_rede_ensino_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_rede_ensino
    ADD CONSTRAINT escola_rede_ensino_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6852 (class 2606 OID 9467028)
-- Name: escola_rede_ensino_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_rede_ensino
    ADD CONSTRAINT escola_rede_ensino_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6833 (class 2606 OID 9467038)
-- Name: escola_ref_cod_escola_rede_ensino_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola
    ADD CONSTRAINT escola_ref_cod_escola_rede_ensino_fkey FOREIGN KEY (ref_cod_escola_rede_ensino) REFERENCES pmieducar.escola_rede_ensino(cod_escola_rede_ensino) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6834 (class 2606 OID 9467043)
-- Name: escola_ref_cod_instituicao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola
    ADD CONSTRAINT escola_ref_cod_instituicao_fkey FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6835 (class 2606 OID 9467048)
-- Name: escola_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola
    ADD CONSTRAINT escola_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.juridica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6836 (class 2606 OID 9467053)
-- Name: escola_ref_idpes_gestor_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola
    ADD CONSTRAINT escola_ref_idpes_gestor_fk FOREIGN KEY (ref_idpes_gestor) REFERENCES cadastro.pessoa(idpes);


--
-- TOC entry 6837 (class 2606 OID 9467058)
-- Name: escola_ref_idpes_secretario_escolar_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola
    ADD CONSTRAINT escola_ref_idpes_secretario_escolar_fkey FOREIGN KEY (ref_idpes_secretario_escolar) REFERENCES cadastro.pessoa(idpes);


--
-- TOC entry 6838 (class 2606 OID 9467063)
-- Name: escola_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola
    ADD CONSTRAINT escola_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6839 (class 2606 OID 9467068)
-- Name: escola_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola
    ADD CONSTRAINT escola_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6859 (class 2606 OID 9467073)
-- Name: escola_serie_disciplina_ref_cod_disciplina_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_serie_disciplina
    ADD CONSTRAINT escola_serie_disciplina_ref_cod_disciplina_fkey FOREIGN KEY (ref_cod_disciplina) REFERENCES modules.componente_curricular(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6858 (class 2606 OID 9467078)
-- Name: escola_serie_disciplina_ref_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_serie_disciplina
    ADD CONSTRAINT escola_serie_disciplina_ref_ref_cod_escola_fkey FOREIGN KEY (ref_ref_cod_escola, ref_ref_cod_serie) REFERENCES pmieducar.escola_serie(ref_cod_escola, ref_cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6857 (class 2606 OID 9467083)
-- Name: escola_serie_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_serie
    ADD CONSTRAINT escola_serie_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6856 (class 2606 OID 9467088)
-- Name: escola_serie_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_serie
    ADD CONSTRAINT escola_serie_ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie) REFERENCES pmieducar.serie(cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6855 (class 2606 OID 9467093)
-- Name: escola_serie_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_serie
    ADD CONSTRAINT escola_serie_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6854 (class 2606 OID 9467098)
-- Name: escola_serie_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_serie
    ADD CONSTRAINT escola_serie_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6861 (class 2606 OID 9467103)
-- Name: escola_usuario_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_usuario
    ADD CONSTRAINT escola_usuario_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola);


--
-- TOC entry 6860 (class 2606 OID 9467108)
-- Name: escola_usuario_ref_cod_usuario_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.escola_usuario
    ADD CONSTRAINT escola_usuario_ref_cod_usuario_fkey FOREIGN KEY (ref_cod_usuario) REFERENCES pmieducar.usuario(cod_usuario);


--
-- TOC entry 6871 (class 2606 OID 9467113)
-- Name: exemplar_emprestimo_ref_cod_cliente_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.exemplar_emprestimo
    ADD CONSTRAINT exemplar_emprestimo_ref_cod_cliente_fkey FOREIGN KEY (ref_cod_cliente) REFERENCES pmieducar.cliente(cod_cliente) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6870 (class 2606 OID 9467118)
-- Name: exemplar_emprestimo_ref_cod_exemplar_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.exemplar_emprestimo
    ADD CONSTRAINT exemplar_emprestimo_ref_cod_exemplar_fkey FOREIGN KEY (ref_cod_exemplar) REFERENCES pmieducar.exemplar(cod_exemplar) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6869 (class 2606 OID 9467123)
-- Name: exemplar_emprestimo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.exemplar_emprestimo
    ADD CONSTRAINT exemplar_emprestimo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6868 (class 2606 OID 9467128)
-- Name: exemplar_emprestimo_ref_usuario_devolucao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.exemplar_emprestimo
    ADD CONSTRAINT exemplar_emprestimo_ref_usuario_devolucao_fkey FOREIGN KEY (ref_usuario_devolucao) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6867 (class 2606 OID 9467133)
-- Name: exemplar_ref_cod_acervo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.exemplar
    ADD CONSTRAINT exemplar_ref_cod_acervo_fkey FOREIGN KEY (ref_cod_acervo) REFERENCES pmieducar.acervo(cod_acervo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6866 (class 2606 OID 9467138)
-- Name: exemplar_ref_cod_fonte_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.exemplar
    ADD CONSTRAINT exemplar_ref_cod_fonte_fkey FOREIGN KEY (ref_cod_fonte) REFERENCES pmieducar.fonte(cod_fonte) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6865 (class 2606 OID 9467143)
-- Name: exemplar_ref_cod_motivo_baixa_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.exemplar
    ADD CONSTRAINT exemplar_ref_cod_motivo_baixa_fkey FOREIGN KEY (ref_cod_motivo_baixa) REFERENCES pmieducar.motivo_baixa(cod_motivo_baixa) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6864 (class 2606 OID 9467148)
-- Name: exemplar_ref_cod_situacao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.exemplar
    ADD CONSTRAINT exemplar_ref_cod_situacao_fkey FOREIGN KEY (ref_cod_situacao) REFERENCES pmieducar.situacao(cod_situacao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6863 (class 2606 OID 9467153)
-- Name: exemplar_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.exemplar
    ADD CONSTRAINT exemplar_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6862 (class 2606 OID 9467158)
-- Name: exemplar_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.exemplar
    ADD CONSTRAINT exemplar_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6874 (class 2606 OID 9467163)
-- Name: exemplar_tipo_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.exemplar_tipo
    ADD CONSTRAINT exemplar_tipo_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6873 (class 2606 OID 9467168)
-- Name: exemplar_tipo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.exemplar_tipo
    ADD CONSTRAINT exemplar_tipo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6872 (class 2606 OID 9467173)
-- Name: exemplar_tipo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.exemplar_tipo
    ADD CONSTRAINT exemplar_tipo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6878 (class 2606 OID 9467178)
-- Name: falta_aluno_ref_cod_curso_disciplina; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.falta_aluno
    ADD CONSTRAINT falta_aluno_ref_cod_curso_disciplina FOREIGN KEY (ref_cod_curso_disciplina) REFERENCES pmieducar.disciplina(cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6877 (class 2606 OID 9467183)
-- Name: falta_aluno_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.falta_aluno
    ADD CONSTRAINT falta_aluno_ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie, ref_cod_escola, ref_cod_disciplina) REFERENCES pmieducar.escola_serie_disciplina(ref_ref_cod_serie, ref_ref_cod_escola, ref_cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6876 (class 2606 OID 9467188)
-- Name: falta_aluno_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.falta_aluno
    ADD CONSTRAINT falta_aluno_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6875 (class 2606 OID 9467193)
-- Name: falta_aluno_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.falta_aluno
    ADD CONSTRAINT falta_aluno_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6886 (class 2606 OID 9467198)
-- Name: falta_atraso_compensado_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.falta_atraso_compensado
    ADD CONSTRAINT falta_atraso_compensado_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6885 (class 2606 OID 9467203)
-- Name: falta_atraso_compensado_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.falta_atraso_compensado
    ADD CONSTRAINT falta_atraso_compensado_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES pmieducar.servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6884 (class 2606 OID 9467208)
-- Name: falta_atraso_compensado_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.falta_atraso_compensado
    ADD CONSTRAINT falta_atraso_compensado_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6883 (class 2606 OID 9467213)
-- Name: falta_atraso_compensado_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.falta_atraso_compensado
    ADD CONSTRAINT falta_atraso_compensado_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6882 (class 2606 OID 9467218)
-- Name: falta_atraso_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.falta_atraso
    ADD CONSTRAINT falta_atraso_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6881 (class 2606 OID 9467223)
-- Name: falta_atraso_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.falta_atraso
    ADD CONSTRAINT falta_atraso_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES pmieducar.servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6880 (class 2606 OID 9467228)
-- Name: falta_atraso_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.falta_atraso
    ADD CONSTRAINT falta_atraso_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6879 (class 2606 OID 9467233)
-- Name: falta_atraso_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.falta_atraso
    ADD CONSTRAINT falta_atraso_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6888 (class 2606 OID 9467238)
-- Name: faltas_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.faltas
    ADD CONSTRAINT faltas_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES pmieducar.matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6887 (class 2606 OID 9467243)
-- Name: faltas_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.faltas
    ADD CONSTRAINT faltas_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6718 (class 2606 OID 9467248)
-- Name: fk_abandono_tipo_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.abandono_tipo
    ADD CONSTRAINT fk_abandono_tipo_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao);


--
-- TOC entry 6717 (class 2606 OID 9467253)
-- Name: fk_abandono_tipo_usuario_cad; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.abandono_tipo
    ADD CONSTRAINT fk_abandono_tipo_usuario_cad FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario);


--
-- TOC entry 6716 (class 2606 OID 9467258)
-- Name: fk_abandono_tipo_usuario_exc; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.abandono_tipo
    ADD CONSTRAINT fk_abandono_tipo_usuario_exc FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario);


--
-- TOC entry 6830 (class 2606 OID 9467263)
-- Name: fk_distribuicao_uniforme_escola; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.distribuicao_uniforme
    ADD CONSTRAINT fk_distribuicao_uniforme_escola FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola);


--
-- TOC entry 6935 (class 2606 OID 9467268)
-- Name: fk_matricula_abandono_tipo; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula
    ADD CONSTRAINT fk_matricula_abandono_tipo FOREIGN KEY (ref_cod_abandono_tipo) REFERENCES pmieducar.abandono_tipo(cod_abandono_tipo);


--
-- TOC entry 6803 (class 2606 OID 9467273)
-- Name: fk_ref_cod_biblioteca_cliente; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.cliente_tipo_cliente
    ADD CONSTRAINT fk_ref_cod_biblioteca_cliente FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7002 (class 2606 OID 9467278)
-- Name: fk_ref_cod_exemplar; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.reservas
    ADD CONSTRAINT fk_ref_cod_exemplar FOREIGN KEY (ref_cod_exemplar) REFERENCES pmieducar.exemplar(cod_exemplar) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7019 (class 2606 OID 9467283)
-- Name: fk_servidor_pessoa; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor
    ADD CONSTRAINT fk_servidor_pessoa FOREIGN KEY (cod_servidor) REFERENCES cadastro.pessoa(idpes);


--
-- TOC entry 7081 (class 2606 OID 9467288)
-- Name: fk_turma_disciplina_dispensada; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma
    ADD CONSTRAINT fk_turma_disciplina_dispensada FOREIGN KEY (ref_cod_disciplina_dispensada) REFERENCES modules.componente_curricular(id);


--
-- TOC entry 6891 (class 2606 OID 9467293)
-- Name: fonte_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.fonte
    ADD CONSTRAINT fonte_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6890 (class 2606 OID 9467298)
-- Name: fonte_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.fonte
    ADD CONSTRAINT fonte_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6889 (class 2606 OID 9467303)
-- Name: fonte_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.fonte
    ADD CONSTRAINT fonte_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6894 (class 2606 OID 9467308)
-- Name: funca_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.funcao
    ADD CONSTRAINT funca_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6893 (class 2606 OID 9467313)
-- Name: funcao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.funcao
    ADD CONSTRAINT funcao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6892 (class 2606 OID 9467318)
-- Name: funcao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.funcao
    ADD CONSTRAINT funcao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6899 (class 2606 OID 9467323)
-- Name: habilitacao_curso_ref_cod_curso_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.habilitacao_curso
    ADD CONSTRAINT habilitacao_curso_ref_cod_curso_fkey FOREIGN KEY (ref_cod_curso) REFERENCES pmieducar.curso(cod_curso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6898 (class 2606 OID 9467328)
-- Name: habilitacao_curso_ref_cod_habilitacao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.habilitacao_curso
    ADD CONSTRAINT habilitacao_curso_ref_cod_habilitacao_fkey FOREIGN KEY (ref_cod_habilitacao) REFERENCES pmieducar.habilitacao(cod_habilitacao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6897 (class 2606 OID 9467333)
-- Name: habilitacao_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.habilitacao
    ADD CONSTRAINT habilitacao_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6896 (class 2606 OID 9467338)
-- Name: habilitacao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.habilitacao
    ADD CONSTRAINT habilitacao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6895 (class 2606 OID 9467343)
-- Name: habilitacao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.habilitacao
    ADD CONSTRAINT habilitacao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6900 (class 2606 OID 9467348)
-- Name: historico_disciplinas_ref_ref_cod_aluno_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.historico_disciplinas
    ADD CONSTRAINT historico_disciplinas_ref_ref_cod_aluno_fkey FOREIGN KEY (ref_ref_cod_aluno, ref_sequencial) REFERENCES pmieducar.historico_escolar(ref_cod_aluno, sequencial) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6906 (class 2606 OID 9467353)
-- Name: historico_escolar_ref_cod_aluno_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.historico_escolar
    ADD CONSTRAINT historico_escolar_ref_cod_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES pmieducar.aluno(cod_aluno) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6905 (class 2606 OID 9467358)
-- Name: historico_escolar_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.historico_escolar
    ADD CONSTRAINT historico_escolar_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola);


--
-- TOC entry 6904 (class 2606 OID 9467363)
-- Name: historico_escolar_ref_cod_escola_fkey1; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.historico_escolar
    ADD CONSTRAINT historico_escolar_ref_cod_escola_fkey1 FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola);


--
-- TOC entry 6903 (class 2606 OID 9467368)
-- Name: historico_escolar_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.historico_escolar
    ADD CONSTRAINT historico_escolar_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6902 (class 2606 OID 9467373)
-- Name: historico_escolar_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.historico_escolar
    ADD CONSTRAINT historico_escolar_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6901 (class 2606 OID 9467378)
-- Name: historico_grade_curso_id_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.historico_escolar
    ADD CONSTRAINT historico_grade_curso_id_fkey FOREIGN KEY (historico_grade_curso_id) REFERENCES pmieducar.historico_grade_curso(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6909 (class 2606 OID 9467383)
-- Name: infra_comodo_funcao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.infra_comodo_funcao
    ADD CONSTRAINT infra_comodo_funcao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6908 (class 2606 OID 9467388)
-- Name: infra_comodo_funcao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.infra_comodo_funcao
    ADD CONSTRAINT infra_comodo_funcao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6907 (class 2606 OID 9467393)
-- Name: infra_comodo_ref_cod_escola; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.infra_comodo_funcao
    ADD CONSTRAINT infra_comodo_ref_cod_escola FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6916 (class 2606 OID 9467398)
-- Name: infra_predio_comodo_ref_cod_infra_comodo_funcao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.infra_predio_comodo
    ADD CONSTRAINT infra_predio_comodo_ref_cod_infra_comodo_funcao_fkey FOREIGN KEY (ref_cod_infra_comodo_funcao) REFERENCES pmieducar.infra_comodo_funcao(cod_infra_comodo_funcao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6915 (class 2606 OID 9467403)
-- Name: infra_predio_comodo_ref_cod_infra_predio_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.infra_predio_comodo
    ADD CONSTRAINT infra_predio_comodo_ref_cod_infra_predio_fkey FOREIGN KEY (ref_cod_infra_predio) REFERENCES pmieducar.infra_predio(cod_infra_predio) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6914 (class 2606 OID 9467408)
-- Name: infra_predio_comodo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.infra_predio_comodo
    ADD CONSTRAINT infra_predio_comodo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6913 (class 2606 OID 9467413)
-- Name: infra_predio_comodo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.infra_predio_comodo
    ADD CONSTRAINT infra_predio_comodo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6912 (class 2606 OID 9467418)
-- Name: infra_predio_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.infra_predio
    ADD CONSTRAINT infra_predio_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6911 (class 2606 OID 9467423)
-- Name: infra_predio_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.infra_predio
    ADD CONSTRAINT infra_predio_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6910 (class 2606 OID 9467428)
-- Name: infra_predio_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.infra_predio
    ADD CONSTRAINT infra_predio_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7020 (class 2606 OID 9467433)
-- Name: instituicao_curso_superior_1_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor
    ADD CONSTRAINT instituicao_curso_superior_1_fk FOREIGN KEY (instituicao_curso_superior_1) REFERENCES modules.educacenso_ies(id);


--
-- TOC entry 7021 (class 2606 OID 9467438)
-- Name: instituicao_curso_superior_2_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor
    ADD CONSTRAINT instituicao_curso_superior_2_fk FOREIGN KEY (instituicao_curso_superior_2) REFERENCES modules.educacenso_ies(id);


--
-- TOC entry 7022 (class 2606 OID 9467443)
-- Name: instituicao_curso_superior_3_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor
    ADD CONSTRAINT instituicao_curso_superior_3_fk FOREIGN KEY (instituicao_curso_superior_3) REFERENCES modules.educacenso_ies(id);


--
-- TOC entry 6920 (class 2606 OID 9467448)
-- Name: instituicao_id_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.instituicao_documentacao
    ADD CONSTRAINT instituicao_id_fkey FOREIGN KEY (instituicao_id) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6919 (class 2606 OID 9467453)
-- Name: instituicao_ref_idtlog_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.instituicao
    ADD CONSTRAINT instituicao_ref_idtlog_fkey FOREIGN KEY (ref_idtlog) REFERENCES urbano.tipo_logradouro(idtlog) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6918 (class 2606 OID 9467458)
-- Name: instituicao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.instituicao
    ADD CONSTRAINT instituicao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6917 (class 2606 OID 9467463)
-- Name: instituicao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.instituicao
    ADD CONSTRAINT instituicao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6924 (class 2606 OID 9467468)
-- Name: material_didatico_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.material_didatico
    ADD CONSTRAINT material_didatico_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6923 (class 2606 OID 9467473)
-- Name: material_didatico_ref_cod_material_tipo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.material_didatico
    ADD CONSTRAINT material_didatico_ref_cod_material_tipo_fkey FOREIGN KEY (ref_cod_material_tipo) REFERENCES pmieducar.material_tipo(cod_material_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6922 (class 2606 OID 9467478)
-- Name: material_didatico_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.material_didatico
    ADD CONSTRAINT material_didatico_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6921 (class 2606 OID 9467483)
-- Name: material_didatico_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.material_didatico
    ADD CONSTRAINT material_didatico_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6927 (class 2606 OID 9467488)
-- Name: material_tipo_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.material_tipo
    ADD CONSTRAINT material_tipo_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6926 (class 2606 OID 9467493)
-- Name: material_tipo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.material_tipo
    ADD CONSTRAINT material_tipo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6925 (class 2606 OID 9467498)
-- Name: material_tipo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.material_tipo
    ADD CONSTRAINT material_tipo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6937 (class 2606 OID 9467503)
-- Name: matricula_excessao_ref_cod_disciplina_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula_excessao
    ADD CONSTRAINT matricula_excessao_ref_cod_disciplina_fkey FOREIGN KEY (ref_cod_serie, ref_cod_escola, ref_cod_disciplina) REFERENCES pmieducar.escola_serie_disciplina(ref_ref_cod_serie, ref_ref_cod_escola, ref_cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6936 (class 2606 OID 9467508)
-- Name: matricula_excessao_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula_excessao
    ADD CONSTRAINT matricula_excessao_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula, ref_cod_turma, ref_sequencial) REFERENCES pmieducar.matricula_turma(ref_cod_matricula, ref_cod_turma, sequencial) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6941 (class 2606 OID 9467513)
-- Name: matricula_ocorrencia_discipli_ref_cod_tipo_ocorrencia_disc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula_ocorrencia_disciplinar
    ADD CONSTRAINT matricula_ocorrencia_discipli_ref_cod_tipo_ocorrencia_disc_fkey FOREIGN KEY (ref_cod_tipo_ocorrencia_disciplinar) REFERENCES pmieducar.tipo_ocorrencia_disciplinar(cod_tipo_ocorrencia_disciplinar) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6940 (class 2606 OID 9467518)
-- Name: matricula_ocorrencia_disciplinar_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula_ocorrencia_disciplinar
    ADD CONSTRAINT matricula_ocorrencia_disciplinar_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES pmieducar.matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6939 (class 2606 OID 9467523)
-- Name: matricula_ocorrencia_disciplinar_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula_ocorrencia_disciplinar
    ADD CONSTRAINT matricula_ocorrencia_disciplinar_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6938 (class 2606 OID 9467528)
-- Name: matricula_ocorrencia_disciplinar_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula_ocorrencia_disciplinar
    ADD CONSTRAINT matricula_ocorrencia_disciplinar_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6934 (class 2606 OID 9467533)
-- Name: matricula_ref_cod_aluno_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula
    ADD CONSTRAINT matricula_ref_cod_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES pmieducar.aluno(cod_aluno) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6933 (class 2606 OID 9467538)
-- Name: matricula_ref_cod_curso; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula
    ADD CONSTRAINT matricula_ref_cod_curso FOREIGN KEY (ref_cod_curso) REFERENCES pmieducar.curso(cod_curso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6932 (class 2606 OID 9467543)
-- Name: matricula_ref_cod_reserva_vaga_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula
    ADD CONSTRAINT matricula_ref_cod_reserva_vaga_fkey FOREIGN KEY (ref_cod_reserva_vaga) REFERENCES pmieducar.reserva_vaga(cod_reserva_vaga) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6931 (class 2606 OID 9467548)
-- Name: matricula_ref_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula
    ADD CONSTRAINT matricula_ref_ref_cod_escola_fkey FOREIGN KEY (ref_ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6930 (class 2606 OID 9467553)
-- Name: matricula_ref_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula
    ADD CONSTRAINT matricula_ref_ref_cod_serie_fkey FOREIGN KEY (ref_ref_cod_serie) REFERENCES pmieducar.serie(cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6929 (class 2606 OID 9467558)
-- Name: matricula_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula
    ADD CONSTRAINT matricula_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6928 (class 2606 OID 9467563)
-- Name: matricula_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula
    ADD CONSTRAINT matricula_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6945 (class 2606 OID 9467568)
-- Name: matricula_turma_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula_turma
    ADD CONSTRAINT matricula_turma_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES pmieducar.matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6944 (class 2606 OID 9467573)
-- Name: matricula_turma_ref_cod_turma_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula_turma
    ADD CONSTRAINT matricula_turma_ref_cod_turma_fkey FOREIGN KEY (ref_cod_turma) REFERENCES pmieducar.turma(cod_turma) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6943 (class 2606 OID 9467578)
-- Name: matricula_turma_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula_turma
    ADD CONSTRAINT matricula_turma_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6942 (class 2606 OID 9467583)
-- Name: matricula_turma_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.matricula_turma
    ADD CONSTRAINT matricula_turma_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6947 (class 2606 OID 9468963)
-- Name: menu_tipo_usuario_ref_cod_menu_submenu_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.menu_tipo_usuario
    ADD CONSTRAINT menu_tipo_usuario_ref_cod_menu_submenu_fkey FOREIGN KEY (ref_cod_menu_submenu) REFERENCES portal.menu_submenu(cod_menu_submenu) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6946 (class 2606 OID 9468968)
-- Name: menu_tipo_usuario_ref_cod_tipo_usuario_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.menu_tipo_usuario
    ADD CONSTRAINT menu_tipo_usuario_ref_cod_tipo_usuario_fkey FOREIGN KEY (ref_cod_tipo_usuario) REFERENCES pmieducar.tipo_usuario(cod_tipo_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6950 (class 2606 OID 9467588)
-- Name: modulo_ref_cod_instituicao_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.modulo
    ADD CONSTRAINT modulo_ref_cod_instituicao_fk FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6949 (class 2606 OID 9467593)
-- Name: modulo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.modulo
    ADD CONSTRAINT modulo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6948 (class 2606 OID 9467598)
-- Name: modulo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.modulo
    ADD CONSTRAINT modulo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6953 (class 2606 OID 9467603)
-- Name: motivo_afastamento_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.motivo_afastamento
    ADD CONSTRAINT motivo_afastamento_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6952 (class 2606 OID 9467608)
-- Name: motivo_afastamento_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.motivo_afastamento
    ADD CONSTRAINT motivo_afastamento_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6951 (class 2606 OID 9467613)
-- Name: motivo_afastamento_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.motivo_afastamento
    ADD CONSTRAINT motivo_afastamento_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6956 (class 2606 OID 9467618)
-- Name: motivo_baixa_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.motivo_baixa
    ADD CONSTRAINT motivo_baixa_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6955 (class 2606 OID 9467623)
-- Name: motivo_baixa_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.motivo_baixa
    ADD CONSTRAINT motivo_baixa_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6954 (class 2606 OID 9467628)
-- Name: motivo_baixa_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.motivo_baixa
    ADD CONSTRAINT motivo_baixa_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6959 (class 2606 OID 9467633)
-- Name: motivo_suspensao_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.motivo_suspensao
    ADD CONSTRAINT motivo_suspensao_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6958 (class 2606 OID 9467638)
-- Name: motivo_suspensao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.motivo_suspensao
    ADD CONSTRAINT motivo_suspensao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6957 (class 2606 OID 9467643)
-- Name: motivo_suspensao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.motivo_suspensao
    ADD CONSTRAINT motivo_suspensao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6966 (class 2606 OID 9467648)
-- Name: nivel_ensino_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.nivel_ensino
    ADD CONSTRAINT nivel_ensino_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6965 (class 2606 OID 9467653)
-- Name: nivel_ensino_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.nivel_ensino
    ADD CONSTRAINT nivel_ensino_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6964 (class 2606 OID 9467658)
-- Name: nivel_ensino_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.nivel_ensino
    ADD CONSTRAINT nivel_ensino_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6963 (class 2606 OID 9467663)
-- Name: nivel_ref_cod_categoria_nivel_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.nivel
    ADD CONSTRAINT nivel_ref_cod_categoria_nivel_fkey FOREIGN KEY (ref_cod_categoria_nivel) REFERENCES pmieducar.categoria_nivel(cod_categoria_nivel) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6962 (class 2606 OID 9467668)
-- Name: nivel_ref_cod_nivel_anterior_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.nivel
    ADD CONSTRAINT nivel_ref_cod_nivel_anterior_fkey FOREIGN KEY (ref_cod_nivel_anterior) REFERENCES pmieducar.nivel(cod_nivel) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6961 (class 2606 OID 9467673)
-- Name: nivel_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.nivel
    ADD CONSTRAINT nivel_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6960 (class 2606 OID 9467678)
-- Name: nivel_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.nivel
    ADD CONSTRAINT nivel_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6972 (class 2606 OID 9467683)
-- Name: nota_aluno_ref_cod_curso_disciplina; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.nota_aluno
    ADD CONSTRAINT nota_aluno_ref_cod_curso_disciplina FOREIGN KEY (ref_cod_curso_disciplina) REFERENCES pmieducar.disciplina(cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6971 (class 2606 OID 9467688)
-- Name: nota_aluno_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.nota_aluno
    ADD CONSTRAINT nota_aluno_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES pmieducar.matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6970 (class 2606 OID 9467693)
-- Name: nota_aluno_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.nota_aluno
    ADD CONSTRAINT nota_aluno_ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie, ref_cod_escola, ref_cod_disciplina) REFERENCES pmieducar.escola_serie_disciplina(ref_ref_cod_serie, ref_ref_cod_escola, ref_cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6969 (class 2606 OID 9467698)
-- Name: nota_aluno_ref_ref_cod_tipo_avaliacao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.nota_aluno
    ADD CONSTRAINT nota_aluno_ref_ref_cod_tipo_avaliacao_fkey FOREIGN KEY (ref_ref_cod_tipo_avaliacao, ref_sequencial) REFERENCES pmieducar.tipo_avaliacao_valores(ref_cod_tipo_avaliacao, sequencial) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6968 (class 2606 OID 9467703)
-- Name: nota_aluno_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.nota_aluno
    ADD CONSTRAINT nota_aluno_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6967 (class 2606 OID 9467708)
-- Name: nota_aluno_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.nota_aluno
    ADD CONSTRAINT nota_aluno_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6974 (class 2606 OID 9467713)
-- Name: operador_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.operador
    ADD CONSTRAINT operador_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6973 (class 2606 OID 9467718)
-- Name: operador_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.operador
    ADD CONSTRAINT operador_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6977 (class 2606 OID 9467723)
-- Name: pagamento_divida_ref_cod_biblioteca; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.pagamento_multa
    ADD CONSTRAINT pagamento_divida_ref_cod_biblioteca FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6976 (class 2606 OID 9467728)
-- Name: pagamento_multa_ref_cod_cliente_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.pagamento_multa
    ADD CONSTRAINT pagamento_multa_ref_cod_cliente_fkey FOREIGN KEY (ref_cod_cliente) REFERENCES pmieducar.cliente(cod_cliente) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6975 (class 2606 OID 9467733)
-- Name: pagamento_multa_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.pagamento_multa
    ADD CONSTRAINT pagamento_multa_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6770 (class 2606 OID 9467738)
-- Name: pmieducar_bloqueio_ano_letivo_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.bloqueio_ano_letivo
    ADD CONSTRAINT pmieducar_bloqueio_ano_letivo_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao);


--
-- TOC entry 6981 (class 2606 OID 9467743)
-- Name: pmieducar_projeto_aluno_ref_cod_aluno; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.projeto_aluno
    ADD CONSTRAINT pmieducar_projeto_aluno_ref_cod_aluno FOREIGN KEY (ref_cod_aluno) REFERENCES pmieducar.aluno(cod_aluno);


--
-- TOC entry 6980 (class 2606 OID 9467748)
-- Name: pmieducar_projeto_aluno_ref_cod_projeto; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.projeto_aluno
    ADD CONSTRAINT pmieducar_projeto_aluno_ref_cod_projeto FOREIGN KEY (ref_cod_projeto) REFERENCES pmieducar.projeto(cod_projeto);


--
-- TOC entry 6979 (class 2606 OID 9467753)
-- Name: pre_requisito_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.pre_requisito
    ADD CONSTRAINT pre_requisito_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6978 (class 2606 OID 9467758)
-- Name: pre_requisito_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.pre_requisito
    ADD CONSTRAINT pre_requisito_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6990 (class 2606 OID 9467763)
-- Name: quadro_horario_horarios_ref_cod_quadro_horario_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.quadro_horario_horarios_aux
    ADD CONSTRAINT quadro_horario_horarios_ref_cod_quadro_horario_fkey FOREIGN KEY (ref_cod_quadro_horario) REFERENCES pmieducar.quadro_horario(cod_quadro_horario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6987 (class 2606 OID 9467768)
-- Name: quadro_horario_horarios_ref_cod_quadro_horario_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.quadro_horario_horarios
    ADD CONSTRAINT quadro_horario_horarios_ref_cod_quadro_horario_fkey FOREIGN KEY (ref_cod_quadro_horario) REFERENCES pmieducar.quadro_horario(cod_quadro_horario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6989 (class 2606 OID 9467773)
-- Name: quadro_horario_horarios_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.quadro_horario_horarios_aux
    ADD CONSTRAINT quadro_horario_horarios_ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie, ref_cod_escola, ref_cod_disciplina) REFERENCES pmieducar.escola_serie_disciplina(ref_ref_cod_serie, ref_ref_cod_escola, ref_cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6988 (class 2606 OID 9467778)
-- Name: quadro_horario_horarios_ref_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.quadro_horario_horarios_aux
    ADD CONSTRAINT quadro_horario_horarios_ref_servidor_fkey FOREIGN KEY (ref_servidor, ref_cod_instituicao_servidor) REFERENCES pmieducar.servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6986 (class 2606 OID 9467783)
-- Name: quadro_horario_horarios_ref_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.quadro_horario_horarios
    ADD CONSTRAINT quadro_horario_horarios_ref_servidor_fkey FOREIGN KEY (ref_servidor, ref_cod_instituicao_servidor) REFERENCES pmieducar.servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6985 (class 2606 OID 9467788)
-- Name: quadro_horario_horarios_ref_servidor_substituto_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.quadro_horario_horarios
    ADD CONSTRAINT quadro_horario_horarios_ref_servidor_substituto_fkey FOREIGN KEY (ref_servidor_substituto, ref_cod_instituicao_substituto) REFERENCES pmieducar.servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6984 (class 2606 OID 9467793)
-- Name: quadro_horario_ref_cod_turma_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.quadro_horario
    ADD CONSTRAINT quadro_horario_ref_cod_turma_fkey FOREIGN KEY (ref_cod_turma) REFERENCES pmieducar.turma(cod_turma) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6983 (class 2606 OID 9467798)
-- Name: quadro_horario_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.quadro_horario
    ADD CONSTRAINT quadro_horario_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6982 (class 2606 OID 9467803)
-- Name: quadro_horario_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.quadro_horario
    ADD CONSTRAINT quadro_horario_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6789 (class 2606 OID 9467808)
-- Name: ref_cod_aluno_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.candidato_reserva_vaga
    ADD CONSTRAINT ref_cod_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES pmieducar.aluno(cod_aluno);


--
-- TOC entry 6829 (class 2606 OID 9467813)
-- Name: ref_cod_disciplina; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.dispensa_etapa
    ADD CONSTRAINT ref_cod_disciplina FOREIGN KEY (ref_cod_dispensa) REFERENCES pmieducar.dispensa_disciplina(cod_dispensa);


--
-- TOC entry 6788 (class 2606 OID 9467818)
-- Name: ref_cod_pessoa_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.candidato_reserva_vaga
    ADD CONSTRAINT ref_cod_pessoa_cad_fkey FOREIGN KEY (ref_cod_pessoa_cad) REFERENCES cadastro.pessoa(idpes);


--
-- TOC entry 6787 (class 2606 OID 9467823)
-- Name: ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.candidato_reserva_vaga
    ADD CONSTRAINT ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie) REFERENCES pmieducar.serie(cod_serie);


--
-- TOC entry 6786 (class 2606 OID 9467828)
-- Name: ref_cod_turno_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.candidato_reserva_vaga
    ADD CONSTRAINT ref_cod_turno_fkey FOREIGN KEY (ref_cod_turno) REFERENCES pmieducar.turma_turno(id);


--
-- TOC entry 6992 (class 2606 OID 9467833)
-- Name: relacao_categoria_acervo_categoria_id_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.relacao_categoria_acervo
    ADD CONSTRAINT relacao_categoria_acervo_categoria_id_fkey FOREIGN KEY (categoria_id) REFERENCES pmieducar.categoria_obra(id);


--
-- TOC entry 6991 (class 2606 OID 9467838)
-- Name: relacao_categoria_acervo_ref_cod_acervo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.relacao_categoria_acervo
    ADD CONSTRAINT relacao_categoria_acervo_ref_cod_acervo_fkey FOREIGN KEY (ref_cod_acervo) REFERENCES pmieducar.acervo(cod_acervo);


--
-- TOC entry 6994 (class 2606 OID 9467843)
-- Name: religiao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.religiao
    ADD CONSTRAINT religiao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6993 (class 2606 OID 9467848)
-- Name: religiao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.religiao
    ADD CONSTRAINT religiao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6998 (class 2606 OID 9467853)
-- Name: reserva_vaga_ref_cod_aluno_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.reserva_vaga
    ADD CONSTRAINT reserva_vaga_ref_cod_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES pmieducar.aluno(cod_aluno) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6997 (class 2606 OID 9467858)
-- Name: reserva_vaga_ref_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.reserva_vaga
    ADD CONSTRAINT reserva_vaga_ref_ref_cod_serie_fkey FOREIGN KEY (ref_ref_cod_serie, ref_ref_cod_escola) REFERENCES pmieducar.escola_serie(ref_cod_serie, ref_cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6996 (class 2606 OID 9467863)
-- Name: reserva_vaga_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.reserva_vaga
    ADD CONSTRAINT reserva_vaga_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6995 (class 2606 OID 9467868)
-- Name: reserva_vaga_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.reserva_vaga
    ADD CONSTRAINT reserva_vaga_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7001 (class 2606 OID 9467873)
-- Name: reservas_ref_cod_cliente_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.reservas
    ADD CONSTRAINT reservas_ref_cod_cliente_fkey FOREIGN KEY (ref_cod_cliente) REFERENCES pmieducar.cliente(cod_cliente) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7000 (class 2606 OID 9467878)
-- Name: reservas_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.reservas
    ADD CONSTRAINT reservas_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6999 (class 2606 OID 9467883)
-- Name: reservas_ref_usuario_libera_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.reservas
    ADD CONSTRAINT reservas_ref_usuario_libera_fkey FOREIGN KEY (ref_usuario_libera) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7006 (class 2606 OID 9467888)
-- Name: sequencia_serie_ref_serie_destino_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.sequencia_serie
    ADD CONSTRAINT sequencia_serie_ref_serie_destino_fkey FOREIGN KEY (ref_serie_destino) REFERENCES pmieducar.serie(cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7005 (class 2606 OID 9467893)
-- Name: sequencia_serie_ref_serie_origem_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.sequencia_serie
    ADD CONSTRAINT sequencia_serie_ref_serie_origem_fkey FOREIGN KEY (ref_serie_origem) REFERENCES pmieducar.serie(cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7004 (class 2606 OID 9467898)
-- Name: sequencia_serie_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.sequencia_serie
    ADD CONSTRAINT sequencia_serie_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7003 (class 2606 OID 9467903)
-- Name: sequencia_serie_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.sequencia_serie
    ADD CONSTRAINT sequencia_serie_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7014 (class 2606 OID 9467908)
-- Name: serie_pre_requisito_ref_cod_operador_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.serie_pre_requisito
    ADD CONSTRAINT serie_pre_requisito_ref_cod_operador_fkey FOREIGN KEY (ref_cod_operador) REFERENCES pmieducar.operador(cod_operador) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7013 (class 2606 OID 9467913)
-- Name: serie_pre_requisito_ref_cod_pre_requisito_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.serie_pre_requisito
    ADD CONSTRAINT serie_pre_requisito_ref_cod_pre_requisito_fkey FOREIGN KEY (ref_cod_pre_requisito) REFERENCES pmieducar.pre_requisito(cod_pre_requisito) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7012 (class 2606 OID 9467918)
-- Name: serie_pre_requisito_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.serie_pre_requisito
    ADD CONSTRAINT serie_pre_requisito_ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie) REFERENCES pmieducar.serie(cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7011 (class 2606 OID 9467923)
-- Name: serie_ref_cod_curso_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.serie
    ADD CONSTRAINT serie_ref_cod_curso_fkey FOREIGN KEY (ref_cod_curso) REFERENCES pmieducar.curso(cod_curso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7010 (class 2606 OID 9467928)
-- Name: serie_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.serie
    ADD CONSTRAINT serie_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7009 (class 2606 OID 9467933)
-- Name: serie_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.serie
    ADD CONSTRAINT serie_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7008 (class 2606 OID 9467938)
-- Name: serie_regra_avaliacao_diferenciada_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.serie
    ADD CONSTRAINT serie_regra_avaliacao_diferenciada_fk FOREIGN KEY (regra_avaliacao_diferenciada_id) REFERENCES modules.regra_avaliacao(id) ON DELETE RESTRICT;


--
-- TOC entry 7007 (class 2606 OID 9467943)
-- Name: serie_regra_avaliacao_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.serie
    ADD CONSTRAINT serie_regra_avaliacao_fk FOREIGN KEY (regra_avaliacao_id) REFERENCES modules.regra_avaliacao(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7018 (class 2606 OID 9467948)
-- Name: serie_vaga_ref_cod_curso_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.serie_vaga
    ADD CONSTRAINT serie_vaga_ref_cod_curso_fk FOREIGN KEY (ref_cod_curso) REFERENCES pmieducar.curso(cod_curso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7017 (class 2606 OID 9467953)
-- Name: serie_vaga_ref_cod_escola_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.serie_vaga
    ADD CONSTRAINT serie_vaga_ref_cod_escola_fk FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7016 (class 2606 OID 9467958)
-- Name: serie_vaga_ref_cod_instituicao_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.serie_vaga
    ADD CONSTRAINT serie_vaga_ref_cod_instituicao_fk FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7015 (class 2606 OID 9467963)
-- Name: serie_vaga_ref_cod_serie_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.serie_vaga
    ADD CONSTRAINT serie_vaga_ref_cod_serie_fk FOREIGN KEY (ref_cod_serie) REFERENCES pmieducar.serie(cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7032 (class 2606 OID 9467968)
-- Name: servidor_afastamento_ref_cod_motivo_afastamento_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_afastamento
    ADD CONSTRAINT servidor_afastamento_ref_cod_motivo_afastamento_fkey FOREIGN KEY (ref_cod_motivo_afastamento) REFERENCES pmieducar.motivo_afastamento(cod_motivo_afastamento) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7031 (class 2606 OID 9467973)
-- Name: servidor_afastamento_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_afastamento
    ADD CONSTRAINT servidor_afastamento_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES pmieducar.servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7030 (class 2606 OID 9467978)
-- Name: servidor_afastamento_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_afastamento
    ADD CONSTRAINT servidor_afastamento_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7029 (class 2606 OID 9467983)
-- Name: servidor_afastamento_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_afastamento
    ADD CONSTRAINT servidor_afastamento_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7036 (class 2606 OID 9467988)
-- Name: servidor_alocacao_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_alocacao
    ADD CONSTRAINT servidor_alocacao_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7035 (class 2606 OID 9467993)
-- Name: servidor_alocacao_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_alocacao
    ADD CONSTRAINT servidor_alocacao_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES pmieducar.servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7034 (class 2606 OID 9467998)
-- Name: servidor_alocacao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_alocacao
    ADD CONSTRAINT servidor_alocacao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7033 (class 2606 OID 9468003)
-- Name: servidor_alocacao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_alocacao
    ADD CONSTRAINT servidor_alocacao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7037 (class 2606 OID 9468008)
-- Name: servidor_curso_ref_cod_formacao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_curso
    ADD CONSTRAINT servidor_curso_ref_cod_formacao_fkey FOREIGN KEY (ref_cod_formacao) REFERENCES pmieducar.servidor_formacao(cod_formacao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7039 (class 2606 OID 9468013)
-- Name: servidor_cuso_ministra_ref_cod_curso_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_curso_ministra
    ADD CONSTRAINT servidor_cuso_ministra_ref_cod_curso_fkey FOREIGN KEY (ref_cod_curso) REFERENCES pmieducar.curso(cod_curso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7038 (class 2606 OID 9468018)
-- Name: servidor_cuso_ministra_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_curso_ministra
    ADD CONSTRAINT servidor_cuso_ministra_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES pmieducar.servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7041 (class 2606 OID 9468023)
-- Name: servidor_disciplina_ref_cod_disciplina_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_disciplina
    ADD CONSTRAINT servidor_disciplina_ref_cod_disciplina_fkey FOREIGN KEY (ref_cod_disciplina) REFERENCES modules.componente_curricular(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7040 (class 2606 OID 9468028)
-- Name: servidor_disciplina_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_disciplina
    ADD CONSTRAINT servidor_disciplina_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES pmieducar.servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7044 (class 2606 OID 9468033)
-- Name: servidor_formacao_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_formacao
    ADD CONSTRAINT servidor_formacao_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES pmieducar.servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7043 (class 2606 OID 9468038)
-- Name: servidor_formacao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_formacao
    ADD CONSTRAINT servidor_formacao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7042 (class 2606 OID 9468043)
-- Name: servidor_formacao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_formacao
    ADD CONSTRAINT servidor_formacao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7046 (class 2606 OID 9468048)
-- Name: servidor_funcao_ref_cod_funcao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_funcao
    ADD CONSTRAINT servidor_funcao_ref_cod_funcao_fkey FOREIGN KEY (ref_cod_funcao) REFERENCES pmieducar.funcao(cod_funcao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7045 (class 2606 OID 9468053)
-- Name: servidor_funcao_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_funcao
    ADD CONSTRAINT servidor_funcao_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES pmieducar.servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7023 (class 2606 OID 9468058)
-- Name: servidor_ref_cod_instituicao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor
    ADD CONSTRAINT servidor_ref_cod_instituicao_fkey FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7024 (class 2606 OID 9468063)
-- Name: servidor_ref_cod_subnivel_; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor
    ADD CONSTRAINT servidor_ref_cod_subnivel_ FOREIGN KEY (ref_cod_subnivel) REFERENCES pmieducar.subnivel(cod_subnivel) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7025 (class 2606 OID 9468068)
-- Name: servidor_ref_idesco_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor
    ADD CONSTRAINT servidor_ref_idesco_fkey FOREIGN KEY (ref_idesco) REFERENCES cadastro.escolaridade(idesco) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7047 (class 2606 OID 9468073)
-- Name: servidor_titulo_concurso_ref_cod_formacao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.servidor_titulo_concurso
    ADD CONSTRAINT servidor_titulo_concurso_ref_cod_formacao_fkey FOREIGN KEY (ref_cod_formacao) REFERENCES pmieducar.servidor_formacao(cod_formacao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7050 (class 2606 OID 9468078)
-- Name: situacao_ref_cod_biblioteca; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.situacao
    ADD CONSTRAINT situacao_ref_cod_biblioteca FOREIGN KEY (ref_cod_biblioteca) REFERENCES pmieducar.biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7049 (class 2606 OID 9468083)
-- Name: situacao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.situacao
    ADD CONSTRAINT situacao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7048 (class 2606 OID 9468088)
-- Name: situacao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.situacao
    ADD CONSTRAINT situacao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7054 (class 2606 OID 9468093)
-- Name: subnivel_ref_cod_nivel_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.subnivel
    ADD CONSTRAINT subnivel_ref_cod_nivel_fkey FOREIGN KEY (ref_cod_nivel) REFERENCES pmieducar.nivel(cod_nivel) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7053 (class 2606 OID 9468098)
-- Name: subnivel_ref_cod_subnivel_anterior_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.subnivel
    ADD CONSTRAINT subnivel_ref_cod_subnivel_anterior_fkey FOREIGN KEY (ref_cod_subnivel_anterior) REFERENCES pmieducar.subnivel(cod_subnivel) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7052 (class 2606 OID 9468103)
-- Name: subnivel_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.subnivel
    ADD CONSTRAINT subnivel_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7051 (class 2606 OID 9468108)
-- Name: subnivel_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.subnivel
    ADD CONSTRAINT subnivel_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7057 (class 2606 OID 9468113)
-- Name: tipo_avaliacao_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_avaliacao
    ADD CONSTRAINT tipo_avaliacao_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7056 (class 2606 OID 9468118)
-- Name: tipo_avaliacao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_avaliacao
    ADD CONSTRAINT tipo_avaliacao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7055 (class 2606 OID 9468123)
-- Name: tipo_avaliacao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_avaliacao
    ADD CONSTRAINT tipo_avaliacao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7058 (class 2606 OID 9468128)
-- Name: tipo_avaliacao_valores_ref_cod_tipo_avaliacao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_avaliacao_valores
    ADD CONSTRAINT tipo_avaliacao_valores_ref_cod_tipo_avaliacao_fkey FOREIGN KEY (ref_cod_tipo_avaliacao) REFERENCES pmieducar.tipo_avaliacao(cod_tipo_avaliacao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7061 (class 2606 OID 9468133)
-- Name: tipo_dispensa_ref_cod_instituicao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_dispensa
    ADD CONSTRAINT tipo_dispensa_ref_cod_instituicao_fkey FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7060 (class 2606 OID 9468138)
-- Name: tipo_dispensa_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_dispensa
    ADD CONSTRAINT tipo_dispensa_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7059 (class 2606 OID 9468143)
-- Name: tipo_dispensa_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_dispensa
    ADD CONSTRAINT tipo_dispensa_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7064 (class 2606 OID 9468148)
-- Name: tipo_ensino_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_ensino
    ADD CONSTRAINT tipo_ensino_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7063 (class 2606 OID 9468153)
-- Name: tipo_ensino_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_ensino
    ADD CONSTRAINT tipo_ensino_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7062 (class 2606 OID 9468158)
-- Name: tipo_ensino_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_ensino
    ADD CONSTRAINT tipo_ensino_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7067 (class 2606 OID 9468163)
-- Name: tipo_ocorrencia_disciplinar_ref_cod_instituicao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_ocorrencia_disciplinar
    ADD CONSTRAINT tipo_ocorrencia_disciplinar_ref_cod_instituicao_fkey FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7066 (class 2606 OID 9468168)
-- Name: tipo_ocorrencia_disciplinar_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_ocorrencia_disciplinar
    ADD CONSTRAINT tipo_ocorrencia_disciplinar_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7065 (class 2606 OID 9468173)
-- Name: tipo_ocorrencia_disciplinar_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_ocorrencia_disciplinar
    ADD CONSTRAINT tipo_ocorrencia_disciplinar_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7070 (class 2606 OID 9468178)
-- Name: tipo_regime_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_regime
    ADD CONSTRAINT tipo_regime_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7069 (class 2606 OID 9468183)
-- Name: tipo_regime_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_regime
    ADD CONSTRAINT tipo_regime_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7068 (class 2606 OID 9468188)
-- Name: tipo_regime_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_regime
    ADD CONSTRAINT tipo_regime_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7072 (class 2606 OID 9468193)
-- Name: tipo_usuario_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_usuario
    ADD CONSTRAINT tipo_usuario_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7071 (class 2606 OID 9468198)
-- Name: tipo_usuario_ref_funcionario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.tipo_usuario
    ADD CONSTRAINT tipo_usuario_ref_funcionario_exc_fkey FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7077 (class 2606 OID 9468203)
-- Name: transferencia_solicitacao_ref_cod_matricula_entrada_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.transferencia_solicitacao
    ADD CONSTRAINT transferencia_solicitacao_ref_cod_matricula_entrada_fkey FOREIGN KEY (ref_cod_matricula_entrada) REFERENCES pmieducar.matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7076 (class 2606 OID 9468208)
-- Name: transferencia_solicitacao_ref_cod_matricula_saida_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.transferencia_solicitacao
    ADD CONSTRAINT transferencia_solicitacao_ref_cod_matricula_saida_fkey FOREIGN KEY (ref_cod_matricula_saida) REFERENCES pmieducar.matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7075 (class 2606 OID 9468213)
-- Name: transferencia_solicitacao_ref_cod_transferencia_tipo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.transferencia_solicitacao
    ADD CONSTRAINT transferencia_solicitacao_ref_cod_transferencia_tipo_fkey FOREIGN KEY (ref_cod_transferencia_tipo) REFERENCES pmieducar.transferencia_tipo(cod_transferencia_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7074 (class 2606 OID 9468218)
-- Name: transferencia_solicitacao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.transferencia_solicitacao
    ADD CONSTRAINT transferencia_solicitacao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7073 (class 2606 OID 9468223)
-- Name: transferencia_solicitacao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.transferencia_solicitacao
    ADD CONSTRAINT transferencia_solicitacao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7080 (class 2606 OID 9468228)
-- Name: transferencia_tipo_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.transferencia_tipo
    ADD CONSTRAINT transferencia_tipo_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7079 (class 2606 OID 9468233)
-- Name: transferencia_tipo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.transferencia_tipo
    ADD CONSTRAINT transferencia_tipo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7078 (class 2606 OID 9468238)
-- Name: transferencia_tipo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.transferencia_tipo
    ADD CONSTRAINT transferencia_tipo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7082 (class 2606 OID 9468248)
-- Name: turma_escola_serie_muil; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma
    ADD CONSTRAINT turma_escola_serie_muil FOREIGN KEY (ref_ref_cod_serie_mult, ref_ref_cod_escola_mult) REFERENCES pmieducar.escola_serie(ref_cod_serie, ref_cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7093 (class 2606 OID 9468253)
-- Name: turma_modulo_ref_cod_modulo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma_modulo
    ADD CONSTRAINT turma_modulo_ref_cod_modulo_fkey FOREIGN KEY (ref_cod_modulo) REFERENCES pmieducar.modulo(cod_modulo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7092 (class 2606 OID 9468258)
-- Name: turma_modulo_ref_cod_turma_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma_modulo
    ADD CONSTRAINT turma_modulo_ref_cod_turma_fkey FOREIGN KEY (ref_cod_turma) REFERENCES pmieducar.turma(cod_turma) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7083 (class 2606 OID 9468263)
-- Name: turma_ref_cod_curso; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma
    ADD CONSTRAINT turma_ref_cod_curso FOREIGN KEY (ref_cod_curso) REFERENCES pmieducar.curso(cod_curso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7084 (class 2606 OID 9468268)
-- Name: turma_ref_cod_infra_predio_comodo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma
    ADD CONSTRAINT turma_ref_cod_infra_predio_comodo_fkey FOREIGN KEY (ref_cod_infra_predio_comodo) REFERENCES pmieducar.infra_predio_comodo(cod_infra_predio_comodo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7085 (class 2606 OID 9468273)
-- Name: turma_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma
    ADD CONSTRAINT turma_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7086 (class 2606 OID 9468278)
-- Name: turma_ref_cod_regente; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma
    ADD CONSTRAINT turma_ref_cod_regente FOREIGN KEY (ref_cod_regente, ref_cod_instituicao_regente) REFERENCES pmieducar.servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7087 (class 2606 OID 9468283)
-- Name: turma_ref_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma
    ADD CONSTRAINT turma_ref_ref_cod_escola_fkey FOREIGN KEY (ref_ref_cod_escola, ref_ref_cod_serie) REFERENCES pmieducar.escola_serie(ref_cod_escola, ref_cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7088 (class 2606 OID 9468288)
-- Name: turma_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma
    ADD CONSTRAINT turma_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7089 (class 2606 OID 9468293)
-- Name: turma_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma
    ADD CONSTRAINT turma_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7095 (class 2606 OID 9468298)
-- Name: turma_tipo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma_tipo
    ADD CONSTRAINT turma_tipo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7094 (class 2606 OID 9468303)
-- Name: turma_tipo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma_tipo
    ADD CONSTRAINT turma_tipo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES pmieducar.usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7090 (class 2606 OID 9468308)
-- Name: turma_turma_tipo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma
    ADD CONSTRAINT turma_turma_tipo_fkey FOREIGN KEY (ref_cod_turma_tipo) REFERENCES pmieducar.turma_tipo(cod_turma_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7091 (class 2606 OID 9468313)
-- Name: turma_turno_id_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.turma
    ADD CONSTRAINT turma_turno_id_fkey FOREIGN KEY (turma_turno_id) REFERENCES pmieducar.turma_turno(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7100 (class 2606 OID 9468318)
-- Name: usuario_cod_usuario_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.usuario
    ADD CONSTRAINT usuario_cod_usuario_fkey FOREIGN KEY (cod_usuario) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7099 (class 2606 OID 9468323)
-- Name: usuario_ref_cod_instituicao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.usuario
    ADD CONSTRAINT usuario_ref_cod_instituicao_fkey FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7098 (class 2606 OID 9468328)
-- Name: usuario_ref_cod_tipo_usuario_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.usuario
    ADD CONSTRAINT usuario_ref_cod_tipo_usuario_fkey FOREIGN KEY (ref_cod_tipo_usuario) REFERENCES pmieducar.tipo_usuario(cod_tipo_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7097 (class 2606 OID 9468333)
-- Name: usuario_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.usuario
    ADD CONSTRAINT usuario_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7096 (class 2606 OID 9468338)
-- Name: usuario_ref_funcionario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: -
--

ALTER TABLE ONLY pmieducar.usuario
    ADD CONSTRAINT usuario_ref_funcionario_exc_fkey FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7101 (class 2606 OID 9468343)
-- Name: funcionario_su_ref_ref_cod_pessoa_fj_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.funcionario_su
    ADD CONSTRAINT funcionario_su_ref_ref_cod_pessoa_fj_fkey FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 7105 (class 2606 OID 9468348)
-- Name: grupomoderador_ref_cod_grupos_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.grupomoderador
    ADD CONSTRAINT grupomoderador_ref_cod_grupos_fkey FOREIGN KEY (ref_cod_grupos) REFERENCES pmiotopic.grupos(cod_grupos) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7104 (class 2606 OID 9468353)
-- Name: grupomoderador_ref_pessoa_cad_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.grupomoderador
    ADD CONSTRAINT grupomoderador_ref_pessoa_cad_fkey FOREIGN KEY (ref_pessoa_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7103 (class 2606 OID 9468358)
-- Name: grupomoderador_ref_pessoa_exc_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.grupomoderador
    ADD CONSTRAINT grupomoderador_ref_pessoa_exc_fkey FOREIGN KEY (ref_pessoa_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7102 (class 2606 OID 9468363)
-- Name: grupomoderador_ref_ref_cod_pessoa_fj_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.grupomoderador
    ADD CONSTRAINT grupomoderador_ref_ref_cod_pessoa_fj_fkey FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7109 (class 2606 OID 9468368)
-- Name: grupopessoa_ref_cod_grupos_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.grupopessoa
    ADD CONSTRAINT grupopessoa_ref_cod_grupos_fkey FOREIGN KEY (ref_cod_grupos) REFERENCES pmiotopic.grupos(cod_grupos) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7108 (class 2606 OID 9468373)
-- Name: grupopessoa_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.grupopessoa
    ADD CONSTRAINT grupopessoa_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7107 (class 2606 OID 9468378)
-- Name: grupopessoa_ref_pessoa_cadatro_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.grupopessoa
    ADD CONSTRAINT grupopessoa_ref_pessoa_cadatro_fkey FOREIGN KEY (ref_pessoa_cad, ref_grupos_cad) REFERENCES pmiotopic.grupomoderador(ref_ref_cod_pessoa_fj, ref_cod_grupos) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7106 (class 2606 OID 9468383)
-- Name: grupopessoa_ref_pessoa_exclusao_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.grupopessoa
    ADD CONSTRAINT grupopessoa_ref_pessoa_exclusao_fkey FOREIGN KEY (ref_pessoa_exc, ref_grupos_exc) REFERENCES pmiotopic.grupomoderador(ref_ref_cod_pessoa_fj, ref_cod_grupos) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7111 (class 2606 OID 9468388)
-- Name: grupos_ref_pessoa_cad_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.grupos
    ADD CONSTRAINT grupos_ref_pessoa_cad_fkey FOREIGN KEY (ref_pessoa_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7110 (class 2606 OID 9468393)
-- Name: grupos_ref_pessoa_exc_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.grupos
    ADD CONSTRAINT grupos_ref_pessoa_exc_fkey FOREIGN KEY (ref_pessoa_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7114 (class 2606 OID 9468398)
-- Name: notas_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.notas
    ADD CONSTRAINT notas_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7113 (class 2606 OID 9468403)
-- Name: notas_ref_pessoa_cad_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.notas
    ADD CONSTRAINT notas_ref_pessoa_cad_fkey FOREIGN KEY (ref_pessoa_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7112 (class 2606 OID 9468408)
-- Name: notas_ref_pessoa_exc_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.notas
    ADD CONSTRAINT notas_ref_pessoa_exc_fkey FOREIGN KEY (ref_pessoa_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7116 (class 2606 OID 9468413)
-- Name: participante_ref_cod_reuniao_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.participante
    ADD CONSTRAINT participante_ref_cod_reuniao_fkey FOREIGN KEY (ref_cod_reuniao) REFERENCES pmiotopic.reuniao(cod_reuniao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7115 (class 2606 OID 9468418)
-- Name: participante_ref_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.participante
    ADD CONSTRAINT participante_ref_ref_idpes_fkey FOREIGN KEY (ref_ref_idpes, ref_ref_cod_grupos) REFERENCES pmiotopic.grupopessoa(ref_idpes, ref_cod_grupos) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7117 (class 2606 OID 9468423)
-- Name: reuniao_ref_moderador_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.reuniao
    ADD CONSTRAINT reuniao_ref_moderador_fkey FOREIGN KEY (ref_moderador, ref_grupos_moderador) REFERENCES pmiotopic.grupomoderador(ref_ref_cod_pessoa_fj, ref_cod_grupos) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7119 (class 2606 OID 9468428)
-- Name: topicoreuniao_ref_cod_reuniao_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.topicoreuniao
    ADD CONSTRAINT topicoreuniao_ref_cod_reuniao_fkey FOREIGN KEY (ref_cod_reuniao) REFERENCES pmiotopic.reuniao(cod_reuniao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7118 (class 2606 OID 9468433)
-- Name: topicoreuniao_ref_cod_topico_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: -
--

ALTER TABLE ONLY pmiotopic.topicoreuniao
    ADD CONSTRAINT topicoreuniao_ref_cod_topico_fkey FOREIGN KEY (ref_cod_topico) REFERENCES pmiotopic.topico(cod_topico) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7124 (class 2606 OID 9468438)
-- Name: agenda_compromisso_ref_cod_agenda_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.agenda_compromisso
    ADD CONSTRAINT agenda_compromisso_ref_cod_agenda_fkey FOREIGN KEY (ref_cod_agenda) REFERENCES portal.agenda(cod_agenda) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7123 (class 2606 OID 9468443)
-- Name: agenda_compromisso_ref_ref_cod_pessoa_cad_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.agenda_compromisso
    ADD CONSTRAINT agenda_compromisso_ref_ref_cod_pessoa_cad_fkey FOREIGN KEY (ref_ref_cod_pessoa_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7122 (class 2606 OID 9468448)
-- Name: agenda_ref_ref_cod_pessoa_cad_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.agenda
    ADD CONSTRAINT agenda_ref_ref_cod_pessoa_cad_fkey FOREIGN KEY (ref_ref_cod_pessoa_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7121 (class 2606 OID 9468453)
-- Name: agenda_ref_ref_cod_pessoa_exc_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.agenda
    ADD CONSTRAINT agenda_ref_ref_cod_pessoa_exc_fkey FOREIGN KEY (ref_ref_cod_pessoa_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7120 (class 2606 OID 9468458)
-- Name: agenda_ref_ref_cod_pessoa_own_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.agenda
    ADD CONSTRAINT agenda_ref_ref_cod_pessoa_own_fkey FOREIGN KEY (ref_ref_cod_pessoa_own) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7126 (class 2606 OID 9468463)
-- Name: agenda_responsavel_ref_cod_agenda_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.agenda_responsavel
    ADD CONSTRAINT agenda_responsavel_ref_cod_agenda_fkey FOREIGN KEY (ref_cod_agenda) REFERENCES portal.agenda(cod_agenda) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7125 (class 2606 OID 9468468)
-- Name: agenda_responsavel_ref_ref_cod_pessoa_fj_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.agenda_responsavel
    ADD CONSTRAINT agenda_responsavel_ref_ref_cod_pessoa_fj_fkey FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7130 (class 2606 OID 9468473)
-- Name: compras_editais_editais_empresas_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_editais_editais_empresas
    ADD CONSTRAINT compras_editais_editais_empresas_ibfk_1 FOREIGN KEY (ref_cod_compras_editais_editais) REFERENCES portal.compras_editais_editais(cod_compras_editais_editais) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7129 (class 2606 OID 9468478)
-- Name: compras_editais_editais_empresas_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_editais_editais_empresas
    ADD CONSTRAINT compras_editais_editais_empresas_ibfk_2 FOREIGN KEY (ref_cod_compras_editais_empresa) REFERENCES portal.compras_editais_empresa(cod_compras_editais_empresa) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7128 (class 2606 OID 9468483)
-- Name: compras_editais_editais_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_editais_editais
    ADD CONSTRAINT compras_editais_editais_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7127 (class 2606 OID 9468488)
-- Name: compras_editais_editais_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_editais_editais
    ADD CONSTRAINT compras_editais_editais_ibfk_2 FOREIGN KEY (ref_cod_compras_licitacoes) REFERENCES portal.compras_licitacoes(cod_compras_licitacoes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7131 (class 2606 OID 9468493)
-- Name: compras_editais_empresa_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_editais_empresa
    ADD CONSTRAINT compras_editais_empresa_ibfk_1 FOREIGN KEY (ref_sigla_uf) REFERENCES public.uf(sigla_uf) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7132 (class 2606 OID 9468498)
-- Name: compras_funcionarios_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_funcionarios
    ADD CONSTRAINT compras_funcionarios_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7134 (class 2606 OID 9468503)
-- Name: compras_licitacoes_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_licitacoes
    ADD CONSTRAINT compras_licitacoes_ibfk_1 FOREIGN KEY (ref_cod_compras_modalidade) REFERENCES portal.compras_modalidade(cod_compras_modalidade) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7133 (class 2606 OID 9468508)
-- Name: compras_licitacoes_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_licitacoes
    ADD CONSTRAINT compras_licitacoes_ibfk_2 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7140 (class 2606 OID 9468513)
-- Name: compras_pregao_execucao_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_pregao_execucao
    ADD CONSTRAINT compras_pregao_execucao_ibfk_1 FOREIGN KEY (ref_equipe3) REFERENCES portal.compras_funcionarios(ref_ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7139 (class 2606 OID 9468518)
-- Name: compras_pregao_execucao_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_pregao_execucao
    ADD CONSTRAINT compras_pregao_execucao_ibfk_2 FOREIGN KEY (ref_pregoeiro) REFERENCES portal.compras_funcionarios(ref_ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7138 (class 2606 OID 9468523)
-- Name: compras_pregao_execucao_ibfk_3; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_pregao_execucao
    ADD CONSTRAINT compras_pregao_execucao_ibfk_3 FOREIGN KEY (ref_equipe1) REFERENCES portal.compras_funcionarios(ref_ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7137 (class 2606 OID 9468528)
-- Name: compras_pregao_execucao_ibfk_4; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_pregao_execucao
    ADD CONSTRAINT compras_pregao_execucao_ibfk_4 FOREIGN KEY (ref_equipe2) REFERENCES portal.compras_funcionarios(ref_ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7136 (class 2606 OID 9468533)
-- Name: compras_pregao_execucao_ibfk_5; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_pregao_execucao
    ADD CONSTRAINT compras_pregao_execucao_ibfk_5 FOREIGN KEY (ref_cod_compras_final_pregao) REFERENCES portal.compras_final_pregao(cod_compras_final_pregao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7135 (class 2606 OID 9468538)
-- Name: compras_pregao_execucao_ibfk_6; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.compras_pregao_execucao
    ADD CONSTRAINT compras_pregao_execucao_ibfk_6 FOREIGN KEY (ref_cod_compras_licitacoes) REFERENCES portal.compras_licitacoes(cod_compras_licitacoes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7145 (class 2606 OID 9468543)
-- Name: fk_to_setor_new; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.funcionario
    ADD CONSTRAINT fk_to_setor_new FOREIGN KEY (ref_cod_setor_new) REFERENCES pmidrh.setor(cod_setor) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7142 (class 2606 OID 9468548)
-- Name: foto_portal_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.foto_portal
    ADD CONSTRAINT foto_portal_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7141 (class 2606 OID 9468553)
-- Name: foto_portal_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.foto_portal
    ADD CONSTRAINT foto_portal_ibfk_2 FOREIGN KEY (ref_cod_credito) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7144 (class 2606 OID 9468558)
-- Name: funcionario_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.funcionario
    ADD CONSTRAINT funcionario_ibfk_1 FOREIGN KEY (ref_cod_pessoa_fj) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7143 (class 2606 OID 9468563)
-- Name: funcionario_ibfk_5; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.funcionario
    ADD CONSTRAINT funcionario_ibfk_5 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7148 (class 2606 OID 9468568)
-- Name: imagem_ref_cod_imagem_tipo_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.imagem
    ADD CONSTRAINT imagem_ref_cod_imagem_tipo_fkey FOREIGN KEY (ref_cod_imagem_tipo) REFERENCES portal.imagem_tipo(cod_imagem_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7147 (class 2606 OID 9468573)
-- Name: imagem_ref_cod_pessoa_cad_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.imagem
    ADD CONSTRAINT imagem_ref_cod_pessoa_cad_fkey FOREIGN KEY (ref_cod_pessoa_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7146 (class 2606 OID 9468578)
-- Name: imagem_ref_cod_pessoa_exc_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.imagem
    ADD CONSTRAINT imagem_ref_cod_pessoa_exc_fkey FOREIGN KEY (ref_cod_pessoa_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7149 (class 2606 OID 9468583)
-- Name: intranet_segur_permissao_negada_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.intranet_segur_permissao_negada
    ADD CONSTRAINT intranet_segur_permissao_negada_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7150 (class 2606 OID 9468588)
-- Name: jor_arquivo_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.jor_arquivo
    ADD CONSTRAINT jor_arquivo_ibfk_1 FOREIGN KEY (ref_cod_jor_edicao) REFERENCES portal.jor_edicao(cod_jor_edicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7151 (class 2606 OID 9468593)
-- Name: jor_edicao_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.jor_edicao
    ADD CONSTRAINT jor_edicao_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7152 (class 2606 OID 9468598)
-- Name: mailling_email_conteudo_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.mailling_email_conteudo
    ADD CONSTRAINT mailling_email_conteudo_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7155 (class 2606 OID 9468603)
-- Name: mailling_fila_envio_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.mailling_fila_envio
    ADD CONSTRAINT mailling_fila_envio_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7154 (class 2606 OID 9468608)
-- Name: mailling_fila_envio_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.mailling_fila_envio
    ADD CONSTRAINT mailling_fila_envio_ibfk_2 FOREIGN KEY (ref_cod_mailling_email) REFERENCES portal.mailling_email(cod_mailling_email);


--
-- TOC entry 7153 (class 2606 OID 9468613)
-- Name: mailling_fila_envio_ibfk_3; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.mailling_fila_envio
    ADD CONSTRAINT mailling_fila_envio_ibfk_3 FOREIGN KEY (ref_cod_mailling_email_conteudo) REFERENCES portal.mailling_email_conteudo(cod_mailling_email_conteudo);


--
-- TOC entry 7157 (class 2606 OID 9468618)
-- Name: mailling_grupo_email_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.mailling_grupo_email
    ADD CONSTRAINT mailling_grupo_email_ibfk_1 FOREIGN KEY (ref_cod_mailling_email) REFERENCES portal.mailling_email(cod_mailling_email) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7156 (class 2606 OID 9468623)
-- Name: mailling_grupo_email_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.mailling_grupo_email
    ADD CONSTRAINT mailling_grupo_email_ibfk_2 FOREIGN KEY (ref_cod_mailling_grupo) REFERENCES portal.mailling_grupo(cod_mailling_grupo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7160 (class 2606 OID 9468628)
-- Name: mailling_historico_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.mailling_historico
    ADD CONSTRAINT mailling_historico_ibfk_1 FOREIGN KEY (ref_cod_not_portal) REFERENCES portal.not_portal(cod_not_portal) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7159 (class 2606 OID 9468633)
-- Name: mailling_historico_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.mailling_historico
    ADD CONSTRAINT mailling_historico_ibfk_2 FOREIGN KEY (ref_cod_mailling_grupo) REFERENCES portal.mailling_grupo(cod_mailling_grupo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7158 (class 2606 OID 9468638)
-- Name: mailling_historico_ibfk_3; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.mailling_historico
    ADD CONSTRAINT mailling_historico_ibfk_3 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7161 (class 2606 OID 9468973)
-- Name: menu_funcionario_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.menu_funcionario
    ADD CONSTRAINT menu_funcionario_ibfk_1 FOREIGN KEY (ref_cod_menu_submenu) REFERENCES portal.menu_submenu(cod_menu_submenu) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7162 (class 2606 OID 9468643)
-- Name: menu_funcionario_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.menu_funcionario
    ADD CONSTRAINT menu_funcionario_ibfk_2 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7164 (class 2606 OID 9468648)
-- Name: menu_submenu_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.menu_submenu
    ADD CONSTRAINT menu_submenu_ibfk_1 FOREIGN KEY (ref_cod_menu_menu) REFERENCES portal.menu_menu(cod_menu_menu) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7165 (class 2606 OID 9468653)
-- Name: not_portal_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.not_portal
    ADD CONSTRAINT not_portal_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7167 (class 2606 OID 9468658)
-- Name: not_portal_tipo_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.not_portal_tipo
    ADD CONSTRAINT not_portal_tipo_ibfk_1 FOREIGN KEY (ref_cod_not_portal) REFERENCES portal.not_portal(cod_not_portal) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7166 (class 2606 OID 9468663)
-- Name: not_portal_tipo_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.not_portal_tipo
    ADD CONSTRAINT not_portal_tipo_ibfk_2 FOREIGN KEY (ref_cod_not_tipo) REFERENCES portal.not_tipo(cod_not_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7168 (class 2606 OID 9468668)
-- Name: not_vinc_portal_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.not_vinc_portal
    ADD CONSTRAINT not_vinc_portal_ibfk_1 FOREIGN KEY (ref_cod_not_portal) REFERENCES portal.not_portal(cod_not_portal) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7169 (class 2606 OID 9468673)
-- Name: notificacao_ref_cod_funcionario_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.notificacao
    ADD CONSTRAINT notificacao_ref_cod_funcionario_fkey FOREIGN KEY (ref_cod_funcionario) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7170 (class 2606 OID 9468678)
-- Name: pessoa_atividade_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.pessoa_atividade
    ADD CONSTRAINT pessoa_atividade_ibfk_1 FOREIGN KEY (ref_cod_ramo_atividade) REFERENCES portal.pessoa_ramo_atividade(cod_ramo_atividade) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7172 (class 2606 OID 9468683)
-- Name: pessoa_fj_pessoa_atividade_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.pessoa_fj_pessoa_atividade
    ADD CONSTRAINT pessoa_fj_pessoa_atividade_ibfk_1 FOREIGN KEY (ref_cod_pessoa_atividade) REFERENCES portal.pessoa_atividade(cod_pessoa_atividade) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7171 (class 2606 OID 9468688)
-- Name: pessoa_fj_pessoa_atividade_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.pessoa_fj_pessoa_atividade
    ADD CONSTRAINT pessoa_fj_pessoa_atividade_ibfk_2 FOREIGN KEY (ref_cod_pessoa_fj) REFERENCES cadastro.juridica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7173 (class 2606 OID 9468693)
-- Name: portal_concurso_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.portal_concurso
    ADD CONSTRAINT portal_concurso_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7163 (class 2606 OID 9468698)
-- Name: ref_cod_menu_pai_fk; Type: FK CONSTRAINT; Schema: portal; Owner: -
--

ALTER TABLE ONLY portal.menu_menu
    ADD CONSTRAINT ref_cod_menu_pai_fk FOREIGN KEY (ref_cod_menu_pai) REFERENCES portal.menu_menu(cod_menu_menu) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6568 (class 2606 OID 9468703)
-- Name: bairro_idsetorbai_fk; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.bairro
    ADD CONSTRAINT bairro_idsetorbai_fk FOREIGN KEY (idsetorbai) REFERENCES public.setor_bai(idsetorbai);


--
-- TOC entry 7175 (class 2606 OID 9468708)
-- Name: bairro_regiao_ref_cod_regiao_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.bairro_regiao
    ADD CONSTRAINT bairro_regiao_ref_cod_regiao_fkey FOREIGN KEY (ref_cod_regiao) REFERENCES public.regiao(cod_regiao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7174 (class 2606 OID 9468713)
-- Name: bairro_regiao_ref_idbai_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.bairro_regiao
    ADD CONSTRAINT bairro_regiao_ref_idbai_fkey FOREIGN KEY (ref_idbai) REFERENCES public.bairro(idbai) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6569 (class 2606 OID 9468718)
-- Name: fk_bairro_distrito; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.bairro
    ADD CONSTRAINT fk_bairro_distrito FOREIGN KEY (iddis) REFERENCES public.distrito(iddis);


--
-- TOC entry 6570 (class 2606 OID 9468723)
-- Name: fk_bairro_municipio; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.bairro
    ADD CONSTRAINT fk_bairro_municipio FOREIGN KEY (idmun) REFERENCES public.municipio(idmun);


--
-- TOC entry 6571 (class 2606 OID 9468728)
-- Name: fk_bairro_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.bairro
    ADD CONSTRAINT fk_bairro_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6572 (class 2606 OID 9468733)
-- Name: fk_bairro_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.bairro
    ADD CONSTRAINT fk_bairro_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6573 (class 2606 OID 9468738)
-- Name: fk_bairro_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.bairro
    ADD CONSTRAINT fk_bairro_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6574 (class 2606 OID 9468743)
-- Name: fk_bairro_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.bairro
    ADD CONSTRAINT fk_bairro_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 7180 (class 2606 OID 9468748)
-- Name: fk_distrito_municipio; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.distrito
    ADD CONSTRAINT fk_distrito_municipio FOREIGN KEY (idmun) REFERENCES public.municipio(idmun);


--
-- TOC entry 7179 (class 2606 OID 9468753)
-- Name: fk_distrito_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.distrito
    ADD CONSTRAINT fk_distrito_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 7178 (class 2606 OID 9468758)
-- Name: fk_distrito_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.distrito
    ADD CONSTRAINT fk_distrito_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 7177 (class 2606 OID 9468763)
-- Name: fk_distrito_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.distrito
    ADD CONSTRAINT fk_distrito_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 7176 (class 2606 OID 9468768)
-- Name: fk_distrito_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.distrito
    ADD CONSTRAINT fk_distrito_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 7181 (class 2606 OID 9468773)
-- Name: fk_logr_logr_fonetico; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.logradouro_fonetico
    ADD CONSTRAINT fk_logr_logr_fonetico FOREIGN KEY (idlog) REFERENCES public.logradouro(idlog);


--
-- TOC entry 6580 (class 2606 OID 9468778)
-- Name: fk_logradouro_municipio; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.municipio
    ADD CONSTRAINT fk_logradouro_municipio FOREIGN KEY (idmun) REFERENCES public.municipio(idmun);


--
-- TOC entry 6579 (class 2606 OID 9468783)
-- Name: fk_logradouro_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.logradouro
    ADD CONSTRAINT fk_logradouro_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6578 (class 2606 OID 9468788)
-- Name: fk_logradouro_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.logradouro
    ADD CONSTRAINT fk_logradouro_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6577 (class 2606 OID 9468793)
-- Name: fk_logradouro_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.logradouro
    ADD CONSTRAINT fk_logradouro_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6576 (class 2606 OID 9468798)
-- Name: fk_logradouro_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.logradouro
    ADD CONSTRAINT fk_logradouro_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6575 (class 2606 OID 9468803)
-- Name: fk_logradouro_tipo_log; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.logradouro
    ADD CONSTRAINT fk_logradouro_tipo_log FOREIGN KEY (idtlog) REFERENCES urbano.tipo_logradouro(idtlog);


--
-- TOC entry 6581 (class 2606 OID 9468808)
-- Name: fk_municipio_municipiopai; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.municipio
    ADD CONSTRAINT fk_municipio_municipiopai FOREIGN KEY (idmun_pai) REFERENCES public.municipio(idmun);


--
-- TOC entry 6582 (class 2606 OID 9468813)
-- Name: fk_municipio_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.municipio
    ADD CONSTRAINT fk_municipio_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6583 (class 2606 OID 9468818)
-- Name: fk_municipio_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.municipio
    ADD CONSTRAINT fk_municipio_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 6584 (class 2606 OID 9468823)
-- Name: fk_municipio_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.municipio
    ADD CONSTRAINT fk_municipio_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6585 (class 2606 OID 9468828)
-- Name: fk_municipio_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.municipio
    ADD CONSTRAINT fk_municipio_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 6586 (class 2606 OID 9468833)
-- Name: fk_municipio_uf; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.municipio
    ADD CONSTRAINT fk_municipio_uf FOREIGN KEY (sigla_uf) REFERENCES public.uf(sigla_uf);


--
-- TOC entry 7183 (class 2606 OID 9468838)
-- Name: fk_setor_idsetredir; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.setor
    ADD CONSTRAINT fk_setor_idsetredir FOREIGN KEY (idsetredir) REFERENCES public.setor(idset) ON DELETE RESTRICT;


--
-- TOC entry 7182 (class 2606 OID 9468843)
-- Name: fk_setor_idsetsub; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.setor
    ADD CONSTRAINT fk_setor_idsetsub FOREIGN KEY (idsetsub) REFERENCES public.setor(idset) ON DELETE CASCADE;


--
-- TOC entry 7184 (class 2606 OID 9468848)
-- Name: fk_uf_pais; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.uf
    ADD CONSTRAINT fk_uf_pais FOREIGN KEY (idpais) REFERENCES public.pais(idpais);


--
-- TOC entry 7185 (class 2606 OID 9468853)
-- Name: fk_vila_municipio; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.vila
    ADD CONSTRAINT fk_vila_municipio FOREIGN KEY (idmun) REFERENCES public.municipio(idmun);


--
-- TOC entry 7186 (class 2606 OID 9468858)
-- Name: aluno_cod_aluno_cod_aluno_fk; Type: FK CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.aluno_cod_aluno
    ADD CONSTRAINT aluno_cod_aluno_cod_aluno_fk FOREIGN KEY (cod_aluno) REFERENCES pmieducar.aluno(cod_aluno) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7187 (class 2606 OID 9468863)
-- Name: aluno_uniforme_ref_cod_aluno_fkey; Type: FK CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.aluno_uniforme
    ADD CONSTRAINT aluno_uniforme_ref_cod_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES pmieducar.aluno(cod_aluno) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7188 (class 2606 OID 9468868)
-- Name: escola_agua_ref_cod_escola_fk; Type: FK CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.escola_agua
    ADD CONSTRAINT escola_agua_ref_cod_escola_fk FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7189 (class 2606 OID 9468873)
-- Name: escola_energia_ref_cod_escola_fk; Type: FK CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.escola_energia
    ADD CONSTRAINT escola_energia_ref_cod_escola_fk FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7190 (class 2606 OID 9468878)
-- Name: escola_lingua_indigena_ref_cod_escola_fk; Type: FK CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.escola_lingua_indigena
    ADD CONSTRAINT escola_lingua_indigena_ref_cod_escola_fk FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7191 (class 2606 OID 9468883)
-- Name: escola_lixo_ref_cod_escola_fk; Type: FK CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.escola_lixo
    ADD CONSTRAINT escola_lixo_ref_cod_escola_fk FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7192 (class 2606 OID 9468888)
-- Name: escola_projeto_ref_cod_escola_fk; Type: FK CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.escola_projeto
    ADD CONSTRAINT escola_projeto_ref_cod_escola_fk FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7193 (class 2606 OID 9468893)
-- Name: escola_regulamentacao_ref_cod_escola_fk; Type: FK CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.escola_regulamentacao
    ADD CONSTRAINT escola_regulamentacao_ref_cod_escola_fk FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7194 (class 2606 OID 9468898)
-- Name: escola_sanitario_ref_cod_escola_fk; Type: FK CONSTRAINT; Schema: serieciasc; Owner: -
--

ALTER TABLE ONLY serieciasc.escola_sanitario
    ADD CONSTRAINT escola_sanitario_ref_cod_escola_fk FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7205 (class 2606 OID 9468903)
-- Name: fk_cep_log_bairro_bai; Type: FK CONSTRAINT; Schema: urbano; Owner: -
--

ALTER TABLE ONLY urbano.cep_logradouro_bairro
    ADD CONSTRAINT fk_cep_log_bairro_bai FOREIGN KEY (idbai) REFERENCES public.bairro(idbai);


--
-- TOC entry 7204 (class 2606 OID 9468908)
-- Name: fk_cep_log_bairro_cep_log; Type: FK CONSTRAINT; Schema: urbano; Owner: -
--

ALTER TABLE ONLY urbano.cep_logradouro_bairro
    ADD CONSTRAINT fk_cep_log_bairro_cep_log FOREIGN KEY (cep, idlog) REFERENCES urbano.cep_logradouro(cep, idlog) ON DELETE CASCADE;


--
-- TOC entry 7203 (class 2606 OID 9468913)
-- Name: fk_cep_logradouro_bairro_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: urbano; Owner: -
--

ALTER TABLE ONLY urbano.cep_logradouro_bairro
    ADD CONSTRAINT fk_cep_logradouro_bairro_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 7202 (class 2606 OID 9468918)
-- Name: fk_cep_logradouro_bairro_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: urbano; Owner: -
--

ALTER TABLE ONLY urbano.cep_logradouro_bairro
    ADD CONSTRAINT fk_cep_logradouro_bairro_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 7201 (class 2606 OID 9468923)
-- Name: fk_cep_logradouro_bairro_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: urbano; Owner: -
--

ALTER TABLE ONLY urbano.cep_logradouro_bairro
    ADD CONSTRAINT fk_cep_logradouro_bairro_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 7200 (class 2606 OID 9468928)
-- Name: fk_cep_logradouro_bairro_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: urbano; Owner: -
--

ALTER TABLE ONLY urbano.cep_logradouro_bairro
    ADD CONSTRAINT fk_cep_logradouro_bairro_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- TOC entry 7199 (class 2606 OID 9468933)
-- Name: fk_cep_logradouro_logradouro; Type: FK CONSTRAINT; Schema: urbano; Owner: -
--

ALTER TABLE ONLY urbano.cep_logradouro
    ADD CONSTRAINT fk_cep_logradouro_logradouro FOREIGN KEY (idlog) REFERENCES public.logradouro(idlog) ON DELETE CASCADE;


--
-- TOC entry 7198 (class 2606 OID 9468938)
-- Name: fk_cep_logradouro_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: urbano; Owner: -
--

ALTER TABLE ONLY urbano.cep_logradouro
    ADD CONSTRAINT fk_cep_logradouro_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 7197 (class 2606 OID 9468943)
-- Name: fk_cep_logradouro_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: urbano; Owner: -
--

ALTER TABLE ONLY urbano.cep_logradouro
    ADD CONSTRAINT fk_cep_logradouro_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- TOC entry 7196 (class 2606 OID 9468948)
-- Name: fk_cep_logradouro_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: urbano; Owner: -
--

ALTER TABLE ONLY urbano.cep_logradouro
    ADD CONSTRAINT fk_cep_logradouro_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;

--
-- Name: get_nome_escola(integer); Type: FUNCTION; Schema: relatorio; Owner: postgres
--

CREATE OR REPLACE FUNCTION relatorio.get_nome_escola(integer) RETURNS character varying
    LANGUAGE sql
    AS $_$SELECT COALESCE(
       (SELECT COALESCE (fcn_upper(ps.nome),fcn_upper(juridica.fantasia))
    FROM cadastro.pessoa ps, cadastro.juridica
   WHERE escola.ref_idpes = juridica.idpes
     AND juridica.idpes = ps.idpes
     AND ps.idpes = escola.ref_idpes),
       (SELECT nm_escola
    FROM pmieducar.escola_complemento
   WHERE ref_cod_escola = escola.cod_escola))
  FROM pmieducar.escola
 WHERE escola.cod_escola = $1;$_$;


--
-- Name: get_ddd_escola(integer); Type: FUNCTION; Schema: relatorio; Owner: postgres
--

CREATE OR REPLACE FUNCTION relatorio.get_ddd_escola(integer) RETURNS numeric
    LANGUAGE sql
    AS $_$
SELECT COALESCE(
                  (SELECT min(fone_pessoa.ddd)
                   FROM cadastro.fone_pessoa, cadastro.juridica
                   WHERE juridica.idpes = fone_pessoa.idpes
                     AND juridica.idpes =
                       (SELECT idpes
                        FROM cadastro.pessoa
                        INNER JOIN pmieducar.escola ON escola.ref_idpes = pessoa.idpes
                        WHERE cod_escola = $1)),
                  (SELECT min(ddd_telefone)
                   FROM pmieducar.escola_complemento
                   WHERE ref_cod_escola = $1)); $_$;

--
-- Name: get_telefone_escola(integer); Type: FUNCTION; Schema: relatorio; Owner: postgres
--

CREATE OR REPLACE FUNCTION relatorio.get_telefone_escola(integer) RETURNS character varying
    LANGUAGE sql
    AS $_$
SELECT COALESCE(
                  (SELECT min(to_char(fone_pessoa.fone, '99999-9999'))
                   FROM cadastro.fone_pessoa, cadastro.juridica
                   WHERE juridica.idpes = fone_pessoa.idpes
                     AND juridica.idpes =
                       (SELECT idpes
                        FROM cadastro.pessoa
                        INNER JOIN pmieducar.escola ON escola.ref_idpes = pessoa.idpes
                        WHERE cod_escola = $1)),
                  (SELECT min(to_char(telefone, '99999-9999'))
                   FROM pmieducar.escola_complemento
                   WHERE escola_complemento.ref_cod_escola = $1)); $_$;

--
-- Name: get_max_sequencial_matricula(integer); Type: FUNCTION; Schema: relatorio; Owner: ieducar
--

CREATE OR REPLACE FUNCTION relatorio.get_max_sequencial_matricula(integer) RETURNS integer
    LANGUAGE sql
    AS $_$
                            SELECT MAX(matricula_turma.sequencial)
                              FROM matricula_turma
                             INNER JOIN pmieducar.matricula ON (matricula.cod_matricula = matricula_turma.ref_cod_matricula)
                             INNER JOIN relatorio.view_situacao ON (view_situacao.cod_matricula = matricula.cod_matricula
                                                                AND view_situacao.cod_turma = matricula_turma.ref_cod_turma
                                                                AND view_situacao.sequencial = matricula_turma.sequencial)
                             WHERE ref_cod_matricula = $1;
                        $_$;

--
-- TOC entry 7195 (class 2606 OID 9468953)
-- Name: fk_cep_logradouro_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: urbano; Owner: -
--

ALTER TABLE ONLY urbano.cep_logradouro
    ADD CONSTRAINT fk_cep_logradouro_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


-- Completed on 2018-11-19 15:03:40 -02

--
-- PostgreSQL database dump complete
--

